Import [FrameNet](https://framenet.icsi.berkeley.edu/fndrupal/) v1.7 into KGTK format. The resulting KGTK file consists of 9 columns.

## Usage
```
usage: kgtk import-framenet [-h] [-o OUTPUT_FILE]

optional arguments:
  -h, --help            show this help message and exit
  -o OUTPUT_FILE, --output-file OUTPUT_FILE
                        The KGTK output file. (May be omitted or '-' for
                        stdout.)
```

## Examples

Importing FrameNet can be done as follows (no inputs should be provided, as FrameNet is read through the NLTK package):

```
kgtk import-framenet
```

Example output (first and last 10 lines):

| node1 | relation | node2 | node1;label | node2;label | relation;label | relation;dimension | source | sentence |
| -- | -- | -- | -- | -- | -- | -- | -- | -- |
| fn:abandonment | /r/IsA | fn:intentionally_affect | "abandonment" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:abandonment | fn:HasLexicalUnit | fn:lu:abandonment:abandon | "abandonment" | "abandon" | "has lexical unit" |  | "FN" |  |
| fn:abandonment | fn:HasLexicalUnit | fn:lu:abandonment:leave | "abandonment" | "leave" | "has lexical unit" |  | "FN" |  |
| fn:abandonment | fn:HasLexicalUnit | fn:lu:abandonment:abandonment | "abandonment" | "abandonment" | "has lexical unit" |  | "FN" |  |
| fn:abandonment | fn:HasLexicalUnit | fn:lu:abandonment:abandoned | "abandonment" | "abandoned" | "has lexical unit" |  | "FN" |  |
| fn:abandonment | fn:HasLexicalUnit | fn:lu:abandonment:forget | "abandonment" | "forget" | "has lexical unit" |  | "FN" |  |
| fn:abandonment | /r/HasA | fn:fe:agent | "abandonment" | "agent" | "/r/has a" |  | "FN" |  |
| fn:abandonment | /r/HasA | fn:fe:theme | "abandonment" | "theme" | "/r/has a" |  | "FN" |  |
| fn:abandonment | /r/HasA | fn:fe:place | "abandonment" | "place" | "/r/has a" |  | "FN" |  |
| fn:abandonment | /r/HasA | fn:fe:time | "abandonment" | "time" | "/r/has a" |  | "FN" |  |
| fn:abandonment | /r/HasA | fn:fe:manner | "abandonment" | "manner" | "/r/has a" |  | "FN" |  |
| fn:abandonment | /r/HasA | fn:fe:duration | "abandonment" | "duration" | "/r/has a" |  | "FN" |  |
| fn:abandonment | /r/HasA | fn:fe:explanation | "abandonment" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:abandonment | /r/HasA | fn:fe:depictive | "abandonment" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:abandonment | /r/HasA | fn:fe:degree | "abandonment" | "degree" | "/r/has a" |  | "FN" |  |
| fn:abandonment | /r/HasA | fn:fe:means | "abandonment" | "means" | "/r/has a" |  | "FN" |  |
| fn:abandonment | /r/HasA | fn:fe:purpose | "abandonment" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:abandonment | /r/HasA | fn:fe:event_description | "abandonment" | "event description" | "/r/has a" |  | "FN" |  |
| fn:lively_place | /r/IsA | fn:abounding_with | "lively place" | "abounding with" | "/r/is a" |  | "FN" |  |
| fn:abounding_with | /r/IsA | fn:locative_relation | "abounding with" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:abounding_with | /r/UsedFor | fn:expensiveness | "abounding with" | "expensiveness" | "/r/used for" |  | "FN" |  |
| fn:abounding_with | /r/UsedFor | fn:mass_motion | "abounding with" | "mass motion" | "/r/used for" |  | "FN" |  |
| fn:abundance | /r/UsedFor | fn:abounding_with | "abundance" | "abounding with" | "/r/used for" |  | "FN" |  |
| fn:distributed_position | /r/RelatedTo | fn:abounding_with | "distributed position" | "abounding with" | "/r/related to" |  | "FN" |  |
| fn:abounding_with | /r/IsA | fn:distributed_abundance | "abounding with" | "distributed abundance" | "/r/is a" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:teem | "abounding with" | "teem" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:crawling | "abounding with" | "crawling" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:crawl | "abounding with" | "crawl" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:throng | "abounding with" | "throng" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:thronged | "abounding with" | "thronged" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:crowded | "abounding with" | "crowded" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:swarming | "abounding with" | "swarming" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:swarm | "abounding with" | "swarm" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:jostling | "abounding with" | "jostling" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:covered | "abounding with" | "covered" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:blanketed | "abounding with" | "blanketed" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:cloaked | "abounding with" | "cloaked" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:thronging | "abounding with" | "thronging" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:coated | "abounding with" | "coated" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:dotted | "abounding with" | "dotted" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:teeming | "abounding with" | "teeming" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:dabbed | "abounding with" | "dabbed" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:drizzled | "abounding with" | "drizzled" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:buttered | "abounding with" | "buttered" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:plastered | "abounding with" | "plastered" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:smeared | "abounding with" | "smeared" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:strewn | "abounding with" | "strewn" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:splattered | "abounding with" | "splattered" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:stuffed | "abounding with" | "stuffed" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:tiled | "abounding with" | "tiled" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:heaped | "abounding with" | "heaped" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:crammed | "abounding with" | "crammed" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:sprinkled | "abounding with" | "sprinkled" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:injected | "abounding with" | "injected" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:draped | "abounding with" | "draped" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:brimming | "abounding with" | "brimming" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:replete | "abounding with" | "replete" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:chock-full | "abounding with" | "chock-full" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:chock-a-block | "abounding with" | "chock-a-block" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:dusted | "abounding with" | "dusted" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:surfaced | "abounding with" | "surfaced" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:wallpapered | "abounding with" | "wallpapered" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:overcrowded | "abounding with" | "overcrowded" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:overfilled | "abounding with" | "overfilled" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:filled | "abounding with" | "filled" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:full | "abounding with" | "full" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:adorned | "abounding with" | "adorned" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:asphalted | "abounding with" | "asphalted" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:brushed | "abounding with" | "brushed" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:hung | "abounding with" | "hung" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:jammed | "abounding with" | "jammed" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:paved | "abounding with" | "paved" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:festooned | "abounding with" | "festooned" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:decked | "abounding with" | "decked" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:bedecked | "abounding with" | "bedecked" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:bejewelled | "abounding with" | "bejewelled" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:bespattered | "abounding with" | "bespattered" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:spattered | "abounding with" | "spattered" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:decorated | "abounding with" | "decorated" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:studded | "abounding with" | "studded" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:lined | "abounding with" | "lined" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:ornamented | "abounding with" | "ornamented" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:varnished | "abounding with" | "varnished" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:painted | "abounding with" | "painted" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:lacquered | "abounding with" | "lacquered" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:glazed | "abounding with" | "glazed" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:gilded | "abounding with" | "gilded" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:embellished | "abounding with" | "embellished" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:panelled | "abounding with" | "panelled" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:rife | "abounding with" | "rife" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:piled | "abounding with" | "piled" | "has lexical unit" |  | "FN" |  |
| fn:abounding_with | fn:HasLexicalUnit | fn:lu:abounding_with:littered | "abounding with" | "littered" | "has lexical unit" |  | "FN" |  |
| fn:fe:theme | /r/IsA | fn:st:physical_object | "theme" | "physical object" | "/r/is a" |  | "FN" |  |
| fn:st:physical_object | /r/IsA | fn:st:ontological_type | "physical object" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:st:physical_object | /r/IsA | fn:st:physical_entity | "physical object" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:st:body_part | /r/IsA | fn:st:physical_object | "body part" | "physical object" | "/r/is a" |  | "FN" |  |
| fn:st:container | /r/IsA | fn:st:physical_object | "container" | "physical object" | "/r/is a" |  | "FN" |  |
| fn:st:location | /r/IsA | fn:st:physical_object | "location" | "physical object" | "/r/is a" |  | "FN" |  |
| fn:st:artifact | /r/IsA | fn:st:physical_object | "artifact" | "physical object" | "/r/is a" |  | "FN" |  |
| fn:st:living_thing | /r/IsA | fn:st:physical_object | "living thing" | "physical object" | "/r/is a" |  | "FN" |  |
| fn:abounding_with | /r/HasA | fn:fe:theme | "abounding with" | "theme" | "/r/has a" |  | "FN" |  |
| fn:fe:location | /r/IsA | fn:st:location | "location" | "location" | "/r/is a" |  | "FN" |  |
| fn:st:location | /r/IsA | fn:st:ontological_type | "location" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:st:region | /r/IsA | fn:st:location | "region" | "location" | "/r/is a" |  | "FN" |  |
| fn:st:point | /r/IsA | fn:st:location | "point" | "location" | "/r/is a" |  | "FN" |  |
| fn:st:line | /r/IsA | fn:st:location | "line" | "location" | "/r/is a" |  | "FN" |  |
| fn:abounding_with | /r/HasA | fn:fe:location | "abounding with" | "location" | "/r/has a" |  | "FN" |  |
| fn:fe:degree | /r/IsA | fn:st:degree | "degree" | "degree" | "/r/is a" |  | "FN" |  |
| fn:st:degree | /r/IsA | fn:st:ontological_type | "degree" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:st:degree | /r/IsA | fn:st:attribute | "degree" | "attribute" | "/r/is a" |  | "FN" |  |
| fn:abounding_with | /r/HasA | fn:fe:degree | "abounding with" | "degree" | "/r/has a" |  | "FN" |  |
| fn:abounding_with | /r/HasA | fn:fe:depictive | "abounding with" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:abounding_with | /r/HasA | fn:fe:time | "abounding with" | "time" | "/r/has a" |  | "FN" |  |
| fn:absorb_heat | /r/IsA | fn:transition_to_a_quality | "absorb heat" | "transition to a quality" | "/r/is a" |  | "FN" |  |
| fn:make_noise | /r/SimilarTo | fn:absorb_heat | "make noise" | "absorb heat" | "/r/similar to" |  | "FN" |  |
| fn:apply_heat | /r/Causes | fn:absorb_heat | "apply heat" | "absorb heat" | "/r/causes" |  | "FN" |  |
| fn:absorb_heat | fn:HasLexicalUnit | fn:lu:absorb_heat:sizzle | "absorb heat" | "sizzle" | "has lexical unit" |  | "FN" |  |
| fn:absorb_heat | fn:HasLexicalUnit | fn:lu:absorb_heat:fry | "absorb heat" | "fry" | "has lexical unit" |  | "FN" |  |
| fn:absorb_heat | fn:HasLexicalUnit | fn:lu:absorb_heat:bake | "absorb heat" | "bake" | "has lexical unit" |  | "FN" |  |
| fn:absorb_heat | fn:HasLexicalUnit | fn:lu:absorb_heat:simmer | "absorb heat" | "simmer" | "has lexical unit" |  | "FN" |  |
| fn:absorb_heat | fn:HasLexicalUnit | fn:lu:absorb_heat:cook | "absorb heat" | "cook" | "has lexical unit" |  | "FN" |  |
| fn:absorb_heat | fn:HasLexicalUnit | fn:lu:absorb_heat:stew | "absorb heat" | "stew" | "has lexical unit" |  | "FN" |  |
| fn:absorb_heat | fn:HasLexicalUnit | fn:lu:absorb_heat:boil | "absorb heat" | "boil" | "has lexical unit" |  | "FN" |  |
| fn:absorb_heat | fn:HasLexicalUnit | fn:lu:absorb_heat:scorch | "absorb heat" | "scorch" | "has lexical unit" |  | "FN" |  |
| fn:absorb_heat | fn:HasLexicalUnit | fn:lu:absorb_heat:sear | "absorb heat" | "sear" | "has lexical unit" |  | "FN" |  |
| fn:absorb_heat | fn:HasLexicalUnit | fn:lu:absorb_heat:singe | "absorb heat" | "singe" | "has lexical unit" |  | "FN" |  |
| fn:absorb_heat | fn:HasLexicalUnit | fn:lu:absorb_heat:barbecue | "absorb heat" | "barbecue" | "has lexical unit" |  | "FN" |  |
| fn:absorb_heat | fn:HasLexicalUnit | fn:lu:absorb_heat:blanch | "absorb heat" | "blanch" | "has lexical unit" |  | "FN" |  |
| fn:absorb_heat | fn:HasLexicalUnit | fn:lu:absorb_heat:braise | "absorb heat" | "braise" | "has lexical unit" |  | "FN" |  |
| fn:absorb_heat | fn:HasLexicalUnit | fn:lu:absorb_heat:broil | "absorb heat" | "broil" | "has lexical unit" |  | "FN" |  |
| fn:absorb_heat | fn:HasLexicalUnit | fn:lu:absorb_heat:brown | "absorb heat" | "brown" | "has lexical unit" |  | "FN" |  |
| fn:absorb_heat | fn:HasLexicalUnit | fn:lu:absorb_heat:char | "absorb heat" | "char" | "has lexical unit" |  | "FN" |  |
| fn:absorb_heat | fn:HasLexicalUnit | fn:lu:absorb_heat:coddle | "absorb heat" | "coddle" | "has lexical unit" |  | "FN" |  |
| fn:absorb_heat | fn:HasLexicalUnit | fn:lu:absorb_heat:deep_fry | "absorb heat" | "deep fry" | "has lexical unit" |  | "FN" |  |
| fn:absorb_heat | fn:HasLexicalUnit | fn:lu:absorb_heat:grill | "absorb heat" | "grill" | "has lexical unit" |  | "FN" |  |
| fn:absorb_heat | fn:HasLexicalUnit | fn:lu:absorb_heat:parboil | "absorb heat" | "parboil" | "has lexical unit" |  | "FN" |  |
| fn:absorb_heat | fn:HasLexicalUnit | fn:lu:absorb_heat:poach | "absorb heat" | "poach" | "has lexical unit" |  | "FN" |  |
| fn:absorb_heat | fn:HasLexicalUnit | fn:lu:absorb_heat:roast | "absorb heat" | "roast" | "has lexical unit" |  | "FN" |  |
| fn:absorb_heat | fn:HasLexicalUnit | fn:lu:absorb_heat:saute | "absorb heat" | "saute" | "has lexical unit" |  | "FN" |  |
| fn:absorb_heat | fn:HasLexicalUnit | fn:lu:absorb_heat:steam | "absorb heat" | "steam" | "has lexical unit" |  | "FN" |  |
| fn:absorb_heat | fn:HasLexicalUnit | fn:lu:absorb_heat:toast | "absorb heat" | "toast" | "has lexical unit" |  | "FN" |  |
| fn:absorb_heat | /r/HasA | fn:fe:entity | "absorb heat" | "entity" | "/r/has a" |  | "FN" |  |
| fn:absorb_heat | /r/HasA | fn:fe:container | "absorb heat" | "container" | "/r/has a" |  | "FN" |  |
| fn:absorb_heat | /r/HasA | fn:fe:heat_source | "absorb heat" | "heat source" | "/r/has a" |  | "FN" |  |
| fn:fe:place | /r/IsA | fn:st:locative_relation | "place" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:st:locative_relation | /r/IsA | fn:st:ontological_type | "locative relation" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:st:locative_relation | /r/IsA | fn:st:relation | "locative relation" | "relation" | "/r/is a" |  | "FN" |  |
| fn:st:source | /r/IsA | fn:st:locative_relation | "source" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:st:path | /r/IsA | fn:st:locative_relation | "path" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:st:goal | /r/IsA | fn:st:locative_relation | "goal" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:absorb_heat | /r/HasA | fn:fe:place | "absorb heat" | "place" | "/r/has a" |  | "FN" |  |
| fn:absorb_heat | /r/HasA | fn:fe:medium | "absorb heat" | "medium" | "/r/has a" |  | "FN" |  |
| fn:fe:manner | /r/IsA | fn:st:manner | "manner" | "manner" | "/r/is a" |  | "FN" |  |
| fn:st:manner | /r/IsA | fn:st:ontological_type | "manner" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:st:manner | /r/IsA | fn:st:attribute | "manner" | "attribute" | "/r/is a" |  | "FN" |  |
| fn:absorb_heat | /r/HasA | fn:fe:manner | "absorb heat" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fe:time | /r/IsA | fn:st:time | "time" | "time" | "/r/is a" |  | "FN" |  |
| fn:st:time | /r/IsA | fn:st:ontological_type | "time" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:st:time | /r/IsA | fn:st:relation | "time" | "relation" | "/r/is a" |  | "FN" |  |
| fn:absorb_heat | /r/HasA | fn:fe:time | "absorb heat" | "time" | "/r/has a" |  | "FN" |  |
| fn:absorb_heat | /r/HasA | fn:fe:explanation | "absorb heat" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:fe:temperature | /r/IsA | fn:st:temperature | "temperature" | "temperature" | "/r/is a" |  | "FN" |  |
| fn:st:temperature | /r/IsA | fn:st:ontological_type | "temperature" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:st:temperature | /r/IsA | fn:st:attribute | "temperature" | "attribute" | "/r/is a" |  | "FN" |  |
| fn:absorb_heat | /r/HasA | fn:fe:temperature | "absorb heat" | "temperature" | "/r/has a" |  | "FN" |  |
| fn:fe:duration | /r/IsA | fn:st:duration | "duration" | "duration" | "/r/is a" |  | "FN" |  |
| fn:st:duration | /r/IsA | fn:st:ontological_type | "duration" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:st:duration | /r/IsA | fn:st:attribute | "duration" | "attribute" | "/r/is a" |  | "FN" |  |
| fn:absorb_heat | /r/HasA | fn:fe:duration | "absorb heat" | "duration" | "/r/has a" |  | "FN" |  |
| fn:absorb_heat | /r/HasA | fn:fe:circumstances | "absorb heat" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:fe:purpose | /r/IsA | fn:st:state_of_affairs | "purpose" | "state of affairs" | "/r/is a" |  | "FN" |  |
| fn:st:state_of_affairs | /r/IsA | fn:st:ontological_type | "state of affairs" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:st:content | /r/IsA | fn:st:state_of_affairs | "content" | "state of affairs" | "/r/is a" |  | "FN" |  |
| fn:st:message | /r/IsA | fn:st:state_of_affairs | "message" | "state of affairs" | "/r/is a" |  | "FN" |  |
| fn:st:event | /r/IsA | fn:st:state_of_affairs | "event" | "state of affairs" | "/r/is a" |  | "FN" |  |
| fn:st:state | /r/IsA | fn:st:state_of_affairs | "state" | "state of affairs" | "/r/is a" |  | "FN" |  |
| fn:absorb_heat | /r/HasA | fn:fe:purpose | "absorb heat" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:absorb_heat | /r/HasA | fn:fe:depictive | "absorb heat" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:absorb_heat | /r/HasA | fn:fe:result | "absorb heat" | "result" | "/r/has a" |  | "FN" |  |
| fn:scarcity | /r/IsA | fn:abundance | "scarcity" | "abundance" | "/r/is a" |  | "FN" |  |
| fn:abundance | /r/IsA | fn:gradable_attributes | "abundance" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:abundance | /r/UsedFor | fn:abounding_with | "abundance" | "abounding with" | "/r/used for" |  | "FN" |  |
| fn:abundance | fn:HasLexicalUnit | fn:lu:abundance:abundant | "abundance" | "abundant" | "has lexical unit" |  | "FN" |  |
| fn:abundance | fn:HasLexicalUnit | fn:lu:abundance:abound | "abundance" | "abound" | "has lexical unit" |  | "FN" |  |
| fn:abundance | fn:HasLexicalUnit | fn:lu:abundance:teem | "abundance" | "teem" | "has lexical unit" |  | "FN" |  |
| fn:abundance | fn:HasLexicalUnit | fn:lu:abundance:galore | "abundance" | "galore" | "has lexical unit" |  | "FN" |  |
| fn:abundance | /r/HasA | fn:fe:collection | "abundance" | "collection" | "/r/has a" |  | "FN" |  |
| fn:fe:quantity | /r/IsA | fn:st:quantity | "quantity" | "quantity" | "/r/is a" |  | "FN" |  |
| fn:st:quantity | /r/IsA | fn:st:ontological_type | "quantity" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:st:quantity | /r/IsA | fn:st:attribute | "quantity" | "attribute" | "/r/is a" |  | "FN" |  |
| fn:abundance | /r/HasA | fn:fe:quantity | "abundance" | "quantity" | "/r/has a" |  | "FN" |  |
| fn:abundance | /r/HasA | fn:fe:degree | "abundance" | "degree" | "/r/has a" |  | "FN" |  |
| fn:abundance | /r/HasA | fn:fe:time | "abundance" | "time" | "/r/has a" |  | "FN" |  |
| fn:abundance | /r/HasA | fn:fe:circumstances | "abundance" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:abundance | /r/HasA | fn:fe:measure | "abundance" | "measure" | "/r/has a" |  | "FN" |  |
| fn:abundance | /r/HasA | fn:fe:place | "abundance" | "place" | "/r/has a" |  | "FN" |  |
| fn:abusing | /r/IsA | fn:committing_crime | "abusing" | "committing crime" | "/r/is a" |  | "FN" |  |
| fn:cause_harm | /r/UsedFor | fn:abusing | "cause harm" | "abusing" | "/r/used for" |  | "FN" |  |
| fn:abusing | fn:HasLexicalUnit | fn:lu:abusing:abuse | "abusing" | "abuse" | "has lexical unit" |  | "FN" |  |
| fn:abusing | fn:HasLexicalUnit | fn:lu:abusing:abuse | "abusing" | "abuse" | "has lexical unit" |  | "FN" |  |
| fn:abusing | fn:HasLexicalUnit | fn:lu:abusing:abusive | "abusing" | "abusive" | "has lexical unit" |  | "FN" |  |
| fn:abusing | fn:HasLexicalUnit | fn:lu:abusing:batter | "abusing" | "batter" | "has lexical unit" |  | "FN" |  |
| fn:abusing | fn:HasLexicalUnit | fn:lu:abusing:domestic_violence | "abusing" | "domestic violence" | "has lexical unit" |  | "FN" |  |
| fn:abusing | fn:HasLexicalUnit | fn:lu:abusing:maltreat | "abusing" | "maltreat" | "has lexical unit" |  | "FN" |  |
| fn:abusing | fn:HasLexicalUnit | fn:lu:abusing:maltreatment | "abusing" | "maltreatment" | "has lexical unit" |  | "FN" |  |
| fn:fe:abuser | /r/IsA | fn:st:sentient | "abuser" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:st:sentient | /r/IsA | fn:st:ontological_type | "sentient" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:st:sentient | /r/IsA | fn:st:animate_being | "sentient" | "animate being" | "/r/is a" |  | "FN" |  |
| fn:st:human | /r/IsA | fn:st:sentient | "human" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:abusing | /r/HasA | fn:fe:abuser | "abusing" | "abuser" | "/r/has a" |  | "FN" |  |
| fn:fe:victim | /r/IsA | fn:st:sentient | "victim" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:abusing | /r/HasA | fn:fe:victim | "abusing" | "victim" | "/r/has a" |  | "FN" |  |
| fn:abusing | /r/HasA | fn:fe:type | "abusing" | "type" | "/r/has a" |  | "FN" |  |
| fn:abusing | /r/HasA | fn:fe:degree | "abusing" | "degree" | "/r/has a" |  | "FN" |  |
| fn:abusing | /r/HasA | fn:fe:place | "abusing" | "place" | "/r/has a" |  | "FN" |  |
| fn:abusing | /r/HasA | fn:fe:time | "abusing" | "time" | "/r/has a" |  | "FN" |  |
| fn:abusing | /r/HasA | fn:fe:manner | "abusing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fe:means | /r/IsA | fn:st:state_of_affairs | "means" | "state of affairs" | "/r/is a" |  | "FN" |  |
| fn:abusing | /r/HasA | fn:fe:means | "abusing" | "means" | "/r/has a" |  | "FN" |  |
| fn:fe:instrument | /r/IsA | fn:st:physical_entity | "instrument" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:st:physical_entity | /r/IsA | fn:st:ontological_type | "physical entity" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:st:material | /r/IsA | fn:st:physical_entity | "material" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:abusing | /r/HasA | fn:fe:instrument | "abusing" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:abusing | /r/HasA | fn:fe:purpose | "abusing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:fe:explanation | /r/IsA | fn:st:state_of_affairs | "explanation" | "state of affairs" | "/r/is a" |  | "FN" |  |
| fn:abusing | /r/HasA | fn:fe:explanation | "abusing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:abusing | /r/HasA | fn:fe:duration | "abusing" | "duration" | "/r/has a" |  | "FN" |  |
| fn:abusing | /r/HasA | fn:fe:frequency | "abusing" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:abusing | /r/HasA | fn:fe:depictive | "abusing" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:abusing | /r/HasA | fn:fe:circumstances | "abusing" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:abusing | /r/HasA | fn:fe:period_of_iterations | "abusing" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:having_or_lacking_access | /r/IsA | fn:access_scenario | "having or lacking access" | "access scenario" | "/r/is a" |  | "FN" |  |
| fn:openness | /r/IsA | fn:access_scenario | "openness" | "access scenario" | "/r/is a" |  | "FN" |  |
| fn:access_scenario | /r/HasA | fn:fe:theme | "access scenario" | "theme" | "/r/has a" |  | "FN" |  |
| fn:access_scenario | /r/HasA | fn:fe:useful_location | "access scenario" | "useful location" | "/r/has a" |  | "FN" |  |
| fn:access_scenario | /r/HasA | fn:fe:barrier | "access scenario" | "barrier" | "/r/has a" |  | "FN" |  |
| fn:accompaniment | /r/IsA | fn:relation | "accompaniment" | "relation" | "/r/is a" |  | "FN" |  |
| fn:accompaniment | fn:HasLexicalUnit | fn:lu:accompaniment:with | "accompaniment" | "with" | "has lexical unit" |  | "FN" |  |
| fn:accompaniment | fn:HasLexicalUnit | fn:lu:accompaniment:along_with | "accompaniment" | "along with" | "has lexical unit" |  | "FN" |  |
| fn:accompaniment | fn:HasLexicalUnit | fn:lu:accompaniment:singly | "accompaniment" | "singly" | "has lexical unit" |  | "FN" |  |
| fn:accompaniment | fn:HasLexicalUnit | fn:lu:accompaniment:alone | "accompaniment" | "alone" | "has lexical unit" |  | "FN" |  |
| fn:accompaniment | fn:HasLexicalUnit | fn:lu:accompaniment:in_combination | "accompaniment" | "in combination" | "has lexical unit" |  | "FN" |  |
| fn:accompaniment | fn:HasLexicalUnit | fn:lu:accompaniment:together | "accompaniment" | "together" | "has lexical unit" |  | "FN" |  |
| fn:fe:participant | /r/RelatedTo | fn:fe:participants | "participant" | "participants" | "/r/related to" |  | "FN" |  |
| fn:accompaniment | /r/HasA | fn:fe:participant | "accompaniment" | "participant" | "/r/has a" |  | "FN" |  |
| fn:fe:co-participant | /r/RelatedTo | fn:fe:participants | "co-participant" | "participants" | "/r/related to" |  | "FN" |  |
| fn:accompaniment | /r/HasA | fn:fe:co-participant | "accompaniment" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:accompaniment | /r/HasA | fn:fe:participants | "accompaniment" | "participants" | "/r/has a" |  | "FN" |  |
| fn:intentionally_act | /r/UsedFor | fn:accomplishment | "intentionally act" | "accomplishment" | "/r/used for" |  | "FN" |  |
| fn:accomplishment | fn:HasLexicalUnit | fn:lu:accomplishment:accomplish | "accomplishment" | "accomplish" | "has lexical unit" |  | "FN" |  |
| fn:accomplishment | fn:HasLexicalUnit | fn:lu:accomplishment:achieve | "accomplishment" | "achieve" | "has lexical unit" |  | "FN" |  |
| fn:accomplishment | fn:HasLexicalUnit | fn:lu:accomplishment:accomplishment | "accomplishment" | "accomplishment" | "has lexical unit" |  | "FN" |  |
| fn:accomplishment | fn:HasLexicalUnit | fn:lu:accomplishment:achievement | "accomplishment" | "achievement" | "has lexical unit" |  | "FN" |  |
| fn:accomplishment | fn:HasLexicalUnit | fn:lu:accomplishment:bring_about | "accomplishment" | "bring about" | "has lexical unit" |  | "FN" |  |
| fn:accomplishment | fn:HasLexicalUnit | fn:lu:accomplishment:effect | "accomplishment" | "effect" | "has lexical unit" |  | "FN" |  |
| fn:accomplishment | /r/HasA | fn:fe:means | "accomplishment" | "means" | "/r/has a" |  | "FN" |  |
| fn:fe:agent | /r/IsA | fn:st:sentient | "agent" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:accomplishment | /r/HasA | fn:fe:agent | "accomplishment" | "agent" | "/r/has a" |  | "FN" |  |
| fn:accomplishment | /r/HasA | fn:fe:instrument | "accomplishment" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:accomplishment | /r/HasA | fn:fe:place | "accomplishment" | "place" | "/r/has a" |  | "FN" |  |
| fn:accomplishment | /r/HasA | fn:fe:time | "accomplishment" | "time" | "/r/has a" |  | "FN" |  |
| fn:accomplishment | /r/HasA | fn:fe:manner | "accomplishment" | "manner" | "/r/has a" |  | "FN" |  |
| fn:accomplishment | /r/HasA | fn:fe:explanation | "accomplishment" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:accomplishment | /r/HasA | fn:fe:degree | "accomplishment" | "degree" | "/r/has a" |  | "FN" |  |
| fn:accomplishment | /r/HasA | fn:fe:goal | "accomplishment" | "goal" | "/r/has a" |  | "FN" |  |
| fn:accomplishment | /r/HasA | fn:fe:outcome | "accomplishment" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:accomplishment | /r/HasA | fn:fe:circumstances | "accomplishment" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:accomplishment | /r/HasA | fn:fe:duration | "accomplishment" | "duration" | "/r/has a" |  | "FN" |  |
| fn:accomplishment | /r/HasA | fn:fe:domain | "accomplishment" | "domain" | "/r/has a" |  | "FN" |  |
| fn:accomplishment | /r/HasA | fn:fe:particular_iteration | "accomplishment" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:accoutrements | /r/IsA | fn:artifact | "accoutrements" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:accoutrements | /r/UsedFor | fn:dressing | "accoutrements" | "dressing" | "/r/used for" |  | "FN" |  |
| fn:accoutrements | /r/UsedFor | fn:undressing | "accoutrements" | "undressing" | "/r/used for" |  | "FN" |  |
| fn:accoutrements | /r/UsedFor | fn:wearing | "accoutrements" | "wearing" | "/r/used for" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:regalia | "accoutrements" | "regalia" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:anklet | "accoutrements" | "anklet" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:ring | "accoutrements" | "ring" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:earring | "accoutrements" | "earring" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:jewellery | "accoutrements" | "jewellery" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:necklace | "accoutrements" | "necklace" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:bangle | "accoutrements" | "bangle" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:bracelet | "accoutrements" | "bracelet" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:coronet | "accoutrements" | "coronet" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:crown | "accoutrements" | "crown" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:brooch | "accoutrements" | "brooch" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:tiara | "accoutrements" | "tiara" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:circlet | "accoutrements" | "circlet" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:diadem | "accoutrements" | "diadem" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:chain | "accoutrements" | "chain" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:locket | "accoutrements" | "locket" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:pendant | "accoutrements" | "pendant" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:wig | "accoutrements" | "wig" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:toupee | "accoutrements" | "toupee" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:cufflink | "accoutrements" | "cufflink" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:glasses | "accoutrements" | "glasses" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:spectacles | "accoutrements" | "spectacles" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:hat | "accoutrements" | "hat" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:hat-pin | "accoutrements" | "hat-pin" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:cap | "accoutrements" | "cap" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:bonnet | "accoutrements" | "bonnet" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:mask | "accoutrements" | "mask" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:bandanna | "accoutrements" | "bandanna" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:headband | "accoutrements" | "headband" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:hairpiece | "accoutrements" | "hairpiece" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:fez | "accoutrements" | "fez" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:skullcap | "accoutrements" | "skullcap" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:top-hat | "accoutrements" | "top-hat" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:accoutrement | "accoutrements" | "accoutrement" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:yarmulkah | "accoutrements" | "yarmulkah" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:balaclava | "accoutrements" | "balaclava" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:beret | "accoutrements" | "beret" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:biretta | "accoutrements" | "biretta" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:boater | "accoutrements" | "boater" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:bowler | "accoutrements" | "bowler" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:nightcap | "accoutrements" | "nightcap" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:panama | "accoutrements" | "panama" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:sombrero | "accoutrements" | "sombrero" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:trilby | "accoutrements" | "trilby" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:turban | "accoutrements" | "turban" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:shako | "accoutrements" | "shako" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:veil | "accoutrements" | "veil" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:headdress | "accoutrements" | "headdress" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:headpiece | "accoutrements" | "headpiece" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:belt | "accoutrements" | "belt" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:trinket | "accoutrements" | "trinket" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:choker | "accoutrements" | "choker" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:sporran | "accoutrements" | "sporran" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:snood | "accoutrements" | "snood" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:hairnet | "accoutrements" | "hairnet" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:hairslide | "accoutrements" | "hairslide" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:hairpin | "accoutrements" | "hairpin" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:hairband | "accoutrements" | "hairband" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:hairgrip | "accoutrements" | "hairgrip" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:sash | "accoutrements" | "sash" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:watch | "accoutrements" | "watch" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:medal | "accoutrements" | "medal" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:medallion | "accoutrements" | "medallion" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:ribbon | "accoutrements" | "ribbon" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:badge | "accoutrements" | "badge" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:armband | "accoutrements" | "armband" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:armlet | "accoutrements" | "armlet" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:goggles | "accoutrements" | "goggles" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:mitre | "accoutrements" | "mitre" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:helm | "accoutrements" | "helm" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:helmet | "accoutrements" | "helmet" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:gorget | "accoutrements" | "gorget" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:greaves | "accoutrements" | "greaves" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:coif | "accoutrements" | "coif" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:hauberk | "accoutrements" | "hauberk" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:mantle | "accoutrements" | "mantle" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | fn:HasLexicalUnit | fn:lu:accoutrements:gas_mask | "accoutrements" | "gas mask" | "has lexical unit" |  | "FN" |  |
| fn:accoutrements | /r/HasA | fn:fe:wearer | "accoutrements" | "wearer" | "/r/has a" |  | "FN" |  |
| fn:accoutrements | /r/HasA | fn:fe:style | "accoutrements" | "style" | "/r/has a" |  | "FN" |  |
| fn:accoutrements | /r/HasA | fn:fe:material | "accoutrements" | "material" | "/r/has a" |  | "FN" |  |
| fn:fe:accoutrement | /r/IsA | fn:st:artifact | "accoutrement" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:st:artifact | /r/IsA | fn:st:ontological_type | "artifact" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:st:structure | /r/IsA | fn:st:artifact | "structure" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:accoutrements | /r/HasA | fn:fe:accoutrement | "accoutrements" | "accoutrement" | "/r/has a" |  | "FN" |  |
| fn:accoutrements | /r/HasA | fn:fe:descriptor | "accoutrements" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:accoutrements | /r/HasA | fn:fe:use | "accoutrements" | "use" | "/r/has a" |  | "FN" |  |
| fn:accoutrements | /r/HasA | fn:fe:part | "accoutrements" | "part" | "/r/has a" |  | "FN" |  |
| fn:fe:body_location | /r/IsA | fn:st:locative_relation | "body location" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:accoutrements | /r/HasA | fn:fe:body_location | "accoutrements" | "body location" | "/r/has a" |  | "FN" |  |
| fn:accoutrements | /r/HasA | fn:fe:creator | "accoutrements" | "creator" | "/r/has a" |  | "FN" |  |
| fn:accoutrements | /r/HasA | fn:fe:time_of_creation | "accoutrements" | "time of creation" | "/r/has a" |  | "FN" |  |
| fn:accoutrements | /r/HasA | fn:fe:name | "accoutrements" | "name" | "/r/has a" |  | "FN" |  |
| fn:accuracy | /r/IsA | fn:inclination | "accuracy" | "inclination" | "/r/is a" |  | "FN" |  |
| fn:measurable_attributes | /r/UsedFor | fn:accuracy | "measurable attributes" | "accuracy" | "/r/used for" |  | "FN" |  |
| fn:success_or_failure | /r/UsedFor | fn:accuracy | "success or failure" | "accuracy" | "/r/used for" |  | "FN" |  |
| fn:accuracy | fn:HasLexicalUnit | fn:lu:accuracy:accurate | "accuracy" | "accurate" | "has lexical unit" |  | "FN" |  |
| fn:accuracy | fn:HasLexicalUnit | fn:lu:accuracy:on | "accuracy" | "on" | "has lexical unit" |  | "FN" |  |
| fn:accuracy | fn:HasLexicalUnit | fn:lu:accuracy:off | "accuracy" | "off" | "has lexical unit" |  | "FN" |  |
| fn:accuracy | fn:HasLexicalUnit | fn:lu:accuracy:inaccurate | "accuracy" | "inaccurate" | "has lexical unit" |  | "FN" |  |
| fn:accuracy | fn:HasLexicalUnit | fn:lu:accuracy:accuracy | "accuracy" | "accuracy" | "has lexical unit" |  | "FN" |  |
| fn:accuracy | fn:HasLexicalUnit | fn:lu:accuracy:inaccuracy | "accuracy" | "inaccuracy" | "has lexical unit" |  | "FN" |  |
| fn:accuracy | fn:HasLexicalUnit | fn:lu:accuracy:exact | "accuracy" | "exact" | "has lexical unit" |  | "FN" |  |
| fn:accuracy | fn:HasLexicalUnit | fn:lu:accuracy:precise | "accuracy" | "precise" | "has lexical unit" |  | "FN" |  |
| fn:accuracy | fn:HasLexicalUnit | fn:lu:accuracy:precision | "accuracy" | "precision" | "has lexical unit" |  | "FN" |  |
| fn:accuracy | fn:HasLexicalUnit | fn:lu:accuracy:accurately | "accuracy" | "accurately" | "has lexical unit" |  | "FN" |  |
| fn:accuracy | fn:HasLexicalUnit | fn:lu:accuracy:inaccurately | "accuracy" | "inaccurately" | "has lexical unit" |  | "FN" |  |
| fn:accuracy | fn:HasLexicalUnit | fn:lu:accuracy:true | "accuracy" | "true" | "has lexical unit" |  | "FN" |  |
| fn:accuracy | /r/HasA | fn:fe:agent | "accuracy" | "agent" | "/r/has a" |  | "FN" |  |
| fn:accuracy | /r/HasA | fn:fe:target | "accuracy" | "target" | "/r/has a" |  | "FN" |  |
| fn:accuracy | /r/HasA | fn:fe:outcome | "accuracy" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:accuracy | /r/HasA | fn:fe:means | "accuracy" | "means" | "/r/has a" |  | "FN" |  |
| fn:accuracy | /r/HasA | fn:fe:degree | "accuracy" | "degree" | "/r/has a" |  | "FN" |  |
| fn:accuracy | /r/HasA | fn:fe:time | "accuracy" | "time" | "/r/has a" |  | "FN" |  |
| fn:accuracy | /r/HasA | fn:fe:place | "accuracy" | "place" | "/r/has a" |  | "FN" |  |
| fn:accuracy | /r/HasA | fn:fe:instrument | "accuracy" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:accuracy | /r/HasA | fn:fe:target_value | "accuracy" | "target value" | "/r/has a" |  | "FN" |  |
| fn:accuracy | /r/HasA | fn:fe:deviation | "accuracy" | "deviation" | "/r/has a" |  | "FN" |  |
| fn:accuracy | /r/HasA | fn:fe:domain | "accuracy" | "domain" | "/r/has a" |  | "FN" |  |
| fn:accuracy | /r/HasA | fn:fe:circumstances | "accuracy" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:accuracy | /r/HasA | fn:fe:frequency | "accuracy" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:achieving_first | /r/IsA | fn:intentionally_create | "achieving first" | "intentionally create" | "/r/is a" |  | "FN" |  |
| fn:product_development_scenario | /r/HasSubevent | fn:achieving_first | "product development scenario" | "achieving first" | "/r/has subevent" |  | "FN" |  |
| fn:first_experience | /r/UsedFor | fn:achieving_first | "first experience" | "achieving first" | "/r/used for" |  | "FN" |  |
| fn:coming_up_with | /r/SimilarTo | fn:achieving_first | "coming up with" | "achieving first" | "/r/similar to" |  | "FN" |  |
| fn:product_development | /r/HasPrerequisite | fn:achieving_first | "product development" | "achieving first" | "/r/has prerequisite" |  | "FN" |  |
| fn:achieving_first | fn:HasLexicalUnit | fn:lu:achieving_first:originate | "achieving first" | "originate" | "has lexical unit" |  | "FN" |  |
| fn:achieving_first | fn:HasLexicalUnit | fn:lu:achieving_first:pioneer | "achieving first" | "pioneer" | "has lexical unit" |  | "FN" |  |
| fn:achieving_first | fn:HasLexicalUnit | fn:lu:achieving_first:invent | "achieving first" | "invent" | "has lexical unit" |  | "FN" |  |
| fn:achieving_first | fn:HasLexicalUnit | fn:lu:achieving_first:discover | "achieving first" | "discover" | "has lexical unit" |  | "FN" |  |
| fn:achieving_first | fn:HasLexicalUnit | fn:lu:achieving_first:coin | "achieving first" | "coin" | "has lexical unit" |  | "FN" |  |
| fn:achieving_first | fn:HasLexicalUnit | fn:lu:achieving_first:coinage | "achieving first" | "coinage" | "has lexical unit" |  | "FN" |  |
| fn:achieving_first | fn:HasLexicalUnit | fn:lu:achieving_first:discovery | "achieving first" | "discovery" | "has lexical unit" |  | "FN" |  |
| fn:achieving_first | fn:HasLexicalUnit | fn:lu:achieving_first:discoverer | "achieving first" | "discoverer" | "has lexical unit" |  | "FN" |  |
| fn:achieving_first | fn:HasLexicalUnit | fn:lu:achieving_first:originator | "achieving first" | "originator" | "has lexical unit" |  | "FN" |  |
| fn:achieving_first | fn:HasLexicalUnit | fn:lu:achieving_first:inventor | "achieving first" | "inventor" | "has lexical unit" |  | "FN" |  |
| fn:achieving_first | fn:HasLexicalUnit | fn:lu:achieving_first:invention | "achieving first" | "invention" | "has lexical unit" |  | "FN" |  |
| fn:achieving_first | fn:HasLexicalUnit | fn:lu:achieving_first:pioneer | "achieving first" | "pioneer" | "has lexical unit" |  | "FN" |  |
| fn:achieving_first | fn:HasLexicalUnit | fn:lu:achieving_first:pioneering | "achieving first" | "pioneering" | "has lexical unit" |  | "FN" |  |
| fn:achieving_first | fn:HasLexicalUnit | fn:lu:achieving_first:find | "achieving first" | "find" | "has lexical unit" |  | "FN" |  |
| fn:achieving_first | fn:HasLexicalUnit | fn:lu:achieving_first:invention_artifact | "achieving first" | "invention artifact" | "has lexical unit" |  | "FN" |  |
| fn:fe:cognizer | /r/IsA | fn:st:sentient | "cognizer" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:achieving_first | /r/HasA | fn:fe:cognizer | "achieving first" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:achieving_first | /r/HasA | fn:fe:new_idea | "achieving first" | "new idea" | "/r/has a" |  | "FN" |  |
| fn:achieving_first | /r/HasA | fn:fe:time | "achieving first" | "time" | "/r/has a" |  | "FN" |  |
| fn:achieving_first | /r/HasA | fn:fe:place | "achieving first" | "place" | "/r/has a" |  | "FN" |  |
| fn:achieving_first | /r/HasA | fn:fe:means | "achieving first" | "means" | "/r/has a" |  | "FN" |  |
| fn:achieving_first | /r/HasA | fn:fe:purpose | "achieving first" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:achieving_first | /r/HasA | fn:fe:explanation | "achieving first" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:achieving_first | /r/HasA | fn:fe:field | "achieving first" | "field" | "/r/has a" |  | "FN" |  |
| fn:achieving_first | /r/HasA | fn:fe:instrument | "achieving first" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:achieving_first | /r/HasA | fn:fe:manner | "achieving first" | "manner" | "/r/has a" |  | "FN" |  |
| fn:achieving_first | /r/HasA | fn:fe:basis | "achieving first" | "basis" | "/r/has a" |  | "FN" |  |
| fn:achieving_first | /r/HasA | fn:fe:location_of_appearance | "achieving first" | "location of appearance" | "/r/has a" |  | "FN" |  |
| fn:active_substance | /r/IsA | fn:substance | "active substance" | "substance" | "/r/is a" |  | "FN" |  |
| fn:active_substance | fn:HasLexicalUnit | fn:lu:active_substance:agent | "active substance" | "agent" | "has lexical unit" |  | "FN" |  |
| fn:active_substance | fn:HasLexicalUnit | fn:lu:active_substance:active | "active substance" | "active" | "has lexical unit" |  | "FN" |  |
| fn:active_substance | fn:HasLexicalUnit | fn:lu:active_substance:bioactive | "active substance" | "bioactive" | "has lexical unit" |  | "FN" |  |
| fn:active_substance | fn:HasLexicalUnit | fn:lu:active_substance:causative_agent | "active substance" | "causative agent" | "has lexical unit" |  | "FN" |  |
| fn:active_substance | fn:HasLexicalUnit | fn:lu:active_substance:irritant | "active substance" | "irritant" | "has lexical unit" |  | "FN" |  |
| fn:active_substance | fn:HasLexicalUnit | fn:lu:active_substance:incapacitant | "active substance" | "incapacitant" | "has lexical unit" |  | "FN" |  |
| fn:active_substance | /r/HasA | fn:fe:effect | "active substance" | "effect" | "/r/has a" |  | "FN" |  |
| fn:fe:substance | /r/IsA | fn:st:physical_entity | "substance" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:active_substance | /r/HasA | fn:fe:substance | "active substance" | "substance" | "/r/has a" |  | "FN" |  |
| fn:active_substance | /r/HasA | fn:fe:descriptor | "active substance" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:active_substance | /r/HasA | fn:fe:type | "active substance" | "type" | "/r/has a" |  | "FN" |  |
| fn:active_substance | /r/HasA | fn:fe:name | "active substance" | "name" | "/r/has a" |  | "FN" |  |
| fn:apply_heat | /r/IsA | fn:activity | "apply heat" | "activity" | "/r/is a" |  | "FN" |  |
| fn:activity | /r/IsA | fn:process | "activity" | "process" | "/r/is a" |  | "FN" |  |
| fn:activity | /r/HasSubevent | fn:activity_abandoned_state | "activity" | "activity abandoned state" | "/r/has subevent" |  | "FN" |  |
| fn:activity | /r/HasSubevent | fn:activity_done_state | "activity" | "activity done state" | "/r/has subevent" |  | "FN" |  |
| fn:activity | /r/HasSubevent | fn:activity_finish | "activity" | "activity finish" | "/r/has subevent" |  | "FN" |  |
| fn:activity | /r/HasSubevent | fn:activity_ongoing | "activity" | "activity ongoing" | "/r/has subevent" |  | "FN" |  |
| fn:activity | /r/HasSubevent | fn:activity_pause | "activity" | "activity pause" | "/r/has subevent" |  | "FN" |  |
| fn:activity | /r/HasSubevent | fn:activity_paused_state | "activity" | "activity paused state" | "/r/has subevent" |  | "FN" |  |
| fn:activity | /r/HasSubevent | fn:activity_prepare | "activity" | "activity prepare" | "/r/has subevent" |  | "FN" |  |
| fn:activity | /r/HasSubevent | fn:activity_ready_state | "activity" | "activity ready state" | "/r/has subevent" |  | "FN" |  |
| fn:activity | /r/HasSubevent | fn:activity_resume | "activity" | "activity resume" | "/r/has subevent" |  | "FN" |  |
| fn:activity | /r/HasSubevent | fn:activity_start | "activity" | "activity start" | "/r/has subevent" |  | "FN" |  |
| fn:activity | /r/HasSubevent | fn:activity_stop | "activity" | "activity stop" | "/r/has subevent" |  | "FN" |  |
| fn:activity | /r/HasA | fn:fe:activity | "activity" | "activity" | "/r/has a" |  | "FN" |  |
| fn:activity | /r/HasA | fn:fe:duration | "activity" | "duration" | "/r/has a" |  | "FN" |  |
| fn:activity | /r/HasA | fn:fe:place | "activity" | "place" | "/r/has a" |  | "FN" |  |
| fn:activity | /r/HasA | fn:fe:time | "activity" | "time" | "/r/has a" |  | "FN" |  |
| fn:activity | /r/HasA | fn:fe:agent | "activity" | "agent" | "/r/has a" |  | "FN" |  |
| fn:activity | /r/HasA | fn:fe:manner | "activity" | "manner" | "/r/has a" |  | "FN" |  |
| fn:activity_abandoned_state | /r/IsA | fn:process_uncompleted_state | "activity abandoned state" | "process uncompleted state" | "/r/is a" |  | "FN" |  |
| fn:activity | /r/HasSubevent | fn:activity_abandoned_state | "activity" | "activity abandoned state" | "/r/has subevent" |  | "FN" |  |
| fn:process_stopped_state | /r/UsedFor | fn:activity_abandoned_state | "process stopped state" | "activity abandoned state" | "/r/used for" |  | "FN" |  |
| fn:activity_abandoned_state | /r/HasPrerequisite | fn:activity_stop | "activity abandoned state" | "activity stop" | "/r/has prerequisite" |  | "FN" |  |
| fn:activity_abandoned_state | /r/HasA | fn:fe:agent | "activity abandoned state" | "agent" | "/r/has a" |  | "FN" |  |
| fn:activity_abandoned_state | /r/HasA | fn:fe:time | "activity abandoned state" | "time" | "/r/has a" |  | "FN" |  |
| fn:activity_abandoned_state | /r/HasA | fn:fe:duration | "activity abandoned state" | "duration" | "/r/has a" |  | "FN" |  |
| fn:activity_abandoned_state | /r/HasA | fn:fe:activity | "activity abandoned state" | "activity" | "/r/has a" |  | "FN" |  |
| fn:activity_abandoned_state | /r/HasA | fn:fe:place | "activity abandoned state" | "place" | "/r/has a" |  | "FN" |  |
| fn:activity_done_state | /r/IsA | fn:process_completed_state | "activity done state" | "process completed state" | "/r/is a" |  | "FN" |  |
| fn:activity | /r/HasSubevent | fn:activity_done_state | "activity" | "activity done state" | "/r/has subevent" |  | "FN" |  |
| fn:activity_done_state | /r/HasPrerequisite | fn:activity_finish | "activity done state" | "activity finish" | "/r/has prerequisite" |  | "FN" |  |
| fn:activity_done_state | fn:HasLexicalUnit | fn:lu:activity_done_state:done | "activity done state" | "done" | "has lexical unit" |  | "FN" |  |
| fn:activity_done_state | fn:HasLexicalUnit | fn:lu:activity_done_state:finished | "activity done state" | "finished" | "has lexical unit" |  | "FN" |  |
| fn:activity_done_state | fn:HasLexicalUnit | fn:lu:activity_done_state:through | "activity done state" | "through" | "has lexical unit" |  | "FN" |  |
| fn:activity_done_state | /r/HasA | fn:fe:agent | "activity done state" | "agent" | "/r/has a" |  | "FN" |  |
| fn:activity_done_state | /r/HasA | fn:fe:activity | "activity done state" | "activity" | "/r/has a" |  | "FN" |  |
| fn:activity_done_state | /r/HasA | fn:fe:time | "activity done state" | "time" | "/r/has a" |  | "FN" |  |
| fn:activity_done_state | /r/HasA | fn:fe:place | "activity done state" | "place" | "/r/has a" |  | "FN" |  |
| fn:finish_game | /r/IsA | fn:activity_finish | "finish game" | "activity finish" | "/r/is a" |  | "FN" |  |
| fn:activity_finish | /r/IsA | fn:intentionally_act | "activity finish" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:activity_finish | /r/IsA | fn:process_end | "activity finish" | "process end" | "/r/is a" |  | "FN" |  |
| fn:activity | /r/HasSubevent | fn:activity_finish | "activity" | "activity finish" | "/r/has subevent" |  | "FN" |  |
| fn:activity_finish | /r/SimilarTo | fn:activity_stop | "activity finish" | "activity stop" | "/r/similar to" |  | "FN" |  |
| fn:activity_done_state | /r/HasPrerequisite | fn:activity_finish | "activity done state" | "activity finish" | "/r/has prerequisite" |  | "FN" |  |
| fn:activity_finish | /r/HasPrerequisite | fn:activity_ongoing | "activity finish" | "activity ongoing" | "/r/has prerequisite" |  | "FN" |  |
| fn:activity_finish | fn:HasLexicalUnit | fn:lu:activity_finish:wrap_up | "activity finish" | "wrap up" | "has lexical unit" |  | "FN" |  |
| fn:activity_finish | fn:HasLexicalUnit | fn:lu:activity_finish:finish | "activity finish" | "finish" | "has lexical unit" |  | "FN" |  |
| fn:activity_finish | fn:HasLexicalUnit | fn:lu:activity_finish:conclude | "activity finish" | "conclude" | "has lexical unit" |  | "FN" |  |
| fn:activity_finish | fn:HasLexicalUnit | fn:lu:activity_finish:complete | "activity finish" | "complete" | "has lexical unit" |  | "FN" |  |
| fn:activity_finish | fn:HasLexicalUnit | fn:lu:activity_finish:completion | "activity finish" | "completion" | "has lexical unit" |  | "FN" |  |
| fn:activity_finish | fn:HasLexicalUnit | fn:lu:activity_finish:tie_up | "activity finish" | "tie up" | "has lexical unit" |  | "FN" |  |
| fn:activity_finish | fn:HasLexicalUnit | fn:lu:activity_finish:graduate | "activity finish" | "graduate" | "has lexical unit" |  | "FN" |  |
| fn:activity_finish | /r/HasA | fn:fe:depictive | "activity finish" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:activity_finish | /r/HasA | fn:fe:manner | "activity finish" | "manner" | "/r/has a" |  | "FN" |  |
| fn:activity_finish | /r/HasA | fn:fe:result | "activity finish" | "result" | "/r/has a" |  | "FN" |  |
| fn:activity_finish | /r/HasA | fn:fe:co-timed_event | "activity finish" | "co-timed event" | "/r/has a" |  | "FN" |  |
| fn:activity_finish | /r/HasA | fn:fe:place | "activity finish" | "place" | "/r/has a" |  | "FN" |  |
| fn:activity_finish | /r/HasA | fn:fe:time | "activity finish" | "time" | "/r/has a" |  | "FN" |  |
| fn:activity_finish | /r/HasA | fn:fe:agent | "activity finish" | "agent" | "/r/has a" |  | "FN" |  |
| fn:activity_finish | /r/HasA | fn:fe:activity | "activity finish" | "activity" | "/r/has a" |  | "FN" |  |
| fn:activity_finish | /r/HasA | fn:fe:means | "activity finish" | "means" | "/r/has a" |  | "FN" |  |
| fn:activity_finish | /r/HasA | fn:fe:purpose | "activity finish" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:activity_finish | /r/HasA | fn:fe:degree | "activity finish" | "degree" | "/r/has a" |  | "FN" |  |
| fn:activity_finish | /r/HasA | fn:fe:explanation | "activity finish" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:activity_finish | /r/HasA | fn:fe:circumstances | "activity finish" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:activity_finish | /r/HasA | fn:fe:containing_event | "activity finish" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:retaining | /r/IsA | fn:activity_ongoing | "retaining" | "activity ongoing" | "/r/is a" |  | "FN" |  |
| fn:activity_ongoing | /r/IsA | fn:process_continue | "activity ongoing" | "process continue" | "/r/is a" |  | "FN" |  |
| fn:activity | /r/HasSubevent | fn:activity_ongoing | "activity" | "activity ongoing" | "/r/has subevent" |  | "FN" |  |
| fn:activity_ongoing | /r/UsedFor | fn:being_active | "activity ongoing" | "being active" | "/r/used for" |  | "FN" |  |
| fn:activity_ongoing | /r/UsedFor | fn:cause_to_move_in_place | "activity ongoing" | "cause to move in place" | "/r/used for" |  | "FN" |  |
| fn:activity_ongoing | /r/UsedFor | fn:lively_place | "activity ongoing" | "lively place" | "/r/used for" |  | "FN" |  |
| fn:activity_finish | /r/HasPrerequisite | fn:activity_ongoing | "activity finish" | "activity ongoing" | "/r/has prerequisite" |  | "FN" |  |
| fn:activity_pause | /r/HasPrerequisite | fn:activity_ongoing | "activity pause" | "activity ongoing" | "/r/has prerequisite" |  | "FN" |  |
| fn:activity_stop | /r/HasPrerequisite | fn:activity_ongoing | "activity stop" | "activity ongoing" | "/r/has prerequisite" |  | "FN" |  |
| fn:activity_ongoing | /r/HasPrerequisite | fn:activity_resume | "activity ongoing" | "activity resume" | "/r/has prerequisite" |  | "FN" |  |
| fn:activity_ongoing | /r/HasPrerequisite | fn:activity_start | "activity ongoing" | "activity start" | "/r/has prerequisite" |  | "FN" |  |
| fn:activity_ongoing | fn:HasLexicalUnit | fn:lu:activity_ongoing:keep | "activity ongoing" | "keep" | "has lexical unit" |  | "FN" |  |
| fn:activity_ongoing | fn:HasLexicalUnit | fn:lu:activity_ongoing:continue | "activity ongoing" | "continue" | "has lexical unit" |  | "FN" |  |
| fn:activity_ongoing | fn:HasLexicalUnit | fn:lu:activity_ongoing:carry_on | "activity ongoing" | "carry on" | "has lexical unit" |  | "FN" |  |
| fn:activity_ongoing | fn:HasLexicalUnit | fn:lu:activity_ongoing:maintenance | "activity ongoing" | "maintenance" | "has lexical unit" |  | "FN" |  |
| fn:activity_ongoing | fn:HasLexicalUnit | fn:lu:activity_ongoing:keep_on | "activity ongoing" | "keep on" | "has lexical unit" |  | "FN" |  |
| fn:activity_ongoing | fn:HasLexicalUnit | fn:lu:activity_ongoing:keep_up | "activity ongoing" | "keep up" | "has lexical unit" |  | "FN" |  |
| fn:activity_ongoing | /r/HasA | fn:fe:duration | "activity ongoing" | "duration" | "/r/has a" |  | "FN" |  |
| fn:activity_ongoing | /r/HasA | fn:fe:activity | "activity ongoing" | "activity" | "/r/has a" |  | "FN" |  |
| fn:activity_ongoing | /r/HasA | fn:fe:place | "activity ongoing" | "place" | "/r/has a" |  | "FN" |  |
| fn:activity_ongoing | /r/HasA | fn:fe:purpose | "activity ongoing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:activity_ongoing | /r/HasA | fn:fe:time | "activity ongoing" | "time" | "/r/has a" |  | "FN" |  |
| fn:activity_ongoing | /r/HasA | fn:fe:depictive | "activity ongoing" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:activity_ongoing | /r/HasA | fn:fe:manner | "activity ongoing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:activity_ongoing | /r/HasA | fn:fe:means | "activity ongoing" | "means" | "/r/has a" |  | "FN" |  |
| fn:activity_ongoing | /r/HasA | fn:fe:co-timed_event | "activity ongoing" | "co-timed event" | "/r/has a" |  | "FN" |  |
| fn:activity_ongoing | /r/HasA | fn:fe:agent | "activity ongoing" | "agent" | "/r/has a" |  | "FN" |  |
| fn:activity_ongoing | /r/HasA | fn:fe:explanation | "activity ongoing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:activity_ongoing | /r/HasA | fn:fe:event_description | "activity ongoing" | "event description" | "/r/has a" |  | "FN" |  |
| fn:activity_ongoing | /r/HasA | fn:fe:circumstances | "activity ongoing" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:activity_pause | /r/IsA | fn:process_pause | "activity pause" | "process pause" | "/r/is a" |  | "FN" |  |
| fn:activity | /r/HasSubevent | fn:activity_pause | "activity" | "activity pause" | "/r/has subevent" |  | "FN" |  |
| fn:eventive_affecting | /r/UsedFor | fn:activity_pause | "eventive affecting" | "activity pause" | "/r/used for" |  | "FN" |  |
| fn:activity_pause | /r/HasPrerequisite | fn:activity_ongoing | "activity pause" | "activity ongoing" | "/r/has prerequisite" |  | "FN" |  |
| fn:activity_paused_state | /r/HasPrerequisite | fn:activity_pause | "activity paused state" | "activity pause" | "/r/has prerequisite" |  | "FN" |  |
| fn:activity_pause | fn:HasLexicalUnit | fn:lu:activity_pause:pause | "activity pause" | "pause" | "has lexical unit" |  | "FN" |  |
| fn:activity_pause | fn:HasLexicalUnit | fn:lu:activity_pause:suspend | "activity pause" | "suspend" | "has lexical unit" |  | "FN" |  |
| fn:activity_pause | fn:HasLexicalUnit | fn:lu:activity_pause:take_break | "activity pause" | "take break" | "has lexical unit" |  | "FN" |  |
| fn:activity_pause | fn:HasLexicalUnit | fn:lu:activity_pause:freeze | "activity pause" | "freeze" | "has lexical unit" |  | "FN" |  |
| fn:activity_pause | fn:HasLexicalUnit | fn:lu:activity_pause:freeze | "activity pause" | "freeze" | "has lexical unit" |  | "FN" |  |
| fn:activity_pause | fn:HasLexicalUnit | fn:lu:activity_pause:moratorium | "activity pause" | "moratorium" | "has lexical unit" |  | "FN" |  |
| fn:activity_pause | fn:HasLexicalUnit | fn:lu:activity_pause:adjourn | "activity pause" | "adjourn" | "has lexical unit" |  | "FN" |  |
| fn:activity_pause | /r/HasA | fn:fe:activity | "activity pause" | "activity" | "/r/has a" |  | "FN" |  |
| fn:activity_pause | /r/HasA | fn:fe:agent | "activity pause" | "agent" | "/r/has a" |  | "FN" |  |
| fn:activity_pause | /r/HasA | fn:fe:manner | "activity pause" | "manner" | "/r/has a" |  | "FN" |  |
| fn:activity_pause | /r/HasA | fn:fe:means | "activity pause" | "means" | "/r/has a" |  | "FN" |  |
| fn:activity_pause | /r/HasA | fn:fe:place | "activity pause" | "place" | "/r/has a" |  | "FN" |  |
| fn:activity_pause | /r/HasA | fn:fe:time | "activity pause" | "time" | "/r/has a" |  | "FN" |  |
| fn:activity_pause | /r/HasA | fn:fe:purpose | "activity pause" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:activity_pause | /r/HasA | fn:fe:depictive | "activity pause" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:activity_pause | /r/HasA | fn:fe:completeness | "activity pause" | "completeness" | "/r/has a" |  | "FN" |  |
| fn:activity_pause | /r/HasA | fn:fe:duration | "activity pause" | "duration" | "/r/has a" |  | "FN" |  |
| fn:activity_pause | /r/HasA | fn:fe:legal_basis | "activity pause" | "legal basis" | "/r/has a" |  | "FN" |  |
| fn:activity_pause | /r/HasA | fn:fe:explanation | "activity pause" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:activity_pause | /r/HasA | fn:fe:event_description | "activity pause" | "event description" | "/r/has a" |  | "FN" |  |
| fn:activity_paused_state | /r/IsA | fn:process_stopped_state | "activity paused state" | "process stopped state" | "/r/is a" |  | "FN" |  |
| fn:activity | /r/HasSubevent | fn:activity_paused_state | "activity" | "activity paused state" | "/r/has subevent" |  | "FN" |  |
| fn:activity_paused_state | /r/HasPrerequisite | fn:activity_pause | "activity paused state" | "activity pause" | "/r/has prerequisite" |  | "FN" |  |
| fn:activity_resume | /r/HasPrerequisite | fn:activity_paused_state | "activity resume" | "activity paused state" | "/r/has prerequisite" |  | "FN" |  |
| fn:activity_paused_state | /r/HasPrerequisite | fn:activity_stop | "activity paused state" | "activity stop" | "/r/has prerequisite" |  | "FN" |  |
| fn:activity_paused_state | /r/HasA | fn:fe:agent | "activity paused state" | "agent" | "/r/has a" |  | "FN" |  |
| fn:activity_paused_state | /r/HasA | fn:fe:time | "activity paused state" | "time" | "/r/has a" |  | "FN" |  |
| fn:activity_paused_state | /r/HasA | fn:fe:activity | "activity paused state" | "activity" | "/r/has a" |  | "FN" |  |
| fn:activity_paused_state | /r/HasA | fn:fe:duration | "activity paused state" | "duration" | "/r/has a" |  | "FN" |  |
| fn:activity | /r/HasSubevent | fn:activity_prepare | "activity" | "activity prepare" | "/r/has subevent" |  | "FN" |  |
| fn:eventive_affecting | /r/UsedFor | fn:activity_prepare | "eventive affecting" | "activity prepare" | "/r/used for" |  | "FN" |  |
| fn:activity_ready_state | /r/HasPrerequisite | fn:activity_prepare | "activity ready state" | "activity prepare" | "/r/has prerequisite" |  | "FN" |  |
| fn:preliminaries | /r/IsA | fn:activity_prepare | "preliminaries" | "activity prepare" | "/r/is a" |  | "FN" |  |
| fn:activity_prepare | fn:HasLexicalUnit | fn:lu:activity_prepare:prepare | "activity prepare" | "prepare" | "has lexical unit" |  | "FN" |  |
| fn:activity_prepare | fn:HasLexicalUnit | fn:lu:activity_prepare:get_ready | "activity prepare" | "get ready" | "has lexical unit" |  | "FN" |  |
| fn:activity_prepare | fn:HasLexicalUnit | fn:lu:activity_prepare:ready | "activity prepare" | "ready" | "has lexical unit" |  | "FN" |  |
| fn:activity_prepare | fn:HasLexicalUnit | fn:lu:activity_prepare:fix | "activity prepare" | "fix" | "has lexical unit" |  | "FN" |  |
| fn:activity_prepare | fn:HasLexicalUnit | fn:lu:activity_prepare:gear_up | "activity prepare" | "gear up" | "has lexical unit" |  | "FN" |  |
| fn:activity_prepare | fn:HasLexicalUnit | fn:lu:activity_prepare:preparation | "activity prepare" | "preparation" | "has lexical unit" |  | "FN" |  |
| fn:activity_prepare | fn:HasLexicalUnit | fn:lu:activity_prepare:compose | "activity prepare" | "compose" | "has lexical unit" |  | "FN" |  |
| fn:activity_prepare | /r/HasA | fn:fe:agent | "activity prepare" | "agent" | "/r/has a" |  | "FN" |  |
| fn:activity_prepare | /r/HasA | fn:fe:activity | "activity prepare" | "activity" | "/r/has a" |  | "FN" |  |
| fn:activity_prepare | /r/HasA | fn:fe:place | "activity prepare" | "place" | "/r/has a" |  | "FN" |  |
| fn:activity_prepare | /r/HasA | fn:fe:time | "activity prepare" | "time" | "/r/has a" |  | "FN" |  |
| fn:activity_prepare | /r/HasA | fn:fe:manner | "activity prepare" | "manner" | "/r/has a" |  | "FN" |  |
| fn:activity_prepare | /r/HasA | fn:fe:means | "activity prepare" | "means" | "/r/has a" |  | "FN" |  |
| fn:activity_prepare | /r/HasA | fn:fe:purpose | "activity prepare" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:activity_prepare | /r/HasA | fn:fe:duration | "activity prepare" | "duration" | "/r/has a" |  | "FN" |  |
| fn:activity_prepare | /r/HasA | fn:fe:depictive | "activity prepare" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:activity_prepare | /r/HasA | fn:fe:degree | "activity prepare" | "degree" | "/r/has a" |  | "FN" |  |
| fn:activity_prepare | /r/HasA | fn:fe:beneficiary | "activity prepare" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:activity_prepare | /r/HasA | fn:fe:iterations | "activity prepare" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:activity_prepare | /r/HasA | fn:fe:event_description | "activity prepare" | "event description" | "/r/has a" |  | "FN" |  |
| fn:be_on_alert | /r/IsA | fn:activity_ready_state | "be on alert" | "activity ready state" | "/r/is a" |  | "FN" |  |
| fn:activity_ready_state | /r/IsA | fn:process_initial_state | "activity ready state" | "process initial state" | "/r/is a" |  | "FN" |  |
| fn:activity | /r/HasSubevent | fn:activity_ready_state | "activity" | "activity ready state" | "/r/has subevent" |  | "FN" |  |
| fn:activity_ready_state | /r/UsedFor | fn:standing_by | "activity ready state" | "standing by" | "/r/used for" |  | "FN" |  |
| fn:activity_ready_state | /r/HasPrerequisite | fn:activity_prepare | "activity ready state" | "activity prepare" | "/r/has prerequisite" |  | "FN" |  |
| fn:activity_start | /r/HasPrerequisite | fn:activity_ready_state | "activity start" | "activity ready state" | "/r/has prerequisite" |  | "FN" |  |
| fn:activity_ready_state | fn:HasLexicalUnit | fn:lu:activity_ready_state:ready | "activity ready state" | "ready" | "has lexical unit" |  | "FN" |  |
| fn:activity_ready_state | fn:HasLexicalUnit | fn:lu:activity_ready_state:prepared | "activity ready state" | "prepared" | "has lexical unit" |  | "FN" |  |
| fn:activity_ready_state | fn:HasLexicalUnit | fn:lu:activity_ready_state:set | "activity ready state" | "set" | "has lexical unit" |  | "FN" |  |
| fn:fe:protagonist | /r/IsA | fn:st:sentient | "protagonist" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:activity_ready_state | /r/HasA | fn:fe:protagonist | "activity ready state" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:fe:activity | /r/RelatedTo | fn:fe:salient_entity | "activity" | "salient entity" | "/r/related to" |  | "FN" |  |
| fn:activity_ready_state | /r/HasA | fn:fe:activity | "activity ready state" | "activity" | "/r/has a" |  | "FN" |  |
| fn:activity_ready_state | /r/HasA | fn:fe:salient_entity | "activity ready state" | "salient entity" | "/r/has a" |  | "FN" |  |
| fn:activity_ready_state | /r/HasA | fn:fe:time | "activity ready state" | "time" | "/r/has a" |  | "FN" |  |
| fn:activity_ready_state | /r/HasA | fn:fe:result | "activity ready state" | "result" | "/r/has a" |  | "FN" |  |
| fn:activity_ready_state | /r/HasA | fn:fe:duration | "activity ready state" | "duration" | "/r/has a" |  | "FN" |  |
| fn:activity_ready_state | /r/HasA | fn:fe:degree | "activity ready state" | "degree" | "/r/has a" |  | "FN" |  |
| fn:activity_resume | /r/IsA | fn:process_resume | "activity resume" | "process resume" | "/r/is a" |  | "FN" |  |
| fn:activity | /r/HasSubevent | fn:activity_resume | "activity" | "activity resume" | "/r/has subevent" |  | "FN" |  |
| fn:activity_resume | /r/HasPrerequisite | fn:activity_paused_state | "activity resume" | "activity paused state" | "/r/has prerequisite" |  | "FN" |  |
| fn:activity_ongoing | /r/HasPrerequisite | fn:activity_resume | "activity ongoing" | "activity resume" | "/r/has prerequisite" |  | "FN" |  |
| fn:activity_resume | fn:HasLexicalUnit | fn:lu:activity_resume:renew | "activity resume" | "renew" | "has lexical unit" |  | "FN" |  |
| fn:activity_resume | fn:HasLexicalUnit | fn:lu:activity_resume:resume | "activity resume" | "resume" | "has lexical unit" |  | "FN" |  |
| fn:activity_resume | fn:HasLexicalUnit | fn:lu:activity_resume:restart | "activity resume" | "restart" | "has lexical unit" |  | "FN" |  |
| fn:activity_resume | /r/HasA | fn:fe:duration | "activity resume" | "duration" | "/r/has a" |  | "FN" |  |
| fn:activity_resume | /r/HasA | fn:fe:activity | "activity resume" | "activity" | "/r/has a" |  | "FN" |  |
| fn:activity_resume | /r/HasA | fn:fe:place | "activity resume" | "place" | "/r/has a" |  | "FN" |  |
| fn:activity_resume | /r/HasA | fn:fe:explanation | "activity resume" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:activity_resume | /r/HasA | fn:fe:time | "activity resume" | "time" | "/r/has a" |  | "FN" |  |
| fn:activity_resume | /r/HasA | fn:fe:manner | "activity resume" | "manner" | "/r/has a" |  | "FN" |  |
| fn:activity_resume | /r/HasA | fn:fe:agent | "activity resume" | "agent" | "/r/has a" |  | "FN" |  |
| fn:activity_resume | /r/HasA | fn:fe:circumstances | "activity resume" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:activity_resume | /r/HasA | fn:fe:depictive | "activity resume" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:activity_resume | /r/HasA | fn:fe:result | "activity resume" | "result" | "/r/has a" |  | "FN" |  |
| fn:activity_resume | /r/HasA | fn:fe:event_description | "activity resume" | "event description" | "/r/has a" |  | "FN" |  |
| fn:activity_start | /r/IsA | fn:process_start | "activity start" | "process start" | "/r/is a" |  | "FN" |  |
| fn:activity | /r/HasSubevent | fn:activity_start | "activity" | "activity start" | "/r/has subevent" |  | "FN" |  |
| fn:eventive_affecting | /r/UsedFor | fn:activity_start | "eventive affecting" | "activity start" | "/r/used for" |  | "FN" |  |
| fn:activity_start | /r/SimilarTo | fn:cause_to_start | "activity start" | "cause to start" | "/r/similar to" |  | "FN" |  |
| fn:traversing | /r/SimilarTo | fn:activity_start | "traversing" | "activity start" | "/r/similar to" |  | "FN" |  |
| fn:activity_start | /r/HasPrerequisite | fn:activity_ready_state | "activity start" | "activity ready state" | "/r/has prerequisite" |  | "FN" |  |
| fn:activity_ongoing | /r/HasPrerequisite | fn:activity_start | "activity ongoing" | "activity start" | "/r/has prerequisite" |  | "FN" |  |
| fn:activity_start | fn:HasLexicalUnit | fn:lu:activity_start:start | "activity start" | "start" | "has lexical unit" |  | "FN" |  |
| fn:activity_start | fn:HasLexicalUnit | fn:lu:activity_start:begin | "activity start" | "begin" | "has lexical unit" |  | "FN" |  |
| fn:activity_start | fn:HasLexicalUnit | fn:lu:activity_start:take_up | "activity start" | "take up" | "has lexical unit" |  | "FN" |  |
| fn:activity_start | fn:HasLexicalUnit | fn:lu:activity_start:beginner | "activity start" | "beginner" | "has lexical unit" |  | "FN" |  |
| fn:activity_start | fn:HasLexicalUnit | fn:lu:activity_start:neophyte | "activity start" | "neophyte" | "has lexical unit" |  | "FN" |  |
| fn:activity_start | fn:HasLexicalUnit | fn:lu:activity_start:enter | "activity start" | "enter" | "has lexical unit" |  | "FN" |  |
| fn:activity_start | fn:HasLexicalUnit | fn:lu:activity_start:swing_(into) | "activity start" | "swing (into)" | "has lexical unit" |  | "FN" |  |
| fn:activity_start | fn:HasLexicalUnit | fn:lu:activity_start:initiate | "activity start" | "initiate" | "has lexical unit" |  | "FN" |  |
| fn:activity_start | fn:HasLexicalUnit | fn:lu:activity_start:commence | "activity start" | "commence" | "has lexical unit" |  | "FN" |  |
| fn:activity_start | fn:HasLexicalUnit | fn:lu:activity_start:launch_(into) | "activity start" | "launch (into)" | "has lexical unit" |  | "FN" |  |
| fn:activity_start | fn:HasLexicalUnit | fn:lu:activity_start:strike_up | "activity start" | "strike up" | "has lexical unit" |  | "FN" |  |
| fn:activity_start | fn:HasLexicalUnit | fn:lu:activity_start:open | "activity start" | "open" | "has lexical unit" |  | "FN" |  |
| fn:activity_start | fn:HasLexicalUnit | fn:lu:activity_start:set_about | "activity start" | "set about" | "has lexical unit" |  | "FN" |  |
| fn:activity_start | fn:HasLexicalUnit | fn:lu:activity_start:get_started | "activity start" | "get started" | "has lexical unit" |  | "FN" |  |
| fn:activity_start | /r/HasA | fn:fe:place | "activity start" | "place" | "/r/has a" |  | "FN" |  |
| fn:activity_start | /r/HasA | fn:fe:purpose | "activity start" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:activity_start | /r/HasA | fn:fe:time | "activity start" | "time" | "/r/has a" |  | "FN" |  |
| fn:activity_start | /r/HasA | fn:fe:depictive | "activity start" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:activity_start | /r/HasA | fn:fe:manner | "activity start" | "manner" | "/r/has a" |  | "FN" |  |
| fn:activity_start | /r/HasA | fn:fe:means | "activity start" | "means" | "/r/has a" |  | "FN" |  |
| fn:activity_start | /r/HasA | fn:fe:activity | "activity start" | "activity" | "/r/has a" |  | "FN" |  |
| fn:activity_start | /r/HasA | fn:fe:agent | "activity start" | "agent" | "/r/has a" |  | "FN" |  |
| fn:activity_start | /r/HasA | fn:fe:co-timed_event | "activity start" | "co-timed event" | "/r/has a" |  | "FN" |  |
| fn:activity_start | /r/HasA | fn:fe:circumstances | "activity start" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:activity_start | /r/HasA | fn:fe:containing_event | "activity start" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:activity_start | /r/HasA | fn:fe:event_description | "activity start" | "event description" | "/r/has a" |  | "FN" |  |
| fn:activity_start | /r/HasA | fn:fe:explanation | "activity start" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:activity_start | /r/HasA | fn:fe:particular_iteration | "activity start" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:activity_start | /r/HasA | fn:fe:new_situation | "activity start" | "new situation" | "/r/has a" |  | "FN" |  |
| fn:activity_start | /r/HasA | fn:fe:communicative_force | "activity start" | "communicative force" | "/r/has a" |  | "FN" |  |
| fn:activity_start | /r/HasA | fn:fe:concessive | "activity start" | "concessive" | "/r/has a" |  | "FN" |  |
| fn:halt | /r/IsA | fn:activity_stop | "halt" | "activity stop" | "/r/is a" |  | "FN" |  |
| fn:activity_stop | /r/IsA | fn:process_stop | "activity stop" | "process stop" | "/r/is a" |  | "FN" |  |
| fn:activity | /r/HasSubevent | fn:activity_stop | "activity" | "activity stop" | "/r/has subevent" |  | "FN" |  |
| fn:eventive_affecting | /r/UsedFor | fn:activity_stop | "eventive affecting" | "activity stop" | "/r/used for" |  | "FN" |  |
| fn:activity_finish | /r/SimilarTo | fn:activity_stop | "activity finish" | "activity stop" | "/r/similar to" |  | "FN" |  |
| fn:activity_stop | /r/HasPrerequisite | fn:activity_ongoing | "activity stop" | "activity ongoing" | "/r/has prerequisite" |  | "FN" |  |
| fn:activity_abandoned_state | /r/HasPrerequisite | fn:activity_stop | "activity abandoned state" | "activity stop" | "/r/has prerequisite" |  | "FN" |  |
| fn:activity_paused_state | /r/HasPrerequisite | fn:activity_stop | "activity paused state" | "activity stop" | "/r/has prerequisite" |  | "FN" |  |
| fn:activity_stop | fn:HasLexicalUnit | fn:lu:activity_stop:stop | "activity stop" | "stop" | "has lexical unit" |  | "FN" |  |
| fn:activity_stop | fn:HasLexicalUnit | fn:lu:activity_stop:halt | "activity stop" | "halt" | "has lexical unit" |  | "FN" |  |
| fn:activity_stop | fn:HasLexicalUnit | fn:lu:activity_stop:discontinue | "activity stop" | "discontinue" | "has lexical unit" |  | "FN" |  |
| fn:activity_stop | fn:HasLexicalUnit | fn:lu:activity_stop:cease | "activity stop" | "cease" | "has lexical unit" |  | "FN" |  |
| fn:activity_stop | fn:HasLexicalUnit | fn:lu:activity_stop:terminate | "activity stop" | "terminate" | "has lexical unit" |  | "FN" |  |
| fn:activity_stop | fn:HasLexicalUnit | fn:lu:activity_stop:abandon | "activity stop" | "abandon" | "has lexical unit" |  | "FN" |  |
| fn:activity_stop | fn:HasLexicalUnit | fn:lu:activity_stop:quit | "activity stop" | "quit" | "has lexical unit" |  | "FN" |  |
| fn:activity_stop | /r/HasA | fn:fe:purpose | "activity stop" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:activity_stop | /r/HasA | fn:fe:place | "activity stop" | "place" | "/r/has a" |  | "FN" |  |
| fn:activity_stop | /r/HasA | fn:fe:time | "activity stop" | "time" | "/r/has a" |  | "FN" |  |
| fn:activity_stop | /r/HasA | fn:fe:depictive | "activity stop" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:activity_stop | /r/HasA | fn:fe:manner | "activity stop" | "manner" | "/r/has a" |  | "FN" |  |
| fn:activity_stop | /r/HasA | fn:fe:result | "activity stop" | "result" | "/r/has a" |  | "FN" |  |
| fn:activity_stop | /r/HasA | fn:fe:agent | "activity stop" | "agent" | "/r/has a" |  | "FN" |  |
| fn:activity_stop | /r/HasA | fn:fe:activity | "activity stop" | "activity" | "/r/has a" |  | "FN" |  |
| fn:activity_stop | /r/HasA | fn:fe:duration | "activity stop" | "duration" | "/r/has a" |  | "FN" |  |
| fn:activity_stop | /r/HasA | fn:fe:means | "activity stop" | "means" | "/r/has a" |  | "FN" |  |
| fn:activity_stop | /r/HasA | fn:fe:co-timed_event | "activity stop" | "co-timed event" | "/r/has a" |  | "FN" |  |
| fn:activity_stop | /r/HasA | fn:fe:degree | "activity stop" | "degree" | "/r/has a" |  | "FN" |  |
| fn:activity_stop | /r/HasA | fn:fe:frequency | "activity stop" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:activity_stop | /r/HasA | fn:fe:containing_event | "activity stop" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:activity_stop | /r/HasA | fn:fe:circumstances | "activity stop" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:activity_stop | /r/HasA | fn:fe:re-encoding | "activity stop" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:activity_stop | /r/HasA | fn:fe:explanation | "activity stop" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:activity_stop | /r/HasA | fn:fe:event_description | "activity stop" | "event description" | "/r/has a" |  | "FN" |  |
| fn:activity_stop | /r/HasA | fn:fe:particular_iteration | "activity stop" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:actually_occurring_entity | /r/IsA | fn:entity | "actually occurring entity" | "entity" | "/r/is a" |  | "FN" |  |
| fn:actually_occurring_entity | fn:HasLexicalUnit | fn:lu:actually_occurring_entity:actual | "actually occurring entity" | "actual" | "has lexical unit" |  | "FN" |  |
| fn:actually_occurring_entity | fn:HasLexicalUnit | fn:lu:actually_occurring_entity:true | "actually occurring entity" | "true" | "has lexical unit" |  | "FN" |  |
| fn:actually_occurring_entity | /r/HasA | fn:fe:instance | "actually occurring entity" | "instance" | "/r/has a" |  | "FN" |  |
| fn:actually_occurring_entity | /r/HasA | fn:fe:type | "actually occurring entity" | "type" | "/r/has a" |  | "FN" |  |
| fn:addiction | /r/IsA | fn:gradable_attributes | "addiction" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:addiction | fn:HasLexicalUnit | fn:lu:addiction:addict | "addiction" | "addict" | "has lexical unit" |  | "FN" |  |
| fn:addiction | fn:HasLexicalUnit | fn:lu:addiction:addicted | "addiction" | "addicted" | "has lexical unit" |  | "FN" |  |
| fn:addiction | fn:HasLexicalUnit | fn:lu:addiction:addiction | "addiction" | "addiction" | "has lexical unit" |  | "FN" |  |
| fn:addiction | fn:HasLexicalUnit | fn:lu:addiction:compulsive | "addiction" | "compulsive" | "has lexical unit" |  | "FN" |  |
| fn:addiction | fn:HasLexicalUnit | fn:lu:addiction:fiend | "addiction" | "fiend" | "has lexical unit" |  | "FN" |  |
| fn:addiction | fn:HasLexicalUnit | fn:lu:addiction:habit | "addiction" | "habit" | "has lexical unit" |  | "FN" |  |
| fn:addiction | fn:HasLexicalUnit | fn:lu:addiction:junkie | "addiction" | "junkie" | "has lexical unit" |  | "FN" |  |
| fn:addiction | fn:HasLexicalUnit | fn:lu:addiction:alcoholic | "addiction" | "alcoholic" | "has lexical unit" |  | "FN" |  |
| fn:addiction | fn:HasLexicalUnit | fn:lu:addiction:alcoholism | "addiction" | "alcoholism" | "has lexical unit" |  | "FN" |  |
| fn:addiction | fn:HasLexicalUnit | fn:lu:addiction:hooked | "addiction" | "hooked" | "has lexical unit" |  | "FN" |  |
| fn:addiction | /r/HasA | fn:fe:addict | "addiction" | "addict" | "/r/has a" |  | "FN" |  |
| fn:addiction | /r/HasA | fn:fe:addictant | "addiction" | "addictant" | "/r/has a" |  | "FN" |  |
| fn:addiction | /r/HasA | fn:fe:degree | "addiction" | "degree" | "/r/has a" |  | "FN" |  |
| fn:addiction | /r/HasA | fn:fe:compeller | "addiction" | "compeller" | "/r/has a" |  | "FN" |  |
| fn:amounting_to | /r/UsedFor | fn:adding_up | "amounting to" | "adding up" | "/r/used for" |  | "FN" |  |
| fn:adding_up | /r/SimilarTo | fn:amounting_to | "adding up" | "amounting to" | "/r/similar to" |  | "FN" |  |
| fn:adding_up | fn:HasLexicalUnit | fn:lu:adding_up:total | "adding up" | "total" | "has lexical unit" |  | "FN" |  |
| fn:adding_up | fn:HasLexicalUnit | fn:lu:adding_up:add_up | "adding up" | "add up" | "has lexical unit" |  | "FN" |  |
| fn:adding_up | fn:HasLexicalUnit | fn:lu:adding_up:tally | "adding up" | "tally" | "has lexical unit" |  | "FN" |  |
| fn:adding_up | /r/HasA | fn:fe:cognizer | "adding up" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:adding_up | /r/HasA | fn:fe:numbers | "adding up" | "numbers" | "/r/has a" |  | "FN" |  |
| fn:adding_up | /r/HasA | fn:fe:result | "adding up" | "result" | "/r/has a" |  | "FN" |  |
| fn:adding_up | /r/HasA | fn:fe:time | "adding up" | "time" | "/r/has a" |  | "FN" |  |
| fn:adding_up | /r/HasA | fn:fe:place | "adding up" | "place" | "/r/has a" |  | "FN" |  |
| fn:adding_up | /r/HasA | fn:fe:purpose | "adding up" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:adding_up | /r/HasA | fn:fe:means | "adding up" | "means" | "/r/has a" |  | "FN" |  |
| fn:adding_up | /r/HasA | fn:fe:manner | "adding up" | "manner" | "/r/has a" |  | "FN" |  |
| fn:adducing | /r/UsedFor | fn:reference_text | "adducing" | "reference text" | "/r/used for" |  | "FN" |  |
| fn:statement | /r/UsedFor | fn:adducing | "statement" | "adducing" | "/r/used for" |  | "FN" |  |
| fn:adducing | fn:HasLexicalUnit | fn:lu:adducing:adduce | "adducing" | "adduce" | "has lexical unit" |  | "FN" |  |
| fn:adducing | fn:HasLexicalUnit | fn:lu:adducing:cite | "adducing" | "cite" | "has lexical unit" |  | "FN" |  |
| fn:adducing | fn:HasLexicalUnit | fn:lu:adducing:point | "adducing" | "point" | "has lexical unit" |  | "FN" |  |
| fn:adducing | fn:HasLexicalUnit | fn:lu:adducing:name | "adducing" | "name" | "has lexical unit" |  | "FN" |  |
| fn:fe:speaker | /r/IsA | fn:st:sentient | "speaker" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:adducing | /r/HasA | fn:fe:speaker | "adducing" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:fe:addressee | /r/IsA | fn:st:sentient | "addressee" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:adducing | /r/HasA | fn:fe:addressee | "adducing" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:adducing | /r/HasA | fn:fe:manner | "adducing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:adducing | /r/HasA | fn:fe:means | "adducing" | "means" | "/r/has a" |  | "FN" |  |
| fn:adducing | /r/HasA | fn:fe:medium | "adducing" | "medium" | "/r/has a" |  | "FN" |  |
| fn:adducing | /r/HasA | fn:fe:depictive | "adducing" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:adducing | /r/HasA | fn:fe:time | "adducing" | "time" | "/r/has a" |  | "FN" |  |
| fn:adducing | /r/HasA | fn:fe:place | "adducing" | "place" | "/r/has a" |  | "FN" |  |
| fn:adducing | /r/HasA | fn:fe:specified_entity | "adducing" | "specified entity" | "/r/has a" |  | "FN" |  |
| fn:adducing | /r/HasA | fn:fe:role | "adducing" | "role" | "/r/has a" |  | "FN" |  |
| fn:adducing | /r/HasA | fn:fe:purpose | "adducing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:adducing | /r/HasA | fn:fe:explanation | "adducing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:adducing | /r/HasA | fn:fe:containing_event | "adducing" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:adducing | /r/HasA | fn:fe:event_description | "adducing" | "event description" | "/r/has a" |  | "FN" |  |
| fn:adducing | /r/HasA | fn:fe:frequency | "adducing" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:adducing | /r/HasA | fn:fe:circumstances | "adducing" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:adjacency | /r/IsA | fn:locative_relation | "adjacency" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:locative_relation | /r/SimilarTo | fn:adjacency | "locative relation" | "adjacency" | "/r/similar to" |  | "FN" |  |
| fn:non-gradable_proximity | /r/SimilarTo | fn:adjacency | "non-gradable proximity" | "adjacency" | "/r/similar to" |  | "FN" |  |
| fn:adjacency | fn:HasLexicalUnit | fn:lu:adjacency:adjacent | "adjacency" | "adjacent" | "has lexical unit" |  | "FN" |  |
| fn:adjacency | fn:HasLexicalUnit | fn:lu:adjacency:border | "adjacency" | "border" | "has lexical unit" |  | "FN" |  |
| fn:adjacency | fn:HasLexicalUnit | fn:lu:adjacency:neighbor | "adjacency" | "neighbor" | "has lexical unit" |  | "FN" |  |
| fn:adjacency | fn:HasLexicalUnit | fn:lu:adjacency:neighboring | "adjacency" | "neighboring" | "has lexical unit" |  | "FN" |  |
| fn:adjacency | fn:HasLexicalUnit | fn:lu:adjacency:adjacency | "adjacency" | "adjacency" | "has lexical unit" |  | "FN" |  |
| fn:adjacency | fn:HasLexicalUnit | fn:lu:adjacency:adjoining | "adjacency" | "adjoining" | "has lexical unit" |  | "FN" |  |
| fn:adjacency | fn:HasLexicalUnit | fn:lu:adjacency:adjoin | "adjacency" | "adjoin" | "has lexical unit" |  | "FN" |  |
| fn:adjacency | fn:HasLexicalUnit | fn:lu:adjacency:contiguous | "adjacency" | "contiguous" | "has lexical unit" |  | "FN" |  |
| fn:adjacency | fn:HasLexicalUnit | fn:lu:adjacency:contiguity | "adjacency" | "contiguity" | "has lexical unit" |  | "FN" |  |
| fn:adjacency | fn:HasLexicalUnit | fn:lu:adjacency:next_to | "adjacency" | "next to" | "has lexical unit" |  | "FN" |  |
| fn:adjacency | fn:HasLexicalUnit | fn:lu:adjacency:neighbor | "adjacency" | "neighbor" | "has lexical unit" |  | "FN" |  |
| fn:adjacency | fn:HasLexicalUnit | fn:lu:adjacency:abut | "adjacency" | "abut" | "has lexical unit" |  | "FN" |  |
| fn:adjacency | fn:HasLexicalUnit | fn:lu:adjacency:bordering | "adjacency" | "bordering" | "has lexical unit" |  | "FN" |  |
| fn:fe:ground | /r/RelatedTo | fn:fe:figures | "ground" | "figures" | "/r/related to" |  | "FN" |  |
| fn:adjacency | /r/HasA | fn:fe:ground | "adjacency" | "ground" | "/r/has a" |  | "FN" |  |
| fn:fe:figure | /r/RelatedTo | fn:fe:figures | "figure" | "figures" | "/r/related to" |  | "FN" |  |
| fn:adjacency | /r/HasA | fn:fe:figure | "adjacency" | "figure" | "/r/has a" |  | "FN" |  |
| fn:adjacency | /r/HasA | fn:fe:distance | "adjacency" | "distance" | "/r/has a" |  | "FN" |  |
| fn:adjacency | /r/HasA | fn:fe:direction | "adjacency" | "direction" | "/r/has a" |  | "FN" |  |
| fn:adjacency | /r/HasA | fn:fe:time | "adjacency" | "time" | "/r/has a" |  | "FN" |  |
| fn:adjacency | /r/HasA | fn:fe:figures | "adjacency" | "figures" | "/r/has a" |  | "FN" |  |
| fn:adjacency | /r/HasA | fn:fe:deixis | "adjacency" | "deixis" | "/r/has a" |  | "FN" |  |
| fn:adjacency | /r/HasA | fn:fe:accessibility | "adjacency" | "accessibility" | "/r/has a" |  | "FN" |  |
| fn:adjacency | /r/HasA | fn:fe:directness | "adjacency" | "directness" | "/r/has a" |  | "FN" |  |
| fn:adjusting | /r/IsA | fn:intentionally_affect | "adjusting" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:cause_change | /r/UsedFor | fn:adjusting | "cause change" | "adjusting" | "/r/used for" |  | "FN" |  |
| fn:adjusting | fn:HasLexicalUnit | fn:lu:adjusting:adjust | "adjusting" | "adjust" | "has lexical unit" |  | "FN" |  |
| fn:adjusting | fn:HasLexicalUnit | fn:lu:adjusting:adjustment | "adjusting" | "adjustment" | "has lexical unit" |  | "FN" |  |
| fn:adjusting | fn:HasLexicalUnit | fn:lu:adjusting:tweak | "adjusting" | "tweak" | "has lexical unit" |  | "FN" |  |
| fn:adjusting | fn:HasLexicalUnit | fn:lu:adjusting:tweak | "adjusting" | "tweak" | "has lexical unit" |  | "FN" |  |
| fn:adjusting | fn:HasLexicalUnit | fn:lu:adjusting:calibrate | "adjusting" | "calibrate" | "has lexical unit" |  | "FN" |  |
| fn:adjusting | fn:HasLexicalUnit | fn:lu:adjusting:calibration | "adjusting" | "calibration" | "has lexical unit" |  | "FN" |  |
| fn:adjusting | /r/HasA | fn:fe:agent | "adjusting" | "agent" | "/r/has a" |  | "FN" |  |
| fn:adjusting | /r/HasA | fn:fe:part | "adjusting" | "part" | "/r/has a" |  | "FN" |  |
| fn:adjusting | /r/HasA | fn:fe:feature | "adjusting" | "feature" | "/r/has a" |  | "FN" |  |
| fn:adjusting | /r/HasA | fn:fe:imposed_purpose | "adjusting" | "imposed purpose" | "/r/has a" |  | "FN" |  |
| fn:adjusting | /r/HasA | fn:fe:means | "adjusting" | "means" | "/r/has a" |  | "FN" |  |
| fn:adjusting | /r/HasA | fn:fe:place | "adjusting" | "place" | "/r/has a" |  | "FN" |  |
| fn:adjusting | /r/HasA | fn:fe:time | "adjusting" | "time" | "/r/has a" |  | "FN" |  |
| fn:adjusting | /r/HasA | fn:fe:final_value | "adjusting" | "final value" | "/r/has a" |  | "FN" |  |
| fn:adjusting | /r/HasA | fn:fe:instrument | "adjusting" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:adjusting | /r/HasA | fn:fe:purpose | "adjusting" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:adjusting | /r/HasA | fn:fe:manner | "adjusting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:adjusting | /r/HasA | fn:fe:degree | "adjusting" | "degree" | "/r/has a" |  | "FN" |  |
| fn:adjusting | /r/HasA | fn:fe:circumstances | "adjusting" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:choosing | /r/UsedFor | fn:adopt_selection | "choosing" | "adopt selection" | "/r/used for" |  | "FN" |  |
| fn:adopt_selection | fn:HasLexicalUnit | fn:lu:adopt_selection:adopt | "adopt selection" | "adopt" | "has lexical unit" |  | "FN" |  |
| fn:adopt_selection | fn:HasLexicalUnit | fn:lu:adopt_selection:assume | "adopt selection" | "assume" | "has lexical unit" |  | "FN" |  |
| fn:adopt_selection | fn:HasLexicalUnit | fn:lu:adopt_selection:embrace | "adopt selection" | "embrace" | "has lexical unit" |  | "FN" |  |
| fn:fe:agent | /r/IsA | fn:st:human | "agent" | "human" | "/r/is a" |  | "FN" |  |
| fn:st:human | /r/IsA | fn:st:ontological_type | "human" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:adopt_selection | /r/HasA | fn:fe:agent | "adopt selection" | "agent" | "/r/has a" |  | "FN" |  |
| fn:adopt_selection | /r/HasA | fn:fe:attribute | "adopt selection" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:adopt_selection | /r/HasA | fn:fe:value | "adopt selection" | "value" | "/r/has a" |  | "FN" |  |
| fn:adopt_selection | /r/HasA | fn:fe:time | "adopt selection" | "time" | "/r/has a" |  | "FN" |  |
| fn:adopt_selection | /r/HasA | fn:fe:manner | "adopt selection" | "manner" | "/r/has a" |  | "FN" |  |
| fn:adopt_selection | /r/HasA | fn:fe:event_description | "adopt selection" | "event description" | "/r/has a" |  | "FN" |  |
| fn:adopt_selection | /r/HasA | fn:fe:depictive | "adopt selection" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:adopt_selection | /r/HasA | fn:fe:purpose | "adopt selection" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:adopt_selection | /r/HasA | fn:fe:role | "adopt selection" | "role" | "/r/has a" |  | "FN" |  |
| fn:adopt_selection | /r/HasA | fn:fe:place | "adopt selection" | "place" | "/r/has a" |  | "FN" |  |
| fn:adopt_selection | /r/HasA | fn:fe:frequency | "adopt selection" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:adopt_selection | /r/HasA | fn:fe:containing_event | "adopt selection" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:adopt_selection | /r/HasA | fn:fe:circumstances | "adopt selection" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:adopt_selection | /r/HasA | fn:fe:re-encoding | "adopt selection" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:adopt_selection | /r/HasA | fn:fe:particular_iteration | "adopt selection" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:adopt_selection | /r/HasA | fn:fe:means | "adopt selection" | "means" | "/r/has a" |  | "FN" |  |
| fn:adopt_selection | /r/HasA | fn:fe:instrument | "adopt selection" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:adopt_selection | /r/HasA | fn:fe:duration | "adopt selection" | "duration" | "/r/has a" |  | "FN" |  |
| fn:adopt_selection | /r/HasA | fn:fe:explanation | "adopt selection" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:adopt_selection | /r/HasA | fn:fe:communicative_force | "adopt selection" | "communicative force" | "/r/has a" |  | "FN" |  |
| fn:aesthetics | /r/IsA | fn:desirability | "aesthetics" | "desirability" | "/r/is a" |  | "FN" |  |
| fn:aesthetics | /r/UsedFor | fn:artistic_style | "aesthetics" | "artistic style" | "/r/used for" |  | "FN" |  |
| fn:aesthetics | fn:HasLexicalUnit | fn:lu:aesthetics:beautiful | "aesthetics" | "beautiful" | "has lexical unit" |  | "FN" |  |
| fn:aesthetics | fn:HasLexicalUnit | fn:lu:aesthetics:lovely | "aesthetics" | "lovely" | "has lexical unit" |  | "FN" |  |
| fn:aesthetics | fn:HasLexicalUnit | fn:lu:aesthetics:smart | "aesthetics" | "smart" | "has lexical unit" |  | "FN" |  |
| fn:aesthetics | fn:HasLexicalUnit | fn:lu:aesthetics:ugly | "aesthetics" | "ugly" | "has lexical unit" |  | "FN" |  |
| fn:aesthetics | fn:HasLexicalUnit | fn:lu:aesthetics:tasty | "aesthetics" | "tasty" | "has lexical unit" |  | "FN" |  |
| fn:aesthetics | fn:HasLexicalUnit | fn:lu:aesthetics:elegant | "aesthetics" | "elegant" | "has lexical unit" |  | "FN" |  |
| fn:aesthetics | fn:HasLexicalUnit | fn:lu:aesthetics:fair | "aesthetics" | "fair" | "has lexical unit" |  | "FN" |  |
| fn:aesthetics | fn:HasLexicalUnit | fn:lu:aesthetics:handsome | "aesthetics" | "handsome" | "has lexical unit" |  | "FN" |  |
| fn:aesthetics | fn:HasLexicalUnit | fn:lu:aesthetics:hideous | "aesthetics" | "hideous" | "has lexical unit" |  | "FN" |  |
| fn:aesthetics | /r/HasA | fn:fe:entity | "aesthetics" | "entity" | "/r/has a" |  | "FN" |  |
| fn:aesthetics | /r/HasA | fn:fe:attribute | "aesthetics" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:aesthetics | /r/HasA | fn:fe:degree | "aesthetics" | "degree" | "/r/has a" |  | "FN" |  |
| fn:aesthetics | /r/HasA | fn:fe:time | "aesthetics" | "time" | "/r/has a" |  | "FN" |  |
| fn:aesthetics | /r/HasA | fn:fe:circumstances | "aesthetics" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:fe:viewpoint | /r/IsA | fn:st:sentient | "viewpoint" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:aesthetics | /r/HasA | fn:fe:viewpoint | "aesthetics" | "viewpoint" | "/r/has a" |  | "FN" |  |
| fn:aesthetics | /r/HasA | fn:fe:place | "aesthetics" | "place" | "/r/has a" |  | "FN" |  |
| fn:affirm_or_deny | /r/IsA | fn:statement | "affirm or deny" | "statement" | "/r/is a" |  | "FN" |  |
| fn:statement | /r/SimilarTo | fn:affirm_or_deny | "statement" | "affirm or deny" | "/r/similar to" |  | "FN" |  |
| fn:affirm_or_deny | fn:HasLexicalUnit | fn:lu:affirm_or_deny:concede | "affirm or deny" | "concede" | "has lexical unit" |  | "FN" |  |
| fn:affirm_or_deny | fn:HasLexicalUnit | fn:lu:affirm_or_deny:deny | "affirm or deny" | "deny" | "has lexical unit" |  | "FN" |  |
| fn:affirm_or_deny | fn:HasLexicalUnit | fn:lu:affirm_or_deny:affirm | "affirm or deny" | "affirm" | "has lexical unit" |  | "FN" |  |
| fn:affirm_or_deny | fn:HasLexicalUnit | fn:lu:affirm_or_deny:affirmation | "affirm or deny" | "affirmation" | "has lexical unit" |  | "FN" |  |
| fn:affirm_or_deny | fn:HasLexicalUnit | fn:lu:affirm_or_deny:confirm | "affirm or deny" | "confirm" | "has lexical unit" |  | "FN" |  |
| fn:affirm_or_deny | fn:HasLexicalUnit | fn:lu:affirm_or_deny:confirmation | "affirm or deny" | "confirmation" | "has lexical unit" |  | "FN" |  |
| fn:affirm_or_deny | fn:HasLexicalUnit | fn:lu:affirm_or_deny:denial | "affirm or deny" | "denial" | "has lexical unit" |  | "FN" |  |
| fn:affirm_or_deny | fn:HasLexicalUnit | fn:lu:affirm_or_deny:reaffirm | "affirm or deny" | "reaffirm" | "has lexical unit" |  | "FN" |  |
| fn:affirm_or_deny | fn:HasLexicalUnit | fn:lu:affirm_or_deny:refute | "affirm or deny" | "refute" | "has lexical unit" |  | "FN" |  |
| fn:affirm_or_deny | fn:HasLexicalUnit | fn:lu:affirm_or_deny:attest | "affirm or deny" | "attest" | "has lexical unit" |  | "FN" |  |
| fn:affirm_or_deny | /r/HasA | fn:fe:speaker | "affirm or deny" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:fe:message | /r/IsA | fn:st:message | "message" | "message" | "/r/is a" |  | "FN" |  |
| fn:st:message | /r/IsA | fn:st:ontological_type | "message" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:affirm_or_deny | /r/HasA | fn:fe:message | "affirm or deny" | "message" | "/r/has a" |  | "FN" |  |
| fn:affirm_or_deny | /r/HasA | fn:fe:addressee | "affirm or deny" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:affirm_or_deny | /r/HasA | fn:fe:place | "affirm or deny" | "place" | "/r/has a" |  | "FN" |  |
| fn:affirm_or_deny | /r/HasA | fn:fe:time | "affirm or deny" | "time" | "/r/has a" |  | "FN" |  |
| fn:affirm_or_deny | /r/HasA | fn:fe:manner | "affirm or deny" | "manner" | "/r/has a" |  | "FN" |  |
| fn:affirm_or_deny | /r/HasA | fn:fe:iterations | "affirm or deny" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:affirm_or_deny | /r/HasA | fn:fe:means | "affirm or deny" | "means" | "/r/has a" |  | "FN" |  |
| fn:affirm_or_deny | /r/HasA | fn:fe:depictive | "affirm or deny" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:affirm_or_deny | /r/HasA | fn:fe:degree | "affirm or deny" | "degree" | "/r/has a" |  | "FN" |  |
| fn:affirm_or_deny | /r/HasA | fn:fe:containing_event | "affirm or deny" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:affirm_or_deny | /r/HasA | fn:fe:event_description | "affirm or deny" | "event description" | "/r/has a" |  | "FN" |  |
| fn:affirm_or_deny | /r/HasA | fn:fe:frequency | "affirm or deny" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:affirm_or_deny | /r/HasA | fn:fe:internal_cause | "affirm or deny" | "internal cause" | "/r/has a" |  | "FN" |  |
| fn:affirm_or_deny | /r/HasA | fn:fe:medium | "affirm or deny" | "medium" | "/r/has a" |  | "FN" |  |
| fn:affirm_or_deny | /r/HasA | fn:fe:topic | "affirm or deny" | "topic" | "/r/has a" |  | "FN" |  |
| fn:age | /r/IsA | fn:measurable_attributes | "age" | "measurable attributes" | "/r/is a" |  | "FN" |  |
| fn:age | /r/UsedFor | fn:aging | "age" | "aging" | "/r/used for" |  | "FN" |  |
| fn:age | /r/UsedFor | fn:people_by_age | "age" | "people by age" | "/r/used for" |  | "FN" |  |
| fn:age | fn:HasLexicalUnit | fn:lu:age:old | "age" | "old" | "has lexical unit" |  | "FN" |  |
| fn:age | fn:HasLexicalUnit | fn:lu:age:ancient | "age" | "ancient" | "has lexical unit" |  | "FN" |  |
| fn:age | fn:HasLexicalUnit | fn:lu:age:young | "age" | "young" | "has lexical unit" |  | "FN" |  |
| fn:age | fn:HasLexicalUnit | fn:lu:age:youngish | "age" | "youngish" | "has lexical unit" |  | "FN" |  |
| fn:age | fn:HasLexicalUnit | fn:lu:age:oldish | "age" | "oldish" | "has lexical unit" |  | "FN" |  |
| fn:age | fn:HasLexicalUnit | fn:lu:age:age | "age" | "age" | "has lexical unit" |  | "FN" |  |
| fn:age | fn:HasLexicalUnit | fn:lu:age:new | "age" | "new" | "has lexical unit" |  | "FN" |  |
| fn:age | fn:HasLexicalUnit | fn:lu:age:fresh | "age" | "fresh" | "has lexical unit" |  | "FN" |  |
| fn:age | fn:HasLexicalUnit | fn:lu:age:of | "age" | "of" | "has lexical unit" |  | "FN" |  |
| fn:age | fn:HasLexicalUnit | fn:lu:age:maturity | "age" | "maturity" | "has lexical unit" |  | "FN" |  |
| fn:age | fn:HasLexicalUnit | fn:lu:age:mature | "age" | "mature" | "has lexical unit" |  | "FN" |  |
| fn:age | fn:HasLexicalUnit | fn:lu:age:elderly | "age" | "elderly" | "has lexical unit" |  | "FN" |  |
| fn:age | /r/HasA | fn:fe:entity | "age" | "entity" | "/r/has a" |  | "FN" |  |
| fn:age | /r/HasA | fn:fe:attribute | "age" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:fe:age | /r/RelatedTo | fn:fe:degree | "age" | "degree" | "/r/related to" |  | "FN" |  |
| fn:age | /r/HasA | fn:fe:age | "age" | "age" | "/r/has a" |  | "FN" |  |
| fn:age | /r/HasA | fn:fe:degree | "age" | "degree" | "/r/has a" |  | "FN" |  |
| fn:age | /r/HasA | fn:fe:time | "age" | "time" | "/r/has a" |  | "FN" |  |
| fn:age | /r/HasA | fn:fe:circumstances | "age" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:fe:expressor | /r/RelatedTo | fn:fe:entity | "expressor" | "entity" | "/r/related to" |  | "FN" |  |
| fn:age | /r/HasA | fn:fe:expressor | "age" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:age | /r/HasA | fn:fe:descriptor | "age" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:age | /r/HasA | fn:fe:duration | "age" | "duration" | "/r/has a" |  | "FN" |  |
| fn:convoy | /r/IsA | fn:aggregate | "convoy" | "aggregate" | "/r/is a" |  | "FN" |  |
| fn:entourage | /r/IsA | fn:aggregate | "entourage" | "aggregate" | "/r/is a" |  | "FN" |  |
| fn:organization | /r/IsA | fn:aggregate | "organization" | "aggregate" | "/r/is a" |  | "FN" |  |
| fn:product_line | /r/IsA | fn:aggregate | "product line" | "aggregate" | "/r/is a" |  | "FN" |  |
| fn:store | /r/IsA | fn:aggregate | "store" | "aggregate" | "/r/is a" |  | "FN" |  |
| fn:team | /r/IsA | fn:aggregate | "team" | "aggregate" | "/r/is a" |  | "FN" |  |
| fn:come_together | /r/Causes | fn:aggregate | "come together" | "aggregate" | "/r/causes" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:army | "aggregate" | "army" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:colony | "aggregate" | "colony" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:brood | "aggregate" | "brood" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:bunch | "aggregate" | "bunch" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:group | "aggregate" | "group" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:cluster | "aggregate" | "cluster" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:herd | "aggregate" | "herd" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:squad | "aggregate" | "squad" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:pack | "aggregate" | "pack" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:swarm | "aggregate" | "swarm" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:host | "aggregate" | "host" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:collection | "aggregate" | "collection" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:gaggle | "aggregate" | "gaggle" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:flock | "aggregate" | "flock" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:team | "aggregate" | "team" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:batch | "aggregate" | "batch" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:party | "aggregate" | "party" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:cohort | "aggregate" | "cohort" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:legion | "aggregate" | "legion" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:heap | "aggregate" | "heap" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:class | "aggregate" | "class" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:clique | "aggregate" | "clique" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:crew | "aggregate" | "crew" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:assembly | "aggregate" | "assembly" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:variety | "aggregate" | "variety" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:crowd | "aggregate" | "crowd" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:assortment | "aggregate" | "assortment" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:gang | "aggregate" | "gang" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:throng | "aggregate" | "throng" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:multitude | "aggregate" | "multitude" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:assemblage | "aggregate" | "assemblage" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:band | "aggregate" | "band" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:clutch | "aggregate" | "clutch" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:multiplicity | "aggregate" | "multiplicity" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:bevy | "aggregate" | "bevy" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:circle | "aggregate" | "circle" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:coterie | "aggregate" | "coterie" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:family | "aggregate" | "family" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:corps | "aggregate" | "corps" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:set | "aggregate" | "set" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:slew | "aggregate" | "slew" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:package | "aggregate" | "package" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:shoal | "aggregate" | "shoal" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:school | "aggregate" | "school" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:covey | "aggregate" | "covey" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:crop | "aggregate" | "crop" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:mob | "aggregate" | "mob" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:harem | "aggregate" | "harem" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:horde | "aggregate" | "horde" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:stand | "aggregate" | "stand" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:repertoire | "aggregate" | "repertoire" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:posse | "aggregate" | "posse" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:huddle | "aggregate" | "huddle" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:claque | "aggregate" | "claque" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:repertory | "aggregate" | "repertory" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:population | "aggregate" | "population" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:quartet | "aggregate" | "quartet" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:quintet | "aggregate" | "quintet" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:trio | "aggregate" | "trio" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:sextet | "aggregate" | "sextet" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:flotilla | "aggregate" | "flotilla" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:clump | "aggregate" | "clump" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:passel | "aggregate" | "passel" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:community | "aggregate" | "community" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:body | "aggregate" | "body" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:tribe | "aggregate" | "tribe" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:force | "aggregate" | "force" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:book | "aggregate" | "book" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | fn:HasLexicalUnit | fn:lu:aggregate:combination | "aggregate" | "combination" | "has lexical unit" |  | "FN" |  |
| fn:aggregate | /r/HasA | fn:fe:individuals | "aggregate" | "individuals" | "/r/has a" |  | "FN" |  |
| fn:aggregate | /r/HasA | fn:fe:aggregate | "aggregate" | "aggregate" | "/r/has a" |  | "FN" |  |
| fn:aggregate | /r/HasA | fn:fe:aggregate_property | "aggregate" | "aggregate property" | "/r/has a" |  | "FN" |  |
| fn:aggregate | /r/HasA | fn:fe:name | "aggregate" | "name" | "/r/has a" |  | "FN" |  |
| fn:aggregate | /r/HasA | fn:fe:container_possessor | "aggregate" | "container possessor" | "/r/has a" |  | "FN" |  |
| fn:aggregate | /r/HasA | fn:fe:domain | "aggregate" | "domain" | "/r/has a" |  | "FN" |  |
| fn:aging | /r/IsA | fn:eventive_affecting | "aging" | "eventive affecting" | "/r/is a" |  | "FN" |  |
| fn:age | /r/UsedFor | fn:aging | "age" | "aging" | "/r/used for" |  | "FN" |  |
| fn:aging | fn:HasLexicalUnit | fn:lu:aging:aging | "aging" | "aging" | "has lexical unit" |  | "FN" |  |
| fn:aging | fn:HasLexicalUnit | fn:lu:aging:age | "aging" | "age" | "has lexical unit" |  | "FN" |  |
| fn:aging | fn:HasLexicalUnit | fn:lu:aging:mature | "aging" | "mature" | "has lexical unit" |  | "FN" |  |
| fn:aging | /r/HasA | fn:fe:entity | "aging" | "entity" | "/r/has a" |  | "FN" |  |
| fn:aging | /r/HasA | fn:fe:time | "aging" | "time" | "/r/has a" |  | "FN" |  |
| fn:aging | /r/HasA | fn:fe:circumstances | "aging" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:aging | /r/HasA | fn:fe:manner | "aging" | "manner" | "/r/has a" |  | "FN" |  |
| fn:aging | /r/HasA | fn:fe:place | "aging" | "place" | "/r/has a" |  | "FN" |  |
| fn:aging | /r/HasA | fn:fe:result | "aging" | "result" | "/r/has a" |  | "FN" |  |
| fn:agree_or_refuse_to_act | /r/IsA | fn:respond_to_proposal | "agree or refuse to act" | "respond to proposal" | "/r/is a" |  | "FN" |  |
| fn:agree_or_refuse_to_act | fn:HasLexicalUnit | fn:lu:agree_or_refuse_to_act:refuse | "agree or refuse to act" | "refuse" | "has lexical unit" |  | "FN" |  |
| fn:agree_or_refuse_to_act | fn:HasLexicalUnit | fn:lu:agree_or_refuse_to_act:decline | "agree or refuse to act" | "decline" | "has lexical unit" |  | "FN" |  |
| fn:agree_or_refuse_to_act | fn:HasLexicalUnit | fn:lu:agree_or_refuse_to_act:refusal | "agree or refuse to act" | "refusal" | "has lexical unit" |  | "FN" |  |
| fn:agree_or_refuse_to_act | fn:HasLexicalUnit | fn:lu:agree_or_refuse_to_act:agree | "agree or refuse to act" | "agree" | "has lexical unit" |  | "FN" |  |
| fn:agree_or_refuse_to_act | /r/HasA | fn:fe:speaker | "agree or refuse to act" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:fe:interlocutor | /r/IsA | fn:st:sentient | "interlocutor" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:agree_or_refuse_to_act | /r/HasA | fn:fe:interlocutor | "agree or refuse to act" | "interlocutor" | "/r/has a" |  | "FN" |  |
| fn:agree_or_refuse_to_act | /r/HasA | fn:fe:medium | "agree or refuse to act" | "medium" | "/r/has a" |  | "FN" |  |
| fn:agree_or_refuse_to_act | /r/HasA | fn:fe:proposed_action | "agree or refuse to act" | "proposed action" | "/r/has a" |  | "FN" |  |
| fn:agree_or_refuse_to_act | /r/HasA | fn:fe:manner | "agree or refuse to act" | "manner" | "/r/has a" |  | "FN" |  |
| fn:agree_or_refuse_to_act | /r/HasA | fn:fe:depictive | "agree or refuse to act" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:agree_or_refuse_to_act | /r/HasA | fn:fe:means | "agree or refuse to act" | "means" | "/r/has a" |  | "FN" |  |
| fn:agree_or_refuse_to_act | /r/HasA | fn:fe:internal_cause | "agree or refuse to act" | "internal cause" | "/r/has a" |  | "FN" |  |
| fn:agree_or_refuse_to_act | /r/HasA | fn:fe:place | "agree or refuse to act" | "place" | "/r/has a" |  | "FN" |  |
| fn:agree_or_refuse_to_act | /r/HasA | fn:fe:time | "agree or refuse to act" | "time" | "/r/has a" |  | "FN" |  |
| fn:agree_or_refuse_to_act | /r/HasA | fn:fe:purpose | "agree or refuse to act" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:agree_or_refuse_to_act | /r/HasA | fn:fe:particular_iteration | "agree or refuse to act" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:agree_or_refuse_to_act | /r/HasA | fn:fe:role | "agree or refuse to act" | "role" | "/r/has a" |  | "FN" |  |
| fn:agree_or_refuse_to_act | /r/HasA | fn:fe:co-timed_event | "agree or refuse to act" | "co-timed event" | "/r/has a" |  | "FN" |  |
| fn:agree_or_refuse_to_act | /r/HasA | fn:fe:frequency | "agree or refuse to act" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:agree_or_refuse_to_act | /r/HasA | fn:fe:explanation | "agree or refuse to act" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:agree_or_refuse_to_act | /r/HasA | fn:fe:event_description | "agree or refuse to act" | "event description" | "/r/has a" |  | "FN" |  |
| fn:agriculture | /r/IsA | fn:attempt_obtain_food_scenario | "agriculture" | "attempt obtain food scenario" | "/r/is a" |  | "FN" |  |
| fn:agriculture | /r/HasSubevent | fn:food_gathering | "agriculture" | "food gathering" | "/r/has subevent" |  | "FN" |  |
| fn:agriculture | /r/HasSubevent | fn:planting | "agriculture" | "planting" | "/r/has subevent" |  | "FN" |  |
| fn:growing_food | /r/IsA | fn:agriculture | "growing food" | "agriculture" | "/r/is a" |  | "FN" |  |
| fn:agriculture | fn:HasLexicalUnit | fn:lu:agriculture:cultivate | "agriculture" | "cultivate" | "has lexical unit" |  | "FN" |  |
| fn:agriculture | fn:HasLexicalUnit | fn:lu:agriculture:farming | "agriculture" | "farming" | "has lexical unit" |  | "FN" |  |
| fn:agriculture | fn:HasLexicalUnit | fn:lu:agriculture:farm | "agriculture" | "farm" | "has lexical unit" |  | "FN" |  |
| fn:fe:agriculturist | /r/IsA | fn:st:sentient | "agriculturist" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:agriculture | /r/HasA | fn:fe:agriculturist | "agriculture" | "agriculturist" | "/r/has a" |  | "FN" |  |
| fn:fe:food | /r/IsA | fn:st:physical_entity | "food" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:agriculture | /r/HasA | fn:fe:food | "agriculture" | "food" | "/r/has a" |  | "FN" |  |
| fn:agriculture | /r/HasA | fn:fe:instrument | "agriculture" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:agriculture | /r/HasA | fn:fe:duration | "agriculture" | "duration" | "/r/has a" |  | "FN" |  |
| fn:agriculture | /r/HasA | fn:fe:manner | "agriculture" | "manner" | "/r/has a" |  | "FN" |  |
| fn:agriculture | /r/HasA | fn:fe:means | "agriculture" | "means" | "/r/has a" |  | "FN" |  |
| fn:agriculture | /r/HasA | fn:fe:outcome | "agriculture" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:agriculture | /r/HasA | fn:fe:place | "agriculture" | "place" | "/r/has a" |  | "FN" |  |
| fn:agriculture | /r/HasA | fn:fe:time | "agriculture" | "time" | "/r/has a" |  | "FN" |  |
| fn:agriculture | /r/HasA | fn:fe:purpose | "agriculture" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:agriculture | /r/HasA | fn:fe:frequency | "agriculture" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:agriculture | /r/HasA | fn:fe:degree | "agriculture" | "degree" | "/r/has a" |  | "FN" |  |
| fn:agriculture | /r/HasA | fn:fe:ground | "agriculture" | "ground" | "/r/has a" |  | "FN" |  |
| fn:agriculture | /r/HasA | fn:fe:particular_iteration | "agriculture" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:agriculture | /r/HasA | fn:fe:type | "agriculture" | "type" | "/r/has a" |  | "FN" |  |
| fn:agriculture | /r/HasA | fn:fe:event_description | "agriculture" | "event description" | "/r/has a" |  | "FN" |  |
| fn:agriculture | /r/HasA | fn:fe:circumstances | "agriculture" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:aiming | /r/IsA | fn:manipulation | "aiming" | "manipulation" | "/r/is a" |  | "FN" |  |
| fn:attempt_distant_interaction_scenario | /r/HasSubevent | fn:aiming | "attempt distant interaction scenario" | "aiming" | "/r/has subevent" |  | "FN" |  |
| fn:hit_or_miss | /r/HasPrerequisite | fn:aiming | "hit or miss" | "aiming" | "/r/has prerequisite" |  | "FN" |  |
| fn:aiming | fn:HasLexicalUnit | fn:lu:aiming:aim | "aiming" | "aim" | "has lexical unit" |  | "FN" |  |
| fn:aiming | fn:HasLexicalUnit | fn:lu:aiming:target | "aiming" | "target" | "has lexical unit" |  | "FN" |  |
| fn:aiming | fn:HasLexicalUnit | fn:lu:aiming:aim | "aiming" | "aim" | "has lexical unit" |  | "FN" |  |
| fn:aiming | fn:HasLexicalUnit | fn:lu:aiming:target | "aiming" | "target" | "has lexical unit" |  | "FN" |  |
| fn:aiming | fn:HasLexicalUnit | fn:lu:aiming:direct | "aiming" | "direct" | "has lexical unit" |  | "FN" |  |
| fn:aiming | /r/HasA | fn:fe:agent | "aiming" | "agent" | "/r/has a" |  | "FN" |  |
| fn:fe:targeted | /r/RelatedTo | fn:fe:target_location | "targeted" | "target location" | "/r/related to" |  | "FN" |  |
| fn:aiming | /r/HasA | fn:fe:targeted | "aiming" | "targeted" | "/r/has a" |  | "FN" |  |
| fn:aiming | /r/HasA | fn:fe:outcome | "aiming" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:aiming | /r/HasA | fn:fe:means | "aiming" | "means" | "/r/has a" |  | "FN" |  |
| fn:aiming | /r/HasA | fn:fe:time | "aiming" | "time" | "/r/has a" |  | "FN" |  |
| fn:aiming | /r/HasA | fn:fe:depictive | "aiming" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:aiming | /r/HasA | fn:fe:place | "aiming" | "place" | "/r/has a" |  | "FN" |  |
| fn:aiming | /r/HasA | fn:fe:manner | "aiming" | "manner" | "/r/has a" |  | "FN" |  |
| fn:aiming | /r/HasA | fn:fe:duration | "aiming" | "duration" | "/r/has a" |  | "FN" |  |
| fn:aiming | /r/HasA | fn:fe:purpose | "aiming" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:aiming | /r/HasA | fn:fe:particular_iteration | "aiming" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:aiming | /r/HasA | fn:fe:circumstances | "aiming" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:aiming | /r/HasA | fn:fe:instrument | "aiming" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:aiming | /r/HasA | fn:fe:target_location | "aiming" | "target location" | "/r/has a" |  | "FN" |  |
| fn:aiming | /r/HasA | fn:fe:location_of_protagonist | "aiming" | "location of protagonist" | "/r/has a" |  | "FN" |  |
| fn:aiming | /r/HasA | fn:fe:activity | "aiming" | "activity" | "/r/has a" |  | "FN" |  |
| fn:aiming | /r/HasA | fn:fe:containing_event | "aiming" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:aiming | /r/HasA | fn:fe:explanation | "aiming" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:alignment_image_schema | /r/IsA | fn:image_schema | "alignment image schema" | "image schema" | "/r/is a" |  | "FN" |  |
| fn:alignment_image_schema | /r/HasA | fn:fe:alignment_match | "alignment image schema" | "alignment match" | "/r/has a" |  | "FN" |  |
| fn:alignment_image_schema | /r/HasA | fn:fe:ground | "alignment image schema" | "ground" | "/r/has a" |  | "FN" |  |
| fn:alignment_image_schema | /r/HasA | fn:fe:alignment_mismatch | "alignment image schema" | "alignment mismatch" | "/r/has a" |  | "FN" |  |
| fn:competition | /r/UsedFor | fn:alliance | "competition" | "alliance" | "/r/used for" |  | "FN" |  |
| fn:organization | /r/UsedFor | fn:alliance | "organization" | "alliance" | "/r/used for" |  | "FN" |  |
| fn:alliance | fn:HasLexicalUnit | fn:lu:alliance:alliance | "alliance" | "alliance" | "has lexical unit" |  | "FN" |  |
| fn:alliance | fn:HasLexicalUnit | fn:lu:alliance:coalition | "alliance" | "coalition" | "has lexical unit" |  | "FN" |  |
| fn:fe:alliance | /r/IsA | fn:st:group | "alliance" | "group" | "/r/is a" |  | "FN" |  |
| fn:st:group | /r/IsA | fn:st:ontological_type | "group" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:st:organization | /r/IsA | fn:st:group | "organization" | "group" | "/r/is a" |  | "FN" |  |
| fn:alliance | /r/HasA | fn:fe:alliance | "alliance" | "alliance" | "/r/has a" |  | "FN" |  |
| fn:fe:members | /r/IsA | fn:st:human | "members" | "human" | "/r/is a" |  | "FN" |  |
| fn:alliance | /r/HasA | fn:fe:members | "alliance" | "members" | "/r/has a" |  | "FN" |  |
| fn:alliance | /r/HasA | fn:fe:purpose | "alliance" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:alliance | /r/HasA | fn:fe:period_of_existence | "alliance" | "period of existence" | "/r/has a" |  | "FN" |  |
| fn:fe:member_1 | /r/RelatedTo | fn:fe:members | "member 1" | "members" | "/r/related to" |  | "FN" |  |
| fn:alliance | /r/HasA | fn:fe:member_1 | "alliance" | "member 1" | "/r/has a" |  | "FN" |  |
| fn:fe:member_2 | /r/RelatedTo | fn:fe:members | "member 2" | "members" | "/r/related to" |  | "FN" |  |
| fn:alliance | /r/HasA | fn:fe:member_2 | "alliance" | "member 2" | "/r/has a" |  | "FN" |  |
| fn:alliance | /r/HasA | fn:fe:descriptor | "alliance" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:alternatives | /r/UsedFor | fn:opportunity | "alternatives" | "opportunity" | "/r/used for" |  | "FN" |  |
| fn:alternatives | /r/UsedFor | fn:time_period_of_action | "alternatives" | "time period of action" | "/r/used for" |  | "FN" |  |
| fn:alternatives | /r/IsA | fn:alternativity | "alternatives" | "alternativity" | "/r/is a" |  | "FN" |  |
| fn:alternatives | fn:HasLexicalUnit | fn:lu:alternatives:possibility | "alternatives" | "possibility" | "has lexical unit" |  | "FN" |  |
| fn:alternatives | fn:HasLexicalUnit | fn:lu:alternatives:way | "alternatives" | "way" | "has lexical unit" |  | "FN" |  |
| fn:alternatives | fn:HasLexicalUnit | fn:lu:alternatives:choice | "alternatives" | "choice" | "has lexical unit" |  | "FN" |  |
| fn:alternatives | fn:HasLexicalUnit | fn:lu:alternatives:use | "alternatives" | "use" | "has lexical unit" |  | "FN" |  |
| fn:alternatives | fn:HasLexicalUnit | fn:lu:alternatives:alternative | "alternatives" | "alternative" | "has lexical unit" |  | "FN" |  |
| fn:alternatives | fn:HasLexicalUnit | fn:lu:alternatives:option | "alternatives" | "option" | "has lexical unit" |  | "FN" |  |
| fn:alternatives | fn:HasLexicalUnit | fn:lu:alternatives:future | "alternatives" | "future" | "has lexical unit" |  | "FN" |  |
| fn:alternatives | fn:HasLexicalUnit | fn:lu:alternatives:chance | "alternatives" | "chance" | "has lexical unit" |  | "FN" |  |
| fn:alternatives | /r/HasA | fn:fe:situation | "alternatives" | "situation" | "/r/has a" |  | "FN" |  |
| fn:alternatives | /r/HasA | fn:fe:agent | "alternatives" | "agent" | "/r/has a" |  | "FN" |  |
| fn:alternatives | /r/HasA | fn:fe:number_of_possibilities | "alternatives" | "number of possibilities" | "/r/has a" |  | "FN" |  |
| fn:alternatives | /r/HasA | fn:fe:salient_entity | "alternatives" | "salient entity" | "/r/has a" |  | "FN" |  |
| fn:alternatives | /r/HasA | fn:fe:purpose | "alternatives" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:conditional_scenario | /r/IsA | fn:alternativity | "conditional scenario" | "alternativity" | "/r/is a" |  | "FN" |  |
| fn:negation | /r/IsA | fn:alternativity | "negation" | "alternativity" | "/r/is a" |  | "FN" |  |
| fn:alternativity | /r/UsedFor | fn:causation_scenario | "alternativity" | "causation scenario" | "/r/used for" |  | "FN" |  |
| fn:alternatives | /r/IsA | fn:alternativity | "alternatives" | "alternativity" | "/r/is a" |  | "FN" |  |
| fn:presentation_of_mitigation | /r/IsA | fn:alternativity | "presentation of mitigation" | "alternativity" | "/r/is a" |  | "FN" |  |
| fn:alternativity | /r/HasA | fn:fe:profiled_alternative | "alternativity" | "profiled alternative" | "/r/has a" |  | "FN" |  |
| fn:alternativity | /r/HasA | fn:fe:contrasting_alternative | "alternativity" | "contrasting alternative" | "/r/has a" |  | "FN" |  |
| fn:amalgamation | /r/IsA | fn:reciprocality | "amalgamation" | "reciprocality" | "/r/is a" |  | "FN" |  |
| fn:cause_to_amalgamate | /r/SimilarTo | fn:amalgamation | "cause to amalgamate" | "amalgamation" | "/r/similar to" |  | "FN" |  |
| fn:cause_to_amalgamate | /r/Causes | fn:amalgamation | "cause to amalgamate" | "amalgamation" | "/r/causes" |  | "FN" |  |
| fn:amalgamation | fn:HasLexicalUnit | fn:lu:amalgamation:merger | "amalgamation" | "merger" | "has lexical unit" |  | "FN" |  |
| fn:amalgamation | fn:HasLexicalUnit | fn:lu:amalgamation:amalgamate | "amalgamation" | "amalgamate" | "has lexical unit" |  | "FN" |  |
| fn:amalgamation | fn:HasLexicalUnit | fn:lu:amalgamation:blend | "amalgamation" | "blend" | "has lexical unit" |  | "FN" |  |
| fn:amalgamation | fn:HasLexicalUnit | fn:lu:amalgamation:combine | "amalgamation" | "combine" | "has lexical unit" |  | "FN" |  |
| fn:amalgamation | fn:HasLexicalUnit | fn:lu:amalgamation:commingle | "amalgamation" | "commingle" | "has lexical unit" |  | "FN" |  |
| fn:amalgamation | fn:HasLexicalUnit | fn:lu:amalgamation:fuse | "amalgamation" | "fuse" | "has lexical unit" |  | "FN" |  |
| fn:amalgamation | fn:HasLexicalUnit | fn:lu:amalgamation:intermix | "amalgamation" | "intermix" | "has lexical unit" |  | "FN" |  |
| fn:amalgamation | fn:HasLexicalUnit | fn:lu:amalgamation:meld | "amalgamation" | "meld" | "has lexical unit" |  | "FN" |  |
| fn:amalgamation | fn:HasLexicalUnit | fn:lu:amalgamation:merge | "amalgamation" | "merge" | "has lexical unit" |  | "FN" |  |
| fn:amalgamation | fn:HasLexicalUnit | fn:lu:amalgamation:unify | "amalgamation" | "unify" | "has lexical unit" |  | "FN" |  |
| fn:amalgamation | fn:HasLexicalUnit | fn:lu:amalgamation:unite | "amalgamation" | "unite" | "has lexical unit" |  | "FN" |  |
| fn:amalgamation | fn:HasLexicalUnit | fn:lu:amalgamation:band_together | "amalgamation" | "band together" | "has lexical unit" |  | "FN" |  |
| fn:amalgamation | fn:HasLexicalUnit | fn:lu:amalgamation:come_together | "amalgamation" | "come together" | "has lexical unit" |  | "FN" |  |
| fn:amalgamation | fn:HasLexicalUnit | fn:lu:amalgamation:combination | "amalgamation" | "combination" | "has lexical unit" |  | "FN" |  |
| fn:amalgamation | fn:HasLexicalUnit | fn:lu:amalgamation:coalesce | "amalgamation" | "coalesce" | "has lexical unit" |  | "FN" |  |
| fn:amalgamation | fn:HasLexicalUnit | fn:lu:amalgamation:consolidate | "amalgamation" | "consolidate" | "has lexical unit" |  | "FN" |  |
| fn:amalgamation | fn:HasLexicalUnit | fn:lu:amalgamation:join | "amalgamation" | "join" | "has lexical unit" |  | "FN" |  |
| fn:amalgamation | fn:HasLexicalUnit | fn:lu:amalgamation:jumble | "amalgamation" | "jumble" | "has lexical unit" |  | "FN" |  |
| fn:amalgamation | fn:HasLexicalUnit | fn:lu:amalgamation:mix | "amalgamation" | "mix" | "has lexical unit" |  | "FN" |  |
| fn:amalgamation | /r/HasA | fn:fe:parts | "amalgamation" | "parts" | "/r/has a" |  | "FN" |  |
| fn:amalgamation | /r/HasA | fn:fe:whole | "amalgamation" | "whole" | "/r/has a" |  | "FN" |  |
| fn:fe:part_1 | /r/HasPrerequisite | fn:fe:part_2 | "part 1" | "part 2" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:part_1 | /r/RelatedTo | fn:fe:parts | "part 1" | "parts" | "/r/related to" |  | "FN" |  |
| fn:amalgamation | /r/HasA | fn:fe:part_1 | "amalgamation" | "part 1" | "/r/has a" |  | "FN" |  |
| fn:fe:part_2 | /r/HasPrerequisite | fn:fe:part_1 | "part 2" | "part 1" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:part_2 | /r/RelatedTo | fn:fe:parts | "part 2" | "parts" | "/r/related to" |  | "FN" |  |
| fn:amalgamation | /r/HasA | fn:fe:part_2 | "amalgamation" | "part 2" | "/r/has a" |  | "FN" |  |
| fn:amalgamation | /r/HasA | fn:fe:degree | "amalgamation" | "degree" | "/r/has a" |  | "FN" |  |
| fn:amalgamation | /r/HasA | fn:fe:manner | "amalgamation" | "manner" | "/r/has a" |  | "FN" |  |
| fn:amalgamation | /r/HasA | fn:fe:result | "amalgamation" | "result" | "/r/has a" |  | "FN" |  |
| fn:amalgamation | /r/HasA | fn:fe:time | "amalgamation" | "time" | "/r/has a" |  | "FN" |  |
| fn:amalgamation | /r/HasA | fn:fe:place | "amalgamation" | "place" | "/r/has a" |  | "FN" |  |
| fn:amalgamation | /r/HasA | fn:fe:depictive | "amalgamation" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:amalgamation | /r/HasA | fn:fe:descriptor | "amalgamation" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:amassing | /r/IsA | fn:getting | "amassing" | "getting" | "/r/is a" |  | "FN" |  |
| fn:amassing | fn:HasLexicalUnit | fn:lu:amassing:amass | "amassing" | "amass" | "has lexical unit" |  | "FN" |  |
| fn:amassing | fn:HasLexicalUnit | fn:lu:amassing:accumulate | "amassing" | "accumulate" | "has lexical unit" |  | "FN" |  |
| fn:amassing | fn:HasLexicalUnit | fn:lu:amassing:stockpile | "amassing" | "stockpile" | "has lexical unit" |  | "FN" |  |
| fn:amassing | fn:HasLexicalUnit | fn:lu:amassing:hoard | "amassing" | "hoard" | "has lexical unit" |  | "FN" |  |
| fn:amassing | fn:HasLexicalUnit | fn:lu:amassing:accumulation | "amassing" | "accumulation" | "has lexical unit" |  | "FN" |  |
| fn:amassing | /r/HasA | fn:fe:recipient | "amassing" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:amassing | /r/HasA | fn:fe:mass_theme | "amassing" | "mass theme" | "/r/has a" |  | "FN" |  |
| fn:fe:source | /r/IsA | fn:st:source | "source" | "source" | "/r/is a" |  | "FN" |  |
| fn:st:source | /r/IsA | fn:st:ontological_type | "source" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:amassing | /r/HasA | fn:fe:source | "amassing" | "source" | "/r/has a" |  | "FN" |  |
| fn:amassing | /r/HasA | fn:fe:place | "amassing" | "place" | "/r/has a" |  | "FN" |  |
| fn:amassing | /r/HasA | fn:fe:purpose | "amassing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:amassing | /r/HasA | fn:fe:explanation | "amassing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:amassing | /r/HasA | fn:fe:time | "amassing" | "time" | "/r/has a" |  | "FN" |  |
| fn:amassing | /r/HasA | fn:fe:means | "amassing" | "means" | "/r/has a" |  | "FN" |  |
| fn:amassing | /r/HasA | fn:fe:manner | "amassing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:amassing | /r/HasA | fn:fe:result | "amassing" | "result" | "/r/has a" |  | "FN" |  |
| fn:amassing | /r/HasA | fn:fe:duration | "amassing" | "duration" | "/r/has a" |  | "FN" |  |
| fn:amassing | /r/HasA | fn:fe:circumstances | "amassing" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:amassing | /r/HasA | fn:fe:role | "amassing" | "role" | "/r/has a" |  | "FN" |  |
| fn:ambient_temperature | /r/IsA | fn:temperature | "ambient temperature" | "temperature" | "/r/is a" |  | "FN" |  |
| fn:ambient_temperature | fn:HasLexicalUnit | fn:lu:ambient_temperature:cool | "ambient temperature" | "cool" | "has lexical unit" |  | "FN" |  |
| fn:ambient_temperature | fn:HasLexicalUnit | fn:lu:ambient_temperature:cold | "ambient temperature" | "cold" | "has lexical unit" |  | "FN" |  |
| fn:ambient_temperature | fn:HasLexicalUnit | fn:lu:ambient_temperature:hot | "ambient temperature" | "hot" | "has lexical unit" |  | "FN" |  |
| fn:ambient_temperature | fn:HasLexicalUnit | fn:lu:ambient_temperature:warm | "ambient temperature" | "warm" | "has lexical unit" |  | "FN" |  |
| fn:ambient_temperature | fn:HasLexicalUnit | fn:lu:ambient_temperature:scorcher | "ambient temperature" | "scorcher" | "has lexical unit" |  | "FN" |  |
| fn:ambient_temperature | fn:HasLexicalUnit | fn:lu:ambient_temperature:chilly | "ambient temperature" | "chilly" | "has lexical unit" |  | "FN" |  |
| fn:ambient_temperature | fn:HasLexicalUnit | fn:lu:ambient_temperature:temperature | "ambient temperature" | "temperature" | "has lexical unit" |  | "FN" |  |
| fn:ambient_temperature | fn:HasLexicalUnit | fn:lu:ambient_temperature:freezing | "ambient temperature" | "freezing" | "has lexical unit" |  | "FN" |  |
| fn:ambient_temperature | fn:HasLexicalUnit | fn:lu:ambient_temperature:cold | "ambient temperature" | "cold" | "has lexical unit" |  | "FN" |  |
| fn:ambient_temperature | /r/HasA | fn:fe:place | "ambient temperature" | "place" | "/r/has a" |  | "FN" |  |
| fn:ambient_temperature | /r/HasA | fn:fe:attribute | "ambient temperature" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:fe:temperature | /r/RelatedTo | fn:fe:degree | "temperature" | "degree" | "/r/related to" |  | "FN" |  |
| fn:ambient_temperature | /r/HasA | fn:fe:temperature | "ambient temperature" | "temperature" | "/r/has a" |  | "FN" |  |
| fn:ambient_temperature | /r/HasA | fn:fe:degree | "ambient temperature" | "degree" | "/r/has a" |  | "FN" |  |
| fn:ambient_temperature | /r/HasA | fn:fe:time | "ambient temperature" | "time" | "/r/has a" |  | "FN" |  |
| fn:ambient_temperature | /r/HasA | fn:fe:circumstances | "ambient temperature" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:ambient_temperature | /r/HasA | fn:fe:weather | "ambient temperature" | "weather" | "/r/has a" |  | "FN" |  |
| fn:ammunition | /r/IsA | fn:artifact | "ammunition" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:weapon | /r/UsedFor | fn:ammunition | "weapon" | "ammunition" | "/r/used for" |  | "FN" |  |
| fn:ammunition | fn:HasLexicalUnit | fn:lu:ammunition:ammunition | "ammunition" | "ammunition" | "has lexical unit" |  | "FN" |  |
| fn:ammunition | fn:HasLexicalUnit | fn:lu:ammunition:ammo | "ammunition" | "ammo" | "has lexical unit" |  | "FN" |  |
| fn:ammunition | fn:HasLexicalUnit | fn:lu:ammunition:ordnance | "ammunition" | "ordnance" | "has lexical unit" |  | "FN" |  |
| fn:ammunition | fn:HasLexicalUnit | fn:lu:ammunition:round | "ammunition" | "round" | "has lexical unit" |  | "FN" |  |
| fn:ammunition | fn:HasLexicalUnit | fn:lu:ammunition:munitions | "ammunition" | "munitions" | "has lexical unit" |  | "FN" |  |
| fn:ammunition | fn:HasLexicalUnit | fn:lu:ammunition:bullet | "ammunition" | "bullet" | "has lexical unit" |  | "FN" |  |
| fn:ammunition | fn:HasLexicalUnit | fn:lu:ammunition:shell | "ammunition" | "shell" | "has lexical unit" |  | "FN" |  |
| fn:ammunition | /r/HasA | fn:fe:ammunition | "ammunition" | "ammunition" | "/r/has a" |  | "FN" |  |
| fn:ammunition | /r/HasA | fn:fe:use | "ammunition" | "use" | "/r/has a" |  | "FN" |  |
| fn:ammunition | /r/HasA | fn:fe:creator | "ammunition" | "creator" | "/r/has a" |  | "FN" |  |
| fn:ammunition | /r/HasA | fn:fe:time_of_creation | "ammunition" | "time of creation" | "/r/has a" |  | "FN" |  |
| fn:ammunition | /r/HasA | fn:fe:name | "ammunition" | "name" | "/r/has a" |  | "FN" |  |
| fn:ammunition | /r/HasA | fn:fe:type | "ammunition" | "type" | "/r/has a" |  | "FN" |  |
| fn:ammunition | /r/HasA | fn:fe:material | "ammunition" | "material" | "/r/has a" |  | "FN" |  |
| fn:ammunition | /r/HasA | fn:fe:weapon | "ammunition" | "weapon" | "/r/has a" |  | "FN" |  |
| fn:amounting_to | /r/UsedFor | fn:adding_up | "amounting to" | "adding up" | "/r/used for" |  | "FN" |  |
| fn:adding_up | /r/SimilarTo | fn:amounting_to | "adding up" | "amounting to" | "/r/similar to" |  | "FN" |  |
| fn:amounting_to | fn:HasLexicalUnit | fn:lu:amounting_to:total | "amounting to" | "total" | "has lexical unit" |  | "FN" |  |
| fn:amounting_to | fn:HasLexicalUnit | fn:lu:amounting_to:amount | "amounting to" | "amount" | "has lexical unit" |  | "FN" |  |
| fn:amounting_to | fn:HasLexicalUnit | fn:lu:amounting_to:total | "amounting to" | "total" | "has lexical unit" |  | "FN" |  |
| fn:amounting_to | fn:HasLexicalUnit | fn:lu:amounting_to:tally | "amounting to" | "tally" | "has lexical unit" |  | "FN" |  |
| fn:amounting_to | fn:HasLexicalUnit | fn:lu:amounting_to:total | "amounting to" | "total" | "has lexical unit" |  | "FN" |  |
| fn:amounting_to | fn:HasLexicalUnit | fn:lu:amounting_to:number | "amounting to" | "number" | "has lexical unit" |  | "FN" |  |
| fn:amounting_to | fn:HasLexicalUnit | fn:lu:amounting_to:in_amount | "amounting to" | "in amount" | "has lexical unit" |  | "FN" |  |
| fn:amounting_to | /r/HasA | fn:fe:value | "amounting to" | "value" | "/r/has a" |  | "FN" |  |
| fn:amounting_to | /r/HasA | fn:fe:attribute | "amounting to" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:amounting_to | /r/HasA | fn:fe:time_span | "amounting to" | "time span" | "/r/has a" |  | "FN" |  |
| fn:amounting_to | /r/HasA | fn:fe:frequency | "amounting to" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:fe:numbers | /r/RelatedTo | fn:fe:attribute | "numbers" | "attribute" | "/r/related to" |  | "FN" |  |
| fn:amounting_to | /r/HasA | fn:fe:numbers | "amounting to" | "numbers" | "/r/has a" |  | "FN" |  |
| fn:animals | /r/IsA | fn:biological_entity | "animals" | "biological entity" | "/r/is a" |  | "FN" |  |
| fn:animals | fn:HasLexicalUnit | fn:lu:animals:dog | "animals" | "dog" | "has lexical unit" |  | "FN" |  |
| fn:animals | fn:HasLexicalUnit | fn:lu:animals:cat | "animals" | "cat" | "has lexical unit" |  | "FN" |  |
| fn:animals | fn:HasLexicalUnit | fn:lu:animals:pig | "animals" | "pig" | "has lexical unit" |  | "FN" |  |
| fn:animals | fn:HasLexicalUnit | fn:lu:animals:cow | "animals" | "cow" | "has lexical unit" |  | "FN" |  |
| fn:animals | fn:HasLexicalUnit | fn:lu:animals:sheep | "animals" | "sheep" | "has lexical unit" |  | "FN" |  |
| fn:animals | fn:HasLexicalUnit | fn:lu:animals:animal | "animals" | "animal" | "has lexical unit" |  | "FN" |  |
| fn:fe:animal | /r/IsA | fn:st:living_thing | "animal" | "living thing" | "/r/is a" |  | "FN" |  |
| fn:st:living_thing | /r/IsA | fn:st:ontological_type | "living thing" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:st:animate_being | /r/IsA | fn:st:living_thing | "animate being" | "living thing" | "/r/is a" |  | "FN" |  |
| fn:animals | /r/HasA | fn:fe:animal | "animals" | "animal" | "/r/has a" |  | "FN" |  |
| fn:animals | /r/HasA | fn:fe:descriptor | "animals" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:animals | /r/HasA | fn:fe:origin | "animals" | "origin" | "/r/has a" |  | "FN" |  |
| fn:animals | /r/HasA | fn:fe:characteristic | "animals" | "characteristic" | "/r/has a" |  | "FN" |  |
| fn:annoyance | /r/IsA | fn:emotions_by_stimulus | "annoyance" | "emotions by stimulus" | "/r/is a" |  | "FN" |  |
| fn:annoyance | fn:HasLexicalUnit | fn:lu:annoyance:annoyed | "annoyance" | "annoyed" | "has lexical unit" |  | "FN" |  |
| fn:annoyance | fn:HasLexicalUnit | fn:lu:annoyance:irritated | "annoyance" | "irritated" | "has lexical unit" |  | "FN" |  |
| fn:annoyance | fn:HasLexicalUnit | fn:lu:annoyance:frustrated | "annoyance" | "frustrated" | "has lexical unit" |  | "FN" |  |
| fn:fe:experiencer | /r/IsA | fn:st:sentient | "experiencer" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:annoyance | /r/HasA | fn:fe:experiencer | "annoyance" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:annoyance | /r/HasA | fn:fe:topic | "annoyance" | "topic" | "/r/has a" |  | "FN" |  |
| fn:annoyance | /r/HasA | fn:fe:stimulus | "annoyance" | "stimulus" | "/r/has a" |  | "FN" |  |
| fn:annoyance | /r/HasA | fn:fe:degree | "annoyance" | "degree" | "/r/has a" |  | "FN" |  |
| fn:annoyance | /r/HasA | fn:fe:empathy_target | "annoyance" | "empathy target" | "/r/has a" |  | "FN" |  |
| fn:annoyance | /r/HasA | fn:fe:expressor | "annoyance" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:annoyance | /r/HasA | fn:fe:explanation | "annoyance" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:annoyance | /r/HasA | fn:fe:circumstances | "annoyance" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:annoyance | /r/HasA | fn:fe:state | "annoyance" | "state" | "/r/has a" |  | "FN" |  |
| fn:annoyance | /r/HasA | fn:fe:parameter | "annoyance" | "parameter" | "/r/has a" |  | "FN" |  |
| fn:annoyance | /r/HasA | fn:fe:manner | "annoyance" | "manner" | "/r/has a" |  | "FN" |  |
| fn:annoyance | /r/HasA | fn:fe:time | "annoyance" | "time" | "/r/has a" |  | "FN" |  |
| fn:criminal_process | /r/UsedFor | fn:appeal | "criminal process" | "appeal" | "/r/used for" |  | "FN" |  |
| fn:appeal | /r/SimilarTo | fn:entering_of_plea | "appeal" | "entering of plea" | "/r/similar to" |  | "FN" |  |
| fn:appeal | fn:HasLexicalUnit | fn:lu:appeal:appeal | "appeal" | "appeal" | "has lexical unit" |  | "FN" |  |
| fn:appeal | fn:HasLexicalUnit | fn:lu:appeal:appeal | "appeal" | "appeal" | "has lexical unit" |  | "FN" |  |
| fn:appeal | fn:HasLexicalUnit | fn:lu:appeal:appellate | "appeal" | "appellate" | "has lexical unit" |  | "FN" |  |
| fn:appeal | fn:HasLexicalUnit | fn:lu:appeal:appellant | "appeal" | "appellant" | "has lexical unit" |  | "FN" |  |
| fn:appeal | /r/HasA | fn:fe:convict | "appeal" | "convict" | "/r/has a" |  | "FN" |  |
| fn:appeal | /r/HasA | fn:fe:representative | "appeal" | "representative" | "/r/has a" |  | "FN" |  |
| fn:appeal | /r/HasA | fn:fe:decision | "appeal" | "decision" | "/r/has a" |  | "FN" |  |
| fn:appeal | /r/HasA | fn:fe:grounds | "appeal" | "grounds" | "/r/has a" |  | "FN" |  |
| fn:appeal | /r/HasA | fn:fe:court | "appeal" | "court" | "/r/has a" |  | "FN" |  |
| fn:appeal | /r/HasA | fn:fe:time | "appeal" | "time" | "/r/has a" |  | "FN" |  |
| fn:appeal | /r/HasA | fn:fe:re-encoding | "appeal" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:appeal | /r/HasA | fn:fe:explanation | "appeal" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:appellations | /r/IsA | fn:being_named | "appellations" | "being named" | "/r/is a" |  | "FN" |  |
| fn:rank | /r/UsedFor | fn:appellations | "rank" | "appellations" | "/r/used for" |  | "FN" |  |
| fn:appellations | /r/RelatedTo | fn:kinship | "appellations" | "kinship" | "/r/related to" |  | "FN" |  |
| fn:appellations | /r/RelatedTo | fn:leadership | "appellations" | "leadership" | "/r/related to" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:officer | "appellations" | "officer" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:general | "appellations" | "general" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:captain | "appellations" | "captain" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:president | "appellations" | "president" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:bishop | "appellations" | "bishop" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:chairman | "appellations" | "chairman" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:chairperson | "appellations" | "chairperson" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:chief | "appellations" | "chief" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:commander | "appellations" | "commander" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:commissioner | "appellations" | "commissioner" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:congressman | "appellations" | "congressman" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:congresswoman | "appellations" | "congresswoman" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:director | "appellations" | "director" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:duchess | "appellations" | "duchess" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:emperor | "appellations" | "emperor" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:empress | "appellations" | "empress" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:executive | "appellations" | "executive" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:governor | "appellations" | "governor" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:headmaster | "appellations" | "headmaster" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:imam | "appellations" | "imam" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:kaiser | "appellations" | "kaiser" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:king | "appellations" | "king" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:leader | "appellations" | "leader" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:legislator | "appellations" | "legislator" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:maharaja | "appellations" | "maharaja" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:mayor | "appellations" | "mayor" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:minister | "appellations" | "minister" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:mogul | "appellations" | "mogul" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:monarch | "appellations" | "monarch" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:official | "appellations" | "official" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:premier | "appellations" | "premier" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:prince | "appellations" | "prince" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:principal | "appellations" | "principal" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:queen | "appellations" | "queen" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:representative | "appellations" | "representative" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:secretary | "appellations" | "secretary" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:shah | "appellations" | "shah" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:sheik | "appellations" | "sheik" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:sultan | "appellations" | "sultan" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:superintendent | "appellations" | "superintendent" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:supervisor | "appellations" | "supervisor" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:tsar | "appellations" | "tsar" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:mother | "appellations" | "mother" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:father | "appellations" | "father" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:doctor | "appellations" | "doctor" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:dr | "appellations" | "dr" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:mr | "appellations" | "mr" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:mrs | "appellations" | "mrs" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:ms | "appellations" | "ms" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:miss | "appellations" | "miss" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:child | "appellations" | "child" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:aunt | "appellations" | "aunt" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:uncle | "appellations" | "uncle" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:sister | "appellations" | "sister" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:brother | "appellations" | "brother" | "has lexical unit" |  | "FN" |  |
| fn:appellations | fn:HasLexicalUnit | fn:lu:appellations:cousin | "appellations" | "cousin" | "has lexical unit" |  | "FN" |  |
| fn:appellations | /r/HasA | fn:fe:name | "appellations" | "name" | "/r/has a" |  | "FN" |  |
| fn:appellations | /r/HasA | fn:fe:title | "appellations" | "title" | "/r/has a" |  | "FN" |  |
| fn:appellations | /r/HasA | fn:fe:context | "appellations" | "context" | "/r/has a" |  | "FN" |  |
| fn:appellations | /r/HasA | fn:fe:type | "appellations" | "type" | "/r/has a" |  | "FN" |  |
| fn:apply_heat | /r/IsA | fn:activity | "apply heat" | "activity" | "/r/is a" |  | "FN" |  |
| fn:apply_heat | /r/IsA | fn:intentionally_affect | "apply heat" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:apply_heat | /r/UsedFor | fn:cooking_creation | "apply heat" | "cooking creation" | "/r/used for" |  | "FN" |  |
| fn:apply_heat | /r/RelatedTo | fn:cooking_creation | "apply heat" | "cooking creation" | "/r/related to" |  | "FN" |  |
| fn:apply_heat | /r/SimilarTo | fn:soaking | "apply heat" | "soaking" | "/r/similar to" |  | "FN" |  |
| fn:soaking | /r/SimilarTo | fn:apply_heat | "soaking" | "apply heat" | "/r/similar to" |  | "FN" |  |
| fn:apply_heat | /r/Causes | fn:absorb_heat | "apply heat" | "absorb heat" | "/r/causes" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:braise | "apply heat" | "braise" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:blanch | "apply heat" | "blanch" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:brown | "apply heat" | "brown" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:broil | "apply heat" | "broil" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:parboil | "apply heat" | "parboil" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:coddle | "apply heat" | "coddle" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:scald | "apply heat" | "scald" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:stew | "apply heat" | "stew" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:char | "apply heat" | "char" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:poach | "apply heat" | "poach" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:toast | "apply heat" | "toast" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:saute | "apply heat" | "saute" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:microwave | "apply heat" | "microwave" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:steam | "apply heat" | "steam" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:fry | "apply heat" | "fry" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:grill | "apply heat" | "grill" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:roast | "apply heat" | "roast" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:boil | "apply heat" | "boil" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:simmer | "apply heat" | "simmer" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:cook | "apply heat" | "cook" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:bake | "apply heat" | "bake" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:barbecue | "apply heat" | "barbecue" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:deep_fry | "apply heat" | "deep fry" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:singe | "apply heat" | "singe" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:sear | "apply heat" | "sear" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:plank | "apply heat" | "plank" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:scorch | "apply heat" | "scorch" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:frying | "apply heat" | "frying" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:grilling | "apply heat" | "grilling" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:boiling | "apply heat" | "boiling" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:roasting | "apply heat" | "roasting" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:melting | "apply heat" | "melting" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:melt | "apply heat" | "melt" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:broiling | "apply heat" | "broiling" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:toasting | "apply heat" | "toasting" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:simmering | "apply heat" | "simmering" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:steaming | "apply heat" | "steaming" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:stewing | "apply heat" | "stewing" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:baking | "apply heat" | "baking" | "has lexical unit" |  | "FN" |  |
| fn:apply_heat | fn:HasLexicalUnit | fn:lu:apply_heat:cooking | "apply heat" | "cooking" | "has lexical unit" |  | "FN" |  |
| fn:fe:cook | /r/IsA | fn:st:sentient | "cook" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:apply_heat | /r/HasA | fn:fe:cook | "apply heat" | "cook" | "/r/has a" |  | "FN" |  |
| fn:fe:heating_instrument | /r/IsA | fn:st:physical_entity | "heating instrument" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:apply_heat | /r/HasA | fn:fe:heating_instrument | "apply heat" | "heating instrument" | "/r/has a" |  | "FN" |  |
| fn:apply_heat | /r/HasA | fn:fe:place | "apply heat" | "place" | "/r/has a" |  | "FN" |  |
| fn:apply_heat | /r/HasA | fn:fe:food | "apply heat" | "food" | "/r/has a" |  | "FN" |  |
| fn:apply_heat | /r/HasA | fn:fe:time | "apply heat" | "time" | "/r/has a" |  | "FN" |  |
| fn:apply_heat | /r/HasA | fn:fe:means | "apply heat" | "means" | "/r/has a" |  | "FN" |  |
| fn:apply_heat | /r/HasA | fn:fe:purpose | "apply heat" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:apply_heat | /r/HasA | fn:fe:duration | "apply heat" | "duration" | "/r/has a" |  | "FN" |  |
| fn:apply_heat | /r/HasA | fn:fe:medium | "apply heat" | "medium" | "/r/has a" |  | "FN" |  |
| fn:fe:co-participant | /r/HasPrerequisite | fn:fe:food | "co-participant" | "food" | "/r/has prerequisite" |  | "FN" |  |
| fn:apply_heat | /r/HasA | fn:fe:co-participant | "apply heat" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:fe:temperature_setting | /r/IsA | fn:st:temperature | "temperature setting" | "temperature" | "/r/is a" |  | "FN" |  |
| fn:apply_heat | /r/HasA | fn:fe:temperature_setting | "apply heat" | "temperature setting" | "/r/has a" |  | "FN" |  |
| fn:apply_heat | /r/HasA | fn:fe:degree | "apply heat" | "degree" | "/r/has a" |  | "FN" |  |
| fn:apply_heat | /r/HasA | fn:fe:manner | "apply heat" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fe:container | /r/IsA | fn:st:container | "container" | "container" | "/r/is a" |  | "FN" |  |
| fn:st:container | /r/IsA | fn:st:ontological_type | "container" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:apply_heat | /r/HasA | fn:fe:container | "apply heat" | "container" | "/r/has a" |  | "FN" |  |
| fn:apply_heat | /r/HasA | fn:fe:beneficiary | "apply heat" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:change_of_leadership | /r/IsA | fn:appointing | "change of leadership" | "appointing" | "/r/is a" |  | "FN" |  |
| fn:appointing | /r/IsA | fn:intentionally_affect | "appointing" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:change_of_leadership | /r/SimilarTo | fn:appointing | "change of leadership" | "appointing" | "/r/similar to" |  | "FN" |  |
| fn:appointing | fn:HasLexicalUnit | fn:lu:appointing:accredit | "appointing" | "accredit" | "has lexical unit" |  | "FN" |  |
| fn:appointing | fn:HasLexicalUnit | fn:lu:appointing:appoint | "appointing" | "appoint" | "has lexical unit" |  | "FN" |  |
| fn:appointing | fn:HasLexicalUnit | fn:lu:appointing:accredited | "appointing" | "accredited" | "has lexical unit" |  | "FN" |  |
| fn:appointing | fn:HasLexicalUnit | fn:lu:appointing:designate | "appointing" | "designate" | "has lexical unit" |  | "FN" |  |
| fn:appointing | fn:HasLexicalUnit | fn:lu:appointing:finger | "appointing" | "finger" | "has lexical unit" |  | "FN" |  |
| fn:appointing | fn:HasLexicalUnit | fn:lu:appointing:tap | "appointing" | "tap" | "has lexical unit" |  | "FN" |  |
| fn:appointing | fn:HasLexicalUnit | fn:lu:appointing:name | "appointing" | "name" | "has lexical unit" |  | "FN" |  |
| fn:appointing | /r/HasA | fn:fe:selector | "appointing" | "selector" | "/r/has a" |  | "FN" |  |
| fn:appointing | /r/HasA | fn:fe:official | "appointing" | "official" | "/r/has a" |  | "FN" |  |
| fn:appointing | /r/HasA | fn:fe:role | "appointing" | "role" | "/r/has a" |  | "FN" |  |
| fn:appointing | /r/HasA | fn:fe:degree | "appointing" | "degree" | "/r/has a" |  | "FN" |  |
| fn:appointing | /r/HasA | fn:fe:depictive | "appointing" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:appointing | /r/HasA | fn:fe:manner | "appointing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:appointing | /r/HasA | fn:fe:means | "appointing" | "means" | "/r/has a" |  | "FN" |  |
| fn:appointing | /r/HasA | fn:fe:result | "appointing" | "result" | "/r/has a" |  | "FN" |  |
| fn:appointing | /r/HasA | fn:fe:circumstances | "appointing" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:appointing | /r/HasA | fn:fe:function | "appointing" | "function" | "/r/has a" |  | "FN" |  |
| fn:appointing | /r/HasA | fn:fe:time | "appointing" | "time" | "/r/has a" |  | "FN" |  |
| fn:appointing | /r/HasA | fn:fe:place | "appointing" | "place" | "/r/has a" |  | "FN" |  |
| fn:appointing | /r/HasA | fn:fe:body | "appointing" | "body" | "/r/has a" |  | "FN" |  |
| fn:connecting_architecture | /r/IsA | fn:architectural_part | "connecting architecture" | "architectural part" | "/r/is a" |  | "FN" |  |
| fn:architectural_part | /r/IsA | fn:shaped_part | "architectural part" | "shaped part" | "/r/is a" |  | "FN" |  |
| fn:architectural_part | fn:HasLexicalUnit | fn:lu:architectural_part:fireplace | "architectural part" | "fireplace" | "has lexical unit" |  | "FN" |  |
| fn:architectural_part | fn:HasLexicalUnit | fn:lu:architectural_part:floor | "architectural part" | "floor" | "has lexical unit" |  | "FN" |  |
| fn:architectural_part | fn:HasLexicalUnit | fn:lu:architectural_part:ceiling | "architectural part" | "ceiling" | "has lexical unit" |  | "FN" |  |
| fn:architectural_part | fn:HasLexicalUnit | fn:lu:architectural_part:mantel | "architectural part" | "mantel" | "has lexical unit" |  | "FN" |  |
| fn:architectural_part | fn:HasLexicalUnit | fn:lu:architectural_part:roof | "architectural part" | "roof" | "has lexical unit" |  | "FN" |  |
| fn:architectural_part | fn:HasLexicalUnit | fn:lu:architectural_part:rail | "architectural part" | "rail" | "has lexical unit" |  | "FN" |  |
| fn:architectural_part | fn:HasLexicalUnit | fn:lu:architectural_part:wall | "architectural part" | "wall" | "has lexical unit" |  | "FN" |  |
| fn:architectural_part | fn:HasLexicalUnit | fn:lu:architectural_part:counter | "architectural part" | "counter" | "has lexical unit" |  | "FN" |  |
| fn:architectural_part | fn:HasLexicalUnit | fn:lu:architectural_part:facade | "architectural part" | "facade" | "has lexical unit" |  | "FN" |  |
| fn:architectural_part | fn:HasLexicalUnit | fn:lu:architectural_part:foundation | "architectural part" | "foundation" | "has lexical unit" |  | "FN" |  |
| fn:architectural_part | fn:HasLexicalUnit | fn:lu:architectural_part:flight | "architectural part" | "flight" | "has lexical unit" |  | "FN" |  |
| fn:architectural_part | fn:HasLexicalUnit | fn:lu:architectural_part:landing | "architectural part" | "landing" | "has lexical unit" |  | "FN" |  |
| fn:architectural_part | fn:HasLexicalUnit | fn:lu:architectural_part:window | "architectural part" | "window" | "has lexical unit" |  | "FN" |  |
| fn:architectural_part | /r/HasA | fn:fe:part | "architectural part" | "part" | "/r/has a" |  | "FN" |  |
| fn:architectural_part | /r/HasA | fn:fe:whole | "architectural part" | "whole" | "/r/has a" |  | "FN" |  |
| fn:architectural_part | /r/HasA | fn:fe:descriptor | "architectural part" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:architectural_part | /r/HasA | fn:fe:orientation | "architectural part" | "orientation" | "/r/has a" |  | "FN" |  |
| fn:architectural_part | /r/HasA | fn:fe:material | "architectural part" | "material" | "/r/has a" |  | "FN" |  |
| fn:architectural_part | /r/HasA | fn:fe:creator | "architectural part" | "creator" | "/r/has a" |  | "FN" |  |
| fn:arithmetic_commutative | /r/IsA | fn:arithmetic | "arithmetic commutative" | "arithmetic" | "/r/is a" |  | "FN" |  |
| fn:arithmetic_non-commutative | /r/IsA | fn:arithmetic | "arithmetic non-commutative" | "arithmetic" | "/r/is a" |  | "FN" |  |
| fn:mathematical_relationship | /r/IsA | fn:arithmetic | "mathematical relationship" | "arithmetic" | "/r/is a" |  | "FN" |  |
| fn:arithmetic | /r/IsA | fn:reciprocality | "arithmetic" | "reciprocality" | "/r/is a" |  | "FN" |  |
| fn:arithmetic | /r/HasA | fn:fe:term1 | "arithmetic" | "term1" | "/r/has a" |  | "FN" |  |
| fn:arithmetic | /r/HasA | fn:fe:term2 | "arithmetic" | "term2" | "/r/has a" |  | "FN" |  |
| fn:arithmetic | /r/HasA | fn:fe:terms | "arithmetic" | "terms" | "/r/has a" |  | "FN" |  |
| fn:arithmetic_commutative | /r/IsA | fn:arithmetic | "arithmetic commutative" | "arithmetic" | "/r/is a" |  | "FN" |  |
| fn:commutative_process | /r/IsA | fn:arithmetic_commutative | "commutative process" | "arithmetic commutative" | "/r/is a" |  | "FN" |  |
| fn:commutative_statement | /r/IsA | fn:arithmetic_commutative | "commutative statement" | "arithmetic commutative" | "/r/is a" |  | "FN" |  |
| fn:arithmetic_commutative | /r/HasA | fn:fe:terms | "arithmetic commutative" | "terms" | "/r/has a" |  | "FN" |  |
| fn:arithmetic_commutative | /r/HasA | fn:fe:term1 | "arithmetic commutative" | "term1" | "/r/has a" |  | "FN" |  |
| fn:arithmetic_commutative | /r/HasA | fn:fe:term2 | "arithmetic commutative" | "term2" | "/r/has a" |  | "FN" |  |
| fn:arithmetic_non-commutative | /r/IsA | fn:arithmetic | "arithmetic non-commutative" | "arithmetic" | "/r/is a" |  | "FN" |  |
| fn:non-commutative_process | /r/IsA | fn:arithmetic_non-commutative | "non-commutative process" | "arithmetic non-commutative" | "/r/is a" |  | "FN" |  |
| fn:non-commutative_statement | /r/IsA | fn:arithmetic_non-commutative | "non-commutative statement" | "arithmetic non-commutative" | "/r/is a" |  | "FN" |  |
| fn:fe:term_1 | /r/HasPrerequisite | fn:fe:term_2 | "term 1" | "term 2" | "/r/has prerequisite" |  | "FN" |  |
| fn:arithmetic_non-commutative | /r/HasA | fn:fe:term_1 | "arithmetic non-commutative" | "term 1" | "/r/has a" |  | "FN" |  |
| fn:arithmetic_non-commutative | /r/HasA | fn:fe:term_2 | "arithmetic non-commutative" | "term 2" | "/r/has a" |  | "FN" |  |
| fn:protecting | /r/UsedFor | fn:armor | "protecting" | "armor" | "/r/used for" |  | "FN" |  |
| fn:clothing | /r/SimilarTo | fn:armor | "clothing" | "armor" | "/r/similar to" |  | "FN" |  |
| fn:armor | fn:HasLexicalUnit | fn:lu:armor:armor | "armor" | "armor" | "has lexical unit" |  | "FN" |  |
| fn:armor | fn:HasLexicalUnit | fn:lu:armor:mail | "armor" | "mail" | "has lexical unit" |  | "FN" |  |
| fn:armor | fn:HasLexicalUnit | fn:lu:armor:bulletproof_vest | "armor" | "bulletproof vest" | "has lexical unit" |  | "FN" |  |
| fn:armor | fn:HasLexicalUnit | fn:lu:armor:greaves | "armor" | "greaves" | "has lexical unit" |  | "FN" |  |
| fn:armor | fn:HasLexicalUnit | fn:lu:armor:flak_jacket | "armor" | "flak jacket" | "has lexical unit" |  | "FN" |  |
| fn:armor | fn:HasLexicalUnit | fn:lu:armor:plate | "armor" | "plate" | "has lexical unit" |  | "FN" |  |
| fn:armor | /r/HasA | fn:fe:armor | "armor" | "armor" | "/r/has a" |  | "FN" |  |
| fn:armor | /r/HasA | fn:fe:danger | "armor" | "danger" | "/r/has a" |  | "FN" |  |
| fn:armor | /r/HasA | fn:fe:asset | "armor" | "asset" | "/r/has a" |  | "FN" |  |
| fn:armor | /r/HasA | fn:fe:descriptor | "armor" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:armor | /r/HasA | fn:fe:degree | "armor" | "degree" | "/r/has a" |  | "FN" |  |
| fn:armor | /r/HasA | fn:fe:material | "armor" | "material" | "/r/has a" |  | "FN" |  |
| fn:armor | /r/HasA | fn:fe:subregion | "armor" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:armor | /r/HasA | fn:fe:type | "armor" | "type" | "/r/has a" |  | "FN" |  |
| fn:arraignment | /r/IsA | fn:process | "arraignment" | "process" | "/r/is a" |  | "FN" |  |
| fn:arraignment | /r/HasSubevent | fn:bail_decision | "arraignment" | "bail decision" | "/r/has subevent" |  | "FN" |  |
| fn:arraignment | /r/HasSubevent | fn:entering_of_plea | "arraignment" | "entering of plea" | "/r/has subevent" |  | "FN" |  |
| fn:arraignment | /r/HasSubevent | fn:notification_of_charges | "arraignment" | "notification of charges" | "/r/has subevent" |  | "FN" |  |
| fn:criminal_process | /r/HasSubevent | fn:arraignment | "criminal process" | "arraignment" | "/r/has subevent" |  | "FN" |  |
| fn:trial | /r/HasPrerequisite | fn:arraignment | "trial" | "arraignment" | "/r/has prerequisite" |  | "FN" |  |
| fn:arraignment | /r/HasPrerequisite | fn:arrest | "arraignment" | "arrest" | "/r/has prerequisite" |  | "FN" |  |
| fn:arraignment | fn:HasLexicalUnit | fn:lu:arraignment:arraign | "arraignment" | "arraign" | "has lexical unit" |  | "FN" |  |
| fn:arraignment | fn:HasLexicalUnit | fn:lu:arraignment:arraignment | "arraignment" | "arraignment" | "has lexical unit" |  | "FN" |  |
| fn:arraignment | /r/HasA | fn:fe:defendant | "arraignment" | "defendant" | "/r/has a" |  | "FN" |  |
| fn:arraignment | /r/HasA | fn:fe:place | "arraignment" | "place" | "/r/has a" |  | "FN" |  |
| fn:arraignment | /r/HasA | fn:fe:time | "arraignment" | "time" | "/r/has a" |  | "FN" |  |
| fn:fe:judge | /r/IsA | fn:st:sentient | "judge" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:arraignment | /r/HasA | fn:fe:judge | "arraignment" | "judge" | "/r/has a" |  | "FN" |  |
| fn:arraignment | /r/HasA | fn:fe:charges | "arraignment" | "charges" | "/r/has a" |  | "FN" |  |
| fn:arraignment | /r/HasA | fn:fe:duration | "arraignment" | "duration" | "/r/has a" |  | "FN" |  |
| fn:arraignment | /r/HasA | fn:fe:manner | "arraignment" | "manner" | "/r/has a" |  | "FN" |  |
| fn:arranging | /r/IsA | fn:intentionally_affect | "arranging" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:placing | /r/UsedFor | fn:arranging | "placing" | "arranging" | "/r/used for" |  | "FN" |  |
| fn:placing | /r/SimilarTo | fn:arranging | "placing" | "arranging" | "/r/similar to" |  | "FN" |  |
| fn:arranging | fn:HasLexicalUnit | fn:lu:arranging:arrange | "arranging" | "arrange" | "has lexical unit" |  | "FN" |  |
| fn:arranging | fn:HasLexicalUnit | fn:lu:arranging:arrangement | "arranging" | "arrangement" | "has lexical unit" |  | "FN" |  |
| fn:arranging | fn:HasLexicalUnit | fn:lu:arranging:array | "arranging" | "array" | "has lexical unit" |  | "FN" |  |
| fn:arranging | fn:HasLexicalUnit | fn:lu:arranging:deploy | "arranging" | "deploy" | "has lexical unit" |  | "FN" |  |
| fn:arranging | fn:HasLexicalUnit | fn:lu:arranging:deployment | "arranging" | "deployment" | "has lexical unit" |  | "FN" |  |
| fn:arranging | fn:HasLexicalUnit | fn:lu:arranging:format | "arranging" | "format" | "has lexical unit" |  | "FN" |  |
| fn:arranging | fn:HasLexicalUnit | fn:lu:arranging:set_up | "arranging" | "set up" | "has lexical unit" |  | "FN" |  |
| fn:arranging | fn:HasLexicalUnit | fn:lu:arranging:order | "arranging" | "order" | "has lexical unit" |  | "FN" |  |
| fn:arranging | fn:HasLexicalUnit | fn:lu:arranging:justify | "arranging" | "justify" | "has lexical unit" |  | "FN" |  |
| fn:arranging | /r/HasA | fn:fe:agent | "arranging" | "agent" | "/r/has a" |  | "FN" |  |
| fn:arranging | /r/HasA | fn:fe:theme | "arranging" | "theme" | "/r/has a" |  | "FN" |  |
| fn:arranging | /r/HasA | fn:fe:time | "arranging" | "time" | "/r/has a" |  | "FN" |  |
| fn:arranging | /r/HasA | fn:fe:configuration | "arranging" | "configuration" | "/r/has a" |  | "FN" |  |
| fn:arranging | /r/HasA | fn:fe:manner | "arranging" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fe:location | /r/IsA | fn:st:goal | "location" | "goal" | "/r/is a" |  | "FN" |  |
| fn:st:goal | /r/IsA | fn:st:ontological_type | "goal" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:arranging | /r/HasA | fn:fe:location | "arranging" | "location" | "/r/has a" |  | "FN" |  |
| fn:arranging | /r/HasA | fn:fe:circumstances | "arranging" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:arranging | /r/HasA | fn:fe:purpose | "arranging" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:arranging | /r/HasA | fn:fe:instrument | "arranging" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:arranging | /r/HasA | fn:fe:means | "arranging" | "means" | "/r/has a" |  | "FN" |  |
| fn:arranging | /r/HasA | fn:fe:degree | "arranging" | "degree" | "/r/has a" |  | "FN" |  |
| fn:arrest | /r/IsA | fn:intentionally_affect | "arrest" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:criminal_process | /r/HasSubevent | fn:arrest | "criminal process" | "arrest" | "/r/has subevent" |  | "FN" |  |
| fn:arrest | /r/UsedFor | fn:surrendering | "arrest" | "surrendering" | "/r/used for" |  | "FN" |  |
| fn:inhibit_movement | /r/UsedFor | fn:arrest | "inhibit movement" | "arrest" | "/r/used for" |  | "FN" |  |
| fn:arraignment | /r/HasPrerequisite | fn:arrest | "arraignment" | "arrest" | "/r/has prerequisite" |  | "FN" |  |
| fn:arrest | fn:HasLexicalUnit | fn:lu:arrest:arrest | "arrest" | "arrest" | "has lexical unit" |  | "FN" |  |
| fn:arrest | fn:HasLexicalUnit | fn:lu:arrest:apprehend | "arrest" | "apprehend" | "has lexical unit" |  | "FN" |  |
| fn:arrest | fn:HasLexicalUnit | fn:lu:arrest:bust | "arrest" | "bust" | "has lexical unit" |  | "FN" |  |
| fn:arrest | fn:HasLexicalUnit | fn:lu:arrest:nab | "arrest" | "nab" | "has lexical unit" |  | "FN" |  |
| fn:arrest | fn:HasLexicalUnit | fn:lu:arrest:collar | "arrest" | "collar" | "has lexical unit" |  | "FN" |  |
| fn:arrest | fn:HasLexicalUnit | fn:lu:arrest:cop | "arrest" | "cop" | "has lexical unit" |  | "FN" |  |
| fn:arrest | fn:HasLexicalUnit | fn:lu:arrest:arrest | "arrest" | "arrest" | "has lexical unit" |  | "FN" |  |
| fn:arrest | fn:HasLexicalUnit | fn:lu:arrest:bust | "arrest" | "bust" | "has lexical unit" |  | "FN" |  |
| fn:arrest | fn:HasLexicalUnit | fn:lu:arrest:apprehension | "arrest" | "apprehension" | "has lexical unit" |  | "FN" |  |
| fn:arrest | fn:HasLexicalUnit | fn:lu:arrest:book | "arrest" | "book" | "has lexical unit" |  | "FN" |  |
| fn:arrest | fn:HasLexicalUnit | fn:lu:arrest:summons | "arrest" | "summons" | "has lexical unit" |  | "FN" |  |
| fn:arrest | /r/HasA | fn:fe:charges | "arrest" | "charges" | "/r/has a" |  | "FN" |  |
| fn:arrest | /r/HasA | fn:fe:place | "arrest" | "place" | "/r/has a" |  | "FN" |  |
| fn:arrest | /r/HasA | fn:fe:time | "arrest" | "time" | "/r/has a" |  | "FN" |  |
| fn:fe:authorities | /r/IsA | fn:st:sentient | "authorities" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:arrest | /r/HasA | fn:fe:authorities | "arrest" | "authorities" | "/r/has a" |  | "FN" |  |
| fn:arrest | /r/HasA | fn:fe:suspect | "arrest" | "suspect" | "/r/has a" |  | "FN" |  |
| fn:arrest | /r/HasA | fn:fe:type | "arrest" | "type" | "/r/has a" |  | "FN" |  |
| fn:arrest | /r/HasA | fn:fe:offense | "arrest" | "offense" | "/r/has a" |  | "FN" |  |
| fn:arrest | /r/HasA | fn:fe:manner | "arrest" | "manner" | "/r/has a" |  | "FN" |  |
| fn:arrest | /r/HasA | fn:fe:means | "arrest" | "means" | "/r/has a" |  | "FN" |  |
| fn:arrest | /r/HasA | fn:fe:purpose | "arrest" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:arrest | /r/HasA | fn:fe:source_of_legal_authority | "arrest" | "source of legal authority" | "/r/has a" |  | "FN" |  |
| fn:arrest | /r/HasA | fn:fe:co-participant | "arrest" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:vehicle_landing | /r/IsA | fn:arriving | "vehicle landing" | "arriving" | "/r/is a" |  | "FN" |  |
| fn:visiting_scenario_arrival | /r/IsA | fn:arriving | "visiting scenario arrival" | "arriving" | "/r/is a" |  | "FN" |  |
| fn:arriving | /r/IsA | fn:eventive_affecting | "arriving" | "eventive affecting" | "/r/is a" |  | "FN" |  |
| fn:traversing | /r/HasSubevent | fn:arriving | "traversing" | "arriving" | "/r/has subevent" |  | "FN" |  |
| fn:arriving | /r/UsedFor | fn:having_or_lacking_access | "arriving" | "having or lacking access" | "/r/used for" |  | "FN" |  |
| fn:traversing | /r/SimilarTo | fn:arriving | "traversing" | "arriving" | "/r/similar to" |  | "FN" |  |
| fn:arriving | /r/HasPrerequisite | fn:departing | "arriving" | "departing" | "/r/has prerequisite" |  | "FN" |  |
| fn:arriving | fn:HasLexicalUnit | fn:lu:arriving:approach | "arriving" | "approach" | "has lexical unit" |  | "FN" |  |
| fn:arriving | fn:HasLexicalUnit | fn:lu:arriving:approach | "arriving" | "approach" | "has lexical unit" |  | "FN" |  |
| fn:arriving | fn:HasLexicalUnit | fn:lu:arriving:arrival | "arriving" | "arrival" | "has lexical unit" |  | "FN" |  |
| fn:arriving | fn:HasLexicalUnit | fn:lu:arriving:arrive | "arriving" | "arrive" | "has lexical unit" |  | "FN" |  |
| fn:arriving | fn:HasLexicalUnit | fn:lu:arriving:come | "arriving" | "come" | "has lexical unit" |  | "FN" |  |
| fn:arriving | fn:HasLexicalUnit | fn:lu:arriving:enter | "arriving" | "enter" | "has lexical unit" |  | "FN" |  |
| fn:arriving | fn:HasLexicalUnit | fn:lu:arriving:entrance | "arriving" | "entrance" | "has lexical unit" |  | "FN" |  |
| fn:arriving | fn:HasLexicalUnit | fn:lu:arriving:return | "arriving" | "return" | "has lexical unit" |  | "FN" |  |
| fn:arriving | fn:HasLexicalUnit | fn:lu:arriving:return | "arriving" | "return" | "has lexical unit" |  | "FN" |  |
| fn:arriving | fn:HasLexicalUnit | fn:lu:arriving:visit | "arriving" | "visit" | "has lexical unit" |  | "FN" |  |
| fn:arriving | fn:HasLexicalUnit | fn:lu:arriving:visit | "arriving" | "visit" | "has lexical unit" |  | "FN" |  |
| fn:arriving | fn:HasLexicalUnit | fn:lu:arriving:reach | "arriving" | "reach" | "has lexical unit" |  | "FN" |  |
| fn:arriving | fn:HasLexicalUnit | fn:lu:arriving:make | "arriving" | "make" | "has lexical unit" |  | "FN" |  |
| fn:arriving | fn:HasLexicalUnit | fn:lu:arriving:get | "arriving" | "get" | "has lexical unit" |  | "FN" |  |
| fn:arriving | fn:HasLexicalUnit | fn:lu:arriving:make_it | "arriving" | "make it" | "has lexical unit" |  | "FN" |  |
| fn:arriving | fn:HasLexicalUnit | fn:lu:arriving:descend_(on) | "arriving" | "descend (on)" | "has lexical unit" |  | "FN" |  |
| fn:arriving | fn:HasLexicalUnit | fn:lu:arriving:crest | "arriving" | "crest" | "has lexical unit" |  | "FN" |  |
| fn:arriving | fn:HasLexicalUnit | fn:lu:arriving:entry | "arriving" | "entry" | "has lexical unit" |  | "FN" |  |
| fn:arriving | fn:HasLexicalUnit | fn:lu:arriving:influx | "arriving" | "influx" | "has lexical unit" |  | "FN" |  |
| fn:arriving | fn:HasLexicalUnit | fn:lu:arriving:hit | "arriving" | "hit" | "has lexical unit" |  | "FN" |  |
| fn:arriving | fn:HasLexicalUnit | fn:lu:arriving:appear | "arriving" | "appear" | "has lexical unit" |  | "FN" |  |
| fn:arriving | fn:HasLexicalUnit | fn:lu:arriving:find | "arriving" | "find" | "has lexical unit" |  | "FN" |  |
| fn:arriving | /r/HasA | fn:fe:theme | "arriving" | "theme" | "/r/has a" |  | "FN" |  |
| fn:arriving | /r/HasA | fn:fe:source | "arriving" | "source" | "/r/has a" |  | "FN" |  |
| fn:arriving | /r/HasA | fn:fe:path | "arriving" | "path" | "/r/has a" |  | "FN" |  |
| fn:fe:goal | /r/IsA | fn:st:location | "goal" | "location" | "/r/is a" |  | "FN" |  |
| fn:arriving | /r/HasA | fn:fe:goal | "arriving" | "goal" | "/r/has a" |  | "FN" |  |
| fn:arriving | /r/HasA | fn:fe:manner | "arriving" | "manner" | "/r/has a" |  | "FN" |  |
| fn:arriving | /r/HasA | fn:fe:means | "arriving" | "means" | "/r/has a" |  | "FN" |  |
| fn:arriving | /r/HasA | fn:fe:mode_of_transportation | "arriving" | "mode of transportation" | "/r/has a" |  | "FN" |  |
| fn:arriving | /r/HasA | fn:fe:cotheme | "arriving" | "cotheme" | "/r/has a" |  | "FN" |  |
| fn:arriving | /r/HasA | fn:fe:time | "arriving" | "time" | "/r/has a" |  | "FN" |  |
| fn:arriving | /r/HasA | fn:fe:new_situation | "arriving" | "new situation" | "/r/has a" |  | "FN" |  |
| fn:arriving | /r/HasA | fn:fe:depictive | "arriving" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:arriving | /r/HasA | fn:fe:period_of_iterations | "arriving" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:arriving | /r/HasA | fn:fe:circumstances | "arriving" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:arriving | /r/HasA | fn:fe:purpose | "arriving" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:arriving | /r/HasA | fn:fe:degree | "arriving" | "degree" | "/r/has a" |  | "FN" |  |
| fn:arriving | /r/HasA | fn:fe:event_description | "arriving" | "event description" | "/r/has a" |  | "FN" |  |
| fn:arriving | /r/HasA | fn:fe:re-encoding | "arriving" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:arriving | /r/HasA | fn:fe:frequency | "arriving" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:arriving | /r/HasA | fn:fe:place | "arriving" | "place" | "/r/has a" |  | "FN" |  |
| fn:arson | /r/IsA | fn:offenses | "arson" | "offenses" | "/r/is a" |  | "FN" |  |
| fn:intentionally_affect | /r/UsedFor | fn:arson | "intentionally affect" | "arson" | "/r/used for" |  | "FN" |  |
| fn:setting_fire | /r/UsedFor | fn:arson | "setting fire" | "arson" | "/r/used for" |  | "FN" |  |
| fn:arson | fn:HasLexicalUnit | fn:lu:arson:arson | "arson" | "arson" | "has lexical unit" |  | "FN" |  |
| fn:arson | fn:HasLexicalUnit | fn:lu:arson:arsonist | "arson" | "arsonist" | "has lexical unit" |  | "FN" |  |
| fn:arson | /r/HasA | fn:fe:degree | "arson" | "degree" | "/r/has a" |  | "FN" |  |
| fn:arson | /r/HasA | fn:fe:depictive | "arson" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:fe:offense | /r/IsA | fn:st:state_of_affairs | "offense" | "state of affairs" | "/r/is a" |  | "FN" |  |
| fn:arson | /r/HasA | fn:fe:offense | "arson" | "offense" | "/r/has a" |  | "FN" |  |
| fn:arson | /r/HasA | fn:fe:manner | "arson" | "manner" | "/r/has a" |  | "FN" |  |
| fn:arson | /r/HasA | fn:fe:means | "arson" | "means" | "/r/has a" |  | "FN" |  |
| fn:arson | /r/HasA | fn:fe:purpose | "arson" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:arson | /r/HasA | fn:fe:duration | "arson" | "duration" | "/r/has a" |  | "FN" |  |
| fn:arson | /r/HasA | fn:fe:place | "arson" | "place" | "/r/has a" |  | "FN" |  |
| fn:arson | /r/HasA | fn:fe:time | "arson" | "time" | "/r/has a" |  | "FN" |  |
| fn:fe:perpetrator | /r/IsA | fn:st:sentient | "perpetrator" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:arson | /r/HasA | fn:fe:perpetrator | "arson" | "perpetrator" | "/r/has a" |  | "FN" |  |
| fn:arson | /r/HasA | fn:fe:victim | "arson" | "victim" | "/r/has a" |  | "FN" |  |
| fn:arson | /r/HasA | fn:fe:frequency | "arson" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:arson | /r/HasA | fn:fe:explanation | "arson" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:accoutrements | /r/IsA | fn:artifact | "accoutrements" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:ammunition | /r/IsA | fn:artifact | "ammunition" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:body_decoration | /r/IsA | fn:artifact | "body decoration" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:buildings | /r/IsA | fn:artifact | "buildings" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:clothing | /r/IsA | fn:artifact | "clothing" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:connectors | /r/IsA | fn:artifact | "connectors" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:controller_object | /r/IsA | fn:artifact | "controller object" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:fastener | /r/IsA | fn:artifact | "fastener" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:fire_break | /r/IsA | fn:artifact | "fire break" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:information_display | /r/IsA | fn:artifact | "information display" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:infrastructure | /r/IsA | fn:artifact | "infrastructure" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:key | /r/IsA | fn:artifact | "key" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:law | /r/IsA | fn:artifact | "law" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:medical_instruments | /r/IsA | fn:artifact | "medical instruments" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:money | /r/IsA | fn:artifact | "money" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:noise_makers | /r/IsA | fn:artifact | "noise makers" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:physical_artworks | /r/IsA | fn:artifact | "physical artworks" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:text | /r/IsA | fn:artifact | "text" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:vehicle | /r/IsA | fn:artifact | "vehicle" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:weapon | /r/IsA | fn:artifact | "weapon" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:artifact | /r/IsA | fn:entity | "artifact" | "entity" | "/r/is a" |  | "FN" |  |
| fn:artifact | /r/HasSubevent | fn:artifact_subpart | "artifact" | "artifact subpart" | "/r/has subevent" |  | "FN" |  |
| fn:artifact | /r/UsedFor | fn:being_operational | "artifact" | "being operational" | "/r/used for" |  | "FN" |  |
| fn:artifact | /r/UsedFor | fn:gizmo | "artifact" | "gizmo" | "/r/used for" |  | "FN" |  |
| fn:using | /r/UsedFor | fn:artifact | "using" | "artifact" | "/r/used for" |  | "FN" |  |
| fn:artifact | fn:HasLexicalUnit | fn:lu:artifact:wheel | "artifact" | "wheel" | "has lexical unit" |  | "FN" |  |
| fn:artifact | fn:HasLexicalUnit | fn:lu:artifact:technology | "artifact" | "technology" | "has lexical unit" |  | "FN" |  |
| fn:artifact | fn:HasLexicalUnit | fn:lu:artifact:biotechnology | "artifact" | "biotechnology" | "has lexical unit" |  | "FN" |  |
| fn:artifact | fn:HasLexicalUnit | fn:lu:artifact:artifact | "artifact" | "artifact" | "has lexical unit" |  | "FN" |  |
| fn:artifact | fn:HasLexicalUnit | fn:lu:artifact:control_panel | "artifact" | "control panel" | "has lexical unit" |  | "FN" |  |
| fn:artifact | fn:HasLexicalUnit | fn:lu:artifact:board | "artifact" | "board" | "has lexical unit" |  | "FN" |  |
| fn:artifact | fn:HasLexicalUnit | fn:lu:artifact:board_[game] | "artifact" | "board [game]" | "has lexical unit" |  | "FN" |  |
| fn:artifact | fn:HasLexicalUnit | fn:lu:artifact:spatula | "artifact" | "spatula" | "has lexical unit" |  | "FN" |  |
| fn:artifact | fn:HasLexicalUnit | fn:lu:artifact:whisk | "artifact" | "whisk" | "has lexical unit" |  | "FN" |  |
| fn:artifact | fn:HasLexicalUnit | fn:lu:artifact:tub | "artifact" | "tub" | "has lexical unit" |  | "FN" |  |
| fn:artifact | fn:HasLexicalUnit | fn:lu:artifact:timer | "artifact" | "timer" | "has lexical unit" |  | "FN" |  |
| fn:artifact | fn:HasLexicalUnit | fn:lu:artifact:oven | "artifact" | "oven" | "has lexical unit" |  | "FN" |  |
| fn:artifact | fn:HasLexicalUnit | fn:lu:artifact:phone | "artifact" | "phone" | "has lexical unit" |  | "FN" |  |
| fn:artifact | /r/HasA | fn:fe:artifact | "artifact" | "artifact" | "/r/has a" |  | "FN" |  |
| fn:artifact | /r/HasA | fn:fe:use | "artifact" | "use" | "/r/has a" |  | "FN" |  |
| fn:artifact | /r/HasA | fn:fe:creator | "artifact" | "creator" | "/r/has a" |  | "FN" |  |
| fn:artifact | /r/HasA | fn:fe:time_of_creation | "artifact" | "time of creation" | "/r/has a" |  | "FN" |  |
| fn:artifact | /r/HasA | fn:fe:name | "artifact" | "name" | "/r/has a" |  | "FN" |  |
| fn:artifact | /r/HasA | fn:fe:type | "artifact" | "type" | "/r/has a" |  | "FN" |  |
| fn:artifact | /r/HasA | fn:fe:material | "artifact" | "material" | "/r/has a" |  | "FN" |  |
| fn:artifact | /r/HasA | fn:fe:descriptor | "artifact" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:artifact | /r/HasSubevent | fn:artifact_subpart | "artifact" | "artifact subpart" | "/r/has subevent" |  | "FN" |  |
| fn:artifact_subpart | fn:HasLexicalUnit | fn:lu:artifact_subpart:part | "artifact subpart" | "part" | "has lexical unit" |  | "FN" |  |
| fn:artifact_subpart | /r/HasA | fn:fe:component | "artifact subpart" | "component" | "/r/has a" |  | "FN" |  |
| fn:artifact_subpart | /r/HasA | fn:fe:artifact | "artifact subpart" | "artifact" | "/r/has a" |  | "FN" |  |
| fn:artifact_subpart | /r/HasA | fn:fe:function | "artifact subpart" | "function" | "/r/has a" |  | "FN" |  |
| fn:artifact_subpart | /r/HasA | fn:fe:material | "artifact subpart" | "material" | "/r/has a" |  | "FN" |  |
| fn:artifact_subpart | /r/HasA | fn:fe:creator | "artifact subpart" | "creator" | "/r/has a" |  | "FN" |  |
| fn:artifact_subpart | /r/HasA | fn:fe:time_of_creation | "artifact subpart" | "time of creation" | "/r/has a" |  | "FN" |  |
| fn:artificiality | /r/IsA | fn:gradable_attributes | "artificiality" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:artificiality | /r/UsedFor | fn:forging | "artificiality" | "forging" | "/r/used for" |  | "FN" |  |
| fn:feigning | /r/SimilarTo | fn:artificiality | "feigning" | "artificiality" | "/r/similar to" |  | "FN" |  |
| fn:artificiality | fn:HasLexicalUnit | fn:lu:artificiality:artificial | "artificiality" | "artificial" | "has lexical unit" |  | "FN" |  |
| fn:artificiality | fn:HasLexicalUnit | fn:lu:artificiality:bogus | "artificiality" | "bogus" | "has lexical unit" |  | "FN" |  |
| fn:artificiality | fn:HasLexicalUnit | fn:lu:artificiality:fake | "artificiality" | "fake" | "has lexical unit" |  | "FN" |  |
| fn:artificiality | fn:HasLexicalUnit | fn:lu:artificiality:counterfeit | "artificiality" | "counterfeit" | "has lexical unit" |  | "FN" |  |
| fn:artificiality | fn:HasLexicalUnit | fn:lu:artificiality:false | "artificiality" | "false" | "has lexical unit" |  | "FN" |  |
| fn:artificiality | fn:HasLexicalUnit | fn:lu:artificiality:genuine | "artificiality" | "genuine" | "has lexical unit" |  | "FN" |  |
| fn:artificiality | fn:HasLexicalUnit | fn:lu:artificiality:ersatz | "artificiality" | "ersatz" | "has lexical unit" |  | "FN" |  |
| fn:artificiality | fn:HasLexicalUnit | fn:lu:artificiality:phoney | "artificiality" | "phoney" | "has lexical unit" |  | "FN" |  |
| fn:artificiality | fn:HasLexicalUnit | fn:lu:artificiality:pseudo | "artificiality" | "pseudo" | "has lexical unit" |  | "FN" |  |
| fn:artificiality | fn:HasLexicalUnit | fn:lu:artificiality:phoney | "artificiality" | "phoney" | "has lexical unit" |  | "FN" |  |
| fn:artificiality | fn:HasLexicalUnit | fn:lu:artificiality:real | "artificiality" | "real" | "has lexical unit" |  | "FN" |  |
| fn:artificiality | fn:HasLexicalUnit | fn:lu:artificiality:actual | "artificiality" | "actual" | "has lexical unit" |  | "FN" |  |
| fn:artificiality | fn:HasLexicalUnit | fn:lu:artificiality:true | "artificiality" | "true" | "has lexical unit" |  | "FN" |  |
| fn:artificiality | fn:HasLexicalUnit | fn:lu:artificiality:disingenuous | "artificiality" | "disingenuous" | "has lexical unit" |  | "FN" |  |
| fn:artificiality | /r/HasA | fn:fe:entity | "artificiality" | "entity" | "/r/has a" |  | "FN" |  |
| fn:artificiality | /r/HasA | fn:fe:reference_category | "artificiality" | "reference category" | "/r/has a" |  | "FN" |  |
| fn:artificiality | /r/HasA | fn:fe:degree | "artificiality" | "degree" | "/r/has a" |  | "FN" |  |
| fn:aesthetics | /r/UsedFor | fn:artistic_style | "aesthetics" | "artistic style" | "/r/used for" |  | "FN" |  |
| fn:artistic_style | fn:HasLexicalUnit | fn:lu:artistic_style:style | "artistic style" | "style" | "has lexical unit" |  | "FN" |  |
| fn:artistic_style | fn:HasLexicalUnit | fn:lu:artistic_style:sound | "artistic style" | "sound" | "has lexical unit" |  | "FN" |  |
| fn:artistic_style | fn:HasLexicalUnit | fn:lu:artistic_style:look | "artistic style" | "look" | "has lexical unit" |  | "FN" |  |
| fn:artistic_style | fn:HasLexicalUnit | fn:lu:artistic_style:order | "artistic style" | "order" | "has lexical unit" |  | "FN" |  |
| fn:artistic_style | /r/HasA | fn:fe:artist | "artistic style" | "artist" | "/r/has a" |  | "FN" |  |
| fn:artistic_style | /r/HasA | fn:fe:artwork | "artistic style" | "artwork" | "/r/has a" |  | "FN" |  |
| fn:artistic_style | /r/HasA | fn:fe:form | "artistic style" | "form" | "/r/has a" |  | "FN" |  |
| fn:artistic_style | /r/HasA | fn:fe:time | "artistic style" | "time" | "/r/has a" |  | "FN" |  |
| fn:artistic_style | /r/HasA | fn:fe:descriptor | "artistic style" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:assemble | /r/IsA | fn:come_together | "assemble" | "come together" | "/r/is a" |  | "FN" |  |
| fn:assemble | /r/IsA | fn:intentionally_act | "assemble" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:meet_with | /r/HasPrerequisite | fn:assemble | "meet with" | "assemble" | "/r/has prerequisite" |  | "FN" |  |
| fn:assemble | fn:HasLexicalUnit | fn:lu:assemble:meet | "assemble" | "meet" | "has lexical unit" |  | "FN" |  |
| fn:assemble | fn:HasLexicalUnit | fn:lu:assemble:assemble | "assemble" | "assemble" | "has lexical unit" |  | "FN" |  |
| fn:assemble | fn:HasLexicalUnit | fn:lu:assemble:convene | "assemble" | "convene" | "has lexical unit" |  | "FN" |  |
| fn:fe:individuals | /r/RelatedTo | fn:fe:party_2 | "individuals" | "party 2" | "/r/related to" |  | "FN" |  |
| fn:assemble | /r/HasA | fn:fe:individuals | "assemble" | "individuals" | "/r/has a" |  | "FN" |  |
| fn:fe:group | /r/RelatedTo | fn:fe:party_1 | "group" | "party 1" | "/r/related to" |  | "FN" |  |
| fn:assemble | /r/HasA | fn:fe:group | "assemble" | "group" | "/r/has a" |  | "FN" |  |
| fn:fe:party_1 | /r/HasPrerequisite | fn:fe:party_2 | "party 1" | "party 2" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:party_1 | /r/RelatedTo | fn:fe:individuals | "party 1" | "individuals" | "/r/related to" |  | "FN" |  |
| fn:assemble | /r/HasA | fn:fe:party_1 | "assemble" | "party 1" | "/r/has a" |  | "FN" |  |
| fn:fe:party_2 | /r/RelatedTo | fn:fe:group | "party 2" | "group" | "/r/related to" |  | "FN" |  |
| fn:assemble | /r/HasA | fn:fe:party_2 | "assemble" | "party 2" | "/r/has a" |  | "FN" |  |
| fn:assemble | /r/HasA | fn:fe:manner | "assemble" | "manner" | "/r/has a" |  | "FN" |  |
| fn:assemble | /r/HasA | fn:fe:place | "assemble" | "place" | "/r/has a" |  | "FN" |  |
| fn:assemble | /r/HasA | fn:fe:means | "assemble" | "means" | "/r/has a" |  | "FN" |  |
| fn:assemble | /r/HasA | fn:fe:time | "assemble" | "time" | "/r/has a" |  | "FN" |  |
| fn:assemble | /r/HasA | fn:fe:purpose | "assemble" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:assessing | /r/IsA | fn:cogitation | "assessing" | "cogitation" | "/r/is a" |  | "FN" |  |
| fn:assessing | fn:HasLexicalUnit | fn:lu:assessing:assess | "assessing" | "assess" | "has lexical unit" |  | "FN" |  |
| fn:assessing | fn:HasLexicalUnit | fn:lu:assessing:rate | "assessing" | "rate" | "has lexical unit" |  | "FN" |  |
| fn:assessing | fn:HasLexicalUnit | fn:lu:assessing:evaluate | "assessing" | "evaluate" | "has lexical unit" |  | "FN" |  |
| fn:assessing | fn:HasLexicalUnit | fn:lu:assessing:grade | "assessing" | "grade" | "has lexical unit" |  | "FN" |  |
| fn:assessing | fn:HasLexicalUnit | fn:lu:assessing:assessment | "assessing" | "assessment" | "has lexical unit" |  | "FN" |  |
| fn:assessing | fn:HasLexicalUnit | fn:lu:assessing:evaluation | "assessing" | "evaluation" | "has lexical unit" |  | "FN" |  |
| fn:assessing | fn:HasLexicalUnit | fn:lu:assessing:weigh | "assessing" | "weigh" | "has lexical unit" |  | "FN" |  |
| fn:assessing | fn:HasLexicalUnit | fn:lu:assessing:judge | "assessing" | "judge" | "has lexical unit" |  | "FN" |  |
| fn:assessing | fn:HasLexicalUnit | fn:lu:assessing:value | "assessing" | "value" | "has lexical unit" |  | "FN" |  |
| fn:assessing | fn:HasLexicalUnit | fn:lu:assessing:rank | "assessing" | "rank" | "has lexical unit" |  | "FN" |  |
| fn:assessing | fn:HasLexicalUnit | fn:lu:assessing:reappraise | "assessing" | "reappraise" | "has lexical unit" |  | "FN" |  |
| fn:assessing | fn:HasLexicalUnit | fn:lu:assessing:appraise | "assessing" | "appraise" | "has lexical unit" |  | "FN" |  |
| fn:assessing | fn:HasLexicalUnit | fn:lu:assessing:appraisal | "assessing" | "appraisal" | "has lexical unit" |  | "FN" |  |
| fn:assessing | fn:HasLexicalUnit | fn:lu:assessing:reappraisal | "assessing" | "reappraisal" | "has lexical unit" |  | "FN" |  |
| fn:fe:assessor | /r/IsA | fn:st:sentient | "assessor" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:assessing | /r/HasA | fn:fe:assessor | "assessing" | "assessor" | "/r/has a" |  | "FN" |  |
| fn:assessing | /r/HasA | fn:fe:phenomenon | "assessing" | "phenomenon" | "/r/has a" |  | "FN" |  |
| fn:assessing | /r/HasA | fn:fe:value | "assessing" | "value" | "/r/has a" |  | "FN" |  |
| fn:assessing | /r/HasA | fn:fe:feature | "assessing" | "feature" | "/r/has a" |  | "FN" |  |
| fn:assessing | /r/HasA | fn:fe:evidence | "assessing" | "evidence" | "/r/has a" |  | "FN" |  |
| fn:assessing | /r/HasA | fn:fe:manner | "assessing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:assessing | /r/HasA | fn:fe:method | "assessing" | "method" | "/r/has a" |  | "FN" |  |
| fn:assessing | /r/HasA | fn:fe:means | "assessing" | "means" | "/r/has a" |  | "FN" |  |
| fn:assessing | /r/HasA | fn:fe:time | "assessing" | "time" | "/r/has a" |  | "FN" |  |
| fn:assessing | /r/HasA | fn:fe:standard | "assessing" | "standard" | "/r/has a" |  | "FN" |  |
| fn:assessing | /r/HasA | fn:fe:purpose | "assessing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:assessing | /r/HasA | fn:fe:place | "assessing" | "place" | "/r/has a" |  | "FN" |  |
| fn:assessing | /r/HasA | fn:fe:medium | "assessing" | "medium" | "/r/has a" |  | "FN" |  |
| fn:assessing | /r/HasA | fn:fe:co-participant | "assessing" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:assessing | /r/HasA | fn:fe:frequency | "assessing" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:assessing | /r/HasA | fn:fe:beneficiary | "assessing" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:assessing | /r/HasA | fn:fe:depictive | "assessing" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:assessing | /r/HasA | fn:fe:degree | "assessing" | "degree" | "/r/has a" |  | "FN" |  |
| fn:assessing | /r/HasA | fn:fe:circumstances | "assessing" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:assessing | /r/HasA | fn:fe:result | "assessing" | "result" | "/r/has a" |  | "FN" |  |
| fn:assessing | /r/HasA | fn:fe:duration | "assessing" | "duration" | "/r/has a" |  | "FN" |  |
| fn:assessing | /r/HasA | fn:fe:explanation | "assessing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:assigned_location | /r/IsA | fn:locale | "assigned location" | "locale" | "/r/is a" |  | "FN" |  |
| fn:being_obligated | /r/UsedFor | fn:assigned_location | "being obligated" | "assigned location" | "/r/used for" |  | "FN" |  |
| fn:placing | /r/SimilarTo | fn:assigned_location | "placing" | "assigned location" | "/r/similar to" |  | "FN" |  |
| fn:assigned_location | fn:HasLexicalUnit | fn:lu:assigned_location:station | "assigned location" | "station" | "has lexical unit" |  | "FN" |  |
| fn:assigned_location | fn:HasLexicalUnit | fn:lu:assigned_location:post | "assigned location" | "post" | "has lexical unit" |  | "FN" |  |
| fn:assigned_location | fn:HasLexicalUnit | fn:lu:assigned_location:place | "assigned location" | "place" | "has lexical unit" |  | "FN" |  |
| fn:fe:station | /r/IsA | fn:st:location | "station" | "location" | "/r/is a" |  | "FN" |  |
| fn:assigned_location | /r/HasA | fn:fe:station | "assigned location" | "station" | "/r/has a" |  | "FN" |  |
| fn:assigned_location | /r/HasA | fn:fe:constituent_parts | "assigned location" | "constituent parts" | "/r/has a" |  | "FN" |  |
| fn:fe:relative_location | /r/IsA | fn:st:locative_relation | "relative location" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:assigned_location | /r/HasA | fn:fe:relative_location | "assigned location" | "relative location" | "/r/has a" |  | "FN" |  |
| fn:assigned_location | /r/HasA | fn:fe:formational_cause | "assigned location" | "formational cause" | "/r/has a" |  | "FN" |  |
| fn:assigned_location | /r/HasA | fn:fe:container_possessor | "assigned location" | "container possessor" | "/r/has a" |  | "FN" |  |
| fn:assigned_location | /r/HasA | fn:fe:descriptor | "assigned location" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:fe:related_event | /r/IsA | fn:st:event | "related event" | "event" | "/r/is a" |  | "FN" |  |
| fn:st:event | /r/IsA | fn:st:ontological_type | "event" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:st:activity | /r/IsA | fn:st:event | "activity" | "event" | "/r/is a" |  | "FN" |  |
| fn:st:achievement | /r/IsA | fn:st:event | "achievement" | "event" | "/r/is a" |  | "FN" |  |
| fn:st:accomplishment | /r/IsA | fn:st:event | "accomplishment" | "event" | "/r/is a" |  | "FN" |  |
| fn:st:intentional_act | /r/IsA | fn:st:event | "intentional act" | "event" | "/r/is a" |  | "FN" |  |
| fn:assigned_location | /r/HasA | fn:fe:related_event | "assigned location" | "related event" | "/r/has a" |  | "FN" |  |
| fn:assigned_location | /r/HasA | fn:fe:task | "assigned location" | "task" | "/r/has a" |  | "FN" |  |
| fn:assigned_location | /r/HasA | fn:fe:responsible_party | "assigned location" | "responsible party" | "/r/has a" |  | "FN" |  |
| fn:supporting | /r/IsA | fn:assistance | "supporting" | "assistance" | "/r/is a" |  | "FN" |  |
| fn:assistance | /r/IsA | fn:intentionally_act | "assistance" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:intentionally_act | /r/UsedFor | fn:assistance | "intentionally act" | "assistance" | "/r/used for" |  | "FN" |  |
| fn:assistance | fn:HasLexicalUnit | fn:lu:assistance:assist | "assistance" | "assist" | "has lexical unit" |  | "FN" |  |
| fn:assistance | fn:HasLexicalUnit | fn:lu:assistance:help | "assistance" | "help" | "has lexical unit" |  | "FN" |  |
| fn:assistance | fn:HasLexicalUnit | fn:lu:assistance:abet | "assistance" | "abet" | "has lexical unit" |  | "FN" |  |
| fn:assistance | fn:HasLexicalUnit | fn:lu:assistance:succor | "assistance" | "succor" | "has lexical unit" |  | "FN" |  |
| fn:assistance | fn:HasLexicalUnit | fn:lu:assistance:helpful | "assistance" | "helpful" | "has lexical unit" |  | "FN" |  |
| fn:assistance | fn:HasLexicalUnit | fn:lu:assistance:assistance | "assistance" | "assistance" | "has lexical unit" |  | "FN" |  |
| fn:assistance | fn:HasLexicalUnit | fn:lu:assistance:aid | "assistance" | "aid" | "has lexical unit" |  | "FN" |  |
| fn:assistance | fn:HasLexicalUnit | fn:lu:assistance:aid_[act] | "assistance" | "aid [act]" | "has lexical unit" |  | "FN" |  |
| fn:assistance | fn:HasLexicalUnit | fn:lu:assistance:help_out | "assistance" | "help out" | "has lexical unit" |  | "FN" |  |
| fn:assistance | fn:HasLexicalUnit | fn:lu:assistance:serve | "assistance" | "serve" | "has lexical unit" |  | "FN" |  |
| fn:assistance | fn:HasLexicalUnit | fn:lu:assistance:cater | "assistance" | "cater" | "has lexical unit" |  | "FN" |  |
| fn:assistance | fn:HasLexicalUnit | fn:lu:assistance:help | "assistance" | "help" | "has lexical unit" |  | "FN" |  |
| fn:assistance | fn:HasLexicalUnit | fn:lu:assistance:aid_[entity] | "assistance" | "aid [entity]" | "has lexical unit" |  | "FN" |  |
| fn:assistance | fn:HasLexicalUnit | fn:lu:assistance:aid_and_abet | "assistance" | "aid and abet" | "has lexical unit" |  | "FN" |  |
| fn:assistance | /r/HasA | fn:fe:benefited_party | "assistance" | "benefited party" | "/r/has a" |  | "FN" |  |
| fn:assistance | /r/HasA | fn:fe:helper | "assistance" | "helper" | "/r/has a" |  | "FN" |  |
| fn:assistance | /r/HasA | fn:fe:goal | "assistance" | "goal" | "/r/has a" |  | "FN" |  |
| fn:assistance | /r/HasA | fn:fe:focal_entity | "assistance" | "focal entity" | "/r/has a" |  | "FN" |  |
| fn:assistance | /r/HasA | fn:fe:time | "assistance" | "time" | "/r/has a" |  | "FN" |  |
| fn:assistance | /r/HasA | fn:fe:place | "assistance" | "place" | "/r/has a" |  | "FN" |  |
| fn:assistance | /r/HasA | fn:fe:manner | "assistance" | "manner" | "/r/has a" |  | "FN" |  |
| fn:assistance | /r/HasA | fn:fe:means | "assistance" | "means" | "/r/has a" |  | "FN" |  |
| fn:assistance | /r/HasA | fn:fe:instrument | "assistance" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:assistance | /r/HasA | fn:fe:domain | "assistance" | "domain" | "/r/has a" |  | "FN" |  |
| fn:assistance | /r/HasA | fn:fe:degree | "assistance" | "degree" | "/r/has a" |  | "FN" |  |
| fn:assistance | /r/HasA | fn:fe:duration | "assistance" | "duration" | "/r/has a" |  | "FN" |  |
| fn:assistance | /r/HasA | fn:fe:purpose | "assistance" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:assistance | /r/HasA | fn:fe:frequency | "assistance" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:assistance | /r/HasA | fn:fe:explanation | "assistance" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:asymmetric_reciprocality | /r/IsA | fn:reciprocality | "asymmetric reciprocality" | "reciprocality" | "/r/is a" |  | "FN" |  |
| fn:fe:protagonist_1 | /r/HasPrerequisite | fn:fe:protagonist_2 | "protagonist 1" | "protagonist 2" | "/r/has prerequisite" |  | "FN" |  |
| fn:asymmetric_reciprocality | /r/HasA | fn:fe:protagonist_1 | "asymmetric reciprocality" | "protagonist 1" | "/r/has a" |  | "FN" |  |
| fn:fe:protagonist_2 | /r/HasPrerequisite | fn:fe:protagonist_1 | "protagonist 2" | "protagonist 1" | "/r/has prerequisite" |  | "FN" |  |
| fn:asymmetric_reciprocality | /r/HasA | fn:fe:protagonist_2 | "asymmetric reciprocality" | "protagonist 2" | "/r/has a" |  | "FN" |  |
| fn:atonement | /r/IsA | fn:intentionally_act | "atonement" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:forgiveness | /r/UsedFor | fn:atonement | "forgiveness" | "atonement" | "/r/used for" |  | "FN" |  |
| fn:atonement | fn:HasLexicalUnit | fn:lu:atonement:atone | "atonement" | "atone" | "has lexical unit" |  | "FN" |  |
| fn:atonement | fn:HasLexicalUnit | fn:lu:atonement:atonement | "atonement" | "atonement" | "has lexical unit" |  | "FN" |  |
| fn:atonement | fn:HasLexicalUnit | fn:lu:atonement:expiate | "atonement" | "expiate" | "has lexical unit" |  | "FN" |  |
| fn:atonement | fn:HasLexicalUnit | fn:lu:atonement:expiation | "atonement" | "expiation" | "has lexical unit" |  | "FN" |  |
| fn:atonement | fn:HasLexicalUnit | fn:lu:atonement:expiatory | "atonement" | "expiatory" | "has lexical unit" |  | "FN" |  |
| fn:atonement | fn:HasLexicalUnit | fn:lu:atonement:expiator | "atonement" | "expiator" | "has lexical unit" |  | "FN" |  |
| fn:atonement | fn:HasLexicalUnit | fn:lu:atonement:atoner | "atonement" | "atoner" | "has lexical unit" |  | "FN" |  |
| fn:atonement | /r/HasA | fn:fe:agent | "atonement" | "agent" | "/r/has a" |  | "FN" |  |
| fn:atonement | /r/HasA | fn:fe:wrong | "atonement" | "wrong" | "/r/has a" |  | "FN" |  |
| fn:atonement | /r/HasA | fn:fe:amends | "atonement" | "amends" | "/r/has a" |  | "FN" |  |
| fn:atonement | /r/HasA | fn:fe:degree | "atonement" | "degree" | "/r/has a" |  | "FN" |  |
| fn:atonement | /r/HasA | fn:fe:purpose | "atonement" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:atonement | /r/HasA | fn:fe:manner | "atonement" | "manner" | "/r/has a" |  | "FN" |  |
| fn:atonement | /r/HasA | fn:fe:time | "atonement" | "time" | "/r/has a" |  | "FN" |  |
| fn:atonement | /r/HasA | fn:fe:place | "atonement" | "place" | "/r/has a" |  | "FN" |  |
| fn:attaching | /r/IsA | fn:intentionally_affect | "attaching" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:attaching | /r/UsedFor | fn:connectors | "attaching" | "connectors" | "/r/used for" |  | "FN" |  |
| fn:placing | /r/SimilarTo | fn:attaching | "placing" | "attaching" | "/r/similar to" |  | "FN" |  |
| fn:attaching | /r/Causes | fn:becoming_attached | "attaching" | "becoming attached" | "/r/causes" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:fasten | "attaching" | "fasten" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:attach | "attaching" | "attach" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:tie | "attaching" | "tie" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:tack | "attaching" | "tack" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:glue | "attaching" | "glue" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:staple | "attaching" | "staple" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:tape | "attaching" | "tape" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:pin | "attaching" | "pin" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:nail | "attaching" | "nail" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:affix | "attaching" | "affix" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:chain | "attaching" | "chain" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:paste | "attaching" | "paste" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:sew | "attaching" | "sew" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:stick | "attaching" | "stick" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:lash | "attaching" | "lash" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:bond | "attaching" | "bond" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:cinch | "attaching" | "cinch" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:secure | "attaching" | "secure" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:fuse | "attaching" | "fuse" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:shackle | "attaching" | "shackle" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:bind | "attaching" | "bind" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:detach | "attaching" | "detach" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:manacle | "attaching" | "manacle" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:handcuff | "attaching" | "handcuff" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:fetter | "attaching" | "fetter" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:rivet | "attaching" | "rivet" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:tether | "attaching" | "tether" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:cement | "attaching" | "cement" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:gum | "attaching" | "gum" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:fix | "attaching" | "fix" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:weld | "attaching" | "weld" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:solder | "attaching" | "solder" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:agglutinate | "attaching" | "agglutinate" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:moor | "attaching" | "moor" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:anchor | "attaching" | "anchor" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:attachment_[item] | "attaching" | "attachment [item]" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:hitch | "attaching" | "hitch" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:tying | "attaching" | "tying" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:untie | "attaching" | "untie" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:hook | "attaching" | "hook" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:plaster | "attaching" | "plaster" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:attachment_[act] | "attaching" | "attachment [act]" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:strap | "attaching" | "strap" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:adhere | "attaching" | "adhere" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:append | "attaching" | "append" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:concatenate | "attaching" | "concatenate" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:tack_on | "attaching" | "tack on" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:yoke | "attaching" | "yoke" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:truss | "attaching" | "truss" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:link | "attaching" | "link" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:connect | "attaching" | "connect" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:join | "attaching" | "join" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:mount | "attaching" | "mount" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:wire | "attaching" | "wire" | "has lexical unit" |  | "FN" |  |
| fn:attaching | fn:HasLexicalUnit | fn:lu:attaching:bracket | "attaching" | "bracket" | "has lexical unit" |  | "FN" |  |
| fn:attaching | /r/HasA | fn:fe:agent | "attaching" | "agent" | "/r/has a" |  | "FN" |  |
| fn:fe:item | /r/HasPrerequisite | fn:fe:goal | "item" | "goal" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:item | /r/RelatedTo | fn:fe:items | "item" | "items" | "/r/related to" |  | "FN" |  |
| fn:attaching | /r/HasA | fn:fe:item | "attaching" | "item" | "/r/has a" |  | "FN" |  |
| fn:attaching | /r/HasA | fn:fe:result | "attaching" | "result" | "/r/has a" |  | "FN" |  |
| fn:fe:goal | /r/IsA | fn:st:goal | "goal" | "goal" | "/r/is a" |  | "FN" |  |
| fn:fe:goal | /r/HasPrerequisite | fn:fe:item | "goal" | "item" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:goal | /r/RelatedTo | fn:fe:items | "goal" | "items" | "/r/related to" |  | "FN" |  |
| fn:attaching | /r/HasA | fn:fe:goal | "attaching" | "goal" | "/r/has a" |  | "FN" |  |
| fn:fe:connector | /r/IsA | fn:st:physical_entity | "connector" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:attaching | /r/HasA | fn:fe:connector | "attaching" | "connector" | "/r/has a" |  | "FN" |  |
| fn:attaching | /r/HasA | fn:fe:items | "attaching" | "items" | "/r/has a" |  | "FN" |  |
| fn:attaching | /r/HasA | fn:fe:handle | "attaching" | "handle" | "/r/has a" |  | "FN" |  |
| fn:attaching | /r/HasA | fn:fe:means | "attaching" | "means" | "/r/has a" |  | "FN" |  |
| fn:attaching | /r/HasA | fn:fe:manner | "attaching" | "manner" | "/r/has a" |  | "FN" |  |
| fn:attaching | /r/HasA | fn:fe:place | "attaching" | "place" | "/r/has a" |  | "FN" |  |
| fn:attaching | /r/HasA | fn:fe:purpose | "attaching" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:attaching | /r/HasA | fn:fe:time | "attaching" | "time" | "/r/has a" |  | "FN" |  |
| fn:attaching | /r/HasA | fn:fe:instrument | "attaching" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:attaching | /r/HasA | fn:fe:degree | "attaching" | "degree" | "/r/has a" |  | "FN" |  |
| fn:attaching | /r/HasA | fn:fe:frequency | "attaching" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:attaching | /r/HasA | fn:fe:period_of_iterations | "attaching" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:attaching | /r/HasA | fn:fe:duration | "attaching" | "duration" | "/r/has a" |  | "FN" |  |
| fn:besieging | /r/IsA | fn:attack | "besieging" | "attack" | "/r/is a" |  | "FN" |  |
| fn:counterattack | /r/IsA | fn:attack | "counterattack" | "attack" | "/r/is a" |  | "FN" |  |
| fn:invading | /r/IsA | fn:attack | "invading" | "attack" | "/r/is a" |  | "FN" |  |
| fn:suicide_attack | /r/IsA | fn:attack | "suicide attack" | "attack" | "/r/is a" |  | "FN" |  |
| fn:attack | /r/IsA | fn:intentionally_affect | "attack" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:attack | /r/UsedFor | fn:defending | "attack" | "defending" | "/r/used for" |  | "FN" |  |
| fn:attack | /r/SimilarTo | fn:invading | "attack" | "invading" | "/r/similar to" |  | "FN" |  |
| fn:attack | /r/IsA | fn:hostile_encounter | "attack" | "hostile encounter" | "/r/is a" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:attack | "attack" | "attack" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:assault | "attack" | "assault" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:assault | "attack" | "assault" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:attack | "attack" | "attack" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:fall_(upon) | "attack" | "fall (upon)" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:incursion | "attack" | "incursion" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:offensive | "attack" | "offensive" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:onset | "attack" | "onset" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:strike | "attack" | "strike" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:onslaught | "attack" | "onslaught" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:charge | "attack" | "charge" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:charge | "attack" | "charge" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:lay_(into) | "attack" | "lay (into)" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:set_(upon) | "attack" | "set (upon)" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:storm | "attack" | "storm" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:strike | "attack" | "strike" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:ambush | "attack" | "ambush" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:ambush | "attack" | "ambush" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:jump | "attack" | "jump" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:assail | "attack" | "assail" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:raid | "attack" | "raid" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:bomb | "attack" | "bomb" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:bombing | "attack" | "bombing" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:raid | "attack" | "raid" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:attacker | "attack" | "attacker" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:offensive | "attack" | "offensive" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:infiltrate | "attack" | "infiltrate" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:infiltration | "attack" | "infiltration" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:hit | "attack" | "hit" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:fire | "attack" | "fire" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:small_arms_fire | "attack" | "small arms fire" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:saf | "attack" | "saf" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:safire | "attack" | "safire" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:drive-by | "attack" | "drive-by" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:airstrike | "attack" | "airstrike" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:assailant | "attack" | "assailant" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:bombardment | "attack" | "bombardment" | "has lexical unit" |  | "FN" |  |
| fn:attack | fn:HasLexicalUnit | fn:lu:attack:bombard | "attack" | "bombard" | "has lexical unit" |  | "FN" |  |
| fn:attack | /r/HasA | fn:fe:victim | "attack" | "victim" | "/r/has a" |  | "FN" |  |
| fn:fe:weapon | /r/IsA | fn:st:physical_entity | "weapon" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:attack | /r/HasA | fn:fe:weapon | "attack" | "weapon" | "/r/has a" |  | "FN" |  |
| fn:fe:assailant | /r/IsA | fn:st:sentient | "assailant" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:attack | /r/HasA | fn:fe:assailant | "attack" | "assailant" | "/r/has a" |  | "FN" |  |
| fn:attack | /r/HasA | fn:fe:manner | "attack" | "manner" | "/r/has a" |  | "FN" |  |
| fn:attack | /r/HasA | fn:fe:means | "attack" | "means" | "/r/has a" |  | "FN" |  |
| fn:attack | /r/HasA | fn:fe:place | "attack" | "place" | "/r/has a" |  | "FN" |  |
| fn:attack | /r/HasA | fn:fe:purpose | "attack" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:attack | /r/HasA | fn:fe:explanation | "attack" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:attack | /r/HasA | fn:fe:time | "attack" | "time" | "/r/has a" |  | "FN" |  |
| fn:attack | /r/HasA | fn:fe:source | "attack" | "source" | "/r/has a" |  | "FN" |  |
| fn:attack | /r/HasA | fn:fe:depictive | "attack" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:attack | /r/HasA | fn:fe:re-encoding | "attack" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:attack | /r/HasA | fn:fe:result | "attack" | "result" | "/r/has a" |  | "FN" |  |
| fn:attack | /r/HasA | fn:fe:containing_event | "attack" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:attack | /r/HasA | fn:fe:particular_iteration | "attack" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:attack | /r/HasA | fn:fe:circumstances | "attack" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:attack | /r/HasA | fn:fe:iterations | "attack" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:attack | /r/HasA | fn:fe:event_description | "attack" | "event description" | "/r/has a" |  | "FN" |  |
| fn:attack | /r/HasA | fn:fe:path | "attack" | "path" | "/r/has a" |  | "FN" |  |
| fn:attack | /r/HasA | fn:fe:frequency | "attack" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:attack | /r/HasA | fn:fe:duration | "attack" | "duration" | "/r/has a" |  | "FN" |  |
| fn:attack | /r/HasA | fn:fe:direction | "attack" | "direction" | "/r/has a" |  | "FN" |  |
| fn:attempt_suasion | /r/IsA | fn:attempt | "attempt suasion" | "attempt" | "/r/is a" |  | "FN" |  |
| fn:work | /r/IsA | fn:attempt | "work" | "attempt" | "/r/is a" |  | "FN" |  |
| fn:attempt | /r/IsA | fn:intentionally_act | "attempt" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:attempt_means | /r/RelatedTo | fn:attempt | "attempt means" | "attempt" | "/r/related to" |  | "FN" |  |
| fn:attempt | /r/IsA | fn:attempt_action_scenario | "attempt" | "attempt action scenario" | "/r/is a" |  | "FN" |  |
| fn:attempt | fn:HasLexicalUnit | fn:lu:attempt:attempt | "attempt" | "attempt" | "has lexical unit" |  | "FN" |  |
| fn:attempt | fn:HasLexicalUnit | fn:lu:attempt:attempt | "attempt" | "attempt" | "has lexical unit" |  | "FN" |  |
| fn:attempt | fn:HasLexicalUnit | fn:lu:attempt:endeavor | "attempt" | "endeavor" | "has lexical unit" |  | "FN" |  |
| fn:attempt | fn:HasLexicalUnit | fn:lu:attempt:endeavor | "attempt" | "endeavor" | "has lexical unit" |  | "FN" |  |
| fn:attempt | fn:HasLexicalUnit | fn:lu:attempt:try | "attempt" | "try" | "has lexical unit" |  | "FN" |  |
| fn:attempt | fn:HasLexicalUnit | fn:lu:attempt:try | "attempt" | "try" | "has lexical unit" |  | "FN" |  |
| fn:attempt | fn:HasLexicalUnit | fn:lu:attempt:effort | "attempt" | "effort" | "has lexical unit" |  | "FN" |  |
| fn:attempt | fn:HasLexicalUnit | fn:lu:attempt:go | "attempt" | "go" | "has lexical unit" |  | "FN" |  |
| fn:attempt | fn:HasLexicalUnit | fn:lu:attempt:undertake | "attempt" | "undertake" | "has lexical unit" |  | "FN" |  |
| fn:attempt | fn:HasLexicalUnit | fn:lu:attempt:stab | "attempt" | "stab" | "has lexical unit" |  | "FN" |  |
| fn:attempt | fn:HasLexicalUnit | fn:lu:attempt:shot | "attempt" | "shot" | "has lexical unit" |  | "FN" |  |
| fn:attempt | fn:HasLexicalUnit | fn:lu:attempt:quest | "attempt" | "quest" | "has lexical unit" |  | "FN" |  |
| fn:attempt | fn:HasLexicalUnit | fn:lu:attempt:push | "attempt" | "push" | "has lexical unit" |  | "FN" |  |
| fn:attempt | /r/HasA | fn:fe:agent | "attempt" | "agent" | "/r/has a" |  | "FN" |  |
| fn:fe:goal | /r/IsA | fn:st:state_of_affairs | "goal" | "state of affairs" | "/r/is a" |  | "FN" |  |
| fn:attempt | /r/HasA | fn:fe:goal | "attempt" | "goal" | "/r/has a" |  | "FN" |  |
| fn:attempt | /r/HasA | fn:fe:outcome | "attempt" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:attempt | /r/HasA | fn:fe:means | "attempt" | "means" | "/r/has a" |  | "FN" |  |
| fn:attempt | /r/HasA | fn:fe:effort | "attempt" | "effort" | "/r/has a" |  | "FN" |  |
| fn:attempt | /r/HasA | fn:fe:time | "attempt" | "time" | "/r/has a" |  | "FN" |  |
| fn:attempt | /r/HasA | fn:fe:depictive | "attempt" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:attempt | /r/HasA | fn:fe:place | "attempt" | "place" | "/r/has a" |  | "FN" |  |
| fn:attempt | /r/HasA | fn:fe:manner | "attempt" | "manner" | "/r/has a" |  | "FN" |  |
| fn:attempt | /r/HasA | fn:fe:duration | "attempt" | "duration" | "/r/has a" |  | "FN" |  |
| fn:attempt | /r/HasA | fn:fe:purpose | "attempt" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:attempt | /r/HasA | fn:fe:particular_iteration | "attempt" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:attempt | /r/HasA | fn:fe:circumstances | "attempt" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:attempt | /r/HasA | fn:fe:domain | "attempt" | "domain" | "/r/has a" |  | "FN" |  |
| fn:attempt | /r/HasA | fn:fe:condition | "attempt" | "condition" | "/r/has a" |  | "FN" |  |
| fn:attempt | /r/HasA | fn:fe:frequency | "attempt" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:attempt | /r/HasA | fn:fe:explanation | "attempt" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:attempting_and_resolving_scenario | /r/HasSubevent | fn:attempt_action_scenario | "attempting and resolving scenario" | "attempt action scenario" | "/r/has subevent" |  | "FN" |  |
| fn:result_of_attempt_scenario | /r/HasPrerequisite | fn:attempt_action_scenario | "result of attempt scenario" | "attempt action scenario" | "/r/has prerequisite" |  | "FN" |  |
| fn:attempt | /r/IsA | fn:attempt_action_scenario | "attempt" | "attempt action scenario" | "/r/is a" |  | "FN" |  |
| fn:attempt_means | /r/IsA | fn:attempt_action_scenario | "attempt means" | "attempt action scenario" | "/r/is a" |  | "FN" |  |
| fn:attempt_action_scenario | /r/HasA | fn:fe:agent | "attempt action scenario" | "agent" | "/r/has a" |  | "FN" |  |
| fn:attempt_action_scenario | /r/HasA | fn:fe:goal | "attempt action scenario" | "goal" | "/r/has a" |  | "FN" |  |
| fn:attempt_action_scenario | /r/HasA | fn:fe:outcome | "attempt action scenario" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:attempt_action_scenario | /r/HasA | fn:fe:means | "attempt action scenario" | "means" | "/r/has a" |  | "FN" |  |
| fn:attempt_action_scenario | /r/HasA | fn:fe:time | "attempt action scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:attempt_action_scenario | /r/HasA | fn:fe:depictive | "attempt action scenario" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:attempt_action_scenario | /r/HasA | fn:fe:place | "attempt action scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:attempt_action_scenario | /r/HasA | fn:fe:manner | "attempt action scenario" | "manner" | "/r/has a" |  | "FN" |  |
| fn:attempt_action_scenario | /r/HasA | fn:fe:duration | "attempt action scenario" | "duration" | "/r/has a" |  | "FN" |  |
| fn:attempt_action_scenario | /r/HasA | fn:fe:purpose | "attempt action scenario" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:attempt_action_scenario | /r/HasA | fn:fe:particular_iteration | "attempt action scenario" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:attempt_action_scenario | /r/HasA | fn:fe:circumstances | "attempt action scenario" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:attempt_action_scenario | /r/HasA | fn:fe:condition | "attempt action scenario" | "condition" | "/r/has a" |  | "FN" |  |
| fn:attempt_action_scenario | /r/HasA | fn:fe:frequency | "attempt action scenario" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:shooting_scenario | /r/IsA | fn:attempt_distant_interaction_scenario | "shooting scenario" | "attempt distant interaction scenario" | "/r/is a" |  | "FN" |  |
| fn:attempt_distant_interaction_scenario | /r/IsA | fn:attempting_and_resolving_scenario | "attempt distant interaction scenario" | "attempting and resolving scenario" | "/r/is a" |  | "FN" |  |
| fn:attempt_distant_interaction_scenario | /r/HasSubevent | fn:aiming | "attempt distant interaction scenario" | "aiming" | "/r/has subevent" |  | "FN" |  |
| fn:attempt_distant_interaction_scenario | /r/HasSubevent | fn:hit_or_miss | "attempt distant interaction scenario" | "hit or miss" | "/r/has subevent" |  | "FN" |  |
| fn:manipulation | /r/UsedFor | fn:attempt_distant_interaction_scenario | "manipulation" | "attempt distant interaction scenario" | "/r/used for" |  | "FN" |  |
| fn:attempt_distant_interaction_scenario | /r/HasA | fn:fe:agent | "attempt distant interaction scenario" | "agent" | "/r/has a" |  | "FN" |  |
| fn:attempt_distant_interaction_scenario | /r/HasA | fn:fe:target | "attempt distant interaction scenario" | "target" | "/r/has a" |  | "FN" |  |
| fn:attempt_distant_interaction_scenario | /r/HasA | fn:fe:outcome | "attempt distant interaction scenario" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:attempt_distant_interaction_scenario | /r/HasA | fn:fe:means | "attempt distant interaction scenario" | "means" | "/r/has a" |  | "FN" |  |
| fn:attempt_distant_interaction_scenario | /r/HasA | fn:fe:degree | "attempt distant interaction scenario" | "degree" | "/r/has a" |  | "FN" |  |
| fn:attempt_distant_interaction_scenario | /r/HasA | fn:fe:time | "attempt distant interaction scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:attempt_distant_interaction_scenario | /r/HasA | fn:fe:depictive | "attempt distant interaction scenario" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:attempt_distant_interaction_scenario | /r/HasA | fn:fe:place | "attempt distant interaction scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:attempt_distant_interaction_scenario | /r/HasA | fn:fe:manner | "attempt distant interaction scenario" | "manner" | "/r/has a" |  | "FN" |  |
| fn:attempt_distant_interaction_scenario | /r/HasA | fn:fe:duration | "attempt distant interaction scenario" | "duration" | "/r/has a" |  | "FN" |  |
| fn:attempt_distant_interaction_scenario | /r/HasA | fn:fe:purpose | "attempt distant interaction scenario" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:attempt_distant_interaction_scenario | /r/HasA | fn:fe:particular_iteration | "attempt distant interaction scenario" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:attempt_distant_interaction_scenario | /r/HasA | fn:fe:circumstances | "attempt distant interaction scenario" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:attempt_distant_interaction_scenario | /r/HasA | fn:fe:instrument | "attempt distant interaction scenario" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:attempt_distant_interaction_scenario | /r/HasA | fn:fe:target_location | "attempt distant interaction scenario" | "target location" | "/r/has a" |  | "FN" |  |
| fn:attempt_means | /r/IsA | fn:using | "attempt means" | "using" | "/r/is a" |  | "FN" |  |
| fn:attempt_means | /r/RelatedTo | fn:attempt | "attempt means" | "attempt" | "/r/related to" |  | "FN" |  |
| fn:attempt_means | /r/IsA | fn:attempt_action_scenario | "attempt means" | "attempt action scenario" | "/r/is a" |  | "FN" |  |
| fn:attempt_means | fn:HasLexicalUnit | fn:lu:attempt_means:try | "attempt means" | "try" | "has lexical unit" |  | "FN" |  |
| fn:attempt_means | fn:HasLexicalUnit | fn:lu:attempt_means:give_try | "attempt means" | "give try" | "has lexical unit" |  | "FN" |  |
| fn:attempt_means | /r/HasA | fn:fe:agent | "attempt means" | "agent" | "/r/has a" |  | "FN" |  |
| fn:attempt_means | /r/HasA | fn:fe:goal | "attempt means" | "goal" | "/r/has a" |  | "FN" |  |
| fn:attempt_means | /r/HasA | fn:fe:outcome | "attempt means" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:attempt_means | /r/HasA | fn:fe:means | "attempt means" | "means" | "/r/has a" |  | "FN" |  |
| fn:attempt_means | /r/HasA | fn:fe:degree | "attempt means" | "degree" | "/r/has a" |  | "FN" |  |
| fn:attempt_means | /r/HasA | fn:fe:time | "attempt means" | "time" | "/r/has a" |  | "FN" |  |
| fn:attempt_means | /r/HasA | fn:fe:depictive | "attempt means" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:attempt_means | /r/HasA | fn:fe:place | "attempt means" | "place" | "/r/has a" |  | "FN" |  |
| fn:attempt_means | /r/HasA | fn:fe:manner | "attempt means" | "manner" | "/r/has a" |  | "FN" |  |
| fn:attempt_means | /r/HasA | fn:fe:duration | "attempt means" | "duration" | "/r/has a" |  | "FN" |  |
| fn:attempt_means | /r/HasA | fn:fe:purpose | "attempt means" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:attempt_means | /r/HasA | fn:fe:particular_iteration | "attempt means" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:attempt_means | /r/HasA | fn:fe:circumstances | "attempt means" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:attempt_means | /r/HasA | fn:fe:domain | "attempt means" | "domain" | "/r/has a" |  | "FN" |  |
| fn:attempt_means | /r/HasA | fn:fe:frequency | "attempt means" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:agriculture | /r/IsA | fn:attempt_obtain_food_scenario | "agriculture" | "attempt obtain food scenario" | "/r/is a" |  | "FN" |  |
| fn:hunting_scenario | /r/IsA | fn:attempt_obtain_food_scenario | "hunting scenario" | "attempt obtain food scenario" | "/r/is a" |  | "FN" |  |
| fn:attempt_obtain_food_scenario | /r/IsA | fn:attempting_and_resolving_scenario | "attempt obtain food scenario" | "attempting and resolving scenario" | "/r/is a" |  | "FN" |  |
| fn:attempt_obtain_food_scenario | fn:HasLexicalUnit | fn:lu:attempt_obtain_food_scenario:subsistence | "attempt obtain food scenario" | "subsistence" | "has lexical unit" |  | "FN" |  |
| fn:fe:seeker | /r/IsA | fn:st:sentient | "seeker" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:attempt_obtain_food_scenario | /r/HasA | fn:fe:seeker | "attempt obtain food scenario" | "seeker" | "/r/has a" |  | "FN" |  |
| fn:attempt_obtain_food_scenario | /r/HasA | fn:fe:food | "attempt obtain food scenario" | "food" | "/r/has a" |  | "FN" |  |
| fn:attempt_obtain_food_scenario | /r/HasA | fn:fe:instrument | "attempt obtain food scenario" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:attempt_obtain_food_scenario | /r/HasA | fn:fe:duration | "attempt obtain food scenario" | "duration" | "/r/has a" |  | "FN" |  |
| fn:attempt_obtain_food_scenario | /r/HasA | fn:fe:manner | "attempt obtain food scenario" | "manner" | "/r/has a" |  | "FN" |  |
| fn:attempt_obtain_food_scenario | /r/HasA | fn:fe:means | "attempt obtain food scenario" | "means" | "/r/has a" |  | "FN" |  |
| fn:attempt_obtain_food_scenario | /r/HasA | fn:fe:outcome | "attempt obtain food scenario" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:attempt_obtain_food_scenario | /r/HasA | fn:fe:place | "attempt obtain food scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:attempt_obtain_food_scenario | /r/HasA | fn:fe:time | "attempt obtain food scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:attempt_obtain_food_scenario | /r/HasA | fn:fe:purpose | "attempt obtain food scenario" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:attempt_obtain_food_scenario | /r/HasA | fn:fe:frequency | "attempt obtain food scenario" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:attempt_obtain_food_scenario | /r/HasA | fn:fe:degree | "attempt obtain food scenario" | "degree" | "/r/has a" |  | "FN" |  |
| fn:attempt_obtain_food_scenario | /r/HasA | fn:fe:ground | "attempt obtain food scenario" | "ground" | "/r/has a" |  | "FN" |  |
| fn:attempt_obtain_food_scenario | /r/HasA | fn:fe:particular_iteration | "attempt obtain food scenario" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:mining | /r/IsA | fn:attempt_obtain_mineral_scenario | "mining" | "attempt obtain mineral scenario" | "/r/is a" |  | "FN" |  |
| fn:attempt_obtain_mineral_scenario | /r/IsA | fn:attempting_and_resolving_scenario | "attempt obtain mineral scenario" | "attempting and resolving scenario" | "/r/is a" |  | "FN" |  |
| fn:attempt_obtain_mineral_scenario | /r/HasA | fn:fe:agent | "attempt obtain mineral scenario" | "agent" | "/r/has a" |  | "FN" |  |
| fn:attempt_obtain_mineral_scenario | /r/HasA | fn:fe:outcome | "attempt obtain mineral scenario" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:attempt_obtain_mineral_scenario | /r/HasA | fn:fe:means | "attempt obtain mineral scenario" | "means" | "/r/has a" |  | "FN" |  |
| fn:attempt_obtain_mineral_scenario | /r/HasA | fn:fe:time | "attempt obtain mineral scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:attempt_obtain_mineral_scenario | /r/HasA | fn:fe:place | "attempt obtain mineral scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:attempt_obtain_mineral_scenario | /r/HasA | fn:fe:duration | "attempt obtain mineral scenario" | "duration" | "/r/has a" |  | "FN" |  |
| fn:attempt_obtain_mineral_scenario | /r/HasA | fn:fe:mineral | "attempt obtain mineral scenario" | "mineral" | "/r/has a" |  | "FN" |  |
| fn:attempt_suasion | /r/IsA | fn:attempt | "attempt suasion" | "attempt" | "/r/is a" |  | "FN" |  |
| fn:attempt_suasion | /r/UsedFor | fn:suasion | "attempt suasion" | "suasion" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:attempt_suasion | "communication" | "attempt suasion" | "/r/used for" |  | "FN" |  |
| fn:subjective_influence | /r/UsedFor | fn:attempt_suasion | "subjective influence" | "attempt suasion" | "/r/used for" |  | "FN" |  |
| fn:attempt_suasion | /r/SimilarTo | fn:causation | "attempt suasion" | "causation" | "/r/similar to" |  | "FN" |  |
| fn:attempt_suasion | /r/SimilarTo | fn:manipulate_into_doing | "attempt suasion" | "manipulate into doing" | "/r/similar to" |  | "FN" |  |
| fn:attempt_suasion | /r/SimilarTo | fn:subjective_influence | "attempt suasion" | "subjective influence" | "/r/similar to" |  | "FN" |  |
| fn:request | /r/SimilarTo | fn:attempt_suasion | "request" | "attempt suasion" | "/r/similar to" |  | "FN" |  |
| fn:attempt_suasion | fn:HasLexicalUnit | fn:lu:attempt_suasion:urge | "attempt suasion" | "urge" | "has lexical unit" |  | "FN" |  |
| fn:attempt_suasion | fn:HasLexicalUnit | fn:lu:attempt_suasion:admonish | "attempt suasion" | "admonish" | "has lexical unit" |  | "FN" |  |
| fn:attempt_suasion | fn:HasLexicalUnit | fn:lu:attempt_suasion:advise | "attempt suasion" | "advise" | "has lexical unit" |  | "FN" |  |
| fn:attempt_suasion | fn:HasLexicalUnit | fn:lu:attempt_suasion:beg | "attempt suasion" | "beg" | "has lexical unit" |  | "FN" |  |
| fn:attempt_suasion | fn:HasLexicalUnit | fn:lu:attempt_suasion:cajole | "attempt suasion" | "cajole" | "has lexical unit" |  | "FN" |  |
| fn:attempt_suasion | fn:HasLexicalUnit | fn:lu:attempt_suasion:exhort | "attempt suasion" | "exhort" | "has lexical unit" |  | "FN" |  |
| fn:attempt_suasion | fn:HasLexicalUnit | fn:lu:attempt_suasion:pressure | "attempt suasion" | "pressure" | "has lexical unit" |  | "FN" |  |
| fn:attempt_suasion | fn:HasLexicalUnit | fn:lu:attempt_suasion:prevail | "attempt suasion" | "prevail" | "has lexical unit" |  | "FN" |  |
| fn:attempt_suasion | fn:HasLexicalUnit | fn:lu:attempt_suasion:press | "attempt suasion" | "press" | "has lexical unit" |  | "FN" |  |
| fn:attempt_suasion | fn:HasLexicalUnit | fn:lu:attempt_suasion:pressure | "attempt suasion" | "pressure" | "has lexical unit" |  | "FN" |  |
| fn:attempt_suasion | fn:HasLexicalUnit | fn:lu:attempt_suasion:lobby | "attempt suasion" | "lobby" | "has lexical unit" |  | "FN" |  |
| fn:attempt_suasion | fn:HasLexicalUnit | fn:lu:attempt_suasion:advocate | "attempt suasion" | "advocate" | "has lexical unit" |  | "FN" |  |
| fn:attempt_suasion | fn:HasLexicalUnit | fn:lu:attempt_suasion:suggest | "attempt suasion" | "suggest" | "has lexical unit" |  | "FN" |  |
| fn:attempt_suasion | fn:HasLexicalUnit | fn:lu:attempt_suasion:recommend | "attempt suasion" | "recommend" | "has lexical unit" |  | "FN" |  |
| fn:attempt_suasion | fn:HasLexicalUnit | fn:lu:attempt_suasion:suggestion | "attempt suasion" | "suggestion" | "has lexical unit" |  | "FN" |  |
| fn:attempt_suasion | fn:HasLexicalUnit | fn:lu:attempt_suasion:enjoin | "attempt suasion" | "enjoin" | "has lexical unit" |  | "FN" |  |
| fn:fe:content | /r/IsA | fn:st:content | "content" | "content" | "/r/is a" |  | "FN" |  |
| fn:st:content | /r/IsA | fn:st:ontological_type | "content" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:attempt_suasion | /r/HasA | fn:fe:content | "attempt suasion" | "content" | "/r/has a" |  | "FN" |  |
| fn:attempt_suasion | /r/HasA | fn:fe:addressee | "attempt suasion" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:attempt_suasion | /r/HasA | fn:fe:speaker | "attempt suasion" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:attempt_suasion | /r/HasA | fn:fe:topic | "attempt suasion" | "topic" | "/r/has a" |  | "FN" |  |
| fn:attempt_suasion | /r/HasA | fn:fe:medium | "attempt suasion" | "medium" | "/r/has a" |  | "FN" |  |
| fn:attempt_suasion | /r/HasA | fn:fe:manner | "attempt suasion" | "manner" | "/r/has a" |  | "FN" |  |
| fn:attempt_suasion | /r/HasA | fn:fe:depictive | "attempt suasion" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:attempt_suasion | /r/HasA | fn:fe:means | "attempt suasion" | "means" | "/r/has a" |  | "FN" |  |
| fn:attempt_suasion | /r/HasA | fn:fe:degree | "attempt suasion" | "degree" | "/r/has a" |  | "FN" |  |
| fn:attempt_suasion | /r/HasA | fn:fe:time | "attempt suasion" | "time" | "/r/has a" |  | "FN" |  |
| fn:attempt_suasion | /r/HasA | fn:fe:explanation | "attempt suasion" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:attempt_suasion | /r/HasA | fn:fe:period_of_iterations | "attempt suasion" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:attempt_suasion | /r/HasA | fn:fe:circumstances | "attempt suasion" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:attempt_suasion | /r/HasA | fn:fe:group | "attempt suasion" | "group" | "/r/has a" |  | "FN" |  |
| fn:attempt_suasion | /r/HasA | fn:fe:frequency | "attempt suasion" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:attempt_suasion | /r/HasA | fn:fe:re-encoding | "attempt suasion" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:attempt_suasion | /r/HasA | fn:fe:place | "attempt suasion" | "place" | "/r/has a" |  | "FN" |  |
| fn:attempt_suasion | /r/HasA | fn:fe:purpose | "attempt suasion" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:attempt_suasion | /r/HasA | fn:fe:salient_entity | "attempt suasion" | "salient entity" | "/r/has a" |  | "FN" |  |
| fn:attempt_suasion | /r/HasA | fn:fe:role | "attempt suasion" | "role" | "/r/has a" |  | "FN" |  |
| fn:attempt_distant_interaction_scenario | /r/IsA | fn:attempting_and_resolving_scenario | "attempt distant interaction scenario" | "attempting and resolving scenario" | "/r/is a" |  | "FN" |  |
| fn:attempt_obtain_food_scenario | /r/IsA | fn:attempting_and_resolving_scenario | "attempt obtain food scenario" | "attempting and resolving scenario" | "/r/is a" |  | "FN" |  |
| fn:attempt_obtain_mineral_scenario | /r/IsA | fn:attempting_and_resolving_scenario | "attempt obtain mineral scenario" | "attempting and resolving scenario" | "/r/is a" |  | "FN" |  |
| fn:attempting_and_resolving_scenario | /r/IsA | fn:intentionally_act | "attempting and resolving scenario" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:attempting_and_resolving_scenario | /r/HasSubevent | fn:attempt_action_scenario | "attempting and resolving scenario" | "attempt action scenario" | "/r/has subevent" |  | "FN" |  |
| fn:attempting_and_resolving_scenario | /r/HasSubevent | fn:result_of_attempt_scenario | "attempting and resolving scenario" | "result of attempt scenario" | "/r/has subevent" |  | "FN" |  |
| fn:attempting_and_resolving_scenario | /r/HasA | fn:fe:agent | "attempting and resolving scenario" | "agent" | "/r/has a" |  | "FN" |  |
| fn:attempting_and_resolving_scenario | /r/HasA | fn:fe:goal | "attempting and resolving scenario" | "goal" | "/r/has a" |  | "FN" |  |
| fn:attempting_and_resolving_scenario | /r/HasA | fn:fe:outcome | "attempting and resolving scenario" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:attempting_and_resolving_scenario | /r/HasA | fn:fe:means | "attempting and resolving scenario" | "means" | "/r/has a" |  | "FN" |  |
| fn:attempting_and_resolving_scenario | /r/HasA | fn:fe:time | "attempting and resolving scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:attempting_and_resolving_scenario | /r/HasA | fn:fe:place | "attempting and resolving scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:attempting_and_resolving_scenario | /r/HasA | fn:fe:duration | "attempting and resolving scenario" | "duration" | "/r/has a" |  | "FN" |  |
| fn:attempting_and_resolving_scenario | /r/HasA | fn:fe:manner | "attempting and resolving scenario" | "manner" | "/r/has a" |  | "FN" |  |
| fn:attempting_and_resolving_scenario | /r/HasA | fn:fe:purpose | "attempting and resolving scenario" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:attending | /r/IsA | fn:intentionally_act | "attending" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:attending | fn:HasLexicalUnit | fn:lu:attending:attend | "attending" | "attend" | "has lexical unit" |  | "FN" |  |
| fn:attending | fn:HasLexicalUnit | fn:lu:attending:go_(to) | "attending" | "go (to)" | "has lexical unit" |  | "FN" |  |
| fn:attending | fn:HasLexicalUnit | fn:lu:attending:attendance | "attending" | "attendance" | "has lexical unit" |  | "FN" |  |
| fn:attending | /r/HasA | fn:fe:agent | "attending" | "agent" | "/r/has a" |  | "FN" |  |
| fn:attending | /r/HasA | fn:fe:event | "attending" | "event" | "/r/has a" |  | "FN" |  |
| fn:attending | /r/HasA | fn:fe:manner | "attending" | "manner" | "/r/has a" |  | "FN" |  |
| fn:attending | /r/HasA | fn:fe:means | "attending" | "means" | "/r/has a" |  | "FN" |  |
| fn:attending | /r/HasA | fn:fe:place | "attending" | "place" | "/r/has a" |  | "FN" |  |
| fn:attending | /r/HasA | fn:fe:time | "attending" | "time" | "/r/has a" |  | "FN" |  |
| fn:attending | /r/HasA | fn:fe:circumstances | "attending" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:attending | /r/HasA | fn:fe:purpose | "attending" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:attending | /r/HasA | fn:fe:frequency | "attending" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:attending | /r/HasA | fn:fe:duration | "attending" | "duration" | "/r/has a" |  | "FN" |  |
| fn:attending | /r/HasA | fn:fe:iterations | "attending" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:attending | /r/HasA | fn:fe:event_description | "attending" | "event description" | "/r/has a" |  | "FN" |  |
| fn:attention | /r/IsA | fn:state | "attention" | "state" | "/r/is a" |  | "FN" |  |
| fn:attention | /r/UsedFor | fn:emotions_of_mental_activity | "attention" | "emotions of mental activity" | "/r/used for" |  | "FN" |  |
| fn:attention | /r/UsedFor | fn:perception_active | "attention" | "perception active" | "/r/used for" |  | "FN" |  |
| fn:attention | /r/UsedFor | fn:searching_scenario | "attention" | "searching scenario" | "/r/used for" |  | "FN" |  |
| fn:awareness | /r/SimilarTo | fn:attention | "awareness" | "attention" | "/r/similar to" |  | "FN" |  |
| fn:attention | fn:HasLexicalUnit | fn:lu:attention:alert | "attention" | "alert" | "has lexical unit" |  | "FN" |  |
| fn:attention | fn:HasLexicalUnit | fn:lu:attention:attend | "attention" | "attend" | "has lexical unit" |  | "FN" |  |
| fn:attention | fn:HasLexicalUnit | fn:lu:attention:attention | "attention" | "attention" | "has lexical unit" |  | "FN" |  |
| fn:attention | fn:HasLexicalUnit | fn:lu:attention:attentive | "attention" | "attentive" | "has lexical unit" |  | "FN" |  |
| fn:attention | fn:HasLexicalUnit | fn:lu:attention:closely | "attention" | "closely" | "has lexical unit" |  | "FN" |  |
| fn:attention | fn:HasLexicalUnit | fn:lu:attention:close | "attention" | "close" | "has lexical unit" |  | "FN" |  |
| fn:attention | fn:HasLexicalUnit | fn:lu:attention:keep_an_eye | "attention" | "keep an eye" | "has lexical unit" |  | "FN" |  |
| fn:attention | fn:HasLexicalUnit | fn:lu:attention:ignore | "attention" | "ignore" | "has lexical unit" |  | "FN" |  |
| fn:fe:perceiver | /r/IsA | fn:st:sentient | "perceiver" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:attention | /r/HasA | fn:fe:perceiver | "attention" | "perceiver" | "/r/has a" |  | "FN" |  |
| fn:attention | /r/HasA | fn:fe:ground | "attention" | "ground" | "/r/has a" |  | "FN" |  |
| fn:attention | /r/HasA | fn:fe:figure | "attention" | "figure" | "/r/has a" |  | "FN" |  |
| fn:attention | /r/HasA | fn:fe:degree | "attention" | "degree" | "/r/has a" |  | "FN" |  |
| fn:attention | /r/HasA | fn:fe:circumstances | "attention" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:attention | /r/HasA | fn:fe:manner | "attention" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fe:expressor | /r/RelatedTo | fn:fe:perceiver | "expressor" | "perceiver" | "/r/related to" |  | "FN" |  |
| fn:attention | /r/HasA | fn:fe:expressor | "attention" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:referring_by_name | /r/UsedFor | fn:attention_getting | "referring by name" | "attention getting" | "/r/used for" |  | "FN" |  |
| fn:attention_getting | fn:HasLexicalUnit | fn:lu:attention_getting:pal | "attention getting" | "pal" | "has lexical unit" |  | "FN" |  |
| fn:attention_getting | fn:HasLexicalUnit | fn:lu:attention_getting:sir | "attention getting" | "sir" | "has lexical unit" |  | "FN" |  |
| fn:attention_getting | fn:HasLexicalUnit | fn:lu:attention_getting:ma'am | "attention getting" | "ma\\'am" | "has lexical unit" |  | "FN" |  |
| fn:attention_getting | fn:HasLexicalUnit | fn:lu:attention_getting:buddy | "attention getting" | "buddy" | "has lexical unit" |  | "FN" |  |
| fn:attention_getting | fn:HasLexicalUnit | fn:lu:attention_getting:kid | "attention getting" | "kid" | "has lexical unit" |  | "FN" |  |
| fn:attention_getting | fn:HasLexicalUnit | fn:lu:attention_getting:dude | "attention getting" | "dude" | "has lexical unit" |  | "FN" |  |
| fn:attention_getting | fn:HasLexicalUnit | fn:lu:attention_getting:boy | "attention getting" | "boy" | "has lexical unit" |  | "FN" |  |
| fn:attention_getting | fn:HasLexicalUnit | fn:lu:attention_getting:guy | "attention getting" | "guy" | "has lexical unit" |  | "FN" |  |
| fn:attention_getting | fn:HasLexicalUnit | fn:lu:attention_getting:miss | "attention getting" | "miss" | "has lexical unit" |  | "FN" |  |
| fn:attention_getting | fn:HasLexicalUnit | fn:lu:attention_getting:bro | "attention getting" | "bro" | "has lexical unit" |  | "FN" |  |
| fn:attention_getting | fn:HasLexicalUnit | fn:lu:attention_getting:homes | "attention getting" | "homes" | "has lexical unit" |  | "FN" |  |
| fn:attention_getting | fn:HasLexicalUnit | fn:lu:attention_getting:yoohoo | "attention getting" | "yoohoo" | "has lexical unit" |  | "FN" |  |
| fn:attention_getting | fn:HasLexicalUnit | fn:lu:attention_getting:hello_there | "attention getting" | "hello there" | "has lexical unit" |  | "FN" |  |
| fn:attention_getting | fn:HasLexicalUnit | fn:lu:attention_getting:excuse_me | "attention getting" | "excuse me" | "has lexical unit" |  | "FN" |  |
| fn:attention_getting | fn:HasLexicalUnit | fn:lu:attention_getting:hey | "attention getting" | "hey" | "has lexical unit" |  | "FN" |  |
| fn:attention_getting | fn:HasLexicalUnit | fn:lu:attention_getting:officer | "attention getting" | "officer" | "has lexical unit" |  | "FN" |  |
| fn:attention_getting | /r/HasA | fn:fe:address_term | "attention getting" | "address term" | "/r/has a" |  | "FN" |  |
| fn:attention_getting | /r/HasA | fn:fe:interjection | "attention getting" | "interjection" | "/r/has a" |  | "FN" |  |
| fn:attitude_description | /r/IsA | fn:social_behavior_evaluation | "attitude description" | "social behavior evaluation" | "/r/is a" |  | "FN" |  |
| fn:emotions | /r/UsedFor | fn:attitude_description | "emotions" | "attitude description" | "/r/used for" |  | "FN" |  |
| fn:attitude_description | fn:HasLexicalUnit | fn:lu:attitude_description:optimistic | "attitude description" | "optimistic" | "has lexical unit" |  | "FN" |  |
| fn:attitude_description | fn:HasLexicalUnit | fn:lu:attitude_description:pessimistic | "attitude description" | "pessimistic" | "has lexical unit" |  | "FN" |  |
| fn:attitude_description | fn:HasLexicalUnit | fn:lu:attitude_description:hopeful | "attitude description" | "hopeful" | "has lexical unit" |  | "FN" |  |
| fn:attitude_description | fn:HasLexicalUnit | fn:lu:attitude_description:positive | "attitude description" | "positive" | "has lexical unit" |  | "FN" |  |
| fn:attitude_description | fn:HasLexicalUnit | fn:lu:attitude_description:negative | "attitude description" | "negative" | "has lexical unit" |  | "FN" |  |
| fn:attitude_description | fn:HasLexicalUnit | fn:lu:attitude_description:hopeless | "attitude description" | "hopeless" | "has lexical unit" |  | "FN" |  |
| fn:attitude_description | fn:HasLexicalUnit | fn:lu:attitude_description:dark | "attitude description" | "dark" | "has lexical unit" |  | "FN" |  |
| fn:attitude_description | /r/HasA | fn:fe:cognizer | "attitude description" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:attitude_description | /r/HasA | fn:fe:attitude | "attitude description" | "attitude" | "/r/has a" |  | "FN" |  |
| fn:attitude_description | /r/HasA | fn:fe:state_of_affairs | "attitude description" | "state of affairs" | "/r/has a" |  | "FN" |  |
| fn:attitude_description | /r/HasA | fn:fe:degree | "attitude description" | "degree" | "/r/has a" |  | "FN" |  |
| fn:attitude_description | /r/HasA | fn:fe:time | "attitude description" | "time" | "/r/has a" |  | "FN" |  |
| fn:statement | /r/UsedFor | fn:attributed_information | "statement" | "attributed information" | "/r/used for" |  | "FN" |  |
| fn:attributed_information | fn:HasLexicalUnit | fn:lu:attributed_information:according_to | "attributed information" | "according to" | "has lexical unit" |  | "FN" |  |
| fn:attributed_information | fn:HasLexicalUnit | fn:lu:attributed_information:source | "attributed information" | "source" | "has lexical unit" |  | "FN" |  |
| fn:attributed_information | fn:HasLexicalUnit | fn:lu:attributed_information:viewpoint | "attributed information" | "viewpoint" | "has lexical unit" |  | "FN" |  |
| fn:attributed_information | fn:HasLexicalUnit | fn:lu:attributed_information:on_authority | "attributed information" | "on authority" | "has lexical unit" |  | "FN" |  |
| fn:attributed_information | /r/HasA | fn:fe:proposition | "attributed information" | "proposition" | "/r/has a" |  | "FN" |  |
| fn:attributed_information | /r/HasA | fn:fe:speaker | "attributed information" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:attributed_information | /r/HasA | fn:fe:text | "attributed information" | "text" | "/r/has a" |  | "FN" |  |
| fn:gradable_attributes | /r/IsA | fn:attributes | "gradable attributes" | "attributes" | "/r/is a" |  | "FN" |  |
| fn:race_descriptor | /r/IsA | fn:attributes | "race descriptor" | "attributes" | "/r/is a" |  | "FN" |  |
| fn:scope | /r/IsA | fn:attributes | "scope" | "attributes" | "/r/is a" |  | "FN" |  |
| fn:attributes | /r/HasA | fn:fe:entity | "attributes" | "entity" | "/r/has a" |  | "FN" |  |
| fn:attributes | /r/HasA | fn:fe:attribute | "attributes" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:attributes | /r/HasA | fn:fe:value | "attributes" | "value" | "/r/has a" |  | "FN" |  |
| fn:authority | /r/IsA | fn:influencing_potential | "authority" | "influencing potential" | "/r/is a" |  | "FN" |  |
| fn:authority | fn:HasLexicalUnit | fn:lu:authority:power | "authority" | "power" | "has lexical unit" |  | "FN" |  |
| fn:authority | fn:HasLexicalUnit | fn:lu:authority:authority | "authority" | "authority" | "has lexical unit" |  | "FN" |  |
| fn:authority | fn:HasLexicalUnit | fn:lu:authority:jurisdiction | "authority" | "jurisdiction" | "has lexical unit" |  | "FN" |  |
| fn:authority | fn:HasLexicalUnit | fn:lu:authority:sway | "authority" | "sway" | "has lexical unit" |  | "FN" |  |
| fn:authority | fn:HasLexicalUnit | fn:lu:authority:dominion | "authority" | "dominion" | "has lexical unit" |  | "FN" |  |
| fn:authority | /r/HasA | fn:fe:agent | "authority" | "agent" | "/r/has a" |  | "FN" |  |
| fn:authority | /r/HasA | fn:fe:theme | "authority" | "theme" | "/r/has a" |  | "FN" |  |
| fn:authority | /r/HasA | fn:fe:domain | "authority" | "domain" | "/r/has a" |  | "FN" |  |
| fn:authority | /r/HasA | fn:fe:source | "authority" | "source" | "/r/has a" |  | "FN" |  |
| fn:authority | /r/HasA | fn:fe:descriptor | "authority" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:dodging | /r/IsA | fn:avoiding | "dodging" | "avoiding" | "/r/is a" |  | "FN" |  |
| fn:evading | /r/IsA | fn:avoiding | "evading" | "avoiding" | "/r/is a" |  | "FN" |  |
| fn:avoiding | /r/IsA | fn:intentionally_act | "avoiding" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:avoiding | /r/SimilarTo | fn:dodging | "avoiding" | "dodging" | "/r/similar to" |  | "FN" |  |
| fn:avoiding | /r/SimilarTo | fn:escaping | "avoiding" | "escaping" | "/r/similar to" |  | "FN" |  |
| fn:avoiding | /r/SimilarTo | fn:evading | "avoiding" | "evading" | "/r/similar to" |  | "FN" |  |
| fn:avoiding | /r/SimilarTo | fn:forgoing | "avoiding" | "forgoing" | "/r/similar to" |  | "FN" |  |
| fn:path_shape | /r/SimilarTo | fn:avoiding | "path shape" | "avoiding" | "/r/similar to" |  | "FN" |  |
| fn:avoiding | fn:HasLexicalUnit | fn:lu:avoiding:avoid | "avoiding" | "avoid" | "has lexical unit" |  | "FN" |  |
| fn:avoiding | fn:HasLexicalUnit | fn:lu:avoiding:evade | "avoiding" | "evade" | "has lexical unit" |  | "FN" |  |
| fn:avoiding | fn:HasLexicalUnit | fn:lu:avoiding:dodge | "avoiding" | "dodge" | "has lexical unit" |  | "FN" |  |
| fn:avoiding | fn:HasLexicalUnit | fn:lu:avoiding:duck | "avoiding" | "duck" | "has lexical unit" |  | "FN" |  |
| fn:avoiding | fn:HasLexicalUnit | fn:lu:avoiding:escape | "avoiding" | "escape" | "has lexical unit" |  | "FN" |  |
| fn:avoiding | fn:HasLexicalUnit | fn:lu:avoiding:shirk | "avoiding" | "shirk" | "has lexical unit" |  | "FN" |  |
| fn:avoiding | fn:HasLexicalUnit | fn:lu:avoiding:shun | "avoiding" | "shun" | "has lexical unit" |  | "FN" |  |
| fn:avoiding | fn:HasLexicalUnit | fn:lu:avoiding:sidestep | "avoiding" | "sidestep" | "has lexical unit" |  | "FN" |  |
| fn:avoiding | fn:HasLexicalUnit | fn:lu:avoiding:skirt | "avoiding" | "skirt" | "has lexical unit" |  | "FN" |  |
| fn:avoiding | fn:HasLexicalUnit | fn:lu:avoiding:avoidance | "avoiding" | "avoidance" | "has lexical unit" |  | "FN" |  |
| fn:avoiding | fn:HasLexicalUnit | fn:lu:avoiding:sidestep | "avoiding" | "sidestep" | "has lexical unit" |  | "FN" |  |
| fn:avoiding | fn:HasLexicalUnit | fn:lu:avoiding:evasion | "avoiding" | "evasion" | "has lexical unit" |  | "FN" |  |
| fn:avoiding | fn:HasLexicalUnit | fn:lu:avoiding:eschew | "avoiding" | "eschew" | "has lexical unit" |  | "FN" |  |
| fn:avoiding | fn:HasLexicalUnit | fn:lu:avoiding:forgo | "avoiding" | "forgo" | "has lexical unit" |  | "FN" |  |
| fn:avoiding | fn:HasLexicalUnit | fn:lu:avoiding:shrink_from | "avoiding" | "shrink from" | "has lexical unit" |  | "FN" |  |
| fn:avoiding | fn:HasLexicalUnit | fn:lu:avoiding:desist | "avoiding" | "desist" | "has lexical unit" |  | "FN" |  |
| fn:avoiding | fn:HasLexicalUnit | fn:lu:avoiding:stay_away | "avoiding" | "stay away" | "has lexical unit" |  | "FN" |  |
| fn:avoiding | fn:HasLexicalUnit | fn:lu:avoiding:keep_away | "avoiding" | "keep away" | "has lexical unit" |  | "FN" |  |
| fn:avoiding | /r/HasA | fn:fe:agent | "avoiding" | "agent" | "/r/has a" |  | "FN" |  |
| fn:avoiding | /r/HasA | fn:fe:place | "avoiding" | "place" | "/r/has a" |  | "FN" |  |
| fn:avoiding | /r/HasA | fn:fe:time | "avoiding" | "time" | "/r/has a" |  | "FN" |  |
| fn:avoiding | /r/HasA | fn:fe:purpose | "avoiding" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:avoiding | /r/HasA | fn:fe:undesirable_situation | "avoiding" | "undesirable situation" | "/r/has a" |  | "FN" |  |
| fn:avoiding | /r/HasA | fn:fe:means | "avoiding" | "means" | "/r/has a" |  | "FN" |  |
| fn:avoiding | /r/HasA | fn:fe:manner | "avoiding" | "manner" | "/r/has a" |  | "FN" |  |
| fn:avoiding | /r/HasA | fn:fe:circumstances | "avoiding" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:avoiding | /r/HasA | fn:fe:degree | "avoiding" | "degree" | "/r/has a" |  | "FN" |  |
| fn:avoiding | /r/HasA | fn:fe:explanation | "avoiding" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:expectation | /r/IsA | fn:awareness | "expectation" | "awareness" | "/r/is a" |  | "FN" |  |
| fn:grasp | /r/IsA | fn:awareness | "grasp" | "awareness" | "/r/is a" |  | "FN" |  |
| fn:awareness | /r/IsA | fn:mental_activity | "awareness" | "mental activity" | "/r/is a" |  | "FN" |  |
| fn:awareness | /r/UsedFor | fn:certainty | "awareness" | "certainty" | "/r/used for" |  | "FN" |  |
| fn:awareness | /r/UsedFor | fn:examination | "awareness" | "examination" | "/r/used for" |  | "FN" |  |
| fn:awareness | /r/UsedFor | fn:fame | "awareness" | "fame" | "/r/used for" |  | "FN" |  |
| fn:awareness | /r/UsedFor | fn:impression | "awareness" | "impression" | "/r/used for" |  | "FN" |  |
| fn:awareness | /r/UsedFor | fn:religious_belief | "awareness" | "religious belief" | "/r/used for" |  | "FN" |  |
| fn:awareness | /r/UsedFor | fn:remembering_information | "awareness" | "remembering information" | "/r/used for" |  | "FN" |  |
| fn:awareness | /r/UsedFor | fn:representing | "awareness" | "representing" | "/r/used for" |  | "FN" |  |
| fn:awareness | /r/UsedFor | fn:secrecy_status | "awareness" | "secrecy status" | "/r/used for" |  | "FN" |  |
| fn:information | /r/UsedFor | fn:awareness | "information" | "awareness" | "/r/used for" |  | "FN" |  |
| fn:awareness | /r/RelatedTo | fn:certainty | "awareness" | "certainty" | "/r/related to" |  | "FN" |  |
| fn:awareness | /r/RelatedTo | fn:opinion | "awareness" | "opinion" | "/r/related to" |  | "FN" |  |
| fn:awareness | /r/SimilarTo | fn:attention | "awareness" | "attention" | "/r/similar to" |  | "FN" |  |
| fn:awareness | /r/SimilarTo | fn:categorization | "awareness" | "categorization" | "/r/similar to" |  | "FN" |  |
| fn:awareness | /r/SimilarTo | fn:coming_up_with | "awareness" | "coming up with" | "/r/similar to" |  | "FN" |  |
| fn:awareness | /r/SimilarTo | fn:emotion_directed | "awareness" | "emotion directed" | "/r/similar to" |  | "FN" |  |
| fn:awareness | /r/SimilarTo | fn:expertise | "awareness" | "expertise" | "/r/similar to" |  | "FN" |  |
| fn:awareness | /r/SimilarTo | fn:opinion | "awareness" | "opinion" | "/r/similar to" |  | "FN" |  |
| fn:categorization | /r/SimilarTo | fn:awareness | "categorization" | "awareness" | "/r/similar to" |  | "FN" |  |
| fn:coming_to_believe | /r/Causes | fn:awareness | "coming to believe" | "awareness" | "/r/causes" |  | "FN" |  |
| fn:awareness | /r/IsA | fn:awareness_situation | "awareness" | "awareness situation" | "/r/is a" |  | "FN" |  |
| fn:awareness | fn:HasLexicalUnit | fn:lu:awareness:aware | "awareness" | "aware" | "has lexical unit" |  | "FN" |  |
| fn:awareness | fn:HasLexicalUnit | fn:lu:awareness:awareness | "awareness" | "awareness" | "has lexical unit" |  | "FN" |  |
| fn:awareness | fn:HasLexicalUnit | fn:lu:awareness:believe | "awareness" | "believe" | "has lexical unit" |  | "FN" |  |
| fn:awareness | fn:HasLexicalUnit | fn:lu:awareness:comprehend | "awareness" | "comprehend" | "has lexical unit" |  | "FN" |  |
| fn:awareness | fn:HasLexicalUnit | fn:lu:awareness:comprehension | "awareness" | "comprehension" | "has lexical unit" |  | "FN" |  |
| fn:awareness | fn:HasLexicalUnit | fn:lu:awareness:conceive | "awareness" | "conceive" | "has lexical unit" |  | "FN" |  |
| fn:awareness | fn:HasLexicalUnit | fn:lu:awareness:conception | "awareness" | "conception" | "has lexical unit" |  | "FN" |  |
| fn:awareness | fn:HasLexicalUnit | fn:lu:awareness:conscious | "awareness" | "conscious" | "has lexical unit" |  | "FN" |  |
| fn:awareness | fn:HasLexicalUnit | fn:lu:awareness:hunch | "awareness" | "hunch" | "has lexical unit" |  | "FN" |  |
| fn:awareness | fn:HasLexicalUnit | fn:lu:awareness:imagine | "awareness" | "imagine" | "has lexical unit" |  | "FN" |  |
| fn:awareness | fn:HasLexicalUnit | fn:lu:awareness:know | "awareness" | "know" | "has lexical unit" |  | "FN" |  |
| fn:awareness | fn:HasLexicalUnit | fn:lu:awareness:knowledge | "awareness" | "knowledge" | "has lexical unit" |  | "FN" |  |
| fn:awareness | fn:HasLexicalUnit | fn:lu:awareness:knowledgeable | "awareness" | "knowledgeable" | "has lexical unit" |  | "FN" |  |
| fn:awareness | fn:HasLexicalUnit | fn:lu:awareness:presume | "awareness" | "presume" | "has lexical unit" |  | "FN" |  |
| fn:awareness | fn:HasLexicalUnit | fn:lu:awareness:presumption | "awareness" | "presumption" | "has lexical unit" |  | "FN" |  |
| fn:awareness | fn:HasLexicalUnit | fn:lu:awareness:reckon | "awareness" | "reckon" | "has lexical unit" |  | "FN" |  |
| fn:awareness | fn:HasLexicalUnit | fn:lu:awareness:supposition | "awareness" | "supposition" | "has lexical unit" |  | "FN" |  |
| fn:awareness | fn:HasLexicalUnit | fn:lu:awareness:suspect | "awareness" | "suspect" | "has lexical unit" |  | "FN" |  |
| fn:awareness | fn:HasLexicalUnit | fn:lu:awareness:suspicion | "awareness" | "suspicion" | "has lexical unit" |  | "FN" |  |
| fn:awareness | fn:HasLexicalUnit | fn:lu:awareness:think | "awareness" | "think" | "has lexical unit" |  | "FN" |  |
| fn:awareness | fn:HasLexicalUnit | fn:lu:awareness:thought | "awareness" | "thought" | "has lexical unit" |  | "FN" |  |
| fn:awareness | fn:HasLexicalUnit | fn:lu:awareness:understand | "awareness" | "understand" | "has lexical unit" |  | "FN" |  |
| fn:awareness | fn:HasLexicalUnit | fn:lu:awareness:understanding | "awareness" | "understanding" | "has lexical unit" |  | "FN" |  |
| fn:awareness | fn:HasLexicalUnit | fn:lu:awareness:ignorance | "awareness" | "ignorance" | "has lexical unit" |  | "FN" |  |
| fn:awareness | fn:HasLexicalUnit | fn:lu:awareness:consciousness | "awareness" | "consciousness" | "has lexical unit" |  | "FN" |  |
| fn:awareness | fn:HasLexicalUnit | fn:lu:awareness:cognizant | "awareness" | "cognizant" | "has lexical unit" |  | "FN" |  |
| fn:awareness | fn:HasLexicalUnit | fn:lu:awareness:unknown | "awareness" | "unknown" | "has lexical unit" |  | "FN" |  |
| fn:awareness | fn:HasLexicalUnit | fn:lu:awareness:idea | "awareness" | "idea" | "has lexical unit" |  | "FN" |  |
| fn:fe:cognizer | /r/RelatedTo | fn:fe:expressor | "cognizer" | "expressor" | "/r/related to" |  | "FN" |  |
| fn:awareness | /r/HasA | fn:fe:cognizer | "awareness" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:awareness | /r/HasA | fn:fe:content | "awareness" | "content" | "/r/has a" |  | "FN" |  |
| fn:awareness | /r/HasA | fn:fe:evidence | "awareness" | "evidence" | "/r/has a" |  | "FN" |  |
| fn:awareness | /r/HasA | fn:fe:topic | "awareness" | "topic" | "/r/has a" |  | "FN" |  |
| fn:awareness | /r/HasA | fn:fe:degree | "awareness" | "degree" | "/r/has a" |  | "FN" |  |
| fn:awareness | /r/HasA | fn:fe:manner | "awareness" | "manner" | "/r/has a" |  | "FN" |  |
| fn:awareness | /r/HasA | fn:fe:expressor | "awareness" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:awareness | /r/HasA | fn:fe:role | "awareness" | "role" | "/r/has a" |  | "FN" |  |
| fn:awareness | /r/HasA | fn:fe:paradigm | "awareness" | "paradigm" | "/r/has a" |  | "FN" |  |
| fn:awareness | /r/HasA | fn:fe:time | "awareness" | "time" | "/r/has a" |  | "FN" |  |
| fn:awareness | /r/HasA | fn:fe:explanation | "awareness" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:awareness_situation | /r/UsedFor | fn:awareness_status | "awareness situation" | "awareness status" | "/r/used for" |  | "FN" |  |
| fn:awareness | /r/IsA | fn:awareness_situation | "awareness" | "awareness situation" | "/r/is a" |  | "FN" |  |
| fn:awareness_situation | /r/HasA | fn:fe:cognizer | "awareness situation" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:awareness_situation | /r/HasA | fn:fe:content | "awareness situation" | "content" | "/r/has a" |  | "FN" |  |
| fn:awareness_situation | /r/HasA | fn:fe:expressor | "awareness situation" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:awareness_situation | /r/HasA | fn:fe:topic | "awareness situation" | "topic" | "/r/has a" |  | "FN" |  |
| fn:awareness_situation | /r/HasA | fn:fe:degree | "awareness situation" | "degree" | "/r/has a" |  | "FN" |  |
| fn:awareness_situation | /r/HasA | fn:fe:evidence | "awareness situation" | "evidence" | "/r/has a" |  | "FN" |  |
| fn:awareness_situation | /r/HasA | fn:fe:manner | "awareness situation" | "manner" | "/r/has a" |  | "FN" |  |
| fn:awareness_situation | /r/HasA | fn:fe:role | "awareness situation" | "role" | "/r/has a" |  | "FN" |  |
| fn:awareness_situation | /r/HasA | fn:fe:time | "awareness situation" | "time" | "/r/has a" |  | "FN" |  |
| fn:awareness_situation | /r/UsedFor | fn:awareness_status | "awareness situation" | "awareness status" | "/r/used for" |  | "FN" |  |
| fn:awareness_status | fn:HasLexicalUnit | fn:lu:awareness_status:known | "awareness status" | "known" | "has lexical unit" |  | "FN" |  |
| fn:awareness_status | fn:HasLexicalUnit | fn:lu:awareness_status:suspected | "awareness status" | "suspected" | "has lexical unit" |  | "FN" |  |
| fn:awareness_status | fn:HasLexicalUnit | fn:lu:awareness_status:presumed | "awareness status" | "presumed" | "has lexical unit" |  | "FN" |  |
| fn:awareness_status | fn:HasLexicalUnit | fn:lu:awareness_status:possible | "awareness status" | "possible" | "has lexical unit" |  | "FN" |  |
| fn:awareness_status | /r/HasA | fn:fe:cognizer | "awareness status" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:awareness_status | /r/HasA | fn:fe:content | "awareness status" | "content" | "/r/has a" |  | "FN" |  |
| fn:awareness_status | /r/HasA | fn:fe:degree | "awareness status" | "degree" | "/r/has a" |  | "FN" |  |
| fn:awareness_status | /r/HasA | fn:fe:evidence | "awareness status" | "evidence" | "/r/has a" |  | "FN" |  |
| fn:awareness_status | /r/HasA | fn:fe:role | "awareness status" | "role" | "/r/has a" |  | "FN" |  |
| fn:awareness_status | /r/HasA | fn:fe:time | "awareness status" | "time" | "/r/has a" |  | "FN" |  |
| fn:bail_decision | /r/IsA | fn:intentionally_act | "bail decision" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:arraignment | /r/HasSubevent | fn:bail_decision | "arraignment" | "bail decision" | "/r/has subevent" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:bail_decision | "communication" | "bail decision" | "/r/used for" |  | "FN" |  |
| fn:bail_decision | /r/HasPrerequisite | fn:entering_of_plea | "bail decision" | "entering of plea" | "/r/has prerequisite" |  | "FN" |  |
| fn:bail_decision | fn:HasLexicalUnit | fn:lu:bail_decision:set | "bail decision" | "set" | "has lexical unit" |  | "FN" |  |
| fn:bail_decision | fn:HasLexicalUnit | fn:lu:bail_decision:fix | "bail decision" | "fix" | "has lexical unit" |  | "FN" |  |
| fn:bail_decision | fn:HasLexicalUnit | fn:lu:bail_decision:order | "bail decision" | "order" | "has lexical unit" |  | "FN" |  |
| fn:bail_decision | fn:HasLexicalUnit | fn:lu:bail_decision:bail | "bail decision" | "bail" | "has lexical unit" |  | "FN" |  |
| fn:bail_decision | fn:HasLexicalUnit | fn:lu:bail_decision:bond | "bail decision" | "bond" | "has lexical unit" |  | "FN" |  |
| fn:bail_decision | /r/HasA | fn:fe:accused | "bail decision" | "accused" | "/r/has a" |  | "FN" |  |
| fn:bail_decision | /r/HasA | fn:fe:judge | "bail decision" | "judge" | "/r/has a" |  | "FN" |  |
| fn:bail_decision | /r/HasA | fn:fe:status | "bail decision" | "status" | "/r/has a" |  | "FN" |  |
| fn:bail_decision | /r/HasA | fn:fe:time | "bail decision" | "time" | "/r/has a" |  | "FN" |  |
| fn:bail_decision | /r/HasA | fn:fe:place | "bail decision" | "place" | "/r/has a" |  | "FN" |  |
| fn:bail_decision | /r/HasA | fn:fe:manner | "bail decision" | "manner" | "/r/has a" |  | "FN" |  |
| fn:bail_decision | /r/HasA | fn:fe:means | "bail decision" | "means" | "/r/has a" |  | "FN" |  |
| fn:bail_decision | /r/HasA | fn:fe:purpose | "bail decision" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:locative_relation | /r/IsA | fn:basis_for_attribute | "locative relation" | "basis for attribute" | "/r/is a" |  | "FN" |  |
| fn:temporal_collocation | /r/IsA | fn:basis_for_attribute | "temporal collocation" | "basis for attribute" | "/r/is a" |  | "FN" |  |
| fn:time_vector | /r/IsA | fn:basis_for_attribute | "time vector" | "basis for attribute" | "/r/is a" |  | "FN" |  |
| fn:basis_for_attribute | /r/IsA | fn:relation | "basis for attribute" | "relation" | "/r/is a" |  | "FN" |  |
| fn:basis_for_attribute | /r/HasA | fn:fe:trajector | "basis for attribute" | "trajector" | "/r/has a" |  | "FN" |  |
| fn:basis_for_attribute | /r/HasA | fn:fe:landmark | "basis for attribute" | "landmark" | "/r/has a" |  | "FN" |  |
| fn:basis_for_attribute | /r/HasA | fn:fe:profiled_region | "basis for attribute" | "profiled region" | "/r/has a" |  | "FN" |  |
| fn:having_commercial_agreement | /r/IsA | fn:be_in_agreement_on_action | "having commercial agreement" | "be in agreement on action" | "/r/is a" |  | "FN" |  |
| fn:make_agreement_on_action | /r/UsedFor | fn:be_in_agreement_on_action | "make agreement on action" | "be in agreement on action" | "/r/used for" |  | "FN" |  |
| fn:be_in_agreement_on_action | fn:HasLexicalUnit | fn:lu:be_in_agreement_on_action:treaty | "be in agreement on action" | "treaty" | "has lexical unit" |  | "FN" |  |
| fn:be_in_agreement_on_action | fn:HasLexicalUnit | fn:lu:be_in_agreement_on_action:agreement | "be in agreement on action" | "agreement" | "has lexical unit" |  | "FN" |  |
| fn:be_in_agreement_on_action | fn:HasLexicalUnit | fn:lu:be_in_agreement_on_action:deal | "be in agreement on action" | "deal" | "has lexical unit" |  | "FN" |  |
| fn:be_in_agreement_on_action | fn:HasLexicalUnit | fn:lu:be_in_agreement_on_action:accord | "be in agreement on action" | "accord" | "has lexical unit" |  | "FN" |  |
| fn:be_in_agreement_on_action | fn:HasLexicalUnit | fn:lu:be_in_agreement_on_action:convention | "be in agreement on action" | "convention" | "has lexical unit" |  | "FN" |  |
| fn:be_in_agreement_on_action | fn:HasLexicalUnit | fn:lu:be_in_agreement_on_action:strike | "be in agreement on action" | "strike" | "has lexical unit" |  | "FN" |  |
| fn:fe:party_1 | /r/IsA | fn:st:sentient | "party 1" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:fe:party_1 | /r/RelatedTo | fn:fe:parties | "party 1" | "parties" | "/r/related to" |  | "FN" |  |
| fn:be_in_agreement_on_action | /r/HasA | fn:fe:party_1 | "be in agreement on action" | "party 1" | "/r/has a" |  | "FN" |  |
| fn:fe:party_2 | /r/IsA | fn:st:sentient | "party 2" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:fe:party_2 | /r/HasPrerequisite | fn:fe:party_1 | "party 2" | "party 1" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:party_2 | /r/RelatedTo | fn:fe:parties | "party 2" | "parties" | "/r/related to" |  | "FN" |  |
| fn:be_in_agreement_on_action | /r/HasA | fn:fe:party_2 | "be in agreement on action" | "party 2" | "/r/has a" |  | "FN" |  |
| fn:be_in_agreement_on_action | /r/HasA | fn:fe:obligation | "be in agreement on action" | "obligation" | "/r/has a" |  | "FN" |  |
| fn:be_in_agreement_on_action | /r/HasA | fn:fe:topic | "be in agreement on action" | "topic" | "/r/has a" |  | "FN" |  |
| fn:be_in_agreement_on_action | /r/HasA | fn:fe:medium | "be in agreement on action" | "medium" | "/r/has a" |  | "FN" |  |
| fn:be_in_agreement_on_action | /r/HasA | fn:fe:parties | "be in agreement on action" | "parties" | "/r/has a" |  | "FN" |  |
| fn:be_in_agreement_on_action | /r/HasA | fn:fe:place | "be in agreement on action" | "place" | "/r/has a" |  | "FN" |  |
| fn:be_in_agreement_on_action | /r/HasA | fn:fe:time | "be in agreement on action" | "time" | "/r/has a" |  | "FN" |  |
| fn:be_in_agreement_on_action | /r/HasA | fn:fe:manner | "be in agreement on action" | "manner" | "/r/has a" |  | "FN" |  |
| fn:be_in_agreement_on_action | /r/HasA | fn:fe:circumstances | "be in agreement on action" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:be_in_agreement_on_action | /r/HasA | fn:fe:degree | "be in agreement on action" | "degree" | "/r/has a" |  | "FN" |  |
| fn:be_in_agreement_on_action | /r/HasA | fn:fe:duration | "be in agreement on action" | "duration" | "/r/has a" |  | "FN" |  |
| fn:be_in_agreement_on_action | /r/HasA | fn:fe:descriptor | "be in agreement on action" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:be_in_agreement_on_assessment | /r/IsA | fn:similarity | "be in agreement on assessment" | "similarity" | "/r/is a" |  | "FN" |  |
| fn:be_in_agreement_on_assessment | /r/UsedFor | fn:point_of_dispute | "be in agreement on assessment" | "point of dispute" | "/r/used for" |  | "FN" |  |
| fn:be_in_agreement_on_assessment | /r/UsedFor | fn:quarreling | "be in agreement on assessment" | "quarreling" | "/r/used for" |  | "FN" |  |
| fn:opinion | /r/UsedFor | fn:be_in_agreement_on_assessment | "opinion" | "be in agreement on assessment" | "/r/used for" |  | "FN" |  |
| fn:be_in_agreement_on_assessment | fn:HasLexicalUnit | fn:lu:be_in_agreement_on_assessment:agree | "be in agreement on assessment" | "agree" | "has lexical unit" |  | "FN" |  |
| fn:be_in_agreement_on_assessment | fn:HasLexicalUnit | fn:lu:be_in_agreement_on_assessment:see_eye_to_eye | "be in agreement on assessment" | "see eye to eye" | "has lexical unit" |  | "FN" |  |
| fn:be_in_agreement_on_assessment | fn:HasLexicalUnit | fn:lu:be_in_agreement_on_assessment:concur | "be in agreement on assessment" | "concur" | "has lexical unit" |  | "FN" |  |
| fn:be_in_agreement_on_assessment | fn:HasLexicalUnit | fn:lu:be_in_agreement_on_assessment:agreement | "be in agreement on assessment" | "agreement" | "has lexical unit" |  | "FN" |  |
| fn:fe:cognizers | /r/RelatedTo | fn:fe:cognizer_1 | "cognizers" | "cognizer 1" | "/r/related to" |  | "FN" |  |
| fn:be_in_agreement_on_assessment | /r/HasA | fn:fe:cognizers | "be in agreement on assessment" | "cognizers" | "/r/has a" |  | "FN" |  |
| fn:fe:cognizer_1 | /r/HasPrerequisite | fn:fe:cognizer_2 | "cognizer 1" | "cognizer 2" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:cognizer_1 | /r/RelatedTo | fn:fe:cognizers | "cognizer 1" | "cognizers" | "/r/related to" |  | "FN" |  |
| fn:be_in_agreement_on_assessment | /r/HasA | fn:fe:cognizer_1 | "be in agreement on assessment" | "cognizer 1" | "/r/has a" |  | "FN" |  |
| fn:fe:cognizer_2 | /r/HasPrerequisite | fn:fe:cognizer_1 | "cognizer 2" | "cognizer 1" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:cognizer_2 | /r/RelatedTo | fn:fe:cognizers | "cognizer 2" | "cognizers" | "/r/related to" |  | "FN" |  |
| fn:be_in_agreement_on_assessment | /r/HasA | fn:fe:cognizer_2 | "be in agreement on assessment" | "cognizer 2" | "/r/has a" |  | "FN" |  |
| fn:fe:question | /r/RelatedTo | fn:fe:topic | "question" | "topic" | "/r/related to" |  | "FN" |  |
| fn:be_in_agreement_on_assessment | /r/HasA | fn:fe:question | "be in agreement on assessment" | "question" | "/r/has a" |  | "FN" |  |
| fn:be_in_agreement_on_assessment | /r/HasA | fn:fe:degree | "be in agreement on assessment" | "degree" | "/r/has a" |  | "FN" |  |
| fn:be_in_agreement_on_assessment | /r/HasA | fn:fe:time | "be in agreement on assessment" | "time" | "/r/has a" |  | "FN" |  |
| fn:be_in_agreement_on_assessment | /r/HasA | fn:fe:place | "be in agreement on assessment" | "place" | "/r/has a" |  | "FN" |  |
| fn:be_in_agreement_on_assessment | /r/HasA | fn:fe:manner | "be in agreement on assessment" | "manner" | "/r/has a" |  | "FN" |  |
| fn:be_in_agreement_on_assessment | /r/HasA | fn:fe:explanation | "be in agreement on assessment" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:be_in_agreement_on_assessment | /r/HasA | fn:fe:depictive | "be in agreement on assessment" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:fe:opinion | /r/RelatedTo | fn:fe:question | "opinion" | "question" | "/r/related to" |  | "FN" |  |
| fn:be_in_agreement_on_assessment | /r/HasA | fn:fe:opinion | "be in agreement on assessment" | "opinion" | "/r/has a" |  | "FN" |  |
| fn:fe:topic | /r/RelatedTo | fn:fe:question | "topic" | "question" | "/r/related to" |  | "FN" |  |
| fn:be_in_agreement_on_assessment | /r/HasA | fn:fe:topic | "be in agreement on assessment" | "topic" | "/r/has a" |  | "FN" |  |
| fn:be_in_agreement_on_assessment | /r/HasA | fn:fe:circumstances | "be in agreement on assessment" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:be_on_alert | /r/IsA | fn:activity_ready_state | "be on alert" | "activity ready state" | "/r/is a" |  | "FN" |  |
| fn:be_on_alert | fn:HasLexicalUnit | fn:lu:be_on_alert:alert | "be on alert" | "alert" | "has lexical unit" |  | "FN" |  |
| fn:be_on_alert | fn:HasLexicalUnit | fn:lu:be_on_alert:guard | "be on alert" | "guard" | "has lexical unit" |  | "FN" |  |
| fn:be_on_alert | /r/HasA | fn:fe:protagonist | "be on alert" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:be_on_alert | /r/HasA | fn:fe:activity | "be on alert" | "activity" | "/r/has a" |  | "FN" |  |
| fn:be_on_alert | /r/HasA | fn:fe:time | "be on alert" | "time" | "/r/has a" |  | "FN" |  |
| fn:be_on_alert | /r/HasA | fn:fe:result | "be on alert" | "result" | "/r/has a" |  | "FN" |  |
| fn:be_on_alert | /r/HasA | fn:fe:duration | "be on alert" | "duration" | "/r/has a" |  | "FN" |  |
| fn:be_on_alert | /r/HasA | fn:fe:degree | "be on alert" | "degree" | "/r/has a" |  | "FN" |  |
| fn:be_on_alert | /r/HasA | fn:fe:danger | "be on alert" | "danger" | "/r/has a" |  | "FN" |  |
| fn:be_on_alert | /r/HasA | fn:fe:dangerous_entity | "be on alert" | "dangerous entity" | "/r/has a" |  | "FN" |  |
| fn:membership | /r/IsA | fn:be_subset_of | "membership" | "be subset of" | "/r/is a" |  | "FN" |  |
| fn:be_subset_of | /r/IsA | fn:being_included | "be subset of" | "being included" | "/r/is a" |  | "FN" |  |
| fn:be_subset_of | /r/IsA | fn:set_relation | "be subset of" | "set relation" | "/r/is a" |  | "FN" |  |
| fn:be_subset_of | fn:HasLexicalUnit | fn:lu:be_subset_of:number | "be subset of" | "number" | "has lexical unit" |  | "FN" |  |
| fn:be_subset_of | fn:HasLexicalUnit | fn:lu:be_subset_of:count | "be subset of" | "count" | "has lexical unit" |  | "FN" |  |
| fn:be_subset_of | fn:HasLexicalUnit | fn:lu:be_subset_of:among | "be subset of" | "among" | "has lexical unit" |  | "FN" |  |
| fn:be_subset_of | fn:HasLexicalUnit | fn:lu:be_subset_of:subset | "be subset of" | "subset" | "has lexical unit" |  | "FN" |  |
| fn:be_subset_of | /r/HasA | fn:fe:total | "be subset of" | "total" | "/r/has a" |  | "FN" |  |
| fn:be_subset_of | /r/HasA | fn:fe:part | "be subset of" | "part" | "/r/has a" |  | "FN" |  |
| fn:be_subset_of | /r/HasA | fn:fe:frequency | "be subset of" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:be_subset_of | /r/HasA | fn:fe:contrast_set | "be subset of" | "contrast set" | "/r/has a" |  | "FN" |  |
| fn:fe:subregion | /r/IsA | fn:st:locative_relation | "subregion" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:be_subset_of | /r/HasA | fn:fe:subregion | "be subset of" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:be_subset_of | /r/HasA | fn:fe:explanation | "be subset of" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:be_subset_of | /r/HasA | fn:fe:manner | "be subset of" | "manner" | "/r/has a" |  | "FN" |  |
| fn:be_subset_of | /r/HasA | fn:fe:time | "be subset of" | "time" | "/r/has a" |  | "FN" |  |
| fn:be_subset_of | /r/HasA | fn:fe:place | "be subset of" | "place" | "/r/has a" |  | "FN" |  |
| fn:translating | /r/UsedFor | fn:be_translation_equivalent | "translating" | "be translation equivalent" | "/r/used for" |  | "FN" |  |
| fn:have_as_translation_equivalent | /r/RelatedTo | fn:be_translation_equivalent | "have as translation equivalent" | "be translation equivalent" | "/r/related to" |  | "FN" |  |
| fn:be_translation_equivalent | fn:HasLexicalUnit | fn:lu:be_translation_equivalent:translate | "be translation equivalent" | "translate" | "has lexical unit" |  | "FN" |  |
| fn:be_translation_equivalent | /r/HasA | fn:fe:source_symbol | "be translation equivalent" | "source symbol" | "/r/has a" |  | "FN" |  |
| fn:be_translation_equivalent | /r/HasA | fn:fe:source_representation | "be translation equivalent" | "source representation" | "/r/has a" |  | "FN" |  |
| fn:be_translation_equivalent | /r/HasA | fn:fe:time | "be translation equivalent" | "time" | "/r/has a" |  | "FN" |  |
| fn:be_translation_equivalent | /r/HasA | fn:fe:circumstances | "be translation equivalent" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:be_translation_equivalent | /r/HasA | fn:fe:target_symbol | "be translation equivalent" | "target symbol" | "/r/has a" |  | "FN" |  |
| fn:be_translation_equivalent | /r/HasA | fn:fe:target_representation | "be translation equivalent" | "target representation" | "/r/has a" |  | "FN" |  |
| fn:be_translation_equivalent | /r/HasA | fn:fe:content | "be translation equivalent" | "content" | "/r/has a" |  | "FN" |  |
| fn:be_translation_equivalent | /r/HasA | fn:fe:equivalence | "be translation equivalent" | "equivalence" | "/r/has a" |  | "FN" |  |
| fn:be_translation_equivalent | /r/HasA | fn:fe:medium | "be translation equivalent" | "medium" | "/r/has a" |  | "FN" |  |
| fn:bearing_arms | /r/IsA | fn:state | "bearing arms" | "state" | "/r/is a" |  | "FN" |  |
| fn:bearing_arms | /r/UsedFor | fn:shooting_scenario | "bearing arms" | "shooting scenario" | "/r/used for" |  | "FN" |  |
| fn:weapon | /r/UsedFor | fn:bearing_arms | "weapon" | "bearing arms" | "/r/used for" |  | "FN" |  |
| fn:bearing_arms | fn:HasLexicalUnit | fn:lu:bearing_arms:armed | "bearing arms" | "armed" | "has lexical unit" |  | "FN" |  |
| fn:bearing_arms | fn:HasLexicalUnit | fn:lu:bearing_arms:unarmed | "bearing arms" | "unarmed" | "has lexical unit" |  | "FN" |  |
| fn:bearing_arms | fn:HasLexicalUnit | fn:lu:bearing_arms:weaponless | "bearing arms" | "weaponless" | "has lexical unit" |  | "FN" |  |
| fn:bearing_arms | fn:HasLexicalUnit | fn:lu:bearing_arms:bear_arms | "bearing arms" | "bear arms" | "has lexical unit" |  | "FN" |  |
| fn:bearing_arms | fn:HasLexicalUnit | fn:lu:bearing_arms:pack | "bearing arms" | "pack" | "has lexical unit" |  | "FN" |  |
| fn:bearing_arms | fn:HasLexicalUnit | fn:lu:bearing_arms:carry | "bearing arms" | "carry" | "has lexical unit" |  | "FN" |  |
| fn:bearing_arms | fn:HasLexicalUnit | fn:lu:bearing_arms:nuclear | "bearing arms" | "nuclear" | "has lexical unit" |  | "FN" |  |
| fn:bearing_arms | fn:HasLexicalUnit | fn:lu:bearing_arms:gunman | "bearing arms" | "gunman" | "has lexical unit" |  | "FN" |  |
| fn:bearing_arms | fn:HasLexicalUnit | fn:lu:bearing_arms:draw | "bearing arms" | "draw" | "has lexical unit" |  | "FN" |  |
| fn:bearing_arms | /r/HasA | fn:fe:degree | "bearing arms" | "degree" | "/r/has a" |  | "FN" |  |
| fn:fe:weapon | /r/IsA | fn:st:artifact | "weapon" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:bearing_arms | /r/HasA | fn:fe:weapon | "bearing arms" | "weapon" | "/r/has a" |  | "FN" |  |
| fn:bearing_arms | /r/HasA | fn:fe:protagonist | "bearing arms" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:bearing_arms | /r/HasA | fn:fe:place | "bearing arms" | "place" | "/r/has a" |  | "FN" |  |
| fn:bearing_arms | /r/HasA | fn:fe:time | "bearing arms" | "time" | "/r/has a" |  | "FN" |  |
| fn:win_prize | /r/UsedFor | fn:beat_opponent | "win prize" | "beat opponent" | "/r/used for" |  | "FN" |  |
| fn:beat_opponent | fn:HasLexicalUnit | fn:lu:beat_opponent:defeat | "beat opponent" | "defeat" | "has lexical unit" |  | "FN" |  |
| fn:beat_opponent | fn:HasLexicalUnit | fn:lu:beat_opponent:beat | "beat opponent" | "beat" | "has lexical unit" |  | "FN" |  |
| fn:beat_opponent | fn:HasLexicalUnit | fn:lu:beat_opponent:demolish | "beat opponent" | "demolish" | "has lexical unit" |  | "FN" |  |
| fn:beat_opponent | fn:HasLexicalUnit | fn:lu:beat_opponent:prevail | "beat opponent" | "prevail" | "has lexical unit" |  | "FN" |  |
| fn:beat_opponent | fn:HasLexicalUnit | fn:lu:beat_opponent:defeat | "beat opponent" | "defeat" | "has lexical unit" |  | "FN" |  |
| fn:beat_opponent | fn:HasLexicalUnit | fn:lu:beat_opponent:trounce | "beat opponent" | "trounce" | "has lexical unit" |  | "FN" |  |
| fn:beat_opponent | fn:HasLexicalUnit | fn:lu:beat_opponent:upend | "beat opponent" | "upend" | "has lexical unit" |  | "FN" |  |
| fn:beat_opponent | fn:HasLexicalUnit | fn:lu:beat_opponent:rout | "beat opponent" | "rout" | "has lexical unit" |  | "FN" |  |
| fn:beat_opponent | fn:HasLexicalUnit | fn:lu:beat_opponent:rout | "beat opponent" | "rout" | "has lexical unit" |  | "FN" |  |
| fn:beat_opponent | /r/HasA | fn:fe:winner | "beat opponent" | "winner" | "/r/has a" |  | "FN" |  |
| fn:beat_opponent | /r/HasA | fn:fe:score | "beat opponent" | "score" | "/r/has a" |  | "FN" |  |
| fn:beat_opponent | /r/HasA | fn:fe:margin | "beat opponent" | "margin" | "/r/has a" |  | "FN" |  |
| fn:beat_opponent | /r/HasA | fn:fe:rank | "beat opponent" | "rank" | "/r/has a" |  | "FN" |  |
| fn:beat_opponent | /r/HasA | fn:fe:prize | "beat opponent" | "prize" | "/r/has a" |  | "FN" |  |
| fn:beat_opponent | /r/HasA | fn:fe:means | "beat opponent" | "means" | "/r/has a" |  | "FN" |  |
| fn:beat_opponent | /r/HasA | fn:fe:manner | "beat opponent" | "manner" | "/r/has a" |  | "FN" |  |
| fn:beat_opponent | /r/HasA | fn:fe:time | "beat opponent" | "time" | "/r/has a" |  | "FN" |  |
| fn:beat_opponent | /r/HasA | fn:fe:place | "beat opponent" | "place" | "/r/has a" |  | "FN" |  |
| fn:beat_opponent | /r/HasA | fn:fe:venue | "beat opponent" | "venue" | "/r/has a" |  | "FN" |  |
| fn:beat_opponent | /r/HasA | fn:fe:particular_iteration | "beat opponent" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:beat_opponent | /r/HasA | fn:fe:explanation | "beat opponent" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:beat_opponent | /r/HasA | fn:fe:period_of_iterations | "beat opponent" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:beat_opponent | /r/HasA | fn:fe:loser | "beat opponent" | "loser" | "/r/has a" |  | "FN" |  |
| fn:beat_opponent | /r/HasA | fn:fe:circumstances | "beat opponent" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:beat_opponent | /r/HasA | fn:fe:re-encoding | "beat opponent" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:beat_opponent | /r/HasA | fn:fe:result | "beat opponent" | "result" | "/r/has a" |  | "FN" |  |
| fn:beat_opponent | /r/HasA | fn:fe:iterations | "beat opponent" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:beat_opponent | /r/HasA | fn:fe:communicative_force | "beat opponent" | "communicative force" | "/r/has a" |  | "FN" |  |
| fn:beat_opponent | /r/HasA | fn:fe:event_description | "beat opponent" | "event description" | "/r/has a" |  | "FN" |  |
| fn:beat_opponent | /r/HasA | fn:fe:degree | "beat opponent" | "degree" | "/r/has a" |  | "FN" |  |
| fn:beat_opponent | /r/HasA | fn:fe:depictive | "beat opponent" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:beat_opponent | /r/HasA | fn:fe:competition | "beat opponent" | "competition" | "/r/has a" |  | "FN" |  |
| fn:beat_opponent | /r/HasA | fn:fe:frequency | "beat opponent" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:transition_to_a_quality | /r/IsA | fn:becoming | "transition to a quality" | "becoming" | "/r/is a" |  | "FN" |  |
| fn:becoming | /r/IsA | fn:transition_to_state | "becoming" | "transition to state" | "/r/is a" |  | "FN" |  |
| fn:transition_to_state | /r/SimilarTo | fn:becoming | "transition to state" | "becoming" | "/r/similar to" |  | "FN" |  |
| fn:becoming | fn:HasLexicalUnit | fn:lu:becoming:become | "becoming" | "become" | "has lexical unit" |  | "FN" |  |
| fn:becoming | fn:HasLexicalUnit | fn:lu:becoming:turn | "becoming" | "turn" | "has lexical unit" |  | "FN" |  |
| fn:becoming | /r/HasA | fn:fe:place | "becoming" | "place" | "/r/has a" |  | "FN" |  |
| fn:becoming | /r/HasA | fn:fe:time | "becoming" | "time" | "/r/has a" |  | "FN" |  |
| fn:fe:duration_of_final_state | /r/IsA | fn:st:duration | "duration of final state" | "duration" | "/r/is a" |  | "FN" |  |
| fn:becoming | /r/HasA | fn:fe:duration_of_final_state | "becoming" | "duration of final state" | "/r/has a" |  | "FN" |  |
| fn:becoming | /r/HasA | fn:fe:manner | "becoming" | "manner" | "/r/has a" |  | "FN" |  |
| fn:becoming | /r/HasA | fn:fe:entity | "becoming" | "entity" | "/r/has a" |  | "FN" |  |
| fn:becoming | /r/HasA | fn:fe:final_quality | "becoming" | "final quality" | "/r/has a" |  | "FN" |  |
| fn:becoming | /r/HasA | fn:fe:final_category | "becoming" | "final category" | "/r/has a" |  | "FN" |  |
| fn:becoming | /r/HasA | fn:fe:transitional_period | "becoming" | "transitional period" | "/r/has a" |  | "FN" |  |
| fn:becoming | /r/HasA | fn:fe:initial_state | "becoming" | "initial state" | "/r/has a" |  | "FN" |  |
| fn:becoming | /r/HasA | fn:fe:circumstances | "becoming" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:becoming | /r/HasA | fn:fe:initial_category | "becoming" | "initial category" | "/r/has a" |  | "FN" |  |
| fn:becoming | /r/HasA | fn:fe:group | "becoming" | "group" | "/r/has a" |  | "FN" |  |
| fn:becoming | /r/HasA | fn:fe:explanation | "becoming" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:becoming_a_member | /r/IsA | fn:intentionally_act | "becoming a member" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:becoming_a_member | /r/Causes | fn:membership | "becoming a member" | "membership" | "/r/causes" |  | "FN" |  |
| fn:becoming_a_member | fn:HasLexicalUnit | fn:lu:becoming_a_member:join | "becoming a member" | "join" | "has lexical unit" |  | "FN" |  |
| fn:becoming_a_member | fn:HasLexicalUnit | fn:lu:becoming_a_member:enlist | "becoming a member" | "enlist" | "has lexical unit" |  | "FN" |  |
| fn:becoming_a_member | fn:HasLexicalUnit | fn:lu:becoming_a_member:enroll | "becoming a member" | "enroll" | "has lexical unit" |  | "FN" |  |
| fn:becoming_a_member | fn:HasLexicalUnit | fn:lu:becoming_a_member:sign_up | "becoming a member" | "sign up" | "has lexical unit" |  | "FN" |  |
| fn:becoming_a_member | fn:HasLexicalUnit | fn:lu:becoming_a_member:enter | "becoming a member" | "enter" | "has lexical unit" |  | "FN" |  |
| fn:fe:new_member | /r/IsA | fn:st:sentient | "new member" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:becoming_a_member | /r/HasA | fn:fe:new_member | "becoming a member" | "new member" | "/r/has a" |  | "FN" |  |
| fn:becoming_a_member | /r/HasA | fn:fe:place | "becoming a member" | "place" | "/r/has a" |  | "FN" |  |
| fn:becoming_a_member | /r/HasA | fn:fe:purpose | "becoming a member" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:becoming_a_member | /r/HasA | fn:fe:time | "becoming a member" | "time" | "/r/has a" |  | "FN" |  |
| fn:becoming_a_member | /r/HasA | fn:fe:means | "becoming a member" | "means" | "/r/has a" |  | "FN" |  |
| fn:becoming_a_member | /r/HasA | fn:fe:manner | "becoming a member" | "manner" | "/r/has a" |  | "FN" |  |
| fn:becoming_a_member | /r/HasA | fn:fe:frequency | "becoming a member" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:becoming_a_member | /r/HasA | fn:fe:group | "becoming a member" | "group" | "/r/has a" |  | "FN" |  |
| fn:becoming_a_member | /r/HasA | fn:fe:explanation | "becoming a member" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:becoming_a_member | /r/HasA | fn:fe:role | "becoming a member" | "role" | "/r/has a" |  | "FN" |  |
| fn:becoming_a_member | /r/HasA | fn:fe:depictive | "becoming a member" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:becoming_a_member | /r/HasA | fn:fe:reciprocation | "becoming a member" | "reciprocation" | "/r/has a" |  | "FN" |  |
| fn:becoming_a_member | /r/HasA | fn:fe:circumstances | "becoming a member" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:becoming_a_member | /r/HasA | fn:fe:re-encoding | "becoming a member" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:becoming_attached | /r/IsA | fn:transition_to_a_quality | "becoming attached" | "transition to a quality" | "/r/is a" |  | "FN" |  |
| fn:becoming_attached | /r/Causes | fn:being_attached | "becoming attached" | "being attached" | "/r/causes" |  | "FN" |  |
| fn:attaching | /r/Causes | fn:becoming_attached | "attaching" | "becoming attached" | "/r/causes" |  | "FN" |  |
| fn:becoming_attached | fn:HasLexicalUnit | fn:lu:becoming_attached:agglutinate | "becoming attached" | "agglutinate" | "has lexical unit" |  | "FN" |  |
| fn:becoming_attached | fn:HasLexicalUnit | fn:lu:becoming_attached:bind | "becoming attached" | "bind" | "has lexical unit" |  | "FN" |  |
| fn:becoming_attached | fn:HasLexicalUnit | fn:lu:becoming_attached:fasten | "becoming attached" | "fasten" | "has lexical unit" |  | "FN" |  |
| fn:becoming_attached | fn:HasLexicalUnit | fn:lu:becoming_attached:moor | "becoming attached" | "moor" | "has lexical unit" |  | "FN" |  |
| fn:becoming_attached | fn:HasLexicalUnit | fn:lu:becoming_attached:attach | "becoming attached" | "attach" | "has lexical unit" |  | "FN" |  |
| fn:becoming_attached | fn:HasLexicalUnit | fn:lu:becoming_attached:take_hold | "becoming attached" | "take hold" | "has lexical unit" |  | "FN" |  |
| fn:becoming_attached | fn:HasLexicalUnit | fn:lu:becoming_attached:stick | "becoming attached" | "stick" | "has lexical unit" |  | "FN" |  |
| fn:becoming_attached | /r/HasA | fn:fe:connector | "becoming attached" | "connector" | "/r/has a" |  | "FN" |  |
| fn:becoming_attached | /r/HasA | fn:fe:handle | "becoming attached" | "handle" | "/r/has a" |  | "FN" |  |
| fn:becoming_attached | /r/HasA | fn:fe:item | "becoming attached" | "item" | "/r/has a" |  | "FN" |  |
| fn:becoming_attached | /r/HasA | fn:fe:items | "becoming attached" | "items" | "/r/has a" |  | "FN" |  |
| fn:becoming_attached | /r/HasA | fn:fe:goal | "becoming attached" | "goal" | "/r/has a" |  | "FN" |  |
| fn:becoming_attached | /r/HasA | fn:fe:result | "becoming attached" | "result" | "/r/has a" |  | "FN" |  |
| fn:becoming_attached | /r/HasA | fn:fe:manner | "becoming attached" | "manner" | "/r/has a" |  | "FN" |  |
| fn:becoming_attached | /r/HasA | fn:fe:place | "becoming attached" | "place" | "/r/has a" |  | "FN" |  |
| fn:becoming_attached | /r/HasA | fn:fe:time | "becoming attached" | "time" | "/r/has a" |  | "FN" |  |
| fn:becoming_aware | /r/IsA | fn:perception | "becoming aware" | "perception" | "/r/is a" |  | "FN" |  |
| fn:becoming_aware | /r/UsedFor | fn:scrutiny | "becoming aware" | "scrutiny" | "/r/used for" |  | "FN" |  |
| fn:becoming_aware | /r/SimilarTo | fn:coming_to_believe | "becoming aware" | "coming to believe" | "/r/similar to" |  | "FN" |  |
| fn:becoming_aware | fn:HasLexicalUnit | fn:lu:becoming_aware:discover | "becoming aware" | "discover" | "has lexical unit" |  | "FN" |  |
| fn:becoming_aware | fn:HasLexicalUnit | fn:lu:becoming_aware:discovery | "becoming aware" | "discovery" | "has lexical unit" |  | "FN" |  |
| fn:becoming_aware | fn:HasLexicalUnit | fn:lu:becoming_aware:find | "becoming aware" | "find" | "has lexical unit" |  | "FN" |  |
| fn:becoming_aware | fn:HasLexicalUnit | fn:lu:becoming_aware:note | "becoming aware" | "note" | "has lexical unit" |  | "FN" |  |
| fn:becoming_aware | fn:HasLexicalUnit | fn:lu:becoming_aware:notice | "becoming aware" | "notice" | "has lexical unit" |  | "FN" |  |
| fn:becoming_aware | fn:HasLexicalUnit | fn:lu:becoming_aware:recognize | "becoming aware" | "recognize" | "has lexical unit" |  | "FN" |  |
| fn:becoming_aware | fn:HasLexicalUnit | fn:lu:becoming_aware:register | "becoming aware" | "register" | "has lexical unit" |  | "FN" |  |
| fn:becoming_aware | fn:HasLexicalUnit | fn:lu:becoming_aware:descry | "becoming aware" | "descry" | "has lexical unit" |  | "FN" |  |
| fn:becoming_aware | fn:HasLexicalUnit | fn:lu:becoming_aware:spot | "becoming aware" | "spot" | "has lexical unit" |  | "FN" |  |
| fn:becoming_aware | fn:HasLexicalUnit | fn:lu:becoming_aware:espy | "becoming aware" | "espy" | "has lexical unit" |  | "FN" |  |
| fn:becoming_aware | fn:HasLexicalUnit | fn:lu:becoming_aware:discern | "becoming aware" | "discern" | "has lexical unit" |  | "FN" |  |
| fn:becoming_aware | fn:HasLexicalUnit | fn:lu:becoming_aware:locate | "becoming aware" | "locate" | "has lexical unit" |  | "FN" |  |
| fn:becoming_aware | fn:HasLexicalUnit | fn:lu:becoming_aware:pick_up | "becoming aware" | "pick up" | "has lexical unit" |  | "FN" |  |
| fn:becoming_aware | fn:HasLexicalUnit | fn:lu:becoming_aware:spy_out | "becoming aware" | "spy out" | "has lexical unit" |  | "FN" |  |
| fn:becoming_aware | fn:HasLexicalUnit | fn:lu:becoming_aware:chance_(on) | "becoming aware" | "chance (on)" | "has lexical unit" |  | "FN" |  |
| fn:becoming_aware | fn:HasLexicalUnit | fn:lu:becoming_aware:come_(across) | "becoming aware" | "come (across)" | "has lexical unit" |  | "FN" |  |
| fn:becoming_aware | fn:HasLexicalUnit | fn:lu:becoming_aware:come_(upon) | "becoming aware" | "come (upon)" | "has lexical unit" |  | "FN" |  |
| fn:becoming_aware | fn:HasLexicalUnit | fn:lu:becoming_aware:chance_(across) | "becoming aware" | "chance (across)" | "has lexical unit" |  | "FN" |  |
| fn:becoming_aware | fn:HasLexicalUnit | fn:lu:becoming_aware:detect | "becoming aware" | "detect" | "has lexical unit" |  | "FN" |  |
| fn:becoming_aware | fn:HasLexicalUnit | fn:lu:becoming_aware:encounter | "becoming aware" | "encounter" | "has lexical unit" |  | "FN" |  |
| fn:becoming_aware | fn:HasLexicalUnit | fn:lu:becoming_aware:fall_(on) | "becoming aware" | "fall (on)" | "has lexical unit" |  | "FN" |  |
| fn:becoming_aware | fn:HasLexicalUnit | fn:lu:becoming_aware:happen_(on) | "becoming aware" | "happen (on)" | "has lexical unit" |  | "FN" |  |
| fn:becoming_aware | fn:HasLexicalUnit | fn:lu:becoming_aware:learn | "becoming aware" | "learn" | "has lexical unit" |  | "FN" |  |
| fn:becoming_aware | fn:HasLexicalUnit | fn:lu:becoming_aware:observe | "becoming aware" | "observe" | "has lexical unit" |  | "FN" |  |
| fn:becoming_aware | fn:HasLexicalUnit | fn:lu:becoming_aware:perceive | "becoming aware" | "perceive" | "has lexical unit" |  | "FN" |  |
| fn:becoming_aware | fn:HasLexicalUnit | fn:lu:becoming_aware:find_out | "becoming aware" | "find out" | "has lexical unit" |  | "FN" |  |
| fn:becoming_aware | fn:HasLexicalUnit | fn:lu:becoming_aware:tell | "becoming aware" | "tell" | "has lexical unit" |  | "FN" |  |
| fn:becoming_aware | fn:HasLexicalUnit | fn:lu:becoming_aware:find_(oneself) | "becoming aware" | "find (oneself)" | "has lexical unit" |  | "FN" |  |
| fn:becoming_aware | /r/HasA | fn:fe:cognizer | "becoming aware" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:becoming_aware | /r/HasA | fn:fe:phenomenon | "becoming aware" | "phenomenon" | "/r/has a" |  | "FN" |  |
| fn:becoming_aware | /r/HasA | fn:fe:ground | "becoming aware" | "ground" | "/r/has a" |  | "FN" |  |
| fn:becoming_aware | /r/HasA | fn:fe:state | "becoming aware" | "state" | "/r/has a" |  | "FN" |  |
| fn:becoming_aware | /r/HasA | fn:fe:evidence | "becoming aware" | "evidence" | "/r/has a" |  | "FN" |  |
| fn:becoming_aware | /r/HasA | fn:fe:degree | "becoming aware" | "degree" | "/r/has a" |  | "FN" |  |
| fn:becoming_aware | /r/HasA | fn:fe:manner | "becoming aware" | "manner" | "/r/has a" |  | "FN" |  |
| fn:becoming_aware | /r/HasA | fn:fe:means | "becoming aware" | "means" | "/r/has a" |  | "FN" |  |
| fn:becoming_aware | /r/HasA | fn:fe:topic | "becoming aware" | "topic" | "/r/has a" |  | "FN" |  |
| fn:becoming_aware | /r/HasA | fn:fe:time | "becoming aware" | "time" | "/r/has a" |  | "FN" |  |
| fn:becoming_aware | /r/HasA | fn:fe:purpose | "becoming aware" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:becoming_aware | /r/HasA | fn:fe:instrument | "becoming aware" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:becoming_aware | /r/HasA | fn:fe:frequency | "becoming aware" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:becoming_aware | /r/HasA | fn:fe:circumstances | "becoming aware" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:becoming_aware | /r/HasA | fn:fe:explanation | "becoming aware" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:becoming_aware | /r/HasA | fn:fe:particular_iteration | "becoming aware" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:becoming_aware | /r/HasA | fn:fe:period_of_iterations | "becoming aware" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:becoming_detached | /r/IsA | fn:transition_to_a_quality | "becoming detached" | "transition to a quality" | "/r/is a" |  | "FN" |  |
| fn:becoming_detached | /r/Causes | fn:being_detached | "becoming detached" | "being detached" | "/r/causes" |  | "FN" |  |
| fn:detaching | /r/Causes | fn:becoming_detached | "detaching" | "becoming detached" | "/r/causes" |  | "FN" |  |
| fn:becoming_detached | fn:HasLexicalUnit | fn:lu:becoming_detached:detach | "becoming detached" | "detach" | "has lexical unit" |  | "FN" |  |
| fn:becoming_detached | fn:HasLexicalUnit | fn:lu:becoming_detached:decouple | "becoming detached" | "decouple" | "has lexical unit" |  | "FN" |  |
| fn:becoming_detached | fn:HasLexicalUnit | fn:lu:becoming_detached:unhook | "becoming detached" | "unhook" | "has lexical unit" |  | "FN" |  |
| fn:becoming_detached | fn:HasLexicalUnit | fn:lu:becoming_detached:unhinge | "becoming detached" | "unhinge" | "has lexical unit" |  | "FN" |  |
| fn:fe:item | /r/HasPrerequisite | fn:fe:source | "item" | "source" | "/r/has prerequisite" |  | "FN" |  |
| fn:becoming_detached | /r/HasA | fn:fe:item | "becoming detached" | "item" | "/r/has a" |  | "FN" |  |
| fn:fe:source | /r/HasPrerequisite | fn:fe:item | "source" | "item" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:source | /r/RelatedTo | fn:fe:items | "source" | "items" | "/r/related to" |  | "FN" |  |
| fn:becoming_detached | /r/HasA | fn:fe:source | "becoming detached" | "source" | "/r/has a" |  | "FN" |  |
| fn:becoming_detached | /r/HasA | fn:fe:items | "becoming detached" | "items" | "/r/has a" |  | "FN" |  |
| fn:becoming_detached | /r/HasA | fn:fe:manner | "becoming detached" | "manner" | "/r/has a" |  | "FN" |  |
| fn:becoming_detached | /r/HasA | fn:fe:place | "becoming detached" | "place" | "/r/has a" |  | "FN" |  |
| fn:becoming_detached | /r/HasA | fn:fe:time | "becoming detached" | "time" | "/r/has a" |  | "FN" |  |
| fn:becoming_detached | /r/HasA | fn:fe:degree | "becoming detached" | "degree" | "/r/has a" |  | "FN" |  |
| fn:becoming_detached | /r/HasA | fn:fe:event_description | "becoming detached" | "event description" | "/r/has a" |  | "FN" |  |
| fn:becoming_dry | /r/IsA | fn:transition_to_a_quality | "becoming dry" | "transition to a quality" | "/r/is a" |  | "FN" |  |
| fn:becoming_dry | /r/Causes | fn:being_dry | "becoming dry" | "being dry" | "/r/causes" |  | "FN" |  |
| fn:becoming_dry | fn:HasLexicalUnit | fn:lu:becoming_dry:dry_up | "becoming dry" | "dry up" | "has lexical unit" |  | "FN" |  |
| fn:becoming_dry | fn:HasLexicalUnit | fn:lu:becoming_dry:exsiccate | "becoming dry" | "exsiccate" | "has lexical unit" |  | "FN" |  |
| fn:becoming_dry | fn:HasLexicalUnit | fn:lu:becoming_dry:dehydrate | "becoming dry" | "dehydrate" | "has lexical unit" |  | "FN" |  |
| fn:becoming_dry | fn:HasLexicalUnit | fn:lu:becoming_dry:dry | "becoming dry" | "dry" | "has lexical unit" |  | "FN" |  |
| fn:becoming_dry | /r/HasA | fn:fe:entity | "becoming dry" | "entity" | "/r/has a" |  | "FN" |  |
| fn:becoming_dry | /r/HasA | fn:fe:degree | "becoming dry" | "degree" | "/r/has a" |  | "FN" |  |
| fn:becoming_dry | /r/HasA | fn:fe:manner | "becoming dry" | "manner" | "/r/has a" |  | "FN" |  |
| fn:becoming_dry | /r/HasA | fn:fe:place | "becoming dry" | "place" | "/r/has a" |  | "FN" |  |
| fn:becoming_dry | /r/HasA | fn:fe:time | "becoming dry" | "time" | "/r/has a" |  | "FN" |  |
| fn:becoming_dry | /r/HasA | fn:fe:circumstances | "becoming dry" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:becoming_dry | /r/HasA | fn:fe:concessive | "becoming dry" | "concessive" | "/r/has a" |  | "FN" |  |
| fn:becoming_dry | /r/HasA | fn:fe:particular_iteration | "becoming dry" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:fragmentation_scenario | /r/IsA | fn:becoming_separated | "fragmentation scenario" | "becoming separated" | "/r/is a" |  | "FN" |  |
| fn:separating | /r/Causes | fn:becoming_separated | "separating" | "becoming separated" | "/r/causes" |  | "FN" |  |
| fn:becoming_separated | fn:HasLexicalUnit | fn:lu:becoming_separated:separate | "becoming separated" | "separate" | "has lexical unit" |  | "FN" |  |
| fn:becoming_separated | fn:HasLexicalUnit | fn:lu:becoming_separated:split | "becoming separated" | "split" | "has lexical unit" |  | "FN" |  |
| fn:becoming_separated | fn:HasLexicalUnit | fn:lu:becoming_separated:divide | "becoming separated" | "divide" | "has lexical unit" |  | "FN" |  |
| fn:becoming_separated | /r/HasA | fn:fe:whole | "becoming separated" | "whole" | "/r/has a" |  | "FN" |  |
| fn:becoming_separated | /r/HasA | fn:fe:parts | "becoming separated" | "parts" | "/r/has a" |  | "FN" |  |
| fn:becoming_separated | /r/HasA | fn:fe:part_1 | "becoming separated" | "part 1" | "/r/has a" |  | "FN" |  |
| fn:becoming_separated | /r/HasA | fn:fe:part_2 | "becoming separated" | "part 2" | "/r/has a" |  | "FN" |  |
| fn:becoming_separated | /r/HasA | fn:fe:criterion | "becoming separated" | "criterion" | "/r/has a" |  | "FN" |  |
| fn:becoming_separated | /r/HasA | fn:fe:depictive | "becoming separated" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:becoming_separated | /r/HasA | fn:fe:manner | "becoming separated" | "manner" | "/r/has a" |  | "FN" |  |
| fn:becoming_separated | /r/HasA | fn:fe:degree | "becoming separated" | "degree" | "/r/has a" |  | "FN" |  |
| fn:becoming_separated | /r/HasA | fn:fe:means | "becoming separated" | "means" | "/r/has a" |  | "FN" |  |
| fn:becoming_separated | /r/HasA | fn:fe:result | "becoming separated" | "result" | "/r/has a" |  | "FN" |  |
| fn:becoming_separated | /r/HasA | fn:fe:time | "becoming separated" | "time" | "/r/has a" |  | "FN" |  |
| fn:becoming_separated | /r/HasA | fn:fe:place | "becoming separated" | "place" | "/r/has a" |  | "FN" |  |
| fn:silencing | /r/SimilarTo | fn:becoming_silent | "silencing" | "becoming silent" | "/r/similar to" |  | "FN" |  |
| fn:silencing | /r/Causes | fn:becoming_silent | "silencing" | "becoming silent" | "/r/causes" |  | "FN" |  |
| fn:becoming_silent | fn:HasLexicalUnit | fn:lu:becoming_silent:button_(one's)_lip | "becoming silent" | "button (one\\'s) lip" | "has lexical unit" |  | "FN" |  |
| fn:becoming_silent | fn:HasLexicalUnit | fn:lu:becoming_silent:hold_(one's)_tongue | "becoming silent" | "hold (one\\'s) tongue" | "has lexical unit" |  | "FN" |  |
| fn:becoming_silent | fn:HasLexicalUnit | fn:lu:becoming_silent:hush | "becoming silent" | "hush" | "has lexical unit" |  | "FN" |  |
| fn:becoming_silent | fn:HasLexicalUnit | fn:lu:becoming_silent:hush_up | "becoming silent" | "hush up" | "has lexical unit" |  | "FN" |  |
| fn:becoming_silent | fn:HasLexicalUnit | fn:lu:becoming_silent:quiet | "becoming silent" | "quiet" | "has lexical unit" |  | "FN" |  |
| fn:becoming_silent | fn:HasLexicalUnit | fn:lu:becoming_silent:quiet_down | "becoming silent" | "quiet down" | "has lexical unit" |  | "FN" |  |
| fn:becoming_silent | fn:HasLexicalUnit | fn:lu:becoming_silent:shush | "becoming silent" | "shush" | "has lexical unit" |  | "FN" |  |
| fn:becoming_silent | fn:HasLexicalUnit | fn:lu:becoming_silent:shut_up | "becoming silent" | "shut up" | "has lexical unit" |  | "FN" |  |
| fn:becoming_silent | fn:HasLexicalUnit | fn:lu:becoming_silent:stow_it | "becoming silent" | "stow it" | "has lexical unit" |  | "FN" |  |
| fn:becoming_silent | fn:HasLexicalUnit | fn:lu:becoming_silent:silence | "becoming silent" | "silence" | "has lexical unit" |  | "FN" |  |
| fn:becoming_silent | fn:HasLexicalUnit | fn:lu:becoming_silent:sh | "becoming silent" | "sh" | "has lexical unit" |  | "FN" |  |
| fn:becoming_silent | fn:HasLexicalUnit | fn:lu:becoming_silent:quieten | "becoming silent" | "quieten" | "has lexical unit" |  | "FN" |  |
| fn:becoming_silent | fn:HasLexicalUnit | fn:lu:becoming_silent:pipe_down | "becoming silent" | "pipe down" | "has lexical unit" |  | "FN" |  |
| fn:becoming_silent | fn:HasLexicalUnit | fn:lu:becoming_silent:quiet | "becoming silent" | "quiet" | "has lexical unit" |  | "FN" |  |
| fn:becoming_silent | fn:HasLexicalUnit | fn:lu:becoming_silent:seal_(one's)_lips | "becoming silent" | "seal (one\\'s) lips" | "has lexical unit" |  | "FN" |  |
| fn:becoming_silent | fn:HasLexicalUnit | fn:lu:becoming_silent:not_a_word | "becoming silent" | "not a word" | "has lexical unit" |  | "FN" |  |
| fn:becoming_silent | /r/HasA | fn:fe:speaker | "becoming silent" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:becoming_silent | /r/HasA | fn:fe:topic | "becoming silent" | "topic" | "/r/has a" |  | "FN" |  |
| fn:becoming_silent | /r/HasA | fn:fe:place | "becoming silent" | "place" | "/r/has a" |  | "FN" |  |
| fn:becoming_silent | /r/HasA | fn:fe:time | "becoming silent" | "time" | "/r/has a" |  | "FN" |  |
| fn:becoming_silent | /r/HasA | fn:fe:expressor | "becoming silent" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:becoming_silent | /r/HasA | fn:fe:manner | "becoming silent" | "manner" | "/r/has a" |  | "FN" |  |
| fn:becoming_silent | /r/HasA | fn:fe:explanation | "becoming silent" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:becoming_visible | /r/IsA | fn:transition_to_a_quality | "becoming visible" | "transition to a quality" | "/r/is a" |  | "FN" |  |
| fn:becoming_visible | /r/UsedFor | fn:perception | "becoming visible" | "perception" | "/r/used for" |  | "FN" |  |
| fn:becoming_visible | fn:HasLexicalUnit | fn:lu:becoming_visible:appear | "becoming visible" | "appear" | "has lexical unit" |  | "FN" |  |
| fn:becoming_visible | /r/HasA | fn:fe:entity | "becoming visible" | "entity" | "/r/has a" |  | "FN" |  |
| fn:becoming_visible | /r/HasA | fn:fe:perceiver | "becoming visible" | "perceiver" | "/r/has a" |  | "FN" |  |
| fn:becoming_visible | /r/HasA | fn:fe:manner | "becoming visible" | "manner" | "/r/has a" |  | "FN" |  |
| fn:becoming_visible | /r/HasA | fn:fe:place | "becoming visible" | "place" | "/r/has a" |  | "FN" |  |
| fn:becoming_visible | /r/HasA | fn:fe:time | "becoming visible" | "time" | "/r/has a" |  | "FN" |  |
| fn:performing_arts | /r/UsedFor | fn:behind_the_scenes | "performing arts" | "behind the scenes" | "/r/used for" |  | "FN" |  |
| fn:behind_the_scenes | fn:HasLexicalUnit | fn:lu:behind_the_scenes:film-maker | "behind the scenes" | "film-maker" | "has lexical unit" |  | "FN" |  |
| fn:behind_the_scenes | fn:HasLexicalUnit | fn:lu:behind_the_scenes:director | "behind the scenes" | "director" | "has lexical unit" |  | "FN" |  |
| fn:behind_the_scenes | fn:HasLexicalUnit | fn:lu:behind_the_scenes:producer | "behind the scenes" | "producer" | "has lexical unit" |  | "FN" |  |
| fn:behind_the_scenes | fn:HasLexicalUnit | fn:lu:behind_the_scenes:direct | "behind the scenes" | "direct" | "has lexical unit" |  | "FN" |  |
| fn:behind_the_scenes | fn:HasLexicalUnit | fn:lu:behind_the_scenes:produce | "behind the scenes" | "produce" | "has lexical unit" |  | "FN" |  |
| fn:behind_the_scenes | fn:HasLexicalUnit | fn:lu:behind_the_scenes:shoot | "behind the scenes" | "shoot" | "has lexical unit" |  | "FN" |  |
| fn:behind_the_scenes | fn:HasLexicalUnit | fn:lu:behind_the_scenes:film | "behind the scenes" | "film" | "has lexical unit" |  | "FN" |  |
| fn:behind_the_scenes | fn:HasLexicalUnit | fn:lu:behind_the_scenes:score | "behind the scenes" | "score" | "has lexical unit" |  | "FN" |  |
| fn:behind_the_scenes | fn:HasLexicalUnit | fn:lu:behind_the_scenes:soundtrack | "behind the scenes" | "soundtrack" | "has lexical unit" |  | "FN" |  |
| fn:behind_the_scenes | fn:HasLexicalUnit | fn:lu:behind_the_scenes:compose | "behind the scenes" | "compose" | "has lexical unit" |  | "FN" |  |
| fn:behind_the_scenes | fn:HasLexicalUnit | fn:lu:behind_the_scenes:stage | "behind the scenes" | "stage" | "has lexical unit" |  | "FN" |  |
| fn:behind_the_scenes | fn:HasLexicalUnit | fn:lu:behind_the_scenes:cast | "behind the scenes" | "cast" | "has lexical unit" |  | "FN" |  |
| fn:behind_the_scenes | /r/HasA | fn:fe:artist | "behind the scenes" | "artist" | "/r/has a" |  | "FN" |  |
| fn:behind_the_scenes | /r/HasA | fn:fe:production | "behind the scenes" | "production" | "/r/has a" |  | "FN" |  |
| fn:behind_the_scenes | /r/HasA | fn:fe:type | "behind the scenes" | "type" | "/r/has a" |  | "FN" |  |
| fn:behind_the_scenes | /r/HasA | fn:fe:distributor | "behind the scenes" | "distributor" | "/r/has a" |  | "FN" |  |
| fn:behind_the_scenes | /r/HasA | fn:fe:studio | "behind the scenes" | "studio" | "/r/has a" |  | "FN" |  |
| fn:behind_the_scenes | /r/HasA | fn:fe:medium | "behind the scenes" | "medium" | "/r/has a" |  | "FN" |  |
| fn:behind_the_scenes | /r/HasA | fn:fe:time | "behind the scenes" | "time" | "/r/has a" |  | "FN" |  |
| fn:behind_the_scenes | /r/HasA | fn:fe:place | "behind the scenes" | "place" | "/r/has a" |  | "FN" |  |
| fn:behind_the_scenes | /r/HasA | fn:fe:nationality | "behind the scenes" | "nationality" | "/r/has a" |  | "FN" |  |
| fn:behind_the_scenes | /r/HasA | fn:fe:purpose | "behind the scenes" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:behind_the_scenes | /r/HasA | fn:fe:performer | "behind the scenes" | "performer" | "/r/has a" |  | "FN" |  |
| fn:behind_the_scenes | /r/HasA | fn:fe:score | "behind the scenes" | "score" | "/r/has a" |  | "FN" |  |
| fn:behind_the_scenes | /r/HasA | fn:fe:scene | "behind the scenes" | "scene" | "/r/has a" |  | "FN" |  |
| fn:behind_the_scenes | /r/HasA | fn:fe:manner | "behind the scenes" | "manner" | "/r/has a" |  | "FN" |  |
| fn:being_active | /r/IsA | fn:gradable_attributes | "being active" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:activity_ongoing | /r/UsedFor | fn:being_active | "activity ongoing" | "being active" | "/r/used for" |  | "FN" |  |
| fn:being_active | fn:HasLexicalUnit | fn:lu:being_active:active | "being active" | "active" | "has lexical unit" |  | "FN" |  |
| fn:being_active | fn:HasLexicalUnit | fn:lu:being_active:inactive | "being active" | "inactive" | "has lexical unit" |  | "FN" |  |
| fn:being_active | fn:HasLexicalUnit | fn:lu:being_active:actively | "being active" | "actively" | "has lexical unit" |  | "FN" |  |
| fn:being_active | /r/HasA | fn:fe:duration | "being active" | "duration" | "/r/has a" |  | "FN" |  |
| fn:fe:activity | /r/RelatedTo | fn:fe:role | "activity" | "role" | "/r/related to" |  | "FN" |  |
| fn:being_active | /r/HasA | fn:fe:activity | "being active" | "activity" | "/r/has a" |  | "FN" |  |
| fn:being_active | /r/HasA | fn:fe:place | "being active" | "place" | "/r/has a" |  | "FN" |  |
| fn:being_active | /r/HasA | fn:fe:purpose | "being active" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:being_active | /r/HasA | fn:fe:time | "being active" | "time" | "/r/has a" |  | "FN" |  |
| fn:being_active | /r/HasA | fn:fe:manner | "being active" | "manner" | "/r/has a" |  | "FN" |  |
| fn:being_active | /r/HasA | fn:fe:agent | "being active" | "agent" | "/r/has a" |  | "FN" |  |
| fn:fe:salient_entity | /r/RelatedTo | fn:fe:agent | "salient entity" | "agent" | "/r/related to" |  | "FN" |  |
| fn:being_active | /r/HasA | fn:fe:salient_entity | "being active" | "salient entity" | "/r/has a" |  | "FN" |  |
| fn:being_active | /r/HasA | fn:fe:role | "being active" | "role" | "/r/has a" |  | "FN" |  |
| fn:being_active | /r/HasA | fn:fe:degree | "being active" | "degree" | "/r/has a" |  | "FN" |  |
| fn:being_active | /r/HasA | fn:fe:event_description | "being active" | "event description" | "/r/has a" |  | "FN" |  |
| fn:being_active | /r/HasA | fn:fe:frequency | "being active" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:being_active | /r/HasA | fn:fe:depictive | "being active" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:being_active | /r/HasA | fn:fe:circumstances | "being active" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:being_active | /r/HasA | fn:fe:explanation | "being active" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:being_active | /r/HasA | fn:fe:iterations | "being active" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:precariousness | /r/IsA | fn:being_at_risk | "precariousness" | "being at risk" | "/r/is a" |  | "FN" |  |
| fn:being_at_risk | /r/IsA | fn:gradable_attributes | "being at risk" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:run_risk | /r/RelatedTo | fn:being_at_risk | "run risk" | "being at risk" | "/r/related to" |  | "FN" |  |
| fn:run_risk | /r/SimilarTo | fn:being_at_risk | "run risk" | "being at risk" | "/r/similar to" |  | "FN" |  |
| fn:endangering | /r/Causes | fn:being_at_risk | "endangering" | "being at risk" | "/r/causes" |  | "FN" |  |
| fn:being_at_risk | /r/IsA | fn:risk_scenario | "being at risk" | "risk scenario" | "/r/is a" |  | "FN" |  |
| fn:being_at_risk | fn:HasLexicalUnit | fn:lu:being_at_risk:secure | "being at risk" | "secure" | "has lexical unit" |  | "FN" |  |
| fn:being_at_risk | fn:HasLexicalUnit | fn:lu:being_at_risk:security | "being at risk" | "security" | "has lexical unit" |  | "FN" |  |
| fn:being_at_risk | fn:HasLexicalUnit | fn:lu:being_at_risk:safe | "being at risk" | "safe" | "has lexical unit" |  | "FN" |  |
| fn:being_at_risk | fn:HasLexicalUnit | fn:lu:being_at_risk:insecure | "being at risk" | "insecure" | "has lexical unit" |  | "FN" |  |
| fn:being_at_risk | fn:HasLexicalUnit | fn:lu:being_at_risk:unsafe | "being at risk" | "unsafe" | "has lexical unit" |  | "FN" |  |
| fn:being_at_risk | fn:HasLexicalUnit | fn:lu:being_at_risk:safety | "being at risk" | "safety" | "has lexical unit" |  | "FN" |  |
| fn:being_at_risk | fn:HasLexicalUnit | fn:lu:being_at_risk:risk | "being at risk" | "risk" | "has lexical unit" |  | "FN" |  |
| fn:being_at_risk | fn:HasLexicalUnit | fn:lu:being_at_risk:vulnerable | "being at risk" | "vulnerable" | "has lexical unit" |  | "FN" |  |
| fn:being_at_risk | fn:HasLexicalUnit | fn:lu:being_at_risk:vulnerability | "being at risk" | "vulnerability" | "has lexical unit" |  | "FN" |  |
| fn:being_at_risk | fn:HasLexicalUnit | fn:lu:being_at_risk:danger | "being at risk" | "danger" | "has lexical unit" |  | "FN" |  |
| fn:being_at_risk | fn:HasLexicalUnit | fn:lu:being_at_risk:threatened | "being at risk" | "threatened" | "has lexical unit" |  | "FN" |  |
| fn:being_at_risk | fn:HasLexicalUnit | fn:lu:being_at_risk:susceptibility | "being at risk" | "susceptibility" | "has lexical unit" |  | "FN" |  |
| fn:being_at_risk | fn:HasLexicalUnit | fn:lu:being_at_risk:susceptible | "being at risk" | "susceptible" | "has lexical unit" |  | "FN" |  |
| fn:being_at_risk | /r/HasA | fn:fe:asset | "being at risk" | "asset" | "/r/has a" |  | "FN" |  |
| fn:being_at_risk | /r/HasA | fn:fe:degree | "being at risk" | "degree" | "/r/has a" |  | "FN" |  |
| fn:fe:harmful_event | /r/RelatedTo | fn:fe:dangerous_entity | "harmful event" | "dangerous entity" | "/r/related to" |  | "FN" |  |
| fn:being_at_risk | /r/HasA | fn:fe:harmful_event | "being at risk" | "harmful event" | "/r/has a" |  | "FN" |  |
| fn:being_at_risk | /r/HasA | fn:fe:dangerous_entity | "being at risk" | "dangerous entity" | "/r/has a" |  | "FN" |  |
| fn:being_at_risk | /r/HasA | fn:fe:place | "being at risk" | "place" | "/r/has a" |  | "FN" |  |
| fn:being_at_risk | /r/HasA | fn:fe:time | "being at risk" | "time" | "/r/has a" |  | "FN" |  |
| fn:being_at_risk | /r/HasA | fn:fe:explanation | "being at risk" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:being_at_risk | /r/HasA | fn:fe:situation | "being at risk" | "situation" | "/r/has a" |  | "FN" |  |
| fn:being_at_risk | /r/HasA | fn:fe:domain | "being at risk" | "domain" | "/r/has a" |  | "FN" |  |
| fn:being_at_risk | /r/HasA | fn:fe:depictive | "being at risk" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:being_at_risk | /r/HasA | fn:fe:frequency | "being at risk" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:being_at_risk | /r/HasA | fn:fe:duration | "being at risk" | "duration" | "/r/has a" |  | "FN" |  |
| fn:being_attached | /r/IsA | fn:reciprocality | "being attached" | "reciprocality" | "/r/is a" |  | "FN" |  |
| fn:being_attached | /r/IsA | fn:state | "being attached" | "state" | "/r/is a" |  | "FN" |  |
| fn:being_attached | /r/UsedFor | fn:being_detached | "being attached" | "being detached" | "/r/used for" |  | "FN" |  |
| fn:becoming_attached | /r/Causes | fn:being_attached | "becoming attached" | "being attached" | "/r/causes" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:attached | "being attached" | "attached" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:tied | "being attached" | "tied" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:bolted | "being attached" | "bolted" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:glued | "being attached" | "glued" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:affixed | "being attached" | "affixed" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:anchored | "being attached" | "anchored" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:bound | "being attached" | "bound" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:chained | "being attached" | "chained" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:fastened | "being attached" | "fastened" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:fused | "being attached" | "fused" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:handcuffed | "being attached" | "handcuffed" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:lashed | "being attached" | "lashed" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:manacled | "being attached" | "manacled" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:moored | "being attached" | "moored" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:nailed | "being attached" | "nailed" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:pasted | "being attached" | "pasted" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:pinned | "being attached" | "pinned" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:riveted | "being attached" | "riveted" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:sewn | "being attached" | "sewn" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:shackled | "being attached" | "shackled" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:stapled | "being attached" | "stapled" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:stuck | "being attached" | "stuck" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:tethered | "being attached" | "tethered" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:welded | "being attached" | "welded" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:stick | "being attached" | "stick" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:taped | "being attached" | "taped" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:plastered | "being attached" | "plastered" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:adhere | "being attached" | "adhere" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:adhesion | "being attached" | "adhesion" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:connected | "being attached" | "connected" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | fn:HasLexicalUnit | fn:lu:being_attached:linked | "being attached" | "linked" | "has lexical unit" |  | "FN" |  |
| fn:being_attached | /r/HasA | fn:fe:connector | "being attached" | "connector" | "/r/has a" |  | "FN" |  |
| fn:being_attached | /r/HasA | fn:fe:handle | "being attached" | "handle" | "/r/has a" |  | "FN" |  |
| fn:being_attached | /r/HasA | fn:fe:item | "being attached" | "item" | "/r/has a" |  | "FN" |  |
| fn:being_attached | /r/HasA | fn:fe:items | "being attached" | "items" | "/r/has a" |  | "FN" |  |
| fn:being_attached | /r/HasA | fn:fe:goal | "being attached" | "goal" | "/r/has a" |  | "FN" |  |
| fn:being_attached | /r/HasA | fn:fe:dependent_state | "being attached" | "dependent state" | "/r/has a" |  | "FN" |  |
| fn:being_attached | /r/HasA | fn:fe:manner | "being attached" | "manner" | "/r/has a" |  | "FN" |  |
| fn:sleep_wake_cycle | /r/HasSubevent | fn:being_awake | "sleep wake cycle" | "being awake" | "/r/has subevent" |  | "FN" |  |
| fn:cause_to_wake | /r/Causes | fn:being_awake | "cause to wake" | "being awake" | "/r/causes" |  | "FN" |  |
| fn:fall_asleep | /r/HasPrerequisite | fn:being_awake | "fall asleep" | "being awake" | "/r/has prerequisite" |  | "FN" |  |
| fn:getting_up | /r/HasPrerequisite | fn:being_awake | "getting up" | "being awake" | "/r/has prerequisite" |  | "FN" |  |
| fn:being_awake | /r/HasPrerequisite | fn:waking_up | "being awake" | "waking up" | "/r/has prerequisite" |  | "FN" |  |
| fn:being_awake | fn:HasLexicalUnit | fn:lu:being_awake:awake | "being awake" | "awake" | "has lexical unit" |  | "FN" |  |
| fn:being_awake | fn:HasLexicalUnit | fn:lu:being_awake:conscious | "being awake" | "conscious" | "has lexical unit" |  | "FN" |  |
| fn:being_awake | fn:HasLexicalUnit | fn:lu:being_awake:wakeful | "being awake" | "wakeful" | "has lexical unit" |  | "FN" |  |
| fn:being_awake | fn:HasLexicalUnit | fn:lu:being_awake:watch | "being awake" | "watch" | "has lexical unit" |  | "FN" |  |
| fn:being_awake | /r/HasA | fn:fe:protagonist | "being awake" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:being_awake | /r/HasA | fn:fe:duration | "being awake" | "duration" | "/r/has a" |  | "FN" |  |
| fn:being_awake | /r/HasA | fn:fe:time | "being awake" | "time" | "/r/has a" |  | "FN" |  |
| fn:being_awake | /r/HasA | fn:fe:place | "being awake" | "place" | "/r/has a" |  | "FN" |  |
| fn:being_awake | /r/HasA | fn:fe:degree | "being awake" | "degree" | "/r/has a" |  | "FN" |  |
| fn:being_awake | /r/HasA | fn:fe:manner | "being awake" | "manner" | "/r/has a" |  | "FN" |  |
| fn:being_born | /r/IsA | fn:coming_to_be | "being born" | "coming to be" | "/r/is a" |  | "FN" |  |
| fn:cycle_of_life_and_death | /r/HasSubevent | fn:being_born | "cycle of life and death" | "being born" | "/r/has subevent" |  | "FN" |  |
| fn:giving_birth | /r/SimilarTo | fn:being_born | "giving birth" | "being born" | "/r/similar to" |  | "FN" |  |
| fn:death | /r/HasPrerequisite | fn:being_born | "death" | "being born" | "/r/has prerequisite" |  | "FN" |  |
| fn:dying | /r/HasPrerequisite | fn:being_born | "dying" | "being born" | "/r/has prerequisite" |  | "FN" |  |
| fn:being_born | /r/IsA | fn:birth_scenario | "being born" | "birth scenario" | "/r/is a" |  | "FN" |  |
| fn:being_born | fn:HasLexicalUnit | fn:lu:being_born:come_into_the_world | "being born" | "come into the world" | "has lexical unit" |  | "FN" |  |
| fn:being_born | fn:HasLexicalUnit | fn:lu:being_born:born | "being born" | "born" | "has lexical unit" |  | "FN" |  |
| fn:being_born | /r/HasA | fn:fe:child | "being born" | "child" | "/r/has a" |  | "FN" |  |
| fn:being_born | /r/HasA | fn:fe:time | "being born" | "time" | "/r/has a" |  | "FN" |  |
| fn:being_born | /r/HasA | fn:fe:place | "being born" | "place" | "/r/has a" |  | "FN" |  |
| fn:being_born | /r/HasA | fn:fe:relatives | "being born" | "relatives" | "/r/has a" |  | "FN" |  |
| fn:being_born | /r/HasA | fn:fe:depictive | "being born" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:being_born | /r/HasA | fn:fe:means | "being born" | "means" | "/r/has a" |  | "FN" |  |
| fn:being_contained_within | /r/IsA | fn:interior_profile_relation | "being contained within" | "interior profile relation" | "/r/is a" |  | "FN" |  |
| fn:being_contained_within | /r/IsA | fn:containment_scenario | "being contained within" | "containment scenario" | "/r/is a" |  | "FN" |  |
| fn:being_contained_within | /r/HasA | fn:fe:profiled_region | "being contained within" | "profiled region" | "/r/has a" |  | "FN" |  |
| fn:being_contained_within | /r/HasA | fn:fe:landmark | "being contained within" | "landmark" | "/r/has a" |  | "FN" |  |
| fn:being_contained_within | /r/HasA | fn:fe:trajector | "being contained within" | "trajector" | "/r/has a" |  | "FN" |  |
| fn:being_contained_within | /r/HasA | fn:fe:time | "being contained within" | "time" | "/r/has a" |  | "FN" |  |
| fn:being_attached | /r/UsedFor | fn:being_detached | "being attached" | "being detached" | "/r/used for" |  | "FN" |  |
| fn:becoming_detached | /r/Causes | fn:being_detached | "becoming detached" | "being detached" | "/r/causes" |  | "FN" |  |
| fn:being_detached | fn:HasLexicalUnit | fn:lu:being_detached:detached | "being detached" | "detached" | "has lexical unit" |  | "FN" |  |
| fn:being_detached | fn:HasLexicalUnit | fn:lu:being_detached:disconnected | "being detached" | "disconnected" | "has lexical unit" |  | "FN" |  |
| fn:being_detached | fn:HasLexicalUnit | fn:lu:being_detached:loose | "being detached" | "loose" | "has lexical unit" |  | "FN" |  |
| fn:being_detached | fn:HasLexicalUnit | fn:lu:being_detached:unfused | "being detached" | "unfused" | "has lexical unit" |  | "FN" |  |
| fn:being_detached | fn:HasLexicalUnit | fn:lu:being_detached:unmoored | "being detached" | "unmoored" | "has lexical unit" |  | "FN" |  |
| fn:being_detached | fn:HasLexicalUnit | fn:lu:being_detached:unattached | "being detached" | "unattached" | "has lexical unit" |  | "FN" |  |
| fn:being_detached | /r/HasA | fn:fe:item | "being detached" | "item" | "/r/has a" |  | "FN" |  |
| fn:being_detached | /r/HasA | fn:fe:items | "being detached" | "items" | "/r/has a" |  | "FN" |  |
| fn:being_detached | /r/HasA | fn:fe:source | "being detached" | "source" | "/r/has a" |  | "FN" |  |
| fn:being_detached | /r/HasA | fn:fe:manner | "being detached" | "manner" | "/r/has a" |  | "FN" |  |
| fn:being_dry | /r/IsA | fn:gradable_attributes | "being dry" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:becoming_dry | /r/Causes | fn:being_dry | "becoming dry" | "being dry" | "/r/causes" |  | "FN" |  |
| fn:cause_to_be_dry | /r/Causes | fn:being_dry | "cause to be dry" | "being dry" | "/r/causes" |  | "FN" |  |
| fn:being_dry | fn:HasLexicalUnit | fn:lu:being_dry:dry | "being dry" | "dry" | "has lexical unit" |  | "FN" |  |
| fn:being_dry | fn:HasLexicalUnit | fn:lu:being_dry:parched | "being dry" | "parched" | "has lexical unit" |  | "FN" |  |
| fn:being_dry | fn:HasLexicalUnit | fn:lu:being_dry:desiccated | "being dry" | "desiccated" | "has lexical unit" |  | "FN" |  |
| fn:being_dry | fn:HasLexicalUnit | fn:lu:being_dry:waterless | "being dry" | "waterless" | "has lexical unit" |  | "FN" |  |
| fn:being_dry | fn:HasLexicalUnit | fn:lu:being_dry:dehydrated | "being dry" | "dehydrated" | "has lexical unit" |  | "FN" |  |
| fn:being_dry | /r/HasA | fn:fe:item | "being dry" | "item" | "/r/has a" |  | "FN" |  |
| fn:being_dry | /r/HasA | fn:fe:degree | "being dry" | "degree" | "/r/has a" |  | "FN" |  |
| fn:being_dry | /r/HasA | fn:fe:subregion | "being dry" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:employee_scenario | /r/HasSubevent | fn:being_employed | "employee scenario" | "being employed" | "/r/has subevent" |  | "FN" |  |
| fn:being_employed | /r/SimilarTo | fn:people_by_vocation | "being employed" | "people by vocation" | "/r/similar to" |  | "FN" |  |
| fn:quitting | /r/HasPrerequisite | fn:being_employed | "quitting" | "being employed" | "/r/has prerequisite" |  | "FN" |  |
| fn:being_employed | /r/HasPrerequisite | fn:get_a_job | "being employed" | "get a job" | "/r/has prerequisite" |  | "FN" |  |
| fn:being_employed | /r/IsA | fn:employment_continue | "being employed" | "employment continue" | "/r/is a" |  | "FN" |  |
| fn:being_employed | fn:HasLexicalUnit | fn:lu:being_employed:work | "being employed" | "work" | "has lexical unit" |  | "FN" |  |
| fn:being_employed | fn:HasLexicalUnit | fn:lu:being_employed:work | "being employed" | "work" | "has lexical unit" |  | "FN" |  |
| fn:being_employed | fn:HasLexicalUnit | fn:lu:being_employed:employ | "being employed" | "employ" | "has lexical unit" |  | "FN" |  |
| fn:being_employed | fn:HasLexicalUnit | fn:lu:being_employed:wait_tables | "being employed" | "wait tables" | "has lexical unit" |  | "FN" |  |
| fn:being_employed | fn:HasLexicalUnit | fn:lu:being_employed:job | "being employed" | "job" | "has lexical unit" |  | "FN" |  |
| fn:being_employed | fn:HasLexicalUnit | fn:lu:being_employed:clerk | "being employed" | "clerk" | "has lexical unit" |  | "FN" |  |
| fn:being_employed | fn:HasLexicalUnit | fn:lu:being_employed:temp | "being employed" | "temp" | "has lexical unit" |  | "FN" |  |
| fn:being_employed | fn:HasLexicalUnit | fn:lu:being_employed:stint | "being employed" | "stint" | "has lexical unit" |  | "FN" |  |
| fn:being_employed | fn:HasLexicalUnit | fn:lu:being_employed:employed | "being employed" | "employed" | "has lexical unit" |  | "FN" |  |
| fn:being_employed | fn:HasLexicalUnit | fn:lu:being_employed:subcontract | "being employed" | "subcontract" | "has lexical unit" |  | "FN" |  |
| fn:being_employed | fn:HasLexicalUnit | fn:lu:being_employed:farm_(out) | "being employed" | "farm (out)" | "has lexical unit" |  | "FN" |  |
| fn:being_employed | fn:HasLexicalUnit | fn:lu:being_employed:employment | "being employed" | "employment" | "has lexical unit" |  | "FN" |  |
| fn:being_employed | fn:HasLexicalUnit | fn:lu:being_employed:unemployment | "being employed" | "unemployment" | "has lexical unit" |  | "FN" |  |
| fn:being_employed | fn:HasLexicalUnit | fn:lu:being_employed:unemployed | "being employed" | "unemployed" | "has lexical unit" |  | "FN" |  |
| fn:being_employed | fn:HasLexicalUnit | fn:lu:being_employed:jobless | "being employed" | "jobless" | "has lexical unit" |  | "FN" |  |
| fn:being_employed | fn:HasLexicalUnit | fn:lu:being_employed:position | "being employed" | "position" | "has lexical unit" |  | "FN" |  |
| fn:being_employed | fn:HasLexicalUnit | fn:lu:being_employed:at | "being employed" | "at" | "has lexical unit" |  | "FN" |  |
| fn:being_employed | /r/HasA | fn:fe:compensation | "being employed" | "compensation" | "/r/has a" |  | "FN" |  |
| fn:being_employed | /r/HasA | fn:fe:employee | "being employed" | "employee" | "/r/has a" |  | "FN" |  |
| fn:being_employed | /r/HasA | fn:fe:employer | "being employed" | "employer" | "/r/has a" |  | "FN" |  |
| fn:being_employed | /r/HasA | fn:fe:manner | "being employed" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fe:place_of_employment | /r/IsA | fn:st:location | "place of employment" | "location" | "/r/is a" |  | "FN" |  |
| fn:being_employed | /r/HasA | fn:fe:place_of_employment | "being employed" | "place of employment" | "/r/has a" |  | "FN" |  |
| fn:being_employed | /r/HasA | fn:fe:position | "being employed" | "position" | "/r/has a" |  | "FN" |  |
| fn:being_employed | /r/HasA | fn:fe:purpose | "being employed" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:being_employed | /r/HasA | fn:fe:task | "being employed" | "task" | "/r/has a" |  | "FN" |  |
| fn:being_employed | /r/HasA | fn:fe:time | "being employed" | "time" | "/r/has a" |  | "FN" |  |
| fn:being_employed | /r/HasA | fn:fe:field | "being employed" | "field" | "/r/has a" |  | "FN" |  |
| fn:being_employed | /r/HasA | fn:fe:duration | "being employed" | "duration" | "/r/has a" |  | "FN" |  |
| fn:being_employed | /r/HasA | fn:fe:rank | "being employed" | "rank" | "/r/has a" |  | "FN" |  |
| fn:being_employed | /r/HasA | fn:fe:type | "being employed" | "type" | "/r/has a" |  | "FN" |  |
| fn:being_employed | /r/HasA | fn:fe:contract_basis | "being employed" | "contract basis" | "/r/has a" |  | "FN" |  |
| fn:being_employed | /r/HasA | fn:fe:place | "being employed" | "place" | "/r/has a" |  | "FN" |  |
| fn:being_employed | /r/HasA | fn:fe:frequency | "being employed" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:being_employed | /r/HasA | fn:fe:event_description | "being employed" | "event description" | "/r/has a" |  | "FN" |  |
| fn:being_employed | /r/HasA | fn:fe:circumstances | "being employed" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:being_employed | /r/HasA | fn:fe:particular_iteration | "being employed" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:being_incarcerated | /r/IsA | fn:being_in_captivity | "being incarcerated" | "being in captivity" | "/r/is a" |  | "FN" |  |
| fn:inhibit_movement | /r/UsedFor | fn:being_in_captivity | "inhibit movement" | "being in captivity" | "/r/used for" |  | "FN" |  |
| fn:being_in_captivity | fn:HasLexicalUnit | fn:lu:being_in_captivity:captivity | "being in captivity" | "captivity" | "has lexical unit" |  | "FN" |  |
| fn:being_in_captivity | fn:HasLexicalUnit | fn:lu:being_in_captivity:prisoner | "being in captivity" | "prisoner" | "has lexical unit" |  | "FN" |  |
| fn:being_in_captivity | /r/HasA | fn:fe:theme | "being in captivity" | "theme" | "/r/has a" |  | "FN" |  |
| fn:fe:holding_location | /r/IsA | fn:st:goal | "holding location" | "goal" | "/r/is a" |  | "FN" |  |
| fn:being_in_captivity | /r/HasA | fn:fe:holding_location | "being in captivity" | "holding location" | "/r/has a" |  | "FN" |  |
| fn:being_in_captivity | /r/HasA | fn:fe:agent | "being in captivity" | "agent" | "/r/has a" |  | "FN" |  |
| fn:being_in_captivity | /r/HasA | fn:fe:reciprocation | "being in captivity" | "reciprocation" | "/r/has a" |  | "FN" |  |
| fn:being_in_captivity | /r/HasA | fn:fe:place | "being in captivity" | "place" | "/r/has a" |  | "FN" |  |
| fn:being_in_captivity | /r/HasA | fn:fe:time | "being in captivity" | "time" | "/r/has a" |  | "FN" |  |
| fn:being_in_captivity | /r/HasA | fn:fe:manner | "being in captivity" | "manner" | "/r/has a" |  | "FN" |  |
| fn:being_in_captivity | /r/HasA | fn:fe:explanation | "being in captivity" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:being_in_captivity | /r/HasA | fn:fe:duration | "being in captivity" | "duration" | "/r/has a" |  | "FN" |  |
| fn:fe:cause | /r/RelatedTo | fn:fe:agent | "cause" | "agent" | "/r/related to" |  | "FN" |  |
| fn:being_in_captivity | /r/HasA | fn:fe:cause | "being in captivity" | "cause" | "/r/has a" |  | "FN" |  |
| fn:categorization | /r/UsedFor | fn:being_in_category | "categorization" | "being in category" | "/r/used for" |  | "FN" |  |
| fn:being_in_category | fn:HasLexicalUnit | fn:lu:being_in_category:tantamount | "being in category" | "tantamount" | "has lexical unit" |  | "FN" |  |
| fn:being_in_category | fn:HasLexicalUnit | fn:lu:being_in_category:count | "being in category" | "count" | "has lexical unit" |  | "FN" |  |
| fn:being_in_category | fn:HasLexicalUnit | fn:lu:being_in_category:amount | "being in category" | "amount" | "has lexical unit" |  | "FN" |  |
| fn:being_in_category | fn:HasLexicalUnit | fn:lu:being_in_category:constitute | "being in category" | "constitute" | "has lexical unit" |  | "FN" |  |
| fn:being_in_category | /r/HasA | fn:fe:cognizer | "being in category" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:being_in_category | /r/HasA | fn:fe:item | "being in category" | "item" | "/r/has a" |  | "FN" |  |
| fn:being_in_category | /r/HasA | fn:fe:category | "being in category" | "category" | "/r/has a" |  | "FN" |  |
| fn:being_in_category | /r/HasA | fn:fe:criteria | "being in category" | "criteria" | "/r/has a" |  | "FN" |  |
| fn:being_in_category | /r/HasA | fn:fe:manner | "being in category" | "manner" | "/r/has a" |  | "FN" |  |
| fn:being_in_category | /r/HasA | fn:fe:means | "being in category" | "means" | "/r/has a" |  | "FN" |  |
| fn:being_in_category | /r/HasA | fn:fe:time | "being in category" | "time" | "/r/has a" |  | "FN" |  |
| fn:being_in_category | /r/HasA | fn:fe:circumstances | "being in category" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:dominate_competitor | /r/IsA | fn:being_in_control | "dominate competitor" | "being in control" | "/r/is a" |  | "FN" |  |
| fn:being_in_control | /r/IsA | fn:control | "being in control" | "control" | "/r/is a" |  | "FN" |  |
| fn:being_in_control | /r/UsedFor | fn:kidnapping | "being in control" | "kidnapping" | "/r/used for" |  | "FN" |  |
| fn:control | /r/SimilarTo | fn:being_in_control | "control" | "being in control" | "/r/similar to" |  | "FN" |  |
| fn:being_in_control | fn:HasLexicalUnit | fn:lu:being_in_control:control | "being in control" | "control" | "has lexical unit" |  | "FN" |  |
| fn:being_in_control | fn:HasLexicalUnit | fn:lu:being_in_control:dominate | "being in control" | "dominate" | "has lexical unit" |  | "FN" |  |
| fn:being_in_control | fn:HasLexicalUnit | fn:lu:being_in_control:domination | "being in control" | "domination" | "has lexical unit" |  | "FN" |  |
| fn:being_in_control | fn:HasLexicalUnit | fn:lu:being_in_control:manage | "being in control" | "manage" | "has lexical unit" |  | "FN" |  |
| fn:being_in_control | fn:HasLexicalUnit | fn:lu:being_in_control:management | "being in control" | "management" | "has lexical unit" |  | "FN" |  |
| fn:being_in_control | fn:HasLexicalUnit | fn:lu:being_in_control:manipulate | "being in control" | "manipulate" | "has lexical unit" |  | "FN" |  |
| fn:being_in_control | fn:HasLexicalUnit | fn:lu:being_in_control:manipulation | "being in control" | "manipulation" | "has lexical unit" |  | "FN" |  |
| fn:being_in_control | fn:HasLexicalUnit | fn:lu:being_in_control:rule | "being in control" | "rule" | "has lexical unit" |  | "FN" |  |
| fn:being_in_control | fn:HasLexicalUnit | fn:lu:being_in_control:control | "being in control" | "control" | "has lexical unit" |  | "FN" |  |
| fn:being_in_control | /r/HasA | fn:fe:controlling_entity | "being in control" | "controlling entity" | "/r/has a" |  | "FN" |  |
| fn:fe:dependent_entity | /r/RelatedTo | fn:fe:dependent_situation | "dependent entity" | "dependent situation" | "/r/related to" |  | "FN" |  |
| fn:being_in_control | /r/HasA | fn:fe:dependent_entity | "being in control" | "dependent entity" | "/r/has a" |  | "FN" |  |
| fn:fe:dependent_situation | /r/RelatedTo | fn:fe:dependent_variable | "dependent situation" | "dependent variable" | "/r/related to" |  | "FN" |  |
| fn:being_in_control | /r/HasA | fn:fe:dependent_situation | "being in control" | "dependent situation" | "/r/has a" |  | "FN" |  |
| fn:fe:dependent_variable | /r/RelatedTo | fn:fe:dependent_entity | "dependent variable" | "dependent entity" | "/r/related to" |  | "FN" |  |
| fn:being_in_control | /r/HasA | fn:fe:dependent_variable | "being in control" | "dependent variable" | "/r/has a" |  | "FN" |  |
| fn:being_in_control | /r/HasA | fn:fe:degree | "being in control" | "degree" | "/r/has a" |  | "FN" |  |
| fn:being_in_control | /r/HasA | fn:fe:time | "being in control" | "time" | "/r/has a" |  | "FN" |  |
| fn:being_in_control | /r/HasA | fn:fe:place | "being in control" | "place" | "/r/has a" |  | "FN" |  |
| fn:being_in_control | /r/HasA | fn:fe:manner | "being in control" | "manner" | "/r/has a" |  | "FN" |  |
| fn:being_in_control | /r/HasA | fn:fe:concessive | "being in control" | "concessive" | "/r/has a" |  | "FN" |  |
| fn:being_in_effect | /r/UsedFor | fn:enforcing | "being in effect" | "enforcing" | "/r/used for" |  | "FN" |  |
| fn:obligation_scenario | /r/UsedFor | fn:being_in_effect | "obligation scenario" | "being in effect" | "/r/used for" |  | "FN" |  |
| fn:being_in_effect | /r/RelatedTo | fn:execute_plan | "being in effect" | "execute plan" | "/r/related to" |  | "FN" |  |
| fn:come_into_effect | /r/Causes | fn:being_in_effect | "come into effect" | "being in effect" | "/r/causes" |  | "FN" |  |
| fn:being_in_effect | fn:HasLexicalUnit | fn:lu:being_in_effect:effective | "being in effect" | "effective" | "has lexical unit" |  | "FN" |  |
| fn:being_in_effect | fn:HasLexicalUnit | fn:lu:being_in_effect:effect | "being in effect" | "effect" | "has lexical unit" |  | "FN" |  |
| fn:being_in_effect | fn:HasLexicalUnit | fn:lu:being_in_effect:force | "being in effect" | "force" | "has lexical unit" |  | "FN" |  |
| fn:being_in_effect | fn:HasLexicalUnit | fn:lu:being_in_effect:valid | "being in effect" | "valid" | "has lexical unit" |  | "FN" |  |
| fn:being_in_effect | fn:HasLexicalUnit | fn:lu:being_in_effect:void | "being in effect" | "void" | "has lexical unit" |  | "FN" |  |
| fn:being_in_effect | fn:HasLexicalUnit | fn:lu:being_in_effect:null | "being in effect" | "null" | "has lexical unit" |  | "FN" |  |
| fn:being_in_effect | fn:HasLexicalUnit | fn:lu:being_in_effect:binding | "being in effect" | "binding" | "has lexical unit" |  | "FN" |  |
| fn:being_in_effect | /r/HasA | fn:fe:binding_principle | "being in effect" | "binding principle" | "/r/has a" |  | "FN" |  |
| fn:being_in_effect | /r/HasA | fn:fe:duration | "being in effect" | "duration" | "/r/has a" |  | "FN" |  |
| fn:being_in_effect | /r/HasA | fn:fe:time | "being in effect" | "time" | "/r/has a" |  | "FN" |  |
| fn:being_in_effect | /r/HasA | fn:fe:place | "being in effect" | "place" | "/r/has a" |  | "FN" |  |
| fn:being_in_effect | /r/HasA | fn:fe:circumstances | "being in effect" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:being_in_effect | /r/HasA | fn:fe:explanation | "being in effect" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:being_in_effect | /r/HasA | fn:fe:obligated_party | "being in effect" | "obligated party" | "/r/has a" |  | "FN" |  |
| fn:being_in_effect | /r/HasA | fn:fe:degree | "being in effect" | "degree" | "/r/has a" |  | "FN" |  |
| fn:being_in_operation | /r/IsA | fn:state | "being in operation" | "state" | "/r/is a" |  | "FN" |  |
| fn:gizmo | /r/UsedFor | fn:being_in_operation | "gizmo" | "being in operation" | "/r/used for" |  | "FN" |  |
| fn:change_operational_state | /r/Causes | fn:being_in_operation | "change operational state" | "being in operation" | "/r/causes" |  | "FN" |  |
| fn:being_in_operation | fn:HasLexicalUnit | fn:lu:being_in_operation:on | "being in operation" | "on" | "has lexical unit" |  | "FN" |  |
| fn:being_in_operation | fn:HasLexicalUnit | fn:lu:being_in_operation:off | "being in operation" | "off" | "has lexical unit" |  | "FN" |  |
| fn:being_in_operation | fn:HasLexicalUnit | fn:lu:being_in_operation:operate | "being in operation" | "operate" | "has lexical unit" |  | "FN" |  |
| fn:being_in_operation | fn:HasLexicalUnit | fn:lu:being_in_operation:operational | "being in operation" | "operational" | "has lexical unit" |  | "FN" |  |
| fn:being_in_operation | /r/HasA | fn:fe:device | "being in operation" | "device" | "/r/has a" |  | "FN" |  |
| fn:being_in_operation | /r/HasA | fn:fe:time | "being in operation" | "time" | "/r/has a" |  | "FN" |  |
| fn:being_in_operation | /r/HasA | fn:fe:place | "being in operation" | "place" | "/r/has a" |  | "FN" |  |
| fn:being_in_operation | /r/HasA | fn:fe:duration | "being in operation" | "duration" | "/r/has a" |  | "FN" |  |
| fn:being_incarcerated | /r/IsA | fn:being_in_captivity | "being incarcerated" | "being in captivity" | "/r/is a" |  | "FN" |  |
| fn:being_incarcerated | /r/UsedFor | fn:fugitive | "being incarcerated" | "fugitive" | "/r/used for" |  | "FN" |  |
| fn:being_incarcerated | fn:HasLexicalUnit | fn:lu:being_incarcerated:incarcerated | "being incarcerated" | "incarcerated" | "has lexical unit" |  | "FN" |  |
| fn:being_incarcerated | fn:HasLexicalUnit | fn:lu:being_incarcerated:prison | "being incarcerated" | "prison" | "has lexical unit" |  | "FN" |  |
| fn:being_incarcerated | fn:HasLexicalUnit | fn:lu:being_incarcerated:jail | "being incarcerated" | "jail" | "has lexical unit" |  | "FN" |  |
| fn:being_incarcerated | fn:HasLexicalUnit | fn:lu:being_incarcerated:inmate | "being incarcerated" | "inmate" | "has lexical unit" |  | "FN" |  |
| fn:being_incarcerated | fn:HasLexicalUnit | fn:lu:being_incarcerated:serve_(one's)_time | "being incarcerated" | "serve (one\\'s) time" | "has lexical unit" |  | "FN" |  |
| fn:being_incarcerated | fn:HasLexicalUnit | fn:lu:being_incarcerated:serve | "being incarcerated" | "serve" | "has lexical unit" |  | "FN" |  |
| fn:being_incarcerated | fn:HasLexicalUnit | fn:lu:being_incarcerated:behind_bars | "being incarcerated" | "behind bars" | "has lexical unit" |  | "FN" |  |
| fn:being_incarcerated | fn:HasLexicalUnit | fn:lu:being_incarcerated:do_time | "being incarcerated" | "do time" | "has lexical unit" |  | "FN" |  |
| fn:fe:prisoner | /r/IsA | fn:st:physical_object | "prisoner" | "physical object" | "/r/is a" |  | "FN" |  |
| fn:being_incarcerated | /r/HasA | fn:fe:prisoner | "being incarcerated" | "prisoner" | "/r/has a" |  | "FN" |  |
| fn:fe:prison | /r/IsA | fn:st:goal | "prison" | "goal" | "/r/is a" |  | "FN" |  |
| fn:being_incarcerated | /r/HasA | fn:fe:prison | "being incarcerated" | "prison" | "/r/has a" |  | "FN" |  |
| fn:being_incarcerated | /r/HasA | fn:fe:authorities | "being incarcerated" | "authorities" | "/r/has a" |  | "FN" |  |
| fn:being_incarcerated | /r/HasA | fn:fe:crime | "being incarcerated" | "crime" | "/r/has a" |  | "FN" |  |
| fn:being_incarcerated | /r/HasA | fn:fe:place | "being incarcerated" | "place" | "/r/has a" |  | "FN" |  |
| fn:being_incarcerated | /r/HasA | fn:fe:time | "being incarcerated" | "time" | "/r/has a" |  | "FN" |  |
| fn:being_incarcerated | /r/HasA | fn:fe:manner | "being incarcerated" | "manner" | "/r/has a" |  | "FN" |  |
| fn:being_incarcerated | /r/HasA | fn:fe:explanation | "being incarcerated" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:being_incarcerated | /r/HasA | fn:fe:duration | "being incarcerated" | "duration" | "/r/has a" |  | "FN" |  |
| fn:be_subset_of | /r/IsA | fn:being_included | "be subset of" | "being included" | "/r/is a" |  | "FN" |  |
| fn:part_piece | /r/IsA | fn:being_included | "part piece" | "being included" | "/r/is a" |  | "FN" |  |
| fn:cause_to_be_included | /r/Causes | fn:being_included | "cause to be included" | "being included" | "/r/causes" |  | "FN" |  |
| fn:being_included | /r/IsA | fn:inclusion_scenario | "being included" | "inclusion scenario" | "/r/is a" |  | "FN" |  |
| fn:being_included | /r/HasA | fn:fe:whole | "being included" | "whole" | "/r/has a" |  | "FN" |  |
| fn:being_included | /r/HasA | fn:fe:part | "being included" | "part" | "/r/has a" |  | "FN" |  |
| fn:presence | /r/IsA | fn:being_located | "presence" | "being located" | "/r/is a" |  | "FN" |  |
| fn:visiting | /r/IsA | fn:being_located | "visiting" | "being located" | "/r/is a" |  | "FN" |  |
| fn:being_located | /r/IsA | fn:state | "being located" | "state" | "/r/is a" |  | "FN" |  |
| fn:being_located | /r/UsedFor | fn:bounded_entity | "being located" | "bounded entity" | "/r/used for" |  | "FN" |  |
| fn:locative_relation | /r/UsedFor | fn:being_located | "locative relation" | "being located" | "/r/used for" |  | "FN" |  |
| fn:being_located | fn:HasLexicalUnit | fn:lu:being_located:located | "being located" | "located" | "has lexical unit" |  | "FN" |  |
| fn:being_located | fn:HasLexicalUnit | fn:lu:being_located:situated | "being located" | "situated" | "has lexical unit" |  | "FN" |  |
| fn:being_located | fn:HasLexicalUnit | fn:lu:being_located:lie | "being located" | "lie" | "has lexical unit" |  | "FN" |  |
| fn:being_located | fn:HasLexicalUnit | fn:lu:being_located:stand | "being located" | "stand" | "has lexical unit" |  | "FN" |  |
| fn:being_located | fn:HasLexicalUnit | fn:lu:being_located:sit | "being located" | "sit" | "has lexical unit" |  | "FN" |  |
| fn:being_located | fn:HasLexicalUnit | fn:lu:being_located:whereabouts | "being located" | "whereabouts" | "has lexical unit" |  | "FN" |  |
| fn:being_located | fn:HasLexicalUnit | fn:lu:being_located:twenty | "being located" | "twenty" | "has lexical unit" |  | "FN" |  |
| fn:being_located | fn:HasLexicalUnit | fn:lu:being_located:find | "being located" | "find" | "has lexical unit" |  | "FN" |  |
| fn:being_located | /r/HasA | fn:fe:theme | "being located" | "theme" | "/r/has a" |  | "FN" |  |
| fn:being_located | /r/HasA | fn:fe:place | "being located" | "place" | "/r/has a" |  | "FN" |  |
| fn:being_located | /r/HasA | fn:fe:dependent_state | "being located" | "dependent state" | "/r/has a" |  | "FN" |  |
| fn:being_located | /r/HasA | fn:fe:time | "being located" | "time" | "/r/has a" |  | "FN" |  |
| fn:being_located | /r/HasA | fn:fe:location | "being located" | "location" | "/r/has a" |  | "FN" |  |
| fn:being_located | /r/HasA | fn:fe:cotheme | "being located" | "cotheme" | "/r/has a" |  | "FN" |  |
| fn:being_located | /r/HasA | fn:fe:depictive | "being located" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:appellations | /r/IsA | fn:being_named | "appellations" | "being named" | "/r/is a" |  | "FN" |  |
| fn:being_named | /r/UsedFor | fn:namesake | "being named" | "namesake" | "/r/used for" |  | "FN" |  |
| fn:being_named | /r/UsedFor | fn:referring_by_name | "being named" | "referring by name" | "/r/used for" |  | "FN" |  |
| fn:being_named | /r/SimilarTo | fn:namesake | "being named" | "namesake" | "/r/similar to" |  | "FN" |  |
| fn:being_named | /r/SimilarTo | fn:referring_by_name | "being named" | "referring by name" | "/r/similar to" |  | "FN" |  |
| fn:name_conferral | /r/Causes | fn:being_named | "name conferral" | "being named" | "/r/causes" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:pseudonym | "being named" | "pseudonym" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:name | "being named" | "name" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:nickname | "being named" | "nickname" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:surname | "being named" | "surname" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:forename | "being named" | "forename" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:maiden_name | "being named" | "maiden name" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:christian_name | "being named" | "christian name" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:family_name | "being named" | "family name" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:nom_de_plume | "being named" | "nom de plume" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:nom_de_guerre | "being named" | "nom de guerre" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:moniker | "being named" | "moniker" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:pen_name | "being named" | "pen name" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:first_name | "being named" | "first name" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:last_name | "being named" | "last name" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:middle_name | "being named" | "middle name" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:stage_name | "being named" | "stage name" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:alias | "being named" | "alias" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:given_name | "being named" | "given name" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:entitled | "being named" | "entitled" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:named | "being named" | "named" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:codename | "being named" | "codename" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:codenamed | "being named" | "codenamed" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:pet_name | "being named" | "pet name" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:cognomen | "being named" | "cognomen" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:agnomen | "being named" | "agnomen" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:by-name | "being named" | "by-name" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:caconym | "being named" | "caconym" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:praenomen | "being named" | "praenomen" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:misnomer | "being named" | "misnomer" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:married_name | "being named" | "married name" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:allonym | "being named" | "allonym" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:soubriquet | "being named" | "soubriquet" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:nee | "being named" | "nee" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:brand_name | "being named" | "brand name" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:patronymic | "being named" | "patronymic" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:metronymic | "being named" | "metronymic" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:trivial_name | "being named" | "trivial name" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:eponym | "being named" | "eponym" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:also_known_as | "being named" | "also known as" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:aka | "being named" | "aka" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:go | "being named" | "go" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:nameless | "being named" | "nameless" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:known | "being named" | "known" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:so-called | "being named" | "so-called" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:designated | "being named" | "designated" | "has lexical unit" |  | "FN" |  |
| fn:being_named | fn:HasLexicalUnit | fn:lu:being_named:full_name | "being named" | "full name" | "has lexical unit" |  | "FN" |  |
| fn:being_named | /r/HasA | fn:fe:name | "being named" | "name" | "/r/has a" |  | "FN" |  |
| fn:being_named | /r/HasA | fn:fe:entity | "being named" | "entity" | "/r/has a" |  | "FN" |  |
| fn:being_named | /r/HasA | fn:fe:language | "being named" | "language" | "/r/has a" |  | "FN" |  |
| fn:being_named | /r/HasA | fn:fe:type | "being named" | "type" | "/r/has a" |  | "FN" |  |
| fn:being_named | /r/HasA | fn:fe:descriptor | "being named" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:being_named | /r/HasA | fn:fe:context | "being named" | "context" | "/r/has a" |  | "FN" |  |
| fn:being_named | /r/HasA | fn:fe:etymological_root | "being named" | "etymological root" | "/r/has a" |  | "FN" |  |
| fn:being_necessary | /r/UsedFor | fn:required_event | "being necessary" | "required event" | "/r/used for" |  | "FN" |  |
| fn:being_necessary | /r/UsedFor | fn:taking_time | "being necessary" | "taking time" | "/r/used for" |  | "FN" |  |
| fn:being_necessary | /r/IsA | fn:requirement_scenario | "being necessary" | "requirement scenario" | "/r/is a" |  | "FN" |  |
| fn:being_necessary | fn:HasLexicalUnit | fn:lu:being_necessary:necessary | "being necessary" | "necessary" | "has lexical unit" |  | "FN" |  |
| fn:being_necessary | fn:HasLexicalUnit | fn:lu:being_necessary:requirement | "being necessary" | "requirement" | "has lexical unit" |  | "FN" |  |
| fn:being_necessary | fn:HasLexicalUnit | fn:lu:being_necessary:necessity | "being necessary" | "necessity" | "has lexical unit" |  | "FN" |  |
| fn:being_necessary | fn:HasLexicalUnit | fn:lu:being_necessary:needed | "being necessary" | "needed" | "has lexical unit" |  | "FN" |  |
| fn:being_necessary | fn:HasLexicalUnit | fn:lu:being_necessary:indispensable | "being necessary" | "indispensable" | "has lexical unit" |  | "FN" |  |
| fn:being_necessary | fn:HasLexicalUnit | fn:lu:being_necessary:required | "being necessary" | "required" | "has lexical unit" |  | "FN" |  |
| fn:being_necessary | fn:HasLexicalUnit | fn:lu:being_necessary:essential | "being necessary" | "essential" | "has lexical unit" |  | "FN" |  |
| fn:being_necessary | fn:HasLexicalUnit | fn:lu:being_necessary:basic | "being necessary" | "basic" | "has lexical unit" |  | "FN" |  |
| fn:being_necessary | /r/HasA | fn:fe:dependent | "being necessary" | "dependent" | "/r/has a" |  | "FN" |  |
| fn:being_necessary | /r/HasA | fn:fe:requirement | "being necessary" | "requirement" | "/r/has a" |  | "FN" |  |
| fn:being_necessary | /r/HasA | fn:fe:degree | "being necessary" | "degree" | "/r/has a" |  | "FN" |  |
| fn:being_necessary | /r/HasA | fn:fe:time | "being necessary" | "time" | "/r/has a" |  | "FN" |  |
| fn:being_necessary | /r/HasA | fn:fe:condition | "being necessary" | "condition" | "/r/has a" |  | "FN" |  |
| fn:being_necessary | /r/HasA | fn:fe:domain | "being necessary" | "domain" | "/r/has a" |  | "FN" |  |
| fn:being_necessary | /r/HasA | fn:fe:place | "being necessary" | "place" | "/r/has a" |  | "FN" |  |
| fn:being_necessary | /r/HasA | fn:fe:dependent_individual | "being necessary" | "dependent individual" | "/r/has a" |  | "FN" |  |
| fn:being_necessary | /r/HasA | fn:fe:required_entity | "being necessary" | "required entity" | "/r/has a" |  | "FN" |  |
| fn:being_necessary | /r/HasA | fn:fe:descriptor | "being necessary" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:being_necessary | /r/HasA | fn:fe:explanation | "being necessary" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:being_obligated | /r/UsedFor | fn:assigned_location | "being obligated" | "assigned location" | "/r/used for" |  | "FN" |  |
| fn:being_obligated | /r/UsedFor | fn:temporary_leave | "being obligated" | "temporary leave" | "/r/used for" |  | "FN" |  |
| fn:required_event | /r/RelatedTo | fn:being_obligated | "required event" | "being obligated" | "/r/related to" |  | "FN" |  |
| fn:being_obligated | /r/SimilarTo | fn:required_event | "being obligated" | "required event" | "/r/similar to" |  | "FN" |  |
| fn:imposing_obligation | /r/Causes | fn:being_obligated | "imposing obligation" | "being obligated" | "/r/causes" |  | "FN" |  |
| fn:being_obligated | /r/IsA | fn:obligation_scenario | "being obligated" | "obligation scenario" | "/r/is a" |  | "FN" |  |
| fn:being_obligated | fn:HasLexicalUnit | fn:lu:being_obligated:obligated | "being obligated" | "obligated" | "has lexical unit" |  | "FN" |  |
| fn:being_obligated | fn:HasLexicalUnit | fn:lu:being_obligated:duty | "being obligated" | "duty" | "has lexical unit" |  | "FN" |  |
| fn:being_obligated | fn:HasLexicalUnit | fn:lu:being_obligated:job | "being obligated" | "job" | "has lexical unit" |  | "FN" |  |
| fn:being_obligated | fn:HasLexicalUnit | fn:lu:being_obligated:task | "being obligated" | "task" | "has lexical unit" |  | "FN" |  |
| fn:being_obligated | fn:HasLexicalUnit | fn:lu:being_obligated:responsibility | "being obligated" | "responsibility" | "has lexical unit" |  | "FN" |  |
| fn:being_obligated | fn:HasLexicalUnit | fn:lu:being_obligated:obligation | "being obligated" | "obligation" | "has lexical unit" |  | "FN" |  |
| fn:being_obligated | fn:HasLexicalUnit | fn:lu:being_obligated:bound | "being obligated" | "bound" | "has lexical unit" |  | "FN" |  |
| fn:being_obligated | fn:HasLexicalUnit | fn:lu:being_obligated:assignment | "being obligated" | "assignment" | "has lexical unit" |  | "FN" |  |
| fn:being_obligated | fn:HasLexicalUnit | fn:lu:being_obligated:mission | "being obligated" | "mission" | "has lexical unit" |  | "FN" |  |
| fn:being_obligated | fn:HasLexicalUnit | fn:lu:being_obligated:commission | "being obligated" | "commission" | "has lexical unit" |  | "FN" |  |
| fn:being_obligated | fn:HasLexicalUnit | fn:lu:being_obligated:contract | "being obligated" | "contract" | "has lexical unit" |  | "FN" |  |
| fn:being_obligated | fn:HasLexicalUnit | fn:lu:being_obligated:obliged | "being obligated" | "obliged" | "has lexical unit" |  | "FN" |  |
| fn:being_obligated | fn:HasLexicalUnit | fn:lu:being_obligated:imposition | "being obligated" | "imposition" | "has lexical unit" |  | "FN" |  |
| fn:being_obligated | /r/HasA | fn:fe:responsible_party | "being obligated" | "responsible party" | "/r/has a" |  | "FN" |  |
| fn:being_obligated | /r/HasA | fn:fe:duty | "being obligated" | "duty" | "/r/has a" |  | "FN" |  |
| fn:being_obligated | /r/HasA | fn:fe:condition | "being obligated" | "condition" | "/r/has a" |  | "FN" |  |
| fn:being_obligated | /r/HasA | fn:fe:consequence | "being obligated" | "consequence" | "/r/has a" |  | "FN" |  |
| fn:being_obligated | /r/HasA | fn:fe:time | "being obligated" | "time" | "/r/has a" |  | "FN" |  |
| fn:being_obligated | /r/HasA | fn:fe:place | "being obligated" | "place" | "/r/has a" |  | "FN" |  |
| fn:being_obligated | /r/HasA | fn:fe:frequency | "being obligated" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:being_obligatory | /r/IsA | fn:obligation_scenario | "being obligatory" | "obligation scenario" | "/r/is a" |  | "FN" |  |
| fn:being_obligatory | fn:HasLexicalUnit | fn:lu:being_obligatory:mandatory | "being obligatory" | "mandatory" | "has lexical unit" |  | "FN" |  |
| fn:being_obligatory | fn:HasLexicalUnit | fn:lu:being_obligatory:compulsory | "being obligatory" | "compulsory" | "has lexical unit" |  | "FN" |  |
| fn:being_obligatory | fn:HasLexicalUnit | fn:lu:being_obligatory:obligatory | "being obligatory" | "obligatory" | "has lexical unit" |  | "FN" |  |
| fn:being_obligatory | fn:HasLexicalUnit | fn:lu:being_obligatory:incumbent | "being obligatory" | "incumbent" | "has lexical unit" |  | "FN" |  |
| fn:being_obligatory | fn:HasLexicalUnit | fn:lu:being_obligatory:behoove | "being obligatory" | "behoove" | "has lexical unit" |  | "FN" |  |
| fn:being_obligatory | fn:HasLexicalUnit | fn:lu:being_obligatory:binding | "being obligatory" | "binding" | "has lexical unit" |  | "FN" |  |
| fn:being_obligatory | fn:HasLexicalUnit | fn:lu:being_obligatory:voluntary | "being obligatory" | "voluntary" | "has lexical unit" |  | "FN" |  |
| fn:being_obligatory | /r/HasA | fn:fe:condition | "being obligatory" | "condition" | "/r/has a" |  | "FN" |  |
| fn:being_obligatory | /r/HasA | fn:fe:consequence | "being obligatory" | "consequence" | "/r/has a" |  | "FN" |  |
| fn:being_obligatory | /r/HasA | fn:fe:duty | "being obligatory" | "duty" | "/r/has a" |  | "FN" |  |
| fn:being_obligatory | /r/HasA | fn:fe:responsible_party | "being obligatory" | "responsible party" | "/r/has a" |  | "FN" |  |
| fn:being_obligatory | /r/HasA | fn:fe:time | "being obligatory" | "time" | "/r/has a" |  | "FN" |  |
| fn:being_obligatory | /r/HasA | fn:fe:place | "being obligatory" | "place" | "/r/has a" |  | "FN" |  |
| fn:being_obligatory | /r/HasA | fn:fe:purpose | "being obligatory" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:being_obligatory | /r/HasA | fn:fe:explanation | "being obligatory" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:being_operational | /r/IsA | fn:capability | "being operational" | "capability" | "/r/is a" |  | "FN" |  |
| fn:artifact | /r/UsedFor | fn:being_operational | "artifact" | "being operational" | "/r/used for" |  | "FN" |  |
| fn:render_nonfunctional | /r/UsedFor | fn:being_operational | "render nonfunctional" | "being operational" | "/r/used for" |  | "FN" |  |
| fn:being_operational | fn:HasLexicalUnit | fn:lu:being_operational:broken | "being operational" | "broken" | "has lexical unit" |  | "FN" |  |
| fn:being_operational | fn:HasLexicalUnit | fn:lu:being_operational:busted | "being operational" | "busted" | "has lexical unit" |  | "FN" |  |
| fn:being_operational | fn:HasLexicalUnit | fn:lu:being_operational:down | "being operational" | "down" | "has lexical unit" |  | "FN" |  |
| fn:being_operational | fn:HasLexicalUnit | fn:lu:being_operational:work | "being operational" | "work" | "has lexical unit" |  | "FN" |  |
| fn:being_operational | fn:HasLexicalUnit | fn:lu:being_operational:operational | "being operational" | "operational" | "has lexical unit" |  | "FN" |  |
| fn:being_operational | fn:HasLexicalUnit | fn:lu:being_operational:functional | "being operational" | "functional" | "has lexical unit" |  | "FN" |  |
| fn:being_operational | fn:HasLexicalUnit | fn:lu:being_operational:working | "being operational" | "working" | "has lexical unit" |  | "FN" |  |
| fn:being_operational | fn:HasLexicalUnit | fn:lu:being_operational:downed | "being operational" | "downed" | "has lexical unit" |  | "FN" |  |
| fn:being_operational | fn:HasLexicalUnit | fn:lu:being_operational:in_order | "being operational" | "in order" | "has lexical unit" |  | "FN" |  |
| fn:being_operational | fn:HasLexicalUnit | fn:lu:being_operational:function | "being operational" | "function" | "has lexical unit" |  | "FN" |  |
| fn:being_operational | /r/HasA | fn:fe:object | "being operational" | "object" | "/r/has a" |  | "FN" |  |
| fn:being_operational | /r/HasA | fn:fe:degree | "being operational" | "degree" | "/r/has a" |  | "FN" |  |
| fn:being_pregnant | /r/HasA | fn:fe:mother | "being pregnant" | "mother" | "/r/has a" |  | "FN" |  |
| fn:being_pregnant | /r/HasA | fn:fe:father | "being pregnant" | "father" | "/r/has a" |  | "FN" |  |
| fn:being_pregnant | /r/HasA | fn:fe:parents | "being pregnant" | "parents" | "/r/has a" |  | "FN" |  |
| fn:being_pregnant | /r/HasA | fn:fe:offspring | "being pregnant" | "offspring" | "/r/has a" |  | "FN" |  |
| fn:being_pregnant | /r/HasA | fn:fe:duration | "being pregnant" | "duration" | "/r/has a" |  | "FN" |  |
| fn:being_questionable | /r/IsA | fn:social_behavior_evaluation | "being questionable" | "social behavior evaluation" | "/r/is a" |  | "FN" |  |
| fn:being_questionable | fn:HasLexicalUnit | fn:lu:being_questionable:suspect | "being questionable" | "suspect" | "has lexical unit" |  | "FN" |  |
| fn:being_questionable | fn:HasLexicalUnit | fn:lu:being_questionable:suspicious | "being questionable" | "suspicious" | "has lexical unit" |  | "FN" |  |
| fn:being_questionable | fn:HasLexicalUnit | fn:lu:being_questionable:questionable | "being questionable" | "questionable" | "has lexical unit" |  | "FN" |  |
| fn:being_questionable | fn:HasLexicalUnit | fn:lu:being_questionable:fishy | "being questionable" | "fishy" | "has lexical unit" |  | "FN" |  |
| fn:being_questionable | fn:HasLexicalUnit | fn:lu:being_questionable:dubious | "being questionable" | "dubious" | "has lexical unit" |  | "FN" |  |
| fn:fe:behavior | /r/RelatedTo | fn:fe:entity | "behavior" | "entity" | "/r/related to" |  | "FN" |  |
| fn:being_questionable | /r/HasA | fn:fe:behavior | "being questionable" | "behavior" | "/r/has a" |  | "FN" |  |
| fn:being_questionable | /r/HasA | fn:fe:degree | "being questionable" | "degree" | "/r/has a" |  | "FN" |  |
| fn:fe:social_actor | /r/RelatedTo | fn:fe:entity | "social actor" | "entity" | "/r/related to" |  | "FN" |  |
| fn:being_questionable | /r/HasA | fn:fe:social_actor | "being questionable" | "social actor" | "/r/has a" |  | "FN" |  |
| fn:being_questionable | /r/HasA | fn:fe:judge | "being questionable" | "judge" | "/r/has a" |  | "FN" |  |
| fn:being_questionable | /r/HasA | fn:fe:entity | "being questionable" | "entity" | "/r/has a" |  | "FN" |  |
| fn:being_relevant | /r/IsA | fn:cognitive_connection | "being relevant" | "cognitive connection" | "/r/is a" |  | "FN" |  |
| fn:being_relevant | fn:HasLexicalUnit | fn:lu:being_relevant:relevant | "being relevant" | "relevant" | "has lexical unit" |  | "FN" |  |
| fn:being_relevant | fn:HasLexicalUnit | fn:lu:being_relevant:irrelevant | "being relevant" | "irrelevant" | "has lexical unit" |  | "FN" |  |
| fn:being_relevant | fn:HasLexicalUnit | fn:lu:being_relevant:pertinent | "being relevant" | "pertinent" | "has lexical unit" |  | "FN" |  |
| fn:being_relevant | fn:HasLexicalUnit | fn:lu:being_relevant:play_(into) | "being relevant" | "play (into)" | "has lexical unit" |  | "FN" |  |
| fn:being_relevant | /r/HasA | fn:fe:phenomenon | "being relevant" | "phenomenon" | "/r/has a" |  | "FN" |  |
| fn:being_relevant | /r/HasA | fn:fe:endeavor | "being relevant" | "endeavor" | "/r/has a" |  | "FN" |  |
| fn:being_relevant | /r/HasA | fn:fe:cognizer | "being relevant" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:being_relevant | /r/HasA | fn:fe:degree | "being relevant" | "degree" | "/r/has a" |  | "FN" |  |
| fn:being_relevant | /r/HasA | fn:fe:specification | "being relevant" | "specification" | "/r/has a" |  | "FN" |  |
| fn:being_rotted | /r/IsA | fn:gradable_attributes | "being rotted" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:being_wet | /r/UsedFor | fn:being_rotted | "being wet" | "being rotted" | "/r/used for" |  | "FN" |  |
| fn:rotting | /r/Causes | fn:being_rotted | "rotting" | "being rotted" | "/r/causes" |  | "FN" |  |
| fn:being_rotted | fn:HasLexicalUnit | fn:lu:being_rotted:rotted | "being rotted" | "rotted" | "has lexical unit" |  | "FN" |  |
| fn:being_rotted | fn:HasLexicalUnit | fn:lu:being_rotted:rancid | "being rotted" | "rancid" | "has lexical unit" |  | "FN" |  |
| fn:being_rotted | fn:HasLexicalUnit | fn:lu:being_rotted:decayed | "being rotted" | "decayed" | "has lexical unit" |  | "FN" |  |
| fn:being_rotted | fn:HasLexicalUnit | fn:lu:being_rotted:rotten | "being rotted" | "rotten" | "has lexical unit" |  | "FN" |  |
| fn:being_rotted | fn:HasLexicalUnit | fn:lu:being_rotted:mouldy | "being rotted" | "mouldy" | "has lexical unit" |  | "FN" |  |
| fn:being_rotted | fn:HasLexicalUnit | fn:lu:being_rotted:putrid | "being rotted" | "putrid" | "has lexical unit" |  | "FN" |  |
| fn:being_rotted | /r/HasA | fn:fe:patient | "being rotted" | "patient" | "/r/has a" |  | "FN" |  |
| fn:being_rotted | /r/HasA | fn:fe:degree | "being rotted" | "degree" | "/r/has a" |  | "FN" |  |
| fn:being_up_to_it | /r/IsA | fn:capability | "being up to it" | "capability" | "/r/is a" |  | "FN" |  |
| fn:rising_to_a_challenge | /r/Causes | fn:being_up_to_it | "rising to a challenge" | "being up to it" | "/r/causes" |  | "FN" |  |
| fn:being_up_to_it | fn:HasLexicalUnit | fn:lu:being_up_to_it:sufficient | "being up to it" | "sufficient" | "has lexical unit" |  | "FN" |  |
| fn:being_up_to_it | fn:HasLexicalUnit | fn:lu:being_up_to_it:up_to | "being up to it" | "up to" | "has lexical unit" |  | "FN" |  |
| fn:being_up_to_it | fn:HasLexicalUnit | fn:lu:being_up_to_it:equal | "being up to it" | "equal" | "has lexical unit" |  | "FN" |  |
| fn:being_up_to_it | /r/HasA | fn:fe:entity | "being up to it" | "entity" | "/r/has a" |  | "FN" |  |
| fn:being_up_to_it | /r/HasA | fn:fe:activity | "being up to it" | "activity" | "/r/has a" |  | "FN" |  |
| fn:being_up_to_it | /r/HasA | fn:fe:degree | "being up to it" | "degree" | "/r/has a" |  | "FN" |  |
| fn:being_up_to_it | /r/HasA | fn:fe:circumstances | "being up to it" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:being_up_to_it | /r/HasA | fn:fe:explanation | "being up to it" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:being_up_to_it | /r/HasA | fn:fe:relevant_feature | "being up to it" | "relevant feature" | "/r/has a" |  | "FN" |  |
| fn:being_wet | /r/IsA | fn:gradable_attributes | "being wet" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:being_wet | /r/UsedFor | fn:being_rotted | "being wet" | "being rotted" | "/r/used for" |  | "FN" |  |
| fn:cause_to_be_wet | /r/Causes | fn:being_wet | "cause to be wet" | "being wet" | "/r/causes" |  | "FN" |  |
| fn:being_wet | fn:HasLexicalUnit | fn:lu:being_wet:drenched | "being wet" | "drenched" | "has lexical unit" |  | "FN" |  |
| fn:being_wet | fn:HasLexicalUnit | fn:lu:being_wet:damp | "being wet" | "damp" | "has lexical unit" |  | "FN" |  |
| fn:being_wet | fn:HasLexicalUnit | fn:lu:being_wet:moist | "being wet" | "moist" | "has lexical unit" |  | "FN" |  |
| fn:being_wet | fn:HasLexicalUnit | fn:lu:being_wet:wet | "being wet" | "wet" | "has lexical unit" |  | "FN" |  |
| fn:being_wet | fn:HasLexicalUnit | fn:lu:being_wet:soaked | "being wet" | "soaked" | "has lexical unit" |  | "FN" |  |
| fn:being_wet | fn:HasLexicalUnit | fn:lu:being_wet:saturated | "being wet" | "saturated" | "has lexical unit" |  | "FN" |  |
| fn:being_wet | fn:HasLexicalUnit | fn:lu:being_wet:soggy | "being wet" | "soggy" | "has lexical unit" |  | "FN" |  |
| fn:being_wet | fn:HasLexicalUnit | fn:lu:being_wet:sopping | "being wet" | "sopping" | "has lexical unit" |  | "FN" |  |
| fn:being_wet | fn:HasLexicalUnit | fn:lu:being_wet:sodden | "being wet" | "sodden" | "has lexical unit" |  | "FN" |  |
| fn:being_wet | fn:HasLexicalUnit | fn:lu:being_wet:soaking | "being wet" | "soaking" | "has lexical unit" |  | "FN" |  |
| fn:being_wet | fn:HasLexicalUnit | fn:lu:being_wet:waterlogged | "being wet" | "waterlogged" | "has lexical unit" |  | "FN" |  |
| fn:being_wet | fn:HasLexicalUnit | fn:lu:being_wet:humid | "being wet" | "humid" | "has lexical unit" |  | "FN" |  |
| fn:being_wet | fn:HasLexicalUnit | fn:lu:being_wet:dewy | "being wet" | "dewy" | "has lexical unit" |  | "FN" |  |
| fn:being_wet | fn:HasLexicalUnit | fn:lu:being_wet:clammy | "being wet" | "clammy" | "has lexical unit" |  | "FN" |  |
| fn:being_wet | fn:HasLexicalUnit | fn:lu:being_wet:moistened | "being wet" | "moistened" | "has lexical unit" |  | "FN" |  |
| fn:being_wet | fn:HasLexicalUnit | fn:lu:being_wet:sweaty | "being wet" | "sweaty" | "has lexical unit" |  | "FN" |  |
| fn:being_wet | /r/HasA | fn:fe:item | "being wet" | "item" | "/r/has a" |  | "FN" |  |
| fn:being_wet | /r/HasA | fn:fe:liquid | "being wet" | "liquid" | "/r/has a" |  | "FN" |  |
| fn:being_wet | /r/HasA | fn:fe:degree | "being wet" | "degree" | "/r/has a" |  | "FN" |  |
| fn:being_wet | /r/HasA | fn:fe:explanation | "being wet" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:being_wet | /r/HasA | fn:fe:subregion | "being wet" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:besieging | /r/IsA | fn:attack | "besieging" | "attack" | "/r/is a" |  | "FN" |  |
| fn:besieging | fn:HasLexicalUnit | fn:lu:besieging:besiege | "besieging" | "besiege" | "has lexical unit" |  | "FN" |  |
| fn:besieging | fn:HasLexicalUnit | fn:lu:besieging:siege | "besieging" | "siege" | "has lexical unit" |  | "FN" |  |
| fn:besieging | fn:HasLexicalUnit | fn:lu:besieging:beleaguer | "besieging" | "beleaguer" | "has lexical unit" |  | "FN" |  |
| fn:besieging | fn:HasLexicalUnit | fn:lu:besieging:invest | "besieging" | "invest" | "has lexical unit" |  | "FN" |  |
| fn:besieging | fn:HasLexicalUnit | fn:lu:besieging:investment | "besieging" | "investment" | "has lexical unit" |  | "FN" |  |
| fn:besieging | fn:HasLexicalUnit | fn:lu:besieging:siege | "besieging" | "siege" | "has lexical unit" |  | "FN" |  |
| fn:besieging | fn:HasLexicalUnit | fn:lu:besieging:besiegement | "besieging" | "besiegement" | "has lexical unit" |  | "FN" |  |
| fn:besieging | fn:HasLexicalUnit | fn:lu:besieging:encirclement | "besieging" | "encirclement" | "has lexical unit" |  | "FN" |  |
| fn:besieging | /r/HasA | fn:fe:assailant | "besieging" | "assailant" | "/r/has a" |  | "FN" |  |
| fn:besieging | /r/HasA | fn:fe:victim | "besieging" | "victim" | "/r/has a" |  | "FN" |  |
| fn:besieging | /r/HasA | fn:fe:manner | "besieging" | "manner" | "/r/has a" |  | "FN" |  |
| fn:besieging | /r/HasA | fn:fe:means | "besieging" | "means" | "/r/has a" |  | "FN" |  |
| fn:besieging | /r/HasA | fn:fe:place | "besieging" | "place" | "/r/has a" |  | "FN" |  |
| fn:besieging | /r/HasA | fn:fe:purpose | "besieging" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:besieging | /r/HasA | fn:fe:source | "besieging" | "source" | "/r/has a" |  | "FN" |  |
| fn:besieging | /r/HasA | fn:fe:time | "besieging" | "time" | "/r/has a" |  | "FN" |  |
| fn:besieging | /r/HasA | fn:fe:weapon | "besieging" | "weapon" | "/r/has a" |  | "FN" |  |
| fn:besieging | /r/HasA | fn:fe:path | "besieging" | "path" | "/r/has a" |  | "FN" |  |
| fn:besieging | /r/HasA | fn:fe:duration | "besieging" | "duration" | "/r/has a" |  | "FN" |  |
| fn:surpassing | /r/UsedFor | fn:beyond_compare | "surpassing" | "beyond compare" | "/r/used for" |  | "FN" |  |
| fn:beyond_compare | fn:HasLexicalUnit | fn:lu:beyond_compare:unmatched | "beyond compare" | "unmatched" | "has lexical unit" |  | "FN" |  |
| fn:beyond_compare | fn:HasLexicalUnit | fn:lu:beyond_compare:unrivalled | "beyond compare" | "unrivalled" | "has lexical unit" |  | "FN" |  |
| fn:beyond_compare | fn:HasLexicalUnit | fn:lu:beyond_compare:peerless | "beyond compare" | "peerless" | "has lexical unit" |  | "FN" |  |
| fn:beyond_compare | fn:HasLexicalUnit | fn:lu:beyond_compare:matchless | "beyond compare" | "matchless" | "has lexical unit" |  | "FN" |  |
| fn:beyond_compare | fn:HasLexicalUnit | fn:lu:beyond_compare:incomparable | "beyond compare" | "incomparable" | "has lexical unit" |  | "FN" |  |
| fn:beyond_compare | fn:HasLexicalUnit | fn:lu:beyond_compare:nonpareil | "beyond compare" | "nonpareil" | "has lexical unit" |  | "FN" |  |
| fn:beyond_compare | fn:HasLexicalUnit | fn:lu:beyond_compare:without_peer | "beyond compare" | "without peer" | "has lexical unit" |  | "FN" |  |
| fn:beyond_compare | fn:HasLexicalUnit | fn:lu:beyond_compare:without_equal | "beyond compare" | "without equal" | "has lexical unit" |  | "FN" |  |
| fn:beyond_compare | fn:HasLexicalUnit | fn:lu:beyond_compare:without_match | "beyond compare" | "without match" | "has lexical unit" |  | "FN" |  |
| fn:beyond_compare | fn:HasLexicalUnit | fn:lu:beyond_compare:without_compare | "beyond compare" | "without compare" | "has lexical unit" |  | "FN" |  |
| fn:beyond_compare | fn:HasLexicalUnit | fn:lu:beyond_compare:unequalled | "beyond compare" | "unequalled" | "has lexical unit" |  | "FN" |  |
| fn:beyond_compare | fn:HasLexicalUnit | fn:lu:beyond_compare:beyond_compare | "beyond compare" | "beyond compare" | "has lexical unit" |  | "FN" |  |
| fn:beyond_compare | /r/HasA | fn:fe:standard | "beyond compare" | "standard" | "/r/has a" |  | "FN" |  |
| fn:beyond_compare | /r/HasA | fn:fe:variable | "beyond compare" | "variable" | "/r/has a" |  | "FN" |  |
| fn:beyond_compare | /r/HasA | fn:fe:competitors | "beyond compare" | "competitors" | "/r/has a" |  | "FN" |  |
| fn:beyond_compare | /r/HasA | fn:fe:domain | "beyond compare" | "domain" | "/r/has a" |  | "FN" |  |
| fn:commerce_collect | /r/UsedFor | fn:billing | "commerce collect" | "billing" | "/r/used for" |  | "FN" |  |
| fn:billing | fn:HasLexicalUnit | fn:lu:billing:bill | "billing" | "bill" | "has lexical unit" |  | "FN" |  |
| fn:billing | fn:HasLexicalUnit | fn:lu:billing:invoice | "billing" | "invoice" | "has lexical unit" |  | "FN" |  |
| fn:billing | fn:HasLexicalUnit | fn:lu:billing:invoice | "billing" | "invoice" | "has lexical unit" |  | "FN" |  |
| fn:fe:debtor | /r/IsA | fn:st:source | "debtor" | "source" | "/r/is a" |  | "FN" |  |
| fn:billing | /r/HasA | fn:fe:debtor | "billing" | "debtor" | "/r/has a" |  | "FN" |  |
| fn:billing | /r/HasA | fn:fe:goods | "billing" | "goods" | "/r/has a" |  | "FN" |  |
| fn:billing | /r/HasA | fn:fe:means | "billing" | "means" | "/r/has a" |  | "FN" |  |
| fn:billing | /r/HasA | fn:fe:money | "billing" | "money" | "/r/has a" |  | "FN" |  |
| fn:billing | /r/HasA | fn:fe:rate | "billing" | "rate" | "/r/has a" |  | "FN" |  |
| fn:billing | /r/HasA | fn:fe:owed_party | "billing" | "owed party" | "/r/has a" |  | "FN" |  |
| fn:billing | /r/HasA | fn:fe:unit | "billing" | "unit" | "/r/has a" |  | "FN" |  |
| fn:billing | /r/HasA | fn:fe:place | "billing" | "place" | "/r/has a" |  | "FN" |  |
| fn:billing | /r/HasA | fn:fe:purpose | "billing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:billing | /r/HasA | fn:fe:explanation | "billing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:billing | /r/HasA | fn:fe:time | "billing" | "time" | "/r/has a" |  | "FN" |  |
| fn:billing | /r/HasA | fn:fe:manner | "billing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:billing | /r/HasA | fn:fe:billing_authority | "billing" | "billing authority" | "/r/has a" |  | "FN" |  |
| fn:billing | /r/HasA | fn:fe:payment_status | "billing" | "payment status" | "/r/has a" |  | "FN" |  |
| fn:billing | /r/HasA | fn:fe:bad_action | "billing" | "bad action" | "/r/has a" |  | "FN" |  |
| fn:biological_area | /r/IsA | fn:locale | "biological area" | "locale" | "/r/is a" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:woodland | "biological area" | "woodland" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:mudflat | "biological area" | "mudflat" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:swamp | "biological area" | "swamp" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:prairie | "biological area" | "prairie" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:desert | "biological area" | "desert" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:forest | "biological area" | "forest" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:bog | "biological area" | "bog" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:wood | "biological area" | "wood" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:jungle | "biological area" | "jungle" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:swampland | "biological area" | "swampland" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:rainforest | "biological area" | "rainforest" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:plain | "biological area" | "plain" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:meadowland | "biological area" | "meadowland" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:heathland | "biological area" | "heathland" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:copse | "biological area" | "copse" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:glade | "biological area" | "glade" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:tundra | "biological area" | "tundra" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:taiga | "biological area" | "taiga" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:marsh | "biological area" | "marsh" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:marshland | "biological area" | "marshland" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:fen | "biological area" | "fen" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:moor | "biological area" | "moor" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:grassland | "biological area" | "grassland" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:mead | "biological area" | "mead" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:lea | "biological area" | "lea" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:veld | "biological area" | "veld" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:wold | "biological area" | "wold" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:thicket | "biological area" | "thicket" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:savanna | "biological area" | "savanna" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:mire | "biological area" | "mire" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:bush | "biological area" | "bush" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:greenwood | "biological area" | "greenwood" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:spinney | "biological area" | "spinney" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:scrub | "biological area" | "scrub" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:oasis | "biological area" | "oasis" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | fn:HasLexicalUnit | fn:lu:biological_area:shrubbery | "biological area" | "shrubbery" | "has lexical unit" |  | "FN" |  |
| fn:biological_area | /r/HasA | fn:fe:constituent_parts | "biological area" | "constituent parts" | "/r/has a" |  | "FN" |  |
| fn:biological_area | /r/HasA | fn:fe:container_possessor | "biological area" | "container possessor" | "/r/has a" |  | "FN" |  |
| fn:biological_area | /r/HasA | fn:fe:formational_cause | "biological area" | "formational cause" | "/r/has a" |  | "FN" |  |
| fn:fe:locale | /r/IsA | fn:st:location | "locale" | "location" | "/r/is a" |  | "FN" |  |
| fn:biological_area | /r/HasA | fn:fe:locale | "biological area" | "locale" | "/r/has a" |  | "FN" |  |
| fn:biological_area | /r/HasA | fn:fe:name | "biological area" | "name" | "/r/has a" |  | "FN" |  |
| fn:biological_area | /r/HasA | fn:fe:relative_location | "biological area" | "relative location" | "/r/has a" |  | "FN" |  |
| fn:biological_area | /r/HasA | fn:fe:descriptor | "biological area" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:biological_classification | /r/IsA | fn:type | "biological classification" | "type" | "/r/is a" |  | "FN" |  |
| fn:biological_entity | /r/UsedFor | fn:biological_classification | "biological entity" | "biological classification" | "/r/used for" |  | "FN" |  |
| fn:biological_classification | fn:HasLexicalUnit | fn:lu:biological_classification:kingdom | "biological classification" | "kingdom" | "has lexical unit" |  | "FN" |  |
| fn:biological_classification | fn:HasLexicalUnit | fn:lu:biological_classification:phylum | "biological classification" | "phylum" | "has lexical unit" |  | "FN" |  |
| fn:biological_classification | fn:HasLexicalUnit | fn:lu:biological_classification:class | "biological classification" | "class" | "has lexical unit" |  | "FN" |  |
| fn:biological_classification | fn:HasLexicalUnit | fn:lu:biological_classification:order | "biological classification" | "order" | "has lexical unit" |  | "FN" |  |
| fn:biological_classification | fn:HasLexicalUnit | fn:lu:biological_classification:family | "biological classification" | "family" | "has lexical unit" |  | "FN" |  |
| fn:biological_classification | fn:HasLexicalUnit | fn:lu:biological_classification:genus | "biological classification" | "genus" | "has lexical unit" |  | "FN" |  |
| fn:biological_classification | fn:HasLexicalUnit | fn:lu:biological_classification:species | "biological classification" | "species" | "has lexical unit" |  | "FN" |  |
| fn:biological_classification | fn:HasLexicalUnit | fn:lu:biological_classification:domain | "biological classification" | "domain" | "has lexical unit" |  | "FN" |  |
| fn:biological_classification | fn:HasLexicalUnit | fn:lu:biological_classification:variety | "biological classification" | "variety" | "has lexical unit" |  | "FN" |  |
| fn:biological_classification | /r/HasA | fn:fe:rank | "biological classification" | "rank" | "/r/has a" |  | "FN" |  |
| fn:fe:member | /r/IsA | fn:st:living_thing | "member" | "living thing" | "/r/is a" |  | "FN" |  |
| fn:biological_classification | /r/HasA | fn:fe:member | "biological classification" | "member" | "/r/has a" |  | "FN" |  |
| fn:biological_classification | /r/HasA | fn:fe:subtype | "biological classification" | "subtype" | "/r/has a" |  | "FN" |  |
| fn:biological_classification | /r/HasA | fn:fe:property | "biological classification" | "property" | "/r/has a" |  | "FN" |  |
| fn:animals | /r/IsA | fn:biological_entity | "animals" | "biological entity" | "/r/is a" |  | "FN" |  |
| fn:people | /r/IsA | fn:biological_entity | "people" | "biological entity" | "/r/is a" |  | "FN" |  |
| fn:plants | /r/IsA | fn:biological_entity | "plants" | "biological entity" | "/r/is a" |  | "FN" |  |
| fn:biological_entity | /r/IsA | fn:entity | "biological entity" | "entity" | "/r/is a" |  | "FN" |  |
| fn:biological_entity | /r/UsedFor | fn:biological_classification | "biological entity" | "biological classification" | "/r/used for" |  | "FN" |  |
| fn:biological_entity | /r/UsedFor | fn:dead_or_alive | "biological entity" | "dead or alive" | "/r/used for" |  | "FN" |  |
| fn:biological_entity | /r/UsedFor | fn:gusto | "biological entity" | "gusto" | "/r/used for" |  | "FN" |  |
| fn:biological_entity | fn:HasLexicalUnit | fn:lu:biological_entity:life | "biological entity" | "life" | "has lexical unit" |  | "FN" |  |
| fn:biological_entity | fn:HasLexicalUnit | fn:lu:biological_entity:lifeform | "biological entity" | "lifeform" | "has lexical unit" |  | "FN" |  |
| fn:biological_entity | fn:HasLexicalUnit | fn:lu:biological_entity:organism | "biological entity" | "organism" | "has lexical unit" |  | "FN" |  |
| fn:biological_entity | fn:HasLexicalUnit | fn:lu:biological_entity:human | "biological entity" | "human" | "has lexical unit" |  | "FN" |  |
| fn:biological_entity | /r/HasA | fn:fe:organism | "biological entity" | "organism" | "/r/has a" |  | "FN" |  |
| fn:biological_entity | /r/HasA | fn:fe:descriptor | "biological entity" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:biological_entity | /r/HasA | fn:fe:origin | "biological entity" | "origin" | "/r/has a" |  | "FN" |  |
| fn:biological_mechanisms | fn:HasLexicalUnit | fn:lu:biological_mechanisms:increase | "biological mechanisms" | "increase" | "has lexical unit" |  | "FN" |  |
| fn:biological_mechanisms | fn:HasLexicalUnit | fn:lu:biological_mechanisms:impair | "biological mechanisms" | "impair" | "has lexical unit" |  | "FN" |  |
| fn:biological_mechanisms | fn:HasLexicalUnit | fn:lu:biological_mechanisms:stimulate | "biological mechanisms" | "stimulate" | "has lexical unit" |  | "FN" |  |
| fn:biological_mechanisms | fn:HasLexicalUnit | fn:lu:biological_mechanisms:inhibit | "biological mechanisms" | "inhibit" | "has lexical unit" |  | "FN" |  |
| fn:biological_mechanisms | fn:HasLexicalUnit | fn:lu:biological_mechanisms:catalyze | "biological mechanisms" | "catalyze" | "has lexical unit" |  | "FN" |  |
| fn:biological_mechanisms | /r/HasA | fn:fe:trigger | "biological mechanisms" | "trigger" | "/r/has a" |  | "FN" |  |
| fn:biological_mechanisms | /r/HasA | fn:fe:systemic_effect | "biological mechanisms" | "systemic effect" | "/r/has a" |  | "FN" |  |
| fn:biological_mechanisms | /r/HasA | fn:fe:place | "biological mechanisms" | "place" | "/r/has a" |  | "FN" |  |
| fn:biological_urge | /r/IsA | fn:gradable_attributes | "biological urge" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:tired | "biological urge" | "tired" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:sleepy | "biological urge" | "sleepy" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:randy | "biological urge" | "randy" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:hungry | "biological urge" | "hungry" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:thirsty | "biological urge" | "thirsty" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:horny | "biological urge" | "horny" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:turned_on | "biological urge" | "turned on" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:in_the_mood | "biological urge" | "in the mood" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:exhausted | "biological urge" | "exhausted" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:bushed | "biological urge" | "bushed" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:weary | "biological urge" | "weary" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:beat | "biological urge" | "beat" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:bone-weary | "biological urge" | "bone-weary" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:fatigued | "biological urge" | "fatigued" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:dog-tired | "biological urge" | "dog-tired" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:pooped | "biological urge" | "pooped" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:tuckered_out | "biological urge" | "tuckered out" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:tuckered | "biological urge" | "tuckered" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:worn_out | "biological urge" | "worn out" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:knackered | "biological urge" | "knackered" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:fatigue | "biological urge" | "fatigue" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:exhaustion | "biological urge" | "exhaustion" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:tiredness | "biological urge" | "tiredness" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:weariness | "biological urge" | "weariness" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:thirst | "biological urge" | "thirst" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:aroused | "biological urge" | "aroused" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:arousal | "biological urge" | "arousal" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:drowsy | "biological urge" | "drowsy" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:enervated | "biological urge" | "enervated" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:famished | "biological urge" | "famished" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:peckish | "biological urge" | "peckish" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:ravenous | "biological urge" | "ravenous" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:nauseous | "biological urge" | "nauseous" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:queasy | "biological urge" | "queasy" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:parched | "biological urge" | "parched" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:nausea | "biological urge" | "nausea" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:queasiness | "biological urge" | "queasiness" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:hunger | "biological urge" | "hunger" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:drowsiness | "biological urge" | "drowsiness" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:sleepiness | "biological urge" | "sleepiness" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:nauseated | "biological urge" | "nauseated" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:sick | "biological urge" | "sick" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:bilious | "biological urge" | "bilious" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:somnolent | "biological urge" | "somnolent" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:soporific | "biological urge" | "soporific" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:somnolence | "biological urge" | "somnolence" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:amorous | "biological urge" | "amorous" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:full | "biological urge" | "full" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | fn:HasLexicalUnit | fn:lu:biological_urge:sated | "biological urge" | "sated" | "has lexical unit" |  | "FN" |  |
| fn:biological_urge | /r/HasA | fn:fe:degree | "biological urge" | "degree" | "/r/has a" |  | "FN" |  |
| fn:fe:experiencer | /r/RelatedTo | fn:fe:expressor | "experiencer" | "expressor" | "/r/related to" |  | "FN" |  |
| fn:biological_urge | /r/HasA | fn:fe:experiencer | "biological urge" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:biological_urge | /r/HasA | fn:fe:time | "biological urge" | "time" | "/r/has a" |  | "FN" |  |
| fn:biological_urge | /r/HasA | fn:fe:place | "biological urge" | "place" | "/r/has a" |  | "FN" |  |
| fn:fe:expressor | /r/RelatedTo | fn:fe:state | "expressor" | "state" | "/r/related to" |  | "FN" |  |
| fn:biological_urge | /r/HasA | fn:fe:expressor | "biological urge" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:biological_urge | /r/HasA | fn:fe:duration | "biological urge" | "duration" | "/r/has a" |  | "FN" |  |
| fn:biological_urge | /r/HasA | fn:fe:explanation | "biological urge" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:fe:state | /r/RelatedTo | fn:fe:experiencer | "state" | "experiencer" | "/r/related to" |  | "FN" |  |
| fn:biological_urge | /r/HasA | fn:fe:state | "biological urge" | "state" | "/r/has a" |  | "FN" |  |
| fn:biological_urge | /r/HasA | fn:fe:parameter | "biological urge" | "parameter" | "/r/has a" |  | "FN" |  |
| fn:birth_scenario | /r/IsA | fn:event | "birth scenario" | "event" | "/r/is a" |  | "FN" |  |
| fn:sexual_reproduction_scenario | /r/HasSubevent | fn:birth_scenario | "sexual reproduction scenario" | "birth scenario" | "/r/has subevent" |  | "FN" |  |
| fn:being_born | /r/IsA | fn:birth_scenario | "being born" | "birth scenario" | "/r/is a" |  | "FN" |  |
| fn:giving_birth | /r/IsA | fn:birth_scenario | "giving birth" | "birth scenario" | "/r/is a" |  | "FN" |  |
| fn:birth_scenario | /r/HasA | fn:fe:offspring | "birth scenario" | "offspring" | "/r/has a" |  | "FN" |  |
| fn:fe:mother | /r/RelatedTo | fn:fe:parents | "mother" | "parents" | "/r/related to" |  | "FN" |  |
| fn:birth_scenario | /r/HasA | fn:fe:mother | "birth scenario" | "mother" | "/r/has a" |  | "FN" |  |
| fn:fe:father | /r/RelatedTo | fn:fe:parents | "father" | "parents" | "/r/related to" |  | "FN" |  |
| fn:birth_scenario | /r/HasA | fn:fe:father | "birth scenario" | "father" | "/r/has a" |  | "FN" |  |
| fn:birth_scenario | /r/HasA | fn:fe:parents | "birth scenario" | "parents" | "/r/has a" |  | "FN" |  |
| fn:birth_scenario | /r/HasA | fn:fe:time | "birth scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:birth_scenario | /r/HasA | fn:fe:place | "birth scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:birth_scenario | /r/HasA | fn:fe:manner | "birth scenario" | "manner" | "/r/has a" |  | "FN" |  |
| fn:ride_vehicle | /r/UsedFor | fn:board_vehicle | "ride vehicle" | "board vehicle" | "/r/used for" |  | "FN" |  |
| fn:board_vehicle | fn:HasLexicalUnit | fn:lu:board_vehicle:board | "board vehicle" | "board" | "has lexical unit" |  | "FN" |  |
| fn:board_vehicle | fn:HasLexicalUnit | fn:lu:board_vehicle:get | "board vehicle" | "get" | "has lexical unit" |  | "FN" |  |
| fn:board_vehicle | fn:HasLexicalUnit | fn:lu:board_vehicle:embark | "board vehicle" | "embark" | "has lexical unit" |  | "FN" |  |
| fn:board_vehicle | fn:HasLexicalUnit | fn:lu:board_vehicle:emplane | "board vehicle" | "emplane" | "has lexical unit" |  | "FN" |  |
| fn:board_vehicle | fn:HasLexicalUnit | fn:lu:board_vehicle:entrain | "board vehicle" | "entrain" | "has lexical unit" |  | "FN" |  |
| fn:board_vehicle | fn:HasLexicalUnit | fn:lu:board_vehicle:mount | "board vehicle" | "mount" | "has lexical unit" |  | "FN" |  |
| fn:board_vehicle | fn:HasLexicalUnit | fn:lu:board_vehicle:hop | "board vehicle" | "hop" | "has lexical unit" |  | "FN" |  |
| fn:board_vehicle | fn:HasLexicalUnit | fn:lu:board_vehicle:embarkation | "board vehicle" | "embarkation" | "has lexical unit" |  | "FN" |  |
| fn:board_vehicle | fn:HasLexicalUnit | fn:lu:board_vehicle:embarkment | "board vehicle" | "embarkment" | "has lexical unit" |  | "FN" |  |
| fn:board_vehicle | fn:HasLexicalUnit | fn:lu:board_vehicle:embus | "board vehicle" | "embus" | "has lexical unit" |  | "FN" |  |
| fn:board_vehicle | /r/HasA | fn:fe:traveller | "board vehicle" | "traveller" | "/r/has a" |  | "FN" |  |
| fn:board_vehicle | /r/HasA | fn:fe:vehicle | "board vehicle" | "vehicle" | "/r/has a" |  | "FN" |  |
| fn:board_vehicle | /r/HasA | fn:fe:source | "board vehicle" | "source" | "/r/has a" |  | "FN" |  |
| fn:board_vehicle | /r/HasA | fn:fe:manner | "board vehicle" | "manner" | "/r/has a" |  | "FN" |  |
| fn:board_vehicle | /r/HasA | fn:fe:path | "board vehicle" | "path" | "/r/has a" |  | "FN" |  |
| fn:board_vehicle | /r/HasA | fn:fe:duration_of_final_state | "board vehicle" | "duration of final state" | "/r/has a" |  | "FN" |  |
| fn:board_vehicle | /r/HasA | fn:fe:depictive | "board vehicle" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:board_vehicle | /r/HasA | fn:fe:time | "board vehicle" | "time" | "/r/has a" |  | "FN" |  |
| fn:board_vehicle | /r/HasA | fn:fe:cotheme | "board vehicle" | "cotheme" | "/r/has a" |  | "FN" |  |
| fn:board_vehicle | /r/HasA | fn:fe:purpose | "board vehicle" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:board_vehicle | /r/HasA | fn:fe:place | "board vehicle" | "place" | "/r/has a" |  | "FN" |  |
| fn:board_vehicle | /r/HasA | fn:fe:circumstances | "board vehicle" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:body_decoration | /r/IsA | fn:artifact | "body decoration" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:body_parts | /r/UsedFor | fn:body_decoration | "body parts" | "body decoration" | "/r/used for" |  | "FN" |  |
| fn:body_decoration | fn:HasLexicalUnit | fn:lu:body_decoration:tattoo | "body decoration" | "tattoo" | "has lexical unit" |  | "FN" |  |
| fn:body_decoration | fn:HasLexicalUnit | fn:lu:body_decoration:make-up | "body decoration" | "make-up" | "has lexical unit" |  | "FN" |  |
| fn:body_decoration | fn:HasLexicalUnit | fn:lu:body_decoration:mascara | "body decoration" | "mascara" | "has lexical unit" |  | "FN" |  |
| fn:body_decoration | fn:HasLexicalUnit | fn:lu:body_decoration:eyeliner | "body decoration" | "eyeliner" | "has lexical unit" |  | "FN" |  |
| fn:body_decoration | fn:HasLexicalUnit | fn:lu:body_decoration:rouge | "body decoration" | "rouge" | "has lexical unit" |  | "FN" |  |
| fn:body_decoration | fn:HasLexicalUnit | fn:lu:body_decoration:blusher | "body decoration" | "blusher" | "has lexical unit" |  | "FN" |  |
| fn:body_decoration | fn:HasLexicalUnit | fn:lu:body_decoration:concealer | "body decoration" | "concealer" | "has lexical unit" |  | "FN" |  |
| fn:body_decoration | fn:HasLexicalUnit | fn:lu:body_decoration:lipstick | "body decoration" | "lipstick" | "has lexical unit" |  | "FN" |  |
| fn:body_decoration | fn:HasLexicalUnit | fn:lu:body_decoration:foundation | "body decoration" | "foundation" | "has lexical unit" |  | "FN" |  |
| fn:body_decoration | fn:HasLexicalUnit | fn:lu:body_decoration:eyeshadow | "body decoration" | "eyeshadow" | "has lexical unit" |  | "FN" |  |
| fn:body_decoration | fn:HasLexicalUnit | fn:lu:body_decoration:kohl | "body decoration" | "kohl" | "has lexical unit" |  | "FN" |  |
| fn:body_decoration | /r/HasA | fn:fe:body_location | "body decoration" | "body location" | "/r/has a" |  | "FN" |  |
| fn:fe:decorated_individual | /r/IsA | fn:st:human | "decorated individual" | "human" | "/r/is a" |  | "FN" |  |
| fn:body_decoration | /r/HasA | fn:fe:decorated_individual | "body decoration" | "decorated individual" | "/r/has a" |  | "FN" |  |
| fn:fe:decoration | /r/IsA | fn:st:artifact | "decoration" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:body_decoration | /r/HasA | fn:fe:decoration | "body decoration" | "decoration" | "/r/has a" |  | "FN" |  |
| fn:body_decoration | /r/HasA | fn:fe:decoration_descriptor | "body decoration" | "decoration descriptor" | "/r/has a" |  | "FN" |  |
| fn:body_decoration | /r/HasA | fn:fe:picture | "body decoration" | "picture" | "/r/has a" |  | "FN" |  |
| fn:body_decoration | /r/HasA | fn:fe:use | "body decoration" | "use" | "/r/has a" |  | "FN" |  |
| fn:body_decoration | /r/HasA | fn:fe:type | "body decoration" | "type" | "/r/has a" |  | "FN" |  |
| fn:body_description_holistic | /r/IsA | fn:gradable_attributes | "body description holistic" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:lanky | "body description holistic" | "lanky" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:chubby | "body description holistic" | "chubby" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:flabby | "body description holistic" | "flabby" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:corpulent | "body description holistic" | "corpulent" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:obese | "body description holistic" | "obese" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:portly | "body description holistic" | "portly" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:svelte | "body description holistic" | "svelte" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:stocky | "body description holistic" | "stocky" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:dumpy | "body description holistic" | "dumpy" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:gaunt | "body description holistic" | "gaunt" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:skinny | "body description holistic" | "skinny" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:beefy | "body description holistic" | "beefy" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:short | "body description holistic" | "short" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:brawny | "body description holistic" | "brawny" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:paunchy | "body description holistic" | "paunchy" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:fat | "body description holistic" | "fat" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:thin | "body description holistic" | "thin" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:spindly | "body description holistic" | "spindly" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:slim | "body description holistic" | "slim" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:slender | "body description holistic" | "slender" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:puny | "body description holistic" | "puny" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:scrawny | "body description holistic" | "scrawny" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:heavy-set | "body description holistic" | "heavy-set" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:stout | "body description holistic" | "stout" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:stubby | "body description holistic" | "stubby" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:tall | "body description holistic" | "tall" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:muscular | "body description holistic" | "muscular" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:lean | "body description holistic" | "lean" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:angular | "body description holistic" | "angular" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:bony | "body description holistic" | "bony" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:rangy | "body description holistic" | "rangy" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:squat | "body description holistic" | "squat" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:thickset | "body description holistic" | "thickset" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:lithe | "body description holistic" | "lithe" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:plump | "body description holistic" | "plump" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:pudgy | "body description holistic" | "pudgy" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:wiry | "body description holistic" | "wiry" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:hefty | "body description holistic" | "hefty" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:medium-build | "body description holistic" | "medium-build" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:big-boned | "body description holistic" | "big-boned" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:male | "body description holistic" | "male" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | fn:HasLexicalUnit | fn:lu:body_description_holistic:female | "body description holistic" | "female" | "has lexical unit" |  | "FN" |  |
| fn:body_description_holistic | /r/HasA | fn:fe:degree | "body description holistic" | "degree" | "/r/has a" |  | "FN" |  |
| fn:fe:individual | /r/IsA | fn:st:human | "individual" | "human" | "/r/is a" |  | "FN" |  |
| fn:body_description_holistic | /r/HasA | fn:fe:individual | "body description holistic" | "individual" | "/r/has a" |  | "FN" |  |
| fn:body_description_holistic | /r/HasA | fn:fe:figure | "body description holistic" | "figure" | "/r/has a" |  | "FN" |  |
| fn:body_description_part | /r/IsA | fn:gradable_attributes | "body description part" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:body_parts | /r/UsedFor | fn:body_description_part | "body parts" | "body description part" | "/r/used for" |  | "FN" |  |
| fn:body_description_part | fn:HasLexicalUnit | fn:lu:body_description_part:blonde | "body description part" | "blonde" | "has lexical unit" |  | "FN" |  |
| fn:body_description_part | fn:HasLexicalUnit | fn:lu:body_description_part:brunette | "body description part" | "brunette" | "has lexical unit" |  | "FN" |  |
| fn:body_description_part | fn:HasLexicalUnit | fn:lu:body_description_part:blue-eyed | "body description part" | "blue-eyed" | "has lexical unit" |  | "FN" |  |
| fn:body_description_part | fn:HasLexicalUnit | fn:lu:body_description_part:redhead | "body description part" | "redhead" | "has lexical unit" |  | "FN" |  |
| fn:body_description_part | fn:HasLexicalUnit | fn:lu:body_description_part:flat-footed | "body description part" | "flat-footed" | "has lexical unit" |  | "FN" |  |
| fn:body_description_part | fn:HasLexicalUnit | fn:lu:body_description_part:albino | "body description part" | "albino" | "has lexical unit" |  | "FN" |  |
| fn:body_description_part | fn:HasLexicalUnit | fn:lu:body_description_part:albino | "body description part" | "albino" | "has lexical unit" |  | "FN" |  |
| fn:body_description_part | fn:HasLexicalUnit | fn:lu:body_description_part:knock-kneed | "body description part" | "knock-kneed" | "has lexical unit" |  | "FN" |  |
| fn:body_description_part | fn:HasLexicalUnit | fn:lu:body_description_part:bow-legged | "body description part" | "bow-legged" | "has lexical unit" |  | "FN" |  |
| fn:body_description_part | fn:HasLexicalUnit | fn:lu:body_description_part:cross-eyed | "body description part" | "cross-eyed" | "has lexical unit" |  | "FN" |  |
| fn:body_description_part | fn:HasLexicalUnit | fn:lu:body_description_part:black-haired | "body description part" | "black-haired" | "has lexical unit" |  | "FN" |  |
| fn:body_description_part | fn:HasLexicalUnit | fn:lu:body_description_part:grey-haired | "body description part" | "grey-haired" | "has lexical unit" |  | "FN" |  |
| fn:body_description_part | fn:HasLexicalUnit | fn:lu:body_description_part:bearded | "body description part" | "bearded" | "has lexical unit" |  | "FN" |  |
| fn:body_description_part | fn:HasLexicalUnit | fn:lu:body_description_part:moustached | "body description part" | "moustached" | "has lexical unit" |  | "FN" |  |
| fn:body_description_part | fn:HasLexicalUnit | fn:lu:body_description_part:pigtailed | "body description part" | "pigtailed" | "has lexical unit" |  | "FN" |  |
| fn:body_description_part | fn:HasLexicalUnit | fn:lu:body_description_part:red-haired | "body description part" | "red-haired" | "has lexical unit" |  | "FN" |  |
| fn:body_description_part | fn:HasLexicalUnit | fn:lu:body_description_part:peg-leg | "body description part" | "peg-leg" | "has lexical unit" |  | "FN" |  |
| fn:body_description_part | fn:HasLexicalUnit | fn:lu:body_description_part:fair | "body description part" | "fair" | "has lexical unit" |  | "FN" |  |
| fn:body_description_part | /r/HasA | fn:fe:individual | "body description part" | "individual" | "/r/has a" |  | "FN" |  |
| fn:body_description_part | /r/HasA | fn:fe:figure | "body description part" | "figure" | "/r/has a" |  | "FN" |  |
| fn:body_description_part | /r/HasA | fn:fe:degree | "body description part" | "degree" | "/r/has a" |  | "FN" |  |
| fn:body_mark | /r/IsA | fn:physical_entity | "body mark" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:body_parts | /r/UsedFor | fn:body_mark | "body parts" | "body mark" | "/r/used for" |  | "FN" |  |
| fn:body_mark | fn:HasLexicalUnit | fn:lu:body_mark:wart | "body mark" | "wart" | "has lexical unit" |  | "FN" |  |
| fn:body_mark | fn:HasLexicalUnit | fn:lu:body_mark:pimple | "body mark" | "pimple" | "has lexical unit" |  | "FN" |  |
| fn:body_mark | fn:HasLexicalUnit | fn:lu:body_mark:blackhead | "body mark" | "blackhead" | "has lexical unit" |  | "FN" |  |
| fn:body_mark | fn:HasLexicalUnit | fn:lu:body_mark:scar | "body mark" | "scar" | "has lexical unit" |  | "FN" |  |
| fn:body_mark | fn:HasLexicalUnit | fn:lu:body_mark:mole | "body mark" | "mole" | "has lexical unit" |  | "FN" |  |
| fn:body_mark | fn:HasLexicalUnit | fn:lu:body_mark:blemish | "body mark" | "blemish" | "has lexical unit" |  | "FN" |  |
| fn:body_mark | fn:HasLexicalUnit | fn:lu:body_mark:birthmark | "body mark" | "birthmark" | "has lexical unit" |  | "FN" |  |
| fn:body_mark | fn:HasLexicalUnit | fn:lu:body_mark:freckle | "body mark" | "freckle" | "has lexical unit" |  | "FN" |  |
| fn:body_mark | fn:HasLexicalUnit | fn:lu:body_mark:zit | "body mark" | "zit" | "has lexical unit" |  | "FN" |  |
| fn:body_mark | fn:HasLexicalUnit | fn:lu:body_mark:boil | "body mark" | "boil" | "has lexical unit" |  | "FN" |  |
| fn:body_mark | fn:HasLexicalUnit | fn:lu:body_mark:blister | "body mark" | "blister" | "has lexical unit" |  | "FN" |  |
| fn:body_mark | fn:HasLexicalUnit | fn:lu:body_mark:rash | "body mark" | "rash" | "has lexical unit" |  | "FN" |  |
| fn:body_mark | fn:HasLexicalUnit | fn:lu:body_mark:love_bite | "body mark" | "love bite" | "has lexical unit" |  | "FN" |  |
| fn:body_mark | fn:HasLexicalUnit | fn:lu:body_mark:liver_spot | "body mark" | "liver spot" | "has lexical unit" |  | "FN" |  |
| fn:body_mark | fn:HasLexicalUnit | fn:lu:body_mark:blotch | "body mark" | "blotch" | "has lexical unit" |  | "FN" |  |
| fn:body_mark | fn:HasLexicalUnit | fn:lu:body_mark:pustule | "body mark" | "pustule" | "has lexical unit" |  | "FN" |  |
| fn:body_mark | fn:HasLexicalUnit | fn:lu:body_mark:cold_sore | "body mark" | "cold sore" | "has lexical unit" |  | "FN" |  |
| fn:body_mark | fn:HasLexicalUnit | fn:lu:body_mark:callus | "body mark" | "callus" | "has lexical unit" |  | "FN" |  |
| fn:body_mark | fn:HasLexicalUnit | fn:lu:body_mark:sore | "body mark" | "sore" | "has lexical unit" |  | "FN" |  |
| fn:body_mark | fn:HasLexicalUnit | fn:lu:body_mark:bedsore | "body mark" | "bedsore" | "has lexical unit" |  | "FN" |  |
| fn:body_mark | fn:HasLexicalUnit | fn:lu:body_mark:acne | "body mark" | "acne" | "has lexical unit" |  | "FN" |  |
| fn:body_mark | /r/HasA | fn:fe:attachment | "body mark" | "attachment" | "/r/has a" |  | "FN" |  |
| fn:fe:body_mark | /r/IsA | fn:st:artifact | "body mark" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:body_mark | /r/HasA | fn:fe:body_mark | "body mark" | "body mark" | "/r/has a" |  | "FN" |  |
| fn:body_mark | /r/HasA | fn:fe:descriptor | "body mark" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:body_mark | /r/HasA | fn:fe:possessor | "body mark" | "possessor" | "/r/has a" |  | "FN" |  |
| fn:body_mark | /r/HasA | fn:fe:cause | "body mark" | "cause" | "/r/has a" |  | "FN" |  |
| fn:body_mark | /r/HasA | fn:fe:type | "body mark" | "type" | "/r/has a" |  | "FN" |  |
| fn:body_mark | /r/HasA | fn:fe:constituents | "body mark" | "constituents" | "/r/has a" |  | "FN" |  |
| fn:body_movement | /r/UsedFor | fn:facial_expression | "body movement" | "facial expression" | "/r/used for" |  | "FN" |  |
| fn:body_parts | /r/UsedFor | fn:body_movement | "body parts" | "body movement" | "/r/used for" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:body_movement | "motion" | "body movement" | "/r/used for" |  | "FN" |  |
| fn:body_movement | /r/SimilarTo | fn:making_faces | "body movement" | "making faces" | "/r/similar to" |  | "FN" |  |
| fn:body_movement | /r/SimilarTo | fn:statement | "body movement" | "statement" | "/r/similar to" |  | "FN" |  |
| fn:self_motion | /r/SimilarTo | fn:body_movement | "self motion" | "body movement" | "/r/similar to" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:arch | "body movement" | "arch" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:bat | "body movement" | "bat" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:bend | "body movement" | "bend" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:blink | "body movement" | "blink" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:bob | "body movement" | "bob" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:clap | "body movement" | "clap" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:cock | "body movement" | "cock" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:crane | "body movement" | "crane" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:cross | "body movement" | "cross" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:drop | "body movement" | "drop" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:flap | "body movement" | "flap" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:flex | "body movement" | "flex" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:fling | "body movement" | "fling" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:flutter | "body movement" | "flutter" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:gnash | "body movement" | "gnash" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:grind | "body movement" | "grind" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:hang | "body movement" | "hang" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:jerk | "body movement" | "jerk" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:lift | "body movement" | "lift" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:nod | "body movement" | "nod" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:pout | "body movement" | "pout" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:pucker | "body movement" | "pucker" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:purse | "body movement" | "purse" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:roll | "body movement" | "roll" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:shake | "body movement" | "shake" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:shrug | "body movement" | "shrug" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:shuffle | "body movement" | "shuffle" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:stretch | "body movement" | "stretch" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:swing | "body movement" | "swing" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:throw | "body movement" | "throw" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:toss | "body movement" | "toss" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:twitch | "body movement" | "twitch" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:wag | "body movement" | "wag" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:waggle | "body movement" | "waggle" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:wave | "body movement" | "wave" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:wiggle | "body movement" | "wiggle" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:wink | "body movement" | "wink" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:wrinkle | "body movement" | "wrinkle" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:curtsy | "body movement" | "curtsy" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:kneel | "body movement" | "kneel" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:writhe | "body movement" | "writhe" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:wriggle | "body movement" | "wriggle" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:shudder | "body movement" | "shudder" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:fidget | "body movement" | "fidget" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:yawn | "body movement" | "yawn" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:jiggle | "body movement" | "jiggle" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:shiver | "body movement" | "shiver" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:curtsy | "body movement" | "curtsy" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:duck | "body movement" | "duck" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:crease | "body movement" | "crease" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:smack | "body movement" | "smack" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:open | "body movement" | "open" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:close | "body movement" | "close" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:shut | "body movement" | "shut" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:twiddle | "body movement" | "twiddle" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:stamp | "body movement" | "stamp" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:crinkle | "body movement" | "crinkle" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:crumple | "body movement" | "crumple" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:scrunch | "body movement" | "scrunch" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:move | "body movement" | "move" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:twist | "body movement" | "twist" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:wink | "body movement" | "wink" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | fn:HasLexicalUnit | fn:lu:body_movement:reach | "body movement" | "reach" | "has lexical unit" |  | "FN" |  |
| fn:body_movement | /r/HasA | fn:fe:agent | "body movement" | "agent" | "/r/has a" |  | "FN" |  |
| fn:fe:body_part | /r/IsA | fn:st:body_part | "body part" | "body part" | "/r/is a" |  | "FN" |  |
| fn:st:body_part | /r/IsA | fn:st:ontological_type | "body part" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:body_movement | /r/HasA | fn:fe:body_part | "body movement" | "body part" | "/r/has a" |  | "FN" |  |
| fn:body_movement | /r/HasA | fn:fe:internal_cause | "body movement" | "internal cause" | "/r/has a" |  | "FN" |  |
| fn:body_movement | /r/HasA | fn:fe:external_cause | "body movement" | "external cause" | "/r/has a" |  | "FN" |  |
| fn:body_movement | /r/HasA | fn:fe:addressee | "body movement" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:body_movement | /r/HasA | fn:fe:source | "body movement" | "source" | "/r/has a" |  | "FN" |  |
| fn:body_movement | /r/HasA | fn:fe:path | "body movement" | "path" | "/r/has a" |  | "FN" |  |
| fn:body_movement | /r/HasA | fn:fe:goal | "body movement" | "goal" | "/r/has a" |  | "FN" |  |
| fn:body_movement | /r/HasA | fn:fe:area | "body movement" | "area" | "/r/has a" |  | "FN" |  |
| fn:body_movement | /r/HasA | fn:fe:degree | "body movement" | "degree" | "/r/has a" |  | "FN" |  |
| fn:body_movement | /r/HasA | fn:fe:depictive | "body movement" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:body_movement | /r/HasA | fn:fe:manner | "body movement" | "manner" | "/r/has a" |  | "FN" |  |
| fn:body_movement | /r/HasA | fn:fe:result | "body movement" | "result" | "/r/has a" |  | "FN" |  |
| fn:body_movement | /r/HasA | fn:fe:message | "body movement" | "message" | "/r/has a" |  | "FN" |  |
| fn:body_movement | /r/HasA | fn:fe:time | "body movement" | "time" | "/r/has a" |  | "FN" |  |
| fn:body_movement | /r/HasA | fn:fe:subregion | "body movement" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:body_movement | /r/HasA | fn:fe:purpose | "body movement" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:body_movement | /r/HasA | fn:fe:cognate_event | "body movement" | "cognate event" | "/r/has a" |  | "FN" |  |
| fn:body_movement | /r/HasA | fn:fe:duration | "body movement" | "duration" | "/r/has a" |  | "FN" |  |
| fn:body_movement | /r/HasA | fn:fe:place | "body movement" | "place" | "/r/has a" |  | "FN" |  |
| fn:body_movement | /r/HasA | fn:fe:re-encoding | "body movement" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:body_movement | /r/HasA | fn:fe:coordinated_event | "body movement" | "coordinated event" | "/r/has a" |  | "FN" |  |
| fn:body_parts | /r/IsA | fn:shaped_part | "body parts" | "shaped part" | "/r/is a" |  | "FN" |  |
| fn:body_parts | /r/UsedFor | fn:body_decoration | "body parts" | "body decoration" | "/r/used for" |  | "FN" |  |
| fn:body_parts | /r/UsedFor | fn:body_description_part | "body parts" | "body description part" | "/r/used for" |  | "FN" |  |
| fn:body_parts | /r/UsedFor | fn:body_mark | "body parts" | "body mark" | "/r/used for" |  | "FN" |  |
| fn:body_parts | /r/UsedFor | fn:body_movement | "body parts" | "body movement" | "/r/used for" |  | "FN" |  |
| fn:body_parts | /r/UsedFor | fn:hair_configuration | "body parts" | "hair configuration" | "/r/used for" |  | "FN" |  |
| fn:body_parts | /r/UsedFor | fn:manipulation | "body parts" | "manipulation" | "/r/used for" |  | "FN" |  |
| fn:body_parts | /r/UsedFor | fn:medical_conditions | "body parts" | "medical conditions" | "/r/used for" |  | "FN" |  |
| fn:body_parts | /r/UsedFor | fn:wearing | "body parts" | "wearing" | "/r/used for" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:arm | "body parts" | "arm" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:ankle | "body parts" | "ankle" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:anus | "body parts" | "anus" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:back | "body parts" | "back" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:beard | "body parts" | "beard" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:belly | "body parts" | "belly" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:body | "body parts" | "body" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:breast | "body parts" | "breast" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:buttocks | "body parts" | "buttocks" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:cheek | "body parts" | "cheek" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:chest | "body parts" | "chest" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:chin | "body parts" | "chin" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:ear | "body parts" | "ear" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:earlobe | "body parts" | "earlobe" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:elbow | "body parts" | "elbow" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:eyelid | "body parts" | "eyelid" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:face | "body parts" | "face" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:finger | "body parts" | "finger" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:flesh | "body parts" | "flesh" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:foot | "body parts" | "foot" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:forearm | "body parts" | "forearm" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:forehead | "body parts" | "forehead" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:groin | "body parts" | "groin" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:hair | "body parts" | "hair" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:hand | "body parts" | "hand" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:head | "body parts" | "head" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:heel | "body parts" | "heel" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:incisor | "body parts" | "incisor" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:jaw | "body parts" | "jaw" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:toe | "body parts" | "toe" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:hoof | "body parts" | "hoof" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:claw | "body parts" | "claw" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:paw | "body parts" | "paw" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:talon | "body parts" | "talon" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:wing | "body parts" | "wing" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:pelt | "body parts" | "pelt" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:snout | "body parts" | "snout" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:maw | "body parts" | "maw" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:fang | "body parts" | "fang" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:mane | "body parts" | "mane" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:whisker | "body parts" | "whisker" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:feeler | "body parts" | "feeler" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:antler | "body parts" | "antler" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:muzzle | "body parts" | "muzzle" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:beak | "body parts" | "beak" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:trunk | "body parts" | "trunk" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:tail | "body parts" | "tail" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:eye | "body parts" | "eye" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:foreleg | "body parts" | "foreleg" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:forefoot | "body parts" | "forefoot" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:forepaw | "body parts" | "forepaw" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:limb | "body parts" | "limb" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:fin | "body parts" | "fin" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:flipper | "body parts" | "flipper" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:horn | "body parts" | "horn" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:nape | "body parts" | "nape" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:nose | "body parts" | "nose" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:antenna | "body parts" | "antenna" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:fluke | "body parts" | "fluke" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:skin | "body parts" | "skin" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:forelimb | "body parts" | "forelimb" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:hindlimb | "body parts" | "hindlimb" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:hindleg | "body parts" | "hindleg" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:fingertip | "body parts" | "fingertip" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:brow | "body parts" | "brow" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:lip | "body parts" | "lip" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:temple | "body parts" | "temple" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:fingernail | "body parts" | "fingernail" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:tongue | "body parts" | "tongue" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:toenail | "body parts" | "toenail" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:thumb | "body parts" | "thumb" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:nostril | "body parts" | "nostril" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:sole | "body parts" | "sole" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:midriff | "body parts" | "midriff" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:navel | "body parts" | "navel" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:neck | "body parts" | "neck" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:hindquarters | "body parts" | "hindquarters" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:forefinger | "body parts" | "forefinger" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:thigh | "body parts" | "thigh" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:mouth | "body parts" | "mouth" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:tentacle | "body parts" | "tentacle" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:bill | "body parts" | "bill" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:appendage | "body parts" | "appendage" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:thorax | "body parts" | "thorax" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:rump | "body parts" | "rump" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:crown | "body parts" | "crown" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:member | "body parts" | "member" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:leg | "body parts" | "leg" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:shoulder | "body parts" | "shoulder" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:tooth | "body parts" | "tooth" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:mustache | "body parts" | "mustache" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:knee | "body parts" | "knee" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:pupil | "body parts" | "pupil" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:throat | "body parts" | "throat" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | fn:HasLexicalUnit | fn:lu:body_parts:lung | "body parts" | "lung" | "has lexical unit" |  | "FN" |  |
| fn:body_parts | /r/HasA | fn:fe:possessor | "body parts" | "possessor" | "/r/has a" |  | "FN" |  |
| fn:body_parts | /r/HasA | fn:fe:descriptor | "body parts" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:body_parts | /r/HasA | fn:fe:body_part | "body parts" | "body part" | "/r/has a" |  | "FN" |  |
| fn:body_parts | /r/HasA | fn:fe:subregion | "body parts" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:body_parts | /r/HasA | fn:fe:orientational_location | "body parts" | "orientational location" | "/r/has a" |  | "FN" |  |
| fn:body_parts | /r/HasA | fn:fe:attachment | "body parts" | "attachment" | "/r/has a" |  | "FN" |  |
| fn:repayment | /r/UsedFor | fn:bond_maturation | "repayment" | "bond maturation" | "/r/used for" |  | "FN" |  |
| fn:bond_maturation | fn:HasLexicalUnit | fn:lu:bond_maturation:mature | "bond maturation" | "mature" | "has lexical unit" |  | "FN" |  |
| fn:bond_maturation | fn:HasLexicalUnit | fn:lu:bond_maturation:maturity | "bond maturation" | "maturity" | "has lexical unit" |  | "FN" |  |
| fn:bond_maturation | fn:HasLexicalUnit | fn:lu:bond_maturation:endow | "bond maturation" | "endow" | "has lexical unit" |  | "FN" |  |
| fn:bond_maturation | /r/HasA | fn:fe:financial_instrument | "bond maturation" | "financial instrument" | "/r/has a" |  | "FN" |  |
| fn:bond_maturation | /r/HasA | fn:fe:time | "bond maturation" | "time" | "/r/has a" |  | "FN" |  |
| fn:bond_maturation | /r/HasA | fn:fe:issuer | "bond maturation" | "issuer" | "/r/has a" |  | "FN" |  |
| fn:bond_maturation | /r/HasA | fn:fe:holder | "bond maturation" | "holder" | "/r/has a" |  | "FN" |  |
| fn:bond_maturation | /r/HasA | fn:fe:value | "bond maturation" | "value" | "/r/has a" |  | "FN" |  |
| fn:bond_maturation | /r/HasA | fn:fe:principle | "bond maturation" | "principle" | "/r/has a" |  | "FN" |  |
| fn:bond_maturation | /r/HasA | fn:fe:interest | "bond maturation" | "interest" | "/r/has a" |  | "FN" |  |
| fn:borrowing | /r/IsA | fn:receiving | "borrowing" | "receiving" | "/r/is a" |  | "FN" |  |
| fn:borrowing | /r/IsA | fn:temporary_transfer_scenario | "borrowing" | "temporary transfer scenario" | "/r/is a" |  | "FN" |  |
| fn:borrowing | fn:HasLexicalUnit | fn:lu:borrowing:borrow | "borrowing" | "borrow" | "has lexical unit" |  | "FN" |  |
| fn:borrowing | /r/HasA | fn:fe:borrower | "borrowing" | "borrower" | "/r/has a" |  | "FN" |  |
| fn:borrowing | /r/HasA | fn:fe:duration | "borrowing" | "duration" | "/r/has a" |  | "FN" |  |
| fn:fe:lender | /r/IsA | fn:st:source | "lender" | "source" | "/r/is a" |  | "FN" |  |
| fn:borrowing | /r/HasA | fn:fe:lender | "borrowing" | "lender" | "/r/has a" |  | "FN" |  |
| fn:borrowing | /r/HasA | fn:fe:theme | "borrowing" | "theme" | "/r/has a" |  | "FN" |  |
| fn:borrowing | /r/HasA | fn:fe:purpose | "borrowing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:borrowing | /r/HasA | fn:fe:time | "borrowing" | "time" | "/r/has a" |  | "FN" |  |
| fn:borrowing | /r/HasA | fn:fe:means_of_transfer | "borrowing" | "means of transfer" | "/r/has a" |  | "FN" |  |
| fn:borrowing | /r/HasA | fn:fe:place | "borrowing" | "place" | "/r/has a" |  | "FN" |  |
| fn:borrowing | /r/HasA | fn:fe:manner | "borrowing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:boundary | /r/UsedFor | fn:bounded_entity | "boundary" | "bounded entity" | "/r/used for" |  | "FN" |  |
| fn:boundary | fn:HasLexicalUnit | fn:lu:boundary:border | "boundary" | "border" | "has lexical unit" |  | "FN" |  |
| fn:boundary | fn:HasLexicalUnit | fn:lu:boundary:boundary | "boundary" | "boundary" | "has lexical unit" |  | "FN" |  |
| fn:boundary | fn:HasLexicalUnit | fn:lu:boundary:edge | "boundary" | "edge" | "has lexical unit" |  | "FN" |  |
| fn:boundary | fn:HasLexicalUnit | fn:lu:boundary:line | "boundary" | "line" | "has lexical unit" |  | "FN" |  |
| fn:boundary | /r/HasA | fn:fe:boundary | "boundary" | "boundary" | "/r/has a" |  | "FN" |  |
| fn:boundary | /r/HasA | fn:fe:entity | "boundary" | "entity" | "/r/has a" |  | "FN" |  |
| fn:boundary | /r/HasA | fn:fe:entities | "boundary" | "entities" | "/r/has a" |  | "FN" |  |
| fn:boundary | /r/HasA | fn:fe:relative_location | "boundary" | "relative location" | "/r/has a" |  | "FN" |  |
| fn:bounded_entity | /r/IsA | fn:physical_entity | "bounded entity" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:being_located | /r/UsedFor | fn:bounded_entity | "being located" | "bounded entity" | "/r/used for" |  | "FN" |  |
| fn:boundary | /r/UsedFor | fn:bounded_entity | "boundary" | "bounded entity" | "/r/used for" |  | "FN" |  |
| fn:bounded_entity | /r/UsedFor | fn:containers | "bounded entity" | "containers" | "/r/used for" |  | "FN" |  |
| fn:bounded_entity | /r/UsedFor | fn:locale | "bounded entity" | "locale" | "/r/used for" |  | "FN" |  |
| fn:bounded_entity | /r/UsedFor | fn:shapes | "bounded entity" | "shapes" | "/r/used for" |  | "FN" |  |
| fn:bounded_entity | /r/HasA | fn:fe:bounded_area | "bounded entity" | "bounded area" | "/r/has a" |  | "FN" |  |
| fn:bounded_entity | /r/HasA | fn:fe:constituent_parts | "bounded entity" | "constituent parts" | "/r/has a" |  | "FN" |  |
| fn:bounded_entity | /r/HasA | fn:fe:relative_location | "bounded entity" | "relative location" | "/r/has a" |  | "FN" |  |
| fn:bounded_entity | /r/HasA | fn:fe:name | "bounded entity" | "name" | "/r/has a" |  | "FN" |  |
| fn:bounded_entity | /r/HasA | fn:fe:owner | "bounded entity" | "owner" | "/r/has a" |  | "FN" |  |
| fn:bounded_entity | /r/HasA | fn:fe:formational_cause | "bounded entity" | "formational cause" | "/r/has a" |  | "FN" |  |
| fn:bounded_entity | /r/HasA | fn:fe:type | "bounded entity" | "type" | "/r/has a" |  | "FN" |  |
| fn:region_with_portal | /r/IsA | fn:bounded_region | "region with portal" | "bounded region" | "/r/is a" |  | "FN" |  |
| fn:bounded_region | /r/IsA | fn:image_schema | "bounded region" | "image schema" | "/r/is a" |  | "FN" |  |
| fn:bounded_region | /r/UsedFor | fn:interior_profile_relation | "bounded region" | "interior profile relation" | "/r/used for" |  | "FN" |  |
| fn:bounded_region | /r/HasA | fn:fe:interior | "bounded region" | "interior" | "/r/has a" |  | "FN" |  |
| fn:bounded_region | /r/HasA | fn:fe:ground | "bounded region" | "ground" | "/r/has a" |  | "FN" |  |
| fn:bounded_region | /r/HasA | fn:fe:surface | "bounded region" | "surface" | "/r/has a" |  | "FN" |  |
| fn:bounded_region | /r/HasA | fn:fe:boundary | "bounded region" | "boundary" | "/r/has a" |  | "FN" |  |
| fn:bounded_region | /r/HasA | fn:fe:exterior | "bounded region" | "exterior" | "/r/has a" |  | "FN" |  |
| fn:bragging | /r/IsA | fn:judgment_communication | "bragging" | "judgment communication" | "/r/is a" |  | "FN" |  |
| fn:statement | /r/SimilarTo | fn:bragging | "statement" | "bragging" | "/r/similar to" |  | "FN" |  |
| fn:bragging | fn:HasLexicalUnit | fn:lu:bragging:brag | "bragging" | "brag" | "has lexical unit" |  | "FN" |  |
| fn:bragging | fn:HasLexicalUnit | fn:lu:bragging:boast | "bragging" | "boast" | "has lexical unit" |  | "FN" |  |
| fn:bragging | fn:HasLexicalUnit | fn:lu:bragging:boast | "bragging" | "boast" | "has lexical unit" |  | "FN" |  |
| fn:bragging | fn:HasLexicalUnit | fn:lu:bragging:preen | "bragging" | "preen" | "has lexical unit" |  | "FN" |  |
| fn:bragging | fn:HasLexicalUnit | fn:lu:bragging:rodomontade | "bragging" | "rodomontade" | "has lexical unit" |  | "FN" |  |
| fn:bragging | fn:HasLexicalUnit | fn:lu:bragging:vaunt | "bragging" | "vaunt" | "has lexical unit" |  | "FN" |  |
| fn:bragging | fn:HasLexicalUnit | fn:lu:bragging:boastful | "bragging" | "boastful" | "has lexical unit" |  | "FN" |  |
| fn:bragging | fn:HasLexicalUnit | fn:lu:bragging:rodomontade | "bragging" | "rodomontade" | "has lexical unit" |  | "FN" |  |
| fn:bragging | fn:HasLexicalUnit | fn:lu:bragging:gripe | "bragging" | "gripe" | "has lexical unit" |  | "FN" |  |
| fn:bragging | fn:HasLexicalUnit | fn:lu:bragging:braggart | "bragging" | "braggart" | "has lexical unit" |  | "FN" |  |
| fn:bragging | /r/HasA | fn:fe:speaker | "bragging" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:bragging | /r/HasA | fn:fe:addressee | "bragging" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:bragging | /r/HasA | fn:fe:topic | "bragging" | "topic" | "/r/has a" |  | "FN" |  |
| fn:bragging | /r/HasA | fn:fe:manner | "bragging" | "manner" | "/r/has a" |  | "FN" |  |
| fn:bragging | /r/HasA | fn:fe:means | "bragging" | "means" | "/r/has a" |  | "FN" |  |
| fn:bragging | /r/HasA | fn:fe:medium | "bragging" | "medium" | "/r/has a" |  | "FN" |  |
| fn:bragging | /r/HasA | fn:fe:depictive | "bragging" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:bragging | /r/HasA | fn:fe:time | "bragging" | "time" | "/r/has a" |  | "FN" |  |
| fn:bragging | /r/HasA | fn:fe:place | "bragging" | "place" | "/r/has a" |  | "FN" |  |
| fn:bragging | /r/HasA | fn:fe:explanation | "bragging" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:bragging | /r/HasA | fn:fe:message | "bragging" | "message" | "/r/has a" |  | "FN" |  |
| fn:bragging | /r/HasA | fn:fe:role | "bragging" | "role" | "/r/has a" |  | "FN" |  |
| fn:bragging | /r/HasA | fn:fe:expressor | "bragging" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:bragging | /r/HasA | fn:fe:occasion | "bragging" | "occasion" | "/r/has a" |  | "FN" |  |
| fn:bragging | /r/HasA | fn:fe:particular_iteration | "bragging" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:bragging | /r/HasA | fn:fe:internal_cause | "bragging" | "internal cause" | "/r/has a" |  | "FN" |  |
| fn:bragging | /r/HasA | fn:fe:degree | "bragging" | "degree" | "/r/has a" |  | "FN" |  |
| fn:cause_to_fragment | /r/Causes | fn:breaking_apart | "cause to fragment" | "breaking apart" | "/r/causes" |  | "FN" |  |
| fn:breaking_apart | /r/IsA | fn:fragmentation_scenario | "breaking apart" | "fragmentation scenario" | "/r/is a" |  | "FN" |  |
| fn:breaking_apart | fn:HasLexicalUnit | fn:lu:breaking_apart:break_apart | "breaking apart" | "break apart" | "has lexical unit" |  | "FN" |  |
| fn:breaking_apart | fn:HasLexicalUnit | fn:lu:breaking_apart:break_down | "breaking apart" | "break down" | "has lexical unit" |  | "FN" |  |
| fn:breaking_apart | fn:HasLexicalUnit | fn:lu:breaking_apart:fragment | "breaking apart" | "fragment" | "has lexical unit" |  | "FN" |  |
| fn:breaking_apart | fn:HasLexicalUnit | fn:lu:breaking_apart:shatter | "breaking apart" | "shatter" | "has lexical unit" |  | "FN" |  |
| fn:breaking_apart | fn:HasLexicalUnit | fn:lu:breaking_apart:splinter | "breaking apart" | "splinter" | "has lexical unit" |  | "FN" |  |
| fn:breaking_apart | fn:HasLexicalUnit | fn:lu:breaking_apart:snap | "breaking apart" | "snap" | "has lexical unit" |  | "FN" |  |
| fn:breaking_apart | fn:HasLexicalUnit | fn:lu:breaking_apart:break | "breaking apart" | "break" | "has lexical unit" |  | "FN" |  |
| fn:breaking_apart | fn:HasLexicalUnit | fn:lu:breaking_apart:crumble | "breaking apart" | "crumble" | "has lexical unit" |  | "FN" |  |
| fn:breaking_apart | /r/HasA | fn:fe:whole | "breaking apart" | "whole" | "/r/has a" |  | "FN" |  |
| fn:breaking_apart | /r/HasA | fn:fe:pieces | "breaking apart" | "pieces" | "/r/has a" |  | "FN" |  |
| fn:breaking_apart | /r/HasA | fn:fe:criterion | "breaking apart" | "criterion" | "/r/has a" |  | "FN" |  |
| fn:breaking_apart | /r/HasA | fn:fe:manner | "breaking apart" | "manner" | "/r/has a" |  | "FN" |  |
| fn:breaking_apart | /r/HasA | fn:fe:time | "breaking apart" | "time" | "/r/has a" |  | "FN" |  |
| fn:breaking_apart | /r/HasA | fn:fe:place | "breaking apart" | "place" | "/r/has a" |  | "FN" |  |
| fn:breaking_apart | /r/HasA | fn:fe:means | "breaking apart" | "means" | "/r/has a" |  | "FN" |  |
| fn:breaking_off | /r/IsA | fn:fragmentation_scenario | "breaking off" | "fragmentation scenario" | "/r/is a" |  | "FN" |  |
| fn:breaking_off | fn:HasLexicalUnit | fn:lu:breaking_off:chip | "breaking off" | "chip" | "has lexical unit" |  | "FN" |  |
| fn:breaking_off | fn:HasLexicalUnit | fn:lu:breaking_off:break | "breaking off" | "break" | "has lexical unit" |  | "FN" |  |
| fn:breaking_off | fn:HasLexicalUnit | fn:lu:breaking_off:snap | "breaking off" | "snap" | "has lexical unit" |  | "FN" |  |
| fn:breaking_off | /r/HasA | fn:fe:subpart | "breaking off" | "subpart" | "/r/has a" |  | "FN" |  |
| fn:breaking_off | /r/HasA | fn:fe:whole | "breaking off" | "whole" | "/r/has a" |  | "FN" |  |
| fn:breaking_off | /r/HasA | fn:fe:criterion | "breaking off" | "criterion" | "/r/has a" |  | "FN" |  |
| fn:breaking_off | /r/HasA | fn:fe:time | "breaking off" | "time" | "/r/has a" |  | "FN" |  |
| fn:breaking_off | /r/HasA | fn:fe:place | "breaking off" | "place" | "/r/has a" |  | "FN" |  |
| fn:breaking_off | /r/HasA | fn:fe:manner | "breaking off" | "manner" | "/r/has a" |  | "FN" |  |
| fn:breaking_off | /r/HasA | fn:fe:means | "breaking off" | "means" | "/r/has a" |  | "FN" |  |
| fn:breaking_out_captive | /r/IsA | fn:intentionally_affect | "breaking out captive" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:breaking_out_captive | fn:HasLexicalUnit | fn:lu:breaking_out_captive:break_out | "breaking out captive" | "break out" | "has lexical unit" |  | "FN" |  |
| fn:breaking_out_captive | fn:HasLexicalUnit | fn:lu:breaking_out_captive:free | "breaking out captive" | "free" | "has lexical unit" |  | "FN" |  |
| fn:breaking_out_captive | /r/HasA | fn:fe:agent | "breaking out captive" | "agent" | "/r/has a" |  | "FN" |  |
| fn:breaking_out_captive | /r/HasA | fn:fe:theme | "breaking out captive" | "theme" | "/r/has a" |  | "FN" |  |
| fn:breaking_out_captive | /r/HasA | fn:fe:manner | "breaking out captive" | "manner" | "/r/has a" |  | "FN" |  |
| fn:breaking_out_captive | /r/HasA | fn:fe:means | "breaking out captive" | "means" | "/r/has a" |  | "FN" |  |
| fn:breaking_out_captive | /r/HasA | fn:fe:explanation | "breaking out captive" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:breaking_out_captive | /r/HasA | fn:fe:purpose | "breaking out captive" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:breaking_out_captive | /r/HasA | fn:fe:place | "breaking out captive" | "place" | "/r/has a" |  | "FN" |  |
| fn:breaking_out_captive | /r/HasA | fn:fe:time | "breaking out captive" | "time" | "/r/has a" |  | "FN" |  |
| fn:fe:location_of_confinement | /r/IsA | fn:st:source | "location of confinement" | "source" | "/r/is a" |  | "FN" |  |
| fn:breaking_out_captive | /r/HasA | fn:fe:location_of_confinement | "breaking out captive" | "location of confinement" | "/r/has a" |  | "FN" |  |
| fn:breaking_out_captive | /r/HasA | fn:fe:concessive | "breaking out captive" | "concessive" | "/r/has a" |  | "FN" |  |
| fn:breaking_out_captive | /r/HasA | fn:fe:circumstances | "breaking out captive" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:fluidic_motion | /r/UsedFor | fn:breathing | "fluidic motion" | "breathing" | "/r/used for" |  | "FN" |  |
| fn:breathing | fn:HasLexicalUnit | fn:lu:breathing:breathe | "breathing" | "breathe" | "has lexical unit" |  | "FN" |  |
| fn:breathing | fn:HasLexicalUnit | fn:lu:breathing:inhale | "breathing" | "inhale" | "has lexical unit" |  | "FN" |  |
| fn:breathing | fn:HasLexicalUnit | fn:lu:breathing:breath | "breathing" | "breath" | "has lexical unit" |  | "FN" |  |
| fn:breathing | fn:HasLexicalUnit | fn:lu:breathing:exhale | "breathing" | "exhale" | "has lexical unit" |  | "FN" |  |
| fn:breathing | fn:HasLexicalUnit | fn:lu:breathing:gasp | "breathing" | "gasp" | "has lexical unit" |  | "FN" |  |
| fn:breathing | fn:HasLexicalUnit | fn:lu:breathing:sigh | "breathing" | "sigh" | "has lexical unit" |  | "FN" |  |
| fn:breathing | fn:HasLexicalUnit | fn:lu:breathing:exhalation | "breathing" | "exhalation" | "has lexical unit" |  | "FN" |  |
| fn:breathing | fn:HasLexicalUnit | fn:lu:breathing:exhalation_[act] | "breathing" | "exhalation [act]" | "has lexical unit" |  | "FN" |  |
| fn:breathing | fn:HasLexicalUnit | fn:lu:breathing:inhalation | "breathing" | "inhalation" | "has lexical unit" |  | "FN" |  |
| fn:breathing | fn:HasLexicalUnit | fn:lu:breathing:inhalation_[breath] | "breathing" | "inhalation [breath]" | "has lexical unit" |  | "FN" |  |
| fn:breathing | fn:HasLexicalUnit | fn:lu:breathing:huff | "breathing" | "huff" | "has lexical unit" |  | "FN" |  |
| fn:breathing | fn:HasLexicalUnit | fn:lu:breathing:puff | "breathing" | "puff" | "has lexical unit" |  | "FN" |  |
| fn:breathing | fn:HasLexicalUnit | fn:lu:breathing:sigh | "breathing" | "sigh" | "has lexical unit" |  | "FN" |  |
| fn:breathing | fn:HasLexicalUnit | fn:lu:breathing:blow | "breathing" | "blow" | "has lexical unit" |  | "FN" |  |
| fn:breathing | fn:HasLexicalUnit | fn:lu:breathing:expire | "breathing" | "expire" | "has lexical unit" |  | "FN" |  |
| fn:breathing | fn:HasLexicalUnit | fn:lu:breathing:inspire | "breathing" | "inspire" | "has lexical unit" |  | "FN" |  |
| fn:breathing | fn:HasLexicalUnit | fn:lu:breathing:insufflate | "breathing" | "insufflate" | "has lexical unit" |  | "FN" |  |
| fn:breathing | fn:HasLexicalUnit | fn:lu:breathing:pant | "breathing" | "pant" | "has lexical unit" |  | "FN" |  |
| fn:breathing | fn:HasLexicalUnit | fn:lu:breathing:respire | "breathing" | "respire" | "has lexical unit" |  | "FN" |  |
| fn:breathing | fn:HasLexicalUnit | fn:lu:breathing:suspire | "breathing" | "suspire" | "has lexical unit" |  | "FN" |  |
| fn:breathing | /r/HasA | fn:fe:agent | "breathing" | "agent" | "/r/has a" |  | "FN" |  |
| fn:breathing | /r/HasA | fn:fe:air | "breathing" | "air" | "/r/has a" |  | "FN" |  |
| fn:breathing | /r/HasA | fn:fe:goal | "breathing" | "goal" | "/r/has a" |  | "FN" |  |
| fn:breathing | /r/HasA | fn:fe:manner | "breathing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:breathing | /r/HasA | fn:fe:means | "breathing" | "means" | "/r/has a" |  | "FN" |  |
| fn:breathing | /r/HasA | fn:fe:source | "breathing" | "source" | "/r/has a" |  | "FN" |  |
| fn:breathing | /r/HasA | fn:fe:path | "breathing" | "path" | "/r/has a" |  | "FN" |  |
| fn:breathing | /r/HasA | fn:fe:degree | "breathing" | "degree" | "/r/has a" |  | "FN" |  |
| fn:breathing | /r/HasA | fn:fe:depictive | "breathing" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:breathing | /r/HasA | fn:fe:place | "breathing" | "place" | "/r/has a" |  | "FN" |  |
| fn:breathing | /r/HasA | fn:fe:duration | "breathing" | "duration" | "/r/has a" |  | "FN" |  |
| fn:breathing | /r/HasA | fn:fe:distance | "breathing" | "distance" | "/r/has a" |  | "FN" |  |
| fn:breathing | /r/HasA | fn:fe:instrument | "breathing" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:breathing | /r/HasA | fn:fe:time | "breathing" | "time" | "/r/has a" |  | "FN" |  |
| fn:breathing | /r/HasA | fn:fe:internal_cause | "breathing" | "internal cause" | "/r/has a" |  | "FN" |  |
| fn:breathing | /r/HasA | fn:fe:external_cause | "breathing" | "external cause" | "/r/has a" |  | "FN" |  |
| fn:breathing | /r/HasA | fn:fe:circumstances | "breathing" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:breathing | /r/HasA | fn:fe:purpose | "breathing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:smuggling | /r/IsA | fn:bringing | "smuggling" | "bringing" | "/r/is a" |  | "FN" |  |
| fn:bringing | /r/UsedFor | fn:convoy | "bringing" | "convoy" | "/r/used for" |  | "FN" |  |
| fn:bringing | /r/UsedFor | fn:sending | "bringing" | "sending" | "/r/used for" |  | "FN" |  |
| fn:cause_motion | /r/UsedFor | fn:bringing | "cause motion" | "bringing" | "/r/used for" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:bringing | "motion" | "bringing" | "/r/used for" |  | "FN" |  |
| fn:bringing | /r/RelatedTo | fn:passing | "bringing" | "passing" | "/r/related to" |  | "FN" |  |
| fn:bringing | /r/RelatedTo | fn:sending | "bringing" | "sending" | "/r/related to" |  | "FN" |  |
| fn:cause_motion | /r/RelatedTo | fn:bringing | "cause motion" | "bringing" | "/r/related to" |  | "FN" |  |
| fn:motion | /r/RelatedTo | fn:bringing | "motion" | "bringing" | "/r/related to" |  | "FN" |  |
| fn:cause_motion | /r/SimilarTo | fn:bringing | "cause motion" | "bringing" | "/r/similar to" |  | "FN" |  |
| fn:operate_vehicle | /r/SimilarTo | fn:bringing | "operate vehicle" | "bringing" | "/r/similar to" |  | "FN" |  |
| fn:placing | /r/SimilarTo | fn:bringing | "placing" | "bringing" | "/r/similar to" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:lug | "bringing" | "lug" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:haul | "bringing" | "haul" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:wheel | "bringing" | "wheel" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:cart | "bringing" | "cart" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:carry | "bringing" | "carry" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:hump | "bringing" | "hump" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:fly | "bringing" | "fly" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:transport | "bringing" | "transport" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:take | "bringing" | "take" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:drive | "bringing" | "drive" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:schlep | "bringing" | "schlep" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:truck | "bringing" | "truck" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:tote | "bringing" | "tote" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:trundle | "bringing" | "trundle" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:ferry | "bringing" | "ferry" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:jet | "bringing" | "jet" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:paddle | "bringing" | "paddle" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:motor | "bringing" | "motor" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:row | "bringing" | "row" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:convey | "bringing" | "convey" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:bike | "bringing" | "bike" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:bring | "bringing" | "bring" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:bear | "bringing" | "bear" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:fetch | "bringing" | "fetch" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:get | "bringing" | "get" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:portable | "bringing" | "portable" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:mobile | "bringing" | "mobile" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:transport | "bringing" | "transport" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:bus | "bringing" | "bus" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:shuttle | "bringing" | "shuttle" | "has lexical unit" |  | "FN" |  |
| fn:bringing | fn:HasLexicalUnit | fn:lu:bringing:airlift | "bringing" | "airlift" | "has lexical unit" |  | "FN" |  |
| fn:bringing | /r/HasA | fn:fe:agent | "bringing" | "agent" | "/r/has a" |  | "FN" |  |
| fn:fe:goal | /r/RelatedTo | fn:fe:area | "goal" | "area" | "/r/related to" |  | "FN" |  |
| fn:bringing | /r/HasA | fn:fe:goal | "bringing" | "goal" | "/r/has a" |  | "FN" |  |
| fn:fe:source | /r/RelatedTo | fn:fe:area | "source" | "area" | "/r/related to" |  | "FN" |  |
| fn:bringing | /r/HasA | fn:fe:source | "bringing" | "source" | "/r/has a" |  | "FN" |  |
| fn:fe:path | /r/RelatedTo | fn:fe:area | "path" | "area" | "/r/related to" |  | "FN" |  |
| fn:bringing | /r/HasA | fn:fe:path | "bringing" | "path" | "/r/has a" |  | "FN" |  |
| fn:bringing | /r/HasA | fn:fe:theme | "bringing" | "theme" | "/r/has a" |  | "FN" |  |
| fn:bringing | /r/HasA | fn:fe:constant_location | "bringing" | "constant location" | "/r/has a" |  | "FN" |  |
| fn:bringing | /r/HasA | fn:fe:area | "bringing" | "area" | "/r/has a" |  | "FN" |  |
| fn:bringing | /r/HasA | fn:fe:depictive | "bringing" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:bringing | /r/HasA | fn:fe:distance | "bringing" | "distance" | "/r/has a" |  | "FN" |  |
| fn:bringing | /r/HasA | fn:fe:manner | "bringing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fe:speed | /r/IsA | fn:st:speed | "speed" | "speed" | "/r/is a" |  | "FN" |  |
| fn:st:speed | /r/IsA | fn:st:ontological_type | "speed" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:st:speed | /r/IsA | fn:st:attribute | "speed" | "attribute" | "/r/is a" |  | "FN" |  |
| fn:bringing | /r/HasA | fn:fe:speed | "bringing" | "speed" | "/r/has a" |  | "FN" |  |
| fn:bringing | /r/HasA | fn:fe:purpose | "bringing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:bringing | /r/HasA | fn:fe:carrier | "bringing" | "carrier" | "/r/has a" |  | "FN" |  |
| fn:bringing | /r/HasA | fn:fe:means | "bringing" | "means" | "/r/has a" |  | "FN" |  |
| fn:bringing | /r/HasA | fn:fe:place | "bringing" | "place" | "/r/has a" |  | "FN" |  |
| fn:bringing | /r/HasA | fn:fe:time | "bringing" | "time" | "/r/has a" |  | "FN" |  |
| fn:bringing | /r/HasA | fn:fe:explanation | "bringing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:bringing | /r/HasA | fn:fe:beneficiary | "bringing" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:bringing | /r/HasA | fn:fe:particular_iteration | "bringing" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:bringing | /r/HasA | fn:fe:frequency | "bringing" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:bringing | /r/HasA | fn:fe:degree | "bringing" | "degree" | "/r/has a" |  | "FN" |  |
| fn:bringing | /r/HasA | fn:fe:co-participant | "bringing" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:bringing | /r/HasA | fn:fe:duration | "bringing" | "duration" | "/r/has a" |  | "FN" |  |
| fn:bringing | /r/HasA | fn:fe:period_of_iterations | "bringing" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:building | /r/IsA | fn:intentionally_create | "building" | "intentionally create" | "/r/is a" |  | "FN" |  |
| fn:building | fn:HasLexicalUnit | fn:lu:building:assemble | "building" | "assemble" | "has lexical unit" |  | "FN" |  |
| fn:building | fn:HasLexicalUnit | fn:lu:building:glue | "building" | "glue" | "has lexical unit" |  | "FN" |  |
| fn:building | fn:HasLexicalUnit | fn:lu:building:build | "building" | "build" | "has lexical unit" |  | "FN" |  |
| fn:building | fn:HasLexicalUnit | fn:lu:building:weld | "building" | "weld" | "has lexical unit" |  | "FN" |  |
| fn:building | fn:HasLexicalUnit | fn:lu:building:put_together | "building" | "put together" | "has lexical unit" |  | "FN" |  |
| fn:building | fn:HasLexicalUnit | fn:lu:building:construct | "building" | "construct" | "has lexical unit" |  | "FN" |  |
| fn:building | fn:HasLexicalUnit | fn:lu:building:assembly | "building" | "assembly" | "has lexical unit" |  | "FN" |  |
| fn:building | fn:HasLexicalUnit | fn:lu:building:construction | "building" | "construction" | "has lexical unit" |  | "FN" |  |
| fn:building | fn:HasLexicalUnit | fn:lu:building:make | "building" | "make" | "has lexical unit" |  | "FN" |  |
| fn:building | fn:HasLexicalUnit | fn:lu:building:fit_together | "building" | "fit together" | "has lexical unit" |  | "FN" |  |
| fn:building | fn:HasLexicalUnit | fn:lu:building:piece_together | "building" | "piece together" | "has lexical unit" |  | "FN" |  |
| fn:building | fn:HasLexicalUnit | fn:lu:building:erect | "building" | "erect" | "has lexical unit" |  | "FN" |  |
| fn:building | fn:HasLexicalUnit | fn:lu:building:raise | "building" | "raise" | "has lexical unit" |  | "FN" |  |
| fn:building | fn:HasLexicalUnit | fn:lu:building:fashion | "building" | "fashion" | "has lexical unit" |  | "FN" |  |
| fn:building | fn:HasLexicalUnit | fn:lu:building:construction_[entity] | "building" | "construction [entity]" | "has lexical unit" |  | "FN" |  |
| fn:building | /r/HasA | fn:fe:agent | "building" | "agent" | "/r/has a" |  | "FN" |  |
| fn:building | /r/HasA | fn:fe:instrument | "building" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:building | /r/HasA | fn:fe:place | "building" | "place" | "/r/has a" |  | "FN" |  |
| fn:building | /r/HasA | fn:fe:purpose | "building" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:building | /r/HasA | fn:fe:time | "building" | "time" | "/r/has a" |  | "FN" |  |
| fn:building | /r/HasA | fn:fe:means | "building" | "means" | "/r/has a" |  | "FN" |  |
| fn:building | /r/HasA | fn:fe:components | "building" | "components" | "/r/has a" |  | "FN" |  |
| fn:fe:created_entity | /r/IsA | fn:st:artifact | "created entity" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:building | /r/HasA | fn:fe:created_entity | "building" | "created entity" | "/r/has a" |  | "FN" |  |
| fn:building | /r/HasA | fn:fe:result | "building" | "result" | "/r/has a" |  | "FN" |  |
| fn:building | /r/HasA | fn:fe:depictive | "building" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:building | /r/HasA | fn:fe:manner | "building" | "manner" | "/r/has a" |  | "FN" |  |
| fn:building | /r/HasA | fn:fe:beneficiary | "building" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:building | /r/HasA | fn:fe:duration | "building" | "duration" | "/r/has a" |  | "FN" |  |
| fn:building | /r/HasA | fn:fe:particular_iteration | "building" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:building | /r/HasA | fn:fe:descriptor | "building" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:building | /r/HasA | fn:fe:period_of_iterations | "building" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:buildings | /r/HasSubevent | fn:building_subparts | "buildings" | "building subparts" | "/r/has subevent" |  | "FN" |  |
| fn:locale | /r/UsedFor | fn:building_subparts | "locale" | "building subparts" | "/r/used for" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:room | "building subparts" | "room" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:antechamber | "building subparts" | "antechamber" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:anteroom | "building subparts" | "anteroom" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:atelier | "building subparts" | "atelier" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:attic | "building subparts" | "attic" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:ballroom | "building subparts" | "ballroom" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:basement | "building subparts" | "basement" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:bathroom | "building subparts" | "bathroom" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:bedroom | "building subparts" | "bedroom" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:ben | "building subparts" | "ben" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:boudoir | "building subparts" | "boudoir" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:buttery | "building subparts" | "buttery" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:catacomb | "building subparts" | "catacomb" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:cell | "building subparts" | "cell" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:cellar | "building subparts" | "cellar" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:chamber | "building subparts" | "chamber" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:chancellery | "building subparts" | "chancellery" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:chapel | "building subparts" | "chapel" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:checkroom | "building subparts" | "checkroom" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:cloakroom | "building subparts" | "cloakroom" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:closet | "building subparts" | "closet" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:corridor | "building subparts" | "corridor" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:den | "building subparts" | "den" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:foyer | "building subparts" | "foyer" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:garret | "building subparts" | "garret" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:hallway | "building subparts" | "hallway" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:kitchen | "building subparts" | "kitchen" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:kitchenette | "building subparts" | "kitchenette" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:larder | "building subparts" | "larder" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:laundry | "building subparts" | "laundry" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:lift | "building subparts" | "lift" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:elevator | "building subparts" | "elevator" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:lobby | "building subparts" | "lobby" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:loft | "building subparts" | "loft" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:nursery | "building subparts" | "nursery" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:office | "building subparts" | "office" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:pantry | "building subparts" | "pantry" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:parlor | "building subparts" | "parlor" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:playroom | "building subparts" | "playroom" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:porch | "building subparts" | "porch" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:refectory | "building subparts" | "refectory" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:repository | "building subparts" | "repository" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:sacristy | "building subparts" | "sacristy" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:salon | "building subparts" | "salon" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:scullery | "building subparts" | "scullery" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:solarium | "building subparts" | "solarium" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:stoop | "building subparts" | "stoop" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:storeroom | "building subparts" | "storeroom" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:studio | "building subparts" | "studio" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:study | "building subparts" | "study" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:veranda | "building subparts" | "veranda" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:vestibule | "building subparts" | "vestibule" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:ward | "building subparts" | "ward" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:wing | "building subparts" | "wing" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:workroom | "building subparts" | "workroom" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:workshop | "building subparts" | "workshop" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:banquet_room | "building subparts" | "banquet room" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:dining_room | "building subparts" | "dining room" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:dressing_room | "building subparts" | "dressing room" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:family_room | "building subparts" | "family room" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:guest_room | "building subparts" | "guest room" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:living_room | "building subparts" | "living room" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:master_bedroom | "building subparts" | "master bedroom" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:powder_room | "building subparts" | "powder room" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:rest_room | "building subparts" | "rest room" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:rumpus_room | "building subparts" | "rumpus room" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:sitting_room | "building subparts" | "sitting room" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:utility_room | "building subparts" | "utility room" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:wine_cellar | "building subparts" | "wine cellar" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:apartment | "building subparts" | "apartment" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:flat | "building subparts" | "flat" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:lavatory | "building subparts" | "lavatory" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:tv_room | "building subparts" | "tv room" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:belfry | "building subparts" | "belfry" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:tower | "building subparts" | "tower" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:altar | "building subparts" | "altar" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:laundry_room | "building subparts" | "laundry room" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:level | "building subparts" | "level" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:floor | "building subparts" | "floor" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | fn:HasLexicalUnit | fn:lu:building_subparts:deck | "building subparts" | "deck" | "has lexical unit" |  | "FN" |  |
| fn:building_subparts | /r/HasA | fn:fe:building_part | "building subparts" | "building part" | "/r/has a" |  | "FN" |  |
| fn:building_subparts | /r/HasA | fn:fe:whole | "building subparts" | "whole" | "/r/has a" |  | "FN" |  |
| fn:building_subparts | /r/HasA | fn:fe:use | "building subparts" | "use" | "/r/has a" |  | "FN" |  |
| fn:building_subparts | /r/HasA | fn:fe:type | "building subparts" | "type" | "/r/has a" |  | "FN" |  |
| fn:building_subparts | /r/HasA | fn:fe:place | "building subparts" | "place" | "/r/has a" |  | "FN" |  |
| fn:building_subparts | /r/HasA | fn:fe:descriptor | "building subparts" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:buildings | /r/IsA | fn:artifact | "buildings" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:buildings | /r/HasSubevent | fn:building_subparts | "buildings" | "building subparts" | "/r/has subevent" |  | "FN" |  |
| fn:locale_by_use | /r/UsedFor | fn:buildings | "locale by use" | "buildings" | "/r/used for" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:house | "buildings" | "house" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:houseboat | "buildings" | "houseboat" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:church | "buildings" | "church" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:tower | "buildings" | "tower" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:bungalow | "buildings" | "bungalow" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:cabin | "buildings" | "cabin" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:castle | "buildings" | "castle" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:condominium | "buildings" | "condominium" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:cottage | "buildings" | "cottage" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:dacha | "buildings" | "dacha" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:dormitory | "buildings" | "dormitory" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:dwelling | "buildings" | "dwelling" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:farmhouse | "buildings" | "farmhouse" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:home | "buildings" | "home" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:hospital | "buildings" | "hospital" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:hostel | "buildings" | "hostel" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:hotel | "buildings" | "hotel" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:igloo | "buildings" | "igloo" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:lodge | "buildings" | "lodge" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:mansion | "buildings" | "mansion" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:monastery | "buildings" | "monastery" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:motel | "buildings" | "motel" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:palace | "buildings" | "palace" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:pension | "buildings" | "pension" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:pueblo | "buildings" | "pueblo" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:residence | "buildings" | "residence" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:shack | "buildings" | "shack" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:shanty | "buildings" | "shanty" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:shelter | "buildings" | "shelter" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:tenement | "buildings" | "tenement" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:tent | "buildings" | "tent" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:villa | "buildings" | "villa" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:acropolis | "buildings" | "acropolis" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:arena | "buildings" | "arena" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:auditorium | "buildings" | "auditorium" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:barn | "buildings" | "barn" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:barracks | "buildings" | "barracks" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:basilica | "buildings" | "basilica" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:blockhouse | "buildings" | "blockhouse" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:campanile | "buildings" | "campanile" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:caravan | "buildings" | "caravan" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:caravanserai | "buildings" | "caravanserai" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:chalet | "buildings" | "chalet" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:chateau | "buildings" | "chateau" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:conservatory | "buildings" | "conservatory" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:garage | "buildings" | "garage" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:gazebo | "buildings" | "gazebo" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:greenhouse | "buildings" | "greenhouse" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:hall | "buildings" | "hall" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:hangar | "buildings" | "hangar" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:hippodrome | "buildings" | "hippodrome" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:hovel | "buildings" | "hovel" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:inn | "buildings" | "inn" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:kennel | "buildings" | "kennel" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:kiosk | "buildings" | "kiosk" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:lighthouse | "buildings" | "lighthouse" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:maisonette | "buildings" | "maisonette" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:mall | "buildings" | "mall" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:manor | "buildings" | "manor" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:manse | "buildings" | "manse" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:mosque | "buildings" | "mosque" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:outbuilding | "buildings" | "outbuilding" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:outhouse | "buildings" | "outhouse" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:pagoda | "buildings" | "pagoda" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:palazzo | "buildings" | "palazzo" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:pavilion | "buildings" | "pavilion" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:penthouse | "buildings" | "penthouse" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:pyramid | "buildings" | "pyramid" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:rotunda | "buildings" | "rotunda" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:shebang | "buildings" | "shebang" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:shed | "buildings" | "shed" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:skyscraper | "buildings" | "skyscraper" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:stable | "buildings" | "stable" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:stadium | "buildings" | "stadium" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:supermarket | "buildings" | "supermarket" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:synagogue | "buildings" | "synagogue" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:tabernacle | "buildings" | "tabernacle" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:tavern | "buildings" | "tavern" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:tepee | "buildings" | "tepee" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:terminal | "buildings" | "terminal" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:triplex | "buildings" | "triplex" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:warehouse | "buildings" | "warehouse" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:wigwam | "buildings" | "wigwam" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:hacienda | "buildings" | "hacienda" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:homestead | "buildings" | "homestead" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:bunker | "buildings" | "bunker" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:theater | "buildings" | "theater" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:bar | "buildings" | "bar" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:city_hall | "buildings" | "city hall" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:disco | "buildings" | "disco" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:discotheque | "buildings" | "discotheque" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:library | "buildings" | "library" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:temple | "buildings" | "temple" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:building | "buildings" | "building" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:structure | "buildings" | "structure" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:housing | "buildings" | "housing" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:fortress | "buildings" | "fortress" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:fortification | "buildings" | "fortification" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:citadel | "buildings" | "citadel" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:fort | "buildings" | "fort" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:airport | "buildings" | "airport" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:pub | "buildings" | "pub" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:high-rise | "buildings" | "high-rise" | "has lexical unit" |  | "FN" |  |
| fn:buildings | fn:HasLexicalUnit | fn:lu:buildings:quarters | "buildings" | "quarters" | "has lexical unit" |  | "FN" |  |
| fn:buildings | /r/HasA | fn:fe:creator | "buildings" | "creator" | "/r/has a" |  | "FN" |  |
| fn:fe:building | /r/IsA | fn:st:artifact | "building" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:buildings | /r/HasA | fn:fe:building | "buildings" | "building" | "/r/has a" |  | "FN" |  |
| fn:buildings | /r/HasA | fn:fe:function | "buildings" | "function" | "/r/has a" |  | "FN" |  |
| fn:buildings | /r/HasA | fn:fe:name | "buildings" | "name" | "/r/has a" |  | "FN" |  |
| fn:buildings | /r/HasA | fn:fe:material | "buildings" | "material" | "/r/has a" |  | "FN" |  |
| fn:buildings | /r/HasA | fn:fe:time_of_creation | "buildings" | "time of creation" | "/r/has a" |  | "FN" |  |
| fn:buildings | /r/HasA | fn:fe:type | "buildings" | "type" | "/r/has a" |  | "FN" |  |
| fn:buildings | /r/HasA | fn:fe:descriptor | "buildings" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:buildings | /r/HasA | fn:fe:place | "buildings" | "place" | "/r/has a" |  | "FN" |  |
| fn:buildings | /r/HasA | fn:fe:relative_location | "buildings" | "relative location" | "/r/has a" |  | "FN" |  |
| fn:buildings | /r/HasA | fn:fe:possessor | "buildings" | "possessor" | "/r/has a" |  | "FN" |  |
| fn:intentionally_act | /r/UsedFor | fn:bungling | "intentionally act" | "bungling" | "/r/used for" |  | "FN" |  |
| fn:intentionally_affect | /r/UsedFor | fn:bungling | "intentionally affect" | "bungling" | "/r/used for" |  | "FN" |  |
| fn:bungling | /r/SimilarTo | fn:expertise | "bungling" | "expertise" | "/r/similar to" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:bungler | "bungling" | "bungler" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:fiasco | "bungling" | "fiasco" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:blow_it | "bungling" | "blow it" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:bungle | "bungling" | "bungle" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:botch | "bungling" | "botch" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:ruin | "bungling" | "ruin" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:mess_up | "bungling" | "mess up" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:fuck_up | "bungling" | "fuck up" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:fuck-up_[event] | "bungling" | "fuck-up [event]" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:screw-up_[event] | "bungling" | "screw-up [event]" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:mess-up | "bungling" | "mess-up" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:fuck-up_[person] | "bungling" | "fuck-up [person]" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:screw-up_[person] | "bungling" | "screw-up [person]" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:fumble | "bungling" | "fumble" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:fumble | "bungling" | "fumble" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:foozle | "bungling" | "foozle" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:screw_up | "bungling" | "screw up" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:bungling | "bungling" | "bungling" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:bumbling | "bungling" | "bumbling" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:founder | "bungling" | "founder" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:bollix | "bungling" | "bollix" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:bollix_up | "bungling" | "bollix up" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:botch_up | "bungling" | "botch up" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:blow | "bungling" | "blow" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:ball_up | "bungling" | "ball up" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:flub | "bungling" | "flub" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:foul_up | "bungling" | "foul up" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:fluff | "bungling" | "fluff" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:louse_up | "bungling" | "louse up" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:muck_up | "bungling" | "muck up" | "has lexical unit" |  | "FN" |  |
| fn:bungling | fn:HasLexicalUnit | fn:lu:bungling:muff | "bungling" | "muff" | "has lexical unit" |  | "FN" |  |
| fn:bungling | /r/HasA | fn:fe:degree | "bungling" | "degree" | "/r/has a" |  | "FN" |  |
| fn:bungling | /r/HasA | fn:fe:depictive | "bungling" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:bungling | /r/HasA | fn:fe:manner | "bungling" | "manner" | "/r/has a" |  | "FN" |  |
| fn:bungling | /r/HasA | fn:fe:means | "bungling" | "means" | "/r/has a" |  | "FN" |  |
| fn:bungling | /r/HasA | fn:fe:agent | "bungling" | "agent" | "/r/has a" |  | "FN" |  |
| fn:bungling | /r/HasA | fn:fe:patient | "bungling" | "patient" | "/r/has a" |  | "FN" |  |
| fn:bungling | /r/HasA | fn:fe:place | "bungling" | "place" | "/r/has a" |  | "FN" |  |
| fn:bungling | /r/HasA | fn:fe:instrument | "bungling" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:bungling | /r/HasA | fn:fe:time | "bungling" | "time" | "/r/has a" |  | "FN" |  |
| fn:bungling | /r/HasA | fn:fe:action | "bungling" | "action" | "/r/has a" |  | "FN" |  |
| fn:bungling | /r/HasA | fn:fe:area | "bungling" | "area" | "/r/has a" |  | "FN" |  |
| fn:burying | /r/IsA | fn:placing | "burying" | "placing" | "/r/is a" |  | "FN" |  |
| fn:burying | fn:HasLexicalUnit | fn:lu:burying:bury | "burying" | "bury" | "has lexical unit" |  | "FN" |  |
| fn:burying | /r/HasA | fn:fe:agent | "burying" | "agent" | "/r/has a" |  | "FN" |  |
| fn:burying | /r/HasA | fn:fe:theme | "burying" | "theme" | "/r/has a" |  | "FN" |  |
| fn:burying | /r/HasA | fn:fe:source | "burying" | "source" | "/r/has a" |  | "FN" |  |
| fn:burying | /r/HasA | fn:fe:path | "burying" | "path" | "/r/has a" |  | "FN" |  |
| fn:burying | /r/HasA | fn:fe:goal | "burying" | "goal" | "/r/has a" |  | "FN" |  |
| fn:burying | /r/HasA | fn:fe:manner | "burying" | "manner" | "/r/has a" |  | "FN" |  |
| fn:burying | /r/HasA | fn:fe:degree | "burying" | "degree" | "/r/has a" |  | "FN" |  |
| fn:burying | /r/HasA | fn:fe:depictive | "burying" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:burying | /r/HasA | fn:fe:means | "burying" | "means" | "/r/has a" |  | "FN" |  |
| fn:burying | /r/HasA | fn:fe:result | "burying" | "result" | "/r/has a" |  | "FN" |  |
| fn:burying | /r/HasA | fn:fe:duration | "burying" | "duration" | "/r/has a" |  | "FN" |  |
| fn:burying | /r/HasA | fn:fe:place | "burying" | "place" | "/r/has a" |  | "FN" |  |
| fn:burying | /r/HasA | fn:fe:explanation | "burying" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:burying | /r/HasA | fn:fe:time | "burying" | "time" | "/r/has a" |  | "FN" |  |
| fn:burying | /r/HasA | fn:fe:area | "burying" | "area" | "/r/has a" |  | "FN" |  |
| fn:burying | /r/HasA | fn:fe:cotheme | "burying" | "cotheme" | "/r/has a" |  | "FN" |  |
| fn:burying | /r/HasA | fn:fe:distance | "burying" | "distance" | "/r/has a" |  | "FN" |  |
| fn:burying | /r/HasA | fn:fe:speed | "burying" | "speed" | "/r/has a" |  | "FN" |  |
| fn:burying | /r/HasA | fn:fe:cause | "burying" | "cause" | "/r/has a" |  | "FN" |  |
| fn:burying | /r/HasA | fn:fe:purpose | "burying" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:burying | /r/HasA | fn:fe:beneficiary | "burying" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:business_closure | /r/IsA | fn:endeavor_failure | "business closure" | "endeavor failure" | "/r/is a" |  | "FN" |  |
| fn:business_closure | /r/IsA | fn:locale_closure | "business closure" | "locale closure" | "/r/is a" |  | "FN" |  |
| fn:endeavor_failure | /r/RelatedTo | fn:business_closure | "endeavor failure" | "business closure" | "/r/related to" |  | "FN" |  |
| fn:business_closure | fn:HasLexicalUnit | fn:lu:business_closure:founder | "business closure" | "founder" | "has lexical unit" |  | "FN" |  |
| fn:business_closure | fn:HasLexicalUnit | fn:lu:business_closure:close_its_doors | "business closure" | "close its doors" | "has lexical unit" |  | "FN" |  |
| fn:business_closure | fn:HasLexicalUnit | fn:lu:business_closure:close_down | "business closure" | "close down" | "has lexical unit" |  | "FN" |  |
| fn:business_closure | /r/HasA | fn:fe:entity | "business closure" | "entity" | "/r/has a" |  | "FN" |  |
| fn:business_closure | /r/HasA | fn:fe:explanation | "business closure" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:business_closure | /r/HasA | fn:fe:time | "business closure" | "time" | "/r/has a" |  | "FN" |  |
| fn:business_closure | /r/HasA | fn:fe:place | "business closure" | "place" | "/r/has a" |  | "FN" |  |
| fn:business_closure | /r/HasA | fn:fe:circumstances | "business closure" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:business_closure | /r/HasA | fn:fe:manner | "business closure" | "manner" | "/r/has a" |  | "FN" |  |
| fn:business_closure | /r/HasA | fn:fe:containing_event | "business closure" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:business_closure | /r/HasA | fn:fe:depictive | "business closure" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:commerce_scenario | /r/UsedFor | fn:businesses | "commerce scenario" | "businesses" | "/r/used for" |  | "FN" |  |
| fn:businesses | fn:HasLexicalUnit | fn:lu:businesses:business | "businesses" | "business" | "has lexical unit" |  | "FN" |  |
| fn:businesses | fn:HasLexicalUnit | fn:lu:businesses:shop | "businesses" | "shop" | "has lexical unit" |  | "FN" |  |
| fn:businesses | fn:HasLexicalUnit | fn:lu:businesses:establishment | "businesses" | "establishment" | "has lexical unit" |  | "FN" |  |
| fn:businesses | fn:HasLexicalUnit | fn:lu:businesses:mill | "businesses" | "mill" | "has lexical unit" |  | "FN" |  |
| fn:businesses | fn:HasLexicalUnit | fn:lu:businesses:practice | "businesses" | "practice" | "has lexical unit" |  | "FN" |  |
| fn:businesses | fn:HasLexicalUnit | fn:lu:businesses:firm | "businesses" | "firm" | "has lexical unit" |  | "FN" |  |
| fn:businesses | fn:HasLexicalUnit | fn:lu:businesses:operation | "businesses" | "operation" | "has lexical unit" |  | "FN" |  |
| fn:businesses | fn:HasLexicalUnit | fn:lu:businesses:company | "businesses" | "company" | "has lexical unit" |  | "FN" |  |
| fn:businesses | fn:HasLexicalUnit | fn:lu:businesses:chain | "businesses" | "chain" | "has lexical unit" |  | "FN" |  |
| fn:businesses | fn:HasLexicalUnit | fn:lu:businesses:corporation | "businesses" | "corporation" | "has lexical unit" |  | "FN" |  |
| fn:businesses | fn:HasLexicalUnit | fn:lu:businesses:paper | "businesses" | "paper" | "has lexical unit" |  | "FN" |  |
| fn:businesses | fn:HasLexicalUnit | fn:lu:businesses:store | "businesses" | "store" | "has lexical unit" |  | "FN" |  |
| fn:businesses | fn:HasLexicalUnit | fn:lu:businesses:bank | "businesses" | "bank" | "has lexical unit" |  | "FN" |  |
| fn:businesses | fn:HasLexicalUnit | fn:lu:businesses:boutique | "businesses" | "boutique" | "has lexical unit" |  | "FN" |  |
| fn:businesses | /r/HasA | fn:fe:product | "businesses" | "product" | "/r/has a" |  | "FN" |  |
| fn:businesses | /r/HasA | fn:fe:proprietor | "businesses" | "proprietor" | "/r/has a" |  | "FN" |  |
| fn:businesses | /r/HasA | fn:fe:descriptor | "businesses" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:businesses | /r/HasA | fn:fe:place | "businesses" | "place" | "/r/has a" |  | "FN" |  |
| fn:businesses | /r/HasA | fn:fe:business | "businesses" | "business" | "/r/has a" |  | "FN" |  |
| fn:businesses | /r/HasA | fn:fe:business_name | "businesses" | "business name" | "/r/has a" |  | "FN" |  |
| fn:businesses | /r/HasA | fn:fe:service_provider | "businesses" | "service provider" | "/r/has a" |  | "FN" |  |
| fn:cache | /r/IsA | fn:store | "cache" | "store" | "/r/is a" |  | "FN" |  |
| fn:secrecy_status | /r/UsedFor | fn:cache | "secrecy status" | "cache" | "/r/used for" |  | "FN" |  |
| fn:cache | fn:HasLexicalUnit | fn:lu:cache:cache | "cache" | "cache" | "has lexical unit" |  | "FN" |  |
| fn:cache | fn:HasLexicalUnit | fn:lu:cache:stash | "cache" | "stash" | "has lexical unit" |  | "FN" |  |
| fn:cache | /r/HasA | fn:fe:cache | "cache" | "cache" | "/r/has a" |  | "FN" |  |
| fn:cache | /r/HasA | fn:fe:resource | "cache" | "resource" | "/r/has a" |  | "FN" |  |
| fn:cache | /r/HasA | fn:fe:use | "cache" | "use" | "/r/has a" |  | "FN" |  |
| fn:fe:possessor | /r/IsA | fn:st:sentient | "possessor" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:cache | /r/HasA | fn:fe:possessor | "cache" | "possessor" | "/r/has a" |  | "FN" |  |
| fn:cache | /r/HasA | fn:fe:descriptor | "cache" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:calendric_unit | /r/IsA | fn:location_in_time | "calendric unit" | "location in time" | "/r/is a" |  | "FN" |  |
| fn:calendric_unit | /r/UsedFor | fn:change_event_time | "calendric unit" | "change event time" | "/r/used for" |  | "FN" |  |
| fn:calendric_unit | /r/RelatedTo | fn:frequency | "calendric unit" | "frequency" | "/r/related to" |  | "FN" |  |
| fn:calendric_unit | /r/RelatedTo | fn:temporal_collocation | "calendric unit" | "temporal collocation" | "/r/related to" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:day | "calendric unit" | "day" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:week | "calendric unit" | "week" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:daybreak | "calendric unit" | "daybreak" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:weekday | "calendric unit" | "weekday" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:weekend | "calendric unit" | "weekend" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:weeknight | "calendric unit" | "weeknight" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:dawn | "calendric unit" | "dawn" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:morning | "calendric unit" | "morning" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:noon | "calendric unit" | "noon" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:monday | "calendric unit" | "monday" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:tuesday | "calendric unit" | "tuesday" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:wednesday | "calendric unit" | "wednesday" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:thursday | "calendric unit" | "thursday" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:friday | "calendric unit" | "friday" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:saturday | "calendric unit" | "saturday" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:today | "calendric unit" | "today" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:yesterday | "calendric unit" | "yesterday" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:tomorrow | "calendric unit" | "tomorrow" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:midday | "calendric unit" | "midday" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:afternoon | "calendric unit" | "afternoon" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:dusk | "calendric unit" | "dusk" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:evening | "calendric unit" | "evening" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:eve | "calendric unit" | "eve" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:night | "calendric unit" | "night" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:midnight | "calendric unit" | "midnight" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:twilight | "calendric unit" | "twilight" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:month | "calendric unit" | "month" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:year | "calendric unit" | "year" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:calendar_year | "calendric unit" | "calendar year" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:fortnight | "calendric unit" | "fortnight" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:decade | "calendric unit" | "decade" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:january | "calendric unit" | "january" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:february | "calendric unit" | "february" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:march | "calendric unit" | "march" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:april | "calendric unit" | "april" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:may | "calendric unit" | "may" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:june | "calendric unit" | "june" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:july | "calendric unit" | "july" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:august | "calendric unit" | "august" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:september | "calendric unit" | "september" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:october | "calendric unit" | "october" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:november | "calendric unit" | "november" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:december | "calendric unit" | "december" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:sunday | "calendric unit" | "sunday" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:leap_year | "calendric unit" | "leap year" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:morn | "calendric unit" | "morn" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:winter | "calendric unit" | "winter" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:spring | "calendric unit" | "spring" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:summer | "calendric unit" | "summer" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:hour | "calendric unit" | "hour" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:minute | "calendric unit" | "minute" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:second | "calendric unit" | "second" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:autumn | "calendric unit" | "autumn" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:school_year | "calendric unit" | "school year" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:quarter | "calendric unit" | "quarter" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:era | "calendric unit" | "era" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:age | "calendric unit" | "age" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:rush_hour | "calendric unit" | "rush hour" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:tonight | "calendric unit" | "tonight" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:century | "calendric unit" | "century" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:millennium | "calendric unit" | "millennium" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:holiday | "calendric unit" | "holiday" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | fn:HasLexicalUnit | fn:lu:calendric_unit:one_day | "calendric unit" | "one day" | "has lexical unit" |  | "FN" |  |
| fn:calendric_unit | /r/HasA | fn:fe:relative_time | "calendric unit" | "relative time" | "/r/has a" |  | "FN" |  |
| fn:calendric_unit | /r/HasA | fn:fe:name | "calendric unit" | "name" | "/r/has a" |  | "FN" |  |
| fn:calendric_unit | /r/HasA | fn:fe:whole | "calendric unit" | "whole" | "/r/has a" |  | "FN" |  |
| fn:calendric_unit | /r/HasA | fn:fe:count | "calendric unit" | "count" | "/r/has a" |  | "FN" |  |
| fn:calendric_unit | /r/HasA | fn:fe:unit | "calendric unit" | "unit" | "/r/has a" |  | "FN" |  |
| fn:calendric_unit | /r/HasA | fn:fe:salient_event | "calendric unit" | "salient event" | "/r/has a" |  | "FN" |  |
| fn:calendric_unit | /r/HasA | fn:fe:landmark_period | "calendric unit" | "landmark period" | "/r/has a" |  | "FN" |  |
| fn:calendric_unit | /r/HasA | fn:fe:trajector_event | "calendric unit" | "trajector event" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:candidness | "communication" | "candidness" | "/r/used for" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:blunt | "candidness" | "blunt" | "has lexical unit" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:candid | "candidness" | "candid" | "has lexical unit" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:coy | "candidness" | "coy" | "has lexical unit" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:discreet | "candidness" | "discreet" | "has lexical unit" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:explicit | "candidness" | "explicit" | "has lexical unit" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:forthcoming | "candidness" | "forthcoming" | "has lexical unit" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:forthright | "candidness" | "forthright" | "has lexical unit" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:frank | "candidness" | "frank" | "has lexical unit" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:honest | "candidness" | "honest" | "has lexical unit" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:open | "candidness" | "open" | "has lexical unit" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:outspoken | "candidness" | "outspoken" | "has lexical unit" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:secretive | "candidness" | "secretive" | "has lexical unit" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:sincere | "candidness" | "sincere" | "has lexical unit" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:straightforward | "candidness" | "straightforward" | "has lexical unit" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:truthful | "candidness" | "truthful" | "has lexical unit" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:disingenuous | "candidness" | "disingenuous" | "has lexical unit" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:evasive | "candidness" | "evasive" | "has lexical unit" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:circumspect | "candidness" | "circumspect" | "has lexical unit" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:honesty | "candidness" | "honesty" | "has lexical unit" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:ingenuous | "candidness" | "ingenuous" | "has lexical unit" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:bluntness | "candidness" | "bluntness" | "has lexical unit" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:candour | "candidness" | "candour" | "has lexical unit" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:forthrightness | "candidness" | "forthrightness" | "has lexical unit" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:straight | "candidness" | "straight" | "has lexical unit" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:earnest | "candidness" | "earnest" | "has lexical unit" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:earnestness | "candidness" | "earnestness" | "has lexical unit" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:dishonest | "candidness" | "dishonest" | "has lexical unit" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:devious | "candidness" | "devious" | "has lexical unit" |  | "FN" |  |
| fn:candidness | fn:HasLexicalUnit | fn:lu:candidness:true | "candidness" | "true" | "has lexical unit" |  | "FN" |  |
| fn:candidness | /r/HasA | fn:fe:speaker | "candidness" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:candidness | /r/HasA | fn:fe:addressee | "candidness" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:candidness | /r/HasA | fn:fe:message | "candidness" | "message" | "/r/has a" |  | "FN" |  |
| fn:candidness | /r/HasA | fn:fe:topic | "candidness" | "topic" | "/r/has a" |  | "FN" |  |
| fn:candidness | /r/HasA | fn:fe:medium | "candidness" | "medium" | "/r/has a" |  | "FN" |  |
| fn:candidness | /r/HasA | fn:fe:degree | "candidness" | "degree" | "/r/has a" |  | "FN" |  |
| fn:candidness | /r/HasA | fn:fe:manner | "candidness" | "manner" | "/r/has a" |  | "FN" |  |
| fn:being_operational | /r/IsA | fn:capability | "being operational" | "capability" | "/r/is a" |  | "FN" |  |
| fn:being_up_to_it | /r/IsA | fn:capability | "being up to it" | "capability" | "/r/is a" |  | "FN" |  |
| fn:capacity | /r/IsA | fn:capability | "capacity" | "capability" | "/r/is a" |  | "FN" |  |
| fn:gusto | /r/IsA | fn:capability | "gusto" | "capability" | "/r/is a" |  | "FN" |  |
| fn:having_or_lacking_access | /r/IsA | fn:capability | "having or lacking access" | "capability" | "/r/is a" |  | "FN" |  |
| fn:capability | /r/IsA | fn:gradable_attributes | "capability" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:capability | /r/IsA | fn:possibility | "capability" | "possibility" | "/r/is a" |  | "FN" |  |
| fn:capability | /r/UsedFor | fn:electricity | "capability" | "electricity" | "/r/used for" |  | "FN" |  |
| fn:capability | /r/UsedFor | fn:range | "capability" | "range" | "/r/used for" |  | "FN" |  |
| fn:capability | /r/UsedFor | fn:sufficiency | "capability" | "sufficiency" | "/r/used for" |  | "FN" |  |
| fn:capability | /r/UsedFor | fn:usefulness | "capability" | "usefulness" | "/r/used for" |  | "FN" |  |
| fn:likelihood | /r/UsedFor | fn:capability | "likelihood" | "capability" | "/r/used for" |  | "FN" |  |
| fn:possibility | /r/RelatedTo | fn:capability | "possibility" | "capability" | "/r/related to" |  | "FN" |  |
| fn:level_of_force_exertion | /r/SimilarTo | fn:capability | "level of force exertion" | "capability" | "/r/similar to" |  | "FN" |  |
| fn:capability | fn:HasLexicalUnit | fn:lu:capability:able | "capability" | "able" | "has lexical unit" |  | "FN" |  |
| fn:capability | fn:HasLexicalUnit | fn:lu:capability:unable | "capability" | "unable" | "has lexical unit" |  | "FN" |  |
| fn:capability | fn:HasLexicalUnit | fn:lu:capability:can | "capability" | "can" | "has lexical unit" |  | "FN" |  |
| fn:capability | fn:HasLexicalUnit | fn:lu:capability:capable | "capability" | "capable" | "has lexical unit" |  | "FN" |  |
| fn:capability | fn:HasLexicalUnit | fn:lu:capability:ability | "capability" | "ability" | "has lexical unit" |  | "FN" |  |
| fn:capability | fn:HasLexicalUnit | fn:lu:capability:potential | "capability" | "potential" | "has lexical unit" |  | "FN" |  |
| fn:capability | fn:HasLexicalUnit | fn:lu:capability:capability | "capability" | "capability" | "has lexical unit" |  | "FN" |  |
| fn:capability | fn:HasLexicalUnit | fn:lu:capability:capacity | "capability" | "capacity" | "has lexical unit" |  | "FN" |  |
| fn:capability | fn:HasLexicalUnit | fn:lu:capability:potential | "capability" | "potential" | "has lexical unit" |  | "FN" |  |
| fn:capability | fn:HasLexicalUnit | fn:lu:capability:power | "capability" | "power" | "has lexical unit" |  | "FN" |  |
| fn:capability | fn:HasLexicalUnit | fn:lu:capability:power_[statistical] | "capability" | "power [statistical]" | "has lexical unit" |  | "FN" |  |
| fn:capability | fn:HasLexicalUnit | fn:lu:capability:powerless | "capability" | "powerless" | "has lexical unit" |  | "FN" |  |
| fn:capability | fn:HasLexicalUnit | fn:lu:capability:powerlessness | "capability" | "powerlessness" | "has lexical unit" |  | "FN" |  |
| fn:capability | fn:HasLexicalUnit | fn:lu:capability:inability | "capability" | "inability" | "has lexical unit" |  | "FN" |  |
| fn:capability | fn:HasLexicalUnit | fn:lu:capability:incapable | "capability" | "incapable" | "has lexical unit" |  | "FN" |  |
| fn:capability | fn:HasLexicalUnit | fn:lu:capability:incapacity | "capability" | "incapacity" | "has lexical unit" |  | "FN" |  |
| fn:capability | fn:HasLexicalUnit | fn:lu:capability:powerful | "capability" | "powerful" | "has lexical unit" |  | "FN" |  |
| fn:capability | /r/HasA | fn:fe:entity | "capability" | "entity" | "/r/has a" |  | "FN" |  |
| fn:fe:event | /r/IsA | fn:st:state_of_affairs | "event" | "state of affairs" | "/r/is a" |  | "FN" |  |
| fn:capability | /r/HasA | fn:fe:event | "capability" | "event" | "/r/has a" |  | "FN" |  |
| fn:capability | /r/HasA | fn:fe:degree | "capability" | "degree" | "/r/has a" |  | "FN" |  |
| fn:capability | /r/HasA | fn:fe:circumstances | "capability" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:capability | /r/HasA | fn:fe:explanation | "capability" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:capability | /r/HasA | fn:fe:relevant_feature | "capability" | "relevant feature" | "/r/has a" |  | "FN" |  |
| fn:capability | /r/HasA | fn:fe:status | "capability" | "status" | "/r/has a" |  | "FN" |  |
| fn:capability | /r/HasA | fn:fe:role | "capability" | "role" | "/r/has a" |  | "FN" |  |
| fn:capability | /r/HasA | fn:fe:time | "capability" | "time" | "/r/has a" |  | "FN" |  |
| fn:capability | /r/HasA | fn:fe:frequency | "capability" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:capacity | /r/IsA | fn:capability | "capacity" | "capability" | "/r/is a" |  | "FN" |  |
| fn:capacity | fn:HasLexicalUnit | fn:lu:capacity:seat | "capacity" | "seat" | "has lexical unit" |  | "FN" |  |
| fn:capacity | fn:HasLexicalUnit | fn:lu:capacity:fit | "capacity" | "fit" | "has lexical unit" |  | "FN" |  |
| fn:capacity | fn:HasLexicalUnit | fn:lu:capacity:take | "capacity" | "take" | "has lexical unit" |  | "FN" |  |
| fn:capacity | fn:HasLexicalUnit | fn:lu:capacity:sleep | "capacity" | "sleep" | "has lexical unit" |  | "FN" |  |
| fn:capacity | fn:HasLexicalUnit | fn:lu:capacity:feed | "capacity" | "feed" | "has lexical unit" |  | "FN" |  |
| fn:capacity | fn:HasLexicalUnit | fn:lu:capacity:serve | "capacity" | "serve" | "has lexical unit" |  | "FN" |  |
| fn:capacity | /r/HasA | fn:fe:entity | "capacity" | "entity" | "/r/has a" |  | "FN" |  |
| fn:capacity | /r/HasA | fn:fe:degree | "capacity" | "degree" | "/r/has a" |  | "FN" |  |
| fn:capacity | /r/HasA | fn:fe:circumstances | "capacity" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:capacity | /r/HasA | fn:fe:explanation | "capacity" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:capacity | /r/HasA | fn:fe:status | "capacity" | "status" | "/r/has a" |  | "FN" |  |
| fn:capacity | /r/HasA | fn:fe:theme | "capacity" | "theme" | "/r/has a" |  | "FN" |  |
| fn:capacity | /r/HasA | fn:fe:depictive | "capacity" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:capacity | /r/HasA | fn:fe:subregion | "capacity" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:capacity | /r/HasA | fn:fe:purpose | "capacity" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:capacity | /r/HasA | fn:fe:time | "capacity" | "time" | "/r/has a" |  | "FN" |  |
| fn:possession | /r/UsedFor | fn:capital_stock | "possession" | "capital stock" | "/r/used for" |  | "FN" |  |
| fn:capital_stock | fn:HasLexicalUnit | fn:lu:capital_stock:share | "capital stock" | "share" | "has lexical unit" |  | "FN" |  |
| fn:capital_stock | fn:HasLexicalUnit | fn:lu:capital_stock:common | "capital stock" | "common" | "has lexical unit" |  | "FN" |  |
| fn:capital_stock | fn:HasLexicalUnit | fn:lu:capital_stock:preferred | "capital stock" | "preferred" | "has lexical unit" |  | "FN" |  |
| fn:capital_stock | fn:HasLexicalUnit | fn:lu:capital_stock:stock | "capital stock" | "stock" | "has lexical unit" |  | "FN" |  |
| fn:capital_stock | fn:HasLexicalUnit | fn:lu:capital_stock:ordinary | "capital stock" | "ordinary" | "has lexical unit" |  | "FN" |  |
| fn:capital_stock | fn:HasLexicalUnit | fn:lu:capital_stock:voting | "capital stock" | "voting" | "has lexical unit" |  | "FN" |  |
| fn:capital_stock | /r/HasA | fn:fe:stock | "capital stock" | "stock" | "/r/has a" |  | "FN" |  |
| fn:capital_stock | /r/HasA | fn:fe:type | "capital stock" | "type" | "/r/has a" |  | "FN" |  |
| fn:fe:shareholder | /r/RelatedTo | fn:fe:stock | "shareholder" | "stock" | "/r/related to" |  | "FN" |  |
| fn:capital_stock | /r/HasA | fn:fe:shareholder | "capital stock" | "shareholder" | "/r/has a" |  | "FN" |  |
| fn:capital_stock | /r/HasA | fn:fe:issuer | "capital stock" | "issuer" | "/r/has a" |  | "FN" |  |
| fn:capital_stock | /r/HasA | fn:fe:amount | "capital stock" | "amount" | "/r/has a" |  | "FN" |  |
| fn:cardinal_numbers | /r/UsedFor | fn:ordinal_numbers | "cardinal numbers" | "ordinal numbers" | "/r/used for" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:one | "cardinal numbers" | "one" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:two | "cardinal numbers" | "two" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:three | "cardinal numbers" | "three" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:million | "cardinal numbers" | "million" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:zero | "cardinal numbers" | "zero" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:brace | "cardinal numbers" | "brace" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:couple | "cardinal numbers" | "couple" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:pair | "cardinal numbers" | "pair" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:score | "cardinal numbers" | "score" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:five | "cardinal numbers" | "five" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:seven | "cardinal numbers" | "seven" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:thirty | "cardinal numbers" | "thirty" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:hundred | "cardinal numbers" | "hundred" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:billion | "cardinal numbers" | "billion" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:dual | "cardinal numbers" | "dual" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:thousand | "cardinal numbers" | "thousand" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:ninety | "cardinal numbers" | "ninety" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:fourteen | "cardinal numbers" | "fourteen" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:five_hundred | "cardinal numbers" | "five hundred" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:twenty-five | "cardinal numbers" | "twenty-five" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:two_hundred | "cardinal numbers" | "two hundred" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:fifteen | "cardinal numbers" | "fifteen" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:fifty | "cardinal numbers" | "fifty" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:forty | "cardinal numbers" | "forty" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:ten | "cardinal numbers" | "ten" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:four | "cardinal numbers" | "four" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:six | "cardinal numbers" | "six" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:twenty | "cardinal numbers" | "twenty" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:sixty | "cardinal numbers" | "sixty" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:seventy | "cardinal numbers" | "seventy" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:twenty-one | "cardinal numbers" | "twenty-one" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:eight | "cardinal numbers" | "eight" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:fifty-two | "cardinal numbers" | "fifty-two" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:twelve | "cardinal numbers" | "twelve" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:seventy-four | "cardinal numbers" | "seventy-four" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:number | "cardinal numbers" | "number" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:nine | "cardinal numbers" | "nine" | "has lexical unit" |  | "FN" |  |
| fn:cardinal_numbers | fn:HasLexicalUnit | fn:lu:cardinal_numbers:twenty-seven | "cardinal numbers" | "twenty-seven" | "has lexical unit" |  | "FN" |  |
| fn:fe:number | /r/IsA | fn:st:quantity | "number" | "quantity" | "/r/is a" |  | "FN" |  |
| fn:cardinal_numbers | /r/HasA | fn:fe:number | "cardinal numbers" | "number" | "/r/has a" |  | "FN" |  |
| fn:fe:entity | /r/RelatedTo | fn:fe:unit | "entity" | "unit" | "/r/related to" |  | "FN" |  |
| fn:cardinal_numbers | /r/HasA | fn:fe:entity | "cardinal numbers" | "entity" | "/r/has a" |  | "FN" |  |
| fn:cardinal_numbers | /r/HasA | fn:fe:precision | "cardinal numbers" | "precision" | "/r/has a" |  | "FN" |  |
| fn:cardinal_numbers | /r/HasA | fn:fe:multiplier | "cardinal numbers" | "multiplier" | "/r/has a" |  | "FN" |  |
| fn:cardinal_numbers | /r/HasA | fn:fe:composite_number | "cardinal numbers" | "composite number" | "/r/has a" |  | "FN" |  |
| fn:fe:unit | /r/RelatedTo | fn:fe:entity | "unit" | "entity" | "/r/related to" |  | "FN" |  |
| fn:cardinal_numbers | /r/HasA | fn:fe:unit | "cardinal numbers" | "unit" | "/r/has a" |  | "FN" |  |
| fn:commerce_sell | /r/UsedFor | fn:carry_goods | "commerce sell" | "carry goods" | "/r/used for" |  | "FN" |  |
| fn:storing | /r/UsedFor | fn:carry_goods | "storing" | "carry goods" | "/r/used for" |  | "FN" |  |
| fn:carry_goods | fn:HasLexicalUnit | fn:lu:carry_goods:carry | "carry goods" | "carry" | "has lexical unit" |  | "FN" |  |
| fn:carry_goods | fn:HasLexicalUnit | fn:lu:carry_goods:stock | "carry goods" | "stock" | "has lexical unit" |  | "FN" |  |
| fn:carry_goods | /r/HasA | fn:fe:distributor | "carry goods" | "distributor" | "/r/has a" |  | "FN" |  |
| fn:carry_goods | /r/HasA | fn:fe:goods | "carry goods" | "goods" | "/r/has a" |  | "FN" |  |
| fn:carry_goods | /r/HasA | fn:fe:time | "carry goods" | "time" | "/r/has a" |  | "FN" |  |
| fn:carry_goods | /r/HasA | fn:fe:place | "carry goods" | "place" | "/r/has a" |  | "FN" |  |
| fn:carry_goods | /r/HasA | fn:fe:manner | "carry goods" | "manner" | "/r/has a" |  | "FN" |  |
| fn:carry_goods | /r/HasA | fn:fe:duration | "carry goods" | "duration" | "/r/has a" |  | "FN" |  |
| fn:carry_goods | /r/HasA | fn:fe:frequency | "carry goods" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:eventive_affecting | /r/UsedFor | fn:catastrophe | "eventive affecting" | "catastrophe" | "/r/used for" |  | "FN" |  |
| fn:undergoing | /r/SimilarTo | fn:catastrophe | "undergoing" | "catastrophe" | "/r/similar to" |  | "FN" |  |
| fn:catastrophe | fn:HasLexicalUnit | fn:lu:catastrophe:befall | "catastrophe" | "befall" | "has lexical unit" |  | "FN" |  |
| fn:catastrophe | fn:HasLexicalUnit | fn:lu:catastrophe:disaster | "catastrophe" | "disaster" | "has lexical unit" |  | "FN" |  |
| fn:catastrophe | fn:HasLexicalUnit | fn:lu:catastrophe:betide | "catastrophe" | "betide" | "has lexical unit" |  | "FN" |  |
| fn:catastrophe | fn:HasLexicalUnit | fn:lu:catastrophe:suffer | "catastrophe" | "suffer" | "has lexical unit" |  | "FN" |  |
| fn:catastrophe | fn:HasLexicalUnit | fn:lu:catastrophe:catastrophe | "catastrophe" | "catastrophe" | "has lexical unit" |  | "FN" |  |
| fn:catastrophe | fn:HasLexicalUnit | fn:lu:catastrophe:mishap | "catastrophe" | "mishap" | "has lexical unit" |  | "FN" |  |
| fn:catastrophe | fn:HasLexicalUnit | fn:lu:catastrophe:mischance | "catastrophe" | "mischance" | "has lexical unit" |  | "FN" |  |
| fn:catastrophe | fn:HasLexicalUnit | fn:lu:catastrophe:misfortune | "catastrophe" | "misfortune" | "has lexical unit" |  | "FN" |  |
| fn:catastrophe | fn:HasLexicalUnit | fn:lu:catastrophe:tragedy | "catastrophe" | "tragedy" | "has lexical unit" |  | "FN" |  |
| fn:catastrophe | fn:HasLexicalUnit | fn:lu:catastrophe:calamity | "catastrophe" | "calamity" | "has lexical unit" |  | "FN" |  |
| fn:catastrophe | fn:HasLexicalUnit | fn:lu:catastrophe:cataclysm | "catastrophe" | "cataclysm" | "has lexical unit" |  | "FN" |  |
| fn:catastrophe | fn:HasLexicalUnit | fn:lu:catastrophe:apocalypse | "catastrophe" | "apocalypse" | "has lexical unit" |  | "FN" |  |
| fn:catastrophe | fn:HasLexicalUnit | fn:lu:catastrophe:calamitous | "catastrophe" | "calamitous" | "has lexical unit" |  | "FN" |  |
| fn:catastrophe | fn:HasLexicalUnit | fn:lu:catastrophe:catastrophic | "catastrophe" | "catastrophic" | "has lexical unit" |  | "FN" |  |
| fn:catastrophe | fn:HasLexicalUnit | fn:lu:catastrophe:incident | "catastrophe" | "incident" | "has lexical unit" |  | "FN" |  |
| fn:catastrophe | fn:HasLexicalUnit | fn:lu:catastrophe:casualty | "catastrophe" | "casualty" | "has lexical unit" |  | "FN" |  |
| fn:catastrophe | fn:HasLexicalUnit | fn:lu:catastrophe:crisis | "catastrophe" | "crisis" | "has lexical unit" |  | "FN" |  |
| fn:catastrophe | fn:HasLexicalUnit | fn:lu:catastrophe:debacle | "catastrophe" | "debacle" | "has lexical unit" |  | "FN" |  |
| fn:catastrophe | fn:HasLexicalUnit | fn:lu:catastrophe:disastrous | "catastrophe" | "disastrous" | "has lexical unit" |  | "FN" |  |
| fn:catastrophe | fn:HasLexicalUnit | fn:lu:catastrophe:accident | "catastrophe" | "accident" | "has lexical unit" |  | "FN" |  |
| fn:catastrophe | fn:HasLexicalUnit | fn:lu:catastrophe:victim | "catastrophe" | "victim" | "has lexical unit" |  | "FN" |  |
| fn:catastrophe | /r/HasA | fn:fe:undesirable_event | "catastrophe" | "undesirable event" | "/r/has a" |  | "FN" |  |
| fn:catastrophe | /r/HasA | fn:fe:place | "catastrophe" | "place" | "/r/has a" |  | "FN" |  |
| fn:catastrophe | /r/HasA | fn:fe:time | "catastrophe" | "time" | "/r/has a" |  | "FN" |  |
| fn:catastrophe | /r/HasA | fn:fe:patient | "catastrophe" | "patient" | "/r/has a" |  | "FN" |  |
| fn:catastrophe | /r/HasA | fn:fe:degree | "catastrophe" | "degree" | "/r/has a" |  | "FN" |  |
| fn:catastrophe | /r/HasA | fn:fe:manner | "catastrophe" | "manner" | "/r/has a" |  | "FN" |  |
| fn:catastrophe | /r/HasA | fn:fe:circumstances | "catastrophe" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:catastrophe | /r/HasA | fn:fe:cause | "catastrophe" | "cause" | "/r/has a" |  | "FN" |  |
| fn:setting_fire | /r/SimilarTo | fn:catching_fire | "setting fire" | "catching fire" | "/r/similar to" |  | "FN" |  |
| fn:fire_burning | /r/HasPrerequisite | fn:catching_fire | "fire burning" | "catching fire" | "/r/has prerequisite" |  | "FN" |  |
| fn:catching_fire | fn:HasLexicalUnit | fn:lu:catching_fire:break_out | "catching fire" | "break out" | "has lexical unit" |  | "FN" |  |
| fn:catching_fire | fn:HasLexicalUnit | fn:lu:catching_fire:catch | "catching fire" | "catch" | "has lexical unit" |  | "FN" |  |
| fn:catching_fire | fn:HasLexicalUnit | fn:lu:catching_fire:catch_fire | "catching fire" | "catch fire" | "has lexical unit" |  | "FN" |  |
| fn:catching_fire | fn:HasLexicalUnit | fn:lu:catching_fire:start | "catching fire" | "start" | "has lexical unit" |  | "FN" |  |
| fn:catching_fire | fn:HasLexicalUnit | fn:lu:catching_fire:combust | "catching fire" | "combust" | "has lexical unit" |  | "FN" |  |
| fn:catching_fire | /r/HasA | fn:fe:place | "catching fire" | "place" | "/r/has a" |  | "FN" |  |
| fn:catching_fire | /r/HasA | fn:fe:time | "catching fire" | "time" | "/r/has a" |  | "FN" |  |
| fn:catching_fire | /r/HasA | fn:fe:fire | "catching fire" | "fire" | "/r/has a" |  | "FN" |  |
| fn:catching_fire | /r/HasA | fn:fe:fuel | "catching fire" | "fuel" | "/r/has a" |  | "FN" |  |
| fn:catching_fire | /r/HasA | fn:fe:manner | "catching fire" | "manner" | "/r/has a" |  | "FN" |  |
| fn:catching_fire | /r/HasA | fn:fe:explanation | "catching fire" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:categorization | /r/UsedFor | fn:being_in_category | "categorization" | "being in category" | "/r/used for" |  | "FN" |  |
| fn:categorization | /r/UsedFor | fn:communicate_categorization | "categorization" | "communicate categorization" | "/r/used for" |  | "FN" |  |
| fn:instance | /r/UsedFor | fn:categorization | "instance" | "categorization" | "/r/used for" |  | "FN" |  |
| fn:mental_activity | /r/UsedFor | fn:categorization | "mental activity" | "categorization" | "/r/used for" |  | "FN" |  |
| fn:awareness | /r/SimilarTo | fn:categorization | "awareness" | "categorization" | "/r/similar to" |  | "FN" |  |
| fn:categorization | /r/SimilarTo | fn:awareness | "categorization" | "awareness" | "/r/similar to" |  | "FN" |  |
| fn:categorization | /r/SimilarTo | fn:communicate_categorization | "categorization" | "communicate categorization" | "/r/similar to" |  | "FN" |  |
| fn:categorization | /r/SimilarTo | fn:statement | "categorization" | "statement" | "/r/similar to" |  | "FN" |  |
| fn:categorization | fn:HasLexicalUnit | fn:lu:categorization:categorization | "categorization" | "categorization" | "has lexical unit" |  | "FN" |  |
| fn:categorization | fn:HasLexicalUnit | fn:lu:categorization:categorize | "categorization" | "categorize" | "has lexical unit" |  | "FN" |  |
| fn:categorization | fn:HasLexicalUnit | fn:lu:categorization:class | "categorization" | "class" | "has lexical unit" |  | "FN" |  |
| fn:categorization | fn:HasLexicalUnit | fn:lu:categorization:classification | "categorization" | "classification" | "has lexical unit" |  | "FN" |  |
| fn:categorization | fn:HasLexicalUnit | fn:lu:categorization:classify | "categorization" | "classify" | "has lexical unit" |  | "FN" |  |
| fn:categorization | fn:HasLexicalUnit | fn:lu:categorization:construe | "categorization" | "construe" | "has lexical unit" |  | "FN" |  |
| fn:categorization | fn:HasLexicalUnit | fn:lu:categorization:interpret | "categorization" | "interpret" | "has lexical unit" |  | "FN" |  |
| fn:categorization | fn:HasLexicalUnit | fn:lu:categorization:interpretation | "categorization" | "interpretation" | "has lexical unit" |  | "FN" |  |
| fn:categorization | fn:HasLexicalUnit | fn:lu:categorization:perceive | "categorization" | "perceive" | "has lexical unit" |  | "FN" |  |
| fn:categorization | fn:HasLexicalUnit | fn:lu:categorization:regard | "categorization" | "regard" | "has lexical unit" |  | "FN" |  |
| fn:categorization | fn:HasLexicalUnit | fn:lu:categorization:translate | "categorization" | "translate" | "has lexical unit" |  | "FN" |  |
| fn:categorization | fn:HasLexicalUnit | fn:lu:categorization:count | "categorization" | "count" | "has lexical unit" |  | "FN" |  |
| fn:categorization | fn:HasLexicalUnit | fn:lu:categorization:peg | "categorization" | "peg" | "has lexical unit" |  | "FN" |  |
| fn:categorization | fn:HasLexicalUnit | fn:lu:categorization:pigeonhole | "categorization" | "pigeonhole" | "has lexical unit" |  | "FN" |  |
| fn:categorization | fn:HasLexicalUnit | fn:lu:categorization:stereotype | "categorization" | "stereotype" | "has lexical unit" |  | "FN" |  |
| fn:categorization | fn:HasLexicalUnit | fn:lu:categorization:typecast | "categorization" | "typecast" | "has lexical unit" |  | "FN" |  |
| fn:categorization | fn:HasLexicalUnit | fn:lu:categorization:understand | "categorization" | "understand" | "has lexical unit" |  | "FN" |  |
| fn:categorization | fn:HasLexicalUnit | fn:lu:categorization:conceive | "categorization" | "conceive" | "has lexical unit" |  | "FN" |  |
| fn:categorization | fn:HasLexicalUnit | fn:lu:categorization:consider | "categorization" | "consider" | "has lexical unit" |  | "FN" |  |
| fn:categorization | fn:HasLexicalUnit | fn:lu:categorization:define | "categorization" | "define" | "has lexical unit" |  | "FN" |  |
| fn:categorization | fn:HasLexicalUnit | fn:lu:categorization:view | "categorization" | "view" | "has lexical unit" |  | "FN" |  |
| fn:categorization | fn:HasLexicalUnit | fn:lu:categorization:render | "categorization" | "render" | "has lexical unit" |  | "FN" |  |
| fn:categorization | fn:HasLexicalUnit | fn:lu:categorization:see | "categorization" | "see" | "has lexical unit" |  | "FN" |  |
| fn:categorization | fn:HasLexicalUnit | fn:lu:categorization:identify | "categorization" | "identify" | "has lexical unit" |  | "FN" |  |
| fn:categorization | fn:HasLexicalUnit | fn:lu:categorization:deem | "categorization" | "deem" | "has lexical unit" |  | "FN" |  |
| fn:categorization | fn:HasLexicalUnit | fn:lu:categorization:bracket | "categorization" | "bracket" | "has lexical unit" |  | "FN" |  |
| fn:categorization | fn:HasLexicalUnit | fn:lu:categorization:read | "categorization" | "read" | "has lexical unit" |  | "FN" |  |
| fn:categorization | fn:HasLexicalUnit | fn:lu:categorization:category | "categorization" | "category" | "has lexical unit" |  | "FN" |  |
| fn:categorization | /r/HasA | fn:fe:cognizer | "categorization" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:categorization | /r/HasA | fn:fe:item | "categorization" | "item" | "/r/has a" |  | "FN" |  |
| fn:categorization | /r/HasA | fn:fe:category | "categorization" | "category" | "/r/has a" |  | "FN" |  |
| fn:categorization | /r/HasA | fn:fe:criteria | "categorization" | "criteria" | "/r/has a" |  | "FN" |  |
| fn:categorization | /r/HasA | fn:fe:manner | "categorization" | "manner" | "/r/has a" |  | "FN" |  |
| fn:categorization | /r/HasA | fn:fe:means | "categorization" | "means" | "/r/has a" |  | "FN" |  |
| fn:categorization | /r/HasA | fn:fe:time | "categorization" | "time" | "/r/has a" |  | "FN" |  |
| fn:categorization | /r/HasA | fn:fe:circumstances | "categorization" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:categorization | /r/HasA | fn:fe:concessive | "categorization" | "concessive" | "/r/has a" |  | "FN" |  |
| fn:categorization | /r/HasA | fn:fe:explanation | "categorization" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:cause_to_start | /r/IsA | fn:causation | "cause to start" | "causation" | "/r/is a" |  | "FN" |  |
| fn:causation | /r/IsA | fn:eventive_affecting | "causation" | "eventive affecting" | "/r/is a" |  | "FN" |  |
| fn:causation | /r/UsedFor | fn:level_of_force_exertion | "causation" | "level of force exertion" | "/r/used for" |  | "FN" |  |
| fn:attempt_suasion | /r/SimilarTo | fn:causation | "attempt suasion" | "causation" | "/r/similar to" |  | "FN" |  |
| fn:causation | /r/SimilarTo | fn:subjective_influence | "causation" | "subjective influence" | "/r/similar to" |  | "FN" |  |
| fn:suasion | /r/SimilarTo | fn:causation | "suasion" | "causation" | "/r/similar to" |  | "FN" |  |
| fn:means | /r/IsA | fn:causation | "means" | "causation" | "/r/is a" |  | "FN" |  |
| fn:causation | /r/IsA | fn:causation_scenario | "causation" | "causation scenario" | "/r/is a" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:cause | "causation" | "cause" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:cause | "causation" | "cause" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:make | "causation" | "make" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:lead_(to) | "causation" | "lead (to)" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:reason | "causation" | "reason" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:send | "causation" | "send" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:bring_about | "causation" | "bring about" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:precipitate | "causation" | "precipitate" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:causative | "causation" | "causative" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:render | "causation" | "render" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:bring | "causation" | "bring" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:bring_on | "causation" | "bring on" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:induce | "causation" | "induce" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:wreak | "causation" | "wreak" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:put | "causation" | "put" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:since | "causation" | "since" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:because | "causation" | "because" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:because_of | "causation" | "because of" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:raise | "causation" | "raise" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:result_(in) | "causation" | "result (in)" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:mean | "causation" | "mean" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:result | "causation" | "result" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:leave | "causation" | "leave" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:for | "causation" | "for" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:see | "causation" | "see" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:force | "causation" | "force" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:give_rise | "causation" | "give rise" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:so | "causation" | "so" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:due_to | "causation" | "due to" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:responsible | "causation" | "responsible" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:consequence | "causation" | "consequence" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:resulting | "causation" | "resulting" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:consequent | "causation" | "consequent" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:consequential | "causation" | "consequential" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:resultant | "causation" | "resultant" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:dictate | "causation" | "dictate" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:motivate | "causation" | "motivate" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:sway | "causation" | "sway" | "has lexical unit" |  | "FN" |  |
| fn:causation | fn:HasLexicalUnit | fn:lu:causation:legacy | "causation" | "legacy" | "has lexical unit" |  | "FN" |  |
| fn:causation | /r/HasA | fn:fe:cause | "causation" | "cause" | "/r/has a" |  | "FN" |  |
| fn:causation | /r/HasA | fn:fe:affected | "causation" | "affected" | "/r/has a" |  | "FN" |  |
| fn:causation | /r/HasA | fn:fe:effect | "causation" | "effect" | "/r/has a" |  | "FN" |  |
| fn:causation | /r/HasA | fn:fe:place | "causation" | "place" | "/r/has a" |  | "FN" |  |
| fn:causation | /r/HasA | fn:fe:time | "causation" | "time" | "/r/has a" |  | "FN" |  |
| fn:fe:actor | /r/IsA | fn:st:sentient | "actor" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:causation | /r/HasA | fn:fe:actor | "causation" | "actor" | "/r/has a" |  | "FN" |  |
| fn:causation | /r/HasA | fn:fe:circumstances | "causation" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:causation | /r/HasA | fn:fe:manner | "causation" | "manner" | "/r/has a" |  | "FN" |  |
| fn:causation | /r/HasA | fn:fe:explanation | "causation" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:causation | /r/HasA | fn:fe:means | "causation" | "means" | "/r/has a" |  | "FN" |  |
| fn:causation | /r/HasA | fn:fe:frequency | "causation" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:causation | /r/HasA | fn:fe:concessive | "causation" | "concessive" | "/r/has a" |  | "FN" |  |
| fn:alternativity | /r/UsedFor | fn:causation_scenario | "alternativity" | "causation scenario" | "/r/used for" |  | "FN" |  |
| fn:conditional_scenario | /r/UsedFor | fn:causation_scenario | "conditional scenario" | "causation scenario" | "/r/used for" |  | "FN" |  |
| fn:causation | /r/IsA | fn:causation_scenario | "causation" | "causation scenario" | "/r/is a" |  | "FN" |  |
| fn:preventing_or_letting | /r/IsA | fn:causation_scenario | "preventing or letting" | "causation scenario" | "/r/is a" |  | "FN" |  |
| fn:causation_scenario | /r/HasA | fn:fe:cause | "causation scenario" | "cause" | "/r/has a" |  | "FN" |  |
| fn:fe:effect | /r/RelatedTo | fn:fe:averted_situation | "effect" | "averted situation" | "/r/related to" |  | "FN" |  |
| fn:causation_scenario | /r/HasA | fn:fe:effect | "causation scenario" | "effect" | "/r/has a" |  | "FN" |  |
| fn:causation_scenario | /r/HasA | fn:fe:averted_situation | "causation scenario" | "averted situation" | "/r/has a" |  | "FN" |  |
| fn:causation_scenario | /r/HasA | fn:fe:time | "causation scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:causation_scenario | /r/HasA | fn:fe:place | "causation scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_harm | /r/IsA | fn:cause_bodily_experience | "cause harm" | "cause bodily experience" | "/r/is a" |  | "FN" |  |
| fn:cause_bodily_experience | /r/IsA | fn:transitive_action | "cause bodily experience" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_bodily_experience | /r/Causes | fn:perception_body | "cause bodily experience" | "perception body" | "/r/causes" |  | "FN" |  |
| fn:cause_bodily_experience | fn:HasLexicalUnit | fn:lu:cause_bodily_experience:itch | "cause bodily experience" | "itch" | "has lexical unit" |  | "FN" |  |
| fn:cause_bodily_experience | fn:HasLexicalUnit | fn:lu:cause_bodily_experience:scratch | "cause bodily experience" | "scratch" | "has lexical unit" |  | "FN" |  |
| fn:cause_bodily_experience | fn:HasLexicalUnit | fn:lu:cause_bodily_experience:tickle | "cause bodily experience" | "tickle" | "has lexical unit" |  | "FN" |  |
| fn:cause_bodily_experience | fn:HasLexicalUnit | fn:lu:cause_bodily_experience:rub | "cause bodily experience" | "rub" | "has lexical unit" |  | "FN" |  |
| fn:cause_bodily_experience | fn:HasLexicalUnit | fn:lu:cause_bodily_experience:massage | "cause bodily experience" | "massage" | "has lexical unit" |  | "FN" |  |
| fn:cause_bodily_experience | fn:HasLexicalUnit | fn:lu:cause_bodily_experience:chafe | "cause bodily experience" | "chafe" | "has lexical unit" |  | "FN" |  |
| fn:cause_bodily_experience | fn:HasLexicalUnit | fn:lu:cause_bodily_experience:hurt | "cause bodily experience" | "hurt" | "has lexical unit" |  | "FN" |  |
| fn:cause_bodily_experience | /r/HasA | fn:fe:agent | "cause bodily experience" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_bodily_experience | /r/HasA | fn:fe:experiencer | "cause bodily experience" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:cause_bodily_experience | /r/HasA | fn:fe:result | "cause bodily experience" | "result" | "/r/has a" |  | "FN" |  |
| fn:cause_bodily_experience | /r/HasA | fn:fe:degree | "cause bodily experience" | "degree" | "/r/has a" |  | "FN" |  |
| fn:cause_bodily_experience | /r/HasA | fn:fe:manner | "cause bodily experience" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_bodily_experience | /r/HasA | fn:fe:means | "cause bodily experience" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_bodily_experience | /r/HasA | fn:fe:place | "cause bodily experience" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_bodily_experience | /r/HasA | fn:fe:time | "cause bodily experience" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_bodily_experience | /r/HasA | fn:fe:body_part | "cause bodily experience" | "body part" | "/r/has a" |  | "FN" |  |
| fn:cause_bodily_experience | /r/HasA | fn:fe:instrument | "cause bodily experience" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:cause_bodily_experience | /r/HasA | fn:fe:purpose | "cause bodily experience" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cause_bodily_experience | /r/HasA | fn:fe:depictive | "cause bodily experience" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:cause_bodily_experience | /r/HasA | fn:fe:containing_event | "cause bodily experience" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:cause_bodily_experience | /r/HasA | fn:fe:explanation | "cause bodily experience" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:cause_bodily_experience | /r/HasA | fn:fe:iterations | "cause bodily experience" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:cause_bodily_experience | /r/HasA | fn:fe:cause | "cause bodily experience" | "cause" | "/r/has a" |  | "FN" |  |
| fn:cause_bodily_experience | /r/HasA | fn:fe:subregion_bodypart | "cause bodily experience" | "subregion bodypart" | "/r/has a" |  | "FN" |  |
| fn:cause_bodily_experience | /r/HasA | fn:fe:circumstances | "cause bodily experience" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:cause_bodily_experience | /r/HasA | fn:fe:frequency | "cause bodily experience" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:cause_bodily_experience | /r/HasA | fn:fe:duration | "cause bodily experience" | "duration" | "/r/has a" |  | "FN" |  |
| fn:cause_bodily_experience | /r/HasA | fn:fe:particular_iteration | "cause bodily experience" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:cause_bodily_experience | /r/HasA | fn:fe:concessive | "cause bodily experience" | "concessive" | "/r/has a" |  | "FN" |  |
| fn:cause_bodily_experience | /r/HasA | fn:fe:re-encoding | "cause bodily experience" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:cause_bodily_experience | /r/HasA | fn:fe:period_of_iterations | "cause bodily experience" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:change_event_duration | /r/IsA | fn:cause_change | "change event duration" | "cause change" | "/r/is a" |  | "FN" |  |
| fn:change_event_time | /r/IsA | fn:cause_change | "change event time" | "cause change" | "/r/is a" |  | "FN" |  |
| fn:exchange_currency | /r/IsA | fn:cause_change | "exchange currency" | "cause change" | "/r/is a" |  | "FN" |  |
| fn:cause_change | /r/IsA | fn:transitive_action | "cause change" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_change | /r/UsedFor | fn:adjusting | "cause change" | "adjusting" | "/r/used for" |  | "FN" |  |
| fn:cause_change | /r/UsedFor | fn:reforming_a_system | "cause change" | "reforming a system" | "/r/used for" |  | "FN" |  |
| fn:reshaping | /r/SimilarTo | fn:cause_change | "reshaping" | "cause change" | "/r/similar to" |  | "FN" |  |
| fn:cause_change | /r/Causes | fn:undergo_change | "cause change" | "undergo change" | "/r/causes" |  | "FN" |  |
| fn:cause_change | fn:HasLexicalUnit | fn:lu:cause_change:make | "cause change" | "make" | "has lexical unit" |  | "FN" |  |
| fn:cause_change | fn:HasLexicalUnit | fn:lu:cause_change:turn | "cause change" | "turn" | "has lexical unit" |  | "FN" |  |
| fn:cause_change | fn:HasLexicalUnit | fn:lu:cause_change:change | "cause change" | "change" | "has lexical unit" |  | "FN" |  |
| fn:cause_change | fn:HasLexicalUnit | fn:lu:cause_change:convert | "cause change" | "convert" | "has lexical unit" |  | "FN" |  |
| fn:cause_change | fn:HasLexicalUnit | fn:lu:cause_change:transform | "cause change" | "transform" | "has lexical unit" |  | "FN" |  |
| fn:cause_change | fn:HasLexicalUnit | fn:lu:cause_change:modify | "cause change" | "modify" | "has lexical unit" |  | "FN" |  |
| fn:cause_change | fn:HasLexicalUnit | fn:lu:cause_change:alter | "cause change" | "alter" | "has lexical unit" |  | "FN" |  |
| fn:cause_change | fn:HasLexicalUnit | fn:lu:cause_change:modification | "cause change" | "modification" | "has lexical unit" |  | "FN" |  |
| fn:cause_change | fn:HasLexicalUnit | fn:lu:cause_change:alteration | "cause change" | "alteration" | "has lexical unit" |  | "FN" |  |
| fn:cause_change | fn:HasLexicalUnit | fn:lu:cause_change:conversion | "cause change" | "conversion" | "has lexical unit" |  | "FN" |  |
| fn:cause_change | fn:HasLexicalUnit | fn:lu:cause_change:transformation | "cause change" | "transformation" | "has lexical unit" |  | "FN" |  |
| fn:cause_change | fn:HasLexicalUnit | fn:lu:cause_change:vary | "cause change" | "vary" | "has lexical unit" |  | "FN" |  |
| fn:cause_change | fn:HasLexicalUnit | fn:lu:cause_change:variation | "cause change" | "variation" | "has lexical unit" |  | "FN" |  |
| fn:cause_change | fn:HasLexicalUnit | fn:lu:cause_change:reshape | "cause change" | "reshape" | "has lexical unit" |  | "FN" |  |
| fn:cause_change | fn:HasLexicalUnit | fn:lu:cause_change:shift | "cause change" | "shift" | "has lexical unit" |  | "FN" |  |
| fn:cause_change | fn:HasLexicalUnit | fn:lu:cause_change:deform | "cause change" | "deform" | "has lexical unit" |  | "FN" |  |
| fn:fe:agent | /r/RelatedTo | fn:fe:cause | "agent" | "cause" | "/r/related to" |  | "FN" |  |
| fn:cause_change | /r/HasA | fn:fe:agent | "cause change" | "agent" | "/r/has a" |  | "FN" |  |
| fn:fe:initial_category | /r/RelatedTo | fn:fe:initial_value | "initial category" | "initial value" | "/r/related to" |  | "FN" |  |
| fn:cause_change | /r/HasA | fn:fe:initial_category | "cause change" | "initial category" | "/r/has a" |  | "FN" |  |
| fn:fe:final_category | /r/RelatedTo | fn:fe:final_value | "final category" | "final value" | "/r/related to" |  | "FN" |  |
| fn:cause_change | /r/HasA | fn:fe:final_category | "cause change" | "final category" | "/r/has a" |  | "FN" |  |
| fn:fe:final_value | /r/HasPrerequisite | fn:fe:attribute | "final value" | "attribute" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:final_value | /r/RelatedTo | fn:fe:final_category | "final value" | "final category" | "/r/related to" |  | "FN" |  |
| fn:cause_change | /r/HasA | fn:fe:final_value | "cause change" | "final value" | "/r/has a" |  | "FN" |  |
| fn:fe:initial_value | /r/HasPrerequisite | fn:fe:attribute | "initial value" | "attribute" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:initial_value | /r/RelatedTo | fn:fe:final_category | "initial value" | "final category" | "/r/related to" |  | "FN" |  |
| fn:cause_change | /r/HasA | fn:fe:initial_value | "cause change" | "initial value" | "/r/has a" |  | "FN" |  |
| fn:cause_change | /r/HasA | fn:fe:time | "cause change" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_change | /r/HasA | fn:fe:degree | "cause change" | "degree" | "/r/has a" |  | "FN" |  |
| fn:cause_change | /r/HasA | fn:fe:manner | "cause change" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_change | /r/HasA | fn:fe:explanation | "cause change" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:fe:attribute | /r/RelatedTo | fn:fe:final_category | "attribute" | "final category" | "/r/related to" |  | "FN" |  |
| fn:cause_change | /r/HasA | fn:fe:attribute | "cause change" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:cause_change | /r/HasA | fn:fe:entity | "cause change" | "entity" | "/r/has a" |  | "FN" |  |
| fn:cause_change | /r/HasA | fn:fe:cause | "cause change" | "cause" | "/r/has a" |  | "FN" |  |
| fn:cause_change | /r/HasA | fn:fe:purpose | "cause change" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cause_change | /r/HasA | fn:fe:means | "cause change" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_change | /r/HasA | fn:fe:containing_event | "cause change" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:cause_change | /r/HasA | fn:fe:place | "cause change" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_change | /r/HasA | fn:fe:duration | "cause change" | "duration" | "/r/has a" |  | "FN" |  |
| fn:cause_change | /r/HasA | fn:fe:circumstances | "cause change" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:cause_change | /r/HasA | fn:fe:role | "cause change" | "role" | "/r/has a" |  | "FN" |  |
| fn:cause_change | /r/HasA | fn:fe:event_description | "cause change" | "event description" | "/r/has a" |  | "FN" |  |
| fn:cause_change | /r/HasA | fn:fe:period_of_iterations | "cause change" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:cause_change | /r/HasA | fn:fe:re-encoding | "cause change" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_consistency | /r/IsA | fn:transitive_action | "cause change of consistency" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_change_of_consistency | /r/Causes | fn:change_of_consistency | "cause change of consistency" | "change of consistency" | "/r/causes" |  | "FN" |  |
| fn:cause_change_of_consistency | fn:HasLexicalUnit | fn:lu:cause_change_of_consistency:thicken | "cause change of consistency" | "thicken" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_consistency | fn:HasLexicalUnit | fn:lu:cause_change_of_consistency:thin | "cause change of consistency" | "thin" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_consistency | fn:HasLexicalUnit | fn:lu:cause_change_of_consistency:curdle | "cause change of consistency" | "curdle" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_consistency | fn:HasLexicalUnit | fn:lu:cause_change_of_consistency:soften | "cause change of consistency" | "soften" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_consistency | fn:HasLexicalUnit | fn:lu:cause_change_of_consistency:harden | "cause change of consistency" | "harden" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_consistency | fn:HasLexicalUnit | fn:lu:cause_change_of_consistency:jell | "cause change of consistency" | "jell" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_consistency | fn:HasLexicalUnit | fn:lu:cause_change_of_consistency:coagulate | "cause change of consistency" | "coagulate" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_consistency | fn:HasLexicalUnit | fn:lu:cause_change_of_consistency:congeal | "cause change of consistency" | "congeal" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_consistency | fn:HasLexicalUnit | fn:lu:cause_change_of_consistency:clot | "cause change of consistency" | "clot" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_consistency | fn:HasLexicalUnit | fn:lu:cause_change_of_consistency:indurate | "cause change of consistency" | "indurate" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_consistency | fn:HasLexicalUnit | fn:lu:cause_change_of_consistency:inspissate | "cause change of consistency" | "inspissate" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_consistency | fn:HasLexicalUnit | fn:lu:cause_change_of_consistency:set | "cause change of consistency" | "set" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_consistency | /r/HasA | fn:fe:circumstances | "cause change of consistency" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_consistency | /r/HasA | fn:fe:degree | "cause change of consistency" | "degree" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_consistency | /r/HasA | fn:fe:initial_state | "cause change of consistency" | "initial state" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_consistency | /r/HasA | fn:fe:manner | "cause change of consistency" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_consistency | /r/HasA | fn:fe:place | "cause change of consistency" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_consistency | /r/HasA | fn:fe:explanation | "cause change of consistency" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_consistency | /r/HasA | fn:fe:result | "cause change of consistency" | "result" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_consistency | /r/HasA | fn:fe:speed | "cause change of consistency" | "speed" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_consistency | /r/HasA | fn:fe:subregion | "cause change of consistency" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_consistency | /r/HasA | fn:fe:time | "cause change of consistency" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_consistency | /r/HasA | fn:fe:patient | "cause change of consistency" | "patient" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_consistency | /r/HasA | fn:fe:agent | "cause change of consistency" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_consistency | /r/HasA | fn:fe:instrument | "cause change of consistency" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_consistency | /r/HasA | fn:fe:means | "cause change of consistency" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_consistency | /r/HasA | fn:fe:purpose | "cause change of consistency" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_consistency | /r/HasA | fn:fe:cause | "cause change of consistency" | "cause" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_consistency | /r/HasA | fn:fe:change_agent | "cause change of consistency" | "change agent" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_consistency | /r/HasA | fn:fe:container | "cause change of consistency" | "container" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_consistency | /r/HasA | fn:fe:hot_cold_source | "cause change of consistency" | "hot cold source" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_phase | /r/IsA | fn:transitive_action | "cause change of phase" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_change_of_phase | /r/Causes | fn:substance_by_phase | "cause change of phase" | "substance by phase" | "/r/causes" |  | "FN" |  |
| fn:cause_change_of_phase | /r/Causes | fn:change_of_phase | "cause change of phase" | "change of phase" | "/r/causes" |  | "FN" |  |
| fn:cause_change_of_phase | fn:HasLexicalUnit | fn:lu:cause_change_of_phase:freeze | "cause change of phase" | "freeze" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_phase | fn:HasLexicalUnit | fn:lu:cause_change_of_phase:thaw | "cause change of phase" | "thaw" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_phase | fn:HasLexicalUnit | fn:lu:cause_change_of_phase:melt | "cause change of phase" | "melt" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_phase | fn:HasLexicalUnit | fn:lu:cause_change_of_phase:defrost | "cause change of phase" | "defrost" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_phase | fn:HasLexicalUnit | fn:lu:cause_change_of_phase:evaporate | "cause change of phase" | "evaporate" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_phase | fn:HasLexicalUnit | fn:lu:cause_change_of_phase:liquefy | "cause change of phase" | "liquefy" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_phase | fn:HasLexicalUnit | fn:lu:cause_change_of_phase:solidify | "cause change of phase" | "solidify" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_phase | fn:HasLexicalUnit | fn:lu:cause_change_of_phase:flux | "cause change of phase" | "flux" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_phase | fn:HasLexicalUnit | fn:lu:cause_change_of_phase:unfreeze | "cause change of phase" | "unfreeze" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_phase | fn:HasLexicalUnit | fn:lu:cause_change_of_phase:boil | "cause change of phase" | "boil" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_phase | /r/HasA | fn:fe:agent | "cause change of phase" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_phase | /r/HasA | fn:fe:instrument | "cause change of phase" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_phase | /r/HasA | fn:fe:manner | "cause change of phase" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_phase | /r/HasA | fn:fe:means | "cause change of phase" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_phase | /r/HasA | fn:fe:patient | "cause change of phase" | "patient" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_phase | /r/HasA | fn:fe:place | "cause change of phase" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_phase | /r/HasA | fn:fe:purpose | "cause change of phase" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_phase | /r/HasA | fn:fe:time | "cause change of phase" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_phase | /r/HasA | fn:fe:circumstances | "cause change of phase" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_phase | /r/HasA | fn:fe:degree | "cause change of phase" | "degree" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_phase | /r/HasA | fn:fe:initial_state | "cause change of phase" | "initial state" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_phase | /r/HasA | fn:fe:result | "cause change of phase" | "result" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_phase | /r/HasA | fn:fe:speed | "cause change of phase" | "speed" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_phase | /r/HasA | fn:fe:subregion | "cause change of phase" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_phase | /r/HasA | fn:fe:cause | "cause change of phase" | "cause" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_phase | /r/HasA | fn:fe:container | "cause change of phase" | "container" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_phase | /r/HasA | fn:fe:duration | "cause change of phase" | "duration" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_phase | /r/HasA | fn:fe:depictive | "cause change of phase" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_phase | /r/HasA | fn:fe:medium | "cause change of phase" | "medium" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_phase | /r/HasA | fn:fe:hot_cold_source | "cause change of phase" | "hot cold source" | "/r/has a" |  | "FN" |  |
| fn:cause_proliferation_in_number | /r/IsA | fn:cause_change_of_position_on_a_scale | "cause proliferation in number" | "cause change of position on a scale" | "/r/is a" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | /r/IsA | fn:transitive_action | "cause change of position on a scale" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_expansion | /r/SimilarTo | fn:cause_change_of_position_on_a_scale | "cause expansion" | "cause change of position on a scale" | "/r/similar to" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | /r/Causes | fn:change_position_on_a_scale | "cause change of position on a scale" | "change position on a scale" | "/r/causes" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | fn:HasLexicalUnit | fn:lu:cause_change_of_position_on_a_scale:increase | "cause change of position on a scale" | "increase" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | fn:HasLexicalUnit | fn:lu:cause_change_of_position_on_a_scale:decrease | "cause change of position on a scale" | "decrease" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | fn:HasLexicalUnit | fn:lu:cause_change_of_position_on_a_scale:reduce | "cause change of position on a scale" | "reduce" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | fn:HasLexicalUnit | fn:lu:cause_change_of_position_on_a_scale:reduction | "cause change of position on a scale" | "reduction" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | fn:HasLexicalUnit | fn:lu:cause_change_of_position_on_a_scale:lower | "cause change of position on a scale" | "lower" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | fn:HasLexicalUnit | fn:lu:cause_change_of_position_on_a_scale:raise | "cause change of position on a scale" | "raise" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | fn:HasLexicalUnit | fn:lu:cause_change_of_position_on_a_scale:swell | "cause change of position on a scale" | "swell" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | fn:HasLexicalUnit | fn:lu:cause_change_of_position_on_a_scale:growth | "cause change of position on a scale" | "growth" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | fn:HasLexicalUnit | fn:lu:cause_change_of_position_on_a_scale:diminish | "cause change of position on a scale" | "diminish" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | fn:HasLexicalUnit | fn:lu:cause_change_of_position_on_a_scale:cut | "cause change of position on a scale" | "cut" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | fn:HasLexicalUnit | fn:lu:cause_change_of_position_on_a_scale:cut | "cause change of position on a scale" | "cut" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | fn:HasLexicalUnit | fn:lu:cause_change_of_position_on_a_scale:move | "cause change of position on a scale" | "move" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | fn:HasLexicalUnit | fn:lu:cause_change_of_position_on_a_scale:curtail | "cause change of position on a scale" | "curtail" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | fn:HasLexicalUnit | fn:lu:cause_change_of_position_on_a_scale:knock_down | "cause change of position on a scale" | "knock down" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | fn:HasLexicalUnit | fn:lu:cause_change_of_position_on_a_scale:step_up | "cause change of position on a scale" | "step up" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | fn:HasLexicalUnit | fn:lu:cause_change_of_position_on_a_scale:push | "cause change of position on a scale" | "push" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | fn:HasLexicalUnit | fn:lu:cause_change_of_position_on_a_scale:push | "cause change of position on a scale" | "push" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | fn:HasLexicalUnit | fn:lu:cause_change_of_position_on_a_scale:promote | "cause change of position on a scale" | "promote" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | fn:HasLexicalUnit | fn:lu:cause_change_of_position_on_a_scale:enhance | "cause change of position on a scale" | "enhance" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | fn:HasLexicalUnit | fn:lu:cause_change_of_position_on_a_scale:add | "cause change of position on a scale" | "add" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | fn:HasLexicalUnit | fn:lu:cause_change_of_position_on_a_scale:development | "cause change of position on a scale" | "development" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | fn:HasLexicalUnit | fn:lu:cause_change_of_position_on_a_scale:crank | "cause change of position on a scale" | "crank" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | fn:HasLexicalUnit | fn:lu:cause_change_of_position_on_a_scale:slash | "cause change of position on a scale" | "slash" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | fn:HasLexicalUnit | fn:lu:cause_change_of_position_on_a_scale:drop | "cause change of position on a scale" | "drop" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | fn:HasLexicalUnit | fn:lu:cause_change_of_position_on_a_scale:double | "cause change of position on a scale" | "double" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | fn:HasLexicalUnit | fn:lu:cause_change_of_position_on_a_scale:lift | "cause change of position on a scale" | "lift" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | /r/HasA | fn:fe:agent | "cause change of position on a scale" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | /r/HasA | fn:fe:difference | "cause change of position on a scale" | "difference" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | /r/HasA | fn:fe:attribute | "cause change of position on a scale" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | /r/HasA | fn:fe:value_1 | "cause change of position on a scale" | "value 1" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | /r/HasA | fn:fe:value_2 | "cause change of position on a scale" | "value 2" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | /r/HasA | fn:fe:co-variable | "cause change of position on a scale" | "co-variable" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | /r/HasA | fn:fe:path | "cause change of position on a scale" | "path" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | /r/HasA | fn:fe:speed | "cause change of position on a scale" | "speed" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | /r/HasA | fn:fe:item | "cause change of position on a scale" | "item" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | /r/HasA | fn:fe:means | "cause change of position on a scale" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | /r/HasA | fn:fe:purpose | "cause change of position on a scale" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | /r/HasA | fn:fe:time | "cause change of position on a scale" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | /r/HasA | fn:fe:cause | "cause change of position on a scale" | "cause" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | /r/HasA | fn:fe:manner | "cause change of position on a scale" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | /r/HasA | fn:fe:place | "cause change of position on a scale" | "place" | "/r/has a" |  | "FN" |  |
| fn:change_resistance | /r/IsA | fn:cause_change_of_strength | "change resistance" | "cause change of strength" | "/r/is a" |  | "FN" |  |
| fn:cause_change_of_strength | /r/IsA | fn:transitive_action | "cause change of strength" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_change_of_strength | /r/UsedFor | fn:supporting | "cause change of strength" | "supporting" | "/r/used for" |  | "FN" |  |
| fn:cause_change_of_strength | fn:HasLexicalUnit | fn:lu:cause_change_of_strength:fortify | "cause change of strength" | "fortify" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_strength | fn:HasLexicalUnit | fn:lu:cause_change_of_strength:strengthen | "cause change of strength" | "strengthen" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_strength | fn:HasLexicalUnit | fn:lu:cause_change_of_strength:reinforce | "cause change of strength" | "reinforce" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_strength | fn:HasLexicalUnit | fn:lu:cause_change_of_strength:weaken | "cause change of strength" | "weaken" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_strength | fn:HasLexicalUnit | fn:lu:cause_change_of_strength:beef_up | "cause change of strength" | "beef up" | "has lexical unit" |  | "FN" |  |
| fn:cause_change_of_strength | /r/HasA | fn:fe:agent | "cause change of strength" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_strength | /r/HasA | fn:fe:patient | "cause change of strength" | "patient" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_strength | /r/HasA | fn:fe:depictive | "cause change of strength" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_strength | /r/HasA | fn:fe:result | "cause change of strength" | "result" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_strength | /r/HasA | fn:fe:means | "cause change of strength" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_strength | /r/HasA | fn:fe:manner | "cause change of strength" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_strength | /r/HasA | fn:fe:time | "cause change of strength" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_strength | /r/HasA | fn:fe:place | "cause change of strength" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_strength | /r/HasA | fn:fe:cause | "cause change of strength" | "cause" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_strength | /r/HasA | fn:fe:containing_event | "cause change of strength" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_strength | /r/HasA | fn:fe:degree | "cause change of strength" | "degree" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_strength | /r/HasA | fn:fe:frequency | "cause change of strength" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:cause_change_of_strength | /r/HasA | fn:fe:circumstances | "cause change of strength" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:cause_emotion | /r/IsA | fn:intentionally_affect | "cause emotion" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:cause_emotion | /r/Causes | fn:experiencer_focus | "cause emotion" | "experiencer focus" | "/r/causes" |  | "FN" |  |
| fn:cause_emotion | fn:HasLexicalUnit | fn:lu:cause_emotion:offend | "cause emotion" | "offend" | "has lexical unit" |  | "FN" |  |
| fn:cause_emotion | fn:HasLexicalUnit | fn:lu:cause_emotion:affront | "cause emotion" | "affront" | "has lexical unit" |  | "FN" |  |
| fn:cause_emotion | fn:HasLexicalUnit | fn:lu:cause_emotion:insult | "cause emotion" | "insult" | "has lexical unit" |  | "FN" |  |
| fn:cause_emotion | fn:HasLexicalUnit | fn:lu:cause_emotion:affront | "cause emotion" | "affront" | "has lexical unit" |  | "FN" |  |
| fn:cause_emotion | fn:HasLexicalUnit | fn:lu:cause_emotion:offensive | "cause emotion" | "offensive" | "has lexical unit" |  | "FN" |  |
| fn:cause_emotion | fn:HasLexicalUnit | fn:lu:cause_emotion:insult | "cause emotion" | "insult" | "has lexical unit" |  | "FN" |  |
| fn:cause_emotion | fn:HasLexicalUnit | fn:lu:cause_emotion:offense | "cause emotion" | "offense" | "has lexical unit" |  | "FN" |  |
| fn:cause_emotion | fn:HasLexicalUnit | fn:lu:cause_emotion:concern | "cause emotion" | "concern" | "has lexical unit" |  | "FN" |  |
| fn:cause_emotion | fn:HasLexicalUnit | fn:lu:cause_emotion:call_name | "cause emotion" | "call name" | "has lexical unit" |  | "FN" |  |
| fn:cause_emotion | /r/HasA | fn:fe:agent | "cause emotion" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_emotion | /r/HasA | fn:fe:experiencer | "cause emotion" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:cause_emotion | /r/HasA | fn:fe:degree | "cause emotion" | "degree" | "/r/has a" |  | "FN" |  |
| fn:cause_emotion | /r/HasA | fn:fe:instrument | "cause emotion" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:cause_emotion | /r/HasA | fn:fe:frequency | "cause emotion" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:cause_emotion | /r/HasA | fn:fe:means | "cause emotion" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_emotion | /r/HasA | fn:fe:manner | "cause emotion" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_emotion | /r/HasA | fn:fe:event_description | "cause emotion" | "event description" | "/r/has a" |  | "FN" |  |
| fn:cause_emotion | /r/HasA | fn:fe:particular_iteration | "cause emotion" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:cause_emotion | /r/HasA | fn:fe:depictive | "cause emotion" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:cause_emotion | /r/HasA | fn:fe:explanation | "cause emotion" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:cause_emotion | /r/HasA | fn:fe:period_of_iterations | "cause emotion" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:cause_emotion | /r/HasA | fn:fe:time | "cause emotion" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_emotion | /r/HasA | fn:fe:containing_event | "cause emotion" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:cause_emotion | /r/HasA | fn:fe:event | "cause emotion" | "event" | "/r/has a" |  | "FN" |  |
| fn:cause_emotion | /r/HasA | fn:fe:type | "cause emotion" | "type" | "/r/has a" |  | "FN" |  |
| fn:cause_emotion | /r/HasA | fn:fe:medium | "cause emotion" | "medium" | "/r/has a" |  | "FN" |  |
| fn:cause_emotion | /r/HasA | fn:fe:place | "cause emotion" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_expansion | /r/IsA | fn:transitive_action | "cause expansion" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_expansion | /r/SimilarTo | fn:cause_change_of_position_on_a_scale | "cause expansion" | "cause change of position on a scale" | "/r/similar to" |  | "FN" |  |
| fn:cause_expansion | /r/SimilarTo | fn:expansion | "cause expansion" | "expansion" | "/r/similar to" |  | "FN" |  |
| fn:cause_expansion | /r/Causes | fn:expansion | "cause expansion" | "expansion" | "/r/causes" |  | "FN" |  |
| fn:cause_expansion | fn:HasLexicalUnit | fn:lu:cause_expansion:aggrandizement | "cause expansion" | "aggrandizement" | "has lexical unit" |  | "FN" |  |
| fn:cause_expansion | fn:HasLexicalUnit | fn:lu:cause_expansion:augmentation | "cause expansion" | "augmentation" | "has lexical unit" |  | "FN" |  |
| fn:cause_expansion | fn:HasLexicalUnit | fn:lu:cause_expansion:contraction | "cause expansion" | "contraction" | "has lexical unit" |  | "FN" |  |
| fn:cause_expansion | fn:HasLexicalUnit | fn:lu:cause_expansion:dilate | "cause expansion" | "dilate" | "has lexical unit" |  | "FN" |  |
| fn:cause_expansion | fn:HasLexicalUnit | fn:lu:cause_expansion:enlarge | "cause expansion" | "enlarge" | "has lexical unit" |  | "FN" |  |
| fn:cause_expansion | fn:HasLexicalUnit | fn:lu:cause_expansion:enlargement | "cause expansion" | "enlargement" | "has lexical unit" |  | "FN" |  |
| fn:cause_expansion | fn:HasLexicalUnit | fn:lu:cause_expansion:expand | "cause expansion" | "expand" | "has lexical unit" |  | "FN" |  |
| fn:cause_expansion | fn:HasLexicalUnit | fn:lu:cause_expansion:expansion | "cause expansion" | "expansion" | "has lexical unit" |  | "FN" |  |
| fn:cause_expansion | fn:HasLexicalUnit | fn:lu:cause_expansion:growth | "cause expansion" | "growth" | "has lexical unit" |  | "FN" |  |
| fn:cause_expansion | fn:HasLexicalUnit | fn:lu:cause_expansion:inflate | "cause expansion" | "inflate" | "has lexical unit" |  | "FN" |  |
| fn:cause_expansion | fn:HasLexicalUnit | fn:lu:cause_expansion:lengthen | "cause expansion" | "lengthen" | "has lexical unit" |  | "FN" |  |
| fn:cause_expansion | fn:HasLexicalUnit | fn:lu:cause_expansion:magnification | "cause expansion" | "magnification" | "has lexical unit" |  | "FN" |  |
| fn:cause_expansion | fn:HasLexicalUnit | fn:lu:cause_expansion:magnify | "cause expansion" | "magnify" | "has lexical unit" |  | "FN" |  |
| fn:cause_expansion | fn:HasLexicalUnit | fn:lu:cause_expansion:reduction | "cause expansion" | "reduction" | "has lexical unit" |  | "FN" |  |
| fn:cause_expansion | fn:HasLexicalUnit | fn:lu:cause_expansion:shrink | "cause expansion" | "shrink" | "has lexical unit" |  | "FN" |  |
| fn:cause_expansion | fn:HasLexicalUnit | fn:lu:cause_expansion:swell | "cause expansion" | "swell" | "has lexical unit" |  | "FN" |  |
| fn:cause_expansion | fn:HasLexicalUnit | fn:lu:cause_expansion:widen | "cause expansion" | "widen" | "has lexical unit" |  | "FN" |  |
| fn:cause_expansion | fn:HasLexicalUnit | fn:lu:cause_expansion:narrow | "cause expansion" | "narrow" | "has lexical unit" |  | "FN" |  |
| fn:cause_expansion | fn:HasLexicalUnit | fn:lu:cause_expansion:grow | "cause expansion" | "grow" | "has lexical unit" |  | "FN" |  |
| fn:cause_expansion | fn:HasLexicalUnit | fn:lu:cause_expansion:blow_up | "cause expansion" | "blow up" | "has lexical unit" |  | "FN" |  |
| fn:cause_expansion | fn:HasLexicalUnit | fn:lu:cause_expansion:stretch | "cause expansion" | "stretch" | "has lexical unit" |  | "FN" |  |
| fn:cause_expansion | fn:HasLexicalUnit | fn:lu:cause_expansion:compress | "cause expansion" | "compress" | "has lexical unit" |  | "FN" |  |
| fn:cause_expansion | fn:HasLexicalUnit | fn:lu:cause_expansion:compression | "cause expansion" | "compression" | "has lexical unit" |  | "FN" |  |
| fn:cause_expansion | fn:HasLexicalUnit | fn:lu:cause_expansion:condense | "cause expansion" | "condense" | "has lexical unit" |  | "FN" |  |
| fn:cause_expansion | /r/HasA | fn:fe:agent | "cause expansion" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_expansion | /r/HasA | fn:fe:item | "cause expansion" | "item" | "/r/has a" |  | "FN" |  |
| fn:cause_expansion | /r/HasA | fn:fe:initial_size | "cause expansion" | "initial size" | "/r/has a" |  | "FN" |  |
| fn:cause_expansion | /r/HasA | fn:fe:result_size | "cause expansion" | "result size" | "/r/has a" |  | "FN" |  |
| fn:cause_expansion | /r/HasA | fn:fe:size_change | "cause expansion" | "size change" | "/r/has a" |  | "FN" |  |
| fn:cause_expansion | /r/HasA | fn:fe:dimension | "cause expansion" | "dimension" | "/r/has a" |  | "FN" |  |
| fn:cause_expansion | /r/HasA | fn:fe:means | "cause expansion" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_expansion | /r/HasA | fn:fe:manner | "cause expansion" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_expansion | /r/HasA | fn:fe:co-variable | "cause expansion" | "co-variable" | "/r/has a" |  | "FN" |  |
| fn:cause_expansion | /r/HasA | fn:fe:group | "cause expansion" | "group" | "/r/has a" |  | "FN" |  |
| fn:cause_expansion | /r/HasA | fn:fe:rate | "cause expansion" | "rate" | "/r/has a" |  | "FN" |  |
| fn:cause_expansion | /r/HasA | fn:fe:cause | "cause expansion" | "cause" | "/r/has a" |  | "FN" |  |
| fn:cause_expansion | /r/HasA | fn:fe:elapsed_time | "cause expansion" | "elapsed time" | "/r/has a" |  | "FN" |  |
| fn:cause_expansion | /r/HasA | fn:fe:time | "cause expansion" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_expansion | /r/HasA | fn:fe:place | "cause expansion" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_expansion | /r/HasA | fn:fe:explanation | "cause expansion" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:cause_expansion | /r/HasA | fn:fe:purpose | "cause expansion" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cause_expansion | /r/HasA | fn:fe:instrument | "cause expansion" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:cause_fluidic_motion | /r/IsA | fn:cause_motion | "cause fluidic motion" | "cause motion" | "/r/is a" |  | "FN" |  |
| fn:placing | /r/SimilarTo | fn:cause_fluidic_motion | "placing" | "cause fluidic motion" | "/r/similar to" |  | "FN" |  |
| fn:cause_fluidic_motion | /r/Causes | fn:fluidic_motion | "cause fluidic motion" | "fluidic motion" | "/r/causes" |  | "FN" |  |
| fn:cause_fluidic_motion | fn:HasLexicalUnit | fn:lu:cause_fluidic_motion:spatter | "cause fluidic motion" | "spatter" | "has lexical unit" |  | "FN" |  |
| fn:cause_fluidic_motion | fn:HasLexicalUnit | fn:lu:cause_fluidic_motion:splatter | "cause fluidic motion" | "splatter" | "has lexical unit" |  | "FN" |  |
| fn:cause_fluidic_motion | fn:HasLexicalUnit | fn:lu:cause_fluidic_motion:splash | "cause fluidic motion" | "splash" | "has lexical unit" |  | "FN" |  |
| fn:cause_fluidic_motion | fn:HasLexicalUnit | fn:lu:cause_fluidic_motion:spray | "cause fluidic motion" | "spray" | "has lexical unit" |  | "FN" |  |
| fn:cause_fluidic_motion | fn:HasLexicalUnit | fn:lu:cause_fluidic_motion:squirt | "cause fluidic motion" | "squirt" | "has lexical unit" |  | "FN" |  |
| fn:cause_fluidic_motion | fn:HasLexicalUnit | fn:lu:cause_fluidic_motion:pump | "cause fluidic motion" | "pump" | "has lexical unit" |  | "FN" |  |
| fn:cause_fluidic_motion | fn:HasLexicalUnit | fn:lu:cause_fluidic_motion:drip | "cause fluidic motion" | "drip" | "has lexical unit" |  | "FN" |  |
| fn:cause_fluidic_motion | fn:HasLexicalUnit | fn:lu:cause_fluidic_motion:sprinkle | "cause fluidic motion" | "sprinkle" | "has lexical unit" |  | "FN" |  |
| fn:cause_fluidic_motion | fn:HasLexicalUnit | fn:lu:cause_fluidic_motion:dribble | "cause fluidic motion" | "dribble" | "has lexical unit" |  | "FN" |  |
| fn:cause_fluidic_motion | fn:HasLexicalUnit | fn:lu:cause_fluidic_motion:spew | "cause fluidic motion" | "spew" | "has lexical unit" |  | "FN" |  |
| fn:cause_fluidic_motion | fn:HasLexicalUnit | fn:lu:cause_fluidic_motion:spill | "cause fluidic motion" | "spill" | "has lexical unit" |  | "FN" |  |
| fn:cause_fluidic_motion | /r/HasA | fn:fe:agent | "cause fluidic motion" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_fluidic_motion | /r/HasA | fn:fe:cause | "cause fluidic motion" | "cause" | "/r/has a" |  | "FN" |  |
| fn:cause_fluidic_motion | /r/HasA | fn:fe:fluid | "cause fluidic motion" | "fluid" | "/r/has a" |  | "FN" |  |
| fn:cause_fluidic_motion | /r/HasA | fn:fe:source | "cause fluidic motion" | "source" | "/r/has a" |  | "FN" |  |
| fn:cause_fluidic_motion | /r/HasA | fn:fe:goal | "cause fluidic motion" | "goal" | "/r/has a" |  | "FN" |  |
| fn:cause_fluidic_motion | /r/HasA | fn:fe:path | "cause fluidic motion" | "path" | "/r/has a" |  | "FN" |  |
| fn:cause_fluidic_motion | /r/HasA | fn:fe:area | "cause fluidic motion" | "area" | "/r/has a" |  | "FN" |  |
| fn:cause_fluidic_motion | /r/HasA | fn:fe:manner | "cause fluidic motion" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_fluidic_motion | /r/HasA | fn:fe:time | "cause fluidic motion" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_fluidic_motion | /r/HasA | fn:fe:explanation | "cause fluidic motion" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:fe:result | /r/RelatedTo | fn:fe:area | "result" | "area" | "/r/related to" |  | "FN" |  |
| fn:cause_fluidic_motion | /r/HasA | fn:fe:result | "cause fluidic motion" | "result" | "/r/has a" |  | "FN" |  |
| fn:cause_fluidic_motion | /r/HasA | fn:fe:place | "cause fluidic motion" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_fluidic_motion | /r/HasA | fn:fe:instrument | "cause fluidic motion" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:cause_fluidic_motion | /r/HasA | fn:fe:means | "cause fluidic motion" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_fluidic_motion | /r/HasA | fn:fe:purpose | "cause fluidic motion" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cause_fluidic_motion | /r/HasA | fn:fe:distance | "cause fluidic motion" | "distance" | "/r/has a" |  | "FN" |  |
| fn:cause_harm | /r/IsA | fn:cause_bodily_experience | "cause harm" | "cause bodily experience" | "/r/is a" |  | "FN" |  |
| fn:corporal_punishment | /r/IsA | fn:cause_harm | "corporal punishment" | "cause harm" | "/r/is a" |  | "FN" |  |
| fn:cause_harm | /r/UsedFor | fn:abusing | "cause harm" | "abusing" | "/r/used for" |  | "FN" |  |
| fn:cause_harm | /r/UsedFor | fn:terrorism | "cause harm" | "terrorism" | "/r/used for" |  | "FN" |  |
| fn:cause_harm | /r/UsedFor | fn:toxic_substance | "cause harm" | "toxic substance" | "/r/used for" |  | "FN" |  |
| fn:cause_harm | /r/UsedFor | fn:violence | "cause harm" | "violence" | "/r/used for" |  | "FN" |  |
| fn:experience_bodily_harm | /r/UsedFor | fn:cause_harm | "experience bodily harm" | "cause harm" | "/r/used for" |  | "FN" |  |
| fn:cause_harm | /r/SimilarTo | fn:cause_impact | "cause harm" | "cause impact" | "/r/similar to" |  | "FN" |  |
| fn:cause_harm | /r/SimilarTo | fn:corporal_punishment | "cause harm" | "corporal punishment" | "/r/similar to" |  | "FN" |  |
| fn:death | /r/SimilarTo | fn:cause_harm | "death" | "cause harm" | "/r/similar to" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:bayonet | "cause harm" | "bayonet" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:beat | "cause harm" | "beat" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:boil | "cause harm" | "boil" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:burn | "cause harm" | "burn" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:bludgeon | "cause harm" | "bludgeon" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:club | "cause harm" | "club" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:crush | "cause harm" | "crush" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:cut | "cause harm" | "cut" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:slice | "cause harm" | "slice" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:hammer | "cause harm" | "hammer" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:hit | "cause harm" | "hit" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:kick | "cause harm" | "kick" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:knife | "cause harm" | "knife" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:punch | "cause harm" | "punch" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:smash | "cause harm" | "smash" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:stab | "cause harm" | "stab" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:spear | "cause harm" | "spear" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:stone | "cause harm" | "stone" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:hurt | "cause harm" | "hurt" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:whip | "cause harm" | "whip" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:batter | "cause harm" | "batter" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:break | "cause harm" | "break" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:butt | "cause harm" | "butt" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:chop | "cause harm" | "chop" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:claw | "cause harm" | "claw" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:clout | "cause harm" | "clout" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:crack | "cause harm" | "crack" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:cudgel | "cause harm" | "cudgel" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:cuff | "cause harm" | "cuff" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:fracture | "cause harm" | "fracture" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:gash | "cause harm" | "gash" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:injure | "cause harm" | "injure" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:jab | "cause harm" | "jab" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:bruise | "cause harm" | "bruise" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:knock | "cause harm" | "knock" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:lash | "cause harm" | "lash" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:maul | "cause harm" | "maul" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:pelt | "cause harm" | "pelt" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:strike | "cause harm" | "strike" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:thwack | "cause harm" | "thwack" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:bash | "cause harm" | "bash" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:belt | "cause harm" | "belt" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:buffet | "cause harm" | "buffet" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:horsewhip | "cause harm" | "horsewhip" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:smack | "cause harm" | "smack" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:squash | "cause harm" | "squash" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:slap | "cause harm" | "slap" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:knee | "cause harm" | "knee" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:wound | "cause harm" | "wound" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:pummel | "cause harm" | "pummel" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:electrocute | "cause harm" | "electrocute" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:electrocution | "cause harm" | "electrocution" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:poisoning | "cause harm" | "poisoning" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:beat_up | "cause harm" | "beat up" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:torture | "cause harm" | "torture" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:maim | "cause harm" | "maim" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:flog | "cause harm" | "flog" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:impale | "cause harm" | "impale" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:biff | "cause harm" | "biff" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:cane | "cause harm" | "cane" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:flagellate | "cause harm" | "flagellate" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:poison | "cause harm" | "poison" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:transfix | "cause harm" | "transfix" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:welt | "cause harm" | "welt" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:mutilate | "cause harm" | "mutilate" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:elbow | "cause harm" | "elbow" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:sting | "cause harm" | "sting" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:swipe | "cause harm" | "swipe" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:strike | "cause harm" | "strike" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:drug | "cause harm" | "drug" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:twist | "cause harm" | "twist" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | fn:HasLexicalUnit | fn:lu:cause_harm:run_through | "cause harm" | "run through" | "has lexical unit" |  | "FN" |  |
| fn:cause_harm | /r/HasA | fn:fe:agent | "cause harm" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_harm | /r/HasA | fn:fe:victim | "cause harm" | "victim" | "/r/has a" |  | "FN" |  |
| fn:cause_harm | /r/HasA | fn:fe:result | "cause harm" | "result" | "/r/has a" |  | "FN" |  |
| fn:cause_harm | /r/HasA | fn:fe:degree | "cause harm" | "degree" | "/r/has a" |  | "FN" |  |
| fn:cause_harm | /r/HasA | fn:fe:manner | "cause harm" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_harm | /r/HasA | fn:fe:means | "cause harm" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_harm | /r/HasA | fn:fe:place | "cause harm" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_harm | /r/HasA | fn:fe:time | "cause harm" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_harm | /r/HasA | fn:fe:body_part | "cause harm" | "body part" | "/r/has a" |  | "FN" |  |
| fn:cause_harm | /r/HasA | fn:fe:instrument | "cause harm" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:cause_harm | /r/HasA | fn:fe:purpose | "cause harm" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cause_harm | /r/HasA | fn:fe:depictive | "cause harm" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:cause_harm | /r/HasA | fn:fe:containing_event | "cause harm" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:cause_harm | /r/HasA | fn:fe:explanation | "cause harm" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:cause_harm | /r/HasA | fn:fe:iterations | "cause harm" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:cause_harm | /r/HasA | fn:fe:cause | "cause harm" | "cause" | "/r/has a" |  | "FN" |  |
| fn:cause_harm | /r/HasA | fn:fe:subregion_bodypart | "cause harm" | "subregion bodypart" | "/r/has a" |  | "FN" |  |
| fn:cause_harm | /r/HasA | fn:fe:circumstances | "cause harm" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:cause_harm | /r/HasA | fn:fe:frequency | "cause harm" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:cause_harm | /r/HasA | fn:fe:duration | "cause harm" | "duration" | "/r/has a" |  | "FN" |  |
| fn:cause_harm | /r/HasA | fn:fe:particular_iteration | "cause harm" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:cause_harm | /r/HasA | fn:fe:concessive | "cause harm" | "concessive" | "/r/has a" |  | "FN" |  |
| fn:cause_harm | /r/HasA | fn:fe:re-encoding | "cause harm" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:cause_harm | /r/HasA | fn:fe:period_of_iterations | "cause harm" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:cause_impact | /r/IsA | fn:transitive_action | "cause impact" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_impact | /r/UsedFor | fn:hit_target | "cause impact" | "hit target" | "/r/used for" |  | "FN" |  |
| fn:make_noise | /r/RelatedTo | fn:cause_impact | "make noise" | "cause impact" | "/r/related to" |  | "FN" |  |
| fn:cause_harm | /r/SimilarTo | fn:cause_impact | "cause harm" | "cause impact" | "/r/similar to" |  | "FN" |  |
| fn:cause_impact | /r/SimilarTo | fn:make_noise | "cause impact" | "make noise" | "/r/similar to" |  | "FN" |  |
| fn:cause_impact | /r/Causes | fn:impact | "cause impact" | "impact" | "/r/causes" |  | "FN" |  |
| fn:cause_impact | fn:HasLexicalUnit | fn:lu:cause_impact:hit | "cause impact" | "hit" | "has lexical unit" |  | "FN" |  |
| fn:cause_impact | fn:HasLexicalUnit | fn:lu:cause_impact:smack | "cause impact" | "smack" | "has lexical unit" |  | "FN" |  |
| fn:cause_impact | fn:HasLexicalUnit | fn:lu:cause_impact:slam | "cause impact" | "slam" | "has lexical unit" |  | "FN" |  |
| fn:cause_impact | fn:HasLexicalUnit | fn:lu:cause_impact:bang | "cause impact" | "bang" | "has lexical unit" |  | "FN" |  |
| fn:cause_impact | fn:HasLexicalUnit | fn:lu:cause_impact:crash | "cause impact" | "crash" | "has lexical unit" |  | "FN" |  |
| fn:cause_impact | fn:HasLexicalUnit | fn:lu:cause_impact:graze | "cause impact" | "graze" | "has lexical unit" |  | "FN" |  |
| fn:cause_impact | fn:HasLexicalUnit | fn:lu:cause_impact:plow | "cause impact" | "plow" | "has lexical unit" |  | "FN" |  |
| fn:cause_impact | fn:HasLexicalUnit | fn:lu:cause_impact:run | "cause impact" | "run" | "has lexical unit" |  | "FN" |  |
| fn:cause_impact | fn:HasLexicalUnit | fn:lu:cause_impact:slap | "cause impact" | "slap" | "has lexical unit" |  | "FN" |  |
| fn:cause_impact | fn:HasLexicalUnit | fn:lu:cause_impact:strike | "cause impact" | "strike" | "has lexical unit" |  | "FN" |  |
| fn:cause_impact | fn:HasLexicalUnit | fn:lu:cause_impact:thud | "cause impact" | "thud" | "has lexical unit" |  | "FN" |  |
| fn:cause_impact | fn:HasLexicalUnit | fn:lu:cause_impact:ram | "cause impact" | "ram" | "has lexical unit" |  | "FN" |  |
| fn:cause_impact | fn:HasLexicalUnit | fn:lu:cause_impact:clang | "cause impact" | "clang" | "has lexical unit" |  | "FN" |  |
| fn:cause_impact | fn:HasLexicalUnit | fn:lu:cause_impact:clash | "cause impact" | "clash" | "has lexical unit" |  | "FN" |  |
| fn:cause_impact | fn:HasLexicalUnit | fn:lu:cause_impact:clatter | "cause impact" | "clatter" | "has lexical unit" |  | "FN" |  |
| fn:cause_impact | fn:HasLexicalUnit | fn:lu:cause_impact:click | "cause impact" | "click" | "has lexical unit" |  | "FN" |  |
| fn:cause_impact | fn:HasLexicalUnit | fn:lu:cause_impact:clink | "cause impact" | "clink" | "has lexical unit" |  | "FN" |  |
| fn:cause_impact | fn:HasLexicalUnit | fn:lu:cause_impact:rap | "cause impact" | "rap" | "has lexical unit" |  | "FN" |  |
| fn:cause_impact | fn:HasLexicalUnit | fn:lu:cause_impact:rattle | "cause impact" | "rattle" | "has lexical unit" |  | "FN" |  |
| fn:cause_impact | fn:HasLexicalUnit | fn:lu:cause_impact:rustle | "cause impact" | "rustle" | "has lexical unit" |  | "FN" |  |
| fn:cause_impact | fn:HasLexicalUnit | fn:lu:cause_impact:thump | "cause impact" | "thump" | "has lexical unit" |  | "FN" |  |
| fn:cause_impact | fn:HasLexicalUnit | fn:lu:cause_impact:collide | "cause impact" | "collide" | "has lexical unit" |  | "FN" |  |
| fn:cause_impact | fn:HasLexicalUnit | fn:lu:cause_impact:jab | "cause impact" | "jab" | "has lexical unit" |  | "FN" |  |
| fn:cause_impact | /r/HasA | fn:fe:force | "cause impact" | "force" | "/r/has a" |  | "FN" |  |
| fn:cause_impact | /r/HasA | fn:fe:impactee | "cause impact" | "impactee" | "/r/has a" |  | "FN" |  |
| fn:cause_impact | /r/HasA | fn:fe:impactor | "cause impact" | "impactor" | "/r/has a" |  | "FN" |  |
| fn:cause_impact | /r/HasA | fn:fe:impactors | "cause impact" | "impactors" | "/r/has a" |  | "FN" |  |
| fn:cause_impact | /r/HasA | fn:fe:manner | "cause impact" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_impact | /r/HasA | fn:fe:place | "cause impact" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_impact | /r/HasA | fn:fe:result | "cause impact" | "result" | "/r/has a" |  | "FN" |  |
| fn:cause_impact | /r/HasA | fn:fe:speed | "cause impact" | "speed" | "/r/has a" |  | "FN" |  |
| fn:cause_impact | /r/HasA | fn:fe:subregion | "cause impact" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:cause_impact | /r/HasA | fn:fe:time | "cause impact" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_impact | /r/HasA | fn:fe:agent | "cause impact" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_impact | /r/HasA | fn:fe:instrument | "cause impact" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:cause_impact | /r/HasA | fn:fe:means | "cause impact" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_impact | /r/HasA | fn:fe:purpose | "cause impact" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cause_impact | /r/HasA | fn:fe:period_of_iterations | "cause impact" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:cause_impact | /r/HasA | fn:fe:cause | "cause impact" | "cause" | "/r/has a" |  | "FN" |  |
| fn:cause_fluidic_motion | /r/IsA | fn:cause_motion | "cause fluidic motion" | "cause motion" | "/r/is a" |  | "FN" |  |
| fn:passing | /r/IsA | fn:cause_motion | "passing" | "cause motion" | "/r/is a" |  | "FN" |  |
| fn:shoot_projectiles | /r/IsA | fn:cause_motion | "shoot projectiles" | "cause motion" | "/r/is a" |  | "FN" |  |
| fn:cause_motion | /r/IsA | fn:transitive_action | "cause motion" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_motion | /r/HasSubevent | fn:placing | "cause motion" | "placing" | "/r/has subevent" |  | "FN" |  |
| fn:cause_motion | /r/HasSubevent | fn:removing | "cause motion" | "removing" | "/r/has subevent" |  | "FN" |  |
| fn:cause_motion | /r/UsedFor | fn:bringing | "cause motion" | "bringing" | "/r/used for" |  | "FN" |  |
| fn:cause_motion | /r/UsedFor | fn:excreting | "cause motion" | "excreting" | "/r/used for" |  | "FN" |  |
| fn:cause_motion | /r/UsedFor | fn:gathering_up | "cause motion" | "gathering up" | "/r/used for" |  | "FN" |  |
| fn:cause_motion | /r/UsedFor | fn:ingestion | "cause motion" | "ingestion" | "/r/used for" |  | "FN" |  |
| fn:cause_motion | /r/RelatedTo | fn:bringing | "cause motion" | "bringing" | "/r/related to" |  | "FN" |  |
| fn:cause_motion | /r/RelatedTo | fn:emptying | "cause motion" | "emptying" | "/r/related to" |  | "FN" |  |
| fn:cause_motion | /r/RelatedTo | fn:filling | "cause motion" | "filling" | "/r/related to" |  | "FN" |  |
| fn:cause_motion | /r/RelatedTo | fn:placing | "cause motion" | "placing" | "/r/related to" |  | "FN" |  |
| fn:cause_motion | /r/RelatedTo | fn:removing | "cause motion" | "removing" | "/r/related to" |  | "FN" |  |
| fn:manipulation | /r/RelatedTo | fn:cause_motion | "manipulation" | "cause motion" | "/r/related to" |  | "FN" |  |
| fn:cause_motion | /r/SimilarTo | fn:bringing | "cause motion" | "bringing" | "/r/similar to" |  | "FN" |  |
| fn:cause_motion | /r/Causes | fn:motion | "cause motion" | "motion" | "/r/causes" |  | "FN" |  |
| fn:cause_motion | /r/SimilarTo | fn:manipulate_into_doing | "cause motion" | "manipulate into doing" | "/r/similar to" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:cast | "cause motion" | "cast" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:catapult | "cause motion" | "catapult" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:chuck | "cause motion" | "chuck" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:drag | "cause motion" | "drag" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:fling | "cause motion" | "fling" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:hurl | "cause motion" | "hurl" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:nudge | "cause motion" | "nudge" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:pitch | "cause motion" | "pitch" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:press | "cause motion" | "press" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:push | "cause motion" | "push" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:shove | "cause motion" | "shove" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:throw | "cause motion" | "throw" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:thrust | "cause motion" | "thrust" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:toss | "cause motion" | "toss" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:tug | "cause motion" | "tug" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:yank | "cause motion" | "yank" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:scoot | "cause motion" | "scoot" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:draw | "cause motion" | "draw" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:run | "cause motion" | "run" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:slide | "cause motion" | "slide" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:pull | "cause motion" | "pull" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:drive | "cause motion" | "drive" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:move | "cause motion" | "move" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:force | "cause motion" | "force" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:haul | "cause motion" | "haul" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:attract | "cause motion" | "attract" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:knock | "cause motion" | "knock" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:punt | "cause motion" | "punt" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:roll | "cause motion" | "roll" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:jerk | "cause motion" | "jerk" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:propel | "cause motion" | "propel" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:launch | "cause motion" | "launch" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:stick | "cause motion" | "stick" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:transfer | "cause motion" | "transfer" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:hit | "cause motion" | "hit" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:slam | "cause motion" | "slam" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:drop | "cause motion" | "drop" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:rake | "cause motion" | "rake" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:impel | "cause motion" | "impel" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:wrench | "cause motion" | "wrench" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:wrest | "cause motion" | "wrest" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | fn:HasLexicalUnit | fn:lu:cause_motion:lift | "cause motion" | "lift" | "has lexical unit" |  | "FN" |  |
| fn:cause_motion | /r/HasA | fn:fe:agent | "cause motion" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_motion | /r/HasA | fn:fe:theme | "cause motion" | "theme" | "/r/has a" |  | "FN" |  |
| fn:cause_motion | /r/HasA | fn:fe:source | "cause motion" | "source" | "/r/has a" |  | "FN" |  |
| fn:cause_motion | /r/HasA | fn:fe:path | "cause motion" | "path" | "/r/has a" |  | "FN" |  |
| fn:cause_motion | /r/HasA | fn:fe:goal | "cause motion" | "goal" | "/r/has a" |  | "FN" |  |
| fn:cause_motion | /r/HasA | fn:fe:distance | "cause motion" | "distance" | "/r/has a" |  | "FN" |  |
| fn:cause_motion | /r/HasA | fn:fe:area | "cause motion" | "area" | "/r/has a" |  | "FN" |  |
| fn:cause_motion | /r/HasA | fn:fe:depictive | "cause motion" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:cause_motion | /r/HasA | fn:fe:degree | "cause motion" | "degree" | "/r/has a" |  | "FN" |  |
| fn:cause_motion | /r/HasA | fn:fe:means | "cause motion" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_motion | /r/HasA | fn:fe:manner | "cause motion" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_motion | /r/HasA | fn:fe:subregion | "cause motion" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:cause_motion | /r/HasA | fn:fe:cause | "cause motion" | "cause" | "/r/has a" |  | "FN" |  |
| fn:cause_motion | /r/HasA | fn:fe:instrument | "cause motion" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:cause_motion | /r/HasA | fn:fe:place | "cause motion" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_motion | /r/HasA | fn:fe:time | "cause motion" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_motion | /r/HasA | fn:fe:result | "cause motion" | "result" | "/r/has a" |  | "FN" |  |
| fn:cause_motion | /r/HasA | fn:fe:handle | "cause motion" | "handle" | "/r/has a" |  | "FN" |  |
| fn:fe:initial_state | /r/RelatedTo | fn:fe:area | "initial state" | "area" | "/r/related to" |  | "FN" |  |
| fn:cause_motion | /r/HasA | fn:fe:initial_state | "cause motion" | "initial state" | "/r/has a" |  | "FN" |  |
| fn:cause_motion | /r/HasA | fn:fe:explanation | "cause motion" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:cause_motion | /r/HasA | fn:fe:duration | "cause motion" | "duration" | "/r/has a" |  | "FN" |  |
| fn:cause_proliferation_in_number | /r/IsA | fn:cause_change_of_position_on_a_scale | "cause proliferation in number" | "cause change of position on a scale" | "/r/is a" |  | "FN" |  |
| fn:cause_proliferation_in_number | /r/Causes | fn:proliferating_in_number | "cause proliferation in number" | "proliferating in number" | "/r/causes" |  | "FN" |  |
| fn:cause_proliferation_in_number | fn:HasLexicalUnit | fn:lu:cause_proliferation_in_number:proliferation | "cause proliferation in number" | "proliferation" | "has lexical unit" |  | "FN" |  |
| fn:cause_proliferation_in_number | fn:HasLexicalUnit | fn:lu:cause_proliferation_in_number:multiplication | "cause proliferation in number" | "multiplication" | "has lexical unit" |  | "FN" |  |
| fn:cause_proliferation_in_number | /r/HasA | fn:fe:agent | "cause proliferation in number" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_proliferation_in_number | /r/HasA | fn:fe:difference | "cause proliferation in number" | "difference" | "/r/has a" |  | "FN" |  |
| fn:cause_proliferation_in_number | /r/HasA | fn:fe:attribute | "cause proliferation in number" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:cause_proliferation_in_number | /r/HasA | fn:fe:initial_number | "cause proliferation in number" | "initial number" | "/r/has a" |  | "FN" |  |
| fn:cause_proliferation_in_number | /r/HasA | fn:fe:final_number | "cause proliferation in number" | "final number" | "/r/has a" |  | "FN" |  |
| fn:cause_proliferation_in_number | /r/HasA | fn:fe:co-variable | "cause proliferation in number" | "co-variable" | "/r/has a" |  | "FN" |  |
| fn:cause_proliferation_in_number | /r/HasA | fn:fe:path | "cause proliferation in number" | "path" | "/r/has a" |  | "FN" |  |
| fn:cause_proliferation_in_number | /r/HasA | fn:fe:speed | "cause proliferation in number" | "speed" | "/r/has a" |  | "FN" |  |
| fn:cause_proliferation_in_number | /r/HasA | fn:fe:set | "cause proliferation in number" | "set" | "/r/has a" |  | "FN" |  |
| fn:cause_proliferation_in_number | /r/HasA | fn:fe:means | "cause proliferation in number" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_proliferation_in_number | /r/HasA | fn:fe:purpose | "cause proliferation in number" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cause_proliferation_in_number | /r/HasA | fn:fe:time | "cause proliferation in number" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_proliferation_in_number | /r/HasA | fn:fe:cause | "cause proliferation in number" | "cause" | "/r/has a" |  | "FN" |  |
| fn:cause_proliferation_in_number | /r/HasA | fn:fe:manner | "cause proliferation in number" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_proliferation_in_number | /r/HasA | fn:fe:place | "cause proliferation in number" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_proliferation_in_number | /r/HasA | fn:fe:initial_state | "cause proliferation in number" | "initial state" | "/r/has a" |  | "FN" |  |
| fn:cause_proliferation_in_number | /r/HasA | fn:fe:final_state | "cause proliferation in number" | "final state" | "/r/has a" |  | "FN" |  |
| fn:cause_temperature_change | /r/IsA | fn:transitive_action | "cause temperature change" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_temperature_change | /r/SimilarTo | fn:change_of_temperature | "cause temperature change" | "change of temperature" | "/r/similar to" |  | "FN" |  |
| fn:cause_temperature_change | /r/Causes | fn:change_of_temperature | "cause temperature change" | "change of temperature" | "/r/causes" |  | "FN" |  |
| fn:cause_temperature_change | fn:HasLexicalUnit | fn:lu:cause_temperature_change:heat | "cause temperature change" | "heat" | "has lexical unit" |  | "FN" |  |
| fn:cause_temperature_change | fn:HasLexicalUnit | fn:lu:cause_temperature_change:warm | "cause temperature change" | "warm" | "has lexical unit" |  | "FN" |  |
| fn:cause_temperature_change | fn:HasLexicalUnit | fn:lu:cause_temperature_change:cool | "cause temperature change" | "cool" | "has lexical unit" |  | "FN" |  |
| fn:cause_temperature_change | fn:HasLexicalUnit | fn:lu:cause_temperature_change:refrigerate | "cause temperature change" | "refrigerate" | "has lexical unit" |  | "FN" |  |
| fn:cause_temperature_change | fn:HasLexicalUnit | fn:lu:cause_temperature_change:heat_up | "cause temperature change" | "heat up" | "has lexical unit" |  | "FN" |  |
| fn:cause_temperature_change | fn:HasLexicalUnit | fn:lu:cause_temperature_change:cool_down | "cause temperature change" | "cool down" | "has lexical unit" |  | "FN" |  |
| fn:cause_temperature_change | fn:HasLexicalUnit | fn:lu:cause_temperature_change:warm_up | "cause temperature change" | "warm up" | "has lexical unit" |  | "FN" |  |
| fn:cause_temperature_change | fn:HasLexicalUnit | fn:lu:cause_temperature_change:reheat | "cause temperature change" | "reheat" | "has lexical unit" |  | "FN" |  |
| fn:cause_temperature_change | fn:HasLexicalUnit | fn:lu:cause_temperature_change:chill | "cause temperature change" | "chill" | "has lexical unit" |  | "FN" |  |
| fn:cause_temperature_change | fn:HasLexicalUnit | fn:lu:cause_temperature_change:overheat | "cause temperature change" | "overheat" | "has lexical unit" |  | "FN" |  |
| fn:cause_temperature_change | /r/HasA | fn:fe:agent | "cause temperature change" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_temperature_change | /r/HasA | fn:fe:instrument | "cause temperature change" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:cause_temperature_change | /r/HasA | fn:fe:item | "cause temperature change" | "item" | "/r/has a" |  | "FN" |  |
| fn:cause_temperature_change | /r/HasA | fn:fe:temperature_goal | "cause temperature change" | "temperature goal" | "/r/has a" |  | "FN" |  |
| fn:cause_temperature_change | /r/HasA | fn:fe:temperature_change | "cause temperature change" | "temperature change" | "/r/has a" |  | "FN" |  |
| fn:cause_temperature_change | /r/HasA | fn:fe:temperature_start | "cause temperature change" | "temperature start" | "/r/has a" |  | "FN" |  |
| fn:cause_temperature_change | /r/HasA | fn:fe:manner | "cause temperature change" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_temperature_change | /r/HasA | fn:fe:means | "cause temperature change" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_temperature_change | /r/HasA | fn:fe:place | "cause temperature change" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_temperature_change | /r/HasA | fn:fe:purpose | "cause temperature change" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cause_temperature_change | /r/HasA | fn:fe:time | "cause temperature change" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_temperature_change | /r/HasA | fn:fe:result | "cause temperature change" | "result" | "/r/has a" |  | "FN" |  |
| fn:cause_temperature_change | /r/HasA | fn:fe:cause | "cause temperature change" | "cause" | "/r/has a" |  | "FN" |  |
| fn:cause_temperature_change | /r/HasA | fn:fe:duration | "cause temperature change" | "duration" | "/r/has a" |  | "FN" |  |
| fn:cause_temperature_change | /r/HasA | fn:fe:subregion | "cause temperature change" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:cause_temperature_change | /r/HasA | fn:fe:container | "cause temperature change" | "container" | "/r/has a" |  | "FN" |  |
| fn:cause_temperature_change | /r/HasA | fn:fe:depictive | "cause temperature change" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:cause_temperature_change | /r/HasA | fn:fe:hot_cold_source | "cause temperature change" | "hot cold source" | "/r/has a" |  | "FN" |  |
| fn:cause_temperature_change | /r/HasA | fn:fe:circumstances | "cause temperature change" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:cause_temperature_change | /r/HasA | fn:fe:degree | "cause temperature change" | "degree" | "/r/has a" |  | "FN" |  |
| fn:cause_to_amalgamate | /r/IsA | fn:intentionally_affect | "cause to amalgamate" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:cause_to_amalgamate | /r/SimilarTo | fn:amalgamation | "cause to amalgamate" | "amalgamation" | "/r/similar to" |  | "FN" |  |
| fn:cause_to_amalgamate | /r/Causes | fn:amalgamation | "cause to amalgamate" | "amalgamation" | "/r/causes" |  | "FN" |  |
| fn:cause_to_amalgamate | fn:HasLexicalUnit | fn:lu:cause_to_amalgamate:amalgamate | "cause to amalgamate" | "amalgamate" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_amalgamate | fn:HasLexicalUnit | fn:lu:cause_to_amalgamate:combine | "cause to amalgamate" | "combine" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_amalgamate | fn:HasLexicalUnit | fn:lu:cause_to_amalgamate:fuse | "cause to amalgamate" | "fuse" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_amalgamate | fn:HasLexicalUnit | fn:lu:cause_to_amalgamate:join | "cause to amalgamate" | "join" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_amalgamate | fn:HasLexicalUnit | fn:lu:cause_to_amalgamate:merge | "cause to amalgamate" | "merge" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_amalgamate | fn:HasLexicalUnit | fn:lu:cause_to_amalgamate:unify | "cause to amalgamate" | "unify" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_amalgamate | fn:HasLexicalUnit | fn:lu:cause_to_amalgamate:unite | "cause to amalgamate" | "unite" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_amalgamate | fn:HasLexicalUnit | fn:lu:cause_to_amalgamate:meld | "cause to amalgamate" | "meld" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_amalgamate | fn:HasLexicalUnit | fn:lu:cause_to_amalgamate:blend | "cause to amalgamate" | "blend" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_amalgamate | fn:HasLexicalUnit | fn:lu:cause_to_amalgamate:commingle | "cause to amalgamate" | "commingle" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_amalgamate | fn:HasLexicalUnit | fn:lu:cause_to_amalgamate:intermix | "cause to amalgamate" | "intermix" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_amalgamate | fn:HasLexicalUnit | fn:lu:cause_to_amalgamate:mix | "cause to amalgamate" | "mix" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_amalgamate | fn:HasLexicalUnit | fn:lu:cause_to_amalgamate:lump | "cause to amalgamate" | "lump" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_amalgamate | fn:HasLexicalUnit | fn:lu:cause_to_amalgamate:bring_together | "cause to amalgamate" | "bring together" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_amalgamate | fn:HasLexicalUnit | fn:lu:cause_to_amalgamate:coalesce | "cause to amalgamate" | "coalesce" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_amalgamate | fn:HasLexicalUnit | fn:lu:cause_to_amalgamate:compound | "cause to amalgamate" | "compound" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_amalgamate | fn:HasLexicalUnit | fn:lu:cause_to_amalgamate:conflate | "cause to amalgamate" | "conflate" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_amalgamate | fn:HasLexicalUnit | fn:lu:cause_to_amalgamate:consolidate | "cause to amalgamate" | "consolidate" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_amalgamate | fn:HasLexicalUnit | fn:lu:cause_to_amalgamate:flux | "cause to amalgamate" | "flux" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_amalgamate | fn:HasLexicalUnit | fn:lu:cause_to_amalgamate:admix | "cause to amalgamate" | "admix" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_amalgamate | fn:HasLexicalUnit | fn:lu:cause_to_amalgamate:jumble | "cause to amalgamate" | "jumble" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_amalgamate | fn:HasLexicalUnit | fn:lu:cause_to_amalgamate:pair | "cause to amalgamate" | "pair" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_amalgamate | fn:HasLexicalUnit | fn:lu:cause_to_amalgamate:throw_together | "cause to amalgamate" | "throw together" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_amalgamate | fn:HasLexicalUnit | fn:lu:cause_to_amalgamate:fold | "cause to amalgamate" | "fold" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_amalgamate | fn:HasLexicalUnit | fn:lu:cause_to_amalgamate:merger | "cause to amalgamate" | "merger" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_amalgamate | fn:HasLexicalUnit | fn:lu:cause_to_amalgamate:combination | "cause to amalgamate" | "combination" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_amalgamate | /r/HasA | fn:fe:agent | "cause to amalgamate" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_to_amalgamate | /r/HasA | fn:fe:whole | "cause to amalgamate" | "whole" | "/r/has a" |  | "FN" |  |
| fn:cause_to_amalgamate | /r/HasA | fn:fe:parts | "cause to amalgamate" | "parts" | "/r/has a" |  | "FN" |  |
| fn:cause_to_amalgamate | /r/HasA | fn:fe:part_1 | "cause to amalgamate" | "part 1" | "/r/has a" |  | "FN" |  |
| fn:cause_to_amalgamate | /r/HasA | fn:fe:part_2 | "cause to amalgamate" | "part 2" | "/r/has a" |  | "FN" |  |
| fn:cause_to_amalgamate | /r/HasA | fn:fe:manner | "cause to amalgamate" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_to_amalgamate | /r/HasA | fn:fe:degree | "cause to amalgamate" | "degree" | "/r/has a" |  | "FN" |  |
| fn:cause_to_amalgamate | /r/HasA | fn:fe:means | "cause to amalgamate" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_to_amalgamate | /r/HasA | fn:fe:result | "cause to amalgamate" | "result" | "/r/has a" |  | "FN" |  |
| fn:cause_to_amalgamate | /r/HasA | fn:fe:depictive | "cause to amalgamate" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:cause_to_amalgamate | /r/HasA | fn:fe:purpose | "cause to amalgamate" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cause_to_amalgamate | /r/HasA | fn:fe:place | "cause to amalgamate" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_to_amalgamate | /r/HasA | fn:fe:time | "cause to amalgamate" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_dry | /r/IsA | fn:transitive_action | "cause to be dry" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_to_be_dry | /r/Causes | fn:being_dry | "cause to be dry" | "being dry" | "/r/causes" |  | "FN" |  |
| fn:cause_to_be_dry | fn:HasLexicalUnit | fn:lu:cause_to_be_dry:desiccate | "cause to be dry" | "desiccate" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_be_dry | fn:HasLexicalUnit | fn:lu:cause_to_be_dry:dry | "cause to be dry" | "dry" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_be_dry | fn:HasLexicalUnit | fn:lu:cause_to_be_dry:dehumidify | "cause to be dry" | "dehumidify" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_be_dry | fn:HasLexicalUnit | fn:lu:cause_to_be_dry:dry_out | "cause to be dry" | "dry out" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_be_dry | fn:HasLexicalUnit | fn:lu:cause_to_be_dry:dry_off | "cause to be dry" | "dry off" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_be_dry | fn:HasLexicalUnit | fn:lu:cause_to_be_dry:dry_up | "cause to be dry" | "dry up" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_be_dry | fn:HasLexicalUnit | fn:lu:cause_to_be_dry:desiccation | "cause to be dry" | "desiccation" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_be_dry | fn:HasLexicalUnit | fn:lu:cause_to_be_dry:dehumidification | "cause to be dry" | "dehumidification" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_be_dry | fn:HasLexicalUnit | fn:lu:cause_to_be_dry:dehydrate | "cause to be dry" | "dehydrate" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_be_dry | fn:HasLexicalUnit | fn:lu:cause_to_be_dry:anhydrate | "cause to be dry" | "anhydrate" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_be_dry | /r/HasA | fn:fe:agent | "cause to be dry" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_dry | /r/HasA | fn:fe:dryee | "cause to be dry" | "dryee" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_dry | /r/HasA | fn:fe:instrument | "cause to be dry" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_dry | /r/HasA | fn:fe:manner | "cause to be dry" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_dry | /r/HasA | fn:fe:means | "cause to be dry" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_dry | /r/HasA | fn:fe:place | "cause to be dry" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_dry | /r/HasA | fn:fe:purpose | "cause to be dry" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_dry | /r/HasA | fn:fe:time | "cause to be dry" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_dry | /r/HasA | fn:fe:cause | "cause to be dry" | "cause" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_dry | /r/HasA | fn:fe:subregion | "cause to be dry" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_dry | /r/HasA | fn:fe:duration | "cause to be dry" | "duration" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_dry | /r/HasA | fn:fe:temperature | "cause to be dry" | "temperature" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_dry | /r/HasA | fn:fe:degree | "cause to be dry" | "degree" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_included | /r/IsA | fn:transitive_action | "cause to be included" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_to_be_included | /r/Causes | fn:being_included | "cause to be included" | "being included" | "/r/causes" |  | "FN" |  |
| fn:cause_to_be_included | fn:HasLexicalUnit | fn:lu:cause_to_be_included:add | "cause to be included" | "add" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_be_included | fn:HasLexicalUnit | fn:lu:cause_to_be_included:include | "cause to be included" | "include" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_be_included | /r/HasA | fn:fe:agent | "cause to be included" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_included | /r/HasA | fn:fe:existing_member | "cause to be included" | "existing member" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_included | /r/HasA | fn:fe:new_member | "cause to be included" | "new member" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_included | /r/HasA | fn:fe:group | "cause to be included" | "group" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_included | /r/HasA | fn:fe:cause | "cause to be included" | "cause" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_included | /r/HasA | fn:fe:particular_iteration | "cause to be included" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_included | /r/HasA | fn:fe:means | "cause to be included" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_included | /r/HasA | fn:fe:time | "cause to be included" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_included | /r/HasA | fn:fe:manner | "cause to be included" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_included | /r/HasA | fn:fe:purpose | "cause to be included" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_included | /r/HasA | fn:fe:place | "cause to be included" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_sharp | /r/IsA | fn:transitive_action | "cause to be sharp" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_to_be_sharp | fn:HasLexicalUnit | fn:lu:cause_to_be_sharp:sharpen | "cause to be sharp" | "sharpen" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_be_sharp | fn:HasLexicalUnit | fn:lu:cause_to_be_sharp:dull | "cause to be sharp" | "dull" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_be_sharp | fn:HasLexicalUnit | fn:lu:cause_to_be_sharp:blunt | "cause to be sharp" | "blunt" | "has lexical unit" |  | "FN" |  |
| fn:fe:means | /r/RelatedTo | fn:fe:cause | "means" | "cause" | "/r/related to" |  | "FN" |  |
| fn:cause_to_be_sharp | /r/HasA | fn:fe:means | "cause to be sharp" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_sharp | /r/HasA | fn:fe:agent | "cause to be sharp" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_sharp | /r/HasA | fn:fe:instrument | "cause to be sharp" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_sharp | /r/HasA | fn:fe:place | "cause to be sharp" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_sharp | /r/HasA | fn:fe:purpose | "cause to be sharp" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_sharp | /r/HasA | fn:fe:time | "cause to be sharp" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_sharp | /r/HasA | fn:fe:patient | "cause to be sharp" | "patient" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_sharp | /r/HasA | fn:fe:manner | "cause to be sharp" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_sharp | /r/HasA | fn:fe:explanation | "cause to be sharp" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_sharp | /r/HasA | fn:fe:degree | "cause to be sharp" | "degree" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_sharp | /r/HasA | fn:fe:cause | "cause to be sharp" | "cause" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_sharp | /r/HasA | fn:fe:result | "cause to be sharp" | "result" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_wet | /r/IsA | fn:transitive_action | "cause to be wet" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_to_be_wet | /r/Causes | fn:being_wet | "cause to be wet" | "being wet" | "/r/causes" |  | "FN" |  |
| fn:cause_to_be_wet | fn:HasLexicalUnit | fn:lu:cause_to_be_wet:drench | "cause to be wet" | "drench" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_be_wet | fn:HasLexicalUnit | fn:lu:cause_to_be_wet:soak | "cause to be wet" | "soak" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_be_wet | fn:HasLexicalUnit | fn:lu:cause_to_be_wet:wet | "cause to be wet" | "wet" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_be_wet | fn:HasLexicalUnit | fn:lu:cause_to_be_wet:saturate | "cause to be wet" | "saturate" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_be_wet | fn:HasLexicalUnit | fn:lu:cause_to_be_wet:douse | "cause to be wet" | "douse" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_be_wet | fn:HasLexicalUnit | fn:lu:cause_to_be_wet:souse | "cause to be wet" | "souse" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_be_wet | fn:HasLexicalUnit | fn:lu:cause_to_be_wet:moisten | "cause to be wet" | "moisten" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_be_wet | fn:HasLexicalUnit | fn:lu:cause_to_be_wet:dampen | "cause to be wet" | "dampen" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_be_wet | fn:HasLexicalUnit | fn:lu:cause_to_be_wet:humidify | "cause to be wet" | "humidify" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_be_wet | fn:HasLexicalUnit | fn:lu:cause_to_be_wet:hydrate | "cause to be wet" | "hydrate" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_be_wet | fn:HasLexicalUnit | fn:lu:cause_to_be_wet:moisturize | "cause to be wet" | "moisturize" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_be_wet | fn:HasLexicalUnit | fn:lu:cause_to_be_wet:sop | "cause to be wet" | "sop" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_be_wet | /r/HasA | fn:fe:agent | "cause to be wet" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_wet | /r/HasA | fn:fe:liquid | "cause to be wet" | "liquid" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_wet | /r/HasA | fn:fe:patient | "cause to be wet" | "patient" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_wet | /r/HasA | fn:fe:manner | "cause to be wet" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_wet | /r/HasA | fn:fe:means | "cause to be wet" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_wet | /r/HasA | fn:fe:place | "cause to be wet" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_wet | /r/HasA | fn:fe:purpose | "cause to be wet" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_wet | /r/HasA | fn:fe:time | "cause to be wet" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_wet | /r/HasA | fn:fe:instrument | "cause to be wet" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_wet | /r/HasA | fn:fe:cause | "cause to be wet" | "cause" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_wet | /r/HasA | fn:fe:degree | "cause to be wet" | "degree" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_wet | /r/HasA | fn:fe:subregion | "cause to be wet" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:cause_to_be_wet | /r/HasA | fn:fe:explanation | "cause to be wet" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:setting_fire | /r/UsedFor | fn:cause_to_burn | "setting fire" | "cause to burn" | "/r/used for" |  | "FN" |  |
| fn:cause_to_burn | /r/HasA | fn:fe:agent | "cause to burn" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_to_burn | /r/HasA | fn:fe:flammables | "cause to burn" | "flammables" | "/r/has a" |  | "FN" |  |
| fn:cause_to_burn | /r/HasA | fn:fe:cause | "cause to burn" | "cause" | "/r/has a" |  | "FN" |  |
| fn:cause_to_burn | /r/HasA | fn:fe:time | "cause to burn" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_to_burn | /r/HasA | fn:fe:place | "cause to burn" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_to_burn | /r/HasA | fn:fe:manner | "cause to burn" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_to_burn | /r/HasA | fn:fe:means | "cause to burn" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_to_burn | /r/HasA | fn:fe:explanation | "cause to burn" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:cause_to_burn | /r/HasA | fn:fe:containing_event | "cause to burn" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:cause_to_burn | /r/HasA | fn:fe:depictive | "cause to burn" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:cause_to_burn | /r/HasA | fn:fe:actor | "cause to burn" | "actor" | "/r/has a" |  | "FN" |  |
| fn:cause_to_continue | /r/IsA | fn:transitive_action | "cause to continue" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_to_continue | /r/Causes | fn:process_continue | "cause to continue" | "process continue" | "/r/causes" |  | "FN" |  |
| fn:cause_to_continue | /r/Causes | fn:state_continue | "cause to continue" | "state continue" | "/r/causes" |  | "FN" |  |
| fn:cause_to_continue | fn:HasLexicalUnit | fn:lu:cause_to_continue:keep | "cause to continue" | "keep" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_continue | /r/HasA | fn:fe:agent | "cause to continue" | "agent" | "/r/has a" |  | "FN" |  |
| fn:fe:process | /r/RelatedTo | fn:fe:state | "process" | "state" | "/r/related to" |  | "FN" |  |
| fn:cause_to_continue | /r/HasA | fn:fe:process | "cause to continue" | "process" | "/r/has a" |  | "FN" |  |
| fn:cause_to_continue | /r/HasA | fn:fe:state | "cause to continue" | "state" | "/r/has a" |  | "FN" |  |
| fn:cause_to_continue | /r/HasA | fn:fe:duration | "cause to continue" | "duration" | "/r/has a" |  | "FN" |  |
| fn:cause_to_continue | /r/HasA | fn:fe:means | "cause to continue" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_to_continue | /r/HasA | fn:fe:cause | "cause to continue" | "cause" | "/r/has a" |  | "FN" |  |
| fn:cause_to_continue | /r/HasA | fn:fe:purpose | "cause to continue" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cause_to_continue | /r/HasA | fn:fe:instrument | "cause to continue" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:cause_to_continue | /r/HasA | fn:fe:time | "cause to continue" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_to_continue | /r/HasA | fn:fe:manner | "cause to continue" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_to_continue | /r/HasA | fn:fe:place | "cause to continue" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_to_end | /r/IsA | fn:transitive_action | "cause to end" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_to_end | /r/Causes | fn:process_end | "cause to end" | "process end" | "/r/causes" |  | "FN" |  |
| fn:cause_to_end | fn:HasLexicalUnit | fn:lu:cause_to_end:lift | "cause to end" | "lift" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_end | fn:HasLexicalUnit | fn:lu:cause_to_end:end | "cause to end" | "end" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_end | fn:HasLexicalUnit | fn:lu:cause_to_end:lifting | "cause to end" | "lifting" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_end | fn:HasLexicalUnit | fn:lu:cause_to_end:arrest | "cause to end" | "arrest" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_end | fn:HasLexicalUnit | fn:lu:cause_to_end:put_an_end_to | "cause to end" | "put an end to" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_end | fn:HasLexicalUnit | fn:lu:cause_to_end:abort | "cause to end" | "abort" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_end | fn:HasLexicalUnit | fn:lu:cause_to_end:do_away_with | "cause to end" | "do away with" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_end | /r/HasA | fn:fe:process | "cause to end" | "process" | "/r/has a" |  | "FN" |  |
| fn:cause_to_end | /r/HasA | fn:fe:means | "cause to end" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_to_end | /r/HasA | fn:fe:place | "cause to end" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_to_end | /r/HasA | fn:fe:explanation | "cause to end" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:cause_to_end | /r/HasA | fn:fe:time | "cause to end" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_to_end | /r/HasA | fn:fe:degree | "cause to end" | "degree" | "/r/has a" |  | "FN" |  |
| fn:cause_to_end | /r/HasA | fn:fe:depictive | "cause to end" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:cause_to_end | /r/HasA | fn:fe:manner | "cause to end" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_to_end | /r/HasA | fn:fe:agent | "cause to end" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_to_end | /r/HasA | fn:fe:cause | "cause to end" | "cause" | "/r/has a" |  | "FN" |  |
| fn:cause_to_end | /r/HasA | fn:fe:state | "cause to end" | "state" | "/r/has a" |  | "FN" |  |
| fn:cause_to_experience | /r/IsA | fn:intentionally_affect | "cause to experience" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:cause_to_experience | fn:HasLexicalUnit | fn:lu:cause_to_experience:terrorize | "cause to experience" | "terrorize" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_experience | fn:HasLexicalUnit | fn:lu:cause_to_experience:torment | "cause to experience" | "torment" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_experience | fn:HasLexicalUnit | fn:lu:cause_to_experience:entertain | "cause to experience" | "entertain" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_experience | fn:HasLexicalUnit | fn:lu:cause_to_experience:amuse | "cause to experience" | "amuse" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_experience | fn:HasLexicalUnit | fn:lu:cause_to_experience:divert | "cause to experience" | "divert" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_experience | /r/HasA | fn:fe:means | "cause to experience" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_to_experience | /r/HasA | fn:fe:agent | "cause to experience" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_to_experience | /r/HasA | fn:fe:experiencer | "cause to experience" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:cause_to_experience | /r/HasA | fn:fe:manner | "cause to experience" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_to_experience | /r/HasA | fn:fe:resulting_action | "cause to experience" | "resulting action" | "/r/has a" |  | "FN" |  |
| fn:cause_to_experience | /r/HasA | fn:fe:time | "cause to experience" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_to_experience | /r/HasA | fn:fe:place | "cause to experience" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_to_experience | /r/HasA | fn:fe:instrument | "cause to experience" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:cause_to_experience | /r/HasA | fn:fe:purpose | "cause to experience" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cause_to_experience | /r/HasA | fn:fe:degree | "cause to experience" | "degree" | "/r/has a" |  | "FN" |  |
| fn:cause_to_fragment | /r/IsA | fn:transitive_action | "cause to fragment" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:destroying | /r/UsedFor | fn:cause_to_fragment | "destroying" | "cause to fragment" | "/r/used for" |  | "FN" |  |
| fn:cause_to_fragment | /r/Causes | fn:breaking_apart | "cause to fragment" | "breaking apart" | "/r/causes" |  | "FN" |  |
| fn:cause_to_fragment | fn:HasLexicalUnit | fn:lu:cause_to_fragment:fracture | "cause to fragment" | "fracture" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_fragment | fn:HasLexicalUnit | fn:lu:cause_to_fragment:rend | "cause to fragment" | "rend" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_fragment | fn:HasLexicalUnit | fn:lu:cause_to_fragment:snap | "cause to fragment" | "snap" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_fragment | fn:HasLexicalUnit | fn:lu:cause_to_fragment:break | "cause to fragment" | "break" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_fragment | fn:HasLexicalUnit | fn:lu:cause_to_fragment:shiver | "cause to fragment" | "shiver" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_fragment | fn:HasLexicalUnit | fn:lu:cause_to_fragment:splinter | "cause to fragment" | "splinter" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_fragment | fn:HasLexicalUnit | fn:lu:cause_to_fragment:fragment | "cause to fragment" | "fragment" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_fragment | fn:HasLexicalUnit | fn:lu:cause_to_fragment:shatter | "cause to fragment" | "shatter" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_fragment | fn:HasLexicalUnit | fn:lu:cause_to_fragment:smash | "cause to fragment" | "smash" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_fragment | fn:HasLexicalUnit | fn:lu:cause_to_fragment:shred | "cause to fragment" | "shred" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_fragment | fn:HasLexicalUnit | fn:lu:cause_to_fragment:rip | "cause to fragment" | "rip" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_fragment | fn:HasLexicalUnit | fn:lu:cause_to_fragment:tear | "cause to fragment" | "tear" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_fragment | fn:HasLexicalUnit | fn:lu:cause_to_fragment:rip_up | "cause to fragment" | "rip up" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_fragment | fn:HasLexicalUnit | fn:lu:cause_to_fragment:cleave | "cause to fragment" | "cleave" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_fragment | fn:HasLexicalUnit | fn:lu:cause_to_fragment:tear_up | "cause to fragment" | "tear up" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_fragment | fn:HasLexicalUnit | fn:lu:cause_to_fragment:break_apart | "cause to fragment" | "break apart" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_fragment | fn:HasLexicalUnit | fn:lu:cause_to_fragment:break_up | "cause to fragment" | "break up" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_fragment | fn:HasLexicalUnit | fn:lu:cause_to_fragment:break_down | "cause to fragment" | "break down" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_fragment | fn:HasLexicalUnit | fn:lu:cause_to_fragment:chip | "cause to fragment" | "chip" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_fragment | fn:HasLexicalUnit | fn:lu:cause_to_fragment:dissect | "cause to fragment" | "dissect" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_fragment | fn:HasLexicalUnit | fn:lu:cause_to_fragment:dissolve | "cause to fragment" | "dissolve" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_fragment | fn:HasLexicalUnit | fn:lu:cause_to_fragment:rive | "cause to fragment" | "rive" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_fragment | fn:HasLexicalUnit | fn:lu:cause_to_fragment:sliver | "cause to fragment" | "sliver" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_fragment | fn:HasLexicalUnit | fn:lu:cause_to_fragment:split | "cause to fragment" | "split" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_fragment | fn:HasLexicalUnit | fn:lu:cause_to_fragment:take_apart | "cause to fragment" | "take apart" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_fragment | /r/HasA | fn:fe:agent | "cause to fragment" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_to_fragment | /r/HasA | fn:fe:instrument | "cause to fragment" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:cause_to_fragment | /r/HasA | fn:fe:manner | "cause to fragment" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_to_fragment | /r/HasA | fn:fe:means | "cause to fragment" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_to_fragment | /r/HasA | fn:fe:whole_patient | "cause to fragment" | "whole patient" | "/r/has a" |  | "FN" |  |
| fn:cause_to_fragment | /r/HasA | fn:fe:place | "cause to fragment" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_to_fragment | /r/HasA | fn:fe:purpose | "cause to fragment" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cause_to_fragment | /r/HasA | fn:fe:explanation | "cause to fragment" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:cause_to_fragment | /r/HasA | fn:fe:time | "cause to fragment" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_to_fragment | /r/HasA | fn:fe:pieces | "cause to fragment" | "pieces" | "/r/has a" |  | "FN" |  |
| fn:cause_to_fragment | /r/HasA | fn:fe:degree | "cause to fragment" | "degree" | "/r/has a" |  | "FN" |  |
| fn:cause_to_fragment | /r/HasA | fn:fe:subregion | "cause to fragment" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:cause_to_fragment | /r/HasA | fn:fe:result | "cause to fragment" | "result" | "/r/has a" |  | "FN" |  |
| fn:cause_to_fragment | /r/HasA | fn:fe:resistant_surface | "cause to fragment" | "resistant surface" | "/r/has a" |  | "FN" |  |
| fn:cause_to_fragment | /r/HasA | fn:fe:cause | "cause to fragment" | "cause" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle_scenario | /r/HasSubevent | fn:cause_to_land | "operate vehicle scenario" | "cause to land" | "/r/has subevent" |  | "FN" |  |
| fn:vehicle_landing | /r/UsedFor | fn:cause_to_land | "vehicle landing" | "cause to land" | "/r/used for" |  | "FN" |  |
| fn:cause_to_land | fn:HasLexicalUnit | fn:lu:cause_to_land:land | "cause to land" | "land" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_land | fn:HasLexicalUnit | fn:lu:cause_to_land:set_down | "cause to land" | "set down" | "has lexical unit" |  | "FN" |  |
| fn:fe:vehicle | /r/IsA | fn:st:physical_object | "vehicle" | "physical object" | "/r/is a" |  | "FN" |  |
| fn:cause_to_land | /r/HasA | fn:fe:vehicle | "cause to land" | "vehicle" | "/r/has a" |  | "FN" |  |
| fn:cause_to_land | /r/HasA | fn:fe:source | "cause to land" | "source" | "/r/has a" |  | "FN" |  |
| fn:cause_to_land | /r/HasA | fn:fe:path | "cause to land" | "path" | "/r/has a" |  | "FN" |  |
| fn:cause_to_land | /r/HasA | fn:fe:goal | "cause to land" | "goal" | "/r/has a" |  | "FN" |  |
| fn:cause_to_land | /r/HasA | fn:fe:manner | "cause to land" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_to_land | /r/HasA | fn:fe:means | "cause to land" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_to_land | /r/HasA | fn:fe:cotheme | "cause to land" | "cotheme" | "/r/has a" |  | "FN" |  |
| fn:cause_to_land | /r/HasA | fn:fe:time | "cause to land" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_to_land | /r/HasA | fn:fe:new_situation | "cause to land" | "new situation" | "/r/has a" |  | "FN" |  |
| fn:cause_to_land | /r/HasA | fn:fe:depictive | "cause to land" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:cause_to_land | /r/HasA | fn:fe:period_of_iterations | "cause to land" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:cause_to_land | /r/HasA | fn:fe:circumstances | "cause to land" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:cause_to_land | /r/HasA | fn:fe:purpose | "cause to land" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cause_to_land | /r/HasA | fn:fe:degree | "cause to land" | "degree" | "/r/has a" |  | "FN" |  |
| fn:cause_to_land | /r/HasA | fn:fe:event_description | "cause to land" | "event description" | "/r/has a" |  | "FN" |  |
| fn:cause_to_land | /r/HasA | fn:fe:re-encoding | "cause to land" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:cause_to_land | /r/HasA | fn:fe:frequency | "cause to land" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:cause_to_land | /r/HasA | fn:fe:place | "cause to land" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_to_land | /r/HasA | fn:fe:operator | "cause to land" | "operator" | "/r/has a" |  | "FN" |  |
| fn:cause_to_make_noise | /r/IsA | fn:transitive_action | "cause to make noise" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:make_noise | /r/RelatedTo | fn:cause_to_make_noise | "make noise" | "cause to make noise" | "/r/related to" |  | "FN" |  |
| fn:make_noise | /r/SimilarTo | fn:cause_to_make_noise | "make noise" | "cause to make noise" | "/r/similar to" |  | "FN" |  |
| fn:cause_to_make_noise | /r/Causes | fn:make_noise | "cause to make noise" | "make noise" | "/r/causes" |  | "FN" |  |
| fn:cause_to_make_noise | fn:HasLexicalUnit | fn:lu:cause_to_make_noise:blare | "cause to make noise" | "blare" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_make_noise | fn:HasLexicalUnit | fn:lu:cause_to_make_noise:blast | "cause to make noise" | "blast" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_make_noise | fn:HasLexicalUnit | fn:lu:cause_to_make_noise:clang | "cause to make noise" | "clang" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_make_noise | fn:HasLexicalUnit | fn:lu:cause_to_make_noise:creak | "cause to make noise" | "creak" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_make_noise | fn:HasLexicalUnit | fn:lu:cause_to_make_noise:peep | "cause to make noise" | "peep" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_make_noise | fn:HasLexicalUnit | fn:lu:cause_to_make_noise:tinkle | "cause to make noise" | "tinkle" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_make_noise | fn:HasLexicalUnit | fn:lu:cause_to_make_noise:play | "cause to make noise" | "play" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_make_noise | fn:HasLexicalUnit | fn:lu:cause_to_make_noise:ringer | "cause to make noise" | "ringer" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_make_noise | fn:HasLexicalUnit | fn:lu:cause_to_make_noise:ring | "cause to make noise" | "ring" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_make_noise | fn:HasLexicalUnit | fn:lu:cause_to_make_noise:honk | "cause to make noise" | "honk" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_make_noise | fn:HasLexicalUnit | fn:lu:cause_to_make_noise:toot | "cause to make noise" | "toot" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_make_noise | fn:HasLexicalUnit | fn:lu:cause_to_make_noise:beep | "cause to make noise" | "beep" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_make_noise | fn:HasLexicalUnit | fn:lu:cause_to_make_noise:clash | "cause to make noise" | "clash" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_make_noise | fn:HasLexicalUnit | fn:lu:cause_to_make_noise:sound | "cause to make noise" | "sound" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_make_noise | fn:HasLexicalUnit | fn:lu:cause_to_make_noise:toll | "cause to make noise" | "toll" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_make_noise | fn:HasLexicalUnit | fn:lu:cause_to_make_noise:trumpet | "cause to make noise" | "trumpet" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_make_noise | /r/HasA | fn:fe:agent | "cause to make noise" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_to_make_noise | /r/HasA | fn:fe:sound_maker | "cause to make noise" | "sound maker" | "/r/has a" |  | "FN" |  |
| fn:cause_to_make_noise | /r/HasA | fn:fe:subregion | "cause to make noise" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:cause_to_make_noise | /r/HasA | fn:fe:location_of_protagonist | "cause to make noise" | "location of protagonist" | "/r/has a" |  | "FN" |  |
| fn:cause_to_make_noise | /r/HasA | fn:fe:depictive | "cause to make noise" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:cause_to_make_noise | /r/HasA | fn:fe:manner | "cause to make noise" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_to_make_noise | /r/HasA | fn:fe:means | "cause to make noise" | "means" | "/r/has a" |  | "FN" |  |
| fn:fe:cause | /r/RelatedTo | fn:fe:means | "cause" | "means" | "/r/related to" |  | "FN" |  |
| fn:cause_to_make_noise | /r/HasA | fn:fe:cause | "cause to make noise" | "cause" | "/r/has a" |  | "FN" |  |
| fn:cause_to_make_noise | /r/HasA | fn:fe:explanation | "cause to make noise" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:cause_to_make_noise | /r/HasA | fn:fe:purpose | "cause to make noise" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cause_to_make_noise | /r/HasA | fn:fe:time | "cause to make noise" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_to_make_noise | /r/HasA | fn:fe:place | "cause to make noise" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_to_make_noise | /r/HasA | fn:fe:frequency | "cause to make noise" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:cause_to_make_noise | /r/HasA | fn:fe:iterations | "cause to make noise" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:cause_to_make_progress | /r/IsA | fn:intentionally_affect | "cause to make progress" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:cause_to_make_progress | /r/Causes | fn:progression | "cause to make progress" | "progression" | "/r/causes" |  | "FN" |  |
| fn:cause_to_make_progress | fn:HasLexicalUnit | fn:lu:cause_to_make_progress:develop | "cause to make progress" | "develop" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_make_progress | fn:HasLexicalUnit | fn:lu:cause_to_make_progress:gains | "cause to make progress" | "gains" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_make_progress | fn:HasLexicalUnit | fn:lu:cause_to_make_progress:perfect | "cause to make progress" | "perfect" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_make_progress | fn:HasLexicalUnit | fn:lu:cause_to_make_progress:improve | "cause to make progress" | "improve" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_make_progress | fn:HasLexicalUnit | fn:lu:cause_to_make_progress:improved | "cause to make progress" | "improved" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_make_progress | fn:HasLexicalUnit | fn:lu:cause_to_make_progress:modernization | "cause to make progress" | "modernization" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_make_progress | fn:HasLexicalUnit | fn:lu:cause_to_make_progress:mature | "cause to make progress" | "mature" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_make_progress | fn:HasLexicalUnit | fn:lu:cause_to_make_progress:advance | "cause to make progress" | "advance" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_make_progress | /r/HasA | fn:fe:project | "cause to make progress" | "project" | "/r/has a" |  | "FN" |  |
| fn:cause_to_make_progress | /r/HasA | fn:fe:prior_state | "cause to make progress" | "prior state" | "/r/has a" |  | "FN" |  |
| fn:cause_to_make_progress | /r/HasA | fn:fe:post_state | "cause to make progress" | "post state" | "/r/has a" |  | "FN" |  |
| fn:cause_to_make_progress | /r/HasA | fn:fe:time | "cause to make progress" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_to_make_progress | /r/HasA | fn:fe:rate | "cause to make progress" | "rate" | "/r/has a" |  | "FN" |  |
| fn:cause_to_make_progress | /r/HasA | fn:fe:manner | "cause to make progress" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_to_make_progress | /r/HasA | fn:fe:duration | "cause to make progress" | "duration" | "/r/has a" |  | "FN" |  |
| fn:cause_to_make_progress | /r/HasA | fn:fe:degree | "cause to make progress" | "degree" | "/r/has a" |  | "FN" |  |
| fn:cause_to_make_progress | /r/HasA | fn:fe:domain | "cause to make progress" | "domain" | "/r/has a" |  | "FN" |  |
| fn:cause_to_make_progress | /r/HasA | fn:fe:agent | "cause to make progress" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_to_make_progress | /r/HasA | fn:fe:place | "cause to make progress" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_to_make_progress | /r/HasA | fn:fe:explanation | "cause to make progress" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:cause_to_make_progress | /r/HasA | fn:fe:particular_iteration | "cause to make progress" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:cause_to_make_progress | /r/HasA | fn:fe:purpose | "cause to make progress" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cause_to_make_progress | /r/HasA | fn:fe:means | "cause to make progress" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_to_move_in_place | /r/IsA | fn:transitive_action | "cause to move in place" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:activity_ongoing | /r/UsedFor | fn:cause_to_move_in_place | "activity ongoing" | "cause to move in place" | "/r/used for" |  | "FN" |  |
| fn:manipulation | /r/UsedFor | fn:cause_to_move_in_place | "manipulation" | "cause to move in place" | "/r/used for" |  | "FN" |  |
| fn:cause_to_move_in_place | /r/SimilarTo | fn:moving_in_place | "cause to move in place" | "moving in place" | "/r/similar to" |  | "FN" |  |
| fn:cause_to_move_in_place | /r/Causes | fn:moving_in_place | "cause to move in place" | "moving in place" | "/r/causes" |  | "FN" |  |
| fn:cause_to_move_in_place | fn:HasLexicalUnit | fn:lu:cause_to_move_in_place:twirl | "cause to move in place" | "twirl" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_move_in_place | fn:HasLexicalUnit | fn:lu:cause_to_move_in_place:spin | "cause to move in place" | "spin" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_move_in_place | fn:HasLexicalUnit | fn:lu:cause_to_move_in_place:vibrate | "cause to move in place" | "vibrate" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_move_in_place | fn:HasLexicalUnit | fn:lu:cause_to_move_in_place:shake | "cause to move in place" | "shake" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_move_in_place | fn:HasLexicalUnit | fn:lu:cause_to_move_in_place:swing | "cause to move in place" | "swing" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_move_in_place | fn:HasLexicalUnit | fn:lu:cause_to_move_in_place:seesaw | "cause to move in place" | "seesaw" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_move_in_place | fn:HasLexicalUnit | fn:lu:cause_to_move_in_place:turn | "cause to move in place" | "turn" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_move_in_place | fn:HasLexicalUnit | fn:lu:cause_to_move_in_place:rotate | "cause to move in place" | "rotate" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_move_in_place | fn:HasLexicalUnit | fn:lu:cause_to_move_in_place:squeeze | "cause to move in place" | "squeeze" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_move_in_place | fn:HasLexicalUnit | fn:lu:cause_to_move_in_place:swirl | "cause to move in place" | "swirl" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_move_in_place | fn:HasLexicalUnit | fn:lu:cause_to_move_in_place:rock | "cause to move in place" | "rock" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_move_in_place | fn:HasLexicalUnit | fn:lu:cause_to_move_in_place:roll | "cause to move in place" | "roll" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_move_in_place | fn:HasLexicalUnit | fn:lu:cause_to_move_in_place:wave | "cause to move in place" | "wave" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_move_in_place | fn:HasLexicalUnit | fn:lu:cause_to_move_in_place:juggle | "cause to move in place" | "juggle" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_move_in_place | fn:HasLexicalUnit | fn:lu:cause_to_move_in_place:jiggle | "cause to move in place" | "jiggle" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_move_in_place | fn:HasLexicalUnit | fn:lu:cause_to_move_in_place:wiggle | "cause to move in place" | "wiggle" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_move_in_place | /r/HasA | fn:fe:theme | "cause to move in place" | "theme" | "/r/has a" |  | "FN" |  |
| fn:cause_to_move_in_place | /r/HasA | fn:fe:place | "cause to move in place" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_to_move_in_place | /r/HasA | fn:fe:duration | "cause to move in place" | "duration" | "/r/has a" |  | "FN" |  |
| fn:cause_to_move_in_place | /r/HasA | fn:fe:explanation | "cause to move in place" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:cause_to_move_in_place | /r/HasA | fn:fe:time | "cause to move in place" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_to_move_in_place | /r/HasA | fn:fe:manner | "cause to move in place" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_to_move_in_place | /r/HasA | fn:fe:means | "cause to move in place" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_to_move_in_place | /r/HasA | fn:fe:degree | "cause to move in place" | "degree" | "/r/has a" |  | "FN" |  |
| fn:cause_to_move_in_place | /r/HasA | fn:fe:periodicity | "cause to move in place" | "periodicity" | "/r/has a" |  | "FN" |  |
| fn:cause_to_move_in_place | /r/HasA | fn:fe:fixed_location | "cause to move in place" | "fixed location" | "/r/has a" |  | "FN" |  |
| fn:cause_to_move_in_place | /r/HasA | fn:fe:agent | "cause to move in place" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_to_move_in_place | /r/HasA | fn:fe:instrument | "cause to move in place" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:cause_to_move_in_place | /r/HasA | fn:fe:purpose | "cause to move in place" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cause_to_move_in_place | /r/HasA | fn:fe:angle | "cause to move in place" | "angle" | "/r/has a" |  | "FN" |  |
| fn:cause_to_move_in_place | /r/HasA | fn:fe:locus | "cause to move in place" | "locus" | "/r/has a" |  | "FN" |  |
| fn:fe:bodypart_of_agent | /r/RelatedTo | fn:fe:cause | "bodypart of agent" | "cause" | "/r/related to" |  | "FN" |  |
| fn:cause_to_move_in_place | /r/HasA | fn:fe:bodypart_of_agent | "cause to move in place" | "bodypart of agent" | "/r/has a" |  | "FN" |  |
| fn:cause_to_move_in_place | /r/HasA | fn:fe:cause | "cause to move in place" | "cause" | "/r/has a" |  | "FN" |  |
| fn:cause_to_move_in_place | /r/HasA | fn:fe:direction | "cause to move in place" | "direction" | "/r/has a" |  | "FN" |  |
| fn:cause_to_move_in_place | /r/HasA | fn:fe:result | "cause to move in place" | "result" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/IsA | fn:cause_to_perceive | "communication" | "cause to perceive" | "/r/is a" |  | "FN" |  |
| fn:cause_to_perceive | /r/IsA | fn:intentionally_affect | "cause to perceive" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:cause_to_perceive | /r/UsedFor | fn:information_display | "cause to perceive" | "information display" | "/r/used for" |  | "FN" |  |
| fn:cause_to_perceive | /r/Causes | fn:perception_experience | "cause to perceive" | "perception experience" | "/r/causes" |  | "FN" |  |
| fn:cause_to_perceive | fn:HasLexicalUnit | fn:lu:cause_to_perceive:show | "cause to perceive" | "show" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_perceive | fn:HasLexicalUnit | fn:lu:cause_to_perceive:demonstrate | "cause to perceive" | "demonstrate" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_perceive | fn:HasLexicalUnit | fn:lu:cause_to_perceive:present | "cause to perceive" | "present" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_perceive | fn:HasLexicalUnit | fn:lu:cause_to_perceive:point | "cause to perceive" | "point" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_perceive | fn:HasLexicalUnit | fn:lu:cause_to_perceive:depict | "cause to perceive" | "depict" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_perceive | fn:HasLexicalUnit | fn:lu:cause_to_perceive:represent | "cause to perceive" | "represent" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_perceive | fn:HasLexicalUnit | fn:lu:cause_to_perceive:exhibit | "cause to perceive" | "exhibit" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_perceive | fn:HasLexicalUnit | fn:lu:cause_to_perceive:present[medical] | "cause to perceive" | "present[medical]" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_perceive | fn:HasLexicalUnit | fn:lu:cause_to_perceive:bring_to_attention | "cause to perceive" | "bring to attention" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_perceive | /r/HasA | fn:fe:agent | "cause to perceive" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_to_perceive | /r/HasA | fn:fe:phenomenon | "cause to perceive" | "phenomenon" | "/r/has a" |  | "FN" |  |
| fn:cause_to_perceive | /r/HasA | fn:fe:perceiver | "cause to perceive" | "perceiver" | "/r/has a" |  | "FN" |  |
| fn:cause_to_perceive | /r/HasA | fn:fe:means | "cause to perceive" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_to_perceive | /r/HasA | fn:fe:manner | "cause to perceive" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_to_perceive | /r/HasA | fn:fe:time | "cause to perceive" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_to_perceive | /r/HasA | fn:fe:frequency | "cause to perceive" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:cause_to_perceive | /r/HasA | fn:fe:place | "cause to perceive" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_to_perceive | /r/HasA | fn:fe:purpose | "cause to perceive" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:fe:actor | /r/RelatedTo | fn:fe:perceiver | "actor" | "perceiver" | "/r/related to" |  | "FN" |  |
| fn:cause_to_perceive | /r/HasA | fn:fe:actor | "cause to perceive" | "actor" | "/r/has a" |  | "FN" |  |
| fn:fe:entity | /r/RelatedTo | fn:fe:perceiver | "entity" | "perceiver" | "/r/related to" |  | "FN" |  |
| fn:cause_to_perceive | /r/HasA | fn:fe:entity | "cause to perceive" | "entity" | "/r/has a" |  | "FN" |  |
| fn:fe:medium | /r/RelatedTo | fn:fe:perceiver | "medium" | "perceiver" | "/r/related to" |  | "FN" |  |
| fn:cause_to_perceive | /r/HasA | fn:fe:medium | "cause to perceive" | "medium" | "/r/has a" |  | "FN" |  |
| fn:cause_to_perceive | /r/HasA | fn:fe:co-participant | "cause to perceive" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:cause_to_perceive | /r/HasA | fn:fe:explanation | "cause to perceive" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:cause_to_resume | /r/IsA | fn:transitive_action | "cause to resume" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_to_resume | /r/Causes | fn:process_resume | "cause to resume" | "process resume" | "/r/causes" |  | "FN" |  |
| fn:cause_to_resume | fn:HasLexicalUnit | fn:lu:cause_to_resume:revive | "cause to resume" | "revive" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_resume | fn:HasLexicalUnit | fn:lu:cause_to_resume:restart | "cause to resume" | "restart" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_resume | fn:HasLexicalUnit | fn:lu:cause_to_resume:reinstate | "cause to resume" | "reinstate" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_resume | fn:HasLexicalUnit | fn:lu:cause_to_resume:resume | "cause to resume" | "resume" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_resume | /r/HasA | fn:fe:agent | "cause to resume" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_to_resume | /r/HasA | fn:fe:process | "cause to resume" | "process" | "/r/has a" |  | "FN" |  |
| fn:cause_to_resume | /r/HasA | fn:fe:hiatus | "cause to resume" | "hiatus" | "/r/has a" |  | "FN" |  |
| fn:cause_to_resume | /r/HasA | fn:fe:time | "cause to resume" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_to_resume | /r/HasA | fn:fe:cause | "cause to resume" | "cause" | "/r/has a" |  | "FN" |  |
| fn:cause_to_resume | /r/HasA | fn:fe:place | "cause to resume" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_to_resume | /r/HasA | fn:fe:means | "cause to resume" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_to_resume | /r/HasA | fn:fe:manner | "cause to resume" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_to_resume | /r/HasA | fn:fe:duration_of_final_state | "cause to resume" | "duration of final state" | "/r/has a" |  | "FN" |  |
| fn:cause_to_rot | /r/IsA | fn:transitive_action | "cause to rot" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_to_rot | /r/Causes | fn:rotting | "cause to rot" | "rotting" | "/r/causes" |  | "FN" |  |
| fn:cause_to_rot | fn:HasLexicalUnit | fn:lu:cause_to_rot:rot | "cause to rot" | "rot" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_rot | fn:HasLexicalUnit | fn:lu:cause_to_rot:putrefy | "cause to rot" | "putrefy" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_rot | /r/HasA | fn:fe:agent | "cause to rot" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_to_rot | /r/HasA | fn:fe:patient | "cause to rot" | "patient" | "/r/has a" |  | "FN" |  |
| fn:cause_to_rot | /r/HasA | fn:fe:depictive | "cause to rot" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:cause_to_rot | /r/HasA | fn:fe:result | "cause to rot" | "result" | "/r/has a" |  | "FN" |  |
| fn:cause_to_rot | /r/HasA | fn:fe:means | "cause to rot" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_to_rot | /r/HasA | fn:fe:manner | "cause to rot" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_to_rot | /r/HasA | fn:fe:time | "cause to rot" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_to_rot | /r/HasA | fn:fe:place | "cause to rot" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_to_rot | /r/HasA | fn:fe:cause | "cause to rot" | "cause" | "/r/has a" |  | "FN" |  |
| fn:cause_to_rot | /r/HasA | fn:fe:instrument | "cause to rot" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:cause_to_start | /r/IsA | fn:causation | "cause to start" | "causation" | "/r/is a" |  | "FN" |  |
| fn:cause_to_start | /r/UsedFor | fn:launch_process | "cause to start" | "launch process" | "/r/used for" |  | "FN" |  |
| fn:activity_start | /r/SimilarTo | fn:cause_to_start | "activity start" | "cause to start" | "/r/similar to" |  | "FN" |  |
| fn:cause_to_start | /r/Causes | fn:process_start | "cause to start" | "process start" | "/r/causes" |  | "FN" |  |
| fn:cause_to_start | fn:HasLexicalUnit | fn:lu:cause_to_start:spark | "cause to start" | "spark" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_start | fn:HasLexicalUnit | fn:lu:cause_to_start:generate | "cause to start" | "generate" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_start | fn:HasLexicalUnit | fn:lu:cause_to_start:arouse | "cause to start" | "arouse" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_start | fn:HasLexicalUnit | fn:lu:cause_to_start:bring_about | "cause to start" | "bring about" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_start | fn:HasLexicalUnit | fn:lu:cause_to_start:set_off | "cause to start" | "set off" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_start | fn:HasLexicalUnit | fn:lu:cause_to_start:produce | "cause to start" | "produce" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_start | fn:HasLexicalUnit | fn:lu:cause_to_start:create | "cause to start" | "create" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_start | fn:HasLexicalUnit | fn:lu:cause_to_start:engender | "cause to start" | "engender" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_start | fn:HasLexicalUnit | fn:lu:cause_to_start:call_forth | "cause to start" | "call forth" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_start | fn:HasLexicalUnit | fn:lu:cause_to_start:elicit | "cause to start" | "elicit" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_start | fn:HasLexicalUnit | fn:lu:cause_to_start:kindle | "cause to start" | "kindle" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_start | fn:HasLexicalUnit | fn:lu:cause_to_start:incite | "cause to start" | "incite" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_start | fn:HasLexicalUnit | fn:lu:cause_to_start:instigate | "cause to start" | "instigate" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_start | fn:HasLexicalUnit | fn:lu:cause_to_start:motivate | "cause to start" | "motivate" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_start | fn:HasLexicalUnit | fn:lu:cause_to_start:prompt | "cause to start" | "prompt" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_start | fn:HasLexicalUnit | fn:lu:cause_to_start:stir_up | "cause to start" | "stir up" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_start | fn:HasLexicalUnit | fn:lu:cause_to_start:stimulate | "cause to start" | "stimulate" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_start | fn:HasLexicalUnit | fn:lu:cause_to_start:provoke | "cause to start" | "provoke" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_start | fn:HasLexicalUnit | fn:lu:cause_to_start:actuate | "cause to start" | "actuate" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_start | fn:HasLexicalUnit | fn:lu:cause_to_start:excite | "cause to start" | "excite" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_start | fn:HasLexicalUnit | fn:lu:cause_to_start:trigger | "cause to start" | "trigger" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_start | /r/HasA | fn:fe:cause | "cause to start" | "cause" | "/r/has a" |  | "FN" |  |
| fn:cause_to_start | /r/HasA | fn:fe:effect | "cause to start" | "effect" | "/r/has a" |  | "FN" |  |
| fn:cause_to_start | /r/HasA | fn:fe:place | "cause to start" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_to_start | /r/HasA | fn:fe:means | "cause to start" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_to_start | /r/HasA | fn:fe:time | "cause to start" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_to_start | /r/HasA | fn:fe:medium | "cause to start" | "medium" | "/r/has a" |  | "FN" |  |
| fn:cause_to_start | /r/HasA | fn:fe:purpose | "cause to start" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cause_to_start | /r/HasA | fn:fe:co-timed_event | "cause to start" | "co-timed event" | "/r/has a" |  | "FN" |  |
| fn:cause_to_start | /r/HasA | fn:fe:manner | "cause to start" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_to_start | /r/HasA | fn:fe:communicative_force | "cause to start" | "communicative force" | "/r/has a" |  | "FN" |  |
| fn:cause_to_start | /r/HasA | fn:fe:explanation | "cause to start" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:cause_to_start | /r/HasA | fn:fe:circumstances | "cause to start" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:cause_to_start | /r/HasA | fn:fe:particular_iteration | "cause to start" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:cause_to_start | /r/HasA | fn:fe:new_situation | "cause to start" | "new situation" | "/r/has a" |  | "FN" |  |
| fn:cause_to_start | /r/HasA | fn:fe:containing_event | "cause to start" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:cause_to_start | /r/HasA | fn:fe:concessive | "cause to start" | "concessive" | "/r/has a" |  | "FN" |  |
| fn:cause_to_start | /r/HasA | fn:fe:depictive | "cause to start" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:cause_to_start | /r/HasA | fn:fe:event_description | "cause to start" | "event description" | "/r/has a" |  | "FN" |  |
| fn:cause_to_wake | /r/IsA | fn:transitive_action | "cause to wake" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_to_wake | /r/Causes | fn:being_awake | "cause to wake" | "being awake" | "/r/causes" |  | "FN" |  |
| fn:cause_to_wake | fn:HasLexicalUnit | fn:lu:cause_to_wake:wake_up | "cause to wake" | "wake up" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_wake | fn:HasLexicalUnit | fn:lu:cause_to_wake:wake | "cause to wake" | "wake" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_wake | fn:HasLexicalUnit | fn:lu:cause_to_wake:awaken | "cause to wake" | "awaken" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_wake | fn:HasLexicalUnit | fn:lu:cause_to_wake:rouse | "cause to wake" | "rouse" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_wake | fn:HasLexicalUnit | fn:lu:cause_to_wake:get_up | "cause to wake" | "get up" | "has lexical unit" |  | "FN" |  |
| fn:cause_to_wake | /r/HasA | fn:fe:place | "cause to wake" | "place" | "/r/has a" |  | "FN" |  |
| fn:cause_to_wake | /r/HasA | fn:fe:sleeper | "cause to wake" | "sleeper" | "/r/has a" |  | "FN" |  |
| fn:cause_to_wake | /r/HasA | fn:fe:time | "cause to wake" | "time" | "/r/has a" |  | "FN" |  |
| fn:cause_to_wake | /r/HasA | fn:fe:agent | "cause to wake" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cause_to_wake | /r/HasA | fn:fe:instrument | "cause to wake" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:cause_to_wake | /r/HasA | fn:fe:means | "cause to wake" | "means" | "/r/has a" |  | "FN" |  |
| fn:cause_to_wake | /r/HasA | fn:fe:purpose | "cause to wake" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cause_to_wake | /r/HasA | fn:fe:explanation | "cause to wake" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:cause_to_wake | /r/HasA | fn:fe:cause | "cause to wake" | "cause" | "/r/has a" |  | "FN" |  |
| fn:cause_to_wake | /r/HasA | fn:fe:sleep_state | "cause to wake" | "sleep state" | "/r/has a" |  | "FN" |  |
| fn:cause_to_wake | /r/HasA | fn:fe:manner | "cause to wake" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cause_to_wake | /r/HasA | fn:fe:degree | "cause to wake" | "degree" | "/r/has a" |  | "FN" |  |
| fn:death | /r/IsA | fn:ceasing_to_be | "death" | "ceasing to be" | "/r/is a" |  | "FN" |  |
| fn:ceasing_to_be | /r/IsA | fn:transition_to_state | "ceasing to be" | "transition to state" | "/r/is a" |  | "FN" |  |
| fn:cycle_of_existence_scenario | /r/HasSubevent | fn:ceasing_to_be | "cycle of existence scenario" | "ceasing to be" | "/r/has subevent" |  | "FN" |  |
| fn:out_of_existence | /r/HasPrerequisite | fn:ceasing_to_be | "out of existence" | "ceasing to be" | "/r/has prerequisite" |  | "FN" |  |
| fn:ceasing_to_be | /r/HasPrerequisite | fn:existence | "ceasing to be" | "existence" | "/r/has prerequisite" |  | "FN" |  |
| fn:ceasing_to_be | fn:HasLexicalUnit | fn:lu:ceasing_to_be:fade | "ceasing to be" | "fade" | "has lexical unit" |  | "FN" |  |
| fn:ceasing_to_be | fn:HasLexicalUnit | fn:lu:ceasing_to_be:disappear | "ceasing to be" | "disappear" | "has lexical unit" |  | "FN" |  |
| fn:ceasing_to_be | fn:HasLexicalUnit | fn:lu:ceasing_to_be:dissipate | "ceasing to be" | "dissipate" | "has lexical unit" |  | "FN" |  |
| fn:ceasing_to_be | fn:HasLexicalUnit | fn:lu:ceasing_to_be:go_away | "ceasing to be" | "go away" | "has lexical unit" |  | "FN" |  |
| fn:ceasing_to_be | fn:HasLexicalUnit | fn:lu:ceasing_to_be:disappearance | "ceasing to be" | "disappearance" | "has lexical unit" |  | "FN" |  |
| fn:ceasing_to_be | fn:HasLexicalUnit | fn:lu:ceasing_to_be:dissipation | "ceasing to be" | "dissipation" | "has lexical unit" |  | "FN" |  |
| fn:ceasing_to_be | fn:HasLexicalUnit | fn:lu:ceasing_to_be:vanish | "ceasing to be" | "vanish" | "has lexical unit" |  | "FN" |  |
| fn:ceasing_to_be | fn:HasLexicalUnit | fn:lu:ceasing_to_be:dissolve | "ceasing to be" | "dissolve" | "has lexical unit" |  | "FN" |  |
| fn:ceasing_to_be | /r/HasA | fn:fe:entity | "ceasing to be" | "entity" | "/r/has a" |  | "FN" |  |
| fn:ceasing_to_be | /r/HasA | fn:fe:place | "ceasing to be" | "place" | "/r/has a" |  | "FN" |  |
| fn:ceasing_to_be | /r/HasA | fn:fe:time | "ceasing to be" | "time" | "/r/has a" |  | "FN" |  |
| fn:ceasing_to_be | /r/HasA | fn:fe:explanation | "ceasing to be" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:ceasing_to_be | /r/HasA | fn:fe:components | "ceasing to be" | "components" | "/r/has a" |  | "FN" |  |
| fn:ceasing_to_be | /r/HasA | fn:fe:duration_of_final_state | "ceasing to be" | "duration of final state" | "/r/has a" |  | "FN" |  |
| fn:ceasing_to_be | /r/HasA | fn:fe:role | "ceasing to be" | "role" | "/r/has a" |  | "FN" |  |
| fn:ceasing_to_be | /r/HasA | fn:fe:period_of_iterations | "ceasing to be" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:ceasing_to_be | /r/HasA | fn:fe:manner | "ceasing to be" | "manner" | "/r/has a" |  | "FN" |  |
| fn:ceasing_to_be | /r/HasA | fn:fe:degree | "ceasing to be" | "degree" | "/r/has a" |  | "FN" |  |
| fn:trust | /r/IsA | fn:certainty | "trust" | "certainty" | "/r/is a" |  | "FN" |  |
| fn:certainty | /r/IsA | fn:gradable_attributes | "certainty" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:awareness | /r/UsedFor | fn:certainty | "awareness" | "certainty" | "/r/used for" |  | "FN" |  |
| fn:certainty | /r/UsedFor | fn:reliance_on_expectation | "certainty" | "reliance on expectation" | "/r/used for" |  | "FN" |  |
| fn:awareness | /r/RelatedTo | fn:certainty | "awareness" | "certainty" | "/r/related to" |  | "FN" |  |
| fn:certainty | /r/SimilarTo | fn:likelihood | "certainty" | "likelihood" | "/r/similar to" |  | "FN" |  |
| fn:certainty | fn:HasLexicalUnit | fn:lu:certainty:certain | "certainty" | "certain" | "has lexical unit" |  | "FN" |  |
| fn:certainty | fn:HasLexicalUnit | fn:lu:certainty:uncertain | "certainty" | "uncertain" | "has lexical unit" |  | "FN" |  |
| fn:certainty | fn:HasLexicalUnit | fn:lu:certainty:confident | "certainty" | "confident" | "has lexical unit" |  | "FN" |  |
| fn:certainty | fn:HasLexicalUnit | fn:lu:certainty:sure | "certainty" | "sure" | "has lexical unit" |  | "FN" |  |
| fn:certainty | fn:HasLexicalUnit | fn:lu:certainty:confidence | "certainty" | "confidence" | "has lexical unit" |  | "FN" |  |
| fn:certainty | fn:HasLexicalUnit | fn:lu:certainty:convinced | "certainty" | "convinced" | "has lexical unit" |  | "FN" |  |
| fn:certainty | fn:HasLexicalUnit | fn:lu:certainty:positive | "certainty" | "positive" | "has lexical unit" |  | "FN" |  |
| fn:certainty | fn:HasLexicalUnit | fn:lu:certainty:dubious | "certainty" | "dubious" | "has lexical unit" |  | "FN" |  |
| fn:certainty | fn:HasLexicalUnit | fn:lu:certainty:certainty | "certainty" | "certainty" | "has lexical unit" |  | "FN" |  |
| fn:certainty | fn:HasLexicalUnit | fn:lu:certainty:doubt | "certainty" | "doubt" | "has lexical unit" |  | "FN" |  |
| fn:certainty | fn:HasLexicalUnit | fn:lu:certainty:doubtful | "certainty" | "doubtful" | "has lexical unit" |  | "FN" |  |
| fn:certainty | fn:HasLexicalUnit | fn:lu:certainty:believe | "certainty" | "believe" | "has lexical unit" |  | "FN" |  |
| fn:certainty | fn:HasLexicalUnit | fn:lu:certainty:uncertainty | "certainty" | "uncertainty" | "has lexical unit" |  | "FN" |  |
| fn:certainty | fn:HasLexicalUnit | fn:lu:certainty:unsure | "certainty" | "unsure" | "has lexical unit" |  | "FN" |  |
| fn:certainty | fn:HasLexicalUnit | fn:lu:certainty:doubt | "certainty" | "doubt" | "has lexical unit" |  | "FN" |  |
| fn:certainty | fn:HasLexicalUnit | fn:lu:certainty:trust | "certainty" | "trust" | "has lexical unit" |  | "FN" |  |
| fn:certainty | fn:HasLexicalUnit | fn:lu:certainty:skeptical | "certainty" | "skeptical" | "has lexical unit" |  | "FN" |  |
| fn:certainty | fn:HasLexicalUnit | fn:lu:certainty:skepticism | "certainty" | "skepticism" | "has lexical unit" |  | "FN" |  |
| fn:certainty | fn:HasLexicalUnit | fn:lu:certainty:skeptic | "certainty" | "skeptic" | "has lexical unit" |  | "FN" |  |
| fn:certainty | fn:HasLexicalUnit | fn:lu:certainty:know | "certainty" | "know" | "has lexical unit" |  | "FN" |  |
| fn:certainty | /r/HasA | fn:fe:cognizer | "certainty" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:certainty | /r/HasA | fn:fe:topic | "certainty" | "topic" | "/r/has a" |  | "FN" |  |
| fn:certainty | /r/HasA | fn:fe:content | "certainty" | "content" | "/r/has a" |  | "FN" |  |
| fn:certainty | /r/HasA | fn:fe:degree | "certainty" | "degree" | "/r/has a" |  | "FN" |  |
| fn:certainty | /r/HasA | fn:fe:manner | "certainty" | "manner" | "/r/has a" |  | "FN" |  |
| fn:certainty | /r/HasA | fn:fe:expressor | "certainty" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:certainty | /r/HasA | fn:fe:concessive | "certainty" | "concessive" | "/r/has a" |  | "FN" |  |
| fn:certainty | /r/HasA | fn:fe:explanation | "certainty" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:change_accessibility | /r/IsA | fn:intentionally_affect | "change accessibility" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:change_accessibility | /r/Causes | fn:openness | "change accessibility" | "openness" | "/r/causes" |  | "FN" |  |
| fn:change_accessibility | fn:HasLexicalUnit | fn:lu:change_accessibility:barricade | "change accessibility" | "barricade" | "has lexical unit" |  | "FN" |  |
| fn:change_accessibility | fn:HasLexicalUnit | fn:lu:change_accessibility:blockade | "change accessibility" | "blockade" | "has lexical unit" |  | "FN" |  |
| fn:change_accessibility | fn:HasLexicalUnit | fn:lu:change_accessibility:cordon_off | "change accessibility" | "cordon off" | "has lexical unit" |  | "FN" |  |
| fn:change_accessibility | fn:HasLexicalUnit | fn:lu:change_accessibility:road-block | "change accessibility" | "road-block" | "has lexical unit" |  | "FN" |  |
| fn:change_accessibility | fn:HasLexicalUnit | fn:lu:change_accessibility:block_off | "change accessibility" | "block off" | "has lexical unit" |  | "FN" |  |
| fn:change_accessibility | fn:HasLexicalUnit | fn:lu:change_accessibility:blockade | "change accessibility" | "blockade" | "has lexical unit" |  | "FN" |  |
| fn:change_accessibility | /r/HasA | fn:fe:agent | "change accessibility" | "agent" | "/r/has a" |  | "FN" |  |
| fn:change_accessibility | /r/HasA | fn:fe:useful_location | "change accessibility" | "useful location" | "/r/has a" |  | "FN" |  |
| fn:change_accessibility | /r/HasA | fn:fe:theme | "change accessibility" | "theme" | "/r/has a" |  | "FN" |  |
| fn:change_accessibility | /r/HasA | fn:fe:degree | "change accessibility" | "degree" | "/r/has a" |  | "FN" |  |
| fn:change_accessibility | /r/HasA | fn:fe:portal | "change accessibility" | "portal" | "/r/has a" |  | "FN" |  |
| fn:change_accessibility | /r/HasA | fn:fe:manner | "change accessibility" | "manner" | "/r/has a" |  | "FN" |  |
| fn:change_accessibility | /r/HasA | fn:fe:means | "change accessibility" | "means" | "/r/has a" |  | "FN" |  |
| fn:change_accessibility | /r/HasA | fn:fe:time | "change accessibility" | "time" | "/r/has a" |  | "FN" |  |
| fn:change_accessibility | /r/HasA | fn:fe:place | "change accessibility" | "place" | "/r/has a" |  | "FN" |  |
| fn:change_accessibility | /r/HasA | fn:fe:purpose | "change accessibility" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:change_accessibility | /r/HasA | fn:fe:subregion | "change accessibility" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:change_accessibility | /r/HasA | fn:fe:instrument | "change accessibility" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:direction | /r/UsedFor | fn:change_direction | "direction" | "change direction" | "/r/used for" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:change_direction | "motion" | "change direction" | "/r/used for" |  | "FN" |  |
| fn:traversing | /r/SimilarTo | fn:change_direction | "traversing" | "change direction" | "/r/similar to" |  | "FN" |  |
| fn:change_direction | fn:HasLexicalUnit | fn:lu:change_direction:cut | "change direction" | "cut" | "has lexical unit" |  | "FN" |  |
| fn:change_direction | fn:HasLexicalUnit | fn:lu:change_direction:turn | "change direction" | "turn" | "has lexical unit" |  | "FN" |  |
| fn:change_direction | fn:HasLexicalUnit | fn:lu:change_direction:bear | "change direction" | "bear" | "has lexical unit" |  | "FN" |  |
| fn:change_direction | fn:HasLexicalUnit | fn:lu:change_direction:left | "change direction" | "left" | "has lexical unit" |  | "FN" |  |
| fn:change_direction | fn:HasLexicalUnit | fn:lu:change_direction:right | "change direction" | "right" | "has lexical unit" |  | "FN" |  |
| fn:change_direction | fn:HasLexicalUnit | fn:lu:change_direction:turn | "change direction" | "turn" | "has lexical unit" |  | "FN" |  |
| fn:change_direction | fn:HasLexicalUnit | fn:lu:change_direction:swing | "change direction" | "swing" | "has lexical unit" |  | "FN" |  |
| fn:change_direction | fn:HasLexicalUnit | fn:lu:change_direction:veer | "change direction" | "veer" | "has lexical unit" |  | "FN" |  |
| fn:change_direction | /r/HasA | fn:fe:theme | "change direction" | "theme" | "/r/has a" |  | "FN" |  |
| fn:change_direction | /r/HasA | fn:fe:source | "change direction" | "source" | "/r/has a" |  | "FN" |  |
| fn:change_direction | /r/HasA | fn:fe:path | "change direction" | "path" | "/r/has a" |  | "FN" |  |
| fn:change_direction | /r/HasA | fn:fe:goal | "change direction" | "goal" | "/r/has a" |  | "FN" |  |
| fn:change_direction | /r/HasA | fn:fe:manner | "change direction" | "manner" | "/r/has a" |  | "FN" |  |
| fn:change_direction | /r/HasA | fn:fe:means | "change direction" | "means" | "/r/has a" |  | "FN" |  |
| fn:change_direction | /r/HasA | fn:fe:speed | "change direction" | "speed" | "/r/has a" |  | "FN" |  |
| fn:change_direction | /r/HasA | fn:fe:cotheme | "change direction" | "cotheme" | "/r/has a" |  | "FN" |  |
| fn:change_direction | /r/HasA | fn:fe:depictive | "change direction" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:change_direction | /r/HasA | fn:fe:place | "change direction" | "place" | "/r/has a" |  | "FN" |  |
| fn:change_direction | /r/HasA | fn:fe:path_shape | "change direction" | "path shape" | "/r/has a" |  | "FN" |  |
| fn:change_direction | /r/HasA | fn:fe:direction | "change direction" | "direction" | "/r/has a" |  | "FN" |  |
| fn:change_direction | /r/HasA | fn:fe:time | "change direction" | "time" | "/r/has a" |  | "FN" |  |
| fn:change_direction | /r/HasA | fn:fe:purpose | "change direction" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:change_direction | /r/HasA | fn:fe:means_of_motion | "change direction" | "means of motion" | "/r/has a" |  | "FN" |  |
| fn:change_direction | /r/HasA | fn:fe:explanation | "change direction" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:change_direction | /r/HasA | fn:fe:containing_event | "change direction" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:change_direction | /r/HasA | fn:fe:frequency | "change direction" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:change_direction | /r/HasA | fn:fe:re-encoding | "change direction" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:change_direction | /r/HasA | fn:fe:new_situation | "change direction" | "new situation" | "/r/has a" |  | "FN" |  |
| fn:change_direction | /r/HasA | fn:fe:circumstances | "change direction" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:change_direction | /r/HasA | fn:fe:angle | "change direction" | "angle" | "/r/has a" |  | "FN" |  |
| fn:change_direction | /r/HasA | fn:fe:result | "change direction" | "result" | "/r/has a" |  | "FN" |  |
| fn:change_event_duration | /r/IsA | fn:cause_change | "change event duration" | "cause change" | "/r/is a" |  | "FN" |  |
| fn:change_event_duration | fn:HasLexicalUnit | fn:lu:change_event_duration:prolong | "change event duration" | "prolong" | "has lexical unit" |  | "FN" |  |
| fn:change_event_duration | fn:HasLexicalUnit | fn:lu:change_event_duration:abbreviate | "change event duration" | "abbreviate" | "has lexical unit" |  | "FN" |  |
| fn:change_event_duration | fn:HasLexicalUnit | fn:lu:change_event_duration:drag_out | "change event duration" | "drag out" | "has lexical unit" |  | "FN" |  |
| fn:change_event_duration | fn:HasLexicalUnit | fn:lu:change_event_duration:protract | "change event duration" | "protract" | "has lexical unit" |  | "FN" |  |
| fn:change_event_duration | fn:HasLexicalUnit | fn:lu:change_event_duration:extend | "change event duration" | "extend" | "has lexical unit" |  | "FN" |  |
| fn:change_event_duration | fn:HasLexicalUnit | fn:lu:change_event_duration:cut_short | "change event duration" | "cut short" | "has lexical unit" |  | "FN" |  |
| fn:change_event_duration | fn:HasLexicalUnit | fn:lu:change_event_duration:shorten | "change event duration" | "shorten" | "has lexical unit" |  | "FN" |  |
| fn:change_event_duration | fn:HasLexicalUnit | fn:lu:change_event_duration:slow | "change event duration" | "slow" | "has lexical unit" |  | "FN" |  |
| fn:change_event_duration | /r/HasA | fn:fe:agent | "change event duration" | "agent" | "/r/has a" |  | "FN" |  |
| fn:fe:new_duration | /r/IsA | fn:st:duration | "new duration" | "duration" | "/r/is a" |  | "FN" |  |
| fn:change_event_duration | /r/HasA | fn:fe:new_duration | "change event duration" | "new duration" | "/r/has a" |  | "FN" |  |
| fn:fe:initial_duration | /r/IsA | fn:st:duration | "initial duration" | "duration" | "/r/is a" |  | "FN" |  |
| fn:change_event_duration | /r/HasA | fn:fe:initial_duration | "change event duration" | "initial duration" | "/r/has a" |  | "FN" |  |
| fn:change_event_duration | /r/HasA | fn:fe:time | "change event duration" | "time" | "/r/has a" |  | "FN" |  |
| fn:change_event_duration | /r/HasA | fn:fe:degree | "change event duration" | "degree" | "/r/has a" |  | "FN" |  |
| fn:change_event_duration | /r/HasA | fn:fe:manner | "change event duration" | "manner" | "/r/has a" |  | "FN" |  |
| fn:change_event_duration | /r/HasA | fn:fe:explanation | "change event duration" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:change_event_duration | /r/HasA | fn:fe:event | "change event duration" | "event" | "/r/has a" |  | "FN" |  |
| fn:change_event_duration | /r/HasA | fn:fe:cause | "change event duration" | "cause" | "/r/has a" |  | "FN" |  |
| fn:change_event_duration | /r/HasA | fn:fe:purpose | "change event duration" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:change_event_duration | /r/HasA | fn:fe:means | "change event duration" | "means" | "/r/has a" |  | "FN" |  |
| fn:change_event_time | /r/IsA | fn:cause_change | "change event time" | "cause change" | "/r/is a" |  | "FN" |  |
| fn:calendric_unit | /r/UsedFor | fn:change_event_time | "calendric unit" | "change event time" | "/r/used for" |  | "FN" |  |
| fn:change_event_time | /r/UsedFor | fn:holding_off_on | "change event time" | "holding off on" | "/r/used for" |  | "FN" |  |
| fn:change_event_time | /r/UsedFor | fn:waiting | "change event time" | "waiting" | "/r/used for" |  | "FN" |  |
| fn:scheduling | /r/UsedFor | fn:change_event_time | "scheduling" | "change event time" | "/r/used for" |  | "FN" |  |
| fn:change_event_time | /r/SimilarTo | fn:scheduling | "change event time" | "scheduling" | "/r/similar to" |  | "FN" |  |
| fn:relative_time | /r/SimilarTo | fn:change_event_time | "relative time" | "change event time" | "/r/similar to" |  | "FN" |  |
| fn:change_event_time | fn:HasLexicalUnit | fn:lu:change_event_time:delay | "change event time" | "delay" | "has lexical unit" |  | "FN" |  |
| fn:change_event_time | fn:HasLexicalUnit | fn:lu:change_event_time:postpone | "change event time" | "postpone" | "has lexical unit" |  | "FN" |  |
| fn:change_event_time | fn:HasLexicalUnit | fn:lu:change_event_time:defer | "change event time" | "defer" | "has lexical unit" |  | "FN" |  |
| fn:change_event_time | fn:HasLexicalUnit | fn:lu:change_event_time:advance | "change event time" | "advance" | "has lexical unit" |  | "FN" |  |
| fn:change_event_time | fn:HasLexicalUnit | fn:lu:change_event_time:move_up | "change event time" | "move up" | "has lexical unit" |  | "FN" |  |
| fn:change_event_time | fn:HasLexicalUnit | fn:lu:change_event_time:move_back | "change event time" | "move back" | "has lexical unit" |  | "FN" |  |
| fn:change_event_time | fn:HasLexicalUnit | fn:lu:change_event_time:put_off | "change event time" | "put off" | "has lexical unit" |  | "FN" |  |
| fn:change_event_time | fn:HasLexicalUnit | fn:lu:change_event_time:hold_over | "change event time" | "hold over" | "has lexical unit" |  | "FN" |  |
| fn:change_event_time | fn:HasLexicalUnit | fn:lu:change_event_time:put_over | "change event time" | "put over" | "has lexical unit" |  | "FN" |  |
| fn:change_event_time | fn:HasLexicalUnit | fn:lu:change_event_time:delay | "change event time" | "delay" | "has lexical unit" |  | "FN" |  |
| fn:change_event_time | fn:HasLexicalUnit | fn:lu:change_event_time:hold_up | "change event time" | "hold up" | "has lexical unit" |  | "FN" |  |
| fn:change_event_time | fn:HasLexicalUnit | fn:lu:change_event_time:reschedule | "change event time" | "reschedule" | "has lexical unit" |  | "FN" |  |
| fn:change_event_time | fn:HasLexicalUnit | fn:lu:change_event_time:delay_[duration] | "change event time" | "delay [duration]" | "has lexical unit" |  | "FN" |  |
| fn:change_event_time | /r/HasA | fn:fe:agent | "change event time" | "agent" | "/r/has a" |  | "FN" |  |
| fn:change_event_time | /r/HasA | fn:fe:cause | "change event time" | "cause" | "/r/has a" |  | "FN" |  |
| fn:change_event_time | /r/HasA | fn:fe:event | "change event time" | "event" | "/r/has a" |  | "FN" |  |
| fn:change_event_time | /r/HasA | fn:fe:manner | "change event time" | "manner" | "/r/has a" |  | "FN" |  |
| fn:change_event_time | /r/HasA | fn:fe:means | "change event time" | "means" | "/r/has a" |  | "FN" |  |
| fn:change_event_time | /r/HasA | fn:fe:degree | "change event time" | "degree" | "/r/has a" |  | "FN" |  |
| fn:change_event_time | /r/HasA | fn:fe:destination_event | "change event time" | "destination event" | "/r/has a" |  | "FN" |  |
| fn:fe:destination_time | /r/IsA | fn:st:time | "destination time" | "time" | "/r/is a" |  | "FN" |  |
| fn:change_event_time | /r/HasA | fn:fe:destination_time | "change event time" | "destination time" | "/r/has a" |  | "FN" |  |
| fn:fe:interval | /r/IsA | fn:st:duration | "interval" | "duration" | "/r/is a" |  | "FN" |  |
| fn:change_event_time | /r/HasA | fn:fe:interval | "change event time" | "interval" | "/r/has a" |  | "FN" |  |
| fn:fe:landmark_time | /r/IsA | fn:st:time | "landmark time" | "time" | "/r/is a" |  | "FN" |  |
| fn:fe:landmark_time | /r/RelatedTo | fn:fe:destination_time | "landmark time" | "destination time" | "/r/related to" |  | "FN" |  |
| fn:change_event_time | /r/HasA | fn:fe:landmark_time | "change event time" | "landmark time" | "/r/has a" |  | "FN" |  |
| fn:change_event_time | /r/HasA | fn:fe:explanation | "change event time" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:change_event_time | /r/HasA | fn:fe:purpose | "change event time" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:change_event_time | /r/HasA | fn:fe:time | "change event time" | "time" | "/r/has a" |  | "FN" |  |
| fn:change_event_time | /r/HasA | fn:fe:place | "change event time" | "place" | "/r/has a" |  | "FN" |  |
| fn:change_of_consistency | /r/IsA | fn:event | "change of consistency" | "event" | "/r/is a" |  | "FN" |  |
| fn:cause_change_of_consistency | /r/Causes | fn:change_of_consistency | "cause change of consistency" | "change of consistency" | "/r/causes" |  | "FN" |  |
| fn:change_of_consistency | fn:HasLexicalUnit | fn:lu:change_of_consistency:congeal | "change of consistency" | "congeal" | "has lexical unit" |  | "FN" |  |
| fn:change_of_consistency | fn:HasLexicalUnit | fn:lu:change_of_consistency:coagulate | "change of consistency" | "coagulate" | "has lexical unit" |  | "FN" |  |
| fn:change_of_consistency | fn:HasLexicalUnit | fn:lu:change_of_consistency:jell | "change of consistency" | "jell" | "has lexical unit" |  | "FN" |  |
| fn:change_of_consistency | fn:HasLexicalUnit | fn:lu:change_of_consistency:clot | "change of consistency" | "clot" | "has lexical unit" |  | "FN" |  |
| fn:change_of_consistency | fn:HasLexicalUnit | fn:lu:change_of_consistency:soften | "change of consistency" | "soften" | "has lexical unit" |  | "FN" |  |
| fn:change_of_consistency | fn:HasLexicalUnit | fn:lu:change_of_consistency:harden | "change of consistency" | "harden" | "has lexical unit" |  | "FN" |  |
| fn:change_of_consistency | fn:HasLexicalUnit | fn:lu:change_of_consistency:curdle | "change of consistency" | "curdle" | "has lexical unit" |  | "FN" |  |
| fn:change_of_consistency | fn:HasLexicalUnit | fn:lu:change_of_consistency:thicken | "change of consistency" | "thicken" | "has lexical unit" |  | "FN" |  |
| fn:change_of_consistency | fn:HasLexicalUnit | fn:lu:change_of_consistency:set | "change of consistency" | "set" | "has lexical unit" |  | "FN" |  |
| fn:change_of_consistency | fn:HasLexicalUnit | fn:lu:change_of_consistency:coagulation | "change of consistency" | "coagulation" | "has lexical unit" |  | "FN" |  |
| fn:change_of_consistency | fn:HasLexicalUnit | fn:lu:change_of_consistency:indurate | "change of consistency" | "indurate" | "has lexical unit" |  | "FN" |  |
| fn:change_of_consistency | fn:HasLexicalUnit | fn:lu:change_of_consistency:thin | "change of consistency" | "thin" | "has lexical unit" |  | "FN" |  |
| fn:change_of_consistency | /r/HasA | fn:fe:result | "change of consistency" | "result" | "/r/has a" |  | "FN" |  |
| fn:change_of_consistency | /r/HasA | fn:fe:initial_state | "change of consistency" | "initial state" | "/r/has a" |  | "FN" |  |
| fn:change_of_consistency | /r/HasA | fn:fe:patient | "change of consistency" | "patient" | "/r/has a" |  | "FN" |  |
| fn:change_of_consistency | /r/HasA | fn:fe:place | "change of consistency" | "place" | "/r/has a" |  | "FN" |  |
| fn:change_of_consistency | /r/HasA | fn:fe:time | "change of consistency" | "time" | "/r/has a" |  | "FN" |  |
| fn:change_of_consistency | /r/HasA | fn:fe:explanation | "change of consistency" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:change_of_consistency | /r/HasA | fn:fe:speed | "change of consistency" | "speed" | "/r/has a" |  | "FN" |  |
| fn:change_of_consistency | /r/HasA | fn:fe:circumstances | "change of consistency" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:change_of_consistency | /r/HasA | fn:fe:manner | "change of consistency" | "manner" | "/r/has a" |  | "FN" |  |
| fn:change_of_consistency | /r/HasA | fn:fe:degree | "change of consistency" | "degree" | "/r/has a" |  | "FN" |  |
| fn:change_of_consistency | /r/HasA | fn:fe:subregion | "change of consistency" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:change_of_leadership | /r/IsA | fn:appointing | "change of leadership" | "appointing" | "/r/is a" |  | "FN" |  |
| fn:change_of_leadership | /r/SimilarTo | fn:appointing | "change of leadership" | "appointing" | "/r/similar to" |  | "FN" |  |
| fn:change_of_leadership | /r/Causes | fn:leadership | "change of leadership" | "leadership" | "/r/causes" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:coup | "change of leadership" | "coup" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:elect | "change of leadership" | "elect" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:insurrection | "change of leadership" | "insurrection" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:mutiny | "change of leadership" | "mutiny" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:mutiny | "change of leadership" | "mutiny" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:overthrow | "change of leadership" | "overthrow" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:rebellion | "change of leadership" | "rebellion" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:revolt | "change of leadership" | "revolt" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:revolution | "change of leadership" | "revolution" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:uprising | "change of leadership" | "uprising" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:oust | "change of leadership" | "oust" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:depose | "change of leadership" | "depose" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:dethrone | "change of leadership" | "dethrone" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:overthrow | "change of leadership" | "overthrow" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:revolt | "change of leadership" | "revolt" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:take_over | "change of leadership" | "take over" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:topple | "change of leadership" | "topple" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:election | "change of leadership" | "election" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:throne | "change of leadership" | "throne" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:enthrone | "change of leadership" | "enthrone" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:coronate | "change of leadership" | "coronate" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:crown | "change of leadership" | "crown" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:vest | "change of leadership" | "vest" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:install | "change of leadership" | "install" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:revolutionary | "change of leadership" | "revolutionary" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:independence | "change of leadership" | "independence" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:rising | "change of leadership" | "rising" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:freedom | "change of leadership" | "freedom" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | fn:HasLexicalUnit | fn:lu:change_of_leadership:ouster | "change of leadership" | "ouster" | "has lexical unit" |  | "FN" |  |
| fn:change_of_leadership | /r/HasA | fn:fe:selector | "change of leadership" | "selector" | "/r/has a" |  | "FN" |  |
| fn:change_of_leadership | /r/HasA | fn:fe:old_leader | "change of leadership" | "old leader" | "/r/has a" |  | "FN" |  |
| fn:change_of_leadership | /r/HasA | fn:fe:new_leader | "change of leadership" | "new leader" | "/r/has a" |  | "FN" |  |
| fn:fe:role | /r/RelatedTo | fn:fe:old_order | "role" | "old order" | "/r/related to" |  | "FN" |  |
| fn:change_of_leadership | /r/HasA | fn:fe:role | "change of leadership" | "role" | "/r/has a" |  | "FN" |  |
| fn:change_of_leadership | /r/HasA | fn:fe:old_order | "change of leadership" | "old order" | "/r/has a" |  | "FN" |  |
| fn:change_of_leadership | /r/HasA | fn:fe:degree | "change of leadership" | "degree" | "/r/has a" |  | "FN" |  |
| fn:change_of_leadership | /r/HasA | fn:fe:depictive | "change of leadership" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:change_of_leadership | /r/HasA | fn:fe:manner | "change of leadership" | "manner" | "/r/has a" |  | "FN" |  |
| fn:change_of_leadership | /r/HasA | fn:fe:means | "change of leadership" | "means" | "/r/has a" |  | "FN" |  |
| fn:change_of_leadership | /r/HasA | fn:fe:result | "change of leadership" | "result" | "/r/has a" |  | "FN" |  |
| fn:change_of_leadership | /r/HasA | fn:fe:circumstances | "change of leadership" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:fe:function | /r/RelatedTo | fn:fe:old_order | "function" | "old order" | "/r/related to" |  | "FN" |  |
| fn:change_of_leadership | /r/HasA | fn:fe:function | "change of leadership" | "function" | "/r/has a" |  | "FN" |  |
| fn:change_of_leadership | /r/HasA | fn:fe:time | "change of leadership" | "time" | "/r/has a" |  | "FN" |  |
| fn:change_of_leadership | /r/HasA | fn:fe:place | "change of leadership" | "place" | "/r/has a" |  | "FN" |  |
| fn:change_of_leadership | /r/HasA | fn:fe:body | "change of leadership" | "body" | "/r/has a" |  | "FN" |  |
| fn:change_of_phase_scenario | /r/HasSubevent | fn:change_of_phase | "change of phase scenario" | "change of phase" | "/r/has subevent" |  | "FN" |  |
| fn:cause_change_of_phase | /r/Causes | fn:change_of_phase | "cause change of phase" | "change of phase" | "/r/causes" |  | "FN" |  |
| fn:substance_by_phase | /r/HasPrerequisite | fn:change_of_phase | "substance by phase" | "change of phase" | "/r/has prerequisite" |  | "FN" |  |
| fn:change_of_phase | fn:HasLexicalUnit | fn:lu:change_of_phase:freeze | "change of phase" | "freeze" | "has lexical unit" |  | "FN" |  |
| fn:change_of_phase | fn:HasLexicalUnit | fn:lu:change_of_phase:liquefy | "change of phase" | "liquefy" | "has lexical unit" |  | "FN" |  |
| fn:change_of_phase | fn:HasLexicalUnit | fn:lu:change_of_phase:vaporize | "change of phase" | "vaporize" | "has lexical unit" |  | "FN" |  |
| fn:change_of_phase | fn:HasLexicalUnit | fn:lu:change_of_phase:evaporate | "change of phase" | "evaporate" | "has lexical unit" |  | "FN" |  |
| fn:change_of_phase | fn:HasLexicalUnit | fn:lu:change_of_phase:solidify | "change of phase" | "solidify" | "has lexical unit" |  | "FN" |  |
| fn:change_of_phase | fn:HasLexicalUnit | fn:lu:change_of_phase:thaw | "change of phase" | "thaw" | "has lexical unit" |  | "FN" |  |
| fn:change_of_phase | fn:HasLexicalUnit | fn:lu:change_of_phase:sublime | "change of phase" | "sublime" | "has lexical unit" |  | "FN" |  |
| fn:change_of_phase | fn:HasLexicalUnit | fn:lu:change_of_phase:condense | "change of phase" | "condense" | "has lexical unit" |  | "FN" |  |
| fn:change_of_phase | fn:HasLexicalUnit | fn:lu:change_of_phase:melt | "change of phase" | "melt" | "has lexical unit" |  | "FN" |  |
| fn:change_of_phase | fn:HasLexicalUnit | fn:lu:change_of_phase:defrost | "change of phase" | "defrost" | "has lexical unit" |  | "FN" |  |
| fn:change_of_phase | fn:HasLexicalUnit | fn:lu:change_of_phase:condensation | "change of phase" | "condensation" | "has lexical unit" |  | "FN" |  |
| fn:change_of_phase | fn:HasLexicalUnit | fn:lu:change_of_phase:evaporation | "change of phase" | "evaporation" | "has lexical unit" |  | "FN" |  |
| fn:change_of_phase | fn:HasLexicalUnit | fn:lu:change_of_phase:solidification | "change of phase" | "solidification" | "has lexical unit" |  | "FN" |  |
| fn:change_of_phase | fn:HasLexicalUnit | fn:lu:change_of_phase:sublimation | "change of phase" | "sublimation" | "has lexical unit" |  | "FN" |  |
| fn:change_of_phase | fn:HasLexicalUnit | fn:lu:change_of_phase:unfreeze | "change of phase" | "unfreeze" | "has lexical unit" |  | "FN" |  |
| fn:change_of_phase | /r/HasA | fn:fe:patient | "change of phase" | "patient" | "/r/has a" |  | "FN" |  |
| fn:change_of_phase | /r/HasA | fn:fe:result | "change of phase" | "result" | "/r/has a" |  | "FN" |  |
| fn:change_of_phase | /r/HasA | fn:fe:initial_state | "change of phase" | "initial state" | "/r/has a" |  | "FN" |  |
| fn:change_of_phase | /r/HasA | fn:fe:degree | "change of phase" | "degree" | "/r/has a" |  | "FN" |  |
| fn:change_of_phase | /r/HasA | fn:fe:speed | "change of phase" | "speed" | "/r/has a" |  | "FN" |  |
| fn:change_of_phase | /r/HasA | fn:fe:manner | "change of phase" | "manner" | "/r/has a" |  | "FN" |  |
| fn:change_of_phase | /r/HasA | fn:fe:place | "change of phase" | "place" | "/r/has a" |  | "FN" |  |
| fn:change_of_phase | /r/HasA | fn:fe:time | "change of phase" | "time" | "/r/has a" |  | "FN" |  |
| fn:change_of_phase | /r/HasA | fn:fe:circumstances | "change of phase" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:change_of_phase | /r/HasA | fn:fe:subregion | "change of phase" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:change_of_phase_scenario | /r/HasSubevent | fn:change_of_phase | "change of phase scenario" | "change of phase" | "/r/has subevent" |  | "FN" |  |
| fn:change_of_phase_scenario | /r/HasSubevent | fn:substance_by_phase | "change of phase scenario" | "substance by phase" | "/r/has subevent" |  | "FN" |  |
| fn:change_of_phase_scenario | /r/HasA | fn:fe:patient | "change of phase scenario" | "patient" | "/r/has a" |  | "FN" |  |
| fn:change_of_phase_scenario | /r/HasA | fn:fe:result | "change of phase scenario" | "result" | "/r/has a" |  | "FN" |  |
| fn:change_of_phase_scenario | /r/HasA | fn:fe:initial_state | "change of phase scenario" | "initial state" | "/r/has a" |  | "FN" |  |
| fn:change_of_phase_scenario | /r/HasA | fn:fe:degree | "change of phase scenario" | "degree" | "/r/has a" |  | "FN" |  |
| fn:change_of_phase_scenario | /r/HasA | fn:fe:speed | "change of phase scenario" | "speed" | "/r/has a" |  | "FN" |  |
| fn:change_of_phase_scenario | /r/HasA | fn:fe:manner | "change of phase scenario" | "manner" | "/r/has a" |  | "FN" |  |
| fn:change_of_phase_scenario | /r/HasA | fn:fe:place | "change of phase scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:change_of_phase_scenario | /r/HasA | fn:fe:time | "change of phase scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:change_of_phase_scenario | /r/HasA | fn:fe:circumstances | "change of phase scenario" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:change_of_phase_scenario | /r/HasA | fn:fe:subregion | "change of phase scenario" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/UsedFor | fn:change_of_quantity_of_possession | "change position on a scale" | "change of quantity of possession" | "/r/used for" |  | "FN" |  |
| fn:possession | /r/UsedFor | fn:change_of_quantity_of_possession | "possession" | "change of quantity of possession" | "/r/used for" |  | "FN" |  |
| fn:change_of_quantity_of_possession | fn:HasLexicalUnit | fn:lu:change_of_quantity_of_possession:gain | "change of quantity of possession" | "gain" | "has lexical unit" |  | "FN" |  |
| fn:change_of_quantity_of_possession | fn:HasLexicalUnit | fn:lu:change_of_quantity_of_possession:lose | "change of quantity of possession" | "lose" | "has lexical unit" |  | "FN" |  |
| fn:change_of_quantity_of_possession | /r/HasA | fn:fe:owner | "change of quantity of possession" | "owner" | "/r/has a" |  | "FN" |  |
| fn:change_of_quantity_of_possession | /r/HasA | fn:fe:possession | "change of quantity of possession" | "possession" | "/r/has a" |  | "FN" |  |
| fn:change_of_quantity_of_possession | /r/HasA | fn:fe:time | "change of quantity of possession" | "time" | "/r/has a" |  | "FN" |  |
| fn:fe:place | /r/IsA | fn:st:location | "place" | "location" | "/r/is a" |  | "FN" |  |
| fn:change_of_quantity_of_possession | /r/HasA | fn:fe:place | "change of quantity of possession" | "place" | "/r/has a" |  | "FN" |  |
| fn:change_of_quantity_of_possession | /r/HasA | fn:fe:degree | "change of quantity of possession" | "degree" | "/r/has a" |  | "FN" |  |
| fn:change_of_quantity_of_possession | /r/HasA | fn:fe:explanation | "change of quantity of possession" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:change_of_temperature | /r/IsA | fn:change_position_on_a_scale | "change of temperature" | "change position on a scale" | "/r/is a" |  | "FN" |  |
| fn:cause_temperature_change | /r/SimilarTo | fn:change_of_temperature | "cause temperature change" | "change of temperature" | "/r/similar to" |  | "FN" |  |
| fn:change_of_temperature | /r/Causes | fn:temperature | "change of temperature" | "temperature" | "/r/causes" |  | "FN" |  |
| fn:cause_temperature_change | /r/Causes | fn:change_of_temperature | "cause temperature change" | "change of temperature" | "/r/causes" |  | "FN" |  |
| fn:change_of_temperature | fn:HasLexicalUnit | fn:lu:change_of_temperature:chill | "change of temperature" | "chill" | "has lexical unit" |  | "FN" |  |
| fn:change_of_temperature | fn:HasLexicalUnit | fn:lu:change_of_temperature:cool | "change of temperature" | "cool" | "has lexical unit" |  | "FN" |  |
| fn:change_of_temperature | fn:HasLexicalUnit | fn:lu:change_of_temperature:heat | "change of temperature" | "heat" | "has lexical unit" |  | "FN" |  |
| fn:change_of_temperature | fn:HasLexicalUnit | fn:lu:change_of_temperature:refrigerate | "change of temperature" | "refrigerate" | "has lexical unit" |  | "FN" |  |
| fn:change_of_temperature | fn:HasLexicalUnit | fn:lu:change_of_temperature:reheat | "change of temperature" | "reheat" | "has lexical unit" |  | "FN" |  |
| fn:change_of_temperature | fn:HasLexicalUnit | fn:lu:change_of_temperature:warm | "change of temperature" | "warm" | "has lexical unit" |  | "FN" |  |
| fn:change_of_temperature | fn:HasLexicalUnit | fn:lu:change_of_temperature:cool_off | "change of temperature" | "cool off" | "has lexical unit" |  | "FN" |  |
| fn:change_of_temperature | /r/HasA | fn:fe:item | "change of temperature" | "item" | "/r/has a" |  | "FN" |  |
| fn:change_of_temperature | /r/HasA | fn:fe:initial_temperature | "change of temperature" | "initial temperature" | "/r/has a" |  | "FN" |  |
| fn:change_of_temperature | /r/HasA | fn:fe:final_temperature | "change of temperature" | "final temperature" | "/r/has a" |  | "FN" |  |
| fn:change_of_temperature | /r/HasA | fn:fe:temperature_change | "change of temperature" | "temperature change" | "/r/has a" |  | "FN" |  |
| fn:change_of_temperature | /r/HasA | fn:fe:hot_cold_source | "change of temperature" | "hot cold source" | "/r/has a" |  | "FN" |  |
| fn:change_of_temperature | /r/HasA | fn:fe:cause | "change of temperature" | "cause" | "/r/has a" |  | "FN" |  |
| fn:change_of_temperature | /r/HasA | fn:fe:container | "change of temperature" | "container" | "/r/has a" |  | "FN" |  |
| fn:change_of_temperature | /r/HasA | fn:fe:depictive | "change of temperature" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:change_of_temperature | /r/HasA | fn:fe:duration | "change of temperature" | "duration" | "/r/has a" |  | "FN" |  |
| fn:change_of_temperature | /r/HasA | fn:fe:time | "change of temperature" | "time" | "/r/has a" |  | "FN" |  |
| fn:change_of_temperature | /r/HasA | fn:fe:place | "change of temperature" | "place" | "/r/has a" |  | "FN" |  |
| fn:change_of_temperature | /r/HasA | fn:fe:subregion | "change of temperature" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:change_of_temperature | /r/HasA | fn:fe:manner | "change of temperature" | "manner" | "/r/has a" |  | "FN" |  |
| fn:change_of_temperature | /r/HasA | fn:fe:circumstances | "change of temperature" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:change_of_temperature | /r/HasA | fn:fe:result | "change of temperature" | "result" | "/r/has a" |  | "FN" |  |
| fn:change_of_temperature | /r/HasA | fn:fe:particular_iteration | "change of temperature" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:change_of_temperature | /r/HasA | fn:fe:temperature | "change of temperature" | "temperature" | "/r/has a" |  | "FN" |  |
| fn:change_of_temperature | /r/HasA | fn:fe:degree | "change of temperature" | "degree" | "/r/has a" |  | "FN" |  |
| fn:change_operational_state | /r/IsA | fn:intentionally_affect | "change operational state" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:change_operational_state | /r/Causes | fn:being_in_operation | "change operational state" | "being in operation" | "/r/causes" |  | "FN" |  |
| fn:change_operational_state | fn:HasLexicalUnit | fn:lu:change_operational_state:activate | "change operational state" | "activate" | "has lexical unit" |  | "FN" |  |
| fn:change_operational_state | fn:HasLexicalUnit | fn:lu:change_operational_state:turn_on | "change operational state" | "turn on" | "has lexical unit" |  | "FN" |  |
| fn:change_operational_state | fn:HasLexicalUnit | fn:lu:change_operational_state:turn_off | "change operational state" | "turn off" | "has lexical unit" |  | "FN" |  |
| fn:change_operational_state | fn:HasLexicalUnit | fn:lu:change_operational_state:boot | "change operational state" | "boot" | "has lexical unit" |  | "FN" |  |
| fn:change_operational_state | fn:HasLexicalUnit | fn:lu:change_operational_state:shut_off | "change operational state" | "shut off" | "has lexical unit" |  | "FN" |  |
| fn:change_operational_state | fn:HasLexicalUnit | fn:lu:change_operational_state:deactivate | "change operational state" | "deactivate" | "has lexical unit" |  | "FN" |  |
| fn:change_operational_state | fn:HasLexicalUnit | fn:lu:change_operational_state:cut | "change operational state" | "cut" | "has lexical unit" |  | "FN" |  |
| fn:change_operational_state | fn:HasLexicalUnit | fn:lu:change_operational_state:cut_off | "change operational state" | "cut off" | "has lexical unit" |  | "FN" |  |
| fn:change_operational_state | fn:HasLexicalUnit | fn:lu:change_operational_state:kill | "change operational state" | "kill" | "has lexical unit" |  | "FN" |  |
| fn:change_operational_state | /r/HasA | fn:fe:device | "change operational state" | "device" | "/r/has a" |  | "FN" |  |
| fn:change_operational_state | /r/HasA | fn:fe:time | "change operational state" | "time" | "/r/has a" |  | "FN" |  |
| fn:change_operational_state | /r/HasA | fn:fe:place | "change operational state" | "place" | "/r/has a" |  | "FN" |  |
| fn:change_operational_state | /r/HasA | fn:fe:agent | "change operational state" | "agent" | "/r/has a" |  | "FN" |  |
| fn:change_operational_state | /r/HasA | fn:fe:cause | "change operational state" | "cause" | "/r/has a" |  | "FN" |  |
| fn:change_operational_state | /r/HasA | fn:fe:purpose | "change operational state" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:change_operational_state | /r/HasA | fn:fe:explanation | "change operational state" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:change_operational_state | /r/HasA | fn:fe:manner | "change operational state" | "manner" | "/r/has a" |  | "FN" |  |
| fn:change_operational_state | /r/HasA | fn:fe:degree | "change operational state" | "degree" | "/r/has a" |  | "FN" |  |
| fn:change_operational_state | /r/HasA | fn:fe:means | "change operational state" | "means" | "/r/has a" |  | "FN" |  |
| fn:change_of_temperature | /r/IsA | fn:change_position_on_a_scale | "change of temperature" | "change position on a scale" | "/r/is a" |  | "FN" |  |
| fn:proliferating_in_number | /r/IsA | fn:change_position_on_a_scale | "proliferating in number" | "change position on a scale" | "/r/is a" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/IsA | fn:event | "change position on a scale" | "event" | "/r/is a" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/UsedFor | fn:change_of_quantity_of_possession | "change position on a scale" | "change of quantity of possession" | "/r/used for" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/UsedFor | fn:remainder | "change position on a scale" | "remainder" | "/r/used for" |  | "FN" |  |
| fn:traversing | /r/SimilarTo | fn:change_position_on_a_scale | "traversing" | "change position on a scale" | "/r/similar to" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/Causes | fn:position_on_a_scale | "change position on a scale" | "position on a scale" | "/r/causes" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | /r/Causes | fn:change_position_on_a_scale | "cause change of position on a scale" | "change position on a scale" | "/r/causes" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:increase | "change position on a scale" | "increase" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:increase | "change position on a scale" | "increase" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:fall | "change position on a scale" | "fall" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:fall | "change position on a scale" | "fall" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:rise | "change position on a scale" | "rise" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:rise | "change position on a scale" | "rise" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:decrease | "change position on a scale" | "decrease" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:decrease | "change position on a scale" | "decrease" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:soar | "change position on a scale" | "soar" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:diminish | "change position on a scale" | "diminish" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:plummet | "change position on a scale" | "plummet" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:grow | "change position on a scale" | "grow" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:move | "change position on a scale" | "move" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:decline | "change position on a scale" | "decline" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:decline | "change position on a scale" | "decline" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:tumble | "change position on a scale" | "tumble" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:tumble | "change position on a scale" | "tumble" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:rocket | "change position on a scale" | "rocket" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:slide | "change position on a scale" | "slide" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:gain | "change position on a scale" | "gain" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:advance | "change position on a scale" | "advance" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:jump | "change position on a scale" | "jump" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:drop | "change position on a scale" | "drop" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:dwindle | "change position on a scale" | "dwindle" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:double | "change position on a scale" | "double" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:triple | "change position on a scale" | "triple" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:fluctuate | "change position on a scale" | "fluctuate" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:fluctuation | "change position on a scale" | "fluctuation" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:hike | "change position on a scale" | "hike" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:explode | "change position on a scale" | "explode" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:explosion | "change position on a scale" | "explosion" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:mushroom | "change position on a scale" | "mushroom" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:growth | "change position on a scale" | "growth" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:swell | "change position on a scale" | "swell" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:skyrocket | "change position on a scale" | "skyrocket" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:reach | "change position on a scale" | "reach" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:dip | "change position on a scale" | "dip" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:edge | "change position on a scale" | "edge" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:climb | "change position on a scale" | "climb" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:swing | "change position on a scale" | "swing" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:escalation | "change position on a scale" | "escalation" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:shift | "change position on a scale" | "shift" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:shift | "change position on a scale" | "shift" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:gain | "change position on a scale" | "gain" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:increasingly | "change position on a scale" | "increasingly" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:balloon | "change position on a scale" | "balloon" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:growing | "change position on a scale" | "growing" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:contract | "change position on a scale" | "contract" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:contraction | "change position on a scale" | "contraction" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:depressed | "change position on a scale" | "depressed" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:elevated | "change position on a scale" | "elevated" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:accelerated | "change position on a scale" | "accelerated" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:depression | "change position on a scale" | "depression" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:elevation | "change position on a scale" | "elevation" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:lower | "change position on a scale" | "lower" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | fn:HasLexicalUnit | fn:lu:change_position_on_a_scale:down | "change position on a scale" | "down" | "has lexical unit" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/HasA | fn:fe:attribute | "change position on a scale" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/HasA | fn:fe:item | "change position on a scale" | "item" | "/r/has a" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/HasA | fn:fe:difference | "change position on a scale" | "difference" | "/r/has a" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/HasA | fn:fe:path | "change position on a scale" | "path" | "/r/has a" |  | "FN" |  |
| fn:fe:final_value | /r/RelatedTo | fn:fe:value_range | "final value" | "value range" | "/r/related to" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/HasA | fn:fe:final_value | "change position on a scale" | "final value" | "/r/has a" |  | "FN" |  |
| fn:fe:initial_value | /r/RelatedTo | fn:fe:value_range | "initial value" | "value range" | "/r/related to" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/HasA | fn:fe:initial_value | "change position on a scale" | "initial value" | "/r/has a" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/HasA | fn:fe:speed | "change position on a scale" | "speed" | "/r/has a" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/HasA | fn:fe:correlated_variable | "change position on a scale" | "correlated variable" | "/r/has a" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/HasA | fn:fe:manner | "change position on a scale" | "manner" | "/r/has a" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/HasA | fn:fe:degree | "change position on a scale" | "degree" | "/r/has a" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/HasA | fn:fe:circumstances | "change position on a scale" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/HasA | fn:fe:result | "change position on a scale" | "result" | "/r/has a" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/HasA | fn:fe:group | "change position on a scale" | "group" | "/r/has a" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/HasA | fn:fe:time | "change position on a scale" | "time" | "/r/has a" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/HasA | fn:fe:duration | "change position on a scale" | "duration" | "/r/has a" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/HasA | fn:fe:value_range | "change position on a scale" | "value range" | "/r/has a" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/HasA | fn:fe:initial_correlate | "change position on a scale" | "initial correlate" | "/r/has a" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/HasA | fn:fe:final_correlate | "change position on a scale" | "final correlate" | "/r/has a" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/HasA | fn:fe:place | "change position on a scale" | "place" | "/r/has a" |  | "FN" |  |
| fn:fe:initial_state | /r/RelatedTo | fn:fe:value_range | "initial state" | "value range" | "/r/related to" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/HasA | fn:fe:initial_state | "change position on a scale" | "initial state" | "/r/has a" |  | "FN" |  |
| fn:fe:final_state | /r/RelatedTo | fn:fe:value_range | "final state" | "value range" | "/r/related to" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/HasA | fn:fe:final_state | "change position on a scale" | "final state" | "/r/has a" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/HasA | fn:fe:period_of_iterations | "change position on a scale" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/HasA | fn:fe:particular_iteration | "change position on a scale" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/HasA | fn:fe:containing_event | "change position on a scale" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/HasA | fn:fe:explanation | "change position on a scale" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:change_post-state | fn:HasLexicalUnit | fn:lu:change_post-state:changed | "change post-state" | "changed" | "has lexical unit" |  | "FN" |  |
| fn:change_post-state | fn:HasLexicalUnit | fn:lu:change_post-state:unchanged | "change post-state" | "unchanged" | "has lexical unit" |  | "FN" |  |
| fn:change_post-state | fn:HasLexicalUnit | fn:lu:change_post-state:altered | "change post-state" | "altered" | "has lexical unit" |  | "FN" |  |
| fn:change_post-state | fn:HasLexicalUnit | fn:lu:change_post-state:unaltered | "change post-state" | "unaltered" | "has lexical unit" |  | "FN" |  |
| fn:change_post-state | /r/HasA | fn:fe:entity | "change post-state" | "entity" | "/r/has a" |  | "FN" |  |
| fn:change_posture | /r/IsA | fn:intentionally_act | "change posture" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:change_posture | /r/UsedFor | fn:getting_up | "change posture" | "getting up" | "/r/used for" |  | "FN" |  |
| fn:path_shape | /r/SimilarTo | fn:change_posture | "path shape" | "change posture" | "/r/similar to" |  | "FN" |  |
| fn:posture | /r/SimilarTo | fn:change_posture | "posture" | "change posture" | "/r/similar to" |  | "FN" |  |
| fn:change_posture | /r/Causes | fn:posture | "change posture" | "posture" | "/r/causes" |  | "FN" |  |
| fn:change_posture | fn:HasLexicalUnit | fn:lu:change_posture:bend | "change posture" | "bend" | "has lexical unit" |  | "FN" |  |
| fn:change_posture | fn:HasLexicalUnit | fn:lu:change_posture:stoop | "change posture" | "stoop" | "has lexical unit" |  | "FN" |  |
| fn:change_posture | fn:HasLexicalUnit | fn:lu:change_posture:stand | "change posture" | "stand" | "has lexical unit" |  | "FN" |  |
| fn:change_posture | fn:HasLexicalUnit | fn:lu:change_posture:stand_up | "change posture" | "stand up" | "has lexical unit" |  | "FN" |  |
| fn:change_posture | fn:HasLexicalUnit | fn:lu:change_posture:kneel | "change posture" | "kneel" | "has lexical unit" |  | "FN" |  |
| fn:change_posture | fn:HasLexicalUnit | fn:lu:change_posture:kneel_down | "change posture" | "kneel down" | "has lexical unit" |  | "FN" |  |
| fn:change_posture | fn:HasLexicalUnit | fn:lu:change_posture:lie_down | "change posture" | "lie down" | "has lexical unit" |  | "FN" |  |
| fn:change_posture | fn:HasLexicalUnit | fn:lu:change_posture:lie | "change posture" | "lie" | "has lexical unit" |  | "FN" |  |
| fn:change_posture | fn:HasLexicalUnit | fn:lu:change_posture:sit | "change posture" | "sit" | "has lexical unit" |  | "FN" |  |
| fn:change_posture | fn:HasLexicalUnit | fn:lu:change_posture:sit_down | "change posture" | "sit down" | "has lexical unit" |  | "FN" |  |
| fn:change_posture | fn:HasLexicalUnit | fn:lu:change_posture:sit_up | "change posture" | "sit up" | "has lexical unit" |  | "FN" |  |
| fn:change_posture | fn:HasLexicalUnit | fn:lu:change_posture:squat | "change posture" | "squat" | "has lexical unit" |  | "FN" |  |
| fn:change_posture | fn:HasLexicalUnit | fn:lu:change_posture:squat_down | "change posture" | "squat down" | "has lexical unit" |  | "FN" |  |
| fn:change_posture | fn:HasLexicalUnit | fn:lu:change_posture:lean | "change posture" | "lean" | "has lexical unit" |  | "FN" |  |
| fn:change_posture | fn:HasLexicalUnit | fn:lu:change_posture:sprawl | "change posture" | "sprawl" | "has lexical unit" |  | "FN" |  |
| fn:change_posture | fn:HasLexicalUnit | fn:lu:change_posture:sprawl_out | "change posture" | "sprawl out" | "has lexical unit" |  | "FN" |  |
| fn:change_posture | fn:HasLexicalUnit | fn:lu:change_posture:crouch | "change posture" | "crouch" | "has lexical unit" |  | "FN" |  |
| fn:change_posture | fn:HasLexicalUnit | fn:lu:change_posture:crouch_down | "change posture" | "crouch down" | "has lexical unit" |  | "FN" |  |
| fn:change_posture | fn:HasLexicalUnit | fn:lu:change_posture:huddle | "change posture" | "huddle" | "has lexical unit" |  | "FN" |  |
| fn:change_posture | fn:HasLexicalUnit | fn:lu:change_posture:hunch | "change posture" | "hunch" | "has lexical unit" |  | "FN" |  |
| fn:change_posture | fn:HasLexicalUnit | fn:lu:change_posture:slouch | "change posture" | "slouch" | "has lexical unit" |  | "FN" |  |
| fn:change_posture | fn:HasLexicalUnit | fn:lu:change_posture:kneel_up | "change posture" | "kneel up" | "has lexical unit" |  | "FN" |  |
| fn:change_posture | fn:HasLexicalUnit | fn:lu:change_posture:hunch_up | "change posture" | "hunch up" | "has lexical unit" |  | "FN" |  |
| fn:change_posture | fn:HasLexicalUnit | fn:lu:change_posture:rise | "change posture" | "rise" | "has lexical unit" |  | "FN" |  |
| fn:change_posture | fn:HasLexicalUnit | fn:lu:change_posture:drop | "change posture" | "drop" | "has lexical unit" |  | "FN" |  |
| fn:change_posture | /r/HasA | fn:fe:manner | "change posture" | "manner" | "/r/has a" |  | "FN" |  |
| fn:change_posture | /r/HasA | fn:fe:protagonist | "change posture" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:change_posture | /r/HasA | fn:fe:depictive | "change posture" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:change_posture | /r/HasA | fn:fe:location | "change posture" | "location" | "/r/has a" |  | "FN" |  |
| fn:change_posture | /r/HasA | fn:fe:time | "change posture" | "time" | "/r/has a" |  | "FN" |  |
| fn:change_posture | /r/HasA | fn:fe:result | "change posture" | "result" | "/r/has a" |  | "FN" |  |
| fn:change_posture | /r/HasA | fn:fe:path | "change posture" | "path" | "/r/has a" |  | "FN" |  |
| fn:change_posture | /r/HasA | fn:fe:goal | "change posture" | "goal" | "/r/has a" |  | "FN" |  |
| fn:change_posture | /r/HasA | fn:fe:source | "change posture" | "source" | "/r/has a" |  | "FN" |  |
| fn:change_posture | /r/HasA | fn:fe:direction | "change posture" | "direction" | "/r/has a" |  | "FN" |  |
| fn:change_posture | /r/HasA | fn:fe:purpose | "change posture" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:change_posture | /r/HasA | fn:fe:distance | "change posture" | "distance" | "/r/has a" |  | "FN" |  |
| fn:change_posture | /r/HasA | fn:fe:point_of_contact | "change posture" | "point of contact" | "/r/has a" |  | "FN" |  |
| fn:change_posture | /r/HasA | fn:fe:means | "change posture" | "means" | "/r/has a" |  | "FN" |  |
| fn:change_resistance | /r/IsA | fn:cause_change_of_strength | "change resistance" | "cause change of strength" | "/r/is a" |  | "FN" |  |
| fn:change_resistance | fn:HasLexicalUnit | fn:lu:change_resistance:buttress | "change resistance" | "buttress" | "has lexical unit" |  | "FN" |  |
| fn:change_resistance | fn:HasLexicalUnit | fn:lu:change_resistance:bulwark | "change resistance" | "bulwark" | "has lexical unit" |  | "FN" |  |
| fn:change_resistance | fn:HasLexicalUnit | fn:lu:change_resistance:brace | "change resistance" | "brace" | "has lexical unit" |  | "FN" |  |
| fn:change_resistance | /r/HasA | fn:fe:agent | "change resistance" | "agent" | "/r/has a" |  | "FN" |  |
| fn:change_resistance | /r/HasA | fn:fe:patient | "change resistance" | "patient" | "/r/has a" |  | "FN" |  |
| fn:change_resistance | /r/HasA | fn:fe:depictive | "change resistance" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:change_resistance | /r/HasA | fn:fe:result | "change resistance" | "result" | "/r/has a" |  | "FN" |  |
| fn:change_resistance | /r/HasA | fn:fe:means | "change resistance" | "means" | "/r/has a" |  | "FN" |  |
| fn:change_resistance | /r/HasA | fn:fe:manner | "change resistance" | "manner" | "/r/has a" |  | "FN" |  |
| fn:change_resistance | /r/HasA | fn:fe:time | "change resistance" | "time" | "/r/has a" |  | "FN" |  |
| fn:change_resistance | /r/HasA | fn:fe:place | "change resistance" | "place" | "/r/has a" |  | "FN" |  |
| fn:change_resistance | /r/HasA | fn:fe:cause | "change resistance" | "cause" | "/r/has a" |  | "FN" |  |
| fn:change_resistance | /r/HasA | fn:fe:attack | "change resistance" | "attack" | "/r/has a" |  | "FN" |  |
| fn:change_tool | /r/IsA | fn:intentionally_act | "change tool" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:change_tool | fn:HasLexicalUnit | fn:lu:change_tool:change | "change tool" | "change" | "has lexical unit" |  | "FN" |  |
| fn:change_tool | fn:HasLexicalUnit | fn:lu:change_tool:transfer | "change tool" | "transfer" | "has lexical unit" |  | "FN" |  |
| fn:change_tool | fn:HasLexicalUnit | fn:lu:change_tool:switch | "change tool" | "switch" | "has lexical unit" |  | "FN" |  |
| fn:change_tool | fn:HasLexicalUnit | fn:lu:change_tool:swap | "change tool" | "swap" | "has lexical unit" |  | "FN" |  |
| fn:change_tool | fn:HasLexicalUnit | fn:lu:change_tool:trade | "change tool" | "trade" | "has lexical unit" |  | "FN" |  |
| fn:change_tool | /r/HasA | fn:fe:agent | "change tool" | "agent" | "/r/has a" |  | "FN" |  |
| fn:change_tool | /r/HasA | fn:fe:place | "change tool" | "place" | "/r/has a" |  | "FN" |  |
| fn:change_tool | /r/HasA | fn:fe:purpose | "change tool" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:change_tool | /r/HasA | fn:fe:time | "change tool" | "time" | "/r/has a" |  | "FN" |  |
| fn:change_tool | /r/HasA | fn:fe:means | "change tool" | "means" | "/r/has a" |  | "FN" |  |
| fn:change_tool | /r/HasA | fn:fe:manner | "change tool" | "manner" | "/r/has a" |  | "FN" |  |
| fn:change_tool | /r/HasA | fn:fe:tools | "change tool" | "tools" | "/r/has a" |  | "FN" |  |
| fn:fe:old_tool | /r/RelatedTo | fn:fe:tools | "old tool" | "tools" | "/r/related to" |  | "FN" |  |
| fn:change_tool | /r/HasA | fn:fe:old_tool | "change tool" | "old tool" | "/r/has a" |  | "FN" |  |
| fn:fe:new_tool | /r/RelatedTo | fn:fe:tools | "new tool" | "tools" | "/r/related to" |  | "FN" |  |
| fn:change_tool | /r/HasA | fn:fe:new_tool | "change tool" | "new tool" | "/r/has a" |  | "FN" |  |
| fn:change_tool | /r/HasA | fn:fe:iterations | "change tool" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:chaos | /r/IsA | fn:state | "chaos" | "state" | "/r/is a" |  | "FN" |  |
| fn:chaos | fn:HasLexicalUnit | fn:lu:chaos:chaos | "chaos" | "chaos" | "has lexical unit" |  | "FN" |  |
| fn:chaos | fn:HasLexicalUnit | fn:lu:chaos:disorder | "chaos" | "disorder" | "has lexical unit" |  | "FN" |  |
| fn:chaos | fn:HasLexicalUnit | fn:lu:chaos:order | "chaos" | "order" | "has lexical unit" |  | "FN" |  |
| fn:chaos | fn:HasLexicalUnit | fn:lu:chaos:disarray | "chaos" | "disarray" | "has lexical unit" |  | "FN" |  |
| fn:chaos | fn:HasLexicalUnit | fn:lu:chaos:lawlessness | "chaos" | "lawlessness" | "has lexical unit" |  | "FN" |  |
| fn:chaos | fn:HasLexicalUnit | fn:lu:chaos:riot | "chaos" | "riot" | "has lexical unit" |  | "FN" |  |
| fn:chaos | /r/HasA | fn:fe:entity | "chaos" | "entity" | "/r/has a" |  | "FN" |  |
| fn:chaos | /r/HasA | fn:fe:state | "chaos" | "state" | "/r/has a" |  | "FN" |  |
| fn:chaos | /r/HasA | fn:fe:degree | "chaos" | "degree" | "/r/has a" |  | "FN" |  |
| fn:chaos | /r/HasA | fn:fe:place | "chaos" | "place" | "/r/has a" |  | "FN" |  |
| fn:chaos | /r/HasA | fn:fe:duration | "chaos" | "duration" | "/r/has a" |  | "FN" |  |
| fn:chaos | /r/HasA | fn:fe:time | "chaos" | "time" | "/r/has a" |  | "FN" |  |
| fn:chaos | /r/HasA | fn:fe:descriptor | "chaos" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:discussion | /r/IsA | fn:chatting | "discussion" | "chatting" | "/r/is a" |  | "FN" |  |
| fn:chatting | /r/IsA | fn:reciprocality | "chatting" | "reciprocality" | "/r/is a" |  | "FN" |  |
| fn:statement | /r/UsedFor | fn:chatting | "statement" | "chatting" | "/r/used for" |  | "FN" |  |
| fn:discussion | /r/SimilarTo | fn:chatting | "discussion" | "chatting" | "/r/similar to" |  | "FN" |  |
| fn:chatting | fn:HasLexicalUnit | fn:lu:chatting:chat | "chatting" | "chat" | "has lexical unit" |  | "FN" |  |
| fn:chatting | fn:HasLexicalUnit | fn:lu:chatting:badinage | "chatting" | "badinage" | "has lexical unit" |  | "FN" |  |
| fn:chatting | fn:HasLexicalUnit | fn:lu:chatting:banter | "chatting" | "banter" | "has lexical unit" |  | "FN" |  |
| fn:chatting | fn:HasLexicalUnit | fn:lu:chatting:chat | "chatting" | "chat" | "has lexical unit" |  | "FN" |  |
| fn:chatting | fn:HasLexicalUnit | fn:lu:chatting:chit-chat | "chatting" | "chit-chat" | "has lexical unit" |  | "FN" |  |
| fn:chatting | fn:HasLexicalUnit | fn:lu:chatting:colloquy | "chatting" | "colloquy" | "has lexical unit" |  | "FN" |  |
| fn:chatting | fn:HasLexicalUnit | fn:lu:chatting:conversation | "chatting" | "conversation" | "has lexical unit" |  | "FN" |  |
| fn:chatting | fn:HasLexicalUnit | fn:lu:chatting:converse | "chatting" | "converse" | "has lexical unit" |  | "FN" |  |
| fn:chatting | fn:HasLexicalUnit | fn:lu:chatting:speak | "chatting" | "speak" | "has lexical unit" |  | "FN" |  |
| fn:chatting | fn:HasLexicalUnit | fn:lu:chatting:talk | "chatting" | "talk" | "has lexical unit" |  | "FN" |  |
| fn:chatting | fn:HasLexicalUnit | fn:lu:chatting:joke | "chatting" | "joke" | "has lexical unit" |  | "FN" |  |
| fn:chatting | fn:HasLexicalUnit | fn:lu:chatting:gossip | "chatting" | "gossip" | "has lexical unit" |  | "FN" |  |
| fn:chatting | fn:HasLexicalUnit | fn:lu:chatting:gossip | "chatting" | "gossip" | "has lexical unit" |  | "FN" |  |
| fn:chatting | fn:HasLexicalUnit | fn:lu:chatting:gab | "chatting" | "gab" | "has lexical unit" |  | "FN" |  |
| fn:chatting | fn:HasLexicalUnit | fn:lu:chatting:shoot_the_breeze | "chatting" | "shoot the breeze" | "has lexical unit" |  | "FN" |  |
| fn:chatting | fn:HasLexicalUnit | fn:lu:chatting:yak | "chatting" | "yak" | "has lexical unit" |  | "FN" |  |
| fn:fe:interlocutors | /r/IsA | fn:st:sentient | "interlocutors" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:chatting | /r/HasA | fn:fe:interlocutors | "chatting" | "interlocutors" | "/r/has a" |  | "FN" |  |
| fn:fe:interlocutor_1 | /r/IsA | fn:st:sentient | "interlocutor 1" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:fe:interlocutor_1 | /r/RelatedTo | fn:fe:interlocutors | "interlocutor 1" | "interlocutors" | "/r/related to" |  | "FN" |  |
| fn:chatting | /r/HasA | fn:fe:interlocutor_1 | "chatting" | "interlocutor 1" | "/r/has a" |  | "FN" |  |
| fn:fe:interlocutor_2 | /r/IsA | fn:st:sentient | "interlocutor 2" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:fe:interlocutor_2 | /r/HasPrerequisite | fn:fe:interlocutor_1 | "interlocutor 2" | "interlocutor 1" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:interlocutor_2 | /r/RelatedTo | fn:fe:interlocutors | "interlocutor 2" | "interlocutors" | "/r/related to" |  | "FN" |  |
| fn:chatting | /r/HasA | fn:fe:interlocutor_2 | "chatting" | "interlocutor 2" | "/r/has a" |  | "FN" |  |
| fn:chatting | /r/HasA | fn:fe:duration | "chatting" | "duration" | "/r/has a" |  | "FN" |  |
| fn:chatting | /r/HasA | fn:fe:topic | "chatting" | "topic" | "/r/has a" |  | "FN" |  |
| fn:chatting | /r/HasA | fn:fe:language | "chatting" | "language" | "/r/has a" |  | "FN" |  |
| fn:chatting | /r/HasA | fn:fe:means_of_communication | "chatting" | "means of communication" | "/r/has a" |  | "FN" |  |
| fn:chatting | /r/HasA | fn:fe:purpose | "chatting" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:chatting | /r/HasA | fn:fe:time | "chatting" | "time" | "/r/has a" |  | "FN" |  |
| fn:chatting | /r/HasA | fn:fe:place | "chatting" | "place" | "/r/has a" |  | "FN" |  |
| fn:chatting | /r/HasA | fn:fe:means | "chatting" | "means" | "/r/has a" |  | "FN" |  |
| fn:chatting | /r/HasA | fn:fe:manner | "chatting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:chatting | /r/HasA | fn:fe:depictive | "chatting" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:chemical-sense_description | /r/IsA | fn:gradable_attributes | "chemical-sense description" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:give_impression | /r/UsedFor | fn:chemical-sense_description | "give impression" | "chemical-sense description" | "/r/used for" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:tasty | "chemical-sense description" | "tasty" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:piquant | "chemical-sense description" | "piquant" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:yummy | "chemical-sense description" | "yummy" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:flavourful | "chemical-sense description" | "flavourful" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:scrumptious | "chemical-sense description" | "scrumptious" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:palatable | "chemical-sense description" | "palatable" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:delectable | "chemical-sense description" | "delectable" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:flavoursome | "chemical-sense description" | "flavoursome" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:toothsome | "chemical-sense description" | "toothsome" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:ambrosial | "chemical-sense description" | "ambrosial" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:sapid | "chemical-sense description" | "sapid" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:salty | "chemical-sense description" | "salty" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:sour | "chemical-sense description" | "sour" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:bitter | "chemical-sense description" | "bitter" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:spicy | "chemical-sense description" | "spicy" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:sweet | "chemical-sense description" | "sweet" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:hot | "chemical-sense description" | "hot" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:savory | "chemical-sense description" | "savory" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:delicious | "chemical-sense description" | "delicious" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:pungent | "chemical-sense description" | "pungent" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:tart | "chemical-sense description" | "tart" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:flavourless | "chemical-sense description" | "flavourless" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:bland | "chemical-sense description" | "bland" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:insipid | "chemical-sense description" | "insipid" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:unpalatable | "chemical-sense description" | "unpalatable" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:stench | "chemical-sense description" | "stench" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:odor | "chemical-sense description" | "odor" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:reek | "chemical-sense description" | "reek" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:reek | "chemical-sense description" | "reek" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:stink | "chemical-sense description" | "stink" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:stink | "chemical-sense description" | "stink" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:aroma | "chemical-sense description" | "aroma" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:fragrance | "chemical-sense description" | "fragrance" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:scent | "chemical-sense description" | "scent" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:bouquet | "chemical-sense description" | "bouquet" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:smelly | "chemical-sense description" | "smelly" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:aromatic | "chemical-sense description" | "aromatic" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:fragrant | "chemical-sense description" | "fragrant" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:tasteless | "chemical-sense description" | "tasteless" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:malodorous | "chemical-sense description" | "malodorous" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | fn:HasLexicalUnit | fn:lu:chemical-sense_description:smell | "chemical-sense description" | "smell" | "has lexical unit" |  | "FN" |  |
| fn:chemical-sense_description | /r/HasA | fn:fe:perceptual_source | "chemical-sense description" | "perceptual source" | "/r/has a" |  | "FN" |  |
| fn:chemical-sense_description | /r/HasA | fn:fe:degree | "chemical-sense description" | "degree" | "/r/has a" |  | "FN" |  |
| fn:chemical-sense_description | /r/HasA | fn:fe:sensory_attribute | "chemical-sense description" | "sensory attribute" | "/r/has a" |  | "FN" |  |
| fn:chemical_potency | /r/IsA | fn:gradable_attributes | "chemical potency" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:chemical_potency | fn:HasLexicalUnit | fn:lu:chemical_potency:strong | "chemical potency" | "strong" | "has lexical unit" |  | "FN" |  |
| fn:chemical_potency | fn:HasLexicalUnit | fn:lu:chemical_potency:potent | "chemical potency" | "potent" | "has lexical unit" |  | "FN" |  |
| fn:chemical_potency | fn:HasLexicalUnit | fn:lu:chemical_potency:stiff | "chemical potency" | "stiff" | "has lexical unit" |  | "FN" |  |
| fn:chemical_potency | /r/HasA | fn:fe:chemical_entity | "chemical potency" | "chemical entity" | "/r/has a" |  | "FN" |  |
| fn:chemical_potency | /r/HasA | fn:fe:degree | "chemical potency" | "degree" | "/r/has a" |  | "FN" |  |
| fn:chemical_potency | /r/HasA | fn:fe:time | "chemical potency" | "time" | "/r/has a" |  | "FN" |  |
| fn:chemical_potency | /r/HasA | fn:fe:circumstances | "chemical potency" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:chemical_potency | /r/HasA | fn:fe:place | "chemical potency" | "place" | "/r/has a" |  | "FN" |  |
| fn:choosing | /r/IsA | fn:deciding | "choosing" | "deciding" | "/r/is a" |  | "FN" |  |
| fn:choosing | /r/IsA | fn:intentionally_act | "choosing" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:choosing | /r/UsedFor | fn:adopt_selection | "choosing" | "adopt selection" | "/r/used for" |  | "FN" |  |
| fn:choosing | /r/UsedFor | fn:waver_between_options | "choosing" | "waver between options" | "/r/used for" |  | "FN" |  |
| fn:choosing | /r/UsedFor | fn:willingness | "choosing" | "willingness" | "/r/used for" |  | "FN" |  |
| fn:deciding | /r/RelatedTo | fn:choosing | "deciding" | "choosing" | "/r/related to" |  | "FN" |  |
| fn:choosing | /r/SimilarTo | fn:deciding | "choosing" | "deciding" | "/r/similar to" |  | "FN" |  |
| fn:choosing | fn:HasLexicalUnit | fn:lu:choosing:select | "choosing" | "select" | "has lexical unit" |  | "FN" |  |
| fn:choosing | fn:HasLexicalUnit | fn:lu:choosing:choose | "choosing" | "choose" | "has lexical unit" |  | "FN" |  |
| fn:choosing | fn:HasLexicalUnit | fn:lu:choosing:pick | "choosing" | "pick" | "has lexical unit" |  | "FN" |  |
| fn:choosing | fn:HasLexicalUnit | fn:lu:choosing:settle_on | "choosing" | "settle on" | "has lexical unit" |  | "FN" |  |
| fn:choosing | fn:HasLexicalUnit | fn:lu:choosing:elect | "choosing" | "elect" | "has lexical unit" |  | "FN" |  |
| fn:choosing | fn:HasLexicalUnit | fn:lu:choosing:choice | "choosing" | "choice" | "has lexical unit" |  | "FN" |  |
| fn:choosing | fn:HasLexicalUnit | fn:lu:choosing:selection | "choosing" | "selection" | "has lexical unit" |  | "FN" |  |
| fn:choosing | fn:HasLexicalUnit | fn:lu:choosing:opt | "choosing" | "opt" | "has lexical unit" |  | "FN" |  |
| fn:choosing | fn:HasLexicalUnit | fn:lu:choosing:pick | "choosing" | "pick" | "has lexical unit" |  | "FN" |  |
| fn:choosing | /r/HasA | fn:fe:depictive | "choosing" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:choosing | /r/HasA | fn:fe:cognizer | "choosing" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:choosing | /r/HasA | fn:fe:chosen | "choosing" | "chosen" | "/r/has a" |  | "FN" |  |
| fn:choosing | /r/HasA | fn:fe:explanation | "choosing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:choosing | /r/HasA | fn:fe:possibilities | "choosing" | "possibilities" | "/r/has a" |  | "FN" |  |
| fn:choosing | /r/HasA | fn:fe:means | "choosing" | "means" | "/r/has a" |  | "FN" |  |
| fn:choosing | /r/HasA | fn:fe:place | "choosing" | "place" | "/r/has a" |  | "FN" |  |
| fn:choosing | /r/HasA | fn:fe:larger_purpose | "choosing" | "larger purpose" | "/r/has a" |  | "FN" |  |
| fn:choosing | /r/HasA | fn:fe:time | "choosing" | "time" | "/r/has a" |  | "FN" |  |
| fn:choosing | /r/HasA | fn:fe:manner | "choosing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:choosing | /r/HasA | fn:fe:topic | "choosing" | "topic" | "/r/has a" |  | "FN" |  |
| fn:choosing | /r/HasA | fn:fe:inherent_purpose | "choosing" | "inherent purpose" | "/r/has a" |  | "FN" |  |
| fn:choosing | /r/HasA | fn:fe:contrast | "choosing" | "contrast" | "/r/has a" |  | "FN" |  |
| fn:circumscribed_existence | /r/IsA | fn:existence | "circumscribed existence" | "existence" | "/r/is a" |  | "FN" |  |
| fn:circumscribed_existence | fn:HasLexicalUnit | fn:lu:circumscribed_existence:appear | "circumscribed existence" | "appear" | "has lexical unit" |  | "FN" |  |
| fn:circumscribed_existence | fn:HasLexicalUnit | fn:lu:circumscribed_existence:occur | "circumscribed existence" | "occur" | "has lexical unit" |  | "FN" |  |
| fn:circumscribed_existence | fn:HasLexicalUnit | fn:lu:circumscribed_existence:found | "circumscribed existence" | "found" | "has lexical unit" |  | "FN" |  |
| fn:circumscribed_existence | /r/HasA | fn:fe:entity | "circumscribed existence" | "entity" | "/r/has a" |  | "FN" |  |
| fn:circumscribed_existence | /r/HasA | fn:fe:time | "circumscribed existence" | "time" | "/r/has a" |  | "FN" |  |
| fn:circumscribed_existence | /r/HasA | fn:fe:place | "circumscribed existence" | "place" | "/r/has a" |  | "FN" |  |
| fn:circumscribed_existence | /r/HasA | fn:fe:circumstances | "circumscribed existence" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:circumscribed_existence | /r/HasA | fn:fe:descriptor | "circumscribed existence" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:citing | /r/RelatedTo | fn:entering_of_plea | "citing" | "entering of plea" | "/r/related to" |  | "FN" |  |
| fn:citing | /r/RelatedTo | fn:fining | "citing" | "fining" | "/r/related to" |  | "FN" |  |
| fn:citing | /r/RelatedTo | fn:notification_of_charges | "citing" | "notification of charges" | "/r/related to" |  | "FN" |  |
| fn:citing | fn:HasLexicalUnit | fn:lu:citing:cite | "citing" | "cite" | "has lexical unit" |  | "FN" |  |
| fn:citing | fn:HasLexicalUnit | fn:lu:citing:summons | "citing" | "summons" | "has lexical unit" |  | "FN" |  |
| fn:citing | fn:HasLexicalUnit | fn:lu:citing:summon | "citing" | "summon" | "has lexical unit" |  | "FN" |  |
| fn:citing | fn:HasLexicalUnit | fn:lu:citing:summons | "citing" | "summons" | "has lexical unit" |  | "FN" |  |
| fn:citing | fn:HasLexicalUnit | fn:lu:citing:citation | "citing" | "citation" | "has lexical unit" |  | "FN" |  |
| fn:citing | fn:HasLexicalUnit | fn:lu:citing:notice_to_appear | "citing" | "notice to appear" | "has lexical unit" |  | "FN" |  |
| fn:fe:defendant | /r/IsA | fn:st:sentient | "defendant" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:citing | /r/HasA | fn:fe:defendant | "citing" | "defendant" | "/r/has a" |  | "FN" |  |
| fn:citing | /r/HasA | fn:fe:court | "citing" | "court" | "/r/has a" |  | "FN" |  |
| fn:fe:authority | /r/IsA | fn:st:sentient | "authority" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:citing | /r/HasA | fn:fe:authority | "citing" | "authority" | "/r/has a" |  | "FN" |  |
| fn:citing | /r/HasA | fn:fe:charges | "citing" | "charges" | "/r/has a" |  | "FN" |  |
| fn:citing | /r/HasA | fn:fe:fine | "citing" | "fine" | "/r/has a" |  | "FN" |  |
| fn:citing | /r/HasA | fn:fe:place | "citing" | "place" | "/r/has a" |  | "FN" |  |
| fn:citing | /r/HasA | fn:fe:time | "citing" | "time" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:claim_ownership | "communication" | "claim ownership" | "/r/used for" |  | "FN" |  |
| fn:claim_ownership | fn:HasLexicalUnit | fn:lu:claim_ownership:claim | "claim ownership" | "claim" | "has lexical unit" |  | "FN" |  |
| fn:claim_ownership | fn:HasLexicalUnit | fn:lu:claim_ownership:claim | "claim ownership" | "claim" | "has lexical unit" |  | "FN" |  |
| fn:claim_ownership | fn:HasLexicalUnit | fn:lu:claim_ownership:call | "claim ownership" | "call" | "has lexical unit" |  | "FN" |  |
| fn:claim_ownership | fn:HasLexicalUnit | fn:lu:claim_ownership:dibs | "claim ownership" | "dibs" | "has lexical unit" |  | "FN" |  |
| fn:claim_ownership | /r/HasA | fn:fe:claimant | "claim ownership" | "claimant" | "/r/has a" |  | "FN" |  |
| fn:claim_ownership | /r/HasA | fn:fe:property | "claim ownership" | "property" | "/r/has a" |  | "FN" |  |
| fn:claim_ownership | /r/HasA | fn:fe:beneficiary | "claim ownership" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:claim_ownership | /r/HasA | fn:fe:role | "claim ownership" | "role" | "/r/has a" |  | "FN" |  |
| fn:pardon | /r/IsA | fn:clemency | "pardon" | "clemency" | "/r/is a" |  | "FN" |  |
| fn:clemency | /r/IsA | fn:intentionally_act | "clemency" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:clemency | /r/UsedFor | fn:commutation | "clemency" | "commutation" | "/r/used for" |  | "FN" |  |
| fn:pardon | /r/SimilarTo | fn:clemency | "pardon" | "clemency" | "/r/similar to" |  | "FN" |  |
| fn:clemency | fn:HasLexicalUnit | fn:lu:clemency:clemency | "clemency" | "clemency" | "has lexical unit" |  | "FN" |  |
| fn:clemency | /r/HasA | fn:fe:offender | "clemency" | "offender" | "/r/has a" |  | "FN" |  |
| fn:clemency | /r/HasA | fn:fe:crime | "clemency" | "crime" | "/r/has a" |  | "FN" |  |
| fn:fe:executive_authority | /r/IsA | fn:st:sentient | "executive authority" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:clemency | /r/HasA | fn:fe:executive_authority | "clemency" | "executive authority" | "/r/has a" |  | "FN" |  |
| fn:clemency | /r/HasA | fn:fe:explanation | "clemency" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:clemency | /r/HasA | fn:fe:time | "clemency" | "time" | "/r/has a" |  | "FN" |  |
| fn:clemency | /r/HasA | fn:fe:means | "clemency" | "means" | "/r/has a" |  | "FN" |  |
| fn:clemency | /r/HasA | fn:fe:manner | "clemency" | "manner" | "/r/has a" |  | "FN" |  |
| fn:clemency | /r/HasA | fn:fe:purpose | "clemency" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:clemency | /r/HasA | fn:fe:place | "clemency" | "place" | "/r/has a" |  | "FN" |  |
| fn:closure | /r/IsA | fn:intentionally_affect | "closure" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:closure | /r/UsedFor | fn:clothing | "closure" | "clothing" | "/r/used for" |  | "FN" |  |
| fn:closure | /r/UsedFor | fn:fastener | "closure" | "fastener" | "/r/used for" |  | "FN" |  |
| fn:closure | fn:HasLexicalUnit | fn:lu:closure:button | "closure" | "button" | "has lexical unit" |  | "FN" |  |
| fn:closure | fn:HasLexicalUnit | fn:lu:closure:open | "closure" | "open" | "has lexical unit" |  | "FN" |  |
| fn:closure | fn:HasLexicalUnit | fn:lu:closure:close | "closure" | "close" | "has lexical unit" |  | "FN" |  |
| fn:closure | fn:HasLexicalUnit | fn:lu:closure:buckle | "closure" | "buckle" | "has lexical unit" |  | "FN" |  |
| fn:closure | fn:HasLexicalUnit | fn:lu:closure:cap | "closure" | "cap" | "has lexical unit" |  | "FN" |  |
| fn:closure | fn:HasLexicalUnit | fn:lu:closure:zip | "closure" | "zip" | "has lexical unit" |  | "FN" |  |
| fn:closure | fn:HasLexicalUnit | fn:lu:closure:lace | "closure" | "lace" | "has lexical unit" |  | "FN" |  |
| fn:closure | fn:HasLexicalUnit | fn:lu:closure:unzip | "closure" | "unzip" | "has lexical unit" |  | "FN" |  |
| fn:closure | fn:HasLexicalUnit | fn:lu:closure:unbuckle | "closure" | "unbuckle" | "has lexical unit" |  | "FN" |  |
| fn:closure | fn:HasLexicalUnit | fn:lu:closure:uncork | "closure" | "uncork" | "has lexical unit" |  | "FN" |  |
| fn:closure | fn:HasLexicalUnit | fn:lu:closure:unscrew | "closure" | "unscrew" | "has lexical unit" |  | "FN" |  |
| fn:closure | fn:HasLexicalUnit | fn:lu:closure:seal | "closure" | "seal" | "has lexical unit" |  | "FN" |  |
| fn:closure | fn:HasLexicalUnit | fn:lu:closure:fasten | "closure" | "fasten" | "has lexical unit" |  | "FN" |  |
| fn:closure | fn:HasLexicalUnit | fn:lu:closure:unfasten | "closure" | "unfasten" | "has lexical unit" |  | "FN" |  |
| fn:closure | fn:HasLexicalUnit | fn:lu:closure:tie | "closure" | "tie" | "has lexical unit" |  | "FN" |  |
| fn:closure | /r/HasA | fn:fe:containing_object | "closure" | "containing object" | "/r/has a" |  | "FN" |  |
| fn:closure | /r/HasA | fn:fe:agent | "closure" | "agent" | "/r/has a" |  | "FN" |  |
| fn:closure | /r/HasA | fn:fe:fastener | "closure" | "fastener" | "/r/has a" |  | "FN" |  |
| fn:closure | /r/HasA | fn:fe:enclosed_region | "closure" | "enclosed region" | "/r/has a" |  | "FN" |  |
| fn:closure | /r/HasA | fn:fe:manipulator | "closure" | "manipulator" | "/r/has a" |  | "FN" |  |
| fn:closure | /r/HasA | fn:fe:container_portal | "closure" | "container portal" | "/r/has a" |  | "FN" |  |
| fn:closure | /r/HasA | fn:fe:degree | "closure" | "degree" | "/r/has a" |  | "FN" |  |
| fn:closure | /r/HasA | fn:fe:instrument | "closure" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:closure | /r/HasA | fn:fe:manner | "closure" | "manner" | "/r/has a" |  | "FN" |  |
| fn:closure | /r/HasA | fn:fe:means | "closure" | "means" | "/r/has a" |  | "FN" |  |
| fn:closure | /r/HasA | fn:fe:place | "closure" | "place" | "/r/has a" |  | "FN" |  |
| fn:closure | /r/HasA | fn:fe:time | "closure" | "time" | "/r/has a" |  | "FN" |  |
| fn:closure | /r/HasA | fn:fe:result | "closure" | "result" | "/r/has a" |  | "FN" |  |
| fn:closure | /r/HasA | fn:fe:beneficiary | "closure" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:closure | /r/HasA | fn:fe:circumstances | "closure" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:closure | /r/HasA | fn:fe:depictive | "closure" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:clothing | /r/IsA | fn:artifact | "clothing" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:closure | /r/UsedFor | fn:clothing | "closure" | "clothing" | "/r/used for" |  | "FN" |  |
| fn:clothing | /r/UsedFor | fn:clothing_parts | "clothing" | "clothing parts" | "/r/used for" |  | "FN" |  |
| fn:clothing | /r/UsedFor | fn:dressing | "clothing" | "dressing" | "/r/used for" |  | "FN" |  |
| fn:clothing | /r/UsedFor | fn:undressing | "clothing" | "undressing" | "/r/used for" |  | "FN" |  |
| fn:clothing | /r/UsedFor | fn:wearing | "clothing" | "wearing" | "/r/used for" |  | "FN" |  |
| fn:clothing | /r/SimilarTo | fn:armor | "clothing" | "armor" | "/r/similar to" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:dress | "clothing" | "dress" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:frock | "clothing" | "frock" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:petticoat | "clothing" | "petticoat" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:ballgown | "clothing" | "ballgown" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:culottes | "clothing" | "culottes" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:chemise | "clothing" | "chemise" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:jodhpurs | "clothing" | "jodhpurs" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:sock | "clothing" | "sock" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:stocking | "clothing" | "stocking" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:leggings | "clothing" | "leggings" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:tunic | "clothing" | "tunic" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:slip | "clothing" | "slip" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:gown | "clothing" | "gown" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:skirt | "clothing" | "skirt" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:shorts | "clothing" | "shorts" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:pants | "clothing" | "pants" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:trousers | "clothing" | "trousers" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:wrap | "clothing" | "wrap" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:shirt | "clothing" | "shirt" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:blouse | "clothing" | "blouse" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:cloak | "clothing" | "cloak" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:cape | "clothing" | "cape" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:coat | "clothing" | "coat" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:greatcoat | "clothing" | "greatcoat" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:overcoat | "clothing" | "overcoat" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:jacket | "clothing" | "jacket" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:vest | "clothing" | "vest" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:tie | "clothing" | "tie" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:hose | "clothing" | "hose" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:hosiery | "clothing" | "hosiery" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:clothing | "clothing" | "clothing" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:clothes | "clothing" | "clothes" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:finery | "clothing" | "finery" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:suit | "clothing" | "suit" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:necktie | "clothing" | "necktie" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:neckwear | "clothing" | "neckwear" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:cummerbund | "clothing" | "cummerbund" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:scarf | "clothing" | "scarf" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:shawl | "clothing" | "shawl" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:bow-tie | "clothing" | "bow-tie" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:pantyhose | "clothing" | "pantyhose" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:garter | "clothing" | "garter" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:panties | "clothing" | "panties" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:knickers | "clothing" | "knickers" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:sweater | "clothing" | "sweater" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:jumper | "clothing" | "jumper" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:cardigan | "clothing" | "cardigan" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:pullover | "clothing" | "pullover" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:blazer | "clothing" | "blazer" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:kilt | "clothing" | "kilt" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:swimsuit | "clothing" | "swimsuit" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:bikini | "clothing" | "bikini" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:robe | "clothing" | "robe" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:bathrobe | "clothing" | "bathrobe" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:apron | "clothing" | "apron" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:miniskirt | "clothing" | "miniskirt" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:fishnet | "clothing" | "fishnet" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:legwarmers | "clothing" | "legwarmers" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:regalia | "clothing" | "regalia" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:raiment | "clothing" | "raiment" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:apparel | "clothing" | "apparel" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:attire | "clothing" | "attire" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:vestment | "clothing" | "vestment" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:livery | "clothing" | "livery" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:outfit | "clothing" | "outfit" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:garment | "clothing" | "garment" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:undergarment | "clothing" | "undergarment" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:underclothing | "clothing" | "underclothing" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:underclothes | "clothing" | "underclothes" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:underwear | "clothing" | "underwear" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:togs | "clothing" | "togs" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:undies | "clothing" | "undies" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:shift | "clothing" | "shift" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:pinafore | "clothing" | "pinafore" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:mitten | "clothing" | "mitten" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:mitt | "clothing" | "mitt" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:glove | "clothing" | "glove" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:bodice | "clothing" | "bodice" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:corset | "clothing" | "corset" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:parka | "clothing" | "parka" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:windbreaker | "clothing" | "windbreaker" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:windcheater | "clothing" | "windcheater" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:raincoat | "clothing" | "raincoat" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:pyjama | "clothing" | "pyjama" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:nightie | "clothing" | "nightie" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:nightdress | "clothing" | "nightdress" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:nightgown | "clothing" | "nightgown" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:nightwear | "clothing" | "nightwear" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:lingerie | "clothing" | "lingerie" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:camisole | "clothing" | "camisole" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:waistcoat | "clothing" | "waistcoat" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:jeans | "clothing" | "jeans" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:overall | "clothing" | "overall" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:coverall | "clothing" | "coverall" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:garb | "clothing" | "garb" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:smock | "clothing" | "smock" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:sundress | "clothing" | "sundress" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:bra | "clothing" | "bra" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:brassiere | "clothing" | "brassiere" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:teddy | "clothing" | "teddy" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:tights | "clothing" | "tights" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:jumpsuit | "clothing" | "jumpsuit" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:kimono | "clothing" | "kimono" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:kaftan | "clothing" | "kaftan" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:uniform | "clothing" | "uniform" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:costume | "clothing" | "costume" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:motley | "clothing" | "motley" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:get-up | "clothing" | "get-up" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:ensemble | "clothing" | "ensemble" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:surplice | "clothing" | "surplice" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:galosh | "clothing" | "galosh" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:welly | "clothing" | "welly" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:wellington | "clothing" | "wellington" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:slipper | "clothing" | "slipper" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:sandal | "clothing" | "sandal" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:sneaker | "clothing" | "sneaker" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:stiletto | "clothing" | "stiletto" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:boot | "clothing" | "boot" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:shoe | "clothing" | "shoe" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:gumboot | "clothing" | "gumboot" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:clog | "clothing" | "clog" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:footwear | "clothing" | "footwear" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:sari | "clothing" | "sari" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:sarong | "clothing" | "sarong" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:poncho | "clothing" | "poncho" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:abaya | "clothing" | "abaya" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:jerkin | "clothing" | "jerkin" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:crinoline | "clothing" | "crinoline" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:muff | "clothing" | "muff" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:cowl | "clothing" | "cowl" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:tutu | "clothing" | "tutu" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:t-shirt | "clothing" | "t-shirt" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:polo-neck | "clothing" | "polo-neck" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:g-string | "clothing" | "g-string" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:flip-flops | "clothing" | "flip-flops" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:one-piece | "clothing" | "one-piece" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:two-piece | "clothing" | "two-piece" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:flannels | "clothing" | "flannels" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:rags | "clothing" | "rags" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:silks | "clothing" | "silks" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:satins | "clothing" | "satins" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:cottons | "clothing" | "cottons" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:tweeds | "clothing" | "tweeds" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:ermines | "clothing" | "ermines" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:muslins | "clothing" | "muslins" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:tippet | "clothing" | "tippet" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:doublet | "clothing" | "doublet" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:tatters | "clothing" | "tatters" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:neckerchief | "clothing" | "neckerchief" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:breeches | "clothing" | "breeches" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:sweatshirt | "clothing" | "sweatshirt" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:sweatpants | "clothing" | "sweatpants" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:tracksuit | "clothing" | "tracksuit" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:alb | "clothing" | "alb" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:stole | "clothing" | "stole" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:chasuble | "clothing" | "chasuble" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:cope | "clothing" | "cope" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:buskin | "clothing" | "buskin" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:pallium | "clothing" | "pallium" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:gauntlet | "clothing" | "gauntlet" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:cravat | "clothing" | "cravat" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:briefs | "clothing" | "briefs" | "has lexical unit" |  | "FN" |  |
| fn:clothing | fn:HasLexicalUnit | fn:lu:clothing:cossie | "clothing" | "cossie" | "has lexical unit" |  | "FN" |  |
| fn:fe:garment | /r/IsA | fn:st:artifact | "garment" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:clothing | /r/HasA | fn:fe:garment | "clothing" | "garment" | "/r/has a" |  | "FN" |  |
| fn:fe:wearer | /r/IsA | fn:st:sentient | "wearer" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:clothing | /r/HasA | fn:fe:wearer | "clothing" | "wearer" | "/r/has a" |  | "FN" |  |
| fn:clothing | /r/HasA | fn:fe:style | "clothing" | "style" | "/r/has a" |  | "FN" |  |
| fn:clothing | /r/HasA | fn:fe:material | "clothing" | "material" | "/r/has a" |  | "FN" |  |
| fn:clothing | /r/HasA | fn:fe:descriptor | "clothing" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:clothing | /r/HasA | fn:fe:subregion | "clothing" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:clothing | /r/HasA | fn:fe:use | "clothing" | "use" | "/r/has a" |  | "FN" |  |
| fn:clothing | /r/HasA | fn:fe:body_location | "clothing" | "body location" | "/r/has a" |  | "FN" |  |
| fn:clothing | /r/HasA | fn:fe:creator | "clothing" | "creator" | "/r/has a" |  | "FN" |  |
| fn:clothing | /r/HasA | fn:fe:time_of_creation | "clothing" | "time of creation" | "/r/has a" |  | "FN" |  |
| fn:clothing | /r/HasA | fn:fe:name | "clothing" | "name" | "/r/has a" |  | "FN" |  |
| fn:clothing | /r/UsedFor | fn:clothing_parts | "clothing" | "clothing parts" | "/r/used for" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:bootlace | "clothing parts" | "bootlace" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:shoelace | "clothing parts" | "shoelace" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:lace | "clothing parts" | "lace" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:button | "clothing parts" | "button" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:zip | "clothing parts" | "zip" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:zipper | "clothing parts" | "zipper" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:buckle | "clothing parts" | "buckle" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:snap | "clothing parts" | "snap" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:thong | "clothing parts" | "thong" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:collar | "clothing parts" | "collar" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:neck | "clothing parts" | "neck" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:sleeve | "clothing parts" | "sleeve" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:cuff | "clothing parts" | "cuff" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:waist | "clothing parts" | "waist" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:tassel | "clothing parts" | "tassel" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:fringe | "clothing parts" | "fringe" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:pocket | "clothing parts" | "pocket" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:braid | "clothing parts" | "braid" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:seat | "clothing parts" | "seat" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:leg | "clothing parts" | "leg" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:sash | "clothing parts" | "sash" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:strap | "clothing parts" | "strap" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:hood | "clothing parts" | "hood" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:cowl | "clothing parts" | "cowl" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:skirt | "clothing parts" | "skirt" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:breastplate | "clothing parts" | "breastplate" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:waist-band | "clothing parts" | "waist-band" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:clasp | "clothing parts" | "clasp" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:seam | "clothing parts" | "seam" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:placket | "clothing parts" | "placket" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:monogram | "clothing parts" | "monogram" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:decolletage | "clothing parts" | "decolletage" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:cuff-link | "clothing parts" | "cuff-link" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:hem | "clothing parts" | "hem" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:insole | "clothing parts" | "insole" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:waistband | "clothing parts" | "waistband" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:waistline | "clothing parts" | "waistline" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:sole | "clothing parts" | "sole" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:brim | "clothing parts" | "brim" | "has lexical unit" |  | "FN" |  |
| fn:clothing_parts | fn:HasLexicalUnit | fn:lu:clothing_parts:neckband | "clothing parts" | "neckband" | "has lexical unit" |  | "FN" |  |
| fn:fe:clothing | /r/IsA | fn:st:artifact | "clothing" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:clothing_parts | /r/HasA | fn:fe:clothing | "clothing parts" | "clothing" | "/r/has a" |  | "FN" |  |
| fn:fe:subpart | /r/IsA | fn:st:artifact | "subpart" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:clothing_parts | /r/HasA | fn:fe:subpart | "clothing parts" | "subpart" | "/r/has a" |  | "FN" |  |
| fn:clothing_parts | /r/HasA | fn:fe:material | "clothing parts" | "material" | "/r/has a" |  | "FN" |  |
| fn:clothing_parts | /r/HasA | fn:fe:subregion | "clothing parts" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:clothing_parts | /r/HasA | fn:fe:wearer | "clothing parts" | "wearer" | "/r/has a" |  | "FN" |  |
| fn:clothing_parts | /r/HasA | fn:fe:body_location | "clothing parts" | "body location" | "/r/has a" |  | "FN" |  |
| fn:clothing_parts | /r/HasA | fn:fe:descriptor | "clothing parts" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:co-association | fn:HasLexicalUnit | fn:lu:co-association:associate | "co-association" | "associate" | "has lexical unit" |  | "FN" |  |
| fn:co-association | fn:HasLexicalUnit | fn:lu:co-association:colleague | "co-association" | "colleague" | "has lexical unit" |  | "FN" |  |
| fn:co-association | fn:HasLexicalUnit | fn:lu:co-association:co-worker | "co-association" | "co-worker" | "has lexical unit" |  | "FN" |  |
| fn:co-association | fn:HasLexicalUnit | fn:lu:co-association:countryman | "co-association" | "countryman" | "has lexical unit" |  | "FN" |  |
| fn:co-association | fn:HasLexicalUnit | fn:lu:co-association:partner | "co-association" | "partner" | "has lexical unit" |  | "FN" |  |
| fn:co-association | fn:HasLexicalUnit | fn:lu:co-association:co-religionist | "co-association" | "co-religionist" | "has lexical unit" |  | "FN" |  |
| fn:co-association | fn:HasLexicalUnit | fn:lu:co-association:fellow | "co-association" | "fellow" | "has lexical unit" |  | "FN" |  |
| fn:co-association | fn:HasLexicalUnit | fn:lu:co-association:comrade | "co-association" | "comrade" | "has lexical unit" |  | "FN" |  |
| fn:co-association | fn:HasLexicalUnit | fn:lu:co-association:brother | "co-association" | "brother" | "has lexical unit" |  | "FN" |  |
| fn:co-association | fn:HasLexicalUnit | fn:lu:co-association:sister | "co-association" | "sister" | "has lexical unit" |  | "FN" |  |
| fn:co-association | /r/HasA | fn:fe:participant1 | "co-association" | "participant1" | "/r/has a" |  | "FN" |  |
| fn:co-association | /r/HasA | fn:fe:participants | "co-association" | "participants" | "/r/has a" |  | "FN" |  |
| fn:co-association | /r/HasA | fn:fe:participant2 | "co-association" | "participant2" | "/r/has a" |  | "FN" |  |
| fn:co-association | /r/HasA | fn:fe:place | "co-association" | "place" | "/r/has a" |  | "FN" |  |
| fn:co-association | /r/HasA | fn:fe:time | "co-association" | "time" | "/r/has a" |  | "FN" |  |
| fn:co-association | /r/HasA | fn:fe:institution | "co-association" | "institution" | "/r/has a" |  | "FN" |  |
| fn:assessing | /r/IsA | fn:cogitation | "assessing" | "cogitation" | "/r/is a" |  | "FN" |  |
| fn:emotion_active | /r/IsA | fn:cogitation | "emotion active" | "cogitation" | "/r/is a" |  | "FN" |  |
| fn:memorization | /r/IsA | fn:cogitation | "memorization" | "cogitation" | "/r/is a" |  | "FN" |  |
| fn:cogitation | /r/UsedFor | fn:remembering_experience | "cogitation" | "remembering experience" | "/r/used for" |  | "FN" |  |
| fn:cogitation | /r/UsedFor | fn:research | "cogitation" | "research" | "/r/used for" |  | "FN" |  |
| fn:mental_activity | /r/UsedFor | fn:cogitation | "mental activity" | "cogitation" | "/r/used for" |  | "FN" |  |
| fn:cogitation | fn:HasLexicalUnit | fn:lu:cogitation:brood | "cogitation" | "brood" | "has lexical unit" |  | "FN" |  |
| fn:cogitation | fn:HasLexicalUnit | fn:lu:cogitation:consider | "cogitation" | "consider" | "has lexical unit" |  | "FN" |  |
| fn:cogitation | fn:HasLexicalUnit | fn:lu:cogitation:consideration | "cogitation" | "consideration" | "has lexical unit" |  | "FN" |  |
| fn:cogitation | fn:HasLexicalUnit | fn:lu:cogitation:contemplate | "cogitation" | "contemplate" | "has lexical unit" |  | "FN" |  |
| fn:cogitation | fn:HasLexicalUnit | fn:lu:cogitation:contemplation | "cogitation" | "contemplation" | "has lexical unit" |  | "FN" |  |
| fn:cogitation | fn:HasLexicalUnit | fn:lu:cogitation:deliberate | "cogitation" | "deliberate" | "has lexical unit" |  | "FN" |  |
| fn:cogitation | fn:HasLexicalUnit | fn:lu:cogitation:deliberation | "cogitation" | "deliberation" | "has lexical unit" |  | "FN" |  |
| fn:cogitation | fn:HasLexicalUnit | fn:lu:cogitation:dwell | "cogitation" | "dwell" | "has lexical unit" |  | "FN" |  |
| fn:cogitation | fn:HasLexicalUnit | fn:lu:cogitation:meditate | "cogitation" | "meditate" | "has lexical unit" |  | "FN" |  |
| fn:cogitation | fn:HasLexicalUnit | fn:lu:cogitation:meditation | "cogitation" | "meditation" | "has lexical unit" |  | "FN" |  |
| fn:cogitation | fn:HasLexicalUnit | fn:lu:cogitation:mull_over | "cogitation" | "mull over" | "has lexical unit" |  | "FN" |  |
| fn:cogitation | fn:HasLexicalUnit | fn:lu:cogitation:muse | "cogitation" | "muse" | "has lexical unit" |  | "FN" |  |
| fn:cogitation | fn:HasLexicalUnit | fn:lu:cogitation:ponder | "cogitation" | "ponder" | "has lexical unit" |  | "FN" |  |
| fn:cogitation | fn:HasLexicalUnit | fn:lu:cogitation:reflect | "cogitation" | "reflect" | "has lexical unit" |  | "FN" |  |
| fn:cogitation | fn:HasLexicalUnit | fn:lu:cogitation:reflection | "cogitation" | "reflection" | "has lexical unit" |  | "FN" |  |
| fn:cogitation | fn:HasLexicalUnit | fn:lu:cogitation:ruminate | "cogitation" | "ruminate" | "has lexical unit" |  | "FN" |  |
| fn:cogitation | fn:HasLexicalUnit | fn:lu:cogitation:wonder | "cogitation" | "wonder" | "has lexical unit" |  | "FN" |  |
| fn:cogitation | fn:HasLexicalUnit | fn:lu:cogitation:think | "cogitation" | "think" | "has lexical unit" |  | "FN" |  |
| fn:cogitation | fn:HasLexicalUnit | fn:lu:cogitation:give_thought | "cogitation" | "give thought" | "has lexical unit" |  | "FN" |  |
| fn:cogitation | fn:HasLexicalUnit | fn:lu:cogitation:thought | "cogitation" | "thought" | "has lexical unit" |  | "FN" |  |
| fn:cogitation | /r/HasA | fn:fe:cognizer | "cogitation" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:cogitation | /r/HasA | fn:fe:topic | "cogitation" | "topic" | "/r/has a" |  | "FN" |  |
| fn:cogitation | /r/HasA | fn:fe:degree | "cogitation" | "degree" | "/r/has a" |  | "FN" |  |
| fn:cogitation | /r/HasA | fn:fe:depictive | "cogitation" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:cogitation | /r/HasA | fn:fe:manner | "cogitation" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cogitation | /r/HasA | fn:fe:means | "cogitation" | "means" | "/r/has a" |  | "FN" |  |
| fn:cogitation | /r/HasA | fn:fe:result | "cogitation" | "result" | "/r/has a" |  | "FN" |  |
| fn:cogitation | /r/HasA | fn:fe:medium | "cogitation" | "medium" | "/r/has a" |  | "FN" |  |
| fn:cogitation | /r/HasA | fn:fe:purpose | "cogitation" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cogitation | /r/HasA | fn:fe:time | "cogitation" | "time" | "/r/has a" |  | "FN" |  |
| fn:being_relevant | /r/IsA | fn:cognitive_connection | "being relevant" | "cognitive connection" | "/r/is a" |  | "FN" |  |
| fn:relating_concepts | /r/IsA | fn:cognitive_connection | "relating concepts" | "cognitive connection" | "/r/is a" |  | "FN" |  |
| fn:cognitive_connection | /r/UsedFor | fn:conditional_scenario | "cognitive connection" | "conditional scenario" | "/r/used for" |  | "FN" |  |
| fn:cognitive_connection | /r/UsedFor | fn:make_cognitive_connection | "cognitive connection" | "make cognitive connection" | "/r/used for" |  | "FN" |  |
| fn:make_cognitive_connection | /r/SimilarTo | fn:cognitive_connection | "make cognitive connection" | "cognitive connection" | "/r/similar to" |  | "FN" |  |
| fn:cognitive_connection | fn:HasLexicalUnit | fn:lu:cognitive_connection:linked | "cognitive connection" | "linked" | "has lexical unit" |  | "FN" |  |
| fn:cognitive_connection | fn:HasLexicalUnit | fn:lu:cognitive_connection:tied | "cognitive connection" | "tied" | "has lexical unit" |  | "FN" |  |
| fn:cognitive_connection | fn:HasLexicalUnit | fn:lu:cognitive_connection:connected | "cognitive connection" | "connected" | "has lexical unit" |  | "FN" |  |
| fn:cognitive_connection | fn:HasLexicalUnit | fn:lu:cognitive_connection:related | "cognitive connection" | "related" | "has lexical unit" |  | "FN" |  |
| fn:cognitive_connection | fn:HasLexicalUnit | fn:lu:cognitive_connection:associated | "cognitive connection" | "associated" | "has lexical unit" |  | "FN" |  |
| fn:cognitive_connection | fn:HasLexicalUnit | fn:lu:cognitive_connection:relationship | "cognitive connection" | "relationship" | "has lexical unit" |  | "FN" |  |
| fn:cognitive_connection | fn:HasLexicalUnit | fn:lu:cognitive_connection:identify_with | "cognitive connection" | "identify with" | "has lexical unit" |  | "FN" |  |
| fn:cognitive_connection | fn:HasLexicalUnit | fn:lu:cognitive_connection:have_to_do_(with) | "cognitive connection" | "have to do (with)" | "has lexical unit" |  | "FN" |  |
| fn:fe:concept_1 | /r/RelatedTo | fn:fe:concepts | "concept 1" | "concepts" | "/r/related to" |  | "FN" |  |
| fn:cognitive_connection | /r/HasA | fn:fe:concept_1 | "cognitive connection" | "concept 1" | "/r/has a" |  | "FN" |  |
| fn:fe:concept_2 | /r/RelatedTo | fn:fe:concepts | "concept 2" | "concepts" | "/r/related to" |  | "FN" |  |
| fn:cognitive_connection | /r/HasA | fn:fe:concept_2 | "cognitive connection" | "concept 2" | "/r/has a" |  | "FN" |  |
| fn:cognitive_connection | /r/HasA | fn:fe:point_of_view | "cognitive connection" | "point of view" | "/r/has a" |  | "FN" |  |
| fn:cognitive_connection | /r/HasA | fn:fe:circumstances | "cognitive connection" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:cognitive_connection | /r/HasA | fn:fe:concepts | "cognitive connection" | "concepts" | "/r/has a" |  | "FN" |  |
| fn:cognitive_connection | /r/HasA | fn:fe:degree | "cognitive connection" | "degree" | "/r/has a" |  | "FN" |  |
| fn:cognitive_connection | /r/HasA | fn:fe:specification | "cognitive connection" | "specification" | "/r/has a" |  | "FN" |  |
| fn:cognitive_impact | fn:HasLexicalUnit | fn:lu:cognitive_impact:strike | "cognitive impact" | "strike" | "has lexical unit" |  | "FN" |  |
| fn:cognitive_impact | fn:HasLexicalUnit | fn:lu:cognitive_impact:hit | "cognitive impact" | "hit" | "has lexical unit" |  | "FN" |  |
| fn:cognitive_impact | /r/HasA | fn:fe:phenomenon | "cognitive impact" | "phenomenon" | "/r/has a" |  | "FN" |  |
| fn:cognitive_impact | /r/HasA | fn:fe:experiencer | "cognitive impact" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:cognitive_impact | /r/HasA | fn:fe:judgment | "cognitive impact" | "judgment" | "/r/has a" |  | "FN" |  |
| fn:cognitive_impact | /r/HasA | fn:fe:circumstances | "cognitive impact" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:cognitive_impact | /r/HasA | fn:fe:manner | "cognitive impact" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cognitive_impact | /r/HasA | fn:fe:frequency | "cognitive impact" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:coincidence | /r/IsA | fn:event | "coincidence" | "event" | "/r/is a" |  | "FN" |  |
| fn:coincidence | fn:HasLexicalUnit | fn:lu:coincidence:coincidence | "coincidence" | "coincidence" | "has lexical unit" |  | "FN" |  |
| fn:coincidence | fn:HasLexicalUnit | fn:lu:coincidence:happenstance | "coincidence" | "happenstance" | "has lexical unit" |  | "FN" |  |
| fn:coincidence | fn:HasLexicalUnit | fn:lu:coincidence:accident | "coincidence" | "accident" | "has lexical unit" |  | "FN" |  |
| fn:coincidence | fn:HasLexicalUnit | fn:lu:coincidence:happen | "coincidence" | "happen" | "has lexical unit" |  | "FN" |  |
| fn:coincidence | fn:HasLexicalUnit | fn:lu:coincidence:chance | "coincidence" | "chance" | "has lexical unit" |  | "FN" |  |
| fn:coincidence | fn:HasLexicalUnit | fn:lu:coincidence:chance | "coincidence" | "chance" | "has lexical unit" |  | "FN" |  |
| fn:coincidence | fn:HasLexicalUnit | fn:lu:coincidence:random | "coincidence" | "random" | "has lexical unit" |  | "FN" |  |
| fn:coincidence | fn:HasLexicalUnit | fn:lu:coincidence:chance | "coincidence" | "chance" | "has lexical unit" |  | "FN" |  |
| fn:coincidence | fn:HasLexicalUnit | fn:lu:coincidence:randomly | "coincidence" | "randomly" | "has lexical unit" |  | "FN" |  |
| fn:coincidence | /r/HasA | fn:fe:state_of_affairs | "coincidence" | "state of affairs" | "/r/has a" |  | "FN" |  |
| fn:coincidence | /r/HasA | fn:fe:time | "coincidence" | "time" | "/r/has a" |  | "FN" |  |
| fn:coincidence | /r/HasA | fn:fe:place | "coincidence" | "place" | "/r/has a" |  | "FN" |  |
| fn:coincidence | /r/HasA | fn:fe:manner | "coincidence" | "manner" | "/r/has a" |  | "FN" |  |
| fn:collaboration | /r/IsA | fn:intentionally_act | "collaboration" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:collaboration | /r/IsA | fn:reciprocality | "collaboration" | "reciprocality" | "/r/is a" |  | "FN" |  |
| fn:collaboration | fn:HasLexicalUnit | fn:lu:collaboration:collaborate | "collaboration" | "collaborate" | "has lexical unit" |  | "FN" |  |
| fn:collaboration | fn:HasLexicalUnit | fn:lu:collaboration:partner | "collaboration" | "partner" | "has lexical unit" |  | "FN" |  |
| fn:collaboration | fn:HasLexicalUnit | fn:lu:collaboration:collaborator | "collaboration" | "collaborator" | "has lexical unit" |  | "FN" |  |
| fn:collaboration | fn:HasLexicalUnit | fn:lu:collaboration:partner | "collaboration" | "partner" | "has lexical unit" |  | "FN" |  |
| fn:collaboration | fn:HasLexicalUnit | fn:lu:collaboration:in_cahoots | "collaboration" | "in cahoots" | "has lexical unit" |  | "FN" |  |
| fn:collaboration | fn:HasLexicalUnit | fn:lu:collaboration:conspire | "collaboration" | "conspire" | "has lexical unit" |  | "FN" |  |
| fn:collaboration | fn:HasLexicalUnit | fn:lu:collaboration:collaboration | "collaboration" | "collaboration" | "has lexical unit" |  | "FN" |  |
| fn:collaboration | fn:HasLexicalUnit | fn:lu:collaboration:associate | "collaboration" | "associate" | "has lexical unit" |  | "FN" |  |
| fn:collaboration | fn:HasLexicalUnit | fn:lu:collaboration:confederate | "collaboration" | "confederate" | "has lexical unit" |  | "FN" |  |
| fn:collaboration | fn:HasLexicalUnit | fn:lu:collaboration:conspiracy | "collaboration" | "conspiracy" | "has lexical unit" |  | "FN" |  |
| fn:collaboration | fn:HasLexicalUnit | fn:lu:collaboration:collude | "collaboration" | "collude" | "has lexical unit" |  | "FN" |  |
| fn:collaboration | fn:HasLexicalUnit | fn:lu:collaboration:collusion | "collaboration" | "collusion" | "has lexical unit" |  | "FN" |  |
| fn:collaboration | fn:HasLexicalUnit | fn:lu:collaboration:team_up | "collaboration" | "team up" | "has lexical unit" |  | "FN" |  |
| fn:collaboration | fn:HasLexicalUnit | fn:lu:collaboration:cooperate | "collaboration" | "cooperate" | "has lexical unit" |  | "FN" |  |
| fn:collaboration | fn:HasLexicalUnit | fn:lu:collaboration:cooperation | "collaboration" | "cooperation" | "has lexical unit" |  | "FN" |  |
| fn:collaboration | fn:HasLexicalUnit | fn:lu:collaboration:affiliated | "collaboration" | "affiliated" | "has lexical unit" |  | "FN" |  |
| fn:collaboration | fn:HasLexicalUnit | fn:lu:collaboration:in_league | "collaboration" | "in league" | "has lexical unit" |  | "FN" |  |
| fn:collaboration | fn:HasLexicalUnit | fn:lu:collaboration:jointly | "collaboration" | "jointly" | "has lexical unit" |  | "FN" |  |
| fn:collaboration | fn:HasLexicalUnit | fn:lu:collaboration:work_together | "collaboration" | "work together" | "has lexical unit" |  | "FN" |  |
| fn:collaboration | fn:HasLexicalUnit | fn:lu:collaboration:together | "collaboration" | "together" | "has lexical unit" |  | "FN" |  |
| fn:fe:partner_1 | /r/IsA | fn:st:human | "partner 1" | "human" | "/r/is a" |  | "FN" |  |
| fn:fe:partner_1 | /r/HasPrerequisite | fn:fe:partner_2 | "partner 1" | "partner 2" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:partner_1 | /r/RelatedTo | fn:fe:partners | "partner 1" | "partners" | "/r/related to" |  | "FN" |  |
| fn:collaboration | /r/HasA | fn:fe:partner_1 | "collaboration" | "partner 1" | "/r/has a" |  | "FN" |  |
| fn:fe:partner_2 | /r/IsA | fn:st:human | "partner 2" | "human" | "/r/is a" |  | "FN" |  |
| fn:fe:partner_2 | /r/HasPrerequisite | fn:fe:partner_1 | "partner 2" | "partner 1" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:partner_2 | /r/RelatedTo | fn:fe:partners | "partner 2" | "partners" | "/r/related to" |  | "FN" |  |
| fn:collaboration | /r/HasA | fn:fe:partner_2 | "collaboration" | "partner 2" | "/r/has a" |  | "FN" |  |
| fn:collaboration | /r/HasA | fn:fe:undertaking | "collaboration" | "undertaking" | "/r/has a" |  | "FN" |  |
| fn:collaboration | /r/HasA | fn:fe:manner | "collaboration" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fe:partners | /r/IsA | fn:st:human | "partners" | "human" | "/r/is a" |  | "FN" |  |
| fn:collaboration | /r/HasA | fn:fe:partners | "collaboration" | "partners" | "/r/has a" |  | "FN" |  |
| fn:collaboration | /r/HasA | fn:fe:time | "collaboration" | "time" | "/r/has a" |  | "FN" |  |
| fn:collaboration | /r/HasA | fn:fe:place | "collaboration" | "place" | "/r/has a" |  | "FN" |  |
| fn:collaboration | /r/HasA | fn:fe:duration | "collaboration" | "duration" | "/r/has a" |  | "FN" |  |
| fn:collaboration | /r/HasA | fn:fe:degree | "collaboration" | "degree" | "/r/has a" |  | "FN" |  |
| fn:collaboration | /r/HasA | fn:fe:means | "collaboration" | "means" | "/r/has a" |  | "FN" |  |
| fn:collocation_image_schema | /r/IsA | fn:image_schema | "collocation image schema" | "image schema" | "/r/is a" |  | "FN" |  |
| fn:collocation_image_schema | /r/UsedFor | fn:spatial_co-location | "collocation image schema" | "spatial co-location" | "/r/used for" |  | "FN" |  |
| fn:proximity_image_schema | /r/RelatedTo | fn:collocation_image_schema | "proximity image schema" | "collocation image schema" | "/r/related to" |  | "FN" |  |
| fn:collocation_image_schema | /r/HasA | fn:fe:profiled_region | "collocation image schema" | "profiled region" | "/r/has a" |  | "FN" |  |
| fn:collocation_image_schema | /r/HasA | fn:fe:ground | "collocation image schema" | "ground" | "/r/has a" |  | "FN" |  |
| fn:residence | /r/UsedFor | fn:colonization | "residence" | "colonization" | "/r/used for" |  | "FN" |  |
| fn:colonization | fn:HasLexicalUnit | fn:lu:colonization:colonize | "colonization" | "colonize" | "has lexical unit" |  | "FN" |  |
| fn:colonization | fn:HasLexicalUnit | fn:lu:colonization:colonist | "colonization" | "colonist" | "has lexical unit" |  | "FN" |  |
| fn:colonization | fn:HasLexicalUnit | fn:lu:colonization:colony | "colonization" | "colony" | "has lexical unit" |  | "FN" |  |
| fn:colonization | fn:HasLexicalUnit | fn:lu:colonization:settle | "colonization" | "settle" | "has lexical unit" |  | "FN" |  |
| fn:colonization | fn:HasLexicalUnit | fn:lu:colonization:settlement_[act] | "colonization" | "settlement [act]" | "has lexical unit" |  | "FN" |  |
| fn:colonization | fn:HasLexicalUnit | fn:lu:colonization:settlement_[entity] | "colonization" | "settlement [entity]" | "has lexical unit" |  | "FN" |  |
| fn:colonization | fn:HasLexicalUnit | fn:lu:colonization:settler | "colonization" | "settler" | "has lexical unit" |  | "FN" |  |
| fn:colonization | fn:HasLexicalUnit | fn:lu:colonization:people | "colonization" | "people" | "has lexical unit" |  | "FN" |  |
| fn:colonization | fn:HasLexicalUnit | fn:lu:colonization:populate | "colonization" | "populate" | "has lexical unit" |  | "FN" |  |
| fn:colonization | fn:HasLexicalUnit | fn:lu:colonization:repopulate | "colonization" | "repopulate" | "has lexical unit" |  | "FN" |  |
| fn:colonization | /r/HasA | fn:fe:colonists | "colonization" | "colonists" | "/r/has a" |  | "FN" |  |
| fn:colonization | /r/HasA | fn:fe:homeland | "colonization" | "homeland" | "/r/has a" |  | "FN" |  |
| fn:colonization | /r/HasA | fn:fe:new_area | "colonization" | "new area" | "/r/has a" |  | "FN" |  |
| fn:colonization | /r/HasA | fn:fe:time | "colonization" | "time" | "/r/has a" |  | "FN" |  |
| fn:colonization | /r/HasA | fn:fe:degree | "colonization" | "degree" | "/r/has a" |  | "FN" |  |
| fn:colonization | /r/HasA | fn:fe:purpose | "colonization" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:colonization | /r/HasA | fn:fe:descriptor | "colonization" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:colonization | /r/HasA | fn:fe:explanation | "colonization" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:color | /r/IsA | fn:gradable_attributes | "color" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:color | fn:HasLexicalUnit | fn:lu:color:red | "color" | "red" | "has lexical unit" |  | "FN" |  |
| fn:color | fn:HasLexicalUnit | fn:lu:color:green | "color" | "green" | "has lexical unit" |  | "FN" |  |
| fn:color | fn:HasLexicalUnit | fn:lu:color:color | "color" | "color" | "has lexical unit" |  | "FN" |  |
| fn:color | fn:HasLexicalUnit | fn:lu:color:vermilion | "color" | "vermilion" | "has lexical unit" |  | "FN" |  |
| fn:color | fn:HasLexicalUnit | fn:lu:color:ebony | "color" | "ebony" | "has lexical unit" |  | "FN" |  |
| fn:color | fn:HasLexicalUnit | fn:lu:color:purple | "color" | "purple" | "has lexical unit" |  | "FN" |  |
| fn:color | fn:HasLexicalUnit | fn:lu:color:blue | "color" | "blue" | "has lexical unit" |  | "FN" |  |
| fn:color | fn:HasLexicalUnit | fn:lu:color:orange | "color" | "orange" | "has lexical unit" |  | "FN" |  |
| fn:color | fn:HasLexicalUnit | fn:lu:color:yellow | "color" | "yellow" | "has lexical unit" |  | "FN" |  |
| fn:color | fn:HasLexicalUnit | fn:lu:color:violet | "color" | "violet" | "has lexical unit" |  | "FN" |  |
| fn:color | fn:HasLexicalUnit | fn:lu:color:brown | "color" | "brown" | "has lexical unit" |  | "FN" |  |
| fn:color | fn:HasLexicalUnit | fn:lu:color:gray | "color" | "gray" | "has lexical unit" |  | "FN" |  |
| fn:color | fn:HasLexicalUnit | fn:lu:color:black | "color" | "black" | "has lexical unit" |  | "FN" |  |
| fn:color | fn:HasLexicalUnit | fn:lu:color:white | "color" | "white" | "has lexical unit" |  | "FN" |  |
| fn:color | fn:HasLexicalUnit | fn:lu:color:pink | "color" | "pink" | "has lexical unit" |  | "FN" |  |
| fn:color | fn:HasLexicalUnit | fn:lu:color:crimson | "color" | "crimson" | "has lexical unit" |  | "FN" |  |
| fn:color | fn:HasLexicalUnit | fn:lu:color:maroon | "color" | "maroon" | "has lexical unit" |  | "FN" |  |
| fn:color | fn:HasLexicalUnit | fn:lu:color:turquoise | "color" | "turquoise" | "has lexical unit" |  | "FN" |  |
| fn:color | fn:HasLexicalUnit | fn:lu:color:azure | "color" | "azure" | "has lexical unit" |  | "FN" |  |
| fn:color | fn:HasLexicalUnit | fn:lu:color:beige | "color" | "beige" | "has lexical unit" |  | "FN" |  |
| fn:color | fn:HasLexicalUnit | fn:lu:color:mauve | "color" | "mauve" | "has lexical unit" |  | "FN" |  |
| fn:color | fn:HasLexicalUnit | fn:lu:color:tan | "color" | "tan" | "has lexical unit" |  | "FN" |  |
| fn:color | fn:HasLexicalUnit | fn:lu:color:buff | "color" | "buff" | "has lexical unit" |  | "FN" |  |
| fn:color | fn:HasLexicalUnit | fn:lu:color:scarlet | "color" | "scarlet" | "has lexical unit" |  | "FN" |  |
| fn:color | fn:HasLexicalUnit | fn:lu:color:pitchblack | "color" | "pitchblack" | "has lexical unit" |  | "FN" |  |
| fn:color | fn:HasLexicalUnit | fn:lu:color:colored | "color" | "colored" | "has lexical unit" |  | "FN" |  |
| fn:color | fn:HasLexicalUnit | fn:lu:color:indigo | "color" | "indigo" | "has lexical unit" |  | "FN" |  |
| fn:color | fn:HasLexicalUnit | fn:lu:color:puce | "color" | "puce" | "has lexical unit" |  | "FN" |  |
| fn:color | /r/HasA | fn:fe:entity | "color" | "entity" | "/r/has a" |  | "FN" |  |
| fn:color | /r/HasA | fn:fe:color | "color" | "color" | "/r/has a" |  | "FN" |  |
| fn:color | /r/HasA | fn:fe:type | "color" | "type" | "/r/has a" |  | "FN" |  |
| fn:color | /r/HasA | fn:fe:comparand | "color" | "comparand" | "/r/has a" |  | "FN" |  |
| fn:color | /r/HasA | fn:fe:color_qualifier | "color" | "color qualifier" | "/r/has a" |  | "FN" |  |
| fn:color | /r/HasA | fn:fe:descriptor | "color" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:color | /r/HasA | fn:fe:cause | "color" | "cause" | "/r/has a" |  | "FN" |  |
| fn:color | /r/HasA | fn:fe:degree | "color" | "degree" | "/r/has a" |  | "FN" |  |
| fn:color | /r/HasA | fn:fe:subregion | "color" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:color | /r/HasA | fn:fe:attribute | "color" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:color_qualities | /r/IsA | fn:gradable_attributes | "color qualities" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:color_qualities | fn:HasLexicalUnit | fn:lu:color_qualities:warm | "color qualities" | "warm" | "has lexical unit" |  | "FN" |  |
| fn:color_qualities | fn:HasLexicalUnit | fn:lu:color_qualities:vivid | "color qualities" | "vivid" | "has lexical unit" |  | "FN" |  |
| fn:color_qualities | fn:HasLexicalUnit | fn:lu:color_qualities:dull | "color qualities" | "dull" | "has lexical unit" |  | "FN" |  |
| fn:color_qualities | fn:HasLexicalUnit | fn:lu:color_qualities:pale | "color qualities" | "pale" | "has lexical unit" |  | "FN" |  |
| fn:color_qualities | fn:HasLexicalUnit | fn:lu:color_qualities:light | "color qualities" | "light" | "has lexical unit" |  | "FN" |  |
| fn:color_qualities | fn:HasLexicalUnit | fn:lu:color_qualities:dark | "color qualities" | "dark" | "has lexical unit" |  | "FN" |  |
| fn:color_qualities | fn:HasLexicalUnit | fn:lu:color_qualities:bright | "color qualities" | "bright" | "has lexical unit" |  | "FN" |  |
| fn:color_qualities | /r/HasA | fn:fe:color | "color qualities" | "color" | "/r/has a" |  | "FN" |  |
| fn:color_qualities | /r/HasA | fn:fe:degree | "color qualities" | "degree" | "/r/has a" |  | "FN" |  |
| fn:color_qualities | /r/HasA | fn:fe:described_entity | "color qualities" | "described entity" | "/r/has a" |  | "FN" |  |
| fn:come_down_with | /r/IsA | fn:eventive_affecting | "come down with" | "eventive affecting" | "/r/is a" |  | "FN" |  |
| fn:come_down_with | fn:HasLexicalUnit | fn:lu:come_down_with:come_down_(with) | "come down with" | "come down (with)" | "has lexical unit" |  | "FN" |  |
| fn:come_down_with | fn:HasLexicalUnit | fn:lu:come_down_with:contract | "come down with" | "contract" | "has lexical unit" |  | "FN" |  |
| fn:come_down_with | fn:HasLexicalUnit | fn:lu:come_down_with:acquire | "come down with" | "acquire" | "has lexical unit" |  | "FN" |  |
| fn:come_down_with | fn:HasLexicalUnit | fn:lu:come_down_with:get | "come down with" | "get" | "has lexical unit" |  | "FN" |  |
| fn:come_down_with | fn:HasLexicalUnit | fn:lu:come_down_with:catch | "come down with" | "catch" | "has lexical unit" |  | "FN" |  |
| fn:come_down_with | /r/HasA | fn:fe:protagonist | "come down with" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:come_down_with | /r/HasA | fn:fe:disease | "come down with" | "disease" | "/r/has a" |  | "FN" |  |
| fn:come_down_with | /r/HasA | fn:fe:source | "come down with" | "source" | "/r/has a" |  | "FN" |  |
| fn:come_down_with | /r/HasA | fn:fe:time | "come down with" | "time" | "/r/has a" |  | "FN" |  |
| fn:come_down_with | /r/HasA | fn:fe:place | "come down with" | "place" | "/r/has a" |  | "FN" |  |
| fn:come_down_with | /r/HasA | fn:fe:manner | "come down with" | "manner" | "/r/has a" |  | "FN" |  |
| fn:come_into_effect | /r/IsA | fn:process_start | "come into effect" | "process start" | "/r/is a" |  | "FN" |  |
| fn:come_into_effect | /r/Causes | fn:being_in_effect | "come into effect" | "being in effect" | "/r/causes" |  | "FN" |  |
| fn:come_into_effect | fn:HasLexicalUnit | fn:lu:come_into_effect:kick_in | "come into effect" | "kick in" | "has lexical unit" |  | "FN" |  |
| fn:come_into_effect | fn:HasLexicalUnit | fn:lu:come_into_effect:take_effect | "come into effect" | "take effect" | "has lexical unit" |  | "FN" |  |
| fn:come_into_effect | fn:HasLexicalUnit | fn:lu:come_into_effect:apply | "come into effect" | "apply" | "has lexical unit" |  | "FN" |  |
| fn:come_into_effect | fn:HasLexicalUnit | fn:lu:come_into_effect:go_into_effect | "come into effect" | "go into effect" | "has lexical unit" |  | "FN" |  |
| fn:come_into_effect | fn:HasLexicalUnit | fn:lu:come_into_effect:come_into_effect | "come into effect" | "come into effect" | "has lexical unit" |  | "FN" |  |
| fn:come_into_effect | /r/HasA | fn:fe:binding_principle | "come into effect" | "binding principle" | "/r/has a" |  | "FN" |  |
| fn:come_into_effect | /r/HasA | fn:fe:manner | "come into effect" | "manner" | "/r/has a" |  | "FN" |  |
| fn:come_into_effect | /r/HasA | fn:fe:place | "come into effect" | "place" | "/r/has a" |  | "FN" |  |
| fn:come_into_effect | /r/HasA | fn:fe:time | "come into effect" | "time" | "/r/has a" |  | "FN" |  |
| fn:come_into_effect | /r/HasA | fn:fe:depictive | "come into effect" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:come_into_effect | /r/HasA | fn:fe:duration | "come into effect" | "duration" | "/r/has a" |  | "FN" |  |
| fn:come_into_effect | /r/HasA | fn:fe:result | "come into effect" | "result" | "/r/has a" |  | "FN" |  |
| fn:come_into_effect | /r/HasA | fn:fe:initial_subevent | "come into effect" | "initial subevent" | "/r/has a" |  | "FN" |  |
| fn:come_into_effect | /r/HasA | fn:fe:frequency | "come into effect" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:come_into_effect | /r/HasA | fn:fe:explanation | "come into effect" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:assemble | /r/IsA | fn:come_together | "assemble" | "come together" | "/r/is a" |  | "FN" |  |
| fn:encounter | /r/IsA | fn:come_together | "encounter" | "come together" | "/r/is a" |  | "FN" |  |
| fn:come_together | /r/IsA | fn:event | "come together" | "event" | "/r/is a" |  | "FN" |  |
| fn:gathering_up | /r/SimilarTo | fn:come_together | "gathering up" | "come together" | "/r/similar to" |  | "FN" |  |
| fn:come_together | /r/Causes | fn:aggregate | "come together" | "aggregate" | "/r/causes" |  | "FN" |  |
| fn:gathering_up | /r/Causes | fn:come_together | "gathering up" | "come together" | "/r/causes" |  | "FN" |  |
| fn:come_together | fn:HasLexicalUnit | fn:lu:come_together:gang_together | "come together" | "gang together" | "has lexical unit" |  | "FN" |  |
| fn:come_together | fn:HasLexicalUnit | fn:lu:come_together:band_together | "come together" | "band together" | "has lexical unit" |  | "FN" |  |
| fn:come_together | fn:HasLexicalUnit | fn:lu:come_together:come_together | "come together" | "come together" | "has lexical unit" |  | "FN" |  |
| fn:come_together | fn:HasLexicalUnit | fn:lu:come_together:gather | "come together" | "gather" | "has lexical unit" |  | "FN" |  |
| fn:come_together | fn:HasLexicalUnit | fn:lu:come_together:throng | "come together" | "throng" | "has lexical unit" |  | "FN" |  |
| fn:come_together | fn:HasLexicalUnit | fn:lu:come_together:meet | "come together" | "meet" | "has lexical unit" |  | "FN" |  |
| fn:come_together | fn:HasLexicalUnit | fn:lu:come_together:amass | "come together" | "amass" | "has lexical unit" |  | "FN" |  |
| fn:come_together | fn:HasLexicalUnit | fn:lu:come_together:congregate | "come together" | "congregate" | "has lexical unit" |  | "FN" |  |
| fn:come_together | fn:HasLexicalUnit | fn:lu:come_together:band | "come together" | "band" | "has lexical unit" |  | "FN" |  |
| fn:come_together | fn:HasLexicalUnit | fn:lu:come_together:assemble | "come together" | "assemble" | "has lexical unit" |  | "FN" |  |
| fn:come_together | fn:HasLexicalUnit | fn:lu:come_together:convene | "come together" | "convene" | "has lexical unit" |  | "FN" |  |
| fn:fe:individuals | /r/RelatedTo | fn:fe:party_1 | "individuals" | "party 1" | "/r/related to" |  | "FN" |  |
| fn:come_together | /r/HasA | fn:fe:individuals | "come together" | "individuals" | "/r/has a" |  | "FN" |  |
| fn:fe:configuration | /r/RelatedTo | fn:fe:party_2 | "configuration" | "party 2" | "/r/related to" |  | "FN" |  |
| fn:come_together | /r/HasA | fn:fe:configuration | "come together" | "configuration" | "/r/has a" |  | "FN" |  |
| fn:come_together | /r/HasA | fn:fe:means | "come together" | "means" | "/r/has a" |  | "FN" |  |
| fn:come_together | /r/HasA | fn:fe:place | "come together" | "place" | "/r/has a" |  | "FN" |  |
| fn:come_together | /r/HasA | fn:fe:time | "come together" | "time" | "/r/has a" |  | "FN" |  |
| fn:come_together | /r/HasA | fn:fe:purpose | "come together" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:come_together | /r/HasA | fn:fe:iterations | "come together" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:come_together | /r/HasA | fn:fe:frequency | "come together" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:come_together | /r/HasA | fn:fe:manner | "come together" | "manner" | "/r/has a" |  | "FN" |  |
| fn:come_together | /r/HasA | fn:fe:topic | "come together" | "topic" | "/r/has a" |  | "FN" |  |
| fn:fe:party_1 | /r/RelatedTo | fn:fe:configuration | "party 1" | "configuration" | "/r/related to" |  | "FN" |  |
| fn:come_together | /r/HasA | fn:fe:party_1 | "come together" | "party 1" | "/r/has a" |  | "FN" |  |
| fn:fe:party_2 | /r/RelatedTo | fn:fe:individuals | "party 2" | "individuals" | "/r/related to" |  | "FN" |  |
| fn:come_together | /r/HasA | fn:fe:party_2 | "come together" | "party 2" | "/r/has a" |  | "FN" |  |
| fn:come_together | /r/HasA | fn:fe:explanation | "come together" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:come_together | /r/HasA | fn:fe:particular_iteration | "come together" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:being_born | /r/IsA | fn:coming_to_be | "being born" | "coming to be" | "/r/is a" |  | "FN" |  |
| fn:coming_to_be | /r/IsA | fn:event | "coming to be" | "event" | "/r/is a" |  | "FN" |  |
| fn:cycle_of_existence_scenario | /r/HasSubevent | fn:coming_to_be | "cycle of existence scenario" | "coming to be" | "/r/has subevent" |  | "FN" |  |
| fn:coming_to_be | /r/Causes | fn:existence | "coming to be" | "existence" | "/r/causes" |  | "FN" |  |
| fn:existence | /r/HasPrerequisite | fn:coming_to_be | "existence" | "coming to be" | "/r/has prerequisite" |  | "FN" |  |
| fn:coming_to_be | fn:HasLexicalUnit | fn:lu:coming_to_be:form | "coming to be" | "form" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_be | fn:HasLexicalUnit | fn:lu:coming_to_be:come_to_be | "coming to be" | "come to be" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_be | fn:HasLexicalUnit | fn:lu:coming_to_be:appear | "coming to be" | "appear" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_be | fn:HasLexicalUnit | fn:lu:coming_to_be:arise | "coming to be" | "arise" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_be | fn:HasLexicalUnit | fn:lu:coming_to_be:emerge | "coming to be" | "emerge" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_be | fn:HasLexicalUnit | fn:lu:coming_to_be:take_shape | "coming to be" | "take shape" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_be | fn:HasLexicalUnit | fn:lu:coming_to_be:develop | "coming to be" | "develop" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_be | fn:HasLexicalUnit | fn:lu:coming_to_be:coalesce | "coming to be" | "coalesce" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_be | fn:HasLexicalUnit | fn:lu:coming_to_be:materialize | "coming to be" | "materialize" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_be | fn:HasLexicalUnit | fn:lu:coming_to_be:spring_up | "coming to be" | "spring up" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_be | fn:HasLexicalUnit | fn:lu:coming_to_be:come_into_existence | "coming to be" | "come into existence" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_be | fn:HasLexicalUnit | fn:lu:coming_to_be:evolve | "coming to be" | "evolve" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_be | fn:HasLexicalUnit | fn:lu:coming_to_be:development | "coming to be" | "development" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_be | fn:HasLexicalUnit | fn:lu:coming_to_be:evolution | "coming to be" | "evolution" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_be | /r/HasA | fn:fe:entity | "coming to be" | "entity" | "/r/has a" |  | "FN" |  |
| fn:coming_to_be | /r/HasA | fn:fe:place | "coming to be" | "place" | "/r/has a" |  | "FN" |  |
| fn:coming_to_be | /r/HasA | fn:fe:time | "coming to be" | "time" | "/r/has a" |  | "FN" |  |
| fn:coming_to_be | /r/HasA | fn:fe:explanation | "coming to be" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:coming_to_be | /r/HasA | fn:fe:components | "coming to be" | "components" | "/r/has a" |  | "FN" |  |
| fn:coming_to_be | /r/HasA | fn:fe:duration_of_final_state | "coming to be" | "duration of final state" | "/r/has a" |  | "FN" |  |
| fn:coming_to_be | /r/HasA | fn:fe:role | "coming to be" | "role" | "/r/has a" |  | "FN" |  |
| fn:coming_to_be | /r/HasA | fn:fe:period_of_iterations | "coming to be" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:coming_to_be | /r/HasA | fn:fe:manner | "coming to be" | "manner" | "/r/has a" |  | "FN" |  |
| fn:see_through | /r/IsA | fn:coming_to_believe | "see through" | "coming to believe" | "/r/is a" |  | "FN" |  |
| fn:coming_to_believe | /r/IsA | fn:event | "coming to believe" | "event" | "/r/is a" |  | "FN" |  |
| fn:coming_to_believe | /r/UsedFor | fn:fall_for | "coming to believe" | "fall for" | "/r/used for" |  | "FN" |  |
| fn:coming_to_believe | /r/UsedFor | fn:turning_out | "coming to believe" | "turning out" | "/r/used for" |  | "FN" |  |
| fn:mental_activity | /r/UsedFor | fn:coming_to_believe | "mental activity" | "coming to believe" | "/r/used for" |  | "FN" |  |
| fn:becoming_aware | /r/SimilarTo | fn:coming_to_believe | "becoming aware" | "coming to believe" | "/r/similar to" |  | "FN" |  |
| fn:coming_to_believe | /r/Causes | fn:awareness | "coming to believe" | "awareness" | "/r/causes" |  | "FN" |  |
| fn:coming_to_believe | fn:HasLexicalUnit | fn:lu:coming_to_believe:ascertain | "coming to believe" | "ascertain" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_believe | fn:HasLexicalUnit | fn:lu:coming_to_believe:conclude | "coming to believe" | "conclude" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_believe | fn:HasLexicalUnit | fn:lu:coming_to_believe:conclusion | "coming to believe" | "conclusion" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_believe | fn:HasLexicalUnit | fn:lu:coming_to_believe:deduce | "coming to believe" | "deduce" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_believe | fn:HasLexicalUnit | fn:lu:coming_to_believe:deduction | "coming to believe" | "deduction" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_believe | fn:HasLexicalUnit | fn:lu:coming_to_believe:guess | "coming to believe" | "guess" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_believe | fn:HasLexicalUnit | fn:lu:coming_to_believe:guess | "coming to believe" | "guess" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_believe | fn:HasLexicalUnit | fn:lu:coming_to_believe:infer | "coming to believe" | "infer" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_believe | fn:HasLexicalUnit | fn:lu:coming_to_believe:inference | "coming to believe" | "inference" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_believe | fn:HasLexicalUnit | fn:lu:coming_to_believe:learn | "coming to believe" | "learn" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_believe | fn:HasLexicalUnit | fn:lu:coming_to_believe:realization | "coming to believe" | "realization" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_believe | fn:HasLexicalUnit | fn:lu:coming_to_believe:realize | "coming to believe" | "realize" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_believe | fn:HasLexicalUnit | fn:lu:coming_to_believe:surmise | "coming to believe" | "surmise" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_believe | fn:HasLexicalUnit | fn:lu:coming_to_believe:figure_out | "coming to believe" | "figure out" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_believe | fn:HasLexicalUnit | fn:lu:coming_to_believe:find | "coming to believe" | "find" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_believe | fn:HasLexicalUnit | fn:lu:coming_to_believe:puzzle_out | "coming to believe" | "puzzle out" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_believe | fn:HasLexicalUnit | fn:lu:coming_to_believe:work_out | "coming to believe" | "work out" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_believe | fn:HasLexicalUnit | fn:lu:coming_to_believe:determine | "coming to believe" | "determine" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_believe | fn:HasLexicalUnit | fn:lu:coming_to_believe:speculate | "coming to believe" | "speculate" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_believe | fn:HasLexicalUnit | fn:lu:coming_to_believe:strike | "coming to believe" | "strike" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_believe | fn:HasLexicalUnit | fn:lu:coming_to_believe:gather | "coming to believe" | "gather" | "has lexical unit" |  | "FN" |  |
| fn:coming_to_believe | /r/HasA | fn:fe:cognizer | "coming to believe" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:coming_to_believe | /r/HasA | fn:fe:evidence | "coming to believe" | "evidence" | "/r/has a" |  | "FN" |  |
| fn:coming_to_believe | /r/HasA | fn:fe:content | "coming to believe" | "content" | "/r/has a" |  | "FN" |  |
| fn:coming_to_believe | /r/HasA | fn:fe:topic | "coming to believe" | "topic" | "/r/has a" |  | "FN" |  |
| fn:coming_to_believe | /r/HasA | fn:fe:degree | "coming to believe" | "degree" | "/r/has a" |  | "FN" |  |
| fn:coming_to_believe | /r/HasA | fn:fe:depictive | "coming to believe" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:coming_to_believe | /r/HasA | fn:fe:manner | "coming to believe" | "manner" | "/r/has a" |  | "FN" |  |
| fn:coming_to_believe | /r/HasA | fn:fe:means | "coming to believe" | "means" | "/r/has a" |  | "FN" |  |
| fn:coming_to_believe | /r/HasA | fn:fe:time | "coming to believe" | "time" | "/r/has a" |  | "FN" |  |
| fn:coming_to_believe | /r/HasA | fn:fe:medium | "coming to believe" | "medium" | "/r/has a" |  | "FN" |  |
| fn:coming_to_believe | /r/HasA | fn:fe:place | "coming to believe" | "place" | "/r/has a" |  | "FN" |  |
| fn:eventive_affecting | /r/UsedFor | fn:coming_up_with | "eventive affecting" | "coming up with" | "/r/used for" |  | "FN" |  |
| fn:awareness | /r/SimilarTo | fn:coming_up_with | "awareness" | "coming up with" | "/r/similar to" |  | "FN" |  |
| fn:coming_up_with | /r/SimilarTo | fn:achieving_first | "coming up with" | "achieving first" | "/r/similar to" |  | "FN" |  |
| fn:coming_up_with | /r/SimilarTo | fn:creating | "coming up with" | "creating" | "/r/similar to" |  | "FN" |  |
| fn:coming_up_with | fn:HasLexicalUnit | fn:lu:coming_up_with:conceive | "coming up with" | "conceive" | "has lexical unit" |  | "FN" |  |
| fn:coming_up_with | fn:HasLexicalUnit | fn:lu:coming_up_with:concoct | "coming up with" | "concoct" | "has lexical unit" |  | "FN" |  |
| fn:coming_up_with | fn:HasLexicalUnit | fn:lu:coming_up_with:concoction | "coming up with" | "concoction" | "has lexical unit" |  | "FN" |  |
| fn:coming_up_with | fn:HasLexicalUnit | fn:lu:coming_up_with:contrivance | "coming up with" | "contrivance" | "has lexical unit" |  | "FN" |  |
| fn:coming_up_with | fn:HasLexicalUnit | fn:lu:coming_up_with:contrive | "coming up with" | "contrive" | "has lexical unit" |  | "FN" |  |
| fn:coming_up_with | fn:HasLexicalUnit | fn:lu:coming_up_with:cook_up | "coming up with" | "cook up" | "has lexical unit" |  | "FN" |  |
| fn:coming_up_with | fn:HasLexicalUnit | fn:lu:coming_up_with:design | "coming up with" | "design" | "has lexical unit" |  | "FN" |  |
| fn:coming_up_with | fn:HasLexicalUnit | fn:lu:coming_up_with:devise | "coming up with" | "devise" | "has lexical unit" |  | "FN" |  |
| fn:coming_up_with | fn:HasLexicalUnit | fn:lu:coming_up_with:formulate | "coming up with" | "formulate" | "has lexical unit" |  | "FN" |  |
| fn:coming_up_with | fn:HasLexicalUnit | fn:lu:coming_up_with:hatch | "coming up with" | "hatch" | "has lexical unit" |  | "FN" |  |
| fn:coming_up_with | fn:HasLexicalUnit | fn:lu:coming_up_with:improvise | "coming up with" | "improvise" | "has lexical unit" |  | "FN" |  |
| fn:coming_up_with | fn:HasLexicalUnit | fn:lu:coming_up_with:invent | "coming up with" | "invent" | "has lexical unit" |  | "FN" |  |
| fn:coming_up_with | fn:HasLexicalUnit | fn:lu:coming_up_with:invention_[process] | "coming up with" | "invention [process]" | "has lexical unit" |  | "FN" |  |
| fn:coming_up_with | fn:HasLexicalUnit | fn:lu:coming_up_with:come_up | "coming up with" | "come up" | "has lexical unit" |  | "FN" |  |
| fn:coming_up_with | fn:HasLexicalUnit | fn:lu:coming_up_with:think_up | "coming up with" | "think up" | "has lexical unit" |  | "FN" |  |
| fn:coming_up_with | fn:HasLexicalUnit | fn:lu:coming_up_with:design | "coming up with" | "design" | "has lexical unit" |  | "FN" |  |
| fn:coming_up_with | fn:HasLexicalUnit | fn:lu:coming_up_with:invention_[artifact] | "coming up with" | "invention [artifact]" | "has lexical unit" |  | "FN" |  |
| fn:coming_up_with | fn:HasLexicalUnit | fn:lu:coming_up_with:find | "coming up with" | "find" | "has lexical unit" |  | "FN" |  |
| fn:coming_up_with | /r/HasA | fn:fe:cognizer | "coming up with" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:coming_up_with | /r/HasA | fn:fe:idea | "coming up with" | "idea" | "/r/has a" |  | "FN" |  |
| fn:coming_up_with | /r/HasA | fn:fe:purpose | "coming up with" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:coming_up_with | /r/HasA | fn:fe:material | "coming up with" | "material" | "/r/has a" |  | "FN" |  |
| fn:fe:amount_of_progress | /r/IsA | fn:st:degree | "amount of progress" | "degree" | "/r/is a" |  | "FN" |  |
| fn:coming_up_with | /r/HasA | fn:fe:amount_of_progress | "coming up with" | "amount of progress" | "/r/has a" |  | "FN" |  |
| fn:coming_up_with | /r/HasA | fn:fe:depictive | "coming up with" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:coming_up_with | /r/HasA | fn:fe:manner | "coming up with" | "manner" | "/r/has a" |  | "FN" |  |
| fn:coming_up_with | /r/HasA | fn:fe:means | "coming up with" | "means" | "/r/has a" |  | "FN" |  |
| fn:coming_up_with | /r/HasA | fn:fe:result | "coming up with" | "result" | "/r/has a" |  | "FN" |  |
| fn:coming_up_with | /r/HasA | fn:fe:location_of_appearance | "coming up with" | "location of appearance" | "/r/has a" |  | "FN" |  |
| fn:coming_up_with | /r/HasA | fn:fe:place | "coming up with" | "place" | "/r/has a" |  | "FN" |  |
| fn:coming_up_with | /r/HasA | fn:fe:time | "coming up with" | "time" | "/r/has a" |  | "FN" |  |
| fn:commemorative | fn:HasLexicalUnit | fn:lu:commemorative:armistice_day | "commemorative" | "armistice day" | "has lexical unit" |  | "FN" |  |
| fn:commemorative | fn:HasLexicalUnit | fn:lu:commemorative:boxing_day | "commemorative" | "boxing day" | "has lexical unit" |  | "FN" |  |
| fn:commemorative | fn:HasLexicalUnit | fn:lu:commemorative:labor_day | "commemorative" | "labor day" | "has lexical unit" |  | "FN" |  |
| fn:commemorative | fn:HasLexicalUnit | fn:lu:commemorative:april_fool's_day | "commemorative" | "april fool\\'s day" | "has lexical unit" |  | "FN" |  |
| fn:commemorative | fn:HasLexicalUnit | fn:lu:commemorative:christmas_day | "commemorative" | "christmas day" | "has lexical unit" |  | "FN" |  |
| fn:commemorative | fn:HasLexicalUnit | fn:lu:commemorative:passover_eve | "commemorative" | "passover eve" | "has lexical unit" |  | "FN" |  |
| fn:commemorative | fn:HasLexicalUnit | fn:lu:commemorative:birthday | "commemorative" | "birthday" | "has lexical unit" |  | "FN" |  |
| fn:commemorative | /r/HasA | fn:fe:honored_entity | "commemorative" | "honored entity" | "/r/has a" |  | "FN" |  |
| fn:commemorative | /r/HasA | fn:fe:dedicated_type | "commemorative" | "dedicated type" | "/r/has a" |  | "FN" |  |
| fn:commemorative | /r/HasA | fn:fe:dedicated_entity | "commemorative" | "dedicated entity" | "/r/has a" |  | "FN" |  |
| fn:renting | /r/IsA | fn:commerce_buy | "renting" | "commerce buy" | "/r/is a" |  | "FN" |  |
| fn:commerce_buy | /r/IsA | fn:getting | "commerce buy" | "getting" | "/r/is a" |  | "FN" |  |
| fn:commerce_buy | /r/UsedFor | fn:importing | "commerce buy" | "importing" | "/r/used for" |  | "FN" |  |
| fn:commerce_buy | /r/UsedFor | fn:shopping | "commerce buy" | "shopping" | "/r/used for" |  | "FN" |  |
| fn:commerce_buy | /r/SimilarTo | fn:renting | "commerce buy" | "renting" | "/r/similar to" |  | "FN" |  |
| fn:commerce_scenario | /r/SimilarTo | fn:commerce_buy | "commerce scenario" | "commerce buy" | "/r/similar to" |  | "FN" |  |
| fn:commerce_buy | /r/IsA | fn:commerce_goods-transfer | "commerce buy" | "commerce goods-transfer" | "/r/is a" |  | "FN" |  |
| fn:commerce_buy | fn:HasLexicalUnit | fn:lu:commerce_buy:buy | "commerce buy" | "buy" | "has lexical unit" |  | "FN" |  |
| fn:commerce_buy | fn:HasLexicalUnit | fn:lu:commerce_buy:purchase | "commerce buy" | "purchase" | "has lexical unit" |  | "FN" |  |
| fn:commerce_buy | fn:HasLexicalUnit | fn:lu:commerce_buy:purchase_[act] | "commerce buy" | "purchase [act]" | "has lexical unit" |  | "FN" |  |
| fn:commerce_buy | fn:HasLexicalUnit | fn:lu:commerce_buy:buyer | "commerce buy" | "buyer" | "has lexical unit" |  | "FN" |  |
| fn:commerce_buy | fn:HasLexicalUnit | fn:lu:commerce_buy:purchaser | "commerce buy" | "purchaser" | "has lexical unit" |  | "FN" |  |
| fn:commerce_buy | fn:HasLexicalUnit | fn:lu:commerce_buy:client | "commerce buy" | "client" | "has lexical unit" |  | "FN" |  |
| fn:commerce_buy | /r/HasA | fn:fe:buyer | "commerce buy" | "buyer" | "/r/has a" |  | "FN" |  |
| fn:commerce_buy | /r/HasA | fn:fe:goods | "commerce buy" | "goods" | "/r/has a" |  | "FN" |  |
| fn:commerce_buy | /r/HasA | fn:fe:means | "commerce buy" | "means" | "/r/has a" |  | "FN" |  |
| fn:commerce_buy | /r/HasA | fn:fe:money | "commerce buy" | "money" | "/r/has a" |  | "FN" |  |
| fn:commerce_buy | /r/HasA | fn:fe:rate | "commerce buy" | "rate" | "/r/has a" |  | "FN" |  |
| fn:fe:seller | /r/IsA | fn:st:source | "seller" | "source" | "/r/is a" |  | "FN" |  |
| fn:commerce_buy | /r/HasA | fn:fe:seller | "commerce buy" | "seller" | "/r/has a" |  | "FN" |  |
| fn:commerce_buy | /r/HasA | fn:fe:unit | "commerce buy" | "unit" | "/r/has a" |  | "FN" |  |
| fn:commerce_buy | /r/HasA | fn:fe:place | "commerce buy" | "place" | "/r/has a" |  | "FN" |  |
| fn:commerce_buy | /r/HasA | fn:fe:purpose | "commerce buy" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:commerce_buy | /r/HasA | fn:fe:explanation | "commerce buy" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:commerce_buy | /r/HasA | fn:fe:time | "commerce buy" | "time" | "/r/has a" |  | "FN" |  |
| fn:commerce_buy | /r/HasA | fn:fe:manner | "commerce buy" | "manner" | "/r/has a" |  | "FN" |  |
| fn:commerce_buy | /r/HasA | fn:fe:recipient | "commerce buy" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:commerce_buy | /r/HasA | fn:fe:period_of_iterations | "commerce buy" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:commerce_buy | /r/HasA | fn:fe:imposed_purpose | "commerce buy" | "imposed purpose" | "/r/has a" |  | "FN" |  |
| fn:earnings_and_losses | /r/IsA | fn:commerce_collect | "earnings and losses" | "commerce collect" | "/r/is a" |  | "FN" |  |
| fn:commerce_collect | /r/IsA | fn:getting | "commerce collect" | "getting" | "/r/is a" |  | "FN" |  |
| fn:commerce_collect | /r/UsedFor | fn:billing | "commerce collect" | "billing" | "/r/used for" |  | "FN" |  |
| fn:commerce_collect | /r/UsedFor | fn:earnings_and_losses | "commerce collect" | "earnings and losses" | "/r/used for" |  | "FN" |  |
| fn:commerce_collect | /r/UsedFor | fn:fining | "commerce collect" | "fining" | "/r/used for" |  | "FN" |  |
| fn:commerce_scenario | /r/SimilarTo | fn:commerce_collect | "commerce scenario" | "commerce collect" | "/r/similar to" |  | "FN" |  |
| fn:commerce_collect | /r/IsA | fn:commerce_money-transfer | "commerce collect" | "commerce money-transfer" | "/r/is a" |  | "FN" |  |
| fn:commerce_collect | fn:HasLexicalUnit | fn:lu:commerce_collect:collect | "commerce collect" | "collect" | "has lexical unit" |  | "FN" |  |
| fn:commerce_collect | fn:HasLexicalUnit | fn:lu:commerce_collect:collection | "commerce collect" | "collection" | "has lexical unit" |  | "FN" |  |
| fn:fe:buyer | /r/IsA | fn:st:source | "buyer" | "source" | "/r/is a" |  | "FN" |  |
| fn:commerce_collect | /r/HasA | fn:fe:buyer | "commerce collect" | "buyer" | "/r/has a" |  | "FN" |  |
| fn:commerce_collect | /r/HasA | fn:fe:goods | "commerce collect" | "goods" | "/r/has a" |  | "FN" |  |
| fn:commerce_collect | /r/HasA | fn:fe:means | "commerce collect" | "means" | "/r/has a" |  | "FN" |  |
| fn:commerce_collect | /r/HasA | fn:fe:money | "commerce collect" | "money" | "/r/has a" |  | "FN" |  |
| fn:commerce_collect | /r/HasA | fn:fe:rate | "commerce collect" | "rate" | "/r/has a" |  | "FN" |  |
| fn:commerce_collect | /r/HasA | fn:fe:seller | "commerce collect" | "seller" | "/r/has a" |  | "FN" |  |
| fn:commerce_collect | /r/HasA | fn:fe:unit | "commerce collect" | "unit" | "/r/has a" |  | "FN" |  |
| fn:commerce_collect | /r/HasA | fn:fe:place | "commerce collect" | "place" | "/r/has a" |  | "FN" |  |
| fn:commerce_collect | /r/HasA | fn:fe:purpose | "commerce collect" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:commerce_collect | /r/HasA | fn:fe:explanation | "commerce collect" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:commerce_collect | /r/HasA | fn:fe:time | "commerce collect" | "time" | "/r/has a" |  | "FN" |  |
| fn:commerce_collect | /r/HasA | fn:fe:manner | "commerce collect" | "manner" | "/r/has a" |  | "FN" |  |
| fn:commerce_goods-transfer | /r/IsA | fn:transfer | "commerce goods-transfer" | "transfer" | "/r/is a" |  | "FN" |  |
| fn:commercial_transaction | /r/HasSubevent | fn:commerce_goods-transfer | "commercial transaction" | "commerce goods-transfer" | "/r/has subevent" |  | "FN" |  |
| fn:commerce_goods-transfer | /r/UsedFor | fn:product_delivery | "commerce goods-transfer" | "product delivery" | "/r/used for" |  | "FN" |  |
| fn:commerce_buy | /r/IsA | fn:commerce_goods-transfer | "commerce buy" | "commerce goods-transfer" | "/r/is a" |  | "FN" |  |
| fn:commerce_sell | /r/IsA | fn:commerce_goods-transfer | "commerce sell" | "commerce goods-transfer" | "/r/is a" |  | "FN" |  |
| fn:fe:buyer | /r/RelatedTo | fn:fe:exchangers | "buyer" | "exchangers" | "/r/related to" |  | "FN" |  |
| fn:commerce_goods-transfer | /r/HasA | fn:fe:buyer | "commerce goods-transfer" | "buyer" | "/r/has a" |  | "FN" |  |
| fn:commerce_goods-transfer | /r/HasA | fn:fe:goods | "commerce goods-transfer" | "goods" | "/r/has a" |  | "FN" |  |
| fn:commerce_goods-transfer | /r/HasA | fn:fe:means | "commerce goods-transfer" | "means" | "/r/has a" |  | "FN" |  |
| fn:commerce_goods-transfer | /r/HasA | fn:fe:money | "commerce goods-transfer" | "money" | "/r/has a" |  | "FN" |  |
| fn:commerce_goods-transfer | /r/HasA | fn:fe:rate | "commerce goods-transfer" | "rate" | "/r/has a" |  | "FN" |  |
| fn:fe:seller | /r/RelatedTo | fn:fe:exchangers | "seller" | "exchangers" | "/r/related to" |  | "FN" |  |
| fn:commerce_goods-transfer | /r/HasA | fn:fe:seller | "commerce goods-transfer" | "seller" | "/r/has a" |  | "FN" |  |
| fn:commerce_goods-transfer | /r/HasA | fn:fe:unit | "commerce goods-transfer" | "unit" | "/r/has a" |  | "FN" |  |
| fn:commerce_goods-transfer | /r/HasA | fn:fe:time | "commerce goods-transfer" | "time" | "/r/has a" |  | "FN" |  |
| fn:commerce_goods-transfer | /r/HasA | fn:fe:place | "commerce goods-transfer" | "place" | "/r/has a" |  | "FN" |  |
| fn:commerce_goods-transfer | /r/HasA | fn:fe:explanation | "commerce goods-transfer" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:commerce_goods-transfer | /r/HasA | fn:fe:manner | "commerce goods-transfer" | "manner" | "/r/has a" |  | "FN" |  |
| fn:commerce_goods-transfer | /r/HasA | fn:fe:purpose | "commerce goods-transfer" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:commerce_goods-transfer | /r/HasA | fn:fe:exchangers | "commerce goods-transfer" | "exchangers" | "/r/has a" |  | "FN" |  |
| fn:commerce_money-transfer | /r/IsA | fn:transfer | "commerce money-transfer" | "transfer" | "/r/is a" |  | "FN" |  |
| fn:commercial_transaction | /r/HasSubevent | fn:commerce_money-transfer | "commercial transaction" | "commerce money-transfer" | "/r/has subevent" |  | "FN" |  |
| fn:commerce_collect | /r/IsA | fn:commerce_money-transfer | "commerce collect" | "commerce money-transfer" | "/r/is a" |  | "FN" |  |
| fn:commerce_pay | /r/IsA | fn:commerce_money-transfer | "commerce pay" | "commerce money-transfer" | "/r/is a" |  | "FN" |  |
| fn:commerce_money-transfer | /r/HasA | fn:fe:buyer | "commerce money-transfer" | "buyer" | "/r/has a" |  | "FN" |  |
| fn:commerce_money-transfer | /r/HasA | fn:fe:goods | "commerce money-transfer" | "goods" | "/r/has a" |  | "FN" |  |
| fn:commerce_money-transfer | /r/HasA | fn:fe:means | "commerce money-transfer" | "means" | "/r/has a" |  | "FN" |  |
| fn:commerce_money-transfer | /r/HasA | fn:fe:money | "commerce money-transfer" | "money" | "/r/has a" |  | "FN" |  |
| fn:commerce_money-transfer | /r/HasA | fn:fe:rate | "commerce money-transfer" | "rate" | "/r/has a" |  | "FN" |  |
| fn:commerce_money-transfer | /r/HasA | fn:fe:seller | "commerce money-transfer" | "seller" | "/r/has a" |  | "FN" |  |
| fn:commerce_money-transfer | /r/HasA | fn:fe:unit | "commerce money-transfer" | "unit" | "/r/has a" |  | "FN" |  |
| fn:commerce_money-transfer | /r/HasA | fn:fe:place | "commerce money-transfer" | "place" | "/r/has a" |  | "FN" |  |
| fn:commerce_money-transfer | /r/HasA | fn:fe:time | "commerce money-transfer" | "time" | "/r/has a" |  | "FN" |  |
| fn:commerce_money-transfer | /r/HasA | fn:fe:explanation | "commerce money-transfer" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:commerce_money-transfer | /r/HasA | fn:fe:manner | "commerce money-transfer" | "manner" | "/r/has a" |  | "FN" |  |
| fn:commerce_money-transfer | /r/HasA | fn:fe:purpose | "commerce money-transfer" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:commerce_money-transfer | /r/HasA | fn:fe:exchangers | "commerce money-transfer" | "exchangers" | "/r/has a" |  | "FN" |  |
| fn:commerce_pay | /r/IsA | fn:giving | "commerce pay" | "giving" | "/r/is a" |  | "FN" |  |
| fn:commerce_pay | /r/UsedFor | fn:earnings_and_losses | "commerce pay" | "earnings and losses" | "/r/used for" |  | "FN" |  |
| fn:commerce_scenario | /r/SimilarTo | fn:commerce_pay | "commerce scenario" | "commerce pay" | "/r/similar to" |  | "FN" |  |
| fn:commerce_pay | /r/IsA | fn:commerce_money-transfer | "commerce pay" | "commerce money-transfer" | "/r/is a" |  | "FN" |  |
| fn:commerce_pay | fn:HasLexicalUnit | fn:lu:commerce_pay:pay | "commerce pay" | "pay" | "has lexical unit" |  | "FN" |  |
| fn:commerce_pay | fn:HasLexicalUnit | fn:lu:commerce_pay:payment | "commerce pay" | "payment" | "has lexical unit" |  | "FN" |  |
| fn:commerce_pay | fn:HasLexicalUnit | fn:lu:commerce_pay:disburse | "commerce pay" | "disburse" | "has lexical unit" |  | "FN" |  |
| fn:commerce_pay | fn:HasLexicalUnit | fn:lu:commerce_pay:disbursement | "commerce pay" | "disbursement" | "has lexical unit" |  | "FN" |  |
| fn:commerce_pay | fn:HasLexicalUnit | fn:lu:commerce_pay:shell_out | "commerce pay" | "shell out" | "has lexical unit" |  | "FN" |  |
| fn:commerce_pay | fn:HasLexicalUnit | fn:lu:commerce_pay:payer | "commerce pay" | "payer" | "has lexical unit" |  | "FN" |  |
| fn:commerce_pay | /r/HasA | fn:fe:buyer | "commerce pay" | "buyer" | "/r/has a" |  | "FN" |  |
| fn:commerce_pay | /r/HasA | fn:fe:goods | "commerce pay" | "goods" | "/r/has a" |  | "FN" |  |
| fn:commerce_pay | /r/HasA | fn:fe:means | "commerce pay" | "means" | "/r/has a" |  | "FN" |  |
| fn:commerce_pay | /r/HasA | fn:fe:money | "commerce pay" | "money" | "/r/has a" |  | "FN" |  |
| fn:commerce_pay | /r/HasA | fn:fe:rate | "commerce pay" | "rate" | "/r/has a" |  | "FN" |  |
| fn:commerce_pay | /r/HasA | fn:fe:seller | "commerce pay" | "seller" | "/r/has a" |  | "FN" |  |
| fn:commerce_pay | /r/HasA | fn:fe:unit | "commerce pay" | "unit" | "/r/has a" |  | "FN" |  |
| fn:commerce_pay | /r/HasA | fn:fe:place | "commerce pay" | "place" | "/r/has a" |  | "FN" |  |
| fn:commerce_pay | /r/HasA | fn:fe:purpose | "commerce pay" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:commerce_pay | /r/HasA | fn:fe:explanation | "commerce pay" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:commerce_pay | /r/HasA | fn:fe:time | "commerce pay" | "time" | "/r/has a" |  | "FN" |  |
| fn:commerce_pay | /r/HasA | fn:fe:manner | "commerce pay" | "manner" | "/r/has a" |  | "FN" |  |
| fn:commerce_pay | /r/HasA | fn:fe:circumstances | "commerce pay" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:commerce_pay | /r/HasA | fn:fe:frequency | "commerce pay" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:commerce_scenario | /r/HasSubevent | fn:commercial_transaction | "commerce scenario" | "commercial transaction" | "/r/has subevent" |  | "FN" |  |
| fn:commerce_scenario | /r/HasSubevent | fn:having_commercial_agreement | "commerce scenario" | "having commercial agreement" | "/r/has subevent" |  | "FN" |  |
| fn:commerce_scenario | /r/UsedFor | fn:businesses | "commerce scenario" | "businesses" | "/r/used for" |  | "FN" |  |
| fn:commerce_scenario | /r/UsedFor | fn:exchange_currency | "commerce scenario" | "exchange currency" | "/r/used for" |  | "FN" |  |
| fn:commerce_scenario | /r/UsedFor | fn:expensiveness | "commerce scenario" | "expensiveness" | "/r/used for" |  | "FN" |  |
| fn:commerce_scenario | /r/SimilarTo | fn:commerce_buy | "commerce scenario" | "commerce buy" | "/r/similar to" |  | "FN" |  |
| fn:commerce_scenario | /r/SimilarTo | fn:commerce_collect | "commerce scenario" | "commerce collect" | "/r/similar to" |  | "FN" |  |
| fn:commerce_scenario | /r/SimilarTo | fn:commerce_pay | "commerce scenario" | "commerce pay" | "/r/similar to" |  | "FN" |  |
| fn:commerce_scenario | /r/SimilarTo | fn:commerce_sell | "commerce scenario" | "commerce sell" | "/r/similar to" |  | "FN" |  |
| fn:commerce_scenario | /r/SimilarTo | fn:expensiveness | "commerce scenario" | "expensiveness" | "/r/similar to" |  | "FN" |  |
| fn:commerce_scenario | fn:HasLexicalUnit | fn:lu:commerce_scenario:price | "commerce scenario" | "price" | "has lexical unit" |  | "FN" |  |
| fn:commerce_scenario | fn:HasLexicalUnit | fn:lu:commerce_scenario:goods | "commerce scenario" | "goods" | "has lexical unit" |  | "FN" |  |
| fn:commerce_scenario | fn:HasLexicalUnit | fn:lu:commerce_scenario:commerce | "commerce scenario" | "commerce" | "has lexical unit" |  | "FN" |  |
| fn:commerce_scenario | fn:HasLexicalUnit | fn:lu:commerce_scenario:trafficker | "commerce scenario" | "trafficker" | "has lexical unit" |  | "FN" |  |
| fn:commerce_scenario | fn:HasLexicalUnit | fn:lu:commerce_scenario:supply_side | "commerce scenario" | "supply side" | "has lexical unit" |  | "FN" |  |
| fn:commerce_scenario | fn:HasLexicalUnit | fn:lu:commerce_scenario:merchandise | "commerce scenario" | "merchandise" | "has lexical unit" |  | "FN" |  |
| fn:commerce_scenario | /r/HasA | fn:fe:buyer | "commerce scenario" | "buyer" | "/r/has a" |  | "FN" |  |
| fn:commerce_scenario | /r/HasA | fn:fe:seller | "commerce scenario" | "seller" | "/r/has a" |  | "FN" |  |
| fn:commerce_scenario | /r/HasA | fn:fe:money | "commerce scenario" | "money" | "/r/has a" |  | "FN" |  |
| fn:commerce_scenario | /r/HasA | fn:fe:goods | "commerce scenario" | "goods" | "/r/has a" |  | "FN" |  |
| fn:commerce_scenario | /r/HasA | fn:fe:rate | "commerce scenario" | "rate" | "/r/has a" |  | "FN" |  |
| fn:commerce_scenario | /r/HasA | fn:fe:unit | "commerce scenario" | "unit" | "/r/has a" |  | "FN" |  |
| fn:commerce_scenario | /r/HasA | fn:fe:means | "commerce scenario" | "means" | "/r/has a" |  | "FN" |  |
| fn:commerce_scenario | /r/HasA | fn:fe:manner | "commerce scenario" | "manner" | "/r/has a" |  | "FN" |  |
| fn:commerce_scenario | /r/HasA | fn:fe:purpose | "commerce scenario" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:renting_out | /r/IsA | fn:commerce_sell | "renting out" | "commerce sell" | "/r/is a" |  | "FN" |  |
| fn:commerce_sell | /r/IsA | fn:giving | "commerce sell" | "giving" | "/r/is a" |  | "FN" |  |
| fn:commerce_sell | /r/UsedFor | fn:carry_goods | "commerce sell" | "carry goods" | "/r/used for" |  | "FN" |  |
| fn:commerce_sell | /r/UsedFor | fn:exporting | "commerce sell" | "exporting" | "/r/used for" |  | "FN" |  |
| fn:commerce_scenario | /r/SimilarTo | fn:commerce_sell | "commerce scenario" | "commerce sell" | "/r/similar to" |  | "FN" |  |
| fn:commerce_sell | /r/SimilarTo | fn:renting_out | "commerce sell" | "renting out" | "/r/similar to" |  | "FN" |  |
| fn:commerce_sell | /r/IsA | fn:commerce_goods-transfer | "commerce sell" | "commerce goods-transfer" | "/r/is a" |  | "FN" |  |
| fn:commerce_sell | fn:HasLexicalUnit | fn:lu:commerce_sell:retail | "commerce sell" | "retail" | "has lexical unit" |  | "FN" |  |
| fn:commerce_sell | fn:HasLexicalUnit | fn:lu:commerce_sell:retailer | "commerce sell" | "retailer" | "has lexical unit" |  | "FN" |  |
| fn:commerce_sell | fn:HasLexicalUnit | fn:lu:commerce_sell:sell | "commerce sell" | "sell" | "has lexical unit" |  | "FN" |  |
| fn:commerce_sell | fn:HasLexicalUnit | fn:lu:commerce_sell:vend | "commerce sell" | "vend" | "has lexical unit" |  | "FN" |  |
| fn:commerce_sell | fn:HasLexicalUnit | fn:lu:commerce_sell:vendor | "commerce sell" | "vendor" | "has lexical unit" |  | "FN" |  |
| fn:commerce_sell | fn:HasLexicalUnit | fn:lu:commerce_sell:sale | "commerce sell" | "sale" | "has lexical unit" |  | "FN" |  |
| fn:commerce_sell | fn:HasLexicalUnit | fn:lu:commerce_sell:auction | "commerce sell" | "auction" | "has lexical unit" |  | "FN" |  |
| fn:commerce_sell | fn:HasLexicalUnit | fn:lu:commerce_sell:auction | "commerce sell" | "auction" | "has lexical unit" |  | "FN" |  |
| fn:commerce_sell | fn:HasLexicalUnit | fn:lu:commerce_sell:seller | "commerce sell" | "seller" | "has lexical unit" |  | "FN" |  |
| fn:commerce_sell | /r/HasA | fn:fe:buyer | "commerce sell" | "buyer" | "/r/has a" |  | "FN" |  |
| fn:commerce_sell | /r/HasA | fn:fe:goods | "commerce sell" | "goods" | "/r/has a" |  | "FN" |  |
| fn:commerce_sell | /r/HasA | fn:fe:means | "commerce sell" | "means" | "/r/has a" |  | "FN" |  |
| fn:commerce_sell | /r/HasA | fn:fe:money | "commerce sell" | "money" | "/r/has a" |  | "FN" |  |
| fn:commerce_sell | /r/HasA | fn:fe:rate | "commerce sell" | "rate" | "/r/has a" |  | "FN" |  |
| fn:commerce_sell | /r/HasA | fn:fe:seller | "commerce sell" | "seller" | "/r/has a" |  | "FN" |  |
| fn:commerce_sell | /r/HasA | fn:fe:unit | "commerce sell" | "unit" | "/r/has a" |  | "FN" |  |
| fn:commerce_sell | /r/HasA | fn:fe:place | "commerce sell" | "place" | "/r/has a" |  | "FN" |  |
| fn:commerce_sell | /r/HasA | fn:fe:purpose | "commerce sell" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:commerce_sell | /r/HasA | fn:fe:explanation | "commerce sell" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:commerce_sell | /r/HasA | fn:fe:time | "commerce sell" | "time" | "/r/has a" |  | "FN" |  |
| fn:commerce_sell | /r/HasA | fn:fe:manner | "commerce sell" | "manner" | "/r/has a" |  | "FN" |  |
| fn:commerce_sell | /r/HasA | fn:fe:result | "commerce sell" | "result" | "/r/has a" |  | "FN" |  |
| fn:commerce_sell | /r/HasA | fn:fe:period_of_iterations | "commerce sell" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:commerce_sell | /r/HasA | fn:fe:imposed_purpose | "commerce sell" | "imposed purpose" | "/r/has a" |  | "FN" |  |
| fn:commerce_sell | /r/HasA | fn:fe:back | "commerce sell" | "back" | "/r/has a" |  | "FN" |  |
| fn:commerce_sell | /r/HasA | fn:fe:relay | "commerce sell" | "relay" | "/r/has a" |  | "FN" |  |
| fn:commercial_transaction | /r/IsA | fn:reciprocality | "commercial transaction" | "reciprocality" | "/r/is a" |  | "FN" |  |
| fn:commerce_scenario | /r/HasSubevent | fn:commercial_transaction | "commerce scenario" | "commercial transaction" | "/r/has subevent" |  | "FN" |  |
| fn:commercial_transaction | /r/HasSubevent | fn:commerce_goods-transfer | "commercial transaction" | "commerce goods-transfer" | "/r/has subevent" |  | "FN" |  |
| fn:commercial_transaction | /r/HasSubevent | fn:commerce_money-transfer | "commercial transaction" | "commerce money-transfer" | "/r/has subevent" |  | "FN" |  |
| fn:commercial_transaction | fn:HasLexicalUnit | fn:lu:commercial_transaction:transaction | "commercial transaction" | "transaction" | "has lexical unit" |  | "FN" |  |
| fn:commercial_transaction | /r/HasA | fn:fe:buyer | "commercial transaction" | "buyer" | "/r/has a" |  | "FN" |  |
| fn:commercial_transaction | /r/HasA | fn:fe:goods | "commercial transaction" | "goods" | "/r/has a" |  | "FN" |  |
| fn:commercial_transaction | /r/HasA | fn:fe:means | "commercial transaction" | "means" | "/r/has a" |  | "FN" |  |
| fn:commercial_transaction | /r/HasA | fn:fe:money | "commercial transaction" | "money" | "/r/has a" |  | "FN" |  |
| fn:commercial_transaction | /r/HasA | fn:fe:rate | "commercial transaction" | "rate" | "/r/has a" |  | "FN" |  |
| fn:commercial_transaction | /r/HasA | fn:fe:seller | "commercial transaction" | "seller" | "/r/has a" |  | "FN" |  |
| fn:commercial_transaction | /r/HasA | fn:fe:unit | "commercial transaction" | "unit" | "/r/has a" |  | "FN" |  |
| fn:commitment | /r/UsedFor | fn:going_back_on_a_commitment | "commitment" | "going back on a commitment" | "/r/used for" |  | "FN" |  |
| fn:commitment | /r/UsedFor | fn:make_agreement_on_action | "commitment" | "make agreement on action" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:commitment | "communication" | "commitment" | "/r/used for" |  | "FN" |  |
| fn:statement | /r/SimilarTo | fn:commitment | "statement" | "commitment" | "/r/similar to" |  | "FN" |  |
| fn:commitment | fn:HasLexicalUnit | fn:lu:commitment:consent | "commitment" | "consent" | "has lexical unit" |  | "FN" |  |
| fn:commitment | fn:HasLexicalUnit | fn:lu:commitment:covenant | "commitment" | "covenant" | "has lexical unit" |  | "FN" |  |
| fn:commitment | fn:HasLexicalUnit | fn:lu:commitment:covenant | "commitment" | "covenant" | "has lexical unit" |  | "FN" |  |
| fn:commitment | fn:HasLexicalUnit | fn:lu:commitment:oath | "commitment" | "oath" | "has lexical unit" |  | "FN" |  |
| fn:commitment | fn:HasLexicalUnit | fn:lu:commitment:pledge | "commitment" | "pledge" | "has lexical unit" |  | "FN" |  |
| fn:commitment | fn:HasLexicalUnit | fn:lu:commitment:pledge | "commitment" | "pledge" | "has lexical unit" |  | "FN" |  |
| fn:commitment | fn:HasLexicalUnit | fn:lu:commitment:promise | "commitment" | "promise" | "has lexical unit" |  | "FN" |  |
| fn:commitment | fn:HasLexicalUnit | fn:lu:commitment:promise | "commitment" | "promise" | "has lexical unit" |  | "FN" |  |
| fn:commitment | fn:HasLexicalUnit | fn:lu:commitment:swear | "commitment" | "swear" | "has lexical unit" |  | "FN" |  |
| fn:commitment | fn:HasLexicalUnit | fn:lu:commitment:threat | "commitment" | "threat" | "has lexical unit" |  | "FN" |  |
| fn:commitment | fn:HasLexicalUnit | fn:lu:commitment:threaten | "commitment" | "threaten" | "has lexical unit" |  | "FN" |  |
| fn:commitment | fn:HasLexicalUnit | fn:lu:commitment:undertake | "commitment" | "undertake" | "has lexical unit" |  | "FN" |  |
| fn:commitment | fn:HasLexicalUnit | fn:lu:commitment:undertaking | "commitment" | "undertaking" | "has lexical unit" |  | "FN" |  |
| fn:commitment | fn:HasLexicalUnit | fn:lu:commitment:volunteer | "commitment" | "volunteer" | "has lexical unit" |  | "FN" |  |
| fn:commitment | fn:HasLexicalUnit | fn:lu:commitment:vow | "commitment" | "vow" | "has lexical unit" |  | "FN" |  |
| fn:commitment | fn:HasLexicalUnit | fn:lu:commitment:commit | "commitment" | "commit" | "has lexical unit" |  | "FN" |  |
| fn:commitment | fn:HasLexicalUnit | fn:lu:commitment:commitment | "commitment" | "commitment" | "has lexical unit" |  | "FN" |  |
| fn:commitment | fn:HasLexicalUnit | fn:lu:commitment:vow | "commitment" | "vow" | "has lexical unit" |  | "FN" |  |
| fn:commitment | /r/HasA | fn:fe:speaker | "commitment" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:commitment | /r/HasA | fn:fe:addressee | "commitment" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:commitment | /r/HasA | fn:fe:message | "commitment" | "message" | "/r/has a" |  | "FN" |  |
| fn:commitment | /r/HasA | fn:fe:topic | "commitment" | "topic" | "/r/has a" |  | "FN" |  |
| fn:commitment | /r/HasA | fn:fe:medium | "commitment" | "medium" | "/r/has a" |  | "FN" |  |
| fn:commitment | /r/HasA | fn:fe:manner | "commitment" | "manner" | "/r/has a" |  | "FN" |  |
| fn:commitment | /r/HasA | fn:fe:time | "commitment" | "time" | "/r/has a" |  | "FN" |  |
| fn:commitment | /r/HasA | fn:fe:place | "commitment" | "place" | "/r/has a" |  | "FN" |  |
| fn:commitment | /r/HasA | fn:fe:purpose | "commitment" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:commitment | /r/HasA | fn:fe:period_of_iterations | "commitment" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:abusing | /r/IsA | fn:committing_crime | "abusing" | "committing crime" | "/r/is a" |  | "FN" |  |
| fn:kidnapping | /r/IsA | fn:committing_crime | "kidnapping" | "committing crime" | "/r/is a" |  | "FN" |  |
| fn:piracy | /r/IsA | fn:committing_crime | "piracy" | "committing crime" | "/r/is a" |  | "FN" |  |
| fn:rape | /r/IsA | fn:committing_crime | "rape" | "committing crime" | "/r/is a" |  | "FN" |  |
| fn:robbery | /r/IsA | fn:committing_crime | "robbery" | "committing crime" | "/r/is a" |  | "FN" |  |
| fn:smuggling | /r/IsA | fn:committing_crime | "smuggling" | "committing crime" | "/r/is a" |  | "FN" |  |
| fn:theft | /r/IsA | fn:committing_crime | "theft" | "committing crime" | "/r/is a" |  | "FN" |  |
| fn:committing_crime | /r/IsA | fn:misdeed | "committing crime" | "misdeed" | "/r/is a" |  | "FN" |  |
| fn:crime_scenario | /r/HasSubevent | fn:committing_crime | "crime scenario" | "committing crime" | "/r/has subevent" |  | "FN" |  |
| fn:committing_crime | /r/UsedFor | fn:offenses | "committing crime" | "offenses" | "/r/used for" |  | "FN" |  |
| fn:legality | /r/UsedFor | fn:committing_crime | "legality" | "committing crime" | "/r/used for" |  | "FN" |  |
| fn:criminal_investigation | /r/HasPrerequisite | fn:committing_crime | "criminal investigation" | "committing crime" | "/r/has prerequisite" |  | "FN" |  |
| fn:committing_crime | fn:HasLexicalUnit | fn:lu:committing_crime:commit | "committing crime" | "commit" | "has lexical unit" |  | "FN" |  |
| fn:committing_crime | fn:HasLexicalUnit | fn:lu:committing_crime:perpetrate | "committing crime" | "perpetrate" | "has lexical unit" |  | "FN" |  |
| fn:committing_crime | fn:HasLexicalUnit | fn:lu:committing_crime:crime | "committing crime" | "crime" | "has lexical unit" |  | "FN" |  |
| fn:committing_crime | fn:HasLexicalUnit | fn:lu:committing_crime:commission | "committing crime" | "commission" | "has lexical unit" |  | "FN" |  |
| fn:committing_crime | /r/HasA | fn:fe:perpetrator | "committing crime" | "perpetrator" | "/r/has a" |  | "FN" |  |
| fn:committing_crime | /r/HasA | fn:fe:crime | "committing crime" | "crime" | "/r/has a" |  | "FN" |  |
| fn:committing_crime | /r/HasA | fn:fe:purpose | "committing crime" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:committing_crime | /r/HasA | fn:fe:manner | "committing crime" | "manner" | "/r/has a" |  | "FN" |  |
| fn:committing_crime | /r/HasA | fn:fe:means | "committing crime" | "means" | "/r/has a" |  | "FN" |  |
| fn:committing_crime | /r/HasA | fn:fe:explanation | "committing crime" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:committing_crime | /r/HasA | fn:fe:time | "committing crime" | "time" | "/r/has a" |  | "FN" |  |
| fn:committing_crime | /r/HasA | fn:fe:place | "committing crime" | "place" | "/r/has a" |  | "FN" |  |
| fn:committing_crime | /r/HasA | fn:fe:instrument | "committing crime" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:committing_crime | /r/HasA | fn:fe:frequency | "committing crime" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:reciprocality | /r/UsedFor | fn:commonality | "reciprocality" | "commonality" | "/r/used for" |  | "FN" |  |
| fn:commonality | fn:HasLexicalUnit | fn:lu:commonality:mutual | "commonality" | "mutual" | "has lexical unit" |  | "FN" |  |
| fn:commonality | fn:HasLexicalUnit | fn:lu:commonality:shared | "commonality" | "shared" | "has lexical unit" |  | "FN" |  |
| fn:commonality | fn:HasLexicalUnit | fn:lu:commonality:common | "commonality" | "common" | "has lexical unit" |  | "FN" |  |
| fn:commonality | fn:HasLexicalUnit | fn:lu:commonality:in_common | "commonality" | "in common" | "has lexical unit" |  | "FN" |  |
| fn:commonality | fn:HasLexicalUnit | fn:lu:commonality:collective | "commonality" | "collective" | "has lexical unit" |  | "FN" |  |
| fn:commonality | fn:HasLexicalUnit | fn:lu:commonality:share | "commonality" | "share" | "has lexical unit" |  | "FN" |  |
| fn:commonality | /r/HasA | fn:fe:entities | "commonality" | "entities" | "/r/has a" |  | "FN" |  |
| fn:commonality | /r/HasA | fn:fe:commonality | "commonality" | "commonality" | "/r/has a" |  | "FN" |  |
| fn:fe:entity_1 | /r/HasPrerequisite | fn:fe:entity_2 | "entity 1" | "entity 2" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:entity_1 | /r/RelatedTo | fn:fe:entities | "entity 1" | "entities" | "/r/related to" |  | "FN" |  |
| fn:commonality | /r/HasA | fn:fe:entity_1 | "commonality" | "entity 1" | "/r/has a" |  | "FN" |  |
| fn:fe:entity_2 | /r/HasPrerequisite | fn:fe:entity_1 | "entity 2" | "entity 1" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:entity_2 | /r/RelatedTo | fn:fe:entities | "entity 2" | "entities" | "/r/related to" |  | "FN" |  |
| fn:commonality | /r/HasA | fn:fe:entity_2 | "commonality" | "entity 2" | "/r/has a" |  | "FN" |  |
| fn:categorization | /r/UsedFor | fn:communicate_categorization | "categorization" | "communicate categorization" | "/r/used for" |  | "FN" |  |
| fn:categorization | /r/SimilarTo | fn:communicate_categorization | "categorization" | "communicate categorization" | "/r/similar to" |  | "FN" |  |
| fn:communicate_categorization | fn:HasLexicalUnit | fn:lu:communicate_categorization:characterize | "communicate categorization" | "characterize" | "has lexical unit" |  | "FN" |  |
| fn:communicate_categorization | fn:HasLexicalUnit | fn:lu:communicate_categorization:depict | "communicate categorization" | "depict" | "has lexical unit" |  | "FN" |  |
| fn:communicate_categorization | fn:HasLexicalUnit | fn:lu:communicate_categorization:depiction | "communicate categorization" | "depiction" | "has lexical unit" |  | "FN" |  |
| fn:communicate_categorization | fn:HasLexicalUnit | fn:lu:communicate_categorization:describe | "communicate categorization" | "describe" | "has lexical unit" |  | "FN" |  |
| fn:communicate_categorization | fn:HasLexicalUnit | fn:lu:communicate_categorization:description | "communicate categorization" | "description" | "has lexical unit" |  | "FN" |  |
| fn:communicate_categorization | fn:HasLexicalUnit | fn:lu:communicate_categorization:portray | "communicate categorization" | "portray" | "has lexical unit" |  | "FN" |  |
| fn:communicate_categorization | fn:HasLexicalUnit | fn:lu:communicate_categorization:represent | "communicate categorization" | "represent" | "has lexical unit" |  | "FN" |  |
| fn:communicate_categorization | fn:HasLexicalUnit | fn:lu:communicate_categorization:representation | "communicate categorization" | "representation" | "has lexical unit" |  | "FN" |  |
| fn:communicate_categorization | fn:HasLexicalUnit | fn:lu:communicate_categorization:define | "communicate categorization" | "define" | "has lexical unit" |  | "FN" |  |
| fn:communicate_categorization | fn:HasLexicalUnit | fn:lu:communicate_categorization:definition | "communicate categorization" | "definition" | "has lexical unit" |  | "FN" |  |
| fn:communicate_categorization | fn:HasLexicalUnit | fn:lu:communicate_categorization:redefine | "communicate categorization" | "redefine" | "has lexical unit" |  | "FN" |  |
| fn:communicate_categorization | fn:HasLexicalUnit | fn:lu:communicate_categorization:redefinition | "communicate categorization" | "redefinition" | "has lexical unit" |  | "FN" |  |
| fn:communicate_categorization | fn:HasLexicalUnit | fn:lu:communicate_categorization:characterization | "communicate categorization" | "characterization" | "has lexical unit" |  | "FN" |  |
| fn:communicate_categorization | fn:HasLexicalUnit | fn:lu:communicate_categorization:treat | "communicate categorization" | "treat" | "has lexical unit" |  | "FN" |  |
| fn:communicate_categorization | fn:HasLexicalUnit | fn:lu:communicate_categorization:paint | "communicate categorization" | "paint" | "has lexical unit" |  | "FN" |  |
| fn:communicate_categorization | fn:HasLexicalUnit | fn:lu:communicate_categorization:cast | "communicate categorization" | "cast" | "has lexical unit" |  | "FN" |  |
| fn:communicate_categorization | fn:HasLexicalUnit | fn:lu:communicate_categorization:make_out_to_be | "communicate categorization" | "make out to be" | "has lexical unit" |  | "FN" |  |
| fn:communicate_categorization | /r/HasA | fn:fe:speaker | "communicate categorization" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:communicate_categorization | /r/HasA | fn:fe:category | "communicate categorization" | "category" | "/r/has a" |  | "FN" |  |
| fn:communicate_categorization | /r/HasA | fn:fe:item | "communicate categorization" | "item" | "/r/has a" |  | "FN" |  |
| fn:communicate_categorization | /r/HasA | fn:fe:means | "communicate categorization" | "means" | "/r/has a" |  | "FN" |  |
| fn:communicate_categorization | /r/HasA | fn:fe:medium | "communicate categorization" | "medium" | "/r/has a" |  | "FN" |  |
| fn:communicate_categorization | /r/HasA | fn:fe:time | "communicate categorization" | "time" | "/r/has a" |  | "FN" |  |
| fn:communicate_categorization | /r/HasA | fn:fe:place | "communicate categorization" | "place" | "/r/has a" |  | "FN" |  |
| fn:communicate_categorization | /r/HasA | fn:fe:circumstances | "communicate categorization" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:communicate_categorization | /r/HasA | fn:fe:criteria | "communicate categorization" | "criteria" | "/r/has a" |  | "FN" |  |
| fn:communicate_categorization | /r/HasA | fn:fe:manner | "communicate categorization" | "manner" | "/r/has a" |  | "FN" |  |
| fn:communicate_categorization | /r/HasA | fn:fe:duration | "communicate categorization" | "duration" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/IsA | fn:cause_to_perceive | "communication" | "cause to perceive" | "/r/is a" |  | "FN" |  |
| fn:communication_manner | /r/IsA | fn:communication | "communication manner" | "communication" | "/r/is a" |  | "FN" |  |
| fn:communication_noise | /r/IsA | fn:communication | "communication noise" | "communication" | "/r/is a" |  | "FN" |  |
| fn:communication_response | /r/IsA | fn:communication | "communication response" | "communication" | "/r/is a" |  | "FN" |  |
| fn:gesture | /r/IsA | fn:communication | "gesture" | "communication" | "/r/is a" |  | "FN" |  |
| fn:reassuring | /r/IsA | fn:communication | "reassuring" | "communication" | "/r/is a" |  | "FN" |  |
| fn:summarizing | /r/IsA | fn:communication | "summarizing" | "communication" | "/r/is a" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:attempt_suasion | "communication" | "attempt suasion" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:bail_decision | "communication" | "bail decision" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:candidness | "communication" | "candidness" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:claim_ownership | "communication" | "claim ownership" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:commitment | "communication" | "commitment" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:communication_means | "communication" | "communication means" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:concessive | "communication" | "concessive" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:contacting | "communication" | "contacting" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:convey_importance | "communication" | "convey importance" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:deny_or_grant_permission | "communication" | "deny or grant permission" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:discussion | "communication" | "discussion" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:encoding | "communication" | "encoding" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:entering_of_plea | "communication" | "entering of plea" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:expressing_publicly | "communication" | "expressing publicly" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:hearsay | "communication" | "hearsay" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:justifying | "communication" | "justifying" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:legal_rulings | "communication" | "legal rulings" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:name_conferral | "communication" | "name conferral" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:notification_of_charges | "communication" | "notification of charges" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:prevarication | "communication" | "prevarication" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:questioning | "communication" | "questioning" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:reasoning | "communication" | "reasoning" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:reporting | "communication" | "reporting" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:request | "communication" | "request" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:sentencing | "communication" | "sentencing" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:speak_on_topic | "communication" | "speak on topic" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:statement | "communication" | "statement" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:successfully_communicate_message | "communication" | "successfully communicate message" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:text_creation | "communication" | "text creation" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:verdict | "communication" | "verdict" | "/r/used for" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:volubility | "communication" | "volubility" | "/r/used for" |  | "FN" |  |
| fn:information | /r/UsedFor | fn:communication | "information" | "communication" | "/r/used for" |  | "FN" |  |
| fn:mention | /r/IsA | fn:communication | "mention" | "communication" | "/r/is a" |  | "FN" |  |
| fn:communication | fn:HasLexicalUnit | fn:lu:communication:communicate | "communication" | "communicate" | "has lexical unit" |  | "FN" |  |
| fn:communication | fn:HasLexicalUnit | fn:lu:communication:speech | "communication" | "speech" | "has lexical unit" |  | "FN" |  |
| fn:communication | fn:HasLexicalUnit | fn:lu:communication:indicate | "communication" | "indicate" | "has lexical unit" |  | "FN" |  |
| fn:communication | fn:HasLexicalUnit | fn:lu:communication:signal | "communication" | "signal" | "has lexical unit" |  | "FN" |  |
| fn:communication | fn:HasLexicalUnit | fn:lu:communication:communication_[act] | "communication" | "communication [act]" | "has lexical unit" |  | "FN" |  |
| fn:communication | fn:HasLexicalUnit | fn:lu:communication:communication_[entity] | "communication" | "communication [entity]" | "has lexical unit" |  | "FN" |  |
| fn:communication | fn:HasLexicalUnit | fn:lu:communication:contact | "communication" | "contact" | "has lexical unit" |  | "FN" |  |
| fn:communication | fn:HasLexicalUnit | fn:lu:communication:codeword | "communication" | "codeword" | "has lexical unit" |  | "FN" |  |
| fn:communication | fn:HasLexicalUnit | fn:lu:communication:password | "communication" | "password" | "has lexical unit" |  | "FN" |  |
| fn:communication | fn:HasLexicalUnit | fn:lu:communication:convey | "communication" | "convey" | "has lexical unit" |  | "FN" |  |
| fn:communication | fn:HasLexicalUnit | fn:lu:communication:say | "communication" | "say" | "has lexical unit" |  | "FN" |  |
| fn:communication | fn:HasLexicalUnit | fn:lu:communication:share | "communication" | "share" | "has lexical unit" |  | "FN" |  |
| fn:fe:communicator | /r/IsA | fn:st:sentient | "communicator" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:communication | /r/HasA | fn:fe:communicator | "communication" | "communicator" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/HasA | fn:fe:addressee | "communication" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/HasA | fn:fe:message | "communication" | "message" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/HasA | fn:fe:topic | "communication" | "topic" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/HasA | fn:fe:medium | "communication" | "medium" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/HasA | fn:fe:amount_of_information | "communication" | "amount of information" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/HasA | fn:fe:depictive | "communication" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/HasA | fn:fe:manner | "communication" | "manner" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/HasA | fn:fe:means | "communication" | "means" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/HasA | fn:fe:time | "communication" | "time" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/HasA | fn:fe:duration | "communication" | "duration" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/HasA | fn:fe:frequency | "communication" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/HasA | fn:fe:place | "communication" | "place" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/HasA | fn:fe:purpose | "communication" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/HasA | fn:fe:quote | "communication" | "quote" | "/r/has a" |  | "FN" |  |
| fn:communication_manner | /r/IsA | fn:communication | "communication manner" | "communication" | "/r/is a" |  | "FN" |  |
| fn:communication_manner | fn:HasLexicalUnit | fn:lu:communication_manner:babble | "communication manner" | "babble" | "has lexical unit" |  | "FN" |  |
| fn:communication_manner | fn:HasLexicalUnit | fn:lu:communication_manner:bluster | "communication manner" | "bluster" | "has lexical unit" |  | "FN" |  |
| fn:communication_manner | fn:HasLexicalUnit | fn:lu:communication_manner:chant | "communication manner" | "chant" | "has lexical unit" |  | "FN" |  |
| fn:communication_manner | fn:HasLexicalUnit | fn:lu:communication_manner:chatter | "communication manner" | "chatter" | "has lexical unit" |  | "FN" |  |
| fn:communication_manner | fn:HasLexicalUnit | fn:lu:communication_manner:drawl | "communication manner" | "drawl" | "has lexical unit" |  | "FN" |  |
| fn:communication_manner | fn:HasLexicalUnit | fn:lu:communication_manner:gabble | "communication manner" | "gabble" | "has lexical unit" |  | "FN" |  |
| fn:communication_manner | fn:HasLexicalUnit | fn:lu:communication_manner:gibber | "communication manner" | "gibber" | "has lexical unit" |  | "FN" |  |
| fn:communication_manner | fn:HasLexicalUnit | fn:lu:communication_manner:jabber | "communication manner" | "jabber" | "has lexical unit" |  | "FN" |  |
| fn:communication_manner | fn:HasLexicalUnit | fn:lu:communication_manner:lisp | "communication manner" | "lisp" | "has lexical unit" |  | "FN" |  |
| fn:communication_manner | fn:HasLexicalUnit | fn:lu:communication_manner:mouth | "communication manner" | "mouth" | "has lexical unit" |  | "FN" |  |
| fn:communication_manner | fn:HasLexicalUnit | fn:lu:communication_manner:mumble | "communication manner" | "mumble" | "has lexical unit" |  | "FN" |  |
| fn:communication_manner | fn:HasLexicalUnit | fn:lu:communication_manner:mutter | "communication manner" | "mutter" | "has lexical unit" |  | "FN" |  |
| fn:communication_manner | fn:HasLexicalUnit | fn:lu:communication_manner:natter | "communication manner" | "natter" | "has lexical unit" |  | "FN" |  |
| fn:communication_manner | fn:HasLexicalUnit | fn:lu:communication_manner:prattle | "communication manner" | "prattle" | "has lexical unit" |  | "FN" |  |
| fn:communication_manner | fn:HasLexicalUnit | fn:lu:communication_manner:rant | "communication manner" | "rant" | "has lexical unit" |  | "FN" |  |
| fn:communication_manner | fn:HasLexicalUnit | fn:lu:communication_manner:rave | "communication manner" | "rave" | "has lexical unit" |  | "FN" |  |
| fn:communication_manner | fn:HasLexicalUnit | fn:lu:communication_manner:shout | "communication manner" | "shout" | "has lexical unit" |  | "FN" |  |
| fn:communication_manner | fn:HasLexicalUnit | fn:lu:communication_manner:simper | "communication manner" | "simper" | "has lexical unit" |  | "FN" |  |
| fn:communication_manner | fn:HasLexicalUnit | fn:lu:communication_manner:sing | "communication manner" | "sing" | "has lexical unit" |  | "FN" |  |
| fn:communication_manner | fn:HasLexicalUnit | fn:lu:communication_manner:slur | "communication manner" | "slur" | "has lexical unit" |  | "FN" |  |
| fn:communication_manner | fn:HasLexicalUnit | fn:lu:communication_manner:stammer | "communication manner" | "stammer" | "has lexical unit" |  | "FN" |  |
| fn:communication_manner | fn:HasLexicalUnit | fn:lu:communication_manner:stutter | "communication manner" | "stutter" | "has lexical unit" |  | "FN" |  |
| fn:communication_manner | fn:HasLexicalUnit | fn:lu:communication_manner:whisper | "communication manner" | "whisper" | "has lexical unit" |  | "FN" |  |
| fn:communication_manner | fn:HasLexicalUnit | fn:lu:communication_manner:blabber | "communication manner" | "blabber" | "has lexical unit" |  | "FN" |  |
| fn:communication_manner | /r/HasA | fn:fe:speaker | "communication manner" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:communication_manner | /r/HasA | fn:fe:addressee | "communication manner" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:communication_manner | /r/HasA | fn:fe:message | "communication manner" | "message" | "/r/has a" |  | "FN" |  |
| fn:communication_manner | /r/HasA | fn:fe:topic | "communication manner" | "topic" | "/r/has a" |  | "FN" |  |
| fn:communication_manner | /r/HasA | fn:fe:medium | "communication manner" | "medium" | "/r/has a" |  | "FN" |  |
| fn:communication_manner | /r/HasA | fn:fe:manner | "communication manner" | "manner" | "/r/has a" |  | "FN" |  |
| fn:communication_manner | /r/HasA | fn:fe:depictive | "communication manner" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:communication_manner | /r/HasA | fn:fe:degree | "communication manner" | "degree" | "/r/has a" |  | "FN" |  |
| fn:communication_manner | /r/HasA | fn:fe:result | "communication manner" | "result" | "/r/has a" |  | "FN" |  |
| fn:communication_manner | /r/HasA | fn:fe:back | "communication manner" | "back" | "/r/has a" |  | "FN" |  |
| fn:communication_manner | /r/HasA | fn:fe:duration | "communication manner" | "duration" | "/r/has a" |  | "FN" |  |
| fn:communication_manner | /r/HasA | fn:fe:time | "communication manner" | "time" | "/r/has a" |  | "FN" |  |
| fn:communication_manner | /r/HasA | fn:fe:place | "communication manner" | "place" | "/r/has a" |  | "FN" |  |
| fn:fe:means | /r/IsA | fn:st:human_act | "means" | "human act" | "/r/is a" |  | "FN" |  |
| fn:st:human_act | /r/IsA | fn:st:ontological_type | "human act" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:st:human_act | /r/IsA | fn:st:intentional_act | "human act" | "intentional act" | "/r/is a" |  | "FN" |  |
| fn:communication_manner | /r/HasA | fn:fe:means | "communication manner" | "means" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:communication_means | "communication" | "communication means" | "/r/used for" |  | "FN" |  |
| fn:communication_means | /r/SimilarTo | fn:contacting | "communication means" | "contacting" | "/r/similar to" |  | "FN" |  |
| fn:communication_means | /r/SimilarTo | fn:sending | "communication means" | "sending" | "/r/similar to" |  | "FN" |  |
| fn:communication_means | fn:HasLexicalUnit | fn:lu:communication_means:cable | "communication means" | "cable" | "has lexical unit" |  | "FN" |  |
| fn:communication_means | fn:HasLexicalUnit | fn:lu:communication_means:wire | "communication means" | "wire" | "has lexical unit" |  | "FN" |  |
| fn:communication_means | fn:HasLexicalUnit | fn:lu:communication_means:phone | "communication means" | "phone" | "has lexical unit" |  | "FN" |  |
| fn:communication_means | fn:HasLexicalUnit | fn:lu:communication_means:semaphore | "communication means" | "semaphore" | "has lexical unit" |  | "FN" |  |
| fn:communication_means | fn:HasLexicalUnit | fn:lu:communication_means:telegraph | "communication means" | "telegraph" | "has lexical unit" |  | "FN" |  |
| fn:communication_means | fn:HasLexicalUnit | fn:lu:communication_means:telex | "communication means" | "telex" | "has lexical unit" |  | "FN" |  |
| fn:communication_means | fn:HasLexicalUnit | fn:lu:communication_means:radio | "communication means" | "radio" | "has lexical unit" |  | "FN" |  |
| fn:communication_means | fn:HasLexicalUnit | fn:lu:communication_means:telephone | "communication means" | "telephone" | "has lexical unit" |  | "FN" |  |
| fn:communication_means | fn:HasLexicalUnit | fn:lu:communication_means:fax | "communication means" | "fax" | "has lexical unit" |  | "FN" |  |
| fn:communication_means | fn:HasLexicalUnit | fn:lu:communication_means:call | "communication means" | "call" | "has lexical unit" |  | "FN" |  |
| fn:communication_means | fn:HasLexicalUnit | fn:lu:communication_means:pdf | "communication means" | "pdf" | "has lexical unit" |  | "FN" |  |
| fn:communication_means | /r/HasA | fn:fe:communicator | "communication means" | "communicator" | "/r/has a" |  | "FN" |  |
| fn:communication_means | /r/HasA | fn:fe:addressee | "communication means" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:communication_means | /r/HasA | fn:fe:message | "communication means" | "message" | "/r/has a" |  | "FN" |  |
| fn:communication_means | /r/HasA | fn:fe:topic | "communication means" | "topic" | "/r/has a" |  | "FN" |  |
| fn:communication_means | /r/HasA | fn:fe:manner | "communication means" | "manner" | "/r/has a" |  | "FN" |  |
| fn:communication_means | /r/HasA | fn:fe:means | "communication means" | "means" | "/r/has a" |  | "FN" |  |
| fn:communication_means | /r/HasA | fn:fe:explanation | "communication means" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:communication_means | /r/HasA | fn:fe:depictive | "communication means" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:communication_noise | /r/IsA | fn:communication | "communication noise" | "communication" | "/r/is a" |  | "FN" |  |
| fn:make_noise | /r/UsedFor | fn:communication_noise | "make noise" | "communication noise" | "/r/used for" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:babble | "communication noise" | "babble" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:bark | "communication noise" | "bark" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:bawl | "communication noise" | "bawl" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:bellow | "communication noise" | "bellow" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:bleat | "communication noise" | "bleat" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:bray | "communication noise" | "bray" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:burble | "communication noise" | "burble" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:cackle | "communication noise" | "cackle" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:chirp | "communication noise" | "chirp" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:chirrup | "communication noise" | "chirrup" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:chuckle | "communication noise" | "chuckle" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:cluck | "communication noise" | "cluck" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:coo | "communication noise" | "coo" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:croak | "communication noise" | "croak" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:croon | "communication noise" | "croon" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:crow | "communication noise" | "crow" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:cry | "communication noise" | "cry" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:drone | "communication noise" | "drone" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:gasp | "communication noise" | "gasp" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:grate | "communication noise" | "grate" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:groan | "communication noise" | "groan" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:growl | "communication noise" | "growl" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:grunt | "communication noise" | "grunt" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:gurgle | "communication noise" | "gurgle" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:hiss | "communication noise" | "hiss" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:hoot | "communication noise" | "hoot" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:howl | "communication noise" | "howl" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:moan | "communication noise" | "moan" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:murmur | "communication noise" | "murmur" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:purr | "communication noise" | "purr" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:rap | "communication noise" | "rap" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:rasp | "communication noise" | "rasp" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:rattle | "communication noise" | "rattle" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:roar | "communication noise" | "roar" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:rumble | "communication noise" | "rumble" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:scream | "communication noise" | "scream" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:screech | "communication noise" | "screech" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:shriek | "communication noise" | "shriek" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:shrill | "communication noise" | "shrill" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:snarl | "communication noise" | "snarl" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:snort | "communication noise" | "snort" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:splutter | "communication noise" | "splutter" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:sputter | "communication noise" | "sputter" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:squawk | "communication noise" | "squawk" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:squeak | "communication noise" | "squeak" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:squeal | "communication noise" | "squeal" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:thunder | "communication noise" | "thunder" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:titter | "communication noise" | "titter" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:trill | "communication noise" | "trill" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:trumpet | "communication noise" | "trumpet" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:twitter | "communication noise" | "twitter" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:wail | "communication noise" | "wail" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:warble | "communication noise" | "warble" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:wheeze | "communication noise" | "wheeze" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:whimper | "communication noise" | "whimper" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:whine | "communication noise" | "whine" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:whoop | "communication noise" | "whoop" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:yell | "communication noise" | "yell" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | fn:HasLexicalUnit | fn:lu:communication_noise:yelp | "communication noise" | "yelp" | "has lexical unit" |  | "FN" |  |
| fn:communication_noise | /r/HasA | fn:fe:speaker | "communication noise" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:communication_noise | /r/HasA | fn:fe:addressee | "communication noise" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:communication_noise | /r/HasA | fn:fe:message | "communication noise" | "message" | "/r/has a" |  | "FN" |  |
| fn:communication_noise | /r/HasA | fn:fe:topic | "communication noise" | "topic" | "/r/has a" |  | "FN" |  |
| fn:communication_noise | /r/HasA | fn:fe:medium | "communication noise" | "medium" | "/r/has a" |  | "FN" |  |
| fn:communication_noise | /r/HasA | fn:fe:depictive | "communication noise" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:communication_noise | /r/HasA | fn:fe:manner | "communication noise" | "manner" | "/r/has a" |  | "FN" |  |
| fn:communication_noise | /r/HasA | fn:fe:internal_cause | "communication noise" | "internal cause" | "/r/has a" |  | "FN" |  |
| fn:communication_noise | /r/HasA | fn:fe:degree | "communication noise" | "degree" | "/r/has a" |  | "FN" |  |
| fn:communication_noise | /r/HasA | fn:fe:means | "communication noise" | "means" | "/r/has a" |  | "FN" |  |
| fn:communication_noise | /r/HasA | fn:fe:voice | "communication noise" | "voice" | "/r/has a" |  | "FN" |  |
| fn:communication_noise | /r/HasA | fn:fe:place | "communication noise" | "place" | "/r/has a" |  | "FN" |  |
| fn:communication_noise | /r/HasA | fn:fe:explanation | "communication noise" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:communication_noise | /r/HasA | fn:fe:back | "communication noise" | "back" | "/r/has a" |  | "FN" |  |
| fn:communication_noise | /r/HasA | fn:fe:time | "communication noise" | "time" | "/r/has a" |  | "FN" |  |
| fn:communication_response | /r/IsA | fn:communication | "communication response" | "communication" | "/r/is a" |  | "FN" |  |
| fn:communication_response | /r/IsA | fn:response | "communication response" | "response" | "/r/is a" |  | "FN" |  |
| fn:communication_response | /r/UsedFor | fn:respond_to_proposal | "communication response" | "respond to proposal" | "/r/used for" |  | "FN" |  |
| fn:communication_response | fn:HasLexicalUnit | fn:lu:communication_response:answer | "communication response" | "answer" | "has lexical unit" |  | "FN" |  |
| fn:communication_response | fn:HasLexicalUnit | fn:lu:communication_response:answer | "communication response" | "answer" | "has lexical unit" |  | "FN" |  |
| fn:communication_response | fn:HasLexicalUnit | fn:lu:communication_response:comeback | "communication response" | "comeback" | "has lexical unit" |  | "FN" |  |
| fn:communication_response | fn:HasLexicalUnit | fn:lu:communication_response:counter | "communication response" | "counter" | "has lexical unit" |  | "FN" |  |
| fn:communication_response | fn:HasLexicalUnit | fn:lu:communication_response:rejoin | "communication response" | "rejoin" | "has lexical unit" |  | "FN" |  |
| fn:communication_response | fn:HasLexicalUnit | fn:lu:communication_response:rejoinder | "communication response" | "rejoinder" | "has lexical unit" |  | "FN" |  |
| fn:communication_response | fn:HasLexicalUnit | fn:lu:communication_response:reply | "communication response" | "reply" | "has lexical unit" |  | "FN" |  |
| fn:communication_response | fn:HasLexicalUnit | fn:lu:communication_response:reply | "communication response" | "reply" | "has lexical unit" |  | "FN" |  |
| fn:communication_response | fn:HasLexicalUnit | fn:lu:communication_response:respond | "communication response" | "respond" | "has lexical unit" |  | "FN" |  |
| fn:communication_response | fn:HasLexicalUnit | fn:lu:communication_response:response | "communication response" | "response" | "has lexical unit" |  | "FN" |  |
| fn:communication_response | fn:HasLexicalUnit | fn:lu:communication_response:retort | "communication response" | "retort" | "has lexical unit" |  | "FN" |  |
| fn:communication_response | fn:HasLexicalUnit | fn:lu:communication_response:retort | "communication response" | "retort" | "has lexical unit" |  | "FN" |  |
| fn:communication_response | fn:HasLexicalUnit | fn:lu:communication_response:riposte | "communication response" | "riposte" | "has lexical unit" |  | "FN" |  |
| fn:communication_response | fn:HasLexicalUnit | fn:lu:communication_response:come_back | "communication response" | "come back" | "has lexical unit" |  | "FN" |  |
| fn:communication_response | fn:HasLexicalUnit | fn:lu:communication_response:reaction | "communication response" | "reaction" | "has lexical unit" |  | "FN" |  |
| fn:communication_response | fn:HasLexicalUnit | fn:lu:communication_response:acknowledge | "communication response" | "acknowledge" | "has lexical unit" |  | "FN" |  |
| fn:communication_response | /r/HasA | fn:fe:speaker | "communication response" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:communication_response | /r/HasA | fn:fe:addressee | "communication response" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:communication_response | /r/HasA | fn:fe:message | "communication response" | "message" | "/r/has a" |  | "FN" |  |
| fn:communication_response | /r/HasA | fn:fe:topic | "communication response" | "topic" | "/r/has a" |  | "FN" |  |
| fn:communication_response | /r/HasA | fn:fe:medium | "communication response" | "medium" | "/r/has a" |  | "FN" |  |
| fn:communication_response | /r/HasA | fn:fe:trigger | "communication response" | "trigger" | "/r/has a" |  | "FN" |  |
| fn:communication_response | /r/HasA | fn:fe:manner | "communication response" | "manner" | "/r/has a" |  | "FN" |  |
| fn:communication_response | /r/HasA | fn:fe:depictive | "communication response" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:communication_response | /r/HasA | fn:fe:means | "communication response" | "means" | "/r/has a" |  | "FN" |  |
| fn:communication_response | /r/HasA | fn:fe:internal_cause | "communication response" | "internal cause" | "/r/has a" |  | "FN" |  |
| fn:communication_response | /r/HasA | fn:fe:place | "communication response" | "place" | "/r/has a" |  | "FN" |  |
| fn:communication_response | /r/HasA | fn:fe:time | "communication response" | "time" | "/r/has a" |  | "FN" |  |
| fn:communication_response | /r/HasA | fn:fe:purpose | "communication response" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:communication_response | /r/HasA | fn:fe:duration | "communication response" | "duration" | "/r/has a" |  | "FN" |  |
| fn:clemency | /r/UsedFor | fn:commutation | "clemency" | "commutation" | "/r/used for" |  | "FN" |  |
| fn:commutation | fn:HasLexicalUnit | fn:lu:commutation:commute | "commutation" | "commute" | "has lexical unit" |  | "FN" |  |
| fn:commutation | fn:HasLexicalUnit | fn:lu:commutation:commutation | "commutation" | "commutation" | "has lexical unit" |  | "FN" |  |
| fn:commutation | /r/HasA | fn:fe:offender | "commutation" | "offender" | "/r/has a" |  | "FN" |  |
| fn:commutation | /r/HasA | fn:fe:executive_authority | "commutation" | "executive authority" | "/r/has a" |  | "FN" |  |
| fn:commutation | /r/HasA | fn:fe:explanation | "commutation" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:commutation | /r/HasA | fn:fe:time | "commutation" | "time" | "/r/has a" |  | "FN" |  |
| fn:commutation | /r/HasA | fn:fe:original_punishment | "commutation" | "original punishment" | "/r/has a" |  | "FN" |  |
| fn:commutation | /r/HasA | fn:fe:new_punishment | "commutation" | "new punishment" | "/r/has a" |  | "FN" |  |
| fn:commutation | /r/HasA | fn:fe:manner | "commutation" | "manner" | "/r/has a" |  | "FN" |  |
| fn:commutation | /r/HasA | fn:fe:place | "commutation" | "place" | "/r/has a" |  | "FN" |  |
| fn:commutation | /r/HasA | fn:fe:means | "commutation" | "means" | "/r/has a" |  | "FN" |  |
| fn:commutative_process | /r/IsA | fn:arithmetic_commutative | "commutative process" | "arithmetic commutative" | "/r/is a" |  | "FN" |  |
| fn:commutative_process | fn:HasLexicalUnit | fn:lu:commutative_process:add | "commutative process" | "add" | "has lexical unit" |  | "FN" |  |
| fn:commutative_process | fn:HasLexicalUnit | fn:lu:commutative_process:multiply | "commutative process" | "multiply" | "has lexical unit" |  | "FN" |  |
| fn:commutative_process | fn:HasLexicalUnit | fn:lu:commutative_process:addition | "commutative process" | "addition" | "has lexical unit" |  | "FN" |  |
| fn:commutative_process | fn:HasLexicalUnit | fn:lu:commutative_process:multiplication | "commutative process" | "multiplication" | "has lexical unit" |  | "FN" |  |
| fn:commutative_process | /r/HasA | fn:fe:term1 | "commutative process" | "term1" | "/r/has a" |  | "FN" |  |
| fn:commutative_process | /r/HasA | fn:fe:term2 | "commutative process" | "term2" | "/r/has a" |  | "FN" |  |
| fn:commutative_process | /r/HasA | fn:fe:terms | "commutative process" | "terms" | "/r/has a" |  | "FN" |  |
| fn:commutative_process | /r/HasA | fn:fe:calculator | "commutative process" | "calculator" | "/r/has a" |  | "FN" |  |
| fn:commutative_statement | /r/IsA | fn:arithmetic_commutative | "commutative statement" | "arithmetic commutative" | "/r/is a" |  | "FN" |  |
| fn:commutative_statement | fn:HasLexicalUnit | fn:lu:commutative_statement:sum | "commutative statement" | "sum" | "has lexical unit" |  | "FN" |  |
| fn:commutative_statement | fn:HasLexicalUnit | fn:lu:commutative_statement:product | "commutative statement" | "product" | "has lexical unit" |  | "FN" |  |
| fn:commutative_statement | fn:HasLexicalUnit | fn:lu:commutative_statement:times | "commutative statement" | "times" | "has lexical unit" |  | "FN" |  |
| fn:commutative_statement | /r/HasA | fn:fe:result | "commutative statement" | "result" | "/r/has a" |  | "FN" |  |
| fn:commutative_statement | /r/HasA | fn:fe:term1 | "commutative statement" | "term1" | "/r/has a" |  | "FN" |  |
| fn:commutative_statement | /r/HasA | fn:fe:term2 | "commutative statement" | "term2" | "/r/has a" |  | "FN" |  |
| fn:commutative_statement | /r/HasA | fn:fe:terms | "commutative statement" | "terms" | "/r/has a" |  | "FN" |  |
| fn:compatibility | /r/IsA | fn:gradable_attributes | "compatibility" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:compatibility | fn:HasLexicalUnit | fn:lu:compatibility:compatible | "compatibility" | "compatible" | "has lexical unit" |  | "FN" |  |
| fn:compatibility | fn:HasLexicalUnit | fn:lu:compatibility:incompatible | "compatibility" | "incompatible" | "has lexical unit" |  | "FN" |  |
| fn:compatibility | fn:HasLexicalUnit | fn:lu:compatibility:incompatibility | "compatibility" | "incompatibility" | "has lexical unit" |  | "FN" |  |
| fn:compatibility | fn:HasLexicalUnit | fn:lu:compatibility:compatibility | "compatibility" | "compatibility" | "has lexical unit" |  | "FN" |  |
| fn:compatibility | fn:HasLexicalUnit | fn:lu:compatibility:harmonize | "compatibility" | "harmonize" | "has lexical unit" |  | "FN" |  |
| fn:compatibility | fn:HasLexicalUnit | fn:lu:compatibility:congruent | "compatibility" | "congruent" | "has lexical unit" |  | "FN" |  |
| fn:compatibility | fn:HasLexicalUnit | fn:lu:compatibility:congruous | "compatibility" | "congruous" | "has lexical unit" |  | "FN" |  |
| fn:compatibility | fn:HasLexicalUnit | fn:lu:compatibility:consonant | "compatibility" | "consonant" | "has lexical unit" |  | "FN" |  |
| fn:compatibility | fn:HasLexicalUnit | fn:lu:compatibility:dovetail | "compatibility" | "dovetail" | "has lexical unit" |  | "FN" |  |
| fn:compatibility | fn:HasLexicalUnit | fn:lu:compatibility:jibe | "compatibility" | "jibe" | "has lexical unit" |  | "FN" |  |
| fn:compatibility | fn:HasLexicalUnit | fn:lu:compatibility:square | "compatibility" | "square" | "has lexical unit" |  | "FN" |  |
| fn:compatibility | fn:HasLexicalUnit | fn:lu:compatibility:comport | "compatibility" | "comport" | "has lexical unit" |  | "FN" |  |
| fn:compatibility | fn:HasLexicalUnit | fn:lu:compatibility:rhyme | "compatibility" | "rhyme" | "has lexical unit" |  | "FN" |  |
| fn:compatibility | fn:HasLexicalUnit | fn:lu:compatibility:accord | "compatibility" | "accord" | "has lexical unit" |  | "FN" |  |
| fn:compatibility | fn:HasLexicalUnit | fn:lu:compatibility:agree | "compatibility" | "agree" | "has lexical unit" |  | "FN" |  |
| fn:compatibility | fn:HasLexicalUnit | fn:lu:compatibility:cohere | "compatibility" | "cohere" | "has lexical unit" |  | "FN" |  |
| fn:compatibility | fn:HasLexicalUnit | fn:lu:compatibility:consistent | "compatibility" | "consistent" | "has lexical unit" |  | "FN" |  |
| fn:compatibility | fn:HasLexicalUnit | fn:lu:compatibility:harmony | "compatibility" | "harmony" | "has lexical unit" |  | "FN" |  |
| fn:compatibility | fn:HasLexicalUnit | fn:lu:compatibility:go | "compatibility" | "go" | "has lexical unit" |  | "FN" |  |
| fn:compatibility | fn:HasLexicalUnit | fn:lu:compatibility:clash | "compatibility" | "clash" | "has lexical unit" |  | "FN" |  |
| fn:compatibility | fn:HasLexicalUnit | fn:lu:compatibility:match | "compatibility" | "match" | "has lexical unit" |  | "FN" |  |
| fn:compatibility | fn:HasLexicalUnit | fn:lu:compatibility:biocompatible | "compatibility" | "biocompatible" | "has lexical unit" |  | "FN" |  |
| fn:compatibility | fn:HasLexicalUnit | fn:lu:compatibility:conflict | "compatibility" | "conflict" | "has lexical unit" |  | "FN" |  |
| fn:compatibility | fn:HasLexicalUnit | fn:lu:compatibility:conflicting | "compatibility" | "conflicting" | "has lexical unit" |  | "FN" |  |
| fn:compatibility | fn:HasLexicalUnit | fn:lu:compatibility:at_variance | "compatibility" | "at variance" | "has lexical unit" |  | "FN" |  |
| fn:compatibility | fn:HasLexicalUnit | fn:lu:compatibility:fly_in_the_face_of | "compatibility" | "fly in the face of" | "has lexical unit" |  | "FN" |  |
| fn:fe:item_1 | /r/HasPrerequisite | fn:fe:item_2 | "item 1" | "item 2" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:item_1 | /r/RelatedTo | fn:fe:items | "item 1" | "items" | "/r/related to" |  | "FN" |  |
| fn:compatibility | /r/HasA | fn:fe:item_1 | "compatibility" | "item 1" | "/r/has a" |  | "FN" |  |
| fn:fe:item_2 | /r/HasPrerequisite | fn:fe:item_1 | "item 2" | "item 1" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:item_2 | /r/RelatedTo | fn:fe:items | "item 2" | "items" | "/r/related to" |  | "FN" |  |
| fn:compatibility | /r/HasA | fn:fe:item_2 | "compatibility" | "item 2" | "/r/has a" |  | "FN" |  |
| fn:compatibility | /r/HasA | fn:fe:items | "compatibility" | "items" | "/r/has a" |  | "FN" |  |
| fn:compatibility | /r/HasA | fn:fe:degree | "compatibility" | "degree" | "/r/has a" |  | "FN" |  |
| fn:compatibility | /r/HasA | fn:fe:parameter | "compatibility" | "parameter" | "/r/has a" |  | "FN" |  |
| fn:competition | /r/HasSubevent | fn:finish_competition | "competition" | "finish competition" | "/r/has subevent" |  | "FN" |  |
| fn:competition | /r/UsedFor | fn:alliance | "competition" | "alliance" | "/r/used for" |  | "FN" |  |
| fn:competition | /r/UsedFor | fn:sports_jargon | "competition" | "sports jargon" | "/r/used for" |  | "FN" |  |
| fn:intentionally_act | /r/UsedFor | fn:competition | "intentionally act" | "competition" | "/r/used for" |  | "FN" |  |
| fn:competition | /r/SimilarTo | fn:finish_competition | "competition" | "finish competition" | "/r/similar to" |  | "FN" |  |
| fn:competition | fn:HasLexicalUnit | fn:lu:competition:competition | "competition" | "competition" | "has lexical unit" |  | "FN" |  |
| fn:competition | fn:HasLexicalUnit | fn:lu:competition:competitive | "competition" | "competitive" | "has lexical unit" |  | "FN" |  |
| fn:competition | fn:HasLexicalUnit | fn:lu:competition:competitor | "competition" | "competitor" | "has lexical unit" |  | "FN" |  |
| fn:competition | fn:HasLexicalUnit | fn:lu:competition:compete | "competition" | "compete" | "has lexical unit" |  | "FN" |  |
| fn:competition | fn:HasLexicalUnit | fn:lu:competition:play | "competition" | "play" | "has lexical unit" |  | "FN" |  |
| fn:competition | fn:HasLexicalUnit | fn:lu:competition:challenge | "competition" | "challenge" | "has lexical unit" |  | "FN" |  |
| fn:competition | fn:HasLexicalUnit | fn:lu:competition:rivalry | "competition" | "rivalry" | "has lexical unit" |  | "FN" |  |
| fn:competition | fn:HasLexicalUnit | fn:lu:competition:rival | "competition" | "rival" | "has lexical unit" |  | "FN" |  |
| fn:competition | fn:HasLexicalUnit | fn:lu:competition:player | "competition" | "player" | "has lexical unit" |  | "FN" |  |
| fn:fe:participant_1 | /r/RelatedTo | fn:fe:participants | "participant 1" | "participants" | "/r/related to" |  | "FN" |  |
| fn:competition | /r/HasA | fn:fe:participant_1 | "competition" | "participant 1" | "/r/has a" |  | "FN" |  |
| fn:fe:participant_2 | /r/HasPrerequisite | fn:fe:participant_1 | "participant 2" | "participant 1" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:participant_2 | /r/RelatedTo | fn:fe:participants | "participant 2" | "participants" | "/r/related to" |  | "FN" |  |
| fn:competition | /r/HasA | fn:fe:participant_2 | "competition" | "participant 2" | "/r/has a" |  | "FN" |  |
| fn:competition | /r/HasA | fn:fe:participants | "competition" | "participants" | "/r/has a" |  | "FN" |  |
| fn:competition | /r/HasA | fn:fe:competition | "competition" | "competition" | "/r/has a" |  | "FN" |  |
| fn:competition | /r/HasA | fn:fe:score | "competition" | "score" | "/r/has a" |  | "FN" |  |
| fn:competition | /r/HasA | fn:fe:rank | "competition" | "rank" | "/r/has a" |  | "FN" |  |
| fn:competition | /r/HasA | fn:fe:prize | "competition" | "prize" | "/r/has a" |  | "FN" |  |
| fn:competition | /r/HasA | fn:fe:venue | "competition" | "venue" | "/r/has a" |  | "FN" |  |
| fn:competition | /r/HasA | fn:fe:place | "competition" | "place" | "/r/has a" |  | "FN" |  |
| fn:competition | /r/HasA | fn:fe:manner | "competition" | "manner" | "/r/has a" |  | "FN" |  |
| fn:competition | /r/HasA | fn:fe:means | "competition" | "means" | "/r/has a" |  | "FN" |  |
| fn:competition | /r/HasA | fn:fe:time | "competition" | "time" | "/r/has a" |  | "FN" |  |
| fn:competition | /r/HasA | fn:fe:duration | "competition" | "duration" | "/r/has a" |  | "FN" |  |
| fn:competition | /r/HasA | fn:fe:purpose | "competition" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:competition | /r/HasA | fn:fe:degree | "competition" | "degree" | "/r/has a" |  | "FN" |  |
| fn:competition | /r/HasA | fn:fe:frequency | "competition" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:complaining | /r/IsA | fn:statement | "complaining" | "statement" | "/r/is a" |  | "FN" |  |
| fn:statement | /r/SimilarTo | fn:complaining | "statement" | "complaining" | "/r/similar to" |  | "FN" |  |
| fn:complaining | fn:HasLexicalUnit | fn:lu:complaining:whinge | "complaining" | "whinge" | "has lexical unit" |  | "FN" |  |
| fn:complaining | fn:HasLexicalUnit | fn:lu:complaining:whine | "complaining" | "whine" | "has lexical unit" |  | "FN" |  |
| fn:complaining | fn:HasLexicalUnit | fn:lu:complaining:complain | "complaining" | "complain" | "has lexical unit" |  | "FN" |  |
| fn:complaining | fn:HasLexicalUnit | fn:lu:complaining:moan | "complaining" | "moan" | "has lexical unit" |  | "FN" |  |
| fn:complaining | fn:HasLexicalUnit | fn:lu:complaining:bitch | "complaining" | "bitch" | "has lexical unit" |  | "FN" |  |
| fn:complaining | fn:HasLexicalUnit | fn:lu:complaining:complaint | "complaining" | "complaint" | "has lexical unit" |  | "FN" |  |
| fn:complaining | fn:HasLexicalUnit | fn:lu:complaining:grouse | "complaining" | "grouse" | "has lexical unit" |  | "FN" |  |
| fn:complaining | fn:HasLexicalUnit | fn:lu:complaining:lament | "complaining" | "lament" | "has lexical unit" |  | "FN" |  |
| fn:complaining | fn:HasLexicalUnit | fn:lu:complaining:gripe | "complaining" | "gripe" | "has lexical unit" |  | "FN" |  |
| fn:complaining | fn:HasLexicalUnit | fn:lu:complaining:belly-ache | "complaining" | "belly-ache" | "has lexical unit" |  | "FN" |  |
| fn:complaining | fn:HasLexicalUnit | fn:lu:complaining:gripe | "complaining" | "gripe" | "has lexical unit" |  | "FN" |  |
| fn:complaining | fn:HasLexicalUnit | fn:lu:complaining:piss_and_moan | "complaining" | "piss and moan" | "has lexical unit" |  | "FN" |  |
| fn:complaining | fn:HasLexicalUnit | fn:lu:complaining:grumble | "complaining" | "grumble" | "has lexical unit" |  | "FN" |  |
| fn:complaining | fn:HasLexicalUnit | fn:lu:complaining:grousing | "complaining" | "grousing" | "has lexical unit" |  | "FN" |  |
| fn:complaining | fn:HasLexicalUnit | fn:lu:complaining:grievance | "complaining" | "grievance" | "has lexical unit" |  | "FN" |  |
| fn:fe:complainer | /r/IsA | fn:st:sentient | "complainer" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:complaining | /r/HasA | fn:fe:complainer | "complaining" | "complainer" | "/r/has a" |  | "FN" |  |
| fn:complaining | /r/HasA | fn:fe:addressee | "complaining" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:complaining | /r/HasA | fn:fe:complaint | "complaining" | "complaint" | "/r/has a" |  | "FN" |  |
| fn:complaining | /r/HasA | fn:fe:topic | "complaining" | "topic" | "/r/has a" |  | "FN" |  |
| fn:complaining | /r/HasA | fn:fe:manner | "complaining" | "manner" | "/r/has a" |  | "FN" |  |
| fn:complaining | /r/HasA | fn:fe:frequency | "complaining" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:complaining | /r/HasA | fn:fe:means | "complaining" | "means" | "/r/has a" |  | "FN" |  |
| fn:complaining | /r/HasA | fn:fe:internal_cause | "complaining" | "internal cause" | "/r/has a" |  | "FN" |  |
| fn:complaining | /r/HasA | fn:fe:medium | "complaining" | "medium" | "/r/has a" |  | "FN" |  |
| fn:complaining | /r/HasA | fn:fe:depictive | "complaining" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:complaining | /r/HasA | fn:fe:time | "complaining" | "time" | "/r/has a" |  | "FN" |  |
| fn:complaining | /r/HasA | fn:fe:place | "complaining" | "place" | "/r/has a" |  | "FN" |  |
| fn:complaining | /r/HasA | fn:fe:particular_iteration | "complaining" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:complaining | /r/HasA | fn:fe:degree | "complaining" | "degree" | "/r/has a" |  | "FN" |  |
| fn:complaining | /r/HasA | fn:fe:occasion | "complaining" | "occasion" | "/r/has a" |  | "FN" |  |
| fn:complaining | /r/HasA | fn:fe:explanation | "complaining" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:complaining | /r/HasA | fn:fe:result | "complaining" | "result" | "/r/has a" |  | "FN" |  |
| fn:completeness | /r/IsA | fn:gradable_attributes | "completeness" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:part_whole | /r/UsedFor | fn:completeness | "part whole" | "completeness" | "/r/used for" |  | "FN" |  |
| fn:ranked_expectation | /r/RelatedTo | fn:completeness | "ranked expectation" | "completeness" | "/r/related to" |  | "FN" |  |
| fn:completeness | fn:HasLexicalUnit | fn:lu:completeness:complete | "completeness" | "complete" | "has lexical unit" |  | "FN" |  |
| fn:completeness | fn:HasLexicalUnit | fn:lu:completeness:incomplete | "completeness" | "incomplete" | "has lexical unit" |  | "FN" |  |
| fn:completeness | fn:HasLexicalUnit | fn:lu:completeness:completeness | "completeness" | "completeness" | "has lexical unit" |  | "FN" |  |
| fn:completeness | fn:HasLexicalUnit | fn:lu:completeness:total | "completeness" | "total" | "has lexical unit" |  | "FN" |  |
| fn:completeness | fn:HasLexicalUnit | fn:lu:completeness:full | "completeness" | "full" | "has lexical unit" |  | "FN" |  |
| fn:completeness | /r/HasA | fn:fe:degree | "completeness" | "degree" | "/r/has a" |  | "FN" |  |
| fn:completeness | /r/HasA | fn:fe:whole | "completeness" | "whole" | "/r/has a" |  | "FN" |  |
| fn:completeness | /r/HasA | fn:fe:time | "completeness" | "time" | "/r/has a" |  | "FN" |  |
| fn:compliance | /r/IsA | fn:satisfying | "compliance" | "satisfying" | "/r/is a" |  | "FN" |  |
| fn:compliance | /r/IsA | fn:social_behavior_evaluation | "compliance" | "social behavior evaluation" | "/r/is a" |  | "FN" |  |
| fn:compliance | /r/UsedFor | fn:legality | "compliance" | "legality" | "/r/used for" |  | "FN" |  |
| fn:compliance | /r/UsedFor | fn:strictness | "compliance" | "strictness" | "/r/used for" |  | "FN" |  |
| fn:obligation_scenario | /r/UsedFor | fn:compliance | "obligation scenario" | "compliance" | "/r/used for" |  | "FN" |  |
| fn:compliance | /r/SimilarTo | fn:giving_in | "compliance" | "giving in" | "/r/similar to" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:adhere | "compliance" | "adhere" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:comply | "compliance" | "comply" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:observe | "compliance" | "observe" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:adherence | "compliance" | "adherence" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:compliance | "compliance" | "compliance" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:follow | "compliance" | "follow" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:observance | "compliance" | "observance" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:break | "compliance" | "break" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:violate | "compliance" | "violate" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:contravene | "compliance" | "contravene" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:breach | "compliance" | "breach" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:violation | "compliance" | "violation" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:contravention | "compliance" | "contravention" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:breach | "compliance" | "breach" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:flout | "compliance" | "flout" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:conform | "compliance" | "conform" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:obey | "compliance" | "obey" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:compliant | "compliance" | "compliant" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:transgress | "compliance" | "transgress" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:transgression | "compliance" | "transgression" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:lawless | "compliance" | "lawless" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:contrary | "compliance" | "contrary" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:conformity | "compliance" | "conformity" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:keep | "compliance" | "keep" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:honor | "compliance" | "honor" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:abide_(by) | "compliance" | "abide (by)" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:obedient | "compliance" | "obedient" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:observant | "compliance" | "observant" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:play_by_the_rules | "compliance" | "play by the rules" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:circumvent | "compliance" | "circumvent" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:noncompliance | "compliance" | "noncompliance" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:(in/out_of)_line | "compliance" | "(in/out of) line" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:disobey | "compliance" | "disobey" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:in_accordance | "compliance" | "in accordance" | "has lexical unit" |  | "FN" |  |
| fn:compliance | fn:HasLexicalUnit | fn:lu:compliance:by-pass | "compliance" | "by-pass" | "has lexical unit" |  | "FN" |  |
| fn:compliance | /r/HasA | fn:fe:protagonist | "compliance" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:fe:act | /r/IsA | fn:st:state_of_affairs | "act" | "state of affairs" | "/r/is a" |  | "FN" |  |
| fn:compliance | /r/HasA | fn:fe:act | "compliance" | "act" | "/r/has a" |  | "FN" |  |
| fn:compliance | /r/HasA | fn:fe:state_of_affairs | "compliance" | "state of affairs" | "/r/has a" |  | "FN" |  |
| fn:compliance | /r/HasA | fn:fe:norm | "compliance" | "norm" | "/r/has a" |  | "FN" |  |
| fn:compliance | /r/HasA | fn:fe:degree | "compliance" | "degree" | "/r/has a" |  | "FN" |  |
| fn:compliance | /r/HasA | fn:fe:depictive | "compliance" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:compliance | /r/HasA | fn:fe:manner | "compliance" | "manner" | "/r/has a" |  | "FN" |  |
| fn:compliance | /r/HasA | fn:fe:means | "compliance" | "means" | "/r/has a" |  | "FN" |  |
| fn:compliance | /r/HasA | fn:fe:result | "compliance" | "result" | "/r/has a" |  | "FN" |  |
| fn:compliance | /r/HasA | fn:fe:time | "compliance" | "time" | "/r/has a" |  | "FN" |  |
| fn:compliance | /r/HasA | fn:fe:explanation | "compliance" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:compliance | /r/HasA | fn:fe:judge | "compliance" | "judge" | "/r/has a" |  | "FN" |  |
| fn:contrary_circumstances | /r/IsA | fn:concessive | "contrary circumstances" | "concessive" | "/r/is a" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:concessive | "communication" | "concessive" | "/r/used for" |  | "FN" |  |
| fn:presentation_of_mitigation | /r/RelatedTo | fn:concessive | "presentation of mitigation" | "concessive" | "/r/related to" |  | "FN" |  |
| fn:concessive | fn:HasLexicalUnit | fn:lu:concessive:despite | "concessive" | "despite" | "has lexical unit" |  | "FN" |  |
| fn:concessive | fn:HasLexicalUnit | fn:lu:concessive:in_spite_of | "concessive" | "in spite of" | "has lexical unit" |  | "FN" |  |
| fn:concessive | fn:HasLexicalUnit | fn:lu:concessive:though | "concessive" | "though" | "has lexical unit" |  | "FN" |  |
| fn:concessive | fn:HasLexicalUnit | fn:lu:concessive:although | "concessive" | "although" | "has lexical unit" |  | "FN" |  |
| fn:concessive | fn:HasLexicalUnit | fn:lu:concessive:while | "concessive" | "while" | "has lexical unit" |  | "FN" |  |
| fn:concessive | fn:HasLexicalUnit | fn:lu:concessive:if | "concessive" | "if" | "has lexical unit" |  | "FN" |  |
| fn:concessive | fn:HasLexicalUnit | fn:lu:concessive:much_as | "concessive" | "much as" | "has lexical unit" |  | "FN" |  |
| fn:fe:conceded_state_of_affairs | /r/IsA | fn:st:message | "conceded state of affairs" | "message" | "/r/is a" |  | "FN" |  |
| fn:concessive | /r/HasA | fn:fe:conceded_state_of_affairs | "concessive" | "conceded state of affairs" | "/r/has a" |  | "FN" |  |
| fn:fe:topic | /r/RelatedTo | fn:fe:conceded_state_of_affairs | "topic" | "conceded state of affairs" | "/r/related to" |  | "FN" |  |
| fn:concessive | /r/HasA | fn:fe:topic | "concessive" | "topic" | "/r/has a" |  | "FN" |  |
| fn:concessive | /r/HasA | fn:fe:main_assertion | "concessive" | "main assertion" | "/r/has a" |  | "FN" |  |
| fn:medical_conditions | /r/UsedFor | fn:condition_symptom_relation | "medical conditions" | "condition symptom relation" | "/r/used for" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:manifest | "condition symptom relation" | "manifest" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:manifest | "condition symptom relation" | "manifest" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:present | "condition symptom relation" | "present" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:symptom | "condition symptom relation" | "symptom" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:symptomatic | "condition symptom relation" | "symptomatic" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:asymptomatic | "condition symptom relation" | "asymptomatic" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:cause | "condition symptom relation" | "cause" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:cause | "condition symptom relation" | "cause" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:associate | "condition symptom relation" | "associate" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:mimic | "condition symptom relation" | "mimic" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:show | "condition symptom relation" | "show" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:see | "condition symptom relation" | "see" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:produce | "condition symptom relation" | "produce" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:link | "condition symptom relation" | "link" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:include | "condition symptom relation" | "include" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:relate | "condition symptom relation" | "relate" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:characterize | "condition symptom relation" | "characterize" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:due_to | "condition symptom relation" | "due to" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:result | "condition symptom relation" | "result" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:consequence | "condition symptom relation" | "consequence" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:contribute | "condition symptom relation" | "contribute" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:induce | "condition symptom relation" | "induce" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:present | "condition symptom relation" | "present" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:provoke | "condition symptom relation" | "provoke" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:result | "condition symptom relation" | "result" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:lead | "condition symptom relation" | "lead" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:indicate | "condition symptom relation" | "indicate" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:uncommon | "condition symptom relation" | "uncommon" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:common | "condition symptom relation" | "common" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:suggest | "condition symptom relation" | "suggest" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:damage | "condition symptom relation" | "damage" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:occur | "condition symptom relation" | "occur" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:observe | "condition symptom relation" | "observe" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:characteristic | "condition symptom relation" | "characteristic" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | fn:HasLexicalUnit | fn:lu:condition_symptom_relation:frequent | "condition symptom relation" | "frequent" | "has lexical unit" |  | "FN" |  |
| fn:condition_symptom_relation | /r/HasA | fn:fe:patient | "condition symptom relation" | "patient" | "/r/has a" |  | "FN" |  |
| fn:condition_symptom_relation | /r/HasA | fn:fe:medical_condition | "condition symptom relation" | "medical condition" | "/r/has a" |  | "FN" |  |
| fn:condition_symptom_relation | /r/HasA | fn:fe:symptom | "condition symptom relation" | "symptom" | "/r/has a" |  | "FN" |  |
| fn:condition_symptom_relation | /r/HasA | fn:fe:group | "condition symptom relation" | "group" | "/r/has a" |  | "FN" |  |
| fn:condition_symptom_relation | /r/HasA | fn:fe:time | "condition symptom relation" | "time" | "/r/has a" |  | "FN" |  |
| fn:condition_symptom_relation | /r/HasA | fn:fe:place | "condition symptom relation" | "place" | "/r/has a" |  | "FN" |  |
| fn:condition_symptom_relation | /r/HasA | fn:fe:frequency | "condition symptom relation" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:condition_symptom_relation | /r/HasA | fn:fe:extent | "condition symptom relation" | "extent" | "/r/has a" |  | "FN" |  |
| fn:condition_symptom_relation | /r/HasA | fn:fe:explanation | "condition symptom relation" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:condition_symptom_relation | /r/HasA | fn:fe:influence | "condition symptom relation" | "influence" | "/r/has a" |  | "FN" |  |
| fn:conditional_occurrence | /r/IsA | fn:conditional_scenario | "conditional occurrence" | "conditional scenario" | "/r/is a" |  | "FN" |  |
| fn:conditional_occurrence | fn:HasLexicalUnit | fn:lu:conditional_occurrence:if | "conditional occurrence" | "if" | "has lexical unit" |  | "FN" |  |
| fn:conditional_occurrence | fn:HasLexicalUnit | fn:lu:conditional_occurrence:in_the_event | "conditional occurrence" | "in the event" | "has lexical unit" |  | "FN" |  |
| fn:conditional_occurrence | fn:HasLexicalUnit | fn:lu:conditional_occurrence:assuming | "conditional occurrence" | "assuming" | "has lexical unit" |  | "FN" |  |
| fn:conditional_occurrence | fn:HasLexicalUnit | fn:lu:conditional_occurrence:supposing | "conditional occurrence" | "supposing" | "has lexical unit" |  | "FN" |  |
| fn:conditional_occurrence | fn:HasLexicalUnit | fn:lu:conditional_occurrence:provided | "conditional occurrence" | "provided" | "has lexical unit" |  | "FN" |  |
| fn:conditional_occurrence | fn:HasLexicalUnit | fn:lu:conditional_occurrence:in_case | "conditional occurrence" | "in case" | "has lexical unit" |  | "FN" |  |
| fn:conditional_occurrence | fn:HasLexicalUnit | fn:lu:conditional_occurrence:as_long_as | "conditional occurrence" | "as long as" | "has lexical unit" |  | "FN" |  |
| fn:conditional_occurrence | fn:HasLexicalUnit | fn:lu:conditional_occurrence:what_if | "conditional occurrence" | "what if" | "has lexical unit" |  | "FN" |  |
| fn:conditional_occurrence | /r/HasA | fn:fe:profiled_possibility | "conditional occurrence" | "profiled possibility" | "/r/has a" |  | "FN" |  |
| fn:conditional_occurrence | /r/HasA | fn:fe:consequence | "conditional occurrence" | "consequence" | "/r/has a" |  | "FN" |  |
| fn:conditional_occurrence | /r/HasA | fn:fe:pragmatic_marker | "conditional occurrence" | "pragmatic marker" | "/r/has a" |  | "FN" |  |
| fn:conditional_scenario | /r/IsA | fn:alternativity | "conditional scenario" | "alternativity" | "/r/is a" |  | "FN" |  |
| fn:preferred_alternative_scenario | /r/IsA | fn:conditional_scenario | "preferred alternative scenario" | "conditional scenario" | "/r/is a" |  | "FN" |  |
| fn:cognitive_connection | /r/UsedFor | fn:conditional_scenario | "cognitive connection" | "conditional scenario" | "/r/used for" |  | "FN" |  |
| fn:conditional_scenario | /r/UsedFor | fn:causation_scenario | "conditional scenario" | "causation scenario" | "/r/used for" |  | "FN" |  |
| fn:presentation_of_mitigation | /r/RelatedTo | fn:conditional_scenario | "presentation of mitigation" | "conditional scenario" | "/r/related to" |  | "FN" |  |
| fn:conditional_occurrence | /r/IsA | fn:conditional_scenario | "conditional occurrence" | "conditional scenario" | "/r/is a" |  | "FN" |  |
| fn:negative_conditional | /r/IsA | fn:conditional_scenario | "negative conditional" | "conditional scenario" | "/r/is a" |  | "FN" |  |
| fn:conditional_scenario | /r/HasA | fn:fe:profiled_possibility | "conditional scenario" | "profiled possibility" | "/r/has a" |  | "FN" |  |
| fn:conditional_scenario | /r/HasA | fn:fe:opposite_possibility | "conditional scenario" | "opposite possibility" | "/r/has a" |  | "FN" |  |
| fn:conditional_scenario | /r/HasA | fn:fe:consequence | "conditional scenario" | "consequence" | "/r/has a" |  | "FN" |  |
| fn:conditional_scenario | /r/HasA | fn:fe:anti_consequence | "conditional scenario" | "anti consequence" | "/r/has a" |  | "FN" |  |
| fn:treating_and_mistreating | /r/IsA | fn:conduct | "treating and mistreating" | "conduct" | "/r/is a" |  | "FN" |  |
| fn:conduct | /r/UsedFor | fn:feigning | "conduct" | "feigning" | "/r/used for" |  | "FN" |  |
| fn:intentionally_act | /r/UsedFor | fn:conduct | "intentionally act" | "conduct" | "/r/used for" |  | "FN" |  |
| fn:social_behavior_evaluation | /r/UsedFor | fn:conduct | "social behavior evaluation" | "conduct" | "/r/used for" |  | "FN" |  |
| fn:conduct | fn:HasLexicalUnit | fn:lu:conduct:conduct | "conduct" | "conduct" | "has lexical unit" |  | "FN" |  |
| fn:conduct | fn:HasLexicalUnit | fn:lu:conduct:deportment | "conduct" | "deportment" | "has lexical unit" |  | "FN" |  |
| fn:conduct | fn:HasLexicalUnit | fn:lu:conduct:behavior | "conduct" | "behavior" | "has lexical unit" |  | "FN" |  |
| fn:conduct | fn:HasLexicalUnit | fn:lu:conduct:comportment | "conduct" | "comportment" | "has lexical unit" |  | "FN" |  |
| fn:conduct | fn:HasLexicalUnit | fn:lu:conduct:misbehave | "conduct" | "misbehave" | "has lexical unit" |  | "FN" |  |
| fn:conduct | fn:HasLexicalUnit | fn:lu:conduct:misbehavior | "conduct" | "misbehavior" | "has lexical unit" |  | "FN" |  |
| fn:conduct | fn:HasLexicalUnit | fn:lu:conduct:behave | "conduct" | "behave" | "has lexical unit" |  | "FN" |  |
| fn:conduct | fn:HasLexicalUnit | fn:lu:conduct:act | "conduct" | "act" | "has lexical unit" |  | "FN" |  |
| fn:conduct | fn:HasLexicalUnit | fn:lu:conduct:act_up | "conduct" | "act up" | "has lexical unit" |  | "FN" |  |
| fn:conduct | fn:HasLexicalUnit | fn:lu:conduct:bearing | "conduct" | "bearing" | "has lexical unit" |  | "FN" |  |
| fn:conduct | fn:HasLexicalUnit | fn:lu:conduct:conduct | "conduct" | "conduct" | "has lexical unit" |  | "FN" |  |
| fn:conduct | fn:HasLexicalUnit | fn:lu:conduct:carry_oneself | "conduct" | "carry oneself" | "has lexical unit" |  | "FN" |  |
| fn:conduct | fn:HasLexicalUnit | fn:lu:conduct:demeanor | "conduct" | "demeanor" | "has lexical unit" |  | "FN" |  |
| fn:conduct | fn:HasLexicalUnit | fn:lu:conduct:manner | "conduct" | "manner" | "has lexical unit" |  | "FN" |  |
| fn:conduct | fn:HasLexicalUnit | fn:lu:conduct:way | "conduct" | "way" | "has lexical unit" |  | "FN" |  |
| fn:conduct | /r/HasA | fn:fe:agent | "conduct" | "agent" | "/r/has a" |  | "FN" |  |
| fn:conduct | /r/HasA | fn:fe:manner | "conduct" | "manner" | "/r/has a" |  | "FN" |  |
| fn:conduct | /r/HasA | fn:fe:circumstances | "conduct" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:conduct | /r/HasA | fn:fe:affected_party | "conduct" | "affected party" | "/r/has a" |  | "FN" |  |
| fn:conduct | /r/HasA | fn:fe:explanation | "conduct" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:conduct | /r/HasA | fn:fe:time | "conduct" | "time" | "/r/has a" |  | "FN" |  |
| fn:conduct | /r/HasA | fn:fe:place | "conduct" | "place" | "/r/has a" |  | "FN" |  |
| fn:conduct | /r/HasA | fn:fe:means | "conduct" | "means" | "/r/has a" |  | "FN" |  |
| fn:conduct | /r/HasA | fn:fe:domain | "conduct" | "domain" | "/r/has a" |  | "FN" |  |
| fn:conduct | /r/HasA | fn:fe:degree | "conduct" | "degree" | "/r/has a" |  | "FN" |  |
| fn:conduct | /r/HasA | fn:fe:standard | "conduct" | "standard" | "/r/has a" |  | "FN" |  |
| fn:giving | /r/UsedFor | fn:conferring_benefit | "giving" | "conferring benefit" | "/r/used for" |  | "FN" |  |
| fn:conferring_benefit | fn:HasLexicalUnit | fn:lu:conferring_benefit:benefit | "conferring benefit" | "benefit" | "has lexical unit" |  | "FN" |  |
| fn:conferring_benefit | fn:HasLexicalUnit | fn:lu:conferring_benefit:benefit | "conferring benefit" | "benefit" | "has lexical unit" |  | "FN" |  |
| fn:conferring_benefit | /r/HasA | fn:fe:benefactor | "conferring benefit" | "benefactor" | "/r/has a" |  | "FN" |  |
| fn:conferring_benefit | /r/HasA | fn:fe:beneficiary | "conferring benefit" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:conferring_benefit | /r/HasA | fn:fe:beneficial_situation | "conferring benefit" | "beneficial situation" | "/r/has a" |  | "FN" |  |
| fn:conferring_benefit | /r/HasA | fn:fe:degree | "conferring benefit" | "degree" | "/r/has a" |  | "FN" |  |
| fn:conferring_benefit | /r/HasA | fn:fe:domain | "conferring benefit" | "domain" | "/r/has a" |  | "FN" |  |
| fn:conferring_benefit | /r/HasA | fn:fe:subset | "conferring benefit" | "subset" | "/r/has a" |  | "FN" |  |
| fn:confronting_problem | /r/IsA | fn:intentionally_act | "confronting problem" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:resolve_problem | /r/HasPrerequisite | fn:confronting_problem | "resolve problem" | "confronting problem" | "/r/has prerequisite" |  | "FN" |  |
| fn:confronting_problem | fn:HasLexicalUnit | fn:lu:confronting_problem:face | "confronting problem" | "face" | "has lexical unit" |  | "FN" |  |
| fn:confronting_problem | fn:HasLexicalUnit | fn:lu:confronting_problem:confront | "confronting problem" | "confront" | "has lexical unit" |  | "FN" |  |
| fn:fe:issue | /r/IsA | fn:st:state_of_affairs | "issue" | "state of affairs" | "/r/is a" |  | "FN" |  |
| fn:confronting_problem | /r/HasA | fn:fe:issue | "confronting problem" | "issue" | "/r/has a" |  | "FN" |  |
| fn:confronting_problem | /r/HasA | fn:fe:agent | "confronting problem" | "agent" | "/r/has a" |  | "FN" |  |
| fn:confronting_problem | /r/HasA | fn:fe:place | "confronting problem" | "place" | "/r/has a" |  | "FN" |  |
| fn:confronting_problem | /r/HasA | fn:fe:purpose | "confronting problem" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:confronting_problem | /r/HasA | fn:fe:time | "confronting problem" | "time" | "/r/has a" |  | "FN" |  |
| fn:confronting_problem | /r/HasA | fn:fe:means | "confronting problem" | "means" | "/r/has a" |  | "FN" |  |
| fn:confronting_problem | /r/HasA | fn:fe:manner | "confronting problem" | "manner" | "/r/has a" |  | "FN" |  |
| fn:confronting_problem | /r/HasA | fn:fe:domain | "confronting problem" | "domain" | "/r/has a" |  | "FN" |  |
| fn:confronting_problem | /r/HasA | fn:fe:frequency | "confronting problem" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:confronting_problem | /r/HasA | fn:fe:period_of_iterations | "confronting problem" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:confronting_problem | /r/HasA | fn:fe:result | "confronting problem" | "result" | "/r/has a" |  | "FN" |  |
| fn:confronting_problem | /r/HasA | fn:fe:particular_iteration | "confronting problem" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:confronting_problem | /r/HasA | fn:fe:explanation | "confronting problem" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:confronting_problem | /r/HasA | fn:fe:event_description | "confronting problem" | "event description" | "/r/has a" |  | "FN" |  |
| fn:connecting_architecture | /r/IsA | fn:architectural_part | "connecting architecture" | "architectural part" | "/r/is a" |  | "FN" |  |
| fn:connecting_architecture | fn:HasLexicalUnit | fn:lu:connecting_architecture:door | "connecting architecture" | "door" | "has lexical unit" |  | "FN" |  |
| fn:connecting_architecture | fn:HasLexicalUnit | fn:lu:connecting_architecture:elevator | "connecting architecture" | "elevator" | "has lexical unit" |  | "FN" |  |
| fn:connecting_architecture | fn:HasLexicalUnit | fn:lu:connecting_architecture:lift | "connecting architecture" | "lift" | "has lexical unit" |  | "FN" |  |
| fn:connecting_architecture | fn:HasLexicalUnit | fn:lu:connecting_architecture:escalator | "connecting architecture" | "escalator" | "has lexical unit" |  | "FN" |  |
| fn:connecting_architecture | fn:HasLexicalUnit | fn:lu:connecting_architecture:corridor | "connecting architecture" | "corridor" | "has lexical unit" |  | "FN" |  |
| fn:connecting_architecture | fn:HasLexicalUnit | fn:lu:connecting_architecture:hallway | "connecting architecture" | "hallway" | "has lexical unit" |  | "FN" |  |
| fn:connecting_architecture | fn:HasLexicalUnit | fn:lu:connecting_architecture:window | "connecting architecture" | "window" | "has lexical unit" |  | "FN" |  |
| fn:connecting_architecture | fn:HasLexicalUnit | fn:lu:connecting_architecture:staircase | "connecting architecture" | "staircase" | "has lexical unit" |  | "FN" |  |
| fn:connecting_architecture | fn:HasLexicalUnit | fn:lu:connecting_architecture:stairs | "connecting architecture" | "stairs" | "has lexical unit" |  | "FN" |  |
| fn:connecting_architecture | fn:HasLexicalUnit | fn:lu:connecting_architecture:step | "connecting architecture" | "step" | "has lexical unit" |  | "FN" |  |
| fn:connecting_architecture | fn:HasLexicalUnit | fn:lu:connecting_architecture:gate | "connecting architecture" | "gate" | "has lexical unit" |  | "FN" |  |
| fn:connecting_architecture | /r/HasA | fn:fe:part | "connecting architecture" | "part" | "/r/has a" |  | "FN" |  |
| fn:connecting_architecture | /r/HasA | fn:fe:whole | "connecting architecture" | "whole" | "/r/has a" |  | "FN" |  |
| fn:connecting_architecture | /r/HasA | fn:fe:descriptor | "connecting architecture" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:connecting_architecture | /r/HasA | fn:fe:orientation | "connecting architecture" | "orientation" | "/r/has a" |  | "FN" |  |
| fn:connecting_architecture | /r/HasA | fn:fe:material | "connecting architecture" | "material" | "/r/has a" |  | "FN" |  |
| fn:connecting_architecture | /r/HasA | fn:fe:creator | "connecting architecture" | "creator" | "/r/has a" |  | "FN" |  |
| fn:connecting_architecture | /r/HasA | fn:fe:source | "connecting architecture" | "source" | "/r/has a" |  | "FN" |  |
| fn:connecting_architecture | /r/HasA | fn:fe:connected_locations | "connecting architecture" | "connected locations" | "/r/has a" |  | "FN" |  |
| fn:connecting_architecture | /r/HasA | fn:fe:direction | "connecting architecture" | "direction" | "/r/has a" |  | "FN" |  |
| fn:connecting_architecture | /r/HasA | fn:fe:goal | "connecting architecture" | "goal" | "/r/has a" |  | "FN" |  |
| fn:connectors | /r/IsA | fn:artifact | "connectors" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:attaching | /r/UsedFor | fn:connectors | "attaching" | "connectors" | "/r/used for" |  | "FN" |  |
| fn:connectors | fn:HasLexicalUnit | fn:lu:connectors:ribbon | "connectors" | "ribbon" | "has lexical unit" |  | "FN" |  |
| fn:connectors | fn:HasLexicalUnit | fn:lu:connectors:rope | "connectors" | "rope" | "has lexical unit" |  | "FN" |  |
| fn:connectors | fn:HasLexicalUnit | fn:lu:connectors:thread | "connectors" | "thread" | "has lexical unit" |  | "FN" |  |
| fn:connectors | fn:HasLexicalUnit | fn:lu:connectors:string | "connectors" | "string" | "has lexical unit" |  | "FN" |  |
| fn:connectors | fn:HasLexicalUnit | fn:lu:connectors:cord | "connectors" | "cord" | "has lexical unit" |  | "FN" |  |
| fn:connectors | fn:HasLexicalUnit | fn:lu:connectors:chain | "connectors" | "chain" | "has lexical unit" |  | "FN" |  |
| fn:connectors | fn:HasLexicalUnit | fn:lu:connectors:bond | "connectors" | "bond" | "has lexical unit" |  | "FN" |  |
| fn:connectors | fn:HasLexicalUnit | fn:lu:connectors:adhesive | "connectors" | "adhesive" | "has lexical unit" |  | "FN" |  |
| fn:connectors | fn:HasLexicalUnit | fn:lu:connectors:tape | "connectors" | "tape" | "has lexical unit" |  | "FN" |  |
| fn:connectors | fn:HasLexicalUnit | fn:lu:connectors:glue | "connectors" | "glue" | "has lexical unit" |  | "FN" |  |
| fn:connectors | fn:HasLexicalUnit | fn:lu:connectors:bolt | "connectors" | "bolt" | "has lexical unit" |  | "FN" |  |
| fn:connectors | fn:HasLexicalUnit | fn:lu:connectors:nut | "connectors" | "nut" | "has lexical unit" |  | "FN" |  |
| fn:connectors | fn:HasLexicalUnit | fn:lu:connectors:nail | "connectors" | "nail" | "has lexical unit" |  | "FN" |  |
| fn:connectors | fn:HasLexicalUnit | fn:lu:connectors:peg | "connectors" | "peg" | "has lexical unit" |  | "FN" |  |
| fn:connectors | fn:HasLexicalUnit | fn:lu:connectors:strap | "connectors" | "strap" | "has lexical unit" |  | "FN" |  |
| fn:connectors | fn:HasLexicalUnit | fn:lu:connectors:tack | "connectors" | "tack" | "has lexical unit" |  | "FN" |  |
| fn:connectors | fn:HasLexicalUnit | fn:lu:connectors:staple | "connectors" | "staple" | "has lexical unit" |  | "FN" |  |
| fn:connectors | fn:HasLexicalUnit | fn:lu:connectors:withy | "connectors" | "withy" | "has lexical unit" |  | "FN" |  |
| fn:connectors | fn:HasLexicalUnit | fn:lu:connectors:tie | "connectors" | "tie" | "has lexical unit" |  | "FN" |  |
| fn:connectors | fn:HasLexicalUnit | fn:lu:connectors:lace | "connectors" | "lace" | "has lexical unit" |  | "FN" |  |
| fn:connectors | fn:HasLexicalUnit | fn:lu:connectors:shoelace | "connectors" | "shoelace" | "has lexical unit" |  | "FN" |  |
| fn:connectors | fn:HasLexicalUnit | fn:lu:connectors:wire | "connectors" | "wire" | "has lexical unit" |  | "FN" |  |
| fn:connectors | fn:HasLexicalUnit | fn:lu:connectors:screw | "connectors" | "screw" | "has lexical unit" |  | "FN" |  |
| fn:connectors | fn:HasLexicalUnit | fn:lu:connectors:link | "connectors" | "link" | "has lexical unit" |  | "FN" |  |
| fn:connectors | fn:HasLexicalUnit | fn:lu:connectors:connector | "connectors" | "connector" | "has lexical unit" |  | "FN" |  |
| fn:connectors | fn:HasLexicalUnit | fn:lu:connectors:trace | "connectors" | "trace" | "has lexical unit" |  | "FN" |  |
| fn:fe:connector | /r/IsA | fn:st:artifact | "connector" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:connectors | /r/HasA | fn:fe:connector | "connectors" | "connector" | "/r/has a" |  | "FN" |  |
| fn:connectors | /r/HasA | fn:fe:connected_item | "connectors" | "connected item" | "/r/has a" |  | "FN" |  |
| fn:connectors | /r/HasA | fn:fe:fixed_location | "connectors" | "fixed location" | "/r/has a" |  | "FN" |  |
| fn:connectors | /r/HasA | fn:fe:use | "connectors" | "use" | "/r/has a" |  | "FN" |  |
| fn:connectors | /r/HasA | fn:fe:material | "connectors" | "material" | "/r/has a" |  | "FN" |  |
| fn:connectors | /r/HasA | fn:fe:type | "connectors" | "type" | "/r/has a" |  | "FN" |  |
| fn:connectors | /r/HasA | fn:fe:name | "connectors" | "name" | "/r/has a" |  | "FN" |  |
| fn:connectors | /r/HasA | fn:fe:creator | "connectors" | "creator" | "/r/has a" |  | "FN" |  |
| fn:connectors | /r/HasA | fn:fe:time_of_creation | "connectors" | "time of creation" | "/r/has a" |  | "FN" |  |
| fn:connectors | /r/HasA | fn:fe:descriptor | "connectors" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:invasion_scenario | /r/HasSubevent | fn:conquering | "invasion scenario" | "conquering" | "/r/has subevent" |  | "FN" |  |
| fn:conquering | /r/HasPrerequisite | fn:invading | "conquering" | "invading" | "/r/has prerequisite" |  | "FN" |  |
| fn:conquering | fn:HasLexicalUnit | fn:lu:conquering:conquer | "conquering" | "conquer" | "has lexical unit" |  | "FN" |  |
| fn:conquering | fn:HasLexicalUnit | fn:lu:conquering:takeover | "conquering" | "takeover" | "has lexical unit" |  | "FN" |  |
| fn:conquering | fn:HasLexicalUnit | fn:lu:conquering:capture | "conquering" | "capture" | "has lexical unit" |  | "FN" |  |
| fn:conquering | fn:HasLexicalUnit | fn:lu:conquering:fall | "conquering" | "fall" | "has lexical unit" |  | "FN" |  |
| fn:conquering | fn:HasLexicalUnit | fn:lu:conquering:take | "conquering" | "take" | "has lexical unit" |  | "FN" |  |
| fn:conquering | fn:HasLexicalUnit | fn:lu:conquering:reduce | "conquering" | "reduce" | "has lexical unit" |  | "FN" |  |
| fn:conquering | fn:HasLexicalUnit | fn:lu:conquering:overcome | "conquering" | "overcome" | "has lexical unit" |  | "FN" |  |
| fn:conquering | /r/HasA | fn:fe:conqueror | "conquering" | "conqueror" | "/r/has a" |  | "FN" |  |
| fn:conquering | /r/HasA | fn:fe:theme | "conquering" | "theme" | "/r/has a" |  | "FN" |  |
| fn:conquering | /r/HasA | fn:fe:degree | "conquering" | "degree" | "/r/has a" |  | "FN" |  |
| fn:conquering | /r/HasA | fn:fe:manner | "conquering" | "manner" | "/r/has a" |  | "FN" |  |
| fn:conquering | /r/HasA | fn:fe:means | "conquering" | "means" | "/r/has a" |  | "FN" |  |
| fn:conquering | /r/HasA | fn:fe:place | "conquering" | "place" | "/r/has a" |  | "FN" |  |
| fn:conquering | /r/HasA | fn:fe:time | "conquering" | "time" | "/r/has a" |  | "FN" |  |
| fn:conquering | /r/HasA | fn:fe:purpose | "conquering" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:conquering | /r/HasA | fn:fe:instrument | "conquering" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:conquering | /r/HasA | fn:fe:depictive | "conquering" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:conquering | /r/HasA | fn:fe:frequency | "conquering" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:contact_image_schema | /r/IsA | fn:image_schema | "contact image schema" | "image schema" | "/r/is a" |  | "FN" |  |
| fn:contact_image_schema | /r/HasA | fn:fe:profiled_region | "contact image schema" | "profiled region" | "/r/has a" |  | "FN" |  |
| fn:contact_image_schema | /r/HasA | fn:fe:ground | "contact image schema" | "ground" | "/r/has a" |  | "FN" |  |
| fn:contacting | /r/IsA | fn:intentionally_act | "contacting" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:contacting | "communication" | "contacting" | "/r/used for" |  | "FN" |  |
| fn:communication_means | /r/SimilarTo | fn:contacting | "communication means" | "contacting" | "/r/similar to" |  | "FN" |  |
| fn:contacting | fn:HasLexicalUnit | fn:lu:contacting:reach | "contacting" | "reach" | "has lexical unit" |  | "FN" |  |
| fn:contacting | fn:HasLexicalUnit | fn:lu:contacting:contact | "contacting" | "contact" | "has lexical unit" |  | "FN" |  |
| fn:contacting | fn:HasLexicalUnit | fn:lu:contacting:contact | "contacting" | "contact" | "has lexical unit" |  | "FN" |  |
| fn:contacting | fn:HasLexicalUnit | fn:lu:contacting:write_in | "contacting" | "write in" | "has lexical unit" |  | "FN" |  |
| fn:contacting | fn:HasLexicalUnit | fn:lu:contacting:write | "contacting" | "write" | "has lexical unit" |  | "FN" |  |
| fn:contacting | fn:HasLexicalUnit | fn:lu:contacting:e-mail | "contacting" | "e-mail" | "has lexical unit" |  | "FN" |  |
| fn:contacting | fn:HasLexicalUnit | fn:lu:contacting:call | "contacting" | "call" | "has lexical unit" |  | "FN" |  |
| fn:contacting | fn:HasLexicalUnit | fn:lu:contacting:call_up | "contacting" | "call up" | "has lexical unit" |  | "FN" |  |
| fn:contacting | fn:HasLexicalUnit | fn:lu:contacting:phone | "contacting" | "phone" | "has lexical unit" |  | "FN" |  |
| fn:contacting | fn:HasLexicalUnit | fn:lu:contacting:phone_in | "contacting" | "phone in" | "has lexical unit" |  | "FN" |  |
| fn:contacting | fn:HasLexicalUnit | fn:lu:contacting:ring | "contacting" | "ring" | "has lexical unit" |  | "FN" |  |
| fn:contacting | fn:HasLexicalUnit | fn:lu:contacting:ring_up | "contacting" | "ring up" | "has lexical unit" |  | "FN" |  |
| fn:contacting | fn:HasLexicalUnit | fn:lu:contacting:get_in_touch | "contacting" | "get in touch" | "has lexical unit" |  | "FN" |  |
| fn:contacting | fn:HasLexicalUnit | fn:lu:contacting:telephone | "contacting" | "telephone" | "has lexical unit" |  | "FN" |  |
| fn:contacting | fn:HasLexicalUnit | fn:lu:contacting:call | "contacting" | "call" | "has lexical unit" |  | "FN" |  |
| fn:contacting | fn:HasLexicalUnit | fn:lu:contacting:mail | "contacting" | "mail" | "has lexical unit" |  | "FN" |  |
| fn:contacting | fn:HasLexicalUnit | fn:lu:contacting:telex | "contacting" | "telex" | "has lexical unit" |  | "FN" |  |
| fn:contacting | fn:HasLexicalUnit | fn:lu:contacting:fax | "contacting" | "fax" | "has lexical unit" |  | "FN" |  |
| fn:contacting | fn:HasLexicalUnit | fn:lu:contacting:cable | "contacting" | "cable" | "has lexical unit" |  | "FN" |  |
| fn:contacting | fn:HasLexicalUnit | fn:lu:contacting:page | "contacting" | "page" | "has lexical unit" |  | "FN" |  |
| fn:contacting | fn:HasLexicalUnit | fn:lu:contacting:radio | "contacting" | "radio" | "has lexical unit" |  | "FN" |  |
| fn:contacting | fn:HasLexicalUnit | fn:lu:contacting:telegraph | "contacting" | "telegraph" | "has lexical unit" |  | "FN" |  |
| fn:contacting | fn:HasLexicalUnit | fn:lu:contacting:call_in | "contacting" | "call in" | "has lexical unit" |  | "FN" |  |
| fn:contacting | fn:HasLexicalUnit | fn:lu:contacting:get_through | "contacting" | "get through" | "has lexical unit" |  | "FN" |  |
| fn:contacting | /r/HasA | fn:fe:communicator | "contacting" | "communicator" | "/r/has a" |  | "FN" |  |
| fn:contacting | /r/HasA | fn:fe:medium | "contacting" | "medium" | "/r/has a" |  | "FN" |  |
| fn:contacting | /r/HasA | fn:fe:addressee | "contacting" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:contacting | /r/HasA | fn:fe:address | "contacting" | "address" | "/r/has a" |  | "FN" |  |
| fn:contacting | /r/HasA | fn:fe:communication | "contacting" | "communication" | "/r/has a" |  | "FN" |  |
| fn:contacting | /r/HasA | fn:fe:purpose | "contacting" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:contacting | /r/HasA | fn:fe:topic | "contacting" | "topic" | "/r/has a" |  | "FN" |  |
| fn:contacting | /r/HasA | fn:fe:location_of_protagonist | "contacting" | "location of protagonist" | "/r/has a" |  | "FN" |  |
| fn:contacting | /r/HasA | fn:fe:place | "contacting" | "place" | "/r/has a" |  | "FN" |  |
| fn:contacting | /r/HasA | fn:fe:time | "contacting" | "time" | "/r/has a" |  | "FN" |  |
| fn:contacting | /r/HasA | fn:fe:intermediary | "contacting" | "intermediary" | "/r/has a" |  | "FN" |  |
| fn:contacting | /r/HasA | fn:fe:depictive | "contacting" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:contacting | /r/HasA | fn:fe:frequency | "contacting" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:contacting | /r/HasA | fn:fe:manner | "contacting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:contacting | /r/HasA | fn:fe:means | "contacting" | "means" | "/r/has a" |  | "FN" |  |
| fn:filling | /r/IsA | fn:container_focused_placing | "filling" | "container focused placing" | "/r/is a" |  | "FN" |  |
| fn:container_focused_placing | /r/IsA | fn:transitive_action | "container focused placing" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:container_focused_placing | /r/IsA | fn:placing_scenario | "container focused placing" | "placing scenario" | "/r/is a" |  | "FN" |  |
| fn:container_focused_placing | /r/HasA | fn:fe:agent | "container focused placing" | "agent" | "/r/has a" |  | "FN" |  |
| fn:container_focused_placing | /r/HasA | fn:fe:theme | "container focused placing" | "theme" | "/r/has a" |  | "FN" |  |
| fn:container_focused_placing | /r/HasA | fn:fe:source | "container focused placing" | "source" | "/r/has a" |  | "FN" |  |
| fn:container_focused_placing | /r/HasA | fn:fe:path | "container focused placing" | "path" | "/r/has a" |  | "FN" |  |
| fn:container_focused_placing | /r/HasA | fn:fe:goal | "container focused placing" | "goal" | "/r/has a" |  | "FN" |  |
| fn:container_focused_placing | /r/HasA | fn:fe:degree | "container focused placing" | "degree" | "/r/has a" |  | "FN" |  |
| fn:container_focused_placing | /r/HasA | fn:fe:depictive | "container focused placing" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:container_focused_placing | /r/HasA | fn:fe:manner | "container focused placing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:container_focused_placing | /r/HasA | fn:fe:means | "container focused placing" | "means" | "/r/has a" |  | "FN" |  |
| fn:container_focused_placing | /r/HasA | fn:fe:result | "container focused placing" | "result" | "/r/has a" |  | "FN" |  |
| fn:container_focused_placing | /r/HasA | fn:fe:explanation | "container focused placing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:container_focused_placing | /r/HasA | fn:fe:time | "container focused placing" | "time" | "/r/has a" |  | "FN" |  |
| fn:container_focused_placing | /r/HasA | fn:fe:place | "container focused placing" | "place" | "/r/has a" |  | "FN" |  |
| fn:container_focused_placing | /r/HasA | fn:fe:purpose | "container focused placing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:container_focused_placing | /r/HasA | fn:fe:instrument | "container focused placing" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:container_focused_placing | /r/HasA | fn:fe:subregion | "container focused placing" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:container_focused_placing | /r/HasA | fn:fe:cause | "container focused placing" | "cause" | "/r/has a" |  | "FN" |  |
| fn:emptying | /r/IsA | fn:container_focused_removing | "emptying" | "container focused removing" | "/r/is a" |  | "FN" |  |
| fn:container_focused_removing | /r/IsA | fn:transitive_action | "container focused removing" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:container_focused_removing | /r/IsA | fn:removing_scenario | "container focused removing" | "removing scenario" | "/r/is a" |  | "FN" |  |
| fn:container_focused_removing | /r/HasA | fn:fe:agent | "container focused removing" | "agent" | "/r/has a" |  | "FN" |  |
| fn:container_focused_removing | /r/HasA | fn:fe:theme | "container focused removing" | "theme" | "/r/has a" |  | "FN" |  |
| fn:container_focused_removing | /r/HasA | fn:fe:source | "container focused removing" | "source" | "/r/has a" |  | "FN" |  |
| fn:container_focused_removing | /r/HasA | fn:fe:path | "container focused removing" | "path" | "/r/has a" |  | "FN" |  |
| fn:container_focused_removing | /r/HasA | fn:fe:goal | "container focused removing" | "goal" | "/r/has a" |  | "FN" |  |
| fn:container_focused_removing | /r/HasA | fn:fe:degree | "container focused removing" | "degree" | "/r/has a" |  | "FN" |  |
| fn:container_focused_removing | /r/HasA | fn:fe:depictive | "container focused removing" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:container_focused_removing | /r/HasA | fn:fe:manner | "container focused removing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:container_focused_removing | /r/HasA | fn:fe:means | "container focused removing" | "means" | "/r/has a" |  | "FN" |  |
| fn:container_focused_removing | /r/HasA | fn:fe:result | "container focused removing" | "result" | "/r/has a" |  | "FN" |  |
| fn:container_focused_removing | /r/HasA | fn:fe:instrument | "container focused removing" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:container_focused_removing | /r/HasA | fn:fe:cause | "container focused removing" | "cause" | "/r/has a" |  | "FN" |  |
| fn:container_focused_removing | /r/HasA | fn:fe:place | "container focused removing" | "place" | "/r/has a" |  | "FN" |  |
| fn:container_focused_removing | /r/HasA | fn:fe:time | "container focused removing" | "time" | "/r/has a" |  | "FN" |  |
| fn:container_focused_removing | /r/HasA | fn:fe:containing_event | "container focused removing" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:container_focused_removing | /r/HasA | fn:fe:explanation | "container focused removing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:container_focused_removing | /r/HasA | fn:fe:circumstances | "container focused removing" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:bounded_entity | /r/UsedFor | fn:containers | "bounded entity" | "containers" | "/r/used for" |  | "FN" |  |
| fn:containing | /r/UsedFor | fn:containers | "containing" | "containers" | "/r/used for" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:amphora | "containers" | "amphora" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:backpack | "containers" | "backpack" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:can | "containers" | "can" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:cart | "containers" | "cart" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:casket | "containers" | "casket" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:chest | "containers" | "chest" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:envelope | "containers" | "envelope" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:flask | "containers" | "flask" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:glass | "containers" | "glass" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:handbag | "containers" | "handbag" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:jar | "containers" | "jar" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:knapsack | "containers" | "knapsack" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:ladle | "containers" | "ladle" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:locker | "containers" | "locker" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:mug | "containers" | "mug" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:pot_[cooking] | "containers" | "pot [cooking]" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:purse | "containers" | "purse" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:reservoir | "containers" | "reservoir" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:sack | "containers" | "sack" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:satchel | "containers" | "satchel" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:spoon | "containers" | "spoon" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:suitcase | "containers" | "suitcase" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:tin | "containers" | "tin" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:wallet | "containers" | "wallet" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:teaspoon | "containers" | "teaspoon" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:ampule | "containers" | "ampule" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:ashtray | "containers" | "ashtray" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:bag | "containers" | "bag" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:barrel | "containers" | "barrel" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:basin | "containers" | "basin" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:basket | "containers" | "basket" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:beaker | "containers" | "beaker" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:bin | "containers" | "bin" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:bottle | "containers" | "bottle" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:bowl | "containers" | "bowl" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:box | "containers" | "box" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:briefcase | "containers" | "briefcase" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:bucket | "containers" | "bucket" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:canister | "containers" | "canister" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:canteen | "containers" | "canteen" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:carafe | "containers" | "carafe" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:carton | "containers" | "carton" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:cartridge | "containers" | "cartridge" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:case | "containers" | "case" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:coffer | "containers" | "coffer" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:coffin | "containers" | "coffin" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:container | "containers" | "container" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:cooler | "containers" | "cooler" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:crate | "containers" | "crate" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:crock | "containers" | "crock" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:crucible | "containers" | "crucible" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:cruet | "containers" | "cruet" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:cup | "containers" | "cup" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:cuspidor | "containers" | "cuspidor" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:cylinder | "containers" | "cylinder" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:cask | "containers" | "cask" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:carryall | "containers" | "carryall" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:censer | "containers" | "censer" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:chalice | "containers" | "chalice" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:creamer | "containers" | "creamer" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:decanter | "containers" | "decanter" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:dish | "containers" | "dish" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:dispenser | "containers" | "dispenser" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:drum | "containers" | "drum" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:duffel_bag | "containers" | "duffel bag" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:flagon | "containers" | "flagon" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:empty | "containers" | "empty" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:etui | "containers" | "etui" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:goblet | "containers" | "goblet" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:grail | "containers" | "grail" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:hamper | "containers" | "hamper" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:haversack | "containers" | "haversack" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:hopper | "containers" | "hopper" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:jeroboam | "containers" | "jeroboam" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:jigger | "containers" | "jigger" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:jug | "containers" | "jug" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:keg | "containers" | "keg" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:magnum | "containers" | "magnum" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:mailer | "containers" | "mailer" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:overnighter | "containers" | "overnighter" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:pack | "containers" | "pack" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:sarcophagus | "containers" | "sarcophagus" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:tun | "containers" | "tun" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:stein | "containers" | "stein" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:spittoon | "containers" | "spittoon" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:pannier | "containers" | "pannier" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:ramekin | "containers" | "ramekin" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:reticule | "containers" | "reticule" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:salver | "containers" | "salver" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:samovar | "containers" | "samovar" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:snifter | "containers" | "snifter" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:thermos | "containers" | "thermos" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:tureen | "containers" | "tureen" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:valise | "containers" | "valise" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:cauldron | "containers" | "cauldron" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:casserole | "containers" | "casserole" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:folder | "containers" | "folder" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:rucksack | "containers" | "rucksack" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:pouch | "containers" | "pouch" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:vial | "containers" | "vial" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:vase | "containers" | "vase" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:pail | "containers" | "pail" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:pipette | "containers" | "pipette" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:tumbler | "containers" | "tumbler" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:vat | "containers" | "vat" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:vivarium | "containers" | "vivarium" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:punch_bowl | "containers" | "punch bowl" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:toilet_bowl | "containers" | "toilet bowl" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:wine_bottle | "containers" | "wine bottle" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:chest_of_drawers | "containers" | "chest of drawers" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:hot-water_bottle | "containers" | "hot-water bottle" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:urn | "containers" | "urn" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:tank | "containers" | "tank" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:safe | "containers" | "safe" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:planter | "containers" | "planter" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:pot | "containers" | "pot" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:drawer | "containers" | "drawer" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:goldfish_bowl | "containers" | "goldfish bowl" | "has lexical unit" |  | "FN" |  |
| fn:containers | fn:HasLexicalUnit | fn:lu:containers:tub | "containers" | "tub" | "has lexical unit" |  | "FN" |  |
| fn:containers | /r/HasA | fn:fe:container | "containers" | "container" | "/r/has a" |  | "FN" |  |
| fn:containers | /r/HasA | fn:fe:contents | "containers" | "contents" | "/r/has a" |  | "FN" |  |
| fn:containers | /r/HasA | fn:fe:material | "containers" | "material" | "/r/has a" |  | "FN" |  |
| fn:containers | /r/HasA | fn:fe:type | "containers" | "type" | "/r/has a" |  | "FN" |  |
| fn:containers | /r/HasA | fn:fe:relative_location | "containers" | "relative location" | "/r/has a" |  | "FN" |  |
| fn:containers | /r/HasA | fn:fe:construction | "containers" | "construction" | "/r/has a" |  | "FN" |  |
| fn:containers | /r/HasA | fn:fe:owner | "containers" | "owner" | "/r/has a" |  | "FN" |  |
| fn:containers | /r/HasA | fn:fe:use | "containers" | "use" | "/r/has a" |  | "FN" |  |
| fn:containers | /r/HasA | fn:fe:part | "containers" | "part" | "/r/has a" |  | "FN" |  |
| fn:containers | /r/HasA | fn:fe:descriptor | "containers" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:containing | /r/IsA | fn:locative_relation | "containing" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:containing | /r/UsedFor | fn:containers | "containing" | "containers" | "/r/used for" |  | "FN" |  |
| fn:containing | /r/UsedFor | fn:fullness | "containing" | "fullness" | "/r/used for" |  | "FN" |  |
| fn:containing | /r/IsA | fn:containment_scenario | "containing" | "containment scenario" | "/r/is a" |  | "FN" |  |
| fn:containing | fn:HasLexicalUnit | fn:lu:containing:contain | "containing" | "contain" | "has lexical unit" |  | "FN" |  |
| fn:containing | fn:HasLexicalUnit | fn:lu:containing:hold | "containing" | "hold" | "has lexical unit" |  | "FN" |  |
| fn:containing | fn:HasLexicalUnit | fn:lu:containing:house | "containing" | "house" | "has lexical unit" |  | "FN" |  |
| fn:containing | fn:HasLexicalUnit | fn:lu:containing:store | "containing" | "store" | "has lexical unit" |  | "FN" |  |
| fn:containing | /r/HasA | fn:fe:container | "containing" | "container" | "/r/has a" |  | "FN" |  |
| fn:containing | /r/HasA | fn:fe:contents | "containing" | "contents" | "/r/has a" |  | "FN" |  |
| fn:containing | /r/HasA | fn:fe:time | "containing" | "time" | "/r/has a" |  | "FN" |  |
| fn:being_contained_within | /r/IsA | fn:containment_scenario | "being contained within" | "containment scenario" | "/r/is a" |  | "FN" |  |
| fn:containing | /r/IsA | fn:containment_scenario | "containing" | "containment scenario" | "/r/is a" |  | "FN" |  |
| fn:containment_scenario | /r/HasA | fn:fe:container | "containment scenario" | "container" | "/r/has a" |  | "FN" |  |
| fn:containment_scenario | /r/HasA | fn:fe:interior | "containment scenario" | "interior" | "/r/has a" |  | "FN" |  |
| fn:containment_scenario | /r/HasA | fn:fe:portal | "containment scenario" | "portal" | "/r/has a" |  | "FN" |  |
| fn:containment_scenario | /r/HasA | fn:fe:contents | "containment scenario" | "contents" | "/r/has a" |  | "FN" |  |
| fn:containment_scenario | /r/HasA | fn:fe:time | "containment scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:have_as_requirement | /r/IsA | fn:contingency | "have as requirement" | "contingency" | "/r/is a" |  | "FN" |  |
| fn:contingency | /r/UsedFor | fn:reliance | "contingency" | "reliance" | "/r/used for" |  | "FN" |  |
| fn:contingency | fn:HasLexicalUnit | fn:lu:contingency:depend | "contingency" | "depend" | "has lexical unit" |  | "FN" |  |
| fn:contingency | fn:HasLexicalUnit | fn:lu:contingency:function | "contingency" | "function" | "has lexical unit" |  | "FN" |  |
| fn:contingency | fn:HasLexicalUnit | fn:lu:contingency:dependent | "contingency" | "dependent" | "has lexical unit" |  | "FN" |  |
| fn:contingency | fn:HasLexicalUnit | fn:lu:contingency:depends | "contingency" | "depends" | "has lexical unit" |  | "FN" |  |
| fn:contingency | fn:HasLexicalUnit | fn:lu:contingency:dependence | "contingency" | "dependence" | "has lexical unit" |  | "FN" |  |
| fn:contingency | fn:HasLexicalUnit | fn:lu:contingency:hang_(on) | "contingency" | "hang (on)" | "has lexical unit" |  | "FN" |  |
| fn:contingency | fn:HasLexicalUnit | fn:lu:contingency:turn | "contingency" | "turn" | "has lexical unit" |  | "FN" |  |
| fn:contingency | fn:HasLexicalUnit | fn:lu:contingency:determine | "contingency" | "determine" | "has lexical unit" |  | "FN" |  |
| fn:contingency | fn:HasLexicalUnit | fn:lu:contingency:independent | "contingency" | "independent" | "has lexical unit" |  | "FN" |  |
| fn:contingency | fn:HasLexicalUnit | fn:lu:contingency:independence | "contingency" | "independence" | "has lexical unit" |  | "FN" |  |
| fn:contingency | fn:HasLexicalUnit | fn:lu:contingency:hinge | "contingency" | "hinge" | "has lexical unit" |  | "FN" |  |
| fn:contingency | fn:HasLexicalUnit | fn:lu:contingency:factor | "contingency" | "factor" | "has lexical unit" |  | "FN" |  |
| fn:contingency | fn:HasLexicalUnit | fn:lu:contingency:variable | "contingency" | "variable" | "has lexical unit" |  | "FN" |  |
| fn:contingency | fn:HasLexicalUnit | fn:lu:contingency:dictate | "contingency" | "dictate" | "has lexical unit" |  | "FN" |  |
| fn:contingency | /r/HasA | fn:fe:outcome | "contingency" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:contingency | /r/HasA | fn:fe:determinant | "contingency" | "determinant" | "/r/has a" |  | "FN" |  |
| fn:contingency | /r/HasA | fn:fe:degree | "contingency" | "degree" | "/r/has a" |  | "FN" |  |
| fn:contingency | /r/HasA | fn:fe:circumstances | "contingency" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:state_continue | /r/UsedFor | fn:continued_state_of_affairs | "state continue" | "continued state of affairs" | "/r/used for" |  | "FN" |  |
| fn:continued_state_of_affairs | fn:HasLexicalUnit | fn:lu:continued_state_of_affairs:so_far | "continued state of affairs" | "so far" | "has lexical unit" |  | "FN" |  |
| fn:continued_state_of_affairs | fn:HasLexicalUnit | fn:lu:continued_state_of_affairs:to_date | "continued state of affairs" | "to date" | "has lexical unit" |  | "FN" |  |
| fn:continued_state_of_affairs | fn:HasLexicalUnit | fn:lu:continued_state_of_affairs:up_to | "continued state of affairs" | "up to" | "has lexical unit" |  | "FN" |  |
| fn:continued_state_of_affairs | fn:HasLexicalUnit | fn:lu:continued_state_of_affairs:as_yet | "continued state of affairs" | "as yet" | "has lexical unit" |  | "FN" |  |
| fn:continued_state_of_affairs | fn:HasLexicalUnit | fn:lu:continued_state_of_affairs:as_of_yet | "continued state of affairs" | "as of yet" | "has lexical unit" |  | "FN" |  |
| fn:continued_state_of_affairs | fn:HasLexicalUnit | fn:lu:continued_state_of_affairs:still | "continued state of affairs" | "still" | "has lexical unit" |  | "FN" |  |
| fn:continued_state_of_affairs | /r/HasA | fn:fe:state_of_affairs | "continued state of affairs" | "state of affairs" | "/r/has a" |  | "FN" |  |
| fn:continued_state_of_affairs | /r/HasA | fn:fe:reference_occasion | "continued state of affairs" | "reference occasion" | "/r/has a" |  | "FN" |  |
| fn:continued_state_of_affairs | /r/HasA | fn:fe:circumstances | "continued state of affairs" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:contrary_circumstances | /r/IsA | fn:concessive | "contrary circumstances" | "concessive" | "/r/is a" |  | "FN" |  |
| fn:contrary_circumstances | fn:HasLexicalUnit | fn:lu:contrary_circumstances:in_the_face_of | "contrary circumstances" | "in the face of" | "has lexical unit" |  | "FN" |  |
| fn:contrary_circumstances | fn:HasLexicalUnit | fn:lu:contrary_circumstances:in_face_of | "contrary circumstances" | "in face of" | "has lexical unit" |  | "FN" |  |
| fn:contrary_circumstances | fn:HasLexicalUnit | fn:lu:contrary_circumstances:despite | "contrary circumstances" | "despite" | "has lexical unit" |  | "FN" |  |
| fn:contrary_circumstances | fn:HasLexicalUnit | fn:lu:contrary_circumstances:amidst | "contrary circumstances" | "amidst" | "has lexical unit" |  | "FN" |  |
| fn:contrary_circumstances | /r/HasA | fn:fe:event | "contrary circumstances" | "event" | "/r/has a" |  | "FN" |  |
| fn:contrary_circumstances | /r/HasA | fn:fe:adversity | "contrary circumstances" | "adversity" | "/r/has a" |  | "FN" |  |
| fn:contrary_circumstances | /r/HasA | fn:fe:contrary_circumstances | "contrary circumstances" | "contrary circumstances" | "/r/has a" |  | "FN" |  |
| fn:emotions | /r/UsedFor | fn:contrition | "emotions" | "contrition" | "/r/used for" |  | "FN" |  |
| fn:guilt_or_innocence | /r/RelatedTo | fn:contrition | "guilt or innocence" | "contrition" | "/r/related to" |  | "FN" |  |
| fn:contrition | fn:HasLexicalUnit | fn:lu:contrition:contrite | "contrition" | "contrite" | "has lexical unit" |  | "FN" |  |
| fn:contrition | fn:HasLexicalUnit | fn:lu:contrition:contrition | "contrition" | "contrition" | "has lexical unit" |  | "FN" |  |
| fn:contrition | fn:HasLexicalUnit | fn:lu:contrition:rue | "contrition" | "rue" | "has lexical unit" |  | "FN" |  |
| fn:contrition | fn:HasLexicalUnit | fn:lu:contrition:rueful | "contrition" | "rueful" | "has lexical unit" |  | "FN" |  |
| fn:contrition | fn:HasLexicalUnit | fn:lu:contrition:repent | "contrition" | "repent" | "has lexical unit" |  | "FN" |  |
| fn:contrition | fn:HasLexicalUnit | fn:lu:contrition:repentant | "contrition" | "repentant" | "has lexical unit" |  | "FN" |  |
| fn:contrition | fn:HasLexicalUnit | fn:lu:contrition:repentance | "contrition" | "repentance" | "has lexical unit" |  | "FN" |  |
| fn:contrition | fn:HasLexicalUnit | fn:lu:contrition:penitent | "contrition" | "penitent" | "has lexical unit" |  | "FN" |  |
| fn:contrition | fn:HasLexicalUnit | fn:lu:contrition:penitence | "contrition" | "penitence" | "has lexical unit" |  | "FN" |  |
| fn:contrition | fn:HasLexicalUnit | fn:lu:contrition:remorse | "contrition" | "remorse" | "has lexical unit" |  | "FN" |  |
| fn:contrition | fn:HasLexicalUnit | fn:lu:contrition:remorseful | "contrition" | "remorseful" | "has lexical unit" |  | "FN" |  |
| fn:contrition | fn:HasLexicalUnit | fn:lu:contrition:sorry | "contrition" | "sorry" | "has lexical unit" |  | "FN" |  |
| fn:contrition | fn:HasLexicalUnit | fn:lu:contrition:guilty | "contrition" | "guilty" | "has lexical unit" |  | "FN" |  |
| fn:contrition | fn:HasLexicalUnit | fn:lu:contrition:remorseless | "contrition" | "remorseless" | "has lexical unit" |  | "FN" |  |
| fn:contrition | fn:HasLexicalUnit | fn:lu:contrition:unrepentant | "contrition" | "unrepentant" | "has lexical unit" |  | "FN" |  |
| fn:contrition | fn:HasLexicalUnit | fn:lu:contrition:guilt | "contrition" | "guilt" | "has lexical unit" |  | "FN" |  |
| fn:contrition | /r/HasA | fn:fe:experiencer | "contrition" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:contrition | /r/HasA | fn:fe:action | "contrition" | "action" | "/r/has a" |  | "FN" |  |
| fn:contrition | /r/HasA | fn:fe:degree | "contrition" | "degree" | "/r/has a" |  | "FN" |  |
| fn:contrition | /r/HasA | fn:fe:expressor | "contrition" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:contrition | /r/HasA | fn:fe:authenticity | "contrition" | "authenticity" | "/r/has a" |  | "FN" |  |
| fn:contrition | /r/HasA | fn:fe:emotional_state | "contrition" | "emotional state" | "/r/has a" |  | "FN" |  |
| fn:contrition | /r/HasA | fn:fe:depictive | "contrition" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:contrition | /r/HasA | fn:fe:time | "contrition" | "time" | "/r/has a" |  | "FN" |  |
| fn:contrition | /r/HasA | fn:fe:manner | "contrition" | "manner" | "/r/has a" |  | "FN" |  |
| fn:being_in_control | /r/IsA | fn:control | "being in control" | "control" | "/r/is a" |  | "FN" |  |
| fn:control | /r/IsA | fn:objective_influence | "control" | "objective influence" | "/r/is a" |  | "FN" |  |
| fn:control | /r/SimilarTo | fn:being_in_control | "control" | "being in control" | "/r/similar to" |  | "FN" |  |
| fn:control | fn:HasLexicalUnit | fn:lu:control:control | "control" | "control" | "has lexical unit" |  | "FN" |  |
| fn:control | fn:HasLexicalUnit | fn:lu:control:determine | "control" | "determine" | "has lexical unit" |  | "FN" |  |
| fn:control | fn:HasLexicalUnit | fn:lu:control:control | "control" | "control" | "has lexical unit" |  | "FN" |  |
| fn:control | fn:HasLexicalUnit | fn:lu:control:command | "control" | "command" | "has lexical unit" |  | "FN" |  |
| fn:control | fn:HasLexicalUnit | fn:lu:control:command | "control" | "command" | "has lexical unit" |  | "FN" |  |
| fn:control | fn:HasLexicalUnit | fn:lu:control:regulate | "control" | "regulate" | "has lexical unit" |  | "FN" |  |
| fn:control | fn:HasLexicalUnit | fn:lu:control:regulation | "control" | "regulation" | "has lexical unit" |  | "FN" |  |
| fn:fe:controlling_entity | /r/RelatedTo | fn:fe:controlling_situation | "controlling entity" | "controlling situation" | "/r/related to" |  | "FN" |  |
| fn:control | /r/HasA | fn:fe:controlling_entity | "control" | "controlling entity" | "/r/has a" |  | "FN" |  |
| fn:control | /r/HasA | fn:fe:dependent_entity | "control" | "dependent entity" | "/r/has a" |  | "FN" |  |
| fn:fe:controlling_variable | /r/RelatedTo | fn:fe:controlling_entity | "controlling variable" | "controlling entity" | "/r/related to" |  | "FN" |  |
| fn:control | /r/HasA | fn:fe:controlling_variable | "control" | "controlling variable" | "/r/has a" |  | "FN" |  |
| fn:control | /r/HasA | fn:fe:dependent_situation | "control" | "dependent situation" | "/r/has a" |  | "FN" |  |
| fn:control | /r/HasA | fn:fe:dependent_variable | "control" | "dependent variable" | "/r/has a" |  | "FN" |  |
| fn:fe:controlling_situation | /r/RelatedTo | fn:fe:controlling_variable | "controlling situation" | "controlling variable" | "/r/related to" |  | "FN" |  |
| fn:control | /r/HasA | fn:fe:controlling_situation | "control" | "controlling situation" | "/r/has a" |  | "FN" |  |
| fn:control | /r/HasA | fn:fe:degree | "control" | "degree" | "/r/has a" |  | "FN" |  |
| fn:control | /r/HasA | fn:fe:time | "control" | "time" | "/r/has a" |  | "FN" |  |
| fn:control | /r/HasA | fn:fe:place | "control" | "place" | "/r/has a" |  | "FN" |  |
| fn:control | /r/HasA | fn:fe:manner | "control" | "manner" | "/r/has a" |  | "FN" |  |
| fn:controller_object | /r/IsA | fn:artifact | "controller object" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:controller_object | fn:HasLexicalUnit | fn:lu:controller_object:button | "controller object" | "button" | "has lexical unit" |  | "FN" |  |
| fn:controller_object | fn:HasLexicalUnit | fn:lu:controller_object:board | "controller object" | "board" | "has lexical unit" |  | "FN" |  |
| fn:controller_object | fn:HasLexicalUnit | fn:lu:controller_object:knob | "controller object" | "knob" | "has lexical unit" |  | "FN" |  |
| fn:controller_object | fn:HasLexicalUnit | fn:lu:controller_object:switch | "controller object" | "switch" | "has lexical unit" |  | "FN" |  |
| fn:controller_object | fn:HasLexicalUnit | fn:lu:controller_object:control | "controller object" | "control" | "has lexical unit" |  | "FN" |  |
| fn:controller_object | fn:HasLexicalUnit | fn:lu:controller_object:switchboard | "controller object" | "switchboard" | "has lexical unit" |  | "FN" |  |
| fn:fe:control | /r/IsA | fn:st:physical_entity | "control" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:controller_object | /r/HasA | fn:fe:control | "controller object" | "control" | "/r/has a" |  | "FN" |  |
| fn:controller_object | /r/HasA | fn:fe:use | "controller object" | "use" | "/r/has a" |  | "FN" |  |
| fn:controller_object | /r/HasA | fn:fe:creator | "controller object" | "creator" | "/r/has a" |  | "FN" |  |
| fn:controller_object | /r/HasA | fn:fe:time_of_creation | "controller object" | "time of creation" | "/r/has a" |  | "FN" |  |
| fn:controller_object | /r/HasA | fn:fe:name | "controller object" | "name" | "/r/has a" |  | "FN" |  |
| fn:controller_object | /r/HasA | fn:fe:type | "controller object" | "type" | "/r/has a" |  | "FN" |  |
| fn:controller_object | /r/HasA | fn:fe:material | "controller object" | "material" | "/r/has a" |  | "FN" |  |
| fn:controller_object | /r/HasA | fn:fe:controlled_entity | "controller object" | "controlled entity" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:convey_importance | "communication" | "convey importance" | "/r/used for" |  | "FN" |  |
| fn:convey_importance | fn:HasLexicalUnit | fn:lu:convey_importance:stress | "convey importance" | "stress" | "has lexical unit" |  | "FN" |  |
| fn:convey_importance | fn:HasLexicalUnit | fn:lu:convey_importance:emphasize | "convey importance" | "emphasize" | "has lexical unit" |  | "FN" |  |
| fn:convey_importance | fn:HasLexicalUnit | fn:lu:convey_importance:underline | "convey importance" | "underline" | "has lexical unit" |  | "FN" |  |
| fn:convey_importance | fn:HasLexicalUnit | fn:lu:convey_importance:underscore | "convey importance" | "underscore" | "has lexical unit" |  | "FN" |  |
| fn:convey_importance | /r/HasA | fn:fe:speaker | "convey importance" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:convey_importance | /r/HasA | fn:fe:addressee | "convey importance" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:convey_importance | /r/HasA | fn:fe:message | "convey importance" | "message" | "/r/has a" |  | "FN" |  |
| fn:convey_importance | /r/HasA | fn:fe:medium | "convey importance" | "medium" | "/r/has a" |  | "FN" |  |
| fn:convey_importance | /r/HasA | fn:fe:manner | "convey importance" | "manner" | "/r/has a" |  | "FN" |  |
| fn:convey_importance | /r/HasA | fn:fe:means | "convey importance" | "means" | "/r/has a" |  | "FN" |  |
| fn:convey_importance | /r/HasA | fn:fe:time | "convey importance" | "time" | "/r/has a" |  | "FN" |  |
| fn:convey_importance | /r/HasA | fn:fe:iterations | "convey importance" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:convey_importance | /r/HasA | fn:fe:degree | "convey importance" | "degree" | "/r/has a" |  | "FN" |  |
| fn:convey_importance | /r/HasA | fn:fe:place | "convey importance" | "place" | "/r/has a" |  | "FN" |  |
| fn:convey_importance | /r/HasA | fn:fe:circumstances | "convey importance" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:convey_importance | /r/HasA | fn:fe:frequency | "convey importance" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:convey_importance | /r/HasA | fn:fe:period_of_iterations | "convey importance" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:convey_importance | /r/HasA | fn:fe:event_description | "convey importance" | "event description" | "/r/has a" |  | "FN" |  |
| fn:convey_importance | /r/HasA | fn:fe:particular_iteration | "convey importance" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:convoy | /r/IsA | fn:aggregate | "convoy" | "aggregate" | "/r/is a" |  | "FN" |  |
| fn:bringing | /r/UsedFor | fn:convoy | "bringing" | "convoy" | "/r/used for" |  | "FN" |  |
| fn:vehicle | /r/UsedFor | fn:convoy | "vehicle" | "convoy" | "/r/used for" |  | "FN" |  |
| fn:convoy | fn:HasLexicalUnit | fn:lu:convoy:convoy | "convoy" | "convoy" | "has lexical unit" |  | "FN" |  |
| fn:convoy | fn:HasLexicalUnit | fn:lu:convoy:train | "convoy" | "train" | "has lexical unit" |  | "FN" |  |
| fn:convoy | /r/HasA | fn:fe:vehicles | "convoy" | "vehicles" | "/r/has a" |  | "FN" |  |
| fn:convoy | /r/HasA | fn:fe:convoy | "convoy" | "convoy" | "/r/has a" |  | "FN" |  |
| fn:convoy | /r/HasA | fn:fe:aggregate_property | "convoy" | "aggregate property" | "/r/has a" |  | "FN" |  |
| fn:convoy | /r/HasA | fn:fe:name | "convoy" | "name" | "/r/has a" |  | "FN" |  |
| fn:convoy | /r/HasA | fn:fe:domain | "convoy" | "domain" | "/r/has a" |  | "FN" |  |
| fn:convoy | /r/HasA | fn:fe:possessor | "convoy" | "possessor" | "/r/has a" |  | "FN" |  |
| fn:convoy | /r/HasA | fn:fe:cargo | "convoy" | "cargo" | "/r/has a" |  | "FN" |  |
| fn:convoy | /r/HasA | fn:fe:source | "convoy" | "source" | "/r/has a" |  | "FN" |  |
| fn:convoy | /r/HasA | fn:fe:path | "convoy" | "path" | "/r/has a" |  | "FN" |  |
| fn:convoy | /r/HasA | fn:fe:goal | "convoy" | "goal" | "/r/has a" |  | "FN" |  |
| fn:convoy | /r/HasA | fn:fe:direction | "convoy" | "direction" | "/r/has a" |  | "FN" |  |
| fn:convoy | /r/HasA | fn:fe:support | "convoy" | "support" | "/r/has a" |  | "FN" |  |
| fn:convoy | /r/HasA | fn:fe:place | "convoy" | "place" | "/r/has a" |  | "FN" |  |
| fn:cooking_creation | /r/IsA | fn:intentionally_create | "cooking creation" | "intentionally create" | "/r/is a" |  | "FN" |  |
| fn:apply_heat | /r/UsedFor | fn:cooking_creation | "apply heat" | "cooking creation" | "/r/used for" |  | "FN" |  |
| fn:apply_heat | /r/RelatedTo | fn:cooking_creation | "apply heat" | "cooking creation" | "/r/related to" |  | "FN" |  |
| fn:cooking_creation | fn:HasLexicalUnit | fn:lu:cooking_creation:concoct | "cooking creation" | "concoct" | "has lexical unit" |  | "FN" |  |
| fn:cooking_creation | fn:HasLexicalUnit | fn:lu:cooking_creation:cook_up | "cooking creation" | "cook up" | "has lexical unit" |  | "FN" |  |
| fn:cooking_creation | fn:HasLexicalUnit | fn:lu:cooking_creation:whip_up | "cooking creation" | "whip up" | "has lexical unit" |  | "FN" |  |
| fn:cooking_creation | fn:HasLexicalUnit | fn:lu:cooking_creation:cook | "cooking creation" | "cook" | "has lexical unit" |  | "FN" |  |
| fn:cooking_creation | fn:HasLexicalUnit | fn:lu:cooking_creation:prepare | "cooking creation" | "prepare" | "has lexical unit" |  | "FN" |  |
| fn:cooking_creation | fn:HasLexicalUnit | fn:lu:cooking_creation:make | "cooking creation" | "make" | "has lexical unit" |  | "FN" |  |
| fn:cooking_creation | fn:HasLexicalUnit | fn:lu:cooking_creation:bake | "cooking creation" | "bake" | "has lexical unit" |  | "FN" |  |
| fn:cooking_creation | fn:HasLexicalUnit | fn:lu:cooking_creation:put_together | "cooking creation" | "put together" | "has lexical unit" |  | "FN" |  |
| fn:cooking_creation | fn:HasLexicalUnit | fn:lu:cooking_creation:cook | "cooking creation" | "cook" | "has lexical unit" |  | "FN" |  |
| fn:cooking_creation | fn:HasLexicalUnit | fn:lu:cooking_creation:preparation | "cooking creation" | "preparation" | "has lexical unit" |  | "FN" |  |
| fn:cooking_creation | fn:HasLexicalUnit | fn:lu:cooking_creation:baking | "cooking creation" | "baking" | "has lexical unit" |  | "FN" |  |
| fn:cooking_creation | fn:HasLexicalUnit | fn:lu:cooking_creation:cooking | "cooking creation" | "cooking" | "has lexical unit" |  | "FN" |  |
| fn:cooking_creation | fn:HasLexicalUnit | fn:lu:cooking_creation:grill | "cooking creation" | "grill" | "has lexical unit" |  | "FN" |  |
| fn:cooking_creation | fn:HasLexicalUnit | fn:lu:cooking_creation:grilling | "cooking creation" | "grilling" | "has lexical unit" |  | "FN" |  |
| fn:cooking_creation | fn:HasLexicalUnit | fn:lu:cooking_creation:roast | "cooking creation" | "roast" | "has lexical unit" |  | "FN" |  |
| fn:cooking_creation | fn:HasLexicalUnit | fn:lu:cooking_creation:roasting | "cooking creation" | "roasting" | "has lexical unit" |  | "FN" |  |
| fn:cooking_creation | fn:HasLexicalUnit | fn:lu:cooking_creation:fry | "cooking creation" | "fry" | "has lexical unit" |  | "FN" |  |
| fn:cooking_creation | fn:HasLexicalUnit | fn:lu:cooking_creation:frying | "cooking creation" | "frying" | "has lexical unit" |  | "FN" |  |
| fn:cooking_creation | fn:HasLexicalUnit | fn:lu:cooking_creation:fix | "cooking creation" | "fix" | "has lexical unit" |  | "FN" |  |
| fn:cooking_creation | /r/HasA | fn:fe:cook | "cooking creation" | "cook" | "/r/has a" |  | "FN" |  |
| fn:cooking_creation | /r/HasA | fn:fe:produced_food | "cooking creation" | "produced food" | "/r/has a" |  | "FN" |  |
| fn:cooking_creation | /r/HasA | fn:fe:heating_instrument | "cooking creation" | "heating instrument" | "/r/has a" |  | "FN" |  |
| fn:cooking_creation | /r/HasA | fn:fe:container | "cooking creation" | "container" | "/r/has a" |  | "FN" |  |
| fn:cooking_creation | /r/HasA | fn:fe:place | "cooking creation" | "place" | "/r/has a" |  | "FN" |  |
| fn:cooking_creation | /r/HasA | fn:fe:means | "cooking creation" | "means" | "/r/has a" |  | "FN" |  |
| fn:cooking_creation | /r/HasA | fn:fe:purpose | "cooking creation" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cooking_creation | /r/HasA | fn:fe:recipient | "cooking creation" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:cooking_creation | /r/HasA | fn:fe:time | "cooking creation" | "time" | "/r/has a" |  | "FN" |  |
| fn:cooking_creation | /r/HasA | fn:fe:degree | "cooking creation" | "degree" | "/r/has a" |  | "FN" |  |
| fn:cooking_creation | /r/HasA | fn:fe:manner | "cooking creation" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cooking_creation | /r/HasA | fn:fe:ingredients | "cooking creation" | "ingredients" | "/r/has a" |  | "FN" |  |
| fn:corporal_punishment | /r/IsA | fn:cause_harm | "corporal punishment" | "cause harm" | "/r/is a" |  | "FN" |  |
| fn:corporal_punishment | /r/IsA | fn:rewards_and_punishments | "corporal punishment" | "rewards and punishments" | "/r/is a" |  | "FN" |  |
| fn:cause_harm | /r/SimilarTo | fn:corporal_punishment | "cause harm" | "corporal punishment" | "/r/similar to" |  | "FN" |  |
| fn:corporal_punishment | fn:HasLexicalUnit | fn:lu:corporal_punishment:flog | "corporal punishment" | "flog" | "has lexical unit" |  | "FN" |  |
| fn:corporal_punishment | fn:HasLexicalUnit | fn:lu:corporal_punishment:flogging | "corporal punishment" | "flogging" | "has lexical unit" |  | "FN" |  |
| fn:corporal_punishment | fn:HasLexicalUnit | fn:lu:corporal_punishment:cane | "corporal punishment" | "cane" | "has lexical unit" |  | "FN" |  |
| fn:corporal_punishment | fn:HasLexicalUnit | fn:lu:corporal_punishment:caning | "corporal punishment" | "caning" | "has lexical unit" |  | "FN" |  |
| fn:corporal_punishment | fn:HasLexicalUnit | fn:lu:corporal_punishment:lash | "corporal punishment" | "lash" | "has lexical unit" |  | "FN" |  |
| fn:corporal_punishment | fn:HasLexicalUnit | fn:lu:corporal_punishment:scourge | "corporal punishment" | "scourge" | "has lexical unit" |  | "FN" |  |
| fn:corporal_punishment | fn:HasLexicalUnit | fn:lu:corporal_punishment:paddle | "corporal punishment" | "paddle" | "has lexical unit" |  | "FN" |  |
| fn:corporal_punishment | fn:HasLexicalUnit | fn:lu:corporal_punishment:spank | "corporal punishment" | "spank" | "has lexical unit" |  | "FN" |  |
| fn:corporal_punishment | /r/HasA | fn:fe:agent | "corporal punishment" | "agent" | "/r/has a" |  | "FN" |  |
| fn:corporal_punishment | /r/HasA | fn:fe:instrument | "corporal punishment" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:corporal_punishment | /r/HasA | fn:fe:means | "corporal punishment" | "means" | "/r/has a" |  | "FN" |  |
| fn:corporal_punishment | /r/HasA | fn:fe:place | "corporal punishment" | "place" | "/r/has a" |  | "FN" |  |
| fn:corporal_punishment | /r/HasA | fn:fe:purpose | "corporal punishment" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:corporal_punishment | /r/HasA | fn:fe:time | "corporal punishment" | "time" | "/r/has a" |  | "FN" |  |
| fn:fe:evaluee | /r/IsA | fn:st:sentient | "evaluee" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:corporal_punishment | /r/HasA | fn:fe:evaluee | "corporal punishment" | "evaluee" | "/r/has a" |  | "FN" |  |
| fn:corporal_punishment | /r/HasA | fn:fe:manner | "corporal punishment" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fe:reason | /r/IsA | fn:st:state_of_affairs | "reason" | "state of affairs" | "/r/is a" |  | "FN" |  |
| fn:corporal_punishment | /r/HasA | fn:fe:reason | "corporal punishment" | "reason" | "/r/has a" |  | "FN" |  |
| fn:corporal_punishment | /r/HasA | fn:fe:result | "corporal punishment" | "result" | "/r/has a" |  | "FN" |  |
| fn:corporal_punishment | /r/HasA | fn:fe:body_part | "corporal punishment" | "body part" | "/r/has a" |  | "FN" |  |
| fn:corporal_punishment | /r/HasA | fn:fe:depictive | "corporal punishment" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:corporal_punishment | /r/HasA | fn:fe:degree | "corporal punishment" | "degree" | "/r/has a" |  | "FN" |  |
| fn:corporal_punishment | /r/HasA | fn:fe:severity | "corporal punishment" | "severity" | "/r/has a" |  | "FN" |  |
| fn:correctness | /r/IsA | fn:gradable_attributes | "correctness" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:correctness | /r/UsedFor | fn:verification | "correctness" | "verification" | "/r/used for" |  | "FN" |  |
| fn:information | /r/UsedFor | fn:correctness | "information" | "correctness" | "/r/used for" |  | "FN" |  |
| fn:similarity | /r/UsedFor | fn:correctness | "similarity" | "correctness" | "/r/used for" |  | "FN" |  |
| fn:correctness | fn:HasLexicalUnit | fn:lu:correctness:correct | "correctness" | "correct" | "has lexical unit" |  | "FN" |  |
| fn:correctness | fn:HasLexicalUnit | fn:lu:correctness:incorrect | "correctness" | "incorrect" | "has lexical unit" |  | "FN" |  |
| fn:correctness | fn:HasLexicalUnit | fn:lu:correctness:wrong | "correctness" | "wrong" | "has lexical unit" |  | "FN" |  |
| fn:correctness | fn:HasLexicalUnit | fn:lu:correctness:right | "correctness" | "right" | "has lexical unit" |  | "FN" |  |
| fn:correctness | fn:HasLexicalUnit | fn:lu:correctness:accurate | "correctness" | "accurate" | "has lexical unit" |  | "FN" |  |
| fn:correctness | fn:HasLexicalUnit | fn:lu:correctness:correctness | "correctness" | "correctness" | "has lexical unit" |  | "FN" |  |
| fn:correctness | fn:HasLexicalUnit | fn:lu:correctness:exact | "correctness" | "exact" | "has lexical unit" |  | "FN" |  |
| fn:correctness | fn:HasLexicalUnit | fn:lu:correctness:true | "correctness" | "true" | "has lexical unit" |  | "FN" |  |
| fn:correctness | /r/HasA | fn:fe:information | "correctness" | "information" | "/r/has a" |  | "FN" |  |
| fn:correctness | /r/HasA | fn:fe:degree | "correctness" | "degree" | "/r/has a" |  | "FN" |  |
| fn:correctness | /r/HasA | fn:fe:domain | "correctness" | "domain" | "/r/has a" |  | "FN" |  |
| fn:correctness | /r/HasA | fn:fe:parameter | "correctness" | "parameter" | "/r/has a" |  | "FN" |  |
| fn:correctness | /r/HasA | fn:fe:frequency | "correctness" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:correctness | /r/HasA | fn:fe:circumstances | "correctness" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:fe:source | /r/RelatedTo | fn:fe:topic | "source" | "topic" | "/r/related to" |  | "FN" |  |
| fn:correctness | /r/HasA | fn:fe:source | "correctness" | "source" | "/r/has a" |  | "FN" |  |
| fn:correctness | /r/HasA | fn:fe:re-encoding | "correctness" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:correctness | /r/HasA | fn:fe:manner | "correctness" | "manner" | "/r/has a" |  | "FN" |  |
| fn:correctness | /r/HasA | fn:fe:time | "correctness" | "time" | "/r/has a" |  | "FN" |  |
| fn:correctness | /r/HasA | fn:fe:medium | "correctness" | "medium" | "/r/has a" |  | "FN" |  |
| fn:correctness | /r/HasA | fn:fe:communicative_force | "correctness" | "communicative force" | "/r/has a" |  | "FN" |  |
| fn:correctness | /r/HasA | fn:fe:result | "correctness" | "result" | "/r/has a" |  | "FN" |  |
| fn:correctness | /r/HasA | fn:fe:communicative_act | "correctness" | "communicative act" | "/r/has a" |  | "FN" |  |
| fn:correctness | /r/HasA | fn:fe:topic | "correctness" | "topic" | "/r/has a" |  | "FN" |  |
| fn:corroding_caused | /r/Causes | fn:corroding | "corroding caused" | "corroding" | "/r/causes" |  | "FN" |  |
| fn:corroding | fn:HasLexicalUnit | fn:lu:corroding:rust | "corroding" | "rust" | "has lexical unit" |  | "FN" |  |
| fn:corroding | fn:HasLexicalUnit | fn:lu:corroding:corrode | "corroding" | "corrode" | "has lexical unit" |  | "FN" |  |
| fn:corroding | fn:HasLexicalUnit | fn:lu:corroding:oxidize | "corroding" | "oxidize" | "has lexical unit" |  | "FN" |  |
| fn:corroding | /r/HasA | fn:fe:initial_state | "corroding" | "initial state" | "/r/has a" |  | "FN" |  |
| fn:corroding | /r/HasA | fn:fe:duration | "corroding" | "duration" | "/r/has a" |  | "FN" |  |
| fn:corroding | /r/HasA | fn:fe:place | "corroding" | "place" | "/r/has a" |  | "FN" |  |
| fn:corroding | /r/HasA | fn:fe:explanation | "corroding" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:corroding | /r/HasA | fn:fe:result | "corroding" | "result" | "/r/has a" |  | "FN" |  |
| fn:corroding | /r/HasA | fn:fe:time | "corroding" | "time" | "/r/has a" |  | "FN" |  |
| fn:corroding | /r/HasA | fn:fe:patient | "corroding" | "patient" | "/r/has a" |  | "FN" |  |
| fn:corroding | /r/HasA | fn:fe:degree | "corroding" | "degree" | "/r/has a" |  | "FN" |  |
| fn:corroding | /r/HasA | fn:fe:subregion | "corroding" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:corroding | /r/HasA | fn:fe:speed | "corroding" | "speed" | "/r/has a" |  | "FN" |  |
| fn:corroding_caused | /r/IsA | fn:transitive_action | "corroding caused" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:corroding_caused | /r/Causes | fn:corroding | "corroding caused" | "corroding" | "/r/causes" |  | "FN" |  |
| fn:corroding_caused | fn:HasLexicalUnit | fn:lu:corroding_caused:corrode | "corroding caused" | "corrode" | "has lexical unit" |  | "FN" |  |
| fn:corroding_caused | fn:HasLexicalUnit | fn:lu:corroding_caused:oxidize | "corroding caused" | "oxidize" | "has lexical unit" |  | "FN" |  |
| fn:corroding_caused | fn:HasLexicalUnit | fn:lu:corroding_caused:tarnish | "corroding caused" | "tarnish" | "has lexical unit" |  | "FN" |  |
| fn:corroding_caused | fn:HasLexicalUnit | fn:lu:corroding_caused:rust | "corroding caused" | "rust" | "has lexical unit" |  | "FN" |  |
| fn:corroding_caused | /r/HasA | fn:fe:degree | "corroding caused" | "degree" | "/r/has a" |  | "FN" |  |
| fn:corroding_caused | /r/HasA | fn:fe:duration | "corroding caused" | "duration" | "/r/has a" |  | "FN" |  |
| fn:corroding_caused | /r/HasA | fn:fe:initial_state | "corroding caused" | "initial state" | "/r/has a" |  | "FN" |  |
| fn:corroding_caused | /r/HasA | fn:fe:place | "corroding caused" | "place" | "/r/has a" |  | "FN" |  |
| fn:corroding_caused | /r/HasA | fn:fe:explanation | "corroding caused" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:corroding_caused | /r/HasA | fn:fe:result | "corroding caused" | "result" | "/r/has a" |  | "FN" |  |
| fn:corroding_caused | /r/HasA | fn:fe:time | "corroding caused" | "time" | "/r/has a" |  | "FN" |  |
| fn:corroding_caused | /r/HasA | fn:fe:patient | "corroding caused" | "patient" | "/r/has a" |  | "FN" |  |
| fn:corroding_caused | /r/HasA | fn:fe:speed | "corroding caused" | "speed" | "/r/has a" |  | "FN" |  |
| fn:corroding_caused | /r/HasA | fn:fe:subregion | "corroding caused" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:corroding_caused | /r/HasA | fn:fe:manner | "corroding caused" | "manner" | "/r/has a" |  | "FN" |  |
| fn:corroding_caused | /r/HasA | fn:fe:means | "corroding caused" | "means" | "/r/has a" |  | "FN" |  |
| fn:corroding_caused | /r/HasA | fn:fe:purpose | "corroding caused" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:corroding_caused | /r/HasA | fn:fe:cause | "corroding caused" | "cause" | "/r/has a" |  | "FN" |  |
| fn:corroding_caused | /r/HasA | fn:fe:agent | "corroding caused" | "agent" | "/r/has a" |  | "FN" |  |
| fn:corroding_caused | /r/HasA | fn:fe:instrument | "corroding caused" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:cotheme | /r/IsA | fn:self_motion | "cotheme" | "self motion" | "/r/is a" |  | "FN" |  |
| fn:cotheme | /r/UsedFor | fn:entourage | "cotheme" | "entourage" | "/r/used for" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:cotheme | "motion" | "cotheme" | "/r/used for" |  | "FN" |  |
| fn:cotheme | /r/SimilarTo | fn:escaping | "cotheme" | "escaping" | "/r/similar to" |  | "FN" |  |
| fn:cotheme | /r/SimilarTo | fn:evading | "cotheme" | "evading" | "/r/similar to" |  | "FN" |  |
| fn:cotheme | fn:HasLexicalUnit | fn:lu:cotheme:accompany | "cotheme" | "accompany" | "has lexical unit" |  | "FN" |  |
| fn:cotheme | fn:HasLexicalUnit | fn:lu:cotheme:chase | "cotheme" | "chase" | "has lexical unit" |  | "FN" |  |
| fn:cotheme | fn:HasLexicalUnit | fn:lu:cotheme:conduct | "cotheme" | "conduct" | "has lexical unit" |  | "FN" |  |
| fn:cotheme | fn:HasLexicalUnit | fn:lu:cotheme:escort | "cotheme" | "escort" | "has lexical unit" |  | "FN" |  |
| fn:cotheme | fn:HasLexicalUnit | fn:lu:cotheme:follow | "cotheme" | "follow" | "has lexical unit" |  | "FN" |  |
| fn:cotheme | fn:HasLexicalUnit | fn:lu:cotheme:guide | "cotheme" | "guide" | "has lexical unit" |  | "FN" |  |
| fn:cotheme | fn:HasLexicalUnit | fn:lu:cotheme:hound | "cotheme" | "hound" | "has lexical unit" |  | "FN" |  |
| fn:cotheme | fn:HasLexicalUnit | fn:lu:cotheme:lead | "cotheme" | "lead" | "has lexical unit" |  | "FN" |  |
| fn:cotheme | fn:HasLexicalUnit | fn:lu:cotheme:pursue | "cotheme" | "pursue" | "has lexical unit" |  | "FN" |  |
| fn:cotheme | fn:HasLexicalUnit | fn:lu:cotheme:shadow | "cotheme" | "shadow" | "has lexical unit" |  | "FN" |  |
| fn:cotheme | fn:HasLexicalUnit | fn:lu:cotheme:shepherd | "cotheme" | "shepherd" | "has lexical unit" |  | "FN" |  |
| fn:cotheme | fn:HasLexicalUnit | fn:lu:cotheme:tail | "cotheme" | "tail" | "has lexical unit" |  | "FN" |  |
| fn:cotheme | fn:HasLexicalUnit | fn:lu:cotheme:track | "cotheme" | "track" | "has lexical unit" |  | "FN" |  |
| fn:cotheme | fn:HasLexicalUnit | fn:lu:cotheme:trail | "cotheme" | "trail" | "has lexical unit" |  | "FN" |  |
| fn:cotheme | fn:HasLexicalUnit | fn:lu:cotheme:pursuit | "cotheme" | "pursuit" | "has lexical unit" |  | "FN" |  |
| fn:cotheme | fn:HasLexicalUnit | fn:lu:cotheme:pursuer | "cotheme" | "pursuer" | "has lexical unit" |  | "FN" |  |
| fn:cotheme | fn:HasLexicalUnit | fn:lu:cotheme:usher | "cotheme" | "usher" | "has lexical unit" |  | "FN" |  |
| fn:cotheme | fn:HasLexicalUnit | fn:lu:cotheme:stalk | "cotheme" | "stalk" | "has lexical unit" |  | "FN" |  |
| fn:cotheme | fn:HasLexicalUnit | fn:lu:cotheme:tag_along | "cotheme" | "tag along" | "has lexical unit" |  | "FN" |  |
| fn:cotheme | fn:HasLexicalUnit | fn:lu:cotheme:walk | "cotheme" | "walk" | "has lexical unit" |  | "FN" |  |
| fn:cotheme | fn:HasLexicalUnit | fn:lu:cotheme:guided | "cotheme" | "guided" | "has lexical unit" |  | "FN" |  |
| fn:cotheme | fn:HasLexicalUnit | fn:lu:cotheme:dog | "cotheme" | "dog" | "has lexical unit" |  | "FN" |  |
| fn:cotheme | fn:HasLexicalUnit | fn:lu:cotheme:dog_(someone's)_steps | "cotheme" | "dog (someone\\'s) steps" | "has lexical unit" |  | "FN" |  |
| fn:cotheme | fn:HasLexicalUnit | fn:lu:cotheme:show | "cotheme" | "show" | "has lexical unit" |  | "FN" |  |
| fn:cotheme | fn:HasLexicalUnit | fn:lu:cotheme:lead_the_way | "cotheme" | "lead the way" | "has lexical unit" |  | "FN" |  |
| fn:cotheme | /r/HasA | fn:fe:theme | "cotheme" | "theme" | "/r/has a" |  | "FN" |  |
| fn:fe:cotheme | /r/IsA | fn:st:physical_object | "cotheme" | "physical object" | "/r/is a" |  | "FN" |  |
| fn:cotheme | /r/HasA | fn:fe:cotheme | "cotheme" | "cotheme" | "/r/has a" |  | "FN" |  |
| fn:cotheme | /r/HasA | fn:fe:source | "cotheme" | "source" | "/r/has a" |  | "FN" |  |
| fn:fe:path | /r/IsA | fn:st:path | "path" | "path" | "/r/is a" |  | "FN" |  |
| fn:st:path | /r/IsA | fn:st:ontological_type | "path" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:cotheme | /r/HasA | fn:fe:path | "cotheme" | "path" | "/r/has a" |  | "FN" |  |
| fn:cotheme | /r/HasA | fn:fe:goal | "cotheme" | "goal" | "/r/has a" |  | "FN" |  |
| fn:cotheme | /r/HasA | fn:fe:manner | "cotheme" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fe:distance | /r/IsA | fn:st:quantity | "distance" | "quantity" | "/r/is a" |  | "FN" |  |
| fn:cotheme | /r/HasA | fn:fe:distance | "cotheme" | "distance" | "/r/has a" |  | "FN" |  |
| fn:fe:area | /r/IsA | fn:st:location | "area" | "location" | "/r/is a" |  | "FN" |  |
| fn:cotheme | /r/HasA | fn:fe:area | "cotheme" | "area" | "/r/has a" |  | "FN" |  |
| fn:fe:depictive | /r/IsA | fn:st:state | "depictive" | "state" | "/r/is a" |  | "FN" |  |
| fn:st:state | /r/IsA | fn:st:ontological_type | "state" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:cotheme | /r/HasA | fn:fe:depictive | "cotheme" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:cotheme | /r/HasA | fn:fe:event | "cotheme" | "event" | "/r/has a" |  | "FN" |  |
| fn:cotheme | /r/HasA | fn:fe:means | "cotheme" | "means" | "/r/has a" |  | "FN" |  |
| fn:fe:result | /r/IsA | fn:st:event | "result" | "event" | "/r/is a" |  | "FN" |  |
| fn:cotheme | /r/HasA | fn:fe:result | "cotheme" | "result" | "/r/has a" |  | "FN" |  |
| fn:cotheme | /r/HasA | fn:fe:mode_of_transportation | "cotheme" | "mode of transportation" | "/r/has a" |  | "FN" |  |
| fn:cotheme | /r/HasA | fn:fe:speed | "cotheme" | "speed" | "/r/has a" |  | "FN" |  |
| fn:fe:road | /r/RelatedTo | fn:fe:cotheme | "road" | "cotheme" | "/r/related to" |  | "FN" |  |
| fn:cotheme | /r/HasA | fn:fe:road | "cotheme" | "road" | "/r/has a" |  | "FN" |  |
| fn:cotheme | /r/HasA | fn:fe:duration | "cotheme" | "duration" | "/r/has a" |  | "FN" |  |
| fn:cotheme | /r/HasA | fn:fe:time | "cotheme" | "time" | "/r/has a" |  | "FN" |  |
| fn:fe:purpose | /r/IsA | fn:st:human_act | "purpose" | "human act" | "/r/is a" |  | "FN" |  |
| fn:cotheme | /r/HasA | fn:fe:purpose | "cotheme" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cotheme | /r/HasA | fn:fe:following_distance | "cotheme" | "following distance" | "/r/has a" |  | "FN" |  |
| fn:cotheme | /r/HasA | fn:fe:handle | "cotheme" | "handle" | "/r/has a" |  | "FN" |  |
| fn:cotheme | /r/HasA | fn:fe:place | "cotheme" | "place" | "/r/has a" |  | "FN" |  |
| fn:cotheme | /r/HasA | fn:fe:explanation | "cotheme" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:fe:direction | /r/RelatedTo | fn:fe:area | "direction" | "area" | "/r/related to" |  | "FN" |  |
| fn:cotheme | /r/HasA | fn:fe:direction | "cotheme" | "direction" | "/r/has a" |  | "FN" |  |
| fn:counterattack | /r/IsA | fn:attack | "counterattack" | "attack" | "/r/is a" |  | "FN" |  |
| fn:response | /r/UsedFor | fn:counterattack | "response" | "counterattack" | "/r/used for" |  | "FN" |  |
| fn:counterattack | fn:HasLexicalUnit | fn:lu:counterattack:counter-attack | "counterattack" | "counter-attack" | "has lexical unit" |  | "FN" |  |
| fn:counterattack | fn:HasLexicalUnit | fn:lu:counterattack:counter-attack | "counterattack" | "counter-attack" | "has lexical unit" |  | "FN" |  |
| fn:counterattack | fn:HasLexicalUnit | fn:lu:counterattack:counter-offensive | "counterattack" | "counter-offensive" | "has lexical unit" |  | "FN" |  |
| fn:counterattack | /r/HasA | fn:fe:victim | "counterattack" | "victim" | "/r/has a" |  | "FN" |  |
| fn:counterattack | /r/HasA | fn:fe:weapon | "counterattack" | "weapon" | "/r/has a" |  | "FN" |  |
| fn:counterattack | /r/HasA | fn:fe:assailant | "counterattack" | "assailant" | "/r/has a" |  | "FN" |  |
| fn:counterattack | /r/HasA | fn:fe:manner | "counterattack" | "manner" | "/r/has a" |  | "FN" |  |
| fn:counterattack | /r/HasA | fn:fe:means | "counterattack" | "means" | "/r/has a" |  | "FN" |  |
| fn:counterattack | /r/HasA | fn:fe:place | "counterattack" | "place" | "/r/has a" |  | "FN" |  |
| fn:counterattack | /r/HasA | fn:fe:purpose | "counterattack" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:counterattack | /r/HasA | fn:fe:explanation | "counterattack" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:counterattack | /r/HasA | fn:fe:time | "counterattack" | "time" | "/r/has a" |  | "FN" |  |
| fn:counterattack | /r/HasA | fn:fe:source | "counterattack" | "source" | "/r/has a" |  | "FN" |  |
| fn:counterattack | /r/HasA | fn:fe:depictive | "counterattack" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:counterattack | /r/HasA | fn:fe:re-encoding | "counterattack" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:counterattack | /r/HasA | fn:fe:result | "counterattack" | "result" | "/r/has a" |  | "FN" |  |
| fn:counterattack | /r/HasA | fn:fe:containing_event | "counterattack" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:counterattack | /r/HasA | fn:fe:particular_iteration | "counterattack" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:counterattack | /r/HasA | fn:fe:circumstances | "counterattack" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:counterattack | /r/HasA | fn:fe:iterations | "counterattack" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:counterattack | /r/HasA | fn:fe:event_description | "counterattack" | "event description" | "/r/has a" |  | "FN" |  |
| fn:counterattack | /r/HasA | fn:fe:path | "counterattack" | "path" | "/r/has a" |  | "FN" |  |
| fn:trial | /r/HasSubevent | fn:court_examination | "trial" | "court examination" | "/r/has subevent" |  | "FN" |  |
| fn:questioning | /r/UsedFor | fn:court_examination | "questioning" | "court examination" | "/r/used for" |  | "FN" |  |
| fn:jury_deliberation | /r/HasPrerequisite | fn:court_examination | "jury deliberation" | "court examination" | "/r/has prerequisite" |  | "FN" |  |
| fn:court_examination | fn:HasLexicalUnit | fn:lu:court_examination:examine | "court examination" | "examine" | "has lexical unit" |  | "FN" |  |
| fn:court_examination | fn:HasLexicalUnit | fn:lu:court_examination:cross-examine | "court examination" | "cross-examine" | "has lexical unit" |  | "FN" |  |
| fn:court_examination | fn:HasLexicalUnit | fn:lu:court_examination:cross | "court examination" | "cross" | "has lexical unit" |  | "FN" |  |
| fn:court_examination | fn:HasLexicalUnit | fn:lu:court_examination:cross-examination | "court examination" | "cross-examination" | "has lexical unit" |  | "FN" |  |
| fn:court_examination | fn:HasLexicalUnit | fn:lu:court_examination:examination | "court examination" | "examination" | "has lexical unit" |  | "FN" |  |
| fn:fe:questioner | /r/IsA | fn:st:sentient | "questioner" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:court_examination | /r/HasA | fn:fe:questioner | "court examination" | "questioner" | "/r/has a" |  | "FN" |  |
| fn:fe:witness | /r/IsA | fn:st:sentient | "witness" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:court_examination | /r/HasA | fn:fe:witness | "court examination" | "witness" | "/r/has a" |  | "FN" |  |
| fn:court_examination | /r/HasA | fn:fe:topic | "court examination" | "topic" | "/r/has a" |  | "FN" |  |
| fn:court_examination | /r/HasA | fn:fe:time | "court examination" | "time" | "/r/has a" |  | "FN" |  |
| fn:court_examination | /r/HasA | fn:fe:place | "court examination" | "place" | "/r/has a" |  | "FN" |  |
| fn:court_examination | /r/HasA | fn:fe:manner | "court examination" | "manner" | "/r/has a" |  | "FN" |  |
| fn:court_examination | /r/HasA | fn:fe:purpose | "court examination" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:court_examination | /r/HasA | fn:fe:means | "court examination" | "means" | "/r/has a" |  | "FN" |  |
| fn:court_examination | /r/HasA | fn:fe:duration | "court examination" | "duration" | "/r/has a" |  | "FN" |  |
| fn:custom | /r/UsedFor | fn:craft | "custom" | "craft" | "/r/used for" |  | "FN" |  |
| fn:fields | /r/UsedFor | fn:craft | "fields" | "craft" | "/r/used for" |  | "FN" |  |
| fn:craft | fn:HasLexicalUnit | fn:lu:craft:art | "craft" | "art" | "has lexical unit" |  | "FN" |  |
| fn:craft | fn:HasLexicalUnit | fn:lu:craft:craft | "craft" | "craft" | "has lexical unit" |  | "FN" |  |
| fn:craft | fn:HasLexicalUnit | fn:lu:craft:science | "craft" | "science" | "has lexical unit" |  | "FN" |  |
| fn:craft | /r/HasA | fn:fe:activity | "craft" | "activity" | "/r/has a" |  | "FN" |  |
| fn:craft | /r/HasA | fn:fe:practitioner | "craft" | "practitioner" | "/r/has a" |  | "FN" |  |
| fn:craft | /r/HasA | fn:fe:place | "craft" | "place" | "/r/has a" |  | "FN" |  |
| fn:craft | /r/HasA | fn:fe:descriptor | "craft" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:craft | /r/HasA | fn:fe:culture | "craft" | "culture" | "/r/has a" |  | "FN" |  |
| fn:create_physical_artwork | /r/IsA | fn:intentionally_create | "create physical artwork" | "intentionally create" | "/r/is a" |  | "FN" |  |
| fn:create_physical_artwork | /r/UsedFor | fn:create_representation | "create physical artwork" | "create representation" | "/r/used for" |  | "FN" |  |
| fn:physical_artworks | /r/UsedFor | fn:create_physical_artwork | "physical artworks" | "create physical artwork" | "/r/used for" |  | "FN" |  |
| fn:create_physical_artwork | fn:HasLexicalUnit | fn:lu:create_physical_artwork:paint | "create physical artwork" | "paint" | "has lexical unit" |  | "FN" |  |
| fn:create_physical_artwork | fn:HasLexicalUnit | fn:lu:create_physical_artwork:draw | "create physical artwork" | "draw" | "has lexical unit" |  | "FN" |  |
| fn:create_physical_artwork | fn:HasLexicalUnit | fn:lu:create_physical_artwork:take_[picture] | "create physical artwork" | "take [picture]" | "has lexical unit" |  | "FN" |  |
| fn:create_physical_artwork | fn:HasLexicalUnit | fn:lu:create_physical_artwork:artist | "create physical artwork" | "artist" | "has lexical unit" |  | "FN" |  |
| fn:create_physical_artwork | fn:HasLexicalUnit | fn:lu:create_physical_artwork:sculpt | "create physical artwork" | "sculpt" | "has lexical unit" |  | "FN" |  |
| fn:create_physical_artwork | fn:HasLexicalUnit | fn:lu:create_physical_artwork:cast | "create physical artwork" | "cast" | "has lexical unit" |  | "FN" |  |
| fn:fe:creator | /r/IsA | fn:st:sentient | "creator" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:create_physical_artwork | /r/HasA | fn:fe:creator | "create physical artwork" | "creator" | "/r/has a" |  | "FN" |  |
| fn:create_physical_artwork | /r/HasA | fn:fe:time | "create physical artwork" | "time" | "/r/has a" |  | "FN" |  |
| fn:create_physical_artwork | /r/HasA | fn:fe:representation | "create physical artwork" | "representation" | "/r/has a" |  | "FN" |  |
| fn:create_physical_artwork | /r/HasA | fn:fe:manner | "create physical artwork" | "manner" | "/r/has a" |  | "FN" |  |
| fn:create_physical_artwork | /r/HasA | fn:fe:role | "create physical artwork" | "role" | "/r/has a" |  | "FN" |  |
| fn:create_physical_artwork | /r/HasA | fn:fe:depictive | "create physical artwork" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:create_physical_artwork | /r/HasA | fn:fe:location_of_representation | "create physical artwork" | "location of representation" | "/r/has a" |  | "FN" |  |
| fn:create_physical_artwork | /r/HasA | fn:fe:purpose | "create physical artwork" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:create_physical_artwork | /r/HasA | fn:fe:place | "create physical artwork" | "place" | "/r/has a" |  | "FN" |  |
| fn:create_physical_artwork | /r/HasA | fn:fe:explanation | "create physical artwork" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:create_physical_artwork | /r/HasA | fn:fe:instrument | "create physical artwork" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:create_physical_artwork | /r/HasA | fn:fe:means | "create physical artwork" | "means" | "/r/has a" |  | "FN" |  |
| fn:create_physical_artwork | /r/HasA | fn:fe:descriptor | "create physical artwork" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:create_physical_artwork | /r/HasA | fn:fe:reference | "create physical artwork" | "reference" | "/r/has a" |  | "FN" |  |
| fn:create_physical_artwork | /r/UsedFor | fn:create_representation | "create physical artwork" | "create representation" | "/r/used for" |  | "FN" |  |
| fn:create_representation | fn:HasLexicalUnit | fn:lu:create_representation:paint | "create representation" | "paint" | "has lexical unit" |  | "FN" |  |
| fn:create_representation | fn:HasLexicalUnit | fn:lu:create_representation:photograph | "create representation" | "photograph" | "has lexical unit" |  | "FN" |  |
| fn:create_representation | fn:HasLexicalUnit | fn:lu:create_representation:draw | "create representation" | "draw" | "has lexical unit" |  | "FN" |  |
| fn:create_representation | fn:HasLexicalUnit | fn:lu:create_representation:carve | "create representation" | "carve" | "has lexical unit" |  | "FN" |  |
| fn:create_representation | fn:HasLexicalUnit | fn:lu:create_representation:sketch | "create representation" | "sketch" | "has lexical unit" |  | "FN" |  |
| fn:create_representation | fn:HasLexicalUnit | fn:lu:create_representation:cast | "create representation" | "cast" | "has lexical unit" |  | "FN" |  |
| fn:create_representation | /r/HasA | fn:fe:representation | "create representation" | "representation" | "/r/has a" |  | "FN" |  |
| fn:create_representation | /r/HasA | fn:fe:creator | "create representation" | "creator" | "/r/has a" |  | "FN" |  |
| fn:create_representation | /r/HasA | fn:fe:time | "create representation" | "time" | "/r/has a" |  | "FN" |  |
| fn:create_representation | /r/HasA | fn:fe:represented | "create representation" | "represented" | "/r/has a" |  | "FN" |  |
| fn:create_representation | /r/HasA | fn:fe:depictive_of_represented | "create representation" | "depictive of represented" | "/r/has a" |  | "FN" |  |
| fn:create_representation | /r/HasA | fn:fe:manner | "create representation" | "manner" | "/r/has a" |  | "FN" |  |
| fn:create_representation | /r/HasA | fn:fe:role | "create representation" | "role" | "/r/has a" |  | "FN" |  |
| fn:create_representation | /r/HasA | fn:fe:depictive | "create representation" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:create_representation | /r/HasA | fn:fe:material | "create representation" | "material" | "/r/has a" |  | "FN" |  |
| fn:create_representation | /r/HasA | fn:fe:purpose | "create representation" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:create_representation | /r/HasA | fn:fe:place | "create representation" | "place" | "/r/has a" |  | "FN" |  |
| fn:create_representation | /r/HasA | fn:fe:instrument | "create representation" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:create_representation | /r/HasA | fn:fe:means | "create representation" | "means" | "/r/has a" |  | "FN" |  |
| fn:create_representation | /r/HasA | fn:fe:iterations | "create representation" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:create_representation | /r/HasA | fn:fe:reference | "create representation" | "reference" | "/r/has a" |  | "FN" |  |
| fn:intentionally_create | /r/IsA | fn:creating | "intentionally create" | "creating" | "/r/is a" |  | "FN" |  |
| fn:creating | /r/IsA | fn:transitive_action | "creating" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:creating | /r/UsedFor | fn:ingredients | "creating" | "ingredients" | "/r/used for" |  | "FN" |  |
| fn:coming_up_with | /r/SimilarTo | fn:creating | "coming up with" | "creating" | "/r/similar to" |  | "FN" |  |
| fn:intentionally_create | /r/SimilarTo | fn:creating | "intentionally create" | "creating" | "/r/similar to" |  | "FN" |  |
| fn:creating | fn:HasLexicalUnit | fn:lu:creating:create | "creating" | "create" | "has lexical unit" |  | "FN" |  |
| fn:creating | fn:HasLexicalUnit | fn:lu:creating:form | "creating" | "form" | "has lexical unit" |  | "FN" |  |
| fn:creating | fn:HasLexicalUnit | fn:lu:creating:assemble | "creating" | "assemble" | "has lexical unit" |  | "FN" |  |
| fn:creating | fn:HasLexicalUnit | fn:lu:creating:produce | "creating" | "produce" | "has lexical unit" |  | "FN" |  |
| fn:creating | fn:HasLexicalUnit | fn:lu:creating:production | "creating" | "production" | "has lexical unit" |  | "FN" |  |
| fn:creating | fn:HasLexicalUnit | fn:lu:creating:formation | "creating" | "formation" | "has lexical unit" |  | "FN" |  |
| fn:creating | fn:HasLexicalUnit | fn:lu:creating:generate | "creating" | "generate" | "has lexical unit" |  | "FN" |  |
| fn:creating | fn:HasLexicalUnit | fn:lu:creating:yield | "creating" | "yield" | "has lexical unit" |  | "FN" |  |
| fn:creating | fn:HasLexicalUnit | fn:lu:creating:issue | "creating" | "issue" | "has lexical unit" |  | "FN" |  |
| fn:creating | fn:HasLexicalUnit | fn:lu:creating:issuance | "creating" | "issuance" | "has lexical unit" |  | "FN" |  |
| fn:creating | fn:HasLexicalUnit | fn:lu:creating:make | "creating" | "make" | "has lexical unit" |  | "FN" |  |
| fn:creating | /r/HasA | fn:fe:components | "creating" | "components" | "/r/has a" |  | "FN" |  |
| fn:creating | /r/HasA | fn:fe:created_entity | "creating" | "created entity" | "/r/has a" |  | "FN" |  |
| fn:creating | /r/HasA | fn:fe:depictive | "creating" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:creating | /r/HasA | fn:fe:means | "creating" | "means" | "/r/has a" |  | "FN" |  |
| fn:creating | /r/HasA | fn:fe:manner | "creating" | "manner" | "/r/has a" |  | "FN" |  |
| fn:creating | /r/HasA | fn:fe:place | "creating" | "place" | "/r/has a" |  | "FN" |  |
| fn:creating | /r/HasA | fn:fe:time | "creating" | "time" | "/r/has a" |  | "FN" |  |
| fn:fe:cause | /r/RelatedTo | fn:fe:creator | "cause" | "creator" | "/r/related to" |  | "FN" |  |
| fn:creating | /r/HasA | fn:fe:cause | "creating" | "cause" | "/r/has a" |  | "FN" |  |
| fn:creating | /r/HasA | fn:fe:instrument | "creating" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:creating | /r/HasA | fn:fe:co-participant | "creating" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:creating | /r/HasA | fn:fe:creator | "creating" | "creator" | "/r/has a" |  | "FN" |  |
| fn:creating | /r/HasA | fn:fe:purpose | "creating" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:creating | /r/HasA | fn:fe:imposed_purpose | "creating" | "imposed purpose" | "/r/has a" |  | "FN" |  |
| fn:creating | /r/HasA | fn:fe:beneficiary | "creating" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:creating | /r/HasA | fn:fe:role | "creating" | "role" | "/r/has a" |  | "FN" |  |
| fn:creating | /r/HasA | fn:fe:period_of_iterations | "creating" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:creating | /r/HasA | fn:fe:frequency | "creating" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:creating | /r/HasA | fn:fe:circumstances | "creating" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:creating | /r/HasA | fn:fe:recipient | "creating" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:crime_scenario | /r/HasSubevent | fn:committing_crime | "crime scenario" | "committing crime" | "/r/has subevent" |  | "FN" |  |
| fn:crime_scenario | /r/HasSubevent | fn:criminal_investigation | "crime scenario" | "criminal investigation" | "/r/has subevent" |  | "FN" |  |
| fn:crime_scenario | /r/HasSubevent | fn:criminal_process | "crime scenario" | "criminal process" | "/r/has subevent" |  | "FN" |  |
| fn:crime_scenario | /r/HasA | fn:fe:suspect | "crime scenario" | "suspect" | "/r/has a" |  | "FN" |  |
| fn:crime_scenario | /r/HasA | fn:fe:perpetrator | "crime scenario" | "perpetrator" | "/r/has a" |  | "FN" |  |
| fn:crime_scenario | /r/HasA | fn:fe:crime | "crime scenario" | "crime" | "/r/has a" |  | "FN" |  |
| fn:crime_scenario | /r/HasA | fn:fe:charge | "crime scenario" | "charge" | "/r/has a" |  | "FN" |  |
| fn:crime_scenario | /r/HasA | fn:fe:authorities | "crime scenario" | "authorities" | "/r/has a" |  | "FN" |  |
| fn:crime_scenario | /r/HasSubevent | fn:criminal_investigation | "crime scenario" | "criminal investigation" | "/r/has subevent" |  | "FN" |  |
| fn:criminal_investigation | /r/UsedFor | fn:suspicion | "criminal investigation" | "suspicion" | "/r/used for" |  | "FN" |  |
| fn:seeking | /r/UsedFor | fn:criminal_investigation | "seeking" | "criminal investigation" | "/r/used for" |  | "FN" |  |
| fn:criminal_investigation | /r/HasPrerequisite | fn:committing_crime | "criminal investigation" | "committing crime" | "/r/has prerequisite" |  | "FN" |  |
| fn:criminal_process | /r/HasPrerequisite | fn:criminal_investigation | "criminal process" | "criminal investigation" | "/r/has prerequisite" |  | "FN" |  |
| fn:criminal_investigation | fn:HasLexicalUnit | fn:lu:criminal_investigation:inquiry | "criminal investigation" | "inquiry" | "has lexical unit" |  | "FN" |  |
| fn:criminal_investigation | fn:HasLexicalUnit | fn:lu:criminal_investigation:probe | "criminal investigation" | "probe" | "has lexical unit" |  | "FN" |  |
| fn:criminal_investigation | fn:HasLexicalUnit | fn:lu:criminal_investigation:investigate | "criminal investigation" | "investigate" | "has lexical unit" |  | "FN" |  |
| fn:criminal_investigation | fn:HasLexicalUnit | fn:lu:criminal_investigation:inquire | "criminal investigation" | "inquire" | "has lexical unit" |  | "FN" |  |
| fn:criminal_investigation | fn:HasLexicalUnit | fn:lu:criminal_investigation:probe | "criminal investigation" | "probe" | "has lexical unit" |  | "FN" |  |
| fn:criminal_investigation | fn:HasLexicalUnit | fn:lu:criminal_investigation:investigation | "criminal investigation" | "investigation" | "has lexical unit" |  | "FN" |  |
| fn:criminal_investigation | fn:HasLexicalUnit | fn:lu:criminal_investigation:lead | "criminal investigation" | "lead" | "has lexical unit" |  | "FN" |  |
| fn:criminal_investigation | fn:HasLexicalUnit | fn:lu:criminal_investigation:clue | "criminal investigation" | "clue" | "has lexical unit" |  | "FN" |  |
| fn:criminal_investigation | fn:HasLexicalUnit | fn:lu:criminal_investigation:case | "criminal investigation" | "case" | "has lexical unit" |  | "FN" |  |
| fn:fe:investigator | /r/IsA | fn:st:sentient | "investigator" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:criminal_investigation | /r/HasA | fn:fe:investigator | "criminal investigation" | "investigator" | "/r/has a" |  | "FN" |  |
| fn:criminal_investigation | /r/HasA | fn:fe:incident | "criminal investigation" | "incident" | "/r/has a" |  | "FN" |  |
| fn:criminal_investigation | /r/HasA | fn:fe:time | "criminal investigation" | "time" | "/r/has a" |  | "FN" |  |
| fn:criminal_investigation | /r/HasA | fn:fe:duration | "criminal investigation" | "duration" | "/r/has a" |  | "FN" |  |
| fn:fe:suspect | /r/IsA | fn:st:goal | "suspect" | "goal" | "/r/is a" |  | "FN" |  |
| fn:fe:suspect | /r/HasPrerequisite | fn:fe:incident | "suspect" | "incident" | "/r/has prerequisite" |  | "FN" |  |
| fn:criminal_investigation | /r/HasA | fn:fe:suspect | "criminal investigation" | "suspect" | "/r/has a" |  | "FN" |  |
| fn:crime_scenario | /r/HasSubevent | fn:criminal_process | "crime scenario" | "criminal process" | "/r/has subevent" |  | "FN" |  |
| fn:criminal_process | /r/HasSubevent | fn:arraignment | "criminal process" | "arraignment" | "/r/has subevent" |  | "FN" |  |
| fn:criminal_process | /r/HasSubevent | fn:arrest | "criminal process" | "arrest" | "/r/has subevent" |  | "FN" |  |
| fn:criminal_process | /r/HasSubevent | fn:sentencing | "criminal process" | "sentencing" | "/r/has subevent" |  | "FN" |  |
| fn:criminal_process | /r/HasSubevent | fn:trial | "criminal process" | "trial" | "/r/has subevent" |  | "FN" |  |
| fn:criminal_process | /r/UsedFor | fn:appeal | "criminal process" | "appeal" | "/r/used for" |  | "FN" |  |
| fn:criminal_process | /r/HasPrerequisite | fn:criminal_investigation | "criminal process" | "criminal investigation" | "/r/has prerequisite" |  | "FN" |  |
| fn:criminal_process | /r/HasA | fn:fe:court | "criminal process" | "court" | "/r/has a" |  | "FN" |  |
| fn:criminal_process | /r/HasA | fn:fe:place | "criminal process" | "place" | "/r/has a" |  | "FN" |  |
| fn:criminal_process | /r/HasA | fn:fe:time | "criminal process" | "time" | "/r/has a" |  | "FN" |  |
| fn:criminal_process | /r/HasA | fn:fe:defendant | "criminal process" | "defendant" | "/r/has a" |  | "FN" |  |
| fn:criminal_process | /r/HasA | fn:fe:judge | "criminal process" | "judge" | "/r/has a" |  | "FN" |  |
| fn:criminal_process | /r/HasA | fn:fe:prosecution | "criminal process" | "prosecution" | "/r/has a" |  | "FN" |  |
| fn:criminal_process | /r/HasA | fn:fe:charges | "criminal process" | "charges" | "/r/has a" |  | "FN" |  |
| fn:criminal_process | /r/HasA | fn:fe:defense | "criminal process" | "defense" | "/r/has a" |  | "FN" |  |
| fn:criminal_process | /r/HasA | fn:fe:jury | "criminal process" | "jury" | "/r/has a" |  | "FN" |  |
| fn:criminal_process | /r/HasA | fn:fe:offense | "criminal process" | "offense" | "/r/has a" |  | "FN" |  |
| fn:criminal_process | /r/HasA | fn:fe:authorities | "criminal process" | "authorities" | "/r/has a" |  | "FN" |  |
| fn:criminal_process | /r/HasA | fn:fe:suspect | "criminal process" | "suspect" | "/r/has a" |  | "FN" |  |
| fn:criminal_process | /r/HasA | fn:fe:witness | "criminal process" | "witness" | "/r/has a" |  | "FN" |  |
| fn:criminal_process | /r/HasA | fn:fe:victim | "criminal process" | "victim" | "/r/has a" |  | "FN" |  |
| fn:cure | /r/IsA | fn:transitive_action | "cure" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cure | /r/UsedFor | fn:institutionalization | "cure" | "institutionalization" | "/r/used for" |  | "FN" |  |
| fn:cure | /r/UsedFor | fn:medical_interaction_scenario | "cure" | "medical interaction scenario" | "/r/used for" |  | "FN" |  |
| fn:medical_conditions | /r/UsedFor | fn:cure | "medical conditions" | "cure" | "/r/used for" |  | "FN" |  |
| fn:medical_intervention | /r/RelatedTo | fn:cure | "medical intervention" | "cure" | "/r/related to" |  | "FN" |  |
| fn:cure | /r/Causes | fn:recovery | "cure" | "recovery" | "/r/causes" |  | "FN" |  |
| fn:cure | fn:HasLexicalUnit | fn:lu:cure:alleviate | "cure" | "alleviate" | "has lexical unit" |  | "FN" |  |
| fn:cure | fn:HasLexicalUnit | fn:lu:cure:cure | "cure" | "cure" | "has lexical unit" |  | "FN" |  |
| fn:cure | fn:HasLexicalUnit | fn:lu:cure:cure | "cure" | "cure" | "has lexical unit" |  | "FN" |  |
| fn:cure | fn:HasLexicalUnit | fn:lu:cure:heal | "cure" | "heal" | "has lexical unit" |  | "FN" |  |
| fn:cure | fn:HasLexicalUnit | fn:lu:cure:rehabilitate | "cure" | "rehabilitate" | "has lexical unit" |  | "FN" |  |
| fn:cure | fn:HasLexicalUnit | fn:lu:cure:rehabilitation | "cure" | "rehabilitation" | "has lexical unit" |  | "FN" |  |
| fn:cure | fn:HasLexicalUnit | fn:lu:cure:treat | "cure" | "treat" | "has lexical unit" |  | "FN" |  |
| fn:cure | fn:HasLexicalUnit | fn:lu:cure:treatment | "cure" | "treatment" | "has lexical unit" |  | "FN" |  |
| fn:cure | fn:HasLexicalUnit | fn:lu:cure:curable | "cure" | "curable" | "has lexical unit" |  | "FN" |  |
| fn:cure | fn:HasLexicalUnit | fn:lu:cure:incurable | "cure" | "incurable" | "has lexical unit" |  | "FN" |  |
| fn:cure | fn:HasLexicalUnit | fn:lu:cure:healer | "cure" | "healer" | "has lexical unit" |  | "FN" |  |
| fn:cure | fn:HasLexicalUnit | fn:lu:cure:curative | "cure" | "curative" | "has lexical unit" |  | "FN" |  |
| fn:cure | fn:HasLexicalUnit | fn:lu:cure:curative | "cure" | "curative" | "has lexical unit" |  | "FN" |  |
| fn:cure | fn:HasLexicalUnit | fn:lu:cure:alleviation | "cure" | "alleviation" | "has lexical unit" |  | "FN" |  |
| fn:cure | fn:HasLexicalUnit | fn:lu:cure:remedy | "cure" | "remedy" | "has lexical unit" |  | "FN" |  |
| fn:cure | fn:HasLexicalUnit | fn:lu:cure:rehabilitative | "cure" | "rehabilitative" | "has lexical unit" |  | "FN" |  |
| fn:cure | fn:HasLexicalUnit | fn:lu:cure:ease | "cure" | "ease" | "has lexical unit" |  | "FN" |  |
| fn:cure | fn:HasLexicalUnit | fn:lu:cure:palliate | "cure" | "palliate" | "has lexical unit" |  | "FN" |  |
| fn:cure | fn:HasLexicalUnit | fn:lu:cure:palliation | "cure" | "palliation" | "has lexical unit" |  | "FN" |  |
| fn:cure | fn:HasLexicalUnit | fn:lu:cure:palliative | "cure" | "palliative" | "has lexical unit" |  | "FN" |  |
| fn:cure | fn:HasLexicalUnit | fn:lu:cure:palliative | "cure" | "palliative" | "has lexical unit" |  | "FN" |  |
| fn:cure | fn:HasLexicalUnit | fn:lu:cure:therapy | "cure" | "therapy" | "has lexical unit" |  | "FN" |  |
| fn:cure | fn:HasLexicalUnit | fn:lu:cure:therapeutic | "cure" | "therapeutic" | "has lexical unit" |  | "FN" |  |
| fn:cure | fn:HasLexicalUnit | fn:lu:cure:therapist | "cure" | "therapist" | "has lexical unit" |  | "FN" |  |
| fn:cure | fn:HasLexicalUnit | fn:lu:cure:resuscitate | "cure" | "resuscitate" | "has lexical unit" |  | "FN" |  |
| fn:cure | fn:HasLexicalUnit | fn:lu:cure:remedy | "cure" | "remedy" | "has lexical unit" |  | "FN" |  |
| fn:cure | fn:HasLexicalUnit | fn:lu:cure:nurse | "cure" | "nurse" | "has lexical unit" |  | "FN" |  |
| fn:fe:healer | /r/IsA | fn:st:sentient | "healer" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:cure | /r/HasA | fn:fe:healer | "cure" | "healer" | "/r/has a" |  | "FN" |  |
| fn:cure | /r/HasA | fn:fe:patient | "cure" | "patient" | "/r/has a" |  | "FN" |  |
| fn:cure | /r/HasA | fn:fe:affliction | "cure" | "affliction" | "/r/has a" |  | "FN" |  |
| fn:cure | /r/HasA | fn:fe:treatment | "cure" | "treatment" | "/r/has a" |  | "FN" |  |
| fn:cure | /r/HasA | fn:fe:degree | "cure" | "degree" | "/r/has a" |  | "FN" |  |
| fn:cure | /r/HasA | fn:fe:manner | "cure" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fe:medication | /r/IsA | fn:st:physical_entity | "medication" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:cure | /r/HasA | fn:fe:medication | "cure" | "medication" | "/r/has a" |  | "FN" |  |
| fn:cure | /r/HasA | fn:fe:reciprocation | "cure" | "reciprocation" | "/r/has a" |  | "FN" |  |
| fn:cure | /r/HasA | fn:fe:place | "cure" | "place" | "/r/has a" |  | "FN" |  |
| fn:cure | /r/HasA | fn:fe:purpose | "cure" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cure | /r/HasA | fn:fe:time | "cure" | "time" | "/r/has a" |  | "FN" |  |
| fn:cure | /r/HasA | fn:fe:body_part | "cure" | "body part" | "/r/has a" |  | "FN" |  |
| fn:cure | /r/HasA | fn:fe:duration | "cure" | "duration" | "/r/has a" |  | "FN" |  |
| fn:custom | /r/UsedFor | fn:craft | "custom" | "craft" | "/r/used for" |  | "FN" |  |
| fn:custom | /r/UsedFor | fn:expected_location_of_person | "custom" | "expected location of person" | "/r/used for" |  | "FN" |  |
| fn:custom | /r/UsedFor | fn:manner_of_life | "custom" | "manner of life" | "/r/used for" |  | "FN" |  |
| fn:frequency | /r/UsedFor | fn:custom | "frequency" | "custom" | "/r/used for" |  | "FN" |  |
| fn:custom | fn:HasLexicalUnit | fn:lu:custom:custom | "custom" | "custom" | "has lexical unit" |  | "FN" |  |
| fn:custom | fn:HasLexicalUnit | fn:lu:custom:practice | "custom" | "practice" | "has lexical unit" |  | "FN" |  |
| fn:custom | fn:HasLexicalUnit | fn:lu:custom:ritual | "custom" | "ritual" | "has lexical unit" |  | "FN" |  |
| fn:custom | fn:HasLexicalUnit | fn:lu:custom:tradition | "custom" | "tradition" | "has lexical unit" |  | "FN" |  |
| fn:custom | fn:HasLexicalUnit | fn:lu:custom:habit | "custom" | "habit" | "has lexical unit" |  | "FN" |  |
| fn:custom | fn:HasLexicalUnit | fn:lu:custom:convention | "custom" | "convention" | "has lexical unit" |  | "FN" |  |
| fn:custom | fn:HasLexicalUnit | fn:lu:custom:traditional | "custom" | "traditional" | "has lexical unit" |  | "FN" |  |
| fn:custom | fn:HasLexicalUnit | fn:lu:custom:ritualistic | "custom" | "ritualistic" | "has lexical unit" |  | "FN" |  |
| fn:custom | fn:HasLexicalUnit | fn:lu:custom:habitual | "custom" | "habitual" | "has lexical unit" |  | "FN" |  |
| fn:custom | fn:HasLexicalUnit | fn:lu:custom:customary | "custom" | "customary" | "has lexical unit" |  | "FN" |  |
| fn:custom | fn:HasLexicalUnit | fn:lu:custom:traditionally | "custom" | "traditionally" | "has lexical unit" |  | "FN" |  |
| fn:custom | fn:HasLexicalUnit | fn:lu:custom:ways | "custom" | "ways" | "has lexical unit" |  | "FN" |  |
| fn:custom | /r/HasA | fn:fe:behavior | "custom" | "behavior" | "/r/has a" |  | "FN" |  |
| fn:fe:protagonist | /r/RelatedTo | fn:fe:society | "protagonist" | "society" | "/r/related to" |  | "FN" |  |
| fn:custom | /r/HasA | fn:fe:protagonist | "custom" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:custom | /r/HasA | fn:fe:domain | "custom" | "domain" | "/r/has a" |  | "FN" |  |
| fn:custom | /r/HasA | fn:fe:descriptor | "custom" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:custom | /r/HasA | fn:fe:place | "custom" | "place" | "/r/has a" |  | "FN" |  |
| fn:custom | /r/HasA | fn:fe:society | "custom" | "society" | "/r/has a" |  | "FN" |  |
| fn:cutting | /r/IsA | fn:intentionally_affect | "cutting" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:cutting | fn:HasLexicalUnit | fn:lu:cutting:slice | "cutting" | "slice" | "has lexical unit" |  | "FN" |  |
| fn:cutting | fn:HasLexicalUnit | fn:lu:cutting:dice | "cutting" | "dice" | "has lexical unit" |  | "FN" |  |
| fn:cutting | fn:HasLexicalUnit | fn:lu:cutting:mince | "cutting" | "mince" | "has lexical unit" |  | "FN" |  |
| fn:cutting | fn:HasLexicalUnit | fn:lu:cutting:cube | "cutting" | "cube" | "has lexical unit" |  | "FN" |  |
| fn:cutting | fn:HasLexicalUnit | fn:lu:cutting:chop | "cutting" | "chop" | "has lexical unit" |  | "FN" |  |
| fn:cutting | fn:HasLexicalUnit | fn:lu:cutting:fillet | "cutting" | "fillet" | "has lexical unit" |  | "FN" |  |
| fn:cutting | fn:HasLexicalUnit | fn:lu:cutting:pare | "cutting" | "pare" | "has lexical unit" |  | "FN" |  |
| fn:cutting | fn:HasLexicalUnit | fn:lu:cutting:cut | "cutting" | "cut" | "has lexical unit" |  | "FN" |  |
| fn:cutting | fn:HasLexicalUnit | fn:lu:cutting:carve | "cutting" | "carve" | "has lexical unit" |  | "FN" |  |
| fn:cutting | /r/HasA | fn:fe:agent | "cutting" | "agent" | "/r/has a" |  | "FN" |  |
| fn:cutting | /r/HasA | fn:fe:instrument | "cutting" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:cutting | /r/HasA | fn:fe:place | "cutting" | "place" | "/r/has a" |  | "FN" |  |
| fn:cutting | /r/HasA | fn:fe:purpose | "cutting" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:cutting | /r/HasA | fn:fe:time | "cutting" | "time" | "/r/has a" |  | "FN" |  |
| fn:cutting | /r/HasA | fn:fe:means | "cutting" | "means" | "/r/has a" |  | "FN" |  |
| fn:cutting | /r/HasA | fn:fe:item | "cutting" | "item" | "/r/has a" |  | "FN" |  |
| fn:cutting | /r/HasA | fn:fe:result | "cutting" | "result" | "/r/has a" |  | "FN" |  |
| fn:cutting | /r/HasA | fn:fe:manner | "cutting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:cutting | /r/HasA | fn:fe:pieces | "cutting" | "pieces" | "/r/has a" |  | "FN" |  |
| fn:cycle_of_life_and_death | /r/IsA | fn:cycle_of_existence_scenario | "cycle of life and death" | "cycle of existence scenario" | "/r/is a" |  | "FN" |  |
| fn:cycle_of_existence_scenario | /r/HasSubevent | fn:ceasing_to_be | "cycle of existence scenario" | "ceasing to be" | "/r/has subevent" |  | "FN" |  |
| fn:cycle_of_existence_scenario | /r/HasSubevent | fn:coming_to_be | "cycle of existence scenario" | "coming to be" | "/r/has subevent" |  | "FN" |  |
| fn:cycle_of_existence_scenario | /r/HasSubevent | fn:existence | "cycle of existence scenario" | "existence" | "/r/has subevent" |  | "FN" |  |
| fn:cycle_of_existence_scenario | /r/HasSubevent | fn:out_of_existence | "cycle of existence scenario" | "out of existence" | "/r/has subevent" |  | "FN" |  |
| fn:entity | /r/UsedFor | fn:cycle_of_existence_scenario | "entity" | "cycle of existence scenario" | "/r/used for" |  | "FN" |  |
| fn:cycle_of_existence_scenario | /r/HasA | fn:fe:entity | "cycle of existence scenario" | "entity" | "/r/has a" |  | "FN" |  |
| fn:cycle_of_life_and_death | /r/IsA | fn:cycle_of_existence_scenario | "cycle of life and death" | "cycle of existence scenario" | "/r/is a" |  | "FN" |  |
| fn:cycle_of_life_and_death | /r/HasSubevent | fn:being_born | "cycle of life and death" | "being born" | "/r/has subevent" |  | "FN" |  |
| fn:cycle_of_life_and_death | /r/HasSubevent | fn:dead_or_alive | "cycle of life and death" | "dead or alive" | "/r/has subevent" |  | "FN" |  |
| fn:cycle_of_life_and_death | /r/HasSubevent | fn:death | "cycle of life and death" | "death" | "/r/has subevent" |  | "FN" |  |
| fn:cycle_of_life_and_death | /r/HasA | fn:fe:protagonist | "cycle of life and death" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:reshaping | /r/IsA | fn:damaging | "reshaping" | "damaging" | "/r/is a" |  | "FN" |  |
| fn:damaging | /r/IsA | fn:transitive_action | "damaging" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:damaging | fn:HasLexicalUnit | fn:lu:damaging:damage | "damaging" | "damage" | "has lexical unit" |  | "FN" |  |
| fn:damaging | fn:HasLexicalUnit | fn:lu:damaging:mar | "damaging" | "mar" | "has lexical unit" |  | "FN" |  |
| fn:damaging | fn:HasLexicalUnit | fn:lu:damaging:deface | "damaging" | "deface" | "has lexical unit" |  | "FN" |  |
| fn:damaging | fn:HasLexicalUnit | fn:lu:damaging:nick | "damaging" | "nick" | "has lexical unit" |  | "FN" |  |
| fn:damaging | fn:HasLexicalUnit | fn:lu:damaging:dent | "damaging" | "dent" | "has lexical unit" |  | "FN" |  |
| fn:damaging | fn:HasLexicalUnit | fn:lu:damaging:vandalise | "damaging" | "vandalise" | "has lexical unit" |  | "FN" |  |
| fn:damaging | fn:HasLexicalUnit | fn:lu:damaging:scratch | "damaging" | "scratch" | "has lexical unit" |  | "FN" |  |
| fn:damaging | fn:HasLexicalUnit | fn:lu:damaging:chip | "damaging" | "chip" | "has lexical unit" |  | "FN" |  |
| fn:damaging | fn:HasLexicalUnit | fn:lu:damaging:score | "damaging" | "score" | "has lexical unit" |  | "FN" |  |
| fn:damaging | fn:HasLexicalUnit | fn:lu:damaging:sabotage | "damaging" | "sabotage" | "has lexical unit" |  | "FN" |  |
| fn:damaging | fn:HasLexicalUnit | fn:lu:damaging:key | "damaging" | "key" | "has lexical unit" |  | "FN" |  |
| fn:damaging | fn:HasLexicalUnit | fn:lu:damaging:vandalism | "damaging" | "vandalism" | "has lexical unit" |  | "FN" |  |
| fn:damaging | fn:HasLexicalUnit | fn:lu:damaging:rend | "damaging" | "rend" | "has lexical unit" |  | "FN" |  |
| fn:damaging | fn:HasLexicalUnit | fn:lu:damaging:tear | "damaging" | "tear" | "has lexical unit" |  | "FN" |  |
| fn:damaging | fn:HasLexicalUnit | fn:lu:damaging:rip | "damaging" | "rip" | "has lexical unit" |  | "FN" |  |
| fn:damaging | fn:HasLexicalUnit | fn:lu:damaging:damage | "damaging" | "damage" | "has lexical unit" |  | "FN" |  |
| fn:damaging | fn:HasLexicalUnit | fn:lu:damaging:scrape | "damaging" | "scrape" | "has lexical unit" |  | "FN" |  |
| fn:damaging | /r/HasA | fn:fe:agent | "damaging" | "agent" | "/r/has a" |  | "FN" |  |
| fn:damaging | /r/HasA | fn:fe:degree | "damaging" | "degree" | "/r/has a" |  | "FN" |  |
| fn:damaging | /r/HasA | fn:fe:instrument | "damaging" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:damaging | /r/HasA | fn:fe:manner | "damaging" | "manner" | "/r/has a" |  | "FN" |  |
| fn:damaging | /r/HasA | fn:fe:means | "damaging" | "means" | "/r/has a" |  | "FN" |  |
| fn:damaging | /r/HasA | fn:fe:place | "damaging" | "place" | "/r/has a" |  | "FN" |  |
| fn:damaging | /r/HasA | fn:fe:purpose | "damaging" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:damaging | /r/HasA | fn:fe:explanation | "damaging" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:damaging | /r/HasA | fn:fe:subregion | "damaging" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:damaging | /r/HasA | fn:fe:time | "damaging" | "time" | "/r/has a" |  | "FN" |  |
| fn:damaging | /r/HasA | fn:fe:patient | "damaging" | "patient" | "/r/has a" |  | "FN" |  |
| fn:damaging | /r/HasA | fn:fe:character_of_end_state | "damaging" | "character of end state" | "/r/has a" |  | "FN" |  |
| fn:damaging | /r/HasA | fn:fe:result | "damaging" | "result" | "/r/has a" |  | "FN" |  |
| fn:damaging | /r/HasA | fn:fe:cause | "damaging" | "cause" | "/r/has a" |  | "FN" |  |
| fn:daring | /r/IsA | fn:intentionally_act | "daring" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:daring | fn:HasLexicalUnit | fn:lu:daring:chance | "daring" | "chance" | "has lexical unit" |  | "FN" |  |
| fn:daring | fn:HasLexicalUnit | fn:lu:daring:hazard | "daring" | "hazard" | "has lexical unit" |  | "FN" |  |
| fn:daring | fn:HasLexicalUnit | fn:lu:daring:dare | "daring" | "dare" | "has lexical unit" |  | "FN" |  |
| fn:daring | fn:HasLexicalUnit | fn:lu:daring:venture | "daring" | "venture" | "has lexical unit" |  | "FN" |  |
| fn:daring | fn:HasLexicalUnit | fn:lu:daring:risk | "daring" | "risk" | "has lexical unit" |  | "FN" |  |
| fn:daring | fn:HasLexicalUnit | fn:lu:daring:risk | "daring" | "risk" | "has lexical unit" |  | "FN" |  |
| fn:daring | fn:HasLexicalUnit | fn:lu:daring:chance | "daring" | "chance" | "has lexical unit" |  | "FN" |  |
| fn:daring | fn:HasLexicalUnit | fn:lu:daring:audacious | "daring" | "audacious" | "has lexical unit" |  | "FN" |  |
| fn:daring | fn:HasLexicalUnit | fn:lu:daring:audacity | "daring" | "audacity" | "has lexical unit" |  | "FN" |  |
| fn:daring | fn:HasLexicalUnit | fn:lu:daring:audaciousness | "daring" | "audaciousness" | "has lexical unit" |  | "FN" |  |
| fn:daring | /r/HasA | fn:fe:agent | "daring" | "agent" | "/r/has a" |  | "FN" |  |
| fn:daring | /r/HasA | fn:fe:action | "daring" | "action" | "/r/has a" |  | "FN" |  |
| fn:daring | /r/HasA | fn:fe:purpose | "daring" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:daring | /r/HasA | fn:fe:explanation | "daring" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:daring | /r/HasA | fn:fe:time | "daring" | "time" | "/r/has a" |  | "FN" |  |
| fn:daring | /r/HasA | fn:fe:place | "daring" | "place" | "/r/has a" |  | "FN" |  |
| fn:daring | /r/HasA | fn:fe:manner | "daring" | "manner" | "/r/has a" |  | "FN" |  |
| fn:subsisting | /r/IsA | fn:dead_or_alive | "subsisting" | "dead or alive" | "/r/is a" |  | "FN" |  |
| fn:dead_or_alive | /r/IsA | fn:state | "dead or alive" | "state" | "/r/is a" |  | "FN" |  |
| fn:cycle_of_life_and_death | /r/HasSubevent | fn:dead_or_alive | "cycle of life and death" | "dead or alive" | "/r/has subevent" |  | "FN" |  |
| fn:biological_entity | /r/UsedFor | fn:dead_or_alive | "biological entity" | "dead or alive" | "/r/used for" |  | "FN" |  |
| fn:dead_or_alive | /r/UsedFor | fn:resurrection | "dead or alive" | "resurrection" | "/r/used for" |  | "FN" |  |
| fn:death | /r/Causes | fn:dead_or_alive | "death" | "dead or alive" | "/r/causes" |  | "FN" |  |
| fn:dead_or_alive | fn:HasLexicalUnit | fn:lu:dead_or_alive:deceased | "dead or alive" | "deceased" | "has lexical unit" |  | "FN" |  |
| fn:dead_or_alive | fn:HasLexicalUnit | fn:lu:dead_or_alive:lifeless | "dead or alive" | "lifeless" | "has lexical unit" |  | "FN" |  |
| fn:dead_or_alive | fn:HasLexicalUnit | fn:lu:dead_or_alive:dead | "dead or alive" | "dead" | "has lexical unit" |  | "FN" |  |
| fn:dead_or_alive | fn:HasLexicalUnit | fn:lu:dead_or_alive:alive | "dead or alive" | "alive" | "has lexical unit" |  | "FN" |  |
| fn:dead_or_alive | fn:HasLexicalUnit | fn:lu:dead_or_alive:undead | "dead or alive" | "undead" | "has lexical unit" |  | "FN" |  |
| fn:dead_or_alive | fn:HasLexicalUnit | fn:lu:dead_or_alive:undead | "dead or alive" | "undead" | "has lexical unit" |  | "FN" |  |
| fn:dead_or_alive | fn:HasLexicalUnit | fn:lu:dead_or_alive:living | "dead or alive" | "living" | "has lexical unit" |  | "FN" |  |
| fn:dead_or_alive | fn:HasLexicalUnit | fn:lu:dead_or_alive:dead | "dead or alive" | "dead" | "has lexical unit" |  | "FN" |  |
| fn:dead_or_alive | fn:HasLexicalUnit | fn:lu:dead_or_alive:living | "dead or alive" | "living" | "has lexical unit" |  | "FN" |  |
| fn:dead_or_alive | fn:HasLexicalUnit | fn:lu:dead_or_alive:nonliving | "dead or alive" | "nonliving" | "has lexical unit" |  | "FN" |  |
| fn:dead_or_alive | fn:HasLexicalUnit | fn:lu:dead_or_alive:live | "dead or alive" | "live" | "has lexical unit" |  | "FN" |  |
| fn:dead_or_alive | fn:HasLexicalUnit | fn:lu:dead_or_alive:life | "dead or alive" | "life" | "has lexical unit" |  | "FN" |  |
| fn:dead_or_alive | fn:HasLexicalUnit | fn:lu:dead_or_alive:late | "dead or alive" | "late" | "has lexical unit" |  | "FN" |  |
| fn:dead_or_alive | fn:HasLexicalUnit | fn:lu:dead_or_alive:dirt_nap | "dead or alive" | "dirt nap" | "has lexical unit" |  | "FN" |  |
| fn:dead_or_alive | /r/HasA | fn:fe:explanation | "dead or alive" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:dead_or_alive | /r/HasA | fn:fe:degree | "dead or alive" | "degree" | "/r/has a" |  | "FN" |  |
| fn:dead_or_alive | /r/HasA | fn:fe:protagonist | "dead or alive" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:dead_or_alive | /r/HasA | fn:fe:figure | "dead or alive" | "figure" | "/r/has a" |  | "FN" |  |
| fn:dead_or_alive | /r/HasA | fn:fe:time | "dead or alive" | "time" | "/r/has a" |  | "FN" |  |
| fn:death | /r/IsA | fn:ceasing_to_be | "death" | "ceasing to be" | "/r/is a" |  | "FN" |  |
| fn:cycle_of_life_and_death | /r/HasSubevent | fn:death | "cycle of life and death" | "death" | "/r/has subevent" |  | "FN" |  |
| fn:death | /r/SimilarTo | fn:cause_harm | "death" | "cause harm" | "/r/similar to" |  | "FN" |  |
| fn:death | /r/SimilarTo | fn:offenses | "death" | "offenses" | "/r/similar to" |  | "FN" |  |
| fn:killing | /r/SimilarTo | fn:death | "killing" | "death" | "/r/similar to" |  | "FN" |  |
| fn:death | /r/Causes | fn:dead_or_alive | "death" | "dead or alive" | "/r/causes" |  | "FN" |  |
| fn:killing | /r/Causes | fn:death | "killing" | "death" | "/r/causes" |  | "FN" |  |
| fn:death | /r/HasPrerequisite | fn:being_born | "death" | "being born" | "/r/has prerequisite" |  | "FN" |  |
| fn:death | /r/HasPrerequisite | fn:dying | "death" | "dying" | "/r/has prerequisite" |  | "FN" |  |
| fn:death | /r/HasPrerequisite | fn:giving_birth | "death" | "giving birth" | "/r/has prerequisite" |  | "FN" |  |
| fn:death | fn:HasLexicalUnit | fn:lu:death:death | "death" | "death" | "has lexical unit" |  | "FN" |  |
| fn:death | fn:HasLexicalUnit | fn:lu:death:demise | "death" | "demise" | "has lexical unit" |  | "FN" |  |
| fn:death | fn:HasLexicalUnit | fn:lu:death:die | "death" | "die" | "has lexical unit" |  | "FN" |  |
| fn:death | fn:HasLexicalUnit | fn:lu:death:perish | "death" | "perish" | "has lexical unit" |  | "FN" |  |
| fn:death | fn:HasLexicalUnit | fn:lu:death:terminator | "death" | "terminator" | "has lexical unit" |  | "FN" |  |
| fn:death | fn:HasLexicalUnit | fn:lu:death:croak | "death" | "croak" | "has lexical unit" |  | "FN" |  |
| fn:death | fn:HasLexicalUnit | fn:lu:death:decease | "death" | "decease" | "has lexical unit" |  | "FN" |  |
| fn:death | fn:HasLexicalUnit | fn:lu:death:starve | "death" | "starve" | "has lexical unit" |  | "FN" |  |
| fn:death | fn:HasLexicalUnit | fn:lu:death:starvation | "death" | "starvation" | "has lexical unit" |  | "FN" |  |
| fn:death | fn:HasLexicalUnit | fn:lu:death:expire | "death" | "expire" | "has lexical unit" |  | "FN" |  |
| fn:death | fn:HasLexicalUnit | fn:lu:death:pass_away | "death" | "pass away" | "has lexical unit" |  | "FN" |  |
| fn:death | fn:HasLexicalUnit | fn:lu:death:kick_the_bucket | "death" | "kick the bucket" | "has lexical unit" |  | "FN" |  |
| fn:death | fn:HasLexicalUnit | fn:lu:death:drown | "death" | "drown" | "has lexical unit" |  | "FN" |  |
| fn:death | fn:HasLexicalUnit | fn:lu:death:croak_it | "death" | "croak it" | "has lexical unit" |  | "FN" |  |
| fn:death | fn:HasLexicalUnit | fn:lu:death:asphyxiate | "death" | "asphyxiate" | "has lexical unit" |  | "FN" |  |
| fn:death | fn:HasLexicalUnit | fn:lu:death:suffocate | "death" | "suffocate" | "has lexical unit" |  | "FN" |  |
| fn:death | fn:HasLexicalUnit | fn:lu:death:suffocation | "death" | "suffocation" | "has lexical unit" |  | "FN" |  |
| fn:death | fn:HasLexicalUnit | fn:lu:death:mortality | "death" | "mortality" | "has lexical unit" |  | "FN" |  |
| fn:death | fn:HasLexicalUnit | fn:lu:death:end | "death" | "end" | "has lexical unit" |  | "FN" |  |
| fn:death | fn:HasLexicalUnit | fn:lu:death:mortal | "death" | "mortal" | "has lexical unit" |  | "FN" |  |
| fn:death | /r/HasA | fn:fe:protagonist | "death" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:death | /r/HasA | fn:fe:explanation | "death" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:death | /r/HasA | fn:fe:degree | "death" | "degree" | "/r/has a" |  | "FN" |  |
| fn:death | /r/HasA | fn:fe:depictive | "death" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:death | /r/HasA | fn:fe:manner | "death" | "manner" | "/r/has a" |  | "FN" |  |
| fn:death | /r/HasA | fn:fe:result | "death" | "result" | "/r/has a" |  | "FN" |  |
| fn:death | /r/HasA | fn:fe:place | "death" | "place" | "/r/has a" |  | "FN" |  |
| fn:death | /r/HasA | fn:fe:time | "death" | "time" | "/r/has a" |  | "FN" |  |
| fn:death | /r/HasA | fn:fe:containing_event | "death" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:death | /r/HasA | fn:fe:maleficiary | "death" | "maleficiary" | "/r/has a" |  | "FN" |  |
| fn:deception_success | /r/IsA | fn:deception_end | "deception success" | "deception end" | "/r/is a" |  | "FN" |  |
| fn:intentional_deception | /r/IsA | fn:deception_end | "intentional deception" | "deception end" | "/r/is a" |  | "FN" |  |
| fn:deception_scenario | /r/HasSubevent | fn:deception_end | "deception scenario" | "deception end" | "/r/has subevent" |  | "FN" |  |
| fn:deception_end | /r/HasA | fn:fe:victim | "deception end" | "victim" | "/r/has a" |  | "FN" |  |
| fn:deception_end | /r/HasA | fn:fe:deceiver | "deception end" | "deceiver" | "/r/has a" |  | "FN" |  |
| fn:deception_end | /r/HasA | fn:fe:phenomenon | "deception end" | "phenomenon" | "/r/has a" |  | "FN" |  |
| fn:deception_end | /r/HasA | fn:fe:topic | "deception end" | "topic" | "/r/has a" |  | "FN" |  |
| fn:deception_end | /r/HasA | fn:fe:time | "deception end" | "time" | "/r/has a" |  | "FN" |  |
| fn:deception_end | /r/HasA | fn:fe:place | "deception end" | "place" | "/r/has a" |  | "FN" |  |
| fn:deception_scenario | /r/HasSubevent | fn:deception_end | "deception scenario" | "deception end" | "/r/has subevent" |  | "FN" |  |
| fn:deception_scenario | /r/HasA | fn:fe:victim | "deception scenario" | "victim" | "/r/has a" |  | "FN" |  |
| fn:deception_scenario | /r/HasA | fn:fe:deceiver | "deception scenario" | "deceiver" | "/r/has a" |  | "FN" |  |
| fn:deception_scenario | /r/HasA | fn:fe:phenomenon | "deception scenario" | "phenomenon" | "/r/has a" |  | "FN" |  |
| fn:deception_scenario | /r/HasA | fn:fe:topic | "deception scenario" | "topic" | "/r/has a" |  | "FN" |  |
| fn:deception_success | /r/IsA | fn:deception_end | "deception success" | "deception end" | "/r/is a" |  | "FN" |  |
| fn:fall_for | /r/IsA | fn:deception_success | "fall for" | "deception success" | "/r/is a" |  | "FN" |  |
| fn:intentional_deception | /r/IsA | fn:deception_success | "intentional deception" | "deception success" | "/r/is a" |  | "FN" |  |
| fn:deception_success | fn:HasLexicalUnit | fn:lu:deception_success:deceit | "deception success" | "deceit" | "has lexical unit" |  | "FN" |  |
| fn:deception_success | fn:HasLexicalUnit | fn:lu:deception_success:deception | "deception success" | "deception" | "has lexical unit" |  | "FN" |  |
| fn:fe:deceiver | /r/IsA | fn:st:sentient | "deceiver" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:deception_success | /r/HasA | fn:fe:deceiver | "deception success" | "deceiver" | "/r/has a" |  | "FN" |  |
| fn:deception_success | /r/HasA | fn:fe:victim | "deception success" | "victim" | "/r/has a" |  | "FN" |  |
| fn:deception_success | /r/HasA | fn:fe:topic | "deception success" | "topic" | "/r/has a" |  | "FN" |  |
| fn:deception_success | /r/HasA | fn:fe:means | "deception success" | "means" | "/r/has a" |  | "FN" |  |
| fn:deception_success | /r/HasA | fn:fe:time | "deception success" | "time" | "/r/has a" |  | "FN" |  |
| fn:deception_success | /r/HasA | fn:fe:place | "deception success" | "place" | "/r/has a" |  | "FN" |  |
| fn:deception_success | /r/HasA | fn:fe:phenomenon | "deception success" | "phenomenon" | "/r/has a" |  | "FN" |  |
| fn:choosing | /r/IsA | fn:deciding | "choosing" | "deciding" | "/r/is a" |  | "FN" |  |
| fn:intentionally_act | /r/UsedFor | fn:deciding | "intentionally act" | "deciding" | "/r/used for" |  | "FN" |  |
| fn:deciding | /r/RelatedTo | fn:choosing | "deciding" | "choosing" | "/r/related to" |  | "FN" |  |
| fn:choosing | /r/SimilarTo | fn:deciding | "choosing" | "deciding" | "/r/similar to" |  | "FN" |  |
| fn:suasion | /r/Causes | fn:deciding | "suasion" | "deciding" | "/r/causes" |  | "FN" |  |
| fn:deciding | fn:HasLexicalUnit | fn:lu:deciding:decide | "deciding" | "decide" | "has lexical unit" |  | "FN" |  |
| fn:deciding | fn:HasLexicalUnit | fn:lu:deciding:decision | "deciding" | "decision" | "has lexical unit" |  | "FN" |  |
| fn:deciding | fn:HasLexicalUnit | fn:lu:deciding:rule_out | "deciding" | "rule out" | "has lexical unit" |  | "FN" |  |
| fn:deciding | fn:HasLexicalUnit | fn:lu:deciding:determine | "deciding" | "determine" | "has lexical unit" |  | "FN" |  |
| fn:deciding | /r/HasA | fn:fe:cognizer | "deciding" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:deciding | /r/HasA | fn:fe:decision | "deciding" | "decision" | "/r/has a" |  | "FN" |  |
| fn:deciding | /r/HasA | fn:fe:possibilities | "deciding" | "possibilities" | "/r/has a" |  | "FN" |  |
| fn:deciding | /r/HasA | fn:fe:time | "deciding" | "time" | "/r/has a" |  | "FN" |  |
| fn:deciding | /r/HasA | fn:fe:place | "deciding" | "place" | "/r/has a" |  | "FN" |  |
| fn:deciding | /r/HasA | fn:fe:manner | "deciding" | "manner" | "/r/has a" |  | "FN" |  |
| fn:deciding | /r/HasA | fn:fe:inherent_purpose | "deciding" | "inherent purpose" | "/r/has a" |  | "FN" |  |
| fn:deciding | /r/HasA | fn:fe:circumstance | "deciding" | "circumstance" | "/r/has a" |  | "FN" |  |
| fn:deciding | /r/HasA | fn:fe:explanation | "deciding" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:attack | /r/UsedFor | fn:defending | "attack" | "defending" | "/r/used for" |  | "FN" |  |
| fn:defending | fn:HasLexicalUnit | fn:lu:defending:defend | "defending" | "defend" | "has lexical unit" |  | "FN" |  |
| fn:defending | fn:HasLexicalUnit | fn:lu:defending:defense | "defending" | "defense" | "has lexical unit" |  | "FN" |  |
| fn:defending | fn:HasLexicalUnit | fn:lu:defending:defensive | "defending" | "defensive" | "has lexical unit" |  | "FN" |  |
| fn:defending | fn:HasLexicalUnit | fn:lu:defending:hold | "defending" | "hold" | "has lexical unit" |  | "FN" |  |
| fn:defending | fn:HasLexicalUnit | fn:lu:defending:defender | "defending" | "defender" | "has lexical unit" |  | "FN" |  |
| fn:defending | fn:HasLexicalUnit | fn:lu:defending:defenses | "defending" | "defenses" | "has lexical unit" |  | "FN" |  |
| fn:defending | fn:HasLexicalUnit | fn:lu:defending:biodefense | "defending" | "biodefense" | "has lexical unit" |  | "FN" |  |
| fn:fe:defender | /r/IsA | fn:st:sentient | "defender" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:defending | /r/HasA | fn:fe:defender | "defending" | "defender" | "/r/has a" |  | "FN" |  |
| fn:defending | /r/HasA | fn:fe:instrument | "defending" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:fe:assailant | /r/IsA | fn:st:source | "assailant" | "source" | "/r/is a" |  | "FN" |  |
| fn:defending | /r/HasA | fn:fe:assailant | "defending" | "assailant" | "/r/has a" |  | "FN" |  |
| fn:defending | /r/HasA | fn:fe:manner | "defending" | "manner" | "/r/has a" |  | "FN" |  |
| fn:defending | /r/HasA | fn:fe:means | "defending" | "means" | "/r/has a" |  | "FN" |  |
| fn:defending | /r/HasA | fn:fe:place | "defending" | "place" | "/r/has a" |  | "FN" |  |
| fn:defending | /r/HasA | fn:fe:purpose | "defending" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:defending | /r/HasA | fn:fe:explanation | "defending" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:defending | /r/HasA | fn:fe:time | "defending" | "time" | "/r/has a" |  | "FN" |  |
| fn:fe:location_of_protagonist | /r/IsA | fn:st:location | "location of protagonist" | "location" | "/r/is a" |  | "FN" |  |
| fn:defending | /r/HasA | fn:fe:location_of_protagonist | "defending" | "location of protagonist" | "/r/has a" |  | "FN" |  |
| fn:defending | /r/HasA | fn:fe:depictive | "defending" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:defending | /r/HasA | fn:fe:victim | "defending" | "victim" | "/r/has a" |  | "FN" |  |
| fn:fe:location_of_assailant | /r/IsA | fn:st:location | "location of assailant" | "location" | "/r/is a" |  | "FN" |  |
| fn:defending | /r/HasA | fn:fe:location_of_assailant | "defending" | "location of assailant" | "/r/has a" |  | "FN" |  |
| fn:importance | /r/UsedFor | fn:degree | "importance" | "degree" | "/r/used for" |  | "FN" |  |
| fn:hedging | /r/RelatedTo | fn:degree | "hedging" | "degree" | "/r/related to" |  | "FN" |  |
| fn:degree | fn:HasLexicalUnit | fn:lu:degree:so | "degree" | "so" | "has lexical unit" |  | "FN" |  |
| fn:degree | fn:HasLexicalUnit | fn:lu:degree:a_little | "degree" | "a little" | "has lexical unit" |  | "FN" |  |
| fn:degree | fn:HasLexicalUnit | fn:lu:degree:a_little_bit | "degree" | "a little bit" | "has lexical unit" |  | "FN" |  |
| fn:degree | fn:HasLexicalUnit | fn:lu:degree:very | "degree" | "very" | "has lexical unit" |  | "FN" |  |
| fn:degree | fn:HasLexicalUnit | fn:lu:degree:that | "degree" | "that" | "has lexical unit" |  | "FN" |  |
| fn:degree | fn:HasLexicalUnit | fn:lu:degree:totally | "degree" | "totally" | "has lexical unit" |  | "FN" |  |
| fn:degree | fn:HasLexicalUnit | fn:lu:degree:fully | "degree" | "fully" | "has lexical unit" |  | "FN" |  |
| fn:degree | fn:HasLexicalUnit | fn:lu:degree:heavily | "degree" | "heavily" | "has lexical unit" |  | "FN" |  |
| fn:degree | fn:HasLexicalUnit | fn:lu:degree:far | "degree" | "far" | "has lexical unit" |  | "FN" |  |
| fn:degree | fn:HasLexicalUnit | fn:lu:degree:somewhat | "degree" | "somewhat" | "has lexical unit" |  | "FN" |  |
| fn:degree | fn:HasLexicalUnit | fn:lu:degree:in_part | "degree" | "in part" | "has lexical unit" |  | "FN" |  |
| fn:degree | fn:HasLexicalUnit | fn:lu:degree:great | "degree" | "great" | "has lexical unit" |  | "FN" |  |
| fn:degree | fn:HasLexicalUnit | fn:lu:degree:way | "degree" | "way" | "has lexical unit" |  | "FN" |  |
| fn:degree | fn:HasLexicalUnit | fn:lu:degree:particular | "degree" | "particular" | "has lexical unit" |  | "FN" |  |
| fn:degree | fn:HasLexicalUnit | fn:lu:degree:a_lot | "degree" | "a lot" | "has lexical unit" |  | "FN" |  |
| fn:degree | fn:HasLexicalUnit | fn:lu:degree:stone_(cold) | "degree" | "stone (cold)" | "has lexical unit" |  | "FN" |  |
| fn:degree | fn:HasLexicalUnit | fn:lu:degree:dirt_(poor) | "degree" | "dirt (poor)" | "has lexical unit" |  | "FN" |  |
| fn:degree | fn:HasLexicalUnit | fn:lu:degree:sopping_(wet) | "degree" | "sopping (wet)" | "has lexical unit" |  | "FN" |  |
| fn:degree | fn:HasLexicalUnit | fn:lu:degree:crystal_(clear) | "degree" | "crystal (clear)" | "has lexical unit" |  | "FN" |  |
| fn:degree | fn:HasLexicalUnit | fn:lu:degree:as_hell | "degree" | "as hell" | "has lexical unit" |  | "FN" |  |
| fn:degree | fn:HasLexicalUnit | fn:lu:degree:kind_of | "degree" | "kind of" | "has lexical unit" |  | "FN" |  |
| fn:degree | /r/HasA | fn:fe:gradable_attribute | "degree" | "gradable attribute" | "/r/has a" |  | "FN" |  |
| fn:processing_materials | /r/UsedFor | fn:degree_of_processing | "processing materials" | "degree of processing" | "/r/used for" |  | "FN" |  |
| fn:degree_of_processing | fn:HasLexicalUnit | fn:lu:degree_of_processing:unprocessed | "degree of processing" | "unprocessed" | "has lexical unit" |  | "FN" |  |
| fn:degree_of_processing | fn:HasLexicalUnit | fn:lu:degree_of_processing:raw | "degree of processing" | "raw" | "has lexical unit" |  | "FN" |  |
| fn:degree_of_processing | fn:HasLexicalUnit | fn:lu:degree_of_processing:enriched | "degree of processing" | "enriched" | "has lexical unit" |  | "FN" |  |
| fn:degree_of_processing | fn:HasLexicalUnit | fn:lu:degree_of_processing:processed | "degree of processing" | "processed" | "has lexical unit" |  | "FN" |  |
| fn:degree_of_processing | /r/HasA | fn:fe:alterant | "degree of processing" | "alterant" | "/r/has a" |  | "FN" |  |
| fn:degree_of_processing | /r/HasA | fn:fe:material | "degree of processing" | "material" | "/r/has a" |  | "FN" |  |
| fn:degree_of_processing | /r/HasA | fn:fe:degree | "degree of processing" | "degree" | "/r/has a" |  | "FN" |  |
| fn:diversity | /r/UsedFor | fn:delimitation_of_diversity | "diversity" | "delimitation of diversity" | "/r/used for" |  | "FN" |  |
| fn:position_on_a_scale | /r/UsedFor | fn:delimitation_of_diversity | "position on a scale" | "delimitation of diversity" | "/r/used for" |  | "FN" |  |
| fn:position_on_a_scale | /r/SimilarTo | fn:delimitation_of_diversity | "position on a scale" | "delimitation of diversity" | "/r/similar to" |  | "FN" |  |
| fn:delimitation_of_diversity | fn:HasLexicalUnit | fn:lu:delimitation_of_diversity:range | "delimitation of diversity" | "range" | "has lexical unit" |  | "FN" |  |
| fn:delimitation_of_diversity | fn:HasLexicalUnit | fn:lu:delimitation_of_diversity:from_to | "delimitation of diversity" | "from to" | "has lexical unit" |  | "FN" |  |
| fn:delimitation_of_diversity | /r/HasA | fn:fe:item | "delimitation of diversity" | "item" | "/r/has a" |  | "FN" |  |
| fn:delimitation_of_diversity | /r/HasA | fn:fe:variable | "delimitation of diversity" | "variable" | "/r/has a" |  | "FN" |  |
| fn:delimitation_of_diversity | /r/HasA | fn:fe:limit1 | "delimitation of diversity" | "limit1" | "/r/has a" |  | "FN" |  |
| fn:delimitation_of_diversity | /r/HasA | fn:fe:limit2 | "delimitation of diversity" | "limit2" | "/r/has a" |  | "FN" |  |
| fn:delimitation_of_diversity | /r/HasA | fn:fe:limits | "delimitation of diversity" | "limits" | "/r/has a" |  | "FN" |  |
| fn:delimitation_of_diversity | /r/HasA | fn:fe:degree | "delimitation of diversity" | "degree" | "/r/has a" |  | "FN" |  |
| fn:duration_scenario | /r/IsA | fn:delimited_state_scenario | "duration scenario" | "delimited state scenario" | "/r/is a" |  | "FN" |  |
| fn:process_continue | /r/IsA | fn:delimited_state_scenario | "process continue" | "delimited state scenario" | "/r/is a" |  | "FN" |  |
| fn:timespan | /r/IsA | fn:delimited_state_scenario | "timespan" | "delimited state scenario" | "/r/is a" |  | "FN" |  |
| fn:delimited_state_scenario | /r/HasA | fn:fe:duration | "delimited state scenario" | "duration" | "/r/has a" |  | "FN" |  |
| fn:delimited_state_scenario | /r/HasA | fn:fe:state | "delimited state scenario" | "state" | "/r/has a" |  | "FN" |  |
| fn:product_delivery | /r/IsA | fn:delivery | "product delivery" | "delivery" | "/r/is a" |  | "FN" |  |
| fn:sending | /r/UsedFor | fn:delivery | "sending" | "delivery" | "/r/used for" |  | "FN" |  |
| fn:delivery | fn:HasLexicalUnit | fn:lu:delivery:deliver | "delivery" | "deliver" | "has lexical unit" |  | "FN" |  |
| fn:delivery | fn:HasLexicalUnit | fn:lu:delivery:delivery | "delivery" | "delivery" | "has lexical unit" |  | "FN" |  |
| fn:delivery | /r/HasA | fn:fe:deliverer | "delivery" | "deliverer" | "/r/has a" |  | "FN" |  |
| fn:delivery | /r/HasA | fn:fe:goal | "delivery" | "goal" | "/r/has a" |  | "FN" |  |
| fn:delivery | /r/HasA | fn:fe:theme | "delivery" | "theme" | "/r/has a" |  | "FN" |  |
| fn:delivery | /r/HasA | fn:fe:vehicle | "delivery" | "vehicle" | "/r/has a" |  | "FN" |  |
| fn:delivery | /r/HasA | fn:fe:depictive | "delivery" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:delivery | /r/HasA | fn:fe:manner | "delivery" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fe:recipient | /r/RelatedTo | fn:fe:goal | "recipient" | "goal" | "/r/related to" |  | "FN" |  |
| fn:delivery | /r/HasA | fn:fe:recipient | "delivery" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:delivery | /r/HasA | fn:fe:purpose | "delivery" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:delivery | /r/HasA | fn:fe:explanation | "delivery" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:delivery | /r/HasA | fn:fe:time | "delivery" | "time" | "/r/has a" |  | "FN" |  |
| fn:delivery | /r/HasA | fn:fe:cotheme | "delivery" | "cotheme" | "/r/has a" |  | "FN" |  |
| fn:delivery | /r/HasA | fn:fe:container | "delivery" | "container" | "/r/has a" |  | "FN" |  |
| fn:delivery | /r/HasA | fn:fe:place | "delivery" | "place" | "/r/has a" |  | "FN" |  |
| fn:delivery | /r/HasA | fn:fe:speed | "delivery" | "speed" | "/r/has a" |  | "FN" |  |
| fn:delivery | /r/HasA | fn:fe:circumstances | "delivery" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:delivery | /r/HasA | fn:fe:source | "delivery" | "source" | "/r/has a" |  | "FN" |  |
| fn:delivery | /r/HasA | fn:fe:means | "delivery" | "means" | "/r/has a" |  | "FN" |  |
| fn:delivery | /r/HasA | fn:fe:path | "delivery" | "path" | "/r/has a" |  | "FN" |  |
| fn:delivery | /r/HasA | fn:fe:beneficiary | "delivery" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:delivery | /r/HasA | fn:fe:event_description | "delivery" | "event description" | "/r/has a" |  | "FN" |  |
| fn:delivery | /r/HasA | fn:fe:period_of_iterations | "delivery" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:deny_or_grant_permission | "communication" | "deny or grant permission" | "/r/used for" |  | "FN" |  |
| fn:deny_or_grant_permission | /r/SimilarTo | fn:preventing_or_letting | "deny or grant permission" | "preventing or letting" | "/r/similar to" |  | "FN" |  |
| fn:preventing_or_letting | /r/SimilarTo | fn:deny_or_grant_permission | "preventing or letting" | "deny or grant permission" | "/r/similar to" |  | "FN" |  |
| fn:deny_or_grant_permission | fn:HasLexicalUnit | fn:lu:deny_or_grant_permission:forbid | "deny or grant permission" | "forbid" | "has lexical unit" |  | "FN" |  |
| fn:deny_or_grant_permission | fn:HasLexicalUnit | fn:lu:deny_or_grant_permission:prohibit | "deny or grant permission" | "prohibit" | "has lexical unit" |  | "FN" |  |
| fn:deny_or_grant_permission | fn:HasLexicalUnit | fn:lu:deny_or_grant_permission:outlaw | "deny or grant permission" | "outlaw" | "has lexical unit" |  | "FN" |  |
| fn:deny_or_grant_permission | fn:HasLexicalUnit | fn:lu:deny_or_grant_permission:disallow | "deny or grant permission" | "disallow" | "has lexical unit" |  | "FN" |  |
| fn:deny_or_grant_permission | fn:HasLexicalUnit | fn:lu:deny_or_grant_permission:approval | "deny or grant permission" | "approval" | "has lexical unit" |  | "FN" |  |
| fn:deny_or_grant_permission | fn:HasLexicalUnit | fn:lu:deny_or_grant_permission:approve | "deny or grant permission" | "approve" | "has lexical unit" |  | "FN" |  |
| fn:deny_or_grant_permission | fn:HasLexicalUnit | fn:lu:deny_or_grant_permission:authorize | "deny or grant permission" | "authorize" | "has lexical unit" |  | "FN" |  |
| fn:deny_or_grant_permission | fn:HasLexicalUnit | fn:lu:deny_or_grant_permission:clear | "deny or grant permission" | "clear" | "has lexical unit" |  | "FN" |  |
| fn:deny_or_grant_permission | fn:HasLexicalUnit | fn:lu:deny_or_grant_permission:greenlight | "deny or grant permission" | "greenlight" | "has lexical unit" |  | "FN" |  |
| fn:deny_or_grant_permission | fn:HasLexicalUnit | fn:lu:deny_or_grant_permission:leave | "deny or grant permission" | "leave" | "has lexical unit" |  | "FN" |  |
| fn:deny_or_grant_permission | fn:HasLexicalUnit | fn:lu:deny_or_grant_permission:mandate | "deny or grant permission" | "mandate" | "has lexical unit" |  | "FN" |  |
| fn:deny_or_grant_permission | fn:HasLexicalUnit | fn:lu:deny_or_grant_permission:okay | "deny or grant permission" | "okay" | "has lexical unit" |  | "FN" |  |
| fn:deny_or_grant_permission | fn:HasLexicalUnit | fn:lu:deny_or_grant_permission:permission | "deny or grant permission" | "permission" | "has lexical unit" |  | "FN" |  |
| fn:deny_or_grant_permission | fn:HasLexicalUnit | fn:lu:deny_or_grant_permission:permit | "deny or grant permission" | "permit" | "has lexical unit" |  | "FN" |  |
| fn:deny_or_grant_permission | fn:HasLexicalUnit | fn:lu:deny_or_grant_permission:restrict | "deny or grant permission" | "restrict" | "has lexical unit" |  | "FN" |  |
| fn:deny_or_grant_permission | fn:HasLexicalUnit | fn:lu:deny_or_grant_permission:sanction_[allow] | "deny or grant permission" | "sanction [allow]" | "has lexical unit" |  | "FN" |  |
| fn:deny_or_grant_permission | fn:HasLexicalUnit | fn:lu:deny_or_grant_permission:the_green_light | "deny or grant permission" | "the green light" | "has lexical unit" |  | "FN" |  |
| fn:deny_or_grant_permission | fn:HasLexicalUnit | fn:lu:deny_or_grant_permission:the_go_ahead | "deny or grant permission" | "the go ahead" | "has lexical unit" |  | "FN" |  |
| fn:deny_or_grant_permission | fn:HasLexicalUnit | fn:lu:deny_or_grant_permission:the_go-ahead | "deny or grant permission" | "the go-ahead" | "has lexical unit" |  | "FN" |  |
| fn:deny_or_grant_permission | fn:HasLexicalUnit | fn:lu:deny_or_grant_permission:the_okay | "deny or grant permission" | "the okay" | "has lexical unit" |  | "FN" |  |
| fn:deny_or_grant_permission | fn:HasLexicalUnit | fn:lu:deny_or_grant_permission:suffer | "deny or grant permission" | "suffer" | "has lexical unit" |  | "FN" |  |
| fn:deny_or_grant_permission | fn:HasLexicalUnit | fn:lu:deny_or_grant_permission:prohibition | "deny or grant permission" | "prohibition" | "has lexical unit" |  | "FN" |  |
| fn:deny_or_grant_permission | /r/HasA | fn:fe:authority | "deny or grant permission" | "authority" | "/r/has a" |  | "FN" |  |
| fn:deny_or_grant_permission | /r/HasA | fn:fe:protagonist | "deny or grant permission" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:deny_or_grant_permission | /r/HasA | fn:fe:action | "deny or grant permission" | "action" | "/r/has a" |  | "FN" |  |
| fn:deny_or_grant_permission | /r/HasA | fn:fe:time | "deny or grant permission" | "time" | "/r/has a" |  | "FN" |  |
| fn:deny_or_grant_permission | /r/HasA | fn:fe:place | "deny or grant permission" | "place" | "/r/has a" |  | "FN" |  |
| fn:deny_or_grant_permission | /r/HasA | fn:fe:purpose | "deny or grant permission" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:deny_or_grant_permission | /r/HasA | fn:fe:event_description | "deny or grant permission" | "event description" | "/r/has a" |  | "FN" |  |
| fn:deny_or_grant_permission | /r/HasA | fn:fe:degree | "deny or grant permission" | "degree" | "/r/has a" |  | "FN" |  |
| fn:deny_or_grant_permission | /r/HasA | fn:fe:explanation | "deny or grant permission" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:deny_or_grant_permission | /r/HasA | fn:fe:circumstances | "deny or grant permission" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:deny_or_grant_permission | /r/HasA | fn:fe:allowed_category | "deny or grant permission" | "allowed category" | "/r/has a" |  | "FN" |  |
| fn:deny_or_grant_permission | /r/HasA | fn:fe:period_of_iterations | "deny or grant permission" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:deny_or_grant_permission | /r/HasA | fn:fe:frequency | "deny or grant permission" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:deny_or_grant_permission | /r/HasA | fn:fe:depictive | "deny or grant permission" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:deny_or_grant_permission | /r/HasA | fn:fe:manner | "deny or grant permission" | "manner" | "/r/has a" |  | "FN" |  |
| fn:deny_or_grant_permission | /r/HasA | fn:fe:means | "deny or grant permission" | "means" | "/r/has a" |  | "FN" |  |
| fn:escaping | /r/IsA | fn:departing | "escaping" | "departing" | "/r/is a" |  | "FN" |  |
| fn:quitting_a_place | /r/IsA | fn:departing | "quitting a place" | "departing" | "/r/is a" |  | "FN" |  |
| fn:visiting_scenario_departing | /r/IsA | fn:departing | "visiting scenario departing" | "departing" | "/r/is a" |  | "FN" |  |
| fn:departing | /r/IsA | fn:eventive_affecting | "departing" | "eventive affecting" | "/r/is a" |  | "FN" |  |
| fn:traversing | /r/HasSubevent | fn:departing | "traversing" | "departing" | "/r/has subevent" |  | "FN" |  |
| fn:departing | /r/UsedFor | fn:disembarking | "departing" | "disembarking" | "/r/used for" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:departing | "motion" | "departing" | "/r/used for" |  | "FN" |  |
| fn:departing | /r/SimilarTo | fn:quitting_a_place | "departing" | "quitting a place" | "/r/similar to" |  | "FN" |  |
| fn:departing | /r/SimilarTo | fn:setting_out | "departing" | "setting out" | "/r/similar to" |  | "FN" |  |
| fn:path_shape | /r/SimilarTo | fn:departing | "path shape" | "departing" | "/r/similar to" |  | "FN" |  |
| fn:traversing | /r/SimilarTo | fn:departing | "traversing" | "departing" | "/r/similar to" |  | "FN" |  |
| fn:arriving | /r/HasPrerequisite | fn:departing | "arriving" | "departing" | "/r/has prerequisite" |  | "FN" |  |
| fn:departing | fn:HasLexicalUnit | fn:lu:departing:decamp | "departing" | "decamp" | "has lexical unit" |  | "FN" |  |
| fn:departing | fn:HasLexicalUnit | fn:lu:departing:depart | "departing" | "depart" | "has lexical unit" |  | "FN" |  |
| fn:departing | fn:HasLexicalUnit | fn:lu:departing:departure | "departing" | "departure" | "has lexical unit" |  | "FN" |  |
| fn:departing | fn:HasLexicalUnit | fn:lu:departing:disappear | "departing" | "disappear" | "has lexical unit" |  | "FN" |  |
| fn:departing | fn:HasLexicalUnit | fn:lu:departing:disappearance | "departing" | "disappearance" | "has lexical unit" |  | "FN" |  |
| fn:departing | fn:HasLexicalUnit | fn:lu:departing:escape | "departing" | "escape" | "has lexical unit" |  | "FN" |  |
| fn:departing | fn:HasLexicalUnit | fn:lu:departing:escape | "departing" | "escape" | "has lexical unit" |  | "FN" |  |
| fn:departing | fn:HasLexicalUnit | fn:lu:departing:vamoose | "departing" | "vamoose" | "has lexical unit" |  | "FN" |  |
| fn:departing | fn:HasLexicalUnit | fn:lu:departing:vanish | "departing" | "vanish" | "has lexical unit" |  | "FN" |  |
| fn:departing | fn:HasLexicalUnit | fn:lu:departing:skedaddle | "departing" | "skedaddle" | "has lexical unit" |  | "FN" |  |
| fn:departing | fn:HasLexicalUnit | fn:lu:departing:exit | "departing" | "exit" | "has lexical unit" |  | "FN" |  |
| fn:departing | fn:HasLexicalUnit | fn:lu:departing:leave | "departing" | "leave" | "has lexical unit" |  | "FN" |  |
| fn:departing | fn:HasLexicalUnit | fn:lu:departing:emerge | "departing" | "emerge" | "has lexical unit" |  | "FN" |  |
| fn:departing | fn:HasLexicalUnit | fn:lu:departing:exit | "departing" | "exit" | "has lexical unit" |  | "FN" |  |
| fn:departing | fn:HasLexicalUnit | fn:lu:departing:exodus | "departing" | "exodus" | "has lexical unit" |  | "FN" |  |
| fn:departing | /r/HasA | fn:fe:theme | "departing" | "theme" | "/r/has a" |  | "FN" |  |
| fn:fe:source | /r/IsA | fn:st:location | "source" | "location" | "/r/is a" |  | "FN" |  |
| fn:departing | /r/HasA | fn:fe:source | "departing" | "source" | "/r/has a" |  | "FN" |  |
| fn:departing | /r/HasA | fn:fe:path | "departing" | "path" | "/r/has a" |  | "FN" |  |
| fn:departing | /r/HasA | fn:fe:goal | "departing" | "goal" | "/r/has a" |  | "FN" |  |
| fn:departing | /r/HasA | fn:fe:manner | "departing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:departing | /r/HasA | fn:fe:means | "departing" | "means" | "/r/has a" |  | "FN" |  |
| fn:departing | /r/HasA | fn:fe:speed | "departing" | "speed" | "/r/has a" |  | "FN" |  |
| fn:departing | /r/HasA | fn:fe:mode_of_transportation | "departing" | "mode of transportation" | "/r/has a" |  | "FN" |  |
| fn:departing | /r/HasA | fn:fe:cotheme | "departing" | "cotheme" | "/r/has a" |  | "FN" |  |
| fn:departing | /r/HasA | fn:fe:distance | "departing" | "distance" | "/r/has a" |  | "FN" |  |
| fn:departing | /r/HasA | fn:fe:time | "departing" | "time" | "/r/has a" |  | "FN" |  |
| fn:departing | /r/HasA | fn:fe:frequency | "departing" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:departing | /r/HasA | fn:fe:journey | "departing" | "journey" | "/r/has a" |  | "FN" |  |
| fn:departing | /r/HasA | fn:fe:place | "departing" | "place" | "/r/has a" |  | "FN" |  |
| fn:departing | /r/HasA | fn:fe:depictive | "departing" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:departing | /r/HasA | fn:fe:explanation | "departing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:departing | /r/HasA | fn:fe:purpose | "departing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:departing | /r/HasA | fn:fe:duration_of_final_state | "departing" | "duration of final state" | "/r/has a" |  | "FN" |  |
| fn:departing | /r/HasA | fn:fe:iterations | "departing" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:departing | /r/HasA | fn:fe:circumstances | "departing" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:departing | /r/HasA | fn:fe:re-encoding | "departing" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:departing | /r/HasA | fn:fe:containing_event | "departing" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:departing | /r/HasA | fn:fe:event_description | "departing" | "event description" | "/r/has a" |  | "FN" |  |
| fn:reason | /r/UsedFor | fn:deserving | "reason" | "deserving" | "/r/used for" |  | "FN" |  |
| fn:required_event | /r/UsedFor | fn:deserving | "required event" | "deserving" | "/r/used for" |  | "FN" |  |
| fn:response | /r/UsedFor | fn:deserving | "response" | "deserving" | "/r/used for" |  | "FN" |  |
| fn:deserving | fn:HasLexicalUnit | fn:lu:deserving:merit | "deserving" | "merit" | "has lexical unit" |  | "FN" |  |
| fn:deserving | fn:HasLexicalUnit | fn:lu:deserving:warrant | "deserving" | "warrant" | "has lexical unit" |  | "FN" |  |
| fn:deserving | fn:HasLexicalUnit | fn:lu:deserving:warrant | "deserving" | "warrant" | "has lexical unit" |  | "FN" |  |
| fn:deserving | fn:HasLexicalUnit | fn:lu:deserving:grounds | "deserving" | "grounds" | "has lexical unit" |  | "FN" |  |
| fn:deserving | fn:HasLexicalUnit | fn:lu:deserving:worth | "deserving" | "worth" | "has lexical unit" |  | "FN" |  |
| fn:deserving | fn:HasLexicalUnit | fn:lu:deserving:deserve | "deserving" | "deserve" | "has lexical unit" |  | "FN" |  |
| fn:deserving | fn:HasLexicalUnit | fn:lu:deserving:call | "deserving" | "call" | "has lexical unit" |  | "FN" |  |
| fn:deserving | fn:HasLexicalUnit | fn:lu:deserving:justify | "deserving" | "justify" | "has lexical unit" |  | "FN" |  |
| fn:deserving | /r/HasA | fn:fe:state_of_affairs | "deserving" | "state of affairs" | "/r/has a" |  | "FN" |  |
| fn:deserving | /r/HasA | fn:fe:action | "deserving" | "action" | "/r/has a" |  | "FN" |  |
| fn:deserving | /r/HasA | fn:fe:degree | "deserving" | "degree" | "/r/has a" |  | "FN" |  |
| fn:deserving | /r/HasA | fn:fe:domain | "deserving" | "domain" | "/r/has a" |  | "FN" |  |
| fn:deserving | /r/HasA | fn:fe:circumstances | "deserving" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:aesthetics | /r/IsA | fn:desirability | "aesthetics" | "desirability" | "/r/is a" |  | "FN" |  |
| fn:desirable_event | /r/IsA | fn:desirability | "desirable event" | "desirability" | "/r/is a" |  | "FN" |  |
| fn:popularity | /r/IsA | fn:desirability | "popularity" | "desirability" | "/r/is a" |  | "FN" |  |
| fn:social_desirability | /r/IsA | fn:desirability | "social desirability" | "desirability" | "/r/is a" |  | "FN" |  |
| fn:desirability | /r/IsA | fn:gradable_attributes | "desirability" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:desirability | /r/UsedFor | fn:grooming | "desirability" | "grooming" | "/r/used for" |  | "FN" |  |
| fn:desirability | /r/UsedFor | fn:preferred_alternative_scenario | "desirability" | "preferred alternative scenario" | "/r/used for" |  | "FN" |  |
| fn:desirability | /r/UsedFor | fn:thriving | "desirability" | "thriving" | "/r/used for" |  | "FN" |  |
| fn:experiencer_focus | /r/UsedFor | fn:desirability | "experiencer focus" | "desirability" | "/r/used for" |  | "FN" |  |
| fn:desirability | /r/SimilarTo | fn:expertise | "desirability" | "expertise" | "/r/similar to" |  | "FN" |  |
| fn:desirability | /r/SimilarTo | fn:usefulness | "desirability" | "usefulness" | "/r/similar to" |  | "FN" |  |
| fn:expertise | /r/SimilarTo | fn:desirability | "expertise" | "desirability" | "/r/similar to" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:pathetic | "desirability" | "pathetic" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:superb | "desirability" | "superb" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:superlative | "desirability" | "superlative" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:excellent | "desirability" | "excellent" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:fabulous | "desirability" | "fabulous" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:outstanding | "desirability" | "outstanding" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:pitiful | "desirability" | "pitiful" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:appalling | "desirability" | "appalling" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:execrable | "desirability" | "execrable" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:fantastic | "desirability" | "fantastic" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:awful | "desirability" | "awful" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:splendid | "desirability" | "splendid" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:sensational | "desirability" | "sensational" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:wonderful | "desirability" | "wonderful" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:astonishing | "desirability" | "astonishing" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:rotten | "desirability" | "rotten" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:terrible | "desirability" | "terrible" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:magnificent | "desirability" | "magnificent" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:horrible | "desirability" | "horrible" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:dreadful | "desirability" | "dreadful" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:stupendous | "desirability" | "stupendous" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:marvellous | "desirability" | "marvellous" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:super | "desirability" | "super" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:first-rate | "desirability" | "first-rate" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:tremendous | "desirability" | "tremendous" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:good | "desirability" | "good" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:bad | "desirability" | "bad" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:fair | "desirability" | "fair" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:mediocre | "desirability" | "mediocre" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:decent | "desirability" | "decent" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:okay | "desirability" | "okay" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:average | "desirability" | "average" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:tolerable | "desirability" | "tolerable" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:second-rate | "desirability" | "second-rate" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:third-rate | "desirability" | "third-rate" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:astounding | "desirability" | "astounding" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:fine | "desirability" | "fine" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:terrific | "desirability" | "terrific" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:great | "desirability" | "great" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:so-so | "desirability" | "so-so" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:substandard | "desirability" | "substandard" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:shitty | "desirability" | "shitty" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:inferior | "desirability" | "inferior" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:top-notch | "desirability" | "top-notch" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:tip-top | "desirability" | "tip-top" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:incredible | "desirability" | "incredible" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:crappy | "desirability" | "crappy" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:amazing | "desirability" | "amazing" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:suck | "desirability" | "suck" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:rock | "desirability" | "rock" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:lamer | "desirability" | "lamer" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:lame | "desirability" | "lame" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:uncool | "desirability" | "uncool" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:excellence | "desirability" | "excellence" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:desirable | "desirability" | "desirable" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:extraordinary | "desirability" | "extraordinary" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:sweet | "desirability" | "sweet" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:cool | "desirability" | "cool" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:nasty | "desirability" | "nasty" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:miserable | "desirability" | "miserable" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:unfortunate | "desirability" | "unfortunate" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:popular | "desirability" | "popular" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:idyllic | "desirability" | "idyllic" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:poor | "desirability" | "poor" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:atrocious | "desirability" | "atrocious" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:well | "desirability" | "well" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:standout | "desirability" | "standout" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:crap | "desirability" | "crap" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:shit | "desirability" | "shit" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:garbage | "desirability" | "garbage" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:gem | "desirability" | "gem" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:gold | "desirability" | "gold" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:killer | "desirability" | "killer" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:awesome | "desirability" | "awesome" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:best_thing_since_sliced_bread | "desirability" | "best thing since sliced bread" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:junk | "desirability" | "junk" | "has lexical unit" |  | "FN" |  |
| fn:desirability | fn:HasLexicalUnit | fn:lu:desirability:worthless | "desirability" | "worthless" | "has lexical unit" |  | "FN" |  |
| fn:desirability | /r/HasA | fn:fe:evaluee | "desirability" | "evaluee" | "/r/has a" |  | "FN" |  |
| fn:desirability | /r/HasA | fn:fe:degree | "desirability" | "degree" | "/r/has a" |  | "FN" |  |
| fn:desirability | /r/HasA | fn:fe:circumstances | "desirability" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:desirability | /r/HasA | fn:fe:parameter | "desirability" | "parameter" | "/r/has a" |  | "FN" |  |
| fn:desirability | /r/HasA | fn:fe:comparison_set | "desirability" | "comparison set" | "/r/has a" |  | "FN" |  |
| fn:desirability | /r/HasA | fn:fe:affected_party | "desirability" | "affected party" | "/r/has a" |  | "FN" |  |
| fn:desirability | /r/HasA | fn:fe:depictive | "desirability" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:desirable_event | /r/IsA | fn:desirability | "desirable event" | "desirability" | "/r/is a" |  | "FN" |  |
| fn:desirable_event | /r/UsedFor | fn:taking_sides | "desirable event" | "taking sides" | "/r/used for" |  | "FN" |  |
| fn:required_event | /r/UsedFor | fn:desirable_event | "required event" | "desirable event" | "/r/used for" |  | "FN" |  |
| fn:required_event | /r/SimilarTo | fn:desirable_event | "required event" | "desirable event" | "/r/similar to" |  | "FN" |  |
| fn:desirable_event | /r/IsA | fn:preferred_alternative_scenario | "desirable event" | "preferred alternative scenario" | "/r/is a" |  | "FN" |  |
| fn:desirable_event | fn:HasLexicalUnit | fn:lu:desirable_event:should | "desirable event" | "should" | "has lexical unit" |  | "FN" |  |
| fn:desirable_event | fn:HasLexicalUnit | fn:lu:desirable_event:ought_to | "desirable event" | "ought to" | "has lexical unit" |  | "FN" |  |
| fn:desirable_event | fn:HasLexicalUnit | fn:lu:desirable_event:bad_idea | "desirable event" | "bad idea" | "has lexical unit" |  | "FN" |  |
| fn:desirable_event | fn:HasLexicalUnit | fn:lu:desirable_event:good_idea | "desirable event" | "good idea" | "has lexical unit" |  | "FN" |  |
| fn:desirable_event | fn:HasLexicalUnit | fn:lu:desirable_event:have_to | "desirable event" | "have to" | "has lexical unit" |  | "FN" |  |
| fn:desirable_event | fn:HasLexicalUnit | fn:lu:desirable_event:be_supposed_to | "desirable event" | "be supposed to" | "has lexical unit" |  | "FN" |  |
| fn:desirable_event | /r/HasA | fn:fe:state_of_affairs | "desirable event" | "state of affairs" | "/r/has a" |  | "FN" |  |
| fn:desirable_event | /r/HasA | fn:fe:circumstances | "desirable event" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:desirable_event | /r/HasA | fn:fe:purpose | "desirable event" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:desirable_event | /r/HasA | fn:fe:degree | "desirable event" | "degree" | "/r/has a" |  | "FN" |  |
| fn:preference | /r/IsA | fn:desiring | "preference" | "desiring" | "/r/is a" |  | "FN" |  |
| fn:desiring | /r/IsA | fn:experiencer_focus | "desiring" | "experiencer focus" | "/r/is a" |  | "FN" |  |
| fn:desiring | /r/UsedFor | fn:needing | "desiring" | "needing" | "/r/used for" |  | "FN" |  |
| fn:desiring | /r/UsedFor | fn:purpose | "desiring" | "purpose" | "/r/used for" |  | "FN" |  |
| fn:emotions | /r/UsedFor | fn:desiring | "emotions" | "desiring" | "/r/used for" |  | "FN" |  |
| fn:experiencer_focus | /r/SimilarTo | fn:desiring | "experiencer focus" | "desiring" | "/r/similar to" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:want | "desiring" | "want" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:desire | "desiring" | "desire" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:desire | "desiring" | "desire" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:desirous | "desiring" | "desirous" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:lust | "desiring" | "lust" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:lust | "desiring" | "lust" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:hunger | "desiring" | "hunger" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:hunger | "desiring" | "hunger" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:hungry | "desiring" | "hungry" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:thirst | "desiring" | "thirst" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:thirst | "desiring" | "thirst" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:thirsty | "desiring" | "thirsty" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:long | "desiring" | "long" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:longing | "desiring" | "longing" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:urge | "desiring" | "urge" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:aspire | "desiring" | "aspire" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:wish | "desiring" | "wish" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:wish_(that) | "desiring" | "wish (that)" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:eager | "desiring" | "eager" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:hanker | "desiring" | "hanker" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:hankering | "desiring" | "hankering" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:aspiration | "desiring" | "aspiration" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:crave | "desiring" | "crave" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:craving | "desiring" | "craving" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:yearn | "desiring" | "yearn" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:yen | "desiring" | "yen" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:yearning | "desiring" | "yearning" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:wants | "desiring" | "wants" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:hope | "desiring" | "hope" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:hope | "desiring" | "hope" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:covet | "desiring" | "covet" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:covetous | "desiring" | "covetous" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:will | "desiring" | "will" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:wish | "desiring" | "wish" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:yen | "desiring" | "yen" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:ambition | "desiring" | "ambition" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:feel_like | "desiring" | "feel like" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:interested | "desiring" | "interested" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:in_the_hope_of | "desiring" | "in the hope of" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:raring | "desiring" | "raring" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:spoiling | "desiring" | "spoiling" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:dying | "desiring" | "dying" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:fancy | "desiring" | "fancy" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:pine | "desiring" | "pine" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:ache | "desiring" | "ache" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:desired | "desiring" | "desired" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:will | "desiring" | "will" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:itch | "desiring" | "itch" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:loath | "desiring" | "loath" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:reluctant | "desiring" | "reluctant" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:care | "desiring" | "care" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:in_hopes_of | "desiring" | "in hopes of" | "has lexical unit" |  | "FN" |  |
| fn:desiring | fn:HasLexicalUnit | fn:lu:desiring:impulse | "desiring" | "impulse" | "has lexical unit" |  | "FN" |  |
| fn:desiring | /r/HasA | fn:fe:experiencer | "desiring" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:desiring | /r/HasA | fn:fe:event | "desiring" | "event" | "/r/has a" |  | "FN" |  |
| fn:desiring | /r/HasA | fn:fe:focal_participant | "desiring" | "focal participant" | "/r/has a" |  | "FN" |  |
| fn:desiring | /r/HasA | fn:fe:degree | "desiring" | "degree" | "/r/has a" |  | "FN" |  |
| fn:desiring | /r/HasA | fn:fe:manner | "desiring" | "manner" | "/r/has a" |  | "FN" |  |
| fn:desiring | /r/HasA | fn:fe:explanation | "desiring" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:desiring | /r/HasA | fn:fe:purpose_of_event | "desiring" | "purpose of event" | "/r/has a" |  | "FN" |  |
| fn:desiring | /r/HasA | fn:fe:time_of_event | "desiring" | "time of event" | "/r/has a" |  | "FN" |  |
| fn:desiring | /r/HasA | fn:fe:location_of_event | "desiring" | "location of event" | "/r/has a" |  | "FN" |  |
| fn:desiring | /r/HasA | fn:fe:time | "desiring" | "time" | "/r/has a" |  | "FN" |  |
| fn:desiring | /r/HasA | fn:fe:place | "desiring" | "place" | "/r/has a" |  | "FN" |  |
| fn:desiring | /r/HasA | fn:fe:duration | "desiring" | "duration" | "/r/has a" |  | "FN" |  |
| fn:desiring | /r/HasA | fn:fe:role_of_focal_participant | "desiring" | "role of focal participant" | "/r/has a" |  | "FN" |  |
| fn:destiny | /r/IsA | fn:eventive_affecting | "destiny" | "eventive affecting" | "/r/is a" |  | "FN" |  |
| fn:destiny | /r/UsedFor | fn:luck | "destiny" | "luck" | "/r/used for" |  | "FN" |  |
| fn:destiny | fn:HasLexicalUnit | fn:lu:destiny:destiny | "destiny" | "destiny" | "has lexical unit" |  | "FN" |  |
| fn:destiny | fn:HasLexicalUnit | fn:lu:destiny:fate | "destiny" | "fate" | "has lexical unit" |  | "FN" |  |
| fn:destiny | fn:HasLexicalUnit | fn:lu:destiny:lot | "destiny" | "lot" | "has lexical unit" |  | "FN" |  |
| fn:destiny | fn:HasLexicalUnit | fn:lu:destiny:fortune | "destiny" | "fortune" | "has lexical unit" |  | "FN" |  |
| fn:destiny | fn:HasLexicalUnit | fn:lu:destiny:kismet | "destiny" | "kismet" | "has lexical unit" |  | "FN" |  |
| fn:destiny | fn:HasLexicalUnit | fn:lu:destiny:stars | "destiny" | "stars" | "has lexical unit" |  | "FN" |  |
| fn:destiny | fn:HasLexicalUnit | fn:lu:destiny:doom | "destiny" | "doom" | "has lexical unit" |  | "FN" |  |
| fn:destiny | fn:HasLexicalUnit | fn:lu:destiny:the_breaks | "destiny" | "the breaks" | "has lexical unit" |  | "FN" |  |
| fn:destiny | fn:HasLexicalUnit | fn:lu:destiny:in_the_cards | "destiny" | "in the cards" | "has lexical unit" |  | "FN" |  |
| fn:destiny | fn:HasLexicalUnit | fn:lu:destiny:predestined | "destiny" | "predestined" | "has lexical unit" |  | "FN" |  |
| fn:destiny | fn:HasLexicalUnit | fn:lu:destiny:destined | "destiny" | "destined" | "has lexical unit" |  | "FN" |  |
| fn:destiny | fn:HasLexicalUnit | fn:lu:destiny:fated | "destiny" | "fated" | "has lexical unit" |  | "FN" |  |
| fn:destiny | fn:HasLexicalUnit | fn:lu:destiny:doomed | "destiny" | "doomed" | "has lexical unit" |  | "FN" |  |
| fn:destiny | /r/HasA | fn:fe:state_of_affairs | "destiny" | "state of affairs" | "/r/has a" |  | "FN" |  |
| fn:destiny | /r/HasA | fn:fe:protagonist | "destiny" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:destiny | /r/HasA | fn:fe:descriptor | "destiny" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:destiny | /r/HasA | fn:fe:role | "destiny" | "role" | "/r/has a" |  | "FN" |  |
| fn:destiny | /r/HasA | fn:fe:time | "destiny" | "time" | "/r/has a" |  | "FN" |  |
| fn:destiny | /r/HasA | fn:fe:place | "destiny" | "place" | "/r/has a" |  | "FN" |  |
| fn:destiny | /r/HasA | fn:fe:manner | "destiny" | "manner" | "/r/has a" |  | "FN" |  |
| fn:destroying | /r/IsA | fn:transitive_action | "destroying" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:destroying | /r/UsedFor | fn:cause_to_fragment | "destroying" | "cause to fragment" | "/r/used for" |  | "FN" |  |
| fn:destroying | fn:HasLexicalUnit | fn:lu:destroying:raze | "destroying" | "raze" | "has lexical unit" |  | "FN" |  |
| fn:destroying | fn:HasLexicalUnit | fn:lu:destroying:unmake | "destroying" | "unmake" | "has lexical unit" |  | "FN" |  |
| fn:destroying | fn:HasLexicalUnit | fn:lu:destroying:level | "destroying" | "level" | "has lexical unit" |  | "FN" |  |
| fn:destroying | fn:HasLexicalUnit | fn:lu:destroying:destroy | "destroying" | "destroy" | "has lexical unit" |  | "FN" |  |
| fn:destroying | fn:HasLexicalUnit | fn:lu:destroying:obliterate | "destroying" | "obliterate" | "has lexical unit" |  | "FN" |  |
| fn:destroying | fn:HasLexicalUnit | fn:lu:destroying:obliteration | "destroying" | "obliteration" | "has lexical unit" |  | "FN" |  |
| fn:destroying | fn:HasLexicalUnit | fn:lu:destroying:destruction | "destroying" | "destruction" | "has lexical unit" |  | "FN" |  |
| fn:destroying | fn:HasLexicalUnit | fn:lu:destroying:devastate | "destroying" | "devastate" | "has lexical unit" |  | "FN" |  |
| fn:destroying | fn:HasLexicalUnit | fn:lu:destroying:devastation | "destroying" | "devastation" | "has lexical unit" |  | "FN" |  |
| fn:destroying | fn:HasLexicalUnit | fn:lu:destroying:vaporize | "destroying" | "vaporize" | "has lexical unit" |  | "FN" |  |
| fn:destroying | fn:HasLexicalUnit | fn:lu:destroying:annihilate | "destroying" | "annihilate" | "has lexical unit" |  | "FN" |  |
| fn:destroying | fn:HasLexicalUnit | fn:lu:destroying:annihilation | "destroying" | "annihilation" | "has lexical unit" |  | "FN" |  |
| fn:destroying | fn:HasLexicalUnit | fn:lu:destroying:lay_waste | "destroying" | "lay waste" | "has lexical unit" |  | "FN" |  |
| fn:destroying | fn:HasLexicalUnit | fn:lu:destroying:demolish | "destroying" | "demolish" | "has lexical unit" |  | "FN" |  |
| fn:destroying | fn:HasLexicalUnit | fn:lu:destroying:demolition | "destroying" | "demolition" | "has lexical unit" |  | "FN" |  |
| fn:destroying | fn:HasLexicalUnit | fn:lu:destroying:dismantle | "destroying" | "dismantle" | "has lexical unit" |  | "FN" |  |
| fn:destroying | fn:HasLexicalUnit | fn:lu:destroying:dismantlement | "destroying" | "dismantlement" | "has lexical unit" |  | "FN" |  |
| fn:destroying | fn:HasLexicalUnit | fn:lu:destroying:destructive | "destroying" | "destructive" | "has lexical unit" |  | "FN" |  |
| fn:destroying | fn:HasLexicalUnit | fn:lu:destroying:blow_up | "destroying" | "blow up" | "has lexical unit" |  | "FN" |  |
| fn:destroying | fn:HasLexicalUnit | fn:lu:destroying:take_out | "destroying" | "take out" | "has lexical unit" |  | "FN" |  |
| fn:destroying | fn:HasLexicalUnit | fn:lu:destroying:blast | "destroying" | "blast" | "has lexical unit" |  | "FN" |  |
| fn:destroying | fn:HasLexicalUnit | fn:lu:destroying:ruin | "destroying" | "ruin" | "has lexical unit" |  | "FN" |  |
| fn:fe:destroyer | /r/IsA | fn:st:sentient | "destroyer" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:destroying | /r/HasA | fn:fe:destroyer | "destroying" | "destroyer" | "/r/has a" |  | "FN" |  |
| fn:destroying | /r/HasA | fn:fe:degree | "destroying" | "degree" | "/r/has a" |  | "FN" |  |
| fn:destroying | /r/HasA | fn:fe:instrument | "destroying" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:destroying | /r/HasA | fn:fe:manner | "destroying" | "manner" | "/r/has a" |  | "FN" |  |
| fn:destroying | /r/HasA | fn:fe:means | "destroying" | "means" | "/r/has a" |  | "FN" |  |
| fn:destroying | /r/HasA | fn:fe:place | "destroying" | "place" | "/r/has a" |  | "FN" |  |
| fn:destroying | /r/HasA | fn:fe:purpose | "destroying" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:destroying | /r/HasA | fn:fe:explanation | "destroying" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:destroying | /r/HasA | fn:fe:result | "destroying" | "result" | "/r/has a" |  | "FN" |  |
| fn:destroying | /r/HasA | fn:fe:subregion | "destroying" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:destroying | /r/HasA | fn:fe:time | "destroying" | "time" | "/r/has a" |  | "FN" |  |
| fn:destroying | /r/HasA | fn:fe:patient | "destroying" | "patient" | "/r/has a" |  | "FN" |  |
| fn:fe:cause | /r/RelatedTo | fn:fe:destroyer | "cause" | "destroyer" | "/r/related to" |  | "FN" |  |
| fn:destroying | /r/HasA | fn:fe:cause | "destroying" | "cause" | "/r/has a" |  | "FN" |  |
| fn:destroying | /r/HasA | fn:fe:role | "destroying" | "role" | "/r/has a" |  | "FN" |  |
| fn:destroying | /r/HasA | fn:fe:frequency | "destroying" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:destroying | /r/HasA | fn:fe:containing_event | "destroying" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:destroying | /r/HasA | fn:fe:depictive | "destroying" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:destroying | /r/HasA | fn:fe:medium | "destroying" | "medium" | "/r/has a" |  | "FN" |  |
| fn:detaching | /r/IsA | fn:intentionally_affect | "detaching" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:detaching | /r/Causes | fn:becoming_detached | "detaching" | "becoming detached" | "/r/causes" |  | "FN" |  |
| fn:detaching | fn:HasLexicalUnit | fn:lu:detaching:detach | "detaching" | "detach" | "has lexical unit" |  | "FN" |  |
| fn:detaching | fn:HasLexicalUnit | fn:lu:detaching:unhitch | "detaching" | "unhitch" | "has lexical unit" |  | "FN" |  |
| fn:detaching | fn:HasLexicalUnit | fn:lu:detaching:unhook | "detaching" | "unhook" | "has lexical unit" |  | "FN" |  |
| fn:detaching | fn:HasLexicalUnit | fn:lu:detaching:unfasten | "detaching" | "unfasten" | "has lexical unit" |  | "FN" |  |
| fn:detaching | fn:HasLexicalUnit | fn:lu:detaching:untie | "detaching" | "untie" | "has lexical unit" |  | "FN" |  |
| fn:detaching | fn:HasLexicalUnit | fn:lu:detaching:unmoor | "detaching" | "unmoor" | "has lexical unit" |  | "FN" |  |
| fn:detaching | fn:HasLexicalUnit | fn:lu:detaching:unchain | "detaching" | "unchain" | "has lexical unit" |  | "FN" |  |
| fn:detaching | fn:HasLexicalUnit | fn:lu:detaching:decouple | "detaching" | "decouple" | "has lexical unit" |  | "FN" |  |
| fn:detaching | fn:HasLexicalUnit | fn:lu:detaching:unhinge | "detaching" | "unhinge" | "has lexical unit" |  | "FN" |  |
| fn:detaching | fn:HasLexicalUnit | fn:lu:detaching:undo | "detaching" | "undo" | "has lexical unit" |  | "FN" |  |
| fn:detaching | /r/HasA | fn:fe:agent | "detaching" | "agent" | "/r/has a" |  | "FN" |  |
| fn:detaching | /r/HasA | fn:fe:item | "detaching" | "item" | "/r/has a" |  | "FN" |  |
| fn:detaching | /r/HasA | fn:fe:result | "detaching" | "result" | "/r/has a" |  | "FN" |  |
| fn:detaching | /r/HasA | fn:fe:source | "detaching" | "source" | "/r/has a" |  | "FN" |  |
| fn:detaching | /r/HasA | fn:fe:items | "detaching" | "items" | "/r/has a" |  | "FN" |  |
| fn:detaching | /r/HasA | fn:fe:means | "detaching" | "means" | "/r/has a" |  | "FN" |  |
| fn:detaching | /r/HasA | fn:fe:manner | "detaching" | "manner" | "/r/has a" |  | "FN" |  |
| fn:detaching | /r/HasA | fn:fe:place | "detaching" | "place" | "/r/has a" |  | "FN" |  |
| fn:detaching | /r/HasA | fn:fe:purpose | "detaching" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:detaching | /r/HasA | fn:fe:time | "detaching" | "time" | "/r/has a" |  | "FN" |  |
| fn:detaching | /r/HasA | fn:fe:instrument | "detaching" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:detaching | /r/HasA | fn:fe:degree | "detaching" | "degree" | "/r/has a" |  | "FN" |  |
| fn:detaining | /r/UsedFor | fn:releasing_from_custody | "detaining" | "releasing from custody" | "/r/used for" |  | "FN" |  |
| fn:inhibit_movement | /r/UsedFor | fn:detaining | "inhibit movement" | "detaining" | "/r/used for" |  | "FN" |  |
| fn:releasing_from_custody | /r/HasPrerequisite | fn:detaining | "releasing from custody" | "detaining" | "/r/has prerequisite" |  | "FN" |  |
| fn:detaining | fn:HasLexicalUnit | fn:lu:detaining:custody | "detaining" | "custody" | "has lexical unit" |  | "FN" |  |
| fn:detaining | fn:HasLexicalUnit | fn:lu:detaining:hold | "detaining" | "hold" | "has lexical unit" |  | "FN" |  |
| fn:detaining | fn:HasLexicalUnit | fn:lu:detaining:detain | "detaining" | "detain" | "has lexical unit" |  | "FN" |  |
| fn:detaining | fn:HasLexicalUnit | fn:lu:detaining:intern | "detaining" | "intern" | "has lexical unit" |  | "FN" |  |
| fn:detaining | fn:HasLexicalUnit | fn:lu:detaining:internment | "detaining" | "internment" | "has lexical unit" |  | "FN" |  |
| fn:detaining | fn:HasLexicalUnit | fn:lu:detaining:at_large | "detaining" | "at large" | "has lexical unit" |  | "FN" |  |
| fn:detaining | fn:HasLexicalUnit | fn:lu:detaining:under_arrest | "detaining" | "under arrest" | "has lexical unit" |  | "FN" |  |
| fn:detaining | /r/HasA | fn:fe:authorities | "detaining" | "authorities" | "/r/has a" |  | "FN" |  |
| fn:detaining | /r/HasA | fn:fe:charges | "detaining" | "charges" | "/r/has a" |  | "FN" |  |
| fn:detaining | /r/HasA | fn:fe:place | "detaining" | "place" | "/r/has a" |  | "FN" |  |
| fn:detaining | /r/HasA | fn:fe:suspect | "detaining" | "suspect" | "/r/has a" |  | "FN" |  |
| fn:detaining | /r/HasA | fn:fe:time | "detaining" | "time" | "/r/has a" |  | "FN" |  |
| fn:detaining | /r/HasA | fn:fe:holding_location | "detaining" | "holding location" | "/r/has a" |  | "FN" |  |
| fn:detaining | /r/HasA | fn:fe:duration | "detaining" | "duration" | "/r/has a" |  | "FN" |  |
| fn:detaining | /r/HasA | fn:fe:legal_basis | "detaining" | "legal basis" | "/r/has a" |  | "FN" |  |
| fn:detaining | /r/HasA | fn:fe:purpose | "detaining" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:detaining | /r/HasA | fn:fe:dependent_state | "detaining" | "dependent state" | "/r/has a" |  | "FN" |  |
| fn:detonate_explosive | /r/IsA | fn:using | "detonate explosive" | "using" | "/r/is a" |  | "FN" |  |
| fn:detonate_explosive | fn:HasLexicalUnit | fn:lu:detonate_explosive:detonate | "detonate explosive" | "detonate" | "has lexical unit" |  | "FN" |  |
| fn:detonate_explosive | fn:HasLexicalUnit | fn:lu:detonate_explosive:explode | "detonate explosive" | "explode" | "has lexical unit" |  | "FN" |  |
| fn:detonate_explosive | fn:HasLexicalUnit | fn:lu:detonate_explosive:detonation | "detonate explosive" | "detonation" | "has lexical unit" |  | "FN" |  |
| fn:detonate_explosive | fn:HasLexicalUnit | fn:lu:detonate_explosive:blow | "detonate explosive" | "blow" | "has lexical unit" |  | "FN" |  |
| fn:detonate_explosive | fn:HasLexicalUnit | fn:lu:detonate_explosive:blow_up | "detonate explosive" | "blow up" | "has lexical unit" |  | "FN" |  |
| fn:detonate_explosive | /r/HasA | fn:fe:agent | "detonate explosive" | "agent" | "/r/has a" |  | "FN" |  |
| fn:detonate_explosive | /r/HasA | fn:fe:place | "detonate explosive" | "place" | "/r/has a" |  | "FN" |  |
| fn:detonate_explosive | /r/HasA | fn:fe:purpose | "detonate explosive" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:detonate_explosive | /r/HasA | fn:fe:time | "detonate explosive" | "time" | "/r/has a" |  | "FN" |  |
| fn:detonate_explosive | /r/HasA | fn:fe:means | "detonate explosive" | "means" | "/r/has a" |  | "FN" |  |
| fn:detonate_explosive | /r/HasA | fn:fe:manner | "detonate explosive" | "manner" | "/r/has a" |  | "FN" |  |
| fn:detonate_explosive | /r/HasA | fn:fe:explosive | "detonate explosive" | "explosive" | "/r/has a" |  | "FN" |  |
| fn:detonate_explosive | /r/HasA | fn:fe:outcome | "detonate explosive" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:detonate_explosive | /r/HasA | fn:fe:containing_event | "detonate explosive" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:detonate_explosive | /r/HasA | fn:fe:frequency | "detonate explosive" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:detonate_explosive | /r/HasA | fn:fe:period_of_iterations | "detonate explosive" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:detonate_explosive | /r/HasA | fn:fe:circumstances | "detonate explosive" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:detonate_explosive | /r/HasA | fn:fe:depictive | "detonate explosive" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:detonate_explosive | /r/HasA | fn:fe:explanation | "detonate explosive" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:detonate_explosive | /r/HasA | fn:fe:degree | "detonate explosive" | "degree" | "/r/has a" |  | "FN" |  |
| fn:detonate_explosive | /r/HasA | fn:fe:duration | "detonate explosive" | "duration" | "/r/has a" |  | "FN" |  |
| fn:detonate_explosive | /r/HasA | fn:fe:instrument | "detonate explosive" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:detonate_explosive | /r/HasA | fn:fe:victim | "detonate explosive" | "victim" | "/r/has a" |  | "FN" |  |
| fn:mental_activity | /r/UsedFor | fn:differentiation | "mental activity" | "differentiation" | "/r/used for" |  | "FN" |  |
| fn:differentiation | fn:HasLexicalUnit | fn:lu:differentiation:differentiate | "differentiation" | "differentiate" | "has lexical unit" |  | "FN" |  |
| fn:differentiation | fn:HasLexicalUnit | fn:lu:differentiation:discriminate | "differentiation" | "discriminate" | "has lexical unit" |  | "FN" |  |
| fn:differentiation | fn:HasLexicalUnit | fn:lu:differentiation:discrimination | "differentiation" | "discrimination" | "has lexical unit" |  | "FN" |  |
| fn:differentiation | fn:HasLexicalUnit | fn:lu:differentiation:distinguish | "differentiation" | "distinguish" | "has lexical unit" |  | "FN" |  |
| fn:differentiation | fn:HasLexicalUnit | fn:lu:differentiation:sort | "differentiation" | "sort" | "has lexical unit" |  | "FN" |  |
| fn:differentiation | fn:HasLexicalUnit | fn:lu:differentiation:tell_apart | "differentiation" | "tell apart" | "has lexical unit" |  | "FN" |  |
| fn:differentiation | fn:HasLexicalUnit | fn:lu:differentiation:separate | "differentiation" | "separate" | "has lexical unit" |  | "FN" |  |
| fn:differentiation | fn:HasLexicalUnit | fn:lu:differentiation:know | "differentiation" | "know" | "has lexical unit" |  | "FN" |  |
| fn:differentiation | fn:HasLexicalUnit | fn:lu:differentiation:tell_from | "differentiation" | "tell from" | "has lexical unit" |  | "FN" |  |
| fn:differentiation | fn:HasLexicalUnit | fn:lu:differentiation:distinguishable | "differentiation" | "distinguishable" | "has lexical unit" |  | "FN" |  |
| fn:differentiation | /r/HasA | fn:fe:cognizer | "differentiation" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:fe:phenomenon_1 | /r/HasPrerequisite | fn:fe:phenomenon_2 | "phenomenon 1" | "phenomenon 2" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:phenomenon_1 | /r/RelatedTo | fn:fe:phenomena | "phenomenon 1" | "phenomena" | "/r/related to" |  | "FN" |  |
| fn:differentiation | /r/HasA | fn:fe:phenomenon_1 | "differentiation" | "phenomenon 1" | "/r/has a" |  | "FN" |  |
| fn:fe:phenomenon_2 | /r/HasPrerequisite | fn:fe:phenomenon_1 | "phenomenon 2" | "phenomenon 1" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:phenomenon_2 | /r/RelatedTo | fn:fe:phenomena | "phenomenon 2" | "phenomena" | "/r/related to" |  | "FN" |  |
| fn:differentiation | /r/HasA | fn:fe:phenomenon_2 | "differentiation" | "phenomenon 2" | "/r/has a" |  | "FN" |  |
| fn:differentiation | /r/HasA | fn:fe:phenomena | "differentiation" | "phenomena" | "/r/has a" |  | "FN" |  |
| fn:differentiation | /r/HasA | fn:fe:quality | "differentiation" | "quality" | "/r/has a" |  | "FN" |  |
| fn:differentiation | /r/HasA | fn:fe:degree | "differentiation" | "degree" | "/r/has a" |  | "FN" |  |
| fn:differentiation | /r/HasA | fn:fe:depictive | "differentiation" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:differentiation | /r/HasA | fn:fe:manner | "differentiation" | "manner" | "/r/has a" |  | "FN" |  |
| fn:differentiation | /r/HasA | fn:fe:means | "differentiation" | "means" | "/r/has a" |  | "FN" |  |
| fn:differentiation | /r/HasA | fn:fe:circumstances | "differentiation" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:difficulty | /r/IsA | fn:gradable_attributes | "difficulty" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:hindering | /r/UsedFor | fn:difficulty | "hindering" | "difficulty" | "/r/used for" |  | "FN" |  |
| fn:difficulty | fn:HasLexicalUnit | fn:lu:difficulty:difficult | "difficulty" | "difficult" | "has lexical unit" |  | "FN" |  |
| fn:difficulty | fn:HasLexicalUnit | fn:lu:difficulty:easy | "difficulty" | "easy" | "has lexical unit" |  | "FN" |  |
| fn:difficulty | fn:HasLexicalUnit | fn:lu:difficulty:hard | "difficulty" | "hard" | "has lexical unit" |  | "FN" |  |
| fn:difficulty | fn:HasLexicalUnit | fn:lu:difficulty:tough | "difficulty" | "tough" | "has lexical unit" |  | "FN" |  |
| fn:difficulty | fn:HasLexicalUnit | fn:lu:difficulty:tricky | "difficulty" | "tricky" | "has lexical unit" |  | "FN" |  |
| fn:difficulty | fn:HasLexicalUnit | fn:lu:difficulty:challenging | "difficulty" | "challenging" | "has lexical unit" |  | "FN" |  |
| fn:difficulty | fn:HasLexicalUnit | fn:lu:difficulty:a_breeze | "difficulty" | "a breeze" | "has lexical unit" |  | "FN" |  |
| fn:difficulty | fn:HasLexicalUnit | fn:lu:difficulty:a_pain | "difficulty" | "a pain" | "has lexical unit" |  | "FN" |  |
| fn:difficulty | fn:HasLexicalUnit | fn:lu:difficulty:a_bitch | "difficulty" | "a bitch" | "has lexical unit" |  | "FN" |  |
| fn:difficulty | fn:HasLexicalUnit | fn:lu:difficulty:impossible | "difficulty" | "impossible" | "has lexical unit" |  | "FN" |  |
| fn:difficulty | fn:HasLexicalUnit | fn:lu:difficulty:trivial | "difficulty" | "trivial" | "has lexical unit" |  | "FN" |  |
| fn:difficulty | fn:HasLexicalUnit | fn:lu:difficulty:a_snap | "difficulty" | "a snap" | "has lexical unit" |  | "FN" |  |
| fn:difficulty | fn:HasLexicalUnit | fn:lu:difficulty:arduous | "difficulty" | "arduous" | "has lexical unit" |  | "FN" |  |
| fn:difficulty | fn:HasLexicalUnit | fn:lu:difficulty:a_pain_in_the_neck | "difficulty" | "a pain in the neck" | "has lexical unit" |  | "FN" |  |
| fn:difficulty | fn:HasLexicalUnit | fn:lu:difficulty:child's_play | "difficulty" | "child\\'s play" | "has lexical unit" |  | "FN" |  |
| fn:difficulty | fn:HasLexicalUnit | fn:lu:difficulty:a_piece_of_cake | "difficulty" | "a piece of cake" | "has lexical unit" |  | "FN" |  |
| fn:difficulty | fn:HasLexicalUnit | fn:lu:difficulty:a_cinch | "difficulty" | "a cinch" | "has lexical unit" |  | "FN" |  |
| fn:difficulty | fn:HasLexicalUnit | fn:lu:difficulty:a_bastard | "difficulty" | "a bastard" | "has lexical unit" |  | "FN" |  |
| fn:difficulty | fn:HasLexicalUnit | fn:lu:difficulty:near_thing | "difficulty" | "near thing" | "has lexical unit" |  | "FN" |  |
| fn:difficulty | fn:HasLexicalUnit | fn:lu:difficulty:challenge | "difficulty" | "challenge" | "has lexical unit" |  | "FN" |  |
| fn:difficulty | fn:HasLexicalUnit | fn:lu:difficulty:a_doddle | "difficulty" | "a doddle" | "has lexical unit" |  | "FN" |  |
| fn:difficulty | fn:HasLexicalUnit | fn:lu:difficulty:difficulty | "difficulty" | "difficulty" | "has lexical unit" |  | "FN" |  |
| fn:difficulty | fn:HasLexicalUnit | fn:lu:difficulty:no_picnic | "difficulty" | "no picnic" | "has lexical unit" |  | "FN" |  |
| fn:difficulty | fn:HasLexicalUnit | fn:lu:difficulty:a_walk_in_the_park | "difficulty" | "a walk in the park" | "has lexical unit" |  | "FN" |  |
| fn:difficulty | fn:HasLexicalUnit | fn:lu:difficulty:like_taking_candy_from_a_baby | "difficulty" | "like taking candy from a baby" | "has lexical unit" |  | "FN" |  |
| fn:difficulty | fn:HasLexicalUnit | fn:lu:difficulty:ease | "difficulty" | "ease" | "has lexical unit" |  | "FN" |  |
| fn:difficulty | /r/HasA | fn:fe:activity | "difficulty" | "activity" | "/r/has a" |  | "FN" |  |
| fn:difficulty | /r/HasA | fn:fe:degree | "difficulty" | "degree" | "/r/has a" |  | "FN" |  |
| fn:difficulty | /r/HasA | fn:fe:circumstances | "difficulty" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:difficulty | /r/HasA | fn:fe:experiencer | "difficulty" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:difficulty | /r/HasA | fn:fe:parameter | "difficulty" | "parameter" | "/r/has a" |  | "FN" |  |
| fn:difficulty | /r/HasA | fn:fe:standard | "difficulty" | "standard" | "/r/has a" |  | "FN" |  |
| fn:difficulty | /r/HasA | fn:fe:time | "difficulty" | "time" | "/r/has a" |  | "FN" |  |
| fn:quantity | /r/IsA | fn:dimension | "quantity" | "dimension" | "/r/is a" |  | "FN" |  |
| fn:measurable_attributes | /r/RelatedTo | fn:dimension | "measurable attributes" | "dimension" | "/r/related to" |  | "FN" |  |
| fn:dimension | /r/SimilarTo | fn:measurable_attributes | "dimension" | "measurable attributes" | "/r/similar to" |  | "FN" |  |
| fn:dimension | /r/SimilarTo | fn:size | "dimension" | "size" | "/r/similar to" |  | "FN" |  |
| fn:dimension | /r/IsA | fn:measure_scenario | "dimension" | "measure scenario" | "/r/is a" |  | "FN" |  |
| fn:dimension | fn:HasLexicalUnit | fn:lu:dimension:tall | "dimension" | "tall" | "has lexical unit" |  | "FN" |  |
| fn:dimension | fn:HasLexicalUnit | fn:lu:dimension:high | "dimension" | "high" | "has lexical unit" |  | "FN" |  |
| fn:dimension | fn:HasLexicalUnit | fn:lu:dimension:wide | "dimension" | "wide" | "has lexical unit" |  | "FN" |  |
| fn:dimension | fn:HasLexicalUnit | fn:lu:dimension:broad | "dimension" | "broad" | "has lexical unit" |  | "FN" |  |
| fn:dimension | fn:HasLexicalUnit | fn:lu:dimension:thick | "dimension" | "thick" | "has lexical unit" |  | "FN" |  |
| fn:dimension | fn:HasLexicalUnit | fn:lu:dimension:deep | "dimension" | "deep" | "has lexical unit" |  | "FN" |  |
| fn:dimension | fn:HasLexicalUnit | fn:lu:dimension:long | "dimension" | "long" | "has lexical unit" |  | "FN" |  |
| fn:dimension | fn:HasLexicalUnit | fn:lu:dimension:breadth | "dimension" | "breadth" | "has lexical unit" |  | "FN" |  |
| fn:dimension | fn:HasLexicalUnit | fn:lu:dimension:depth | "dimension" | "depth" | "has lexical unit" |  | "FN" |  |
| fn:dimension | fn:HasLexicalUnit | fn:lu:dimension:length | "dimension" | "length" | "has lexical unit" |  | "FN" |  |
| fn:dimension | fn:HasLexicalUnit | fn:lu:dimension:width | "dimension" | "width" | "has lexical unit" |  | "FN" |  |
| fn:dimension | fn:HasLexicalUnit | fn:lu:dimension:height | "dimension" | "height" | "has lexical unit" |  | "FN" |  |
| fn:dimension | fn:HasLexicalUnit | fn:lu:dimension:weigh | "dimension" | "weigh" | "has lexical unit" |  | "FN" |  |
| fn:dimension | fn:HasLexicalUnit | fn:lu:dimension:measure | "dimension" | "measure" | "has lexical unit" |  | "FN" |  |
| fn:dimension | fn:HasLexicalUnit | fn:lu:dimension:weight | "dimension" | "weight" | "has lexical unit" |  | "FN" |  |
| fn:dimension | fn:HasLexicalUnit | fn:lu:dimension:area | "dimension" | "area" | "has lexical unit" |  | "FN" |  |
| fn:dimension | fn:HasLexicalUnit | fn:lu:dimension:circumference | "dimension" | "circumference" | "has lexical unit" |  | "FN" |  |
| fn:dimension | fn:HasLexicalUnit | fn:lu:dimension:around | "dimension" | "around" | "has lexical unit" |  | "FN" |  |
| fn:dimension | fn:HasLexicalUnit | fn:lu:dimension:work | "dimension" | "work" | "has lexical unit" |  | "FN" |  |
| fn:dimension | fn:HasLexicalUnit | fn:lu:dimension:across | "dimension" | "across" | "has lexical unit" |  | "FN" |  |
| fn:dimension | fn:HasLexicalUnit | fn:lu:dimension:level | "dimension" | "level" | "has lexical unit" |  | "FN" |  |
| fn:dimension | /r/HasA | fn:fe:dimension | "dimension" | "dimension" | "/r/has a" |  | "FN" |  |
| fn:dimension | /r/HasA | fn:fe:object | "dimension" | "object" | "/r/has a" |  | "FN" |  |
| fn:dimension | /r/HasA | fn:fe:measurement | "dimension" | "measurement" | "/r/has a" |  | "FN" |  |
| fn:fe:locus | /r/IsA | fn:st:location | "locus" | "location" | "/r/is a" |  | "FN" |  |
| fn:dimension | /r/HasA | fn:fe:locus | "dimension" | "locus" | "/r/has a" |  | "FN" |  |
| fn:dimension | /r/HasA | fn:fe:domain | "dimension" | "domain" | "/r/has a" |  | "FN" |  |
| fn:dimension | /r/HasA | fn:fe:degree | "dimension" | "degree" | "/r/has a" |  | "FN" |  |
| fn:direction | /r/UsedFor | fn:change_direction | "direction" | "change direction" | "/r/used for" |  | "FN" |  |
| fn:direction | /r/UsedFor | fn:time_vector | "direction" | "time vector" | "/r/used for" |  | "FN" |  |
| fn:direction | /r/RelatedTo | fn:directional_locative_relation | "direction" | "directional locative relation" | "/r/related to" |  | "FN" |  |
| fn:direction | fn:HasLexicalUnit | fn:lu:direction:east | "direction" | "east" | "has lexical unit" |  | "FN" |  |
| fn:direction | fn:HasLexicalUnit | fn:lu:direction:up | "direction" | "up" | "has lexical unit" |  | "FN" |  |
| fn:direction | fn:HasLexicalUnit | fn:lu:direction:forward | "direction" | "forward" | "has lexical unit" |  | "FN" |  |
| fn:direction | fn:HasLexicalUnit | fn:lu:direction:left | "direction" | "left" | "has lexical unit" |  | "FN" |  |
| fn:direction | fn:HasLexicalUnit | fn:lu:direction:right | "direction" | "right" | "has lexical unit" |  | "FN" |  |
| fn:direction | fn:HasLexicalUnit | fn:lu:direction:north | "direction" | "north" | "has lexical unit" |  | "FN" |  |
| fn:direction | fn:HasLexicalUnit | fn:lu:direction:south | "direction" | "south" | "has lexical unit" |  | "FN" |  |
| fn:direction | fn:HasLexicalUnit | fn:lu:direction:east | "direction" | "east" | "has lexical unit" |  | "FN" |  |
| fn:direction | fn:HasLexicalUnit | fn:lu:direction:south | "direction" | "south" | "has lexical unit" |  | "FN" |  |
| fn:direction | fn:HasLexicalUnit | fn:lu:direction:down | "direction" | "down" | "has lexical unit" |  | "FN" |  |
| fn:direction | fn:HasLexicalUnit | fn:lu:direction:outward | "direction" | "outward" | "has lexical unit" |  | "FN" |  |
| fn:direction | fn:HasLexicalUnit | fn:lu:direction:north | "direction" | "north" | "has lexical unit" |  | "FN" |  |
| fn:direction | fn:HasLexicalUnit | fn:lu:direction:west | "direction" | "west" | "has lexical unit" |  | "FN" |  |
| fn:direction | fn:HasLexicalUnit | fn:lu:direction:true_north | "direction" | "true north" | "has lexical unit" |  | "FN" |  |
| fn:direction | fn:HasLexicalUnit | fn:lu:direction:way | "direction" | "way" | "has lexical unit" |  | "FN" |  |
| fn:direction | /r/HasA | fn:fe:landmark | "direction" | "landmark" | "/r/has a" |  | "FN" |  |
| fn:direction | /r/HasA | fn:fe:path | "direction" | "path" | "/r/has a" |  | "FN" |  |
| fn:direction | /r/HasA | fn:fe:domain | "direction" | "domain" | "/r/has a" |  | "FN" |  |
| fn:direction | /r/HasA | fn:fe:independent_variable | "direction" | "independent variable" | "/r/has a" |  | "FN" |  |
| fn:direction | /r/HasA | fn:fe:distance | "direction" | "distance" | "/r/has a" |  | "FN" |  |
| fn:directional_locative_relation | /r/IsA | fn:locative_relation | "directional locative relation" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:direction | /r/RelatedTo | fn:directional_locative_relation | "direction" | "directional locative relation" | "/r/related to" |  | "FN" |  |
| fn:non-gradable_proximity | /r/SimilarTo | fn:directional_locative_relation | "non-gradable proximity" | "directional locative relation" | "/r/similar to" |  | "FN" |  |
| fn:directional_locative_relation | fn:HasLexicalUnit | fn:lu:directional_locative_relation:above | "directional locative relation" | "above" | "has lexical unit" |  | "FN" |  |
| fn:directional_locative_relation | fn:HasLexicalUnit | fn:lu:directional_locative_relation:below | "directional locative relation" | "below" | "has lexical unit" |  | "FN" |  |
| fn:directional_locative_relation | fn:HasLexicalUnit | fn:lu:directional_locative_relation:east | "directional locative relation" | "east" | "has lexical unit" |  | "FN" |  |
| fn:directional_locative_relation | fn:HasLexicalUnit | fn:lu:directional_locative_relation:east | "directional locative relation" | "east" | "has lexical unit" |  | "FN" |  |
| fn:directional_locative_relation | fn:HasLexicalUnit | fn:lu:directional_locative_relation:north | "directional locative relation" | "north" | "has lexical unit" |  | "FN" |  |
| fn:directional_locative_relation | fn:HasLexicalUnit | fn:lu:directional_locative_relation:north | "directional locative relation" | "north" | "has lexical unit" |  | "FN" |  |
| fn:directional_locative_relation | fn:HasLexicalUnit | fn:lu:directional_locative_relation:northeast | "directional locative relation" | "northeast" | "has lexical unit" |  | "FN" |  |
| fn:directional_locative_relation | fn:HasLexicalUnit | fn:lu:directional_locative_relation:northeast | "directional locative relation" | "northeast" | "has lexical unit" |  | "FN" |  |
| fn:directional_locative_relation | fn:HasLexicalUnit | fn:lu:directional_locative_relation:northwest | "directional locative relation" | "northwest" | "has lexical unit" |  | "FN" |  |
| fn:directional_locative_relation | fn:HasLexicalUnit | fn:lu:directional_locative_relation:northwest | "directional locative relation" | "northwest" | "has lexical unit" |  | "FN" |  |
| fn:directional_locative_relation | fn:HasLexicalUnit | fn:lu:directional_locative_relation:south | "directional locative relation" | "south" | "has lexical unit" |  | "FN" |  |
| fn:directional_locative_relation | fn:HasLexicalUnit | fn:lu:directional_locative_relation:south | "directional locative relation" | "south" | "has lexical unit" |  | "FN" |  |
| fn:directional_locative_relation | fn:HasLexicalUnit | fn:lu:directional_locative_relation:southeast | "directional locative relation" | "southeast" | "has lexical unit" |  | "FN" |  |
| fn:directional_locative_relation | fn:HasLexicalUnit | fn:lu:directional_locative_relation:southeast | "directional locative relation" | "southeast" | "has lexical unit" |  | "FN" |  |
| fn:directional_locative_relation | fn:HasLexicalUnit | fn:lu:directional_locative_relation:southwest | "directional locative relation" | "southwest" | "has lexical unit" |  | "FN" |  |
| fn:directional_locative_relation | fn:HasLexicalUnit | fn:lu:directional_locative_relation:southwest | "directional locative relation" | "southwest" | "has lexical unit" |  | "FN" |  |
| fn:directional_locative_relation | fn:HasLexicalUnit | fn:lu:directional_locative_relation:west | "directional locative relation" | "west" | "has lexical unit" |  | "FN" |  |
| fn:directional_locative_relation | fn:HasLexicalUnit | fn:lu:directional_locative_relation:west | "directional locative relation" | "west" | "has lexical unit" |  | "FN" |  |
| fn:directional_locative_relation | /r/HasA | fn:fe:ground | "directional locative relation" | "ground" | "/r/has a" |  | "FN" |  |
| fn:directional_locative_relation | /r/HasA | fn:fe:figure | "directional locative relation" | "figure" | "/r/has a" |  | "FN" |  |
| fn:directional_locative_relation | /r/HasA | fn:fe:accessibility | "directional locative relation" | "accessibility" | "/r/has a" |  | "FN" |  |
| fn:directional_locative_relation | /r/HasA | fn:fe:direction | "directional locative relation" | "direction" | "/r/has a" |  | "FN" |  |
| fn:directional_locative_relation | /r/HasA | fn:fe:time | "directional locative relation" | "time" | "/r/has a" |  | "FN" |  |
| fn:directional_locative_relation | /r/HasA | fn:fe:distance | "directional locative relation" | "distance" | "/r/has a" |  | "FN" |  |
| fn:directional_locative_relation | /r/HasA | fn:fe:deixis | "directional locative relation" | "deixis" | "/r/has a" |  | "FN" |  |
| fn:directional_locative_relation | /r/HasA | fn:fe:directness | "directional locative relation" | "directness" | "/r/has a" |  | "FN" |  |
| fn:directional_locative_relation | /r/HasA | fn:fe:temporal_profile | "directional locative relation" | "temporal profile" | "/r/has a" |  | "FN" |  |
| fn:fire_emergency_scenario | /r/IsA | fn:disaster_scenario | "fire emergency scenario" | "disaster scenario" | "/r/is a" |  | "FN" |  |
| fn:fe:responder | /r/IsA | fn:st:sentient | "responder" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:disaster_scenario | /r/HasA | fn:fe:responder | "disaster scenario" | "responder" | "/r/has a" |  | "FN" |  |
| fn:disaster_scenario | /r/HasA | fn:fe:victim | "disaster scenario" | "victim" | "/r/has a" |  | "FN" |  |
| fn:disaster_scenario | /r/HasA | fn:fe:place | "disaster scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:disaster_scenario | /r/HasA | fn:fe:response | "disaster scenario" | "response" | "/r/has a" |  | "FN" |  |
| fn:disaster_scenario | /r/HasA | fn:fe:time | "disaster scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:disaster_scenario | /r/HasA | fn:fe:duration | "disaster scenario" | "duration" | "/r/has a" |  | "FN" |  |
| fn:disaster_scenario | /r/HasA | fn:fe:disaster | "disaster scenario" | "disaster" | "/r/has a" |  | "FN" |  |
| fn:discussion | /r/IsA | fn:chatting | "discussion" | "chatting" | "/r/is a" |  | "FN" |  |
| fn:quarreling | /r/IsA | fn:discussion | "quarreling" | "discussion" | "/r/is a" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:discussion | "communication" | "discussion" | "/r/used for" |  | "FN" |  |
| fn:discussion | /r/UsedFor | fn:jury_deliberation | "discussion" | "jury deliberation" | "/r/used for" |  | "FN" |  |
| fn:discussion | /r/UsedFor | fn:meet_with | "discussion" | "meet with" | "/r/used for" |  | "FN" |  |
| fn:discussion | /r/UsedFor | fn:point_of_dispute | "discussion" | "point of dispute" | "/r/used for" |  | "FN" |  |
| fn:discussion | /r/SimilarTo | fn:chatting | "discussion" | "chatting" | "/r/similar to" |  | "FN" |  |
| fn:discussion | /r/SimilarTo | fn:quarreling | "discussion" | "quarreling" | "/r/similar to" |  | "FN" |  |
| fn:discussion | /r/SimilarTo | fn:topic | "discussion" | "topic" | "/r/similar to" |  | "FN" |  |
| fn:discussion | fn:HasLexicalUnit | fn:lu:discussion:confer | "discussion" | "confer" | "has lexical unit" |  | "FN" |  |
| fn:discussion | fn:HasLexicalUnit | fn:lu:discussion:debate | "discussion" | "debate" | "has lexical unit" |  | "FN" |  |
| fn:discussion | fn:HasLexicalUnit | fn:lu:discussion:debate | "discussion" | "debate" | "has lexical unit" |  | "FN" |  |
| fn:discussion | fn:HasLexicalUnit | fn:lu:discussion:dialog | "discussion" | "dialog" | "has lexical unit" |  | "FN" |  |
| fn:discussion | fn:HasLexicalUnit | fn:lu:discussion:discuss | "discussion" | "discuss" | "has lexical unit" |  | "FN" |  |
| fn:discussion | fn:HasLexicalUnit | fn:lu:discussion:discussion | "discussion" | "discussion" | "has lexical unit" |  | "FN" |  |
| fn:discussion | fn:HasLexicalUnit | fn:lu:discussion:exchange | "discussion" | "exchange" | "has lexical unit" |  | "FN" |  |
| fn:discussion | fn:HasLexicalUnit | fn:lu:discussion:meeting | "discussion" | "meeting" | "has lexical unit" |  | "FN" |  |
| fn:discussion | fn:HasLexicalUnit | fn:lu:discussion:conference | "discussion" | "conference" | "has lexical unit" |  | "FN" |  |
| fn:discussion | fn:HasLexicalUnit | fn:lu:discussion:parley | "discussion" | "parley" | "has lexical unit" |  | "FN" |  |
| fn:discussion | fn:HasLexicalUnit | fn:lu:discussion:parley | "discussion" | "parley" | "has lexical unit" |  | "FN" |  |
| fn:discussion | fn:HasLexicalUnit | fn:lu:discussion:interlocutor | "discussion" | "interlocutor" | "has lexical unit" |  | "FN" |  |
| fn:discussion | fn:HasLexicalUnit | fn:lu:discussion:discussant | "discussion" | "discussant" | "has lexical unit" |  | "FN" |  |
| fn:discussion | fn:HasLexicalUnit | fn:lu:discussion:negotiation | "discussion" | "negotiation" | "has lexical unit" |  | "FN" |  |
| fn:discussion | fn:HasLexicalUnit | fn:lu:discussion:negotiate | "discussion" | "negotiate" | "has lexical unit" |  | "FN" |  |
| fn:discussion | fn:HasLexicalUnit | fn:lu:discussion:talk | "discussion" | "talk" | "has lexical unit" |  | "FN" |  |
| fn:discussion | fn:HasLexicalUnit | fn:lu:discussion:consultation | "discussion" | "consultation" | "has lexical unit" |  | "FN" |  |
| fn:discussion | fn:HasLexicalUnit | fn:lu:discussion:talk_(to) | "discussion" | "talk (to)" | "has lexical unit" |  | "FN" |  |
| fn:discussion | fn:HasLexicalUnit | fn:lu:discussion:talk_over | "discussion" | "talk over" | "has lexical unit" |  | "FN" |  |
| fn:fe:interlocutor_1 | /r/HasPrerequisite | fn:fe:interlocutor_2 | "interlocutor 1" | "interlocutor 2" | "/r/has prerequisite" |  | "FN" |  |
| fn:discussion | /r/HasA | fn:fe:interlocutor_1 | "discussion" | "interlocutor 1" | "/r/has a" |  | "FN" |  |
| fn:discussion | /r/HasA | fn:fe:interlocutor_2 | "discussion" | "interlocutor 2" | "/r/has a" |  | "FN" |  |
| fn:discussion | /r/HasA | fn:fe:interlocutors | "discussion" | "interlocutors" | "/r/has a" |  | "FN" |  |
| fn:discussion | /r/HasA | fn:fe:topic | "discussion" | "topic" | "/r/has a" |  | "FN" |  |
| fn:discussion | /r/HasA | fn:fe:language | "discussion" | "language" | "/r/has a" |  | "FN" |  |
| fn:discussion | /r/HasA | fn:fe:amount_of_discussion | "discussion" | "amount of discussion" | "/r/has a" |  | "FN" |  |
| fn:discussion | /r/HasA | fn:fe:depictive | "discussion" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:discussion | /r/HasA | fn:fe:manner | "discussion" | "manner" | "/r/has a" |  | "FN" |  |
| fn:discussion | /r/HasA | fn:fe:means | "discussion" | "means" | "/r/has a" |  | "FN" |  |
| fn:discussion | /r/HasA | fn:fe:duration | "discussion" | "duration" | "/r/has a" |  | "FN" |  |
| fn:discussion | /r/HasA | fn:fe:purpose | "discussion" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:discussion | /r/HasA | fn:fe:time | "discussion" | "time" | "/r/has a" |  | "FN" |  |
| fn:discussion | /r/HasA | fn:fe:place | "discussion" | "place" | "/r/has a" |  | "FN" |  |
| fn:discussion | /r/HasA | fn:fe:means_of_communication | "discussion" | "means of communication" | "/r/has a" |  | "FN" |  |
| fn:discussion | /r/HasA | fn:fe:period_of_iterations | "discussion" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:discussion | /r/HasA | fn:fe:containing_event | "discussion" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:discussion | /r/HasA | fn:fe:frequency | "discussion" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:discussion | /r/HasA | fn:fe:domain | "discussion" | "domain" | "/r/has a" |  | "FN" |  |
| fn:departing | /r/UsedFor | fn:disembarking | "departing" | "disembarking" | "/r/used for" |  | "FN" |  |
| fn:ride_vehicle | /r/UsedFor | fn:disembarking | "ride vehicle" | "disembarking" | "/r/used for" |  | "FN" |  |
| fn:disembarking | fn:HasLexicalUnit | fn:lu:disembarking:disembark | "disembarking" | "disembark" | "has lexical unit" |  | "FN" |  |
| fn:disembarking | fn:HasLexicalUnit | fn:lu:disembarking:debark | "disembarking" | "debark" | "has lexical unit" |  | "FN" |  |
| fn:disembarking | fn:HasLexicalUnit | fn:lu:disembarking:deplane | "disembarking" | "deplane" | "has lexical unit" |  | "FN" |  |
| fn:disembarking | fn:HasLexicalUnit | fn:lu:disembarking:detrain | "disembarking" | "detrain" | "has lexical unit" |  | "FN" |  |
| fn:disembarking | fn:HasLexicalUnit | fn:lu:disembarking:dismount | "disembarking" | "dismount" | "has lexical unit" |  | "FN" |  |
| fn:disembarking | fn:HasLexicalUnit | fn:lu:disembarking:alight | "disembarking" | "alight" | "has lexical unit" |  | "FN" |  |
| fn:disembarking | fn:HasLexicalUnit | fn:lu:disembarking:debus | "disembarking" | "debus" | "has lexical unit" |  | "FN" |  |
| fn:disembarking | fn:HasLexicalUnit | fn:lu:disembarking:disembarkation | "disembarking" | "disembarkation" | "has lexical unit" |  | "FN" |  |
| fn:disembarking | fn:HasLexicalUnit | fn:lu:disembarking:get | "disembarking" | "get" | "has lexical unit" |  | "FN" |  |
| fn:disembarking | /r/HasA | fn:fe:traveller | "disembarking" | "traveller" | "/r/has a" |  | "FN" |  |
| fn:disembarking | /r/HasA | fn:fe:vehicle | "disembarking" | "vehicle" | "/r/has a" |  | "FN" |  |
| fn:disembarking | /r/HasA | fn:fe:manner | "disembarking" | "manner" | "/r/has a" |  | "FN" |  |
| fn:disembarking | /r/HasA | fn:fe:path | "disembarking" | "path" | "/r/has a" |  | "FN" |  |
| fn:disembarking | /r/HasA | fn:fe:duration_of_final_state | "disembarking" | "duration of final state" | "/r/has a" |  | "FN" |  |
| fn:disembarking | /r/HasA | fn:fe:depictive | "disembarking" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:disembarking | /r/HasA | fn:fe:time | "disembarking" | "time" | "/r/has a" |  | "FN" |  |
| fn:disembarking | /r/HasA | fn:fe:cotheme | "disembarking" | "cotheme" | "/r/has a" |  | "FN" |  |
| fn:disembarking | /r/HasA | fn:fe:purpose | "disembarking" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:disembarking | /r/HasA | fn:fe:place | "disembarking" | "place" | "/r/has a" |  | "FN" |  |
| fn:disembarking | /r/HasA | fn:fe:goal | "disembarking" | "goal" | "/r/has a" |  | "FN" |  |
| fn:disgraceful_situation | /r/IsA | fn:social_behavior_evaluation | "disgraceful situation" | "social behavior evaluation" | "/r/is a" |  | "FN" |  |
| fn:disgraceful_situation | fn:HasLexicalUnit | fn:lu:disgraceful_situation:disgraceful | "disgraceful situation" | "disgraceful" | "has lexical unit" |  | "FN" |  |
| fn:disgraceful_situation | fn:HasLexicalUnit | fn:lu:disgraceful_situation:shameful | "disgraceful situation" | "shameful" | "has lexical unit" |  | "FN" |  |
| fn:disgraceful_situation | /r/HasA | fn:fe:state_of_affairs | "disgraceful situation" | "state of affairs" | "/r/has a" |  | "FN" |  |
| fn:disgraceful_situation | /r/HasA | fn:fe:protagonist | "disgraceful situation" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:disgraceful_situation | /r/HasA | fn:fe:degree | "disgraceful situation" | "degree" | "/r/has a" |  | "FN" |  |
| fn:disgraceful_situation | /r/HasA | fn:fe:explanation | "disgraceful situation" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:disgraceful_situation | /r/HasA | fn:fe:judge | "disgraceful situation" | "judge" | "/r/has a" |  | "FN" |  |
| fn:dispersal | /r/IsA | fn:placing | "dispersal" | "placing" | "/r/is a" |  | "FN" |  |
| fn:placing | /r/SimilarTo | fn:dispersal | "placing" | "dispersal" | "/r/similar to" |  | "FN" |  |
| fn:dispersal | fn:HasLexicalUnit | fn:lu:dispersal:disperse | "dispersal" | "disperse" | "has lexical unit" |  | "FN" |  |
| fn:dispersal | fn:HasLexicalUnit | fn:lu:dispersal:dissolve | "dispersal" | "dissolve" | "has lexical unit" |  | "FN" |  |
| fn:dispersal | fn:HasLexicalUnit | fn:lu:dispersal:scatter | "dispersal" | "scatter" | "has lexical unit" |  | "FN" |  |
| fn:dispersal | fn:HasLexicalUnit | fn:lu:dispersal:dissolution | "dispersal" | "dissolution" | "has lexical unit" |  | "FN" |  |
| fn:dispersal | fn:HasLexicalUnit | fn:lu:dispersal:dispersal | "dispersal" | "dispersal" | "has lexical unit" |  | "FN" |  |
| fn:dispersal | fn:HasLexicalUnit | fn:lu:dispersal:dispersion | "dispersal" | "dispersion" | "has lexical unit" |  | "FN" |  |
| fn:dispersal | fn:HasLexicalUnit | fn:lu:dispersal:distribute | "dispersal" | "distribute" | "has lexical unit" |  | "FN" |  |
| fn:dispersal | fn:HasLexicalUnit | fn:lu:dispersal:distribution | "dispersal" | "distribution" | "has lexical unit" |  | "FN" |  |
| fn:dispersal | fn:HasLexicalUnit | fn:lu:dispersal:spread | "dispersal" | "spread" | "has lexical unit" |  | "FN" |  |
| fn:dispersal | fn:HasLexicalUnit | fn:lu:dispersal:strew | "dispersal" | "strew" | "has lexical unit" |  | "FN" |  |
| fn:dispersal | fn:HasLexicalUnit | fn:lu:dispersal:sprinkle | "dispersal" | "sprinkle" | "has lexical unit" |  | "FN" |  |
| fn:dispersal | fn:HasLexicalUnit | fn:lu:dispersal:disseminate | "dispersal" | "disseminate" | "has lexical unit" |  | "FN" |  |
| fn:dispersal | fn:HasLexicalUnit | fn:lu:dispersal:pass_on | "dispersal" | "pass on" | "has lexical unit" |  | "FN" |  |
| fn:dispersal | /r/HasA | fn:fe:agent | "dispersal" | "agent" | "/r/has a" |  | "FN" |  |
| fn:dispersal | /r/HasA | fn:fe:individuals | "dispersal" | "individuals" | "/r/has a" |  | "FN" |  |
| fn:dispersal | /r/HasA | fn:fe:source | "dispersal" | "source" | "/r/has a" |  | "FN" |  |
| fn:dispersal | /r/HasA | fn:fe:goal_area | "dispersal" | "goal area" | "/r/has a" |  | "FN" |  |
| fn:dispersal | /r/HasA | fn:fe:cause | "dispersal" | "cause" | "/r/has a" |  | "FN" |  |
| fn:dispersal | /r/HasA | fn:fe:manner | "dispersal" | "manner" | "/r/has a" |  | "FN" |  |
| fn:dispersal | /r/HasA | fn:fe:time | "dispersal" | "time" | "/r/has a" |  | "FN" |  |
| fn:dispersal | /r/HasA | fn:fe:means | "dispersal" | "means" | "/r/has a" |  | "FN" |  |
| fn:dispersal | /r/HasA | fn:fe:result | "dispersal" | "result" | "/r/has a" |  | "FN" |  |
| fn:dispersal | /r/HasA | fn:fe:path | "dispersal" | "path" | "/r/has a" |  | "FN" |  |
| fn:dispersal | /r/HasA | fn:fe:place | "dispersal" | "place" | "/r/has a" |  | "FN" |  |
| fn:dispersal | /r/HasA | fn:fe:explanation | "dispersal" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:dispersal | /r/HasA | fn:fe:distance | "dispersal" | "distance" | "/r/has a" |  | "FN" |  |
| fn:dispersal | /r/HasA | fn:fe:speed | "dispersal" | "speed" | "/r/has a" |  | "FN" |  |
| fn:distant_operated_ied | /r/IsA | fn:improvised_explosive_device | "distant operated ied" | "improvised explosive device" | "/r/is a" |  | "FN" |  |
| fn:distant_operated_ied | /r/UsedFor | fn:firing_point | "distant operated ied" | "firing point" | "/r/used for" |  | "FN" |  |
| fn:distant_operated_ied | fn:HasLexicalUnit | fn:lu:distant_operated_ied:rcied | "distant operated ied" | "rcied" | "has lexical unit" |  | "FN" |  |
| fn:distant_operated_ied | fn:HasLexicalUnit | fn:lu:distant_operated_ied:cwied | "distant operated ied" | "cwied" | "has lexical unit" |  | "FN" |  |
| fn:distant_operated_ied | fn:HasLexicalUnit | fn:lu:distant_operated_ied:command_ied | "distant operated ied" | "command ied" | "has lexical unit" |  | "FN" |  |
| fn:fe:bomb | /r/IsA | fn:st:artifact | "bomb" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:distant_operated_ied | /r/HasA | fn:fe:bomb | "distant operated ied" | "bomb" | "/r/has a" |  | "FN" |  |
| fn:distant_operated_ied | /r/HasA | fn:fe:use | "distant operated ied" | "use" | "/r/has a" |  | "FN" |  |
| fn:distant_operated_ied | /r/HasA | fn:fe:type | "distant operated ied" | "type" | "/r/has a" |  | "FN" |  |
| fn:distant_operated_ied | /r/HasA | fn:fe:material | "distant operated ied" | "material" | "/r/has a" |  | "FN" |  |
| fn:distant_operated_ied | /r/HasA | fn:fe:detonator | "distant operated ied" | "detonator" | "/r/has a" |  | "FN" |  |
| fn:distant_operated_ied | /r/HasA | fn:fe:part | "distant operated ied" | "part" | "/r/has a" |  | "FN" |  |
| fn:distant_operated_ied | /r/HasA | fn:fe:name | "distant operated ied" | "name" | "/r/has a" |  | "FN" |  |
| fn:distant_operated_ied | /r/HasA | fn:fe:time_of_creation | "distant operated ied" | "time of creation" | "/r/has a" |  | "FN" |  |
| fn:distant_operated_ied | /r/HasA | fn:fe:creator | "distant operated ied" | "creator" | "/r/has a" |  | "FN" |  |
| fn:distant_operated_ied | /r/HasA | fn:fe:descriptor | "distant operated ied" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:distant_operated_ied | /r/HasA | fn:fe:target | "distant operated ied" | "target" | "/r/has a" |  | "FN" |  |
| fn:similarity | /r/UsedFor | fn:distinctiveness | "similarity" | "distinctiveness" | "/r/used for" |  | "FN" |  |
| fn:distinctiveness | fn:HasLexicalUnit | fn:lu:distinctiveness:characteristic | "distinctiveness" | "characteristic" | "has lexical unit" |  | "FN" |  |
| fn:distinctiveness | fn:HasLexicalUnit | fn:lu:distinctiveness:trademark | "distinctiveness" | "trademark" | "has lexical unit" |  | "FN" |  |
| fn:distinctiveness | fn:HasLexicalUnit | fn:lu:distinctiveness:signature | "distinctiveness" | "signature" | "has lexical unit" |  | "FN" |  |
| fn:distinctiveness | fn:HasLexicalUnit | fn:lu:distinctiveness:distinctive | "distinctiveness" | "distinctive" | "has lexical unit" |  | "FN" |  |
| fn:distinctiveness | fn:HasLexicalUnit | fn:lu:distinctiveness:distinct | "distinctiveness" | "distinct" | "has lexical unit" |  | "FN" |  |
| fn:distinctiveness | fn:HasLexicalUnit | fn:lu:distinctiveness:characterize | "distinctiveness" | "characterize" | "has lexical unit" |  | "FN" |  |
| fn:distinctiveness | fn:HasLexicalUnit | fn:lu:distinctiveness:signature | "distinctiveness" | "signature" | "has lexical unit" |  | "FN" |  |
| fn:distinctiveness | fn:HasLexicalUnit | fn:lu:distinctiveness:trademark | "distinctiveness" | "trademark" | "has lexical unit" |  | "FN" |  |
| fn:distinctiveness | fn:HasLexicalUnit | fn:lu:distinctiveness:aspect | "distinctiveness" | "aspect" | "has lexical unit" |  | "FN" |  |
| fn:distinctiveness | fn:HasLexicalUnit | fn:lu:distinctiveness:marked | "distinctiveness" | "marked" | "has lexical unit" |  | "FN" |  |
| fn:distinctiveness | /r/HasA | fn:fe:feature | "distinctiveness" | "feature" | "/r/has a" |  | "FN" |  |
| fn:distinctiveness | /r/HasA | fn:fe:entity | "distinctiveness" | "entity" | "/r/has a" |  | "FN" |  |
| fn:distinctiveness | /r/HasA | fn:fe:degree | "distinctiveness" | "degree" | "/r/has a" |  | "FN" |  |
| fn:distinctiveness | /r/HasA | fn:fe:duration | "distinctiveness" | "duration" | "/r/has a" |  | "FN" |  |
| fn:abounding_with | /r/IsA | fn:distributed_abundance | "abounding with" | "distributed abundance" | "/r/is a" |  | "FN" |  |
| fn:distributed_position | /r/IsA | fn:distributed_abundance | "distributed position" | "distributed abundance" | "/r/is a" |  | "FN" |  |
| fn:distributed_abundance | /r/HasA | fn:fe:theme | "distributed abundance" | "theme" | "/r/has a" |  | "FN" |  |
| fn:distributed_abundance | /r/HasA | fn:fe:location | "distributed abundance" | "location" | "/r/has a" |  | "FN" |  |
| fn:distributed_abundance | /r/HasA | fn:fe:degree | "distributed abundance" | "degree" | "/r/has a" |  | "FN" |  |
| fn:distributed_abundance | /r/HasA | fn:fe:time | "distributed abundance" | "time" | "/r/has a" |  | "FN" |  |
| fn:distributed_position | /r/IsA | fn:locative_relation | "distributed position" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:distributed_position | /r/RelatedTo | fn:abounding_with | "distributed position" | "abounding with" | "/r/related to" |  | "FN" |  |
| fn:distributed_position | /r/RelatedTo | fn:filling | "distributed position" | "filling" | "/r/related to" |  | "FN" |  |
| fn:surrounding | /r/RelatedTo | fn:distributed_position | "surrounding" | "distributed position" | "/r/related to" |  | "FN" |  |
| fn:distributed_position | /r/IsA | fn:distributed_abundance | "distributed position" | "distributed abundance" | "/r/is a" |  | "FN" |  |
| fn:distributed_position | fn:HasLexicalUnit | fn:lu:distributed_position:adorn | "distributed position" | "adorn" | "has lexical unit" |  | "FN" |  |
| fn:distributed_position | fn:HasLexicalUnit | fn:lu:distributed_position:blanket | "distributed position" | "blanket" | "has lexical unit" |  | "FN" |  |
| fn:distributed_position | fn:HasLexicalUnit | fn:lu:distributed_position:cloak | "distributed position" | "cloak" | "has lexical unit" |  | "FN" |  |
| fn:distributed_position | fn:HasLexicalUnit | fn:lu:distributed_position:coat | "distributed position" | "coat" | "has lexical unit" |  | "FN" |  |
| fn:distributed_position | fn:HasLexicalUnit | fn:lu:distributed_position:cover | "distributed position" | "cover" | "has lexical unit" |  | "FN" |  |
| fn:distributed_position | fn:HasLexicalUnit | fn:lu:distributed_position:deck | "distributed position" | "deck" | "has lexical unit" |  | "FN" |  |
| fn:distributed_position | fn:HasLexicalUnit | fn:lu:distributed_position:decorate | "distributed position" | "decorate" | "has lexical unit" |  | "FN" |  |
| fn:distributed_position | fn:HasLexicalUnit | fn:lu:distributed_position:envelop | "distributed position" | "envelop" | "has lexical unit" |  | "FN" |  |
| fn:distributed_position | fn:HasLexicalUnit | fn:lu:distributed_position:festoon | "distributed position" | "festoon" | "has lexical unit" |  | "FN" |  |
| fn:distributed_position | fn:HasLexicalUnit | fn:lu:distributed_position:fill | "distributed position" | "fill" | "has lexical unit" |  | "FN" |  |
| fn:distributed_position | fn:HasLexicalUnit | fn:lu:distributed_position:film | "distributed position" | "film" | "has lexical unit" |  | "FN" |  |
| fn:distributed_position | fn:HasLexicalUnit | fn:lu:distributed_position:line | "distributed position" | "line" | "has lexical unit" |  | "FN" |  |
| fn:distributed_position | fn:HasLexicalUnit | fn:lu:distributed_position:pave | "distributed position" | "pave" | "has lexical unit" |  | "FN" |  |
| fn:distributed_position | fn:HasLexicalUnit | fn:lu:distributed_position:wreathe | "distributed position" | "wreathe" | "has lexical unit" |  | "FN" |  |
| fn:distributed_position | fn:HasLexicalUnit | fn:lu:distributed_position:dot | "distributed position" | "dot" | "has lexical unit" |  | "FN" |  |
| fn:distributed_position | fn:HasLexicalUnit | fn:lu:distributed_position:stud | "distributed position" | "stud" | "has lexical unit" |  | "FN" |  |
| fn:distributed_position | fn:HasLexicalUnit | fn:lu:distributed_position:garnish | "distributed position" | "garnish" | "has lexical unit" |  | "FN" |  |
| fn:distributed_position | fn:HasLexicalUnit | fn:lu:distributed_position:encrust | "distributed position" | "encrust" | "has lexical unit" |  | "FN" |  |
| fn:distributed_position | fn:HasLexicalUnit | fn:lu:distributed_position:litter | "distributed position" | "litter" | "has lexical unit" |  | "FN" |  |
| fn:distributed_position | fn:HasLexicalUnit | fn:lu:distributed_position:all_over | "distributed position" | "all over" | "has lexical unit" |  | "FN" |  |
| fn:distributed_position | fn:HasLexicalUnit | fn:lu:distributed_position:across | "distributed position" | "across" | "has lexical unit" |  | "FN" |  |
| fn:distributed_position | fn:HasLexicalUnit | fn:lu:distributed_position:over | "distributed position" | "over" | "has lexical unit" |  | "FN" |  |
| fn:distributed_position | fn:HasLexicalUnit | fn:lu:distributed_position:around | "distributed position" | "around" | "has lexical unit" |  | "FN" |  |
| fn:distributed_position | /r/HasA | fn:fe:theme | "distributed position" | "theme" | "/r/has a" |  | "FN" |  |
| fn:distributed_position | /r/HasA | fn:fe:location | "distributed position" | "location" | "/r/has a" |  | "FN" |  |
| fn:distributed_position | /r/HasA | fn:fe:subregion | "distributed position" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:distributed_position | /r/HasA | fn:fe:time | "distributed position" | "time" | "/r/has a" |  | "FN" |  |
| fn:distributed_position | /r/HasA | fn:fe:deixis | "distributed position" | "deixis" | "/r/has a" |  | "FN" |  |
| fn:distributed_position | /r/HasA | fn:fe:region_quantification | "distributed position" | "region quantification" | "/r/has a" |  | "FN" |  |
| fn:distributed_position | /r/HasA | fn:fe:temporal_profile | "distributed position" | "temporal profile" | "/r/has a" |  | "FN" |  |
| fn:diversity | /r/IsA | fn:similarity | "diversity" | "similarity" | "/r/is a" |  | "FN" |  |
| fn:diversity | /r/UsedFor | fn:delimitation_of_diversity | "diversity" | "delimitation of diversity" | "/r/used for" |  | "FN" |  |
| fn:type | /r/UsedFor | fn:diversity | "type" | "diversity" | "/r/used for" |  | "FN" |  |
| fn:diversity | fn:HasLexicalUnit | fn:lu:diversity:homogeneous | "diversity" | "homogeneous" | "has lexical unit" |  | "FN" |  |
| fn:diversity | fn:HasLexicalUnit | fn:lu:diversity:diversity | "diversity" | "diversity" | "has lexical unit" |  | "FN" |  |
| fn:diversity | fn:HasLexicalUnit | fn:lu:diversity:variety | "diversity" | "variety" | "has lexical unit" |  | "FN" |  |
| fn:diversity | fn:HasLexicalUnit | fn:lu:diversity:diverse | "diversity" | "diverse" | "has lexical unit" |  | "FN" |  |
| fn:diversity | fn:HasLexicalUnit | fn:lu:diversity:homogeneity | "diversity" | "homogeneity" | "has lexical unit" |  | "FN" |  |
| fn:diversity | fn:HasLexicalUnit | fn:lu:diversity:various | "diversity" | "various" | "has lexical unit" |  | "FN" |  |
| fn:diversity | fn:HasLexicalUnit | fn:lu:diversity:range | "diversity" | "range" | "has lexical unit" |  | "FN" |  |
| fn:diversity | fn:HasLexicalUnit | fn:lu:diversity:broad | "diversity" | "broad" | "has lexical unit" |  | "FN" |  |
| fn:diversity | fn:HasLexicalUnit | fn:lu:diversity:breadth | "diversity" | "breadth" | "has lexical unit" |  | "FN" |  |
| fn:diversity | fn:HasLexicalUnit | fn:lu:diversity:varied | "diversity" | "varied" | "has lexical unit" |  | "FN" |  |
| fn:diversity | fn:HasLexicalUnit | fn:lu:diversity:medley | "diversity" | "medley" | "has lexical unit" |  | "FN" |  |
| fn:diversity | fn:HasLexicalUnit | fn:lu:diversity:miscellany | "diversity" | "miscellany" | "has lexical unit" |  | "FN" |  |
| fn:diversity | fn:HasLexicalUnit | fn:lu:diversity:array | "diversity" | "array" | "has lexical unit" |  | "FN" |  |
| fn:diversity | fn:HasLexicalUnit | fn:lu:diversity:uniform | "diversity" | "uniform" | "has lexical unit" |  | "FN" |  |
| fn:diversity | fn:HasLexicalUnit | fn:lu:diversity:uniformity | "diversity" | "uniformity" | "has lexical unit" |  | "FN" |  |
| fn:diversity | fn:HasLexicalUnit | fn:lu:diversity:assortment | "diversity" | "assortment" | "has lexical unit" |  | "FN" |  |
| fn:diversity | fn:HasLexicalUnit | fn:lu:diversity:assorted | "diversity" | "assorted" | "has lexical unit" |  | "FN" |  |
| fn:diversity | fn:HasLexicalUnit | fn:lu:diversity:multifarious | "diversity" | "multifarious" | "has lexical unit" |  | "FN" |  |
| fn:diversity | fn:HasLexicalUnit | fn:lu:diversity:diverseness | "diversity" | "diverseness" | "has lexical unit" |  | "FN" |  |
| fn:diversity | fn:HasLexicalUnit | fn:lu:diversity:heterogeneous | "diversity" | "heterogeneous" | "has lexical unit" |  | "FN" |  |
| fn:diversity | fn:HasLexicalUnit | fn:lu:diversity:heterogeneity | "diversity" | "heterogeneity" | "has lexical unit" |  | "FN" |  |
| fn:diversity | fn:HasLexicalUnit | fn:lu:diversity:mixed_bag | "diversity" | "mixed bag" | "has lexical unit" |  | "FN" |  |
| fn:diversity | fn:HasLexicalUnit | fn:lu:diversity:multifariousness | "diversity" | "multifariousness" | "has lexical unit" |  | "FN" |  |
| fn:diversity | fn:HasLexicalUnit | fn:lu:diversity:manifold | "diversity" | "manifold" | "has lexical unit" |  | "FN" |  |
| fn:diversity | fn:HasLexicalUnit | fn:lu:diversity:multiplicity | "diversity" | "multiplicity" | "has lexical unit" |  | "FN" |  |
| fn:diversity | fn:HasLexicalUnit | fn:lu:diversity:variability | "diversity" | "variability" | "has lexical unit" |  | "FN" |  |
| fn:diversity | fn:HasLexicalUnit | fn:lu:diversity:scope | "diversity" | "scope" | "has lexical unit" |  | "FN" |  |
| fn:diversity | /r/HasA | fn:fe:group | "diversity" | "group" | "/r/has a" |  | "FN" |  |
| fn:diversity | /r/HasA | fn:fe:dimension | "diversity" | "dimension" | "/r/has a" |  | "FN" |  |
| fn:diversity | /r/HasA | fn:fe:degree | "diversity" | "degree" | "/r/has a" |  | "FN" |  |
| fn:diversity | /r/HasA | fn:fe:time | "diversity" | "time" | "/r/has a" |  | "FN" |  |
| fn:diversity | /r/HasA | fn:fe:place | "diversity" | "place" | "/r/has a" |  | "FN" |  |
| fn:diversity | /r/HasA | fn:fe:manner | "diversity" | "manner" | "/r/has a" |  | "FN" |  |
| fn:diversity | /r/HasA | fn:fe:explanation | "diversity" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:diversity | /r/HasA | fn:fe:depictive | "diversity" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:documents | /r/IsA | fn:text | "documents" | "text" | "/r/is a" |  | "FN" |  |
| fn:documents | /r/UsedFor | fn:terms_of_agreement | "documents" | "terms of agreement" | "/r/used for" |  | "FN" |  |
| fn:obligation_scenario | /r/UsedFor | fn:documents | "obligation scenario" | "documents" | "/r/used for" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:visa | "documents" | "visa" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:passport | "documents" | "passport" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:subpoena | "documents" | "subpoena" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:warrant | "documents" | "warrant" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:certificate | "documents" | "certificate" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:papers | "documents" | "papers" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:license | "documents" | "license" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:summons | "documents" | "summons" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:diploma | "documents" | "diploma" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:deed | "documents" | "deed" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:lease | "documents" | "lease" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:agreement | "documents" | "agreement" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:treaty | "documents" | "treaty" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:charter | "documents" | "charter" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:authorization | "documents" | "authorization" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:deposition | "documents" | "deposition" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:brief | "documents" | "brief" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:writ | "documents" | "writ" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:affidavit | "documents" | "affidavit" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:will | "documents" | "will" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:testimony | "documents" | "testimony" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:testament | "documents" | "testament" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:ruling | "documents" | "ruling" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:finding | "documents" | "finding" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:opinion | "documents" | "opinion" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:title | "documents" | "title" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:orders | "documents" | "orders" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:contract | "documents" | "contract" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:permit | "documents" | "permit" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:document | "documents" | "document" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:contractual | "documents" | "contractual" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:accord | "documents" | "accord" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:confirmation | "documents" | "confirmation" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:identification | "documents" | "identification" | "has lexical unit" |  | "FN" |  |
| fn:documents | fn:HasLexicalUnit | fn:lu:documents:business_card | "documents" | "business card" | "has lexical unit" |  | "FN" |  |
| fn:documents | /r/HasA | fn:fe:bearer | "documents" | "bearer" | "/r/has a" |  | "FN" |  |
| fn:documents | /r/HasA | fn:fe:issuer | "documents" | "issuer" | "/r/has a" |  | "FN" |  |
| fn:documents | /r/HasA | fn:fe:obligation | "documents" | "obligation" | "/r/has a" |  | "FN" |  |
| fn:fe:right | /r/RelatedTo | fn:fe:obligation | "right" | "obligation" | "/r/related to" |  | "FN" |  |
| fn:documents | /r/HasA | fn:fe:right | "documents" | "right" | "/r/has a" |  | "FN" |  |
| fn:fe:status | /r/RelatedTo | fn:fe:obligation | "status" | "obligation" | "/r/related to" |  | "FN" |  |
| fn:documents | /r/HasA | fn:fe:status | "documents" | "status" | "/r/has a" |  | "FN" |  |
| fn:documents | /r/HasA | fn:fe:specification | "documents" | "specification" | "/r/has a" |  | "FN" |  |
| fn:documents | /r/HasA | fn:fe:document | "documents" | "document" | "/r/has a" |  | "FN" |  |
| fn:documents | /r/HasA | fn:fe:medium | "documents" | "medium" | "/r/has a" |  | "FN" |  |
| fn:documents | /r/HasA | fn:fe:descriptor | "documents" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:dodging | /r/IsA | fn:avoiding | "dodging" | "avoiding" | "/r/is a" |  | "FN" |  |
| fn:avoiding | /r/SimilarTo | fn:dodging | "avoiding" | "dodging" | "/r/similar to" |  | "FN" |  |
| fn:evading | /r/SimilarTo | fn:dodging | "evading" | "dodging" | "/r/similar to" |  | "FN" |  |
| fn:dodging | fn:HasLexicalUnit | fn:lu:dodging:dodge | "dodging" | "dodge" | "has lexical unit" |  | "FN" |  |
| fn:dodging | fn:HasLexicalUnit | fn:lu:dodging:dodge | "dodging" | "dodge" | "has lexical unit" |  | "FN" |  |
| fn:dodging | fn:HasLexicalUnit | fn:lu:dodging:sidestep | "dodging" | "sidestep" | "has lexical unit" |  | "FN" |  |
| fn:dodging | fn:HasLexicalUnit | fn:lu:dodging:sidestep | "dodging" | "sidestep" | "has lexical unit" |  | "FN" |  |
| fn:fe:dodger | /r/IsA | fn:st:sentient | "dodger" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:dodging | /r/HasA | fn:fe:dodger | "dodging" | "dodger" | "/r/has a" |  | "FN" |  |
| fn:dodging | /r/HasA | fn:fe:bad_entity | "dodging" | "bad entity" | "/r/has a" |  | "FN" |  |
| fn:dodging | /r/HasA | fn:fe:degree | "dodging" | "degree" | "/r/has a" |  | "FN" |  |
| fn:dodging | /r/HasA | fn:fe:manner | "dodging" | "manner" | "/r/has a" |  | "FN" |  |
| fn:dodging | /r/HasA | fn:fe:place | "dodging" | "place" | "/r/has a" |  | "FN" |  |
| fn:dodging | /r/HasA | fn:fe:time | "dodging" | "time" | "/r/has a" |  | "FN" |  |
| fn:dodging | /r/HasA | fn:fe:purpose | "dodging" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:dodging | /r/HasA | fn:fe:explanation | "dodging" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:dodging | /r/HasA | fn:fe:means | "dodging" | "means" | "/r/has a" |  | "FN" |  |
| fn:domain | fn:HasLexicalUnit | fn:lu:domain:legally | "domain" | "legally" | "has lexical unit" |  | "FN" |  |
| fn:domain | fn:HasLexicalUnit | fn:lu:domain:economically | "domain" | "economically" | "has lexical unit" |  | "FN" |  |
| fn:domain | fn:HasLexicalUnit | fn:lu:domain:emotionally | "domain" | "emotionally" | "has lexical unit" |  | "FN" |  |
| fn:domain | fn:HasLexicalUnit | fn:lu:domain:geographically | "domain" | "geographically" | "has lexical unit" |  | "FN" |  |
| fn:domain | fn:HasLexicalUnit | fn:lu:domain:psychologically | "domain" | "psychologically" | "has lexical unit" |  | "FN" |  |
| fn:domain | fn:HasLexicalUnit | fn:lu:domain:historically | "domain" | "historically" | "has lexical unit" |  | "FN" |  |
| fn:domain | fn:HasLexicalUnit | fn:lu:domain:socially | "domain" | "socially" | "has lexical unit" |  | "FN" |  |
| fn:domain | fn:HasLexicalUnit | fn:lu:domain:culturally | "domain" | "culturally" | "has lexical unit" |  | "FN" |  |
| fn:domain | fn:HasLexicalUnit | fn:lu:domain:financially | "domain" | "financially" | "has lexical unit" |  | "FN" |  |
| fn:domain | fn:HasLexicalUnit | fn:lu:domain:in_terms | "domain" | "in terms" | "has lexical unit" |  | "FN" |  |
| fn:domain | /r/HasA | fn:fe:predicate | "domain" | "predicate" | "/r/has a" |  | "FN" |  |
| fn:domain | /r/HasA | fn:fe:domain | "domain" | "domain" | "/r/has a" |  | "FN" |  |
| fn:domain | /r/HasA | fn:fe:explanation | "domain" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:dominate_competitor | /r/IsA | fn:being_in_control | "dominate competitor" | "being in control" | "/r/is a" |  | "FN" |  |
| fn:dominate_competitor | /r/IsA | fn:domination | "dominate competitor" | "domination" | "/r/is a" |  | "FN" |  |
| fn:dominate_competitor | fn:HasLexicalUnit | fn:lu:dominate_competitor:dominate | "dominate competitor" | "dominate" | "has lexical unit" |  | "FN" |  |
| fn:dominate_competitor | fn:HasLexicalUnit | fn:lu:dominate_competitor:domination | "dominate competitor" | "domination" | "has lexical unit" |  | "FN" |  |
| fn:dominate_competitor | fn:HasLexicalUnit | fn:lu:dominate_competitor:dominant | "dominate competitor" | "dominant" | "has lexical unit" |  | "FN" |  |
| fn:dominate_competitor | fn:HasLexicalUnit | fn:lu:dominate_competitor:strongman | "dominate competitor" | "strongman" | "has lexical unit" |  | "FN" |  |
| fn:dominate_competitor | /r/HasA | fn:fe:agent | "dominate competitor" | "agent" | "/r/has a" |  | "FN" |  |
| fn:dominate_competitor | /r/HasA | fn:fe:patient | "dominate competitor" | "patient" | "/r/has a" |  | "FN" |  |
| fn:dominate_competitor | /r/HasA | fn:fe:situation | "dominate competitor" | "situation" | "/r/has a" |  | "FN" |  |
| fn:dominate_competitor | /r/HasA | fn:fe:duration | "dominate competitor" | "duration" | "/r/has a" |  | "FN" |  |
| fn:dominate_competitor | /r/HasA | fn:fe:manner | "dominate competitor" | "manner" | "/r/has a" |  | "FN" |  |
| fn:dominate_competitor | /r/HasA | fn:fe:place | "dominate competitor" | "place" | "/r/has a" |  | "FN" |  |
| fn:dominate_competitor | /r/HasA | fn:fe:time | "dominate competitor" | "time" | "/r/has a" |  | "FN" |  |
| fn:dominate_competitor | /r/HasA | fn:fe:degree | "dominate competitor" | "degree" | "/r/has a" |  | "FN" |  |
| fn:first_rank | /r/UsedFor | fn:dominate_situation | "first rank" | "dominate situation" | "/r/used for" |  | "FN" |  |
| fn:dominate_situation | /r/IsA | fn:domination | "dominate situation" | "domination" | "/r/is a" |  | "FN" |  |
| fn:dominate_situation | fn:HasLexicalUnit | fn:lu:dominate_situation:dominate | "dominate situation" | "dominate" | "has lexical unit" |  | "FN" |  |
| fn:dominate_situation | fn:HasLexicalUnit | fn:lu:dominate_situation:domination | "dominate situation" | "domination" | "has lexical unit" |  | "FN" |  |
| fn:dominate_situation | fn:HasLexicalUnit | fn:lu:dominate_situation:dominant | "dominate situation" | "dominant" | "has lexical unit" |  | "FN" |  |
| fn:dominate_situation | fn:HasLexicalUnit | fn:lu:dominate_situation:predominate | "dominate situation" | "predominate" | "has lexical unit" |  | "FN" |  |
| fn:dominate_situation | fn:HasLexicalUnit | fn:lu:dominate_situation:rule | "dominate situation" | "rule" | "has lexical unit" |  | "FN" |  |
| fn:dominate_situation | /r/HasA | fn:fe:agent | "dominate situation" | "agent" | "/r/has a" |  | "FN" |  |
| fn:dominate_situation | /r/HasA | fn:fe:situation | "dominate situation" | "situation" | "/r/has a" |  | "FN" |  |
| fn:dominate_situation | /r/HasA | fn:fe:time | "dominate situation" | "time" | "/r/has a" |  | "FN" |  |
| fn:dominate_situation | /r/HasA | fn:fe:duration | "dominate situation" | "duration" | "/r/has a" |  | "FN" |  |
| fn:dominate_situation | /r/HasA | fn:fe:place | "dominate situation" | "place" | "/r/has a" |  | "FN" |  |
| fn:dominate_situation | /r/HasA | fn:fe:manner | "dominate situation" | "manner" | "/r/has a" |  | "FN" |  |
| fn:dominate_situation | /r/HasA | fn:fe:degree | "dominate situation" | "degree" | "/r/has a" |  | "FN" |  |
| fn:dominate_competitor | /r/IsA | fn:domination | "dominate competitor" | "domination" | "/r/is a" |  | "FN" |  |
| fn:dominate_situation | /r/IsA | fn:domination | "dominate situation" | "domination" | "/r/is a" |  | "FN" |  |
| fn:domination | /r/HasA | fn:fe:agent | "domination" | "agent" | "/r/has a" |  | "FN" |  |
| fn:domination | /r/HasA | fn:fe:situation | "domination" | "situation" | "/r/has a" |  | "FN" |  |
| fn:domination | /r/HasA | fn:fe:competitor | "domination" | "competitor" | "/r/has a" |  | "FN" |  |
| fn:domination | /r/HasA | fn:fe:time | "domination" | "time" | "/r/has a" |  | "FN" |  |
| fn:domination | /r/HasA | fn:fe:place | "domination" | "place" | "/r/has a" |  | "FN" |  |
| fn:domination | /r/HasA | fn:fe:manner | "domination" | "manner" | "/r/has a" |  | "FN" |  |
| fn:domination | /r/HasA | fn:fe:duration | "domination" | "duration" | "/r/has a" |  | "FN" |  |
| fn:domination | /r/HasA | fn:fe:degree | "domination" | "degree" | "/r/has a" |  | "FN" |  |
| fn:expansion | /r/UsedFor | fn:dough_rising | "expansion" | "dough rising" | "/r/used for" |  | "FN" |  |
| fn:dough_rising | fn:HasLexicalUnit | fn:lu:dough_rising:rise | "dough rising" | "rise" | "has lexical unit" |  | "FN" |  |
| fn:dough_rising | fn:HasLexicalUnit | fn:lu:dough_rising:prove | "dough rising" | "prove" | "has lexical unit" |  | "FN" |  |
| fn:dough_rising | /r/HasA | fn:fe:dough | "dough rising" | "dough" | "/r/has a" |  | "FN" |  |
| fn:fe:duration_of_activity | /r/IsA | fn:st:duration | "duration of activity" | "duration" | "/r/is a" |  | "FN" |  |
| fn:dough_rising | /r/HasA | fn:fe:duration_of_activity | "dough rising" | "duration of activity" | "/r/has a" |  | "FN" |  |
| fn:dough_rising | /r/HasA | fn:fe:time | "dough rising" | "time" | "/r/has a" |  | "FN" |  |
| fn:dough_rising | /r/HasA | fn:fe:speed | "dough rising" | "speed" | "/r/has a" |  | "FN" |  |
| fn:dough_rising | /r/HasA | fn:fe:manner | "dough rising" | "manner" | "/r/has a" |  | "FN" |  |
| fn:dough_rising | /r/HasA | fn:fe:circumstances | "dough rising" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:dough_rising | /r/HasA | fn:fe:size_change | "dough rising" | "size change" | "/r/has a" |  | "FN" |  |
| fn:dough_rising | /r/HasA | fn:fe:explanation | "dough rising" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:downing | /r/IsA | fn:transitive_action | "downing" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:downing | fn:HasLexicalUnit | fn:lu:downing:down | "downing" | "down" | "has lexical unit" |  | "FN" |  |
| fn:downing | fn:HasLexicalUnit | fn:lu:downing:shoot_down | "downing" | "shoot down" | "has lexical unit" |  | "FN" |  |
| fn:downing | fn:HasLexicalUnit | fn:lu:downing:downing | "downing" | "downing" | "has lexical unit" |  | "FN" |  |
| fn:downing | /r/HasA | fn:fe:agent | "downing" | "agent" | "/r/has a" |  | "FN" |  |
| fn:downing | /r/HasA | fn:fe:patient | "downing" | "patient" | "/r/has a" |  | "FN" |  |
| fn:downing | /r/HasA | fn:fe:depictive | "downing" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:downing | /r/HasA | fn:fe:result | "downing" | "result" | "/r/has a" |  | "FN" |  |
| fn:downing | /r/HasA | fn:fe:means | "downing" | "means" | "/r/has a" |  | "FN" |  |
| fn:downing | /r/HasA | fn:fe:manner | "downing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:downing | /r/HasA | fn:fe:time | "downing" | "time" | "/r/has a" |  | "FN" |  |
| fn:downing | /r/HasA | fn:fe:place | "downing" | "place" | "/r/has a" |  | "FN" |  |
| fn:downing | /r/HasA | fn:fe:cause | "downing" | "cause" | "/r/has a" |  | "FN" |  |
| fn:fe:instrument | /r/IsA | fn:st:artifact | "instrument" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:downing | /r/HasA | fn:fe:instrument | "downing" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:accoutrements | /r/UsedFor | fn:dressing | "accoutrements" | "dressing" | "/r/used for" |  | "FN" |  |
| fn:clothing | /r/UsedFor | fn:dressing | "clothing" | "dressing" | "/r/used for" |  | "FN" |  |
| fn:placing | /r/UsedFor | fn:dressing | "placing" | "dressing" | "/r/used for" |  | "FN" |  |
| fn:dressing | fn:HasLexicalUnit | fn:lu:dressing:don | "dressing" | "don" | "has lexical unit" |  | "FN" |  |
| fn:dressing | fn:HasLexicalUnit | fn:lu:dressing:put_on | "dressing" | "put on" | "has lexical unit" |  | "FN" |  |
| fn:dressing | fn:HasLexicalUnit | fn:lu:dressing:slip_on | "dressing" | "slip on" | "has lexical unit" |  | "FN" |  |
| fn:dressing | fn:HasLexicalUnit | fn:lu:dressing:pull_on | "dressing" | "pull on" | "has lexical unit" |  | "FN" |  |
| fn:dressing | fn:HasLexicalUnit | fn:lu:dressing:dress | "dressing" | "dress" | "has lexical unit" |  | "FN" |  |
| fn:dressing | fn:HasLexicalUnit | fn:lu:dressing:dress_up | "dressing" | "dress up" | "has lexical unit" |  | "FN" |  |
| fn:dressing | fn:HasLexicalUnit | fn:lu:dressing:get_on | "dressing" | "get on" | "has lexical unit" |  | "FN" |  |
| fn:dressing | fn:HasLexicalUnit | fn:lu:dressing:throw_on | "dressing" | "throw on" | "has lexical unit" |  | "FN" |  |
| fn:dressing | /r/HasA | fn:fe:wearer | "dressing" | "wearer" | "/r/has a" |  | "FN" |  |
| fn:dressing | /r/HasA | fn:fe:clothing | "dressing" | "clothing" | "/r/has a" |  | "FN" |  |
| fn:fe:body_location | /r/IsA | fn:st:goal | "body location" | "goal" | "/r/is a" |  | "FN" |  |
| fn:dressing | /r/HasA | fn:fe:body_location | "dressing" | "body location" | "/r/has a" |  | "FN" |  |
| fn:dressing | /r/HasA | fn:fe:manner | "dressing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:dressing | /r/HasA | fn:fe:depictive | "dressing" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:dressing | /r/HasA | fn:fe:means | "dressing" | "means" | "/r/has a" |  | "FN" |  |
| fn:dressing | /r/HasA | fn:fe:result | "dressing" | "result" | "/r/has a" |  | "FN" |  |
| fn:dressing | /r/HasA | fn:fe:duration | "dressing" | "duration" | "/r/has a" |  | "FN" |  |
| fn:dressing | /r/HasA | fn:fe:place | "dressing" | "place" | "/r/has a" |  | "FN" |  |
| fn:dressing | /r/HasA | fn:fe:explanation | "dressing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:dressing | /r/HasA | fn:fe:time | "dressing" | "time" | "/r/has a" |  | "FN" |  |
| fn:dressing | /r/HasA | fn:fe:purpose | "dressing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:drop_in_on | /r/IsA | fn:visitor_arrival | "drop in on" | "visitor arrival" | "/r/is a" |  | "FN" |  |
| fn:visit_host | /r/HasSubevent | fn:drop_in_on | "visit host" | "drop in on" | "/r/has subevent" |  | "FN" |  |
| fn:drop_in_on | /r/IsA | fn:visit_host_arrival | "drop in on" | "visit host arrival" | "/r/is a" |  | "FN" |  |
| fn:drop_in_on | fn:HasLexicalUnit | fn:lu:drop_in_on:drop_in | "drop in on" | "drop in" | "has lexical unit" |  | "FN" |  |
| fn:drop_in_on | fn:HasLexicalUnit | fn:lu:drop_in_on:stop_in | "drop in on" | "stop in" | "has lexical unit" |  | "FN" |  |
| fn:drop_in_on | fn:HasLexicalUnit | fn:lu:drop_in_on:pop_in | "drop in on" | "pop in" | "has lexical unit" |  | "FN" |  |
| fn:fe:visitor | /r/IsA | fn:st:sentient | "visitor" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:drop_in_on | /r/HasA | fn:fe:visitor | "drop in on" | "visitor" | "/r/has a" |  | "FN" |  |
| fn:fe:normal_location | /r/IsA | fn:st:source | "normal location" | "source" | "/r/is a" |  | "FN" |  |
| fn:drop_in_on | /r/HasA | fn:fe:normal_location | "drop in on" | "normal location" | "/r/has a" |  | "FN" |  |
| fn:drop_in_on | /r/HasA | fn:fe:path | "drop in on" | "path" | "/r/has a" |  | "FN" |  |
| fn:fe:host | /r/IsA | fn:st:location | "host" | "location" | "/r/is a" |  | "FN" |  |
| fn:drop_in_on | /r/HasA | fn:fe:host | "drop in on" | "host" | "/r/has a" |  | "FN" |  |
| fn:drop_in_on | /r/HasA | fn:fe:manner | "drop in on" | "manner" | "/r/has a" |  | "FN" |  |
| fn:drop_in_on | /r/HasA | fn:fe:means | "drop in on" | "means" | "/r/has a" |  | "FN" |  |
| fn:drop_in_on | /r/HasA | fn:fe:mode_of_transportation | "drop in on" | "mode of transportation" | "/r/has a" |  | "FN" |  |
| fn:drop_in_on | /r/HasA | fn:fe:time | "drop in on" | "time" | "/r/has a" |  | "FN" |  |
| fn:drop_in_on | /r/HasA | fn:fe:purpose | "drop in on" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:drop_in_on | /r/HasA | fn:fe:host_location | "drop in on" | "host location" | "/r/has a" |  | "FN" |  |
| fn:drop_in_on | /r/HasA | fn:fe:containing_event | "drop in on" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:drop_in_on | /r/HasA | fn:fe:frequency | "drop in on" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:drop_in_on | /r/HasA | fn:fe:duration | "drop in on" | "duration" | "/r/has a" |  | "FN" |  |
| fn:drop_in_on | /r/HasA | fn:fe:place | "drop in on" | "place" | "/r/has a" |  | "FN" |  |
| fn:drop_in_on | /r/HasA | fn:fe:particular_iteration | "drop in on" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:drop_in_on | /r/HasA | fn:fe:explanation | "drop in on" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:placing | /r/UsedFor | fn:dunking | "placing" | "dunking" | "/r/used for" |  | "FN" |  |
| fn:removing | /r/UsedFor | fn:dunking | "removing" | "dunking" | "/r/used for" |  | "FN" |  |
| fn:dunking | fn:HasLexicalUnit | fn:lu:dunking:dunk | "dunking" | "dunk" | "has lexical unit" |  | "FN" |  |
| fn:dunking | fn:HasLexicalUnit | fn:lu:dunking:dip | "dunking" | "dip" | "has lexical unit" |  | "FN" |  |
| fn:dunking | /r/HasA | fn:fe:agent | "dunking" | "agent" | "/r/has a" |  | "FN" |  |
| fn:dunking | /r/HasA | fn:fe:theme | "dunking" | "theme" | "/r/has a" |  | "FN" |  |
| fn:dunking | /r/HasA | fn:fe:substance | "dunking" | "substance" | "/r/has a" |  | "FN" |  |
| fn:dunking | /r/HasA | fn:fe:manner | "dunking" | "manner" | "/r/has a" |  | "FN" |  |
| fn:dunking | /r/HasA | fn:fe:time | "dunking" | "time" | "/r/has a" |  | "FN" |  |
| fn:forging | /r/IsA | fn:duplication | "forging" | "duplication" | "/r/is a" |  | "FN" |  |
| fn:duplication | /r/IsA | fn:intentionally_create | "duplication" | "intentionally create" | "/r/is a" |  | "FN" |  |
| fn:duplication | fn:HasLexicalUnit | fn:lu:duplication:clone | "duplication" | "clone" | "has lexical unit" |  | "FN" |  |
| fn:duplication | fn:HasLexicalUnit | fn:lu:duplication:copy | "duplication" | "copy" | "has lexical unit" |  | "FN" |  |
| fn:duplication | fn:HasLexicalUnit | fn:lu:duplication:copy | "duplication" | "copy" | "has lexical unit" |  | "FN" |  |
| fn:duplication | fn:HasLexicalUnit | fn:lu:duplication:duplicate | "duplication" | "duplicate" | "has lexical unit" |  | "FN" |  |
| fn:duplication | fn:HasLexicalUnit | fn:lu:duplication:duplicate | "duplication" | "duplicate" | "has lexical unit" |  | "FN" |  |
| fn:duplication | fn:HasLexicalUnit | fn:lu:duplication:photocopy | "duplication" | "photocopy" | "has lexical unit" |  | "FN" |  |
| fn:duplication | fn:HasLexicalUnit | fn:lu:duplication:photocopy | "duplication" | "photocopy" | "has lexical unit" |  | "FN" |  |
| fn:duplication | fn:HasLexicalUnit | fn:lu:duplication:reduplicate | "duplication" | "reduplicate" | "has lexical unit" |  | "FN" |  |
| fn:duplication | fn:HasLexicalUnit | fn:lu:duplication:replicate | "duplication" | "replicate" | "has lexical unit" |  | "FN" |  |
| fn:duplication | fn:HasLexicalUnit | fn:lu:duplication:reproduce | "duplication" | "reproduce" | "has lexical unit" |  | "FN" |  |
| fn:duplication | fn:HasLexicalUnit | fn:lu:duplication:replica | "duplication" | "replica" | "has lexical unit" |  | "FN" |  |
| fn:duplication | fn:HasLexicalUnit | fn:lu:duplication:duplication | "duplication" | "duplication" | "has lexical unit" |  | "FN" |  |
| fn:duplication | fn:HasLexicalUnit | fn:lu:duplication:run_off | "duplication" | "run off" | "has lexical unit" |  | "FN" |  |
| fn:duplication | fn:HasLexicalUnit | fn:lu:duplication:clone | "duplication" | "clone" | "has lexical unit" |  | "FN" |  |
| fn:duplication | /r/HasA | fn:fe:creator | "duplication" | "creator" | "/r/has a" |  | "FN" |  |
| fn:duplication | /r/HasA | fn:fe:original | "duplication" | "original" | "/r/has a" |  | "FN" |  |
| fn:duplication | /r/HasA | fn:fe:copy | "duplication" | "copy" | "/r/has a" |  | "FN" |  |
| fn:duplication | /r/HasA | fn:fe:source | "duplication" | "source" | "/r/has a" |  | "FN" |  |
| fn:duplication | /r/HasA | fn:fe:goal | "duplication" | "goal" | "/r/has a" |  | "FN" |  |
| fn:duplication | /r/HasA | fn:fe:characterization | "duplication" | "characterization" | "/r/has a" |  | "FN" |  |
| fn:duplication | /r/HasA | fn:fe:means | "duplication" | "means" | "/r/has a" |  | "FN" |  |
| fn:duplication | /r/HasA | fn:fe:manner | "duplication" | "manner" | "/r/has a" |  | "FN" |  |
| fn:duplication | /r/HasA | fn:fe:result | "duplication" | "result" | "/r/has a" |  | "FN" |  |
| fn:duplication | /r/HasA | fn:fe:depictive | "duplication" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:duplication | /r/HasA | fn:fe:degree | "duplication" | "degree" | "/r/has a" |  | "FN" |  |
| fn:duplication | /r/HasA | fn:fe:purpose | "duplication" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:duplication | /r/HasA | fn:fe:time | "duplication" | "time" | "/r/has a" |  | "FN" |  |
| fn:duplication | /r/HasA | fn:fe:place | "duplication" | "place" | "/r/has a" |  | "FN" |  |
| fn:duplication | /r/HasA | fn:fe:explanation | "duplication" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:duplication | /r/HasA | fn:fe:instrument | "duplication" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:duplication | /r/HasA | fn:fe:duration | "duplication" | "duration" | "/r/has a" |  | "FN" |  |
| fn:duplication | /r/HasA | fn:fe:fidelity | "duplication" | "fidelity" | "/r/has a" |  | "FN" |  |
| fn:duplication | /r/HasA | fn:fe:iterations | "duplication" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:duplication | /r/HasA | fn:fe:frequency | "duplication" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:duplication | /r/HasA | fn:fe:co-participant | "duplication" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:duration_description | /r/IsA | fn:measurable_attributes | "duration description" | "measurable attributes" | "/r/is a" |  | "FN" |  |
| fn:duration_description | /r/UsedFor | fn:taking_time | "duration description" | "taking time" | "/r/used for" |  | "FN" |  |
| fn:duration_description | /r/IsA | fn:duration_scenario | "duration description" | "duration scenario" | "/r/is a" |  | "FN" |  |
| fn:duration_description | fn:HasLexicalUnit | fn:lu:duration_description:abiding | "duration description" | "abiding" | "has lexical unit" |  | "FN" |  |
| fn:duration_description | fn:HasLexicalUnit | fn:lu:duration_description:brief | "duration description" | "brief" | "has lexical unit" |  | "FN" |  |
| fn:duration_description | fn:HasLexicalUnit | fn:lu:duration_description:chronic | "duration description" | "chronic" | "has lexical unit" |  | "FN" |  |
| fn:duration_description | fn:HasLexicalUnit | fn:lu:duration_description:enduring | "duration description" | "enduring" | "has lexical unit" |  | "FN" |  |
| fn:duration_description | fn:HasLexicalUnit | fn:lu:duration_description:ephemeral | "duration description" | "ephemeral" | "has lexical unit" |  | "FN" |  |
| fn:duration_description | fn:HasLexicalUnit | fn:lu:duration_description:eternal | "duration description" | "eternal" | "has lexical unit" |  | "FN" |  |
| fn:duration_description | fn:HasLexicalUnit | fn:lu:duration_description:extended | "duration description" | "extended" | "has lexical unit" |  | "FN" |  |
| fn:duration_description | fn:HasLexicalUnit | fn:lu:duration_description:interim | "duration description" | "interim" | "has lexical unit" |  | "FN" |  |
| fn:duration_description | fn:HasLexicalUnit | fn:lu:duration_description:lasting | "duration description" | "lasting" | "has lexical unit" |  | "FN" |  |
| fn:duration_description | fn:HasLexicalUnit | fn:lu:duration_description:lengthy | "duration description" | "lengthy" | "has lexical unit" |  | "FN" |  |
| fn:duration_description | fn:HasLexicalUnit | fn:lu:duration_description:momentary | "duration description" | "momentary" | "has lexical unit" |  | "FN" |  |
| fn:duration_description | fn:HasLexicalUnit | fn:lu:duration_description:perpetual | "duration description" | "perpetual" | "has lexical unit" |  | "FN" |  |
| fn:duration_description | fn:HasLexicalUnit | fn:lu:duration_description:short | "duration description" | "short" | "has lexical unit" |  | "FN" |  |
| fn:duration_description | fn:HasLexicalUnit | fn:lu:duration_description:long | "duration description" | "long" | "has lexical unit" |  | "FN" |  |
| fn:duration_description | fn:HasLexicalUnit | fn:lu:duration_description:persistent | "duration description" | "persistent" | "has lexical unit" |  | "FN" |  |
| fn:duration_description | fn:HasLexicalUnit | fn:lu:duration_description:rapid | "duration description" | "rapid" | "has lexical unit" |  | "FN" |  |
| fn:duration_description | fn:HasLexicalUnit | fn:lu:duration_description:sustained | "duration description" | "sustained" | "has lexical unit" |  | "FN" |  |
| fn:duration_description | /r/HasA | fn:fe:eventuality | "duration description" | "eventuality" | "/r/has a" |  | "FN" |  |
| fn:duration_description | /r/HasA | fn:fe:period | "duration description" | "period" | "/r/has a" |  | "FN" |  |
| fn:duration_description | /r/HasA | fn:fe:degree | "duration description" | "degree" | "/r/has a" |  | "FN" |  |
| fn:duration_relation | /r/IsA | fn:relation | "duration relation" | "relation" | "/r/is a" |  | "FN" |  |
| fn:duration_relation | /r/IsA | fn:duration_scenario | "duration relation" | "duration scenario" | "/r/is a" |  | "FN" |  |
| fn:duration_relation | fn:HasLexicalUnit | fn:lu:duration_relation:last | "duration relation" | "last" | "has lexical unit" |  | "FN" |  |
| fn:duration_relation | fn:HasLexicalUnit | fn:lu:duration_relation:persist | "duration relation" | "persist" | "has lexical unit" |  | "FN" |  |
| fn:duration_relation | fn:HasLexicalUnit | fn:lu:duration_relation:for | "duration relation" | "for" | "has lexical unit" |  | "FN" |  |
| fn:fe:eventuality | /r/RelatedTo | fn:fe:period | "eventuality" | "period" | "/r/related to" |  | "FN" |  |
| fn:duration_relation | /r/HasA | fn:fe:eventuality | "duration relation" | "eventuality" | "/r/has a" |  | "FN" |  |
| fn:fe:period | /r/RelatedTo | fn:fe:entity | "period" | "entity" | "/r/related to" |  | "FN" |  |
| fn:duration_relation | /r/HasA | fn:fe:period | "duration relation" | "period" | "/r/has a" |  | "FN" |  |
| fn:duration_relation | /r/HasA | fn:fe:duration | "duration relation" | "duration" | "/r/has a" |  | "FN" |  |
| fn:fe:entity | /r/RelatedTo | fn:fe:eventuality | "entity" | "eventuality" | "/r/related to" |  | "FN" |  |
| fn:duration_relation | /r/HasA | fn:fe:entity | "duration relation" | "entity" | "/r/has a" |  | "FN" |  |
| fn:duration_relation | /r/HasA | fn:fe:user | "duration relation" | "user" | "/r/has a" |  | "FN" |  |
| fn:duration_scenario | /r/IsA | fn:measure_scenario | "duration scenario" | "measure scenario" | "/r/is a" |  | "FN" |  |
| fn:duration_scenario | /r/IsA | fn:delimited_state_scenario | "duration scenario" | "delimited state scenario" | "/r/is a" |  | "FN" |  |
| fn:duration_description | /r/IsA | fn:duration_scenario | "duration description" | "duration scenario" | "/r/is a" |  | "FN" |  |
| fn:duration_relation | /r/IsA | fn:duration_scenario | "duration relation" | "duration scenario" | "/r/is a" |  | "FN" |  |
| fn:measure_duration | /r/IsA | fn:duration_scenario | "measure duration" | "duration scenario" | "/r/is a" |  | "FN" |  |
| fn:duration_scenario | /r/HasA | fn:fe:period | "duration scenario" | "period" | "/r/has a" |  | "FN" |  |
| fn:duration_scenario | /r/HasA | fn:fe:attribute | "duration scenario" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:duration_scenario | /r/HasA | fn:fe:duration | "duration scenario" | "duration" | "/r/has a" |  | "FN" |  |
| fn:duration_scenario | /r/HasA | fn:fe:degree | "duration scenario" | "degree" | "/r/has a" |  | "FN" |  |
| fn:duration_scenario | /r/HasA | fn:fe:unit | "duration scenario" | "unit" | "/r/has a" |  | "FN" |  |
| fn:duration_scenario | /r/HasA | fn:fe:count | "duration scenario" | "count" | "/r/has a" |  | "FN" |  |
| fn:duration_scenario | /r/HasA | fn:fe:event | "duration scenario" | "event" | "/r/has a" |  | "FN" |  |
| fn:dying | /r/IsA | fn:state | "dying" | "state" | "/r/is a" |  | "FN" |  |
| fn:dying | /r/HasPrerequisite | fn:being_born | "dying" | "being born" | "/r/has prerequisite" |  | "FN" |  |
| fn:death | /r/HasPrerequisite | fn:dying | "death" | "dying" | "/r/has prerequisite" |  | "FN" |  |
| fn:dying | /r/HasPrerequisite | fn:giving_birth | "dying" | "giving birth" | "/r/has prerequisite" |  | "FN" |  |
| fn:dying | fn:HasLexicalUnit | fn:lu:dying:dying | "dying" | "dying" | "has lexical unit" |  | "FN" |  |
| fn:dying | fn:HasLexicalUnit | fn:lu:dying:moribund | "dying" | "moribund" | "has lexical unit" |  | "FN" |  |
| fn:fe:protagonist | /r/IsA | fn:st:state_of_affairs | "protagonist" | "state of affairs" | "/r/is a" |  | "FN" |  |
| fn:dying | /r/HasA | fn:fe:protagonist | "dying" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:dying | /r/HasA | fn:fe:place | "dying" | "place" | "/r/has a" |  | "FN" |  |
| fn:dying | /r/HasA | fn:fe:explanation | "dying" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:dying | /r/HasA | fn:fe:time | "dying" | "time" | "/r/has a" |  | "FN" |  |
| fn:dying | /r/HasA | fn:fe:duration | "dying" | "duration" | "/r/has a" |  | "FN" |  |
| fn:dying | /r/HasA | fn:fe:manner | "dying" | "manner" | "/r/has a" |  | "FN" |  |
| fn:dying | /r/HasA | fn:fe:frequency | "dying" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:dynamic_situation_scenario | /r/HasSubevent | fn:event | "dynamic situation scenario" | "event" | "/r/has subevent" |  | "FN" |  |
| fn:dynamic_situation_scenario | /r/HasSubevent | fn:event_endstate | "dynamic situation scenario" | "event endstate" | "/r/has subevent" |  | "FN" |  |
| fn:dynamic_situation_scenario | /r/HasSubevent | fn:event_initial_state | "dynamic situation scenario" | "event initial state" | "/r/has subevent" |  | "FN" |  |
| fn:dynamic_situation_scenario | /r/HasA | fn:fe:time | "dynamic situation scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:dynamic_situation_scenario | /r/HasA | fn:fe:entity | "dynamic situation scenario" | "entity" | "/r/has a" |  | "FN" |  |
| fn:dynamic_situation_scenario | /r/HasA | fn:fe:explanation | "dynamic situation scenario" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:dynamic_situation_scenario | /r/HasA | fn:fe:event | "dynamic situation scenario" | "event" | "/r/has a" |  | "FN" |  |
| fn:dynamic_situation_scenario | /r/HasA | fn:fe:place | "dynamic situation scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:dynamism | /r/IsA | fn:gradable_attributes | "dynamism" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:level_of_force_exertion | /r/RelatedTo | fn:dynamism | "level of force exertion" | "dynamism" | "/r/related to" |  | "FN" |  |
| fn:dynamism | /r/SimilarTo | fn:level_of_force_exertion | "dynamism" | "level of force exertion" | "/r/similar to" |  | "FN" |  |
| fn:dynamism | fn:HasLexicalUnit | fn:lu:dynamism:dynamic | "dynamism" | "dynamic" | "has lexical unit" |  | "FN" |  |
| fn:dynamism | fn:HasLexicalUnit | fn:lu:dynamism:dynamism | "dynamism" | "dynamism" | "has lexical unit" |  | "FN" |  |
| fn:dynamism | fn:HasLexicalUnit | fn:lu:dynamism:energetic | "dynamism" | "energetic" | "has lexical unit" |  | "FN" |  |
| fn:dynamism | fn:HasLexicalUnit | fn:lu:dynamism:energy | "dynamism" | "energy" | "has lexical unit" |  | "FN" |  |
| fn:dynamism | fn:HasLexicalUnit | fn:lu:dynamism:intense | "dynamism" | "intense" | "has lexical unit" |  | "FN" |  |
| fn:dynamism | fn:HasLexicalUnit | fn:lu:dynamism:intensity | "dynamism" | "intensity" | "has lexical unit" |  | "FN" |  |
| fn:dynamism | fn:HasLexicalUnit | fn:lu:dynamism:lazy | "dynamism" | "lazy" | "has lexical unit" |  | "FN" |  |
| fn:dynamism | fn:HasLexicalUnit | fn:lu:dynamism:laziness | "dynamism" | "laziness" | "has lexical unit" |  | "FN" |  |
| fn:dynamism | fn:HasLexicalUnit | fn:lu:dynamism:lethargic | "dynamism" | "lethargic" | "has lexical unit" |  | "FN" |  |
| fn:dynamism | fn:HasLexicalUnit | fn:lu:dynamism:lethargy | "dynamism" | "lethargy" | "has lexical unit" |  | "FN" |  |
| fn:dynamism | fn:HasLexicalUnit | fn:lu:dynamism:sluggish | "dynamism" | "sluggish" | "has lexical unit" |  | "FN" |  |
| fn:dynamism | fn:HasLexicalUnit | fn:lu:dynamism:sluggishness | "dynamism" | "sluggishness" | "has lexical unit" |  | "FN" |  |
| fn:dynamism | fn:HasLexicalUnit | fn:lu:dynamism:stamina | "dynamism" | "stamina" | "has lexical unit" |  | "FN" |  |
| fn:dynamism | fn:HasLexicalUnit | fn:lu:dynamism:vibrant | "dynamism" | "vibrant" | "has lexical unit" |  | "FN" |  |
| fn:dynamism | fn:HasLexicalUnit | fn:lu:dynamism:vigorous | "dynamism" | "vigorous" | "has lexical unit" |  | "FN" |  |
| fn:dynamism | fn:HasLexicalUnit | fn:lu:dynamism:vigor | "dynamism" | "vigor" | "has lexical unit" |  | "FN" |  |
| fn:dynamism | /r/HasA | fn:fe:action | "dynamism" | "action" | "/r/has a" |  | "FN" |  |
| fn:dynamism | /r/HasA | fn:fe:exerter | "dynamism" | "exerter" | "/r/has a" |  | "FN" |  |
| fn:dynamism | /r/HasA | fn:fe:descriptor | "dynamism" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:dynamism | /r/HasA | fn:fe:degree | "dynamism" | "degree" | "/r/has a" |  | "FN" |  |
| fn:dynamism | /r/HasA | fn:fe:time | "dynamism" | "time" | "/r/has a" |  | "FN" |  |
| fn:dynamism | /r/HasA | fn:fe:force | "dynamism" | "force" | "/r/has a" |  | "FN" |  |
| fn:dynamism | /r/HasA | fn:fe:circumstances | "dynamism" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:dynamism | /r/HasA | fn:fe:place | "dynamism" | "place" | "/r/has a" |  | "FN" |  |
| fn:dynamism | /r/HasA | fn:fe:domain | "dynamism" | "domain" | "/r/has a" |  | "FN" |  |
| fn:earnings_and_losses | /r/IsA | fn:commerce_collect | "earnings and losses" | "commerce collect" | "/r/is a" |  | "FN" |  |
| fn:commerce_collect | /r/UsedFor | fn:earnings_and_losses | "commerce collect" | "earnings and losses" | "/r/used for" |  | "FN" |  |
| fn:commerce_pay | /r/UsedFor | fn:earnings_and_losses | "commerce pay" | "earnings and losses" | "/r/used for" |  | "FN" |  |
| fn:earnings_and_losses | fn:HasLexicalUnit | fn:lu:earnings_and_losses:earn | "earnings and losses" | "earn" | "has lexical unit" |  | "FN" |  |
| fn:earnings_and_losses | fn:HasLexicalUnit | fn:lu:earnings_and_losses:earnings | "earnings and losses" | "earnings" | "has lexical unit" |  | "FN" |  |
| fn:earnings_and_losses | fn:HasLexicalUnit | fn:lu:earnings_and_losses:profit | "earnings and losses" | "profit" | "has lexical unit" |  | "FN" |  |
| fn:earnings_and_losses | fn:HasLexicalUnit | fn:lu:earnings_and_losses:loss | "earnings and losses" | "loss" | "has lexical unit" |  | "FN" |  |
| fn:earnings_and_losses | fn:HasLexicalUnit | fn:lu:earnings_and_losses:revenue | "earnings and losses" | "revenue" | "has lexical unit" |  | "FN" |  |
| fn:earnings_and_losses | fn:HasLexicalUnit | fn:lu:earnings_and_losses:income | "earnings and losses" | "income" | "has lexical unit" |  | "FN" |  |
| fn:earnings_and_losses | fn:HasLexicalUnit | fn:lu:earnings_and_losses:net | "earnings and losses" | "net" | "has lexical unit" |  | "FN" |  |
| fn:earnings_and_losses | fn:HasLexicalUnit | fn:lu:earnings_and_losses:make | "earnings and losses" | "make" | "has lexical unit" |  | "FN" |  |
| fn:earnings_and_losses | fn:HasLexicalUnit | fn:lu:earnings_and_losses:net | "earnings and losses" | "net" | "has lexical unit" |  | "FN" |  |
| fn:earnings_and_losses | fn:HasLexicalUnit | fn:lu:earnings_and_losses:lose | "earnings and losses" | "lose" | "has lexical unit" |  | "FN" |  |
| fn:earnings_and_losses | fn:HasLexicalUnit | fn:lu:earnings_and_losses:result | "earnings and losses" | "result" | "has lexical unit" |  | "FN" |  |
| fn:earnings_and_losses | fn:HasLexicalUnit | fn:lu:earnings_and_losses:pull | "earnings and losses" | "pull" | "has lexical unit" |  | "FN" |  |
| fn:earnings_and_losses | /r/HasA | fn:fe:buyer | "earnings and losses" | "buyer" | "/r/has a" |  | "FN" |  |
| fn:earnings_and_losses | /r/HasA | fn:fe:earner | "earnings and losses" | "earner" | "/r/has a" |  | "FN" |  |
| fn:earnings_and_losses | /r/HasA | fn:fe:earnings | "earnings and losses" | "earnings" | "/r/has a" |  | "FN" |  |
| fn:earnings_and_losses | /r/HasA | fn:fe:goods | "earnings and losses" | "goods" | "/r/has a" |  | "FN" |  |
| fn:earnings_and_losses | /r/HasA | fn:fe:rate | "earnings and losses" | "rate" | "/r/has a" |  | "FN" |  |
| fn:earnings_and_losses | /r/HasA | fn:fe:unit | "earnings and losses" | "unit" | "/r/has a" |  | "FN" |  |
| fn:earnings_and_losses | /r/HasA | fn:fe:means | "earnings and losses" | "means" | "/r/has a" |  | "FN" |  |
| fn:earnings_and_losses | /r/HasA | fn:fe:manner | "earnings and losses" | "manner" | "/r/has a" |  | "FN" |  |
| fn:earnings_and_losses | /r/HasA | fn:fe:purpose | "earnings and losses" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:earnings_and_losses | /r/HasA | fn:fe:place | "earnings and losses" | "place" | "/r/has a" |  | "FN" |  |
| fn:earnings_and_losses | /r/HasA | fn:fe:time | "earnings and losses" | "time" | "/r/has a" |  | "FN" |  |
| fn:earnings_and_losses | /r/HasA | fn:fe:containing_event | "earnings and losses" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:earnings_and_losses | /r/HasA | fn:fe:explanation | "earnings and losses" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:perception_experience | /r/UsedFor | fn:eclipse | "perception experience" | "eclipse" | "/r/used for" |  | "FN" |  |
| fn:hiding_objects | /r/Causes | fn:eclipse | "hiding objects" | "eclipse" | "/r/causes" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:hide | "eclipse" | "hide" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:eclipse | "eclipse" | "eclipse" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:mask | "eclipse" | "mask" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:cover | "eclipse" | "cover" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:obscure | "eclipse" | "obscure" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:screen | "eclipse" | "screen" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:veil | "eclipse" | "veil" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:hidden | "eclipse" | "hidden" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:blot_out | "eclipse" | "blot out" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:obscured | "eclipse" | "obscured" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:block | "eclipse" | "block" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:screened | "eclipse" | "screened" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:masked | "eclipse" | "masked" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:veiled | "eclipse" | "veiled" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:covered | "eclipse" | "covered" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:occlude | "eclipse" | "occlude" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:cloak | "eclipse" | "cloak" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:shroud | "eclipse" | "shroud" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:shrouded | "eclipse" | "shrouded" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:cloaked | "eclipse" | "cloaked" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:eclipse | "eclipse" | "eclipse" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:occlusion | "eclipse" | "occlusion" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:occultation | "eclipse" | "occultation" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:conceal | "eclipse" | "conceal" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:concealed | "eclipse" | "concealed" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:obstruct | "eclipse" | "obstruct" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:becloud | "eclipse" | "becloud" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:befog | "eclipse" | "befog" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:beclouded | "eclipse" | "beclouded" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:befogged | "eclipse" | "befogged" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:enshroud | "eclipse" | "enshroud" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | fn:HasLexicalUnit | fn:lu:eclipse:enshrouded | "eclipse" | "enshrouded" | "has lexical unit" |  | "FN" |  |
| fn:eclipse | /r/HasA | fn:fe:obstruction | "eclipse" | "obstruction" | "/r/has a" |  | "FN" |  |
| fn:eclipse | /r/HasA | fn:fe:eclipsed | "eclipse" | "eclipsed" | "/r/has a" |  | "FN" |  |
| fn:eclipse | /r/HasA | fn:fe:vantage_point | "eclipse" | "vantage point" | "/r/has a" |  | "FN" |  |
| fn:eclipse | /r/HasA | fn:fe:degree | "eclipse" | "degree" | "/r/has a" |  | "FN" |  |
| fn:eclipse | /r/HasA | fn:fe:subregion | "eclipse" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:political_locales | /r/UsedFor | fn:economy | "political locales" | "economy" | "/r/used for" |  | "FN" |  |
| fn:economy | fn:HasLexicalUnit | fn:lu:economy:economy | "economy" | "economy" | "has lexical unit" |  | "FN" |  |
| fn:economy | fn:HasLexicalUnit | fn:lu:economy:economic | "economy" | "economic" | "has lexical unit" |  | "FN" |  |
| fn:economy | /r/HasA | fn:fe:political_region | "economy" | "political region" | "/r/has a" |  | "FN" |  |
| fn:economy | /r/HasA | fn:fe:economy | "economy" | "economy" | "/r/has a" |  | "FN" |  |
| fn:economy | /r/HasA | fn:fe:domain | "economy" | "domain" | "/r/has a" |  | "FN" |  |
| fn:economy | /r/HasA | fn:fe:market_type | "economy" | "market type" | "/r/has a" |  | "FN" |  |
| fn:economy | /r/HasA | fn:fe:descriptor | "economy" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:education_teaching | /r/IsA | fn:intentionally_affect | "education teaching" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:education_teaching | /r/UsedFor | fn:studying | "education teaching" | "studying" | "/r/used for" |  | "FN" |  |
| fn:memorization | /r/RelatedTo | fn:education_teaching | "memorization" | "education teaching" | "/r/related to" |  | "FN" |  |
| fn:education_teaching | fn:HasLexicalUnit | fn:lu:education_teaching:student | "education teaching" | "student" | "has lexical unit" |  | "FN" |  |
| fn:education_teaching | fn:HasLexicalUnit | fn:lu:education_teaching:pupil | "education teaching" | "pupil" | "has lexical unit" |  | "FN" |  |
| fn:education_teaching | fn:HasLexicalUnit | fn:lu:education_teaching:teacher | "education teaching" | "teacher" | "has lexical unit" |  | "FN" |  |
| fn:education_teaching | fn:HasLexicalUnit | fn:lu:education_teaching:professor | "education teaching" | "professor" | "has lexical unit" |  | "FN" |  |
| fn:education_teaching | fn:HasLexicalUnit | fn:lu:education_teaching:tutor | "education teaching" | "tutor" | "has lexical unit" |  | "FN" |  |
| fn:education_teaching | fn:HasLexicalUnit | fn:lu:education_teaching:lecturer | "education teaching" | "lecturer" | "has lexical unit" |  | "FN" |  |
| fn:education_teaching | fn:HasLexicalUnit | fn:lu:education_teaching:tutee | "education teaching" | "tutee" | "has lexical unit" |  | "FN" |  |
| fn:education_teaching | fn:HasLexicalUnit | fn:lu:education_teaching:schoolmaster | "education teaching" | "schoolmaster" | "has lexical unit" |  | "FN" |  |
| fn:education_teaching | fn:HasLexicalUnit | fn:lu:education_teaching:schoolmistress | "education teaching" | "schoolmistress" | "has lexical unit" |  | "FN" |  |
| fn:education_teaching | fn:HasLexicalUnit | fn:lu:education_teaching:schoolteacher | "education teaching" | "schoolteacher" | "has lexical unit" |  | "FN" |  |
| fn:education_teaching | fn:HasLexicalUnit | fn:lu:education_teaching:study | "education teaching" | "study" | "has lexical unit" |  | "FN" |  |
| fn:education_teaching | fn:HasLexicalUnit | fn:lu:education_teaching:tutor | "education teaching" | "tutor" | "has lexical unit" |  | "FN" |  |
| fn:education_teaching | fn:HasLexicalUnit | fn:lu:education_teaching:coach | "education teaching" | "coach" | "has lexical unit" |  | "FN" |  |
| fn:education_teaching | fn:HasLexicalUnit | fn:lu:education_teaching:educate | "education teaching" | "educate" | "has lexical unit" |  | "FN" |  |
| fn:education_teaching | fn:HasLexicalUnit | fn:lu:education_teaching:learn | "education teaching" | "learn" | "has lexical unit" |  | "FN" |  |
| fn:education_teaching | fn:HasLexicalUnit | fn:lu:education_teaching:school | "education teaching" | "school" | "has lexical unit" |  | "FN" |  |
| fn:education_teaching | fn:HasLexicalUnit | fn:lu:education_teaching:train | "education teaching" | "train" | "has lexical unit" |  | "FN" |  |
| fn:education_teaching | fn:HasLexicalUnit | fn:lu:education_teaching:training | "education teaching" | "training" | "has lexical unit" |  | "FN" |  |
| fn:education_teaching | fn:HasLexicalUnit | fn:lu:education_teaching:instruct | "education teaching" | "instruct" | "has lexical unit" |  | "FN" |  |
| fn:education_teaching | fn:HasLexicalUnit | fn:lu:education_teaching:teach | "education teaching" | "teach" | "has lexical unit" |  | "FN" |  |
| fn:education_teaching | fn:HasLexicalUnit | fn:lu:education_teaching:instruction | "education teaching" | "instruction" | "has lexical unit" |  | "FN" |  |
| fn:education_teaching | fn:HasLexicalUnit | fn:lu:education_teaching:education | "education teaching" | "education" | "has lexical unit" |  | "FN" |  |
| fn:education_teaching | fn:HasLexicalUnit | fn:lu:education_teaching:master | "education teaching" | "master" | "has lexical unit" |  | "FN" |  |
| fn:education_teaching | fn:HasLexicalUnit | fn:lu:education_teaching:educational | "education teaching" | "educational" | "has lexical unit" |  | "FN" |  |
| fn:education_teaching | fn:HasLexicalUnit | fn:lu:education_teaching:graduate | "education teaching" | "graduate" | "has lexical unit" |  | "FN" |  |
| fn:education_teaching | fn:HasLexicalUnit | fn:lu:education_teaching:protege | "education teaching" | "protege" | "has lexical unit" |  | "FN" |  |
| fn:education_teaching | fn:HasLexicalUnit | fn:lu:education_teaching:cram | "education teaching" | "cram" | "has lexical unit" |  | "FN" |  |
| fn:fe:teacher | /r/IsA | fn:st:sentient | "teacher" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:education_teaching | /r/HasA | fn:fe:teacher | "education teaching" | "teacher" | "/r/has a" |  | "FN" |  |
| fn:fe:student | /r/IsA | fn:st:sentient | "student" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:education_teaching | /r/HasA | fn:fe:student | "education teaching" | "student" | "/r/has a" |  | "FN" |  |
| fn:education_teaching | /r/HasA | fn:fe:institution | "education teaching" | "institution" | "/r/has a" |  | "FN" |  |
| fn:fe:subject | /r/RelatedTo | fn:fe:precept | "subject" | "precept" | "/r/related to" |  | "FN" |  |
| fn:education_teaching | /r/HasA | fn:fe:subject | "education teaching" | "subject" | "/r/has a" |  | "FN" |  |
| fn:education_teaching | /r/HasA | fn:fe:level | "education teaching" | "level" | "/r/has a" |  | "FN" |  |
| fn:fe:qualification | /r/RelatedTo | fn:fe:fact | "qualification" | "fact" | "/r/related to" |  | "FN" |  |
| fn:education_teaching | /r/HasA | fn:fe:qualification | "education teaching" | "qualification" | "/r/has a" |  | "FN" |  |
| fn:education_teaching | /r/HasA | fn:fe:degree | "education teaching" | "degree" | "/r/has a" |  | "FN" |  |
| fn:education_teaching | /r/HasA | fn:fe:depictive | "education teaching" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:education_teaching | /r/HasA | fn:fe:manner | "education teaching" | "manner" | "/r/has a" |  | "FN" |  |
| fn:education_teaching | /r/HasA | fn:fe:means | "education teaching" | "means" | "/r/has a" |  | "FN" |  |
| fn:education_teaching | /r/HasA | fn:fe:result | "education teaching" | "result" | "/r/has a" |  | "FN" |  |
| fn:education_teaching | /r/HasA | fn:fe:time | "education teaching" | "time" | "/r/has a" |  | "FN" |  |
| fn:education_teaching | /r/HasA | fn:fe:place | "education teaching" | "place" | "/r/has a" |  | "FN" |  |
| fn:education_teaching | /r/HasA | fn:fe:duration | "education teaching" | "duration" | "/r/has a" |  | "FN" |  |
| fn:fe:skill | /r/RelatedTo | fn:fe:subject | "skill" | "subject" | "/r/related to" |  | "FN" |  |
| fn:education_teaching | /r/HasA | fn:fe:skill | "education teaching" | "skill" | "/r/has a" |  | "FN" |  |
| fn:fe:precept | /r/RelatedTo | fn:fe:skill | "precept" | "skill" | "/r/related to" |  | "FN" |  |
| fn:education_teaching | /r/HasA | fn:fe:precept | "education teaching" | "precept" | "/r/has a" |  | "FN" |  |
| fn:fe:fact | /r/RelatedTo | fn:fe:precept | "fact" | "precept" | "/r/related to" |  | "FN" |  |
| fn:education_teaching | /r/HasA | fn:fe:fact | "education teaching" | "fact" | "/r/has a" |  | "FN" |  |
| fn:education_teaching | /r/HasA | fn:fe:material | "education teaching" | "material" | "/r/has a" |  | "FN" |  |
| fn:education_teaching | /r/HasA | fn:fe:role | "education teaching" | "role" | "/r/has a" |  | "FN" |  |
| fn:education_teaching | /r/HasA | fn:fe:course | "education teaching" | "course" | "/r/has a" |  | "FN" |  |
| fn:education_teaching | /r/HasA | fn:fe:purpose | "education teaching" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:capability | /r/UsedFor | fn:electricity | "capability" | "electricity" | "/r/used for" |  | "FN" |  |
| fn:electricity | fn:HasLexicalUnit | fn:lu:electricity:electricity | "electricity" | "electricity" | "has lexical unit" |  | "FN" |  |
| fn:electricity | fn:HasLexicalUnit | fn:lu:electricity:electric | "electricity" | "electric" | "has lexical unit" |  | "FN" |  |
| fn:electricity | fn:HasLexicalUnit | fn:lu:electricity:power | "electricity" | "power" | "has lexical unit" |  | "FN" |  |
| fn:electricity | fn:HasLexicalUnit | fn:lu:electricity:electric_power | "electricity" | "electric power" | "has lexical unit" |  | "FN" |  |
| fn:electricity | fn:HasLexicalUnit | fn:lu:electricity:juice | "electricity" | "juice" | "has lexical unit" |  | "FN" |  |
| fn:electricity | fn:HasLexicalUnit | fn:lu:electricity:electrical | "electricity" | "electrical" | "has lexical unit" |  | "FN" |  |
| fn:electricity | fn:HasLexicalUnit | fn:lu:electricity:hydroelectric | "electricity" | "hydroelectric" | "has lexical unit" |  | "FN" |  |
| fn:electricity | fn:HasLexicalUnit | fn:lu:electricity:hydroelectricity | "electricity" | "hydroelectricity" | "has lexical unit" |  | "FN" |  |
| fn:electricity | fn:HasLexicalUnit | fn:lu:electricity:photoelectric | "electricity" | "photoelectric" | "has lexical unit" |  | "FN" |  |
| fn:electricity | fn:HasLexicalUnit | fn:lu:electricity:photoelectricity | "electricity" | "photoelectricity" | "has lexical unit" |  | "FN" |  |
| fn:electricity | fn:HasLexicalUnit | fn:lu:electricity:energy | "electricity" | "energy" | "has lexical unit" |  | "FN" |  |
| fn:electricity | fn:HasLexicalUnit | fn:lu:electricity:electrical_power | "electricity" | "electrical power" | "has lexical unit" |  | "FN" |  |
| fn:electricity | fn:HasLexicalUnit | fn:lu:electricity:current | "electricity" | "current" | "has lexical unit" |  | "FN" |  |
| fn:electricity | /r/HasA | fn:fe:electricity | "electricity" | "electricity" | "/r/has a" |  | "FN" |  |
| fn:electricity | /r/HasA | fn:fe:source | "electricity" | "source" | "/r/has a" |  | "FN" |  |
| fn:electricity | /r/HasA | fn:fe:descriptor | "electricity" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:electricity | /r/HasA | fn:fe:inherent_purpose | "electricity" | "inherent purpose" | "/r/has a" |  | "FN" |  |
| fn:purpose | /r/UsedFor | fn:elusive_goal | "purpose" | "elusive goal" | "/r/used for" |  | "FN" |  |
| fn:elusive_goal | /r/RelatedTo | fn:evading | "elusive goal" | "evading" | "/r/related to" |  | "FN" |  |
| fn:elusive_goal | /r/SimilarTo | fn:evading | "elusive goal" | "evading" | "/r/similar to" |  | "FN" |  |
| fn:evading | /r/SimilarTo | fn:elusive_goal | "evading" | "elusive goal" | "/r/similar to" |  | "FN" |  |
| fn:elusive_goal | /r/IsA | fn:result_of_attempt_scenario | "elusive goal" | "result of attempt scenario" | "/r/is a" |  | "FN" |  |
| fn:evading | /r/SimilarTo | fn:elusive_goal | "evading" | "elusive goal" | "/r/similar to" |  | "FN" |  |
| fn:elusive_goal | fn:HasLexicalUnit | fn:lu:elusive_goal:evade | "elusive goal" | "evade" | "has lexical unit" |  | "FN" |  |
| fn:elusive_goal | fn:HasLexicalUnit | fn:lu:elusive_goal:escape | "elusive goal" | "escape" | "has lexical unit" |  | "FN" |  |
| fn:elusive_goal | fn:HasLexicalUnit | fn:lu:elusive_goal:elude | "elusive goal" | "elude" | "has lexical unit" |  | "FN" |  |
| fn:elusive_goal | /r/HasA | fn:fe:experiencer | "elusive goal" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:elusive_goal | /r/HasA | fn:fe:desired_goal | "elusive goal" | "desired goal" | "/r/has a" |  | "FN" |  |
| fn:elusive_goal | /r/HasA | fn:fe:time | "elusive goal" | "time" | "/r/has a" |  | "FN" |  |
| fn:elusive_goal | /r/HasA | fn:fe:place | "elusive goal" | "place" | "/r/has a" |  | "FN" |  |
| fn:elusive_goal | /r/HasA | fn:fe:manner | "elusive goal" | "manner" | "/r/has a" |  | "FN" |  |
| fn:elusive_goal | /r/HasA | fn:fe:degree | "elusive goal" | "degree" | "/r/has a" |  | "FN" |  |
| fn:elusive_goal | /r/HasA | fn:fe:duration | "elusive goal" | "duration" | "/r/has a" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:emanating | "motion" | "emanating" | "/r/used for" |  | "FN" |  |
| fn:emitting | /r/Causes | fn:emanating | "emitting" | "emanating" | "/r/causes" |  | "FN" |  |
| fn:emanating | fn:HasLexicalUnit | fn:lu:emanating:emanate | "emanating" | "emanate" | "has lexical unit" |  | "FN" |  |
| fn:emanating | fn:HasLexicalUnit | fn:lu:emanating:issue | "emanating" | "issue" | "has lexical unit" |  | "FN" |  |
| fn:emanating | fn:HasLexicalUnit | fn:lu:emanating:exude | "emanating" | "exude" | "has lexical unit" |  | "FN" |  |
| fn:emanating | fn:HasLexicalUnit | fn:lu:emanating:radiate | "emanating" | "radiate" | "has lexical unit" |  | "FN" |  |
| fn:emanating | fn:HasLexicalUnit | fn:lu:emanating:discharge | "emanating" | "discharge" | "has lexical unit" |  | "FN" |  |
| fn:emanating | fn:HasLexicalUnit | fn:lu:emanating:excrete | "emanating" | "excrete" | "has lexical unit" |  | "FN" |  |
| fn:emanating | fn:HasLexicalUnit | fn:lu:emanating:secrete | "emanating" | "secrete" | "has lexical unit" |  | "FN" |  |
| fn:emanating | /r/HasA | fn:fe:area | "emanating" | "area" | "/r/has a" |  | "FN" |  |
| fn:emanating | /r/HasA | fn:fe:degree | "emanating" | "degree" | "/r/has a" |  | "FN" |  |
| fn:emanating | /r/HasA | fn:fe:depictive | "emanating" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:emanating | /r/HasA | fn:fe:distance | "emanating" | "distance" | "/r/has a" |  | "FN" |  |
| fn:emanating | /r/HasA | fn:fe:duration | "emanating" | "duration" | "/r/has a" |  | "FN" |  |
| fn:emanating | /r/HasA | fn:fe:emission | "emanating" | "emission" | "/r/has a" |  | "FN" |  |
| fn:emanating | /r/HasA | fn:fe:goal | "emanating" | "goal" | "/r/has a" |  | "FN" |  |
| fn:emanating | /r/HasA | fn:fe:manner | "emanating" | "manner" | "/r/has a" |  | "FN" |  |
| fn:emanating | /r/HasA | fn:fe:path | "emanating" | "path" | "/r/has a" |  | "FN" |  |
| fn:emanating | /r/HasA | fn:fe:speed | "emanating" | "speed" | "/r/has a" |  | "FN" |  |
| fn:emanating | /r/HasA | fn:fe:time | "emanating" | "time" | "/r/has a" |  | "FN" |  |
| fn:emanating | /r/HasA | fn:fe:carrier | "emanating" | "carrier" | "/r/has a" |  | "FN" |  |
| fn:emanating | /r/HasA | fn:fe:source | "emanating" | "source" | "/r/has a" |  | "FN" |  |
| fn:emanating | /r/HasA | fn:fe:form | "emanating" | "form" | "/r/has a" |  | "FN" |  |
| fn:emanating | /r/HasA | fn:fe:result | "emanating" | "result" | "/r/has a" |  | "FN" |  |
| fn:emergency | /r/IsA | fn:event | "emergency" | "event" | "/r/is a" |  | "FN" |  |
| fn:emergency | fn:HasLexicalUnit | fn:lu:emergency:emergency | "emergency" | "emergency" | "has lexical unit" |  | "FN" |  |
| fn:emergency | /r/HasA | fn:fe:undesirable_event | "emergency" | "undesirable event" | "/r/has a" |  | "FN" |  |
| fn:emergency | /r/HasA | fn:fe:entity | "emergency" | "entity" | "/r/has a" |  | "FN" |  |
| fn:emergency | /r/HasA | fn:fe:circumstances | "emergency" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:emergency | /r/HasA | fn:fe:place | "emergency" | "place" | "/r/has a" |  | "FN" |  |
| fn:emergency | /r/HasA | fn:fe:domain | "emergency" | "domain" | "/r/has a" |  | "FN" |  |
| fn:emergency | /r/HasA | fn:fe:experiencer | "emergency" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:emergency | /r/HasA | fn:fe:time | "emergency" | "time" | "/r/has a" |  | "FN" |  |
| fn:emergency | /r/HasA | fn:fe:manner | "emergency" | "manner" | "/r/has a" |  | "FN" |  |
| fn:emergency | /r/HasA | fn:fe:timespan | "emergency" | "timespan" | "/r/has a" |  | "FN" |  |
| fn:emergency | /r/HasA | fn:fe:duration | "emergency" | "duration" | "/r/has a" |  | "FN" |  |
| fn:emergency | /r/HasA | fn:fe:frequency | "emergency" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:emergency_fire | /r/IsA | fn:fire_burning | "emergency fire" | "fire burning" | "/r/is a" |  | "FN" |  |
| fn:fire_emergency_scenario | /r/HasSubevent | fn:emergency_fire | "fire emergency scenario" | "emergency fire" | "/r/has subevent" |  | "FN" |  |
| fn:emergency_fire | fn:HasLexicalUnit | fn:lu:emergency_fire:wildland_fire | "emergency fire" | "wildland fire" | "has lexical unit" |  | "FN" |  |
| fn:emergency_fire | fn:HasLexicalUnit | fn:lu:emergency_fire:wildfire | "emergency fire" | "wildfire" | "has lexical unit" |  | "FN" |  |
| fn:emergency_fire | /r/HasA | fn:fe:fire | "emergency fire" | "fire" | "/r/has a" |  | "FN" |  |
| fn:emergency_fire | /r/HasA | fn:fe:fuel | "emergency fire" | "fuel" | "/r/has a" |  | "FN" |  |
| fn:emergency_fire | /r/HasA | fn:fe:manner | "emergency fire" | "manner" | "/r/has a" |  | "FN" |  |
| fn:emergency_fire | /r/HasA | fn:fe:name | "emergency fire" | "name" | "/r/has a" |  | "FN" |  |
| fn:emergency_fire | /r/HasA | fn:fe:place | "emergency fire" | "place" | "/r/has a" |  | "FN" |  |
| fn:emergency_fire | /r/HasA | fn:fe:time | "emergency fire" | "time" | "/r/has a" |  | "FN" |  |
| fn:emitting | /r/Causes | fn:emanating | "emitting" | "emanating" | "/r/causes" |  | "FN" |  |
| fn:emitting | fn:HasLexicalUnit | fn:lu:emitting:exude | "emitting" | "exude" | "has lexical unit" |  | "FN" |  |
| fn:emitting | fn:HasLexicalUnit | fn:lu:emitting:emit | "emitting" | "emit" | "has lexical unit" |  | "FN" |  |
| fn:emitting | fn:HasLexicalUnit | fn:lu:emitting:discharge | "emitting" | "discharge" | "has lexical unit" |  | "FN" |  |
| fn:emitting | fn:HasLexicalUnit | fn:lu:emitting:radiate | "emitting" | "radiate" | "has lexical unit" |  | "FN" |  |
| fn:emitting | fn:HasLexicalUnit | fn:lu:emitting:secrete | "emitting" | "secrete" | "has lexical unit" |  | "FN" |  |
| fn:emitting | fn:HasLexicalUnit | fn:lu:emitting:exhale | "emitting" | "exhale" | "has lexical unit" |  | "FN" |  |
| fn:emitting | fn:HasLexicalUnit | fn:lu:emitting:give_off | "emitting" | "give off" | "has lexical unit" |  | "FN" |  |
| fn:emitting | fn:HasLexicalUnit | fn:lu:emitting:excrete | "emitting" | "excrete" | "has lexical unit" |  | "FN" |  |
| fn:emitting | fn:HasLexicalUnit | fn:lu:emitting:void | "emitting" | "void" | "has lexical unit" |  | "FN" |  |
| fn:emitting | fn:HasLexicalUnit | fn:lu:emitting:emanate | "emitting" | "emanate" | "has lexical unit" |  | "FN" |  |
| fn:emitting | /r/HasA | fn:fe:manner | "emitting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:emitting | /r/HasA | fn:fe:time | "emitting" | "time" | "/r/has a" |  | "FN" |  |
| fn:emitting | /r/HasA | fn:fe:source_emitter | "emitting" | "source emitter" | "/r/has a" |  | "FN" |  |
| fn:emitting | /r/HasA | fn:fe:emission | "emitting" | "emission" | "/r/has a" |  | "FN" |  |
| fn:emitting | /r/HasA | fn:fe:area | "emitting" | "area" | "/r/has a" |  | "FN" |  |
| fn:emitting | /r/HasA | fn:fe:degree | "emitting" | "degree" | "/r/has a" |  | "FN" |  |
| fn:emitting | /r/HasA | fn:fe:depictive | "emitting" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:emitting | /r/HasA | fn:fe:distance | "emitting" | "distance" | "/r/has a" |  | "FN" |  |
| fn:emitting | /r/HasA | fn:fe:goal | "emitting" | "goal" | "/r/has a" |  | "FN" |  |
| fn:emitting | /r/HasA | fn:fe:means | "emitting" | "means" | "/r/has a" |  | "FN" |  |
| fn:emitting | /r/HasA | fn:fe:path | "emitting" | "path" | "/r/has a" |  | "FN" |  |
| fn:emitting | /r/HasA | fn:fe:sub-source | "emitting" | "sub-source" | "/r/has a" |  | "FN" |  |
| fn:emitting | /r/HasA | fn:fe:speed | "emitting" | "speed" | "/r/has a" |  | "FN" |  |
| fn:emitting | /r/HasA | fn:fe:explanation | "emitting" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:emitting | /r/HasA | fn:fe:duration | "emitting" | "duration" | "/r/has a" |  | "FN" |  |
| fn:emitting | /r/HasA | fn:fe:carrier | "emitting" | "carrier" | "/r/has a" |  | "FN" |  |
| fn:emitting | /r/HasA | fn:fe:form | "emitting" | "form" | "/r/has a" |  | "FN" |  |
| fn:emotion_active | /r/IsA | fn:cogitation | "emotion active" | "cogitation" | "/r/is a" |  | "FN" |  |
| fn:emotions | /r/UsedFor | fn:emotion_active | "emotions" | "emotion active" | "/r/used for" |  | "FN" |  |
| fn:emotion_directed | /r/SimilarTo | fn:emotion_active | "emotion directed" | "emotion active" | "/r/similar to" |  | "FN" |  |
| fn:emotion_active | fn:HasLexicalUnit | fn:lu:emotion_active:fret | "emotion active" | "fret" | "has lexical unit" |  | "FN" |  |
| fn:emotion_active | fn:HasLexicalUnit | fn:lu:emotion_active:fuss | "emotion active" | "fuss" | "has lexical unit" |  | "FN" |  |
| fn:emotion_active | fn:HasLexicalUnit | fn:lu:emotion_active:worry | "emotion active" | "worry" | "has lexical unit" |  | "FN" |  |
| fn:emotion_active | fn:HasLexicalUnit | fn:lu:emotion_active:lose_sleep | "emotion active" | "lose sleep" | "has lexical unit" |  | "FN" |  |
| fn:emotion_active | fn:HasLexicalUnit | fn:lu:emotion_active:agonize | "emotion active" | "agonize" | "has lexical unit" |  | "FN" |  |
| fn:emotion_active | fn:HasLexicalUnit | fn:lu:emotion_active:obsess | "emotion active" | "obsess" | "has lexical unit" |  | "FN" |  |
| fn:emotion_active | fn:HasLexicalUnit | fn:lu:emotion_active:obsession | "emotion active" | "obsession" | "has lexical unit" |  | "FN" |  |
| fn:emotion_active | /r/HasA | fn:fe:experiencer | "emotion active" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:emotion_active | /r/HasA | fn:fe:topic | "emotion active" | "topic" | "/r/has a" |  | "FN" |  |
| fn:emotion_active | /r/HasA | fn:fe:degree | "emotion active" | "degree" | "/r/has a" |  | "FN" |  |
| fn:emotion_active | /r/HasA | fn:fe:manner | "emotion active" | "manner" | "/r/has a" |  | "FN" |  |
| fn:emotion_active | /r/HasA | fn:fe:result | "emotion active" | "result" | "/r/has a" |  | "FN" |  |
| fn:emotion_active | /r/HasA | fn:fe:means | "emotion active" | "means" | "/r/has a" |  | "FN" |  |
| fn:emotions | /r/UsedFor | fn:emotion_directed | "emotions" | "emotion directed" | "/r/used for" |  | "FN" |  |
| fn:awareness | /r/SimilarTo | fn:emotion_directed | "awareness" | "emotion directed" | "/r/similar to" |  | "FN" |  |
| fn:emotion_directed | /r/SimilarTo | fn:emotion_active | "emotion directed" | "emotion active" | "/r/similar to" |  | "FN" |  |
| fn:emotion_directed | /r/SimilarTo | fn:experiencer_focus | "emotion directed" | "experiencer focus" | "/r/similar to" |  | "FN" |  |
| fn:experiencer_focus | /r/SimilarTo | fn:emotion_directed | "experiencer focus" | "emotion directed" | "/r/similar to" |  | "FN" |  |
| fn:experiencer_obj | /r/SimilarTo | fn:emotion_directed | "experiencer obj" | "emotion directed" | "/r/similar to" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:angry | "emotion directed" | "angry" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:appalled | "emotion directed" | "appalled" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:cross | "emotion directed" | "cross" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:disappointed | "emotion directed" | "disappointed" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:furious | "emotion directed" | "furious" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:mad | "emotion directed" | "mad" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:pleased | "emotion directed" | "pleased" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:sore | "emotion directed" | "sore" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:upset | "emotion directed" | "upset" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:petrified | "emotion directed" | "petrified" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:miffed | "emotion directed" | "miffed" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:embarrassed | "emotion directed" | "embarrassed" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:anxious | "emotion directed" | "anxious" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:excited | "emotion directed" | "excited" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:livid | "emotion directed" | "livid" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:rattled | "emotion directed" | "rattled" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:relaxed | "emotion directed" | "relaxed" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:resentful | "emotion directed" | "resentful" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:revolted | "emotion directed" | "revolted" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:sad | "emotion directed" | "sad" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:sickened | "emotion directed" | "sickened" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:sorrowful | "emotion directed" | "sorrowful" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:startled | "emotion directed" | "startled" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:stressed | "emotion directed" | "stressed" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:stupefied | "emotion directed" | "stupefied" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:terror-stricken | "emotion directed" | "terror-stricken" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:tormented | "emotion directed" | "tormented" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:traumatised | "emotion directed" | "traumatised" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:unsettled | "emotion directed" | "unsettled" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:vexed | "emotion directed" | "vexed" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:worried | "emotion directed" | "worried" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:disquieted | "emotion directed" | "disquieted" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:harried | "emotion directed" | "harried" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:ruffled | "emotion directed" | "ruffled" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:abashed | "emotion directed" | "abashed" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:flustered | "emotion directed" | "flustered" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:humiliated | "emotion directed" | "humiliated" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:flummoxed | "emotion directed" | "flummoxed" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:nonplussed | "emotion directed" | "nonplussed" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:disconsolate | "emotion directed" | "disconsolate" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:glum | "emotion directed" | "glum" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:woebegone | "emotion directed" | "woebegone" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:lugubrious | "emotion directed" | "lugubrious" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:desolate | "emotion directed" | "desolate" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:wretched | "emotion directed" | "wretched" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:miserable | "emotion directed" | "miserable" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:blue | "emotion directed" | "blue" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:despondent | "emotion directed" | "despondent" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:downcast | "emotion directed" | "downcast" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:low-spirited | "emotion directed" | "low-spirited" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:crestfallen | "emotion directed" | "crestfallen" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:disgruntled | "emotion directed" | "disgruntled" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:downhearted | "emotion directed" | "downhearted" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:flabbergasted | "emotion directed" | "flabbergasted" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:affronted | "emotion directed" | "affronted" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:incensed | "emotion directed" | "incensed" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:overwrought | "emotion directed" | "overwrought" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:riled | "emotion directed" | "riled" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:agonized | "emotion directed" | "agonized" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:inconsolable | "emotion directed" | "inconsolable" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:stunned | "emotion directed" | "stunned" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:befuddled | "emotion directed" | "befuddled" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:anguished | "emotion directed" | "anguished" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:happy | "emotion directed" | "happy" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:revulsion | "emotion directed" | "revulsion" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:vexation | "emotion directed" | "vexation" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:anger | "emotion directed" | "anger" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:anguish | "emotion directed" | "anguish" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:agony | "emotion directed" | "agony" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:annoyance | "emotion directed" | "annoyance" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:despondency | "emotion directed" | "despondency" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:disquiet | "emotion directed" | "disquiet" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:elation | "emotion directed" | "elation" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:bafflement | "emotion directed" | "bafflement" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:astonishment | "emotion directed" | "astonishment" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:bewilderment | "emotion directed" | "bewilderment" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:perplexity | "emotion directed" | "perplexity" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:puzzlement | "emotion directed" | "puzzlement" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:stupefaction | "emotion directed" | "stupefaction" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:mystification | "emotion directed" | "mystification" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:dismay | "emotion directed" | "dismay" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:discomfiture | "emotion directed" | "discomfiture" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:disgruntlement | "emotion directed" | "disgruntlement" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:disorientation | "emotion directed" | "disorientation" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:discouragement | "emotion directed" | "discouragement" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:glumness | "emotion directed" | "glumness" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:disconcertion | "emotion directed" | "disconcertion" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:displeasure | "emotion directed" | "displeasure" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:dejection | "emotion directed" | "dejection" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:sorrow | "emotion directed" | "sorrow" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:embarrassment | "emotion directed" | "embarrassment" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:exhilaration | "emotion directed" | "exhilaration" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:disappointment | "emotion directed" | "disappointment" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:exasperation | "emotion directed" | "exasperation" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:agitation | "emotion directed" | "agitation" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:amusement | "emotion directed" | "amusement" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:boredom | "emotion directed" | "boredom" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:distress | "emotion directed" | "distress" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:chagrined | "emotion directed" | "chagrined" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:excitement | "emotion directed" | "excitement" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:gratification | "emotion directed" | "gratification" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:heartbreak | "emotion directed" | "heartbreak" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:horror | "emotion directed" | "horror" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:mortification | "emotion directed" | "mortification" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:sadness | "emotion directed" | "sadness" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:sympathy | "emotion directed" | "sympathy" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:agitated | "emotion directed" | "agitated" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:alarmed | "emotion directed" | "alarmed" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:amused | "emotion directed" | "amused" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:ashamed | "emotion directed" | "ashamed" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:astonished | "emotion directed" | "astonished" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:astounded | "emotion directed" | "astounded" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:baffled | "emotion directed" | "baffled" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:bewildered | "emotion directed" | "bewildered" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:bored | "emotion directed" | "bored" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:chagrin | "emotion directed" | "chagrin" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:concerned | "emotion directed" | "concerned" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:contented | "emotion directed" | "contented" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:covetous | "emotion directed" | "covetous" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:dejected | "emotion directed" | "dejected" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:delight | "emotion directed" | "delight" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:delighted | "emotion directed" | "delighted" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:depressed | "emotion directed" | "depressed" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:despair | "emotion directed" | "despair" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:devastated | "emotion directed" | "devastated" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:discomfited | "emotion directed" | "discomfited" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:disconcerted | "emotion directed" | "disconcerted" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:discouraged | "emotion directed" | "discouraged" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:disheartened | "emotion directed" | "disheartened" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:dismayed | "emotion directed" | "dismayed" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:disoriented | "emotion directed" | "disoriented" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:distressed | "emotion directed" | "distressed" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:ecstatic | "emotion directed" | "ecstatic" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:elated | "emotion directed" | "elated" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:displeased | "emotion directed" | "displeased" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:embittered | "emotion directed" | "embittered" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:enraged | "emotion directed" | "enraged" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:exasperated | "emotion directed" | "exasperated" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:exhilarated | "emotion directed" | "exhilarated" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:fed-up | "emotion directed" | "fed-up" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:gleeful | "emotion directed" | "gleeful" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:gratified | "emotion directed" | "gratified" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:grief-stricken | "emotion directed" | "grief-stricken" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:heartbroken | "emotion directed" | "heartbroken" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:horrified | "emotion directed" | "horrified" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:indignant | "emotion directed" | "indignant" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:infuriated | "emotion directed" | "infuriated" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:frightened | "emotion directed" | "frightened" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:mortified | "emotion directed" | "mortified" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:glee | "emotion directed" | "glee" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:grief | "emotion directed" | "grief" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:mourning | "emotion directed" | "mourning" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:sympathetic | "emotion directed" | "sympathetic" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:sympathize | "emotion directed" | "sympathize" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:unsympathetic | "emotion directed" | "unsympathetic" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:thrilled | "emotion directed" | "thrilled" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:saddened | "emotion directed" | "saddened" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:irate | "emotion directed" | "irate" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:irked | "emotion directed" | "irked" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:jubilant | "emotion directed" | "jubilant" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:mournful | "emotion directed" | "mournful" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:mystified | "emotion directed" | "mystified" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:nervous | "emotion directed" | "nervous" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:nettled | "emotion directed" | "nettled" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:offended | "emotion directed" | "offended" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:overjoyed | "emotion directed" | "overjoyed" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:peeved | "emotion directed" | "peeved" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:perplexed | "emotion directed" | "perplexed" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:perturbed | "emotion directed" | "perturbed" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:interest | "emotion directed" | "interest" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:concern | "emotion directed" | "concern" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:fed_up | "emotion directed" | "fed up" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:all_about | "emotion directed" | "all about" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:fury | "emotion directed" | "fury" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:outrage | "emotion directed" | "outrage" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:demolished | "emotion directed" | "demolished" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:crushed | "emotion directed" | "crushed" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:bitterness | "emotion directed" | "bitterness" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:ok | "emotion directed" | "ok" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:fine | "emotion directed" | "fine" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:misery | "emotion directed" | "misery" | "has lexical unit" |  | "FN" |  |
| fn:emotion_directed | fn:HasLexicalUnit | fn:lu:emotion_directed:grim | "emotion directed" | "grim" | "has lexical unit" |  | "FN" |  |
| fn:fe:experiencer | /r/RelatedTo | fn:fe:event | "experiencer" | "event" | "/r/related to" |  | "FN" |  |
| fn:emotion_directed | /r/HasA | fn:fe:experiencer | "emotion directed" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:emotion_directed | /r/HasA | fn:fe:topic | "emotion directed" | "topic" | "/r/has a" |  | "FN" |  |
| fn:emotion_directed | /r/HasA | fn:fe:stimulus | "emotion directed" | "stimulus" | "/r/has a" |  | "FN" |  |
| fn:emotion_directed | /r/HasA | fn:fe:degree | "emotion directed" | "degree" | "/r/has a" |  | "FN" |  |
| fn:emotion_directed | /r/HasA | fn:fe:empathy_target | "emotion directed" | "empathy target" | "/r/has a" |  | "FN" |  |
| fn:fe:expressor | /r/RelatedTo | fn:fe:experiencer | "expressor" | "experiencer" | "/r/related to" |  | "FN" |  |
| fn:emotion_directed | /r/HasA | fn:fe:expressor | "emotion directed" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:emotion_directed | /r/HasA | fn:fe:explanation | "emotion directed" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:emotion_directed | /r/HasA | fn:fe:circumstances | "emotion directed" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:emotion_directed | /r/HasA | fn:fe:state | "emotion directed" | "state" | "/r/has a" |  | "FN" |  |
| fn:fe:event | /r/RelatedTo | fn:fe:expressor | "event" | "expressor" | "/r/related to" |  | "FN" |  |
| fn:emotion_directed | /r/HasA | fn:fe:event | "emotion directed" | "event" | "/r/has a" |  | "FN" |  |
| fn:emotion_directed | /r/HasA | fn:fe:parameter | "emotion directed" | "parameter" | "/r/has a" |  | "FN" |  |
| fn:emotion_directed | /r/HasA | fn:fe:manner | "emotion directed" | "manner" | "/r/has a" |  | "FN" |  |
| fn:emotion_directed | /r/HasA | fn:fe:frequency | "emotion directed" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:emotions | /r/UsedFor | fn:emotion_heat | "emotions" | "emotion heat" | "/r/used for" |  | "FN" |  |
| fn:emotion_heat | fn:HasLexicalUnit | fn:lu:emotion_heat:boil | "emotion heat" | "boil" | "has lexical unit" |  | "FN" |  |
| fn:emotion_heat | fn:HasLexicalUnit | fn:lu:emotion_heat:burn | "emotion heat" | "burn" | "has lexical unit" |  | "FN" |  |
| fn:emotion_heat | fn:HasLexicalUnit | fn:lu:emotion_heat:chafe | "emotion heat" | "chafe" | "has lexical unit" |  | "FN" |  |
| fn:emotion_heat | fn:HasLexicalUnit | fn:lu:emotion_heat:fume | "emotion heat" | "fume" | "has lexical unit" |  | "FN" |  |
| fn:emotion_heat | fn:HasLexicalUnit | fn:lu:emotion_heat:seethe | "emotion heat" | "seethe" | "has lexical unit" |  | "FN" |  |
| fn:emotion_heat | fn:HasLexicalUnit | fn:lu:emotion_heat:simmer | "emotion heat" | "simmer" | "has lexical unit" |  | "FN" |  |
| fn:emotion_heat | fn:HasLexicalUnit | fn:lu:emotion_heat:smoulder | "emotion heat" | "smoulder" | "has lexical unit" |  | "FN" |  |
| fn:emotion_heat | fn:HasLexicalUnit | fn:lu:emotion_heat:stew | "emotion heat" | "stew" | "has lexical unit" |  | "FN" |  |
| fn:emotion_heat | /r/HasA | fn:fe:experiencer | "emotion heat" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:emotion_heat | /r/HasA | fn:fe:emotion | "emotion heat" | "emotion" | "/r/has a" |  | "FN" |  |
| fn:emotion_heat | /r/HasA | fn:fe:cause | "emotion heat" | "cause" | "/r/has a" |  | "FN" |  |
| fn:emotion_heat | /r/HasA | fn:fe:seat_of_emotion | "emotion heat" | "seat of emotion" | "/r/has a" |  | "FN" |  |
| fn:emotion_heat | /r/HasA | fn:fe:degree | "emotion heat" | "degree" | "/r/has a" |  | "FN" |  |
| fn:emotion_heat | /r/HasA | fn:fe:manner | "emotion heat" | "manner" | "/r/has a" |  | "FN" |  |
| fn:emotion_heat | /r/HasA | fn:fe:topic | "emotion heat" | "topic" | "/r/has a" |  | "FN" |  |
| fn:emotion_heat | /r/HasA | fn:fe:expression | "emotion heat" | "expression" | "/r/has a" |  | "FN" |  |
| fn:emotions_by_stimulus | /r/IsA | fn:emotions | "emotions by stimulus" | "emotions" | "/r/is a" |  | "FN" |  |
| fn:emotions | /r/IsA | fn:state | "emotions" | "state" | "/r/is a" |  | "FN" |  |
| fn:emotions | /r/UsedFor | fn:attitude_description | "emotions" | "attitude description" | "/r/used for" |  | "FN" |  |
| fn:emotions | /r/UsedFor | fn:contrition | "emotions" | "contrition" | "/r/used for" |  | "FN" |  |
| fn:emotions | /r/UsedFor | fn:desiring | "emotions" | "desiring" | "/r/used for" |  | "FN" |  |
| fn:emotions | /r/UsedFor | fn:emotion_active | "emotions" | "emotion active" | "/r/used for" |  | "FN" |  |
| fn:emotions | /r/UsedFor | fn:emotion_directed | "emotions" | "emotion directed" | "/r/used for" |  | "FN" |  |
| fn:emotions | /r/UsedFor | fn:emotion_heat | "emotions" | "emotion heat" | "/r/used for" |  | "FN" |  |
| fn:emotions | /r/UsedFor | fn:experiencer_obj | "emotions" | "experiencer obj" | "/r/used for" |  | "FN" |  |
| fn:emotions | /r/UsedFor | fn:feeling | "emotions" | "feeling" | "/r/used for" |  | "FN" |  |
| fn:emotions | /r/UsedFor | fn:forgiveness | "emotions" | "forgiveness" | "/r/used for" |  | "FN" |  |
| fn:emotions | /r/UsedFor | fn:judgment | "emotions" | "judgment" | "/r/used for" |  | "FN" |  |
| fn:emotions | /r/UsedFor | fn:predicament | "emotions" | "predicament" | "/r/used for" |  | "FN" |  |
| fn:experiencer_focus | /r/IsA | fn:emotions | "experiencer focus" | "emotions" | "/r/is a" |  | "FN" |  |
| fn:stimulus_focus | /r/IsA | fn:emotions | "stimulus focus" | "emotions" | "/r/is a" |  | "FN" |  |
| fn:emotions | /r/HasA | fn:fe:experiencer | "emotions" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:emotions | /r/HasA | fn:fe:topic | "emotions" | "topic" | "/r/has a" |  | "FN" |  |
| fn:emotions | /r/HasA | fn:fe:stimulus | "emotions" | "stimulus" | "/r/has a" |  | "FN" |  |
| fn:emotions | /r/HasA | fn:fe:degree | "emotions" | "degree" | "/r/has a" |  | "FN" |  |
| fn:emotions | /r/HasA | fn:fe:empathy_target | "emotions" | "empathy target" | "/r/has a" |  | "FN" |  |
| fn:emotions | /r/HasA | fn:fe:expressor | "emotions" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:emotions | /r/HasA | fn:fe:explanation | "emotions" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:emotions | /r/HasA | fn:fe:circumstances | "emotions" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:emotions | /r/HasA | fn:fe:state | "emotions" | "state" | "/r/has a" |  | "FN" |  |
| fn:emotions | /r/HasA | fn:fe:event | "emotions" | "event" | "/r/has a" |  | "FN" |  |
| fn:emotions | /r/HasA | fn:fe:parameter | "emotions" | "parameter" | "/r/has a" |  | "FN" |  |
| fn:emotions | /r/HasA | fn:fe:manner | "emotions" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fear | /r/IsA | fn:emotions_by_possibility | "fear" | "emotions by possibility" | "/r/is a" |  | "FN" |  |
| fn:emotions_by_possibility | /r/IsA | fn:emotions_by_stimulus | "emotions by possibility" | "emotions by stimulus" | "/r/is a" |  | "FN" |  |
| fn:emotions_by_possibility | /r/HasA | fn:fe:experiencer | "emotions by possibility" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:emotions_by_possibility | /r/HasA | fn:fe:topic | "emotions by possibility" | "topic" | "/r/has a" |  | "FN" |  |
| fn:emotions_by_possibility | /r/HasA | fn:fe:stimulus | "emotions by possibility" | "stimulus" | "/r/has a" |  | "FN" |  |
| fn:emotions_by_possibility | /r/HasA | fn:fe:degree | "emotions by possibility" | "degree" | "/r/has a" |  | "FN" |  |
| fn:emotions_by_possibility | /r/HasA | fn:fe:empathy_target | "emotions by possibility" | "empathy target" | "/r/has a" |  | "FN" |  |
| fn:emotions_by_possibility | /r/HasA | fn:fe:expressor | "emotions by possibility" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:emotions_by_possibility | /r/HasA | fn:fe:explanation | "emotions by possibility" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:emotions_by_possibility | /r/HasA | fn:fe:circumstances | "emotions by possibility" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:emotions_by_possibility | /r/HasA | fn:fe:state | "emotions by possibility" | "state" | "/r/has a" |  | "FN" |  |
| fn:emotions_by_possibility | /r/HasA | fn:fe:event | "emotions by possibility" | "event" | "/r/has a" |  | "FN" |  |
| fn:emotions_by_possibility | /r/HasA | fn:fe:parameter | "emotions by possibility" | "parameter" | "/r/has a" |  | "FN" |  |
| fn:emotions_by_possibility | /r/HasA | fn:fe:manner | "emotions by possibility" | "manner" | "/r/has a" |  | "FN" |  |
| fn:emotions_by_possibility | /r/HasA | fn:fe:time | "emotions by possibility" | "time" | "/r/has a" |  | "FN" |  |
| fn:emotions_by_stimulus | /r/IsA | fn:emotions | "emotions by stimulus" | "emotions" | "/r/is a" |  | "FN" |  |
| fn:annoyance | /r/IsA | fn:emotions_by_stimulus | "annoyance" | "emotions by stimulus" | "/r/is a" |  | "FN" |  |
| fn:emotions_by_possibility | /r/IsA | fn:emotions_by_stimulus | "emotions by possibility" | "emotions by stimulus" | "/r/is a" |  | "FN" |  |
| fn:emotions_of_mental_activity | /r/IsA | fn:emotions_by_stimulus | "emotions of mental activity" | "emotions by stimulus" | "/r/is a" |  | "FN" |  |
| fn:emotions_success_or_failure | /r/IsA | fn:emotions_by_stimulus | "emotions success or failure" | "emotions by stimulus" | "/r/is a" |  | "FN" |  |
| fn:just_found_out | /r/IsA | fn:emotions_by_stimulus | "just found out" | "emotions by stimulus" | "/r/is a" |  | "FN" |  |
| fn:others_situation_as_stimulus | /r/IsA | fn:emotions_by_stimulus | "others situation as stimulus" | "emotions by stimulus" | "/r/is a" |  | "FN" |  |
| fn:emotions_by_stimulus | fn:HasLexicalUnit | fn:lu:emotions_by_stimulus:joyful | "emotions by stimulus" | "joyful" | "has lexical unit" |  | "FN" |  |
| fn:emotions_by_stimulus | fn:HasLexicalUnit | fn:lu:emotions_by_stimulus:jubilant | "emotions by stimulus" | "jubilant" | "has lexical unit" |  | "FN" |  |
| fn:emotions_by_stimulus | fn:HasLexicalUnit | fn:lu:emotions_by_stimulus:glad | "emotions by stimulus" | "glad" | "has lexical unit" |  | "FN" |  |
| fn:emotions_by_stimulus | /r/HasA | fn:fe:experiencer | "emotions by stimulus" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:emotions_by_stimulus | /r/HasA | fn:fe:topic | "emotions by stimulus" | "topic" | "/r/has a" |  | "FN" |  |
| fn:emotions_by_stimulus | /r/HasA | fn:fe:stimulus | "emotions by stimulus" | "stimulus" | "/r/has a" |  | "FN" |  |
| fn:emotions_by_stimulus | /r/HasA | fn:fe:degree | "emotions by stimulus" | "degree" | "/r/has a" |  | "FN" |  |
| fn:emotions_by_stimulus | /r/HasA | fn:fe:empathy_target | "emotions by stimulus" | "empathy target" | "/r/has a" |  | "FN" |  |
| fn:emotions_by_stimulus | /r/HasA | fn:fe:expressor | "emotions by stimulus" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:emotions_by_stimulus | /r/HasA | fn:fe:explanation | "emotions by stimulus" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:emotions_by_stimulus | /r/HasA | fn:fe:circumstances | "emotions by stimulus" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:emotions_by_stimulus | /r/HasA | fn:fe:state | "emotions by stimulus" | "state" | "/r/has a" |  | "FN" |  |
| fn:emotions_by_stimulus | /r/HasA | fn:fe:event | "emotions by stimulus" | "event" | "/r/has a" |  | "FN" |  |
| fn:emotions_by_stimulus | /r/HasA | fn:fe:parameter | "emotions by stimulus" | "parameter" | "/r/has a" |  | "FN" |  |
| fn:emotions_by_stimulus | /r/HasA | fn:fe:manner | "emotions by stimulus" | "manner" | "/r/has a" |  | "FN" |  |
| fn:emotions_by_stimulus | /r/HasA | fn:fe:time | "emotions by stimulus" | "time" | "/r/has a" |  | "FN" |  |
| fn:emotions_of_mental_activity | /r/IsA | fn:emotions_by_stimulus | "emotions of mental activity" | "emotions by stimulus" | "/r/is a" |  | "FN" |  |
| fn:attention | /r/UsedFor | fn:emotions_of_mental_activity | "attention" | "emotions of mental activity" | "/r/used for" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | /r/IsA | fn:emotions_of_mental_activity | "mental stimulus exp focus" | "emotions of mental activity" | "/r/is a" |  | "FN" |  |
| fn:mental_stimulus_stimulus_focus | /r/IsA | fn:emotions_of_mental_activity | "mental stimulus stimulus focus" | "emotions of mental activity" | "/r/is a" |  | "FN" |  |
| fn:emotions_of_mental_activity | fn:HasLexicalUnit | fn:lu:emotions_of_mental_activity:delight | "emotions of mental activity" | "delight" | "has lexical unit" |  | "FN" |  |
| fn:emotions_of_mental_activity | fn:HasLexicalUnit | fn:lu:emotions_of_mental_activity:enjoyment | "emotions of mental activity" | "enjoyment" | "has lexical unit" |  | "FN" |  |
| fn:emotions_of_mental_activity | fn:HasLexicalUnit | fn:lu:emotions_of_mental_activity:pleasure | "emotions of mental activity" | "pleasure" | "has lexical unit" |  | "FN" |  |
| fn:emotions_of_mental_activity | fn:HasLexicalUnit | fn:lu:emotions_of_mental_activity:drudgery | "emotions of mental activity" | "drudgery" | "has lexical unit" |  | "FN" |  |
| fn:emotions_of_mental_activity | fn:HasLexicalUnit | fn:lu:emotions_of_mental_activity:enjoy | "emotions of mental activity" | "enjoy" | "has lexical unit" |  | "FN" |  |
| fn:emotions_of_mental_activity | fn:HasLexicalUnit | fn:lu:emotions_of_mental_activity:relish | "emotions of mental activity" | "relish" | "has lexical unit" |  | "FN" |  |
| fn:emotions_of_mental_activity | fn:HasLexicalUnit | fn:lu:emotions_of_mental_activity:savour | "emotions of mental activity" | "savour" | "has lexical unit" |  | "FN" |  |
| fn:emotions_of_mental_activity | fn:HasLexicalUnit | fn:lu:emotions_of_mental_activity:luxuriate | "emotions of mental activity" | "luxuriate" | "has lexical unit" |  | "FN" |  |
| fn:emotions_of_mental_activity | fn:HasLexicalUnit | fn:lu:emotions_of_mental_activity:delight_(in) | "emotions of mental activity" | "delight (in)" | "has lexical unit" |  | "FN" |  |
| fn:emotions_of_mental_activity | fn:HasLexicalUnit | fn:lu:emotions_of_mental_activity:groove | "emotions of mental activity" | "groove" | "has lexical unit" |  | "FN" |  |
| fn:emotions_of_mental_activity | /r/HasA | fn:fe:experiencer | "emotions of mental activity" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:emotions_of_mental_activity | /r/HasA | fn:fe:stimulus | "emotions of mental activity" | "stimulus" | "/r/has a" |  | "FN" |  |
| fn:emotions_of_mental_activity | /r/HasA | fn:fe:degree | "emotions of mental activity" | "degree" | "/r/has a" |  | "FN" |  |
| fn:emotions_of_mental_activity | /r/HasA | fn:fe:empathy_target | "emotions of mental activity" | "empathy target" | "/r/has a" |  | "FN" |  |
| fn:emotions_of_mental_activity | /r/HasA | fn:fe:explanation | "emotions of mental activity" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:emotions_of_mental_activity | /r/HasA | fn:fe:circumstances | "emotions of mental activity" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:emotions_of_mental_activity | /r/HasA | fn:fe:parameter | "emotions of mental activity" | "parameter" | "/r/has a" |  | "FN" |  |
| fn:emotions_of_mental_activity | /r/HasA | fn:fe:manner | "emotions of mental activity" | "manner" | "/r/has a" |  | "FN" |  |
| fn:emotions_of_mental_activity | /r/HasA | fn:fe:time | "emotions of mental activity" | "time" | "/r/has a" |  | "FN" |  |
| fn:emotions_of_mental_activity | /r/HasA | fn:fe:event_description | "emotions of mental activity" | "event description" | "/r/has a" |  | "FN" |  |
| fn:emotions_success_or_failure | /r/IsA | fn:emotions_by_stimulus | "emotions success or failure" | "emotions by stimulus" | "/r/is a" |  | "FN" |  |
| fn:emotions_success_or_failure | fn:HasLexicalUnit | fn:lu:emotions_success_or_failure:unfulfilled | "emotions success or failure" | "unfulfilled" | "has lexical unit" |  | "FN" |  |
| fn:emotions_success_or_failure | fn:HasLexicalUnit | fn:lu:emotions_success_or_failure:fulfilled | "emotions success or failure" | "fulfilled" | "has lexical unit" |  | "FN" |  |
| fn:emotions_success_or_failure | fn:HasLexicalUnit | fn:lu:emotions_success_or_failure:dissatisfied | "emotions success or failure" | "dissatisfied" | "has lexical unit" |  | "FN" |  |
| fn:emotions_success_or_failure | fn:HasLexicalUnit | fn:lu:emotions_success_or_failure:satisfied | "emotions success or failure" | "satisfied" | "has lexical unit" |  | "FN" |  |
| fn:emotions_success_or_failure | /r/HasA | fn:fe:experiencer | "emotions success or failure" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:emotions_success_or_failure | /r/HasA | fn:fe:topic | "emotions success or failure" | "topic" | "/r/has a" |  | "FN" |  |
| fn:emotions_success_or_failure | /r/HasA | fn:fe:stimulus | "emotions success or failure" | "stimulus" | "/r/has a" |  | "FN" |  |
| fn:emotions_success_or_failure | /r/HasA | fn:fe:degree | "emotions success or failure" | "degree" | "/r/has a" |  | "FN" |  |
| fn:emotions_success_or_failure | /r/HasA | fn:fe:empathy_target | "emotions success or failure" | "empathy target" | "/r/has a" |  | "FN" |  |
| fn:emotions_success_or_failure | /r/HasA | fn:fe:expressor | "emotions success or failure" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:emotions_success_or_failure | /r/HasA | fn:fe:explanation | "emotions success or failure" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:emotions_success_or_failure | /r/HasA | fn:fe:circumstances | "emotions success or failure" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:emotions_success_or_failure | /r/HasA | fn:fe:state | "emotions success or failure" | "state" | "/r/has a" |  | "FN" |  |
| fn:emotions_success_or_failure | /r/HasA | fn:fe:event | "emotions success or failure" | "event" | "/r/has a" |  | "FN" |  |
| fn:emotions_success_or_failure | /r/HasA | fn:fe:parameter | "emotions success or failure" | "parameter" | "/r/has a" |  | "FN" |  |
| fn:emotions_success_or_failure | /r/HasA | fn:fe:manner | "emotions success or failure" | "manner" | "/r/has a" |  | "FN" |  |
| fn:emotions_success_or_failure | /r/HasA | fn:fe:time | "emotions success or failure" | "time" | "/r/has a" |  | "FN" |  |
| fn:emotions_success_or_failure | /r/HasA | fn:fe:frequency | "emotions success or failure" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:importance | /r/UsedFor | fn:emphasizing | "importance" | "emphasizing" | "/r/used for" |  | "FN" |  |
| fn:emphasizing | fn:HasLexicalUnit | fn:lu:emphasizing:emphasize | "emphasizing" | "emphasize" | "has lexical unit" |  | "FN" |  |
| fn:emphasizing | fn:HasLexicalUnit | fn:lu:emphasizing:prioritize | "emphasizing" | "prioritize" | "has lexical unit" |  | "FN" |  |
| fn:emphasizing | fn:HasLexicalUnit | fn:lu:emphasizing:emphasis | "emphasizing" | "emphasis" | "has lexical unit" |  | "FN" |  |
| fn:emphasizing | fn:HasLexicalUnit | fn:lu:emphasizing:place_weight | "emphasizing" | "place weight" | "has lexical unit" |  | "FN" |  |
| fn:emphasizing | fn:HasLexicalUnit | fn:lu:emphasizing:centered | "emphasizing" | "centered" | "has lexical unit" |  | "FN" |  |
| fn:emphasizing | fn:HasLexicalUnit | fn:lu:emphasizing:focused | "emphasizing" | "focused" | "has lexical unit" |  | "FN" |  |
| fn:emphasizing | fn:HasLexicalUnit | fn:lu:emphasizing:focus | "emphasizing" | "focus" | "has lexical unit" |  | "FN" |  |
| fn:emphasizing | fn:HasLexicalUnit | fn:lu:emphasizing:oriented | "emphasizing" | "oriented" | "has lexical unit" |  | "FN" |  |
| fn:emphasizing | fn:HasLexicalUnit | fn:lu:emphasizing:growth-oriented | "emphasizing" | "growth-oriented" | "has lexical unit" |  | "FN" |  |
| fn:emphasizing | fn:HasLexicalUnit | fn:lu:emphasizing:stress | "emphasizing" | "stress" | "has lexical unit" |  | "FN" |  |
| fn:emphasizing | fn:HasLexicalUnit | fn:lu:emphasizing:accentuate | "emphasizing" | "accentuate" | "has lexical unit" |  | "FN" |  |
| fn:emphasizing | /r/HasA | fn:fe:consideration | "emphasizing" | "consideration" | "/r/has a" |  | "FN" |  |
| fn:emphasizing | /r/HasA | fn:fe:degree | "emphasizing" | "degree" | "/r/has a" |  | "FN" |  |
| fn:emphasizing | /r/HasA | fn:fe:undertaking | "emphasizing" | "undertaking" | "/r/has a" |  | "FN" |  |
| fn:emphasizing | /r/HasA | fn:fe:explanation | "emphasizing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:emphasizing | /r/HasA | fn:fe:agent | "emphasizing" | "agent" | "/r/has a" |  | "FN" |  |
| fn:emphasizing | /r/HasA | fn:fe:purpose | "emphasizing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:emphasizing | /r/HasA | fn:fe:means | "emphasizing" | "means" | "/r/has a" |  | "FN" |  |
| fn:emphasizing | /r/HasA | fn:fe:competing_consideration | "emphasizing" | "competing consideration" | "/r/has a" |  | "FN" |  |
| fn:emphasizing | /r/HasA | fn:fe:time | "emphasizing" | "time" | "/r/has a" |  | "FN" |  |
| fn:emphasizing | /r/HasA | fn:fe:place | "emphasizing" | "place" | "/r/has a" |  | "FN" |  |
| fn:emphasizing | /r/HasA | fn:fe:manner | "emphasizing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fe:artifact | /r/RelatedTo | fn:fe:agent | "artifact" | "agent" | "/r/related to" |  | "FN" |  |
| fn:emphasizing | /r/HasA | fn:fe:artifact | "emphasizing" | "artifact" | "/r/has a" |  | "FN" |  |
| fn:fe:action | /r/RelatedTo | fn:fe:agent | "action" | "agent" | "/r/related to" |  | "FN" |  |
| fn:emphasizing | /r/HasA | fn:fe:action | "emphasizing" | "action" | "/r/has a" |  | "FN" |  |
| fn:emphasizing | /r/HasA | fn:fe:frequency | "emphasizing" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:emphasizing | /r/HasA | fn:fe:depictive | "emphasizing" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:employee_scenario | /r/HasSubevent | fn:being_employed | "employee scenario" | "being employed" | "/r/has subevent" |  | "FN" |  |
| fn:employee_scenario | /r/HasSubevent | fn:get_a_job | "employee scenario" | "get a job" | "/r/has subevent" |  | "FN" |  |
| fn:employee_scenario | /r/HasSubevent | fn:quitting | "employee scenario" | "quitting" | "/r/has subevent" |  | "FN" |  |
| fn:employee_scenario | /r/IsA | fn:employment_scenario | "employee scenario" | "employment scenario" | "/r/is a" |  | "FN" |  |
| fn:employee_scenario | /r/HasA | fn:fe:compensation | "employee scenario" | "compensation" | "/r/has a" |  | "FN" |  |
| fn:fe:employee | /r/IsA | fn:st:human | "employee" | "human" | "/r/is a" |  | "FN" |  |
| fn:employee_scenario | /r/HasA | fn:fe:employee | "employee scenario" | "employee" | "/r/has a" |  | "FN" |  |
| fn:employee_scenario | /r/HasA | fn:fe:employer | "employee scenario" | "employer" | "/r/has a" |  | "FN" |  |
| fn:employee_scenario | /r/HasA | fn:fe:position | "employee scenario" | "position" | "/r/has a" |  | "FN" |  |
| fn:employee_scenario | /r/HasA | fn:fe:task | "employee scenario" | "task" | "/r/has a" |  | "FN" |  |
| fn:employee_scenario | /r/HasA | fn:fe:field | "employee scenario" | "field" | "/r/has a" |  | "FN" |  |
| fn:employee_scenario | /r/HasA | fn:fe:duration | "employee scenario" | "duration" | "/r/has a" |  | "FN" |  |
| fn:employer_scenario | /r/HasSubevent | fn:employing | "employer scenario" | "employing" | "/r/has subevent" |  | "FN" |  |
| fn:employer_scenario | /r/HasSubevent | fn:firing | "employer scenario" | "firing" | "/r/has subevent" |  | "FN" |  |
| fn:employer_scenario | /r/HasSubevent | fn:hiring | "employer scenario" | "hiring" | "/r/has subevent" |  | "FN" |  |
| fn:employer_scenario | /r/IsA | fn:employment_scenario | "employer scenario" | "employment scenario" | "/r/is a" |  | "FN" |  |
| fn:employer_scenario | /r/HasA | fn:fe:compensation | "employer scenario" | "compensation" | "/r/has a" |  | "FN" |  |
| fn:employer_scenario | /r/HasA | fn:fe:employee | "employer scenario" | "employee" | "/r/has a" |  | "FN" |  |
| fn:employer_scenario | /r/HasA | fn:fe:employer | "employer scenario" | "employer" | "/r/has a" |  | "FN" |  |
| fn:employer_scenario | /r/HasA | fn:fe:position | "employer scenario" | "position" | "/r/has a" |  | "FN" |  |
| fn:employer_scenario | /r/HasA | fn:fe:task | "employer scenario" | "task" | "/r/has a" |  | "FN" |  |
| fn:employer_scenario | /r/HasA | fn:fe:field | "employer scenario" | "field" | "/r/has a" |  | "FN" |  |
| fn:employer_scenario | /r/HasA | fn:fe:duration | "employer scenario" | "duration" | "/r/has a" |  | "FN" |  |
| fn:employer_scenario | /r/HasSubevent | fn:employing | "employer scenario" | "employing" | "/r/has subevent" |  | "FN" |  |
| fn:firing | /r/HasPrerequisite | fn:employing | "firing" | "employing" | "/r/has prerequisite" |  | "FN" |  |
| fn:employing | /r/HasPrerequisite | fn:hiring | "employing" | "hiring" | "/r/has prerequisite" |  | "FN" |  |
| fn:employing | /r/IsA | fn:employment_continue | "employing" | "employment continue" | "/r/is a" |  | "FN" |  |
| fn:employing | fn:HasLexicalUnit | fn:lu:employing:employ | "employing" | "employ" | "has lexical unit" |  | "FN" |  |
| fn:employing | fn:HasLexicalUnit | fn:lu:employing:employer | "employing" | "employer" | "has lexical unit" |  | "FN" |  |
| fn:employing | fn:HasLexicalUnit | fn:lu:employing:employee | "employing" | "employee" | "has lexical unit" |  | "FN" |  |
| fn:employing | fn:HasLexicalUnit | fn:lu:employing:commission | "employing" | "commission" | "has lexical unit" |  | "FN" |  |
| fn:employing | fn:HasLexicalUnit | fn:lu:employing:personnel | "employing" | "personnel" | "has lexical unit" |  | "FN" |  |
| fn:employing | fn:HasLexicalUnit | fn:lu:employing:staff | "employing" | "staff" | "has lexical unit" |  | "FN" |  |
| fn:employing | fn:HasLexicalUnit | fn:lu:employing:employment | "employing" | "employment" | "has lexical unit" |  | "FN" |  |
| fn:employing | fn:HasLexicalUnit | fn:lu:employing:worker | "employing" | "worker" | "has lexical unit" |  | "FN" |  |
| fn:employing | /r/HasA | fn:fe:compensation | "employing" | "compensation" | "/r/has a" |  | "FN" |  |
| fn:employing | /r/HasA | fn:fe:employee | "employing" | "employee" | "/r/has a" |  | "FN" |  |
| fn:employing | /r/HasA | fn:fe:employer | "employing" | "employer" | "/r/has a" |  | "FN" |  |
| fn:employing | /r/HasA | fn:fe:field | "employing" | "field" | "/r/has a" |  | "FN" |  |
| fn:employing | /r/HasA | fn:fe:manner | "employing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:employing | /r/HasA | fn:fe:place | "employing" | "place" | "/r/has a" |  | "FN" |  |
| fn:employing | /r/HasA | fn:fe:position | "employing" | "position" | "/r/has a" |  | "FN" |  |
| fn:employing | /r/HasA | fn:fe:purpose | "employing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:employing | /r/HasA | fn:fe:task | "employing" | "task" | "/r/has a" |  | "FN" |  |
| fn:employing | /r/HasA | fn:fe:time | "employing" | "time" | "/r/has a" |  | "FN" |  |
| fn:employing | /r/HasA | fn:fe:duration | "employing" | "duration" | "/r/has a" |  | "FN" |  |
| fn:employing | /r/HasA | fn:fe:contract_basis | "employing" | "contract basis" | "/r/has a" |  | "FN" |  |
| fn:employing | /r/HasA | fn:fe:descriptor | "employing" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:employing | /r/HasA | fn:fe:subgroup | "employing" | "subgroup" | "/r/has a" |  | "FN" |  |
| fn:employment_scenario | /r/HasSubevent | fn:employment_continue | "employment scenario" | "employment continue" | "/r/has subevent" |  | "FN" |  |
| fn:employment_end | /r/HasPrerequisite | fn:employment_continue | "employment end" | "employment continue" | "/r/has prerequisite" |  | "FN" |  |
| fn:employment_continue | /r/HasPrerequisite | fn:employment_start | "employment continue" | "employment start" | "/r/has prerequisite" |  | "FN" |  |
| fn:being_employed | /r/IsA | fn:employment_continue | "being employed" | "employment continue" | "/r/is a" |  | "FN" |  |
| fn:employing | /r/IsA | fn:employment_continue | "employing" | "employment continue" | "/r/is a" |  | "FN" |  |
| fn:employment_continue | /r/HasA | fn:fe:employee | "employment continue" | "employee" | "/r/has a" |  | "FN" |  |
| fn:employment_continue | /r/HasA | fn:fe:employer | "employment continue" | "employer" | "/r/has a" |  | "FN" |  |
| fn:employment_continue | /r/HasA | fn:fe:compensation | "employment continue" | "compensation" | "/r/has a" |  | "FN" |  |
| fn:employment_continue | /r/HasA | fn:fe:duration | "employment continue" | "duration" | "/r/has a" |  | "FN" |  |
| fn:employment_continue | /r/HasA | fn:fe:field | "employment continue" | "field" | "/r/has a" |  | "FN" |  |
| fn:employment_continue | /r/HasA | fn:fe:manner | "employment continue" | "manner" | "/r/has a" |  | "FN" |  |
| fn:employment_continue | /r/HasA | fn:fe:place | "employment continue" | "place" | "/r/has a" |  | "FN" |  |
| fn:employment_continue | /r/HasA | fn:fe:position | "employment continue" | "position" | "/r/has a" |  | "FN" |  |
| fn:employment_continue | /r/HasA | fn:fe:task | "employment continue" | "task" | "/r/has a" |  | "FN" |  |
| fn:employment_continue | /r/HasA | fn:fe:time | "employment continue" | "time" | "/r/has a" |  | "FN" |  |
| fn:firing | /r/IsA | fn:employment_end | "firing" | "employment end" | "/r/is a" |  | "FN" |  |
| fn:quitting | /r/IsA | fn:employment_end | "quitting" | "employment end" | "/r/is a" |  | "FN" |  |
| fn:employment_scenario | /r/HasSubevent | fn:employment_end | "employment scenario" | "employment end" | "/r/has subevent" |  | "FN" |  |
| fn:employment_end | /r/HasPrerequisite | fn:employment_continue | "employment end" | "employment continue" | "/r/has prerequisite" |  | "FN" |  |
| fn:employment_end | /r/HasA | fn:fe:employee | "employment end" | "employee" | "/r/has a" |  | "FN" |  |
| fn:employment_end | /r/HasA | fn:fe:employer | "employment end" | "employer" | "/r/has a" |  | "FN" |  |
| fn:employment_end | /r/HasA | fn:fe:manner | "employment end" | "manner" | "/r/has a" |  | "FN" |  |
| fn:employment_end | /r/HasA | fn:fe:place | "employment end" | "place" | "/r/has a" |  | "FN" |  |
| fn:employment_end | /r/HasA | fn:fe:position | "employment end" | "position" | "/r/has a" |  | "FN" |  |
| fn:employment_end | /r/HasA | fn:fe:time | "employment end" | "time" | "/r/has a" |  | "FN" |  |
| fn:employment_scenario | /r/HasSubevent | fn:employment_continue | "employment scenario" | "employment continue" | "/r/has subevent" |  | "FN" |  |
| fn:employment_scenario | /r/HasSubevent | fn:employment_end | "employment scenario" | "employment end" | "/r/has subevent" |  | "FN" |  |
| fn:employment_scenario | /r/HasSubevent | fn:employment_start | "employment scenario" | "employment start" | "/r/has subevent" |  | "FN" |  |
| fn:employment_scenario | /r/UsedFor | fn:fields | "employment scenario" | "fields" | "/r/used for" |  | "FN" |  |
| fn:employee_scenario | /r/IsA | fn:employment_scenario | "employee scenario" | "employment scenario" | "/r/is a" |  | "FN" |  |
| fn:employer_scenario | /r/IsA | fn:employment_scenario | "employer scenario" | "employment scenario" | "/r/is a" |  | "FN" |  |
| fn:employment_scenario | /r/HasA | fn:fe:compensation | "employment scenario" | "compensation" | "/r/has a" |  | "FN" |  |
| fn:employment_scenario | /r/HasA | fn:fe:employee | "employment scenario" | "employee" | "/r/has a" |  | "FN" |  |
| fn:employment_scenario | /r/HasA | fn:fe:employer | "employment scenario" | "employer" | "/r/has a" |  | "FN" |  |
| fn:employment_scenario | /r/HasA | fn:fe:position | "employment scenario" | "position" | "/r/has a" |  | "FN" |  |
| fn:employment_scenario | /r/HasA | fn:fe:task | "employment scenario" | "task" | "/r/has a" |  | "FN" |  |
| fn:employment_scenario | /r/HasA | fn:fe:field | "employment scenario" | "field" | "/r/has a" |  | "FN" |  |
| fn:employment_scenario | /r/HasA | fn:fe:duration | "employment scenario" | "duration" | "/r/has a" |  | "FN" |  |
| fn:employment_scenario | /r/HasSubevent | fn:employment_start | "employment scenario" | "employment start" | "/r/has subevent" |  | "FN" |  |
| fn:employment_continue | /r/HasPrerequisite | fn:employment_start | "employment continue" | "employment start" | "/r/has prerequisite" |  | "FN" |  |
| fn:get_a_job | /r/IsA | fn:employment_start | "get a job" | "employment start" | "/r/is a" |  | "FN" |  |
| fn:hiring | /r/IsA | fn:employment_start | "hiring" | "employment start" | "/r/is a" |  | "FN" |  |
| fn:employment_start | /r/HasA | fn:fe:employee | "employment start" | "employee" | "/r/has a" |  | "FN" |  |
| fn:employment_start | /r/HasA | fn:fe:employer | "employment start" | "employer" | "/r/has a" |  | "FN" |  |
| fn:employment_start | /r/HasA | fn:fe:compensation | "employment start" | "compensation" | "/r/has a" |  | "FN" |  |
| fn:employment_start | /r/HasA | fn:fe:field | "employment start" | "field" | "/r/has a" |  | "FN" |  |
| fn:employment_start | /r/HasA | fn:fe:manner | "employment start" | "manner" | "/r/has a" |  | "FN" |  |
| fn:employment_start | /r/HasA | fn:fe:place | "employment start" | "place" | "/r/has a" |  | "FN" |  |
| fn:employment_start | /r/HasA | fn:fe:position | "employment start" | "position" | "/r/has a" |  | "FN" |  |
| fn:employment_start | /r/HasA | fn:fe:task | "employment start" | "task" | "/r/has a" |  | "FN" |  |
| fn:employment_start | /r/HasA | fn:fe:time | "employment start" | "time" | "/r/has a" |  | "FN" |  |
| fn:emptying | /r/IsA | fn:container_focused_removing | "emptying" | "container focused removing" | "/r/is a" |  | "FN" |  |
| fn:cause_motion | /r/RelatedTo | fn:emptying | "cause motion" | "emptying" | "/r/related to" |  | "FN" |  |
| fn:removing | /r/SimilarTo | fn:emptying | "removing" | "emptying" | "/r/similar to" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:clear | "emptying" | "clear" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:drain | "emptying" | "drain" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:empty | "emptying" | "empty" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:purge | "emptying" | "purge" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:strip | "emptying" | "strip" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:divest | "emptying" | "divest" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:rid | "emptying" | "rid" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:disembowel | "emptying" | "disembowel" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:skin | "emptying" | "skin" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:core | "emptying" | "core" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:peel | "emptying" | "peel" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:gut | "emptying" | "gut" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:bone | "emptying" | "bone" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:debug | "emptying" | "debug" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:deforest | "emptying" | "deforest" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:degrease | "emptying" | "degrease" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:descale | "emptying" | "descale" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:scalp | "emptying" | "scalp" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:defrost | "emptying" | "defrost" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:delouse | "emptying" | "delouse" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:eviscerate | "emptying" | "eviscerate" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:denude | "emptying" | "denude" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:unload | "emptying" | "unload" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:emptying | "emptying" | "emptying" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:expurgate | "emptying" | "expurgate" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:void | "emptying" | "void" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:evacuate | "emptying" | "evacuate" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:debone | "emptying" | "debone" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:devein | "emptying" | "devein" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:disarm | "emptying" | "disarm" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:disarmament | "emptying" | "disarmament" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:decontaminate | "emptying" | "decontaminate" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:decontamination | "emptying" | "decontamination" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:cleanse | "emptying" | "cleanse" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:pit | "emptying" | "pit" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:seed | "emptying" | "seed" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:stone | "emptying" | "stone" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:stalk | "emptying" | "stalk" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:flush | "emptying" | "flush" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:expunge | "emptying" | "expunge" | "has lexical unit" |  | "FN" |  |
| fn:emptying | fn:HasLexicalUnit | fn:lu:emptying:weed | "emptying" | "weed" | "has lexical unit" |  | "FN" |  |
| fn:emptying | /r/HasA | fn:fe:agent | "emptying" | "agent" | "/r/has a" |  | "FN" |  |
| fn:emptying | /r/HasA | fn:fe:theme | "emptying" | "theme" | "/r/has a" |  | "FN" |  |
| fn:emptying | /r/HasA | fn:fe:source | "emptying" | "source" | "/r/has a" |  | "FN" |  |
| fn:emptying | /r/HasA | fn:fe:path | "emptying" | "path" | "/r/has a" |  | "FN" |  |
| fn:emptying | /r/HasA | fn:fe:goal | "emptying" | "goal" | "/r/has a" |  | "FN" |  |
| fn:emptying | /r/HasA | fn:fe:degree | "emptying" | "degree" | "/r/has a" |  | "FN" |  |
| fn:emptying | /r/HasA | fn:fe:depictive | "emptying" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:emptying | /r/HasA | fn:fe:manner | "emptying" | "manner" | "/r/has a" |  | "FN" |  |
| fn:emptying | /r/HasA | fn:fe:means | "emptying" | "means" | "/r/has a" |  | "FN" |  |
| fn:emptying | /r/HasA | fn:fe:result | "emptying" | "result" | "/r/has a" |  | "FN" |  |
| fn:emptying | /r/HasA | fn:fe:instrument | "emptying" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:emptying | /r/HasA | fn:fe:cause | "emptying" | "cause" | "/r/has a" |  | "FN" |  |
| fn:emptying | /r/HasA | fn:fe:place | "emptying" | "place" | "/r/has a" |  | "FN" |  |
| fn:emptying | /r/HasA | fn:fe:time | "emptying" | "time" | "/r/has a" |  | "FN" |  |
| fn:emptying | /r/HasA | fn:fe:containing_event | "emptying" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:emptying | /r/HasA | fn:fe:explanation | "emptying" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:emptying | /r/HasA | fn:fe:circumstances | "emptying" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:emptying | /r/HasA | fn:fe:purpose | "emptying" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:encoding | "communication" | "encoding" | "/r/used for" |  | "FN" |  |
| fn:encoding | /r/SimilarTo | fn:statement | "encoding" | "statement" | "/r/similar to" |  | "FN" |  |
| fn:statement | /r/SimilarTo | fn:encoding | "statement" | "encoding" | "/r/similar to" |  | "FN" |  |
| fn:encoding | fn:HasLexicalUnit | fn:lu:encoding:couch | "encoding" | "couch" | "has lexical unit" |  | "FN" |  |
| fn:encoding | fn:HasLexicalUnit | fn:lu:encoding:expression | "encoding" | "expression" | "has lexical unit" |  | "FN" |  |
| fn:encoding | fn:HasLexicalUnit | fn:lu:encoding:formulation | "encoding" | "formulation" | "has lexical unit" |  | "FN" |  |
| fn:encoding | fn:HasLexicalUnit | fn:lu:encoding:frame | "encoding" | "frame" | "has lexical unit" |  | "FN" |  |
| fn:encoding | fn:HasLexicalUnit | fn:lu:encoding:phrase | "encoding" | "phrase" | "has lexical unit" |  | "FN" |  |
| fn:encoding | fn:HasLexicalUnit | fn:lu:encoding:put | "encoding" | "put" | "has lexical unit" |  | "FN" |  |
| fn:encoding | fn:HasLexicalUnit | fn:lu:encoding:word | "encoding" | "word" | "has lexical unit" |  | "FN" |  |
| fn:encoding | fn:HasLexicalUnit | fn:lu:encoding:wording | "encoding" | "wording" | "has lexical unit" |  | "FN" |  |
| fn:encoding | fn:HasLexicalUnit | fn:lu:encoding:phrasing | "encoding" | "phrasing" | "has lexical unit" |  | "FN" |  |
| fn:encoding | fn:HasLexicalUnit | fn:lu:encoding:misword | "encoding" | "misword" | "has lexical unit" |  | "FN" |  |
| fn:encoding | fn:HasLexicalUnit | fn:lu:encoding:express | "encoding" | "express" | "has lexical unit" |  | "FN" |  |
| fn:encoding | fn:HasLexicalUnit | fn:lu:encoding:cast | "encoding" | "cast" | "has lexical unit" |  | "FN" |  |
| fn:encoding | /r/HasA | fn:fe:speaker | "encoding" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:encoding | /r/HasA | fn:fe:message | "encoding" | "message" | "/r/has a" |  | "FN" |  |
| fn:encoding | /r/HasA | fn:fe:manner | "encoding" | "manner" | "/r/has a" |  | "FN" |  |
| fn:encoding | /r/HasA | fn:fe:medium | "encoding" | "medium" | "/r/has a" |  | "FN" |  |
| fn:encoding | /r/HasA | fn:fe:addressee | "encoding" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:encoding | /r/HasA | fn:fe:means | "encoding" | "means" | "/r/has a" |  | "FN" |  |
| fn:encounter | /r/IsA | fn:come_together | "encounter" | "come together" | "/r/is a" |  | "FN" |  |
| fn:encounter | fn:HasLexicalUnit | fn:lu:encounter:encounter | "encounter" | "encounter" | "has lexical unit" |  | "FN" |  |
| fn:encounter | fn:HasLexicalUnit | fn:lu:encounter:stumble | "encounter" | "stumble" | "has lexical unit" |  | "FN" |  |
| fn:encounter | /r/HasA | fn:fe:group | "encounter" | "group" | "/r/has a" |  | "FN" |  |
| fn:encounter | /r/HasA | fn:fe:individuals | "encounter" | "individuals" | "/r/has a" |  | "FN" |  |
| fn:encounter | /r/HasA | fn:fe:party_1 | "encounter" | "party 1" | "/r/has a" |  | "FN" |  |
| fn:encounter | /r/HasA | fn:fe:party_2 | "encounter" | "party 2" | "/r/has a" |  | "FN" |  |
| fn:encounter | /r/HasA | fn:fe:manner | "encounter" | "manner" | "/r/has a" |  | "FN" |  |
| fn:encounter | /r/HasA | fn:fe:means | "encounter" | "means" | "/r/has a" |  | "FN" |  |
| fn:encounter | /r/HasA | fn:fe:time | "encounter" | "time" | "/r/has a" |  | "FN" |  |
| fn:encounter | /r/HasA | fn:fe:place | "encounter" | "place" | "/r/has a" |  | "FN" |  |
| fn:endangering | /r/IsA | fn:transitive_action | "endangering" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:endangering | /r/Causes | fn:being_at_risk | "endangering" | "being at risk" | "/r/causes" |  | "FN" |  |
| fn:endangering | fn:HasLexicalUnit | fn:lu:endangering:imperil | "endangering" | "imperil" | "has lexical unit" |  | "FN" |  |
| fn:endangering | fn:HasLexicalUnit | fn:lu:endangering:endanger | "endangering" | "endanger" | "has lexical unit" |  | "FN" |  |
| fn:endangering | fn:HasLexicalUnit | fn:lu:endangering:endangerment | "endangering" | "endangerment" | "has lexical unit" |  | "FN" |  |
| fn:endangering | fn:HasLexicalUnit | fn:lu:endangering:jeopardise | "endangering" | "jeopardise" | "has lexical unit" |  | "FN" |  |
| fn:endangering | /r/HasA | fn:fe:cause | "endangering" | "cause" | "/r/has a" |  | "FN" |  |
| fn:endangering | /r/HasA | fn:fe:valued_entity | "endangering" | "valued entity" | "/r/has a" |  | "FN" |  |
| fn:endangering | /r/HasA | fn:fe:agent | "endangering" | "agent" | "/r/has a" |  | "FN" |  |
| fn:endangering | /r/HasA | fn:fe:endangering_act | "endangering" | "endangering act" | "/r/has a" |  | "FN" |  |
| fn:endangering | /r/HasA | fn:fe:manner | "endangering" | "manner" | "/r/has a" |  | "FN" |  |
| fn:endangering | /r/HasA | fn:fe:place | "endangering" | "place" | "/r/has a" |  | "FN" |  |
| fn:endangering | /r/HasA | fn:fe:time | "endangering" | "time" | "/r/has a" |  | "FN" |  |
| fn:business_closure | /r/IsA | fn:endeavor_failure | "business closure" | "endeavor failure" | "/r/is a" |  | "FN" |  |
| fn:endeavor_failure | /r/IsA | fn:success_or_failure | "endeavor failure" | "success or failure" | "/r/is a" |  | "FN" |  |
| fn:endeavor_failure | /r/RelatedTo | fn:business_closure | "endeavor failure" | "business closure" | "/r/related to" |  | "FN" |  |
| fn:endeavor_failure | /r/RelatedTo | fn:locale_closure | "endeavor failure" | "locale closure" | "/r/related to" |  | "FN" |  |
| fn:endeavor_failure | fn:HasLexicalUnit | fn:lu:endeavor_failure:fail | "endeavor failure" | "fail" | "has lexical unit" |  | "FN" |  |
| fn:endeavor_failure | fn:HasLexicalUnit | fn:lu:endeavor_failure:flop | "endeavor failure" | "flop" | "has lexical unit" |  | "FN" |  |
| fn:endeavor_failure | fn:HasLexicalUnit | fn:lu:endeavor_failure:collapse | "endeavor failure" | "collapse" | "has lexical unit" |  | "FN" |  |
| fn:endeavor_failure | fn:HasLexicalUnit | fn:lu:endeavor_failure:fold | "endeavor failure" | "fold" | "has lexical unit" |  | "FN" |  |
| fn:endeavor_failure | fn:HasLexicalUnit | fn:lu:endeavor_failure:go_under | "endeavor failure" | "go under" | "has lexical unit" |  | "FN" |  |
| fn:endeavor_failure | fn:HasLexicalUnit | fn:lu:endeavor_failure:go_bust | "endeavor failure" | "go bust" | "has lexical unit" |  | "FN" |  |
| fn:endeavor_failure | /r/HasA | fn:fe:endeavor | "endeavor failure" | "endeavor" | "/r/has a" |  | "FN" |  |
| fn:endeavor_failure | /r/HasA | fn:fe:explanation | "endeavor failure" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:endeavor_failure | /r/HasA | fn:fe:time | "endeavor failure" | "time" | "/r/has a" |  | "FN" |  |
| fn:endeavor_failure | /r/HasA | fn:fe:place | "endeavor failure" | "place" | "/r/has a" |  | "FN" |  |
| fn:endeavor_failure | /r/HasA | fn:fe:circumstances | "endeavor failure" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:endeavor_failure | /r/HasA | fn:fe:manner | "endeavor failure" | "manner" | "/r/has a" |  | "FN" |  |
| fn:endeavor_failure | /r/HasA | fn:fe:containing_event | "endeavor failure" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:endeavor_failure | /r/HasA | fn:fe:depictive | "endeavor failure" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:endeavor_failure | /r/HasA | fn:fe:degree | "endeavor failure" | "degree" | "/r/has a" |  | "FN" |  |
| fn:endeavor_failure | /r/HasA | fn:fe:means | "endeavor failure" | "means" | "/r/has a" |  | "FN" |  |
| fn:enforcing | /r/IsA | fn:execute_plan | "enforcing" | "execute plan" | "/r/is a" |  | "FN" |  |
| fn:being_in_effect | /r/UsedFor | fn:enforcing | "being in effect" | "enforcing" | "/r/used for" |  | "FN" |  |
| fn:enforcing | fn:HasLexicalUnit | fn:lu:enforcing:enforce | "enforcing" | "enforce" | "has lexical unit" |  | "FN" |  |
| fn:enforcing | fn:HasLexicalUnit | fn:lu:enforcing:enforcement | "enforcing" | "enforcement" | "has lexical unit" |  | "FN" |  |
| fn:enforcing | /r/HasA | fn:fe:rule | "enforcing" | "rule" | "/r/has a" |  | "FN" |  |
| fn:enforcing | /r/HasA | fn:fe:duration | "enforcing" | "duration" | "/r/has a" |  | "FN" |  |
| fn:enforcing | /r/HasA | fn:fe:time | "enforcing" | "time" | "/r/has a" |  | "FN" |  |
| fn:enforcing | /r/HasA | fn:fe:place | "enforcing" | "place" | "/r/has a" |  | "FN" |  |
| fn:enforcing | /r/HasA | fn:fe:circumstances | "enforcing" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:enforcing | /r/HasA | fn:fe:explanation | "enforcing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:enforcing | /r/HasA | fn:fe:focal_participant | "enforcing" | "focal participant" | "/r/has a" |  | "FN" |  |
| fn:enforcing | /r/HasA | fn:fe:agent | "enforcing" | "agent" | "/r/has a" |  | "FN" |  |
| fn:enforcing | /r/HasA | fn:fe:manner | "enforcing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:enforcing | /r/HasA | fn:fe:means | "enforcing" | "means" | "/r/has a" |  | "FN" |  |
| fn:enforcing | /r/HasA | fn:fe:purpose | "enforcing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:enforcing | /r/HasA | fn:fe:degree | "enforcing" | "degree" | "/r/has a" |  | "FN" |  |
| fn:enforcing | /r/HasA | fn:fe:medium | "enforcing" | "medium" | "/r/has a" |  | "FN" |  |
| fn:enforcing | /r/HasA | fn:fe:outcome | "enforcing" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:arraignment | /r/HasSubevent | fn:entering_of_plea | "arraignment" | "entering of plea" | "/r/has subevent" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:entering_of_plea | "communication" | "entering of plea" | "/r/used for" |  | "FN" |  |
| fn:citing | /r/RelatedTo | fn:entering_of_plea | "citing" | "entering of plea" | "/r/related to" |  | "FN" |  |
| fn:appeal | /r/SimilarTo | fn:entering_of_plea | "appeal" | "entering of plea" | "/r/similar to" |  | "FN" |  |
| fn:bail_decision | /r/HasPrerequisite | fn:entering_of_plea | "bail decision" | "entering of plea" | "/r/has prerequisite" |  | "FN" |  |
| fn:entering_of_plea | /r/HasPrerequisite | fn:notification_of_charges | "entering of plea" | "notification of charges" | "/r/has prerequisite" |  | "FN" |  |
| fn:entering_of_plea | fn:HasLexicalUnit | fn:lu:entering_of_plea:plead | "entering of plea" | "plead" | "has lexical unit" |  | "FN" |  |
| fn:entering_of_plea | fn:HasLexicalUnit | fn:lu:entering_of_plea:plea | "entering of plea" | "plea" | "has lexical unit" |  | "FN" |  |
| fn:entering_of_plea | /r/HasA | fn:fe:judge | "entering of plea" | "judge" | "/r/has a" |  | "FN" |  |
| fn:entering_of_plea | /r/HasA | fn:fe:accused | "entering of plea" | "accused" | "/r/has a" |  | "FN" |  |
| fn:entering_of_plea | /r/HasA | fn:fe:charges | "entering of plea" | "charges" | "/r/has a" |  | "FN" |  |
| fn:entering_of_plea | /r/HasA | fn:fe:plea | "entering of plea" | "plea" | "/r/has a" |  | "FN" |  |
| fn:entering_of_plea | /r/HasA | fn:fe:time | "entering of plea" | "time" | "/r/has a" |  | "FN" |  |
| fn:entering_of_plea | /r/HasA | fn:fe:place | "entering of plea" | "place" | "/r/has a" |  | "FN" |  |
| fn:entering_of_plea | /r/HasA | fn:fe:court | "entering of plea" | "court" | "/r/has a" |  | "FN" |  |
| fn:actually_occurring_entity | /r/IsA | fn:entity | "actually occurring entity" | "entity" | "/r/is a" |  | "FN" |  |
| fn:artifact | /r/IsA | fn:entity | "artifact" | "entity" | "/r/is a" |  | "FN" |  |
| fn:biological_entity | /r/IsA | fn:entity | "biological entity" | "entity" | "/r/is a" |  | "FN" |  |
| fn:physical_entity | /r/IsA | fn:entity | "physical entity" | "entity" | "/r/is a" |  | "FN" |  |
| fn:entity | /r/UsedFor | fn:cycle_of_existence_scenario | "entity" | "cycle of existence scenario" | "/r/used for" |  | "FN" |  |
| fn:entity | fn:HasLexicalUnit | fn:lu:entity:item | "entity" | "item" | "has lexical unit" |  | "FN" |  |
| fn:entity | fn:HasLexicalUnit | fn:lu:entity:entity | "entity" | "entity" | "has lexical unit" |  | "FN" |  |
| fn:entity | fn:HasLexicalUnit | fn:lu:entity:object | "entity" | "object" | "has lexical unit" |  | "FN" |  |
| fn:entity | fn:HasLexicalUnit | fn:lu:entity:thing | "entity" | "thing" | "has lexical unit" |  | "FN" |  |
| fn:entity | fn:HasLexicalUnit | fn:lu:entity:individual | "entity" | "individual" | "has lexical unit" |  | "FN" |  |
| fn:entity | fn:HasLexicalUnit | fn:lu:entity:what | "entity" | "what" | "has lexical unit" |  | "FN" |  |
| fn:entity | /r/HasA | fn:fe:constituent_parts | "entity" | "constituent parts" | "/r/has a" |  | "FN" |  |
| fn:entity | /r/HasA | fn:fe:formational_cause | "entity" | "formational cause" | "/r/has a" |  | "FN" |  |
| fn:entity | /r/HasA | fn:fe:name | "entity" | "name" | "/r/has a" |  | "FN" |  |
| fn:entity | /r/HasA | fn:fe:entity | "entity" | "entity" | "/r/has a" |  | "FN" |  |
| fn:entity | /r/HasA | fn:fe:type | "entity" | "type" | "/r/has a" |  | "FN" |  |
| fn:entourage | /r/IsA | fn:aggregate | "entourage" | "aggregate" | "/r/is a" |  | "FN" |  |
| fn:cotheme | /r/UsedFor | fn:entourage | "cotheme" | "entourage" | "/r/used for" |  | "FN" |  |
| fn:entourage | fn:HasLexicalUnit | fn:lu:entourage:entourage | "entourage" | "entourage" | "has lexical unit" |  | "FN" |  |
| fn:entourage | fn:HasLexicalUnit | fn:lu:entourage:retinue | "entourage" | "retinue" | "has lexical unit" |  | "FN" |  |
| fn:entourage | fn:HasLexicalUnit | fn:lu:entourage:tail | "entourage" | "tail" | "has lexical unit" |  | "FN" |  |
| fn:entourage | fn:HasLexicalUnit | fn:lu:entourage:train | "entourage" | "train" | "has lexical unit" |  | "FN" |  |
| fn:entourage | /r/HasA | fn:fe:individuals | "entourage" | "individuals" | "/r/has a" |  | "FN" |  |
| fn:entourage | /r/HasA | fn:fe:entourage | "entourage" | "entourage" | "/r/has a" |  | "FN" |  |
| fn:entourage | /r/HasA | fn:fe:aggregate_property | "entourage" | "aggregate property" | "/r/has a" |  | "FN" |  |
| fn:entourage | /r/HasA | fn:fe:name | "entourage" | "name" | "/r/has a" |  | "FN" |  |
| fn:entourage | /r/HasA | fn:fe:container_possessor | "entourage" | "container possessor" | "/r/has a" |  | "FN" |  |
| fn:entourage | /r/HasA | fn:fe:domain | "entourage" | "domain" | "/r/has a" |  | "FN" |  |
| fn:entourage | /r/HasA | fn:fe:attended_person | "entourage" | "attended person" | "/r/has a" |  | "FN" |  |
| fn:erasing | /r/IsA | fn:transitive_action | "erasing" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:erasing | fn:HasLexicalUnit | fn:lu:erasing:strike | "erasing" | "strike" | "has lexical unit" |  | "FN" |  |
| fn:erasing | fn:HasLexicalUnit | fn:lu:erasing:delete | "erasing" | "delete" | "has lexical unit" |  | "FN" |  |
| fn:erasing | fn:HasLexicalUnit | fn:lu:erasing:erase | "erasing" | "erase" | "has lexical unit" |  | "FN" |  |
| fn:erasing | fn:HasLexicalUnit | fn:lu:erasing:expunge | "erasing" | "expunge" | "has lexical unit" |  | "FN" |  |
| fn:erasing | fn:HasLexicalUnit | fn:lu:erasing:kill | "erasing" | "kill" | "has lexical unit" |  | "FN" |  |
| fn:erasing | /r/HasA | fn:fe:agent | "erasing" | "agent" | "/r/has a" |  | "FN" |  |
| fn:erasing | /r/HasA | fn:fe:information | "erasing" | "information" | "/r/has a" |  | "FN" |  |
| fn:erasing | /r/HasA | fn:fe:cause | "erasing" | "cause" | "/r/has a" |  | "FN" |  |
| fn:erasing | /r/HasA | fn:fe:document | "erasing" | "document" | "/r/has a" |  | "FN" |  |
| fn:erasing | /r/HasA | fn:fe:manner | "erasing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:erasing | /r/HasA | fn:fe:time | "erasing" | "time" | "/r/has a" |  | "FN" |  |
| fn:erasing | /r/HasA | fn:fe:place | "erasing" | "place" | "/r/has a" |  | "FN" |  |
| fn:erasing | /r/HasA | fn:fe:means | "erasing" | "means" | "/r/has a" |  | "FN" |  |
| fn:escaping | /r/IsA | fn:departing | "escaping" | "departing" | "/r/is a" |  | "FN" |  |
| fn:avoiding | /r/SimilarTo | fn:escaping | "avoiding" | "escaping" | "/r/similar to" |  | "FN" |  |
| fn:cotheme | /r/SimilarTo | fn:escaping | "cotheme" | "escaping" | "/r/similar to" |  | "FN" |  |
| fn:escaping | /r/SimilarTo | fn:fleeing | "escaping" | "fleeing" | "/r/similar to" |  | "FN" |  |
| fn:removing | /r/SimilarTo | fn:escaping | "removing" | "escaping" | "/r/similar to" |  | "FN" |  |
| fn:self_motion | /r/SimilarTo | fn:escaping | "self motion" | "escaping" | "/r/similar to" |  | "FN" |  |
| fn:escaping | fn:HasLexicalUnit | fn:lu:escaping:escape | "escaping" | "escape" | "has lexical unit" |  | "FN" |  |
| fn:escaping | fn:HasLexicalUnit | fn:lu:escaping:evacuate | "escaping" | "evacuate" | "has lexical unit" |  | "FN" |  |
| fn:escaping | fn:HasLexicalUnit | fn:lu:escaping:get_out | "escaping" | "get out" | "has lexical unit" |  | "FN" |  |
| fn:escaping | fn:HasLexicalUnit | fn:lu:escaping:bust_out | "escaping" | "bust out" | "has lexical unit" |  | "FN" |  |
| fn:escaping | fn:HasLexicalUnit | fn:lu:escaping:fly_the_coop | "escaping" | "fly the coop" | "has lexical unit" |  | "FN" |  |
| fn:escaping | fn:HasLexicalUnit | fn:lu:escaping:scarper | "escaping" | "scarper" | "has lexical unit" |  | "FN" |  |
| fn:escaping | fn:HasLexicalUnit | fn:lu:escaping:get_free | "escaping" | "get free" | "has lexical unit" |  | "FN" |  |
| fn:escaping | fn:HasLexicalUnit | fn:lu:escaping:get_loose | "escaping" | "get loose" | "has lexical unit" |  | "FN" |  |
| fn:escaping | fn:HasLexicalUnit | fn:lu:escaping:evacuation | "escaping" | "evacuation" | "has lexical unit" |  | "FN" |  |
| fn:fe:escapee | /r/IsA | fn:st:animate_being | "escapee" | "animate being" | "/r/is a" |  | "FN" |  |
| fn:st:animate_being | /r/IsA | fn:st:ontological_type | "animate being" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:escaping | /r/HasA | fn:fe:escapee | "escaping" | "escapee" | "/r/has a" |  | "FN" |  |
| fn:escaping | /r/HasA | fn:fe:goal | "escaping" | "goal" | "/r/has a" |  | "FN" |  |
| fn:escaping | /r/HasA | fn:fe:means | "escaping" | "means" | "/r/has a" |  | "FN" |  |
| fn:escaping | /r/HasA | fn:fe:manner | "escaping" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fe:undesirable_location | /r/IsA | fn:st:source | "undesirable location" | "source" | "/r/is a" |  | "FN" |  |
| fn:escaping | /r/HasA | fn:fe:undesirable_location | "escaping" | "undesirable location" | "/r/has a" |  | "FN" |  |
| fn:escaping | /r/HasA | fn:fe:speed | "escaping" | "speed" | "/r/has a" |  | "FN" |  |
| fn:escaping | /r/HasA | fn:fe:vehicle | "escaping" | "vehicle" | "/r/has a" |  | "FN" |  |
| fn:escaping | /r/HasA | fn:fe:time | "escaping" | "time" | "/r/has a" |  | "FN" |  |
| fn:escaping | /r/HasA | fn:fe:purpose | "escaping" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:escaping | /r/HasA | fn:fe:place | "escaping" | "place" | "/r/has a" |  | "FN" |  |
| fn:escaping | /r/HasA | fn:fe:depictive | "escaping" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:escaping | /r/HasA | fn:fe:path | "escaping" | "path" | "/r/has a" |  | "FN" |  |
| fn:escaping | /r/HasA | fn:fe:degree | "escaping" | "degree" | "/r/has a" |  | "FN" |  |
| fn:escaping | /r/HasA | fn:fe:distance | "escaping" | "distance" | "/r/has a" |  | "FN" |  |
| fn:escaping | /r/HasA | fn:fe:explanation | "escaping" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:estimating | /r/UsedFor | fn:estimated_value | "estimating" | "estimated value" | "/r/used for" |  | "FN" |  |
| fn:estimated_value | fn:HasLexicalUnit | fn:lu:estimated_value:estimate | "estimated value" | "estimate" | "has lexical unit" |  | "FN" |  |
| fn:estimated_value | fn:HasLexicalUnit | fn:lu:estimated_value:estimation | "estimated value" | "estimation" | "has lexical unit" |  | "FN" |  |
| fn:estimated_value | fn:HasLexicalUnit | fn:lu:estimated_value:ballpark_figure | "estimated value" | "ballpark figure" | "has lexical unit" |  | "FN" |  |
| fn:estimated_value | /r/HasA | fn:fe:cognizer | "estimated value" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:estimated_value | /r/HasA | fn:fe:value | "estimated value" | "value" | "/r/has a" |  | "FN" |  |
| fn:estimated_value | /r/HasA | fn:fe:item | "estimated value" | "item" | "/r/has a" |  | "FN" |  |
| fn:estimated_value | /r/HasA | fn:fe:evidence | "estimated value" | "evidence" | "/r/has a" |  | "FN" |  |
| fn:estimated_value | /r/HasA | fn:fe:time | "estimated value" | "time" | "/r/has a" |  | "FN" |  |
| fn:estimated_value | /r/HasA | fn:fe:place | "estimated value" | "place" | "/r/has a" |  | "FN" |  |
| fn:fe:estimation | /r/RelatedTo | fn:fe:item | "estimation" | "item" | "/r/related to" |  | "FN" |  |
| fn:estimated_value | /r/HasA | fn:fe:estimation | "estimated value" | "estimation" | "/r/has a" |  | "FN" |  |
| fn:fe:question | /r/RelatedTo | fn:fe:item | "question" | "item" | "/r/related to" |  | "FN" |  |
| fn:estimated_value | /r/HasA | fn:fe:question | "estimated value" | "question" | "/r/has a" |  | "FN" |  |
| fn:estimating | /r/UsedFor | fn:estimated_value | "estimating" | "estimated value" | "/r/used for" |  | "FN" |  |
| fn:mental_activity | /r/UsedFor | fn:estimating | "mental activity" | "estimating" | "/r/used for" |  | "FN" |  |
| fn:estimating | fn:HasLexicalUnit | fn:lu:estimating:estimate | "estimating" | "estimate" | "has lexical unit" |  | "FN" |  |
| fn:estimating | fn:HasLexicalUnit | fn:lu:estimating:estimation | "estimating" | "estimation" | "has lexical unit" |  | "FN" |  |
| fn:estimating | fn:HasLexicalUnit | fn:lu:estimating:guess | "estimating" | "guess" | "has lexical unit" |  | "FN" |  |
| fn:estimating | fn:HasLexicalUnit | fn:lu:estimating:put_(at) | "estimating" | "put (at)" | "has lexical unit" |  | "FN" |  |
| fn:estimating | /r/HasA | fn:fe:cognizer | "estimating" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:fe:feature | /r/HasPrerequisite | fn:fe:item | "feature" | "item" | "/r/has prerequisite" |  | "FN" |  |
| fn:estimating | /r/HasA | fn:fe:feature | "estimating" | "feature" | "/r/has a" |  | "FN" |  |
| fn:fe:value | /r/RelatedTo | fn:fe:estimation | "value" | "estimation" | "/r/related to" |  | "FN" |  |
| fn:estimating | /r/HasA | fn:fe:value | "estimating" | "value" | "/r/has a" |  | "FN" |  |
| fn:fe:item | /r/HasPrerequisite | fn:fe:value | "item" | "value" | "/r/has prerequisite" |  | "FN" |  |
| fn:estimating | /r/HasA | fn:fe:item | "estimating" | "item" | "/r/has a" |  | "FN" |  |
| fn:estimating | /r/HasA | fn:fe:evidence | "estimating" | "evidence" | "/r/has a" |  | "FN" |  |
| fn:estimating | /r/HasA | fn:fe:time | "estimating" | "time" | "/r/has a" |  | "FN" |  |
| fn:estimating | /r/HasA | fn:fe:place | "estimating" | "place" | "/r/has a" |  | "FN" |  |
| fn:estimating | /r/HasA | fn:fe:estimation | "estimating" | "estimation" | "/r/has a" |  | "FN" |  |
| fn:fe:question | /r/HasPrerequisite | fn:fe:value | "question" | "value" | "/r/has prerequisite" |  | "FN" |  |
| fn:estimating | /r/HasA | fn:fe:question | "estimating" | "question" | "/r/has a" |  | "FN" |  |
| fn:estimating | /r/HasA | fn:fe:means | "estimating" | "means" | "/r/has a" |  | "FN" |  |
| fn:estimating | /r/HasA | fn:fe:manner | "estimating" | "manner" | "/r/has a" |  | "FN" |  |
| fn:estimating | /r/HasA | fn:fe:circumstances | "estimating" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:estimating | /r/HasA | fn:fe:explanation | "estimating" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:estimating | /r/HasA | fn:fe:result | "estimating" | "result" | "/r/has a" |  | "FN" |  |
| fn:estimating | /r/HasA | fn:fe:frequency | "estimating" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:evading | /r/IsA | fn:avoiding | "evading" | "avoiding" | "/r/is a" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:evading | "motion" | "evading" | "/r/used for" |  | "FN" |  |
| fn:elusive_goal | /r/RelatedTo | fn:evading | "elusive goal" | "evading" | "/r/related to" |  | "FN" |  |
| fn:avoiding | /r/SimilarTo | fn:evading | "avoiding" | "evading" | "/r/similar to" |  | "FN" |  |
| fn:cotheme | /r/SimilarTo | fn:evading | "cotheme" | "evading" | "/r/similar to" |  | "FN" |  |
| fn:elusive_goal | /r/SimilarTo | fn:evading | "elusive goal" | "evading" | "/r/similar to" |  | "FN" |  |
| fn:evading | /r/SimilarTo | fn:dodging | "evading" | "dodging" | "/r/similar to" |  | "FN" |  |
| fn:evading | /r/SimilarTo | fn:elusive_goal | "evading" | "elusive goal" | "/r/similar to" |  | "FN" |  |
| fn:evading | /r/SimilarTo | fn:elusive_goal | "evading" | "elusive goal" | "/r/similar to" |  | "FN" |  |
| fn:evading | fn:HasLexicalUnit | fn:lu:evading:evade | "evading" | "evade" | "has lexical unit" |  | "FN" |  |
| fn:evading | fn:HasLexicalUnit | fn:lu:evading:evasion | "evading" | "evasion" | "has lexical unit" |  | "FN" |  |
| fn:evading | fn:HasLexicalUnit | fn:lu:evading:evasive | "evading" | "evasive" | "has lexical unit" |  | "FN" |  |
| fn:evading | fn:HasLexicalUnit | fn:lu:evading:elude | "evading" | "elude" | "has lexical unit" |  | "FN" |  |
| fn:evading | fn:HasLexicalUnit | fn:lu:evading:elusive | "evading" | "elusive" | "has lexical unit" |  | "FN" |  |
| fn:evading | fn:HasLexicalUnit | fn:lu:evading:give_the_slip | "evading" | "give the slip" | "has lexical unit" |  | "FN" |  |
| fn:evading | fn:HasLexicalUnit | fn:lu:evading:flee | "evading" | "flee" | "has lexical unit" |  | "FN" |  |
| fn:evading | fn:HasLexicalUnit | fn:lu:evading:get_away | "evading" | "get away" | "has lexical unit" |  | "FN" |  |
| fn:evading | fn:HasLexicalUnit | fn:lu:evading:skip_town | "evading" | "skip town" | "has lexical unit" |  | "FN" |  |
| fn:evading | /r/HasA | fn:fe:area | "evading" | "area" | "/r/has a" |  | "FN" |  |
| fn:evading | /r/HasA | fn:fe:path | "evading" | "path" | "/r/has a" |  | "FN" |  |
| fn:fe:evader | /r/IsA | fn:st:sentient | "evader" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:evading | /r/HasA | fn:fe:evader | "evading" | "evader" | "/r/has a" |  | "FN" |  |
| fn:evading | /r/HasA | fn:fe:mode_of_transportation | "evading" | "mode of transportation" | "/r/has a" |  | "FN" |  |
| fn:evading | /r/HasA | fn:fe:means | "evading" | "means" | "/r/has a" |  | "FN" |  |
| fn:evading | /r/HasA | fn:fe:pursuer | "evading" | "pursuer" | "/r/has a" |  | "FN" |  |
| fn:evading | /r/HasA | fn:fe:degree | "evading" | "degree" | "/r/has a" |  | "FN" |  |
| fn:evading | /r/HasA | fn:fe:manner | "evading" | "manner" | "/r/has a" |  | "FN" |  |
| fn:evading | /r/HasA | fn:fe:purpose | "evading" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:evading | /r/HasA | fn:fe:explanation | "evading" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:evading | /r/HasA | fn:fe:circumstances | "evading" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:evading | /r/HasA | fn:fe:time | "evading" | "time" | "/r/has a" |  | "FN" |  |
| fn:evading | /r/HasA | fn:fe:depictive | "evading" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:evading | /r/HasA | fn:fe:speed | "evading" | "speed" | "/r/has a" |  | "FN" |  |
| fn:fe:capture | /r/RelatedTo | fn:fe:pursuer | "capture" | "pursuer" | "/r/related to" |  | "FN" |  |
| fn:evading | /r/HasA | fn:fe:capture | "evading" | "capture" | "/r/has a" |  | "FN" |  |
| fn:evaluative_comparison | /r/IsA | fn:position_on_a_scale | "evaluative comparison" | "position on a scale" | "/r/is a" |  | "FN" |  |
| fn:evaluative_comparison | fn:HasLexicalUnit | fn:lu:evaluative_comparison:compare | "evaluative comparison" | "compare" | "has lexical unit" |  | "FN" |  |
| fn:evaluative_comparison | fn:HasLexicalUnit | fn:lu:evaluative_comparison:measure_up | "evaluative comparison" | "measure up" | "has lexical unit" |  | "FN" |  |
| fn:evaluative_comparison | fn:HasLexicalUnit | fn:lu:evaluative_comparison:match | "evaluative comparison" | "match" | "has lexical unit" |  | "FN" |  |
| fn:evaluative_comparison | fn:HasLexicalUnit | fn:lu:evaluative_comparison:match | "evaluative comparison" | "match" | "has lexical unit" |  | "FN" |  |
| fn:evaluative_comparison | fn:HasLexicalUnit | fn:lu:evaluative_comparison:rival | "evaluative comparison" | "rival" | "has lexical unit" |  | "FN" |  |
| fn:evaluative_comparison | fn:HasLexicalUnit | fn:lu:evaluative_comparison:equal | "evaluative comparison" | "equal" | "has lexical unit" |  | "FN" |  |
| fn:evaluative_comparison | fn:HasLexicalUnit | fn:lu:evaluative_comparison:comparable | "evaluative comparison" | "comparable" | "has lexical unit" |  | "FN" |  |
| fn:evaluative_comparison | fn:HasLexicalUnit | fn:lu:evaluative_comparison:stack_up | "evaluative comparison" | "stack up" | "has lexical unit" |  | "FN" |  |
| fn:evaluative_comparison | /r/HasA | fn:fe:profiled_item | "evaluative comparison" | "profiled item" | "/r/has a" |  | "FN" |  |
| fn:evaluative_comparison | /r/HasA | fn:fe:standard_item | "evaluative comparison" | "standard item" | "/r/has a" |  | "FN" |  |
| fn:evaluative_comparison | /r/HasA | fn:fe:attribute | "evaluative comparison" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:evaluative_comparison | /r/HasA | fn:fe:degree | "evaluative comparison" | "degree" | "/r/has a" |  | "FN" |  |
| fn:fe:standard_attribute | /r/RelatedTo | fn:fe:attribute | "standard attribute" | "attribute" | "/r/related to" |  | "FN" |  |
| fn:evaluative_comparison | /r/HasA | fn:fe:standard_attribute | "evaluative comparison" | "standard attribute" | "/r/has a" |  | "FN" |  |
| fn:fe:profiled_attribute | /r/RelatedTo | fn:fe:attribute | "profiled attribute" | "attribute" | "/r/related to" |  | "FN" |  |
| fn:evaluative_comparison | /r/HasA | fn:fe:profiled_attribute | "evaluative comparison" | "profiled attribute" | "/r/has a" |  | "FN" |  |
| fn:evaluative_comparison | /r/HasA | fn:fe:comparison_set | "evaluative comparison" | "comparison set" | "/r/has a" |  | "FN" |  |
| fn:evaluative_comparison | /r/HasA | fn:fe:place | "evaluative comparison" | "place" | "/r/has a" |  | "FN" |  |
| fn:evaluative_comparison | /r/HasA | fn:fe:time | "evaluative comparison" | "time" | "/r/has a" |  | "FN" |  |
| fn:evaluative_comparison | /r/HasA | fn:fe:manner | "evaluative comparison" | "manner" | "/r/has a" |  | "FN" |  |
| fn:birth_scenario | /r/IsA | fn:event | "birth scenario" | "event" | "/r/is a" |  | "FN" |  |
| fn:change_of_consistency | /r/IsA | fn:event | "change of consistency" | "event" | "/r/is a" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/IsA | fn:event | "change position on a scale" | "event" | "/r/is a" |  | "FN" |  |
| fn:coincidence | /r/IsA | fn:event | "coincidence" | "event" | "/r/is a" |  | "FN" |  |
| fn:come_together | /r/IsA | fn:event | "come together" | "event" | "/r/is a" |  | "FN" |  |
| fn:coming_to_be | /r/IsA | fn:event | "coming to be" | "event" | "/r/is a" |  | "FN" |  |
| fn:coming_to_believe | /r/IsA | fn:event | "coming to believe" | "event" | "/r/is a" |  | "FN" |  |
| fn:emergency | /r/IsA | fn:event | "emergency" | "event" | "/r/is a" |  | "FN" |  |
| fn:eventive_affecting | /r/IsA | fn:event | "eventive affecting" | "event" | "/r/is a" |  | "FN" |  |
| fn:experience_bodily_harm | /r/IsA | fn:event | "experience bodily harm" | "event" | "/r/is a" |  | "FN" |  |
| fn:getting | /r/IsA | fn:event | "getting" | "event" | "/r/is a" |  | "FN" |  |
| fn:go_into_shape | /r/IsA | fn:event | "go into shape" | "event" | "/r/is a" |  | "FN" |  |
| fn:intentionally_act | /r/IsA | fn:event | "intentionally act" | "event" | "/r/is a" |  | "FN" |  |
| fn:losing_someone | /r/IsA | fn:event | "losing someone" | "event" | "/r/is a" |  | "FN" |  |
| fn:misdeed | /r/IsA | fn:event | "misdeed" | "event" | "/r/is a" |  | "FN" |  |
| fn:motion | /r/IsA | fn:event | "motion" | "event" | "/r/is a" |  | "FN" |  |
| fn:objective_influence | /r/IsA | fn:event | "objective influence" | "event" | "/r/is a" |  | "FN" |  |
| fn:process_end | /r/IsA | fn:event | "process end" | "event" | "/r/is a" |  | "FN" |  |
| fn:process_pause | /r/IsA | fn:event | "process pause" | "event" | "/r/is a" |  | "FN" |  |
| fn:process_resume | /r/IsA | fn:event | "process resume" | "event" | "/r/is a" |  | "FN" |  |
| fn:process_start | /r/IsA | fn:event | "process start" | "event" | "/r/is a" |  | "FN" |  |
| fn:process_stop | /r/IsA | fn:event | "process stop" | "event" | "/r/is a" |  | "FN" |  |
| fn:rotting | /r/IsA | fn:event | "rotting" | "event" | "/r/is a" |  | "FN" |  |
| fn:transition_to_state | /r/IsA | fn:event | "transition to state" | "event" | "/r/is a" |  | "FN" |  |
| fn:traversing | /r/IsA | fn:event | "traversing" | "event" | "/r/is a" |  | "FN" |  |
| fn:undergoing | /r/IsA | fn:event | "undergoing" | "event" | "/r/is a" |  | "FN" |  |
| fn:waking_up | /r/IsA | fn:event | "waking up" | "event" | "/r/is a" |  | "FN" |  |
| fn:dynamic_situation_scenario | /r/HasSubevent | fn:event | "dynamic situation scenario" | "event" | "/r/has subevent" |  | "FN" |  |
| fn:event | /r/UsedFor | fn:frequency | "event" | "frequency" | "/r/used for" |  | "FN" |  |
| fn:event | /r/UsedFor | fn:hindering | "event" | "hindering" | "/r/used for" |  | "FN" |  |
| fn:event | /r/UsedFor | fn:locale_by_event | "event" | "locale by event" | "/r/used for" |  | "FN" |  |
| fn:event | /r/UsedFor | fn:manner | "event" | "manner" | "/r/used for" |  | "FN" |  |
| fn:event | /r/UsedFor | fn:participation | "event" | "participation" | "/r/used for" |  | "FN" |  |
| fn:event | /r/UsedFor | fn:preventing_or_letting | "event" | "preventing or letting" | "/r/used for" |  | "FN" |  |
| fn:event | /r/UsedFor | fn:temporal_pattern | "event" | "temporal pattern" | "/r/used for" |  | "FN" |  |
| fn:event_endstate | /r/HasPrerequisite | fn:event | "event endstate" | "event" | "/r/has prerequisite" |  | "FN" |  |
| fn:event | /r/HasPrerequisite | fn:event_initial_state | "event" | "event initial state" | "/r/has prerequisite" |  | "FN" |  |
| fn:event | fn:HasLexicalUnit | fn:lu:event:happen | "event" | "happen" | "has lexical unit" |  | "FN" |  |
| fn:event | fn:HasLexicalUnit | fn:lu:event:occur | "event" | "occur" | "has lexical unit" |  | "FN" |  |
| fn:event | fn:HasLexicalUnit | fn:lu:event:take_place | "event" | "take place" | "has lexical unit" |  | "FN" |  |
| fn:event | fn:HasLexicalUnit | fn:lu:event:transpire | "event" | "transpire" | "has lexical unit" |  | "FN" |  |
| fn:event | fn:HasLexicalUnit | fn:lu:event:development | "event" | "development" | "has lexical unit" |  | "FN" |  |
| fn:event | fn:HasLexicalUnit | fn:lu:event:event | "event" | "event" | "has lexical unit" |  | "FN" |  |
| fn:event | fn:HasLexicalUnit | fn:lu:event:episode | "event" | "episode" | "has lexical unit" |  | "FN" |  |
| fn:event | fn:HasLexicalUnit | fn:lu:event:incident | "event" | "incident" | "has lexical unit" |  | "FN" |  |
| fn:event | fn:HasLexicalUnit | fn:lu:event:go_on | "event" | "go on" | "has lexical unit" |  | "FN" |  |
| fn:event | /r/HasA | fn:fe:event | "event" | "event" | "/r/has a" |  | "FN" |  |
| fn:event | /r/HasA | fn:fe:place | "event" | "place" | "/r/has a" |  | "FN" |  |
| fn:event | /r/HasA | fn:fe:explanation | "event" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:event | /r/HasA | fn:fe:time | "event" | "time" | "/r/has a" |  | "FN" |  |
| fn:event | /r/HasA | fn:fe:duration | "event" | "duration" | "/r/has a" |  | "FN" |  |
| fn:event | /r/HasA | fn:fe:manner | "event" | "manner" | "/r/has a" |  | "FN" |  |
| fn:event | /r/HasA | fn:fe:frequency | "event" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:event | /r/HasA | fn:fe:timespan | "event" | "timespan" | "/r/has a" |  | "FN" |  |
| fn:event_endstate | /r/IsA | fn:state | "event endstate" | "state" | "/r/is a" |  | "FN" |  |
| fn:dynamic_situation_scenario | /r/HasSubevent | fn:event_endstate | "dynamic situation scenario" | "event endstate" | "/r/has subevent" |  | "FN" |  |
| fn:event_endstate | /r/HasPrerequisite | fn:event | "event endstate" | "event" | "/r/has prerequisite" |  | "FN" |  |
| fn:event_endstate | /r/HasA | fn:fe:entity | "event endstate" | "entity" | "/r/has a" |  | "FN" |  |
| fn:event_endstate | /r/HasA | fn:fe:state | "event endstate" | "state" | "/r/has a" |  | "FN" |  |
| fn:event_initial_state | /r/IsA | fn:state | "event initial state" | "state" | "/r/is a" |  | "FN" |  |
| fn:dynamic_situation_scenario | /r/HasSubevent | fn:event_initial_state | "dynamic situation scenario" | "event initial state" | "/r/has subevent" |  | "FN" |  |
| fn:event | /r/HasPrerequisite | fn:event_initial_state | "event" | "event initial state" | "/r/has prerequisite" |  | "FN" |  |
| fn:event_initial_state | /r/HasA | fn:fe:entity | "event initial state" | "entity" | "/r/has a" |  | "FN" |  |
| fn:event_initial_state | /r/HasA | fn:fe:state | "event initial state" | "state" | "/r/has a" |  | "FN" |  |
| fn:event_instance | /r/IsA | fn:instance | "event instance" | "instance" | "/r/is a" |  | "FN" |  |
| fn:frequency | /r/SimilarTo | fn:event_instance | "frequency" | "event instance" | "/r/similar to" |  | "FN" |  |
| fn:event_instance | fn:HasLexicalUnit | fn:lu:event_instance:time | "event instance" | "time" | "has lexical unit" |  | "FN" |  |
| fn:event_instance | fn:HasLexicalUnit | fn:lu:event_instance:once | "event instance" | "once" | "has lexical unit" |  | "FN" |  |
| fn:event_instance | fn:HasLexicalUnit | fn:lu:event_instance:twice | "event instance" | "twice" | "has lexical unit" |  | "FN" |  |
| fn:event_instance | fn:HasLexicalUnit | fn:lu:event_instance:thrice | "event instance" | "thrice" | "has lexical unit" |  | "FN" |  |
| fn:event_instance | fn:HasLexicalUnit | fn:lu:event_instance:repeated | "event instance" | "repeated" | "has lexical unit" |  | "FN" |  |
| fn:event_instance | fn:HasLexicalUnit | fn:lu:event_instance:repeatedly | "event instance" | "repeatedly" | "has lexical unit" |  | "FN" |  |
| fn:event_instance | fn:HasLexicalUnit | fn:lu:event_instance:occasion | "event instance" | "occasion" | "has lexical unit" |  | "FN" |  |
| fn:event_instance | /r/HasA | fn:fe:instance | "event instance" | "instance" | "/r/has a" |  | "FN" |  |
| fn:event_instance | /r/HasA | fn:fe:event | "event instance" | "event" | "/r/has a" |  | "FN" |  |
| fn:event_instance | /r/HasA | fn:fe:instance_prop | "event instance" | "instance prop" | "/r/has a" |  | "FN" |  |
| fn:fe:iteration_count | /r/IsA | fn:st:quantity | "iteration count" | "quantity" | "/r/is a" |  | "FN" |  |
| fn:event_instance | /r/HasA | fn:fe:iteration_count | "event instance" | "iteration count" | "/r/has a" |  | "FN" |  |
| fn:eventive_affecting | /r/IsA | fn:event | "eventive affecting" | "event" | "/r/is a" |  | "FN" |  |
| fn:aging | /r/IsA | fn:eventive_affecting | "aging" | "eventive affecting" | "/r/is a" |  | "FN" |  |
| fn:arriving | /r/IsA | fn:eventive_affecting | "arriving" | "eventive affecting" | "/r/is a" |  | "FN" |  |
| fn:causation | /r/IsA | fn:eventive_affecting | "causation" | "eventive affecting" | "/r/is a" |  | "FN" |  |
| fn:come_down_with | /r/IsA | fn:eventive_affecting | "come down with" | "eventive affecting" | "/r/is a" |  | "FN" |  |
| fn:departing | /r/IsA | fn:eventive_affecting | "departing" | "eventive affecting" | "/r/is a" |  | "FN" |  |
| fn:destiny | /r/IsA | fn:eventive_affecting | "destiny" | "eventive affecting" | "/r/is a" |  | "FN" |  |
| fn:eventive_cognizer_affecting | /r/IsA | fn:eventive_affecting | "eventive cognizer affecting" | "eventive affecting" | "/r/is a" |  | "FN" |  |
| fn:explosion | /r/IsA | fn:eventive_affecting | "explosion" | "eventive affecting" | "/r/is a" |  | "FN" |  |
| fn:historic_event | /r/IsA | fn:eventive_affecting | "historic event" | "eventive affecting" | "/r/is a" |  | "FN" |  |
| fn:lose_possession | /r/IsA | fn:eventive_affecting | "lose possession" | "eventive affecting" | "/r/is a" |  | "FN" |  |
| fn:response | /r/IsA | fn:eventive_affecting | "response" | "eventive affecting" | "/r/is a" |  | "FN" |  |
| fn:transfer | /r/IsA | fn:eventive_affecting | "transfer" | "eventive affecting" | "/r/is a" |  | "FN" |  |
| fn:eventive_affecting | /r/UsedFor | fn:activity_pause | "eventive affecting" | "activity pause" | "/r/used for" |  | "FN" |  |
| fn:eventive_affecting | /r/UsedFor | fn:activity_prepare | "eventive affecting" | "activity prepare" | "/r/used for" |  | "FN" |  |
| fn:eventive_affecting | /r/UsedFor | fn:activity_start | "eventive affecting" | "activity start" | "/r/used for" |  | "FN" |  |
| fn:eventive_affecting | /r/UsedFor | fn:activity_stop | "eventive affecting" | "activity stop" | "/r/used for" |  | "FN" |  |
| fn:eventive_affecting | /r/UsedFor | fn:catastrophe | "eventive affecting" | "catastrophe" | "/r/used for" |  | "FN" |  |
| fn:eventive_affecting | /r/UsedFor | fn:coming_up_with | "eventive affecting" | "coming up with" | "/r/used for" |  | "FN" |  |
| fn:eventive_affecting | /r/UsedFor | fn:individual_history | "eventive affecting" | "individual history" | "/r/used for" |  | "FN" |  |
| fn:eventive_affecting | /r/UsedFor | fn:memory | "eventive affecting" | "memory" | "/r/used for" |  | "FN" |  |
| fn:eventive_affecting | /r/UsedFor | fn:social_event | "eventive affecting" | "social event" | "/r/used for" |  | "FN" |  |
| fn:eventive_affecting | /r/UsedFor | fn:undergoing | "eventive affecting" | "undergoing" | "/r/used for" |  | "FN" |  |
| fn:eventive_affecting | /r/IsA | fn:undergoing_scenario | "eventive affecting" | "undergoing scenario" | "/r/is a" |  | "FN" |  |
| fn:eventive_affecting | fn:HasLexicalUnit | fn:lu:eventive_affecting:happen | "eventive affecting" | "happen" | "has lexical unit" |  | "FN" |  |
| fn:eventive_affecting | fn:HasLexicalUnit | fn:lu:eventive_affecting:strike | "eventive affecting" | "strike" | "has lexical unit" |  | "FN" |  |
| fn:eventive_affecting | fn:HasLexicalUnit | fn:lu:eventive_affecting:see | "eventive affecting" | "see" | "has lexical unit" |  | "FN" |  |
| fn:eventive_affecting | fn:HasLexicalUnit | fn:lu:eventive_affecting:hit | "eventive affecting" | "hit" | "has lexical unit" |  | "FN" |  |
| fn:eventive_affecting | fn:HasLexicalUnit | fn:lu:eventive_affecting:what_become_(of) | "eventive affecting" | "what become (of)" | "has lexical unit" |  | "FN" |  |
| fn:eventive_affecting | fn:HasLexicalUnit | fn:lu:eventive_affecting:suffer | "eventive affecting" | "suffer" | "has lexical unit" |  | "FN" |  |
| fn:eventive_affecting | /r/HasA | fn:fe:event | "eventive affecting" | "event" | "/r/has a" |  | "FN" |  |
| fn:eventive_affecting | /r/HasA | fn:fe:place | "eventive affecting" | "place" | "/r/has a" |  | "FN" |  |
| fn:eventive_affecting | /r/HasA | fn:fe:time | "eventive affecting" | "time" | "/r/has a" |  | "FN" |  |
| fn:eventive_affecting | /r/HasA | fn:fe:explanation | "eventive affecting" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:eventive_affecting | /r/HasA | fn:fe:entity | "eventive affecting" | "entity" | "/r/has a" |  | "FN" |  |
| fn:eventive_affecting | /r/HasA | fn:fe:manner | "eventive affecting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:eventive_affecting | /r/HasA | fn:fe:frequency | "eventive affecting" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:eventive_cognizer_affecting | /r/IsA | fn:eventive_affecting | "eventive cognizer affecting" | "eventive affecting" | "/r/is a" |  | "FN" |  |
| fn:suasion | /r/IsA | fn:eventive_cognizer_affecting | "suasion" | "eventive cognizer affecting" | "/r/is a" |  | "FN" |  |
| fn:eventive_cognizer_affecting | /r/UsedFor | fn:suasion | "eventive cognizer affecting" | "suasion" | "/r/used for" |  | "FN" |  |
| fn:subjective_influence | /r/UsedFor | fn:eventive_cognizer_affecting | "subjective influence" | "eventive cognizer affecting" | "/r/used for" |  | "FN" |  |
| fn:eventive_cognizer_affecting | /r/Causes | fn:purpose | "eventive cognizer affecting" | "purpose" | "/r/causes" |  | "FN" |  |
| fn:eventive_cognizer_affecting | fn:HasLexicalUnit | fn:lu:eventive_cognizer_affecting:convince | "eventive cognizer affecting" | "convince" | "has lexical unit" |  | "FN" |  |
| fn:eventive_cognizer_affecting | fn:HasLexicalUnit | fn:lu:eventive_cognizer_affecting:decide | "eventive cognizer affecting" | "decide" | "has lexical unit" |  | "FN" |  |
| fn:eventive_cognizer_affecting | /r/HasA | fn:fe:cognizer | "eventive cognizer affecting" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:eventive_cognizer_affecting | /r/HasA | fn:fe:content | "eventive cognizer affecting" | "content" | "/r/has a" |  | "FN" |  |
| fn:eventive_cognizer_affecting | /r/HasA | fn:fe:event | "eventive cognizer affecting" | "event" | "/r/has a" |  | "FN" |  |
| fn:eventive_cognizer_affecting | /r/HasA | fn:fe:degree | "eventive cognizer affecting" | "degree" | "/r/has a" |  | "FN" |  |
| fn:eventive_cognizer_affecting | /r/HasA | fn:fe:manner | "eventive cognizer affecting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:eventive_cognizer_affecting | /r/HasA | fn:fe:time | "eventive cognizer affecting" | "time" | "/r/has a" |  | "FN" |  |
| fn:eventive_cognizer_affecting | /r/HasA | fn:fe:place | "eventive cognizer affecting" | "place" | "/r/has a" |  | "FN" |  |
| fn:evidence | /r/UsedFor | fn:explaining_the_facts | "evidence" | "explaining the facts" | "/r/used for" |  | "FN" |  |
| fn:evidence | /r/UsedFor | fn:sign | "evidence" | "sign" | "/r/used for" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:argument | "evidence" | "argument" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:attest | "evidence" | "attest" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:confirm | "evidence" | "confirm" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:corroborate | "evidence" | "corroborate" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:demonstrate | "evidence" | "demonstrate" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:evidence | "evidence" | "evidence" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:evince | "evidence" | "evince" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:prove | "evidence" | "prove" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:reveal | "evidence" | "reveal" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:show | "evidence" | "show" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:substantiate | "evidence" | "substantiate" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:testify | "evidence" | "testify" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:verify | "evidence" | "verify" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:disprove | "evidence" | "disprove" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:contradict | "evidence" | "contradict" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:argue | "evidence" | "argue" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:mean | "evidence" | "mean" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:evidence | "evidence" | "evidence" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:from | "evidence" | "from" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:suggest | "evidence" | "suggest" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:indicate | "evidence" | "indicate" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:imply | "evidence" | "imply" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:proof | "evidence" | "proof" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:illustrate | "evidence" | "illustrate" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:point_(to) | "evidence" | "point (to)" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:credence_[lend] | "evidence" | "credence [lend]" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:support | "evidence" | "support" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:tell | "evidence" | "tell" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:rule_out | "evidence" | "rule out" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:demonstration | "evidence" | "demonstration" | "has lexical unit" |  | "FN" |  |
| fn:evidence | fn:HasLexicalUnit | fn:lu:evidence:assure | "evidence" | "assure" | "has lexical unit" |  | "FN" |  |
| fn:evidence | /r/HasA | fn:fe:support | "evidence" | "support" | "/r/has a" |  | "FN" |  |
| fn:evidence | /r/HasA | fn:fe:proposition | "evidence" | "proposition" | "/r/has a" |  | "FN" |  |
| fn:evidence | /r/HasA | fn:fe:degree | "evidence" | "degree" | "/r/has a" |  | "FN" |  |
| fn:evidence | /r/HasA | fn:fe:manner | "evidence" | "manner" | "/r/has a" |  | "FN" |  |
| fn:evidence | /r/HasA | fn:fe:means | "evidence" | "means" | "/r/has a" |  | "FN" |  |
| fn:evidence | /r/HasA | fn:fe:depictive | "evidence" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:evidence | /r/HasA | fn:fe:result | "evidence" | "result" | "/r/has a" |  | "FN" |  |
| fn:evidence | /r/HasA | fn:fe:domain_of_relevance | "evidence" | "domain of relevance" | "/r/has a" |  | "FN" |  |
| fn:evidence | /r/HasA | fn:fe:cognizer | "evidence" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:memory | /r/UsedFor | fn:evoking | "memory" | "evoking" | "/r/used for" |  | "FN" |  |
| fn:evoking | fn:HasLexicalUnit | fn:lu:evoking:remind | "evoking" | "remind" | "has lexical unit" |  | "FN" |  |
| fn:evoking | fn:HasLexicalUnit | fn:lu:evoking:bring_to_mind | "evoking" | "bring to mind" | "has lexical unit" |  | "FN" |  |
| fn:evoking | fn:HasLexicalUnit | fn:lu:evoking:evoke | "evoking" | "evoke" | "has lexical unit" |  | "FN" |  |
| fn:evoking | fn:HasLexicalUnit | fn:lu:evoking:call_to_mind | "evoking" | "call to mind" | "has lexical unit" |  | "FN" |  |
| fn:evoking | fn:HasLexicalUnit | fn:lu:evoking:put_in_mind_(of) | "evoking" | "put in mind (of)" | "has lexical unit" |  | "FN" |  |
| fn:evoking | fn:HasLexicalUnit | fn:lu:evoking:conjure | "evoking" | "conjure" | "has lexical unit" |  | "FN" |  |
| fn:evoking | fn:HasLexicalUnit | fn:lu:evoking:ring_a_bell | "evoking" | "ring a bell" | "has lexical unit" |  | "FN" |  |
| fn:evoking | fn:HasLexicalUnit | fn:lu:evoking:recall | "evoking" | "recall" | "has lexical unit" |  | "FN" |  |
| fn:evoking | fn:HasLexicalUnit | fn:lu:evoking:reminder | "evoking" | "reminder" | "has lexical unit" |  | "FN" |  |
| fn:evoking | fn:HasLexicalUnit | fn:lu:evoking:evocative | "evoking" | "evocative" | "has lexical unit" |  | "FN" |  |
| fn:evoking | fn:HasLexicalUnit | fn:lu:evoking:evocation | "evoking" | "evocation" | "has lexical unit" |  | "FN" |  |
| fn:evoking | fn:HasLexicalUnit | fn:lu:evoking:suggest | "evoking" | "suggest" | "has lexical unit" |  | "FN" |  |
| fn:evoking | /r/HasA | fn:fe:cognizer | "evoking" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:evoking | /r/HasA | fn:fe:phenomenon | "evoking" | "phenomenon" | "/r/has a" |  | "FN" |  |
| fn:evoking | /r/HasA | fn:fe:degree | "evoking" | "degree" | "/r/has a" |  | "FN" |  |
| fn:evoking | /r/HasA | fn:fe:manner | "evoking" | "manner" | "/r/has a" |  | "FN" |  |
| fn:evoking | /r/HasA | fn:fe:duration | "evoking" | "duration" | "/r/has a" |  | "FN" |  |
| fn:evoking | /r/HasA | fn:fe:explanation | "evoking" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:evoking | /r/HasA | fn:fe:time | "evoking" | "time" | "/r/has a" |  | "FN" |  |
| fn:evoking | /r/HasA | fn:fe:stimulus | "evoking" | "stimulus" | "/r/has a" |  | "FN" |  |
| fn:evoking | /r/HasA | fn:fe:feature | "evoking" | "feature" | "/r/has a" |  | "FN" |  |
| fn:examination | /r/IsA | fn:intentionally_act | "examination" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:awareness | /r/UsedFor | fn:examination | "awareness" | "examination" | "/r/used for" |  | "FN" |  |
| fn:examination | fn:HasLexicalUnit | fn:lu:examination:test | "examination" | "test" | "has lexical unit" |  | "FN" |  |
| fn:examination | fn:HasLexicalUnit | fn:lu:examination:examination | "examination" | "examination" | "has lexical unit" |  | "FN" |  |
| fn:examination | fn:HasLexicalUnit | fn:lu:examination:assessment | "examination" | "assessment" | "has lexical unit" |  | "FN" |  |
| fn:examination | fn:HasLexicalUnit | fn:lu:examination:examine | "examination" | "examine" | "has lexical unit" |  | "FN" |  |
| fn:examination | fn:HasLexicalUnit | fn:lu:examination:exam | "examination" | "exam" | "has lexical unit" |  | "FN" |  |
| fn:fe:examiner | /r/IsA | fn:st:human | "examiner" | "human" | "/r/is a" |  | "FN" |  |
| fn:examination | /r/HasA | fn:fe:examiner | "examination" | "examiner" | "/r/has a" |  | "FN" |  |
| fn:examination | /r/HasA | fn:fe:examinee | "examination" | "examinee" | "/r/has a" |  | "FN" |  |
| fn:examination | /r/HasA | fn:fe:knowledge | "examination" | "knowledge" | "/r/has a" |  | "FN" |  |
| fn:examination | /r/HasA | fn:fe:qualification | "examination" | "qualification" | "/r/has a" |  | "FN" |  |
| fn:examination | /r/HasA | fn:fe:examination | "examination" | "examination" | "/r/has a" |  | "FN" |  |
| fn:examination | /r/HasA | fn:fe:means | "examination" | "means" | "/r/has a" |  | "FN" |  |
| fn:examination | /r/HasA | fn:fe:purpose | "examination" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:examination | /r/HasA | fn:fe:place | "examination" | "place" | "/r/has a" |  | "FN" |  |
| fn:examination | /r/HasA | fn:fe:time | "examination" | "time" | "/r/has a" |  | "FN" |  |
| fn:examination | /r/HasA | fn:fe:manner | "examination" | "manner" | "/r/has a" |  | "FN" |  |
| fn:exchange | /r/IsA | fn:intentionally_act | "exchange" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:exchange | /r/IsA | fn:reciprocality | "exchange" | "reciprocality" | "/r/is a" |  | "FN" |  |
| fn:exchange | /r/UsedFor | fn:exchange_currency | "exchange" | "exchange currency" | "/r/used for" |  | "FN" |  |
| fn:transfer_scenario | /r/UsedFor | fn:exchange | "transfer scenario" | "exchange" | "/r/used for" |  | "FN" |  |
| fn:exchange | /r/RelatedTo | fn:replacing | "exchange" | "replacing" | "/r/related to" |  | "FN" |  |
| fn:exchange | fn:HasLexicalUnit | fn:lu:exchange:exchange | "exchange" | "exchange" | "has lexical unit" |  | "FN" |  |
| fn:exchange | fn:HasLexicalUnit | fn:lu:exchange:trade | "exchange" | "trade" | "has lexical unit" |  | "FN" |  |
| fn:exchange | fn:HasLexicalUnit | fn:lu:exchange:swap | "exchange" | "swap" | "has lexical unit" |  | "FN" |  |
| fn:exchange | fn:HasLexicalUnit | fn:lu:exchange:exchange | "exchange" | "exchange" | "has lexical unit" |  | "FN" |  |
| fn:exchange | fn:HasLexicalUnit | fn:lu:exchange:swap | "exchange" | "swap" | "has lexical unit" |  | "FN" |  |
| fn:exchange | fn:HasLexicalUnit | fn:lu:exchange:trade | "exchange" | "trade" | "has lexical unit" |  | "FN" |  |
| fn:exchange | fn:HasLexicalUnit | fn:lu:exchange:switch | "exchange" | "switch" | "has lexical unit" |  | "FN" |  |
| fn:exchange | fn:HasLexicalUnit | fn:lu:exchange:change | "exchange" | "change" | "has lexical unit" |  | "FN" |  |
| fn:fe:exchanger_1 | /r/IsA | fn:st:sentient | "exchanger 1" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:fe:exchanger_1 | /r/HasPrerequisite | fn:fe:exchanger_2 | "exchanger 1" | "exchanger 2" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:exchanger_1 | /r/RelatedTo | fn:fe:exchangers | "exchanger 1" | "exchangers" | "/r/related to" |  | "FN" |  |
| fn:exchange | /r/HasA | fn:fe:exchanger_1 | "exchange" | "exchanger 1" | "/r/has a" |  | "FN" |  |
| fn:exchange | /r/HasA | fn:fe:place | "exchange" | "place" | "/r/has a" |  | "FN" |  |
| fn:exchange | /r/HasA | fn:fe:purpose | "exchange" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:exchange | /r/HasA | fn:fe:time | "exchange" | "time" | "/r/has a" |  | "FN" |  |
| fn:exchange | /r/HasA | fn:fe:means | "exchange" | "means" | "/r/has a" |  | "FN" |  |
| fn:exchange | /r/HasA | fn:fe:manner | "exchange" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fe:exchanger_2 | /r/HasPrerequisite | fn:fe:exchanger_1 | "exchanger 2" | "exchanger 1" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:exchanger_2 | /r/RelatedTo | fn:fe:exchangers | "exchanger 2" | "exchangers" | "/r/related to" |  | "FN" |  |
| fn:exchange | /r/HasA | fn:fe:exchanger_2 | "exchange" | "exchanger 2" | "/r/has a" |  | "FN" |  |
| fn:fe:exchangers | /r/HasPrerequisite | fn:fe:themes | "exchangers" | "themes" | "/r/has prerequisite" |  | "FN" |  |
| fn:exchange | /r/HasA | fn:fe:exchangers | "exchange" | "exchangers" | "/r/has a" |  | "FN" |  |
| fn:exchange | /r/HasA | fn:fe:depictive | "exchange" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:fe:theme_1 | /r/HasPrerequisite | fn:fe:theme_2 | "theme 1" | "theme 2" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:theme_1 | /r/RelatedTo | fn:fe:themes | "theme 1" | "themes" | "/r/related to" |  | "FN" |  |
| fn:exchange | /r/HasA | fn:fe:theme_1 | "exchange" | "theme 1" | "/r/has a" |  | "FN" |  |
| fn:fe:theme_2 | /r/HasPrerequisite | fn:fe:theme_1 | "theme 2" | "theme 1" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:theme_2 | /r/RelatedTo | fn:fe:themes | "theme 2" | "themes" | "/r/related to" |  | "FN" |  |
| fn:exchange | /r/HasA | fn:fe:theme_2 | "exchange" | "theme 2" | "/r/has a" |  | "FN" |  |
| fn:exchange | /r/HasA | fn:fe:themes | "exchange" | "themes" | "/r/has a" |  | "FN" |  |
| fn:exchange | /r/HasA | fn:fe:frequency | "exchange" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:exchange | /r/HasA | fn:fe:period_of_iterations | "exchange" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:exchange_currency | /r/IsA | fn:cause_change | "exchange currency" | "cause change" | "/r/is a" |  | "FN" |  |
| fn:commerce_scenario | /r/UsedFor | fn:exchange_currency | "commerce scenario" | "exchange currency" | "/r/used for" |  | "FN" |  |
| fn:exchange | /r/UsedFor | fn:exchange_currency | "exchange" | "exchange currency" | "/r/used for" |  | "FN" |  |
| fn:exchange_currency | fn:HasLexicalUnit | fn:lu:exchange_currency:exchange | "exchange currency" | "exchange" | "has lexical unit" |  | "FN" |  |
| fn:exchange_currency | fn:HasLexicalUnit | fn:lu:exchange_currency:change | "exchange currency" | "change" | "has lexical unit" |  | "FN" |  |
| fn:exchange_currency | fn:HasLexicalUnit | fn:lu:exchange_currency:convert | "exchange currency" | "convert" | "has lexical unit" |  | "FN" |  |
| fn:fe:money_owner | /r/IsA | fn:st:sentient | "money owner" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:exchange_currency | /r/HasA | fn:fe:money_owner | "exchange currency" | "money owner" | "/r/has a" |  | "FN" |  |
| fn:fe:sum_1 | /r/RelatedTo | fn:fe:source_currency | "sum 1" | "source currency" | "/r/related to" |  | "FN" |  |
| fn:exchange_currency | /r/HasA | fn:fe:sum_1 | "exchange currency" | "sum 1" | "/r/has a" |  | "FN" |  |
| fn:exchange_currency | /r/HasA | fn:fe:source_currency | "exchange currency" | "source currency" | "/r/has a" |  | "FN" |  |
| fn:fe:sum_2 | /r/RelatedTo | fn:fe:target_currency | "sum 2" | "target currency" | "/r/related to" |  | "FN" |  |
| fn:exchange_currency | /r/HasA | fn:fe:sum_2 | "exchange currency" | "sum 2" | "/r/has a" |  | "FN" |  |
| fn:exchange_currency | /r/HasA | fn:fe:exchange_service | "exchange currency" | "exchange service" | "/r/has a" |  | "FN" |  |
| fn:exchange_currency | /r/HasA | fn:fe:target_currency | "exchange currency" | "target currency" | "/r/has a" |  | "FN" |  |
| fn:exchange_currency | /r/HasA | fn:fe:place | "exchange currency" | "place" | "/r/has a" |  | "FN" |  |
| fn:exchange_currency | /r/HasA | fn:fe:time | "exchange currency" | "time" | "/r/has a" |  | "FN" |  |
| fn:exchange_currency | /r/HasA | fn:fe:manner | "exchange currency" | "manner" | "/r/has a" |  | "FN" |  |
| fn:exchange_currency | /r/HasA | fn:fe:exchange_rate | "exchange currency" | "exchange rate" | "/r/has a" |  | "FN" |  |
| fn:exchange_currency | /r/HasA | fn:fe:means | "exchange currency" | "means" | "/r/has a" |  | "FN" |  |
| fn:exchange_currency | /r/HasA | fn:fe:purpose | "exchange currency" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:exchange_currency | /r/HasA | fn:fe:money | "exchange currency" | "money" | "/r/has a" |  | "FN" |  |
| fn:membership | /r/UsedFor | fn:exclude_member | "membership" | "exclude member" | "/r/used for" |  | "FN" |  |
| fn:exclude_member | fn:HasLexicalUnit | fn:lu:exclude_member:expel | "exclude member" | "expel" | "has lexical unit" |  | "FN" |  |
| fn:exclude_member | fn:HasLexicalUnit | fn:lu:exclude_member:excommunicate | "exclude member" | "excommunicate" | "has lexical unit" |  | "FN" |  |
| fn:exclude_member | fn:HasLexicalUnit | fn:lu:exclude_member:expulsion | "exclude member" | "expulsion" | "has lexical unit" |  | "FN" |  |
| fn:exclude_member | fn:HasLexicalUnit | fn:lu:exclude_member:excommunication | "exclude member" | "excommunication" | "has lexical unit" |  | "FN" |  |
| fn:exclude_member | fn:HasLexicalUnit | fn:lu:exclude_member:exclude | "exclude member" | "exclude" | "has lexical unit" |  | "FN" |  |
| fn:exclude_member | /r/HasA | fn:fe:member | "exclude member" | "member" | "/r/has a" |  | "FN" |  |
| fn:exclude_member | /r/HasA | fn:fe:group | "exclude member" | "group" | "/r/has a" |  | "FN" |  |
| fn:exclude_member | /r/HasA | fn:fe:authority | "exclude member" | "authority" | "/r/has a" |  | "FN" |  |
| fn:exclude_member | /r/HasA | fn:fe:time | "exclude member" | "time" | "/r/has a" |  | "FN" |  |
| fn:exclude_member | /r/HasA | fn:fe:explanation | "exclude member" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:exclude_member | /r/HasA | fn:fe:place | "exclude member" | "place" | "/r/has a" |  | "FN" |  |
| fn:exclude_member | /r/HasA | fn:fe:means | "exclude member" | "means" | "/r/has a" |  | "FN" |  |
| fn:exclude_member | /r/HasA | fn:fe:depictive | "exclude member" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:cause_motion | /r/UsedFor | fn:excreting | "cause motion" | "excreting" | "/r/used for" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:excreting | "motion" | "excreting" | "/r/used for" |  | "FN" |  |
| fn:removing | /r/SimilarTo | fn:excreting | "removing" | "excreting" | "/r/similar to" |  | "FN" |  |
| fn:excreting | fn:HasLexicalUnit | fn:lu:excreting:urinate | "excreting" | "urinate" | "has lexical unit" |  | "FN" |  |
| fn:excreting | fn:HasLexicalUnit | fn:lu:excreting:shit | "excreting" | "shit" | "has lexical unit" |  | "FN" |  |
| fn:excreting | fn:HasLexicalUnit | fn:lu:excreting:defecate | "excreting" | "defecate" | "has lexical unit" |  | "FN" |  |
| fn:excreting | fn:HasLexicalUnit | fn:lu:excreting:void | "excreting" | "void" | "has lexical unit" |  | "FN" |  |
| fn:excreting | fn:HasLexicalUnit | fn:lu:excreting:burp | "excreting" | "burp" | "has lexical unit" |  | "FN" |  |
| fn:excreting | fn:HasLexicalUnit | fn:lu:excreting:belch | "excreting" | "belch" | "has lexical unit" |  | "FN" |  |
| fn:excreting | fn:HasLexicalUnit | fn:lu:excreting:fart | "excreting" | "fart" | "has lexical unit" |  | "FN" |  |
| fn:excreting | fn:HasLexicalUnit | fn:lu:excreting:vomit | "excreting" | "vomit" | "has lexical unit" |  | "FN" |  |
| fn:excreting | fn:HasLexicalUnit | fn:lu:excreting:pee | "excreting" | "pee" | "has lexical unit" |  | "FN" |  |
| fn:excreting | fn:HasLexicalUnit | fn:lu:excreting:piss | "excreting" | "piss" | "has lexical unit" |  | "FN" |  |
| fn:excreting | fn:HasLexicalUnit | fn:lu:excreting:puke | "excreting" | "puke" | "has lexical unit" |  | "FN" |  |
| fn:excreting | fn:HasLexicalUnit | fn:lu:excreting:regurgitate | "excreting" | "regurgitate" | "has lexical unit" |  | "FN" |  |
| fn:excreting | fn:HasLexicalUnit | fn:lu:excreting:sweat | "excreting" | "sweat" | "has lexical unit" |  | "FN" |  |
| fn:excreting | fn:HasLexicalUnit | fn:lu:excreting:spew | "excreting" | "spew" | "has lexical unit" |  | "FN" |  |
| fn:excreting | fn:HasLexicalUnit | fn:lu:excreting:retch | "excreting" | "retch" | "has lexical unit" |  | "FN" |  |
| fn:excreting | fn:HasLexicalUnit | fn:lu:excreting:take_a_piss | "excreting" | "take a piss" | "has lexical unit" |  | "FN" |  |
| fn:excreting | fn:HasLexicalUnit | fn:lu:excreting:evacuate | "excreting" | "evacuate" | "has lexical unit" |  | "FN" |  |
| fn:excreting | fn:HasLexicalUnit | fn:lu:excreting:throw_up | "excreting" | "throw up" | "has lexical unit" |  | "FN" |  |
| fn:excreting | fn:HasLexicalUnit | fn:lu:excreting:perspire | "excreting" | "perspire" | "has lexical unit" |  | "FN" |  |
| fn:excreting | fn:HasLexicalUnit | fn:lu:excreting:perspiration | "excreting" | "perspiration" | "has lexical unit" |  | "FN" |  |
| fn:excreting | fn:HasLexicalUnit | fn:lu:excreting:sweat | "excreting" | "sweat" | "has lexical unit" |  | "FN" |  |
| fn:excreting | fn:HasLexicalUnit | fn:lu:excreting:spit_up | "excreting" | "spit up" | "has lexical unit" |  | "FN" |  |
| fn:excreting | /r/HasA | fn:fe:excreta | "excreting" | "excreta" | "/r/has a" |  | "FN" |  |
| fn:excreting | /r/HasA | fn:fe:excreter | "excreting" | "excreter" | "/r/has a" |  | "FN" |  |
| fn:excreting | /r/HasA | fn:fe:source | "excreting" | "source" | "/r/has a" |  | "FN" |  |
| fn:excreting | /r/HasA | fn:fe:path | "excreting" | "path" | "/r/has a" |  | "FN" |  |
| fn:excreting | /r/HasA | fn:fe:goal | "excreting" | "goal" | "/r/has a" |  | "FN" |  |
| fn:excreting | /r/HasA | fn:fe:manner | "excreting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:excreting | /r/HasA | fn:fe:means | "excreting" | "means" | "/r/has a" |  | "FN" |  |
| fn:excreting | /r/HasA | fn:fe:place | "excreting" | "place" | "/r/has a" |  | "FN" |  |
| fn:excreting | /r/HasA | fn:fe:time | "excreting" | "time" | "/r/has a" |  | "FN" |  |
| fn:excreting | /r/HasA | fn:fe:purpose | "excreting" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:excreting | /r/HasA | fn:fe:frequency | "excreting" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:excreting | /r/HasA | fn:fe:degree | "excreting" | "degree" | "/r/has a" |  | "FN" |  |
| fn:enforcing | /r/IsA | fn:execute_plan | "enforcing" | "execute plan" | "/r/is a" |  | "FN" |  |
| fn:execute_plan | /r/IsA | fn:intentionally_act | "execute plan" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:being_in_effect | /r/RelatedTo | fn:execute_plan | "being in effect" | "execute plan" | "/r/related to" |  | "FN" |  |
| fn:execute_plan | fn:HasLexicalUnit | fn:lu:execute_plan:implement | "execute plan" | "implement" | "has lexical unit" |  | "FN" |  |
| fn:execute_plan | fn:HasLexicalUnit | fn:lu:execute_plan:implementation | "execute plan" | "implementation" | "has lexical unit" |  | "FN" |  |
| fn:execute_plan | fn:HasLexicalUnit | fn:lu:execute_plan:effect_[into_effect] | "execute plan" | "effect [into effect]" | "has lexical unit" |  | "FN" |  |
| fn:execute_plan | fn:HasLexicalUnit | fn:lu:execute_plan:institute | "execute plan" | "institute" | "has lexical unit" |  | "FN" |  |
| fn:execute_plan | fn:HasLexicalUnit | fn:lu:execute_plan:force_[into_force] | "execute plan" | "force [into force]" | "has lexical unit" |  | "FN" |  |
| fn:execute_plan | /r/HasA | fn:fe:plan | "execute plan" | "plan" | "/r/has a" |  | "FN" |  |
| fn:execute_plan | /r/HasA | fn:fe:duration | "execute plan" | "duration" | "/r/has a" |  | "FN" |  |
| fn:execute_plan | /r/HasA | fn:fe:time | "execute plan" | "time" | "/r/has a" |  | "FN" |  |
| fn:execute_plan | /r/HasA | fn:fe:place | "execute plan" | "place" | "/r/has a" |  | "FN" |  |
| fn:execute_plan | /r/HasA | fn:fe:circumstances | "execute plan" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:execute_plan | /r/HasA | fn:fe:explanation | "execute plan" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:execute_plan | /r/HasA | fn:fe:focal_participant | "execute plan" | "focal participant" | "/r/has a" |  | "FN" |  |
| fn:execute_plan | /r/HasA | fn:fe:agent | "execute plan" | "agent" | "/r/has a" |  | "FN" |  |
| fn:execute_plan | /r/HasA | fn:fe:manner | "execute plan" | "manner" | "/r/has a" |  | "FN" |  |
| fn:execute_plan | /r/HasA | fn:fe:means | "execute plan" | "means" | "/r/has a" |  | "FN" |  |
| fn:execute_plan | /r/HasA | fn:fe:purpose | "execute plan" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:execute_plan | /r/HasA | fn:fe:degree | "execute plan" | "degree" | "/r/has a" |  | "FN" |  |
| fn:execute_plan | /r/HasA | fn:fe:medium | "execute plan" | "medium" | "/r/has a" |  | "FN" |  |
| fn:execute_plan | /r/HasA | fn:fe:outcome | "execute plan" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:execution | /r/IsA | fn:killing | "execution" | "killing" | "/r/is a" |  | "FN" |  |
| fn:execution | /r/IsA | fn:rewards_and_punishments | "execution" | "rewards and punishments" | "/r/is a" |  | "FN" |  |
| fn:killing | /r/SimilarTo | fn:execution | "killing" | "execution" | "/r/similar to" |  | "FN" |  |
| fn:execution | fn:HasLexicalUnit | fn:lu:execution:execute | "execution" | "execute" | "has lexical unit" |  | "FN" |  |
| fn:execution | fn:HasLexicalUnit | fn:lu:execution:execution | "execution" | "execution" | "has lexical unit" |  | "FN" |  |
| fn:execution | fn:HasLexicalUnit | fn:lu:execution:executioner | "execution" | "executioner" | "has lexical unit" |  | "FN" |  |
| fn:execution | fn:HasLexicalUnit | fn:lu:execution:hangman | "execution" | "hangman" | "has lexical unit" |  | "FN" |  |
| fn:execution | fn:HasLexicalUnit | fn:lu:execution:headsman | "execution" | "headsman" | "has lexical unit" |  | "FN" |  |
| fn:execution | fn:HasLexicalUnit | fn:lu:execution:firing_squad | "execution" | "firing squad" | "has lexical unit" |  | "FN" |  |
| fn:execution | fn:HasLexicalUnit | fn:lu:execution:hang | "execution" | "hang" | "has lexical unit" |  | "FN" |  |
| fn:execution | fn:HasLexicalUnit | fn:lu:execution:guillotine | "execution" | "guillotine" | "has lexical unit" |  | "FN" |  |
| fn:execution | fn:HasLexicalUnit | fn:lu:execution:guillotining | "execution" | "guillotining" | "has lexical unit" |  | "FN" |  |
| fn:execution | fn:HasLexicalUnit | fn:lu:execution:put_to_death | "execution" | "put to death" | "has lexical unit" |  | "FN" |  |
| fn:execution | fn:HasLexicalUnit | fn:lu:execution:hanging | "execution" | "hanging" | "has lexical unit" |  | "FN" |  |
| fn:fe:executioner | /r/IsA | fn:st:sentient | "executioner" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:execution | /r/HasA | fn:fe:executioner | "execution" | "executioner" | "/r/has a" |  | "FN" |  |
| fn:execution | /r/HasA | fn:fe:instrument | "execution" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:execution | /r/HasA | fn:fe:means | "execution" | "means" | "/r/has a" |  | "FN" |  |
| fn:execution | /r/HasA | fn:fe:place | "execution" | "place" | "/r/has a" |  | "FN" |  |
| fn:execution | /r/HasA | fn:fe:purpose | "execution" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:execution | /r/HasA | fn:fe:execution | "execution" | "execution" | "/r/has a" |  | "FN" |  |
| fn:execution | /r/HasA | fn:fe:time | "execution" | "time" | "/r/has a" |  | "FN" |  |
| fn:execution | /r/HasA | fn:fe:degree | "execution" | "degree" | "/r/has a" |  | "FN" |  |
| fn:execution | /r/HasA | fn:fe:depictive | "execution" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:fe:executed | /r/IsA | fn:st:sentient | "executed" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:execution | /r/HasA | fn:fe:executed | "execution" | "executed" | "/r/has a" |  | "FN" |  |
| fn:execution | /r/HasA | fn:fe:manner | "execution" | "manner" | "/r/has a" |  | "FN" |  |
| fn:execution | /r/HasA | fn:fe:explanation | "execution" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:execution | /r/HasA | fn:fe:result | "execution" | "result" | "/r/has a" |  | "FN" |  |
| fn:exemplar | /r/IsA | fn:instance | "exemplar" | "instance" | "/r/is a" |  | "FN" |  |
| fn:judgment | /r/UsedFor | fn:exemplar | "judgment" | "exemplar" | "/r/used for" |  | "FN" |  |
| fn:exemplariness | /r/IsA | fn:exemplar | "exemplariness" | "exemplar" | "/r/is a" |  | "FN" |  |
| fn:exemplar | fn:HasLexicalUnit | fn:lu:exemplar:prototype | "exemplar" | "prototype" | "has lexical unit" |  | "FN" |  |
| fn:exemplar | fn:HasLexicalUnit | fn:lu:exemplar:model | "exemplar" | "model" | "has lexical unit" |  | "FN" |  |
| fn:exemplar | fn:HasLexicalUnit | fn:lu:exemplar:image | "exemplar" | "image" | "has lexical unit" |  | "FN" |  |
| fn:exemplar | fn:HasLexicalUnit | fn:lu:exemplar:exemplar | "exemplar" | "exemplar" | "has lexical unit" |  | "FN" |  |
| fn:exemplar | fn:HasLexicalUnit | fn:lu:exemplar:epitome | "exemplar" | "epitome" | "has lexical unit" |  | "FN" |  |
| fn:exemplar | fn:HasLexicalUnit | fn:lu:exemplar:paragon | "exemplar" | "paragon" | "has lexical unit" |  | "FN" |  |
| fn:exemplar | fn:HasLexicalUnit | fn:lu:exemplar:true | "exemplar" | "true" | "has lexical unit" |  | "FN" |  |
| fn:exemplar | /r/HasA | fn:fe:instance | "exemplar" | "instance" | "/r/has a" |  | "FN" |  |
| fn:exemplar | /r/HasA | fn:fe:type | "exemplar" | "type" | "/r/has a" |  | "FN" |  |
| fn:exemplar | /r/HasA | fn:fe:domain | "exemplar" | "domain" | "/r/has a" |  | "FN" |  |
| fn:exemplar | /r/HasA | fn:fe:instance_prop | "exemplar" | "instance prop" | "/r/has a" |  | "FN" |  |
| fn:exemplariness | /r/IsA | fn:exemplar | "exemplariness" | "exemplar" | "/r/is a" |  | "FN" |  |
| fn:exemplariness | fn:HasLexicalUnit | fn:lu:exemplariness:exemplary | "exemplariness" | "exemplary" | "has lexical unit" |  | "FN" |  |
| fn:exemplariness | fn:HasLexicalUnit | fn:lu:exemplariness:prototypical | "exemplariness" | "prototypical" | "has lexical unit" |  | "FN" |  |
| fn:exemplariness | fn:HasLexicalUnit | fn:lu:exemplariness:standard | "exemplariness" | "standard" | "has lexical unit" |  | "FN" |  |
| fn:exemplariness | /r/HasA | fn:fe:entity | "exemplariness" | "entity" | "/r/has a" |  | "FN" |  |
| fn:exemplariness | /r/HasA | fn:fe:comparison_set | "exemplariness" | "comparison set" | "/r/has a" |  | "FN" |  |
| fn:exemplariness | /r/HasA | fn:fe:domain | "exemplariness" | "domain" | "/r/has a" |  | "FN" |  |
| fn:exemplariness | /r/HasA | fn:fe:degree | "exemplariness" | "degree" | "/r/has a" |  | "FN" |  |
| fn:exercising | /r/IsA | fn:intentionally_act | "exercising" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:exercising | fn:HasLexicalUnit | fn:lu:exercising:exercise | "exercising" | "exercise" | "has lexical unit" |  | "FN" |  |
| fn:exercising | fn:HasLexicalUnit | fn:lu:exercising:work_out | "exercising" | "work out" | "has lexical unit" |  | "FN" |  |
| fn:exercising | fn:HasLexicalUnit | fn:lu:exercising:exercise | "exercising" | "exercise" | "has lexical unit" |  | "FN" |  |
| fn:exercising | /r/HasA | fn:fe:agent | "exercising" | "agent" | "/r/has a" |  | "FN" |  |
| fn:exercising | /r/HasA | fn:fe:body_part | "exercising" | "body part" | "/r/has a" |  | "FN" |  |
| fn:exercising | /r/HasA | fn:fe:means | "exercising" | "means" | "/r/has a" |  | "FN" |  |
| fn:exercising | /r/HasA | fn:fe:manner | "exercising" | "manner" | "/r/has a" |  | "FN" |  |
| fn:exercising | /r/HasA | fn:fe:time | "exercising" | "time" | "/r/has a" |  | "FN" |  |
| fn:exercising | /r/HasA | fn:fe:place | "exercising" | "place" | "/r/has a" |  | "FN" |  |
| fn:exercising | /r/HasA | fn:fe:frequency | "exercising" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:exercising | /r/HasA | fn:fe:subtype | "exercising" | "subtype" | "/r/has a" |  | "FN" |  |
| fn:exercising | /r/HasA | fn:fe:purpose | "exercising" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:circumscribed_existence | /r/IsA | fn:existence | "circumscribed existence" | "existence" | "/r/is a" |  | "FN" |  |
| fn:existence | /r/IsA | fn:state | "existence" | "state" | "/r/is a" |  | "FN" |  |
| fn:cycle_of_existence_scenario | /r/HasSubevent | fn:existence | "cycle of existence scenario" | "existence" | "/r/has subevent" |  | "FN" |  |
| fn:existence | /r/UsedFor | fn:have_associated | "existence" | "have associated" | "/r/used for" |  | "FN" |  |
| fn:existence | /r/UsedFor | fn:locative_relation | "existence" | "locative relation" | "/r/used for" |  | "FN" |  |
| fn:existence | /r/RelatedTo | fn:presence | "existence" | "presence" | "/r/related to" |  | "FN" |  |
| fn:coming_to_be | /r/Causes | fn:existence | "coming to be" | "existence" | "/r/causes" |  | "FN" |  |
| fn:existence | /r/HasPrerequisite | fn:coming_to_be | "existence" | "coming to be" | "/r/has prerequisite" |  | "FN" |  |
| fn:ceasing_to_be | /r/HasPrerequisite | fn:existence | "ceasing to be" | "existence" | "/r/has prerequisite" |  | "FN" |  |
| fn:existence | fn:HasLexicalUnit | fn:lu:existence:exist | "existence" | "exist" | "has lexical unit" |  | "FN" |  |
| fn:existence | fn:HasLexicalUnit | fn:lu:existence:existence | "existence" | "existence" | "has lexical unit" |  | "FN" |  |
| fn:existence | fn:HasLexicalUnit | fn:lu:existence:real | "existence" | "real" | "has lexical unit" |  | "FN" |  |
| fn:existence | fn:HasLexicalUnit | fn:lu:existence:there_be | "existence" | "there be" | "has lexical unit" |  | "FN" |  |
| fn:existence | fn:HasLexicalUnit | fn:lu:existence:remain | "existence" | "remain" | "has lexical unit" |  | "FN" |  |
| fn:existence | /r/HasA | fn:fe:entity | "existence" | "entity" | "/r/has a" |  | "FN" |  |
| fn:existence | /r/HasA | fn:fe:time | "existence" | "time" | "/r/has a" |  | "FN" |  |
| fn:existence | /r/HasA | fn:fe:duration | "existence" | "duration" | "/r/has a" |  | "FN" |  |
| fn:existence | /r/HasA | fn:fe:inherent_purpose | "existence" | "inherent purpose" | "/r/has a" |  | "FN" |  |
| fn:existence | /r/HasA | fn:fe:state | "existence" | "state" | "/r/has a" |  | "FN" |  |
| fn:existence | /r/HasA | fn:fe:explanation | "existence" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:existence | /r/HasA | fn:fe:place | "existence" | "place" | "/r/has a" |  | "FN" |  |
| fn:existence | /r/HasA | fn:fe:circumstances | "existence" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:existence | /r/HasA | fn:fe:viewpoint | "existence" | "viewpoint" | "/r/has a" |  | "FN" |  |
| fn:existence | /r/HasA | fn:fe:concessive | "existence" | "concessive" | "/r/has a" |  | "FN" |  |
| fn:existence | /r/HasA | fn:fe:depictive | "existence" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:expansion | /r/UsedFor | fn:dough_rising | "expansion" | "dough rising" | "/r/used for" |  | "FN" |  |
| fn:cause_expansion | /r/SimilarTo | fn:expansion | "cause expansion" | "expansion" | "/r/similar to" |  | "FN" |  |
| fn:cause_expansion | /r/Causes | fn:expansion | "cause expansion" | "expansion" | "/r/causes" |  | "FN" |  |
| fn:expansion | fn:HasLexicalUnit | fn:lu:expansion:contract | "expansion" | "contract" | "has lexical unit" |  | "FN" |  |
| fn:expansion | fn:HasLexicalUnit | fn:lu:expansion:contraction | "expansion" | "contraction" | "has lexical unit" |  | "FN" |  |
| fn:expansion | fn:HasLexicalUnit | fn:lu:expansion:enlarge | "expansion" | "enlarge" | "has lexical unit" |  | "FN" |  |
| fn:expansion | fn:HasLexicalUnit | fn:lu:expansion:dilate | "expansion" | "dilate" | "has lexical unit" |  | "FN" |  |
| fn:expansion | fn:HasLexicalUnit | fn:lu:expansion:enlargement | "expansion" | "enlargement" | "has lexical unit" |  | "FN" |  |
| fn:expansion | fn:HasLexicalUnit | fn:lu:expansion:expand | "expansion" | "expand" | "has lexical unit" |  | "FN" |  |
| fn:expansion | fn:HasLexicalUnit | fn:lu:expansion:shrink | "expansion" | "shrink" | "has lexical unit" |  | "FN" |  |
| fn:expansion | fn:HasLexicalUnit | fn:lu:expansion:stretch | "expansion" | "stretch" | "has lexical unit" |  | "FN" |  |
| fn:expansion | fn:HasLexicalUnit | fn:lu:expansion:grow | "expansion" | "grow" | "has lexical unit" |  | "FN" |  |
| fn:expansion | fn:HasLexicalUnit | fn:lu:expansion:lengthen | "expansion" | "lengthen" | "has lexical unit" |  | "FN" |  |
| fn:expansion | fn:HasLexicalUnit | fn:lu:expansion:expansion | "expansion" | "expansion" | "has lexical unit" |  | "FN" |  |
| fn:expansion | fn:HasLexicalUnit | fn:lu:expansion:inflate | "expansion" | "inflate" | "has lexical unit" |  | "FN" |  |
| fn:expansion | fn:HasLexicalUnit | fn:lu:expansion:swell | "expansion" | "swell" | "has lexical unit" |  | "FN" |  |
| fn:expansion | fn:HasLexicalUnit | fn:lu:expansion:explosive | "expansion" | "explosive" | "has lexical unit" |  | "FN" |  |
| fn:expansion | fn:HasLexicalUnit | fn:lu:expansion:spread | "expansion" | "spread" | "has lexical unit" |  | "FN" |  |
| fn:expansion | fn:HasLexicalUnit | fn:lu:expansion:extension | "expansion" | "extension" | "has lexical unit" |  | "FN" |  |
| fn:expansion | /r/HasA | fn:fe:item | "expansion" | "item" | "/r/has a" |  | "FN" |  |
| fn:expansion | /r/HasA | fn:fe:dimension | "expansion" | "dimension" | "/r/has a" |  | "FN" |  |
| fn:expansion | /r/HasA | fn:fe:group | "expansion" | "group" | "/r/has a" |  | "FN" |  |
| fn:expansion | /r/HasA | fn:fe:initial_size | "expansion" | "initial size" | "/r/has a" |  | "FN" |  |
| fn:expansion | /r/HasA | fn:fe:result_size | "expansion" | "result size" | "/r/has a" |  | "FN" |  |
| fn:expansion | /r/HasA | fn:fe:size_change | "expansion" | "size change" | "/r/has a" |  | "FN" |  |
| fn:expansion | /r/HasA | fn:fe:rate | "expansion" | "rate" | "/r/has a" |  | "FN" |  |
| fn:expansion | /r/HasA | fn:fe:duration | "expansion" | "duration" | "/r/has a" |  | "FN" |  |
| fn:expansion | /r/HasA | fn:fe:time | "expansion" | "time" | "/r/has a" |  | "FN" |  |
| fn:expansion | /r/HasA | fn:fe:co-variable | "expansion" | "co-variable" | "/r/has a" |  | "FN" |  |
| fn:expansion | /r/HasA | fn:fe:manner | "expansion" | "manner" | "/r/has a" |  | "FN" |  |
| fn:expansion | /r/HasA | fn:fe:degree | "expansion" | "degree" | "/r/has a" |  | "FN" |  |
| fn:expansion | /r/HasA | fn:fe:path | "expansion" | "path" | "/r/has a" |  | "FN" |  |
| fn:expansion | /r/HasA | fn:fe:goal | "expansion" | "goal" | "/r/has a" |  | "FN" |  |
| fn:expectation | /r/IsA | fn:awareness | "expectation" | "awareness" | "/r/is a" |  | "FN" |  |
| fn:expectation | /r/UsedFor | fn:predicting | "expectation" | "predicting" | "/r/used for" |  | "FN" |  |
| fn:omen | /r/RelatedTo | fn:expectation | "omen" | "expectation" | "/r/related to" |  | "FN" |  |
| fn:expectation | fn:HasLexicalUnit | fn:lu:expectation:anticipate | "expectation" | "anticipate" | "has lexical unit" |  | "FN" |  |
| fn:expectation | fn:HasLexicalUnit | fn:lu:expectation:await | "expectation" | "await" | "has lexical unit" |  | "FN" |  |
| fn:expectation | fn:HasLexicalUnit | fn:lu:expectation:expect | "expectation" | "expect" | "has lexical unit" |  | "FN" |  |
| fn:expectation | fn:HasLexicalUnit | fn:lu:expectation:foresee | "expectation" | "foresee" | "has lexical unit" |  | "FN" |  |
| fn:expectation | fn:HasLexicalUnit | fn:lu:expectation:predict | "expectation" | "predict" | "has lexical unit" |  | "FN" |  |
| fn:expectation | fn:HasLexicalUnit | fn:lu:expectation:predictable | "expectation" | "predictable" | "has lexical unit" |  | "FN" |  |
| fn:expectation | fn:HasLexicalUnit | fn:lu:expectation:unpredictable | "expectation" | "unpredictable" | "has lexical unit" |  | "FN" |  |
| fn:expectation | fn:HasLexicalUnit | fn:lu:expectation:unforeseeable | "expectation" | "unforeseeable" | "has lexical unit" |  | "FN" |  |
| fn:expectation | fn:HasLexicalUnit | fn:lu:expectation:foreseeable | "expectation" | "foreseeable" | "has lexical unit" |  | "FN" |  |
| fn:expectation | fn:HasLexicalUnit | fn:lu:expectation:expectation | "expectation" | "expectation" | "has lexical unit" |  | "FN" |  |
| fn:expectation | fn:HasLexicalUnit | fn:lu:expectation:prediction | "expectation" | "prediction" | "has lexical unit" |  | "FN" |  |
| fn:expectation | fn:HasLexicalUnit | fn:lu:expectation:premonition | "expectation" | "premonition" | "has lexical unit" |  | "FN" |  |
| fn:expectation | fn:HasLexicalUnit | fn:lu:expectation:unexpected | "expectation" | "unexpected" | "has lexical unit" |  | "FN" |  |
| fn:expectation | fn:HasLexicalUnit | fn:lu:expectation:wait | "expectation" | "wait" | "has lexical unit" |  | "FN" |  |
| fn:expectation | /r/HasA | fn:fe:cognizer | "expectation" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:expectation | /r/HasA | fn:fe:phenomenon | "expectation" | "phenomenon" | "/r/has a" |  | "FN" |  |
| fn:expectation | /r/HasA | fn:fe:degree | "expectation" | "degree" | "/r/has a" |  | "FN" |  |
| fn:expectation | /r/HasA | fn:fe:depictive | "expectation" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:expectation | /r/HasA | fn:fe:manner | "expectation" | "manner" | "/r/has a" |  | "FN" |  |
| fn:expectation | /r/HasA | fn:fe:evidence | "expectation" | "evidence" | "/r/has a" |  | "FN" |  |
| fn:expectation | /r/HasA | fn:fe:place | "expectation" | "place" | "/r/has a" |  | "FN" |  |
| fn:expectation | /r/HasA | fn:fe:time | "expectation" | "time" | "/r/has a" |  | "FN" |  |
| fn:expectation | /r/HasA | fn:fe:topic | "expectation" | "topic" | "/r/has a" |  | "FN" |  |
| fn:expectation | /r/HasA | fn:fe:time_of_phenomenon | "expectation" | "time of phenomenon" | "/r/has a" |  | "FN" |  |
| fn:temporary_leave | /r/IsA | fn:expected_location_of_person | "temporary leave" | "expected location of person" | "/r/is a" |  | "FN" |  |
| fn:expected_location_of_person | /r/IsA | fn:locative_relation | "expected location of person" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:custom | /r/UsedFor | fn:expected_location_of_person | "custom" | "expected location of person" | "/r/used for" |  | "FN" |  |
| fn:expected_location_of_person | fn:HasLexicalUnit | fn:lu:expected_location_of_person:in | "expected location of person" | "in" | "has lexical unit" |  | "FN" |  |
| fn:expected_location_of_person | fn:HasLexicalUnit | fn:lu:expected_location_of_person:out | "expected location of person" | "out" | "has lexical unit" |  | "FN" |  |
| fn:expected_location_of_person | fn:HasLexicalUnit | fn:lu:expected_location_of_person:home | "expected location of person" | "home" | "has lexical unit" |  | "FN" |  |
| fn:expected_location_of_person | /r/HasA | fn:fe:location | "expected location of person" | "location" | "/r/has a" |  | "FN" |  |
| fn:fe:person | /r/IsA | fn:st:human | "person" | "human" | "/r/is a" |  | "FN" |  |
| fn:expected_location_of_person | /r/HasA | fn:fe:person | "expected location of person" | "person" | "/r/has a" |  | "FN" |  |
| fn:expected_location_of_person | /r/HasA | fn:fe:time | "expected location of person" | "time" | "/r/has a" |  | "FN" |  |
| fn:expected_location_of_person | /r/HasA | fn:fe:duration | "expected location of person" | "duration" | "/r/has a" |  | "FN" |  |
| fn:expend_resource | /r/IsA | fn:using | "expend resource" | "using" | "/r/is a" |  | "FN" |  |
| fn:expend_resource | /r/Causes | fn:used_up | "expend resource" | "used up" | "/r/causes" |  | "FN" |  |
| fn:expend_resource | fn:HasLexicalUnit | fn:lu:expend_resource:exhaust | "expend resource" | "exhaust" | "has lexical unit" |  | "FN" |  |
| fn:expend_resource | fn:HasLexicalUnit | fn:lu:expend_resource:use_up | "expend resource" | "use up" | "has lexical unit" |  | "FN" |  |
| fn:expend_resource | fn:HasLexicalUnit | fn:lu:expend_resource:expend | "expend resource" | "expend" | "has lexical unit" |  | "FN" |  |
| fn:expend_resource | fn:HasLexicalUnit | fn:lu:expend_resource:devour | "expend resource" | "devour" | "has lexical unit" |  | "FN" |  |
| fn:expend_resource | fn:HasLexicalUnit | fn:lu:expend_resource:deplete | "expend resource" | "deplete" | "has lexical unit" |  | "FN" |  |
| fn:expend_resource | fn:HasLexicalUnit | fn:lu:expend_resource:consume | "expend resource" | "consume" | "has lexical unit" |  | "FN" |  |
| fn:expend_resource | fn:HasLexicalUnit | fn:lu:expend_resource:spend | "expend resource" | "spend" | "has lexical unit" |  | "FN" |  |
| fn:expend_resource | fn:HasLexicalUnit | fn:lu:expend_resource:squander | "expend resource" | "squander" | "has lexical unit" |  | "FN" |  |
| fn:expend_resource | fn:HasLexicalUnit | fn:lu:expend_resource:eat_up | "expend resource" | "eat up" | "has lexical unit" |  | "FN" |  |
| fn:expend_resource | fn:HasLexicalUnit | fn:lu:expend_resource:go_through | "expend resource" | "go through" | "has lexical unit" |  | "FN" |  |
| fn:expend_resource | fn:HasLexicalUnit | fn:lu:expend_resource:run_out | "expend resource" | "run out" | "has lexical unit" |  | "FN" |  |
| fn:expend_resource | /r/HasA | fn:fe:resource | "expend resource" | "resource" | "/r/has a" |  | "FN" |  |
| fn:expend_resource | /r/HasA | fn:fe:agent | "expend resource" | "agent" | "/r/has a" |  | "FN" |  |
| fn:expend_resource | /r/HasA | fn:fe:purpose | "expend resource" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:expend_resource | /r/HasA | fn:fe:manner | "expend resource" | "manner" | "/r/has a" |  | "FN" |  |
| fn:expend_resource | /r/HasA | fn:fe:place | "expend resource" | "place" | "/r/has a" |  | "FN" |  |
| fn:expend_resource | /r/HasA | fn:fe:means | "expend resource" | "means" | "/r/has a" |  | "FN" |  |
| fn:expend_resource | /r/HasA | fn:fe:time | "expend resource" | "time" | "/r/has a" |  | "FN" |  |
| fn:expend_resource | /r/HasA | fn:fe:degree | "expend resource" | "degree" | "/r/has a" |  | "FN" |  |
| fn:abounding_with | /r/UsedFor | fn:expensiveness | "abounding with" | "expensiveness" | "/r/used for" |  | "FN" |  |
| fn:commerce_scenario | /r/UsedFor | fn:expensiveness | "commerce scenario" | "expensiveness" | "/r/used for" |  | "FN" |  |
| fn:commerce_scenario | /r/SimilarTo | fn:expensiveness | "commerce scenario" | "expensiveness" | "/r/similar to" |  | "FN" |  |
| fn:expensiveness | fn:HasLexicalUnit | fn:lu:expensiveness:affordable | "expensiveness" | "affordable" | "has lexical unit" |  | "FN" |  |
| fn:expensiveness | fn:HasLexicalUnit | fn:lu:expensiveness:cheap | "expensiveness" | "cheap" | "has lexical unit" |  | "FN" |  |
| fn:expensiveness | fn:HasLexicalUnit | fn:lu:expensiveness:costly | "expensiveness" | "costly" | "has lexical unit" |  | "FN" |  |
| fn:expensiveness | fn:HasLexicalUnit | fn:lu:expensiveness:exorbitant | "expensiveness" | "exorbitant" | "has lexical unit" |  | "FN" |  |
| fn:expensiveness | fn:HasLexicalUnit | fn:lu:expensiveness:expensive | "expensiveness" | "expensive" | "has lexical unit" |  | "FN" |  |
| fn:expensiveness | fn:HasLexicalUnit | fn:lu:expensiveness:free | "expensiveness" | "free" | "has lexical unit" |  | "FN" |  |
| fn:expensiveness | fn:HasLexicalUnit | fn:lu:expensiveness:inexpensive | "expensiveness" | "inexpensive" | "has lexical unit" |  | "FN" |  |
| fn:expensiveness | fn:HasLexicalUnit | fn:lu:expensiveness:low-cost | "expensiveness" | "low-cost" | "has lexical unit" |  | "FN" |  |
| fn:expensiveness | fn:HasLexicalUnit | fn:lu:expensiveness:low-priced | "expensiveness" | "low-priced" | "has lexical unit" |  | "FN" |  |
| fn:expensiveness | fn:HasLexicalUnit | fn:lu:expensiveness:overpriced | "expensiveness" | "overpriced" | "has lexical unit" |  | "FN" |  |
| fn:expensiveness | fn:HasLexicalUnit | fn:lu:expensiveness:pricey | "expensiveness" | "pricey" | "has lexical unit" |  | "FN" |  |
| fn:expensiveness | fn:HasLexicalUnit | fn:lu:expensiveness:cost | "expensiveness" | "cost" | "has lexical unit" |  | "FN" |  |
| fn:expensiveness | fn:HasLexicalUnit | fn:lu:expensiveness:cost | "expensiveness" | "cost" | "has lexical unit" |  | "FN" |  |
| fn:expensiveness | fn:HasLexicalUnit | fn:lu:expensiveness:expense | "expensiveness" | "expense" | "has lexical unit" |  | "FN" |  |
| fn:expensiveness | fn:HasLexicalUnit | fn:lu:expensiveness:affordability | "expensiveness" | "affordability" | "has lexical unit" |  | "FN" |  |
| fn:expensiveness | fn:HasLexicalUnit | fn:lu:expensiveness:set_back | "expensiveness" | "set back" | "has lexical unit" |  | "FN" |  |
| fn:fe:goods | /r/RelatedTo | fn:fe:intended_event | "goods" | "intended event" | "/r/related to" |  | "FN" |  |
| fn:expensiveness | /r/HasA | fn:fe:goods | "expensiveness" | "goods" | "/r/has a" |  | "FN" |  |
| fn:fe:payer | /r/IsA | fn:st:location | "payer" | "location" | "/r/is a" |  | "FN" |  |
| fn:expensiveness | /r/HasA | fn:fe:payer | "expensiveness" | "payer" | "/r/has a" |  | "FN" |  |
| fn:expensiveness | /r/HasA | fn:fe:asset | "expensiveness" | "asset" | "/r/has a" |  | "FN" |  |
| fn:expensiveness | /r/HasA | fn:fe:origin | "expensiveness" | "origin" | "/r/has a" |  | "FN" |  |
| fn:expensiveness | /r/HasA | fn:fe:degree | "expensiveness" | "degree" | "/r/has a" |  | "FN" |  |
| fn:expensiveness | /r/HasA | fn:fe:intended_event | "expensiveness" | "intended event" | "/r/has a" |  | "FN" |  |
| fn:expensiveness | /r/HasA | fn:fe:time | "expensiveness" | "time" | "/r/has a" |  | "FN" |  |
| fn:expensiveness | /r/HasA | fn:fe:rate | "expensiveness" | "rate" | "/r/has a" |  | "FN" |  |
| fn:experience_bodily_harm | /r/IsA | fn:event | "experience bodily harm" | "event" | "/r/is a" |  | "FN" |  |
| fn:experience_bodily_harm | /r/UsedFor | fn:cause_harm | "experience bodily harm" | "cause harm" | "/r/used for" |  | "FN" |  |
| fn:intentionally_act | /r/UsedFor | fn:experience_bodily_harm | "intentionally act" | "experience bodily harm" | "/r/used for" |  | "FN" |  |
| fn:experience_bodily_harm | fn:HasLexicalUnit | fn:lu:experience_bodily_harm:stub | "experience bodily harm" | "stub" | "has lexical unit" |  | "FN" |  |
| fn:experience_bodily_harm | fn:HasLexicalUnit | fn:lu:experience_bodily_harm:jam | "experience bodily harm" | "jam" | "has lexical unit" |  | "FN" |  |
| fn:experience_bodily_harm | fn:HasLexicalUnit | fn:lu:experience_bodily_harm:hit | "experience bodily harm" | "hit" | "has lexical unit" |  | "FN" |  |
| fn:experience_bodily_harm | fn:HasLexicalUnit | fn:lu:experience_bodily_harm:hurt | "experience bodily harm" | "hurt" | "has lexical unit" |  | "FN" |  |
| fn:experience_bodily_harm | fn:HasLexicalUnit | fn:lu:experience_bodily_harm:injure | "experience bodily harm" | "injure" | "has lexical unit" |  | "FN" |  |
| fn:experience_bodily_harm | fn:HasLexicalUnit | fn:lu:experience_bodily_harm:break | "experience bodily harm" | "break" | "has lexical unit" |  | "FN" |  |
| fn:experience_bodily_harm | fn:HasLexicalUnit | fn:lu:experience_bodily_harm:sprain | "experience bodily harm" | "sprain" | "has lexical unit" |  | "FN" |  |
| fn:experience_bodily_harm | fn:HasLexicalUnit | fn:lu:experience_bodily_harm:strain | "experience bodily harm" | "strain" | "has lexical unit" |  | "FN" |  |
| fn:experience_bodily_harm | fn:HasLexicalUnit | fn:lu:experience_bodily_harm:twist | "experience bodily harm" | "twist" | "has lexical unit" |  | "FN" |  |
| fn:experience_bodily_harm | fn:HasLexicalUnit | fn:lu:experience_bodily_harm:pull | "experience bodily harm" | "pull" | "has lexical unit" |  | "FN" |  |
| fn:experience_bodily_harm | fn:HasLexicalUnit | fn:lu:experience_bodily_harm:tear | "experience bodily harm" | "tear" | "has lexical unit" |  | "FN" |  |
| fn:experience_bodily_harm | fn:HasLexicalUnit | fn:lu:experience_bodily_harm:cut | "experience bodily harm" | "cut" | "has lexical unit" |  | "FN" |  |
| fn:experience_bodily_harm | fn:HasLexicalUnit | fn:lu:experience_bodily_harm:burn | "experience bodily harm" | "burn" | "has lexical unit" |  | "FN" |  |
| fn:experience_bodily_harm | fn:HasLexicalUnit | fn:lu:experience_bodily_harm:smack | "experience bodily harm" | "smack" | "has lexical unit" |  | "FN" |  |
| fn:experience_bodily_harm | fn:HasLexicalUnit | fn:lu:experience_bodily_harm:abrade | "experience bodily harm" | "abrade" | "has lexical unit" |  | "FN" |  |
| fn:experience_bodily_harm | fn:HasLexicalUnit | fn:lu:experience_bodily_harm:graze | "experience bodily harm" | "graze" | "has lexical unit" |  | "FN" |  |
| fn:experience_bodily_harm | fn:HasLexicalUnit | fn:lu:experience_bodily_harm:bruise | "experience bodily harm" | "bruise" | "has lexical unit" |  | "FN" |  |
| fn:experience_bodily_harm | fn:HasLexicalUnit | fn:lu:experience_bodily_harm:scrape | "experience bodily harm" | "scrape" | "has lexical unit" |  | "FN" |  |
| fn:experience_bodily_harm | fn:HasLexicalUnit | fn:lu:experience_bodily_harm:sunburn | "experience bodily harm" | "sunburn" | "has lexical unit" |  | "FN" |  |
| fn:experience_bodily_harm | fn:HasLexicalUnit | fn:lu:experience_bodily_harm:injury | "experience bodily harm" | "injury" | "has lexical unit" |  | "FN" |  |
| fn:experience_bodily_harm | /r/HasA | fn:fe:body_part | "experience bodily harm" | "body part" | "/r/has a" |  | "FN" |  |
| fn:experience_bodily_harm | /r/HasA | fn:fe:containing_event | "experience bodily harm" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:experience_bodily_harm | /r/HasA | fn:fe:manner | "experience bodily harm" | "manner" | "/r/has a" |  | "FN" |  |
| fn:experience_bodily_harm | /r/HasA | fn:fe:place | "experience bodily harm" | "place" | "/r/has a" |  | "FN" |  |
| fn:experience_bodily_harm | /r/HasA | fn:fe:experiencer | "experience bodily harm" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:experience_bodily_harm | /r/HasA | fn:fe:time | "experience bodily harm" | "time" | "/r/has a" |  | "FN" |  |
| fn:experience_bodily_harm | /r/HasA | fn:fe:injuring_entity | "experience bodily harm" | "injuring entity" | "/r/has a" |  | "FN" |  |
| fn:experience_bodily_harm | /r/HasA | fn:fe:severity | "experience bodily harm" | "severity" | "/r/has a" |  | "FN" |  |
| fn:experience_bodily_harm | /r/HasA | fn:fe:iterations | "experience bodily harm" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:experience_bodily_harm | /r/HasA | fn:fe:duration | "experience bodily harm" | "duration" | "/r/has a" |  | "FN" |  |
| fn:experience_bodily_harm | /r/HasA | fn:fe:frequency | "experience bodily harm" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:desiring | /r/IsA | fn:experiencer_focus | "desiring" | "experiencer focus" | "/r/is a" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | /r/IsA | fn:experiencer_focus | "mental stimulus exp focus" | "experiencer focus" | "/r/is a" |  | "FN" |  |
| fn:experiencer_focus | /r/UsedFor | fn:desirability | "experiencer focus" | "desirability" | "/r/used for" |  | "FN" |  |
| fn:experiencer_focus | /r/UsedFor | fn:tolerating | "experiencer focus" | "tolerating" | "/r/used for" |  | "FN" |  |
| fn:emotion_directed | /r/SimilarTo | fn:experiencer_focus | "emotion directed" | "experiencer focus" | "/r/similar to" |  | "FN" |  |
| fn:experiencer_focus | /r/SimilarTo | fn:desiring | "experiencer focus" | "desiring" | "/r/similar to" |  | "FN" |  |
| fn:experiencer_focus | /r/SimilarTo | fn:emotion_directed | "experiencer focus" | "emotion directed" | "/r/similar to" |  | "FN" |  |
| fn:experiencer_focus | /r/SimilarTo | fn:fear | "experiencer focus" | "fear" | "/r/similar to" |  | "FN" |  |
| fn:experiencer_focus | /r/SimilarTo | fn:feeling | "experiencer focus" | "feeling" | "/r/similar to" |  | "FN" |  |
| fn:cause_emotion | /r/Causes | fn:experiencer_focus | "cause emotion" | "experiencer focus" | "/r/causes" |  | "FN" |  |
| fn:experiencer_focus | /r/IsA | fn:emotions | "experiencer focus" | "emotions" | "/r/is a" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:abhor | "experiencer focus" | "abhor" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:abominate | "experiencer focus" | "abominate" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:adore | "experiencer focus" | "adore" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:delight | "experiencer focus" | "delight" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:despair | "experiencer focus" | "despair" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:despise | "experiencer focus" | "despise" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:detest | "experiencer focus" | "detest" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:dislike | "experiencer focus" | "dislike" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:dread | "experiencer focus" | "dread" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:envy | "experiencer focus" | "envy" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:fear | "experiencer focus" | "fear" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:grieve | "experiencer focus" | "grieve" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:hate | "experiencer focus" | "hate" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:like | "experiencer focus" | "like" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:loathe | "experiencer focus" | "loathe" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:love | "experiencer focus" | "love" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:mourn | "experiencer focus" | "mourn" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:pity | "experiencer focus" | "pity" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:regret | "experiencer focus" | "regret" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:resent | "experiencer focus" | "resent" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:rue | "experiencer focus" | "rue" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:rueful | "experiencer focus" | "rueful" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:hatred | "experiencer focus" | "hatred" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:empathy | "experiencer focus" | "empathy" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:compassion | "experiencer focus" | "compassion" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:dislike | "experiencer focus" | "dislike" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:desperation | "experiencer focus" | "desperation" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:envy | "experiencer focus" | "envy" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:loathing | "experiencer focus" | "loathing" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:pity | "experiencer focus" | "pity" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:regret | "experiencer focus" | "regret" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:resentment | "experiencer focus" | "resentment" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:adoration | "experiencer focus" | "adoration" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:abhorrence | "experiencer focus" | "abhorrence" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:relish | "experiencer focus" | "relish" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:detestation | "experiencer focus" | "detestation" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:nettled | "experiencer focus" | "nettled" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:worried | "experiencer focus" | "worried" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:nervous | "experiencer focus" | "nervous" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:apprehensive | "experiencer focus" | "apprehensive" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:fond | "experiencer focus" | "fond" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:interested | "experiencer focus" | "interested" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:agape | "experiencer focus" | "agape" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:fulfilled | "experiencer focus" | "fulfilled" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:fulfillment | "experiencer focus" | "fulfillment" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:satisfaction | "experiencer focus" | "satisfaction" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:satisfied | "experiencer focus" | "satisfied" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:worked_up | "experiencer focus" | "worked up" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:dissatisfied | "experiencer focus" | "dissatisfied" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:fazed | "experiencer focus" | "fazed" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:unfazed | "experiencer focus" | "unfazed" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:calm | "experiencer focus" | "calm" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:comfort | "experiencer focus" | "comfort" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:solace | "experiencer focus" | "solace" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:pleasure | "experiencer focus" | "pleasure" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:irritated | "experiencer focus" | "irritated" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:upset | "experiencer focus" | "upset" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:antipathy | "experiencer focus" | "antipathy" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:taken | "experiencer focus" | "taken" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:fed_up | "experiencer focus" | "fed up" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:intimidated | "experiencer focus" | "intimidated" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:happily | "experiencer focus" | "happily" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:feverish | "experiencer focus" | "feverish" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:feverishly | "experiencer focus" | "feverishly" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:cool | "experiencer focus" | "cool" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:easy | "experiencer focus" | "easy" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | fn:HasLexicalUnit | fn:lu:experiencer_focus:discomfort | "experiencer focus" | "discomfort" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_focus | /r/HasA | fn:fe:experiencer | "experiencer focus" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:experiencer_focus | /r/HasA | fn:fe:content | "experiencer focus" | "content" | "/r/has a" |  | "FN" |  |
| fn:experiencer_focus | /r/HasA | fn:fe:explanation | "experiencer focus" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:experiencer_focus | /r/HasA | fn:fe:degree | "experiencer focus" | "degree" | "/r/has a" |  | "FN" |  |
| fn:experiencer_focus | /r/HasA | fn:fe:manner | "experiencer focus" | "manner" | "/r/has a" |  | "FN" |  |
| fn:experiencer_focus | /r/HasA | fn:fe:expressor | "experiencer focus" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:experiencer_focus | /r/HasA | fn:fe:parameter | "experiencer focus" | "parameter" | "/r/has a" |  | "FN" |  |
| fn:experiencer_focus | /r/HasA | fn:fe:topic | "experiencer focus" | "topic" | "/r/has a" |  | "FN" |  |
| fn:experiencer_focus | /r/HasA | fn:fe:state | "experiencer focus" | "state" | "/r/has a" |  | "FN" |  |
| fn:experiencer_focus | /r/HasA | fn:fe:event | "experiencer focus" | "event" | "/r/has a" |  | "FN" |  |
| fn:experiencer_focus | /r/HasA | fn:fe:circumstances | "experiencer focus" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:experiencer_focus | /r/HasA | fn:fe:time | "experiencer focus" | "time" | "/r/has a" |  | "FN" |  |
| fn:emotions | /r/UsedFor | fn:experiencer_obj | "emotions" | "experiencer obj" | "/r/used for" |  | "FN" |  |
| fn:experiencer_obj | /r/SimilarTo | fn:emotion_directed | "experiencer obj" | "emotion directed" | "/r/similar to" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:aggrieve | "experiencer obj" | "aggrieve" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:alarm | "experiencer obj" | "alarm" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:amaze | "experiencer obj" | "amaze" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:anger | "experiencer obj" | "anger" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:annoy | "experiencer obj" | "annoy" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:antagonize | "experiencer obj" | "antagonize" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:astonish | "experiencer obj" | "astonish" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:astound | "experiencer obj" | "astound" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:baffle | "experiencer obj" | "baffle" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:bewilder | "experiencer obj" | "bewilder" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:bewitch | "experiencer obj" | "bewitch" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:calm | "experiencer obj" | "calm" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:captivate | "experiencer obj" | "captivate" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:charm | "experiencer obj" | "charm" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:cheer | "experiencer obj" | "cheer" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:comfort | "experiencer obj" | "comfort" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:conciliate | "experiencer obj" | "conciliate" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:confuse | "experiencer obj" | "confuse" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:console | "experiencer obj" | "console" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:dazzle | "experiencer obj" | "dazzle" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:delight | "experiencer obj" | "delight" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:depress | "experiencer obj" | "depress" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:disappoint | "experiencer obj" | "disappoint" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:discomfit | "experiencer obj" | "discomfit" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:disconcert | "experiencer obj" | "disconcert" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:discourage | "experiencer obj" | "discourage" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:dishearten | "experiencer obj" | "dishearten" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:displease | "experiencer obj" | "displease" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:distress | "experiencer obj" | "distress" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:disturb | "experiencer obj" | "disturb" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:embarrass | "experiencer obj" | "embarrass" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:enchant | "experiencer obj" | "enchant" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:enrage | "experiencer obj" | "enrage" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:entertain | "experiencer obj" | "entertain" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:enthrall | "experiencer obj" | "enthrall" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:exasperate | "experiencer obj" | "exasperate" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:excite | "experiencer obj" | "excite" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:fascinate | "experiencer obj" | "fascinate" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:frighten | "experiencer obj" | "frighten" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:frustrate | "experiencer obj" | "frustrate" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:gall | "experiencer obj" | "gall" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:gladden | "experiencer obj" | "gladden" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:gratify | "experiencer obj" | "gratify" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:hearten | "experiencer obj" | "hearten" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:humiliate | "experiencer obj" | "humiliate" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:impress | "experiencer obj" | "impress" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:infuriate | "experiencer obj" | "infuriate" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:irk | "experiencer obj" | "irk" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:irritate | "experiencer obj" | "irritate" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:mollify | "experiencer obj" | "mollify" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:pacify | "experiencer obj" | "pacify" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:perplex | "experiencer obj" | "perplex" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:placate | "experiencer obj" | "placate" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:please | "experiencer obj" | "please" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:puzzle | "experiencer obj" | "puzzle" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:rattle | "experiencer obj" | "rattle" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:reassure | "experiencer obj" | "reassure" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:rile | "experiencer obj" | "rile" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:sadden | "experiencer obj" | "sadden" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:satisfy | "experiencer obj" | "satisfy" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:scare | "experiencer obj" | "scare" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:shake | "experiencer obj" | "shake" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:shame | "experiencer obj" | "shame" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:shock | "experiencer obj" | "shock" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:soothe | "experiencer obj" | "soothe" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:spook | "experiencer obj" | "spook" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:startle | "experiencer obj" | "startle" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:stimulate | "experiencer obj" | "stimulate" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:stun | "experiencer obj" | "stun" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:surprise | "experiencer obj" | "surprise" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:terrify | "experiencer obj" | "terrify" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:thrill | "experiencer obj" | "thrill" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:unnerve | "experiencer obj" | "unnerve" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:unsettle | "experiencer obj" | "unsettle" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:upset | "experiencer obj" | "upset" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:bore | "experiencer obj" | "bore" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:wow | "experiencer obj" | "wow" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:vex | "experiencer obj" | "vex" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:vexation | "experiencer obj" | "vexation" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:shocker | "experiencer obj" | "shocker" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:sicken | "experiencer obj" | "sicken" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:stupefy | "experiencer obj" | "stupefy" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:tickle | "experiencer obj" | "tickle" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:trouble | "experiencer obj" | "trouble" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:sting | "experiencer obj" | "sting" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:solace | "experiencer obj" | "solace" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:nettle | "experiencer obj" | "nettle" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:abash | "experiencer obj" | "abash" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:aggravate | "experiencer obj" | "aggravate" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:exhilarate | "experiencer obj" | "exhilarate" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:faze | "experiencer obj" | "faze" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:embitter | "experiencer obj" | "embitter" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:flabbergast | "experiencer obj" | "flabbergast" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:floor | "experiencer obj" | "floor" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:rankle | "experiencer obj" | "rankle" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:nonplus | "experiencer obj" | "nonplus" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:mortify | "experiencer obj" | "mortify" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:madden | "experiencer obj" | "madden" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:incense | "experiencer obj" | "incense" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:petrify | "experiencer obj" | "petrify" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:revolt | "experiencer obj" | "revolt" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:sober | "experiencer obj" | "sober" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:repel | "experiencer obj" | "repel" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:torment | "experiencer obj" | "torment" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:beguile | "experiencer obj" | "beguile" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:traumatize | "experiencer obj" | "traumatize" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:interest | "experiencer obj" | "interest" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:intrigue | "experiencer obj" | "intrigue" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:offend | "experiencer obj" | "offend" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:intimidate | "experiencer obj" | "intimidate" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:mystify | "experiencer obj" | "mystify" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:perturb | "experiencer obj" | "perturb" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:stir | "experiencer obj" | "stir" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:fluster | "experiencer obj" | "fluster" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:flummox | "experiencer obj" | "flummox" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:outrage | "experiencer obj" | "outrage" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:surprise | "experiencer obj" | "surprise" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:boggle | "experiencer obj" | "boggle" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:trouble | "experiencer obj" | "trouble" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:fulfill | "experiencer obj" | "fulfill" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:crush | "experiencer obj" | "crush" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:devastate | "experiencer obj" | "devastate" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:arouse | "experiencer obj" | "arouse" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:grate | "experiencer obj" | "grate" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:appeal | "experiencer obj" | "appeal" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:worry | "experiencer obj" | "worry" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:harass | "experiencer obj" | "harass" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:engage | "experiencer obj" | "engage" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:stagger | "experiencer obj" | "stagger" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:destroy | "experiencer obj" | "destroy" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:demolish | "experiencer obj" | "demolish" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:agonize | "experiencer obj" | "agonize" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:encourage | "experiencer obj" | "encourage" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:wound | "experiencer obj" | "wound" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:kill | "experiencer obj" | "kill" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | fn:HasLexicalUnit | fn:lu:experiencer_obj:let_down | "experiencer obj" | "let down" | "has lexical unit" |  | "FN" |  |
| fn:experiencer_obj | /r/HasA | fn:fe:experiencer | "experiencer obj" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:experiencer_obj | /r/HasA | fn:fe:stimulus | "experiencer obj" | "stimulus" | "/r/has a" |  | "FN" |  |
| fn:experiencer_obj | /r/HasA | fn:fe:degree | "experiencer obj" | "degree" | "/r/has a" |  | "FN" |  |
| fn:experiencer_obj | /r/HasA | fn:fe:depictive | "experiencer obj" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:experiencer_obj | /r/HasA | fn:fe:manner | "experiencer obj" | "manner" | "/r/has a" |  | "FN" |  |
| fn:experiencer_obj | /r/HasA | fn:fe:means | "experiencer obj" | "means" | "/r/has a" |  | "FN" |  |
| fn:experiencer_obj | /r/HasA | fn:fe:result | "experiencer obj" | "result" | "/r/has a" |  | "FN" |  |
| fn:experiencer_obj | /r/HasA | fn:fe:circumstances | "experiencer obj" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:experiencer_obj | /r/HasA | fn:fe:explanation | "experiencer obj" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:experiencer_obj | /r/HasA | fn:fe:time | "experiencer obj" | "time" | "/r/has a" |  | "FN" |  |
| fn:scrutiny | /r/UsedFor | fn:experimentation | "scrutiny" | "experimentation" | "/r/used for" |  | "FN" |  |
| fn:experimentation | fn:HasLexicalUnit | fn:lu:experimentation:control | "experimentation" | "control" | "has lexical unit" |  | "FN" |  |
| fn:experimentation | fn:HasLexicalUnit | fn:lu:experimentation:control_group | "experimentation" | "control group" | "has lexical unit" |  | "FN" |  |
| fn:experimentation | fn:HasLexicalUnit | fn:lu:experimentation:experiment | "experimentation" | "experiment" | "has lexical unit" |  | "FN" |  |
| fn:experimentation | fn:HasLexicalUnit | fn:lu:experimentation:study | "experimentation" | "study" | "has lexical unit" |  | "FN" |  |
| fn:experimentation | fn:HasLexicalUnit | fn:lu:experimentation:treatment | "experimentation" | "treatment" | "has lexical unit" |  | "FN" |  |
| fn:experimentation | fn:HasLexicalUnit | fn:lu:experimentation:test | "experimentation" | "test" | "has lexical unit" |  | "FN" |  |
| fn:experimentation | fn:HasLexicalUnit | fn:lu:experimentation:experiment | "experimentation" | "experiment" | "has lexical unit" |  | "FN" |  |
| fn:experimentation | fn:HasLexicalUnit | fn:lu:experimentation:subject | "experimentation" | "subject" | "has lexical unit" |  | "FN" |  |
| fn:experimentation | fn:HasLexicalUnit | fn:lu:experimentation:hypothesis | "experimentation" | "hypothesis" | "has lexical unit" |  | "FN" |  |
| fn:fe:experimenter | /r/IsA | fn:st:sentient | "experimenter" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:experimentation | /r/HasA | fn:fe:experimenter | "experimentation" | "experimenter" | "/r/has a" |  | "FN" |  |
| fn:fe:control_group | /r/RelatedTo | fn:fe:control_group_member | "control group" | "control group member" | "/r/related to" |  | "FN" |  |
| fn:experimentation | /r/HasA | fn:fe:control_group | "experimentation" | "control group" | "/r/has a" |  | "FN" |  |
| fn:fe:control_group_member | /r/RelatedTo | fn:fe:control_group | "control group member" | "control group" | "/r/related to" |  | "FN" |  |
| fn:experimentation | /r/HasA | fn:fe:control_group_member | "experimentation" | "control group member" | "/r/has a" |  | "FN" |  |
| fn:fe:treatment_group | /r/RelatedTo | fn:fe:treated_individual | "treatment group" | "treated individual" | "/r/related to" |  | "FN" |  |
| fn:experimentation | /r/HasA | fn:fe:treatment_group | "experimentation" | "treatment group" | "/r/has a" |  | "FN" |  |
| fn:fe:treated_individual | /r/RelatedTo | fn:fe:treatment_group | "treated individual" | "treatment group" | "/r/related to" |  | "FN" |  |
| fn:experimentation | /r/HasA | fn:fe:treated_individual | "experimentation" | "treated individual" | "/r/has a" |  | "FN" |  |
| fn:experimentation | /r/HasA | fn:fe:duration | "experimentation" | "duration" | "/r/has a" |  | "FN" |  |
| fn:experimentation | /r/HasA | fn:fe:place | "experimentation" | "place" | "/r/has a" |  | "FN" |  |
| fn:experimentation | /r/HasA | fn:fe:time | "experimentation" | "time" | "/r/has a" |  | "FN" |  |
| fn:experimentation | /r/HasA | fn:fe:phenomenon | "experimentation" | "phenomenon" | "/r/has a" |  | "FN" |  |
| fn:experimentation | /r/HasA | fn:fe:result | "experimentation" | "result" | "/r/has a" |  | "FN" |  |
| fn:experimentation | /r/HasA | fn:fe:descriptor | "experimentation" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:experimentation | /r/HasA | fn:fe:experiment | "experimentation" | "experiment" | "/r/has a" |  | "FN" |  |
| fn:experimentation | /r/HasA | fn:fe:hypothesis | "experimentation" | "hypothesis" | "/r/has a" |  | "FN" |  |
| fn:experimentation | /r/HasA | fn:fe:subjects | "experimentation" | "subjects" | "/r/has a" |  | "FN" |  |
| fn:experimentation | /r/HasA | fn:fe:instrument | "experimentation" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:experimentation | /r/HasA | fn:fe:topic | "experimentation" | "topic" | "/r/has a" |  | "FN" |  |
| fn:expertise | /r/IsA | fn:social_behavior_evaluation | "expertise" | "social behavior evaluation" | "/r/is a" |  | "FN" |  |
| fn:result_of_attempt_scenario | /r/UsedFor | fn:expertise | "result of attempt scenario" | "expertise" | "/r/used for" |  | "FN" |  |
| fn:awareness | /r/SimilarTo | fn:expertise | "awareness" | "expertise" | "/r/similar to" |  | "FN" |  |
| fn:bungling | /r/SimilarTo | fn:expertise | "bungling" | "expertise" | "/r/similar to" |  | "FN" |  |
| fn:desirability | /r/SimilarTo | fn:expertise | "desirability" | "expertise" | "/r/similar to" |  | "FN" |  |
| fn:expertise | /r/SimilarTo | fn:desirability | "expertise" | "desirability" | "/r/similar to" |  | "FN" |  |
| fn:mental_property | /r/SimilarTo | fn:expertise | "mental property" | "expertise" | "/r/similar to" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:buff | "expertise" | "buff" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:maven | "expertise" | "maven" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:expert | "expertise" | "expert" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:expertise | "expertise" | "expertise" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:expert | "expertise" | "expert" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:experience | "expertise" | "experience" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:experienced | "expertise" | "experienced" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:master | "expertise" | "master" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:mastery | "expertise" | "mastery" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:connoisseur | "expertise" | "connoisseur" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:familiar | "expertise" | "familiar" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:pro | "expertise" | "pro" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:ace | "expertise" | "ace" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:versed | "expertise" | "versed" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:well-versed | "expertise" | "well-versed" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:conversant | "expertise" | "conversant" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:conversance | "expertise" | "conversance" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:crack | "expertise" | "crack" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:skilled | "expertise" | "skilled" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:skilful | "expertise" | "skilful" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:ace | "expertise" | "ace" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:wizard | "expertise" | "wizard" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:whiz | "expertise" | "whiz" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:novice | "expertise" | "novice" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:inexperienced | "expertise" | "inexperienced" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:inexpert | "expertise" | "inexpert" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:guru | "expertise" | "guru" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:proficient | "expertise" | "proficient" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:proficiency | "expertise" | "proficiency" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:prowess | "expertise" | "prowess" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:virtuoso | "expertise" | "virtuoso" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:virtuosity | "expertise" | "virtuosity" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:adept | "expertise" | "adept" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:adeptness | "expertise" | "adeptness" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:adept | "expertise" | "adept" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:skill | "expertise" | "skill" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:amateur | "expertise" | "amateur" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:amateur | "expertise" | "amateur" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:master | "expertise" | "master" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:incompetent | "expertise" | "incompetent" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:incompetence | "expertise" | "incompetence" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:competent | "expertise" | "competent" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:competence | "expertise" | "competence" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:inept | "expertise" | "inept" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:ineptitude | "expertise" | "ineptitude" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:ineptness | "expertise" | "ineptness" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:knowledgeable | "expertise" | "knowledgeable" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:awful | "expertise" | "awful" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:bad | "expertise" | "bad" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:wonderful | "expertise" | "wonderful" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:tremendous | "expertise" | "tremendous" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:superb | "expertise" | "superb" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:stupendous | "expertise" | "stupendous" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:so-so | "expertise" | "so-so" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:mediocre | "expertise" | "mediocre" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:incredible | "expertise" | "incredible" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:great | "expertise" | "great" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:good | "expertise" | "good" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:fantastic | "expertise" | "fantastic" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:excellent | "expertise" | "excellent" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:dreadful | "expertise" | "dreadful" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:terrible | "expertise" | "terrible" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:terrific | "expertise" | "terrific" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:superlative | "expertise" | "superlative" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:outstanding | "expertise" | "outstanding" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:splendid | "expertise" | "splendid" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:know-how | "expertise" | "know-how" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:specialist | "expertise" | "specialist" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:new_(to) | "expertise" | "new (to)" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:excel | "expertise" | "excel" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:strong | "expertise" | "strong" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:layman | "expertise" | "layman" | "has lexical unit" |  | "FN" |  |
| fn:expertise | fn:HasLexicalUnit | fn:lu:expertise:lay | "expertise" | "lay" | "has lexical unit" |  | "FN" |  |
| fn:expertise | /r/HasA | fn:fe:protagonist | "expertise" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:fe:skill | /r/RelatedTo | fn:fe:behavior_product | "skill" | "behavior product" | "/r/related to" |  | "FN" |  |
| fn:expertise | /r/HasA | fn:fe:skill | "expertise" | "skill" | "/r/has a" |  | "FN" |  |
| fn:fe:knowledge | /r/RelatedTo | fn:fe:behavior_product | "knowledge" | "behavior product" | "/r/related to" |  | "FN" |  |
| fn:expertise | /r/HasA | fn:fe:knowledge | "expertise" | "knowledge" | "/r/has a" |  | "FN" |  |
| fn:expertise | /r/HasA | fn:fe:degree | "expertise" | "degree" | "/r/has a" |  | "FN" |  |
| fn:expertise | /r/HasA | fn:fe:behavior_product | "expertise" | "behavior product" | "/r/has a" |  | "FN" |  |
| fn:fe:focal_participant | /r/RelatedTo | fn:fe:behavior_product | "focal participant" | "behavior product" | "/r/related to" |  | "FN" |  |
| fn:expertise | /r/HasA | fn:fe:focal_participant | "expertise" | "focal participant" | "/r/has a" |  | "FN" |  |
| fn:fe:role | /r/RelatedTo | fn:fe:behavior_product | "role" | "behavior product" | "/r/related to" |  | "FN" |  |
| fn:expertise | /r/HasA | fn:fe:role | "expertise" | "role" | "/r/has a" |  | "FN" |  |
| fn:expertise | /r/HasA | fn:fe:manner | "expertise" | "manner" | "/r/has a" |  | "FN" |  |
| fn:expertise | /r/HasA | fn:fe:judge | "expertise" | "judge" | "/r/has a" |  | "FN" |  |
| fn:expertise | /r/HasA | fn:fe:time | "expertise" | "time" | "/r/has a" |  | "FN" |  |
| fn:evidence | /r/UsedFor | fn:explaining_the_facts | "evidence" | "explaining the facts" | "/r/used for" |  | "FN" |  |
| fn:explaining_the_facts | fn:HasLexicalUnit | fn:lu:explaining_the_facts:explain | "explaining the facts" | "explain" | "has lexical unit" |  | "FN" |  |
| fn:explaining_the_facts | fn:HasLexicalUnit | fn:lu:explaining_the_facts:account | "explaining the facts" | "account" | "has lexical unit" |  | "FN" |  |
| fn:explaining_the_facts | fn:HasLexicalUnit | fn:lu:explaining_the_facts:explanation | "explaining the facts" | "explanation" | "has lexical unit" |  | "FN" |  |
| fn:explaining_the_facts | /r/HasA | fn:fe:fact | "explaining the facts" | "fact" | "/r/has a" |  | "FN" |  |
| fn:fe:state_of_affairs | /r/RelatedTo | fn:fe:question | "state of affairs" | "question" | "/r/related to" |  | "FN" |  |
| fn:explaining_the_facts | /r/HasA | fn:fe:state_of_affairs | "explaining the facts" | "state of affairs" | "/r/has a" |  | "FN" |  |
| fn:explaining_the_facts | /r/HasA | fn:fe:degree | "explaining the facts" | "degree" | "/r/has a" |  | "FN" |  |
| fn:explaining_the_facts | /r/HasA | fn:fe:manner | "explaining the facts" | "manner" | "/r/has a" |  | "FN" |  |
| fn:explaining_the_facts | /r/HasA | fn:fe:means | "explaining the facts" | "means" | "/r/has a" |  | "FN" |  |
| fn:explaining_the_facts | /r/HasA | fn:fe:viewpoint | "explaining the facts" | "viewpoint" | "/r/has a" |  | "FN" |  |
| fn:explaining_the_facts | /r/HasA | fn:fe:question | "explaining the facts" | "question" | "/r/has a" |  | "FN" |  |
| fn:explaining_the_facts | /r/HasA | fn:fe:concessive | "explaining the facts" | "concessive" | "/r/has a" |  | "FN" |  |
| fn:explosion | /r/IsA | fn:eventive_affecting | "explosion" | "eventive affecting" | "/r/is a" |  | "FN" |  |
| fn:explosion | fn:HasLexicalUnit | fn:lu:explosion:explosion | "explosion" | "explosion" | "has lexical unit" |  | "FN" |  |
| fn:explosion | fn:HasLexicalUnit | fn:lu:explosion:explode | "explosion" | "explode" | "has lexical unit" |  | "FN" |  |
| fn:explosion | fn:HasLexicalUnit | fn:lu:explosion:detonate | "explosion" | "detonate" | "has lexical unit" |  | "FN" |  |
| fn:explosion | fn:HasLexicalUnit | fn:lu:explosion:detonation | "explosion" | "detonation" | "has lexical unit" |  | "FN" |  |
| fn:explosion | fn:HasLexicalUnit | fn:lu:explosion:blast | "explosion" | "blast" | "has lexical unit" |  | "FN" |  |
| fn:explosion | fn:HasLexicalUnit | fn:lu:explosion:blow | "explosion" | "blow" | "has lexical unit" |  | "FN" |  |
| fn:explosion | fn:HasLexicalUnit | fn:lu:explosion:blow_up | "explosion" | "blow up" | "has lexical unit" |  | "FN" |  |
| fn:explosion | /r/HasA | fn:fe:explosive | "explosion" | "explosive" | "/r/has a" |  | "FN" |  |
| fn:explosion | /r/HasA | fn:fe:time | "explosion" | "time" | "/r/has a" |  | "FN" |  |
| fn:explosion | /r/HasA | fn:fe:place | "explosion" | "place" | "/r/has a" |  | "FN" |  |
| fn:explosion | /r/HasA | fn:fe:victim | "explosion" | "victim" | "/r/has a" |  | "FN" |  |
| fn:explosion | /r/HasA | fn:fe:containing_event | "explosion" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:explosion | /r/HasA | fn:fe:means | "explosion" | "means" | "/r/has a" |  | "FN" |  |
| fn:explosion | /r/HasA | fn:fe:manner | "explosion" | "manner" | "/r/has a" |  | "FN" |  |
| fn:explosion | /r/HasA | fn:fe:degree | "explosion" | "degree" | "/r/has a" |  | "FN" |  |
| fn:explosion | /r/HasA | fn:fe:frequency | "explosion" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:commerce_sell | /r/UsedFor | fn:exporting | "commerce sell" | "exporting" | "/r/used for" |  | "FN" |  |
| fn:import_export_scenario | /r/SimilarTo | fn:exporting | "import export scenario" | "exporting" | "/r/similar to" |  | "FN" |  |
| fn:exporting | /r/IsA | fn:import_export_scenario | "exporting" | "import export scenario" | "/r/is a" |  | "FN" |  |
| fn:exporting | fn:HasLexicalUnit | fn:lu:exporting:exportation | "exporting" | "exportation" | "has lexical unit" |  | "FN" |  |
| fn:exporting | fn:HasLexicalUnit | fn:lu:exporting:export | "exporting" | "export" | "has lexical unit" |  | "FN" |  |
| fn:exporting | fn:HasLexicalUnit | fn:lu:exporting:export_[act] | "exporting" | "export [act]" | "has lexical unit" |  | "FN" |  |
| fn:exporting | fn:HasLexicalUnit | fn:lu:exporting:export_[entity] | "exporting" | "export [entity]" | "has lexical unit" |  | "FN" |  |
| fn:fe:exporter | /r/IsA | fn:st:sentient | "exporter" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:exporting | /r/HasA | fn:fe:exporter | "exporting" | "exporter" | "/r/has a" |  | "FN" |  |
| fn:exporting | /r/HasA | fn:fe:vehicle | "exporting" | "vehicle" | "/r/has a" |  | "FN" |  |
| fn:exporting | /r/HasA | fn:fe:manner | "exporting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:exporting | /r/HasA | fn:fe:means | "exporting" | "means" | "/r/has a" |  | "FN" |  |
| fn:exporting | /r/HasA | fn:fe:goods | "exporting" | "goods" | "/r/has a" |  | "FN" |  |
| fn:exporting | /r/HasA | fn:fe:purpose | "exporting" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:exporting | /r/HasA | fn:fe:explanation | "exporting" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:exporting | /r/HasA | fn:fe:time | "exporting" | "time" | "/r/has a" |  | "FN" |  |
| fn:exporting | /r/HasA | fn:fe:depictive | "exporting" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:exporting | /r/HasA | fn:fe:importing_area | "exporting" | "importing area" | "/r/has a" |  | "FN" |  |
| fn:exporting | /r/HasA | fn:fe:path | "exporting" | "path" | "/r/has a" |  | "FN" |  |
| fn:exporting | /r/HasA | fn:fe:exporting_area | "exporting" | "exporting area" | "/r/has a" |  | "FN" |  |
| fn:exporting | /r/HasA | fn:fe:re-encoding | "exporting" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:exporting | /r/HasA | fn:fe:type | "exporting" | "type" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:expressing_publicly | "communication" | "expressing publicly" | "/r/used for" |  | "FN" |  |
| fn:statement | /r/SimilarTo | fn:expressing_publicly | "statement" | "expressing publicly" | "/r/similar to" |  | "FN" |  |
| fn:expressing_publicly | fn:HasLexicalUnit | fn:lu:expressing_publicly:vent | "expressing publicly" | "vent" | "has lexical unit" |  | "FN" |  |
| fn:expressing_publicly | fn:HasLexicalUnit | fn:lu:expressing_publicly:air | "expressing publicly" | "air" | "has lexical unit" |  | "FN" |  |
| fn:expressing_publicly | fn:HasLexicalUnit | fn:lu:expressing_publicly:express | "expressing publicly" | "express" | "has lexical unit" |  | "FN" |  |
| fn:expressing_publicly | fn:HasLexicalUnit | fn:lu:expressing_publicly:voice | "expressing publicly" | "voice" | "has lexical unit" |  | "FN" |  |
| fn:expressing_publicly | fn:HasLexicalUnit | fn:lu:expressing_publicly:give_voice | "expressing publicly" | "give voice" | "has lexical unit" |  | "FN" |  |
| fn:expressing_publicly | fn:HasLexicalUnit | fn:lu:expressing_publicly:expression | "expressing publicly" | "expression" | "has lexical unit" |  | "FN" |  |
| fn:expressing_publicly | fn:HasLexicalUnit | fn:lu:expressing_publicly:articulate | "expressing publicly" | "articulate" | "has lexical unit" |  | "FN" |  |
| fn:expressing_publicly | fn:HasLexicalUnit | fn:lu:expressing_publicly:put_into_words | "expressing publicly" | "put into words" | "has lexical unit" |  | "FN" |  |
| fn:expressing_publicly | /r/HasA | fn:fe:communicator | "expressing publicly" | "communicator" | "/r/has a" |  | "FN" |  |
| fn:expressing_publicly | /r/HasA | fn:fe:addressee | "expressing publicly" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:expressing_publicly | /r/HasA | fn:fe:content | "expressing publicly" | "content" | "/r/has a" |  | "FN" |  |
| fn:expressing_publicly | /r/HasA | fn:fe:manner | "expressing publicly" | "manner" | "/r/has a" |  | "FN" |  |
| fn:expressing_publicly | /r/HasA | fn:fe:means | "expressing publicly" | "means" | "/r/has a" |  | "FN" |  |
| fn:expressing_publicly | /r/HasA | fn:fe:internal_cause | "expressing publicly" | "internal cause" | "/r/has a" |  | "FN" |  |
| fn:expressing_publicly | /r/HasA | fn:fe:medium | "expressing publicly" | "medium" | "/r/has a" |  | "FN" |  |
| fn:expressing_publicly | /r/HasA | fn:fe:depictive | "expressing publicly" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:expressing_publicly | /r/HasA | fn:fe:time | "expressing publicly" | "time" | "/r/has a" |  | "FN" |  |
| fn:expressing_publicly | /r/HasA | fn:fe:place | "expressing publicly" | "place" | "/r/has a" |  | "FN" |  |
| fn:expressing_publicly | /r/HasA | fn:fe:particular_iteration | "expressing publicly" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:expressing_publicly | /r/HasA | fn:fe:purpose | "expressing publicly" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:expressing_publicly | /r/HasA | fn:fe:frequency | "expressing publicly" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:expressing_publicly | /r/HasA | fn:fe:circumstances | "expressing publicly" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:expressing_publicly | /r/HasA | fn:fe:explanation | "expressing publicly" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:extradition | /r/IsA | fn:intentionally_affect | "extradition" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:extradition | fn:HasLexicalUnit | fn:lu:extradition:extradite | "extradition" | "extradite" | "has lexical unit" |  | "FN" |  |
| fn:extradition | fn:HasLexicalUnit | fn:lu:extradition:extradition | "extradition" | "extradition" | "has lexical unit" |  | "FN" |  |
| fn:fe:authorities | /r/IsA | fn:st:human | "authorities" | "human" | "/r/is a" |  | "FN" |  |
| fn:extradition | /r/HasA | fn:fe:authorities | "extradition" | "authorities" | "/r/has a" |  | "FN" |  |
| fn:fe:current_jurisdiction | /r/IsA | fn:st:locative_relation | "current jurisdiction" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:extradition | /r/HasA | fn:fe:current_jurisdiction | "extradition" | "current jurisdiction" | "/r/has a" |  | "FN" |  |
| fn:extradition | /r/HasA | fn:fe:crime_jurisdiction | "extradition" | "crime jurisdiction" | "/r/has a" |  | "FN" |  |
| fn:fe:suspect | /r/IsA | fn:st:human | "suspect" | "human" | "/r/is a" |  | "FN" |  |
| fn:extradition | /r/HasA | fn:fe:suspect | "extradition" | "suspect" | "/r/has a" |  | "FN" |  |
| fn:extradition | /r/HasA | fn:fe:purpose | "extradition" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:extradition | /r/HasA | fn:fe:explanation | "extradition" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:extradition | /r/HasA | fn:fe:legal_basis | "extradition" | "legal basis" | "/r/has a" |  | "FN" |  |
| fn:extradition | /r/HasA | fn:fe:time | "extradition" | "time" | "/r/has a" |  | "FN" |  |
| fn:extradition | /r/HasA | fn:fe:manner | "extradition" | "manner" | "/r/has a" |  | "FN" |  |
| fn:extradition | /r/HasA | fn:fe:depictive | "extradition" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:extradition | /r/HasA | fn:fe:means | "extradition" | "means" | "/r/has a" |  | "FN" |  |
| fn:extradition | /r/HasA | fn:fe:place | "extradition" | "place" | "/r/has a" |  | "FN" |  |
| fn:gradable_attributes | /r/UsedFor | fn:extreme_point | "gradable attributes" | "extreme point" | "/r/used for" |  | "FN" |  |
| fn:extreme_point | fn:HasLexicalUnit | fn:lu:extreme_point:high-water_mark | "extreme point" | "high-water mark" | "has lexical unit" |  | "FN" |  |
| fn:extreme_point | fn:HasLexicalUnit | fn:lu:extreme_point:high_point | "extreme point" | "high point" | "has lexical unit" |  | "FN" |  |
| fn:extreme_point | fn:HasLexicalUnit | fn:lu:extreme_point:low_point | "extreme point" | "low point" | "has lexical unit" |  | "FN" |  |
| fn:extreme_point | fn:HasLexicalUnit | fn:lu:extreme_point:zenith | "extreme point" | "zenith" | "has lexical unit" |  | "FN" |  |
| fn:extreme_point | fn:HasLexicalUnit | fn:lu:extreme_point:nadir | "extreme point" | "nadir" | "has lexical unit" |  | "FN" |  |
| fn:extreme_point | /r/HasA | fn:fe:entity | "extreme point" | "entity" | "/r/has a" |  | "FN" |  |
| fn:extreme_point | /r/HasA | fn:fe:marker | "extreme point" | "marker" | "/r/has a" |  | "FN" |  |
| fn:measurable_attributes | /r/UsedFor | fn:extreme_value | "measurable attributes" | "extreme value" | "/r/used for" |  | "FN" |  |
| fn:extreme_value | fn:HasLexicalUnit | fn:lu:extreme_value:high | "extreme value" | "high" | "has lexical unit" |  | "FN" |  |
| fn:extreme_value | fn:HasLexicalUnit | fn:lu:extreme_value:low | "extreme value" | "low" | "has lexical unit" |  | "FN" |  |
| fn:extreme_value | fn:HasLexicalUnit | fn:lu:extreme_value:acme | "extreme value" | "acme" | "has lexical unit" |  | "FN" |  |
| fn:extreme_value | fn:HasLexicalUnit | fn:lu:extreme_value:maximum | "extreme value" | "maximum" | "has lexical unit" |  | "FN" |  |
| fn:extreme_value | fn:HasLexicalUnit | fn:lu:extreme_value:maximum | "extreme value" | "maximum" | "has lexical unit" |  | "FN" |  |
| fn:extreme_value | fn:HasLexicalUnit | fn:lu:extreme_value:minimum | "extreme value" | "minimum" | "has lexical unit" |  | "FN" |  |
| fn:extreme_value | fn:HasLexicalUnit | fn:lu:extreme_value:minimum | "extreme value" | "minimum" | "has lexical unit" |  | "FN" |  |
| fn:extreme_value | /r/HasA | fn:fe:entity | "extreme value" | "entity" | "/r/has a" |  | "FN" |  |
| fn:extreme_value | /r/HasA | fn:fe:attribute | "extreme value" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:extreme_value | /r/HasA | fn:fe:value | "extreme value" | "value" | "/r/has a" |  | "FN" |  |
| fn:extreme_value | /r/HasA | fn:fe:period | "extreme value" | "period" | "/r/has a" |  | "FN" |  |
| fn:extreme_value | /r/HasA | fn:fe:degree | "extreme value" | "degree" | "/r/has a" |  | "FN" |  |
| fn:extreme_value | /r/HasA | fn:fe:domain | "extreme value" | "domain" | "/r/has a" |  | "FN" |  |
| fn:extreme_value | /r/HasA | fn:fe:descriptor | "extreme value" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:extreme_value | /r/HasA | fn:fe:depictive | "extreme value" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:extreme_value | /r/HasA | fn:fe:explanation | "extreme value" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:body_movement | /r/UsedFor | fn:facial_expression | "body movement" | "facial expression" | "/r/used for" |  | "FN" |  |
| fn:facial_expression | /r/UsedFor | fn:making_faces | "facial expression" | "making faces" | "/r/used for" |  | "FN" |  |
| fn:facial_expression | fn:HasLexicalUnit | fn:lu:facial_expression:smile | "facial expression" | "smile" | "has lexical unit" |  | "FN" |  |
| fn:facial_expression | fn:HasLexicalUnit | fn:lu:facial_expression:grimace | "facial expression" | "grimace" | "has lexical unit" |  | "FN" |  |
| fn:facial_expression | fn:HasLexicalUnit | fn:lu:facial_expression:grin | "facial expression" | "grin" | "has lexical unit" |  | "FN" |  |
| fn:facial_expression | fn:HasLexicalUnit | fn:lu:facial_expression:frown | "facial expression" | "frown" | "has lexical unit" |  | "FN" |  |
| fn:facial_expression | fn:HasLexicalUnit | fn:lu:facial_expression:expression | "facial expression" | "expression" | "has lexical unit" |  | "FN" |  |
| fn:facial_expression | fn:HasLexicalUnit | fn:lu:facial_expression:smirk | "facial expression" | "smirk" | "has lexical unit" |  | "FN" |  |
| fn:facial_expression | fn:HasLexicalUnit | fn:lu:facial_expression:rictus | "facial expression" | "rictus" | "has lexical unit" |  | "FN" |  |
| fn:facial_expression | fn:HasLexicalUnit | fn:lu:facial_expression:look | "facial expression" | "look" | "has lexical unit" |  | "FN" |  |
| fn:facial_expression | fn:HasLexicalUnit | fn:lu:facial_expression:scowl | "facial expression" | "scowl" | "has lexical unit" |  | "FN" |  |
| fn:facial_expression | fn:HasLexicalUnit | fn:lu:facial_expression:face | "facial expression" | "face" | "has lexical unit" |  | "FN" |  |
| fn:facial_expression | fn:HasLexicalUnit | fn:lu:facial_expression:snarl | "facial expression" | "snarl" | "has lexical unit" |  | "FN" |  |
| fn:facial_expression | fn:HasLexicalUnit | fn:lu:facial_expression:sneer | "facial expression" | "sneer" | "has lexical unit" |  | "FN" |  |
| fn:facial_expression | fn:HasLexicalUnit | fn:lu:facial_expression:pout | "facial expression" | "pout" | "has lexical unit" |  | "FN" |  |
| fn:facial_expression | /r/HasA | fn:fe:manner | "facial expression" | "manner" | "/r/has a" |  | "FN" |  |
| fn:facial_expression | /r/HasA | fn:fe:degree | "facial expression" | "degree" | "/r/has a" |  | "FN" |  |
| fn:facial_expression | /r/HasA | fn:fe:expression | "facial expression" | "expression" | "/r/has a" |  | "FN" |  |
| fn:facial_expression | /r/HasA | fn:fe:possessor | "facial expression" | "possessor" | "/r/has a" |  | "FN" |  |
| fn:facial_expression | /r/HasA | fn:fe:internal_cause | "facial expression" | "internal cause" | "/r/has a" |  | "FN" |  |
| fn:facial_expression | /r/HasA | fn:fe:subregion | "facial expression" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:facial_expression | /r/HasA | fn:fe:conveyed_emotion | "facial expression" | "conveyed emotion" | "/r/has a" |  | "FN" |  |
| fn:facial_expression | /r/HasA | fn:fe:intended_perceiver | "facial expression" | "intended perceiver" | "/r/has a" |  | "FN" |  |
| fn:facial_expression | /r/HasA | fn:fe:external_cause | "facial expression" | "external cause" | "/r/has a" |  | "FN" |  |
| fn:facial_expression | /r/HasA | fn:fe:duration | "facial expression" | "duration" | "/r/has a" |  | "FN" |  |
| fn:social_interaction_evaluation | /r/UsedFor | fn:fairness_evaluation | "social interaction evaluation" | "fairness evaluation" | "/r/used for" |  | "FN" |  |
| fn:fairness_evaluation | fn:HasLexicalUnit | fn:lu:fairness_evaluation:fair | "fairness evaluation" | "fair" | "has lexical unit" |  | "FN" |  |
| fn:fairness_evaluation | fn:HasLexicalUnit | fn:lu:fairness_evaluation:unfair | "fairness evaluation" | "unfair" | "has lexical unit" |  | "FN" |  |
| fn:fairness_evaluation | fn:HasLexicalUnit | fn:lu:fairness_evaluation:unjust | "fairness evaluation" | "unjust" | "has lexical unit" |  | "FN" |  |
| fn:fairness_evaluation | fn:HasLexicalUnit | fn:lu:fairness_evaluation:inequitable | "fairness evaluation" | "inequitable" | "has lexical unit" |  | "FN" |  |
| fn:fairness_evaluation | fn:HasLexicalUnit | fn:lu:fairness_evaluation:fairly | "fairness evaluation" | "fairly" | "has lexical unit" |  | "FN" |  |
| fn:fairness_evaluation | fn:HasLexicalUnit | fn:lu:fairness_evaluation:unfairly | "fairness evaluation" | "unfairly" | "has lexical unit" |  | "FN" |  |
| fn:fairness_evaluation | fn:HasLexicalUnit | fn:lu:fairness_evaluation:unjustly | "fairness evaluation" | "unjustly" | "has lexical unit" |  | "FN" |  |
| fn:fairness_evaluation | /r/HasA | fn:fe:actor | "fairness evaluation" | "actor" | "/r/has a" |  | "FN" |  |
| fn:fairness_evaluation | /r/HasA | fn:fe:action | "fairness evaluation" | "action" | "/r/has a" |  | "FN" |  |
| fn:fairness_evaluation | /r/HasA | fn:fe:grounds | "fairness evaluation" | "grounds" | "/r/has a" |  | "FN" |  |
| fn:fairness_evaluation | /r/HasA | fn:fe:affected_party | "fairness evaluation" | "affected party" | "/r/has a" |  | "FN" |  |
| fn:fairness_evaluation | /r/HasA | fn:fe:degree | "fairness evaluation" | "degree" | "/r/has a" |  | "FN" |  |
| fn:fairness_evaluation | /r/HasA | fn:fe:parameter | "fairness evaluation" | "parameter" | "/r/has a" |  | "FN" |  |
| fn:fairness_evaluation | /r/HasA | fn:fe:manner | "fairness evaluation" | "manner" | "/r/has a" |  | "FN" |  |
| fn:sleep_wake_cycle | /r/HasSubevent | fn:fall_asleep | "sleep wake cycle" | "fall asleep" | "/r/has subevent" |  | "FN" |  |
| fn:fall_asleep | /r/HasPrerequisite | fn:being_awake | "fall asleep" | "being awake" | "/r/has prerequisite" |  | "FN" |  |
| fn:sleep | /r/HasPrerequisite | fn:fall_asleep | "sleep" | "fall asleep" | "/r/has prerequisite" |  | "FN" |  |
| fn:fall_asleep | fn:HasLexicalUnit | fn:lu:fall_asleep:konk_out | "fall asleep" | "konk out" | "has lexical unit" |  | "FN" |  |
| fn:fall_asleep | fn:HasLexicalUnit | fn:lu:fall_asleep:black_out | "fall asleep" | "black out" | "has lexical unit" |  | "FN" |  |
| fn:fall_asleep | fn:HasLexicalUnit | fn:lu:fall_asleep:doze_off | "fall asleep" | "doze off" | "has lexical unit" |  | "FN" |  |
| fn:fall_asleep | fn:HasLexicalUnit | fn:lu:fall_asleep:pass_out | "fall asleep" | "pass out" | "has lexical unit" |  | "FN" |  |
| fn:fall_asleep | fn:HasLexicalUnit | fn:lu:fall_asleep:faint | "fall asleep" | "faint" | "has lexical unit" |  | "FN" |  |
| fn:fall_asleep | fn:HasLexicalUnit | fn:lu:fall_asleep:nod_off | "fall asleep" | "nod off" | "has lexical unit" |  | "FN" |  |
| fn:fall_asleep | fn:HasLexicalUnit | fn:lu:fall_asleep:zonk_out | "fall asleep" | "zonk out" | "has lexical unit" |  | "FN" |  |
| fn:fall_asleep | fn:HasLexicalUnit | fn:lu:fall_asleep:drift_off | "fall asleep" | "drift off" | "has lexical unit" |  | "FN" |  |
| fn:fall_asleep | /r/HasA | fn:fe:place | "fall asleep" | "place" | "/r/has a" |  | "FN" |  |
| fn:fall_asleep | /r/HasA | fn:fe:sleeper | "fall asleep" | "sleeper" | "/r/has a" |  | "FN" |  |
| fn:fall_asleep | /r/HasA | fn:fe:time | "fall asleep" | "time" | "/r/has a" |  | "FN" |  |
| fn:coming_to_believe | /r/UsedFor | fn:fall_for | "coming to believe" | "fall for" | "/r/used for" |  | "FN" |  |
| fn:fall_for | /r/IsA | fn:deception_success | "fall for" | "deception success" | "/r/is a" |  | "FN" |  |
| fn:fall_for | fn:HasLexicalUnit | fn:lu:fall_for:fall_for | "fall for" | "fall for" | "has lexical unit" |  | "FN" |  |
| fn:fall_for | fn:HasLexicalUnit | fn:lu:fall_for:swallow | "fall for" | "swallow" | "has lexical unit" |  | "FN" |  |
| fn:fall_for | /r/HasA | fn:fe:victim | "fall for" | "victim" | "/r/has a" |  | "FN" |  |
| fn:fall_for | /r/HasA | fn:fe:deception | "fall for" | "deception" | "/r/has a" |  | "FN" |  |
| fn:fall_for | /r/HasA | fn:fe:time | "fall for" | "time" | "/r/has a" |  | "FN" |  |
| fn:fall_for | /r/HasA | fn:fe:place | "fall for" | "place" | "/r/has a" |  | "FN" |  |
| fn:fall_for | /r/HasA | fn:fe:manner | "fall for" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fall_for | /r/HasA | fn:fe:degree | "fall for" | "degree" | "/r/has a" |  | "FN" |  |
| fn:fame | /r/IsA | fn:personal_success | "fame" | "personal success" | "/r/is a" |  | "FN" |  |
| fn:awareness | /r/UsedFor | fn:fame | "awareness" | "fame" | "/r/used for" |  | "FN" |  |
| fn:fame | /r/UsedFor | fn:obscurity | "fame" | "obscurity" | "/r/used for" |  | "FN" |  |
| fn:fame | fn:HasLexicalUnit | fn:lu:fame:famous | "fame" | "famous" | "has lexical unit" |  | "FN" |  |
| fn:fame | fn:HasLexicalUnit | fn:lu:fame:fame | "fame" | "fame" | "has lexical unit" |  | "FN" |  |
| fn:fame | fn:HasLexicalUnit | fn:lu:fame:stature | "fame" | "stature" | "has lexical unit" |  | "FN" |  |
| fn:fame | fn:HasLexicalUnit | fn:lu:fame:legendary | "fame" | "legendary" | "has lexical unit" |  | "FN" |  |
| fn:fame | fn:HasLexicalUnit | fn:lu:fame:well_known | "fame" | "well known" | "has lexical unit" |  | "FN" |  |
| fn:fame | fn:HasLexicalUnit | fn:lu:fame:infamous | "fame" | "infamous" | "has lexical unit" |  | "FN" |  |
| fn:fame | fn:HasLexicalUnit | fn:lu:fame:renown | "fame" | "renown" | "has lexical unit" |  | "FN" |  |
| fn:fame | fn:HasLexicalUnit | fn:lu:fame:renowned | "fame" | "renowned" | "has lexical unit" |  | "FN" |  |
| fn:fame | fn:HasLexicalUnit | fn:lu:fame:notorious | "fame" | "notorious" | "has lexical unit" |  | "FN" |  |
| fn:fame | fn:HasLexicalUnit | fn:lu:fame:notoriety | "fame" | "notoriety" | "has lexical unit" |  | "FN" |  |
| fn:fame | fn:HasLexicalUnit | fn:lu:fame:reputation | "fame" | "reputation" | "has lexical unit" |  | "FN" |  |
| fn:fame | fn:HasLexicalUnit | fn:lu:fame:epic | "fame" | "epic" | "has lexical unit" |  | "FN" |  |
| fn:fame | fn:HasLexicalUnit | fn:lu:fame:name | "fame" | "name" | "has lexical unit" |  | "FN" |  |
| fn:fame | fn:HasLexicalUnit | fn:lu:fame:known | "fame" | "known" | "has lexical unit" |  | "FN" |  |
| fn:fame | fn:HasLexicalUnit | fn:lu:fame:big_name | "fame" | "big name" | "has lexical unit" |  | "FN" |  |
| fn:fame | fn:HasLexicalUnit | fn:lu:fame:make_a_name_for_oneself | "fame" | "make a name for oneself" | "has lexical unit" |  | "FN" |  |
| fn:fame | /r/HasA | fn:fe:entity | "fame" | "entity" | "/r/has a" |  | "FN" |  |
| fn:fame | /r/HasA | fn:fe:degree | "fame" | "degree" | "/r/has a" |  | "FN" |  |
| fn:fame | /r/HasA | fn:fe:time | "fame" | "time" | "/r/has a" |  | "FN" |  |
| fn:fame | /r/HasA | fn:fe:circumstances | "fame" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:fame | /r/HasA | fn:fe:explanation | "fame" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:fame | /r/HasA | fn:fe:reason | "fame" | "reason" | "/r/has a" |  | "FN" |  |
| fn:fame | /r/HasA | fn:fe:duration | "fame" | "duration" | "/r/has a" |  | "FN" |  |
| fn:fame | /r/HasA | fn:fe:place | "fame" | "place" | "/r/has a" |  | "FN" |  |
| fn:fame | /r/HasA | fn:fe:role | "fame" | "role" | "/r/has a" |  | "FN" |  |
| fn:fame | /r/HasA | fn:fe:means | "fame" | "means" | "/r/has a" |  | "FN" |  |
| fn:familiarity | /r/IsA | fn:gradable_attributes | "familiarity" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:familiarity | fn:HasLexicalUnit | fn:lu:familiarity:familiar | "familiarity" | "familiar" | "has lexical unit" |  | "FN" |  |
| fn:familiarity | fn:HasLexicalUnit | fn:lu:familiarity:unfamiliar | "familiarity" | "unfamiliar" | "has lexical unit" |  | "FN" |  |
| fn:familiarity | fn:HasLexicalUnit | fn:lu:familiarity:new | "familiarity" | "new" | "has lexical unit" |  | "FN" |  |
| fn:familiarity | fn:HasLexicalUnit | fn:lu:familiarity:know | "familiarity" | "know" | "has lexical unit" |  | "FN" |  |
| fn:familiarity | fn:HasLexicalUnit | fn:lu:familiarity:acquainted | "familiarity" | "acquainted" | "has lexical unit" |  | "FN" |  |
| fn:familiarity | fn:HasLexicalUnit | fn:lu:familiarity:ken | "familiarity" | "ken" | "has lexical unit" |  | "FN" |  |
| fn:familiarity | fn:HasLexicalUnit | fn:lu:familiarity:intimate | "familiarity" | "intimate" | "has lexical unit" |  | "FN" |  |
| fn:familiarity | /r/HasA | fn:fe:entity | "familiarity" | "entity" | "/r/has a" |  | "FN" |  |
| fn:familiarity | /r/HasA | fn:fe:cognizer | "familiarity" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:familiarity | /r/HasA | fn:fe:degree | "familiarity" | "degree" | "/r/has a" |  | "FN" |  |
| fn:familiarity | /r/HasA | fn:fe:role | "familiarity" | "role" | "/r/has a" |  | "FN" |  |
| fn:familiarity | /r/HasA | fn:fe:depictive | "familiarity" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:familiarity | /r/HasA | fn:fe:context | "familiarity" | "context" | "/r/has a" |  | "FN" |  |
| fn:fastener | /r/IsA | fn:artifact | "fastener" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:closure | /r/UsedFor | fn:fastener | "closure" | "fastener" | "/r/used for" |  | "FN" |  |
| fn:fastener | fn:HasLexicalUnit | fn:lu:fastener:zipper | "fastener" | "zipper" | "has lexical unit" |  | "FN" |  |
| fn:fastener | fn:HasLexicalUnit | fn:lu:fastener:seal | "fastener" | "seal" | "has lexical unit" |  | "FN" |  |
| fn:fastener | fn:HasLexicalUnit | fn:lu:fastener:button | "fastener" | "button" | "has lexical unit" |  | "FN" |  |
| fn:fastener | fn:HasLexicalUnit | fn:lu:fastener:buckle | "fastener" | "buckle" | "has lexical unit" |  | "FN" |  |
| fn:fastener | /r/HasA | fn:fe:container | "fastener" | "container" | "/r/has a" |  | "FN" |  |
| fn:fastener | /r/HasA | fn:fe:fastener | "fastener" | "fastener" | "/r/has a" |  | "FN" |  |
| fn:fastener | /r/HasA | fn:fe:container_portal | "fastener" | "container portal" | "/r/has a" |  | "FN" |  |
| fn:fastener | /r/HasA | fn:fe:material | "fastener" | "material" | "/r/has a" |  | "FN" |  |
| fn:fastener | /r/HasA | fn:fe:descriptor | "fastener" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:fastener | /r/HasA | fn:fe:creator | "fastener" | "creator" | "/r/has a" |  | "FN" |  |
| fn:fastener | /r/HasA | fn:fe:time_of_creation | "fastener" | "time of creation" | "/r/has a" |  | "FN" |  |
| fn:fastener | /r/HasA | fn:fe:name | "fastener" | "name" | "/r/has a" |  | "FN" |  |
| fn:fastener | /r/HasA | fn:fe:type | "fastener" | "type" | "/r/has a" |  | "FN" |  |
| fn:fastener | /r/HasA | fn:fe:use | "fastener" | "use" | "/r/has a" |  | "FN" |  |
| fn:fear | /r/IsA | fn:emotions_by_possibility | "fear" | "emotions by possibility" | "/r/is a" |  | "FN" |  |
| fn:experiencer_focus | /r/SimilarTo | fn:fear | "experiencer focus" | "fear" | "/r/similar to" |  | "FN" |  |
| fn:fear | fn:HasLexicalUnit | fn:lu:fear:terrified | "fear" | "terrified" | "has lexical unit" |  | "FN" |  |
| fn:fear | fn:HasLexicalUnit | fn:lu:fear:nervous | "fear" | "nervous" | "has lexical unit" |  | "FN" |  |
| fn:fear | fn:HasLexicalUnit | fn:lu:fear:frightened | "fear" | "frightened" | "has lexical unit" |  | "FN" |  |
| fn:fear | fn:HasLexicalUnit | fn:lu:fear:afraid | "fear" | "afraid" | "has lexical unit" |  | "FN" |  |
| fn:fear | fn:HasLexicalUnit | fn:lu:fear:apprehension | "fear" | "apprehension" | "has lexical unit" |  | "FN" |  |
| fn:fear | fn:HasLexicalUnit | fn:lu:fear:fear | "fear" | "fear" | "has lexical unit" |  | "FN" |  |
| fn:fear | fn:HasLexicalUnit | fn:lu:fear:freaked | "fear" | "freaked" | "has lexical unit" |  | "FN" |  |
| fn:fear | fn:HasLexicalUnit | fn:lu:fear:scared | "fear" | "scared" | "has lexical unit" |  | "FN" |  |
| fn:fear | fn:HasLexicalUnit | fn:lu:fear:dread | "fear" | "dread" | "has lexical unit" |  | "FN" |  |
| fn:fear | fn:HasLexicalUnit | fn:lu:fear:terror | "fear" | "terror" | "has lexical unit" |  | "FN" |  |
| fn:fear | fn:HasLexicalUnit | fn:lu:fear:live_in_fear | "fear" | "live in fear" | "has lexical unit" |  | "FN" |  |
| fn:fear | /r/HasA | fn:fe:experiencer | "fear" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:fear | /r/HasA | fn:fe:topic | "fear" | "topic" | "/r/has a" |  | "FN" |  |
| fn:fear | /r/HasA | fn:fe:stimulus | "fear" | "stimulus" | "/r/has a" |  | "FN" |  |
| fn:fear | /r/HasA | fn:fe:degree | "fear" | "degree" | "/r/has a" |  | "FN" |  |
| fn:fear | /r/HasA | fn:fe:empathy_target | "fear" | "empathy target" | "/r/has a" |  | "FN" |  |
| fn:fear | /r/HasA | fn:fe:expressor | "fear" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:fear | /r/HasA | fn:fe:explanation | "fear" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:fear | /r/HasA | fn:fe:circumstances | "fear" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:fear | /r/HasA | fn:fe:state | "fear" | "state" | "/r/has a" |  | "FN" |  |
| fn:fear | /r/HasA | fn:fe:parameter | "fear" | "parameter" | "/r/has a" |  | "FN" |  |
| fn:fear | /r/HasA | fn:fe:manner | "fear" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fear | /r/HasA | fn:fe:time | "fear" | "time" | "/r/has a" |  | "FN" |  |
| fn:emotions | /r/UsedFor | fn:feeling | "emotions" | "feeling" | "/r/used for" |  | "FN" |  |
| fn:experiencer_focus | /r/SimilarTo | fn:feeling | "experiencer focus" | "feeling" | "/r/similar to" |  | "FN" |  |
| fn:feeling | fn:HasLexicalUnit | fn:lu:feeling:experience | "feeling" | "experience" | "has lexical unit" |  | "FN" |  |
| fn:feeling | fn:HasLexicalUnit | fn:lu:feeling:full | "feeling" | "full" | "has lexical unit" |  | "FN" |  |
| fn:feeling | fn:HasLexicalUnit | fn:lu:feeling:feel | "feeling" | "feel" | "has lexical unit" |  | "FN" |  |
| fn:feeling | fn:HasLexicalUnit | fn:lu:feeling:feelings | "feeling" | "feelings" | "has lexical unit" |  | "FN" |  |
| fn:feeling | fn:HasLexicalUnit | fn:lu:feeling:emotion | "feeling" | "emotion" | "has lexical unit" |  | "FN" |  |
| fn:feeling | fn:HasLexicalUnit | fn:lu:feeling:sense | "feeling" | "sense" | "has lexical unit" |  | "FN" |  |
| fn:feeling | /r/HasA | fn:fe:experiencer | "feeling" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:feeling | /r/HasA | fn:fe:emotion | "feeling" | "emotion" | "/r/has a" |  | "FN" |  |
| fn:feeling | /r/HasA | fn:fe:emotional_state | "feeling" | "emotional state" | "/r/has a" |  | "FN" |  |
| fn:feeling | /r/HasA | fn:fe:evaluation | "feeling" | "evaluation" | "/r/has a" |  | "FN" |  |
| fn:feeling | /r/HasA | fn:fe:explanation | "feeling" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:conduct | /r/UsedFor | fn:feigning | "conduct" | "feigning" | "/r/used for" |  | "FN" |  |
| fn:feigning | /r/SimilarTo | fn:artificiality | "feigning" | "artificiality" | "/r/similar to" |  | "FN" |  |
| fn:feigning | /r/SimilarTo | fn:forging | "feigning" | "forging" | "/r/similar to" |  | "FN" |  |
| fn:feigning | /r/SimilarTo | fn:posing_as | "feigning" | "posing as" | "/r/similar to" |  | "FN" |  |
| fn:feigning | fn:HasLexicalUnit | fn:lu:feigning:counterfeit | "feigning" | "counterfeit" | "has lexical unit" |  | "FN" |  |
| fn:feigning | fn:HasLexicalUnit | fn:lu:feigning:fake | "feigning" | "fake" | "has lexical unit" |  | "FN" |  |
| fn:feigning | fn:HasLexicalUnit | fn:lu:feigning:feign | "feigning" | "feign" | "has lexical unit" |  | "FN" |  |
| fn:feigning | fn:HasLexicalUnit | fn:lu:feigning:stage | "feigning" | "stage" | "has lexical unit" |  | "FN" |  |
| fn:feigning | fn:HasLexicalUnit | fn:lu:feigning:affect | "feigning" | "affect" | "has lexical unit" |  | "FN" |  |
| fn:feigning | fn:HasLexicalUnit | fn:lu:feigning:pretend | "feigning" | "pretend" | "has lexical unit" |  | "FN" |  |
| fn:feigning | fn:HasLexicalUnit | fn:lu:feigning:simulate | "feigning" | "simulate" | "has lexical unit" |  | "FN" |  |
| fn:feigning | /r/HasA | fn:fe:agent | "feigning" | "agent" | "/r/has a" |  | "FN" |  |
| fn:fe:original | /r/RelatedTo | fn:fe:state_of_affairs | "original" | "state of affairs" | "/r/related to" |  | "FN" |  |
| fn:feigning | /r/HasA | fn:fe:original | "feigning" | "original" | "/r/has a" |  | "FN" |  |
| fn:fe:copy | /r/RelatedTo | fn:fe:state_of_affairs | "copy" | "state of affairs" | "/r/related to" |  | "FN" |  |
| fn:feigning | /r/HasA | fn:fe:copy | "feigning" | "copy" | "/r/has a" |  | "FN" |  |
| fn:feigning | /r/HasA | fn:fe:manner | "feigning" | "manner" | "/r/has a" |  | "FN" |  |
| fn:feigning | /r/HasA | fn:fe:means | "feigning" | "means" | "/r/has a" |  | "FN" |  |
| fn:feigning | /r/HasA | fn:fe:degree | "feigning" | "degree" | "/r/has a" |  | "FN" |  |
| fn:feigning | /r/HasA | fn:fe:state_of_affairs | "feigning" | "state of affairs" | "/r/has a" |  | "FN" |  |
| fn:feigning | /r/HasA | fn:fe:purpose | "feigning" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:feigning | /r/HasA | fn:fe:explanation | "feigning" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:feigning | /r/HasA | fn:fe:frequency | "feigning" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:feigning | /r/HasA | fn:fe:time | "feigning" | "time" | "/r/has a" |  | "FN" |  |
| fn:feigning | /r/HasA | fn:fe:period_of_iterations | "feigning" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:feigning | /r/HasA | fn:fe:duration | "feigning" | "duration" | "/r/has a" |  | "FN" |  |
| fn:feigning | /r/HasA | fn:fe:depictive | "feigning" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:feigning | /r/HasA | fn:fe:circumstances | "feigning" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:feigning | /r/HasA | fn:fe:place | "feigning" | "place" | "/r/has a" |  | "FN" |  |
| fn:employment_scenario | /r/UsedFor | fn:fields | "employment scenario" | "fields" | "/r/used for" |  | "FN" |  |
| fn:fields | /r/UsedFor | fn:craft | "fields" | "craft" | "/r/used for" |  | "FN" |  |
| fn:people | /r/UsedFor | fn:fields | "people" | "fields" | "/r/used for" |  | "FN" |  |
| fn:fields | fn:HasLexicalUnit | fn:lu:fields:industry | "fields" | "industry" | "has lexical unit" |  | "FN" |  |
| fn:fields | fn:HasLexicalUnit | fn:lu:fields:sector | "fields" | "sector" | "has lexical unit" |  | "FN" |  |
| fn:fields | fn:HasLexicalUnit | fn:lu:fields:in | "fields" | "in" | "has lexical unit" |  | "FN" |  |
| fn:fields | fn:HasLexicalUnit | fn:lu:fields:field | "fields" | "field" | "has lexical unit" |  | "FN" |  |
| fn:fields | fn:HasLexicalUnit | fn:lu:fields:area | "fields" | "area" | "has lexical unit" |  | "FN" |  |
| fn:fields | fn:HasLexicalUnit | fn:lu:fields:artistic | "fields" | "artistic" | "has lexical unit" |  | "FN" |  |
| fn:fields | fn:HasLexicalUnit | fn:lu:fields:art | "fields" | "art" | "has lexical unit" |  | "FN" |  |
| fn:fields | fn:HasLexicalUnit | fn:lu:fields:literary | "fields" | "literary" | "has lexical unit" |  | "FN" |  |
| fn:fields | fn:HasLexicalUnit | fn:lu:fields:literature | "fields" | "literature" | "has lexical unit" |  | "FN" |  |
| fn:fields | fn:HasLexicalUnit | fn:lu:fields:theater | "fields" | "theater" | "has lexical unit" |  | "FN" |  |
| fn:fields | fn:HasLexicalUnit | fn:lu:fields:industrial | "fields" | "industrial" | "has lexical unit" |  | "FN" |  |
| fn:fields | fn:HasLexicalUnit | fn:lu:fields:history | "fields" | "history" | "has lexical unit" |  | "FN" |  |
| fn:fields | fn:HasLexicalUnit | fn:lu:fields:mathematics | "fields" | "mathematics" | "has lexical unit" |  | "FN" |  |
| fn:fields | fn:HasLexicalUnit | fn:lu:fields:finance | "fields" | "finance" | "has lexical unit" |  | "FN" |  |
| fn:fields | fn:HasLexicalUnit | fn:lu:fields:math | "fields" | "math" | "has lexical unit" |  | "FN" |  |
| fn:fields | fn:HasLexicalUnit | fn:lu:fields:technical | "fields" | "technical" | "has lexical unit" |  | "FN" |  |
| fn:fields | /r/HasA | fn:fe:activity | "fields" | "activity" | "/r/has a" |  | "FN" |  |
| fn:fe:practitioner | /r/IsA | fn:st:human | "practitioner" | "human" | "/r/is a" |  | "FN" |  |
| fn:fields | /r/HasA | fn:fe:practitioner | "fields" | "practitioner" | "/r/has a" |  | "FN" |  |
| fn:fields | /r/HasA | fn:fe:salient_entity | "fields" | "salient entity" | "/r/has a" |  | "FN" |  |
| fn:fields | /r/HasA | fn:fe:work | "fields" | "work" | "/r/has a" |  | "FN" |  |
| fn:fields | /r/HasA | fn:fe:type | "fields" | "type" | "/r/has a" |  | "FN" |  |
| fn:fields | /r/HasA | fn:fe:place | "fields" | "place" | "/r/has a" |  | "FN" |  |
| fn:fields | /r/HasA | fn:fe:time | "fields" | "time" | "/r/has a" |  | "FN" |  |
| fn:fighting_activity | /r/IsA | fn:hostile_encounter | "fighting activity" | "hostile encounter" | "/r/is a" |  | "FN" |  |
| fn:fighting_activity | fn:HasLexicalUnit | fn:lu:fighting_activity:melee | "fighting activity" | "melee" | "has lexical unit" |  | "FN" |  |
| fn:fighting_activity | fn:HasLexicalUnit | fn:lu:fighting_activity:free-for-all | "fighting activity" | "free-for-all" | "has lexical unit" |  | "FN" |  |
| fn:fighting_activity | fn:HasLexicalUnit | fn:lu:fighting_activity:affray | "fighting activity" | "affray" | "has lexical unit" |  | "FN" |  |
| fn:fighting_activity | fn:HasLexicalUnit | fn:lu:fighting_activity:fray | "fighting activity" | "fray" | "has lexical unit" |  | "FN" |  |
| fn:fighting_activity | fn:HasLexicalUnit | fn:lu:fighting_activity:donnybrook | "fighting activity" | "donnybrook" | "has lexical unit" |  | "FN" |  |
| fn:fighting_activity | fn:HasLexicalUnit | fn:lu:fighting_activity:fracas | "fighting activity" | "fracas" | "has lexical unit" |  | "FN" |  |
| fn:fighting_activity | /r/HasA | fn:fe:combatants | "fighting activity" | "combatants" | "/r/has a" |  | "FN" |  |
| fn:fighting_activity | /r/HasA | fn:fe:fight | "fighting activity" | "fight" | "/r/has a" |  | "FN" |  |
| fn:fighting_activity | /r/HasA | fn:fe:time | "fighting activity" | "time" | "/r/has a" |  | "FN" |  |
| fn:fighting_activity | /r/HasA | fn:fe:place | "fighting activity" | "place" | "/r/has a" |  | "FN" |  |
| fn:fighting_activity | /r/HasA | fn:fe:manner | "fighting activity" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fighting_activity | /r/HasA | fn:fe:degree | "fighting activity" | "degree" | "/r/has a" |  | "FN" |  |
| fn:fighting_activity | /r/HasA | fn:fe:salient_activity | "fighting activity" | "salient activity" | "/r/has a" |  | "FN" |  |
| fn:fighting_activity | /r/HasA | fn:fe:issue | "fighting activity" | "issue" | "/r/has a" |  | "FN" |  |
| fn:fighting_activity | /r/HasA | fn:fe:duration | "fighting activity" | "duration" | "/r/has a" |  | "FN" |  |
| fn:fighting_activity | /r/HasA | fn:fe:means | "fighting activity" | "means" | "/r/has a" |  | "FN" |  |
| fn:fighting_activity | /r/HasA | fn:fe:instrument | "fighting activity" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:fighting_activity | /r/HasA | fn:fe:purpose | "fighting activity" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:filling | /r/IsA | fn:container_focused_placing | "filling" | "container focused placing" | "/r/is a" |  | "FN" |  |
| fn:cause_motion | /r/RelatedTo | fn:filling | "cause motion" | "filling" | "/r/related to" |  | "FN" |  |
| fn:distributed_position | /r/RelatedTo | fn:filling | "distributed position" | "filling" | "/r/related to" |  | "FN" |  |
| fn:placing | /r/RelatedTo | fn:filling | "placing" | "filling" | "/r/related to" |  | "FN" |  |
| fn:filling | /r/Causes | fn:fullness | "filling" | "fullness" | "/r/causes" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:adorn | "filling" | "adorn" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:anoint | "filling" | "anoint" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:cover | "filling" | "cover" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:dust | "filling" | "dust" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:load | "filling" | "load" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:pack | "filling" | "pack" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:smear | "filling" | "smear" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:spread | "filling" | "spread" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:stuff | "filling" | "stuff" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:wrap | "filling" | "wrap" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:plaster | "filling" | "plaster" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:drape | "filling" | "drape" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:dab | "filling" | "dab" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:daub | "filling" | "daub" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:inject | "filling" | "inject" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:cram | "filling" | "cram" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:sow | "filling" | "sow" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:seed | "filling" | "seed" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:brush | "filling" | "brush" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:hang | "filling" | "hang" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:spatter | "filling" | "spatter" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:splash | "filling" | "splash" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:splatter | "filling" | "splatter" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:spray | "filling" | "spray" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:sprinkle | "filling" | "sprinkle" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:squirt | "filling" | "squirt" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:shower | "filling" | "shower" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:drizzle | "filling" | "drizzle" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:heap | "filling" | "heap" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:pile | "filling" | "pile" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:pump | "filling" | "pump" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:jam | "filling" | "jam" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:plant | "filling" | "plant" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:scatter | "filling" | "scatter" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:butter | "filling" | "butter" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:asphalt | "filling" | "asphalt" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:surface | "filling" | "surface" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:tile | "filling" | "tile" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:wallpaper | "filling" | "wallpaper" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:coat | "filling" | "coat" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:suffuse | "filling" | "suffuse" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:fill | "filling" | "fill" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:strew | "filling" | "strew" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:douse | "filling" | "douse" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:flood | "filling" | "flood" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:crowd | "filling" | "crowd" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:pave | "filling" | "pave" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:varnish | "filling" | "varnish" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:paint | "filling" | "paint" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:gild | "filling" | "gild" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:glaze | "filling" | "glaze" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:embellish | "filling" | "embellish" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:panel | "filling" | "panel" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:wax | "filling" | "wax" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:wash | "filling" | "wash" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:plank | "filling" | "plank" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:yoke | "filling" | "yoke" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:dress | "filling" | "dress" | "has lexical unit" |  | "FN" |  |
| fn:filling | fn:HasLexicalUnit | fn:lu:filling:accessorize | "filling" | "accessorize" | "has lexical unit" |  | "FN" |  |
| fn:filling | /r/HasA | fn:fe:agent | "filling" | "agent" | "/r/has a" |  | "FN" |  |
| fn:filling | /r/HasA | fn:fe:theme | "filling" | "theme" | "/r/has a" |  | "FN" |  |
| fn:filling | /r/HasA | fn:fe:source | "filling" | "source" | "/r/has a" |  | "FN" |  |
| fn:filling | /r/HasA | fn:fe:path | "filling" | "path" | "/r/has a" |  | "FN" |  |
| fn:filling | /r/HasA | fn:fe:goal | "filling" | "goal" | "/r/has a" |  | "FN" |  |
| fn:filling | /r/HasA | fn:fe:degree | "filling" | "degree" | "/r/has a" |  | "FN" |  |
| fn:filling | /r/HasA | fn:fe:depictive | "filling" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:filling | /r/HasA | fn:fe:manner | "filling" | "manner" | "/r/has a" |  | "FN" |  |
| fn:filling | /r/HasA | fn:fe:means | "filling" | "means" | "/r/has a" |  | "FN" |  |
| fn:filling | /r/HasA | fn:fe:result | "filling" | "result" | "/r/has a" |  | "FN" |  |
| fn:filling | /r/HasA | fn:fe:explanation | "filling" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:filling | /r/HasA | fn:fe:time | "filling" | "time" | "/r/has a" |  | "FN" |  |
| fn:filling | /r/HasA | fn:fe:place | "filling" | "place" | "/r/has a" |  | "FN" |  |
| fn:filling | /r/HasA | fn:fe:purpose | "filling" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:filling | /r/HasA | fn:fe:instrument | "filling" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:filling | /r/HasA | fn:fe:subregion | "filling" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:filling | /r/HasA | fn:fe:cause | "filling" | "cause" | "/r/has a" |  | "FN" |  |
| fn:fining | /r/IsA | fn:rewards_and_punishments | "fining" | "rewards and punishments" | "/r/is a" |  | "FN" |  |
| fn:commerce_collect | /r/UsedFor | fn:fining | "commerce collect" | "fining" | "/r/used for" |  | "FN" |  |
| fn:citing | /r/RelatedTo | fn:fining | "citing" | "fining" | "/r/related to" |  | "FN" |  |
| fn:fining | fn:HasLexicalUnit | fn:lu:fining:fine | "fining" | "fine" | "has lexical unit" |  | "FN" |  |
| fn:fining | fn:HasLexicalUnit | fn:lu:fining:fine | "fining" | "fine" | "has lexical unit" |  | "FN" |  |
| fn:fining | fn:HasLexicalUnit | fn:lu:fining:reparations | "fining" | "reparations" | "has lexical unit" |  | "FN" |  |
| fn:fining | fn:HasLexicalUnit | fn:lu:fining:damages | "fining" | "damages" | "has lexical unit" |  | "FN" |  |
| fn:fining | fn:HasLexicalUnit | fn:lu:fining:amerce | "fining" | "amerce" | "has lexical unit" |  | "FN" |  |
| fn:fining | fn:HasLexicalUnit | fn:lu:fining:ticket | "fining" | "ticket" | "has lexical unit" |  | "FN" |  |
| fn:fining | fn:HasLexicalUnit | fn:lu:fining:ticket | "fining" | "ticket" | "has lexical unit" |  | "FN" |  |
| fn:fining | fn:HasLexicalUnit | fn:lu:fining:mulct | "fining" | "mulct" | "has lexical unit" |  | "FN" |  |
| fn:fining | /r/HasA | fn:fe:speaker | "fining" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:fining | /r/HasA | fn:fe:instrument | "fining" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:fining | /r/HasA | fn:fe:means | "fining" | "means" | "/r/has a" |  | "FN" |  |
| fn:fining | /r/HasA | fn:fe:place | "fining" | "place" | "/r/has a" |  | "FN" |  |
| fn:fining | /r/HasA | fn:fe:purpose | "fining" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:fining | /r/HasA | fn:fe:time | "fining" | "time" | "/r/has a" |  | "FN" |  |
| fn:fe:payer | /r/IsA | fn:st:source | "payer" | "source" | "/r/is a" |  | "FN" |  |
| fn:fining | /r/HasA | fn:fe:payer | "fining" | "payer" | "/r/has a" |  | "FN" |  |
| fn:fining | /r/HasA | fn:fe:manner | "fining" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fining | /r/HasA | fn:fe:reason | "fining" | "reason" | "/r/has a" |  | "FN" |  |
| fn:fining | /r/HasA | fn:fe:result | "fining" | "result" | "/r/has a" |  | "FN" |  |
| fn:fining | /r/HasA | fn:fe:fine | "fining" | "fine" | "/r/has a" |  | "FN" |  |
| fn:fining | /r/HasA | fn:fe:rate | "fining" | "rate" | "/r/has a" |  | "FN" |  |
| fn:fining | /r/HasA | fn:fe:unit | "fining" | "unit" | "/r/has a" |  | "FN" |  |
| fn:fining | /r/HasA | fn:fe:event | "fining" | "event" | "/r/has a" |  | "FN" |  |
| fn:fining | /r/HasA | fn:fe:degree | "fining" | "degree" | "/r/has a" |  | "FN" |  |
| fn:finish_competition | /r/IsA | fn:finish_game | "finish competition" | "finish game" | "/r/is a" |  | "FN" |  |
| fn:competition | /r/HasSubevent | fn:finish_competition | "competition" | "finish competition" | "/r/has subevent" |  | "FN" |  |
| fn:finish_competition | /r/UsedFor | fn:margin_of_resolution | "finish competition" | "margin of resolution" | "/r/used for" |  | "FN" |  |
| fn:success_or_failure | /r/UsedFor | fn:finish_competition | "success or failure" | "finish competition" | "/r/used for" |  | "FN" |  |
| fn:win_prize | /r/RelatedTo | fn:finish_competition | "win prize" | "finish competition" | "/r/related to" |  | "FN" |  |
| fn:competition | /r/SimilarTo | fn:finish_competition | "competition" | "finish competition" | "/r/similar to" |  | "FN" |  |
| fn:finish_competition | fn:HasLexicalUnit | fn:lu:finish_competition:win | "finish competition" | "win" | "has lexical unit" |  | "FN" |  |
| fn:finish_competition | fn:HasLexicalUnit | fn:lu:finish_competition:victorious | "finish competition" | "victorious" | "has lexical unit" |  | "FN" |  |
| fn:finish_competition | fn:HasLexicalUnit | fn:lu:finish_competition:winner | "finish competition" | "winner" | "has lexical unit" |  | "FN" |  |
| fn:finish_competition | fn:HasLexicalUnit | fn:lu:finish_competition:victory | "finish competition" | "victory" | "has lexical unit" |  | "FN" |  |
| fn:finish_competition | fn:HasLexicalUnit | fn:lu:finish_competition:lose | "finish competition" | "lose" | "has lexical unit" |  | "FN" |  |
| fn:finish_competition | fn:HasLexicalUnit | fn:lu:finish_competition:loss | "finish competition" | "loss" | "has lexical unit" |  | "FN" |  |
| fn:finish_competition | fn:HasLexicalUnit | fn:lu:finish_competition:tie | "finish competition" | "tie" | "has lexical unit" |  | "FN" |  |
| fn:finish_competition | fn:HasLexicalUnit | fn:lu:finish_competition:tie | "finish competition" | "tie" | "has lexical unit" |  | "FN" |  |
| fn:finish_competition | fn:HasLexicalUnit | fn:lu:finish_competition:victor | "finish competition" | "victor" | "has lexical unit" |  | "FN" |  |
| fn:finish_competition | fn:HasLexicalUnit | fn:lu:finish_competition:draw | "finish competition" | "draw" | "has lexical unit" |  | "FN" |  |
| fn:finish_competition | fn:HasLexicalUnit | fn:lu:finish_competition:show | "finish competition" | "show" | "has lexical unit" |  | "FN" |  |
| fn:finish_competition | fn:HasLexicalUnit | fn:lu:finish_competition:win | "finish competition" | "win" | "has lexical unit" |  | "FN" |  |
| fn:finish_competition | fn:HasLexicalUnit | fn:lu:finish_competition:fold | "finish competition" | "fold" | "has lexical unit" |  | "FN" |  |
| fn:fe:competitor | /r/IsA | fn:st:sentient | "competitor" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:fe:competitor | /r/RelatedTo | fn:fe:competitors | "competitor" | "competitors" | "/r/related to" |  | "FN" |  |
| fn:finish_competition | /r/HasA | fn:fe:competitor | "finish competition" | "competitor" | "/r/has a" |  | "FN" |  |
| fn:fe:opponent | /r/HasPrerequisite | fn:fe:competitor | "opponent" | "competitor" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:opponent | /r/RelatedTo | fn:fe:competitors | "opponent" | "competitors" | "/r/related to" |  | "FN" |  |
| fn:finish_competition | /r/HasA | fn:fe:opponent | "finish competition" | "opponent" | "/r/has a" |  | "FN" |  |
| fn:finish_competition | /r/HasA | fn:fe:competitors | "finish competition" | "competitors" | "/r/has a" |  | "FN" |  |
| fn:finish_competition | /r/HasA | fn:fe:score | "finish competition" | "score" | "/r/has a" |  | "FN" |  |
| fn:finish_competition | /r/HasA | fn:fe:margin | "finish competition" | "margin" | "/r/has a" |  | "FN" |  |
| fn:finish_competition | /r/HasA | fn:fe:rank | "finish competition" | "rank" | "/r/has a" |  | "FN" |  |
| fn:finish_competition | /r/HasA | fn:fe:prize | "finish competition" | "prize" | "/r/has a" |  | "FN" |  |
| fn:finish_competition | /r/HasA | fn:fe:competition | "finish competition" | "competition" | "/r/has a" |  | "FN" |  |
| fn:finish_competition | /r/HasA | fn:fe:means | "finish competition" | "means" | "/r/has a" |  | "FN" |  |
| fn:finish_competition | /r/HasA | fn:fe:manner | "finish competition" | "manner" | "/r/has a" |  | "FN" |  |
| fn:finish_competition | /r/HasA | fn:fe:time | "finish competition" | "time" | "/r/has a" |  | "FN" |  |
| fn:finish_competition | /r/HasA | fn:fe:place | "finish competition" | "place" | "/r/has a" |  | "FN" |  |
| fn:finish_competition | /r/HasA | fn:fe:venue | "finish competition" | "venue" | "/r/has a" |  | "FN" |  |
| fn:finish_competition | /r/HasA | fn:fe:particular_iteration | "finish competition" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:finish_game | /r/IsA | fn:activity_finish | "finish game" | "activity finish" | "/r/is a" |  | "FN" |  |
| fn:finish_competition | /r/IsA | fn:finish_game | "finish competition" | "finish game" | "/r/is a" |  | "FN" |  |
| fn:finish_game | fn:HasLexicalUnit | fn:lu:finish_game:win | "finish game" | "win" | "has lexical unit" |  | "FN" |  |
| fn:finish_game | fn:HasLexicalUnit | fn:lu:finish_game:lose | "finish game" | "lose" | "has lexical unit" |  | "FN" |  |
| fn:finish_game | /r/HasA | fn:fe:game | "finish game" | "game" | "/r/has a" |  | "FN" |  |
| fn:fe:player | /r/IsA | fn:st:sentient | "player" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:finish_game | /r/HasA | fn:fe:player | "finish game" | "player" | "/r/has a" |  | "FN" |  |
| fn:finish_game | /r/HasA | fn:fe:manner | "finish game" | "manner" | "/r/has a" |  | "FN" |  |
| fn:finish_game | /r/HasA | fn:fe:means | "finish game" | "means" | "/r/has a" |  | "FN" |  |
| fn:finish_game | /r/HasA | fn:fe:time | "finish game" | "time" | "/r/has a" |  | "FN" |  |
| fn:finish_game | /r/HasA | fn:fe:place | "finish game" | "place" | "/r/has a" |  | "FN" |  |
| fn:finish_game | /r/HasA | fn:fe:purpose | "finish game" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:finish_game | /r/HasA | fn:fe:degree | "finish game" | "degree" | "/r/has a" |  | "FN" |  |
| fn:fire_break | /r/IsA | fn:artifact | "fire break" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:fire_break | fn:HasLexicalUnit | fn:lu:fire_break:fire_break | "fire break" | "fire break" | "has lexical unit" |  | "FN" |  |
| fn:fire_break | fn:HasLexicalUnit | fn:lu:fire_break:fire_line | "fire break" | "fire line" | "has lexical unit" |  | "FN" |  |
| fn:fire_break | /r/HasA | fn:fe:fire_break | "fire break" | "fire break" | "/r/has a" |  | "FN" |  |
| fn:fire_break | /r/HasA | fn:fe:creator | "fire break" | "creator" | "/r/has a" |  | "FN" |  |
| fn:fire_break | /r/HasA | fn:fe:material | "fire break" | "material" | "/r/has a" |  | "FN" |  |
| fn:fire_break | /r/HasA | fn:fe:name | "fire break" | "name" | "/r/has a" |  | "FN" |  |
| fn:fire_break | /r/HasA | fn:fe:time_of_creation | "fire break" | "time of creation" | "/r/has a" |  | "FN" |  |
| fn:fire_break | /r/HasA | fn:fe:type | "fire break" | "type" | "/r/has a" |  | "FN" |  |
| fn:fire_break | /r/HasA | fn:fe:use | "fire break" | "use" | "/r/has a" |  | "FN" |  |
| fn:emergency_fire | /r/IsA | fn:fire_burning | "emergency fire" | "fire burning" | "/r/is a" |  | "FN" |  |
| fn:fire_burning | /r/HasPrerequisite | fn:catching_fire | "fire burning" | "catching fire" | "/r/has prerequisite" |  | "FN" |  |
| fn:fire_going_out | /r/HasPrerequisite | fn:fire_burning | "fire going out" | "fire burning" | "/r/has prerequisite" |  | "FN" |  |
| fn:putting_out_fire | /r/HasPrerequisite | fn:fire_burning | "putting out fire" | "fire burning" | "/r/has prerequisite" |  | "FN" |  |
| fn:fire_burning | /r/HasPrerequisite | fn:setting_fire | "fire burning" | "setting fire" | "/r/has prerequisite" |  | "FN" |  |
| fn:fire_burning | fn:HasLexicalUnit | fn:lu:fire_burning:burn | "fire burning" | "burn" | "has lexical unit" |  | "FN" |  |
| fn:fire_burning | fn:HasLexicalUnit | fn:lu:fire_burning:conflagration | "fire burning" | "conflagration" | "has lexical unit" |  | "FN" |  |
| fn:fire_burning | fn:HasLexicalUnit | fn:lu:fire_burning:inferno | "fire burning" | "inferno" | "has lexical unit" |  | "FN" |  |
| fn:fire_burning | fn:HasLexicalUnit | fn:lu:fire_burning:fire | "fire burning" | "fire" | "has lexical unit" |  | "FN" |  |
| fn:fire_burning | fn:HasLexicalUnit | fn:lu:fire_burning:hot_spot | "fire burning" | "hot spot" | "has lexical unit" |  | "FN" |  |
| fn:fire_burning | fn:HasLexicalUnit | fn:lu:fire_burning:backfire | "fire burning" | "backfire" | "has lexical unit" |  | "FN" |  |
| fn:fire_burning | fn:HasLexicalUnit | fn:lu:fire_burning:campfire | "fire burning" | "campfire" | "has lexical unit" |  | "FN" |  |
| fn:fire_burning | fn:HasLexicalUnit | fn:lu:fire_burning:flames | "fire burning" | "flames" | "has lexical unit" |  | "FN" |  |
| fn:fire_burning | fn:HasLexicalUnit | fn:lu:fire_burning:spot_fire | "fire burning" | "spot fire" | "has lexical unit" |  | "FN" |  |
| fn:fire_burning | fn:HasLexicalUnit | fn:lu:fire_burning:blaze | "fire burning" | "blaze" | "has lexical unit" |  | "FN" |  |
| fn:fire_burning | fn:HasLexicalUnit | fn:lu:fire_burning:blaze | "fire burning" | "blaze" | "has lexical unit" |  | "FN" |  |
| fn:fire_burning | fn:HasLexicalUnit | fn:lu:fire_burning:on_fire | "fire burning" | "on fire" | "has lexical unit" |  | "FN" |  |
| fn:fire_burning | fn:HasLexicalUnit | fn:lu:fire_burning:brush_fire | "fire burning" | "brush fire" | "has lexical unit" |  | "FN" |  |
| fn:fire_burning | fn:HasLexicalUnit | fn:lu:fire_burning:rage | "fire burning" | "rage" | "has lexical unit" |  | "FN" |  |
| fn:fire_burning | fn:HasLexicalUnit | fn:lu:fire_burning:bonfire | "fire burning" | "bonfire" | "has lexical unit" |  | "FN" |  |
| fn:fire_burning | fn:HasLexicalUnit | fn:lu:fire_burning:ablaze | "fire burning" | "ablaze" | "has lexical unit" |  | "FN" |  |
| fn:fire_burning | fn:HasLexicalUnit | fn:lu:fire_burning:alight | "fire burning" | "alight" | "has lexical unit" |  | "FN" |  |
| fn:fire_burning | /r/HasA | fn:fe:place | "fire burning" | "place" | "/r/has a" |  | "FN" |  |
| fn:fire_burning | /r/HasA | fn:fe:time | "fire burning" | "time" | "/r/has a" |  | "FN" |  |
| fn:fire_burning | /r/HasA | fn:fe:fire | "fire burning" | "fire" | "/r/has a" |  | "FN" |  |
| fn:fire_burning | /r/HasA | fn:fe:fuel | "fire burning" | "fuel" | "/r/has a" |  | "FN" |  |
| fn:fire_burning | /r/HasA | fn:fe:manner | "fire burning" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fire_burning | /r/HasA | fn:fe:name | "fire burning" | "name" | "/r/has a" |  | "FN" |  |
| fn:fire_burning | /r/HasA | fn:fe:duration | "fire burning" | "duration" | "/r/has a" |  | "FN" |  |
| fn:fire_burning | /r/HasA | fn:fe:depictive | "fire burning" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:fire_burning | /r/HasA | fn:fe:result | "fire burning" | "result" | "/r/has a" |  | "FN" |  |
| fn:fire_burning | /r/HasA | fn:fe:subregion | "fire burning" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:fire_emergency_scenario | /r/IsA | fn:disaster_scenario | "fire emergency scenario" | "disaster scenario" | "/r/is a" |  | "FN" |  |
| fn:fire_emergency_scenario | /r/HasSubevent | fn:emergency_fire | "fire emergency scenario" | "emergency fire" | "/r/has subevent" |  | "FN" |  |
| fn:fire_emergency_scenario | /r/HasSubevent | fn:firefighting | "fire emergency scenario" | "firefighting" | "/r/has subevent" |  | "FN" |  |
| fn:fire_emergency_scenario | /r/HasA | fn:fe:fire | "fire emergency scenario" | "fire" | "/r/has a" |  | "FN" |  |
| fn:fire_emergency_scenario | /r/HasA | fn:fe:duration | "fire emergency scenario" | "duration" | "/r/has a" |  | "FN" |  |
| fn:fire_emergency_scenario | /r/HasA | fn:fe:place | "fire emergency scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:fire_emergency_scenario | /r/HasA | fn:fe:responder | "fire emergency scenario" | "responder" | "/r/has a" |  | "FN" |  |
| fn:fire_emergency_scenario | /r/HasA | fn:fe:response | "fire emergency scenario" | "response" | "/r/has a" |  | "FN" |  |
| fn:fire_emergency_scenario | /r/HasA | fn:fe:time | "fire emergency scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:fire_emergency_scenario | /r/HasA | fn:fe:victim | "fire emergency scenario" | "victim" | "/r/has a" |  | "FN" |  |
| fn:fire_end_scenario | /r/HasSubevent | fn:fire_going_out | "fire end scenario" | "fire going out" | "/r/has subevent" |  | "FN" |  |
| fn:fire_end_scenario | /r/HasA | fn:fe:place | "fire end scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:fire_end_scenario | /r/HasA | fn:fe:time | "fire end scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:fire_end_scenario | /r/HasA | fn:fe:fire | "fire end scenario" | "fire" | "/r/has a" |  | "FN" |  |
| fn:fire_end_scenario | /r/HasA | fn:fe:degree | "fire end scenario" | "degree" | "/r/has a" |  | "FN" |  |
| fn:fire_end_scenario | /r/HasSubevent | fn:fire_going_out | "fire end scenario" | "fire going out" | "/r/has subevent" |  | "FN" |  |
| fn:putting_out_fire | /r/Causes | fn:fire_going_out | "putting out fire" | "fire going out" | "/r/causes" |  | "FN" |  |
| fn:fire_going_out | /r/HasPrerequisite | fn:fire_burning | "fire going out" | "fire burning" | "/r/has prerequisite" |  | "FN" |  |
| fn:fire_going_out | fn:HasLexicalUnit | fn:lu:fire_going_out:die | "fire going out" | "die" | "has lexical unit" |  | "FN" |  |
| fn:fire_going_out | fn:HasLexicalUnit | fn:lu:fire_going_out:burn_out | "fire going out" | "burn out" | "has lexical unit" |  | "FN" |  |
| fn:fire_going_out | fn:HasLexicalUnit | fn:lu:fire_going_out:go_out | "fire going out" | "go out" | "has lexical unit" |  | "FN" |  |
| fn:fire_going_out | fn:HasLexicalUnit | fn:lu:fire_going_out:gutter_out | "fire going out" | "gutter out" | "has lexical unit" |  | "FN" |  |
| fn:fire_going_out | /r/HasA | fn:fe:depictive | "fire going out" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:fire_going_out | /r/HasA | fn:fe:manner | "fire going out" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fire_going_out | /r/HasA | fn:fe:result | "fire going out" | "result" | "/r/has a" |  | "FN" |  |
| fn:fire_going_out | /r/HasA | fn:fe:place | "fire going out" | "place" | "/r/has a" |  | "FN" |  |
| fn:fire_going_out | /r/HasA | fn:fe:time | "fire going out" | "time" | "/r/has a" |  | "FN" |  |
| fn:fire_going_out | /r/HasA | fn:fe:fire | "fire going out" | "fire" | "/r/has a" |  | "FN" |  |
| fn:fire_going_out | /r/HasA | fn:fe:degree | "fire going out" | "degree" | "/r/has a" |  | "FN" |  |
| fn:fire_going_out | /r/HasA | fn:fe:explanation | "fire going out" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:fire_going_out | /r/HasA | fn:fe:circumstances | "fire going out" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:fire_going_out | /r/HasA | fn:fe:containing_event | "fire going out" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:fire_stopping_scenario | /r/HasSubevent | fn:putting_out_fire | "fire stopping scenario" | "putting out fire" | "/r/has subevent" |  | "FN" |  |
| fn:fire_stopping_scenario | /r/HasA | fn:fe:place | "fire stopping scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:fire_stopping_scenario | /r/HasA | fn:fe:time | "fire stopping scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:fire_stopping_scenario | /r/HasA | fn:fe:agent | "fire stopping scenario" | "agent" | "/r/has a" |  | "FN" |  |
| fn:fire_stopping_scenario | /r/HasA | fn:fe:fire | "fire stopping scenario" | "fire" | "/r/has a" |  | "FN" |  |
| fn:fire_stopping_scenario | /r/HasA | fn:fe:degree | "fire stopping scenario" | "degree" | "/r/has a" |  | "FN" |  |
| fn:fire_emergency_scenario | /r/HasSubevent | fn:firefighting | "fire emergency scenario" | "firefighting" | "/r/has subevent" |  | "FN" |  |
| fn:hostile_encounter | /r/UsedFor | fn:firefighting | "hostile encounter" | "firefighting" | "/r/used for" |  | "FN" |  |
| fn:putting_out_fire | /r/HasPrerequisite | fn:firefighting | "putting out fire" | "firefighting" | "/r/has prerequisite" |  | "FN" |  |
| fn:hostile_encounter | /r/SimilarTo | fn:firefighting | "hostile encounter" | "firefighting" | "/r/similar to" |  | "FN" |  |
| fn:firefighting | fn:HasLexicalUnit | fn:lu:firefighting:fight | "firefighting" | "fight" | "has lexical unit" |  | "FN" |  |
| fn:firefighting | fn:HasLexicalUnit | fn:lu:firefighting:gain_ground | "firefighting" | "gain ground" | "has lexical unit" |  | "FN" |  |
| fn:firefighting | fn:HasLexicalUnit | fn:lu:firefighting:battle | "firefighting" | "battle" | "has lexical unit" |  | "FN" |  |
| fn:firefighting | fn:HasLexicalUnit | fn:lu:firefighting:control | "firefighting" | "control" | "has lexical unit" |  | "FN" |  |
| fn:firefighting | fn:HasLexicalUnit | fn:lu:firefighting:tackle | "firefighting" | "tackle" | "has lexical unit" |  | "FN" |  |
| fn:firefighting | fn:HasLexicalUnit | fn:lu:firefighting:attack | "firefighting" | "attack" | "has lexical unit" |  | "FN" |  |
| fn:firefighting | fn:HasLexicalUnit | fn:lu:firefighting:battle | "firefighting" | "battle" | "has lexical unit" |  | "FN" |  |
| fn:firefighting | fn:HasLexicalUnit | fn:lu:firefighting:fire_fighting | "firefighting" | "fire fighting" | "has lexical unit" |  | "FN" |  |
| fn:firefighting | /r/HasA | fn:fe:fire | "firefighting" | "fire" | "/r/has a" |  | "FN" |  |
| fn:fe:firefighter | /r/IsA | fn:st:sentient | "firefighter" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:firefighting | /r/HasA | fn:fe:firefighter | "firefighting" | "firefighter" | "/r/has a" |  | "FN" |  |
| fn:firefighting | /r/HasA | fn:fe:time | "firefighting" | "time" | "/r/has a" |  | "FN" |  |
| fn:firefighting | /r/HasA | fn:fe:place | "firefighting" | "place" | "/r/has a" |  | "FN" |  |
| fn:firefighting | /r/HasA | fn:fe:manner | "firefighting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:firefighting | /r/HasA | fn:fe:purpose | "firefighting" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:firefighting | /r/HasA | fn:fe:instrument | "firefighting" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:firefighting | /r/HasA | fn:fe:depictive | "firefighting" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:firing | /r/IsA | fn:employment_end | "firing" | "employment end" | "/r/is a" |  | "FN" |  |
| fn:firing | /r/IsA | fn:intentionally_affect | "firing" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:employer_scenario | /r/HasSubevent | fn:firing | "employer scenario" | "firing" | "/r/has subevent" |  | "FN" |  |
| fn:firing | /r/HasPrerequisite | fn:employing | "firing" | "employing" | "/r/has prerequisite" |  | "FN" |  |
| fn:firing | fn:HasLexicalUnit | fn:lu:firing:dismiss | "firing" | "dismiss" | "has lexical unit" |  | "FN" |  |
| fn:firing | fn:HasLexicalUnit | fn:lu:firing:can | "firing" | "can" | "has lexical unit" |  | "FN" |  |
| fn:firing | fn:HasLexicalUnit | fn:lu:firing:fire | "firing" | "fire" | "has lexical unit" |  | "FN" |  |
| fn:firing | fn:HasLexicalUnit | fn:lu:firing:shitcan | "firing" | "shitcan" | "has lexical unit" |  | "FN" |  |
| fn:firing | fn:HasLexicalUnit | fn:lu:firing:sack | "firing" | "sack" | "has lexical unit" |  | "FN" |  |
| fn:firing | fn:HasLexicalUnit | fn:lu:firing:terminate | "firing" | "terminate" | "has lexical unit" |  | "FN" |  |
| fn:firing | fn:HasLexicalUnit | fn:lu:firing:let_go | "firing" | "let go" | "has lexical unit" |  | "FN" |  |
| fn:firing | fn:HasLexicalUnit | fn:lu:firing:lay_off | "firing" | "lay off" | "has lexical unit" |  | "FN" |  |
| fn:firing | fn:HasLexicalUnit | fn:lu:firing:dismissal | "firing" | "dismissal" | "has lexical unit" |  | "FN" |  |
| fn:firing | fn:HasLexicalUnit | fn:lu:firing:firing | "firing" | "firing" | "has lexical unit" |  | "FN" |  |
| fn:firing | fn:HasLexicalUnit | fn:lu:firing:give_the_boot | "firing" | "give the boot" | "has lexical unit" |  | "FN" |  |
| fn:firing | fn:HasLexicalUnit | fn:lu:firing:lay-off | "firing" | "lay-off" | "has lexical unit" |  | "FN" |  |
| fn:firing | fn:HasLexicalUnit | fn:lu:firing:the_sack | "firing" | "the sack" | "has lexical unit" |  | "FN" |  |
| fn:firing | fn:HasLexicalUnit | fn:lu:firing:termination | "firing" | "termination" | "has lexical unit" |  | "FN" |  |
| fn:firing | fn:HasLexicalUnit | fn:lu:firing:downsize | "firing" | "downsize" | "has lexical unit" |  | "FN" |  |
| fn:firing | fn:HasLexicalUnit | fn:lu:firing:discharge | "firing" | "discharge" | "has lexical unit" |  | "FN" |  |
| fn:firing | /r/HasA | fn:fe:employee | "firing" | "employee" | "/r/has a" |  | "FN" |  |
| fn:fe:employer | /r/IsA | fn:st:sentient | "employer" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:firing | /r/HasA | fn:fe:employer | "firing" | "employer" | "/r/has a" |  | "FN" |  |
| fn:firing | /r/HasA | fn:fe:manner | "firing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:firing | /r/HasA | fn:fe:place | "firing" | "place" | "/r/has a" |  | "FN" |  |
| fn:firing | /r/HasA | fn:fe:position | "firing" | "position" | "/r/has a" |  | "FN" |  |
| fn:firing | /r/HasA | fn:fe:purpose | "firing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:fe:task | /r/RelatedTo | fn:fe:position | "task" | "position" | "/r/related to" |  | "FN" |  |
| fn:firing | /r/HasA | fn:fe:task | "firing" | "task" | "/r/has a" |  | "FN" |  |
| fn:firing | /r/HasA | fn:fe:time | "firing" | "time" | "/r/has a" |  | "FN" |  |
| fn:firing | /r/HasA | fn:fe:explanation | "firing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:firing | /r/HasA | fn:fe:means | "firing" | "means" | "/r/has a" |  | "FN" |  |
| fn:firing_point | /r/IsA | fn:locale_by_event | "firing point" | "locale by event" | "/r/is a" |  | "FN" |  |
| fn:distant_operated_ied | /r/UsedFor | fn:firing_point | "distant operated ied" | "firing point" | "/r/used for" |  | "FN" |  |
| fn:firing_point | fn:HasLexicalUnit | fn:lu:firing_point:firing_point | "firing point" | "firing point" | "has lexical unit" |  | "FN" |  |
| fn:fe:firing_point | /r/IsA | fn:st:location | "firing point" | "location" | "/r/is a" |  | "FN" |  |
| fn:firing_point | /r/HasA | fn:fe:firing_point | "firing point" | "firing point" | "/r/has a" |  | "FN" |  |
| fn:firing_point | /r/HasA | fn:fe:relative_location | "firing point" | "relative location" | "/r/has a" |  | "FN" |  |
| fn:firing_point | /r/HasA | fn:fe:descriptor | "firing point" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:firing_point | /r/HasA | fn:fe:name | "firing point" | "name" | "/r/has a" |  | "FN" |  |
| fn:firing_point | /r/HasA | fn:fe:detonator | "firing point" | "detonator" | "/r/has a" |  | "FN" |  |
| fn:first_experience | /r/UsedFor | fn:achieving_first | "first experience" | "achieving first" | "/r/used for" |  | "FN" |  |
| fn:first_experience | fn:HasLexicalUnit | fn:lu:first_experience:first | "first experience" | "first" | "has lexical unit" |  | "FN" |  |
| fn:first_experience | /r/HasA | fn:fe:experience | "first experience" | "experience" | "/r/has a" |  | "FN" |  |
| fn:first_experience | /r/HasA | fn:fe:context | "first experience" | "context" | "/r/has a" |  | "FN" |  |
| fn:first_rank | /r/UsedFor | fn:dominate_situation | "first rank" | "dominate situation" | "/r/used for" |  | "FN" |  |
| fn:gradable_attributes | /r/UsedFor | fn:first_rank | "gradable attributes" | "first rank" | "/r/used for" |  | "FN" |  |
| fn:prominence | /r/UsedFor | fn:first_rank | "prominence" | "first rank" | "/r/used for" |  | "FN" |  |
| fn:first_rank | fn:HasLexicalUnit | fn:lu:first_rank:primary | "first rank" | "primary" | "has lexical unit" |  | "FN" |  |
| fn:first_rank | fn:HasLexicalUnit | fn:lu:first_rank:main | "first rank" | "main" | "has lexical unit" |  | "FN" |  |
| fn:first_rank | fn:HasLexicalUnit | fn:lu:first_rank:chief | "first rank" | "chief" | "has lexical unit" |  | "FN" |  |
| fn:first_rank | fn:HasLexicalUnit | fn:lu:first_rank:principal | "first rank" | "principal" | "has lexical unit" |  | "FN" |  |
| fn:first_rank | fn:HasLexicalUnit | fn:lu:first_rank:foremost | "first rank" | "foremost" | "has lexical unit" |  | "FN" |  |
| fn:first_rank | fn:HasLexicalUnit | fn:lu:first_rank:lead | "first rank" | "lead" | "has lexical unit" |  | "FN" |  |
| fn:first_rank | fn:HasLexicalUnit | fn:lu:first_rank:leading | "first rank" | "leading" | "has lexical unit" |  | "FN" |  |
| fn:first_rank | fn:HasLexicalUnit | fn:lu:first_rank:lead | "first rank" | "lead" | "has lexical unit" |  | "FN" |  |
| fn:first_rank | fn:HasLexicalUnit | fn:lu:first_rank:leader | "first rank" | "leader" | "has lexical unit" |  | "FN" |  |
| fn:first_rank | /r/HasA | fn:fe:item | "first rank" | "item" | "/r/has a" |  | "FN" |  |
| fn:first_rank | /r/HasA | fn:fe:limits_of_consideration | "first rank" | "limits of consideration" | "/r/has a" |  | "FN" |  |
| fn:first_rank | /r/HasA | fn:fe:contrast_set | "first rank" | "contrast set" | "/r/has a" |  | "FN" |  |
| fn:first_rank | /r/HasA | fn:fe:attribute | "first rank" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:fleeing | /r/IsA | fn:self_motion | "fleeing" | "self motion" | "/r/is a" |  | "FN" |  |
| fn:escaping | /r/SimilarTo | fn:fleeing | "escaping" | "fleeing" | "/r/similar to" |  | "FN" |  |
| fn:self_motion | /r/SimilarTo | fn:fleeing | "self motion" | "fleeing" | "/r/similar to" |  | "FN" |  |
| fn:fleeing | fn:HasLexicalUnit | fn:lu:fleeing:bolt | "fleeing" | "bolt" | "has lexical unit" |  | "FN" |  |
| fn:fleeing | fn:HasLexicalUnit | fn:lu:fleeing:flee | "fleeing" | "flee" | "has lexical unit" |  | "FN" |  |
| fn:fleeing | fn:HasLexicalUnit | fn:lu:fleeing:run_away | "fleeing" | "run away" | "has lexical unit" |  | "FN" |  |
| fn:fleeing | fn:HasLexicalUnit | fn:lu:fleeing:flight | "fleeing" | "flight" | "has lexical unit" |  | "FN" |  |
| fn:fe:self_mover | /r/IsA | fn:st:sentient | "self mover" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:fleeing | /r/HasA | fn:fe:self_mover | "fleeing" | "self mover" | "/r/has a" |  | "FN" |  |
| fn:fleeing | /r/HasA | fn:fe:source | "fleeing" | "source" | "/r/has a" |  | "FN" |  |
| fn:fleeing | /r/HasA | fn:fe:path | "fleeing" | "path" | "/r/has a" |  | "FN" |  |
| fn:fleeing | /r/HasA | fn:fe:goal | "fleeing" | "goal" | "/r/has a" |  | "FN" |  |
| fn:fleeing | /r/HasA | fn:fe:manner | "fleeing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fleeing | /r/HasA | fn:fe:distance | "fleeing" | "distance" | "/r/has a" |  | "FN" |  |
| fn:fleeing | /r/HasA | fn:fe:time | "fleeing" | "time" | "/r/has a" |  | "FN" |  |
| fn:fleeing | /r/HasA | fn:fe:cotheme | "fleeing" | "cotheme" | "/r/has a" |  | "FN" |  |
| fn:fleeing | /r/HasA | fn:fe:speed | "fleeing" | "speed" | "/r/has a" |  | "FN" |  |
| fn:fleeing | /r/HasA | fn:fe:depictive | "fleeing" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:fleeing | /r/HasA | fn:fe:means | "fleeing" | "means" | "/r/has a" |  | "FN" |  |
| fn:fleeing | /r/HasA | fn:fe:result | "fleeing" | "result" | "/r/has a" |  | "FN" |  |
| fn:fleeing | /r/HasA | fn:fe:internal_cause | "fleeing" | "internal cause" | "/r/has a" |  | "FN" |  |
| fn:fleeing | /r/HasA | fn:fe:duration | "fleeing" | "duration" | "/r/has a" |  | "FN" |  |
| fn:fleeing | /r/HasA | fn:fe:purpose | "fleeing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:fleeing | /r/HasA | fn:fe:place | "fleeing" | "place" | "/r/has a" |  | "FN" |  |
| fn:fleeing | /r/HasA | fn:fe:explanation | "fleeing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:fleeing | /r/HasA | fn:fe:external_cause | "fleeing" | "external cause" | "/r/has a" |  | "FN" |  |
| fn:fleeing | /r/HasA | fn:fe:direction | "fleeing" | "direction" | "/r/has a" |  | "FN" |  |
| fn:fleeing | /r/HasA | fn:fe:means_of_motion | "fleeing" | "means of motion" | "/r/has a" |  | "FN" |  |
| fn:fluidic_motion | /r/IsA | fn:motion | "fluidic motion" | "motion" | "/r/is a" |  | "FN" |  |
| fn:fluidic_motion | /r/UsedFor | fn:breathing | "fluidic motion" | "breathing" | "/r/used for" |  | "FN" |  |
| fn:make_noise | /r/SimilarTo | fn:fluidic_motion | "make noise" | "fluidic motion" | "/r/similar to" |  | "FN" |  |
| fn:cause_fluidic_motion | /r/Causes | fn:fluidic_motion | "cause fluidic motion" | "fluidic motion" | "/r/causes" |  | "FN" |  |
| fn:fluidic_motion | fn:HasLexicalUnit | fn:lu:fluidic_motion:drip | "fluidic motion" | "drip" | "has lexical unit" |  | "FN" |  |
| fn:fluidic_motion | fn:HasLexicalUnit | fn:lu:fluidic_motion:flow | "fluidic motion" | "flow" | "has lexical unit" |  | "FN" |  |
| fn:fluidic_motion | fn:HasLexicalUnit | fn:lu:fluidic_motion:bubble | "fluidic motion" | "bubble" | "has lexical unit" |  | "FN" |  |
| fn:fluidic_motion | fn:HasLexicalUnit | fn:lu:fluidic_motion:trickle | "fluidic motion" | "trickle" | "has lexical unit" |  | "FN" |  |
| fn:fluidic_motion | fn:HasLexicalUnit | fn:lu:fluidic_motion:gush | "fluidic motion" | "gush" | "has lexical unit" |  | "FN" |  |
| fn:fluidic_motion | fn:HasLexicalUnit | fn:lu:fluidic_motion:cascade | "fluidic motion" | "cascade" | "has lexical unit" |  | "FN" |  |
| fn:fluidic_motion | fn:HasLexicalUnit | fn:lu:fluidic_motion:dribble | "fluidic motion" | "dribble" | "has lexical unit" |  | "FN" |  |
| fn:fluidic_motion | fn:HasLexicalUnit | fn:lu:fluidic_motion:splash | "fluidic motion" | "splash" | "has lexical unit" |  | "FN" |  |
| fn:fluidic_motion | fn:HasLexicalUnit | fn:lu:fluidic_motion:spew | "fluidic motion" | "spew" | "has lexical unit" |  | "FN" |  |
| fn:fluidic_motion | fn:HasLexicalUnit | fn:lu:fluidic_motion:seep | "fluidic motion" | "seep" | "has lexical unit" |  | "FN" |  |
| fn:fluidic_motion | fn:HasLexicalUnit | fn:lu:fluidic_motion:ooze | "fluidic motion" | "ooze" | "has lexical unit" |  | "FN" |  |
| fn:fluidic_motion | fn:HasLexicalUnit | fn:lu:fluidic_motion:percolate | "fluidic motion" | "percolate" | "has lexical unit" |  | "FN" |  |
| fn:fluidic_motion | fn:HasLexicalUnit | fn:lu:fluidic_motion:leak | "fluidic motion" | "leak" | "has lexical unit" |  | "FN" |  |
| fn:fluidic_motion | fn:HasLexicalUnit | fn:lu:fluidic_motion:jet | "fluidic motion" | "jet" | "has lexical unit" |  | "FN" |  |
| fn:fluidic_motion | fn:HasLexicalUnit | fn:lu:fluidic_motion:soak | "fluidic motion" | "soak" | "has lexical unit" |  | "FN" |  |
| fn:fluidic_motion | fn:HasLexicalUnit | fn:lu:fluidic_motion:run | "fluidic motion" | "run" | "has lexical unit" |  | "FN" |  |
| fn:fluidic_motion | fn:HasLexicalUnit | fn:lu:fluidic_motion:squirt | "fluidic motion" | "squirt" | "has lexical unit" |  | "FN" |  |
| fn:fluidic_motion | fn:HasLexicalUnit | fn:lu:fluidic_motion:spurt | "fluidic motion" | "spurt" | "has lexical unit" |  | "FN" |  |
| fn:fluidic_motion | fn:HasLexicalUnit | fn:lu:fluidic_motion:spout | "fluidic motion" | "spout" | "has lexical unit" |  | "FN" |  |
| fn:fluidic_motion | fn:HasLexicalUnit | fn:lu:fluidic_motion:rush | "fluidic motion" | "rush" | "has lexical unit" |  | "FN" |  |
| fn:fluidic_motion | fn:HasLexicalUnit | fn:lu:fluidic_motion:course | "fluidic motion" | "course" | "has lexical unit" |  | "FN" |  |
| fn:fluidic_motion | fn:HasLexicalUnit | fn:lu:fluidic_motion:purl | "fluidic motion" | "purl" | "has lexical unit" |  | "FN" |  |
| fn:fluidic_motion | fn:HasLexicalUnit | fn:lu:fluidic_motion:spill | "fluidic motion" | "spill" | "has lexical unit" |  | "FN" |  |
| fn:fluidic_motion | fn:HasLexicalUnit | fn:lu:fluidic_motion:stream | "fluidic motion" | "stream" | "has lexical unit" |  | "FN" |  |
| fn:fluidic_motion | fn:HasLexicalUnit | fn:lu:fluidic_motion:hiss | "fluidic motion" | "hiss" | "has lexical unit" |  | "FN" |  |
| fn:fluidic_motion | fn:HasLexicalUnit | fn:lu:fluidic_motion:pump | "fluidic motion" | "pump" | "has lexical unit" |  | "FN" |  |
| fn:fluidic_motion | fn:HasLexicalUnit | fn:lu:fluidic_motion:splatter | "fluidic motion" | "splatter" | "has lexical unit" |  | "FN" |  |
| fn:fluidic_motion | fn:HasLexicalUnit | fn:lu:fluidic_motion:spray | "fluidic motion" | "spray" | "has lexical unit" |  | "FN" |  |
| fn:fluidic_motion | /r/HasA | fn:fe:area | "fluidic motion" | "area" | "/r/has a" |  | "FN" |  |
| fn:fluidic_motion | /r/HasA | fn:fe:distance | "fluidic motion" | "distance" | "/r/has a" |  | "FN" |  |
| fn:fluidic_motion | /r/HasA | fn:fe:duration | "fluidic motion" | "duration" | "/r/has a" |  | "FN" |  |
| fn:fluidic_motion | /r/HasA | fn:fe:goal | "fluidic motion" | "goal" | "/r/has a" |  | "FN" |  |
| fn:fluidic_motion | /r/HasA | fn:fe:path | "fluidic motion" | "path" | "/r/has a" |  | "FN" |  |
| fn:fluidic_motion | /r/HasA | fn:fe:source | "fluidic motion" | "source" | "/r/has a" |  | "FN" |  |
| fn:fluidic_motion | /r/HasA | fn:fe:speed | "fluidic motion" | "speed" | "/r/has a" |  | "FN" |  |
| fn:fluidic_motion | /r/HasA | fn:fe:fluid | "fluidic motion" | "fluid" | "/r/has a" |  | "FN" |  |
| fn:fluidic_motion | /r/HasA | fn:fe:time | "fluidic motion" | "time" | "/r/has a" |  | "FN" |  |
| fn:fluidic_motion | /r/HasA | fn:fe:configuration | "fluidic motion" | "configuration" | "/r/has a" |  | "FN" |  |
| fn:fluidic_motion | /r/HasA | fn:fe:manner | "fluidic motion" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fluidic_motion | /r/HasA | fn:fe:explanation | "fluidic motion" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:fluidic_motion | /r/HasA | fn:fe:depictive | "fluidic motion" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:fluidic_motion | /r/HasA | fn:fe:result | "fluidic motion" | "result" | "/r/has a" |  | "FN" |  |
| fn:fluidic_motion | /r/HasA | fn:fe:place | "fluidic motion" | "place" | "/r/has a" |  | "FN" |  |
| fn:food | /r/IsA | fn:physical_entity | "food" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:food | /r/UsedFor | fn:tasting | "food" | "tasting" | "/r/used for" |  | "FN" |  |
| fn:ingestion | /r/UsedFor | fn:food | "ingestion" | "food" | "/r/used for" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:fruit | "food" | "fruit" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:apple | "food" | "apple" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:banana | "food" | "banana" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:vegetable | "food" | "vegetable" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:carrot | "food" | "carrot" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:potato | "food" | "potato" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:pea | "food" | "pea" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:meat | "food" | "meat" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:beef | "food" | "beef" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:lamb | "food" | "lamb" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:veal | "food" | "veal" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:poultry | "food" | "poultry" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:chicken | "food" | "chicken" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:turkey | "food" | "turkey" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:fish | "food" | "fish" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:salmon | "food" | "salmon" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:tuna | "food" | "tuna" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:shellfish | "food" | "shellfish" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:shrimp | "food" | "shrimp" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:lobster | "food" | "lobster" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:milk | "food" | "milk" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:cheese | "food" | "cheese" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:egg | "food" | "egg" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:butter | "food" | "butter" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:nut | "food" | "nut" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:almond | "food" | "almond" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:peanut | "food" | "peanut" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:pasta | "food" | "pasta" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:noodle | "food" | "noodle" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:herb | "food" | "herb" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:spice | "food" | "spice" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:pepper | "food" | "pepper" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:basil | "food" | "basil" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:cereal | "food" | "cereal" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:lettuce | "food" | "lettuce" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:berry | "food" | "berry" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:bread | "food" | "bread" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:roll | "food" | "roll" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:cracker | "food" | "cracker" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:cake | "food" | "cake" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:pancake | "food" | "pancake" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:cheesecake | "food" | "cheesecake" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:pastry | "food" | "pastry" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:croissant | "food" | "croissant" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:cookie | "food" | "cookie" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:biscuit | "food" | "biscuit" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:sweet | "food" | "sweet" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:chocolate | "food" | "chocolate" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:sweetener | "food" | "sweetener" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:sugar | "food" | "sugar" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:honey | "food" | "honey" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:fat | "food" | "fat" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:oil | "food" | "oil" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:vinegar | "food" | "vinegar" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:coffee | "food" | "coffee" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:juice | "food" | "juice" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:soup | "food" | "soup" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:stew | "food" | "stew" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:sauce | "food" | "sauce" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:dressing | "food" | "dressing" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:vinaigrette | "food" | "vinaigrette" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:ketchup | "food" | "ketchup" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:mayonnaise | "food" | "mayonnaise" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:lasagne | "food" | "lasagne" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:food | "food" | "food" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:tea | "food" | "tea" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:water | "food" | "water" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:date | "food" | "date" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:cabbage | "food" | "cabbage" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:mre | "food" | "mre" | "has lexical unit" |  | "FN" |  |
| fn:food | fn:HasLexicalUnit | fn:lu:food:beer | "food" | "beer" | "has lexical unit" |  | "FN" |  |
| fn:food | /r/HasA | fn:fe:descriptor | "food" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:food | /r/HasA | fn:fe:type | "food" | "type" | "/r/has a" |  | "FN" |  |
| fn:food | /r/HasA | fn:fe:food | "food" | "food" | "/r/has a" |  | "FN" |  |
| fn:food | /r/HasA | fn:fe:constituent_parts | "food" | "constituent parts" | "/r/has a" |  | "FN" |  |
| fn:agriculture | /r/HasSubevent | fn:food_gathering | "agriculture" | "food gathering" | "/r/has subevent" |  | "FN" |  |
| fn:food_gathering | fn:HasLexicalUnit | fn:lu:food_gathering:gather | "food gathering" | "gather" | "has lexical unit" |  | "FN" |  |
| fn:food_gathering | fn:HasLexicalUnit | fn:lu:food_gathering:pick | "food gathering" | "pick" | "has lexical unit" |  | "FN" |  |
| fn:food_gathering | fn:HasLexicalUnit | fn:lu:food_gathering:harvest | "food gathering" | "harvest" | "has lexical unit" |  | "FN" |  |
| fn:food_gathering | fn:HasLexicalUnit | fn:lu:food_gathering:bring_in | "food gathering" | "bring in" | "has lexical unit" |  | "FN" |  |
| fn:fe:gatherer | /r/IsA | fn:st:sentient | "gatherer" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:food_gathering | /r/HasA | fn:fe:gatherer | "food gathering" | "gatherer" | "/r/has a" |  | "FN" |  |
| fn:fe:crop | /r/IsA | fn:st:physical_entity | "crop" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:food_gathering | /r/HasA | fn:fe:crop | "food gathering" | "crop" | "/r/has a" |  | "FN" |  |
| fn:food_gathering | /r/HasA | fn:fe:duration | "food gathering" | "duration" | "/r/has a" |  | "FN" |  |
| fn:food_gathering | /r/HasA | fn:fe:manner | "food gathering" | "manner" | "/r/has a" |  | "FN" |  |
| fn:food_gathering | /r/HasA | fn:fe:means | "food gathering" | "means" | "/r/has a" |  | "FN" |  |
| fn:food_gathering | /r/HasA | fn:fe:place | "food gathering" | "place" | "/r/has a" |  | "FN" |  |
| fn:food_gathering | /r/HasA | fn:fe:time | "food gathering" | "time" | "/r/has a" |  | "FN" |  |
| fn:food_gathering | /r/HasA | fn:fe:purpose | "food gathering" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:food_gathering | /r/HasA | fn:fe:frequency | "food gathering" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:food_gathering | /r/HasA | fn:fe:particular_iteration | "food gathering" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:food_gathering | /r/HasA | fn:fe:source | "food gathering" | "source" | "/r/has a" |  | "FN" |  |
| fn:food_gathering | /r/HasA | fn:fe:circumstances | "food gathering" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:food_gathering | /r/HasA | fn:fe:degree | "food gathering" | "degree" | "/r/has a" |  | "FN" |  |
| fn:food_gathering | /r/HasA | fn:fe:beneficiary | "food gathering" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:foreign_or_domestic_country | /r/IsA | fn:political_locales | "foreign or domestic country" | "political locales" | "/r/is a" |  | "FN" |  |
| fn:foreign_or_domestic_country | /r/UsedFor | fn:indigenous_origin | "foreign or domestic country" | "indigenous origin" | "/r/used for" |  | "FN" |  |
| fn:foreign_or_domestic_country | fn:HasLexicalUnit | fn:lu:foreign_or_domestic_country:foreign | "foreign or domestic country" | "foreign" | "has lexical unit" |  | "FN" |  |
| fn:foreign_or_domestic_country | fn:HasLexicalUnit | fn:lu:foreign_or_domestic_country:domestic | "foreign or domestic country" | "domestic" | "has lexical unit" |  | "FN" |  |
| fn:foreign_or_domestic_country | fn:HasLexicalUnit | fn:lu:foreign_or_domestic_country:international | "foreign or domestic country" | "international" | "has lexical unit" |  | "FN" |  |
| fn:foreign_or_domestic_country | fn:HasLexicalUnit | fn:lu:foreign_or_domestic_country:home | "foreign or domestic country" | "home" | "has lexical unit" |  | "FN" |  |
| fn:foreign_or_domestic_country | fn:HasLexicalUnit | fn:lu:foreign_or_domestic_country:homeland | "foreign or domestic country" | "homeland" | "has lexical unit" |  | "FN" |  |
| fn:foreign_or_domestic_country | /r/HasA | fn:fe:constituent_parts | "foreign or domestic country" | "constituent parts" | "/r/has a" |  | "FN" |  |
| fn:foreign_or_domestic_country | /r/HasA | fn:fe:container_possessor | "foreign or domestic country" | "container possessor" | "/r/has a" |  | "FN" |  |
| fn:foreign_or_domestic_country | /r/HasA | fn:fe:current_country | "foreign or domestic country" | "current country" | "/r/has a" |  | "FN" |  |
| fn:foreign_or_domestic_country | /r/HasA | fn:fe:name | "foreign or domestic country" | "name" | "/r/has a" |  | "FN" |  |
| fn:foreign_or_domestic_country | /r/HasA | fn:fe:relative_location | "foreign or domestic country" | "relative location" | "/r/has a" |  | "FN" |  |
| fn:foreign_or_domestic_country | /r/HasA | fn:fe:descriptor | "foreign or domestic country" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:foreign_or_domestic_country | /r/HasA | fn:fe:population | "foreign or domestic country" | "population" | "/r/has a" |  | "FN" |  |
| fn:foreign_or_domestic_country | /r/HasA | fn:fe:discourse_salient_country | "foreign or domestic country" | "discourse salient country" | "/r/has a" |  | "FN" |  |
| fn:forging | /r/IsA | fn:duplication | "forging" | "duplication" | "/r/is a" |  | "FN" |  |
| fn:artificiality | /r/UsedFor | fn:forging | "artificiality" | "forging" | "/r/used for" |  | "FN" |  |
| fn:feigning | /r/SimilarTo | fn:forging | "feigning" | "forging" | "/r/similar to" |  | "FN" |  |
| fn:forging | fn:HasLexicalUnit | fn:lu:forging:falsify | "forging" | "falsify" | "has lexical unit" |  | "FN" |  |
| fn:forging | fn:HasLexicalUnit | fn:lu:forging:counterfeit | "forging" | "counterfeit" | "has lexical unit" |  | "FN" |  |
| fn:forging | fn:HasLexicalUnit | fn:lu:forging:forge | "forging" | "forge" | "has lexical unit" |  | "FN" |  |
| fn:forging | fn:HasLexicalUnit | fn:lu:forging:fake | "forging" | "fake" | "has lexical unit" |  | "FN" |  |
| fn:forging | fn:HasLexicalUnit | fn:lu:forging:forgery_[act] | "forging" | "forgery [act]" | "has lexical unit" |  | "FN" |  |
| fn:forging | fn:HasLexicalUnit | fn:lu:forging:forgery_[entity] | "forging" | "forgery [entity]" | "has lexical unit" |  | "FN" |  |
| fn:forging | fn:HasLexicalUnit | fn:lu:forging:fake | "forging" | "fake" | "has lexical unit" |  | "FN" |  |
| fn:forging | /r/HasA | fn:fe:agent | "forging" | "agent" | "/r/has a" |  | "FN" |  |
| fn:forging | /r/HasA | fn:fe:forgery | "forging" | "forgery" | "/r/has a" |  | "FN" |  |
| fn:forging | /r/HasA | fn:fe:manner | "forging" | "manner" | "/r/has a" |  | "FN" |  |
| fn:forging | /r/HasA | fn:fe:means | "forging" | "means" | "/r/has a" |  | "FN" |  |
| fn:forging | /r/HasA | fn:fe:degree | "forging" | "degree" | "/r/has a" |  | "FN" |  |
| fn:forging | /r/HasA | fn:fe:explanation | "forging" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:forging | /r/HasA | fn:fe:purpose | "forging" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:forging | /r/HasA | fn:fe:standard | "forging" | "standard" | "/r/has a" |  | "FN" |  |
| fn:forging | /r/HasA | fn:fe:instrument | "forging" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:forging | /r/HasA | fn:fe:place | "forging" | "place" | "/r/has a" |  | "FN" |  |
| fn:forging | /r/HasA | fn:fe:time | "forging" | "time" | "/r/has a" |  | "FN" |  |
| fn:forging | /r/HasA | fn:fe:fidelity | "forging" | "fidelity" | "/r/has a" |  | "FN" |  |
| fn:forging | /r/HasA | fn:fe:source | "forging" | "source" | "/r/has a" |  | "FN" |  |
| fn:emotions | /r/UsedFor | fn:forgiveness | "emotions" | "forgiveness" | "/r/used for" |  | "FN" |  |
| fn:forgiveness | /r/UsedFor | fn:atonement | "forgiveness" | "atonement" | "/r/used for" |  | "FN" |  |
| fn:forgiveness | fn:HasLexicalUnit | fn:lu:forgiveness:forgive | "forgiveness" | "forgive" | "has lexical unit" |  | "FN" |  |
| fn:forgiveness | fn:HasLexicalUnit | fn:lu:forgiveness:forgiveness | "forgiveness" | "forgiveness" | "has lexical unit" |  | "FN" |  |
| fn:forgiveness | fn:HasLexicalUnit | fn:lu:forgiveness:excuse | "forgiveness" | "excuse" | "has lexical unit" |  | "FN" |  |
| fn:forgiveness | fn:HasLexicalUnit | fn:lu:forgiveness:pardon | "forgiveness" | "pardon" | "has lexical unit" |  | "FN" |  |
| fn:forgiveness | fn:HasLexicalUnit | fn:lu:forgiveness:condone | "forgiveness" | "condone" | "has lexical unit" |  | "FN" |  |
| fn:forgiveness | /r/HasA | fn:fe:judge | "forgiveness" | "judge" | "/r/has a" |  | "FN" |  |
| fn:forgiveness | /r/HasA | fn:fe:evaluee | "forgiveness" | "evaluee" | "/r/has a" |  | "FN" |  |
| fn:forgiveness | /r/HasA | fn:fe:offense | "forgiveness" | "offense" | "/r/has a" |  | "FN" |  |
| fn:forgoing | /r/UsedFor | fn:holding_off_on | "forgoing" | "holding off on" | "/r/used for" |  | "FN" |  |
| fn:avoiding | /r/SimilarTo | fn:forgoing | "avoiding" | "forgoing" | "/r/similar to" |  | "FN" |  |
| fn:forgoing | fn:HasLexicalUnit | fn:lu:forgoing:forgo | "forgoing" | "forgo" | "has lexical unit" |  | "FN" |  |
| fn:forgoing | fn:HasLexicalUnit | fn:lu:forgoing:skip | "forgoing" | "skip" | "has lexical unit" |  | "FN" |  |
| fn:forgoing | fn:HasLexicalUnit | fn:lu:forgoing:abstain | "forgoing" | "abstain" | "has lexical unit" |  | "FN" |  |
| fn:forgoing | fn:HasLexicalUnit | fn:lu:forgoing:abstention | "forgoing" | "abstention" | "has lexical unit" |  | "FN" |  |
| fn:forgoing | fn:HasLexicalUnit | fn:lu:forgoing:abstinence | "forgoing" | "abstinence" | "has lexical unit" |  | "FN" |  |
| fn:forgoing | fn:HasLexicalUnit | fn:lu:forgoing:forbear | "forgoing" | "forbear" | "has lexical unit" |  | "FN" |  |
| fn:forgoing | fn:HasLexicalUnit | fn:lu:forgoing:refrain | "forgoing" | "refrain" | "has lexical unit" |  | "FN" |  |
| fn:forgoing | fn:HasLexicalUnit | fn:lu:forgoing:forbearance | "forgoing" | "forbearance" | "has lexical unit" |  | "FN" |  |
| fn:forgoing | fn:HasLexicalUnit | fn:lu:forgoing:forbearing | "forgoing" | "forbearing" | "has lexical unit" |  | "FN" |  |
| fn:forgoing | fn:HasLexicalUnit | fn:lu:forgoing:do_without | "forgoing" | "do without" | "has lexical unit" |  | "FN" |  |
| fn:forgoing | fn:HasLexicalUnit | fn:lu:forgoing:go_without | "forgoing" | "go without" | "has lexical unit" |  | "FN" |  |
| fn:forgoing | /r/HasA | fn:fe:forgoer | "forgoing" | "forgoer" | "/r/has a" |  | "FN" |  |
| fn:forgoing | /r/HasA | fn:fe:desirable | "forgoing" | "desirable" | "/r/has a" |  | "FN" |  |
| fn:forgoing | /r/HasA | fn:fe:degree | "forgoing" | "degree" | "/r/has a" |  | "FN" |  |
| fn:forgoing | /r/HasA | fn:fe:manner | "forgoing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:forgoing | /r/HasA | fn:fe:means | "forgoing" | "means" | "/r/has a" |  | "FN" |  |
| fn:forgoing | /r/HasA | fn:fe:place | "forgoing" | "place" | "/r/has a" |  | "FN" |  |
| fn:forgoing | /r/HasA | fn:fe:time | "forgoing" | "time" | "/r/has a" |  | "FN" |  |
| fn:forgoing | /r/HasA | fn:fe:purpose | "forgoing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:forgoing | /r/HasA | fn:fe:explanation | "forgoing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:forgoing | /r/HasA | fn:fe:circumstances | "forgoing" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:forming_relationships | /r/IsA | fn:intentionally_act | "forming relationships" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:personal_relationship | /r/SimilarTo | fn:forming_relationships | "personal relationship" | "forming relationships" | "/r/similar to" |  | "FN" |  |
| fn:traversing | /r/SimilarTo | fn:forming_relationships | "traversing" | "forming relationships" | "/r/similar to" |  | "FN" |  |
| fn:forming_relationships | /r/Causes | fn:personal_relationship | "forming relationships" | "personal relationship" | "/r/causes" |  | "FN" |  |
| fn:forming_relationships | fn:HasLexicalUnit | fn:lu:forming_relationships:befriend | "forming relationships" | "befriend" | "has lexical unit" |  | "FN" |  |
| fn:forming_relationships | fn:HasLexicalUnit | fn:lu:forming_relationships:woo | "forming relationships" | "woo" | "has lexical unit" |  | "FN" |  |
| fn:forming_relationships | fn:HasLexicalUnit | fn:lu:forming_relationships:betrothal | "forming relationships" | "betrothal" | "has lexical unit" |  | "FN" |  |
| fn:forming_relationships | fn:HasLexicalUnit | fn:lu:forming_relationships:betroth | "forming relationships" | "betroth" | "has lexical unit" |  | "FN" |  |
| fn:forming_relationships | fn:HasLexicalUnit | fn:lu:forming_relationships:divorce | "forming relationships" | "divorce" | "has lexical unit" |  | "FN" |  |
| fn:forming_relationships | fn:HasLexicalUnit | fn:lu:forming_relationships:divorce | "forming relationships" | "divorce" | "has lexical unit" |  | "FN" |  |
| fn:forming_relationships | fn:HasLexicalUnit | fn:lu:forming_relationships:leave | "forming relationships" | "leave" | "has lexical unit" |  | "FN" |  |
| fn:forming_relationships | fn:HasLexicalUnit | fn:lu:forming_relationships:marriage | "forming relationships" | "marriage" | "has lexical unit" |  | "FN" |  |
| fn:forming_relationships | fn:HasLexicalUnit | fn:lu:forming_relationships:marry | "forming relationships" | "marry" | "has lexical unit" |  | "FN" |  |
| fn:forming_relationships | fn:HasLexicalUnit | fn:lu:forming_relationships:marry_(into) | "forming relationships" | "marry (into)" | "has lexical unit" |  | "FN" |  |
| fn:forming_relationships | fn:HasLexicalUnit | fn:lu:forming_relationships:separate | "forming relationships" | "separate" | "has lexical unit" |  | "FN" |  |
| fn:forming_relationships | fn:HasLexicalUnit | fn:lu:forming_relationships:separation | "forming relationships" | "separation" | "has lexical unit" |  | "FN" |  |
| fn:forming_relationships | fn:HasLexicalUnit | fn:lu:forming_relationships:tie_the_knot | "forming relationships" | "tie the knot" | "has lexical unit" |  | "FN" |  |
| fn:forming_relationships | fn:HasLexicalUnit | fn:lu:forming_relationships:wed | "forming relationships" | "wed" | "has lexical unit" |  | "FN" |  |
| fn:forming_relationships | fn:HasLexicalUnit | fn:lu:forming_relationships:wedding | "forming relationships" | "wedding" | "has lexical unit" |  | "FN" |  |
| fn:forming_relationships | fn:HasLexicalUnit | fn:lu:forming_relationships:marriage_(into) | "forming relationships" | "marriage (into)" | "has lexical unit" |  | "FN" |  |
| fn:forming_relationships | fn:HasLexicalUnit | fn:lu:forming_relationships:engagement | "forming relationships" | "engagement" | "has lexical unit" |  | "FN" |  |
| fn:forming_relationships | /r/HasA | fn:fe:partner_1 | "forming relationships" | "partner 1" | "/r/has a" |  | "FN" |  |
| fn:forming_relationships | /r/HasA | fn:fe:partner_2 | "forming relationships" | "partner 2" | "/r/has a" |  | "FN" |  |
| fn:forming_relationships | /r/HasA | fn:fe:partners | "forming relationships" | "partners" | "/r/has a" |  | "FN" |  |
| fn:forming_relationships | /r/HasA | fn:fe:means | "forming relationships" | "means" | "/r/has a" |  | "FN" |  |
| fn:forming_relationships | /r/HasA | fn:fe:time | "forming relationships" | "time" | "/r/has a" |  | "FN" |  |
| fn:forming_relationships | /r/HasA | fn:fe:manner | "forming relationships" | "manner" | "/r/has a" |  | "FN" |  |
| fn:forming_relationships | /r/HasA | fn:fe:depictive | "forming relationships" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:forming_relationships | /r/HasA | fn:fe:duration_of_final_state | "forming relationships" | "duration of final state" | "/r/has a" |  | "FN" |  |
| fn:forming_relationships | /r/HasA | fn:fe:place | "forming relationships" | "place" | "/r/has a" |  | "FN" |  |
| fn:forming_relationships | /r/HasA | fn:fe:purpose | "forming relationships" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:forming_relationships | /r/HasA | fn:fe:communicative_force | "forming relationships" | "communicative force" | "/r/has a" |  | "FN" |  |
| fn:forming_relationships | /r/HasA | fn:fe:frequency | "forming relationships" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:forming_relationships | /r/HasA | fn:fe:circumstances | "forming relationships" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:forming_relationships | /r/HasA | fn:fe:explanation | "forming relationships" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:forming_relationships | /r/HasA | fn:fe:iterations | "forming relationships" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:fragmentation_scenario | /r/IsA | fn:becoming_separated | "fragmentation scenario" | "becoming separated" | "/r/is a" |  | "FN" |  |
| fn:breaking_apart | /r/IsA | fn:fragmentation_scenario | "breaking apart" | "fragmentation scenario" | "/r/is a" |  | "FN" |  |
| fn:breaking_off | /r/IsA | fn:fragmentation_scenario | "breaking off" | "fragmentation scenario" | "/r/is a" |  | "FN" |  |
| fn:fragmentation_scenario | /r/HasA | fn:fe:whole | "fragmentation scenario" | "whole" | "/r/has a" |  | "FN" |  |
| fn:fragmentation_scenario | /r/HasA | fn:fe:parts | "fragmentation scenario" | "parts" | "/r/has a" |  | "FN" |  |
| fn:fragmentation_scenario | /r/HasA | fn:fe:part_1 | "fragmentation scenario" | "part 1" | "/r/has a" |  | "FN" |  |
| fn:fragmentation_scenario | /r/HasA | fn:fe:part_2 | "fragmentation scenario" | "part 2" | "/r/has a" |  | "FN" |  |
| fn:fragmentation_scenario | /r/HasA | fn:fe:criterion | "fragmentation scenario" | "criterion" | "/r/has a" |  | "FN" |  |
| fn:fragmentation_scenario | /r/HasA | fn:fe:depictive | "fragmentation scenario" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:fragmentation_scenario | /r/HasA | fn:fe:manner | "fragmentation scenario" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fragmentation_scenario | /r/HasA | fn:fe:degree | "fragmentation scenario" | "degree" | "/r/has a" |  | "FN" |  |
| fn:fragmentation_scenario | /r/HasA | fn:fe:result | "fragmentation scenario" | "result" | "/r/has a" |  | "FN" |  |
| fn:fragmentation_scenario | /r/HasA | fn:fe:time | "fragmentation scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:fragmentation_scenario | /r/HasA | fn:fe:place | "fragmentation scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:fragmentation_scenario | /r/HasA | fn:fe:resistant_surface | "fragmentation scenario" | "resistant surface" | "/r/has a" |  | "FN" |  |
| fn:fragmentation_scenario | /r/HasA | fn:fe:means | "fragmentation scenario" | "means" | "/r/has a" |  | "FN" |  |
| fn:releasing | /r/UsedFor | fn:freeing_from_confinement | "releasing" | "freeing from confinement" | "/r/used for" |  | "FN" |  |
| fn:freeing_from_confinement | fn:HasLexicalUnit | fn:lu:freeing_from_confinement:spring | "freeing from confinement" | "spring" | "has lexical unit" |  | "FN" |  |
| fn:freeing_from_confinement | /r/HasA | fn:fe:agent | "freeing from confinement" | "agent" | "/r/has a" |  | "FN" |  |
| fn:freeing_from_confinement | /r/HasA | fn:fe:theme | "freeing from confinement" | "theme" | "/r/has a" |  | "FN" |  |
| fn:freeing_from_confinement | /r/HasA | fn:fe:manner | "freeing from confinement" | "manner" | "/r/has a" |  | "FN" |  |
| fn:freeing_from_confinement | /r/HasA | fn:fe:means | "freeing from confinement" | "means" | "/r/has a" |  | "FN" |  |
| fn:freeing_from_confinement | /r/HasA | fn:fe:explanation | "freeing from confinement" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:freeing_from_confinement | /r/HasA | fn:fe:purpose | "freeing from confinement" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:freeing_from_confinement | /r/HasA | fn:fe:place | "freeing from confinement" | "place" | "/r/has a" |  | "FN" |  |
| fn:freeing_from_confinement | /r/HasA | fn:fe:time | "freeing from confinement" | "time" | "/r/has a" |  | "FN" |  |
| fn:freeing_from_confinement | /r/HasA | fn:fe:location_of_confinement | "freeing from confinement" | "location of confinement" | "/r/has a" |  | "FN" |  |
| fn:freeing_from_confinement | /r/HasA | fn:fe:concessive | "freeing from confinement" | "concessive" | "/r/has a" |  | "FN" |  |
| fn:freeing_from_confinement | /r/HasA | fn:fe:circumstances | "freeing from confinement" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:frequency | /r/IsA | fn:gradable_attributes | "frequency" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:event | /r/UsedFor | fn:frequency | "event" | "frequency" | "/r/used for" |  | "FN" |  |
| fn:frequency | /r/UsedFor | fn:custom | "frequency" | "custom" | "/r/used for" |  | "FN" |  |
| fn:calendric_unit | /r/RelatedTo | fn:frequency | "calendric unit" | "frequency" | "/r/related to" |  | "FN" |  |
| fn:frequency | /r/SimilarTo | fn:event_instance | "frequency" | "event instance" | "/r/similar to" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:annual | "frequency" | "annual" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:bi-annual | "frequency" | "bi-annual" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:bi-monthly | "frequency" | "bi-monthly" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:biennial | "frequency" | "biennial" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:daily | "frequency" | "daily" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:fortnightly | "frequency" | "fortnightly" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:frequent | "frequency" | "frequent" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:infrequent | "frequency" | "infrequent" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:intermittent | "frequency" | "intermittent" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:monthly | "frequency" | "monthly" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:nightly | "frequency" | "nightly" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:occasional | "frequency" | "occasional" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:periodic | "frequency" | "periodic" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:recurrent | "frequency" | "recurrent" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:recurring | "frequency" | "recurring" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:sporadic | "frequency" | "sporadic" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:weekly | "frequency" | "weekly" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:yearly | "frequency" | "yearly" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:interval | "frequency" | "interval" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:period | "frequency" | "period" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:sometime | "frequency" | "sometime" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:on_and_off | "frequency" | "on and off" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:off_and_on | "frequency" | "off and on" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:frequency | "frequency" | "frequency" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:always | "frequency" | "always" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:time_to_time | "frequency" | "time to time" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:never | "frequency" | "never" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:often | "frequency" | "often" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:frequently | "frequency" | "frequently" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:infrequently | "frequency" | "infrequently" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:occasionally | "frequency" | "occasionally" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:sometimes | "frequency" | "sometimes" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:every | "frequency" | "every" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:all_the_time | "frequency" | "all the time" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:once_in_a_while | "frequency" | "once in a while" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:every_once_in_a_while | "frequency" | "every once in a while" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:at_times | "frequency" | "at times" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:constantly | "frequency" | "constantly" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:rare | "frequency" | "rare" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:regularly | "frequency" | "regularly" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:daily | "frequency" | "daily" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:seldom | "frequency" | "seldom" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:usually | "frequency" | "usually" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:normally | "frequency" | "normally" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:in_general | "frequency" | "in general" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:generally | "frequency" | "generally" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:ordinarily | "frequency" | "ordinarily" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:every_so_often | "frequency" | "every so often" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:now_and_then | "frequency" | "now and then" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:common | "frequency" | "common" | "has lexical unit" |  | "FN" |  |
| fn:frequency | fn:HasLexicalUnit | fn:lu:frequency:recurrence | "frequency" | "recurrence" | "has lexical unit" |  | "FN" |  |
| fn:fe:event | /r/RelatedTo | fn:fe:salient_entity | "event" | "salient entity" | "/r/related to" |  | "FN" |  |
| fn:frequency | /r/HasA | fn:fe:event | "frequency" | "event" | "/r/has a" |  | "FN" |  |
| fn:frequency | /r/HasA | fn:fe:degree | "frequency" | "degree" | "/r/has a" |  | "FN" |  |
| fn:fe:interval | /r/RelatedTo | fn:fe:salient_entity | "interval" | "salient entity" | "/r/related to" |  | "FN" |  |
| fn:frequency | /r/HasA | fn:fe:interval | "frequency" | "interval" | "/r/has a" |  | "FN" |  |
| fn:frequency | /r/HasA | fn:fe:time_span | "frequency" | "time span" | "/r/has a" |  | "FN" |  |
| fn:fe:rate | /r/RelatedTo | fn:fe:degree | "rate" | "degree" | "/r/related to" |  | "FN" |  |
| fn:frequency | /r/HasA | fn:fe:rate | "frequency" | "rate" | "/r/has a" |  | "FN" |  |
| fn:frequency | /r/HasA | fn:fe:salient_entity | "frequency" | "salient entity" | "/r/has a" |  | "FN" |  |
| fn:frequency | /r/HasA | fn:fe:attribute | "frequency" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:frequency | /r/HasA | fn:fe:time | "frequency" | "time" | "/r/has a" |  | "FN" |  |
| fn:frequency | /r/HasA | fn:fe:group | "frequency" | "group" | "/r/has a" |  | "FN" |  |
| fn:impact | /r/UsedFor | fn:friction | "impact" | "friction" | "/r/used for" |  | "FN" |  |
| fn:make_noise | /r/RelatedTo | fn:friction | "make noise" | "friction" | "/r/related to" |  | "FN" |  |
| fn:make_noise | /r/SimilarTo | fn:friction | "make noise" | "friction" | "/r/similar to" |  | "FN" |  |
| fn:friction | fn:HasLexicalUnit | fn:lu:friction:grate | "friction" | "grate" | "has lexical unit" |  | "FN" |  |
| fn:friction | fn:HasLexicalUnit | fn:lu:friction:squeal | "friction" | "squeal" | "has lexical unit" |  | "FN" |  |
| fn:friction | fn:HasLexicalUnit | fn:lu:friction:scrunch | "friction" | "scrunch" | "has lexical unit" |  | "FN" |  |
| fn:friction | fn:HasLexicalUnit | fn:lu:friction:screech | "friction" | "screech" | "has lexical unit" |  | "FN" |  |
| fn:friction | fn:HasLexicalUnit | fn:lu:friction:scrape | "friction" | "scrape" | "has lexical unit" |  | "FN" |  |
| fn:friction | fn:HasLexicalUnit | fn:lu:friction:rasp | "friction" | "rasp" | "has lexical unit" |  | "FN" |  |
| fn:fe:theme | /r/HasPrerequisite | fn:fe:static_object | "theme" | "static object" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:theme | /r/RelatedTo | fn:fe:themes | "theme" | "themes" | "/r/related to" |  | "FN" |  |
| fn:friction | /r/HasA | fn:fe:theme | "friction" | "theme" | "/r/has a" |  | "FN" |  |
| fn:fe:static_object | /r/HasPrerequisite | fn:fe:theme | "static object" | "theme" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:static_object | /r/RelatedTo | fn:fe:themes | "static object" | "themes" | "/r/related to" |  | "FN" |  |
| fn:friction | /r/HasA | fn:fe:static_object | "friction" | "static object" | "/r/has a" |  | "FN" |  |
| fn:friction | /r/HasA | fn:fe:themes | "friction" | "themes" | "/r/has a" |  | "FN" |  |
| fn:friction | /r/HasA | fn:fe:manner | "friction" | "manner" | "/r/has a" |  | "FN" |  |
| fn:friction | /r/HasA | fn:fe:place | "friction" | "place" | "/r/has a" |  | "FN" |  |
| fn:friction | /r/HasA | fn:fe:degree | "friction" | "degree" | "/r/has a" |  | "FN" |  |
| fn:hostile_encounter | /r/UsedFor | fn:friendly_or_hostile | "hostile encounter" | "friendly or hostile" | "/r/used for" |  | "FN" |  |
| fn:friendly_or_hostile | fn:HasLexicalUnit | fn:lu:friendly_or_hostile:friendly | "friendly or hostile" | "friendly" | "has lexical unit" |  | "FN" |  |
| fn:friendly_or_hostile | fn:HasLexicalUnit | fn:lu:friendly_or_hostile:hostile | "friendly or hostile" | "hostile" | "has lexical unit" |  | "FN" |  |
| fn:friendly_or_hostile | fn:HasLexicalUnit | fn:lu:friendly_or_hostile:friendly | "friendly or hostile" | "friendly" | "has lexical unit" |  | "FN" |  |
| fn:friendly_or_hostile | fn:HasLexicalUnit | fn:lu:friendly_or_hostile:hostile | "friendly or hostile" | "hostile" | "has lexical unit" |  | "FN" |  |
| fn:friendly_or_hostile | fn:HasLexicalUnit | fn:lu:friendly_or_hostile:enemy | "friendly or hostile" | "enemy" | "has lexical unit" |  | "FN" |  |
| fn:fe:side_1 | /r/IsA | fn:st:sentient | "side 1" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:fe:side_1 | /r/HasPrerequisite | fn:fe:side_2 | "side 1" | "side 2" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:side_1 | /r/RelatedTo | fn:fe:sides | "side 1" | "sides" | "/r/related to" |  | "FN" |  |
| fn:friendly_or_hostile | /r/HasA | fn:fe:side_1 | "friendly or hostile" | "side 1" | "/r/has a" |  | "FN" |  |
| fn:fe:side_2 | /r/HasPrerequisite | fn:fe:side_1 | "side 2" | "side 1" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:side_2 | /r/RelatedTo | fn:fe:sides | "side 2" | "sides" | "/r/related to" |  | "FN" |  |
| fn:friendly_or_hostile | /r/HasA | fn:fe:side_2 | "friendly or hostile" | "side 2" | "/r/has a" |  | "FN" |  |
| fn:friendly_or_hostile | /r/HasA | fn:fe:degree | "friendly or hostile" | "degree" | "/r/has a" |  | "FN" |  |
| fn:friendly_or_hostile | /r/HasA | fn:fe:time | "friendly or hostile" | "time" | "/r/has a" |  | "FN" |  |
| fn:friendly_or_hostile | /r/HasA | fn:fe:explanation | "friendly or hostile" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:friendly_or_hostile | /r/HasA | fn:fe:descriptor | "friendly or hostile" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:friendly_or_hostile | /r/HasA | fn:fe:concessive | "friendly or hostile" | "concessive" | "/r/has a" |  | "FN" |  |
| fn:friendly_or_hostile | /r/HasA | fn:fe:place | "friendly or hostile" | "place" | "/r/has a" |  | "FN" |  |
| fn:friendly_or_hostile | /r/HasA | fn:fe:sides | "friendly or hostile" | "sides" | "/r/has a" |  | "FN" |  |
| fn:front_for | /r/IsA | fn:intentionally_act | "front for" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:posing_as | /r/UsedFor | fn:front_for | "posing as" | "front for" | "/r/used for" |  | "FN" |  |
| fn:prevarication | /r/UsedFor | fn:front_for | "prevarication" | "front for" | "/r/used for" |  | "FN" |  |
| fn:front_for | fn:HasLexicalUnit | fn:lu:front_for:front | "front for" | "front" | "has lexical unit" |  | "FN" |  |
| fn:front_for | fn:HasLexicalUnit | fn:lu:front_for:front | "front for" | "front" | "has lexical unit" |  | "FN" |  |
| fn:front_for | fn:HasLexicalUnit | fn:lu:front_for:blind | "front for" | "blind" | "has lexical unit" |  | "FN" |  |
| fn:front_for | /r/HasA | fn:fe:front | "front for" | "front" | "/r/has a" |  | "FN" |  |
| fn:fe:illicit_organization | /r/RelatedTo | fn:fe:illicit_activity | "illicit organization" | "illicit activity" | "/r/related to" |  | "FN" |  |
| fn:front_for | /r/HasA | fn:fe:illicit_organization | "front for" | "illicit organization" | "/r/has a" |  | "FN" |  |
| fn:fe:illicit_activity | /r/RelatedTo | fn:fe:illicit_organization | "illicit activity" | "illicit organization" | "/r/related to" |  | "FN" |  |
| fn:front_for | /r/HasA | fn:fe:illicit_activity | "front for" | "illicit activity" | "/r/has a" |  | "FN" |  |
| fn:front_for | /r/HasA | fn:fe:time | "front for" | "time" | "/r/has a" |  | "FN" |  |
| fn:front_for | /r/HasA | fn:fe:purpose | "front for" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:front_for | /r/HasA | fn:fe:place | "front for" | "place" | "/r/has a" |  | "FN" |  |
| fn:front_for | /r/HasA | fn:fe:means | "front for" | "means" | "/r/has a" |  | "FN" |  |
| fn:front_for | /r/HasA | fn:fe:manner | "front for" | "manner" | "/r/has a" |  | "FN" |  |
| fn:frugality | /r/IsA | fn:social_behavior_evaluation | "frugality" | "social behavior evaluation" | "/r/is a" |  | "FN" |  |
| fn:frugality | /r/SimilarTo | fn:stinginess | "frugality" | "stinginess" | "/r/similar to" |  | "FN" |  |
| fn:frugality | fn:HasLexicalUnit | fn:lu:frugality:austere | "frugality" | "austere" | "has lexical unit" |  | "FN" |  |
| fn:frugality | fn:HasLexicalUnit | fn:lu:frugality:economical | "frugality" | "economical" | "has lexical unit" |  | "FN" |  |
| fn:frugality | fn:HasLexicalUnit | fn:lu:frugality:extravagant | "frugality" | "extravagant" | "has lexical unit" |  | "FN" |  |
| fn:frugality | fn:HasLexicalUnit | fn:lu:frugality:frugal | "frugality" | "frugal" | "has lexical unit" |  | "FN" |  |
| fn:frugality | fn:HasLexicalUnit | fn:lu:frugality:parsimonious | "frugality" | "parsimonious" | "has lexical unit" |  | "FN" |  |
| fn:frugality | fn:HasLexicalUnit | fn:lu:frugality:sparing | "frugality" | "sparing" | "has lexical unit" |  | "FN" |  |
| fn:frugality | fn:HasLexicalUnit | fn:lu:frugality:thrifty | "frugality" | "thrifty" | "has lexical unit" |  | "FN" |  |
| fn:frugality | fn:HasLexicalUnit | fn:lu:frugality:austerity | "frugality" | "austerity" | "has lexical unit" |  | "FN" |  |
| fn:frugality | fn:HasLexicalUnit | fn:lu:frugality:penny-wise | "frugality" | "penny-wise" | "has lexical unit" |  | "FN" |  |
| fn:frugality | fn:HasLexicalUnit | fn:lu:frugality:spendthrift | "frugality" | "spendthrift" | "has lexical unit" |  | "FN" |  |
| fn:frugality | fn:HasLexicalUnit | fn:lu:frugality:thrift | "frugality" | "thrift" | "has lexical unit" |  | "FN" |  |
| fn:frugality | fn:HasLexicalUnit | fn:lu:frugality:squander | "frugality" | "squander" | "has lexical unit" |  | "FN" |  |
| fn:frugality | fn:HasLexicalUnit | fn:lu:frugality:spartan | "frugality" | "spartan" | "has lexical unit" |  | "FN" |  |
| fn:frugality | fn:HasLexicalUnit | fn:lu:frugality:profligate | "frugality" | "profligate" | "has lexical unit" |  | "FN" |  |
| fn:frugality | fn:HasLexicalUnit | fn:lu:frugality:profligacy | "frugality" | "profligacy" | "has lexical unit" |  | "FN" |  |
| fn:frugality | fn:HasLexicalUnit | fn:lu:frugality:frugality | "frugality" | "frugality" | "has lexical unit" |  | "FN" |  |
| fn:frugality | fn:HasLexicalUnit | fn:lu:frugality:parsimony | "frugality" | "parsimony" | "has lexical unit" |  | "FN" |  |
| fn:frugality | fn:HasLexicalUnit | fn:lu:frugality:waste | "frugality" | "waste" | "has lexical unit" |  | "FN" |  |
| fn:frugality | fn:HasLexicalUnit | fn:lu:frugality:husband | "frugality" | "husband" | "has lexical unit" |  | "FN" |  |
| fn:frugality | fn:HasLexicalUnit | fn:lu:frugality:wasteful | "frugality" | "wasteful" | "has lexical unit" |  | "FN" |  |
| fn:frugality | fn:HasLexicalUnit | fn:lu:frugality:scrimp | "frugality" | "scrimp" | "has lexical unit" |  | "FN" |  |
| fn:frugality | fn:HasLexicalUnit | fn:lu:frugality:economy | "frugality" | "economy" | "has lexical unit" |  | "FN" |  |
| fn:frugality | /r/HasA | fn:fe:resource_controller | "frugality" | "resource controller" | "/r/has a" |  | "FN" |  |
| fn:frugality | /r/HasA | fn:fe:behavior | "frugality" | "behavior" | "/r/has a" |  | "FN" |  |
| fn:frugality | /r/HasA | fn:fe:resource | "frugality" | "resource" | "/r/has a" |  | "FN" |  |
| fn:frugality | /r/HasA | fn:fe:degree | "frugality" | "degree" | "/r/has a" |  | "FN" |  |
| fn:frugality | /r/HasA | fn:fe:judge | "frugality" | "judge" | "/r/has a" |  | "FN" |  |
| fn:being_incarcerated | /r/UsedFor | fn:fugitive | "being incarcerated" | "fugitive" | "/r/used for" |  | "FN" |  |
| fn:fugitive | fn:HasLexicalUnit | fn:lu:fugitive:fugitive | "fugitive" | "fugitive" | "has lexical unit" |  | "FN" |  |
| fn:fugitive | fn:HasLexicalUnit | fn:lu:fugitive:on_the_lam | "fugitive" | "on the lam" | "has lexical unit" |  | "FN" |  |
| fn:fugitive | fn:HasLexicalUnit | fn:lu:fugitive:on_the_run | "fugitive" | "on the run" | "has lexical unit" |  | "FN" |  |
| fn:fugitive | fn:HasLexicalUnit | fn:lu:fugitive:lamster | "fugitive" | "lamster" | "has lexical unit" |  | "FN" |  |
| fn:fugitive | fn:HasLexicalUnit | fn:lu:fugitive:on_the_loose | "fugitive" | "on the loose" | "has lexical unit" |  | "FN" |  |
| fn:fe:fugitive | /r/IsA | fn:st:human | "fugitive" | "human" | "/r/is a" |  | "FN" |  |
| fn:fugitive | /r/HasA | fn:fe:fugitive | "fugitive" | "fugitive" | "/r/has a" |  | "FN" |  |
| fn:fugitive | /r/HasA | fn:fe:prison | "fugitive" | "prison" | "/r/has a" |  | "FN" |  |
| fn:fugitive | /r/HasA | fn:fe:authorities | "fugitive" | "authorities" | "/r/has a" |  | "FN" |  |
| fn:fugitive | /r/HasA | fn:fe:crime | "fugitive" | "crime" | "/r/has a" |  | "FN" |  |
| fn:fugitive | /r/HasA | fn:fe:place | "fugitive" | "place" | "/r/has a" |  | "FN" |  |
| fn:fugitive | /r/HasA | fn:fe:time | "fugitive" | "time" | "/r/has a" |  | "FN" |  |
| fn:fugitive | /r/HasA | fn:fe:manner | "fugitive" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fugitive | /r/HasA | fn:fe:explanation | "fugitive" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:fugitive | /r/HasA | fn:fe:duration | "fugitive" | "duration" | "/r/has a" |  | "FN" |  |
| fn:fullness | /r/IsA | fn:gradable_attributes | "fullness" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:containing | /r/UsedFor | fn:fullness | "containing" | "fullness" | "/r/used for" |  | "FN" |  |
| fn:filling | /r/Causes | fn:fullness | "filling" | "fullness" | "/r/causes" |  | "FN" |  |
| fn:fullness | fn:HasLexicalUnit | fn:lu:fullness:full | "fullness" | "full" | "has lexical unit" |  | "FN" |  |
| fn:fullness | fn:HasLexicalUnit | fn:lu:fullness:empty | "fullness" | "empty" | "has lexical unit" |  | "FN" |  |
| fn:fullness | fn:HasLexicalUnit | fn:lu:fullness:emptiness | "fullness" | "emptiness" | "has lexical unit" |  | "FN" |  |
| fn:fullness | fn:HasLexicalUnit | fn:lu:fullness:fullness | "fullness" | "fullness" | "has lexical unit" |  | "FN" |  |
| fn:fullness | /r/HasA | fn:fe:container | "fullness" | "container" | "/r/has a" |  | "FN" |  |
| fn:fullness | /r/HasA | fn:fe:contents | "fullness" | "contents" | "/r/has a" |  | "FN" |  |
| fn:fullness | /r/HasA | fn:fe:degree | "fullness" | "degree" | "/r/has a" |  | "FN" |  |
| fn:fullness | /r/HasA | fn:fe:time | "fullness" | "time" | "/r/has a" |  | "FN" |  |
| fn:fullness | /r/HasA | fn:fe:frequency | "fullness" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:fullness | /r/HasA | fn:fe:duration | "fullness" | "duration" | "/r/has a" |  | "FN" |  |
| fn:function | fn:HasLexicalUnit | fn:lu:function:serve | "function" | "serve" | "has lexical unit" |  | "FN" |  |
| fn:function | /r/HasA | fn:fe:entity | "function" | "entity" | "/r/has a" |  | "FN" |  |
| fn:function | /r/HasA | fn:fe:activity | "function" | "activity" | "/r/has a" |  | "FN" |  |
| fn:function | /r/HasA | fn:fe:role | "function" | "role" | "/r/has a" |  | "FN" |  |
| fn:function | /r/HasA | fn:fe:descriptor | "function" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:function | /r/HasA | fn:fe:duration | "function" | "duration" | "/r/has a" |  | "FN" |  |
| fn:function | /r/HasA | fn:fe:manner | "function" | "manner" | "/r/has a" |  | "FN" |  |
| fn:function | /r/HasA | fn:fe:means | "function" | "means" | "/r/has a" |  | "FN" |  |
| fn:funding | /r/IsA | fn:supply | "funding" | "supply" | "/r/is a" |  | "FN" |  |
| fn:funding | fn:HasLexicalUnit | fn:lu:funding:fund | "funding" | "fund" | "has lexical unit" |  | "FN" |  |
| fn:funding | fn:HasLexicalUnit | fn:lu:funding:finance | "funding" | "finance" | "has lexical unit" |  | "FN" |  |
| fn:funding | fn:HasLexicalUnit | fn:lu:funding:back | "funding" | "back" | "has lexical unit" |  | "FN" |  |
| fn:funding | fn:HasLexicalUnit | fn:lu:funding:bankroll | "funding" | "bankroll" | "has lexical unit" |  | "FN" |  |
| fn:funding | fn:HasLexicalUnit | fn:lu:funding:support | "funding" | "support" | "has lexical unit" |  | "FN" |  |
| fn:funding | /r/HasA | fn:fe:supplier | "funding" | "supplier" | "/r/has a" |  | "FN" |  |
| fn:funding | /r/HasA | fn:fe:recipient | "funding" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:funding | /r/HasA | fn:fe:imposed_purpose | "funding" | "imposed purpose" | "/r/has a" |  | "FN" |  |
| fn:funding | /r/HasA | fn:fe:circumstances | "funding" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:funding | /r/HasA | fn:fe:explanation | "funding" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:funding | /r/HasA | fn:fe:manner | "funding" | "manner" | "/r/has a" |  | "FN" |  |
| fn:funding | /r/HasA | fn:fe:means | "funding" | "means" | "/r/has a" |  | "FN" |  |
| fn:funding | /r/HasA | fn:fe:period_of_iterations | "funding" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:funding | /r/HasA | fn:fe:place | "funding" | "place" | "/r/has a" |  | "FN" |  |
| fn:funding | /r/HasA | fn:fe:source | "funding" | "source" | "/r/has a" |  | "FN" |  |
| fn:funding | /r/HasA | fn:fe:time | "funding" | "time" | "/r/has a" |  | "FN" |  |
| fn:funding | /r/HasA | fn:fe:money | "funding" | "money" | "/r/has a" |  | "FN" |  |
| fn:funding | /r/HasA | fn:fe:purpose | "funding" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:gathering_up | /r/IsA | fn:intentionally_affect | "gathering up" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:cause_motion | /r/UsedFor | fn:gathering_up | "cause motion" | "gathering up" | "/r/used for" |  | "FN" |  |
| fn:gathering_up | /r/SimilarTo | fn:come_together | "gathering up" | "come together" | "/r/similar to" |  | "FN" |  |
| fn:gathering_up | /r/Causes | fn:come_together | "gathering up" | "come together" | "/r/causes" |  | "FN" |  |
| fn:gathering_up | fn:HasLexicalUnit | fn:lu:gathering_up:assemble | "gathering up" | "assemble" | "has lexical unit" |  | "FN" |  |
| fn:gathering_up | fn:HasLexicalUnit | fn:lu:gathering_up:gather | "gathering up" | "gather" | "has lexical unit" |  | "FN" |  |
| fn:gathering_up | fn:HasLexicalUnit | fn:lu:gathering_up:bring_together | "gathering up" | "bring together" | "has lexical unit" |  | "FN" |  |
| fn:gathering_up | fn:HasLexicalUnit | fn:lu:gathering_up:convene | "gathering up" | "convene" | "has lexical unit" |  | "FN" |  |
| fn:gathering_up | fn:HasLexicalUnit | fn:lu:gathering_up:herd | "gathering up" | "herd" | "has lexical unit" |  | "FN" |  |
| fn:gathering_up | fn:HasLexicalUnit | fn:lu:gathering_up:collect | "gathering up" | "collect" | "has lexical unit" |  | "FN" |  |
| fn:gathering_up | fn:HasLexicalUnit | fn:lu:gathering_up:amass | "gathering up" | "amass" | "has lexical unit" |  | "FN" |  |
| fn:gathering_up | fn:HasLexicalUnit | fn:lu:gathering_up:round_up | "gathering up" | "round up" | "has lexical unit" |  | "FN" |  |
| fn:gathering_up | /r/HasA | fn:fe:aggregate | "gathering up" | "aggregate" | "/r/has a" |  | "FN" |  |
| fn:gathering_up | /r/HasA | fn:fe:agent | "gathering up" | "agent" | "/r/has a" |  | "FN" |  |
| fn:gathering_up | /r/HasA | fn:fe:time | "gathering up" | "time" | "/r/has a" |  | "FN" |  |
| fn:gathering_up | /r/HasA | fn:fe:means | "gathering up" | "means" | "/r/has a" |  | "FN" |  |
| fn:gathering_up | /r/HasA | fn:fe:place | "gathering up" | "place" | "/r/has a" |  | "FN" |  |
| fn:gathering_up | /r/HasA | fn:fe:individuals | "gathering up" | "individuals" | "/r/has a" |  | "FN" |  |
| fn:gathering_up | /r/HasA | fn:fe:manner | "gathering up" | "manner" | "/r/has a" |  | "FN" |  |
| fn:gathering_up | /r/HasA | fn:fe:instrument | "gathering up" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:gathering_up | /r/HasA | fn:fe:purpose | "gathering up" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:gathering_up | /r/HasA | fn:fe:frequency | "gathering up" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:gathering_up | /r/HasA | fn:fe:containing_event | "gathering up" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:gathering_up | /r/HasA | fn:fe:goal | "gathering up" | "goal" | "/r/has a" |  | "FN" |  |
| fn:gathering_up | /r/HasA | fn:fe:co-participant | "gathering up" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:gathering_up | /r/HasA | fn:fe:path | "gathering up" | "path" | "/r/has a" |  | "FN" |  |
| fn:gathering_up | /r/HasA | fn:fe:source | "gathering up" | "source" | "/r/has a" |  | "FN" |  |
| fn:gesture | /r/IsA | fn:communication | "gesture" | "communication" | "/r/is a" |  | "FN" |  |
| fn:gesture | fn:HasLexicalUnit | fn:lu:gesture:beckon | "gesture" | "beckon" | "has lexical unit" |  | "FN" |  |
| fn:gesture | fn:HasLexicalUnit | fn:lu:gesture:gesticulate | "gesture" | "gesticulate" | "has lexical unit" |  | "FN" |  |
| fn:gesture | fn:HasLexicalUnit | fn:lu:gesture:gesture | "gesture" | "gesture" | "has lexical unit" |  | "FN" |  |
| fn:gesture | fn:HasLexicalUnit | fn:lu:gesture:motion | "gesture" | "motion" | "has lexical unit" |  | "FN" |  |
| fn:gesture | fn:HasLexicalUnit | fn:lu:gesture:nod | "gesture" | "nod" | "has lexical unit" |  | "FN" |  |
| fn:gesture | fn:HasLexicalUnit | fn:lu:gesture:signal | "gesture" | "signal" | "has lexical unit" |  | "FN" |  |
| fn:gesture | fn:HasLexicalUnit | fn:lu:gesture:wave | "gesture" | "wave" | "has lexical unit" |  | "FN" |  |
| fn:gesture | fn:HasLexicalUnit | fn:lu:gesture:signal | "gesture" | "signal" | "has lexical unit" |  | "FN" |  |
| fn:gesture | /r/HasA | fn:fe:communicator | "gesture" | "communicator" | "/r/has a" |  | "FN" |  |
| fn:gesture | /r/HasA | fn:fe:addressee | "gesture" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:gesture | /r/HasA | fn:fe:message | "gesture" | "message" | "/r/has a" |  | "FN" |  |
| fn:gesture | /r/HasA | fn:fe:manner | "gesture" | "manner" | "/r/has a" |  | "FN" |  |
| fn:gesture | /r/HasA | fn:fe:means | "gesture" | "means" | "/r/has a" |  | "FN" |  |
| fn:gesture | /r/HasA | fn:fe:body_part | "gesture" | "body part" | "/r/has a" |  | "FN" |  |
| fn:gesture | /r/HasA | fn:fe:time | "gesture" | "time" | "/r/has a" |  | "FN" |  |
| fn:gesture | /r/HasA | fn:fe:place | "gesture" | "place" | "/r/has a" |  | "FN" |  |
| fn:gesture | /r/HasA | fn:fe:indicated_entity | "gesture" | "indicated entity" | "/r/has a" |  | "FN" |  |
| fn:gesture | /r/HasA | fn:fe:instrument | "gesture" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:get_a_job | /r/IsA | fn:intentionally_act | "get a job" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:employee_scenario | /r/HasSubevent | fn:get_a_job | "employee scenario" | "get a job" | "/r/has subevent" |  | "FN" |  |
| fn:being_employed | /r/HasPrerequisite | fn:get_a_job | "being employed" | "get a job" | "/r/has prerequisite" |  | "FN" |  |
| fn:get_a_job | /r/IsA | fn:employment_start | "get a job" | "employment start" | "/r/is a" |  | "FN" |  |
| fn:get_a_job | fn:HasLexicalUnit | fn:lu:get_a_job:sign_on | "get a job" | "sign on" | "has lexical unit" |  | "FN" |  |
| fn:get_a_job | fn:HasLexicalUnit | fn:lu:get_a_job:hire_on | "get a job" | "hire on" | "has lexical unit" |  | "FN" |  |
| fn:get_a_job | /r/HasA | fn:fe:compensation | "get a job" | "compensation" | "/r/has a" |  | "FN" |  |
| fn:fe:employee | /r/IsA | fn:st:sentient | "employee" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:get_a_job | /r/HasA | fn:fe:employee | "get a job" | "employee" | "/r/has a" |  | "FN" |  |
| fn:get_a_job | /r/HasA | fn:fe:employer | "get a job" | "employer" | "/r/has a" |  | "FN" |  |
| fn:get_a_job | /r/HasA | fn:fe:manner | "get a job" | "manner" | "/r/has a" |  | "FN" |  |
| fn:get_a_job | /r/HasA | fn:fe:place | "get a job" | "place" | "/r/has a" |  | "FN" |  |
| fn:get_a_job | /r/HasA | fn:fe:position | "get a job" | "position" | "/r/has a" |  | "FN" |  |
| fn:get_a_job | /r/HasA | fn:fe:purpose | "get a job" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:get_a_job | /r/HasA | fn:fe:task | "get a job" | "task" | "/r/has a" |  | "FN" |  |
| fn:get_a_job | /r/HasA | fn:fe:time | "get a job" | "time" | "/r/has a" |  | "FN" |  |
| fn:get_a_job | /r/HasA | fn:fe:means | "get a job" | "means" | "/r/has a" |  | "FN" |  |
| fn:get_a_job | /r/HasA | fn:fe:contract_basis | "get a job" | "contract basis" | "/r/has a" |  | "FN" |  |
| fn:getting | /r/IsA | fn:event | "getting" | "event" | "/r/is a" |  | "FN" |  |
| fn:amassing | /r/IsA | fn:getting | "amassing" | "getting" | "/r/is a" |  | "FN" |  |
| fn:commerce_buy | /r/IsA | fn:getting | "commerce buy" | "getting" | "/r/is a" |  | "FN" |  |
| fn:commerce_collect | /r/IsA | fn:getting | "commerce collect" | "getting" | "/r/is a" |  | "FN" |  |
| fn:receiving | /r/IsA | fn:getting | "receiving" | "getting" | "/r/is a" |  | "FN" |  |
| fn:taking | /r/IsA | fn:getting | "taking" | "getting" | "/r/is a" |  | "FN" |  |
| fn:getting_scenario | /r/HasSubevent | fn:getting | "getting scenario" | "getting" | "/r/has subevent" |  | "FN" |  |
| fn:getting | /r/Causes | fn:possession | "getting" | "possession" | "/r/causes" |  | "FN" |  |
| fn:post_getting | /r/HasPrerequisite | fn:getting | "post getting" | "getting" | "/r/has prerequisite" |  | "FN" |  |
| fn:getting | /r/HasPrerequisite | fn:pre_getting | "getting" | "pre getting" | "/r/has prerequisite" |  | "FN" |  |
| fn:getting | fn:HasLexicalUnit | fn:lu:getting:get | "getting" | "get" | "has lexical unit" |  | "FN" |  |
| fn:getting | fn:HasLexicalUnit | fn:lu:getting:obtain | "getting" | "obtain" | "has lexical unit" |  | "FN" |  |
| fn:getting | fn:HasLexicalUnit | fn:lu:getting:acquire | "getting" | "acquire" | "has lexical unit" |  | "FN" |  |
| fn:getting | fn:HasLexicalUnit | fn:lu:getting:acquisition_[act] | "getting" | "acquisition [act]" | "has lexical unit" |  | "FN" |  |
| fn:getting | fn:HasLexicalUnit | fn:lu:getting:gain | "getting" | "gain" | "has lexical unit" |  | "FN" |  |
| fn:getting | fn:HasLexicalUnit | fn:lu:getting:acquisition_[entity] | "getting" | "acquisition [entity]" | "has lexical unit" |  | "FN" |  |
| fn:getting | fn:HasLexicalUnit | fn:lu:getting:secure | "getting" | "secure" | "has lexical unit" |  | "FN" |  |
| fn:getting | fn:HasLexicalUnit | fn:lu:getting:procure | "getting" | "procure" | "has lexical unit" |  | "FN" |  |
| fn:getting | fn:HasLexicalUnit | fn:lu:getting:procurement_[act] | "getting" | "procurement [act]" | "has lexical unit" |  | "FN" |  |
| fn:getting | fn:HasLexicalUnit | fn:lu:getting:score | "getting" | "score" | "has lexical unit" |  | "FN" |  |
| fn:getting | fn:HasLexicalUnit | fn:lu:getting:win | "getting" | "win" | "has lexical unit" |  | "FN" |  |
| fn:getting | /r/HasA | fn:fe:recipient | "getting" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:getting | /r/HasA | fn:fe:theme | "getting" | "theme" | "/r/has a" |  | "FN" |  |
| fn:getting | /r/HasA | fn:fe:source | "getting" | "source" | "/r/has a" |  | "FN" |  |
| fn:getting | /r/HasA | fn:fe:place | "getting" | "place" | "/r/has a" |  | "FN" |  |
| fn:getting | /r/HasA | fn:fe:purpose | "getting" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:getting | /r/HasA | fn:fe:explanation | "getting" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:getting | /r/HasA | fn:fe:time | "getting" | "time" | "/r/has a" |  | "FN" |  |
| fn:getting | /r/HasA | fn:fe:means | "getting" | "means" | "/r/has a" |  | "FN" |  |
| fn:getting | /r/HasA | fn:fe:manner | "getting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:getting | /r/HasA | fn:fe:result | "getting" | "result" | "/r/has a" |  | "FN" |  |
| fn:getting | /r/HasA | fn:fe:concessive | "getting" | "concessive" | "/r/has a" |  | "FN" |  |
| fn:getting | /r/HasA | fn:fe:beneficiary | "getting" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:getting | /r/HasA | fn:fe:circumstances | "getting" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:receiving_scenario | /r/IsA | fn:getting_scenario | "receiving scenario" | "getting scenario" | "/r/is a" |  | "FN" |  |
| fn:getting_scenario | /r/HasSubevent | fn:getting | "getting scenario" | "getting" | "/r/has subevent" |  | "FN" |  |
| fn:getting_scenario | /r/HasSubevent | fn:post_getting | "getting scenario" | "post getting" | "/r/has subevent" |  | "FN" |  |
| fn:getting_scenario | /r/HasSubevent | fn:pre_getting | "getting scenario" | "pre getting" | "/r/has subevent" |  | "FN" |  |
| fn:getting_scenario | /r/HasA | fn:fe:recipient | "getting scenario" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:getting_scenario | /r/HasA | fn:fe:theme | "getting scenario" | "theme" | "/r/has a" |  | "FN" |  |
| fn:getting_scenario | /r/HasA | fn:fe:source | "getting scenario" | "source" | "/r/has a" |  | "FN" |  |
| fn:getting_scenario | /r/HasA | fn:fe:purpose | "getting scenario" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:getting_scenario | /r/HasA | fn:fe:explanation | "getting scenario" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:triggering | /r/Causes | fn:getting_triggered | "triggering" | "getting triggered" | "/r/causes" |  | "FN" |  |
| fn:getting_triggered | fn:HasLexicalUnit | fn:lu:getting_triggered:trigger | "getting triggered" | "trigger" | "has lexical unit" |  | "FN" |  |
| fn:getting_triggered | fn:HasLexicalUnit | fn:lu:getting_triggered:go_off | "getting triggered" | "go off" | "has lexical unit" |  | "FN" |  |
| fn:getting_triggered | /r/HasA | fn:fe:system | "getting triggered" | "system" | "/r/has a" |  | "FN" |  |
| fn:getting_triggered | /r/HasA | fn:fe:manner | "getting triggered" | "manner" | "/r/has a" |  | "FN" |  |
| fn:getting_triggered | /r/HasA | fn:fe:place | "getting triggered" | "place" | "/r/has a" |  | "FN" |  |
| fn:getting_triggered | /r/HasA | fn:fe:time | "getting triggered" | "time" | "/r/has a" |  | "FN" |  |
| fn:getting_triggered | /r/HasA | fn:fe:frequency | "getting triggered" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:motion | /r/HasSubevent | fn:getting_underway | "motion" | "getting underway" | "/r/has subevent" |  | "FN" |  |
| fn:getting_underway | fn:HasLexicalUnit | fn:lu:getting_underway:get_under_way | "getting underway" | "get under way" | "has lexical unit" |  | "FN" |  |
| fn:getting_underway | fn:HasLexicalUnit | fn:lu:getting_underway:get_going | "getting underway" | "get going" | "has lexical unit" |  | "FN" |  |
| fn:getting_underway | fn:HasLexicalUnit | fn:lu:getting_underway:head_out | "getting underway" | "head out" | "has lexical unit" |  | "FN" |  |
| fn:getting_underway | fn:HasLexicalUnit | fn:lu:getting_underway:hit_the_road | "getting underway" | "hit the road" | "has lexical unit" |  | "FN" |  |
| fn:getting_underway | /r/HasA | fn:fe:self_mover | "getting underway" | "self mover" | "/r/has a" |  | "FN" |  |
| fn:getting_underway | /r/HasA | fn:fe:source | "getting underway" | "source" | "/r/has a" |  | "FN" |  |
| fn:getting_underway | /r/HasA | fn:fe:path | "getting underway" | "path" | "/r/has a" |  | "FN" |  |
| fn:getting_underway | /r/HasA | fn:fe:goal | "getting underway" | "goal" | "/r/has a" |  | "FN" |  |
| fn:getting_underway | /r/HasA | fn:fe:manner | "getting underway" | "manner" | "/r/has a" |  | "FN" |  |
| fn:getting_underway | /r/HasA | fn:fe:means | "getting underway" | "means" | "/r/has a" |  | "FN" |  |
| fn:getting_underway | /r/HasA | fn:fe:time | "getting underway" | "time" | "/r/has a" |  | "FN" |  |
| fn:getting_underway | /r/HasA | fn:fe:depictive | "getting underway" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:getting_underway | /r/HasA | fn:fe:duration_of_final_state | "getting underway" | "duration of final state" | "/r/has a" |  | "FN" |  |
| fn:getting_underway | /r/HasA | fn:fe:mode_of_transportation | "getting underway" | "mode of transportation" | "/r/has a" |  | "FN" |  |
| fn:getting_underway | /r/HasA | fn:fe:journey | "getting underway" | "journey" | "/r/has a" |  | "FN" |  |
| fn:getting_underway | /r/HasA | fn:fe:direction | "getting underway" | "direction" | "/r/has a" |  | "FN" |  |
| fn:sleep_wake_cycle | /r/HasSubevent | fn:getting_up | "sleep wake cycle" | "getting up" | "/r/has subevent" |  | "FN" |  |
| fn:change_posture | /r/UsedFor | fn:getting_up | "change posture" | "getting up" | "/r/used for" |  | "FN" |  |
| fn:getting_up | /r/HasPrerequisite | fn:being_awake | "getting up" | "being awake" | "/r/has prerequisite" |  | "FN" |  |
| fn:getting_up | fn:HasLexicalUnit | fn:lu:getting_up:rise | "getting up" | "rise" | "has lexical unit" |  | "FN" |  |
| fn:getting_up | fn:HasLexicalUnit | fn:lu:getting_up:get_up | "getting up" | "get up" | "has lexical unit" |  | "FN" |  |
| fn:getting_up | /r/HasA | fn:fe:protagonist | "getting up" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:fe:bed | /r/IsA | fn:st:source | "bed" | "source" | "/r/is a" |  | "FN" |  |
| fn:getting_up | /r/HasA | fn:fe:bed | "getting up" | "bed" | "/r/has a" |  | "FN" |  |
| fn:getting_up | /r/HasA | fn:fe:time | "getting up" | "time" | "/r/has a" |  | "FN" |  |
| fn:getting_up | /r/HasA | fn:fe:purpose | "getting up" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:getting_up | /r/HasA | fn:fe:manner | "getting up" | "manner" | "/r/has a" |  | "FN" |  |
| fn:getting_up | /r/HasA | fn:fe:new_situation | "getting up" | "new situation" | "/r/has a" |  | "FN" |  |
| fn:getting_up | /r/HasA | fn:fe:circumstances | "getting up" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:getting_up | /r/HasA | fn:fe:explanation | "getting up" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:getting_up | /r/HasA | fn:fe:duration_of_final_state | "getting up" | "duration of final state" | "/r/has a" |  | "FN" |  |
| fn:getting_up | /r/HasA | fn:fe:place | "getting up" | "place" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle_scenario | /r/HasSubevent | fn:getting_vehicle_underway | "operate vehicle scenario" | "getting vehicle underway" | "/r/has subevent" |  | "FN" |  |
| fn:getting_vehicle_underway | /r/UsedFor | fn:vehicle_departure_initial_stage | "getting vehicle underway" | "vehicle departure initial stage" | "/r/used for" |  | "FN" |  |
| fn:getting_vehicle_underway | fn:HasLexicalUnit | fn:lu:getting_vehicle_underway:launch | "getting vehicle underway" | "launch" | "has lexical unit" |  | "FN" |  |
| fn:getting_vehicle_underway | fn:HasLexicalUnit | fn:lu:getting_vehicle_underway:weigh_anchor | "getting vehicle underway" | "weigh anchor" | "has lexical unit" |  | "FN" |  |
| fn:getting_vehicle_underway | fn:HasLexicalUnit | fn:lu:getting_vehicle_underway:cast_off | "getting vehicle underway" | "cast off" | "has lexical unit" |  | "FN" |  |
| fn:getting_vehicle_underway | fn:HasLexicalUnit | fn:lu:getting_vehicle_underway:pull_(out) | "getting vehicle underway" | "pull (out)" | "has lexical unit" |  | "FN" |  |
| fn:getting_vehicle_underway | fn:HasLexicalUnit | fn:lu:getting_vehicle_underway:lift_(off) | "getting vehicle underway" | "lift (off)" | "has lexical unit" |  | "FN" |  |
| fn:getting_vehicle_underway | fn:HasLexicalUnit | fn:lu:getting_vehicle_underway:take_(off) | "getting vehicle underway" | "take (off)" | "has lexical unit" |  | "FN" |  |
| fn:getting_vehicle_underway | /r/HasA | fn:fe:driver | "getting vehicle underway" | "driver" | "/r/has a" |  | "FN" |  |
| fn:getting_vehicle_underway | /r/HasA | fn:fe:vehicle | "getting vehicle underway" | "vehicle" | "/r/has a" |  | "FN" |  |
| fn:getting_vehicle_underway | /r/HasA | fn:fe:source | "getting vehicle underway" | "source" | "/r/has a" |  | "FN" |  |
| fn:fe:intended_goal | /r/IsA | fn:st:goal | "intended goal" | "goal" | "/r/is a" |  | "FN" |  |
| fn:getting_vehicle_underway | /r/HasA | fn:fe:intended_goal | "getting vehicle underway" | "intended goal" | "/r/has a" |  | "FN" |  |
| fn:getting_vehicle_underway | /r/HasA | fn:fe:manner | "getting vehicle underway" | "manner" | "/r/has a" |  | "FN" |  |
| fn:getting_vehicle_underway | /r/HasA | fn:fe:depictive | "getting vehicle underway" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:getting_vehicle_underway | /r/HasA | fn:fe:means | "getting vehicle underway" | "means" | "/r/has a" |  | "FN" |  |
| fn:getting_vehicle_underway | /r/HasA | fn:fe:result | "getting vehicle underway" | "result" | "/r/has a" |  | "FN" |  |
| fn:getting_vehicle_underway | /r/HasA | fn:fe:co-participant | "getting vehicle underway" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:getting_vehicle_underway | /r/HasA | fn:fe:circumstances | "getting vehicle underway" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:getting_vehicle_underway | /r/HasA | fn:fe:place | "getting vehicle underway" | "place" | "/r/has a" |  | "FN" |  |
| fn:getting_vehicle_underway | /r/HasA | fn:fe:duration_of_final_state | "getting vehicle underway" | "duration of final state" | "/r/has a" |  | "FN" |  |
| fn:getting_vehicle_underway | /r/HasA | fn:fe:time | "getting vehicle underway" | "time" | "/r/has a" |  | "FN" |  |
| fn:getting_vehicle_underway | /r/HasA | fn:fe:explanation | "getting vehicle underway" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:give_impression | /r/IsA | fn:perception | "give impression" | "perception" | "/r/is a" |  | "FN" |  |
| fn:give_impression | /r/UsedFor | fn:chemical-sense_description | "give impression" | "chemical-sense description" | "/r/used for" |  | "FN" |  |
| fn:give_impression | /r/UsedFor | fn:want_suspect | "give impression" | "want suspect" | "/r/used for" |  | "FN" |  |
| fn:give_impression | fn:HasLexicalUnit | fn:lu:give_impression:appear | "give impression" | "appear" | "has lexical unit" |  | "FN" |  |
| fn:give_impression | fn:HasLexicalUnit | fn:lu:give_impression:feel | "give impression" | "feel" | "has lexical unit" |  | "FN" |  |
| fn:give_impression | fn:HasLexicalUnit | fn:lu:give_impression:look | "give impression" | "look" | "has lexical unit" |  | "FN" |  |
| fn:give_impression | fn:HasLexicalUnit | fn:lu:give_impression:reek | "give impression" | "reek" | "has lexical unit" |  | "FN" |  |
| fn:give_impression | fn:HasLexicalUnit | fn:lu:give_impression:seem | "give impression" | "seem" | "has lexical unit" |  | "FN" |  |
| fn:give_impression | fn:HasLexicalUnit | fn:lu:give_impression:smell | "give impression" | "smell" | "has lexical unit" |  | "FN" |  |
| fn:give_impression | fn:HasLexicalUnit | fn:lu:give_impression:sound | "give impression" | "sound" | "has lexical unit" |  | "FN" |  |
| fn:give_impression | fn:HasLexicalUnit | fn:lu:give_impression:stink | "give impression" | "stink" | "has lexical unit" |  | "FN" |  |
| fn:give_impression | fn:HasLexicalUnit | fn:lu:give_impression:taste | "give impression" | "taste" | "has lexical unit" |  | "FN" |  |
| fn:give_impression | /r/HasA | fn:fe:phenomenon | "give impression" | "phenomenon" | "/r/has a" |  | "FN" |  |
| fn:give_impression | /r/HasA | fn:fe:characterization | "give impression" | "characterization" | "/r/has a" |  | "FN" |  |
| fn:give_impression | /r/HasA | fn:fe:appraisal | "give impression" | "appraisal" | "/r/has a" |  | "FN" |  |
| fn:give_impression | /r/HasA | fn:fe:inference | "give impression" | "inference" | "/r/has a" |  | "FN" |  |
| fn:fe:perceiver_passive | /r/IsA | fn:st:sentient | "perceiver passive" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:give_impression | /r/HasA | fn:fe:perceiver_passive | "give impression" | "perceiver passive" | "/r/has a" |  | "FN" |  |
| fn:give_impression | /r/HasA | fn:fe:body_part | "give impression" | "body part" | "/r/has a" |  | "FN" |  |
| fn:give_impression | /r/HasA | fn:fe:location_of_protagonist | "give impression" | "location of protagonist" | "/r/has a" |  | "FN" |  |
| fn:give_impression | /r/HasA | fn:fe:path | "give impression" | "path" | "/r/has a" |  | "FN" |  |
| fn:give_impression | /r/HasA | fn:fe:state | "give impression" | "state" | "/r/has a" |  | "FN" |  |
| fn:give_impression | /r/HasA | fn:fe:ground | "give impression" | "ground" | "/r/has a" |  | "FN" |  |
| fn:give_impression | /r/HasA | fn:fe:degree | "give impression" | "degree" | "/r/has a" |  | "FN" |  |
| fn:give_impression | /r/HasA | fn:fe:circumstances | "give impression" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:give_impression | /r/HasA | fn:fe:frequency | "give impression" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:commerce_pay | /r/IsA | fn:giving | "commerce pay" | "giving" | "/r/is a" |  | "FN" |  |
| fn:commerce_sell | /r/IsA | fn:giving | "commerce sell" | "giving" | "/r/is a" |  | "FN" |  |
| fn:lending | /r/IsA | fn:giving | "lending" | "giving" | "/r/is a" |  | "FN" |  |
| fn:submitting_documents | /r/IsA | fn:giving | "submitting documents" | "giving" | "/r/is a" |  | "FN" |  |
| fn:supply | /r/IsA | fn:giving | "supply" | "giving" | "/r/is a" |  | "FN" |  |
| fn:surrendering_possession | /r/IsA | fn:giving | "surrendering possession" | "giving" | "/r/is a" |  | "FN" |  |
| fn:giving | /r/IsA | fn:intentionally_act | "giving" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:giving | /r/IsA | fn:lose_possession | "giving" | "lose possession" | "/r/is a" |  | "FN" |  |
| fn:giving_scenario | /r/HasSubevent | fn:giving | "giving scenario" | "giving" | "/r/has subevent" |  | "FN" |  |
| fn:giving | /r/UsedFor | fn:conferring_benefit | "giving" | "conferring benefit" | "/r/used for" |  | "FN" |  |
| fn:giving | /r/UsedFor | fn:offering | "giving" | "offering" | "/r/used for" |  | "FN" |  |
| fn:post_giving | /r/HasPrerequisite | fn:giving | "post giving" | "giving" | "/r/has prerequisite" |  | "FN" |  |
| fn:giving | /r/HasPrerequisite | fn:pre_giving | "giving" | "pre giving" | "/r/has prerequisite" |  | "FN" |  |
| fn:giving | /r/IsA | fn:transfer | "giving" | "transfer" | "/r/is a" |  | "FN" |  |
| fn:giving | fn:HasLexicalUnit | fn:lu:giving:give | "giving" | "give" | "has lexical unit" |  | "FN" |  |
| fn:giving | fn:HasLexicalUnit | fn:lu:giving:donate | "giving" | "donate" | "has lexical unit" |  | "FN" |  |
| fn:giving | fn:HasLexicalUnit | fn:lu:giving:donation | "giving" | "donation" | "has lexical unit" |  | "FN" |  |
| fn:giving | fn:HasLexicalUnit | fn:lu:giving:donor | "giving" | "donor" | "has lexical unit" |  | "FN" |  |
| fn:giving | fn:HasLexicalUnit | fn:lu:giving:foist | "giving" | "foist" | "has lexical unit" |  | "FN" |  |
| fn:giving | fn:HasLexicalUnit | fn:lu:giving:endow | "giving" | "endow" | "has lexical unit" |  | "FN" |  |
| fn:giving | fn:HasLexicalUnit | fn:lu:giving:fob_off | "giving" | "fob off" | "has lexical unit" |  | "FN" |  |
| fn:giving | fn:HasLexicalUnit | fn:lu:giving:give_out | "giving" | "give out" | "has lexical unit" |  | "FN" |  |
| fn:giving | fn:HasLexicalUnit | fn:lu:giving:hand_over | "giving" | "hand over" | "has lexical unit" |  | "FN" |  |
| fn:giving | fn:HasLexicalUnit | fn:lu:giving:hand_out | "giving" | "hand out" | "has lexical unit" |  | "FN" |  |
| fn:giving | fn:HasLexicalUnit | fn:lu:giving:gift | "giving" | "gift" | "has lexical unit" |  | "FN" |  |
| fn:giving | fn:HasLexicalUnit | fn:lu:giving:gift | "giving" | "gift" | "has lexical unit" |  | "FN" |  |
| fn:giving | fn:HasLexicalUnit | fn:lu:giving:pass_out | "giving" | "pass out" | "has lexical unit" |  | "FN" |  |
| fn:giving | fn:HasLexicalUnit | fn:lu:giving:bequeath | "giving" | "bequeath" | "has lexical unit" |  | "FN" |  |
| fn:giving | fn:HasLexicalUnit | fn:lu:giving:treat | "giving" | "treat" | "has lexical unit" |  | "FN" |  |
| fn:giving | fn:HasLexicalUnit | fn:lu:giving:hand | "giving" | "hand" | "has lexical unit" |  | "FN" |  |
| fn:giving | fn:HasLexicalUnit | fn:lu:giving:hand_in | "giving" | "hand in" | "has lexical unit" |  | "FN" |  |
| fn:giving | fn:HasLexicalUnit | fn:lu:giving:contribute | "giving" | "contribute" | "has lexical unit" |  | "FN" |  |
| fn:giving | fn:HasLexicalUnit | fn:lu:giving:contribution | "giving" | "contribution" | "has lexical unit" |  | "FN" |  |
| fn:giving | fn:HasLexicalUnit | fn:lu:giving:charity | "giving" | "charity" | "has lexical unit" |  | "FN" |  |
| fn:giving | fn:HasLexicalUnit | fn:lu:giving:volunteer | "giving" | "volunteer" | "has lexical unit" |  | "FN" |  |
| fn:giving | fn:HasLexicalUnit | fn:lu:giving:will | "giving" | "will" | "has lexical unit" |  | "FN" |  |
| fn:giving | fn:HasLexicalUnit | fn:lu:giving:leave | "giving" | "leave" | "has lexical unit" |  | "FN" |  |
| fn:giving | fn:HasLexicalUnit | fn:lu:giving:advance | "giving" | "advance" | "has lexical unit" |  | "FN" |  |
| fn:giving | fn:HasLexicalUnit | fn:lu:giving:confer_(upon) | "giving" | "confer (upon)" | "has lexical unit" |  | "FN" |  |
| fn:giving | fn:HasLexicalUnit | fn:lu:giving:bequest | "giving" | "bequest" | "has lexical unit" |  | "FN" |  |
| fn:giving | /r/HasA | fn:fe:donor | "giving" | "donor" | "/r/has a" |  | "FN" |  |
| fn:giving | /r/HasA | fn:fe:recipient | "giving" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:giving | /r/HasA | fn:fe:theme | "giving" | "theme" | "/r/has a" |  | "FN" |  |
| fn:giving | /r/HasA | fn:fe:place | "giving" | "place" | "/r/has a" |  | "FN" |  |
| fn:giving | /r/HasA | fn:fe:explanation | "giving" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:giving | /r/HasA | fn:fe:time | "giving" | "time" | "/r/has a" |  | "FN" |  |
| fn:giving | /r/HasA | fn:fe:purpose | "giving" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:giving | /r/HasA | fn:fe:means | "giving" | "means" | "/r/has a" |  | "FN" |  |
| fn:giving | /r/HasA | fn:fe:manner | "giving" | "manner" | "/r/has a" |  | "FN" |  |
| fn:giving | /r/HasA | fn:fe:circumstances | "giving" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:giving | /r/HasA | fn:fe:imposed_purpose | "giving" | "imposed purpose" | "/r/has a" |  | "FN" |  |
| fn:giving | /r/HasA | fn:fe:depictive | "giving" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:giving | /r/HasA | fn:fe:period_of_iterations | "giving" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:giving_birth | /r/SimilarTo | fn:being_born | "giving birth" | "being born" | "/r/similar to" |  | "FN" |  |
| fn:death | /r/HasPrerequisite | fn:giving_birth | "death" | "giving birth" | "/r/has prerequisite" |  | "FN" |  |
| fn:dying | /r/HasPrerequisite | fn:giving_birth | "dying" | "giving birth" | "/r/has prerequisite" |  | "FN" |  |
| fn:giving_birth | /r/IsA | fn:birth_scenario | "giving birth" | "birth scenario" | "/r/is a" |  | "FN" |  |
| fn:giving_birth | fn:HasLexicalUnit | fn:lu:giving_birth:bear | "giving birth" | "bear" | "has lexical unit" |  | "FN" |  |
| fn:giving_birth | fn:HasLexicalUnit | fn:lu:giving_birth:birth | "giving birth" | "birth" | "has lexical unit" |  | "FN" |  |
| fn:giving_birth | fn:HasLexicalUnit | fn:lu:giving_birth:whelp | "giving birth" | "whelp" | "has lexical unit" |  | "FN" |  |
| fn:giving_birth | fn:HasLexicalUnit | fn:lu:giving_birth:father | "giving birth" | "father" | "has lexical unit" |  | "FN" |  |
| fn:giving_birth | fn:HasLexicalUnit | fn:lu:giving_birth:beget | "giving birth" | "beget" | "has lexical unit" |  | "FN" |  |
| fn:giving_birth | fn:HasLexicalUnit | fn:lu:giving_birth:sire | "giving birth" | "sire" | "has lexical unit" |  | "FN" |  |
| fn:giving_birth | fn:HasLexicalUnit | fn:lu:giving_birth:spawn | "giving birth" | "spawn" | "has lexical unit" |  | "FN" |  |
| fn:giving_birth | fn:HasLexicalUnit | fn:lu:giving_birth:have | "giving birth" | "have" | "has lexical unit" |  | "FN" |  |
| fn:giving_birth | fn:HasLexicalUnit | fn:lu:giving_birth:drop | "giving birth" | "drop" | "has lexical unit" |  | "FN" |  |
| fn:giving_birth | fn:HasLexicalUnit | fn:lu:giving_birth:calve | "giving birth" | "calve" | "has lexical unit" |  | "FN" |  |
| fn:giving_birth | fn:HasLexicalUnit | fn:lu:giving_birth:kid | "giving birth" | "kid" | "has lexical unit" |  | "FN" |  |
| fn:giving_birth | fn:HasLexicalUnit | fn:lu:giving_birth:lay | "giving birth" | "lay" | "has lexical unit" |  | "FN" |  |
| fn:giving_birth | fn:HasLexicalUnit | fn:lu:giving_birth:calving | "giving birth" | "calving" | "has lexical unit" |  | "FN" |  |
| fn:giving_birth | fn:HasLexicalUnit | fn:lu:giving_birth:lambing | "giving birth" | "lambing" | "has lexical unit" |  | "FN" |  |
| fn:giving_birth | fn:HasLexicalUnit | fn:lu:giving_birth:carry_to_term | "giving birth" | "carry to term" | "has lexical unit" |  | "FN" |  |
| fn:giving_birth | fn:HasLexicalUnit | fn:lu:giving_birth:birth | "giving birth" | "birth" | "has lexical unit" |  | "FN" |  |
| fn:giving_birth | fn:HasLexicalUnit | fn:lu:giving_birth:mother | "giving birth" | "mother" | "has lexical unit" |  | "FN" |  |
| fn:giving_birth | fn:HasLexicalUnit | fn:lu:giving_birth:bring_forth | "giving birth" | "bring forth" | "has lexical unit" |  | "FN" |  |
| fn:giving_birth | fn:HasLexicalUnit | fn:lu:giving_birth:generate | "giving birth" | "generate" | "has lexical unit" |  | "FN" |  |
| fn:giving_birth | fn:HasLexicalUnit | fn:lu:giving_birth:propagate | "giving birth" | "propagate" | "has lexical unit" |  | "FN" |  |
| fn:giving_birth | fn:HasLexicalUnit | fn:lu:giving_birth:get | "giving birth" | "get" | "has lexical unit" |  | "FN" |  |
| fn:giving_birth | /r/HasA | fn:fe:mother | "giving birth" | "mother" | "/r/has a" |  | "FN" |  |
| fn:giving_birth | /r/HasA | fn:fe:child | "giving birth" | "child" | "/r/has a" |  | "FN" |  |
| fn:giving_birth | /r/HasA | fn:fe:father | "giving birth" | "father" | "/r/has a" |  | "FN" |  |
| fn:giving_birth | /r/HasA | fn:fe:place | "giving birth" | "place" | "/r/has a" |  | "FN" |  |
| fn:giving_birth | /r/HasA | fn:fe:time | "giving birth" | "time" | "/r/has a" |  | "FN" |  |
| fn:giving_birth | /r/HasA | fn:fe:depictive | "giving birth" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:giving_birth | /r/HasA | fn:fe:circumstances | "giving birth" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:fe:egg | /r/RelatedTo | fn:fe:child | "egg" | "child" | "/r/related to" |  | "FN" |  |
| fn:giving_birth | /r/HasA | fn:fe:egg | "giving birth" | "egg" | "/r/has a" |  | "FN" |  |
| fn:giving_birth | /r/HasA | fn:fe:means | "giving birth" | "means" | "/r/has a" |  | "FN" |  |
| fn:giving_birth | /r/HasA | fn:fe:parents | "giving birth" | "parents" | "/r/has a" |  | "FN" |  |
| fn:giving_birth | /r/HasA | fn:fe:result | "giving birth" | "result" | "/r/has a" |  | "FN" |  |
| fn:giving_birth | /r/HasA | fn:fe:manner | "giving birth" | "manner" | "/r/has a" |  | "FN" |  |
| fn:taking_sides | /r/UsedFor | fn:giving_in | "taking sides" | "giving in" | "/r/used for" |  | "FN" |  |
| fn:compliance | /r/SimilarTo | fn:giving_in | "compliance" | "giving in" | "/r/similar to" |  | "FN" |  |
| fn:giving_in | fn:HasLexicalUnit | fn:lu:giving_in:relent | "giving in" | "relent" | "has lexical unit" |  | "FN" |  |
| fn:giving_in | fn:HasLexicalUnit | fn:lu:giving_in:acquiesce | "giving in" | "acquiesce" | "has lexical unit" |  | "FN" |  |
| fn:giving_in | fn:HasLexicalUnit | fn:lu:giving_in:yield | "giving in" | "yield" | "has lexical unit" |  | "FN" |  |
| fn:giving_in | fn:HasLexicalUnit | fn:lu:giving_in:cave_in | "giving in" | "cave in" | "has lexical unit" |  | "FN" |  |
| fn:giving_in | fn:HasLexicalUnit | fn:lu:giving_in:give_in | "giving in" | "give in" | "has lexical unit" |  | "FN" |  |
| fn:giving_in | fn:HasLexicalUnit | fn:lu:giving_in:give_way | "giving in" | "give way" | "has lexical unit" |  | "FN" |  |
| fn:giving_in | fn:HasLexicalUnit | fn:lu:giving_in:capitulate | "giving in" | "capitulate" | "has lexical unit" |  | "FN" |  |
| fn:giving_in | fn:HasLexicalUnit | fn:lu:giving_in:fold_[to_demands] | "giving in" | "fold [to demands]" | "has lexical unit" |  | "FN" |  |
| fn:giving_in | fn:HasLexicalUnit | fn:lu:giving_in:cave | "giving in" | "cave" | "has lexical unit" |  | "FN" |  |
| fn:giving_in | fn:HasLexicalUnit | fn:lu:giving_in:submit | "giving in" | "submit" | "has lexical unit" |  | "FN" |  |
| fn:fe:capitulator | /r/IsA | fn:st:sentient | "capitulator" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:giving_in | /r/HasA | fn:fe:capitulator | "giving in" | "capitulator" | "/r/has a" |  | "FN" |  |
| fn:giving_in | /r/HasA | fn:fe:issue | "giving in" | "issue" | "/r/has a" |  | "FN" |  |
| fn:giving_in | /r/HasA | fn:fe:compeller | "giving in" | "compeller" | "/r/has a" |  | "FN" |  |
| fn:giving_in | /r/HasA | fn:fe:time | "giving in" | "time" | "/r/has a" |  | "FN" |  |
| fn:giving_in | /r/HasA | fn:fe:explanation | "giving in" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:giving_in | /r/HasA | fn:fe:force | "giving in" | "force" | "/r/has a" |  | "FN" |  |
| fn:giving_in | /r/HasA | fn:fe:place | "giving in" | "place" | "/r/has a" |  | "FN" |  |
| fn:giving_in | /r/HasA | fn:fe:purpose | "giving in" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:giving_in | /r/HasA | fn:fe:manner | "giving in" | "manner" | "/r/has a" |  | "FN" |  |
| fn:giving_in | /r/HasA | fn:fe:degree | "giving in" | "degree" | "/r/has a" |  | "FN" |  |
| fn:giving_in | /r/HasA | fn:fe:resultant_action | "giving in" | "resultant action" | "/r/has a" |  | "FN" |  |
| fn:giving_scenario | /r/IsA | fn:lose_possession_scenario | "giving scenario" | "lose possession scenario" | "/r/is a" |  | "FN" |  |
| fn:giving_scenario | /r/HasSubevent | fn:giving | "giving scenario" | "giving" | "/r/has subevent" |  | "FN" |  |
| fn:giving_scenario | /r/HasSubevent | fn:post_giving | "giving scenario" | "post giving" | "/r/has subevent" |  | "FN" |  |
| fn:giving_scenario | /r/HasSubevent | fn:pre_giving | "giving scenario" | "pre giving" | "/r/has subevent" |  | "FN" |  |
| fn:giving_scenario | /r/IsA | fn:transfer_scenario | "giving scenario" | "transfer scenario" | "/r/is a" |  | "FN" |  |
| fn:giving_scenario | /r/HasA | fn:fe:donor | "giving scenario" | "donor" | "/r/has a" |  | "FN" |  |
| fn:giving_scenario | /r/HasA | fn:fe:recipient | "giving scenario" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:giving_scenario | /r/HasA | fn:fe:theme | "giving scenario" | "theme" | "/r/has a" |  | "FN" |  |
| fn:giving_scenario | /r/HasA | fn:fe:purpose | "giving scenario" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:giving_scenario | /r/HasA | fn:fe:manner | "giving scenario" | "manner" | "/r/has a" |  | "FN" |  |
| fn:giving_scenario | /r/HasA | fn:fe:imposed_purpose | "giving scenario" | "imposed purpose" | "/r/has a" |  | "FN" |  |
| fn:artifact | /r/UsedFor | fn:gizmo | "artifact" | "gizmo" | "/r/used for" |  | "FN" |  |
| fn:gizmo | /r/UsedFor | fn:being_in_operation | "gizmo" | "being in operation" | "/r/used for" |  | "FN" |  |
| fn:gizmo | fn:HasLexicalUnit | fn:lu:gizmo:tool | "gizmo" | "tool" | "has lexical unit" |  | "FN" |  |
| fn:gizmo | fn:HasLexicalUnit | fn:lu:gizmo:implement | "gizmo" | "implement" | "has lexical unit" |  | "FN" |  |
| fn:gizmo | fn:HasLexicalUnit | fn:lu:gizmo:apparatus | "gizmo" | "apparatus" | "has lexical unit" |  | "FN" |  |
| fn:gizmo | fn:HasLexicalUnit | fn:lu:gizmo:device | "gizmo" | "device" | "has lexical unit" |  | "FN" |  |
| fn:gizmo | fn:HasLexicalUnit | fn:lu:gizmo:utensil | "gizmo" | "utensil" | "has lexical unit" |  | "FN" |  |
| fn:gizmo | fn:HasLexicalUnit | fn:lu:gizmo:instrument | "gizmo" | "instrument" | "has lexical unit" |  | "FN" |  |
| fn:gizmo | fn:HasLexicalUnit | fn:lu:gizmo:equipment | "gizmo" | "equipment" | "has lexical unit" |  | "FN" |  |
| fn:gizmo | fn:HasLexicalUnit | fn:lu:gizmo:gadget | "gizmo" | "gadget" | "has lexical unit" |  | "FN" |  |
| fn:gizmo | fn:HasLexicalUnit | fn:lu:gizmo:appliance | "gizmo" | "appliance" | "has lexical unit" |  | "FN" |  |
| fn:gizmo | fn:HasLexicalUnit | fn:lu:gizmo:contraption | "gizmo" | "contraption" | "has lexical unit" |  | "FN" |  |
| fn:gizmo | fn:HasLexicalUnit | fn:lu:gizmo:machine | "gizmo" | "machine" | "has lexical unit" |  | "FN" |  |
| fn:gizmo | fn:HasLexicalUnit | fn:lu:gizmo:mechanical | "gizmo" | "mechanical" | "has lexical unit" |  | "FN" |  |
| fn:gizmo | fn:HasLexicalUnit | fn:lu:gizmo:centrifuge | "gizmo" | "centrifuge" | "has lexical unit" |  | "FN" |  |
| fn:gizmo | fn:HasLexicalUnit | fn:lu:gizmo:technology | "gizmo" | "technology" | "has lexical unit" |  | "FN" |  |
| fn:gizmo | fn:HasLexicalUnit | fn:lu:gizmo:system | "gizmo" | "system" | "has lexical unit" |  | "FN" |  |
| fn:gizmo | fn:HasLexicalUnit | fn:lu:gizmo:gear | "gizmo" | "gear" | "has lexical unit" |  | "FN" |  |
| fn:gizmo | fn:HasLexicalUnit | fn:lu:gizmo:core | "gizmo" | "core" | "has lexical unit" |  | "FN" |  |
| fn:gizmo | fn:HasLexicalUnit | fn:lu:gizmo:player | "gizmo" | "player" | "has lexical unit" |  | "FN" |  |
| fn:gizmo | fn:HasLexicalUnit | fn:lu:gizmo:range | "gizmo" | "range" | "has lexical unit" |  | "FN" |  |
| fn:gizmo | fn:HasLexicalUnit | fn:lu:gizmo:level | "gizmo" | "level" | "has lexical unit" |  | "FN" |  |
| fn:gizmo | /r/HasA | fn:fe:use | "gizmo" | "use" | "/r/has a" |  | "FN" |  |
| fn:gizmo | /r/HasA | fn:fe:user | "gizmo" | "user" | "/r/has a" |  | "FN" |  |
| fn:gizmo | /r/HasA | fn:fe:power_source | "gizmo" | "power source" | "/r/has a" |  | "FN" |  |
| fn:gizmo | /r/HasA | fn:fe:gizmo | "gizmo" | "gizmo" | "/r/has a" |  | "FN" |  |
| fn:gizmo | /r/HasA | fn:fe:descriptor | "gizmo" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:go_into_shape | /r/IsA | fn:event | "go into shape" | "event" | "/r/is a" |  | "FN" |  |
| fn:go_into_shape | /r/Causes | fn:shapes | "go into shape" | "shapes" | "/r/causes" |  | "FN" |  |
| fn:go_into_shape | fn:HasLexicalUnit | fn:lu:go_into_shape:coil | "go into shape" | "coil" | "has lexical unit" |  | "FN" |  |
| fn:go_into_shape | fn:HasLexicalUnit | fn:lu:go_into_shape:curl | "go into shape" | "curl" | "has lexical unit" |  | "FN" |  |
| fn:go_into_shape | fn:HasLexicalUnit | fn:lu:go_into_shape:twist | "go into shape" | "twist" | "has lexical unit" |  | "FN" |  |
| fn:go_into_shape | fn:HasLexicalUnit | fn:lu:go_into_shape:fold | "go into shape" | "fold" | "has lexical unit" |  | "FN" |  |
| fn:go_into_shape | fn:HasLexicalUnit | fn:lu:go_into_shape:fold_[protein] | "go into shape" | "fold [protein]" | "has lexical unit" |  | "FN" |  |
| fn:go_into_shape | /r/HasA | fn:fe:place | "go into shape" | "place" | "/r/has a" |  | "FN" |  |
| fn:go_into_shape | /r/HasA | fn:fe:explanation | "go into shape" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:go_into_shape | /r/HasA | fn:fe:time | "go into shape" | "time" | "/r/has a" |  | "FN" |  |
| fn:go_into_shape | /r/HasA | fn:fe:duration | "go into shape" | "duration" | "/r/has a" |  | "FN" |  |
| fn:go_into_shape | /r/HasA | fn:fe:manner | "go into shape" | "manner" | "/r/has a" |  | "FN" |  |
| fn:go_into_shape | /r/HasA | fn:fe:frequency | "go into shape" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:go_into_shape | /r/HasA | fn:fe:theme | "go into shape" | "theme" | "/r/has a" |  | "FN" |  |
| fn:go_into_shape | /r/HasA | fn:fe:resultant_configuration | "go into shape" | "resultant configuration" | "/r/has a" |  | "FN" |  |
| fn:go_into_shape | /r/HasA | fn:fe:containing_event | "go into shape" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:go_into_shape | /r/HasA | fn:fe:circumstances | "go into shape" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:go_into_shape | /r/HasA | fn:fe:imposed_purpose | "go into shape" | "imposed purpose" | "/r/has a" |  | "FN" |  |
| fn:goal | /r/IsA | fn:locative_relation | "goal" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:source_path_goal | /r/UsedFor | fn:goal | "source path goal" | "goal" | "/r/used for" |  | "FN" |  |
| fn:goal | fn:HasLexicalUnit | fn:lu:goal:to | "goal" | "to" | "has lexical unit" |  | "FN" |  |
| fn:goal | fn:HasLexicalUnit | fn:lu:goal:into | "goal" | "into" | "has lexical unit" |  | "FN" |  |
| fn:fe:landmark | /r/IsA | fn:st:location | "landmark" | "location" | "/r/is a" |  | "FN" |  |
| fn:goal | /r/HasA | fn:fe:landmark | "goal" | "landmark" | "/r/has a" |  | "FN" |  |
| fn:fe:profiled_region | /r/IsA | fn:st:goal | "profiled region" | "goal" | "/r/is a" |  | "FN" |  |
| fn:goal | /r/HasA | fn:fe:profiled_region | "goal" | "profiled region" | "/r/has a" |  | "FN" |  |
| fn:goal | /r/HasA | fn:fe:trajector | "goal" | "trajector" | "/r/has a" |  | "FN" |  |
| fn:goal | /r/HasA | fn:fe:time | "goal" | "time" | "/r/has a" |  | "FN" |  |
| fn:commitment | /r/UsedFor | fn:going_back_on_a_commitment | "commitment" | "going back on a commitment" | "/r/used for" |  | "FN" |  |
| fn:going_back_on_a_commitment | fn:HasLexicalUnit | fn:lu:going_back_on_a_commitment:back_out | "going back on a commitment" | "back out" | "has lexical unit" |  | "FN" |  |
| fn:going_back_on_a_commitment | fn:HasLexicalUnit | fn:lu:going_back_on_a_commitment:go_back | "going back on a commitment" | "go back" | "has lexical unit" |  | "FN" |  |
| fn:going_back_on_a_commitment | fn:HasLexicalUnit | fn:lu:going_back_on_a_commitment:renege | "going back on a commitment" | "renege" | "has lexical unit" |  | "FN" |  |
| fn:going_back_on_a_commitment | /r/HasA | fn:fe:protagonist | "going back on a commitment" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:fe:affected_party | /r/IsA | fn:st:sentient | "affected party" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:going_back_on_a_commitment | /r/HasA | fn:fe:affected_party | "going back on a commitment" | "affected party" | "/r/has a" |  | "FN" |  |
| fn:going_back_on_a_commitment | /r/HasA | fn:fe:commitment | "going back on a commitment" | "commitment" | "/r/has a" |  | "FN" |  |
| fn:going_back_on_a_commitment | /r/HasA | fn:fe:manner | "going back on a commitment" | "manner" | "/r/has a" |  | "FN" |  |
| fn:going_back_on_a_commitment | /r/HasA | fn:fe:time | "going back on a commitment" | "time" | "/r/has a" |  | "FN" |  |
| fn:going_back_on_a_commitment | /r/HasA | fn:fe:place | "going back on a commitment" | "place" | "/r/has a" |  | "FN" |  |
| fn:going_back_on_a_commitment | /r/HasA | fn:fe:explanation | "going back on a commitment" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:going_back_on_a_commitment | /r/HasA | fn:fe:event_description | "going back on a commitment" | "event description" | "/r/has a" |  | "FN" |  |
| fn:going_back_on_a_commitment | /r/HasA | fn:fe:degree | "going back on a commitment" | "degree" | "/r/has a" |  | "FN" |  |
| fn:going_back_on_a_commitment | /r/HasA | fn:fe:re-encoding | "going back on a commitment" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:going_back_on_a_commitment | /r/HasA | fn:fe:iterations | "going back on a commitment" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:going_back_on_a_commitment | /r/HasA | fn:fe:result | "going back on a commitment" | "result" | "/r/has a" |  | "FN" |  |
| fn:law_enforcement_agency | /r/IsA | fn:government_institution | "law enforcement agency" | "government institution" | "/r/is a" |  | "FN" |  |
| fn:government_institution | /r/IsA | fn:institutions | "government institution" | "institutions" | "/r/is a" |  | "FN" |  |
| fn:fe:institution | /r/IsA | fn:st:group | "institution" | "group" | "/r/is a" |  | "FN" |  |
| fn:government_institution | /r/HasA | fn:fe:institution | "government institution" | "institution" | "/r/has a" |  | "FN" |  |
| fn:government_institution | /r/HasA | fn:fe:members | "government institution" | "members" | "/r/has a" |  | "FN" |  |
| fn:government_institution | /r/HasA | fn:fe:purpose | "government institution" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:government_institution | /r/HasA | fn:fe:period_of_existence | "government institution" | "period of existence" | "/r/has a" |  | "FN" |  |
| fn:government_institution | /r/HasA | fn:fe:name | "government institution" | "name" | "/r/has a" |  | "FN" |  |
| fn:government_institution | /r/HasA | fn:fe:place | "government institution" | "place" | "/r/has a" |  | "FN" |  |
| fn:government_institution | /r/HasA | fn:fe:descriptor | "government institution" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:government_institution | /r/HasA | fn:fe:domain | "government institution" | "domain" | "/r/has a" |  | "FN" |  |
| fn:gradable_artistic_quality | /r/IsA | fn:gradable_attributes | "gradable artistic quality" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:gradable_artistic_quality | fn:HasLexicalUnit | fn:lu:gradable_artistic_quality:severe | "gradable artistic quality" | "severe" | "has lexical unit" |  | "FN" |  |
| fn:gradable_artistic_quality | fn:HasLexicalUnit | fn:lu:gradable_artistic_quality:austere | "gradable artistic quality" | "austere" | "has lexical unit" |  | "FN" |  |
| fn:gradable_artistic_quality | fn:HasLexicalUnit | fn:lu:gradable_artistic_quality:stark | "gradable artistic quality" | "stark" | "has lexical unit" |  | "FN" |  |
| fn:gradable_artistic_quality | fn:HasLexicalUnit | fn:lu:gradable_artistic_quality:busy | "gradable artistic quality" | "busy" | "has lexical unit" |  | "FN" |  |
| fn:gradable_artistic_quality | fn:HasLexicalUnit | fn:lu:gradable_artistic_quality:cluttered | "gradable artistic quality" | "cluttered" | "has lexical unit" |  | "FN" |  |
| fn:gradable_artistic_quality | /r/HasA | fn:fe:entity | "gradable artistic quality" | "entity" | "/r/has a" |  | "FN" |  |
| fn:gradable_artistic_quality | /r/HasA | fn:fe:attribute | "gradable artistic quality" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:gradable_artistic_quality | /r/HasA | fn:fe:degree | "gradable artistic quality" | "degree" | "/r/has a" |  | "FN" |  |
| fn:gradable_artistic_quality | /r/HasA | fn:fe:time | "gradable artistic quality" | "time" | "/r/has a" |  | "FN" |  |
| fn:gradable_artistic_quality | /r/HasA | fn:fe:circumstances | "gradable artistic quality" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:gradable_artistic_quality | /r/HasA | fn:fe:place | "gradable artistic quality" | "place" | "/r/has a" |  | "FN" |  |
| fn:gradable_attributes | /r/IsA | fn:attributes | "gradable attributes" | "attributes" | "/r/is a" |  | "FN" |  |
| fn:abundance | /r/IsA | fn:gradable_attributes | "abundance" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:addiction | /r/IsA | fn:gradable_attributes | "addiction" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:artificiality | /r/IsA | fn:gradable_attributes | "artificiality" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:being_active | /r/IsA | fn:gradable_attributes | "being active" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:being_at_risk | /r/IsA | fn:gradable_attributes | "being at risk" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:being_dry | /r/IsA | fn:gradable_attributes | "being dry" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:being_rotted | /r/IsA | fn:gradable_attributes | "being rotted" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:being_wet | /r/IsA | fn:gradable_attributes | "being wet" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:biological_urge | /r/IsA | fn:gradable_attributes | "biological urge" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:body_description_holistic | /r/IsA | fn:gradable_attributes | "body description holistic" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:body_description_part | /r/IsA | fn:gradable_attributes | "body description part" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:capability | /r/IsA | fn:gradable_attributes | "capability" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:certainty | /r/IsA | fn:gradable_attributes | "certainty" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:chemical-sense_description | /r/IsA | fn:gradable_attributes | "chemical-sense description" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:chemical_potency | /r/IsA | fn:gradable_attributes | "chemical potency" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:color | /r/IsA | fn:gradable_attributes | "color" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:color_qualities | /r/IsA | fn:gradable_attributes | "color qualities" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:compatibility | /r/IsA | fn:gradable_attributes | "compatibility" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:completeness | /r/IsA | fn:gradable_attributes | "completeness" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:correctness | /r/IsA | fn:gradable_attributes | "correctness" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:desirability | /r/IsA | fn:gradable_attributes | "desirability" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:difficulty | /r/IsA | fn:gradable_attributes | "difficulty" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:dynamism | /r/IsA | fn:gradable_attributes | "dynamism" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:familiarity | /r/IsA | fn:gradable_attributes | "familiarity" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:frequency | /r/IsA | fn:gradable_attributes | "frequency" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:fullness | /r/IsA | fn:gradable_attributes | "fullness" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:gradable_artistic_quality | /r/IsA | fn:gradable_attributes | "gradable artistic quality" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:inclination | /r/IsA | fn:gradable_attributes | "inclination" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:intoxication | /r/IsA | fn:gradable_attributes | "intoxication" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:judgment_of_intensity | /r/IsA | fn:gradable_attributes | "judgment of intensity" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:level_of_force_exertion | /r/IsA | fn:gradable_attributes | "level of force exertion" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:level_of_force_resistance | /r/IsA | fn:gradable_attributes | "level of force resistance" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:level_of_light | /r/IsA | fn:gradable_attributes | "level of light" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:likelihood | /r/IsA | fn:gradable_attributes | "likelihood" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:lively_place | /r/IsA | fn:gradable_attributes | "lively place" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:luck | /r/IsA | fn:gradable_attributes | "luck" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:margin_of_resolution | /r/IsA | fn:gradable_attributes | "margin of resolution" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:measurable_attributes | /r/IsA | fn:gradable_attributes | "measurable attributes" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:medical_conditions | /r/IsA | fn:gradable_attributes | "medical conditions" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:notability | /r/IsA | fn:gradable_attributes | "notability" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:obscurity | /r/IsA | fn:gradable_attributes | "obscurity" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:obviousness | /r/IsA | fn:gradable_attributes | "obviousness" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:personal_success | /r/IsA | fn:gradable_attributes | "personal success" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:position_on_a_scale | /r/IsA | fn:gradable_attributes | "position on a scale" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:prominence | /r/IsA | fn:gradable_attributes | "prominence" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:risky_situation | /r/IsA | fn:gradable_attributes | "risky situation" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:sharpness | /r/IsA | fn:gradable_attributes | "sharpness" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:similarity | /r/IsA | fn:gradable_attributes | "similarity" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:social_behavior_evaluation | /r/IsA | fn:gradable_attributes | "social behavior evaluation" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:suitability | /r/IsA | fn:gradable_attributes | "suitability" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:system_complexity | /r/IsA | fn:gradable_attributes | "system complexity" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:taking_time | /r/IsA | fn:gradable_attributes | "taking time" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:typicality | /r/IsA | fn:gradable_attributes | "typicality" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:usefulness | /r/IsA | fn:gradable_attributes | "usefulness" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:wealthiness | /r/IsA | fn:gradable_attributes | "wealthiness" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:gradable_attributes | /r/UsedFor | fn:extreme_point | "gradable attributes" | "extreme point" | "/r/used for" |  | "FN" |  |
| fn:gradable_attributes | /r/UsedFor | fn:first_rank | "gradable attributes" | "first rank" | "/r/used for" |  | "FN" |  |
| fn:gradable_attributes | /r/UsedFor | fn:transition_to_a_quality | "gradable attributes" | "transition to a quality" | "/r/used for" |  | "FN" |  |
| fn:gradable_attributes | /r/HasA | fn:fe:entity | "gradable attributes" | "entity" | "/r/has a" |  | "FN" |  |
| fn:gradable_attributes | /r/HasA | fn:fe:attribute | "gradable attributes" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:fe:degree | /r/RelatedTo | fn:fe:value | "degree" | "value" | "/r/related to" |  | "FN" |  |
| fn:gradable_attributes | /r/HasA | fn:fe:degree | "gradable attributes" | "degree" | "/r/has a" |  | "FN" |  |
| fn:gradable_attributes | /r/HasA | fn:fe:time | "gradable attributes" | "time" | "/r/has a" |  | "FN" |  |
| fn:gradable_attributes | /r/HasA | fn:fe:circumstances | "gradable attributes" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:gradable_attributes | /r/HasA | fn:fe:value | "gradable attributes" | "value" | "/r/has a" |  | "FN" |  |
| fn:gradable_attributes | /r/HasA | fn:fe:place | "gradable attributes" | "place" | "/r/has a" |  | "FN" |  |
| fn:gradable_proximity | /r/IsA | fn:locative_relation | "gradable proximity" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:gradable_proximity | /r/IsA | fn:proximity_image_schema | "gradable proximity" | "proximity image schema" | "/r/is a" |  | "FN" |  |
| fn:gradable_proximity | fn:HasLexicalUnit | fn:lu:gradable_proximity:near | "gradable proximity" | "near" | "has lexical unit" |  | "FN" |  |
| fn:gradable_proximity | fn:HasLexicalUnit | fn:lu:gradable_proximity:close | "gradable proximity" | "close" | "has lexical unit" |  | "FN" |  |
| fn:gradable_proximity | fn:HasLexicalUnit | fn:lu:gradable_proximity:proximity | "gradable proximity" | "proximity" | "has lexical unit" |  | "FN" |  |
| fn:gradable_proximity | fn:HasLexicalUnit | fn:lu:gradable_proximity:far | "gradable proximity" | "far" | "has lexical unit" |  | "FN" |  |
| fn:gradable_proximity | fn:HasLexicalUnit | fn:lu:gradable_proximity:distant | "gradable proximity" | "distant" | "has lexical unit" |  | "FN" |  |
| fn:gradable_proximity | /r/HasA | fn:fe:ground | "gradable proximity" | "ground" | "/r/has a" |  | "FN" |  |
| fn:gradable_proximity | /r/HasA | fn:fe:figure | "gradable proximity" | "figure" | "/r/has a" |  | "FN" |  |
| fn:gradable_proximity | /r/HasA | fn:fe:accessibility | "gradable proximity" | "accessibility" | "/r/has a" |  | "FN" |  |
| fn:gradable_proximity | /r/HasA | fn:fe:direction | "gradable proximity" | "direction" | "/r/has a" |  | "FN" |  |
| fn:gradable_proximity | /r/HasA | fn:fe:time | "gradable proximity" | "time" | "/r/has a" |  | "FN" |  |
| fn:gradable_proximity | /r/HasA | fn:fe:figures | "gradable proximity" | "figures" | "/r/has a" |  | "FN" |  |
| fn:gradable_proximity | /r/HasA | fn:fe:degree | "gradable proximity" | "degree" | "/r/has a" |  | "FN" |  |
| fn:gradable_proximity | /r/HasA | fn:fe:deixis | "gradable proximity" | "deixis" | "/r/has a" |  | "FN" |  |
| fn:gradable_proximity | /r/HasA | fn:fe:directness | "gradable proximity" | "directness" | "/r/has a" |  | "FN" |  |
| fn:gradable_proximity | /r/HasA | fn:fe:temporal_profile | "gradable proximity" | "temporal profile" | "/r/has a" |  | "FN" |  |
| fn:gradable_proximity | /r/HasA | fn:fe:distance | "gradable proximity" | "distance" | "/r/has a" |  | "FN" |  |
| fn:graph_shape | fn:HasLexicalUnit | fn:lu:graph_shape:trace | "graph shape" | "trace" | "has lexical unit" |  | "FN" |  |
| fn:graph_shape | fn:HasLexicalUnit | fn:lu:graph_shape:plot | "graph shape" | "plot" | "has lexical unit" |  | "FN" |  |
| fn:graph_shape | /r/HasA | fn:fe:shape | "graph shape" | "shape" | "/r/has a" |  | "FN" |  |
| fn:graph_shape | /r/HasA | fn:fe:data | "graph shape" | "data" | "/r/has a" |  | "FN" |  |
| fn:graph_shape | /r/HasA | fn:fe:graph | "graph shape" | "graph" | "/r/has a" |  | "FN" |  |
| fn:graph_shape | /r/HasA | fn:fe:name | "graph shape" | "name" | "/r/has a" |  | "FN" |  |
| fn:graph_shape | /r/HasA | fn:fe:descriptor | "graph shape" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:graph_shape | /r/HasA | fn:fe:location | "graph shape" | "location" | "/r/has a" |  | "FN" |  |
| fn:grasp | /r/IsA | fn:awareness | "grasp" | "awareness" | "/r/is a" |  | "FN" |  |
| fn:grasp | fn:HasLexicalUnit | fn:lu:grasp:grasp | "grasp" | "grasp" | "has lexical unit" |  | "FN" |  |
| fn:grasp | fn:HasLexicalUnit | fn:lu:grasp:comprehend | "grasp" | "comprehend" | "has lexical unit" |  | "FN" |  |
| fn:grasp | fn:HasLexicalUnit | fn:lu:grasp:understand | "grasp" | "understand" | "has lexical unit" |  | "FN" |  |
| fn:grasp | fn:HasLexicalUnit | fn:lu:grasp:grasp | "grasp" | "grasp" | "has lexical unit" |  | "FN" |  |
| fn:grasp | fn:HasLexicalUnit | fn:lu:grasp:get | "grasp" | "get" | "has lexical unit" |  | "FN" |  |
| fn:grasp | fn:HasLexicalUnit | fn:lu:grasp:see | "grasp" | "see" | "has lexical unit" |  | "FN" |  |
| fn:grasp | fn:HasLexicalUnit | fn:lu:grasp:unintelligible | "grasp" | "unintelligible" | "has lexical unit" |  | "FN" |  |
| fn:grasp | fn:HasLexicalUnit | fn:lu:grasp:intelligible | "grasp" | "intelligible" | "has lexical unit" |  | "FN" |  |
| fn:grasp | fn:HasLexicalUnit | fn:lu:grasp:comprehensible | "grasp" | "comprehensible" | "has lexical unit" |  | "FN" |  |
| fn:grasp | fn:HasLexicalUnit | fn:lu:grasp:incomprehensible | "grasp" | "incomprehensible" | "has lexical unit" |  | "FN" |  |
| fn:grasp | fn:HasLexicalUnit | fn:lu:grasp:graspable | "grasp" | "graspable" | "has lexical unit" |  | "FN" |  |
| fn:grasp | fn:HasLexicalUnit | fn:lu:grasp:apprehend | "grasp" | "apprehend" | "has lexical unit" |  | "FN" |  |
| fn:grasp | fn:HasLexicalUnit | fn:lu:grasp:fathom | "grasp" | "fathom" | "has lexical unit" |  | "FN" |  |
| fn:grasp | fn:HasLexicalUnit | fn:lu:grasp:follow | "grasp" | "follow" | "has lexical unit" |  | "FN" |  |
| fn:fe:cognizer | /r/RelatedTo | fn:fe:faculty | "cognizer" | "faculty" | "/r/related to" |  | "FN" |  |
| fn:grasp | /r/HasA | fn:fe:cognizer | "grasp" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:grasp | /r/HasA | fn:fe:phenomenon | "grasp" | "phenomenon" | "/r/has a" |  | "FN" |  |
| fn:grasp | /r/HasA | fn:fe:completeness | "grasp" | "completeness" | "/r/has a" |  | "FN" |  |
| fn:grasp | /r/HasA | fn:fe:manner | "grasp" | "manner" | "/r/has a" |  | "FN" |  |
| fn:grasp | /r/HasA | fn:fe:reference_point | "grasp" | "reference point" | "/r/has a" |  | "FN" |  |
| fn:grasp | /r/HasA | fn:fe:category | "grasp" | "category" | "/r/has a" |  | "FN" |  |
| fn:grasp | /r/HasA | fn:fe:time | "grasp" | "time" | "/r/has a" |  | "FN" |  |
| fn:grasp | /r/HasA | fn:fe:faculty | "grasp" | "faculty" | "/r/has a" |  | "FN" |  |
| fn:grasp | /r/HasA | fn:fe:evidence | "grasp" | "evidence" | "/r/has a" |  | "FN" |  |
| fn:grasp | /r/HasA | fn:fe:concessive | "grasp" | "concessive" | "/r/has a" |  | "FN" |  |
| fn:grinding | /r/IsA | fn:transitive_action | "grinding" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:reshaping | /r/SimilarTo | fn:grinding | "reshaping" | "grinding" | "/r/similar to" |  | "FN" |  |
| fn:grinding | /r/Causes | fn:ground_up | "grinding" | "ground up" | "/r/causes" |  | "FN" |  |
| fn:grinding | fn:HasLexicalUnit | fn:lu:grinding:flake | "grinding" | "flake" | "has lexical unit" |  | "FN" |  |
| fn:grinding | fn:HasLexicalUnit | fn:lu:grinding:pulverize | "grinding" | "pulverize" | "has lexical unit" |  | "FN" |  |
| fn:grinding | fn:HasLexicalUnit | fn:lu:grinding:grind | "grinding" | "grind" | "has lexical unit" |  | "FN" |  |
| fn:grinding | fn:HasLexicalUnit | fn:lu:grinding:crumble | "grinding" | "crumble" | "has lexical unit" |  | "FN" |  |
| fn:grinding | fn:HasLexicalUnit | fn:lu:grinding:crush | "grinding" | "crush" | "has lexical unit" |  | "FN" |  |
| fn:grinding | fn:HasLexicalUnit | fn:lu:grinding:mill | "grinding" | "mill" | "has lexical unit" |  | "FN" |  |
| fn:grinding | fn:HasLexicalUnit | fn:lu:grinding:grate | "grinding" | "grate" | "has lexical unit" |  | "FN" |  |
| fn:grinding | fn:HasLexicalUnit | fn:lu:grinding:shred | "grinding" | "shred" | "has lexical unit" |  | "FN" |  |
| fn:grinding | fn:HasLexicalUnit | fn:lu:grinding:crunch | "grinding" | "crunch" | "has lexical unit" |  | "FN" |  |
| fn:grinding | fn:HasLexicalUnit | fn:lu:grinding:masticate | "grinding" | "masticate" | "has lexical unit" |  | "FN" |  |
| fn:grinding | fn:HasLexicalUnit | fn:lu:grinding:chew | "grinding" | "chew" | "has lexical unit" |  | "FN" |  |
| fn:grinding | fn:HasLexicalUnit | fn:lu:grinding:mastication | "grinding" | "mastication" | "has lexical unit" |  | "FN" |  |
| fn:grinding | fn:HasLexicalUnit | fn:lu:grinding:mash | "grinding" | "mash" | "has lexical unit" |  | "FN" |  |
| fn:grinding | fn:HasLexicalUnit | fn:lu:grinding:pulp | "grinding" | "pulp" | "has lexical unit" |  | "FN" |  |
| fn:grinding | /r/HasA | fn:fe:grinding_cause | "grinding" | "grinding cause" | "/r/has a" |  | "FN" |  |
| fn:grinding | /r/HasA | fn:fe:grinder | "grinding" | "grinder" | "/r/has a" |  | "FN" |  |
| fn:grinding | /r/HasA | fn:fe:instrument | "grinding" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:grinding | /r/HasA | fn:fe:locus | "grinding" | "locus" | "/r/has a" |  | "FN" |  |
| fn:grinding | /r/HasA | fn:fe:manner | "grinding" | "manner" | "/r/has a" |  | "FN" |  |
| fn:grinding | /r/HasA | fn:fe:means | "grinding" | "means" | "/r/has a" |  | "FN" |  |
| fn:grinding | /r/HasA | fn:fe:place | "grinding" | "place" | "/r/has a" |  | "FN" |  |
| fn:grinding | /r/HasA | fn:fe:purpose | "grinding" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:grinding | /r/HasA | fn:fe:result | "grinding" | "result" | "/r/has a" |  | "FN" |  |
| fn:grinding | /r/HasA | fn:fe:time | "grinding" | "time" | "/r/has a" |  | "FN" |  |
| fn:grinding | /r/HasA | fn:fe:patient | "grinding" | "patient" | "/r/has a" |  | "FN" |  |
| fn:grinding | /r/HasA | fn:fe:duration | "grinding" | "duration" | "/r/has a" |  | "FN" |  |
| fn:grinding | /r/HasA | fn:fe:goal | "grinding" | "goal" | "/r/has a" |  | "FN" |  |
| fn:grooming | /r/IsA | fn:intentionally_affect | "grooming" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:desirability | /r/UsedFor | fn:grooming | "desirability" | "grooming" | "/r/used for" |  | "FN" |  |
| fn:hair_configuration | /r/SimilarTo | fn:grooming | "hair configuration" | "grooming" | "/r/similar to" |  | "FN" |  |
| fn:grooming | fn:HasLexicalUnit | fn:lu:grooming:bathe | "grooming" | "bathe" | "has lexical unit" |  | "FN" |  |
| fn:grooming | fn:HasLexicalUnit | fn:lu:grooming:wash | "grooming" | "wash" | "has lexical unit" |  | "FN" |  |
| fn:grooming | fn:HasLexicalUnit | fn:lu:grooming:lave | "grooming" | "lave" | "has lexical unit" |  | "FN" |  |
| fn:grooming | fn:HasLexicalUnit | fn:lu:grooming:shower | "grooming" | "shower" | "has lexical unit" |  | "FN" |  |
| fn:grooming | fn:HasLexicalUnit | fn:lu:grooming:pluck | "grooming" | "pluck" | "has lexical unit" |  | "FN" |  |
| fn:grooming | fn:HasLexicalUnit | fn:lu:grooming:floss | "grooming" | "floss" | "has lexical unit" |  | "FN" |  |
| fn:grooming | fn:HasLexicalUnit | fn:lu:grooming:shave | "grooming" | "shave" | "has lexical unit" |  | "FN" |  |
| fn:grooming | fn:HasLexicalUnit | fn:lu:grooming:wax | "grooming" | "wax" | "has lexical unit" |  | "FN" |  |
| fn:grooming | fn:HasLexicalUnit | fn:lu:grooming:comb | "grooming" | "comb" | "has lexical unit" |  | "FN" |  |
| fn:grooming | fn:HasLexicalUnit | fn:lu:grooming:shampoo | "grooming" | "shampoo" | "has lexical unit" |  | "FN" |  |
| fn:grooming | fn:HasLexicalUnit | fn:lu:grooming:manicure | "grooming" | "manicure" | "has lexical unit" |  | "FN" |  |
| fn:grooming | fn:HasLexicalUnit | fn:lu:grooming:pedicure | "grooming" | "pedicure" | "has lexical unit" |  | "FN" |  |
| fn:grooming | fn:HasLexicalUnit | fn:lu:grooming:ablution | "grooming" | "ablution" | "has lexical unit" |  | "FN" |  |
| fn:grooming | fn:HasLexicalUnit | fn:lu:grooming:moisturize | "grooming" | "moisturize" | "has lexical unit" |  | "FN" |  |
| fn:grooming | fn:HasLexicalUnit | fn:lu:grooming:soap | "grooming" | "soap" | "has lexical unit" |  | "FN" |  |
| fn:grooming | fn:HasLexicalUnit | fn:lu:grooming:cleanse | "grooming" | "cleanse" | "has lexical unit" |  | "FN" |  |
| fn:grooming | fn:HasLexicalUnit | fn:lu:grooming:facial | "grooming" | "facial" | "has lexical unit" |  | "FN" |  |
| fn:grooming | fn:HasLexicalUnit | fn:lu:grooming:manicure | "grooming" | "manicure" | "has lexical unit" |  | "FN" |  |
| fn:grooming | fn:HasLexicalUnit | fn:lu:grooming:groom | "grooming" | "groom" | "has lexical unit" |  | "FN" |  |
| fn:grooming | fn:HasLexicalUnit | fn:lu:grooming:brush_[teeth] | "grooming" | "brush [teeth]" | "has lexical unit" |  | "FN" |  |
| fn:grooming | fn:HasLexicalUnit | fn:lu:grooming:brush_[hair] | "grooming" | "brush [hair]" | "has lexical unit" |  | "FN" |  |
| fn:grooming | fn:HasLexicalUnit | fn:lu:grooming:plait | "grooming" | "plait" | "has lexical unit" |  | "FN" |  |
| fn:grooming | fn:HasLexicalUnit | fn:lu:grooming:file | "grooming" | "file" | "has lexical unit" |  | "FN" |  |
| fn:grooming | /r/HasA | fn:fe:result | "grooming" | "result" | "/r/has a" |  | "FN" |  |
| fn:grooming | /r/HasA | fn:fe:agent | "grooming" | "agent" | "/r/has a" |  | "FN" |  |
| fn:grooming | /r/HasA | fn:fe:patient | "grooming" | "patient" | "/r/has a" |  | "FN" |  |
| fn:grooming | /r/HasA | fn:fe:instrument | "grooming" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:grooming | /r/HasA | fn:fe:body_part | "grooming" | "body part" | "/r/has a" |  | "FN" |  |
| fn:grooming | /r/HasA | fn:fe:subregion | "grooming" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:grooming | /r/HasA | fn:fe:medium | "grooming" | "medium" | "/r/has a" |  | "FN" |  |
| fn:grooming | /r/HasA | fn:fe:frequency | "grooming" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:grooming | /r/HasA | fn:fe:manner | "grooming" | "manner" | "/r/has a" |  | "FN" |  |
| fn:grooming | /r/HasA | fn:fe:time | "grooming" | "time" | "/r/has a" |  | "FN" |  |
| fn:grooming | /r/HasA | fn:fe:place | "grooming" | "place" | "/r/has a" |  | "FN" |  |
| fn:grooming | /r/HasA | fn:fe:duration | "grooming" | "duration" | "/r/has a" |  | "FN" |  |
| fn:grooming | /r/HasA | fn:fe:purpose | "grooming" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:grooming | /r/HasA | fn:fe:means | "grooming" | "means" | "/r/has a" |  | "FN" |  |
| fn:grinding | /r/Causes | fn:ground_up | "grinding" | "ground up" | "/r/causes" |  | "FN" |  |
| fn:ground_up | fn:HasLexicalUnit | fn:lu:ground_up:pulverized | "ground up" | "pulverized" | "has lexical unit" |  | "FN" |  |
| fn:ground_up | fn:HasLexicalUnit | fn:lu:ground_up:ground | "ground up" | "ground" | "has lexical unit" |  | "FN" |  |
| fn:ground_up | fn:HasLexicalUnit | fn:lu:ground_up:crushed | "ground up" | "crushed" | "has lexical unit" |  | "FN" |  |
| fn:ground_up | fn:HasLexicalUnit | fn:lu:ground_up:milled | "ground up" | "milled" | "has lexical unit" |  | "FN" |  |
| fn:ground_up | fn:HasLexicalUnit | fn:lu:ground_up:grated | "ground up" | "grated" | "has lexical unit" |  | "FN" |  |
| fn:ground_up | fn:HasLexicalUnit | fn:lu:ground_up:flaked | "ground up" | "flaked" | "has lexical unit" |  | "FN" |  |
| fn:ground_up | fn:HasLexicalUnit | fn:lu:ground_up:powdered | "ground up" | "powdered" | "has lexical unit" |  | "FN" |  |
| fn:ground_up | fn:HasLexicalUnit | fn:lu:ground_up:shredded | "ground up" | "shredded" | "has lexical unit" |  | "FN" |  |
| fn:ground_up | fn:HasLexicalUnit | fn:lu:ground_up:crumbled | "ground up" | "crumbled" | "has lexical unit" |  | "FN" |  |
| fn:ground_up | fn:HasLexicalUnit | fn:lu:ground_up:granulated | "ground up" | "granulated" | "has lexical unit" |  | "FN" |  |
| fn:ground_up | /r/HasA | fn:fe:patient | "ground up" | "patient" | "/r/has a" |  | "FN" |  |
| fn:ground_up | /r/HasA | fn:fe:result | "ground up" | "result" | "/r/has a" |  | "FN" |  |
| fn:growing_food | /r/IsA | fn:agriculture | "growing food" | "agriculture" | "/r/is a" |  | "FN" |  |
| fn:growing_food | fn:HasLexicalUnit | fn:lu:growing_food:grow | "growing food" | "grow" | "has lexical unit" |  | "FN" |  |
| fn:growing_food | fn:HasLexicalUnit | fn:lu:growing_food:raise | "growing food" | "raise" | "has lexical unit" |  | "FN" |  |
| fn:fe:grower | /r/IsA | fn:st:sentient | "grower" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:growing_food | /r/HasA | fn:fe:grower | "growing food" | "grower" | "/r/has a" |  | "FN" |  |
| fn:growing_food | /r/HasA | fn:fe:food | "growing food" | "food" | "/r/has a" |  | "FN" |  |
| fn:growing_food | /r/HasA | fn:fe:instrument | "growing food" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:growing_food | /r/HasA | fn:fe:duration | "growing food" | "duration" | "/r/has a" |  | "FN" |  |
| fn:growing_food | /r/HasA | fn:fe:manner | "growing food" | "manner" | "/r/has a" |  | "FN" |  |
| fn:growing_food | /r/HasA | fn:fe:means | "growing food" | "means" | "/r/has a" |  | "FN" |  |
| fn:growing_food | /r/HasA | fn:fe:place | "growing food" | "place" | "/r/has a" |  | "FN" |  |
| fn:growing_food | /r/HasA | fn:fe:time | "growing food" | "time" | "/r/has a" |  | "FN" |  |
| fn:growing_food | /r/HasA | fn:fe:purpose | "growing food" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:growing_food | /r/HasA | fn:fe:frequency | "growing food" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:growing_food | /r/HasA | fn:fe:particular_iteration | "growing food" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:growing_food | /r/HasA | fn:fe:ground | "growing food" | "ground" | "/r/has a" |  | "FN" |  |
| fn:growing_food | /r/HasA | fn:fe:circumstances | "growing food" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:growing_food | /r/HasA | fn:fe:source | "growing food" | "source" | "/r/has a" |  | "FN" |  |
| fn:guest_and_host | /r/IsA | fn:relation_between_individuals | "guest and host" | "relation between individuals" | "/r/is a" |  | "FN" |  |
| fn:guest_and_host | /r/UsedFor | fn:hospitality | "guest and host" | "hospitality" | "/r/used for" |  | "FN" |  |
| fn:guest_and_host | /r/UsedFor | fn:lodging_scenario | "guest and host" | "lodging scenario" | "/r/used for" |  | "FN" |  |
| fn:guest_and_host | /r/UsedFor | fn:visitor_and_host | "guest and host" | "visitor and host" | "/r/used for" |  | "FN" |  |
| fn:guest_and_host | fn:HasLexicalUnit | fn:lu:guest_and_host:guest | "guest and host" | "guest" | "has lexical unit" |  | "FN" |  |
| fn:guest_and_host | fn:HasLexicalUnit | fn:lu:guest_and_host:host | "guest and host" | "host" | "has lexical unit" |  | "FN" |  |
| fn:fe:host | /r/IsA | fn:st:human | "host" | "human" | "/r/is a" |  | "FN" |  |
| fn:guest_and_host | /r/HasA | fn:fe:host | "guest and host" | "host" | "/r/has a" |  | "FN" |  |
| fn:fe:guest | /r/IsA | fn:st:human | "guest" | "human" | "/r/is a" |  | "FN" |  |
| fn:guest_and_host | /r/HasA | fn:fe:guest | "guest and host" | "guest" | "/r/has a" |  | "FN" |  |
| fn:guest_and_host | /r/HasA | fn:fe:degree | "guest and host" | "degree" | "/r/has a" |  | "FN" |  |
| fn:guest_and_host | /r/HasA | fn:fe:depictive | "guest and host" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:guest_and_host | /r/HasA | fn:fe:manner | "guest and host" | "manner" | "/r/has a" |  | "FN" |  |
| fn:guest_and_host | /r/HasA | fn:fe:means | "guest and host" | "means" | "/r/has a" |  | "FN" |  |
| fn:guest_and_host | /r/HasA | fn:fe:duration | "guest and host" | "duration" | "/r/has a" |  | "FN" |  |
| fn:fe:host_location | /r/IsA | fn:st:location | "host location" | "location" | "/r/is a" |  | "FN" |  |
| fn:guest_and_host | /r/HasA | fn:fe:host_location | "guest and host" | "host location" | "/r/has a" |  | "FN" |  |
| fn:guest_and_host | /r/HasA | fn:fe:time | "guest and host" | "time" | "/r/has a" |  | "FN" |  |
| fn:guest_and_host | /r/HasA | fn:fe:descriptor | "guest and host" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:misdeed | /r/UsedFor | fn:guilt_or_innocence | "misdeed" | "guilt or innocence" | "/r/used for" |  | "FN" |  |
| fn:guilt_or_innocence | /r/RelatedTo | fn:contrition | "guilt or innocence" | "contrition" | "/r/related to" |  | "FN" |  |
| fn:guilt_or_innocence | fn:HasLexicalUnit | fn:lu:guilt_or_innocence:guilty | "guilt or innocence" | "guilty" | "has lexical unit" |  | "FN" |  |
| fn:guilt_or_innocence | fn:HasLexicalUnit | fn:lu:guilt_or_innocence:innocent | "guilt or innocence" | "innocent" | "has lexical unit" |  | "FN" |  |
| fn:guilt_or_innocence | fn:HasLexicalUnit | fn:lu:guilt_or_innocence:guilt | "guilt or innocence" | "guilt" | "has lexical unit" |  | "FN" |  |
| fn:guilt_or_innocence | fn:HasLexicalUnit | fn:lu:guilt_or_innocence:innocence | "guilt or innocence" | "innocence" | "has lexical unit" |  | "FN" |  |
| fn:guilt_or_innocence | fn:HasLexicalUnit | fn:lu:guilt_or_innocence:blood_on_hands | "guilt or innocence" | "blood on hands" | "has lexical unit" |  | "FN" |  |
| fn:guilt_or_innocence | /r/HasA | fn:fe:accused | "guilt or innocence" | "accused" | "/r/has a" |  | "FN" |  |
| fn:guilt_or_innocence | /r/HasA | fn:fe:misdeed | "guilt or innocence" | "misdeed" | "/r/has a" |  | "FN" |  |
| fn:guilt_or_innocence | /r/HasA | fn:fe:viewpoint | "guilt or innocence" | "viewpoint" | "/r/has a" |  | "FN" |  |
| fn:guilt_or_innocence | /r/HasA | fn:fe:degree | "guilt or innocence" | "degree" | "/r/has a" |  | "FN" |  |
| fn:gusto | /r/IsA | fn:capability | "gusto" | "capability" | "/r/is a" |  | "FN" |  |
| fn:biological_entity | /r/UsedFor | fn:gusto | "biological entity" | "gusto" | "/r/used for" |  | "FN" |  |
| fn:gusto | fn:HasLexicalUnit | fn:lu:gusto:life | "gusto" | "life" | "has lexical unit" |  | "FN" |  |
| fn:gusto | fn:HasLexicalUnit | fn:lu:gusto:vim | "gusto" | "vim" | "has lexical unit" |  | "FN" |  |
| fn:gusto | fn:HasLexicalUnit | fn:lu:gusto:spirit | "gusto" | "spirit" | "has lexical unit" |  | "FN" |  |
| fn:gusto | /r/HasA | fn:fe:person | "gusto" | "person" | "/r/has a" |  | "FN" |  |
| fn:gusto | /r/HasA | fn:fe:degree | "gusto" | "degree" | "/r/has a" |  | "FN" |  |
| fn:body_parts | /r/UsedFor | fn:hair_configuration | "body parts" | "hair configuration" | "/r/used for" |  | "FN" |  |
| fn:hair_configuration | /r/SimilarTo | fn:grooming | "hair configuration" | "grooming" | "/r/similar to" |  | "FN" |  |
| fn:hair_configuration | fn:HasLexicalUnit | fn:lu:hair_configuration:lock | "hair configuration" | "lock" | "has lexical unit" |  | "FN" |  |
| fn:hair_configuration | fn:HasLexicalUnit | fn:lu:hair_configuration:tress | "hair configuration" | "tress" | "has lexical unit" |  | "FN" |  |
| fn:hair_configuration | fn:HasLexicalUnit | fn:lu:hair_configuration:curl | "hair configuration" | "curl" | "has lexical unit" |  | "FN" |  |
| fn:hair_configuration | fn:HasLexicalUnit | fn:lu:hair_configuration:curl | "hair configuration" | "curl" | "has lexical unit" |  | "FN" |  |
| fn:hair_configuration | fn:HasLexicalUnit | fn:lu:hair_configuration:blond | "hair configuration" | "blond" | "has lexical unit" |  | "FN" |  |
| fn:hair_configuration | fn:HasLexicalUnit | fn:lu:hair_configuration:blonde | "hair configuration" | "blonde" | "has lexical unit" |  | "FN" |  |
| fn:hair_configuration | fn:HasLexicalUnit | fn:lu:hair_configuration:pigtail | "hair configuration" | "pigtail" | "has lexical unit" |  | "FN" |  |
| fn:hair_configuration | fn:HasLexicalUnit | fn:lu:hair_configuration:curly | "hair configuration" | "curly" | "has lexical unit" |  | "FN" |  |
| fn:hair_configuration | fn:HasLexicalUnit | fn:lu:hair_configuration:ponytail | "hair configuration" | "ponytail" | "has lexical unit" |  | "FN" |  |
| fn:hair_configuration | fn:HasLexicalUnit | fn:lu:hair_configuration:plait | "hair configuration" | "plait" | "has lexical unit" |  | "FN" |  |
| fn:hair_configuration | fn:HasLexicalUnit | fn:lu:hair_configuration:braid | "hair configuration" | "braid" | "has lexical unit" |  | "FN" |  |
| fn:hair_configuration | fn:HasLexicalUnit | fn:lu:hair_configuration:braided | "hair configuration" | "braided" | "has lexical unit" |  | "FN" |  |
| fn:hair_configuration | fn:HasLexicalUnit | fn:lu:hair_configuration:topknot | "hair configuration" | "topknot" | "has lexical unit" |  | "FN" |  |
| fn:hair_configuration | fn:HasLexicalUnit | fn:lu:hair_configuration:wavy | "hair configuration" | "wavy" | "has lexical unit" |  | "FN" |  |
| fn:hair_configuration | fn:HasLexicalUnit | fn:lu:hair_configuration:wave | "hair configuration" | "wave" | "has lexical unit" |  | "FN" |  |
| fn:hair_configuration | fn:HasLexicalUnit | fn:lu:hair_configuration:hairdo | "hair configuration" | "hairdo" | "has lexical unit" |  | "FN" |  |
| fn:hair_configuration | fn:HasLexicalUnit | fn:lu:hair_configuration:golden | "hair configuration" | "golden" | "has lexical unit" |  | "FN" |  |
| fn:hair_configuration | fn:HasLexicalUnit | fn:lu:hair_configuration:flaxen | "hair configuration" | "flaxen" | "has lexical unit" |  | "FN" |  |
| fn:hair_configuration | fn:HasLexicalUnit | fn:lu:hair_configuration:styled | "hair configuration" | "styled" | "has lexical unit" |  | "FN" |  |
| fn:hair_configuration | fn:HasLexicalUnit | fn:lu:hair_configuration:hairstyle | "hair configuration" | "hairstyle" | "has lexical unit" |  | "FN" |  |
| fn:hair_configuration | fn:HasLexicalUnit | fn:lu:hair_configuration:haircut | "hair configuration" | "haircut" | "has lexical unit" |  | "FN" |  |
| fn:hair_configuration | fn:HasLexicalUnit | fn:lu:hair_configuration:cut | "hair configuration" | "cut" | "has lexical unit" |  | "FN" |  |
| fn:hair_configuration | fn:HasLexicalUnit | fn:lu:hair_configuration:cut | "hair configuration" | "cut" | "has lexical unit" |  | "FN" |  |
| fn:hair_configuration | fn:HasLexicalUnit | fn:lu:hair_configuration:cropped | "hair configuration" | "cropped" | "has lexical unit" |  | "FN" |  |
| fn:hair_configuration | fn:HasLexicalUnit | fn:lu:hair_configuration:hair | "hair configuration" | "hair" | "has lexical unit" |  | "FN" |  |
| fn:hair_configuration | fn:HasLexicalUnit | fn:lu:hair_configuration:part | "hair configuration" | "part" | "has lexical unit" |  | "FN" |  |
| fn:hair_configuration | /r/HasA | fn:fe:hair | "hair configuration" | "hair" | "/r/has a" |  | "FN" |  |
| fn:hair_configuration | /r/HasA | fn:fe:possessor | "hair configuration" | "possessor" | "/r/has a" |  | "FN" |  |
| fn:hair_configuration | /r/HasA | fn:fe:subregion | "hair configuration" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:hair_configuration | /r/HasA | fn:fe:configuration | "hair configuration" | "configuration" | "/r/has a" |  | "FN" |  |
| fn:hair_configuration | /r/HasA | fn:fe:hair_property | "hair configuration" | "hair property" | "/r/has a" |  | "FN" |  |
| fn:hair_configuration | /r/HasA | fn:fe:location | "hair configuration" | "location" | "/r/has a" |  | "FN" |  |
| fn:hair_configuration | /r/HasA | fn:fe:accessory | "hair configuration" | "accessory" | "/r/has a" |  | "FN" |  |
| fn:halt | /r/IsA | fn:activity_stop | "halt" | "activity stop" | "/r/is a" |  | "FN" |  |
| fn:motion | /r/HasSubevent | fn:halt | "motion" | "halt" | "/r/has subevent" |  | "FN" |  |
| fn:halt | fn:HasLexicalUnit | fn:lu:halt:stop | "halt" | "stop" | "has lexical unit" |  | "FN" |  |
| fn:halt | fn:HasLexicalUnit | fn:lu:halt:halt | "halt" | "halt" | "has lexical unit" |  | "FN" |  |
| fn:halt | fn:HasLexicalUnit | fn:lu:halt:to_a_halt | "halt" | "to a halt" | "has lexical unit" |  | "FN" |  |
| fn:halt | fn:HasLexicalUnit | fn:lu:halt:to_a_stop | "halt" | "to a stop" | "has lexical unit" |  | "FN" |  |
| fn:halt | /r/HasA | fn:fe:purpose | "halt" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:halt | /r/HasA | fn:fe:place | "halt" | "place" | "/r/has a" |  | "FN" |  |
| fn:halt | /r/HasA | fn:fe:time | "halt" | "time" | "/r/has a" |  | "FN" |  |
| fn:halt | /r/HasA | fn:fe:depictive | "halt" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:halt | /r/HasA | fn:fe:manner | "halt" | "manner" | "/r/has a" |  | "FN" |  |
| fn:halt | /r/HasA | fn:fe:theme | "halt" | "theme" | "/r/has a" |  | "FN" |  |
| fn:halt | /r/HasA | fn:fe:duration | "halt" | "duration" | "/r/has a" |  | "FN" |  |
| fn:halt | /r/HasA | fn:fe:means | "halt" | "means" | "/r/has a" |  | "FN" |  |
| fn:halt | /r/HasA | fn:fe:co-timed_event | "halt" | "co-timed event" | "/r/has a" |  | "FN" |  |
| fn:halt | /r/HasA | fn:fe:explanation | "halt" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:halt | /r/HasA | fn:fe:period_of_iterations | "halt" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:halt | /r/HasA | fn:fe:containing_event | "halt" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:have_as_requirement | /r/IsA | fn:contingency | "have as requirement" | "contingency" | "/r/is a" |  | "FN" |  |
| fn:have_as_requirement | /r/UsedFor | fn:needing | "have as requirement" | "needing" | "/r/used for" |  | "FN" |  |
| fn:have_as_requirement | /r/IsA | fn:requirement_scenario | "have as requirement" | "requirement scenario" | "/r/is a" |  | "FN" |  |
| fn:have_as_requirement | fn:HasLexicalUnit | fn:lu:have_as_requirement:demand | "have as requirement" | "demand" | "has lexical unit" |  | "FN" |  |
| fn:have_as_requirement | fn:HasLexicalUnit | fn:lu:have_as_requirement:require | "have as requirement" | "require" | "has lexical unit" |  | "FN" |  |
| fn:have_as_requirement | fn:HasLexicalUnit | fn:lu:have_as_requirement:take | "have as requirement" | "take" | "has lexical unit" |  | "FN" |  |
| fn:have_as_requirement | fn:HasLexicalUnit | fn:lu:have_as_requirement:need | "have as requirement" | "need" | "has lexical unit" |  | "FN" |  |
| fn:have_as_requirement | /r/HasA | fn:fe:dependent | "have as requirement" | "dependent" | "/r/has a" |  | "FN" |  |
| fn:have_as_requirement | /r/HasA | fn:fe:requirement | "have as requirement" | "requirement" | "/r/has a" |  | "FN" |  |
| fn:have_as_requirement | /r/HasA | fn:fe:degree | "have as requirement" | "degree" | "/r/has a" |  | "FN" |  |
| fn:have_as_requirement | /r/HasA | fn:fe:explanation | "have as requirement" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:have_as_requirement | /r/HasA | fn:fe:time | "have as requirement" | "time" | "/r/has a" |  | "FN" |  |
| fn:have_as_requirement | /r/HasA | fn:fe:condition | "have as requirement" | "condition" | "/r/has a" |  | "FN" |  |
| fn:have_as_requirement | /r/HasA | fn:fe:domain | "have as requirement" | "domain" | "/r/has a" |  | "FN" |  |
| fn:fe:required_entity | /r/RelatedTo | fn:fe:requirement | "required entity" | "requirement" | "/r/related to" |  | "FN" |  |
| fn:have_as_requirement | /r/HasA | fn:fe:required_entity | "have as requirement" | "required entity" | "/r/has a" |  | "FN" |  |
| fn:have_as_requirement | /r/HasA | fn:fe:required_individual | "have as requirement" | "required individual" | "/r/has a" |  | "FN" |  |
| fn:have_as_requirement | /r/HasA | fn:fe:place | "have as requirement" | "place" | "/r/has a" |  | "FN" |  |
| fn:translating | /r/UsedFor | fn:have_as_translation_equivalent | "translating" | "have as translation equivalent" | "/r/used for" |  | "FN" |  |
| fn:have_as_translation_equivalent | /r/RelatedTo | fn:be_translation_equivalent | "have as translation equivalent" | "be translation equivalent" | "/r/related to" |  | "FN" |  |
| fn:have_as_translation_equivalent | fn:HasLexicalUnit | fn:lu:have_as_translation_equivalent:translate | "have as translation equivalent" | "translate" | "has lexical unit" |  | "FN" |  |
| fn:have_as_translation_equivalent | /r/HasA | fn:fe:source_symbol | "have as translation equivalent" | "source symbol" | "/r/has a" |  | "FN" |  |
| fn:have_as_translation_equivalent | /r/HasA | fn:fe:source_representation | "have as translation equivalent" | "source representation" | "/r/has a" |  | "FN" |  |
| fn:have_as_translation_equivalent | /r/HasA | fn:fe:time | "have as translation equivalent" | "time" | "/r/has a" |  | "FN" |  |
| fn:have_as_translation_equivalent | /r/HasA | fn:fe:circumstances | "have as translation equivalent" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:have_as_translation_equivalent | /r/HasA | fn:fe:target_symbol | "have as translation equivalent" | "target symbol" | "/r/has a" |  | "FN" |  |
| fn:have_as_translation_equivalent | /r/HasA | fn:fe:target_representation | "have as translation equivalent" | "target representation" | "/r/has a" |  | "FN" |  |
| fn:have_as_translation_equivalent | /r/HasA | fn:fe:content | "have as translation equivalent" | "content" | "/r/has a" |  | "FN" |  |
| fn:have_as_translation_equivalent | /r/HasA | fn:fe:equivalence | "have as translation equivalent" | "equivalence" | "/r/has a" |  | "FN" |  |
| fn:have_as_translation_equivalent | /r/HasA | fn:fe:medium | "have as translation equivalent" | "medium" | "/r/has a" |  | "FN" |  |
| fn:existence | /r/UsedFor | fn:have_associated | "existence" | "have associated" | "/r/used for" |  | "FN" |  |
| fn:have_associated | fn:HasLexicalUnit | fn:lu:have_associated:have | "have associated" | "have" | "has lexical unit" |  | "FN" |  |
| fn:have_associated | fn:HasLexicalUnit | fn:lu:have_associated:have_got | "have associated" | "have got" | "has lexical unit" |  | "FN" |  |
| fn:have_associated | fn:HasLexicalUnit | fn:lu:have_associated:with | "have associated" | "with" | "has lexical unit" |  | "FN" |  |
| fn:have_associated | /r/HasA | fn:fe:entity | "have associated" | "entity" | "/r/has a" |  | "FN" |  |
| fn:have_associated | /r/HasA | fn:fe:time | "have associated" | "time" | "/r/has a" |  | "FN" |  |
| fn:have_associated | /r/HasA | fn:fe:duration | "have associated" | "duration" | "/r/has a" |  | "FN" |  |
| fn:have_associated | /r/HasA | fn:fe:explanation | "have associated" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:have_associated | /r/HasA | fn:fe:place | "have associated" | "place" | "/r/has a" |  | "FN" |  |
| fn:have_associated | /r/HasA | fn:fe:circumstances | "have associated" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:have_associated | /r/HasA | fn:fe:viewpoint | "have associated" | "viewpoint" | "/r/has a" |  | "FN" |  |
| fn:have_associated | /r/HasA | fn:fe:concessive | "have associated" | "concessive" | "/r/has a" |  | "FN" |  |
| fn:have_associated | /r/HasA | fn:fe:depictive | "have associated" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:have_associated | /r/HasA | fn:fe:topical_entity | "have associated" | "topical entity" | "/r/has a" |  | "FN" |  |
| fn:have_associated | /r/HasA | fn:fe:period_of_iterations | "have associated" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:receive_visitor_scenario | /r/HasSubevent | fn:have_visitor_over | "receive visitor scenario" | "have visitor over" | "/r/has subevent" |  | "FN" |  |
| fn:have_visitor_over | fn:HasLexicalUnit | fn:lu:have_visitor_over:have_over | "have visitor over" | "have over" | "has lexical unit" |  | "FN" |  |
| fn:have_visitor_over | /r/HasA | fn:fe:host | "have visitor over" | "host" | "/r/has a" |  | "FN" |  |
| fn:have_visitor_over | /r/HasA | fn:fe:visitor | "have visitor over" | "visitor" | "/r/has a" |  | "FN" |  |
| fn:have_visitor_over | /r/HasA | fn:fe:purpose | "have visitor over" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:having_commercial_agreement | /r/IsA | fn:be_in_agreement_on_action | "having commercial agreement" | "be in agreement on action" | "/r/is a" |  | "FN" |  |
| fn:commerce_scenario | /r/HasSubevent | fn:having_commercial_agreement | "commerce scenario" | "having commercial agreement" | "/r/has subevent" |  | "FN" |  |
| fn:having_commercial_agreement | /r/HasA | fn:fe:party_1 | "having commercial agreement" | "party 1" | "/r/has a" |  | "FN" |  |
| fn:having_commercial_agreement | /r/HasA | fn:fe:party_2 | "having commercial agreement" | "party 2" | "/r/has a" |  | "FN" |  |
| fn:having_commercial_agreement | /r/HasA | fn:fe:obligation | "having commercial agreement" | "obligation" | "/r/has a" |  | "FN" |  |
| fn:having_commercial_agreement | /r/HasA | fn:fe:topic | "having commercial agreement" | "topic" | "/r/has a" |  | "FN" |  |
| fn:having_commercial_agreement | /r/HasA | fn:fe:medium | "having commercial agreement" | "medium" | "/r/has a" |  | "FN" |  |
| fn:having_commercial_agreement | /r/HasA | fn:fe:parties | "having commercial agreement" | "parties" | "/r/has a" |  | "FN" |  |
| fn:having_commercial_agreement | /r/HasA | fn:fe:place | "having commercial agreement" | "place" | "/r/has a" |  | "FN" |  |
| fn:having_commercial_agreement | /r/HasA | fn:fe:time | "having commercial agreement" | "time" | "/r/has a" |  | "FN" |  |
| fn:having_or_lacking_access | /r/IsA | fn:capability | "having or lacking access" | "capability" | "/r/is a" |  | "FN" |  |
| fn:arriving | /r/UsedFor | fn:having_or_lacking_access | "arriving" | "having or lacking access" | "/r/used for" |  | "FN" |  |
| fn:having_or_lacking_access | /r/IsA | fn:access_scenario | "having or lacking access" | "access scenario" | "/r/is a" |  | "FN" |  |
| fn:having_or_lacking_access | fn:HasLexicalUnit | fn:lu:having_or_lacking_access:access | "having or lacking access" | "access" | "has lexical unit" |  | "FN" |  |
| fn:having_or_lacking_access | fn:HasLexicalUnit | fn:lu:having_or_lacking_access:blocked | "having or lacking access" | "blocked" | "has lexical unit" |  | "FN" |  |
| fn:having_or_lacking_access | fn:HasLexicalUnit | fn:lu:having_or_lacking_access:accessible | "having or lacking access" | "accessible" | "has lexical unit" |  | "FN" |  |
| fn:having_or_lacking_access | fn:HasLexicalUnit | fn:lu:having_or_lacking_access:inaccessible | "having or lacking access" | "inaccessible" | "has lexical unit" |  | "FN" |  |
| fn:having_or_lacking_access | fn:HasLexicalUnit | fn:lu:having_or_lacking_access:access | "having or lacking access" | "access" | "has lexical unit" |  | "FN" |  |
| fn:having_or_lacking_access | /r/HasA | fn:fe:theme | "having or lacking access" | "theme" | "/r/has a" |  | "FN" |  |
| fn:having_or_lacking_access | /r/HasA | fn:fe:degree | "having or lacking access" | "degree" | "/r/has a" |  | "FN" |  |
| fn:having_or_lacking_access | /r/HasA | fn:fe:circumstances | "having or lacking access" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:having_or_lacking_access | /r/HasA | fn:fe:explanation | "having or lacking access" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:having_or_lacking_access | /r/HasA | fn:fe:useful_location | "having or lacking access" | "useful location" | "/r/has a" |  | "FN" |  |
| fn:having_or_lacking_access | /r/HasA | fn:fe:barrier | "having or lacking access" | "barrier" | "/r/has a" |  | "FN" |  |
| fn:health_response | /r/IsA | fn:inclination | "health response" | "inclination" | "/r/is a" |  | "FN" |  |
| fn:response | /r/UsedFor | fn:health_response | "response" | "health response" | "/r/used for" |  | "FN" |  |
| fn:health_response | fn:HasLexicalUnit | fn:lu:health_response:allergic | "health response" | "allergic" | "has lexical unit" |  | "FN" |  |
| fn:health_response | fn:HasLexicalUnit | fn:lu:health_response:allergy | "health response" | "allergy" | "has lexical unit" |  | "FN" |  |
| fn:health_response | fn:HasLexicalUnit | fn:lu:health_response:sensitive | "health response" | "sensitive" | "has lexical unit" |  | "FN" |  |
| fn:health_response | fn:HasLexicalUnit | fn:lu:health_response:sensitivity | "health response" | "sensitivity" | "has lexical unit" |  | "FN" |  |
| fn:health_response | fn:HasLexicalUnit | fn:lu:health_response:susceptible | "health response" | "susceptible" | "has lexical unit" |  | "FN" |  |
| fn:health_response | fn:HasLexicalUnit | fn:lu:health_response:susceptibility | "health response" | "susceptibility" | "has lexical unit" |  | "FN" |  |
| fn:health_response | /r/HasA | fn:fe:protagonist | "health response" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:health_response | /r/HasA | fn:fe:trigger | "health response" | "trigger" | "/r/has a" |  | "FN" |  |
| fn:health_response | /r/HasA | fn:fe:manner | "health response" | "manner" | "/r/has a" |  | "FN" |  |
| fn:health_response | /r/HasA | fn:fe:degree | "health response" | "degree" | "/r/has a" |  | "FN" |  |
| fn:health_response | /r/HasA | fn:fe:body_part | "health response" | "body part" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:hearsay | "communication" | "hearsay" | "/r/used for" |  | "FN" |  |
| fn:hearsay | /r/SimilarTo | fn:perception_experience | "hearsay" | "perception experience" | "/r/similar to" |  | "FN" |  |
| fn:hearsay | fn:HasLexicalUnit | fn:lu:hearsay:hear | "hearsay" | "hear" | "has lexical unit" |  | "FN" |  |
| fn:hearsay | fn:HasLexicalUnit | fn:lu:hearsay:read | "hearsay" | "read" | "has lexical unit" |  | "FN" |  |
| fn:hearsay | /r/HasA | fn:fe:speaker | "hearsay" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:fe:hearer | /r/IsA | fn:st:sentient | "hearer" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:hearsay | /r/HasA | fn:fe:hearer | "hearsay" | "hearer" | "/r/has a" |  | "FN" |  |
| fn:hearsay | /r/HasA | fn:fe:message | "hearsay" | "message" | "/r/has a" |  | "FN" |  |
| fn:hearsay | /r/HasA | fn:fe:topic | "hearsay" | "topic" | "/r/has a" |  | "FN" |  |
| fn:hearsay | /r/HasA | fn:fe:medium | "hearsay" | "medium" | "/r/has a" |  | "FN" |  |
| fn:hearsay | /r/HasA | fn:fe:period_of_iterations | "hearsay" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:hearsay | /r/HasA | fn:fe:time | "hearsay" | "time" | "/r/has a" |  | "FN" |  |
| fn:subjective_temperature | /r/UsedFor | fn:heat_potential | "subjective temperature" | "heat potential" | "/r/used for" |  | "FN" |  |
| fn:temperature | /r/UsedFor | fn:heat_potential | "temperature" | "heat potential" | "/r/used for" |  | "FN" |  |
| fn:heat_potential | fn:HasLexicalUnit | fn:lu:heat_potential:warm | "heat potential" | "warm" | "has lexical unit" |  | "FN" |  |
| fn:heat_potential | fn:HasLexicalUnit | fn:lu:heat_potential:toasty | "heat potential" | "toasty" | "has lexical unit" |  | "FN" |  |
| fn:heat_potential | /r/HasA | fn:fe:insulator | "heat potential" | "insulator" | "/r/has a" |  | "FN" |  |
| fn:heat_potential | /r/HasA | fn:fe:activity | "heat potential" | "activity" | "/r/has a" |  | "FN" |  |
| fn:heat_potential | /r/HasA | fn:fe:circumstances | "heat potential" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:heat_potential | /r/HasA | fn:fe:degree | "heat potential" | "degree" | "/r/has a" |  | "FN" |  |
| fn:heat_potential | /r/HasA | fn:fe:experiencer | "heat potential" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:hedging | /r/RelatedTo | fn:degree | "hedging" | "degree" | "/r/related to" |  | "FN" |  |
| fn:hedging | /r/RelatedTo | fn:proportional_quantity | "hedging" | "proportional quantity" | "/r/related to" |  | "FN" |  |
| fn:hedging | fn:HasLexicalUnit | fn:lu:hedging:a_bit | "hedging" | "a bit" | "has lexical unit" |  | "FN" |  |
| fn:hedging | fn:HasLexicalUnit | fn:lu:hedging:sort_of | "hedging" | "sort of" | "has lexical unit" |  | "FN" |  |
| fn:hedging | fn:HasLexicalUnit | fn:lu:hedging:like | "hedging" | "like" | "has lexical unit" |  | "FN" |  |
| fn:hedging | fn:HasLexicalUnit | fn:lu:hedging:kind_of | "hedging" | "kind of" | "has lexical unit" |  | "FN" |  |
| fn:hedging | fn:HasLexicalUnit | fn:lu:hedging:on_the_side | "hedging" | "on the side" | "has lexical unit" |  | "FN" |  |
| fn:hedging | fn:HasLexicalUnit | fn:lu:hedging:something | "hedging" | "something" | "has lexical unit" |  | "FN" |  |
| fn:hedging | fn:HasLexicalUnit | fn:lu:hedging:in_a_way | "hedging" | "in a way" | "has lexical unit" |  | "FN" |  |
| fn:hedging | fn:HasLexicalUnit | fn:lu:hedging:rather | "hedging" | "rather" | "has lexical unit" |  | "FN" |  |
| fn:hedging | /r/HasA | fn:fe:hedged_content | "hedging" | "hedged content" | "/r/has a" |  | "FN" |  |
| fn:heralding | /r/IsA | fn:intentionally_act | "heralding" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:heralding | fn:HasLexicalUnit | fn:lu:heralding:herald | "heralding" | "herald" | "has lexical unit" |  | "FN" |  |
| fn:heralding | /r/HasA | fn:fe:communicator | "heralding" | "communicator" | "/r/has a" |  | "FN" |  |
| fn:heralding | /r/HasA | fn:fe:place | "heralding" | "place" | "/r/has a" |  | "FN" |  |
| fn:heralding | /r/HasA | fn:fe:purpose | "heralding" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:heralding | /r/HasA | fn:fe:time | "heralding" | "time" | "/r/has a" |  | "FN" |  |
| fn:heralding | /r/HasA | fn:fe:means | "heralding" | "means" | "/r/has a" |  | "FN" |  |
| fn:heralding | /r/HasA | fn:fe:manner | "heralding" | "manner" | "/r/has a" |  | "FN" |  |
| fn:heralding | /r/HasA | fn:fe:individual | "heralding" | "individual" | "/r/has a" |  | "FN" |  |
| fn:fe:event | /r/RelatedTo | fn:fe:individual | "event" | "individual" | "/r/related to" |  | "FN" |  |
| fn:heralding | /r/HasA | fn:fe:event | "heralding" | "event" | "/r/has a" |  | "FN" |  |
| fn:heralding | /r/HasA | fn:fe:medium | "heralding" | "medium" | "/r/has a" |  | "FN" |  |
| fn:hiding_objects | /r/IsA | fn:intentionally_affect | "hiding objects" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:hiding_objects | /r/Causes | fn:eclipse | "hiding objects" | "eclipse" | "/r/causes" |  | "FN" |  |
| fn:hiding_objects | fn:HasLexicalUnit | fn:lu:hiding_objects:hide | "hiding objects" | "hide" | "has lexical unit" |  | "FN" |  |
| fn:hiding_objects | fn:HasLexicalUnit | fn:lu:hiding_objects:conceal | "hiding objects" | "conceal" | "has lexical unit" |  | "FN" |  |
| fn:hiding_objects | fn:HasLexicalUnit | fn:lu:hiding_objects:mask | "hiding objects" | "mask" | "has lexical unit" |  | "FN" |  |
| fn:hiding_objects | fn:HasLexicalUnit | fn:lu:hiding_objects:shroud | "hiding objects" | "shroud" | "has lexical unit" |  | "FN" |  |
| fn:hiding_objects | fn:HasLexicalUnit | fn:lu:hiding_objects:camouflage | "hiding objects" | "camouflage" | "has lexical unit" |  | "FN" |  |
| fn:hiding_objects | fn:HasLexicalUnit | fn:lu:hiding_objects:block | "hiding objects" | "block" | "has lexical unit" |  | "FN" |  |
| fn:hiding_objects | fn:HasLexicalUnit | fn:lu:hiding_objects:cover | "hiding objects" | "cover" | "has lexical unit" |  | "FN" |  |
| fn:fe:obstruction | /r/IsA | fn:st:physical_entity | "obstruction" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:hiding_objects | /r/HasA | fn:fe:obstruction | "hiding objects" | "obstruction" | "/r/has a" |  | "FN" |  |
| fn:hiding_objects | /r/HasA | fn:fe:hidden_object | "hiding objects" | "hidden object" | "/r/has a" |  | "FN" |  |
| fn:hiding_objects | /r/HasA | fn:fe:potential_observer | "hiding objects" | "potential observer" | "/r/has a" |  | "FN" |  |
| fn:hiding_objects | /r/HasA | fn:fe:degree | "hiding objects" | "degree" | "/r/has a" |  | "FN" |  |
| fn:hiding_objects | /r/HasA | fn:fe:agent | "hiding objects" | "agent" | "/r/has a" |  | "FN" |  |
| fn:hiding_objects | /r/HasA | fn:fe:hiding_place | "hiding objects" | "hiding place" | "/r/has a" |  | "FN" |  |
| fn:hiding_objects | /r/HasA | fn:fe:place | "hiding objects" | "place" | "/r/has a" |  | "FN" |  |
| fn:hiding_objects | /r/HasA | fn:fe:time | "hiding objects" | "time" | "/r/has a" |  | "FN" |  |
| fn:hiding_objects | /r/HasA | fn:fe:explanation | "hiding objects" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:hiding_objects | /r/HasA | fn:fe:means | "hiding objects" | "means" | "/r/has a" |  | "FN" |  |
| fn:hiding_objects | /r/HasA | fn:fe:purpose | "hiding objects" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:hiding_objects | /r/HasA | fn:fe:manner | "hiding objects" | "manner" | "/r/has a" |  | "FN" |  |
| fn:event | /r/UsedFor | fn:hindering | "event" | "hindering" | "/r/used for" |  | "FN" |  |
| fn:hindering | /r/UsedFor | fn:difficulty | "hindering" | "difficulty" | "/r/used for" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:hinder | "hindering" | "hinder" | "has lexical unit" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:hamper | "hindering" | "hamper" | "has lexical unit" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:impede | "hindering" | "impede" | "has lexical unit" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:obstruct | "hindering" | "obstruct" | "has lexical unit" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:trammel | "hindering" | "trammel" | "has lexical unit" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:constrain | "hindering" | "constrain" | "has lexical unit" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:handicap | "hindering" | "handicap" | "has lexical unit" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:inhibit | "hindering" | "inhibit" | "has lexical unit" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:encumber | "hindering" | "encumber" | "has lexical unit" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:delay | "hindering" | "delay" | "has lexical unit" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:retard | "hindering" | "retard" | "has lexical unit" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:hindrance | "hindering" | "hindrance" | "has lexical unit" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:impediment | "hindering" | "impediment" | "has lexical unit" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:encumbrance | "hindering" | "encumbrance" | "has lexical unit" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:obstruction_[act] | "hindering" | "obstruction [act]" | "has lexical unit" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:obstruction_[entity] | "hindering" | "obstruction [entity]" | "has lexical unit" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:obstructive | "hindering" | "obstructive" | "has lexical unit" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:interfere | "hindering" | "interfere" | "has lexical unit" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:interference | "hindering" | "interference" | "has lexical unit" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:hurdle | "hindering" | "hurdle" | "has lexical unit" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:hardship | "hindering" | "hardship" | "has lexical unit" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:block | "hindering" | "block" | "has lexical unit" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:repress | "hindering" | "repress" | "has lexical unit" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:repressive | "hindering" | "repressive" | "has lexical unit" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:restrain | "hindering" | "restrain" | "has lexical unit" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:restraint | "hindering" | "restraint" | "has lexical unit" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:slow | "hindering" | "slow" | "has lexical unit" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:hold_back | "hindering" | "hold back" | "has lexical unit" |  | "FN" |  |
| fn:hindering | fn:HasLexicalUnit | fn:lu:hindering:curtail | "hindering" | "curtail" | "has lexical unit" |  | "FN" |  |
| fn:fe:protagonist | /r/HasPrerequisite | fn:fe:action | "protagonist" | "action" | "/r/has prerequisite" |  | "FN" |  |
| fn:hindering | /r/HasA | fn:fe:protagonist | "hindering" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:hindering | /r/HasA | fn:fe:hindrance | "hindering" | "hindrance" | "/r/has a" |  | "FN" |  |
| fn:hindering | /r/HasA | fn:fe:action | "hindering" | "action" | "/r/has a" |  | "FN" |  |
| fn:hindering | /r/HasA | fn:fe:time | "hindering" | "time" | "/r/has a" |  | "FN" |  |
| fn:hindering | /r/HasA | fn:fe:place | "hindering" | "place" | "/r/has a" |  | "FN" |  |
| fn:hindering | /r/HasA | fn:fe:degree | "hindering" | "degree" | "/r/has a" |  | "FN" |  |
| fn:hindering | /r/HasA | fn:fe:means | "hindering" | "means" | "/r/has a" |  | "FN" |  |
| fn:hindering | /r/HasA | fn:fe:explanation | "hindering" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:hindering | /r/HasA | fn:fe:manner | "hindering" | "manner" | "/r/has a" |  | "FN" |  |
| fn:hindering | /r/HasA | fn:fe:duration | "hindering" | "duration" | "/r/has a" |  | "FN" |  |
| fn:hindering | /r/HasA | fn:fe:concessive | "hindering" | "concessive" | "/r/has a" |  | "FN" |  |
| fn:hindering | /r/HasA | fn:fe:frequency | "hindering" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:hindering | /r/HasA | fn:fe:circumstances | "hindering" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:hiring | /r/IsA | fn:intentionally_affect | "hiring" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:employer_scenario | /r/HasSubevent | fn:hiring | "employer scenario" | "hiring" | "/r/has subevent" |  | "FN" |  |
| fn:employing | /r/HasPrerequisite | fn:hiring | "employing" | "hiring" | "/r/has prerequisite" |  | "FN" |  |
| fn:hiring | /r/IsA | fn:employment_start | "hiring" | "employment start" | "/r/is a" |  | "FN" |  |
| fn:hiring | fn:HasLexicalUnit | fn:lu:hiring:hire | "hiring" | "hire" | "has lexical unit" |  | "FN" |  |
| fn:hiring | fn:HasLexicalUnit | fn:lu:hiring:sign | "hiring" | "sign" | "has lexical unit" |  | "FN" |  |
| fn:hiring | fn:HasLexicalUnit | fn:lu:hiring:retain | "hiring" | "retain" | "has lexical unit" |  | "FN" |  |
| fn:hiring | fn:HasLexicalUnit | fn:lu:hiring:commission | "hiring" | "commission" | "has lexical unit" |  | "FN" |  |
| fn:hiring | fn:HasLexicalUnit | fn:lu:hiring:take_on | "hiring" | "take on" | "has lexical unit" |  | "FN" |  |
| fn:hiring | fn:HasLexicalUnit | fn:lu:hiring:hire | "hiring" | "hire" | "has lexical unit" |  | "FN" |  |
| fn:hiring | fn:HasLexicalUnit | fn:lu:hiring:give_job | "hiring" | "give job" | "has lexical unit" |  | "FN" |  |
| fn:hiring | fn:HasLexicalUnit | fn:lu:hiring:commission | "hiring" | "commission" | "has lexical unit" |  | "FN" |  |
| fn:hiring | fn:HasLexicalUnit | fn:lu:hiring:contract | "hiring" | "contract" | "has lexical unit" |  | "FN" |  |
| fn:hiring | fn:HasLexicalUnit | fn:lu:hiring:subcontract | "hiring" | "subcontract" | "has lexical unit" |  | "FN" |  |
| fn:hiring | fn:HasLexicalUnit | fn:lu:hiring:sign_on | "hiring" | "sign on" | "has lexical unit" |  | "FN" |  |
| fn:hiring | fn:HasLexicalUnit | fn:lu:hiring:sign_up | "hiring" | "sign up" | "has lexical unit" |  | "FN" |  |
| fn:hiring | /r/HasA | fn:fe:employee | "hiring" | "employee" | "/r/has a" |  | "FN" |  |
| fn:hiring | /r/HasA | fn:fe:employer | "hiring" | "employer" | "/r/has a" |  | "FN" |  |
| fn:hiring | /r/HasA | fn:fe:compensation | "hiring" | "compensation" | "/r/has a" |  | "FN" |  |
| fn:hiring | /r/HasA | fn:fe:manner | "hiring" | "manner" | "/r/has a" |  | "FN" |  |
| fn:hiring | /r/HasA | fn:fe:place | "hiring" | "place" | "/r/has a" |  | "FN" |  |
| fn:hiring | /r/HasA | fn:fe:time | "hiring" | "time" | "/r/has a" |  | "FN" |  |
| fn:hiring | /r/HasA | fn:fe:purpose | "hiring" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:hiring | /r/HasA | fn:fe:task | "hiring" | "task" | "/r/has a" |  | "FN" |  |
| fn:hiring | /r/HasA | fn:fe:position | "hiring" | "position" | "/r/has a" |  | "FN" |  |
| fn:hiring | /r/HasA | fn:fe:field | "hiring" | "field" | "/r/has a" |  | "FN" |  |
| fn:hiring | /r/HasA | fn:fe:instrument | "hiring" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:hiring | /r/HasA | fn:fe:means | "hiring" | "means" | "/r/has a" |  | "FN" |  |
| fn:hiring | /r/HasA | fn:fe:contract_basis | "hiring" | "contract basis" | "/r/has a" |  | "FN" |  |
| fn:hiring | /r/HasA | fn:fe:period_of_iterations | "hiring" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:historic_event | /r/IsA | fn:eventive_affecting | "historic event" | "eventive affecting" | "/r/is a" |  | "FN" |  |
| fn:individual_history | /r/HasSubevent | fn:historic_event | "individual history" | "historic event" | "/r/has subevent" |  | "FN" |  |
| fn:importance | /r/UsedFor | fn:historic_event | "importance" | "historic event" | "/r/used for" |  | "FN" |  |
| fn:historic_event | fn:HasLexicalUnit | fn:lu:historic_event:historic | "historic event" | "historic" | "has lexical unit" |  | "FN" |  |
| fn:historic_event | fn:HasLexicalUnit | fn:lu:historic_event:make_history | "historic event" | "make history" | "has lexical unit" |  | "FN" |  |
| fn:historic_event | fn:HasLexicalUnit | fn:lu:historic_event:historic_[entity] | "historic event" | "historic [entity]" | "has lexical unit" |  | "FN" |  |
| fn:historic_event | /r/HasA | fn:fe:event | "historic event" | "event" | "/r/has a" |  | "FN" |  |
| fn:historic_event | /r/HasA | fn:fe:place | "historic event" | "place" | "/r/has a" |  | "FN" |  |
| fn:historic_event | /r/HasA | fn:fe:time | "historic event" | "time" | "/r/has a" |  | "FN" |  |
| fn:historic_event | /r/HasA | fn:fe:explanation | "historic event" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:historic_event | /r/HasA | fn:fe:entity | "historic event" | "entity" | "/r/has a" |  | "FN" |  |
| fn:historic_event | /r/HasA | fn:fe:manner | "historic event" | "manner" | "/r/has a" |  | "FN" |  |
| fn:historic_event | /r/HasA | fn:fe:domain | "historic event" | "domain" | "/r/has a" |  | "FN" |  |
| fn:historic_event | /r/HasA | fn:fe:degree | "historic event" | "degree" | "/r/has a" |  | "FN" |  |
| fn:history | /r/IsA | fn:individual_history | "history" | "individual history" | "/r/is a" |  | "FN" |  |
| fn:history | /r/IsA | fn:socially_significant_history_scenario | "history" | "socially significant history scenario" | "/r/is a" |  | "FN" |  |
| fn:history | fn:HasLexicalUnit | fn:lu:history:history | "history" | "history" | "has lexical unit" |  | "FN" |  |
| fn:history | /r/HasA | fn:fe:topic | "history" | "topic" | "/r/has a" |  | "FN" |  |
| fn:history | /r/HasA | fn:fe:domain | "history" | "domain" | "/r/has a" |  | "FN" |  |
| fn:history | /r/HasA | fn:fe:end_time | "history" | "end time" | "/r/has a" |  | "FN" |  |
| fn:history | /r/HasA | fn:fe:start_time | "history" | "start time" | "/r/has a" |  | "FN" |  |
| fn:history | /r/HasA | fn:fe:time_span | "history" | "time span" | "/r/has a" |  | "FN" |  |
| fn:history | /r/HasA | fn:fe:duration | "history" | "duration" | "/r/has a" |  | "FN" |  |
| fn:history | /r/HasA | fn:fe:time | "history" | "time" | "/r/has a" |  | "FN" |  |
| fn:socially_significant_history_scenario | /r/IsA | fn:history_scenario | "socially significant history scenario" | "history scenario" | "/r/is a" |  | "FN" |  |
| fn:individual_history | /r/IsA | fn:history_scenario | "individual history" | "history scenario" | "/r/is a" |  | "FN" |  |
| fn:history_scenario | /r/HasA | fn:fe:event | "history scenario" | "event" | "/r/has a" |  | "FN" |  |
| fn:history_scenario | /r/HasA | fn:fe:place | "history scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:history_scenario | /r/HasA | fn:fe:time | "history scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:hit_or_miss | /r/IsA | fn:success_or_failure | "hit or miss" | "success or failure" | "/r/is a" |  | "FN" |  |
| fn:attempt_distant_interaction_scenario | /r/HasSubevent | fn:hit_or_miss | "attempt distant interaction scenario" | "hit or miss" | "/r/has subevent" |  | "FN" |  |
| fn:hit_or_miss | /r/UsedFor | fn:hit_target | "hit or miss" | "hit target" | "/r/used for" |  | "FN" |  |
| fn:hit_or_miss | /r/HasPrerequisite | fn:aiming | "hit or miss" | "aiming" | "/r/has prerequisite" |  | "FN" |  |
| fn:hit_or_miss | fn:HasLexicalUnit | fn:lu:hit_or_miss:hit | "hit or miss" | "hit" | "has lexical unit" |  | "FN" |  |
| fn:hit_or_miss | fn:HasLexicalUnit | fn:lu:hit_or_miss:miss | "hit or miss" | "miss" | "has lexical unit" |  | "FN" |  |
| fn:hit_or_miss | fn:HasLexicalUnit | fn:lu:hit_or_miss:wide | "hit or miss" | "wide" | "has lexical unit" |  | "FN" |  |
| fn:hit_or_miss | fn:HasLexicalUnit | fn:lu:hit_or_miss:hit | "hit or miss" | "hit" | "has lexical unit" |  | "FN" |  |
| fn:hit_or_miss | fn:HasLexicalUnit | fn:lu:hit_or_miss:bullseye | "hit or miss" | "bullseye" | "has lexical unit" |  | "FN" |  |
| fn:hit_or_miss | fn:HasLexicalUnit | fn:lu:hit_or_miss:hole_in_one | "hit or miss" | "hole in one" | "has lexical unit" |  | "FN" |  |
| fn:hit_or_miss | /r/HasA | fn:fe:agent | "hit or miss" | "agent" | "/r/has a" |  | "FN" |  |
| fn:hit_or_miss | /r/HasA | fn:fe:target | "hit or miss" | "target" | "/r/has a" |  | "FN" |  |
| fn:hit_or_miss | /r/HasA | fn:fe:outcome | "hit or miss" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:hit_or_miss | /r/HasA | fn:fe:means | "hit or miss" | "means" | "/r/has a" |  | "FN" |  |
| fn:hit_or_miss | /r/HasA | fn:fe:degree | "hit or miss" | "degree" | "/r/has a" |  | "FN" |  |
| fn:hit_or_miss | /r/HasA | fn:fe:time | "hit or miss" | "time" | "/r/has a" |  | "FN" |  |
| fn:hit_or_miss | /r/HasA | fn:fe:depictive | "hit or miss" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:hit_or_miss | /r/HasA | fn:fe:place | "hit or miss" | "place" | "/r/has a" |  | "FN" |  |
| fn:hit_or_miss | /r/HasA | fn:fe:manner | "hit or miss" | "manner" | "/r/has a" |  | "FN" |  |
| fn:hit_or_miss | /r/HasA | fn:fe:purpose | "hit or miss" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:hit_or_miss | /r/HasA | fn:fe:particular_iteration | "hit or miss" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:hit_or_miss | /r/HasA | fn:fe:circumstances | "hit or miss" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:hit_or_miss | /r/HasA | fn:fe:instrument | "hit or miss" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:hit_or_miss | /r/HasA | fn:fe:target_location | "hit or miss" | "target location" | "/r/has a" |  | "FN" |  |
| fn:hit_or_miss | /r/HasA | fn:fe:iterations | "hit or miss" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:hit_or_miss | /r/HasA | fn:fe:deviation | "hit or miss" | "deviation" | "/r/has a" |  | "FN" |  |
| fn:hit_target | /r/IsA | fn:intentionally_affect | "hit target" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:cause_impact | /r/UsedFor | fn:hit_target | "cause impact" | "hit target" | "/r/used for" |  | "FN" |  |
| fn:hit_or_miss | /r/UsedFor | fn:hit_target | "hit or miss" | "hit target" | "/r/used for" |  | "FN" |  |
| fn:shoot_projectiles | /r/UsedFor | fn:hit_target | "shoot projectiles" | "hit target" | "/r/used for" |  | "FN" |  |
| fn:shooting_scenario | /r/UsedFor | fn:hit_target | "shooting scenario" | "hit target" | "/r/used for" |  | "FN" |  |
| fn:hit_target | fn:HasLexicalUnit | fn:lu:hit_target:shoot | "hit target" | "shoot" | "has lexical unit" |  | "FN" |  |
| fn:hit_target | fn:HasLexicalUnit | fn:lu:hit_target:hit | "hit target" | "hit" | "has lexical unit" |  | "FN" |  |
| fn:hit_target | fn:HasLexicalUnit | fn:lu:hit_target:pick_off | "hit target" | "pick off" | "has lexical unit" |  | "FN" |  |
| fn:hit_target | /r/HasA | fn:fe:target | "hit target" | "target" | "/r/has a" |  | "FN" |  |
| fn:hit_target | /r/HasA | fn:fe:agent | "hit target" | "agent" | "/r/has a" |  | "FN" |  |
| fn:hit_target | /r/HasA | fn:fe:purpose | "hit target" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:hit_target | /r/HasA | fn:fe:time | "hit target" | "time" | "/r/has a" |  | "FN" |  |
| fn:hit_target | /r/HasA | fn:fe:place | "hit target" | "place" | "/r/has a" |  | "FN" |  |
| fn:hit_target | /r/HasA | fn:fe:subregion | "hit target" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:hit_target | /r/HasA | fn:fe:means | "hit target" | "means" | "/r/has a" |  | "FN" |  |
| fn:hit_target | /r/HasA | fn:fe:instrument | "hit target" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:hit_target | /r/HasA | fn:fe:manner | "hit target" | "manner" | "/r/has a" |  | "FN" |  |
| fn:change_event_time | /r/UsedFor | fn:holding_off_on | "change event time" | "holding off on" | "/r/used for" |  | "FN" |  |
| fn:forgoing | /r/UsedFor | fn:holding_off_on | "forgoing" | "holding off on" | "/r/used for" |  | "FN" |  |
| fn:waiting | /r/RelatedTo | fn:holding_off_on | "waiting" | "holding off on" | "/r/related to" |  | "FN" |  |
| fn:holding_off_on | fn:HasLexicalUnit | fn:lu:holding_off_on:hold_off | "holding off on" | "hold off" | "has lexical unit" |  | "FN" |  |
| fn:holding_off_on | fn:HasLexicalUnit | fn:lu:holding_off_on:wait | "holding off on" | "wait" | "has lexical unit" |  | "FN" |  |
| fn:holding_off_on | /r/HasA | fn:fe:agent | "holding off on" | "agent" | "/r/has a" |  | "FN" |  |
| fn:fe:desirable_action | /r/RelatedTo | fn:fe:salient_entity | "desirable action" | "salient entity" | "/r/related to" |  | "FN" |  |
| fn:holding_off_on | /r/HasA | fn:fe:desirable_action | "holding off on" | "desirable action" | "/r/has a" |  | "FN" |  |
| fn:holding_off_on | /r/HasA | fn:fe:degree | "holding off on" | "degree" | "/r/has a" |  | "FN" |  |
| fn:holding_off_on | /r/HasA | fn:fe:manner | "holding off on" | "manner" | "/r/has a" |  | "FN" |  |
| fn:holding_off_on | /r/HasA | fn:fe:means | "holding off on" | "means" | "/r/has a" |  | "FN" |  |
| fn:holding_off_on | /r/HasA | fn:fe:place | "holding off on" | "place" | "/r/has a" |  | "FN" |  |
| fn:holding_off_on | /r/HasA | fn:fe:time | "holding off on" | "time" | "/r/has a" |  | "FN" |  |
| fn:holding_off_on | /r/HasA | fn:fe:purpose | "holding off on" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:holding_off_on | /r/HasA | fn:fe:explanation | "holding off on" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:holding_off_on | /r/HasA | fn:fe:circumstances | "holding off on" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:holding_off_on | /r/HasA | fn:fe:salient_entity | "holding off on" | "salient entity" | "/r/has a" |  | "FN" |  |
| fn:holding_off_on | /r/HasA | fn:fe:duration | "holding off on" | "duration" | "/r/has a" |  | "FN" |  |
| fn:holding_off_on | /r/HasA | fn:fe:end_point | "holding off on" | "end point" | "/r/has a" |  | "FN" |  |
| fn:hospitality | /r/IsA | fn:social_interaction_evaluation | "hospitality" | "social interaction evaluation" | "/r/is a" |  | "FN" |  |
| fn:guest_and_host | /r/UsedFor | fn:hospitality | "guest and host" | "hospitality" | "/r/used for" |  | "FN" |  |
| fn:hospitality | fn:HasLexicalUnit | fn:lu:hospitality:hospitality | "hospitality" | "hospitality" | "has lexical unit" |  | "FN" |  |
| fn:hospitality | fn:HasLexicalUnit | fn:lu:hospitality:hospitable | "hospitality" | "hospitable" | "has lexical unit" |  | "FN" |  |
| fn:hospitality | fn:HasLexicalUnit | fn:lu:hospitality:red_carpet | "hospitality" | "red carpet" | "has lexical unit" |  | "FN" |  |
| fn:hospitality | /r/HasA | fn:fe:host | "hospitality" | "host" | "/r/has a" |  | "FN" |  |
| fn:hospitality | /r/HasA | fn:fe:guest | "hospitality" | "guest" | "/r/has a" |  | "FN" |  |
| fn:hospitality | /r/HasA | fn:fe:behavior | "hospitality" | "behavior" | "/r/has a" |  | "FN" |  |
| fn:hospitality | /r/HasA | fn:fe:degree | "hospitality" | "degree" | "/r/has a" |  | "FN" |  |
| fn:hospitality | /r/HasA | fn:fe:topic | "hospitality" | "topic" | "/r/has a" |  | "FN" |  |
| fn:hospitality | /r/HasA | fn:fe:expressor | "hospitality" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:hospitality | /r/HasA | fn:fe:manner | "hospitality" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fe:judge | /r/IsA | fn:st:human | "judge" | "human" | "/r/is a" |  | "FN" |  |
| fn:hospitality | /r/HasA | fn:fe:judge | "hospitality" | "judge" | "/r/has a" |  | "FN" |  |
| fn:fighting_activity | /r/IsA | fn:hostile_encounter | "fighting activity" | "hostile encounter" | "/r/is a" |  | "FN" |  |
| fn:hostile_encounter | /r/IsA | fn:intentionally_act | "hostile encounter" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:hostile_encounter | /r/UsedFor | fn:firefighting | "hostile encounter" | "firefighting" | "/r/used for" |  | "FN" |  |
| fn:hostile_encounter | /r/UsedFor | fn:friendly_or_hostile | "hostile encounter" | "friendly or hostile" | "/r/used for" |  | "FN" |  |
| fn:hostile_encounter | /r/UsedFor | fn:irregular_combatants | "hostile encounter" | "irregular combatants" | "/r/used for" |  | "FN" |  |
| fn:hostile_encounter | /r/UsedFor | fn:member_of_military | "hostile encounter" | "member of military" | "/r/used for" |  | "FN" |  |
| fn:taking_sides | /r/UsedFor | fn:hostile_encounter | "taking sides" | "hostile encounter" | "/r/used for" |  | "FN" |  |
| fn:attack | /r/IsA | fn:hostile_encounter | "attack" | "hostile encounter" | "/r/is a" |  | "FN" |  |
| fn:hostile_encounter | /r/SimilarTo | fn:firefighting | "hostile encounter" | "firefighting" | "/r/similar to" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:battle | "hostile encounter" | "battle" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:fight | "hostile encounter" | "fight" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:scuffle | "hostile encounter" | "scuffle" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:spat | "hostile encounter" | "spat" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:altercation | "hostile encounter" | "altercation" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:duel | "hostile encounter" | "duel" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:clash | "hostile encounter" | "clash" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:confrontation | "hostile encounter" | "confrontation" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:row | "hostile encounter" | "row" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:fighting | "hostile encounter" | "fighting" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:bout | "hostile encounter" | "bout" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:struggle | "hostile encounter" | "struggle" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:hostility | "hostile encounter" | "hostility" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:skirmish | "hostile encounter" | "skirmish" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:combat | "hostile encounter" | "combat" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:squabble | "hostile encounter" | "squabble" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:stalemate | "hostile encounter" | "stalemate" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:brawl | "hostile encounter" | "brawl" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:strife | "hostile encounter" | "strife" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:fight | "hostile encounter" | "fight" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:battle | "hostile encounter" | "battle" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:duel | "hostile encounter" | "duel" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:clash | "hostile encounter" | "clash" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:brawl | "hostile encounter" | "brawl" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:skirmish | "hostile encounter" | "skirmish" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:scuffle | "hostile encounter" | "scuffle" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:confront | "hostile encounter" | "confront" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:war | "hostile encounter" | "war" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:war | "hostile encounter" | "war" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:gunfight | "hostile encounter" | "gunfight" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:shootout | "hostile encounter" | "shootout" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:standoff | "hostile encounter" | "standoff" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:showdown | "hostile encounter" | "showdown" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:wrangling | "hostile encounter" | "wrangling" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:tiff | "hostile encounter" | "tiff" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:fistfight | "hostile encounter" | "fistfight" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:firefight | "hostile encounter" | "firefight" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:conflict | "hostile encounter" | "conflict" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:dust-up | "hostile encounter" | "dust-up" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:warfare | "hostile encounter" | "warfare" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:cw | "hostile encounter" | "cw" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:bw | "hostile encounter" | "bw" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:tussle | "hostile encounter" | "tussle" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:struggle | "hostile encounter" | "struggle" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:infighting | "hostile encounter" | "infighting" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:engage | "hostile encounter" | "engage" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | fn:HasLexicalUnit | fn:lu:hostile_encounter:engagement | "hostile encounter" | "engagement" | "has lexical unit" |  | "FN" |  |
| fn:hostile_encounter | /r/HasA | fn:fe:side_1 | "hostile encounter" | "side 1" | "/r/has a" |  | "FN" |  |
| fn:fe:side_2 | /r/IsA | fn:st:sentient | "side 2" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:hostile_encounter | /r/HasA | fn:fe:side_2 | "hostile encounter" | "side 2" | "/r/has a" |  | "FN" |  |
| fn:fe:sides | /r/IsA | fn:st:sentient | "sides" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:hostile_encounter | /r/HasA | fn:fe:sides | "hostile encounter" | "sides" | "/r/has a" |  | "FN" |  |
| fn:hostile_encounter | /r/HasA | fn:fe:issue | "hostile encounter" | "issue" | "/r/has a" |  | "FN" |  |
| fn:hostile_encounter | /r/HasA | fn:fe:purpose | "hostile encounter" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:hostile_encounter | /r/HasA | fn:fe:means | "hostile encounter" | "means" | "/r/has a" |  | "FN" |  |
| fn:hostile_encounter | /r/HasA | fn:fe:manner | "hostile encounter" | "manner" | "/r/has a" |  | "FN" |  |
| fn:hostile_encounter | /r/HasA | fn:fe:place | "hostile encounter" | "place" | "/r/has a" |  | "FN" |  |
| fn:hostile_encounter | /r/HasA | fn:fe:time | "hostile encounter" | "time" | "/r/has a" |  | "FN" |  |
| fn:hostile_encounter | /r/HasA | fn:fe:degree | "hostile encounter" | "degree" | "/r/has a" |  | "FN" |  |
| fn:hostile_encounter | /r/HasA | fn:fe:depictive | "hostile encounter" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:hostile_encounter | /r/HasA | fn:fe:result | "hostile encounter" | "result" | "/r/has a" |  | "FN" |  |
| fn:hostile_encounter | /r/HasA | fn:fe:duration | "hostile encounter" | "duration" | "/r/has a" |  | "FN" |  |
| fn:hostile_encounter | /r/HasA | fn:fe:explanation | "hostile encounter" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:hostile_encounter | /r/HasA | fn:fe:instrument | "hostile encounter" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:hostile_encounter | /r/HasA | fn:fe:internal_cause | "hostile encounter" | "internal cause" | "/r/has a" |  | "FN" |  |
| fn:hostile_encounter | /r/HasA | fn:fe:particular_iteration | "hostile encounter" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:hunting_scenario | /r/HasSubevent | fn:hunting | "hunting scenario" | "hunting" | "/r/has subevent" |  | "FN" |  |
| fn:hunting | fn:HasLexicalUnit | fn:lu:hunting:hunt | "hunting" | "hunt" | "has lexical unit" |  | "FN" |  |
| fn:hunting | fn:HasLexicalUnit | fn:lu:hunting:fish | "hunting" | "fish" | "has lexical unit" |  | "FN" |  |
| fn:hunting | fn:HasLexicalUnit | fn:lu:hunting:seal | "hunting" | "seal" | "has lexical unit" |  | "FN" |  |
| fn:fe:hunter | /r/IsA | fn:st:sentient | "hunter" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:hunting | /r/HasA | fn:fe:hunter | "hunting" | "hunter" | "/r/has a" |  | "FN" |  |
| fn:hunting | /r/HasA | fn:fe:food | "hunting" | "food" | "/r/has a" |  | "FN" |  |
| fn:hunting | /r/HasA | fn:fe:instrument | "hunting" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:hunting | /r/HasA | fn:fe:duration | "hunting" | "duration" | "/r/has a" |  | "FN" |  |
| fn:hunting | /r/HasA | fn:fe:manner | "hunting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:hunting | /r/HasA | fn:fe:means | "hunting" | "means" | "/r/has a" |  | "FN" |  |
| fn:hunting | /r/HasA | fn:fe:outcome | "hunting" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:hunting | /r/HasA | fn:fe:place | "hunting" | "place" | "/r/has a" |  | "FN" |  |
| fn:hunting | /r/HasA | fn:fe:time | "hunting" | "time" | "/r/has a" |  | "FN" |  |
| fn:hunting | /r/HasA | fn:fe:purpose | "hunting" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:hunting | /r/HasA | fn:fe:frequency | "hunting" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:hunting | /r/HasA | fn:fe:degree | "hunting" | "degree" | "/r/has a" |  | "FN" |  |
| fn:hunting | /r/HasA | fn:fe:ground | "hunting" | "ground" | "/r/has a" |  | "FN" |  |
| fn:hunting | /r/HasA | fn:fe:particular_iteration | "hunting" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:hunting | /r/HasA | fn:fe:co-participant | "hunting" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:hunting_scenario | /r/IsA | fn:attempt_obtain_food_scenario | "hunting scenario" | "attempt obtain food scenario" | "/r/is a" |  | "FN" |  |
| fn:hunting_scenario | /r/HasSubevent | fn:hunting | "hunting scenario" | "hunting" | "/r/has subevent" |  | "FN" |  |
| fn:hunting_scenario | /r/HasSubevent | fn:hunting_success_or_failure | "hunting scenario" | "hunting success or failure" | "/r/has subevent" |  | "FN" |  |
| fn:hunting_scenario | /r/HasA | fn:fe:hunter | "hunting scenario" | "hunter" | "/r/has a" |  | "FN" |  |
| fn:hunting_scenario | /r/HasA | fn:fe:food | "hunting scenario" | "food" | "/r/has a" |  | "FN" |  |
| fn:hunting_scenario | /r/HasA | fn:fe:instrument | "hunting scenario" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:hunting_scenario | /r/HasA | fn:fe:duration | "hunting scenario" | "duration" | "/r/has a" |  | "FN" |  |
| fn:hunting_scenario | /r/HasA | fn:fe:manner | "hunting scenario" | "manner" | "/r/has a" |  | "FN" |  |
| fn:hunting_scenario | /r/HasA | fn:fe:means | "hunting scenario" | "means" | "/r/has a" |  | "FN" |  |
| fn:hunting_scenario | /r/HasA | fn:fe:outcome | "hunting scenario" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:hunting_scenario | /r/HasA | fn:fe:place | "hunting scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:hunting_scenario | /r/HasA | fn:fe:time | "hunting scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:hunting_scenario | /r/HasA | fn:fe:purpose | "hunting scenario" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:hunting_scenario | /r/HasA | fn:fe:frequency | "hunting scenario" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:hunting_scenario | /r/HasA | fn:fe:degree | "hunting scenario" | "degree" | "/r/has a" |  | "FN" |  |
| fn:hunting_scenario | /r/HasA | fn:fe:ground | "hunting scenario" | "ground" | "/r/has a" |  | "FN" |  |
| fn:hunting_scenario | /r/HasA | fn:fe:particular_iteration | "hunting scenario" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:hunting_scenario | /r/HasSubevent | fn:hunting_success_or_failure | "hunting scenario" | "hunting success or failure" | "/r/has subevent" |  | "FN" |  |
| fn:hunting_success_or_failure | fn:HasLexicalUnit | fn:lu:hunting_success_or_failure:bag | "hunting success or failure" | "bag" | "has lexical unit" |  | "FN" |  |
| fn:hunting_success_or_failure | fn:HasLexicalUnit | fn:lu:hunting_success_or_failure:catch | "hunting success or failure" | "catch" | "has lexical unit" |  | "FN" |  |
| fn:hunting_success_or_failure | /r/HasA | fn:fe:hunter | "hunting success or failure" | "hunter" | "/r/has a" |  | "FN" |  |
| fn:hunting_success_or_failure | /r/HasA | fn:fe:food | "hunting success or failure" | "food" | "/r/has a" |  | "FN" |  |
| fn:hunting_success_or_failure | /r/HasA | fn:fe:instrument | "hunting success or failure" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:hunting_success_or_failure | /r/HasA | fn:fe:manner | "hunting success or failure" | "manner" | "/r/has a" |  | "FN" |  |
| fn:hunting_success_or_failure | /r/HasA | fn:fe:means | "hunting success or failure" | "means" | "/r/has a" |  | "FN" |  |
| fn:hunting_success_or_failure | /r/HasA | fn:fe:place | "hunting success or failure" | "place" | "/r/has a" |  | "FN" |  |
| fn:hunting_success_or_failure | /r/HasA | fn:fe:time | "hunting success or failure" | "time" | "/r/has a" |  | "FN" |  |
| fn:hunting_success_or_failure | /r/HasA | fn:fe:purpose | "hunting success or failure" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:hunting_success_or_failure | /r/HasA | fn:fe:frequency | "hunting success or failure" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:hunting_success_or_failure | /r/HasA | fn:fe:degree | "hunting success or failure" | "degree" | "/r/has a" |  | "FN" |  |
| fn:hunting_success_or_failure | /r/HasA | fn:fe:particular_iteration | "hunting success or failure" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:identicality | /r/IsA | fn:relation | "identicality" | "relation" | "/r/is a" |  | "FN" |  |
| fn:instance | /r/UsedFor | fn:identicality | "instance" | "identicality" | "/r/used for" |  | "FN" |  |
| fn:identicality | /r/IsA | fn:identity_scenario | "identicality" | "identity scenario" | "/r/is a" |  | "FN" |  |
| fn:identicality | fn:HasLexicalUnit | fn:lu:identicality:same | "identicality" | "same" | "has lexical unit" |  | "FN" |  |
| fn:identicality | fn:HasLexicalUnit | fn:lu:identicality:different | "identicality" | "different" | "has lexical unit" |  | "FN" |  |
| fn:identicality | fn:HasLexicalUnit | fn:lu:identicality:identical | "identicality" | "identical" | "has lexical unit" |  | "FN" |  |
| fn:identicality | fn:HasLexicalUnit | fn:lu:identicality:distinct | "identicality" | "distinct" | "has lexical unit" |  | "FN" |  |
| fn:identicality | fn:HasLexicalUnit | fn:lu:identicality:identity | "identicality" | "identity" | "has lexical unit" |  | "FN" |  |
| fn:identicality | /r/HasA | fn:fe:type | "identicality" | "type" | "/r/has a" |  | "FN" |  |
| fn:fe:current_instance | /r/RelatedTo | fn:fe:set_of_instances | "current instance" | "set of instances" | "/r/related to" |  | "FN" |  |
| fn:identicality | /r/HasA | fn:fe:current_instance | "identicality" | "current instance" | "/r/has a" |  | "FN" |  |
| fn:fe:previous_instance | /r/RelatedTo | fn:fe:set_of_instances | "previous instance" | "set of instances" | "/r/related to" |  | "FN" |  |
| fn:identicality | /r/HasA | fn:fe:previous_instance | "identicality" | "previous instance" | "/r/has a" |  | "FN" |  |
| fn:fe:previous_context | /r/RelatedTo | fn:fe:set_of_instances | "previous context" | "set of instances" | "/r/related to" |  | "FN" |  |
| fn:identicality | /r/HasA | fn:fe:previous_context | "identicality" | "previous context" | "/r/has a" |  | "FN" |  |
| fn:identicality | /r/HasA | fn:fe:set_of_instances | "identicality" | "set of instances" | "/r/has a" |  | "FN" |  |
| fn:identicality | /r/HasA | fn:fe:time | "identicality" | "time" | "/r/has a" |  | "FN" |  |
| fn:identity | /r/IsA | fn:identity_scenario | "identity" | "identity scenario" | "/r/is a" |  | "FN" |  |
| fn:identity | fn:HasLexicalUnit | fn:lu:identity:identity | "identity" | "identity" | "has lexical unit" |  | "FN" |  |
| fn:identity | /r/HasA | fn:fe:instance | "identity" | "instance" | "/r/has a" |  | "FN" |  |
| fn:identity | /r/HasA | fn:fe:identity | "identity" | "identity" | "/r/has a" |  | "FN" |  |
| fn:identicality | /r/IsA | fn:identity_scenario | "identicality" | "identity scenario" | "/r/is a" |  | "FN" |  |
| fn:identity | /r/IsA | fn:identity_scenario | "identity" | "identity scenario" | "/r/is a" |  | "FN" |  |
| fn:identity_scenario | /r/HasA | fn:fe:type | "identity scenario" | "type" | "/r/has a" |  | "FN" |  |
| fn:identity_scenario | /r/HasA | fn:fe:instance | "identity scenario" | "instance" | "/r/has a" |  | "FN" |  |
| fn:identity_scenario | /r/HasA | fn:fe:identity | "identity scenario" | "identity" | "/r/has a" |  | "FN" |  |
| fn:idiosyncrasy | /r/IsA | fn:relation | "idiosyncrasy" | "relation" | "/r/is a" |  | "FN" |  |
| fn:typicality | /r/RelatedTo | fn:idiosyncrasy | "typicality" | "idiosyncrasy" | "/r/related to" |  | "FN" |  |
| fn:idiosyncrasy | fn:HasLexicalUnit | fn:lu:idiosyncrasy:idiosyncratic | "idiosyncrasy" | "idiosyncratic" | "has lexical unit" |  | "FN" |  |
| fn:idiosyncrasy | fn:HasLexicalUnit | fn:lu:idiosyncrasy:peculiar | "idiosyncrasy" | "peculiar" | "has lexical unit" |  | "FN" |  |
| fn:idiosyncrasy | fn:HasLexicalUnit | fn:lu:idiosyncrasy:peculiarity | "idiosyncrasy" | "peculiarity" | "has lexical unit" |  | "FN" |  |
| fn:idiosyncrasy | fn:HasLexicalUnit | fn:lu:idiosyncrasy:unique | "idiosyncrasy" | "unique" | "has lexical unit" |  | "FN" |  |
| fn:idiosyncrasy | fn:HasLexicalUnit | fn:lu:idiosyncrasy:idiosyncrasy | "idiosyncrasy" | "idiosyncrasy" | "has lexical unit" |  | "FN" |  |
| fn:idiosyncrasy | fn:HasLexicalUnit | fn:lu:idiosyncrasy:particular | "idiosyncrasy" | "particular" | "has lexical unit" |  | "FN" |  |
| fn:idiosyncrasy | fn:HasLexicalUnit | fn:lu:idiosyncrasy:certain | "idiosyncrasy" | "certain" | "has lexical unit" |  | "FN" |  |
| fn:idiosyncrasy | fn:HasLexicalUnit | fn:lu:idiosyncrasy:oddity | "idiosyncrasy" | "oddity" | "has lexical unit" |  | "FN" |  |
| fn:idiosyncrasy | fn:HasLexicalUnit | fn:lu:idiosyncrasy:weird | "idiosyncrasy" | "weird" | "has lexical unit" |  | "FN" |  |
| fn:idiosyncrasy | fn:HasLexicalUnit | fn:lu:idiosyncrasy:uncanny | "idiosyncrasy" | "uncanny" | "has lexical unit" |  | "FN" |  |
| fn:idiosyncrasy | /r/HasA | fn:fe:idiosyncrasy | "idiosyncrasy" | "idiosyncrasy" | "/r/has a" |  | "FN" |  |
| fn:idiosyncrasy | /r/HasA | fn:fe:entity | "idiosyncrasy" | "entity" | "/r/has a" |  | "FN" |  |
| fn:idiosyncrasy | /r/HasA | fn:fe:degree | "idiosyncrasy" | "degree" | "/r/has a" |  | "FN" |  |
| fn:alignment_image_schema | /r/IsA | fn:image_schema | "alignment image schema" | "image schema" | "/r/is a" |  | "FN" |  |
| fn:bounded_region | /r/IsA | fn:image_schema | "bounded region" | "image schema" | "/r/is a" |  | "FN" |  |
| fn:collocation_image_schema | /r/IsA | fn:image_schema | "collocation image schema" | "image schema" | "/r/is a" |  | "FN" |  |
| fn:contact_image_schema | /r/IsA | fn:image_schema | "contact image schema" | "image schema" | "/r/is a" |  | "FN" |  |
| fn:proximity_image_schema | /r/IsA | fn:image_schema | "proximity image schema" | "image schema" | "/r/is a" |  | "FN" |  |
| fn:image_schema | /r/UsedFor | fn:relational_location | "image schema" | "relational location" | "/r/used for" |  | "FN" |  |
| fn:image_schema | /r/UsedFor | fn:relational_natural_features | "image schema" | "relational natural features" | "/r/used for" |  | "FN" |  |
| fn:image_schema | /r/HasA | fn:fe:profiled_region | "image schema" | "profiled region" | "/r/has a" |  | "FN" |  |
| fn:image_schema | /r/HasA | fn:fe:ground | "image schema" | "ground" | "/r/has a" |  | "FN" |  |
| fn:similarity | /r/UsedFor | fn:imitating | "similarity" | "imitating" | "/r/used for" |  | "FN" |  |
| fn:imitating | fn:HasLexicalUnit | fn:lu:imitating:imitate | "imitating" | "imitate" | "has lexical unit" |  | "FN" |  |
| fn:imitating | fn:HasLexicalUnit | fn:lu:imitating:mimic | "imitating" | "mimic" | "has lexical unit" |  | "FN" |  |
| fn:imitating | fn:HasLexicalUnit | fn:lu:imitating:ape | "imitating" | "ape" | "has lexical unit" |  | "FN" |  |
| fn:imitating | fn:HasLexicalUnit | fn:lu:imitating:copy | "imitating" | "copy" | "has lexical unit" |  | "FN" |  |
| fn:imitating | /r/HasA | fn:fe:agent | "imitating" | "agent" | "/r/has a" |  | "FN" |  |
| fn:imitating | /r/HasA | fn:fe:characteristic | "imitating" | "characteristic" | "/r/has a" |  | "FN" |  |
| fn:imitating | /r/HasA | fn:fe:manner | "imitating" | "manner" | "/r/has a" |  | "FN" |  |
| fn:imitating | /r/HasA | fn:fe:means | "imitating" | "means" | "/r/has a" |  | "FN" |  |
| fn:imitating | /r/HasA | fn:fe:standard | "imitating" | "standard" | "/r/has a" |  | "FN" |  |
| fn:imitating | /r/HasA | fn:fe:purpose | "imitating" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:imitating | /r/HasA | fn:fe:explanation | "imitating" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:imitating | /r/HasA | fn:fe:depictive | "imitating" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:imitating | /r/HasA | fn:fe:containing_event | "imitating" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:imitating | /r/HasA | fn:fe:degree | "imitating" | "degree" | "/r/has a" |  | "FN" |  |
| fn:imitating | /r/HasA | fn:fe:time | "imitating" | "time" | "/r/has a" |  | "FN" |  |
| fn:imitating | /r/HasA | fn:fe:place | "imitating" | "place" | "/r/has a" |  | "FN" |  |
| fn:imitating | /r/HasA | fn:fe:duration | "imitating" | "duration" | "/r/has a" |  | "FN" |  |
| fn:immobilization | /r/IsA | fn:intentionally_affect | "immobilization" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:immobilization | fn:HasLexicalUnit | fn:lu:immobilization:tie_up | "immobilization" | "tie up" | "has lexical unit" |  | "FN" |  |
| fn:immobilization | fn:HasLexicalUnit | fn:lu:immobilization:lock_up | "immobilization" | "lock up" | "has lexical unit" |  | "FN" |  |
| fn:immobilization | fn:HasLexicalUnit | fn:lu:immobilization:handcuff | "immobilization" | "handcuff" | "has lexical unit" |  | "FN" |  |
| fn:immobilization | fn:HasLexicalUnit | fn:lu:immobilization:shackle | "immobilization" | "shackle" | "has lexical unit" |  | "FN" |  |
| fn:immobilization | fn:HasLexicalUnit | fn:lu:immobilization:straitjacket | "immobilization" | "straitjacket" | "has lexical unit" |  | "FN" |  |
| fn:immobilization | /r/HasA | fn:fe:agent | "immobilization" | "agent" | "/r/has a" |  | "FN" |  |
| fn:immobilization | /r/HasA | fn:fe:instrument | "immobilization" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:immobilization | /r/HasA | fn:fe:patient | "immobilization" | "patient" | "/r/has a" |  | "FN" |  |
| fn:immobilization | /r/HasA | fn:fe:means | "immobilization" | "means" | "/r/has a" |  | "FN" |  |
| fn:immobilization | /r/HasA | fn:fe:purpose | "immobilization" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:immobilization | /r/HasA | fn:fe:time | "immobilization" | "time" | "/r/has a" |  | "FN" |  |
| fn:immobilization | /r/HasA | fn:fe:place | "immobilization" | "place" | "/r/has a" |  | "FN" |  |
| fn:immobilization | /r/HasA | fn:fe:anchor | "immobilization" | "anchor" | "/r/has a" |  | "FN" |  |
| fn:immobilization | /r/HasA | fn:fe:degree | "immobilization" | "degree" | "/r/has a" |  | "FN" |  |
| fn:immobilization | /r/HasA | fn:fe:manner | "immobilization" | "manner" | "/r/has a" |  | "FN" |  |
| fn:impact | /r/UsedFor | fn:friction | "impact" | "friction" | "/r/used for" |  | "FN" |  |
| fn:make_noise | /r/RelatedTo | fn:impact | "make noise" | "impact" | "/r/related to" |  | "FN" |  |
| fn:make_noise | /r/SimilarTo | fn:impact | "make noise" | "impact" | "/r/similar to" |  | "FN" |  |
| fn:cause_impact | /r/Causes | fn:impact | "cause impact" | "impact" | "/r/causes" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:graze | "impact" | "graze" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:glancing | "impact" | "glancing" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:impact | "impact" | "impact" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:hit | "impact" | "hit" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:run | "impact" | "run" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:smack | "impact" | "smack" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:crash | "impact" | "crash" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:bump | "impact" | "bump" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:clang | "impact" | "clang" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:plow | "impact" | "plow" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:bang | "impact" | "bang" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:collide | "impact" | "collide" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:collision | "impact" | "collision" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:smash | "impact" | "smash" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:strike | "impact" | "strike" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:impact | "impact" | "impact" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:hit | "impact" | "hit" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:thud | "impact" | "thud" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:crash | "impact" | "crash" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:clunk | "impact" | "clunk" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:crunch | "impact" | "crunch" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:slam | "impact" | "slam" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:plop | "impact" | "plop" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:plunk | "impact" | "plunk" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:slap | "impact" | "slap" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:thump | "impact" | "thump" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:chatter | "impact" | "chatter" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:clash | "impact" | "clash" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:click | "impact" | "click" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:patter | "impact" | "patter" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:plash | "impact" | "plash" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:rap | "impact" | "rap" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:tinkle | "impact" | "tinkle" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:clatter | "impact" | "clatter" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:clink | "impact" | "clink" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:hiss | "impact" | "hiss" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:rattle | "impact" | "rattle" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:touch | "impact" | "touch" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:brush | "impact" | "brush" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:knock | "impact" | "knock" | "has lexical unit" |  | "FN" |  |
| fn:impact | fn:HasLexicalUnit | fn:lu:impact:impinge | "impact" | "impinge" | "has lexical unit" |  | "FN" |  |
| fn:impact | /r/HasA | fn:fe:place | "impact" | "place" | "/r/has a" |  | "FN" |  |
| fn:impact | /r/HasA | fn:fe:result | "impact" | "result" | "/r/has a" |  | "FN" |  |
| fn:impact | /r/HasA | fn:fe:time | "impact" | "time" | "/r/has a" |  | "FN" |  |
| fn:impact | /r/HasA | fn:fe:explanation | "impact" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:impact | /r/HasA | fn:fe:manner | "impact" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fe:impactor | /r/HasPrerequisite | fn:fe:impactee | "impactor" | "impactee" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:impactor | /r/RelatedTo | fn:fe:impactors | "impactor" | "impactors" | "/r/related to" |  | "FN" |  |
| fn:impact | /r/HasA | fn:fe:impactor | "impact" | "impactor" | "/r/has a" |  | "FN" |  |
| fn:fe:impactee | /r/HasPrerequisite | fn:fe:impactor | "impactee" | "impactor" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:impactee | /r/RelatedTo | fn:fe:impactors | "impactee" | "impactors" | "/r/related to" |  | "FN" |  |
| fn:impact | /r/HasA | fn:fe:impactee | "impact" | "impactee" | "/r/has a" |  | "FN" |  |
| fn:impact | /r/HasA | fn:fe:impactors | "impact" | "impactors" | "/r/has a" |  | "FN" |  |
| fn:impact | /r/HasA | fn:fe:speed | "impact" | "speed" | "/r/has a" |  | "FN" |  |
| fn:impact | /r/HasA | fn:fe:subregion | "impact" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:impact | /r/HasA | fn:fe:force | "impact" | "force" | "/r/has a" |  | "FN" |  |
| fn:impact | /r/HasA | fn:fe:period_of_iterations | "impact" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:impact | /r/HasA | fn:fe:depictive | "impact" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:intentionally_affect | /r/UsedFor | fn:import_export_scenario | "intentionally affect" | "import export scenario" | "/r/used for" |  | "FN" |  |
| fn:import_export_scenario | /r/SimilarTo | fn:exporting | "import export scenario" | "exporting" | "/r/similar to" |  | "FN" |  |
| fn:import_export_scenario | /r/SimilarTo | fn:importing | "import export scenario" | "importing" | "/r/similar to" |  | "FN" |  |
| fn:exporting | /r/IsA | fn:import_export_scenario | "exporting" | "import export scenario" | "/r/is a" |  | "FN" |  |
| fn:importing | /r/IsA | fn:import_export_scenario | "importing" | "import export scenario" | "/r/is a" |  | "FN" |  |
| fn:import_export_scenario | fn:HasLexicalUnit | fn:lu:import_export_scenario:transship | "import export scenario" | "transship" | "has lexical unit" |  | "FN" |  |
| fn:import_export_scenario | fn:HasLexicalUnit | fn:lu:import_export_scenario:exporter | "import export scenario" | "exporter" | "has lexical unit" |  | "FN" |  |
| fn:import_export_scenario | fn:HasLexicalUnit | fn:lu:import_export_scenario:importer | "import export scenario" | "importer" | "has lexical unit" |  | "FN" |  |
| fn:import_export_scenario | fn:HasLexicalUnit | fn:lu:import_export_scenario:trans-shipping | "import export scenario" | "trans-shipping" | "has lexical unit" |  | "FN" |  |
| fn:import_export_scenario | /r/HasA | fn:fe:agent | "import export scenario" | "agent" | "/r/has a" |  | "FN" |  |
| fn:import_export_scenario | /r/HasA | fn:fe:vehicle | "import export scenario" | "vehicle" | "/r/has a" |  | "FN" |  |
| fn:import_export_scenario | /r/HasA | fn:fe:manner | "import export scenario" | "manner" | "/r/has a" |  | "FN" |  |
| fn:import_export_scenario | /r/HasA | fn:fe:means | "import export scenario" | "means" | "/r/has a" |  | "FN" |  |
| fn:import_export_scenario | /r/HasA | fn:fe:goods | "import export scenario" | "goods" | "/r/has a" |  | "FN" |  |
| fn:import_export_scenario | /r/HasA | fn:fe:purpose | "import export scenario" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:import_export_scenario | /r/HasA | fn:fe:explanation | "import export scenario" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:import_export_scenario | /r/HasA | fn:fe:time | "import export scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:import_export_scenario | /r/HasA | fn:fe:depictive | "import export scenario" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:import_export_scenario | /r/HasA | fn:fe:importing_area | "import export scenario" | "importing area" | "/r/has a" |  | "FN" |  |
| fn:import_export_scenario | /r/HasA | fn:fe:path | "import export scenario" | "path" | "/r/has a" |  | "FN" |  |
| fn:import_export_scenario | /r/HasA | fn:fe:exporting_area | "import export scenario" | "exporting area" | "/r/has a" |  | "FN" |  |
| fn:import_export_scenario | /r/HasA | fn:fe:descriptor | "import export scenario" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:importance | /r/UsedFor | fn:degree | "importance" | "degree" | "/r/used for" |  | "FN" |  |
| fn:importance | /r/UsedFor | fn:emphasizing | "importance" | "emphasizing" | "/r/used for" |  | "FN" |  |
| fn:importance | /r/UsedFor | fn:historic_event | "importance" | "historic event" | "/r/used for" |  | "FN" |  |
| fn:importance | /r/UsedFor | fn:individual_history | "importance" | "individual history" | "/r/used for" |  | "FN" |  |
| fn:importance | fn:HasLexicalUnit | fn:lu:importance:crucial | "importance" | "crucial" | "has lexical unit" |  | "FN" |  |
| fn:importance | fn:HasLexicalUnit | fn:lu:importance:critical | "importance" | "critical" | "has lexical unit" |  | "FN" |  |
| fn:importance | fn:HasLexicalUnit | fn:lu:importance:key | "importance" | "key" | "has lexical unit" |  | "FN" |  |
| fn:importance | fn:HasLexicalUnit | fn:lu:importance:decisive | "importance" | "decisive" | "has lexical unit" |  | "FN" |  |
| fn:importance | fn:HasLexicalUnit | fn:lu:importance:pivotal | "importance" | "pivotal" | "has lexical unit" |  | "FN" |  |
| fn:importance | fn:HasLexicalUnit | fn:lu:importance:important | "importance" | "important" | "has lexical unit" |  | "FN" |  |
| fn:importance | fn:HasLexicalUnit | fn:lu:importance:significant | "importance" | "significant" | "has lexical unit" |  | "FN" |  |
| fn:importance | fn:HasLexicalUnit | fn:lu:importance:importance | "importance" | "importance" | "has lexical unit" |  | "FN" |  |
| fn:importance | fn:HasLexicalUnit | fn:lu:importance:significance | "importance" | "significance" | "has lexical unit" |  | "FN" |  |
| fn:importance | fn:HasLexicalUnit | fn:lu:importance:import | "importance" | "import" | "has lexical unit" |  | "FN" |  |
| fn:importance | fn:HasLexicalUnit | fn:lu:importance:major | "importance" | "major" | "has lexical unit" |  | "FN" |  |
| fn:importance | fn:HasLexicalUnit | fn:lu:importance:instrumental | "importance" | "instrumental" | "has lexical unit" |  | "FN" |  |
| fn:importance | fn:HasLexicalUnit | fn:lu:importance:vital | "importance" | "vital" | "has lexical unit" |  | "FN" |  |
| fn:importance | fn:HasLexicalUnit | fn:lu:importance:considerable | "importance" | "considerable" | "has lexical unit" |  | "FN" |  |
| fn:importance | fn:HasLexicalUnit | fn:lu:importance:fundamental | "importance" | "fundamental" | "has lexical unit" |  | "FN" |  |
| fn:importance | fn:HasLexicalUnit | fn:lu:importance:main | "importance" | "main" | "has lexical unit" |  | "FN" |  |
| fn:importance | fn:HasLexicalUnit | fn:lu:importance:serious | "importance" | "serious" | "has lexical unit" |  | "FN" |  |
| fn:importance | fn:HasLexicalUnit | fn:lu:importance:seriously | "importance" | "seriously" | "has lexical unit" |  | "FN" |  |
| fn:importance | fn:HasLexicalUnit | fn:lu:importance:acute | "importance" | "acute" | "has lexical unit" |  | "FN" |  |
| fn:importance | fn:HasLexicalUnit | fn:lu:importance:landmark | "importance" | "landmark" | "has lexical unit" |  | "FN" |  |
| fn:importance | fn:HasLexicalUnit | fn:lu:importance:epic | "importance" | "epic" | "has lexical unit" |  | "FN" |  |
| fn:importance | fn:HasLexicalUnit | fn:lu:importance:count | "importance" | "count" | "has lexical unit" |  | "FN" |  |
| fn:importance | fn:HasLexicalUnit | fn:lu:importance:priority | "importance" | "priority" | "has lexical unit" |  | "FN" |  |
| fn:importance | /r/HasA | fn:fe:factor | "importance" | "factor" | "/r/has a" |  | "FN" |  |
| fn:importance | /r/HasA | fn:fe:degree | "importance" | "degree" | "/r/has a" |  | "FN" |  |
| fn:importance | /r/HasA | fn:fe:undertaking | "importance" | "undertaking" | "/r/has a" |  | "FN" |  |
| fn:importance | /r/HasA | fn:fe:explanation | "importance" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:fe:interested_party | /r/RelatedTo | fn:fe:field | "interested party" | "field" | "/r/related to" |  | "FN" |  |
| fn:importance | /r/HasA | fn:fe:interested_party | "importance" | "interested party" | "/r/has a" |  | "FN" |  |
| fn:importance | /r/HasA | fn:fe:field | "importance" | "field" | "/r/has a" |  | "FN" |  |
| fn:importance | /r/HasA | fn:fe:time | "importance" | "time" | "/r/has a" |  | "FN" |  |
| fn:importance | /r/HasA | fn:fe:frequency | "importance" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:importance | /r/HasA | fn:fe:place | "importance" | "place" | "/r/has a" |  | "FN" |  |
| fn:commerce_buy | /r/UsedFor | fn:importing | "commerce buy" | "importing" | "/r/used for" |  | "FN" |  |
| fn:import_export_scenario | /r/SimilarTo | fn:importing | "import export scenario" | "importing" | "/r/similar to" |  | "FN" |  |
| fn:importing | /r/IsA | fn:import_export_scenario | "importing" | "import export scenario" | "/r/is a" |  | "FN" |  |
| fn:importing | fn:HasLexicalUnit | fn:lu:importing:importation | "importing" | "importation" | "has lexical unit" |  | "FN" |  |
| fn:importing | fn:HasLexicalUnit | fn:lu:importing:import | "importing" | "import" | "has lexical unit" |  | "FN" |  |
| fn:importing | fn:HasLexicalUnit | fn:lu:importing:import_[act] | "importing" | "import [act]" | "has lexical unit" |  | "FN" |  |
| fn:importing | fn:HasLexicalUnit | fn:lu:importing:import_[entity] | "importing" | "import [entity]" | "has lexical unit" |  | "FN" |  |
| fn:fe:importer | /r/IsA | fn:st:sentient | "importer" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:importing | /r/HasA | fn:fe:importer | "importing" | "importer" | "/r/has a" |  | "FN" |  |
| fn:importing | /r/HasA | fn:fe:vehicle | "importing" | "vehicle" | "/r/has a" |  | "FN" |  |
| fn:importing | /r/HasA | fn:fe:manner | "importing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:importing | /r/HasA | fn:fe:means | "importing" | "means" | "/r/has a" |  | "FN" |  |
| fn:importing | /r/HasA | fn:fe:goods | "importing" | "goods" | "/r/has a" |  | "FN" |  |
| fn:importing | /r/HasA | fn:fe:purpose | "importing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:importing | /r/HasA | fn:fe:explanation | "importing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:importing | /r/HasA | fn:fe:time | "importing" | "time" | "/r/has a" |  | "FN" |  |
| fn:importing | /r/HasA | fn:fe:depictive | "importing" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:importing | /r/HasA | fn:fe:importing_area | "importing" | "importing area" | "/r/has a" |  | "FN" |  |
| fn:importing | /r/HasA | fn:fe:path | "importing" | "path" | "/r/has a" |  | "FN" |  |
| fn:importing | /r/HasA | fn:fe:exporting_area | "importing" | "exporting area" | "/r/has a" |  | "FN" |  |
| fn:importing | /r/HasA | fn:fe:particular_iteration | "importing" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:importing | /r/HasA | fn:fe:frequency | "importing" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:importing | /r/HasA | fn:fe:result | "importing" | "result" | "/r/has a" |  | "FN" |  |
| fn:importing | /r/HasA | fn:fe:beneficiary | "importing" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:imposing_obligation | /r/IsA | fn:transitive_action | "imposing obligation" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:imposing_obligation | /r/Causes | fn:being_obligated | "imposing obligation" | "being obligated" | "/r/causes" |  | "FN" |  |
| fn:imposing_obligation | fn:HasLexicalUnit | fn:lu:imposing_obligation:bind | "imposing obligation" | "bind" | "has lexical unit" |  | "FN" |  |
| fn:imposing_obligation | fn:HasLexicalUnit | fn:lu:imposing_obligation:obligate | "imposing obligation" | "obligate" | "has lexical unit" |  | "FN" |  |
| fn:imposing_obligation | fn:HasLexicalUnit | fn:lu:imposing_obligation:commit | "imposing obligation" | "commit" | "has lexical unit" |  | "FN" |  |
| fn:imposing_obligation | fn:HasLexicalUnit | fn:lu:imposing_obligation:pledge | "imposing obligation" | "pledge" | "has lexical unit" |  | "FN" |  |
| fn:imposing_obligation | fn:HasLexicalUnit | fn:lu:imposing_obligation:require | "imposing obligation" | "require" | "has lexical unit" |  | "FN" |  |
| fn:imposing_obligation | fn:HasLexicalUnit | fn:lu:imposing_obligation:charge | "imposing obligation" | "charge" | "has lexical unit" |  | "FN" |  |
| fn:imposing_obligation | fn:HasLexicalUnit | fn:lu:imposing_obligation:charge | "imposing obligation" | "charge" | "has lexical unit" |  | "FN" |  |
| fn:imposing_obligation | fn:HasLexicalUnit | fn:lu:imposing_obligation:oblige | "imposing obligation" | "oblige" | "has lexical unit" |  | "FN" |  |
| fn:imposing_obligation | /r/HasA | fn:fe:responsible_party | "imposing obligation" | "responsible party" | "/r/has a" |  | "FN" |  |
| fn:imposing_obligation | /r/HasA | fn:fe:duty | "imposing obligation" | "duty" | "/r/has a" |  | "FN" |  |
| fn:imposing_obligation | /r/HasA | fn:fe:condition | "imposing obligation" | "condition" | "/r/has a" |  | "FN" |  |
| fn:imposing_obligation | /r/HasA | fn:fe:time | "imposing obligation" | "time" | "/r/has a" |  | "FN" |  |
| fn:imposing_obligation | /r/HasA | fn:fe:place | "imposing obligation" | "place" | "/r/has a" |  | "FN" |  |
| fn:fe:obligator | /r/RelatedTo | fn:fe:situation | "obligator" | "situation" | "/r/related to" |  | "FN" |  |
| fn:imposing_obligation | /r/HasA | fn:fe:obligator | "imposing obligation" | "obligator" | "/r/has a" |  | "FN" |  |
| fn:imposing_obligation | /r/HasA | fn:fe:situation | "imposing obligation" | "situation" | "/r/has a" |  | "FN" |  |
| fn:imposing_obligation | /r/HasA | fn:fe:principle | "imposing obligation" | "principle" | "/r/has a" |  | "FN" |  |
| fn:imposing_obligation | /r/HasA | fn:fe:purpose | "imposing obligation" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:imposing_obligation | /r/HasA | fn:fe:manner | "imposing obligation" | "manner" | "/r/has a" |  | "FN" |  |
| fn:imposing_obligation | /r/HasA | fn:fe:means | "imposing obligation" | "means" | "/r/has a" |  | "FN" |  |
| fn:awareness | /r/UsedFor | fn:impression | "awareness" | "impression" | "/r/used for" |  | "FN" |  |
| fn:impression | fn:HasLexicalUnit | fn:lu:impression:image | "impression" | "image" | "has lexical unit" |  | "FN" |  |
| fn:impression | fn:HasLexicalUnit | fn:lu:impression:persona | "impression" | "persona" | "has lexical unit" |  | "FN" |  |
| fn:impression | /r/HasA | fn:fe:figure | "impression" | "figure" | "/r/has a" |  | "FN" |  |
| fn:impression | /r/HasA | fn:fe:audience | "impression" | "audience" | "/r/has a" |  | "FN" |  |
| fn:impression | /r/HasA | fn:fe:descriptor | "impression" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:impression | /r/HasA | fn:fe:degree | "impression" | "degree" | "/r/has a" |  | "FN" |  |
| fn:impression | /r/HasA | fn:fe:context | "impression" | "context" | "/r/has a" |  | "FN" |  |
| fn:impression | /r/HasA | fn:fe:impression | "impression" | "impression" | "/r/has a" |  | "FN" |  |
| fn:imprisonment | /r/IsA | fn:inhibit_movement | "imprisonment" | "inhibit movement" | "/r/is a" |  | "FN" |  |
| fn:imprisonment | fn:HasLexicalUnit | fn:lu:imprisonment:imprison | "imprisonment" | "imprison" | "has lexical unit" |  | "FN" |  |
| fn:imprisonment | fn:HasLexicalUnit | fn:lu:imprisonment:imprisonment | "imprisonment" | "imprisonment" | "has lexical unit" |  | "FN" |  |
| fn:imprisonment | fn:HasLexicalUnit | fn:lu:imprisonment:put_away | "imprisonment" | "put away" | "has lexical unit" |  | "FN" |  |
| fn:imprisonment | fn:HasLexicalUnit | fn:lu:imprisonment:jail | "imprisonment" | "jail" | "has lexical unit" |  | "FN" |  |
| fn:imprisonment | fn:HasLexicalUnit | fn:lu:imprisonment:incarcerate | "imprisonment" | "incarcerate" | "has lexical unit" |  | "FN" |  |
| fn:imprisonment | fn:HasLexicalUnit | fn:lu:imprisonment:incarceration | "imprisonment" | "incarceration" | "has lexical unit" |  | "FN" |  |
| fn:imprisonment | fn:HasLexicalUnit | fn:lu:imprisonment:time | "imprisonment" | "time" | "has lexical unit" |  | "FN" |  |
| fn:imprisonment | fn:HasLexicalUnit | fn:lu:imprisonment:life | "imprisonment" | "life" | "has lexical unit" |  | "FN" |  |
| fn:imprisonment | /r/HasA | fn:fe:prisoner | "imprisonment" | "prisoner" | "/r/has a" |  | "FN" |  |
| fn:imprisonment | /r/HasA | fn:fe:prison | "imprisonment" | "prison" | "/r/has a" |  | "FN" |  |
| fn:imprisonment | /r/HasA | fn:fe:authorities | "imprisonment" | "authorities" | "/r/has a" |  | "FN" |  |
| fn:imprisonment | /r/HasA | fn:fe:offense | "imprisonment" | "offense" | "/r/has a" |  | "FN" |  |
| fn:imprisonment | /r/HasA | fn:fe:place | "imprisonment" | "place" | "/r/has a" |  | "FN" |  |
| fn:imprisonment | /r/HasA | fn:fe:time | "imprisonment" | "time" | "/r/has a" |  | "FN" |  |
| fn:imprisonment | /r/HasA | fn:fe:purpose | "imprisonment" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:imprisonment | /r/HasA | fn:fe:means | "imprisonment" | "means" | "/r/has a" |  | "FN" |  |
| fn:imprisonment | /r/HasA | fn:fe:manner | "imprisonment" | "manner" | "/r/has a" |  | "FN" |  |
| fn:imprisonment | /r/HasA | fn:fe:explanation | "imprisonment" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:imprisonment | /r/HasA | fn:fe:duration | "imprisonment" | "duration" | "/r/has a" |  | "FN" |  |
| fn:imprisonment | /r/HasA | fn:fe:conviction | "imprisonment" | "conviction" | "/r/has a" |  | "FN" |  |
| fn:imprisonment | /r/HasA | fn:fe:iterations | "imprisonment" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:improvement_or_decline | /r/IsA | fn:undergo_change | "improvement or decline" | "undergo change" | "/r/is a" |  | "FN" |  |
| fn:progression | /r/RelatedTo | fn:improvement_or_decline | "progression" | "improvement or decline" | "/r/related to" |  | "FN" |  |
| fn:improvement_or_decline | fn:HasLexicalUnit | fn:lu:improvement_or_decline:improve | "improvement or decline" | "improve" | "has lexical unit" |  | "FN" |  |
| fn:improvement_or_decline | fn:HasLexicalUnit | fn:lu:improvement_or_decline:ameliorate | "improvement or decline" | "ameliorate" | "has lexical unit" |  | "FN" |  |
| fn:improvement_or_decline | fn:HasLexicalUnit | fn:lu:improvement_or_decline:decline | "improvement or decline" | "decline" | "has lexical unit" |  | "FN" |  |
| fn:improvement_or_decline | fn:HasLexicalUnit | fn:lu:improvement_or_decline:shape_up | "improvement or decline" | "shape up" | "has lexical unit" |  | "FN" |  |
| fn:improvement_or_decline | fn:HasLexicalUnit | fn:lu:improvement_or_decline:look_up | "improvement or decline" | "look up" | "has lexical unit" |  | "FN" |  |
| fn:improvement_or_decline | fn:HasLexicalUnit | fn:lu:improvement_or_decline:deteriorate | "improvement or decline" | "deteriorate" | "has lexical unit" |  | "FN" |  |
| fn:improvement_or_decline | fn:HasLexicalUnit | fn:lu:improvement_or_decline:worsen | "improvement or decline" | "worsen" | "has lexical unit" |  | "FN" |  |
| fn:improvement_or_decline | fn:HasLexicalUnit | fn:lu:improvement_or_decline:improvement | "improvement or decline" | "improvement" | "has lexical unit" |  | "FN" |  |
| fn:improvement_or_decline | fn:HasLexicalUnit | fn:lu:improvement_or_decline:amelioration | "improvement or decline" | "amelioration" | "has lexical unit" |  | "FN" |  |
| fn:improvement_or_decline | fn:HasLexicalUnit | fn:lu:improvement_or_decline:deterioration | "improvement or decline" | "deterioration" | "has lexical unit" |  | "FN" |  |
| fn:improvement_or_decline | fn:HasLexicalUnit | fn:lu:improvement_or_decline:decline | "improvement or decline" | "decline" | "has lexical unit" |  | "FN" |  |
| fn:improvement_or_decline | /r/HasA | fn:fe:entity | "improvement or decline" | "entity" | "/r/has a" |  | "FN" |  |
| fn:improvement_or_decline | /r/HasA | fn:fe:prior_state | "improvement or decline" | "prior state" | "/r/has a" |  | "FN" |  |
| fn:improvement_or_decline | /r/HasA | fn:fe:post_state | "improvement or decline" | "post state" | "/r/has a" |  | "FN" |  |
| fn:improvement_or_decline | /r/HasA | fn:fe:time | "improvement or decline" | "time" | "/r/has a" |  | "FN" |  |
| fn:improvement_or_decline | /r/HasA | fn:fe:rate | "improvement or decline" | "rate" | "/r/has a" |  | "FN" |  |
| fn:improvement_or_decline | /r/HasA | fn:fe:manner | "improvement or decline" | "manner" | "/r/has a" |  | "FN" |  |
| fn:improvement_or_decline | /r/HasA | fn:fe:duration | "improvement or decline" | "duration" | "/r/has a" |  | "FN" |  |
| fn:improvement_or_decline | /r/HasA | fn:fe:degree | "improvement or decline" | "degree" | "/r/has a" |  | "FN" |  |
| fn:improvement_or_decline | /r/HasA | fn:fe:domain | "improvement or decline" | "domain" | "/r/has a" |  | "FN" |  |
| fn:improvement_or_decline | /r/HasA | fn:fe:explanation | "improvement or decline" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:improvement_or_decline | /r/HasA | fn:fe:place | "improvement or decline" | "place" | "/r/has a" |  | "FN" |  |
| fn:improvement_or_decline | /r/HasA | fn:fe:event_description | "improvement or decline" | "event description" | "/r/has a" |  | "FN" |  |
| fn:improvement_or_decline | /r/HasA | fn:fe:frequency | "improvement or decline" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:improvement_or_decline | /r/HasA | fn:fe:circumstances | "improvement or decline" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:distant_operated_ied | /r/IsA | fn:improvised_explosive_device | "distant operated ied" | "improvised explosive device" | "/r/is a" |  | "FN" |  |
| fn:victim_operated_ied | /r/IsA | fn:improvised_explosive_device | "victim operated ied" | "improvised explosive device" | "/r/is a" |  | "FN" |  |
| fn:improvised_explosive_device | /r/IsA | fn:weapon | "improvised explosive device" | "weapon" | "/r/is a" |  | "FN" |  |
| fn:improvised_explosive_device | fn:HasLexicalUnit | fn:lu:improvised_explosive_device:roadside_bomb | "improvised explosive device" | "roadside bomb" | "has lexical unit" |  | "FN" |  |
| fn:improvised_explosive_device | fn:HasLexicalUnit | fn:lu:improvised_explosive_device:improvised_explosive_device | "improvised explosive device" | "improvised explosive device" | "has lexical unit" |  | "FN" |  |
| fn:improvised_explosive_device | fn:HasLexicalUnit | fn:lu:improvised_explosive_device:ied | "improvised explosive device" | "ied" | "has lexical unit" |  | "FN" |  |
| fn:improvised_explosive_device | fn:HasLexicalUnit | fn:lu:improvised_explosive_device:dismounted_ied | "improvised explosive device" | "dismounted ied" | "has lexical unit" |  | "FN" |  |
| fn:improvised_explosive_device | fn:HasLexicalUnit | fn:lu:improvised_explosive_device:car_bomb | "improvised explosive device" | "car bomb" | "has lexical unit" |  | "FN" |  |
| fn:improvised_explosive_device | fn:HasLexicalUnit | fn:lu:improvised_explosive_device:vbied | "improvised explosive device" | "vbied" | "has lexical unit" |  | "FN" |  |
| fn:improvised_explosive_device | /r/HasA | fn:fe:bomb | "improvised explosive device" | "bomb" | "/r/has a" |  | "FN" |  |
| fn:improvised_explosive_device | /r/HasA | fn:fe:use | "improvised explosive device" | "use" | "/r/has a" |  | "FN" |  |
| fn:improvised_explosive_device | /r/HasA | fn:fe:type | "improvised explosive device" | "type" | "/r/has a" |  | "FN" |  |
| fn:improvised_explosive_device | /r/HasA | fn:fe:material | "improvised explosive device" | "material" | "/r/has a" |  | "FN" |  |
| fn:improvised_explosive_device | /r/HasA | fn:fe:wielder | "improvised explosive device" | "wielder" | "/r/has a" |  | "FN" |  |
| fn:improvised_explosive_device | /r/HasA | fn:fe:part | "improvised explosive device" | "part" | "/r/has a" |  | "FN" |  |
| fn:improvised_explosive_device | /r/HasA | fn:fe:name | "improvised explosive device" | "name" | "/r/has a" |  | "FN" |  |
| fn:improvised_explosive_device | /r/HasA | fn:fe:time_of_creation | "improvised explosive device" | "time of creation" | "/r/has a" |  | "FN" |  |
| fn:improvised_explosive_device | /r/HasA | fn:fe:creator | "improvised explosive device" | "creator" | "/r/has a" |  | "FN" |  |
| fn:improvised_explosive_device | /r/HasA | fn:fe:descriptor | "improvised explosive device" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:improvised_explosive_device | /r/HasA | fn:fe:target | "improvised explosive device" | "target" | "/r/has a" |  | "FN" |  |
| fn:improvised_explosive_device | /r/HasA | fn:fe:location | "improvised explosive device" | "location" | "/r/has a" |  | "FN" |  |
| fn:inclination | /r/IsA | fn:gradable_attributes | "inclination" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:accuracy | /r/IsA | fn:inclination | "accuracy" | "inclination" | "/r/is a" |  | "FN" |  |
| fn:health_response | /r/IsA | fn:inclination | "health response" | "inclination" | "/r/is a" |  | "FN" |  |
| fn:sociability | /r/IsA | fn:inclination | "sociability" | "inclination" | "/r/is a" |  | "FN" |  |
| fn:volubility | /r/IsA | fn:inclination | "volubility" | "inclination" | "/r/is a" |  | "FN" |  |
| fn:inclination | fn:HasLexicalUnit | fn:lu:inclination:tendency | "inclination" | "tendency" | "has lexical unit" |  | "FN" |  |
| fn:inclination | fn:HasLexicalUnit | fn:lu:inclination:inclined | "inclination" | "inclined" | "has lexical unit" |  | "FN" |  |
| fn:inclination | fn:HasLexicalUnit | fn:lu:inclination:prone | "inclination" | "prone" | "has lexical unit" |  | "FN" |  |
| fn:inclination | fn:HasLexicalUnit | fn:lu:inclination:proclivity | "inclination" | "proclivity" | "has lexical unit" |  | "FN" |  |
| fn:inclination | fn:HasLexicalUnit | fn:lu:inclination:propensity | "inclination" | "propensity" | "has lexical unit" |  | "FN" |  |
| fn:inclination | fn:HasLexicalUnit | fn:lu:inclination:predisposition | "inclination" | "predisposition" | "has lexical unit" |  | "FN" |  |
| fn:inclination | fn:HasLexicalUnit | fn:lu:inclination:penchant | "inclination" | "penchant" | "has lexical unit" |  | "FN" |  |
| fn:inclination | fn:HasLexicalUnit | fn:lu:inclination:predisposed | "inclination" | "predisposed" | "has lexical unit" |  | "FN" |  |
| fn:inclination | fn:HasLexicalUnit | fn:lu:inclination:sense_(of_humor) | "inclination" | "sense (of humor)" | "has lexical unit" |  | "FN" |  |
| fn:inclination | fn:HasLexicalUnit | fn:lu:inclination:of_a_mind | "inclination" | "of a mind" | "has lexical unit" |  | "FN" |  |
| fn:inclination | /r/HasA | fn:fe:entity | "inclination" | "entity" | "/r/has a" |  | "FN" |  |
| fn:inclination | /r/HasA | fn:fe:behavior | "inclination" | "behavior" | "/r/has a" |  | "FN" |  |
| fn:inclination | /r/HasA | fn:fe:degree | "inclination" | "degree" | "/r/has a" |  | "FN" |  |
| fn:inclination | /r/HasA | fn:fe:basis | "inclination" | "basis" | "/r/has a" |  | "FN" |  |
| fn:inclination | /r/HasA | fn:fe:containing_event | "inclination" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:part_whole | /r/UsedFor | fn:inclusion | "part whole" | "inclusion" | "/r/used for" |  | "FN" |  |
| fn:inclusion | /r/IsA | fn:inclusion_scenario | "inclusion" | "inclusion scenario" | "/r/is a" |  | "FN" |  |
| fn:inclusion | fn:HasLexicalUnit | fn:lu:inclusion:include | "inclusion" | "include" | "has lexical unit" |  | "FN" |  |
| fn:inclusion | fn:HasLexicalUnit | fn:lu:inclusion:contain | "inclusion" | "contain" | "has lexical unit" |  | "FN" |  |
| fn:inclusion | fn:HasLexicalUnit | fn:lu:inclusion:have | "inclusion" | "have" | "has lexical unit" |  | "FN" |  |
| fn:inclusion | fn:HasLexicalUnit | fn:lu:inclusion:integrated | "inclusion" | "integrated" | "has lexical unit" |  | "FN" |  |
| fn:inclusion | fn:HasLexicalUnit | fn:lu:inclusion:exclude | "inclusion" | "exclude" | "has lexical unit" |  | "FN" |  |
| fn:inclusion | fn:HasLexicalUnit | fn:lu:inclusion:excluding | "inclusion" | "excluding" | "has lexical unit" |  | "FN" |  |
| fn:inclusion | fn:HasLexicalUnit | fn:lu:inclusion:inclusive | "inclusion" | "inclusive" | "has lexical unit" |  | "FN" |  |
| fn:inclusion | fn:HasLexicalUnit | fn:lu:inclusion:including | "inclusion" | "including" | "has lexical unit" |  | "FN" |  |
| fn:inclusion | fn:HasLexicalUnit | fn:lu:inclusion:incorporate | "inclusion" | "incorporate" | "has lexical unit" |  | "FN" |  |
| fn:inclusion | /r/HasA | fn:fe:total | "inclusion" | "total" | "/r/has a" |  | "FN" |  |
| fn:inclusion | /r/HasA | fn:fe:part | "inclusion" | "part" | "/r/has a" |  | "FN" |  |
| fn:inclusion | /r/HasA | fn:fe:purpose | "inclusion" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:inclusion | /r/HasA | fn:fe:frequency | "inclusion" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:inclusion | /r/HasA | fn:fe:contrast_set | "inclusion" | "contrast set" | "/r/has a" |  | "FN" |  |
| fn:inclusion | /r/HasA | fn:fe:subregion | "inclusion" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:inclusion | /r/HasA | fn:fe:explanation | "inclusion" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:inclusion | /r/HasA | fn:fe:manner | "inclusion" | "manner" | "/r/has a" |  | "FN" |  |
| fn:inclusion | /r/HasA | fn:fe:time | "inclusion" | "time" | "/r/has a" |  | "FN" |  |
| fn:inclusion | /r/HasA | fn:fe:place | "inclusion" | "place" | "/r/has a" |  | "FN" |  |
| fn:set_relation | /r/IsA | fn:inclusion_scenario | "set relation" | "inclusion scenario" | "/r/is a" |  | "FN" |  |
| fn:wholes_and_parts | /r/IsA | fn:inclusion_scenario | "wholes and parts" | "inclusion scenario" | "/r/is a" |  | "FN" |  |
| fn:being_included | /r/IsA | fn:inclusion_scenario | "being included" | "inclusion scenario" | "/r/is a" |  | "FN" |  |
| fn:inclusion | /r/IsA | fn:inclusion_scenario | "inclusion" | "inclusion scenario" | "/r/is a" |  | "FN" |  |
| fn:inclusion_scenario | /r/HasA | fn:fe:whole | "inclusion scenario" | "whole" | "/r/has a" |  | "FN" |  |
| fn:inclusion_scenario | /r/HasA | fn:fe:part | "inclusion scenario" | "part" | "/r/has a" |  | "FN" |  |
| fn:inclusion_scenario | /r/HasA | fn:fe:manner | "inclusion scenario" | "manner" | "/r/has a" |  | "FN" |  |
| fn:inclusion_scenario | /r/HasA | fn:fe:time | "inclusion scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:inclusion_scenario | /r/HasA | fn:fe:place | "inclusion scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:increment | fn:HasLexicalUnit | fn:lu:increment:other | "increment" | "other" | "has lexical unit" |  | "FN" |  |
| fn:increment | fn:HasLexicalUnit | fn:lu:increment:another | "increment" | "another" | "has lexical unit" |  | "FN" |  |
| fn:increment | fn:HasLexicalUnit | fn:lu:increment:other | "increment" | "other" | "has lexical unit" |  | "FN" |  |
| fn:increment | fn:HasLexicalUnit | fn:lu:increment:another | "increment" | "another" | "has lexical unit" |  | "FN" |  |
| fn:increment | fn:HasLexicalUnit | fn:lu:increment:further | "increment" | "further" | "has lexical unit" |  | "FN" |  |
| fn:increment | fn:HasLexicalUnit | fn:lu:increment:more | "increment" | "more" | "has lexical unit" |  | "FN" |  |
| fn:increment | fn:HasLexicalUnit | fn:lu:increment:more | "increment" | "more" | "has lexical unit" |  | "FN" |  |
| fn:increment | fn:HasLexicalUnit | fn:lu:increment:additional | "increment" | "additional" | "has lexical unit" |  | "FN" |  |
| fn:increment | /r/HasA | fn:fe:class | "increment" | "class" | "/r/has a" |  | "FN" |  |
| fn:increment | /r/HasA | fn:fe:added_set | "increment" | "added set" | "/r/has a" |  | "FN" |  |
| fn:increment | /r/HasA | fn:fe:initial_set | "increment" | "initial set" | "/r/has a" |  | "FN" |  |
| fn:increment | /r/HasA | fn:fe:increment | "increment" | "increment" | "/r/has a" |  | "FN" |  |
| fn:indicating | /r/IsA | fn:mention | "indicating" | "mention" | "/r/is a" |  | "FN" |  |
| fn:reporting | /r/SimilarTo | fn:indicating | "reporting" | "indicating" | "/r/similar to" |  | "FN" |  |
| fn:indicating | fn:HasLexicalUnit | fn:lu:indicating:name | "indicating" | "name" | "has lexical unit" |  | "FN" |  |
| fn:indicating | fn:HasLexicalUnit | fn:lu:indicating:indicate | "indicating" | "indicate" | "has lexical unit" |  | "FN" |  |
| fn:indicating | fn:HasLexicalUnit | fn:lu:indicating:identify | "indicating" | "identify" | "has lexical unit" |  | "FN" |  |
| fn:indicating | fn:HasLexicalUnit | fn:lu:indicating:point_out | "indicating" | "point out" | "has lexical unit" |  | "FN" |  |
| fn:indicating | fn:HasLexicalUnit | fn:lu:indicating:finger | "indicating" | "finger" | "has lexical unit" |  | "FN" |  |
| fn:indicating | /r/HasA | fn:fe:communicator | "indicating" | "communicator" | "/r/has a" |  | "FN" |  |
| fn:fe:unresolved_referent | /r/IsA | fn:st:message | "unresolved referent" | "message" | "/r/is a" |  | "FN" |  |
| fn:indicating | /r/HasA | fn:fe:unresolved_referent | "indicating" | "unresolved referent" | "/r/has a" |  | "FN" |  |
| fn:indicating | /r/HasA | fn:fe:medium | "indicating" | "medium" | "/r/has a" |  | "FN" |  |
| fn:indicating | /r/HasA | fn:fe:amount_of_information | "indicating" | "amount of information" | "/r/has a" |  | "FN" |  |
| fn:indicating | /r/HasA | fn:fe:depictive | "indicating" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:indicating | /r/HasA | fn:fe:manner | "indicating" | "manner" | "/r/has a" |  | "FN" |  |
| fn:indicating | /r/HasA | fn:fe:means | "indicating" | "means" | "/r/has a" |  | "FN" |  |
| fn:indicating | /r/HasA | fn:fe:time | "indicating" | "time" | "/r/has a" |  | "FN" |  |
| fn:indicating | /r/HasA | fn:fe:duration | "indicating" | "duration" | "/r/has a" |  | "FN" |  |
| fn:indicating | /r/HasA | fn:fe:frequency | "indicating" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:indicating | /r/HasA | fn:fe:explanation | "indicating" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:indicating | /r/HasA | fn:fe:place | "indicating" | "place" | "/r/has a" |  | "FN" |  |
| fn:indicating | /r/HasA | fn:fe:purpose | "indicating" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:indigenous_origin | /r/IsA | fn:origin | "indigenous origin" | "origin" | "/r/is a" |  | "FN" |  |
| fn:foreign_or_domestic_country | /r/UsedFor | fn:indigenous_origin | "foreign or domestic country" | "indigenous origin" | "/r/used for" |  | "FN" |  |
| fn:indigenous_origin | fn:HasLexicalUnit | fn:lu:indigenous_origin:indigenous | "indigenous origin" | "indigenous" | "has lexical unit" |  | "FN" |  |
| fn:indigenous_origin | fn:HasLexicalUnit | fn:lu:indigenous_origin:native | "indigenous origin" | "native" | "has lexical unit" |  | "FN" |  |
| fn:indigenous_origin | fn:HasLexicalUnit | fn:lu:indigenous_origin:autochthonous | "indigenous origin" | "autochthonous" | "has lexical unit" |  | "FN" |  |
| fn:indigenous_origin | fn:HasLexicalUnit | fn:lu:indigenous_origin:stranger | "indigenous origin" | "stranger" | "has lexical unit" |  | "FN" |  |
| fn:indigenous_origin | fn:HasLexicalUnit | fn:lu:indigenous_origin:non-native | "indigenous origin" | "non-native" | "has lexical unit" |  | "FN" |  |
| fn:indigenous_origin | fn:HasLexicalUnit | fn:lu:indigenous_origin:local | "indigenous origin" | "local" | "has lexical unit" |  | "FN" |  |
| fn:indigenous_origin | /r/HasA | fn:fe:entity | "indigenous origin" | "entity" | "/r/has a" |  | "FN" |  |
| fn:indigenous_origin | /r/HasA | fn:fe:origin | "indigenous origin" | "origin" | "/r/has a" |  | "FN" |  |
| fn:history | /r/IsA | fn:individual_history | "history" | "individual history" | "/r/is a" |  | "FN" |  |
| fn:individual_history | /r/HasSubevent | fn:historic_event | "individual history" | "historic event" | "/r/has subevent" |  | "FN" |  |
| fn:eventive_affecting | /r/UsedFor | fn:individual_history | "eventive affecting" | "individual history" | "/r/used for" |  | "FN" |  |
| fn:importance | /r/UsedFor | fn:individual_history | "importance" | "individual history" | "/r/used for" |  | "FN" |  |
| fn:individual_history | /r/IsA | fn:history_scenario | "individual history" | "history scenario" | "/r/is a" |  | "FN" |  |
| fn:individual_history | fn:HasLexicalUnit | fn:lu:individual_history:history | "individual history" | "history" | "has lexical unit" |  | "FN" |  |
| fn:individual_history | fn:HasLexicalUnit | fn:lu:individual_history:past | "individual history" | "past" | "has lexical unit" |  | "FN" |  |
| fn:individual_history | /r/HasA | fn:fe:participant | "individual history" | "participant" | "/r/has a" |  | "FN" |  |
| fn:individual_history | /r/HasA | fn:fe:events | "individual history" | "events" | "/r/has a" |  | "FN" |  |
| fn:individual_history | /r/HasA | fn:fe:domain | "individual history" | "domain" | "/r/has a" |  | "FN" |  |
| fn:individual_history | /r/HasA | fn:fe:end_time | "individual history" | "end time" | "/r/has a" |  | "FN" |  |
| fn:individual_history | /r/HasA | fn:fe:start_time | "individual history" | "start time" | "/r/has a" |  | "FN" |  |
| fn:individual_history | /r/HasA | fn:fe:time_span | "individual history" | "time span" | "/r/has a" |  | "FN" |  |
| fn:individual_history | /r/HasA | fn:fe:duration | "individual history" | "duration" | "/r/has a" |  | "FN" |  |
| fn:individual_history | /r/HasA | fn:fe:depictive | "individual history" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:individual_history | /r/HasA | fn:fe:time | "individual history" | "time" | "/r/has a" |  | "FN" |  |
| fn:ineffability | /r/IsA | fn:stimulus_focus | "ineffability" | "stimulus focus" | "/r/is a" |  | "FN" |  |
| fn:ineffability | fn:HasLexicalUnit | fn:lu:ineffability:magic | "ineffability" | "magic" | "has lexical unit" |  | "FN" |  |
| fn:ineffability | fn:HasLexicalUnit | fn:lu:ineffability:magic | "ineffability" | "magic" | "has lexical unit" |  | "FN" |  |
| fn:ineffability | fn:HasLexicalUnit | fn:lu:ineffability:magical | "ineffability" | "magical" | "has lexical unit" |  | "FN" |  |
| fn:ineffability | fn:HasLexicalUnit | fn:lu:ineffability:ineffable | "ineffability" | "ineffable" | "has lexical unit" |  | "FN" |  |
| fn:ineffability | fn:HasLexicalUnit | fn:lu:ineffability:ineffability | "ineffability" | "ineffability" | "has lexical unit" |  | "FN" |  |
| fn:ineffability | fn:HasLexicalUnit | fn:lu:ineffability:je_ne_sais_quoi | "ineffability" | "je ne sais quoi" | "has lexical unit" |  | "FN" |  |
| fn:ineffability | fn:HasLexicalUnit | fn:lu:ineffability:magicalness | "ineffability" | "magicalness" | "has lexical unit" |  | "FN" |  |
| fn:ineffability | /r/HasA | fn:fe:stimulus | "ineffability" | "stimulus" | "/r/has a" |  | "FN" |  |
| fn:ineffability | /r/HasA | fn:fe:experiencer | "ineffability" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:ineffability | /r/HasA | fn:fe:degree | "ineffability" | "degree" | "/r/has a" |  | "FN" |  |
| fn:ineffability | /r/HasA | fn:fe:circumstances | "ineffability" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:ineffability | /r/HasA | fn:fe:parameter | "ineffability" | "parameter" | "/r/has a" |  | "FN" |  |
| fn:ineffability | /r/HasA | fn:fe:comparison_set | "ineffability" | "comparison set" | "/r/has a" |  | "FN" |  |
| fn:ineffability | /r/HasA | fn:fe:property | "ineffability" | "property" | "/r/has a" |  | "FN" |  |
| fn:ineffability | /r/HasA | fn:fe:attribute | "ineffability" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:infecting | /r/IsA | fn:transitive_action | "infecting" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:infecting | /r/Causes | fn:medical_conditions | "infecting" | "medical conditions" | "/r/causes" |  | "FN" |  |
| fn:infecting | fn:HasLexicalUnit | fn:lu:infecting:give | "infecting" | "give" | "has lexical unit" |  | "FN" |  |
| fn:infecting | fn:HasLexicalUnit | fn:lu:infecting:infect | "infecting" | "infect" | "has lexical unit" |  | "FN" |  |
| fn:infecting | /r/HasA | fn:fe:infection | "infecting" | "infection" | "/r/has a" |  | "FN" |  |
| fn:infecting | /r/HasA | fn:fe:infected_entity | "infecting" | "infected entity" | "/r/has a" |  | "FN" |  |
| fn:infecting | /r/HasA | fn:fe:infection_cause | "infecting" | "infection cause" | "/r/has a" |  | "FN" |  |
| fn:infecting | /r/HasA | fn:fe:medium | "infecting" | "medium" | "/r/has a" |  | "FN" |  |
| fn:infecting | /r/HasA | fn:fe:manner | "infecting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:infecting | /r/HasA | fn:fe:place | "infecting" | "place" | "/r/has a" |  | "FN" |  |
| fn:infecting | /r/HasA | fn:fe:time | "infecting" | "time" | "/r/has a" |  | "FN" |  |
| fn:infecting | /r/HasA | fn:fe:depictive | "infecting" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:infecting | /r/HasA | fn:fe:means | "infecting" | "means" | "/r/has a" |  | "FN" |  |
| fn:infecting | /r/HasA | fn:fe:result | "infecting" | "result" | "/r/has a" |  | "FN" |  |
| fn:authority | /r/IsA | fn:influencing_potential | "authority" | "influencing potential" | "/r/is a" |  | "FN" |  |
| fn:influencing_potential | /r/UsedFor | fn:manipulate_into_doing | "influencing potential" | "manipulate into doing" | "/r/used for" |  | "FN" |  |
| fn:influencing_potential | /r/HasA | fn:fe:force | "influencing potential" | "force" | "/r/has a" |  | "FN" |  |
| fn:influencing_potential | /r/HasA | fn:fe:entity | "influencing potential" | "entity" | "/r/has a" |  | "FN" |  |
| fn:influencing_potential | /r/HasA | fn:fe:domain | "influencing potential" | "domain" | "/r/has a" |  | "FN" |  |
| fn:influencing_potential | /r/HasA | fn:fe:source | "influencing potential" | "source" | "/r/has a" |  | "FN" |  |
| fn:influencing_potential | /r/HasA | fn:fe:state_of_affairs | "influencing potential" | "state of affairs" | "/r/has a" |  | "FN" |  |
| fn:information | /r/UsedFor | fn:awareness | "information" | "awareness" | "/r/used for" |  | "FN" |  |
| fn:information | /r/UsedFor | fn:communication | "information" | "communication" | "/r/used for" |  | "FN" |  |
| fn:information | /r/UsedFor | fn:correctness | "information" | "correctness" | "/r/used for" |  | "FN" |  |
| fn:information | fn:HasLexicalUnit | fn:lu:information:information | "information" | "information" | "has lexical unit" |  | "FN" |  |
| fn:information | fn:HasLexicalUnit | fn:lu:information:intelligence | "information" | "intelligence" | "has lexical unit" |  | "FN" |  |
| fn:information | fn:HasLexicalUnit | fn:lu:information:intel | "information" | "intel" | "has lexical unit" |  | "FN" |  |
| fn:information | fn:HasLexicalUnit | fn:lu:information:dirt | "information" | "dirt" | "has lexical unit" |  | "FN" |  |
| fn:information | fn:HasLexicalUnit | fn:lu:information:scoop | "information" | "scoop" | "has lexical unit" |  | "FN" |  |
| fn:information | fn:HasLexicalUnit | fn:lu:information:dope | "information" | "dope" | "has lexical unit" |  | "FN" |  |
| fn:information | fn:HasLexicalUnit | fn:lu:information:straight_dope | "information" | "straight dope" | "has lexical unit" |  | "FN" |  |
| fn:information | fn:HasLexicalUnit | fn:lu:information:data | "information" | "data" | "has lexical unit" |  | "FN" |  |
| fn:information | fn:HasLexicalUnit | fn:lu:information:info | "information" | "info" | "has lexical unit" |  | "FN" |  |
| fn:information | fn:HasLexicalUnit | fn:lu:information:skinny | "information" | "skinny" | "has lexical unit" |  | "FN" |  |
| fn:information | fn:HasLexicalUnit | fn:lu:information:details | "information" | "details" | "has lexical unit" |  | "FN" |  |
| fn:information | /r/HasA | fn:fe:information | "information" | "information" | "/r/has a" |  | "FN" |  |
| fn:fe:cognizer | /r/IsA | fn:st:human | "cognizer" | "human" | "/r/is a" |  | "FN" |  |
| fn:information | /r/HasA | fn:fe:cognizer | "information" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:information | /r/HasA | fn:fe:topic | "information" | "topic" | "/r/has a" |  | "FN" |  |
| fn:information | /r/HasA | fn:fe:source | "information" | "source" | "/r/has a" |  | "FN" |  |
| fn:information | /r/HasA | fn:fe:means_of_gathering | "information" | "means of gathering" | "/r/has a" |  | "FN" |  |
| fn:information_display | /r/IsA | fn:artifact | "information display" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:cause_to_perceive | /r/UsedFor | fn:information_display | "cause to perceive" | "information display" | "/r/used for" |  | "FN" |  |
| fn:information_display | fn:HasLexicalUnit | fn:lu:information_display:board_[forum] | "information display" | "board [forum]" | "has lexical unit" |  | "FN" |  |
| fn:information_display | fn:HasLexicalUnit | fn:lu:information_display:board_[white/black/chalk] | "information display" | "board [white/black/chalk]" | "has lexical unit" |  | "FN" |  |
| fn:information_display | fn:HasLexicalUnit | fn:lu:information_display:monitor | "information display" | "monitor" | "has lexical unit" |  | "FN" |  |
| fn:information_display | /r/HasA | fn:fe:display | "information display" | "display" | "/r/has a" |  | "FN" |  |
| fn:information_display | /r/HasA | fn:fe:use | "information display" | "use" | "/r/has a" |  | "FN" |  |
| fn:information_display | /r/HasA | fn:fe:creator | "information display" | "creator" | "/r/has a" |  | "FN" |  |
| fn:information_display | /r/HasA | fn:fe:time_of_creation | "information display" | "time of creation" | "/r/has a" |  | "FN" |  |
| fn:information_display | /r/HasA | fn:fe:name | "information display" | "name" | "/r/has a" |  | "FN" |  |
| fn:information_display | /r/HasA | fn:fe:type | "information display" | "type" | "/r/has a" |  | "FN" |  |
| fn:information_display | /r/HasA | fn:fe:material | "information display" | "material" | "/r/has a" |  | "FN" |  |
| fn:infrastructure | /r/IsA | fn:artifact | "infrastructure" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:infrastructure | /r/UsedFor | fn:institutions | "infrastructure" | "institutions" | "/r/used for" |  | "FN" |  |
| fn:infrastructure | fn:HasLexicalUnit | fn:lu:infrastructure:infrastructure | "infrastructure" | "infrastructure" | "has lexical unit" |  | "FN" |  |
| fn:infrastructure | fn:HasLexicalUnit | fn:lu:infrastructure:base | "infrastructure" | "base" | "has lexical unit" |  | "FN" |  |
| fn:infrastructure | /r/HasA | fn:fe:activity | "infrastructure" | "activity" | "/r/has a" |  | "FN" |  |
| fn:infrastructure | /r/HasA | fn:fe:place | "infrastructure" | "place" | "/r/has a" |  | "FN" |  |
| fn:infrastructure | /r/HasA | fn:fe:possessor | "infrastructure" | "possessor" | "/r/has a" |  | "FN" |  |
| fn:infrastructure | /r/HasA | fn:fe:resource | "infrastructure" | "resource" | "/r/has a" |  | "FN" |  |
| fn:infrastructure | /r/HasA | fn:fe:user | "infrastructure" | "user" | "/r/has a" |  | "FN" |  |
| fn:infrastructure | /r/HasA | fn:fe:descriptor | "infrastructure" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:infrastructure | /r/HasA | fn:fe:infrastructure | "infrastructure" | "infrastructure" | "/r/has a" |  | "FN" |  |
| fn:ingestion | /r/IsA | fn:ingest_substance | "ingestion" | "ingest substance" | "/r/is a" |  | "FN" |  |
| fn:ingest_substance | /r/IsA | fn:intentionally_act | "ingest substance" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:ingest_substance | fn:HasLexicalUnit | fn:lu:ingest_substance:smoke | "ingest substance" | "smoke" | "has lexical unit" |  | "FN" |  |
| fn:ingest_substance | fn:HasLexicalUnit | fn:lu:ingest_substance:snort | "ingest substance" | "snort" | "has lexical unit" |  | "FN" |  |
| fn:ingest_substance | fn:HasLexicalUnit | fn:lu:ingest_substance:drag | "ingest substance" | "drag" | "has lexical unit" |  | "FN" |  |
| fn:ingest_substance | fn:HasLexicalUnit | fn:lu:ingest_substance:drag | "ingest substance" | "drag" | "has lexical unit" |  | "FN" |  |
| fn:ingest_substance | fn:HasLexicalUnit | fn:lu:ingest_substance:toke | "ingest substance" | "toke" | "has lexical unit" |  | "FN" |  |
| fn:ingest_substance | fn:HasLexicalUnit | fn:lu:ingest_substance:pull | "ingest substance" | "pull" | "has lexical unit" |  | "FN" |  |
| fn:ingest_substance | fn:HasLexicalUnit | fn:lu:ingest_substance:pop | "ingest substance" | "pop" | "has lexical unit" |  | "FN" |  |
| fn:ingest_substance | fn:HasLexicalUnit | fn:lu:ingest_substance:inject | "ingest substance" | "inject" | "has lexical unit" |  | "FN" |  |
| fn:ingest_substance | fn:HasLexicalUnit | fn:lu:ingest_substance:shoot | "ingest substance" | "shoot" | "has lexical unit" |  | "FN" |  |
| fn:ingest_substance | fn:HasLexicalUnit | fn:lu:ingest_substance:sniff | "ingest substance" | "sniff" | "has lexical unit" |  | "FN" |  |
| fn:ingest_substance | fn:HasLexicalUnit | fn:lu:ingest_substance:do | "ingest substance" | "do" | "has lexical unit" |  | "FN" |  |
| fn:ingest_substance | fn:HasLexicalUnit | fn:lu:ingest_substance:use | "ingest substance" | "use" | "has lexical unit" |  | "FN" |  |
| fn:ingest_substance | fn:HasLexicalUnit | fn:lu:ingest_substance:take | "ingest substance" | "take" | "has lexical unit" |  | "FN" |  |
| fn:ingest_substance | fn:HasLexicalUnit | fn:lu:ingest_substance:puff | "ingest substance" | "puff" | "has lexical unit" |  | "FN" |  |
| fn:ingest_substance | fn:HasLexicalUnit | fn:lu:ingest_substance:have | "ingest substance" | "have" | "has lexical unit" |  | "FN" |  |
| fn:ingest_substance | /r/HasA | fn:fe:manner | "ingest substance" | "manner" | "/r/has a" |  | "FN" |  |
| fn:ingest_substance | /r/HasA | fn:fe:means | "ingest substance" | "means" | "/r/has a" |  | "FN" |  |
| fn:ingest_substance | /r/HasA | fn:fe:place | "ingest substance" | "place" | "/r/has a" |  | "FN" |  |
| fn:ingest_substance | /r/HasA | fn:fe:purpose | "ingest substance" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:ingest_substance | /r/HasA | fn:fe:time | "ingest substance" | "time" | "/r/has a" |  | "FN" |  |
| fn:ingest_substance | /r/HasA | fn:fe:delivery_device | "ingest substance" | "delivery device" | "/r/has a" |  | "FN" |  |
| fn:fe:ingestor | /r/IsA | fn:st:sentient | "ingestor" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:ingest_substance | /r/HasA | fn:fe:ingestor | "ingest substance" | "ingestor" | "/r/has a" |  | "FN" |  |
| fn:ingest_substance | /r/HasA | fn:fe:substance | "ingest substance" | "substance" | "/r/has a" |  | "FN" |  |
| fn:ingest_substance | /r/HasA | fn:fe:frequency | "ingest substance" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:ingest_substance | /r/HasA | fn:fe:entry_path | "ingest substance" | "entry path" | "/r/has a" |  | "FN" |  |
| fn:ingest_substance | /r/HasA | fn:fe:duration | "ingest substance" | "duration" | "/r/has a" |  | "FN" |  |
| fn:ingestion | /r/IsA | fn:ingest_substance | "ingestion" | "ingest substance" | "/r/is a" |  | "FN" |  |
| fn:ingestion | /r/IsA | fn:manipulation | "ingestion" | "manipulation" | "/r/is a" |  | "FN" |  |
| fn:cause_motion | /r/UsedFor | fn:ingestion | "cause motion" | "ingestion" | "/r/used for" |  | "FN" |  |
| fn:ingestion | /r/UsedFor | fn:food | "ingestion" | "food" | "/r/used for" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:lap | "ingestion" | "lap" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:slurp | "ingestion" | "slurp" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:swig | "ingestion" | "swig" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:guzzle | "ingestion" | "guzzle" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:gulp | "ingestion" | "gulp" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:down | "ingestion" | "down" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:sip | "ingestion" | "sip" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:sup | "ingestion" | "sup" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:munch | "ingestion" | "munch" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:nosh | "ingestion" | "nosh" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:feast | "ingestion" | "feast" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:feed | "ingestion" | "feed" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:snack | "ingestion" | "snack" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:breakfast | "ingestion" | "breakfast" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:lunch | "ingestion" | "lunch" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:dine | "ingestion" | "dine" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:ingest | "ingestion" | "ingest" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:nurse | "ingestion" | "nurse" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:nibble | "ingestion" | "nibble" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:eat | "ingestion" | "eat" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:drink | "ingestion" | "drink" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:gobble | "ingestion" | "gobble" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:devour | "ingestion" | "devour" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:consume | "ingestion" | "consume" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:sip | "ingestion" | "sip" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:gulp | "ingestion" | "gulp" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:swig | "ingestion" | "swig" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:slurp | "ingestion" | "slurp" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:have | "ingestion" | "have" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:imbibe | "ingestion" | "imbibe" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:quaff | "ingestion" | "quaff" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:swill | "ingestion" | "swill" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:put_away | "ingestion" | "put away" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:put_back | "ingestion" | "put back" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:tuck | "ingestion" | "tuck" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | fn:HasLexicalUnit | fn:lu:ingestion:ingestion | "ingestion" | "ingestion" | "has lexical unit" |  | "FN" |  |
| fn:ingestion | /r/HasA | fn:fe:ingestor | "ingestion" | "ingestor" | "/r/has a" |  | "FN" |  |
| fn:ingestion | /r/HasA | fn:fe:place | "ingestion" | "place" | "/r/has a" |  | "FN" |  |
| fn:ingestion | /r/HasA | fn:fe:time | "ingestion" | "time" | "/r/has a" |  | "FN" |  |
| fn:ingestion | /r/HasA | fn:fe:ingestibles | "ingestion" | "ingestibles" | "/r/has a" |  | "FN" |  |
| fn:ingestion | /r/HasA | fn:fe:instrument | "ingestion" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:ingestion | /r/HasA | fn:fe:manner | "ingestion" | "manner" | "/r/has a" |  | "FN" |  |
| fn:ingestion | /r/HasA | fn:fe:source | "ingestion" | "source" | "/r/has a" |  | "FN" |  |
| fn:ingestion | /r/HasA | fn:fe:means | "ingestion" | "means" | "/r/has a" |  | "FN" |  |
| fn:ingestion | /r/HasA | fn:fe:degree | "ingestion" | "degree" | "/r/has a" |  | "FN" |  |
| fn:ingestion | /r/HasA | fn:fe:purpose | "ingestion" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:ingestion | /r/HasA | fn:fe:duration | "ingestion" | "duration" | "/r/has a" |  | "FN" |  |
| fn:creating | /r/UsedFor | fn:ingredients | "creating" | "ingredients" | "/r/used for" |  | "FN" |  |
| fn:ingredients | fn:HasLexicalUnit | fn:lu:ingredients:ingredient | "ingredients" | "ingredient" | "has lexical unit" |  | "FN" |  |
| fn:ingredients | fn:HasLexicalUnit | fn:lu:ingredients:precursor | "ingredients" | "precursor" | "has lexical unit" |  | "FN" |  |
| fn:ingredients | fn:HasLexicalUnit | fn:lu:ingredients:material | "ingredients" | "material" | "has lexical unit" |  | "FN" |  |
| fn:ingredients | fn:HasLexicalUnit | fn:lu:ingredients:component | "ingredients" | "component" | "has lexical unit" |  | "FN" |  |
| fn:ingredients | fn:HasLexicalUnit | fn:lu:ingredients:element | "ingredients" | "element" | "has lexical unit" |  | "FN" |  |
| fn:ingredients | fn:HasLexicalUnit | fn:lu:ingredients:trace | "ingredients" | "trace" | "has lexical unit" |  | "FN" |  |
| fn:ingredients | /r/HasA | fn:fe:material | "ingredients" | "material" | "/r/has a" |  | "FN" |  |
| fn:ingredients | /r/HasA | fn:fe:type | "ingredients" | "type" | "/r/has a" |  | "FN" |  |
| fn:fe:origin | /r/IsA | fn:st:source | "origin" | "source" | "/r/is a" |  | "FN" |  |
| fn:ingredients | /r/HasA | fn:fe:origin | "ingredients" | "origin" | "/r/has a" |  | "FN" |  |
| fn:ingredients | /r/HasA | fn:fe:descriptor | "ingredients" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:ingredients | /r/HasA | fn:fe:use | "ingredients" | "use" | "/r/has a" |  | "FN" |  |
| fn:ingredients | /r/HasA | fn:fe:product | "ingredients" | "product" | "/r/has a" |  | "FN" |  |
| fn:ingredients | /r/HasA | fn:fe:name | "ingredients" | "name" | "/r/has a" |  | "FN" |  |
| fn:tool_purpose | /r/IsA | fn:inherent_purpose | "tool purpose" | "inherent purpose" | "/r/is a" |  | "FN" |  |
| fn:inherent_purpose | /r/IsA | fn:relation | "inherent purpose" | "relation" | "/r/is a" |  | "FN" |  |
| fn:inherent_purpose | fn:HasLexicalUnit | fn:lu:inherent_purpose:function | "inherent purpose" | "function" | "has lexical unit" |  | "FN" |  |
| fn:inherent_purpose | fn:HasLexicalUnit | fn:lu:inherent_purpose:purpose | "inherent purpose" | "purpose" | "has lexical unit" |  | "FN" |  |
| fn:inherent_purpose | /r/HasA | fn:fe:apparatus | "inherent purpose" | "apparatus" | "/r/has a" |  | "FN" |  |
| fn:inherent_purpose | /r/HasA | fn:fe:goal | "inherent purpose" | "goal" | "/r/has a" |  | "FN" |  |
| fn:inherent_purpose | /r/HasA | fn:fe:domain | "inherent purpose" | "domain" | "/r/has a" |  | "FN" |  |
| fn:inherent_purpose | /r/HasA | fn:fe:type | "inherent purpose" | "type" | "/r/has a" |  | "FN" |  |
| fn:inhibit_motion_scenario | /r/HasSubevent | fn:inhibit_movement | "inhibit motion scenario" | "inhibit movement" | "/r/has subevent" |  | "FN" |  |
| fn:inhibit_motion_scenario | /r/HasSubevent | fn:releasing | "inhibit motion scenario" | "releasing" | "/r/has subevent" |  | "FN" |  |
| fn:inhibit_motion_scenario | /r/HasSubevent | fn:taking_captive | "inhibit motion scenario" | "taking captive" | "/r/has subevent" |  | "FN" |  |
| fn:inhibit_motion_scenario | /r/HasA | fn:fe:agent | "inhibit motion scenario" | "agent" | "/r/has a" |  | "FN" |  |
| fn:inhibit_motion_scenario | /r/HasA | fn:fe:theme | "inhibit motion scenario" | "theme" | "/r/has a" |  | "FN" |  |
| fn:inhibit_motion_scenario | /r/HasA | fn:fe:holding_location | "inhibit motion scenario" | "holding location" | "/r/has a" |  | "FN" |  |
| fn:inhibit_motion_scenario | /r/HasA | fn:fe:cause | "inhibit motion scenario" | "cause" | "/r/has a" |  | "FN" |  |
| fn:imprisonment | /r/IsA | fn:inhibit_movement | "imprisonment" | "inhibit movement" | "/r/is a" |  | "FN" |  |
| fn:inhibit_movement | /r/IsA | fn:intentionally_affect | "inhibit movement" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:inhibit_motion_scenario | /r/HasSubevent | fn:inhibit_movement | "inhibit motion scenario" | "inhibit movement" | "/r/has subevent" |  | "FN" |  |
| fn:inhibit_movement | /r/UsedFor | fn:arrest | "inhibit movement" | "arrest" | "/r/used for" |  | "FN" |  |
| fn:inhibit_movement | /r/UsedFor | fn:being_in_captivity | "inhibit movement" | "being in captivity" | "/r/used for" |  | "FN" |  |
| fn:inhibit_movement | /r/UsedFor | fn:detaining | "inhibit movement" | "detaining" | "/r/used for" |  | "FN" |  |
| fn:inhibit_movement | /r/UsedFor | fn:prison | "inhibit movement" | "prison" | "/r/used for" |  | "FN" |  |
| fn:releasing | /r/HasPrerequisite | fn:inhibit_movement | "releasing" | "inhibit movement" | "/r/has prerequisite" |  | "FN" |  |
| fn:inhibit_movement | /r/HasPrerequisite | fn:taking_captive | "inhibit movement" | "taking captive" | "/r/has prerequisite" |  | "FN" |  |
| fn:inhibit_movement | fn:HasLexicalUnit | fn:lu:inhibit_movement:confine | "inhibit movement" | "confine" | "has lexical unit" |  | "FN" |  |
| fn:inhibit_movement | fn:HasLexicalUnit | fn:lu:inhibit_movement:lock | "inhibit movement" | "lock" | "has lexical unit" |  | "FN" |  |
| fn:inhibit_movement | fn:HasLexicalUnit | fn:lu:inhibit_movement:tie | "inhibit movement" | "tie" | "has lexical unit" |  | "FN" |  |
| fn:inhibit_movement | fn:HasLexicalUnit | fn:lu:inhibit_movement:shut_up | "inhibit movement" | "shut up" | "has lexical unit" |  | "FN" |  |
| fn:inhibit_movement | fn:HasLexicalUnit | fn:lu:inhibit_movement:restrict | "inhibit movement" | "restrict" | "has lexical unit" |  | "FN" |  |
| fn:inhibit_movement | fn:HasLexicalUnit | fn:lu:inhibit_movement:imprison | "inhibit movement" | "imprison" | "has lexical unit" |  | "FN" |  |
| fn:inhibit_movement | fn:HasLexicalUnit | fn:lu:inhibit_movement:confinement | "inhibit movement" | "confinement" | "has lexical unit" |  | "FN" |  |
| fn:inhibit_movement | fn:HasLexicalUnit | fn:lu:inhibit_movement:detain | "inhibit movement" | "detain" | "has lexical unit" |  | "FN" |  |
| fn:inhibit_movement | fn:HasLexicalUnit | fn:lu:inhibit_movement:hold | "inhibit movement" | "hold" | "has lexical unit" |  | "FN" |  |
| fn:inhibit_movement | fn:HasLexicalUnit | fn:lu:inhibit_movement:immure | "inhibit movement" | "immure" | "has lexical unit" |  | "FN" |  |
| fn:inhibit_movement | fn:HasLexicalUnit | fn:lu:inhibit_movement:constraint | "inhibit movement" | "constraint" | "has lexical unit" |  | "FN" |  |
| fn:inhibit_movement | fn:HasLexicalUnit | fn:lu:inhibit_movement:constrain | "inhibit movement" | "constrain" | "has lexical unit" |  | "FN" |  |
| fn:inhibit_movement | /r/HasA | fn:fe:theme | "inhibit movement" | "theme" | "/r/has a" |  | "FN" |  |
| fn:inhibit_movement | /r/HasA | fn:fe:holding_location | "inhibit movement" | "holding location" | "/r/has a" |  | "FN" |  |
| fn:inhibit_movement | /r/HasA | fn:fe:agent | "inhibit movement" | "agent" | "/r/has a" |  | "FN" |  |
| fn:inhibit_movement | /r/HasA | fn:fe:instrument | "inhibit movement" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:inhibit_movement | /r/HasA | fn:fe:reciprocation | "inhibit movement" | "reciprocation" | "/r/has a" |  | "FN" |  |
| fn:inhibit_movement | /r/HasA | fn:fe:place | "inhibit movement" | "place" | "/r/has a" |  | "FN" |  |
| fn:inhibit_movement | /r/HasA | fn:fe:time | "inhibit movement" | "time" | "/r/has a" |  | "FN" |  |
| fn:inhibit_movement | /r/HasA | fn:fe:purpose | "inhibit movement" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:inhibit_movement | /r/HasA | fn:fe:means | "inhibit movement" | "means" | "/r/has a" |  | "FN" |  |
| fn:inhibit_movement | /r/HasA | fn:fe:manner | "inhibit movement" | "manner" | "/r/has a" |  | "FN" |  |
| fn:inhibit_movement | /r/HasA | fn:fe:explanation | "inhibit movement" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:inhibit_movement | /r/HasA | fn:fe:duration | "inhibit movement" | "duration" | "/r/has a" |  | "FN" |  |
| fn:inhibit_movement | /r/HasA | fn:fe:cause | "inhibit movement" | "cause" | "/r/has a" |  | "FN" |  |
| fn:patrolling | /r/IsA | fn:inspecting | "patrolling" | "inspecting" | "/r/is a" |  | "FN" |  |
| fn:inspecting | /r/IsA | fn:scrutinizing_for | "inspecting" | "scrutinizing for" | "/r/is a" |  | "FN" |  |
| fn:inspecting | /r/SimilarTo | fn:scrutiny | "inspecting" | "scrutiny" | "/r/similar to" |  | "FN" |  |
| fn:inspecting | fn:HasLexicalUnit | fn:lu:inspecting:inspect | "inspecting" | "inspect" | "has lexical unit" |  | "FN" |  |
| fn:inspecting | fn:HasLexicalUnit | fn:lu:inspecting:proof-read | "inspecting" | "proof-read" | "has lexical unit" |  | "FN" |  |
| fn:inspecting | fn:HasLexicalUnit | fn:lu:inspecting:frisk | "inspecting" | "frisk" | "has lexical unit" |  | "FN" |  |
| fn:inspecting | fn:HasLexicalUnit | fn:lu:inspecting:inspection | "inspecting" | "inspection" | "has lexical unit" |  | "FN" |  |
| fn:inspecting | fn:HasLexicalUnit | fn:lu:inspecting:check | "inspecting" | "check" | "has lexical unit" |  | "FN" |  |
| fn:inspecting | fn:HasLexicalUnit | fn:lu:inspecting:double-check | "inspecting" | "double-check" | "has lexical unit" |  | "FN" |  |
| fn:inspecting | fn:HasLexicalUnit | fn:lu:inspecting:examine | "inspecting" | "examine" | "has lexical unit" |  | "FN" |  |
| fn:inspecting | fn:HasLexicalUnit | fn:lu:inspecting:pat_down | "inspecting" | "pat down" | "has lexical unit" |  | "FN" |  |
| fn:inspecting | fn:HasLexicalUnit | fn:lu:inspecting:examination | "inspecting" | "examination" | "has lexical unit" |  | "FN" |  |
| fn:fe:inspector | /r/IsA | fn:st:sentient | "inspector" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:inspecting | /r/HasA | fn:fe:inspector | "inspecting" | "inspector" | "/r/has a" |  | "FN" |  |
| fn:inspecting | /r/HasA | fn:fe:ground | "inspecting" | "ground" | "/r/has a" |  | "FN" |  |
| fn:inspecting | /r/HasA | fn:fe:unwanted_entity | "inspecting" | "unwanted entity" | "/r/has a" |  | "FN" |  |
| fn:inspecting | /r/HasA | fn:fe:means | "inspecting" | "means" | "/r/has a" |  | "FN" |  |
| fn:inspecting | /r/HasA | fn:fe:purpose | "inspecting" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:inspecting | /r/HasA | fn:fe:manner | "inspecting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:inspecting | /r/HasA | fn:fe:degree | "inspecting" | "degree" | "/r/has a" |  | "FN" |  |
| fn:inspecting | /r/HasA | fn:fe:location_of_protagonist | "inspecting" | "location of protagonist" | "/r/has a" |  | "FN" |  |
| fn:inspecting | /r/HasA | fn:fe:desired_state_of_affairs | "inspecting" | "desired state of affairs" | "/r/has a" |  | "FN" |  |
| fn:inspecting | /r/HasA | fn:fe:time | "inspecting" | "time" | "/r/has a" |  | "FN" |  |
| fn:inspecting | /r/HasA | fn:fe:circumstances | "inspecting" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:inspecting | /r/HasA | fn:fe:instrument | "inspecting" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:inspecting | /r/HasA | fn:fe:particular_iteration | "inspecting" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:placing | /r/UsedFor | fn:installing | "placing" | "installing" | "/r/used for" |  | "FN" |  |
| fn:installing | fn:HasLexicalUnit | fn:lu:installing:install | "installing" | "install" | "has lexical unit" |  | "FN" |  |
| fn:installing | fn:HasLexicalUnit | fn:lu:installing:installation | "installing" | "installation" | "has lexical unit" |  | "FN" |  |
| fn:installing | /r/HasA | fn:fe:agent | "installing" | "agent" | "/r/has a" |  | "FN" |  |
| fn:installing | /r/HasA | fn:fe:component | "installing" | "component" | "/r/has a" |  | "FN" |  |
| fn:installing | /r/HasA | fn:fe:location_of_protagonist | "installing" | "location of protagonist" | "/r/has a" |  | "FN" |  |
| fn:fe:fixed_location | /r/IsA | fn:st:goal | "fixed location" | "goal" | "/r/is a" |  | "FN" |  |
| fn:installing | /r/HasA | fn:fe:fixed_location | "installing" | "fixed location" | "/r/has a" |  | "FN" |  |
| fn:installing | /r/HasA | fn:fe:manner | "installing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:installing | /r/HasA | fn:fe:degree | "installing" | "degree" | "/r/has a" |  | "FN" |  |
| fn:installing | /r/HasA | fn:fe:depictive | "installing" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:installing | /r/HasA | fn:fe:means | "installing" | "means" | "/r/has a" |  | "FN" |  |
| fn:installing | /r/HasA | fn:fe:duration_of_final_state | "installing" | "duration of final state" | "/r/has a" |  | "FN" |  |
| fn:installing | /r/HasA | fn:fe:place | "installing" | "place" | "/r/has a" |  | "FN" |  |
| fn:installing | /r/HasA | fn:fe:explanation | "installing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:installing | /r/HasA | fn:fe:time | "installing" | "time" | "/r/has a" |  | "FN" |  |
| fn:installing | /r/HasA | fn:fe:area | "installing" | "area" | "/r/has a" |  | "FN" |  |
| fn:installing | /r/HasA | fn:fe:co-participant | "installing" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:installing | /r/HasA | fn:fe:purpose | "installing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:event_instance | /r/IsA | fn:instance | "event instance" | "instance" | "/r/is a" |  | "FN" |  |
| fn:exemplar | /r/IsA | fn:instance | "exemplar" | "instance" | "/r/is a" |  | "FN" |  |
| fn:instance | /r/UsedFor | fn:categorization | "instance" | "categorization" | "/r/used for" |  | "FN" |  |
| fn:instance | /r/UsedFor | fn:identicality | "instance" | "identicality" | "/r/used for" |  | "FN" |  |
| fn:instance | /r/UsedFor | fn:sole_instance | "instance" | "sole instance" | "/r/used for" |  | "FN" |  |
| fn:typicality | /r/IsA | fn:instance | "typicality" | "instance" | "/r/is a" |  | "FN" |  |
| fn:instance | fn:HasLexicalUnit | fn:lu:instance:specimen | "instance" | "specimen" | "has lexical unit" |  | "FN" |  |
| fn:instance | fn:HasLexicalUnit | fn:lu:instance:example | "instance" | "example" | "has lexical unit" |  | "FN" |  |
| fn:instance | fn:HasLexicalUnit | fn:lu:instance:case | "instance" | "case" | "has lexical unit" |  | "FN" |  |
| fn:instance | fn:HasLexicalUnit | fn:lu:instance:instance | "instance" | "instance" | "has lexical unit" |  | "FN" |  |
| fn:instance | /r/HasA | fn:fe:instance | "instance" | "instance" | "/r/has a" |  | "FN" |  |
| fn:instance | /r/HasA | fn:fe:type | "instance" | "type" | "/r/has a" |  | "FN" |  |
| fn:instance | /r/HasA | fn:fe:instance_prop | "instance" | "instance prop" | "/r/has a" |  | "FN" |  |
| fn:cure | /r/UsedFor | fn:institutionalization | "cure" | "institutionalization" | "/r/used for" |  | "FN" |  |
| fn:institutionalization | fn:HasLexicalUnit | fn:lu:institutionalization:institutionalize | "institutionalization" | "institutionalize" | "has lexical unit" |  | "FN" |  |
| fn:institutionalization | fn:HasLexicalUnit | fn:lu:institutionalization:institutionalization | "institutionalization" | "institutionalization" | "has lexical unit" |  | "FN" |  |
| fn:institutionalization | fn:HasLexicalUnit | fn:lu:institutionalization:commit | "institutionalization" | "commit" | "has lexical unit" |  | "FN" |  |
| fn:institutionalization | fn:HasLexicalUnit | fn:lu:institutionalization:commitment | "institutionalization" | "commitment" | "has lexical unit" |  | "FN" |  |
| fn:institutionalization | fn:HasLexicalUnit | fn:lu:institutionalization:hospitalize | "institutionalization" | "hospitalize" | "has lexical unit" |  | "FN" |  |
| fn:institutionalization | fn:HasLexicalUnit | fn:lu:institutionalization:hospitalization | "institutionalization" | "hospitalization" | "has lexical unit" |  | "FN" |  |
| fn:institutionalization | fn:HasLexicalUnit | fn:lu:institutionalization:admit | "institutionalization" | "admit" | "has lexical unit" |  | "FN" |  |
| fn:institutionalization | fn:HasLexicalUnit | fn:lu:institutionalization:admission | "institutionalization" | "admission" | "has lexical unit" |  | "FN" |  |
| fn:institutionalization | /r/HasA | fn:fe:patient | "institutionalization" | "patient" | "/r/has a" |  | "FN" |  |
| fn:fe:facility | /r/IsA | fn:st:goal | "facility" | "goal" | "/r/is a" |  | "FN" |  |
| fn:institutionalization | /r/HasA | fn:fe:facility | "institutionalization" | "facility" | "/r/has a" |  | "FN" |  |
| fn:institutionalization | /r/HasA | fn:fe:authority | "institutionalization" | "authority" | "/r/has a" |  | "FN" |  |
| fn:institutionalization | /r/HasA | fn:fe:affliction | "institutionalization" | "affliction" | "/r/has a" |  | "FN" |  |
| fn:institutionalization | /r/HasA | fn:fe:time | "institutionalization" | "time" | "/r/has a" |  | "FN" |  |
| fn:institutionalization | /r/HasA | fn:fe:purpose | "institutionalization" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:institutionalization | /r/HasA | fn:fe:means | "institutionalization" | "means" | "/r/has a" |  | "FN" |  |
| fn:institutionalization | /r/HasA | fn:fe:manner | "institutionalization" | "manner" | "/r/has a" |  | "FN" |  |
| fn:institutionalization | /r/HasA | fn:fe:explanation | "institutionalization" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:institutionalization | /r/HasA | fn:fe:duration_of_final_state | "institutionalization" | "duration of final state" | "/r/has a" |  | "FN" |  |
| fn:institutionalization | /r/HasA | fn:fe:place | "institutionalization" | "place" | "/r/has a" |  | "FN" |  |
| fn:institutionalization | /r/HasA | fn:fe:depictive | "institutionalization" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:institutionalization | /r/HasA | fn:fe:particular_iteration | "institutionalization" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:institutionalization | /r/HasA | fn:fe:frequency | "institutionalization" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:government_institution | /r/IsA | fn:institutions | "government institution" | "institutions" | "/r/is a" |  | "FN" |  |
| fn:judicial_body | /r/IsA | fn:institutions | "judicial body" | "institutions" | "/r/is a" |  | "FN" |  |
| fn:institutions | /r/IsA | fn:organization | "institutions" | "organization" | "/r/is a" |  | "FN" |  |
| fn:infrastructure | /r/UsedFor | fn:institutions | "infrastructure" | "institutions" | "/r/used for" |  | "FN" |  |
| fn:institutions | /r/UsedFor | fn:public_services | "institutions" | "public services" | "/r/used for" |  | "FN" |  |
| fn:institutions | fn:HasLexicalUnit | fn:lu:institutions:institution | "institutions" | "institution" | "has lexical unit" |  | "FN" |  |
| fn:institutions | fn:HasLexicalUnit | fn:lu:institutions:institutional | "institutions" | "institutional" | "has lexical unit" |  | "FN" |  |
| fn:institutions | /r/HasA | fn:fe:institution | "institutions" | "institution" | "/r/has a" |  | "FN" |  |
| fn:institutions | /r/HasA | fn:fe:domain | "institutions" | "domain" | "/r/has a" |  | "FN" |  |
| fn:institutions | /r/HasA | fn:fe:purpose | "institutions" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:institutions | /r/HasA | fn:fe:members | "institutions" | "members" | "/r/has a" |  | "FN" |  |
| fn:institutions | /r/HasA | fn:fe:place | "institutions" | "place" | "/r/has a" |  | "FN" |  |
| fn:intentional_deception | /r/IsA | fn:deception_end | "intentional deception" | "deception end" | "/r/is a" |  | "FN" |  |
| fn:intentional_deception | /r/UsedFor | fn:trap | "intentional deception" | "trap" | "/r/used for" |  | "FN" |  |
| fn:intentional_deception | /r/IsA | fn:deception_success | "intentional deception" | "deception success" | "/r/is a" |  | "FN" |  |
| fn:intentional_deception | fn:HasLexicalUnit | fn:lu:intentional_deception:fool | "intentional deception" | "fool" | "has lexical unit" |  | "FN" |  |
| fn:intentional_deception | fn:HasLexicalUnit | fn:lu:intentional_deception:mislead | "intentional deception" | "mislead" | "has lexical unit" |  | "FN" |  |
| fn:intentional_deception | fn:HasLexicalUnit | fn:lu:intentional_deception:deceive | "intentional deception" | "deceive" | "has lexical unit" |  | "FN" |  |
| fn:intentional_deception | fn:HasLexicalUnit | fn:lu:intentional_deception:trick | "intentional deception" | "trick" | "has lexical unit" |  | "FN" |  |
| fn:intentional_deception | fn:HasLexicalUnit | fn:lu:intentional_deception:deception | "intentional deception" | "deception" | "has lexical unit" |  | "FN" |  |
| fn:intentional_deception | fn:HasLexicalUnit | fn:lu:intentional_deception:get | "intentional deception" | "get" | "has lexical unit" |  | "FN" |  |
| fn:intentional_deception | /r/HasA | fn:fe:deceiver | "intentional deception" | "deceiver" | "/r/has a" |  | "FN" |  |
| fn:intentional_deception | /r/HasA | fn:fe:victim | "intentional deception" | "victim" | "/r/has a" |  | "FN" |  |
| fn:intentional_deception | /r/HasA | fn:fe:topic | "intentional deception" | "topic" | "/r/has a" |  | "FN" |  |
| fn:intentional_deception | /r/HasA | fn:fe:means | "intentional deception" | "means" | "/r/has a" |  | "FN" |  |
| fn:intentional_deception | /r/HasA | fn:fe:time | "intentional deception" | "time" | "/r/has a" |  | "FN" |  |
| fn:intentional_deception | /r/HasA | fn:fe:place | "intentional deception" | "place" | "/r/has a" |  | "FN" |  |
| fn:intentional_traversing | /r/IsA | fn:self_motion | "intentional traversing" | "self motion" | "/r/is a" |  | "FN" |  |
| fn:intentional_traversing | /r/IsA | fn:traversing | "intentional traversing" | "traversing" | "/r/is a" |  | "FN" |  |
| fn:intentional_traversing | /r/HasSubevent | fn:quitting_a_place | "intentional traversing" | "quitting a place" | "/r/has subevent" |  | "FN" |  |
| fn:traversing | /r/SimilarTo | fn:intentional_traversing | "traversing" | "intentional traversing" | "/r/similar to" |  | "FN" |  |
| fn:intentional_traversing | fn:HasLexicalUnit | fn:lu:intentional_traversing:ford | "intentional traversing" | "ford" | "has lexical unit" |  | "FN" |  |
| fn:intentional_traversing | fn:HasLexicalUnit | fn:lu:intentional_traversing:cut | "intentional traversing" | "cut" | "has lexical unit" |  | "FN" |  |
| fn:intentional_traversing | fn:HasLexicalUnit | fn:lu:intentional_traversing:climb | "intentional traversing" | "climb" | "has lexical unit" |  | "FN" |  |
| fn:intentional_traversing | fn:HasLexicalUnit | fn:lu:intentional_traversing:ascend | "intentional traversing" | "ascend" | "has lexical unit" |  | "FN" |  |
| fn:intentional_traversing | /r/HasA | fn:fe:self_mover | "intentional traversing" | "self mover" | "/r/has a" |  | "FN" |  |
| fn:fe:source | /r/RelatedTo | fn:fe:place | "source" | "place" | "/r/related to" |  | "FN" |  |
| fn:intentional_traversing | /r/HasA | fn:fe:source | "intentional traversing" | "source" | "/r/has a" |  | "FN" |  |
| fn:fe:path | /r/RelatedTo | fn:fe:place | "path" | "place" | "/r/related to" |  | "FN" |  |
| fn:intentional_traversing | /r/HasA | fn:fe:path | "intentional traversing" | "path" | "/r/has a" |  | "FN" |  |
| fn:fe:goal | /r/RelatedTo | fn:fe:place | "goal" | "place" | "/r/related to" |  | "FN" |  |
| fn:intentional_traversing | /r/HasA | fn:fe:goal | "intentional traversing" | "goal" | "/r/has a" |  | "FN" |  |
| fn:intentional_traversing | /r/HasA | fn:fe:manner | "intentional traversing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:intentional_traversing | /r/HasA | fn:fe:distance | "intentional traversing" | "distance" | "/r/has a" |  | "FN" |  |
| fn:intentional_traversing | /r/HasA | fn:fe:means | "intentional traversing" | "means" | "/r/has a" |  | "FN" |  |
| fn:intentional_traversing | /r/HasA | fn:fe:speed | "intentional traversing" | "speed" | "/r/has a" |  | "FN" |  |
| fn:intentional_traversing | /r/HasA | fn:fe:cotheme | "intentional traversing" | "cotheme" | "/r/has a" |  | "FN" |  |
| fn:intentional_traversing | /r/HasA | fn:fe:depictive | "intentional traversing" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:intentional_traversing | /r/HasA | fn:fe:place | "intentional traversing" | "place" | "/r/has a" |  | "FN" |  |
| fn:intentional_traversing | /r/HasA | fn:fe:path_shape | "intentional traversing" | "path shape" | "/r/has a" |  | "FN" |  |
| fn:intentional_traversing | /r/HasA | fn:fe:direction | "intentional traversing" | "direction" | "/r/has a" |  | "FN" |  |
| fn:intentional_traversing | /r/HasA | fn:fe:time | "intentional traversing" | "time" | "/r/has a" |  | "FN" |  |
| fn:intentional_traversing | /r/HasA | fn:fe:purpose | "intentional traversing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:intentional_traversing | /r/HasA | fn:fe:means_of_motion | "intentional traversing" | "means of motion" | "/r/has a" |  | "FN" |  |
| fn:intentional_traversing | /r/HasA | fn:fe:duration | "intentional traversing" | "duration" | "/r/has a" |  | "FN" |  |
| fn:intentional_traversing | /r/HasA | fn:fe:explanation | "intentional traversing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:intentional_traversing | /r/HasA | fn:fe:containing_event | "intentional traversing" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:intentional_traversing | /r/HasA | fn:fe:frequency | "intentional traversing" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:intentional_traversing | /r/HasA | fn:fe:re-encoding | "intentional traversing" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:intentional_traversing | /r/HasA | fn:fe:new_situation | "intentional traversing" | "new situation" | "/r/has a" |  | "FN" |  |
| fn:intentional_traversing | /r/HasA | fn:fe:circumstances | "intentional traversing" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:intentional_traversing | /r/HasA | fn:fe:endpoints | "intentional traversing" | "endpoints" | "/r/has a" |  | "FN" |  |
| fn:intentional_traversing | /r/HasA | fn:fe:co-participant | "intentional traversing" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:intentionally_act | /r/IsA | fn:event | "intentionally act" | "event" | "/r/is a" |  | "FN" |  |
| fn:activity_finish | /r/IsA | fn:intentionally_act | "activity finish" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:assemble | /r/IsA | fn:intentionally_act | "assemble" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:assistance | /r/IsA | fn:intentionally_act | "assistance" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:atonement | /r/IsA | fn:intentionally_act | "atonement" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:attempt | /r/IsA | fn:intentionally_act | "attempt" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:attempting_and_resolving_scenario | /r/IsA | fn:intentionally_act | "attempting and resolving scenario" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:attending | /r/IsA | fn:intentionally_act | "attending" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:avoiding | /r/IsA | fn:intentionally_act | "avoiding" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:bail_decision | /r/IsA | fn:intentionally_act | "bail decision" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:becoming_a_member | /r/IsA | fn:intentionally_act | "becoming a member" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:change_posture | /r/IsA | fn:intentionally_act | "change posture" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:change_tool | /r/IsA | fn:intentionally_act | "change tool" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:choosing | /r/IsA | fn:intentionally_act | "choosing" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:clemency | /r/IsA | fn:intentionally_act | "clemency" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:collaboration | /r/IsA | fn:intentionally_act | "collaboration" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:confronting_problem | /r/IsA | fn:intentionally_act | "confronting problem" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:contacting | /r/IsA | fn:intentionally_act | "contacting" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:daring | /r/IsA | fn:intentionally_act | "daring" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:examination | /r/IsA | fn:intentionally_act | "examination" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:exchange | /r/IsA | fn:intentionally_act | "exchange" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:execute_plan | /r/IsA | fn:intentionally_act | "execute plan" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:exercising | /r/IsA | fn:intentionally_act | "exercising" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:forming_relationships | /r/IsA | fn:intentionally_act | "forming relationships" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:front_for | /r/IsA | fn:intentionally_act | "front for" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:get_a_job | /r/IsA | fn:intentionally_act | "get a job" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:giving | /r/IsA | fn:intentionally_act | "giving" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:heralding | /r/IsA | fn:intentionally_act | "heralding" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:hostile_encounter | /r/IsA | fn:intentionally_act | "hostile encounter" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:ingest_substance | /r/IsA | fn:intentionally_act | "ingest substance" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:intentionally_affect | /r/IsA | fn:intentionally_act | "intentionally affect" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:intentionally_create | /r/IsA | fn:intentionally_act | "intentionally create" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:intercepting | /r/IsA | fn:intentionally_act | "intercepting" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:legal_rulings | /r/IsA | fn:intentionally_act | "legal rulings" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:manipulation | /r/IsA | fn:intentionally_act | "manipulation" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:military_operation | /r/IsA | fn:intentionally_act | "military operation" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:name_conferral | /r/IsA | fn:intentionally_act | "name conferral" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:passing_off | /r/IsA | fn:intentionally_act | "passing off" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:perception_active | /r/IsA | fn:intentionally_act | "perception active" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:piracy | /r/IsA | fn:intentionally_act | "piracy" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:practice | /r/IsA | fn:intentionally_act | "practice" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:quitting | /r/IsA | fn:intentionally_act | "quitting" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:resolve_problem | /r/IsA | fn:intentionally_act | "resolve problem" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:self_motion | /r/IsA | fn:intentionally_act | "self motion" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:visiting | /r/IsA | fn:intentionally_act | "visiting" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:working_a_post | /r/IsA | fn:intentionally_act | "working a post" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:intentionally_act | /r/UsedFor | fn:accomplishment | "intentionally act" | "accomplishment" | "/r/used for" |  | "FN" |  |
| fn:intentionally_act | /r/UsedFor | fn:assistance | "intentionally act" | "assistance" | "/r/used for" |  | "FN" |  |
| fn:intentionally_act | /r/UsedFor | fn:bungling | "intentionally act" | "bungling" | "/r/used for" |  | "FN" |  |
| fn:intentionally_act | /r/UsedFor | fn:competition | "intentionally act" | "competition" | "/r/used for" |  | "FN" |  |
| fn:intentionally_act | /r/UsedFor | fn:conduct | "intentionally act" | "conduct" | "/r/used for" |  | "FN" |  |
| fn:intentionally_act | /r/UsedFor | fn:deciding | "intentionally act" | "deciding" | "/r/used for" |  | "FN" |  |
| fn:intentionally_act | /r/UsedFor | fn:experience_bodily_harm | "intentionally act" | "experience bodily harm" | "/r/used for" |  | "FN" |  |
| fn:intentionally_act | /r/UsedFor | fn:reason | "intentionally act" | "reason" | "/r/used for" |  | "FN" |  |
| fn:intentionally_act | /r/UsedFor | fn:remembering_to_do | "intentionally act" | "remembering to do" | "/r/used for" |  | "FN" |  |
| fn:intentionally_act | /r/UsedFor | fn:responsibility | "intentionally act" | "responsibility" | "/r/used for" |  | "FN" |  |
| fn:intentionally_act | /r/UsedFor | fn:rite | "intentionally act" | "rite" | "/r/used for" |  | "FN" |  |
| fn:intentionally_act | /r/UsedFor | fn:subjective_influence | "intentionally act" | "subjective influence" | "/r/used for" |  | "FN" |  |
| fn:intentionally_act | /r/UsedFor | fn:waiting | "intentionally act" | "waiting" | "/r/used for" |  | "FN" |  |
| fn:intentionally_act | fn:HasLexicalUnit | fn:lu:intentionally_act:action | "intentionally act" | "action" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_act | fn:HasLexicalUnit | fn:lu:intentionally_act:do | "intentionally act" | "do" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_act | fn:HasLexicalUnit | fn:lu:intentionally_act:step | "intentionally act" | "step" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_act | fn:HasLexicalUnit | fn:lu:intentionally_act:act | "intentionally act" | "act" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_act | fn:HasLexicalUnit | fn:lu:intentionally_act:doing | "intentionally act" | "doing" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_act | fn:HasLexicalUnit | fn:lu:intentionally_act:activity | "intentionally act" | "activity" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_act | fn:HasLexicalUnit | fn:lu:intentionally_act:perform | "intentionally act" | "perform" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_act | fn:HasLexicalUnit | fn:lu:intentionally_act:carry_out | "intentionally act" | "carry out" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_act | fn:HasLexicalUnit | fn:lu:intentionally_act:conduct | "intentionally act" | "conduct" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_act | fn:HasLexicalUnit | fn:lu:intentionally_act:execute | "intentionally act" | "execute" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_act | fn:HasLexicalUnit | fn:lu:intentionally_act:engage | "intentionally act" | "engage" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_act | fn:HasLexicalUnit | fn:lu:intentionally_act:measures | "intentionally act" | "measures" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_act | fn:HasLexicalUnit | fn:lu:intentionally_act:act | "intentionally act" | "act" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_act | fn:HasLexicalUnit | fn:lu:intentionally_act:move | "intentionally act" | "move" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_act | fn:HasLexicalUnit | fn:lu:intentionally_act:actor | "intentionally act" | "actor" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_act | fn:HasLexicalUnit | fn:lu:intentionally_act:agent | "intentionally act" | "agent" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_act | fn:HasLexicalUnit | fn:lu:intentionally_act:deed | "intentionally act" | "deed" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_act | /r/HasA | fn:fe:act | "intentionally act" | "act" | "/r/has a" |  | "FN" |  |
| fn:intentionally_act | /r/HasA | fn:fe:agent | "intentionally act" | "agent" | "/r/has a" |  | "FN" |  |
| fn:intentionally_act | /r/HasA | fn:fe:place | "intentionally act" | "place" | "/r/has a" |  | "FN" |  |
| fn:intentionally_act | /r/HasA | fn:fe:purpose | "intentionally act" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:intentionally_act | /r/HasA | fn:fe:time | "intentionally act" | "time" | "/r/has a" |  | "FN" |  |
| fn:intentionally_act | /r/HasA | fn:fe:means | "intentionally act" | "means" | "/r/has a" |  | "FN" |  |
| fn:intentionally_act | /r/HasA | fn:fe:manner | "intentionally act" | "manner" | "/r/has a" |  | "FN" |  |
| fn:intentionally_act | /r/HasA | fn:fe:domain | "intentionally act" | "domain" | "/r/has a" |  | "FN" |  |
| fn:intentionally_act | /r/HasA | fn:fe:frequency | "intentionally act" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:intentionally_act | /r/HasA | fn:fe:period_of_iterations | "intentionally act" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:intentionally_act | /r/HasA | fn:fe:result | "intentionally act" | "result" | "/r/has a" |  | "FN" |  |
| fn:intentionally_act | /r/HasA | fn:fe:particular_iteration | "intentionally act" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:intentionally_act | /r/HasA | fn:fe:explanation | "intentionally act" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:intentionally_act | /r/HasA | fn:fe:event_description | "intentionally act" | "event description" | "/r/has a" |  | "FN" |  |
| fn:intentionally_act | /r/HasA | fn:fe:apparent_conclusion | "intentionally act" | "apparent conclusion" | "/r/has a" |  | "FN" |  |
| fn:intentionally_affect | /r/IsA | fn:intentionally_act | "intentionally affect" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:abandonment | /r/IsA | fn:intentionally_affect | "abandonment" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:adjusting | /r/IsA | fn:intentionally_affect | "adjusting" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:apply_heat | /r/IsA | fn:intentionally_affect | "apply heat" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:appointing | /r/IsA | fn:intentionally_affect | "appointing" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:arranging | /r/IsA | fn:intentionally_affect | "arranging" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:arrest | /r/IsA | fn:intentionally_affect | "arrest" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:attaching | /r/IsA | fn:intentionally_affect | "attaching" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:attack | /r/IsA | fn:intentionally_affect | "attack" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:breaking_out_captive | /r/IsA | fn:intentionally_affect | "breaking out captive" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:cause_emotion | /r/IsA | fn:intentionally_affect | "cause emotion" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:cause_to_amalgamate | /r/IsA | fn:intentionally_affect | "cause to amalgamate" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:cause_to_experience | /r/IsA | fn:intentionally_affect | "cause to experience" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:cause_to_make_progress | /r/IsA | fn:intentionally_affect | "cause to make progress" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:cause_to_perceive | /r/IsA | fn:intentionally_affect | "cause to perceive" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:change_accessibility | /r/IsA | fn:intentionally_affect | "change accessibility" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:change_operational_state | /r/IsA | fn:intentionally_affect | "change operational state" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:closure | /r/IsA | fn:intentionally_affect | "closure" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:cutting | /r/IsA | fn:intentionally_affect | "cutting" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:detaching | /r/IsA | fn:intentionally_affect | "detaching" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:education_teaching | /r/IsA | fn:intentionally_affect | "education teaching" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:extradition | /r/IsA | fn:intentionally_affect | "extradition" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:firing | /r/IsA | fn:intentionally_affect | "firing" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:gathering_up | /r/IsA | fn:intentionally_affect | "gathering up" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:grooming | /r/IsA | fn:intentionally_affect | "grooming" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:hiding_objects | /r/IsA | fn:intentionally_affect | "hiding objects" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:hiring | /r/IsA | fn:intentionally_affect | "hiring" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:hit_target | /r/IsA | fn:intentionally_affect | "hit target" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:immobilization | /r/IsA | fn:intentionally_affect | "immobilization" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:inhibit_movement | /r/IsA | fn:intentionally_affect | "inhibit movement" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:limiting | /r/IsA | fn:intentionally_affect | "limiting" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:making_arrangements | /r/IsA | fn:intentionally_affect | "making arrangements" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:manipulate_into_doing | /r/IsA | fn:intentionally_affect | "manipulate into doing" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:manipulate_into_shape | /r/IsA | fn:intentionally_affect | "manipulate into shape" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:processing_materials | /r/IsA | fn:intentionally_affect | "processing materials" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:publishing | /r/IsA | fn:intentionally_affect | "publishing" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:rape | /r/IsA | fn:intentionally_affect | "rape" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:releasing | /r/IsA | fn:intentionally_affect | "releasing" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:reparation | /r/IsA | fn:intentionally_affect | "reparation" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:replacing | /r/IsA | fn:intentionally_affect | "replacing" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:rescuing | /r/IsA | fn:intentionally_affect | "rescuing" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:rewards_and_punishments | /r/IsA | fn:intentionally_affect | "rewards and punishments" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:separating | /r/IsA | fn:intentionally_affect | "separating" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:short_selling | /r/IsA | fn:intentionally_affect | "short selling" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:silencing | /r/IsA | fn:intentionally_affect | "silencing" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:soaking | /r/IsA | fn:intentionally_affect | "soaking" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:taking | /r/IsA | fn:intentionally_affect | "taking" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:using | /r/IsA | fn:intentionally_affect | "using" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:intentionally_affect | /r/IsA | fn:transitive_action | "intentionally affect" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:intentionally_affect | /r/UsedFor | fn:arson | "intentionally affect" | "arson" | "/r/used for" |  | "FN" |  |
| fn:intentionally_affect | /r/UsedFor | fn:bungling | "intentionally affect" | "bungling" | "/r/used for" |  | "FN" |  |
| fn:intentionally_affect | /r/UsedFor | fn:import_export_scenario | "intentionally affect" | "import export scenario" | "/r/used for" |  | "FN" |  |
| fn:intentionally_affect | fn:HasLexicalUnit | fn:lu:intentionally_affect:do | "intentionally affect" | "do" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_affect | fn:HasLexicalUnit | fn:lu:intentionally_affect:do_something_(to/with) | "intentionally affect" | "do something (to/with)" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_affect | fn:HasLexicalUnit | fn:lu:intentionally_affect:do_what_(to/with) | "intentionally affect" | "do what (to/with)" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_affect | /r/HasA | fn:fe:means | "intentionally affect" | "means" | "/r/has a" |  | "FN" |  |
| fn:intentionally_affect | /r/HasA | fn:fe:event | "intentionally affect" | "event" | "/r/has a" |  | "FN" |  |
| fn:intentionally_affect | /r/HasA | fn:fe:agent | "intentionally affect" | "agent" | "/r/has a" |  | "FN" |  |
| fn:intentionally_affect | /r/HasA | fn:fe:instrument | "intentionally affect" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:intentionally_affect | /r/HasA | fn:fe:place | "intentionally affect" | "place" | "/r/has a" |  | "FN" |  |
| fn:intentionally_affect | /r/HasA | fn:fe:purpose | "intentionally affect" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:intentionally_affect | /r/HasA | fn:fe:time | "intentionally affect" | "time" | "/r/has a" |  | "FN" |  |
| fn:intentionally_affect | /r/HasA | fn:fe:patient | "intentionally affect" | "patient" | "/r/has a" |  | "FN" |  |
| fn:intentionally_affect | /r/HasA | fn:fe:manner | "intentionally affect" | "manner" | "/r/has a" |  | "FN" |  |
| fn:intentionally_affect | /r/HasA | fn:fe:explanation | "intentionally affect" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:intentionally_affect | /r/HasA | fn:fe:degree | "intentionally affect" | "degree" | "/r/has a" |  | "FN" |  |
| fn:intentionally_affect | /r/HasA | fn:fe:event_description | "intentionally affect" | "event description" | "/r/has a" |  | "FN" |  |
| fn:intentionally_create | /r/IsA | fn:creating | "intentionally create" | "creating" | "/r/is a" |  | "FN" |  |
| fn:intentionally_create | /r/IsA | fn:intentionally_act | "intentionally create" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:achieving_first | /r/IsA | fn:intentionally_create | "achieving first" | "intentionally create" | "/r/is a" |  | "FN" |  |
| fn:building | /r/IsA | fn:intentionally_create | "building" | "intentionally create" | "/r/is a" |  | "FN" |  |
| fn:cooking_creation | /r/IsA | fn:intentionally_create | "cooking creation" | "intentionally create" | "/r/is a" |  | "FN" |  |
| fn:create_physical_artwork | /r/IsA | fn:intentionally_create | "create physical artwork" | "intentionally create" | "/r/is a" |  | "FN" |  |
| fn:duplication | /r/IsA | fn:intentionally_create | "duplication" | "intentionally create" | "/r/is a" |  | "FN" |  |
| fn:knot_creation | /r/IsA | fn:intentionally_create | "knot creation" | "intentionally create" | "/r/is a" |  | "FN" |  |
| fn:manufacturing | /r/IsA | fn:intentionally_create | "manufacturing" | "intentionally create" | "/r/is a" |  | "FN" |  |
| fn:text_creation | /r/IsA | fn:intentionally_create | "text creation" | "intentionally create" | "/r/is a" |  | "FN" |  |
| fn:translating | /r/IsA | fn:intentionally_create | "translating" | "intentionally create" | "/r/is a" |  | "FN" |  |
| fn:intentionally_create | /r/SimilarTo | fn:creating | "intentionally create" | "creating" | "/r/similar to" |  | "FN" |  |
| fn:intentionally_create | fn:HasLexicalUnit | fn:lu:intentionally_create:make | "intentionally create" | "make" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_create | fn:HasLexicalUnit | fn:lu:intentionally_create:create | "intentionally create" | "create" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_create | fn:HasLexicalUnit | fn:lu:intentionally_create:creation | "intentionally create" | "creation" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_create | fn:HasLexicalUnit | fn:lu:intentionally_create:establish | "intentionally create" | "establish" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_create | fn:HasLexicalUnit | fn:lu:intentionally_create:set_up | "intentionally create" | "set up" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_create | fn:HasLexicalUnit | fn:lu:intentionally_create:generate | "intentionally create" | "generate" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_create | fn:HasLexicalUnit | fn:lu:intentionally_create:establishment | "intentionally create" | "establishment" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_create | fn:HasLexicalUnit | fn:lu:intentionally_create:generation | "intentionally create" | "generation" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_create | fn:HasLexicalUnit | fn:lu:intentionally_create:produce | "intentionally create" | "produce" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_create | fn:HasLexicalUnit | fn:lu:intentionally_create:found | "intentionally create" | "found" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_create | fn:HasLexicalUnit | fn:lu:intentionally_create:production | "intentionally create" | "production" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_create | fn:HasLexicalUnit | fn:lu:intentionally_create:synthesise | "intentionally create" | "synthesise" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_create | fn:HasLexicalUnit | fn:lu:intentionally_create:synthesis | "intentionally create" | "synthesis" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_create | fn:HasLexicalUnit | fn:lu:intentionally_create:develop | "intentionally create" | "develop" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_create | fn:HasLexicalUnit | fn:lu:intentionally_create:development | "intentionally create" | "development" | "has lexical unit" |  | "FN" |  |
| fn:intentionally_create | /r/HasA | fn:fe:creator | "intentionally create" | "creator" | "/r/has a" |  | "FN" |  |
| fn:intentionally_create | /r/HasA | fn:fe:place | "intentionally create" | "place" | "/r/has a" |  | "FN" |  |
| fn:intentionally_create | /r/HasA | fn:fe:time | "intentionally create" | "time" | "/r/has a" |  | "FN" |  |
| fn:intentionally_create | /r/HasA | fn:fe:purpose | "intentionally create" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:intentionally_create | /r/HasA | fn:fe:components | "intentionally create" | "components" | "/r/has a" |  | "FN" |  |
| fn:intentionally_create | /r/HasA | fn:fe:depictive | "intentionally create" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:intentionally_create | /r/HasA | fn:fe:created_entity | "intentionally create" | "created entity" | "/r/has a" |  | "FN" |  |
| fn:intentionally_create | /r/HasA | fn:fe:manner | "intentionally create" | "manner" | "/r/has a" |  | "FN" |  |
| fn:intentionally_create | /r/HasA | fn:fe:means | "intentionally create" | "means" | "/r/has a" |  | "FN" |  |
| fn:intentionally_create | /r/HasA | fn:fe:instrument | "intentionally create" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:intentionally_create | /r/HasA | fn:fe:role | "intentionally create" | "role" | "/r/has a" |  | "FN" |  |
| fn:intentionally_create | /r/HasA | fn:fe:co-participant | "intentionally create" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:intercepting | /r/IsA | fn:intentionally_act | "intercepting" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:intercepting | fn:HasLexicalUnit | fn:lu:intercepting:intercept | "intercepting" | "intercept" | "has lexical unit" |  | "FN" |  |
| fn:intercepting | fn:HasLexicalUnit | fn:lu:intercepting:interception | "intercepting" | "interception" | "has lexical unit" |  | "FN" |  |
| fn:fe:interceptor | /r/IsA | fn:st:sentient | "interceptor" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:intercepting | /r/HasA | fn:fe:interceptor | "intercepting" | "interceptor" | "/r/has a" |  | "FN" |  |
| fn:intercepting | /r/HasA | fn:fe:theme | "intercepting" | "theme" | "/r/has a" |  | "FN" |  |
| fn:intercepting | /r/HasA | fn:fe:place | "intercepting" | "place" | "/r/has a" |  | "FN" |  |
| fn:intercepting | /r/HasA | fn:fe:time | "intercepting" | "time" | "/r/has a" |  | "FN" |  |
| fn:intercepting | /r/HasA | fn:fe:depictive | "intercepting" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:intercepting | /r/HasA | fn:fe:manner | "intercepting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:intercepting | /r/HasA | fn:fe:circumstances | "intercepting" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:intercepting | /r/HasA | fn:fe:purpose | "intercepting" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:intercepting | /r/HasA | fn:fe:means | "intercepting" | "means" | "/r/has a" |  | "FN" |  |
| fn:being_contained_within | /r/IsA | fn:interior_profile_relation | "being contained within" | "interior profile relation" | "/r/is a" |  | "FN" |  |
| fn:interior_profile_relation | /r/IsA | fn:locative_relation | "interior profile relation" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:bounded_region | /r/UsedFor | fn:interior_profile_relation | "bounded region" | "interior profile relation" | "/r/used for" |  | "FN" |  |
| fn:interior_profile_relation | /r/UsedFor | fn:surrounding | "interior profile relation" | "surrounding" | "/r/used for" |  | "FN" |  |
| fn:interior_profile_relation | /r/RelatedTo | fn:within_distance | "interior profile relation" | "within distance" | "/r/related to" |  | "FN" |  |
| fn:locative_relation | /r/SimilarTo | fn:interior_profile_relation | "locative relation" | "interior profile relation" | "/r/similar to" |  | "FN" |  |
| fn:interior_profile_relation | fn:HasLexicalUnit | fn:lu:interior_profile_relation:in | "interior profile relation" | "in" | "has lexical unit" |  | "FN" |  |
| fn:interior_profile_relation | fn:HasLexicalUnit | fn:lu:interior_profile_relation:inside | "interior profile relation" | "inside" | "has lexical unit" |  | "FN" |  |
| fn:interior_profile_relation | fn:HasLexicalUnit | fn:lu:interior_profile_relation:among | "interior profile relation" | "among" | "has lexical unit" |  | "FN" |  |
| fn:interior_profile_relation | fn:HasLexicalUnit | fn:lu:interior_profile_relation:within | "interior profile relation" | "within" | "has lexical unit" |  | "FN" |  |
| fn:interior_profile_relation | fn:HasLexicalUnit | fn:lu:interior_profile_relation:between | "interior profile relation" | "between" | "has lexical unit" |  | "FN" |  |
| fn:interior_profile_relation | fn:HasLexicalUnit | fn:lu:interior_profile_relation:amid | "interior profile relation" | "amid" | "has lexical unit" |  | "FN" |  |
| fn:interior_profile_relation | fn:HasLexicalUnit | fn:lu:interior_profile_relation:in_between | "interior profile relation" | "in between" | "has lexical unit" |  | "FN" |  |
| fn:interior_profile_relation | fn:HasLexicalUnit | fn:lu:interior_profile_relation:in_among | "interior profile relation" | "in among" | "has lexical unit" |  | "FN" |  |
| fn:interior_profile_relation | fn:HasLexicalUnit | fn:lu:interior_profile_relation:outside | "interior profile relation" | "outside" | "has lexical unit" |  | "FN" |  |
| fn:interior_profile_relation | fn:HasLexicalUnit | fn:lu:interior_profile_relation:outside_the_wire | "interior profile relation" | "outside the wire" | "has lexical unit" |  | "FN" |  |
| fn:interior_profile_relation | /r/HasA | fn:fe:figure | "interior profile relation" | "figure" | "/r/has a" |  | "FN" |  |
| fn:interior_profile_relation | /r/HasA | fn:fe:ground | "interior profile relation" | "ground" | "/r/has a" |  | "FN" |  |
| fn:interior_profile_relation | /r/HasA | fn:fe:time | "interior profile relation" | "time" | "/r/has a" |  | "FN" |  |
| fn:interior_profile_relation | /r/HasA | fn:fe:direction | "interior profile relation" | "direction" | "/r/has a" |  | "FN" |  |
| fn:interior_profile_relation | /r/HasA | fn:fe:accessibility | "interior profile relation" | "accessibility" | "/r/has a" |  | "FN" |  |
| fn:interior_profile_relation | /r/HasA | fn:fe:profiled_region | "interior profile relation" | "profiled region" | "/r/has a" |  | "FN" |  |
| fn:interior_profile_relation | /r/HasA | fn:fe:directness | "interior profile relation" | "directness" | "/r/has a" |  | "FN" |  |
| fn:interior_profile_relation | /r/HasA | fn:fe:temporal_profile | "interior profile relation" | "temporal profile" | "/r/has a" |  | "FN" |  |
| fn:interior_profile_relation | /r/HasA | fn:fe:deixis | "interior profile relation" | "deixis" | "/r/has a" |  | "FN" |  |
| fn:interior_profile_relation | /r/HasA | fn:fe:region_quantification | "interior profile relation" | "region quantification" | "/r/has a" |  | "FN" |  |
| fn:interrupt_process | /r/IsA | fn:transitive_action | "interrupt process" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:interrupt_process | /r/Causes | fn:process_pause | "interrupt process" | "process pause" | "/r/causes" |  | "FN" |  |
| fn:interrupt_process | fn:HasLexicalUnit | fn:lu:interrupt_process:uninterrupted | "interrupt process" | "uninterrupted" | "has lexical unit" |  | "FN" |  |
| fn:interrupt_process | fn:HasLexicalUnit | fn:lu:interrupt_process:interrupt | "interrupt process" | "interrupt" | "has lexical unit" |  | "FN" |  |
| fn:interrupt_process | fn:HasLexicalUnit | fn:lu:interrupt_process:interruption | "interrupt process" | "interruption" | "has lexical unit" |  | "FN" |  |
| fn:interrupt_process | /r/HasA | fn:fe:cause | "interrupt process" | "cause" | "/r/has a" |  | "FN" |  |
| fn:interrupt_process | /r/HasA | fn:fe:process | "interrupt process" | "process" | "/r/has a" |  | "FN" |  |
| fn:interrupt_process | /r/HasA | fn:fe:place | "interrupt process" | "place" | "/r/has a" |  | "FN" |  |
| fn:interrupt_process | /r/HasA | fn:fe:time | "interrupt process" | "time" | "/r/has a" |  | "FN" |  |
| fn:fe:actor | /r/RelatedTo | fn:fe:cause | "actor" | "cause" | "/r/related to" |  | "FN" |  |
| fn:interrupt_process | /r/HasA | fn:fe:actor | "interrupt process" | "actor" | "/r/has a" |  | "FN" |  |
| fn:interrupt_process | /r/HasA | fn:fe:circumstances | "interrupt process" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:interrupt_process | /r/HasA | fn:fe:manner | "interrupt process" | "manner" | "/r/has a" |  | "FN" |  |
| fn:interrupt_process | /r/HasA | fn:fe:explanation | "interrupt process" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:interrupt_process | /r/HasA | fn:fe:means | "interrupt process" | "means" | "/r/has a" |  | "FN" |  |
| fn:interrupt_process | /r/HasA | fn:fe:frequency | "interrupt process" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:interrupt_process | /r/HasA | fn:fe:concessive | "interrupt process" | "concessive" | "/r/has a" |  | "FN" |  |
| fn:intoxicants | /r/IsA | fn:physical_entity | "intoxicants" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:intoxicants | /r/UsedFor | fn:intoxication | "intoxicants" | "intoxication" | "/r/used for" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:marijuana | "intoxicants" | "marijuana" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:heroin | "intoxicants" | "heroin" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:cocaine | "intoxicants" | "cocaine" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:opium | "intoxicants" | "opium" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:lsd | "intoxicants" | "lsd" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:mescaline | "intoxicants" | "mescaline" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:ecstasy | "intoxicants" | "ecstasy" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:methamphetamine | "intoxicants" | "methamphetamine" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:cannabis | "intoxicants" | "cannabis" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:amphetamine | "intoxicants" | "amphetamine" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:barbiturate | "intoxicants" | "barbiturate" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:sedative | "intoxicants" | "sedative" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:tranquillizer | "intoxicants" | "tranquillizer" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:dope | "intoxicants" | "dope" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:coke | "intoxicants" | "coke" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:upper | "intoxicants" | "upper" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:downer | "intoxicants" | "downer" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:speed | "intoxicants" | "speed" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:crack | "intoxicants" | "crack" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:freebase | "intoxicants" | "freebase" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:pot | "intoxicants" | "pot" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:acid | "intoxicants" | "acid" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:hallucinogen | "intoxicants" | "hallucinogen" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:tobacco | "intoxicants" | "tobacco" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:nicotine | "intoxicants" | "nicotine" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:alcohol | "intoxicants" | "alcohol" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:ketamine | "intoxicants" | "ketamine" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:morphine | "intoxicants" | "morphine" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:codeine | "intoxicants" | "codeine" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:inhalant | "intoxicants" | "inhalant" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:weed | "intoxicants" | "weed" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:grass | "intoxicants" | "grass" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:hashish | "intoxicants" | "hashish" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:peyote | "intoxicants" | "peyote" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:snuff | "intoxicants" | "snuff" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:drug | "intoxicants" | "drug" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | fn:HasLexicalUnit | fn:lu:intoxicants:cigarette | "intoxicants" | "cigarette" | "has lexical unit" |  | "FN" |  |
| fn:intoxicants | /r/HasA | fn:fe:intoxicant | "intoxicants" | "intoxicant" | "/r/has a" |  | "FN" |  |
| fn:intoxicants | /r/HasA | fn:fe:type | "intoxicants" | "type" | "/r/has a" |  | "FN" |  |
| fn:intoxicants | /r/HasA | fn:fe:descriptor | "intoxicants" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:intoxicants | /r/HasA | fn:fe:country_of_origin | "intoxicants" | "country of origin" | "/r/has a" |  | "FN" |  |
| fn:intoxication | /r/IsA | fn:gradable_attributes | "intoxication" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:intoxicants | /r/UsedFor | fn:intoxication | "intoxicants" | "intoxication" | "/r/used for" |  | "FN" |  |
| fn:intoxication | fn:HasLexicalUnit | fn:lu:intoxication:stoned | "intoxication" | "stoned" | "has lexical unit" |  | "FN" |  |
| fn:intoxication | fn:HasLexicalUnit | fn:lu:intoxication:high | "intoxication" | "high" | "has lexical unit" |  | "FN" |  |
| fn:intoxication | fn:HasLexicalUnit | fn:lu:intoxication:drunk | "intoxication" | "drunk" | "has lexical unit" |  | "FN" |  |
| fn:intoxication | fn:HasLexicalUnit | fn:lu:intoxication:intoxicated | "intoxication" | "intoxicated" | "has lexical unit" |  | "FN" |  |
| fn:intoxication | fn:HasLexicalUnit | fn:lu:intoxication:sober | "intoxication" | "sober" | "has lexical unit" |  | "FN" |  |
| fn:intoxication | fn:HasLexicalUnit | fn:lu:intoxication:pissed | "intoxication" | "pissed" | "has lexical unit" |  | "FN" |  |
| fn:intoxication | fn:HasLexicalUnit | fn:lu:intoxication:tipsy | "intoxication" | "tipsy" | "has lexical unit" |  | "FN" |  |
| fn:intoxication | fn:HasLexicalUnit | fn:lu:intoxication:inebriated | "intoxication" | "inebriated" | "has lexical unit" |  | "FN" |  |
| fn:intoxication | fn:HasLexicalUnit | fn:lu:intoxication:sloshed | "intoxication" | "sloshed" | "has lexical unit" |  | "FN" |  |
| fn:intoxication | fn:HasLexicalUnit | fn:lu:intoxication:trip | "intoxication" | "trip" | "has lexical unit" |  | "FN" |  |
| fn:intoxication | fn:HasLexicalUnit | fn:lu:intoxication:under_the_influence_(of) | "intoxication" | "under the influence (of)" | "has lexical unit" |  | "FN" |  |
| fn:intoxication | fn:HasLexicalUnit | fn:lu:intoxication:blasted | "intoxication" | "blasted" | "has lexical unit" |  | "FN" |  |
| fn:intoxication | fn:HasLexicalUnit | fn:lu:intoxication:blotto | "intoxication" | "blotto" | "has lexical unit" |  | "FN" |  |
| fn:intoxication | fn:HasLexicalUnit | fn:lu:intoxication:wasted | "intoxication" | "wasted" | "has lexical unit" |  | "FN" |  |
| fn:intoxication | /r/HasA | fn:fe:cognizer | "intoxication" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:intoxication | /r/HasA | fn:fe:intoxicant | "intoxication" | "intoxicant" | "/r/has a" |  | "FN" |  |
| fn:intoxication | /r/HasA | fn:fe:degree | "intoxication" | "degree" | "/r/has a" |  | "FN" |  |
| fn:intoxication | /r/HasA | fn:fe:evaluation | "intoxication" | "evaluation" | "/r/has a" |  | "FN" |  |
| fn:intoxication | /r/HasA | fn:fe:duration | "intoxication" | "duration" | "/r/has a" |  | "FN" |  |
| fn:intoxication | /r/HasA | fn:fe:manner | "intoxication" | "manner" | "/r/has a" |  | "FN" |  |
| fn:intoxication | /r/HasA | fn:fe:time | "intoxication" | "time" | "/r/has a" |  | "FN" |  |
| fn:invading | /r/IsA | fn:attack | "invading" | "attack" | "/r/is a" |  | "FN" |  |
| fn:invasion_scenario | /r/HasSubevent | fn:invading | "invasion scenario" | "invading" | "/r/has subevent" |  | "FN" |  |
| fn:attack | /r/SimilarTo | fn:invading | "attack" | "invading" | "/r/similar to" |  | "FN" |  |
| fn:conquering | /r/HasPrerequisite | fn:invading | "conquering" | "invading" | "/r/has prerequisite" |  | "FN" |  |
| fn:repel | /r/HasPrerequisite | fn:invading | "repel" | "invading" | "/r/has prerequisite" |  | "FN" |  |
| fn:invading | fn:HasLexicalUnit | fn:lu:invading:invade | "invading" | "invade" | "has lexical unit" |  | "FN" |  |
| fn:invading | fn:HasLexicalUnit | fn:lu:invading:invasion | "invading" | "invasion" | "has lexical unit" |  | "FN" |  |
| fn:invading | fn:HasLexicalUnit | fn:lu:invading:overrun | "invading" | "overrun" | "has lexical unit" |  | "FN" |  |
| fn:invading | fn:HasLexicalUnit | fn:lu:invading:invader | "invading" | "invader" | "has lexical unit" |  | "FN" |  |
| fn:invading | /r/HasA | fn:fe:land | "invading" | "land" | "/r/has a" |  | "FN" |  |
| fn:invading | /r/HasA | fn:fe:weapon | "invading" | "weapon" | "/r/has a" |  | "FN" |  |
| fn:fe:invader | /r/IsA | fn:st:sentient | "invader" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:invading | /r/HasA | fn:fe:invader | "invading" | "invader" | "/r/has a" |  | "FN" |  |
| fn:invading | /r/HasA | fn:fe:manner | "invading" | "manner" | "/r/has a" |  | "FN" |  |
| fn:invading | /r/HasA | fn:fe:means | "invading" | "means" | "/r/has a" |  | "FN" |  |
| fn:invading | /r/HasA | fn:fe:place | "invading" | "place" | "/r/has a" |  | "FN" |  |
| fn:invading | /r/HasA | fn:fe:purpose | "invading" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:invading | /r/HasA | fn:fe:explanation | "invading" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:invading | /r/HasA | fn:fe:time | "invading" | "time" | "/r/has a" |  | "FN" |  |
| fn:invading | /r/HasA | fn:fe:source | "invading" | "source" | "/r/has a" |  | "FN" |  |
| fn:invading | /r/HasA | fn:fe:depictive | "invading" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:invading | /r/HasA | fn:fe:re-encoding | "invading" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:invading | /r/HasA | fn:fe:result | "invading" | "result" | "/r/has a" |  | "FN" |  |
| fn:invading | /r/HasA | fn:fe:containing_event | "invading" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:invading | /r/HasA | fn:fe:particular_iteration | "invading" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:invading | /r/HasA | fn:fe:circumstances | "invading" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:invading | /r/HasA | fn:fe:iterations | "invading" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:invading | /r/HasA | fn:fe:event_description | "invading" | "event description" | "/r/has a" |  | "FN" |  |
| fn:invading | /r/HasA | fn:fe:path | "invading" | "path" | "/r/has a" |  | "FN" |  |
| fn:invading | /r/HasA | fn:fe:frequency | "invading" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:invading | /r/HasA | fn:fe:type | "invading" | "type" | "/r/has a" |  | "FN" |  |
| fn:invading | /r/HasA | fn:fe:degree | "invading" | "degree" | "/r/has a" |  | "FN" |  |
| fn:invading | /r/HasA | fn:fe:period_of_iterations | "invading" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:invading | /r/HasA | fn:fe:duration | "invading" | "duration" | "/r/has a" |  | "FN" |  |
| fn:invasion_scenario | /r/HasSubevent | fn:conquering | "invasion scenario" | "conquering" | "/r/has subevent" |  | "FN" |  |
| fn:invasion_scenario | /r/HasSubevent | fn:invading | "invasion scenario" | "invading" | "/r/has subevent" |  | "FN" |  |
| fn:invasion_scenario | /r/HasSubevent | fn:repel | "invasion scenario" | "repel" | "/r/has subevent" |  | "FN" |  |
| fn:invasion_scenario | /r/HasA | fn:fe:invader | "invasion scenario" | "invader" | "/r/has a" |  | "FN" |  |
| fn:invasion_scenario | /r/HasA | fn:fe:attacked | "invasion scenario" | "attacked" | "/r/has a" |  | "FN" |  |
| fn:invasion_scenario | /r/HasA | fn:fe:degree | "invasion scenario" | "degree" | "/r/has a" |  | "FN" |  |
| fn:invasion_scenario | /r/HasA | fn:fe:manner | "invasion scenario" | "manner" | "/r/has a" |  | "FN" |  |
| fn:invasion_scenario | /r/HasA | fn:fe:means | "invasion scenario" | "means" | "/r/has a" |  | "FN" |  |
| fn:invasion_scenario | /r/HasA | fn:fe:place | "invasion scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:invasion_scenario | /r/HasA | fn:fe:time | "invasion scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:invasion_scenario | /r/HasA | fn:fe:purpose | "invasion scenario" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:invasion_scenario | /r/HasA | fn:fe:instrument | "invasion scenario" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:irregular_combatants | /r/IsA | fn:people | "irregular combatants" | "people" | "/r/is a" |  | "FN" |  |
| fn:hostile_encounter | /r/UsedFor | fn:irregular_combatants | "hostile encounter" | "irregular combatants" | "/r/used for" |  | "FN" |  |
| fn:irregular_combatants | fn:HasLexicalUnit | fn:lu:irregular_combatants:combatant | "irregular combatants" | "combatant" | "has lexical unit" |  | "FN" |  |
| fn:irregular_combatants | fn:HasLexicalUnit | fn:lu:irregular_combatants:militant | "irregular combatants" | "militant" | "has lexical unit" |  | "FN" |  |
| fn:irregular_combatants | fn:HasLexicalUnit | fn:lu:irregular_combatants:fighter | "irregular combatants" | "fighter" | "has lexical unit" |  | "FN" |  |
| fn:irregular_combatants | fn:HasLexicalUnit | fn:lu:irregular_combatants:belligerent | "irregular combatants" | "belligerent" | "has lexical unit" |  | "FN" |  |
| fn:irregular_combatants | fn:HasLexicalUnit | fn:lu:irregular_combatants:hostile | "irregular combatants" | "hostile" | "has lexical unit" |  | "FN" |  |
| fn:irregular_combatants | fn:HasLexicalUnit | fn:lu:irregular_combatants:guerrilla | "irregular combatants" | "guerrilla" | "has lexical unit" |  | "FN" |  |
| fn:irregular_combatants | /r/HasA | fn:fe:origin | "irregular combatants" | "origin" | "/r/has a" |  | "FN" |  |
| fn:fe:combatant | /r/IsA | fn:st:human | "combatant" | "human" | "/r/is a" |  | "FN" |  |
| fn:irregular_combatants | /r/HasA | fn:fe:combatant | "irregular combatants" | "combatant" | "/r/has a" |  | "FN" |  |
| fn:irregular_combatants | /r/HasA | fn:fe:persistent_characteristic | "irregular combatants" | "persistent characteristic" | "/r/has a" |  | "FN" |  |
| fn:irregular_combatants | /r/HasA | fn:fe:descriptor | "irregular combatants" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:irregular_combatants | /r/HasA | fn:fe:age | "irregular combatants" | "age" | "/r/has a" |  | "FN" |  |
| fn:irregular_combatants | /r/HasA | fn:fe:ethnicity | "irregular combatants" | "ethnicity" | "/r/has a" |  | "FN" |  |
| fn:irregular_combatants | /r/HasA | fn:fe:context_of_acquaintance | "irregular combatants" | "context of acquaintance" | "/r/has a" |  | "FN" |  |
| fn:irregular_combatants | /r/HasA | fn:fe:side_1 | "irregular combatants" | "side 1" | "/r/has a" |  | "FN" |  |
| fn:irregular_combatants | /r/HasA | fn:fe:side_2 | "irregular combatants" | "side 2" | "/r/has a" |  | "FN" |  |
| fn:irregular_combatants | /r/HasA | fn:fe:conflict | "irregular combatants" | "conflict" | "/r/has a" |  | "FN" |  |
| fn:irregular_combatants | /r/HasA | fn:fe:purpose | "irregular combatants" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:irregular_combatants | /r/HasA | fn:fe:group | "irregular combatants" | "group" | "/r/has a" |  | "FN" |  |
| fn:locale | /r/UsedFor | fn:isolated_places | "locale" | "isolated places" | "/r/used for" |  | "FN" |  |
| fn:isolated_places | fn:HasLexicalUnit | fn:lu:isolated_places:boondocks | "isolated places" | "boondocks" | "has lexical unit" |  | "FN" |  |
| fn:isolated_places | fn:HasLexicalUnit | fn:lu:isolated_places:boonies | "isolated places" | "boonies" | "has lexical unit" |  | "FN" |  |
| fn:isolated_places | fn:HasLexicalUnit | fn:lu:isolated_places:backwater | "isolated places" | "backwater" | "has lexical unit" |  | "FN" |  |
| fn:isolated_places | fn:HasLexicalUnit | fn:lu:isolated_places:backwoods | "isolated places" | "backwoods" | "has lexical unit" |  | "FN" |  |
| fn:isolated_places | fn:HasLexicalUnit | fn:lu:isolated_places:middle_of_nowhere | "isolated places" | "middle of nowhere" | "has lexical unit" |  | "FN" |  |
| fn:isolated_places | fn:HasLexicalUnit | fn:lu:isolated_places:back_of_beyond | "isolated places" | "back of beyond" | "has lexical unit" |  | "FN" |  |
| fn:isolated_places | fn:HasLexicalUnit | fn:lu:isolated_places:bumblefuck | "isolated places" | "bumblefuck" | "has lexical unit" |  | "FN" |  |
| fn:isolated_places | fn:HasLexicalUnit | fn:lu:isolated_places:podunk | "isolated places" | "podunk" | "has lexical unit" |  | "FN" |  |
| fn:isolated_places | fn:HasLexicalUnit | fn:lu:isolated_places:godforsaken | "isolated places" | "godforsaken" | "has lexical unit" |  | "FN" |  |
| fn:isolated_places | fn:HasLexicalUnit | fn:lu:isolated_places:out-of-the-way | "isolated places" | "out-of-the-way" | "has lexical unit" |  | "FN" |  |
| fn:isolated_places | fn:HasLexicalUnit | fn:lu:isolated_places:outback | "isolated places" | "outback" | "has lexical unit" |  | "FN" |  |
| fn:isolated_places | fn:HasLexicalUnit | fn:lu:isolated_places:backcountry | "isolated places" | "backcountry" | "has lexical unit" |  | "FN" |  |
| fn:isolated_places | fn:HasLexicalUnit | fn:lu:isolated_places:fly-over_country | "isolated places" | "fly-over country" | "has lexical unit" |  | "FN" |  |
| fn:isolated_places | fn:HasLexicalUnit | fn:lu:isolated_places:the_sticks | "isolated places" | "the sticks" | "has lexical unit" |  | "FN" |  |
| fn:isolated_places | fn:HasLexicalUnit | fn:lu:isolated_places:off_the_beaten_path | "isolated places" | "off the beaten path" | "has lexical unit" |  | "FN" |  |
| fn:isolated_places | /r/HasA | fn:fe:place | "isolated places" | "place" | "/r/has a" |  | "FN" |  |
| fn:isolated_places | /r/HasA | fn:fe:relative_location | "isolated places" | "relative location" | "/r/has a" |  | "FN" |  |
| fn:emotions | /r/UsedFor | fn:judgment | "emotions" | "judgment" | "/r/used for" |  | "FN" |  |
| fn:judgment | /r/UsedFor | fn:exemplar | "judgment" | "exemplar" | "/r/used for" |  | "FN" |  |
| fn:judgment | /r/UsedFor | fn:judgment_communication | "judgment" | "judgment communication" | "/r/used for" |  | "FN" |  |
| fn:judgment | /r/UsedFor | fn:praiseworthiness | "judgment" | "praiseworthiness" | "/r/used for" |  | "FN" |  |
| fn:judgment | /r/UsedFor | fn:regard | "judgment" | "regard" | "/r/used for" |  | "FN" |  |
| fn:judgment | /r/RelatedTo | fn:judgment_communication | "judgment" | "judgment communication" | "/r/related to" |  | "FN" |  |
| fn:judgment | /r/SimilarTo | fn:judgment_communication | "judgment" | "judgment communication" | "/r/similar to" |  | "FN" |  |
| fn:judgment_communication | /r/SimilarTo | fn:judgment | "judgment communication" | "judgment" | "/r/similar to" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:admiration | "judgment" | "admiration" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:admire | "judgment" | "admire" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:admiring | "judgment" | "admiring" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:applaud | "judgment" | "applaud" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:appreciate | "judgment" | "appreciate" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:appreciation | "judgment" | "appreciation" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:approbation | "judgment" | "approbation" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:approving | "judgment" | "approving" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:blame | "judgment" | "blame" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:blame | "judgment" | "blame" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:contempt | "judgment" | "contempt" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:contemptuous | "judgment" | "contemptuous" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:critical | "judgment" | "critical" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:damnation | "judgment" | "damnation" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:deplore | "judgment" | "deplore" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:derisive | "judgment" | "derisive" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:disapproval | "judgment" | "disapproval" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:disapprove | "judgment" | "disapprove" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:disapproving | "judgment" | "disapproving" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:disdain | "judgment" | "disdain" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:disdain | "judgment" | "disdain" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:disdainful | "judgment" | "disdainful" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:disrespect | "judgment" | "disrespect" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:esteem | "judgment" | "esteem" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:esteem | "judgment" | "esteem" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:fault | "judgment" | "fault" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:fault | "judgment" | "fault" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:mock | "judgment" | "mock" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:reproachful | "judgment" | "reproachful" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:scorn | "judgment" | "scorn" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:scorn | "judgment" | "scorn" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:scornful | "judgment" | "scornful" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:stigma | "judgment" | "stigma" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:stigmatize | "judgment" | "stigmatize" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:stricture | "judgment" | "stricture" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:uncritical | "judgment" | "uncritical" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:exalt | "judgment" | "exalt" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:prize | "judgment" | "prize" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:boo | "judgment" | "boo" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:revere | "judgment" | "revere" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:reverence | "judgment" | "reverence" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:mockery | "judgment" | "mockery" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:exaltation | "judgment" | "exaltation" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:accolade | "judgment" | "accolade" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:vilification | "judgment" | "vilification" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:value | "judgment" | "value" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:respect | "judgment" | "respect" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:respect | "judgment" | "respect" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:deify | "judgment" | "deify" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:reproach | "judgment" | "reproach" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:reprehensible | "judgment" | "reprehensible" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:appreciative | "judgment" | "appreciative" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:set_store | "judgment" | "set store" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:accuse | "judgment" | "accuse" | "has lexical unit" |  | "FN" |  |
| fn:judgment | fn:HasLexicalUnit | fn:lu:judgment:approve | "judgment" | "approve" | "has lexical unit" |  | "FN" |  |
| fn:judgment | /r/HasA | fn:fe:cognizer | "judgment" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:judgment | /r/HasA | fn:fe:evaluee | "judgment" | "evaluee" | "/r/has a" |  | "FN" |  |
| fn:judgment | /r/HasA | fn:fe:reason | "judgment" | "reason" | "/r/has a" |  | "FN" |  |
| fn:judgment | /r/HasA | fn:fe:role | "judgment" | "role" | "/r/has a" |  | "FN" |  |
| fn:judgment | /r/HasA | fn:fe:expressor | "judgment" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:judgment | /r/HasA | fn:fe:degree | "judgment" | "degree" | "/r/has a" |  | "FN" |  |
| fn:judgment | /r/HasA | fn:fe:depictive | "judgment" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:judgment | /r/HasA | fn:fe:manner | "judgment" | "manner" | "/r/has a" |  | "FN" |  |
| fn:judgment | /r/HasA | fn:fe:means | "judgment" | "means" | "/r/has a" |  | "FN" |  |
| fn:judgment | /r/HasA | fn:fe:topic | "judgment" | "topic" | "/r/has a" |  | "FN" |  |
| fn:judgment | /r/HasA | fn:fe:extent_of_acclaim | "judgment" | "extent of acclaim" | "/r/has a" |  | "FN" |  |
| fn:judgment | /r/HasA | fn:fe:result | "judgment" | "result" | "/r/has a" |  | "FN" |  |
| fn:bragging | /r/IsA | fn:judgment_communication | "bragging" | "judgment communication" | "/r/is a" |  | "FN" |  |
| fn:judgment_direct_address | /r/IsA | fn:judgment_communication | "judgment direct address" | "judgment communication" | "/r/is a" |  | "FN" |  |
| fn:judgment | /r/UsedFor | fn:judgment_communication | "judgment" | "judgment communication" | "/r/used for" |  | "FN" |  |
| fn:judgment_communication | /r/UsedFor | fn:labeling | "judgment communication" | "labeling" | "/r/used for" |  | "FN" |  |
| fn:statement | /r/UsedFor | fn:judgment_communication | "statement" | "judgment communication" | "/r/used for" |  | "FN" |  |
| fn:judgment | /r/RelatedTo | fn:judgment_communication | "judgment" | "judgment communication" | "/r/related to" |  | "FN" |  |
| fn:judgment | /r/SimilarTo | fn:judgment_communication | "judgment" | "judgment communication" | "/r/similar to" |  | "FN" |  |
| fn:judgment_communication | /r/SimilarTo | fn:judgment | "judgment communication" | "judgment" | "/r/similar to" |  | "FN" |  |
| fn:judgment_communication | /r/SimilarTo | fn:judgment_direct_address | "judgment communication" | "judgment direct address" | "/r/similar to" |  | "FN" |  |
| fn:judgment_direct_address | /r/SimilarTo | fn:judgment_communication | "judgment direct address" | "judgment communication" | "/r/similar to" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:gibe | "judgment communication" | "gibe" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:excoriate | "judgment communication" | "excoriate" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:excoriation | "judgment communication" | "excoriation" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:denigrative | "judgment communication" | "denigrative" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:denunciatory | "judgment communication" | "denunciatory" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:denunciative | "judgment communication" | "denunciative" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:kudos | "judgment communication" | "kudos" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:deprecatory | "judgment communication" | "deprecatory" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:deprecation | "judgment communication" | "deprecation" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:deprecative | "judgment communication" | "deprecative" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:execrate | "judgment communication" | "execrate" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:execration | "judgment communication" | "execration" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:execrative | "judgment communication" | "execrative" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:laudable | "judgment communication" | "laudable" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:laudatory | "judgment communication" | "laudatory" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:commendable | "judgment communication" | "commendable" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:commendatory | "judgment communication" | "commendatory" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:malediction | "judgment communication" | "malediction" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:maledictory | "judgment communication" | "maledictory" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:reprehend | "judgment communication" | "reprehend" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:reprehension | "judgment communication" | "reprehension" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:belittlement | "judgment communication" | "belittlement" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:belittling | "judgment communication" | "belittling" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:recrimination | "judgment communication" | "recrimination" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:recriminate | "judgment communication" | "recriminate" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:critic | "judgment communication" | "critic" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:critique | "judgment communication" | "critique" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:critique | "judgment communication" | "critique" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:harangue | "judgment communication" | "harangue" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:acclaim | "judgment communication" | "acclaim" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:acclaim | "judgment communication" | "acclaim" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:accusation | "judgment communication" | "accusation" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:accuse | "judgment communication" | "accuse" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:belittle | "judgment communication" | "belittle" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:blast | "judgment communication" | "blast" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:censure | "judgment communication" | "censure" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:censure | "judgment communication" | "censure" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:charge | "judgment communication" | "charge" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:commend | "judgment communication" | "commend" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:commendation | "judgment communication" | "commendation" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:condemn | "judgment communication" | "condemn" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:condemnation | "judgment communication" | "condemnation" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:criticism | "judgment communication" | "criticism" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:criticize | "judgment communication" | "criticize" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:damn | "judgment communication" | "damn" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:decry | "judgment communication" | "decry" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:denigrate | "judgment communication" | "denigrate" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:denigration | "judgment communication" | "denigration" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:denounce | "judgment communication" | "denounce" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:denouncement | "judgment communication" | "denouncement" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:denunciation | "judgment communication" | "denunciation" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:deprecate | "judgment communication" | "deprecate" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:deride | "judgment communication" | "deride" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:derision | "judgment communication" | "derision" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:disparage | "judgment communication" | "disparage" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:disparagement | "judgment communication" | "disparagement" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:disparaging | "judgment communication" | "disparaging" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:extol | "judgment communication" | "extol" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:laud | "judgment communication" | "laud" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:mocking | "judgment communication" | "mocking" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:praise | "judgment communication" | "praise" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:praise | "judgment communication" | "praise" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:remonstrance | "judgment communication" | "remonstrance" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:remonstrate | "judgment communication" | "remonstrate" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:ridicule | "judgment communication" | "ridicule" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:ridicule | "judgment communication" | "ridicule" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:scathing | "judgment communication" | "scathing" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:scoff | "judgment communication" | "scoff" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:mock | "judgment communication" | "mock" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:cite | "judgment communication" | "cite" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:castigate | "judgment communication" | "castigate" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:slam | "judgment communication" | "slam" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:harangue | "judgment communication" | "harangue" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:dump | "judgment communication" | "dump" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:critical | "judgment communication" | "critical" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:blame | "judgment communication" | "blame" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:tout | "judgment communication" | "tout" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:charge | "judgment communication" | "charge" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:pin | "judgment communication" | "pin" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:rave | "judgment communication" | "rave" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:hail | "judgment communication" | "hail" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:rip | "judgment communication" | "rip" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:attack | "judgment communication" | "attack" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | fn:HasLexicalUnit | fn:lu:judgment_communication:attack | "judgment communication" | "attack" | "has lexical unit" |  | "FN" |  |
| fn:judgment_communication | /r/HasA | fn:fe:addressee | "judgment communication" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:judgment_communication | /r/HasA | fn:fe:communicator | "judgment communication" | "communicator" | "/r/has a" |  | "FN" |  |
| fn:judgment_communication | /r/HasA | fn:fe:medium | "judgment communication" | "medium" | "/r/has a" |  | "FN" |  |
| fn:judgment_communication | /r/HasA | fn:fe:topic | "judgment communication" | "topic" | "/r/has a" |  | "FN" |  |
| fn:judgment_communication | /r/HasA | fn:fe:degree | "judgment communication" | "degree" | "/r/has a" |  | "FN" |  |
| fn:judgment_communication | /r/HasA | fn:fe:evaluee | "judgment communication" | "evaluee" | "/r/has a" |  | "FN" |  |
| fn:fe:expressor | /r/RelatedTo | fn:fe:communicator | "expressor" | "communicator" | "/r/related to" |  | "FN" |  |
| fn:judgment_communication | /r/HasA | fn:fe:expressor | "judgment communication" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:judgment_communication | /r/HasA | fn:fe:manner | "judgment communication" | "manner" | "/r/has a" |  | "FN" |  |
| fn:judgment_communication | /r/HasA | fn:fe:means | "judgment communication" | "means" | "/r/has a" |  | "FN" |  |
| fn:judgment_communication | /r/HasA | fn:fe:reason | "judgment communication" | "reason" | "/r/has a" |  | "FN" |  |
| fn:judgment_communication | /r/HasA | fn:fe:role | "judgment communication" | "role" | "/r/has a" |  | "FN" |  |
| fn:judgment_communication | /r/HasA | fn:fe:result | "judgment communication" | "result" | "/r/has a" |  | "FN" |  |
| fn:judgment_communication | /r/HasA | fn:fe:depictive | "judgment communication" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:judgment_communication | /r/HasA | fn:fe:grounds | "judgment communication" | "grounds" | "/r/has a" |  | "FN" |  |
| fn:judgment_communication | /r/HasA | fn:fe:extent_of_acclaim | "judgment communication" | "extent of acclaim" | "/r/has a" |  | "FN" |  |
| fn:judgment_communication | /r/HasA | fn:fe:time | "judgment communication" | "time" | "/r/has a" |  | "FN" |  |
| fn:judgment_communication | /r/HasA | fn:fe:place | "judgment communication" | "place" | "/r/has a" |  | "FN" |  |
| fn:judgment_communication | /r/HasA | fn:fe:internal_cause | "judgment communication" | "internal cause" | "/r/has a" |  | "FN" |  |
| fn:judgment_communication | /r/HasA | fn:fe:frequency | "judgment communication" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:judgment_direct_address | /r/IsA | fn:judgment_communication | "judgment direct address" | "judgment communication" | "/r/is a" |  | "FN" |  |
| fn:judgment_communication | /r/SimilarTo | fn:judgment_direct_address | "judgment communication" | "judgment direct address" | "/r/similar to" |  | "FN" |  |
| fn:judgment_direct_address | /r/SimilarTo | fn:judgment_communication | "judgment direct address" | "judgment communication" | "/r/similar to" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:scold | "judgment direct address" | "scold" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:upbraid | "judgment direct address" | "upbraid" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:thank | "judgment direct address" | "thank" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:thanks | "judgment direct address" | "thanks" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:rebuke | "judgment direct address" | "rebuke" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:rebuke | "judgment direct address" | "rebuke" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:jeer | "judgment direct address" | "jeer" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:jeer | "judgment direct address" | "jeer" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:compliment | "judgment direct address" | "compliment" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:compliment | "judgment direct address" | "compliment" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:chide | "judgment direct address" | "chide" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:chastise | "judgment direct address" | "chastise" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:chastisement | "judgment direct address" | "chastisement" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:castigation | "judgment direct address" | "castigation" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:berate | "judgment direct address" | "berate" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:admonish | "judgment direct address" | "admonish" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:admonishment | "judgment direct address" | "admonishment" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:admonition | "judgment direct address" | "admonition" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:reprimand | "judgment direct address" | "reprimand" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:reprimand | "judgment direct address" | "reprimand" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:castigatory | "judgment direct address" | "castigatory" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:reproach | "judgment direct address" | "reproach" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:harangue | "judgment direct address" | "harangue" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:reprove | "judgment direct address" | "reprove" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:reproof | "judgment direct address" | "reproof" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:take_to_task | "judgment direct address" | "take to task" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:tell_off | "judgment direct address" | "tell off" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:telling_off | "judgment direct address" | "telling off" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:tongue-lashing | "judgment direct address" | "tongue-lashing" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:congratulate | "judgment direct address" | "congratulate" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:talking-to | "judgment direct address" | "talking-to" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | fn:HasLexicalUnit | fn:lu:judgment_direct_address:give_shit | "judgment direct address" | "give shit" | "has lexical unit" |  | "FN" |  |
| fn:judgment_direct_address | /r/HasA | fn:fe:communicator | "judgment direct address" | "communicator" | "/r/has a" |  | "FN" |  |
| fn:judgment_direct_address | /r/HasA | fn:fe:addressee | "judgment direct address" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:judgment_direct_address | /r/HasA | fn:fe:topic | "judgment direct address" | "topic" | "/r/has a" |  | "FN" |  |
| fn:judgment_direct_address | /r/HasA | fn:fe:reason | "judgment direct address" | "reason" | "/r/has a" |  | "FN" |  |
| fn:judgment_direct_address | /r/HasA | fn:fe:medium | "judgment direct address" | "medium" | "/r/has a" |  | "FN" |  |
| fn:judgment_direct_address | /r/HasA | fn:fe:degree | "judgment direct address" | "degree" | "/r/has a" |  | "FN" |  |
| fn:judgment_direct_address | /r/HasA | fn:fe:depictive | "judgment direct address" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:judgment_direct_address | /r/HasA | fn:fe:grounds | "judgment direct address" | "grounds" | "/r/has a" |  | "FN" |  |
| fn:judgment_direct_address | /r/HasA | fn:fe:manner | "judgment direct address" | "manner" | "/r/has a" |  | "FN" |  |
| fn:judgment_direct_address | /r/HasA | fn:fe:means | "judgment direct address" | "means" | "/r/has a" |  | "FN" |  |
| fn:judgment_direct_address | /r/HasA | fn:fe:place | "judgment direct address" | "place" | "/r/has a" |  | "FN" |  |
| fn:judgment_direct_address | /r/HasA | fn:fe:time | "judgment direct address" | "time" | "/r/has a" |  | "FN" |  |
| fn:judgment_direct_address | /r/HasA | fn:fe:role | "judgment direct address" | "role" | "/r/has a" |  | "FN" |  |
| fn:judgment_direct_address | /r/HasA | fn:fe:expressor | "judgment direct address" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:judgment_of_intensity | /r/IsA | fn:gradable_attributes | "judgment of intensity" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:judgment_of_intensity | fn:HasLexicalUnit | fn:lu:judgment_of_intensity:severe | "judgment of intensity" | "severe" | "has lexical unit" |  | "FN" |  |
| fn:judgment_of_intensity | fn:HasLexicalUnit | fn:lu:judgment_of_intensity:strong | "judgment of intensity" | "strong" | "has lexical unit" |  | "FN" |  |
| fn:judgment_of_intensity | fn:HasLexicalUnit | fn:lu:judgment_of_intensity:weak | "judgment of intensity" | "weak" | "has lexical unit" |  | "FN" |  |
| fn:judgment_of_intensity | /r/HasA | fn:fe:entity | "judgment of intensity" | "entity" | "/r/has a" |  | "FN" |  |
| fn:judgment_of_intensity | /r/HasA | fn:fe:attribute | "judgment of intensity" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:judgment_of_intensity | /r/HasA | fn:fe:degree | "judgment of intensity" | "degree" | "/r/has a" |  | "FN" |  |
| fn:judgment_of_intensity | /r/HasA | fn:fe:time | "judgment of intensity" | "time" | "/r/has a" |  | "FN" |  |
| fn:judgment_of_intensity | /r/HasA | fn:fe:circumstances | "judgment of intensity" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:judgment_of_intensity | /r/HasA | fn:fe:place | "judgment of intensity" | "place" | "/r/has a" |  | "FN" |  |
| fn:judicial_body | /r/IsA | fn:institutions | "judicial body" | "institutions" | "/r/is a" |  | "FN" |  |
| fn:judicial_body | fn:HasLexicalUnit | fn:lu:judicial_body:court | "judicial body" | "court" | "has lexical unit" |  | "FN" |  |
| fn:judicial_body | fn:HasLexicalUnit | fn:lu:judicial_body:tribunal | "judicial body" | "tribunal" | "has lexical unit" |  | "FN" |  |
| fn:judicial_body | fn:HasLexicalUnit | fn:lu:judicial_body:judiciary | "judicial body" | "judiciary" | "has lexical unit" |  | "FN" |  |
| fn:judicial_body | fn:HasLexicalUnit | fn:lu:judicial_body:judicial | "judicial body" | "judicial" | "has lexical unit" |  | "FN" |  |
| fn:judicial_body | /r/HasA | fn:fe:judicial_body | "judicial body" | "judicial body" | "/r/has a" |  | "FN" |  |
| fn:judicial_body | /r/HasA | fn:fe:domain | "judicial body" | "domain" | "/r/has a" |  | "FN" |  |
| fn:judicial_body | /r/HasA | fn:fe:task | "judicial body" | "task" | "/r/has a" |  | "FN" |  |
| fn:judicial_body | /r/HasA | fn:fe:rank | "judicial body" | "rank" | "/r/has a" |  | "FN" |  |
| fn:judicial_body | /r/HasA | fn:fe:seat | "judicial body" | "seat" | "/r/has a" |  | "FN" |  |
| fn:judicial_body | /r/HasA | fn:fe:jurisdiction | "judicial body" | "jurisdiction" | "/r/has a" |  | "FN" |  |
| fn:judicial_body | /r/HasA | fn:fe:source_of_authority | "judicial body" | "source of authority" | "/r/has a" |  | "FN" |  |
| fn:judicial_body | /r/HasA | fn:fe:judges | "judicial body" | "judges" | "/r/has a" |  | "FN" |  |
| fn:judicial_body | /r/HasA | fn:fe:place | "judicial body" | "place" | "/r/has a" |  | "FN" |  |
| fn:trial | /r/HasSubevent | fn:jury_deliberation | "trial" | "jury deliberation" | "/r/has subevent" |  | "FN" |  |
| fn:discussion | /r/UsedFor | fn:jury_deliberation | "discussion" | "jury deliberation" | "/r/used for" |  | "FN" |  |
| fn:jury_deliberation | /r/HasPrerequisite | fn:court_examination | "jury deliberation" | "court examination" | "/r/has prerequisite" |  | "FN" |  |
| fn:verdict | /r/HasPrerequisite | fn:jury_deliberation | "verdict" | "jury deliberation" | "/r/has prerequisite" |  | "FN" |  |
| fn:jury_deliberation | fn:HasLexicalUnit | fn:lu:jury_deliberation:deliberation | "jury deliberation" | "deliberation" | "has lexical unit" |  | "FN" |  |
| fn:jury_deliberation | fn:HasLexicalUnit | fn:lu:jury_deliberation:deliberate | "jury deliberation" | "deliberate" | "has lexical unit" |  | "FN" |  |
| fn:jury_deliberation | /r/HasA | fn:fe:jury | "jury deliberation" | "jury" | "/r/has a" |  | "FN" |  |
| fn:jury_deliberation | /r/HasA | fn:fe:duration | "jury deliberation" | "duration" | "/r/has a" |  | "FN" |  |
| fn:jury_deliberation | /r/HasA | fn:fe:charges | "jury deliberation" | "charges" | "/r/has a" |  | "FN" |  |
| fn:jury_deliberation | /r/HasA | fn:fe:case | "jury deliberation" | "case" | "/r/has a" |  | "FN" |  |
| fn:jury_deliberation | /r/HasA | fn:fe:time | "jury deliberation" | "time" | "/r/has a" |  | "FN" |  |
| fn:jury_deliberation | /r/HasA | fn:fe:place | "jury deliberation" | "place" | "/r/has a" |  | "FN" |  |
| fn:jury_deliberation | /r/HasA | fn:fe:possible_sentence | "jury deliberation" | "possible sentence" | "/r/has a" |  | "FN" |  |
| fn:just_found_out | /r/IsA | fn:emotions_by_stimulus | "just found out" | "emotions by stimulus" | "/r/is a" |  | "FN" |  |
| fn:just_found_out | fn:HasLexicalUnit | fn:lu:just_found_out:surprised | "just found out" | "surprised" | "has lexical unit" |  | "FN" |  |
| fn:just_found_out | fn:HasLexicalUnit | fn:lu:just_found_out:shocked | "just found out" | "shocked" | "has lexical unit" |  | "FN" |  |
| fn:just_found_out | fn:HasLexicalUnit | fn:lu:just_found_out:shock | "just found out" | "shock" | "has lexical unit" |  | "FN" |  |
| fn:just_found_out | fn:HasLexicalUnit | fn:lu:just_found_out:surprise | "just found out" | "surprise" | "has lexical unit" |  | "FN" |  |
| fn:just_found_out | /r/HasA | fn:fe:experiencer | "just found out" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:just_found_out | /r/HasA | fn:fe:topic | "just found out" | "topic" | "/r/has a" |  | "FN" |  |
| fn:just_found_out | /r/HasA | fn:fe:stimulus | "just found out" | "stimulus" | "/r/has a" |  | "FN" |  |
| fn:just_found_out | /r/HasA | fn:fe:degree | "just found out" | "degree" | "/r/has a" |  | "FN" |  |
| fn:just_found_out | /r/HasA | fn:fe:empathy_target | "just found out" | "empathy target" | "/r/has a" |  | "FN" |  |
| fn:just_found_out | /r/HasA | fn:fe:expressor | "just found out" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:just_found_out | /r/HasA | fn:fe:explanation | "just found out" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:just_found_out | /r/HasA | fn:fe:circumstances | "just found out" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:just_found_out | /r/HasA | fn:fe:state | "just found out" | "state" | "/r/has a" |  | "FN" |  |
| fn:just_found_out | /r/HasA | fn:fe:parameter | "just found out" | "parameter" | "/r/has a" |  | "FN" |  |
| fn:just_found_out | /r/HasA | fn:fe:manner | "just found out" | "manner" | "/r/has a" |  | "FN" |  |
| fn:just_found_out | /r/HasA | fn:fe:time | "just found out" | "time" | "/r/has a" |  | "FN" |  |
| fn:just_found_out | /r/HasA | fn:fe:type | "just found out" | "type" | "/r/has a" |  | "FN" |  |
| fn:just_found_out | /r/HasA | fn:fe:medium | "just found out" | "medium" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:justifying | "communication" | "justifying" | "/r/used for" |  | "FN" |  |
| fn:justifying | fn:HasLexicalUnit | fn:lu:justifying:justify | "justifying" | "justify" | "has lexical unit" |  | "FN" |  |
| fn:justifying | fn:HasLexicalUnit | fn:lu:justifying:justification | "justifying" | "justification" | "has lexical unit" |  | "FN" |  |
| fn:justifying | fn:HasLexicalUnit | fn:lu:justifying:defend | "justifying" | "defend" | "has lexical unit" |  | "FN" |  |
| fn:justifying | fn:HasLexicalUnit | fn:lu:justifying:account | "justifying" | "account" | "has lexical unit" |  | "FN" |  |
| fn:justifying | fn:HasLexicalUnit | fn:lu:justifying:explain | "justifying" | "explain" | "has lexical unit" |  | "FN" |  |
| fn:justifying | fn:HasLexicalUnit | fn:lu:justifying:rationalize | "justifying" | "rationalize" | "has lexical unit" |  | "FN" |  |
| fn:justifying | /r/HasA | fn:fe:agent | "justifying" | "agent" | "/r/has a" |  | "FN" |  |
| fn:justifying | /r/HasA | fn:fe:explanation | "justifying" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:justifying | /r/HasA | fn:fe:act | "justifying" | "act" | "/r/has a" |  | "FN" |  |
| fn:justifying | /r/HasA | fn:fe:state_of_affairs | "justifying" | "state of affairs" | "/r/has a" |  | "FN" |  |
| fn:justifying | /r/HasA | fn:fe:judge | "justifying" | "judge" | "/r/has a" |  | "FN" |  |
| fn:justifying | /r/HasA | fn:fe:means | "justifying" | "means" | "/r/has a" |  | "FN" |  |
| fn:justifying | /r/HasA | fn:fe:frequency | "justifying" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:justifying | /r/HasA | fn:fe:domain | "justifying" | "domain" | "/r/has a" |  | "FN" |  |
| fn:justifying | /r/HasA | fn:fe:time | "justifying" | "time" | "/r/has a" |  | "FN" |  |
| fn:justifying | /r/HasA | fn:fe:degree | "justifying" | "degree" | "/r/has a" |  | "FN" |  |
| fn:key | /r/IsA | fn:artifact | "key" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:key | fn:HasLexicalUnit | fn:lu:key:key | "key" | "key" | "has lexical unit" |  | "FN" |  |
| fn:key | fn:HasLexicalUnit | fn:lu:key:combination | "key" | "combination" | "has lexical unit" |  | "FN" |  |
| fn:key | fn:HasLexicalUnit | fn:lu:key:password | "key" | "password" | "has lexical unit" |  | "FN" |  |
| fn:key | fn:HasLexicalUnit | fn:lu:key:passcard | "key" | "passcard" | "has lexical unit" |  | "FN" |  |
| fn:key | fn:HasLexicalUnit | fn:lu:key:keycard | "key" | "keycard" | "has lexical unit" |  | "FN" |  |
| fn:key | /r/HasA | fn:fe:key | "key" | "key" | "/r/has a" |  | "FN" |  |
| fn:key | /r/HasA | fn:fe:function | "key" | "function" | "/r/has a" |  | "FN" |  |
| fn:key | /r/HasA | fn:fe:creator | "key" | "creator" | "/r/has a" |  | "FN" |  |
| fn:key | /r/HasA | fn:fe:time_of_creation | "key" | "time of creation" | "/r/has a" |  | "FN" |  |
| fn:key | /r/HasA | fn:fe:name | "key" | "name" | "/r/has a" |  | "FN" |  |
| fn:key | /r/HasA | fn:fe:type | "key" | "type" | "/r/has a" |  | "FN" |  |
| fn:key | /r/HasA | fn:fe:material | "key" | "material" | "/r/has a" |  | "FN" |  |
| fn:key | /r/HasA | fn:fe:location | "key" | "location" | "/r/has a" |  | "FN" |  |
| fn:key | /r/HasA | fn:fe:object | "key" | "object" | "/r/has a" |  | "FN" |  |
| fn:kidnapping | /r/IsA | fn:committing_crime | "kidnapping" | "committing crime" | "/r/is a" |  | "FN" |  |
| fn:being_in_control | /r/UsedFor | fn:kidnapping | "being in control" | "kidnapping" | "/r/used for" |  | "FN" |  |
| fn:removing | /r/SimilarTo | fn:kidnapping | "removing" | "kidnapping" | "/r/similar to" |  | "FN" |  |
| fn:kidnapping | fn:HasLexicalUnit | fn:lu:kidnapping:kidnap | "kidnapping" | "kidnap" | "has lexical unit" |  | "FN" |  |
| fn:kidnapping | fn:HasLexicalUnit | fn:lu:kidnapping:abduct | "kidnapping" | "abduct" | "has lexical unit" |  | "FN" |  |
| fn:kidnapping | fn:HasLexicalUnit | fn:lu:kidnapping:shanghai | "kidnapping" | "shanghai" | "has lexical unit" |  | "FN" |  |
| fn:kidnapping | fn:HasLexicalUnit | fn:lu:kidnapping:nab | "kidnapping" | "nab" | "has lexical unit" |  | "FN" |  |
| fn:kidnapping | fn:HasLexicalUnit | fn:lu:kidnapping:snatch | "kidnapping" | "snatch" | "has lexical unit" |  | "FN" |  |
| fn:kidnapping | fn:HasLexicalUnit | fn:lu:kidnapping:kidnapping | "kidnapping" | "kidnapping" | "has lexical unit" |  | "FN" |  |
| fn:kidnapping | fn:HasLexicalUnit | fn:lu:kidnapping:abduction | "kidnapping" | "abduction" | "has lexical unit" |  | "FN" |  |
| fn:kidnapping | fn:HasLexicalUnit | fn:lu:kidnapping:kidnapper | "kidnapping" | "kidnapper" | "has lexical unit" |  | "FN" |  |
| fn:kidnapping | fn:HasLexicalUnit | fn:lu:kidnapping:abductor | "kidnapping" | "abductor" | "has lexical unit" |  | "FN" |  |
| fn:kidnapping | fn:HasLexicalUnit | fn:lu:kidnapping:snatcher | "kidnapping" | "snatcher" | "has lexical unit" |  | "FN" |  |
| fn:kidnapping | fn:HasLexicalUnit | fn:lu:kidnapping:kidnapped | "kidnapping" | "kidnapped" | "has lexical unit" |  | "FN" |  |
| fn:kidnapping | fn:HasLexicalUnit | fn:lu:kidnapping:abducted | "kidnapping" | "abducted" | "has lexical unit" |  | "FN" |  |
| fn:kidnapping | /r/HasA | fn:fe:perpetrator | "kidnapping" | "perpetrator" | "/r/has a" |  | "FN" |  |
| fn:kidnapping | /r/HasA | fn:fe:victim | "kidnapping" | "victim" | "/r/has a" |  | "FN" |  |
| fn:kidnapping | /r/HasA | fn:fe:place | "kidnapping" | "place" | "/r/has a" |  | "FN" |  |
| fn:kidnapping | /r/HasA | fn:fe:time | "kidnapping" | "time" | "/r/has a" |  | "FN" |  |
| fn:kidnapping | /r/HasA | fn:fe:source | "kidnapping" | "source" | "/r/has a" |  | "FN" |  |
| fn:kidnapping | /r/HasA | fn:fe:goal | "kidnapping" | "goal" | "/r/has a" |  | "FN" |  |
| fn:kidnapping | /r/HasA | fn:fe:degree | "kidnapping" | "degree" | "/r/has a" |  | "FN" |  |
| fn:kidnapping | /r/HasA | fn:fe:manner | "kidnapping" | "manner" | "/r/has a" |  | "FN" |  |
| fn:kidnapping | /r/HasA | fn:fe:means | "kidnapping" | "means" | "/r/has a" |  | "FN" |  |
| fn:kidnapping | /r/HasA | fn:fe:purpose | "kidnapping" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:kidnapping | /r/HasA | fn:fe:explanation | "kidnapping" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:kidnapping | /r/HasA | fn:fe:event | "kidnapping" | "event" | "/r/has a" |  | "FN" |  |
| fn:kidnapping | /r/HasA | fn:fe:co-participant | "kidnapping" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:kidnapping | /r/HasA | fn:fe:duration | "kidnapping" | "duration" | "/r/has a" |  | "FN" |  |
| fn:kidnapping | /r/HasA | fn:fe:frequency | "kidnapping" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:execution | /r/IsA | fn:killing | "execution" | "killing" | "/r/is a" |  | "FN" |  |
| fn:killing | /r/IsA | fn:transitive_action | "killing" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:killing | /r/UsedFor | fn:surviving | "killing" | "surviving" | "/r/used for" |  | "FN" |  |
| fn:killing | /r/SimilarTo | fn:death | "killing" | "death" | "/r/similar to" |  | "FN" |  |
| fn:killing | /r/SimilarTo | fn:execution | "killing" | "execution" | "/r/similar to" |  | "FN" |  |
| fn:killing | /r/Causes | fn:death | "killing" | "death" | "/r/causes" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:kill | "killing" | "kill" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:annihilate | "killing" | "annihilate" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:assassinate | "killing" | "assassinate" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:behead | "killing" | "behead" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:eliminate | "killing" | "eliminate" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:exterminate | "killing" | "exterminate" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:drown | "killing" | "drown" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:liquidate | "killing" | "liquidate" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:murder | "killing" | "murder" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:slay | "killing" | "slay" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:terminate | "killing" | "terminate" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:suffocate | "killing" | "suffocate" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:smother | "killing" | "smother" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:starve | "killing" | "starve" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:asphyxiate | "killing" | "asphyxiate" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:suicide | "killing" | "suicide" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:homicide | "killing" | "homicide" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:suicide | "killing" | "suicide" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:euthanize | "killing" | "euthanize" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:euthanasia | "killing" | "euthanasia" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:dispatch | "killing" | "dispatch" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:lethal | "killing" | "lethal" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:annihilation | "killing" | "annihilation" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:liquidation | "killing" | "liquidation" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:crucify | "killing" | "crucify" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:crucifixion | "killing" | "crucifixion" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:decapitate | "killing" | "decapitate" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:massacre | "killing" | "massacre" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:slaughter | "killing" | "slaughter" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:lynch | "killing" | "lynch" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:liquidator | "killing" | "liquidator" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:killing | "killing" | "killing" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:murder | "killing" | "murder" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:slaughter | "killing" | "slaughter" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:killer | "killing" | "killer" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:massacre | "killing" | "massacre" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:infanticide | "killing" | "infanticide" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:smothering | "killing" | "smothering" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:slaying | "killing" | "slaying" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:regicide | "killing" | "regicide" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:pogrom | "killing" | "pogrom" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:shooting | "killing" | "shooting" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:holocaust | "killing" | "holocaust" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:matricide | "killing" | "matricide" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:genocide | "killing" | "genocide" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:butcher | "killing" | "butcher" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:beheading | "killing" | "beheading" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:assassination | "killing" | "assassination" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:butchery | "killing" | "butchery" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:carnage | "killing" | "carnage" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:suffocation | "killing" | "suffocation" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:assassin | "killing" | "assassin" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:blood-bath | "killing" | "blood-bath" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:decapitation | "killing" | "decapitation" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:extermination | "killing" | "extermination" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:fratricide | "killing" | "fratricide" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:garrotte | "killing" | "garrotte" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:murderer | "killing" | "murderer" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:slaughterer | "killing" | "slaughterer" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:slayer | "killing" | "slayer" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:immolation | "killing" | "immolation" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:patricide | "killing" | "patricide" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:silence | "killing" | "silence" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:deadly | "killing" | "deadly" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:fatal | "killing" | "fatal" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:fatality | "killing" | "fatality" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:destroy | "killing" | "destroy" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:take_out | "killing" | "take out" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:bloodshed | "killing" | "bloodshed" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:do_in | "killing" | "do in" | "has lexical unit" |  | "FN" |  |
| fn:killing | fn:HasLexicalUnit | fn:lu:killing:take_(someone's)_life | "killing" | "take (someone\\'s) life" | "has lexical unit" |  | "FN" |  |
| fn:fe:killer | /r/RelatedTo | fn:fe:cause | "killer" | "cause" | "/r/related to" |  | "FN" |  |
| fn:killing | /r/HasA | fn:fe:killer | "killing" | "killer" | "/r/has a" |  | "FN" |  |
| fn:killing | /r/HasA | fn:fe:victim | "killing" | "victim" | "/r/has a" |  | "FN" |  |
| fn:fe:cause | /r/RelatedTo | fn:fe:killer | "cause" | "killer" | "/r/related to" |  | "FN" |  |
| fn:killing | /r/HasA | fn:fe:cause | "killing" | "cause" | "/r/has a" |  | "FN" |  |
| fn:killing | /r/HasA | fn:fe:purpose | "killing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:killing | /r/HasA | fn:fe:means | "killing" | "means" | "/r/has a" |  | "FN" |  |
| fn:killing | /r/HasA | fn:fe:explanation | "killing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:killing | /r/HasA | fn:fe:place | "killing" | "place" | "/r/has a" |  | "FN" |  |
| fn:killing | /r/HasA | fn:fe:time | "killing" | "time" | "/r/has a" |  | "FN" |  |
| fn:killing | /r/HasA | fn:fe:depictive | "killing" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:killing | /r/HasA | fn:fe:result | "killing" | "result" | "/r/has a" |  | "FN" |  |
| fn:fe:instrument | /r/RelatedTo | fn:fe:cause | "instrument" | "cause" | "/r/related to" |  | "FN" |  |
| fn:killing | /r/HasA | fn:fe:instrument | "killing" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:killing | /r/HasA | fn:fe:manner | "killing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:killing | /r/HasA | fn:fe:degree | "killing" | "degree" | "/r/has a" |  | "FN" |  |
| fn:killing | /r/HasA | fn:fe:beneficiary | "killing" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:killing | /r/HasA | fn:fe:circumstances | "killing" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:killing | /r/HasA | fn:fe:period_of_iterations | "killing" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:killing | /r/HasA | fn:fe:frequency | "killing" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:killing | /r/HasA | fn:fe:containing_event | "killing" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:relation_between_individuals | /r/UsedFor | fn:kinship | "relation between individuals" | "kinship" | "/r/used for" |  | "FN" |  |
| fn:appellations | /r/RelatedTo | fn:kinship | "appellations" | "kinship" | "/r/related to" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:father | "kinship" | "father" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:mother | "kinship" | "mother" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:son | "kinship" | "son" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:daughter | "kinship" | "daughter" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:uncle | "kinship" | "uncle" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:aunt | "kinship" | "aunt" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:auntie | "kinship" | "auntie" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:dad | "kinship" | "dad" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:daddy | "kinship" | "daddy" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:grandson | "kinship" | "grandson" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:granddaughter | "kinship" | "granddaughter" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:niece | "kinship" | "niece" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:nephew | "kinship" | "nephew" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:brother | "kinship" | "brother" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:sister | "kinship" | "sister" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:grandfather | "kinship" | "grandfather" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:grandmother | "kinship" | "grandmother" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:mother-in-law | "kinship" | "mother-in-law" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:father-in-law | "kinship" | "father-in-law" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:son-in-law | "kinship" | "son-in-law" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:daughter-in-law | "kinship" | "daughter-in-law" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:stepson | "kinship" | "stepson" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:stepdaughter | "kinship" | "stepdaughter" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:stepmother | "kinship" | "stepmother" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:stepfather | "kinship" | "stepfather" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:stepbrother | "kinship" | "stepbrother" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:stepsister | "kinship" | "stepsister" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:brother-in-law | "kinship" | "brother-in-law" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:sister-in-law | "kinship" | "sister-in-law" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:cousin | "kinship" | "cousin" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:mom | "kinship" | "mom" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:great-grandson | "kinship" | "great-grandson" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:great-granddaughter | "kinship" | "great-granddaughter" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:parent | "kinship" | "parent" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:child | "kinship" | "child" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:in-law | "kinship" | "in-law" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:family | "kinship" | "family" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:sibling | "kinship" | "sibling" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:ancestor | "kinship" | "ancestor" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:descendant | "kinship" | "descendant" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:forebear | "kinship" | "forebear" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:forefather | "kinship" | "forefather" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:kinsman | "kinship" | "kinsman" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:kinsfolk | "kinship" | "kinsfolk" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:kinswoman | "kinship" | "kinswoman" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:relative | "kinship" | "relative" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:kin | "kinship" | "kin" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:maternal | "kinship" | "maternal" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:paternal | "kinship" | "paternal" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:parental | "kinship" | "parental" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:filial | "kinship" | "filial" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:ancestral | "kinship" | "ancestral" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:scion | "kinship" | "scion" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:kid | "kinship" | "kid" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:offspring | "kinship" | "offspring" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:clan | "kinship" | "clan" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:people | "kinship" | "people" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:name | "kinship" | "name" | "has lexical unit" |  | "FN" |  |
| fn:kinship | fn:HasLexicalUnit | fn:lu:kinship:kinship | "kinship" | "kinship" | "has lexical unit" |  | "FN" |  |
| fn:fe:alter | /r/HasPrerequisite | fn:fe:ego | "alter" | "ego" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:alter | /r/RelatedTo | fn:fe:relatives | "alter" | "relatives" | "/r/related to" |  | "FN" |  |
| fn:kinship | /r/HasA | fn:fe:alter | "kinship" | "alter" | "/r/has a" |  | "FN" |  |
| fn:fe:ego | /r/HasPrerequisite | fn:fe:alter | "ego" | "alter" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:ego | /r/RelatedTo | fn:fe:relatives | "ego" | "relatives" | "/r/related to" |  | "FN" |  |
| fn:kinship | /r/HasA | fn:fe:ego | "kinship" | "ego" | "/r/has a" |  | "FN" |  |
| fn:kinship | /r/HasA | fn:fe:relatives | "kinship" | "relatives" | "/r/has a" |  | "FN" |  |
| fn:kinship | /r/HasA | fn:fe:degree | "kinship" | "degree" | "/r/has a" |  | "FN" |  |
| fn:kinship | /r/HasA | fn:fe:descriptor | "kinship" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:knot_creation | /r/IsA | fn:intentionally_create | "knot creation" | "intentionally create" | "/r/is a" |  | "FN" |  |
| fn:knot_creation | /r/IsA | fn:knot_creation_scenario | "knot creation" | "knot creation scenario" | "/r/is a" |  | "FN" |  |
| fn:knot_creation | fn:HasLexicalUnit | fn:lu:knot_creation:tie | "knot creation" | "tie" | "has lexical unit" |  | "FN" |  |
| fn:knot_creation | /r/HasA | fn:fe:agent | "knot creation" | "agent" | "/r/has a" |  | "FN" |  |
| fn:knot_creation | /r/HasA | fn:fe:instrument | "knot creation" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:knot_creation | /r/HasA | fn:fe:place | "knot creation" | "place" | "/r/has a" |  | "FN" |  |
| fn:knot_creation | /r/HasA | fn:fe:purpose | "knot creation" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:knot_creation | /r/HasA | fn:fe:time | "knot creation" | "time" | "/r/has a" |  | "FN" |  |
| fn:knot_creation | /r/HasA | fn:fe:means | "knot creation" | "means" | "/r/has a" |  | "FN" |  |
| fn:knot_creation | /r/HasA | fn:fe:knot | "knot creation" | "knot" | "/r/has a" |  | "FN" |  |
| fn:knot_creation | /r/HasA | fn:fe:manner | "knot creation" | "manner" | "/r/has a" |  | "FN" |  |
| fn:knot_creation | /r/HasA | fn:fe:depictive | "knot creation" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:knot_creation | /r/IsA | fn:knot_creation_scenario | "knot creation" | "knot creation scenario" | "/r/is a" |  | "FN" |  |
| fn:rope_manipulation | /r/IsA | fn:knot_creation_scenario | "rope manipulation" | "knot creation scenario" | "/r/is a" |  | "FN" |  |
| fn:knot_creation_scenario | /r/HasA | fn:fe:agent | "knot creation scenario" | "agent" | "/r/has a" |  | "FN" |  |
| fn:knot_creation_scenario | /r/HasA | fn:fe:instrument | "knot creation scenario" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:knot_creation_scenario | /r/HasA | fn:fe:place | "knot creation scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:knot_creation_scenario | /r/HasA | fn:fe:purpose | "knot creation scenario" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:knot_creation_scenario | /r/HasA | fn:fe:time | "knot creation scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:knot_creation_scenario | /r/HasA | fn:fe:means | "knot creation scenario" | "means" | "/r/has a" |  | "FN" |  |
| fn:knot_creation_scenario | /r/HasA | fn:fe:explanation | "knot creation scenario" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:knot_creation_scenario | /r/HasA | fn:fe:rope | "knot creation scenario" | "rope" | "/r/has a" |  | "FN" |  |
| fn:knot_creation_scenario | /r/HasA | fn:fe:knot | "knot creation scenario" | "knot" | "/r/has a" |  | "FN" |  |
| fn:knot_creation_scenario | /r/HasA | fn:fe:manner | "knot creation scenario" | "manner" | "/r/has a" |  | "FN" |  |
| fn:knot_creation_scenario | /r/HasA | fn:fe:locus | "knot creation scenario" | "locus" | "/r/has a" |  | "FN" |  |
| fn:labeling | /r/IsA | fn:referring_by_name | "labeling" | "referring by name" | "/r/is a" |  | "FN" |  |
| fn:judgment_communication | /r/UsedFor | fn:labeling | "judgment communication" | "labeling" | "/r/used for" |  | "FN" |  |
| fn:labeling | fn:HasLexicalUnit | fn:lu:labeling:label | "labeling" | "label" | "has lexical unit" |  | "FN" |  |
| fn:labeling | fn:HasLexicalUnit | fn:lu:labeling:call | "labeling" | "call" | "has lexical unit" |  | "FN" |  |
| fn:labeling | fn:HasLexicalUnit | fn:lu:labeling:term | "labeling" | "term" | "has lexical unit" |  | "FN" |  |
| fn:labeling | fn:HasLexicalUnit | fn:lu:labeling:brand | "labeling" | "brand" | "has lexical unit" |  | "FN" |  |
| fn:labeling | /r/HasA | fn:fe:speaker | "labeling" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:labeling | /r/HasA | fn:fe:entity | "labeling" | "entity" | "/r/has a" |  | "FN" |  |
| fn:labeling | /r/HasA | fn:fe:label | "labeling" | "label" | "/r/has a" |  | "FN" |  |
| fn:labeling | /r/HasA | fn:fe:time | "labeling" | "time" | "/r/has a" |  | "FN" |  |
| fn:labeling | /r/HasA | fn:fe:place | "labeling" | "place" | "/r/has a" |  | "FN" |  |
| fn:labeling | /r/HasA | fn:fe:medium | "labeling" | "medium" | "/r/has a" |  | "FN" |  |
| fn:labeling | /r/HasA | fn:fe:particular_iteration | "labeling" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:labeling | /r/HasA | fn:fe:explanation | "labeling" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:labeling | /r/HasA | fn:fe:duration_of_final_state | "labeling" | "duration of final state" | "/r/has a" |  | "FN" |  |
| fn:labor_product | fn:HasLexicalUnit | fn:lu:labor_product:oeuvre | "labor product" | "oeuvre" | "has lexical unit" |  | "FN" |  |
| fn:labor_product | fn:HasLexicalUnit | fn:lu:labor_product:work | "labor product" | "work" | "has lexical unit" |  | "FN" |  |
| fn:labor_product | fn:HasLexicalUnit | fn:lu:labor_product:output | "labor product" | "output" | "has lexical unit" |  | "FN" |  |
| fn:labor_product | /r/HasA | fn:fe:agent | "labor product" | "agent" | "/r/has a" |  | "FN" |  |
| fn:labor_product | /r/HasA | fn:fe:cause | "labor product" | "cause" | "/r/has a" |  | "FN" |  |
| fn:labor_product | /r/HasA | fn:fe:input | "labor product" | "input" | "/r/has a" |  | "FN" |  |
| fn:labor_product | /r/HasA | fn:fe:output | "labor product" | "output" | "/r/has a" |  | "FN" |  |
| fn:labor_product | /r/HasA | fn:fe:depictive | "labor product" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:labor_product | /r/HasA | fn:fe:time | "labor product" | "time" | "/r/has a" |  | "FN" |  |
| fn:labor_product | /r/HasA | fn:fe:place | "labor product" | "place" | "/r/has a" |  | "FN" |  |
| fn:labor_product | /r/HasA | fn:fe:beneficiary | "labor product" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:labor_product | /r/HasA | fn:fe:presentation | "labor product" | "presentation" | "/r/has a" |  | "FN" |  |
| fn:labor_product | /r/HasA | fn:fe:descriptor | "labor product" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:cause_to_start | /r/UsedFor | fn:launch_process | "cause to start" | "launch process" | "/r/used for" |  | "FN" |  |
| fn:launch_process | fn:HasLexicalUnit | fn:lu:launch_process:launch | "launch process" | "launch" | "has lexical unit" |  | "FN" |  |
| fn:launch_process | /r/HasA | fn:fe:process | "launch process" | "process" | "/r/has a" |  | "FN" |  |
| fn:launch_process | /r/HasA | fn:fe:place | "launch process" | "place" | "/r/has a" |  | "FN" |  |
| fn:launch_process | /r/HasA | fn:fe:means | "launch process" | "means" | "/r/has a" |  | "FN" |  |
| fn:launch_process | /r/HasA | fn:fe:time | "launch process" | "time" | "/r/has a" |  | "FN" |  |
| fn:launch_process | /r/HasA | fn:fe:medium | "launch process" | "medium" | "/r/has a" |  | "FN" |  |
| fn:launch_process | /r/HasA | fn:fe:agent | "launch process" | "agent" | "/r/has a" |  | "FN" |  |
| fn:launch_process | /r/HasA | fn:fe:purpose | "launch process" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:launch_process | /r/HasA | fn:fe:co-timed_event | "launch process" | "co-timed event" | "/r/has a" |  | "FN" |  |
| fn:launch_process | /r/HasA | fn:fe:manner | "launch process" | "manner" | "/r/has a" |  | "FN" |  |
| fn:launch_process | /r/HasA | fn:fe:communicative_force | "launch process" | "communicative force" | "/r/has a" |  | "FN" |  |
| fn:launch_process | /r/HasA | fn:fe:explanation | "launch process" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:launch_process | /r/HasA | fn:fe:circumstances | "launch process" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:launch_process | /r/HasA | fn:fe:particular_iteration | "launch process" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:launch_process | /r/HasA | fn:fe:new_situation | "launch process" | "new situation" | "/r/has a" |  | "FN" |  |
| fn:launch_process | /r/HasA | fn:fe:containing_event | "launch process" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:launch_process | /r/HasA | fn:fe:concessive | "launch process" | "concessive" | "/r/has a" |  | "FN" |  |
| fn:launch_process | /r/HasA | fn:fe:depictive | "launch process" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:launch_process | /r/HasA | fn:fe:event_description | "launch process" | "event description" | "/r/has a" |  | "FN" |  |
| fn:launch_process | /r/HasA | fn:fe:beneficiary | "launch process" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:launch_process | /r/HasA | fn:fe:re-encoding | "launch process" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:launch_process | /r/HasA | fn:fe:frequency | "launch process" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:law | /r/IsA | fn:artifact | "law" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:law | /r/UsedFor | fn:legality | "law" | "legality" | "/r/used for" |  | "FN" |  |
| fn:law | /r/UsedFor | fn:prohibiting_or_licensing | "law" | "prohibiting or licensing" | "/r/used for" |  | "FN" |  |
| fn:text | /r/UsedFor | fn:law | "text" | "law" | "/r/used for" |  | "FN" |  |
| fn:law | fn:HasLexicalUnit | fn:lu:law:law | "law" | "law" | "has lexical unit" |  | "FN" |  |
| fn:law | fn:HasLexicalUnit | fn:lu:law:code | "law" | "code" | "has lexical unit" |  | "FN" |  |
| fn:law | fn:HasLexicalUnit | fn:lu:law:protocol | "law" | "protocol" | "has lexical unit" |  | "FN" |  |
| fn:law | fn:HasLexicalUnit | fn:lu:law:act | "law" | "act" | "has lexical unit" |  | "FN" |  |
| fn:law | fn:HasLexicalUnit | fn:lu:law:statute | "law" | "statute" | "has lexical unit" |  | "FN" |  |
| fn:law | fn:HasLexicalUnit | fn:lu:law:regulation | "law" | "regulation" | "has lexical unit" |  | "FN" |  |
| fn:law | fn:HasLexicalUnit | fn:lu:law:regime | "law" | "regime" | "has lexical unit" |  | "FN" |  |
| fn:law | fn:HasLexicalUnit | fn:lu:law:policy | "law" | "policy" | "has lexical unit" |  | "FN" |  |
| fn:law | fn:HasLexicalUnit | fn:lu:law:order | "law" | "order" | "has lexical unit" |  | "FN" |  |
| fn:fe:law | /r/IsA | fn:st:artifact | "law" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:law | /r/HasA | fn:fe:law | "law" | "law" | "/r/has a" |  | "FN" |  |
| fn:law | /r/HasA | fn:fe:use | "law" | "use" | "/r/has a" |  | "FN" |  |
| fn:law | /r/HasA | fn:fe:creator | "law" | "creator" | "/r/has a" |  | "FN" |  |
| fn:law | /r/HasA | fn:fe:time_of_creation | "law" | "time of creation" | "/r/has a" |  | "FN" |  |
| fn:law | /r/HasA | fn:fe:name | "law" | "name" | "/r/has a" |  | "FN" |  |
| fn:law | /r/HasA | fn:fe:type | "law" | "type" | "/r/has a" |  | "FN" |  |
| fn:law | /r/HasA | fn:fe:part | "law" | "part" | "/r/has a" |  | "FN" |  |
| fn:law | /r/HasA | fn:fe:forbidden | "law" | "forbidden" | "/r/has a" |  | "FN" |  |
| fn:law | /r/HasA | fn:fe:required | "law" | "required" | "/r/has a" |  | "FN" |  |
| fn:law | /r/HasA | fn:fe:jurisdiction | "law" | "jurisdiction" | "/r/has a" |  | "FN" |  |
| fn:law | /r/HasA | fn:fe:descriptor | "law" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:law_enforcement_agency | /r/IsA | fn:government_institution | "law enforcement agency" | "government institution" | "/r/is a" |  | "FN" |  |
| fn:law_enforcement_agency | fn:HasLexicalUnit | fn:lu:law_enforcement_agency:police | "law enforcement agency" | "police" | "has lexical unit" |  | "FN" |  |
| fn:law_enforcement_agency | fn:HasLexicalUnit | fn:lu:law_enforcement_agency:police_department | "law enforcement agency" | "police department" | "has lexical unit" |  | "FN" |  |
| fn:law_enforcement_agency | fn:HasLexicalUnit | fn:lu:law_enforcement_agency:fire_department | "law enforcement agency" | "fire department" | "has lexical unit" |  | "FN" |  |
| fn:fe:agency | /r/IsA | fn:st:group | "agency" | "group" | "/r/is a" |  | "FN" |  |
| fn:law_enforcement_agency | /r/HasA | fn:fe:agency | "law enforcement agency" | "agency" | "/r/has a" |  | "FN" |  |
| fn:law_enforcement_agency | /r/HasA | fn:fe:members | "law enforcement agency" | "members" | "/r/has a" |  | "FN" |  |
| fn:law_enforcement_agency | /r/HasA | fn:fe:purpose | "law enforcement agency" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:law_enforcement_agency | /r/HasA | fn:fe:period_of_existence | "law enforcement agency" | "period of existence" | "/r/has a" |  | "FN" |  |
| fn:law_enforcement_agency | /r/HasA | fn:fe:name | "law enforcement agency" | "name" | "/r/has a" |  | "FN" |  |
| fn:law_enforcement_agency | /r/HasA | fn:fe:place | "law enforcement agency" | "place" | "/r/has a" |  | "FN" |  |
| fn:law_enforcement_agency | /r/HasA | fn:fe:descriptor | "law enforcement agency" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:law_enforcement_agency | /r/HasA | fn:fe:jurisdiction | "law enforcement agency" | "jurisdiction" | "/r/has a" |  | "FN" |  |
| fn:leadership | /r/UsedFor | fn:political_locales | "leadership" | "political locales" | "/r/used for" |  | "FN" |  |
| fn:appellations | /r/RelatedTo | fn:leadership | "appellations" | "leadership" | "/r/related to" |  | "FN" |  |
| fn:change_of_leadership | /r/Causes | fn:leadership | "change of leadership" | "leadership" | "/r/causes" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:bishop | "leadership" | "bishop" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:boss | "leadership" | "boss" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:captain | "leadership" | "captain" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:chairman | "leadership" | "chairman" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:chairperson | "leadership" | "chairperson" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:chief | "leadership" | "chief" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:chieftain | "leadership" | "chieftain" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:command | "leadership" | "command" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:commandant | "leadership" | "commandant" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:commander | "leadership" | "commander" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:director | "leadership" | "director" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:emperor | "leadership" | "emperor" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:general | "leadership" | "general" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:govern | "leadership" | "govern" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:governor | "leadership" | "governor" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:head | "leadership" | "head" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:head | "leadership" | "head" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:imam | "leadership" | "imam" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:king | "leadership" | "king" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:lead | "leadership" | "lead" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:leader | "leadership" | "leader" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:mayor | "leadership" | "mayor" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:minister | "leadership" | "minister" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:monarch | "leadership" | "monarch" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:premier | "leadership" | "premier" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:preside | "leadership" | "preside" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:president_[political] | "leadership" | "president [political]" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:principal | "leadership" | "principal" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:queen | "leadership" | "queen" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:reign | "leadership" | "reign" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:rule | "leadership" | "rule" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:ruler | "leadership" | "ruler" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:run | "leadership" | "run" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:shah | "leadership" | "shah" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:sovereign | "leadership" | "sovereign" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:sultan | "leadership" | "sultan" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:vice-captain | "leadership" | "vice-captain" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:vice-chairman | "leadership" | "vice-chairman" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:vice-president_[political] | "leadership" | "vice-president [political]" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:vice-principal | "leadership" | "vice-principal" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:viceroy | "leadership" | "viceroy" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:caliph | "leadership" | "caliph" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:suzerain | "leadership" | "suzerain" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:satrap | "leadership" | "satrap" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:rector | "leadership" | "rector" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:headmaster | "leadership" | "headmaster" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:doyen | "leadership" | "doyen" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:doyenne | "leadership" | "doyenne" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:empress | "leadership" | "empress" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:maharaja | "leadership" | "maharaja" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:tsar | "leadership" | "tsar" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:tsarina | "leadership" | "tsarina" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:sheik | "leadership" | "sheik" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:vizier | "leadership" | "vizier" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:duchess | "leadership" | "duchess" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:khan | "leadership" | "khan" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:khedive | "leadership" | "khedive" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:kaiser | "leadership" | "kaiser" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:pasha | "leadership" | "pasha" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:overlord | "leadership" | "overlord" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:baron | "leadership" | "baron" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:dictator | "leadership" | "dictator" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:official | "leadership" | "official" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:prime_minister | "leadership" | "prime minister" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:authority | "leadership" | "authority" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:drug_lord | "leadership" | "drug lord" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:government | "leadership" | "government" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:power_[govt] | "leadership" | "power [govt]" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:presidential | "leadership" | "presidential" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:regime | "leadership" | "regime" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:director_general | "leadership" | "director general" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:command | "leadership" | "command" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:charge | "leadership" | "charge" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:power_[rule] | "leadership" | "power [rule]" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:rule | "leadership" | "rule" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:high-priest | "leadership" | "high-priest" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:diplomat | "leadership" | "diplomat" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:legislature | "leadership" | "legislature" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:congressman | "leadership" | "congressman" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:leadership | "leadership" | "leadership" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:senate | "leadership" | "senate" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:mogul | "leadership" | "mogul" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:prince | "leadership" | "prince" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:administration | "leadership" | "administration" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:major_general | "leadership" | "major general" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:representative | "leadership" | "representative" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:executive | "leadership" | "executive" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:crown_prince | "leadership" | "crown prince" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:legislator | "leadership" | "legislator" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:administer | "leadership" | "administer" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:secretary | "leadership" | "secretary" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:lawmaker | "leadership" | "lawmaker" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:spearhead | "leadership" | "spearhead" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:ceo | "leadership" | "ceo" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:chief_executive_officer | "leadership" | "chief executive officer" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:officer | "leadership" | "officer" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:state | "leadership" | "state" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:despot | "leadership" | "despot" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:tyrant | "leadership" | "tyrant" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:chair | "leadership" | "chair" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:superintendent | "leadership" | "superintendent" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:commissioner | "leadership" | "commissioner" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:supervisor | "leadership" | "supervisor" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:congresswoman | "leadership" | "congresswoman" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:president_[non-political] | "leadership" | "president [non-political]" | "has lexical unit" |  | "FN" |  |
| fn:leadership | fn:HasLexicalUnit | fn:lu:leadership:vice-president_[non-political] | "leadership" | "vice-president [non-political]" | "has lexical unit" |  | "FN" |  |
| fn:leadership | /r/HasA | fn:fe:leader | "leadership" | "leader" | "/r/has a" |  | "FN" |  |
| fn:leadership | /r/HasA | fn:fe:role | "leadership" | "role" | "/r/has a" |  | "FN" |  |
| fn:leadership | /r/HasA | fn:fe:duration | "leadership" | "duration" | "/r/has a" |  | "FN" |  |
| fn:leadership | /r/HasA | fn:fe:depictive | "leadership" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:leadership | /r/HasA | fn:fe:manner | "leadership" | "manner" | "/r/has a" |  | "FN" |  |
| fn:leadership | /r/HasA | fn:fe:means | "leadership" | "means" | "/r/has a" |  | "FN" |  |
| fn:leadership | /r/HasA | fn:fe:degree | "leadership" | "degree" | "/r/has a" |  | "FN" |  |
| fn:leadership | /r/HasA | fn:fe:time | "leadership" | "time" | "/r/has a" |  | "FN" |  |
| fn:leadership | /r/HasA | fn:fe:governed | "leadership" | "governed" | "/r/has a" |  | "FN" |  |
| fn:leadership | /r/HasA | fn:fe:descriptor | "leadership" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:leadership | /r/HasA | fn:fe:type | "leadership" | "type" | "/r/has a" |  | "FN" |  |
| fn:leadership | /r/HasA | fn:fe:domain | "leadership" | "domain" | "/r/has a" |  | "FN" |  |
| fn:fe:activity | /r/IsA | fn:st:activity | "activity" | "activity" | "/r/is a" |  | "FN" |  |
| fn:st:activity | /r/IsA | fn:st:ontological_type | "activity" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:leadership | /r/HasA | fn:fe:activity | "leadership" | "activity" | "/r/has a" |  | "FN" |  |
| fn:leadership | /r/HasA | fn:fe:place | "leadership" | "place" | "/r/has a" |  | "FN" |  |
| fn:leaving_traces | /r/IsA | fn:sign | "leaving traces" | "sign" | "/r/is a" |  | "FN" |  |
| fn:leaving_traces | fn:HasLexicalUnit | fn:lu:leaving_traces:trace | "leaving traces" | "trace" | "has lexical unit" |  | "FN" |  |
| fn:leaving_traces | fn:HasLexicalUnit | fn:lu:leaving_traces:track | "leaving traces" | "track" | "has lexical unit" |  | "FN" |  |
| fn:leaving_traces | fn:HasLexicalUnit | fn:lu:leaving_traces:trail | "leaving traces" | "trail" | "has lexical unit" |  | "FN" |  |
| fn:leaving_traces | fn:HasLexicalUnit | fn:lu:leaving_traces:wake | "leaving traces" | "wake" | "has lexical unit" |  | "FN" |  |
| fn:leaving_traces | fn:HasLexicalUnit | fn:lu:leaving_traces:contrail | "leaving traces" | "contrail" | "has lexical unit" |  | "FN" |  |
| fn:leaving_traces | fn:HasLexicalUnit | fn:lu:leaving_traces:vestige | "leaving traces" | "vestige" | "has lexical unit" |  | "FN" |  |
| fn:leaving_traces | /r/HasA | fn:fe:evidence | "leaving traces" | "evidence" | "/r/has a" |  | "FN" |  |
| fn:leaving_traces | /r/HasA | fn:fe:entity | "leaving traces" | "entity" | "/r/has a" |  | "FN" |  |
| fn:leaving_traces | /r/HasA | fn:fe:descriptor | "leaving traces" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:leaving_traces | /r/HasA | fn:fe:location | "leaving traces" | "location" | "/r/has a" |  | "FN" |  |
| fn:leaving_traces | /r/HasA | fn:fe:event | "leaving traces" | "event" | "/r/has a" |  | "FN" |  |
| fn:leaving_traces | /r/HasA | fn:fe:time | "leaving traces" | "time" | "/r/has a" |  | "FN" |  |
| fn:leaving_traces | /r/HasA | fn:fe:reliability | "leaving traces" | "reliability" | "/r/has a" |  | "FN" |  |
| fn:purpose | /r/UsedFor | fn:left_to_do | "purpose" | "left to do" | "/r/used for" |  | "FN" |  |
| fn:left_to_do | fn:HasLexicalUnit | fn:lu:left_to_do:left | "left to do" | "left" | "has lexical unit" |  | "FN" |  |
| fn:left_to_do | fn:HasLexicalUnit | fn:lu:left_to_do:remain | "left to do" | "remain" | "has lexical unit" |  | "FN" |  |
| fn:left_to_do | fn:HasLexicalUnit | fn:lu:left_to_do:remainder | "left to do" | "remainder" | "has lexical unit" |  | "FN" |  |
| fn:left_to_do | /r/HasA | fn:fe:process | "left to do" | "process" | "/r/has a" |  | "FN" |  |
| fn:left_to_do | /r/HasA | fn:fe:remainder | "left to do" | "remainder" | "/r/has a" |  | "FN" |  |
| fn:left_to_do | /r/HasA | fn:fe:time | "left to do" | "time" | "/r/has a" |  | "FN" |  |
| fn:left_to_do | /r/HasA | fn:fe:agent | "left to do" | "agent" | "/r/has a" |  | "FN" |  |
| fn:legal_rulings | /r/IsA | fn:intentionally_act | "legal rulings" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:verdict | /r/IsA | fn:legal_rulings | "verdict" | "legal rulings" | "/r/is a" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:legal_rulings | "communication" | "legal rulings" | "/r/used for" |  | "FN" |  |
| fn:legal_rulings | fn:HasLexicalUnit | fn:lu:legal_rulings:rule | "legal rulings" | "rule" | "has lexical unit" |  | "FN" |  |
| fn:legal_rulings | fn:HasLexicalUnit | fn:lu:legal_rulings:judge | "legal rulings" | "judge" | "has lexical unit" |  | "FN" |  |
| fn:legal_rulings | fn:HasLexicalUnit | fn:lu:legal_rulings:decree | "legal rulings" | "decree" | "has lexical unit" |  | "FN" |  |
| fn:legal_rulings | fn:HasLexicalUnit | fn:lu:legal_rulings:adjudicate | "legal rulings" | "adjudicate" | "has lexical unit" |  | "FN" |  |
| fn:legal_rulings | fn:HasLexicalUnit | fn:lu:legal_rulings:judgment | "legal rulings" | "judgment" | "has lexical unit" |  | "FN" |  |
| fn:legal_rulings | fn:HasLexicalUnit | fn:lu:legal_rulings:deem | "legal rulings" | "deem" | "has lexical unit" |  | "FN" |  |
| fn:legal_rulings | /r/HasA | fn:fe:authority | "legal rulings" | "authority" | "/r/has a" |  | "FN" |  |
| fn:legal_rulings | /r/HasA | fn:fe:finding | "legal rulings" | "finding" | "/r/has a" |  | "FN" |  |
| fn:legal_rulings | /r/HasA | fn:fe:case | "legal rulings" | "case" | "/r/has a" |  | "FN" |  |
| fn:legal_rulings | /r/HasA | fn:fe:time | "legal rulings" | "time" | "/r/has a" |  | "FN" |  |
| fn:legal_rulings | /r/HasA | fn:fe:place | "legal rulings" | "place" | "/r/has a" |  | "FN" |  |
| fn:legal_rulings | /r/HasA | fn:fe:legal_basis | "legal rulings" | "legal basis" | "/r/has a" |  | "FN" |  |
| fn:legal_rulings | /r/HasA | fn:fe:circumstances | "legal rulings" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:legal_rulings | /r/HasA | fn:fe:manner | "legal rulings" | "manner" | "/r/has a" |  | "FN" |  |
| fn:legal_rulings | /r/HasA | fn:fe:purpose | "legal rulings" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:legal_rulings | /r/HasA | fn:fe:means | "legal rulings" | "means" | "/r/has a" |  | "FN" |  |
| fn:legal_rulings | /r/HasA | fn:fe:explanation | "legal rulings" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:legal_rulings | /r/HasA | fn:fe:re-encoding | "legal rulings" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:legal_rulings | /r/HasA | fn:fe:particular_iteration | "legal rulings" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:legal_rulings | /r/HasA | fn:fe:communicative_force | "legal rulings" | "communicative force" | "/r/has a" |  | "FN" |  |
| fn:legal_rulings | /r/HasA | fn:fe:duration | "legal rulings" | "duration" | "/r/has a" |  | "FN" |  |
| fn:legal_rulings | /r/HasA | fn:fe:defendant | "legal rulings" | "defendant" | "/r/has a" |  | "FN" |  |
| fn:compliance | /r/UsedFor | fn:legality | "compliance" | "legality" | "/r/used for" |  | "FN" |  |
| fn:law | /r/UsedFor | fn:legality | "law" | "legality" | "/r/used for" |  | "FN" |  |
| fn:legality | /r/UsedFor | fn:committing_crime | "legality" | "committing crime" | "/r/used for" |  | "FN" |  |
| fn:morality_evaluation | /r/UsedFor | fn:legality | "morality evaluation" | "legality" | "/r/used for" |  | "FN" |  |
| fn:legality | fn:HasLexicalUnit | fn:lu:legality:illegal | "legality" | "illegal" | "has lexical unit" |  | "FN" |  |
| fn:legality | fn:HasLexicalUnit | fn:lu:legality:legal | "legality" | "legal" | "has lexical unit" |  | "FN" |  |
| fn:legality | fn:HasLexicalUnit | fn:lu:legality:lawful | "legality" | "lawful" | "has lexical unit" |  | "FN" |  |
| fn:legality | fn:HasLexicalUnit | fn:lu:legality:unlawful | "legality" | "unlawful" | "has lexical unit" |  | "FN" |  |
| fn:legality | fn:HasLexicalUnit | fn:lu:legality:wrongful | "legality" | "wrongful" | "has lexical unit" |  | "FN" |  |
| fn:legality | fn:HasLexicalUnit | fn:lu:legality:illicit | "legality" | "illicit" | "has lexical unit" |  | "FN" |  |
| fn:legality | fn:HasLexicalUnit | fn:lu:legality:licit | "legality" | "licit" | "has lexical unit" |  | "FN" |  |
| fn:legality | fn:HasLexicalUnit | fn:lu:legality:permissible | "legality" | "permissible" | "has lexical unit" |  | "FN" |  |
| fn:legality | fn:HasLexicalUnit | fn:lu:legality:wrongly | "legality" | "wrongly" | "has lexical unit" |  | "FN" |  |
| fn:legality | fn:HasLexicalUnit | fn:lu:legality:wrong | "legality" | "wrong" | "has lexical unit" |  | "FN" |  |
| fn:legality | fn:HasLexicalUnit | fn:lu:legality:prohibited | "legality" | "prohibited" | "has lexical unit" |  | "FN" |  |
| fn:legality | fn:HasLexicalUnit | fn:lu:legality:legitimate | "legality" | "legitimate" | "has lexical unit" |  | "FN" |  |
| fn:legality | fn:HasLexicalUnit | fn:lu:legality:fair | "legality" | "fair" | "has lexical unit" |  | "FN" |  |
| fn:legality | fn:HasLexicalUnit | fn:lu:legality:criminal | "legality" | "criminal" | "has lexical unit" |  | "FN" |  |
| fn:legality | /r/HasA | fn:fe:action | "legality" | "action" | "/r/has a" |  | "FN" |  |
| fn:fe:code | /r/IsA | fn:st:artifact | "code" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:legality | /r/HasA | fn:fe:code | "legality" | "code" | "/r/has a" |  | "FN" |  |
| fn:legality | /r/HasA | fn:fe:object | "legality" | "object" | "/r/has a" |  | "FN" |  |
| fn:legality | /r/HasA | fn:fe:explanation | "legality" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:lending | /r/IsA | fn:giving | "lending" | "giving" | "/r/is a" |  | "FN" |  |
| fn:lending | /r/IsA | fn:temporary_transfer_scenario | "lending" | "temporary transfer scenario" | "/r/is a" |  | "FN" |  |
| fn:lending | fn:HasLexicalUnit | fn:lu:lending:lend | "lending" | "lend" | "has lexical unit" |  | "FN" |  |
| fn:lending | fn:HasLexicalUnit | fn:lu:lending:loan | "lending" | "loan" | "has lexical unit" |  | "FN" |  |
| fn:lending | fn:HasLexicalUnit | fn:lu:lending:loan | "lending" | "loan" | "has lexical unit" |  | "FN" |  |
| fn:lending | /r/HasA | fn:fe:borrower | "lending" | "borrower" | "/r/has a" |  | "FN" |  |
| fn:lending | /r/HasA | fn:fe:duration | "lending" | "duration" | "/r/has a" |  | "FN" |  |
| fn:lending | /r/HasA | fn:fe:lender | "lending" | "lender" | "/r/has a" |  | "FN" |  |
| fn:lending | /r/HasA | fn:fe:theme | "lending" | "theme" | "/r/has a" |  | "FN" |  |
| fn:lending | /r/HasA | fn:fe:purpose | "lending" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:lending | /r/HasA | fn:fe:time | "lending" | "time" | "/r/has a" |  | "FN" |  |
| fn:lending | /r/HasA | fn:fe:manner | "lending" | "manner" | "/r/has a" |  | "FN" |  |
| fn:lending | /r/HasA | fn:fe:place | "lending" | "place" | "/r/has a" |  | "FN" |  |
| fn:level_of_force_exertion | /r/IsA | fn:gradable_attributes | "level of force exertion" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:causation | /r/UsedFor | fn:level_of_force_exertion | "causation" | "level of force exertion" | "/r/used for" |  | "FN" |  |
| fn:level_of_force_exertion | /r/RelatedTo | fn:dynamism | "level of force exertion" | "dynamism" | "/r/related to" |  | "FN" |  |
| fn:level_of_force_exertion | /r/RelatedTo | fn:level_of_force_resistance | "level of force exertion" | "level of force resistance" | "/r/related to" |  | "FN" |  |
| fn:dynamism | /r/SimilarTo | fn:level_of_force_exertion | "dynamism" | "level of force exertion" | "/r/similar to" |  | "FN" |  |
| fn:level_of_force_exertion | /r/SimilarTo | fn:capability | "level of force exertion" | "capability" | "/r/similar to" |  | "FN" |  |
| fn:level_of_force_exertion | fn:HasLexicalUnit | fn:lu:level_of_force_exertion:strong | "level of force exertion" | "strong" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_exertion | fn:HasLexicalUnit | fn:lu:level_of_force_exertion:weak | "level of force exertion" | "weak" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_exertion | fn:HasLexicalUnit | fn:lu:level_of_force_exertion:mighty | "level of force exertion" | "mighty" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_exertion | fn:HasLexicalUnit | fn:lu:level_of_force_exertion:power | "level of force exertion" | "power" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_exertion | fn:HasLexicalUnit | fn:lu:level_of_force_exertion:might | "level of force exertion" | "might" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_exertion | fn:HasLexicalUnit | fn:lu:level_of_force_exertion:forceful | "level of force exertion" | "forceful" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_exertion | fn:HasLexicalUnit | fn:lu:level_of_force_exertion:force | "level of force exertion" | "force" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_exertion | fn:HasLexicalUnit | fn:lu:level_of_force_exertion:strength | "level of force exertion" | "strength" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_exertion | fn:HasLexicalUnit | fn:lu:level_of_force_exertion:weakness | "level of force exertion" | "weakness" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_exertion | fn:HasLexicalUnit | fn:lu:level_of_force_exertion:powerful | "level of force exertion" | "powerful" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_exertion | fn:HasLexicalUnit | fn:lu:level_of_force_exertion:powerless | "level of force exertion" | "powerless" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_exertion | /r/HasA | fn:fe:exerter | "level of force exertion" | "exerter" | "/r/has a" |  | "FN" |  |
| fn:level_of_force_exertion | /r/HasA | fn:fe:force | "level of force exertion" | "force" | "/r/has a" |  | "FN" |  |
| fn:level_of_force_exertion | /r/HasA | fn:fe:time | "level of force exertion" | "time" | "/r/has a" |  | "FN" |  |
| fn:level_of_force_exertion | /r/HasA | fn:fe:circumstances | "level of force exertion" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:level_of_force_exertion | /r/HasA | fn:fe:action | "level of force exertion" | "action" | "/r/has a" |  | "FN" |  |
| fn:level_of_force_exertion | /r/HasA | fn:fe:degree | "level of force exertion" | "degree" | "/r/has a" |  | "FN" |  |
| fn:level_of_force_exertion | /r/HasA | fn:fe:place | "level of force exertion" | "place" | "/r/has a" |  | "FN" |  |
| fn:level_of_force_exertion | /r/HasA | fn:fe:descriptor | "level of force exertion" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:level_of_force_exertion | /r/HasA | fn:fe:domain | "level of force exertion" | "domain" | "/r/has a" |  | "FN" |  |
| fn:level_of_force_resistance | /r/IsA | fn:gradable_attributes | "level of force resistance" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:level_of_force_resistance | /r/UsedFor | fn:repel | "level of force resistance" | "repel" | "/r/used for" |  | "FN" |  |
| fn:preventing_or_letting | /r/UsedFor | fn:level_of_force_resistance | "preventing or letting" | "level of force resistance" | "/r/used for" |  | "FN" |  |
| fn:level_of_force_exertion | /r/RelatedTo | fn:level_of_force_resistance | "level of force exertion" | "level of force resistance" | "/r/related to" |  | "FN" |  |
| fn:level_of_force_resistance | fn:HasLexicalUnit | fn:lu:level_of_force_resistance:strong | "level of force resistance" | "strong" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_resistance | fn:HasLexicalUnit | fn:lu:level_of_force_resistance:impregnable | "level of force resistance" | "impregnable" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_resistance | fn:HasLexicalUnit | fn:lu:level_of_force_resistance:tough | "level of force resistance" | "tough" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_resistance | fn:HasLexicalUnit | fn:lu:level_of_force_resistance:strength | "level of force resistance" | "strength" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_resistance | fn:HasLexicalUnit | fn:lu:level_of_force_resistance:weak | "level of force resistance" | "weak" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_resistance | fn:HasLexicalUnit | fn:lu:level_of_force_resistance:weakness | "level of force resistance" | "weakness" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_resistance | fn:HasLexicalUnit | fn:lu:level_of_force_resistance:hardy | "level of force resistance" | "hardy" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_resistance | fn:HasLexicalUnit | fn:lu:level_of_force_resistance:hardiness | "level of force resistance" | "hardiness" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_resistance | fn:HasLexicalUnit | fn:lu:level_of_force_resistance:sturdy | "level of force resistance" | "sturdy" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_resistance | fn:HasLexicalUnit | fn:lu:level_of_force_resistance:sturdiness | "level of force resistance" | "sturdiness" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_resistance | fn:HasLexicalUnit | fn:lu:level_of_force_resistance:toughness | "level of force resistance" | "toughness" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_resistance | fn:HasLexicalUnit | fn:lu:level_of_force_resistance:durable | "level of force resistance" | "durable" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_resistance | fn:HasLexicalUnit | fn:lu:level_of_force_resistance:durability | "level of force resistance" | "durability" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_resistance | fn:HasLexicalUnit | fn:lu:level_of_force_resistance:fragile | "level of force resistance" | "fragile" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_resistance | fn:HasLexicalUnit | fn:lu:level_of_force_resistance:fragility | "level of force resistance" | "fragility" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_resistance | fn:HasLexicalUnit | fn:lu:level_of_force_resistance:flimsy | "level of force resistance" | "flimsy" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_resistance | fn:HasLexicalUnit | fn:lu:level_of_force_resistance:flimsiness | "level of force resistance" | "flimsiness" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_resistance | fn:HasLexicalUnit | fn:lu:level_of_force_resistance:robust | "level of force resistance" | "robust" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_resistance | fn:HasLexicalUnit | fn:lu:level_of_force_resistance:robustness | "level of force resistance" | "robustness" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_resistance | fn:HasLexicalUnit | fn:lu:level_of_force_resistance:pliable | "level of force resistance" | "pliable" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_resistance | fn:HasLexicalUnit | fn:lu:level_of_force_resistance:pliability | "level of force resistance" | "pliability" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_resistance | fn:HasLexicalUnit | fn:lu:level_of_force_resistance:flexible | "level of force resistance" | "flexible" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_resistance | fn:HasLexicalUnit | fn:lu:level_of_force_resistance:flexibility | "level of force resistance" | "flexibility" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_resistance | fn:HasLexicalUnit | fn:lu:level_of_force_resistance:frail | "level of force resistance" | "frail" | "has lexical unit" |  | "FN" |  |
| fn:level_of_force_resistance | /r/HasA | fn:fe:resisting_entity | "level of force resistance" | "resisting entity" | "/r/has a" |  | "FN" |  |
| fn:level_of_force_resistance | /r/HasA | fn:fe:degree | "level of force resistance" | "degree" | "/r/has a" |  | "FN" |  |
| fn:level_of_force_resistance | /r/HasA | fn:fe:place | "level of force resistance" | "place" | "/r/has a" |  | "FN" |  |
| fn:level_of_force_resistance | /r/HasA | fn:fe:time | "level of force resistance" | "time" | "/r/has a" |  | "FN" |  |
| fn:level_of_force_resistance | /r/HasA | fn:fe:circumstances | "level of force resistance" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:level_of_force_resistance | /r/HasA | fn:fe:descriptor | "level of force resistance" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:level_of_force_resistance | /r/HasA | fn:fe:domain | "level of force resistance" | "domain" | "/r/has a" |  | "FN" |  |
| fn:level_of_force_resistance | /r/HasA | fn:fe:opposing_force | "level of force resistance" | "opposing force" | "/r/has a" |  | "FN" |  |
| fn:level_of_light | /r/IsA | fn:gradable_attributes | "level of light" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:level_of_light | fn:HasLexicalUnit | fn:lu:level_of_light:dark | "level of light" | "dark" | "has lexical unit" |  | "FN" |  |
| fn:level_of_light | fn:HasLexicalUnit | fn:lu:level_of_light:dim | "level of light" | "dim" | "has lexical unit" |  | "FN" |  |
| fn:level_of_light | fn:HasLexicalUnit | fn:lu:level_of_light:black | "level of light" | "black" | "has lexical unit" |  | "FN" |  |
| fn:level_of_light | fn:HasLexicalUnit | fn:lu:level_of_light:unlighted | "level of light" | "unlighted" | "has lexical unit" |  | "FN" |  |
| fn:level_of_light | fn:HasLexicalUnit | fn:lu:level_of_light:lightless | "level of light" | "lightless" | "has lexical unit" |  | "FN" |  |
| fn:level_of_light | fn:HasLexicalUnit | fn:lu:level_of_light:light | "level of light" | "light" | "has lexical unit" |  | "FN" |  |
| fn:level_of_light | fn:HasLexicalUnit | fn:lu:level_of_light:bright | "level of light" | "bright" | "has lexical unit" |  | "FN" |  |
| fn:level_of_light | fn:HasLexicalUnit | fn:lu:level_of_light:sunny | "level of light" | "sunny" | "has lexical unit" |  | "FN" |  |
| fn:level_of_light | fn:HasLexicalUnit | fn:lu:level_of_light:lighted | "level of light" | "lighted" | "has lexical unit" |  | "FN" |  |
| fn:level_of_light | fn:HasLexicalUnit | fn:lu:level_of_light:sunless | "level of light" | "sunless" | "has lexical unit" |  | "FN" |  |
| fn:level_of_light | fn:HasLexicalUnit | fn:lu:level_of_light:moonless | "level of light" | "moonless" | "has lexical unit" |  | "FN" |  |
| fn:level_of_light | fn:HasLexicalUnit | fn:lu:level_of_light:shady | "level of light" | "shady" | "has lexical unit" |  | "FN" |  |
| fn:level_of_light | /r/HasA | fn:fe:location | "level of light" | "location" | "/r/has a" |  | "FN" |  |
| fn:level_of_light | /r/HasA | fn:fe:source | "level of light" | "source" | "/r/has a" |  | "FN" |  |
| fn:level_of_light | /r/HasA | fn:fe:degree | "level of light" | "degree" | "/r/has a" |  | "FN" |  |
| fn:level_of_light | /r/HasA | fn:fe:descriptor | "level of light" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:light_movement | "motion" | "light movement" | "/r/used for" |  | "FN" |  |
| fn:location_of_light | /r/RelatedTo | fn:light_movement | "location of light" | "light movement" | "/r/related to" |  | "FN" |  |
| fn:location_of_light | /r/SimilarTo | fn:light_movement | "location of light" | "light movement" | "/r/similar to" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:glow | "light movement" | "glow" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:twinkle | "light movement" | "twinkle" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:twinkle | "light movement" | "twinkle" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:sparkle | "light movement" | "sparkle" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:shine | "light movement" | "shine" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:shine | "light movement" | "shine" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:shimmer | "light movement" | "shimmer" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:sheen | "light movement" | "sheen" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:scintillation | "light movement" | "scintillation" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:scintillate | "light movement" | "scintillate" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:refulgence | "light movement" | "refulgence" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:glow | "light movement" | "glow" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:glitter | "light movement" | "glitter" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:glitter | "light movement" | "glitter" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:glister | "light movement" | "glister" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:glister | "light movement" | "glister" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:glistening | "light movement" | "glistening" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:glisten | "light movement" | "glisten" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:glint | "light movement" | "glint" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:glint | "light movement" | "glint" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:glimmer | "light movement" | "glimmer" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:glimmer | "light movement" | "glimmer" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:gleam | "light movement" | "gleam" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:gleam | "light movement" | "gleam" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:flicker | "light movement" | "flicker" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:flicker | "light movement" | "flicker" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:flash | "light movement" | "flash" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:flash | "light movement" | "flash" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:flare | "light movement" | "flare" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:flame | "light movement" | "flame" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:coruscation | "light movement" | "coruscation" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:coruscate | "light movement" | "coruscate" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | fn:HasLexicalUnit | fn:lu:light_movement:strike | "light movement" | "strike" | "has lexical unit" |  | "FN" |  |
| fn:light_movement | /r/HasA | fn:fe:degree | "light movement" | "degree" | "/r/has a" |  | "FN" |  |
| fn:light_movement | /r/HasA | fn:fe:depictive | "light movement" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:light_movement | /r/HasA | fn:fe:manner | "light movement" | "manner" | "/r/has a" |  | "FN" |  |
| fn:light_movement | /r/HasA | fn:fe:result | "light movement" | "result" | "/r/has a" |  | "FN" |  |
| fn:light_movement | /r/HasA | fn:fe:emitter | "light movement" | "emitter" | "/r/has a" |  | "FN" |  |
| fn:light_movement | /r/HasA | fn:fe:source | "light movement" | "source" | "/r/has a" |  | "FN" |  |
| fn:light_movement | /r/HasA | fn:fe:beam | "light movement" | "beam" | "/r/has a" |  | "FN" |  |
| fn:light_movement | /r/HasA | fn:fe:path | "light movement" | "path" | "/r/has a" |  | "FN" |  |
| fn:light_movement | /r/HasA | fn:fe:goal | "light movement" | "goal" | "/r/has a" |  | "FN" |  |
| fn:likelihood | /r/IsA | fn:gradable_attributes | "likelihood" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:run_risk | /r/IsA | fn:likelihood | "run risk" | "likelihood" | "/r/is a" |  | "FN" |  |
| fn:likelihood | /r/UsedFor | fn:capability | "likelihood" | "capability" | "/r/used for" |  | "FN" |  |
| fn:likelihood | /r/UsedFor | fn:luck | "likelihood" | "luck" | "/r/used for" |  | "FN" |  |
| fn:certainty | /r/SimilarTo | fn:likelihood | "certainty" | "likelihood" | "/r/similar to" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:certain | "likelihood" | "certain" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:likely | "likelihood" | "likely" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:likelihood | "likelihood" | "likelihood" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:certainty | "likelihood" | "certainty" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:possible | "likelihood" | "possible" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:possibility | "likelihood" | "possibility" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:chance | "likelihood" | "chance" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:probable | "likelihood" | "probable" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:unlikely | "likelihood" | "unlikely" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:impossible | "likelihood" | "impossible" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:improbability | "likelihood" | "improbability" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:prone | "likelihood" | "prone" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:sure | "likelihood" | "sure" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:probability | "likelihood" | "probability" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:possibly | "likelihood" | "possibly" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:tend | "likelihood" | "tend" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:bound | "likelihood" | "bound" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:may | "likelihood" | "may" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:might | "likelihood" | "might" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:probably | "likelihood" | "probably" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:likely | "likelihood" | "likely" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:certainly | "likelihood" | "certainly" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:guaranteed | "likelihood" | "guaranteed" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:can | "likelihood" | "can" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:long | "likelihood" | "long" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:assured | "likelihood" | "assured" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:liable | "likelihood" | "liable" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:surely | "likelihood" | "surely" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:undoubtedly | "likelihood" | "undoubtedly" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:must | "likelihood" | "must" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | fn:HasLexicalUnit | fn:lu:likelihood:would | "likelihood" | "would" | "has lexical unit" |  | "FN" |  |
| fn:likelihood | /r/HasA | fn:fe:hypothetical_event | "likelihood" | "hypothetical event" | "/r/has a" |  | "FN" |  |
| fn:likelihood | /r/HasA | fn:fe:explanation | "likelihood" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:likelihood | /r/HasA | fn:fe:degree | "likelihood" | "degree" | "/r/has a" |  | "FN" |  |
| fn:likelihood | /r/HasA | fn:fe:place | "likelihood" | "place" | "/r/has a" |  | "FN" |  |
| fn:likelihood | /r/HasA | fn:fe:time | "likelihood" | "time" | "/r/has a" |  | "FN" |  |
| fn:likelihood | /r/HasA | fn:fe:circumstances | "likelihood" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:limiting | /r/UsedFor | fn:limitation | "limiting" | "limitation" | "/r/used for" |  | "FN" |  |
| fn:limiting | /r/Causes | fn:limitation | "limiting" | "limitation" | "/r/causes" |  | "FN" |  |
| fn:limitation | fn:HasLexicalUnit | fn:lu:limitation:limit | "limitation" | "limit" | "has lexical unit" |  | "FN" |  |
| fn:limitation | fn:HasLexicalUnit | fn:lu:limitation:limitation | "limitation" | "limitation" | "has lexical unit" |  | "FN" |  |
| fn:limitation | /r/HasA | fn:fe:entity | "limitation" | "entity" | "/r/has a" |  | "FN" |  |
| fn:limitation | /r/HasA | fn:fe:degree | "limitation" | "degree" | "/r/has a" |  | "FN" |  |
| fn:limiting | /r/IsA | fn:intentionally_affect | "limiting" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:limiting | /r/UsedFor | fn:limitation | "limiting" | "limitation" | "/r/used for" |  | "FN" |  |
| fn:limiting | /r/Causes | fn:limitation | "limiting" | "limitation" | "/r/causes" |  | "FN" |  |
| fn:limiting | fn:HasLexicalUnit | fn:lu:limiting:limit | "limiting" | "limit" | "has lexical unit" |  | "FN" |  |
| fn:limiting | /r/HasA | fn:fe:agent | "limiting" | "agent" | "/r/has a" |  | "FN" |  |
| fn:limiting | /r/HasA | fn:fe:cause | "limiting" | "cause" | "/r/has a" |  | "FN" |  |
| fn:limiting | /r/HasA | fn:fe:range_of_options | "limiting" | "range of options" | "/r/has a" |  | "FN" |  |
| fn:limiting | /r/HasA | fn:fe:degree | "limiting" | "degree" | "/r/has a" |  | "FN" |  |
| fn:limiting | /r/HasA | fn:fe:characteristic | "limiting" | "characteristic" | "/r/has a" |  | "FN" |  |
| fn:limiting | /r/HasA | fn:fe:time | "limiting" | "time" | "/r/has a" |  | "FN" |  |
| fn:limiting | /r/HasA | fn:fe:duration | "limiting" | "duration" | "/r/has a" |  | "FN" |  |
| fn:limiting | /r/HasA | fn:fe:manner | "limiting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:limiting | /r/HasA | fn:fe:place | "limiting" | "place" | "/r/has a" |  | "FN" |  |
| fn:limiting | /r/HasA | fn:fe:means | "limiting" | "means" | "/r/has a" |  | "FN" |  |
| fn:limiting | /r/HasA | fn:fe:purpose | "limiting" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:linguistic_meaning | /r/UsedFor | fn:word_relations | "linguistic meaning" | "word relations" | "/r/used for" |  | "FN" |  |
| fn:simple_name | /r/UsedFor | fn:linguistic_meaning | "simple name" | "linguistic meaning" | "/r/used for" |  | "FN" |  |
| fn:linguistic_meaning | fn:HasLexicalUnit | fn:lu:linguistic_meaning:denote | "linguistic meaning" | "denote" | "has lexical unit" |  | "FN" |  |
| fn:linguistic_meaning | fn:HasLexicalUnit | fn:lu:linguistic_meaning:denotation | "linguistic meaning" | "denotation" | "has lexical unit" |  | "FN" |  |
| fn:linguistic_meaning | fn:HasLexicalUnit | fn:lu:linguistic_meaning:ambiguous | "linguistic meaning" | "ambiguous" | "has lexical unit" |  | "FN" |  |
| fn:linguistic_meaning | fn:HasLexicalUnit | fn:lu:linguistic_meaning:polysemous | "linguistic meaning" | "polysemous" | "has lexical unit" |  | "FN" |  |
| fn:linguistic_meaning | fn:HasLexicalUnit | fn:lu:linguistic_meaning:monosemous | "linguistic meaning" | "monosemous" | "has lexical unit" |  | "FN" |  |
| fn:linguistic_meaning | fn:HasLexicalUnit | fn:lu:linguistic_meaning:vague | "linguistic meaning" | "vague" | "has lexical unit" |  | "FN" |  |
| fn:linguistic_meaning | fn:HasLexicalUnit | fn:lu:linguistic_meaning:designate | "linguistic meaning" | "designate" | "has lexical unit" |  | "FN" |  |
| fn:linguistic_meaning | fn:HasLexicalUnit | fn:lu:linguistic_meaning:intension | "linguistic meaning" | "intension" | "has lexical unit" |  | "FN" |  |
| fn:linguistic_meaning | fn:HasLexicalUnit | fn:lu:linguistic_meaning:extension | "linguistic meaning" | "extension" | "has lexical unit" |  | "FN" |  |
| fn:linguistic_meaning | fn:HasLexicalUnit | fn:lu:linguistic_meaning:meaning | "linguistic meaning" | "meaning" | "has lexical unit" |  | "FN" |  |
| fn:linguistic_meaning | fn:HasLexicalUnit | fn:lu:linguistic_meaning:mean | "linguistic meaning" | "mean" | "has lexical unit" |  | "FN" |  |
| fn:linguistic_meaning | fn:HasLexicalUnit | fn:lu:linguistic_meaning:referential | "linguistic meaning" | "referential" | "has lexical unit" |  | "FN" |  |
| fn:linguistic_meaning | fn:HasLexicalUnit | fn:lu:linguistic_meaning:non-referential | "linguistic meaning" | "non-referential" | "has lexical unit" |  | "FN" |  |
| fn:linguistic_meaning | fn:HasLexicalUnit | fn:lu:linguistic_meaning:sense | "linguistic meaning" | "sense" | "has lexical unit" |  | "FN" |  |
| fn:linguistic_meaning | fn:HasLexicalUnit | fn:lu:linguistic_meaning:reading | "linguistic meaning" | "reading" | "has lexical unit" |  | "FN" |  |
| fn:linguistic_meaning | /r/HasA | fn:fe:form | "linguistic meaning" | "form" | "/r/has a" |  | "FN" |  |
| fn:linguistic_meaning | /r/HasA | fn:fe:meaning | "linguistic meaning" | "meaning" | "/r/has a" |  | "FN" |  |
| fn:linguistic_meaning | /r/HasA | fn:fe:textual_location | "linguistic meaning" | "textual location" | "/r/has a" |  | "FN" |  |
| fn:linguistic_meaning | /r/HasA | fn:fe:referent | "linguistic meaning" | "referent" | "/r/has a" |  | "FN" |  |
| fn:linguistic_meaning | /r/HasA | fn:fe:degree | "linguistic meaning" | "degree" | "/r/has a" |  | "FN" |  |
| fn:lively_place | /r/IsA | fn:abounding_with | "lively place" | "abounding with" | "/r/is a" |  | "FN" |  |
| fn:lively_place | /r/IsA | fn:gradable_attributes | "lively place" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:activity_ongoing | /r/UsedFor | fn:lively_place | "activity ongoing" | "lively place" | "/r/used for" |  | "FN" |  |
| fn:lively_place | fn:HasLexicalUnit | fn:lu:lively_place:busy | "lively place" | "busy" | "has lexical unit" |  | "FN" |  |
| fn:lively_place | fn:HasLexicalUnit | fn:lu:lively_place:bustle | "lively place" | "bustle" | "has lexical unit" |  | "FN" |  |
| fn:lively_place | fn:HasLexicalUnit | fn:lu:lively_place:hum | "lively place" | "hum" | "has lexical unit" |  | "FN" |  |
| fn:lively_place | fn:HasLexicalUnit | fn:lu:lively_place:abuzz | "lively place" | "abuzz" | "has lexical unit" |  | "FN" |  |
| fn:lively_place | fn:HasLexicalUnit | fn:lu:lively_place:lively | "lively place" | "lively" | "has lexical unit" |  | "FN" |  |
| fn:lively_place | fn:HasLexicalUnit | fn:lu:lively_place:hectic | "lively place" | "hectic" | "has lexical unit" |  | "FN" |  |
| fn:lively_place | fn:HasLexicalUnit | fn:lu:lively_place:hopping | "lively place" | "hopping" | "has lexical unit" |  | "FN" |  |
| fn:lively_place | fn:HasLexicalUnit | fn:lu:lively_place:jumping | "lively place" | "jumping" | "has lexical unit" |  | "FN" |  |
| fn:lively_place | fn:HasLexicalUnit | fn:lu:lively_place:abustle | "lively place" | "abustle" | "has lexical unit" |  | "FN" |  |
| fn:lively_place | fn:HasLexicalUnit | fn:lu:lively_place:buzz | "lively place" | "buzz" | "has lexical unit" |  | "FN" |  |
| fn:lively_place | fn:HasLexicalUnit | fn:lu:lively_place:frenetic | "lively place" | "frenetic" | "has lexical unit" |  | "FN" |  |
| fn:lively_place | fn:HasLexicalUnit | fn:lu:lively_place:happening | "lively place" | "happening" | "has lexical unit" |  | "FN" |  |
| fn:lively_place | /r/HasA | fn:fe:location | "lively place" | "location" | "/r/has a" |  | "FN" |  |
| fn:lively_place | /r/HasA | fn:fe:degree | "lively place" | "degree" | "/r/has a" |  | "FN" |  |
| fn:lively_place | /r/HasA | fn:fe:time | "lively place" | "time" | "/r/has a" |  | "FN" |  |
| fn:lively_place | /r/HasA | fn:fe:circumstances | "lively place" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:lively_place | /r/HasA | fn:fe:place | "lively place" | "place" | "/r/has a" |  | "FN" |  |
| fn:lively_place | /r/HasA | fn:fe:activity | "lively place" | "activity" | "/r/has a" |  | "FN" |  |
| fn:lively_place | /r/HasA | fn:fe:individuals | "lively place" | "individuals" | "/r/has a" |  | "FN" |  |
| fn:lively_place | /r/HasA | fn:fe:duration | "lively place" | "duration" | "/r/has a" |  | "FN" |  |
| fn:lively_place | /r/HasA | fn:fe:manner | "lively place" | "manner" | "/r/has a" |  | "FN" |  |
| fn:lively_place | /r/HasA | fn:fe:explanation | "lively place" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:living_conditions | fn:HasLexicalUnit | fn:lu:living_conditions:live | "living conditions" | "live" | "has lexical unit" |  | "FN" |  |
| fn:living_conditions | /r/HasA | fn:fe:experiencer | "living conditions" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:living_conditions | /r/HasA | fn:fe:condition | "living conditions" | "condition" | "/r/has a" |  | "FN" |  |
| fn:living_conditions | /r/HasA | fn:fe:place | "living conditions" | "place" | "/r/has a" |  | "FN" |  |
| fn:living_conditions | /r/HasA | fn:fe:time | "living conditions" | "time" | "/r/has a" |  | "FN" |  |
| fn:living_conditions | /r/HasA | fn:fe:duration | "living conditions" | "duration" | "/r/has a" |  | "FN" |  |
| fn:assigned_location | /r/IsA | fn:locale | "assigned location" | "locale" | "/r/is a" |  | "FN" |  |
| fn:biological_area | /r/IsA | fn:locale | "biological area" | "locale" | "/r/is a" |  | "FN" |  |
| fn:locale_by_characteristic_entity | /r/IsA | fn:locale | "locale by characteristic entity" | "locale" | "/r/is a" |  | "FN" |  |
| fn:locale_by_ownership | /r/IsA | fn:locale | "locale by ownership" | "locale" | "/r/is a" |  | "FN" |  |
| fn:locale_by_use | /r/IsA | fn:locale | "locale by use" | "locale" | "/r/is a" |  | "FN" |  |
| fn:natural_features | /r/IsA | fn:locale | "natural features" | "locale" | "/r/is a" |  | "FN" |  |
| fn:relational_location | /r/IsA | fn:locale | "relational location" | "locale" | "/r/is a" |  | "FN" |  |
| fn:bounded_entity | /r/UsedFor | fn:locale | "bounded entity" | "locale" | "/r/used for" |  | "FN" |  |
| fn:locale | /r/UsedFor | fn:building_subparts | "locale" | "building subparts" | "/r/used for" |  | "FN" |  |
| fn:locale | /r/UsedFor | fn:isolated_places | "locale" | "isolated places" | "/r/used for" |  | "FN" |  |
| fn:locale | fn:HasLexicalUnit | fn:lu:locale:area | "locale" | "area" | "has lexical unit" |  | "FN" |  |
| fn:locale | fn:HasLexicalUnit | fn:lu:locale:zone | "locale" | "zone" | "has lexical unit" |  | "FN" |  |
| fn:locale | fn:HasLexicalUnit | fn:lu:locale:region | "locale" | "region" | "has lexical unit" |  | "FN" |  |
| fn:locale | fn:HasLexicalUnit | fn:lu:locale:place | "locale" | "place" | "has lexical unit" |  | "FN" |  |
| fn:locale | fn:HasLexicalUnit | fn:lu:locale:spot | "locale" | "spot" | "has lexical unit" |  | "FN" |  |
| fn:locale | fn:HasLexicalUnit | fn:lu:locale:location | "locale" | "location" | "has lexical unit" |  | "FN" |  |
| fn:locale | fn:HasLexicalUnit | fn:lu:locale:locale | "locale" | "locale" | "has lexical unit" |  | "FN" |  |
| fn:locale | fn:HasLexicalUnit | fn:lu:locale:pocket | "locale" | "pocket" | "has lexical unit" |  | "FN" |  |
| fn:locale | fn:HasLexicalUnit | fn:lu:locale:regional | "locale" | "regional" | "has lexical unit" |  | "FN" |  |
| fn:locale | fn:HasLexicalUnit | fn:lu:locale:site | "locale" | "site" | "has lexical unit" |  | "FN" |  |
| fn:locale | fn:HasLexicalUnit | fn:lu:locale:point | "locale" | "point" | "has lexical unit" |  | "FN" |  |
| fn:locale | fn:HasLexicalUnit | fn:lu:locale:grounds | "locale" | "grounds" | "has lexical unit" |  | "FN" |  |
| fn:locale | fn:HasLexicalUnit | fn:lu:locale:earth | "locale" | "earth" | "has lexical unit" |  | "FN" |  |
| fn:locale | /r/HasA | fn:fe:locale | "locale" | "locale" | "/r/has a" |  | "FN" |  |
| fn:locale | /r/HasA | fn:fe:constituent_parts | "locale" | "constituent parts" | "/r/has a" |  | "FN" |  |
| fn:locale | /r/HasA | fn:fe:relative_location | "locale" | "relative location" | "/r/has a" |  | "FN" |  |
| fn:locale | /r/HasA | fn:fe:formational_cause | "locale" | "formational cause" | "/r/has a" |  | "FN" |  |
| fn:locale | /r/HasA | fn:fe:container_possessor | "locale" | "container possessor" | "/r/has a" |  | "FN" |  |
| fn:locale | /r/HasA | fn:fe:name | "locale" | "name" | "/r/has a" |  | "FN" |  |
| fn:locale | /r/HasA | fn:fe:descriptor | "locale" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:locale | /r/HasA | fn:fe:related_event | "locale" | "related event" | "/r/has a" |  | "FN" |  |
| fn:locale | /r/HasA | fn:fe:inherent_purpose | "locale" | "inherent purpose" | "/r/has a" |  | "FN" |  |
| fn:locale_by_characteristic_entity | /r/IsA | fn:locale | "locale by characteristic entity" | "locale" | "/r/is a" |  | "FN" |  |
| fn:locale_by_characteristic_entity | fn:HasLexicalUnit | fn:lu:locale_by_characteristic_entity:quarter | "locale by characteristic entity" | "quarter" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_characteristic_entity | fn:HasLexicalUnit | fn:lu:locale_by_characteristic_entity:enclave | "locale by characteristic entity" | "enclave" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_characteristic_entity | fn:HasLexicalUnit | fn:lu:locale_by_characteristic_entity:belt | "locale by characteristic entity" | "belt" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_characteristic_entity | /r/HasA | fn:fe:locale | "locale by characteristic entity" | "locale" | "/r/has a" |  | "FN" |  |
| fn:locale_by_characteristic_entity | /r/HasA | fn:fe:constituent_parts | "locale by characteristic entity" | "constituent parts" | "/r/has a" |  | "FN" |  |
| fn:locale_by_characteristic_entity | /r/HasA | fn:fe:relative_location | "locale by characteristic entity" | "relative location" | "/r/has a" |  | "FN" |  |
| fn:locale_by_characteristic_entity | /r/HasA | fn:fe:formational_cause | "locale by characteristic entity" | "formational cause" | "/r/has a" |  | "FN" |  |
| fn:locale_by_characteristic_entity | /r/HasA | fn:fe:container_possessor | "locale by characteristic entity" | "container possessor" | "/r/has a" |  | "FN" |  |
| fn:locale_by_characteristic_entity | /r/HasA | fn:fe:descriptor | "locale by characteristic entity" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:locale_by_characteristic_entity | /r/HasA | fn:fe:related_event | "locale by characteristic entity" | "related event" | "/r/has a" |  | "FN" |  |
| fn:locale_by_characteristic_entity | /r/HasA | fn:fe:inherent_purpose | "locale by characteristic entity" | "inherent purpose" | "/r/has a" |  | "FN" |  |
| fn:locale_by_characteristic_entity | /r/HasA | fn:fe:characteristic | "locale by characteristic entity" | "characteristic" | "/r/has a" |  | "FN" |  |
| fn:locale_by_event | /r/IsA | fn:locale_by_collocation | "locale by event" | "locale by collocation" | "/r/is a" |  | "FN" |  |
| fn:locale_by_collocation | /r/IsA | fn:relational_location | "locale by collocation" | "relational location" | "/r/is a" |  | "FN" |  |
| fn:locale_by_collocation | fn:HasLexicalUnit | fn:lu:locale_by_collocation:position | "locale by collocation" | "position" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_collocation | fn:HasLexicalUnit | fn:lu:locale_by_collocation:location | "locale by collocation" | "location" | "has lexical unit" |  | "FN" |  |
| fn:fe:profiled_region | /r/IsA | fn:st:location | "profiled region" | "location" | "/r/is a" |  | "FN" |  |
| fn:locale_by_collocation | /r/HasA | fn:fe:profiled_region | "locale by collocation" | "profiled region" | "/r/has a" |  | "FN" |  |
| fn:locale_by_collocation | /r/HasA | fn:fe:constituent_parts | "locale by collocation" | "constituent parts" | "/r/has a" |  | "FN" |  |
| fn:locale_by_collocation | /r/HasA | fn:fe:relative_location | "locale by collocation" | "relative location" | "/r/has a" |  | "FN" |  |
| fn:locale_by_collocation | /r/HasA | fn:fe:formational_cause | "locale by collocation" | "formational cause" | "/r/has a" |  | "FN" |  |
| fn:locale_by_collocation | /r/HasA | fn:fe:container_possessor | "locale by collocation" | "container possessor" | "/r/has a" |  | "FN" |  |
| fn:locale_by_collocation | /r/HasA | fn:fe:descriptor | "locale by collocation" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:locale_by_collocation | /r/HasA | fn:fe:related_event | "locale by collocation" | "related event" | "/r/has a" |  | "FN" |  |
| fn:locale_by_collocation | /r/HasA | fn:fe:inherent_purpose | "locale by collocation" | "inherent purpose" | "/r/has a" |  | "FN" |  |
| fn:locale_by_collocation | /r/HasA | fn:fe:entity | "locale by collocation" | "entity" | "/r/has a" |  | "FN" |  |
| fn:locale_by_collocation | /r/HasA | fn:fe:time | "locale by collocation" | "time" | "/r/has a" |  | "FN" |  |
| fn:locale_by_event | /r/IsA | fn:locale_by_collocation | "locale by event" | "locale by collocation" | "/r/is a" |  | "FN" |  |
| fn:firing_point | /r/IsA | fn:locale_by_event | "firing point" | "locale by event" | "/r/is a" |  | "FN" |  |
| fn:event | /r/UsedFor | fn:locale_by_event | "event" | "locale by event" | "/r/used for" |  | "FN" |  |
| fn:locale_by_event | fn:HasLexicalUnit | fn:lu:locale_by_event:site | "locale by event" | "site" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_event | fn:HasLexicalUnit | fn:lu:locale_by_event:scene | "locale by event" | "scene" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_event | fn:HasLexicalUnit | fn:lu:locale_by_event:venue | "locale by event" | "venue" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_event | fn:HasLexicalUnit | fn:lu:locale_by_event:theater_[of_war] | "locale by event" | "theater [of war]" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_event | fn:HasLexicalUnit | fn:lu:locale_by_event:field | "locale by event" | "field" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_event | fn:HasLexicalUnit | fn:lu:locale_by_event:battlefield | "locale by event" | "battlefield" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_event | /r/HasA | fn:fe:locale | "locale by event" | "locale" | "/r/has a" |  | "FN" |  |
| fn:locale_by_event | /r/HasA | fn:fe:constituent_parts | "locale by event" | "constituent parts" | "/r/has a" |  | "FN" |  |
| fn:locale_by_event | /r/HasA | fn:fe:relative_location | "locale by event" | "relative location" | "/r/has a" |  | "FN" |  |
| fn:locale_by_event | /r/HasA | fn:fe:defining_event | "locale by event" | "defining event" | "/r/has a" |  | "FN" |  |
| fn:locale_by_event | /r/HasA | fn:fe:descriptor | "locale by event" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:locale_by_event | /r/HasA | fn:fe:name | "locale by event" | "name" | "/r/has a" |  | "FN" |  |
| fn:locale_by_ownership | /r/IsA | fn:locale | "locale by ownership" | "locale" | "/r/is a" |  | "FN" |  |
| fn:political_locales | /r/IsA | fn:locale_by_ownership | "political locales" | "locale by ownership" | "/r/is a" |  | "FN" |  |
| fn:possession | /r/UsedFor | fn:locale_by_ownership | "possession" | "locale by ownership" | "/r/used for" |  | "FN" |  |
| fn:locale_by_ownership | fn:HasLexicalUnit | fn:lu:locale_by_ownership:land | "locale by ownership" | "land" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_ownership | fn:HasLexicalUnit | fn:lu:locale_by_ownership:property | "locale by ownership" | "property" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_ownership | fn:HasLexicalUnit | fn:lu:locale_by_ownership:estate | "locale by ownership" | "estate" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_ownership | /r/HasA | fn:fe:locale | "locale by ownership" | "locale" | "/r/has a" |  | "FN" |  |
| fn:locale_by_ownership | /r/HasA | fn:fe:relative_location | "locale by ownership" | "relative location" | "/r/has a" |  | "FN" |  |
| fn:locale_by_ownership | /r/HasA | fn:fe:owner | "locale by ownership" | "owner" | "/r/has a" |  | "FN" |  |
| fn:locale_by_ownership | /r/HasA | fn:fe:constituent_parts | "locale by ownership" | "constituent parts" | "/r/has a" |  | "FN" |  |
| fn:locale_by_ownership | /r/HasA | fn:fe:descriptor | "locale by ownership" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:locale_by_ownership | /r/HasA | fn:fe:container_possessor | "locale by ownership" | "container possessor" | "/r/has a" |  | "FN" |  |
| fn:locale_by_ownership | /r/HasA | fn:fe:name | "locale by ownership" | "name" | "/r/has a" |  | "FN" |  |
| fn:locale_by_ownership | /r/HasA | fn:fe:inherent_purpose | "locale by ownership" | "inherent purpose" | "/r/has a" |  | "FN" |  |
| fn:locale_by_use | /r/IsA | fn:locale | "locale by use" | "locale" | "/r/is a" |  | "FN" |  |
| fn:prison | /r/IsA | fn:locale_by_use | "prison" | "locale by use" | "/r/is a" |  | "FN" |  |
| fn:roadways | /r/IsA | fn:locale_by_use | "roadways" | "locale by use" | "/r/is a" |  | "FN" |  |
| fn:locale_by_use | /r/UsedFor | fn:buildings | "locale by use" | "buildings" | "/r/used for" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:farm | "locale by use" | "farm" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:hedge | "locale by use" | "hedge" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:mine | "locale by use" | "mine" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:field | "locale by use" | "field" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:airfield | "locale by use" | "airfield" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:cemetery | "locale by use" | "cemetery" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:rural | "locale by use" | "rural" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:country | "locale by use" | "country" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:countryside | "locale by use" | "countryside" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:urban | "locale by use" | "urban" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:city | "locale by use" | "city" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:village | "locale by use" | "village" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:center | "locale by use" | "center" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:facility | "locale by use" | "facility" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:complex | "locale by use" | "complex" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:installation | "locale by use" | "installation" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:reactor | "locale by use" | "reactor" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:harbor | "locale by use" | "harbor" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:lab | "locale by use" | "lab" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:plant | "locale by use" | "plant" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:laboratory | "locale by use" | "laboratory" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:depot | "locale by use" | "depot" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:site | "locale by use" | "site" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:school | "locale by use" | "school" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:university | "locale by use" | "university" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:factory | "locale by use" | "factory" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:silo | "locale by use" | "silo" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:parking_lot | "locale by use" | "parking lot" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:base | "locale by use" | "base" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:settlement | "locale by use" | "settlement" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:courtyard | "locale by use" | "courtyard" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:institute | "locale by use" | "institute" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:pub | "locale by use" | "pub" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:restaurant | "locale by use" | "restaurant" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:museum | "locale by use" | "museum" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:gallery | "locale by use" | "gallery" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:garden | "locale by use" | "garden" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:park | "locale by use" | "park" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:square | "locale by use" | "square" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:theater | "locale by use" | "theater" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:shop | "locale by use" | "shop" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:college | "locale by use" | "college" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:open_space | "locale by use" | "open space" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:post_office | "locale by use" | "post office" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:canal | "locale by use" | "canal" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:green | "locale by use" | "green" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:park[2] | "locale by use" | "park[2]" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:ranch | "locale by use" | "ranch" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:headquarters | "locale by use" | "headquarters" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:downtown | "locale by use" | "downtown" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:campus | "locale by use" | "campus" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:zoo | "locale by use" | "zoo" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:port | "locale by use" | "port" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:work | "locale by use" | "work" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:court | "locale by use" | "court" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:range | "locale by use" | "range" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:compound | "locale by use" | "compound" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:station | "locale by use" | "station" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:firehouse | "locale by use" | "firehouse" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:bathhouse | "locale by use" | "bathhouse" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:development | "locale by use" | "development" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:plantation | "locale by use" | "plantation" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:safe_house | "locale by use" | "safe house" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | fn:HasLexicalUnit | fn:lu:locale_by_use:boutique | "locale by use" | "boutique" | "has lexical unit" |  | "FN" |  |
| fn:locale_by_use | /r/HasA | fn:fe:constituent_parts | "locale by use" | "constituent parts" | "/r/has a" |  | "FN" |  |
| fn:locale_by_use | /r/HasA | fn:fe:container_possessor | "locale by use" | "container possessor" | "/r/has a" |  | "FN" |  |
| fn:locale_by_use | /r/HasA | fn:fe:formational_cause | "locale by use" | "formational cause" | "/r/has a" |  | "FN" |  |
| fn:locale_by_use | /r/HasA | fn:fe:locale | "locale by use" | "locale" | "/r/has a" |  | "FN" |  |
| fn:locale_by_use | /r/HasA | fn:fe:name | "locale by use" | "name" | "/r/has a" |  | "FN" |  |
| fn:locale_by_use | /r/HasA | fn:fe:relative_location | "locale by use" | "relative location" | "/r/has a" |  | "FN" |  |
| fn:locale_by_use | /r/HasA | fn:fe:use | "locale by use" | "use" | "/r/has a" |  | "FN" |  |
| fn:locale_by_use | /r/HasA | fn:fe:descriptor | "locale by use" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:locale_by_use | /r/HasA | fn:fe:circumstances | "locale by use" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:business_closure | /r/IsA | fn:locale_closure | "business closure" | "locale closure" | "/r/is a" |  | "FN" |  |
| fn:endeavor_failure | /r/RelatedTo | fn:locale_closure | "endeavor failure" | "locale closure" | "/r/related to" |  | "FN" |  |
| fn:locale_closure | fn:HasLexicalUnit | fn:lu:locale_closure:close | "locale closure" | "close" | "has lexical unit" |  | "FN" |  |
| fn:locale_closure | fn:HasLexicalUnit | fn:lu:locale_closure:shut_down | "locale closure" | "shut down" | "has lexical unit" |  | "FN" |  |
| fn:locale_closure | /r/HasA | fn:fe:locale | "locale closure" | "locale" | "/r/has a" |  | "FN" |  |
| fn:locale_closure | /r/HasA | fn:fe:explanation | "locale closure" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:locale_closure | /r/HasA | fn:fe:containing_event | "locale closure" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:locale_closure | /r/HasA | fn:fe:depictive | "locale closure" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:locale_closure | /r/HasA | fn:fe:time | "locale closure" | "time" | "/r/has a" |  | "FN" |  |
| fn:locale_closure | /r/HasA | fn:fe:manner | "locale closure" | "manner" | "/r/has a" |  | "FN" |  |
| fn:locale_closure | /r/HasA | fn:fe:circumstances | "locale closure" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:locale_closure | /r/HasA | fn:fe:place | "locale closure" | "place" | "/r/has a" |  | "FN" |  |
| fn:locale_closure | /r/HasA | fn:fe:duration | "locale closure" | "duration" | "/r/has a" |  | "FN" |  |
| fn:seeking | /r/UsedFor | fn:locating | "seeking" | "locating" | "/r/used for" |  | "FN" |  |
| fn:locating | fn:HasLexicalUnit | fn:lu:locating:locate | "locating" | "locate" | "has lexical unit" |  | "FN" |  |
| fn:locating | fn:HasLexicalUnit | fn:lu:locating:find | "locating" | "find" | "has lexical unit" |  | "FN" |  |
| fn:locating | /r/HasA | fn:fe:perceiver | "locating" | "perceiver" | "/r/has a" |  | "FN" |  |
| fn:fe:sought_entity | /r/IsA | fn:st:physical_entity | "sought entity" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:locating | /r/HasA | fn:fe:sought_entity | "locating" | "sought entity" | "/r/has a" |  | "FN" |  |
| fn:locating | /r/HasA | fn:fe:location | "locating" | "location" | "/r/has a" |  | "FN" |  |
| fn:locating | /r/HasA | fn:fe:ground | "locating" | "ground" | "/r/has a" |  | "FN" |  |
| fn:locating | /r/HasA | fn:fe:time | "locating" | "time" | "/r/has a" |  | "FN" |  |
| fn:calendric_unit | /r/IsA | fn:location_in_time | "calendric unit" | "location in time" | "/r/is a" |  | "FN" |  |
| fn:location_in_time | /r/IsA | fn:simultaneity | "location in time" | "simultaneity" | "/r/is a" |  | "FN" |  |
| fn:location_in_time | fn:HasLexicalUnit | fn:lu:location_in_time:time | "location in time" | "time" | "has lexical unit" |  | "FN" |  |
| fn:location_in_time | fn:HasLexicalUnit | fn:lu:location_in_time:date | "location in time" | "date" | "has lexical unit" |  | "FN" |  |
| fn:location_in_time | fn:HasLexicalUnit | fn:lu:location_in_time:day | "location in time" | "day" | "has lexical unit" |  | "FN" |  |
| fn:location_in_time | /r/HasA | fn:fe:relative_time | "location in time" | "relative time" | "/r/has a" |  | "FN" |  |
| fn:location_in_time | /r/HasA | fn:fe:name | "location in time" | "name" | "/r/has a" |  | "FN" |  |
| fn:location_in_time | /r/HasA | fn:fe:whole | "location in time" | "whole" | "/r/has a" |  | "FN" |  |
| fn:location_in_time | /r/HasA | fn:fe:focal_time | "location in time" | "focal time" | "/r/has a" |  | "FN" |  |
| fn:location_in_time | /r/HasA | fn:fe:salient_event | "location in time" | "salient event" | "/r/has a" |  | "FN" |  |
| fn:location_in_time | /r/HasA | fn:fe:descriptor | "location in time" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:location_of_light | /r/IsA | fn:measurable_attributes | "location of light" | "measurable attributes" | "/r/is a" |  | "FN" |  |
| fn:perception | /r/UsedFor | fn:location_of_light | "perception" | "location of light" | "/r/used for" |  | "FN" |  |
| fn:location_of_light | /r/RelatedTo | fn:light_movement | "location of light" | "light movement" | "/r/related to" |  | "FN" |  |
| fn:location_of_light | /r/SimilarTo | fn:light_movement | "location of light" | "light movement" | "/r/similar to" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:glow | "location of light" | "glow" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:glisten | "location of light" | "glisten" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:glimmer | "location of light" | "glimmer" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:twinkle | "location of light" | "twinkle" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:shimmer | "location of light" | "shimmer" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:glint | "location of light" | "glint" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:flash | "location of light" | "flash" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:sparkle | "location of light" | "sparkle" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:gleam | "location of light" | "gleam" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:glitter | "location of light" | "glitter" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:shine | "location of light" | "shine" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:flicker | "location of light" | "flicker" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:coruscate | "location of light" | "coruscate" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:flame | "location of light" | "flame" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:scintillate | "location of light" | "scintillate" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:flare | "location of light" | "flare" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:glint | "location of light" | "glint" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:gleam | "location of light" | "gleam" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:glimmer | "location of light" | "glimmer" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:flicker | "location of light" | "flicker" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:coruscation | "location of light" | "coruscation" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:scintillation | "location of light" | "scintillation" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:glitter | "location of light" | "glitter" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:glow | "location of light" | "glow" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:twinkle | "location of light" | "twinkle" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:flashing | "location of light" | "flashing" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:gleaming | "location of light" | "gleaming" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:glittering | "location of light" | "glittering" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:flash | "location of light" | "flash" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:glistening | "location of light" | "glistening" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:shining | "location of light" | "shining" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:shine | "location of light" | "shine" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:sheen | "location of light" | "sheen" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:lustre | "location of light" | "lustre" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:lambent | "location of light" | "lambent" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:refulgent | "location of light" | "refulgent" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:lambency | "location of light" | "lambency" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:refulgence | "location of light" | "refulgence" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:bright | "location of light" | "bright" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:brilliant | "location of light" | "brilliant" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:glossy | "location of light" | "glossy" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:shiny | "location of light" | "shiny" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:glister | "location of light" | "glister" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:glister | "location of light" | "glister" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:light | "location of light" | "light" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:light_up | "location of light" | "light up" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | fn:HasLexicalUnit | fn:lu:location_of_light:illuminate | "location of light" | "illuminate" | "has lexical unit" |  | "FN" |  |
| fn:location_of_light | /r/HasA | fn:fe:degree | "location of light" | "degree" | "/r/has a" |  | "FN" |  |
| fn:location_of_light | /r/HasA | fn:fe:depictive | "location of light" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:location_of_light | /r/HasA | fn:fe:manner | "location of light" | "manner" | "/r/has a" |  | "FN" |  |
| fn:location_of_light | /r/HasA | fn:fe:figure | "location of light" | "figure" | "/r/has a" |  | "FN" |  |
| fn:location_of_light | /r/HasA | fn:fe:ground | "location of light" | "ground" | "/r/has a" |  | "FN" |  |
| fn:location_of_light | /r/HasA | fn:fe:result | "location of light" | "result" | "/r/has a" |  | "FN" |  |
| fn:location_of_light | /r/HasA | fn:fe:cause_of_shine | "location of light" | "cause of shine" | "/r/has a" |  | "FN" |  |
| fn:location_of_light | /r/HasA | fn:fe:light | "location of light" | "light" | "/r/has a" |  | "FN" |  |
| fn:location_of_light | /r/HasA | fn:fe:duration | "location of light" | "duration" | "/r/has a" |  | "FN" |  |
| fn:location_of_light | /r/HasA | fn:fe:place | "location of light" | "place" | "/r/has a" |  | "FN" |  |
| fn:location_of_light | /r/HasA | fn:fe:time | "location of light" | "time" | "/r/has a" |  | "FN" |  |
| fn:location_on_path | /r/IsA | fn:locative_relation | "location on path" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:location_on_path | /r/HasA | fn:fe:ground | "location on path" | "ground" | "/r/has a" |  | "FN" |  |
| fn:location_on_path | /r/HasA | fn:fe:figure | "location on path" | "figure" | "/r/has a" |  | "FN" |  |
| fn:location_on_path | /r/HasA | fn:fe:distance | "location on path" | "distance" | "/r/has a" |  | "FN" |  |
| fn:location_on_path | /r/HasA | fn:fe:direction | "location on path" | "direction" | "/r/has a" |  | "FN" |  |
| fn:location_on_path | /r/HasA | fn:fe:time | "location on path" | "time" | "/r/has a" |  | "FN" |  |
| fn:location_on_path | /r/HasA | fn:fe:figures | "location on path" | "figures" | "/r/has a" |  | "FN" |  |
| fn:location_on_path | /r/HasA | fn:fe:deixis | "location on path" | "deixis" | "/r/has a" |  | "FN" |  |
| fn:location_on_path | /r/HasA | fn:fe:accessibility | "location on path" | "accessibility" | "/r/has a" |  | "FN" |  |
| fn:location_on_path | /r/HasA | fn:fe:directness | "location on path" | "directness" | "/r/has a" |  | "FN" |  |
| fn:location_on_path | /r/HasA | fn:fe:temporal_profile | "location on path" | "temporal profile" | "/r/has a" |  | "FN" |  |
| fn:location_on_path | /r/HasA | fn:fe:region_quantification | "location on path" | "region quantification" | "/r/has a" |  | "FN" |  |
| fn:location_on_path | /r/HasA | fn:fe:profiled_region | "location on path" | "profiled region" | "/r/has a" |  | "FN" |  |
| fn:locative_relation | /r/IsA | fn:basis_for_attribute | "locative relation" | "basis for attribute" | "/r/is a" |  | "FN" |  |
| fn:abounding_with | /r/IsA | fn:locative_relation | "abounding with" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:adjacency | /r/IsA | fn:locative_relation | "adjacency" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:containing | /r/IsA | fn:locative_relation | "containing" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:directional_locative_relation | /r/IsA | fn:locative_relation | "directional locative relation" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:distributed_position | /r/IsA | fn:locative_relation | "distributed position" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:expected_location_of_person | /r/IsA | fn:locative_relation | "expected location of person" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:goal | /r/IsA | fn:locative_relation | "goal" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:gradable_proximity | /r/IsA | fn:locative_relation | "gradable proximity" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:interior_profile_relation | /r/IsA | fn:locative_relation | "interior profile relation" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:location_on_path | /r/IsA | fn:locative_relation | "location on path" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:non-gradable_proximity | /r/IsA | fn:locative_relation | "non-gradable proximity" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:spatial_co-location | /r/IsA | fn:locative_relation | "spatial co-location" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:spatial_contact | /r/IsA | fn:locative_relation | "spatial contact" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:within_distance | /r/IsA | fn:locative_relation | "within distance" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:locative_relation | /r/IsA | fn:state | "locative relation" | "state" | "/r/is a" |  | "FN" |  |
| fn:existence | /r/UsedFor | fn:locative_relation | "existence" | "locative relation" | "/r/used for" |  | "FN" |  |
| fn:locative_relation | /r/UsedFor | fn:being_located | "locative relation" | "being located" | "/r/used for" |  | "FN" |  |
| fn:locative_relation | /r/UsedFor | fn:path_shape | "locative relation" | "path shape" | "/r/used for" |  | "FN" |  |
| fn:locative_relation | /r/UsedFor | fn:relational_natural_features | "locative relation" | "relational natural features" | "/r/used for" |  | "FN" |  |
| fn:locative_relation | /r/SimilarTo | fn:adjacency | "locative relation" | "adjacency" | "/r/similar to" |  | "FN" |  |
| fn:locative_relation | /r/SimilarTo | fn:interior_profile_relation | "locative relation" | "interior profile relation" | "/r/similar to" |  | "FN" |  |
| fn:locative_relation | /r/SimilarTo | fn:non-gradable_proximity | "locative relation" | "non-gradable proximity" | "/r/similar to" |  | "FN" |  |
| fn:locative_relation | /r/SimilarTo | fn:spatial_contact | "locative relation" | "spatial contact" | "/r/similar to" |  | "FN" |  |
| fn:locative_relation | /r/IsA | fn:locative_scenario | "locative relation" | "locative scenario" | "/r/is a" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:at | "locative relation" | "at" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:athwart | "locative relation" | "athwart" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:over | "locative relation" | "over" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:beyond | "locative relation" | "beyond" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:along | "locative relation" | "along" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:up | "locative relation" | "up" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:down | "locative relation" | "down" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:astride | "locative relation" | "astride" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:all_over | "locative relation" | "all over" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:border | "locative relation" | "border" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:where | "locative relation" | "where" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:near | "locative relation" | "near" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:underground | "locative relation" | "underground" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:above-ground | "locative relation" | "above-ground" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:underground | "locative relation" | "underground" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:everywhere | "locative relation" | "everywhere" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:elsewhere | "locative relation" | "elsewhere" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:here | "locative relation" | "here" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:surrounding | "locative relation" | "surrounding" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:distant | "locative relation" | "distant" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:outlying | "locative relation" | "outlying" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:north | "locative relation" | "north" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:south | "locative relation" | "south" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:out | "locative relation" | "out" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:west | "locative relation" | "west" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:ubiquitous | "locative relation" | "ubiquitous" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:there | "locative relation" | "there" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:offshore | "locative relation" | "offshore" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:inland | "locative relation" | "inland" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:past | "locative relation" | "past" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:to | "locative relation" | "to" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:southeast | "locative relation" | "southeast" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:mainland | "locative relation" | "mainland" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:throughout | "locative relation" | "throughout" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:meet | "locative relation" | "meet" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:bracket | "locative relation" | "bracket" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:southwest | "locative relation" | "southwest" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:northeast | "locative relation" | "northeast" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | fn:HasLexicalUnit | fn:lu:locative_relation:northwest | "locative relation" | "northwest" | "has lexical unit" |  | "FN" |  |
| fn:locative_relation | /r/HasA | fn:fe:ground | "locative relation" | "ground" | "/r/has a" |  | "FN" |  |
| fn:locative_relation | /r/HasA | fn:fe:figure | "locative relation" | "figure" | "/r/has a" |  | "FN" |  |
| fn:locative_relation | /r/HasA | fn:fe:distance | "locative relation" | "distance" | "/r/has a" |  | "FN" |  |
| fn:locative_relation | /r/HasA | fn:fe:direction | "locative relation" | "direction" | "/r/has a" |  | "FN" |  |
| fn:locative_relation | /r/HasA | fn:fe:time | "locative relation" | "time" | "/r/has a" |  | "FN" |  |
| fn:fe:figures | /r/RelatedTo | fn:fe:profiled_region | "figures" | "profiled region" | "/r/related to" |  | "FN" |  |
| fn:locative_relation | /r/HasA | fn:fe:figures | "locative relation" | "figures" | "/r/has a" |  | "FN" |  |
| fn:locative_relation | /r/HasA | fn:fe:deixis | "locative relation" | "deixis" | "/r/has a" |  | "FN" |  |
| fn:locative_relation | /r/HasA | fn:fe:accessibility | "locative relation" | "accessibility" | "/r/has a" |  | "FN" |  |
| fn:locative_relation | /r/HasA | fn:fe:directness | "locative relation" | "directness" | "/r/has a" |  | "FN" |  |
| fn:locative_relation | /r/HasA | fn:fe:temporal_profile | "locative relation" | "temporal profile" | "/r/has a" |  | "FN" |  |
| fn:locative_relation | /r/HasA | fn:fe:region_quantification | "locative relation" | "region quantification" | "/r/has a" |  | "FN" |  |
| fn:fe:profiled_region | /r/RelatedTo | fn:fe:figure | "profiled region" | "figure" | "/r/related to" |  | "FN" |  |
| fn:locative_relation | /r/HasA | fn:fe:profiled_region | "locative relation" | "profiled region" | "/r/has a" |  | "FN" |  |
| fn:locative_relation | /r/IsA | fn:locative_scenario | "locative relation" | "locative scenario" | "/r/is a" |  | "FN" |  |
| fn:locative_scenario | /r/HasA | fn:fe:figure | "locative scenario" | "figure" | "/r/has a" |  | "FN" |  |
| fn:locative_scenario | /r/HasA | fn:fe:ground | "locative scenario" | "ground" | "/r/has a" |  | "FN" |  |
| fn:locative_scenario | /r/HasA | fn:fe:figures | "locative scenario" | "figures" | "/r/has a" |  | "FN" |  |
| fn:locative_scenario | /r/HasA | fn:fe:profiled_region | "locative scenario" | "profiled region" | "/r/has a" |  | "FN" |  |
| fn:guest_and_host | /r/UsedFor | fn:lodging_scenario | "guest and host" | "lodging scenario" | "/r/used for" |  | "FN" |  |
| fn:provide_lodging | /r/IsA | fn:lodging_scenario | "provide lodging" | "lodging scenario" | "/r/is a" |  | "FN" |  |
| fn:temporary_stay | /r/IsA | fn:lodging_scenario | "temporary stay" | "lodging scenario" | "/r/is a" |  | "FN" |  |
| fn:fe:host | /r/IsA | fn:st:sentient | "host" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:lodging_scenario | /r/HasA | fn:fe:host | "lodging scenario" | "host" | "/r/has a" |  | "FN" |  |
| fn:fe:lodger | /r/IsA | fn:st:sentient | "lodger" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:lodging_scenario | /r/HasA | fn:fe:lodger | "lodging scenario" | "lodger" | "/r/has a" |  | "FN" |  |
| fn:lodging_scenario | /r/HasA | fn:fe:time | "lodging scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:lodging_scenario | /r/HasA | fn:fe:place | "lodging scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:lodging_scenario | /r/HasA | fn:fe:residence | "lodging scenario" | "residence" | "/r/has a" |  | "FN" |  |
| fn:lose_possession | /r/IsA | fn:eventive_affecting | "lose possession" | "eventive affecting" | "/r/is a" |  | "FN" |  |
| fn:giving | /r/IsA | fn:lose_possession | "giving" | "lose possession" | "/r/is a" |  | "FN" |  |
| fn:lose_possession_scenario | /r/HasSubevent | fn:lose_possession | "lose possession scenario" | "lose possession" | "/r/has subevent" |  | "FN" |  |
| fn:post_lose_possession | /r/HasPrerequisite | fn:lose_possession | "post lose possession" | "lose possession" | "/r/has prerequisite" |  | "FN" |  |
| fn:lose_possession | /r/HasPrerequisite | fn:pre_lose_possession | "lose possession" | "pre lose possession" | "/r/has prerequisite" |  | "FN" |  |
| fn:lose_possession | /r/HasA | fn:fe:place | "lose possession" | "place" | "/r/has a" |  | "FN" |  |
| fn:lose_possession | /r/HasA | fn:fe:explanation | "lose possession" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:lose_possession | /r/HasA | fn:fe:time | "lose possession" | "time" | "/r/has a" |  | "FN" |  |
| fn:lose_possession | /r/HasA | fn:fe:donor | "lose possession" | "donor" | "/r/has a" |  | "FN" |  |
| fn:lose_possession | /r/HasA | fn:fe:theme | "lose possession" | "theme" | "/r/has a" |  | "FN" |  |
| fn:lose_possession | /r/HasA | fn:fe:purpose | "lose possession" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:lose_possession | /r/HasA | fn:fe:recipient | "lose possession" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:giving_scenario | /r/IsA | fn:lose_possession_scenario | "giving scenario" | "lose possession scenario" | "/r/is a" |  | "FN" |  |
| fn:lose_possession_scenario | /r/HasSubevent | fn:lose_possession | "lose possession scenario" | "lose possession" | "/r/has subevent" |  | "FN" |  |
| fn:lose_possession_scenario | /r/HasSubevent | fn:post_lose_possession | "lose possession scenario" | "post lose possession" | "/r/has subevent" |  | "FN" |  |
| fn:lose_possession_scenario | /r/HasSubevent | fn:pre_lose_possession | "lose possession scenario" | "pre lose possession" | "/r/has subevent" |  | "FN" |  |
| fn:lose_possession_scenario | /r/HasA | fn:fe:donor | "lose possession scenario" | "donor" | "/r/has a" |  | "FN" |  |
| fn:lose_possession_scenario | /r/HasA | fn:fe:theme | "lose possession scenario" | "theme" | "/r/has a" |  | "FN" |  |
| fn:losing | /r/IsA | fn:losing_track_of_theme | "losing" | "losing track of theme" | "/r/is a" |  | "FN" |  |
| fn:losing | fn:HasLexicalUnit | fn:lu:losing:lose | "losing" | "lose" | "has lexical unit" |  | "FN" |  |
| fn:losing | fn:HasLexicalUnit | fn:lu:losing:misplace | "losing" | "misplace" | "has lexical unit" |  | "FN" |  |
| fn:losing | /r/HasA | fn:fe:owner | "losing" | "owner" | "/r/has a" |  | "FN" |  |
| fn:losing | /r/HasA | fn:fe:possession | "losing" | "possession" | "/r/has a" |  | "FN" |  |
| fn:fe:time | /r/IsA | fn:st:locative_relation | "time" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:losing | /r/HasA | fn:fe:time | "losing" | "time" | "/r/has a" |  | "FN" |  |
| fn:losing | /r/HasA | fn:fe:place | "losing" | "place" | "/r/has a" |  | "FN" |  |
| fn:losing | /r/HasA | fn:fe:means | "losing" | "means" | "/r/has a" |  | "FN" |  |
| fn:losing | /r/HasA | fn:fe:explanation | "losing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:mental_property | /r/UsedFor | fn:losing_it | "mental property" | "losing it" | "/r/used for" |  | "FN" |  |
| fn:losing_it | fn:HasLexicalUnit | fn:lu:losing_it:go_apeshit | "losing it" | "go apeshit" | "has lexical unit" |  | "FN" |  |
| fn:losing_it | fn:HasLexicalUnit | fn:lu:losing_it:lose_it | "losing it" | "lose it" | "has lexical unit" |  | "FN" |  |
| fn:losing_it | fn:HasLexicalUnit | fn:lu:losing_it:go_ballistic | "losing it" | "go ballistic" | "has lexical unit" |  | "FN" |  |
| fn:losing_it | fn:HasLexicalUnit | fn:lu:losing_it:flip_out | "losing it" | "flip out" | "has lexical unit" |  | "FN" |  |
| fn:losing_it | fn:HasLexicalUnit | fn:lu:losing_it:blow_cool | "losing it" | "blow cool" | "has lexical unit" |  | "FN" |  |
| fn:losing_it | fn:HasLexicalUnit | fn:lu:losing_it:freak_out | "losing it" | "freak out" | "has lexical unit" |  | "FN" |  |
| fn:losing_it | /r/HasA | fn:fe:protagonist | "losing it" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:losing_it | /r/HasA | fn:fe:action | "losing it" | "action" | "/r/has a" |  | "FN" |  |
| fn:losing_it | /r/HasA | fn:fe:degree | "losing it" | "degree" | "/r/has a" |  | "FN" |  |
| fn:losing_it | /r/HasA | fn:fe:manner | "losing it" | "manner" | "/r/has a" |  | "FN" |  |
| fn:losing_it | /r/HasA | fn:fe:affected_party | "losing it" | "affected party" | "/r/has a" |  | "FN" |  |
| fn:losing_it | /r/HasA | fn:fe:explanation | "losing it" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:losing_someone | /r/IsA | fn:event | "losing someone" | "event" | "/r/is a" |  | "FN" |  |
| fn:losing_someone | fn:HasLexicalUnit | fn:lu:losing_someone:lose | "losing someone" | "lose" | "has lexical unit" |  | "FN" |  |
| fn:fe:sufferer | /r/IsA | fn:st:sentient | "sufferer" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:losing_someone | /r/HasA | fn:fe:sufferer | "losing someone" | "sufferer" | "/r/has a" |  | "FN" |  |
| fn:fe:deceased | /r/IsA | fn:st:sentient | "deceased" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:losing_someone | /r/HasA | fn:fe:deceased | "losing someone" | "deceased" | "/r/has a" |  | "FN" |  |
| fn:losing_someone | /r/HasA | fn:fe:place | "losing someone" | "place" | "/r/has a" |  | "FN" |  |
| fn:losing_someone | /r/HasA | fn:fe:time | "losing someone" | "time" | "/r/has a" |  | "FN" |  |
| fn:losing_someone | /r/HasA | fn:fe:explanation | "losing someone" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:losing_someone | /r/HasA | fn:fe:manner | "losing someone" | "manner" | "/r/has a" |  | "FN" |  |
| fn:losing_someone | /r/HasA | fn:fe:timespan | "losing someone" | "timespan" | "/r/has a" |  | "FN" |  |
| fn:losing_someone | /r/HasA | fn:fe:duration | "losing someone" | "duration" | "/r/has a" |  | "FN" |  |
| fn:losing_someone | /r/HasA | fn:fe:frequency | "losing someone" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:losing_track_of_perceiver | /r/IsA | fn:losing_track_of | "losing track of perceiver" | "losing track of" | "/r/is a" |  | "FN" |  |
| fn:losing_track_of_theme | /r/IsA | fn:losing_track_of | "losing track of theme" | "losing track of" | "/r/is a" |  | "FN" |  |
| fn:losing_track_of | /r/HasA | fn:fe:perceiver | "losing track of" | "perceiver" | "/r/has a" |  | "FN" |  |
| fn:losing_track_of | /r/HasA | fn:fe:theme | "losing track of" | "theme" | "/r/has a" |  | "FN" |  |
| fn:losing_track_of | /r/HasA | fn:fe:time | "losing track of" | "time" | "/r/has a" |  | "FN" |  |
| fn:losing_track_of | /r/HasA | fn:fe:place | "losing track of" | "place" | "/r/has a" |  | "FN" |  |
| fn:losing_track_of | /r/HasA | fn:fe:explanation | "losing track of" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:losing_track_of_perceiver | /r/IsA | fn:losing_track_of | "losing track of perceiver" | "losing track of" | "/r/is a" |  | "FN" |  |
| fn:losing_track_of_perceiver | fn:HasLexicalUnit | fn:lu:losing_track_of_perceiver:lose | "losing track of perceiver" | "lose" | "has lexical unit" |  | "FN" |  |
| fn:losing_track_of_perceiver | /r/HasA | fn:fe:theme | "losing track of perceiver" | "theme" | "/r/has a" |  | "FN" |  |
| fn:losing_track_of_perceiver | /r/HasA | fn:fe:perceiver | "losing track of perceiver" | "perceiver" | "/r/has a" |  | "FN" |  |
| fn:losing_track_of_perceiver | /r/HasA | fn:fe:place | "losing track of perceiver" | "place" | "/r/has a" |  | "FN" |  |
| fn:losing_track_of_perceiver | /r/HasA | fn:fe:time | "losing track of perceiver" | "time" | "/r/has a" |  | "FN" |  |
| fn:losing_track_of_perceiver | /r/HasA | fn:fe:explanation | "losing track of perceiver" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:losing | /r/IsA | fn:losing_track_of_theme | "losing" | "losing track of theme" | "/r/is a" |  | "FN" |  |
| fn:losing_track_of_theme | /r/IsA | fn:losing_track_of | "losing track of theme" | "losing track of" | "/r/is a" |  | "FN" |  |
| fn:losing_track_of_theme | fn:HasLexicalUnit | fn:lu:losing_track_of_theme:lose | "losing track of theme" | "lose" | "has lexical unit" |  | "FN" |  |
| fn:losing_track_of_theme | /r/HasA | fn:fe:perceiver | "losing track of theme" | "perceiver" | "/r/has a" |  | "FN" |  |
| fn:losing_track_of_theme | /r/HasA | fn:fe:theme | "losing track of theme" | "theme" | "/r/has a" |  | "FN" |  |
| fn:losing_track_of_theme | /r/HasA | fn:fe:place | "losing track of theme" | "place" | "/r/has a" |  | "FN" |  |
| fn:losing_track_of_theme | /r/HasA | fn:fe:time | "losing track of theme" | "time" | "/r/has a" |  | "FN" |  |
| fn:losing_track_of_theme | /r/HasA | fn:fe:explanation | "losing track of theme" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:luck | /r/IsA | fn:gradable_attributes | "luck" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:destiny | /r/UsedFor | fn:luck | "destiny" | "luck" | "/r/used for" |  | "FN" |  |
| fn:likelihood | /r/UsedFor | fn:luck | "likelihood" | "luck" | "/r/used for" |  | "FN" |  |
| fn:luck | fn:HasLexicalUnit | fn:lu:luck:lucky | "luck" | "lucky" | "has lexical unit" |  | "FN" |  |
| fn:luck | fn:HasLexicalUnit | fn:lu:luck:luck | "luck" | "luck" | "has lexical unit" |  | "FN" |  |
| fn:luck | fn:HasLexicalUnit | fn:lu:luck:happy | "luck" | "happy" | "has lexical unit" |  | "FN" |  |
| fn:luck | fn:HasLexicalUnit | fn:lu:luck:fortunate | "luck" | "fortunate" | "has lexical unit" |  | "FN" |  |
| fn:luck | fn:HasLexicalUnit | fn:lu:luck:luckily | "luck" | "luckily" | "has lexical unit" |  | "FN" |  |
| fn:luck | fn:HasLexicalUnit | fn:lu:luck:fortunately | "luck" | "fortunately" | "has lexical unit" |  | "FN" |  |
| fn:luck | fn:HasLexicalUnit | fn:lu:luck:fortune | "luck" | "fortune" | "has lexical unit" |  | "FN" |  |
| fn:luck | fn:HasLexicalUnit | fn:lu:luck:fortuitous | "luck" | "fortuitous" | "has lexical unit" |  | "FN" |  |
| fn:luck | fn:HasLexicalUnit | fn:lu:luck:poor | "luck" | "poor" | "has lexical unit" |  | "FN" |  |
| fn:luck | /r/HasA | fn:fe:state_of_affairs | "luck" | "state of affairs" | "/r/has a" |  | "FN" |  |
| fn:luck | /r/HasA | fn:fe:protagonist | "luck" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:luck | /r/HasA | fn:fe:descriptor | "luck" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:luck | /r/HasA | fn:fe:role | "luck" | "role" | "/r/has a" |  | "FN" |  |
| fn:luck | /r/HasA | fn:fe:time | "luck" | "time" | "/r/has a" |  | "FN" |  |
| fn:luck | /r/HasA | fn:fe:degree | "luck" | "degree" | "/r/has a" |  | "FN" |  |
| fn:luck | /r/HasA | fn:fe:place | "luck" | "place" | "/r/has a" |  | "FN" |  |
| fn:make_acquaintance | /r/IsA | fn:reciprocality | "make acquaintance" | "reciprocality" | "/r/is a" |  | "FN" |  |
| fn:make_acquaintance | fn:HasLexicalUnit | fn:lu:make_acquaintance:meet | "make acquaintance" | "meet" | "has lexical unit" |  | "FN" |  |
| fn:make_acquaintance | fn:HasLexicalUnit | fn:lu:make_acquaintance:make_(someone's)_acquaintance | "make acquaintance" | "make (someone\\'s) acquaintance" | "has lexical unit" |  | "FN" |  |
| fn:make_acquaintance | /r/HasA | fn:fe:time | "make acquaintance" | "time" | "/r/has a" |  | "FN" |  |
| fn:make_acquaintance | /r/HasA | fn:fe:place | "make acquaintance" | "place" | "/r/has a" |  | "FN" |  |
| fn:fe:individuals | /r/IsA | fn:st:sentient | "individuals" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:make_acquaintance | /r/HasA | fn:fe:individuals | "make acquaintance" | "individuals" | "/r/has a" |  | "FN" |  |
| fn:make_acquaintance | /r/HasA | fn:fe:context | "make acquaintance" | "context" | "/r/has a" |  | "FN" |  |
| fn:fe:individual_1 | /r/IsA | fn:st:sentient | "individual 1" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:fe:individual_1 | /r/HasPrerequisite | fn:fe:individual_2 | "individual 1" | "individual 2" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:individual_1 | /r/RelatedTo | fn:fe:individuals | "individual 1" | "individuals" | "/r/related to" |  | "FN" |  |
| fn:make_acquaintance | /r/HasA | fn:fe:individual_1 | "make acquaintance" | "individual 1" | "/r/has a" |  | "FN" |  |
| fn:fe:individual_2 | /r/IsA | fn:st:sentient | "individual 2" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:fe:individual_2 | /r/RelatedTo | fn:fe:individuals | "individual 2" | "individuals" | "/r/related to" |  | "FN" |  |
| fn:make_acquaintance | /r/HasA | fn:fe:individual_2 | "make acquaintance" | "individual 2" | "/r/has a" |  | "FN" |  |
| fn:fe:intermediary | /r/IsA | fn:st:sentient | "intermediary" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:make_acquaintance | /r/HasA | fn:fe:intermediary | "make acquaintance" | "intermediary" | "/r/has a" |  | "FN" |  |
| fn:make_acquaintance | /r/HasA | fn:fe:explanation | "make acquaintance" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:make_acquaintance | /r/HasA | fn:fe:iterations | "make acquaintance" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:make_acquaintance | /r/HasA | fn:fe:depictive | "make acquaintance" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:make_acquaintance | /r/HasA | fn:fe:particular_iteration | "make acquaintance" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:make_compromise | /r/IsA | fn:make_agreement_on_action | "make compromise" | "make agreement on action" | "/r/is a" |  | "FN" |  |
| fn:commitment | /r/UsedFor | fn:make_agreement_on_action | "commitment" | "make agreement on action" | "/r/used for" |  | "FN" |  |
| fn:make_agreement_on_action | /r/UsedFor | fn:be_in_agreement_on_action | "make agreement on action" | "be in agreement on action" | "/r/used for" |  | "FN" |  |
| fn:make_agreement_on_action | fn:HasLexicalUnit | fn:lu:make_agreement_on_action:agree | "make agreement on action" | "agree" | "has lexical unit" |  | "FN" |  |
| fn:make_agreement_on_action | fn:HasLexicalUnit | fn:lu:make_agreement_on_action:agreement | "make agreement on action" | "agreement" | "has lexical unit" |  | "FN" |  |
| fn:make_agreement_on_action | fn:HasLexicalUnit | fn:lu:make_agreement_on_action:deal | "make agreement on action" | "deal" | "has lexical unit" |  | "FN" |  |
| fn:make_agreement_on_action | fn:HasLexicalUnit | fn:lu:make_agreement_on_action:treaty | "make agreement on action" | "treaty" | "has lexical unit" |  | "FN" |  |
| fn:make_agreement_on_action | fn:HasLexicalUnit | fn:lu:make_agreement_on_action:settle | "make agreement on action" | "settle" | "has lexical unit" |  | "FN" |  |
| fn:make_agreement_on_action | /r/HasA | fn:fe:party_1 | "make agreement on action" | "party 1" | "/r/has a" |  | "FN" |  |
| fn:make_agreement_on_action | /r/HasA | fn:fe:party_2 | "make agreement on action" | "party 2" | "/r/has a" |  | "FN" |  |
| fn:make_agreement_on_action | /r/HasA | fn:fe:obligation | "make agreement on action" | "obligation" | "/r/has a" |  | "FN" |  |
| fn:make_agreement_on_action | /r/HasA | fn:fe:topic | "make agreement on action" | "topic" | "/r/has a" |  | "FN" |  |
| fn:make_agreement_on_action | /r/HasA | fn:fe:medium | "make agreement on action" | "medium" | "/r/has a" |  | "FN" |  |
| fn:make_agreement_on_action | /r/HasA | fn:fe:manner | "make agreement on action" | "manner" | "/r/has a" |  | "FN" |  |
| fn:make_agreement_on_action | /r/HasA | fn:fe:parties | "make agreement on action" | "parties" | "/r/has a" |  | "FN" |  |
| fn:make_agreement_on_action | /r/HasA | fn:fe:place | "make agreement on action" | "place" | "/r/has a" |  | "FN" |  |
| fn:make_agreement_on_action | /r/HasA | fn:fe:time | "make agreement on action" | "time" | "/r/has a" |  | "FN" |  |
| fn:make_agreement_on_action | /r/HasA | fn:fe:descriptor | "make agreement on action" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:cognitive_connection | /r/UsedFor | fn:make_cognitive_connection | "cognitive connection" | "make cognitive connection" | "/r/used for" |  | "FN" |  |
| fn:make_cognitive_connection | /r/SimilarTo | fn:cognitive_connection | "make cognitive connection" | "cognitive connection" | "/r/similar to" |  | "FN" |  |
| fn:make_cognitive_connection | fn:HasLexicalUnit | fn:lu:make_cognitive_connection:tie | "make cognitive connection" | "tie" | "has lexical unit" |  | "FN" |  |
| fn:make_cognitive_connection | fn:HasLexicalUnit | fn:lu:make_cognitive_connection:connection | "make cognitive connection" | "connection" | "has lexical unit" |  | "FN" |  |
| fn:make_cognitive_connection | fn:HasLexicalUnit | fn:lu:make_cognitive_connection:connect | "make cognitive connection" | "connect" | "has lexical unit" |  | "FN" |  |
| fn:make_cognitive_connection | fn:HasLexicalUnit | fn:lu:make_cognitive_connection:link | "make cognitive connection" | "link" | "has lexical unit" |  | "FN" |  |
| fn:make_cognitive_connection | fn:HasLexicalUnit | fn:lu:make_cognitive_connection:link | "make cognitive connection" | "link" | "has lexical unit" |  | "FN" |  |
| fn:make_cognitive_connection | fn:HasLexicalUnit | fn:lu:make_cognitive_connection:tie | "make cognitive connection" | "tie" | "has lexical unit" |  | "FN" |  |
| fn:make_cognitive_connection | fn:HasLexicalUnit | fn:lu:make_cognitive_connection:linked | "make cognitive connection" | "linked" | "has lexical unit" |  | "FN" |  |
| fn:fe:concept_1 | /r/HasPrerequisite | fn:fe:concept_2 | "concept 1" | "concept 2" | "/r/has prerequisite" |  | "FN" |  |
| fn:make_cognitive_connection | /r/HasA | fn:fe:concept_1 | "make cognitive connection" | "concept 1" | "/r/has a" |  | "FN" |  |
| fn:fe:concept_2 | /r/HasPrerequisite | fn:fe:concept_1 | "concept 2" | "concept 1" | "/r/has prerequisite" |  | "FN" |  |
| fn:make_cognitive_connection | /r/HasA | fn:fe:concept_2 | "make cognitive connection" | "concept 2" | "/r/has a" |  | "FN" |  |
| fn:make_cognitive_connection | /r/HasA | fn:fe:evidence | "make cognitive connection" | "evidence" | "/r/has a" |  | "FN" |  |
| fn:make_cognitive_connection | /r/HasA | fn:fe:cognizer | "make cognitive connection" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:make_cognitive_connection | /r/HasA | fn:fe:concepts | "make cognitive connection" | "concepts" | "/r/has a" |  | "FN" |  |
| fn:make_cognitive_connection | /r/HasA | fn:fe:frequency | "make cognitive connection" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:make_cognitive_connection | /r/HasA | fn:fe:time | "make cognitive connection" | "time" | "/r/has a" |  | "FN" |  |
| fn:make_cognitive_connection | /r/HasA | fn:fe:place | "make cognitive connection" | "place" | "/r/has a" |  | "FN" |  |
| fn:make_cognitive_connection | /r/HasA | fn:fe:circumstances | "make cognitive connection" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:make_compromise | /r/IsA | fn:make_agreement_on_action | "make compromise" | "make agreement on action" | "/r/is a" |  | "FN" |  |
| fn:make_compromise | fn:HasLexicalUnit | fn:lu:make_compromise:compromise | "make compromise" | "compromise" | "has lexical unit" |  | "FN" |  |
| fn:make_compromise | fn:HasLexicalUnit | fn:lu:make_compromise:compromise | "make compromise" | "compromise" | "has lexical unit" |  | "FN" |  |
| fn:make_compromise | fn:HasLexicalUnit | fn:lu:make_compromise:meet_half-way | "make compromise" | "meet half-way" | "has lexical unit" |  | "FN" |  |
| fn:make_compromise | /r/HasA | fn:fe:party_1 | "make compromise" | "party 1" | "/r/has a" |  | "FN" |  |
| fn:make_compromise | /r/HasA | fn:fe:party_2 | "make compromise" | "party 2" | "/r/has a" |  | "FN" |  |
| fn:make_compromise | /r/HasA | fn:fe:obligation | "make compromise" | "obligation" | "/r/has a" |  | "FN" |  |
| fn:make_compromise | /r/HasA | fn:fe:topic | "make compromise" | "topic" | "/r/has a" |  | "FN" |  |
| fn:make_compromise | /r/HasA | fn:fe:medium | "make compromise" | "medium" | "/r/has a" |  | "FN" |  |
| fn:make_compromise | /r/HasA | fn:fe:manner | "make compromise" | "manner" | "/r/has a" |  | "FN" |  |
| fn:make_compromise | /r/HasA | fn:fe:parties | "make compromise" | "parties" | "/r/has a" |  | "FN" |  |
| fn:make_compromise | /r/HasA | fn:fe:place | "make compromise" | "place" | "/r/has a" |  | "FN" |  |
| fn:make_compromise | /r/HasA | fn:fe:time | "make compromise" | "time" | "/r/has a" |  | "FN" |  |
| fn:make_compromise | /r/HasA | fn:fe:descriptor | "make compromise" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:make_compromise | /r/HasA | fn:fe:purpose | "make compromise" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:make_noise | /r/UsedFor | fn:communication_noise | "make noise" | "communication noise" | "/r/used for" |  | "FN" |  |
| fn:perception | /r/UsedFor | fn:make_noise | "perception" | "make noise" | "/r/used for" |  | "FN" |  |
| fn:make_noise | /r/RelatedTo | fn:cause_impact | "make noise" | "cause impact" | "/r/related to" |  | "FN" |  |
| fn:make_noise | /r/RelatedTo | fn:cause_to_make_noise | "make noise" | "cause to make noise" | "/r/related to" |  | "FN" |  |
| fn:make_noise | /r/RelatedTo | fn:friction | "make noise" | "friction" | "/r/related to" |  | "FN" |  |
| fn:make_noise | /r/RelatedTo | fn:impact | "make noise" | "impact" | "/r/related to" |  | "FN" |  |
| fn:make_noise | /r/RelatedTo | fn:motion_noise | "make noise" | "motion noise" | "/r/related to" |  | "FN" |  |
| fn:make_noise | /r/RelatedTo | fn:sound_movement | "make noise" | "sound movement" | "/r/related to" |  | "FN" |  |
| fn:make_noise | /r/RelatedTo | fn:sounds | "make noise" | "sounds" | "/r/related to" |  | "FN" |  |
| fn:cause_impact | /r/SimilarTo | fn:make_noise | "cause impact" | "make noise" | "/r/similar to" |  | "FN" |  |
| fn:make_noise | /r/SimilarTo | fn:absorb_heat | "make noise" | "absorb heat" | "/r/similar to" |  | "FN" |  |
| fn:make_noise | /r/SimilarTo | fn:cause_to_make_noise | "make noise" | "cause to make noise" | "/r/similar to" |  | "FN" |  |
| fn:make_noise | /r/SimilarTo | fn:fluidic_motion | "make noise" | "fluidic motion" | "/r/similar to" |  | "FN" |  |
| fn:make_noise | /r/SimilarTo | fn:friction | "make noise" | "friction" | "/r/similar to" |  | "FN" |  |
| fn:make_noise | /r/SimilarTo | fn:impact | "make noise" | "impact" | "/r/similar to" |  | "FN" |  |
| fn:make_noise | /r/SimilarTo | fn:motion_noise | "make noise" | "motion noise" | "/r/similar to" |  | "FN" |  |
| fn:make_noise | /r/SimilarTo | fn:sounds | "make noise" | "sounds" | "/r/similar to" |  | "FN" |  |
| fn:cause_to_make_noise | /r/Causes | fn:make_noise | "cause to make noise" | "make noise" | "/r/causes" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:babble | "make noise" | "babble" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:bark | "make noise" | "bark" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:bellow | "make noise" | "bellow" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:blare | "make noise" | "blare" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:blast | "make noise" | "blast" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:bleat | "make noise" | "bleat" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:bray | "make noise" | "bray" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:burble | "make noise" | "burble" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:cackle | "make noise" | "cackle" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:caterwaul | "make noise" | "caterwaul" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:caw | "make noise" | "caw" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:chatter | "make noise" | "chatter" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:cheep | "make noise" | "cheep" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:chirp | "make noise" | "chirp" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:chuckle | "make noise" | "chuckle" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:clang | "make noise" | "clang" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:clash | "make noise" | "clash" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:clatter | "make noise" | "clatter" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:click | "make noise" | "click" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:coo | "make noise" | "coo" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:cough | "make noise" | "cough" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:creak | "make noise" | "creak" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:croak | "make noise" | "croak" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:croon | "make noise" | "croon" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:crunch | "make noise" | "crunch" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:drone | "make noise" | "drone" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:fizzle | "make noise" | "fizzle" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:gasp | "make noise" | "gasp" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:giggle | "make noise" | "giggle" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:gobble | "make noise" | "gobble" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:growl | "make noise" | "growl" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:grunt | "make noise" | "grunt" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:guffaw | "make noise" | "guffaw" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:gurgle | "make noise" | "gurgle" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:hawk | "make noise" | "hawk" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:hiss | "make noise" | "hiss" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:hoot | "make noise" | "hoot" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:howl | "make noise" | "howl" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:hum | "make noise" | "hum" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:keen | "make noise" | "keen" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:mew | "make noise" | "mew" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:mewl | "make noise" | "mewl" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:moan | "make noise" | "moan" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:moo | "make noise" | "moo" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:neigh | "make noise" | "neigh" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:patter | "make noise" | "patter" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:peal | "make noise" | "peal" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:peep | "make noise" | "peep" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:plash | "make noise" | "plash" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:plonk | "make noise" | "plonk" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:plop | "make noise" | "plop" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:purr | "make noise" | "purr" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:quack | "make noise" | "quack" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:rasp | "make noise" | "rasp" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:rattle | "make noise" | "rattle" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:roar | "make noise" | "roar" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:rustle | "make noise" | "rustle" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:scrape | "make noise" | "scrape" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:screech | "make noise" | "screech" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:scrunch | "make noise" | "scrunch" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:sizzle | "make noise" | "sizzle" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:snarl | "make noise" | "snarl" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:snicker | "make noise" | "snicker" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:snigger | "make noise" | "snigger" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:snore | "make noise" | "snore" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:snort | "make noise" | "snort" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:sob | "make noise" | "sob" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:sough | "make noise" | "sough" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:squawk | "make noise" | "squawk" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:squeak | "make noise" | "squeak" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:squeal | "make noise" | "squeal" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:thump | "make noise" | "thump" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:thunder | "make noise" | "thunder" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:tinkle | "make noise" | "tinkle" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:titter | "make noise" | "titter" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:toll | "make noise" | "toll" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:trumpet | "make noise" | "trumpet" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:tweet | "make noise" | "tweet" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:twitter | "make noise" | "twitter" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:ululate | "make noise" | "ululate" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:wail | "make noise" | "wail" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:whimper | "make noise" | "whimper" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:whine | "make noise" | "whine" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:whinny | "make noise" | "whinny" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:whisper | "make noise" | "whisper" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:whistle | "make noise" | "whistle" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:yammer | "make noise" | "yammer" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:yap | "make noise" | "yap" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:yelp | "make noise" | "yelp" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:yodel | "make noise" | "yodel" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:yowl | "make noise" | "yowl" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:crepitate | "make noise" | "crepitate" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:laugh | "make noise" | "laugh" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:clack | "make noise" | "clack" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:sploosh | "make noise" | "sploosh" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:scream | "make noise" | "scream" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:ring | "make noise" | "ring" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:beep | "make noise" | "beep" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:hem_and_haw | "make noise" | "hem and haw" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:boom | "make noise" | "boom" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:cry | "make noise" | "cry" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:sound | "make noise" | "sound" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:honk | "make noise" | "honk" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:play | "make noise" | "play" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | fn:HasLexicalUnit | fn:lu:make_noise:toot | "make noise" | "toot" | "has lexical unit" |  | "FN" |  |
| fn:make_noise | /r/HasA | fn:fe:sound_source | "make noise" | "sound source" | "/r/has a" |  | "FN" |  |
| fn:make_noise | /r/HasA | fn:fe:explanation | "make noise" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:make_noise | /r/HasA | fn:fe:sound | "make noise" | "sound" | "/r/has a" |  | "FN" |  |
| fn:make_noise | /r/HasA | fn:fe:manner | "make noise" | "manner" | "/r/has a" |  | "FN" |  |
| fn:make_noise | /r/HasA | fn:fe:location_of_protagonist | "make noise" | "location of protagonist" | "/r/has a" |  | "FN" |  |
| fn:make_noise | /r/HasA | fn:fe:degree | "make noise" | "degree" | "/r/has a" |  | "FN" |  |
| fn:make_noise | /r/HasA | fn:fe:depictive | "make noise" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:make_noise | /r/HasA | fn:fe:internal_cause | "make noise" | "internal cause" | "/r/has a" |  | "FN" |  |
| fn:make_noise | /r/HasA | fn:fe:subregion | "make noise" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:make_noise | /r/HasA | fn:fe:addressee | "make noise" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:make_noise | /r/HasA | fn:fe:noisy_event | "make noise" | "noisy event" | "/r/has a" |  | "FN" |  |
| fn:make_noise | /r/HasA | fn:fe:path | "make noise" | "path" | "/r/has a" |  | "FN" |  |
| fn:make_noise | /r/HasA | fn:fe:place | "make noise" | "place" | "/r/has a" |  | "FN" |  |
| fn:make_noise | /r/HasA | fn:fe:circumstances | "make noise" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:make_noise | /r/HasA | fn:fe:time | "make noise" | "time" | "/r/has a" |  | "FN" |  |
| fn:make_noise | /r/HasA | fn:fe:iterations | "make noise" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:make_noise | /r/HasA | fn:fe:particular_iteration | "make noise" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:making_arrangements | /r/IsA | fn:intentionally_affect | "making arrangements" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:making_arrangements | /r/UsedFor | fn:scheduling | "making arrangements" | "scheduling" | "/r/used for" |  | "FN" |  |
| fn:making_arrangements | fn:HasLexicalUnit | fn:lu:making_arrangements:make_arrangements | "making arrangements" | "make arrangements" | "has lexical unit" |  | "FN" |  |
| fn:making_arrangements | fn:HasLexicalUnit | fn:lu:making_arrangements:plan | "making arrangements" | "plan" | "has lexical unit" |  | "FN" |  |
| fn:making_arrangements | fn:HasLexicalUnit | fn:lu:making_arrangements:organize | "making arrangements" | "organize" | "has lexical unit" |  | "FN" |  |
| fn:making_arrangements | fn:HasLexicalUnit | fn:lu:making_arrangements:set_up | "making arrangements" | "set up" | "has lexical unit" |  | "FN" |  |
| fn:making_arrangements | fn:HasLexicalUnit | fn:lu:making_arrangements:put_together | "making arrangements" | "put together" | "has lexical unit" |  | "FN" |  |
| fn:making_arrangements | /r/HasA | fn:fe:agent | "making arrangements" | "agent" | "/r/has a" |  | "FN" |  |
| fn:making_arrangements | /r/HasA | fn:fe:event | "making arrangements" | "event" | "/r/has a" |  | "FN" |  |
| fn:making_arrangements | /r/HasA | fn:fe:beneficiary | "making arrangements" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:making_arrangements | /r/HasA | fn:fe:frequency | "making arrangements" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:making_arrangements | /r/HasA | fn:fe:manner | "making arrangements" | "manner" | "/r/has a" |  | "FN" |  |
| fn:making_arrangements | /r/HasA | fn:fe:means | "making arrangements" | "means" | "/r/has a" |  | "FN" |  |
| fn:making_arrangements | /r/HasA | fn:fe:place | "making arrangements" | "place" | "/r/has a" |  | "FN" |  |
| fn:making_arrangements | /r/HasA | fn:fe:purpose | "making arrangements" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:making_arrangements | /r/HasA | fn:fe:explanation | "making arrangements" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:making_arrangements | /r/HasA | fn:fe:scheduled_time | "making arrangements" | "scheduled time" | "/r/has a" |  | "FN" |  |
| fn:making_arrangements | /r/HasA | fn:fe:time | "making arrangements" | "time" | "/r/has a" |  | "FN" |  |
| fn:facial_expression | /r/UsedFor | fn:making_faces | "facial expression" | "making faces" | "/r/used for" |  | "FN" |  |
| fn:body_movement | /r/SimilarTo | fn:making_faces | "body movement" | "making faces" | "/r/similar to" |  | "FN" |  |
| fn:making_faces | fn:HasLexicalUnit | fn:lu:making_faces:frown | "making faces" | "frown" | "has lexical unit" |  | "FN" |  |
| fn:making_faces | fn:HasLexicalUnit | fn:lu:making_faces:grimace | "making faces" | "grimace" | "has lexical unit" |  | "FN" |  |
| fn:making_faces | fn:HasLexicalUnit | fn:lu:making_faces:grin | "making faces" | "grin" | "has lexical unit" |  | "FN" |  |
| fn:making_faces | fn:HasLexicalUnit | fn:lu:making_faces:pout | "making faces" | "pout" | "has lexical unit" |  | "FN" |  |
| fn:making_faces | fn:HasLexicalUnit | fn:lu:making_faces:scowl | "making faces" | "scowl" | "has lexical unit" |  | "FN" |  |
| fn:making_faces | fn:HasLexicalUnit | fn:lu:making_faces:smile | "making faces" | "smile" | "has lexical unit" |  | "FN" |  |
| fn:making_faces | fn:HasLexicalUnit | fn:lu:making_faces:smirk | "making faces" | "smirk" | "has lexical unit" |  | "FN" |  |
| fn:making_faces | /r/HasA | fn:fe:agent | "making faces" | "agent" | "/r/has a" |  | "FN" |  |
| fn:making_faces | /r/HasA | fn:fe:internal_cause | "making faces" | "internal cause" | "/r/has a" |  | "FN" |  |
| fn:making_faces | /r/HasA | fn:fe:body_part | "making faces" | "body part" | "/r/has a" |  | "FN" |  |
| fn:making_faces | /r/HasA | fn:fe:degree | "making faces" | "degree" | "/r/has a" |  | "FN" |  |
| fn:making_faces | /r/HasA | fn:fe:manner | "making faces" | "manner" | "/r/has a" |  | "FN" |  |
| fn:making_faces | /r/HasA | fn:fe:intended_perceiver | "making faces" | "intended perceiver" | "/r/has a" |  | "FN" |  |
| fn:making_faces | /r/HasA | fn:fe:time | "making faces" | "time" | "/r/has a" |  | "FN" |  |
| fn:making_faces | /r/HasA | fn:fe:location_of_protagonist | "making faces" | "location of protagonist" | "/r/has a" |  | "FN" |  |
| fn:making_faces | /r/HasA | fn:fe:path_of_gaze | "making faces" | "path of gaze" | "/r/has a" |  | "FN" |  |
| fn:making_faces | /r/HasA | fn:fe:cognate_event | "making faces" | "cognate event" | "/r/has a" |  | "FN" |  |
| fn:making_faces | /r/HasA | fn:fe:depictive | "making faces" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:making_faces | /r/HasA | fn:fe:external_cause | "making faces" | "external cause" | "/r/has a" |  | "FN" |  |
| fn:manipulate_into_doing | /r/IsA | fn:intentionally_affect | "manipulate into doing" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:talking_into | /r/IsA | fn:manipulate_into_doing | "talking into" | "manipulate into doing" | "/r/is a" |  | "FN" |  |
| fn:influencing_potential | /r/UsedFor | fn:manipulate_into_doing | "influencing potential" | "manipulate into doing" | "/r/used for" |  | "FN" |  |
| fn:attempt_suasion | /r/SimilarTo | fn:manipulate_into_doing | "attempt suasion" | "manipulate into doing" | "/r/similar to" |  | "FN" |  |
| fn:cause_motion | /r/SimilarTo | fn:manipulate_into_doing | "cause motion" | "manipulate into doing" | "/r/similar to" |  | "FN" |  |
| fn:manipulate_into_doing | fn:HasLexicalUnit | fn:lu:manipulate_into_doing:deceive | "manipulate into doing" | "deceive" | "has lexical unit" |  | "FN" |  |
| fn:manipulate_into_doing | fn:HasLexicalUnit | fn:lu:manipulate_into_doing:defraud | "manipulate into doing" | "defraud" | "has lexical unit" |  | "FN" |  |
| fn:manipulate_into_doing | fn:HasLexicalUnit | fn:lu:manipulate_into_doing:con | "manipulate into doing" | "con" | "has lexical unit" |  | "FN" |  |
| fn:manipulate_into_doing | fn:HasLexicalUnit | fn:lu:manipulate_into_doing:badger | "manipulate into doing" | "badger" | "has lexical unit" |  | "FN" |  |
| fn:manipulate_into_doing | fn:HasLexicalUnit | fn:lu:manipulate_into_doing:trick | "manipulate into doing" | "trick" | "has lexical unit" |  | "FN" |  |
| fn:manipulate_into_doing | fn:HasLexicalUnit | fn:lu:manipulate_into_doing:flatter | "manipulate into doing" | "flatter" | "has lexical unit" |  | "FN" |  |
| fn:manipulate_into_doing | fn:HasLexicalUnit | fn:lu:manipulate_into_doing:lure | "manipulate into doing" | "lure" | "has lexical unit" |  | "FN" |  |
| fn:manipulate_into_doing | fn:HasLexicalUnit | fn:lu:manipulate_into_doing:cheat | "manipulate into doing" | "cheat" | "has lexical unit" |  | "FN" |  |
| fn:manipulate_into_doing | fn:HasLexicalUnit | fn:lu:manipulate_into_doing:manipulate | "manipulate into doing" | "manipulate" | "has lexical unit" |  | "FN" |  |
| fn:manipulate_into_doing | fn:HasLexicalUnit | fn:lu:manipulate_into_doing:harass | "manipulate into doing" | "harass" | "has lexical unit" |  | "FN" |  |
| fn:manipulate_into_doing | fn:HasLexicalUnit | fn:lu:manipulate_into_doing:blackmail | "manipulate into doing" | "blackmail" | "has lexical unit" |  | "FN" |  |
| fn:manipulate_into_doing | fn:HasLexicalUnit | fn:lu:manipulate_into_doing:cajole | "manipulate into doing" | "cajole" | "has lexical unit" |  | "FN" |  |
| fn:manipulate_into_doing | fn:HasLexicalUnit | fn:lu:manipulate_into_doing:bully | "manipulate into doing" | "bully" | "has lexical unit" |  | "FN" |  |
| fn:manipulate_into_doing | fn:HasLexicalUnit | fn:lu:manipulate_into_doing:fool | "manipulate into doing" | "fool" | "has lexical unit" |  | "FN" |  |
| fn:manipulate_into_doing | fn:HasLexicalUnit | fn:lu:manipulate_into_doing:dupe | "manipulate into doing" | "dupe" | "has lexical unit" |  | "FN" |  |
| fn:manipulate_into_doing | fn:HasLexicalUnit | fn:lu:manipulate_into_doing:hustle | "manipulate into doing" | "hustle" | "has lexical unit" |  | "FN" |  |
| fn:manipulate_into_doing | /r/HasA | fn:fe:manipulator | "manipulate into doing" | "manipulator" | "/r/has a" |  | "FN" |  |
| fn:manipulate_into_doing | /r/HasA | fn:fe:victim | "manipulate into doing" | "victim" | "/r/has a" |  | "FN" |  |
| fn:manipulate_into_doing | /r/HasA | fn:fe:resulting_action | "manipulate into doing" | "resulting action" | "/r/has a" |  | "FN" |  |
| fn:manipulate_into_doing | /r/HasA | fn:fe:degree | "manipulate into doing" | "degree" | "/r/has a" |  | "FN" |  |
| fn:manipulate_into_doing | /r/HasA | fn:fe:means | "manipulate into doing" | "means" | "/r/has a" |  | "FN" |  |
| fn:manipulate_into_doing | /r/HasA | fn:fe:goods | "manipulate into doing" | "goods" | "/r/has a" |  | "FN" |  |
| fn:manipulate_into_doing | /r/HasA | fn:fe:instrument | "manipulate into doing" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:manipulate_into_doing | /r/HasA | fn:fe:purpose | "manipulate into doing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:manipulate_into_doing | /r/HasA | fn:fe:time | "manipulate into doing" | "time" | "/r/has a" |  | "FN" |  |
| fn:manipulate_into_doing | /r/HasA | fn:fe:place | "manipulate into doing" | "place" | "/r/has a" |  | "FN" |  |
| fn:manipulate_into_doing | /r/HasA | fn:fe:manner | "manipulate into doing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:manipulate_into_shape | /r/IsA | fn:intentionally_affect | "manipulate into shape" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:rope_manipulation | /r/IsA | fn:manipulate_into_shape | "rope manipulation" | "manipulate into shape" | "/r/is a" |  | "FN" |  |
| fn:manipulate_into_shape | fn:HasLexicalUnit | fn:lu:manipulate_into_shape:wind | "manipulate into shape" | "wind" | "has lexical unit" |  | "FN" |  |
| fn:manipulate_into_shape | fn:HasLexicalUnit | fn:lu:manipulate_into_shape:loop | "manipulate into shape" | "loop" | "has lexical unit" |  | "FN" |  |
| fn:manipulate_into_shape | fn:HasLexicalUnit | fn:lu:manipulate_into_shape:coil | "manipulate into shape" | "coil" | "has lexical unit" |  | "FN" |  |
| fn:manipulate_into_shape | fn:HasLexicalUnit | fn:lu:manipulate_into_shape:twist | "manipulate into shape" | "twist" | "has lexical unit" |  | "FN" |  |
| fn:manipulate_into_shape | fn:HasLexicalUnit | fn:lu:manipulate_into_shape:curl | "manipulate into shape" | "curl" | "has lexical unit" |  | "FN" |  |
| fn:manipulate_into_shape | fn:HasLexicalUnit | fn:lu:manipulate_into_shape:mold | "manipulate into shape" | "mold" | "has lexical unit" |  | "FN" |  |
| fn:manipulate_into_shape | fn:HasLexicalUnit | fn:lu:manipulate_into_shape:roll_(into) | "manipulate into shape" | "roll (into)" | "has lexical unit" |  | "FN" |  |
| fn:manipulate_into_shape | /r/HasA | fn:fe:agent | "manipulate into shape" | "agent" | "/r/has a" |  | "FN" |  |
| fn:manipulate_into_shape | /r/HasA | fn:fe:instrument | "manipulate into shape" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:manipulate_into_shape | /r/HasA | fn:fe:place | "manipulate into shape" | "place" | "/r/has a" |  | "FN" |  |
| fn:manipulate_into_shape | /r/HasA | fn:fe:purpose | "manipulate into shape" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:manipulate_into_shape | /r/HasA | fn:fe:time | "manipulate into shape" | "time" | "/r/has a" |  | "FN" |  |
| fn:manipulate_into_shape | /r/HasA | fn:fe:means | "manipulate into shape" | "means" | "/r/has a" |  | "FN" |  |
| fn:manipulate_into_shape | /r/HasA | fn:fe:explanation | "manipulate into shape" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:manipulate_into_shape | /r/HasA | fn:fe:theme | "manipulate into shape" | "theme" | "/r/has a" |  | "FN" |  |
| fn:manipulate_into_shape | /r/HasA | fn:fe:manner | "manipulate into shape" | "manner" | "/r/has a" |  | "FN" |  |
| fn:manipulate_into_shape | /r/HasA | fn:fe:locus | "manipulate into shape" | "locus" | "/r/has a" |  | "FN" |  |
| fn:manipulate_into_shape | /r/HasA | fn:fe:resultant_configuration | "manipulate into shape" | "resultant configuration" | "/r/has a" |  | "FN" |  |
| fn:manipulation | /r/IsA | fn:intentionally_act | "manipulation" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:aiming | /r/IsA | fn:manipulation | "aiming" | "manipulation" | "/r/is a" |  | "FN" |  |
| fn:ingestion | /r/IsA | fn:manipulation | "ingestion" | "manipulation" | "/r/is a" |  | "FN" |  |
| fn:body_parts | /r/UsedFor | fn:manipulation | "body parts" | "manipulation" | "/r/used for" |  | "FN" |  |
| fn:manipulation | /r/UsedFor | fn:attempt_distant_interaction_scenario | "manipulation" | "attempt distant interaction scenario" | "/r/used for" |  | "FN" |  |
| fn:manipulation | /r/UsedFor | fn:cause_to_move_in_place | "manipulation" | "cause to move in place" | "/r/used for" |  | "FN" |  |
| fn:manipulation | /r/RelatedTo | fn:cause_motion | "manipulation" | "cause motion" | "/r/related to" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:clasp | "manipulation" | "clasp" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:claw | "manipulation" | "claw" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:clutch | "manipulation" | "clutch" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:finger | "manipulation" | "finger" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:grab | "manipulation" | "grab" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:grasp | "manipulation" | "grasp" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:grip | "manipulation" | "grip" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:knead | "manipulation" | "knead" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:massage | "manipulation" | "massage" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:nip | "manipulation" | "nip" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:nudge | "manipulation" | "nudge" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:paw | "manipulation" | "paw" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:pinch | "manipulation" | "pinch" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:pull | "manipulation" | "pull" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:push | "manipulation" | "push" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:seize | "manipulation" | "seize" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:squeeze | "manipulation" | "squeeze" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:tug | "manipulation" | "tug" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:tweak | "manipulation" | "tweak" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:wring | "manipulation" | "wring" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:yank | "manipulation" | "yank" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:fumble | "manipulation" | "fumble" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:grope | "manipulation" | "grope" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:stroke | "manipulation" | "stroke" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:rub | "manipulation" | "rub" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:grab_hold | "manipulation" | "grab hold" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:pull | "manipulation" | "pull" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:lick | "manipulation" | "lick" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:touch | "manipulation" | "touch" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:kiss | "manipulation" | "kiss" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:caress | "manipulation" | "caress" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:caress | "manipulation" | "caress" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:stroke | "manipulation" | "stroke" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:diddle | "manipulation" | "diddle" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:hold | "manipulation" | "hold" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:tickle | "manipulation" | "tickle" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:handle | "manipulation" | "handle" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:kiss | "manipulation" | "kiss" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | fn:HasLexicalUnit | fn:lu:manipulation:poke | "manipulation" | "poke" | "has lexical unit" |  | "FN" |  |
| fn:manipulation | /r/HasA | fn:fe:agent | "manipulation" | "agent" | "/r/has a" |  | "FN" |  |
| fn:manipulation | /r/HasA | fn:fe:entity | "manipulation" | "entity" | "/r/has a" |  | "FN" |  |
| fn:manipulation | /r/HasA | fn:fe:locus | "manipulation" | "locus" | "/r/has a" |  | "FN" |  |
| fn:fe:bodypart_of_agent | /r/IsA | fn:st:body_part | "bodypart of agent" | "body part" | "/r/is a" |  | "FN" |  |
| fn:manipulation | /r/HasA | fn:fe:bodypart_of_agent | "manipulation" | "bodypart of agent" | "/r/has a" |  | "FN" |  |
| fn:manipulation | /r/HasA | fn:fe:duration | "manipulation" | "duration" | "/r/has a" |  | "FN" |  |
| fn:manipulation | /r/HasA | fn:fe:manner | "manipulation" | "manner" | "/r/has a" |  | "FN" |  |
| fn:manipulation | /r/HasA | fn:fe:result | "manipulation" | "result" | "/r/has a" |  | "FN" |  |
| fn:manipulation | /r/HasA | fn:fe:time | "manipulation" | "time" | "/r/has a" |  | "FN" |  |
| fn:manipulation | /r/HasA | fn:fe:purpose | "manipulation" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:manipulation | /r/HasA | fn:fe:instrument | "manipulation" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:manipulation | /r/HasA | fn:fe:means | "manipulation" | "means" | "/r/has a" |  | "FN" |  |
| fn:manipulation | /r/HasA | fn:fe:place | "manipulation" | "place" | "/r/has a" |  | "FN" |  |
| fn:manipulation | /r/HasA | fn:fe:depictive | "manipulation" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:manipulation | /r/HasA | fn:fe:explanation | "manipulation" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:manipulation | /r/HasA | fn:fe:particular_iteration | "manipulation" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:event | /r/UsedFor | fn:manner | "event" | "manner" | "/r/used for" |  | "FN" |  |
| fn:manner | fn:HasLexicalUnit | fn:lu:manner:manner | "manner" | "manner" | "has lexical unit" |  | "FN" |  |
| fn:manner | fn:HasLexicalUnit | fn:lu:manner:way | "manner" | "way" | "has lexical unit" |  | "FN" |  |
| fn:manner | /r/HasA | fn:fe:comparison_event | "manner" | "comparison event" | "/r/has a" |  | "FN" |  |
| fn:fe:salient_entity | /r/HasPrerequisite | fn:fe:comparison_activity | "salient entity" | "comparison activity" | "/r/has prerequisite" |  | "FN" |  |
| fn:manner | /r/HasA | fn:fe:salient_entity | "manner" | "salient entity" | "/r/has a" |  | "FN" |  |
| fn:manner | /r/HasA | fn:fe:manner | "manner" | "manner" | "/r/has a" |  | "FN" |  |
| fn:manner | /r/HasA | fn:fe:manner_descriptor | "manner" | "manner descriptor" | "/r/has a" |  | "FN" |  |
| fn:fe:foreground_event | /r/RelatedTo | fn:fe:comparison_activity | "foreground event" | "comparison activity" | "/r/related to" |  | "FN" |  |
| fn:manner | /r/HasA | fn:fe:foreground_event | "manner" | "foreground event" | "/r/has a" |  | "FN" |  |
| fn:fe:comparison_activity | /r/HasPrerequisite | fn:fe:salient_entity | "comparison activity" | "salient entity" | "/r/has prerequisite" |  | "FN" |  |
| fn:manner | /r/HasA | fn:fe:comparison_activity | "manner" | "comparison activity" | "/r/has a" |  | "FN" |  |
| fn:custom | /r/UsedFor | fn:manner_of_life | "custom" | "manner of life" | "/r/used for" |  | "FN" |  |
| fn:manner_of_life | fn:HasLexicalUnit | fn:lu:manner_of_life:live | "manner of life" | "live" | "has lexical unit" |  | "FN" |  |
| fn:manner_of_life | fn:HasLexicalUnit | fn:lu:manner_of_life:lifestyle | "manner of life" | "lifestyle" | "has lexical unit" |  | "FN" |  |
| fn:manner_of_life | fn:HasLexicalUnit | fn:lu:manner_of_life:life | "manner of life" | "life" | "has lexical unit" |  | "FN" |  |
| fn:manner_of_life | /r/HasA | fn:fe:experiencer | "manner of life" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:manner_of_life | /r/HasA | fn:fe:lifestyle | "manner of life" | "lifestyle" | "/r/has a" |  | "FN" |  |
| fn:manner_of_life | /r/HasA | fn:fe:manner | "manner of life" | "manner" | "/r/has a" |  | "FN" |  |
| fn:manner_of_life | /r/HasA | fn:fe:time | "manner of life" | "time" | "/r/has a" |  | "FN" |  |
| fn:manner_of_life | /r/HasA | fn:fe:degree | "manner of life" | "degree" | "/r/has a" |  | "FN" |  |
| fn:manner_of_life | /r/HasA | fn:fe:place | "manner of life" | "place" | "/r/has a" |  | "FN" |  |
| fn:manner_of_life | /r/HasA | fn:fe:domain | "manner of life" | "domain" | "/r/has a" |  | "FN" |  |
| fn:manner_of_life | /r/HasA | fn:fe:descriptor | "manner of life" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:manufacturing | /r/IsA | fn:intentionally_create | "manufacturing" | "intentionally create" | "/r/is a" |  | "FN" |  |
| fn:product_development_scenario | /r/HasSubevent | fn:manufacturing | "product development scenario" | "manufacturing" | "/r/has subevent" |  | "FN" |  |
| fn:manufacturing | /r/HasPrerequisite | fn:product_development | "manufacturing" | "product development" | "/r/has prerequisite" |  | "FN" |  |
| fn:manufacturing | fn:HasLexicalUnit | fn:lu:manufacturing:manufacture | "manufacturing" | "manufacture" | "has lexical unit" |  | "FN" |  |
| fn:manufacturing | fn:HasLexicalUnit | fn:lu:manufacturing:produce | "manufacturing" | "produce" | "has lexical unit" |  | "FN" |  |
| fn:manufacturing | fn:HasLexicalUnit | fn:lu:manufacturing:manufacture | "manufacturing" | "manufacture" | "has lexical unit" |  | "FN" |  |
| fn:manufacturing | fn:HasLexicalUnit | fn:lu:manufacturing:make | "manufacturing" | "make" | "has lexical unit" |  | "FN" |  |
| fn:manufacturing | fn:HasLexicalUnit | fn:lu:manufacturing:manufacturing | "manufacturing" | "manufacturing" | "has lexical unit" |  | "FN" |  |
| fn:manufacturing | fn:HasLexicalUnit | fn:lu:manufacturing:manufacturer | "manufacturing" | "manufacturer" | "has lexical unit" |  | "FN" |  |
| fn:manufacturing | fn:HasLexicalUnit | fn:lu:manufacturing:production | "manufacturing" | "production" | "has lexical unit" |  | "FN" |  |
| fn:manufacturing | fn:HasLexicalUnit | fn:lu:manufacturing:producer | "manufacturing" | "producer" | "has lexical unit" |  | "FN" |  |
| fn:manufacturing | fn:HasLexicalUnit | fn:lu:manufacturing:industrial | "manufacturing" | "industrial" | "has lexical unit" |  | "FN" |  |
| fn:manufacturing | fn:HasLexicalUnit | fn:lu:manufacturing:fabricate | "manufacturing" | "fabricate" | "has lexical unit" |  | "FN" |  |
| fn:manufacturing | fn:HasLexicalUnit | fn:lu:manufacturing:fabrication | "manufacturing" | "fabrication" | "has lexical unit" |  | "FN" |  |
| fn:manufacturing | fn:HasLexicalUnit | fn:lu:manufacturing:maker | "manufacturing" | "maker" | "has lexical unit" |  | "FN" |  |
| fn:manufacturing | fn:HasLexicalUnit | fn:lu:manufacturing:product | "manufacturing" | "product" | "has lexical unit" |  | "FN" |  |
| fn:manufacturing | fn:HasLexicalUnit | fn:lu:manufacturing:assembly_line | "manufacturing" | "assembly line" | "has lexical unit" |  | "FN" |  |
| fn:fe:producer | /r/IsA | fn:st:sentient | "producer" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:manufacturing | /r/HasA | fn:fe:producer | "manufacturing" | "producer" | "/r/has a" |  | "FN" |  |
| fn:manufacturing | /r/HasA | fn:fe:product | "manufacturing" | "product" | "/r/has a" |  | "FN" |  |
| fn:manufacturing | /r/HasA | fn:fe:resource | "manufacturing" | "resource" | "/r/has a" |  | "FN" |  |
| fn:manufacturing | /r/HasA | fn:fe:place | "manufacturing" | "place" | "/r/has a" |  | "FN" |  |
| fn:manufacturing | /r/HasA | fn:fe:time | "manufacturing" | "time" | "/r/has a" |  | "FN" |  |
| fn:manufacturing | /r/HasA | fn:fe:factory | "manufacturing" | "factory" | "/r/has a" |  | "FN" |  |
| fn:manufacturing | /r/HasA | fn:fe:consumer | "manufacturing" | "consumer" | "/r/has a" |  | "FN" |  |
| fn:manufacturing | /r/HasA | fn:fe:depictive | "manufacturing" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:manufacturing | /r/HasA | fn:fe:instrument | "manufacturing" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:manufacturing | /r/HasA | fn:fe:manner | "manufacturing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:manufacturing | /r/HasA | fn:fe:means | "manufacturing" | "means" | "/r/has a" |  | "FN" |  |
| fn:manufacturing | /r/HasA | fn:fe:purpose | "manufacturing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:manufacturing | /r/HasA | fn:fe:circumstances | "manufacturing" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:manufacturing | /r/HasA | fn:fe:frequency | "manufacturing" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:manufacturing | /r/HasA | fn:fe:locus | "manufacturing" | "locus" | "/r/has a" |  | "FN" |  |
| fn:margin_of_resolution | /r/IsA | fn:gradable_attributes | "margin of resolution" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:finish_competition | /r/UsedFor | fn:margin_of_resolution | "finish competition" | "margin of resolution" | "/r/used for" |  | "FN" |  |
| fn:margin_of_resolution | fn:HasLexicalUnit | fn:lu:margin_of_resolution:narrow | "margin of resolution" | "narrow" | "has lexical unit" |  | "FN" |  |
| fn:margin_of_resolution | fn:HasLexicalUnit | fn:lu:margin_of_resolution:decisive | "margin of resolution" | "decisive" | "has lexical unit" |  | "FN" |  |
| fn:margin_of_resolution | fn:HasLexicalUnit | fn:lu:margin_of_resolution:decisiveness | "margin of resolution" | "decisiveness" | "has lexical unit" |  | "FN" |  |
| fn:margin_of_resolution | fn:HasLexicalUnit | fn:lu:margin_of_resolution:close | "margin of resolution" | "close" | "has lexical unit" |  | "FN" |  |
| fn:margin_of_resolution | fn:HasLexicalUnit | fn:lu:margin_of_resolution:narrowly | "margin of resolution" | "narrowly" | "has lexical unit" |  | "FN" |  |
| fn:margin_of_resolution | /r/HasA | fn:fe:outcome | "margin of resolution" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:margin_of_resolution | /r/HasA | fn:fe:margin | "margin of resolution" | "margin" | "/r/has a" |  | "FN" |  |
| fn:margin_of_resolution | /r/HasA | fn:fe:degree | "margin of resolution" | "degree" | "/r/has a" |  | "FN" |  |
| fn:margin_of_resolution | /r/HasA | fn:fe:circumstances | "margin of resolution" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:margin_of_resolution | /r/HasA | fn:fe:value | "margin of resolution" | "value" | "/r/has a" |  | "FN" |  |
| fn:mass_motion | /r/IsA | fn:motion | "mass motion" | "motion" | "/r/is a" |  | "FN" |  |
| fn:abounding_with | /r/UsedFor | fn:mass_motion | "abounding with" | "mass motion" | "/r/used for" |  | "FN" |  |
| fn:mass_motion | fn:HasLexicalUnit | fn:lu:mass_motion:swarm | "mass motion" | "swarm" | "has lexical unit" |  | "FN" |  |
| fn:mass_motion | fn:HasLexicalUnit | fn:lu:mass_motion:teem | "mass motion" | "teem" | "has lexical unit" |  | "FN" |  |
| fn:mass_motion | fn:HasLexicalUnit | fn:lu:mass_motion:throng | "mass motion" | "throng" | "has lexical unit" |  | "FN" |  |
| fn:mass_motion | fn:HasLexicalUnit | fn:lu:mass_motion:stream | "mass motion" | "stream" | "has lexical unit" |  | "FN" |  |
| fn:mass_motion | fn:HasLexicalUnit | fn:lu:mass_motion:crowd | "mass motion" | "crowd" | "has lexical unit" |  | "FN" |  |
| fn:mass_motion | fn:HasLexicalUnit | fn:lu:mass_motion:flood | "mass motion" | "flood" | "has lexical unit" |  | "FN" |  |
| fn:mass_motion | fn:HasLexicalUnit | fn:lu:mass_motion:pour | "mass motion" | "pour" | "has lexical unit" |  | "FN" |  |
| fn:mass_motion | fn:HasLexicalUnit | fn:lu:mass_motion:flock | "mass motion" | "flock" | "has lexical unit" |  | "FN" |  |
| fn:mass_motion | fn:HasLexicalUnit | fn:lu:mass_motion:roll | "mass motion" | "roll" | "has lexical unit" |  | "FN" |  |
| fn:mass_motion | fn:HasLexicalUnit | fn:lu:mass_motion:troop | "mass motion" | "troop" | "has lexical unit" |  | "FN" |  |
| fn:mass_motion | fn:HasLexicalUnit | fn:lu:mass_motion:parade | "mass motion" | "parade" | "has lexical unit" |  | "FN" |  |
| fn:mass_motion | fn:HasLexicalUnit | fn:lu:mass_motion:rain | "mass motion" | "rain" | "has lexical unit" |  | "FN" |  |
| fn:mass_motion | fn:HasLexicalUnit | fn:lu:mass_motion:hail | "mass motion" | "hail" | "has lexical unit" |  | "FN" |  |
| fn:mass_motion | fn:HasLexicalUnit | fn:lu:mass_motion:shower | "mass motion" | "shower" | "has lexical unit" |  | "FN" |  |
| fn:mass_motion | fn:HasLexicalUnit | fn:lu:mass_motion:pelt | "mass motion" | "pelt" | "has lexical unit" |  | "FN" |  |
| fn:mass_motion | /r/HasA | fn:fe:mass_theme | "mass motion" | "mass theme" | "/r/has a" |  | "FN" |  |
| fn:mass_motion | /r/HasA | fn:fe:degree | "mass motion" | "degree" | "/r/has a" |  | "FN" |  |
| fn:mass_motion | /r/HasA | fn:fe:area | "mass motion" | "area" | "/r/has a" |  | "FN" |  |
| fn:mass_motion | /r/HasA | fn:fe:time | "mass motion" | "time" | "/r/has a" |  | "FN" |  |
| fn:mass_motion | /r/HasA | fn:fe:speed | "mass motion" | "speed" | "/r/has a" |  | "FN" |  |
| fn:mass_motion | /r/HasA | fn:fe:source | "mass motion" | "source" | "/r/has a" |  | "FN" |  |
| fn:mass_motion | /r/HasA | fn:fe:path | "mass motion" | "path" | "/r/has a" |  | "FN" |  |
| fn:mass_motion | /r/HasA | fn:fe:goal | "mass motion" | "goal" | "/r/has a" |  | "FN" |  |
| fn:mass_motion | /r/HasA | fn:fe:duration | "mass motion" | "duration" | "/r/has a" |  | "FN" |  |
| fn:mass_motion | /r/HasA | fn:fe:distance | "mass motion" | "distance" | "/r/has a" |  | "FN" |  |
| fn:mass_motion | /r/HasA | fn:fe:mode_of_transportation | "mass motion" | "mode of transportation" | "/r/has a" |  | "FN" |  |
| fn:mass_motion | /r/HasA | fn:fe:manner | "mass motion" | "manner" | "/r/has a" |  | "FN" |  |
| fn:mass_motion | /r/HasA | fn:fe:place | "mass motion" | "place" | "/r/has a" |  | "FN" |  |
| fn:mass_motion | /r/HasA | fn:fe:direction | "mass motion" | "direction" | "/r/has a" |  | "FN" |  |
| fn:mass_motion | /r/HasA | fn:fe:purpose | "mass motion" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:mathematical_relationship | /r/IsA | fn:arithmetic | "mathematical relationship" | "arithmetic" | "/r/is a" |  | "FN" |  |
| fn:mathematical_relationship | fn:HasLexicalUnit | fn:lu:mathematical_relationship:function | "mathematical relationship" | "function" | "has lexical unit" |  | "FN" |  |
| fn:mathematical_relationship | fn:HasLexicalUnit | fn:lu:mathematical_relationship:equation | "mathematical relationship" | "equation" | "has lexical unit" |  | "FN" |  |
| fn:mathematical_relationship | fn:HasLexicalUnit | fn:lu:mathematical_relationship:formula | "mathematical relationship" | "formula" | "has lexical unit" |  | "FN" |  |
| fn:mathematical_relationship | /r/HasA | fn:fe:expression_1 | "mathematical relationship" | "expression 1" | "/r/has a" |  | "FN" |  |
| fn:mathematical_relationship | /r/HasA | fn:fe:expression_2 | "mathematical relationship" | "expression 2" | "/r/has a" |  | "FN" |  |
| fn:mathematical_relationship | /r/HasA | fn:fe:type | "mathematical relationship" | "type" | "/r/has a" |  | "FN" |  |
| fn:preliminaries | /r/IsA | fn:means | "preliminaries" | "means" | "/r/is a" |  | "FN" |  |
| fn:means | /r/UsedFor | fn:purpose | "means" | "purpose" | "/r/used for" |  | "FN" |  |
| fn:means | /r/IsA | fn:causation | "means" | "causation" | "/r/is a" |  | "FN" |  |
| fn:means | fn:HasLexicalUnit | fn:lu:means:means | "means" | "means" | "has lexical unit" |  | "FN" |  |
| fn:means | fn:HasLexicalUnit | fn:lu:means:way | "means" | "way" | "has lexical unit" |  | "FN" |  |
| fn:means | fn:HasLexicalUnit | fn:lu:means:method | "means" | "method" | "has lexical unit" |  | "FN" |  |
| fn:means | fn:HasLexicalUnit | fn:lu:means:technique | "means" | "technique" | "has lexical unit" |  | "FN" |  |
| fn:means | fn:HasLexicalUnit | fn:lu:means:procedure | "means" | "procedure" | "has lexical unit" |  | "FN" |  |
| fn:means | fn:HasLexicalUnit | fn:lu:means:approach | "means" | "approach" | "has lexical unit" |  | "FN" |  |
| fn:means | fn:HasLexicalUnit | fn:lu:means:course_of_action | "means" | "course of action" | "has lexical unit" |  | "FN" |  |
| fn:means | fn:HasLexicalUnit | fn:lu:means:mechanism | "means" | "mechanism" | "has lexical unit" |  | "FN" |  |
| fn:means | fn:HasLexicalUnit | fn:lu:means:modus_operandi | "means" | "modus operandi" | "has lexical unit" |  | "FN" |  |
| fn:means | fn:HasLexicalUnit | fn:lu:means:nuts_and_bolts | "means" | "nuts and bolts" | "has lexical unit" |  | "FN" |  |
| fn:means | fn:HasLexicalUnit | fn:lu:means:process | "means" | "process" | "has lexical unit" |  | "FN" |  |
| fn:means | fn:HasLexicalUnit | fn:lu:means:recipe_[cooking] | "means" | "recipe [cooking]" | "has lexical unit" |  | "FN" |  |
| fn:means | fn:HasLexicalUnit | fn:lu:means:by | "means" | "by" | "has lexical unit" |  | "FN" |  |
| fn:means | fn:HasLexicalUnit | fn:lu:means:tactic | "means" | "tactic" | "has lexical unit" |  | "FN" |  |
| fn:means | fn:HasLexicalUnit | fn:lu:means:on | "means" | "on" | "has lexical unit" |  | "FN" |  |
| fn:means | fn:HasLexicalUnit | fn:lu:means:how | "means" | "how" | "has lexical unit" |  | "FN" |  |
| fn:means | /r/HasA | fn:fe:agent | "means" | "agent" | "/r/has a" |  | "FN" |  |
| fn:means | /r/HasA | fn:fe:means | "means" | "means" | "/r/has a" |  | "FN" |  |
| fn:means | /r/HasA | fn:fe:purpose | "means" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:means | /r/HasA | fn:fe:descriptor | "means" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:means | /r/HasA | fn:fe:time | "means" | "time" | "/r/has a" |  | "FN" |  |
| fn:measurable_attributes | /r/IsA | fn:gradable_attributes | "measurable attributes" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:age | /r/IsA | fn:measurable_attributes | "age" | "measurable attributes" | "/r/is a" |  | "FN" |  |
| fn:duration_description | /r/IsA | fn:measurable_attributes | "duration description" | "measurable attributes" | "/r/is a" |  | "FN" |  |
| fn:location_of_light | /r/IsA | fn:measurable_attributes | "location of light" | "measurable attributes" | "/r/is a" |  | "FN" |  |
| fn:rate_description | /r/IsA | fn:measurable_attributes | "rate description" | "measurable attributes" | "/r/is a" |  | "FN" |  |
| fn:size | /r/IsA | fn:measurable_attributes | "size" | "measurable attributes" | "/r/is a" |  | "FN" |  |
| fn:sound_level | /r/IsA | fn:measurable_attributes | "sound level" | "measurable attributes" | "/r/is a" |  | "FN" |  |
| fn:speed_description | /r/IsA | fn:measurable_attributes | "speed description" | "measurable attributes" | "/r/is a" |  | "FN" |  |
| fn:temperature | /r/IsA | fn:measurable_attributes | "temperature" | "measurable attributes" | "/r/is a" |  | "FN" |  |
| fn:unemployment_rate | /r/IsA | fn:measurable_attributes | "unemployment rate" | "measurable attributes" | "/r/is a" |  | "FN" |  |
| fn:measurable_attributes | /r/UsedFor | fn:accuracy | "measurable attributes" | "accuracy" | "/r/used for" |  | "FN" |  |
| fn:measurable_attributes | /r/UsedFor | fn:extreme_value | "measurable attributes" | "extreme value" | "/r/used for" |  | "FN" |  |
| fn:measurable_attributes | /r/RelatedTo | fn:dimension | "measurable attributes" | "dimension" | "/r/related to" |  | "FN" |  |
| fn:dimension | /r/SimilarTo | fn:measurable_attributes | "dimension" | "measurable attributes" | "/r/similar to" |  | "FN" |  |
| fn:measurable_attributes | /r/IsA | fn:measure_scenario | "measurable attributes" | "measure scenario" | "/r/is a" |  | "FN" |  |
| fn:measurable_attributes | fn:HasLexicalUnit | fn:lu:measurable_attributes:long | "measurable attributes" | "long" | "has lexical unit" |  | "FN" |  |
| fn:measurable_attributes | fn:HasLexicalUnit | fn:lu:measurable_attributes:deep | "measurable attributes" | "deep" | "has lexical unit" |  | "FN" |  |
| fn:measurable_attributes | fn:HasLexicalUnit | fn:lu:measurable_attributes:high | "measurable attributes" | "high" | "has lexical unit" |  | "FN" |  |
| fn:measurable_attributes | fn:HasLexicalUnit | fn:lu:measurable_attributes:tall | "measurable attributes" | "tall" | "has lexical unit" |  | "FN" |  |
| fn:measurable_attributes | fn:HasLexicalUnit | fn:lu:measurable_attributes:thick | "measurable attributes" | "thick" | "has lexical unit" |  | "FN" |  |
| fn:measurable_attributes | fn:HasLexicalUnit | fn:lu:measurable_attributes:heavy | "measurable attributes" | "heavy" | "has lexical unit" |  | "FN" |  |
| fn:measurable_attributes | fn:HasLexicalUnit | fn:lu:measurable_attributes:big_around | "measurable attributes" | "big around" | "has lexical unit" |  | "FN" |  |
| fn:measurable_attributes | fn:HasLexicalUnit | fn:lu:measurable_attributes:low | "measurable attributes" | "low" | "has lexical unit" |  | "FN" |  |
| fn:measurable_attributes | fn:HasLexicalUnit | fn:lu:measurable_attributes:broad | "measurable attributes" | "broad" | "has lexical unit" |  | "FN" |  |
| fn:measurable_attributes | fn:HasLexicalUnit | fn:lu:measurable_attributes:thin | "measurable attributes" | "thin" | "has lexical unit" |  | "FN" |  |
| fn:measurable_attributes | fn:HasLexicalUnit | fn:lu:measurable_attributes:light_[weight] | "measurable attributes" | "light [weight]" | "has lexical unit" |  | "FN" |  |
| fn:measurable_attributes | fn:HasLexicalUnit | fn:lu:measurable_attributes:narrow | "measurable attributes" | "narrow" | "has lexical unit" |  | "FN" |  |
| fn:measurable_attributes | fn:HasLexicalUnit | fn:lu:measurable_attributes:short | "measurable attributes" | "short" | "has lexical unit" |  | "FN" |  |
| fn:measurable_attributes | /r/HasA | fn:fe:entity | "measurable attributes" | "entity" | "/r/has a" |  | "FN" |  |
| fn:measurable_attributes | /r/HasA | fn:fe:attribute | "measurable attributes" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:measurable_attributes | /r/HasA | fn:fe:value | "measurable attributes" | "value" | "/r/has a" |  | "FN" |  |
| fn:measurable_attributes | /r/HasA | fn:fe:degree | "measurable attributes" | "degree" | "/r/has a" |  | "FN" |  |
| fn:measurable_attributes | /r/HasA | fn:fe:time | "measurable attributes" | "time" | "/r/has a" |  | "FN" |  |
| fn:measurable_attributes | /r/HasA | fn:fe:circumstances | "measurable attributes" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:measure_area | /r/IsA | fn:measures | "measure area" | "measures" | "/r/is a" |  | "FN" |  |
| fn:measure_area | fn:HasLexicalUnit | fn:lu:measure_area:hectare | "measure area" | "hectare" | "has lexical unit" |  | "FN" |  |
| fn:measure_area | fn:HasLexicalUnit | fn:lu:measure_area:acre | "measure area" | "acre" | "has lexical unit" |  | "FN" |  |
| fn:measure_area | /r/HasA | fn:fe:unit | "measure area" | "unit" | "/r/has a" |  | "FN" |  |
| fn:fe:area | /r/RelatedTo | fn:fe:occupant | "area" | "occupant" | "/r/related to" |  | "FN" |  |
| fn:measure_area | /r/HasA | fn:fe:area | "measure area" | "area" | "/r/has a" |  | "FN" |  |
| fn:measure_area | /r/HasA | fn:fe:count | "measure area" | "count" | "/r/has a" |  | "FN" |  |
| fn:measure_area | /r/HasA | fn:fe:occupant | "measure area" | "occupant" | "/r/has a" |  | "FN" |  |
| fn:measure_by_action | /r/IsA | fn:measures | "measure by action" | "measures" | "/r/is a" |  | "FN" |  |
| fn:measure_by_action | fn:HasLexicalUnit | fn:lu:measure_by_action:splash | "measure by action" | "splash" | "has lexical unit" |  | "FN" |  |
| fn:measure_by_action | fn:HasLexicalUnit | fn:lu:measure_by_action:bite | "measure by action" | "bite" | "has lexical unit" |  | "FN" |  |
| fn:measure_by_action | fn:HasLexicalUnit | fn:lu:measure_by_action:pinch | "measure by action" | "pinch" | "has lexical unit" |  | "FN" |  |
| fn:measure_by_action | /r/HasA | fn:fe:entity | "measure by action" | "entity" | "/r/has a" |  | "FN" |  |
| fn:measure_by_action | /r/HasA | fn:fe:event | "measure by action" | "event" | "/r/has a" |  | "FN" |  |
| fn:measure_by_action | /r/HasA | fn:fe:count | "measure by action" | "count" | "/r/has a" |  | "FN" |  |
| fn:measure_by_action | /r/HasA | fn:fe:particular_iteration | "measure by action" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:measure_duration | /r/IsA | fn:measures | "measure duration" | "measures" | "/r/is a" |  | "FN" |  |
| fn:measure_duration | /r/IsA | fn:duration_scenario | "measure duration" | "duration scenario" | "/r/is a" |  | "FN" |  |
| fn:measure_duration | fn:HasLexicalUnit | fn:lu:measure_duration:hour | "measure duration" | "hour" | "has lexical unit" |  | "FN" |  |
| fn:measure_duration | fn:HasLexicalUnit | fn:lu:measure_duration:minute | "measure duration" | "minute" | "has lexical unit" |  | "FN" |  |
| fn:measure_duration | fn:HasLexicalUnit | fn:lu:measure_duration:second | "measure duration" | "second" | "has lexical unit" |  | "FN" |  |
| fn:measure_duration | fn:HasLexicalUnit | fn:lu:measure_duration:day | "measure duration" | "day" | "has lexical unit" |  | "FN" |  |
| fn:measure_duration | fn:HasLexicalUnit | fn:lu:measure_duration:week | "measure duration" | "week" | "has lexical unit" |  | "FN" |  |
| fn:measure_duration | fn:HasLexicalUnit | fn:lu:measure_duration:month | "measure duration" | "month" | "has lexical unit" |  | "FN" |  |
| fn:measure_duration | fn:HasLexicalUnit | fn:lu:measure_duration:year | "measure duration" | "year" | "has lexical unit" |  | "FN" |  |
| fn:measure_duration | fn:HasLexicalUnit | fn:lu:measure_duration:decade | "measure duration" | "decade" | "has lexical unit" |  | "FN" |  |
| fn:measure_duration | fn:HasLexicalUnit | fn:lu:measure_duration:century | "measure duration" | "century" | "has lexical unit" |  | "FN" |  |
| fn:measure_duration | fn:HasLexicalUnit | fn:lu:measure_duration:millennium | "measure duration" | "millennium" | "has lexical unit" |  | "FN" |  |
| fn:measure_duration | fn:HasLexicalUnit | fn:lu:measure_duration:fortnight | "measure duration" | "fortnight" | "has lexical unit" |  | "FN" |  |
| fn:measure_duration | fn:HasLexicalUnit | fn:lu:measure_duration:a_while | "measure duration" | "a while" | "has lexical unit" |  | "FN" |  |
| fn:measure_duration | fn:HasLexicalUnit | fn:lu:measure_duration:nanosecond | "measure duration" | "nanosecond" | "has lexical unit" |  | "FN" |  |
| fn:measure_duration | fn:HasLexicalUnit | fn:lu:measure_duration:time | "measure duration" | "time" | "has lexical unit" |  | "FN" |  |
| fn:measure_duration | /r/HasA | fn:fe:count | "measure duration" | "count" | "/r/has a" |  | "FN" |  |
| fn:measure_duration | /r/HasA | fn:fe:unit | "measure duration" | "unit" | "/r/has a" |  | "FN" |  |
| fn:measure_duration | /r/HasA | fn:fe:process | "measure duration" | "process" | "/r/has a" |  | "FN" |  |
| fn:measure_duration | /r/HasA | fn:fe:agent | "measure duration" | "agent" | "/r/has a" |  | "FN" |  |
| fn:measure_linear_extent | /r/IsA | fn:measures | "measure linear extent" | "measures" | "/r/is a" |  | "FN" |  |
| fn:measure_linear_extent | fn:HasLexicalUnit | fn:lu:measure_linear_extent:inch | "measure linear extent" | "inch" | "has lexical unit" |  | "FN" |  |
| fn:measure_linear_extent | fn:HasLexicalUnit | fn:lu:measure_linear_extent:mile | "measure linear extent" | "mile" | "has lexical unit" |  | "FN" |  |
| fn:measure_linear_extent | fn:HasLexicalUnit | fn:lu:measure_linear_extent:yard | "measure linear extent" | "yard" | "has lexical unit" |  | "FN" |  |
| fn:measure_linear_extent | fn:HasLexicalUnit | fn:lu:measure_linear_extent:foot | "measure linear extent" | "foot" | "has lexical unit" |  | "FN" |  |
| fn:measure_linear_extent | fn:HasLexicalUnit | fn:lu:measure_linear_extent:meter | "measure linear extent" | "meter" | "has lexical unit" |  | "FN" |  |
| fn:measure_linear_extent | fn:HasLexicalUnit | fn:lu:measure_linear_extent:kilometer | "measure linear extent" | "kilometer" | "has lexical unit" |  | "FN" |  |
| fn:measure_linear_extent | fn:HasLexicalUnit | fn:lu:measure_linear_extent:centimeter | "measure linear extent" | "centimeter" | "has lexical unit" |  | "FN" |  |
| fn:measure_linear_extent | fn:HasLexicalUnit | fn:lu:measure_linear_extent:millimeter | "measure linear extent" | "millimeter" | "has lexical unit" |  | "FN" |  |
| fn:measure_linear_extent | fn:HasLexicalUnit | fn:lu:measure_linear_extent:furlong | "measure linear extent" | "furlong" | "has lexical unit" |  | "FN" |  |
| fn:measure_linear_extent | fn:HasLexicalUnit | fn:lu:measure_linear_extent:light-year | "measure linear extent" | "light-year" | "has lexical unit" |  | "FN" |  |
| fn:measure_linear_extent | fn:HasLexicalUnit | fn:lu:measure_linear_extent:block | "measure linear extent" | "block" | "has lexical unit" |  | "FN" |  |
| fn:measure_linear_extent | /r/HasA | fn:fe:count | "measure linear extent" | "count" | "/r/has a" |  | "FN" |  |
| fn:measure_linear_extent | /r/HasA | fn:fe:stuff | "measure linear extent" | "stuff" | "/r/has a" |  | "FN" |  |
| fn:measure_linear_extent | /r/HasA | fn:fe:unit | "measure linear extent" | "unit" | "/r/has a" |  | "FN" |  |
| fn:measure_linear_extent | /r/HasA | fn:fe:dimension | "measure linear extent" | "dimension" | "/r/has a" |  | "FN" |  |
| fn:measure_mass | /r/IsA | fn:measures | "measure mass" | "measures" | "/r/is a" |  | "FN" |  |
| fn:measure_mass | fn:HasLexicalUnit | fn:lu:measure_mass:kilo | "measure mass" | "kilo" | "has lexical unit" |  | "FN" |  |
| fn:measure_mass | fn:HasLexicalUnit | fn:lu:measure_mass:kilogram | "measure mass" | "kilogram" | "has lexical unit" |  | "FN" |  |
| fn:measure_mass | fn:HasLexicalUnit | fn:lu:measure_mass:gram | "measure mass" | "gram" | "has lexical unit" |  | "FN" |  |
| fn:measure_mass | fn:HasLexicalUnit | fn:lu:measure_mass:ton | "measure mass" | "ton" | "has lexical unit" |  | "FN" |  |
| fn:measure_mass | fn:HasLexicalUnit | fn:lu:measure_mass:pound | "measure mass" | "pound" | "has lexical unit" |  | "FN" |  |
| fn:measure_mass | fn:HasLexicalUnit | fn:lu:measure_mass:ounce | "measure mass" | "ounce" | "has lexical unit" |  | "FN" |  |
| fn:measure_mass | fn:HasLexicalUnit | fn:lu:measure_mass:milligram | "measure mass" | "milligram" | "has lexical unit" |  | "FN" |  |
| fn:measure_mass | fn:HasLexicalUnit | fn:lu:measure_mass:metric_ton | "measure mass" | "metric ton" | "has lexical unit" |  | "FN" |  |
| fn:measure_mass | /r/HasA | fn:fe:count | "measure mass" | "count" | "/r/has a" |  | "FN" |  |
| fn:measure_mass | /r/HasA | fn:fe:unit | "measure mass" | "unit" | "/r/has a" |  | "FN" |  |
| fn:measure_mass | /r/HasA | fn:fe:stuff | "measure mass" | "stuff" | "/r/has a" |  | "FN" |  |
| fn:duration_scenario | /r/IsA | fn:measure_scenario | "duration scenario" | "measure scenario" | "/r/is a" |  | "FN" |  |
| fn:dimension | /r/IsA | fn:measure_scenario | "dimension" | "measure scenario" | "/r/is a" |  | "FN" |  |
| fn:measurable_attributes | /r/IsA | fn:measure_scenario | "measurable attributes" | "measure scenario" | "/r/is a" |  | "FN" |  |
| fn:measures | /r/IsA | fn:measure_scenario | "measures" | "measure scenario" | "/r/is a" |  | "FN" |  |
| fn:quantified_mass | /r/IsA | fn:measure_scenario | "quantified mass" | "measure scenario" | "/r/is a" |  | "FN" |  |
| fn:measure_scenario | /r/HasA | fn:fe:entity | "measure scenario" | "entity" | "/r/has a" |  | "FN" |  |
| fn:measure_scenario | /r/HasA | fn:fe:attribute | "measure scenario" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:measure_scenario | /r/HasA | fn:fe:value | "measure scenario" | "value" | "/r/has a" |  | "FN" |  |
| fn:measure_scenario | /r/HasA | fn:fe:degree | "measure scenario" | "degree" | "/r/has a" |  | "FN" |  |
| fn:measure_scenario | /r/HasA | fn:fe:time | "measure scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:measure_scenario | /r/HasA | fn:fe:circumstances | "measure scenario" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:measure_scenario | /r/HasA | fn:fe:unit | "measure scenario" | "unit" | "/r/has a" |  | "FN" |  |
| fn:measure_scenario | /r/HasA | fn:fe:count | "measure scenario" | "count" | "/r/has a" |  | "FN" |  |
| fn:measure_volume | /r/IsA | fn:measures | "measure volume" | "measures" | "/r/is a" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:pint | "measure volume" | "pint" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:cup | "measure volume" | "cup" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:bottle | "measure volume" | "bottle" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:bushel | "measure volume" | "bushel" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:box | "measure volume" | "box" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:glass | "measure volume" | "glass" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:gallon | "measure volume" | "gallon" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:barrel | "measure volume" | "barrel" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:pack | "measure volume" | "pack" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:bowl | "measure volume" | "bowl" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:teaspoon | "measure volume" | "teaspoon" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:jug | "measure volume" | "jug" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:spoon | "measure volume" | "spoon" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:tablespoon | "measure volume" | "tablespoon" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:bag | "measure volume" | "bag" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:quart | "measure volume" | "quart" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:spoonful | "measure volume" | "spoonful" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:teaspoonful | "measure volume" | "teaspoonful" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:bagful | "measure volume" | "bagful" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:boxful | "measure volume" | "boxful" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:bucketful | "measure volume" | "bucketful" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:tankful | "measure volume" | "tankful" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:sackful | "measure volume" | "sackful" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:packet | "measure volume" | "packet" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:mug | "measure volume" | "mug" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:scoop | "measure volume" | "scoop" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:scoopful | "measure volume" | "scoopful" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:platter | "measure volume" | "platter" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:tray | "measure volume" | "tray" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:busload | "measure volume" | "busload" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:planeload | "measure volume" | "planeload" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:truckload | "measure volume" | "truckload" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:carload | "measure volume" | "carload" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:roomful | "measure volume" | "roomful" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:trainload | "measure volume" | "trainload" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:boatload | "measure volume" | "boatload" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:litre | "measure volume" | "litre" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:can | "measure volume" | "can" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | fn:HasLexicalUnit | fn:lu:measure_volume:case | "measure volume" | "case" | "has lexical unit" |  | "FN" |  |
| fn:measure_volume | /r/HasA | fn:fe:count | "measure volume" | "count" | "/r/has a" |  | "FN" |  |
| fn:measure_volume | /r/HasA | fn:fe:stuff | "measure volume" | "stuff" | "/r/has a" |  | "FN" |  |
| fn:measure_volume | /r/HasA | fn:fe:unit | "measure volume" | "unit" | "/r/has a" |  | "FN" |  |
| fn:measure_volume | /r/HasA | fn:fe:size | "measure volume" | "size" | "/r/has a" |  | "FN" |  |
| fn:measure_area | /r/IsA | fn:measures | "measure area" | "measures" | "/r/is a" |  | "FN" |  |
| fn:measure_by_action | /r/IsA | fn:measures | "measure by action" | "measures" | "/r/is a" |  | "FN" |  |
| fn:measure_duration | /r/IsA | fn:measures | "measure duration" | "measures" | "/r/is a" |  | "FN" |  |
| fn:measure_linear_extent | /r/IsA | fn:measures | "measure linear extent" | "measures" | "/r/is a" |  | "FN" |  |
| fn:measure_mass | /r/IsA | fn:measures | "measure mass" | "measures" | "/r/is a" |  | "FN" |  |
| fn:measure_volume | /r/IsA | fn:measures | "measure volume" | "measures" | "/r/is a" |  | "FN" |  |
| fn:measures | /r/IsA | fn:measure_scenario | "measures" | "measure scenario" | "/r/is a" |  | "FN" |  |
| fn:measures | /r/HasA | fn:fe:count | "measures" | "count" | "/r/has a" |  | "FN" |  |
| fn:measures | /r/HasA | fn:fe:unit | "measures" | "unit" | "/r/has a" |  | "FN" |  |
| fn:measures | /r/HasA | fn:fe:entity | "measures" | "entity" | "/r/has a" |  | "FN" |  |
| fn:measures | /r/HasA | fn:fe:attribute | "measures" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:medical_conditions | /r/IsA | fn:gradable_attributes | "medical conditions" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:body_parts | /r/UsedFor | fn:medical_conditions | "body parts" | "medical conditions" | "/r/used for" |  | "FN" |  |
| fn:medical_conditions | /r/UsedFor | fn:condition_symptom_relation | "medical conditions" | "condition symptom relation" | "/r/used for" |  | "FN" |  |
| fn:medical_conditions | /r/UsedFor | fn:cure | "medical conditions" | "cure" | "/r/used for" |  | "FN" |  |
| fn:medical_conditions | /r/UsedFor | fn:recovery | "medical conditions" | "recovery" | "/r/used for" |  | "FN" |  |
| fn:infecting | /r/Causes | fn:medical_conditions | "infecting" | "medical conditions" | "/r/causes" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:acromegaly | "medical conditions" | "acromegaly" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:amnesia | "medical conditions" | "amnesia" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:arthritis | "medical conditions" | "arthritis" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:anorexia | "medical conditions" | "anorexia" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:asphyxia | "medical conditions" | "asphyxia" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:asthma | "medical conditions" | "asthma" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:bronchitis | "medical conditions" | "bronchitis" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:cancer | "medical conditions" | "cancer" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:candida | "medical conditions" | "candida" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:cataract | "medical conditions" | "cataract" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:cholangitis | "medical conditions" | "cholangitis" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:cholecystitis | "medical conditions" | "cholecystitis" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:cholera | "medical conditions" | "cholera" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:cirrhosis | "medical conditions" | "cirrhosis" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:cold | "medical conditions" | "cold" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:colitis | "medical conditions" | "colitis" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:conjunctivitis | "medical conditions" | "conjunctivitis" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:cryptosporidiosis | "medical conditions" | "cryptosporidiosis" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:diarrhea | "medical conditions" | "diarrhea" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:depression | "medical conditions" | "depression" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:dermatitis | "medical conditions" | "dermatitis" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:diabetes | "medical conditions" | "diabetes" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:diphtheria | "medical conditions" | "diphtheria" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:diverticulosis | "medical conditions" | "diverticulosis" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:dysmenorrhoea | "medical conditions" | "dysmenorrhoea" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:eczema | "medical conditions" | "eczema" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:flu | "medical conditions" | "flu" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:influenza | "medical conditions" | "influenza" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:hepatitis | "medical conditions" | "hepatitis" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:hernia | "medical conditions" | "hernia" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:hypertension | "medical conditions" | "hypertension" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:hypoglycaemia | "medical conditions" | "hypoglycaemia" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:illness | "medical conditions" | "illness" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:disease | "medical conditions" | "disease" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:sickness | "medical conditions" | "sickness" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:infection | "medical conditions" | "infection" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:jaundice | "medical conditions" | "jaundice" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:leprosy | "medical conditions" | "leprosy" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:leukemia | "medical conditions" | "leukemia" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:malaria | "medical conditions" | "malaria" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:measles | "medical conditions" | "measles" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:meningitis | "medical conditions" | "meningitis" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:menorrhagia | "medical conditions" | "menorrhagia" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:polio | "medical conditions" | "polio" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:psoriasis | "medical conditions" | "psoriasis" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:pyelonephritis | "medical conditions" | "pyelonephritis" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:rosacea | "medical conditions" | "rosacea" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:schizophrenia | "medical conditions" | "schizophrenia" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:sciatica | "medical conditions" | "sciatica" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:shock | "medical conditions" | "shock" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:stress | "medical conditions" | "stress" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:strongylosis | "medical conditions" | "strongylosis" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:syphilis | "medical conditions" | "syphilis" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:tetanus | "medical conditions" | "tetanus" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:tuberculosis | "medical conditions" | "tuberculosis" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:tumor | "medical conditions" | "tumor" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:ulcer | "medical conditions" | "ulcer" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:rubella | "medical conditions" | "rubella" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:mumps | "medical conditions" | "mumps" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:bacterial_meningitis | "medical conditions" | "bacterial meningitis" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:german_measles | "medical conditions" | "german measles" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:ailment | "medical conditions" | "ailment" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:wound | "medical conditions" | "wound" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:affliction | "medical conditions" | "affliction" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:condition | "medical conditions" | "condition" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:syndrome | "medical conditions" | "syndrome" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:stenosis | "medical conditions" | "stenosis" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:sick | "medical conditions" | "sick" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:ill | "medical conditions" | "ill" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:unwell | "medical conditions" | "unwell" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:health | "medical conditions" | "health" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:plague | "medical conditions" | "plague" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:malnourishment | "medical conditions" | "malnourishment" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:malnutrition | "medical conditions" | "malnutrition" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:paraplegic | "medical conditions" | "paraplegic" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:healthy | "medical conditions" | "healthy" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:aids | "medical conditions" | "aids" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:alzheimer's | "medical conditions" | "alzheimer\\'s" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:disorder | "medical conditions" | "disorder" | "has lexical unit" |  | "FN" |  |
| fn:medical_conditions | fn:HasLexicalUnit | fn:lu:medical_conditions:develop | "medical conditions" | "develop" | "has lexical unit" |  | "FN" |  |
| fn:fe:patient | /r/IsA | fn:st:living_thing | "patient" | "living thing" | "/r/is a" |  | "FN" |  |
| fn:medical_conditions | /r/HasA | fn:fe:patient | "medical conditions" | "patient" | "/r/has a" |  | "FN" |  |
| fn:medical_conditions | /r/HasA | fn:fe:body_part | "medical conditions" | "body part" | "/r/has a" |  | "FN" |  |
| fn:medical_conditions | /r/HasA | fn:fe:cause | "medical conditions" | "cause" | "/r/has a" |  | "FN" |  |
| fn:medical_conditions | /r/HasA | fn:fe:symptom | "medical conditions" | "symptom" | "/r/has a" |  | "FN" |  |
| fn:medical_conditions | /r/HasA | fn:fe:name | "medical conditions" | "name" | "/r/has a" |  | "FN" |  |
| fn:medical_conditions | /r/HasA | fn:fe:ailment | "medical conditions" | "ailment" | "/r/has a" |  | "FN" |  |
| fn:medical_conditions | /r/HasA | fn:fe:degree | "medical conditions" | "degree" | "/r/has a" |  | "FN" |  |
| fn:medical_conditions | /r/HasA | fn:fe:place | "medical conditions" | "place" | "/r/has a" |  | "FN" |  |
| fn:medical_conditions | /r/HasA | fn:fe:duration | "medical conditions" | "duration" | "/r/has a" |  | "FN" |  |
| fn:medical_instruments | /r/IsA | fn:artifact | "medical instruments" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:medical_instruments | fn:HasLexicalUnit | fn:lu:medical_instruments:stethoscope | "medical instruments" | "stethoscope" | "has lexical unit" |  | "FN" |  |
| fn:medical_instruments | fn:HasLexicalUnit | fn:lu:medical_instruments:bronchoscope | "medical instruments" | "bronchoscope" | "has lexical unit" |  | "FN" |  |
| fn:medical_instruments | fn:HasLexicalUnit | fn:lu:medical_instruments:colonoscope | "medical instruments" | "colonoscope" | "has lexical unit" |  | "FN" |  |
| fn:medical_instruments | fn:HasLexicalUnit | fn:lu:medical_instruments:endoscope | "medical instruments" | "endoscope" | "has lexical unit" |  | "FN" |  |
| fn:medical_instruments | fn:HasLexicalUnit | fn:lu:medical_instruments:catheter | "medical instruments" | "catheter" | "has lexical unit" |  | "FN" |  |
| fn:medical_instruments | fn:HasLexicalUnit | fn:lu:medical_instruments:forceps | "medical instruments" | "forceps" | "has lexical unit" |  | "FN" |  |
| fn:medical_instruments | fn:HasLexicalUnit | fn:lu:medical_instruments:cholecystoscope | "medical instruments" | "cholecystoscope" | "has lexical unit" |  | "FN" |  |
| fn:medical_instruments | fn:HasLexicalUnit | fn:lu:medical_instruments:fluoroscope | "medical instruments" | "fluoroscope" | "has lexical unit" |  | "FN" |  |
| fn:medical_instruments | fn:HasLexicalUnit | fn:lu:medical_instruments:gastroscope | "medical instruments" | "gastroscope" | "has lexical unit" |  | "FN" |  |
| fn:medical_instruments | fn:HasLexicalUnit | fn:lu:medical_instruments:laparoscope | "medical instruments" | "laparoscope" | "has lexical unit" |  | "FN" |  |
| fn:medical_instruments | fn:HasLexicalUnit | fn:lu:medical_instruments:ophthalmoscope | "medical instruments" | "ophthalmoscope" | "has lexical unit" |  | "FN" |  |
| fn:medical_instruments | fn:HasLexicalUnit | fn:lu:medical_instruments:oscilloscope | "medical instruments" | "oscilloscope" | "has lexical unit" |  | "FN" |  |
| fn:medical_instruments | fn:HasLexicalUnit | fn:lu:medical_instruments:sigmoidoscope | "medical instruments" | "sigmoidoscope" | "has lexical unit" |  | "FN" |  |
| fn:medical_instruments | fn:HasLexicalUnit | fn:lu:medical_instruments:needle | "medical instruments" | "needle" | "has lexical unit" |  | "FN" |  |
| fn:medical_instruments | fn:HasLexicalUnit | fn:lu:medical_instruments:scalpel | "medical instruments" | "scalpel" | "has lexical unit" |  | "FN" |  |
| fn:medical_instruments | fn:HasLexicalUnit | fn:lu:medical_instruments:speculum | "medical instruments" | "speculum" | "has lexical unit" |  | "FN" |  |
| fn:medical_instruments | fn:HasLexicalUnit | fn:lu:medical_instruments:syringe | "medical instruments" | "syringe" | "has lexical unit" |  | "FN" |  |
| fn:medical_instruments | fn:HasLexicalUnit | fn:lu:medical_instruments:otoscope | "medical instruments" | "otoscope" | "has lexical unit" |  | "FN" |  |
| fn:medical_instruments | fn:HasLexicalUnit | fn:lu:medical_instruments:blood_pressure_cuff | "medical instruments" | "blood pressure cuff" | "has lexical unit" |  | "FN" |  |
| fn:medical_instruments | /r/HasA | fn:fe:purpose | "medical instruments" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:medical_instruments | /r/HasA | fn:fe:instrument | "medical instruments" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:cure | /r/UsedFor | fn:medical_interaction_scenario | "cure" | "medical interaction scenario" | "/r/used for" |  | "FN" |  |
| fn:medical_interaction_scenario | /r/UsedFor | fn:medical_professionals | "medical interaction scenario" | "medical professionals" | "/r/used for" |  | "FN" |  |
| fn:medical_interaction_scenario | /r/UsedFor | fn:medical_specialties | "medical interaction scenario" | "medical specialties" | "/r/used for" |  | "FN" |  |
| fn:medical_interaction_scenario | fn:HasLexicalUnit | fn:lu:medical_interaction_scenario:patient | "medical interaction scenario" | "patient" | "has lexical unit" |  | "FN" |  |
| fn:medical_interaction_scenario | fn:HasLexicalUnit | fn:lu:medical_interaction_scenario:doctor | "medical interaction scenario" | "doctor" | "has lexical unit" |  | "FN" |  |
| fn:medical_interaction_scenario | fn:HasLexicalUnit | fn:lu:medical_interaction_scenario:nurse | "medical interaction scenario" | "nurse" | "has lexical unit" |  | "FN" |  |
| fn:medical_interaction_scenario | fn:HasLexicalUnit | fn:lu:medical_interaction_scenario:surgeon | "medical interaction scenario" | "surgeon" | "has lexical unit" |  | "FN" |  |
| fn:medical_interaction_scenario | fn:HasLexicalUnit | fn:lu:medical_interaction_scenario:medical_care | "medical interaction scenario" | "medical care" | "has lexical unit" |  | "FN" |  |
| fn:medical_interaction_scenario | /r/HasA | fn:fe:medic | "medical interaction scenario" | "medic" | "/r/has a" |  | "FN" |  |
| fn:medical_interaction_scenario | /r/HasA | fn:fe:affliction | "medical interaction scenario" | "affliction" | "/r/has a" |  | "FN" |  |
| fn:medical_interaction_scenario | /r/HasA | fn:fe:body_system | "medical interaction scenario" | "body system" | "/r/has a" |  | "FN" |  |
| fn:medical_interaction_scenario | /r/HasA | fn:fe:medical_center | "medical interaction scenario" | "medical center" | "/r/has a" |  | "FN" |  |
| fn:medical_interaction_scenario | /r/HasA | fn:fe:patient | "medical interaction scenario" | "patient" | "/r/has a" |  | "FN" |  |
| fn:medical_intervention | /r/RelatedTo | fn:cure | "medical intervention" | "cure" | "/r/related to" |  | "FN" |  |
| fn:medical_intervention | fn:HasLexicalUnit | fn:lu:medical_intervention:treat | "medical intervention" | "treat" | "has lexical unit" |  | "FN" |  |
| fn:medical_intervention | fn:HasLexicalUnit | fn:lu:medical_intervention:develop | "medical intervention" | "develop" | "has lexical unit" |  | "FN" |  |
| fn:medical_intervention | fn:HasLexicalUnit | fn:lu:medical_intervention:indicate | "medical intervention" | "indicate" | "has lexical unit" |  | "FN" |  |
| fn:medical_intervention | fn:HasLexicalUnit | fn:lu:medical_intervention:consist | "medical intervention" | "consist" | "has lexical unit" |  | "FN" |  |
| fn:medical_intervention | fn:HasLexicalUnit | fn:lu:medical_intervention:attempt | "medical intervention" | "attempt" | "has lexical unit" |  | "FN" |  |
| fn:medical_intervention | fn:HasLexicalUnit | fn:lu:medical_intervention:prevent | "medical intervention" | "prevent" | "has lexical unit" |  | "FN" |  |
| fn:medical_intervention | fn:HasLexicalUnit | fn:lu:medical_intervention:result | "medical intervention" | "result" | "has lexical unit" |  | "FN" |  |
| fn:medical_intervention | /r/HasA | fn:fe:intervention | "medical intervention" | "intervention" | "/r/has a" |  | "FN" |  |
| fn:medical_intervention | /r/HasA | fn:fe:result | "medical intervention" | "result" | "/r/has a" |  | "FN" |  |
| fn:medical_intervention | /r/HasA | fn:fe:medical_condition | "medical intervention" | "medical condition" | "/r/has a" |  | "FN" |  |
| fn:medical_intervention | /r/HasA | fn:fe:patient | "medical intervention" | "patient" | "/r/has a" |  | "FN" |  |
| fn:medical_intervention | /r/HasA | fn:fe:side_effects | "medical intervention" | "side effects" | "/r/has a" |  | "FN" |  |
| fn:medical_intervention | /r/HasA | fn:fe:extent | "medical intervention" | "extent" | "/r/has a" |  | "FN" |  |
| fn:medical_intervention | /r/HasA | fn:fe:frequency_of_success | "medical intervention" | "frequency of success" | "/r/has a" |  | "FN" |  |
| fn:medical_intervention | /r/HasA | fn:fe:medical_professional | "medical intervention" | "medical professional" | "/r/has a" |  | "FN" |  |
| fn:medical_professionals | /r/IsA | fn:people_by_vocation | "medical professionals" | "people by vocation" | "/r/is a" |  | "FN" |  |
| fn:medical_interaction_scenario | /r/UsedFor | fn:medical_professionals | "medical interaction scenario" | "medical professionals" | "/r/used for" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:physician | "medical professionals" | "physician" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:surgeon | "medical professionals" | "surgeon" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:allergist | "medical professionals" | "allergist" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:doctor | "medical professionals" | "doctor" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:cardiologist | "medical professionals" | "cardiologist" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:anesthesiologist | "medical professionals" | "anesthesiologist" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:chiropractor | "medical professionals" | "chiropractor" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:dermatologist | "medical professionals" | "dermatologist" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:endocrinologist | "medical professionals" | "endocrinologist" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:gastroenterologist | "medical professionals" | "gastroenterologist" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:gerontologist | "medical professionals" | "gerontologist" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:homeopathist | "medical professionals" | "homeopathist" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:immunologist | "medical professionals" | "immunologist" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:neonatologist | "medical professionals" | "neonatologist" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:nephrologist | "medical professionals" | "nephrologist" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:neurologist | "medical professionals" | "neurologist" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:obstetrician | "medical professionals" | "obstetrician" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:gynaecologist | "medical professionals" | "gynaecologist" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:oncologist | "medical professionals" | "oncologist" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:orthopaedist | "medical professionals" | "orthopaedist" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:pediatrician | "medical professionals" | "pediatrician" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:proctologist | "medical professionals" | "proctologist" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:psychiatrist | "medical professionals" | "psychiatrist" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:psychoanalyst | "medical professionals" | "psychoanalyst" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:radiologist | "medical professionals" | "radiologist" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:rheumatologist | "medical professionals" | "rheumatologist" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:family_practitioner | "medical professionals" | "family practitioner" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:therapist | "medical professionals" | "therapist" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:ophthalmologist | "medical professionals" | "ophthalmologist" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:radiation_oncologist | "medical professionals" | "radiation oncologist" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:midwife | "medical professionals" | "midwife" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:psychologist | "medical professionals" | "psychologist" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:psychotherapist | "medical professionals" | "psychotherapist" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:shaman | "medical professionals" | "shaman" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:urologist | "medical professionals" | "urologist" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:speech_therapist | "medical professionals" | "speech therapist" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | fn:HasLexicalUnit | fn:lu:medical_professionals:nurse | "medical professionals" | "nurse" | "has lexical unit" |  | "FN" |  |
| fn:medical_professionals | /r/HasA | fn:fe:type | "medical professionals" | "type" | "/r/has a" |  | "FN" |  |
| fn:medical_professionals | /r/HasA | fn:fe:professional | "medical professionals" | "professional" | "/r/has a" |  | "FN" |  |
| fn:medical_professionals | /r/HasA | fn:fe:affliction | "medical professionals" | "affliction" | "/r/has a" |  | "FN" |  |
| fn:medical_professionals | /r/HasA | fn:fe:body_system | "medical professionals" | "body system" | "/r/has a" |  | "FN" |  |
| fn:medical_professionals | /r/HasA | fn:fe:age | "medical professionals" | "age" | "/r/has a" |  | "FN" |  |
| fn:medical_professionals | /r/HasA | fn:fe:compensation | "medical professionals" | "compensation" | "/r/has a" |  | "FN" |  |
| fn:medical_professionals | /r/HasA | fn:fe:contract_basis | "medical professionals" | "contract basis" | "/r/has a" |  | "FN" |  |
| fn:medical_professionals | /r/HasA | fn:fe:employer | "medical professionals" | "employer" | "/r/has a" |  | "FN" |  |
| fn:medical_professionals | /r/HasA | fn:fe:ethnicity | "medical professionals" | "ethnicity" | "/r/has a" |  | "FN" |  |
| fn:medical_professionals | /r/HasA | fn:fe:place_of_employment | "medical professionals" | "place of employment" | "/r/has a" |  | "FN" |  |
| fn:medical_professionals | /r/HasA | fn:fe:rank | "medical professionals" | "rank" | "/r/has a" |  | "FN" |  |
| fn:medical_professionals | /r/HasA | fn:fe:origin | "medical professionals" | "origin" | "/r/has a" |  | "FN" |  |
| fn:medical_interaction_scenario | /r/UsedFor | fn:medical_specialties | "medical interaction scenario" | "medical specialties" | "/r/used for" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:cardiology | "medical specialties" | "cardiology" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:dentistry | "medical specialties" | "dentistry" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:dermatology | "medical specialties" | "dermatology" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:endocrinology | "medical specialties" | "endocrinology" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:epidemiology | "medical specialties" | "epidemiology" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:gastroenterology | "medical specialties" | "gastroenterology" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:gynaecology | "medical specialties" | "gynaecology" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:haematology | "medical specialties" | "haematology" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:chiropractic | "medical specialties" | "chiropractic" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:histology | "medical specialties" | "histology" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:homeopathy | "medical specialties" | "homeopathy" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:allopathy | "medical specialties" | "allopathy" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:midwifery | "medical specialties" | "midwifery" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:psychotherapy | "medical specialties" | "psychotherapy" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:psychoanalysis | "medical specialties" | "psychoanalysis" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:immunology | "medical specialties" | "immunology" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:neonatology | "medical specialties" | "neonatology" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:nephrology | "medical specialties" | "nephrology" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:neurology | "medical specialties" | "neurology" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:obstetrics | "medical specialties" | "obstetrics" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:oncology | "medical specialties" | "oncology" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:orthopaedics | "medical specialties" | "orthopaedics" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:paediatrics | "medical specialties" | "paediatrics" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:podiatry | "medical specialties" | "podiatry" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:radiology | "medical specialties" | "radiology" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:rheumatology | "medical specialties" | "rheumatology" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:medicine | "medical specialties" | "medicine" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:therapy | "medical specialties" | "therapy" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | fn:HasLexicalUnit | fn:lu:medical_specialties:speech_therapy | "medical specialties" | "speech therapy" | "has lexical unit" |  | "FN" |  |
| fn:medical_specialties | /r/HasA | fn:fe:specialty | "medical specialties" | "specialty" | "/r/has a" |  | "FN" |  |
| fn:medical_specialties | /r/HasA | fn:fe:type | "medical specialties" | "type" | "/r/has a" |  | "FN" |  |
| fn:medical_specialties | /r/HasA | fn:fe:body_system | "medical specialties" | "body system" | "/r/has a" |  | "FN" |  |
| fn:medical_specialties | /r/HasA | fn:fe:affliction | "medical specialties" | "affliction" | "/r/has a" |  | "FN" |  |
| fn:text | /r/UsedFor | fn:medium | "text" | "medium" | "/r/used for" |  | "FN" |  |
| fn:medium | fn:HasLexicalUnit | fn:lu:medium:in | "medium" | "in" | "has lexical unit" |  | "FN" |  |
| fn:medium | /r/HasA | fn:fe:text | "medium" | "text" | "/r/has a" |  | "FN" |  |
| fn:medium | /r/HasA | fn:fe:item | "medium" | "item" | "/r/has a" |  | "FN" |  |
| fn:medium | /r/HasA | fn:fe:frequency | "medium" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:medium | /r/HasA | fn:fe:time | "medium" | "time" | "/r/has a" |  | "FN" |  |
| fn:rising_to_a_challenge | /r/IsA | fn:meet_specifications | "rising to a challenge" | "meet specifications" | "/r/is a" |  | "FN" |  |
| fn:meet_specifications | /r/IsA | fn:satisfying | "meet specifications" | "satisfying" | "/r/is a" |  | "FN" |  |
| fn:sufficiency | /r/UsedFor | fn:meet_specifications | "sufficiency" | "meet specifications" | "/r/used for" |  | "FN" |  |
| fn:meet_specifications | fn:HasLexicalUnit | fn:lu:meet_specifications:meet | "meet specifications" | "meet" | "has lexical unit" |  | "FN" |  |
| fn:meet_specifications | fn:HasLexicalUnit | fn:lu:meet_specifications:fulfill | "meet specifications" | "fulfill" | "has lexical unit" |  | "FN" |  |
| fn:meet_specifications | /r/HasA | fn:fe:agent | "meet specifications" | "agent" | "/r/has a" |  | "FN" |  |
| fn:meet_specifications | /r/HasA | fn:fe:entity | "meet specifications" | "entity" | "/r/has a" |  | "FN" |  |
| fn:meet_specifications | /r/HasA | fn:fe:event | "meet specifications" | "event" | "/r/has a" |  | "FN" |  |
| fn:meet_specifications | /r/HasA | fn:fe:standard | "meet specifications" | "standard" | "/r/has a" |  | "FN" |  |
| fn:meet_specifications | /r/HasA | fn:fe:manner | "meet specifications" | "manner" | "/r/has a" |  | "FN" |  |
| fn:meet_specifications | /r/HasA | fn:fe:means | "meet specifications" | "means" | "/r/has a" |  | "FN" |  |
| fn:meet_specifications | /r/HasA | fn:fe:time | "meet specifications" | "time" | "/r/has a" |  | "FN" |  |
| fn:meet_specifications | /r/HasA | fn:fe:degree | "meet specifications" | "degree" | "/r/has a" |  | "FN" |  |
| fn:discussion | /r/UsedFor | fn:meet_with | "discussion" | "meet with" | "/r/used for" |  | "FN" |  |
| fn:meet_with | /r/HasPrerequisite | fn:assemble | "meet with" | "assemble" | "/r/has prerequisite" |  | "FN" |  |
| fn:meet_with | fn:HasLexicalUnit | fn:lu:meet_with:meet_with | "meet with" | "meet with" | "has lexical unit" |  | "FN" |  |
| fn:meet_with | /r/HasA | fn:fe:party_1 | "meet with" | "party 1" | "/r/has a" |  | "FN" |  |
| fn:meet_with | /r/HasA | fn:fe:party_2 | "meet with" | "party 2" | "/r/has a" |  | "FN" |  |
| fn:meet_with | /r/HasA | fn:fe:purpose | "meet with" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:meet_with | /r/HasA | fn:fe:place | "meet with" | "place" | "/r/has a" |  | "FN" |  |
| fn:meet_with | /r/HasA | fn:fe:time | "meet with" | "time" | "/r/has a" |  | "FN" |  |
| fn:meet_with | /r/HasA | fn:fe:means | "meet with" | "means" | "/r/has a" |  | "FN" |  |
| fn:meet_with | /r/HasA | fn:fe:manner | "meet with" | "manner" | "/r/has a" |  | "FN" |  |
| fn:meet_with_response | /r/IsA | fn:response_scenario | "meet with response" | "response scenario" | "/r/is a" |  | "FN" |  |
| fn:meet_with_response | fn:HasLexicalUnit | fn:lu:meet_with_response:meet | "meet with response" | "meet" | "has lexical unit" |  | "FN" |  |
| fn:meet_with_response | /r/HasA | fn:fe:trigger | "meet with response" | "trigger" | "/r/has a" |  | "FN" |  |
| fn:meet_with_response | /r/HasA | fn:fe:response | "meet with response" | "response" | "/r/has a" |  | "FN" |  |
| fn:meet_with_response | /r/HasA | fn:fe:manner | "meet with response" | "manner" | "/r/has a" |  | "FN" |  |
| fn:meet_with_response | /r/HasA | fn:fe:place | "meet with response" | "place" | "/r/has a" |  | "FN" |  |
| fn:meet_with_response | /r/HasA | fn:fe:time | "meet with response" | "time" | "/r/has a" |  | "FN" |  |
| fn:member_of_military | /r/IsA | fn:people_by_vocation | "member of military" | "people by vocation" | "/r/is a" |  | "FN" |  |
| fn:hostile_encounter | /r/UsedFor | fn:member_of_military | "hostile encounter" | "member of military" | "/r/used for" |  | "FN" |  |
| fn:member_of_military | /r/UsedFor | fn:people_by_military_specialty | "member of military" | "people by military specialty" | "/r/used for" |  | "FN" |  |
| fn:membership | /r/UsedFor | fn:member_of_military | "membership" | "member of military" | "/r/used for" |  | "FN" |  |
| fn:military | /r/UsedFor | fn:member_of_military | "military" | "member of military" | "/r/used for" |  | "FN" |  |
| fn:member_of_military | fn:HasLexicalUnit | fn:lu:member_of_military:soldier | "member of military" | "soldier" | "has lexical unit" |  | "FN" |  |
| fn:member_of_military | fn:HasLexicalUnit | fn:lu:member_of_military:marine | "member of military" | "marine" | "has lexical unit" |  | "FN" |  |
| fn:member_of_military | fn:HasLexicalUnit | fn:lu:member_of_military:sailor | "member of military" | "sailor" | "has lexical unit" |  | "FN" |  |
| fn:member_of_military | fn:HasLexicalUnit | fn:lu:member_of_military:airman | "member of military" | "airman" | "has lexical unit" |  | "FN" |  |
| fn:member_of_military | fn:HasLexicalUnit | fn:lu:member_of_military:troop | "member of military" | "troop" | "has lexical unit" |  | "FN" |  |
| fn:member_of_military | fn:HasLexicalUnit | fn:lu:member_of_military:service_member | "member of military" | "service member" | "has lexical unit" |  | "FN" |  |
| fn:member_of_military | fn:HasLexicalUnit | fn:lu:member_of_military:commando | "member of military" | "commando" | "has lexical unit" |  | "FN" |  |
| fn:member_of_military | /r/HasA | fn:fe:origin | "member of military" | "origin" | "/r/has a" |  | "FN" |  |
| fn:member_of_military | /r/HasA | fn:fe:person | "member of military" | "person" | "/r/has a" |  | "FN" |  |
| fn:member_of_military | /r/HasA | fn:fe:persistent_characteristic | "member of military" | "persistent characteristic" | "/r/has a" |  | "FN" |  |
| fn:member_of_military | /r/HasA | fn:fe:descriptor | "member of military" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:member_of_military | /r/HasA | fn:fe:age | "member of military" | "age" | "/r/has a" |  | "FN" |  |
| fn:member_of_military | /r/HasA | fn:fe:ethnicity | "member of military" | "ethnicity" | "/r/has a" |  | "FN" |  |
| fn:member_of_military | /r/HasA | fn:fe:context_of_acquaintance | "member of military" | "context of acquaintance" | "/r/has a" |  | "FN" |  |
| fn:member_of_military | /r/HasA | fn:fe:rank | "member of military" | "rank" | "/r/has a" |  | "FN" |  |
| fn:member_of_military | /r/HasA | fn:fe:place_of_employment | "member of military" | "place of employment" | "/r/has a" |  | "FN" |  |
| fn:member_of_military | /r/HasA | fn:fe:loyal_side | "member of military" | "loyal side" | "/r/has a" |  | "FN" |  |
| fn:member_of_military | /r/HasA | fn:fe:type | "member of military" | "type" | "/r/has a" |  | "FN" |  |
| fn:member_of_military | /r/HasA | fn:fe:compensation | "member of military" | "compensation" | "/r/has a" |  | "FN" |  |
| fn:member_of_military | /r/HasA | fn:fe:contract_basis | "member of military" | "contract basis" | "/r/has a" |  | "FN" |  |
| fn:member_of_military | /r/HasA | fn:fe:military_organization | "member of military" | "military organization" | "/r/has a" |  | "FN" |  |
| fn:membership | /r/IsA | fn:be_subset_of | "membership" | "be subset of" | "/r/is a" |  | "FN" |  |
| fn:membership | /r/UsedFor | fn:exclude_member | "membership" | "exclude member" | "/r/used for" |  | "FN" |  |
| fn:membership | /r/UsedFor | fn:member_of_military | "membership" | "member of military" | "/r/used for" |  | "FN" |  |
| fn:becoming_a_member | /r/Causes | fn:membership | "becoming a member" | "membership" | "/r/causes" |  | "FN" |  |
| fn:membership | fn:HasLexicalUnit | fn:lu:membership:member | "membership" | "member" | "has lexical unit" |  | "FN" |  |
| fn:membership | fn:HasLexicalUnit | fn:lu:membership:belong | "membership" | "belong" | "has lexical unit" |  | "FN" |  |
| fn:membership | fn:HasLexicalUnit | fn:lu:membership:part | "membership" | "part" | "has lexical unit" |  | "FN" |  |
| fn:membership | fn:HasLexicalUnit | fn:lu:membership:membership_[status] | "membership" | "membership [status]" | "has lexical unit" |  | "FN" |  |
| fn:membership | fn:HasLexicalUnit | fn:lu:membership:membership | "membership" | "membership" | "has lexical unit" |  | "FN" |  |
| fn:membership | fn:HasLexicalUnit | fn:lu:membership:associated | "membership" | "associated" | "has lexical unit" |  | "FN" |  |
| fn:membership | /r/HasA | fn:fe:member | "membership" | "member" | "/r/has a" |  | "FN" |  |
| fn:membership | /r/HasA | fn:fe:group | "membership" | "group" | "/r/has a" |  | "FN" |  |
| fn:membership | /r/HasA | fn:fe:standing | "membership" | "standing" | "/r/has a" |  | "FN" |  |
| fn:membership | /r/HasA | fn:fe:manner | "membership" | "manner" | "/r/has a" |  | "FN" |  |
| fn:membership | /r/HasA | fn:fe:time | "membership" | "time" | "/r/has a" |  | "FN" |  |
| fn:membership | /r/HasA | fn:fe:place | "membership" | "place" | "/r/has a" |  | "FN" |  |
| fn:memorization | /r/IsA | fn:cogitation | "memorization" | "cogitation" | "/r/is a" |  | "FN" |  |
| fn:memorization | /r/RelatedTo | fn:education_teaching | "memorization" | "education teaching" | "/r/related to" |  | "FN" |  |
| fn:memorization | /r/Causes | fn:remembering_information | "memorization" | "remembering information" | "/r/causes" |  | "FN" |  |
| fn:memorization | fn:HasLexicalUnit | fn:lu:memorization:memorise | "memorization" | "memorise" | "has lexical unit" |  | "FN" |  |
| fn:memorization | fn:HasLexicalUnit | fn:lu:memorization:memorization | "memorization" | "memorization" | "has lexical unit" |  | "FN" |  |
| fn:memorization | fn:HasLexicalUnit | fn:lu:memorization:learn | "memorization" | "learn" | "has lexical unit" |  | "FN" |  |
| fn:memorization | fn:HasLexicalUnit | fn:lu:memorization:commit_to_memory | "memorization" | "commit to memory" | "has lexical unit" |  | "FN" |  |
| fn:memorization | /r/HasA | fn:fe:cognizer | "memorization" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:memorization | /r/HasA | fn:fe:pattern | "memorization" | "pattern" | "/r/has a" |  | "FN" |  |
| fn:memorization | /r/HasA | fn:fe:time | "memorization" | "time" | "/r/has a" |  | "FN" |  |
| fn:memorization | /r/HasA | fn:fe:place | "memorization" | "place" | "/r/has a" |  | "FN" |  |
| fn:memorization | /r/HasA | fn:fe:manner | "memorization" | "manner" | "/r/has a" |  | "FN" |  |
| fn:memorization | /r/HasA | fn:fe:completeness | "memorization" | "completeness" | "/r/has a" |  | "FN" |  |
| fn:memorization | /r/HasA | fn:fe:means | "memorization" | "means" | "/r/has a" |  | "FN" |  |
| fn:memorization | /r/HasA | fn:fe:purpose | "memorization" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:eventive_affecting | /r/UsedFor | fn:memory | "eventive affecting" | "memory" | "/r/used for" |  | "FN" |  |
| fn:memory | /r/UsedFor | fn:evoking | "memory" | "evoking" | "/r/used for" |  | "FN" |  |
| fn:memory | /r/SimilarTo | fn:remembering_experience | "memory" | "remembering experience" | "/r/similar to" |  | "FN" |  |
| fn:memory | /r/SimilarTo | fn:remembering_information | "memory" | "remembering information" | "/r/similar to" |  | "FN" |  |
| fn:memory | /r/SimilarTo | fn:remembering_to_do | "memory" | "remembering to do" | "/r/similar to" |  | "FN" |  |
| fn:memory | fn:HasLexicalUnit | fn:lu:memory:remember | "memory" | "remember" | "has lexical unit" |  | "FN" |  |
| fn:memory | fn:HasLexicalUnit | fn:lu:memory:memory | "memory" | "memory" | "has lexical unit" |  | "FN" |  |
| fn:memory | fn:HasLexicalUnit | fn:lu:memory:recall | "memory" | "recall" | "has lexical unit" |  | "FN" |  |
| fn:memory | fn:HasLexicalUnit | fn:lu:memory:recollect | "memory" | "recollect" | "has lexical unit" |  | "FN" |  |
| fn:memory | fn:HasLexicalUnit | fn:lu:memory:recollection | "memory" | "recollection" | "has lexical unit" |  | "FN" |  |
| fn:memory | fn:HasLexicalUnit | fn:lu:memory:retain | "memory" | "retain" | "has lexical unit" |  | "FN" |  |
| fn:memory | fn:HasLexicalUnit | fn:lu:memory:bethink_oneself | "memory" | "bethink oneself" | "has lexical unit" |  | "FN" |  |
| fn:memory | /r/HasA | fn:fe:cognizer | "memory" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:memory | /r/HasA | fn:fe:content | "memory" | "content" | "/r/has a" |  | "FN" |  |
| fn:memory | /r/HasA | fn:fe:topic | "memory" | "topic" | "/r/has a" |  | "FN" |  |
| fn:memory | /r/HasA | fn:fe:degree | "memory" | "degree" | "/r/has a" |  | "FN" |  |
| fn:memory | /r/HasA | fn:fe:depictive | "memory" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:memory | /r/HasA | fn:fe:manner | "memory" | "manner" | "/r/has a" |  | "FN" |  |
| fn:memory | /r/HasA | fn:fe:means | "memory" | "means" | "/r/has a" |  | "FN" |  |
| fn:memory | /r/HasA | fn:fe:result | "memory" | "result" | "/r/has a" |  | "FN" |  |
| fn:memory | /r/HasA | fn:fe:duration | "memory" | "duration" | "/r/has a" |  | "FN" |  |
| fn:memory | /r/HasA | fn:fe:place | "memory" | "place" | "/r/has a" |  | "FN" |  |
| fn:memory | /r/HasA | fn:fe:explanation | "memory" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:memory | /r/HasA | fn:fe:time | "memory" | "time" | "/r/has a" |  | "FN" |  |
| fn:memory | /r/HasA | fn:fe:experience | "memory" | "experience" | "/r/has a" |  | "FN" |  |
| fn:memory | /r/HasA | fn:fe:circumstances | "memory" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:awareness | /r/IsA | fn:mental_activity | "awareness" | "mental activity" | "/r/is a" |  | "FN" |  |
| fn:mental_activity | /r/UsedFor | fn:categorization | "mental activity" | "categorization" | "/r/used for" |  | "FN" |  |
| fn:mental_activity | /r/UsedFor | fn:cogitation | "mental activity" | "cogitation" | "/r/used for" |  | "FN" |  |
| fn:mental_activity | /r/UsedFor | fn:coming_to_believe | "mental activity" | "coming to believe" | "/r/used for" |  | "FN" |  |
| fn:mental_activity | /r/UsedFor | fn:differentiation | "mental activity" | "differentiation" | "/r/used for" |  | "FN" |  |
| fn:mental_activity | /r/UsedFor | fn:estimating | "mental activity" | "estimating" | "/r/used for" |  | "FN" |  |
| fn:mental_activity | /r/UsedFor | fn:purpose | "mental activity" | "purpose" | "/r/used for" |  | "FN" |  |
| fn:mental_activity | /r/UsedFor | fn:translating | "mental activity" | "translating" | "/r/used for" |  | "FN" |  |
| fn:fe:sentient_entity | /r/IsA | fn:st:sentient | "sentient entity" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:mental_activity | /r/HasA | fn:fe:sentient_entity | "mental activity" | "sentient entity" | "/r/has a" |  | "FN" |  |
| fn:mental_activity | /r/HasA | fn:fe:content | "mental activity" | "content" | "/r/has a" |  | "FN" |  |
| fn:mental_activity | /r/HasA | fn:fe:evidence | "mental activity" | "evidence" | "/r/has a" |  | "FN" |  |
| fn:mental_activity | /r/HasA | fn:fe:topic | "mental activity" | "topic" | "/r/has a" |  | "FN" |  |
| fn:mental_activity | /r/HasA | fn:fe:degree | "mental activity" | "degree" | "/r/has a" |  | "FN" |  |
| fn:mental_activity | /r/HasA | fn:fe:manner | "mental activity" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fe:expressor | /r/RelatedTo | fn:fe:sentient_entity | "expressor" | "sentient entity" | "/r/related to" |  | "FN" |  |
| fn:mental_activity | /r/HasA | fn:fe:expressor | "mental activity" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:mental_activity | /r/HasA | fn:fe:role | "mental activity" | "role" | "/r/has a" |  | "FN" |  |
| fn:mental_activity | /r/HasA | fn:fe:paradigm | "mental activity" | "paradigm" | "/r/has a" |  | "FN" |  |
| fn:mental_activity | /r/HasA | fn:fe:time | "mental activity" | "time" | "/r/has a" |  | "FN" |  |
| fn:mental_property | /r/IsA | fn:social_behavior_evaluation | "mental property" | "social behavior evaluation" | "/r/is a" |  | "FN" |  |
| fn:mental_property | /r/UsedFor | fn:losing_it | "mental property" | "losing it" | "/r/used for" |  | "FN" |  |
| fn:mental_property | /r/SimilarTo | fn:expertise | "mental property" | "expertise" | "/r/similar to" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:absent-minded | "mental property" | "absent-minded" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:absurd | "mental property" | "absurd" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:absurdity | "mental property" | "absurdity" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:astute | "mental property" | "astute" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:astuteness | "mental property" | "astuteness" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:brainless | "mental property" | "brainless" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:brilliance | "mental property" | "brilliance" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:brilliant | "mental property" | "brilliant" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:broad-minded | "mental property" | "broad-minded" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:bull-headed | "mental property" | "bull-headed" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:canny | "mental property" | "canny" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:careless | "mental property" | "careless" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:carelessness | "mental property" | "carelessness" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:crafty | "mental property" | "crafty" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:crazy | "mental property" | "crazy" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:cunning | "mental property" | "cunning" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:cynical | "mental property" | "cynical" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:daft | "mental property" | "daft" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:diligent | "mental property" | "diligent" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:dim-witted | "mental property" | "dim-witted" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:dim | "mental property" | "dim" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:discerning | "mental property" | "discerning" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:discernment | "mental property" | "discernment" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:enlightened | "mental property" | "enlightened" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:enlightenment | "mental property" | "enlightenment" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:foolish | "mental property" | "foolish" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:foolishness | "mental property" | "foolishness" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:forgetful | "mental property" | "forgetful" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:foxy | "mental property" | "foxy" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:idiotic | "mental property" | "idiotic" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:ill-advised | "mental property" | "ill-advised" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:inane | "mental property" | "inane" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:inattentive | "mental property" | "inattentive" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:ingenious | "mental property" | "ingenious" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:insightful | "mental property" | "insightful" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:intelligent | "mental property" | "intelligent" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:irrational | "mental property" | "irrational" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:ludicrous | "mental property" | "ludicrous" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:moronic | "mental property" | "moronic" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:naive | "mental property" | "naive" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:narrow-minded | "mental property" | "narrow-minded" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:nonsensical | "mental property" | "nonsensical" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:perceptive | "mental property" | "perceptive" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:reasonable | "mental property" | "reasonable" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:ridiculous | "mental property" | "ridiculous" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:sagacious | "mental property" | "sagacious" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:sage | "mental property" | "sage" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:sensible | "mental property" | "sensible" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:shrewd | "mental property" | "shrewd" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:smart | "mental property" | "smart" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:unreasonable | "mental property" | "unreasonable" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:stupid | "mental property" | "stupid" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:crackers | "mental property" | "crackers" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:wise | "mental property" | "wise" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:stupidly | "mental property" | "stupidly" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:narrow-mindedly | "mental property" | "narrow-mindedly" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:carelessly | "mental property" | "carelessly" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:perceptively | "mental property" | "perceptively" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:insightfully | "mental property" | "insightfully" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:wit | "mental property" | "wit" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:acquisitive | "mental property" | "acquisitive" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:carefully | "mental property" | "carefully" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:curious | "mental property" | "curious" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:suspicious | "mental property" | "suspicious" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:sense | "mental property" | "sense" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | fn:HasLexicalUnit | fn:lu:mental_property:common_sense | "mental property" | "common sense" | "has lexical unit" |  | "FN" |  |
| fn:mental_property | /r/HasA | fn:fe:protagonist | "mental property" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:mental_property | /r/HasA | fn:fe:behavior | "mental property" | "behavior" | "/r/has a" |  | "FN" |  |
| fn:fe:practice | /r/HasPrerequisite | fn:fe:protagonist | "practice" | "protagonist" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:practice | /r/RelatedTo | fn:fe:behavior | "practice" | "behavior" | "/r/related to" |  | "FN" |  |
| fn:mental_property | /r/HasA | fn:fe:practice | "mental property" | "practice" | "/r/has a" |  | "FN" |  |
| fn:mental_property | /r/HasA | fn:fe:degree | "mental property" | "degree" | "/r/has a" |  | "FN" |  |
| fn:mental_property | /r/HasA | fn:fe:manner | "mental property" | "manner" | "/r/has a" |  | "FN" |  |
| fn:mental_property | /r/HasA | fn:fe:domain | "mental property" | "domain" | "/r/has a" |  | "FN" |  |
| fn:mental_property | /r/HasA | fn:fe:judge | "mental property" | "judge" | "/r/has a" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | /r/IsA | fn:experiencer_focus | "mental stimulus exp focus" | "experiencer focus" | "/r/is a" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | /r/IsA | fn:emotions_of_mental_activity | "mental stimulus exp focus" | "emotions of mental activity" | "/r/is a" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | fn:HasLexicalUnit | fn:lu:mental_stimulus_exp_focus:interested | "mental stimulus exp focus" | "interested" | "has lexical unit" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | fn:HasLexicalUnit | fn:lu:mental_stimulus_exp_focus:smitten | "mental stimulus exp focus" | "smitten" | "has lexical unit" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | fn:HasLexicalUnit | fn:lu:mental_stimulus_exp_focus:fascinated | "mental stimulus exp focus" | "fascinated" | "has lexical unit" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | fn:HasLexicalUnit | fn:lu:mental_stimulus_exp_focus:infatuated | "mental stimulus exp focus" | "infatuated" | "has lexical unit" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | fn:HasLexicalUnit | fn:lu:mental_stimulus_exp_focus:enthralled | "mental stimulus exp focus" | "enthralled" | "has lexical unit" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | fn:HasLexicalUnit | fn:lu:mental_stimulus_exp_focus:captivated | "mental stimulus exp focus" | "captivated" | "has lexical unit" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | fn:HasLexicalUnit | fn:lu:mental_stimulus_exp_focus:engrossed | "mental stimulus exp focus" | "engrossed" | "has lexical unit" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | fn:HasLexicalUnit | fn:lu:mental_stimulus_exp_focus:absorbed | "mental stimulus exp focus" | "absorbed" | "has lexical unit" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | fn:HasLexicalUnit | fn:lu:mental_stimulus_exp_focus:lost_(in) | "mental stimulus exp focus" | "lost (in)" | "has lexical unit" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | fn:HasLexicalUnit | fn:lu:mental_stimulus_exp_focus:wrapped_up_(in) | "mental stimulus exp focus" | "wrapped up (in)" | "has lexical unit" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | fn:HasLexicalUnit | fn:lu:mental_stimulus_exp_focus:curious | "mental stimulus exp focus" | "curious" | "has lexical unit" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | fn:HasLexicalUnit | fn:lu:mental_stimulus_exp_focus:suspicious | "mental stimulus exp focus" | "suspicious" | "has lexical unit" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | /r/HasA | fn:fe:experiencer | "mental stimulus exp focus" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | /r/HasA | fn:fe:topic | "mental stimulus exp focus" | "topic" | "/r/has a" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | /r/HasA | fn:fe:stimulus | "mental stimulus exp focus" | "stimulus" | "/r/has a" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | /r/HasA | fn:fe:degree | "mental stimulus exp focus" | "degree" | "/r/has a" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | /r/HasA | fn:fe:empathy_target | "mental stimulus exp focus" | "empathy target" | "/r/has a" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | /r/HasA | fn:fe:explanation | "mental stimulus exp focus" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | /r/HasA | fn:fe:circumstances | "mental stimulus exp focus" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | /r/HasA | fn:fe:state | "mental stimulus exp focus" | "state" | "/r/has a" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | /r/HasA | fn:fe:parameter | "mental stimulus exp focus" | "parameter" | "/r/has a" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | /r/HasA | fn:fe:manner | "mental stimulus exp focus" | "manner" | "/r/has a" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | /r/HasA | fn:fe:time | "mental stimulus exp focus" | "time" | "/r/has a" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | /r/HasA | fn:fe:expressor | "mental stimulus exp focus" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:mental_stimulus_exp_focus | /r/HasA | fn:fe:duration | "mental stimulus exp focus" | "duration" | "/r/has a" |  | "FN" |  |
| fn:stimulus_focus | /r/SimilarTo | fn:mental_stimulus_stimulus_focus | "stimulus focus" | "mental stimulus stimulus focus" | "/r/similar to" |  | "FN" |  |
| fn:mental_stimulus_stimulus_focus | /r/IsA | fn:emotions_of_mental_activity | "mental stimulus stimulus focus" | "emotions of mental activity" | "/r/is a" |  | "FN" |  |
| fn:mental_stimulus_stimulus_focus | fn:HasLexicalUnit | fn:lu:mental_stimulus_stimulus_focus:interesting | "mental stimulus stimulus focus" | "interesting" | "has lexical unit" |  | "FN" |  |
| fn:mental_stimulus_stimulus_focus | fn:HasLexicalUnit | fn:lu:mental_stimulus_stimulus_focus:fascinating | "mental stimulus stimulus focus" | "fascinating" | "has lexical unit" |  | "FN" |  |
| fn:mental_stimulus_stimulus_focus | fn:HasLexicalUnit | fn:lu:mental_stimulus_stimulus_focus:enthralling | "mental stimulus stimulus focus" | "enthralling" | "has lexical unit" |  | "FN" |  |
| fn:mental_stimulus_stimulus_focus | fn:HasLexicalUnit | fn:lu:mental_stimulus_stimulus_focus:captivating | "mental stimulus stimulus focus" | "captivating" | "has lexical unit" |  | "FN" |  |
| fn:mental_stimulus_stimulus_focus | fn:HasLexicalUnit | fn:lu:mental_stimulus_stimulus_focus:absorbing | "mental stimulus stimulus focus" | "absorbing" | "has lexical unit" |  | "FN" |  |
| fn:mental_stimulus_stimulus_focus | fn:HasLexicalUnit | fn:lu:mental_stimulus_stimulus_focus:engrossing | "mental stimulus stimulus focus" | "engrossing" | "has lexical unit" |  | "FN" |  |
| fn:mental_stimulus_stimulus_focus | /r/HasA | fn:fe:experiencer | "mental stimulus stimulus focus" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:mental_stimulus_stimulus_focus | /r/HasA | fn:fe:stimulus | "mental stimulus stimulus focus" | "stimulus" | "/r/has a" |  | "FN" |  |
| fn:mental_stimulus_stimulus_focus | /r/HasA | fn:fe:degree | "mental stimulus stimulus focus" | "degree" | "/r/has a" |  | "FN" |  |
| fn:mental_stimulus_stimulus_focus | /r/HasA | fn:fe:empathy_target | "mental stimulus stimulus focus" | "empathy target" | "/r/has a" |  | "FN" |  |
| fn:mental_stimulus_stimulus_focus | /r/HasA | fn:fe:explanation | "mental stimulus stimulus focus" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:mental_stimulus_stimulus_focus | /r/HasA | fn:fe:circumstances | "mental stimulus stimulus focus" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:mental_stimulus_stimulus_focus | /r/HasA | fn:fe:parameter | "mental stimulus stimulus focus" | "parameter" | "/r/has a" |  | "FN" |  |
| fn:mental_stimulus_stimulus_focus | /r/HasA | fn:fe:manner | "mental stimulus stimulus focus" | "manner" | "/r/has a" |  | "FN" |  |
| fn:mental_stimulus_stimulus_focus | /r/HasA | fn:fe:time | "mental stimulus stimulus focus" | "time" | "/r/has a" |  | "FN" |  |
| fn:mental_stimulus_stimulus_focus | /r/HasA | fn:fe:frequency | "mental stimulus stimulus focus" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:indicating | /r/IsA | fn:mention | "indicating" | "mention" | "/r/is a" |  | "FN" |  |
| fn:mention | /r/IsA | fn:communication | "mention" | "communication" | "/r/is a" |  | "FN" |  |
| fn:mention | fn:HasLexicalUnit | fn:lu:mention:mention | "mention" | "mention" | "has lexical unit" |  | "FN" |  |
| fn:mention | fn:HasLexicalUnit | fn:lu:mention:touch_(on) | "mention" | "touch (on)" | "has lexical unit" |  | "FN" |  |
| fn:mention | /r/HasA | fn:fe:communicator | "mention" | "communicator" | "/r/has a" |  | "FN" |  |
| fn:mention | /r/HasA | fn:fe:addressee | "mention" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:fe:message | /r/RelatedTo | fn:fe:specified_content | "message" | "specified content" | "/r/related to" |  | "FN" |  |
| fn:mention | /r/HasA | fn:fe:message | "mention" | "message" | "/r/has a" |  | "FN" |  |
| fn:mention | /r/HasA | fn:fe:medium | "mention" | "medium" | "/r/has a" |  | "FN" |  |
| fn:mention | /r/HasA | fn:fe:depictive | "mention" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:mention | /r/HasA | fn:fe:manner | "mention" | "manner" | "/r/has a" |  | "FN" |  |
| fn:mention | /r/HasA | fn:fe:means | "mention" | "means" | "/r/has a" |  | "FN" |  |
| fn:mention | /r/HasA | fn:fe:time | "mention" | "time" | "/r/has a" |  | "FN" |  |
| fn:mention | /r/HasA | fn:fe:duration | "mention" | "duration" | "/r/has a" |  | "FN" |  |
| fn:mention | /r/HasA | fn:fe:iterations | "mention" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:mention | /r/HasA | fn:fe:particular_iteration | "mention" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:mention | /r/HasA | fn:fe:frequency | "mention" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:fe:specified_content | /r/IsA | fn:st:content | "specified content" | "content" | "/r/is a" |  | "FN" |  |
| fn:mention | /r/HasA | fn:fe:specified_content | "mention" | "specified content" | "/r/has a" |  | "FN" |  |
| fn:mention | /r/HasA | fn:fe:containing_event | "mention" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:mention | /r/HasA | fn:fe:circumstances | "mention" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:mention | /r/HasA | fn:fe:place | "mention" | "place" | "/r/has a" |  | "FN" |  |
| fn:mention | /r/HasA | fn:fe:purpose | "mention" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:military | /r/IsA | fn:organization | "military" | "organization" | "/r/is a" |  | "FN" |  |
| fn:military | /r/UsedFor | fn:member_of_military | "military" | "member of military" | "/r/used for" |  | "FN" |  |
| fn:military | fn:HasLexicalUnit | fn:lu:military:military | "military" | "military" | "has lexical unit" |  | "FN" |  |
| fn:military | fn:HasLexicalUnit | fn:lu:military:force | "military" | "force" | "has lexical unit" |  | "FN" |  |
| fn:military | fn:HasLexicalUnit | fn:lu:military:navy | "military" | "navy" | "has lexical unit" |  | "FN" |  |
| fn:military | fn:HasLexicalUnit | fn:lu:military:air_force | "military" | "air force" | "has lexical unit" |  | "FN" |  |
| fn:military | fn:HasLexicalUnit | fn:lu:military:army | "military" | "army" | "has lexical unit" |  | "FN" |  |
| fn:military | fn:HasLexicalUnit | fn:lu:military:naval | "military" | "naval" | "has lexical unit" |  | "FN" |  |
| fn:military | fn:HasLexicalUnit | fn:lu:military:armed_forces | "military" | "armed forces" | "has lexical unit" |  | "FN" |  |
| fn:military | fn:HasLexicalUnit | fn:lu:military:military | "military" | "military" | "has lexical unit" |  | "FN" |  |
| fn:military | fn:HasLexicalUnit | fn:lu:military:military_forces | "military" | "military forces" | "has lexical unit" |  | "FN" |  |
| fn:military | fn:HasLexicalUnit | fn:lu:military:militia | "military" | "militia" | "has lexical unit" |  | "FN" |  |
| fn:military | fn:HasLexicalUnit | fn:lu:military:national_guard | "military" | "national guard" | "has lexical unit" |  | "FN" |  |
| fn:military | fn:HasLexicalUnit | fn:lu:military:marines | "military" | "marines" | "has lexical unit" |  | "FN" |  |
| fn:military | fn:HasLexicalUnit | fn:lu:military:coast_guard | "military" | "coast guard" | "has lexical unit" |  | "FN" |  |
| fn:fe:force | /r/IsA | fn:st:group | "force" | "group" | "/r/is a" |  | "FN" |  |
| fn:military | /r/HasA | fn:fe:force | "military" | "force" | "/r/has a" |  | "FN" |  |
| fn:military | /r/HasA | fn:fe:possessor | "military" | "possessor" | "/r/has a" |  | "FN" |  |
| fn:military | /r/HasA | fn:fe:descriptor | "military" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:military | /r/HasA | fn:fe:members | "military" | "members" | "/r/has a" |  | "FN" |  |
| fn:military | /r/HasA | fn:fe:domain | "military" | "domain" | "/r/has a" |  | "FN" |  |
| fn:military | /r/HasA | fn:fe:goal | "military" | "goal" | "/r/has a" |  | "FN" |  |
| fn:military | /r/HasA | fn:fe:period_of_existence | "military" | "period of existence" | "/r/has a" |  | "FN" |  |
| fn:military_operation | /r/IsA | fn:intentionally_act | "military operation" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:military_operation | fn:HasLexicalUnit | fn:lu:military_operation:operation | "military operation" | "operation" | "has lexical unit" |  | "FN" |  |
| fn:military_operation | fn:HasLexicalUnit | fn:lu:military_operation:campaign | "military operation" | "campaign" | "has lexical unit" |  | "FN" |  |
| fn:military_operation | fn:HasLexicalUnit | fn:lu:military_operation:operate | "military operation" | "operate" | "has lexical unit" |  | "FN" |  |
| fn:military_operation | /r/HasA | fn:fe:force | "military operation" | "force" | "/r/has a" |  | "FN" |  |
| fn:military_operation | /r/HasA | fn:fe:possessor | "military operation" | "possessor" | "/r/has a" |  | "FN" |  |
| fn:fe:area | /r/IsA | fn:st:locative_relation | "area" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:military_operation | /r/HasA | fn:fe:area | "military operation" | "area" | "/r/has a" |  | "FN" |  |
| fn:fe:opponent | /r/IsA | fn:st:state_of_affairs | "opponent" | "state of affairs" | "/r/is a" |  | "FN" |  |
| fn:military_operation | /r/HasA | fn:fe:opponent | "military operation" | "opponent" | "/r/has a" |  | "FN" |  |
| fn:military_operation | /r/HasA | fn:fe:time | "military operation" | "time" | "/r/has a" |  | "FN" |  |
| fn:military_operation | /r/HasA | fn:fe:duration | "military operation" | "duration" | "/r/has a" |  | "FN" |  |
| fn:military_operation | /r/HasA | fn:fe:manner | "military operation" | "manner" | "/r/has a" |  | "FN" |  |
| fn:military_operation | /r/HasA | fn:fe:means | "military operation" | "means" | "/r/has a" |  | "FN" |  |
| fn:military_operation | /r/HasA | fn:fe:domain | "military operation" | "domain" | "/r/has a" |  | "FN" |  |
| fn:military_operation | /r/HasA | fn:fe:goal | "military operation" | "goal" | "/r/has a" |  | "FN" |  |
| fn:military_operation | /r/HasA | fn:fe:place | "military operation" | "place" | "/r/has a" |  | "FN" |  |
| fn:mining | /r/IsA | fn:attempt_obtain_mineral_scenario | "mining" | "attempt obtain mineral scenario" | "/r/is a" |  | "FN" |  |
| fn:mining | fn:HasLexicalUnit | fn:lu:mining:mine | "mining" | "mine" | "has lexical unit" |  | "FN" |  |
| fn:mining | fn:HasLexicalUnit | fn:lu:mining:miner | "mining" | "miner" | "has lexical unit" |  | "FN" |  |
| fn:mining | fn:HasLexicalUnit | fn:lu:mining:extract | "mining" | "extract" | "has lexical unit" |  | "FN" |  |
| fn:mining | /r/HasA | fn:fe:miner | "mining" | "miner" | "/r/has a" |  | "FN" |  |
| fn:mining | /r/HasA | fn:fe:resource | "mining" | "resource" | "/r/has a" |  | "FN" |  |
| fn:mining | /r/HasA | fn:fe:place | "mining" | "place" | "/r/has a" |  | "FN" |  |
| fn:mining | /r/HasA | fn:fe:means | "mining" | "means" | "/r/has a" |  | "FN" |  |
| fn:mining | /r/HasA | fn:fe:outcome | "mining" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:mining | /r/HasA | fn:fe:time | "mining" | "time" | "/r/has a" |  | "FN" |  |
| fn:misdeed | /r/IsA | fn:event | "misdeed" | "event" | "/r/is a" |  | "FN" |  |
| fn:committing_crime | /r/IsA | fn:misdeed | "committing crime" | "misdeed" | "/r/is a" |  | "FN" |  |
| fn:misdeed | /r/UsedFor | fn:guilt_or_innocence | "misdeed" | "guilt or innocence" | "/r/used for" |  | "FN" |  |
| fn:morality_evaluation | /r/UsedFor | fn:misdeed | "morality evaluation" | "misdeed" | "/r/used for" |  | "FN" |  |
| fn:misdeed | fn:HasLexicalUnit | fn:lu:misdeed:misdeed | "misdeed" | "misdeed" | "has lexical unit" |  | "FN" |  |
| fn:misdeed | fn:HasLexicalUnit | fn:lu:misdeed:sin | "misdeed" | "sin" | "has lexical unit" |  | "FN" |  |
| fn:misdeed | fn:HasLexicalUnit | fn:lu:misdeed:sin | "misdeed" | "sin" | "has lexical unit" |  | "FN" |  |
| fn:misdeed | fn:HasLexicalUnit | fn:lu:misdeed:transgress | "misdeed" | "transgress" | "has lexical unit" |  | "FN" |  |
| fn:misdeed | fn:HasLexicalUnit | fn:lu:misdeed:transgression | "misdeed" | "transgression" | "has lexical unit" |  | "FN" |  |
| fn:misdeed | fn:HasLexicalUnit | fn:lu:misdeed:peccadillo | "misdeed" | "peccadillo" | "has lexical unit" |  | "FN" |  |
| fn:misdeed | /r/HasA | fn:fe:wrongdoer | "misdeed" | "wrongdoer" | "/r/has a" |  | "FN" |  |
| fn:misdeed | /r/HasA | fn:fe:misdeed | "misdeed" | "misdeed" | "/r/has a" |  | "FN" |  |
| fn:misdeed | /r/HasA | fn:fe:severity | "misdeed" | "severity" | "/r/has a" |  | "FN" |  |
| fn:misdeed | /r/HasA | fn:fe:viewpoint | "misdeed" | "viewpoint" | "/r/has a" |  | "FN" |  |
| fn:misdeed | /r/HasA | fn:fe:time | "misdeed" | "time" | "/r/has a" |  | "FN" |  |
| fn:misdeed | /r/HasA | fn:fe:place | "misdeed" | "place" | "/r/has a" |  | "FN" |  |
| fn:misdeed | /r/HasA | fn:fe:purpose | "misdeed" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:misdeed | /r/HasA | fn:fe:means | "misdeed" | "means" | "/r/has a" |  | "FN" |  |
| fn:misdeed | /r/HasA | fn:fe:manner | "misdeed" | "manner" | "/r/has a" |  | "FN" |  |
| fn:misdeed | /r/HasA | fn:fe:injured_party | "misdeed" | "injured party" | "/r/has a" |  | "FN" |  |
| fn:misdeed | /r/HasA | fn:fe:frequency | "misdeed" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:money | /r/IsA | fn:artifact | "money" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:money | fn:HasLexicalUnit | fn:lu:money:money | "money" | "money" | "has lexical unit" |  | "FN" |  |
| fn:money | fn:HasLexicalUnit | fn:lu:money:cash | "money" | "cash" | "has lexical unit" |  | "FN" |  |
| fn:money | fn:HasLexicalUnit | fn:lu:money:funds | "money" | "funds" | "has lexical unit" |  | "FN" |  |
| fn:money | fn:HasLexicalUnit | fn:lu:money:dough | "money" | "dough" | "has lexical unit" |  | "FN" |  |
| fn:money | fn:HasLexicalUnit | fn:lu:money:capital | "money" | "capital" | "has lexical unit" |  | "FN" |  |
| fn:money | fn:HasLexicalUnit | fn:lu:money:dinero | "money" | "dinero" | "has lexical unit" |  | "FN" |  |
| fn:money | fn:HasLexicalUnit | fn:lu:money:sterling | "money" | "sterling" | "has lexical unit" |  | "FN" |  |
| fn:money | fn:HasLexicalUnit | fn:lu:money:fund | "money" | "fund" | "has lexical unit" |  | "FN" |  |
| fn:money | /r/HasA | fn:fe:money | "money" | "money" | "/r/has a" |  | "FN" |  |
| fn:money | /r/HasA | fn:fe:inherent_purpose | "money" | "inherent purpose" | "/r/has a" |  | "FN" |  |
| fn:money | /r/HasA | fn:fe:creator | "money" | "creator" | "/r/has a" |  | "FN" |  |
| fn:money | /r/HasA | fn:fe:time_of_creation | "money" | "time of creation" | "/r/has a" |  | "FN" |  |
| fn:money | /r/HasA | fn:fe:name | "money" | "name" | "/r/has a" |  | "FN" |  |
| fn:money | /r/HasA | fn:fe:type | "money" | "type" | "/r/has a" |  | "FN" |  |
| fn:money | /r/HasA | fn:fe:material | "money" | "material" | "/r/has a" |  | "FN" |  |
| fn:money | /r/HasA | fn:fe:origin | "money" | "origin" | "/r/has a" |  | "FN" |  |
| fn:money | /r/HasA | fn:fe:possessor | "money" | "possessor" | "/r/has a" |  | "FN" |  |
| fn:morality_evaluation | /r/IsA | fn:social_behavior_evaluation | "morality evaluation" | "social behavior evaluation" | "/r/is a" |  | "FN" |  |
| fn:morality_evaluation | /r/UsedFor | fn:legality | "morality evaluation" | "legality" | "/r/used for" |  | "FN" |  |
| fn:morality_evaluation | /r/UsedFor | fn:misdeed | "morality evaluation" | "misdeed" | "/r/used for" |  | "FN" |  |
| fn:morality_evaluation | /r/UsedFor | fn:people_by_morality | "morality evaluation" | "people by morality" | "/r/used for" |  | "FN" |  |
| fn:morality_evaluation | /r/SimilarTo | fn:people_by_morality | "morality evaluation" | "people by morality" | "/r/similar to" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:improper | "morality evaluation" | "improper" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:immoral | "morality evaluation" | "immoral" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:dishonorable | "morality evaluation" | "dishonorable" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:low | "morality evaluation" | "low" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:evil | "morality evaluation" | "evil" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:right | "morality evaluation" | "right" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:honorable | "morality evaluation" | "honorable" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:reprobate | "morality evaluation" | "reprobate" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:vile | "morality evaluation" | "vile" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:sinful | "morality evaluation" | "sinful" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:low-minded | "morality evaluation" | "low-minded" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:wicked | "morality evaluation" | "wicked" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:wrong | "morality evaluation" | "wrong" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:corrupt | "morality evaluation" | "corrupt" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:bad | "morality evaluation" | "bad" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:degenerate | "morality evaluation" | "degenerate" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:depraved | "morality evaluation" | "depraved" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:iniquitous | "morality evaluation" | "iniquitous" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:nefarious | "morality evaluation" | "nefarious" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:unethical | "morality evaluation" | "unethical" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:ethical | "morality evaluation" | "ethical" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:moral | "morality evaluation" | "moral" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:decent | "morality evaluation" | "decent" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:righteous | "morality evaluation" | "righteous" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:upstanding | "morality evaluation" | "upstanding" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:virtuous | "morality evaluation" | "virtuous" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:high-minded | "morality evaluation" | "high-minded" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:good | "morality evaluation" | "good" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:villainous | "morality evaluation" | "villainous" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:felonious | "morality evaluation" | "felonious" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:miscreant | "morality evaluation" | "miscreant" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:heinous | "morality evaluation" | "heinous" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:depravity | "morality evaluation" | "depravity" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:base | "morality evaluation" | "base" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:foul | "morality evaluation" | "foul" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:insidious | "morality evaluation" | "insidious" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:stand-up | "morality evaluation" | "stand-up" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:unscrupulous | "morality evaluation" | "unscrupulous" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | fn:HasLexicalUnit | fn:lu:morality_evaluation:dark | "morality evaluation" | "dark" | "has lexical unit" |  | "FN" |  |
| fn:morality_evaluation | /r/HasA | fn:fe:evaluee | "morality evaluation" | "evaluee" | "/r/has a" |  | "FN" |  |
| fn:morality_evaluation | /r/HasA | fn:fe:behavior | "morality evaluation" | "behavior" | "/r/has a" |  | "FN" |  |
| fn:morality_evaluation | /r/HasA | fn:fe:degree | "morality evaluation" | "degree" | "/r/has a" |  | "FN" |  |
| fn:morality_evaluation | /r/HasA | fn:fe:expressor | "morality evaluation" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:morality_evaluation | /r/HasA | fn:fe:judge | "morality evaluation" | "judge" | "/r/has a" |  | "FN" |  |
| fn:motion | /r/IsA | fn:event | "motion" | "event" | "/r/is a" |  | "FN" |  |
| fn:fluidic_motion | /r/IsA | fn:motion | "fluidic motion" | "motion" | "/r/is a" |  | "FN" |  |
| fn:mass_motion | /r/IsA | fn:motion | "mass motion" | "motion" | "/r/is a" |  | "FN" |  |
| fn:motion_directional | /r/IsA | fn:motion | "motion directional" | "motion" | "/r/is a" |  | "FN" |  |
| fn:motion_noise | /r/IsA | fn:motion | "motion noise" | "motion" | "/r/is a" |  | "FN" |  |
| fn:self_motion | /r/IsA | fn:motion | "self motion" | "motion" | "/r/is a" |  | "FN" |  |
| fn:motion | /r/HasSubevent | fn:getting_underway | "motion" | "getting underway" | "/r/has subevent" |  | "FN" |  |
| fn:motion | /r/HasSubevent | fn:halt | "motion" | "halt" | "/r/has subevent" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:body_movement | "motion" | "body movement" | "/r/used for" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:bringing | "motion" | "bringing" | "/r/used for" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:change_direction | "motion" | "change direction" | "/r/used for" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:cotheme | "motion" | "cotheme" | "/r/used for" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:departing | "motion" | "departing" | "/r/used for" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:emanating | "motion" | "emanating" | "/r/used for" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:evading | "motion" | "evading" | "/r/used for" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:excreting | "motion" | "excreting" | "/r/used for" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:light_movement | "motion" | "light movement" | "/r/used for" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:operate_vehicle | "motion" | "operate vehicle" | "/r/used for" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:path_traveled | "motion" | "path traveled" | "/r/used for" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:placing | "motion" | "placing" | "/r/used for" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:redirecting | "motion" | "redirecting" | "/r/used for" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:removing | "motion" | "removing" | "/r/used for" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:roadways | "motion" | "roadways" | "/r/used for" |  | "FN" |  |
| fn:motion | /r/RelatedTo | fn:bringing | "motion" | "bringing" | "/r/related to" |  | "FN" |  |
| fn:motion | /r/RelatedTo | fn:operate_vehicle | "motion" | "operate vehicle" | "/r/related to" |  | "FN" |  |
| fn:motion | /r/RelatedTo | fn:ride_vehicle | "motion" | "ride vehicle" | "/r/related to" |  | "FN" |  |
| fn:motion | /r/RelatedTo | fn:self_motion | "motion" | "self motion" | "/r/related to" |  | "FN" |  |
| fn:traversing | /r/SimilarTo | fn:motion | "traversing" | "motion" | "/r/similar to" |  | "FN" |  |
| fn:cause_motion | /r/Causes | fn:motion | "cause motion" | "motion" | "/r/causes" |  | "FN" |  |
| fn:motion | /r/IsA | fn:motion_scenario | "motion" | "motion scenario" | "/r/is a" |  | "FN" |  |
| fn:motion | fn:HasLexicalUnit | fn:lu:motion:move | "motion" | "move" | "has lexical unit" |  | "FN" |  |
| fn:motion | fn:HasLexicalUnit | fn:lu:motion:go | "motion" | "go" | "has lexical unit" |  | "FN" |  |
| fn:motion | fn:HasLexicalUnit | fn:lu:motion:drift | "motion" | "drift" | "has lexical unit" |  | "FN" |  |
| fn:motion | fn:HasLexicalUnit | fn:lu:motion:glide | "motion" | "glide" | "has lexical unit" |  | "FN" |  |
| fn:motion | fn:HasLexicalUnit | fn:lu:motion:blow | "motion" | "blow" | "has lexical unit" |  | "FN" |  |
| fn:motion | fn:HasLexicalUnit | fn:lu:motion:float | "motion" | "float" | "has lexical unit" |  | "FN" |  |
| fn:motion | fn:HasLexicalUnit | fn:lu:motion:coast | "motion" | "coast" | "has lexical unit" |  | "FN" |  |
| fn:motion | fn:HasLexicalUnit | fn:lu:motion:roll | "motion" | "roll" | "has lexical unit" |  | "FN" |  |
| fn:motion | fn:HasLexicalUnit | fn:lu:motion:soar | "motion" | "soar" | "has lexical unit" |  | "FN" |  |
| fn:motion | fn:HasLexicalUnit | fn:lu:motion:fly | "motion" | "fly" | "has lexical unit" |  | "FN" |  |
| fn:motion | fn:HasLexicalUnit | fn:lu:motion:slide | "motion" | "slide" | "has lexical unit" |  | "FN" |  |
| fn:motion | fn:HasLexicalUnit | fn:lu:motion:swerve | "motion" | "swerve" | "has lexical unit" |  | "FN" |  |
| fn:motion | fn:HasLexicalUnit | fn:lu:motion:snake | "motion" | "snake" | "has lexical unit" |  | "FN" |  |
| fn:motion | fn:HasLexicalUnit | fn:lu:motion:meander | "motion" | "meander" | "has lexical unit" |  | "FN" |  |
| fn:motion | fn:HasLexicalUnit | fn:lu:motion:undulate | "motion" | "undulate" | "has lexical unit" |  | "FN" |  |
| fn:motion | fn:HasLexicalUnit | fn:lu:motion:weave | "motion" | "weave" | "has lexical unit" |  | "FN" |  |
| fn:motion | fn:HasLexicalUnit | fn:lu:motion:wind | "motion" | "wind" | "has lexical unit" |  | "FN" |  |
| fn:motion | fn:HasLexicalUnit | fn:lu:motion:zigzag | "motion" | "zigzag" | "has lexical unit" |  | "FN" |  |
| fn:motion | fn:HasLexicalUnit | fn:lu:motion:circle | "motion" | "circle" | "has lexical unit" |  | "FN" |  |
| fn:motion | fn:HasLexicalUnit | fn:lu:motion:spiral | "motion" | "spiral" | "has lexical unit" |  | "FN" |  |
| fn:motion | fn:HasLexicalUnit | fn:lu:motion:swing | "motion" | "swing" | "has lexical unit" |  | "FN" |  |
| fn:motion | fn:HasLexicalUnit | fn:lu:motion:travel | "motion" | "travel" | "has lexical unit" |  | "FN" |  |
| fn:motion | fn:HasLexicalUnit | fn:lu:motion:come | "motion" | "come" | "has lexical unit" |  | "FN" |  |
| fn:motion | /r/HasA | fn:fe:theme | "motion" | "theme" | "/r/has a" |  | "FN" |  |
| fn:motion | /r/HasA | fn:fe:source | "motion" | "source" | "/r/has a" |  | "FN" |  |
| fn:motion | /r/HasA | fn:fe:path | "motion" | "path" | "/r/has a" |  | "FN" |  |
| fn:motion | /r/HasA | fn:fe:goal | "motion" | "goal" | "/r/has a" |  | "FN" |  |
| fn:motion | /r/HasA | fn:fe:area | "motion" | "area" | "/r/has a" |  | "FN" |  |
| fn:fe:distance | /r/RelatedTo | fn:fe:area | "distance" | "area" | "/r/related to" |  | "FN" |  |
| fn:motion | /r/HasA | fn:fe:distance | "motion" | "distance" | "/r/has a" |  | "FN" |  |
| fn:motion | /r/HasA | fn:fe:speed | "motion" | "speed" | "/r/has a" |  | "FN" |  |
| fn:motion | /r/HasA | fn:fe:carrier | "motion" | "carrier" | "/r/has a" |  | "FN" |  |
| fn:motion | /r/HasA | fn:fe:duration | "motion" | "duration" | "/r/has a" |  | "FN" |  |
| fn:motion | /r/HasA | fn:fe:time | "motion" | "time" | "/r/has a" |  | "FN" |  |
| fn:motion | /r/HasA | fn:fe:manner | "motion" | "manner" | "/r/has a" |  | "FN" |  |
| fn:motion | /r/HasA | fn:fe:result | "motion" | "result" | "/r/has a" |  | "FN" |  |
| fn:motion | /r/HasA | fn:fe:depictive | "motion" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:motion | /r/HasA | fn:fe:place | "motion" | "place" | "/r/has a" |  | "FN" |  |
| fn:motion | /r/HasA | fn:fe:degree | "motion" | "degree" | "/r/has a" |  | "FN" |  |
| fn:motion | /r/HasA | fn:fe:direction | "motion" | "direction" | "/r/has a" |  | "FN" |  |
| fn:motion | /r/HasA | fn:fe:purpose | "motion" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:motion | /r/HasA | fn:fe:path_shape | "motion" | "path shape" | "/r/has a" |  | "FN" |  |
| fn:motion | /r/HasA | fn:fe:containing_event | "motion" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:motion | /r/HasA | fn:fe:frequency | "motion" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:motion | /r/HasA | fn:fe:iterations | "motion" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:motion_directional | /r/IsA | fn:motion | "motion directional" | "motion" | "/r/is a" |  | "FN" |  |
| fn:motion_directional | /r/UsedFor | fn:precariousness | "motion directional" | "precariousness" | "/r/used for" |  | "FN" |  |
| fn:motion_directional | /r/UsedFor | fn:sidereal_appearance | "motion directional" | "sidereal appearance" | "/r/used for" |  | "FN" |  |
| fn:traversing | /r/SimilarTo | fn:motion_directional | "traversing" | "motion directional" | "/r/similar to" |  | "FN" |  |
| fn:motion_directional | fn:HasLexicalUnit | fn:lu:motion_directional:plummet | "motion directional" | "plummet" | "has lexical unit" |  | "FN" |  |
| fn:motion_directional | fn:HasLexicalUnit | fn:lu:motion_directional:drop | "motion directional" | "drop" | "has lexical unit" |  | "FN" |  |
| fn:motion_directional | fn:HasLexicalUnit | fn:lu:motion_directional:fall | "motion directional" | "fall" | "has lexical unit" |  | "FN" |  |
| fn:motion_directional | fn:HasLexicalUnit | fn:lu:motion_directional:topple | "motion directional" | "topple" | "has lexical unit" |  | "FN" |  |
| fn:motion_directional | fn:HasLexicalUnit | fn:lu:motion_directional:plunge | "motion directional" | "plunge" | "has lexical unit" |  | "FN" |  |
| fn:motion_directional | fn:HasLexicalUnit | fn:lu:motion_directional:descend | "motion directional" | "descend" | "has lexical unit" |  | "FN" |  |
| fn:motion_directional | fn:HasLexicalUnit | fn:lu:motion_directional:rise | "motion directional" | "rise" | "has lexical unit" |  | "FN" |  |
| fn:motion_directional | fn:HasLexicalUnit | fn:lu:motion_directional:dip | "motion directional" | "dip" | "has lexical unit" |  | "FN" |  |
| fn:motion_directional | fn:HasLexicalUnit | fn:lu:motion_directional:angle | "motion directional" | "angle" | "has lexical unit" |  | "FN" |  |
| fn:motion_directional | fn:HasLexicalUnit | fn:lu:motion_directional:slant | "motion directional" | "slant" | "has lexical unit" |  | "FN" |  |
| fn:motion_directional | /r/HasA | fn:fe:area | "motion directional" | "area" | "/r/has a" |  | "FN" |  |
| fn:motion_directional | /r/HasA | fn:fe:depictive | "motion directional" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:motion_directional | /r/HasA | fn:fe:distance | "motion directional" | "distance" | "/r/has a" |  | "FN" |  |
| fn:motion_directional | /r/HasA | fn:fe:duration | "motion directional" | "duration" | "/r/has a" |  | "FN" |  |
| fn:motion_directional | /r/HasA | fn:fe:goal | "motion directional" | "goal" | "/r/has a" |  | "FN" |  |
| fn:motion_directional | /r/HasA | fn:fe:manner | "motion directional" | "manner" | "/r/has a" |  | "FN" |  |
| fn:motion_directional | /r/HasA | fn:fe:path | "motion directional" | "path" | "/r/has a" |  | "FN" |  |
| fn:motion_directional | /r/HasA | fn:fe:speed | "motion directional" | "speed" | "/r/has a" |  | "FN" |  |
| fn:motion_directional | /r/HasA | fn:fe:time | "motion directional" | "time" | "/r/has a" |  | "FN" |  |
| fn:motion_directional | /r/HasA | fn:fe:carrier | "motion directional" | "carrier" | "/r/has a" |  | "FN" |  |
| fn:motion_directional | /r/HasA | fn:fe:theme | "motion directional" | "theme" | "/r/has a" |  | "FN" |  |
| fn:motion_directional | /r/HasA | fn:fe:source | "motion directional" | "source" | "/r/has a" |  | "FN" |  |
| fn:motion_directional | /r/HasA | fn:fe:result | "motion directional" | "result" | "/r/has a" |  | "FN" |  |
| fn:motion_directional | /r/HasA | fn:fe:place | "motion directional" | "place" | "/r/has a" |  | "FN" |  |
| fn:motion_directional | /r/HasA | fn:fe:degree | "motion directional" | "degree" | "/r/has a" |  | "FN" |  |
| fn:motion_directional | /r/HasA | fn:fe:point_of_contact | "motion directional" | "point of contact" | "/r/has a" |  | "FN" |  |
| fn:motion_directional | /r/HasA | fn:fe:path_shape | "motion directional" | "path shape" | "/r/has a" |  | "FN" |  |
| fn:motion_directional | /r/HasA | fn:fe:means | "motion directional" | "means" | "/r/has a" |  | "FN" |  |
| fn:motion_directional | /r/HasA | fn:fe:direction | "motion directional" | "direction" | "/r/has a" |  | "FN" |  |
| fn:motion_directional | /r/HasA | fn:fe:explanation | "motion directional" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:motion_directional | /r/HasA | fn:fe:purpose | "motion directional" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:motion_directional | /r/HasA | fn:fe:circumstances | "motion directional" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:motion_noise | /r/IsA | fn:motion | "motion noise" | "motion" | "/r/is a" |  | "FN" |  |
| fn:make_noise | /r/RelatedTo | fn:motion_noise | "make noise" | "motion noise" | "/r/related to" |  | "FN" |  |
| fn:make_noise | /r/SimilarTo | fn:motion_noise | "make noise" | "motion noise" | "/r/similar to" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:bang | "motion noise" | "bang" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:buzz | "motion noise" | "buzz" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:chug | "motion noise" | "chug" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:clack | "motion noise" | "clack" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:clang | "motion noise" | "clang" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:clank | "motion noise" | "clank" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:clatter | "motion noise" | "clatter" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:click | "motion noise" | "click" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:clink | "motion noise" | "clink" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:clump | "motion noise" | "clump" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:clunk | "motion noise" | "clunk" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:crackle | "motion noise" | "crackle" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:crash | "motion noise" | "crash" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:creak | "motion noise" | "creak" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:crunch | "motion noise" | "crunch" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:fizz | "motion noise" | "fizz" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:gurgle | "motion noise" | "gurgle" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:howl | "motion noise" | "howl" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:patter | "motion noise" | "patter" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:ping | "motion noise" | "ping" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:purr | "motion noise" | "purr" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:putter | "motion noise" | "putter" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:roar | "motion noise" | "roar" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:rumble | "motion noise" | "rumble" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:rustle | "motion noise" | "rustle" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:screech | "motion noise" | "screech" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:splash | "motion noise" | "splash" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:splutter | "motion noise" | "splutter" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:squelch | "motion noise" | "squelch" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:swish | "motion noise" | "swish" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:thud | "motion noise" | "thud" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:thump | "motion noise" | "thump" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:thunder | "motion noise" | "thunder" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:wheeze | "motion noise" | "wheeze" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:whine | "motion noise" | "whine" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:whir | "motion noise" | "whir" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:zing | "motion noise" | "zing" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | fn:HasLexicalUnit | fn:lu:motion_noise:hiss | "motion noise" | "hiss" | "has lexical unit" |  | "FN" |  |
| fn:motion_noise | /r/HasA | fn:fe:cause | "motion noise" | "cause" | "/r/has a" |  | "FN" |  |
| fn:motion_noise | /r/HasA | fn:fe:theme | "motion noise" | "theme" | "/r/has a" |  | "FN" |  |
| fn:motion_noise | /r/HasA | fn:fe:source | "motion noise" | "source" | "/r/has a" |  | "FN" |  |
| fn:motion_noise | /r/HasA | fn:fe:path | "motion noise" | "path" | "/r/has a" |  | "FN" |  |
| fn:motion_noise | /r/HasA | fn:fe:goal | "motion noise" | "goal" | "/r/has a" |  | "FN" |  |
| fn:motion_noise | /r/HasA | fn:fe:area | "motion noise" | "area" | "/r/has a" |  | "FN" |  |
| fn:motion_noise | /r/HasA | fn:fe:distance | "motion noise" | "distance" | "/r/has a" |  | "FN" |  |
| fn:motion_noise | /r/HasA | fn:fe:speed | "motion noise" | "speed" | "/r/has a" |  | "FN" |  |
| fn:motion_noise | /r/HasA | fn:fe:depictive | "motion noise" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:motion_noise | /r/HasA | fn:fe:manner | "motion noise" | "manner" | "/r/has a" |  | "FN" |  |
| fn:motion_noise | /r/HasA | fn:fe:means | "motion noise" | "means" | "/r/has a" |  | "FN" |  |
| fn:motion_noise | /r/HasA | fn:fe:result | "motion noise" | "result" | "/r/has a" |  | "FN" |  |
| fn:motion_noise | /r/HasA | fn:fe:degree | "motion noise" | "degree" | "/r/has a" |  | "FN" |  |
| fn:motion_noise | /r/HasA | fn:fe:place | "motion noise" | "place" | "/r/has a" |  | "FN" |  |
| fn:motion_noise | /r/HasA | fn:fe:duration | "motion noise" | "duration" | "/r/has a" |  | "FN" |  |
| fn:motion_noise | /r/HasA | fn:fe:time | "motion noise" | "time" | "/r/has a" |  | "FN" |  |
| fn:motion_scenario | /r/UsedFor | fn:operate_vehicle_scenario | "motion scenario" | "operate vehicle scenario" | "/r/used for" |  | "FN" |  |
| fn:motion | /r/IsA | fn:motion_scenario | "motion" | "motion scenario" | "/r/is a" |  | "FN" |  |
| fn:source_of_getting | /r/IsA | fn:motion_scenario | "source of getting" | "motion scenario" | "/r/is a" |  | "FN" |  |
| fn:source_path_goal | /r/IsA | fn:motion_scenario | "source path goal" | "motion scenario" | "/r/is a" |  | "FN" |  |
| fn:traversing | /r/IsA | fn:motion_scenario | "traversing" | "motion scenario" | "/r/is a" |  | "FN" |  |
| fn:motion_scenario | /r/HasA | fn:fe:duration | "motion scenario" | "duration" | "/r/has a" |  | "FN" |  |
| fn:motion_scenario | /r/HasA | fn:fe:time | "motion scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:motion_scenario | /r/HasA | fn:fe:area | "motion scenario" | "area" | "/r/has a" |  | "FN" |  |
| fn:motion_scenario | /r/HasA | fn:fe:cotheme | "motion scenario" | "cotheme" | "/r/has a" |  | "FN" |  |
| fn:motion_scenario | /r/HasA | fn:fe:distance | "motion scenario" | "distance" | "/r/has a" |  | "FN" |  |
| fn:motion_scenario | /r/HasA | fn:fe:goal | "motion scenario" | "goal" | "/r/has a" |  | "FN" |  |
| fn:motion_scenario | /r/HasA | fn:fe:path | "motion scenario" | "path" | "/r/has a" |  | "FN" |  |
| fn:motion_scenario | /r/HasA | fn:fe:source | "motion scenario" | "source" | "/r/has a" |  | "FN" |  |
| fn:motion_scenario | /r/HasA | fn:fe:speed | "motion scenario" | "speed" | "/r/has a" |  | "FN" |  |
| fn:motion_scenario | /r/HasA | fn:fe:theme | "motion scenario" | "theme" | "/r/has a" |  | "FN" |  |
| fn:motion_scenario | /r/HasA | fn:fe:mode_of_transportation | "motion scenario" | "mode of transportation" | "/r/has a" |  | "FN" |  |
| fn:cause_to_move_in_place | /r/SimilarTo | fn:moving_in_place | "cause to move in place" | "moving in place" | "/r/similar to" |  | "FN" |  |
| fn:traversing | /r/SimilarTo | fn:moving_in_place | "traversing" | "moving in place" | "/r/similar to" |  | "FN" |  |
| fn:cause_to_move_in_place | /r/Causes | fn:moving_in_place | "cause to move in place" | "moving in place" | "/r/causes" |  | "FN" |  |
| fn:moving_in_place | fn:HasLexicalUnit | fn:lu:moving_in_place:judder | "moving in place" | "judder" | "has lexical unit" |  | "FN" |  |
| fn:moving_in_place | fn:HasLexicalUnit | fn:lu:moving_in_place:rotate | "moving in place" | "rotate" | "has lexical unit" |  | "FN" |  |
| fn:moving_in_place | fn:HasLexicalUnit | fn:lu:moving_in_place:shake | "moving in place" | "shake" | "has lexical unit" |  | "FN" |  |
| fn:moving_in_place | fn:HasLexicalUnit | fn:lu:moving_in_place:twirl | "moving in place" | "twirl" | "has lexical unit" |  | "FN" |  |
| fn:moving_in_place | fn:HasLexicalUnit | fn:lu:moving_in_place:vibrate | "moving in place" | "vibrate" | "has lexical unit" |  | "FN" |  |
| fn:moving_in_place | fn:HasLexicalUnit | fn:lu:moving_in_place:swing | "moving in place" | "swing" | "has lexical unit" |  | "FN" |  |
| fn:moving_in_place | fn:HasLexicalUnit | fn:lu:moving_in_place:flop | "moving in place" | "flop" | "has lexical unit" |  | "FN" |  |
| fn:moving_in_place | fn:HasLexicalUnit | fn:lu:moving_in_place:quiver | "moving in place" | "quiver" | "has lexical unit" |  | "FN" |  |
| fn:moving_in_place | fn:HasLexicalUnit | fn:lu:moving_in_place:quiver | "moving in place" | "quiver" | "has lexical unit" |  | "FN" |  |
| fn:moving_in_place | fn:HasLexicalUnit | fn:lu:moving_in_place:wave | "moving in place" | "wave" | "has lexical unit" |  | "FN" |  |
| fn:moving_in_place | fn:HasLexicalUnit | fn:lu:moving_in_place:rock | "moving in place" | "rock" | "has lexical unit" |  | "FN" |  |
| fn:moving_in_place | fn:HasLexicalUnit | fn:lu:moving_in_place:roll | "moving in place" | "roll" | "has lexical unit" |  | "FN" |  |
| fn:moving_in_place | fn:HasLexicalUnit | fn:lu:moving_in_place:swing | "moving in place" | "swing" | "has lexical unit" |  | "FN" |  |
| fn:moving_in_place | fn:HasLexicalUnit | fn:lu:moving_in_place:spin | "moving in place" | "spin" | "has lexical unit" |  | "FN" |  |
| fn:moving_in_place | fn:HasLexicalUnit | fn:lu:moving_in_place:turn | "moving in place" | "turn" | "has lexical unit" |  | "FN" |  |
| fn:moving_in_place | fn:HasLexicalUnit | fn:lu:moving_in_place:earthquake | "moving in place" | "earthquake" | "has lexical unit" |  | "FN" |  |
| fn:moving_in_place | fn:HasLexicalUnit | fn:lu:moving_in_place:temblor | "moving in place" | "temblor" | "has lexical unit" |  | "FN" |  |
| fn:moving_in_place | fn:HasLexicalUnit | fn:lu:moving_in_place:quake | "moving in place" | "quake" | "has lexical unit" |  | "FN" |  |
| fn:moving_in_place | /r/HasA | fn:fe:theme | "moving in place" | "theme" | "/r/has a" |  | "FN" |  |
| fn:moving_in_place | /r/HasA | fn:fe:fixed_location | "moving in place" | "fixed location" | "/r/has a" |  | "FN" |  |
| fn:moving_in_place | /r/HasA | fn:fe:periodicity | "moving in place" | "periodicity" | "/r/has a" |  | "FN" |  |
| fn:moving_in_place | /r/HasA | fn:fe:angle | "moving in place" | "angle" | "/r/has a" |  | "FN" |  |
| fn:moving_in_place | /r/HasA | fn:fe:time | "moving in place" | "time" | "/r/has a" |  | "FN" |  |
| fn:moving_in_place | /r/HasA | fn:fe:place | "moving in place" | "place" | "/r/has a" |  | "FN" |  |
| fn:moving_in_place | /r/HasA | fn:fe:direction | "moving in place" | "direction" | "/r/has a" |  | "FN" |  |
| fn:moving_in_place | /r/HasA | fn:fe:manner | "moving in place" | "manner" | "/r/has a" |  | "FN" |  |
| fn:moving_in_place | /r/HasA | fn:fe:result | "moving in place" | "result" | "/r/has a" |  | "FN" |  |
| fn:moving_in_place | /r/HasA | fn:fe:explanation | "moving in place" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:moving_in_place | /r/HasA | fn:fe:depictive | "moving in place" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:moving_in_place | /r/HasA | fn:fe:purpose | "moving in place" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:moving_in_place | /r/HasA | fn:fe:path_shape | "moving in place" | "path shape" | "/r/has a" |  | "FN" |  |
| fn:name_conferral | /r/IsA | fn:intentionally_act | "name conferral" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:name_conferral | "communication" | "name conferral" | "/r/used for" |  | "FN" |  |
| fn:name_conferral | /r/Causes | fn:being_named | "name conferral" | "being named" | "/r/causes" |  | "FN" |  |
| fn:name_conferral | fn:HasLexicalUnit | fn:lu:name_conferral:nickname | "name conferral" | "nickname" | "has lexical unit" |  | "FN" |  |
| fn:name_conferral | fn:HasLexicalUnit | fn:lu:name_conferral:dub | "name conferral" | "dub" | "has lexical unit" |  | "FN" |  |
| fn:name_conferral | fn:HasLexicalUnit | fn:lu:name_conferral:christen | "name conferral" | "christen" | "has lexical unit" |  | "FN" |  |
| fn:name_conferral | fn:HasLexicalUnit | fn:lu:name_conferral:name | "name conferral" | "name" | "has lexical unit" |  | "FN" |  |
| fn:name_conferral | fn:HasLexicalUnit | fn:lu:name_conferral:baptize | "name conferral" | "baptize" | "has lexical unit" |  | "FN" |  |
| fn:name_conferral | fn:HasLexicalUnit | fn:lu:name_conferral:rename | "name conferral" | "rename" | "has lexical unit" |  | "FN" |  |
| fn:name_conferral | fn:HasLexicalUnit | fn:lu:name_conferral:entitle | "name conferral" | "entitle" | "has lexical unit" |  | "FN" |  |
| fn:name_conferral | fn:HasLexicalUnit | fn:lu:name_conferral:call | "name conferral" | "call" | "has lexical unit" |  | "FN" |  |
| fn:name_conferral | /r/HasA | fn:fe:entity | "name conferral" | "entity" | "/r/has a" |  | "FN" |  |
| fn:name_conferral | /r/HasA | fn:fe:name | "name conferral" | "name" | "/r/has a" |  | "FN" |  |
| fn:name_conferral | /r/HasA | fn:fe:speaker | "name conferral" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:name_conferral | /r/HasA | fn:fe:instrument | "name conferral" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:name_conferral | /r/HasA | fn:fe:explanation | "name conferral" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:name_conferral | /r/HasA | fn:fe:place | "name conferral" | "place" | "/r/has a" |  | "FN" |  |
| fn:name_conferral | /r/HasA | fn:fe:purpose | "name conferral" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:name_conferral | /r/HasA | fn:fe:time | "name conferral" | "time" | "/r/has a" |  | "FN" |  |
| fn:name_conferral | /r/HasA | fn:fe:name_source | "name conferral" | "name source" | "/r/has a" |  | "FN" |  |
| fn:name_conferral | /r/HasA | fn:fe:manner | "name conferral" | "manner" | "/r/has a" |  | "FN" |  |
| fn:name_conferral | /r/HasA | fn:fe:means | "name conferral" | "means" | "/r/has a" |  | "FN" |  |
| fn:being_named | /r/UsedFor | fn:namesake | "being named" | "namesake" | "/r/used for" |  | "FN" |  |
| fn:being_named | /r/SimilarTo | fn:namesake | "being named" | "namesake" | "/r/similar to" |  | "FN" |  |
| fn:namesake | fn:HasLexicalUnit | fn:lu:namesake:namesake | "namesake" | "namesake" | "has lexical unit" |  | "FN" |  |
| fn:namesake | fn:HasLexicalUnit | fn:lu:namesake:eponymous | "namesake" | "eponymous" | "has lexical unit" |  | "FN" |  |
| fn:namesake | /r/HasA | fn:fe:entity | "namesake" | "entity" | "/r/has a" |  | "FN" |  |
| fn:namesake | /r/HasA | fn:fe:namesake | "namesake" | "namesake" | "/r/has a" |  | "FN" |  |
| fn:namesake | /r/HasA | fn:fe:anchor | "namesake" | "anchor" | "/r/has a" |  | "FN" |  |
| fn:namesake | /r/HasA | fn:fe:descriptor | "namesake" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:natural_features | /r/IsA | fn:locale | "natural features" | "locale" | "/r/is a" |  | "FN" |  |
| fn:relational_natural_features | /r/IsA | fn:natural_features | "relational natural features" | "natural features" | "/r/is a" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:rill | "natural features" | "rill" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:hill | "natural features" | "hill" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:mountain | "natural features" | "mountain" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:knoll | "natural features" | "knoll" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:cordillera | "natural features" | "cordillera" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:lake | "natural features" | "lake" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:pond | "natural features" | "pond" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:tarn | "natural features" | "tarn" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:creek | "natural features" | "creek" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:vale | "natural features" | "vale" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:crevasse | "natural features" | "crevasse" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:sound | "natural features" | "sound" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:strait | "natural features" | "strait" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:valley | "natural features" | "valley" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:river | "natural features" | "river" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:sea | "natural features" | "sea" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:ocean | "natural features" | "ocean" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:pool | "natural features" | "pool" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:peninsula | "natural features" | "peninsula" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:fjord | "natural features" | "fjord" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:outcrop | "natural features" | "outcrop" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:island | "natural features" | "island" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:archipelago | "natural features" | "archipelago" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:crag | "natural features" | "crag" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:glacier | "natural features" | "glacier" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:canyon | "natural features" | "canyon" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:mount | "natural features" | "mount" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:cove | "natural features" | "cove" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:bay | "natural features" | "bay" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:inlet | "natural features" | "inlet" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:cliff | "natural features" | "cliff" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:channel | "natural features" | "channel" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:headland | "natural features" | "headland" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:isthmus | "natural features" | "isthmus" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:cave | "natural features" | "cave" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:cavern | "natural features" | "cavern" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:iceberg | "natural features" | "iceberg" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:berg | "natural features" | "berg" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:waterfall | "natural features" | "waterfall" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:falls | "natural features" | "falls" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:spring | "natural features" | "spring" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:cataract | "natural features" | "cataract" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:stream | "natural features" | "stream" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:brook | "natural features" | "brook" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:atoll | "natural features" | "atoll" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:floe | "natural features" | "floe" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:dune | "natural features" | "dune" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:massif | "natural features" | "massif" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:loch | "natural features" | "loch" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:butte | "natural features" | "butte" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:fell | "natural features" | "fell" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:hillock | "natural features" | "hillock" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:mesa | "natural features" | "mesa" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:isle | "natural features" | "isle" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:islet | "natural features" | "islet" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:cay | "natural features" | "cay" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:sandbar | "natural features" | "sandbar" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:coombe | "natural features" | "coombe" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:key | "natural features" | "key" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:crater | "natural features" | "crater" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:bar | "natural features" | "bar" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:sandbank | "natural features" | "sandbank" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:sandspit | "natural features" | "sandspit" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:reef | "natural features" | "reef" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:clough | "natural features" | "clough" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:dale | "natural features" | "dale" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:defile | "natural features" | "defile" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:dell | "natural features" | "dell" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:depression | "natural features" | "depression" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:range | "natural features" | "range" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:dingle | "natural features" | "dingle" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:gap | "natural features" | "gap" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:pass | "natural features" | "pass" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:glen | "natural features" | "glen" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:graben | "natural features" | "graben" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:gulch | "natural features" | "gulch" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:gully | "natural features" | "gully" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:hollow | "natural features" | "hollow" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:ravine | "natural features" | "ravine" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:beck | "natural features" | "beck" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:hummock | "natural features" | "hummock" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:moraine | "natural features" | "moraine" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:burn | "natural features" | "burn" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:shelf | "natural features" | "shelf" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:shoal | "natural features" | "shoal" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:lagoon | "natural features" | "lagoon" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:slough | "natural features" | "slough" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:bayou | "natural features" | "bayou" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:tor | "natural features" | "tor" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:eyot | "natural features" | "eyot" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:plateau | "natural features" | "plateau" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:seamount | "natural features" | "seamount" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:guyot | "natural features" | "guyot" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:volcano | "natural features" | "volcano" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:declivity | "natural features" | "declivity" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:corrie | "natural features" | "corrie" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:ridge | "natural features" | "ridge" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:skerry | "natural features" | "skerry" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:rapids | "natural features" | "rapids" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:watershed | "natural features" | "watershed" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:height | "natural features" | "height" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:cirque | "natural features" | "cirque" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:beach | "natural features" | "beach" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:continent | "natural features" | "continent" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:continental | "natural features" | "continental" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:peak | "natural features" | "peak" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:coastal | "natural features" | "coastal" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:wash | "natural features" | "wash" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:strand | "natural features" | "strand" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:rugged | "natural features" | "rugged" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:gulf | "natural features" | "gulf" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:cascade | "natural features" | "cascade" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:land | "natural features" | "land" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:water | "natural features" | "water" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | fn:HasLexicalUnit | fn:lu:natural_features:range_[grazing] | "natural features" | "range [grazing]" | "has lexical unit" |  | "FN" |  |
| fn:natural_features | /r/HasA | fn:fe:constituent_parts | "natural features" | "constituent parts" | "/r/has a" |  | "FN" |  |
| fn:natural_features | /r/HasA | fn:fe:container_possessor | "natural features" | "container possessor" | "/r/has a" |  | "FN" |  |
| fn:natural_features | /r/HasA | fn:fe:formational_cause | "natural features" | "formational cause" | "/r/has a" |  | "FN" |  |
| fn:natural_features | /r/HasA | fn:fe:locale | "natural features" | "locale" | "/r/has a" |  | "FN" |  |
| fn:natural_features | /r/HasA | fn:fe:name | "natural features" | "name" | "/r/has a" |  | "FN" |  |
| fn:natural_features | /r/HasA | fn:fe:relative_location | "natural features" | "relative location" | "/r/has a" |  | "FN" |  |
| fn:natural_features | /r/HasA | fn:fe:type | "natural features" | "type" | "/r/has a" |  | "FN" |  |
| fn:natural_features | /r/HasA | fn:fe:descriptor | "natural features" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:desiring | /r/UsedFor | fn:needing | "desiring" | "needing" | "/r/used for" |  | "FN" |  |
| fn:have_as_requirement | /r/UsedFor | fn:needing | "have as requirement" | "needing" | "/r/used for" |  | "FN" |  |
| fn:needing | /r/UsedFor | fn:reliance | "needing" | "reliance" | "/r/used for" |  | "FN" |  |
| fn:needing | fn:HasLexicalUnit | fn:lu:needing:need | "needing" | "need" | "has lexical unit" |  | "FN" |  |
| fn:needing | fn:HasLexicalUnit | fn:lu:needing:require | "needing" | "require" | "has lexical unit" |  | "FN" |  |
| fn:needing | fn:HasLexicalUnit | fn:lu:needing:need | "needing" | "need" | "has lexical unit" |  | "FN" |  |
| fn:needing | /r/HasA | fn:fe:cognizer | "needing" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:needing | /r/HasA | fn:fe:requirement | "needing" | "requirement" | "/r/has a" |  | "FN" |  |
| fn:needing | /r/HasA | fn:fe:dependent | "needing" | "dependent" | "/r/has a" |  | "FN" |  |
| fn:needing | /r/HasA | fn:fe:circumstances | "needing" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:needing | /r/HasA | fn:fe:degree | "needing" | "degree" | "/r/has a" |  | "FN" |  |
| fn:needing | /r/HasA | fn:fe:time | "needing" | "time" | "/r/has a" |  | "FN" |  |
| fn:needing | /r/HasA | fn:fe:place | "needing" | "place" | "/r/has a" |  | "FN" |  |
| fn:needing | /r/HasA | fn:fe:consequences | "needing" | "consequences" | "/r/has a" |  | "FN" |  |
| fn:needing | /r/HasA | fn:fe:frequency | "needing" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:needing | /r/HasA | fn:fe:iterations | "needing" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:needing | /r/HasA | fn:fe:particular_iteration | "needing" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:needing | /r/HasA | fn:fe:explanation | "needing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:negation | /r/IsA | fn:alternativity | "negation" | "alternativity" | "/r/is a" |  | "FN" |  |
| fn:negation | /r/UsedFor | fn:presentation_of_mitigation | "negation" | "presentation of mitigation" | "/r/used for" |  | "FN" |  |
| fn:negation | fn:HasLexicalUnit | fn:lu:negation:not | "negation" | "not" | "has lexical unit" |  | "FN" |  |
| fn:negation | fn:HasLexicalUnit | fn:lu:negation:never | "negation" | "never" | "has lexical unit" |  | "FN" |  |
| fn:negation | fn:HasLexicalUnit | fn:lu:negation:without | "negation" | "without" | "has lexical unit" |  | "FN" |  |
| fn:negation | fn:HasLexicalUnit | fn:lu:negation:no | "negation" | "no" | "has lexical unit" |  | "FN" |  |
| fn:negation | fn:HasLexicalUnit | fn:lu:negation:no_longer | "negation" | "no longer" | "has lexical unit" |  | "FN" |  |
| fn:negation | fn:HasLexicalUnit | fn:lu:negation:far | "negation" | "far" | "has lexical unit" |  | "FN" |  |
| fn:negation | /r/HasA | fn:fe:negated_proposition | "negation" | "negated proposition" | "/r/has a" |  | "FN" |  |
| fn:negation | /r/HasA | fn:fe:factual_situation | "negation" | "factual situation" | "/r/has a" |  | "FN" |  |
| fn:negative_conditional | /r/IsA | fn:conditional_scenario | "negative conditional" | "conditional scenario" | "/r/is a" |  | "FN" |  |
| fn:negative_conditional | fn:HasLexicalUnit | fn:lu:negative_conditional:unless | "negative conditional" | "unless" | "has lexical unit" |  | "FN" |  |
| fn:negative_conditional | fn:HasLexicalUnit | fn:lu:negative_conditional:otherwise | "negative conditional" | "otherwise" | "has lexical unit" |  | "FN" |  |
| fn:negative_conditional | /r/HasA | fn:fe:profiled_possibility | "negative conditional" | "profiled possibility" | "/r/has a" |  | "FN" |  |
| fn:negative_conditional | /r/HasA | fn:fe:anti_consequence | "negative conditional" | "anti consequence" | "/r/has a" |  | "FN" |  |
| fn:set_of_interrelated_entities | /r/UsedFor | fn:network | "set of interrelated entities" | "network" | "/r/used for" |  | "FN" |  |
| fn:network | fn:HasLexicalUnit | fn:lu:network:network | "network" | "network" | "has lexical unit" |  | "FN" |  |
| fn:network | fn:HasLexicalUnit | fn:lu:network:web | "network" | "web" | "has lexical unit" |  | "FN" |  |
| fn:network | /r/HasA | fn:fe:network | "network" | "network" | "/r/has a" |  | "FN" |  |
| fn:network | /r/HasA | fn:fe:nodes | "network" | "nodes" | "/r/has a" |  | "FN" |  |
| fn:network | /r/HasA | fn:fe:connections | "network" | "connections" | "/r/has a" |  | "FN" |  |
| fn:network | /r/HasA | fn:fe:descriptor | "network" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:network | /r/HasA | fn:fe:possessor | "network" | "possessor" | "/r/has a" |  | "FN" |  |
| fn:noise_makers | /r/IsA | fn:artifact | "noise makers" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:noise_makers | fn:HasLexicalUnit | fn:lu:noise_makers:guitar | "noise makers" | "guitar" | "has lexical unit" |  | "FN" |  |
| fn:noise_makers | fn:HasLexicalUnit | fn:lu:noise_makers:bell | "noise makers" | "bell" | "has lexical unit" |  | "FN" |  |
| fn:noise_makers | fn:HasLexicalUnit | fn:lu:noise_makers:siren | "noise makers" | "siren" | "has lexical unit" |  | "FN" |  |
| fn:noise_makers | fn:HasLexicalUnit | fn:lu:noise_makers:piano | "noise makers" | "piano" | "has lexical unit" |  | "FN" |  |
| fn:noise_makers | fn:HasLexicalUnit | fn:lu:noise_makers:rattle | "noise makers" | "rattle" | "has lexical unit" |  | "FN" |  |
| fn:noise_makers | fn:HasLexicalUnit | fn:lu:noise_makers:xylophone | "noise makers" | "xylophone" | "has lexical unit" |  | "FN" |  |
| fn:noise_makers | fn:HasLexicalUnit | fn:lu:noise_makers:drum | "noise makers" | "drum" | "has lexical unit" |  | "FN" |  |
| fn:noise_makers | fn:HasLexicalUnit | fn:lu:noise_makers:cello | "noise makers" | "cello" | "has lexical unit" |  | "FN" |  |
| fn:noise_makers | fn:HasLexicalUnit | fn:lu:noise_makers:saxophone | "noise makers" | "saxophone" | "has lexical unit" |  | "FN" |  |
| fn:noise_makers | fn:HasLexicalUnit | fn:lu:noise_makers:alarm | "noise makers" | "alarm" | "has lexical unit" |  | "FN" |  |
| fn:fe:noise_maker | /r/IsA | fn:st:artifact | "noise maker" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:noise_makers | /r/HasA | fn:fe:noise_maker | "noise makers" | "noise maker" | "/r/has a" |  | "FN" |  |
| fn:noise_makers | /r/HasA | fn:fe:use | "noise makers" | "use" | "/r/has a" |  | "FN" |  |
| fn:noise_makers | /r/HasA | fn:fe:creator | "noise makers" | "creator" | "/r/has a" |  | "FN" |  |
| fn:noise_makers | /r/HasA | fn:fe:time_of_creation | "noise makers" | "time of creation" | "/r/has a" |  | "FN" |  |
| fn:noise_makers | /r/HasA | fn:fe:name | "noise makers" | "name" | "/r/has a" |  | "FN" |  |
| fn:noise_makers | /r/HasA | fn:fe:type | "noise makers" | "type" | "/r/has a" |  | "FN" |  |
| fn:noise_makers | /r/HasA | fn:fe:material | "noise makers" | "material" | "/r/has a" |  | "FN" |  |
| fn:noise_makers | /r/HasA | fn:fe:ground | "noise makers" | "ground" | "/r/has a" |  | "FN" |  |
| fn:non-commutative_process | /r/IsA | fn:arithmetic_non-commutative | "non-commutative process" | "arithmetic non-commutative" | "/r/is a" |  | "FN" |  |
| fn:non-commutative_process | fn:HasLexicalUnit | fn:lu:non-commutative_process:subtract | "non-commutative process" | "subtract" | "has lexical unit" |  | "FN" |  |
| fn:non-commutative_process | fn:HasLexicalUnit | fn:lu:non-commutative_process:divide | "non-commutative process" | "divide" | "has lexical unit" |  | "FN" |  |
| fn:non-commutative_process | fn:HasLexicalUnit | fn:lu:non-commutative_process:subtraction | "non-commutative process" | "subtraction" | "has lexical unit" |  | "FN" |  |
| fn:non-commutative_process | fn:HasLexicalUnit | fn:lu:non-commutative_process:division | "non-commutative process" | "division" | "has lexical unit" |  | "FN" |  |
| fn:non-commutative_process | fn:HasLexicalUnit | fn:lu:non-commutative_process:take_away | "non-commutative process" | "take away" | "has lexical unit" |  | "FN" |  |
| fn:non-commutative_process | /r/HasA | fn:fe:term_1 | "non-commutative process" | "term 1" | "/r/has a" |  | "FN" |  |
| fn:non-commutative_process | /r/HasA | fn:fe:term_2 | "non-commutative process" | "term 2" | "/r/has a" |  | "FN" |  |
| fn:non-commutative_process | /r/HasA | fn:fe:calculator | "non-commutative process" | "calculator" | "/r/has a" |  | "FN" |  |
| fn:non-commutative_statement | /r/IsA | fn:arithmetic_non-commutative | "non-commutative statement" | "arithmetic non-commutative" | "/r/is a" |  | "FN" |  |
| fn:non-commutative_statement | fn:HasLexicalUnit | fn:lu:non-commutative_statement:quotient | "non-commutative statement" | "quotient" | "has lexical unit" |  | "FN" |  |
| fn:non-commutative_statement | fn:HasLexicalUnit | fn:lu:non-commutative_statement:difference | "non-commutative statement" | "difference" | "has lexical unit" |  | "FN" |  |
| fn:non-commutative_statement | fn:HasLexicalUnit | fn:lu:non-commutative_statement:minus | "non-commutative statement" | "minus" | "has lexical unit" |  | "FN" |  |
| fn:non-commutative_statement | /r/HasA | fn:fe:term_1 | "non-commutative statement" | "term 1" | "/r/has a" |  | "FN" |  |
| fn:non-commutative_statement | /r/HasA | fn:fe:term_2 | "non-commutative statement" | "term 2" | "/r/has a" |  | "FN" |  |
| fn:non-commutative_statement | /r/HasA | fn:fe:result | "non-commutative statement" | "result" | "/r/has a" |  | "FN" |  |
| fn:non-gradable_proximity | /r/IsA | fn:locative_relation | "non-gradable proximity" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:locative_relation | /r/SimilarTo | fn:non-gradable_proximity | "locative relation" | "non-gradable proximity" | "/r/similar to" |  | "FN" |  |
| fn:non-gradable_proximity | /r/SimilarTo | fn:adjacency | "non-gradable proximity" | "adjacency" | "/r/similar to" |  | "FN" |  |
| fn:non-gradable_proximity | /r/SimilarTo | fn:directional_locative_relation | "non-gradable proximity" | "directional locative relation" | "/r/similar to" |  | "FN" |  |
| fn:non-gradable_proximity | /r/SimilarTo | fn:surrounding | "non-gradable proximity" | "surrounding" | "/r/similar to" |  | "FN" |  |
| fn:non-gradable_proximity | /r/IsA | fn:proximity_image_schema | "non-gradable proximity" | "proximity image schema" | "/r/is a" |  | "FN" |  |
| fn:non-gradable_proximity | fn:HasLexicalUnit | fn:lu:non-gradable_proximity:by | "non-gradable proximity" | "by" | "has lexical unit" |  | "FN" |  |
| fn:non-gradable_proximity | fn:HasLexicalUnit | fn:lu:non-gradable_proximity:beside | "non-gradable proximity" | "beside" | "has lexical unit" |  | "FN" |  |
| fn:non-gradable_proximity | fn:HasLexicalUnit | fn:lu:non-gradable_proximity:under | "non-gradable proximity" | "under" | "has lexical unit" |  | "FN" |  |
| fn:non-gradable_proximity | fn:HasLexicalUnit | fn:lu:non-gradable_proximity:underneath | "non-gradable proximity" | "underneath" | "has lexical unit" |  | "FN" |  |
| fn:non-gradable_proximity | fn:HasLexicalUnit | fn:lu:non-gradable_proximity:behind | "non-gradable proximity" | "behind" | "has lexical unit" |  | "FN" |  |
| fn:non-gradable_proximity | fn:HasLexicalUnit | fn:lu:non-gradable_proximity:in_front_(of) | "non-gradable proximity" | "in front (of)" | "has lexical unit" |  | "FN" |  |
| fn:non-gradable_proximity | fn:HasLexicalUnit | fn:lu:non-gradable_proximity:in_back_(of) | "non-gradable proximity" | "in back (of)" | "has lexical unit" |  | "FN" |  |
| fn:non-gradable_proximity | fn:HasLexicalUnit | fn:lu:non-gradable_proximity:ahead | "non-gradable proximity" | "ahead" | "has lexical unit" |  | "FN" |  |
| fn:non-gradable_proximity | fn:HasLexicalUnit | fn:lu:non-gradable_proximity:along | "non-gradable proximity" | "along" | "has lexical unit" |  | "FN" |  |
| fn:non-gradable_proximity | fn:HasLexicalUnit | fn:lu:non-gradable_proximity:neighboring | "non-gradable proximity" | "neighboring" | "has lexical unit" |  | "FN" |  |
| fn:non-gradable_proximity | fn:HasLexicalUnit | fn:lu:non-gradable_proximity:over | "non-gradable proximity" | "over" | "has lexical unit" |  | "FN" |  |
| fn:non-gradable_proximity | fn:HasLexicalUnit | fn:lu:non-gradable_proximity:opposite | "non-gradable proximity" | "opposite" | "has lexical unit" |  | "FN" |  |
| fn:non-gradable_proximity | fn:HasLexicalUnit | fn:lu:non-gradable_proximity:left_[landmark-based] | "non-gradable proximity" | "left [landmark-based]" | "has lexical unit" |  | "FN" |  |
| fn:non-gradable_proximity | fn:HasLexicalUnit | fn:lu:non-gradable_proximity:right_[landmark-based] | "non-gradable proximity" | "right [landmark-based]" | "has lexical unit" |  | "FN" |  |
| fn:non-gradable_proximity | fn:HasLexicalUnit | fn:lu:non-gradable_proximity:left_[viewpoint-based] | "non-gradable proximity" | "left [viewpoint-based]" | "has lexical unit" |  | "FN" |  |
| fn:non-gradable_proximity | fn:HasLexicalUnit | fn:lu:non-gradable_proximity:right_[viewpoint-based] | "non-gradable proximity" | "right [viewpoint-based]" | "has lexical unit" |  | "FN" |  |
| fn:non-gradable_proximity | fn:HasLexicalUnit | fn:lu:non-gradable_proximity:beneath | "non-gradable proximity" | "beneath" | "has lexical unit" |  | "FN" |  |
| fn:non-gradable_proximity | fn:HasLexicalUnit | fn:lu:non-gradable_proximity:opposite | "non-gradable proximity" | "opposite" | "has lexical unit" |  | "FN" |  |
| fn:non-gradable_proximity | fn:HasLexicalUnit | fn:lu:non-gradable_proximity:starboard | "non-gradable proximity" | "starboard" | "has lexical unit" |  | "FN" |  |
| fn:non-gradable_proximity | fn:HasLexicalUnit | fn:lu:non-gradable_proximity:port | "non-gradable proximity" | "port" | "has lexical unit" |  | "FN" |  |
| fn:non-gradable_proximity | fn:HasLexicalUnit | fn:lu:non-gradable_proximity:on | "non-gradable proximity" | "on" | "has lexical unit" |  | "FN" |  |
| fn:non-gradable_proximity | /r/HasA | fn:fe:ground | "non-gradable proximity" | "ground" | "/r/has a" |  | "FN" |  |
| fn:non-gradable_proximity | /r/HasA | fn:fe:figure | "non-gradable proximity" | "figure" | "/r/has a" |  | "FN" |  |
| fn:non-gradable_proximity | /r/HasA | fn:fe:accessibility | "non-gradable proximity" | "accessibility" | "/r/has a" |  | "FN" |  |
| fn:non-gradable_proximity | /r/HasA | fn:fe:direction | "non-gradable proximity" | "direction" | "/r/has a" |  | "FN" |  |
| fn:non-gradable_proximity | /r/HasA | fn:fe:time | "non-gradable proximity" | "time" | "/r/has a" |  | "FN" |  |
| fn:non-gradable_proximity | /r/HasA | fn:fe:distance | "non-gradable proximity" | "distance" | "/r/has a" |  | "FN" |  |
| fn:non-gradable_proximity | /r/HasA | fn:fe:deixis | "non-gradable proximity" | "deixis" | "/r/has a" |  | "FN" |  |
| fn:non-gradable_proximity | /r/HasA | fn:fe:directness | "non-gradable proximity" | "directness" | "/r/has a" |  | "FN" |  |
| fn:non-gradable_proximity | /r/HasA | fn:fe:temporal_profile | "non-gradable proximity" | "temporal profile" | "/r/has a" |  | "FN" |  |
| fn:noncombatant | /r/IsA | fn:people | "noncombatant" | "people" | "/r/is a" |  | "FN" |  |
| fn:noncombatant | fn:HasLexicalUnit | fn:lu:noncombatant:non-combatant | "noncombatant" | "non-combatant" | "has lexical unit" |  | "FN" |  |
| fn:noncombatant | fn:HasLexicalUnit | fn:lu:noncombatant:civilian | "noncombatant" | "civilian" | "has lexical unit" |  | "FN" |  |
| fn:noncombatant | fn:HasLexicalUnit | fn:lu:noncombatant:civvie | "noncombatant" | "civvie" | "has lexical unit" |  | "FN" |  |
| fn:noncombatant | /r/HasA | fn:fe:origin | "noncombatant" | "origin" | "/r/has a" |  | "FN" |  |
| fn:noncombatant | /r/HasA | fn:fe:person | "noncombatant" | "person" | "/r/has a" |  | "FN" |  |
| fn:noncombatant | /r/HasA | fn:fe:persistent_characteristic | "noncombatant" | "persistent characteristic" | "/r/has a" |  | "FN" |  |
| fn:noncombatant | /r/HasA | fn:fe:descriptor | "noncombatant" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:noncombatant | /r/HasA | fn:fe:age | "noncombatant" | "age" | "/r/has a" |  | "FN" |  |
| fn:noncombatant | /r/HasA | fn:fe:ethnicity | "noncombatant" | "ethnicity" | "/r/has a" |  | "FN" |  |
| fn:noncombatant | /r/HasA | fn:fe:context_of_acquaintance | "noncombatant" | "context of acquaintance" | "/r/has a" |  | "FN" |  |
| fn:noncombatant | /r/HasA | fn:fe:conflict | "noncombatant" | "conflict" | "/r/has a" |  | "FN" |  |
| fn:notability | /r/IsA | fn:gradable_attributes | "notability" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:notability | fn:HasLexicalUnit | fn:lu:notability:great | "notability" | "great" | "has lexical unit" |  | "FN" |  |
| fn:notability | fn:HasLexicalUnit | fn:lu:notability:notable | "notability" | "notable" | "has lexical unit" |  | "FN" |  |
| fn:notability | /r/HasA | fn:fe:type | "notability" | "type" | "/r/has a" |  | "FN" |  |
| fn:notability | /r/HasA | fn:fe:name | "notability" | "name" | "/r/has a" |  | "FN" |  |
| fn:notability | /r/HasA | fn:fe:time | "notability" | "time" | "/r/has a" |  | "FN" |  |
| fn:notability | /r/HasA | fn:fe:place | "notability" | "place" | "/r/has a" |  | "FN" |  |
| fn:notability | /r/HasA | fn:fe:degree | "notability" | "degree" | "/r/has a" |  | "FN" |  |
| fn:arraignment | /r/HasSubevent | fn:notification_of_charges | "arraignment" | "notification of charges" | "/r/has subevent" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:notification_of_charges | "communication" | "notification of charges" | "/r/used for" |  | "FN" |  |
| fn:citing | /r/RelatedTo | fn:notification_of_charges | "citing" | "notification of charges" | "/r/related to" |  | "FN" |  |
| fn:entering_of_plea | /r/HasPrerequisite | fn:notification_of_charges | "entering of plea" | "notification of charges" | "/r/has prerequisite" |  | "FN" |  |
| fn:notification_of_charges | fn:HasLexicalUnit | fn:lu:notification_of_charges:charge | "notification of charges" | "charge" | "has lexical unit" |  | "FN" |  |
| fn:notification_of_charges | fn:HasLexicalUnit | fn:lu:notification_of_charges:charge | "notification of charges" | "charge" | "has lexical unit" |  | "FN" |  |
| fn:notification_of_charges | fn:HasLexicalUnit | fn:lu:notification_of_charges:indict | "notification of charges" | "indict" | "has lexical unit" |  | "FN" |  |
| fn:notification_of_charges | fn:HasLexicalUnit | fn:lu:notification_of_charges:indictment | "notification of charges" | "indictment" | "has lexical unit" |  | "FN" |  |
| fn:notification_of_charges | fn:HasLexicalUnit | fn:lu:notification_of_charges:accuse | "notification of charges" | "accuse" | "has lexical unit" |  | "FN" |  |
| fn:fe:arraign_authority | /r/IsA | fn:st:sentient | "arraign authority" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:notification_of_charges | /r/HasA | fn:fe:arraign_authority | "notification of charges" | "arraign authority" | "/r/has a" |  | "FN" |  |
| fn:fe:accused | /r/IsA | fn:st:sentient | "accused" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:notification_of_charges | /r/HasA | fn:fe:accused | "notification of charges" | "accused" | "/r/has a" |  | "FN" |  |
| fn:notification_of_charges | /r/HasA | fn:fe:charges | "notification of charges" | "charges" | "/r/has a" |  | "FN" |  |
| fn:notification_of_charges | /r/HasA | fn:fe:place | "notification of charges" | "place" | "/r/has a" |  | "FN" |  |
| fn:notification_of_charges | /r/HasA | fn:fe:time | "notification of charges" | "time" | "/r/has a" |  | "FN" |  |
| fn:notification_of_charges | /r/HasA | fn:fe:containing_event | "notification of charges" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:nuclear_process | /r/IsA | fn:undergo_change | "nuclear process" | "undergo change" | "/r/is a" |  | "FN" |  |
| fn:nuclear_process | fn:HasLexicalUnit | fn:lu:nuclear_process:fissile | "nuclear process" | "fissile" | "has lexical unit" |  | "FN" |  |
| fn:nuclear_process | fn:HasLexicalUnit | fn:lu:nuclear_process:decay | "nuclear process" | "decay" | "has lexical unit" |  | "FN" |  |
| fn:nuclear_process | fn:HasLexicalUnit | fn:lu:nuclear_process:decay | "nuclear process" | "decay" | "has lexical unit" |  | "FN" |  |
| fn:nuclear_process | fn:HasLexicalUnit | fn:lu:nuclear_process:fuse | "nuclear process" | "fuse" | "has lexical unit" |  | "FN" |  |
| fn:nuclear_process | fn:HasLexicalUnit | fn:lu:nuclear_process:fusion | "nuclear process" | "fusion" | "has lexical unit" |  | "FN" |  |
| fn:nuclear_process | fn:HasLexicalUnit | fn:lu:nuclear_process:fission | "nuclear process" | "fission" | "has lexical unit" |  | "FN" |  |
| fn:nuclear_process | fn:HasLexicalUnit | fn:lu:nuclear_process:fission | "nuclear process" | "fission" | "has lexical unit" |  | "FN" |  |
| fn:nuclear_process | fn:HasLexicalUnit | fn:lu:nuclear_process:nuclear | "nuclear process" | "nuclear" | "has lexical unit" |  | "FN" |  |
| fn:nuclear_process | fn:HasLexicalUnit | fn:lu:nuclear_process:thermonuclear | "nuclear process" | "thermonuclear" | "has lexical unit" |  | "FN" |  |
| fn:nuclear_process | fn:HasLexicalUnit | fn:lu:nuclear_process:fusable | "nuclear process" | "fusable" | "has lexical unit" |  | "FN" |  |
| fn:nuclear_process | fn:HasLexicalUnit | fn:lu:nuclear_process:radioactive | "nuclear process" | "radioactive" | "has lexical unit" |  | "FN" |  |
| fn:nuclear_process | fn:HasLexicalUnit | fn:lu:nuclear_process:radioactivity | "nuclear process" | "radioactivity" | "has lexical unit" |  | "FN" |  |
| fn:nuclear_process | /r/HasA | fn:fe:element | "nuclear process" | "element" | "/r/has a" |  | "FN" |  |
| fn:nuclear_process | /r/HasA | fn:fe:final_element | "nuclear process" | "final element" | "/r/has a" |  | "FN" |  |
| fn:nuclear_process | /r/HasA | fn:fe:initial_element | "nuclear process" | "initial element" | "/r/has a" |  | "FN" |  |
| fn:nuclear_process | /r/HasA | fn:fe:time | "nuclear process" | "time" | "/r/has a" |  | "FN" |  |
| fn:nuclear_process | /r/HasA | fn:fe:manner | "nuclear process" | "manner" | "/r/has a" |  | "FN" |  |
| fn:nuclear_process | /r/HasA | fn:fe:degree | "nuclear process" | "degree" | "/r/has a" |  | "FN" |  |
| fn:nuclear_process | /r/HasA | fn:fe:circumstances | "nuclear process" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:nuclear_process | /r/HasA | fn:fe:cause | "nuclear process" | "cause" | "/r/has a" |  | "FN" |  |
| fn:nuclear_process | /r/HasA | fn:fe:frequency | "nuclear process" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:nuclear_process | /r/HasA | fn:fe:period_of_iterations | "nuclear process" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:nuclear_process | /r/HasA | fn:fe:place | "nuclear process" | "place" | "/r/has a" |  | "FN" |  |
| fn:objective_influence | /r/IsA | fn:event | "objective influence" | "event" | "/r/is a" |  | "FN" |  |
| fn:control | /r/IsA | fn:objective_influence | "control" | "objective influence" | "/r/is a" |  | "FN" |  |
| fn:transitive_action | /r/IsA | fn:objective_influence | "transitive action" | "objective influence" | "/r/is a" |  | "FN" |  |
| fn:subjective_influence | /r/RelatedTo | fn:objective_influence | "subjective influence" | "objective influence" | "/r/related to" |  | "FN" |  |
| fn:objective_influence | fn:HasLexicalUnit | fn:lu:objective_influence:influence | "objective influence" | "influence" | "has lexical unit" |  | "FN" |  |
| fn:objective_influence | fn:HasLexicalUnit | fn:lu:objective_influence:impact | "objective influence" | "impact" | "has lexical unit" |  | "FN" |  |
| fn:objective_influence | fn:HasLexicalUnit | fn:lu:objective_influence:effect | "objective influence" | "effect" | "has lexical unit" |  | "FN" |  |
| fn:objective_influence | fn:HasLexicalUnit | fn:lu:objective_influence:influence | "objective influence" | "influence" | "has lexical unit" |  | "FN" |  |
| fn:objective_influence | fn:HasLexicalUnit | fn:lu:objective_influence:affect | "objective influence" | "affect" | "has lexical unit" |  | "FN" |  |
| fn:objective_influence | fn:HasLexicalUnit | fn:lu:objective_influence:impact | "objective influence" | "impact" | "has lexical unit" |  | "FN" |  |
| fn:objective_influence | fn:HasLexicalUnit | fn:lu:objective_influence:power | "objective influence" | "power" | "has lexical unit" |  | "FN" |  |
| fn:fe:influencing_entity | /r/RelatedTo | fn:fe:influencing_variable | "influencing entity" | "influencing variable" | "/r/related to" |  | "FN" |  |
| fn:objective_influence | /r/HasA | fn:fe:influencing_entity | "objective influence" | "influencing entity" | "/r/has a" |  | "FN" |  |
| fn:fe:dependent_entity | /r/RelatedTo | fn:fe:dependent_variable | "dependent entity" | "dependent variable" | "/r/related to" |  | "FN" |  |
| fn:objective_influence | /r/HasA | fn:fe:dependent_entity | "objective influence" | "dependent entity" | "/r/has a" |  | "FN" |  |
| fn:fe:influencing_variable | /r/RelatedTo | fn:fe:influencing_situation | "influencing variable" | "influencing situation" | "/r/related to" |  | "FN" |  |
| fn:objective_influence | /r/HasA | fn:fe:influencing_variable | "objective influence" | "influencing variable" | "/r/has a" |  | "FN" |  |
| fn:fe:dependent_situation | /r/RelatedTo | fn:fe:dependent_entity | "dependent situation" | "dependent entity" | "/r/related to" |  | "FN" |  |
| fn:objective_influence | /r/HasA | fn:fe:dependent_situation | "objective influence" | "dependent situation" | "/r/has a" |  | "FN" |  |
| fn:fe:dependent_variable | /r/RelatedTo | fn:fe:dependent_situation | "dependent variable" | "dependent situation" | "/r/related to" |  | "FN" |  |
| fn:objective_influence | /r/HasA | fn:fe:dependent_variable | "objective influence" | "dependent variable" | "/r/has a" |  | "FN" |  |
| fn:fe:influencing_situation | /r/RelatedTo | fn:fe:influencing_entity | "influencing situation" | "influencing entity" | "/r/related to" |  | "FN" |  |
| fn:objective_influence | /r/HasA | fn:fe:influencing_situation | "objective influence" | "influencing situation" | "/r/has a" |  | "FN" |  |
| fn:objective_influence | /r/HasA | fn:fe:degree | "objective influence" | "degree" | "/r/has a" |  | "FN" |  |
| fn:objective_influence | /r/HasA | fn:fe:time | "objective influence" | "time" | "/r/has a" |  | "FN" |  |
| fn:objective_influence | /r/HasA | fn:fe:place | "objective influence" | "place" | "/r/has a" |  | "FN" |  |
| fn:objective_influence | /r/HasA | fn:fe:manner | "objective influence" | "manner" | "/r/has a" |  | "FN" |  |
| fn:objective_influence | /r/HasA | fn:fe:circumstances | "objective influence" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:objective_influence | /r/HasA | fn:fe:descriptor | "objective influence" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:obligation_scenario | /r/IsA | fn:required_event | "obligation scenario" | "required event" | "/r/is a" |  | "FN" |  |
| fn:obligation_scenario | /r/UsedFor | fn:being_in_effect | "obligation scenario" | "being in effect" | "/r/used for" |  | "FN" |  |
| fn:obligation_scenario | /r/UsedFor | fn:compliance | "obligation scenario" | "compliance" | "/r/used for" |  | "FN" |  |
| fn:obligation_scenario | /r/UsedFor | fn:documents | "obligation scenario" | "documents" | "/r/used for" |  | "FN" |  |
| fn:being_obligated | /r/IsA | fn:obligation_scenario | "being obligated" | "obligation scenario" | "/r/is a" |  | "FN" |  |
| fn:being_obligatory | /r/IsA | fn:obligation_scenario | "being obligatory" | "obligation scenario" | "/r/is a" |  | "FN" |  |
| fn:obligation_scenario | /r/HasA | fn:fe:responsible_party | "obligation scenario" | "responsible party" | "/r/has a" |  | "FN" |  |
| fn:obligation_scenario | /r/HasA | fn:fe:duty | "obligation scenario" | "duty" | "/r/has a" |  | "FN" |  |
| fn:obligation_scenario | /r/HasA | fn:fe:condition | "obligation scenario" | "condition" | "/r/has a" |  | "FN" |  |
| fn:obligation_scenario | /r/HasA | fn:fe:consequence | "obligation scenario" | "consequence" | "/r/has a" |  | "FN" |  |
| fn:obligation_scenario | /r/HasA | fn:fe:time | "obligation scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:obligation_scenario | /r/HasA | fn:fe:place | "obligation scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:obligation_scenario | /r/HasA | fn:fe:degree | "obligation scenario" | "degree" | "/r/has a" |  | "FN" |  |
| fn:obligation_scenario | /r/HasA | fn:fe:purpose | "obligation scenario" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:obscurity | /r/IsA | fn:gradable_attributes | "obscurity" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:fame | /r/UsedFor | fn:obscurity | "fame" | "obscurity" | "/r/used for" |  | "FN" |  |
| fn:obscurity | fn:HasLexicalUnit | fn:lu:obscurity:little_known | "obscurity" | "little known" | "has lexical unit" |  | "FN" |  |
| fn:obscurity | fn:HasLexicalUnit | fn:lu:obscurity:obscure | "obscurity" | "obscure" | "has lexical unit" |  | "FN" |  |
| fn:obscurity | fn:HasLexicalUnit | fn:lu:obscurity:unsung | "obscurity" | "unsung" | "has lexical unit" |  | "FN" |  |
| fn:obscurity | fn:HasLexicalUnit | fn:lu:obscurity:recondite | "obscurity" | "recondite" | "has lexical unit" |  | "FN" |  |
| fn:obscurity | /r/HasA | fn:fe:entity | "obscurity" | "entity" | "/r/has a" |  | "FN" |  |
| fn:obscurity | /r/HasA | fn:fe:degree | "obscurity" | "degree" | "/r/has a" |  | "FN" |  |
| fn:obscurity | /r/HasA | fn:fe:time | "obscurity" | "time" | "/r/has a" |  | "FN" |  |
| fn:obscurity | /r/HasA | fn:fe:circumstances | "obscurity" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:obscurity | /r/HasA | fn:fe:explanation | "obscurity" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:obscurity | /r/HasA | fn:fe:duration | "obscurity" | "duration" | "/r/has a" |  | "FN" |  |
| fn:obscurity | /r/HasA | fn:fe:place | "obscurity" | "place" | "/r/has a" |  | "FN" |  |
| fn:obviousness | /r/IsA | fn:gradable_attributes | "obviousness" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:obviousness | fn:HasLexicalUnit | fn:lu:obviousness:obvious | "obviousness" | "obvious" | "has lexical unit" |  | "FN" |  |
| fn:obviousness | fn:HasLexicalUnit | fn:lu:obviousness:evident | "obviousness" | "evident" | "has lexical unit" |  | "FN" |  |
| fn:obviousness | fn:HasLexicalUnit | fn:lu:obviousness:manifest | "obviousness" | "manifest" | "has lexical unit" |  | "FN" |  |
| fn:obviousness | fn:HasLexicalUnit | fn:lu:obviousness:visible | "obviousness" | "visible" | "has lexical unit" |  | "FN" |  |
| fn:obviousness | fn:HasLexicalUnit | fn:lu:obviousness:audible | "obviousness" | "audible" | "has lexical unit" |  | "FN" |  |
| fn:obviousness | fn:HasLexicalUnit | fn:lu:obviousness:unclear | "obviousness" | "unclear" | "has lexical unit" |  | "FN" |  |
| fn:obviousness | fn:HasLexicalUnit | fn:lu:obviousness:clear | "obviousness" | "clear" | "has lexical unit" |  | "FN" |  |
| fn:obviousness | fn:HasLexicalUnit | fn:lu:obviousness:clearly | "obviousness" | "clearly" | "has lexical unit" |  | "FN" |  |
| fn:obviousness | fn:HasLexicalUnit | fn:lu:obviousness:obviously | "obviousness" | "obviously" | "has lexical unit" |  | "FN" |  |
| fn:obviousness | fn:HasLexicalUnit | fn:lu:obviousness:clarity | "obviousness" | "clarity" | "has lexical unit" |  | "FN" |  |
| fn:obviousness | fn:HasLexicalUnit | fn:lu:obviousness:show | "obviousness" | "show" | "has lexical unit" |  | "FN" |  |
| fn:obviousness | fn:HasLexicalUnit | fn:lu:obviousness:show_up | "obviousness" | "show up" | "has lexical unit" |  | "FN" |  |
| fn:obviousness | fn:HasLexicalUnit | fn:lu:obviousness:stand_out | "obviousness" | "stand out" | "has lexical unit" |  | "FN" |  |
| fn:obviousness | fn:HasLexicalUnit | fn:lu:obviousness:noticeable | "obviousness" | "noticeable" | "has lexical unit" |  | "FN" |  |
| fn:obviousness | /r/HasA | fn:fe:phenomenon | "obviousness" | "phenomenon" | "/r/has a" |  | "FN" |  |
| fn:obviousness | /r/HasA | fn:fe:attribute | "obviousness" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:obviousness | /r/HasA | fn:fe:degree | "obviousness" | "degree" | "/r/has a" |  | "FN" |  |
| fn:obviousness | /r/HasA | fn:fe:time | "obviousness" | "time" | "/r/has a" |  | "FN" |  |
| fn:obviousness | /r/HasA | fn:fe:circumstances | "obviousness" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:obviousness | /r/HasA | fn:fe:perceiver | "obviousness" | "perceiver" | "/r/has a" |  | "FN" |  |
| fn:obviousness | /r/HasA | fn:fe:evidence | "obviousness" | "evidence" | "/r/has a" |  | "FN" |  |
| fn:obviousness | /r/HasA | fn:fe:group | "obviousness" | "group" | "/r/has a" |  | "FN" |  |
| fn:obviousness | /r/HasA | fn:fe:location_of_protagonist | "obviousness" | "location of protagonist" | "/r/has a" |  | "FN" |  |
| fn:obviousness | /r/HasA | fn:fe:particular_iteration | "obviousness" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:obviousness | /r/HasA | fn:fe:direction | "obviousness" | "direction" | "/r/has a" |  | "FN" |  |
| fn:rank | /r/UsedFor | fn:occupy_rank | "rank" | "occupy rank" | "/r/used for" |  | "FN" |  |
| fn:occupy_rank | fn:HasLexicalUnit | fn:lu:occupy_rank:rank | "occupy rank" | "rank" | "has lexical unit" |  | "FN" |  |
| fn:occupy_rank | fn:HasLexicalUnit | fn:lu:occupy_rank:stand | "occupy rank" | "stand" | "has lexical unit" |  | "FN" |  |
| fn:occupy_rank | fn:HasLexicalUnit | fn:lu:occupy_rank:top | "occupy rank" | "top" | "has lexical unit" |  | "FN" |  |
| fn:occupy_rank | /r/HasA | fn:fe:rank | "occupy rank" | "rank" | "/r/has a" |  | "FN" |  |
| fn:occupy_rank | /r/HasA | fn:fe:item | "occupy rank" | "item" | "/r/has a" |  | "FN" |  |
| fn:occupy_rank | /r/HasA | fn:fe:dimension | "occupy rank" | "dimension" | "/r/has a" |  | "FN" |  |
| fn:occupy_rank | /r/HasA | fn:fe:time | "occupy rank" | "time" | "/r/has a" |  | "FN" |  |
| fn:occupy_rank | /r/HasA | fn:fe:comparison_set | "occupy rank" | "comparison set" | "/r/has a" |  | "FN" |  |
| fn:arson | /r/IsA | fn:offenses | "arson" | "offenses" | "/r/is a" |  | "FN" |  |
| fn:committing_crime | /r/UsedFor | fn:offenses | "committing crime" | "offenses" | "/r/used for" |  | "FN" |  |
| fn:offenses | /r/UsedFor | fn:severity_of_offense | "offenses" | "severity of offense" | "/r/used for" |  | "FN" |  |
| fn:death | /r/SimilarTo | fn:offenses | "death" | "offenses" | "/r/similar to" |  | "FN" |  |
| fn:offenses | fn:HasLexicalUnit | fn:lu:offenses:assault | "offenses" | "assault" | "has lexical unit" |  | "FN" |  |
| fn:offenses | fn:HasLexicalUnit | fn:lu:offenses:murder | "offenses" | "murder" | "has lexical unit" |  | "FN" |  |
| fn:offenses | fn:HasLexicalUnit | fn:lu:offenses:statutory_rape | "offenses" | "statutory rape" | "has lexical unit" |  | "FN" |  |
| fn:offenses | fn:HasLexicalUnit | fn:lu:offenses:sabotage | "offenses" | "sabotage" | "has lexical unit" |  | "FN" |  |
| fn:offenses | fn:HasLexicalUnit | fn:lu:offenses:manslaughter | "offenses" | "manslaughter" | "has lexical unit" |  | "FN" |  |
| fn:offenses | fn:HasLexicalUnit | fn:lu:offenses:hijacking | "offenses" | "hijacking" | "has lexical unit" |  | "FN" |  |
| fn:offenses | fn:HasLexicalUnit | fn:lu:offenses:theft | "offenses" | "theft" | "has lexical unit" |  | "FN" |  |
| fn:offenses | fn:HasLexicalUnit | fn:lu:offenses:burglary | "offenses" | "burglary" | "has lexical unit" |  | "FN" |  |
| fn:offenses | fn:HasLexicalUnit | fn:lu:offenses:robbery | "offenses" | "robbery" | "has lexical unit" |  | "FN" |  |
| fn:offenses | fn:HasLexicalUnit | fn:lu:offenses:conspiracy | "offenses" | "conspiracy" | "has lexical unit" |  | "FN" |  |
| fn:offenses | fn:HasLexicalUnit | fn:lu:offenses:larceny | "offenses" | "larceny" | "has lexical unit" |  | "FN" |  |
| fn:offenses | fn:HasLexicalUnit | fn:lu:offenses:copyright_infringement | "offenses" | "copyright infringement" | "has lexical unit" |  | "FN" |  |
| fn:offenses | fn:HasLexicalUnit | fn:lu:offenses:negligence | "offenses" | "negligence" | "has lexical unit" |  | "FN" |  |
| fn:offenses | fn:HasLexicalUnit | fn:lu:offenses:possession | "offenses" | "possession" | "has lexical unit" |  | "FN" |  |
| fn:offenses | fn:HasLexicalUnit | fn:lu:offenses:felony | "offenses" | "felony" | "has lexical unit" |  | "FN" |  |
| fn:offenses | fn:HasLexicalUnit | fn:lu:offenses:sexual_harassment | "offenses" | "sexual harassment" | "has lexical unit" |  | "FN" |  |
| fn:offenses | fn:HasLexicalUnit | fn:lu:offenses:treason | "offenses" | "treason" | "has lexical unit" |  | "FN" |  |
| fn:offenses | fn:HasLexicalUnit | fn:lu:offenses:battery | "offenses" | "battery" | "has lexical unit" |  | "FN" |  |
| fn:offenses | fn:HasLexicalUnit | fn:lu:offenses:kidnapping | "offenses" | "kidnapping" | "has lexical unit" |  | "FN" |  |
| fn:offenses | fn:HasLexicalUnit | fn:lu:offenses:fraud | "offenses" | "fraud" | "has lexical unit" |  | "FN" |  |
| fn:offenses | fn:HasLexicalUnit | fn:lu:offenses:indecent_assault | "offenses" | "indecent assault" | "has lexical unit" |  | "FN" |  |
| fn:offenses | fn:HasLexicalUnit | fn:lu:offenses:sexual_assault | "offenses" | "sexual assault" | "has lexical unit" |  | "FN" |  |
| fn:offenses | fn:HasLexicalUnit | fn:lu:offenses:child_abuse | "offenses" | "child abuse" | "has lexical unit" |  | "FN" |  |
| fn:offenses | fn:HasLexicalUnit | fn:lu:offenses:homicide | "offenses" | "homicide" | "has lexical unit" |  | "FN" |  |
| fn:offenses | fn:HasLexicalUnit | fn:lu:offenses:arson | "offenses" | "arson" | "has lexical unit" |  | "FN" |  |
| fn:offenses | fn:HasLexicalUnit | fn:lu:offenses:rape | "offenses" | "rape" | "has lexical unit" |  | "FN" |  |
| fn:offenses | /r/HasA | fn:fe:degree | "offenses" | "degree" | "/r/has a" |  | "FN" |  |
| fn:offenses | /r/HasA | fn:fe:specification | "offenses" | "specification" | "/r/has a" |  | "FN" |  |
| fn:offenses | /r/HasA | fn:fe:offense | "offenses" | "offense" | "/r/has a" |  | "FN" |  |
| fn:offenses | /r/HasA | fn:fe:victim | "offenses" | "victim" | "/r/has a" |  | "FN" |  |
| fn:offenses | /r/HasA | fn:fe:punishment | "offenses" | "punishment" | "/r/has a" |  | "FN" |  |
| fn:offenses | /r/HasA | fn:fe:perpetrator | "offenses" | "perpetrator" | "/r/has a" |  | "FN" |  |
| fn:giving | /r/UsedFor | fn:offering | "giving" | "offering" | "/r/used for" |  | "FN" |  |
| fn:offering | fn:HasLexicalUnit | fn:lu:offering:offer | "offering" | "offer" | "has lexical unit" |  | "FN" |  |
| fn:offering | fn:HasLexicalUnit | fn:lu:offering:proffer | "offering" | "proffer" | "has lexical unit" |  | "FN" |  |
| fn:offering | fn:HasLexicalUnit | fn:lu:offering:extend | "offering" | "extend" | "has lexical unit" |  | "FN" |  |
| fn:offering | fn:HasLexicalUnit | fn:lu:offering:serve | "offering" | "serve" | "has lexical unit" |  | "FN" |  |
| fn:offering | /r/HasA | fn:fe:offerer | "offering" | "offerer" | "/r/has a" |  | "FN" |  |
| fn:offering | /r/HasA | fn:fe:potential_recipient | "offering" | "potential recipient" | "/r/has a" |  | "FN" |  |
| fn:offering | /r/HasA | fn:fe:theme | "offering" | "theme" | "/r/has a" |  | "FN" |  |
| fn:offering | /r/HasA | fn:fe:place | "offering" | "place" | "/r/has a" |  | "FN" |  |
| fn:offering | /r/HasA | fn:fe:explanation | "offering" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:offering | /r/HasA | fn:fe:time | "offering" | "time" | "/r/has a" |  | "FN" |  |
| fn:offering | /r/HasA | fn:fe:purpose | "offering" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:offering | /r/HasA | fn:fe:means | "offering" | "means" | "/r/has a" |  | "FN" |  |
| fn:offering | /r/HasA | fn:fe:manner | "offering" | "manner" | "/r/has a" |  | "FN" |  |
| fn:offering | /r/HasA | fn:fe:circumstances | "offering" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:offering | /r/HasA | fn:fe:imposed_purpose | "offering" | "imposed purpose" | "/r/has a" |  | "FN" |  |
| fn:offering | /r/HasA | fn:fe:depictive | "offering" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:offering | /r/HasA | fn:fe:period_of_iterations | "offering" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:offshoot | fn:HasLexicalUnit | fn:lu:offshoot:offshoot | "offshoot" | "offshoot" | "has lexical unit" |  | "FN" |  |
| fn:offshoot | fn:HasLexicalUnit | fn:lu:offshoot:faction | "offshoot" | "faction" | "has lexical unit" |  | "FN" |  |
| fn:offshoot | fn:HasLexicalUnit | fn:lu:offshoot:breakaway | "offshoot" | "breakaway" | "has lexical unit" |  | "FN" |  |
| fn:offshoot | fn:HasLexicalUnit | fn:lu:offshoot:sect | "offshoot" | "sect" | "has lexical unit" |  | "FN" |  |
| fn:offshoot | fn:HasLexicalUnit | fn:lu:offshoot:splinter_group | "offshoot" | "splinter group" | "has lexical unit" |  | "FN" |  |
| fn:offshoot | /r/HasA | fn:fe:original_body | "offshoot" | "original body" | "/r/has a" |  | "FN" |  |
| fn:offshoot | /r/HasA | fn:fe:branch | "offshoot" | "branch" | "/r/has a" |  | "FN" |  |
| fn:offshoot | /r/HasA | fn:fe:place | "offshoot" | "place" | "/r/has a" |  | "FN" |  |
| fn:offshoot | /r/HasA | fn:fe:time | "offshoot" | "time" | "/r/has a" |  | "FN" |  |
| fn:omen | /r/IsA | fn:sign | "omen" | "sign" | "/r/is a" |  | "FN" |  |
| fn:omen | /r/RelatedTo | fn:expectation | "omen" | "expectation" | "/r/related to" |  | "FN" |  |
| fn:omen | fn:HasLexicalUnit | fn:lu:omen:portend | "omen" | "portend" | "has lexical unit" |  | "FN" |  |
| fn:omen | fn:HasLexicalUnit | fn:lu:omen:portent | "omen" | "portent" | "has lexical unit" |  | "FN" |  |
| fn:omen | fn:HasLexicalUnit | fn:lu:omen:foretoken | "omen" | "foretoken" | "has lexical unit" |  | "FN" |  |
| fn:omen | fn:HasLexicalUnit | fn:lu:omen:betoken | "omen" | "betoken" | "has lexical unit" |  | "FN" |  |
| fn:omen | fn:HasLexicalUnit | fn:lu:omen:foretoken | "omen" | "foretoken" | "has lexical unit" |  | "FN" |  |
| fn:omen | fn:HasLexicalUnit | fn:lu:omen:presage | "omen" | "presage" | "has lexical unit" |  | "FN" |  |
| fn:omen | fn:HasLexicalUnit | fn:lu:omen:presage | "omen" | "presage" | "has lexical unit" |  | "FN" |  |
| fn:omen | fn:HasLexicalUnit | fn:lu:omen:omen | "omen" | "omen" | "has lexical unit" |  | "FN" |  |
| fn:omen | fn:HasLexicalUnit | fn:lu:omen:forebode | "omen" | "forebode" | "has lexical unit" |  | "FN" |  |
| fn:omen | fn:HasLexicalUnit | fn:lu:omen:augur | "omen" | "augur" | "has lexical unit" |  | "FN" |  |
| fn:omen | fn:HasLexicalUnit | fn:lu:omen:bode | "omen" | "bode" | "has lexical unit" |  | "FN" |  |
| fn:omen | fn:HasLexicalUnit | fn:lu:omen:ominous | "omen" | "ominous" | "has lexical unit" |  | "FN" |  |
| fn:omen | fn:HasLexicalUnit | fn:lu:omen:harbinger | "omen" | "harbinger" | "has lexical unit" |  | "FN" |  |
| fn:omen | fn:HasLexicalUnit | fn:lu:omen:foreshadow | "omen" | "foreshadow" | "has lexical unit" |  | "FN" |  |
| fn:omen | fn:HasLexicalUnit | fn:lu:omen:foretell | "omen" | "foretell" | "has lexical unit" |  | "FN" |  |
| fn:omen | fn:HasLexicalUnit | fn:lu:omen:foreshadowing | "omen" | "foreshadowing" | "has lexical unit" |  | "FN" |  |
| fn:omen | fn:HasLexicalUnit | fn:lu:omen:prefigure | "omen" | "prefigure" | "has lexical unit" |  | "FN" |  |
| fn:omen | fn:HasLexicalUnit | fn:lu:omen:promise | "omen" | "promise" | "has lexical unit" |  | "FN" |  |
| fn:omen | fn:HasLexicalUnit | fn:lu:omen:herald | "omen" | "herald" | "has lexical unit" |  | "FN" |  |
| fn:omen | fn:HasLexicalUnit | fn:lu:omen:announce | "omen" | "announce" | "has lexical unit" |  | "FN" |  |
| fn:omen | fn:HasLexicalUnit | fn:lu:omen:promising | "omen" | "promising" | "has lexical unit" |  | "FN" |  |
| fn:omen | fn:HasLexicalUnit | fn:lu:omen:promise | "omen" | "promise" | "has lexical unit" |  | "FN" |  |
| fn:omen | fn:HasLexicalUnit | fn:lu:omen:threaten | "omen" | "threaten" | "has lexical unit" |  | "FN" |  |
| fn:omen | /r/HasA | fn:fe:predictive_phenomenon | "omen" | "predictive phenomenon" | "/r/has a" |  | "FN" |  |
| fn:omen | /r/HasA | fn:fe:future_phenomenon | "omen" | "future phenomenon" | "/r/has a" |  | "FN" |  |
| fn:omen | /r/HasA | fn:fe:outcome | "omen" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:omen | /r/HasA | fn:fe:interested_party | "omen" | "interested party" | "/r/has a" |  | "FN" |  |
| fn:omen | /r/HasA | fn:fe:strength | "omen" | "strength" | "/r/has a" |  | "FN" |  |
| fn:omen | /r/HasA | fn:fe:time | "omen" | "time" | "/r/has a" |  | "FN" |  |
| fn:omen | /r/HasA | fn:fe:explanation | "omen" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:omen | /r/HasA | fn:fe:circumstances | "omen" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:omen | /r/HasA | fn:fe:duration | "omen" | "duration" | "/r/has a" |  | "FN" |  |
| fn:omen | /r/HasA | fn:fe:place | "omen" | "place" | "/r/has a" |  | "FN" |  |
| fn:ontogeny | /r/IsA | fn:progression | "ontogeny" | "progression" | "/r/is a" |  | "FN" |  |
| fn:ontogeny | fn:HasLexicalUnit | fn:lu:ontogeny:develop | "ontogeny" | "develop" | "has lexical unit" |  | "FN" |  |
| fn:ontogeny | fn:HasLexicalUnit | fn:lu:ontogeny:development | "ontogeny" | "development" | "has lexical unit" |  | "FN" |  |
| fn:ontogeny | fn:HasLexicalUnit | fn:lu:ontogeny:grow | "ontogeny" | "grow" | "has lexical unit" |  | "FN" |  |
| fn:ontogeny | fn:HasLexicalUnit | fn:lu:ontogeny:growth | "ontogeny" | "growth" | "has lexical unit" |  | "FN" |  |
| fn:fe:entity | /r/RelatedTo | fn:fe:domain | "entity" | "domain" | "/r/related to" |  | "FN" |  |
| fn:ontogeny | /r/HasA | fn:fe:entity | "ontogeny" | "entity" | "/r/has a" |  | "FN" |  |
| fn:fe:organism | /r/IsA | fn:st:living_thing | "organism" | "living thing" | "/r/is a" |  | "FN" |  |
| fn:ontogeny | /r/HasA | fn:fe:organism | "ontogeny" | "organism" | "/r/has a" |  | "FN" |  |
| fn:ontogeny | /r/HasA | fn:fe:prior_state | "ontogeny" | "prior state" | "/r/has a" |  | "FN" |  |
| fn:ontogeny | /r/HasA | fn:fe:post_state | "ontogeny" | "post state" | "/r/has a" |  | "FN" |  |
| fn:ontogeny | /r/HasA | fn:fe:time | "ontogeny" | "time" | "/r/has a" |  | "FN" |  |
| fn:ontogeny | /r/HasA | fn:fe:degree | "ontogeny" | "degree" | "/r/has a" |  | "FN" |  |
| fn:fe:domain | /r/RelatedTo | fn:fe:entity | "domain" | "entity" | "/r/related to" |  | "FN" |  |
| fn:ontogeny | /r/HasA | fn:fe:domain | "ontogeny" | "domain" | "/r/has a" |  | "FN" |  |
| fn:ontogeny | /r/HasA | fn:fe:manner | "ontogeny" | "manner" | "/r/has a" |  | "FN" |  |
| fn:ontogeny | /r/HasA | fn:fe:place | "ontogeny" | "place" | "/r/has a" |  | "FN" |  |
| fn:ontogeny | /r/HasA | fn:fe:rate | "ontogeny" | "rate" | "/r/has a" |  | "FN" |  |
| fn:ontogeny | /r/HasA | fn:fe:duration | "ontogeny" | "duration" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/UsedFor | fn:openness | "traversing" | "openness" | "/r/used for" |  | "FN" |  |
| fn:change_accessibility | /r/Causes | fn:openness | "change accessibility" | "openness" | "/r/causes" |  | "FN" |  |
| fn:openness | /r/IsA | fn:access_scenario | "openness" | "access scenario" | "/r/is a" |  | "FN" |  |
| fn:openness | fn:HasLexicalUnit | fn:lu:openness:open | "openness" | "open" | "has lexical unit" |  | "FN" |  |
| fn:openness | fn:HasLexicalUnit | fn:lu:openness:closed | "openness" | "closed" | "has lexical unit" |  | "FN" |  |
| fn:openness | fn:HasLexicalUnit | fn:lu:openness:dark | "openness" | "dark" | "has lexical unit" |  | "FN" |  |
| fn:openness | /r/HasA | fn:fe:theme | "openness" | "theme" | "/r/has a" |  | "FN" |  |
| fn:openness | /r/HasA | fn:fe:useful_location | "openness" | "useful location" | "/r/has a" |  | "FN" |  |
| fn:fe:barrier | /r/RelatedTo | fn:fe:useful_location | "barrier" | "useful location" | "/r/related to" |  | "FN" |  |
| fn:openness | /r/HasA | fn:fe:barrier | "openness" | "barrier" | "/r/has a" |  | "FN" |  |
| fn:openness | /r/HasA | fn:fe:degree | "openness" | "degree" | "/r/has a" |  | "FN" |  |
| fn:openness | /r/HasA | fn:fe:time | "openness" | "time" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle | /r/IsA | fn:operating_a_system | "operate vehicle" | "operating a system" | "/r/is a" |  | "FN" |  |
| fn:operate_vehicle_scenario | /r/HasSubevent | fn:operate_vehicle | "operate vehicle scenario" | "operate vehicle" | "/r/has subevent" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:operate_vehicle | "motion" | "operate vehicle" | "/r/used for" |  | "FN" |  |
| fn:operate_vehicle | /r/UsedFor | fn:piracy | "operate vehicle" | "piracy" | "/r/used for" |  | "FN" |  |
| fn:motion | /r/RelatedTo | fn:operate_vehicle | "motion" | "operate vehicle" | "/r/related to" |  | "FN" |  |
| fn:operate_vehicle | /r/SimilarTo | fn:bringing | "operate vehicle" | "bringing" | "/r/similar to" |  | "FN" |  |
| fn:operate_vehicle | /r/SimilarTo | fn:ride_vehicle | "operate vehicle" | "ride vehicle" | "/r/similar to" |  | "FN" |  |
| fn:operate_vehicle | /r/SimilarTo | fn:self_motion | "operate vehicle" | "self motion" | "/r/similar to" |  | "FN" |  |
| fn:operate_vehicle | /r/IsA | fn:use_vehicle | "operate vehicle" | "use vehicle" | "/r/is a" |  | "FN" |  |
| fn:operate_vehicle | fn:HasLexicalUnit | fn:lu:operate_vehicle:balloon | "operate vehicle" | "balloon" | "has lexical unit" |  | "FN" |  |
| fn:operate_vehicle | fn:HasLexicalUnit | fn:lu:operate_vehicle:bicycle | "operate vehicle" | "bicycle" | "has lexical unit" |  | "FN" |  |
| fn:operate_vehicle | fn:HasLexicalUnit | fn:lu:operate_vehicle:bike | "operate vehicle" | "bike" | "has lexical unit" |  | "FN" |  |
| fn:operate_vehicle | fn:HasLexicalUnit | fn:lu:operate_vehicle:boat | "operate vehicle" | "boat" | "has lexical unit" |  | "FN" |  |
| fn:operate_vehicle | fn:HasLexicalUnit | fn:lu:operate_vehicle:canoe | "operate vehicle" | "canoe" | "has lexical unit" |  | "FN" |  |
| fn:operate_vehicle | fn:HasLexicalUnit | fn:lu:operate_vehicle:caravan | "operate vehicle" | "caravan" | "has lexical unit" |  | "FN" |  |
| fn:operate_vehicle | fn:HasLexicalUnit | fn:lu:operate_vehicle:cycle | "operate vehicle" | "cycle" | "has lexical unit" |  | "FN" |  |
| fn:operate_vehicle | fn:HasLexicalUnit | fn:lu:operate_vehicle:motor | "operate vehicle" | "motor" | "has lexical unit" |  | "FN" |  |
| fn:operate_vehicle | fn:HasLexicalUnit | fn:lu:operate_vehicle:paddle | "operate vehicle" | "paddle" | "has lexical unit" |  | "FN" |  |
| fn:operate_vehicle | fn:HasLexicalUnit | fn:lu:operate_vehicle:parachute | "operate vehicle" | "parachute" | "has lexical unit" |  | "FN" |  |
| fn:operate_vehicle | fn:HasLexicalUnit | fn:lu:operate_vehicle:pedal | "operate vehicle" | "pedal" | "has lexical unit" |  | "FN" |  |
| fn:operate_vehicle | fn:HasLexicalUnit | fn:lu:operate_vehicle:punt | "operate vehicle" | "punt" | "has lexical unit" |  | "FN" |  |
| fn:operate_vehicle | fn:HasLexicalUnit | fn:lu:operate_vehicle:raft | "operate vehicle" | "raft" | "has lexical unit" |  | "FN" |  |
| fn:operate_vehicle | fn:HasLexicalUnit | fn:lu:operate_vehicle:row | "operate vehicle" | "row" | "has lexical unit" |  | "FN" |  |
| fn:operate_vehicle | fn:HasLexicalUnit | fn:lu:operate_vehicle:skate | "operate vehicle" | "skate" | "has lexical unit" |  | "FN" |  |
| fn:operate_vehicle | fn:HasLexicalUnit | fn:lu:operate_vehicle:sledge | "operate vehicle" | "sledge" | "has lexical unit" |  | "FN" |  |
| fn:operate_vehicle | fn:HasLexicalUnit | fn:lu:operate_vehicle:tack | "operate vehicle" | "tack" | "has lexical unit" |  | "FN" |  |
| fn:operate_vehicle | fn:HasLexicalUnit | fn:lu:operate_vehicle:taxi | "operate vehicle" | "taxi" | "has lexical unit" |  | "FN" |  |
| fn:operate_vehicle | fn:HasLexicalUnit | fn:lu:operate_vehicle:toboggan | "operate vehicle" | "toboggan" | "has lexical unit" |  | "FN" |  |
| fn:operate_vehicle | fn:HasLexicalUnit | fn:lu:operate_vehicle:cruise | "operate vehicle" | "cruise" | "has lexical unit" |  | "FN" |  |
| fn:operate_vehicle | fn:HasLexicalUnit | fn:lu:operate_vehicle:drive | "operate vehicle" | "drive" | "has lexical unit" |  | "FN" |  |
| fn:operate_vehicle | fn:HasLexicalUnit | fn:lu:operate_vehicle:ride | "operate vehicle" | "ride" | "has lexical unit" |  | "FN" |  |
| fn:operate_vehicle | fn:HasLexicalUnit | fn:lu:operate_vehicle:sail | "operate vehicle" | "sail" | "has lexical unit" |  | "FN" |  |
| fn:operate_vehicle | fn:HasLexicalUnit | fn:lu:operate_vehicle:fly | "operate vehicle" | "fly" | "has lexical unit" |  | "FN" |  |
| fn:fe:driver | /r/IsA | fn:st:sentient | "driver" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:operate_vehicle | /r/HasA | fn:fe:driver | "operate vehicle" | "driver" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle | /r/HasA | fn:fe:vehicle | "operate vehicle" | "vehicle" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle | /r/HasA | fn:fe:source | "operate vehicle" | "source" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle | /r/HasA | fn:fe:path | "operate vehicle" | "path" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle | /r/HasA | fn:fe:goal | "operate vehicle" | "goal" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle | /r/HasA | fn:fe:manner | "operate vehicle" | "manner" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle | /r/HasA | fn:fe:distance | "operate vehicle" | "distance" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle | /r/HasA | fn:fe:area | "operate vehicle" | "area" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle | /r/HasA | fn:fe:depictive | "operate vehicle" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle | /r/HasA | fn:fe:event | "operate vehicle" | "event" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle | /r/HasA | fn:fe:means | "operate vehicle" | "means" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle | /r/HasA | fn:fe:result | "operate vehicle" | "result" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle | /r/HasA | fn:fe:cotheme | "operate vehicle" | "cotheme" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle | /r/HasA | fn:fe:speed | "operate vehicle" | "speed" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle | /r/HasA | fn:fe:route | "operate vehicle" | "route" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle | /r/HasA | fn:fe:circumstances | "operate vehicle" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle | /r/HasA | fn:fe:place | "operate vehicle" | "place" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle | /r/HasA | fn:fe:duration | "operate vehicle" | "duration" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle | /r/HasA | fn:fe:time | "operate vehicle" | "time" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle | /r/HasA | fn:fe:degree | "operate vehicle" | "degree" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle | /r/HasA | fn:fe:purpose | "operate vehicle" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle | /r/HasA | fn:fe:particular_iteration | "operate vehicle" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle | /r/HasA | fn:fe:explanation | "operate vehicle" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle | /r/HasA | fn:fe:frequency | "operate vehicle" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle_scenario | /r/HasSubevent | fn:cause_to_land | "operate vehicle scenario" | "cause to land" | "/r/has subevent" |  | "FN" |  |
| fn:operate_vehicle_scenario | /r/HasSubevent | fn:getting_vehicle_underway | "operate vehicle scenario" | "getting vehicle underway" | "/r/has subevent" |  | "FN" |  |
| fn:operate_vehicle_scenario | /r/HasSubevent | fn:operate_vehicle | "operate vehicle scenario" | "operate vehicle" | "/r/has subevent" |  | "FN" |  |
| fn:motion_scenario | /r/UsedFor | fn:operate_vehicle_scenario | "motion scenario" | "operate vehicle scenario" | "/r/used for" |  | "FN" |  |
| fn:operate_vehicle_scenario | /r/HasA | fn:fe:operator | "operate vehicle scenario" | "operator" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle_scenario | /r/HasA | fn:fe:vehicle | "operate vehicle scenario" | "vehicle" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle_scenario | /r/HasA | fn:fe:source | "operate vehicle scenario" | "source" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle_scenario | /r/HasA | fn:fe:path | "operate vehicle scenario" | "path" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle_scenario | /r/HasA | fn:fe:goal | "operate vehicle scenario" | "goal" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle_scenario | /r/HasA | fn:fe:area | "operate vehicle scenario" | "area" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle_scenario | /r/HasA | fn:fe:place | "operate vehicle scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle_scenario | /r/HasA | fn:fe:time | "operate vehicle scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle_scenario | /r/HasA | fn:fe:manner | "operate vehicle scenario" | "manner" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle_scenario | /r/HasA | fn:fe:means | "operate vehicle scenario" | "means" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle | /r/IsA | fn:operating_a_system | "operate vehicle" | "operating a system" | "/r/is a" |  | "FN" |  |
| fn:operating_a_system | /r/IsA | fn:using | "operating a system" | "using" | "/r/is a" |  | "FN" |  |
| fn:operating_a_system | /r/UsedFor | fn:operational_testing | "operating a system" | "operational testing" | "/r/used for" |  | "FN" |  |
| fn:operating_a_system | /r/RelatedTo | fn:using | "operating a system" | "using" | "/r/related to" |  | "FN" |  |
| fn:operating_a_system | fn:HasLexicalUnit | fn:lu:operating_a_system:operate | "operating a system" | "operate" | "has lexical unit" |  | "FN" |  |
| fn:operating_a_system | fn:HasLexicalUnit | fn:lu:operating_a_system:run | "operating a system" | "run" | "has lexical unit" |  | "FN" |  |
| fn:operating_a_system | fn:HasLexicalUnit | fn:lu:operating_a_system:manage | "operating a system" | "manage" | "has lexical unit" |  | "FN" |  |
| fn:fe:system | /r/IsA | fn:st:physical_entity | "system" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:operating_a_system | /r/HasA | fn:fe:system | "operating a system" | "system" | "/r/has a" |  | "FN" |  |
| fn:fe:operator | /r/IsA | fn:st:sentient | "operator" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:operating_a_system | /r/HasA | fn:fe:operator | "operating a system" | "operator" | "/r/has a" |  | "FN" |  |
| fn:operating_a_system | /r/HasA | fn:fe:place | "operating a system" | "place" | "/r/has a" |  | "FN" |  |
| fn:operating_a_system | /r/HasA | fn:fe:purpose | "operating a system" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:operating_a_system | /r/HasA | fn:fe:time | "operating a system" | "time" | "/r/has a" |  | "FN" |  |
| fn:operating_a_system | /r/HasA | fn:fe:means | "operating a system" | "means" | "/r/has a" |  | "FN" |  |
| fn:operating_a_system | /r/HasA | fn:fe:manner | "operating a system" | "manner" | "/r/has a" |  | "FN" |  |
| fn:operating_a_system | /r/HasA | fn:fe:duration | "operating a system" | "duration" | "/r/has a" |  | "FN" |  |
| fn:operating_a_system | /r/UsedFor | fn:operational_testing | "operating a system" | "operational testing" | "/r/used for" |  | "FN" |  |
| fn:operational_testing | fn:HasLexicalUnit | fn:lu:operational_testing:test | "operational testing" | "test" | "has lexical unit" |  | "FN" |  |
| fn:operational_testing | fn:HasLexicalUnit | fn:lu:operational_testing:test | "operational testing" | "test" | "has lexical unit" |  | "FN" |  |
| fn:operational_testing | fn:HasLexicalUnit | fn:lu:operational_testing:flight-test | "operational testing" | "flight-test" | "has lexical unit" |  | "FN" |  |
| fn:operational_testing | fn:HasLexicalUnit | fn:lu:operational_testing:crash-test | "operational testing" | "crash-test" | "has lexical unit" |  | "FN" |  |
| fn:operational_testing | fn:HasLexicalUnit | fn:lu:operational_testing:testing | "operational testing" | "testing" | "has lexical unit" |  | "FN" |  |
| fn:operational_testing | fn:HasLexicalUnit | fn:lu:operational_testing:flight-testing | "operational testing" | "flight-testing" | "has lexical unit" |  | "FN" |  |
| fn:operational_testing | fn:HasLexicalUnit | fn:lu:operational_testing:flight_test | "operational testing" | "flight test" | "has lexical unit" |  | "FN" |  |
| fn:operational_testing | fn:HasLexicalUnit | fn:lu:operational_testing:flight_test | "operational testing" | "flight test" | "has lexical unit" |  | "FN" |  |
| fn:operational_testing | fn:HasLexicalUnit | fn:lu:operational_testing:trial | "operational testing" | "trial" | "has lexical unit" |  | "FN" |  |
| fn:operational_testing | fn:HasLexicalUnit | fn:lu:operational_testing:try_out | "operational testing" | "try out" | "has lexical unit" |  | "FN" |  |
| fn:fe:tester | /r/IsA | fn:st:sentient | "tester" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:operational_testing | /r/HasA | fn:fe:tester | "operational testing" | "tester" | "/r/has a" |  | "FN" |  |
| fn:operational_testing | /r/HasA | fn:fe:product | "operational testing" | "product" | "/r/has a" |  | "FN" |  |
| fn:operational_testing | /r/HasA | fn:fe:unwanted_characteristics | "operational testing" | "unwanted characteristics" | "/r/has a" |  | "FN" |  |
| fn:operational_testing | /r/HasA | fn:fe:means | "operational testing" | "means" | "/r/has a" |  | "FN" |  |
| fn:operational_testing | /r/HasA | fn:fe:purpose | "operational testing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:operational_testing | /r/HasA | fn:fe:manner | "operational testing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:operational_testing | /r/HasA | fn:fe:degree | "operational testing" | "degree" | "/r/has a" |  | "FN" |  |
| fn:operational_testing | /r/HasA | fn:fe:location_of_protagonist | "operational testing" | "location of protagonist" | "/r/has a" |  | "FN" |  |
| fn:operational_testing | /r/HasA | fn:fe:desired_state_of_affairs | "operational testing" | "desired state of affairs" | "/r/has a" |  | "FN" |  |
| fn:operational_testing | /r/HasA | fn:fe:time | "operational testing" | "time" | "/r/has a" |  | "FN" |  |
| fn:operational_testing | /r/HasA | fn:fe:circumstances | "operational testing" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:operational_testing | /r/HasA | fn:fe:duration | "operational testing" | "duration" | "/r/has a" |  | "FN" |  |
| fn:operational_testing | /r/HasA | fn:fe:place | "operational testing" | "place" | "/r/has a" |  | "FN" |  |
| fn:operational_testing | /r/HasA | fn:fe:function | "operational testing" | "function" | "/r/has a" |  | "FN" |  |
| fn:operational_testing | /r/HasA | fn:fe:tested_property | "operational testing" | "tested property" | "/r/has a" |  | "FN" |  |
| fn:operational_testing | /r/HasA | fn:fe:period_of_iterations | "operational testing" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:operational_testing | /r/HasA | fn:fe:result | "operational testing" | "result" | "/r/has a" |  | "FN" |  |
| fn:opinion | /r/UsedFor | fn:be_in_agreement_on_assessment | "opinion" | "be in agreement on assessment" | "/r/used for" |  | "FN" |  |
| fn:opinion | /r/UsedFor | fn:taking_sides | "opinion" | "taking sides" | "/r/used for" |  | "FN" |  |
| fn:awareness | /r/RelatedTo | fn:opinion | "awareness" | "opinion" | "/r/related to" |  | "FN" |  |
| fn:awareness | /r/SimilarTo | fn:opinion | "awareness" | "opinion" | "/r/similar to" |  | "FN" |  |
| fn:opinion | fn:HasLexicalUnit | fn:lu:opinion:opinion | "opinion" | "opinion" | "has lexical unit" |  | "FN" |  |
| fn:opinion | fn:HasLexicalUnit | fn:lu:opinion:view | "opinion" | "view" | "has lexical unit" |  | "FN" |  |
| fn:opinion | fn:HasLexicalUnit | fn:lu:opinion:take | "opinion" | "take" | "has lexical unit" |  | "FN" |  |
| fn:opinion | fn:HasLexicalUnit | fn:lu:opinion:think | "opinion" | "think" | "has lexical unit" |  | "FN" |  |
| fn:opinion | fn:HasLexicalUnit | fn:lu:opinion:belief | "opinion" | "belief" | "has lexical unit" |  | "FN" |  |
| fn:opinion | fn:HasLexicalUnit | fn:lu:opinion:expect | "opinion" | "expect" | "has lexical unit" |  | "FN" |  |
| fn:opinion | fn:HasLexicalUnit | fn:lu:opinion:feel | "opinion" | "feel" | "has lexical unit" |  | "FN" |  |
| fn:opinion | fn:HasLexicalUnit | fn:lu:opinion:figure | "opinion" | "figure" | "has lexical unit" |  | "FN" |  |
| fn:opinion | fn:HasLexicalUnit | fn:lu:opinion:suppose | "opinion" | "suppose" | "has lexical unit" |  | "FN" |  |
| fn:opinion | fn:HasLexicalUnit | fn:lu:opinion:believe | "opinion" | "believe" | "has lexical unit" |  | "FN" |  |
| fn:opinion | fn:HasLexicalUnit | fn:lu:opinion:hold | "opinion" | "hold" | "has lexical unit" |  | "FN" |  |
| fn:opinion | fn:HasLexicalUnit | fn:lu:opinion:sense | "opinion" | "sense" | "has lexical unit" |  | "FN" |  |
| fn:opinion | fn:HasLexicalUnit | fn:lu:opinion:subscribe | "opinion" | "subscribe" | "has lexical unit" |  | "FN" |  |
| fn:opinion | fn:HasLexicalUnit | fn:lu:opinion:subscriber | "opinion" | "subscriber" | "has lexical unit" |  | "FN" |  |
| fn:opinion | fn:HasLexicalUnit | fn:lu:opinion:believer | "opinion" | "believer" | "has lexical unit" |  | "FN" |  |
| fn:opinion | /r/HasA | fn:fe:cognizer | "opinion" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:opinion | /r/HasA | fn:fe:opinion | "opinion" | "opinion" | "/r/has a" |  | "FN" |  |
| fn:opinion | /r/HasA | fn:fe:evidence | "opinion" | "evidence" | "/r/has a" |  | "FN" |  |
| fn:opinion | /r/HasA | fn:fe:topic | "opinion" | "topic" | "/r/has a" |  | "FN" |  |
| fn:opinion | /r/HasA | fn:fe:constancy | "opinion" | "constancy" | "/r/has a" |  | "FN" |  |
| fn:opinion | /r/HasA | fn:fe:manner | "opinion" | "manner" | "/r/has a" |  | "FN" |  |
| fn:opinion | /r/HasA | fn:fe:role | "opinion" | "role" | "/r/has a" |  | "FN" |  |
| fn:opinion | /r/HasA | fn:fe:domain | "opinion" | "domain" | "/r/has a" |  | "FN" |  |
| fn:opinion | /r/HasA | fn:fe:time | "opinion" | "time" | "/r/has a" |  | "FN" |  |
| fn:opinion | /r/HasA | fn:fe:circumstances | "opinion" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:alternatives | /r/UsedFor | fn:opportunity | "alternatives" | "opportunity" | "/r/used for" |  | "FN" |  |
| fn:opportunity | fn:HasLexicalUnit | fn:lu:opportunity:opportunity | "opportunity" | "opportunity" | "has lexical unit" |  | "FN" |  |
| fn:opportunity | fn:HasLexicalUnit | fn:lu:opportunity:chance | "opportunity" | "chance" | "has lexical unit" |  | "FN" |  |
| fn:opportunity | fn:HasLexicalUnit | fn:lu:opportunity:opportune | "opportunity" | "opportune" | "has lexical unit" |  | "FN" |  |
| fn:opportunity | fn:HasLexicalUnit | fn:lu:opportunity:break | "opportunity" | "break" | "has lexical unit" |  | "FN" |  |
| fn:opportunity | /r/HasA | fn:fe:opportunity | "opportunity" | "opportunity" | "/r/has a" |  | "FN" |  |
| fn:opportunity | /r/HasA | fn:fe:agent | "opportunity" | "agent" | "/r/has a" |  | "FN" |  |
| fn:opportunity | /r/HasA | fn:fe:desirable_situation | "opportunity" | "desirable situation" | "/r/has a" |  | "FN" |  |
| fn:optical_image | fn:HasLexicalUnit | fn:lu:optical_image:image | "optical image" | "image" | "has lexical unit" |  | "FN" |  |
| fn:optical_image | fn:HasLexicalUnit | fn:lu:optical_image:silhouette | "optical image" | "silhouette" | "has lexical unit" |  | "FN" |  |
| fn:optical_image | fn:HasLexicalUnit | fn:lu:optical_image:shadow | "optical image" | "shadow" | "has lexical unit" |  | "FN" |  |
| fn:optical_image | /r/HasA | fn:fe:image | "optical image" | "image" | "/r/has a" |  | "FN" |  |
| fn:optical_image | /r/HasA | fn:fe:source | "optical image" | "source" | "/r/has a" |  | "FN" |  |
| fn:cardinal_numbers | /r/UsedFor | fn:ordinal_numbers | "cardinal numbers" | "ordinal numbers" | "/r/used for" |  | "FN" |  |
| fn:ordinal_numbers | fn:HasLexicalUnit | fn:lu:ordinal_numbers:first | "ordinal numbers" | "first" | "has lexical unit" |  | "FN" |  |
| fn:ordinal_numbers | fn:HasLexicalUnit | fn:lu:ordinal_numbers:second | "ordinal numbers" | "second" | "has lexical unit" |  | "FN" |  |
| fn:ordinal_numbers | fn:HasLexicalUnit | fn:lu:ordinal_numbers:third | "ordinal numbers" | "third" | "has lexical unit" |  | "FN" |  |
| fn:ordinal_numbers | fn:HasLexicalUnit | fn:lu:ordinal_numbers:fourth | "ordinal numbers" | "fourth" | "has lexical unit" |  | "FN" |  |
| fn:ordinal_numbers | fn:HasLexicalUnit | fn:lu:ordinal_numbers:fifth | "ordinal numbers" | "fifth" | "has lexical unit" |  | "FN" |  |
| fn:ordinal_numbers | fn:HasLexicalUnit | fn:lu:ordinal_numbers:thirteenth | "ordinal numbers" | "thirteenth" | "has lexical unit" |  | "FN" |  |
| fn:ordinal_numbers | fn:HasLexicalUnit | fn:lu:ordinal_numbers:nineteenth | "ordinal numbers" | "nineteenth" | "has lexical unit" |  | "FN" |  |
| fn:ordinal_numbers | fn:HasLexicalUnit | fn:lu:ordinal_numbers:last | "ordinal numbers" | "last" | "has lexical unit" |  | "FN" |  |
| fn:ordinal_numbers | fn:HasLexicalUnit | fn:lu:ordinal_numbers:eighth | "ordinal numbers" | "eighth" | "has lexical unit" |  | "FN" |  |
| fn:ordinal_numbers | fn:HasLexicalUnit | fn:lu:ordinal_numbers:tenth | "ordinal numbers" | "tenth" | "has lexical unit" |  | "FN" |  |
| fn:ordinal_numbers | fn:HasLexicalUnit | fn:lu:ordinal_numbers:ninth | "ordinal numbers" | "ninth" | "has lexical unit" |  | "FN" |  |
| fn:ordinal_numbers | fn:HasLexicalUnit | fn:lu:ordinal_numbers:seventeenth | "ordinal numbers" | "seventeenth" | "has lexical unit" |  | "FN" |  |
| fn:ordinal_numbers | fn:HasLexicalUnit | fn:lu:ordinal_numbers:sixteenth | "ordinal numbers" | "sixteenth" | "has lexical unit" |  | "FN" |  |
| fn:ordinal_numbers | fn:HasLexicalUnit | fn:lu:ordinal_numbers:final | "ordinal numbers" | "final" | "has lexical unit" |  | "FN" |  |
| fn:ordinal_numbers | /r/HasA | fn:fe:type | "ordinal numbers" | "type" | "/r/has a" |  | "FN" |  |
| fn:ordinal_numbers | /r/HasA | fn:fe:starting_point | "ordinal numbers" | "starting point" | "/r/has a" |  | "FN" |  |
| fn:fe:basis_of_order | /r/RelatedTo | fn:fe:starting_point | "basis of order" | "starting point" | "/r/related to" |  | "FN" |  |
| fn:ordinal_numbers | /r/HasA | fn:fe:basis_of_order | "ordinal numbers" | "basis of order" | "/r/has a" |  | "FN" |  |
| fn:ordinal_numbers | /r/HasA | fn:fe:item | "ordinal numbers" | "item" | "/r/has a" |  | "FN" |  |
| fn:ordinal_numbers | /r/HasA | fn:fe:comparison_set | "ordinal numbers" | "comparison set" | "/r/has a" |  | "FN" |  |
| fn:organization | /r/IsA | fn:aggregate | "organization" | "aggregate" | "/r/is a" |  | "FN" |  |
| fn:institutions | /r/IsA | fn:organization | "institutions" | "organization" | "/r/is a" |  | "FN" |  |
| fn:military | /r/IsA | fn:organization | "military" | "organization" | "/r/is a" |  | "FN" |  |
| fn:temporary_group | /r/IsA | fn:organization | "temporary group" | "organization" | "/r/is a" |  | "FN" |  |
| fn:organization | /r/UsedFor | fn:alliance | "organization" | "alliance" | "/r/used for" |  | "FN" |  |
| fn:organization | fn:HasLexicalUnit | fn:lu:organization:cartel | "organization" | "cartel" | "has lexical unit" |  | "FN" |  |
| fn:organization | fn:HasLexicalUnit | fn:lu:organization:club | "organization" | "club" | "has lexical unit" |  | "FN" |  |
| fn:organization | fn:HasLexicalUnit | fn:lu:organization:government | "organization" | "government" | "has lexical unit" |  | "FN" |  |
| fn:organization | fn:HasLexicalUnit | fn:lu:organization:organization | "organization" | "organization" | "has lexical unit" |  | "FN" |  |
| fn:organization | fn:HasLexicalUnit | fn:lu:organization:association | "organization" | "association" | "has lexical unit" |  | "FN" |  |
| fn:organization | fn:HasLexicalUnit | fn:lu:organization:league | "organization" | "league" | "has lexical unit" |  | "FN" |  |
| fn:organization | fn:HasLexicalUnit | fn:lu:organization:intelligence | "organization" | "intelligence" | "has lexical unit" |  | "FN" |  |
| fn:organization | fn:HasLexicalUnit | fn:lu:organization:agency | "organization" | "agency" | "has lexical unit" |  | "FN" |  |
| fn:organization | fn:HasLexicalUnit | fn:lu:organization:union | "organization" | "union" | "has lexical unit" |  | "FN" |  |
| fn:organization | fn:HasLexicalUnit | fn:lu:organization:brotherhood | "organization" | "brotherhood" | "has lexical unit" |  | "FN" |  |
| fn:organization | fn:HasLexicalUnit | fn:lu:organization:delegation | "organization" | "delegation" | "has lexical unit" |  | "FN" |  |
| fn:organization | fn:HasLexicalUnit | fn:lu:organization:committee | "organization" | "committee" | "has lexical unit" |  | "FN" |  |
| fn:organization | fn:HasLexicalUnit | fn:lu:organization:group | "organization" | "group" | "has lexical unit" |  | "FN" |  |
| fn:organization | fn:HasLexicalUnit | fn:lu:organization:board | "organization" | "board" | "has lexical unit" |  | "FN" |  |
| fn:organization | fn:HasLexicalUnit | fn:lu:organization:order | "organization" | "order" | "has lexical unit" |  | "FN" |  |
| fn:organization | fn:HasLexicalUnit | fn:lu:organization:society | "organization" | "society" | "has lexical unit" |  | "FN" |  |
| fn:organization | fn:HasLexicalUnit | fn:lu:organization:parliament | "organization" | "parliament" | "has lexical unit" |  | "FN" |  |
| fn:organization | fn:HasLexicalUnit | fn:lu:organization:news_outlet | "organization" | "news outlet" | "has lexical unit" |  | "FN" |  |
| fn:fe:organization | /r/IsA | fn:st:group | "organization" | "group" | "/r/is a" |  | "FN" |  |
| fn:organization | /r/HasA | fn:fe:organization | "organization" | "organization" | "/r/has a" |  | "FN" |  |
| fn:organization | /r/HasA | fn:fe:members | "organization" | "members" | "/r/has a" |  | "FN" |  |
| fn:organization | /r/HasA | fn:fe:purpose | "organization" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:organization | /r/HasA | fn:fe:period_of_existence | "organization" | "period of existence" | "/r/has a" |  | "FN" |  |
| fn:organization | /r/HasA | fn:fe:name | "organization" | "name" | "/r/has a" |  | "FN" |  |
| fn:organization | /r/HasA | fn:fe:container_possessor | "organization" | "container possessor" | "/r/has a" |  | "FN" |  |
| fn:organization | /r/HasA | fn:fe:place | "organization" | "place" | "/r/has a" |  | "FN" |  |
| fn:organization | /r/HasA | fn:fe:descriptor | "organization" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:indigenous_origin | /r/IsA | fn:origin | "indigenous origin" | "origin" | "/r/is a" |  | "FN" |  |
| fn:origin | /r/UsedFor | fn:people_by_origin | "origin" | "people by origin" | "/r/used for" |  | "FN" |  |
| fn:origin | /r/SimilarTo | fn:people_by_jurisdiction | "origin" | "people by jurisdiction" | "/r/similar to" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:chinese | "origin" | "chinese" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:american | "origin" | "american" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:vietnamese | "origin" | "vietnamese" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:origin | "origin" | "origin" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:originate | "origin" | "originate" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:of | "origin" | "of" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:from | "origin" | "from" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:iranian | "origin" | "iranian" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:canadian | "origin" | "canadian" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:dutch | "origin" | "dutch" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:iraqi | "origin" | "iraqi" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:french | "origin" | "french" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:finnish | "origin" | "finnish" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:indian | "origin" | "indian" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:russian | "origin" | "russian" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:national | "origin" | "national" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:italian | "origin" | "italian" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:syrian | "origin" | "syrian" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:irish | "origin" | "irish" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:japanese | "origin" | "japanese" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:european | "origin" | "european" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:greek | "origin" | "greek" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:jordanian | "origin" | "jordanian" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:swiss | "origin" | "swiss" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:colombian | "origin" | "colombian" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:cuban | "origin" | "cuban" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:egyptian | "origin" | "egyptian" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:roman | "origin" | "roman" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:saudi | "origin" | "saudi" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:turkish | "origin" | "turkish" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:assyrian | "origin" | "assyrian" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:ottoman | "origin" | "ottoman" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:portuguese | "origin" | "portuguese" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:jamaican | "origin" | "jamaican" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:byzantine | "origin" | "byzantine" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:come_from | "origin" | "come from" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:spanish | "origin" | "spanish" | "has lexical unit" |  | "FN" |  |
| fn:origin | fn:HasLexicalUnit | fn:lu:origin:date | "origin" | "date" | "has lexical unit" |  | "FN" |  |
| fn:origin | /r/HasA | fn:fe:entity | "origin" | "entity" | "/r/has a" |  | "FN" |  |
| fn:origin | /r/HasA | fn:fe:origin | "origin" | "origin" | "/r/has a" |  | "FN" |  |
| fn:others_situation_as_stimulus | /r/IsA | fn:emotions_by_stimulus | "others situation as stimulus" | "emotions by stimulus" | "/r/is a" |  | "FN" |  |
| fn:others_situation_as_stimulus | fn:HasLexicalUnit | fn:lu:others_situation_as_stimulus:compassion | "others situation as stimulus" | "compassion" | "has lexical unit" |  | "FN" |  |
| fn:others_situation_as_stimulus | fn:HasLexicalUnit | fn:lu:others_situation_as_stimulus:empathize | "others situation as stimulus" | "empathize" | "has lexical unit" |  | "FN" |  |
| fn:others_situation_as_stimulus | fn:HasLexicalUnit | fn:lu:others_situation_as_stimulus:sympathize | "others situation as stimulus" | "sympathize" | "has lexical unit" |  | "FN" |  |
| fn:others_situation_as_stimulus | fn:HasLexicalUnit | fn:lu:others_situation_as_stimulus:pity | "others situation as stimulus" | "pity" | "has lexical unit" |  | "FN" |  |
| fn:others_situation_as_stimulus | fn:HasLexicalUnit | fn:lu:others_situation_as_stimulus:feel_(for) | "others situation as stimulus" | "feel (for)" | "has lexical unit" |  | "FN" |  |
| fn:others_situation_as_stimulus | /r/HasA | fn:fe:experiencer | "others situation as stimulus" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:fe:other | /r/IsA | fn:st:sentient | "other" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:others_situation_as_stimulus | /r/HasA | fn:fe:other | "others situation as stimulus" | "other" | "/r/has a" |  | "FN" |  |
| fn:others_situation_as_stimulus | /r/HasA | fn:fe:degree | "others situation as stimulus" | "degree" | "/r/has a" |  | "FN" |  |
| fn:others_situation_as_stimulus | /r/HasA | fn:fe:explanation | "others situation as stimulus" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:others_situation_as_stimulus | /r/HasA | fn:fe:circumstances | "others situation as stimulus" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:others_situation_as_stimulus | /r/HasA | fn:fe:parameter | "others situation as stimulus" | "parameter" | "/r/has a" |  | "FN" |  |
| fn:others_situation_as_stimulus | /r/HasA | fn:fe:manner | "others situation as stimulus" | "manner" | "/r/has a" |  | "FN" |  |
| fn:others_situation_as_stimulus | /r/HasA | fn:fe:time | "others situation as stimulus" | "time" | "/r/has a" |  | "FN" |  |
| fn:others_situation_as_stimulus | /r/HasA | fn:fe:situation | "others situation as stimulus" | "situation" | "/r/has a" |  | "FN" |  |
| fn:others_situation_as_stimulus | /r/HasA | fn:fe:frequency | "others situation as stimulus" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:cycle_of_existence_scenario | /r/HasSubevent | fn:out_of_existence | "cycle of existence scenario" | "out of existence" | "/r/has subevent" |  | "FN" |  |
| fn:out_of_existence | /r/HasPrerequisite | fn:ceasing_to_be | "out of existence" | "ceasing to be" | "/r/has prerequisite" |  | "FN" |  |
| fn:out_of_existence | fn:HasLexicalUnit | fn:lu:out_of_existence:toast | "out of existence" | "toast" | "has lexical unit" |  | "FN" |  |
| fn:out_of_existence | fn:HasLexicalUnit | fn:lu:out_of_existence:history | "out of existence" | "history" | "has lexical unit" |  | "FN" |  |
| fn:out_of_existence | fn:HasLexicalUnit | fn:lu:out_of_existence:gone | "out of existence" | "gone" | "has lexical unit" |  | "FN" |  |
| fn:out_of_existence | fn:HasLexicalUnit | fn:lu:out_of_existence:a_thing_of_the_past | "out of existence" | "a thing of the past" | "has lexical unit" |  | "FN" |  |
| fn:out_of_existence | /r/HasA | fn:fe:entity | "out of existence" | "entity" | "/r/has a" |  | "FN" |  |
| fn:out_of_existence | /r/HasA | fn:fe:place | "out of existence" | "place" | "/r/has a" |  | "FN" |  |
| fn:out_of_existence | /r/HasA | fn:fe:time | "out of existence" | "time" | "/r/has a" |  | "FN" |  |
| fn:out_of_existence | /r/HasA | fn:fe:explanation | "out of existence" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:out_of_existence | /r/HasA | fn:fe:duration | "out of existence" | "duration" | "/r/has a" |  | "FN" |  |
| fn:out_of_existence | /r/HasA | fn:fe:role | "out of existence" | "role" | "/r/has a" |  | "FN" |  |
| fn:out_of_existence | /r/HasA | fn:fe:manner | "out of existence" | "manner" | "/r/has a" |  | "FN" |  |
| fn:out_of_existence | /r/HasA | fn:fe:circumstances | "out of existence" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:pardon | /r/IsA | fn:clemency | "pardon" | "clemency" | "/r/is a" |  | "FN" |  |
| fn:pardon | /r/SimilarTo | fn:clemency | "pardon" | "clemency" | "/r/similar to" |  | "FN" |  |
| fn:pardon | fn:HasLexicalUnit | fn:lu:pardon:pardon | "pardon" | "pardon" | "has lexical unit" |  | "FN" |  |
| fn:pardon | fn:HasLexicalUnit | fn:lu:pardon:pardon | "pardon" | "pardon" | "has lexical unit" |  | "FN" |  |
| fn:pardon | /r/HasA | fn:fe:offender | "pardon" | "offender" | "/r/has a" |  | "FN" |  |
| fn:pardon | /r/HasA | fn:fe:authority | "pardon" | "authority" | "/r/has a" |  | "FN" |  |
| fn:pardon | /r/HasA | fn:fe:offense | "pardon" | "offense" | "/r/has a" |  | "FN" |  |
| fn:pardon | /r/HasA | fn:fe:explanation | "pardon" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:pardon | /r/HasA | fn:fe:time | "pardon" | "time" | "/r/has a" |  | "FN" |  |
| fn:pardon | /r/HasA | fn:fe:means | "pardon" | "means" | "/r/has a" |  | "FN" |  |
| fn:pardon | /r/HasA | fn:fe:manner | "pardon" | "manner" | "/r/has a" |  | "FN" |  |
| fn:pardon | /r/HasA | fn:fe:place | "pardon" | "place" | "/r/has a" |  | "FN" |  |
| fn:pardon | /r/HasA | fn:fe:purpose | "pardon" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:part_edge | /r/IsA | fn:part_whole | "part edge" | "part whole" | "/r/is a" |  | "FN" |  |
| fn:part_edge | fn:HasLexicalUnit | fn:lu:part_edge:edge | "part edge" | "edge" | "has lexical unit" |  | "FN" |  |
| fn:part_edge | /r/HasA | fn:fe:orientation | "part edge" | "orientation" | "/r/has a" |  | "FN" |  |
| fn:part_edge | /r/HasA | fn:fe:whole | "part edge" | "whole" | "/r/has a" |  | "FN" |  |
| fn:part_edge | /r/HasA | fn:fe:part_prop | "part edge" | "part prop" | "/r/has a" |  | "FN" |  |
| fn:part_edge | /r/HasA | fn:fe:part | "part edge" | "part" | "/r/has a" |  | "FN" |  |
| fn:part_inner_outer | /r/IsA | fn:part_whole | "part inner outer" | "part whole" | "/r/is a" |  | "FN" |  |
| fn:part_orientational | /r/SimilarTo | fn:part_inner_outer | "part orientational" | "part inner outer" | "/r/similar to" |  | "FN" |  |
| fn:part_inner_outer | fn:HasLexicalUnit | fn:lu:part_inner_outer:outside | "part inner outer" | "outside" | "has lexical unit" |  | "FN" |  |
| fn:part_inner_outer | fn:HasLexicalUnit | fn:lu:part_inner_outer:outer | "part inner outer" | "outer" | "has lexical unit" |  | "FN" |  |
| fn:part_inner_outer | fn:HasLexicalUnit | fn:lu:part_inner_outer:inside | "part inner outer" | "inside" | "has lexical unit" |  | "FN" |  |
| fn:part_inner_outer | fn:HasLexicalUnit | fn:lu:part_inner_outer:exterior | "part inner outer" | "exterior" | "has lexical unit" |  | "FN" |  |
| fn:part_inner_outer | fn:HasLexicalUnit | fn:lu:part_inner_outer:inner | "part inner outer" | "inner" | "has lexical unit" |  | "FN" |  |
| fn:part_inner_outer | fn:HasLexicalUnit | fn:lu:part_inner_outer:outside | "part inner outer" | "outside" | "has lexical unit" |  | "FN" |  |
| fn:part_inner_outer | fn:HasLexicalUnit | fn:lu:part_inner_outer:skin | "part inner outer" | "skin" | "has lexical unit" |  | "FN" |  |
| fn:part_inner_outer | fn:HasLexicalUnit | fn:lu:part_inner_outer:lining | "part inner outer" | "lining" | "has lexical unit" |  | "FN" |  |
| fn:part_inner_outer | fn:HasLexicalUnit | fn:lu:part_inner_outer:perimeter | "part inner outer" | "perimeter" | "has lexical unit" |  | "FN" |  |
| fn:part_inner_outer | fn:HasLexicalUnit | fn:lu:part_inner_outer:center | "part inner outer" | "center" | "has lexical unit" |  | "FN" |  |
| fn:part_inner_outer | fn:HasLexicalUnit | fn:lu:part_inner_outer:exterior | "part inner outer" | "exterior" | "has lexical unit" |  | "FN" |  |
| fn:part_inner_outer | fn:HasLexicalUnit | fn:lu:part_inner_outer:inside | "part inner outer" | "inside" | "has lexical unit" |  | "FN" |  |
| fn:part_inner_outer | fn:HasLexicalUnit | fn:lu:part_inner_outer:interior | "part inner outer" | "interior" | "has lexical unit" |  | "FN" |  |
| fn:part_inner_outer | fn:HasLexicalUnit | fn:lu:part_inner_outer:interior | "part inner outer" | "interior" | "has lexical unit" |  | "FN" |  |
| fn:part_inner_outer | fn:HasLexicalUnit | fn:lu:part_inner_outer:middle | "part inner outer" | "middle" | "has lexical unit" |  | "FN" |  |
| fn:part_inner_outer | fn:HasLexicalUnit | fn:lu:part_inner_outer:shell | "part inner outer" | "shell" | "has lexical unit" |  | "FN" |  |
| fn:part_inner_outer | fn:HasLexicalUnit | fn:lu:part_inner_outer:surface | "part inner outer" | "surface" | "has lexical unit" |  | "FN" |  |
| fn:part_inner_outer | fn:HasLexicalUnit | fn:lu:part_inner_outer:central | "part inner outer" | "central" | "has lexical unit" |  | "FN" |  |
| fn:part_inner_outer | /r/HasA | fn:fe:part | "part inner outer" | "part" | "/r/has a" |  | "FN" |  |
| fn:part_inner_outer | /r/HasA | fn:fe:whole | "part inner outer" | "whole" | "/r/has a" |  | "FN" |  |
| fn:part_inner_outer | /r/HasA | fn:fe:part_prop | "part inner outer" | "part prop" | "/r/has a" |  | "FN" |  |
| fn:part_ordered_segments | /r/IsA | fn:part_whole | "part ordered segments" | "part whole" | "/r/is a" |  | "FN" |  |
| fn:part_ordered_segments | fn:HasLexicalUnit | fn:lu:part_ordered_segments:inning | "part ordered segments" | "inning" | "has lexical unit" |  | "FN" |  |
| fn:part_ordered_segments | fn:HasLexicalUnit | fn:lu:part_ordered_segments:chapter | "part ordered segments" | "chapter" | "has lexical unit" |  | "FN" |  |
| fn:part_ordered_segments | fn:HasLexicalUnit | fn:lu:part_ordered_segments:act | "part ordered segments" | "act" | "has lexical unit" |  | "FN" |  |
| fn:part_ordered_segments | fn:HasLexicalUnit | fn:lu:part_ordered_segments:book | "part ordered segments" | "book" | "has lexical unit" |  | "FN" |  |
| fn:part_ordered_segments | fn:HasLexicalUnit | fn:lu:part_ordered_segments:layer | "part ordered segments" | "layer" | "has lexical unit" |  | "FN" |  |
| fn:part_ordered_segments | fn:HasLexicalUnit | fn:lu:part_ordered_segments:level | "part ordered segments" | "level" | "has lexical unit" |  | "FN" |  |
| fn:part_ordered_segments | /r/HasA | fn:fe:ordinality | "part ordered segments" | "ordinality" | "/r/has a" |  | "FN" |  |
| fn:part_ordered_segments | /r/HasA | fn:fe:part_prop | "part ordered segments" | "part prop" | "/r/has a" |  | "FN" |  |
| fn:part_ordered_segments | /r/HasA | fn:fe:part | "part ordered segments" | "part" | "/r/has a" |  | "FN" |  |
| fn:part_ordered_segments | /r/HasA | fn:fe:whole | "part ordered segments" | "whole" | "/r/has a" |  | "FN" |  |
| fn:part_orientational | /r/IsA | fn:part_whole | "part orientational" | "part whole" | "/r/is a" |  | "FN" |  |
| fn:part_orientational | /r/UsedFor | fn:temporal_subregion | "part orientational" | "temporal subregion" | "/r/used for" |  | "FN" |  |
| fn:part_orientational | /r/SimilarTo | fn:part_inner_outer | "part orientational" | "part inner outer" | "/r/similar to" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:top | "part orientational" | "top" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:bottom | "part orientational" | "bottom" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:front | "part orientational" | "front" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:back | "part orientational" | "back" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:side | "part orientational" | "side" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:underside | "part orientational" | "underside" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:underbelly | "part orientational" | "underbelly" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:peak | "part orientational" | "peak" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:back | "part orientational" | "back" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:top | "part orientational" | "top" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:bottom | "part orientational" | "bottom" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:apex | "part orientational" | "apex" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:base | "part orientational" | "base" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:tip | "part orientational" | "tip" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:rear | "part orientational" | "rear" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:foot | "part orientational" | "foot" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:face | "part orientational" | "face" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:hind | "part orientational" | "hind" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:rear | "part orientational" | "rear" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:heart | "part orientational" | "heart" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:left | "part orientational" | "left" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:left | "part orientational" | "left" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:right | "part orientational" | "right" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:right | "part orientational" | "right" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:crest | "part orientational" | "crest" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:summit | "part orientational" | "summit" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:east | "part orientational" | "east" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:west | "part orientational" | "west" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:north | "part orientational" | "north" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:south | "part orientational" | "south" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:southern | "part orientational" | "southern" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:northern | "part orientational" | "northern" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:northernmost | "part orientational" | "northernmost" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:southernmost | "part orientational" | "southernmost" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:eastern | "part orientational" | "eastern" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:easternmost | "part orientational" | "easternmost" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:western | "part orientational" | "western" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:westernmost | "part orientational" | "westernmost" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:north | "part orientational" | "north" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:south | "part orientational" | "south" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:west | "part orientational" | "west" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:east | "part orientational" | "east" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:northwest | "part orientational" | "northwest" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:north-south | "part orientational" | "north-south" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | fn:HasLexicalUnit | fn:lu:part_orientational:front | "part orientational" | "front" | "has lexical unit" |  | "FN" |  |
| fn:part_orientational | /r/HasA | fn:fe:part | "part orientational" | "part" | "/r/has a" |  | "FN" |  |
| fn:part_orientational | /r/HasA | fn:fe:part_prop | "part orientational" | "part prop" | "/r/has a" |  | "FN" |  |
| fn:part_orientational | /r/HasA | fn:fe:whole | "part orientational" | "whole" | "/r/has a" |  | "FN" |  |
| fn:part_piece | /r/IsA | fn:being_included | "part piece" | "being included" | "/r/is a" |  | "FN" |  |
| fn:part_whole | /r/IsA | fn:part_piece | "part whole" | "part piece" | "/r/is a" |  | "FN" |  |
| fn:part_piece | /r/IsA | fn:wholes_and_parts | "part piece" | "wholes and parts" | "/r/is a" |  | "FN" |  |
| fn:part_piece | fn:HasLexicalUnit | fn:lu:part_piece:scrap | "part piece" | "scrap" | "has lexical unit" |  | "FN" |  |
| fn:part_piece | fn:HasLexicalUnit | fn:lu:part_piece:sliver | "part piece" | "sliver" | "has lexical unit" |  | "FN" |  |
| fn:part_piece | fn:HasLexicalUnit | fn:lu:part_piece:shred | "part piece" | "shred" | "has lexical unit" |  | "FN" |  |
| fn:part_piece | fn:HasLexicalUnit | fn:lu:part_piece:snippet | "part piece" | "snippet" | "has lexical unit" |  | "FN" |  |
| fn:part_piece | fn:HasLexicalUnit | fn:lu:part_piece:hunk | "part piece" | "hunk" | "has lexical unit" |  | "FN" |  |
| fn:part_piece | fn:HasLexicalUnit | fn:lu:part_piece:chunk | "part piece" | "chunk" | "has lexical unit" |  | "FN" |  |
| fn:part_piece | fn:HasLexicalUnit | fn:lu:part_piece:smidgen | "part piece" | "smidgen" | "has lexical unit" |  | "FN" |  |
| fn:part_piece | fn:HasLexicalUnit | fn:lu:part_piece:chip | "part piece" | "chip" | "has lexical unit" |  | "FN" |  |
| fn:part_piece | fn:HasLexicalUnit | fn:lu:part_piece:shard | "part piece" | "shard" | "has lexical unit" |  | "FN" |  |
| fn:part_piece | fn:HasLexicalUnit | fn:lu:part_piece:morsel | "part piece" | "morsel" | "has lexical unit" |  | "FN" |  |
| fn:part_piece | fn:HasLexicalUnit | fn:lu:part_piece:piece | "part piece" | "piece" | "has lexical unit" |  | "FN" |  |
| fn:part_piece | fn:HasLexicalUnit | fn:lu:part_piece:slice | "part piece" | "slice" | "has lexical unit" |  | "FN" |  |
| fn:part_piece | fn:HasLexicalUnit | fn:lu:part_piece:lump | "part piece" | "lump" | "has lexical unit" |  | "FN" |  |
| fn:part_piece | fn:HasLexicalUnit | fn:lu:part_piece:flake | "part piece" | "flake" | "has lexical unit" |  | "FN" |  |
| fn:part_piece | fn:HasLexicalUnit | fn:lu:part_piece:fragment | "part piece" | "fragment" | "has lexical unit" |  | "FN" |  |
| fn:part_piece | fn:HasLexicalUnit | fn:lu:part_piece:clump | "part piece" | "clump" | "has lexical unit" |  | "FN" |  |
| fn:part_piece | fn:HasLexicalUnit | fn:lu:part_piece:clod | "part piece" | "clod" | "has lexical unit" |  | "FN" |  |
| fn:part_piece | fn:HasLexicalUnit | fn:lu:part_piece:board_[computer] | "part piece" | "board [computer]" | "has lexical unit" |  | "FN" |  |
| fn:part_piece | /r/HasA | fn:fe:piece | "part piece" | "piece" | "/r/has a" |  | "FN" |  |
| fn:part_piece | /r/HasA | fn:fe:piece_prop | "part piece" | "piece prop" | "/r/has a" |  | "FN" |  |
| fn:part_piece | /r/HasA | fn:fe:substance | "part piece" | "substance" | "/r/has a" |  | "FN" |  |
| fn:part_whole | /r/IsA | fn:part_piece | "part whole" | "part piece" | "/r/is a" |  | "FN" |  |
| fn:part_edge | /r/IsA | fn:part_whole | "part edge" | "part whole" | "/r/is a" |  | "FN" |  |
| fn:part_inner_outer | /r/IsA | fn:part_whole | "part inner outer" | "part whole" | "/r/is a" |  | "FN" |  |
| fn:part_ordered_segments | /r/IsA | fn:part_whole | "part ordered segments" | "part whole" | "/r/is a" |  | "FN" |  |
| fn:part_orientational | /r/IsA | fn:part_whole | "part orientational" | "part whole" | "/r/is a" |  | "FN" |  |
| fn:rest | /r/IsA | fn:part_whole | "rest" | "part whole" | "/r/is a" |  | "FN" |  |
| fn:shaped_part | /r/IsA | fn:part_whole | "shaped part" | "part whole" | "/r/is a" |  | "FN" |  |
| fn:temporary_group | /r/IsA | fn:part_whole | "temporary group" | "part whole" | "/r/is a" |  | "FN" |  |
| fn:vehicle_subpart | /r/IsA | fn:part_whole | "vehicle subpart" | "part whole" | "/r/is a" |  | "FN" |  |
| fn:part_whole | /r/UsedFor | fn:completeness | "part whole" | "completeness" | "/r/used for" |  | "FN" |  |
| fn:part_whole | /r/UsedFor | fn:inclusion | "part whole" | "inclusion" | "/r/used for" |  | "FN" |  |
| fn:part_whole | fn:HasLexicalUnit | fn:lu:part_whole:part | "part whole" | "part" | "has lexical unit" |  | "FN" |  |
| fn:part_whole | fn:HasLexicalUnit | fn:lu:part_whole:fragment | "part whole" | "fragment" | "has lexical unit" |  | "FN" |  |
| fn:part_whole | fn:HasLexicalUnit | fn:lu:part_whole:half | "part whole" | "half" | "has lexical unit" |  | "FN" |  |
| fn:part_whole | fn:HasLexicalUnit | fn:lu:part_whole:segment | "part whole" | "segment" | "has lexical unit" |  | "FN" |  |
| fn:part_whole | fn:HasLexicalUnit | fn:lu:part_whole:section | "part whole" | "section" | "has lexical unit" |  | "FN" |  |
| fn:part_whole | fn:HasLexicalUnit | fn:lu:part_whole:eighth | "part whole" | "eighth" | "has lexical unit" |  | "FN" |  |
| fn:part_whole | fn:HasLexicalUnit | fn:lu:part_whole:fifth | "part whole" | "fifth" | "has lexical unit" |  | "FN" |  |
| fn:part_whole | fn:HasLexicalUnit | fn:lu:part_whole:hundredth | "part whole" | "hundredth" | "has lexical unit" |  | "FN" |  |
| fn:part_whole | fn:HasLexicalUnit | fn:lu:part_whole:third | "part whole" | "third" | "has lexical unit" |  | "FN" |  |
| fn:part_whole | fn:HasLexicalUnit | fn:lu:part_whole:quarter | "part whole" | "quarter" | "has lexical unit" |  | "FN" |  |
| fn:part_whole | fn:HasLexicalUnit | fn:lu:part_whole:tenth | "part whole" | "tenth" | "has lexical unit" |  | "FN" |  |
| fn:part_whole | fn:HasLexicalUnit | fn:lu:part_whole:portion | "part whole" | "portion" | "has lexical unit" |  | "FN" |  |
| fn:part_whole | fn:HasLexicalUnit | fn:lu:part_whole:development | "part whole" | "development" | "has lexical unit" |  | "FN" |  |
| fn:part_whole | /r/HasA | fn:fe:part | "part whole" | "part" | "/r/has a" |  | "FN" |  |
| fn:part_whole | /r/HasA | fn:fe:whole | "part whole" | "whole" | "/r/has a" |  | "FN" |  |
| fn:part_whole | /r/HasA | fn:fe:part_prop | "part whole" | "part prop" | "/r/has a" |  | "FN" |  |
| fn:part_whole | /r/HasA | fn:fe:orientation | "part whole" | "orientation" | "/r/has a" |  | "FN" |  |
| fn:part_whole | /r/HasA | fn:fe:system | "part whole" | "system" | "/r/has a" |  | "FN" |  |
| fn:part_whole | /r/HasA | fn:fe:name | "part whole" | "name" | "/r/has a" |  | "FN" |  |
| fn:partiality | /r/IsA | fn:social_interaction_evaluation | "partiality" | "social interaction evaluation" | "/r/is a" |  | "FN" |  |
| fn:taking_sides | /r/UsedFor | fn:partiality | "taking sides" | "partiality" | "/r/used for" |  | "FN" |  |
| fn:partiality | fn:HasLexicalUnit | fn:lu:partiality:bias | "partiality" | "bias" | "has lexical unit" |  | "FN" |  |
| fn:partiality | fn:HasLexicalUnit | fn:lu:partiality:partial | "partiality" | "partial" | "has lexical unit" |  | "FN" |  |
| fn:partiality | fn:HasLexicalUnit | fn:lu:partiality:impartial | "partiality" | "impartial" | "has lexical unit" |  | "FN" |  |
| fn:partiality | fn:HasLexicalUnit | fn:lu:partiality:partiality | "partiality" | "partiality" | "has lexical unit" |  | "FN" |  |
| fn:partiality | fn:HasLexicalUnit | fn:lu:partiality:impartiality | "partiality" | "impartiality" | "has lexical unit" |  | "FN" |  |
| fn:partiality | fn:HasLexicalUnit | fn:lu:partiality:neutral | "partiality" | "neutral" | "has lexical unit" |  | "FN" |  |
| fn:partiality | fn:HasLexicalUnit | fn:lu:partiality:neutrality | "partiality" | "neutrality" | "has lexical unit" |  | "FN" |  |
| fn:partiality | fn:HasLexicalUnit | fn:lu:partiality:favor | "partiality" | "favor" | "has lexical unit" |  | "FN" |  |
| fn:partiality | fn:HasLexicalUnit | fn:lu:partiality:prefer | "partiality" | "prefer" | "has lexical unit" |  | "FN" |  |
| fn:partiality | fn:HasLexicalUnit | fn:lu:partiality:bias | "partiality" | "bias" | "has lexical unit" |  | "FN" |  |
| fn:partiality | fn:HasLexicalUnit | fn:lu:partiality:biased | "partiality" | "biased" | "has lexical unit" |  | "FN" |  |
| fn:partiality | fn:HasLexicalUnit | fn:lu:partiality:prejudiced | "partiality" | "prejudiced" | "has lexical unit" |  | "FN" |  |
| fn:partiality | fn:HasLexicalUnit | fn:lu:partiality:prejudice | "partiality" | "prejudice" | "has lexical unit" |  | "FN" |  |
| fn:partiality | fn:HasLexicalUnit | fn:lu:partiality:prejudge | "partiality" | "prejudge" | "has lexical unit" |  | "FN" |  |
| fn:fe:decision_maker | /r/IsA | fn:st:sentient | "decision maker" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:partiality | /r/HasA | fn:fe:decision_maker | "partiality" | "decision maker" | "/r/has a" |  | "FN" |  |
| fn:partiality | /r/HasA | fn:fe:side_1 | "partiality" | "side 1" | "/r/has a" |  | "FN" |  |
| fn:partiality | /r/HasA | fn:fe:sides | "partiality" | "sides" | "/r/has a" |  | "FN" |  |
| fn:partiality | /r/HasA | fn:fe:side_2 | "partiality" | "side 2" | "/r/has a" |  | "FN" |  |
| fn:partiality | /r/HasA | fn:fe:domain | "partiality" | "domain" | "/r/has a" |  | "FN" |  |
| fn:partiality | /r/HasA | fn:fe:degree | "partiality" | "degree" | "/r/has a" |  | "FN" |  |
| fn:partiality | /r/HasA | fn:fe:manifestation_of_bias | "partiality" | "manifestation of bias" | "/r/has a" |  | "FN" |  |
| fn:partiality | /r/HasA | fn:fe:dispute | "partiality" | "dispute" | "/r/has a" |  | "FN" |  |
| fn:partiality | /r/HasA | fn:fe:judge | "partiality" | "judge" | "/r/has a" |  | "FN" |  |
| fn:partiality | /r/HasA | fn:fe:explanation | "partiality" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:partiality | /r/HasA | fn:fe:time | "partiality" | "time" | "/r/has a" |  | "FN" |  |
| fn:partiality | /r/HasA | fn:fe:expressor | "partiality" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:partiality | /r/HasA | fn:fe:manner | "partiality" | "manner" | "/r/has a" |  | "FN" |  |
| fn:event | /r/UsedFor | fn:participation | "event" | "participation" | "/r/used for" |  | "FN" |  |
| fn:participation | /r/UsedFor | fn:withdraw_from_participation | "participation" | "withdraw from participation" | "/r/used for" |  | "FN" |  |
| fn:reciprocality | /r/UsedFor | fn:participation | "reciprocality" | "participation" | "/r/used for" |  | "FN" |  |
| fn:participation | fn:HasLexicalUnit | fn:lu:participation:participate | "participation" | "participate" | "has lexical unit" |  | "FN" |  |
| fn:participation | fn:HasLexicalUnit | fn:lu:participation:participant | "participation" | "participant" | "has lexical unit" |  | "FN" |  |
| fn:participation | fn:HasLexicalUnit | fn:lu:participation:participation | "participation" | "participation" | "has lexical unit" |  | "FN" |  |
| fn:participation | fn:HasLexicalUnit | fn:lu:participation:involved | "participation" | "involved" | "has lexical unit" |  | "FN" |  |
| fn:participation | fn:HasLexicalUnit | fn:lu:participation:involvement | "participation" | "involvement" | "has lexical unit" |  | "FN" |  |
| fn:participation | fn:HasLexicalUnit | fn:lu:participation:embroiled | "participation" | "embroiled" | "has lexical unit" |  | "FN" |  |
| fn:participation | fn:HasLexicalUnit | fn:lu:participation:player | "participation" | "player" | "has lexical unit" |  | "FN" |  |
| fn:participation | fn:HasLexicalUnit | fn:lu:participation:entangled | "participation" | "entangled" | "has lexical unit" |  | "FN" |  |
| fn:participation | fn:HasLexicalUnit | fn:lu:participation:entanglement | "participation" | "entanglement" | "has lexical unit" |  | "FN" |  |
| fn:participation | fn:HasLexicalUnit | fn:lu:participation:take_part | "participation" | "take part" | "has lexical unit" |  | "FN" |  |
| fn:participation | fn:HasLexicalUnit | fn:lu:participation:party | "participation" | "party" | "has lexical unit" |  | "FN" |  |
| fn:participation | fn:HasLexicalUnit | fn:lu:participation:engage | "participation" | "engage" | "has lexical unit" |  | "FN" |  |
| fn:participation | fn:HasLexicalUnit | fn:lu:participation:concerned | "participation" | "concerned" | "has lexical unit" |  | "FN" |  |
| fn:participation | /r/HasA | fn:fe:participants | "participation" | "participants" | "/r/has a" |  | "FN" |  |
| fn:participation | /r/HasA | fn:fe:participant_1 | "participation" | "participant 1" | "/r/has a" |  | "FN" |  |
| fn:participation | /r/HasA | fn:fe:participant_2 | "participation" | "participant 2" | "/r/has a" |  | "FN" |  |
| fn:fe:event | /r/RelatedTo | fn:fe:institution | "event" | "institution" | "/r/related to" |  | "FN" |  |
| fn:participation | /r/HasA | fn:fe:event | "participation" | "event" | "/r/has a" |  | "FN" |  |
| fn:participation | /r/HasA | fn:fe:time | "participation" | "time" | "/r/has a" |  | "FN" |  |
| fn:participation | /r/HasA | fn:fe:place | "participation" | "place" | "/r/has a" |  | "FN" |  |
| fn:participation | /r/HasA | fn:fe:manner | "participation" | "manner" | "/r/has a" |  | "FN" |  |
| fn:participation | /r/HasA | fn:fe:purpose | "participation" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:participation | /r/HasA | fn:fe:means | "participation" | "means" | "/r/has a" |  | "FN" |  |
| fn:participation | /r/HasA | fn:fe:degree_of_involvement | "participation" | "degree of involvement" | "/r/has a" |  | "FN" |  |
| fn:participation | /r/HasA | fn:fe:institution | "participation" | "institution" | "/r/has a" |  | "FN" |  |
| fn:participation | /r/HasA | fn:fe:duration | "participation" | "duration" | "/r/has a" |  | "FN" |  |
| fn:partitive | /r/IsA | fn:relation | "partitive" | "relation" | "/r/is a" |  | "FN" |  |
| fn:partitive | fn:HasLexicalUnit | fn:lu:partitive:of | "partitive" | "of" | "has lexical unit" |  | "FN" |  |
| fn:partitive | fn:HasLexicalUnit | fn:lu:partitive:out_of | "partitive" | "out of" | "has lexical unit" |  | "FN" |  |
| fn:partitive | /r/HasA | fn:fe:subset | "partitive" | "subset" | "/r/has a" |  | "FN" |  |
| fn:partitive | /r/HasA | fn:fe:group | "partitive" | "group" | "/r/has a" |  | "FN" |  |
| fn:passing | /r/IsA | fn:cause_motion | "passing" | "cause motion" | "/r/is a" |  | "FN" |  |
| fn:bringing | /r/RelatedTo | fn:passing | "bringing" | "passing" | "/r/related to" |  | "FN" |  |
| fn:passing | fn:HasLexicalUnit | fn:lu:passing:pass | "passing" | "pass" | "has lexical unit" |  | "FN" |  |
| fn:passing | /r/HasA | fn:fe:agent | "passing" | "agent" | "/r/has a" |  | "FN" |  |
| fn:passing | /r/HasA | fn:fe:theme | "passing" | "theme" | "/r/has a" |  | "FN" |  |
| fn:passing | /r/HasA | fn:fe:source | "passing" | "source" | "/r/has a" |  | "FN" |  |
| fn:passing | /r/HasA | fn:fe:path | "passing" | "path" | "/r/has a" |  | "FN" |  |
| fn:fe:recipient | /r/IsA | fn:st:goal | "recipient" | "goal" | "/r/is a" |  | "FN" |  |
| fn:fe:recipient | /r/RelatedTo | fn:fe:area | "recipient" | "area" | "/r/related to" |  | "FN" |  |
| fn:passing | /r/HasA | fn:fe:recipient | "passing" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:passing | /r/HasA | fn:fe:distance | "passing" | "distance" | "/r/has a" |  | "FN" |  |
| fn:passing | /r/HasA | fn:fe:area | "passing" | "area" | "/r/has a" |  | "FN" |  |
| fn:passing | /r/HasA | fn:fe:depictive | "passing" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:passing | /r/HasA | fn:fe:means | "passing" | "means" | "/r/has a" |  | "FN" |  |
| fn:passing | /r/HasA | fn:fe:manner | "passing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:passing | /r/HasA | fn:fe:instrument | "passing" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:passing | /r/HasA | fn:fe:place | "passing" | "place" | "/r/has a" |  | "FN" |  |
| fn:passing | /r/HasA | fn:fe:time | "passing" | "time" | "/r/has a" |  | "FN" |  |
| fn:passing | /r/HasA | fn:fe:result | "passing" | "result" | "/r/has a" |  | "FN" |  |
| fn:passing | /r/HasA | fn:fe:initial_state | "passing" | "initial state" | "/r/has a" |  | "FN" |  |
| fn:passing | /r/HasA | fn:fe:explanation | "passing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:passing_off | /r/IsA | fn:intentionally_act | "passing off" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:posing_as | /r/IsA | fn:passing_off | "posing as" | "passing off" | "/r/is a" |  | "FN" |  |
| fn:passing_off | fn:HasLexicalUnit | fn:lu:passing_off:pass_off | "passing off" | "pass off" | "has lexical unit" |  | "FN" |  |
| fn:passing_off | fn:HasLexicalUnit | fn:lu:passing_off:palm_off | "passing off" | "palm off" | "has lexical unit" |  | "FN" |  |
| fn:passing_off | /r/HasA | fn:fe:agent | "passing off" | "agent" | "/r/has a" |  | "FN" |  |
| fn:passing_off | /r/HasA | fn:fe:manner | "passing off" | "manner" | "/r/has a" |  | "FN" |  |
| fn:passing_off | /r/HasA | fn:fe:means | "passing off" | "means" | "/r/has a" |  | "FN" |  |
| fn:passing_off | /r/HasA | fn:fe:item | "passing off" | "item" | "/r/has a" |  | "FN" |  |
| fn:passing_off | /r/HasA | fn:fe:purpose | "passing off" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:passing_off | /r/HasA | fn:fe:explanation | "passing off" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:passing_off | /r/HasA | fn:fe:simulated_entity | "passing off" | "simulated entity" | "/r/has a" |  | "FN" |  |
| fn:passing_off | /r/HasA | fn:fe:place | "passing off" | "place" | "/r/has a" |  | "FN" |  |
| fn:passing_off | /r/HasA | fn:fe:audience | "passing off" | "audience" | "/r/has a" |  | "FN" |  |
| fn:passing_off | /r/HasA | fn:fe:time | "passing off" | "time" | "/r/has a" |  | "FN" |  |
| fn:locative_relation | /r/UsedFor | fn:path_shape | "locative relation" | "path shape" | "/r/used for" |  | "FN" |  |
| fn:path_shape | /r/UsedFor | fn:traversing | "path shape" | "traversing" | "/r/used for" |  | "FN" |  |
| fn:path_shape | /r/SimilarTo | fn:avoiding | "path shape" | "avoiding" | "/r/similar to" |  | "FN" |  |
| fn:path_shape | /r/SimilarTo | fn:change_posture | "path shape" | "change posture" | "/r/similar to" |  | "FN" |  |
| fn:path_shape | /r/SimilarTo | fn:departing | "path shape" | "departing" | "/r/similar to" |  | "FN" |  |
| fn:path_shape | /r/SimilarTo | fn:traversing | "path shape" | "traversing" | "/r/similar to" |  | "FN" |  |
| fn:traversing | /r/SimilarTo | fn:path_shape | "traversing" | "path shape" | "/r/similar to" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:angle | "path shape" | "angle" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:bear | "path shape" | "bear" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:crisscross | "path shape" | "crisscross" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:cross | "path shape" | "cross" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:descend | "path shape" | "descend" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:dip | "path shape" | "dip" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:drop | "path shape" | "drop" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:edge | "path shape" | "edge" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:emerge | "path shape" | "emerge" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:exit | "path shape" | "exit" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:leave | "path shape" | "leave" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:meander | "path shape" | "meander" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:reach | "path shape" | "reach" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:rise | "path shape" | "rise" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:skirt | "path shape" | "skirt" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:slant | "path shape" | "slant" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:snake | "path shape" | "snake" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:swerve | "path shape" | "swerve" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:swing | "path shape" | "swing" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:traverse | "path shape" | "traverse" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:veer | "path shape" | "veer" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:weave | "path shape" | "weave" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:wind | "path shape" | "wind" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:zigzag | "path shape" | "zigzag" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:undulate | "path shape" | "undulate" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:winding | "path shape" | "winding" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:twisting | "path shape" | "twisting" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:windy | "path shape" | "windy" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:twisty | "path shape" | "twisty" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:ascend | "path shape" | "ascend" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:ascent | "path shape" | "ascent" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:bend | "path shape" | "bend" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:descent | "path shape" | "descent" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:dive | "path shape" | "dive" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:emergence | "path shape" | "emergence" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:crest | "path shape" | "crest" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:round | "path shape" | "round" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:enter | "path shape" | "enter" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:pass | "path shape" | "pass" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:ford | "path shape" | "ford" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:twist | "path shape" | "twist" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | fn:HasLexicalUnit | fn:lu:path_shape:run | "path shape" | "run" | "has lexical unit" |  | "FN" |  |
| fn:path_shape | /r/HasA | fn:fe:source | "path shape" | "source" | "/r/has a" |  | "FN" |  |
| fn:path_shape | /r/HasA | fn:fe:path | "path shape" | "path" | "/r/has a" |  | "FN" |  |
| fn:path_shape | /r/HasA | fn:fe:goal | "path shape" | "goal" | "/r/has a" |  | "FN" |  |
| fn:path_shape | /r/HasA | fn:fe:road | "path shape" | "road" | "/r/has a" |  | "FN" |  |
| fn:path_shape | /r/HasA | fn:fe:manner | "path shape" | "manner" | "/r/has a" |  | "FN" |  |
| fn:path_shape | /r/HasA | fn:fe:distance | "path shape" | "distance" | "/r/has a" |  | "FN" |  |
| fn:path_shape | /r/HasA | fn:fe:area | "path shape" | "area" | "/r/has a" |  | "FN" |  |
| fn:path_shape | /r/HasA | fn:fe:degree | "path shape" | "degree" | "/r/has a" |  | "FN" |  |
| fn:path_shape | /r/HasA | fn:fe:means | "path shape" | "means" | "/r/has a" |  | "FN" |  |
| fn:path_shape | /r/HasA | fn:fe:result | "path shape" | "result" | "/r/has a" |  | "FN" |  |
| fn:path_shape | /r/HasA | fn:fe:speed | "path shape" | "speed" | "/r/has a" |  | "FN" |  |
| fn:path_shape | /r/HasA | fn:fe:depictive | "path shape" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:path_shape | /r/HasA | fn:fe:place | "path shape" | "place" | "/r/has a" |  | "FN" |  |
| fn:path_shape | /r/HasA | fn:fe:path_shape | "path shape" | "path shape" | "/r/has a" |  | "FN" |  |
| fn:path_shape | /r/HasA | fn:fe:direction | "path shape" | "direction" | "/r/has a" |  | "FN" |  |
| fn:path_shape | /r/HasA | fn:fe:time | "path shape" | "time" | "/r/has a" |  | "FN" |  |
| fn:path_shape | /r/HasA | fn:fe:purpose | "path shape" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:path_traveled | "motion" | "path traveled" | "/r/used for" |  | "FN" |  |
| fn:path_traveled | fn:HasLexicalUnit | fn:lu:path_traveled:orbit | "path traveled" | "orbit" | "has lexical unit" |  | "FN" |  |
| fn:path_traveled | fn:HasLexicalUnit | fn:lu:path_traveled:course | "path traveled" | "course" | "has lexical unit" |  | "FN" |  |
| fn:path_traveled | fn:HasLexicalUnit | fn:lu:path_traveled:circuit | "path traveled" | "circuit" | "has lexical unit" |  | "FN" |  |
| fn:path_traveled | fn:HasLexicalUnit | fn:lu:path_traveled:path | "path traveled" | "path" | "has lexical unit" |  | "FN" |  |
| fn:path_traveled | /r/HasA | fn:fe:path | "path traveled" | "path" | "/r/has a" |  | "FN" |  |
| fn:path_traveled | /r/HasA | fn:fe:source | "path traveled" | "source" | "/r/has a" |  | "FN" |  |
| fn:path_traveled | /r/HasA | fn:fe:goal | "path traveled" | "goal" | "/r/has a" |  | "FN" |  |
| fn:path_traveled | /r/HasA | fn:fe:endpoints | "path traveled" | "endpoints" | "/r/has a" |  | "FN" |  |
| fn:path_traveled | /r/HasA | fn:fe:characteristic | "path traveled" | "characteristic" | "/r/has a" |  | "FN" |  |
| fn:path_traveled | /r/HasA | fn:fe:landmark | "path traveled" | "landmark" | "/r/has a" |  | "FN" |  |
| fn:path_traveled | /r/HasA | fn:fe:direction | "path traveled" | "direction" | "/r/has a" |  | "FN" |  |
| fn:path_traveled | /r/HasA | fn:fe:ground | "path traveled" | "ground" | "/r/has a" |  | "FN" |  |
| fn:path_traveled | /r/HasA | fn:fe:length | "path traveled" | "length" | "/r/has a" |  | "FN" |  |
| fn:path_traveled | /r/HasA | fn:fe:theme | "path traveled" | "theme" | "/r/has a" |  | "FN" |  |
| fn:patrolling | /r/IsA | fn:inspecting | "patrolling" | "inspecting" | "/r/is a" |  | "FN" |  |
| fn:patrolling | fn:HasLexicalUnit | fn:lu:patrolling:patrol | "patrolling" | "patrol" | "has lexical unit" |  | "FN" |  |
| fn:patrolling | fn:HasLexicalUnit | fn:lu:patrolling:police | "patrolling" | "police" | "has lexical unit" |  | "FN" |  |
| fn:patrolling | fn:HasLexicalUnit | fn:lu:patrolling:patrol_[act] | "patrolling" | "patrol [act]" | "has lexical unit" |  | "FN" |  |
| fn:patrolling | fn:HasLexicalUnit | fn:lu:patrolling:patrol_[entity] | "patrolling" | "patrol [entity]" | "has lexical unit" |  | "FN" |  |
| fn:fe:patrol | /r/IsA | fn:st:sentient | "patrol" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:patrolling | /r/HasA | fn:fe:patrol | "patrolling" | "patrol" | "/r/has a" |  | "FN" |  |
| fn:patrolling | /r/HasA | fn:fe:ground | "patrolling" | "ground" | "/r/has a" |  | "FN" |  |
| fn:patrolling | /r/HasA | fn:fe:unwanted_entity | "patrolling" | "unwanted entity" | "/r/has a" |  | "FN" |  |
| fn:patrolling | /r/HasA | fn:fe:means | "patrolling" | "means" | "/r/has a" |  | "FN" |  |
| fn:patrolling | /r/HasA | fn:fe:purpose | "patrolling" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:patrolling | /r/HasA | fn:fe:manner | "patrolling" | "manner" | "/r/has a" |  | "FN" |  |
| fn:patrolling | /r/HasA | fn:fe:degree | "patrolling" | "degree" | "/r/has a" |  | "FN" |  |
| fn:patrolling | /r/HasA | fn:fe:location_of_protagonist | "patrolling" | "location of protagonist" | "/r/has a" |  | "FN" |  |
| fn:patrolling | /r/HasA | fn:fe:desired_state_of_affairs | "patrolling" | "desired state of affairs" | "/r/has a" |  | "FN" |  |
| fn:patrolling | /r/HasA | fn:fe:time | "patrolling" | "time" | "/r/has a" |  | "FN" |  |
| fn:patrolling | /r/HasA | fn:fe:circumstances | "patrolling" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:patrolling | /r/HasA | fn:fe:instrument | "patrolling" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:patrolling | /r/HasA | fn:fe:particular_iteration | "patrolling" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:patrolling | /r/HasA | fn:fe:descriptor | "patrolling" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:patrolling | /r/HasA | fn:fe:members | "patrolling" | "members" | "/r/has a" |  | "FN" |  |
| fn:patrolling | /r/HasA | fn:fe:duration | "patrolling" | "duration" | "/r/has a" |  | "FN" |  |
| fn:patrolling | /r/HasA | fn:fe:co-participant | "patrolling" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:patrolling | /r/HasA | fn:fe:vehicle | "patrolling" | "vehicle" | "/r/has a" |  | "FN" |  |
| fn:patrolling | /r/HasA | fn:fe:possessor | "patrolling" | "possessor" | "/r/has a" |  | "FN" |  |
| fn:pattern | fn:HasLexicalUnit | fn:lu:pattern:pattern | "pattern" | "pattern" | "has lexical unit" |  | "FN" |  |
| fn:pattern | fn:HasLexicalUnit | fn:lu:pattern:formation | "pattern" | "formation" | "has lexical unit" |  | "FN" |  |
| fn:pattern | /r/HasA | fn:fe:entities | "pattern" | "entities" | "/r/has a" |  | "FN" |  |
| fn:pattern | /r/HasA | fn:fe:name | "pattern" | "name" | "/r/has a" |  | "FN" |  |
| fn:pattern | /r/HasA | fn:fe:descriptor | "pattern" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:people | /r/IsA | fn:biological_entity | "people" | "biological entity" | "/r/is a" |  | "FN" |  |
| fn:irregular_combatants | /r/IsA | fn:people | "irregular combatants" | "people" | "/r/is a" |  | "FN" |  |
| fn:noncombatant | /r/IsA | fn:people | "noncombatant" | "people" | "/r/is a" |  | "FN" |  |
| fn:people_along_political_spectrum | /r/IsA | fn:people | "people along political spectrum" | "people" | "/r/is a" |  | "FN" |  |
| fn:people_by_age | /r/IsA | fn:people | "people by age" | "people" | "/r/is a" |  | "FN" |  |
| fn:people_by_jurisdiction | /r/IsA | fn:people | "people by jurisdiction" | "people" | "/r/is a" |  | "FN" |  |
| fn:people_by_morality | /r/IsA | fn:people | "people by morality" | "people" | "/r/is a" |  | "FN" |  |
| fn:people_by_origin | /r/IsA | fn:people | "people by origin" | "people" | "/r/is a" |  | "FN" |  |
| fn:people_by_religion | /r/IsA | fn:people | "people by religion" | "people" | "/r/is a" |  | "FN" |  |
| fn:people_by_residence | /r/IsA | fn:people | "people by residence" | "people" | "/r/is a" |  | "FN" |  |
| fn:people_by_vocation | /r/IsA | fn:people | "people by vocation" | "people" | "/r/is a" |  | "FN" |  |
| fn:people | /r/UsedFor | fn:fields | "people" | "fields" | "/r/used for" |  | "FN" |  |
| fn:people | /r/UsedFor | fn:race_descriptor | "people" | "race descriptor" | "/r/used for" |  | "FN" |  |
| fn:people | /r/UsedFor | fn:relation_between_individuals | "people" | "relation between individuals" | "/r/used for" |  | "FN" |  |
| fn:people | /r/SimilarTo | fn:people_by_age | "people" | "people by age" | "/r/similar to" |  | "FN" |  |
| fn:people | fn:HasLexicalUnit | fn:lu:people:people | "people" | "people" | "has lexical unit" |  | "FN" |  |
| fn:people | fn:HasLexicalUnit | fn:lu:people:person | "people" | "person" | "has lexical unit" |  | "FN" |  |
| fn:people | fn:HasLexicalUnit | fn:lu:people:un | "people" | "un" | "has lexical unit" |  | "FN" |  |
| fn:people | fn:HasLexicalUnit | fn:lu:people:guy | "people" | "guy" | "has lexical unit" |  | "FN" |  |
| fn:people | fn:HasLexicalUnit | fn:lu:people:dude | "people" | "dude" | "has lexical unit" |  | "FN" |  |
| fn:people | fn:HasLexicalUnit | fn:lu:people:lady | "people" | "lady" | "has lexical unit" |  | "FN" |  |
| fn:people | fn:HasLexicalUnit | fn:lu:people:man | "people" | "man" | "has lexical unit" |  | "FN" |  |
| fn:people | fn:HasLexicalUnit | fn:lu:people:woman | "people" | "woman" | "has lexical unit" |  | "FN" |  |
| fn:people | fn:HasLexicalUnit | fn:lu:people:fellow | "people" | "fellow" | "has lexical unit" |  | "FN" |  |
| fn:people | fn:HasLexicalUnit | fn:lu:people:gentleman | "people" | "gentleman" | "has lexical unit" |  | "FN" |  |
| fn:people | fn:HasLexicalUnit | fn:lu:people:girl | "people" | "girl" | "has lexical unit" |  | "FN" |  |
| fn:people | fn:HasLexicalUnit | fn:lu:people:individual | "people" | "individual" | "has lexical unit" |  | "FN" |  |
| fn:people | fn:HasLexicalUnit | fn:lu:people:chap | "people" | "chap" | "has lexical unit" |  | "FN" |  |
| fn:people | fn:HasLexicalUnit | fn:lu:people:human | "people" | "human" | "has lexical unit" |  | "FN" |  |
| fn:people | fn:HasLexicalUnit | fn:lu:people:human_being | "people" | "human being" | "has lexical unit" |  | "FN" |  |
| fn:people | fn:HasLexicalUnit | fn:lu:people:folks | "people" | "folks" | "has lexical unit" |  | "FN" |  |
| fn:people | fn:HasLexicalUnit | fn:lu:people:life | "people" | "life" | "has lexical unit" |  | "FN" |  |
| fn:people | fn:HasLexicalUnit | fn:lu:people:pax | "people" | "pax" | "has lexical unit" |  | "FN" |  |
| fn:people | fn:HasLexicalUnit | fn:lu:people:folk | "people" | "folk" | "has lexical unit" |  | "FN" |  |
| fn:people | fn:HasLexicalUnit | fn:lu:people:who | "people" | "who" | "has lexical unit" |  | "FN" |  |
| fn:people | fn:HasLexicalUnit | fn:lu:people:someone | "people" | "someone" | "has lexical unit" |  | "FN" |  |
| fn:people | fn:HasLexicalUnit | fn:lu:people:somebody | "people" | "somebody" | "has lexical unit" |  | "FN" |  |
| fn:people | fn:HasLexicalUnit | fn:lu:people:personage | "people" | "personage" | "has lexical unit" |  | "FN" |  |
| fn:people | fn:HasLexicalUnit | fn:lu:people:gent | "people" | "gent" | "has lexical unit" |  | "FN" |  |
| fn:people | fn:HasLexicalUnit | fn:lu:people:character | "people" | "character" | "has lexical unit" |  | "FN" |  |
| fn:people | /r/HasA | fn:fe:origin | "people" | "origin" | "/r/has a" |  | "FN" |  |
| fn:people | /r/HasA | fn:fe:person | "people" | "person" | "/r/has a" |  | "FN" |  |
| fn:people | /r/HasA | fn:fe:persistent_characteristic | "people" | "persistent characteristic" | "/r/has a" |  | "FN" |  |
| fn:people | /r/HasA | fn:fe:descriptor | "people" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:people | /r/HasA | fn:fe:age | "people" | "age" | "/r/has a" |  | "FN" |  |
| fn:people | /r/HasA | fn:fe:ethnicity | "people" | "ethnicity" | "/r/has a" |  | "FN" |  |
| fn:people | /r/HasA | fn:fe:context_of_acquaintance | "people" | "context of acquaintance" | "/r/has a" |  | "FN" |  |
| fn:people_along_political_spectrum | /r/IsA | fn:people | "people along political spectrum" | "people" | "/r/is a" |  | "FN" |  |
| fn:people_along_political_spectrum | fn:HasLexicalUnit | fn:lu:people_along_political_spectrum:left | "people along political spectrum" | "left" | "has lexical unit" |  | "FN" |  |
| fn:people_along_political_spectrum | fn:HasLexicalUnit | fn:lu:people_along_political_spectrum:leftist | "people along political spectrum" | "leftist" | "has lexical unit" |  | "FN" |  |
| fn:people_along_political_spectrum | fn:HasLexicalUnit | fn:lu:people_along_political_spectrum:conservative | "people along political spectrum" | "conservative" | "has lexical unit" |  | "FN" |  |
| fn:people_along_political_spectrum | fn:HasLexicalUnit | fn:lu:people_along_political_spectrum:far-left | "people along political spectrum" | "far-left" | "has lexical unit" |  | "FN" |  |
| fn:people_along_political_spectrum | fn:HasLexicalUnit | fn:lu:people_along_political_spectrum:far_left | "people along political spectrum" | "far left" | "has lexical unit" |  | "FN" |  |
| fn:people_along_political_spectrum | /r/HasA | fn:fe:individual | "people along political spectrum" | "individual" | "/r/has a" |  | "FN" |  |
| fn:people_along_political_spectrum | /r/HasA | fn:fe:place | "people along political spectrum" | "place" | "/r/has a" |  | "FN" |  |
| fn:people_along_political_spectrum | /r/HasA | fn:fe:domain | "people along political spectrum" | "domain" | "/r/has a" |  | "FN" |  |
| fn:people_along_political_spectrum | /r/HasA | fn:fe:origin | "people along political spectrum" | "origin" | "/r/has a" |  | "FN" |  |
| fn:people_along_political_spectrum | /r/HasA | fn:fe:descriptor | "people along political spectrum" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:people_along_political_spectrum | /r/HasA | fn:fe:persistent_characteristic | "people along political spectrum" | "persistent characteristic" | "/r/has a" |  | "FN" |  |
| fn:people_along_political_spectrum | /r/HasA | fn:fe:age | "people along political spectrum" | "age" | "/r/has a" |  | "FN" |  |
| fn:people_along_political_spectrum | /r/HasA | fn:fe:ethnicity | "people along political spectrum" | "ethnicity" | "/r/has a" |  | "FN" |  |
| fn:people_along_political_spectrum | /r/HasA | fn:fe:position_qualifier | "people along political spectrum" | "position qualifier" | "/r/has a" |  | "FN" |  |
| fn:people_by_age | /r/IsA | fn:people | "people by age" | "people" | "/r/is a" |  | "FN" |  |
| fn:age | /r/UsedFor | fn:people_by_age | "age" | "people by age" | "/r/used for" |  | "FN" |  |
| fn:people | /r/SimilarTo | fn:people_by_age | "people" | "people by age" | "/r/similar to" |  | "FN" |  |
| fn:people_by_age | fn:HasLexicalUnit | fn:lu:people_by_age:geezer | "people by age" | "geezer" | "has lexical unit" |  | "FN" |  |
| fn:people_by_age | fn:HasLexicalUnit | fn:lu:people_by_age:coot | "people by age" | "coot" | "has lexical unit" |  | "FN" |  |
| fn:people_by_age | fn:HasLexicalUnit | fn:lu:people_by_age:spring_chicken | "people by age" | "spring chicken" | "has lexical unit" |  | "FN" |  |
| fn:people_by_age | fn:HasLexicalUnit | fn:lu:people_by_age:adolescent | "people by age" | "adolescent" | "has lexical unit" |  | "FN" |  |
| fn:people_by_age | fn:HasLexicalUnit | fn:lu:people_by_age:adult | "people by age" | "adult" | "has lexical unit" |  | "FN" |  |
| fn:people_by_age | fn:HasLexicalUnit | fn:lu:people_by_age:baby | "people by age" | "baby" | "has lexical unit" |  | "FN" |  |
| fn:people_by_age | fn:HasLexicalUnit | fn:lu:people_by_age:boy | "people by age" | "boy" | "has lexical unit" |  | "FN" |  |
| fn:people_by_age | fn:HasLexicalUnit | fn:lu:people_by_age:child | "people by age" | "child" | "has lexical unit" |  | "FN" |  |
| fn:people_by_age | fn:HasLexicalUnit | fn:lu:people_by_age:infant | "people by age" | "infant" | "has lexical unit" |  | "FN" |  |
| fn:people_by_age | fn:HasLexicalUnit | fn:lu:people_by_age:neonate | "people by age" | "neonate" | "has lexical unit" |  | "FN" |  |
| fn:people_by_age | fn:HasLexicalUnit | fn:lu:people_by_age:teenager | "people by age" | "teenager" | "has lexical unit" |  | "FN" |  |
| fn:people_by_age | fn:HasLexicalUnit | fn:lu:people_by_age:kid | "people by age" | "kid" | "has lexical unit" |  | "FN" |  |
| fn:people_by_age | fn:HasLexicalUnit | fn:lu:people_by_age:youth | "people by age" | "youth" | "has lexical unit" |  | "FN" |  |
| fn:people_by_age | fn:HasLexicalUnit | fn:lu:people_by_age:youngster | "people by age" | "youngster" | "has lexical unit" |  | "FN" |  |
| fn:people_by_age | fn:HasLexicalUnit | fn:lu:people_by_age:elderly | "people by age" | "elderly" | "has lexical unit" |  | "FN" |  |
| fn:people_by_age | fn:HasLexicalUnit | fn:lu:people_by_age:newborn | "people by age" | "newborn" | "has lexical unit" |  | "FN" |  |
| fn:people_by_age | /r/HasA | fn:fe:origin | "people by age" | "origin" | "/r/has a" |  | "FN" |  |
| fn:people_by_age | /r/HasA | fn:fe:person | "people by age" | "person" | "/r/has a" |  | "FN" |  |
| fn:people_by_age | /r/HasA | fn:fe:persistent_characteristic | "people by age" | "persistent characteristic" | "/r/has a" |  | "FN" |  |
| fn:people_by_age | /r/HasA | fn:fe:descriptor | "people by age" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:people_by_age | /r/HasA | fn:fe:age | "people by age" | "age" | "/r/has a" |  | "FN" |  |
| fn:people_by_age | /r/HasA | fn:fe:ethnicity | "people by age" | "ethnicity" | "/r/has a" |  | "FN" |  |
| fn:people_by_age | /r/HasA | fn:fe:context_of_acquaintance | "people by age" | "context of acquaintance" | "/r/has a" |  | "FN" |  |
| fn:people_by_jurisdiction | /r/IsA | fn:people | "people by jurisdiction" | "people" | "/r/is a" |  | "FN" |  |
| fn:political_locales | /r/UsedFor | fn:people_by_jurisdiction | "political locales" | "people by jurisdiction" | "/r/used for" |  | "FN" |  |
| fn:origin | /r/SimilarTo | fn:people_by_jurisdiction | "origin" | "people by jurisdiction" | "/r/similar to" |  | "FN" |  |
| fn:people_by_jurisdiction | fn:HasLexicalUnit | fn:lu:people_by_jurisdiction:citizen | "people by jurisdiction" | "citizen" | "has lexical unit" |  | "FN" |  |
| fn:people_by_jurisdiction | fn:HasLexicalUnit | fn:lu:people_by_jurisdiction:parishioner | "people by jurisdiction" | "parishioner" | "has lexical unit" |  | "FN" |  |
| fn:people_by_jurisdiction | fn:HasLexicalUnit | fn:lu:people_by_jurisdiction:national | "people by jurisdiction" | "national" | "has lexical unit" |  | "FN" |  |
| fn:people_by_jurisdiction | fn:HasLexicalUnit | fn:lu:people_by_jurisdiction:subject | "people by jurisdiction" | "subject" | "has lexical unit" |  | "FN" |  |
| fn:people_by_jurisdiction | fn:HasLexicalUnit | fn:lu:people_by_jurisdiction:citizenry | "people by jurisdiction" | "citizenry" | "has lexical unit" |  | "FN" |  |
| fn:people_by_jurisdiction | /r/HasA | fn:fe:jurisdiction | "people by jurisdiction" | "jurisdiction" | "/r/has a" |  | "FN" |  |
| fn:people_by_jurisdiction | /r/HasA | fn:fe:person | "people by jurisdiction" | "person" | "/r/has a" |  | "FN" |  |
| fn:people_by_jurisdiction | /r/HasA | fn:fe:persistent_characteristic | "people by jurisdiction" | "persistent characteristic" | "/r/has a" |  | "FN" |  |
| fn:people_by_jurisdiction | /r/HasA | fn:fe:descriptor | "people by jurisdiction" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:people_by_jurisdiction | /r/HasA | fn:fe:age | "people by jurisdiction" | "age" | "/r/has a" |  | "FN" |  |
| fn:people_by_jurisdiction | /r/HasA | fn:fe:ethnicity | "people by jurisdiction" | "ethnicity" | "/r/has a" |  | "FN" |  |
| fn:people_by_jurisdiction | /r/HasA | fn:fe:authority | "people by jurisdiction" | "authority" | "/r/has a" |  | "FN" |  |
| fn:member_of_military | /r/UsedFor | fn:people_by_military_specialty | "member of military" | "people by military specialty" | "/r/used for" |  | "FN" |  |
| fn:people_by_military_specialty | fn:HasLexicalUnit | fn:lu:people_by_military_specialty:gunner | "people by military specialty" | "gunner" | "has lexical unit" |  | "FN" |  |
| fn:people_by_military_specialty | fn:HasLexicalUnit | fn:lu:people_by_military_specialty:sniper | "people by military specialty" | "sniper" | "has lexical unit" |  | "FN" |  |
| fn:people_by_military_specialty | fn:HasLexicalUnit | fn:lu:people_by_military_specialty:signaller | "people by military specialty" | "signaller" | "has lexical unit" |  | "FN" |  |
| fn:people_by_military_specialty | fn:HasLexicalUnit | fn:lu:people_by_military_specialty:infantryman | "people by military specialty" | "infantryman" | "has lexical unit" |  | "FN" |  |
| fn:people_by_military_specialty | /r/HasA | fn:fe:origin | "people by military specialty" | "origin" | "/r/has a" |  | "FN" |  |
| fn:fe:fighter | /r/IsA | fn:st:human | "fighter" | "human" | "/r/is a" |  | "FN" |  |
| fn:people_by_military_specialty | /r/HasA | fn:fe:fighter | "people by military specialty" | "fighter" | "/r/has a" |  | "FN" |  |
| fn:people_by_military_specialty | /r/HasA | fn:fe:persistent_characteristic | "people by military specialty" | "persistent characteristic" | "/r/has a" |  | "FN" |  |
| fn:people_by_military_specialty | /r/HasA | fn:fe:descriptor | "people by military specialty" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:people_by_military_specialty | /r/HasA | fn:fe:age | "people by military specialty" | "age" | "/r/has a" |  | "FN" |  |
| fn:people_by_military_specialty | /r/HasA | fn:fe:ethnicity | "people by military specialty" | "ethnicity" | "/r/has a" |  | "FN" |  |
| fn:people_by_military_specialty | /r/HasA | fn:fe:context_of_acquaintance | "people by military specialty" | "context of acquaintance" | "/r/has a" |  | "FN" |  |
| fn:people_by_military_specialty | /r/HasA | fn:fe:rank | "people by military specialty" | "rank" | "/r/has a" |  | "FN" |  |
| fn:people_by_military_specialty | /r/HasA | fn:fe:place_of_operation | "people by military specialty" | "place of operation" | "/r/has a" |  | "FN" |  |
| fn:people_by_military_specialty | /r/HasA | fn:fe:loyal_side | "people by military specialty" | "loyal side" | "/r/has a" |  | "FN" |  |
| fn:people_by_military_specialty | /r/HasA | fn:fe:type | "people by military specialty" | "type" | "/r/has a" |  | "FN" |  |
| fn:people_by_military_specialty | /r/HasA | fn:fe:compensation | "people by military specialty" | "compensation" | "/r/has a" |  | "FN" |  |
| fn:people_by_military_specialty | /r/HasA | fn:fe:contract_basis | "people by military specialty" | "contract basis" | "/r/has a" |  | "FN" |  |
| fn:people_by_military_specialty | /r/HasA | fn:fe:military_organization | "people by military specialty" | "military organization" | "/r/has a" |  | "FN" |  |
| fn:people_by_morality | /r/IsA | fn:people | "people by morality" | "people" | "/r/is a" |  | "FN" |  |
| fn:morality_evaluation | /r/UsedFor | fn:people_by_morality | "morality evaluation" | "people by morality" | "/r/used for" |  | "FN" |  |
| fn:morality_evaluation | /r/SimilarTo | fn:people_by_morality | "morality evaluation" | "people by morality" | "/r/similar to" |  | "FN" |  |
| fn:people_by_morality | fn:HasLexicalUnit | fn:lu:people_by_morality:villain | "people by morality" | "villain" | "has lexical unit" |  | "FN" |  |
| fn:people_by_morality | fn:HasLexicalUnit | fn:lu:people_by_morality:reprobate | "people by morality" | "reprobate" | "has lexical unit" |  | "FN" |  |
| fn:people_by_morality | fn:HasLexicalUnit | fn:lu:people_by_morality:degenerate | "people by morality" | "degenerate" | "has lexical unit" |  | "FN" |  |
| fn:people_by_morality | fn:HasLexicalUnit | fn:lu:people_by_morality:sinner | "people by morality" | "sinner" | "has lexical unit" |  | "FN" |  |
| fn:people_by_morality | fn:HasLexicalUnit | fn:lu:people_by_morality:miscreant | "people by morality" | "miscreant" | "has lexical unit" |  | "FN" |  |
| fn:people_by_morality | fn:HasLexicalUnit | fn:lu:people_by_morality:fink | "people by morality" | "fink" | "has lexical unit" |  | "FN" |  |
| fn:people_by_morality | fn:HasLexicalUnit | fn:lu:people_by_morality:bad_apple | "people by morality" | "bad apple" | "has lexical unit" |  | "FN" |  |
| fn:people_by_morality | fn:HasLexicalUnit | fn:lu:people_by_morality:malefactor | "people by morality" | "malefactor" | "has lexical unit" |  | "FN" |  |
| fn:people_by_morality | fn:HasLexicalUnit | fn:lu:people_by_morality:evildoer | "people by morality" | "evildoer" | "has lexical unit" |  | "FN" |  |
| fn:people_by_morality | fn:HasLexicalUnit | fn:lu:people_by_morality:delinquent | "people by morality" | "delinquent" | "has lexical unit" |  | "FN" |  |
| fn:people_by_morality | fn:HasLexicalUnit | fn:lu:people_by_morality:low_life | "people by morality" | "low life" | "has lexical unit" |  | "FN" |  |
| fn:people_by_morality | fn:HasLexicalUnit | fn:lu:people_by_morality:wrongdoer | "people by morality" | "wrongdoer" | "has lexical unit" |  | "FN" |  |
| fn:people_by_morality | fn:HasLexicalUnit | fn:lu:people_by_morality:saint | "people by morality" | "saint" | "has lexical unit" |  | "FN" |  |
| fn:people_by_morality | /r/HasA | fn:fe:origin | "people by morality" | "origin" | "/r/has a" |  | "FN" |  |
| fn:people_by_morality | /r/HasA | fn:fe:person | "people by morality" | "person" | "/r/has a" |  | "FN" |  |
| fn:people_by_morality | /r/HasA | fn:fe:persistent_characteristic | "people by morality" | "persistent characteristic" | "/r/has a" |  | "FN" |  |
| fn:people_by_morality | /r/HasA | fn:fe:descriptor | "people by morality" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:people_by_morality | /r/HasA | fn:fe:age | "people by morality" | "age" | "/r/has a" |  | "FN" |  |
| fn:people_by_morality | /r/HasA | fn:fe:ethnicity | "people by morality" | "ethnicity" | "/r/has a" |  | "FN" |  |
| fn:people_by_morality | /r/HasA | fn:fe:context_of_acquaintance | "people by morality" | "context of acquaintance" | "/r/has a" |  | "FN" |  |
| fn:people_by_morality | /r/HasA | fn:fe:field | "people by morality" | "field" | "/r/has a" |  | "FN" |  |
| fn:people_by_origin | /r/IsA | fn:people | "people by origin" | "people" | "/r/is a" |  | "FN" |  |
| fn:origin | /r/UsedFor | fn:people_by_origin | "origin" | "people by origin" | "/r/used for" |  | "FN" |  |
| fn:people_by_origin | fn:HasLexicalUnit | fn:lu:people_by_origin:mexican | "people by origin" | "mexican" | "has lexical unit" |  | "FN" |  |
| fn:people_by_origin | fn:HasLexicalUnit | fn:lu:people_by_origin:new_yorker | "people by origin" | "new yorker" | "has lexical unit" |  | "FN" |  |
| fn:people_by_origin | fn:HasLexicalUnit | fn:lu:people_by_origin:frenchman | "people by origin" | "frenchman" | "has lexical unit" |  | "FN" |  |
| fn:people_by_origin | fn:HasLexicalUnit | fn:lu:people_by_origin:english | "people by origin" | "english" | "has lexical unit" |  | "FN" |  |
| fn:people_by_origin | fn:HasLexicalUnit | fn:lu:people_by_origin:foreigner | "people by origin" | "foreigner" | "has lexical unit" |  | "FN" |  |
| fn:people_by_origin | fn:HasLexicalUnit | fn:lu:people_by_origin:american | "people by origin" | "american" | "has lexical unit" |  | "FN" |  |
| fn:people_by_origin | fn:HasLexicalUnit | fn:lu:people_by_origin:american_[n_and_s_am] | "people by origin" | "american [n and s am]" | "has lexical unit" |  | "FN" |  |
| fn:people_by_origin | fn:HasLexicalUnit | fn:lu:people_by_origin:frenchwoman | "people by origin" | "frenchwoman" | "has lexical unit" |  | "FN" |  |
| fn:people_by_origin | fn:HasLexicalUnit | fn:lu:people_by_origin:frenchy | "people by origin" | "frenchy" | "has lexical unit" |  | "FN" |  |
| fn:people_by_origin | fn:HasLexicalUnit | fn:lu:people_by_origin:kraut | "people by origin" | "kraut" | "has lexical unit" |  | "FN" |  |
| fn:people_by_origin | fn:HasLexicalUnit | fn:lu:people_by_origin:brit | "people by origin" | "brit" | "has lexical unit" |  | "FN" |  |
| fn:people_by_origin | fn:HasLexicalUnit | fn:lu:people_by_origin:denverite | "people by origin" | "denverite" | "has lexical unit" |  | "FN" |  |
| fn:people_by_origin | fn:HasLexicalUnit | fn:lu:people_by_origin:chicagoan | "people by origin" | "chicagoan" | "has lexical unit" |  | "FN" |  |
| fn:people_by_origin | fn:HasLexicalUnit | fn:lu:people_by_origin:californian | "people by origin" | "californian" | "has lexical unit" |  | "FN" |  |
| fn:people_by_origin | fn:HasLexicalUnit | fn:lu:people_by_origin:iranian | "people by origin" | "iranian" | "has lexical unit" |  | "FN" |  |
| fn:people_by_origin | fn:HasLexicalUnit | fn:lu:people_by_origin:irish | "people by origin" | "irish" | "has lexical unit" |  | "FN" |  |
| fn:people_by_origin | fn:HasLexicalUnit | fn:lu:people_by_origin:dubliner | "people by origin" | "dubliner" | "has lexical unit" |  | "FN" |  |
| fn:people_by_origin | fn:HasLexicalUnit | fn:lu:people_by_origin:persian | "people by origin" | "persian" | "has lexical unit" |  | "FN" |  |
| fn:people_by_origin | fn:HasLexicalUnit | fn:lu:people_by_origin:greek | "people by origin" | "greek" | "has lexical unit" |  | "FN" |  |
| fn:people_by_origin | fn:HasLexicalUnit | fn:lu:people_by_origin:turk | "people by origin" | "turk" | "has lexical unit" |  | "FN" |  |
| fn:people_by_origin | fn:HasLexicalUnit | fn:lu:people_by_origin:italian | "people by origin" | "italian" | "has lexical unit" |  | "FN" |  |
| fn:people_by_origin | fn:HasLexicalUnit | fn:lu:people_by_origin:ottoman | "people by origin" | "ottoman" | "has lexical unit" |  | "FN" |  |
| fn:people_by_origin | fn:HasLexicalUnit | fn:lu:people_by_origin:german | "people by origin" | "german" | "has lexical unit" |  | "FN" |  |
| fn:people_by_origin | fn:HasLexicalUnit | fn:lu:people_by_origin:indian_[american] | "people by origin" | "indian [american]" | "has lexical unit" |  | "FN" |  |
| fn:people_by_origin | fn:HasLexicalUnit | fn:lu:people_by_origin:englishwoman | "people by origin" | "englishwoman" | "has lexical unit" |  | "FN" |  |
| fn:people_by_origin | /r/HasA | fn:fe:origin | "people by origin" | "origin" | "/r/has a" |  | "FN" |  |
| fn:people_by_origin | /r/HasA | fn:fe:person | "people by origin" | "person" | "/r/has a" |  | "FN" |  |
| fn:people_by_origin | /r/HasA | fn:fe:persistent_characteristic | "people by origin" | "persistent characteristic" | "/r/has a" |  | "FN" |  |
| fn:people_by_origin | /r/HasA | fn:fe:descriptor | "people by origin" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:people_by_origin | /r/HasA | fn:fe:age | "people by origin" | "age" | "/r/has a" |  | "FN" |  |
| fn:people_by_origin | /r/HasA | fn:fe:ethnicity | "people by origin" | "ethnicity" | "/r/has a" |  | "FN" |  |
| fn:people_by_origin | /r/HasA | fn:fe:context_of_acquaintance | "people by origin" | "context of acquaintance" | "/r/has a" |  | "FN" |  |
| fn:people_by_religion | /r/IsA | fn:people | "people by religion" | "people" | "/r/is a" |  | "FN" |  |
| fn:religious_belief | /r/UsedFor | fn:people_by_religion | "religious belief" | "people by religion" | "/r/used for" |  | "FN" |  |
| fn:people_by_religion | fn:HasLexicalUnit | fn:lu:people_by_religion:muslim | "people by religion" | "muslim" | "has lexical unit" |  | "FN" |  |
| fn:people_by_religion | fn:HasLexicalUnit | fn:lu:people_by_religion:christian | "people by religion" | "christian" | "has lexical unit" |  | "FN" |  |
| fn:people_by_religion | fn:HasLexicalUnit | fn:lu:people_by_religion:faithful | "people by religion" | "faithful" | "has lexical unit" |  | "FN" |  |
| fn:people_by_religion | fn:HasLexicalUnit | fn:lu:people_by_religion:baptist | "people by religion" | "baptist" | "has lexical unit" |  | "FN" |  |
| fn:people_by_religion | fn:HasLexicalUnit | fn:lu:people_by_religion:buddhist | "people by religion" | "buddhist" | "has lexical unit" |  | "FN" |  |
| fn:people_by_religion | fn:HasLexicalUnit | fn:lu:people_by_religion:pagan | "people by religion" | "pagan" | "has lexical unit" |  | "FN" |  |
| fn:people_by_religion | fn:HasLexicalUnit | fn:lu:people_by_religion:mormon | "people by religion" | "mormon" | "has lexical unit" |  | "FN" |  |
| fn:people_by_religion | fn:HasLexicalUnit | fn:lu:people_by_religion:infidel | "people by religion" | "infidel" | "has lexical unit" |  | "FN" |  |
| fn:people_by_religion | fn:HasLexicalUnit | fn:lu:people_by_religion:zealot | "people by religion" | "zealot" | "has lexical unit" |  | "FN" |  |
| fn:people_by_religion | fn:HasLexicalUnit | fn:lu:people_by_religion:jew | "people by religion" | "jew" | "has lexical unit" |  | "FN" |  |
| fn:people_by_religion | /r/HasA | fn:fe:origin | "people by religion" | "origin" | "/r/has a" |  | "FN" |  |
| fn:people_by_religion | /r/HasA | fn:fe:person | "people by religion" | "person" | "/r/has a" |  | "FN" |  |
| fn:people_by_religion | /r/HasA | fn:fe:persistent_characteristic | "people by religion" | "persistent characteristic" | "/r/has a" |  | "FN" |  |
| fn:people_by_religion | /r/HasA | fn:fe:descriptor | "people by religion" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:people_by_religion | /r/HasA | fn:fe:age | "people by religion" | "age" | "/r/has a" |  | "FN" |  |
| fn:people_by_religion | /r/HasA | fn:fe:ethnicity | "people by religion" | "ethnicity" | "/r/has a" |  | "FN" |  |
| fn:people_by_religion | /r/HasA | fn:fe:religion | "people by religion" | "religion" | "/r/has a" |  | "FN" |  |
| fn:people_by_residence | /r/IsA | fn:people | "people by residence" | "people" | "/r/is a" |  | "FN" |  |
| fn:relation_between_individuals | /r/UsedFor | fn:people_by_residence | "relation between individuals" | "people by residence" | "/r/used for" |  | "FN" |  |
| fn:residence | /r/UsedFor | fn:people_by_residence | "residence" | "people by residence" | "/r/used for" |  | "FN" |  |
| fn:people_by_residence | fn:HasLexicalUnit | fn:lu:people_by_residence:roommate | "people by residence" | "roommate" | "has lexical unit" |  | "FN" |  |
| fn:people_by_residence | fn:HasLexicalUnit | fn:lu:people_by_residence:housemate | "people by residence" | "housemate" | "has lexical unit" |  | "FN" |  |
| fn:people_by_residence | fn:HasLexicalUnit | fn:lu:people_by_residence:neighbor | "people by residence" | "neighbor" | "has lexical unit" |  | "FN" |  |
| fn:people_by_residence | /r/HasA | fn:fe:known_resident | "people by residence" | "known resident" | "/r/has a" |  | "FN" |  |
| fn:people_by_residence | /r/HasA | fn:fe:location | "people by residence" | "location" | "/r/has a" |  | "FN" |  |
| fn:people_by_residence | /r/HasA | fn:fe:indicated_resident | "people by residence" | "indicated resident" | "/r/has a" |  | "FN" |  |
| fn:people_by_residence | /r/HasA | fn:fe:age | "people by residence" | "age" | "/r/has a" |  | "FN" |  |
| fn:people_by_residence | /r/HasA | fn:fe:descriptor | "people by residence" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:people_by_residence | /r/HasA | fn:fe:persistent_characteristic | "people by residence" | "persistent characteristic" | "/r/has a" |  | "FN" |  |
| fn:people_by_residence | /r/HasA | fn:fe:residents | "people by residence" | "residents" | "/r/has a" |  | "FN" |  |
| fn:people_by_residence | /r/HasA | fn:fe:ethnicity | "people by residence" | "ethnicity" | "/r/has a" |  | "FN" |  |
| fn:people_by_vocation | /r/IsA | fn:people | "people by vocation" | "people" | "/r/is a" |  | "FN" |  |
| fn:medical_professionals | /r/IsA | fn:people_by_vocation | "medical professionals" | "people by vocation" | "/r/is a" |  | "FN" |  |
| fn:member_of_military | /r/IsA | fn:people_by_vocation | "member of military" | "people by vocation" | "/r/is a" |  | "FN" |  |
| fn:performers | /r/IsA | fn:people_by_vocation | "performers" | "people by vocation" | "/r/is a" |  | "FN" |  |
| fn:representative | /r/IsA | fn:people_by_vocation | "representative" | "people by vocation" | "/r/is a" |  | "FN" |  |
| fn:being_employed | /r/SimilarTo | fn:people_by_vocation | "being employed" | "people by vocation" | "/r/similar to" |  | "FN" |  |
| fn:team | /r/SimilarTo | fn:people_by_vocation | "team" | "people by vocation" | "/r/similar to" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:politician | "people by vocation" | "politician" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:farmer | "people by vocation" | "farmer" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:attendant | "people by vocation" | "attendant" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:clerk | "people by vocation" | "clerk" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:consultant | "people by vocation" | "consultant" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:gardener | "people by vocation" | "gardener" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:lawyer | "people by vocation" | "lawyer" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:maid | "people by vocation" | "maid" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:manager | "people by vocation" | "manager" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:professor | "people by vocation" | "professor" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:receptionist | "people by vocation" | "receptionist" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:salesman | "people by vocation" | "salesman" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:servant | "people by vocation" | "servant" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:waiter | "people by vocation" | "waiter" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:carpenter | "people by vocation" | "carpenter" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:scientist | "people by vocation" | "scientist" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:private_eye | "people by vocation" | "private eye" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:actress | "people by vocation" | "actress" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:waitress | "people by vocation" | "waitress" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:technician | "people by vocation" | "technician" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:toxicologist | "people by vocation" | "toxicologist" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:engineer | "people by vocation" | "engineer" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:double_agent | "people by vocation" | "double agent" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:researcher | "people by vocation" | "researcher" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:archaeologist | "people by vocation" | "archaeologist" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:professional | "people by vocation" | "professional" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:agent | "people by vocation" | "agent" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:journalist | "people by vocation" | "journalist" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:judge | "people by vocation" | "judge" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:mechanic | "people by vocation" | "mechanic" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:oilman | "people by vocation" | "oilman" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:reporter | "people by vocation" | "reporter" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:scholar | "people by vocation" | "scholar" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:veterinarian | "people by vocation" | "veterinarian" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:trader | "people by vocation" | "trader" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:mole | "people by vocation" | "mole" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:spy | "people by vocation" | "spy" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:businessperson | "people by vocation" | "businessperson" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:speculator | "people by vocation" | "speculator" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:architect | "people by vocation" | "architect" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:plain-clothes_man | "people by vocation" | "plain-clothes man" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:magistrate | "people by vocation" | "magistrate" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:officer | "people by vocation" | "officer" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:police_officer | "people by vocation" | "police officer" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:spokesperson | "people by vocation" | "spokesperson" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:spokesman | "people by vocation" | "spokesman" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:spokeswoman | "people by vocation" | "spokeswoman" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:policeman | "people by vocation" | "policeman" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:bodyguard | "people by vocation" | "bodyguard" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:police | "people by vocation" | "police" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:tailor | "people by vocation" | "tailor" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:correspondent | "people by vocation" | "correspondent" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:cook | "people by vocation" | "cook" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:manservant | "people by vocation" | "manservant" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:senator | "people by vocation" | "senator" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:attorney | "people by vocation" | "attorney" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:athlete | "people by vocation" | "athlete" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:chef | "people by vocation" | "chef" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:bartender | "people by vocation" | "bartender" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:teacher | "people by vocation" | "teacher" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:pilot | "people by vocation" | "pilot" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:flight_attendant | "people by vocation" | "flight attendant" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:server | "people by vocation" | "server" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:software_developer | "people by vocation" | "software developer" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:web_developer | "people by vocation" | "web developer" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:saleswoman | "people by vocation" | "saleswoman" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:salesperson | "people by vocation" | "salesperson" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:homemaker | "people by vocation" | "homemaker" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:student | "people by vocation" | "student" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:artist | "people by vocation" | "artist" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:musician | "people by vocation" | "musician" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:singer | "people by vocation" | "singer" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:painter | "people by vocation" | "painter" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:dancer | "people by vocation" | "dancer" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:writer | "people by vocation" | "writer" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:editor | "people by vocation" | "editor" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:actor | "people by vocation" | "actor" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:producer | "people by vocation" | "producer" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:director | "people by vocation" | "director" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:designer | "people by vocation" | "designer" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:neuroscientist | "people by vocation" | "neuroscientist" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:biologist | "people by vocation" | "biologist" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:chemist | "people by vocation" | "chemist" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:physicist | "people by vocation" | "physicist" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:anthropologist | "people by vocation" | "anthropologist" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:linguist | "people by vocation" | "linguist" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:psychologist | "people by vocation" | "psychologist" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:psychiatrist | "people by vocation" | "psychiatrist" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:mathematician | "people by vocation" | "mathematician" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:sociologist | "people by vocation" | "sociologist" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:fire_fighter | "people by vocation" | "fire fighter" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:firefighter | "people by vocation" | "firefighter" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:programmer | "people by vocation" | "programmer" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | fn:HasLexicalUnit | fn:lu:people_by_vocation:driver | "people by vocation" | "driver" | "has lexical unit" |  | "FN" |  |
| fn:people_by_vocation | /r/HasA | fn:fe:origin | "people by vocation" | "origin" | "/r/has a" |  | "FN" |  |
| fn:people_by_vocation | /r/HasA | fn:fe:person | "people by vocation" | "person" | "/r/has a" |  | "FN" |  |
| fn:people_by_vocation | /r/HasA | fn:fe:persistent_characteristic | "people by vocation" | "persistent characteristic" | "/r/has a" |  | "FN" |  |
| fn:people_by_vocation | /r/HasA | fn:fe:descriptor | "people by vocation" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:people_by_vocation | /r/HasA | fn:fe:age | "people by vocation" | "age" | "/r/has a" |  | "FN" |  |
| fn:people_by_vocation | /r/HasA | fn:fe:ethnicity | "people by vocation" | "ethnicity" | "/r/has a" |  | "FN" |  |
| fn:people_by_vocation | /r/HasA | fn:fe:context_of_acquaintance | "people by vocation" | "context of acquaintance" | "/r/has a" |  | "FN" |  |
| fn:people_by_vocation | /r/HasA | fn:fe:rank | "people by vocation" | "rank" | "/r/has a" |  | "FN" |  |
| fn:people_by_vocation | /r/HasA | fn:fe:place_of_employment | "people by vocation" | "place of employment" | "/r/has a" |  | "FN" |  |
| fn:people_by_vocation | /r/HasA | fn:fe:employer | "people by vocation" | "employer" | "/r/has a" |  | "FN" |  |
| fn:people_by_vocation | /r/HasA | fn:fe:type | "people by vocation" | "type" | "/r/has a" |  | "FN" |  |
| fn:people_by_vocation | /r/HasA | fn:fe:compensation | "people by vocation" | "compensation" | "/r/has a" |  | "FN" |  |
| fn:people_by_vocation | /r/HasA | fn:fe:contract_basis | "people by vocation" | "contract basis" | "/r/has a" |  | "FN" |  |
| fn:becoming_aware | /r/IsA | fn:perception | "becoming aware" | "perception" | "/r/is a" |  | "FN" |  |
| fn:give_impression | /r/IsA | fn:perception | "give impression" | "perception" | "/r/is a" |  | "FN" |  |
| fn:perception_active | /r/IsA | fn:perception | "perception active" | "perception" | "/r/is a" |  | "FN" |  |
| fn:perception_experience | /r/IsA | fn:perception | "perception experience" | "perception" | "/r/is a" |  | "FN" |  |
| fn:sensation | /r/IsA | fn:perception | "sensation" | "perception" | "/r/is a" |  | "FN" |  |
| fn:becoming_visible | /r/UsedFor | fn:perception | "becoming visible" | "perception" | "/r/used for" |  | "FN" |  |
| fn:perception | /r/UsedFor | fn:location_of_light | "perception" | "location of light" | "/r/used for" |  | "FN" |  |
| fn:perception | /r/UsedFor | fn:make_noise | "perception" | "make noise" | "/r/used for" |  | "FN" |  |
| fn:perception | /r/UsedFor | fn:sounds | "perception" | "sounds" | "/r/used for" |  | "FN" |  |
| fn:perception | /r/HasA | fn:fe:perceiver | "perception" | "perceiver" | "/r/has a" |  | "FN" |  |
| fn:perception | /r/HasA | fn:fe:sought_phenomenon | "perception" | "sought phenomenon" | "/r/has a" |  | "FN" |  |
| fn:perception | /r/HasA | fn:fe:phenomenon | "perception" | "phenomenon" | "/r/has a" |  | "FN" |  |
| fn:perception_active | /r/IsA | fn:intentionally_act | "perception active" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:perception_active | /r/IsA | fn:perception | "perception active" | "perception" | "/r/is a" |  | "FN" |  |
| fn:touring | /r/IsA | fn:perception_active | "touring" | "perception active" | "/r/is a" |  | "FN" |  |
| fn:attention | /r/UsedFor | fn:perception_active | "attention" | "perception active" | "/r/used for" |  | "FN" |  |
| fn:perception_active | /r/UsedFor | fn:scrutiny | "perception active" | "scrutiny" | "/r/used for" |  | "FN" |  |
| fn:perception_active | /r/RelatedTo | fn:perception_experience | "perception active" | "perception experience" | "/r/related to" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:attend | "perception active" | "attend" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:eavesdrop | "perception active" | "eavesdrop" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:feel | "perception active" | "feel" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:gaze | "perception active" | "gaze" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:gaze | "perception active" | "gaze" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:glance | "perception active" | "glance" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:glance | "perception active" | "glance" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:listen | "perception active" | "listen" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:look | "perception active" | "look" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:look | "perception active" | "look" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:observation | "perception active" | "observation" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:palpate | "perception active" | "palpate" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:peek | "perception active" | "peek" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:peek | "perception active" | "peek" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:peep | "perception active" | "peep" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:peer | "perception active" | "peer" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:savour | "perception active" | "savour" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:smell | "perception active" | "smell" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:sniff | "perception active" | "sniff" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:sniff | "perception active" | "sniff" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:spy | "perception active" | "spy" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:stare | "perception active" | "stare" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:stare | "perception active" | "stare" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:taste | "perception active" | "taste" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:taste | "perception active" | "taste" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:view | "perception active" | "view" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:watch | "perception active" | "watch" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:squint | "perception active" | "squint" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:admire | "perception active" | "admire" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:eye | "perception active" | "eye" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:gape | "perception active" | "gape" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:gawk | "perception active" | "gawk" | "has lexical unit" |  | "FN" |  |
| fn:perception_active | fn:HasLexicalUnit | fn:lu:perception_active:goggle | "perception active" | "goggle" | "has lexical unit" |  | "FN" |  |
| fn:fe:perceiver_agentive | /r/IsA | fn:st:sentient | "perceiver agentive" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:perception_active | /r/HasA | fn:fe:perceiver_agentive | "perception active" | "perceiver agentive" | "/r/has a" |  | "FN" |  |
| fn:perception_active | /r/HasA | fn:fe:phenomenon | "perception active" | "phenomenon" | "/r/has a" |  | "FN" |  |
| fn:perception_active | /r/HasA | fn:fe:body_part | "perception active" | "body part" | "/r/has a" |  | "FN" |  |
| fn:perception_active | /r/HasA | fn:fe:location_of_protagonist | "perception active" | "location of protagonist" | "/r/has a" |  | "FN" |  |
| fn:perception_active | /r/HasA | fn:fe:direction | "perception active" | "direction" | "/r/has a" |  | "FN" |  |
| fn:perception_active | /r/HasA | fn:fe:depictive | "perception active" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:perception_active | /r/HasA | fn:fe:state | "perception active" | "state" | "/r/has a" |  | "FN" |  |
| fn:perception_active | /r/HasA | fn:fe:manner | "perception active" | "manner" | "/r/has a" |  | "FN" |  |
| fn:perception_active | /r/HasA | fn:fe:means | "perception active" | "means" | "/r/has a" |  | "FN" |  |
| fn:perception_active | /r/HasA | fn:fe:time | "perception active" | "time" | "/r/has a" |  | "FN" |  |
| fn:perception_active | /r/HasA | fn:fe:purpose | "perception active" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:perception_active | /r/HasA | fn:fe:place | "perception active" | "place" | "/r/has a" |  | "FN" |  |
| fn:perception_active | /r/HasA | fn:fe:duration | "perception active" | "duration" | "/r/has a" |  | "FN" |  |
| fn:perception_active | /r/HasA | fn:fe:expected_entity | "perception active" | "expected entity" | "/r/has a" |  | "FN" |  |
| fn:perception_active | /r/HasA | fn:fe:ground | "perception active" | "ground" | "/r/has a" |  | "FN" |  |
| fn:perception_active | /r/HasA | fn:fe:obscuring_medium | "perception active" | "obscuring medium" | "/r/has a" |  | "FN" |  |
| fn:perception_experience | /r/UsedFor | fn:perception_body | "perception experience" | "perception body" | "/r/used for" |  | "FN" |  |
| fn:cause_bodily_experience | /r/Causes | fn:perception_body | "cause bodily experience" | "perception body" | "/r/causes" |  | "FN" |  |
| fn:perception_body | fn:HasLexicalUnit | fn:lu:perception_body:ache | "perception body" | "ache" | "has lexical unit" |  | "FN" |  |
| fn:perception_body | fn:HasLexicalUnit | fn:lu:perception_body:burn | "perception body" | "burn" | "has lexical unit" |  | "FN" |  |
| fn:perception_body | fn:HasLexicalUnit | fn:lu:perception_body:hurt | "perception body" | "hurt" | "has lexical unit" |  | "FN" |  |
| fn:perception_body | fn:HasLexicalUnit | fn:lu:perception_body:itch | "perception body" | "itch" | "has lexical unit" |  | "FN" |  |
| fn:perception_body | fn:HasLexicalUnit | fn:lu:perception_body:prickle | "perception body" | "prickle" | "has lexical unit" |  | "FN" |  |
| fn:perception_body | fn:HasLexicalUnit | fn:lu:perception_body:smart | "perception body" | "smart" | "has lexical unit" |  | "FN" |  |
| fn:perception_body | fn:HasLexicalUnit | fn:lu:perception_body:sting | "perception body" | "sting" | "has lexical unit" |  | "FN" |  |
| fn:perception_body | fn:HasLexicalUnit | fn:lu:perception_body:tickle | "perception body" | "tickle" | "has lexical unit" |  | "FN" |  |
| fn:perception_body | fn:HasLexicalUnit | fn:lu:perception_body:tingle | "perception body" | "tingle" | "has lexical unit" |  | "FN" |  |
| fn:perception_body | fn:HasLexicalUnit | fn:lu:perception_body:ail | "perception body" | "ail" | "has lexical unit" |  | "FN" |  |
| fn:perception_body | fn:HasLexicalUnit | fn:lu:perception_body:goosebump | "perception body" | "goosebump" | "has lexical unit" |  | "FN" |  |
| fn:perception_body | fn:HasLexicalUnit | fn:lu:perception_body:pain | "perception body" | "pain" | "has lexical unit" |  | "FN" |  |
| fn:perception_body | fn:HasLexicalUnit | fn:lu:perception_body:pain | "perception body" | "pain" | "has lexical unit" |  | "FN" |  |
| fn:perception_body | fn:HasLexicalUnit | fn:lu:perception_body:hum | "perception body" | "hum" | "has lexical unit" |  | "FN" |  |
| fn:perception_body | fn:HasLexicalUnit | fn:lu:perception_body:spin | "perception body" | "spin" | "has lexical unit" |  | "FN" |  |
| fn:perception_body | fn:HasLexicalUnit | fn:lu:perception_body:be_killing | "perception body" | "be killing" | "has lexical unit" |  | "FN" |  |
| fn:perception_body | fn:HasLexicalUnit | fn:lu:perception_body:discomfort | "perception body" | "discomfort" | "has lexical unit" |  | "FN" |  |
| fn:perception_body | fn:HasLexicalUnit | fn:lu:perception_body:chafe | "perception body" | "chafe" | "has lexical unit" |  | "FN" |  |
| fn:perception_body | /r/HasA | fn:fe:experiencer | "perception body" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:perception_body | /r/HasA | fn:fe:body_part | "perception body" | "body part" | "/r/has a" |  | "FN" |  |
| fn:perception_body | /r/HasA | fn:fe:explanation | "perception body" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:perception_body | /r/HasA | fn:fe:degree | "perception body" | "degree" | "/r/has a" |  | "FN" |  |
| fn:perception_body | /r/HasA | fn:fe:manner | "perception body" | "manner" | "/r/has a" |  | "FN" |  |
| fn:perception_body | /r/HasA | fn:fe:subregion | "perception body" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:perception_experience | /r/IsA | fn:perception | "perception experience" | "perception" | "/r/is a" |  | "FN" |  |
| fn:punctual_perception | /r/IsA | fn:perception_experience | "punctual perception" | "perception experience" | "/r/is a" |  | "FN" |  |
| fn:perception_experience | /r/UsedFor | fn:eclipse | "perception experience" | "eclipse" | "/r/used for" |  | "FN" |  |
| fn:perception_experience | /r/UsedFor | fn:perception_body | "perception experience" | "perception body" | "/r/used for" |  | "FN" |  |
| fn:perception_active | /r/RelatedTo | fn:perception_experience | "perception active" | "perception experience" | "/r/related to" |  | "FN" |  |
| fn:hearsay | /r/SimilarTo | fn:perception_experience | "hearsay" | "perception experience" | "/r/similar to" |  | "FN" |  |
| fn:cause_to_perceive | /r/Causes | fn:perception_experience | "cause to perceive" | "perception experience" | "/r/causes" |  | "FN" |  |
| fn:perception_experience | fn:HasLexicalUnit | fn:lu:perception_experience:detect | "perception experience" | "detect" | "has lexical unit" |  | "FN" |  |
| fn:perception_experience | fn:HasLexicalUnit | fn:lu:perception_experience:feel | "perception experience" | "feel" | "has lexical unit" |  | "FN" |  |
| fn:perception_experience | fn:HasLexicalUnit | fn:lu:perception_experience:hear | "perception experience" | "hear" | "has lexical unit" |  | "FN" |  |
| fn:perception_experience | fn:HasLexicalUnit | fn:lu:perception_experience:perceive | "perception experience" | "perceive" | "has lexical unit" |  | "FN" |  |
| fn:perception_experience | fn:HasLexicalUnit | fn:lu:perception_experience:perception | "perception experience" | "perception" | "has lexical unit" |  | "FN" |  |
| fn:perception_experience | fn:HasLexicalUnit | fn:lu:perception_experience:see | "perception experience" | "see" | "has lexical unit" |  | "FN" |  |
| fn:perception_experience | fn:HasLexicalUnit | fn:lu:perception_experience:sense | "perception experience" | "sense" | "has lexical unit" |  | "FN" |  |
| fn:perception_experience | fn:HasLexicalUnit | fn:lu:perception_experience:smell | "perception experience" | "smell" | "has lexical unit" |  | "FN" |  |
| fn:perception_experience | fn:HasLexicalUnit | fn:lu:perception_experience:taste | "perception experience" | "taste" | "has lexical unit" |  | "FN" |  |
| fn:perception_experience | fn:HasLexicalUnit | fn:lu:perception_experience:overhear | "perception experience" | "overhear" | "has lexical unit" |  | "FN" |  |
| fn:perception_experience | fn:HasLexicalUnit | fn:lu:perception_experience:experience | "perception experience" | "experience" | "has lexical unit" |  | "FN" |  |
| fn:perception_experience | fn:HasLexicalUnit | fn:lu:perception_experience:witness | "perception experience" | "witness" | "has lexical unit" |  | "FN" |  |
| fn:perception_experience | fn:HasLexicalUnit | fn:lu:perception_experience:experience | "perception experience" | "experience" | "has lexical unit" |  | "FN" |  |
| fn:perception_experience | /r/HasA | fn:fe:perceiver_passive | "perception experience" | "perceiver passive" | "/r/has a" |  | "FN" |  |
| fn:perception_experience | /r/HasA | fn:fe:phenomenon | "perception experience" | "phenomenon" | "/r/has a" |  | "FN" |  |
| fn:perception_experience | /r/HasA | fn:fe:body_part | "perception experience" | "body part" | "/r/has a" |  | "FN" |  |
| fn:perception_experience | /r/HasA | fn:fe:location_of_protagonist | "perception experience" | "location of protagonist" | "/r/has a" |  | "FN" |  |
| fn:perception_experience | /r/HasA | fn:fe:direction | "perception experience" | "direction" | "/r/has a" |  | "FN" |  |
| fn:perception_experience | /r/HasA | fn:fe:depictive | "perception experience" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:perception_experience | /r/HasA | fn:fe:state | "perception experience" | "state" | "/r/has a" |  | "FN" |  |
| fn:perception_experience | /r/HasA | fn:fe:manner | "perception experience" | "manner" | "/r/has a" |  | "FN" |  |
| fn:perception_experience | /r/HasA | fn:fe:degree | "perception experience" | "degree" | "/r/has a" |  | "FN" |  |
| fn:perception_experience | /r/HasA | fn:fe:means | "perception experience" | "means" | "/r/has a" |  | "FN" |  |
| fn:perception_experience | /r/HasA | fn:fe:time | "perception experience" | "time" | "/r/has a" |  | "FN" |  |
| fn:perception_experience | /r/HasA | fn:fe:duration | "perception experience" | "duration" | "/r/has a" |  | "FN" |  |
| fn:perception_experience | /r/HasA | fn:fe:contrastive_context | "perception experience" | "contrastive context" | "/r/has a" |  | "FN" |  |
| fn:perception_experience | /r/HasA | fn:fe:concessive | "perception experience" | "concessive" | "/r/has a" |  | "FN" |  |
| fn:perception_experience | /r/HasA | fn:fe:circumstances | "perception experience" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:perception_experience | /r/HasA | fn:fe:frequency | "perception experience" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:perception_experience | /r/HasA | fn:fe:place | "perception experience" | "place" | "/r/has a" |  | "FN" |  |
| fn:perception_experience | /r/HasA | fn:fe:ground | "perception experience" | "ground" | "/r/has a" |  | "FN" |  |
| fn:perception_experience | /r/HasA | fn:fe:obscuring_medium | "perception experience" | "obscuring medium" | "/r/has a" |  | "FN" |  |
| fn:performers | /r/IsA | fn:people_by_vocation | "performers" | "people by vocation" | "/r/is a" |  | "FN" |  |
| fn:performers_and_roles | /r/UsedFor | fn:performers | "performers and roles" | "performers" | "/r/used for" |  | "FN" |  |
| fn:performers | fn:HasLexicalUnit | fn:lu:performers:actress | "performers" | "actress" | "has lexical unit" |  | "FN" |  |
| fn:performers | fn:HasLexicalUnit | fn:lu:performers:actor | "performers" | "actor" | "has lexical unit" |  | "FN" |  |
| fn:performers | fn:HasLexicalUnit | fn:lu:performers:player | "performers" | "player" | "has lexical unit" |  | "FN" |  |
| fn:performers | fn:HasLexicalUnit | fn:lu:performers:musician | "performers" | "musician" | "has lexical unit" |  | "FN" |  |
| fn:performers | /r/HasA | fn:fe:origin | "performers" | "origin" | "/r/has a" |  | "FN" |  |
| fn:performers | /r/HasA | fn:fe:person | "performers" | "person" | "/r/has a" |  | "FN" |  |
| fn:performers | /r/HasA | fn:fe:persistent_characteristic | "performers" | "persistent characteristic" | "/r/has a" |  | "FN" |  |
| fn:performers | /r/HasA | fn:fe:descriptor | "performers" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:performers | /r/HasA | fn:fe:age | "performers" | "age" | "/r/has a" |  | "FN" |  |
| fn:performers | /r/HasA | fn:fe:ethnicity | "performers" | "ethnicity" | "/r/has a" |  | "FN" |  |
| fn:performers | /r/HasA | fn:fe:context_of_acquaintance | "performers" | "context of acquaintance" | "/r/has a" |  | "FN" |  |
| fn:performers | /r/HasA | fn:fe:rank | "performers" | "rank" | "/r/has a" |  | "FN" |  |
| fn:performers | /r/HasA | fn:fe:place_of_employment | "performers" | "place of employment" | "/r/has a" |  | "FN" |  |
| fn:performers | /r/HasA | fn:fe:employer | "performers" | "employer" | "/r/has a" |  | "FN" |  |
| fn:performers | /r/HasA | fn:fe:type | "performers" | "type" | "/r/has a" |  | "FN" |  |
| fn:performers | /r/HasA | fn:fe:compensation | "performers" | "compensation" | "/r/has a" |  | "FN" |  |
| fn:performers | /r/HasA | fn:fe:contract_basis | "performers" | "contract basis" | "/r/has a" |  | "FN" |  |
| fn:performers_and_roles | /r/UsedFor | fn:performers | "performers and roles" | "performers" | "/r/used for" |  | "FN" |  |
| fn:performing_arts | /r/UsedFor | fn:performers_and_roles | "performing arts" | "performers and roles" | "/r/used for" |  | "FN" |  |
| fn:performers_and_roles | fn:HasLexicalUnit | fn:lu:performers_and_roles:star | "performers and roles" | "star" | "has lexical unit" |  | "FN" |  |
| fn:performers_and_roles | fn:HasLexicalUnit | fn:lu:performers_and_roles:act | "performers and roles" | "act" | "has lexical unit" |  | "FN" |  |
| fn:performers_and_roles | fn:HasLexicalUnit | fn:lu:performers_and_roles:play | "performers and roles" | "play" | "has lexical unit" |  | "FN" |  |
| fn:performers_and_roles | fn:HasLexicalUnit | fn:lu:performers_and_roles:be | "performers and roles" | "be" | "has lexical unit" |  | "FN" |  |
| fn:performers_and_roles | fn:HasLexicalUnit | fn:lu:performers_and_roles:star | "performers and roles" | "star" | "has lexical unit" |  | "FN" |  |
| fn:performers_and_roles | fn:HasLexicalUnit | fn:lu:performers_and_roles:co-star | "performers and roles" | "co-star" | "has lexical unit" |  | "FN" |  |
| fn:performers_and_roles | fn:HasLexicalUnit | fn:lu:performers_and_roles:co-star_(in) | "performers and roles" | "co-star (in)" | "has lexical unit" |  | "FN" |  |
| fn:performers_and_roles | fn:HasLexicalUnit | fn:lu:performers_and_roles:lead | "performers and roles" | "lead" | "has lexical unit" |  | "FN" |  |
| fn:performers_and_roles | fn:HasLexicalUnit | fn:lu:performers_and_roles:star_(in) | "performers and roles" | "star (in)" | "has lexical unit" |  | "FN" |  |
| fn:performers_and_roles | fn:HasLexicalUnit | fn:lu:performers_and_roles:as | "performers and roles" | "as" | "has lexical unit" |  | "FN" |  |
| fn:performers_and_roles | fn:HasLexicalUnit | fn:lu:performers_and_roles:co-star | "performers and roles" | "co-star" | "has lexical unit" |  | "FN" |  |
| fn:performers_and_roles | fn:HasLexicalUnit | fn:lu:performers_and_roles:feature | "performers and roles" | "feature" | "has lexical unit" |  | "FN" |  |
| fn:performers_and_roles | fn:HasLexicalUnit | fn:lu:performers_and_roles:character | "performers and roles" | "character" | "has lexical unit" |  | "FN" |  |
| fn:performers_and_roles | fn:HasLexicalUnit | fn:lu:performers_and_roles:role | "performers and roles" | "role" | "has lexical unit" |  | "FN" |  |
| fn:performers_and_roles | fn:HasLexicalUnit | fn:lu:performers_and_roles:part | "performers and roles" | "part" | "has lexical unit" |  | "FN" |  |
| fn:performers_and_roles | fn:HasLexicalUnit | fn:lu:performers_and_roles:appear | "performers and roles" | "appear" | "has lexical unit" |  | "FN" |  |
| fn:performers_and_roles | /r/HasA | fn:fe:audience | "performers and roles" | "audience" | "/r/has a" |  | "FN" |  |
| fn:performers_and_roles | /r/HasA | fn:fe:medium | "performers and roles" | "medium" | "/r/has a" |  | "FN" |  |
| fn:performers_and_roles | /r/HasA | fn:fe:performance | "performers and roles" | "performance" | "/r/has a" |  | "FN" |  |
| fn:performers_and_roles | /r/HasA | fn:fe:performer | "performers and roles" | "performer" | "/r/has a" |  | "FN" |  |
| fn:performers_and_roles | /r/HasA | fn:fe:score | "performers and roles" | "score" | "/r/has a" |  | "FN" |  |
| fn:performers_and_roles | /r/HasA | fn:fe:script | "performers and roles" | "script" | "/r/has a" |  | "FN" |  |
| fn:performers_and_roles | /r/HasA | fn:fe:type | "performers and roles" | "type" | "/r/has a" |  | "FN" |  |
| fn:performers_and_roles | /r/HasA | fn:fe:role | "performers and roles" | "role" | "/r/has a" |  | "FN" |  |
| fn:performers_and_roles | /r/HasA | fn:fe:time | "performers and roles" | "time" | "/r/has a" |  | "FN" |  |
| fn:performers_and_roles | /r/HasA | fn:fe:place | "performers and roles" | "place" | "/r/has a" |  | "FN" |  |
| fn:performers_and_roles | /r/HasA | fn:fe:manner | "performers and roles" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fe:performer1 | /r/HasPrerequisite | fn:fe:performer2 | "performer1" | "performer2" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:performer1 | /r/RelatedTo | fn:fe:performer | "performer1" | "performer" | "/r/related to" |  | "FN" |  |
| fn:performers_and_roles | /r/HasA | fn:fe:performer1 | "performers and roles" | "performer1" | "/r/has a" |  | "FN" |  |
| fn:fe:performer2 | /r/HasPrerequisite | fn:fe:performer1 | "performer2" | "performer1" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:performer2 | /r/RelatedTo | fn:fe:performer | "performer2" | "performer" | "/r/related to" |  | "FN" |  |
| fn:performers_and_roles | /r/HasA | fn:fe:performer2 | "performers and roles" | "performer2" | "/r/has a" |  | "FN" |  |
| fn:performers_and_roles | /r/HasA | fn:fe:duration | "performers and roles" | "duration" | "/r/has a" |  | "FN" |  |
| fn:performers_and_roles | /r/HasA | fn:fe:event_description | "performers and roles" | "event description" | "/r/has a" |  | "FN" |  |
| fn:performing_arts | /r/UsedFor | fn:behind_the_scenes | "performing arts" | "behind the scenes" | "/r/used for" |  | "FN" |  |
| fn:performing_arts | /r/UsedFor | fn:performers_and_roles | "performing arts" | "performers and roles" | "/r/used for" |  | "FN" |  |
| fn:performing_arts | fn:HasLexicalUnit | fn:lu:performing_arts:music | "performing arts" | "music" | "has lexical unit" |  | "FN" |  |
| fn:performing_arts | fn:HasLexicalUnit | fn:lu:performing_arts:performance | "performing arts" | "performance" | "has lexical unit" |  | "FN" |  |
| fn:performing_arts | fn:HasLexicalUnit | fn:lu:performing_arts:play | "performing arts" | "play" | "has lexical unit" |  | "FN" |  |
| fn:performing_arts | /r/HasA | fn:fe:performer | "performing arts" | "performer" | "/r/has a" |  | "FN" |  |
| fn:performing_arts | /r/HasA | fn:fe:personnel | "performing arts" | "personnel" | "/r/has a" |  | "FN" |  |
| fn:performing_arts | /r/HasA | fn:fe:audience | "performing arts" | "audience" | "/r/has a" |  | "FN" |  |
| fn:performing_arts | /r/HasA | fn:fe:performance | "performing arts" | "performance" | "/r/has a" |  | "FN" |  |
| fn:performing_arts | /r/HasA | fn:fe:script | "performing arts" | "script" | "/r/has a" |  | "FN" |  |
| fn:performing_arts | /r/HasA | fn:fe:score | "performing arts" | "score" | "/r/has a" |  | "FN" |  |
| fn:performing_arts | /r/HasA | fn:fe:type | "performing arts" | "type" | "/r/has a" |  | "FN" |  |
| fn:performing_arts | /r/HasA | fn:fe:medium | "performing arts" | "medium" | "/r/has a" |  | "FN" |  |
| fn:relation_between_individuals | /r/UsedFor | fn:personal_relationship | "relation between individuals" | "personal relationship" | "/r/used for" |  | "FN" |  |
| fn:personal_relationship | /r/SimilarTo | fn:forming_relationships | "personal relationship" | "forming relationships" | "/r/similar to" |  | "FN" |  |
| fn:social_interaction_evaluation | /r/SimilarTo | fn:personal_relationship | "social interaction evaluation" | "personal relationship" | "/r/similar to" |  | "FN" |  |
| fn:forming_relationships | /r/Causes | fn:personal_relationship | "forming relationships" | "personal relationship" | "/r/causes" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:husband | "personal relationship" | "husband" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:wife | "personal relationship" | "wife" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:widow | "personal relationship" | "widow" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:widower | "personal relationship" | "widower" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:widowed | "personal relationship" | "widowed" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:spouse | "personal relationship" | "spouse" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:couple | "personal relationship" | "couple" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:companion | "personal relationship" | "companion" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:divorcee | "personal relationship" | "divorcee" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:married | "personal relationship" | "married" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:betrothed | "personal relationship" | "betrothed" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:bachelor | "personal relationship" | "bachelor" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:engaged | "personal relationship" | "engaged" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:engagement | "personal relationship" | "engagement" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:marriage | "personal relationship" | "marriage" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:boyfriend | "personal relationship" | "boyfriend" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:girlfriend | "personal relationship" | "girlfriend" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:single | "personal relationship" | "single" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:date | "personal relationship" | "date" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:break-up | "personal relationship" | "break-up" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:lover | "personal relationship" | "lover" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:partner | "personal relationship" | "partner" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:mistress | "personal relationship" | "mistress" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:suitor | "personal relationship" | "suitor" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:court | "personal relationship" | "court" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:spinster | "personal relationship" | "spinster" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:estranged | "personal relationship" | "estranged" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:friend | "personal relationship" | "friend" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:betrothed | "personal relationship" | "betrothed" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:cohabit | "personal relationship" | "cohabit" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:cohabitation | "personal relationship" | "cohabitation" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:seeing | "personal relationship" | "seeing" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:widow | "personal relationship" | "widow" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:divorced | "personal relationship" | "divorced" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:buddy | "personal relationship" | "buddy" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:moll | "personal relationship" | "moll" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:paramour | "personal relationship" | "paramour" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:inamorata | "personal relationship" | "inamorata" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:beau | "personal relationship" | "beau" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:sugar_daddy | "personal relationship" | "sugar daddy" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:significant_other | "personal relationship" | "significant other" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:chum | "personal relationship" | "chum" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:pal | "personal relationship" | "pal" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:cobber | "personal relationship" | "cobber" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:mate | "personal relationship" | "mate" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:crush | "personal relationship" | "crush" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:affair | "personal relationship" | "affair" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:adultery | "personal relationship" | "adultery" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:amigo | "personal relationship" | "amigo" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:sleep_(together/with) | "personal relationship" | "sleep (together/with)" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:spousal | "personal relationship" | "spousal" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:marital | "personal relationship" | "marital" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:affianced | "personal relationship" | "affianced" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:friendship | "personal relationship" | "friendship" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:romance | "personal relationship" | "romance" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:befriend | "personal relationship" | "befriend" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:familiar | "personal relationship" | "familiar" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:fiancée | "personal relationship" | "fiancée" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:fiancé | "personal relationship" | "fiancé" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:relationship | "personal relationship" | "relationship" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | fn:HasLexicalUnit | fn:lu:personal_relationship:chummy | "personal relationship" | "chummy" | "has lexical unit" |  | "FN" |  |
| fn:personal_relationship | /r/HasA | fn:fe:partner_1 | "personal relationship" | "partner 1" | "/r/has a" |  | "FN" |  |
| fn:personal_relationship | /r/HasA | fn:fe:partner_2 | "personal relationship" | "partner 2" | "/r/has a" |  | "FN" |  |
| fn:personal_relationship | /r/HasA | fn:fe:partners | "personal relationship" | "partners" | "/r/has a" |  | "FN" |  |
| fn:personal_relationship | /r/HasA | fn:fe:degree | "personal relationship" | "degree" | "/r/has a" |  | "FN" |  |
| fn:personal_relationship | /r/HasA | fn:fe:depictive | "personal relationship" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:personal_relationship | /r/HasA | fn:fe:manner | "personal relationship" | "manner" | "/r/has a" |  | "FN" |  |
| fn:personal_relationship | /r/HasA | fn:fe:means | "personal relationship" | "means" | "/r/has a" |  | "FN" |  |
| fn:personal_relationship | /r/HasA | fn:fe:relationship | "personal relationship" | "relationship" | "/r/has a" |  | "FN" |  |
| fn:personal_relationship | /r/HasA | fn:fe:duration | "personal relationship" | "duration" | "/r/has a" |  | "FN" |  |
| fn:personal_relationship | /r/HasA | fn:fe:source_of_relationship | "personal relationship" | "source of relationship" | "/r/has a" |  | "FN" |  |
| fn:personal_success | /r/IsA | fn:gradable_attributes | "personal success" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:fame | /r/IsA | fn:personal_success | "fame" | "personal success" | "/r/is a" |  | "FN" |  |
| fn:success_or_failure | /r/RelatedTo | fn:personal_success | "success or failure" | "personal success" | "/r/related to" |  | "FN" |  |
| fn:successful_action | /r/RelatedTo | fn:personal_success | "successful action" | "personal success" | "/r/related to" |  | "FN" |  |
| fn:personal_success | fn:HasLexicalUnit | fn:lu:personal_success:success_[person] | "personal success" | "success [person]" | "has lexical unit" |  | "FN" |  |
| fn:personal_success | fn:HasLexicalUnit | fn:lu:personal_success:success_[event] | "personal success" | "success [event]" | "has lexical unit" |  | "FN" |  |
| fn:personal_success | fn:HasLexicalUnit | fn:lu:personal_success:success_[state] | "personal success" | "success [state]" | "has lexical unit" |  | "FN" |  |
| fn:personal_success | fn:HasLexicalUnit | fn:lu:personal_success:successful | "personal success" | "successful" | "has lexical unit" |  | "FN" |  |
| fn:personal_success | fn:HasLexicalUnit | fn:lu:personal_success:make_it | "personal success" | "make it" | "has lexical unit" |  | "FN" |  |
| fn:personal_success | fn:HasLexicalUnit | fn:lu:personal_success:arrive | "personal success" | "arrive" | "has lexical unit" |  | "FN" |  |
| fn:personal_success | fn:HasLexicalUnit | fn:lu:personal_success:succeed | "personal success" | "succeed" | "has lexical unit" |  | "FN" |  |
| fn:personal_success | /r/HasA | fn:fe:person | "personal success" | "person" | "/r/has a" |  | "FN" |  |
| fn:personal_success | /r/HasA | fn:fe:time | "personal success" | "time" | "/r/has a" |  | "FN" |  |
| fn:personal_success | /r/HasA | fn:fe:degree | "personal success" | "degree" | "/r/has a" |  | "FN" |  |
| fn:personal_success | /r/HasA | fn:fe:endeavor | "personal success" | "endeavor" | "/r/has a" |  | "FN" |  |
| fn:personal_success | /r/HasA | fn:fe:explanation | "personal success" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:personal_success | /r/HasA | fn:fe:field | "personal success" | "field" | "/r/has a" |  | "FN" |  |
| fn:physical_artworks | /r/IsA | fn:artifact | "physical artworks" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:physical_artworks | /r/UsedFor | fn:create_physical_artwork | "physical artworks" | "create physical artwork" | "/r/used for" |  | "FN" |  |
| fn:physical_artworks | fn:HasLexicalUnit | fn:lu:physical_artworks:photo | "physical artworks" | "photo" | "has lexical unit" |  | "FN" |  |
| fn:physical_artworks | fn:HasLexicalUnit | fn:lu:physical_artworks:photograph | "physical artworks" | "photograph" | "has lexical unit" |  | "FN" |  |
| fn:physical_artworks | fn:HasLexicalUnit | fn:lu:physical_artworks:painting | "physical artworks" | "painting" | "has lexical unit" |  | "FN" |  |
| fn:physical_artworks | fn:HasLexicalUnit | fn:lu:physical_artworks:picture | "physical artworks" | "picture" | "has lexical unit" |  | "FN" |  |
| fn:physical_artworks | fn:HasLexicalUnit | fn:lu:physical_artworks:drawing | "physical artworks" | "drawing" | "has lexical unit" |  | "FN" |  |
| fn:physical_artworks | fn:HasLexicalUnit | fn:lu:physical_artworks:statue | "physical artworks" | "statue" | "has lexical unit" |  | "FN" |  |
| fn:physical_artworks | fn:HasLexicalUnit | fn:lu:physical_artworks:statuette | "physical artworks" | "statuette" | "has lexical unit" |  | "FN" |  |
| fn:physical_artworks | fn:HasLexicalUnit | fn:lu:physical_artworks:bronze | "physical artworks" | "bronze" | "has lexical unit" |  | "FN" |  |
| fn:physical_artworks | fn:HasLexicalUnit | fn:lu:physical_artworks:diagram | "physical artworks" | "diagram" | "has lexical unit" |  | "FN" |  |
| fn:physical_artworks | fn:HasLexicalUnit | fn:lu:physical_artworks:sculpture | "physical artworks" | "sculpture" | "has lexical unit" |  | "FN" |  |
| fn:physical_artworks | fn:HasLexicalUnit | fn:lu:physical_artworks:image | "physical artworks" | "image" | "has lexical unit" |  | "FN" |  |
| fn:physical_artworks | fn:HasLexicalUnit | fn:lu:physical_artworks:poster | "physical artworks" | "poster" | "has lexical unit" |  | "FN" |  |
| fn:physical_artworks | fn:HasLexicalUnit | fn:lu:physical_artworks:trace | "physical artworks" | "trace" | "has lexical unit" |  | "FN" |  |
| fn:physical_artworks | fn:HasLexicalUnit | fn:lu:physical_artworks:tracing | "physical artworks" | "tracing" | "has lexical unit" |  | "FN" |  |
| fn:physical_artworks | /r/HasA | fn:fe:artifact | "physical artworks" | "artifact" | "/r/has a" |  | "FN" |  |
| fn:physical_artworks | /r/HasA | fn:fe:use | "physical artworks" | "use" | "/r/has a" |  | "FN" |  |
| fn:physical_artworks | /r/HasA | fn:fe:creator | "physical artworks" | "creator" | "/r/has a" |  | "FN" |  |
| fn:physical_artworks | /r/HasA | fn:fe:time_of_creation | "physical artworks" | "time of creation" | "/r/has a" |  | "FN" |  |
| fn:physical_artworks | /r/HasA | fn:fe:name | "physical artworks" | "name" | "/r/has a" |  | "FN" |  |
| fn:physical_artworks | /r/HasA | fn:fe:type | "physical artworks" | "type" | "/r/has a" |  | "FN" |  |
| fn:physical_artworks | /r/HasA | fn:fe:material | "physical artworks" | "material" | "/r/has a" |  | "FN" |  |
| fn:physical_artworks | /r/HasA | fn:fe:represented | "physical artworks" | "represented" | "/r/has a" |  | "FN" |  |
| fn:physical_artworks | /r/HasA | fn:fe:state_of_represented | "physical artworks" | "state of represented" | "/r/has a" |  | "FN" |  |
| fn:physical_artworks | /r/HasA | fn:fe:descriptor | "physical artworks" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:physical_artworks | /r/HasA | fn:fe:place | "physical artworks" | "place" | "/r/has a" |  | "FN" |  |
| fn:physical_entity | /r/IsA | fn:entity | "physical entity" | "entity" | "/r/is a" |  | "FN" |  |
| fn:body_mark | /r/IsA | fn:physical_entity | "body mark" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:bounded_entity | /r/IsA | fn:physical_entity | "bounded entity" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:food | /r/IsA | fn:physical_entity | "food" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:intoxicants | /r/IsA | fn:physical_entity | "intoxicants" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:substance | /r/IsA | fn:physical_entity | "substance" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:physical_entity | /r/HasA | fn:fe:constituents | "physical entity" | "constituents" | "/r/has a" |  | "FN" |  |
| fn:physical_entity | /r/HasA | fn:fe:entity | "physical entity" | "entity" | "/r/has a" |  | "FN" |  |
| fn:physical_entity | /r/HasA | fn:fe:formational_cause | "physical entity" | "formational cause" | "/r/has a" |  | "FN" |  |
| fn:physical_entity | /r/HasA | fn:fe:name | "physical entity" | "name" | "/r/has a" |  | "FN" |  |
| fn:physical_entity | /r/HasA | fn:fe:type | "physical entity" | "type" | "/r/has a" |  | "FN" |  |
| fn:physical_entity | /r/HasA | fn:fe:place | "physical entity" | "place" | "/r/has a" |  | "FN" |  |
| fn:piracy | /r/IsA | fn:committing_crime | "piracy" | "committing crime" | "/r/is a" |  | "FN" |  |
| fn:piracy | /r/IsA | fn:intentionally_act | "piracy" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:operate_vehicle | /r/UsedFor | fn:piracy | "operate vehicle" | "piracy" | "/r/used for" |  | "FN" |  |
| fn:piracy | fn:HasLexicalUnit | fn:lu:piracy:hijack | "piracy" | "hijack" | "has lexical unit" |  | "FN" |  |
| fn:piracy | fn:HasLexicalUnit | fn:lu:piracy:hijacking | "piracy" | "hijacking" | "has lexical unit" |  | "FN" |  |
| fn:piracy | fn:HasLexicalUnit | fn:lu:piracy:hijacker | "piracy" | "hijacker" | "has lexical unit" |  | "FN" |  |
| fn:piracy | fn:HasLexicalUnit | fn:lu:piracy:carjacking | "piracy" | "carjacking" | "has lexical unit" |  | "FN" |  |
| fn:piracy | fn:HasLexicalUnit | fn:lu:piracy:hijacked | "piracy" | "hijacked" | "has lexical unit" |  | "FN" |  |
| fn:piracy | fn:HasLexicalUnit | fn:lu:piracy:piracy | "piracy" | "piracy" | "has lexical unit" |  | "FN" |  |
| fn:piracy | fn:HasLexicalUnit | fn:lu:piracy:pirate | "piracy" | "pirate" | "has lexical unit" |  | "FN" |  |
| fn:piracy | fn:HasLexicalUnit | fn:lu:piracy:carjack | "piracy" | "carjack" | "has lexical unit" |  | "FN" |  |
| fn:piracy | /r/HasA | fn:fe:perpetrator | "piracy" | "perpetrator" | "/r/has a" |  | "FN" |  |
| fn:piracy | /r/HasA | fn:fe:vehicle | "piracy" | "vehicle" | "/r/has a" |  | "FN" |  |
| fn:piracy | /r/HasA | fn:fe:victim | "piracy" | "victim" | "/r/has a" |  | "FN" |  |
| fn:piracy | /r/HasA | fn:fe:degree | "piracy" | "degree" | "/r/has a" |  | "FN" |  |
| fn:piracy | /r/HasA | fn:fe:event | "piracy" | "event" | "/r/has a" |  | "FN" |  |
| fn:piracy | /r/HasA | fn:fe:manner | "piracy" | "manner" | "/r/has a" |  | "FN" |  |
| fn:piracy | /r/HasA | fn:fe:means | "piracy" | "means" | "/r/has a" |  | "FN" |  |
| fn:piracy | /r/HasA | fn:fe:duration | "piracy" | "duration" | "/r/has a" |  | "FN" |  |
| fn:piracy | /r/HasA | fn:fe:place | "piracy" | "place" | "/r/has a" |  | "FN" |  |
| fn:piracy | /r/HasA | fn:fe:time | "piracy" | "time" | "/r/has a" |  | "FN" |  |
| fn:piracy | /r/HasA | fn:fe:goal | "piracy" | "goal" | "/r/has a" |  | "FN" |  |
| fn:piracy | /r/HasA | fn:fe:source | "piracy" | "source" | "/r/has a" |  | "FN" |  |
| fn:piracy | /r/HasA | fn:fe:purpose | "piracy" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:piracy | /r/HasA | fn:fe:explanation | "piracy" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:piracy | /r/HasA | fn:fe:instrument | "piracy" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:piracy | /r/HasA | fn:fe:frequency | "piracy" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:burying | /r/IsA | fn:placing | "burying" | "placing" | "/r/is a" |  | "FN" |  |
| fn:dispersal | /r/IsA | fn:placing | "dispersal" | "placing" | "/r/is a" |  | "FN" |  |
| fn:placing | /r/IsA | fn:transitive_action | "placing" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_motion | /r/HasSubevent | fn:placing | "cause motion" | "placing" | "/r/has subevent" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:placing | "motion" | "placing" | "/r/used for" |  | "FN" |  |
| fn:placing | /r/UsedFor | fn:arranging | "placing" | "arranging" | "/r/used for" |  | "FN" |  |
| fn:placing | /r/UsedFor | fn:dressing | "placing" | "dressing" | "/r/used for" |  | "FN" |  |
| fn:placing | /r/UsedFor | fn:dunking | "placing" | "dunking" | "/r/used for" |  | "FN" |  |
| fn:placing | /r/UsedFor | fn:installing | "placing" | "installing" | "/r/used for" |  | "FN" |  |
| fn:placing | /r/UsedFor | fn:storing | "placing" | "storing" | "/r/used for" |  | "FN" |  |
| fn:cause_motion | /r/RelatedTo | fn:placing | "cause motion" | "placing" | "/r/related to" |  | "FN" |  |
| fn:placing | /r/RelatedTo | fn:filling | "placing" | "filling" | "/r/related to" |  | "FN" |  |
| fn:placing | /r/RelatedTo | fn:removing | "placing" | "removing" | "/r/related to" |  | "FN" |  |
| fn:placing | /r/SimilarTo | fn:arranging | "placing" | "arranging" | "/r/similar to" |  | "FN" |  |
| fn:placing | /r/SimilarTo | fn:assigned_location | "placing" | "assigned location" | "/r/similar to" |  | "FN" |  |
| fn:placing | /r/SimilarTo | fn:attaching | "placing" | "attaching" | "/r/similar to" |  | "FN" |  |
| fn:placing | /r/SimilarTo | fn:bringing | "placing" | "bringing" | "/r/similar to" |  | "FN" |  |
| fn:placing | /r/SimilarTo | fn:cause_fluidic_motion | "placing" | "cause fluidic motion" | "/r/similar to" |  | "FN" |  |
| fn:placing | /r/SimilarTo | fn:dispersal | "placing" | "dispersal" | "/r/similar to" |  | "FN" |  |
| fn:placing | /r/SimilarTo | fn:planting | "placing" | "planting" | "/r/similar to" |  | "FN" |  |
| fn:placing | /r/HasPrerequisite | fn:removing | "placing" | "removing" | "/r/has prerequisite" |  | "FN" |  |
| fn:placing | /r/IsA | fn:placing_scenario | "placing" | "placing scenario" | "/r/is a" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:deposit | "placing" | "deposit" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:embed | "placing" | "embed" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:hang | "placing" | "hang" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:immerse | "placing" | "immerse" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:implant | "placing" | "implant" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:inject | "placing" | "inject" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:insert | "placing" | "insert" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:insertion | "placing" | "insertion" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:lay | "placing" | "lay" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:lean | "placing" | "lean" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:load | "placing" | "load" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:lodge | "placing" | "lodge" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:pack | "placing" | "pack" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:park | "placing" | "park" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:pile | "placing" | "pile" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:place | "placing" | "place" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:placement | "placing" | "placement" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:plant | "placing" | "plant" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:position | "placing" | "position" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:rest | "placing" | "rest" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:set | "placing" | "set" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:situate | "placing" | "situate" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:smear | "placing" | "smear" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:stand | "placing" | "stand" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:stash | "placing" | "stash" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:stow | "placing" | "stow" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:stuff | "placing" | "stuff" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:tuck | "placing" | "tuck" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:wrap | "placing" | "wrap" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:bag | "placing" | "bag" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:billet | "placing" | "billet" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:bin | "placing" | "bin" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:bottle | "placing" | "bottle" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:archive | "placing" | "archive" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:box | "placing" | "box" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:cage | "placing" | "cage" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:crate | "placing" | "crate" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:file | "placing" | "file" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:garage | "placing" | "garage" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:pocket | "placing" | "pocket" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:shelve | "placing" | "shelve" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:stable | "placing" | "stable" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:perch | "placing" | "perch" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:sit | "placing" | "sit" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:daub | "placing" | "daub" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:drizzle | "placing" | "drizzle" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:dab | "placing" | "dab" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:drape | "placing" | "drape" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:brush | "placing" | "brush" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:dust | "placing" | "dust" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:heap | "placing" | "heap" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:jam | "placing" | "jam" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:rub | "placing" | "rub" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:cram | "placing" | "cram" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:shower | "placing" | "shower" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:pot | "placing" | "pot" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:sheathe | "placing" | "sheathe" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:warehouse | "placing" | "warehouse" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:shoulder | "placing" | "shoulder" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:stick | "placing" | "stick" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:bestow | "placing" | "bestow" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:put | "placing" | "put" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:package | "placing" | "package" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:plunge | "placing" | "plunge" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:arrange | "placing" | "arrange" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:emplace | "placing" | "emplace" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:enclose | "placing" | "enclose" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:implanted | "placing" | "implanted" | "has lexical unit" |  | "FN" |  |
| fn:placing | fn:HasLexicalUnit | fn:lu:placing:gag | "placing" | "gag" | "has lexical unit" |  | "FN" |  |
| fn:placing | /r/HasA | fn:fe:agent | "placing" | "agent" | "/r/has a" |  | "FN" |  |
| fn:placing | /r/HasA | fn:fe:theme | "placing" | "theme" | "/r/has a" |  | "FN" |  |
| fn:placing | /r/HasA | fn:fe:source | "placing" | "source" | "/r/has a" |  | "FN" |  |
| fn:placing | /r/HasA | fn:fe:path | "placing" | "path" | "/r/has a" |  | "FN" |  |
| fn:placing | /r/HasA | fn:fe:goal | "placing" | "goal" | "/r/has a" |  | "FN" |  |
| fn:placing | /r/HasA | fn:fe:manner | "placing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:placing | /r/HasA | fn:fe:degree | "placing" | "degree" | "/r/has a" |  | "FN" |  |
| fn:placing | /r/HasA | fn:fe:depictive | "placing" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:placing | /r/HasA | fn:fe:means | "placing" | "means" | "/r/has a" |  | "FN" |  |
| fn:placing | /r/HasA | fn:fe:result | "placing" | "result" | "/r/has a" |  | "FN" |  |
| fn:placing | /r/HasA | fn:fe:duration | "placing" | "duration" | "/r/has a" |  | "FN" |  |
| fn:placing | /r/HasA | fn:fe:place | "placing" | "place" | "/r/has a" |  | "FN" |  |
| fn:placing | /r/HasA | fn:fe:explanation | "placing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:placing | /r/HasA | fn:fe:time | "placing" | "time" | "/r/has a" |  | "FN" |  |
| fn:placing | /r/HasA | fn:fe:area | "placing" | "area" | "/r/has a" |  | "FN" |  |
| fn:placing | /r/HasA | fn:fe:cotheme | "placing" | "cotheme" | "/r/has a" |  | "FN" |  |
| fn:placing | /r/HasA | fn:fe:distance | "placing" | "distance" | "/r/has a" |  | "FN" |  |
| fn:placing | /r/HasA | fn:fe:speed | "placing" | "speed" | "/r/has a" |  | "FN" |  |
| fn:placing | /r/HasA | fn:fe:cause | "placing" | "cause" | "/r/has a" |  | "FN" |  |
| fn:placing | /r/HasA | fn:fe:purpose | "placing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:placing | /r/HasA | fn:fe:beneficiary | "placing" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:container_focused_placing | /r/IsA | fn:placing_scenario | "container focused placing" | "placing scenario" | "/r/is a" |  | "FN" |  |
| fn:placing | /r/IsA | fn:placing_scenario | "placing" | "placing scenario" | "/r/is a" |  | "FN" |  |
| fn:placing_scenario | /r/HasA | fn:fe:agent | "placing scenario" | "agent" | "/r/has a" |  | "FN" |  |
| fn:placing_scenario | /r/HasA | fn:fe:theme | "placing scenario" | "theme" | "/r/has a" |  | "FN" |  |
| fn:placing_scenario | /r/HasA | fn:fe:source | "placing scenario" | "source" | "/r/has a" |  | "FN" |  |
| fn:placing_scenario | /r/HasA | fn:fe:path | "placing scenario" | "path" | "/r/has a" |  | "FN" |  |
| fn:placing_scenario | /r/HasA | fn:fe:goal | "placing scenario" | "goal" | "/r/has a" |  | "FN" |  |
| fn:placing_scenario | /r/HasA | fn:fe:degree | "placing scenario" | "degree" | "/r/has a" |  | "FN" |  |
| fn:placing_scenario | /r/HasA | fn:fe:depictive | "placing scenario" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:placing_scenario | /r/HasA | fn:fe:manner | "placing scenario" | "manner" | "/r/has a" |  | "FN" |  |
| fn:placing_scenario | /r/HasA | fn:fe:means | "placing scenario" | "means" | "/r/has a" |  | "FN" |  |
| fn:placing_scenario | /r/HasA | fn:fe:result | "placing scenario" | "result" | "/r/has a" |  | "FN" |  |
| fn:placing_scenario | /r/HasA | fn:fe:explanation | "placing scenario" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:placing_scenario | /r/HasA | fn:fe:time | "placing scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:placing_scenario | /r/HasA | fn:fe:place | "placing scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:placing_scenario | /r/HasA | fn:fe:instrument | "placing scenario" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:placing_scenario | /r/HasA | fn:fe:subregion | "placing scenario" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:placing_scenario | /r/HasA | fn:fe:cause | "placing scenario" | "cause" | "/r/has a" |  | "FN" |  |
| fn:planned_trajectory | fn:HasLexicalUnit | fn:lu:planned_trajectory:way | "planned trajectory" | "way" | "has lexical unit" |  | "FN" |  |
| fn:planned_trajectory | /r/HasA | fn:fe:theme | "planned trajectory" | "theme" | "/r/has a" |  | "FN" |  |
| fn:planned_trajectory | /r/HasA | fn:fe:source | "planned trajectory" | "source" | "/r/has a" |  | "FN" |  |
| fn:planned_trajectory | /r/HasA | fn:fe:path | "planned trajectory" | "path" | "/r/has a" |  | "FN" |  |
| fn:planned_trajectory | /r/HasA | fn:fe:goal | "planned trajectory" | "goal" | "/r/has a" |  | "FN" |  |
| fn:planned_trajectory | /r/HasA | fn:fe:descriptor | "planned trajectory" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:agriculture | /r/HasSubevent | fn:planting | "agriculture" | "planting" | "/r/has subevent" |  | "FN" |  |
| fn:placing | /r/SimilarTo | fn:planting | "placing" | "planting" | "/r/similar to" |  | "FN" |  |
| fn:planting | fn:HasLexicalUnit | fn:lu:planting:plant | "planting" | "plant" | "has lexical unit" |  | "FN" |  |
| fn:planting | fn:HasLexicalUnit | fn:lu:planting:sow | "planting" | "sow" | "has lexical unit" |  | "FN" |  |
| fn:planting | /r/HasA | fn:fe:agent | "planting" | "agent" | "/r/has a" |  | "FN" |  |
| fn:fe:theme | /r/IsA | fn:st:physical_entity | "theme" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:planting | /r/HasA | fn:fe:theme | "planting" | "theme" | "/r/has a" |  | "FN" |  |
| fn:planting | /r/HasA | fn:fe:instrument | "planting" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:planting | /r/HasA | fn:fe:duration | "planting" | "duration" | "/r/has a" |  | "FN" |  |
| fn:planting | /r/HasA | fn:fe:manner | "planting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:planting | /r/HasA | fn:fe:means | "planting" | "means" | "/r/has a" |  | "FN" |  |
| fn:planting | /r/HasA | fn:fe:outcome | "planting" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:planting | /r/HasA | fn:fe:place | "planting" | "place" | "/r/has a" |  | "FN" |  |
| fn:planting | /r/HasA | fn:fe:time | "planting" | "time" | "/r/has a" |  | "FN" |  |
| fn:planting | /r/HasA | fn:fe:purpose | "planting" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:planting | /r/HasA | fn:fe:frequency | "planting" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:planting | /r/HasA | fn:fe:degree | "planting" | "degree" | "/r/has a" |  | "FN" |  |
| fn:planting | /r/HasA | fn:fe:ground | "planting" | "ground" | "/r/has a" |  | "FN" |  |
| fn:planting | /r/HasA | fn:fe:particular_iteration | "planting" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:planting | /r/HasA | fn:fe:depictive | "planting" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:planting | /r/HasA | fn:fe:co-participant | "planting" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:planting | /r/HasA | fn:fe:explanation | "planting" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:plants | /r/IsA | fn:biological_entity | "plants" | "biological entity" | "/r/is a" |  | "FN" |  |
| fn:plants | fn:HasLexicalUnit | fn:lu:plants:tree | "plants" | "tree" | "has lexical unit" |  | "FN" |  |
| fn:plants | fn:HasLexicalUnit | fn:lu:plants:weed | "plants" | "weed" | "has lexical unit" |  | "FN" |  |
| fn:plants | /r/HasA | fn:fe:plant | "plants" | "plant" | "/r/has a" |  | "FN" |  |
| fn:plants | /r/HasA | fn:fe:characteristic | "plants" | "characteristic" | "/r/has a" |  | "FN" |  |
| fn:plants | /r/HasA | fn:fe:descriptor | "plants" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:plants | /r/HasA | fn:fe:origin | "plants" | "origin" | "/r/has a" |  | "FN" |  |
| fn:be_in_agreement_on_assessment | /r/UsedFor | fn:point_of_dispute | "be in agreement on assessment" | "point of dispute" | "/r/used for" |  | "FN" |  |
| fn:discussion | /r/UsedFor | fn:point_of_dispute | "discussion" | "point of dispute" | "/r/used for" |  | "FN" |  |
| fn:point_of_dispute | fn:HasLexicalUnit | fn:lu:point_of_dispute:issue | "point of dispute" | "issue" | "has lexical unit" |  | "FN" |  |
| fn:point_of_dispute | fn:HasLexicalUnit | fn:lu:point_of_dispute:question | "point of dispute" | "question" | "has lexical unit" |  | "FN" |  |
| fn:point_of_dispute | fn:HasLexicalUnit | fn:lu:point_of_dispute:concern | "point of dispute" | "concern" | "has lexical unit" |  | "FN" |  |
| fn:point_of_dispute | /r/HasA | fn:fe:question | "point of dispute" | "question" | "/r/has a" |  | "FN" |  |
| fn:fe:group | /r/IsA | fn:st:sentient | "group" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:point_of_dispute | /r/HasA | fn:fe:group | "point of dispute" | "group" | "/r/has a" |  | "FN" |  |
| fn:point_of_dispute | /r/HasA | fn:fe:status | "point of dispute" | "status" | "/r/has a" |  | "FN" |  |
| fn:point_of_dispute | /r/HasA | fn:fe:descriptor | "point of dispute" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:point_of_dispute | /r/HasA | fn:fe:domain | "point of dispute" | "domain" | "/r/has a" |  | "FN" |  |
| fn:point_of_dispute | /r/HasA | fn:fe:context | "point of dispute" | "context" | "/r/has a" |  | "FN" |  |
| fn:point_of_dispute | /r/HasA | fn:fe:time | "point of dispute" | "time" | "/r/has a" |  | "FN" |  |
| fn:point_of_dispute | /r/HasA | fn:fe:viewpoint | "point of dispute" | "viewpoint" | "/r/has a" |  | "FN" |  |
| fn:political_actions | fn:HasLexicalUnit | fn:lu:political_actions:strike | "political actions" | "strike" | "has lexical unit" |  | "FN" |  |
| fn:political_actions | fn:HasLexicalUnit | fn:lu:political_actions:strike | "political actions" | "strike" | "has lexical unit" |  | "FN" |  |
| fn:political_actions | fn:HasLexicalUnit | fn:lu:political_actions:walk-out | "political actions" | "walk-out" | "has lexical unit" |  | "FN" |  |
| fn:fe:activists | /r/IsA | fn:st:sentient | "activists" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:political_actions | /r/HasA | fn:fe:activists | "political actions" | "activists" | "/r/has a" |  | "FN" |  |
| fn:political_actions | /r/HasA | fn:fe:institution | "political actions" | "institution" | "/r/has a" |  | "FN" |  |
| fn:political_actions | /r/HasA | fn:fe:demands | "political actions" | "demands" | "/r/has a" |  | "FN" |  |
| fn:political_actions | /r/HasA | fn:fe:duration | "political actions" | "duration" | "/r/has a" |  | "FN" |  |
| fn:political_actions | /r/HasA | fn:fe:manner | "political actions" | "manner" | "/r/has a" |  | "FN" |  |
| fn:political_actions | /r/HasA | fn:fe:means | "political actions" | "means" | "/r/has a" |  | "FN" |  |
| fn:political_actions | /r/HasA | fn:fe:place | "political actions" | "place" | "/r/has a" |  | "FN" |  |
| fn:political_actions | /r/HasA | fn:fe:type | "political actions" | "type" | "/r/has a" |  | "FN" |  |
| fn:political_actions | /r/HasA | fn:fe:result | "political actions" | "result" | "/r/has a" |  | "FN" |  |
| fn:political_locales | /r/IsA | fn:locale_by_ownership | "political locales" | "locale by ownership" | "/r/is a" |  | "FN" |  |
| fn:foreign_or_domestic_country | /r/IsA | fn:political_locales | "foreign or domestic country" | "political locales" | "/r/is a" |  | "FN" |  |
| fn:relational_political_locales | /r/IsA | fn:political_locales | "relational political locales" | "political locales" | "/r/is a" |  | "FN" |  |
| fn:leadership | /r/UsedFor | fn:political_locales | "leadership" | "political locales" | "/r/used for" |  | "FN" |  |
| fn:political_locales | /r/UsedFor | fn:economy | "political locales" | "economy" | "/r/used for" |  | "FN" |  |
| fn:political_locales | /r/UsedFor | fn:people_by_jurisdiction | "political locales" | "people by jurisdiction" | "/r/used for" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:barony | "political locales" | "barony" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:territory | "political locales" | "territory" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:country | "political locales" | "country" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:province | "political locales" | "province" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:duchy | "political locales" | "duchy" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:viscountcy | "political locales" | "viscountcy" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:county | "political locales" | "county" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:state_[sovereign] | "political locales" | "state [sovereign]" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:principality | "political locales" | "principality" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:borough | "political locales" | "borough" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:town | "political locales" | "town" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:realm | "political locales" | "realm" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:kingdom | "political locales" | "kingdom" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:municipality | "political locales" | "municipality" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:metropolis | "political locales" | "metropolis" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:megalopolis | "political locales" | "megalopolis" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:city | "political locales" | "city" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:world | "political locales" | "world" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:federal | "political locales" | "federal" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:global | "political locales" | "global" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:parish | "political locales" | "parish" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:diocese | "political locales" | "diocese" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:international | "political locales" | "international" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:local | "political locales" | "local" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:locality | "political locales" | "locality" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:municipal | "political locales" | "municipal" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:national | "political locales" | "national" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:empire | "political locales" | "empire" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:village | "political locales" | "village" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:nation | "political locales" | "nation" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:commonwealth | "political locales" | "commonwealth" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:internationally | "political locales" | "internationally" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:multinational | "political locales" | "multinational" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:city-state | "political locales" | "city-state" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:district | "political locales" | "district" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:fiefdom | "political locales" | "fiefdom" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:jurisdiction | "political locales" | "jurisdiction" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:land | "political locales" | "land" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:state_[internal] | "political locales" | "state [internal]" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:provincial | "political locales" | "provincial" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:territorial | "political locales" | "territorial" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | fn:HasLexicalUnit | fn:lu:political_locales:township | "political locales" | "township" | "has lexical unit" |  | "FN" |  |
| fn:political_locales | /r/HasA | fn:fe:constituent_parts | "political locales" | "constituent parts" | "/r/has a" |  | "FN" |  |
| fn:political_locales | /r/HasA | fn:fe:container_possessor | "political locales" | "container possessor" | "/r/has a" |  | "FN" |  |
| fn:political_locales | /r/HasA | fn:fe:locale | "political locales" | "locale" | "/r/has a" |  | "FN" |  |
| fn:political_locales | /r/HasA | fn:fe:name | "political locales" | "name" | "/r/has a" |  | "FN" |  |
| fn:political_locales | /r/HasA | fn:fe:relative_location | "political locales" | "relative location" | "/r/has a" |  | "FN" |  |
| fn:political_locales | /r/HasA | fn:fe:descriptor | "political locales" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:political_locales | /r/HasA | fn:fe:population | "political locales" | "population" | "/r/has a" |  | "FN" |  |
| fn:popularity | /r/IsA | fn:desirability | "popularity" | "desirability" | "/r/is a" |  | "FN" |  |
| fn:popularity | fn:HasLexicalUnit | fn:lu:popularity:popular | "popularity" | "popular" | "has lexical unit" |  | "FN" |  |
| fn:popularity | fn:HasLexicalUnit | fn:lu:popularity:cool | "popularity" | "cool" | "has lexical unit" |  | "FN" |  |
| fn:popularity | fn:HasLexicalUnit | fn:lu:popularity:in | "popularity" | "in" | "has lexical unit" |  | "FN" |  |
| fn:popularity | fn:HasLexicalUnit | fn:lu:popularity:in_demand | "popularity" | "in demand" | "has lexical unit" |  | "FN" |  |
| fn:popularity | fn:HasLexicalUnit | fn:lu:popularity:hot | "popularity" | "hot" | "has lexical unit" |  | "FN" |  |
| fn:popularity | /r/HasA | fn:fe:evaluee | "popularity" | "evaluee" | "/r/has a" |  | "FN" |  |
| fn:popularity | /r/HasA | fn:fe:degree | "popularity" | "degree" | "/r/has a" |  | "FN" |  |
| fn:popularity | /r/HasA | fn:fe:judge | "popularity" | "judge" | "/r/has a" |  | "FN" |  |
| fn:popularity | /r/HasA | fn:fe:time | "popularity" | "time" | "/r/has a" |  | "FN" |  |
| fn:popularity | /r/HasA | fn:fe:place | "popularity" | "place" | "/r/has a" |  | "FN" |  |
| fn:posing_as | /r/IsA | fn:passing_off | "posing as" | "passing off" | "/r/is a" |  | "FN" |  |
| fn:posing_as | /r/UsedFor | fn:front_for | "posing as" | "front for" | "/r/used for" |  | "FN" |  |
| fn:feigning | /r/SimilarTo | fn:posing_as | "feigning" | "posing as" | "/r/similar to" |  | "FN" |  |
| fn:posing_as | fn:HasLexicalUnit | fn:lu:posing_as:pose | "posing as" | "pose" | "has lexical unit" |  | "FN" |  |
| fn:posing_as | fn:HasLexicalUnit | fn:lu:posing_as:impersonate | "posing as" | "impersonate" | "has lexical unit" |  | "FN" |  |
| fn:posing_as | fn:HasLexicalUnit | fn:lu:posing_as:masquerade | "posing as" | "masquerade" | "has lexical unit" |  | "FN" |  |
| fn:posing_as | fn:HasLexicalUnit | fn:lu:posing_as:impersonation | "posing as" | "impersonation" | "has lexical unit" |  | "FN" |  |
| fn:posing_as | fn:HasLexicalUnit | fn:lu:posing_as:impostor | "posing as" | "impostor" | "has lexical unit" |  | "FN" |  |
| fn:posing_as | /r/HasA | fn:fe:agent | "posing as" | "agent" | "/r/has a" |  | "FN" |  |
| fn:posing_as | /r/HasA | fn:fe:manner | "posing as" | "manner" | "/r/has a" |  | "FN" |  |
| fn:posing_as | /r/HasA | fn:fe:means | "posing as" | "means" | "/r/has a" |  | "FN" |  |
| fn:posing_as | /r/HasA | fn:fe:simulated_entity | "posing as" | "simulated entity" | "/r/has a" |  | "FN" |  |
| fn:posing_as | /r/HasA | fn:fe:purpose | "posing as" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:posing_as | /r/HasA | fn:fe:explanation | "posing as" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:posing_as | /r/HasA | fn:fe:place | "posing as" | "place" | "/r/has a" |  | "FN" |  |
| fn:posing_as | /r/HasA | fn:fe:time | "posing as" | "time" | "/r/has a" |  | "FN" |  |
| fn:position_on_a_scale | /r/IsA | fn:gradable_attributes | "position on a scale" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:evaluative_comparison | /r/IsA | fn:position_on_a_scale | "evaluative comparison" | "position on a scale" | "/r/is a" |  | "FN" |  |
| fn:sufficiency | /r/IsA | fn:position_on_a_scale | "sufficiency" | "position on a scale" | "/r/is a" |  | "FN" |  |
| fn:surpassing | /r/IsA | fn:position_on_a_scale | "surpassing" | "position on a scale" | "/r/is a" |  | "FN" |  |
| fn:used_up | /r/IsA | fn:position_on_a_scale | "used up" | "position on a scale" | "/r/is a" |  | "FN" |  |
| fn:position_on_a_scale | /r/UsedFor | fn:delimitation_of_diversity | "position on a scale" | "delimitation of diversity" | "/r/used for" |  | "FN" |  |
| fn:position_on_a_scale | /r/UsedFor | fn:probability | "position on a scale" | "probability" | "/r/used for" |  | "FN" |  |
| fn:position_on_a_scale | /r/SimilarTo | fn:delimitation_of_diversity | "position on a scale" | "delimitation of diversity" | "/r/similar to" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/Causes | fn:position_on_a_scale | "change position on a scale" | "position on a scale" | "/r/causes" |  | "FN" |  |
| fn:position_on_a_scale | fn:HasLexicalUnit | fn:lu:position_on_a_scale:high | "position on a scale" | "high" | "has lexical unit" |  | "FN" |  |
| fn:position_on_a_scale | fn:HasLexicalUnit | fn:lu:position_on_a_scale:low | "position on a scale" | "low" | "has lexical unit" |  | "FN" |  |
| fn:position_on_a_scale | fn:HasLexicalUnit | fn:lu:position_on_a_scale:rich | "position on a scale" | "rich" | "has lexical unit" |  | "FN" |  |
| fn:position_on_a_scale | fn:HasLexicalUnit | fn:lu:position_on_a_scale:deficient | "position on a scale" | "deficient" | "has lexical unit" |  | "FN" |  |
| fn:position_on_a_scale | fn:HasLexicalUnit | fn:lu:position_on_a_scale:lacking | "position on a scale" | "lacking" | "has lexical unit" |  | "FN" |  |
| fn:position_on_a_scale | fn:HasLexicalUnit | fn:lu:position_on_a_scale:advanced | "position on a scale" | "advanced" | "has lexical unit" |  | "FN" |  |
| fn:position_on_a_scale | fn:HasLexicalUnit | fn:lu:position_on_a_scale:medium | "position on a scale" | "medium" | "has lexical unit" |  | "FN" |  |
| fn:position_on_a_scale | fn:HasLexicalUnit | fn:lu:position_on_a_scale:poor | "position on a scale" | "poor" | "has lexical unit" |  | "FN" |  |
| fn:position_on_a_scale | fn:HasLexicalUnit | fn:lu:position_on_a_scale:through_the_roof | "position on a scale" | "through the roof" | "has lexical unit" |  | "FN" |  |
| fn:position_on_a_scale | fn:HasLexicalUnit | fn:lu:position_on_a_scale:moderate | "position on a scale" | "moderate" | "has lexical unit" |  | "FN" |  |
| fn:position_on_a_scale | /r/HasA | fn:fe:item | "position on a scale" | "item" | "/r/has a" |  | "FN" |  |
| fn:position_on_a_scale | /r/HasA | fn:fe:variable | "position on a scale" | "variable" | "/r/has a" |  | "FN" |  |
| fn:position_on_a_scale | /r/HasA | fn:fe:value | "position on a scale" | "value" | "/r/has a" |  | "FN" |  |
| fn:position_on_a_scale | /r/HasA | fn:fe:degree | "position on a scale" | "degree" | "/r/has a" |  | "FN" |  |
| fn:position_on_a_scale | /r/HasA | fn:fe:domain | "position on a scale" | "domain" | "/r/has a" |  | "FN" |  |
| fn:post_getting | /r/IsA | fn:possession | "post getting" | "possession" | "/r/is a" |  | "FN" |  |
| fn:post_lose_possession | /r/IsA | fn:possession | "post lose possession" | "possession" | "/r/is a" |  | "FN" |  |
| fn:post_transfer | /r/IsA | fn:possession | "post transfer" | "possession" | "/r/is a" |  | "FN" |  |
| fn:pre_getting | /r/IsA | fn:possession | "pre getting" | "possession" | "/r/is a" |  | "FN" |  |
| fn:pre_lose_possession | /r/IsA | fn:possession | "pre lose possession" | "possession" | "/r/is a" |  | "FN" |  |
| fn:pre_transfer | /r/IsA | fn:possession | "pre transfer" | "possession" | "/r/is a" |  | "FN" |  |
| fn:retaining | /r/IsA | fn:possession | "retaining" | "possession" | "/r/is a" |  | "FN" |  |
| fn:possession | /r/UsedFor | fn:capital_stock | "possession" | "capital stock" | "/r/used for" |  | "FN" |  |
| fn:possession | /r/UsedFor | fn:change_of_quantity_of_possession | "possession" | "change of quantity of possession" | "/r/used for" |  | "FN" |  |
| fn:possession | /r/UsedFor | fn:locale_by_ownership | "possession" | "locale by ownership" | "/r/used for" |  | "FN" |  |
| fn:possession | /r/UsedFor | fn:prevent_or_allow_possession | "possession" | "prevent or allow possession" | "/r/used for" |  | "FN" |  |
| fn:possession | /r/UsedFor | fn:sacrificing_for | "possession" | "sacrificing for" | "/r/used for" |  | "FN" |  |
| fn:possession | /r/UsedFor | fn:wealthiness | "possession" | "wealthiness" | "/r/used for" |  | "FN" |  |
| fn:getting | /r/Causes | fn:possession | "getting" | "possession" | "/r/causes" |  | "FN" |  |
| fn:possession | fn:HasLexicalUnit | fn:lu:possession:own | "possession" | "own" | "has lexical unit" |  | "FN" |  |
| fn:possession | fn:HasLexicalUnit | fn:lu:possession:have | "possession" | "have" | "has lexical unit" |  | "FN" |  |
| fn:possession | fn:HasLexicalUnit | fn:lu:possession:lack | "possession" | "lack" | "has lexical unit" |  | "FN" |  |
| fn:possession | fn:HasLexicalUnit | fn:lu:possession:possess | "possession" | "possess" | "has lexical unit" |  | "FN" |  |
| fn:possession | fn:HasLexicalUnit | fn:lu:possession:possession | "possession" | "possession" | "has lexical unit" |  | "FN" |  |
| fn:possession | fn:HasLexicalUnit | fn:lu:possession:ownership | "possession" | "ownership" | "has lexical unit" |  | "FN" |  |
| fn:possession | fn:HasLexicalUnit | fn:lu:possession:owner | "possession" | "owner" | "has lexical unit" |  | "FN" |  |
| fn:possession | fn:HasLexicalUnit | fn:lu:possession:possessor | "possession" | "possessor" | "has lexical unit" |  | "FN" |  |
| fn:possession | fn:HasLexicalUnit | fn:lu:possession:lacking | "possession" | "lacking" | "has lexical unit" |  | "FN" |  |
| fn:possession | fn:HasLexicalUnit | fn:lu:possession:lack | "possession" | "lack" | "has lexical unit" |  | "FN" |  |
| fn:possession | fn:HasLexicalUnit | fn:lu:possession:wanting | "possession" | "wanting" | "has lexical unit" |  | "FN" |  |
| fn:possession | fn:HasLexicalUnit | fn:lu:possession:want | "possession" | "want" | "has lexical unit" |  | "FN" |  |
| fn:possession | fn:HasLexicalUnit | fn:lu:possession:want | "possession" | "want" | "has lexical unit" |  | "FN" |  |
| fn:possession | fn:HasLexicalUnit | fn:lu:possession:belong | "possession" | "belong" | "has lexical unit" |  | "FN" |  |
| fn:possession | fn:HasLexicalUnit | fn:lu:possession:belongings | "possession" | "belongings" | "has lexical unit" |  | "FN" |  |
| fn:possession | fn:HasLexicalUnit | fn:lu:possession:assets | "possession" | "assets" | "has lexical unit" |  | "FN" |  |
| fn:possession | fn:HasLexicalUnit | fn:lu:possession:property | "possession" | "property" | "has lexical unit" |  | "FN" |  |
| fn:possession | fn:HasLexicalUnit | fn:lu:possession:possession_[definite_noun] | "possession" | "possession [definite noun]" | "has lexical unit" |  | "FN" |  |
| fn:possession | fn:HasLexicalUnit | fn:lu:possession:possession_[of_goods] | "possession" | "possession [of goods]" | "has lexical unit" |  | "FN" |  |
| fn:possession | fn:HasLexicalUnit | fn:lu:possession:effects | "possession" | "effects" | "has lexical unit" |  | "FN" |  |
| fn:possession | fn:HasLexicalUnit | fn:lu:possession:have_got | "possession" | "have got" | "has lexical unit" |  | "FN" |  |
| fn:possession | fn:HasLexicalUnit | fn:lu:possession:custody | "possession" | "custody" | "has lexical unit" |  | "FN" |  |
| fn:possession | fn:HasLexicalUnit | fn:lu:possession:got | "possession" | "got" | "has lexical unit" |  | "FN" |  |
| fn:possession | /r/HasA | fn:fe:owner | "possession" | "owner" | "/r/has a" |  | "FN" |  |
| fn:possession | /r/HasA | fn:fe:possession | "possession" | "possession" | "/r/has a" |  | "FN" |  |
| fn:possession | /r/HasA | fn:fe:depictive | "possession" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:possession | /r/HasA | fn:fe:manner | "possession" | "manner" | "/r/has a" |  | "FN" |  |
| fn:possession | /r/HasA | fn:fe:duration | "possession" | "duration" | "/r/has a" |  | "FN" |  |
| fn:possession | /r/HasA | fn:fe:time | "possession" | "time" | "/r/has a" |  | "FN" |  |
| fn:possession | /r/HasA | fn:fe:explanation | "possession" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:capability | /r/IsA | fn:possibility | "capability" | "possibility" | "/r/is a" |  | "FN" |  |
| fn:possibility | /r/RelatedTo | fn:capability | "possibility" | "capability" | "/r/related to" |  | "FN" |  |
| fn:possibility | fn:HasLexicalUnit | fn:lu:possibility:can | "possibility" | "can" | "has lexical unit" |  | "FN" |  |
| fn:possibility | fn:HasLexicalUnit | fn:lu:possibility:might | "possibility" | "might" | "has lexical unit" |  | "FN" |  |
| fn:possibility | fn:HasLexicalUnit | fn:lu:possibility:may | "possibility" | "may" | "has lexical unit" |  | "FN" |  |
| fn:possibility | fn:HasLexicalUnit | fn:lu:possibility:could | "possibility" | "could" | "has lexical unit" |  | "FN" |  |
| fn:fe:possible_event | /r/IsA | fn:st:state_of_affairs | "possible event" | "state of affairs" | "/r/is a" |  | "FN" |  |
| fn:possibility | /r/HasA | fn:fe:possible_event | "possibility" | "possible event" | "/r/has a" |  | "FN" |  |
| fn:possibility | /r/HasA | fn:fe:circumstances | "possibility" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:possibility | /r/HasA | fn:fe:explanation | "possibility" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:possibility | /r/HasA | fn:fe:condition | "possibility" | "condition" | "/r/has a" |  | "FN" |  |
| fn:possibility | /r/HasA | fn:fe:time | "possibility" | "time" | "/r/has a" |  | "FN" |  |
| fn:post_getting | /r/IsA | fn:possession | "post getting" | "possession" | "/r/is a" |  | "FN" |  |
| fn:post_receiving | /r/IsA | fn:post_getting | "post receiving" | "post getting" | "/r/is a" |  | "FN" |  |
| fn:getting_scenario | /r/HasSubevent | fn:post_getting | "getting scenario" | "post getting" | "/r/has subevent" |  | "FN" |  |
| fn:post_getting | /r/HasPrerequisite | fn:getting | "post getting" | "getting" | "/r/has prerequisite" |  | "FN" |  |
| fn:post_getting | /r/HasA | fn:fe:recipient | "post getting" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:post_getting | /r/HasA | fn:fe:theme | "post getting" | "theme" | "/r/has a" |  | "FN" |  |
| fn:post_getting | /r/HasA | fn:fe:manner | "post getting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:post_getting | /r/HasA | fn:fe:time | "post getting" | "time" | "/r/has a" |  | "FN" |  |
| fn:post_giving | /r/IsA | fn:post_lose_possession | "post giving" | "post lose possession" | "/r/is a" |  | "FN" |  |
| fn:giving_scenario | /r/HasSubevent | fn:post_giving | "giving scenario" | "post giving" | "/r/has subevent" |  | "FN" |  |
| fn:post_giving | /r/HasPrerequisite | fn:giving | "post giving" | "giving" | "/r/has prerequisite" |  | "FN" |  |
| fn:post_giving | /r/IsA | fn:post_transfer | "post giving" | "post transfer" | "/r/is a" |  | "FN" |  |
| fn:post_giving | /r/HasA | fn:fe:donor | "post giving" | "donor" | "/r/has a" |  | "FN" |  |
| fn:post_giving | /r/HasA | fn:fe:theme | "post giving" | "theme" | "/r/has a" |  | "FN" |  |
| fn:post_giving | /r/HasA | fn:fe:manner | "post giving" | "manner" | "/r/has a" |  | "FN" |  |
| fn:post_giving | /r/HasA | fn:fe:recipient | "post giving" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:post_giving | /r/HasA | fn:fe:time | "post giving" | "time" | "/r/has a" |  | "FN" |  |
| fn:post_lose_possession | /r/IsA | fn:possession | "post lose possession" | "possession" | "/r/is a" |  | "FN" |  |
| fn:post_giving | /r/IsA | fn:post_lose_possession | "post giving" | "post lose possession" | "/r/is a" |  | "FN" |  |
| fn:lose_possession_scenario | /r/HasSubevent | fn:post_lose_possession | "lose possession scenario" | "post lose possession" | "/r/has subevent" |  | "FN" |  |
| fn:post_lose_possession | /r/HasPrerequisite | fn:lose_possession | "post lose possession" | "lose possession" | "/r/has prerequisite" |  | "FN" |  |
| fn:post_lose_possession | /r/HasA | fn:fe:owner | "post lose possession" | "owner" | "/r/has a" |  | "FN" |  |
| fn:post_lose_possession | /r/HasA | fn:fe:possession | "post lose possession" | "possession" | "/r/has a" |  | "FN" |  |
| fn:post_lose_possession | /r/HasA | fn:fe:manner | "post lose possession" | "manner" | "/r/has a" |  | "FN" |  |
| fn:post_lose_possession | /r/HasA | fn:fe:time | "post lose possession" | "time" | "/r/has a" |  | "FN" |  |
| fn:post_receiving | /r/IsA | fn:post_getting | "post receiving" | "post getting" | "/r/is a" |  | "FN" |  |
| fn:receiving_scenario | /r/HasSubevent | fn:post_receiving | "receiving scenario" | "post receiving" | "/r/has subevent" |  | "FN" |  |
| fn:post_receiving | /r/HasPrerequisite | fn:receiving | "post receiving" | "receiving" | "/r/has prerequisite" |  | "FN" |  |
| fn:post_receiving | /r/IsA | fn:post_transfer | "post receiving" | "post transfer" | "/r/is a" |  | "FN" |  |
| fn:post_receiving | /r/HasA | fn:fe:recipient | "post receiving" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:post_receiving | /r/HasA | fn:fe:donor | "post receiving" | "donor" | "/r/has a" |  | "FN" |  |
| fn:post_receiving | /r/HasA | fn:fe:theme | "post receiving" | "theme" | "/r/has a" |  | "FN" |  |
| fn:post_receiving | /r/HasA | fn:fe:manner | "post receiving" | "manner" | "/r/has a" |  | "FN" |  |
| fn:post_receiving | /r/HasA | fn:fe:time | "post receiving" | "time" | "/r/has a" |  | "FN" |  |
| fn:post_transfer | /r/IsA | fn:possession | "post transfer" | "possession" | "/r/is a" |  | "FN" |  |
| fn:transfer_scenario | /r/HasSubevent | fn:post_transfer | "transfer scenario" | "post transfer" | "/r/has subevent" |  | "FN" |  |
| fn:post_transfer | /r/HasPrerequisite | fn:transfer | "post transfer" | "transfer" | "/r/has prerequisite" |  | "FN" |  |
| fn:post_giving | /r/IsA | fn:post_transfer | "post giving" | "post transfer" | "/r/is a" |  | "FN" |  |
| fn:post_receiving | /r/IsA | fn:post_transfer | "post receiving" | "post transfer" | "/r/is a" |  | "FN" |  |
| fn:post_transfer | /r/HasA | fn:fe:donor | "post transfer" | "donor" | "/r/has a" |  | "FN" |  |
| fn:post_transfer | /r/HasA | fn:fe:theme | "post transfer" | "theme" | "/r/has a" |  | "FN" |  |
| fn:post_transfer | /r/HasA | fn:fe:manner | "post transfer" | "manner" | "/r/has a" |  | "FN" |  |
| fn:post_transfer | /r/HasA | fn:fe:recipient | "post transfer" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:post_transfer | /r/HasA | fn:fe:time | "post transfer" | "time" | "/r/has a" |  | "FN" |  |
| fn:posture | /r/IsA | fn:state | "posture" | "state" | "/r/is a" |  | "FN" |  |
| fn:posture | /r/SimilarTo | fn:change_posture | "posture" | "change posture" | "/r/similar to" |  | "FN" |  |
| fn:change_posture | /r/Causes | fn:posture | "change posture" | "posture" | "/r/causes" |  | "FN" |  |
| fn:posture | fn:HasLexicalUnit | fn:lu:posture:bend | "posture" | "bend" | "has lexical unit" |  | "FN" |  |
| fn:posture | fn:HasLexicalUnit | fn:lu:posture:crouch | "posture" | "crouch" | "has lexical unit" |  | "FN" |  |
| fn:posture | fn:HasLexicalUnit | fn:lu:posture:hunch | "posture" | "hunch" | "has lexical unit" |  | "FN" |  |
| fn:posture | fn:HasLexicalUnit | fn:lu:posture:huddle | "posture" | "huddle" | "has lexical unit" |  | "FN" |  |
| fn:posture | fn:HasLexicalUnit | fn:lu:posture:kneel | "posture" | "kneel" | "has lexical unit" |  | "FN" |  |
| fn:posture | fn:HasLexicalUnit | fn:lu:posture:lean | "posture" | "lean" | "has lexical unit" |  | "FN" |  |
| fn:posture | fn:HasLexicalUnit | fn:lu:posture:lie | "posture" | "lie" | "has lexical unit" |  | "FN" |  |
| fn:posture | fn:HasLexicalUnit | fn:lu:posture:sit | "posture" | "sit" | "has lexical unit" |  | "FN" |  |
| fn:posture | fn:HasLexicalUnit | fn:lu:posture:slouch | "posture" | "slouch" | "has lexical unit" |  | "FN" |  |
| fn:posture | fn:HasLexicalUnit | fn:lu:posture:sprawl | "posture" | "sprawl" | "has lexical unit" |  | "FN" |  |
| fn:posture | fn:HasLexicalUnit | fn:lu:posture:squat | "posture" | "squat" | "has lexical unit" |  | "FN" |  |
| fn:posture | fn:HasLexicalUnit | fn:lu:posture:stand | "posture" | "stand" | "has lexical unit" |  | "FN" |  |
| fn:posture | fn:HasLexicalUnit | fn:lu:posture:stoop | "posture" | "stoop" | "has lexical unit" |  | "FN" |  |
| fn:posture | fn:HasLexicalUnit | fn:lu:posture:bent | "posture" | "bent" | "has lexical unit" |  | "FN" |  |
| fn:posture | fn:HasLexicalUnit | fn:lu:posture:crouched | "posture" | "crouched" | "has lexical unit" |  | "FN" |  |
| fn:posture | fn:HasLexicalUnit | fn:lu:posture:huddled | "posture" | "huddled" | "has lexical unit" |  | "FN" |  |
| fn:posture | fn:HasLexicalUnit | fn:lu:posture:hunched | "posture" | "hunched" | "has lexical unit" |  | "FN" |  |
| fn:posture | fn:HasLexicalUnit | fn:lu:posture:sprawled | "posture" | "sprawled" | "has lexical unit" |  | "FN" |  |
| fn:posture | fn:HasLexicalUnit | fn:lu:posture:slouched | "posture" | "slouched" | "has lexical unit" |  | "FN" |  |
| fn:posture | fn:HasLexicalUnit | fn:lu:posture:seated | "posture" | "seated" | "has lexical unit" |  | "FN" |  |
| fn:posture | fn:HasLexicalUnit | fn:lu:posture:posture | "posture" | "posture" | "has lexical unit" |  | "FN" |  |
| fn:posture | fn:HasLexicalUnit | fn:lu:posture:stance | "posture" | "stance" | "has lexical unit" |  | "FN" |  |
| fn:posture | fn:HasLexicalUnit | fn:lu:posture:position | "posture" | "position" | "has lexical unit" |  | "FN" |  |
| fn:posture | fn:HasLexicalUnit | fn:lu:posture:cower | "posture" | "cower" | "has lexical unit" |  | "FN" |  |
| fn:posture | fn:HasLexicalUnit | fn:lu:posture:shrink | "posture" | "shrink" | "has lexical unit" |  | "FN" |  |
| fn:posture | /r/HasA | fn:fe:agent | "posture" | "agent" | "/r/has a" |  | "FN" |  |
| fn:posture | /r/HasA | fn:fe:location | "posture" | "location" | "/r/has a" |  | "FN" |  |
| fn:posture | /r/HasA | fn:fe:degree | "posture" | "degree" | "/r/has a" |  | "FN" |  |
| fn:posture | /r/HasA | fn:fe:depictive | "posture" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:posture | /r/HasA | fn:fe:manner | "posture" | "manner" | "/r/has a" |  | "FN" |  |
| fn:posture | /r/HasA | fn:fe:dependent_state | "posture" | "dependent state" | "/r/has a" |  | "FN" |  |
| fn:posture | /r/HasA | fn:fe:time | "posture" | "time" | "/r/has a" |  | "FN" |  |
| fn:posture | /r/HasA | fn:fe:purpose | "posture" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:posture | /r/HasA | fn:fe:duration | "posture" | "duration" | "/r/has a" |  | "FN" |  |
| fn:posture | /r/HasA | fn:fe:point_of_contact | "posture" | "point of contact" | "/r/has a" |  | "FN" |  |
| fn:practice | /r/IsA | fn:intentionally_act | "practice" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:practice | fn:HasLexicalUnit | fn:lu:practice:practice | "practice" | "practice" | "has lexical unit" |  | "FN" |  |
| fn:practice | fn:HasLexicalUnit | fn:lu:practice:practice | "practice" | "practice" | "has lexical unit" |  | "FN" |  |
| fn:practice | fn:HasLexicalUnit | fn:lu:practice:practice_[mass] | "practice" | "practice [mass]" | "has lexical unit" |  | "FN" |  |
| fn:practice | fn:HasLexicalUnit | fn:lu:practice:rehearse | "practice" | "rehearse" | "has lexical unit" |  | "FN" |  |
| fn:practice | fn:HasLexicalUnit | fn:lu:practice:rehearsal | "practice" | "rehearsal" | "has lexical unit" |  | "FN" |  |
| fn:practice | fn:HasLexicalUnit | fn:lu:practice:rehearsal_[mass] | "practice" | "rehearsal [mass]" | "has lexical unit" |  | "FN" |  |
| fn:practice | fn:HasLexicalUnit | fn:lu:practice:run_(through) | "practice" | "run (through)" | "has lexical unit" |  | "FN" |  |
| fn:practice | fn:HasLexicalUnit | fn:lu:practice:run-through | "practice" | "run-through" | "has lexical unit" |  | "FN" |  |
| fn:practice | fn:HasLexicalUnit | fn:lu:practice:dry_run | "practice" | "dry run" | "has lexical unit" |  | "FN" |  |
| fn:practice | fn:HasLexicalUnit | fn:lu:practice:exercise | "practice" | "exercise" | "has lexical unit" |  | "FN" |  |
| fn:practice | fn:HasLexicalUnit | fn:lu:practice:drill | "practice" | "drill" | "has lexical unit" |  | "FN" |  |
| fn:practice | fn:HasLexicalUnit | fn:lu:practice:mock | "practice" | "mock" | "has lexical unit" |  | "FN" |  |
| fn:practice | /r/HasA | fn:fe:action | "practice" | "action" | "/r/has a" |  | "FN" |  |
| fn:practice | /r/HasA | fn:fe:agent | "practice" | "agent" | "/r/has a" |  | "FN" |  |
| fn:practice | /r/HasA | fn:fe:place | "practice" | "place" | "/r/has a" |  | "FN" |  |
| fn:practice | /r/HasA | fn:fe:purpose | "practice" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:practice | /r/HasA | fn:fe:time | "practice" | "time" | "/r/has a" |  | "FN" |  |
| fn:practice | /r/HasA | fn:fe:means | "practice" | "means" | "/r/has a" |  | "FN" |  |
| fn:practice | /r/HasA | fn:fe:manner | "practice" | "manner" | "/r/has a" |  | "FN" |  |
| fn:practice | /r/HasA | fn:fe:occasion | "practice" | "occasion" | "/r/has a" |  | "FN" |  |
| fn:practice | /r/HasA | fn:fe:duration | "practice" | "duration" | "/r/has a" |  | "FN" |  |
| fn:practice | /r/HasA | fn:fe:iterations | "practice" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:practice | /r/HasA | fn:fe:co-participant | "practice" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:praiseworthiness | /r/IsA | fn:social_behavior_evaluation | "praiseworthiness" | "social behavior evaluation" | "/r/is a" |  | "FN" |  |
| fn:judgment | /r/UsedFor | fn:praiseworthiness | "judgment" | "praiseworthiness" | "/r/used for" |  | "FN" |  |
| fn:praiseworthiness | fn:HasLexicalUnit | fn:lu:praiseworthiness:praiseworthy | "praiseworthiness" | "praiseworthy" | "has lexical unit" |  | "FN" |  |
| fn:praiseworthiness | fn:HasLexicalUnit | fn:lu:praiseworthiness:commendable | "praiseworthiness" | "commendable" | "has lexical unit" |  | "FN" |  |
| fn:praiseworthiness | fn:HasLexicalUnit | fn:lu:praiseworthiness:reprehensible | "praiseworthiness" | "reprehensible" | "has lexical unit" |  | "FN" |  |
| fn:praiseworthiness | fn:HasLexicalUnit | fn:lu:praiseworthiness:blameworthy | "praiseworthiness" | "blameworthy" | "has lexical unit" |  | "FN" |  |
| fn:praiseworthiness | fn:HasLexicalUnit | fn:lu:praiseworthiness:deplorable | "praiseworthiness" | "deplorable" | "has lexical unit" |  | "FN" |  |
| fn:praiseworthiness | fn:HasLexicalUnit | fn:lu:praiseworthiness:lamentable | "praiseworthiness" | "lamentable" | "has lexical unit" |  | "FN" |  |
| fn:praiseworthiness | fn:HasLexicalUnit | fn:lu:praiseworthiness:laudable | "praiseworthiness" | "laudable" | "has lexical unit" |  | "FN" |  |
| fn:praiseworthiness | fn:HasLexicalUnit | fn:lu:praiseworthiness:admirable | "praiseworthiness" | "admirable" | "has lexical unit" |  | "FN" |  |
| fn:praiseworthiness | fn:HasLexicalUnit | fn:lu:praiseworthiness:pitiable | "praiseworthiness" | "pitiable" | "has lexical unit" |  | "FN" |  |
| fn:praiseworthiness | fn:HasLexicalUnit | fn:lu:praiseworthiness:estimable | "praiseworthiness" | "estimable" | "has lexical unit" |  | "FN" |  |
| fn:praiseworthiness | fn:HasLexicalUnit | fn:lu:praiseworthiness:creditable | "praiseworthiness" | "creditable" | "has lexical unit" |  | "FN" |  |
| fn:praiseworthiness | fn:HasLexicalUnit | fn:lu:praiseworthiness:detestable | "praiseworthiness" | "detestable" | "has lexical unit" |  | "FN" |  |
| fn:praiseworthiness | fn:HasLexicalUnit | fn:lu:praiseworthiness:abominable | "praiseworthiness" | "abominable" | "has lexical unit" |  | "FN" |  |
| fn:praiseworthiness | fn:HasLexicalUnit | fn:lu:praiseworthiness:execrable | "praiseworthiness" | "execrable" | "has lexical unit" |  | "FN" |  |
| fn:praiseworthiness | fn:HasLexicalUnit | fn:lu:praiseworthiness:honorable | "praiseworthiness" | "honorable" | "has lexical unit" |  | "FN" |  |
| fn:praiseworthiness | fn:HasLexicalUnit | fn:lu:praiseworthiness:dishonorable | "praiseworthiness" | "dishonorable" | "has lexical unit" |  | "FN" |  |
| fn:praiseworthiness | fn:HasLexicalUnit | fn:lu:praiseworthiness:meritorious | "praiseworthiness" | "meritorious" | "has lexical unit" |  | "FN" |  |
| fn:praiseworthiness | fn:HasLexicalUnit | fn:lu:praiseworthiness:despicable | "praiseworthiness" | "despicable" | "has lexical unit" |  | "FN" |  |
| fn:praiseworthiness | /r/HasA | fn:fe:evaluee | "praiseworthiness" | "evaluee" | "/r/has a" |  | "FN" |  |
| fn:praiseworthiness | /r/HasA | fn:fe:behavior | "praiseworthiness" | "behavior" | "/r/has a" |  | "FN" |  |
| fn:praiseworthiness | /r/HasA | fn:fe:degree | "praiseworthiness" | "degree" | "/r/has a" |  | "FN" |  |
| fn:praiseworthiness | /r/HasA | fn:fe:judge | "praiseworthiness" | "judge" | "/r/has a" |  | "FN" |  |
| fn:prank | /r/IsA | fn:trap | "prank" | "trap" | "/r/is a" |  | "FN" |  |
| fn:prank | fn:HasLexicalUnit | fn:lu:prank:prank | "prank" | "prank" | "has lexical unit" |  | "FN" |  |
| fn:prank | fn:HasLexicalUnit | fn:lu:prank:practical_joke | "prank" | "practical joke" | "has lexical unit" |  | "FN" |  |
| fn:prank | /r/HasA | fn:fe:prank | "prank" | "prank" | "/r/has a" |  | "FN" |  |
| fn:prank | /r/HasA | fn:fe:joker | "prank" | "joker" | "/r/has a" |  | "FN" |  |
| fn:prank | /r/HasA | fn:fe:victim | "prank" | "victim" | "/r/has a" |  | "FN" |  |
| fn:prank | /r/HasA | fn:fe:descriptor | "prank" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:pre_getting | /r/IsA | fn:possession | "pre getting" | "possession" | "/r/is a" |  | "FN" |  |
| fn:pre_receiving | /r/IsA | fn:pre_getting | "pre receiving" | "pre getting" | "/r/is a" |  | "FN" |  |
| fn:getting_scenario | /r/HasSubevent | fn:pre_getting | "getting scenario" | "pre getting" | "/r/has subevent" |  | "FN" |  |
| fn:getting | /r/HasPrerequisite | fn:pre_getting | "getting" | "pre getting" | "/r/has prerequisite" |  | "FN" |  |
| fn:pre_getting | /r/HasA | fn:fe:recipient | "pre getting" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:pre_getting | /r/HasA | fn:fe:theme | "pre getting" | "theme" | "/r/has a" |  | "FN" |  |
| fn:pre_getting | /r/HasA | fn:fe:manner | "pre getting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:pre_getting | /r/HasA | fn:fe:time | "pre getting" | "time" | "/r/has a" |  | "FN" |  |
| fn:pre_giving | /r/IsA | fn:pre_lose_possession | "pre giving" | "pre lose possession" | "/r/is a" |  | "FN" |  |
| fn:giving_scenario | /r/HasSubevent | fn:pre_giving | "giving scenario" | "pre giving" | "/r/has subevent" |  | "FN" |  |
| fn:giving | /r/HasPrerequisite | fn:pre_giving | "giving" | "pre giving" | "/r/has prerequisite" |  | "FN" |  |
| fn:pre_giving | /r/IsA | fn:pre_transfer | "pre giving" | "pre transfer" | "/r/is a" |  | "FN" |  |
| fn:pre_giving | /r/HasA | fn:fe:donor | "pre giving" | "donor" | "/r/has a" |  | "FN" |  |
| fn:pre_giving | /r/HasA | fn:fe:theme | "pre giving" | "theme" | "/r/has a" |  | "FN" |  |
| fn:pre_giving | /r/HasA | fn:fe:manner | "pre giving" | "manner" | "/r/has a" |  | "FN" |  |
| fn:pre_giving | /r/HasA | fn:fe:recipient | "pre giving" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:pre_giving | /r/HasA | fn:fe:time | "pre giving" | "time" | "/r/has a" |  | "FN" |  |
| fn:pre_lose_possession | /r/IsA | fn:possession | "pre lose possession" | "possession" | "/r/is a" |  | "FN" |  |
| fn:pre_giving | /r/IsA | fn:pre_lose_possession | "pre giving" | "pre lose possession" | "/r/is a" |  | "FN" |  |
| fn:lose_possession_scenario | /r/HasSubevent | fn:pre_lose_possession | "lose possession scenario" | "pre lose possession" | "/r/has subevent" |  | "FN" |  |
| fn:lose_possession | /r/HasPrerequisite | fn:pre_lose_possession | "lose possession" | "pre lose possession" | "/r/has prerequisite" |  | "FN" |  |
| fn:pre_lose_possession | /r/HasA | fn:fe:owner | "pre lose possession" | "owner" | "/r/has a" |  | "FN" |  |
| fn:pre_lose_possession | /r/HasA | fn:fe:possession | "pre lose possession" | "possession" | "/r/has a" |  | "FN" |  |
| fn:pre_lose_possession | /r/HasA | fn:fe:manner | "pre lose possession" | "manner" | "/r/has a" |  | "FN" |  |
| fn:pre_lose_possession | /r/HasA | fn:fe:time | "pre lose possession" | "time" | "/r/has a" |  | "FN" |  |
| fn:pre_receiving | /r/IsA | fn:pre_getting | "pre receiving" | "pre getting" | "/r/is a" |  | "FN" |  |
| fn:receiving_scenario | /r/HasSubevent | fn:pre_receiving | "receiving scenario" | "pre receiving" | "/r/has subevent" |  | "FN" |  |
| fn:receiving | /r/HasPrerequisite | fn:pre_receiving | "receiving" | "pre receiving" | "/r/has prerequisite" |  | "FN" |  |
| fn:pre_receiving | /r/IsA | fn:pre_transfer | "pre receiving" | "pre transfer" | "/r/is a" |  | "FN" |  |
| fn:pre_receiving | /r/HasA | fn:fe:recipient | "pre receiving" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:pre_receiving | /r/HasA | fn:fe:donor | "pre receiving" | "donor" | "/r/has a" |  | "FN" |  |
| fn:pre_receiving | /r/HasA | fn:fe:theme | "pre receiving" | "theme" | "/r/has a" |  | "FN" |  |
| fn:pre_receiving | /r/HasA | fn:fe:manner | "pre receiving" | "manner" | "/r/has a" |  | "FN" |  |
| fn:pre_receiving | /r/HasA | fn:fe:time | "pre receiving" | "time" | "/r/has a" |  | "FN" |  |
| fn:pre_transfer | /r/IsA | fn:possession | "pre transfer" | "possession" | "/r/is a" |  | "FN" |  |
| fn:transfer_scenario | /r/HasSubevent | fn:pre_transfer | "transfer scenario" | "pre transfer" | "/r/has subevent" |  | "FN" |  |
| fn:transfer | /r/HasPrerequisite | fn:pre_transfer | "transfer" | "pre transfer" | "/r/has prerequisite" |  | "FN" |  |
| fn:pre_giving | /r/IsA | fn:pre_transfer | "pre giving" | "pre transfer" | "/r/is a" |  | "FN" |  |
| fn:pre_receiving | /r/IsA | fn:pre_transfer | "pre receiving" | "pre transfer" | "/r/is a" |  | "FN" |  |
| fn:pre_transfer | /r/HasA | fn:fe:donor | "pre transfer" | "donor" | "/r/has a" |  | "FN" |  |
| fn:pre_transfer | /r/HasA | fn:fe:theme | "pre transfer" | "theme" | "/r/has a" |  | "FN" |  |
| fn:pre_transfer | /r/HasA | fn:fe:manner | "pre transfer" | "manner" | "/r/has a" |  | "FN" |  |
| fn:pre_transfer | /r/HasA | fn:fe:recipient | "pre transfer" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:pre_transfer | /r/HasA | fn:fe:time | "pre transfer" | "time" | "/r/has a" |  | "FN" |  |
| fn:precariousness | /r/IsA | fn:being_at_risk | "precariousness" | "being at risk" | "/r/is a" |  | "FN" |  |
| fn:motion_directional | /r/UsedFor | fn:precariousness | "motion directional" | "precariousness" | "/r/used for" |  | "FN" |  |
| fn:precariousness | fn:HasLexicalUnit | fn:lu:precariousness:teeter | "precariousness" | "teeter" | "has lexical unit" |  | "FN" |  |
| fn:precariousness | fn:HasLexicalUnit | fn:lu:precariousness:balanced | "precariousness" | "balanced" | "has lexical unit" |  | "FN" |  |
| fn:precariousness | fn:HasLexicalUnit | fn:lu:precariousness:instability | "precariousness" | "instability" | "has lexical unit" |  | "FN" |  |
| fn:precariousness | fn:HasLexicalUnit | fn:lu:precariousness:unstable | "precariousness" | "unstable" | "has lexical unit" |  | "FN" |  |
| fn:precariousness | fn:HasLexicalUnit | fn:lu:precariousness:unsteady | "precariousness" | "unsteady" | "has lexical unit" |  | "FN" |  |
| fn:precariousness | fn:HasLexicalUnit | fn:lu:precariousness:stability | "precariousness" | "stability" | "has lexical unit" |  | "FN" |  |
| fn:precariousness | fn:HasLexicalUnit | fn:lu:precariousness:stable | "precariousness" | "stable" | "has lexical unit" |  | "FN" |  |
| fn:precariousness | fn:HasLexicalUnit | fn:lu:precariousness:steady | "precariousness" | "steady" | "has lexical unit" |  | "FN" |  |
| fn:precariousness | /r/HasA | fn:fe:theme | "precariousness" | "theme" | "/r/has a" |  | "FN" |  |
| fn:precariousness | /r/HasA | fn:fe:degree | "precariousness" | "degree" | "/r/has a" |  | "FN" |  |
| fn:precariousness | /r/HasA | fn:fe:falling_event | "precariousness" | "falling event" | "/r/has a" |  | "FN" |  |
| fn:precariousness | /r/HasA | fn:fe:dangerous_entity | "precariousness" | "dangerous entity" | "/r/has a" |  | "FN" |  |
| fn:precariousness | /r/HasA | fn:fe:place | "precariousness" | "place" | "/r/has a" |  | "FN" |  |
| fn:precariousness | /r/HasA | fn:fe:time | "precariousness" | "time" | "/r/has a" |  | "FN" |  |
| fn:precariousness | /r/HasA | fn:fe:explanation | "precariousness" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:precariousness | /r/HasA | fn:fe:situation | "precariousness" | "situation" | "/r/has a" |  | "FN" |  |
| fn:precariousness | /r/HasA | fn:fe:domain | "precariousness" | "domain" | "/r/has a" |  | "FN" |  |
| fn:precariousness | /r/HasA | fn:fe:depictive | "precariousness" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:precariousness | /r/HasA | fn:fe:frequency | "precariousness" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:precariousness | /r/HasA | fn:fe:duration | "precariousness" | "duration" | "/r/has a" |  | "FN" |  |
| fn:precariousness | /r/HasA | fn:fe:manner | "precariousness" | "manner" | "/r/has a" |  | "FN" |  |
| fn:precariousness | /r/HasA | fn:fe:location | "precariousness" | "location" | "/r/has a" |  | "FN" |  |
| fn:precariousness | /r/HasA | fn:fe:result | "precariousness" | "result" | "/r/has a" |  | "FN" |  |
| fn:precipitation | /r/IsA | fn:process | "precipitation" | "process" | "/r/is a" |  | "FN" |  |
| fn:weather | /r/HasSubevent | fn:precipitation | "weather" | "precipitation" | "/r/has subevent" |  | "FN" |  |
| fn:precipitation | fn:HasLexicalUnit | fn:lu:precipitation:rain | "precipitation" | "rain" | "has lexical unit" |  | "FN" |  |
| fn:precipitation | fn:HasLexicalUnit | fn:lu:precipitation:rain | "precipitation" | "rain" | "has lexical unit" |  | "FN" |  |
| fn:precipitation | fn:HasLexicalUnit | fn:lu:precipitation:rain_event | "precipitation" | "rain event" | "has lexical unit" |  | "FN" |  |
| fn:precipitation | fn:HasLexicalUnit | fn:lu:precipitation:snow | "precipitation" | "snow" | "has lexical unit" |  | "FN" |  |
| fn:precipitation | fn:HasLexicalUnit | fn:lu:precipitation:snow | "precipitation" | "snow" | "has lexical unit" |  | "FN" |  |
| fn:precipitation | fn:HasLexicalUnit | fn:lu:precipitation:snowfall | "precipitation" | "snowfall" | "has lexical unit" |  | "FN" |  |
| fn:precipitation | fn:HasLexicalUnit | fn:lu:precipitation:rainfall | "precipitation" | "rainfall" | "has lexical unit" |  | "FN" |  |
| fn:precipitation | fn:HasLexicalUnit | fn:lu:precipitation:drizzle | "precipitation" | "drizzle" | "has lexical unit" |  | "FN" |  |
| fn:precipitation | fn:HasLexicalUnit | fn:lu:precipitation:drizzle | "precipitation" | "drizzle" | "has lexical unit" |  | "FN" |  |
| fn:precipitation | fn:HasLexicalUnit | fn:lu:precipitation:sleet | "precipitation" | "sleet" | "has lexical unit" |  | "FN" |  |
| fn:precipitation | fn:HasLexicalUnit | fn:lu:precipitation:sleet | "precipitation" | "sleet" | "has lexical unit" |  | "FN" |  |
| fn:precipitation | fn:HasLexicalUnit | fn:lu:precipitation:downpour | "precipitation" | "downpour" | "has lexical unit" |  | "FN" |  |
| fn:precipitation | fn:HasLexicalUnit | fn:lu:precipitation:hail | "precipitation" | "hail" | "has lexical unit" |  | "FN" |  |
| fn:precipitation | fn:HasLexicalUnit | fn:lu:precipitation:hail | "precipitation" | "hail" | "has lexical unit" |  | "FN" |  |
| fn:precipitation | fn:HasLexicalUnit | fn:lu:precipitation:precipitation | "precipitation" | "precipitation" | "has lexical unit" |  | "FN" |  |
| fn:precipitation | fn:HasLexicalUnit | fn:lu:precipitation:precipitation_[event] | "precipitation" | "precipitation [event]" | "has lexical unit" |  | "FN" |  |
| fn:precipitation | fn:HasLexicalUnit | fn:lu:precipitation:shower | "precipitation" | "shower" | "has lexical unit" |  | "FN" |  |
| fn:precipitation | fn:HasLexicalUnit | fn:lu:precipitation:torrent | "precipitation" | "torrent" | "has lexical unit" |  | "FN" |  |
| fn:precipitation | fn:HasLexicalUnit | fn:lu:precipitation:sprinkle | "precipitation" | "sprinkle" | "has lexical unit" |  | "FN" |  |
| fn:precipitation | fn:HasLexicalUnit | fn:lu:precipitation:torrential | "precipitation" | "torrential" | "has lexical unit" |  | "FN" |  |
| fn:precipitation | fn:HasLexicalUnit | fn:lu:precipitation:shower | "precipitation" | "shower" | "has lexical unit" |  | "FN" |  |
| fn:precipitation | fn:HasLexicalUnit | fn:lu:precipitation:snow_[event] | "precipitation" | "snow [event]" | "has lexical unit" |  | "FN" |  |
| fn:precipitation | /r/HasA | fn:fe:precipitation | "precipitation" | "precipitation" | "/r/has a" |  | "FN" |  |
| fn:precipitation | /r/HasA | fn:fe:rate | "precipitation" | "rate" | "/r/has a" |  | "FN" |  |
| fn:precipitation | /r/HasA | fn:fe:quantity | "precipitation" | "quantity" | "/r/has a" |  | "FN" |  |
| fn:precipitation | /r/HasA | fn:fe:place | "precipitation" | "place" | "/r/has a" |  | "FN" |  |
| fn:precipitation | /r/HasA | fn:fe:duration | "precipitation" | "duration" | "/r/has a" |  | "FN" |  |
| fn:precipitation | /r/HasA | fn:fe:time | "precipitation" | "time" | "/r/has a" |  | "FN" |  |
| fn:precipitation | /r/HasA | fn:fe:explanation | "precipitation" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:precipitation | /r/HasA | fn:fe:manner | "precipitation" | "manner" | "/r/has a" |  | "FN" |  |
| fn:precipitation | /r/HasA | fn:fe:temperature | "precipitation" | "temperature" | "/r/has a" |  | "FN" |  |
| fn:precipitation | /r/HasA | fn:fe:frequency | "precipitation" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:predicament | /r/IsA | fn:state_of_entity | "predicament" | "state of entity" | "/r/is a" |  | "FN" |  |
| fn:emotions | /r/UsedFor | fn:predicament | "emotions" | "predicament" | "/r/used for" |  | "FN" |  |
| fn:predicament | fn:HasLexicalUnit | fn:lu:predicament:pickle | "predicament" | "pickle" | "has lexical unit" |  | "FN" |  |
| fn:predicament | fn:HasLexicalUnit | fn:lu:predicament:scrape | "predicament" | "scrape" | "has lexical unit" |  | "FN" |  |
| fn:predicament | fn:HasLexicalUnit | fn:lu:predicament:pinch | "predicament" | "pinch" | "has lexical unit" |  | "FN" |  |
| fn:predicament | fn:HasLexicalUnit | fn:lu:predicament:predicament | "predicament" | "predicament" | "has lexical unit" |  | "FN" |  |
| fn:predicament | fn:HasLexicalUnit | fn:lu:predicament:bind | "predicament" | "bind" | "has lexical unit" |  | "FN" |  |
| fn:predicament | fn:HasLexicalUnit | fn:lu:predicament:fix | "predicament" | "fix" | "has lexical unit" |  | "FN" |  |
| fn:predicament | fn:HasLexicalUnit | fn:lu:predicament:jam | "predicament" | "jam" | "has lexical unit" |  | "FN" |  |
| fn:predicament | fn:HasLexicalUnit | fn:lu:predicament:mess | "predicament" | "mess" | "has lexical unit" |  | "FN" |  |
| fn:predicament | fn:HasLexicalUnit | fn:lu:predicament:plight | "predicament" | "plight" | "has lexical unit" |  | "FN" |  |
| fn:predicament | fn:HasLexicalUnit | fn:lu:predicament:misfortune | "predicament" | "misfortune" | "has lexical unit" |  | "FN" |  |
| fn:predicament | fn:HasLexicalUnit | fn:lu:predicament:problem | "predicament" | "problem" | "has lexical unit" |  | "FN" |  |
| fn:predicament | fn:HasLexicalUnit | fn:lu:predicament:trouble | "predicament" | "trouble" | "has lexical unit" |  | "FN" |  |
| fn:predicament | /r/HasA | fn:fe:experiencer | "predicament" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:predicament | /r/HasA | fn:fe:situation | "predicament" | "situation" | "/r/has a" |  | "FN" |  |
| fn:predicament | /r/HasA | fn:fe:explanation | "predicament" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:predicament | /r/HasA | fn:fe:time | "predicament" | "time" | "/r/has a" |  | "FN" |  |
| fn:predicament | /r/HasA | fn:fe:place | "predicament" | "place" | "/r/has a" |  | "FN" |  |
| fn:predicament | /r/HasA | fn:fe:domain | "predicament" | "domain" | "/r/has a" |  | "FN" |  |
| fn:predicting | /r/IsA | fn:statement | "predicting" | "statement" | "/r/is a" |  | "FN" |  |
| fn:expectation | /r/UsedFor | fn:predicting | "expectation" | "predicting" | "/r/used for" |  | "FN" |  |
| fn:predicting | fn:HasLexicalUnit | fn:lu:predicting:predict | "predicting" | "predict" | "has lexical unit" |  | "FN" |  |
| fn:predicting | fn:HasLexicalUnit | fn:lu:predicting:vaticinate | "predicting" | "vaticinate" | "has lexical unit" |  | "FN" |  |
| fn:predicting | fn:HasLexicalUnit | fn:lu:predicting:forecast | "predicting" | "forecast" | "has lexical unit" |  | "FN" |  |
| fn:predicting | fn:HasLexicalUnit | fn:lu:predicting:foretell | "predicting" | "foretell" | "has lexical unit" |  | "FN" |  |
| fn:predicting | fn:HasLexicalUnit | fn:lu:predicting:prophesy | "predicting" | "prophesy" | "has lexical unit" |  | "FN" |  |
| fn:predicting | fn:HasLexicalUnit | fn:lu:predicting:prognosticate | "predicting" | "prognosticate" | "has lexical unit" |  | "FN" |  |
| fn:predicting | fn:HasLexicalUnit | fn:lu:predicting:claim | "predicting" | "claim" | "has lexical unit" |  | "FN" |  |
| fn:predicting | fn:HasLexicalUnit | fn:lu:predicting:soothsay | "predicting" | "soothsay" | "has lexical unit" |  | "FN" |  |
| fn:predicting | fn:HasLexicalUnit | fn:lu:predicting:prophecy | "predicting" | "prophecy" | "has lexical unit" |  | "FN" |  |
| fn:predicting | fn:HasLexicalUnit | fn:lu:predicting:prediction | "predicting" | "prediction" | "has lexical unit" |  | "FN" |  |
| fn:predicting | /r/HasA | fn:fe:speaker | "predicting" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:predicting | /r/HasA | fn:fe:eventuality | "predicting" | "eventuality" | "/r/has a" |  | "FN" |  |
| fn:predicting | /r/HasA | fn:fe:evidence | "predicting" | "evidence" | "/r/has a" |  | "FN" |  |
| fn:predicting | /r/HasA | fn:fe:time | "predicting" | "time" | "/r/has a" |  | "FN" |  |
| fn:predicting | /r/HasA | fn:fe:place | "predicting" | "place" | "/r/has a" |  | "FN" |  |
| fn:predicting | /r/HasA | fn:fe:manner | "predicting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:predicting | /r/HasA | fn:fe:time_of_eventuality | "predicting" | "time of eventuality" | "/r/has a" |  | "FN" |  |
| fn:predicting | /r/HasA | fn:fe:accuracy | "predicting" | "accuracy" | "/r/has a" |  | "FN" |  |
| fn:predicting | /r/HasA | fn:fe:descriptor | "predicting" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:predicting | /r/HasA | fn:fe:medium | "predicting" | "medium" | "/r/has a" |  | "FN" |  |
| fn:predicting | /r/HasA | fn:fe:topic | "predicting" | "topic" | "/r/has a" |  | "FN" |  |
| fn:predicting | /r/HasA | fn:fe:means | "predicting" | "means" | "/r/has a" |  | "FN" |  |
| fn:preference | /r/IsA | fn:desiring | "preference" | "desiring" | "/r/is a" |  | "FN" |  |
| fn:preference | /r/UsedFor | fn:sacrificing_for | "preference" | "sacrificing for" | "/r/used for" |  | "FN" |  |
| fn:preference | fn:HasLexicalUnit | fn:lu:preference:prefer | "preference" | "prefer" | "has lexical unit" |  | "FN" |  |
| fn:preference | fn:HasLexicalUnit | fn:lu:preference:disprefer | "preference" | "disprefer" | "has lexical unit" |  | "FN" |  |
| fn:preference | fn:HasLexicalUnit | fn:lu:preference:favor | "preference" | "favor" | "has lexical unit" |  | "FN" |  |
| fn:preference | /r/HasA | fn:fe:experiencer | "preference" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:preference | /r/HasA | fn:fe:event | "preference" | "event" | "/r/has a" |  | "FN" |  |
| fn:preference | /r/HasA | fn:fe:focal_participant | "preference" | "focal participant" | "/r/has a" |  | "FN" |  |
| fn:preference | /r/HasA | fn:fe:degree | "preference" | "degree" | "/r/has a" |  | "FN" |  |
| fn:preference | /r/HasA | fn:fe:manner | "preference" | "manner" | "/r/has a" |  | "FN" |  |
| fn:preference | /r/HasA | fn:fe:explanation | "preference" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:preference | /r/HasA | fn:fe:purpose_of_event | "preference" | "purpose of event" | "/r/has a" |  | "FN" |  |
| fn:preference | /r/HasA | fn:fe:time_of_event | "preference" | "time of event" | "/r/has a" |  | "FN" |  |
| fn:preference | /r/HasA | fn:fe:location_of_event | "preference" | "location of event" | "/r/has a" |  | "FN" |  |
| fn:preference | /r/HasA | fn:fe:time | "preference" | "time" | "/r/has a" |  | "FN" |  |
| fn:preference | /r/HasA | fn:fe:place | "preference" | "place" | "/r/has a" |  | "FN" |  |
| fn:preference | /r/HasA | fn:fe:duration | "preference" | "duration" | "/r/has a" |  | "FN" |  |
| fn:preference | /r/HasA | fn:fe:contrast | "preference" | "contrast" | "/r/has a" |  | "FN" |  |
| fn:preferred_alternative_scenario | /r/IsA | fn:conditional_scenario | "preferred alternative scenario" | "conditional scenario" | "/r/is a" |  | "FN" |  |
| fn:desirability | /r/UsedFor | fn:preferred_alternative_scenario | "desirability" | "preferred alternative scenario" | "/r/used for" |  | "FN" |  |
| fn:desirable_event | /r/IsA | fn:preferred_alternative_scenario | "desirable event" | "preferred alternative scenario" | "/r/is a" |  | "FN" |  |
| fn:required_event | /r/IsA | fn:preferred_alternative_scenario | "required event" | "preferred alternative scenario" | "/r/is a" |  | "FN" |  |
| fn:preferred_alternative_scenario | /r/HasA | fn:fe:profiled_possibility | "preferred alternative scenario" | "profiled possibility" | "/r/has a" |  | "FN" |  |
| fn:preferred_alternative_scenario | /r/HasA | fn:fe:opposite_possibility | "preferred alternative scenario" | "opposite possibility" | "/r/has a" |  | "FN" |  |
| fn:preferred_alternative_scenario | /r/HasA | fn:fe:positive_consequence | "preferred alternative scenario" | "positive consequence" | "/r/has a" |  | "FN" |  |
| fn:preferred_alternative_scenario | /r/HasA | fn:fe:undesirable_consequence | "preferred alternative scenario" | "undesirable consequence" | "/r/has a" |  | "FN" |  |
| fn:preliminaries | /r/IsA | fn:means | "preliminaries" | "means" | "/r/is a" |  | "FN" |  |
| fn:preliminaries | /r/IsA | fn:activity_prepare | "preliminaries" | "activity prepare" | "/r/is a" |  | "FN" |  |
| fn:preliminaries | fn:HasLexicalUnit | fn:lu:preliminaries:preliminary | "preliminaries" | "preliminary" | "has lexical unit" |  | "FN" |  |
| fn:preliminaries | fn:HasLexicalUnit | fn:lu:preliminaries:preliminary | "preliminaries" | "preliminary" | "has lexical unit" |  | "FN" |  |
| fn:preliminaries | fn:HasLexicalUnit | fn:lu:preliminaries:exploratory | "preliminaries" | "exploratory" | "has lexical unit" |  | "FN" |  |
| fn:preliminaries | fn:HasLexicalUnit | fn:lu:preliminaries:groundwork | "preliminaries" | "groundwork" | "has lexical unit" |  | "FN" |  |
| fn:preliminaries | fn:HasLexicalUnit | fn:lu:preliminaries:prefatory | "preliminaries" | "prefatory" | "has lexical unit" |  | "FN" |  |
| fn:preliminaries | fn:HasLexicalUnit | fn:lu:preliminaries:preparatory | "preliminaries" | "preparatory" | "has lexical unit" |  | "FN" |  |
| fn:preliminaries | /r/HasA | fn:fe:agent | "preliminaries" | "agent" | "/r/has a" |  | "FN" |  |
| fn:fe:preparatory_act | /r/RelatedTo | fn:fe:preparatory_phase | "preparatory act" | "preparatory phase" | "/r/related to" |  | "FN" |  |
| fn:preliminaries | /r/HasA | fn:fe:preparatory_act | "preliminaries" | "preparatory act" | "/r/has a" |  | "FN" |  |
| fn:fe:purpose | /r/IsA | fn:st:goal | "purpose" | "goal" | "/r/is a" |  | "FN" |  |
| fn:preliminaries | /r/HasA | fn:fe:purpose | "preliminaries" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:preliminaries | /r/HasA | fn:fe:descriptor | "preliminaries" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:preliminaries | /r/HasA | fn:fe:degree | "preliminaries" | "degree" | "/r/has a" |  | "FN" |  |
| fn:preliminaries | /r/HasA | fn:fe:domain_of_relevance | "preliminaries" | "domain of relevance" | "/r/has a" |  | "FN" |  |
| fn:preliminaries | /r/HasA | fn:fe:time | "preliminaries" | "time" | "/r/has a" |  | "FN" |  |
| fn:preliminaries | /r/HasA | fn:fe:place | "preliminaries" | "place" | "/r/has a" |  | "FN" |  |
| fn:preliminaries | /r/HasA | fn:fe:preparatory_phase | "preliminaries" | "preparatory phase" | "/r/has a" |  | "FN" |  |
| fn:presence | /r/IsA | fn:being_located | "presence" | "being located" | "/r/is a" |  | "FN" |  |
| fn:existence | /r/RelatedTo | fn:presence | "existence" | "presence" | "/r/related to" |  | "FN" |  |
| fn:presence | fn:HasLexicalUnit | fn:lu:presence:present | "presence" | "present" | "has lexical unit" |  | "FN" |  |
| fn:presence | fn:HasLexicalUnit | fn:lu:presence:presence | "presence" | "presence" | "has lexical unit" |  | "FN" |  |
| fn:presence | fn:HasLexicalUnit | fn:lu:presence:absence | "presence" | "absence" | "has lexical unit" |  | "FN" |  |
| fn:presence | /r/HasA | fn:fe:entity | "presence" | "entity" | "/r/has a" |  | "FN" |  |
| fn:presence | /r/HasA | fn:fe:location | "presence" | "location" | "/r/has a" |  | "FN" |  |
| fn:presence | /r/HasA | fn:fe:time | "presence" | "time" | "/r/has a" |  | "FN" |  |
| fn:presence | /r/HasA | fn:fe:depictive | "presence" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:presence | /r/HasA | fn:fe:duration | "presence" | "duration" | "/r/has a" |  | "FN" |  |
| fn:presence | /r/HasA | fn:fe:purpose | "presence" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:presence | /r/HasA | fn:fe:descriptor | "presence" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:presence | /r/HasA | fn:fe:degree | "presence" | "degree" | "/r/has a" |  | "FN" |  |
| fn:negation | /r/UsedFor | fn:presentation_of_mitigation | "negation" | "presentation of mitigation" | "/r/used for" |  | "FN" |  |
| fn:presentation_of_mitigation | /r/RelatedTo | fn:concessive | "presentation of mitigation" | "concessive" | "/r/related to" |  | "FN" |  |
| fn:presentation_of_mitigation | /r/RelatedTo | fn:conditional_scenario | "presentation of mitigation" | "conditional scenario" | "/r/related to" |  | "FN" |  |
| fn:presentation_of_mitigation | /r/IsA | fn:alternativity | "presentation of mitigation" | "alternativity" | "/r/is a" |  | "FN" |  |
| fn:presentation_of_mitigation | fn:HasLexicalUnit | fn:lu:presentation_of_mitigation:anyway | "presentation of mitigation" | "anyway" | "has lexical unit" |  | "FN" |  |
| fn:presentation_of_mitigation | fn:HasLexicalUnit | fn:lu:presentation_of_mitigation:anyhow | "presentation of mitigation" | "anyhow" | "has lexical unit" |  | "FN" |  |
| fn:presentation_of_mitigation | fn:HasLexicalUnit | fn:lu:presentation_of_mitigation:at_any_rate | "presentation of mitigation" | "at any rate" | "has lexical unit" |  | "FN" |  |
| fn:presentation_of_mitigation | fn:HasLexicalUnit | fn:lu:presentation_of_mitigation:in_any_case | "presentation of mitigation" | "in any case" | "has lexical unit" |  | "FN" |  |
| fn:presentation_of_mitigation | fn:HasLexicalUnit | fn:lu:presentation_of_mitigation:in_any_event | "presentation of mitigation" | "in any event" | "has lexical unit" |  | "FN" |  |
| fn:presentation_of_mitigation | fn:HasLexicalUnit | fn:lu:presentation_of_mitigation:at_a_minimum | "presentation of mitigation" | "at a minimum" | "has lexical unit" |  | "FN" |  |
| fn:presentation_of_mitigation | fn:HasLexicalUnit | fn:lu:presentation_of_mitigation:at_least | "presentation of mitigation" | "at least" | "has lexical unit" |  | "FN" |  |
| fn:presentation_of_mitigation | fn:HasLexicalUnit | fn:lu:presentation_of_mitigation:at_the_least | "presentation of mitigation" | "at the least" | "has lexical unit" |  | "FN" |  |
| fn:presentation_of_mitigation | /r/HasA | fn:fe:mitigating_situation | "presentation of mitigation" | "mitigating situation" | "/r/has a" |  | "FN" |  |
| fn:preserving | /r/IsA | fn:processing_materials | "preserving" | "processing materials" | "/r/is a" |  | "FN" |  |
| fn:preserving | fn:HasLexicalUnit | fn:lu:preserving:mummify | "preserving" | "mummify" | "has lexical unit" |  | "FN" |  |
| fn:preserving | fn:HasLexicalUnit | fn:lu:preserving:pickle | "preserving" | "pickle" | "has lexical unit" |  | "FN" |  |
| fn:preserving | fn:HasLexicalUnit | fn:lu:preserving:embalm | "preserving" | "embalm" | "has lexical unit" |  | "FN" |  |
| fn:preserving | fn:HasLexicalUnit | fn:lu:preserving:salt | "preserving" | "salt" | "has lexical unit" |  | "FN" |  |
| fn:preserving | fn:HasLexicalUnit | fn:lu:preserving:cure | "preserving" | "cure" | "has lexical unit" |  | "FN" |  |
| fn:preserving | fn:HasLexicalUnit | fn:lu:preserving:mummification | "preserving" | "mummification" | "has lexical unit" |  | "FN" |  |
| fn:preserving | fn:HasLexicalUnit | fn:lu:preserving:preservation | "preserving" | "preservation" | "has lexical unit" |  | "FN" |  |
| fn:preserving | fn:HasLexicalUnit | fn:lu:preserving:can | "preserving" | "can" | "has lexical unit" |  | "FN" |  |
| fn:preserving | fn:HasLexicalUnit | fn:lu:preserving:preserve | "preserving" | "preserve" | "has lexical unit" |  | "FN" |  |
| fn:preserving | fn:HasLexicalUnit | fn:lu:preserving:embalming | "preserving" | "embalming" | "has lexical unit" |  | "FN" |  |
| fn:preserving | fn:HasLexicalUnit | fn:lu:preserving:dry | "preserving" | "dry" | "has lexical unit" |  | "FN" |  |
| fn:preserving | /r/HasA | fn:fe:agent | "preserving" | "agent" | "/r/has a" |  | "FN" |  |
| fn:preserving | /r/HasA | fn:fe:medium | "preserving" | "medium" | "/r/has a" |  | "FN" |  |
| fn:preserving | /r/HasA | fn:fe:patient | "preserving" | "patient" | "/r/has a" |  | "FN" |  |
| fn:preserving | /r/HasA | fn:fe:instrument | "preserving" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:preserving | /r/HasA | fn:fe:means | "preserving" | "means" | "/r/has a" |  | "FN" |  |
| fn:preserving | /r/HasA | fn:fe:manner | "preserving" | "manner" | "/r/has a" |  | "FN" |  |
| fn:preserving | /r/HasA | fn:fe:place | "preserving" | "place" | "/r/has a" |  | "FN" |  |
| fn:preserving | /r/HasA | fn:fe:time | "preserving" | "time" | "/r/has a" |  | "FN" |  |
| fn:preserving | /r/HasA | fn:fe:purpose | "preserving" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:preserving | /r/HasA | fn:fe:result | "preserving" | "result" | "/r/has a" |  | "FN" |  |
| fn:preserving | /r/HasA | fn:fe:duration | "preserving" | "duration" | "/r/has a" |  | "FN" |  |
| fn:preserving | /r/HasA | fn:fe:depictive | "preserving" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:preserving | /r/HasA | fn:fe:degree | "preserving" | "degree" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:prevarication | "communication" | "prevarication" | "/r/used for" |  | "FN" |  |
| fn:prevarication | /r/UsedFor | fn:front_for | "prevarication" | "front for" | "/r/used for" |  | "FN" |  |
| fn:prevarication | fn:HasLexicalUnit | fn:lu:prevarication:lie | "prevarication" | "lie" | "has lexical unit" |  | "FN" |  |
| fn:prevarication | fn:HasLexicalUnit | fn:lu:prevarication:prevaricate | "prevarication" | "prevaricate" | "has lexical unit" |  | "FN" |  |
| fn:prevarication | fn:HasLexicalUnit | fn:lu:prevarication:lie | "prevarication" | "lie" | "has lexical unit" |  | "FN" |  |
| fn:prevarication | fn:HasLexicalUnit | fn:lu:prevarication:mislead | "prevarication" | "mislead" | "has lexical unit" |  | "FN" |  |
| fn:prevarication | fn:HasLexicalUnit | fn:lu:prevarication:kid | "prevarication" | "kid" | "has lexical unit" |  | "FN" |  |
| fn:prevarication | fn:HasLexicalUnit | fn:lu:prevarication:misrepresent | "prevarication" | "misrepresent" | "has lexical unit" |  | "FN" |  |
| fn:prevarication | fn:HasLexicalUnit | fn:lu:prevarication:deception | "prevarication" | "deception" | "has lexical unit" |  | "FN" |  |
| fn:prevarication | fn:HasLexicalUnit | fn:lu:prevarication:misrepresentation | "prevarication" | "misrepresentation" | "has lexical unit" |  | "FN" |  |
| fn:prevarication | fn:HasLexicalUnit | fn:lu:prevarication:prevarication | "prevarication" | "prevarication" | "has lexical unit" |  | "FN" |  |
| fn:prevarication | fn:HasLexicalUnit | fn:lu:prevarication:shit | "prevarication" | "shit" | "has lexical unit" |  | "FN" |  |
| fn:prevarication | fn:HasLexicalUnit | fn:lu:prevarication:joke | "prevarication" | "joke" | "has lexical unit" |  | "FN" |  |
| fn:prevarication | fn:HasLexicalUnit | fn:lu:prevarication:equivocate | "prevarication" | "equivocate" | "has lexical unit" |  | "FN" |  |
| fn:prevarication | fn:HasLexicalUnit | fn:lu:prevarication:fool | "prevarication" | "fool" | "has lexical unit" |  | "FN" |  |
| fn:prevarication | fn:HasLexicalUnit | fn:lu:prevarication:equivocation | "prevarication" | "equivocation" | "has lexical unit" |  | "FN" |  |
| fn:prevarication | fn:HasLexicalUnit | fn:lu:prevarication:fib | "prevarication" | "fib" | "has lexical unit" |  | "FN" |  |
| fn:prevarication | fn:HasLexicalUnit | fn:lu:prevarication:bullshit | "prevarication" | "bullshit" | "has lexical unit" |  | "FN" |  |
| fn:prevarication | fn:HasLexicalUnit | fn:lu:prevarication:pull_(someone's)_leg | "prevarication" | "pull (someone\\'s) leg" | "has lexical unit" |  | "FN" |  |
| fn:prevarication | fn:HasLexicalUnit | fn:lu:prevarication:deceive | "prevarication" | "deceive" | "has lexical unit" |  | "FN" |  |
| fn:prevarication | fn:HasLexicalUnit | fn:lu:prevarication:fib | "prevarication" | "fib" | "has lexical unit" |  | "FN" |  |
| fn:prevarication | fn:HasLexicalUnit | fn:lu:prevarication:pull_the_wool_over_(someone's)_eyes | "prevarication" | "pull the wool over (someone\\'s) eyes" | "has lexical unit" |  | "FN" |  |
| fn:prevarication | fn:HasLexicalUnit | fn:lu:prevarication:hoodwink | "prevarication" | "hoodwink" | "has lexical unit" |  | "FN" |  |
| fn:prevarication | fn:HasLexicalUnit | fn:lu:prevarication:bullshit_artist | "prevarication" | "bullshit artist" | "has lexical unit" |  | "FN" |  |
| fn:prevarication | fn:HasLexicalUnit | fn:lu:prevarication:dissemble | "prevarication" | "dissemble" | "has lexical unit" |  | "FN" |  |
| fn:prevarication | fn:HasLexicalUnit | fn:lu:prevarication:dissembler | "prevarication" | "dissembler" | "has lexical unit" |  | "FN" |  |
| fn:prevarication | fn:HasLexicalUnit | fn:lu:prevarication:deceptive | "prevarication" | "deceptive" | "has lexical unit" |  | "FN" |  |
| fn:prevarication | fn:HasLexicalUnit | fn:lu:prevarication:tell | "prevarication" | "tell" | "has lexical unit" |  | "FN" |  |
| fn:prevarication | /r/HasA | fn:fe:speaker | "prevarication" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:prevarication | /r/HasA | fn:fe:addressee | "prevarication" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:prevarication | /r/HasA | fn:fe:topic | "prevarication" | "topic" | "/r/has a" |  | "FN" |  |
| fn:prevarication | /r/HasA | fn:fe:place | "prevarication" | "place" | "/r/has a" |  | "FN" |  |
| fn:prevarication | /r/HasA | fn:fe:time | "prevarication" | "time" | "/r/has a" |  | "FN" |  |
| fn:prevarication | /r/HasA | fn:fe:means | "prevarication" | "means" | "/r/has a" |  | "FN" |  |
| fn:prevarication | /r/HasA | fn:fe:duration | "prevarication" | "duration" | "/r/has a" |  | "FN" |  |
| fn:prevarication | /r/HasA | fn:fe:purpose | "prevarication" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:prevarication | /r/HasA | fn:fe:degree | "prevarication" | "degree" | "/r/has a" |  | "FN" |  |
| fn:prevarication | /r/HasA | fn:fe:frequency | "prevarication" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:prevent_or_allow_possession | /r/IsA | fn:preventing_or_letting | "prevent or allow possession" | "preventing or letting" | "/r/is a" |  | "FN" |  |
| fn:possession | /r/UsedFor | fn:prevent_or_allow_possession | "possession" | "prevent or allow possession" | "/r/used for" |  | "FN" |  |
| fn:prevent_or_allow_possession | fn:HasLexicalUnit | fn:lu:prevent_or_allow_possession:deprive | "prevent or allow possession" | "deprive" | "has lexical unit" |  | "FN" |  |
| fn:prevent_or_allow_possession | fn:HasLexicalUnit | fn:lu:prevent_or_allow_possession:starve | "prevent or allow possession" | "starve" | "has lexical unit" |  | "FN" |  |
| fn:prevent_or_allow_possession | fn:HasLexicalUnit | fn:lu:prevent_or_allow_possession:deny | "prevent or allow possession" | "deny" | "has lexical unit" |  | "FN" |  |
| fn:prevent_or_allow_possession | fn:HasLexicalUnit | fn:lu:prevent_or_allow_possession:allow | "prevent or allow possession" | "allow" | "has lexical unit" |  | "FN" |  |
| fn:prevent_or_allow_possession | fn:HasLexicalUnit | fn:lu:prevent_or_allow_possession:permit | "prevent or allow possession" | "permit" | "has lexical unit" |  | "FN" |  |
| fn:prevent_or_allow_possession | /r/HasA | fn:fe:potential_hindrance | "prevent or allow possession" | "potential hindrance" | "/r/has a" |  | "FN" |  |
| fn:fe:state_of_affairs | /r/IsA | fn:st:state_of_affairs | "state of affairs" | "state of affairs" | "/r/is a" |  | "FN" |  |
| fn:prevent_or_allow_possession | /r/HasA | fn:fe:state_of_affairs | "prevent or allow possession" | "state of affairs" | "/r/has a" |  | "FN" |  |
| fn:prevent_or_allow_possession | /r/HasA | fn:fe:time | "prevent or allow possession" | "time" | "/r/has a" |  | "FN" |  |
| fn:prevent_or_allow_possession | /r/HasA | fn:fe:place | "prevent or allow possession" | "place" | "/r/has a" |  | "FN" |  |
| fn:fe:agent | /r/RelatedTo | fn:fe:potential_hindrance | "agent" | "potential hindrance" | "/r/related to" |  | "FN" |  |
| fn:prevent_or_allow_possession | /r/HasA | fn:fe:agent | "prevent or allow possession" | "agent" | "/r/has a" |  | "FN" |  |
| fn:prevent_or_allow_possession | /r/HasA | fn:fe:protagonist | "prevent or allow possession" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:prevent_or_allow_possession | /r/HasA | fn:fe:purpose | "prevent or allow possession" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:prevent_or_allow_possession | /r/HasA | fn:fe:duration | "prevent or allow possession" | "duration" | "/r/has a" |  | "FN" |  |
| fn:prevent_or_allow_possession | /r/HasA | fn:fe:explanation | "prevent or allow possession" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:prevent_or_allow_possession | /r/HasA | fn:fe:frequency | "prevent or allow possession" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:prevent_or_allow_possession | /r/HasA | fn:fe:containing_event | "prevent or allow possession" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:prevent_or_allow_possession | /r/IsA | fn:preventing_or_letting | "prevent or allow possession" | "preventing or letting" | "/r/is a" |  | "FN" |  |
| fn:self_control | /r/IsA | fn:preventing_or_letting | "self control" | "preventing or letting" | "/r/is a" |  | "FN" |  |
| fn:thwarting | /r/IsA | fn:preventing_or_letting | "thwarting" | "preventing or letting" | "/r/is a" |  | "FN" |  |
| fn:event | /r/UsedFor | fn:preventing_or_letting | "event" | "preventing or letting" | "/r/used for" |  | "FN" |  |
| fn:preventing_or_letting | /r/UsedFor | fn:level_of_force_resistance | "preventing or letting" | "level of force resistance" | "/r/used for" |  | "FN" |  |
| fn:deny_or_grant_permission | /r/SimilarTo | fn:preventing_or_letting | "deny or grant permission" | "preventing or letting" | "/r/similar to" |  | "FN" |  |
| fn:thwarting | /r/SimilarTo | fn:preventing_or_letting | "thwarting" | "preventing or letting" | "/r/similar to" |  | "FN" |  |
| fn:preventing_or_letting | /r/IsA | fn:causation_scenario | "preventing or letting" | "causation scenario" | "/r/is a" |  | "FN" |  |
| fn:preventing_or_letting | /r/SimilarTo | fn:deny_or_grant_permission | "preventing or letting" | "deny or grant permission" | "/r/similar to" |  | "FN" |  |
| fn:preventing_or_letting | fn:HasLexicalUnit | fn:lu:preventing_or_letting:prevent | "preventing or letting" | "prevent" | "has lexical unit" |  | "FN" |  |
| fn:preventing_or_letting | fn:HasLexicalUnit | fn:lu:preventing_or_letting:avert | "preventing or letting" | "avert" | "has lexical unit" |  | "FN" |  |
| fn:preventing_or_letting | fn:HasLexicalUnit | fn:lu:preventing_or_letting:frustrate | "preventing or letting" | "frustrate" | "has lexical unit" |  | "FN" |  |
| fn:preventing_or_letting | fn:HasLexicalUnit | fn:lu:preventing_or_letting:nip_in_the_bud | "preventing or letting" | "nip in the bud" | "has lexical unit" |  | "FN" |  |
| fn:preventing_or_letting | fn:HasLexicalUnit | fn:lu:preventing_or_letting:obviate | "preventing or letting" | "obviate" | "has lexical unit" |  | "FN" |  |
| fn:preventing_or_letting | fn:HasLexicalUnit | fn:lu:preventing_or_letting:stave_off | "preventing or letting" | "stave off" | "has lexical unit" |  | "FN" |  |
| fn:preventing_or_letting | fn:HasLexicalUnit | fn:lu:preventing_or_letting:check | "preventing or letting" | "check" | "has lexical unit" |  | "FN" |  |
| fn:preventing_or_letting | fn:HasLexicalUnit | fn:lu:preventing_or_letting:avoid | "preventing or letting" | "avoid" | "has lexical unit" |  | "FN" |  |
| fn:preventing_or_letting | fn:HasLexicalUnit | fn:lu:preventing_or_letting:prevention | "preventing or letting" | "prevention" | "has lexical unit" |  | "FN" |  |
| fn:preventing_or_letting | fn:HasLexicalUnit | fn:lu:preventing_or_letting:stopping | "preventing or letting" | "stopping" | "has lexical unit" |  | "FN" |  |
| fn:preventing_or_letting | fn:HasLexicalUnit | fn:lu:preventing_or_letting:prohibit | "preventing or letting" | "prohibit" | "has lexical unit" |  | "FN" |  |
| fn:preventing_or_letting | fn:HasLexicalUnit | fn:lu:preventing_or_letting:stop | "preventing or letting" | "stop" | "has lexical unit" |  | "FN" |  |
| fn:preventing_or_letting | fn:HasLexicalUnit | fn:lu:preventing_or_letting:upset | "preventing or letting" | "upset" | "has lexical unit" |  | "FN" |  |
| fn:preventing_or_letting | fn:HasLexicalUnit | fn:lu:preventing_or_letting:keep_(from) | "preventing or letting" | "keep (from)" | "has lexical unit" |  | "FN" |  |
| fn:preventing_or_letting | fn:HasLexicalUnit | fn:lu:preventing_or_letting:preempt | "preventing or letting" | "preempt" | "has lexical unit" |  | "FN" |  |
| fn:preventing_or_letting | fn:HasLexicalUnit | fn:lu:preventing_or_letting:preemption | "preventing or letting" | "preemption" | "has lexical unit" |  | "FN" |  |
| fn:preventing_or_letting | fn:HasLexicalUnit | fn:lu:preventing_or_letting:preemptive | "preventing or letting" | "preemptive" | "has lexical unit" |  | "FN" |  |
| fn:preventing_or_letting | fn:HasLexicalUnit | fn:lu:preventing_or_letting:allow | "preventing or letting" | "allow" | "has lexical unit" |  | "FN" |  |
| fn:preventing_or_letting | fn:HasLexicalUnit | fn:lu:preventing_or_letting:let | "preventing or letting" | "let" | "has lexical unit" |  | "FN" |  |
| fn:preventing_or_letting | fn:HasLexicalUnit | fn:lu:preventing_or_letting:permit | "preventing or letting" | "permit" | "has lexical unit" |  | "FN" |  |
| fn:preventing_or_letting | fn:HasLexicalUnit | fn:lu:preventing_or_letting:enable | "preventing or letting" | "enable" | "has lexical unit" |  | "FN" |  |
| fn:preventing_or_letting | fn:HasLexicalUnit | fn:lu:preventing_or_letting:enablement | "preventing or letting" | "enablement" | "has lexical unit" |  | "FN" |  |
| fn:preventing_or_letting | fn:HasLexicalUnit | fn:lu:preventing_or_letting:forestall | "preventing or letting" | "forestall" | "has lexical unit" |  | "FN" |  |
| fn:preventing_or_letting | fn:HasLexicalUnit | fn:lu:preventing_or_letting:preclude | "preventing or letting" | "preclude" | "has lexical unit" |  | "FN" |  |
| fn:preventing_or_letting | /r/HasA | fn:fe:potential_hindrance | "preventing or letting" | "potential hindrance" | "/r/has a" |  | "FN" |  |
| fn:preventing_or_letting | /r/HasA | fn:fe:event | "preventing or letting" | "event" | "/r/has a" |  | "FN" |  |
| fn:preventing_or_letting | /r/HasA | fn:fe:time | "preventing or letting" | "time" | "/r/has a" |  | "FN" |  |
| fn:preventing_or_letting | /r/HasA | fn:fe:place | "preventing or letting" | "place" | "/r/has a" |  | "FN" |  |
| fn:preventing_or_letting | /r/HasA | fn:fe:agent | "preventing or letting" | "agent" | "/r/has a" |  | "FN" |  |
| fn:preventing_or_letting | /r/HasA | fn:fe:degree | "preventing or letting" | "degree" | "/r/has a" |  | "FN" |  |
| fn:preventing_or_letting | /r/HasA | fn:fe:circumstances | "preventing or letting" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:preventing_or_letting | /r/HasA | fn:fe:manner | "preventing or letting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:preventing_or_letting | /r/HasA | fn:fe:means | "preventing or letting" | "means" | "/r/has a" |  | "FN" |  |
| fn:preventing_or_letting | /r/HasA | fn:fe:event_description | "preventing or letting" | "event description" | "/r/has a" |  | "FN" |  |
| fn:preventing_or_letting | /r/HasA | fn:fe:depictive | "preventing or letting" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:preventing_or_letting | /r/HasA | fn:fe:period_of_iterations | "preventing or letting" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:preventing_or_letting | /r/HasA | fn:fe:allowed_category | "preventing or letting" | "allowed category" | "/r/has a" |  | "FN" |  |
| fn:preventing_or_letting | /r/HasA | fn:fe:explanation | "preventing or letting" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:preventing_or_letting | /r/HasA | fn:fe:frequency | "preventing or letting" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:preventing_or_letting | /r/HasA | fn:fe:purpose | "preventing or letting" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:price_per_unit | /r/IsA | fn:relational_quantity | "price per unit" | "relational quantity" | "/r/is a" |  | "FN" |  |
| fn:price_per_unit | fn:HasLexicalUnit | fn:lu:price_per_unit:rate | "price per unit" | "rate" | "has lexical unit" |  | "FN" |  |
| fn:price_per_unit | /r/HasA | fn:fe:product | "price per unit" | "product" | "/r/has a" |  | "FN" |  |
| fn:price_per_unit | /r/HasA | fn:fe:price | "price per unit" | "price" | "/r/has a" |  | "FN" |  |
| fn:price_per_unit | /r/HasA | fn:fe:seller | "price per unit" | "seller" | "/r/has a" |  | "FN" |  |
| fn:price_per_unit | /r/HasA | fn:fe:buyer | "price per unit" | "buyer" | "/r/has a" |  | "FN" |  |
| fn:price_per_unit | /r/HasA | fn:fe:descriptor | "price per unit" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:prison | /r/IsA | fn:locale_by_use | "prison" | "locale by use" | "/r/is a" |  | "FN" |  |
| fn:inhibit_movement | /r/UsedFor | fn:prison | "inhibit movement" | "prison" | "/r/used for" |  | "FN" |  |
| fn:prison | fn:HasLexicalUnit | fn:lu:prison:penitentiary | "prison" | "penitentiary" | "has lexical unit" |  | "FN" |  |
| fn:prison | fn:HasLexicalUnit | fn:lu:prison:jail | "prison" | "jail" | "has lexical unit" |  | "FN" |  |
| fn:prison | fn:HasLexicalUnit | fn:lu:prison:prison | "prison" | "prison" | "has lexical unit" |  | "FN" |  |
| fn:prison | fn:HasLexicalUnit | fn:lu:prison:jailhouse | "prison" | "jailhouse" | "has lexical unit" |  | "FN" |  |
| fn:prison | fn:HasLexicalUnit | fn:lu:prison:slammer | "prison" | "slammer" | "has lexical unit" |  | "FN" |  |
| fn:prison | fn:HasLexicalUnit | fn:lu:prison:stockade | "prison" | "stockade" | "has lexical unit" |  | "FN" |  |
| fn:prison | fn:HasLexicalUnit | fn:lu:prison:pen | "prison" | "pen" | "has lexical unit" |  | "FN" |  |
| fn:prison | fn:HasLexicalUnit | fn:lu:prison:joint | "prison" | "joint" | "has lexical unit" |  | "FN" |  |
| fn:prison | fn:HasLexicalUnit | fn:lu:prison:correctional_institution | "prison" | "correctional institution" | "has lexical unit" |  | "FN" |  |
| fn:prison | fn:HasLexicalUnit | fn:lu:prison:brig | "prison" | "brig" | "has lexical unit" |  | "FN" |  |
| fn:prison | /r/HasA | fn:fe:operator | "prison" | "operator" | "/r/has a" |  | "FN" |  |
| fn:prison | /r/HasA | fn:fe:inmates | "prison" | "inmates" | "/r/has a" |  | "FN" |  |
| fn:prison | /r/HasA | fn:fe:name | "prison" | "name" | "/r/has a" |  | "FN" |  |
| fn:prison | /r/HasA | fn:fe:location | "prison" | "location" | "/r/has a" |  | "FN" |  |
| fn:prison | /r/HasA | fn:fe:security | "prison" | "security" | "/r/has a" |  | "FN" |  |
| fn:fe:penal_institution | /r/IsA | fn:st:goal | "penal institution" | "goal" | "/r/is a" |  | "FN" |  |
| fn:prison | /r/HasA | fn:fe:penal_institution | "prison" | "penal institution" | "/r/has a" |  | "FN" |  |
| fn:prison | /r/HasA | fn:fe:part | "prison" | "part" | "/r/has a" |  | "FN" |  |
| fn:prison | /r/HasA | fn:fe:descriptor | "prison" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:position_on_a_scale | /r/UsedFor | fn:probability | "position on a scale" | "probability" | "/r/used for" |  | "FN" |  |
| fn:probability | fn:HasLexicalUnit | fn:lu:probability:chance | "probability" | "chance" | "has lexical unit" |  | "FN" |  |
| fn:probability | fn:HasLexicalUnit | fn:lu:probability:odds | "probability" | "odds" | "has lexical unit" |  | "FN" |  |
| fn:probability | fn:HasLexicalUnit | fn:lu:probability:probability | "probability" | "probability" | "has lexical unit" |  | "FN" |  |
| fn:probability | fn:HasLexicalUnit | fn:lu:probability:likelihood | "probability" | "likelihood" | "has lexical unit" |  | "FN" |  |
| fn:probability | fn:HasLexicalUnit | fn:lu:probability:significance | "probability" | "significance" | "has lexical unit" |  | "FN" |  |
| fn:probability | fn:HasLexicalUnit | fn:lu:probability:chances | "probability" | "chances" | "has lexical unit" |  | "FN" |  |
| fn:probability | /r/HasA | fn:fe:odds | "probability" | "odds" | "/r/has a" |  | "FN" |  |
| fn:probability | /r/HasA | fn:fe:position | "probability" | "position" | "/r/has a" |  | "FN" |  |
| fn:probability | /r/HasA | fn:fe:hypothetical_event | "probability" | "hypothetical event" | "/r/has a" |  | "FN" |  |
| fn:activity | /r/IsA | fn:process | "activity" | "process" | "/r/is a" |  | "FN" |  |
| fn:arraignment | /r/IsA | fn:process | "arraignment" | "process" | "/r/is a" |  | "FN" |  |
| fn:precipitation | /r/IsA | fn:process | "precipitation" | "process" | "/r/is a" |  | "FN" |  |
| fn:process | /r/HasSubevent | fn:process_completed_state | "process" | "process completed state" | "/r/has subevent" |  | "FN" |  |
| fn:process | /r/HasSubevent | fn:process_continue | "process" | "process continue" | "/r/has subevent" |  | "FN" |  |
| fn:process | /r/HasSubevent | fn:process_end | "process" | "process end" | "/r/has subevent" |  | "FN" |  |
| fn:process | /r/HasSubevent | fn:process_initial_state | "process" | "process initial state" | "/r/has subevent" |  | "FN" |  |
| fn:process | /r/HasSubevent | fn:process_pause | "process" | "process pause" | "/r/has subevent" |  | "FN" |  |
| fn:process | /r/HasSubevent | fn:process_resume | "process" | "process resume" | "/r/has subevent" |  | "FN" |  |
| fn:process | /r/HasSubevent | fn:process_start | "process" | "process start" | "/r/has subevent" |  | "FN" |  |
| fn:process | /r/HasSubevent | fn:process_stop | "process" | "process stop" | "/r/has subevent" |  | "FN" |  |
| fn:process | /r/HasSubevent | fn:process_stopped_state | "process" | "process stopped state" | "/r/has subevent" |  | "FN" |  |
| fn:process | /r/HasSubevent | fn:process_uncompleted_state | "process" | "process uncompleted state" | "/r/has subevent" |  | "FN" |  |
| fn:process | /r/UsedFor | fn:progression | "process" | "progression" | "/r/used for" |  | "FN" |  |
| fn:process | /r/UsedFor | fn:temporal_pattern | "process" | "temporal pattern" | "/r/used for" |  | "FN" |  |
| fn:process | fn:HasLexicalUnit | fn:lu:process:process | "process" | "process" | "has lexical unit" |  | "FN" |  |
| fn:process | /r/HasA | fn:fe:explanation | "process" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:process | /r/HasA | fn:fe:process | "process" | "process" | "/r/has a" |  | "FN" |  |
| fn:process | /r/HasA | fn:fe:place | "process" | "place" | "/r/has a" |  | "FN" |  |
| fn:process | /r/HasA | fn:fe:time | "process" | "time" | "/r/has a" |  | "FN" |  |
| fn:process | /r/HasA | fn:fe:manner | "process" | "manner" | "/r/has a" |  | "FN" |  |
| fn:process | /r/HasA | fn:fe:result | "process" | "result" | "/r/has a" |  | "FN" |  |
| fn:process | /r/HasA | fn:fe:duration | "process" | "duration" | "/r/has a" |  | "FN" |  |
| fn:activity_done_state | /r/IsA | fn:process_completed_state | "activity done state" | "process completed state" | "/r/is a" |  | "FN" |  |
| fn:process_completed_state | /r/IsA | fn:state | "process completed state" | "state" | "/r/is a" |  | "FN" |  |
| fn:process | /r/HasSubevent | fn:process_completed_state | "process" | "process completed state" | "/r/has subevent" |  | "FN" |  |
| fn:process_completed_state | /r/HasPrerequisite | fn:process_end | "process completed state" | "process end" | "/r/has prerequisite" |  | "FN" |  |
| fn:process_completed_state | fn:HasLexicalUnit | fn:lu:process_completed_state:done | "process completed state" | "done" | "has lexical unit" |  | "FN" |  |
| fn:process_completed_state | fn:HasLexicalUnit | fn:lu:process_completed_state:finished | "process completed state" | "finished" | "has lexical unit" |  | "FN" |  |
| fn:process_completed_state | fn:HasLexicalUnit | fn:lu:process_completed_state:complete | "process completed state" | "complete" | "has lexical unit" |  | "FN" |  |
| fn:process_completed_state | fn:HasLexicalUnit | fn:lu:process_completed_state:over | "process completed state" | "over" | "has lexical unit" |  | "FN" |  |
| fn:process_completed_state | /r/HasA | fn:fe:place | "process completed state" | "place" | "/r/has a" |  | "FN" |  |
| fn:process_completed_state | /r/HasA | fn:fe:process | "process completed state" | "process" | "/r/has a" |  | "FN" |  |
| fn:process_completed_state | /r/HasA | fn:fe:time | "process completed state" | "time" | "/r/has a" |  | "FN" |  |
| fn:activity_ongoing | /r/IsA | fn:process_continue | "activity ongoing" | "process continue" | "/r/is a" |  | "FN" |  |
| fn:sleep | /r/IsA | fn:process_continue | "sleep" | "process continue" | "/r/is a" |  | "FN" |  |
| fn:process | /r/HasSubevent | fn:process_continue | "process" | "process continue" | "/r/has subevent" |  | "FN" |  |
| fn:process_start | /r/Causes | fn:process_continue | "process start" | "process continue" | "/r/causes" |  | "FN" |  |
| fn:cause_to_continue | /r/Causes | fn:process_continue | "cause to continue" | "process continue" | "/r/causes" |  | "FN" |  |
| fn:process_end | /r/HasPrerequisite | fn:process_continue | "process end" | "process continue" | "/r/has prerequisite" |  | "FN" |  |
| fn:process_pause | /r/HasPrerequisite | fn:process_continue | "process pause" | "process continue" | "/r/has prerequisite" |  | "FN" |  |
| fn:process_stop | /r/HasPrerequisite | fn:process_continue | "process stop" | "process continue" | "/r/has prerequisite" |  | "FN" |  |
| fn:process_continue | /r/HasPrerequisite | fn:process_resume | "process continue" | "process resume" | "/r/has prerequisite" |  | "FN" |  |
| fn:process_continue | /r/HasPrerequisite | fn:process_start | "process continue" | "process start" | "/r/has prerequisite" |  | "FN" |  |
| fn:process_continue | /r/IsA | fn:delimited_state_scenario | "process continue" | "delimited state scenario" | "/r/is a" |  | "FN" |  |
| fn:process_continue | fn:HasLexicalUnit | fn:lu:process_continue:continue | "process continue" | "continue" | "has lexical unit" |  | "FN" |  |
| fn:process_continue | fn:HasLexicalUnit | fn:lu:process_continue:ongoing | "process continue" | "ongoing" | "has lexical unit" |  | "FN" |  |
| fn:process_continue | fn:HasLexicalUnit | fn:lu:process_continue:persist | "process continue" | "persist" | "has lexical unit" |  | "FN" |  |
| fn:process_continue | fn:HasLexicalUnit | fn:lu:process_continue:drag_on | "process continue" | "drag on" | "has lexical unit" |  | "FN" |  |
| fn:process_continue | fn:HasLexicalUnit | fn:lu:process_continue:go_on | "process continue" | "go on" | "has lexical unit" |  | "FN" |  |
| fn:process_continue | fn:HasLexicalUnit | fn:lu:process_continue:persistence | "process continue" | "persistence" | "has lexical unit" |  | "FN" |  |
| fn:process_continue | fn:HasLexicalUnit | fn:lu:process_continue:proceed | "process continue" | "proceed" | "has lexical unit" |  | "FN" |  |
| fn:process_continue | fn:HasLexicalUnit | fn:lu:process_continue:underway | "process continue" | "underway" | "has lexical unit" |  | "FN" |  |
| fn:process_continue | fn:HasLexicalUnit | fn:lu:process_continue:on | "process continue" | "on" | "has lexical unit" |  | "FN" |  |
| fn:process_continue | /r/HasA | fn:fe:depictive | "process continue" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:process_continue | /r/HasA | fn:fe:manner | "process continue" | "manner" | "/r/has a" |  | "FN" |  |
| fn:process_continue | /r/HasA | fn:fe:duration | "process continue" | "duration" | "/r/has a" |  | "FN" |  |
| fn:process_continue | /r/HasA | fn:fe:event | "process continue" | "event" | "/r/has a" |  | "FN" |  |
| fn:process_continue | /r/HasA | fn:fe:place | "process continue" | "place" | "/r/has a" |  | "FN" |  |
| fn:process_continue | /r/HasA | fn:fe:explanation | "process continue" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:process_continue | /r/HasA | fn:fe:time | "process continue" | "time" | "/r/has a" |  | "FN" |  |
| fn:process_continue | /r/HasA | fn:fe:next_subevent | "process continue" | "next subevent" | "/r/has a" |  | "FN" |  |
| fn:process_continue | /r/HasA | fn:fe:circumstances | "process continue" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:process_continue | /r/HasA | fn:fe:concessive | "process continue" | "concessive" | "/r/has a" |  | "FN" |  |
| fn:process_end | /r/IsA | fn:event | "process end" | "event" | "/r/is a" |  | "FN" |  |
| fn:activity_finish | /r/IsA | fn:process_end | "activity finish" | "process end" | "/r/is a" |  | "FN" |  |
| fn:process | /r/HasSubevent | fn:process_end | "process" | "process end" | "/r/has subevent" |  | "FN" |  |
| fn:cause_to_end | /r/Causes | fn:process_end | "cause to end" | "process end" | "/r/causes" |  | "FN" |  |
| fn:process_end | /r/HasPrerequisite | fn:process_continue | "process end" | "process continue" | "/r/has prerequisite" |  | "FN" |  |
| fn:process_completed_state | /r/HasPrerequisite | fn:process_end | "process completed state" | "process end" | "/r/has prerequisite" |  | "FN" |  |
| fn:process_end | fn:HasLexicalUnit | fn:lu:process_end:end | "process end" | "end" | "has lexical unit" |  | "FN" |  |
| fn:process_end | fn:HasLexicalUnit | fn:lu:process_end:come_to_a_end | "process end" | "come to a end" | "has lexical unit" |  | "FN" |  |
| fn:process_end | fn:HasLexicalUnit | fn:lu:process_end:come_to_a_close | "process end" | "come to a close" | "has lexical unit" |  | "FN" |  |
| fn:process_end | fn:HasLexicalUnit | fn:lu:process_end:conclude | "process end" | "conclude" | "has lexical unit" |  | "FN" |  |
| fn:process_end | fn:HasLexicalUnit | fn:lu:process_end:draw_to_a_close | "process end" | "draw to a close" | "has lexical unit" |  | "FN" |  |
| fn:process_end | fn:HasLexicalUnit | fn:lu:process_end:draw_to_a_end | "process end" | "draw to a end" | "has lexical unit" |  | "FN" |  |
| fn:process_end | fn:HasLexicalUnit | fn:lu:process_end:end_[cessation] | "process end" | "end [cessation]" | "has lexical unit" |  | "FN" |  |
| fn:process_end | fn:HasLexicalUnit | fn:lu:process_end:end_[final-subevent] | "process end" | "end [final-subevent]" | "has lexical unit" |  | "FN" |  |
| fn:process_end | fn:HasLexicalUnit | fn:lu:process_end:final | "process end" | "final" | "has lexical unit" |  | "FN" |  |
| fn:process_end | fn:HasLexicalUnit | fn:lu:process_end:finale | "process end" | "finale" | "has lexical unit" |  | "FN" |  |
| fn:process_end | fn:HasLexicalUnit | fn:lu:process_end:pass | "process end" | "pass" | "has lexical unit" |  | "FN" |  |
| fn:process_end | fn:HasLexicalUnit | fn:lu:process_end:end | "process end" | "end" | "has lexical unit" |  | "FN" |  |
| fn:process_end | /r/HasA | fn:fe:process | "process end" | "process" | "/r/has a" |  | "FN" |  |
| fn:process_end | /r/HasA | fn:fe:final_subevent | "process end" | "final subevent" | "/r/has a" |  | "FN" |  |
| fn:process_end | /r/HasA | fn:fe:place | "process end" | "place" | "/r/has a" |  | "FN" |  |
| fn:process_end | /r/HasA | fn:fe:explanation | "process end" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:process_end | /r/HasA | fn:fe:time | "process end" | "time" | "/r/has a" |  | "FN" |  |
| fn:process_end | /r/HasA | fn:fe:degree | "process end" | "degree" | "/r/has a" |  | "FN" |  |
| fn:process_end | /r/HasA | fn:fe:depictive | "process end" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:process_end | /r/HasA | fn:fe:manner | "process end" | "manner" | "/r/has a" |  | "FN" |  |
| fn:process_end | /r/HasA | fn:fe:result | "process end" | "result" | "/r/has a" |  | "FN" |  |
| fn:process_end | /r/HasA | fn:fe:frequency | "process end" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:process_end | /r/HasA | fn:fe:duration | "process end" | "duration" | "/r/has a" |  | "FN" |  |
| fn:activity_ready_state | /r/IsA | fn:process_initial_state | "activity ready state" | "process initial state" | "/r/is a" |  | "FN" |  |
| fn:process_initial_state | /r/IsA | fn:state | "process initial state" | "state" | "/r/is a" |  | "FN" |  |
| fn:process | /r/HasSubevent | fn:process_initial_state | "process" | "process initial state" | "/r/has subevent" |  | "FN" |  |
| fn:process_start | /r/HasPrerequisite | fn:process_initial_state | "process start" | "process initial state" | "/r/has prerequisite" |  | "FN" |  |
| fn:process_initial_state | /r/HasA | fn:fe:process | "process initial state" | "process" | "/r/has a" |  | "FN" |  |
| fn:process_initial_state | /r/HasA | fn:fe:time | "process initial state" | "time" | "/r/has a" |  | "FN" |  |
| fn:process_initial_state | /r/HasA | fn:fe:duration | "process initial state" | "duration" | "/r/has a" |  | "FN" |  |
| fn:process_pause | /r/IsA | fn:event | "process pause" | "event" | "/r/is a" |  | "FN" |  |
| fn:activity_pause | /r/IsA | fn:process_pause | "activity pause" | "process pause" | "/r/is a" |  | "FN" |  |
| fn:process | /r/HasSubevent | fn:process_pause | "process" | "process pause" | "/r/has subevent" |  | "FN" |  |
| fn:interrupt_process | /r/Causes | fn:process_pause | "interrupt process" | "process pause" | "/r/causes" |  | "FN" |  |
| fn:process_pause | /r/HasPrerequisite | fn:process_continue | "process pause" | "process continue" | "/r/has prerequisite" |  | "FN" |  |
| fn:process_stopped_state | /r/HasPrerequisite | fn:process_pause | "process stopped state" | "process pause" | "/r/has prerequisite" |  | "FN" |  |
| fn:process_pause | /r/HasA | fn:fe:process | "process pause" | "process" | "/r/has a" |  | "FN" |  |
| fn:process_pause | /r/HasA | fn:fe:place | "process pause" | "place" | "/r/has a" |  | "FN" |  |
| fn:process_pause | /r/HasA | fn:fe:time | "process pause" | "time" | "/r/has a" |  | "FN" |  |
| fn:process_pause | /r/HasA | fn:fe:degree | "process pause" | "degree" | "/r/has a" |  | "FN" |  |
| fn:process_pause | /r/HasA | fn:fe:depictive | "process pause" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:process_pause | /r/HasA | fn:fe:manner | "process pause" | "manner" | "/r/has a" |  | "FN" |  |
| fn:process_pause | /r/HasA | fn:fe:result | "process pause" | "result" | "/r/has a" |  | "FN" |  |
| fn:process_pause | /r/HasA | fn:fe:final_subevent | "process pause" | "final subevent" | "/r/has a" |  | "FN" |  |
| fn:process_pause | /r/HasA | fn:fe:explanation | "process pause" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:process_pause | /r/HasA | fn:fe:duration | "process pause" | "duration" | "/r/has a" |  | "FN" |  |
| fn:process_pause | /r/HasA | fn:fe:iterations | "process pause" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:process_resume | /r/IsA | fn:event | "process resume" | "event" | "/r/is a" |  | "FN" |  |
| fn:activity_resume | /r/IsA | fn:process_resume | "activity resume" | "process resume" | "/r/is a" |  | "FN" |  |
| fn:process | /r/HasSubevent | fn:process_resume | "process" | "process resume" | "/r/has subevent" |  | "FN" |  |
| fn:cause_to_resume | /r/Causes | fn:process_resume | "cause to resume" | "process resume" | "/r/causes" |  | "FN" |  |
| fn:process_continue | /r/HasPrerequisite | fn:process_resume | "process continue" | "process resume" | "/r/has prerequisite" |  | "FN" |  |
| fn:process_resume | /r/HasPrerequisite | fn:process_stopped_state | "process resume" | "process stopped state" | "/r/has prerequisite" |  | "FN" |  |
| fn:process_resume | fn:HasLexicalUnit | fn:lu:process_resume:resume | "process resume" | "resume" | "has lexical unit" |  | "FN" |  |
| fn:process_resume | fn:HasLexicalUnit | fn:lu:process_resume:restart | "process resume" | "restart" | "has lexical unit" |  | "FN" |  |
| fn:process_resume | /r/HasA | fn:fe:duration | "process resume" | "duration" | "/r/has a" |  | "FN" |  |
| fn:process_resume | /r/HasA | fn:fe:process | "process resume" | "process" | "/r/has a" |  | "FN" |  |
| fn:process_resume | /r/HasA | fn:fe:place | "process resume" | "place" | "/r/has a" |  | "FN" |  |
| fn:process_resume | /r/HasA | fn:fe:explanation | "process resume" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:process_resume | /r/HasA | fn:fe:time | "process resume" | "time" | "/r/has a" |  | "FN" |  |
| fn:process_resume | /r/HasA | fn:fe:frequency | "process resume" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:process_resume | /r/HasA | fn:fe:manner | "process resume" | "manner" | "/r/has a" |  | "FN" |  |
| fn:process_start | /r/IsA | fn:event | "process start" | "event" | "/r/is a" |  | "FN" |  |
| fn:activity_start | /r/IsA | fn:process_start | "activity start" | "process start" | "/r/is a" |  | "FN" |  |
| fn:come_into_effect | /r/IsA | fn:process_start | "come into effect" | "process start" | "/r/is a" |  | "FN" |  |
| fn:process | /r/HasSubevent | fn:process_start | "process" | "process start" | "/r/has subevent" |  | "FN" |  |
| fn:transition_to_a_situation | /r/RelatedTo | fn:process_start | "transition to a situation" | "process start" | "/r/related to" |  | "FN" |  |
| fn:process_start | /r/Causes | fn:process_continue | "process start" | "process continue" | "/r/causes" |  | "FN" |  |
| fn:cause_to_start | /r/Causes | fn:process_start | "cause to start" | "process start" | "/r/causes" |  | "FN" |  |
| fn:process_start | /r/HasPrerequisite | fn:process_initial_state | "process start" | "process initial state" | "/r/has prerequisite" |  | "FN" |  |
| fn:process_continue | /r/HasPrerequisite | fn:process_start | "process continue" | "process start" | "/r/has prerequisite" |  | "FN" |  |
| fn:process_start | fn:HasLexicalUnit | fn:lu:process_start:start | "process start" | "start" | "has lexical unit" |  | "FN" |  |
| fn:process_start | fn:HasLexicalUnit | fn:lu:process_start:begin | "process start" | "begin" | "has lexical unit" |  | "FN" |  |
| fn:process_start | fn:HasLexicalUnit | fn:lu:process_start:commence | "process start" | "commence" | "has lexical unit" |  | "FN" |  |
| fn:process_start | fn:HasLexicalUnit | fn:lu:process_start:erupt | "process start" | "erupt" | "has lexical unit" |  | "FN" |  |
| fn:process_start | fn:HasLexicalUnit | fn:lu:process_start:break_out | "process start" | "break out" | "has lexical unit" |  | "FN" |  |
| fn:process_start | fn:HasLexicalUnit | fn:lu:process_start:commencement | "process start" | "commencement" | "has lexical unit" |  | "FN" |  |
| fn:process_start | fn:HasLexicalUnit | fn:lu:process_start:incipient | "process start" | "incipient" | "has lexical unit" |  | "FN" |  |
| fn:process_start | fn:HasLexicalUnit | fn:lu:process_start:onset | "process start" | "onset" | "has lexical unit" |  | "FN" |  |
| fn:process_start | fn:HasLexicalUnit | fn:lu:process_start:nascent | "process start" | "nascent" | "has lexical unit" |  | "FN" |  |
| fn:process_start | fn:HasLexicalUnit | fn:lu:process_start:eruption | "process start" | "eruption" | "has lexical unit" |  | "FN" |  |
| fn:process_start | /r/HasA | fn:fe:event | "process start" | "event" | "/r/has a" |  | "FN" |  |
| fn:process_start | /r/HasA | fn:fe:place | "process start" | "place" | "/r/has a" |  | "FN" |  |
| fn:process_start | /r/HasA | fn:fe:explanation | "process start" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:process_start | /r/HasA | fn:fe:time | "process start" | "time" | "/r/has a" |  | "FN" |  |
| fn:process_start | /r/HasA | fn:fe:initial_subevent | "process start" | "initial subevent" | "/r/has a" |  | "FN" |  |
| fn:process_start | /r/HasA | fn:fe:depictive | "process start" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:process_start | /r/HasA | fn:fe:manner | "process start" | "manner" | "/r/has a" |  | "FN" |  |
| fn:process_start | /r/HasA | fn:fe:result | "process start" | "result" | "/r/has a" |  | "FN" |  |
| fn:process_start | /r/HasA | fn:fe:duration | "process start" | "duration" | "/r/has a" |  | "FN" |  |
| fn:process_start | /r/HasA | fn:fe:frequency | "process start" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:process_stop | /r/IsA | fn:event | "process stop" | "event" | "/r/is a" |  | "FN" |  |
| fn:activity_stop | /r/IsA | fn:process_stop | "activity stop" | "process stop" | "/r/is a" |  | "FN" |  |
| fn:process | /r/HasSubevent | fn:process_stop | "process" | "process stop" | "/r/has subevent" |  | "FN" |  |
| fn:process_stop | /r/HasPrerequisite | fn:process_continue | "process stop" | "process continue" | "/r/has prerequisite" |  | "FN" |  |
| fn:process_stopped_state | /r/HasPrerequisite | fn:process_stop | "process stopped state" | "process stop" | "/r/has prerequisite" |  | "FN" |  |
| fn:process_uncompleted_state | /r/HasPrerequisite | fn:process_stop | "process uncompleted state" | "process stop" | "/r/has prerequisite" |  | "FN" |  |
| fn:process_stop | fn:HasLexicalUnit | fn:lu:process_stop:stop | "process stop" | "stop" | "has lexical unit" |  | "FN" |  |
| fn:process_stop | fn:HasLexicalUnit | fn:lu:process_stop:discontinue | "process stop" | "discontinue" | "has lexical unit" |  | "FN" |  |
| fn:process_stop | fn:HasLexicalUnit | fn:lu:process_stop:desist | "process stop" | "desist" | "has lexical unit" |  | "FN" |  |
| fn:process_stop | fn:HasLexicalUnit | fn:lu:process_stop:quit | "process stop" | "quit" | "has lexical unit" |  | "FN" |  |
| fn:process_stop | fn:HasLexicalUnit | fn:lu:process_stop:cease | "process stop" | "cease" | "has lexical unit" |  | "FN" |  |
| fn:process_stop | fn:HasLexicalUnit | fn:lu:process_stop:cessation | "process stop" | "cessation" | "has lexical unit" |  | "FN" |  |
| fn:process_stop | fn:HasLexicalUnit | fn:lu:process_stop:discontinuation | "process stop" | "discontinuation" | "has lexical unit" |  | "FN" |  |
| fn:process_stop | fn:HasLexicalUnit | fn:lu:process_stop:halt | "process stop" | "halt" | "has lexical unit" |  | "FN" |  |
| fn:process_stop | fn:HasLexicalUnit | fn:lu:process_stop:shutdown | "process stop" | "shutdown" | "has lexical unit" |  | "FN" |  |
| fn:process_stop | fn:HasLexicalUnit | fn:lu:process_stop:kill | "process stop" | "kill" | "has lexical unit" |  | "FN" |  |
| fn:process_stop | fn:HasLexicalUnit | fn:lu:process_stop:shut_down | "process stop" | "shut down" | "has lexical unit" |  | "FN" |  |
| fn:process_stop | /r/HasA | fn:fe:process | "process stop" | "process" | "/r/has a" |  | "FN" |  |
| fn:process_stop | /r/HasA | fn:fe:place | "process stop" | "place" | "/r/has a" |  | "FN" |  |
| fn:process_stop | /r/HasA | fn:fe:explanation | "process stop" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:process_stop | /r/HasA | fn:fe:time | "process stop" | "time" | "/r/has a" |  | "FN" |  |
| fn:process_stop | /r/HasA | fn:fe:degree | "process stop" | "degree" | "/r/has a" |  | "FN" |  |
| fn:process_stop | /r/HasA | fn:fe:depictive | "process stop" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:process_stop | /r/HasA | fn:fe:manner | "process stop" | "manner" | "/r/has a" |  | "FN" |  |
| fn:process_stop | /r/HasA | fn:fe:result | "process stop" | "result" | "/r/has a" |  | "FN" |  |
| fn:process_stop | /r/HasA | fn:fe:final_subevent | "process stop" | "final subevent" | "/r/has a" |  | "FN" |  |
| fn:process_stop | /r/HasA | fn:fe:duration | "process stop" | "duration" | "/r/has a" |  | "FN" |  |
| fn:process_stop | /r/HasA | fn:fe:frequency | "process stop" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:activity_paused_state | /r/IsA | fn:process_stopped_state | "activity paused state" | "process stopped state" | "/r/is a" |  | "FN" |  |
| fn:process_stopped_state | /r/IsA | fn:state | "process stopped state" | "state" | "/r/is a" |  | "FN" |  |
| fn:process | /r/HasSubevent | fn:process_stopped_state | "process" | "process stopped state" | "/r/has subevent" |  | "FN" |  |
| fn:process_stopped_state | /r/UsedFor | fn:activity_abandoned_state | "process stopped state" | "activity abandoned state" | "/r/used for" |  | "FN" |  |
| fn:process_stopped_state | /r/HasPrerequisite | fn:process_pause | "process stopped state" | "process pause" | "/r/has prerequisite" |  | "FN" |  |
| fn:process_stopped_state | /r/HasPrerequisite | fn:process_stop | "process stopped state" | "process stop" | "/r/has prerequisite" |  | "FN" |  |
| fn:process_resume | /r/HasPrerequisite | fn:process_stopped_state | "process resume" | "process stopped state" | "/r/has prerequisite" |  | "FN" |  |
| fn:process_stopped_state | /r/HasA | fn:fe:process | "process stopped state" | "process" | "/r/has a" |  | "FN" |  |
| fn:process_stopped_state | /r/HasA | fn:fe:time | "process stopped state" | "time" | "/r/has a" |  | "FN" |  |
| fn:process_stopped_state | /r/HasA | fn:fe:duration | "process stopped state" | "duration" | "/r/has a" |  | "FN" |  |
| fn:activity_abandoned_state | /r/IsA | fn:process_uncompleted_state | "activity abandoned state" | "process uncompleted state" | "/r/is a" |  | "FN" |  |
| fn:process_uncompleted_state | /r/IsA | fn:state | "process uncompleted state" | "state" | "/r/is a" |  | "FN" |  |
| fn:process | /r/HasSubevent | fn:process_uncompleted_state | "process" | "process uncompleted state" | "/r/has subevent" |  | "FN" |  |
| fn:process_uncompleted_state | /r/HasPrerequisite | fn:process_stop | "process uncompleted state" | "process stop" | "/r/has prerequisite" |  | "FN" |  |
| fn:process_uncompleted_state | /r/HasA | fn:fe:place | "process uncompleted state" | "place" | "/r/has a" |  | "FN" |  |
| fn:process_uncompleted_state | /r/HasA | fn:fe:process | "process uncompleted state" | "process" | "/r/has a" |  | "FN" |  |
| fn:process_uncompleted_state | /r/HasA | fn:fe:time | "process uncompleted state" | "time" | "/r/has a" |  | "FN" |  |
| fn:processing_materials | /r/IsA | fn:intentionally_affect | "processing materials" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:preserving | /r/IsA | fn:processing_materials | "preserving" | "processing materials" | "/r/is a" |  | "FN" |  |
| fn:processing_materials | /r/UsedFor | fn:degree_of_processing | "processing materials" | "degree of processing" | "/r/used for" |  | "FN" |  |
| fn:processing_materials | fn:HasLexicalUnit | fn:lu:processing_materials:stain | "processing materials" | "stain" | "has lexical unit" |  | "FN" |  |
| fn:processing_materials | fn:HasLexicalUnit | fn:lu:processing_materials:dye | "processing materials" | "dye" | "has lexical unit" |  | "FN" |  |
| fn:processing_materials | fn:HasLexicalUnit | fn:lu:processing_materials:etch | "processing materials" | "etch" | "has lexical unit" |  | "FN" |  |
| fn:processing_materials | fn:HasLexicalUnit | fn:lu:processing_materials:treat | "processing materials" | "treat" | "has lexical unit" |  | "FN" |  |
| fn:processing_materials | fn:HasLexicalUnit | fn:lu:processing_materials:galvanize | "processing materials" | "galvanize" | "has lexical unit" |  | "FN" |  |
| fn:processing_materials | fn:HasLexicalUnit | fn:lu:processing_materials:enrich | "processing materials" | "enrich" | "has lexical unit" |  | "FN" |  |
| fn:processing_materials | fn:HasLexicalUnit | fn:lu:processing_materials:enrichment | "processing materials" | "enrichment" | "has lexical unit" |  | "FN" |  |
| fn:processing_materials | fn:HasLexicalUnit | fn:lu:processing_materials:process | "processing materials" | "process" | "has lexical unit" |  | "FN" |  |
| fn:processing_materials | fn:HasLexicalUnit | fn:lu:processing_materials:reprocess | "processing materials" | "reprocess" | "has lexical unit" |  | "FN" |  |
| fn:processing_materials | fn:HasLexicalUnit | fn:lu:processing_materials:reprocessing | "processing materials" | "reprocessing" | "has lexical unit" |  | "FN" |  |
| fn:processing_materials | fn:HasLexicalUnit | fn:lu:processing_materials:weaponize | "processing materials" | "weaponize" | "has lexical unit" |  | "FN" |  |
| fn:processing_materials | fn:HasLexicalUnit | fn:lu:processing_materials:weaponization | "processing materials" | "weaponization" | "has lexical unit" |  | "FN" |  |
| fn:processing_materials | fn:HasLexicalUnit | fn:lu:processing_materials:spin | "processing materials" | "spin" | "has lexical unit" |  | "FN" |  |
| fn:processing_materials | fn:HasLexicalUnit | fn:lu:processing_materials:develop | "processing materials" | "develop" | "has lexical unit" |  | "FN" |  |
| fn:processing_materials | fn:HasLexicalUnit | fn:lu:processing_materials:development | "processing materials" | "development" | "has lexical unit" |  | "FN" |  |
| fn:processing_materials | /r/HasA | fn:fe:agent | "processing materials" | "agent" | "/r/has a" |  | "FN" |  |
| fn:processing_materials | /r/HasA | fn:fe:alterant | "processing materials" | "alterant" | "/r/has a" |  | "FN" |  |
| fn:processing_materials | /r/HasA | fn:fe:material | "processing materials" | "material" | "/r/has a" |  | "FN" |  |
| fn:processing_materials | /r/HasA | fn:fe:purpose | "processing materials" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:processing_materials | /r/HasA | fn:fe:result | "processing materials" | "result" | "/r/has a" |  | "FN" |  |
| fn:processing_materials | /r/HasA | fn:fe:duration | "processing materials" | "duration" | "/r/has a" |  | "FN" |  |
| fn:processing_materials | /r/HasA | fn:fe:place | "processing materials" | "place" | "/r/has a" |  | "FN" |  |
| fn:processing_materials | /r/HasA | fn:fe:time | "processing materials" | "time" | "/r/has a" |  | "FN" |  |
| fn:processing_materials | /r/HasA | fn:fe:subregion | "processing materials" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:processing_materials | /r/HasA | fn:fe:explanation | "processing materials" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:processing_materials | /r/HasA | fn:fe:dimension | "processing materials" | "dimension" | "/r/has a" |  | "FN" |  |
| fn:processing_materials | /r/HasA | fn:fe:manner | "processing materials" | "manner" | "/r/has a" |  | "FN" |  |
| fn:procreative_sex | /r/IsA | fn:sex | "procreative sex" | "sex" | "/r/is a" |  | "FN" |  |
| fn:sexual_reproduction_scenario | /r/HasSubevent | fn:procreative_sex | "sexual reproduction scenario" | "procreative sex" | "/r/has subevent" |  | "FN" |  |
| fn:procreative_sex | fn:HasLexicalUnit | fn:lu:procreative_sex:make_baby | "procreative sex" | "make baby" | "has lexical unit" |  | "FN" |  |
| fn:procreative_sex | /r/HasA | fn:fe:participants | "procreative sex" | "participants" | "/r/has a" |  | "FN" |  |
| fn:procreative_sex | /r/HasA | fn:fe:participant_1 | "procreative sex" | "participant 1" | "/r/has a" |  | "FN" |  |
| fn:procreative_sex | /r/HasA | fn:fe:participant_2 | "procreative sex" | "participant 2" | "/r/has a" |  | "FN" |  |
| fn:procreative_sex | /r/HasA | fn:fe:duration | "procreative sex" | "duration" | "/r/has a" |  | "FN" |  |
| fn:procreative_sex | /r/HasA | fn:fe:manner | "procreative sex" | "manner" | "/r/has a" |  | "FN" |  |
| fn:procreative_sex | /r/HasA | fn:fe:means | "procreative sex" | "means" | "/r/has a" |  | "FN" |  |
| fn:procreative_sex | /r/HasA | fn:fe:place | "procreative sex" | "place" | "/r/has a" |  | "FN" |  |
| fn:procreative_sex | /r/HasA | fn:fe:time | "procreative sex" | "time" | "/r/has a" |  | "FN" |  |
| fn:procreative_sex | /r/HasA | fn:fe:domain | "procreative sex" | "domain" | "/r/has a" |  | "FN" |  |
| fn:procreative_sex | /r/HasA | fn:fe:purpose | "procreative sex" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:product_delivery | /r/IsA | fn:delivery | "product delivery" | "delivery" | "/r/is a" |  | "FN" |  |
| fn:commerce_goods-transfer | /r/UsedFor | fn:product_delivery | "commerce goods-transfer" | "product delivery" | "/r/used for" |  | "FN" |  |
| fn:product_delivery | /r/HasA | fn:fe:deliverer | "product delivery" | "deliverer" | "/r/has a" |  | "FN" |  |
| fn:product_delivery | /r/HasA | fn:fe:goal | "product delivery" | "goal" | "/r/has a" |  | "FN" |  |
| fn:product_delivery | /r/HasA | fn:fe:goods | "product delivery" | "goods" | "/r/has a" |  | "FN" |  |
| fn:product_delivery | /r/HasA | fn:fe:vehicle | "product delivery" | "vehicle" | "/r/has a" |  | "FN" |  |
| fn:product_delivery | /r/HasA | fn:fe:depictive | "product delivery" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:product_delivery | /r/HasA | fn:fe:manner | "product delivery" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fe:purchaser | /r/RelatedTo | fn:fe:goal | "purchaser" | "goal" | "/r/related to" |  | "FN" |  |
| fn:product_delivery | /r/HasA | fn:fe:purchaser | "product delivery" | "purchaser" | "/r/has a" |  | "FN" |  |
| fn:product_delivery | /r/HasA | fn:fe:purpose | "product delivery" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:product_delivery | /r/HasA | fn:fe:explanation | "product delivery" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:product_delivery | /r/HasA | fn:fe:time | "product delivery" | "time" | "/r/has a" |  | "FN" |  |
| fn:product_delivery | /r/HasA | fn:fe:cotheme | "product delivery" | "cotheme" | "/r/has a" |  | "FN" |  |
| fn:product_delivery | /r/HasA | fn:fe:container | "product delivery" | "container" | "/r/has a" |  | "FN" |  |
| fn:product_delivery | /r/HasA | fn:fe:place | "product delivery" | "place" | "/r/has a" |  | "FN" |  |
| fn:product_delivery | /r/HasA | fn:fe:speed | "product delivery" | "speed" | "/r/has a" |  | "FN" |  |
| fn:product_delivery | /r/HasA | fn:fe:circumstances | "product delivery" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:product_delivery | /r/HasA | fn:fe:source | "product delivery" | "source" | "/r/has a" |  | "FN" |  |
| fn:product_delivery | /r/HasA | fn:fe:means | "product delivery" | "means" | "/r/has a" |  | "FN" |  |
| fn:product_delivery | /r/HasA | fn:fe:path | "product delivery" | "path" | "/r/has a" |  | "FN" |  |
| fn:product_development_scenario | /r/HasSubevent | fn:product_development | "product development scenario" | "product development" | "/r/has subevent" |  | "FN" |  |
| fn:product_development | /r/HasPrerequisite | fn:achieving_first | "product development" | "achieving first" | "/r/has prerequisite" |  | "FN" |  |
| fn:manufacturing | /r/HasPrerequisite | fn:product_development | "manufacturing" | "product development" | "/r/has prerequisite" |  | "FN" |  |
| fn:product_line | /r/HasPrerequisite | fn:product_development | "product line" | "product development" | "/r/has prerequisite" |  | "FN" |  |
| fn:product_development | fn:HasLexicalUnit | fn:lu:product_development:develop | "product development" | "develop" | "has lexical unit" |  | "FN" |  |
| fn:product_development | fn:HasLexicalUnit | fn:lu:product_development:development | "product development" | "development" | "has lexical unit" |  | "FN" |  |
| fn:fe:developer | /r/IsA | fn:st:sentient | "developer" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:product_development | /r/HasA | fn:fe:developer | "product development" | "developer" | "/r/has a" |  | "FN" |  |
| fn:product_development | /r/HasA | fn:fe:product | "product development" | "product" | "/r/has a" |  | "FN" |  |
| fn:product_development | /r/HasA | fn:fe:company | "product development" | "company" | "/r/has a" |  | "FN" |  |
| fn:product_development | /r/HasA | fn:fe:place | "product development" | "place" | "/r/has a" |  | "FN" |  |
| fn:product_development | /r/HasA | fn:fe:time | "product development" | "time" | "/r/has a" |  | "FN" |  |
| fn:product_development | /r/HasA | fn:fe:manner | "product development" | "manner" | "/r/has a" |  | "FN" |  |
| fn:product_development | /r/HasA | fn:fe:use | "product development" | "use" | "/r/has a" |  | "FN" |  |
| fn:product_development_scenario | /r/HasSubevent | fn:achieving_first | "product development scenario" | "achieving first" | "/r/has subevent" |  | "FN" |  |
| fn:product_development_scenario | /r/HasSubevent | fn:manufacturing | "product development scenario" | "manufacturing" | "/r/has subevent" |  | "FN" |  |
| fn:product_development_scenario | /r/HasSubevent | fn:product_development | "product development scenario" | "product development" | "/r/has subevent" |  | "FN" |  |
| fn:product_development_scenario | /r/HasA | fn:fe:developer | "product development scenario" | "developer" | "/r/has a" |  | "FN" |  |
| fn:product_development_scenario | /r/HasA | fn:fe:entity | "product development scenario" | "entity" | "/r/has a" |  | "FN" |  |
| fn:product_development_scenario | /r/HasA | fn:fe:time | "product development scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:product_development_scenario | /r/HasA | fn:fe:place | "product development scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:product_development_scenario | /r/HasA | fn:fe:company | "product development scenario" | "company" | "/r/has a" |  | "FN" |  |
| fn:product_development_scenario | /r/HasA | fn:fe:purpose | "product development scenario" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:product_development_scenario | /r/HasA | fn:fe:explanation | "product development scenario" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:product_line | /r/IsA | fn:aggregate | "product line" | "aggregate" | "/r/is a" |  | "FN" |  |
| fn:product_line | /r/HasPrerequisite | fn:product_development | "product line" | "product development" | "/r/has prerequisite" |  | "FN" |  |
| fn:product_line | fn:HasLexicalUnit | fn:lu:product_line:line | "product line" | "line" | "has lexical unit" |  | "FN" |  |
| fn:product_line | fn:HasLexicalUnit | fn:lu:product_line:collection | "product line" | "collection" | "has lexical unit" |  | "FN" |  |
| fn:product_line | /r/HasA | fn:fe:brand | "product line" | "brand" | "/r/has a" |  | "FN" |  |
| fn:product_line | /r/HasA | fn:fe:collection | "product line" | "collection" | "/r/has a" |  | "FN" |  |
| fn:product_line | /r/HasA | fn:fe:products | "product line" | "products" | "/r/has a" |  | "FN" |  |
| fn:product_line | /r/HasA | fn:fe:descriptor | "product line" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:product_line | /r/HasA | fn:fe:collection_name | "product line" | "collection name" | "/r/has a" |  | "FN" |  |
| fn:product_line | /r/HasA | fn:fe:designer | "product line" | "designer" | "/r/has a" |  | "FN" |  |
| fn:ontogeny | /r/IsA | fn:progression | "ontogeny" | "progression" | "/r/is a" |  | "FN" |  |
| fn:process | /r/UsedFor | fn:progression | "process" | "progression" | "/r/used for" |  | "FN" |  |
| fn:progression | /r/UsedFor | fn:stage_of_progress | "progression" | "stage of progress" | "/r/used for" |  | "FN" |  |
| fn:undergo_change | /r/UsedFor | fn:progression | "undergo change" | "progression" | "/r/used for" |  | "FN" |  |
| fn:progression | /r/RelatedTo | fn:improvement_or_decline | "progression" | "improvement or decline" | "/r/related to" |  | "FN" |  |
| fn:cause_to_make_progress | /r/Causes | fn:progression | "cause to make progress" | "progression" | "/r/causes" |  | "FN" |  |
| fn:progression | fn:HasLexicalUnit | fn:lu:progression:progress | "progression" | "progress" | "has lexical unit" |  | "FN" |  |
| fn:progression | fn:HasLexicalUnit | fn:lu:progression:progress | "progression" | "progress" | "has lexical unit" |  | "FN" |  |
| fn:progression | fn:HasLexicalUnit | fn:lu:progression:advance | "progression" | "advance" | "has lexical unit" |  | "FN" |  |
| fn:progression | fn:HasLexicalUnit | fn:lu:progression:advance | "progression" | "advance" | "has lexical unit" |  | "FN" |  |
| fn:progression | fn:HasLexicalUnit | fn:lu:progression:development | "progression" | "development" | "has lexical unit" |  | "FN" |  |
| fn:progression | fn:HasLexicalUnit | fn:lu:progression:develop | "progression" | "develop" | "has lexical unit" |  | "FN" |  |
| fn:progression | fn:HasLexicalUnit | fn:lu:progression:mature | "progression" | "mature" | "has lexical unit" |  | "FN" |  |
| fn:progression | fn:HasLexicalUnit | fn:lu:progression:maturation | "progression" | "maturation" | "has lexical unit" |  | "FN" |  |
| fn:progression | fn:HasLexicalUnit | fn:lu:progression:advancement | "progression" | "advancement" | "has lexical unit" |  | "FN" |  |
| fn:progression | fn:HasLexicalUnit | fn:lu:progression:stagnate | "progression" | "stagnate" | "has lexical unit" |  | "FN" |  |
| fn:progression | fn:HasLexicalUnit | fn:lu:progression:progression | "progression" | "progression" | "has lexical unit" |  | "FN" |  |
| fn:progression | /r/HasA | fn:fe:entity | "progression" | "entity" | "/r/has a" |  | "FN" |  |
| fn:progression | /r/HasA | fn:fe:prior_state | "progression" | "prior state" | "/r/has a" |  | "FN" |  |
| fn:progression | /r/HasA | fn:fe:post_state | "progression" | "post state" | "/r/has a" |  | "FN" |  |
| fn:progression | /r/HasA | fn:fe:time | "progression" | "time" | "/r/has a" |  | "FN" |  |
| fn:progression | /r/HasA | fn:fe:rate | "progression" | "rate" | "/r/has a" |  | "FN" |  |
| fn:progression | /r/HasA | fn:fe:manner | "progression" | "manner" | "/r/has a" |  | "FN" |  |
| fn:progression | /r/HasA | fn:fe:duration | "progression" | "duration" | "/r/has a" |  | "FN" |  |
| fn:progression | /r/HasA | fn:fe:degree | "progression" | "degree" | "/r/has a" |  | "FN" |  |
| fn:progression | /r/HasA | fn:fe:domain | "progression" | "domain" | "/r/has a" |  | "FN" |  |
| fn:progression | /r/HasA | fn:fe:explanation | "progression" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:progression | /r/HasA | fn:fe:place | "progression" | "place" | "/r/has a" |  | "FN" |  |
| fn:progression | /r/HasA | fn:fe:event_description | "progression" | "event description" | "/r/has a" |  | "FN" |  |
| fn:progression | /r/HasA | fn:fe:frequency | "progression" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:progression | /r/HasA | fn:fe:circumstances | "progression" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:law | /r/UsedFor | fn:prohibiting_or_licensing | "law" | "prohibiting or licensing" | "/r/used for" |  | "FN" |  |
| fn:prohibiting_or_licensing | fn:HasLexicalUnit | fn:lu:prohibiting_or_licensing:ban | "prohibiting or licensing" | "ban" | "has lexical unit" |  | "FN" |  |
| fn:prohibiting_or_licensing | fn:HasLexicalUnit | fn:lu:prohibiting_or_licensing:forbid | "prohibiting or licensing" | "forbid" | "has lexical unit" |  | "FN" |  |
| fn:prohibiting_or_licensing | fn:HasLexicalUnit | fn:lu:prohibiting_or_licensing:prohibit | "prohibiting or licensing" | "prohibit" | "has lexical unit" |  | "FN" |  |
| fn:prohibiting_or_licensing | fn:HasLexicalUnit | fn:lu:prohibiting_or_licensing:proscribe | "prohibiting or licensing" | "proscribe" | "has lexical unit" |  | "FN" |  |
| fn:prohibiting_or_licensing | fn:HasLexicalUnit | fn:lu:prohibiting_or_licensing:outlaw | "prohibiting or licensing" | "outlaw" | "has lexical unit" |  | "FN" |  |
| fn:prohibiting_or_licensing | fn:HasLexicalUnit | fn:lu:prohibiting_or_licensing:ban | "prohibiting or licensing" | "ban" | "has lexical unit" |  | "FN" |  |
| fn:prohibiting_or_licensing | fn:HasLexicalUnit | fn:lu:prohibiting_or_licensing:prohibition | "prohibiting or licensing" | "prohibition" | "has lexical unit" |  | "FN" |  |
| fn:prohibiting_or_licensing | fn:HasLexicalUnit | fn:lu:prohibiting_or_licensing:bar | "prohibiting or licensing" | "bar" | "has lexical unit" |  | "FN" |  |
| fn:prohibiting_or_licensing | fn:HasLexicalUnit | fn:lu:prohibiting_or_licensing:allow | "prohibiting or licensing" | "allow" | "has lexical unit" |  | "FN" |  |
| fn:prohibiting_or_licensing | fn:HasLexicalUnit | fn:lu:prohibiting_or_licensing:entitle | "prohibiting or licensing" | "entitle" | "has lexical unit" |  | "FN" |  |
| fn:prohibiting_or_licensing | fn:HasLexicalUnit | fn:lu:prohibiting_or_licensing:permit | "prohibiting or licensing" | "permit" | "has lexical unit" |  | "FN" |  |
| fn:prohibiting_or_licensing | fn:HasLexicalUnit | fn:lu:prohibiting_or_licensing:sanction | "prohibiting or licensing" | "sanction" | "has lexical unit" |  | "FN" |  |
| fn:prohibiting_or_licensing | /r/HasA | fn:fe:state_of_affairs | "prohibiting or licensing" | "state of affairs" | "/r/has a" |  | "FN" |  |
| fn:fe:principle | /r/IsA | fn:st:artifact | "principle" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:prohibiting_or_licensing | /r/HasA | fn:fe:principle | "prohibiting or licensing" | "principle" | "/r/has a" |  | "FN" |  |
| fn:prohibiting_or_licensing | /r/HasA | fn:fe:place | "prohibiting or licensing" | "place" | "/r/has a" |  | "FN" |  |
| fn:prohibiting_or_licensing | /r/HasA | fn:fe:time | "prohibiting or licensing" | "time" | "/r/has a" |  | "FN" |  |
| fn:prohibiting_or_licensing | /r/HasA | fn:fe:circumstances | "prohibiting or licensing" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:prohibiting_or_licensing | /r/HasA | fn:fe:explanation | "prohibiting or licensing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:purpose | /r/UsedFor | fn:project | "purpose" | "project" | "/r/used for" |  | "FN" |  |
| fn:project | fn:HasLexicalUnit | fn:lu:project:project | "project" | "project" | "has lexical unit" |  | "FN" |  |
| fn:project | fn:HasLexicalUnit | fn:lu:project:program | "project" | "program" | "has lexical unit" |  | "FN" |  |
| fn:project | fn:HasLexicalUnit | fn:lu:project:plan | "project" | "plan" | "has lexical unit" |  | "FN" |  |
| fn:project | fn:HasLexicalUnit | fn:lu:project:scheme | "project" | "scheme" | "has lexical unit" |  | "FN" |  |
| fn:project | /r/HasA | fn:fe:agent | "project" | "agent" | "/r/has a" |  | "FN" |  |
| fn:project | /r/HasA | fn:fe:field | "project" | "field" | "/r/has a" |  | "FN" |  |
| fn:project | /r/HasA | fn:fe:activity | "project" | "activity" | "/r/has a" |  | "FN" |  |
| fn:project | /r/HasA | fn:fe:name | "project" | "name" | "/r/has a" |  | "FN" |  |
| fn:fe:goal | /r/IsA | fn:st:human_act | "goal" | "human act" | "/r/is a" |  | "FN" |  |
| fn:project | /r/HasA | fn:fe:goal | "project" | "goal" | "/r/has a" |  | "FN" |  |
| fn:project | /r/HasA | fn:fe:salient_entity | "project" | "salient entity" | "/r/has a" |  | "FN" |  |
| fn:project | /r/HasA | fn:fe:manner | "project" | "manner" | "/r/has a" |  | "FN" |  |
| fn:project | /r/HasA | fn:fe:duration | "project" | "duration" | "/r/has a" |  | "FN" |  |
| fn:project | /r/HasA | fn:fe:co-participant | "project" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:project | /r/HasA | fn:fe:project | "project" | "project" | "/r/has a" |  | "FN" |  |
| fn:project | /r/HasA | fn:fe:time | "project" | "time" | "/r/has a" |  | "FN" |  |
| fn:project | /r/HasA | fn:fe:place | "project" | "place" | "/r/has a" |  | "FN" |  |
| fn:project | /r/HasA | fn:fe:descriptor | "project" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:proliferating_in_number | /r/IsA | fn:change_position_on_a_scale | "proliferating in number" | "change position on a scale" | "/r/is a" |  | "FN" |  |
| fn:cause_proliferation_in_number | /r/Causes | fn:proliferating_in_number | "cause proliferation in number" | "proliferating in number" | "/r/causes" |  | "FN" |  |
| fn:proliferating_in_number | fn:HasLexicalUnit | fn:lu:proliferating_in_number:proliferate | "proliferating in number" | "proliferate" | "has lexical unit" |  | "FN" |  |
| fn:proliferating_in_number | fn:HasLexicalUnit | fn:lu:proliferating_in_number:multiply | "proliferating in number" | "multiply" | "has lexical unit" |  | "FN" |  |
| fn:proliferating_in_number | fn:HasLexicalUnit | fn:lu:proliferating_in_number:dwindle | "proliferating in number" | "dwindle" | "has lexical unit" |  | "FN" |  |
| fn:proliferating_in_number | fn:HasLexicalUnit | fn:lu:proliferating_in_number:proliferation | "proliferating in number" | "proliferation" | "has lexical unit" |  | "FN" |  |
| fn:proliferating_in_number | fn:HasLexicalUnit | fn:lu:proliferating_in_number:non-proliferation | "proliferating in number" | "non-proliferation" | "has lexical unit" |  | "FN" |  |
| fn:proliferating_in_number | /r/HasA | fn:fe:attribute | "proliferating in number" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:proliferating_in_number | /r/HasA | fn:fe:set | "proliferating in number" | "set" | "/r/has a" |  | "FN" |  |
| fn:proliferating_in_number | /r/HasA | fn:fe:difference | "proliferating in number" | "difference" | "/r/has a" |  | "FN" |  |
| fn:proliferating_in_number | /r/HasA | fn:fe:path | "proliferating in number" | "path" | "/r/has a" |  | "FN" |  |
| fn:proliferating_in_number | /r/HasA | fn:fe:final_number | "proliferating in number" | "final number" | "/r/has a" |  | "FN" |  |
| fn:proliferating_in_number | /r/HasA | fn:fe:initial_number | "proliferating in number" | "initial number" | "/r/has a" |  | "FN" |  |
| fn:proliferating_in_number | /r/HasA | fn:fe:speed | "proliferating in number" | "speed" | "/r/has a" |  | "FN" |  |
| fn:proliferating_in_number | /r/HasA | fn:fe:correlated_variable | "proliferating in number" | "correlated variable" | "/r/has a" |  | "FN" |  |
| fn:proliferating_in_number | /r/HasA | fn:fe:manner | "proliferating in number" | "manner" | "/r/has a" |  | "FN" |  |
| fn:proliferating_in_number | /r/HasA | fn:fe:degree | "proliferating in number" | "degree" | "/r/has a" |  | "FN" |  |
| fn:proliferating_in_number | /r/HasA | fn:fe:circumstances | "proliferating in number" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:proliferating_in_number | /r/HasA | fn:fe:group | "proliferating in number" | "group" | "/r/has a" |  | "FN" |  |
| fn:proliferating_in_number | /r/HasA | fn:fe:time | "proliferating in number" | "time" | "/r/has a" |  | "FN" |  |
| fn:proliferating_in_number | /r/HasA | fn:fe:duration | "proliferating in number" | "duration" | "/r/has a" |  | "FN" |  |
| fn:proliferating_in_number | /r/HasA | fn:fe:initial_correlate | "proliferating in number" | "initial correlate" | "/r/has a" |  | "FN" |  |
| fn:proliferating_in_number | /r/HasA | fn:fe:final_correlate | "proliferating in number" | "final correlate" | "/r/has a" |  | "FN" |  |
| fn:proliferating_in_number | /r/HasA | fn:fe:place | "proliferating in number" | "place" | "/r/has a" |  | "FN" |  |
| fn:proliferating_in_number | /r/HasA | fn:fe:initial_state | "proliferating in number" | "initial state" | "/r/has a" |  | "FN" |  |
| fn:proliferating_in_number | /r/HasA | fn:fe:final_state | "proliferating in number" | "final state" | "/r/has a" |  | "FN" |  |
| fn:prominence | /r/IsA | fn:gradable_attributes | "prominence" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:prominence | /r/UsedFor | fn:first_rank | "prominence" | "first rank" | "/r/used for" |  | "FN" |  |
| fn:prominence | fn:HasLexicalUnit | fn:lu:prominence:salient | "prominence" | "salient" | "has lexical unit" |  | "FN" |  |
| fn:prominence | fn:HasLexicalUnit | fn:lu:prominence:prominent | "prominence" | "prominent" | "has lexical unit" |  | "FN" |  |
| fn:prominence | fn:HasLexicalUnit | fn:lu:prominence:conspicuous | "prominence" | "conspicuous" | "has lexical unit" |  | "FN" |  |
| fn:prominence | fn:HasLexicalUnit | fn:lu:prominence:eye-catching | "prominence" | "eye-catching" | "has lexical unit" |  | "FN" |  |
| fn:prominence | fn:HasLexicalUnit | fn:lu:prominence:flashy | "prominence" | "flashy" | "has lexical unit" |  | "FN" |  |
| fn:prominence | fn:HasLexicalUnit | fn:lu:prominence:blatant | "prominence" | "blatant" | "has lexical unit" |  | "FN" |  |
| fn:prominence | fn:HasLexicalUnit | fn:lu:prominence:quiet | "prominence" | "quiet" | "has lexical unit" |  | "FN" |  |
| fn:prominence | /r/HasA | fn:fe:entity | "prominence" | "entity" | "/r/has a" |  | "FN" |  |
| fn:prominence | /r/HasA | fn:fe:attribute | "prominence" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:prominence | /r/HasA | fn:fe:degree | "prominence" | "degree" | "/r/has a" |  | "FN" |  |
| fn:prominence | /r/HasA | fn:fe:time | "prominence" | "time" | "/r/has a" |  | "FN" |  |
| fn:prominence | /r/HasA | fn:fe:circumstances | "prominence" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:prominence | /r/HasA | fn:fe:place | "prominence" | "place" | "/r/has a" |  | "FN" |  |
| fn:proper_reference | fn:HasLexicalUnit | fn:lu:proper_reference:proper | "proper reference" | "proper" | "has lexical unit" |  | "FN" |  |
| fn:proper_reference | fn:HasLexicalUnit | fn:lu:proper_reference:self | "proper reference" | "self" | "has lexical unit" |  | "FN" |  |
| fn:proper_reference | /r/HasA | fn:fe:entity | "proper reference" | "entity" | "/r/has a" |  | "FN" |  |
| fn:proper_reference | /r/HasA | fn:fe:intended_referent | "proper reference" | "intended referent" | "/r/has a" |  | "FN" |  |
| fn:proportion | /r/IsA | fn:relational_quantity | "proportion" | "relational quantity" | "/r/is a" |  | "FN" |  |
| fn:proportion | fn:HasLexicalUnit | fn:lu:proportion:rate | "proportion" | "rate" | "has lexical unit" |  | "FN" |  |
| fn:proportion | /r/HasA | fn:fe:criteria | "proportion" | "criteria" | "/r/has a" |  | "FN" |  |
| fn:proportion | /r/HasA | fn:fe:subset | "proportion" | "subset" | "/r/has a" |  | "FN" |  |
| fn:proportion | /r/HasA | fn:fe:group | "proportion" | "group" | "/r/has a" |  | "FN" |  |
| fn:proportion | /r/HasA | fn:fe:descriptor | "proportion" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:proportion | /r/HasA | fn:fe:ratio | "proportion" | "ratio" | "/r/has a" |  | "FN" |  |
| fn:hedging | /r/RelatedTo | fn:proportional_quantity | "hedging" | "proportional quantity" | "/r/related to" |  | "FN" |  |
| fn:proportional_quantity | fn:HasLexicalUnit | fn:lu:proportional_quantity:about | "proportional quantity" | "about" | "has lexical unit" |  | "FN" |  |
| fn:proportional_quantity | fn:HasLexicalUnit | fn:lu:proportional_quantity:a_good | "proportional quantity" | "a good" | "has lexical unit" |  | "FN" |  |
| fn:proportional_quantity | fn:HasLexicalUnit | fn:lu:proportional_quantity:over | "proportional quantity" | "over" | "has lexical unit" |  | "FN" |  |
| fn:proportional_quantity | fn:HasLexicalUnit | fn:lu:proportional_quantity:almost | "proportional quantity" | "almost" | "has lexical unit" |  | "FN" |  |
| fn:proportional_quantity | fn:HasLexicalUnit | fn:lu:proportional_quantity:approximately | "proportional quantity" | "approximately" | "has lexical unit" |  | "FN" |  |
| fn:proportional_quantity | fn:HasLexicalUnit | fn:lu:proportional_quantity:around | "proportional quantity" | "around" | "has lexical unit" |  | "FN" |  |
| fn:proportional_quantity | fn:HasLexicalUnit | fn:lu:proportional_quantity:circa | "proportional quantity" | "circa" | "has lexical unit" |  | "FN" |  |
| fn:proportional_quantity | fn:HasLexicalUnit | fn:lu:proportional_quantity:or_so | "proportional quantity" | "or so" | "has lexical unit" |  | "FN" |  |
| fn:proportional_quantity | fn:HasLexicalUnit | fn:lu:proportional_quantity:in_neighborhood_(of) | "proportional quantity" | "in neighborhood (of)" | "has lexical unit" |  | "FN" |  |
| fn:proportional_quantity | fn:HasLexicalUnit | fn:lu:proportional_quantity:nearly | "proportional quantity" | "nearly" | "has lexical unit" |  | "FN" |  |
| fn:proportional_quantity | fn:HasLexicalUnit | fn:lu:proportional_quantity:under | "proportional quantity" | "under" | "has lexical unit" |  | "FN" |  |
| fn:proportional_quantity | fn:HasLexicalUnit | fn:lu:proportional_quantity:close_(to) | "proportional quantity" | "close (to)" | "has lexical unit" |  | "FN" |  |
| fn:proportional_quantity | fn:HasLexicalUnit | fn:lu:proportional_quantity:roughly | "proportional quantity" | "roughly" | "has lexical unit" |  | "FN" |  |
| fn:proportional_quantity | fn:HasLexicalUnit | fn:lu:proportional_quantity:precisely | "proportional quantity" | "precisely" | "has lexical unit" |  | "FN" |  |
| fn:proportional_quantity | fn:HasLexicalUnit | fn:lu:proportional_quantity:exactly | "proportional quantity" | "exactly" | "has lexical unit" |  | "FN" |  |
| fn:proportional_quantity | fn:HasLexicalUnit | fn:lu:proportional_quantity:some | "proportional quantity" | "some" | "has lexical unit" |  | "FN" |  |
| fn:proportional_quantity | fn:HasLexicalUnit | fn:lu:proportional_quantity:at_least | "proportional quantity" | "at least" | "has lexical unit" |  | "FN" |  |
| fn:proportional_quantity | fn:HasLexicalUnit | fn:lu:proportional_quantity:tops | "proportional quantity" | "tops" | "has lexical unit" |  | "FN" |  |
| fn:proportional_quantity | fn:HasLexicalUnit | fn:lu:proportional_quantity:minimum | "proportional quantity" | "minimum" | "has lexical unit" |  | "FN" |  |
| fn:proportional_quantity | fn:HasLexicalUnit | fn:lu:proportional_quantity:at_most | "proportional quantity" | "at most" | "has lexical unit" |  | "FN" |  |
| fn:proportional_quantity | fn:HasLexicalUnit | fn:lu:proportional_quantity:thereabouts | "proportional quantity" | "thereabouts" | "has lexical unit" |  | "FN" |  |
| fn:proportional_quantity | fn:HasLexicalUnit | fn:lu:proportional_quantity:barely | "proportional quantity" | "barely" | "has lexical unit" |  | "FN" |  |
| fn:proportional_quantity | fn:HasLexicalUnit | fn:lu:proportional_quantity:odd | "proportional quantity" | "odd" | "has lexical unit" |  | "FN" |  |
| fn:proportional_quantity | fn:HasLexicalUnit | fn:lu:proportional_quantity:much | "proportional quantity" | "much" | "has lexical unit" |  | "FN" |  |
| fn:proportional_quantity | fn:HasLexicalUnit | fn:lu:proportional_quantity:little | "proportional quantity" | "little" | "has lexical unit" |  | "FN" |  |
| fn:proportional_quantity | fn:HasLexicalUnit | fn:lu:proportional_quantity:most | "proportional quantity" | "most" | "has lexical unit" |  | "FN" |  |
| fn:fe:denoted_quantity | /r/IsA | fn:st:quantity | "denoted quantity" | "quantity" | "/r/is a" |  | "FN" |  |
| fn:proportional_quantity | /r/HasA | fn:fe:denoted_quantity | "proportional quantity" | "denoted quantity" | "/r/has a" |  | "FN" |  |
| fn:proportional_quantity | /r/HasA | fn:fe:mass | "proportional quantity" | "mass" | "/r/has a" |  | "FN" |  |
| fn:proportional_quantity | /r/HasA | fn:fe:individuals | "proportional quantity" | "individuals" | "/r/has a" |  | "FN" |  |
| fn:proportional_quantity | /r/HasA | fn:fe:q_prop | "proportional quantity" | "q prop" | "/r/has a" |  | "FN" |  |
| fn:proportional_quantity | /r/HasA | fn:fe:reference_quantity | "proportional quantity" | "reference quantity" | "/r/has a" |  | "FN" |  |
| fn:proportional_quantity | /r/HasA | fn:fe:degree | "proportional quantity" | "degree" | "/r/has a" |  | "FN" |  |
| fn:protecting | /r/UsedFor | fn:armor | "protecting" | "armor" | "/r/used for" |  | "FN" |  |
| fn:run_risk | /r/UsedFor | fn:protecting | "run risk" | "protecting" | "/r/used for" |  | "FN" |  |
| fn:protecting | fn:HasLexicalUnit | fn:lu:protecting:protect | "protecting" | "protect" | "has lexical unit" |  | "FN" |  |
| fn:protecting | fn:HasLexicalUnit | fn:lu:protecting:shield | "protecting" | "shield" | "has lexical unit" |  | "FN" |  |
| fn:protecting | fn:HasLexicalUnit | fn:lu:protecting:safeguard | "protecting" | "safeguard" | "has lexical unit" |  | "FN" |  |
| fn:protecting | fn:HasLexicalUnit | fn:lu:protecting:insulate | "protecting" | "insulate" | "has lexical unit" |  | "FN" |  |
| fn:protecting | fn:HasLexicalUnit | fn:lu:protecting:secure | "protecting" | "secure" | "has lexical unit" |  | "FN" |  |
| fn:protecting | fn:HasLexicalUnit | fn:lu:protecting:protection_[event] | "protecting" | "protection [event]" | "has lexical unit" |  | "FN" |  |
| fn:protecting | fn:HasLexicalUnit | fn:lu:protecting:protection_[entity] | "protecting" | "protection [entity]" | "has lexical unit" |  | "FN" |  |
| fn:protecting | fn:HasLexicalUnit | fn:lu:protecting:safeguard | "protecting" | "safeguard" | "has lexical unit" |  | "FN" |  |
| fn:protecting | fn:HasLexicalUnit | fn:lu:protecting:shield | "protecting" | "shield" | "has lexical unit" |  | "FN" |  |
| fn:protecting | fn:HasLexicalUnit | fn:lu:protecting:bulwark | "protecting" | "bulwark" | "has lexical unit" |  | "FN" |  |
| fn:protecting | fn:HasLexicalUnit | fn:lu:protecting:guard | "protecting" | "guard" | "has lexical unit" |  | "FN" |  |
| fn:protecting | fn:HasLexicalUnit | fn:lu:protecting:shelter | "protecting" | "shelter" | "has lexical unit" |  | "FN" |  |
| fn:protecting | fn:HasLexicalUnit | fn:lu:protecting:shelter | "protecting" | "shelter" | "has lexical unit" |  | "FN" |  |
| fn:protecting | fn:HasLexicalUnit | fn:lu:protecting:cover | "protecting" | "cover" | "has lexical unit" |  | "FN" |  |
| fn:protecting | /r/HasA | fn:fe:protection | "protecting" | "protection" | "/r/has a" |  | "FN" |  |
| fn:protecting | /r/HasA | fn:fe:place | "protecting" | "place" | "/r/has a" |  | "FN" |  |
| fn:protecting | /r/HasA | fn:fe:time | "protecting" | "time" | "/r/has a" |  | "FN" |  |
| fn:protecting | /r/HasA | fn:fe:danger | "protecting" | "danger" | "/r/has a" |  | "FN" |  |
| fn:protecting | /r/HasA | fn:fe:asset | "protecting" | "asset" | "/r/has a" |  | "FN" |  |
| fn:protecting | /r/HasA | fn:fe:means | "protecting" | "means" | "/r/has a" |  | "FN" |  |
| fn:protecting | /r/HasA | fn:fe:instrument | "protecting" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:protecting | /r/HasA | fn:fe:manner | "protecting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:protecting | /r/HasA | fn:fe:event_description | "protecting" | "event description" | "/r/has a" |  | "FN" |  |
| fn:protecting | /r/HasA | fn:fe:descriptor | "protecting" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:protecting | /r/HasA | fn:fe:degree | "protecting" | "degree" | "/r/has a" |  | "FN" |  |
| fn:protecting | /r/HasA | fn:fe:explanation | "protecting" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:protecting | /r/HasA | fn:fe:duration | "protecting" | "duration" | "/r/has a" |  | "FN" |  |
| fn:protecting | /r/HasA | fn:fe:depictive | "protecting" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:protecting | /r/HasA | fn:fe:beneficiary | "protecting" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:taking_sides | /r/UsedFor | fn:protest | "taking sides" | "protest" | "/r/used for" |  | "FN" |  |
| fn:protest | fn:HasLexicalUnit | fn:lu:protest:demonstration | "protest" | "demonstration" | "has lexical unit" |  | "FN" |  |
| fn:protest | fn:HasLexicalUnit | fn:lu:protest:demonstrate | "protest" | "demonstrate" | "has lexical unit" |  | "FN" |  |
| fn:protest | fn:HasLexicalUnit | fn:lu:protest:protest | "protest" | "protest" | "has lexical unit" |  | "FN" |  |
| fn:protest | fn:HasLexicalUnit | fn:lu:protest:protest | "protest" | "protest" | "has lexical unit" |  | "FN" |  |
| fn:protest | fn:HasLexicalUnit | fn:lu:protest:protester | "protest" | "protester" | "has lexical unit" |  | "FN" |  |
| fn:fe:protester | /r/IsA | fn:st:sentient | "protester" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:protest | /r/HasA | fn:fe:protester | "protest" | "protester" | "/r/has a" |  | "FN" |  |
| fn:protest | /r/HasA | fn:fe:issue | "protest" | "issue" | "/r/has a" |  | "FN" |  |
| fn:protest | /r/HasA | fn:fe:side | "protest" | "side" | "/r/has a" |  | "FN" |  |
| fn:protest | /r/HasA | fn:fe:degree | "protest" | "degree" | "/r/has a" |  | "FN" |  |
| fn:protest | /r/HasA | fn:fe:time | "protest" | "time" | "/r/has a" |  | "FN" |  |
| fn:protest | /r/HasA | fn:fe:explanation | "protest" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:protest | /r/HasA | fn:fe:action | "protest" | "action" | "/r/has a" |  | "FN" |  |
| fn:protest | /r/HasA | fn:fe:descriptor | "protest" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:protest | /r/HasA | fn:fe:particular_iteration | "protest" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:protest | /r/HasA | fn:fe:manner | "protest" | "manner" | "/r/has a" |  | "FN" |  |
| fn:protest | /r/HasA | fn:fe:concessive | "protest" | "concessive" | "/r/has a" |  | "FN" |  |
| fn:protest | /r/HasA | fn:fe:place | "protest" | "place" | "/r/has a" |  | "FN" |  |
| fn:protest | /r/HasA | fn:fe:duration | "protest" | "duration" | "/r/has a" |  | "FN" |  |
| fn:protest | /r/HasA | fn:fe:frequency | "protest" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:provide_lodging | /r/IsA | fn:lodging_scenario | "provide lodging" | "lodging scenario" | "/r/is a" |  | "FN" |  |
| fn:provide_lodging | fn:HasLexicalUnit | fn:lu:provide_lodging:house | "provide lodging" | "house" | "has lexical unit" |  | "FN" |  |
| fn:provide_lodging | fn:HasLexicalUnit | fn:lu:provide_lodging:lodge | "provide lodging" | "lodge" | "has lexical unit" |  | "FN" |  |
| fn:provide_lodging | fn:HasLexicalUnit | fn:lu:provide_lodging:host | "provide lodging" | "host" | "has lexical unit" |  | "FN" |  |
| fn:provide_lodging | fn:HasLexicalUnit | fn:lu:provide_lodging:put_up | "provide lodging" | "put up" | "has lexical unit" |  | "FN" |  |
| fn:provide_lodging | /r/HasA | fn:fe:host | "provide lodging" | "host" | "/r/has a" |  | "FN" |  |
| fn:provide_lodging | /r/HasA | fn:fe:lodger | "provide lodging" | "lodger" | "/r/has a" |  | "FN" |  |
| fn:provide_lodging | /r/HasA | fn:fe:circumstances | "provide lodging" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:provide_lodging | /r/HasA | fn:fe:time | "provide lodging" | "time" | "/r/has a" |  | "FN" |  |
| fn:provide_lodging | /r/HasA | fn:fe:place | "provide lodging" | "place" | "/r/has a" |  | "FN" |  |
| fn:provide_lodging | /r/HasA | fn:fe:purpose | "provide lodging" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:provide_lodging | /r/HasA | fn:fe:explanation | "provide lodging" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:provide_lodging | /r/HasA | fn:fe:manner | "provide lodging" | "manner" | "/r/has a" |  | "FN" |  |
| fn:provide_lodging | /r/HasA | fn:fe:means | "provide lodging" | "means" | "/r/has a" |  | "FN" |  |
| fn:provide_lodging | /r/HasA | fn:fe:residence | "provide lodging" | "residence" | "/r/has a" |  | "FN" |  |
| fn:proximity_image_schema | /r/IsA | fn:image_schema | "proximity image schema" | "image schema" | "/r/is a" |  | "FN" |  |
| fn:proximity_image_schema | /r/RelatedTo | fn:collocation_image_schema | "proximity image schema" | "collocation image schema" | "/r/related to" |  | "FN" |  |
| fn:gradable_proximity | /r/IsA | fn:proximity_image_schema | "gradable proximity" | "proximity image schema" | "/r/is a" |  | "FN" |  |
| fn:non-gradable_proximity | /r/IsA | fn:proximity_image_schema | "non-gradable proximity" | "proximity image schema" | "/r/is a" |  | "FN" |  |
| fn:proximity_image_schema | /r/HasA | fn:fe:near_profiled_region | "proximity image schema" | "near profiled region" | "/r/has a" |  | "FN" |  |
| fn:proximity_image_schema | /r/HasA | fn:fe:ground | "proximity image schema" | "ground" | "/r/has a" |  | "FN" |  |
| fn:proximity_image_schema | /r/HasA | fn:fe:degree | "proximity image schema" | "degree" | "/r/has a" |  | "FN" |  |
| fn:proximity_image_schema | /r/HasA | fn:fe:distant_profiled_region | "proximity image schema" | "distant profiled region" | "/r/has a" |  | "FN" |  |
| fn:institutions | /r/UsedFor | fn:public_services | "institutions" | "public services" | "/r/used for" |  | "FN" |  |
| fn:public_services | fn:HasLexicalUnit | fn:lu:public_services:service | "public services" | "service" | "has lexical unit" |  | "FN" |  |
| fn:public_services | fn:HasLexicalUnit | fn:lu:public_services:public_service | "public services" | "public service" | "has lexical unit" |  | "FN" |  |
| fn:public_services | /r/HasA | fn:fe:institution | "public services" | "institution" | "/r/has a" |  | "FN" |  |
| fn:public_services | /r/HasA | fn:fe:domain | "public services" | "domain" | "/r/has a" |  | "FN" |  |
| fn:public_services | /r/HasA | fn:fe:target_group | "public services" | "target group" | "/r/has a" |  | "FN" |  |
| fn:public_services | /r/HasA | fn:fe:service_action | "public services" | "service action" | "/r/has a" |  | "FN" |  |
| fn:publishing | /r/IsA | fn:intentionally_affect | "publishing" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:publishing | fn:HasLexicalUnit | fn:lu:publishing:appear | "publishing" | "appear" | "has lexical unit" |  | "FN" |  |
| fn:publishing | fn:HasLexicalUnit | fn:lu:publishing:publish | "publishing" | "publish" | "has lexical unit" |  | "FN" |  |
| fn:publishing | fn:HasLexicalUnit | fn:lu:publishing:release | "publishing" | "release" | "has lexical unit" |  | "FN" |  |
| fn:publishing | fn:HasLexicalUnit | fn:lu:publishing:release_[event] | "publishing" | "release [event]" | "has lexical unit" |  | "FN" |  |
| fn:publishing | fn:HasLexicalUnit | fn:lu:publishing:publication | "publishing" | "publication" | "has lexical unit" |  | "FN" |  |
| fn:publishing | fn:HasLexicalUnit | fn:lu:publishing:put_out | "publishing" | "put out" | "has lexical unit" |  | "FN" |  |
| fn:publishing | /r/HasA | fn:fe:publisher | "publishing" | "publisher" | "/r/has a" |  | "FN" |  |
| fn:publishing | /r/HasA | fn:fe:medium | "publishing" | "medium" | "/r/has a" |  | "FN" |  |
| fn:publishing | /r/HasA | fn:fe:work | "publishing" | "work" | "/r/has a" |  | "FN" |  |
| fn:publishing | /r/HasA | fn:fe:time | "publishing" | "time" | "/r/has a" |  | "FN" |  |
| fn:publishing | /r/HasA | fn:fe:audience | "publishing" | "audience" | "/r/has a" |  | "FN" |  |
| fn:publishing | /r/HasA | fn:fe:author | "publishing" | "author" | "/r/has a" |  | "FN" |  |
| fn:publishing | /r/HasA | fn:fe:purpose | "publishing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:publishing | /r/HasA | fn:fe:place | "publishing" | "place" | "/r/has a" |  | "FN" |  |
| fn:publishing | /r/HasA | fn:fe:manner | "publishing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:publishing | /r/HasA | fn:fe:means | "publishing" | "means" | "/r/has a" |  | "FN" |  |
| fn:punctual_perception | /r/IsA | fn:perception_experience | "punctual perception" | "perception experience" | "/r/is a" |  | "FN" |  |
| fn:punctual_perception | fn:HasLexicalUnit | fn:lu:punctual_perception:glimpse | "punctual perception" | "glimpse" | "has lexical unit" |  | "FN" |  |
| fn:punctual_perception | fn:HasLexicalUnit | fn:lu:punctual_perception:glimpse | "punctual perception" | "glimpse" | "has lexical unit" |  | "FN" |  |
| fn:punctual_perception | fn:HasLexicalUnit | fn:lu:punctual_perception:get_an_eyeful | "punctual perception" | "get an eyeful" | "has lexical unit" |  | "FN" |  |
| fn:punctual_perception | /r/HasA | fn:fe:perceiver | "punctual perception" | "perceiver" | "/r/has a" |  | "FN" |  |
| fn:punctual_perception | /r/HasA | fn:fe:phenomenon | "punctual perception" | "phenomenon" | "/r/has a" |  | "FN" |  |
| fn:punctual_perception | /r/HasA | fn:fe:body_part | "punctual perception" | "body part" | "/r/has a" |  | "FN" |  |
| fn:punctual_perception | /r/HasA | fn:fe:location_of_protagonist | "punctual perception" | "location of protagonist" | "/r/has a" |  | "FN" |  |
| fn:punctual_perception | /r/HasA | fn:fe:direction | "punctual perception" | "direction" | "/r/has a" |  | "FN" |  |
| fn:punctual_perception | /r/HasA | fn:fe:depictive | "punctual perception" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:punctual_perception | /r/HasA | fn:fe:ground | "punctual perception" | "ground" | "/r/has a" |  | "FN" |  |
| fn:punctual_perception | /r/HasA | fn:fe:manner | "punctual perception" | "manner" | "/r/has a" |  | "FN" |  |
| fn:punctual_perception | /r/HasA | fn:fe:degree | "punctual perception" | "degree" | "/r/has a" |  | "FN" |  |
| fn:punctual_perception | /r/HasA | fn:fe:means | "punctual perception" | "means" | "/r/has a" |  | "FN" |  |
| fn:punctual_perception | /r/HasA | fn:fe:time | "punctual perception" | "time" | "/r/has a" |  | "FN" |  |
| fn:punctual_perception | /r/HasA | fn:fe:duration | "punctual perception" | "duration" | "/r/has a" |  | "FN" |  |
| fn:desiring | /r/UsedFor | fn:purpose | "desiring" | "purpose" | "/r/used for" |  | "FN" |  |
| fn:means | /r/UsedFor | fn:purpose | "means" | "purpose" | "/r/used for" |  | "FN" |  |
| fn:mental_activity | /r/UsedFor | fn:purpose | "mental activity" | "purpose" | "/r/used for" |  | "FN" |  |
| fn:purpose | /r/UsedFor | fn:elusive_goal | "purpose" | "elusive goal" | "/r/used for" |  | "FN" |  |
| fn:purpose | /r/UsedFor | fn:left_to_do | "purpose" | "left to do" | "/r/used for" |  | "FN" |  |
| fn:purpose | /r/UsedFor | fn:project | "purpose" | "project" | "/r/used for" |  | "FN" |  |
| fn:purpose | /r/UsedFor | fn:remembering_to_do | "purpose" | "remembering to do" | "/r/used for" |  | "FN" |  |
| fn:purpose | /r/UsedFor | fn:tool_purpose | "purpose" | "tool purpose" | "/r/used for" |  | "FN" |  |
| fn:eventive_cognizer_affecting | /r/Causes | fn:purpose | "eventive cognizer affecting" | "purpose" | "/r/causes" |  | "FN" |  |
| fn:purpose | fn:HasLexicalUnit | fn:lu:purpose:purpose | "purpose" | "purpose" | "has lexical unit" |  | "FN" |  |
| fn:purpose | fn:HasLexicalUnit | fn:lu:purpose:goal | "purpose" | "goal" | "has lexical unit" |  | "FN" |  |
| fn:purpose | fn:HasLexicalUnit | fn:lu:purpose:aim | "purpose" | "aim" | "has lexical unit" |  | "FN" |  |
| fn:purpose | fn:HasLexicalUnit | fn:lu:purpose:objective | "purpose" | "objective" | "has lexical unit" |  | "FN" |  |
| fn:purpose | fn:HasLexicalUnit | fn:lu:purpose:object | "purpose" | "object" | "has lexical unit" |  | "FN" |  |
| fn:purpose | fn:HasLexicalUnit | fn:lu:purpose:target | "purpose" | "target" | "has lexical unit" |  | "FN" |  |
| fn:purpose | fn:HasLexicalUnit | fn:lu:purpose:aim | "purpose" | "aim" | "has lexical unit" |  | "FN" |  |
| fn:purpose | fn:HasLexicalUnit | fn:lu:purpose:intend | "purpose" | "intend" | "has lexical unit" |  | "FN" |  |
| fn:purpose | fn:HasLexicalUnit | fn:lu:purpose:intention | "purpose" | "intention" | "has lexical unit" |  | "FN" |  |
| fn:purpose | fn:HasLexicalUnit | fn:lu:purpose:use | "purpose" | "use" | "has lexical unit" |  | "FN" |  |
| fn:purpose | fn:HasLexicalUnit | fn:lu:purpose:plan | "purpose" | "plan" | "has lexical unit" |  | "FN" |  |
| fn:purpose | fn:HasLexicalUnit | fn:lu:purpose:in_order | "purpose" | "in order" | "has lexical unit" |  | "FN" |  |
| fn:purpose | fn:HasLexicalUnit | fn:lu:purpose:plan | "purpose" | "plan" | "has lexical unit" |  | "FN" |  |
| fn:purpose | fn:HasLexicalUnit | fn:lu:purpose:bent | "purpose" | "bent" | "has lexical unit" |  | "FN" |  |
| fn:purpose | fn:HasLexicalUnit | fn:lu:purpose:intent | "purpose" | "intent" | "has lexical unit" |  | "FN" |  |
| fn:purpose | fn:HasLexicalUnit | fn:lu:purpose:determined | "purpose" | "determined" | "has lexical unit" |  | "FN" |  |
| fn:purpose | fn:HasLexicalUnit | fn:lu:purpose:mean | "purpose" | "mean" | "has lexical unit" |  | "FN" |  |
| fn:purpose | /r/HasA | fn:fe:agent | "purpose" | "agent" | "/r/has a" |  | "FN" |  |
| fn:fe:goal | /r/RelatedTo | fn:fe:attribute | "goal" | "attribute" | "/r/related to" |  | "FN" |  |
| fn:purpose | /r/HasA | fn:fe:goal | "purpose" | "goal" | "/r/has a" |  | "FN" |  |
| fn:purpose | /r/HasA | fn:fe:means | "purpose" | "means" | "/r/has a" |  | "FN" |  |
| fn:purpose | /r/HasA | fn:fe:domain | "purpose" | "domain" | "/r/has a" |  | "FN" |  |
| fn:purpose | /r/HasA | fn:fe:time | "purpose" | "time" | "/r/has a" |  | "FN" |  |
| fn:purpose | /r/HasA | fn:fe:restrictor | "purpose" | "restrictor" | "/r/has a" |  | "FN" |  |
| fn:fe:attribute | /r/HasPrerequisite | fn:fe:value | "attribute" | "value" | "/r/has prerequisite" |  | "FN" |  |
| fn:purpose | /r/HasA | fn:fe:attribute | "purpose" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:fe:value | /r/RelatedTo | fn:fe:goal | "value" | "goal" | "/r/related to" |  | "FN" |  |
| fn:purpose | /r/HasA | fn:fe:value | "purpose" | "value" | "/r/has a" |  | "FN" |  |
| fn:fire_stopping_scenario | /r/HasSubevent | fn:putting_out_fire | "fire stopping scenario" | "putting out fire" | "/r/has subevent" |  | "FN" |  |
| fn:putting_out_fire | /r/Causes | fn:fire_going_out | "putting out fire" | "fire going out" | "/r/causes" |  | "FN" |  |
| fn:putting_out_fire | /r/HasPrerequisite | fn:fire_burning | "putting out fire" | "fire burning" | "/r/has prerequisite" |  | "FN" |  |
| fn:putting_out_fire | /r/HasPrerequisite | fn:firefighting | "putting out fire" | "firefighting" | "/r/has prerequisite" |  | "FN" |  |
| fn:putting_out_fire | fn:HasLexicalUnit | fn:lu:putting_out_fire:douse | "putting out fire" | "douse" | "has lexical unit" |  | "FN" |  |
| fn:putting_out_fire | fn:HasLexicalUnit | fn:lu:putting_out_fire:smother | "putting out fire" | "smother" | "has lexical unit" |  | "FN" |  |
| fn:putting_out_fire | fn:HasLexicalUnit | fn:lu:putting_out_fire:quench | "putting out fire" | "quench" | "has lexical unit" |  | "FN" |  |
| fn:putting_out_fire | fn:HasLexicalUnit | fn:lu:putting_out_fire:put_out | "putting out fire" | "put out" | "has lexical unit" |  | "FN" |  |
| fn:putting_out_fire | fn:HasLexicalUnit | fn:lu:putting_out_fire:extinguish | "putting out fire" | "extinguish" | "has lexical unit" |  | "FN" |  |
| fn:putting_out_fire | fn:HasLexicalUnit | fn:lu:putting_out_fire:blow_out | "putting out fire" | "blow out" | "has lexical unit" |  | "FN" |  |
| fn:putting_out_fire | fn:HasLexicalUnit | fn:lu:putting_out_fire:stamp_out | "putting out fire" | "stamp out" | "has lexical unit" |  | "FN" |  |
| fn:putting_out_fire | fn:HasLexicalUnit | fn:lu:putting_out_fire:snuff_out | "putting out fire" | "snuff out" | "has lexical unit" |  | "FN" |  |
| fn:putting_out_fire | /r/HasA | fn:fe:depictive | "putting out fire" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:putting_out_fire | /r/HasA | fn:fe:manner | "putting out fire" | "manner" | "/r/has a" |  | "FN" |  |
| fn:putting_out_fire | /r/HasA | fn:fe:result | "putting out fire" | "result" | "/r/has a" |  | "FN" |  |
| fn:putting_out_fire | /r/HasA | fn:fe:place | "putting out fire" | "place" | "/r/has a" |  | "FN" |  |
| fn:putting_out_fire | /r/HasA | fn:fe:time | "putting out fire" | "time" | "/r/has a" |  | "FN" |  |
| fn:putting_out_fire | /r/HasA | fn:fe:agent | "putting out fire" | "agent" | "/r/has a" |  | "FN" |  |
| fn:putting_out_fire | /r/HasA | fn:fe:fire | "putting out fire" | "fire" | "/r/has a" |  | "FN" |  |
| fn:putting_out_fire | /r/HasA | fn:fe:means | "putting out fire" | "means" | "/r/has a" |  | "FN" |  |
| fn:putting_out_fire | /r/HasA | fn:fe:purpose | "putting out fire" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:putting_out_fire | /r/HasA | fn:fe:degree | "putting out fire" | "degree" | "/r/has a" |  | "FN" |  |
| fn:putting_out_fire | /r/HasA | fn:fe:explanation | "putting out fire" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:putting_out_fire | /r/HasA | fn:fe:circumstances | "putting out fire" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:putting_out_fire | /r/HasA | fn:fe:containing_event | "putting out fire" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:quantified_mass | /r/RelatedTo | fn:quantity | "quantified mass" | "quantity" | "/r/related to" |  | "FN" |  |
| fn:quantified_mass | /r/IsA | fn:measure_scenario | "quantified mass" | "measure scenario" | "/r/is a" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:oodles | "quantified mass" | "oodles" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:pile | "quantified mass" | "pile" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:ton | "quantified mass" | "ton" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:heap | "quantified mass" | "heap" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:load | "quantified mass" | "load" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:modicum | "quantified mass" | "modicum" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:mite | "quantified mass" | "mite" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:mass | "quantified mass" | "mass" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:scads | "quantified mass" | "scads" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:hundreds | "quantified mass" | "hundreds" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:thousands | "quantified mass" | "thousands" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:millions | "quantified mass" | "millions" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:billions | "quantified mass" | "billions" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:dozens | "quantified mass" | "dozens" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:shitload | "quantified mass" | "shitload" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:abundance | "quantified mass" | "abundance" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:myriad | "quantified mass" | "myriad" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:plethora | "quantified mass" | "plethora" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:quantity | "quantified mass" | "quantity" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:number | "quantified mass" | "number" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:pinch | "quantified mass" | "pinch" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:ounce | "quantified mass" | "ounce" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:touch | "quantified mass" | "touch" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:measure | "quantified mass" | "measure" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:amount | "quantified mass" | "amount" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:scores | "quantified mass" | "scores" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:degree | "quantified mass" | "degree" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:avalanche | "quantified mass" | "avalanche" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:deluge | "quantified mass" | "deluge" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:torrent | "quantified mass" | "torrent" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:flood | "quantified mass" | "flood" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:trickle | "quantified mass" | "trickle" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:stream | "quantified mass" | "stream" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:wave | "quantified mass" | "wave" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:raft | "quantified mass" | "raft" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:mountain | "quantified mass" | "mountain" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:handful | "quantified mass" | "handful" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:a_lot | "quantified mass" | "a lot" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:few | "quantified mass" | "few" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:many | "quantified mass" | "many" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:several | "quantified mass" | "several" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:several | "quantified mass" | "several" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:few | "quantified mass" | "few" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:a_few | "quantified mass" | "a few" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:any | "quantified mass" | "any" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:many | "quantified mass" | "many" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:all | "quantified mass" | "all" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:numerous | "quantified mass" | "numerous" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:a_bit | "quantified mass" | "a bit" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:no | "quantified mass" | "no" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:multiple | "quantified mass" | "multiple" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:dose | "quantified mass" | "dose" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:a_little | "quantified mass" | "a little" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:both | "quantified mass" | "both" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:smattering | "quantified mass" | "smattering" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:fair | "quantified mass" | "fair" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:trace | "quantified mass" | "trace" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | fn:HasLexicalUnit | fn:lu:quantified_mass:deal | "quantified mass" | "deal" | "has lexical unit" |  | "FN" |  |
| fn:quantified_mass | /r/HasA | fn:fe:quantity | "quantified mass" | "quantity" | "/r/has a" |  | "FN" |  |
| fn:quantified_mass | /r/HasA | fn:fe:mass | "quantified mass" | "mass" | "/r/has a" |  | "FN" |  |
| fn:fe:individuals | /r/RelatedTo | fn:fe:mass | "individuals" | "mass" | "/r/related to" |  | "FN" |  |
| fn:quantified_mass | /r/HasA | fn:fe:individuals | "quantified mass" | "individuals" | "/r/has a" |  | "FN" |  |
| fn:quantified_mass | /r/HasA | fn:fe:q_prop | "quantified mass" | "q prop" | "/r/has a" |  | "FN" |  |
| fn:quantified_mass | /r/HasA | fn:fe:degree | "quantified mass" | "degree" | "/r/has a" |  | "FN" |  |
| fn:quantity | /r/IsA | fn:dimension | "quantity" | "dimension" | "/r/is a" |  | "FN" |  |
| fn:quantified_mass | /r/RelatedTo | fn:quantity | "quantified mass" | "quantity" | "/r/related to" |  | "FN" |  |
| fn:quantity | fn:HasLexicalUnit | fn:lu:quantity:level | "quantity" | "level" | "has lexical unit" |  | "FN" |  |
| fn:quantity | fn:HasLexicalUnit | fn:lu:quantity:amount | "quantity" | "amount" | "has lexical unit" |  | "FN" |  |
| fn:quantity | fn:HasLexicalUnit | fn:lu:quantity:quantity | "quantity" | "quantity" | "has lexical unit" |  | "FN" |  |
| fn:quantity | fn:HasLexicalUnit | fn:lu:quantity:number | "quantity" | "number" | "has lexical unit" |  | "FN" |  |
| fn:quantity | fn:HasLexicalUnit | fn:lu:quantity:extent | "quantity" | "extent" | "has lexical unit" |  | "FN" |  |
| fn:quantity | fn:HasLexicalUnit | fn:lu:quantity:degree | "quantity" | "degree" | "has lexical unit" |  | "FN" |  |
| fn:quantity | /r/HasA | fn:fe:entity | "quantity" | "entity" | "/r/has a" |  | "FN" |  |
| fn:quantity | /r/HasA | fn:fe:quantity | "quantity" | "quantity" | "/r/has a" |  | "FN" |  |
| fn:quantity | /r/HasA | fn:fe:value | "quantity" | "value" | "/r/has a" |  | "FN" |  |
| fn:quantity | /r/HasA | fn:fe:descriptor | "quantity" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:quarreling | /r/IsA | fn:discussion | "quarreling" | "discussion" | "/r/is a" |  | "FN" |  |
| fn:be_in_agreement_on_assessment | /r/UsedFor | fn:quarreling | "be in agreement on assessment" | "quarreling" | "/r/used for" |  | "FN" |  |
| fn:discussion | /r/SimilarTo | fn:quarreling | "discussion" | "quarreling" | "/r/similar to" |  | "FN" |  |
| fn:quarreling | fn:HasLexicalUnit | fn:lu:quarreling:argue | "quarreling" | "argue" | "has lexical unit" |  | "FN" |  |
| fn:quarreling | fn:HasLexicalUnit | fn:lu:quarreling:quarrel | "quarreling" | "quarrel" | "has lexical unit" |  | "FN" |  |
| fn:quarreling | fn:HasLexicalUnit | fn:lu:quarreling:bicker | "quarreling" | "bicker" | "has lexical unit" |  | "FN" |  |
| fn:quarreling | fn:HasLexicalUnit | fn:lu:quarreling:altercation | "quarreling" | "altercation" | "has lexical unit" |  | "FN" |  |
| fn:quarreling | fn:HasLexicalUnit | fn:lu:quarreling:argument | "quarreling" | "argument" | "has lexical unit" |  | "FN" |  |
| fn:quarreling | fn:HasLexicalUnit | fn:lu:quarreling:bickering | "quarreling" | "bickering" | "has lexical unit" |  | "FN" |  |
| fn:quarreling | fn:HasLexicalUnit | fn:lu:quarreling:disagreement | "quarreling" | "disagreement" | "has lexical unit" |  | "FN" |  |
| fn:quarreling | fn:HasLexicalUnit | fn:lu:quarreling:dispute | "quarreling" | "dispute" | "has lexical unit" |  | "FN" |  |
| fn:quarreling | fn:HasLexicalUnit | fn:lu:quarreling:disputation | "quarreling" | "disputation" | "has lexical unit" |  | "FN" |  |
| fn:quarreling | fn:HasLexicalUnit | fn:lu:quarreling:fight | "quarreling" | "fight" | "has lexical unit" |  | "FN" |  |
| fn:quarreling | fn:HasLexicalUnit | fn:lu:quarreling:fight | "quarreling" | "fight" | "has lexical unit" |  | "FN" |  |
| fn:quarreling | fn:HasLexicalUnit | fn:lu:quarreling:quarrel | "quarreling" | "quarrel" | "has lexical unit" |  | "FN" |  |
| fn:quarreling | fn:HasLexicalUnit | fn:lu:quarreling:quibble | "quarreling" | "quibble" | "has lexical unit" |  | "FN" |  |
| fn:quarreling | fn:HasLexicalUnit | fn:lu:quarreling:row | "quarreling" | "row" | "has lexical unit" |  | "FN" |  |
| fn:quarreling | fn:HasLexicalUnit | fn:lu:quarreling:row | "quarreling" | "row" | "has lexical unit" |  | "FN" |  |
| fn:quarreling | fn:HasLexicalUnit | fn:lu:quarreling:spat | "quarreling" | "spat" | "has lexical unit" |  | "FN" |  |
| fn:quarreling | fn:HasLexicalUnit | fn:lu:quarreling:squabble | "quarreling" | "squabble" | "has lexical unit" |  | "FN" |  |
| fn:quarreling | fn:HasLexicalUnit | fn:lu:quarreling:squabble | "quarreling" | "squabble" | "has lexical unit" |  | "FN" |  |
| fn:quarreling | fn:HasLexicalUnit | fn:lu:quarreling:tiff | "quarreling" | "tiff" | "has lexical unit" |  | "FN" |  |
| fn:quarreling | fn:HasLexicalUnit | fn:lu:quarreling:wrangle | "quarreling" | "wrangle" | "has lexical unit" |  | "FN" |  |
| fn:quarreling | fn:HasLexicalUnit | fn:lu:quarreling:wrangling | "quarreling" | "wrangling" | "has lexical unit" |  | "FN" |  |
| fn:quarreling | fn:HasLexicalUnit | fn:lu:quarreling:wrangle | "quarreling" | "wrangle" | "has lexical unit" |  | "FN" |  |
| fn:quarreling | /r/HasA | fn:fe:arguers | "quarreling" | "arguers" | "/r/has a" |  | "FN" |  |
| fn:fe:arguer1 | /r/HasPrerequisite | fn:fe:arguer2 | "arguer1" | "arguer2" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:arguer1 | /r/RelatedTo | fn:fe:arguers | "arguer1" | "arguers" | "/r/related to" |  | "FN" |  |
| fn:quarreling | /r/HasA | fn:fe:arguer1 | "quarreling" | "arguer1" | "/r/has a" |  | "FN" |  |
| fn:fe:arguer2 | /r/HasPrerequisite | fn:fe:arguer1 | "arguer2" | "arguer1" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:arguer2 | /r/RelatedTo | fn:fe:arguers | "arguer2" | "arguers" | "/r/related to" |  | "FN" |  |
| fn:quarreling | /r/HasA | fn:fe:arguer2 | "quarreling" | "arguer2" | "/r/has a" |  | "FN" |  |
| fn:quarreling | /r/HasA | fn:fe:issue | "quarreling" | "issue" | "/r/has a" |  | "FN" |  |
| fn:quarreling | /r/HasA | fn:fe:frequency | "quarreling" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:quarreling | /r/HasA | fn:fe:depictive | "quarreling" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:quarreling | /r/HasA | fn:fe:duration | "quarreling" | "duration" | "/r/has a" |  | "FN" |  |
| fn:quarreling | /r/HasA | fn:fe:manner | "quarreling" | "manner" | "/r/has a" |  | "FN" |  |
| fn:quarreling | /r/HasA | fn:fe:means | "quarreling" | "means" | "/r/has a" |  | "FN" |  |
| fn:quarreling | /r/HasA | fn:fe:medium | "quarreling" | "medium" | "/r/has a" |  | "FN" |  |
| fn:quarreling | /r/HasA | fn:fe:amount_of_discussion | "quarreling" | "amount of discussion" | "/r/has a" |  | "FN" |  |
| fn:quarreling | /r/HasA | fn:fe:purpose | "quarreling" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:quarreling | /r/HasA | fn:fe:place | "quarreling" | "place" | "/r/has a" |  | "FN" |  |
| fn:quarreling | /r/HasA | fn:fe:time | "quarreling" | "time" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:questioning | "communication" | "questioning" | "/r/used for" |  | "FN" |  |
| fn:questioning | /r/UsedFor | fn:court_examination | "questioning" | "court examination" | "/r/used for" |  | "FN" |  |
| fn:request | /r/SimilarTo | fn:questioning | "request" | "questioning" | "/r/similar to" |  | "FN" |  |
| fn:questioning | fn:HasLexicalUnit | fn:lu:questioning:grill | "questioning" | "grill" | "has lexical unit" |  | "FN" |  |
| fn:questioning | fn:HasLexicalUnit | fn:lu:questioning:inquire | "questioning" | "inquire" | "has lexical unit" |  | "FN" |  |
| fn:questioning | fn:HasLexicalUnit | fn:lu:questioning:inquiry | "questioning" | "inquiry" | "has lexical unit" |  | "FN" |  |
| fn:questioning | fn:HasLexicalUnit | fn:lu:questioning:interrogate | "questioning" | "interrogate" | "has lexical unit" |  | "FN" |  |
| fn:questioning | fn:HasLexicalUnit | fn:lu:questioning:interrogation | "questioning" | "interrogation" | "has lexical unit" |  | "FN" |  |
| fn:questioning | fn:HasLexicalUnit | fn:lu:questioning:query | "questioning" | "query" | "has lexical unit" |  | "FN" |  |
| fn:questioning | fn:HasLexicalUnit | fn:lu:questioning:query | "questioning" | "query" | "has lexical unit" |  | "FN" |  |
| fn:questioning | fn:HasLexicalUnit | fn:lu:questioning:question | "questioning" | "question" | "has lexical unit" |  | "FN" |  |
| fn:questioning | fn:HasLexicalUnit | fn:lu:questioning:question | "questioning" | "question" | "has lexical unit" |  | "FN" |  |
| fn:questioning | fn:HasLexicalUnit | fn:lu:questioning:questioning | "questioning" | "questioning" | "has lexical unit" |  | "FN" |  |
| fn:questioning | fn:HasLexicalUnit | fn:lu:questioning:quiz | "questioning" | "quiz" | "has lexical unit" |  | "FN" |  |
| fn:questioning | fn:HasLexicalUnit | fn:lu:questioning:ask | "questioning" | "ask" | "has lexical unit" |  | "FN" |  |
| fn:questioning | /r/HasA | fn:fe:speaker | "questioning" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:questioning | /r/HasA | fn:fe:addressee | "questioning" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:questioning | /r/HasA | fn:fe:message | "questioning" | "message" | "/r/has a" |  | "FN" |  |
| fn:questioning | /r/HasA | fn:fe:topic | "questioning" | "topic" | "/r/has a" |  | "FN" |  |
| fn:questioning | /r/HasA | fn:fe:medium | "questioning" | "medium" | "/r/has a" |  | "FN" |  |
| fn:questioning | /r/HasA | fn:fe:manner | "questioning" | "manner" | "/r/has a" |  | "FN" |  |
| fn:questioning | /r/HasA | fn:fe:internal_cause | "questioning" | "internal cause" | "/r/has a" |  | "FN" |  |
| fn:questioning | /r/HasA | fn:fe:time | "questioning" | "time" | "/r/has a" |  | "FN" |  |
| fn:questioning | /r/HasA | fn:fe:iterations | "questioning" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:quitting | /r/IsA | fn:employment_end | "quitting" | "employment end" | "/r/is a" |  | "FN" |  |
| fn:quitting | /r/IsA | fn:intentionally_act | "quitting" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:employee_scenario | /r/HasSubevent | fn:quitting | "employee scenario" | "quitting" | "/r/has subevent" |  | "FN" |  |
| fn:quitting | /r/HasPrerequisite | fn:being_employed | "quitting" | "being employed" | "/r/has prerequisite" |  | "FN" |  |
| fn:quitting | fn:HasLexicalUnit | fn:lu:quitting:quit | "quitting" | "quit" | "has lexical unit" |  | "FN" |  |
| fn:quitting | fn:HasLexicalUnit | fn:lu:quitting:resign | "quitting" | "resign" | "has lexical unit" |  | "FN" |  |
| fn:quitting | fn:HasLexicalUnit | fn:lu:quitting:retire | "quitting" | "retire" | "has lexical unit" |  | "FN" |  |
| fn:quitting | fn:HasLexicalUnit | fn:lu:quitting:stand_down | "quitting" | "stand down" | "has lexical unit" |  | "FN" |  |
| fn:quitting | fn:HasLexicalUnit | fn:lu:quitting:resignation | "quitting" | "resignation" | "has lexical unit" |  | "FN" |  |
| fn:quitting | fn:HasLexicalUnit | fn:lu:quitting:retirement | "quitting" | "retirement" | "has lexical unit" |  | "FN" |  |
| fn:quitting | fn:HasLexicalUnit | fn:lu:quitting:give_notice | "quitting" | "give notice" | "has lexical unit" |  | "FN" |  |
| fn:quitting | fn:HasLexicalUnit | fn:lu:quitting:step_down | "quitting" | "step down" | "has lexical unit" |  | "FN" |  |
| fn:quitting | fn:HasLexicalUnit | fn:lu:quitting:leave | "quitting" | "leave" | "has lexical unit" |  | "FN" |  |
| fn:quitting | /r/HasA | fn:fe:employee | "quitting" | "employee" | "/r/has a" |  | "FN" |  |
| fn:quitting | /r/HasA | fn:fe:employer | "quitting" | "employer" | "/r/has a" |  | "FN" |  |
| fn:quitting | /r/HasA | fn:fe:field | "quitting" | "field" | "/r/has a" |  | "FN" |  |
| fn:quitting | /r/HasA | fn:fe:manner | "quitting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:quitting | /r/HasA | fn:fe:place | "quitting" | "place" | "/r/has a" |  | "FN" |  |
| fn:quitting | /r/HasA | fn:fe:position | "quitting" | "position" | "/r/has a" |  | "FN" |  |
| fn:quitting | /r/HasA | fn:fe:purpose | "quitting" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:quitting | /r/HasA | fn:fe:time | "quitting" | "time" | "/r/has a" |  | "FN" |  |
| fn:quitting | /r/HasA | fn:fe:explanation | "quitting" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:quitting | /r/HasA | fn:fe:means | "quitting" | "means" | "/r/has a" |  | "FN" |  |
| fn:quitting_a_place | /r/IsA | fn:departing | "quitting a place" | "departing" | "/r/is a" |  | "FN" |  |
| fn:setting_out | /r/IsA | fn:quitting_a_place | "setting out" | "quitting a place" | "/r/is a" |  | "FN" |  |
| fn:intentional_traversing | /r/HasSubevent | fn:quitting_a_place | "intentional traversing" | "quitting a place" | "/r/has subevent" |  | "FN" |  |
| fn:self_motion | /r/HasSubevent | fn:quitting_a_place | "self motion" | "quitting a place" | "/r/has subevent" |  | "FN" |  |
| fn:departing | /r/SimilarTo | fn:quitting_a_place | "departing" | "quitting a place" | "/r/similar to" |  | "FN" |  |
| fn:quitting_a_place | fn:HasLexicalUnit | fn:lu:quitting_a_place:quit | "quitting a place" | "quit" | "has lexical unit" |  | "FN" |  |
| fn:quitting_a_place | fn:HasLexicalUnit | fn:lu:quitting_a_place:vamoose | "quitting a place" | "vamoose" | "has lexical unit" |  | "FN" |  |
| fn:quitting_a_place | fn:HasLexicalUnit | fn:lu:quitting_a_place:skedaddle | "quitting a place" | "skedaddle" | "has lexical unit" |  | "FN" |  |
| fn:quitting_a_place | fn:HasLexicalUnit | fn:lu:quitting_a_place:split | "quitting a place" | "split" | "has lexical unit" |  | "FN" |  |
| fn:quitting_a_place | fn:HasLexicalUnit | fn:lu:quitting_a_place:vacate | "quitting a place" | "vacate" | "has lexical unit" |  | "FN" |  |
| fn:quitting_a_place | fn:HasLexicalUnit | fn:lu:quitting_a_place:sally | "quitting a place" | "sally" | "has lexical unit" |  | "FN" |  |
| fn:quitting_a_place | fn:HasLexicalUnit | fn:lu:quitting_a_place:retreat | "quitting a place" | "retreat" | "has lexical unit" |  | "FN" |  |
| fn:quitting_a_place | fn:HasLexicalUnit | fn:lu:quitting_a_place:retreat | "quitting a place" | "retreat" | "has lexical unit" |  | "FN" |  |
| fn:quitting_a_place | fn:HasLexicalUnit | fn:lu:quitting_a_place:escapee | "quitting a place" | "escapee" | "has lexical unit" |  | "FN" |  |
| fn:quitting_a_place | fn:HasLexicalUnit | fn:lu:quitting_a_place:emigre | "quitting a place" | "emigre" | "has lexical unit" |  | "FN" |  |
| fn:quitting_a_place | fn:HasLexicalUnit | fn:lu:quitting_a_place:emigration | "quitting a place" | "emigration" | "has lexical unit" |  | "FN" |  |
| fn:quitting_a_place | fn:HasLexicalUnit | fn:lu:quitting_a_place:emigrate | "quitting a place" | "emigrate" | "has lexical unit" |  | "FN" |  |
| fn:quitting_a_place | fn:HasLexicalUnit | fn:lu:quitting_a_place:emigrant | "quitting a place" | "emigrant" | "has lexical unit" |  | "FN" |  |
| fn:quitting_a_place | fn:HasLexicalUnit | fn:lu:quitting_a_place:desertion | "quitting a place" | "desertion" | "has lexical unit" |  | "FN" |  |
| fn:quitting_a_place | fn:HasLexicalUnit | fn:lu:quitting_a_place:desert | "quitting a place" | "desert" | "has lexical unit" |  | "FN" |  |
| fn:quitting_a_place | fn:HasLexicalUnit | fn:lu:quitting_a_place:defect | "quitting a place" | "defect" | "has lexical unit" |  | "FN" |  |
| fn:quitting_a_place | fn:HasLexicalUnit | fn:lu:quitting_a_place:defection | "quitting a place" | "defection" | "has lexical unit" |  | "FN" |  |
| fn:quitting_a_place | fn:HasLexicalUnit | fn:lu:quitting_a_place:bolt | "quitting a place" | "bolt" | "has lexical unit" |  | "FN" |  |
| fn:quitting_a_place | fn:HasLexicalUnit | fn:lu:quitting_a_place:abandon | "quitting a place" | "abandon" | "has lexical unit" |  | "FN" |  |
| fn:quitting_a_place | /r/HasA | fn:fe:self_mover | "quitting a place" | "self mover" | "/r/has a" |  | "FN" |  |
| fn:quitting_a_place | /r/HasA | fn:fe:source | "quitting a place" | "source" | "/r/has a" |  | "FN" |  |
| fn:quitting_a_place | /r/HasA | fn:fe:path | "quitting a place" | "path" | "/r/has a" |  | "FN" |  |
| fn:quitting_a_place | /r/HasA | fn:fe:intended_goal | "quitting a place" | "intended goal" | "/r/has a" |  | "FN" |  |
| fn:quitting_a_place | /r/HasA | fn:fe:manner | "quitting a place" | "manner" | "/r/has a" |  | "FN" |  |
| fn:quitting_a_place | /r/HasA | fn:fe:means | "quitting a place" | "means" | "/r/has a" |  | "FN" |  |
| fn:quitting_a_place | /r/HasA | fn:fe:speed | "quitting a place" | "speed" | "/r/has a" |  | "FN" |  |
| fn:quitting_a_place | /r/HasA | fn:fe:co-participant | "quitting a place" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:quitting_a_place | /r/HasA | fn:fe:depictive | "quitting a place" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:quitting_a_place | /r/HasA | fn:fe:place | "quitting a place" | "place" | "/r/has a" |  | "FN" |  |
| fn:quitting_a_place | /r/HasA | fn:fe:path_shape | "quitting a place" | "path shape" | "/r/has a" |  | "FN" |  |
| fn:quitting_a_place | /r/HasA | fn:fe:direction | "quitting a place" | "direction" | "/r/has a" |  | "FN" |  |
| fn:quitting_a_place | /r/HasA | fn:fe:time | "quitting a place" | "time" | "/r/has a" |  | "FN" |  |
| fn:quitting_a_place | /r/HasA | fn:fe:purpose | "quitting a place" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:quitting_a_place | /r/HasA | fn:fe:vehicle | "quitting a place" | "vehicle" | "/r/has a" |  | "FN" |  |
| fn:quitting_a_place | /r/HasA | fn:fe:duration_of_final_state | "quitting a place" | "duration of final state" | "/r/has a" |  | "FN" |  |
| fn:quitting_a_place | /r/HasA | fn:fe:result | "quitting a place" | "result" | "/r/has a" |  | "FN" |  |
| fn:quitting_a_place | /r/HasA | fn:fe:explanation | "quitting a place" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:quitting_a_place | /r/HasA | fn:fe:reciprocation | "quitting a place" | "reciprocation" | "/r/has a" |  | "FN" |  |
| fn:quitting_a_place | /r/HasA | fn:fe:containing_event | "quitting a place" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:quitting_a_place | /r/HasA | fn:fe:frequency | "quitting a place" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:quitting_a_place | /r/HasA | fn:fe:re-encoding | "quitting a place" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:quitting_a_place | /r/HasA | fn:fe:new_situation | "quitting a place" | "new situation" | "/r/has a" |  | "FN" |  |
| fn:quitting_a_place | /r/HasA | fn:fe:circumstances | "quitting a place" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:quitting_a_place | /r/HasA | fn:fe:coordinated_event | "quitting a place" | "coordinated event" | "/r/has a" |  | "FN" |  |
| fn:quitting_a_place | /r/HasA | fn:fe:distance | "quitting a place" | "distance" | "/r/has a" |  | "FN" |  |
| fn:race_descriptor | /r/IsA | fn:attributes | "race descriptor" | "attributes" | "/r/is a" |  | "FN" |  |
| fn:people | /r/UsedFor | fn:race_descriptor | "people" | "race descriptor" | "/r/used for" |  | "FN" |  |
| fn:race_descriptor | fn:HasLexicalUnit | fn:lu:race_descriptor:white | "race descriptor" | "white" | "has lexical unit" |  | "FN" |  |
| fn:race_descriptor | fn:HasLexicalUnit | fn:lu:race_descriptor:black | "race descriptor" | "black" | "has lexical unit" |  | "FN" |  |
| fn:race_descriptor | fn:HasLexicalUnit | fn:lu:race_descriptor:color | "race descriptor" | "color" | "has lexical unit" |  | "FN" |  |
| fn:race_descriptor | fn:HasLexicalUnit | fn:lu:race_descriptor:yellow | "race descriptor" | "yellow" | "has lexical unit" |  | "FN" |  |
| fn:race_descriptor | fn:HasLexicalUnit | fn:lu:race_descriptor:asian | "race descriptor" | "asian" | "has lexical unit" |  | "FN" |  |
| fn:race_descriptor | fn:HasLexicalUnit | fn:lu:race_descriptor:hispanic | "race descriptor" | "hispanic" | "has lexical unit" |  | "FN" |  |
| fn:race_descriptor | /r/HasA | fn:fe:person | "race descriptor" | "person" | "/r/has a" |  | "FN" |  |
| fn:capability | /r/UsedFor | fn:range | "capability" | "range" | "/r/used for" |  | "FN" |  |
| fn:range | fn:HasLexicalUnit | fn:lu:range:range | "range" | "range" | "has lexical unit" |  | "FN" |  |
| fn:range | fn:HasLexicalUnit | fn:lu:range:earshot | "range" | "earshot" | "has lexical unit" |  | "FN" |  |
| fn:range | fn:HasLexicalUnit | fn:lu:range:reach | "range" | "reach" | "has lexical unit" |  | "FN" |  |
| fn:range | fn:HasLexicalUnit | fn:lu:range:view | "range" | "view" | "has lexical unit" |  | "FN" |  |
| fn:range | fn:HasLexicalUnit | fn:lu:range:distance | "range" | "distance" | "has lexical unit" |  | "FN" |  |
| fn:range | fn:HasLexicalUnit | fn:lu:range:strike | "range" | "strike" | "has lexical unit" |  | "FN" |  |
| fn:range | fn:HasLexicalUnit | fn:lu:range:intercontinental | "range" | "intercontinental" | "has lexical unit" |  | "FN" |  |
| fn:range | fn:HasLexicalUnit | fn:lu:range:sight | "range" | "sight" | "has lexical unit" |  | "FN" |  |
| fn:range | /r/HasA | fn:fe:event | "range" | "event" | "/r/has a" |  | "FN" |  |
| fn:range | /r/HasA | fn:fe:participant | "range" | "participant" | "/r/has a" |  | "FN" |  |
| fn:range | /r/HasA | fn:fe:instrument | "range" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:range | /r/HasA | fn:fe:distance | "range" | "distance" | "/r/has a" |  | "FN" |  |
| fn:range | /r/HasA | fn:fe:circumstances | "range" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:rank | /r/UsedFor | fn:appellations | "rank" | "appellations" | "/r/used for" |  | "FN" |  |
| fn:rank | /r/UsedFor | fn:occupy_rank | "rank" | "occupy rank" | "/r/used for" |  | "FN" |  |
| fn:rank | fn:HasLexicalUnit | fn:lu:rank:rank | "rank" | "rank" | "has lexical unit" |  | "FN" |  |
| fn:rank | fn:HasLexicalUnit | fn:lu:rank:level | "rank" | "level" | "has lexical unit" |  | "FN" |  |
| fn:rank | fn:HasLexicalUnit | fn:lu:rank:degree | "rank" | "degree" | "has lexical unit" |  | "FN" |  |
| fn:rank | fn:HasLexicalUnit | fn:lu:rank:order | "rank" | "order" | "has lexical unit" |  | "FN" |  |
| fn:rank | fn:HasLexicalUnit | fn:lu:rank:baseline | "rank" | "baseline" | "has lexical unit" |  | "FN" |  |
| fn:rank | /r/HasA | fn:fe:rank | "rank" | "rank" | "/r/has a" |  | "FN" |  |
| fn:rank | /r/HasA | fn:fe:item | "rank" | "item" | "/r/has a" |  | "FN" |  |
| fn:ranked_expectation | /r/RelatedTo | fn:completeness | "ranked expectation" | "completeness" | "/r/related to" |  | "FN" |  |
| fn:ranked_expectation | fn:HasLexicalUnit | fn:lu:ranked_expectation:entire | "ranked expectation" | "entire" | "has lexical unit" |  | "FN" |  |
| fn:ranked_expectation | fn:HasLexicalUnit | fn:lu:ranked_expectation:whole | "ranked expectation" | "whole" | "has lexical unit" |  | "FN" |  |
| fn:ranked_expectation | fn:HasLexicalUnit | fn:lu:ranked_expectation:mere | "ranked expectation" | "mere" | "has lexical unit" |  | "FN" |  |
| fn:ranked_expectation | /r/HasA | fn:fe:entity | "ranked expectation" | "entity" | "/r/has a" |  | "FN" |  |
| fn:rape | /r/IsA | fn:committing_crime | "rape" | "committing crime" | "/r/is a" |  | "FN" |  |
| fn:rape | /r/IsA | fn:intentionally_affect | "rape" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:rape | fn:HasLexicalUnit | fn:lu:rape:rape | "rape" | "rape" | "has lexical unit" |  | "FN" |  |
| fn:rape | fn:HasLexicalUnit | fn:lu:rape:rape | "rape" | "rape" | "has lexical unit" |  | "FN" |  |
| fn:rape | fn:HasLexicalUnit | fn:lu:rape:rapist | "rape" | "rapist" | "has lexical unit" |  | "FN" |  |
| fn:rape | fn:HasLexicalUnit | fn:lu:rape:raped | "rape" | "raped" | "has lexical unit" |  | "FN" |  |
| fn:rape | fn:HasLexicalUnit | fn:lu:rape:sexually_assault | "rape" | "sexually assault" | "has lexical unit" |  | "FN" |  |
| fn:rape | /r/HasA | fn:fe:perpetrator | "rape" | "perpetrator" | "/r/has a" |  | "FN" |  |
| fn:rape | /r/HasA | fn:fe:victim | "rape" | "victim" | "/r/has a" |  | "FN" |  |
| fn:rape | /r/HasA | fn:fe:degree | "rape" | "degree" | "/r/has a" |  | "FN" |  |
| fn:rape | /r/HasA | fn:fe:event | "rape" | "event" | "/r/has a" |  | "FN" |  |
| fn:rape | /r/HasA | fn:fe:manner | "rape" | "manner" | "/r/has a" |  | "FN" |  |
| fn:rape | /r/HasA | fn:fe:means | "rape" | "means" | "/r/has a" |  | "FN" |  |
| fn:rape | /r/HasA | fn:fe:result | "rape" | "result" | "/r/has a" |  | "FN" |  |
| fn:rape | /r/HasA | fn:fe:duration | "rape" | "duration" | "/r/has a" |  | "FN" |  |
| fn:rape | /r/HasA | fn:fe:place | "rape" | "place" | "/r/has a" |  | "FN" |  |
| fn:rape | /r/HasA | fn:fe:explanation | "rape" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:rape | /r/HasA | fn:fe:time | "rape" | "time" | "/r/has a" |  | "FN" |  |
| fn:rape | /r/HasA | fn:fe:instrument | "rape" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:rape | /r/HasA | fn:fe:purpose | "rape" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:rape | /r/HasA | fn:fe:frequency | "rape" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:rashness | /r/IsA | fn:social_behavior_evaluation | "rashness" | "social behavior evaluation" | "/r/is a" |  | "FN" |  |
| fn:rashness | fn:HasLexicalUnit | fn:lu:rashness:rash | "rashness" | "rash" | "has lexical unit" |  | "FN" |  |
| fn:rashness | fn:HasLexicalUnit | fn:lu:rashness:impatient | "rashness" | "impatient" | "has lexical unit" |  | "FN" |  |
| fn:rashness | fn:HasLexicalUnit | fn:lu:rashness:impetuous | "rashness" | "impetuous" | "has lexical unit" |  | "FN" |  |
| fn:rashness | fn:HasLexicalUnit | fn:lu:rashness:patient | "rashness" | "patient" | "has lexical unit" |  | "FN" |  |
| fn:rashness | fn:HasLexicalUnit | fn:lu:rashness:precipitate | "rashness" | "precipitate" | "has lexical unit" |  | "FN" |  |
| fn:rashness | fn:HasLexicalUnit | fn:lu:rashness:precipitous | "rashness" | "precipitous" | "has lexical unit" |  | "FN" |  |
| fn:rashness | /r/HasA | fn:fe:protagonist | "rashness" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:rashness | /r/HasA | fn:fe:action | "rashness" | "action" | "/r/has a" |  | "FN" |  |
| fn:rashness | /r/HasA | fn:fe:time | "rashness" | "time" | "/r/has a" |  | "FN" |  |
| fn:rashness | /r/HasA | fn:fe:degree | "rashness" | "degree" | "/r/has a" |  | "FN" |  |
| fn:rashness | /r/HasA | fn:fe:judge | "rashness" | "judge" | "/r/has a" |  | "FN" |  |
| fn:rate_description | /r/IsA | fn:measurable_attributes | "rate description" | "measurable attributes" | "/r/is a" |  | "FN" |  |
| fn:rate_description | fn:HasLexicalUnit | fn:lu:rate_description:rapid | "rate description" | "rapid" | "has lexical unit" |  | "FN" |  |
| fn:rate_description | fn:HasLexicalUnit | fn:lu:rate_description:rapidly | "rate description" | "rapidly" | "has lexical unit" |  | "FN" |  |
| fn:rate_description | fn:HasLexicalUnit | fn:lu:rate_description:fast | "rate description" | "fast" | "has lexical unit" |  | "FN" |  |
| fn:fe:event | /r/IsA | fn:st:event | "event" | "event" | "/r/is a" |  | "FN" |  |
| fn:rate_description | /r/HasA | fn:fe:event | "rate description" | "event" | "/r/has a" |  | "FN" |  |
| fn:rate_description | /r/HasA | fn:fe:rate | "rate description" | "rate" | "/r/has a" |  | "FN" |  |
| fn:rate_description | /r/HasA | fn:fe:degree | "rate description" | "degree" | "/r/has a" |  | "FN" |  |
| fn:rate_description | /r/HasA | fn:fe:agent | "rate description" | "agent" | "/r/has a" |  | "FN" |  |
| fn:rate_quantification | /r/IsA | fn:relational_quantity | "rate quantification" | "relational quantity" | "/r/is a" |  | "FN" |  |
| fn:rate_quantification | fn:HasLexicalUnit | fn:lu:rate_quantification:rate | "rate quantification" | "rate" | "has lexical unit" |  | "FN" |  |
| fn:rate_quantification | /r/HasA | fn:fe:event | "rate quantification" | "event" | "/r/has a" |  | "FN" |  |
| fn:rate_quantification | /r/HasA | fn:fe:rate | "rate quantification" | "rate" | "/r/has a" |  | "FN" |  |
| fn:rate_quantification | /r/HasA | fn:fe:descriptor | "rate quantification" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:rate_quantification | /r/HasA | fn:fe:entity | "rate quantification" | "entity" | "/r/has a" |  | "FN" |  |
| fn:rate_quantification | /r/HasA | fn:fe:type | "rate quantification" | "type" | "/r/has a" |  | "FN" |  |
| fn:rate_quantification | /r/HasA | fn:fe:degree | "rate quantification" | "degree" | "/r/has a" |  | "FN" |  |
| fn:ratification | fn:HasLexicalUnit | fn:lu:ratification:ratify | "ratification" | "ratify" | "has lexical unit" |  | "FN" |  |
| fn:ratification | fn:HasLexicalUnit | fn:lu:ratification:ratification | "ratification" | "ratification" | "has lexical unit" |  | "FN" |  |
| fn:fe:ratifier | /r/IsA | fn:st:sentient | "ratifier" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:ratification | /r/HasA | fn:fe:ratifier | "ratification" | "ratifier" | "/r/has a" |  | "FN" |  |
| fn:ratification | /r/HasA | fn:fe:proposal | "ratification" | "proposal" | "/r/has a" |  | "FN" |  |
| fn:ratification | /r/HasA | fn:fe:time | "ratification" | "time" | "/r/has a" |  | "FN" |  |
| fn:ratification | /r/HasA | fn:fe:place | "ratification" | "place" | "/r/has a" |  | "FN" |  |
| fn:ratification | /r/HasA | fn:fe:purpose | "ratification" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:ratification | /r/HasA | fn:fe:explanation | "ratification" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:ratification | /r/HasA | fn:fe:manner | "ratification" | "manner" | "/r/has a" |  | "FN" |  |
| fn:ratification | /r/HasA | fn:fe:means | "ratification" | "means" | "/r/has a" |  | "FN" |  |
| fn:reading_aloud | /r/IsA | fn:reading_activity | "reading aloud" | "reading activity" | "/r/is a" |  | "FN" |  |
| fn:reading_perception | /r/IsA | fn:reading_activity | "reading perception" | "reading activity" | "/r/is a" |  | "FN" |  |
| fn:reading_activity | /r/RelatedTo | fn:reading_perception | "reading activity" | "reading perception" | "/r/related to" |  | "FN" |  |
| fn:reading_perception | /r/SimilarTo | fn:reading_activity | "reading perception" | "reading activity" | "/r/similar to" |  | "FN" |  |
| fn:reading_activity | fn:HasLexicalUnit | fn:lu:reading_activity:read | "reading activity" | "read" | "has lexical unit" |  | "FN" |  |
| fn:fe:reader | /r/IsA | fn:st:sentient | "reader" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:reading_activity | /r/HasA | fn:fe:reader | "reading activity" | "reader" | "/r/has a" |  | "FN" |  |
| fn:reading_activity | /r/HasA | fn:fe:text | "reading activity" | "text" | "/r/has a" |  | "FN" |  |
| fn:reading_activity | /r/HasA | fn:fe:degree | "reading activity" | "degree" | "/r/has a" |  | "FN" |  |
| fn:reading_activity | /r/HasA | fn:fe:sought_phenomenon | "reading activity" | "sought phenomenon" | "/r/has a" |  | "FN" |  |
| fn:reading_activity | /r/HasA | fn:fe:manner | "reading activity" | "manner" | "/r/has a" |  | "FN" |  |
| fn:reading_activity | /r/HasA | fn:fe:means | "reading activity" | "means" | "/r/has a" |  | "FN" |  |
| fn:reading_activity | /r/HasA | fn:fe:purpose | "reading activity" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:reading_activity | /r/HasA | fn:fe:time | "reading activity" | "time" | "/r/has a" |  | "FN" |  |
| fn:reading_activity | /r/HasA | fn:fe:place | "reading activity" | "place" | "/r/has a" |  | "FN" |  |
| fn:reading_activity | /r/HasA | fn:fe:circumstances | "reading activity" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:reading_activity | /r/HasA | fn:fe:textual_location | "reading activity" | "textual location" | "/r/has a" |  | "FN" |  |
| fn:fe:topic | /r/RelatedTo | fn:fe:text | "topic" | "text" | "/r/related to" |  | "FN" |  |
| fn:reading_activity | /r/HasA | fn:fe:topic | "reading activity" | "topic" | "/r/has a" |  | "FN" |  |
| fn:reading_activity | /r/HasA | fn:fe:frequency | "reading activity" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:reading_aloud | /r/IsA | fn:reading_activity | "reading aloud" | "reading activity" | "/r/is a" |  | "FN" |  |
| fn:reading_aloud | /r/IsA | fn:statement | "reading aloud" | "statement" | "/r/is a" |  | "FN" |  |
| fn:reading_aloud | fn:HasLexicalUnit | fn:lu:reading_aloud:read | "reading aloud" | "read" | "has lexical unit" |  | "FN" |  |
| fn:reading_aloud | fn:HasLexicalUnit | fn:lu:reading_aloud:read_out | "reading aloud" | "read out" | "has lexical unit" |  | "FN" |  |
| fn:reading_aloud | /r/HasA | fn:fe:addressee | "reading aloud" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:reading_aloud | /r/HasA | fn:fe:speaker | "reading aloud" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:reading_aloud | /r/HasA | fn:fe:text | "reading aloud" | "text" | "/r/has a" |  | "FN" |  |
| fn:reading_aloud | /r/HasA | fn:fe:manner | "reading aloud" | "manner" | "/r/has a" |  | "FN" |  |
| fn:reading_aloud | /r/HasA | fn:fe:source | "reading aloud" | "source" | "/r/has a" |  | "FN" |  |
| fn:reading_aloud | /r/HasA | fn:fe:time | "reading aloud" | "time" | "/r/has a" |  | "FN" |  |
| fn:reading_aloud | /r/HasA | fn:fe:purpose | "reading aloud" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:reading_aloud | /r/HasA | fn:fe:place | "reading aloud" | "place" | "/r/has a" |  | "FN" |  |
| fn:reading_aloud | /r/HasA | fn:fe:means | "reading aloud" | "means" | "/r/has a" |  | "FN" |  |
| fn:reading_perception | /r/IsA | fn:reading_activity | "reading perception" | "reading activity" | "/r/is a" |  | "FN" |  |
| fn:reading_perception | /r/IsA | fn:scrutiny | "reading perception" | "scrutiny" | "/r/is a" |  | "FN" |  |
| fn:reading_activity | /r/RelatedTo | fn:reading_perception | "reading activity" | "reading perception" | "/r/related to" |  | "FN" |  |
| fn:reading_perception | /r/SimilarTo | fn:reading_activity | "reading perception" | "reading activity" | "/r/similar to" |  | "FN" |  |
| fn:reading_perception | /r/SimilarTo | fn:scrutiny | "reading perception" | "scrutiny" | "/r/similar to" |  | "FN" |  |
| fn:reading_perception | fn:HasLexicalUnit | fn:lu:reading_perception:read | "reading perception" | "read" | "has lexical unit" |  | "FN" |  |
| fn:reading_perception | fn:HasLexicalUnit | fn:lu:reading_perception:pore | "reading perception" | "pore" | "has lexical unit" |  | "FN" |  |
| fn:reading_perception | fn:HasLexicalUnit | fn:lu:reading_perception:scan | "reading perception" | "scan" | "has lexical unit" |  | "FN" |  |
| fn:reading_perception | fn:HasLexicalUnit | fn:lu:reading_perception:skim | "reading perception" | "skim" | "has lexical unit" |  | "FN" |  |
| fn:reading_perception | fn:HasLexicalUnit | fn:lu:reading_perception:devour | "reading perception" | "devour" | "has lexical unit" |  | "FN" |  |
| fn:reading_perception | fn:HasLexicalUnit | fn:lu:reading_perception:reader | "reading perception" | "reader" | "has lexical unit" |  | "FN" |  |
| fn:reading_perception | fn:HasLexicalUnit | fn:lu:reading_perception:peruse | "reading perception" | "peruse" | "has lexical unit" |  | "FN" |  |
| fn:reading_perception | fn:HasLexicalUnit | fn:lu:reading_perception:perusal | "reading perception" | "perusal" | "has lexical unit" |  | "FN" |  |
| fn:reading_perception | /r/HasA | fn:fe:reader | "reading perception" | "reader" | "/r/has a" |  | "FN" |  |
| fn:reading_perception | /r/HasA | fn:fe:text | "reading perception" | "text" | "/r/has a" |  | "FN" |  |
| fn:reading_perception | /r/HasA | fn:fe:degree | "reading perception" | "degree" | "/r/has a" |  | "FN" |  |
| fn:reading_perception | /r/HasA | fn:fe:sought_phenomenon | "reading perception" | "sought phenomenon" | "/r/has a" |  | "FN" |  |
| fn:reading_perception | /r/HasA | fn:fe:manner | "reading perception" | "manner" | "/r/has a" |  | "FN" |  |
| fn:reading_perception | /r/HasA | fn:fe:means | "reading perception" | "means" | "/r/has a" |  | "FN" |  |
| fn:reading_perception | /r/HasA | fn:fe:purpose | "reading perception" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:reading_perception | /r/HasA | fn:fe:time | "reading perception" | "time" | "/r/has a" |  | "FN" |  |
| fn:reading_perception | /r/HasA | fn:fe:place | "reading perception" | "place" | "/r/has a" |  | "FN" |  |
| fn:reading_perception | /r/HasA | fn:fe:circumstances | "reading perception" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:reading_perception | /r/HasA | fn:fe:context | "reading perception" | "context" | "/r/has a" |  | "FN" |  |
| fn:intentionally_act | /r/UsedFor | fn:reason | "intentionally act" | "reason" | "/r/used for" |  | "FN" |  |
| fn:reason | /r/UsedFor | fn:deserving | "reason" | "deserving" | "/r/used for" |  | "FN" |  |
| fn:reason | fn:HasLexicalUnit | fn:lu:reason:reason | "reason" | "reason" | "has lexical unit" |  | "FN" |  |
| fn:reason | fn:HasLexicalUnit | fn:lu:reason:why | "reason" | "why" | "has lexical unit" |  | "FN" |  |
| fn:reason | fn:HasLexicalUnit | fn:lu:reason:motive | "reason" | "motive" | "has lexical unit" |  | "FN" |  |
| fn:reason | fn:HasLexicalUnit | fn:lu:reason:motivation | "reason" | "motivation" | "has lexical unit" |  | "FN" |  |
| fn:reason | fn:HasLexicalUnit | fn:lu:reason:basis | "reason" | "basis" | "has lexical unit" |  | "FN" |  |
| fn:reason | /r/HasA | fn:fe:agent | "reason" | "agent" | "/r/has a" |  | "FN" |  |
| fn:reason | /r/HasA | fn:fe:action | "reason" | "action" | "/r/has a" |  | "FN" |  |
| fn:reason | /r/HasA | fn:fe:state_of_affairs | "reason" | "state of affairs" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:reasoning | "communication" | "reasoning" | "/r/used for" |  | "FN" |  |
| fn:reasoning | fn:HasLexicalUnit | fn:lu:reasoning:argue | "reasoning" | "argue" | "has lexical unit" |  | "FN" |  |
| fn:reasoning | fn:HasLexicalUnit | fn:lu:reasoning:prove | "reasoning" | "prove" | "has lexical unit" |  | "FN" |  |
| fn:reasoning | fn:HasLexicalUnit | fn:lu:reasoning:reason | "reasoning" | "reason" | "has lexical unit" |  | "FN" |  |
| fn:reasoning | fn:HasLexicalUnit | fn:lu:reasoning:demonstrate | "reasoning" | "demonstrate" | "has lexical unit" |  | "FN" |  |
| fn:reasoning | fn:HasLexicalUnit | fn:lu:reasoning:show | "reasoning" | "show" | "has lexical unit" |  | "FN" |  |
| fn:reasoning | fn:HasLexicalUnit | fn:lu:reasoning:disprove | "reasoning" | "disprove" | "has lexical unit" |  | "FN" |  |
| fn:reasoning | fn:HasLexicalUnit | fn:lu:reasoning:argument | "reasoning" | "argument" | "has lexical unit" |  | "FN" |  |
| fn:reasoning | fn:HasLexicalUnit | fn:lu:reasoning:polemic | "reasoning" | "polemic" | "has lexical unit" |  | "FN" |  |
| fn:reasoning | fn:HasLexicalUnit | fn:lu:reasoning:case | "reasoning" | "case" | "has lexical unit" |  | "FN" |  |
| fn:reasoning | fn:HasLexicalUnit | fn:lu:reasoning:demonstration | "reasoning" | "demonstration" | "has lexical unit" |  | "FN" |  |
| fn:reasoning | fn:HasLexicalUnit | fn:lu:reasoning:reasoning | "reasoning" | "reasoning" | "has lexical unit" |  | "FN" |  |
| fn:reasoning | /r/HasA | fn:fe:content | "reasoning" | "content" | "/r/has a" |  | "FN" |  |
| fn:reasoning | /r/HasA | fn:fe:medium | "reasoning" | "medium" | "/r/has a" |  | "FN" |  |
| fn:fe:arguer | /r/IsA | fn:st:sentient | "arguer" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:reasoning | /r/HasA | fn:fe:arguer | "reasoning" | "arguer" | "/r/has a" |  | "FN" |  |
| fn:reasoning | /r/HasA | fn:fe:addressee | "reasoning" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:reasoning | /r/HasA | fn:fe:support | "reasoning" | "support" | "/r/has a" |  | "FN" |  |
| fn:reasoning | /r/HasA | fn:fe:manner | "reasoning" | "manner" | "/r/has a" |  | "FN" |  |
| fn:reasoning | /r/HasA | fn:fe:means | "reasoning" | "means" | "/r/has a" |  | "FN" |  |
| fn:reasoning | /r/HasA | fn:fe:depictive | "reasoning" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:reasoning | /r/HasA | fn:fe:result | "reasoning" | "result" | "/r/has a" |  | "FN" |  |
| fn:reasoning | /r/HasA | fn:fe:degree | "reasoning" | "degree" | "/r/has a" |  | "FN" |  |
| fn:reasoning | /r/HasA | fn:fe:time | "reasoning" | "time" | "/r/has a" |  | "FN" |  |
| fn:reasoning | /r/HasA | fn:fe:place | "reasoning" | "place" | "/r/has a" |  | "FN" |  |
| fn:reasoning | /r/HasA | fn:fe:duration | "reasoning" | "duration" | "/r/has a" |  | "FN" |  |
| fn:reasoning | /r/HasA | fn:fe:group | "reasoning" | "group" | "/r/has a" |  | "FN" |  |
| fn:reassuring | /r/IsA | fn:communication | "reassuring" | "communication" | "/r/is a" |  | "FN" |  |
| fn:reassuring | fn:HasLexicalUnit | fn:lu:reassuring:reassurance | "reassuring" | "reassurance" | "has lexical unit" |  | "FN" |  |
| fn:reassuring | fn:HasLexicalUnit | fn:lu:reassuring:reassure | "reassuring" | "reassure" | "has lexical unit" |  | "FN" |  |
| fn:reassuring | /r/HasA | fn:fe:speaker | "reassuring" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:reassuring | /r/HasA | fn:fe:experiencer | "reassuring" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:fe:message | /r/IsA | fn:st:content | "message" | "content" | "/r/is a" |  | "FN" |  |
| fn:reassuring | /r/HasA | fn:fe:message | "reassuring" | "message" | "/r/has a" |  | "FN" |  |
| fn:reassuring | /r/HasA | fn:fe:situation | "reassuring" | "situation" | "/r/has a" |  | "FN" |  |
| fn:reassuring | /r/HasA | fn:fe:medium | "reassuring" | "medium" | "/r/has a" |  | "FN" |  |
| fn:reassuring | /r/HasA | fn:fe:amount_of_reassurance | "reassuring" | "amount of reassurance" | "/r/has a" |  | "FN" |  |
| fn:reassuring | /r/HasA | fn:fe:depictive | "reassuring" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:reassuring | /r/HasA | fn:fe:manner | "reassuring" | "manner" | "/r/has a" |  | "FN" |  |
| fn:reassuring | /r/HasA | fn:fe:means | "reassuring" | "means" | "/r/has a" |  | "FN" |  |
| fn:reassuring | /r/HasA | fn:fe:time | "reassuring" | "time" | "/r/has a" |  | "FN" |  |
| fn:rebellion | /r/UsedFor | fn:revolution | "rebellion" | "revolution" | "/r/used for" |  | "FN" |  |
| fn:rebellion | fn:HasLexicalUnit | fn:lu:rebellion:insurgence | "rebellion" | "insurgence" | "has lexical unit" |  | "FN" |  |
| fn:rebellion | fn:HasLexicalUnit | fn:lu:rebellion:insurgency | "rebellion" | "insurgency" | "has lexical unit" |  | "FN" |  |
| fn:rebellion | fn:HasLexicalUnit | fn:lu:rebellion:insurgent | "rebellion" | "insurgent" | "has lexical unit" |  | "FN" |  |
| fn:rebellion | fn:HasLexicalUnit | fn:lu:rebellion:rebel | "rebellion" | "rebel" | "has lexical unit" |  | "FN" |  |
| fn:rebellion | fn:HasLexicalUnit | fn:lu:rebellion:insurge | "rebellion" | "insurge" | "has lexical unit" |  | "FN" |  |
| fn:rebellion | fn:HasLexicalUnit | fn:lu:rebellion:rebel | "rebellion" | "rebel" | "has lexical unit" |  | "FN" |  |
| fn:rebellion | /r/HasA | fn:fe:rebel | "rebellion" | "rebel" | "/r/has a" |  | "FN" |  |
| fn:rebellion | /r/HasA | fn:fe:current_leadership | "rebellion" | "current leadership" | "/r/has a" |  | "FN" |  |
| fn:rebellion | /r/HasA | fn:fe:current_order | "rebellion" | "current order" | "/r/has a" |  | "FN" |  |
| fn:rebellion | /r/HasA | fn:fe:place | "rebellion" | "place" | "/r/has a" |  | "FN" |  |
| fn:rebellion | /r/HasA | fn:fe:time | "rebellion" | "time" | "/r/has a" |  | "FN" |  |
| fn:rebellion | /r/HasA | fn:fe:means | "rebellion" | "means" | "/r/has a" |  | "FN" |  |
| fn:rebellion | /r/HasA | fn:fe:degree | "rebellion" | "degree" | "/r/has a" |  | "FN" |  |
| fn:rebellion | /r/HasA | fn:fe:manner | "rebellion" | "manner" | "/r/has a" |  | "FN" |  |
| fn:rebellion | /r/HasA | fn:fe:new_order | "rebellion" | "new order" | "/r/has a" |  | "FN" |  |
| fn:rebellion | /r/HasA | fn:fe:result | "rebellion" | "result" | "/r/has a" |  | "FN" |  |
| fn:rebellion | /r/HasA | fn:fe:duration | "rebellion" | "duration" | "/r/has a" |  | "FN" |  |
| fn:receive_visitor_scenario | /r/HasSubevent | fn:have_visitor_over | "receive visitor scenario" | "have visitor over" | "/r/has subevent" |  | "FN" |  |
| fn:receive_visitor_scenario | /r/IsA | fn:visitor_and_host | "receive visitor scenario" | "visitor and host" | "/r/is a" |  | "FN" |  |
| fn:receive_visitor_scenario | /r/HasA | fn:fe:host | "receive visitor scenario" | "host" | "/r/has a" |  | "FN" |  |
| fn:receive_visitor_scenario | /r/HasA | fn:fe:visitor | "receive visitor scenario" | "visitor" | "/r/has a" |  | "FN" |  |
| fn:receive_visitor_scenario | /r/HasA | fn:fe:purpose | "receive visitor scenario" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:receiving | /r/IsA | fn:getting | "receiving" | "getting" | "/r/is a" |  | "FN" |  |
| fn:borrowing | /r/IsA | fn:receiving | "borrowing" | "receiving" | "/r/is a" |  | "FN" |  |
| fn:receiving_scenario | /r/HasSubevent | fn:receiving | "receiving scenario" | "receiving" | "/r/has subevent" |  | "FN" |  |
| fn:receiving | /r/HasPrerequisite | fn:pre_receiving | "receiving" | "pre receiving" | "/r/has prerequisite" |  | "FN" |  |
| fn:post_receiving | /r/HasPrerequisite | fn:receiving | "post receiving" | "receiving" | "/r/has prerequisite" |  | "FN" |  |
| fn:receiving | /r/IsA | fn:transfer | "receiving" | "transfer" | "/r/is a" |  | "FN" |  |
| fn:receiving | fn:HasLexicalUnit | fn:lu:receiving:receive | "receiving" | "receive" | "has lexical unit" |  | "FN" |  |
| fn:receiving | fn:HasLexicalUnit | fn:lu:receiving:accept | "receiving" | "accept" | "has lexical unit" |  | "FN" |  |
| fn:receiving | fn:HasLexicalUnit | fn:lu:receiving:receipt | "receiving" | "receipt" | "has lexical unit" |  | "FN" |  |
| fn:receiving | /r/HasA | fn:fe:recipient | "receiving" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:fe:donor | /r/IsA | fn:st:source | "donor" | "source" | "/r/is a" |  | "FN" |  |
| fn:receiving | /r/HasA | fn:fe:donor | "receiving" | "donor" | "/r/has a" |  | "FN" |  |
| fn:receiving | /r/HasA | fn:fe:theme | "receiving" | "theme" | "/r/has a" |  | "FN" |  |
| fn:receiving | /r/HasA | fn:fe:purpose_of_donor | "receiving" | "purpose of donor" | "/r/has a" |  | "FN" |  |
| fn:receiving | /r/HasA | fn:fe:means | "receiving" | "means" | "/r/has a" |  | "FN" |  |
| fn:receiving | /r/HasA | fn:fe:time | "receiving" | "time" | "/r/has a" |  | "FN" |  |
| fn:receiving | /r/HasA | fn:fe:place | "receiving" | "place" | "/r/has a" |  | "FN" |  |
| fn:receiving | /r/HasA | fn:fe:mode_of_transfer | "receiving" | "mode of transfer" | "/r/has a" |  | "FN" |  |
| fn:receiving | /r/HasA | fn:fe:depictive | "receiving" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:receiving | /r/HasA | fn:fe:manner | "receiving" | "manner" | "/r/has a" |  | "FN" |  |
| fn:receiving | /r/HasA | fn:fe:countertransfer | "receiving" | "countertransfer" | "/r/has a" |  | "FN" |  |
| fn:receiving | /r/HasA | fn:fe:path | "receiving" | "path" | "/r/has a" |  | "FN" |  |
| fn:receiving | /r/HasA | fn:fe:purpose_of_theme | "receiving" | "purpose of theme" | "/r/has a" |  | "FN" |  |
| fn:receiving | /r/HasA | fn:fe:role | "receiving" | "role" | "/r/has a" |  | "FN" |  |
| fn:receiving_scenario | /r/IsA | fn:getting_scenario | "receiving scenario" | "getting scenario" | "/r/is a" |  | "FN" |  |
| fn:receiving_scenario | /r/HasSubevent | fn:post_receiving | "receiving scenario" | "post receiving" | "/r/has subevent" |  | "FN" |  |
| fn:receiving_scenario | /r/HasSubevent | fn:pre_receiving | "receiving scenario" | "pre receiving" | "/r/has subevent" |  | "FN" |  |
| fn:receiving_scenario | /r/HasSubevent | fn:receiving | "receiving scenario" | "receiving" | "/r/has subevent" |  | "FN" |  |
| fn:receiving_scenario | /r/IsA | fn:transfer_scenario | "receiving scenario" | "transfer scenario" | "/r/is a" |  | "FN" |  |
| fn:receiving_scenario | /r/HasA | fn:fe:recipient | "receiving scenario" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:receiving_scenario | /r/HasA | fn:fe:donor | "receiving scenario" | "donor" | "/r/has a" |  | "FN" |  |
| fn:receiving_scenario | /r/HasA | fn:fe:theme | "receiving scenario" | "theme" | "/r/has a" |  | "FN" |  |
| fn:receiving_scenario | /r/HasA | fn:fe:purpose | "receiving scenario" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:receiving_scenario | /r/HasA | fn:fe:means | "receiving scenario" | "means" | "/r/has a" |  | "FN" |  |
| fn:receiving_scenario | /r/HasA | fn:fe:mode_of_transfer | "receiving scenario" | "mode of transfer" | "/r/has a" |  | "FN" |  |
| fn:amalgamation | /r/IsA | fn:reciprocality | "amalgamation" | "reciprocality" | "/r/is a" |  | "FN" |  |
| fn:arithmetic | /r/IsA | fn:reciprocality | "arithmetic" | "reciprocality" | "/r/is a" |  | "FN" |  |
| fn:being_attached | /r/IsA | fn:reciprocality | "being attached" | "reciprocality" | "/r/is a" |  | "FN" |  |
| fn:chatting | /r/IsA | fn:reciprocality | "chatting" | "reciprocality" | "/r/is a" |  | "FN" |  |
| fn:collaboration | /r/IsA | fn:reciprocality | "collaboration" | "reciprocality" | "/r/is a" |  | "FN" |  |
| fn:commercial_transaction | /r/IsA | fn:reciprocality | "commercial transaction" | "reciprocality" | "/r/is a" |  | "FN" |  |
| fn:exchange | /r/IsA | fn:reciprocality | "exchange" | "reciprocality" | "/r/is a" |  | "FN" |  |
| fn:make_acquaintance | /r/IsA | fn:reciprocality | "make acquaintance" | "reciprocality" | "/r/is a" |  | "FN" |  |
| fn:sharing | /r/IsA | fn:reciprocality | "sharing" | "reciprocality" | "/r/is a" |  | "FN" |  |
| fn:similarity | /r/IsA | fn:reciprocality | "similarity" | "reciprocality" | "/r/is a" |  | "FN" |  |
| fn:reciprocality | /r/UsedFor | fn:commonality | "reciprocality" | "commonality" | "/r/used for" |  | "FN" |  |
| fn:reciprocality | /r/UsedFor | fn:participation | "reciprocality" | "participation" | "/r/used for" |  | "FN" |  |
| fn:asymmetric_reciprocality | /r/IsA | fn:reciprocality | "asymmetric reciprocality" | "reciprocality" | "/r/is a" |  | "FN" |  |
| fn:symmetrical_collective_reciprocality | /r/IsA | fn:reciprocality | "symmetrical collective reciprocality" | "reciprocality" | "/r/is a" |  | "FN" |  |
| fn:fe:protagonist_1 | /r/RelatedTo | fn:fe:protagonists | "protagonist 1" | "protagonists" | "/r/related to" |  | "FN" |  |
| fn:reciprocality | /r/HasA | fn:fe:protagonist_1 | "reciprocality" | "protagonist 1" | "/r/has a" |  | "FN" |  |
| fn:fe:protagonist_2 | /r/RelatedTo | fn:fe:protagonists | "protagonist 2" | "protagonists" | "/r/related to" |  | "FN" |  |
| fn:reciprocality | /r/HasA | fn:fe:protagonist_2 | "reciprocality" | "protagonist 2" | "/r/has a" |  | "FN" |  |
| fn:reciprocality | /r/HasA | fn:fe:protagonists | "reciprocality" | "protagonists" | "/r/has a" |  | "FN" |  |
| fn:recording | /r/IsA | fn:statement | "recording" | "statement" | "/r/is a" |  | "FN" |  |
| fn:recording | fn:HasLexicalUnit | fn:lu:recording:record | "recording" | "record" | "has lexical unit" |  | "FN" |  |
| fn:recording | fn:HasLexicalUnit | fn:lu:recording:register | "recording" | "register" | "has lexical unit" |  | "FN" |  |
| fn:recording | fn:HasLexicalUnit | fn:lu:recording:document | "recording" | "document" | "has lexical unit" |  | "FN" |  |
| fn:recording | fn:HasLexicalUnit | fn:lu:recording:chronicle | "recording" | "chronicle" | "has lexical unit" |  | "FN" |  |
| fn:recording | /r/HasA | fn:fe:agent | "recording" | "agent" | "/r/has a" |  | "FN" |  |
| fn:recording | /r/HasA | fn:fe:phenomenon | "recording" | "phenomenon" | "/r/has a" |  | "FN" |  |
| fn:recording | /r/HasA | fn:fe:manner | "recording" | "manner" | "/r/has a" |  | "FN" |  |
| fn:recording | /r/HasA | fn:fe:means | "recording" | "means" | "/r/has a" |  | "FN" |  |
| fn:recording | /r/HasA | fn:fe:time | "recording" | "time" | "/r/has a" |  | "FN" |  |
| fn:recording | /r/HasA | fn:fe:purpose | "recording" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:recording | /r/HasA | fn:fe:instrument | "recording" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:fe:attribute | /r/RelatedTo | fn:fe:phenomenon | "attribute" | "phenomenon" | "/r/related to" |  | "FN" |  |
| fn:recording | /r/HasA | fn:fe:attribute | "recording" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:fe:value | /r/RelatedTo | fn:fe:phenomenon | "value" | "phenomenon" | "/r/related to" |  | "FN" |  |
| fn:recording | /r/HasA | fn:fe:value | "recording" | "value" | "/r/has a" |  | "FN" |  |
| fn:recording | /r/HasA | fn:fe:entity | "recording" | "entity" | "/r/has a" |  | "FN" |  |
| fn:recording | /r/HasA | fn:fe:medium | "recording" | "medium" | "/r/has a" |  | "FN" |  |
| fn:recording | /r/HasA | fn:fe:language | "recording" | "language" | "/r/has a" |  | "FN" |  |
| fn:recording | /r/HasA | fn:fe:place | "recording" | "place" | "/r/has a" |  | "FN" |  |
| fn:recording | /r/HasA | fn:fe:degree | "recording" | "degree" | "/r/has a" |  | "FN" |  |
| fn:recording | /r/HasA | fn:fe:frequency | "recording" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:recording | /r/HasA | fn:fe:duration | "recording" | "duration" | "/r/has a" |  | "FN" |  |
| fn:recording | /r/HasA | fn:fe:period_of_iterations | "recording" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:records | /r/IsA | fn:text | "records" | "text" | "/r/is a" |  | "FN" |  |
| fn:records | fn:HasLexicalUnit | fn:lu:records:book | "records" | "book" | "has lexical unit" |  | "FN" |  |
| fn:records | fn:HasLexicalUnit | fn:lu:records:log | "records" | "log" | "has lexical unit" |  | "FN" |  |
| fn:records | fn:HasLexicalUnit | fn:lu:records:record | "records" | "record" | "has lexical unit" |  | "FN" |  |
| fn:records | fn:HasLexicalUnit | fn:lu:records:journal | "records" | "journal" | "has lexical unit" |  | "FN" |  |
| fn:records | fn:HasLexicalUnit | fn:lu:records:recording | "records" | "recording" | "has lexical unit" |  | "FN" |  |
| fn:records | /r/HasA | fn:fe:record | "records" | "record" | "/r/has a" |  | "FN" |  |
| fn:records | /r/HasA | fn:fe:data | "records" | "data" | "/r/has a" |  | "FN" |  |
| fn:records | /r/HasA | fn:fe:recorder | "records" | "recorder" | "/r/has a" |  | "FN" |  |
| fn:records | /r/HasA | fn:fe:entity | "records" | "entity" | "/r/has a" |  | "FN" |  |
| fn:records | /r/HasA | fn:fe:type | "records" | "type" | "/r/has a" |  | "FN" |  |
| fn:records | /r/HasA | fn:fe:descriptor | "records" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:records | /r/HasA | fn:fe:material | "records" | "material" | "/r/has a" |  | "FN" |  |
| fn:records | /r/HasA | fn:fe:medium | "records" | "medium" | "/r/has a" |  | "FN" |  |
| fn:records | /r/HasA | fn:fe:place | "records" | "place" | "/r/has a" |  | "FN" |  |
| fn:records | /r/HasA | fn:fe:time_of_creation | "records" | "time of creation" | "/r/has a" |  | "FN" |  |
| fn:records | /r/HasA | fn:fe:title | "records" | "title" | "/r/has a" |  | "FN" |  |
| fn:records | /r/HasA | fn:fe:topic | "records" | "topic" | "/r/has a" |  | "FN" |  |
| fn:records | /r/HasA | fn:fe:use | "records" | "use" | "/r/has a" |  | "FN" |  |
| fn:medical_conditions | /r/UsedFor | fn:recovery | "medical conditions" | "recovery" | "/r/used for" |  | "FN" |  |
| fn:cure | /r/Causes | fn:recovery | "cure" | "recovery" | "/r/causes" |  | "FN" |  |
| fn:recovery | fn:HasLexicalUnit | fn:lu:recovery:convalesce | "recovery" | "convalesce" | "has lexical unit" |  | "FN" |  |
| fn:recovery | fn:HasLexicalUnit | fn:lu:recovery:convalescence | "recovery" | "convalescence" | "has lexical unit" |  | "FN" |  |
| fn:recovery | fn:HasLexicalUnit | fn:lu:recovery:heal | "recovery" | "heal" | "has lexical unit" |  | "FN" |  |
| fn:recovery | fn:HasLexicalUnit | fn:lu:recovery:recover | "recovery" | "recover" | "has lexical unit" |  | "FN" |  |
| fn:recovery | fn:HasLexicalUnit | fn:lu:recovery:recovery | "recovery" | "recovery" | "has lexical unit" |  | "FN" |  |
| fn:recovery | fn:HasLexicalUnit | fn:lu:recovery:recuperate | "recovery" | "recuperate" | "has lexical unit" |  | "FN" |  |
| fn:recovery | fn:HasLexicalUnit | fn:lu:recovery:recuperation | "recovery" | "recuperation" | "has lexical unit" |  | "FN" |  |
| fn:recovery | fn:HasLexicalUnit | fn:lu:recovery:perk_up | "recovery" | "perk up" | "has lexical unit" |  | "FN" |  |
| fn:recovery | fn:HasLexicalUnit | fn:lu:recovery:ease | "recovery" | "ease" | "has lexical unit" |  | "FN" |  |
| fn:fe:patient | /r/HasPrerequisite | fn:fe:affliction | "patient" | "affliction" | "/r/has prerequisite" |  | "FN" |  |
| fn:recovery | /r/HasA | fn:fe:patient | "recovery" | "patient" | "/r/has a" |  | "FN" |  |
| fn:fe:affliction | /r/HasPrerequisite | fn:fe:patient | "affliction" | "patient" | "/r/has prerequisite" |  | "FN" |  |
| fn:recovery | /r/HasA | fn:fe:affliction | "recovery" | "affliction" | "/r/has a" |  | "FN" |  |
| fn:recovery | /r/HasA | fn:fe:body_part | "recovery" | "body part" | "/r/has a" |  | "FN" |  |
| fn:recovery | /r/HasA | fn:fe:manner | "recovery" | "manner" | "/r/has a" |  | "FN" |  |
| fn:recovery | /r/HasA | fn:fe:degree | "recovery" | "degree" | "/r/has a" |  | "FN" |  |
| fn:recovery | /r/HasA | fn:fe:means | "recovery" | "means" | "/r/has a" |  | "FN" |  |
| fn:recovery | /r/HasA | fn:fe:company | "recovery" | "company" | "/r/has a" |  | "FN" |  |
| fn:recovery | /r/HasA | fn:fe:time | "recovery" | "time" | "/r/has a" |  | "FN" |  |
| fn:recovery | /r/HasA | fn:fe:place | "recovery" | "place" | "/r/has a" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:redirecting | "motion" | "redirecting" | "/r/used for" |  | "FN" |  |
| fn:redirecting | fn:HasLexicalUnit | fn:lu:redirecting:redirect | "redirecting" | "redirect" | "has lexical unit" |  | "FN" |  |
| fn:redirecting | fn:HasLexicalUnit | fn:lu:redirecting:detour | "redirecting" | "detour" | "has lexical unit" |  | "FN" |  |
| fn:redirecting | fn:HasLexicalUnit | fn:lu:redirecting:divert | "redirecting" | "divert" | "has lexical unit" |  | "FN" |  |
| fn:redirecting | /r/HasA | fn:fe:theme | "redirecting" | "theme" | "/r/has a" |  | "FN" |  |
| fn:fe:original_path | /r/IsA | fn:st:source | "original path" | "source" | "/r/is a" |  | "FN" |  |
| fn:redirecting | /r/HasA | fn:fe:original_path | "redirecting" | "original path" | "/r/has a" |  | "FN" |  |
| fn:redirecting | /r/HasA | fn:fe:path | "redirecting" | "path" | "/r/has a" |  | "FN" |  |
| fn:redirecting | /r/HasA | fn:fe:goal | "redirecting" | "goal" | "/r/has a" |  | "FN" |  |
| fn:redirecting | /r/HasA | fn:fe:time | "redirecting" | "time" | "/r/has a" |  | "FN" |  |
| fn:redirecting | /r/HasA | fn:fe:manner | "redirecting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:redirecting | /r/HasA | fn:fe:depictive | "redirecting" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:redirecting | /r/HasA | fn:fe:place | "redirecting" | "place" | "/r/has a" |  | "FN" |  |
| fn:redirecting | /r/HasA | fn:fe:direction | "redirecting" | "direction" | "/r/has a" |  | "FN" |  |
| fn:redirecting | /r/HasA | fn:fe:purpose | "redirecting" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:redirecting | /r/HasA | fn:fe:agent | "redirecting" | "agent" | "/r/has a" |  | "FN" |  |
| fn:redirecting | /r/HasA | fn:fe:cause | "redirecting" | "cause" | "/r/has a" |  | "FN" |  |
| fn:redirecting | /r/HasA | fn:fe:means | "redirecting" | "means" | "/r/has a" |  | "FN" |  |
| fn:adducing | /r/UsedFor | fn:reference_text | "adducing" | "reference text" | "/r/used for" |  | "FN" |  |
| fn:text | /r/UsedFor | fn:reference_text | "text" | "reference text" | "/r/used for" |  | "FN" |  |
| fn:reference_text | fn:HasLexicalUnit | fn:lu:reference_text:see | "reference text" | "see" | "has lexical unit" |  | "FN" |  |
| fn:reference_text | fn:HasLexicalUnit | fn:lu:reference_text:cf | "reference text" | "cf" | "has lexical unit" |  | "FN" |  |
| fn:reference_text | fn:HasLexicalUnit | fn:lu:reference_text:qv | "reference text" | "qv" | "has lexical unit" |  | "FN" |  |
| fn:reference_text | fn:HasLexicalUnit | fn:lu:reference_text:refer | "reference text" | "refer" | "has lexical unit" |  | "FN" |  |
| fn:reference_text | /r/HasA | fn:fe:source_of_information | "reference text" | "source of information" | "/r/has a" |  | "FN" |  |
| fn:reference_text | /r/HasA | fn:fe:information | "reference text" | "information" | "/r/has a" |  | "FN" |  |
| fn:labeling | /r/IsA | fn:referring_by_name | "labeling" | "referring by name" | "/r/is a" |  | "FN" |  |
| fn:being_named | /r/UsedFor | fn:referring_by_name | "being named" | "referring by name" | "/r/used for" |  | "FN" |  |
| fn:referring_by_name | /r/UsedFor | fn:attention_getting | "referring by name" | "attention getting" | "/r/used for" |  | "FN" |  |
| fn:being_named | /r/SimilarTo | fn:referring_by_name | "being named" | "referring by name" | "/r/similar to" |  | "FN" |  |
| fn:referring_by_name | fn:HasLexicalUnit | fn:lu:referring_by_name:address | "referring by name" | "address" | "has lexical unit" |  | "FN" |  |
| fn:referring_by_name | fn:HasLexicalUnit | fn:lu:referring_by_name:call | "referring by name" | "call" | "has lexical unit" |  | "FN" |  |
| fn:referring_by_name | fn:HasLexicalUnit | fn:lu:referring_by_name:refer | "referring by name" | "refer" | "has lexical unit" |  | "FN" |  |
| fn:referring_by_name | fn:HasLexicalUnit | fn:lu:referring_by_name:name | "referring by name" | "name" | "has lexical unit" |  | "FN" |  |
| fn:referring_by_name | fn:HasLexicalUnit | fn:lu:referring_by_name:designation | "referring by name" | "designation" | "has lexical unit" |  | "FN" |  |
| fn:referring_by_name | /r/HasA | fn:fe:speaker | "referring by name" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:referring_by_name | /r/HasA | fn:fe:entity | "referring by name" | "entity" | "/r/has a" |  | "FN" |  |
| fn:referring_by_name | /r/HasA | fn:fe:name | "referring by name" | "name" | "/r/has a" |  | "FN" |  |
| fn:referring_by_name | /r/HasA | fn:fe:time | "referring by name" | "time" | "/r/has a" |  | "FN" |  |
| fn:referring_by_name | /r/HasA | fn:fe:descriptor | "referring by name" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:cause_change | /r/UsedFor | fn:reforming_a_system | "cause change" | "reforming a system" | "/r/used for" |  | "FN" |  |
| fn:reforming_a_system | fn:HasLexicalUnit | fn:lu:reforming_a_system:reform | "reforming a system" | "reform" | "has lexical unit" |  | "FN" |  |
| fn:reforming_a_system | fn:HasLexicalUnit | fn:lu:reforming_a_system:reform | "reforming a system" | "reform" | "has lexical unit" |  | "FN" |  |
| fn:reforming_a_system | fn:HasLexicalUnit | fn:lu:reforming_a_system:overhaul | "reforming a system" | "overhaul" | "has lexical unit" |  | "FN" |  |
| fn:reforming_a_system | fn:HasLexicalUnit | fn:lu:reforming_a_system:overhaul | "reforming a system" | "overhaul" | "has lexical unit" |  | "FN" |  |
| fn:reforming_a_system | fn:HasLexicalUnit | fn:lu:reforming_a_system:restructure | "reforming a system" | "restructure" | "has lexical unit" |  | "FN" |  |
| fn:reforming_a_system | /r/HasA | fn:fe:agent | "reforming a system" | "agent" | "/r/has a" |  | "FN" |  |
| fn:reforming_a_system | /r/HasA | fn:fe:time | "reforming a system" | "time" | "/r/has a" |  | "FN" |  |
| fn:reforming_a_system | /r/HasA | fn:fe:degree | "reforming a system" | "degree" | "/r/has a" |  | "FN" |  |
| fn:reforming_a_system | /r/HasA | fn:fe:manner | "reforming a system" | "manner" | "/r/has a" |  | "FN" |  |
| fn:reforming_a_system | /r/HasA | fn:fe:explanation | "reforming a system" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:reforming_a_system | /r/HasA | fn:fe:entity | "reforming a system" | "entity" | "/r/has a" |  | "FN" |  |
| fn:reforming_a_system | /r/HasA | fn:fe:purpose | "reforming a system" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:reforming_a_system | /r/HasA | fn:fe:initial_category | "reforming a system" | "initial category" | "/r/has a" |  | "FN" |  |
| fn:reforming_a_system | /r/HasA | fn:fe:final_category | "reforming a system" | "final category" | "/r/has a" |  | "FN" |  |
| fn:reforming_a_system | /r/HasA | fn:fe:means | "reforming a system" | "means" | "/r/has a" |  | "FN" |  |
| fn:reforming_a_system | /r/HasA | fn:fe:re-encoding | "reforming a system" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:reforming_a_system | /r/HasA | fn:fe:event_description | "reforming a system" | "event description" | "/r/has a" |  | "FN" |  |
| fn:reforming_a_system | /r/HasA | fn:fe:circumstances | "reforming a system" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:reforming_a_system | /r/HasA | fn:fe:duration | "reforming a system" | "duration" | "/r/has a" |  | "FN" |  |
| fn:reforming_a_system | /r/HasA | fn:fe:cause | "reforming a system" | "cause" | "/r/has a" |  | "FN" |  |
| fn:reforming_a_system | /r/HasA | fn:fe:place | "reforming a system" | "place" | "/r/has a" |  | "FN" |  |
| fn:judgment | /r/UsedFor | fn:regard | "judgment" | "regard" | "/r/used for" |  | "FN" |  |
| fn:regard | fn:HasLexicalUnit | fn:lu:regard:regard | "regard" | "regard" | "has lexical unit" |  | "FN" |  |
| fn:regard | fn:HasLexicalUnit | fn:lu:regard:esteem | "regard" | "esteem" | "has lexical unit" |  | "FN" |  |
| fn:regard | fn:HasLexicalUnit | fn:lu:regard:regard | "regard" | "regard" | "has lexical unit" |  | "FN" |  |
| fn:regard | fn:HasLexicalUnit | fn:lu:regard:impression | "regard" | "impression" | "has lexical unit" |  | "FN" |  |
| fn:regard | fn:HasLexicalUnit | fn:lu:regard:opinion | "regard" | "opinion" | "has lexical unit" |  | "FN" |  |
| fn:regard | fn:HasLexicalUnit | fn:lu:regard:think | "regard" | "think" | "has lexical unit" |  | "FN" |  |
| fn:regard | fn:HasLexicalUnit | fn:lu:regard:appreciate | "regard" | "appreciate" | "has lexical unit" |  | "FN" |  |
| fn:regard | fn:HasLexicalUnit | fn:lu:regard:appreciative | "regard" | "appreciative" | "has lexical unit" |  | "FN" |  |
| fn:regard | fn:HasLexicalUnit | fn:lu:regard:find | "regard" | "find" | "has lexical unit" |  | "FN" |  |
| fn:regard | /r/HasA | fn:fe:cognizer | "regard" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:regard | /r/HasA | fn:fe:evaluee | "regard" | "evaluee" | "/r/has a" |  | "FN" |  |
| fn:regard | /r/HasA | fn:fe:explanation | "regard" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:regard | /r/HasA | fn:fe:role | "regard" | "role" | "/r/has a" |  | "FN" |  |
| fn:regard | /r/HasA | fn:fe:depictive | "regard" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:regard | /r/HasA | fn:fe:manner | "regard" | "manner" | "/r/has a" |  | "FN" |  |
| fn:regard | /r/HasA | fn:fe:extent_of_acclaim | "regard" | "extent of acclaim" | "/r/has a" |  | "FN" |  |
| fn:regard | /r/HasA | fn:fe:judgment | "regard" | "judgment" | "/r/has a" |  | "FN" |  |
| fn:region_with_portal | /r/IsA | fn:bounded_region | "region with portal" | "bounded region" | "/r/is a" |  | "FN" |  |
| fn:region_with_portal | /r/HasA | fn:fe:interior | "region with portal" | "interior" | "/r/has a" |  | "FN" |  |
| fn:region_with_portal | /r/HasA | fn:fe:ground | "region with portal" | "ground" | "/r/has a" |  | "FN" |  |
| fn:region_with_portal | /r/HasA | fn:fe:surface | "region with portal" | "surface" | "/r/has a" |  | "FN" |  |
| fn:region_with_portal | /r/HasA | fn:fe:boundary | "region with portal" | "boundary" | "/r/has a" |  | "FN" |  |
| fn:region_with_portal | /r/HasA | fn:fe:exterior | "region with portal" | "exterior" | "/r/has a" |  | "FN" |  |
| fn:rejuvenation | /r/IsA | fn:transitive_action | "rejuvenation" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:rejuvenation | fn:HasLexicalUnit | fn:lu:rejuvenation:rejuvenation | "rejuvenation" | "rejuvenation" | "has lexical unit" |  | "FN" |  |
| fn:rejuvenation | fn:HasLexicalUnit | fn:lu:rejuvenation:revitalize | "rejuvenation" | "revitalize" | "has lexical unit" |  | "FN" |  |
| fn:rejuvenation | fn:HasLexicalUnit | fn:lu:rejuvenation:revitalization | "rejuvenation" | "revitalization" | "has lexical unit" |  | "FN" |  |
| fn:rejuvenation | fn:HasLexicalUnit | fn:lu:rejuvenation:rejuvenate | "rejuvenation" | "rejuvenate" | "has lexical unit" |  | "FN" |  |
| fn:rejuvenation | fn:HasLexicalUnit | fn:lu:rejuvenation:refresh | "rejuvenation" | "refresh" | "has lexical unit" |  | "FN" |  |
| fn:rejuvenation | fn:HasLexicalUnit | fn:lu:rejuvenation:reinvigorate | "rejuvenation" | "reinvigorate" | "has lexical unit" |  | "FN" |  |
| fn:rejuvenation | fn:HasLexicalUnit | fn:lu:rejuvenation:reinvigoration | "rejuvenation" | "reinvigoration" | "has lexical unit" |  | "FN" |  |
| fn:rejuvenation | fn:HasLexicalUnit | fn:lu:rejuvenation:breathe_new_life | "rejuvenation" | "breathe new life" | "has lexical unit" |  | "FN" |  |
| fn:rejuvenation | fn:HasLexicalUnit | fn:lu:rejuvenation:breathe_fresh_life | "rejuvenation" | "breathe fresh life" | "has lexical unit" |  | "FN" |  |
| fn:rejuvenation | fn:HasLexicalUnit | fn:lu:rejuvenation:resuscitate | "rejuvenation" | "resuscitate" | "has lexical unit" |  | "FN" |  |
| fn:rejuvenation | fn:HasLexicalUnit | fn:lu:rejuvenation:reawaken | "rejuvenation" | "reawaken" | "has lexical unit" |  | "FN" |  |
| fn:rejuvenation | fn:HasLexicalUnit | fn:lu:rejuvenation:resuscitation | "rejuvenation" | "resuscitation" | "has lexical unit" |  | "FN" |  |
| fn:rejuvenation | fn:HasLexicalUnit | fn:lu:rejuvenation:renew | "rejuvenation" | "renew" | "has lexical unit" |  | "FN" |  |
| fn:rejuvenation | fn:HasLexicalUnit | fn:lu:rejuvenation:invigorate | "rejuvenation" | "invigorate" | "has lexical unit" |  | "FN" |  |
| fn:rejuvenation | fn:HasLexicalUnit | fn:lu:rejuvenation:revival | "rejuvenation" | "revival" | "has lexical unit" |  | "FN" |  |
| fn:rejuvenation | fn:HasLexicalUnit | fn:lu:rejuvenation:restore | "rejuvenation" | "restore" | "has lexical unit" |  | "FN" |  |
| fn:rejuvenation | /r/HasA | fn:fe:entity | "rejuvenation" | "entity" | "/r/has a" |  | "FN" |  |
| fn:rejuvenation | /r/HasA | fn:fe:agent | "rejuvenation" | "agent" | "/r/has a" |  | "FN" |  |
| fn:rejuvenation | /r/HasA | fn:fe:place | "rejuvenation" | "place" | "/r/has a" |  | "FN" |  |
| fn:rejuvenation | /r/HasA | fn:fe:purpose | "rejuvenation" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:rejuvenation | /r/HasA | fn:fe:time | "rejuvenation" | "time" | "/r/has a" |  | "FN" |  |
| fn:rejuvenation | /r/HasA | fn:fe:means | "rejuvenation" | "means" | "/r/has a" |  | "FN" |  |
| fn:rejuvenation | /r/HasA | fn:fe:manner | "rejuvenation" | "manner" | "/r/has a" |  | "FN" |  |
| fn:rejuvenation | /r/HasA | fn:fe:domain | "rejuvenation" | "domain" | "/r/has a" |  | "FN" |  |
| fn:rejuvenation | /r/HasA | fn:fe:iterations | "rejuvenation" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:rejuvenation | /r/HasA | fn:fe:cause | "rejuvenation" | "cause" | "/r/has a" |  | "FN" |  |
| fn:rejuvenation | /r/HasA | fn:fe:event_description | "rejuvenation" | "event description" | "/r/has a" |  | "FN" |  |
| fn:rejuvenation | /r/HasA | fn:fe:frequency | "rejuvenation" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:rejuvenation | /r/HasA | fn:fe:degree | "rejuvenation" | "degree" | "/r/has a" |  | "FN" |  |
| fn:rejuvenation | /r/HasA | fn:fe:instrument | "rejuvenation" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:rejuvenation | /r/HasA | fn:fe:role | "rejuvenation" | "role" | "/r/has a" |  | "FN" |  |
| fn:rejuvenation | /r/HasA | fn:fe:result | "rejuvenation" | "result" | "/r/has a" |  | "FN" |  |
| fn:relating_concepts | /r/IsA | fn:cognitive_connection | "relating concepts" | "cognitive connection" | "/r/is a" |  | "FN" |  |
| fn:relating_concepts | fn:HasLexicalUnit | fn:lu:relating_concepts:link | "relating concepts" | "link" | "has lexical unit" |  | "FN" |  |
| fn:relating_concepts | fn:HasLexicalUnit | fn:lu:relating_concepts:connect | "relating concepts" | "connect" | "has lexical unit" |  | "FN" |  |
| fn:relating_concepts | fn:HasLexicalUnit | fn:lu:relating_concepts:tie | "relating concepts" | "tie" | "has lexical unit" |  | "FN" |  |
| fn:relating_concepts | fn:HasLexicalUnit | fn:lu:relating_concepts:associate | "relating concepts" | "associate" | "has lexical unit" |  | "FN" |  |
| fn:relating_concepts | fn:HasLexicalUnit | fn:lu:relating_concepts:relate | "relating concepts" | "relate" | "has lexical unit" |  | "FN" |  |
| fn:relating_concepts | /r/HasA | fn:fe:concept_1 | "relating concepts" | "concept 1" | "/r/has a" |  | "FN" |  |
| fn:relating_concepts | /r/HasA | fn:fe:concept_2 | "relating concepts" | "concept 2" | "/r/has a" |  | "FN" |  |
| fn:relating_concepts | /r/HasA | fn:fe:point_of_view | "relating concepts" | "point of view" | "/r/has a" |  | "FN" |  |
| fn:relating_concepts | /r/HasA | fn:fe:evidence | "relating concepts" | "evidence" | "/r/has a" |  | "FN" |  |
| fn:relating_concepts | /r/HasA | fn:fe:circumstances | "relating concepts" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:relating_concepts | /r/HasA | fn:fe:concepts | "relating concepts" | "concepts" | "/r/has a" |  | "FN" |  |
| fn:relating_concepts | /r/HasA | fn:fe:degree | "relating concepts" | "degree" | "/r/has a" |  | "FN" |  |
| fn:relating_concepts | /r/HasA | fn:fe:specification | "relating concepts" | "specification" | "/r/has a" |  | "FN" |  |
| fn:accompaniment | /r/IsA | fn:relation | "accompaniment" | "relation" | "/r/is a" |  | "FN" |  |
| fn:basis_for_attribute | /r/IsA | fn:relation | "basis for attribute" | "relation" | "/r/is a" |  | "FN" |  |
| fn:duration_relation | /r/IsA | fn:relation | "duration relation" | "relation" | "/r/is a" |  | "FN" |  |
| fn:identicality | /r/IsA | fn:relation | "identicality" | "relation" | "/r/is a" |  | "FN" |  |
| fn:idiosyncrasy | /r/IsA | fn:relation | "idiosyncrasy" | "relation" | "/r/is a" |  | "FN" |  |
| fn:inherent_purpose | /r/IsA | fn:relation | "inherent purpose" | "relation" | "/r/is a" |  | "FN" |  |
| fn:partitive | /r/IsA | fn:relation | "partitive" | "relation" | "/r/is a" |  | "FN" |  |
| fn:relation_between_individuals | /r/IsA | fn:relation | "relation between individuals" | "relation" | "/r/is a" |  | "FN" |  |
| fn:relative_time | /r/IsA | fn:relation | "relative time" | "relation" | "/r/is a" |  | "FN" |  |
| fn:sequence | /r/IsA | fn:relation | "sequence" | "relation" | "/r/is a" |  | "FN" |  |
| fn:simultaneity | /r/IsA | fn:relation | "simultaneity" | "relation" | "/r/is a" |  | "FN" |  |
| fn:relation | fn:HasLexicalUnit | fn:lu:relation:relation | "relation" | "relation" | "has lexical unit" |  | "FN" |  |
| fn:relation | /r/HasA | fn:fe:entity_1 | "relation" | "entity 1" | "/r/has a" |  | "FN" |  |
| fn:relation | /r/HasA | fn:fe:entity_2 | "relation" | "entity 2" | "/r/has a" |  | "FN" |  |
| fn:relation | /r/HasA | fn:fe:entities | "relation" | "entities" | "/r/has a" |  | "FN" |  |
| fn:relation | /r/HasA | fn:fe:relation_type | "relation" | "relation type" | "/r/has a" |  | "FN" |  |
| fn:relation_between_individuals | /r/IsA | fn:relation | "relation between individuals" | "relation" | "/r/is a" |  | "FN" |  |
| fn:guest_and_host | /r/IsA | fn:relation_between_individuals | "guest and host" | "relation between individuals" | "/r/is a" |  | "FN" |  |
| fn:social_connection | /r/IsA | fn:relation_between_individuals | "social connection" | "relation between individuals" | "/r/is a" |  | "FN" |  |
| fn:people | /r/UsedFor | fn:relation_between_individuals | "people" | "relation between individuals" | "/r/used for" |  | "FN" |  |
| fn:relation_between_individuals | /r/UsedFor | fn:kinship | "relation between individuals" | "kinship" | "/r/used for" |  | "FN" |  |
| fn:relation_between_individuals | /r/UsedFor | fn:people_by_residence | "relation between individuals" | "people by residence" | "/r/used for" |  | "FN" |  |
| fn:relation_between_individuals | /r/UsedFor | fn:personal_relationship | "relation between individuals" | "personal relationship" | "/r/used for" |  | "FN" |  |
| fn:relation_between_individuals | /r/UsedFor | fn:subordinates_and_superiors | "relation between individuals" | "subordinates and superiors" | "/r/used for" |  | "FN" |  |
| fn:relation_between_individuals | /r/HasA | fn:fe:individual_1 | "relation between individuals" | "individual 1" | "/r/has a" |  | "FN" |  |
| fn:fe:individual_2 | /r/HasPrerequisite | fn:fe:individual_1 | "individual 2" | "individual 1" | "/r/has prerequisite" |  | "FN" |  |
| fn:relation_between_individuals | /r/HasA | fn:fe:individual_2 | "relation between individuals" | "individual 2" | "/r/has a" |  | "FN" |  |
| fn:relation_between_individuals | /r/HasA | fn:fe:relation | "relation between individuals" | "relation" | "/r/has a" |  | "FN" |  |
| fn:relation_between_individuals | /r/HasA | fn:fe:individuals | "relation between individuals" | "individuals" | "/r/has a" |  | "FN" |  |
| fn:relational_location | /r/IsA | fn:locale | "relational location" | "locale" | "/r/is a" |  | "FN" |  |
| fn:locale_by_collocation | /r/IsA | fn:relational_location | "locale by collocation" | "relational location" | "/r/is a" |  | "FN" |  |
| fn:relational_natural_features | /r/IsA | fn:relational_location | "relational natural features" | "relational location" | "/r/is a" |  | "FN" |  |
| fn:image_schema | /r/UsedFor | fn:relational_location | "image schema" | "relational location" | "/r/used for" |  | "FN" |  |
| fn:relational_location | /r/HasA | fn:fe:profiled_region | "relational location" | "profiled region" | "/r/has a" |  | "FN" |  |
| fn:relational_location | /r/HasA | fn:fe:constituent_parts | "relational location" | "constituent parts" | "/r/has a" |  | "FN" |  |
| fn:relational_location | /r/HasA | fn:fe:relative_location | "relational location" | "relative location" | "/r/has a" |  | "FN" |  |
| fn:relational_location | /r/HasA | fn:fe:formational_cause | "relational location" | "formational cause" | "/r/has a" |  | "FN" |  |
| fn:relational_location | /r/HasA | fn:fe:container_possessor | "relational location" | "container possessor" | "/r/has a" |  | "FN" |  |
| fn:relational_location | /r/HasA | fn:fe:descriptor | "relational location" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:relational_location | /r/HasA | fn:fe:related_event | "relational location" | "related event" | "/r/has a" |  | "FN" |  |
| fn:relational_location | /r/HasA | fn:fe:inherent_purpose | "relational location" | "inherent purpose" | "/r/has a" |  | "FN" |  |
| fn:relational_location | /r/HasA | fn:fe:ground | "relational location" | "ground" | "/r/has a" |  | "FN" |  |
| fn:relational_natural_features | /r/IsA | fn:natural_features | "relational natural features" | "natural features" | "/r/is a" |  | "FN" |  |
| fn:relational_natural_features | /r/IsA | fn:relational_location | "relational natural features" | "relational location" | "/r/is a" |  | "FN" |  |
| fn:image_schema | /r/UsedFor | fn:relational_natural_features | "image schema" | "relational natural features" | "/r/used for" |  | "FN" |  |
| fn:locative_relation | /r/UsedFor | fn:relational_natural_features | "locative relation" | "relational natural features" | "/r/used for" |  | "FN" |  |
| fn:relational_natural_features | fn:HasLexicalUnit | fn:lu:relational_natural_features:shore | "relational natural features" | "shore" | "has lexical unit" |  | "FN" |  |
| fn:relational_natural_features | fn:HasLexicalUnit | fn:lu:relational_natural_features:coast | "relational natural features" | "coast" | "has lexical unit" |  | "FN" |  |
| fn:relational_natural_features | fn:HasLexicalUnit | fn:lu:relational_natural_features:delta | "relational natural features" | "delta" | "has lexical unit" |  | "FN" |  |
| fn:relational_natural_features | fn:HasLexicalUnit | fn:lu:relational_natural_features:bank | "relational natural features" | "bank" | "has lexical unit" |  | "FN" |  |
| fn:relational_natural_features | fn:HasLexicalUnit | fn:lu:relational_natural_features:seaboard | "relational natural features" | "seaboard" | "has lexical unit" |  | "FN" |  |
| fn:relational_natural_features | fn:HasLexicalUnit | fn:lu:relational_natural_features:mouth | "relational natural features" | "mouth" | "has lexical unit" |  | "FN" |  |
| fn:relational_natural_features | fn:HasLexicalUnit | fn:lu:relational_natural_features:source | "relational natural features" | "source" | "has lexical unit" |  | "FN" |  |
| fn:relational_natural_features | fn:HasLexicalUnit | fn:lu:relational_natural_features:summit | "relational natural features" | "summit" | "has lexical unit" |  | "FN" |  |
| fn:relational_natural_features | fn:HasLexicalUnit | fn:lu:relational_natural_features:peak | "relational natural features" | "peak" | "has lexical unit" |  | "FN" |  |
| fn:relational_natural_features | fn:HasLexicalUnit | fn:lu:relational_natural_features:foothill | "relational natural features" | "foothill" | "has lexical unit" |  | "FN" |  |
| fn:relational_natural_features | fn:HasLexicalUnit | fn:lu:relational_natural_features:estuary | "relational natural features" | "estuary" | "has lexical unit" |  | "FN" |  |
| fn:relational_natural_features | fn:HasLexicalUnit | fn:lu:relational_natural_features:shoreline | "relational natural features" | "shoreline" | "has lexical unit" |  | "FN" |  |
| fn:relational_natural_features | /r/HasA | fn:fe:constituent_parts | "relational natural features" | "constituent parts" | "/r/has a" |  | "FN" |  |
| fn:relational_natural_features | /r/HasA | fn:fe:container_possessor | "relational natural features" | "container possessor" | "/r/has a" |  | "FN" |  |
| fn:relational_natural_features | /r/HasA | fn:fe:formational_cause | "relational natural features" | "formational cause" | "/r/has a" |  | "FN" |  |
| fn:relational_natural_features | /r/HasA | fn:fe:focal_feature | "relational natural features" | "focal feature" | "/r/has a" |  | "FN" |  |
| fn:relational_natural_features | /r/HasA | fn:fe:name | "relational natural features" | "name" | "/r/has a" |  | "FN" |  |
| fn:relational_natural_features | /r/HasA | fn:fe:relative_location | "relational natural features" | "relative location" | "/r/has a" |  | "FN" |  |
| fn:relational_natural_features | /r/HasA | fn:fe:type | "relational natural features" | "type" | "/r/has a" |  | "FN" |  |
| fn:relational_natural_features | /r/HasA | fn:fe:descriptor | "relational natural features" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:relational_natural_features | /r/HasA | fn:fe:landmark_feature | "relational natural features" | "landmark feature" | "/r/has a" |  | "FN" |  |
| fn:relational_political_locales | /r/IsA | fn:political_locales | "relational political locales" | "political locales" | "/r/is a" |  | "FN" |  |
| fn:relational_political_locales | fn:HasLexicalUnit | fn:lu:relational_political_locales:capital | "relational political locales" | "capital" | "has lexical unit" |  | "FN" |  |
| fn:relational_political_locales | fn:HasLexicalUnit | fn:lu:relational_political_locales:county_seat | "relational political locales" | "county seat" | "has lexical unit" |  | "FN" |  |
| fn:relational_political_locales | fn:HasLexicalUnit | fn:lu:relational_political_locales:see | "relational political locales" | "see" | "has lexical unit" |  | "FN" |  |
| fn:relational_political_locales | /r/HasA | fn:fe:constituent_parts | "relational political locales" | "constituent parts" | "/r/has a" |  | "FN" |  |
| fn:relational_political_locales | /r/HasA | fn:fe:container_possessor | "relational political locales" | "container possessor" | "/r/has a" |  | "FN" |  |
| fn:relational_political_locales | /r/HasA | fn:fe:locale | "relational political locales" | "locale" | "/r/has a" |  | "FN" |  |
| fn:relational_political_locales | /r/HasA | fn:fe:name | "relational political locales" | "name" | "/r/has a" |  | "FN" |  |
| fn:relational_political_locales | /r/HasA | fn:fe:relative_location | "relational political locales" | "relative location" | "/r/has a" |  | "FN" |  |
| fn:relational_political_locales | /r/HasA | fn:fe:descriptor | "relational political locales" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:relational_political_locales | /r/HasA | fn:fe:population | "relational political locales" | "population" | "/r/has a" |  | "FN" |  |
| fn:price_per_unit | /r/IsA | fn:relational_quantity | "price per unit" | "relational quantity" | "/r/is a" |  | "FN" |  |
| fn:proportion | /r/IsA | fn:relational_quantity | "proportion" | "relational quantity" | "/r/is a" |  | "FN" |  |
| fn:rate_quantification | /r/IsA | fn:relational_quantity | "rate quantification" | "relational quantity" | "/r/is a" |  | "FN" |  |
| fn:relational_quantity | fn:HasLexicalUnit | fn:lu:relational_quantity:rate | "relational quantity" | "rate" | "has lexical unit" |  | "FN" |  |
| fn:relational_quantity | /r/HasA | fn:fe:rate | "relational quantity" | "rate" | "/r/has a" |  | "FN" |  |
| fn:relational_quantity | /r/HasA | fn:fe:numerator | "relational quantity" | "numerator" | "/r/has a" |  | "FN" |  |
| fn:relational_quantity | /r/HasA | fn:fe:focal_entity | "relational quantity" | "focal entity" | "/r/has a" |  | "FN" |  |
| fn:relational_quantity | /r/HasA | fn:fe:descriptor | "relational quantity" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:relational_quantity | /r/HasA | fn:fe:type | "relational quantity" | "type" | "/r/has a" |  | "FN" |  |
| fn:relational_quantity | /r/HasA | fn:fe:denominator | "relational quantity" | "denominator" | "/r/has a" |  | "FN" |  |
| fn:relative_time | /r/IsA | fn:relation | "relative time" | "relation" | "/r/is a" |  | "FN" |  |
| fn:relative_time | /r/RelatedTo | fn:time_vector | "relative time" | "time vector" | "/r/related to" |  | "FN" |  |
| fn:relative_time | /r/SimilarTo | fn:change_event_time | "relative time" | "change event time" | "/r/similar to" |  | "FN" |  |
| fn:relative_time | /r/SimilarTo | fn:temporal_collocation | "relative time" | "temporal collocation" | "/r/similar to" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:antecedent | "relative time" | "antecedent" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:belated | "relative time" | "belated" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:early | "relative time" | "early" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:follow | "relative time" | "follow" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:following | "relative time" | "following" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:late | "relative time" | "late" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:overdue | "relative time" | "overdue" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:precede | "relative time" | "precede" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:preceding | "relative time" | "preceding" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:predate | "relative time" | "predate" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:premature | "relative time" | "premature" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:previous | "relative time" | "previous" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:prior | "relative time" | "prior" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:punctual | "relative time" | "punctual" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:subsequent | "relative time" | "subsequent" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:tardy | "relative time" | "tardy" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:come_on_heels | "relative time" | "come on heels" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:ahead | "relative time" | "ahead" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:behind | "relative time" | "behind" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:later | "relative time" | "later" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:after | "relative time" | "after" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:sooner | "relative time" | "sooner" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:sooner_rather_than_later | "relative time" | "sooner rather than later" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:subsequently | "relative time" | "subsequently" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:erstwhile | "relative time" | "erstwhile" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:as | "relative time" | "as" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:in_parallel | "relative time" | "in parallel" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:while | "relative time" | "while" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:recent | "relative time" | "recent" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:last | "relative time" | "last" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:past | "relative time" | "past" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:on_time | "relative time" | "on time" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:punctually | "relative time" | "punctually" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:punctuality | "relative time" | "punctuality" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:next | "relative time" | "next" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:latest | "relative time" | "latest" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:late_[at_night] | "relative time" | "late [at night]" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:coming | "relative time" | "coming" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | fn:HasLexicalUnit | fn:lu:relative_time:succeed | "relative time" | "succeed" | "has lexical unit" |  | "FN" |  |
| fn:relative_time | /r/HasA | fn:fe:focal_occasion | "relative time" | "focal occasion" | "/r/has a" |  | "FN" |  |
| fn:relative_time | /r/HasA | fn:fe:landmark_occasion | "relative time" | "landmark occasion" | "/r/has a" |  | "FN" |  |
| fn:relative_time | /r/HasA | fn:fe:interval | "relative time" | "interval" | "/r/has a" |  | "FN" |  |
| fn:relative_time | /r/HasA | fn:fe:degree | "relative time" | "degree" | "/r/has a" |  | "FN" |  |
| fn:relative_time | /r/HasA | fn:fe:manner | "relative time" | "manner" | "/r/has a" |  | "FN" |  |
| fn:relative_time | /r/HasA | fn:fe:explanation | "relative time" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:relative_time | /r/HasA | fn:fe:focal_participant | "relative time" | "focal participant" | "/r/has a" |  | "FN" |  |
| fn:releasing | /r/IsA | fn:intentionally_affect | "releasing" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:releasing_from_custody | /r/IsA | fn:releasing | "releasing from custody" | "releasing" | "/r/is a" |  | "FN" |  |
| fn:inhibit_motion_scenario | /r/HasSubevent | fn:releasing | "inhibit motion scenario" | "releasing" | "/r/has subevent" |  | "FN" |  |
| fn:releasing | /r/UsedFor | fn:freeing_from_confinement | "releasing" | "freeing from confinement" | "/r/used for" |  | "FN" |  |
| fn:releasing | /r/HasPrerequisite | fn:inhibit_movement | "releasing" | "inhibit movement" | "/r/has prerequisite" |  | "FN" |  |
| fn:releasing | fn:HasLexicalUnit | fn:lu:releasing:release | "releasing" | "release" | "has lexical unit" |  | "FN" |  |
| fn:releasing | fn:HasLexicalUnit | fn:lu:releasing:let_go | "releasing" | "let go" | "has lexical unit" |  | "FN" |  |
| fn:releasing | fn:HasLexicalUnit | fn:lu:releasing:set_free | "releasing" | "set free" | "has lexical unit" |  | "FN" |  |
| fn:releasing | fn:HasLexicalUnit | fn:lu:releasing:release | "releasing" | "release" | "has lexical unit" |  | "FN" |  |
| fn:fe:captor | /r/IsA | fn:st:sentient | "captor" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:releasing | /r/HasA | fn:fe:captor | "releasing" | "captor" | "/r/has a" |  | "FN" |  |
| fn:releasing | /r/HasA | fn:fe:theme | "releasing" | "theme" | "/r/has a" |  | "FN" |  |
| fn:releasing | /r/HasA | fn:fe:manner | "releasing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:releasing | /r/HasA | fn:fe:means | "releasing" | "means" | "/r/has a" |  | "FN" |  |
| fn:releasing | /r/HasA | fn:fe:explanation | "releasing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:releasing | /r/HasA | fn:fe:purpose | "releasing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:releasing | /r/HasA | fn:fe:place | "releasing" | "place" | "/r/has a" |  | "FN" |  |
| fn:releasing | /r/HasA | fn:fe:time | "releasing" | "time" | "/r/has a" |  | "FN" |  |
| fn:releasing | /r/HasA | fn:fe:location_of_confinement | "releasing" | "location of confinement" | "/r/has a" |  | "FN" |  |
| fn:releasing | /r/HasA | fn:fe:concessive | "releasing" | "concessive" | "/r/has a" |  | "FN" |  |
| fn:releasing | /r/HasA | fn:fe:circumstances | "releasing" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:releasing_from_custody | /r/IsA | fn:releasing | "releasing from custody" | "releasing" | "/r/is a" |  | "FN" |  |
| fn:detaining | /r/UsedFor | fn:releasing_from_custody | "detaining" | "releasing from custody" | "/r/used for" |  | "FN" |  |
| fn:releasing_from_custody | /r/HasPrerequisite | fn:detaining | "releasing from custody" | "detaining" | "/r/has prerequisite" |  | "FN" |  |
| fn:releasing_from_custody | /r/HasA | fn:fe:authorities | "releasing from custody" | "authorities" | "/r/has a" |  | "FN" |  |
| fn:releasing_from_custody | /r/HasA | fn:fe:suspect | "releasing from custody" | "suspect" | "/r/has a" |  | "FN" |  |
| fn:releasing_from_custody | /r/HasA | fn:fe:manner | "releasing from custody" | "manner" | "/r/has a" |  | "FN" |  |
| fn:releasing_from_custody | /r/HasA | fn:fe:means | "releasing from custody" | "means" | "/r/has a" |  | "FN" |  |
| fn:releasing_from_custody | /r/HasA | fn:fe:explanation | "releasing from custody" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:releasing_from_custody | /r/HasA | fn:fe:purpose | "releasing from custody" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:releasing_from_custody | /r/HasA | fn:fe:place | "releasing from custody" | "place" | "/r/has a" |  | "FN" |  |
| fn:releasing_from_custody | /r/HasA | fn:fe:time | "releasing from custody" | "time" | "/r/has a" |  | "FN" |  |
| fn:releasing_from_custody | /r/HasA | fn:fe:holding_location | "releasing from custody" | "holding location" | "/r/has a" |  | "FN" |  |
| fn:contingency | /r/UsedFor | fn:reliance | "contingency" | "reliance" | "/r/used for" |  | "FN" |  |
| fn:needing | /r/UsedFor | fn:reliance | "needing" | "reliance" | "/r/used for" |  | "FN" |  |
| fn:reliance | fn:HasLexicalUnit | fn:lu:reliance:rely | "reliance" | "rely" | "has lexical unit" |  | "FN" |  |
| fn:reliance | fn:HasLexicalUnit | fn:lu:reliance:depend | "reliance" | "depend" | "has lexical unit" |  | "FN" |  |
| fn:reliance | fn:HasLexicalUnit | fn:lu:reliance:count | "reliance" | "count" | "has lexical unit" |  | "FN" |  |
| fn:reliance | fn:HasLexicalUnit | fn:lu:reliance:reliance | "reliance" | "reliance" | "has lexical unit" |  | "FN" |  |
| fn:reliance | fn:HasLexicalUnit | fn:lu:reliance:dependence | "reliance" | "dependence" | "has lexical unit" |  | "FN" |  |
| fn:reliance | fn:HasLexicalUnit | fn:lu:reliance:dependency | "reliance" | "dependency" | "has lexical unit" |  | "FN" |  |
| fn:reliance | /r/HasA | fn:fe:protagonist | "reliance" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:fe:benefit | /r/RelatedTo | fn:fe:purpose | "benefit" | "purpose" | "/r/related to" |  | "FN" |  |
| fn:reliance | /r/HasA | fn:fe:benefit | "reliance" | "benefit" | "/r/has a" |  | "FN" |  |
| fn:reliance | /r/HasA | fn:fe:degree | "reliance" | "degree" | "/r/has a" |  | "FN" |  |
| fn:fe:intermediary | /r/RelatedTo | fn:fe:means | "intermediary" | "means" | "/r/related to" |  | "FN" |  |
| fn:reliance | /r/HasA | fn:fe:intermediary | "reliance" | "intermediary" | "/r/has a" |  | "FN" |  |
| fn:fe:instrument | /r/RelatedTo | fn:fe:intermediary | "instrument" | "intermediary" | "/r/related to" |  | "FN" |  |
| fn:reliance | /r/HasA | fn:fe:instrument | "reliance" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:reliance | /r/HasA | fn:fe:purpose | "reliance" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:fe:means | /r/RelatedTo | fn:fe:instrument | "means" | "instrument" | "/r/related to" |  | "FN" |  |
| fn:reliance | /r/HasA | fn:fe:means | "reliance" | "means" | "/r/has a" |  | "FN" |  |
| fn:reliance | /r/HasA | fn:fe:circumstances | "reliance" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:certainty | /r/UsedFor | fn:reliance_on_expectation | "certainty" | "reliance on expectation" | "/r/used for" |  | "FN" |  |
| fn:reliance_on_expectation | fn:HasLexicalUnit | fn:lu:reliance_on_expectation:bank_(on) | "reliance on expectation" | "bank (on)" | "has lexical unit" |  | "FN" |  |
| fn:reliance_on_expectation | fn:HasLexicalUnit | fn:lu:reliance_on_expectation:count_(on) | "reliance on expectation" | "count (on)" | "has lexical unit" |  | "FN" |  |
| fn:reliance_on_expectation | /r/HasA | fn:fe:cognizer | "reliance on expectation" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:reliance_on_expectation | /r/HasA | fn:fe:expectation | "reliance on expectation" | "expectation" | "/r/has a" |  | "FN" |  |
| fn:reliance_on_expectation | /r/HasA | fn:fe:circumstances | "reliance on expectation" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:awareness | /r/UsedFor | fn:religious_belief | "awareness" | "religious belief" | "/r/used for" |  | "FN" |  |
| fn:religious_belief | /r/UsedFor | fn:people_by_religion | "religious belief" | "people by religion" | "/r/used for" |  | "FN" |  |
| fn:religious_belief | fn:HasLexicalUnit | fn:lu:religious_belief:believe | "religious belief" | "believe" | "has lexical unit" |  | "FN" |  |
| fn:religious_belief | fn:HasLexicalUnit | fn:lu:religious_belief:belief | "religious belief" | "belief" | "has lexical unit" |  | "FN" |  |
| fn:religious_belief | fn:HasLexicalUnit | fn:lu:religious_belief:faith | "religious belief" | "faith" | "has lexical unit" |  | "FN" |  |
| fn:religious_belief | fn:HasLexicalUnit | fn:lu:religious_belief:faithful | "religious belief" | "faithful" | "has lexical unit" |  | "FN" |  |
| fn:fe:believer | /r/IsA | fn:st:sentient | "believer" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:religious_belief | /r/HasA | fn:fe:believer | "religious belief" | "believer" | "/r/has a" |  | "FN" |  |
| fn:fe:content | /r/RelatedTo | fn:fe:role | "content" | "role" | "/r/related to" |  | "FN" |  |
| fn:religious_belief | /r/HasA | fn:fe:content | "religious belief" | "content" | "/r/has a" |  | "FN" |  |
| fn:religious_belief | /r/HasA | fn:fe:degree | "religious belief" | "degree" | "/r/has a" |  | "FN" |  |
| fn:religious_belief | /r/HasA | fn:fe:manner | "religious belief" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fe:role | /r/HasPrerequisite | fn:fe:element | "role" | "element" | "/r/has prerequisite" |  | "FN" |  |
| fn:religious_belief | /r/HasA | fn:fe:role | "religious belief" | "role" | "/r/has a" |  | "FN" |  |
| fn:fe:element | /r/RelatedTo | fn:fe:content | "element" | "content" | "/r/related to" |  | "FN" |  |
| fn:religious_belief | /r/HasA | fn:fe:element | "religious belief" | "element" | "/r/has a" |  | "FN" |  |
| fn:change_position_on_a_scale | /r/UsedFor | fn:remainder | "change position on a scale" | "remainder" | "/r/used for" |  | "FN" |  |
| fn:remainder | fn:HasLexicalUnit | fn:lu:remainder:remnant | "remainder" | "remnant" | "has lexical unit" |  | "FN" |  |
| fn:remainder | fn:HasLexicalUnit | fn:lu:remainder:left | "remainder" | "left" | "has lexical unit" |  | "FN" |  |
| fn:remainder | fn:HasLexicalUnit | fn:lu:remainder:remain | "remainder" | "remain" | "has lexical unit" |  | "FN" |  |
| fn:remainder | fn:HasLexicalUnit | fn:lu:remainder:remains | "remainder" | "remains" | "has lexical unit" |  | "FN" |  |
| fn:remainder | /r/HasA | fn:fe:remainder | "remainder" | "remainder" | "/r/has a" |  | "FN" |  |
| fn:fe:resource | /r/RelatedTo | fn:fe:original_context | "resource" | "original context" | "/r/related to" |  | "FN" |  |
| fn:remainder | /r/HasA | fn:fe:resource | "remainder" | "resource" | "/r/has a" |  | "FN" |  |
| fn:remainder | /r/HasA | fn:fe:location | "remainder" | "location" | "/r/has a" |  | "FN" |  |
| fn:fe:original_owner | /r/RelatedTo | fn:fe:original_context | "original owner" | "original context" | "/r/related to" |  | "FN" |  |
| fn:remainder | /r/HasA | fn:fe:original_owner | "remainder" | "original owner" | "/r/has a" |  | "FN" |  |
| fn:remainder | /r/HasA | fn:fe:time | "remainder" | "time" | "/r/has a" |  | "FN" |  |
| fn:remainder | /r/HasA | fn:fe:beneficiary | "remainder" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:fe:original_context | /r/RelatedTo | fn:fe:resource | "original context" | "resource" | "/r/related to" |  | "FN" |  |
| fn:remainder | /r/HasA | fn:fe:original_context | "remainder" | "original context" | "/r/has a" |  | "FN" |  |
| fn:cogitation | /r/UsedFor | fn:remembering_experience | "cogitation" | "remembering experience" | "/r/used for" |  | "FN" |  |
| fn:remembering_information | /r/RelatedTo | fn:remembering_experience | "remembering information" | "remembering experience" | "/r/related to" |  | "FN" |  |
| fn:memory | /r/SimilarTo | fn:remembering_experience | "memory" | "remembering experience" | "/r/similar to" |  | "FN" |  |
| fn:remembering_experience | fn:HasLexicalUnit | fn:lu:remembering_experience:remember | "remembering experience" | "remember" | "has lexical unit" |  | "FN" |  |
| fn:remembering_experience | fn:HasLexicalUnit | fn:lu:remembering_experience:forget | "remembering experience" | "forget" | "has lexical unit" |  | "FN" |  |
| fn:remembering_experience | fn:HasLexicalUnit | fn:lu:remembering_experience:memory | "remembering experience" | "memory" | "has lexical unit" |  | "FN" |  |
| fn:remembering_experience | fn:HasLexicalUnit | fn:lu:remembering_experience:recall | "remembering experience" | "recall" | "has lexical unit" |  | "FN" |  |
| fn:remembering_experience | fn:HasLexicalUnit | fn:lu:remembering_experience:look_back | "remembering experience" | "look back" | "has lexical unit" |  | "FN" |  |
| fn:remembering_experience | fn:HasLexicalUnit | fn:lu:remembering_experience:reminisce | "remembering experience" | "reminisce" | "has lexical unit" |  | "FN" |  |
| fn:remembering_experience | /r/HasA | fn:fe:cognizer | "remembering experience" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:fe:salient_entity | /r/RelatedTo | fn:fe:experience | "salient entity" | "experience" | "/r/related to" |  | "FN" |  |
| fn:remembering_experience | /r/HasA | fn:fe:salient_entity | "remembering experience" | "salient entity" | "/r/has a" |  | "FN" |  |
| fn:fe:experience | /r/RelatedTo | fn:fe:state | "experience" | "state" | "/r/related to" |  | "FN" |  |
| fn:remembering_experience | /r/HasA | fn:fe:experience | "remembering experience" | "experience" | "/r/has a" |  | "FN" |  |
| fn:fe:impression | /r/RelatedTo | fn:fe:experience | "impression" | "experience" | "/r/related to" |  | "FN" |  |
| fn:remembering_experience | /r/HasA | fn:fe:impression | "remembering experience" | "impression" | "/r/has a" |  | "FN" |  |
| fn:fe:state | /r/HasPrerequisite | fn:fe:salient_entity | "state" | "salient entity" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:state | /r/RelatedTo | fn:fe:impression | "state" | "impression" | "/r/related to" |  | "FN" |  |
| fn:remembering_experience | /r/HasA | fn:fe:state | "remembering experience" | "state" | "/r/has a" |  | "FN" |  |
| fn:remembering_experience | /r/HasA | fn:fe:vividness | "remembering experience" | "vividness" | "/r/has a" |  | "FN" |  |
| fn:remembering_experience | /r/HasA | fn:fe:context | "remembering experience" | "context" | "/r/has a" |  | "FN" |  |
| fn:remembering_experience | /r/HasA | fn:fe:time | "remembering experience" | "time" | "/r/has a" |  | "FN" |  |
| fn:remembering_experience | /r/HasA | fn:fe:manner | "remembering experience" | "manner" | "/r/has a" |  | "FN" |  |
| fn:remembering_experience | /r/HasA | fn:fe:duration | "remembering experience" | "duration" | "/r/has a" |  | "FN" |  |
| fn:awareness | /r/UsedFor | fn:remembering_information | "awareness" | "remembering information" | "/r/used for" |  | "FN" |  |
| fn:remembering_information | /r/UsedFor | fn:remembering_to_do | "remembering information" | "remembering to do" | "/r/used for" |  | "FN" |  |
| fn:remembering_information | /r/RelatedTo | fn:remembering_experience | "remembering information" | "remembering experience" | "/r/related to" |  | "FN" |  |
| fn:remembering_information | /r/RelatedTo | fn:remembering_to_do | "remembering information" | "remembering to do" | "/r/related to" |  | "FN" |  |
| fn:memory | /r/SimilarTo | fn:remembering_information | "memory" | "remembering information" | "/r/similar to" |  | "FN" |  |
| fn:memorization | /r/Causes | fn:remembering_information | "memorization" | "remembering information" | "/r/causes" |  | "FN" |  |
| fn:remembering_information | fn:HasLexicalUnit | fn:lu:remembering_information:remember | "remembering information" | "remember" | "has lexical unit" |  | "FN" |  |
| fn:remembering_information | fn:HasLexicalUnit | fn:lu:remembering_information:forget | "remembering information" | "forget" | "has lexical unit" |  | "FN" |  |
| fn:remembering_information | fn:HasLexicalUnit | fn:lu:remembering_information:draw_blank | "remembering information" | "draw blank" | "has lexical unit" |  | "FN" |  |
| fn:remembering_information | /r/HasA | fn:fe:cognizer | "remembering information" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:fe:mental_content | /r/IsA | fn:st:content | "mental content" | "content" | "/r/is a" |  | "FN" |  |
| fn:remembering_information | /r/HasA | fn:fe:mental_content | "remembering information" | "mental content" | "/r/has a" |  | "FN" |  |
| fn:remembering_information | /r/HasA | fn:fe:accuracy | "remembering information" | "accuracy" | "/r/has a" |  | "FN" |  |
| fn:remembering_information | /r/HasA | fn:fe:time | "remembering information" | "time" | "/r/has a" |  | "FN" |  |
| fn:remembering_information | /r/HasA | fn:fe:topic | "remembering information" | "topic" | "/r/has a" |  | "FN" |  |
| fn:remembering_information | /r/HasA | fn:fe:context | "remembering information" | "context" | "/r/has a" |  | "FN" |  |
| fn:intentionally_act | /r/UsedFor | fn:remembering_to_do | "intentionally act" | "remembering to do" | "/r/used for" |  | "FN" |  |
| fn:purpose | /r/UsedFor | fn:remembering_to_do | "purpose" | "remembering to do" | "/r/used for" |  | "FN" |  |
| fn:remembering_information | /r/UsedFor | fn:remembering_to_do | "remembering information" | "remembering to do" | "/r/used for" |  | "FN" |  |
| fn:remembering_information | /r/RelatedTo | fn:remembering_to_do | "remembering information" | "remembering to do" | "/r/related to" |  | "FN" |  |
| fn:memory | /r/SimilarTo | fn:remembering_to_do | "memory" | "remembering to do" | "/r/similar to" |  | "FN" |  |
| fn:remembering_to_do | fn:HasLexicalUnit | fn:lu:remembering_to_do:remember | "remembering to do" | "remember" | "has lexical unit" |  | "FN" |  |
| fn:remembering_to_do | fn:HasLexicalUnit | fn:lu:remembering_to_do:forget | "remembering to do" | "forget" | "has lexical unit" |  | "FN" |  |
| fn:remembering_to_do | /r/HasA | fn:fe:cognizer | "remembering to do" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:remembering_to_do | /r/HasA | fn:fe:action | "remembering to do" | "action" | "/r/has a" |  | "FN" |  |
| fn:remembering_to_do | /r/HasA | fn:fe:time | "remembering to do" | "time" | "/r/has a" |  | "FN" |  |
| fn:fe:salient_entity | /r/RelatedTo | fn:fe:action | "salient entity" | "action" | "/r/related to" |  | "FN" |  |
| fn:remembering_to_do | /r/HasA | fn:fe:salient_entity | "remembering to do" | "salient entity" | "/r/has a" |  | "FN" |  |
| fn:remembering_to_do | /r/HasA | fn:fe:frequency | "remembering to do" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:removing | /r/IsA | fn:transitive_action | "removing" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_motion | /r/HasSubevent | fn:removing | "cause motion" | "removing" | "/r/has subevent" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:removing | "motion" | "removing" | "/r/used for" |  | "FN" |  |
| fn:removing | /r/UsedFor | fn:dunking | "removing" | "dunking" | "/r/used for" |  | "FN" |  |
| fn:removing | /r/UsedFor | fn:undressing | "removing" | "undressing" | "/r/used for" |  | "FN" |  |
| fn:cause_motion | /r/RelatedTo | fn:removing | "cause motion" | "removing" | "/r/related to" |  | "FN" |  |
| fn:placing | /r/RelatedTo | fn:removing | "placing" | "removing" | "/r/related to" |  | "FN" |  |
| fn:removing | /r/SimilarTo | fn:emptying | "removing" | "emptying" | "/r/similar to" |  | "FN" |  |
| fn:removing | /r/SimilarTo | fn:escaping | "removing" | "escaping" | "/r/similar to" |  | "FN" |  |
| fn:removing | /r/SimilarTo | fn:excreting | "removing" | "excreting" | "/r/similar to" |  | "FN" |  |
| fn:removing | /r/SimilarTo | fn:kidnapping | "removing" | "kidnapping" | "/r/similar to" |  | "FN" |  |
| fn:placing | /r/HasPrerequisite | fn:removing | "placing" | "removing" | "/r/has prerequisite" |  | "FN" |  |
| fn:removing | /r/IsA | fn:removing_scenario | "removing" | "removing scenario" | "/r/is a" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:clear | "removing" | "clear" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:confiscate | "removing" | "confiscate" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:discard | "removing" | "discard" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:dislodge | "removing" | "dislodge" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:drain | "removing" | "drain" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:eject | "removing" | "eject" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:ejection | "removing" | "ejection" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:eliminate | "removing" | "eliminate" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:elimination | "removing" | "elimination" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:empty | "removing" | "empty" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:evacuate | "removing" | "evacuate" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:evacuation | "removing" | "evacuation" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:evict | "removing" | "evict" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:eviction | "removing" | "eviction" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:excise | "removing" | "excise" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:expel | "removing" | "expel" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:expulsion | "removing" | "expulsion" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:expunge | "removing" | "expunge" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:extract | "removing" | "extract" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:oust | "removing" | "oust" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:pluck | "removing" | "pluck" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:prise | "removing" | "prise" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:purge | "removing" | "purge" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:purge | "removing" | "purge" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:removal | "removing" | "removal" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:remove | "removing" | "remove" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:skim | "removing" | "skim" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:snatch | "removing" | "snatch" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:strip | "removing" | "strip" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:swipe | "removing" | "swipe" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:take | "removing" | "take" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:withdraw | "removing" | "withdraw" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:withdrawal | "removing" | "withdrawal" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:unload | "removing" | "unload" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:expurgate | "removing" | "expurgate" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:wash | "removing" | "wash" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:shave | "removing" | "shave" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:rinse | "removing" | "rinse" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:roust | "removing" | "roust" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:dust | "removing" | "dust" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:extraction | "removing" | "extraction" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:scrape | "removing" | "scrape" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:rip | "removing" | "rip" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:tear | "removing" | "tear" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:cut | "removing" | "cut" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:file | "removing" | "file" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:disgorge | "removing" | "disgorge" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:flush | "removing" | "flush" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:weed | "removing" | "weed" | "has lexical unit" |  | "FN" |  |
| fn:removing | fn:HasLexicalUnit | fn:lu:removing:amputate | "removing" | "amputate" | "has lexical unit" |  | "FN" |  |
| fn:removing | /r/HasA | fn:fe:agent | "removing" | "agent" | "/r/has a" |  | "FN" |  |
| fn:removing | /r/HasA | fn:fe:theme | "removing" | "theme" | "/r/has a" |  | "FN" |  |
| fn:removing | /r/HasA | fn:fe:source | "removing" | "source" | "/r/has a" |  | "FN" |  |
| fn:removing | /r/HasA | fn:fe:path | "removing" | "path" | "/r/has a" |  | "FN" |  |
| fn:removing | /r/HasA | fn:fe:goal | "removing" | "goal" | "/r/has a" |  | "FN" |  |
| fn:removing | /r/HasA | fn:fe:manner | "removing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:removing | /r/HasA | fn:fe:means | "removing" | "means" | "/r/has a" |  | "FN" |  |
| fn:removing | /r/HasA | fn:fe:result | "removing" | "result" | "/r/has a" |  | "FN" |  |
| fn:removing | /r/HasA | fn:fe:degree | "removing" | "degree" | "/r/has a" |  | "FN" |  |
| fn:removing | /r/HasA | fn:fe:cause | "removing" | "cause" | "/r/has a" |  | "FN" |  |
| fn:removing | /r/HasA | fn:fe:distance | "removing" | "distance" | "/r/has a" |  | "FN" |  |
| fn:removing | /r/HasA | fn:fe:means_of_motion | "removing" | "means of motion" | "/r/has a" |  | "FN" |  |
| fn:removing | /r/HasA | fn:fe:cotheme | "removing" | "cotheme" | "/r/has a" |  | "FN" |  |
| fn:removing | /r/HasA | fn:fe:time | "removing" | "time" | "/r/has a" |  | "FN" |  |
| fn:removing | /r/HasA | fn:fe:place | "removing" | "place" | "/r/has a" |  | "FN" |  |
| fn:removing | /r/HasA | fn:fe:explanation | "removing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:removing | /r/HasA | fn:fe:instrument | "removing" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:removing | /r/HasA | fn:fe:depictive | "removing" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:removing | /r/HasA | fn:fe:co-timed_event | "removing" | "co-timed event" | "/r/has a" |  | "FN" |  |
| fn:removing | /r/HasA | fn:fe:circumstances | "removing" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:removing | /r/HasA | fn:fe:purpose | "removing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:removing | /r/HasA | fn:fe:particular_iteration | "removing" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:removing | /r/HasA | fn:fe:direction | "removing" | "direction" | "/r/has a" |  | "FN" |  |
| fn:container_focused_removing | /r/IsA | fn:removing_scenario | "container focused removing" | "removing scenario" | "/r/is a" |  | "FN" |  |
| fn:removing | /r/IsA | fn:removing_scenario | "removing" | "removing scenario" | "/r/is a" |  | "FN" |  |
| fn:removing_scenario | /r/HasA | fn:fe:agent | "removing scenario" | "agent" | "/r/has a" |  | "FN" |  |
| fn:removing_scenario | /r/HasA | fn:fe:theme | "removing scenario" | "theme" | "/r/has a" |  | "FN" |  |
| fn:removing_scenario | /r/HasA | fn:fe:source | "removing scenario" | "source" | "/r/has a" |  | "FN" |  |
| fn:removing_scenario | /r/HasA | fn:fe:path | "removing scenario" | "path" | "/r/has a" |  | "FN" |  |
| fn:removing_scenario | /r/HasA | fn:fe:goal | "removing scenario" | "goal" | "/r/has a" |  | "FN" |  |
| fn:removing_scenario | /r/HasA | fn:fe:degree | "removing scenario" | "degree" | "/r/has a" |  | "FN" |  |
| fn:removing_scenario | /r/HasA | fn:fe:depictive | "removing scenario" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:removing_scenario | /r/HasA | fn:fe:manner | "removing scenario" | "manner" | "/r/has a" |  | "FN" |  |
| fn:removing_scenario | /r/HasA | fn:fe:means | "removing scenario" | "means" | "/r/has a" |  | "FN" |  |
| fn:removing_scenario | /r/HasA | fn:fe:result | "removing scenario" | "result" | "/r/has a" |  | "FN" |  |
| fn:removing_scenario | /r/HasA | fn:fe:instrument | "removing scenario" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:removing_scenario | /r/HasA | fn:fe:cause | "removing scenario" | "cause" | "/r/has a" |  | "FN" |  |
| fn:removing_scenario | /r/HasA | fn:fe:place | "removing scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:removing_scenario | /r/HasA | fn:fe:time | "removing scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:removing_scenario | /r/HasA | fn:fe:containing_event | "removing scenario" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:removing_scenario | /r/HasA | fn:fe:explanation | "removing scenario" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:removing_scenario | /r/HasA | fn:fe:circumstances | "removing scenario" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:render_nonfunctional | /r/IsA | fn:transitive_action | "render nonfunctional" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:render_nonfunctional | /r/UsedFor | fn:being_operational | "render nonfunctional" | "being operational" | "/r/used for" |  | "FN" |  |
| fn:render_nonfunctional | fn:HasLexicalUnit | fn:lu:render_nonfunctional:total | "render nonfunctional" | "total" | "has lexical unit" |  | "FN" |  |
| fn:render_nonfunctional | fn:HasLexicalUnit | fn:lu:render_nonfunctional:break | "render nonfunctional" | "break" | "has lexical unit" |  | "FN" |  |
| fn:render_nonfunctional | fn:HasLexicalUnit | fn:lu:render_nonfunctional:hose | "render nonfunctional" | "hose" | "has lexical unit" |  | "FN" |  |
| fn:render_nonfunctional | fn:HasLexicalUnit | fn:lu:render_nonfunctional:knock_out | "render nonfunctional" | "knock out" | "has lexical unit" |  | "FN" |  |
| fn:render_nonfunctional | fn:HasLexicalUnit | fn:lu:render_nonfunctional:disable | "render nonfunctional" | "disable" | "has lexical unit" |  | "FN" |  |
| fn:render_nonfunctional | fn:HasLexicalUnit | fn:lu:render_nonfunctional:incapacitate | "render nonfunctional" | "incapacitate" | "has lexical unit" |  | "FN" |  |
| fn:render_nonfunctional | /r/HasA | fn:fe:agent | "render nonfunctional" | "agent" | "/r/has a" |  | "FN" |  |
| fn:render_nonfunctional | /r/HasA | fn:fe:artifact | "render nonfunctional" | "artifact" | "/r/has a" |  | "FN" |  |
| fn:render_nonfunctional | /r/HasA | fn:fe:purpose | "render nonfunctional" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:render_nonfunctional | /r/HasA | fn:fe:means | "render nonfunctional" | "means" | "/r/has a" |  | "FN" |  |
| fn:render_nonfunctional | /r/HasA | fn:fe:cause | "render nonfunctional" | "cause" | "/r/has a" |  | "FN" |  |
| fn:render_nonfunctional | /r/HasA | fn:fe:time | "render nonfunctional" | "time" | "/r/has a" |  | "FN" |  |
| fn:render_nonfunctional | /r/HasA | fn:fe:place | "render nonfunctional" | "place" | "/r/has a" |  | "FN" |  |
| fn:render_nonfunctional | /r/HasA | fn:fe:manner | "render nonfunctional" | "manner" | "/r/has a" |  | "FN" |  |
| fn:render_nonfunctional | /r/HasA | fn:fe:frequency | "render nonfunctional" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:render_nonfunctional | /r/HasA | fn:fe:degree | "render nonfunctional" | "degree" | "/r/has a" |  | "FN" |  |
| fn:render_nonfunctional | /r/HasA | fn:fe:duration | "render nonfunctional" | "duration" | "/r/has a" |  | "FN" |  |
| fn:render_nonfunctional | /r/HasA | fn:fe:depictive | "render nonfunctional" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:renting | /r/IsA | fn:commerce_buy | "renting" | "commerce buy" | "/r/is a" |  | "FN" |  |
| fn:commerce_buy | /r/SimilarTo | fn:renting | "commerce buy" | "renting" | "/r/similar to" |  | "FN" |  |
| fn:renting | fn:HasLexicalUnit | fn:lu:renting:lease | "renting" | "lease" | "has lexical unit" |  | "FN" |  |
| fn:renting | fn:HasLexicalUnit | fn:lu:renting:rent | "renting" | "rent" | "has lexical unit" |  | "FN" |  |
| fn:renting | fn:HasLexicalUnit | fn:lu:renting:charter | "renting" | "charter" | "has lexical unit" |  | "FN" |  |
| fn:renting | fn:HasLexicalUnit | fn:lu:renting:hire | "renting" | "hire" | "has lexical unit" |  | "FN" |  |
| fn:renting | /r/HasA | fn:fe:lessee | "renting" | "lessee" | "/r/has a" |  | "FN" |  |
| fn:renting | /r/HasA | fn:fe:goods | "renting" | "goods" | "/r/has a" |  | "FN" |  |
| fn:renting | /r/HasA | fn:fe:means | "renting" | "means" | "/r/has a" |  | "FN" |  |
| fn:renting | /r/HasA | fn:fe:money | "renting" | "money" | "/r/has a" |  | "FN" |  |
| fn:renting | /r/HasA | fn:fe:rate | "renting" | "rate" | "/r/has a" |  | "FN" |  |
| fn:fe:lessor | /r/IsA | fn:st:source | "lessor" | "source" | "/r/is a" |  | "FN" |  |
| fn:renting | /r/HasA | fn:fe:lessor | "renting" | "lessor" | "/r/has a" |  | "FN" |  |
| fn:renting | /r/HasA | fn:fe:unit | "renting" | "unit" | "/r/has a" |  | "FN" |  |
| fn:renting | /r/HasA | fn:fe:place | "renting" | "place" | "/r/has a" |  | "FN" |  |
| fn:renting | /r/HasA | fn:fe:purpose | "renting" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:renting | /r/HasA | fn:fe:explanation | "renting" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:renting | /r/HasA | fn:fe:time | "renting" | "time" | "/r/has a" |  | "FN" |  |
| fn:renting | /r/HasA | fn:fe:manner | "renting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:renting | /r/HasA | fn:fe:recipient | "renting" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:renting | /r/HasA | fn:fe:duration | "renting" | "duration" | "/r/has a" |  | "FN" |  |
| fn:renting | /r/HasA | fn:fe:imposed_purpose | "renting" | "imposed purpose" | "/r/has a" |  | "FN" |  |
| fn:renting_out | /r/IsA | fn:commerce_sell | "renting out" | "commerce sell" | "/r/is a" |  | "FN" |  |
| fn:commerce_sell | /r/SimilarTo | fn:renting_out | "commerce sell" | "renting out" | "/r/similar to" |  | "FN" |  |
| fn:renting_out | fn:HasLexicalUnit | fn:lu:renting_out:lease | "renting out" | "lease" | "has lexical unit" |  | "FN" |  |
| fn:renting_out | fn:HasLexicalUnit | fn:lu:renting_out:rent | "renting out" | "rent" | "has lexical unit" |  | "FN" |  |
| fn:renting_out | /r/HasA | fn:fe:lessee | "renting out" | "lessee" | "/r/has a" |  | "FN" |  |
| fn:renting_out | /r/HasA | fn:fe:goods | "renting out" | "goods" | "/r/has a" |  | "FN" |  |
| fn:renting_out | /r/HasA | fn:fe:means | "renting out" | "means" | "/r/has a" |  | "FN" |  |
| fn:renting_out | /r/HasA | fn:fe:money | "renting out" | "money" | "/r/has a" |  | "FN" |  |
| fn:renting_out | /r/HasA | fn:fe:rate | "renting out" | "rate" | "/r/has a" |  | "FN" |  |
| fn:renting_out | /r/HasA | fn:fe:lessor | "renting out" | "lessor" | "/r/has a" |  | "FN" |  |
| fn:renting_out | /r/HasA | fn:fe:unit | "renting out" | "unit" | "/r/has a" |  | "FN" |  |
| fn:renting_out | /r/HasA | fn:fe:place | "renting out" | "place" | "/r/has a" |  | "FN" |  |
| fn:renting_out | /r/HasA | fn:fe:purpose | "renting out" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:renting_out | /r/HasA | fn:fe:explanation | "renting out" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:renting_out | /r/HasA | fn:fe:time | "renting out" | "time" | "/r/has a" |  | "FN" |  |
| fn:renting_out | /r/HasA | fn:fe:manner | "renting out" | "manner" | "/r/has a" |  | "FN" |  |
| fn:renting_out | /r/HasA | fn:fe:result | "renting out" | "result" | "/r/has a" |  | "FN" |  |
| fn:renting_out | /r/HasA | fn:fe:duration | "renting out" | "duration" | "/r/has a" |  | "FN" |  |
| fn:renting_out | /r/HasA | fn:fe:imposed_purpose | "renting out" | "imposed purpose" | "/r/has a" |  | "FN" |  |
| fn:renting_out | /r/HasA | fn:fe:back | "renting out" | "back" | "/r/has a" |  | "FN" |  |
| fn:renting_out | /r/HasA | fn:fe:relay | "renting out" | "relay" | "/r/has a" |  | "FN" |  |
| fn:statement | /r/UsedFor | fn:renunciation | "statement" | "renunciation" | "/r/used for" |  | "FN" |  |
| fn:renunciation | fn:HasLexicalUnit | fn:lu:renunciation:renounce | "renunciation" | "renounce" | "has lexical unit" |  | "FN" |  |
| fn:renunciation | fn:HasLexicalUnit | fn:lu:renunciation:renunciation | "renunciation" | "renunciation" | "has lexical unit" |  | "FN" |  |
| fn:renunciation | /r/HasA | fn:fe:speaker | "renunciation" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:renunciation | /r/HasA | fn:fe:addressee | "renunciation" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:renunciation | /r/HasA | fn:fe:content | "renunciation" | "content" | "/r/has a" |  | "FN" |  |
| fn:renunciation | /r/HasA | fn:fe:manner | "renunciation" | "manner" | "/r/has a" |  | "FN" |  |
| fn:renunciation | /r/HasA | fn:fe:means | "renunciation" | "means" | "/r/has a" |  | "FN" |  |
| fn:renunciation | /r/HasA | fn:fe:internal_cause | "renunciation" | "internal cause" | "/r/has a" |  | "FN" |  |
| fn:renunciation | /r/HasA | fn:fe:medium | "renunciation" | "medium" | "/r/has a" |  | "FN" |  |
| fn:renunciation | /r/HasA | fn:fe:depictive | "renunciation" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:renunciation | /r/HasA | fn:fe:time | "renunciation" | "time" | "/r/has a" |  | "FN" |  |
| fn:renunciation | /r/HasA | fn:fe:place | "renunciation" | "place" | "/r/has a" |  | "FN" |  |
| fn:renunciation | /r/HasA | fn:fe:containing_event | "renunciation" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:reparation | /r/IsA | fn:intentionally_affect | "reparation" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:reparation | fn:HasLexicalUnit | fn:lu:reparation:reparation | "reparation" | "reparation" | "has lexical unit" |  | "FN" |  |
| fn:reparation | fn:HasLexicalUnit | fn:lu:reparation:restitution | "reparation" | "restitution" | "has lexical unit" |  | "FN" |  |
| fn:reparation | fn:HasLexicalUnit | fn:lu:reparation:amends | "reparation" | "amends" | "has lexical unit" |  | "FN" |  |
| fn:reparation | fn:HasLexicalUnit | fn:lu:reparation:make_up | "reparation" | "make up" | "has lexical unit" |  | "FN" |  |
| fn:reparation | /r/HasA | fn:fe:injured_party | "reparation" | "injured party" | "/r/has a" |  | "FN" |  |
| fn:reparation | /r/HasA | fn:fe:injury | "reparation" | "injury" | "/r/has a" |  | "FN" |  |
| fn:fe:wrongdoer | /r/IsA | fn:st:sentient | "wrongdoer" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:reparation | /r/HasA | fn:fe:wrongdoer | "reparation" | "wrongdoer" | "/r/has a" |  | "FN" |  |
| fn:reparation | /r/HasA | fn:fe:benefiting_action | "reparation" | "benefiting action" | "/r/has a" |  | "FN" |  |
| fn:fe:gift | /r/IsA | fn:st:physical_entity | "gift" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:reparation | /r/HasA | fn:fe:gift | "reparation" | "gift" | "/r/has a" |  | "FN" |  |
| fn:reparation | /r/HasA | fn:fe:manner | "reparation" | "manner" | "/r/has a" |  | "FN" |  |
| fn:reparation | /r/HasA | fn:fe:place | "reparation" | "place" | "/r/has a" |  | "FN" |  |
| fn:reparation | /r/HasA | fn:fe:time | "reparation" | "time" | "/r/has a" |  | "FN" |  |
| fn:reparation | /r/HasA | fn:fe:purpose | "reparation" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:reparation | /r/HasA | fn:fe:degree | "reparation" | "degree" | "/r/has a" |  | "FN" |  |
| fn:reparation | /r/HasA | fn:fe:means | "reparation" | "means" | "/r/has a" |  | "FN" |  |
| fn:repayment | /r/UsedFor | fn:bond_maturation | "repayment" | "bond maturation" | "/r/used for" |  | "FN" |  |
| fn:repayment | fn:HasLexicalUnit | fn:lu:repayment:repay | "repayment" | "repay" | "has lexical unit" |  | "FN" |  |
| fn:repayment | fn:HasLexicalUnit | fn:lu:repayment:repayment | "repayment" | "repayment" | "has lexical unit" |  | "FN" |  |
| fn:repayment | fn:HasLexicalUnit | fn:lu:repayment:pay_back | "repayment" | "pay back" | "has lexical unit" |  | "FN" |  |
| fn:fe:loaner | /r/IsA | fn:st:sentient | "loaner" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:repayment | /r/HasA | fn:fe:loaner | "repayment" | "loaner" | "/r/has a" |  | "FN" |  |
| fn:fe:debtor | /r/IsA | fn:st:sentient | "debtor" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:repayment | /r/HasA | fn:fe:debtor | "repayment" | "debtor" | "/r/has a" |  | "FN" |  |
| fn:repayment | /r/HasA | fn:fe:money | "repayment" | "money" | "/r/has a" |  | "FN" |  |
| fn:repayment | /r/HasA | fn:fe:loan | "repayment" | "loan" | "/r/has a" |  | "FN" |  |
| fn:repayment | /r/HasA | fn:fe:degree | "repayment" | "degree" | "/r/has a" |  | "FN" |  |
| fn:repayment | /r/HasA | fn:fe:time | "repayment" | "time" | "/r/has a" |  | "FN" |  |
| fn:repayment | /r/HasA | fn:fe:circumstances | "repayment" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:repayment | /r/HasA | fn:fe:manner | "repayment" | "manner" | "/r/has a" |  | "FN" |  |
| fn:repayment | /r/HasA | fn:fe:place | "repayment" | "place" | "/r/has a" |  | "FN" |  |
| fn:repayment | /r/HasA | fn:fe:means | "repayment" | "means" | "/r/has a" |  | "FN" |  |
| fn:invasion_scenario | /r/HasSubevent | fn:repel | "invasion scenario" | "repel" | "/r/has subevent" |  | "FN" |  |
| fn:level_of_force_resistance | /r/UsedFor | fn:repel | "level of force resistance" | "repel" | "/r/used for" |  | "FN" |  |
| fn:repel | /r/HasPrerequisite | fn:invading | "repel" | "invading" | "/r/has prerequisite" |  | "FN" |  |
| fn:repel | fn:HasLexicalUnit | fn:lu:repel:repel | "repel" | "repel" | "has lexical unit" |  | "FN" |  |
| fn:repel | fn:HasLexicalUnit | fn:lu:repel:resist | "repel" | "resist" | "has lexical unit" |  | "FN" |  |
| fn:repel | /r/HasA | fn:fe:enemy | "repel" | "enemy" | "/r/has a" |  | "FN" |  |
| fn:repel | /r/HasA | fn:fe:defender | "repel" | "defender" | "/r/has a" |  | "FN" |  |
| fn:repel | /r/HasA | fn:fe:degree | "repel" | "degree" | "/r/has a" |  | "FN" |  |
| fn:repel | /r/HasA | fn:fe:manner | "repel" | "manner" | "/r/has a" |  | "FN" |  |
| fn:repel | /r/HasA | fn:fe:means | "repel" | "means" | "/r/has a" |  | "FN" |  |
| fn:repel | /r/HasA | fn:fe:place | "repel" | "place" | "/r/has a" |  | "FN" |  |
| fn:repel | /r/HasA | fn:fe:time | "repel" | "time" | "/r/has a" |  | "FN" |  |
| fn:repel | /r/HasA | fn:fe:purpose | "repel" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:repel | /r/HasA | fn:fe:instrument | "repel" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:repel | /r/HasA | fn:fe:invasion_act | "repel" | "invasion act" | "/r/has a" |  | "FN" |  |
| fn:repel | /r/HasA | fn:fe:result | "repel" | "result" | "/r/has a" |  | "FN" |  |
| fn:replacing | /r/IsA | fn:intentionally_affect | "replacing" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:exchange | /r/RelatedTo | fn:replacing | "exchange" | "replacing" | "/r/related to" |  | "FN" |  |
| fn:replacing | /r/Causes | fn:take_place_of | "replacing" | "take place of" | "/r/causes" |  | "FN" |  |
| fn:replacing | fn:HasLexicalUnit | fn:lu:replacing:replace | "replacing" | "replace" | "has lexical unit" |  | "FN" |  |
| fn:replacing | fn:HasLexicalUnit | fn:lu:replacing:substitute | "replacing" | "substitute" | "has lexical unit" |  | "FN" |  |
| fn:replacing | fn:HasLexicalUnit | fn:lu:replacing:replacement | "replacing" | "replacement" | "has lexical unit" |  | "FN" |  |
| fn:replacing | fn:HasLexicalUnit | fn:lu:replacing:substitution | "replacing" | "substitution" | "has lexical unit" |  | "FN" |  |
| fn:replacing | fn:HasLexicalUnit | fn:lu:replacing:swap_out | "replacing" | "swap out" | "has lexical unit" |  | "FN" |  |
| fn:replacing | fn:HasLexicalUnit | fn:lu:replacing:exchange | "replacing" | "exchange" | "has lexical unit" |  | "FN" |  |
| fn:replacing | fn:HasLexicalUnit | fn:lu:replacing:change | "replacing" | "change" | "has lexical unit" |  | "FN" |  |
| fn:replacing | fn:HasLexicalUnit | fn:lu:replacing:switch | "replacing" | "switch" | "has lexical unit" |  | "FN" |  |
| fn:replacing | /r/HasA | fn:fe:means | "replacing" | "means" | "/r/has a" |  | "FN" |  |
| fn:replacing | /r/HasA | fn:fe:agent | "replacing" | "agent" | "/r/has a" |  | "FN" |  |
| fn:replacing | /r/HasA | fn:fe:instrument | "replacing" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:replacing | /r/HasA | fn:fe:place | "replacing" | "place" | "/r/has a" |  | "FN" |  |
| fn:replacing | /r/HasA | fn:fe:purpose | "replacing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:replacing | /r/HasA | fn:fe:time | "replacing" | "time" | "/r/has a" |  | "FN" |  |
| fn:replacing | /r/HasA | fn:fe:new | "replacing" | "new" | "/r/has a" |  | "FN" |  |
| fn:replacing | /r/HasA | fn:fe:manner | "replacing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:replacing | /r/HasA | fn:fe:explanation | "replacing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:replacing | /r/HasA | fn:fe:degree | "replacing" | "degree" | "/r/has a" |  | "FN" |  |
| fn:replacing | /r/HasA | fn:fe:old | "replacing" | "old" | "/r/has a" |  | "FN" |  |
| fn:replacing | /r/HasA | fn:fe:role | "replacing" | "role" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:reporting | "communication" | "reporting" | "/r/used for" |  | "FN" |  |
| fn:reporting | /r/SimilarTo | fn:indicating | "reporting" | "indicating" | "/r/similar to" |  | "FN" |  |
| fn:reporting | fn:HasLexicalUnit | fn:lu:reporting:report | "reporting" | "report" | "has lexical unit" |  | "FN" |  |
| fn:reporting | fn:HasLexicalUnit | fn:lu:reporting:rat | "reporting" | "rat" | "has lexical unit" |  | "FN" |  |
| fn:reporting | fn:HasLexicalUnit | fn:lu:reporting:inform | "reporting" | "inform" | "has lexical unit" |  | "FN" |  |
| fn:reporting | fn:HasLexicalUnit | fn:lu:reporting:tell_(on) | "reporting" | "tell (on)" | "has lexical unit" |  | "FN" |  |
| fn:reporting | fn:HasLexicalUnit | fn:lu:reporting:rat_out | "reporting" | "rat out" | "has lexical unit" |  | "FN" |  |
| fn:reporting | fn:HasLexicalUnit | fn:lu:reporting:squeal | "reporting" | "squeal" | "has lexical unit" |  | "FN" |  |
| fn:reporting | fn:HasLexicalUnit | fn:lu:reporting:snitch | "reporting" | "snitch" | "has lexical unit" |  | "FN" |  |
| fn:reporting | fn:HasLexicalUnit | fn:lu:reporting:peach | "reporting" | "peach" | "has lexical unit" |  | "FN" |  |
| fn:reporting | fn:HasLexicalUnit | fn:lu:reporting:fink | "reporting" | "fink" | "has lexical unit" |  | "FN" |  |
| fn:reporting | fn:HasLexicalUnit | fn:lu:reporting:informer | "reporting" | "informer" | "has lexical unit" |  | "FN" |  |
| fn:reporting | fn:HasLexicalUnit | fn:lu:reporting:snitch | "reporting" | "snitch" | "has lexical unit" |  | "FN" |  |
| fn:reporting | fn:HasLexicalUnit | fn:lu:reporting:nark | "reporting" | "nark" | "has lexical unit" |  | "FN" |  |
| fn:reporting | fn:HasLexicalUnit | fn:lu:reporting:fink | "reporting" | "fink" | "has lexical unit" |  | "FN" |  |
| fn:reporting | /r/HasA | fn:fe:informer | "reporting" | "informer" | "/r/has a" |  | "FN" |  |
| fn:reporting | /r/HasA | fn:fe:wrongdoer | "reporting" | "wrongdoer" | "/r/has a" |  | "FN" |  |
| fn:reporting | /r/HasA | fn:fe:authorities | "reporting" | "authorities" | "/r/has a" |  | "FN" |  |
| fn:reporting | /r/HasA | fn:fe:behavior | "reporting" | "behavior" | "/r/has a" |  | "FN" |  |
| fn:reporting | /r/HasA | fn:fe:time | "reporting" | "time" | "/r/has a" |  | "FN" |  |
| fn:reporting | /r/HasA | fn:fe:place | "reporting" | "place" | "/r/has a" |  | "FN" |  |
| fn:reporting | /r/HasA | fn:fe:purpose | "reporting" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:representative | /r/IsA | fn:people_by_vocation | "representative" | "people by vocation" | "/r/is a" |  | "FN" |  |
| fn:representative | fn:HasLexicalUnit | fn:lu:representative:spokesman | "representative" | "spokesman" | "has lexical unit" |  | "FN" |  |
| fn:representative | fn:HasLexicalUnit | fn:lu:representative:representative | "representative" | "representative" | "has lexical unit" |  | "FN" |  |
| fn:representative | fn:HasLexicalUnit | fn:lu:representative:spokeswoman | "representative" | "spokeswoman" | "has lexical unit" |  | "FN" |  |
| fn:representative | fn:HasLexicalUnit | fn:lu:representative:spokesperson | "representative" | "spokesperson" | "has lexical unit" |  | "FN" |  |
| fn:representative | /r/HasA | fn:fe:origin | "representative" | "origin" | "/r/has a" |  | "FN" |  |
| fn:fe:representative | /r/IsA | fn:st:human | "representative" | "human" | "/r/is a" |  | "FN" |  |
| fn:representative | /r/HasA | fn:fe:representative | "representative" | "representative" | "/r/has a" |  | "FN" |  |
| fn:representative | /r/HasA | fn:fe:persistent_characteristic | "representative" | "persistent characteristic" | "/r/has a" |  | "FN" |  |
| fn:representative | /r/HasA | fn:fe:descriptor | "representative" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:representative | /r/HasA | fn:fe:age | "representative" | "age" | "/r/has a" |  | "FN" |  |
| fn:representative | /r/HasA | fn:fe:ethnicity | "representative" | "ethnicity" | "/r/has a" |  | "FN" |  |
| fn:representative | /r/HasA | fn:fe:context_of_acquaintance | "representative" | "context of acquaintance" | "/r/has a" |  | "FN" |  |
| fn:representative | /r/HasA | fn:fe:rank | "representative" | "rank" | "/r/has a" |  | "FN" |  |
| fn:representative | /r/HasA | fn:fe:place_of_employment | "representative" | "place of employment" | "/r/has a" |  | "FN" |  |
| fn:representative | /r/HasA | fn:fe:represented | "representative" | "represented" | "/r/has a" |  | "FN" |  |
| fn:representative | /r/HasA | fn:fe:type | "representative" | "type" | "/r/has a" |  | "FN" |  |
| fn:representative | /r/HasA | fn:fe:compensation | "representative" | "compensation" | "/r/has a" |  | "FN" |  |
| fn:representative | /r/HasA | fn:fe:contract_basis | "representative" | "contract basis" | "/r/has a" |  | "FN" |  |
| fn:awareness | /r/UsedFor | fn:representing | "awareness" | "representing" | "/r/used for" |  | "FN" |  |
| fn:representing | fn:HasLexicalUnit | fn:lu:representing:symbolize | "representing" | "symbolize" | "has lexical unit" |  | "FN" |  |
| fn:representing | fn:HasLexicalUnit | fn:lu:representing:be_symbol | "representing" | "be symbol" | "has lexical unit" |  | "FN" |  |
| fn:representing | /r/HasA | fn:fe:phenomenon | "representing" | "phenomenon" | "/r/has a" |  | "FN" |  |
| fn:representing | /r/HasA | fn:fe:degree | "representing" | "degree" | "/r/has a" |  | "FN" |  |
| fn:representing | /r/HasA | fn:fe:time | "representing" | "time" | "/r/has a" |  | "FN" |  |
| fn:representing | /r/HasA | fn:fe:means | "representing" | "means" | "/r/has a" |  | "FN" |  |
| fn:representing | /r/HasA | fn:fe:entity | "representing" | "entity" | "/r/has a" |  | "FN" |  |
| fn:representing | /r/HasA | fn:fe:cognizer | "representing" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:representing | /r/HasA | fn:fe:frequency | "representing" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:representing | /r/HasA | fn:fe:explanation | "representing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:representing | /r/HasA | fn:fe:place | "representing" | "place" | "/r/has a" |  | "FN" |  |
| fn:request_entity | /r/IsA | fn:request | "request entity" | "request" | "/r/is a" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:request | "communication" | "request" | "/r/used for" |  | "FN" |  |
| fn:request | /r/SimilarTo | fn:attempt_suasion | "request" | "attempt suasion" | "/r/similar to" |  | "FN" |  |
| fn:request | /r/SimilarTo | fn:questioning | "request" | "questioning" | "/r/similar to" |  | "FN" |  |
| fn:request | /r/SimilarTo | fn:telling | "request" | "telling" | "/r/similar to" |  | "FN" |  |
| fn:request | fn:HasLexicalUnit | fn:lu:request:appeal | "request" | "appeal" | "has lexical unit" |  | "FN" |  |
| fn:request | fn:HasLexicalUnit | fn:lu:request:ask | "request" | "ask" | "has lexical unit" |  | "FN" |  |
| fn:request | fn:HasLexicalUnit | fn:lu:request:beg | "request" | "beg" | "has lexical unit" |  | "FN" |  |
| fn:request | fn:HasLexicalUnit | fn:lu:request:beseech | "request" | "beseech" | "has lexical unit" |  | "FN" |  |
| fn:request | fn:HasLexicalUnit | fn:lu:request:command | "request" | "command" | "has lexical unit" |  | "FN" |  |
| fn:request | fn:HasLexicalUnit | fn:lu:request:command | "request" | "command" | "has lexical unit" |  | "FN" |  |
| fn:request | fn:HasLexicalUnit | fn:lu:request:demand | "request" | "demand" | "has lexical unit" |  | "FN" |  |
| fn:request | fn:HasLexicalUnit | fn:lu:request:demand | "request" | "demand" | "has lexical unit" |  | "FN" |  |
| fn:request | fn:HasLexicalUnit | fn:lu:request:entreat | "request" | "entreat" | "has lexical unit" |  | "FN" |  |
| fn:request | fn:HasLexicalUnit | fn:lu:request:entreaty | "request" | "entreaty" | "has lexical unit" |  | "FN" |  |
| fn:request | fn:HasLexicalUnit | fn:lu:request:implore | "request" | "implore" | "has lexical unit" |  | "FN" |  |
| fn:request | fn:HasLexicalUnit | fn:lu:request:order | "request" | "order" | "has lexical unit" |  | "FN" |  |
| fn:request | fn:HasLexicalUnit | fn:lu:request:order | "request" | "order" | "has lexical unit" |  | "FN" |  |
| fn:request | fn:HasLexicalUnit | fn:lu:request:petition | "request" | "petition" | "has lexical unit" |  | "FN" |  |
| fn:request | fn:HasLexicalUnit | fn:lu:request:plea | "request" | "plea" | "has lexical unit" |  | "FN" |  |
| fn:request | fn:HasLexicalUnit | fn:lu:request:plead | "request" | "plead" | "has lexical unit" |  | "FN" |  |
| fn:request | fn:HasLexicalUnit | fn:lu:request:request | "request" | "request" | "has lexical unit" |  | "FN" |  |
| fn:request | fn:HasLexicalUnit | fn:lu:request:request | "request" | "request" | "has lexical unit" |  | "FN" |  |
| fn:request | fn:HasLexicalUnit | fn:lu:request:summon | "request" | "summon" | "has lexical unit" |  | "FN" |  |
| fn:request | fn:HasLexicalUnit | fn:lu:request:tell | "request" | "tell" | "has lexical unit" |  | "FN" |  |
| fn:request | fn:HasLexicalUnit | fn:lu:request:urge | "request" | "urge" | "has lexical unit" |  | "FN" |  |
| fn:request | fn:HasLexicalUnit | fn:lu:request:call | "request" | "call" | "has lexical unit" |  | "FN" |  |
| fn:request | fn:HasLexicalUnit | fn:lu:request:invite | "request" | "invite" | "has lexical unit" |  | "FN" |  |
| fn:request | fn:HasLexicalUnit | fn:lu:request:call | "request" | "call" | "has lexical unit" |  | "FN" |  |
| fn:request | fn:HasLexicalUnit | fn:lu:request:instruct | "request" | "instruct" | "has lexical unit" |  | "FN" |  |
| fn:request | fn:HasLexicalUnit | fn:lu:request:invitation | "request" | "invitation" | "has lexical unit" |  | "FN" |  |
| fn:request | /r/HasA | fn:fe:speaker | "request" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:request | /r/HasA | fn:fe:addressee | "request" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:request | /r/HasA | fn:fe:message | "request" | "message" | "/r/has a" |  | "FN" |  |
| fn:request | /r/HasA | fn:fe:topic | "request" | "topic" | "/r/has a" |  | "FN" |  |
| fn:request | /r/HasA | fn:fe:medium | "request" | "medium" | "/r/has a" |  | "FN" |  |
| fn:request | /r/HasA | fn:fe:manner | "request" | "manner" | "/r/has a" |  | "FN" |  |
| fn:request | /r/HasA | fn:fe:means | "request" | "means" | "/r/has a" |  | "FN" |  |
| fn:request | /r/HasA | fn:fe:time | "request" | "time" | "/r/has a" |  | "FN" |  |
| fn:request | /r/HasA | fn:fe:beneficiary | "request" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:request | /r/HasA | fn:fe:containing_event | "request" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:request | /r/HasA | fn:fe:iterations | "request" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:request | /r/HasA | fn:fe:depictive | "request" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:request_entity | /r/IsA | fn:request | "request entity" | "request" | "/r/is a" |  | "FN" |  |
| fn:request_entity | fn:HasLexicalUnit | fn:lu:request_entity:order | "request entity" | "order" | "has lexical unit" |  | "FN" |  |
| fn:request_entity | fn:HasLexicalUnit | fn:lu:request_entity:order | "request entity" | "order" | "has lexical unit" |  | "FN" |  |
| fn:request_entity | fn:HasLexicalUnit | fn:lu:request_entity:order_[physical_object] | "request entity" | "order [physical object]" | "has lexical unit" |  | "FN" |  |
| fn:request_entity | /r/HasA | fn:fe:customer | "request entity" | "customer" | "/r/has a" |  | "FN" |  |
| fn:request_entity | /r/HasA | fn:fe:entity | "request entity" | "entity" | "/r/has a" |  | "FN" |  |
| fn:request_entity | /r/HasA | fn:fe:medium | "request entity" | "medium" | "/r/has a" |  | "FN" |  |
| fn:request_entity | /r/HasA | fn:fe:supplier | "request entity" | "supplier" | "/r/has a" |  | "FN" |  |
| fn:request_entity | /r/HasA | fn:fe:time | "request entity" | "time" | "/r/has a" |  | "FN" |  |
| fn:request_entity | /r/HasA | fn:fe:beneficiary | "request entity" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:request_entity | /r/HasA | fn:fe:manner | "request entity" | "manner" | "/r/has a" |  | "FN" |  |
| fn:request_entity | /r/HasA | fn:fe:means | "request entity" | "means" | "/r/has a" |  | "FN" |  |
| fn:obligation_scenario | /r/IsA | fn:required_event | "obligation scenario" | "required event" | "/r/is a" |  | "FN" |  |
| fn:being_necessary | /r/UsedFor | fn:required_event | "being necessary" | "required event" | "/r/used for" |  | "FN" |  |
| fn:required_event | /r/UsedFor | fn:deserving | "required event" | "deserving" | "/r/used for" |  | "FN" |  |
| fn:required_event | /r/UsedFor | fn:desirable_event | "required event" | "desirable event" | "/r/used for" |  | "FN" |  |
| fn:required_event | /r/RelatedTo | fn:being_obligated | "required event" | "being obligated" | "/r/related to" |  | "FN" |  |
| fn:being_obligated | /r/SimilarTo | fn:required_event | "being obligated" | "required event" | "/r/similar to" |  | "FN" |  |
| fn:required_event | /r/SimilarTo | fn:desirable_event | "required event" | "desirable event" | "/r/similar to" |  | "FN" |  |
| fn:required_event | /r/IsA | fn:preferred_alternative_scenario | "required event" | "preferred alternative scenario" | "/r/is a" |  | "FN" |  |
| fn:required_event | fn:HasLexicalUnit | fn:lu:required_event:must | "required event" | "must" | "has lexical unit" |  | "FN" |  |
| fn:required_event | fn:HasLexicalUnit | fn:lu:required_event:need | "required event" | "need" | "has lexical unit" |  | "FN" |  |
| fn:required_event | fn:HasLexicalUnit | fn:lu:required_event:had_better | "required event" | "had better" | "has lexical unit" |  | "FN" |  |
| fn:required_event | fn:HasLexicalUnit | fn:lu:required_event:better | "required event" | "better" | "has lexical unit" |  | "FN" |  |
| fn:required_event | fn:HasLexicalUnit | fn:lu:required_event:got_to | "required event" | "got to" | "has lexical unit" |  | "FN" |  |
| fn:required_event | fn:HasLexicalUnit | fn:lu:required_event:gotta | "required event" | "gotta" | "has lexical unit" |  | "FN" |  |
| fn:required_event | fn:HasLexicalUnit | fn:lu:required_event:hafta | "required event" | "hafta" | "has lexical unit" |  | "FN" |  |
| fn:required_event | fn:HasLexicalUnit | fn:lu:required_event:oughta | "required event" | "oughta" | "has lexical unit" |  | "FN" |  |
| fn:required_event | fn:HasLexicalUnit | fn:lu:required_event:have_to | "required event" | "have to" | "has lexical unit" |  | "FN" |  |
| fn:required_event | fn:HasLexicalUnit | fn:lu:required_event:ought_to | "required event" | "ought to" | "has lexical unit" |  | "FN" |  |
| fn:required_event | fn:HasLexicalUnit | fn:lu:required_event:be_supposed_(to) | "required event" | "be supposed (to)" | "has lexical unit" |  | "FN" |  |
| fn:required_event | fn:HasLexicalUnit | fn:lu:required_event:best | "required event" | "best" | "has lexical unit" |  | "FN" |  |
| fn:required_event | fn:HasLexicalUnit | fn:lu:required_event:shall | "required event" | "shall" | "has lexical unit" |  | "FN" |  |
| fn:required_event | /r/HasA | fn:fe:required_situation | "required event" | "required situation" | "/r/has a" |  | "FN" |  |
| fn:required_event | /r/HasA | fn:fe:negative_consequences | "required event" | "negative consequences" | "/r/has a" |  | "FN" |  |
| fn:required_event | /r/HasA | fn:fe:circumstances | "required event" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:required_event | /r/HasA | fn:fe:purpose | "required event" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:required_event | /r/HasA | fn:fe:time | "required event" | "time" | "/r/has a" |  | "FN" |  |
| fn:required_event | /r/HasA | fn:fe:place | "required event" | "place" | "/r/has a" |  | "FN" |  |
| fn:required_event | /r/HasA | fn:fe:explanation | "required event" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:required_event | /r/HasA | fn:fe:degree | "required event" | "degree" | "/r/has a" |  | "FN" |  |
| fn:being_necessary | /r/IsA | fn:requirement_scenario | "being necessary" | "requirement scenario" | "/r/is a" |  | "FN" |  |
| fn:have_as_requirement | /r/IsA | fn:requirement_scenario | "have as requirement" | "requirement scenario" | "/r/is a" |  | "FN" |  |
| fn:requirement_scenario | /r/HasA | fn:fe:dependent | "requirement scenario" | "dependent" | "/r/has a" |  | "FN" |  |
| fn:requirement_scenario | /r/HasA | fn:fe:requirement | "requirement scenario" | "requirement" | "/r/has a" |  | "FN" |  |
| fn:requirement_scenario | /r/HasA | fn:fe:degree | "requirement scenario" | "degree" | "/r/has a" |  | "FN" |  |
| fn:requirement_scenario | /r/HasA | fn:fe:explanation | "requirement scenario" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:requirement_scenario | /r/HasA | fn:fe:time | "requirement scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:requirement_scenario | /r/HasA | fn:fe:condition | "requirement scenario" | "condition" | "/r/has a" |  | "FN" |  |
| fn:requirement_scenario | /r/HasA | fn:fe:domain | "requirement scenario" | "domain" | "/r/has a" |  | "FN" |  |
| fn:requirement_scenario | /r/HasA | fn:fe:place | "requirement scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:requirement_scenario | /r/HasA | fn:fe:dependent_individual | "requirement scenario" | "dependent individual" | "/r/has a" |  | "FN" |  |
| fn:requirement_scenario | /r/HasA | fn:fe:required_entity | "requirement scenario" | "required entity" | "/r/has a" |  | "FN" |  |
| fn:requirement_scenario | /r/HasA | fn:fe:required_individual | "requirement scenario" | "required individual" | "/r/has a" |  | "FN" |  |
| fn:rescuing | /r/IsA | fn:intentionally_affect | "rescuing" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:risk_scenario | /r/UsedFor | fn:rescuing | "risk scenario" | "rescuing" | "/r/used for" |  | "FN" |  |
| fn:rescuing | fn:HasLexicalUnit | fn:lu:rescuing:rescue | "rescuing" | "rescue" | "has lexical unit" |  | "FN" |  |
| fn:rescuing | fn:HasLexicalUnit | fn:lu:rescuing:save | "rescuing" | "save" | "has lexical unit" |  | "FN" |  |
| fn:rescuing | /r/HasA | fn:fe:agent | "rescuing" | "agent" | "/r/has a" |  | "FN" |  |
| fn:rescuing | /r/HasA | fn:fe:patient | "rescuing" | "patient" | "/r/has a" |  | "FN" |  |
| fn:rescuing | /r/HasA | fn:fe:asset | "rescuing" | "asset" | "/r/has a" |  | "FN" |  |
| fn:rescuing | /r/HasA | fn:fe:harmful_situation | "rescuing" | "harmful situation" | "/r/has a" |  | "FN" |  |
| fn:rescuing | /r/HasA | fn:fe:time | "rescuing" | "time" | "/r/has a" |  | "FN" |  |
| fn:rescuing | /r/HasA | fn:fe:manner | "rescuing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:rescuing | /r/HasA | fn:fe:place | "rescuing" | "place" | "/r/has a" |  | "FN" |  |
| fn:rescuing | /r/HasA | fn:fe:circumstances | "rescuing" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:rescuing | /r/HasA | fn:fe:instrument | "rescuing" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:rescuing | /r/HasA | fn:fe:means | "rescuing" | "means" | "/r/has a" |  | "FN" |  |
| fn:rescuing | /r/HasA | fn:fe:purpose | "rescuing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:rescuing | /r/HasA | fn:fe:explanation | "rescuing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:rescuing | /r/HasA | fn:fe:degree | "rescuing" | "degree" | "/r/has a" |  | "FN" |  |
| fn:trying_out | /r/IsA | fn:research | "trying out" | "research" | "/r/is a" |  | "FN" |  |
| fn:research | /r/IsA | fn:scrutiny | "research" | "scrutiny" | "/r/is a" |  | "FN" |  |
| fn:cogitation | /r/UsedFor | fn:research | "cogitation" | "research" | "/r/used for" |  | "FN" |  |
| fn:scrutiny | /r/SimilarTo | fn:research | "scrutiny" | "research" | "/r/similar to" |  | "FN" |  |
| fn:research | fn:HasLexicalUnit | fn:lu:research:research | "research" | "research" | "has lexical unit" |  | "FN" |  |
| fn:research | fn:HasLexicalUnit | fn:lu:research:research | "research" | "research" | "has lexical unit" |  | "FN" |  |
| fn:research | fn:HasLexicalUnit | fn:lu:research:investigate | "research" | "investigate" | "has lexical unit" |  | "FN" |  |
| fn:fe:researcher | /r/IsA | fn:st:sentient | "researcher" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:research | /r/HasA | fn:fe:researcher | "research" | "researcher" | "/r/has a" |  | "FN" |  |
| fn:research | /r/HasA | fn:fe:field | "research" | "field" | "/r/has a" |  | "FN" |  |
| fn:research | /r/HasA | fn:fe:question | "research" | "question" | "/r/has a" |  | "FN" |  |
| fn:research | /r/HasA | fn:fe:topic | "research" | "topic" | "/r/has a" |  | "FN" |  |
| fn:research | /r/HasA | fn:fe:time | "research" | "time" | "/r/has a" |  | "FN" |  |
| fn:research | /r/HasA | fn:fe:means | "research" | "means" | "/r/has a" |  | "FN" |  |
| fn:research | /r/HasA | fn:fe:population | "research" | "population" | "/r/has a" |  | "FN" |  |
| fn:research | /r/HasA | fn:fe:manner | "research" | "manner" | "/r/has a" |  | "FN" |  |
| fn:research | /r/HasA | fn:fe:purpose | "research" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:research | /r/HasA | fn:fe:duration_of_state | "research" | "duration of state" | "/r/has a" |  | "FN" |  |
| fn:research | /r/HasA | fn:fe:place | "research" | "place" | "/r/has a" |  | "FN" |  |
| fn:research | /r/HasA | fn:fe:type | "research" | "type" | "/r/has a" |  | "FN" |  |
| fn:reserving | /r/IsA | fn:scheduling | "reserving" | "scheduling" | "/r/is a" |  | "FN" |  |
| fn:reserving | fn:HasLexicalUnit | fn:lu:reserving:reserve | "reserving" | "reserve" | "has lexical unit" |  | "FN" |  |
| fn:reserving | fn:HasLexicalUnit | fn:lu:reserving:book | "reserving" | "book" | "has lexical unit" |  | "FN" |  |
| fn:reserving | fn:HasLexicalUnit | fn:lu:reserving:hold | "reserving" | "hold" | "has lexical unit" |  | "FN" |  |
| fn:reserving | fn:HasLexicalUnit | fn:lu:reserving:reservation | "reserving" | "reservation" | "has lexical unit" |  | "FN" |  |
| fn:reserving | fn:HasLexicalUnit | fn:lu:reserving:booking | "reserving" | "booking" | "has lexical unit" |  | "FN" |  |
| fn:reserving | /r/HasA | fn:fe:client | "reserving" | "client" | "/r/has a" |  | "FN" |  |
| fn:reserving | /r/HasA | fn:fe:services | "reserving" | "services" | "/r/has a" |  | "FN" |  |
| fn:reserving | /r/HasA | fn:fe:organization | "reserving" | "organization" | "/r/has a" |  | "FN" |  |
| fn:reserving | /r/HasA | fn:fe:scheduled_time | "reserving" | "scheduled time" | "/r/has a" |  | "FN" |  |
| fn:reserving | /r/HasA | fn:fe:booker | "reserving" | "booker" | "/r/has a" |  | "FN" |  |
| fn:reserving | /r/HasA | fn:fe:manner | "reserving" | "manner" | "/r/has a" |  | "FN" |  |
| fn:reserving | /r/HasA | fn:fe:place | "reserving" | "place" | "/r/has a" |  | "FN" |  |
| fn:reserving | /r/HasA | fn:fe:purpose | "reserving" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:reserving | /r/HasA | fn:fe:means | "reserving" | "means" | "/r/has a" |  | "FN" |  |
| fn:reserving | /r/HasA | fn:fe:time | "reserving" | "time" | "/r/has a" |  | "FN" |  |
| fn:reserving | /r/HasA | fn:fe:payment | "reserving" | "payment" | "/r/has a" |  | "FN" |  |
| fn:reshaping | /r/IsA | fn:damaging | "reshaping" | "damaging" | "/r/is a" |  | "FN" |  |
| fn:reshaping | /r/SimilarTo | fn:cause_change | "reshaping" | "cause change" | "/r/similar to" |  | "FN" |  |
| fn:reshaping | /r/SimilarTo | fn:grinding | "reshaping" | "grinding" | "/r/similar to" |  | "FN" |  |
| fn:reshaping | fn:HasLexicalUnit | fn:lu:reshaping:scrunch | "reshaping" | "scrunch" | "has lexical unit" |  | "FN" |  |
| fn:reshaping | fn:HasLexicalUnit | fn:lu:reshaping:flatten | "reshaping" | "flatten" | "has lexical unit" |  | "FN" |  |
| fn:reshaping | fn:HasLexicalUnit | fn:lu:reshaping:crumple | "reshaping" | "crumple" | "has lexical unit" |  | "FN" |  |
| fn:reshaping | fn:HasLexicalUnit | fn:lu:reshaping:squish | "reshaping" | "squish" | "has lexical unit" |  | "FN" |  |
| fn:reshaping | fn:HasLexicalUnit | fn:lu:reshaping:dent | "reshaping" | "dent" | "has lexical unit" |  | "FN" |  |
| fn:reshaping | fn:HasLexicalUnit | fn:lu:reshaping:squash | "reshaping" | "squash" | "has lexical unit" |  | "FN" |  |
| fn:reshaping | fn:HasLexicalUnit | fn:lu:reshaping:crush | "reshaping" | "crush" | "has lexical unit" |  | "FN" |  |
| fn:reshaping | fn:HasLexicalUnit | fn:lu:reshaping:warp | "reshaping" | "warp" | "has lexical unit" |  | "FN" |  |
| fn:reshaping | fn:HasLexicalUnit | fn:lu:reshaping:roll | "reshaping" | "roll" | "has lexical unit" |  | "FN" |  |
| fn:reshaping | fn:HasLexicalUnit | fn:lu:reshaping:fold | "reshaping" | "fold" | "has lexical unit" |  | "FN" |  |
| fn:reshaping | fn:HasLexicalUnit | fn:lu:reshaping:form | "reshaping" | "form" | "has lexical unit" |  | "FN" |  |
| fn:reshaping | fn:HasLexicalUnit | fn:lu:reshaping:shape | "reshaping" | "shape" | "has lexical unit" |  | "FN" |  |
| fn:reshaping | fn:HasLexicalUnit | fn:lu:reshaping:mold | "reshaping" | "mold" | "has lexical unit" |  | "FN" |  |
| fn:reshaping | fn:HasLexicalUnit | fn:lu:reshaping:deformation | "reshaping" | "deformation" | "has lexical unit" |  | "FN" |  |
| fn:reshaping | fn:HasLexicalUnit | fn:lu:reshaping:bend | "reshaping" | "bend" | "has lexical unit" |  | "FN" |  |
| fn:reshaping | fn:HasLexicalUnit | fn:lu:reshaping:launch | "reshaping" | "launch" | "has lexical unit" |  | "FN" |  |
| fn:reshaping | fn:HasLexicalUnit | fn:lu:reshaping:curl | "reshaping" | "curl" | "has lexical unit" |  | "FN" |  |
| fn:fe:deformer | /r/IsA | fn:st:sentient | "deformer" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:reshaping | /r/HasA | fn:fe:deformer | "reshaping" | "deformer" | "/r/has a" |  | "FN" |  |
| fn:reshaping | /r/HasA | fn:fe:instrument | "reshaping" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:reshaping | /r/HasA | fn:fe:manner | "reshaping" | "manner" | "/r/has a" |  | "FN" |  |
| fn:reshaping | /r/HasA | fn:fe:means | "reshaping" | "means" | "/r/has a" |  | "FN" |  |
| fn:reshaping | /r/HasA | fn:fe:patient | "reshaping" | "patient" | "/r/has a" |  | "FN" |  |
| fn:reshaping | /r/HasA | fn:fe:place | "reshaping" | "place" | "/r/has a" |  | "FN" |  |
| fn:reshaping | /r/HasA | fn:fe:purpose | "reshaping" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:reshaping | /r/HasA | fn:fe:time | "reshaping" | "time" | "/r/has a" |  | "FN" |  |
| fn:reshaping | /r/HasA | fn:fe:result | "reshaping" | "result" | "/r/has a" |  | "FN" |  |
| fn:reshaping | /r/HasA | fn:fe:resistant_surface | "reshaping" | "resistant surface" | "/r/has a" |  | "FN" |  |
| fn:reshaping | /r/HasA | fn:fe:locus | "reshaping" | "locus" | "/r/has a" |  | "FN" |  |
| fn:fe:cause | /r/RelatedTo | fn:fe:deformer | "cause" | "deformer" | "/r/related to" |  | "FN" |  |
| fn:reshaping | /r/HasA | fn:fe:cause | "reshaping" | "cause" | "/r/has a" |  | "FN" |  |
| fn:reshaping | /r/HasA | fn:fe:iterations | "reshaping" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:reshaping | /r/HasA | fn:fe:explanation | "reshaping" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:reshaping | /r/HasA | fn:fe:degree | "reshaping" | "degree" | "/r/has a" |  | "FN" |  |
| fn:reshaping | /r/HasA | fn:fe:subregion | "reshaping" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:reshaping | /r/HasA | fn:fe:goal | "reshaping" | "goal" | "/r/has a" |  | "FN" |  |
| fn:reshaping | /r/HasA | fn:fe:containing_event | "reshaping" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:reshaping | /r/HasA | fn:fe:circumstances | "reshaping" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:reshaping | /r/HasA | fn:fe:imposed_purpose | "reshaping" | "imposed purpose" | "/r/has a" |  | "FN" |  |
| fn:reshaping | /r/HasA | fn:fe:configuration | "reshaping" | "configuration" | "/r/has a" |  | "FN" |  |
| fn:temporary_stay | /r/IsA | fn:residence | "temporary stay" | "residence" | "/r/is a" |  | "FN" |  |
| fn:residence | /r/UsedFor | fn:colonization | "residence" | "colonization" | "/r/used for" |  | "FN" |  |
| fn:residence | /r/UsedFor | fn:people_by_residence | "residence" | "people by residence" | "/r/used for" |  | "FN" |  |
| fn:residence | fn:HasLexicalUnit | fn:lu:residence:reside | "residence" | "reside" | "has lexical unit" |  | "FN" |  |
| fn:residence | fn:HasLexicalUnit | fn:lu:residence:resident | "residence" | "resident" | "has lexical unit" |  | "FN" |  |
| fn:residence | fn:HasLexicalUnit | fn:lu:residence:dwell | "residence" | "dwell" | "has lexical unit" |  | "FN" |  |
| fn:residence | fn:HasLexicalUnit | fn:lu:residence:stay | "residence" | "stay" | "has lexical unit" |  | "FN" |  |
| fn:residence | fn:HasLexicalUnit | fn:lu:residence:lodge | "residence" | "lodge" | "has lexical unit" |  | "FN" |  |
| fn:residence | fn:HasLexicalUnit | fn:lu:residence:inhabit | "residence" | "inhabit" | "has lexical unit" |  | "FN" |  |
| fn:residence | fn:HasLexicalUnit | fn:lu:residence:inhabitant | "residence" | "inhabitant" | "has lexical unit" |  | "FN" |  |
| fn:residence | fn:HasLexicalUnit | fn:lu:residence:live | "residence" | "live" | "has lexical unit" |  | "FN" |  |
| fn:residence | fn:HasLexicalUnit | fn:lu:residence:camp | "residence" | "camp" | "has lexical unit" |  | "FN" |  |
| fn:residence | fn:HasLexicalUnit | fn:lu:residence:squat | "residence" | "squat" | "has lexical unit" |  | "FN" |  |
| fn:residence | fn:HasLexicalUnit | fn:lu:residence:camp | "residence" | "camp" | "has lexical unit" |  | "FN" |  |
| fn:residence | fn:HasLexicalUnit | fn:lu:residence:camped | "residence" | "camped" | "has lexical unit" |  | "FN" |  |
| fn:residence | fn:HasLexicalUnit | fn:lu:residence:room-mate | "residence" | "room-mate" | "has lexical unit" |  | "FN" |  |
| fn:residence | fn:HasLexicalUnit | fn:lu:residence:squatter | "residence" | "squatter" | "has lexical unit" |  | "FN" |  |
| fn:residence | fn:HasLexicalUnit | fn:lu:residence:occupy | "residence" | "occupy" | "has lexical unit" |  | "FN" |  |
| fn:residence | fn:HasLexicalUnit | fn:lu:residence:dweller | "residence" | "dweller" | "has lexical unit" |  | "FN" |  |
| fn:residence | fn:HasLexicalUnit | fn:lu:residence:camper | "residence" | "camper" | "has lexical unit" |  | "FN" |  |
| fn:residence | fn:HasLexicalUnit | fn:lu:residence:occupant | "residence" | "occupant" | "has lexical unit" |  | "FN" |  |
| fn:residence | fn:HasLexicalUnit | fn:lu:residence:room | "residence" | "room" | "has lexical unit" |  | "FN" |  |
| fn:residence | fn:HasLexicalUnit | fn:lu:residence:shack_up | "residence" | "shack up" | "has lexical unit" |  | "FN" |  |
| fn:residence | fn:HasLexicalUnit | fn:lu:residence:bivouac | "residence" | "bivouac" | "has lexical unit" |  | "FN" |  |
| fn:residence | fn:HasLexicalUnit | fn:lu:residence:bivouac | "residence" | "bivouac" | "has lexical unit" |  | "FN" |  |
| fn:residence | fn:HasLexicalUnit | fn:lu:residence:tenant | "residence" | "tenant" | "has lexical unit" |  | "FN" |  |
| fn:residence | /r/HasA | fn:fe:resident | "residence" | "resident" | "/r/has a" |  | "FN" |  |
| fn:residence | /r/HasA | fn:fe:location | "residence" | "location" | "/r/has a" |  | "FN" |  |
| fn:residence | /r/HasA | fn:fe:co_resident | "residence" | "co resident" | "/r/has a" |  | "FN" |  |
| fn:fe:frequency | /r/IsA | fn:st:degree | "frequency" | "degree" | "/r/is a" |  | "FN" |  |
| fn:residence | /r/HasA | fn:fe:frequency | "residence" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:residence | /r/HasA | fn:fe:depictive | "residence" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:residence | /r/HasA | fn:fe:manner | "residence" | "manner" | "/r/has a" |  | "FN" |  |
| fn:residence | /r/HasA | fn:fe:means | "residence" | "means" | "/r/has a" |  | "FN" |  |
| fn:residence | /r/HasA | fn:fe:time | "residence" | "time" | "/r/has a" |  | "FN" |  |
| fn:residence | /r/HasA | fn:fe:circumstances | "residence" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:resolve_problem | /r/IsA | fn:intentionally_act | "resolve problem" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:resolve_problem | /r/SimilarTo | fn:speak_on_topic | "resolve problem" | "speak on topic" | "/r/similar to" |  | "FN" |  |
| fn:resolve_problem | /r/HasPrerequisite | fn:confronting_problem | "resolve problem" | "confronting problem" | "/r/has prerequisite" |  | "FN" |  |
| fn:resolve_problem | fn:HasLexicalUnit | fn:lu:resolve_problem:resolve | "resolve problem" | "resolve" | "has lexical unit" |  | "FN" |  |
| fn:resolve_problem | fn:HasLexicalUnit | fn:lu:resolve_problem:solve | "resolve problem" | "solve" | "has lexical unit" |  | "FN" |  |
| fn:resolve_problem | fn:HasLexicalUnit | fn:lu:resolve_problem:work_through | "resolve problem" | "work through" | "has lexical unit" |  | "FN" |  |
| fn:resolve_problem | fn:HasLexicalUnit | fn:lu:resolve_problem:deal | "resolve problem" | "deal" | "has lexical unit" |  | "FN" |  |
| fn:resolve_problem | fn:HasLexicalUnit | fn:lu:resolve_problem:fix | "resolve problem" | "fix" | "has lexical unit" |  | "FN" |  |
| fn:resolve_problem | fn:HasLexicalUnit | fn:lu:resolve_problem:clear_up | "resolve problem" | "clear up" | "has lexical unit" |  | "FN" |  |
| fn:resolve_problem | fn:HasLexicalUnit | fn:lu:resolve_problem:do_something_about | "resolve problem" | "do something about" | "has lexical unit" |  | "FN" |  |
| fn:resolve_problem | fn:HasLexicalUnit | fn:lu:resolve_problem:address | "resolve problem" | "address" | "has lexical unit" |  | "FN" |  |
| fn:resolve_problem | fn:HasLexicalUnit | fn:lu:resolve_problem:handle | "resolve problem" | "handle" | "has lexical unit" |  | "FN" |  |
| fn:resolve_problem | fn:HasLexicalUnit | fn:lu:resolve_problem:correct | "resolve problem" | "correct" | "has lexical unit" |  | "FN" |  |
| fn:resolve_problem | fn:HasLexicalUnit | fn:lu:resolve_problem:result | "resolve problem" | "result" | "has lexical unit" |  | "FN" |  |
| fn:resolve_problem | fn:HasLexicalUnit | fn:lu:resolve_problem:answer | "resolve problem" | "answer" | "has lexical unit" |  | "FN" |  |
| fn:resolve_problem | fn:HasLexicalUnit | fn:lu:resolve_problem:get_a_handle | "resolve problem" | "get a handle" | "has lexical unit" |  | "FN" |  |
| fn:resolve_problem | /r/HasA | fn:fe:agent | "resolve problem" | "agent" | "/r/has a" |  | "FN" |  |
| fn:resolve_problem | /r/HasA | fn:fe:problem | "resolve problem" | "problem" | "/r/has a" |  | "FN" |  |
| fn:resolve_problem | /r/HasA | fn:fe:cause | "resolve problem" | "cause" | "/r/has a" |  | "FN" |  |
| fn:resolve_problem | /r/HasA | fn:fe:means | "resolve problem" | "means" | "/r/has a" |  | "FN" |  |
| fn:resolve_problem | /r/HasA | fn:fe:time | "resolve problem" | "time" | "/r/has a" |  | "FN" |  |
| fn:resolve_problem | /r/HasA | fn:fe:place | "resolve problem" | "place" | "/r/has a" |  | "FN" |  |
| fn:resolve_problem | /r/HasA | fn:fe:degree | "resolve problem" | "degree" | "/r/has a" |  | "FN" |  |
| fn:resolve_problem | /r/HasA | fn:fe:manner | "resolve problem" | "manner" | "/r/has a" |  | "FN" |  |
| fn:resolve_problem | /r/HasA | fn:fe:resultant_situation | "resolve problem" | "resultant situation" | "/r/has a" |  | "FN" |  |
| fn:resolve_problem | /r/HasA | fn:fe:outcome | "resolve problem" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:resolve_problem | /r/HasA | fn:fe:containing_event | "resolve problem" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:resolve_problem | /r/HasA | fn:fe:circumstances | "resolve problem" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:resolve_problem | /r/HasA | fn:fe:instrument | "resolve problem" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:resolve_problem | /r/HasA | fn:fe:beneficiary | "resolve problem" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:resolve_problem | /r/HasA | fn:fe:duration | "resolve problem" | "duration" | "/r/has a" |  | "FN" |  |
| fn:resolve_problem | /r/HasA | fn:fe:role | "resolve problem" | "role" | "/r/has a" |  | "FN" |  |
| fn:resolve_problem | /r/HasA | fn:fe:frequency | "resolve problem" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:resolve_problem | /r/HasA | fn:fe:medium | "resolve problem" | "medium" | "/r/has a" |  | "FN" |  |
| fn:resolve_problem | /r/HasA | fn:fe:co-participant | "resolve problem" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:resolve_problem | /r/HasA | fn:fe:purpose | "resolve problem" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:agree_or_refuse_to_act | /r/IsA | fn:respond_to_proposal | "agree or refuse to act" | "respond to proposal" | "/r/is a" |  | "FN" |  |
| fn:communication_response | /r/UsedFor | fn:respond_to_proposal | "communication response" | "respond to proposal" | "/r/used for" |  | "FN" |  |
| fn:respond_to_proposal | fn:HasLexicalUnit | fn:lu:respond_to_proposal:turn_down | "respond to proposal" | "turn down" | "has lexical unit" |  | "FN" |  |
| fn:respond_to_proposal | fn:HasLexicalUnit | fn:lu:respond_to_proposal:rebuff | "respond to proposal" | "rebuff" | "has lexical unit" |  | "FN" |  |
| fn:respond_to_proposal | fn:HasLexicalUnit | fn:lu:respond_to_proposal:rebuff | "respond to proposal" | "rebuff" | "has lexical unit" |  | "FN" |  |
| fn:respond_to_proposal | fn:HasLexicalUnit | fn:lu:respond_to_proposal:reject | "respond to proposal" | "reject" | "has lexical unit" |  | "FN" |  |
| fn:respond_to_proposal | fn:HasLexicalUnit | fn:lu:respond_to_proposal:accept | "respond to proposal" | "accept" | "has lexical unit" |  | "FN" |  |
| fn:respond_to_proposal | fn:HasLexicalUnit | fn:lu:respond_to_proposal:acceptance | "respond to proposal" | "acceptance" | "has lexical unit" |  | "FN" |  |
| fn:respond_to_proposal | fn:HasLexicalUnit | fn:lu:respond_to_proposal:rejection | "respond to proposal" | "rejection" | "has lexical unit" |  | "FN" |  |
| fn:respond_to_proposal | fn:HasLexicalUnit | fn:lu:respond_to_proposal:refuse | "respond to proposal" | "refuse" | "has lexical unit" |  | "FN" |  |
| fn:respond_to_proposal | /r/HasA | fn:fe:speaker | "respond to proposal" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:respond_to_proposal | /r/HasA | fn:fe:interlocutor | "respond to proposal" | "interlocutor" | "/r/has a" |  | "FN" |  |
| fn:respond_to_proposal | /r/HasA | fn:fe:medium | "respond to proposal" | "medium" | "/r/has a" |  | "FN" |  |
| fn:respond_to_proposal | /r/HasA | fn:fe:proposal | "respond to proposal" | "proposal" | "/r/has a" |  | "FN" |  |
| fn:respond_to_proposal | /r/HasA | fn:fe:manner | "respond to proposal" | "manner" | "/r/has a" |  | "FN" |  |
| fn:respond_to_proposal | /r/HasA | fn:fe:depictive | "respond to proposal" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:respond_to_proposal | /r/HasA | fn:fe:means | "respond to proposal" | "means" | "/r/has a" |  | "FN" |  |
| fn:respond_to_proposal | /r/HasA | fn:fe:internal_cause | "respond to proposal" | "internal cause" | "/r/has a" |  | "FN" |  |
| fn:respond_to_proposal | /r/HasA | fn:fe:place | "respond to proposal" | "place" | "/r/has a" |  | "FN" |  |
| fn:respond_to_proposal | /r/HasA | fn:fe:time | "respond to proposal" | "time" | "/r/has a" |  | "FN" |  |
| fn:respond_to_proposal | /r/HasA | fn:fe:purpose | "respond to proposal" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:respond_to_proposal | /r/HasA | fn:fe:particular_iteration | "respond to proposal" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:respond_to_proposal | /r/HasA | fn:fe:role | "respond to proposal" | "role" | "/r/has a" |  | "FN" |  |
| fn:respond_to_proposal | /r/HasA | fn:fe:group | "respond to proposal" | "group" | "/r/has a" |  | "FN" |  |
| fn:respond_to_proposal | /r/HasA | fn:fe:iterations | "respond to proposal" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:respond_to_proposal | /r/HasA | fn:fe:explanation | "respond to proposal" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:response | /r/IsA | fn:eventive_affecting | "response" | "eventive affecting" | "/r/is a" |  | "FN" |  |
| fn:communication_response | /r/IsA | fn:response | "communication response" | "response" | "/r/is a" |  | "FN" |  |
| fn:rewards_and_punishments | /r/IsA | fn:response | "rewards and punishments" | "response" | "/r/is a" |  | "FN" |  |
| fn:response | /r/UsedFor | fn:counterattack | "response" | "counterattack" | "/r/used for" |  | "FN" |  |
| fn:response | /r/UsedFor | fn:deserving | "response" | "deserving" | "/r/used for" |  | "FN" |  |
| fn:response | /r/UsedFor | fn:health_response | "response" | "health response" | "/r/used for" |  | "FN" |  |
| fn:response | /r/IsA | fn:response_scenario | "response" | "response scenario" | "/r/is a" |  | "FN" |  |
| fn:response | fn:HasLexicalUnit | fn:lu:response:respond | "response" | "respond" | "has lexical unit" |  | "FN" |  |
| fn:response | fn:HasLexicalUnit | fn:lu:response:response | "response" | "response" | "has lexical unit" |  | "FN" |  |
| fn:response | fn:HasLexicalUnit | fn:lu:response:react | "response" | "react" | "has lexical unit" |  | "FN" |  |
| fn:response | fn:HasLexicalUnit | fn:lu:response:reaction | "response" | "reaction" | "has lexical unit" |  | "FN" |  |
| fn:response | fn:HasLexicalUnit | fn:lu:response:meet | "response" | "meet" | "has lexical unit" |  | "FN" |  |
| fn:response | fn:HasLexicalUnit | fn:lu:response:act_(on) | "response" | "act (on)" | "has lexical unit" |  | "FN" |  |
| fn:response | /r/HasA | fn:fe:response | "response" | "response" | "/r/has a" |  | "FN" |  |
| fn:fe:responding_entity | /r/RelatedTo | fn:fe:agent | "responding entity" | "agent" | "/r/related to" |  | "FN" |  |
| fn:response | /r/HasA | fn:fe:responding_entity | "response" | "responding entity" | "/r/has a" |  | "FN" |  |
| fn:response | /r/HasA | fn:fe:trigger | "response" | "trigger" | "/r/has a" |  | "FN" |  |
| fn:response | /r/HasA | fn:fe:time | "response" | "time" | "/r/has a" |  | "FN" |  |
| fn:response | /r/HasA | fn:fe:manner | "response" | "manner" | "/r/has a" |  | "FN" |  |
| fn:response | /r/HasA | fn:fe:place | "response" | "place" | "/r/has a" |  | "FN" |  |
| fn:response | /r/HasA | fn:fe:purpose | "response" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:response | /r/HasA | fn:fe:agent | "response" | "agent" | "/r/has a" |  | "FN" |  |
| fn:response | /r/HasA | fn:fe:dimension | "response" | "dimension" | "/r/has a" |  | "FN" |  |
| fn:response | /r/HasA | fn:fe:role | "response" | "role" | "/r/has a" |  | "FN" |  |
| fn:meet_with_response | /r/IsA | fn:response_scenario | "meet with response" | "response scenario" | "/r/is a" |  | "FN" |  |
| fn:response | /r/IsA | fn:response_scenario | "response" | "response scenario" | "/r/is a" |  | "FN" |  |
| fn:response_scenario | /r/HasA | fn:fe:responding_entity | "response scenario" | "responding entity" | "/r/has a" |  | "FN" |  |
| fn:response_scenario | /r/HasA | fn:fe:trigger | "response scenario" | "trigger" | "/r/has a" |  | "FN" |  |
| fn:response_scenario | /r/HasA | fn:fe:response | "response scenario" | "response" | "/r/has a" |  | "FN" |  |
| fn:response_scenario | /r/HasA | fn:fe:agent | "response scenario" | "agent" | "/r/has a" |  | "FN" |  |
| fn:response_scenario | /r/HasA | fn:fe:manner | "response scenario" | "manner" | "/r/has a" |  | "FN" |  |
| fn:response_scenario | /r/HasA | fn:fe:place | "response scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:response_scenario | /r/HasA | fn:fe:purpose | "response scenario" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:response_scenario | /r/HasA | fn:fe:time | "response scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:intentionally_act | /r/UsedFor | fn:responsibility | "intentionally act" | "responsibility" | "/r/used for" |  | "FN" |  |
| fn:responsibility | fn:HasLexicalUnit | fn:lu:responsibility:responsibility | "responsibility" | "responsibility" | "has lexical unit" |  | "FN" |  |
| fn:responsibility | fn:HasLexicalUnit | fn:lu:responsibility:responsible | "responsibility" | "responsible" | "has lexical unit" |  | "FN" |  |
| fn:responsibility | fn:HasLexicalUnit | fn:lu:responsibility:behind | "responsibility" | "behind" | "has lexical unit" |  | "FN" |  |
| fn:responsibility | /r/HasA | fn:fe:act | "responsibility" | "act" | "/r/has a" |  | "FN" |  |
| fn:responsibility | /r/HasA | fn:fe:agent | "responsibility" | "agent" | "/r/has a" |  | "FN" |  |
| fn:responsibility | /r/HasA | fn:fe:place | "responsibility" | "place" | "/r/has a" |  | "FN" |  |
| fn:responsibility | /r/HasA | fn:fe:time | "responsibility" | "time" | "/r/has a" |  | "FN" |  |
| fn:responsibility | /r/HasA | fn:fe:domain | "responsibility" | "domain" | "/r/has a" |  | "FN" |  |
| fn:responsibility | /r/HasA | fn:fe:frequency | "responsibility" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:responsibility | /r/HasA | fn:fe:period_of_iterations | "responsibility" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:responsibility | /r/HasA | fn:fe:result | "responsibility" | "result" | "/r/has a" |  | "FN" |  |
| fn:responsibility | /r/HasA | fn:fe:particular_iteration | "responsibility" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:responsibility | /r/HasA | fn:fe:explanation | "responsibility" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:responsibility | /r/HasA | fn:fe:event_description | "responsibility" | "event description" | "/r/has a" |  | "FN" |  |
| fn:responsibility | /r/HasA | fn:fe:degree | "responsibility" | "degree" | "/r/has a" |  | "FN" |  |
| fn:rest | /r/IsA | fn:part_whole | "rest" | "part whole" | "/r/is a" |  | "FN" |  |
| fn:rest | fn:HasLexicalUnit | fn:lu:rest:rest | "rest" | "rest" | "has lexical unit" |  | "FN" |  |
| fn:rest | fn:HasLexicalUnit | fn:lu:rest:complement | "rest" | "complement" | "has lexical unit" |  | "FN" |  |
| fn:rest | fn:HasLexicalUnit | fn:lu:rest:complement | "rest" | "complement" | "has lexical unit" |  | "FN" |  |
| fn:rest | /r/HasA | fn:fe:part | "rest" | "part" | "/r/has a" |  | "FN" |  |
| fn:rest | /r/HasA | fn:fe:rest | "rest" | "rest" | "/r/has a" |  | "FN" |  |
| fn:rest | /r/HasA | fn:fe:whole | "rest" | "whole" | "/r/has a" |  | "FN" |  |
| fn:attempting_and_resolving_scenario | /r/HasSubevent | fn:result_of_attempt_scenario | "attempting and resolving scenario" | "result of attempt scenario" | "/r/has subevent" |  | "FN" |  |
| fn:result_of_attempt_scenario | /r/UsedFor | fn:expertise | "result of attempt scenario" | "expertise" | "/r/used for" |  | "FN" |  |
| fn:result_of_attempt_scenario | /r/HasPrerequisite | fn:attempt_action_scenario | "result of attempt scenario" | "attempt action scenario" | "/r/has prerequisite" |  | "FN" |  |
| fn:elusive_goal | /r/IsA | fn:result_of_attempt_scenario | "elusive goal" | "result of attempt scenario" | "/r/is a" |  | "FN" |  |
| fn:success_or_failure | /r/IsA | fn:result_of_attempt_scenario | "success or failure" | "result of attempt scenario" | "/r/is a" |  | "FN" |  |
| fn:successful_action | /r/IsA | fn:result_of_attempt_scenario | "successful action" | "result of attempt scenario" | "/r/is a" |  | "FN" |  |
| fn:thwarting | /r/IsA | fn:result_of_attempt_scenario | "thwarting" | "result of attempt scenario" | "/r/is a" |  | "FN" |  |
| fn:result_of_attempt_scenario | /r/HasA | fn:fe:agent | "result of attempt scenario" | "agent" | "/r/has a" |  | "FN" |  |
| fn:result_of_attempt_scenario | /r/HasA | fn:fe:goal | "result of attempt scenario" | "goal" | "/r/has a" |  | "FN" |  |
| fn:result_of_attempt_scenario | /r/HasA | fn:fe:action | "result of attempt scenario" | "action" | "/r/has a" |  | "FN" |  |
| fn:result_of_attempt_scenario | /r/HasA | fn:fe:time | "result of attempt scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:result_of_attempt_scenario | /r/HasA | fn:fe:depictive | "result of attempt scenario" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:result_of_attempt_scenario | /r/HasA | fn:fe:place | "result of attempt scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:result_of_attempt_scenario | /r/HasA | fn:fe:role | "result of attempt scenario" | "role" | "/r/has a" |  | "FN" |  |
| fn:result_of_attempt_scenario | /r/HasA | fn:fe:circumstances | "result of attempt scenario" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:result_of_attempt_scenario | /r/HasA | fn:fe:explanation | "result of attempt scenario" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:result_of_attempt_scenario | /r/HasA | fn:fe:containing_event | "result of attempt scenario" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:result_of_attempt_scenario | /r/HasA | fn:fe:degree | "result of attempt scenario" | "degree" | "/r/has a" |  | "FN" |  |
| fn:dead_or_alive | /r/UsedFor | fn:resurrection | "dead or alive" | "resurrection" | "/r/used for" |  | "FN" |  |
| fn:resurrection | fn:HasLexicalUnit | fn:lu:resurrection:resurrect | "resurrection" | "resurrect" | "has lexical unit" |  | "FN" |  |
| fn:resurrection | fn:HasLexicalUnit | fn:lu:resurrection:come_back | "resurrection" | "come back" | "has lexical unit" |  | "FN" |  |
| fn:resurrection | fn:HasLexicalUnit | fn:lu:resurrection:rise | "resurrection" | "rise" | "has lexical unit" |  | "FN" |  |
| fn:resurrection | fn:HasLexicalUnit | fn:lu:resurrection:resurrection | "resurrection" | "resurrection" | "has lexical unit" |  | "FN" |  |
| fn:resurrection | fn:HasLexicalUnit | fn:lu:resurrection:return | "resurrection" | "return" | "has lexical unit" |  | "FN" |  |
| fn:resurrection | /r/HasA | fn:fe:protagonist | "resurrection" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:resurrection | /r/HasA | fn:fe:time | "resurrection" | "time" | "/r/has a" |  | "FN" |  |
| fn:resurrection | /r/HasA | fn:fe:explanation | "resurrection" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:resurrection | /r/HasA | fn:fe:prior_state | "resurrection" | "prior state" | "/r/has a" |  | "FN" |  |
| fn:resurrection | /r/HasA | fn:fe:result | "resurrection" | "result" | "/r/has a" |  | "FN" |  |
| fn:resurrection | /r/HasA | fn:fe:depictive | "resurrection" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:resurrection | /r/HasA | fn:fe:place | "resurrection" | "place" | "/r/has a" |  | "FN" |  |
| fn:retaining | /r/IsA | fn:activity_ongoing | "retaining" | "activity ongoing" | "/r/is a" |  | "FN" |  |
| fn:retaining | /r/IsA | fn:possession | "retaining" | "possession" | "/r/is a" |  | "FN" |  |
| fn:retaining | fn:HasLexicalUnit | fn:lu:retaining:retain | "retaining" | "retain" | "has lexical unit" |  | "FN" |  |
| fn:retaining | fn:HasLexicalUnit | fn:lu:retaining:keep | "retaining" | "keep" | "has lexical unit" |  | "FN" |  |
| fn:retaining | fn:HasLexicalUnit | fn:lu:retaining:hold_on_to | "retaining" | "hold on to" | "has lexical unit" |  | "FN" |  |
| fn:retaining | fn:HasLexicalUnit | fn:lu:retaining:hang_on_to | "retaining" | "hang on to" | "has lexical unit" |  | "FN" |  |
| fn:retaining | /r/HasA | fn:fe:agent | "retaining" | "agent" | "/r/has a" |  | "FN" |  |
| fn:retaining | /r/HasA | fn:fe:theme | "retaining" | "theme" | "/r/has a" |  | "FN" |  |
| fn:retaining | /r/HasA | fn:fe:duration | "retaining" | "duration" | "/r/has a" |  | "FN" |  |
| fn:retaining | /r/HasA | fn:fe:place | "retaining" | "place" | "/r/has a" |  | "FN" |  |
| fn:retaining | /r/HasA | fn:fe:manner | "retaining" | "manner" | "/r/has a" |  | "FN" |  |
| fn:retaining | /r/HasA | fn:fe:time | "retaining" | "time" | "/r/has a" |  | "FN" |  |
| fn:retaining | /r/HasA | fn:fe:means | "retaining" | "means" | "/r/has a" |  | "FN" |  |
| fn:reveal_secret | /r/IsA | fn:statement | "reveal secret" | "statement" | "/r/is a" |  | "FN" |  |
| fn:statement | /r/SimilarTo | fn:reveal_secret | "statement" | "reveal secret" | "/r/similar to" |  | "FN" |  |
| fn:reveal_secret | fn:HasLexicalUnit | fn:lu:reveal_secret:reveal | "reveal secret" | "reveal" | "has lexical unit" |  | "FN" |  |
| fn:reveal_secret | fn:HasLexicalUnit | fn:lu:reveal_secret:disclose | "reveal secret" | "disclose" | "has lexical unit" |  | "FN" |  |
| fn:reveal_secret | fn:HasLexicalUnit | fn:lu:reveal_secret:revelation | "reveal secret" | "revelation" | "has lexical unit" |  | "FN" |  |
| fn:reveal_secret | fn:HasLexicalUnit | fn:lu:reveal_secret:expose | "reveal secret" | "expose" | "has lexical unit" |  | "FN" |  |
| fn:reveal_secret | fn:HasLexicalUnit | fn:lu:reveal_secret:disclosure | "reveal secret" | "disclosure" | "has lexical unit" |  | "FN" |  |
| fn:reveal_secret | fn:HasLexicalUnit | fn:lu:reveal_secret:divulge | "reveal secret" | "divulge" | "has lexical unit" |  | "FN" |  |
| fn:reveal_secret | fn:HasLexicalUnit | fn:lu:reveal_secret:divulgence | "reveal secret" | "divulgence" | "has lexical unit" |  | "FN" |  |
| fn:reveal_secret | fn:HasLexicalUnit | fn:lu:reveal_secret:confess | "reveal secret" | "confess" | "has lexical unit" |  | "FN" |  |
| fn:reveal_secret | fn:HasLexicalUnit | fn:lu:reveal_secret:confession | "reveal secret" | "confession" | "has lexical unit" |  | "FN" |  |
| fn:reveal_secret | fn:HasLexicalUnit | fn:lu:reveal_secret:confide | "reveal secret" | "confide" | "has lexical unit" |  | "FN" |  |
| fn:reveal_secret | fn:HasLexicalUnit | fn:lu:reveal_secret:spill_beans | "reveal secret" | "spill beans" | "has lexical unit" |  | "FN" |  |
| fn:reveal_secret | fn:HasLexicalUnit | fn:lu:reveal_secret:come_clean | "reveal secret" | "come clean" | "has lexical unit" |  | "FN" |  |
| fn:reveal_secret | fn:HasLexicalUnit | fn:lu:reveal_secret:let_slip | "reveal secret" | "let slip" | "has lexical unit" |  | "FN" |  |
| fn:reveal_secret | fn:HasLexicalUnit | fn:lu:reveal_secret:leak | "reveal secret" | "leak" | "has lexical unit" |  | "FN" |  |
| fn:reveal_secret | fn:HasLexicalUnit | fn:lu:reveal_secret:tip_(someone's)_hand | "reveal secret" | "tip (someone\\'s) hand" | "has lexical unit" |  | "FN" |  |
| fn:reveal_secret | fn:HasLexicalUnit | fn:lu:reveal_secret:admit | "reveal secret" | "admit" | "has lexical unit" |  | "FN" |  |
| fn:reveal_secret | fn:HasLexicalUnit | fn:lu:reveal_secret:come_forward | "reveal secret" | "come forward" | "has lexical unit" |  | "FN" |  |
| fn:reveal_secret | fn:HasLexicalUnit | fn:lu:reveal_secret:fess_up | "reveal secret" | "fess up" | "has lexical unit" |  | "FN" |  |
| fn:reveal_secret | fn:HasLexicalUnit | fn:lu:reveal_secret:let_on | "reveal secret" | "let on" | "has lexical unit" |  | "FN" |  |
| fn:reveal_secret | /r/HasA | fn:fe:speaker | "reveal secret" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:reveal_secret | /r/HasA | fn:fe:addressee | "reveal secret" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:reveal_secret | /r/HasA | fn:fe:information | "reveal secret" | "information" | "/r/has a" |  | "FN" |  |
| fn:reveal_secret | /r/HasA | fn:fe:topic | "reveal secret" | "topic" | "/r/has a" |  | "FN" |  |
| fn:reveal_secret | /r/HasA | fn:fe:manner | "reveal secret" | "manner" | "/r/has a" |  | "FN" |  |
| fn:reveal_secret | /r/HasA | fn:fe:completeness | "reveal secret" | "completeness" | "/r/has a" |  | "FN" |  |
| fn:reveal_secret | /r/HasA | fn:fe:means | "reveal secret" | "means" | "/r/has a" |  | "FN" |  |
| fn:reveal_secret | /r/HasA | fn:fe:internal_cause | "reveal secret" | "internal cause" | "/r/has a" |  | "FN" |  |
| fn:reveal_secret | /r/HasA | fn:fe:medium | "reveal secret" | "medium" | "/r/has a" |  | "FN" |  |
| fn:reveal_secret | /r/HasA | fn:fe:depictive | "reveal secret" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:reveal_secret | /r/HasA | fn:fe:time | "reveal secret" | "time" | "/r/has a" |  | "FN" |  |
| fn:reveal_secret | /r/HasA | fn:fe:place | "reveal secret" | "place" | "/r/has a" |  | "FN" |  |
| fn:reveal_secret | /r/HasA | fn:fe:re-encoding | "reveal secret" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:reveal_secret | /r/HasA | fn:fe:location_of_protagonist | "reveal secret" | "location of protagonist" | "/r/has a" |  | "FN" |  |
| fn:reveal_secret | /r/HasA | fn:fe:containing_event | "reveal secret" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:reveal_secret | /r/HasA | fn:fe:source_material | "reveal secret" | "source material" | "/r/has a" |  | "FN" |  |
| fn:reveal_secret | /r/HasA | fn:fe:event_description | "reveal secret" | "event description" | "/r/has a" |  | "FN" |  |
| fn:reveal_secret | /r/HasA | fn:fe:period_of_iterations | "reveal secret" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:reveal_secret | /r/HasA | fn:fe:frequency | "reveal secret" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:reveal_secret | /r/HasA | fn:fe:descriptor | "reveal secret" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:revenge | /r/IsA | fn:rewards_and_punishments | "revenge" | "rewards and punishments" | "/r/is a" |  | "FN" |  |
| fn:revenge | fn:HasLexicalUnit | fn:lu:revenge:avenge | "revenge" | "avenge" | "has lexical unit" |  | "FN" |  |
| fn:revenge | fn:HasLexicalUnit | fn:lu:revenge:avenger | "revenge" | "avenger" | "has lexical unit" |  | "FN" |  |
| fn:revenge | fn:HasLexicalUnit | fn:lu:revenge:vengeance | "revenge" | "vengeance" | "has lexical unit" |  | "FN" |  |
| fn:revenge | fn:HasLexicalUnit | fn:lu:revenge:retaliate | "revenge" | "retaliate" | "has lexical unit" |  | "FN" |  |
| fn:revenge | fn:HasLexicalUnit | fn:lu:revenge:revenge | "revenge" | "revenge" | "has lexical unit" |  | "FN" |  |
| fn:revenge | fn:HasLexicalUnit | fn:lu:revenge:revenge | "revenge" | "revenge" | "has lexical unit" |  | "FN" |  |
| fn:revenge | fn:HasLexicalUnit | fn:lu:revenge:vengeful | "revenge" | "vengeful" | "has lexical unit" |  | "FN" |  |
| fn:revenge | fn:HasLexicalUnit | fn:lu:revenge:vindictive | "revenge" | "vindictive" | "has lexical unit" |  | "FN" |  |
| fn:revenge | fn:HasLexicalUnit | fn:lu:revenge:retribution | "revenge" | "retribution" | "has lexical unit" |  | "FN" |  |
| fn:revenge | fn:HasLexicalUnit | fn:lu:revenge:retaliation | "revenge" | "retaliation" | "has lexical unit" |  | "FN" |  |
| fn:revenge | fn:HasLexicalUnit | fn:lu:revenge:revenger | "revenge" | "revenger" | "has lexical unit" |  | "FN" |  |
| fn:revenge | fn:HasLexicalUnit | fn:lu:revenge:revengeful | "revenge" | "revengeful" | "has lexical unit" |  | "FN" |  |
| fn:revenge | fn:HasLexicalUnit | fn:lu:revenge:retributive | "revenge" | "retributive" | "has lexical unit" |  | "FN" |  |
| fn:revenge | fn:HasLexicalUnit | fn:lu:revenge:get_even | "revenge" | "get even" | "has lexical unit" |  | "FN" |  |
| fn:revenge | fn:HasLexicalUnit | fn:lu:revenge:retributory | "revenge" | "retributory" | "has lexical unit" |  | "FN" |  |
| fn:revenge | fn:HasLexicalUnit | fn:lu:revenge:get_back_(at) | "revenge" | "get back (at)" | "has lexical unit" |  | "FN" |  |
| fn:revenge | fn:HasLexicalUnit | fn:lu:revenge:payback | "revenge" | "payback" | "has lexical unit" |  | "FN" |  |
| fn:revenge | fn:HasLexicalUnit | fn:lu:revenge:sanction | "revenge" | "sanction" | "has lexical unit" |  | "FN" |  |
| fn:fe:avenger | /r/IsA | fn:st:sentient | "avenger" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:revenge | /r/HasA | fn:fe:avenger | "revenge" | "avenger" | "/r/has a" |  | "FN" |  |
| fn:revenge | /r/HasA | fn:fe:degree | "revenge" | "degree" | "/r/has a" |  | "FN" |  |
| fn:revenge | /r/HasA | fn:fe:depictive | "revenge" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:revenge | /r/HasA | fn:fe:offender | "revenge" | "offender" | "/r/has a" |  | "FN" |  |
| fn:revenge | /r/HasA | fn:fe:instrument | "revenge" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:revenge | /r/HasA | fn:fe:manner | "revenge" | "manner" | "/r/has a" |  | "FN" |  |
| fn:revenge | /r/HasA | fn:fe:punishment | "revenge" | "punishment" | "/r/has a" |  | "FN" |  |
| fn:revenge | /r/HasA | fn:fe:place | "revenge" | "place" | "/r/has a" |  | "FN" |  |
| fn:revenge | /r/HasA | fn:fe:purpose | "revenge" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:revenge | /r/HasA | fn:fe:injury | "revenge" | "injury" | "/r/has a" |  | "FN" |  |
| fn:revenge | /r/HasA | fn:fe:result | "revenge" | "result" | "/r/has a" |  | "FN" |  |
| fn:revenge | /r/HasA | fn:fe:time | "revenge" | "time" | "/r/has a" |  | "FN" |  |
| fn:revenge | /r/HasA | fn:fe:injured_party | "revenge" | "injured party" | "/r/has a" |  | "FN" |  |
| fn:revenge | /r/HasA | fn:fe:duration | "revenge" | "duration" | "/r/has a" |  | "FN" |  |
| fn:rebellion | /r/UsedFor | fn:revolution | "rebellion" | "revolution" | "/r/used for" |  | "FN" |  |
| fn:revolution | fn:HasLexicalUnit | fn:lu:revolution:revolutionary | "revolution" | "revolutionary" | "has lexical unit" |  | "FN" |  |
| fn:revolution | /r/HasA | fn:fe:agent | "revolution" | "agent" | "/r/has a" |  | "FN" |  |
| fn:revolution | /r/HasA | fn:fe:current_leadership | "revolution" | "current leadership" | "/r/has a" |  | "FN" |  |
| fn:revolution | /r/HasA | fn:fe:current_order | "revolution" | "current order" | "/r/has a" |  | "FN" |  |
| fn:revolution | /r/HasA | fn:fe:place | "revolution" | "place" | "/r/has a" |  | "FN" |  |
| fn:revolution | /r/HasA | fn:fe:time | "revolution" | "time" | "/r/has a" |  | "FN" |  |
| fn:revolution | /r/HasA | fn:fe:means | "revolution" | "means" | "/r/has a" |  | "FN" |  |
| fn:revolution | /r/HasA | fn:fe:degree | "revolution" | "degree" | "/r/has a" |  | "FN" |  |
| fn:revolution | /r/HasA | fn:fe:manner | "revolution" | "manner" | "/r/has a" |  | "FN" |  |
| fn:rewards_and_punishments | /r/IsA | fn:intentionally_affect | "rewards and punishments" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:rewards_and_punishments | /r/IsA | fn:response | "rewards and punishments" | "response" | "/r/is a" |  | "FN" |  |
| fn:corporal_punishment | /r/IsA | fn:rewards_and_punishments | "corporal punishment" | "rewards and punishments" | "/r/is a" |  | "FN" |  |
| fn:execution | /r/IsA | fn:rewards_and_punishments | "execution" | "rewards and punishments" | "/r/is a" |  | "FN" |  |
| fn:fining | /r/IsA | fn:rewards_and_punishments | "fining" | "rewards and punishments" | "/r/is a" |  | "FN" |  |
| fn:revenge | /r/IsA | fn:rewards_and_punishments | "revenge" | "rewards and punishments" | "/r/is a" |  | "FN" |  |
| fn:rewards_and_punishments | fn:HasLexicalUnit | fn:lu:rewards_and_punishments:punish | "rewards and punishments" | "punish" | "has lexical unit" |  | "FN" |  |
| fn:rewards_and_punishments | fn:HasLexicalUnit | fn:lu:rewards_and_punishments:reward | "rewards and punishments" | "reward" | "has lexical unit" |  | "FN" |  |
| fn:rewards_and_punishments | fn:HasLexicalUnit | fn:lu:rewards_and_punishments:reward | "rewards and punishments" | "reward" | "has lexical unit" |  | "FN" |  |
| fn:rewards_and_punishments | fn:HasLexicalUnit | fn:lu:rewards_and_punishments:discipline | "rewards and punishments" | "discipline" | "has lexical unit" |  | "FN" |  |
| fn:rewards_and_punishments | fn:HasLexicalUnit | fn:lu:rewards_and_punishments:disciplinary | "rewards and punishments" | "disciplinary" | "has lexical unit" |  | "FN" |  |
| fn:rewards_and_punishments | fn:HasLexicalUnit | fn:lu:rewards_and_punishments:penalty | "rewards and punishments" | "penalty" | "has lexical unit" |  | "FN" |  |
| fn:rewards_and_punishments | fn:HasLexicalUnit | fn:lu:rewards_and_punishments:punitive | "rewards and punishments" | "punitive" | "has lexical unit" |  | "FN" |  |
| fn:rewards_and_punishments | fn:HasLexicalUnit | fn:lu:rewards_and_punishments:punishment_[penalty] | "rewards and punishments" | "punishment [penalty]" | "has lexical unit" |  | "FN" |  |
| fn:rewards_and_punishments | fn:HasLexicalUnit | fn:lu:rewards_and_punishments:punishment_[act] | "rewards and punishments" | "punishment [act]" | "has lexical unit" |  | "FN" |  |
| fn:rewards_and_punishments | fn:HasLexicalUnit | fn:lu:rewards_and_punishments:recompense | "rewards and punishments" | "recompense" | "has lexical unit" |  | "FN" |  |
| fn:rewards_and_punishments | /r/HasA | fn:fe:evaluee | "rewards and punishments" | "evaluee" | "/r/has a" |  | "FN" |  |
| fn:rewards_and_punishments | /r/HasA | fn:fe:manner | "rewards and punishments" | "manner" | "/r/has a" |  | "FN" |  |
| fn:rewards_and_punishments | /r/HasA | fn:fe:means | "rewards and punishments" | "means" | "/r/has a" |  | "FN" |  |
| fn:rewards_and_punishments | /r/HasA | fn:fe:reason | "rewards and punishments" | "reason" | "/r/has a" |  | "FN" |  |
| fn:rewards_and_punishments | /r/HasA | fn:fe:result | "rewards and punishments" | "result" | "/r/has a" |  | "FN" |  |
| fn:rewards_and_punishments | /r/HasA | fn:fe:place | "rewards and punishments" | "place" | "/r/has a" |  | "FN" |  |
| fn:rewards_and_punishments | /r/HasA | fn:fe:time | "rewards and punishments" | "time" | "/r/has a" |  | "FN" |  |
| fn:rewards_and_punishments | /r/HasA | fn:fe:agent | "rewards and punishments" | "agent" | "/r/has a" |  | "FN" |  |
| fn:rewards_and_punishments | /r/HasA | fn:fe:instrument | "rewards and punishments" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:rewards_and_punishments | /r/HasA | fn:fe:purpose | "rewards and punishments" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:rewards_and_punishments | /r/HasA | fn:fe:response_action | "rewards and punishments" | "response action" | "/r/has a" |  | "FN" |  |
| fn:rewards_and_punishments | /r/HasA | fn:fe:degree | "rewards and punishments" | "degree" | "/r/has a" |  | "FN" |  |
| fn:rewards_and_punishments | /r/HasA | fn:fe:depictive | "rewards and punishments" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:ride_vehicle | /r/UsedFor | fn:board_vehicle | "ride vehicle" | "board vehicle" | "/r/used for" |  | "FN" |  |
| fn:ride_vehicle | /r/UsedFor | fn:disembarking | "ride vehicle" | "disembarking" | "/r/used for" |  | "FN" |  |
| fn:motion | /r/RelatedTo | fn:ride_vehicle | "motion" | "ride vehicle" | "/r/related to" |  | "FN" |  |
| fn:spatial_contact | /r/RelatedTo | fn:ride_vehicle | "spatial contact" | "ride vehicle" | "/r/related to" |  | "FN" |  |
| fn:operate_vehicle | /r/SimilarTo | fn:ride_vehicle | "operate vehicle" | "ride vehicle" | "/r/similar to" |  | "FN" |  |
| fn:self_motion | /r/SimilarTo | fn:ride_vehicle | "self motion" | "ride vehicle" | "/r/similar to" |  | "FN" |  |
| fn:ride_vehicle | /r/IsA | fn:use_vehicle | "ride vehicle" | "use vehicle" | "/r/is a" |  | "FN" |  |
| fn:ride_vehicle | fn:HasLexicalUnit | fn:lu:ride_vehicle:ride | "ride vehicle" | "ride" | "has lexical unit" |  | "FN" |  |
| fn:ride_vehicle | fn:HasLexicalUnit | fn:lu:ride_vehicle:sail | "ride vehicle" | "sail" | "has lexical unit" |  | "FN" |  |
| fn:ride_vehicle | fn:HasLexicalUnit | fn:lu:ride_vehicle:fly | "ride vehicle" | "fly" | "has lexical unit" |  | "FN" |  |
| fn:ride_vehicle | fn:HasLexicalUnit | fn:lu:ride_vehicle:taxi | "ride vehicle" | "taxi" | "has lexical unit" |  | "FN" |  |
| fn:ride_vehicle | fn:HasLexicalUnit | fn:lu:ride_vehicle:take | "ride vehicle" | "take" | "has lexical unit" |  | "FN" |  |
| fn:ride_vehicle | fn:HasLexicalUnit | fn:lu:ride_vehicle:cruise | "ride vehicle" | "cruise" | "has lexical unit" |  | "FN" |  |
| fn:ride_vehicle | fn:HasLexicalUnit | fn:lu:ride_vehicle:coast | "ride vehicle" | "coast" | "has lexical unit" |  | "FN" |  |
| fn:ride_vehicle | fn:HasLexicalUnit | fn:lu:ride_vehicle:jet | "ride vehicle" | "jet" | "has lexical unit" |  | "FN" |  |
| fn:ride_vehicle | fn:HasLexicalUnit | fn:lu:ride_vehicle:hitchhike | "ride vehicle" | "hitchhike" | "has lexical unit" |  | "FN" |  |
| fn:ride_vehicle | fn:HasLexicalUnit | fn:lu:ride_vehicle:ride | "ride vehicle" | "ride" | "has lexical unit" |  | "FN" |  |
| fn:ride_vehicle | fn:HasLexicalUnit | fn:lu:ride_vehicle:cruise | "ride vehicle" | "cruise" | "has lexical unit" |  | "FN" |  |
| fn:ride_vehicle | fn:HasLexicalUnit | fn:lu:ride_vehicle:flight | "ride vehicle" | "flight" | "has lexical unit" |  | "FN" |  |
| fn:ride_vehicle | fn:HasLexicalUnit | fn:lu:ride_vehicle:bus | "ride vehicle" | "bus" | "has lexical unit" |  | "FN" |  |
| fn:ride_vehicle | /r/HasA | fn:fe:theme | "ride vehicle" | "theme" | "/r/has a" |  | "FN" |  |
| fn:ride_vehicle | /r/HasA | fn:fe:vehicle | "ride vehicle" | "vehicle" | "/r/has a" |  | "FN" |  |
| fn:ride_vehicle | /r/HasA | fn:fe:source | "ride vehicle" | "source" | "/r/has a" |  | "FN" |  |
| fn:ride_vehicle | /r/HasA | fn:fe:manner | "ride vehicle" | "manner" | "/r/has a" |  | "FN" |  |
| fn:ride_vehicle | /r/HasA | fn:fe:path | "ride vehicle" | "path" | "/r/has a" |  | "FN" |  |
| fn:ride_vehicle | /r/HasA | fn:fe:goal | "ride vehicle" | "goal" | "/r/has a" |  | "FN" |  |
| fn:ride_vehicle | /r/HasA | fn:fe:distance | "ride vehicle" | "distance" | "/r/has a" |  | "FN" |  |
| fn:ride_vehicle | /r/HasA | fn:fe:duration | "ride vehicle" | "duration" | "/r/has a" |  | "FN" |  |
| fn:ride_vehicle | /r/HasA | fn:fe:speed | "ride vehicle" | "speed" | "/r/has a" |  | "FN" |  |
| fn:ride_vehicle | /r/HasA | fn:fe:area | "ride vehicle" | "area" | "/r/has a" |  | "FN" |  |
| fn:ride_vehicle | /r/HasA | fn:fe:road | "ride vehicle" | "road" | "/r/has a" |  | "FN" |  |
| fn:ride_vehicle | /r/HasA | fn:fe:route | "ride vehicle" | "route" | "/r/has a" |  | "FN" |  |
| fn:ride_vehicle | /r/HasA | fn:fe:depictive | "ride vehicle" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:ride_vehicle | /r/HasA | fn:fe:time | "ride vehicle" | "time" | "/r/has a" |  | "FN" |  |
| fn:ride_vehicle | /r/HasA | fn:fe:cotheme | "ride vehicle" | "cotheme" | "/r/has a" |  | "FN" |  |
| fn:ride_vehicle | /r/HasA | fn:fe:purpose | "ride vehicle" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:rising_to_a_challenge | /r/IsA | fn:meet_specifications | "rising to a challenge" | "meet specifications" | "/r/is a" |  | "FN" |  |
| fn:rising_to_a_challenge | /r/Causes | fn:being_up_to_it | "rising to a challenge" | "being up to it" | "/r/causes" |  | "FN" |  |
| fn:rising_to_a_challenge | fn:HasLexicalUnit | fn:lu:rising_to_a_challenge:rise | "rising to a challenge" | "rise" | "has lexical unit" |  | "FN" |  |
| fn:rising_to_a_challenge | fn:HasLexicalUnit | fn:lu:rising_to_a_challenge:rise_to_the_occasion | "rising to a challenge" | "rise to the occasion" | "has lexical unit" |  | "FN" |  |
| fn:rising_to_a_challenge | /r/HasA | fn:fe:protagonist | "rising to a challenge" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:rising_to_a_challenge | /r/HasA | fn:fe:activity | "rising to a challenge" | "activity" | "/r/has a" |  | "FN" |  |
| fn:rising_to_a_challenge | /r/HasA | fn:fe:degree | "rising to a challenge" | "degree" | "/r/has a" |  | "FN" |  |
| fn:rising_to_a_challenge | /r/HasA | fn:fe:circumstances | "rising to a challenge" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:rising_to_a_challenge | /r/HasA | fn:fe:explanation | "rising to a challenge" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:rising_to_a_challenge | /r/HasA | fn:fe:relevant_feature | "rising to a challenge" | "relevant feature" | "/r/has a" |  | "FN" |  |
| fn:rising_to_a_challenge | /r/HasA | fn:fe:means | "rising to a challenge" | "means" | "/r/has a" |  | "FN" |  |
| fn:rising_to_a_challenge | /r/HasA | fn:fe:time | "rising to a challenge" | "time" | "/r/has a" |  | "FN" |  |
| fn:rising_to_a_challenge | /r/HasA | fn:fe:place | "rising to a challenge" | "place" | "/r/has a" |  | "FN" |  |
| fn:rising_to_a_challenge | /r/HasA | fn:fe:manner | "rising to a challenge" | "manner" | "/r/has a" |  | "FN" |  |
| fn:risk_scenario | /r/UsedFor | fn:rescuing | "risk scenario" | "rescuing" | "/r/used for" |  | "FN" |  |
| fn:being_at_risk | /r/IsA | fn:risk_scenario | "being at risk" | "risk scenario" | "/r/is a" |  | "FN" |  |
| fn:risky_situation | /r/IsA | fn:risk_scenario | "risky situation" | "risk scenario" | "/r/is a" |  | "FN" |  |
| fn:run_risk | /r/IsA | fn:risk_scenario | "run risk" | "risk scenario" | "/r/is a" |  | "FN" |  |
| fn:risk_scenario | /r/HasA | fn:fe:asset | "risk scenario" | "asset" | "/r/has a" |  | "FN" |  |
| fn:risk_scenario | /r/HasA | fn:fe:harmful_event | "risk scenario" | "harmful event" | "/r/has a" |  | "FN" |  |
| fn:risk_scenario | /r/HasA | fn:fe:situation | "risk scenario" | "situation" | "/r/has a" |  | "FN" |  |
| fn:risk_scenario | /r/HasA | fn:fe:degree | "risk scenario" | "degree" | "/r/has a" |  | "FN" |  |
| fn:risk_scenario | /r/HasA | fn:fe:time | "risk scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:risk_scenario | /r/HasA | fn:fe:place | "risk scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:risky_situation | /r/IsA | fn:gradable_attributes | "risky situation" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:run_risk | /r/RelatedTo | fn:risky_situation | "run risk" | "risky situation" | "/r/related to" |  | "FN" |  |
| fn:run_risk | /r/SimilarTo | fn:risky_situation | "run risk" | "risky situation" | "/r/similar to" |  | "FN" |  |
| fn:risky_situation | /r/IsA | fn:risk_scenario | "risky situation" | "risk scenario" | "/r/is a" |  | "FN" |  |
| fn:risky_situation | fn:HasLexicalUnit | fn:lu:risky_situation:safe | "risky situation" | "safe" | "has lexical unit" |  | "FN" |  |
| fn:risky_situation | fn:HasLexicalUnit | fn:lu:risky_situation:unsafe | "risky situation" | "unsafe" | "has lexical unit" |  | "FN" |  |
| fn:risky_situation | fn:HasLexicalUnit | fn:lu:risky_situation:dangerous | "risky situation" | "dangerous" | "has lexical unit" |  | "FN" |  |
| fn:risky_situation | fn:HasLexicalUnit | fn:lu:risky_situation:risky | "risky situation" | "risky" | "has lexical unit" |  | "FN" |  |
| fn:risky_situation | fn:HasLexicalUnit | fn:lu:risky_situation:risk | "risky situation" | "risk" | "has lexical unit" |  | "FN" |  |
| fn:risky_situation | fn:HasLexicalUnit | fn:lu:risky_situation:threat | "risky situation" | "threat" | "has lexical unit" |  | "FN" |  |
| fn:risky_situation | fn:HasLexicalUnit | fn:lu:risky_situation:danger | "risky situation" | "danger" | "has lexical unit" |  | "FN" |  |
| fn:risky_situation | fn:HasLexicalUnit | fn:lu:risky_situation:riskily | "risky situation" | "riskily" | "has lexical unit" |  | "FN" |  |
| fn:risky_situation | fn:HasLexicalUnit | fn:lu:risky_situation:safely | "risky situation" | "safely" | "has lexical unit" |  | "FN" |  |
| fn:risky_situation | fn:HasLexicalUnit | fn:lu:risky_situation:warm | "risky situation" | "warm" | "has lexical unit" |  | "FN" |  |
| fn:risky_situation | /r/HasA | fn:fe:situation | "risky situation" | "situation" | "/r/has a" |  | "FN" |  |
| fn:risky_situation | /r/HasA | fn:fe:asset | "risky situation" | "asset" | "/r/has a" |  | "FN" |  |
| fn:risky_situation | /r/HasA | fn:fe:degree | "risky situation" | "degree" | "/r/has a" |  | "FN" |  |
| fn:risky_situation | /r/HasA | fn:fe:place | "risky situation" | "place" | "/r/has a" |  | "FN" |  |
| fn:risky_situation | /r/HasA | fn:fe:time | "risky situation" | "time" | "/r/has a" |  | "FN" |  |
| fn:risky_situation | /r/HasA | fn:fe:domain | "risky situation" | "domain" | "/r/has a" |  | "FN" |  |
| fn:fe:dangerous_entity | /r/RelatedTo | fn:fe:situation | "dangerous entity" | "situation" | "/r/related to" |  | "FN" |  |
| fn:risky_situation | /r/HasA | fn:fe:dangerous_entity | "risky situation" | "dangerous entity" | "/r/has a" |  | "FN" |  |
| fn:risky_situation | /r/HasA | fn:fe:frequency | "risky situation" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:risky_situation | /r/HasA | fn:fe:circumstances | "risky situation" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:intentionally_act | /r/UsedFor | fn:rite | "intentionally act" | "rite" | "/r/used for" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:christen | "rite" | "christen" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:baptism | "rite" | "baptism" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:eucharist | "rite" | "eucharist" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:confirmation | "rite" | "confirmation" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:pray | "rite" | "pray" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:prayer | "rite" | "prayer" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:mass | "rite" | "mass" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:communion | "rite" | "communion" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:bless | "rite" | "bless" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:blessing | "rite" | "blessing" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:consecrate | "rite" | "consecrate" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:anoint | "rite" | "anoint" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:unction | "rite" | "unction" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:rite | "rite" | "rite" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:ritual | "rite" | "ritual" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:confirm | "rite" | "confirm" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:circumcise | "rite" | "circumcise" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:circumcision | "rite" | "circumcision" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:service | "rite" | "service" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:ordination | "rite" | "ordination" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:vigil | "rite" | "vigil" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:confession | "rite" | "confession" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:baptize | "rite" | "baptize" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:sacrament | "rite" | "sacrament" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:ordain | "rite" | "ordain" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:christening | "rite" | "christening" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:consecration | "rite" | "consecration" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:bar_mitzvah | "rite" | "bar mitzvah" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:sacrifice | "rite" | "sacrifice" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:initiation | "rite" | "initiation" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:initiate | "rite" | "initiate" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:rite_of_passage | "rite" | "rite of passage" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:evensong | "rite" | "evensong" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:worship | "rite" | "worship" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:vesper | "rite" | "vesper" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:sacrifice | "rite" | "sacrifice" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:order | "rite" | "order" | "has lexical unit" |  | "FN" |  |
| fn:rite | fn:HasLexicalUnit | fn:lu:rite:exercise | "rite" | "exercise" | "has lexical unit" |  | "FN" |  |
| fn:fe:leader | /r/IsA | fn:st:sentient | "leader" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:rite | /r/HasA | fn:fe:leader | "rite" | "leader" | "/r/has a" |  | "FN" |  |
| fn:fe:member | /r/IsA | fn:st:sentient | "member" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:rite | /r/HasA | fn:fe:member | "rite" | "member" | "/r/has a" |  | "FN" |  |
| fn:fe:organization | /r/IsA | fn:st:organization | "organization" | "organization" | "/r/is a" |  | "FN" |  |
| fn:st:organization | /r/IsA | fn:st:ontological_type | "organization" | "ontological type" | "/r/is a" |  | "FN" |  |
| fn:rite | /r/HasA | fn:fe:organization | "rite" | "organization" | "/r/has a" |  | "FN" |  |
| fn:rite | /r/HasA | fn:fe:means | "rite" | "means" | "/r/has a" |  | "FN" |  |
| fn:rite | /r/HasA | fn:fe:manner | "rite" | "manner" | "/r/has a" |  | "FN" |  |
| fn:rite | /r/HasA | fn:fe:time | "rite" | "time" | "/r/has a" |  | "FN" |  |
| fn:rite | /r/HasA | fn:fe:place | "rite" | "place" | "/r/has a" |  | "FN" |  |
| fn:rite | /r/HasA | fn:fe:instrument | "rite" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:rite | /r/HasA | fn:fe:desired_state_of_affairs | "rite" | "desired state of affairs" | "/r/has a" |  | "FN" |  |
| fn:rite | /r/HasA | fn:fe:type | "rite" | "type" | "/r/has a" |  | "FN" |  |
| fn:rite | /r/HasA | fn:fe:object | "rite" | "object" | "/r/has a" |  | "FN" |  |
| fn:rite | /r/HasA | fn:fe:new_status | "rite" | "new status" | "/r/has a" |  | "FN" |  |
| fn:fe:guardian | /r/IsA | fn:st:sentient | "guardian" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:rite | /r/HasA | fn:fe:guardian | "rite" | "guardian" | "/r/has a" |  | "FN" |  |
| fn:roadways | /r/IsA | fn:locale_by_use | "roadways" | "locale by use" | "/r/is a" |  | "FN" |  |
| fn:motion | /r/UsedFor | fn:roadways | "motion" | "roadways" | "/r/used for" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:road | "roadways" | "road" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:path | "roadways" | "path" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:way | "roadways" | "way" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:street | "roadways" | "street" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:avenue | "roadways" | "avenue" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:artery | "roadways" | "artery" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:highway | "roadways" | "highway" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:expressway | "roadways" | "expressway" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:motorway | "roadways" | "motorway" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:sidewalk | "roadways" | "sidewalk" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:pavement | "roadways" | "pavement" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:underpass | "roadways" | "underpass" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:overpass | "roadways" | "overpass" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:railway | "roadways" | "railway" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:railroad | "roadways" | "railroad" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:route | "roadways" | "route" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:line | "roadways" | "line" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:crosswalk | "roadways" | "crosswalk" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:bridge | "roadways" | "bridge" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:tunnel | "roadways" | "tunnel" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:autobahn | "roadways" | "autobahn" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:lane | "roadways" | "lane" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:track | "roadways" | "track" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:trail | "roadways" | "trail" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:boulevard | "roadways" | "boulevard" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:course | "roadways" | "course" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:freeway | "roadways" | "freeway" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:pathway | "roadways" | "pathway" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:roadway | "roadways" | "roadway" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:thoroughfare | "roadways" | "thoroughfare" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:byway | "roadways" | "byway" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:cul-de-sac | "roadways" | "cul-de-sac" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:driveway | "roadways" | "driveway" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:parkway | "roadways" | "parkway" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:runway | "roadways" | "runway" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:bypass | "roadways" | "bypass" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:flyover | "roadways" | "flyover" | "has lexical unit" |  | "FN" |  |
| fn:roadways | fn:HasLexicalUnit | fn:lu:roadways:rail | "roadways" | "rail" | "has lexical unit" |  | "FN" |  |
| fn:roadways | /r/HasA | fn:fe:roadway | "roadways" | "roadway" | "/r/has a" |  | "FN" |  |
| fn:roadways | /r/HasA | fn:fe:source | "roadways" | "source" | "/r/has a" |  | "FN" |  |
| fn:roadways | /r/HasA | fn:fe:goal | "roadways" | "goal" | "/r/has a" |  | "FN" |  |
| fn:roadways | /r/HasA | fn:fe:endpoints | "roadways" | "endpoints" | "/r/has a" |  | "FN" |  |
| fn:roadways | /r/HasA | fn:fe:characteristic | "roadways" | "characteristic" | "/r/has a" |  | "FN" |  |
| fn:roadways | /r/HasA | fn:fe:name | "roadways" | "name" | "/r/has a" |  | "FN" |  |
| fn:roadways | /r/HasA | fn:fe:path | "roadways" | "path" | "/r/has a" |  | "FN" |  |
| fn:roadways | /r/HasA | fn:fe:use | "roadways" | "use" | "/r/has a" |  | "FN" |  |
| fn:roadways | /r/HasA | fn:fe:direction | "roadways" | "direction" | "/r/has a" |  | "FN" |  |
| fn:roadways | /r/HasA | fn:fe:relative_location | "roadways" | "relative location" | "/r/has a" |  | "FN" |  |
| fn:roadways | /r/HasA | fn:fe:material | "roadways" | "material" | "/r/has a" |  | "FN" |  |
| fn:roadways | /r/HasA | fn:fe:frequency_of_use | "roadways" | "frequency of use" | "/r/has a" |  | "FN" |  |
| fn:roadways | /r/HasA | fn:fe:abundant_entities | "roadways" | "abundant entities" | "/r/has a" |  | "FN" |  |
| fn:roadways | /r/HasA | fn:fe:length | "roadways" | "length" | "/r/has a" |  | "FN" |  |
| fn:roadways | /r/HasA | fn:fe:part | "roadways" | "part" | "/r/has a" |  | "FN" |  |
| fn:robbery | /r/IsA | fn:committing_crime | "robbery" | "committing crime" | "/r/is a" |  | "FN" |  |
| fn:theft | /r/UsedFor | fn:robbery | "theft" | "robbery" | "/r/used for" |  | "FN" |  |
| fn:robbery | fn:HasLexicalUnit | fn:lu:robbery:rob | "robbery" | "rob" | "has lexical unit" |  | "FN" |  |
| fn:robbery | fn:HasLexicalUnit | fn:lu:robbery:robber | "robbery" | "robber" | "has lexical unit" |  | "FN" |  |
| fn:robbery | fn:HasLexicalUnit | fn:lu:robbery:mug | "robbery" | "mug" | "has lexical unit" |  | "FN" |  |
| fn:robbery | fn:HasLexicalUnit | fn:lu:robbery:robbery | "robbery" | "robbery" | "has lexical unit" |  | "FN" |  |
| fn:robbery | fn:HasLexicalUnit | fn:lu:robbery:mugger | "robbery" | "mugger" | "has lexical unit" |  | "FN" |  |
| fn:robbery | fn:HasLexicalUnit | fn:lu:robbery:mugging | "robbery" | "mugging" | "has lexical unit" |  | "FN" |  |
| fn:robbery | fn:HasLexicalUnit | fn:lu:robbery:stick-up | "robbery" | "stick-up" | "has lexical unit" |  | "FN" |  |
| fn:robbery | fn:HasLexicalUnit | fn:lu:robbery:hold-up | "robbery" | "hold-up" | "has lexical unit" |  | "FN" |  |
| fn:robbery | fn:HasLexicalUnit | fn:lu:robbery:hold_up | "robbery" | "hold up" | "has lexical unit" |  | "FN" |  |
| fn:robbery | fn:HasLexicalUnit | fn:lu:robbery:rob_blind | "robbery" | "rob blind" | "has lexical unit" |  | "FN" |  |
| fn:robbery | fn:HasLexicalUnit | fn:lu:robbery:stick_up | "robbery" | "stick up" | "has lexical unit" |  | "FN" |  |
| fn:robbery | fn:HasLexicalUnit | fn:lu:robbery:ransack | "robbery" | "ransack" | "has lexical unit" |  | "FN" |  |
| fn:robbery | fn:HasLexicalUnit | fn:lu:robbery:rifle | "robbery" | "rifle" | "has lexical unit" |  | "FN" |  |
| fn:robbery | /r/HasA | fn:fe:perpetrator | "robbery" | "perpetrator" | "/r/has a" |  | "FN" |  |
| fn:robbery | /r/HasA | fn:fe:victim | "robbery" | "victim" | "/r/has a" |  | "FN" |  |
| fn:robbery | /r/HasA | fn:fe:goods | "robbery" | "goods" | "/r/has a" |  | "FN" |  |
| fn:robbery | /r/HasA | fn:fe:source | "robbery" | "source" | "/r/has a" |  | "FN" |  |
| fn:robbery | /r/HasA | fn:fe:means | "robbery" | "means" | "/r/has a" |  | "FN" |  |
| fn:robbery | /r/HasA | fn:fe:manner | "robbery" | "manner" | "/r/has a" |  | "FN" |  |
| fn:robbery | /r/HasA | fn:fe:place | "robbery" | "place" | "/r/has a" |  | "FN" |  |
| fn:robbery | /r/HasA | fn:fe:time | "robbery" | "time" | "/r/has a" |  | "FN" |  |
| fn:robbery | /r/HasA | fn:fe:purpose | "robbery" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:robbery | /r/HasA | fn:fe:explanation | "robbery" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:robbery | /r/HasA | fn:fe:frequency | "robbery" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:robbery | /r/HasA | fn:fe:co-participant | "robbery" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:rope_manipulation | /r/IsA | fn:manipulate_into_shape | "rope manipulation" | "manipulate into shape" | "/r/is a" |  | "FN" |  |
| fn:rope_manipulation | /r/IsA | fn:knot_creation_scenario | "rope manipulation" | "knot creation scenario" | "/r/is a" |  | "FN" |  |
| fn:rope_manipulation | fn:HasLexicalUnit | fn:lu:rope_manipulation:tie | "rope manipulation" | "tie" | "has lexical unit" |  | "FN" |  |
| fn:rope_manipulation | fn:HasLexicalUnit | fn:lu:rope_manipulation:knot | "rope manipulation" | "knot" | "has lexical unit" |  | "FN" |  |
| fn:rope_manipulation | fn:HasLexicalUnit | fn:lu:rope_manipulation:tangle | "rope manipulation" | "tangle" | "has lexical unit" |  | "FN" |  |
| fn:rope_manipulation | fn:HasLexicalUnit | fn:lu:rope_manipulation:braid | "rope manipulation" | "braid" | "has lexical unit" |  | "FN" |  |
| fn:rope_manipulation | /r/HasA | fn:fe:agent | "rope manipulation" | "agent" | "/r/has a" |  | "FN" |  |
| fn:rope_manipulation | /r/HasA | fn:fe:instrument | "rope manipulation" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:rope_manipulation | /r/HasA | fn:fe:place | "rope manipulation" | "place" | "/r/has a" |  | "FN" |  |
| fn:rope_manipulation | /r/HasA | fn:fe:purpose | "rope manipulation" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:rope_manipulation | /r/HasA | fn:fe:time | "rope manipulation" | "time" | "/r/has a" |  | "FN" |  |
| fn:rope_manipulation | /r/HasA | fn:fe:means | "rope manipulation" | "means" | "/r/has a" |  | "FN" |  |
| fn:rope_manipulation | /r/HasA | fn:fe:explanation | "rope manipulation" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:rope_manipulation | /r/HasA | fn:fe:rope | "rope manipulation" | "rope" | "/r/has a" |  | "FN" |  |
| fn:rope_manipulation | /r/HasA | fn:fe:knot | "rope manipulation" | "knot" | "/r/has a" |  | "FN" |  |
| fn:rope_manipulation | /r/HasA | fn:fe:manner | "rope manipulation" | "manner" | "/r/has a" |  | "FN" |  |
| fn:rope_manipulation | /r/HasA | fn:fe:locus | "rope manipulation" | "locus" | "/r/has a" |  | "FN" |  |
| fn:rotting | /r/IsA | fn:event | "rotting" | "event" | "/r/is a" |  | "FN" |  |
| fn:rotting | /r/Causes | fn:being_rotted | "rotting" | "being rotted" | "/r/causes" |  | "FN" |  |
| fn:cause_to_rot | /r/Causes | fn:rotting | "cause to rot" | "rotting" | "/r/causes" |  | "FN" |  |
| fn:rotting | fn:HasLexicalUnit | fn:lu:rotting:putrefy | "rotting" | "putrefy" | "has lexical unit" |  | "FN" |  |
| fn:rotting | fn:HasLexicalUnit | fn:lu:rotting:rot | "rotting" | "rot" | "has lexical unit" |  | "FN" |  |
| fn:rotting | fn:HasLexicalUnit | fn:lu:rotting:decompose | "rotting" | "decompose" | "has lexical unit" |  | "FN" |  |
| fn:rotting | fn:HasLexicalUnit | fn:lu:rotting:decay | "rotting" | "decay" | "has lexical unit" |  | "FN" |  |
| fn:rotting | fn:HasLexicalUnit | fn:lu:rotting:fester | "rotting" | "fester" | "has lexical unit" |  | "FN" |  |
| fn:rotting | fn:HasLexicalUnit | fn:lu:rotting:moulder | "rotting" | "moulder" | "has lexical unit" |  | "FN" |  |
| fn:rotting | fn:HasLexicalUnit | fn:lu:rotting:perish | "rotting" | "perish" | "has lexical unit" |  | "FN" |  |
| fn:rotting | fn:HasLexicalUnit | fn:lu:rotting:spoil | "rotting" | "spoil" | "has lexical unit" |  | "FN" |  |
| fn:rotting | fn:HasLexicalUnit | fn:lu:rotting:decay | "rotting" | "decay" | "has lexical unit" |  | "FN" |  |
| fn:rotting | fn:HasLexicalUnit | fn:lu:rotting:rot | "rotting" | "rot" | "has lexical unit" |  | "FN" |  |
| fn:rotting | /r/HasA | fn:fe:patient | "rotting" | "patient" | "/r/has a" |  | "FN" |  |
| fn:rotting | /r/HasA | fn:fe:place | "rotting" | "place" | "/r/has a" |  | "FN" |  |
| fn:rotting | /r/HasA | fn:fe:time | "rotting" | "time" | "/r/has a" |  | "FN" |  |
| fn:rotting | /r/HasA | fn:fe:explanation | "rotting" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:rotting | /r/HasA | fn:fe:result | "rotting" | "result" | "/r/has a" |  | "FN" |  |
| fn:rotting | /r/HasA | fn:fe:initial_state | "rotting" | "initial state" | "/r/has a" |  | "FN" |  |
| fn:rotting | /r/HasA | fn:fe:duration | "rotting" | "duration" | "/r/has a" |  | "FN" |  |
| fn:rotting | /r/HasA | fn:fe:speed | "rotting" | "speed" | "/r/has a" |  | "FN" |  |
| fn:rotting | /r/HasA | fn:fe:subregion | "rotting" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:rotting | /r/HasA | fn:fe:degree | "rotting" | "degree" | "/r/has a" |  | "FN" |  |
| fn:rotting | /r/HasA | fn:fe:frequency | "rotting" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:rotting | /r/HasA | fn:fe:manner | "rotting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:rotting | /r/HasA | fn:fe:circumstances | "rotting" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:run_risk | /r/IsA | fn:likelihood | "run risk" | "likelihood" | "/r/is a" |  | "FN" |  |
| fn:run_risk | /r/UsedFor | fn:protecting | "run risk" | "protecting" | "/r/used for" |  | "FN" |  |
| fn:run_risk | /r/UsedFor | fn:wagering | "run risk" | "wagering" | "/r/used for" |  | "FN" |  |
| fn:run_risk | /r/RelatedTo | fn:being_at_risk | "run risk" | "being at risk" | "/r/related to" |  | "FN" |  |
| fn:run_risk | /r/RelatedTo | fn:risky_situation | "run risk" | "risky situation" | "/r/related to" |  | "FN" |  |
| fn:run_risk | /r/SimilarTo | fn:being_at_risk | "run risk" | "being at risk" | "/r/similar to" |  | "FN" |  |
| fn:run_risk | /r/SimilarTo | fn:risky_situation | "run risk" | "risky situation" | "/r/similar to" |  | "FN" |  |
| fn:run_risk | /r/IsA | fn:risk_scenario | "run risk" | "risk scenario" | "/r/is a" |  | "FN" |  |
| fn:run_risk | fn:HasLexicalUnit | fn:lu:run_risk:risk | "run risk" | "risk" | "has lexical unit" |  | "FN" |  |
| fn:run_risk | fn:HasLexicalUnit | fn:lu:run_risk:endangered | "run risk" | "endangered" | "has lexical unit" |  | "FN" |  |
| fn:run_risk | fn:HasLexicalUnit | fn:lu:run_risk:peril | "run risk" | "peril" | "has lexical unit" |  | "FN" |  |
| fn:run_risk | fn:HasLexicalUnit | fn:lu:run_risk:risk | "run risk" | "risk" | "has lexical unit" |  | "FN" |  |
| fn:run_risk | fn:HasLexicalUnit | fn:lu:run_risk:wager | "run risk" | "wager" | "has lexical unit" |  | "FN" |  |
| fn:run_risk | /r/HasA | fn:fe:protagonist | "run risk" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:run_risk | /r/HasA | fn:fe:place | "run risk" | "place" | "/r/has a" |  | "FN" |  |
| fn:run_risk | /r/HasA | fn:fe:severity | "run risk" | "severity" | "/r/has a" |  | "FN" |  |
| fn:run_risk | /r/HasA | fn:fe:time | "run risk" | "time" | "/r/has a" |  | "FN" |  |
| fn:run_risk | /r/HasA | fn:fe:bad_outcome | "run risk" | "bad outcome" | "/r/has a" |  | "FN" |  |
| fn:fe:asset | /r/RelatedTo | fn:fe:bad_outcome | "asset" | "bad outcome" | "/r/related to" |  | "FN" |  |
| fn:run_risk | /r/HasA | fn:fe:asset | "run risk" | "asset" | "/r/has a" |  | "FN" |  |
| fn:run_risk | /r/HasA | fn:fe:action | "run risk" | "action" | "/r/has a" |  | "FN" |  |
| fn:run_risk | /r/HasA | fn:fe:frequency | "run risk" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:run_risk | /r/HasA | fn:fe:purpose | "run risk" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:run_risk | /r/HasA | fn:fe:explanation | "run risk" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:run_risk | /r/HasA | fn:fe:iterations | "run risk" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:run_risk | /r/HasA | fn:fe:circumstances | "run risk" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:run_risk | /r/HasA | fn:fe:beneficiary | "run risk" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:possession | /r/UsedFor | fn:sacrificing_for | "possession" | "sacrificing for" | "/r/used for" |  | "FN" |  |
| fn:preference | /r/UsedFor | fn:sacrificing_for | "preference" | "sacrificing for" | "/r/used for" |  | "FN" |  |
| fn:sacrificing_for | fn:HasLexicalUnit | fn:lu:sacrificing_for:sacrifice | "sacrificing for" | "sacrifice" | "has lexical unit" |  | "FN" |  |
| fn:sacrificing_for | fn:HasLexicalUnit | fn:lu:sacrificing_for:compromise | "sacrificing for" | "compromise" | "has lexical unit" |  | "FN" |  |
| fn:sacrificing_for | /r/HasA | fn:fe:agent | "sacrificing for" | "agent" | "/r/has a" |  | "FN" |  |
| fn:sacrificing_for | /r/HasA | fn:fe:asset | "sacrificing for" | "asset" | "/r/has a" |  | "FN" |  |
| fn:sacrificing_for | /r/HasA | fn:fe:depictive | "sacrificing for" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:sacrificing_for | /r/HasA | fn:fe:manner | "sacrificing for" | "manner" | "/r/has a" |  | "FN" |  |
| fn:sacrificing_for | /r/HasA | fn:fe:duration | "sacrificing for" | "duration" | "/r/has a" |  | "FN" |  |
| fn:sacrificing_for | /r/HasA | fn:fe:time | "sacrificing for" | "time" | "/r/has a" |  | "FN" |  |
| fn:sacrificing_for | /r/HasA | fn:fe:explanation | "sacrificing for" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:sacrificing_for | /r/HasA | fn:fe:benefit | "sacrificing for" | "benefit" | "/r/has a" |  | "FN" |  |
| fn:compliance | /r/IsA | fn:satisfying | "compliance" | "satisfying" | "/r/is a" |  | "FN" |  |
| fn:meet_specifications | /r/IsA | fn:satisfying | "meet specifications" | "satisfying" | "/r/is a" |  | "FN" |  |
| fn:satisfying | fn:HasLexicalUnit | fn:lu:satisfying:satisfy | "satisfying" | "satisfy" | "has lexical unit" |  | "FN" |  |
| fn:satisfying | /r/HasA | fn:fe:agent | "satisfying" | "agent" | "/r/has a" |  | "FN" |  |
| fn:satisfying | /r/HasA | fn:fe:entity | "satisfying" | "entity" | "/r/has a" |  | "FN" |  |
| fn:satisfying | /r/HasA | fn:fe:event | "satisfying" | "event" | "/r/has a" |  | "FN" |  |
| fn:satisfying | /r/HasA | fn:fe:standard | "satisfying" | "standard" | "/r/has a" |  | "FN" |  |
| fn:satisfying | /r/HasA | fn:fe:manner | "satisfying" | "manner" | "/r/has a" |  | "FN" |  |
| fn:satisfying | /r/HasA | fn:fe:means | "satisfying" | "means" | "/r/has a" |  | "FN" |  |
| fn:satisfying | /r/HasA | fn:fe:time | "satisfying" | "time" | "/r/has a" |  | "FN" |  |
| fn:scarcity | /r/IsA | fn:abundance | "scarcity" | "abundance" | "/r/is a" |  | "FN" |  |
| fn:scarcity | fn:HasLexicalUnit | fn:lu:scarcity:scarcity | "scarcity" | "scarcity" | "has lexical unit" |  | "FN" |  |
| fn:scarcity | fn:HasLexicalUnit | fn:lu:scarcity:scarce | "scarcity" | "scarce" | "has lexical unit" |  | "FN" |  |
| fn:scarcity | fn:HasLexicalUnit | fn:lu:scarcity:plentiful | "scarcity" | "plentiful" | "has lexical unit" |  | "FN" |  |
| fn:scarcity | fn:HasLexicalUnit | fn:lu:scarcity:plentifulness | "scarcity" | "plentifulness" | "has lexical unit" |  | "FN" |  |
| fn:scarcity | fn:HasLexicalUnit | fn:lu:scarcity:scarceness | "scarcity" | "scarceness" | "has lexical unit" |  | "FN" |  |
| fn:scarcity | /r/HasA | fn:fe:collection | "scarcity" | "collection" | "/r/has a" |  | "FN" |  |
| fn:scarcity | /r/HasA | fn:fe:quantity | "scarcity" | "quantity" | "/r/has a" |  | "FN" |  |
| fn:scarcity | /r/HasA | fn:fe:degree | "scarcity" | "degree" | "/r/has a" |  | "FN" |  |
| fn:scarcity | /r/HasA | fn:fe:time | "scarcity" | "time" | "/r/has a" |  | "FN" |  |
| fn:scarcity | /r/HasA | fn:fe:circumstances | "scarcity" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:scarcity | /r/HasA | fn:fe:measure | "scarcity" | "measure" | "/r/has a" |  | "FN" |  |
| fn:scarcity | /r/HasA | fn:fe:place | "scarcity" | "place" | "/r/has a" |  | "FN" |  |
| fn:reserving | /r/IsA | fn:scheduling | "reserving" | "scheduling" | "/r/is a" |  | "FN" |  |
| fn:making_arrangements | /r/UsedFor | fn:scheduling | "making arrangements" | "scheduling" | "/r/used for" |  | "FN" |  |
| fn:scheduling | /r/UsedFor | fn:change_event_time | "scheduling" | "change event time" | "/r/used for" |  | "FN" |  |
| fn:change_event_time | /r/SimilarTo | fn:scheduling | "change event time" | "scheduling" | "/r/similar to" |  | "FN" |  |
| fn:scheduling | /r/Causes | fn:timetable | "scheduling" | "timetable" | "/r/causes" |  | "FN" |  |
| fn:scheduling | fn:HasLexicalUnit | fn:lu:scheduling:schedule | "scheduling" | "schedule" | "has lexical unit" |  | "FN" |  |
| fn:scheduling | fn:HasLexicalUnit | fn:lu:scheduling:set_up | "scheduling" | "set up" | "has lexical unit" |  | "FN" |  |
| fn:scheduling | fn:HasLexicalUnit | fn:lu:scheduling:arrange | "scheduling" | "arrange" | "has lexical unit" |  | "FN" |  |
| fn:scheduling | /r/HasA | fn:fe:agent | "scheduling" | "agent" | "/r/has a" |  | "FN" |  |
| fn:scheduling | /r/HasA | fn:fe:event | "scheduling" | "event" | "/r/has a" |  | "FN" |  |
| fn:scheduling | /r/HasA | fn:fe:scheduled_time | "scheduling" | "scheduled time" | "/r/has a" |  | "FN" |  |
| fn:scheduling | /r/HasA | fn:fe:place | "scheduling" | "place" | "/r/has a" |  | "FN" |  |
| fn:scheduling | /r/HasA | fn:fe:beneficiary | "scheduling" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:scheduling | /r/HasA | fn:fe:frequency | "scheduling" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:scheduling | /r/HasA | fn:fe:means | "scheduling" | "means" | "/r/has a" |  | "FN" |  |
| fn:scheduling | /r/HasA | fn:fe:purpose | "scheduling" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:scheduling | /r/HasA | fn:fe:explanation | "scheduling" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:scheduling | /r/HasA | fn:fe:manner | "scheduling" | "manner" | "/r/has a" |  | "FN" |  |
| fn:scheduling | /r/HasA | fn:fe:time | "scheduling" | "time" | "/r/has a" |  | "FN" |  |
| fn:scope | /r/IsA | fn:attributes | "scope" | "attributes" | "/r/is a" |  | "FN" |  |
| fn:scope | fn:HasLexicalUnit | fn:lu:scope:scope | "scope" | "scope" | "has lexical unit" |  | "FN" |  |
| fn:scope | /r/HasA | fn:fe:event | "scope" | "event" | "/r/has a" |  | "FN" |  |
| fn:scope | /r/HasA | fn:fe:attribute | "scope" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:scope | /r/HasA | fn:fe:salient_entity | "scope" | "salient entity" | "/r/has a" |  | "FN" |  |
| fn:scouring | /r/IsA | fn:scrutinizing_for | "scouring" | "scrutinizing for" | "/r/is a" |  | "FN" |  |
| fn:scrutiny | /r/SimilarTo | fn:scouring | "scrutiny" | "scouring" | "/r/similar to" |  | "FN" |  |
| fn:scouring | fn:HasLexicalUnit | fn:lu:scouring:scour | "scouring" | "scour" | "has lexical unit" |  | "FN" |  |
| fn:scouring | fn:HasLexicalUnit | fn:lu:scouring:comb | "scouring" | "comb" | "has lexical unit" |  | "FN" |  |
| fn:scouring | fn:HasLexicalUnit | fn:lu:scouring:ransack | "scouring" | "ransack" | "has lexical unit" |  | "FN" |  |
| fn:scouring | fn:HasLexicalUnit | fn:lu:scouring:sift | "scouring" | "sift" | "has lexical unit" |  | "FN" |  |
| fn:scouring | fn:HasLexicalUnit | fn:lu:scouring:sweep | "scouring" | "sweep" | "has lexical unit" |  | "FN" |  |
| fn:scouring | fn:HasLexicalUnit | fn:lu:scouring:sweep | "scouring" | "sweep" | "has lexical unit" |  | "FN" |  |
| fn:scouring | fn:HasLexicalUnit | fn:lu:scouring:rummage | "scouring" | "rummage" | "has lexical unit" |  | "FN" |  |
| fn:scouring | fn:HasLexicalUnit | fn:lu:scouring:rifle | "scouring" | "rifle" | "has lexical unit" |  | "FN" |  |
| fn:fe:searcher | /r/IsA | fn:st:sentient | "searcher" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:scouring | /r/HasA | fn:fe:searcher | "scouring" | "searcher" | "/r/has a" |  | "FN" |  |
| fn:scouring | /r/HasA | fn:fe:ground | "scouring" | "ground" | "/r/has a" |  | "FN" |  |
| fn:scouring | /r/HasA | fn:fe:sought_entity | "scouring" | "sought entity" | "/r/has a" |  | "FN" |  |
| fn:scouring | /r/HasA | fn:fe:manner | "scouring" | "manner" | "/r/has a" |  | "FN" |  |
| fn:scouring | /r/HasA | fn:fe:duration | "scouring" | "duration" | "/r/has a" |  | "FN" |  |
| fn:scouring | /r/HasA | fn:fe:degree | "scouring" | "degree" | "/r/has a" |  | "FN" |  |
| fn:scouring | /r/HasA | fn:fe:instrument | "scouring" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:scouring | /r/HasA | fn:fe:means | "scouring" | "means" | "/r/has a" |  | "FN" |  |
| fn:scouring | /r/HasA | fn:fe:purpose | "scouring" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:scouring | /r/HasA | fn:fe:time | "scouring" | "time" | "/r/has a" |  | "FN" |  |
| fn:inspecting | /r/IsA | fn:scrutinizing_for | "inspecting" | "scrutinizing for" | "/r/is a" |  | "FN" |  |
| fn:scouring | /r/IsA | fn:scrutinizing_for | "scouring" | "scrutinizing for" | "/r/is a" |  | "FN" |  |
| fn:scrutinizing_for | /r/IsA | fn:scrutiny | "scrutinizing for" | "scrutiny" | "/r/is a" |  | "FN" |  |
| fn:scrutinizing_for | /r/IsA | fn:searching_scenario | "scrutinizing for" | "searching scenario" | "/r/is a" |  | "FN" |  |
| fn:scrutinizing_for | /r/HasA | fn:fe:cognizer | "scrutinizing for" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:scrutinizing_for | /r/HasA | fn:fe:ground | "scrutinizing for" | "ground" | "/r/has a" |  | "FN" |  |
| fn:scrutinizing_for | /r/HasA | fn:fe:phenomenon | "scrutinizing for" | "phenomenon" | "/r/has a" |  | "FN" |  |
| fn:scrutinizing_for | /r/HasA | fn:fe:manner | "scrutinizing for" | "manner" | "/r/has a" |  | "FN" |  |
| fn:scrutinizing_for | /r/HasA | fn:fe:means | "scrutinizing for" | "means" | "/r/has a" |  | "FN" |  |
| fn:scrutinizing_for | /r/HasA | fn:fe:degree | "scrutinizing for" | "degree" | "/r/has a" |  | "FN" |  |
| fn:scrutinizing_for | /r/HasA | fn:fe:purpose | "scrutinizing for" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:scrutinizing_for | /r/HasA | fn:fe:instrument | "scrutinizing for" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:reading_perception | /r/IsA | fn:scrutiny | "reading perception" | "scrutiny" | "/r/is a" |  | "FN" |  |
| fn:research | /r/IsA | fn:scrutiny | "research" | "scrutiny" | "/r/is a" |  | "FN" |  |
| fn:scrutinizing_for | /r/IsA | fn:scrutiny | "scrutinizing for" | "scrutiny" | "/r/is a" |  | "FN" |  |
| fn:verification | /r/IsA | fn:scrutiny | "verification" | "scrutiny" | "/r/is a" |  | "FN" |  |
| fn:becoming_aware | /r/UsedFor | fn:scrutiny | "becoming aware" | "scrutiny" | "/r/used for" |  | "FN" |  |
| fn:perception_active | /r/UsedFor | fn:scrutiny | "perception active" | "scrutiny" | "/r/used for" |  | "FN" |  |
| fn:scrutiny | /r/UsedFor | fn:experimentation | "scrutiny" | "experimentation" | "/r/used for" |  | "FN" |  |
| fn:seeking | /r/RelatedTo | fn:scrutiny | "seeking" | "scrutiny" | "/r/related to" |  | "FN" |  |
| fn:inspecting | /r/SimilarTo | fn:scrutiny | "inspecting" | "scrutiny" | "/r/similar to" |  | "FN" |  |
| fn:reading_perception | /r/SimilarTo | fn:scrutiny | "reading perception" | "scrutiny" | "/r/similar to" |  | "FN" |  |
| fn:scrutiny | /r/SimilarTo | fn:research | "scrutiny" | "research" | "/r/similar to" |  | "FN" |  |
| fn:scrutiny | /r/SimilarTo | fn:scouring | "scrutiny" | "scouring" | "/r/similar to" |  | "FN" |  |
| fn:scrutiny | /r/SimilarTo | fn:seeking | "scrutiny" | "seeking" | "/r/similar to" |  | "FN" |  |
| fn:seeking | /r/SimilarTo | fn:scrutiny | "seeking" | "scrutiny" | "/r/similar to" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:analyse | "scrutiny" | "analyse" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:analysis | "scrutiny" | "analysis" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:investigate | "scrutiny" | "investigate" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:investigation | "scrutiny" | "investigation" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:look | "scrutiny" | "look" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:perusal | "scrutiny" | "perusal" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:peruse | "scrutiny" | "peruse" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:scan | "scrutiny" | "scan" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:scrutinize | "scrutiny" | "scrutinize" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:scrutiny | "scrutiny" | "scrutiny" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:search | "scrutiny" | "search" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:search | "scrutiny" | "search" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:study | "scrutiny" | "study" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:study | "scrutiny" | "study" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:survey | "scrutiny" | "survey" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:survey | "scrutiny" | "survey" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:analyst | "scrutiny" | "analyst" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:probe | "scrutiny" | "probe" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:reconnoitre | "scrutiny" | "reconnoitre" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:inspector | "scrutiny" | "inspector" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:assay | "scrutiny" | "assay" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:skim | "scrutiny" | "skim" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:sift | "scrutiny" | "sift" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:rummage | "scrutiny" | "rummage" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:surveyor | "scrutiny" | "surveyor" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:scout | "scrutiny" | "scout" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:eyeball | "scrutiny" | "eyeball" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:check | "scrutiny" | "check" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:sweep | "scrutiny" | "sweep" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:sweep | "scrutiny" | "sweep" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:double-check | "scrutiny" | "double-check" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:spy_out_the_land | "scrutiny" | "spy out the land" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:once-over | "scrutiny" | "once-over" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:comb | "scrutiny" | "comb" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:frisk | "scrutiny" | "frisk" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:ransack | "scrutiny" | "ransack" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:scour | "scrutiny" | "scour" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:monitor | "scrutiny" | "monitor" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:analytic | "scrutiny" | "analytic" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:go_[through] | "scrutiny" | "go [through]" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:monitoring | "scrutiny" | "monitoring" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:unmonitored | "scrutiny" | "unmonitored" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:surveillance | "scrutiny" | "surveillance" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:surveillance_[entity] | "scrutiny" | "surveillance [entity]" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:explore | "scrutiny" | "explore" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:rifle | "scrutiny" | "rifle" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:pry | "scrutiny" | "pry" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:examination | "scrutiny" | "examination" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | fn:HasLexicalUnit | fn:lu:scrutiny:reconnaissance | "scrutiny" | "reconnaissance" | "has lexical unit" |  | "FN" |  |
| fn:scrutiny | /r/HasA | fn:fe:cognizer | "scrutiny" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:scrutiny | /r/HasA | fn:fe:ground | "scrutiny" | "ground" | "/r/has a" |  | "FN" |  |
| fn:scrutiny | /r/HasA | fn:fe:phenomenon | "scrutiny" | "phenomenon" | "/r/has a" |  | "FN" |  |
| fn:scrutiny | /r/HasA | fn:fe:manner | "scrutiny" | "manner" | "/r/has a" |  | "FN" |  |
| fn:scrutiny | /r/HasA | fn:fe:means | "scrutiny" | "means" | "/r/has a" |  | "FN" |  |
| fn:scrutiny | /r/HasA | fn:fe:degree | "scrutiny" | "degree" | "/r/has a" |  | "FN" |  |
| fn:scrutiny | /r/HasA | fn:fe:direction | "scrutiny" | "direction" | "/r/has a" |  | "FN" |  |
| fn:scrutiny | /r/HasA | fn:fe:purpose | "scrutiny" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:scrutiny | /r/HasA | fn:fe:medium | "scrutiny" | "medium" | "/r/has a" |  | "FN" |  |
| fn:scrutiny | /r/HasA | fn:fe:instrument | "scrutiny" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:scrutiny | /r/HasA | fn:fe:time | "scrutiny" | "time" | "/r/has a" |  | "FN" |  |
| fn:attention | /r/UsedFor | fn:searching_scenario | "attention" | "searching scenario" | "/r/used for" |  | "FN" |  |
| fn:scrutinizing_for | /r/IsA | fn:searching_scenario | "scrutinizing for" | "searching scenario" | "/r/is a" |  | "FN" |  |
| fn:seeking | /r/IsA | fn:searching_scenario | "seeking" | "searching scenario" | "/r/is a" |  | "FN" |  |
| fn:searching_scenario | /r/HasA | fn:fe:cognizer | "searching scenario" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:searching_scenario | /r/HasA | fn:fe:ground | "searching scenario" | "ground" | "/r/has a" |  | "FN" |  |
| fn:searching_scenario | /r/HasA | fn:fe:phenomenon | "searching scenario" | "phenomenon" | "/r/has a" |  | "FN" |  |
| fn:searching_scenario | /r/HasA | fn:fe:manner | "searching scenario" | "manner" | "/r/has a" |  | "FN" |  |
| fn:searching_scenario | /r/HasA | fn:fe:means | "searching scenario" | "means" | "/r/has a" |  | "FN" |  |
| fn:searching_scenario | /r/HasA | fn:fe:degree | "searching scenario" | "degree" | "/r/has a" |  | "FN" |  |
| fn:searching_scenario | /r/HasA | fn:fe:purpose | "searching scenario" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:searching_scenario | /r/HasA | fn:fe:instrument | "searching scenario" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:awareness | /r/UsedFor | fn:secrecy_status | "awareness" | "secrecy status" | "/r/used for" |  | "FN" |  |
| fn:secrecy_status | /r/UsedFor | fn:cache | "secrecy status" | "cache" | "/r/used for" |  | "FN" |  |
| fn:secrecy_status | fn:HasLexicalUnit | fn:lu:secrecy_status:clandestine | "secrecy status" | "clandestine" | "has lexical unit" |  | "FN" |  |
| fn:secrecy_status | fn:HasLexicalUnit | fn:lu:secrecy_status:surreptitious | "secrecy status" | "surreptitious" | "has lexical unit" |  | "FN" |  |
| fn:secrecy_status | fn:HasLexicalUnit | fn:lu:secrecy_status:covert | "secrecy status" | "covert" | "has lexical unit" |  | "FN" |  |
| fn:secrecy_status | fn:HasLexicalUnit | fn:lu:secrecy_status:secret | "secrecy status" | "secret" | "has lexical unit" |  | "FN" |  |
| fn:secrecy_status | fn:HasLexicalUnit | fn:lu:secrecy_status:secretly | "secrecy status" | "secretly" | "has lexical unit" |  | "FN" |  |
| fn:secrecy_status | fn:HasLexicalUnit | fn:lu:secrecy_status:open | "secrecy status" | "open" | "has lexical unit" |  | "FN" |  |
| fn:secrecy_status | fn:HasLexicalUnit | fn:lu:secrecy_status:public | "secrecy status" | "public" | "has lexical unit" |  | "FN" |  |
| fn:secrecy_status | fn:HasLexicalUnit | fn:lu:secrecy_status:confidential | "secrecy status" | "confidential" | "has lexical unit" |  | "FN" |  |
| fn:secrecy_status | fn:HasLexicalUnit | fn:lu:secrecy_status:publicly | "secrecy status" | "publicly" | "has lexical unit" |  | "FN" |  |
| fn:secrecy_status | fn:HasLexicalUnit | fn:lu:secrecy_status:concealed | "secrecy status" | "concealed" | "has lexical unit" |  | "FN" |  |
| fn:secrecy_status | fn:HasLexicalUnit | fn:lu:secrecy_status:unclassified | "secrecy status" | "unclassified" | "has lexical unit" |  | "FN" |  |
| fn:secrecy_status | fn:HasLexicalUnit | fn:lu:secrecy_status:shadowy | "secrecy status" | "shadowy" | "has lexical unit" |  | "FN" |  |
| fn:secrecy_status | /r/HasA | fn:fe:phenomenon | "secrecy status" | "phenomenon" | "/r/has a" |  | "FN" |  |
| fn:secrecy_status | /r/HasA | fn:fe:degree | "secrecy status" | "degree" | "/r/has a" |  | "FN" |  |
| fn:secrecy_status | /r/HasA | fn:fe:time | "secrecy status" | "time" | "/r/has a" |  | "FN" |  |
| fn:secrecy_status | /r/HasA | fn:fe:cognizer | "secrecy status" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:secrecy_status | /r/HasA | fn:fe:communicative_force | "secrecy status" | "communicative force" | "/r/has a" |  | "FN" |  |
| fn:see_through | /r/IsA | fn:coming_to_believe | "see through" | "coming to believe" | "/r/is a" |  | "FN" |  |
| fn:see_through | fn:HasLexicalUnit | fn:lu:see_through:see_(through) | "see through" | "see (through)" | "has lexical unit" |  | "FN" |  |
| fn:see_through | /r/HasA | fn:fe:cognizer | "see through" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:see_through | /r/HasA | fn:fe:state_of_affairs | "see through" | "state of affairs" | "/r/has a" |  | "FN" |  |
| fn:see_through | /r/HasA | fn:fe:focal_entity | "see through" | "focal entity" | "/r/has a" |  | "FN" |  |
| fn:see_through | /r/HasA | fn:fe:means | "see through" | "means" | "/r/has a" |  | "FN" |  |
| fn:see_through | /r/HasA | fn:fe:medium | "see through" | "medium" | "/r/has a" |  | "FN" |  |
| fn:see_through | /r/HasA | fn:fe:topic | "see through" | "topic" | "/r/has a" |  | "FN" |  |
| fn:see_through | /r/HasA | fn:fe:degree | "see through" | "degree" | "/r/has a" |  | "FN" |  |
| fn:see_through | /r/HasA | fn:fe:depictive | "see through" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:see_through | /r/HasA | fn:fe:manner | "see through" | "manner" | "/r/has a" |  | "FN" |  |
| fn:see_through | /r/HasA | fn:fe:place | "see through" | "place" | "/r/has a" |  | "FN" |  |
| fn:see_through | /r/HasA | fn:fe:time | "see through" | "time" | "/r/has a" |  | "FN" |  |
| fn:shopping | /r/IsA | fn:seeking | "shopping" | "seeking" | "/r/is a" |  | "FN" |  |
| fn:seeking | /r/IsA | fn:seeking_to_achieve | "seeking" | "seeking to achieve" | "/r/is a" |  | "FN" |  |
| fn:seeking | /r/UsedFor | fn:criminal_investigation | "seeking" | "criminal investigation" | "/r/used for" |  | "FN" |  |
| fn:seeking | /r/UsedFor | fn:locating | "seeking" | "locating" | "/r/used for" |  | "FN" |  |
| fn:seeking | /r/RelatedTo | fn:scrutiny | "seeking" | "scrutiny" | "/r/related to" |  | "FN" |  |
| fn:scrutiny | /r/SimilarTo | fn:seeking | "scrutiny" | "seeking" | "/r/similar to" |  | "FN" |  |
| fn:seeking | /r/SimilarTo | fn:scrutiny | "seeking" | "scrutiny" | "/r/similar to" |  | "FN" |  |
| fn:seeking | /r/IsA | fn:searching_scenario | "seeking" | "searching scenario" | "/r/is a" |  | "FN" |  |
| fn:seeking | fn:HasLexicalUnit | fn:lu:seeking:sniff | "seeking" | "sniff" | "has lexical unit" |  | "FN" |  |
| fn:seeking | fn:HasLexicalUnit | fn:lu:seeking:listen | "seeking" | "listen" | "has lexical unit" |  | "FN" |  |
| fn:seeking | fn:HasLexicalUnit | fn:lu:seeking:watch | "seeking" | "watch" | "has lexical unit" |  | "FN" |  |
| fn:seeking | fn:HasLexicalUnit | fn:lu:seeking:grope | "seeking" | "grope" | "has lexical unit" |  | "FN" |  |
| fn:seeking | fn:HasLexicalUnit | fn:lu:seeking:fumble | "seeking" | "fumble" | "has lexical unit" |  | "FN" |  |
| fn:seeking | fn:HasLexicalUnit | fn:lu:seeking:feel | "seeking" | "feel" | "has lexical unit" |  | "FN" |  |
| fn:seeking | fn:HasLexicalUnit | fn:lu:seeking:forage | "seeking" | "forage" | "has lexical unit" |  | "FN" |  |
| fn:seeking | fn:HasLexicalUnit | fn:lu:seeking:hunt | "seeking" | "hunt" | "has lexical unit" |  | "FN" |  |
| fn:seeking | fn:HasLexicalUnit | fn:lu:seeking:nose | "seeking" | "nose" | "has lexical unit" |  | "FN" |  |
| fn:seeking | fn:HasLexicalUnit | fn:lu:seeking:pan | "seeking" | "pan" | "has lexical unit" |  | "FN" |  |
| fn:seeking | fn:HasLexicalUnit | fn:lu:seeking:pat_down | "seeking" | "pat down" | "has lexical unit" |  | "FN" |  |
| fn:seeking | fn:HasLexicalUnit | fn:lu:seeking:seek | "seeking" | "seek" | "has lexical unit" |  | "FN" |  |
| fn:seeking | fn:HasLexicalUnit | fn:lu:seeking:palpate | "seeking" | "palpate" | "has lexical unit" |  | "FN" |  |
| fn:seeking | fn:HasLexicalUnit | fn:lu:seeking:manhunt | "seeking" | "manhunt" | "has lexical unit" |  | "FN" |  |
| fn:seeking | fn:HasLexicalUnit | fn:lu:seeking:dig | "seeking" | "dig" | "has lexical unit" |  | "FN" |  |
| fn:fe:cognizer_agent | /r/IsA | fn:st:sentient | "cognizer agent" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:seeking | /r/HasA | fn:fe:cognizer_agent | "seeking" | "cognizer agent" | "/r/has a" |  | "FN" |  |
| fn:seeking | /r/HasA | fn:fe:ground | "seeking" | "ground" | "/r/has a" |  | "FN" |  |
| fn:seeking | /r/HasA | fn:fe:sought_entity | "seeking" | "sought entity" | "/r/has a" |  | "FN" |  |
| fn:seeking | /r/HasA | fn:fe:manner | "seeking" | "manner" | "/r/has a" |  | "FN" |  |
| fn:seeking | /r/HasA | fn:fe:means | "seeking" | "means" | "/r/has a" |  | "FN" |  |
| fn:seeking | /r/HasA | fn:fe:outcome | "seeking" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:seeking | /r/HasA | fn:fe:place | "seeking" | "place" | "/r/has a" |  | "FN" |  |
| fn:seeking | /r/HasA | fn:fe:time | "seeking" | "time" | "/r/has a" |  | "FN" |  |
| fn:seeking | /r/HasA | fn:fe:purpose | "seeking" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:seeking | /r/HasA | fn:fe:degree | "seeking" | "degree" | "/r/has a" |  | "FN" |  |
| fn:seeking | /r/IsA | fn:seeking_to_achieve | "seeking" | "seeking to achieve" | "/r/is a" |  | "FN" |  |
| fn:seeking_to_achieve | /r/IsA | fn:work | "seeking to achieve" | "work" | "/r/is a" |  | "FN" |  |
| fn:seeking_to_achieve | fn:HasLexicalUnit | fn:lu:seeking_to_achieve:seek | "seeking to achieve" | "seek" | "has lexical unit" |  | "FN" |  |
| fn:seeking_to_achieve | fn:HasLexicalUnit | fn:lu:seeking_to_achieve:pursue | "seeking to achieve" | "pursue" | "has lexical unit" |  | "FN" |  |
| fn:seeking_to_achieve | fn:HasLexicalUnit | fn:lu:seeking_to_achieve:pursuit | "seeking to achieve" | "pursuit" | "has lexical unit" |  | "FN" |  |
| fn:seeking_to_achieve | /r/HasA | fn:fe:agent | "seeking to achieve" | "agent" | "/r/has a" |  | "FN" |  |
| fn:fe:sought_entity | /r/IsA | fn:st:goal | "sought entity" | "goal" | "/r/is a" |  | "FN" |  |
| fn:fe:sought_entity | /r/RelatedTo | fn:fe:state_of_affairs | "sought entity" | "state of affairs" | "/r/related to" |  | "FN" |  |
| fn:seeking_to_achieve | /r/HasA | fn:fe:sought_entity | "seeking to achieve" | "sought entity" | "/r/has a" |  | "FN" |  |
| fn:seeking_to_achieve | /r/HasA | fn:fe:outcome | "seeking to achieve" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:seeking_to_achieve | /r/HasA | fn:fe:means | "seeking to achieve" | "means" | "/r/has a" |  | "FN" |  |
| fn:seeking_to_achieve | /r/HasA | fn:fe:degree | "seeking to achieve" | "degree" | "/r/has a" |  | "FN" |  |
| fn:seeking_to_achieve | /r/HasA | fn:fe:time | "seeking to achieve" | "time" | "/r/has a" |  | "FN" |  |
| fn:seeking_to_achieve | /r/HasA | fn:fe:depictive | "seeking to achieve" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:seeking_to_achieve | /r/HasA | fn:fe:place | "seeking to achieve" | "place" | "/r/has a" |  | "FN" |  |
| fn:seeking_to_achieve | /r/HasA | fn:fe:manner | "seeking to achieve" | "manner" | "/r/has a" |  | "FN" |  |
| fn:seeking_to_achieve | /r/HasA | fn:fe:duration | "seeking to achieve" | "duration" | "/r/has a" |  | "FN" |  |
| fn:seeking_to_achieve | /r/HasA | fn:fe:purpose | "seeking to achieve" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:seeking_to_achieve | /r/HasA | fn:fe:state_of_affairs | "seeking to achieve" | "state of affairs" | "/r/has a" |  | "FN" |  |
| fn:seeking_to_achieve | /r/HasA | fn:fe:explanation | "seeking to achieve" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:seeking_to_achieve | /r/HasA | fn:fe:source | "seeking to achieve" | "source" | "/r/has a" |  | "FN" |  |
| fn:seeking_to_achieve | /r/HasA | fn:fe:circumstances | "seeking to achieve" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:seeking_to_achieve | /r/HasA | fn:fe:beneficiary | "seeking to achieve" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:self_control | /r/IsA | fn:preventing_or_letting | "self control" | "preventing or letting" | "/r/is a" |  | "FN" |  |
| fn:self_control | fn:HasLexicalUnit | fn:lu:self_control:(can't)_help | "self control" | "(can\\'t) help" | "has lexical unit" |  | "FN" |  |
| fn:self_control | fn:HasLexicalUnit | fn:lu:self_control:hold_back | "self control" | "hold back" | "has lexical unit" |  | "FN" |  |
| fn:self_control | fn:HasLexicalUnit | fn:lu:self_control:refrain | "self control" | "refrain" | "has lexical unit" |  | "FN" |  |
| fn:self_control | fn:HasLexicalUnit | fn:lu:self_control:repress | "self control" | "repress" | "has lexical unit" |  | "FN" |  |
| fn:self_control | fn:HasLexicalUnit | fn:lu:self_control:repression | "self control" | "repression" | "has lexical unit" |  | "FN" |  |
| fn:self_control | fn:HasLexicalUnit | fn:lu:self_control:resist | "self control" | "resist" | "has lexical unit" |  | "FN" |  |
| fn:self_control | fn:HasLexicalUnit | fn:lu:self_control:resistance | "self control" | "resistance" | "has lexical unit" |  | "FN" |  |
| fn:self_control | fn:HasLexicalUnit | fn:lu:self_control:resistant | "self control" | "resistant" | "has lexical unit" |  | "FN" |  |
| fn:self_control | fn:HasLexicalUnit | fn:lu:self_control:restrain | "self control" | "restrain" | "has lexical unit" |  | "FN" |  |
| fn:self_control | fn:HasLexicalUnit | fn:lu:self_control:restraint | "self control" | "restraint" | "has lexical unit" |  | "FN" |  |
| fn:self_control | fn:HasLexicalUnit | fn:lu:self_control:suppress | "self control" | "suppress" | "has lexical unit" |  | "FN" |  |
| fn:self_control | fn:HasLexicalUnit | fn:lu:self_control:suppression | "self control" | "suppression" | "has lexical unit" |  | "FN" |  |
| fn:self_control | /r/HasA | fn:fe:agent | "self control" | "agent" | "/r/has a" |  | "FN" |  |
| fn:self_control | /r/HasA | fn:fe:event | "self control" | "event" | "/r/has a" |  | "FN" |  |
| fn:self_control | /r/HasA | fn:fe:degree | "self control" | "degree" | "/r/has a" |  | "FN" |  |
| fn:self_control | /r/HasA | fn:fe:place | "self control" | "place" | "/r/has a" |  | "FN" |  |
| fn:self_control | /r/HasA | fn:fe:time | "self control" | "time" | "/r/has a" |  | "FN" |  |
| fn:self_motion | /r/IsA | fn:intentionally_act | "self motion" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:self_motion | /r/IsA | fn:motion | "self motion" | "motion" | "/r/is a" |  | "FN" |  |
| fn:cotheme | /r/IsA | fn:self_motion | "cotheme" | "self motion" | "/r/is a" |  | "FN" |  |
| fn:fleeing | /r/IsA | fn:self_motion | "fleeing" | "self motion" | "/r/is a" |  | "FN" |  |
| fn:intentional_traversing | /r/IsA | fn:self_motion | "intentional traversing" | "self motion" | "/r/is a" |  | "FN" |  |
| fn:travel | /r/IsA | fn:self_motion | "travel" | "self motion" | "/r/is a" |  | "FN" |  |
| fn:self_motion | /r/HasSubevent | fn:quitting_a_place | "self motion" | "quitting a place" | "/r/has subevent" |  | "FN" |  |
| fn:motion | /r/RelatedTo | fn:self_motion | "motion" | "self motion" | "/r/related to" |  | "FN" |  |
| fn:operate_vehicle | /r/SimilarTo | fn:self_motion | "operate vehicle" | "self motion" | "/r/similar to" |  | "FN" |  |
| fn:self_motion | /r/SimilarTo | fn:body_movement | "self motion" | "body movement" | "/r/similar to" |  | "FN" |  |
| fn:self_motion | /r/SimilarTo | fn:escaping | "self motion" | "escaping" | "/r/similar to" |  | "FN" |  |
| fn:self_motion | /r/SimilarTo | fn:fleeing | "self motion" | "fleeing" | "/r/similar to" |  | "FN" |  |
| fn:self_motion | /r/SimilarTo | fn:ride_vehicle | "self motion" | "ride vehicle" | "/r/similar to" |  | "FN" |  |
| fn:traversing | /r/SimilarTo | fn:self_motion | "traversing" | "self motion" | "/r/similar to" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:amble | "self motion" | "amble" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:back | "self motion" | "back" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:barge | "self motion" | "barge" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:bop | "self motion" | "bop" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:bound | "self motion" | "bound" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:burrow | "self motion" | "burrow" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:bustle | "self motion" | "bustle" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:canter | "self motion" | "canter" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:caper | "self motion" | "caper" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:clamber | "self motion" | "clamber" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:climb | "self motion" | "climb" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:clomp | "self motion" | "clomp" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:crawl | "self motion" | "crawl" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:creep | "self motion" | "creep" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:dance | "self motion" | "dance" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:dart | "self motion" | "dart" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:dash | "self motion" | "dash" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:dash | "self motion" | "dash" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:flit | "self motion" | "flit" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:flounce | "self motion" | "flounce" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:frolic | "self motion" | "frolic" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:gallivant | "self motion" | "gallivant" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:gambol | "self motion" | "gambol" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:hasten | "self motion" | "hasten" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:hike | "self motion" | "hike" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:hike | "self motion" | "hike" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:hitchhike | "self motion" | "hitchhike" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:hobble | "self motion" | "hobble" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:hop | "self motion" | "hop" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:hurry | "self motion" | "hurry" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:jaunt | "self motion" | "jaunt" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:jog | "self motion" | "jog" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:jump | "self motion" | "jump" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:leap | "self motion" | "leap" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:limp | "self motion" | "limp" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:lope | "self motion" | "lope" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:lumber | "self motion" | "lumber" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:lunge | "self motion" | "lunge" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:lurch | "self motion" | "lurch" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:march | "self motion" | "march" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:march | "self motion" | "march" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:meander | "self motion" | "meander" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:mince | "self motion" | "mince" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:mosey | "self motion" | "mosey" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:pace | "self motion" | "pace" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:pad | "self motion" | "pad" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:parade | "self motion" | "parade" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:plod | "self motion" | "plod" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:pounce | "self motion" | "pounce" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:prance | "self motion" | "prance" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:promenade | "self motion" | "promenade" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:prowl | "self motion" | "prowl" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:roam | "self motion" | "roam" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:romp | "self motion" | "romp" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:run | "self motion" | "run" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:rush | "self motion" | "rush" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:sashay | "self motion" | "sashay" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:saunter | "self motion" | "saunter" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:scamper | "self motion" | "scamper" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:scoot | "self motion" | "scoot" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:scramble | "self motion" | "scramble" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:scramble | "self motion" | "scramble" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:scurry | "self motion" | "scurry" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:scuttle | "self motion" | "scuttle" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:shuffle | "self motion" | "shuffle" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:shuffle | "self motion" | "shuffle" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:skip | "self motion" | "skip" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:skulk | "self motion" | "skulk" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:slalom | "self motion" | "slalom" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:sleepwalk | "self motion" | "sleepwalk" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:slink | "self motion" | "slink" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:slither | "self motion" | "slither" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:slog | "self motion" | "slog" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:slog | "self motion" | "slog" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:sneak | "self motion" | "sneak" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:spring | "self motion" | "spring" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:sprint | "self motion" | "sprint" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:sprint | "self motion" | "sprint" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:stagger | "self motion" | "stagger" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:steal | "self motion" | "steal" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:step | "self motion" | "step" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:step | "self motion" | "step" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:stomp | "self motion" | "stomp" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:straggle | "self motion" | "straggle" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:stride | "self motion" | "stride" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:stroll | "self motion" | "stroll" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:stroll | "self motion" | "stroll" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:strut | "self motion" | "strut" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:stumble | "self motion" | "stumble" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:swagger | "self motion" | "swagger" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:swim | "self motion" | "swim" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:swim | "self motion" | "swim" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:tiptoe | "self motion" | "tiptoe" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:toddle | "self motion" | "toddle" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:totter | "self motion" | "totter" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:traipse | "self motion" | "traipse" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:tramp | "self motion" | "tramp" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:tread | "self motion" | "tread" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:trek | "self motion" | "trek" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:trip | "self motion" | "trip" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:troop | "self motion" | "troop" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:trot | "self motion" | "trot" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:trudge | "self motion" | "trudge" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:trundle | "self motion" | "trundle" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:vault | "self motion" | "vault" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:waddle | "self motion" | "waddle" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:wade | "self motion" | "wade" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:walk | "self motion" | "walk" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:waltz | "self motion" | "waltz" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:wander | "self motion" | "wander" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:wriggle | "self motion" | "wriggle" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:slosh | "self motion" | "slosh" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:slop | "self motion" | "slop" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:skim | "self motion" | "skim" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:goose-step | "self motion" | "goose-step" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:crawl | "self motion" | "crawl" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:proceed | "self motion" | "proceed" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:sidle | "self motion" | "sidle" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:fly | "self motion" | "fly" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:head | "self motion" | "head" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:repair | "self motion" | "repair" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:make | "self motion" | "make" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:stalk | "self motion" | "stalk" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:venture | "self motion" | "venture" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:storm | "self motion" | "storm" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:make_a_beeline | "self motion" | "make a beeline" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:walk | "self motion" | "walk" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:drive | "self motion" | "drive" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:sail | "self motion" | "sail" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:coast | "self motion" | "coast" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:cruise | "self motion" | "cruise" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:tack | "self motion" | "tack" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:taxi | "self motion" | "taxi" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:shoulder | "self motion" | "shoulder" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:nance | "self motion" | "nance" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:swing | "self motion" | "swing" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:edge | "self motion" | "edge" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:rove | "self motion" | "rove" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:way | "self motion" | "way" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:advance | "self motion" | "advance" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:file | "self motion" | "file" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:take_to_the_air | "self motion" | "take to the air" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:rip | "self motion" | "rip" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:slouch | "self motion" | "slouch" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:slip | "self motion" | "slip" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:enroute | "self motion" | "enroute" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:press | "self motion" | "press" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:shrink | "self motion" | "shrink" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:en_route | "self motion" | "en route" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:ramble | "self motion" | "ramble" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:whisk | "self motion" | "whisk" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | fn:HasLexicalUnit | fn:lu:self_motion:hiker | "self motion" | "hiker" | "has lexical unit" |  | "FN" |  |
| fn:self_motion | /r/HasA | fn:fe:self_mover | "self motion" | "self mover" | "/r/has a" |  | "FN" |  |
| fn:self_motion | /r/HasA | fn:fe:source | "self motion" | "source" | "/r/has a" |  | "FN" |  |
| fn:self_motion | /r/HasA | fn:fe:path | "self motion" | "path" | "/r/has a" |  | "FN" |  |
| fn:self_motion | /r/HasA | fn:fe:goal | "self motion" | "goal" | "/r/has a" |  | "FN" |  |
| fn:self_motion | /r/HasA | fn:fe:manner | "self motion" | "manner" | "/r/has a" |  | "FN" |  |
| fn:self_motion | /r/HasA | fn:fe:distance | "self motion" | "distance" | "/r/has a" |  | "FN" |  |
| fn:self_motion | /r/HasA | fn:fe:area | "self motion" | "area" | "/r/has a" |  | "FN" |  |
| fn:self_motion | /r/HasA | fn:fe:time | "self motion" | "time" | "/r/has a" |  | "FN" |  |
| fn:self_motion | /r/HasA | fn:fe:cotheme | "self motion" | "cotheme" | "/r/has a" |  | "FN" |  |
| fn:self_motion | /r/HasA | fn:fe:speed | "self motion" | "speed" | "/r/has a" |  | "FN" |  |
| fn:self_motion | /r/HasA | fn:fe:depictive | "self motion" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:self_motion | /r/HasA | fn:fe:means | "self motion" | "means" | "/r/has a" |  | "FN" |  |
| fn:self_motion | /r/HasA | fn:fe:result | "self motion" | "result" | "/r/has a" |  | "FN" |  |
| fn:self_motion | /r/HasA | fn:fe:internal_cause | "self motion" | "internal cause" | "/r/has a" |  | "FN" |  |
| fn:self_motion | /r/HasA | fn:fe:duration | "self motion" | "duration" | "/r/has a" |  | "FN" |  |
| fn:self_motion | /r/HasA | fn:fe:purpose | "self motion" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:self_motion | /r/HasA | fn:fe:place | "self motion" | "place" | "/r/has a" |  | "FN" |  |
| fn:self_motion | /r/HasA | fn:fe:explanation | "self motion" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:self_motion | /r/HasA | fn:fe:external_cause | "self motion" | "external cause" | "/r/has a" |  | "FN" |  |
| fn:self_motion | /r/HasA | fn:fe:direction | "self motion" | "direction" | "/r/has a" |  | "FN" |  |
| fn:self_motion | /r/HasA | fn:fe:coordinated_event | "self motion" | "coordinated event" | "/r/has a" |  | "FN" |  |
| fn:self_motion | /r/HasA | fn:fe:path_shape | "self motion" | "path shape" | "/r/has a" |  | "FN" |  |
| fn:self_motion | /r/HasA | fn:fe:concessive | "self motion" | "concessive" | "/r/has a" |  | "FN" |  |
| fn:bringing | /r/UsedFor | fn:sending | "bringing" | "sending" | "/r/used for" |  | "FN" |  |
| fn:sending | /r/UsedFor | fn:delivery | "sending" | "delivery" | "/r/used for" |  | "FN" |  |
| fn:sending | /r/UsedFor | fn:sent_items | "sending" | "sent items" | "/r/used for" |  | "FN" |  |
| fn:bringing | /r/RelatedTo | fn:sending | "bringing" | "sending" | "/r/related to" |  | "FN" |  |
| fn:communication_means | /r/SimilarTo | fn:sending | "communication means" | "sending" | "/r/similar to" |  | "FN" |  |
| fn:sending | fn:HasLexicalUnit | fn:lu:sending:send | "sending" | "send" | "has lexical unit" |  | "FN" |  |
| fn:sending | fn:HasLexicalUnit | fn:lu:sending:mail | "sending" | "mail" | "has lexical unit" |  | "FN" |  |
| fn:sending | fn:HasLexicalUnit | fn:lu:sending:ship | "sending" | "ship" | "has lexical unit" |  | "FN" |  |
| fn:sending | fn:HasLexicalUnit | fn:lu:sending:post | "sending" | "post" | "has lexical unit" |  | "FN" |  |
| fn:sending | fn:HasLexicalUnit | fn:lu:sending:export | "sending" | "export" | "has lexical unit" |  | "FN" |  |
| fn:sending | fn:HasLexicalUnit | fn:lu:sending:forward | "sending" | "forward" | "has lexical unit" |  | "FN" |  |
| fn:sending | fn:HasLexicalUnit | fn:lu:sending:route | "sending" | "route" | "has lexical unit" |  | "FN" |  |
| fn:sending | fn:HasLexicalUnit | fn:lu:sending:dispatch | "sending" | "dispatch" | "has lexical unit" |  | "FN" |  |
| fn:sending | fn:HasLexicalUnit | fn:lu:sending:fax | "sending" | "fax" | "has lexical unit" |  | "FN" |  |
| fn:sending | fn:HasLexicalUnit | fn:lu:sending:telex | "sending" | "telex" | "has lexical unit" |  | "FN" |  |
| fn:sending | fn:HasLexicalUnit | fn:lu:sending:shipment_[items] | "sending" | "shipment [items]" | "has lexical unit" |  | "FN" |  |
| fn:sending | fn:HasLexicalUnit | fn:lu:sending:shipment_[act] | "sending" | "shipment [act]" | "has lexical unit" |  | "FN" |  |
| fn:sending | fn:HasLexicalUnit | fn:lu:sending:express | "sending" | "express" | "has lexical unit" |  | "FN" |  |
| fn:sending | fn:HasLexicalUnit | fn:lu:sending:barge | "sending" | "barge" | "has lexical unit" |  | "FN" |  |
| fn:sending | fn:HasLexicalUnit | fn:lu:sending:wire | "sending" | "wire" | "has lexical unit" |  | "FN" |  |
| fn:sending | fn:HasLexicalUnit | fn:lu:sending:refer | "sending" | "refer" | "has lexical unit" |  | "FN" |  |
| fn:sending | fn:HasLexicalUnit | fn:lu:sending:shipping | "sending" | "shipping" | "has lexical unit" |  | "FN" |  |
| fn:sending | /r/HasA | fn:fe:sender | "sending" | "sender" | "/r/has a" |  | "FN" |  |
| fn:sending | /r/HasA | fn:fe:path | "sending" | "path" | "/r/has a" |  | "FN" |  |
| fn:sending | /r/HasA | fn:fe:goal | "sending" | "goal" | "/r/has a" |  | "FN" |  |
| fn:sending | /r/HasA | fn:fe:source | "sending" | "source" | "/r/has a" |  | "FN" |  |
| fn:sending | /r/HasA | fn:fe:theme | "sending" | "theme" | "/r/has a" |  | "FN" |  |
| fn:sending | /r/HasA | fn:fe:transport_means | "sending" | "transport means" | "/r/has a" |  | "FN" |  |
| fn:sending | /r/HasA | fn:fe:degree | "sending" | "degree" | "/r/has a" |  | "FN" |  |
| fn:sending | /r/HasA | fn:fe:depictive | "sending" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:sending | /r/HasA | fn:fe:distance | "sending" | "distance" | "/r/has a" |  | "FN" |  |
| fn:sending | /r/HasA | fn:fe:manner | "sending" | "manner" | "/r/has a" |  | "FN" |  |
| fn:sending | /r/HasA | fn:fe:recipient | "sending" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:sending | /r/HasA | fn:fe:purpose | "sending" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:sending | /r/HasA | fn:fe:explanation | "sending" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:sending | /r/HasA | fn:fe:time | "sending" | "time" | "/r/has a" |  | "FN" |  |
| fn:sending | /r/HasA | fn:fe:cotheme | "sending" | "cotheme" | "/r/has a" |  | "FN" |  |
| fn:sending | /r/HasA | fn:fe:container | "sending" | "container" | "/r/has a" |  | "FN" |  |
| fn:sending | /r/HasA | fn:fe:place | "sending" | "place" | "/r/has a" |  | "FN" |  |
| fn:sensation | /r/IsA | fn:perception | "sensation" | "perception" | "/r/is a" |  | "FN" |  |
| fn:sensation | fn:HasLexicalUnit | fn:lu:sensation:aroma | "sensation" | "aroma" | "has lexical unit" |  | "FN" |  |
| fn:sensation | fn:HasLexicalUnit | fn:lu:sensation:bouquet | "sensation" | "bouquet" | "has lexical unit" |  | "FN" |  |
| fn:sensation | fn:HasLexicalUnit | fn:lu:sensation:feel | "sensation" | "feel" | "has lexical unit" |  | "FN" |  |
| fn:sensation | fn:HasLexicalUnit | fn:lu:sensation:feeling | "sensation" | "feeling" | "has lexical unit" |  | "FN" |  |
| fn:sensation | fn:HasLexicalUnit | fn:lu:sensation:flavour | "sensation" | "flavour" | "has lexical unit" |  | "FN" |  |
| fn:sensation | fn:HasLexicalUnit | fn:lu:sensation:fragrance | "sensation" | "fragrance" | "has lexical unit" |  | "FN" |  |
| fn:sensation | fn:HasLexicalUnit | fn:lu:sensation:incense | "sensation" | "incense" | "has lexical unit" |  | "FN" |  |
| fn:sensation | fn:HasLexicalUnit | fn:lu:sensation:noise | "sensation" | "noise" | "has lexical unit" |  | "FN" |  |
| fn:sensation | fn:HasLexicalUnit | fn:lu:sensation:odor | "sensation" | "odor" | "has lexical unit" |  | "FN" |  |
| fn:sensation | fn:HasLexicalUnit | fn:lu:sensation:perception | "sensation" | "perception" | "has lexical unit" |  | "FN" |  |
| fn:sensation | fn:HasLexicalUnit | fn:lu:sensation:perfume | "sensation" | "perfume" | "has lexical unit" |  | "FN" |  |
| fn:sensation | fn:HasLexicalUnit | fn:lu:sensation:reek | "sensation" | "reek" | "has lexical unit" |  | "FN" |  |
| fn:sensation | fn:HasLexicalUnit | fn:lu:sensation:savour | "sensation" | "savour" | "has lexical unit" |  | "FN" |  |
| fn:sensation | fn:HasLexicalUnit | fn:lu:sensation:scent | "sensation" | "scent" | "has lexical unit" |  | "FN" |  |
| fn:sensation | fn:HasLexicalUnit | fn:lu:sensation:sensation | "sensation" | "sensation" | "has lexical unit" |  | "FN" |  |
| fn:sensation | fn:HasLexicalUnit | fn:lu:sensation:sense | "sensation" | "sense" | "has lexical unit" |  | "FN" |  |
| fn:sensation | fn:HasLexicalUnit | fn:lu:sensation:sight | "sensation" | "sight" | "has lexical unit" |  | "FN" |  |
| fn:sensation | fn:HasLexicalUnit | fn:lu:sensation:smell | "sensation" | "smell" | "has lexical unit" |  | "FN" |  |
| fn:sensation | fn:HasLexicalUnit | fn:lu:sensation:sound | "sensation" | "sound" | "has lexical unit" |  | "FN" |  |
| fn:sensation | fn:HasLexicalUnit | fn:lu:sensation:stink | "sensation" | "stink" | "has lexical unit" |  | "FN" |  |
| fn:sensation | fn:HasLexicalUnit | fn:lu:sensation:taste | "sensation" | "taste" | "has lexical unit" |  | "FN" |  |
| fn:sensation | fn:HasLexicalUnit | fn:lu:sensation:whiff | "sensation" | "whiff" | "has lexical unit" |  | "FN" |  |
| fn:sensation | fn:HasLexicalUnit | fn:lu:sensation:scene | "sensation" | "scene" | "has lexical unit" |  | "FN" |  |
| fn:sensation | fn:HasLexicalUnit | fn:lu:sensation:image | "sensation" | "image" | "has lexical unit" |  | "FN" |  |
| fn:sensation | /r/HasA | fn:fe:perceiver_passive | "sensation" | "perceiver passive" | "/r/has a" |  | "FN" |  |
| fn:sensation | /r/HasA | fn:fe:source | "sensation" | "source" | "/r/has a" |  | "FN" |  |
| fn:sensation | /r/HasA | fn:fe:percept | "sensation" | "percept" | "/r/has a" |  | "FN" |  |
| fn:sensation | /r/HasA | fn:fe:body_part | "sensation" | "body part" | "/r/has a" |  | "FN" |  |
| fn:fe:descriptor | /r/IsA | fn:st:manner | "descriptor" | "manner" | "/r/is a" |  | "FN" |  |
| fn:sensation | /r/HasA | fn:fe:descriptor | "sensation" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:sensation | /r/HasA | fn:fe:ground | "sensation" | "ground" | "/r/has a" |  | "FN" |  |
| fn:sensation | /r/HasA | fn:fe:time | "sensation" | "time" | "/r/has a" |  | "FN" |  |
| fn:sensation | /r/HasA | fn:fe:degree | "sensation" | "degree" | "/r/has a" |  | "FN" |  |
| fn:sending | /r/UsedFor | fn:sent_items | "sending" | "sent items" | "/r/used for" |  | "FN" |  |
| fn:sent_items | fn:HasLexicalUnit | fn:lu:sent_items:mail | "sent items" | "mail" | "has lexical unit" |  | "FN" |  |
| fn:sent_items | fn:HasLexicalUnit | fn:lu:sent_items:post | "sent items" | "post" | "has lexical unit" |  | "FN" |  |
| fn:sent_items | fn:HasLexicalUnit | fn:lu:sent_items:shipment | "sent items" | "shipment" | "has lexical unit" |  | "FN" |  |
| fn:sent_items | /r/HasA | fn:fe:sender | "sent items" | "sender" | "/r/has a" |  | "FN" |  |
| fn:sent_items | /r/HasA | fn:fe:goal | "sent items" | "goal" | "/r/has a" |  | "FN" |  |
| fn:sent_items | /r/HasA | fn:fe:source | "sent items" | "source" | "/r/has a" |  | "FN" |  |
| fn:sent_items | /r/HasA | fn:fe:sent_item | "sent items" | "sent item" | "/r/has a" |  | "FN" |  |
| fn:sent_items | /r/HasA | fn:fe:transport_means | "sent items" | "transport means" | "/r/has a" |  | "FN" |  |
| fn:sent_items | /r/HasA | fn:fe:recipient | "sent items" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:sent_items | /r/HasA | fn:fe:time | "sent items" | "time" | "/r/has a" |  | "FN" |  |
| fn:sent_items | /r/HasA | fn:fe:place | "sent items" | "place" | "/r/has a" |  | "FN" |  |
| fn:sent_items | /r/HasA | fn:fe:descriptor | "sent items" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:criminal_process | /r/HasSubevent | fn:sentencing | "criminal process" | "sentencing" | "/r/has subevent" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:sentencing | "communication" | "sentencing" | "/r/used for" |  | "FN" |  |
| fn:sentencing | /r/HasPrerequisite | fn:trial | "sentencing" | "trial" | "/r/has prerequisite" |  | "FN" |  |
| fn:sentencing | fn:HasLexicalUnit | fn:lu:sentencing:sentence | "sentencing" | "sentence" | "has lexical unit" |  | "FN" |  |
| fn:sentencing | fn:HasLexicalUnit | fn:lu:sentencing:sentence | "sentencing" | "sentence" | "has lexical unit" |  | "FN" |  |
| fn:sentencing | fn:HasLexicalUnit | fn:lu:sentencing:order | "sentencing" | "order" | "has lexical unit" |  | "FN" |  |
| fn:sentencing | fn:HasLexicalUnit | fn:lu:sentencing:send_up | "sentencing" | "send up" | "has lexical unit" |  | "FN" |  |
| fn:sentencing | fn:HasLexicalUnit | fn:lu:sentencing:condemn | "sentencing" | "condemn" | "has lexical unit" |  | "FN" |  |
| fn:sentencing | /r/HasA | fn:fe:convict | "sentencing" | "convict" | "/r/has a" |  | "FN" |  |
| fn:sentencing | /r/HasA | fn:fe:court | "sentencing" | "court" | "/r/has a" |  | "FN" |  |
| fn:fe:sentence | /r/RelatedTo | fn:fe:term_of_sentence | "sentence" | "term of sentence" | "/r/related to" |  | "FN" |  |
| fn:sentencing | /r/HasA | fn:fe:sentence | "sentencing" | "sentence" | "/r/has a" |  | "FN" |  |
| fn:sentencing | /r/HasA | fn:fe:type | "sentencing" | "type" | "/r/has a" |  | "FN" |  |
| fn:sentencing | /r/HasA | fn:fe:term_of_sentence | "sentencing" | "term of sentence" | "/r/has a" |  | "FN" |  |
| fn:sentencing | /r/HasA | fn:fe:time | "sentencing" | "time" | "/r/has a" |  | "FN" |  |
| fn:sentencing | /r/HasA | fn:fe:offense | "sentencing" | "offense" | "/r/has a" |  | "FN" |  |
| fn:sentencing | /r/HasA | fn:fe:place | "sentencing" | "place" | "/r/has a" |  | "FN" |  |
| fn:sentencing | /r/HasA | fn:fe:depictive | "sentencing" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:separating | /r/IsA | fn:intentionally_affect | "separating" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:separating | /r/Causes | fn:becoming_separated | "separating" | "becoming separated" | "/r/causes" |  | "FN" |  |
| fn:separating | fn:HasLexicalUnit | fn:lu:separating:bisect | "separating" | "bisect" | "has lexical unit" |  | "FN" |  |
| fn:separating | fn:HasLexicalUnit | fn:lu:separating:divide | "separating" | "divide" | "has lexical unit" |  | "FN" |  |
| fn:separating | fn:HasLexicalUnit | fn:lu:separating:part | "separating" | "part" | "has lexical unit" |  | "FN" |  |
| fn:separating | fn:HasLexicalUnit | fn:lu:separating:partition | "separating" | "partition" | "has lexical unit" |  | "FN" |  |
| fn:separating | fn:HasLexicalUnit | fn:lu:separating:section | "separating" | "section" | "has lexical unit" |  | "FN" |  |
| fn:separating | fn:HasLexicalUnit | fn:lu:separating:segment | "separating" | "segment" | "has lexical unit" |  | "FN" |  |
| fn:separating | fn:HasLexicalUnit | fn:lu:separating:segregate | "separating" | "segregate" | "has lexical unit" |  | "FN" |  |
| fn:separating | fn:HasLexicalUnit | fn:lu:separating:separate | "separating" | "separate" | "has lexical unit" |  | "FN" |  |
| fn:separating | fn:HasLexicalUnit | fn:lu:separating:split | "separating" | "split" | "has lexical unit" |  | "FN" |  |
| fn:separating | fn:HasLexicalUnit | fn:lu:separating:partition | "separating" | "partition" | "has lexical unit" |  | "FN" |  |
| fn:separating | fn:HasLexicalUnit | fn:lu:separating:sever | "separating" | "sever" | "has lexical unit" |  | "FN" |  |
| fn:fe:whole | /r/HasPrerequisite | fn:fe:parts | "whole" | "parts" | "/r/has prerequisite" |  | "FN" |  |
| fn:separating | /r/HasA | fn:fe:whole | "separating" | "whole" | "/r/has a" |  | "FN" |  |
| fn:fe:parts | /r/HasPrerequisite | fn:fe:whole | "parts" | "whole" | "/r/has prerequisite" |  | "FN" |  |
| fn:separating | /r/HasA | fn:fe:parts | "separating" | "parts" | "/r/has a" |  | "FN" |  |
| fn:separating | /r/HasA | fn:fe:part_1 | "separating" | "part 1" | "/r/has a" |  | "FN" |  |
| fn:separating | /r/HasA | fn:fe:part_2 | "separating" | "part 2" | "/r/has a" |  | "FN" |  |
| fn:separating | /r/HasA | fn:fe:agent | "separating" | "agent" | "/r/has a" |  | "FN" |  |
| fn:separating | /r/HasA | fn:fe:criterion | "separating" | "criterion" | "/r/has a" |  | "FN" |  |
| fn:separating | /r/HasA | fn:fe:depictive | "separating" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:separating | /r/HasA | fn:fe:manner | "separating" | "manner" | "/r/has a" |  | "FN" |  |
| fn:separating | /r/HasA | fn:fe:degree | "separating" | "degree" | "/r/has a" |  | "FN" |  |
| fn:separating | /r/HasA | fn:fe:means | "separating" | "means" | "/r/has a" |  | "FN" |  |
| fn:separating | /r/HasA | fn:fe:result | "separating" | "result" | "/r/has a" |  | "FN" |  |
| fn:separating | /r/HasA | fn:fe:cause | "separating" | "cause" | "/r/has a" |  | "FN" |  |
| fn:separating | /r/HasA | fn:fe:recipients | "separating" | "recipients" | "/r/has a" |  | "FN" |  |
| fn:separating | /r/HasA | fn:fe:time | "separating" | "time" | "/r/has a" |  | "FN" |  |
| fn:separating | /r/HasA | fn:fe:place | "separating" | "place" | "/r/has a" |  | "FN" |  |
| fn:separating | /r/HasA | fn:fe:instrument | "separating" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:separating | /r/HasA | fn:fe:purpose | "separating" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:sequence | /r/IsA | fn:relation | "sequence" | "relation" | "/r/is a" |  | "FN" |  |
| fn:sequence | fn:HasLexicalUnit | fn:lu:sequence:sequence | "sequence" | "sequence" | "has lexical unit" |  | "FN" |  |
| fn:sequence | fn:HasLexicalUnit | fn:lu:sequence:succession | "sequence" | "succession" | "has lexical unit" |  | "FN" |  |
| fn:sequence | fn:HasLexicalUnit | fn:lu:sequence:series | "sequence" | "series" | "has lexical unit" |  | "FN" |  |
| fn:sequence | fn:HasLexicalUnit | fn:lu:sequence:sequential | "sequence" | "sequential" | "has lexical unit" |  | "FN" |  |
| fn:sequence | fn:HasLexicalUnit | fn:lu:sequence:successive | "sequence" | "successive" | "has lexical unit" |  | "FN" |  |
| fn:sequence | fn:HasLexicalUnit | fn:lu:sequence:order | "sequence" | "order" | "has lexical unit" |  | "FN" |  |
| fn:sequence | /r/HasA | fn:fe:entity_1 | "sequence" | "entity 1" | "/r/has a" |  | "FN" |  |
| fn:sequence | /r/HasA | fn:fe:entity_2 | "sequence" | "entity 2" | "/r/has a" |  | "FN" |  |
| fn:sequence | /r/HasA | fn:fe:entities | "sequence" | "entities" | "/r/has a" |  | "FN" |  |
| fn:sequence | /r/HasA | fn:fe:relation_type | "sequence" | "relation type" | "/r/has a" |  | "FN" |  |
| fn:sequence | /r/HasA | fn:fe:descriptor | "sequence" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:serving_in_capacity | fn:HasLexicalUnit | fn:lu:serving_in_capacity:serve | "serving in capacity" | "serve" | "has lexical unit" |  | "FN" |  |
| fn:serving_in_capacity | /r/HasA | fn:fe:agent | "serving in capacity" | "agent" | "/r/has a" |  | "FN" |  |
| fn:serving_in_capacity | /r/HasA | fn:fe:role | "serving in capacity" | "role" | "/r/has a" |  | "FN" |  |
| fn:serving_in_capacity | /r/HasA | fn:fe:duration | "serving in capacity" | "duration" | "/r/has a" |  | "FN" |  |
| fn:serving_in_capacity | /r/HasA | fn:fe:descriptor | "serving in capacity" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:serving_in_capacity | /r/HasA | fn:fe:time | "serving in capacity" | "time" | "/r/has a" |  | "FN" |  |
| fn:serving_in_capacity | /r/HasA | fn:fe:place | "serving in capacity" | "place" | "/r/has a" |  | "FN" |  |
| fn:system | /r/IsA | fn:set_of_interrelated_entities | "system" | "set of interrelated entities" | "/r/is a" |  | "FN" |  |
| fn:set_of_interrelated_entities | /r/UsedFor | fn:network | "set of interrelated entities" | "network" | "/r/used for" |  | "FN" |  |
| fn:set_of_interrelated_entities | fn:HasLexicalUnit | fn:lu:set_of_interrelated_entities:system | "set of interrelated entities" | "system" | "has lexical unit" |  | "FN" |  |
| fn:set_of_interrelated_entities | /r/HasA | fn:fe:component_entities | "set of interrelated entities" | "component entities" | "/r/has a" |  | "FN" |  |
| fn:set_of_interrelated_entities | /r/HasA | fn:fe:complex | "set of interrelated entities" | "complex" | "/r/has a" |  | "FN" |  |
| fn:set_of_interrelated_entities | /r/HasA | fn:fe:descriptor | "set of interrelated entities" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:set_of_interrelated_entities | /r/HasA | fn:fe:possessor | "set of interrelated entities" | "possessor" | "/r/has a" |  | "FN" |  |
| fn:set_relation | /r/IsA | fn:inclusion_scenario | "set relation" | "inclusion scenario" | "/r/is a" |  | "FN" |  |
| fn:be_subset_of | /r/IsA | fn:set_relation | "be subset of" | "set relation" | "/r/is a" |  | "FN" |  |
| fn:set_relation | /r/HasA | fn:fe:superset | "set relation" | "superset" | "/r/has a" |  | "FN" |  |
| fn:set_relation | /r/HasA | fn:fe:subset | "set relation" | "subset" | "/r/has a" |  | "FN" |  |
| fn:set_relation | /r/HasA | fn:fe:manner | "set relation" | "manner" | "/r/has a" |  | "FN" |  |
| fn:set_relation | /r/HasA | fn:fe:time | "set relation" | "time" | "/r/has a" |  | "FN" |  |
| fn:set_relation | /r/HasA | fn:fe:place | "set relation" | "place" | "/r/has a" |  | "FN" |  |
| fn:setting_back_burn | /r/IsA | fn:setting_fire | "setting back burn" | "setting fire" | "/r/is a" |  | "FN" |  |
| fn:setting_back_burn | fn:HasLexicalUnit | fn:lu:setting_back_burn:backfire | "setting back burn" | "backfire" | "has lexical unit" |  | "FN" |  |
| fn:setting_back_burn | /r/HasA | fn:fe:firefighter | "setting back burn" | "firefighter" | "/r/has a" |  | "FN" |  |
| fn:setting_back_burn | /r/HasA | fn:fe:flame | "setting back burn" | "flame" | "/r/has a" |  | "FN" |  |
| fn:setting_back_burn | /r/HasA | fn:fe:flammables | "setting back burn" | "flammables" | "/r/has a" |  | "FN" |  |
| fn:setting_back_burn | /r/HasA | fn:fe:time | "setting back burn" | "time" | "/r/has a" |  | "FN" |  |
| fn:setting_back_burn | /r/HasA | fn:fe:place | "setting back burn" | "place" | "/r/has a" |  | "FN" |  |
| fn:setting_back_burn | /r/HasA | fn:fe:manner | "setting back burn" | "manner" | "/r/has a" |  | "FN" |  |
| fn:setting_back_burn | /r/HasA | fn:fe:means | "setting back burn" | "means" | "/r/has a" |  | "FN" |  |
| fn:setting_back_burn | /r/HasA | fn:fe:explanation | "setting back burn" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:setting_back_burn | /r/HasA | fn:fe:containing_event | "setting back burn" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:setting_back_burn | /r/HasA | fn:fe:depictive | "setting back burn" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:setting_back_burn | /r/IsA | fn:setting_fire | "setting back burn" | "setting fire" | "/r/is a" |  | "FN" |  |
| fn:setting_fire | /r/IsA | fn:transitive_action | "setting fire" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:setting_fire | /r/UsedFor | fn:arson | "setting fire" | "arson" | "/r/used for" |  | "FN" |  |
| fn:setting_fire | /r/UsedFor | fn:cause_to_burn | "setting fire" | "cause to burn" | "/r/used for" |  | "FN" |  |
| fn:setting_fire | /r/SimilarTo | fn:catching_fire | "setting fire" | "catching fire" | "/r/similar to" |  | "FN" |  |
| fn:fire_burning | /r/HasPrerequisite | fn:setting_fire | "fire burning" | "setting fire" | "/r/has prerequisite" |  | "FN" |  |
| fn:setting_fire | fn:HasLexicalUnit | fn:lu:setting_fire:light | "setting fire" | "light" | "has lexical unit" |  | "FN" |  |
| fn:setting_fire | fn:HasLexicalUnit | fn:lu:setting_fire:ignite | "setting fire" | "ignite" | "has lexical unit" |  | "FN" |  |
| fn:setting_fire | fn:HasLexicalUnit | fn:lu:setting_fire:kindle | "setting fire" | "kindle" | "has lexical unit" |  | "FN" |  |
| fn:setting_fire | fn:HasLexicalUnit | fn:lu:setting_fire:spark | "setting fire" | "spark" | "has lexical unit" |  | "FN" |  |
| fn:setting_fire | fn:HasLexicalUnit | fn:lu:setting_fire:set_on_fire | "setting fire" | "set on fire" | "has lexical unit" |  | "FN" |  |
| fn:setting_fire | fn:HasLexicalUnit | fn:lu:setting_fire:catch_on_fire | "setting fire" | "catch on fire" | "has lexical unit" |  | "FN" |  |
| fn:setting_fire | fn:HasLexicalUnit | fn:lu:setting_fire:set_fire | "setting fire" | "set fire" | "has lexical unit" |  | "FN" |  |
| fn:setting_fire | fn:HasLexicalUnit | fn:lu:setting_fire:set_ablaze | "setting fire" | "set ablaze" | "has lexical unit" |  | "FN" |  |
| fn:setting_fire | fn:HasLexicalUnit | fn:lu:setting_fire:set_alight | "setting fire" | "set alight" | "has lexical unit" |  | "FN" |  |
| fn:fe:kindler | /r/IsA | fn:st:sentient | "kindler" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:fe:kindler | /r/RelatedTo | fn:fe:cause | "kindler" | "cause" | "/r/related to" |  | "FN" |  |
| fn:setting_fire | /r/HasA | fn:fe:kindler | "setting fire" | "kindler" | "/r/has a" |  | "FN" |  |
| fn:setting_fire | /r/HasA | fn:fe:flame | "setting fire" | "flame" | "/r/has a" |  | "FN" |  |
| fn:setting_fire | /r/HasA | fn:fe:flammables | "setting fire" | "flammables" | "/r/has a" |  | "FN" |  |
| fn:setting_fire | /r/HasA | fn:fe:cause | "setting fire" | "cause" | "/r/has a" |  | "FN" |  |
| fn:setting_fire | /r/HasA | fn:fe:time | "setting fire" | "time" | "/r/has a" |  | "FN" |  |
| fn:setting_fire | /r/HasA | fn:fe:place | "setting fire" | "place" | "/r/has a" |  | "FN" |  |
| fn:setting_fire | /r/HasA | fn:fe:manner | "setting fire" | "manner" | "/r/has a" |  | "FN" |  |
| fn:setting_fire | /r/HasA | fn:fe:means | "setting fire" | "means" | "/r/has a" |  | "FN" |  |
| fn:setting_fire | /r/HasA | fn:fe:explanation | "setting fire" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:setting_fire | /r/HasA | fn:fe:containing_event | "setting fire" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:setting_fire | /r/HasA | fn:fe:depictive | "setting fire" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:setting_out | /r/IsA | fn:quitting_a_place | "setting out" | "quitting a place" | "/r/is a" |  | "FN" |  |
| fn:travel | /r/HasSubevent | fn:setting_out | "travel" | "setting out" | "/r/has subevent" |  | "FN" |  |
| fn:departing | /r/SimilarTo | fn:setting_out | "departing" | "setting out" | "/r/similar to" |  | "FN" |  |
| fn:setting_out | fn:HasLexicalUnit | fn:lu:setting_out:set_off | "setting out" | "set off" | "has lexical unit" |  | "FN" |  |
| fn:setting_out | fn:HasLexicalUnit | fn:lu:setting_out:set_out | "setting out" | "set out" | "has lexical unit" |  | "FN" |  |
| fn:setting_out | fn:HasLexicalUnit | fn:lu:setting_out:decamp | "setting out" | "decamp" | "has lexical unit" |  | "FN" |  |
| fn:setting_out | /r/HasA | fn:fe:self_mover | "setting out" | "self mover" | "/r/has a" |  | "FN" |  |
| fn:setting_out | /r/HasA | fn:fe:source | "setting out" | "source" | "/r/has a" |  | "FN" |  |
| fn:setting_out | /r/HasA | fn:fe:path | "setting out" | "path" | "/r/has a" |  | "FN" |  |
| fn:setting_out | /r/HasA | fn:fe:intended_goal | "setting out" | "intended goal" | "/r/has a" |  | "FN" |  |
| fn:setting_out | /r/HasA | fn:fe:manner | "setting out" | "manner" | "/r/has a" |  | "FN" |  |
| fn:setting_out | /r/HasA | fn:fe:means | "setting out" | "means" | "/r/has a" |  | "FN" |  |
| fn:setting_out | /r/HasA | fn:fe:speed | "setting out" | "speed" | "/r/has a" |  | "FN" |  |
| fn:setting_out | /r/HasA | fn:fe:cotheme | "setting out" | "cotheme" | "/r/has a" |  | "FN" |  |
| fn:setting_out | /r/HasA | fn:fe:depictive | "setting out" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:setting_out | /r/HasA | fn:fe:place | "setting out" | "place" | "/r/has a" |  | "FN" |  |
| fn:setting_out | /r/HasA | fn:fe:path_shape | "setting out" | "path shape" | "/r/has a" |  | "FN" |  |
| fn:setting_out | /r/HasA | fn:fe:direction | "setting out" | "direction" | "/r/has a" |  | "FN" |  |
| fn:setting_out | /r/HasA | fn:fe:time | "setting out" | "time" | "/r/has a" |  | "FN" |  |
| fn:setting_out | /r/HasA | fn:fe:purpose | "setting out" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:setting_out | /r/HasA | fn:fe:vehicle | "setting out" | "vehicle" | "/r/has a" |  | "FN" |  |
| fn:setting_out | /r/HasA | fn:fe:duration_of_final_state | "setting out" | "duration of final state" | "/r/has a" |  | "FN" |  |
| fn:setting_out | /r/HasA | fn:fe:result | "setting out" | "result" | "/r/has a" |  | "FN" |  |
| fn:setting_out | /r/HasA | fn:fe:explanation | "setting out" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:setting_out | /r/HasA | fn:fe:reciprocation | "setting out" | "reciprocation" | "/r/has a" |  | "FN" |  |
| fn:setting_out | /r/HasA | fn:fe:containing_event | "setting out" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:setting_out | /r/HasA | fn:fe:frequency | "setting out" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:setting_out | /r/HasA | fn:fe:re-encoding | "setting out" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:setting_out | /r/HasA | fn:fe:new_situation | "setting out" | "new situation" | "/r/has a" |  | "FN" |  |
| fn:setting_out | /r/HasA | fn:fe:circumstances | "setting out" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:setting_out | /r/HasA | fn:fe:coordinated_event | "setting out" | "coordinated event" | "/r/has a" |  | "FN" |  |
| fn:setting_out | /r/HasA | fn:fe:distance | "setting out" | "distance" | "/r/has a" |  | "FN" |  |
| fn:offenses | /r/UsedFor | fn:severity_of_offense | "offenses" | "severity of offense" | "/r/used for" |  | "FN" |  |
| fn:severity_of_offense | fn:HasLexicalUnit | fn:lu:severity_of_offense:actionable | "severity of offense" | "actionable" | "has lexical unit" |  | "FN" |  |
| fn:severity_of_offense | fn:HasLexicalUnit | fn:lu:severity_of_offense:capital | "severity of offense" | "capital" | "has lexical unit" |  | "FN" |  |
| fn:severity_of_offense | fn:HasLexicalUnit | fn:lu:severity_of_offense:indictable | "severity of offense" | "indictable" | "has lexical unit" |  | "FN" |  |
| fn:severity_of_offense | fn:HasLexicalUnit | fn:lu:severity_of_offense:felonious | "severity of offense" | "felonious" | "has lexical unit" |  | "FN" |  |
| fn:severity_of_offense | /r/HasA | fn:fe:offense | "severity of offense" | "offense" | "/r/has a" |  | "FN" |  |
| fn:severity_of_offense | /r/HasA | fn:fe:code | "severity of offense" | "code" | "/r/has a" |  | "FN" |  |
| fn:procreative_sex | /r/IsA | fn:sex | "procreative sex" | "sex" | "/r/is a" |  | "FN" |  |
| fn:sex | fn:HasLexicalUnit | fn:lu:sex:do | "sex" | "do" | "has lexical unit" |  | "FN" |  |
| fn:sex | fn:HasLexicalUnit | fn:lu:sex:shag | "sex" | "shag" | "has lexical unit" |  | "FN" |  |
| fn:sex | fn:HasLexicalUnit | fn:lu:sex:mate | "sex" | "mate" | "has lexical unit" |  | "FN" |  |
| fn:sex | fn:HasLexicalUnit | fn:lu:sex:bang | "sex" | "bang" | "has lexical unit" |  | "FN" |  |
| fn:sex | fn:HasLexicalUnit | fn:lu:sex:lay | "sex" | "lay" | "has lexical unit" |  | "FN" |  |
| fn:sex | fn:HasLexicalUnit | fn:lu:sex:bump_uglies | "sex" | "bump uglies" | "has lexical unit" |  | "FN" |  |
| fn:sex | fn:HasLexicalUnit | fn:lu:sex:knock_boots | "sex" | "knock boots" | "has lexical unit" |  | "FN" |  |
| fn:sex | fn:HasLexicalUnit | fn:lu:sex:bone | "sex" | "bone" | "has lexical unit" |  | "FN" |  |
| fn:sex | fn:HasLexicalUnit | fn:lu:sex:slam | "sex" | "slam" | "has lexical unit" |  | "FN" |  |
| fn:sex | fn:HasLexicalUnit | fn:lu:sex:intercourse | "sex" | "intercourse" | "has lexical unit" |  | "FN" |  |
| fn:sex | fn:HasLexicalUnit | fn:lu:sex:copulate | "sex" | "copulate" | "has lexical unit" |  | "FN" |  |
| fn:sex | fn:HasLexicalUnit | fn:lu:sex:make_love | "sex" | "make love" | "has lexical unit" |  | "FN" |  |
| fn:sex | fn:HasLexicalUnit | fn:lu:sex:make_whoopee | "sex" | "make whoopee" | "has lexical unit" |  | "FN" |  |
| fn:sex | fn:HasLexicalUnit | fn:lu:sex:pork | "sex" | "pork" | "has lexical unit" |  | "FN" |  |
| fn:sex | fn:HasLexicalUnit | fn:lu:sex:fuck | "sex" | "fuck" | "has lexical unit" |  | "FN" |  |
| fn:sex | fn:HasLexicalUnit | fn:lu:sex:do_it | "sex" | "do it" | "has lexical unit" |  | "FN" |  |
| fn:sex | fn:HasLexicalUnit | fn:lu:sex:take | "sex" | "take" | "has lexical unit" |  | "FN" |  |
| fn:sex | fn:HasLexicalUnit | fn:lu:sex:sex | "sex" | "sex" | "has lexical unit" |  | "FN" |  |
| fn:sex | fn:HasLexicalUnit | fn:lu:sex:bed | "sex" | "bed" | "has lexical unit" |  | "FN" |  |
| fn:sex | fn:HasLexicalUnit | fn:lu:sex:have | "sex" | "have" | "has lexical unit" |  | "FN" |  |
| fn:sex | fn:HasLexicalUnit | fn:lu:sex:give | "sex" | "give" | "has lexical unit" |  | "FN" |  |
| fn:sex | fn:HasLexicalUnit | fn:lu:sex:quickie | "sex" | "quickie" | "has lexical unit" |  | "FN" |  |
| fn:sex | fn:HasLexicalUnit | fn:lu:sex:jump_(someone's)_bones | "sex" | "jump (someone\\'s) bones" | "has lexical unit" |  | "FN" |  |
| fn:sex | fn:HasLexicalUnit | fn:lu:sex:jump | "sex" | "jump" | "has lexical unit" |  | "FN" |  |
| fn:sex | fn:HasLexicalUnit | fn:lu:sex:go_at_it | "sex" | "go at it" | "has lexical unit" |  | "FN" |  |
| fn:sex | /r/HasA | fn:fe:participants | "sex" | "participants" | "/r/has a" |  | "FN" |  |
| fn:sex | /r/HasA | fn:fe:participant_1 | "sex" | "participant 1" | "/r/has a" |  | "FN" |  |
| fn:sex | /r/HasA | fn:fe:participant_2 | "sex" | "participant 2" | "/r/has a" |  | "FN" |  |
| fn:sex | /r/HasA | fn:fe:duration | "sex" | "duration" | "/r/has a" |  | "FN" |  |
| fn:sex | /r/HasA | fn:fe:manner | "sex" | "manner" | "/r/has a" |  | "FN" |  |
| fn:sex | /r/HasA | fn:fe:place | "sex" | "place" | "/r/has a" |  | "FN" |  |
| fn:sex | /r/HasA | fn:fe:time | "sex" | "time" | "/r/has a" |  | "FN" |  |
| fn:sex | /r/HasA | fn:fe:domain | "sex" | "domain" | "/r/has a" |  | "FN" |  |
| fn:sex | /r/HasA | fn:fe:purpose | "sex" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:sex | /r/HasA | fn:fe:means | "sex" | "means" | "/r/has a" |  | "FN" |  |
| fn:sexual_reproduction_scenario | /r/HasSubevent | fn:birth_scenario | "sexual reproduction scenario" | "birth scenario" | "/r/has subevent" |  | "FN" |  |
| fn:sexual_reproduction_scenario | /r/HasSubevent | fn:procreative_sex | "sexual reproduction scenario" | "procreative sex" | "/r/has subevent" |  | "FN" |  |
| fn:sexual_reproduction_scenario | /r/HasA | fn:fe:parents | "sexual reproduction scenario" | "parents" | "/r/has a" |  | "FN" |  |
| fn:sexual_reproduction_scenario | /r/HasA | fn:fe:father | "sexual reproduction scenario" | "father" | "/r/has a" |  | "FN" |  |
| fn:sexual_reproduction_scenario | /r/HasA | fn:fe:mother | "sexual reproduction scenario" | "mother" | "/r/has a" |  | "FN" |  |
| fn:sexual_reproduction_scenario | /r/HasA | fn:fe:offspring | "sexual reproduction scenario" | "offspring" | "/r/has a" |  | "FN" |  |
| fn:shaped_part | /r/IsA | fn:part_whole | "shaped part" | "part whole" | "/r/is a" |  | "FN" |  |
| fn:architectural_part | /r/IsA | fn:shaped_part | "architectural part" | "shaped part" | "/r/is a" |  | "FN" |  |
| fn:body_parts | /r/IsA | fn:shaped_part | "body parts" | "shaped part" | "/r/is a" |  | "FN" |  |
| fn:shaped_part | fn:HasLexicalUnit | fn:lu:shaped_part:arm | "shaped part" | "arm" | "has lexical unit" |  | "FN" |  |
| fn:shaped_part | fn:HasLexicalUnit | fn:lu:shaped_part:mouth | "shaped part" | "mouth" | "has lexical unit" |  | "FN" |  |
| fn:shaped_part | fn:HasLexicalUnit | fn:lu:shaped_part:leg | "shaped part" | "leg" | "has lexical unit" |  | "FN" |  |
| fn:shaped_part | fn:HasLexicalUnit | fn:lu:shaped_part:rind | "shaped part" | "rind" | "has lexical unit" |  | "FN" |  |
| fn:shaped_part | fn:HasLexicalUnit | fn:lu:shaped_part:brim | "shaped part" | "brim" | "has lexical unit" |  | "FN" |  |
| fn:shaped_part | fn:HasLexicalUnit | fn:lu:shaped_part:handle | "shaped part" | "handle" | "has lexical unit" |  | "FN" |  |
| fn:shaped_part | /r/HasA | fn:fe:part | "shaped part" | "part" | "/r/has a" |  | "FN" |  |
| fn:shaped_part | /r/HasA | fn:fe:whole | "shaped part" | "whole" | "/r/has a" |  | "FN" |  |
| fn:shaped_part | /r/HasA | fn:fe:part_prop | "shaped part" | "part prop" | "/r/has a" |  | "FN" |  |
| fn:shaped_part | /r/HasA | fn:fe:orientation | "shaped part" | "orientation" | "/r/has a" |  | "FN" |  |
| fn:bounded_entity | /r/UsedFor | fn:shapes | "bounded entity" | "shapes" | "/r/used for" |  | "FN" |  |
| fn:go_into_shape | /r/Causes | fn:shapes | "go into shape" | "shapes" | "/r/causes" |  | "FN" |  |
| fn:shapes | fn:HasLexicalUnit | fn:lu:shapes:square | "shapes" | "square" | "has lexical unit" |  | "FN" |  |
| fn:shapes | fn:HasLexicalUnit | fn:lu:shapes:sheet | "shapes" | "sheet" | "has lexical unit" |  | "FN" |  |
| fn:shapes | fn:HasLexicalUnit | fn:lu:shapes:coil | "shapes" | "coil" | "has lexical unit" |  | "FN" |  |
| fn:shapes | fn:HasLexicalUnit | fn:lu:shapes:cube | "shapes" | "cube" | "has lexical unit" |  | "FN" |  |
| fn:shapes | fn:HasLexicalUnit | fn:lu:shapes:stick | "shapes" | "stick" | "has lexical unit" |  | "FN" |  |
| fn:shapes | fn:HasLexicalUnit | fn:lu:shapes:strip | "shapes" | "strip" | "has lexical unit" |  | "FN" |  |
| fn:shapes | fn:HasLexicalUnit | fn:lu:shapes:stretch | "shapes" | "stretch" | "has lexical unit" |  | "FN" |  |
| fn:shapes | fn:HasLexicalUnit | fn:lu:shapes:ribbon | "shapes" | "ribbon" | "has lexical unit" |  | "FN" |  |
| fn:shapes | fn:HasLexicalUnit | fn:lu:shapes:expanse | "shapes" | "expanse" | "has lexical unit" |  | "FN" |  |
| fn:shapes | fn:HasLexicalUnit | fn:lu:shapes:circle | "shapes" | "circle" | "has lexical unit" |  | "FN" |  |
| fn:shapes | fn:HasLexicalUnit | fn:lu:shapes:ball | "shapes" | "ball" | "has lexical unit" |  | "FN" |  |
| fn:shapes | fn:HasLexicalUnit | fn:lu:shapes:length | "shapes" | "length" | "has lexical unit" |  | "FN" |  |
| fn:shapes | fn:HasLexicalUnit | fn:lu:shapes:shape | "shapes" | "shape" | "has lexical unit" |  | "FN" |  |
| fn:shapes | fn:HasLexicalUnit | fn:lu:shapes:curve | "shapes" | "curve" | "has lexical unit" |  | "FN" |  |
| fn:shapes | fn:HasLexicalUnit | fn:lu:shapes:circular | "shapes" | "circular" | "has lexical unit" |  | "FN" |  |
| fn:shapes | fn:HasLexicalUnit | fn:lu:shapes:line | "shapes" | "line" | "has lexical unit" |  | "FN" |  |
| fn:shapes | fn:HasLexicalUnit | fn:lu:shapes:row | "shapes" | "row" | "has lexical unit" |  | "FN" |  |
| fn:shapes | fn:HasLexicalUnit | fn:lu:shapes:triangle | "shapes" | "triangle" | "has lexical unit" |  | "FN" |  |
| fn:shapes | fn:HasLexicalUnit | fn:lu:shapes:wedge | "shapes" | "wedge" | "has lexical unit" |  | "FN" |  |
| fn:shapes | fn:HasLexicalUnit | fn:lu:shapes:v | "shapes" | "v" | "has lexical unit" |  | "FN" |  |
| fn:shapes | fn:HasLexicalUnit | fn:lu:shapes:oval | "shapes" | "oval" | "has lexical unit" |  | "FN" |  |
| fn:shapes | fn:HasLexicalUnit | fn:lu:shapes:round | "shapes" | "round" | "has lexical unit" |  | "FN" |  |
| fn:shapes | fn:HasLexicalUnit | fn:lu:shapes:ellipse | "shapes" | "ellipse" | "has lexical unit" |  | "FN" |  |
| fn:shapes | /r/HasA | fn:fe:substance | "shapes" | "substance" | "/r/has a" |  | "FN" |  |
| fn:shapes | /r/HasA | fn:fe:shape | "shapes" | "shape" | "/r/has a" |  | "FN" |  |
| fn:shapes | /r/HasA | fn:fe:shape_prop | "shapes" | "shape prop" | "/r/has a" |  | "FN" |  |
| fn:shapes | /r/HasA | fn:fe:count | "shapes" | "count" | "/r/has a" |  | "FN" |  |
| fn:sharing | /r/IsA | fn:reciprocality | "sharing" | "reciprocality" | "/r/is a" |  | "FN" |  |
| fn:sharing | fn:HasLexicalUnit | fn:lu:sharing:share | "sharing" | "share" | "has lexical unit" |  | "FN" |  |
| fn:sharing | /r/HasA | fn:fe:protagonists | "sharing" | "protagonists" | "/r/has a" |  | "FN" |  |
| fn:sharing | /r/HasA | fn:fe:protagonist_1 | "sharing" | "protagonist 1" | "/r/has a" |  | "FN" |  |
| fn:sharing | /r/HasA | fn:fe:protagonist_2 | "sharing" | "protagonist 2" | "/r/has a" |  | "FN" |  |
| fn:sharing | /r/HasA | fn:fe:entity | "sharing" | "entity" | "/r/has a" |  | "FN" |  |
| fn:sharing | /r/HasA | fn:fe:time | "sharing" | "time" | "/r/has a" |  | "FN" |  |
| fn:sharing | /r/HasA | fn:fe:place | "sharing" | "place" | "/r/has a" |  | "FN" |  |
| fn:sharpness | /r/IsA | fn:gradable_attributes | "sharpness" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:sharpness | fn:HasLexicalUnit | fn:lu:sharpness:sharp | "sharpness" | "sharp" | "has lexical unit" |  | "FN" |  |
| fn:sharpness | fn:HasLexicalUnit | fn:lu:sharpness:dull | "sharpness" | "dull" | "has lexical unit" |  | "FN" |  |
| fn:sharpness | fn:HasLexicalUnit | fn:lu:sharpness:blunt | "sharpness" | "blunt" | "has lexical unit" |  | "FN" |  |
| fn:fe:entity | /r/IsA | fn:st:physical_entity | "entity" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:sharpness | /r/HasA | fn:fe:entity | "sharpness" | "entity" | "/r/has a" |  | "FN" |  |
| fn:sharpness | /r/HasA | fn:fe:attribute | "sharpness" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:sharpness | /r/HasA | fn:fe:degree | "sharpness" | "degree" | "/r/has a" |  | "FN" |  |
| fn:sharpness | /r/HasA | fn:fe:time | "sharpness" | "time" | "/r/has a" |  | "FN" |  |
| fn:sharpness | /r/HasA | fn:fe:circumstances | "sharpness" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:sharpness | /r/HasA | fn:fe:sharpness | "sharpness" | "sharpness" | "/r/has a" |  | "FN" |  |
| fn:shoot_projectiles | /r/IsA | fn:cause_motion | "shoot projectiles" | "cause motion" | "/r/is a" |  | "FN" |  |
| fn:shoot_projectiles | /r/UsedFor | fn:hit_target | "shoot projectiles" | "hit target" | "/r/used for" |  | "FN" |  |
| fn:use_firearm | /r/UsedFor | fn:shoot_projectiles | "use firearm" | "shoot projectiles" | "/r/used for" |  | "FN" |  |
| fn:shoot_projectiles | /r/IsA | fn:shooting_scenario | "shoot projectiles" | "shooting scenario" | "/r/is a" |  | "FN" |  |
| fn:shoot_projectiles | fn:HasLexicalUnit | fn:lu:shoot_projectiles:shoot | "shoot projectiles" | "shoot" | "has lexical unit" |  | "FN" |  |
| fn:shoot_projectiles | fn:HasLexicalUnit | fn:lu:shoot_projectiles:fire | "shoot projectiles" | "fire" | "has lexical unit" |  | "FN" |  |
| fn:shoot_projectiles | fn:HasLexicalUnit | fn:lu:shoot_projectiles:fire_off | "shoot projectiles" | "fire off" | "has lexical unit" |  | "FN" |  |
| fn:shoot_projectiles | fn:HasLexicalUnit | fn:lu:shoot_projectiles:launch | "shoot projectiles" | "launch" | "has lexical unit" |  | "FN" |  |
| fn:shoot_projectiles | fn:HasLexicalUnit | fn:lu:shoot_projectiles:launch | "shoot projectiles" | "launch" | "has lexical unit" |  | "FN" |  |
| fn:shoot_projectiles | fn:HasLexicalUnit | fn:lu:shoot_projectiles:fire | "shoot projectiles" | "fire" | "has lexical unit" |  | "FN" |  |
| fn:fe:firearm | /r/IsA | fn:st:physical_entity | "firearm" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:shoot_projectiles | /r/HasA | fn:fe:firearm | "shoot projectiles" | "firearm" | "/r/has a" |  | "FN" |  |
| fn:fe:projectile | /r/IsA | fn:st:physical_entity | "projectile" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:shoot_projectiles | /r/HasA | fn:fe:projectile | "shoot projectiles" | "projectile" | "/r/has a" |  | "FN" |  |
| fn:shoot_projectiles | /r/HasA | fn:fe:agent | "shoot projectiles" | "agent" | "/r/has a" |  | "FN" |  |
| fn:shoot_projectiles | /r/HasA | fn:fe:distance | "shoot projectiles" | "distance" | "/r/has a" |  | "FN" |  |
| fn:shoot_projectiles | /r/HasA | fn:fe:goal | "shoot projectiles" | "goal" | "/r/has a" |  | "FN" |  |
| fn:shoot_projectiles | /r/HasA | fn:fe:manner | "shoot projectiles" | "manner" | "/r/has a" |  | "FN" |  |
| fn:shoot_projectiles | /r/HasA | fn:fe:means | "shoot projectiles" | "means" | "/r/has a" |  | "FN" |  |
| fn:shoot_projectiles | /r/HasA | fn:fe:path | "shoot projectiles" | "path" | "/r/has a" |  | "FN" |  |
| fn:shoot_projectiles | /r/HasA | fn:fe:source | "shoot projectiles" | "source" | "/r/has a" |  | "FN" |  |
| fn:shoot_projectiles | /r/HasA | fn:fe:degree | "shoot projectiles" | "degree" | "/r/has a" |  | "FN" |  |
| fn:shoot_projectiles | /r/HasA | fn:fe:depictive | "shoot projectiles" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:shoot_projectiles | /r/HasA | fn:fe:area | "shoot projectiles" | "area" | "/r/has a" |  | "FN" |  |
| fn:shoot_projectiles | /r/HasA | fn:fe:place | "shoot projectiles" | "place" | "/r/has a" |  | "FN" |  |
| fn:shoot_projectiles | /r/HasA | fn:fe:time | "shoot projectiles" | "time" | "/r/has a" |  | "FN" |  |
| fn:shoot_projectiles | /r/HasA | fn:fe:purpose | "shoot projectiles" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:shooting_scenario | /r/IsA | fn:attempt_distant_interaction_scenario | "shooting scenario" | "attempt distant interaction scenario" | "/r/is a" |  | "FN" |  |
| fn:bearing_arms | /r/UsedFor | fn:shooting_scenario | "bearing arms" | "shooting scenario" | "/r/used for" |  | "FN" |  |
| fn:shooting_scenario | /r/UsedFor | fn:hit_target | "shooting scenario" | "hit target" | "/r/used for" |  | "FN" |  |
| fn:shoot_projectiles | /r/IsA | fn:shooting_scenario | "shoot projectiles" | "shooting scenario" | "/r/is a" |  | "FN" |  |
| fn:use_firearm | /r/IsA | fn:shooting_scenario | "use firearm" | "shooting scenario" | "/r/is a" |  | "FN" |  |
| fn:shooting_scenario | /r/HasA | fn:fe:firearm | "shooting scenario" | "firearm" | "/r/has a" |  | "FN" |  |
| fn:shooting_scenario | /r/HasA | fn:fe:projectile | "shooting scenario" | "projectile" | "/r/has a" |  | "FN" |  |
| fn:shooting_scenario | /r/HasA | fn:fe:agent | "shooting scenario" | "agent" | "/r/has a" |  | "FN" |  |
| fn:shooting_scenario | /r/HasA | fn:fe:distance | "shooting scenario" | "distance" | "/r/has a" |  | "FN" |  |
| fn:shooting_scenario | /r/HasA | fn:fe:goal | "shooting scenario" | "goal" | "/r/has a" |  | "FN" |  |
| fn:shooting_scenario | /r/HasA | fn:fe:manner | "shooting scenario" | "manner" | "/r/has a" |  | "FN" |  |
| fn:shooting_scenario | /r/HasA | fn:fe:means | "shooting scenario" | "means" | "/r/has a" |  | "FN" |  |
| fn:shooting_scenario | /r/HasA | fn:fe:path | "shooting scenario" | "path" | "/r/has a" |  | "FN" |  |
| fn:shooting_scenario | /r/HasA | fn:fe:source | "shooting scenario" | "source" | "/r/has a" |  | "FN" |  |
| fn:shooting_scenario | /r/HasA | fn:fe:degree | "shooting scenario" | "degree" | "/r/has a" |  | "FN" |  |
| fn:shooting_scenario | /r/HasA | fn:fe:depictive | "shooting scenario" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:shooting_scenario | /r/HasA | fn:fe:area | "shooting scenario" | "area" | "/r/has a" |  | "FN" |  |
| fn:shooting_scenario | /r/HasA | fn:fe:place | "shooting scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:shooting_scenario | /r/HasA | fn:fe:time | "shooting scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:shooting_scenario | /r/HasA | fn:fe:purpose | "shooting scenario" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:shopping | /r/IsA | fn:seeking | "shopping" | "seeking" | "/r/is a" |  | "FN" |  |
| fn:commerce_buy | /r/UsedFor | fn:shopping | "commerce buy" | "shopping" | "/r/used for" |  | "FN" |  |
| fn:shopping | fn:HasLexicalUnit | fn:lu:shopping:shopping | "shopping" | "shopping" | "has lexical unit" |  | "FN" |  |
| fn:shopping | fn:HasLexicalUnit | fn:lu:shopping:shop | "shopping" | "shop" | "has lexical unit" |  | "FN" |  |
| fn:fe:shopper | /r/IsA | fn:st:sentient | "shopper" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:shopping | /r/HasA | fn:fe:shopper | "shopping" | "shopper" | "/r/has a" |  | "FN" |  |
| fn:shopping | /r/HasA | fn:fe:ground | "shopping" | "ground" | "/r/has a" |  | "FN" |  |
| fn:fe:goods | /r/IsA | fn:st:goal | "goods" | "goal" | "/r/is a" |  | "FN" |  |
| fn:shopping | /r/HasA | fn:fe:goods | "shopping" | "goods" | "/r/has a" |  | "FN" |  |
| fn:shopping | /r/HasA | fn:fe:manner | "shopping" | "manner" | "/r/has a" |  | "FN" |  |
| fn:shopping | /r/HasA | fn:fe:means | "shopping" | "means" | "/r/has a" |  | "FN" |  |
| fn:shopping | /r/HasA | fn:fe:outcome | "shopping" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:shopping | /r/HasA | fn:fe:place | "shopping" | "place" | "/r/has a" |  | "FN" |  |
| fn:shopping | /r/HasA | fn:fe:time | "shopping" | "time" | "/r/has a" |  | "FN" |  |
| fn:shopping | /r/HasA | fn:fe:purpose | "shopping" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:shopping | /r/HasA | fn:fe:degree | "shopping" | "degree" | "/r/has a" |  | "FN" |  |
| fn:shopping | /r/HasA | fn:fe:depictive | "shopping" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:fe:co-participant | /r/IsA | fn:st:sentient | "co-participant" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:shopping | /r/HasA | fn:fe:co-participant | "shopping" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:short_selling | /r/IsA | fn:intentionally_affect | "short selling" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:short_selling | fn:HasLexicalUnit | fn:lu:short_selling:sell_short | "short selling" | "sell short" | "has lexical unit" |  | "FN" |  |
| fn:short_selling | /r/HasA | fn:fe:lender | "short selling" | "lender" | "/r/has a" |  | "FN" |  |
| fn:short_selling | /r/HasA | fn:fe:assets | "short selling" | "assets" | "/r/has a" |  | "FN" |  |
| fn:short_selling | /r/HasA | fn:fe:intermediary | "short selling" | "intermediary" | "/r/has a" |  | "FN" |  |
| fn:short_selling | /r/HasA | fn:fe:market | "short selling" | "market" | "/r/has a" |  | "FN" |  |
| fn:short_selling | /r/HasA | fn:fe:purpose | "short selling" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:short_selling | /r/HasA | fn:fe:time | "short selling" | "time" | "/r/has a" |  | "FN" |  |
| fn:short_selling | /r/HasA | fn:fe:place | "short selling" | "place" | "/r/has a" |  | "FN" |  |
| fn:short_selling | /r/HasA | fn:fe:manner | "short selling" | "manner" | "/r/has a" |  | "FN" |  |
| fn:short_selling | /r/HasA | fn:fe:means | "short selling" | "means" | "/r/has a" |  | "FN" |  |
| fn:motion_directional | /r/UsedFor | fn:sidereal_appearance | "motion directional" | "sidereal appearance" | "/r/used for" |  | "FN" |  |
| fn:sidereal_appearance | fn:HasLexicalUnit | fn:lu:sidereal_appearance:rise | "sidereal appearance" | "rise" | "has lexical unit" |  | "FN" |  |
| fn:sidereal_appearance | fn:HasLexicalUnit | fn:lu:sidereal_appearance:come_up | "sidereal appearance" | "come up" | "has lexical unit" |  | "FN" |  |
| fn:sidereal_appearance | fn:HasLexicalUnit | fn:lu:sidereal_appearance:rise | "sidereal appearance" | "rise" | "has lexical unit" |  | "FN" |  |
| fn:sidereal_appearance | /r/HasA | fn:fe:depictive | "sidereal appearance" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:sidereal_appearance | /r/HasA | fn:fe:goal | "sidereal appearance" | "goal" | "/r/has a" |  | "FN" |  |
| fn:sidereal_appearance | /r/HasA | fn:fe:manner | "sidereal appearance" | "manner" | "/r/has a" |  | "FN" |  |
| fn:sidereal_appearance | /r/HasA | fn:fe:path | "sidereal appearance" | "path" | "/r/has a" |  | "FN" |  |
| fn:sidereal_appearance | /r/HasA | fn:fe:speed | "sidereal appearance" | "speed" | "/r/has a" |  | "FN" |  |
| fn:sidereal_appearance | /r/HasA | fn:fe:time | "sidereal appearance" | "time" | "/r/has a" |  | "FN" |  |
| fn:sidereal_appearance | /r/HasA | fn:fe:astronomical_entity | "sidereal appearance" | "astronomical entity" | "/r/has a" |  | "FN" |  |
| fn:sidereal_appearance | /r/HasA | fn:fe:source | "sidereal appearance" | "source" | "/r/has a" |  | "FN" |  |
| fn:sidereal_appearance | /r/HasA | fn:fe:result | "sidereal appearance" | "result" | "/r/has a" |  | "FN" |  |
| fn:sidereal_appearance | /r/HasA | fn:fe:place | "sidereal appearance" | "place" | "/r/has a" |  | "FN" |  |
| fn:sidereal_appearance | /r/HasA | fn:fe:degree | "sidereal appearance" | "degree" | "/r/has a" |  | "FN" |  |
| fn:sidereal_appearance | /r/HasA | fn:fe:circumstances | "sidereal appearance" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:sidereal_appearance | /r/HasA | fn:fe:correlated_event | "sidereal appearance" | "correlated event" | "/r/has a" |  | "FN" |  |
| fn:sidereal_appearance | /r/HasA | fn:fe:frequency | "sidereal appearance" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:leaving_traces | /r/IsA | fn:sign | "leaving traces" | "sign" | "/r/is a" |  | "FN" |  |
| fn:omen | /r/IsA | fn:sign | "omen" | "sign" | "/r/is a" |  | "FN" |  |
| fn:evidence | /r/UsedFor | fn:sign | "evidence" | "sign" | "/r/used for" |  | "FN" |  |
| fn:sign | fn:HasLexicalUnit | fn:lu:sign:sign | "sign" | "sign" | "has lexical unit" |  | "FN" |  |
| fn:sign | fn:HasLexicalUnit | fn:lu:sign:indication | "sign" | "indication" | "has lexical unit" |  | "FN" |  |
| fn:sign | fn:HasLexicalUnit | fn:lu:sign:symptom | "sign" | "symptom" | "has lexical unit" |  | "FN" |  |
| fn:sign | fn:HasLexicalUnit | fn:lu:sign:symptomatic | "sign" | "symptomatic" | "has lexical unit" |  | "FN" |  |
| fn:sign | fn:HasLexicalUnit | fn:lu:sign:indicative | "sign" | "indicative" | "has lexical unit" |  | "FN" |  |
| fn:sign | fn:HasLexicalUnit | fn:lu:sign:indicate | "sign" | "indicate" | "has lexical unit" |  | "FN" |  |
| fn:sign | fn:HasLexicalUnit | fn:lu:sign:signify | "sign" | "signify" | "has lexical unit" |  | "FN" |  |
| fn:sign | fn:HasLexicalUnit | fn:lu:sign:mark | "sign" | "mark" | "has lexical unit" |  | "FN" |  |
| fn:sign | fn:HasLexicalUnit | fn:lu:sign:usher_in | "sign" | "usher in" | "has lexical unit" |  | "FN" |  |
| fn:sign | /r/HasA | fn:fe:indicator | "sign" | "indicator" | "/r/has a" |  | "FN" |  |
| fn:sign | /r/HasA | fn:fe:indicated | "sign" | "indicated" | "/r/has a" |  | "FN" |  |
| fn:fe:reliability | /r/IsA | fn:st:degree | "reliability" | "degree" | "/r/is a" |  | "FN" |  |
| fn:sign | /r/HasA | fn:fe:reliability | "sign" | "reliability" | "/r/has a" |  | "FN" |  |
| fn:sign | /r/HasA | fn:fe:descriptor | "sign" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:sign | /r/HasA | fn:fe:frequency | "sign" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:sign_agreement | /r/IsA | fn:text_creation | "sign agreement" | "text creation" | "/r/is a" |  | "FN" |  |
| fn:sign_agreement | fn:HasLexicalUnit | fn:lu:sign_agreement:sign | "sign agreement" | "sign" | "has lexical unit" |  | "FN" |  |
| fn:sign_agreement | fn:HasLexicalUnit | fn:lu:sign_agreement:signature | "sign agreement" | "signature" | "has lexical unit" |  | "FN" |  |
| fn:sign_agreement | fn:HasLexicalUnit | fn:lu:sign_agreement:signatory | "sign agreement" | "signatory" | "has lexical unit" |  | "FN" |  |
| fn:sign_agreement | fn:HasLexicalUnit | fn:lu:sign_agreement:accede | "sign agreement" | "accede" | "has lexical unit" |  | "FN" |  |
| fn:fe:signatory | /r/IsA | fn:st:sentient | "signatory" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:sign_agreement | /r/HasA | fn:fe:signatory | "sign agreement" | "signatory" | "/r/has a" |  | "FN" |  |
| fn:sign_agreement | /r/HasA | fn:fe:signature | "sign agreement" | "signature" | "/r/has a" |  | "FN" |  |
| fn:sign_agreement | /r/HasA | fn:fe:depictive | "sign agreement" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:sign_agreement | /r/HasA | fn:fe:instrument | "sign agreement" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:sign_agreement | /r/HasA | fn:fe:place | "sign agreement" | "place" | "/r/has a" |  | "FN" |  |
| fn:sign_agreement | /r/HasA | fn:fe:manner | "sign agreement" | "manner" | "/r/has a" |  | "FN" |  |
| fn:sign_agreement | /r/HasA | fn:fe:means | "sign agreement" | "means" | "/r/has a" |  | "FN" |  |
| fn:sign_agreement | /r/HasA | fn:fe:purpose | "sign agreement" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:sign_agreement | /r/HasA | fn:fe:time | "sign agreement" | "time" | "/r/has a" |  | "FN" |  |
| fn:sign_agreement | /r/HasA | fn:fe:explanation | "sign agreement" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:sign_agreement | /r/HasA | fn:fe:agreement | "sign agreement" | "agreement" | "/r/has a" |  | "FN" |  |
| fn:sign_agreement | /r/HasA | fn:fe:co-participant | "sign agreement" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:sign_agreement | /r/HasA | fn:fe:beneficiary | "sign agreement" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:sign_agreement | /r/HasA | fn:fe:role | "sign agreement" | "role" | "/r/has a" |  | "FN" |  |
| fn:silencing | /r/IsA | fn:intentionally_affect | "silencing" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:silencing | /r/SimilarTo | fn:becoming_silent | "silencing" | "becoming silent" | "/r/similar to" |  | "FN" |  |
| fn:silencing | /r/Causes | fn:becoming_silent | "silencing" | "becoming silent" | "/r/causes" |  | "FN" |  |
| fn:silencing | fn:HasLexicalUnit | fn:lu:silencing:silence | "silencing" | "silence" | "has lexical unit" |  | "FN" |  |
| fn:silencing | fn:HasLexicalUnit | fn:lu:silencing:shush | "silencing" | "shush" | "has lexical unit" |  | "FN" |  |
| fn:silencing | fn:HasLexicalUnit | fn:lu:silencing:hush | "silencing" | "hush" | "has lexical unit" |  | "FN" |  |
| fn:silencing | fn:HasLexicalUnit | fn:lu:silencing:hush_up | "silencing" | "hush up" | "has lexical unit" |  | "FN" |  |
| fn:silencing | fn:HasLexicalUnit | fn:lu:silencing:shut_up | "silencing" | "shut up" | "has lexical unit" |  | "FN" |  |
| fn:silencing | fn:HasLexicalUnit | fn:lu:silencing:quiet | "silencing" | "quiet" | "has lexical unit" |  | "FN" |  |
| fn:silencing | fn:HasLexicalUnit | fn:lu:silencing:quiet_down | "silencing" | "quiet down" | "has lexical unit" |  | "FN" |  |
| fn:silencing | /r/HasA | fn:fe:agent | "silencing" | "agent" | "/r/has a" |  | "FN" |  |
| fn:silencing | /r/HasA | fn:fe:instrument | "silencing" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:silencing | /r/HasA | fn:fe:place | "silencing" | "place" | "/r/has a" |  | "FN" |  |
| fn:silencing | /r/HasA | fn:fe:purpose | "silencing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:silencing | /r/HasA | fn:fe:time | "silencing" | "time" | "/r/has a" |  | "FN" |  |
| fn:silencing | /r/HasA | fn:fe:means | "silencing" | "means" | "/r/has a" |  | "FN" |  |
| fn:silencing | /r/HasA | fn:fe:speaker | "silencing" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:silencing | /r/HasA | fn:fe:topic | "silencing" | "topic" | "/r/has a" |  | "FN" |  |
| fn:silencing | /r/HasA | fn:fe:explanation | "silencing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:silencing | /r/HasA | fn:fe:result | "silencing" | "result" | "/r/has a" |  | "FN" |  |
| fn:silencing | /r/HasA | fn:fe:expressor | "silencing" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:silencing | /r/HasA | fn:fe:manner | "silencing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:silencing | /r/HasA | fn:fe:degree | "silencing" | "degree" | "/r/has a" |  | "FN" |  |
| fn:similarity | /r/IsA | fn:gradable_attributes | "similarity" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:similarity | /r/IsA | fn:reciprocality | "similarity" | "reciprocality" | "/r/is a" |  | "FN" |  |
| fn:be_in_agreement_on_assessment | /r/IsA | fn:similarity | "be in agreement on assessment" | "similarity" | "/r/is a" |  | "FN" |  |
| fn:diversity | /r/IsA | fn:similarity | "diversity" | "similarity" | "/r/is a" |  | "FN" |  |
| fn:similarity | /r/UsedFor | fn:correctness | "similarity" | "correctness" | "/r/used for" |  | "FN" |  |
| fn:similarity | /r/UsedFor | fn:distinctiveness | "similarity" | "distinctiveness" | "/r/used for" |  | "FN" |  |
| fn:similarity | /r/UsedFor | fn:imitating | "similarity" | "imitating" | "/r/used for" |  | "FN" |  |
| fn:similarity | /r/UsedFor | fn:typicality | "similarity" | "typicality" | "/r/used for" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:similar | "similarity" | "similar" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:dissimilar | "similarity" | "dissimilar" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:similarity_[mass] | "similarity" | "similarity [mass]" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:dissimilarity | "similarity" | "dissimilarity" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:alike | "similarity" | "alike" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:resemble | "similarity" | "resemble" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:different | "similarity" | "different" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:unlike | "similarity" | "unlike" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:resemblance | "similarity" | "resemblance" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:unlike | "similarity" | "unlike" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:ringer | "similarity" | "ringer" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:spitting_image | "similarity" | "spitting image" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:like | "similarity" | "like" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:similarity_[count] | "similarity" | "similarity [count]" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:like | "similarity" | "like" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:like | "similarity" | "like" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:differ | "similarity" | "differ" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:distinct | "similarity" | "distinct" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:difference_[count] | "similarity" | "difference [count]" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:parallel | "similarity" | "parallel" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:difference | "similarity" | "difference" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:vary | "similarity" | "vary" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:discrepancy | "similarity" | "discrepancy" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:discrepant | "similarity" | "discrepant" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:disparity | "similarity" | "disparity" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:disparate | "similarity" | "disparate" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:distinction | "similarity" | "distinction" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:variant | "similarity" | "variant" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:dissimilarity_[mass] | "similarity" | "dissimilarity [mass]" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:image | "similarity" | "image" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:very_image | "similarity" | "very image" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:take_after | "similarity" | "take after" | "has lexical unit" |  | "FN" |  |
| fn:similarity | fn:HasLexicalUnit | fn:lu:similarity:mimic | "similarity" | "mimic" | "has lexical unit" |  | "FN" |  |
| fn:similarity | /r/HasA | fn:fe:entities | "similarity" | "entities" | "/r/has a" |  | "FN" |  |
| fn:similarity | /r/HasA | fn:fe:entity_1 | "similarity" | "entity 1" | "/r/has a" |  | "FN" |  |
| fn:similarity | /r/HasA | fn:fe:entity_2 | "similarity" | "entity 2" | "/r/has a" |  | "FN" |  |
| fn:similarity | /r/HasA | fn:fe:dimension | "similarity" | "dimension" | "/r/has a" |  | "FN" |  |
| fn:similarity | /r/HasA | fn:fe:degree | "similarity" | "degree" | "/r/has a" |  | "FN" |  |
| fn:similarity | /r/HasA | fn:fe:time | "similarity" | "time" | "/r/has a" |  | "FN" |  |
| fn:similarity | /r/HasA | fn:fe:place | "similarity" | "place" | "/r/has a" |  | "FN" |  |
| fn:similarity | /r/HasA | fn:fe:manner | "similarity" | "manner" | "/r/has a" |  | "FN" |  |
| fn:similarity | /r/HasA | fn:fe:explanation | "similarity" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:similarity | /r/HasA | fn:fe:depictive | "similarity" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:similarity | /r/HasA | fn:fe:circumstances | "similarity" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:similarity | /r/HasA | fn:fe:differentiating_fact | "similarity" | "differentiating fact" | "/r/has a" |  | "FN" |  |
| fn:simple_name | /r/UsedFor | fn:linguistic_meaning | "simple name" | "linguistic meaning" | "/r/used for" |  | "FN" |  |
| fn:simple_name | /r/UsedFor | fn:simple_naming | "simple name" | "simple naming" | "/r/used for" |  | "FN" |  |
| fn:simple_name | fn:HasLexicalUnit | fn:lu:simple_name:term | "simple name" | "term" | "has lexical unit" |  | "FN" |  |
| fn:simple_name | fn:HasLexicalUnit | fn:lu:simple_name:word | "simple name" | "word" | "has lexical unit" |  | "FN" |  |
| fn:simple_name | /r/HasA | fn:fe:term | "simple name" | "term" | "/r/has a" |  | "FN" |  |
| fn:simple_name | /r/HasA | fn:fe:entity | "simple name" | "entity" | "/r/has a" |  | "FN" |  |
| fn:simple_name | /r/HasA | fn:fe:speaker | "simple name" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:simple_name | /r/UsedFor | fn:simple_naming | "simple name" | "simple naming" | "/r/used for" |  | "FN" |  |
| fn:simple_naming | fn:HasLexicalUnit | fn:lu:simple_naming:call | "simple naming" | "call" | "has lexical unit" |  | "FN" |  |
| fn:simple_naming | fn:HasLexicalUnit | fn:lu:simple_naming:term | "simple naming" | "term" | "has lexical unit" |  | "FN" |  |
| fn:simple_naming | /r/HasA | fn:fe:entity | "simple naming" | "entity" | "/r/has a" |  | "FN" |  |
| fn:simple_naming | /r/HasA | fn:fe:term | "simple naming" | "term" | "/r/has a" |  | "FN" |  |
| fn:simple_naming | /r/HasA | fn:fe:speaker | "simple naming" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:simple_naming | /r/HasA | fn:fe:explanation | "simple naming" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:simple_naming | /r/HasA | fn:fe:frequency | "simple naming" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:simultaneity | /r/IsA | fn:relation | "simultaneity" | "relation" | "/r/is a" |  | "FN" |  |
| fn:location_in_time | /r/IsA | fn:simultaneity | "location in time" | "simultaneity" | "/r/is a" |  | "FN" |  |
| fn:temporal_collocation | /r/IsA | fn:simultaneity | "temporal collocation" | "simultaneity" | "/r/is a" |  | "FN" |  |
| fn:simultaneity | fn:HasLexicalUnit | fn:lu:simultaneity:simultaneous | "simultaneity" | "simultaneous" | "has lexical unit" |  | "FN" |  |
| fn:simultaneity | fn:HasLexicalUnit | fn:lu:simultaneity:simultaneity | "simultaneity" | "simultaneity" | "has lexical unit" |  | "FN" |  |
| fn:simultaneity | fn:HasLexicalUnit | fn:lu:simultaneity:conjunction | "simultaneity" | "conjunction" | "has lexical unit" |  | "FN" |  |
| fn:simultaneity | fn:HasLexicalUnit | fn:lu:simultaneity:coincide | "simultaneity" | "coincide" | "has lexical unit" |  | "FN" |  |
| fn:simultaneity | fn:HasLexicalUnit | fn:lu:simultaneity:co-occur | "simultaneity" | "co-occur" | "has lexical unit" |  | "FN" |  |
| fn:simultaneity | fn:HasLexicalUnit | fn:lu:simultaneity:concurrent | "simultaneity" | "concurrent" | "has lexical unit" |  | "FN" |  |
| fn:simultaneity | fn:HasLexicalUnit | fn:lu:simultaneity:concurrency | "simultaneity" | "concurrency" | "has lexical unit" |  | "FN" |  |
| fn:simultaneity | fn:HasLexicalUnit | fn:lu:simultaneity:co-occurrence | "simultaneity" | "co-occurrence" | "has lexical unit" |  | "FN" |  |
| fn:simultaneity | fn:HasLexicalUnit | fn:lu:simultaneity:simultaneously | "simultaneity" | "simultaneously" | "has lexical unit" |  | "FN" |  |
| fn:fe:profiled_event | /r/RelatedTo | fn:fe:events | "profiled event" | "events" | "/r/related to" |  | "FN" |  |
| fn:simultaneity | /r/HasA | fn:fe:profiled_event | "simultaneity" | "profiled event" | "/r/has a" |  | "FN" |  |
| fn:fe:landmark_event | /r/RelatedTo | fn:fe:events | "landmark event" | "events" | "/r/related to" |  | "FN" |  |
| fn:simultaneity | /r/HasA | fn:fe:landmark_event | "simultaneity" | "landmark event" | "/r/has a" |  | "FN" |  |
| fn:simultaneity | /r/HasA | fn:fe:events | "simultaneity" | "events" | "/r/has a" |  | "FN" |  |
| fn:simultaneity | /r/HasA | fn:fe:degree | "simultaneity" | "degree" | "/r/has a" |  | "FN" |  |
| fn:size | /r/IsA | fn:measurable_attributes | "size" | "measurable attributes" | "/r/is a" |  | "FN" |  |
| fn:dimension | /r/SimilarTo | fn:size | "dimension" | "size" | "/r/similar to" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:large | "size" | "large" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:big | "size" | "big" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:huge | "size" | "huge" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:small | "size" | "small" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:tiny | "size" | "tiny" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:little | "size" | "little" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:enormous | "size" | "enormous" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:great | "size" | "great" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:infinitesimal | "size" | "infinitesimal" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:gigantic | "size" | "gigantic" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:giant | "size" | "giant" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:miniature | "size" | "miniature" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:grand | "size" | "grand" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:immense | "size" | "immense" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:miniscule | "size" | "miniscule" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:massive | "size" | "massive" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:sizable | "size" | "sizable" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:substantial | "size" | "substantial" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:ample | "size" | "ample" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:bulky | "size" | "bulky" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:capacious | "size" | "capacious" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:colossal | "size" | "colossal" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:humongous | "size" | "humongous" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:immeasurable | "size" | "immeasurable" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:voluminous | "size" | "voluminous" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:jumbo | "size" | "jumbo" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:mini | "size" | "mini" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:petite | "size" | "petite" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:wee | "size" | "wee" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:bitty | "size" | "bitty" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:puny | "size" | "puny" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:brobdingnagian | "size" | "brobdingnagian" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:lilliputian | "size" | "lilliputian" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:medium | "size" | "medium" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:mid-size | "size" | "mid-size" | "has lexical unit" |  | "FN" |  |
| fn:size | fn:HasLexicalUnit | fn:lu:size:medium-sized | "size" | "medium-sized" | "has lexical unit" |  | "FN" |  |
| fn:size | /r/HasA | fn:fe:entity | "size" | "entity" | "/r/has a" |  | "FN" |  |
| fn:size | /r/HasA | fn:fe:degree | "size" | "degree" | "/r/has a" |  | "FN" |  |
| fn:size | /r/HasA | fn:fe:standard | "size" | "standard" | "/r/has a" |  | "FN" |  |
| fn:size | /r/HasA | fn:fe:subregion | "size" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:size | /r/HasA | fn:fe:dimension | "size" | "dimension" | "/r/has a" |  | "FN" |  |
| fn:sleep | /r/IsA | fn:process_continue | "sleep" | "process continue" | "/r/is a" |  | "FN" |  |
| fn:sleep_wake_cycle | /r/HasSubevent | fn:sleep | "sleep wake cycle" | "sleep" | "/r/has subevent" |  | "FN" |  |
| fn:sleep | /r/HasPrerequisite | fn:fall_asleep | "sleep" | "fall asleep" | "/r/has prerequisite" |  | "FN" |  |
| fn:waking_up | /r/HasPrerequisite | fn:sleep | "waking up" | "sleep" | "/r/has prerequisite" |  | "FN" |  |
| fn:sleep | fn:HasLexicalUnit | fn:lu:sleep:nap | "sleep" | "nap" | "has lexical unit" |  | "FN" |  |
| fn:sleep | fn:HasLexicalUnit | fn:lu:sleep:doze | "sleep" | "doze" | "has lexical unit" |  | "FN" |  |
| fn:sleep | fn:HasLexicalUnit | fn:lu:sleep:snooze | "sleep" | "snooze" | "has lexical unit" |  | "FN" |  |
| fn:sleep | fn:HasLexicalUnit | fn:lu:sleep:catnap | "sleep" | "catnap" | "has lexical unit" |  | "FN" |  |
| fn:sleep | fn:HasLexicalUnit | fn:lu:sleep:slumber | "sleep" | "slumber" | "has lexical unit" |  | "FN" |  |
| fn:sleep | fn:HasLexicalUnit | fn:lu:sleep:hibernate | "sleep" | "hibernate" | "has lexical unit" |  | "FN" |  |
| fn:sleep | fn:HasLexicalUnit | fn:lu:sleep:kip | "sleep" | "kip" | "has lexical unit" |  | "FN" |  |
| fn:sleep | fn:HasLexicalUnit | fn:lu:sleep:drowse | "sleep" | "drowse" | "has lexical unit" |  | "FN" |  |
| fn:sleep | fn:HasLexicalUnit | fn:lu:sleep:sleep | "sleep" | "sleep" | "has lexical unit" |  | "FN" |  |
| fn:sleep | fn:HasLexicalUnit | fn:lu:sleep:shut-eye | "sleep" | "shut-eye" | "has lexical unit" |  | "FN" |  |
| fn:sleep | fn:HasLexicalUnit | fn:lu:sleep:forty_winks | "sleep" | "forty winks" | "has lexical unit" |  | "FN" |  |
| fn:sleep | fn:HasLexicalUnit | fn:lu:sleep:doze | "sleep" | "doze" | "has lexical unit" |  | "FN" |  |
| fn:sleep | fn:HasLexicalUnit | fn:lu:sleep:catnap | "sleep" | "catnap" | "has lexical unit" |  | "FN" |  |
| fn:sleep | fn:HasLexicalUnit | fn:lu:sleep:drowse | "sleep" | "drowse" | "has lexical unit" |  | "FN" |  |
| fn:sleep | fn:HasLexicalUnit | fn:lu:sleep:hibernation | "sleep" | "hibernation" | "has lexical unit" |  | "FN" |  |
| fn:sleep | fn:HasLexicalUnit | fn:lu:sleep:kip | "sleep" | "kip" | "has lexical unit" |  | "FN" |  |
| fn:sleep | fn:HasLexicalUnit | fn:lu:sleep:nap | "sleep" | "nap" | "has lexical unit" |  | "FN" |  |
| fn:sleep | fn:HasLexicalUnit | fn:lu:sleep:sleep_[event] | "sleep" | "sleep [event]" | "has lexical unit" |  | "FN" |  |
| fn:sleep | fn:HasLexicalUnit | fn:lu:sleep:slumber | "sleep" | "slumber" | "has lexical unit" |  | "FN" |  |
| fn:sleep | fn:HasLexicalUnit | fn:lu:sleep:snooze | "sleep" | "snooze" | "has lexical unit" |  | "FN" |  |
| fn:sleep | fn:HasLexicalUnit | fn:lu:sleep:asleep | "sleep" | "asleep" | "has lexical unit" |  | "FN" |  |
| fn:sleep | fn:HasLexicalUnit | fn:lu:sleep:out_like_a_light | "sleep" | "out like a light" | "has lexical unit" |  | "FN" |  |
| fn:sleep | fn:HasLexicalUnit | fn:lu:sleep:sleep_[quantity] | "sleep" | "sleep [quantity]" | "has lexical unit" |  | "FN" |  |
| fn:sleep | fn:HasLexicalUnit | fn:lu:sleep:out | "sleep" | "out" | "has lexical unit" |  | "FN" |  |
| fn:sleep | fn:HasLexicalUnit | fn:lu:sleep:unconscious | "sleep" | "unconscious" | "has lexical unit" |  | "FN" |  |
| fn:sleep | /r/HasA | fn:fe:sleeper | "sleep" | "sleeper" | "/r/has a" |  | "FN" |  |
| fn:sleep | /r/HasA | fn:fe:duration | "sleep" | "duration" | "/r/has a" |  | "FN" |  |
| fn:sleep | /r/HasA | fn:fe:time | "sleep" | "time" | "/r/has a" |  | "FN" |  |
| fn:sleep | /r/HasA | fn:fe:place | "sleep" | "place" | "/r/has a" |  | "FN" |  |
| fn:sleep | /r/HasA | fn:fe:degree | "sleep" | "degree" | "/r/has a" |  | "FN" |  |
| fn:sleep | /r/HasA | fn:fe:manner | "sleep" | "manner" | "/r/has a" |  | "FN" |  |
| fn:sleep_wake_cycle | /r/HasSubevent | fn:being_awake | "sleep wake cycle" | "being awake" | "/r/has subevent" |  | "FN" |  |
| fn:sleep_wake_cycle | /r/HasSubevent | fn:fall_asleep | "sleep wake cycle" | "fall asleep" | "/r/has subevent" |  | "FN" |  |
| fn:sleep_wake_cycle | /r/HasSubevent | fn:getting_up | "sleep wake cycle" | "getting up" | "/r/has subevent" |  | "FN" |  |
| fn:sleep_wake_cycle | /r/HasSubevent | fn:sleep | "sleep wake cycle" | "sleep" | "/r/has subevent" |  | "FN" |  |
| fn:sleep_wake_cycle | /r/HasSubevent | fn:waking_up | "sleep wake cycle" | "waking up" | "/r/has subevent" |  | "FN" |  |
| fn:sleep_wake_cycle | /r/HasA | fn:fe:duration | "sleep wake cycle" | "duration" | "/r/has a" |  | "FN" |  |
| fn:sleep_wake_cycle | /r/HasA | fn:fe:place | "sleep wake cycle" | "place" | "/r/has a" |  | "FN" |  |
| fn:sleep_wake_cycle | /r/HasA | fn:fe:sleeper | "sleep wake cycle" | "sleeper" | "/r/has a" |  | "FN" |  |
| fn:sleep_wake_cycle | /r/HasA | fn:fe:time | "sleep wake cycle" | "time" | "/r/has a" |  | "FN" |  |
| fn:smuggling | /r/IsA | fn:bringing | "smuggling" | "bringing" | "/r/is a" |  | "FN" |  |
| fn:smuggling | /r/IsA | fn:committing_crime | "smuggling" | "committing crime" | "/r/is a" |  | "FN" |  |
| fn:smuggling | fn:HasLexicalUnit | fn:lu:smuggling:smuggle | "smuggling" | "smuggle" | "has lexical unit" |  | "FN" |  |
| fn:smuggling | fn:HasLexicalUnit | fn:lu:smuggling:smuggling | "smuggling" | "smuggling" | "has lexical unit" |  | "FN" |  |
| fn:smuggling | fn:HasLexicalUnit | fn:lu:smuggling:smuggler | "smuggling" | "smuggler" | "has lexical unit" |  | "FN" |  |
| fn:smuggling | fn:HasLexicalUnit | fn:lu:smuggling:contraband | "smuggling" | "contraband" | "has lexical unit" |  | "FN" |  |
| fn:smuggling | fn:HasLexicalUnit | fn:lu:smuggling:contraband | "smuggling" | "contraband" | "has lexical unit" |  | "FN" |  |
| fn:smuggling | /r/HasA | fn:fe:perpetrator | "smuggling" | "perpetrator" | "/r/has a" |  | "FN" |  |
| fn:smuggling | /r/HasA | fn:fe:goods | "smuggling" | "goods" | "/r/has a" |  | "FN" |  |
| fn:smuggling | /r/HasA | fn:fe:duration | "smuggling" | "duration" | "/r/has a" |  | "FN" |  |
| fn:smuggling | /r/HasA | fn:fe:place | "smuggling" | "place" | "/r/has a" |  | "FN" |  |
| fn:smuggling | /r/HasA | fn:fe:explanation | "smuggling" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:smuggling | /r/HasA | fn:fe:time | "smuggling" | "time" | "/r/has a" |  | "FN" |  |
| fn:smuggling | /r/HasA | fn:fe:source | "smuggling" | "source" | "/r/has a" |  | "FN" |  |
| fn:smuggling | /r/HasA | fn:fe:path | "smuggling" | "path" | "/r/has a" |  | "FN" |  |
| fn:smuggling | /r/HasA | fn:fe:goal | "smuggling" | "goal" | "/r/has a" |  | "FN" |  |
| fn:smuggling | /r/HasA | fn:fe:means | "smuggling" | "means" | "/r/has a" |  | "FN" |  |
| fn:smuggling | /r/HasA | fn:fe:event | "smuggling" | "event" | "/r/has a" |  | "FN" |  |
| fn:smuggling | /r/HasA | fn:fe:manner | "smuggling" | "manner" | "/r/has a" |  | "FN" |  |
| fn:smuggling | /r/HasA | fn:fe:purpose | "smuggling" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:smuggling | /r/HasA | fn:fe:frequency | "smuggling" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:smuggling | /r/HasA | fn:fe:constant_location | "smuggling" | "constant location" | "/r/has a" |  | "FN" |  |
| fn:smuggling | /r/HasA | fn:fe:distance | "smuggling" | "distance" | "/r/has a" |  | "FN" |  |
| fn:smuggling | /r/HasA | fn:fe:speed | "smuggling" | "speed" | "/r/has a" |  | "FN" |  |
| fn:soaking | /r/IsA | fn:intentionally_affect | "soaking" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:apply_heat | /r/SimilarTo | fn:soaking | "apply heat" | "soaking" | "/r/similar to" |  | "FN" |  |
| fn:soaking | /r/SimilarTo | fn:apply_heat | "soaking" | "apply heat" | "/r/similar to" |  | "FN" |  |
| fn:soaking | /r/Causes | fn:soaking_up | "soaking" | "soaking up" | "/r/causes" |  | "FN" |  |
| fn:soaking | fn:HasLexicalUnit | fn:lu:soaking:soak | "soaking" | "soak" | "has lexical unit" |  | "FN" |  |
| fn:soaking | fn:HasLexicalUnit | fn:lu:soaking:marinate | "soaking" | "marinate" | "has lexical unit" |  | "FN" |  |
| fn:soaking | fn:HasLexicalUnit | fn:lu:soaking:steep | "soaking" | "steep" | "has lexical unit" |  | "FN" |  |
| fn:soaking | /r/HasA | fn:fe:agent | "soaking" | "agent" | "/r/has a" |  | "FN" |  |
| fn:soaking | /r/HasA | fn:fe:theme | "soaking" | "theme" | "/r/has a" |  | "FN" |  |
| fn:soaking | /r/HasA | fn:fe:duration | "soaking" | "duration" | "/r/has a" |  | "FN" |  |
| fn:soaking | /r/HasA | fn:fe:manner | "soaking" | "manner" | "/r/has a" |  | "FN" |  |
| fn:soaking | /r/HasA | fn:fe:medium | "soaking" | "medium" | "/r/has a" |  | "FN" |  |
| fn:soaking | /r/HasA | fn:fe:container | "soaking" | "container" | "/r/has a" |  | "FN" |  |
| fn:soaking | /r/HasA | fn:fe:place | "soaking" | "place" | "/r/has a" |  | "FN" |  |
| fn:soaking | /r/HasA | fn:fe:time | "soaking" | "time" | "/r/has a" |  | "FN" |  |
| fn:soaking | /r/HasA | fn:fe:means | "soaking" | "means" | "/r/has a" |  | "FN" |  |
| fn:soaking | /r/HasA | fn:fe:purpose | "soaking" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:soaking | /r/Causes | fn:soaking_up | "soaking" | "soaking up" | "/r/causes" |  | "FN" |  |
| fn:soaking_up | fn:HasLexicalUnit | fn:lu:soaking_up:absorb | "soaking up" | "absorb" | "has lexical unit" |  | "FN" |  |
| fn:soaking_up | fn:HasLexicalUnit | fn:lu:soaking_up:soak_up | "soaking up" | "soak up" | "has lexical unit" |  | "FN" |  |
| fn:soaking_up | fn:HasLexicalUnit | fn:lu:soaking_up:sponge | "soaking up" | "sponge" | "has lexical unit" |  | "FN" |  |
| fn:soaking_up | /r/HasA | fn:fe:item | "soaking up" | "item" | "/r/has a" |  | "FN" |  |
| fn:soaking_up | /r/HasA | fn:fe:substance | "soaking up" | "substance" | "/r/has a" |  | "FN" |  |
| fn:soaking_up | /r/HasA | fn:fe:place | "soaking up" | "place" | "/r/has a" |  | "FN" |  |
| fn:soaking_up | /r/HasA | fn:fe:time | "soaking up" | "time" | "/r/has a" |  | "FN" |  |
| fn:soaking_up | /r/HasA | fn:fe:duration | "soaking up" | "duration" | "/r/has a" |  | "FN" |  |
| fn:soaking_up | /r/HasA | fn:fe:manner | "soaking up" | "manner" | "/r/has a" |  | "FN" |  |
| fn:soaking_up | /r/HasA | fn:fe:degree | "soaking up" | "degree" | "/r/has a" |  | "FN" |  |
| fn:sociability | /r/IsA | fn:inclination | "sociability" | "inclination" | "/r/is a" |  | "FN" |  |
| fn:social_behavior_evaluation | /r/UsedFor | fn:sociability | "social behavior evaluation" | "sociability" | "/r/used for" |  | "FN" |  |
| fn:sociability | /r/RelatedTo | fn:social_interaction_evaluation | "sociability" | "social interaction evaluation" | "/r/related to" |  | "FN" |  |
| fn:social_interaction_evaluation | /r/SimilarTo | fn:sociability | "social interaction evaluation" | "sociability" | "/r/similar to" |  | "FN" |  |
| fn:sociability | fn:HasLexicalUnit | fn:lu:sociability:companionable | "sociability" | "companionable" | "has lexical unit" |  | "FN" |  |
| fn:sociability | fn:HasLexicalUnit | fn:lu:sociability:extrovert | "sociability" | "extrovert" | "has lexical unit" |  | "FN" |  |
| fn:sociability | fn:HasLexicalUnit | fn:lu:sociability:friendly | "sociability" | "friendly" | "has lexical unit" |  | "FN" |  |
| fn:sociability | fn:HasLexicalUnit | fn:lu:sociability:gregarious | "sociability" | "gregarious" | "has lexical unit" |  | "FN" |  |
| fn:sociability | fn:HasLexicalUnit | fn:lu:sociability:introverted | "sociability" | "introverted" | "has lexical unit" |  | "FN" |  |
| fn:sociability | fn:HasLexicalUnit | fn:lu:sociability:loner | "sociability" | "loner" | "has lexical unit" |  | "FN" |  |
| fn:sociability | fn:HasLexicalUnit | fn:lu:sociability:outgoing | "sociability" | "outgoing" | "has lexical unit" |  | "FN" |  |
| fn:sociability | fn:HasLexicalUnit | fn:lu:sociability:recluse | "sociability" | "recluse" | "has lexical unit" |  | "FN" |  |
| fn:sociability | fn:HasLexicalUnit | fn:lu:sociability:shy | "sociability" | "shy" | "has lexical unit" |  | "FN" |  |
| fn:sociability | fn:HasLexicalUnit | fn:lu:sociability:sociable | "sociability" | "sociable" | "has lexical unit" |  | "FN" |  |
| fn:sociability | fn:HasLexicalUnit | fn:lu:sociability:timid | "sociability" | "timid" | "has lexical unit" |  | "FN" |  |
| fn:sociability | fn:HasLexicalUnit | fn:lu:sociability:affable | "sociability" | "affable" | "has lexical unit" |  | "FN" |  |
| fn:sociability | /r/HasA | fn:fe:protagonist | "sociability" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:sociability | /r/HasA | fn:fe:company | "sociability" | "company" | "/r/has a" |  | "FN" |  |
| fn:sociability | /r/HasA | fn:fe:content | "sociability" | "content" | "/r/has a" |  | "FN" |  |
| fn:sociability | /r/HasA | fn:fe:manner | "sociability" | "manner" | "/r/has a" |  | "FN" |  |
| fn:sociability | /r/HasA | fn:fe:degree | "sociability" | "degree" | "/r/has a" |  | "FN" |  |
| fn:sociability | /r/HasA | fn:fe:judge | "sociability" | "judge" | "/r/has a" |  | "FN" |  |
| fn:social_behavior_evaluation | /r/IsA | fn:gradable_attributes | "social behavior evaluation" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:attitude_description | /r/IsA | fn:social_behavior_evaluation | "attitude description" | "social behavior evaluation" | "/r/is a" |  | "FN" |  |
| fn:being_questionable | /r/IsA | fn:social_behavior_evaluation | "being questionable" | "social behavior evaluation" | "/r/is a" |  | "FN" |  |
| fn:compliance | /r/IsA | fn:social_behavior_evaluation | "compliance" | "social behavior evaluation" | "/r/is a" |  | "FN" |  |
| fn:disgraceful_situation | /r/IsA | fn:social_behavior_evaluation | "disgraceful situation" | "social behavior evaluation" | "/r/is a" |  | "FN" |  |
| fn:expertise | /r/IsA | fn:social_behavior_evaluation | "expertise" | "social behavior evaluation" | "/r/is a" |  | "FN" |  |
| fn:frugality | /r/IsA | fn:social_behavior_evaluation | "frugality" | "social behavior evaluation" | "/r/is a" |  | "FN" |  |
| fn:mental_property | /r/IsA | fn:social_behavior_evaluation | "mental property" | "social behavior evaluation" | "/r/is a" |  | "FN" |  |
| fn:morality_evaluation | /r/IsA | fn:social_behavior_evaluation | "morality evaluation" | "social behavior evaluation" | "/r/is a" |  | "FN" |  |
| fn:praiseworthiness | /r/IsA | fn:social_behavior_evaluation | "praiseworthiness" | "social behavior evaluation" | "/r/is a" |  | "FN" |  |
| fn:rashness | /r/IsA | fn:social_behavior_evaluation | "rashness" | "social behavior evaluation" | "/r/is a" |  | "FN" |  |
| fn:social_interaction_evaluation | /r/IsA | fn:social_behavior_evaluation | "social interaction evaluation" | "social behavior evaluation" | "/r/is a" |  | "FN" |  |
| fn:trendiness | /r/IsA | fn:social_behavior_evaluation | "trendiness" | "social behavior evaluation" | "/r/is a" |  | "FN" |  |
| fn:social_behavior_evaluation | /r/UsedFor | fn:conduct | "social behavior evaluation" | "conduct" | "/r/used for" |  | "FN" |  |
| fn:social_behavior_evaluation | /r/UsedFor | fn:sociability | "social behavior evaluation" | "sociability" | "/r/used for" |  | "FN" |  |
| fn:social_behavior_evaluation | /r/UsedFor | fn:volubility | "social behavior evaluation" | "volubility" | "/r/used for" |  | "FN" |  |
| fn:social_behavior_evaluation | /r/HasA | fn:fe:behavior | "social behavior evaluation" | "behavior" | "/r/has a" |  | "FN" |  |
| fn:social_behavior_evaluation | /r/HasA | fn:fe:individual | "social behavior evaluation" | "individual" | "/r/has a" |  | "FN" |  |
| fn:social_behavior_evaluation | /r/HasA | fn:fe:judge | "social behavior evaluation" | "judge" | "/r/has a" |  | "FN" |  |
| fn:social_behavior_evaluation | /r/HasA | fn:fe:degree | "social behavior evaluation" | "degree" | "/r/has a" |  | "FN" |  |
| fn:social_connection | /r/IsA | fn:relation_between_individuals | "social connection" | "relation between individuals" | "/r/is a" |  | "FN" |  |
| fn:social_connection | fn:HasLexicalUnit | fn:lu:social_connection:tie | "social connection" | "tie" | "has lexical unit" |  | "FN" |  |
| fn:social_connection | fn:HasLexicalUnit | fn:lu:social_connection:connection | "social connection" | "connection" | "has lexical unit" |  | "FN" |  |
| fn:social_connection | fn:HasLexicalUnit | fn:lu:social_connection:connected | "social connection" | "connected" | "has lexical unit" |  | "FN" |  |
| fn:social_connection | fn:HasLexicalUnit | fn:lu:social_connection:bond | "social connection" | "bond" | "has lexical unit" |  | "FN" |  |
| fn:social_connection | fn:HasLexicalUnit | fn:lu:social_connection:close | "social connection" | "close" | "has lexical unit" |  | "FN" |  |
| fn:social_connection | fn:HasLexicalUnit | fn:lu:social_connection:closeness | "social connection" | "closeness" | "has lexical unit" |  | "FN" |  |
| fn:social_connection | fn:HasLexicalUnit | fn:lu:social_connection:linked | "social connection" | "linked" | "has lexical unit" |  | "FN" |  |
| fn:social_connection | fn:HasLexicalUnit | fn:lu:social_connection:intimate | "social connection" | "intimate" | "has lexical unit" |  | "FN" |  |
| fn:social_connection | fn:HasLexicalUnit | fn:lu:social_connection:intimate_[setting] | "social connection" | "intimate [setting]" | "has lexical unit" |  | "FN" |  |
| fn:social_connection | fn:HasLexicalUnit | fn:lu:social_connection:link | "social connection" | "link" | "has lexical unit" |  | "FN" |  |
| fn:social_connection | /r/HasA | fn:fe:individuals | "social connection" | "individuals" | "/r/has a" |  | "FN" |  |
| fn:social_connection | /r/HasA | fn:fe:individual_1 | "social connection" | "individual 1" | "/r/has a" |  | "FN" |  |
| fn:social_connection | /r/HasA | fn:fe:individual_2 | "social connection" | "individual 2" | "/r/has a" |  | "FN" |  |
| fn:social_connection | /r/HasA | fn:fe:connection | "social connection" | "connection" | "/r/has a" |  | "FN" |  |
| fn:social_connection | /r/HasA | fn:fe:type | "social connection" | "type" | "/r/has a" |  | "FN" |  |
| fn:social_connection | /r/HasA | fn:fe:degree | "social connection" | "degree" | "/r/has a" |  | "FN" |  |
| fn:social_desirability | /r/IsA | fn:desirability | "social desirability" | "desirability" | "/r/is a" |  | "FN" |  |
| fn:social_desirability | fn:HasLexicalUnit | fn:lu:social_desirability:common | "social desirability" | "common" | "has lexical unit" |  | "FN" |  |
| fn:social_desirability | fn:HasLexicalUnit | fn:lu:social_desirability:plebeian | "social desirability" | "plebeian" | "has lexical unit" |  | "FN" |  |
| fn:social_desirability | fn:HasLexicalUnit | fn:lu:social_desirability:humble | "social desirability" | "humble" | "has lexical unit" |  | "FN" |  |
| fn:social_desirability | fn:HasLexicalUnit | fn:lu:social_desirability:pedestrian | "social desirability" | "pedestrian" | "has lexical unit" |  | "FN" |  |
| fn:social_desirability | fn:HasLexicalUnit | fn:lu:social_desirability:low | "social desirability" | "low" | "has lexical unit" |  | "FN" |  |
| fn:social_desirability | fn:HasLexicalUnit | fn:lu:social_desirability:proletarian | "social desirability" | "proletarian" | "has lexical unit" |  | "FN" |  |
| fn:social_desirability | fn:HasLexicalUnit | fn:lu:social_desirability:vulgar | "social desirability" | "vulgar" | "has lexical unit" |  | "FN" |  |
| fn:social_desirability | fn:HasLexicalUnit | fn:lu:social_desirability:working-class | "social desirability" | "working-class" | "has lexical unit" |  | "FN" |  |
| fn:social_desirability | fn:HasLexicalUnit | fn:lu:social_desirability:upper-class | "social desirability" | "upper-class" | "has lexical unit" |  | "FN" |  |
| fn:social_desirability | /r/HasA | fn:fe:evaluee | "social desirability" | "evaluee" | "/r/has a" |  | "FN" |  |
| fn:social_desirability | /r/HasA | fn:fe:degree | "social desirability" | "degree" | "/r/has a" |  | "FN" |  |
| fn:social_desirability | /r/HasA | fn:fe:circumstances | "social desirability" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:social_desirability | /r/HasA | fn:fe:comparison_set | "social desirability" | "comparison set" | "/r/has a" |  | "FN" |  |
| fn:social_desirability | /r/HasA | fn:fe:depictive | "social desirability" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:social_event_collective | /r/IsA | fn:social_event | "social event collective" | "social event" | "/r/is a" |  | "FN" |  |
| fn:social_event_individuals | /r/IsA | fn:social_event | "social event individuals" | "social event" | "/r/is a" |  | "FN" |  |
| fn:eventive_affecting | /r/UsedFor | fn:social_event | "eventive affecting" | "social event" | "/r/used for" |  | "FN" |  |
| fn:social_event | fn:HasLexicalUnit | fn:lu:social_event:party | "social event" | "party" | "has lexical unit" |  | "FN" |  |
| fn:social_event | fn:HasLexicalUnit | fn:lu:social_event:banquet | "social event" | "banquet" | "has lexical unit" |  | "FN" |  |
| fn:social_event | fn:HasLexicalUnit | fn:lu:social_event:shindig | "social event" | "shindig" | "has lexical unit" |  | "FN" |  |
| fn:social_event | fn:HasLexicalUnit | fn:lu:social_event:fete | "social event" | "fete" | "has lexical unit" |  | "FN" |  |
| fn:social_event | fn:HasLexicalUnit | fn:lu:social_event:celebration | "social event" | "celebration" | "has lexical unit" |  | "FN" |  |
| fn:social_event | fn:HasLexicalUnit | fn:lu:social_event:social | "social event" | "social" | "has lexical unit" |  | "FN" |  |
| fn:social_event | fn:HasLexicalUnit | fn:lu:social_event:get-together | "social event" | "get-together" | "has lexical unit" |  | "FN" |  |
| fn:social_event | fn:HasLexicalUnit | fn:lu:social_event:picnic | "social event" | "picnic" | "has lexical unit" |  | "FN" |  |
| fn:social_event | fn:HasLexicalUnit | fn:lu:social_event:fair | "social event" | "fair" | "has lexical unit" |  | "FN" |  |
| fn:social_event | fn:HasLexicalUnit | fn:lu:social_event:reception | "social event" | "reception" | "has lexical unit" |  | "FN" |  |
| fn:social_event | fn:HasLexicalUnit | fn:lu:social_event:dance | "social event" | "dance" | "has lexical unit" |  | "FN" |  |
| fn:social_event | fn:HasLexicalUnit | fn:lu:social_event:festival | "social event" | "festival" | "has lexical unit" |  | "FN" |  |
| fn:social_event | fn:HasLexicalUnit | fn:lu:social_event:feast | "social event" | "feast" | "has lexical unit" |  | "FN" |  |
| fn:social_event | fn:HasLexicalUnit | fn:lu:social_event:dinner | "social event" | "dinner" | "has lexical unit" |  | "FN" |  |
| fn:social_event | fn:HasLexicalUnit | fn:lu:social_event:dinner-party | "social event" | "dinner-party" | "has lexical unit" |  | "FN" |  |
| fn:social_event | fn:HasLexicalUnit | fn:lu:social_event:bash | "social event" | "bash" | "has lexical unit" |  | "FN" |  |
| fn:social_event | fn:HasLexicalUnit | fn:lu:social_event:gala | "social event" | "gala" | "has lexical unit" |  | "FN" |  |
| fn:social_event | fn:HasLexicalUnit | fn:lu:social_event:jollification | "social event" | "jollification" | "has lexical unit" |  | "FN" |  |
| fn:social_event | fn:HasLexicalUnit | fn:lu:social_event:rave | "social event" | "rave" | "has lexical unit" |  | "FN" |  |
| fn:social_event | fn:HasLexicalUnit | fn:lu:social_event:soiree | "social event" | "soiree" | "has lexical unit" |  | "FN" |  |
| fn:social_event | fn:HasLexicalUnit | fn:lu:social_event:barbecue | "social event" | "barbecue" | "has lexical unit" |  | "FN" |  |
| fn:social_event | fn:HasLexicalUnit | fn:lu:social_event:ball | "social event" | "ball" | "has lexical unit" |  | "FN" |  |
| fn:social_event | fn:HasLexicalUnit | fn:lu:social_event:meeting | "social event" | "meeting" | "has lexical unit" |  | "FN" |  |
| fn:social_event | fn:HasLexicalUnit | fn:lu:social_event:function | "social event" | "function" | "has lexical unit" |  | "FN" |  |
| fn:social_event | fn:HasLexicalUnit | fn:lu:social_event:benefit | "social event" | "benefit" | "has lexical unit" |  | "FN" |  |
| fn:social_event | /r/HasA | fn:fe:duration | "social event" | "duration" | "/r/has a" |  | "FN" |  |
| fn:social_event | /r/HasA | fn:fe:social_event | "social event" | "social event" | "/r/has a" |  | "FN" |  |
| fn:social_event | /r/HasA | fn:fe:place | "social event" | "place" | "/r/has a" |  | "FN" |  |
| fn:social_event | /r/HasA | fn:fe:time | "social event" | "time" | "/r/has a" |  | "FN" |  |
| fn:social_event | /r/HasA | fn:fe:host | "social event" | "host" | "/r/has a" |  | "FN" |  |
| fn:social_event | /r/HasA | fn:fe:beneficiary | "social event" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:social_event | /r/HasA | fn:fe:occasion | "social event" | "occasion" | "/r/has a" |  | "FN" |  |
| fn:social_event | /r/HasA | fn:fe:attendee | "social event" | "attendee" | "/r/has a" |  | "FN" |  |
| fn:social_event | /r/HasA | fn:fe:degree | "social event" | "degree" | "/r/has a" |  | "FN" |  |
| fn:social_event | /r/HasA | fn:fe:manner | "social event" | "manner" | "/r/has a" |  | "FN" |  |
| fn:social_event | /r/HasA | fn:fe:refreshment | "social event" | "refreshment" | "/r/has a" |  | "FN" |  |
| fn:social_event | /r/HasA | fn:fe:style | "social event" | "style" | "/r/has a" |  | "FN" |  |
| fn:social_event | /r/HasA | fn:fe:period_of_iterations | "social event" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:social_event | /r/HasA | fn:fe:descriptor | "social event" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:social_event | /r/HasA | fn:fe:name | "social event" | "name" | "/r/has a" |  | "FN" |  |
| fn:social_event | /r/HasA | fn:fe:frequency | "social event" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:social_event | /r/HasA | fn:fe:purpose | "social event" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:social_event_collective | /r/IsA | fn:social_event | "social event collective" | "social event" | "/r/is a" |  | "FN" |  |
| fn:social_event_collective | fn:HasLexicalUnit | fn:lu:social_event_collective:date | "social event collective" | "date" | "has lexical unit" |  | "FN" |  |
| fn:social_event_collective | /r/HasA | fn:fe:attendees | "social event collective" | "attendees" | "/r/has a" |  | "FN" |  |
| fn:social_event_collective | /r/HasA | fn:fe:degree | "social event collective" | "degree" | "/r/has a" |  | "FN" |  |
| fn:social_event_collective | /r/HasA | fn:fe:duration | "social event collective" | "duration" | "/r/has a" |  | "FN" |  |
| fn:social_event_collective | /r/HasA | fn:fe:manner | "social event collective" | "manner" | "/r/has a" |  | "FN" |  |
| fn:social_event_collective | /r/HasA | fn:fe:place | "social event collective" | "place" | "/r/has a" |  | "FN" |  |
| fn:social_event_collective | /r/HasA | fn:fe:time | "social event collective" | "time" | "/r/has a" |  | "FN" |  |
| fn:social_event_collective | /r/HasA | fn:fe:particular_iteration | "social event collective" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:social_event_individuals | /r/IsA | fn:social_event | "social event individuals" | "social event" | "/r/is a" |  | "FN" |  |
| fn:social_event_individuals | fn:HasLexicalUnit | fn:lu:social_event_individuals:go_out_with | "social event individuals" | "go out with" | "has lexical unit" |  | "FN" |  |
| fn:social_event_individuals | /r/HasA | fn:fe:party_1 | "social event individuals" | "party 1" | "/r/has a" |  | "FN" |  |
| fn:social_event_individuals | /r/HasA | fn:fe:party_2 | "social event individuals" | "party 2" | "/r/has a" |  | "FN" |  |
| fn:social_event_individuals | /r/HasA | fn:fe:degree | "social event individuals" | "degree" | "/r/has a" |  | "FN" |  |
| fn:social_event_individuals | /r/HasA | fn:fe:duration | "social event individuals" | "duration" | "/r/has a" |  | "FN" |  |
| fn:social_event_individuals | /r/HasA | fn:fe:manner | "social event individuals" | "manner" | "/r/has a" |  | "FN" |  |
| fn:social_event_individuals | /r/HasA | fn:fe:place | "social event individuals" | "place" | "/r/has a" |  | "FN" |  |
| fn:social_event_individuals | /r/HasA | fn:fe:time | "social event individuals" | "time" | "/r/has a" |  | "FN" |  |
| fn:social_interaction_evaluation | /r/IsA | fn:social_behavior_evaluation | "social interaction evaluation" | "social behavior evaluation" | "/r/is a" |  | "FN" |  |
| fn:hospitality | /r/IsA | fn:social_interaction_evaluation | "hospitality" | "social interaction evaluation" | "/r/is a" |  | "FN" |  |
| fn:partiality | /r/IsA | fn:social_interaction_evaluation | "partiality" | "social interaction evaluation" | "/r/is a" |  | "FN" |  |
| fn:stinginess | /r/IsA | fn:social_interaction_evaluation | "stinginess" | "social interaction evaluation" | "/r/is a" |  | "FN" |  |
| fn:strictness | /r/IsA | fn:social_interaction_evaluation | "strictness" | "social interaction evaluation" | "/r/is a" |  | "FN" |  |
| fn:social_interaction_evaluation | /r/UsedFor | fn:fairness_evaluation | "social interaction evaluation" | "fairness evaluation" | "/r/used for" |  | "FN" |  |
| fn:sociability | /r/RelatedTo | fn:social_interaction_evaluation | "sociability" | "social interaction evaluation" | "/r/related to" |  | "FN" |  |
| fn:social_interaction_evaluation | /r/SimilarTo | fn:personal_relationship | "social interaction evaluation" | "personal relationship" | "/r/similar to" |  | "FN" |  |
| fn:social_interaction_evaluation | /r/SimilarTo | fn:sociability | "social interaction evaluation" | "sociability" | "/r/similar to" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:inconsiderate | "social interaction evaluation" | "inconsiderate" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:kind | "social interaction evaluation" | "kind" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:considerate | "social interaction evaluation" | "considerate" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:mean | "social interaction evaluation" | "mean" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:insensitive | "social interaction evaluation" | "insensitive" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:thoughtless | "social interaction evaluation" | "thoughtless" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:thoughtful | "social interaction evaluation" | "thoughtful" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:cruel | "social interaction evaluation" | "cruel" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:sweet | "social interaction evaluation" | "sweet" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:rude | "social interaction evaluation" | "rude" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:impolite | "social interaction evaluation" | "impolite" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:ill-mannered | "social interaction evaluation" | "ill-mannered" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:churlish | "social interaction evaluation" | "churlish" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:discourteous | "social interaction evaluation" | "discourteous" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:unkind | "social interaction evaluation" | "unkind" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:courteous | "social interaction evaluation" | "courteous" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:polite | "social interaction evaluation" | "polite" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:impudent | "social interaction evaluation" | "impudent" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:respectful | "social interaction evaluation" | "respectful" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:disrespectful | "social interaction evaluation" | "disrespectful" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:boorish | "social interaction evaluation" | "boorish" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:compassionate | "social interaction evaluation" | "compassionate" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:nice | "social interaction evaluation" | "nice" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:friendly | "social interaction evaluation" | "friendly" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:unfriendly | "social interaction evaluation" | "unfriendly" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:amiable | "social interaction evaluation" | "amiable" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:sociable | "social interaction evaluation" | "sociable" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:cordial | "social interaction evaluation" | "cordial" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:genial | "social interaction evaluation" | "genial" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:gracious | "social interaction evaluation" | "gracious" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:ungracious | "social interaction evaluation" | "ungracious" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:civil | "social interaction evaluation" | "civil" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:uncivil | "social interaction evaluation" | "uncivil" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:impertinent | "social interaction evaluation" | "impertinent" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:tactful | "social interaction evaluation" | "tactful" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:diplomatic | "social interaction evaluation" | "diplomatic" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:barbaric | "social interaction evaluation" | "barbaric" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:spiteful | "social interaction evaluation" | "spiteful" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:pleasant | "social interaction evaluation" | "pleasant" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:horrible | "social interaction evaluation" | "horrible" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:good | "social interaction evaluation" | "good" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:good-natured | "social interaction evaluation" | "good-natured" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:good-humored | "social interaction evaluation" | "good-humored" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:warm | "social interaction evaluation" | "warm" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:smart | "social interaction evaluation" | "smart" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:mature | "social interaction evaluation" | "mature" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:maturity | "social interaction evaluation" | "maturity" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:cruelty | "social interaction evaluation" | "cruelty" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:thoughtfulness | "social interaction evaluation" | "thoughtfulness" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:rudeness | "social interaction evaluation" | "rudeness" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:compassion | "social interaction evaluation" | "compassion" | "has lexical unit" |  | "FN" |  |
| fn:social_interaction_evaluation | fn:HasLexicalUnit | fn:lu:social_interaction_evaluation:atrocious | "social interaction evaluation" | "atrocious" | "has lexical unit" |  | "FN" |  |
| fn:fe:evaluee | /r/IsA | fn:st:human | "evaluee" | "human" | "/r/is a" |  | "FN" |  |
| fn:social_interaction_evaluation | /r/HasA | fn:fe:evaluee | "social interaction evaluation" | "evaluee" | "/r/has a" |  | "FN" |  |
| fn:social_interaction_evaluation | /r/HasA | fn:fe:affected_party | "social interaction evaluation" | "affected party" | "/r/has a" |  | "FN" |  |
| fn:social_interaction_evaluation | /r/HasA | fn:fe:behavior | "social interaction evaluation" | "behavior" | "/r/has a" |  | "FN" |  |
| fn:social_interaction_evaluation | /r/HasA | fn:fe:degree | "social interaction evaluation" | "degree" | "/r/has a" |  | "FN" |  |
| fn:fe:topic | /r/RelatedTo | fn:fe:behavior | "topic" | "behavior" | "/r/related to" |  | "FN" |  |
| fn:social_interaction_evaluation | /r/HasA | fn:fe:topic | "social interaction evaluation" | "topic" | "/r/has a" |  | "FN" |  |
| fn:social_interaction_evaluation | /r/HasA | fn:fe:expressor | "social interaction evaluation" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:social_interaction_evaluation | /r/HasA | fn:fe:manner | "social interaction evaluation" | "manner" | "/r/has a" |  | "FN" |  |
| fn:social_interaction_evaluation | /r/HasA | fn:fe:judge | "social interaction evaluation" | "judge" | "/r/has a" |  | "FN" |  |
| fn:socially_significant_history_scenario | /r/IsA | fn:history_scenario | "socially significant history scenario" | "history scenario" | "/r/is a" |  | "FN" |  |
| fn:history | /r/IsA | fn:socially_significant_history_scenario | "history" | "socially significant history scenario" | "/r/is a" |  | "FN" |  |
| fn:socially_significant_history_scenario | /r/HasA | fn:fe:event | "socially significant history scenario" | "event" | "/r/has a" |  | "FN" |  |
| fn:socially_significant_history_scenario | /r/HasA | fn:fe:place | "socially significant history scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:socially_significant_history_scenario | /r/HasA | fn:fe:time | "socially significant history scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:socially_significant_history_scenario | /r/HasA | fn:fe:manner | "socially significant history scenario" | "manner" | "/r/has a" |  | "FN" |  |
| fn:socially_significant_history_scenario | /r/HasA | fn:fe:domain | "socially significant history scenario" | "domain" | "/r/has a" |  | "FN" |  |
| fn:instance | /r/UsedFor | fn:sole_instance | "instance" | "sole instance" | "/r/used for" |  | "FN" |  |
| fn:sole_instance | fn:HasLexicalUnit | fn:lu:sole_instance:sole | "sole instance" | "sole" | "has lexical unit" |  | "FN" |  |
| fn:sole_instance | fn:HasLexicalUnit | fn:lu:sole_instance:only | "sole instance" | "only" | "has lexical unit" |  | "FN" |  |
| fn:sole_instance | fn:HasLexicalUnit | fn:lu:sole_instance:one_and_only | "sole instance" | "one and only" | "has lexical unit" |  | "FN" |  |
| fn:sole_instance | fn:HasLexicalUnit | fn:lu:sole_instance:lone | "sole instance" | "lone" | "has lexical unit" |  | "FN" |  |
| fn:sole_instance | fn:HasLexicalUnit | fn:lu:sole_instance:single | "sole instance" | "single" | "has lexical unit" |  | "FN" |  |
| fn:sole_instance | /r/HasA | fn:fe:item | "sole instance" | "item" | "/r/has a" |  | "FN" |  |
| fn:sole_instance | /r/HasA | fn:fe:type | "sole instance" | "type" | "/r/has a" |  | "FN" |  |
| fn:sound_level | /r/IsA | fn:measurable_attributes | "sound level" | "measurable attributes" | "/r/is a" |  | "FN" |  |
| fn:sound_level | fn:HasLexicalUnit | fn:lu:sound_level:loud | "sound level" | "loud" | "has lexical unit" |  | "FN" |  |
| fn:sound_level | fn:HasLexicalUnit | fn:lu:sound_level:quiet | "sound level" | "quiet" | "has lexical unit" |  | "FN" |  |
| fn:sound_level | /r/HasA | fn:fe:entity | "sound level" | "entity" | "/r/has a" |  | "FN" |  |
| fn:sound_level | /r/HasA | fn:fe:attribute | "sound level" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:sound_level | /r/HasA | fn:fe:volume | "sound level" | "volume" | "/r/has a" |  | "FN" |  |
| fn:sound_level | /r/HasA | fn:fe:degree | "sound level" | "degree" | "/r/has a" |  | "FN" |  |
| fn:sound_level | /r/HasA | fn:fe:circumstances | "sound level" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:sound_level | /r/HasA | fn:fe:time | "sound level" | "time" | "/r/has a" |  | "FN" |  |
| fn:sound_level | /r/HasA | fn:fe:place | "sound level" | "place" | "/r/has a" |  | "FN" |  |
| fn:sound_level | /r/HasA | fn:fe:explanation | "sound level" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:sounds | /r/UsedFor | fn:sound_movement | "sounds" | "sound movement" | "/r/used for" |  | "FN" |  |
| fn:make_noise | /r/RelatedTo | fn:sound_movement | "make noise" | "sound movement" | "/r/related to" |  | "FN" |  |
| fn:sound_movement | fn:HasLexicalUnit | fn:lu:sound_movement:reverberate | "sound movement" | "reverberate" | "has lexical unit" |  | "FN" |  |
| fn:sound_movement | fn:HasLexicalUnit | fn:lu:sound_movement:echo | "sound movement" | "echo" | "has lexical unit" |  | "FN" |  |
| fn:sound_movement | fn:HasLexicalUnit | fn:lu:sound_movement:resound | "sound movement" | "resound" | "has lexical unit" |  | "FN" |  |
| fn:sound_movement | fn:HasLexicalUnit | fn:lu:sound_movement:roll | "sound movement" | "roll" | "has lexical unit" |  | "FN" |  |
| fn:sound_movement | fn:HasLexicalUnit | fn:lu:sound_movement:blast | "sound movement" | "blast" | "has lexical unit" |  | "FN" |  |
| fn:sound_movement | /r/HasA | fn:fe:sound | "sound movement" | "sound" | "/r/has a" |  | "FN" |  |
| fn:sound_movement | /r/HasA | fn:fe:location_of_sound_source | "sound movement" | "location of sound source" | "/r/has a" |  | "FN" |  |
| fn:sound_movement | /r/HasA | fn:fe:path | "sound movement" | "path" | "/r/has a" |  | "FN" |  |
| fn:sound_movement | /r/HasA | fn:fe:place | "sound movement" | "place" | "/r/has a" |  | "FN" |  |
| fn:sound_movement | /r/HasA | fn:fe:time | "sound movement" | "time" | "/r/has a" |  | "FN" |  |
| fn:sound_movement | /r/HasA | fn:fe:sound_source | "sound movement" | "sound source" | "/r/has a" |  | "FN" |  |
| fn:sound_movement | /r/HasA | fn:fe:manner | "sound movement" | "manner" | "/r/has a" |  | "FN" |  |
| fn:sound_movement | /r/HasA | fn:fe:goal | "sound movement" | "goal" | "/r/has a" |  | "FN" |  |
| fn:vocalizations | /r/IsA | fn:sounds | "vocalizations" | "sounds" | "/r/is a" |  | "FN" |  |
| fn:perception | /r/UsedFor | fn:sounds | "perception" | "sounds" | "/r/used for" |  | "FN" |  |
| fn:sounds | /r/UsedFor | fn:sound_movement | "sounds" | "sound movement" | "/r/used for" |  | "FN" |  |
| fn:make_noise | /r/RelatedTo | fn:sounds | "make noise" | "sounds" | "/r/related to" |  | "FN" |  |
| fn:make_noise | /r/SimilarTo | fn:sounds | "make noise" | "sounds" | "/r/similar to" |  | "FN" |  |
| fn:sounds | /r/SimilarTo | fn:vocalizations | "sounds" | "vocalizations" | "/r/similar to" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:babble | "sounds" | "babble" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:bark | "sounds" | "bark" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:beep | "sounds" | "beep" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:bellow | "sounds" | "bellow" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:blare | "sounds" | "blare" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:blast | "sounds" | "blast" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:bleat | "sounds" | "bleat" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:boom | "sounds" | "boom" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:bray | "sounds" | "bray" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:burble | "sounds" | "burble" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:buzz | "sounds" | "buzz" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:cackle | "sounds" | "cackle" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:caw | "sounds" | "caw" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:chatter | "sounds" | "chatter" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:cheep | "sounds" | "cheep" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:chirp | "sounds" | "chirp" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:chuckle | "sounds" | "chuckle" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:clack | "sounds" | "clack" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:clang | "sounds" | "clang" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:clash | "sounds" | "clash" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:clatter | "sounds" | "clatter" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:click | "sounds" | "click" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:clink | "sounds" | "clink" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:coo | "sounds" | "coo" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:cough | "sounds" | "cough" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:creak | "sounds" | "creak" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:crunch | "sounds" | "crunch" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:drone | "sounds" | "drone" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:gasp | "sounds" | "gasp" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:giggle | "sounds" | "giggle" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:growl | "sounds" | "growl" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:grunt | "sounds" | "grunt" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:guffaw | "sounds" | "guffaw" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:gurgle | "sounds" | "gurgle" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:hiss | "sounds" | "hiss" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:hoot | "sounds" | "hoot" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:hum | "sounds" | "hum" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:mew | "sounds" | "mew" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:moan | "sounds" | "moan" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:neigh | "sounds" | "neigh" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:patter | "sounds" | "patter" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:peal | "sounds" | "peal" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:peep | "sounds" | "peep" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:plash | "sounds" | "plash" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:plop | "sounds" | "plop" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:plunk | "sounds" | "plunk" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:purr | "sounds" | "purr" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:quack | "sounds" | "quack" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:rap | "sounds" | "rap" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:rasp | "sounds" | "rasp" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:roar | "sounds" | "roar" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:rustle | "sounds" | "rustle" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:scrape | "sounds" | "scrape" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:screech | "sounds" | "screech" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:scrunch | "sounds" | "scrunch" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:sizzle | "sounds" | "sizzle" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:slap | "sounds" | "slap" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:smack | "sounds" | "smack" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:snarl | "sounds" | "snarl" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:snigger | "sounds" | "snigger" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:snore | "sounds" | "snore" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:snort | "sounds" | "snort" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:sob | "sounds" | "sob" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:sough | "sounds" | "sough" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:squawk | "sounds" | "squawk" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:thump | "sounds" | "thump" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:squeal | "sounds" | "squeal" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:thunder | "sounds" | "thunder" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:tinkle | "sounds" | "tinkle" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:titter | "sounds" | "titter" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:toll | "sounds" | "toll" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:trumpet | "sounds" | "trumpet" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:tweet | "sounds" | "tweet" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:twitter | "sounds" | "twitter" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:wail | "sounds" | "wail" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:whimper | "sounds" | "whimper" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:whine | "sounds" | "whine" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:whinny | "sounds" | "whinny" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:whistle | "sounds" | "whistle" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:yammer | "sounds" | "yammer" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:yap | "sounds" | "yap" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:yelp | "sounds" | "yelp" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:yodel | "sounds" | "yodel" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:yowl | "sounds" | "yowl" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:sound | "sounds" | "sound" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:noise | "sounds" | "noise" | "has lexical unit" |  | "FN" |  |
| fn:sounds | fn:HasLexicalUnit | fn:lu:sounds:bang | "sounds" | "bang" | "has lexical unit" |  | "FN" |  |
| fn:fe:noisy_event | /r/RelatedTo | fn:fe:themes | "noisy event" | "themes" | "/r/related to" |  | "FN" |  |
| fn:sounds | /r/HasA | fn:fe:noisy_event | "sounds" | "noisy event" | "/r/has a" |  | "FN" |  |
| fn:fe:sound_source | /r/RelatedTo | fn:fe:themes | "sound source" | "themes" | "/r/related to" |  | "FN" |  |
| fn:sounds | /r/HasA | fn:fe:sound_source | "sounds" | "sound source" | "/r/has a" |  | "FN" |  |
| fn:fe:theme | /r/HasPrerequisite | fn:fe:ground | "theme" | "ground" | "/r/has prerequisite" |  | "FN" |  |
| fn:sounds | /r/HasA | fn:fe:theme | "sounds" | "theme" | "/r/has a" |  | "FN" |  |
| fn:fe:ground | /r/HasPrerequisite | fn:fe:theme | "ground" | "theme" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:ground | /r/RelatedTo | fn:fe:themes | "ground" | "themes" | "/r/related to" |  | "FN" |  |
| fn:sounds | /r/HasA | fn:fe:ground | "sounds" | "ground" | "/r/has a" |  | "FN" |  |
| fn:sounds | /r/HasA | fn:fe:themes | "sounds" | "themes" | "/r/has a" |  | "FN" |  |
| fn:sounds | /r/HasA | fn:fe:location_of_sound_source | "sounds" | "location of sound source" | "/r/has a" |  | "FN" |  |
| fn:sounds | /r/HasA | fn:fe:place | "sounds" | "place" | "/r/has a" |  | "FN" |  |
| fn:sounds | /r/HasA | fn:fe:internal_cause | "sounds" | "internal cause" | "/r/has a" |  | "FN" |  |
| fn:sounds | /r/HasA | fn:fe:manner | "sounds" | "manner" | "/r/has a" |  | "FN" |  |
| fn:fe:component_sound | /r/RelatedTo | fn:fe:themes | "component sound" | "themes" | "/r/related to" |  | "FN" |  |
| fn:sounds | /r/HasA | fn:fe:component_sound | "sounds" | "component sound" | "/r/has a" |  | "FN" |  |
| fn:sounds | /r/HasA | fn:fe:degree | "sounds" | "degree" | "/r/has a" |  | "FN" |  |
| fn:sounds | /r/HasA | fn:fe:explanation | "sounds" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:sounds | /r/HasA | fn:fe:path | "sounds" | "path" | "/r/has a" |  | "FN" |  |
| fn:source_of_getting | /r/IsA | fn:motion_scenario | "source of getting" | "motion scenario" | "/r/is a" |  | "FN" |  |
| fn:source_of_getting | fn:HasLexicalUnit | fn:lu:source_of_getting:source | "source of getting" | "source" | "has lexical unit" |  | "FN" |  |
| fn:source_of_getting | /r/HasA | fn:fe:theme | "source of getting" | "theme" | "/r/has a" |  | "FN" |  |
| fn:source_of_getting | /r/HasA | fn:fe:source | "source of getting" | "source" | "/r/has a" |  | "FN" |  |
| fn:source_of_getting | /r/HasA | fn:fe:goal | "source of getting" | "goal" | "/r/has a" |  | "FN" |  |
| fn:source_of_getting | /r/HasA | fn:fe:descriptor | "source of getting" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:source_path_goal | /r/UsedFor | fn:goal | "source path goal" | "goal" | "/r/used for" |  | "FN" |  |
| fn:source_path_goal | /r/IsA | fn:motion_scenario | "source path goal" | "motion scenario" | "/r/is a" |  | "FN" |  |
| fn:source_path_goal | /r/HasA | fn:fe:trajector | "source path goal" | "trajector" | "/r/has a" |  | "FN" |  |
| fn:source_path_goal | /r/HasA | fn:fe:source | "source path goal" | "source" | "/r/has a" |  | "FN" |  |
| fn:source_path_goal | /r/HasA | fn:fe:path | "source path goal" | "path" | "/r/has a" |  | "FN" |  |
| fn:source_path_goal | /r/HasA | fn:fe:goal | "source path goal" | "goal" | "/r/has a" |  | "FN" |  |
| fn:source_path_goal | /r/HasA | fn:fe:means | "source path goal" | "means" | "/r/has a" |  | "FN" |  |
| fn:spatial_co-location | /r/IsA | fn:locative_relation | "spatial co-location" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:collocation_image_schema | /r/UsedFor | fn:spatial_co-location | "collocation image schema" | "spatial co-location" | "/r/used for" |  | "FN" |  |
| fn:spatial_co-location | fn:HasLexicalUnit | fn:lu:spatial_co-location:at | "spatial co-location" | "at" | "has lexical unit" |  | "FN" |  |
| fn:spatial_co-location | fn:HasLexicalUnit | fn:lu:spatial_co-location:where_[relativizer] | "spatial co-location" | "where [relativizer]" | "has lexical unit" |  | "FN" |  |
| fn:spatial_co-location | fn:HasLexicalUnit | fn:lu:spatial_co-location:here | "spatial co-location" | "here" | "has lexical unit" |  | "FN" |  |
| fn:spatial_co-location | fn:HasLexicalUnit | fn:lu:spatial_co-location:there | "spatial co-location" | "there" | "has lexical unit" |  | "FN" |  |
| fn:spatial_co-location | fn:HasLexicalUnit | fn:lu:spatial_co-location:where_[interrog] | "spatial co-location" | "where [interrog]" | "has lexical unit" |  | "FN" |  |
| fn:spatial_co-location | fn:HasLexicalUnit | fn:lu:spatial_co-location:home | "spatial co-location" | "home" | "has lexical unit" |  | "FN" |  |
| fn:spatial_co-location | /r/HasA | fn:fe:ground | "spatial co-location" | "ground" | "/r/has a" |  | "FN" |  |
| fn:spatial_co-location | /r/HasA | fn:fe:figure | "spatial co-location" | "figure" | "/r/has a" |  | "FN" |  |
| fn:spatial_co-location | /r/HasA | fn:fe:accessibility | "spatial co-location" | "accessibility" | "/r/has a" |  | "FN" |  |
| fn:spatial_co-location | /r/HasA | fn:fe:direction | "spatial co-location" | "direction" | "/r/has a" |  | "FN" |  |
| fn:spatial_co-location | /r/HasA | fn:fe:time | "spatial co-location" | "time" | "/r/has a" |  | "FN" |  |
| fn:spatial_co-location | /r/HasA | fn:fe:deixis | "spatial co-location" | "deixis" | "/r/has a" |  | "FN" |  |
| fn:spatial_co-location | /r/HasA | fn:fe:directness | "spatial co-location" | "directness" | "/r/has a" |  | "FN" |  |
| fn:spatial_co-location | /r/HasA | fn:fe:temporal_profile | "spatial co-location" | "temporal profile" | "/r/has a" |  | "FN" |  |
| fn:spatial_contact | /r/IsA | fn:locative_relation | "spatial contact" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:spatial_contact | /r/RelatedTo | fn:ride_vehicle | "spatial contact" | "ride vehicle" | "/r/related to" |  | "FN" |  |
| fn:spatial_contact | /r/RelatedTo | fn:topic | "spatial contact" | "topic" | "/r/related to" |  | "FN" |  |
| fn:spatial_contact | /r/RelatedTo | fn:wearing | "spatial contact" | "wearing" | "/r/related to" |  | "FN" |  |
| fn:locative_relation | /r/SimilarTo | fn:spatial_contact | "locative relation" | "spatial contact" | "/r/similar to" |  | "FN" |  |
| fn:spatial_contact | fn:HasLexicalUnit | fn:lu:spatial_contact:on | "spatial contact" | "on" | "has lexical unit" |  | "FN" |  |
| fn:spatial_contact | fn:HasLexicalUnit | fn:lu:spatial_contact:atop | "spatial contact" | "atop" | "has lexical unit" |  | "FN" |  |
| fn:spatial_contact | fn:HasLexicalUnit | fn:lu:spatial_contact:on_top_(of) | "spatial contact" | "on top (of)" | "has lexical unit" |  | "FN" |  |
| fn:spatial_contact | fn:HasLexicalUnit | fn:lu:spatial_contact:against | "spatial contact" | "against" | "has lexical unit" |  | "FN" |  |
| fn:spatial_contact | fn:HasLexicalUnit | fn:lu:spatial_contact:touch | "spatial contact" | "touch" | "has lexical unit" |  | "FN" |  |
| fn:spatial_contact | fn:HasLexicalUnit | fn:lu:spatial_contact:touching | "spatial contact" | "touching" | "has lexical unit" |  | "FN" |  |
| fn:spatial_contact | fn:HasLexicalUnit | fn:lu:spatial_contact:contact | "spatial contact" | "contact" | "has lexical unit" |  | "FN" |  |
| fn:spatial_contact | fn:HasLexicalUnit | fn:lu:spatial_contact:contact | "spatial contact" | "contact" | "has lexical unit" |  | "FN" |  |
| fn:spatial_contact | fn:HasLexicalUnit | fn:lu:spatial_contact:tangent | "spatial contact" | "tangent" | "has lexical unit" |  | "FN" |  |
| fn:spatial_contact | fn:HasLexicalUnit | fn:lu:spatial_contact:upon | "spatial contact" | "upon" | "has lexical unit" |  | "FN" |  |
| fn:spatial_contact | fn:HasLexicalUnit | fn:lu:spatial_contact:off | "spatial contact" | "off" | "has lexical unit" |  | "FN" |  |
| fn:spatial_contact | /r/HasA | fn:fe:ground | "spatial contact" | "ground" | "/r/has a" |  | "FN" |  |
| fn:spatial_contact | /r/HasA | fn:fe:figure | "spatial contact" | "figure" | "/r/has a" |  | "FN" |  |
| fn:spatial_contact | /r/HasA | fn:fe:accessibility | "spatial contact" | "accessibility" | "/r/has a" |  | "FN" |  |
| fn:spatial_contact | /r/HasA | fn:fe:direction | "spatial contact" | "direction" | "/r/has a" |  | "FN" |  |
| fn:spatial_contact | /r/HasA | fn:fe:time | "spatial contact" | "time" | "/r/has a" |  | "FN" |  |
| fn:spatial_contact | /r/HasA | fn:fe:figures | "spatial contact" | "figures" | "/r/has a" |  | "FN" |  |
| fn:spatial_contact | /r/HasA | fn:fe:deixis | "spatial contact" | "deixis" | "/r/has a" |  | "FN" |  |
| fn:spatial_contact | /r/HasA | fn:fe:directness | "spatial contact" | "directness" | "/r/has a" |  | "FN" |  |
| fn:spatial_contact | /r/HasA | fn:fe:temporal_profile | "spatial contact" | "temporal profile" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:speak_on_topic | "communication" | "speak on topic" | "/r/used for" |  | "FN" |  |
| fn:resolve_problem | /r/SimilarTo | fn:speak_on_topic | "resolve problem" | "speak on topic" | "/r/similar to" |  | "FN" |  |
| fn:speak_on_topic | /r/SimilarTo | fn:statement | "speak on topic" | "statement" | "/r/similar to" |  | "FN" |  |
| fn:statement | /r/SimilarTo | fn:speak_on_topic | "statement" | "speak on topic" | "/r/similar to" |  | "FN" |  |
| fn:speak_on_topic | fn:HasLexicalUnit | fn:lu:speak_on_topic:lecture | "speak on topic" | "lecture" | "has lexical unit" |  | "FN" |  |
| fn:speak_on_topic | fn:HasLexicalUnit | fn:lu:speak_on_topic:sermonize | "speak on topic" | "sermonize" | "has lexical unit" |  | "FN" |  |
| fn:speak_on_topic | fn:HasLexicalUnit | fn:lu:speak_on_topic:expound | "speak on topic" | "expound" | "has lexical unit" |  | "FN" |  |
| fn:speak_on_topic | fn:HasLexicalUnit | fn:lu:speak_on_topic:preach | "speak on topic" | "preach" | "has lexical unit" |  | "FN" |  |
| fn:speak_on_topic | fn:HasLexicalUnit | fn:lu:speak_on_topic:hold_forth | "speak on topic" | "hold forth" | "has lexical unit" |  | "FN" |  |
| fn:speak_on_topic | fn:HasLexicalUnit | fn:lu:speak_on_topic:expatiate | "speak on topic" | "expatiate" | "has lexical unit" |  | "FN" |  |
| fn:speak_on_topic | fn:HasLexicalUnit | fn:lu:speak_on_topic:ramble | "speak on topic" | "ramble" | "has lexical unit" |  | "FN" |  |
| fn:speak_on_topic | fn:HasLexicalUnit | fn:lu:speak_on_topic:go_on | "speak on topic" | "go on" | "has lexical unit" |  | "FN" |  |
| fn:speak_on_topic | fn:HasLexicalUnit | fn:lu:speak_on_topic:discuss | "speak on topic" | "discuss" | "has lexical unit" |  | "FN" |  |
| fn:speak_on_topic | fn:HasLexicalUnit | fn:lu:speak_on_topic:address | "speak on topic" | "address" | "has lexical unit" |  | "FN" |  |
| fn:speak_on_topic | fn:HasLexicalUnit | fn:lu:speak_on_topic:address | "speak on topic" | "address" | "has lexical unit" |  | "FN" |  |
| fn:speak_on_topic | fn:HasLexicalUnit | fn:lu:speak_on_topic:lecture | "speak on topic" | "lecture" | "has lexical unit" |  | "FN" |  |
| fn:speak_on_topic | fn:HasLexicalUnit | fn:lu:speak_on_topic:pontificate | "speak on topic" | "pontificate" | "has lexical unit" |  | "FN" |  |
| fn:speak_on_topic | fn:HasLexicalUnit | fn:lu:speak_on_topic:tell | "speak on topic" | "tell" | "has lexical unit" |  | "FN" |  |
| fn:speak_on_topic | /r/HasA | fn:fe:audience | "speak on topic" | "audience" | "/r/has a" |  | "FN" |  |
| fn:speak_on_topic | /r/HasA | fn:fe:speaker | "speak on topic" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:speak_on_topic | /r/HasA | fn:fe:topic | "speak on topic" | "topic" | "/r/has a" |  | "FN" |  |
| fn:speak_on_topic | /r/HasA | fn:fe:manner | "speak on topic" | "manner" | "/r/has a" |  | "FN" |  |
| fn:speak_on_topic | /r/HasA | fn:fe:medium | "speak on topic" | "medium" | "/r/has a" |  | "FN" |  |
| fn:speak_on_topic | /r/HasA | fn:fe:occasion | "speak on topic" | "occasion" | "/r/has a" |  | "FN" |  |
| fn:speak_on_topic | /r/HasA | fn:fe:time | "speak on topic" | "time" | "/r/has a" |  | "FN" |  |
| fn:speak_on_topic | /r/HasA | fn:fe:place | "speak on topic" | "place" | "/r/has a" |  | "FN" |  |
| fn:speak_on_topic | /r/HasA | fn:fe:explanation | "speak on topic" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:specific_individual | fn:HasLexicalUnit | fn:lu:specific_individual:particular | "specific individual" | "particular" | "has lexical unit" |  | "FN" |  |
| fn:specific_individual | fn:HasLexicalUnit | fn:lu:specific_individual:specific | "specific individual" | "specific" | "has lexical unit" |  | "FN" |  |
| fn:specific_individual | fn:HasLexicalUnit | fn:lu:specific_individual:certain | "specific individual" | "certain" | "has lexical unit" |  | "FN" |  |
| fn:specific_individual | /r/HasA | fn:fe:type | "specific individual" | "type" | "/r/has a" |  | "FN" |  |
| fn:specific_individual | /r/HasA | fn:fe:instance | "specific individual" | "instance" | "/r/has a" |  | "FN" |  |
| fn:speed_description | /r/IsA | fn:measurable_attributes | "speed description" | "measurable attributes" | "/r/is a" |  | "FN" |  |
| fn:speed_description | fn:HasLexicalUnit | fn:lu:speed_description:fast | "speed description" | "fast" | "has lexical unit" |  | "FN" |  |
| fn:speed_description | fn:HasLexicalUnit | fn:lu:speed_description:quick | "speed description" | "quick" | "has lexical unit" |  | "FN" |  |
| fn:speed_description | fn:HasLexicalUnit | fn:lu:speed_description:speedy | "speed description" | "speedy" | "has lexical unit" |  | "FN" |  |
| fn:speed_description | fn:HasLexicalUnit | fn:lu:speed_description:speed | "speed description" | "speed" | "has lexical unit" |  | "FN" |  |
| fn:speed_description | fn:HasLexicalUnit | fn:lu:speed_description:breakneck | "speed description" | "breakneck" | "has lexical unit" |  | "FN" |  |
| fn:speed_description | fn:HasLexicalUnit | fn:lu:speed_description:rate | "speed description" | "rate" | "has lexical unit" |  | "FN" |  |
| fn:speed_description | fn:HasLexicalUnit | fn:lu:speed_description:pace | "speed description" | "pace" | "has lexical unit" |  | "FN" |  |
| fn:speed_description | fn:HasLexicalUnit | fn:lu:speed_description:rapidly | "speed description" | "rapidly" | "has lexical unit" |  | "FN" |  |
| fn:speed_description | fn:HasLexicalUnit | fn:lu:speed_description:speedily | "speed description" | "speedily" | "has lexical unit" |  | "FN" |  |
| fn:speed_description | fn:HasLexicalUnit | fn:lu:speed_description:smart | "speed description" | "smart" | "has lexical unit" |  | "FN" |  |
| fn:speed_description | fn:HasLexicalUnit | fn:lu:speed_description:rapid | "speed description" | "rapid" | "has lexical unit" |  | "FN" |  |
| fn:speed_description | /r/HasA | fn:fe:entity | "speed description" | "entity" | "/r/has a" |  | "FN" |  |
| fn:speed_description | /r/HasA | fn:fe:attribute | "speed description" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:speed_description | /r/HasA | fn:fe:speed | "speed description" | "speed" | "/r/has a" |  | "FN" |  |
| fn:fe:degree | /r/RelatedTo | fn:fe:speed | "degree" | "speed" | "/r/related to" |  | "FN" |  |
| fn:speed_description | /r/HasA | fn:fe:degree | "speed description" | "degree" | "/r/has a" |  | "FN" |  |
| fn:speed_description | /r/HasA | fn:fe:time | "speed description" | "time" | "/r/has a" |  | "FN" |  |
| fn:speed_description | /r/HasA | fn:fe:circumstances | "speed description" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:speed_description | /r/HasA | fn:fe:explanation | "speed description" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:text_creation | /r/UsedFor | fn:spelling_and_pronouncing | "text creation" | "spelling and pronouncing" | "/r/used for" |  | "FN" |  |
| fn:spelling_and_pronouncing | fn:HasLexicalUnit | fn:lu:spelling_and_pronouncing:spell | "spelling and pronouncing" | "spell" | "has lexical unit" |  | "FN" |  |
| fn:spelling_and_pronouncing | fn:HasLexicalUnit | fn:lu:spelling_and_pronouncing:misspell | "spelling and pronouncing" | "misspell" | "has lexical unit" |  | "FN" |  |
| fn:spelling_and_pronouncing | fn:HasLexicalUnit | fn:lu:spelling_and_pronouncing:pronounce | "spelling and pronouncing" | "pronounce" | "has lexical unit" |  | "FN" |  |
| fn:spelling_and_pronouncing | fn:HasLexicalUnit | fn:lu:spelling_and_pronouncing:mispronounce | "spelling and pronouncing" | "mispronounce" | "has lexical unit" |  | "FN" |  |
| fn:spelling_and_pronouncing | fn:HasLexicalUnit | fn:lu:spelling_and_pronouncing:say | "spelling and pronouncing" | "say" | "has lexical unit" |  | "FN" |  |
| fn:spelling_and_pronouncing | fn:HasLexicalUnit | fn:lu:spelling_and_pronouncing:write | "spelling and pronouncing" | "write" | "has lexical unit" |  | "FN" |  |
| fn:spelling_and_pronouncing | fn:HasLexicalUnit | fn:lu:spelling_and_pronouncing:sound | "spelling and pronouncing" | "sound" | "has lexical unit" |  | "FN" |  |
| fn:spelling_and_pronouncing | /r/HasA | fn:fe:speaker | "spelling and pronouncing" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:spelling_and_pronouncing | /r/HasA | fn:fe:sign | "spelling and pronouncing" | "sign" | "/r/has a" |  | "FN" |  |
| fn:spelling_and_pronouncing | /r/HasA | fn:fe:judgment | "spelling and pronouncing" | "judgment" | "/r/has a" |  | "FN" |  |
| fn:spelling_and_pronouncing | /r/HasA | fn:fe:formal_realization | "spelling and pronouncing" | "formal realization" | "/r/has a" |  | "FN" |  |
| fn:spelling_and_pronouncing | /r/HasA | fn:fe:part_of_form | "spelling and pronouncing" | "part of form" | "/r/has a" |  | "FN" |  |
| fn:spelling_and_pronouncing | /r/HasA | fn:fe:manner | "spelling and pronouncing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:spelling_and_pronouncing | /r/HasA | fn:fe:time | "spelling and pronouncing" | "time" | "/r/has a" |  | "FN" |  |
| fn:spelling_and_pronouncing | /r/HasA | fn:fe:textual_location | "spelling and pronouncing" | "textual location" | "/r/has a" |  | "FN" |  |
| fn:spelling_and_pronouncing | /r/HasA | fn:fe:addressee | "spelling and pronouncing" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:spelling_and_pronouncing | /r/HasA | fn:fe:explanation | "spelling and pronouncing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:spelling_and_pronouncing | /r/HasA | fn:fe:frequency | "spelling and pronouncing" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:spelling_and_pronouncing | /r/HasA | fn:fe:depictive | "spelling and pronouncing" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:spelling_and_pronouncing | /r/HasA | fn:fe:particular_iteration | "spelling and pronouncing" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:spelling_and_pronouncing | /r/HasA | fn:fe:purpose | "spelling and pronouncing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:competition | /r/UsedFor | fn:sports_jargon | "competition" | "sports jargon" | "/r/used for" |  | "FN" |  |
| fn:sports_jargon | fn:HasLexicalUnit | fn:lu:sports_jargon:strike_[baseball] | "sports jargon" | "strike [baseball]" | "has lexical unit" |  | "FN" |  |
| fn:sports_jargon | fn:HasLexicalUnit | fn:lu:sports_jargon:strike_[bowling] | "sports jargon" | "strike [bowling]" | "has lexical unit" |  | "FN" |  |
| fn:sports_jargon | fn:HasLexicalUnit | fn:lu:sports_jargon:serve | "sports jargon" | "serve" | "has lexical unit" |  | "FN" |  |
| fn:sports_jargon | /r/HasA | fn:fe:competition | "sports jargon" | "competition" | "/r/has a" |  | "FN" |  |
| fn:sports_jargon | /r/HasA | fn:fe:agent | "sports jargon" | "agent" | "/r/has a" |  | "FN" |  |
| fn:progression | /r/UsedFor | fn:stage_of_progress | "progression" | "stage of progress" | "/r/used for" |  | "FN" |  |
| fn:stage_of_progress | fn:HasLexicalUnit | fn:lu:stage_of_progress:mature | "stage of progress" | "mature" | "has lexical unit" |  | "FN" |  |
| fn:stage_of_progress | fn:HasLexicalUnit | fn:lu:stage_of_progress:advanced | "stage of progress" | "advanced" | "has lexical unit" |  | "FN" |  |
| fn:stage_of_progress | fn:HasLexicalUnit | fn:lu:stage_of_progress:developed | "stage of progress" | "developed" | "has lexical unit" |  | "FN" |  |
| fn:stage_of_progress | fn:HasLexicalUnit | fn:lu:stage_of_progress:next_generation | "stage of progress" | "next generation" | "has lexical unit" |  | "FN" |  |
| fn:stage_of_progress | fn:HasLexicalUnit | fn:lu:stage_of_progress:low-tech | "stage of progress" | "low-tech" | "has lexical unit" |  | "FN" |  |
| fn:stage_of_progress | fn:HasLexicalUnit | fn:lu:stage_of_progress:sophisticated | "stage of progress" | "sophisticated" | "has lexical unit" |  | "FN" |  |
| fn:stage_of_progress | fn:HasLexicalUnit | fn:lu:stage_of_progress:modern | "stage of progress" | "modern" | "has lexical unit" |  | "FN" |  |
| fn:stage_of_progress | fn:HasLexicalUnit | fn:lu:stage_of_progress:cutting-edge | "stage of progress" | "cutting-edge" | "has lexical unit" |  | "FN" |  |
| fn:stage_of_progress | fn:HasLexicalUnit | fn:lu:stage_of_progress:generation | "stage of progress" | "generation" | "has lexical unit" |  | "FN" |  |
| fn:stage_of_progress | fn:HasLexicalUnit | fn:lu:stage_of_progress:state-of-the-art | "stage of progress" | "state-of-the-art" | "has lexical unit" |  | "FN" |  |
| fn:stage_of_progress | fn:HasLexicalUnit | fn:lu:stage_of_progress:high-tech | "stage of progress" | "high-tech" | "has lexical unit" |  | "FN" |  |
| fn:stage_of_progress | fn:HasLexicalUnit | fn:lu:stage_of_progress:old-fashioned | "stage of progress" | "old-fashioned" | "has lexical unit" |  | "FN" |  |
| fn:stage_of_progress | fn:HasLexicalUnit | fn:lu:stage_of_progress:maturity | "stage of progress" | "maturity" | "has lexical unit" |  | "FN" |  |
| fn:stage_of_progress | /r/HasA | fn:fe:entity | "stage of progress" | "entity" | "/r/has a" |  | "FN" |  |
| fn:stage_of_progress | /r/HasA | fn:fe:time | "stage of progress" | "time" | "/r/has a" |  | "FN" |  |
| fn:stage_of_progress | /r/HasA | fn:fe:manner | "stage of progress" | "manner" | "/r/has a" |  | "FN" |  |
| fn:stage_of_progress | /r/HasA | fn:fe:degree | "stage of progress" | "degree" | "/r/has a" |  | "FN" |  |
| fn:stage_of_progress | /r/HasA | fn:fe:domain | "stage of progress" | "domain" | "/r/has a" |  | "FN" |  |
| fn:standing_by | /r/IsA | fn:waiting | "standing by" | "waiting" | "/r/is a" |  | "FN" |  |
| fn:activity_ready_state | /r/UsedFor | fn:standing_by | "activity ready state" | "standing by" | "/r/used for" |  | "FN" |  |
| fn:standing_by | fn:HasLexicalUnit | fn:lu:standing_by:stand_by | "standing by" | "stand by" | "has lexical unit" |  | "FN" |  |
| fn:standing_by | fn:HasLexicalUnit | fn:lu:standing_by:on_call | "standing by" | "on call" | "has lexical unit" |  | "FN" |  |
| fn:standing_by | fn:HasLexicalUnit | fn:lu:standing_by:on_station | "standing by" | "on station" | "has lexical unit" |  | "FN" |  |
| fn:standing_by | /r/HasA | fn:fe:protagonist | "standing by" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:standing_by | /r/HasA | fn:fe:salient_entity | "standing by" | "salient entity" | "/r/has a" |  | "FN" |  |
| fn:standing_by | /r/HasA | fn:fe:time | "standing by" | "time" | "/r/has a" |  | "FN" |  |
| fn:standing_by | /r/HasA | fn:fe:place | "standing by" | "place" | "/r/has a" |  | "FN" |  |
| fn:standing_by | /r/HasA | fn:fe:duration | "standing by" | "duration" | "/r/has a" |  | "FN" |  |
| fn:standing_by | /r/HasA | fn:fe:manner | "standing by" | "manner" | "/r/has a" |  | "FN" |  |
| fn:standing_by | /r/HasA | fn:fe:expected_request | "standing by" | "expected request" | "/r/has a" |  | "FN" |  |
| fn:standing_by | /r/HasA | fn:fe:end_point | "standing by" | "end point" | "/r/has a" |  | "FN" |  |
| fn:standing_by | /r/HasA | fn:fe:explanation | "standing by" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:standing_by | /r/HasA | fn:fe:depictive | "standing by" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:standing_by | /r/HasA | fn:fe:purpose | "standing by" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:standing_by | /r/HasA | fn:fe:co-participant | "standing by" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:standing_by | /r/HasA | fn:fe:activity | "standing by" | "activity" | "/r/has a" |  | "FN" |  |
| fn:attention | /r/IsA | fn:state | "attention" | "state" | "/r/is a" |  | "FN" |  |
| fn:bearing_arms | /r/IsA | fn:state | "bearing arms" | "state" | "/r/is a" |  | "FN" |  |
| fn:being_attached | /r/IsA | fn:state | "being attached" | "state" | "/r/is a" |  | "FN" |  |
| fn:being_in_operation | /r/IsA | fn:state | "being in operation" | "state" | "/r/is a" |  | "FN" |  |
| fn:being_located | /r/IsA | fn:state | "being located" | "state" | "/r/is a" |  | "FN" |  |
| fn:chaos | /r/IsA | fn:state | "chaos" | "state" | "/r/is a" |  | "FN" |  |
| fn:dead_or_alive | /r/IsA | fn:state | "dead or alive" | "state" | "/r/is a" |  | "FN" |  |
| fn:dying | /r/IsA | fn:state | "dying" | "state" | "/r/is a" |  | "FN" |  |
| fn:emotions | /r/IsA | fn:state | "emotions" | "state" | "/r/is a" |  | "FN" |  |
| fn:event_endstate | /r/IsA | fn:state | "event endstate" | "state" | "/r/is a" |  | "FN" |  |
| fn:event_initial_state | /r/IsA | fn:state | "event initial state" | "state" | "/r/is a" |  | "FN" |  |
| fn:existence | /r/IsA | fn:state | "existence" | "state" | "/r/is a" |  | "FN" |  |
| fn:locative_relation | /r/IsA | fn:state | "locative relation" | "state" | "/r/is a" |  | "FN" |  |
| fn:posture | /r/IsA | fn:state | "posture" | "state" | "/r/is a" |  | "FN" |  |
| fn:process_completed_state | /r/IsA | fn:state | "process completed state" | "state" | "/r/is a" |  | "FN" |  |
| fn:process_initial_state | /r/IsA | fn:state | "process initial state" | "state" | "/r/is a" |  | "FN" |  |
| fn:process_stopped_state | /r/IsA | fn:state | "process stopped state" | "state" | "/r/is a" |  | "FN" |  |
| fn:process_uncompleted_state | /r/IsA | fn:state | "process uncompleted state" | "state" | "/r/is a" |  | "FN" |  |
| fn:state_of_entity | /r/IsA | fn:state | "state of entity" | "state" | "/r/is a" |  | "FN" |  |
| fn:thriving | /r/IsA | fn:state | "thriving" | "state" | "/r/is a" |  | "FN" |  |
| fn:transportation_status | /r/IsA | fn:state | "transportation status" | "state" | "/r/is a" |  | "FN" |  |
| fn:state | /r/UsedFor | fn:state_continue | "state" | "state continue" | "/r/used for" |  | "FN" |  |
| fn:state | /r/HasA | fn:fe:entity | "state" | "entity" | "/r/has a" |  | "FN" |  |
| fn:state | /r/HasA | fn:fe:state | "state" | "state" | "/r/has a" |  | "FN" |  |
| fn:state | /r/UsedFor | fn:state_continue | "state" | "state continue" | "/r/used for" |  | "FN" |  |
| fn:state_continue | /r/UsedFor | fn:continued_state_of_affairs | "state continue" | "continued state of affairs" | "/r/used for" |  | "FN" |  |
| fn:cause_to_continue | /r/Causes | fn:state_continue | "cause to continue" | "state continue" | "/r/causes" |  | "FN" |  |
| fn:state_continue | fn:HasLexicalUnit | fn:lu:state_continue:remain | "state continue" | "remain" | "has lexical unit" |  | "FN" |  |
| fn:state_continue | fn:HasLexicalUnit | fn:lu:state_continue:stay | "state continue" | "stay" | "has lexical unit" |  | "FN" |  |
| fn:state_continue | fn:HasLexicalUnit | fn:lu:state_continue:rest | "state continue" | "rest" | "has lexical unit" |  | "FN" |  |
| fn:state_continue | /r/HasA | fn:fe:entity | "state continue" | "entity" | "/r/has a" |  | "FN" |  |
| fn:state_continue | /r/HasA | fn:fe:state | "state continue" | "state" | "/r/has a" |  | "FN" |  |
| fn:state_continue | /r/HasA | fn:fe:time | "state continue" | "time" | "/r/has a" |  | "FN" |  |
| fn:state_continue | /r/HasA | fn:fe:place | "state continue" | "place" | "/r/has a" |  | "FN" |  |
| fn:state_continue | /r/HasA | fn:fe:explanation | "state continue" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:state_continue | /r/HasA | fn:fe:duration | "state continue" | "duration" | "/r/has a" |  | "FN" |  |
| fn:state_continue | /r/HasA | fn:fe:circumstances | "state continue" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:state_continue | /r/HasA | fn:fe:depictive | "state continue" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:state_of_entity | /r/IsA | fn:state | "state of entity" | "state" | "/r/is a" |  | "FN" |  |
| fn:predicament | /r/IsA | fn:state_of_entity | "predicament" | "state of entity" | "/r/is a" |  | "FN" |  |
| fn:state_of_entity | fn:HasLexicalUnit | fn:lu:state_of_entity:state | "state of entity" | "state" | "has lexical unit" |  | "FN" |  |
| fn:state_of_entity | fn:HasLexicalUnit | fn:lu:state_of_entity:condition | "state of entity" | "condition" | "has lexical unit" |  | "FN" |  |
| fn:state_of_entity | /r/HasA | fn:fe:entity | "state of entity" | "entity" | "/r/has a" |  | "FN" |  |
| fn:state_of_entity | /r/HasA | fn:fe:evaluation | "state of entity" | "evaluation" | "/r/has a" |  | "FN" |  |
| fn:state_of_entity | /r/HasA | fn:fe:state | "state of entity" | "state" | "/r/has a" |  | "FN" |  |
| fn:state_of_entity | /r/HasA | fn:fe:parameter | "state of entity" | "parameter" | "/r/has a" |  | "FN" |  |
| fn:affirm_or_deny | /r/IsA | fn:statement | "affirm or deny" | "statement" | "/r/is a" |  | "FN" |  |
| fn:complaining | /r/IsA | fn:statement | "complaining" | "statement" | "/r/is a" |  | "FN" |  |
| fn:predicting | /r/IsA | fn:statement | "predicting" | "statement" | "/r/is a" |  | "FN" |  |
| fn:reading_aloud | /r/IsA | fn:statement | "reading aloud" | "statement" | "/r/is a" |  | "FN" |  |
| fn:recording | /r/IsA | fn:statement | "recording" | "statement" | "/r/is a" |  | "FN" |  |
| fn:reveal_secret | /r/IsA | fn:statement | "reveal secret" | "statement" | "/r/is a" |  | "FN" |  |
| fn:telling | /r/IsA | fn:statement | "telling" | "statement" | "/r/is a" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:statement | "communication" | "statement" | "/r/used for" |  | "FN" |  |
| fn:statement | /r/UsedFor | fn:adducing | "statement" | "adducing" | "/r/used for" |  | "FN" |  |
| fn:statement | /r/UsedFor | fn:attributed_information | "statement" | "attributed information" | "/r/used for" |  | "FN" |  |
| fn:statement | /r/UsedFor | fn:chatting | "statement" | "chatting" | "/r/used for" |  | "FN" |  |
| fn:statement | /r/UsedFor | fn:judgment_communication | "statement" | "judgment communication" | "/r/used for" |  | "FN" |  |
| fn:statement | /r/UsedFor | fn:renunciation | "statement" | "renunciation" | "/r/used for" |  | "FN" |  |
| fn:statement | /r/UsedFor | fn:unattributed_information | "statement" | "unattributed information" | "/r/used for" |  | "FN" |  |
| fn:body_movement | /r/SimilarTo | fn:statement | "body movement" | "statement" | "/r/similar to" |  | "FN" |  |
| fn:categorization | /r/SimilarTo | fn:statement | "categorization" | "statement" | "/r/similar to" |  | "FN" |  |
| fn:encoding | /r/SimilarTo | fn:statement | "encoding" | "statement" | "/r/similar to" |  | "FN" |  |
| fn:speak_on_topic | /r/SimilarTo | fn:statement | "speak on topic" | "statement" | "/r/similar to" |  | "FN" |  |
| fn:statement | /r/SimilarTo | fn:affirm_or_deny | "statement" | "affirm or deny" | "/r/similar to" |  | "FN" |  |
| fn:statement | /r/SimilarTo | fn:bragging | "statement" | "bragging" | "/r/similar to" |  | "FN" |  |
| fn:statement | /r/SimilarTo | fn:commitment | "statement" | "commitment" | "/r/similar to" |  | "FN" |  |
| fn:statement | /r/SimilarTo | fn:complaining | "statement" | "complaining" | "/r/similar to" |  | "FN" |  |
| fn:statement | /r/SimilarTo | fn:encoding | "statement" | "encoding" | "/r/similar to" |  | "FN" |  |
| fn:statement | /r/SimilarTo | fn:expressing_publicly | "statement" | "expressing publicly" | "/r/similar to" |  | "FN" |  |
| fn:statement | /r/SimilarTo | fn:reveal_secret | "statement" | "reveal secret" | "/r/similar to" |  | "FN" |  |
| fn:statement | /r/SimilarTo | fn:speak_on_topic | "statement" | "speak on topic" | "/r/similar to" |  | "FN" |  |
| fn:statement | /r/SimilarTo | fn:successfully_communicate_message | "statement" | "successfully communicate message" | "/r/similar to" |  | "FN" |  |
| fn:statement | /r/SimilarTo | fn:telling | "statement" | "telling" | "/r/similar to" |  | "FN" |  |
| fn:statement | /r/SimilarTo | fn:translating | "statement" | "translating" | "/r/similar to" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:add | "statement" | "add" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:address | "statement" | "address" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:admission | "statement" | "admission" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:allegation | "statement" | "allegation" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:allege | "statement" | "allege" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:announce | "statement" | "announce" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:announcement | "statement" | "announcement" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:assert | "statement" | "assert" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:assertion | "statement" | "assertion" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:attest | "statement" | "attest" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:aver | "statement" | "aver" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:avow | "statement" | "avow" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:caution | "statement" | "caution" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:claim | "statement" | "claim" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:claim | "statement" | "claim" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:comment | "statement" | "comment" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:comment | "statement" | "comment" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:concession | "statement" | "concession" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:conjecture | "statement" | "conjecture" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:conjecture | "statement" | "conjecture" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:contend | "statement" | "contend" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:contention | "statement" | "contention" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:declaration | "statement" | "declaration" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:declare | "statement" | "declare" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:denial | "statement" | "denial" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:exclaim | "statement" | "exclaim" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:exclamation | "statement" | "exclamation" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:explain | "statement" | "explain" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:gloat | "statement" | "gloat" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:insist | "statement" | "insist" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:maintain | "statement" | "maintain" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:mention | "statement" | "mention" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:mention | "statement" | "mention" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:preach | "statement" | "preach" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:proclaim | "statement" | "proclaim" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:proclamation | "statement" | "proclamation" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:profess | "statement" | "profess" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:pronouncement | "statement" | "pronouncement" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:proposal | "statement" | "proposal" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:propose | "statement" | "propose" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:proposition | "statement" | "proposition" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:reaffirm | "statement" | "reaffirm" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:recount | "statement" | "recount" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:reiterate | "statement" | "reiterate" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:relate | "statement" | "relate" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:remark | "statement" | "remark" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:remark | "statement" | "remark" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:report | "statement" | "report" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:report | "statement" | "report" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:say | "statement" | "say" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:speak | "statement" | "speak" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:state | "statement" | "state" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:statement | "statement" | "statement" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:suggest | "statement" | "suggest" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:talk | "statement" | "talk" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:write | "statement" | "write" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:insistence | "statement" | "insistence" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:explanation | "statement" | "explanation" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:venture | "statement" | "venture" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:hazard | "statement" | "hazard" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:pout | "statement" | "pout" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:smirk | "statement" | "smirk" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:confirm | "statement" | "confirm" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:avowal | "statement" | "avowal" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:acknowledge | "statement" | "acknowledge" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:acknowledgment | "statement" | "acknowledgment" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:note | "statement" | "note" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:observe | "statement" | "observe" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:refute | "statement" | "refute" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:describe | "statement" | "describe" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:promulgation | "statement" | "promulgation" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:message | "statement" | "message" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:detail | "statement" | "detail" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:tell | "statement" | "tell" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:allow | "statement" | "allow" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:caution | "statement" | "caution" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:be_like | "statement" | "be like" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:challenge | "statement" | "challenge" | "has lexical unit" |  | "FN" |  |
| fn:statement | fn:HasLexicalUnit | fn:lu:statement:pronounce | "statement" | "pronounce" | "has lexical unit" |  | "FN" |  |
| fn:statement | /r/HasA | fn:fe:speaker | "statement" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:statement | /r/HasA | fn:fe:addressee | "statement" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:statement | /r/HasA | fn:fe:message | "statement" | "message" | "/r/has a" |  | "FN" |  |
| fn:statement | /r/HasA | fn:fe:topic | "statement" | "topic" | "/r/has a" |  | "FN" |  |
| fn:statement | /r/HasA | fn:fe:manner | "statement" | "manner" | "/r/has a" |  | "FN" |  |
| fn:statement | /r/HasA | fn:fe:means | "statement" | "means" | "/r/has a" |  | "FN" |  |
| fn:statement | /r/HasA | fn:fe:internal_cause | "statement" | "internal cause" | "/r/has a" |  | "FN" |  |
| fn:statement | /r/HasA | fn:fe:medium | "statement" | "medium" | "/r/has a" |  | "FN" |  |
| fn:statement | /r/HasA | fn:fe:depictive | "statement" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:statement | /r/HasA | fn:fe:time | "statement" | "time" | "/r/has a" |  | "FN" |  |
| fn:statement | /r/HasA | fn:fe:place | "statement" | "place" | "/r/has a" |  | "FN" |  |
| fn:statement | /r/HasA | fn:fe:occasion | "statement" | "occasion" | "/r/has a" |  | "FN" |  |
| fn:statement | /r/HasA | fn:fe:particular_iteration | "statement" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:statement | /r/HasA | fn:fe:communicative_force | "statement" | "communicative force" | "/r/has a" |  | "FN" |  |
| fn:statement | /r/HasA | fn:fe:degree | "statement" | "degree" | "/r/has a" |  | "FN" |  |
| fn:statement | /r/HasA | fn:fe:group | "statement" | "group" | "/r/has a" |  | "FN" |  |
| fn:statement | /r/HasA | fn:fe:event_description | "statement" | "event description" | "/r/has a" |  | "FN" |  |
| fn:statement | /r/HasA | fn:fe:frequency | "statement" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:statement | /r/HasA | fn:fe:iterations | "statement" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:statement | /r/HasA | fn:fe:containing_event | "statement" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:ineffability | /r/IsA | fn:stimulus_focus | "ineffability" | "stimulus focus" | "/r/is a" |  | "FN" |  |
| fn:stimulus_focus | /r/SimilarTo | fn:mental_stimulus_stimulus_focus | "stimulus focus" | "mental stimulus stimulus focus" | "/r/similar to" |  | "FN" |  |
| fn:stimulus_focus | /r/IsA | fn:emotions | "stimulus focus" | "emotions" | "/r/is a" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:gratifying | "stimulus focus" | "gratifying" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:delightful | "stimulus focus" | "delightful" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:alarming | "stimulus focus" | "alarming" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:worrisome | "stimulus focus" | "worrisome" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:agonizing | "stimulus focus" | "agonizing" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:comforting | "stimulus focus" | "comforting" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:maddening | "stimulus focus" | "maddening" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:sobering | "stimulus focus" | "sobering" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:terrifying | "stimulus focus" | "terrifying" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:pathetic | "stimulus focus" | "pathetic" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:pitiful | "stimulus focus" | "pitiful" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:aggravating | "stimulus focus" | "aggravating" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:exasperating | "stimulus focus" | "exasperating" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:vexing | "stimulus focus" | "vexing" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:revolting | "stimulus focus" | "revolting" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:heartening | "stimulus focus" | "heartening" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:disheartening | "stimulus focus" | "disheartening" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:embittering | "stimulus focus" | "embittering" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:discomfiting | "stimulus focus" | "discomfiting" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:discomforting | "stimulus focus" | "discomforting" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:beguiling | "stimulus focus" | "beguiling" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:captivating | "stimulus focus" | "captivating" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:cheering | "stimulus focus" | "cheering" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:disillusioning | "stimulus focus" | "disillusioning" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:upsetting | "stimulus focus" | "upsetting" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:unsettling | "stimulus focus" | "unsettling" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:unnerving | "stimulus focus" | "unnerving" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:troubling | "stimulus focus" | "troubling" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:tormenting | "stimulus focus" | "tormenting" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:thrilling | "stimulus focus" | "thrilling" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:stupefying | "stimulus focus" | "stupefying" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:stirring | "stimulus focus" | "stirring" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:stinging | "stimulus focus" | "stinging" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:stimulating | "stimulus focus" | "stimulating" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:startling | "stimulus focus" | "startling" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:soothing | "stimulus focus" | "soothing" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:sickening | "stimulus focus" | "sickening" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:perplexing | "stimulus focus" | "perplexing" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:infuriating | "stimulus focus" | "infuriating" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:shocking | "stimulus focus" | "shocking" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:scary | "stimulus focus" | "scary" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:surprising | "stimulus focus" | "surprising" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:saddening | "stimulus focus" | "saddening" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:repellent | "stimulus focus" | "repellent" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:reassuring | "stimulus focus" | "reassuring" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:displeasing | "stimulus focus" | "displeasing" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:unpleasing | "stimulus focus" | "unpleasing" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:pleasing | "stimulus focus" | "pleasing" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:pleasant | "stimulus focus" | "pleasant" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:unpleasant | "stimulus focus" | "unpleasant" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:pleasurable | "stimulus focus" | "pleasurable" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:enjoyable | "stimulus focus" | "enjoyable" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:blood-curdling | "stimulus focus" | "blood-curdling" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:hair-raising | "stimulus focus" | "hair-raising" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:spine-chilling | "stimulus focus" | "spine-chilling" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:frightening | "stimulus focus" | "frightening" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:dismaying | "stimulus focus" | "dismaying" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:heart-warming | "stimulus focus" | "heart-warming" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:uplifting | "stimulus focus" | "uplifting" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:irksome | "stimulus focus" | "irksome" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:irritating | "stimulus focus" | "irritating" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:enraging | "stimulus focus" | "enraging" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:galling | "stimulus focus" | "galling" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:vexatious | "stimulus focus" | "vexatious" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:worrying | "stimulus focus" | "worrying" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:mortifying | "stimulus focus" | "mortifying" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:annoying | "stimulus focus" | "annoying" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:bothersome | "stimulus focus" | "bothersome" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:troublesome | "stimulus focus" | "troublesome" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:boring | "stimulus focus" | "boring" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:encouraging | "stimulus focus" | "encouraging" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:distressing | "stimulus focus" | "distressing" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:alienating | "stimulus focus" | "alienating" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:tiresome | "stimulus focus" | "tiresome" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:astonishing | "stimulus focus" | "astonishing" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:astounding | "stimulus focus" | "astounding" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:appalling | "stimulus focus" | "appalling" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:baffling | "stimulus focus" | "baffling" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:bewildering | "stimulus focus" | "bewildering" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:bewitching | "stimulus focus" | "bewitching" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:calming | "stimulus focus" | "calming" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:relaxing | "stimulus focus" | "relaxing" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:charming | "stimulus focus" | "charming" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:confusing | "stimulus focus" | "confusing" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:consoling | "stimulus focus" | "consoling" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:depressing | "stimulus focus" | "depressing" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:disappointing | "stimulus focus" | "disappointing" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:disconcerting | "stimulus focus" | "disconcerting" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:discouraging | "stimulus focus" | "discouraging" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:disturbing | "stimulus focus" | "disturbing" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:embarrassing | "stimulus focus" | "embarrassing" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:enchanting | "stimulus focus" | "enchanting" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:entertaining | "stimulus focus" | "entertaining" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:enthralling | "stimulus focus" | "enthralling" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:exciting | "stimulus focus" | "exciting" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:exhilarating | "stimulus focus" | "exhilarating" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:pacifying | "stimulus focus" | "pacifying" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:placating | "stimulus focus" | "placating" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:heartbreaking | "stimulus focus" | "heartbreaking" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:nerve-racking | "stimulus focus" | "nerve-racking" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:stressful | "stimulus focus" | "stressful" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:spine-tingling | "stimulus focus" | "spine-tingling" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:heart-rending | "stimulus focus" | "heart-rending" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:heart-stopping | "stimulus focus" | "heart-stopping" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:suspenseful | "stimulus focus" | "suspenseful" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:sad | "stimulus focus" | "sad" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:hilarious | "stimulus focus" | "hilarious" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:unfunny | "stimulus focus" | "unfunny" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:droll | "stimulus focus" | "droll" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:comical | "stimulus focus" | "comical" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:white-knuckle | "stimulus focus" | "white-knuckle" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:rousing | "stimulus focus" | "rousing" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:tear-jerking | "stimulus focus" | "tear-jerking" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:funny | "stimulus focus" | "funny" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:jaw-dropping | "stimulus focus" | "jaw-dropping" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:earth-shattering | "stimulus focus" | "earth-shattering" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:devastating | "stimulus focus" | "devastating" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:side-splitting | "stimulus focus" | "side-splitting" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:humorous | "stimulus focus" | "humorous" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:dull | "stimulus focus" | "dull" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:unexciting | "stimulus focus" | "unexciting" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:intriguing | "stimulus focus" | "intriguing" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:fascinating | "stimulus focus" | "fascinating" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:offensive | "stimulus focus" | "offensive" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:mind-numbing | "stimulus focus" | "mind-numbing" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:tedious | "stimulus focus" | "tedious" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:gripping | "stimulus focus" | "gripping" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:absorbing | "stimulus focus" | "absorbing" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:engrossing | "stimulus focus" | "engrossing" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:tiring | "stimulus focus" | "tiring" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:intimidating | "stimulus focus" | "intimidating" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:traumatising | "stimulus focus" | "traumatising" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:traumatic | "stimulus focus" | "traumatic" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:poignant | "stimulus focus" | "poignant" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:disorientating | "stimulus focus" | "disorientating" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:mystifying | "stimulus focus" | "mystifying" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:thorny | "stimulus focus" | "thorny" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:electrifying | "stimulus focus" | "electrifying" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:invigorating | "stimulus focus" | "invigorating" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:disagreeable | "stimulus focus" | "disagreeable" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:agreeable | "stimulus focus" | "agreeable" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:nice | "stimulus focus" | "nice" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:dreadful | "stimulus focus" | "dreadful" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:distasteful | "stimulus focus" | "distasteful" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:ghastly | "stimulus focus" | "ghastly" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:abominable | "stimulus focus" | "abominable" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:delight | "stimulus focus" | "delight" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:aggravation | "stimulus focus" | "aggravation" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:annoyance | "stimulus focus" | "annoyance" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:vexation | "stimulus focus" | "vexation" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:amusing | "stimulus focus" | "amusing" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:jolly | "stimulus focus" | "jolly" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:harrowing | "stimulus focus" | "harrowing" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:chilling | "stimulus focus" | "chilling" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:touching | "stimulus focus" | "touching" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:amazing | "stimulus focus" | "amazing" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:empty | "stimulus focus" | "empty" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:fulfilling | "stimulus focus" | "fulfilling" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:full | "stimulus focus" | "full" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:rich | "stimulus focus" | "rich" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:unfulfilling | "stimulus focus" | "unfulfilling" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:satisfying | "stimulus focus" | "satisfying" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:solemn | "stimulus focus" | "solemn" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:mind-boggling | "stimulus focus" | "mind-boggling" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:breathtaking | "stimulus focus" | "breathtaking" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:impressive | "stimulus focus" | "impressive" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:formidable | "stimulus focus" | "formidable" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:striking | "stimulus focus" | "striking" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:disgusting | "stimulus focus" | "disgusting" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:charm_[mass] | "stimulus focus" | "charm [mass]" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:charm_[count] | "stimulus focus" | "charm [count]" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:recreation | "stimulus focus" | "recreation" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:relaxation | "stimulus focus" | "relaxation" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:insulting | "stimulus focus" | "insulting" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:rest | "stimulus focus" | "rest" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:cool | "stimulus focus" | "cool" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:color | "stimulus focus" | "color" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:strike_a_chord | "stimulus focus" | "strike a chord" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | fn:HasLexicalUnit | fn:lu:stimulus_focus:dear | "stimulus focus" | "dear" | "has lexical unit" |  | "FN" |  |
| fn:stimulus_focus | /r/HasA | fn:fe:stimulus | "stimulus focus" | "stimulus" | "/r/has a" |  | "FN" |  |
| fn:stimulus_focus | /r/HasA | fn:fe:experiencer | "stimulus focus" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:stimulus_focus | /r/HasA | fn:fe:degree | "stimulus focus" | "degree" | "/r/has a" |  | "FN" |  |
| fn:stimulus_focus | /r/HasA | fn:fe:circumstances | "stimulus focus" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:stimulus_focus | /r/HasA | fn:fe:parameter | "stimulus focus" | "parameter" | "/r/has a" |  | "FN" |  |
| fn:stimulus_focus | /r/HasA | fn:fe:comparison_set | "stimulus focus" | "comparison set" | "/r/has a" |  | "FN" |  |
| fn:stimulus_focus | /r/HasA | fn:fe:property | "stimulus focus" | "property" | "/r/has a" |  | "FN" |  |
| fn:stinginess | /r/IsA | fn:social_interaction_evaluation | "stinginess" | "social interaction evaluation" | "/r/is a" |  | "FN" |  |
| fn:frugality | /r/SimilarTo | fn:stinginess | "frugality" | "stinginess" | "/r/similar to" |  | "FN" |  |
| fn:stinginess | fn:HasLexicalUnit | fn:lu:stinginess:generous | "stinginess" | "generous" | "has lexical unit" |  | "FN" |  |
| fn:stinginess | fn:HasLexicalUnit | fn:lu:stinginess:stingy | "stinginess" | "stingy" | "has lexical unit" |  | "FN" |  |
| fn:stinginess | fn:HasLexicalUnit | fn:lu:stinginess:mean | "stinginess" | "mean" | "has lexical unit" |  | "FN" |  |
| fn:stinginess | fn:HasLexicalUnit | fn:lu:stinginess:lavish | "stinginess" | "lavish" | "has lexical unit" |  | "FN" |  |
| fn:stinginess | fn:HasLexicalUnit | fn:lu:stinginess:lavish | "stinginess" | "lavish" | "has lexical unit" |  | "FN" |  |
| fn:stinginess | fn:HasLexicalUnit | fn:lu:stinginess:miserliness | "stinginess" | "miserliness" | "has lexical unit" |  | "FN" |  |
| fn:stinginess | fn:HasLexicalUnit | fn:lu:stinginess:miser | "stinginess" | "miser" | "has lexical unit" |  | "FN" |  |
| fn:stinginess | fn:HasLexicalUnit | fn:lu:stinginess:hoard | "stinginess" | "hoard" | "has lexical unit" |  | "FN" |  |
| fn:stinginess | fn:HasLexicalUnit | fn:lu:stinginess:miserly | "stinginess" | "miserly" | "has lexical unit" |  | "FN" |  |
| fn:stinginess | fn:HasLexicalUnit | fn:lu:stinginess:niggardliness | "stinginess" | "niggardliness" | "has lexical unit" |  | "FN" |  |
| fn:stinginess | fn:HasLexicalUnit | fn:lu:stinginess:niggardly | "stinginess" | "niggardly" | "has lexical unit" |  | "FN" |  |
| fn:stinginess | fn:HasLexicalUnit | fn:lu:stinginess:ungenerous | "stinginess" | "ungenerous" | "has lexical unit" |  | "FN" |  |
| fn:stinginess | /r/HasA | fn:fe:resource_controller | "stinginess" | "resource controller" | "/r/has a" |  | "FN" |  |
| fn:stinginess | /r/HasA | fn:fe:resource | "stinginess" | "resource" | "/r/has a" |  | "FN" |  |
| fn:stinginess | /r/HasA | fn:fe:recipient | "stinginess" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:stinginess | /r/HasA | fn:fe:degree | "stinginess" | "degree" | "/r/has a" |  | "FN" |  |
| fn:stinginess | /r/HasA | fn:fe:behavior | "stinginess" | "behavior" | "/r/has a" |  | "FN" |  |
| fn:stinginess | /r/HasA | fn:fe:judge | "stinginess" | "judge" | "/r/has a" |  | "FN" |  |
| fn:stinginess | /r/HasA | fn:fe:expressor | "stinginess" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:stinginess | /r/HasA | fn:fe:manner | "stinginess" | "manner" | "/r/has a" |  | "FN" |  |
| fn:store | /r/IsA | fn:aggregate | "store" | "aggregate" | "/r/is a" |  | "FN" |  |
| fn:cache | /r/IsA | fn:store | "cache" | "store" | "/r/is a" |  | "FN" |  |
| fn:storing | /r/UsedFor | fn:store | "storing" | "store" | "/r/used for" |  | "FN" |  |
| fn:store | fn:HasLexicalUnit | fn:lu:store:store | "store" | "store" | "has lexical unit" |  | "FN" |  |
| fn:store | fn:HasLexicalUnit | fn:lu:store:stock | "store" | "stock" | "has lexical unit" |  | "FN" |  |
| fn:store | fn:HasLexicalUnit | fn:lu:store:stockpile | "store" | "stockpile" | "has lexical unit" |  | "FN" |  |
| fn:store | fn:HasLexicalUnit | fn:lu:store:supply | "store" | "supply" | "has lexical unit" |  | "FN" |  |
| fn:store | fn:HasLexicalUnit | fn:lu:store:inventory | "store" | "inventory" | "has lexical unit" |  | "FN" |  |
| fn:store | fn:HasLexicalUnit | fn:lu:store:reserve | "store" | "reserve" | "has lexical unit" |  | "FN" |  |
| fn:store | fn:HasLexicalUnit | fn:lu:store:cargo | "store" | "cargo" | "has lexical unit" |  | "FN" |  |
| fn:store | /r/HasA | fn:fe:supply | "store" | "supply" | "/r/has a" |  | "FN" |  |
| fn:store | /r/HasA | fn:fe:resource | "store" | "resource" | "/r/has a" |  | "FN" |  |
| fn:store | /r/HasA | fn:fe:use | "store" | "use" | "/r/has a" |  | "FN" |  |
| fn:store | /r/HasA | fn:fe:possessor | "store" | "possessor" | "/r/has a" |  | "FN" |  |
| fn:store | /r/HasA | fn:fe:descriptor | "store" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:placing | /r/UsedFor | fn:storing | "placing" | "storing" | "/r/used for" |  | "FN" |  |
| fn:storing | /r/UsedFor | fn:carry_goods | "storing" | "carry goods" | "/r/used for" |  | "FN" |  |
| fn:storing | /r/UsedFor | fn:store | "storing" | "store" | "/r/used for" |  | "FN" |  |
| fn:storing | fn:HasLexicalUnit | fn:lu:storing:storage | "storing" | "storage" | "has lexical unit" |  | "FN" |  |
| fn:storing | fn:HasLexicalUnit | fn:lu:storing:store | "storing" | "store" | "has lexical unit" |  | "FN" |  |
| fn:storing | fn:HasLexicalUnit | fn:lu:storing:warehouse | "storing" | "warehouse" | "has lexical unit" |  | "FN" |  |
| fn:storing | fn:HasLexicalUnit | fn:lu:storing:cache | "storing" | "cache" | "has lexical unit" |  | "FN" |  |
| fn:storing | fn:HasLexicalUnit | fn:lu:storing:keep | "storing" | "keep" | "has lexical unit" |  | "FN" |  |
| fn:storing | fn:HasLexicalUnit | fn:lu:storing:cellar | "storing" | "cellar" | "has lexical unit" |  | "FN" |  |
| fn:storing | fn:HasLexicalUnit | fn:lu:storing:stock | "storing" | "stock" | "has lexical unit" |  | "FN" |  |
| fn:storing | /r/HasA | fn:fe:agent | "storing" | "agent" | "/r/has a" |  | "FN" |  |
| fn:storing | /r/HasA | fn:fe:theme | "storing" | "theme" | "/r/has a" |  | "FN" |  |
| fn:storing | /r/HasA | fn:fe:location | "storing" | "location" | "/r/has a" |  | "FN" |  |
| fn:storing | /r/HasA | fn:fe:manner | "storing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:storing | /r/HasA | fn:fe:depictive | "storing" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:storing | /r/HasA | fn:fe:duration | "storing" | "duration" | "/r/has a" |  | "FN" |  |
| fn:storing | /r/HasA | fn:fe:place | "storing" | "place" | "/r/has a" |  | "FN" |  |
| fn:storing | /r/HasA | fn:fe:explanation | "storing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:storing | /r/HasA | fn:fe:time | "storing" | "time" | "/r/has a" |  | "FN" |  |
| fn:storing | /r/HasA | fn:fe:area | "storing" | "area" | "/r/has a" |  | "FN" |  |
| fn:storing | /r/HasA | fn:fe:co-participant | "storing" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:storing | /r/HasA | fn:fe:purpose | "storing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:storing | /r/HasA | fn:fe:frequency | "storing" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:strictness | /r/IsA | fn:social_interaction_evaluation | "strictness" | "social interaction evaluation" | "/r/is a" |  | "FN" |  |
| fn:compliance | /r/UsedFor | fn:strictness | "compliance" | "strictness" | "/r/used for" |  | "FN" |  |
| fn:strictness | fn:HasLexicalUnit | fn:lu:strictness:authoritarian | "strictness" | "authoritarian" | "has lexical unit" |  | "FN" |  |
| fn:strictness | fn:HasLexicalUnit | fn:lu:strictness:indulgent | "strictness" | "indulgent" | "has lexical unit" |  | "FN" |  |
| fn:strictness | fn:HasLexicalUnit | fn:lu:strictness:lenient | "strictness" | "lenient" | "has lexical unit" |  | "FN" |  |
| fn:strictness | fn:HasLexicalUnit | fn:lu:strictness:liberal | "strictness" | "liberal" | "has lexical unit" |  | "FN" |  |
| fn:strictness | fn:HasLexicalUnit | fn:lu:strictness:strict | "strictness" | "strict" | "has lexical unit" |  | "FN" |  |
| fn:strictness | fn:HasLexicalUnit | fn:lu:strictness:tolerant | "strictness" | "tolerant" | "has lexical unit" |  | "FN" |  |
| fn:strictness | fn:HasLexicalUnit | fn:lu:strictness:severe | "strictness" | "severe" | "has lexical unit" |  | "FN" |  |
| fn:strictness | /r/HasA | fn:fe:agent | "strictness" | "agent" | "/r/has a" |  | "FN" |  |
| fn:strictness | /r/HasA | fn:fe:controlled_entity | "strictness" | "controlled entity" | "/r/has a" |  | "FN" |  |
| fn:strictness | /r/HasA | fn:fe:controlling_act | "strictness" | "controlling act" | "/r/has a" |  | "FN" |  |
| fn:strictness | /r/HasA | fn:fe:issue | "strictness" | "issue" | "/r/has a" |  | "FN" |  |
| fn:strictness | /r/HasA | fn:fe:medium | "strictness" | "medium" | "/r/has a" |  | "FN" |  |
| fn:strictness | /r/HasA | fn:fe:degree | "strictness" | "degree" | "/r/has a" |  | "FN" |  |
| fn:strictness | /r/HasA | fn:fe:area | "strictness" | "area" | "/r/has a" |  | "FN" |  |
| fn:strictness | /r/HasA | fn:fe:judge | "strictness" | "judge" | "/r/has a" |  | "FN" |  |
| fn:strictness | /r/HasA | fn:fe:expressor | "strictness" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:strictness | /r/HasA | fn:fe:manner | "strictness" | "manner" | "/r/has a" |  | "FN" |  |
| fn:education_teaching | /r/UsedFor | fn:studying | "education teaching" | "studying" | "/r/used for" |  | "FN" |  |
| fn:studying | fn:HasLexicalUnit | fn:lu:studying:study | "studying" | "study" | "has lexical unit" |  | "FN" |  |
| fn:studying | /r/HasA | fn:fe:teacher | "studying" | "teacher" | "/r/has a" |  | "FN" |  |
| fn:studying | /r/HasA | fn:fe:student | "studying" | "student" | "/r/has a" |  | "FN" |  |
| fn:studying | /r/HasA | fn:fe:institution | "studying" | "institution" | "/r/has a" |  | "FN" |  |
| fn:studying | /r/HasA | fn:fe:subject | "studying" | "subject" | "/r/has a" |  | "FN" |  |
| fn:studying | /r/HasA | fn:fe:level | "studying" | "level" | "/r/has a" |  | "FN" |  |
| fn:studying | /r/HasA | fn:fe:depictive | "studying" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:studying | /r/HasA | fn:fe:manner | "studying" | "manner" | "/r/has a" |  | "FN" |  |
| fn:studying | /r/HasA | fn:fe:time | "studying" | "time" | "/r/has a" |  | "FN" |  |
| fn:studying | /r/HasA | fn:fe:place | "studying" | "place" | "/r/has a" |  | "FN" |  |
| fn:studying | /r/HasA | fn:fe:duration | "studying" | "duration" | "/r/has a" |  | "FN" |  |
| fn:studying | /r/HasA | fn:fe:explanation | "studying" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:studying | /r/HasA | fn:fe:co-participant | "studying" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:studying | /r/HasA | fn:fe:intended_academic_credit | "studying" | "intended academic credit" | "/r/has a" |  | "FN" |  |
| fn:suasion | /r/IsA | fn:eventive_cognizer_affecting | "suasion" | "eventive cognizer affecting" | "/r/is a" |  | "FN" |  |
| fn:suasion | /r/IsA | fn:telling | "suasion" | "telling" | "/r/is a" |  | "FN" |  |
| fn:attempt_suasion | /r/UsedFor | fn:suasion | "attempt suasion" | "suasion" | "/r/used for" |  | "FN" |  |
| fn:eventive_cognizer_affecting | /r/UsedFor | fn:suasion | "eventive cognizer affecting" | "suasion" | "/r/used for" |  | "FN" |  |
| fn:suasion | /r/UsedFor | fn:talking_into | "suasion" | "talking into" | "/r/used for" |  | "FN" |  |
| fn:suasion | /r/SimilarTo | fn:causation | "suasion" | "causation" | "/r/similar to" |  | "FN" |  |
| fn:talking_into | /r/SimilarTo | fn:suasion | "talking into" | "suasion" | "/r/similar to" |  | "FN" |  |
| fn:suasion | /r/Causes | fn:deciding | "suasion" | "deciding" | "/r/causes" |  | "FN" |  |
| fn:suasion | fn:HasLexicalUnit | fn:lu:suasion:convince | "suasion" | "convince" | "has lexical unit" |  | "FN" |  |
| fn:suasion | fn:HasLexicalUnit | fn:lu:suasion:dissuade | "suasion" | "dissuade" | "has lexical unit" |  | "FN" |  |
| fn:suasion | fn:HasLexicalUnit | fn:lu:suasion:motivate | "suasion" | "motivate" | "has lexical unit" |  | "FN" |  |
| fn:suasion | fn:HasLexicalUnit | fn:lu:suasion:persuade | "suasion" | "persuade" | "has lexical unit" |  | "FN" |  |
| fn:suasion | fn:HasLexicalUnit | fn:lu:suasion:sway | "suasion" | "sway" | "has lexical unit" |  | "FN" |  |
| fn:suasion | fn:HasLexicalUnit | fn:lu:suasion:incite | "suasion" | "incite" | "has lexical unit" |  | "FN" |  |
| fn:suasion | /r/HasA | fn:fe:addressee | "suasion" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:suasion | /r/HasA | fn:fe:speaker | "suasion" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:suasion | /r/HasA | fn:fe:content | "suasion" | "content" | "/r/has a" |  | "FN" |  |
| fn:suasion | /r/HasA | fn:fe:text | "suasion" | "text" | "/r/has a" |  | "FN" |  |
| fn:suasion | /r/HasA | fn:fe:topic | "suasion" | "topic" | "/r/has a" |  | "FN" |  |
| fn:suasion | /r/HasA | fn:fe:means | "suasion" | "means" | "/r/has a" |  | "FN" |  |
| fn:suasion | /r/HasA | fn:fe:degree | "suasion" | "degree" | "/r/has a" |  | "FN" |  |
| fn:suasion | /r/HasA | fn:fe:manner | "suasion" | "manner" | "/r/has a" |  | "FN" |  |
| fn:suasion | /r/HasA | fn:fe:time | "suasion" | "time" | "/r/has a" |  | "FN" |  |
| fn:suasion | /r/HasA | fn:fe:place | "suasion" | "place" | "/r/has a" |  | "FN" |  |
| fn:intentionally_act | /r/UsedFor | fn:subjective_influence | "intentionally act" | "subjective influence" | "/r/used for" |  | "FN" |  |
| fn:subjective_influence | /r/UsedFor | fn:attempt_suasion | "subjective influence" | "attempt suasion" | "/r/used for" |  | "FN" |  |
| fn:subjective_influence | /r/UsedFor | fn:eventive_cognizer_affecting | "subjective influence" | "eventive cognizer affecting" | "/r/used for" |  | "FN" |  |
| fn:subjective_influence | /r/RelatedTo | fn:objective_influence | "subjective influence" | "objective influence" | "/r/related to" |  | "FN" |  |
| fn:attempt_suasion | /r/SimilarTo | fn:subjective_influence | "attempt suasion" | "subjective influence" | "/r/similar to" |  | "FN" |  |
| fn:causation | /r/SimilarTo | fn:subjective_influence | "causation" | "subjective influence" | "/r/similar to" |  | "FN" |  |
| fn:talking_into | /r/SimilarTo | fn:subjective_influence | "talking into" | "subjective influence" | "/r/similar to" |  | "FN" |  |
| fn:subjective_influence | fn:HasLexicalUnit | fn:lu:subjective_influence:impact | "subjective influence" | "impact" | "has lexical unit" |  | "FN" |  |
| fn:subjective_influence | fn:HasLexicalUnit | fn:lu:subjective_influence:influential | "subjective influence" | "influential" | "has lexical unit" |  | "FN" |  |
| fn:subjective_influence | fn:HasLexicalUnit | fn:lu:subjective_influence:inspire | "subjective influence" | "inspire" | "has lexical unit" |  | "FN" |  |
| fn:subjective_influence | fn:HasLexicalUnit | fn:lu:subjective_influence:influence | "subjective influence" | "influence" | "has lexical unit" |  | "FN" |  |
| fn:subjective_influence | fn:HasLexicalUnit | fn:lu:subjective_influence:influence | "subjective influence" | "influence" | "has lexical unit" |  | "FN" |  |
| fn:subjective_influence | fn:HasLexicalUnit | fn:lu:subjective_influence:inspiration | "subjective influence" | "inspiration" | "has lexical unit" |  | "FN" |  |
| fn:subjective_influence | fn:HasLexicalUnit | fn:lu:subjective_influence:effect | "subjective influence" | "effect" | "has lexical unit" |  | "FN" |  |
| fn:subjective_influence | fn:HasLexicalUnit | fn:lu:subjective_influence:impact | "subjective influence" | "impact" | "has lexical unit" |  | "FN" |  |
| fn:subjective_influence | fn:HasLexicalUnit | fn:lu:subjective_influence:drive | "subjective influence" | "drive" | "has lexical unit" |  | "FN" |  |
| fn:subjective_influence | fn:HasLexicalUnit | fn:lu:subjective_influence:motivate | "subjective influence" | "motivate" | "has lexical unit" |  | "FN" |  |
| fn:subjective_influence | fn:HasLexicalUnit | fn:lu:subjective_influence:push | "subjective influence" | "push" | "has lexical unit" |  | "FN" |  |
| fn:subjective_influence | fn:HasLexicalUnit | fn:lu:subjective_influence:galvanize | "subjective influence" | "galvanize" | "has lexical unit" |  | "FN" |  |
| fn:subjective_influence | fn:HasLexicalUnit | fn:lu:subjective_influence:coax | "subjective influence" | "coax" | "has lexical unit" |  | "FN" |  |
| fn:subjective_influence | fn:HasLexicalUnit | fn:lu:subjective_influence:entice | "subjective influence" | "entice" | "has lexical unit" |  | "FN" |  |
| fn:subjective_influence | fn:HasLexicalUnit | fn:lu:subjective_influence:spur | "subjective influence" | "spur" | "has lexical unit" |  | "FN" |  |
| fn:subjective_influence | fn:HasLexicalUnit | fn:lu:subjective_influence:tempt | "subjective influence" | "tempt" | "has lexical unit" |  | "FN" |  |
| fn:subjective_influence | fn:HasLexicalUnit | fn:lu:subjective_influence:discourage | "subjective influence" | "discourage" | "has lexical unit" |  | "FN" |  |
| fn:subjective_influence | fn:HasLexicalUnit | fn:lu:subjective_influence:encourage | "subjective influence" | "encourage" | "has lexical unit" |  | "FN" |  |
| fn:subjective_influence | fn:HasLexicalUnit | fn:lu:subjective_influence:goad | "subjective influence" | "goad" | "has lexical unit" |  | "FN" |  |
| fn:subjective_influence | fn:HasLexicalUnit | fn:lu:subjective_influence:stimulate | "subjective influence" | "stimulate" | "has lexical unit" |  | "FN" |  |
| fn:fe:cognizer | /r/RelatedTo | fn:fe:product | "cognizer" | "product" | "/r/related to" |  | "FN" |  |
| fn:subjective_influence | /r/HasA | fn:fe:cognizer | "subjective influence" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:fe:situation | /r/RelatedTo | fn:fe:entity | "situation" | "entity" | "/r/related to" |  | "FN" |  |
| fn:subjective_influence | /r/HasA | fn:fe:situation | "subjective influence" | "situation" | "/r/has a" |  | "FN" |  |
| fn:fe:entity | /r/RelatedTo | fn:fe:agent | "entity" | "agent" | "/r/related to" |  | "FN" |  |
| fn:subjective_influence | /r/HasA | fn:fe:entity | "subjective influence" | "entity" | "/r/has a" |  | "FN" |  |
| fn:fe:action | /r/RelatedTo | fn:fe:behavior | "action" | "behavior" | "/r/related to" |  | "FN" |  |
| fn:subjective_influence | /r/HasA | fn:fe:action | "subjective influence" | "action" | "/r/has a" |  | "FN" |  |
| fn:fe:behavior | /r/RelatedTo | fn:fe:product | "behavior" | "product" | "/r/related to" |  | "FN" |  |
| fn:subjective_influence | /r/HasA | fn:fe:behavior | "subjective influence" | "behavior" | "/r/has a" |  | "FN" |  |
| fn:fe:product | /r/RelatedTo | fn:fe:action | "product" | "action" | "/r/related to" |  | "FN" |  |
| fn:subjective_influence | /r/HasA | fn:fe:product | "subjective influence" | "product" | "/r/has a" |  | "FN" |  |
| fn:subjective_influence | /r/HasA | fn:fe:time | "subjective influence" | "time" | "/r/has a" |  | "FN" |  |
| fn:subjective_influence | /r/HasA | fn:fe:event_description | "subjective influence" | "event description" | "/r/has a" |  | "FN" |  |
| fn:fe:agent | /r/RelatedTo | fn:fe:situation | "agent" | "situation" | "/r/related to" |  | "FN" |  |
| fn:subjective_influence | /r/HasA | fn:fe:agent | "subjective influence" | "agent" | "/r/has a" |  | "FN" |  |
| fn:subjective_influence | /r/HasA | fn:fe:place | "subjective influence" | "place" | "/r/has a" |  | "FN" |  |
| fn:subjective_influence | /r/HasA | fn:fe:domain | "subjective influence" | "domain" | "/r/has a" |  | "FN" |  |
| fn:subjective_influence | /r/HasA | fn:fe:descriptor | "subjective influence" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:subjective_temperature | /r/UsedFor | fn:heat_potential | "subjective temperature" | "heat potential" | "/r/used for" |  | "FN" |  |
| fn:subjective_temperature | fn:HasLexicalUnit | fn:lu:subjective_temperature:hot | "subjective temperature" | "hot" | "has lexical unit" |  | "FN" |  |
| fn:subjective_temperature | fn:HasLexicalUnit | fn:lu:subjective_temperature:warm | "subjective temperature" | "warm" | "has lexical unit" |  | "FN" |  |
| fn:subjective_temperature | fn:HasLexicalUnit | fn:lu:subjective_temperature:cool | "subjective temperature" | "cool" | "has lexical unit" |  | "FN" |  |
| fn:subjective_temperature | fn:HasLexicalUnit | fn:lu:subjective_temperature:cold | "subjective temperature" | "cold" | "has lexical unit" |  | "FN" |  |
| fn:subjective_temperature | fn:HasLexicalUnit | fn:lu:subjective_temperature:burn_up | "subjective temperature" | "burn up" | "has lexical unit" |  | "FN" |  |
| fn:subjective_temperature | fn:HasLexicalUnit | fn:lu:subjective_temperature:freezing | "subjective temperature" | "freezing" | "has lexical unit" |  | "FN" |  |
| fn:subjective_temperature | /r/HasA | fn:fe:experiencer | "subjective temperature" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:subjective_temperature | /r/HasA | fn:fe:degree | "subjective temperature" | "degree" | "/r/has a" |  | "FN" |  |
| fn:subjective_temperature | /r/HasA | fn:fe:body_part | "subjective temperature" | "body part" | "/r/has a" |  | "FN" |  |
| fn:submitting_documents | /r/IsA | fn:giving | "submitting documents" | "giving" | "/r/is a" |  | "FN" |  |
| fn:submitting_documents | fn:HasLexicalUnit | fn:lu:submitting_documents:submit | "submitting documents" | "submit" | "has lexical unit" |  | "FN" |  |
| fn:submitting_documents | fn:HasLexicalUnit | fn:lu:submitting_documents:submission | "submitting documents" | "submission" | "has lexical unit" |  | "FN" |  |
| fn:submitting_documents | fn:HasLexicalUnit | fn:lu:submitting_documents:hand_in | "submitting documents" | "hand in" | "has lexical unit" |  | "FN" |  |
| fn:submitting_documents | fn:HasLexicalUnit | fn:lu:submitting_documents:turn_in | "submitting documents" | "turn in" | "has lexical unit" |  | "FN" |  |
| fn:submitting_documents | fn:HasLexicalUnit | fn:lu:submitting_documents:file | "submitting documents" | "file" | "has lexical unit" |  | "FN" |  |
| fn:submitting_documents | /r/HasA | fn:fe:submittor | "submitting documents" | "submittor" | "/r/has a" |  | "FN" |  |
| fn:submitting_documents | /r/HasA | fn:fe:authority | "submitting documents" | "authority" | "/r/has a" |  | "FN" |  |
| fn:submitting_documents | /r/HasA | fn:fe:documents | "submitting documents" | "documents" | "/r/has a" |  | "FN" |  |
| fn:submitting_documents | /r/HasA | fn:fe:place | "submitting documents" | "place" | "/r/has a" |  | "FN" |  |
| fn:submitting_documents | /r/HasA | fn:fe:explanation | "submitting documents" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:submitting_documents | /r/HasA | fn:fe:time | "submitting documents" | "time" | "/r/has a" |  | "FN" |  |
| fn:submitting_documents | /r/HasA | fn:fe:purpose | "submitting documents" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:submitting_documents | /r/HasA | fn:fe:means | "submitting documents" | "means" | "/r/has a" |  | "FN" |  |
| fn:submitting_documents | /r/HasA | fn:fe:manner | "submitting documents" | "manner" | "/r/has a" |  | "FN" |  |
| fn:submitting_documents | /r/HasA | fn:fe:imposed_purpose | "submitting documents" | "imposed purpose" | "/r/has a" |  | "FN" |  |
| fn:submitting_documents | /r/HasA | fn:fe:depictive | "submitting documents" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:submitting_documents | /r/HasA | fn:fe:beneficiary | "submitting documents" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:relation_between_individuals | /r/UsedFor | fn:subordinates_and_superiors | "relation between individuals" | "subordinates and superiors" | "/r/used for" |  | "FN" |  |
| fn:subordinates_and_superiors | fn:HasLexicalUnit | fn:lu:subordinates_and_superiors:henchman | "subordinates and superiors" | "henchman" | "has lexical unit" |  | "FN" |  |
| fn:subordinates_and_superiors | fn:HasLexicalUnit | fn:lu:subordinates_and_superiors:minion | "subordinates and superiors" | "minion" | "has lexical unit" |  | "FN" |  |
| fn:subordinates_and_superiors | fn:HasLexicalUnit | fn:lu:subordinates_and_superiors:underling | "subordinates and superiors" | "underling" | "has lexical unit" |  | "FN" |  |
| fn:subordinates_and_superiors | fn:HasLexicalUnit | fn:lu:subordinates_and_superiors:lackey | "subordinates and superiors" | "lackey" | "has lexical unit" |  | "FN" |  |
| fn:subordinates_and_superiors | fn:HasLexicalUnit | fn:lu:subordinates_and_superiors:subordinate | "subordinates and superiors" | "subordinate" | "has lexical unit" |  | "FN" |  |
| fn:subordinates_and_superiors | fn:HasLexicalUnit | fn:lu:subordinates_and_superiors:master | "subordinates and superiors" | "master" | "has lexical unit" |  | "FN" |  |
| fn:subordinates_and_superiors | fn:HasLexicalUnit | fn:lu:subordinates_and_superiors:servant | "subordinates and superiors" | "servant" | "has lexical unit" |  | "FN" |  |
| fn:subordinates_and_superiors | fn:HasLexicalUnit | fn:lu:subordinates_and_superiors:superior | "subordinates and superiors" | "superior" | "has lexical unit" |  | "FN" |  |
| fn:subordinates_and_superiors | fn:HasLexicalUnit | fn:lu:subordinates_and_superiors:assistant | "subordinates and superiors" | "assistant" | "has lexical unit" |  | "FN" |  |
| fn:subordinates_and_superiors | fn:HasLexicalUnit | fn:lu:subordinates_and_superiors:hireling | "subordinates and superiors" | "hireling" | "has lexical unit" |  | "FN" |  |
| fn:subordinates_and_superiors | fn:HasLexicalUnit | fn:lu:subordinates_and_superiors:goon | "subordinates and superiors" | "goon" | "has lexical unit" |  | "FN" |  |
| fn:subordinates_and_superiors | fn:HasLexicalUnit | fn:lu:subordinates_and_superiors:paxman | "subordinates and superiors" | "paxman" | "has lexical unit" |  | "FN" |  |
| fn:subordinates_and_superiors | fn:HasLexicalUnit | fn:lu:subordinates_and_superiors:stooge | "subordinates and superiors" | "stooge" | "has lexical unit" |  | "FN" |  |
| fn:subordinates_and_superiors | fn:HasLexicalUnit | fn:lu:subordinates_and_superiors:senior | "subordinates and superiors" | "senior" | "has lexical unit" |  | "FN" |  |
| fn:subordinates_and_superiors | fn:HasLexicalUnit | fn:lu:subordinates_and_superiors:junior | "subordinates and superiors" | "junior" | "has lexical unit" |  | "FN" |  |
| fn:subordinates_and_superiors | fn:HasLexicalUnit | fn:lu:subordinates_and_superiors:serve | "subordinates and superiors" | "serve" | "has lexical unit" |  | "FN" |  |
| fn:subordinates_and_superiors | /r/HasA | fn:fe:superior | "subordinates and superiors" | "superior" | "/r/has a" |  | "FN" |  |
| fn:subordinates_and_superiors | /r/HasA | fn:fe:subordinate | "subordinates and superiors" | "subordinate" | "/r/has a" |  | "FN" |  |
| fn:subsisting | /r/IsA | fn:dead_or_alive | "subsisting" | "dead or alive" | "/r/is a" |  | "FN" |  |
| fn:subsisting | fn:HasLexicalUnit | fn:lu:subsisting:subsist | "subsisting" | "subsist" | "has lexical unit" |  | "FN" |  |
| fn:subsisting | fn:HasLexicalUnit | fn:lu:subsisting:live_(on) | "subsisting" | "live (on)" | "has lexical unit" |  | "FN" |  |
| fn:subsisting | /r/HasA | fn:fe:entity | "subsisting" | "entity" | "/r/has a" |  | "FN" |  |
| fn:subsisting | /r/HasA | fn:fe:support | "subsisting" | "support" | "/r/has a" |  | "FN" |  |
| fn:subsisting | /r/HasA | fn:fe:duration | "subsisting" | "duration" | "/r/has a" |  | "FN" |  |
| fn:subsisting | /r/HasA | fn:fe:degree | "subsisting" | "degree" | "/r/has a" |  | "FN" |  |
| fn:substance | /r/IsA | fn:physical_entity | "substance" | "physical entity" | "/r/is a" |  | "FN" |  |
| fn:active_substance | /r/IsA | fn:substance | "active substance" | "substance" | "/r/is a" |  | "FN" |  |
| fn:substance | fn:HasLexicalUnit | fn:lu:substance:gas | "substance" | "gas" | "has lexical unit" |  | "FN" |  |
| fn:substance | fn:HasLexicalUnit | fn:lu:substance:sand | "substance" | "sand" | "has lexical unit" |  | "FN" |  |
| fn:substance | fn:HasLexicalUnit | fn:lu:substance:oil | "substance" | "oil" | "has lexical unit" |  | "FN" |  |
| fn:substance | fn:HasLexicalUnit | fn:lu:substance:liquid | "substance" | "liquid" | "has lexical unit" |  | "FN" |  |
| fn:substance | fn:HasLexicalUnit | fn:lu:substance:methane | "substance" | "methane" | "has lexical unit" |  | "FN" |  |
| fn:substance | fn:HasLexicalUnit | fn:lu:substance:chemical | "substance" | "chemical" | "has lexical unit" |  | "FN" |  |
| fn:substance | fn:HasLexicalUnit | fn:lu:substance:iron | "substance" | "iron" | "has lexical unit" |  | "FN" |  |
| fn:substance | fn:HasLexicalUnit | fn:lu:substance:material | "substance" | "material" | "has lexical unit" |  | "FN" |  |
| fn:substance | fn:HasLexicalUnit | fn:lu:substance:uranium | "substance" | "uranium" | "has lexical unit" |  | "FN" |  |
| fn:substance | fn:HasLexicalUnit | fn:lu:substance:aluminum | "substance" | "aluminum" | "has lexical unit" |  | "FN" |  |
| fn:substance | fn:HasLexicalUnit | fn:lu:substance:plutonium | "substance" | "plutonium" | "has lexical unit" |  | "FN" |  |
| fn:substance | fn:HasLexicalUnit | fn:lu:substance:atropine | "substance" | "atropine" | "has lexical unit" |  | "FN" |  |
| fn:substance | fn:HasLexicalUnit | fn:lu:substance:yellowcake | "substance" | "yellowcake" | "has lexical unit" |  | "FN" |  |
| fn:substance | fn:HasLexicalUnit | fn:lu:substance:solid | "substance" | "solid" | "has lexical unit" |  | "FN" |  |
| fn:substance | fn:HasLexicalUnit | fn:lu:substance:ore | "substance" | "ore" | "has lexical unit" |  | "FN" |  |
| fn:substance | fn:HasLexicalUnit | fn:lu:substance:petroleum | "substance" | "petroleum" | "has lexical unit" |  | "FN" |  |
| fn:substance | fn:HasLexicalUnit | fn:lu:substance:water | "substance" | "water" | "has lexical unit" |  | "FN" |  |
| fn:substance | fn:HasLexicalUnit | fn:lu:substance:juice | "substance" | "juice" | "has lexical unit" |  | "FN" |  |
| fn:substance | fn:HasLexicalUnit | fn:lu:substance:metal | "substance" | "metal" | "has lexical unit" |  | "FN" |  |
| fn:substance | fn:HasLexicalUnit | fn:lu:substance:glass | "substance" | "glass" | "has lexical unit" |  | "FN" |  |
| fn:substance | fn:HasLexicalUnit | fn:lu:substance:paper | "substance" | "paper" | "has lexical unit" |  | "FN" |  |
| fn:substance | fn:HasLexicalUnit | fn:lu:substance:mud | "substance" | "mud" | "has lexical unit" |  | "FN" |  |
| fn:substance | fn:HasLexicalUnit | fn:lu:substance:cement | "substance" | "cement" | "has lexical unit" |  | "FN" |  |
| fn:substance | fn:HasLexicalUnit | fn:lu:substance:calcium | "substance" | "calcium" | "has lexical unit" |  | "FN" |  |
| fn:substance | fn:HasLexicalUnit | fn:lu:substance:oxygen | "substance" | "oxygen" | "has lexical unit" |  | "FN" |  |
| fn:substance | fn:HasLexicalUnit | fn:lu:substance:fertilizer | "substance" | "fertilizer" | "has lexical unit" |  | "FN" |  |
| fn:substance | /r/HasA | fn:fe:constituents | "substance" | "constituents" | "/r/has a" |  | "FN" |  |
| fn:substance | /r/HasA | fn:fe:substance | "substance" | "substance" | "/r/has a" |  | "FN" |  |
| fn:substance | /r/HasA | fn:fe:type | "substance" | "type" | "/r/has a" |  | "FN" |  |
| fn:substance | /r/HasA | fn:fe:origin | "substance" | "origin" | "/r/has a" |  | "FN" |  |
| fn:substance | /r/HasA | fn:fe:descriptor | "substance" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:substance | /r/HasA | fn:fe:inherent_purpose | "substance" | "inherent purpose" | "/r/has a" |  | "FN" |  |
| fn:change_of_phase_scenario | /r/HasSubevent | fn:substance_by_phase | "change of phase scenario" | "substance by phase" | "/r/has subevent" |  | "FN" |  |
| fn:thermodynamic_phase | /r/UsedFor | fn:substance_by_phase | "thermodynamic phase" | "substance by phase" | "/r/used for" |  | "FN" |  |
| fn:cause_change_of_phase | /r/Causes | fn:substance_by_phase | "cause change of phase" | "substance by phase" | "/r/causes" |  | "FN" |  |
| fn:substance_by_phase | /r/HasPrerequisite | fn:change_of_phase | "substance by phase" | "change of phase" | "/r/has prerequisite" |  | "FN" |  |
| fn:substance_by_phase | fn:HasLexicalUnit | fn:lu:substance_by_phase:thawed | "substance by phase" | "thawed" | "has lexical unit" |  | "FN" |  |
| fn:substance_by_phase | fn:HasLexicalUnit | fn:lu:substance_by_phase:melted | "substance by phase" | "melted" | "has lexical unit" |  | "FN" |  |
| fn:substance_by_phase | fn:HasLexicalUnit | fn:lu:substance_by_phase:liquefied | "substance by phase" | "liquefied" | "has lexical unit" |  | "FN" |  |
| fn:substance_by_phase | fn:HasLexicalUnit | fn:lu:substance_by_phase:frozen | "substance by phase" | "frozen" | "has lexical unit" |  | "FN" |  |
| fn:substance_by_phase | fn:HasLexicalUnit | fn:lu:substance_by_phase:defrosted | "substance by phase" | "defrosted" | "has lexical unit" |  | "FN" |  |
| fn:substance_by_phase | fn:HasLexicalUnit | fn:lu:substance_by_phase:solidified | "substance by phase" | "solidified" | "has lexical unit" |  | "FN" |  |
| fn:substance_by_phase | fn:HasLexicalUnit | fn:lu:substance_by_phase:solid | "substance by phase" | "solid" | "has lexical unit" |  | "FN" |  |
| fn:substance_by_phase | fn:HasLexicalUnit | fn:lu:substance_by_phase:gas | "substance by phase" | "gas" | "has lexical unit" |  | "FN" |  |
| fn:substance_by_phase | fn:HasLexicalUnit | fn:lu:substance_by_phase:gaseous | "substance by phase" | "gaseous" | "has lexical unit" |  | "FN" |  |
| fn:substance_by_phase | fn:HasLexicalUnit | fn:lu:substance_by_phase:plasma | "substance by phase" | "plasma" | "has lexical unit" |  | "FN" |  |
| fn:substance_by_phase | fn:HasLexicalUnit | fn:lu:substance_by_phase:liquid | "substance by phase" | "liquid" | "has lexical unit" |  | "FN" |  |
| fn:substance_by_phase | fn:HasLexicalUnit | fn:lu:substance_by_phase:liquid | "substance by phase" | "liquid" | "has lexical unit" |  | "FN" |  |
| fn:substance_by_phase | /r/HasA | fn:fe:substance | "substance by phase" | "substance" | "/r/has a" |  | "FN" |  |
| fn:substance_by_phase | /r/HasA | fn:fe:subregion | "substance by phase" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:subversion | /r/IsA | fn:thwarting | "subversion" | "thwarting" | "/r/is a" |  | "FN" |  |
| fn:subversion | fn:HasLexicalUnit | fn:lu:subversion:sabotage | "subversion" | "sabotage" | "has lexical unit" |  | "FN" |  |
| fn:subversion | fn:HasLexicalUnit | fn:lu:subversion:undermine | "subversion" | "undermine" | "has lexical unit" |  | "FN" |  |
| fn:subversion | fn:HasLexicalUnit | fn:lu:subversion:undercut | "subversion" | "undercut" | "has lexical unit" |  | "FN" |  |
| fn:subversion | fn:HasLexicalUnit | fn:lu:subversion:subvert | "subversion" | "subvert" | "has lexical unit" |  | "FN" |  |
| fn:subversion | fn:HasLexicalUnit | fn:lu:subversion:subversion | "subversion" | "subversion" | "has lexical unit" |  | "FN" |  |
| fn:subversion | /r/HasA | fn:fe:cause | "subversion" | "cause" | "/r/has a" |  | "FN" |  |
| fn:fe:counter_actor | /r/RelatedTo | fn:fe:cause | "counter actor" | "cause" | "/r/related to" |  | "FN" |  |
| fn:subversion | /r/HasA | fn:fe:counter_actor | "subversion" | "counter actor" | "/r/has a" |  | "FN" |  |
| fn:fe:agent | /r/HasPrerequisite | fn:fe:activity | "agent" | "activity" | "/r/has prerequisite" |  | "FN" |  |
| fn:subversion | /r/HasA | fn:fe:agent | "subversion" | "agent" | "/r/has a" |  | "FN" |  |
| fn:subversion | /r/HasA | fn:fe:activity | "subversion" | "activity" | "/r/has a" |  | "FN" |  |
| fn:fe:state_of_affairs | /r/RelatedTo | fn:fe:activity | "state of affairs" | "activity" | "/r/related to" |  | "FN" |  |
| fn:subversion | /r/HasA | fn:fe:state_of_affairs | "subversion" | "state of affairs" | "/r/has a" |  | "FN" |  |
| fn:subversion | /r/HasA | fn:fe:degree | "subversion" | "degree" | "/r/has a" |  | "FN" |  |
| fn:subversion | /r/HasA | fn:fe:purpose | "subversion" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:subversion | /r/HasA | fn:fe:place | "subversion" | "place" | "/r/has a" |  | "FN" |  |
| fn:subversion | /r/HasA | fn:fe:time | "subversion" | "time" | "/r/has a" |  | "FN" |  |
| fn:subversion | /r/HasA | fn:fe:manner | "subversion" | "manner" | "/r/has a" |  | "FN" |  |
| fn:subversion | /r/HasA | fn:fe:frequency | "subversion" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:subversion | /r/HasA | fn:fe:iterations | "subversion" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:subversion | /r/HasA | fn:fe:means | "subversion" | "means" | "/r/has a" |  | "FN" |  |
| fn:endeavor_failure | /r/IsA | fn:success_or_failure | "endeavor failure" | "success or failure" | "/r/is a" |  | "FN" |  |
| fn:hit_or_miss | /r/IsA | fn:success_or_failure | "hit or miss" | "success or failure" | "/r/is a" |  | "FN" |  |
| fn:surviving | /r/IsA | fn:success_or_failure | "surviving" | "success or failure" | "/r/is a" |  | "FN" |  |
| fn:success_or_failure | /r/UsedFor | fn:accuracy | "success or failure" | "accuracy" | "/r/used for" |  | "FN" |  |
| fn:success_or_failure | /r/UsedFor | fn:finish_competition | "success or failure" | "finish competition" | "/r/used for" |  | "FN" |  |
| fn:success_or_failure | /r/RelatedTo | fn:personal_success | "success or failure" | "personal success" | "/r/related to" |  | "FN" |  |
| fn:thwarting | /r/Causes | fn:success_or_failure | "thwarting" | "success or failure" | "/r/causes" |  | "FN" |  |
| fn:success_or_failure | /r/IsA | fn:result_of_attempt_scenario | "success or failure" | "result of attempt scenario" | "/r/is a" |  | "FN" |  |
| fn:success_or_failure | fn:HasLexicalUnit | fn:lu:success_or_failure:succeed | "success or failure" | "succeed" | "has lexical unit" |  | "FN" |  |
| fn:success_or_failure | fn:HasLexicalUnit | fn:lu:success_or_failure:fail | "success or failure" | "fail" | "has lexical unit" |  | "FN" |  |
| fn:success_or_failure | fn:HasLexicalUnit | fn:lu:success_or_failure:successful | "success or failure" | "successful" | "has lexical unit" |  | "FN" |  |
| fn:success_or_failure | fn:HasLexicalUnit | fn:lu:success_or_failure:pull_off | "success or failure" | "pull off" | "has lexical unit" |  | "FN" |  |
| fn:success_or_failure | fn:HasLexicalUnit | fn:lu:success_or_failure:unsuccessful | "success or failure" | "unsuccessful" | "has lexical unit" |  | "FN" |  |
| fn:success_or_failure | fn:HasLexicalUnit | fn:lu:success_or_failure:success | "success or failure" | "success" | "has lexical unit" |  | "FN" |  |
| fn:success_or_failure | fn:HasLexicalUnit | fn:lu:success_or_failure:manage | "success or failure" | "manage" | "has lexical unit" |  | "FN" |  |
| fn:success_or_failure | fn:HasLexicalUnit | fn:lu:success_or_failure:miss | "success or failure" | "miss" | "has lexical unit" |  | "FN" |  |
| fn:success_or_failure | fn:HasLexicalUnit | fn:lu:success_or_failure:failure | "success or failure" | "failure" | "has lexical unit" |  | "FN" |  |
| fn:success_or_failure | fn:HasLexicalUnit | fn:lu:success_or_failure:failing | "success or failure" | "failing" | "has lexical unit" |  | "FN" |  |
| fn:success_or_failure | fn:HasLexicalUnit | fn:lu:success_or_failure:ace | "success or failure" | "ace" | "has lexical unit" |  | "FN" |  |
| fn:success_or_failure | fn:HasLexicalUnit | fn:lu:success_or_failure:get_there | "success or failure" | "get there" | "has lexical unit" |  | "FN" |  |
| fn:success_or_failure | /r/HasA | fn:fe:agent | "success or failure" | "agent" | "/r/has a" |  | "FN" |  |
| fn:success_or_failure | /r/HasA | fn:fe:goal | "success or failure" | "goal" | "/r/has a" |  | "FN" |  |
| fn:success_or_failure | /r/HasA | fn:fe:means | "success or failure" | "means" | "/r/has a" |  | "FN" |  |
| fn:success_or_failure | /r/HasA | fn:fe:degree | "success or failure" | "degree" | "/r/has a" |  | "FN" |  |
| fn:success_or_failure | /r/HasA | fn:fe:time | "success or failure" | "time" | "/r/has a" |  | "FN" |  |
| fn:success_or_failure | /r/HasA | fn:fe:depictive | "success or failure" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:success_or_failure | /r/HasA | fn:fe:place | "success or failure" | "place" | "/r/has a" |  | "FN" |  |
| fn:fe:role | /r/RelatedTo | fn:fe:goal | "role" | "goal" | "/r/related to" |  | "FN" |  |
| fn:success_or_failure | /r/HasA | fn:fe:role | "success or failure" | "role" | "/r/has a" |  | "FN" |  |
| fn:success_or_failure | /r/HasA | fn:fe:circumstances | "success or failure" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:success_or_failure | /r/HasA | fn:fe:explanation | "success or failure" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:success_or_failure | /r/HasA | fn:fe:containing_event | "success or failure" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:success_or_failure | /r/HasA | fn:fe:re-encoding | "success or failure" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:successful_action | /r/RelatedTo | fn:personal_success | "successful action" | "personal success" | "/r/related to" |  | "FN" |  |
| fn:successful_action | /r/IsA | fn:result_of_attempt_scenario | "successful action" | "result of attempt scenario" | "/r/is a" |  | "FN" |  |
| fn:successful_action | fn:HasLexicalUnit | fn:lu:successful_action:succeed | "successful action" | "succeed" | "has lexical unit" |  | "FN" |  |
| fn:successful_action | fn:HasLexicalUnit | fn:lu:successful_action:do_the_trick | "successful action" | "do the trick" | "has lexical unit" |  | "FN" |  |
| fn:successful_action | fn:HasLexicalUnit | fn:lu:successful_action:do_it | "successful action" | "do it" | "has lexical unit" |  | "FN" |  |
| fn:successful_action | fn:HasLexicalUnit | fn:lu:successful_action:successful | "successful action" | "successful" | "has lexical unit" |  | "FN" |  |
| fn:successful_action | fn:HasLexicalUnit | fn:lu:successful_action:come_off | "successful action" | "come off" | "has lexical unit" |  | "FN" |  |
| fn:successful_action | fn:HasLexicalUnit | fn:lu:successful_action:fail | "successful action" | "fail" | "has lexical unit" |  | "FN" |  |
| fn:successful_action | fn:HasLexicalUnit | fn:lu:successful_action:unsuccessful | "successful action" | "unsuccessful" | "has lexical unit" |  | "FN" |  |
| fn:successful_action | fn:HasLexicalUnit | fn:lu:successful_action:manage | "successful action" | "manage" | "has lexical unit" |  | "FN" |  |
| fn:successful_action | fn:HasLexicalUnit | fn:lu:successful_action:failed | "successful action" | "failed" | "has lexical unit" |  | "FN" |  |
| fn:successful_action | fn:HasLexicalUnit | fn:lu:successful_action:go_wrong | "successful action" | "go wrong" | "has lexical unit" |  | "FN" |  |
| fn:successful_action | fn:HasLexicalUnit | fn:lu:successful_action:success | "successful action" | "success" | "has lexical unit" |  | "FN" |  |
| fn:successful_action | fn:HasLexicalUnit | fn:lu:successful_action:serve | "successful action" | "serve" | "has lexical unit" |  | "FN" |  |
| fn:successful_action | /r/HasA | fn:fe:means | "successful action" | "means" | "/r/has a" |  | "FN" |  |
| fn:successful_action | /r/HasA | fn:fe:goal | "successful action" | "goal" | "/r/has a" |  | "FN" |  |
| fn:successful_action | /r/HasA | fn:fe:instrument | "successful action" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:successful_action | /r/HasA | fn:fe:place | "successful action" | "place" | "/r/has a" |  | "FN" |  |
| fn:successful_action | /r/HasA | fn:fe:time | "successful action" | "time" | "/r/has a" |  | "FN" |  |
| fn:successful_action | /r/HasA | fn:fe:circumstances | "successful action" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:successful_action | /r/HasA | fn:fe:protagonist | "successful action" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:successful_action | /r/HasA | fn:fe:degree | "successful action" | "degree" | "/r/has a" |  | "FN" |  |
| fn:successful_action | /r/HasA | fn:fe:role | "successful action" | "role" | "/r/has a" |  | "FN" |  |
| fn:successful_action | /r/HasA | fn:fe:explanation | "successful action" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:successful_action | /r/HasA | fn:fe:containing_event | "successful action" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:successfully_communicate_message | "communication" | "successfully communicate message" | "/r/used for" |  | "FN" |  |
| fn:statement | /r/SimilarTo | fn:successfully_communicate_message | "statement" | "successfully communicate message" | "/r/similar to" |  | "FN" |  |
| fn:successfully_communicate_message | fn:HasLexicalUnit | fn:lu:successfully_communicate_message:convey | "successfully communicate message" | "convey" | "has lexical unit" |  | "FN" |  |
| fn:successfully_communicate_message | fn:HasLexicalUnit | fn:lu:successfully_communicate_message:get_through | "successfully communicate message" | "get through" | "has lexical unit" |  | "FN" |  |
| fn:successfully_communicate_message | fn:HasLexicalUnit | fn:lu:successfully_communicate_message:get_across | "successfully communicate message" | "get across" | "has lexical unit" |  | "FN" |  |
| fn:successfully_communicate_message | /r/HasA | fn:fe:communicator | "successfully communicate message" | "communicator" | "/r/has a" |  | "FN" |  |
| fn:successfully_communicate_message | /r/HasA | fn:fe:addressee | "successfully communicate message" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:successfully_communicate_message | /r/HasA | fn:fe:message | "successfully communicate message" | "message" | "/r/has a" |  | "FN" |  |
| fn:successfully_communicate_message | /r/HasA | fn:fe:medium | "successfully communicate message" | "medium" | "/r/has a" |  | "FN" |  |
| fn:successfully_communicate_message | /r/HasA | fn:fe:depictive | "successfully communicate message" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:successfully_communicate_message | /r/HasA | fn:fe:manner | "successfully communicate message" | "manner" | "/r/has a" |  | "FN" |  |
| fn:successfully_communicate_message | /r/HasA | fn:fe:means | "successfully communicate message" | "means" | "/r/has a" |  | "FN" |  |
| fn:successfully_communicate_message | /r/HasA | fn:fe:time | "successfully communicate message" | "time" | "/r/has a" |  | "FN" |  |
| fn:successfully_communicate_message | /r/HasA | fn:fe:adequacy | "successfully communicate message" | "adequacy" | "/r/has a" |  | "FN" |  |
| fn:sufficiency | /r/IsA | fn:position_on_a_scale | "sufficiency" | "position on a scale" | "/r/is a" |  | "FN" |  |
| fn:capability | /r/UsedFor | fn:sufficiency | "capability" | "sufficiency" | "/r/used for" |  | "FN" |  |
| fn:sufficiency | /r/UsedFor | fn:meet_specifications | "sufficiency" | "meet specifications" | "/r/used for" |  | "FN" |  |
| fn:sufficiency | fn:HasLexicalUnit | fn:lu:sufficiency:enough | "sufficiency" | "enough" | "has lexical unit" |  | "FN" |  |
| fn:sufficiency | fn:HasLexicalUnit | fn:lu:sufficiency:enough | "sufficiency" | "enough" | "has lexical unit" |  | "FN" |  |
| fn:sufficiency | fn:HasLexicalUnit | fn:lu:sufficiency:enough | "sufficiency" | "enough" | "has lexical unit" |  | "FN" |  |
| fn:sufficiency | fn:HasLexicalUnit | fn:lu:sufficiency:suffice | "sufficiency" | "suffice" | "has lexical unit" |  | "FN" |  |
| fn:sufficiency | fn:HasLexicalUnit | fn:lu:sufficiency:sufficient | "sufficiency" | "sufficient" | "has lexical unit" |  | "FN" |  |
| fn:sufficiency | fn:HasLexicalUnit | fn:lu:sufficiency:sufficiently | "sufficiency" | "sufficiently" | "has lexical unit" |  | "FN" |  |
| fn:sufficiency | fn:HasLexicalUnit | fn:lu:sufficiency:insufficient | "sufficiency" | "insufficient" | "has lexical unit" |  | "FN" |  |
| fn:sufficiency | fn:HasLexicalUnit | fn:lu:sufficiency:insufficiently | "sufficiency" | "insufficiently" | "has lexical unit" |  | "FN" |  |
| fn:sufficiency | fn:HasLexicalUnit | fn:lu:sufficiency:adequate | "sufficiency" | "adequate" | "has lexical unit" |  | "FN" |  |
| fn:sufficiency | fn:HasLexicalUnit | fn:lu:sufficiency:adequately | "sufficiency" | "adequately" | "has lexical unit" |  | "FN" |  |
| fn:sufficiency | fn:HasLexicalUnit | fn:lu:sufficiency:insufficiency | "sufficiency" | "insufficiency" | "has lexical unit" |  | "FN" |  |
| fn:sufficiency | fn:HasLexicalUnit | fn:lu:sufficiency:adequacy | "sufficiency" | "adequacy" | "has lexical unit" |  | "FN" |  |
| fn:sufficiency | fn:HasLexicalUnit | fn:lu:sufficiency:inadequacy | "sufficiency" | "inadequacy" | "has lexical unit" |  | "FN" |  |
| fn:sufficiency | fn:HasLexicalUnit | fn:lu:sufficiency:inadequate | "sufficiency" | "inadequate" | "has lexical unit" |  | "FN" |  |
| fn:sufficiency | fn:HasLexicalUnit | fn:lu:sufficiency:inadequately | "sufficiency" | "inadequately" | "has lexical unit" |  | "FN" |  |
| fn:sufficiency | fn:HasLexicalUnit | fn:lu:sufficiency:plenty | "sufficiency" | "plenty" | "has lexical unit" |  | "FN" |  |
| fn:sufficiency | fn:HasLexicalUnit | fn:lu:sufficiency:plenty | "sufficiency" | "plenty" | "has lexical unit" |  | "FN" |  |
| fn:sufficiency | fn:HasLexicalUnit | fn:lu:sufficiency:plenty | "sufficiency" | "plenty" | "has lexical unit" |  | "FN" |  |
| fn:sufficiency | fn:HasLexicalUnit | fn:lu:sufficiency:ample | "sufficiency" | "ample" | "has lexical unit" |  | "FN" |  |
| fn:sufficiency | fn:HasLexicalUnit | fn:lu:sufficiency:too | "sufficiency" | "too" | "has lexical unit" |  | "FN" |  |
| fn:sufficiency | fn:HasLexicalUnit | fn:lu:sufficiency:so | "sufficiency" | "so" | "has lexical unit" |  | "FN" |  |
| fn:sufficiency | fn:HasLexicalUnit | fn:lu:sufficiency:serve | "sufficiency" | "serve" | "has lexical unit" |  | "FN" |  |
| fn:sufficiency | /r/HasA | fn:fe:item | "sufficiency" | "item" | "/r/has a" |  | "FN" |  |
| fn:sufficiency | /r/HasA | fn:fe:scale | "sufficiency" | "scale" | "/r/has a" |  | "FN" |  |
| fn:sufficiency | /r/HasA | fn:fe:enabled_situation | "sufficiency" | "enabled situation" | "/r/has a" |  | "FN" |  |
| fn:sufficiency | /r/HasA | fn:fe:degree | "sufficiency" | "degree" | "/r/has a" |  | "FN" |  |
| fn:sufficiency | /r/HasA | fn:fe:circumstances | "sufficiency" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:suicide_attack | /r/IsA | fn:attack | "suicide attack" | "attack" | "/r/is a" |  | "FN" |  |
| fn:suicide_attack | fn:HasLexicalUnit | fn:lu:suicide_attack:suicide_attack | "suicide attack" | "suicide attack" | "has lexical unit" |  | "FN" |  |
| fn:suicide_attack | fn:HasLexicalUnit | fn:lu:suicide_attack:suicide_bombing | "suicide attack" | "suicide bombing" | "has lexical unit" |  | "FN" |  |
| fn:suicide_attack | fn:HasLexicalUnit | fn:lu:suicide_attack:kamikaze_[attack] | "suicide attack" | "kamikaze [attack]" | "has lexical unit" |  | "FN" |  |
| fn:suicide_attack | fn:HasLexicalUnit | fn:lu:suicide_attack:suicide_bomber | "suicide attack" | "suicide bomber" | "has lexical unit" |  | "FN" |  |
| fn:suicide_attack | fn:HasLexicalUnit | fn:lu:suicide_attack:suicide_attacker | "suicide attack" | "suicide attacker" | "has lexical unit" |  | "FN" |  |
| fn:suicide_attack | fn:HasLexicalUnit | fn:lu:suicide_attack:kamikaze_[person] | "suicide attack" | "kamikaze [person]" | "has lexical unit" |  | "FN" |  |
| fn:suicide_attack | /r/HasA | fn:fe:victim | "suicide attack" | "victim" | "/r/has a" |  | "FN" |  |
| fn:suicide_attack | /r/HasA | fn:fe:weapon | "suicide attack" | "weapon" | "/r/has a" |  | "FN" |  |
| fn:suicide_attack | /r/HasA | fn:fe:assailant | "suicide attack" | "assailant" | "/r/has a" |  | "FN" |  |
| fn:suicide_attack | /r/HasA | fn:fe:manner | "suicide attack" | "manner" | "/r/has a" |  | "FN" |  |
| fn:suicide_attack | /r/HasA | fn:fe:means | "suicide attack" | "means" | "/r/has a" |  | "FN" |  |
| fn:suicide_attack | /r/HasA | fn:fe:place | "suicide attack" | "place" | "/r/has a" |  | "FN" |  |
| fn:suicide_attack | /r/HasA | fn:fe:purpose | "suicide attack" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:suicide_attack | /r/HasA | fn:fe:time | "suicide attack" | "time" | "/r/has a" |  | "FN" |  |
| fn:suicide_attack | /r/HasA | fn:fe:source | "suicide attack" | "source" | "/r/has a" |  | "FN" |  |
| fn:suicide_attack | /r/HasA | fn:fe:depictive | "suicide attack" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:suicide_attack | /r/HasA | fn:fe:re-encoding | "suicide attack" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:suicide_attack | /r/HasA | fn:fe:result | "suicide attack" | "result" | "/r/has a" |  | "FN" |  |
| fn:suicide_attack | /r/HasA | fn:fe:containing_event | "suicide attack" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:suicide_attack | /r/HasA | fn:fe:explanation | "suicide attack" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:suicide_attack | /r/HasA | fn:fe:particular_iteration | "suicide attack" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:suicide_attack | /r/HasA | fn:fe:circumstances | "suicide attack" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:suicide_attack | /r/HasA | fn:fe:path | "suicide attack" | "path" | "/r/has a" |  | "FN" |  |
| fn:suitability | /r/IsA | fn:gradable_attributes | "suitability" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:suitability | fn:HasLexicalUnit | fn:lu:suitability:suitable | "suitability" | "suitable" | "has lexical unit" |  | "FN" |  |
| fn:suitability | fn:HasLexicalUnit | fn:lu:suitability:unsuitable | "suitability" | "unsuitable" | "has lexical unit" |  | "FN" |  |
| fn:suitability | fn:HasLexicalUnit | fn:lu:suitability:suitability | "suitability" | "suitability" | "has lexical unit" |  | "FN" |  |
| fn:suitability | fn:HasLexicalUnit | fn:lu:suitability:unsuitability | "suitability" | "unsuitability" | "has lexical unit" |  | "FN" |  |
| fn:suitability | fn:HasLexicalUnit | fn:lu:suitability:suitableness | "suitability" | "suitableness" | "has lexical unit" |  | "FN" |  |
| fn:suitability | fn:HasLexicalUnit | fn:lu:suitability:unsuitableness | "suitability" | "unsuitableness" | "has lexical unit" |  | "FN" |  |
| fn:suitability | fn:HasLexicalUnit | fn:lu:suitability:fitting | "suitability" | "fitting" | "has lexical unit" |  | "FN" |  |
| fn:suitability | fn:HasLexicalUnit | fn:lu:suitability:fit | "suitability" | "fit" | "has lexical unit" |  | "FN" |  |
| fn:suitability | fn:HasLexicalUnit | fn:lu:suitability:fit | "suitability" | "fit" | "has lexical unit" |  | "FN" |  |
| fn:suitability | fn:HasLexicalUnit | fn:lu:suitability:proper | "suitability" | "proper" | "has lexical unit" |  | "FN" |  |
| fn:suitability | fn:HasLexicalUnit | fn:lu:suitability:suit | "suitability" | "suit" | "has lexical unit" |  | "FN" |  |
| fn:suitability | fn:HasLexicalUnit | fn:lu:suitability:suited | "suitability" | "suited" | "has lexical unit" |  | "FN" |  |
| fn:suitability | fn:HasLexicalUnit | fn:lu:suitability:right | "suitability" | "right" | "has lexical unit" |  | "FN" |  |
| fn:suitability | fn:HasLexicalUnit | fn:lu:suitability:correct | "suitability" | "correct" | "has lexical unit" |  | "FN" |  |
| fn:suitability | fn:HasLexicalUnit | fn:lu:suitability:become | "suitability" | "become" | "has lexical unit" |  | "FN" |  |
| fn:suitability | fn:HasLexicalUnit | fn:lu:suitability:appropriate | "suitability" | "appropriate" | "has lexical unit" |  | "FN" |  |
| fn:suitability | fn:HasLexicalUnit | fn:lu:suitability:inappropriate | "suitability" | "inappropriate" | "has lexical unit" |  | "FN" |  |
| fn:suitability | /r/HasA | fn:fe:evaluee | "suitability" | "evaluee" | "/r/has a" |  | "FN" |  |
| fn:suitability | /r/HasA | fn:fe:degree | "suitability" | "degree" | "/r/has a" |  | "FN" |  |
| fn:suitability | /r/HasA | fn:fe:purpose | "suitability" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:suitability | /r/HasA | fn:fe:user | "suitability" | "user" | "/r/has a" |  | "FN" |  |
| fn:summarizing | /r/IsA | fn:communication | "summarizing" | "communication" | "/r/is a" |  | "FN" |  |
| fn:summarizing | fn:HasLexicalUnit | fn:lu:summarizing:summarize | "summarizing" | "summarize" | "has lexical unit" |  | "FN" |  |
| fn:summarizing | fn:HasLexicalUnit | fn:lu:summarizing:synopsis | "summarizing" | "synopsis" | "has lexical unit" |  | "FN" |  |
| fn:summarizing | fn:HasLexicalUnit | fn:lu:summarizing:boil_down | "summarizing" | "boil down" | "has lexical unit" |  | "FN" |  |
| fn:summarizing | fn:HasLexicalUnit | fn:lu:summarizing:outline | "summarizing" | "outline" | "has lexical unit" |  | "FN" |  |
| fn:summarizing | fn:HasLexicalUnit | fn:lu:summarizing:sum_up | "summarizing" | "sum up" | "has lexical unit" |  | "FN" |  |
| fn:summarizing | /r/HasA | fn:fe:communicator | "summarizing" | "communicator" | "/r/has a" |  | "FN" |  |
| fn:summarizing | /r/HasA | fn:fe:addressee | "summarizing" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:summarizing | /r/HasA | fn:fe:state_of_affairs | "summarizing" | "state of affairs" | "/r/has a" |  | "FN" |  |
| fn:summarizing | /r/HasA | fn:fe:medium | "summarizing" | "medium" | "/r/has a" |  | "FN" |  |
| fn:summarizing | /r/HasA | fn:fe:summary | "summarizing" | "summary" | "/r/has a" |  | "FN" |  |
| fn:summarizing | /r/HasA | fn:fe:time | "summarizing" | "time" | "/r/has a" |  | "FN" |  |
| fn:summarizing | /r/HasA | fn:fe:place | "summarizing" | "place" | "/r/has a" |  | "FN" |  |
| fn:summarizing | /r/HasA | fn:fe:manner | "summarizing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:summarizing | /r/HasA | fn:fe:means | "summarizing" | "means" | "/r/has a" |  | "FN" |  |
| fn:summarizing | /r/HasA | fn:fe:purpose | "summarizing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:summarizing | /r/HasA | fn:fe:duration | "summarizing" | "duration" | "/r/has a" |  | "FN" |  |
| fn:summarizing | /r/HasA | fn:fe:containing_event | "summarizing" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:summarizing | /r/HasA | fn:fe:circumstances | "summarizing" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:supply | /r/IsA | fn:giving | "supply" | "giving" | "/r/is a" |  | "FN" |  |
| fn:funding | /r/IsA | fn:supply | "funding" | "supply" | "/r/is a" |  | "FN" |  |
| fn:supply | fn:HasLexicalUnit | fn:lu:supply:supply | "supply" | "supply" | "has lexical unit" |  | "FN" |  |
| fn:supply | fn:HasLexicalUnit | fn:lu:supply:provide | "supply" | "provide" | "has lexical unit" |  | "FN" |  |
| fn:supply | fn:HasLexicalUnit | fn:lu:supply:supply | "supply" | "supply" | "has lexical unit" |  | "FN" |  |
| fn:supply | fn:HasLexicalUnit | fn:lu:supply:provision | "supply" | "provision" | "has lexical unit" |  | "FN" |  |
| fn:supply | fn:HasLexicalUnit | fn:lu:supply:provision | "supply" | "provision" | "has lexical unit" |  | "FN" |  |
| fn:supply | fn:HasLexicalUnit | fn:lu:supply:supplier | "supply" | "supplier" | "has lexical unit" |  | "FN" |  |
| fn:supply | fn:HasLexicalUnit | fn:lu:supply:equip | "supply" | "equip" | "has lexical unit" |  | "FN" |  |
| fn:supply | fn:HasLexicalUnit | fn:lu:supply:equipment | "supply" | "equipment" | "has lexical unit" |  | "FN" |  |
| fn:supply | fn:HasLexicalUnit | fn:lu:supply:outfit | "supply" | "outfit" | "has lexical unit" |  | "FN" |  |
| fn:supply | fn:HasLexicalUnit | fn:lu:supply:fix_up | "supply" | "fix up" | "has lexical unit" |  | "FN" |  |
| fn:supply | fn:HasLexicalUnit | fn:lu:supply:fuel | "supply" | "fuel" | "has lexical unit" |  | "FN" |  |
| fn:supply | fn:HasLexicalUnit | fn:lu:supply:issue | "supply" | "issue" | "has lexical unit" |  | "FN" |  |
| fn:supply | fn:HasLexicalUnit | fn:lu:supply:furnish | "supply" | "furnish" | "has lexical unit" |  | "FN" |  |
| fn:supply | fn:HasLexicalUnit | fn:lu:supply:afford | "supply" | "afford" | "has lexical unit" |  | "FN" |  |
| fn:supply | /r/HasA | fn:fe:supplier | "supply" | "supplier" | "/r/has a" |  | "FN" |  |
| fn:supply | /r/HasA | fn:fe:recipient | "supply" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:supply | /r/HasA | fn:fe:theme | "supply" | "theme" | "/r/has a" |  | "FN" |  |
| fn:supply | /r/HasA | fn:fe:place | "supply" | "place" | "/r/has a" |  | "FN" |  |
| fn:supply | /r/HasA | fn:fe:explanation | "supply" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:supply | /r/HasA | fn:fe:time | "supply" | "time" | "/r/has a" |  | "FN" |  |
| fn:supply | /r/HasA | fn:fe:purpose | "supply" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:supply | /r/HasA | fn:fe:means | "supply" | "means" | "/r/has a" |  | "FN" |  |
| fn:supply | /r/HasA | fn:fe:manner | "supply" | "manner" | "/r/has a" |  | "FN" |  |
| fn:supply | /r/HasA | fn:fe:circumstances | "supply" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:supply | /r/HasA | fn:fe:imposed_purpose | "supply" | "imposed purpose" | "/r/has a" |  | "FN" |  |
| fn:supply | /r/HasA | fn:fe:period_of_iterations | "supply" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:supply | /r/HasA | fn:fe:cotheme | "supply" | "cotheme" | "/r/has a" |  | "FN" |  |
| fn:supply | /r/HasA | fn:fe:source | "supply" | "source" | "/r/has a" |  | "FN" |  |
| fn:supporting | /r/IsA | fn:assistance | "supporting" | "assistance" | "/r/is a" |  | "FN" |  |
| fn:cause_change_of_strength | /r/UsedFor | fn:supporting | "cause change of strength" | "supporting" | "/r/used for" |  | "FN" |  |
| fn:supporting | fn:HasLexicalUnit | fn:lu:supporting:support | "supporting" | "support" | "has lexical unit" |  | "FN" |  |
| fn:supporting | fn:HasLexicalUnit | fn:lu:supporting:bolster | "supporting" | "bolster" | "has lexical unit" |  | "FN" |  |
| fn:supporting | fn:HasLexicalUnit | fn:lu:supporting:buttress | "supporting" | "buttress" | "has lexical unit" |  | "FN" |  |
| fn:supporting | /r/HasA | fn:fe:supporter | "supporting" | "supporter" | "/r/has a" |  | "FN" |  |
| fn:supporting | /r/HasA | fn:fe:supported | "supporting" | "supported" | "/r/has a" |  | "FN" |  |
| fn:supporting | /r/HasA | fn:fe:degree | "supporting" | "degree" | "/r/has a" |  | "FN" |  |
| fn:supporting | /r/HasA | fn:fe:duration | "supporting" | "duration" | "/r/has a" |  | "FN" |  |
| fn:supporting | /r/HasA | fn:fe:instrument | "supporting" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:supporting | /r/HasA | fn:fe:manner | "supporting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:supporting | /r/HasA | fn:fe:means | "supporting" | "means" | "/r/has a" |  | "FN" |  |
| fn:supporting | /r/HasA | fn:fe:place | "supporting" | "place" | "/r/has a" |  | "FN" |  |
| fn:supporting | /r/HasA | fn:fe:time | "supporting" | "time" | "/r/has a" |  | "FN" |  |
| fn:supporting | /r/HasA | fn:fe:purpose | "supporting" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:supporting | /r/HasA | fn:fe:explanation | "supporting" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:supporting | /r/HasA | fn:fe:event_description | "supporting" | "event description" | "/r/has a" |  | "FN" |  |
| fn:surpassing | /r/IsA | fn:position_on_a_scale | "surpassing" | "position on a scale" | "/r/is a" |  | "FN" |  |
| fn:surpassing | /r/UsedFor | fn:beyond_compare | "surpassing" | "beyond compare" | "/r/used for" |  | "FN" |  |
| fn:surpassing | fn:HasLexicalUnit | fn:lu:surpassing:outstrip | "surpassing" | "outstrip" | "has lexical unit" |  | "FN" |  |
| fn:surpassing | fn:HasLexicalUnit | fn:lu:surpassing:outshine | "surpassing" | "outshine" | "has lexical unit" |  | "FN" |  |
| fn:surpassing | fn:HasLexicalUnit | fn:lu:surpassing:surpass | "surpassing" | "surpass" | "has lexical unit" |  | "FN" |  |
| fn:surpassing | fn:HasLexicalUnit | fn:lu:surpassing:outdo | "surpassing" | "outdo" | "has lexical unit" |  | "FN" |  |
| fn:surpassing | fn:HasLexicalUnit | fn:lu:surpassing:better | "surpassing" | "better" | "has lexical unit" |  | "FN" |  |
| fn:surpassing | fn:HasLexicalUnit | fn:lu:surpassing:eclipse | "surpassing" | "eclipse" | "has lexical unit" |  | "FN" |  |
| fn:surpassing | fn:HasLexicalUnit | fn:lu:surpassing:pale | "surpassing" | "pale" | "has lexical unit" |  | "FN" |  |
| fn:surpassing | fn:HasLexicalUnit | fn:lu:surpassing:exceed | "surpassing" | "exceed" | "has lexical unit" |  | "FN" |  |
| fn:surpassing | /r/HasA | fn:fe:standard_item | "surpassing" | "standard item" | "/r/has a" |  | "FN" |  |
| fn:surpassing | /r/HasA | fn:fe:profiled_item | "surpassing" | "profiled item" | "/r/has a" |  | "FN" |  |
| fn:surpassing | /r/HasA | fn:fe:attribute | "surpassing" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:surpassing | /r/HasA | fn:fe:extent | "surpassing" | "extent" | "/r/has a" |  | "FN" |  |
| fn:surpassing | /r/HasA | fn:fe:time | "surpassing" | "time" | "/r/has a" |  | "FN" |  |
| fn:surpassing | /r/HasA | fn:fe:standard_attribute | "surpassing" | "standard attribute" | "/r/has a" |  | "FN" |  |
| fn:surpassing | /r/HasA | fn:fe:profiled_attribute | "surpassing" | "profiled attribute" | "/r/has a" |  | "FN" |  |
| fn:surpassing | /r/HasA | fn:fe:comparison_set | "surpassing" | "comparison set" | "/r/has a" |  | "FN" |  |
| fn:surpassing | /r/HasA | fn:fe:iterations | "surpassing" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:surpassing | /r/HasA | fn:fe:circumstances | "surpassing" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:arrest | /r/UsedFor | fn:surrendering | "arrest" | "surrendering" | "/r/used for" |  | "FN" |  |
| fn:want_suspect | /r/UsedFor | fn:surrendering | "want suspect" | "surrendering" | "/r/used for" |  | "FN" |  |
| fn:surrendering | fn:HasLexicalUnit | fn:lu:surrendering:surrender | "surrendering" | "surrender" | "has lexical unit" |  | "FN" |  |
| fn:surrendering | fn:HasLexicalUnit | fn:lu:surrendering:turn_in | "surrendering" | "turn in" | "has lexical unit" |  | "FN" |  |
| fn:surrendering | fn:HasLexicalUnit | fn:lu:surrendering:give_up | "surrendering" | "give up" | "has lexical unit" |  | "FN" |  |
| fn:surrendering | fn:HasLexicalUnit | fn:lu:surrendering:surrender | "surrendering" | "surrender" | "has lexical unit" |  | "FN" |  |
| fn:surrendering | /r/HasA | fn:fe:fugitive | "surrendering" | "fugitive" | "/r/has a" |  | "FN" |  |
| fn:surrendering | /r/HasA | fn:fe:authorities | "surrendering" | "authorities" | "/r/has a" |  | "FN" |  |
| fn:surrendering | /r/HasA | fn:fe:place | "surrendering" | "place" | "/r/has a" |  | "FN" |  |
| fn:surrendering | /r/HasA | fn:fe:time | "surrendering" | "time" | "/r/has a" |  | "FN" |  |
| fn:surrendering | /r/HasA | fn:fe:charges | "surrendering" | "charges" | "/r/has a" |  | "FN" |  |
| fn:surrendering | /r/HasA | fn:fe:manner | "surrendering" | "manner" | "/r/has a" |  | "FN" |  |
| fn:surrendering | /r/HasA | fn:fe:explanation | "surrendering" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:surrendering_possession | /r/IsA | fn:giving | "surrendering possession" | "giving" | "/r/is a" |  | "FN" |  |
| fn:surrendering_possession | fn:HasLexicalUnit | fn:lu:surrendering_possession:surrender | "surrendering possession" | "surrender" | "has lexical unit" |  | "FN" |  |
| fn:surrendering_possession | fn:HasLexicalUnit | fn:lu:surrendering_possession:yield | "surrendering possession" | "yield" | "has lexical unit" |  | "FN" |  |
| fn:surrendering_possession | fn:HasLexicalUnit | fn:lu:surrendering_possession:relinquish | "surrendering possession" | "relinquish" | "has lexical unit" |  | "FN" |  |
| fn:surrendering_possession | fn:HasLexicalUnit | fn:lu:surrendering_possession:give_up | "surrendering possession" | "give up" | "has lexical unit" |  | "FN" |  |
| fn:surrendering_possession | /r/HasA | fn:fe:surrenderer | "surrendering possession" | "surrenderer" | "/r/has a" |  | "FN" |  |
| fn:surrendering_possession | /r/HasA | fn:fe:recipient | "surrendering possession" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:surrendering_possession | /r/HasA | fn:fe:theme | "surrendering possession" | "theme" | "/r/has a" |  | "FN" |  |
| fn:surrendering_possession | /r/HasA | fn:fe:place | "surrendering possession" | "place" | "/r/has a" |  | "FN" |  |
| fn:surrendering_possession | /r/HasA | fn:fe:explanation | "surrendering possession" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:surrendering_possession | /r/HasA | fn:fe:time | "surrendering possession" | "time" | "/r/has a" |  | "FN" |  |
| fn:surrendering_possession | /r/HasA | fn:fe:purpose | "surrendering possession" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:surrendering_possession | /r/HasA | fn:fe:means | "surrendering possession" | "means" | "/r/has a" |  | "FN" |  |
| fn:surrendering_possession | /r/HasA | fn:fe:manner | "surrendering possession" | "manner" | "/r/has a" |  | "FN" |  |
| fn:surrendering_possession | /r/HasA | fn:fe:circumstances | "surrendering possession" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:surrendering_possession | /r/HasA | fn:fe:period_of_iterations | "surrendering possession" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:surrendering_possession | /r/HasA | fn:fe:event_description | "surrendering possession" | "event description" | "/r/has a" |  | "FN" |  |
| fn:surrendering_possession | /r/HasA | fn:fe:re-encoding | "surrendering possession" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:surrendering_possession | /r/HasA | fn:fe:communicative_force | "surrendering possession" | "communicative force" | "/r/has a" |  | "FN" |  |
| fn:surrendering_possession | /r/HasA | fn:fe:particular_iteration | "surrendering possession" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:surrendering_possession | /r/HasA | fn:fe:depictive | "surrendering possession" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:surrendering_possession | /r/HasA | fn:fe:containing_event | "surrendering possession" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:surrendering_possession | /r/HasA | fn:fe:frequency | "surrendering possession" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:surrendering_possession | /r/HasA | fn:fe:result | "surrendering possession" | "result" | "/r/has a" |  | "FN" |  |
| fn:surrendering_possession | /r/HasA | fn:fe:degree | "surrendering possession" | "degree" | "/r/has a" |  | "FN" |  |
| fn:interior_profile_relation | /r/UsedFor | fn:surrounding | "interior profile relation" | "surrounding" | "/r/used for" |  | "FN" |  |
| fn:surrounding | /r/RelatedTo | fn:distributed_position | "surrounding" | "distributed position" | "/r/related to" |  | "FN" |  |
| fn:non-gradable_proximity | /r/SimilarTo | fn:surrounding | "non-gradable proximity" | "surrounding" | "/r/similar to" |  | "FN" |  |
| fn:surrounding | fn:HasLexicalUnit | fn:lu:surrounding:around | "surrounding" | "around" | "has lexical unit" |  | "FN" |  |
| fn:surrounding | fn:HasLexicalUnit | fn:lu:surrounding:surround | "surrounding" | "surround" | "has lexical unit" |  | "FN" |  |
| fn:surrounding | fn:HasLexicalUnit | fn:lu:surrounding:surrounding | "surrounding" | "surrounding" | "has lexical unit" |  | "FN" |  |
| fn:surrounding | fn:HasLexicalUnit | fn:lu:surrounding:astride | "surrounding" | "astride" | "has lexical unit" |  | "FN" |  |
| fn:surrounding | fn:HasLexicalUnit | fn:lu:surrounding:straddle | "surrounding" | "straddle" | "has lexical unit" |  | "FN" |  |
| fn:surrounding | fn:HasLexicalUnit | fn:lu:surrounding:ring | "surrounding" | "ring" | "has lexical unit" |  | "FN" |  |
| fn:surrounding | fn:HasLexicalUnit | fn:lu:surrounding:rim | "surrounding" | "rim" | "has lexical unit" |  | "FN" |  |
| fn:surrounding | fn:HasLexicalUnit | fn:lu:surrounding:edge | "surrounding" | "edge" | "has lexical unit" |  | "FN" |  |
| fn:surrounding | fn:HasLexicalUnit | fn:lu:surrounding:straddling | "surrounding" | "straddling" | "has lexical unit" |  | "FN" |  |
| fn:surrounding | /r/HasA | fn:fe:figure | "surrounding" | "figure" | "/r/has a" |  | "FN" |  |
| fn:surrounding | /r/HasA | fn:fe:ground | "surrounding" | "ground" | "/r/has a" |  | "FN" |  |
| fn:surrounding | /r/HasA | fn:fe:time | "surrounding" | "time" | "/r/has a" |  | "FN" |  |
| fn:surrounding | /r/HasA | fn:fe:direction | "surrounding" | "direction" | "/r/has a" |  | "FN" |  |
| fn:surrounding | /r/HasA | fn:fe:distance | "surrounding" | "distance" | "/r/has a" |  | "FN" |  |
| fn:surrounding | /r/HasA | fn:fe:profiled_region | "surrounding" | "profiled region" | "/r/has a" |  | "FN" |  |
| fn:surrounding | /r/HasA | fn:fe:directness | "surrounding" | "directness" | "/r/has a" |  | "FN" |  |
| fn:surrounding | /r/HasA | fn:fe:accessibility | "surrounding" | "accessibility" | "/r/has a" |  | "FN" |  |
| fn:surviving | /r/IsA | fn:success_or_failure | "surviving" | "success or failure" | "/r/is a" |  | "FN" |  |
| fn:killing | /r/UsedFor | fn:surviving | "killing" | "surviving" | "/r/used for" |  | "FN" |  |
| fn:surviving | fn:HasLexicalUnit | fn:lu:surviving:survive | "surviving" | "survive" | "has lexical unit" |  | "FN" |  |
| fn:surviving | fn:HasLexicalUnit | fn:lu:surviving:ride_out | "surviving" | "ride out" | "has lexical unit" |  | "FN" |  |
| fn:surviving | fn:HasLexicalUnit | fn:lu:surviving:weather | "surviving" | "weather" | "has lexical unit" |  | "FN" |  |
| fn:surviving | fn:HasLexicalUnit | fn:lu:surviving:survival | "surviving" | "survival" | "has lexical unit" |  | "FN" |  |
| fn:surviving | fn:HasLexicalUnit | fn:lu:surviving:live_[through] | "surviving" | "live [through]" | "has lexical unit" |  | "FN" |  |
| fn:surviving | /r/HasA | fn:fe:survivor | "surviving" | "survivor" | "/r/has a" |  | "FN" |  |
| fn:surviving | /r/HasA | fn:fe:dangerous_situation | "surviving" | "dangerous situation" | "/r/has a" |  | "FN" |  |
| fn:surviving | /r/HasA | fn:fe:place | "surviving" | "place" | "/r/has a" |  | "FN" |  |
| fn:surviving | /r/HasA | fn:fe:time | "surviving" | "time" | "/r/has a" |  | "FN" |  |
| fn:surviving | /r/HasA | fn:fe:means | "surviving" | "means" | "/r/has a" |  | "FN" |  |
| fn:surviving | /r/HasA | fn:fe:degree | "surviving" | "degree" | "/r/has a" |  | "FN" |  |
| fn:surviving | /r/HasA | fn:fe:depictive | "surviving" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:criminal_investigation | /r/UsedFor | fn:suspicion | "criminal investigation" | "suspicion" | "/r/used for" |  | "FN" |  |
| fn:suspicion | fn:HasLexicalUnit | fn:lu:suspicion:suspect | "suspicion" | "suspect" | "has lexical unit" |  | "FN" |  |
| fn:suspicion | fn:HasLexicalUnit | fn:lu:suspicion:under_suspicion_(of) | "suspicion" | "under suspicion (of)" | "has lexical unit" |  | "FN" |  |
| fn:suspicion | fn:HasLexicalUnit | fn:lu:suspicion:suspect | "suspicion" | "suspect" | "has lexical unit" |  | "FN" |  |
| fn:suspicion | /r/HasA | fn:fe:authority | "suspicion" | "authority" | "/r/has a" |  | "FN" |  |
| fn:suspicion | /r/HasA | fn:fe:suspect | "suspicion" | "suspect" | "/r/has a" |  | "FN" |  |
| fn:suspicion | /r/HasA | fn:fe:incident | "suspicion" | "incident" | "/r/has a" |  | "FN" |  |
| fn:suspicion | /r/HasA | fn:fe:time | "suspicion" | "time" | "/r/has a" |  | "FN" |  |
| fn:symmetrical_collective_reciprocality | /r/IsA | fn:reciprocality | "symmetrical collective reciprocality" | "reciprocality" | "/r/is a" |  | "FN" |  |
| fn:symmetrical_collective_reciprocality | /r/HasA | fn:fe:protagonists | "symmetrical collective reciprocality" | "protagonists" | "/r/has a" |  | "FN" |  |
| fn:system | /r/IsA | fn:set_of_interrelated_entities | "system" | "set of interrelated entities" | "/r/is a" |  | "FN" |  |
| fn:system | fn:HasLexicalUnit | fn:lu:system:system | "system" | "system" | "has lexical unit" |  | "FN" |  |
| fn:system | fn:HasLexicalUnit | fn:lu:system:complex | "system" | "complex" | "has lexical unit" |  | "FN" |  |
| fn:system | fn:HasLexicalUnit | fn:lu:system:cascade | "system" | "cascade" | "has lexical unit" |  | "FN" |  |
| fn:system | /r/HasA | fn:fe:component_entities | "system" | "component entities" | "/r/has a" |  | "FN" |  |
| fn:system | /r/HasA | fn:fe:complex | "system" | "complex" | "/r/has a" |  | "FN" |  |
| fn:system | /r/HasA | fn:fe:function | "system" | "function" | "/r/has a" |  | "FN" |  |
| fn:system | /r/HasA | fn:fe:descriptor | "system" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:system | /r/HasA | fn:fe:possessor | "system" | "possessor" | "/r/has a" |  | "FN" |  |
| fn:system | /r/HasA | fn:fe:salient_entity | "system" | "salient entity" | "/r/has a" |  | "FN" |  |
| fn:system_complexity | /r/IsA | fn:gradable_attributes | "system complexity" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:system_complexity | fn:HasLexicalUnit | fn:lu:system_complexity:complex | "system complexity" | "complex" | "has lexical unit" |  | "FN" |  |
| fn:system_complexity | fn:HasLexicalUnit | fn:lu:system_complexity:simple | "system complexity" | "simple" | "has lexical unit" |  | "FN" |  |
| fn:system_complexity | fn:HasLexicalUnit | fn:lu:system_complexity:byzantine | "system complexity" | "byzantine" | "has lexical unit" |  | "FN" |  |
| fn:system_complexity | /r/HasA | fn:fe:system | "system complexity" | "system" | "/r/has a" |  | "FN" |  |
| fn:system_complexity | /r/HasA | fn:fe:degree | "system complexity" | "degree" | "/r/has a" |  | "FN" |  |
| fn:system_complexity | /r/HasA | fn:fe:dimension | "system complexity" | "dimension" | "/r/has a" |  | "FN" |  |
| fn:replacing | /r/Causes | fn:take_place_of | "replacing" | "take place of" | "/r/causes" |  | "FN" |  |
| fn:take_place_of | fn:HasLexicalUnit | fn:lu:take_place_of:replace | "take place of" | "replace" | "has lexical unit" |  | "FN" |  |
| fn:take_place_of | fn:HasLexicalUnit | fn:lu:take_place_of:substitute | "take place of" | "substitute" | "has lexical unit" |  | "FN" |  |
| fn:take_place_of | fn:HasLexicalUnit | fn:lu:take_place_of:take_place | "take place of" | "take place" | "has lexical unit" |  | "FN" |  |
| fn:take_place_of | fn:HasLexicalUnit | fn:lu:take_place_of:replacement | "take place of" | "replacement" | "has lexical unit" |  | "FN" |  |
| fn:take_place_of | fn:HasLexicalUnit | fn:lu:take_place_of:do_duty | "take place of" | "do duty" | "has lexical unit" |  | "FN" |  |
| fn:take_place_of | fn:HasLexicalUnit | fn:lu:take_place_of:succeed | "take place of" | "succeed" | "has lexical unit" |  | "FN" |  |
| fn:take_place_of | fn:HasLexicalUnit | fn:lu:take_place_of:succession | "take place of" | "succession" | "has lexical unit" |  | "FN" |  |
| fn:take_place_of | /r/HasA | fn:fe:new | "take place of" | "new" | "/r/has a" |  | "FN" |  |
| fn:fe:role | /r/RelatedTo | fn:fe:function | "role" | "function" | "/r/related to" |  | "FN" |  |
| fn:take_place_of | /r/HasA | fn:fe:role | "take place of" | "role" | "/r/has a" |  | "FN" |  |
| fn:take_place_of | /r/HasA | fn:fe:function | "take place of" | "function" | "/r/has a" |  | "FN" |  |
| fn:take_place_of | /r/HasA | fn:fe:old | "take place of" | "old" | "/r/has a" |  | "FN" |  |
| fn:take_place_of | /r/HasA | fn:fe:time | "take place of" | "time" | "/r/has a" |  | "FN" |  |
| fn:take_place_of | /r/HasA | fn:fe:degree | "take place of" | "degree" | "/r/has a" |  | "FN" |  |
| fn:take_place_of | /r/HasA | fn:fe:manner | "take place of" | "manner" | "/r/has a" |  | "FN" |  |
| fn:take_place_of | /r/HasA | fn:fe:textual_location | "take place of" | "textual location" | "/r/has a" |  | "FN" |  |
| fn:take_place_of | /r/HasA | fn:fe:explanation | "take place of" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:taking | /r/IsA | fn:getting | "taking" | "getting" | "/r/is a" |  | "FN" |  |
| fn:taking | /r/IsA | fn:intentionally_affect | "taking" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:theft | /r/IsA | fn:taking | "theft" | "taking" | "/r/is a" |  | "FN" |  |
| fn:taking | fn:HasLexicalUnit | fn:lu:taking:take | "taking" | "take" | "has lexical unit" |  | "FN" |  |
| fn:taking | fn:HasLexicalUnit | fn:lu:taking:seize | "taking" | "seize" | "has lexical unit" |  | "FN" |  |
| fn:taking | fn:HasLexicalUnit | fn:lu:taking:seizure | "taking" | "seizure" | "has lexical unit" |  | "FN" |  |
| fn:taking | fn:HasLexicalUnit | fn:lu:taking:grab | "taking" | "grab" | "has lexical unit" |  | "FN" |  |
| fn:taking | fn:HasLexicalUnit | fn:lu:taking:commandeer | "taking" | "commandeer" | "has lexical unit" |  | "FN" |  |
| fn:taking | /r/HasA | fn:fe:agent | "taking" | "agent" | "/r/has a" |  | "FN" |  |
| fn:taking | /r/HasA | fn:fe:theme | "taking" | "theme" | "/r/has a" |  | "FN" |  |
| fn:taking | /r/HasA | fn:fe:source | "taking" | "source" | "/r/has a" |  | "FN" |  |
| fn:taking | /r/HasA | fn:fe:place | "taking" | "place" | "/r/has a" |  | "FN" |  |
| fn:taking | /r/HasA | fn:fe:time | "taking" | "time" | "/r/has a" |  | "FN" |  |
| fn:taking | /r/HasA | fn:fe:manner | "taking" | "manner" | "/r/has a" |  | "FN" |  |
| fn:taking | /r/HasA | fn:fe:means | "taking" | "means" | "/r/has a" |  | "FN" |  |
| fn:taking | /r/HasA | fn:fe:purpose | "taking" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:taking | /r/HasA | fn:fe:explanation | "taking" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:taking | /r/HasA | fn:fe:containing_event | "taking" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:inhibit_motion_scenario | /r/HasSubevent | fn:taking_captive | "inhibit motion scenario" | "taking captive" | "/r/has subevent" |  | "FN" |  |
| fn:inhibit_movement | /r/HasPrerequisite | fn:taking_captive | "inhibit movement" | "taking captive" | "/r/has prerequisite" |  | "FN" |  |
| fn:taking_captive | fn:HasLexicalUnit | fn:lu:taking_captive:capture | "taking captive" | "capture" | "has lexical unit" |  | "FN" |  |
| fn:taking_captive | fn:HasLexicalUnit | fn:lu:taking_captive:take_captive | "taking captive" | "take captive" | "has lexical unit" |  | "FN" |  |
| fn:taking_captive | fn:HasLexicalUnit | fn:lu:taking_captive:secure | "taking captive" | "secure" | "has lexical unit" |  | "FN" |  |
| fn:taking_captive | fn:HasLexicalUnit | fn:lu:taking_captive:capture | "taking captive" | "capture" | "has lexical unit" |  | "FN" |  |
| fn:fe:captive | /r/IsA | fn:st:physical_object | "captive" | "physical object" | "/r/is a" |  | "FN" |  |
| fn:taking_captive | /r/HasA | fn:fe:captive | "taking captive" | "captive" | "/r/has a" |  | "FN" |  |
| fn:taking_captive | /r/HasA | fn:fe:agent | "taking captive" | "agent" | "/r/has a" |  | "FN" |  |
| fn:taking_captive | /r/HasA | fn:fe:instrument | "taking captive" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:taking_captive | /r/HasA | fn:fe:reciprocation | "taking captive" | "reciprocation" | "/r/has a" |  | "FN" |  |
| fn:taking_captive | /r/HasA | fn:fe:place | "taking captive" | "place" | "/r/has a" |  | "FN" |  |
| fn:taking_captive | /r/HasA | fn:fe:time | "taking captive" | "time" | "/r/has a" |  | "FN" |  |
| fn:taking_captive | /r/HasA | fn:fe:purpose | "taking captive" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:taking_captive | /r/HasA | fn:fe:means | "taking captive" | "means" | "/r/has a" |  | "FN" |  |
| fn:taking_captive | /r/HasA | fn:fe:manner | "taking captive" | "manner" | "/r/has a" |  | "FN" |  |
| fn:taking_captive | /r/HasA | fn:fe:explanation | "taking captive" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:taking_captive | /r/HasA | fn:fe:cause | "taking captive" | "cause" | "/r/has a" |  | "FN" |  |
| fn:taking_captive | /r/HasA | fn:fe:depictive | "taking captive" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:taking_captive | /r/HasA | fn:fe:containing_event | "taking captive" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:desirable_event | /r/UsedFor | fn:taking_sides | "desirable event" | "taking sides" | "/r/used for" |  | "FN" |  |
| fn:opinion | /r/UsedFor | fn:taking_sides | "opinion" | "taking sides" | "/r/used for" |  | "FN" |  |
| fn:taking_sides | /r/UsedFor | fn:giving_in | "taking sides" | "giving in" | "/r/used for" |  | "FN" |  |
| fn:taking_sides | /r/UsedFor | fn:hostile_encounter | "taking sides" | "hostile encounter" | "/r/used for" |  | "FN" |  |
| fn:taking_sides | /r/UsedFor | fn:partiality | "taking sides" | "partiality" | "/r/used for" |  | "FN" |  |
| fn:taking_sides | /r/UsedFor | fn:protest | "taking sides" | "protest" | "/r/used for" |  | "FN" |  |
| fn:taking_sides | fn:HasLexicalUnit | fn:lu:taking_sides:oppose | "taking sides" | "oppose" | "has lexical unit" |  | "FN" |  |
| fn:taking_sides | fn:HasLexicalUnit | fn:lu:taking_sides:for | "taking sides" | "for" | "has lexical unit" |  | "FN" |  |
| fn:taking_sides | fn:HasLexicalUnit | fn:lu:taking_sides:against | "taking sides" | "against" | "has lexical unit" |  | "FN" |  |
| fn:taking_sides | fn:HasLexicalUnit | fn:lu:taking_sides:pro | "taking sides" | "pro" | "has lexical unit" |  | "FN" |  |
| fn:taking_sides | fn:HasLexicalUnit | fn:lu:taking_sides:support | "taking sides" | "support" | "has lexical unit" |  | "FN" |  |
| fn:taking_sides | fn:HasLexicalUnit | fn:lu:taking_sides:side | "taking sides" | "side" | "has lexical unit" |  | "FN" |  |
| fn:taking_sides | fn:HasLexicalUnit | fn:lu:taking_sides:side | "taking sides" | "side" | "has lexical unit" |  | "FN" |  |
| fn:taking_sides | fn:HasLexicalUnit | fn:lu:taking_sides:opposition_[act] | "taking sides" | "opposition [act]" | "has lexical unit" |  | "FN" |  |
| fn:taking_sides | fn:HasLexicalUnit | fn:lu:taking_sides:in_favor | "taking sides" | "in favor" | "has lexical unit" |  | "FN" |  |
| fn:taking_sides | fn:HasLexicalUnit | fn:lu:taking_sides:supportive | "taking sides" | "supportive" | "has lexical unit" |  | "FN" |  |
| fn:taking_sides | fn:HasLexicalUnit | fn:lu:taking_sides:opponent | "taking sides" | "opponent" | "has lexical unit" |  | "FN" |  |
| fn:taking_sides | fn:HasLexicalUnit | fn:lu:taking_sides:supporter | "taking sides" | "supporter" | "has lexical unit" |  | "FN" |  |
| fn:taking_sides | fn:HasLexicalUnit | fn:lu:taking_sides:opposition_[entity] | "taking sides" | "opposition [entity]" | "has lexical unit" |  | "FN" |  |
| fn:taking_sides | fn:HasLexicalUnit | fn:lu:taking_sides:endorse | "taking sides" | "endorse" | "has lexical unit" |  | "FN" |  |
| fn:taking_sides | fn:HasLexicalUnit | fn:lu:taking_sides:back | "taking sides" | "back" | "has lexical unit" |  | "FN" |  |
| fn:taking_sides | fn:HasLexicalUnit | fn:lu:taking_sides:backing | "taking sides" | "backing" | "has lexical unit" |  | "FN" |  |
| fn:taking_sides | fn:HasLexicalUnit | fn:lu:taking_sides:believe_(in) | "taking sides" | "believe (in)" | "has lexical unit" |  | "FN" |  |
| fn:taking_sides | fn:HasLexicalUnit | fn:lu:taking_sides:part | "taking sides" | "part" | "has lexical unit" |  | "FN" |  |
| fn:taking_sides | /r/HasA | fn:fe:cognizer | "taking sides" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:taking_sides | /r/HasA | fn:fe:issue | "taking sides" | "issue" | "/r/has a" |  | "FN" |  |
| fn:taking_sides | /r/HasA | fn:fe:side | "taking sides" | "side" | "/r/has a" |  | "FN" |  |
| fn:taking_sides | /r/HasA | fn:fe:degree | "taking sides" | "degree" | "/r/has a" |  | "FN" |  |
| fn:taking_sides | /r/HasA | fn:fe:time | "taking sides" | "time" | "/r/has a" |  | "FN" |  |
| fn:taking_sides | /r/HasA | fn:fe:explanation | "taking sides" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:taking_sides | /r/HasA | fn:fe:action | "taking sides" | "action" | "/r/has a" |  | "FN" |  |
| fn:taking_sides | /r/HasA | fn:fe:descriptor | "taking sides" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:taking_sides | /r/HasA | fn:fe:particular_iteration | "taking sides" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:taking_sides | /r/HasA | fn:fe:manner | "taking sides" | "manner" | "/r/has a" |  | "FN" |  |
| fn:taking_sides | /r/HasA | fn:fe:concessive | "taking sides" | "concessive" | "/r/has a" |  | "FN" |  |
| fn:taking_sides | /r/HasA | fn:fe:place | "taking sides" | "place" | "/r/has a" |  | "FN" |  |
| fn:taking_time | /r/IsA | fn:gradable_attributes | "taking time" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:being_necessary | /r/UsedFor | fn:taking_time | "being necessary" | "taking time" | "/r/used for" |  | "FN" |  |
| fn:duration_description | /r/UsedFor | fn:taking_time | "duration description" | "taking time" | "/r/used for" |  | "FN" |  |
| fn:taking_time | fn:HasLexicalUnit | fn:lu:taking_time:take | "taking time" | "take" | "has lexical unit" |  | "FN" |  |
| fn:taking_time | fn:HasLexicalUnit | fn:lu:taking_time:in | "taking time" | "in" | "has lexical unit" |  | "FN" |  |
| fn:taking_time | fn:HasLexicalUnit | fn:lu:taking_time:fast | "taking time" | "fast" | "has lexical unit" |  | "FN" |  |
| fn:taking_time | fn:HasLexicalUnit | fn:lu:taking_time:quick | "taking time" | "quick" | "has lexical unit" |  | "FN" |  |
| fn:taking_time | fn:HasLexicalUnit | fn:lu:taking_time:rapid | "taking time" | "rapid" | "has lexical unit" |  | "FN" |  |
| fn:taking_time | fn:HasLexicalUnit | fn:lu:taking_time:swift | "taking time" | "swift" | "has lexical unit" |  | "FN" |  |
| fn:taking_time | fn:HasLexicalUnit | fn:lu:taking_time:speedy | "taking time" | "speedy" | "has lexical unit" |  | "FN" |  |
| fn:taking_time | fn:HasLexicalUnit | fn:lu:taking_time:slowly | "taking time" | "slowly" | "has lexical unit" |  | "FN" |  |
| fn:taking_time | fn:HasLexicalUnit | fn:lu:taking_time:slow | "taking time" | "slow" | "has lexical unit" |  | "FN" |  |
| fn:taking_time | fn:HasLexicalUnit | fn:lu:taking_time:gradually | "taking time" | "gradually" | "has lexical unit" |  | "FN" |  |
| fn:taking_time | fn:HasLexicalUnit | fn:lu:taking_time:quickly | "taking time" | "quickly" | "has lexical unit" |  | "FN" |  |
| fn:taking_time | /r/HasA | fn:fe:activity | "taking time" | "activity" | "/r/has a" |  | "FN" |  |
| fn:taking_time | /r/HasA | fn:fe:attribute | "taking time" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:taking_time | /r/HasA | fn:fe:time_length | "taking time" | "time length" | "/r/has a" |  | "FN" |  |
| fn:fe:degree | /r/RelatedTo | fn:fe:time_length | "degree" | "time length" | "/r/related to" |  | "FN" |  |
| fn:taking_time | /r/HasA | fn:fe:degree | "taking time" | "degree" | "/r/has a" |  | "FN" |  |
| fn:taking_time | /r/HasA | fn:fe:time | "taking time" | "time" | "/r/has a" |  | "FN" |  |
| fn:taking_time | /r/HasA | fn:fe:circumstances | "taking time" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:taking_time | /r/HasA | fn:fe:agent | "taking time" | "agent" | "/r/has a" |  | "FN" |  |
| fn:taking_time | /r/HasA | fn:fe:duration | "taking time" | "duration" | "/r/has a" |  | "FN" |  |
| fn:talking_into | /r/IsA | fn:manipulate_into_doing | "talking into" | "manipulate into doing" | "/r/is a" |  | "FN" |  |
| fn:suasion | /r/UsedFor | fn:talking_into | "suasion" | "talking into" | "/r/used for" |  | "FN" |  |
| fn:talking_into | /r/SimilarTo | fn:suasion | "talking into" | "suasion" | "/r/similar to" |  | "FN" |  |
| fn:talking_into | /r/SimilarTo | fn:subjective_influence | "talking into" | "subjective influence" | "/r/similar to" |  | "FN" |  |
| fn:talking_into | fn:HasLexicalUnit | fn:lu:talking_into:incite | "talking into" | "incite" | "has lexical unit" |  | "FN" |  |
| fn:talking_into | fn:HasLexicalUnit | fn:lu:talking_into:induce | "talking into" | "induce" | "has lexical unit" |  | "FN" |  |
| fn:talking_into | fn:HasLexicalUnit | fn:lu:talking_into:influence | "talking into" | "influence" | "has lexical unit" |  | "FN" |  |
| fn:talking_into | fn:HasLexicalUnit | fn:lu:talking_into:lead | "talking into" | "lead" | "has lexical unit" |  | "FN" |  |
| fn:talking_into | fn:HasLexicalUnit | fn:lu:talking_into:talk | "talking into" | "talk" | "has lexical unit" |  | "FN" |  |
| fn:talking_into | /r/HasA | fn:fe:speaker | "talking into" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:talking_into | /r/HasA | fn:fe:content | "talking into" | "content" | "/r/has a" |  | "FN" |  |
| fn:talking_into | /r/HasA | fn:fe:addressee | "talking into" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:talking_into | /r/HasA | fn:fe:means | "talking into" | "means" | "/r/has a" |  | "FN" |  |
| fn:talking_into | /r/HasA | fn:fe:goods | "talking into" | "goods" | "/r/has a" |  | "FN" |  |
| fn:talking_into | /r/HasA | fn:fe:purpose | "talking into" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:talking_into | /r/HasA | fn:fe:instrument | "talking into" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:talking_into | /r/HasA | fn:fe:place | "talking into" | "place" | "/r/has a" |  | "FN" |  |
| fn:tasting | /r/IsA | fn:trying_out | "tasting" | "trying out" | "/r/is a" |  | "FN" |  |
| fn:food | /r/UsedFor | fn:tasting | "food" | "tasting" | "/r/used for" |  | "FN" |  |
| fn:tasting | fn:HasLexicalUnit | fn:lu:tasting:try | "tasting" | "try" | "has lexical unit" |  | "FN" |  |
| fn:tasting | fn:HasLexicalUnit | fn:lu:tasting:taste | "tasting" | "taste" | "has lexical unit" |  | "FN" |  |
| fn:tasting | /r/HasA | fn:fe:agent | "tasting" | "agent" | "/r/has a" |  | "FN" |  |
| fn:tasting | /r/HasA | fn:fe:food | "tasting" | "food" | "/r/has a" |  | "FN" |  |
| fn:tasting | /r/HasA | fn:fe:means | "tasting" | "means" | "/r/has a" |  | "FN" |  |
| fn:tasting | /r/HasA | fn:fe:instrument | "tasting" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:tasting | /r/HasA | fn:fe:purpose | "tasting" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:tasting | /r/HasA | fn:fe:time | "tasting" | "time" | "/r/has a" |  | "FN" |  |
| fn:tasting | /r/HasA | fn:fe:place | "tasting" | "place" | "/r/has a" |  | "FN" |  |
| fn:tasting | /r/HasA | fn:fe:manner | "tasting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:team | /r/IsA | fn:aggregate | "team" | "aggregate" | "/r/is a" |  | "FN" |  |
| fn:team | /r/SimilarTo | fn:people_by_vocation | "team" | "people by vocation" | "/r/similar to" |  | "FN" |  |
| fn:team | fn:HasLexicalUnit | fn:lu:team:team | "team" | "team" | "has lexical unit" |  | "FN" |  |
| fn:team | fn:HasLexicalUnit | fn:lu:team:crew | "team" | "crew" | "has lexical unit" |  | "FN" |  |
| fn:team | fn:HasLexicalUnit | fn:lu:team:firefighter | "team" | "firefighter" | "has lexical unit" |  | "FN" |  |
| fn:team | fn:HasLexicalUnit | fn:lu:team:fire_fighter | "team" | "fire fighter" | "has lexical unit" |  | "FN" |  |
| fn:team | /r/HasA | fn:fe:members | "team" | "members" | "/r/has a" |  | "FN" |  |
| fn:team | /r/HasA | fn:fe:team | "team" | "team" | "/r/has a" |  | "FN" |  |
| fn:team | /r/HasA | fn:fe:aggregate_property | "team" | "aggregate property" | "/r/has a" |  | "FN" |  |
| fn:team | /r/HasA | fn:fe:name | "team" | "name" | "/r/has a" |  | "FN" |  |
| fn:team | /r/HasA | fn:fe:container_possessor | "team" | "container possessor" | "/r/has a" |  | "FN" |  |
| fn:team | /r/HasA | fn:fe:domain | "team" | "domain" | "/r/has a" |  | "FN" |  |
| fn:team | /r/HasA | fn:fe:activity | "team" | "activity" | "/r/has a" |  | "FN" |  |
| fn:team | /r/HasA | fn:fe:parent_organization | "team" | "parent organization" | "/r/has a" |  | "FN" |  |
| fn:telling | /r/IsA | fn:statement | "telling" | "statement" | "/r/is a" |  | "FN" |  |
| fn:suasion | /r/IsA | fn:telling | "suasion" | "telling" | "/r/is a" |  | "FN" |  |
| fn:warning | /r/IsA | fn:telling | "warning" | "telling" | "/r/is a" |  | "FN" |  |
| fn:request | /r/SimilarTo | fn:telling | "request" | "telling" | "/r/similar to" |  | "FN" |  |
| fn:statement | /r/SimilarTo | fn:telling | "statement" | "telling" | "/r/similar to" |  | "FN" |  |
| fn:telling | fn:HasLexicalUnit | fn:lu:telling:tell | "telling" | "tell" | "has lexical unit" |  | "FN" |  |
| fn:telling | fn:HasLexicalUnit | fn:lu:telling:inform | "telling" | "inform" | "has lexical unit" |  | "FN" |  |
| fn:telling | fn:HasLexicalUnit | fn:lu:telling:advise | "telling" | "advise" | "has lexical unit" |  | "FN" |  |
| fn:telling | fn:HasLexicalUnit | fn:lu:telling:apprise | "telling" | "apprise" | "has lexical unit" |  | "FN" |  |
| fn:telling | fn:HasLexicalUnit | fn:lu:telling:assure | "telling" | "assure" | "has lexical unit" |  | "FN" |  |
| fn:telling | fn:HasLexicalUnit | fn:lu:telling:confide | "telling" | "confide" | "has lexical unit" |  | "FN" |  |
| fn:telling | fn:HasLexicalUnit | fn:lu:telling:notify | "telling" | "notify" | "has lexical unit" |  | "FN" |  |
| fn:telling | fn:HasLexicalUnit | fn:lu:telling:notification | "telling" | "notification" | "has lexical unit" |  | "FN" |  |
| fn:telling | fn:HasLexicalUnit | fn:lu:telling:assurance | "telling" | "assurance" | "has lexical unit" |  | "FN" |  |
| fn:telling | fn:HasLexicalUnit | fn:lu:telling:brief | "telling" | "brief" | "has lexical unit" |  | "FN" |  |
| fn:telling | fn:HasLexicalUnit | fn:lu:telling:let_know | "telling" | "let know" | "has lexical unit" |  | "FN" |  |
| fn:telling | /r/HasA | fn:fe:speaker | "telling" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:telling | /r/HasA | fn:fe:addressee | "telling" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:telling | /r/HasA | fn:fe:message | "telling" | "message" | "/r/has a" |  | "FN" |  |
| fn:telling | /r/HasA | fn:fe:topic | "telling" | "topic" | "/r/has a" |  | "FN" |  |
| fn:telling | /r/HasA | fn:fe:manner | "telling" | "manner" | "/r/has a" |  | "FN" |  |
| fn:telling | /r/HasA | fn:fe:means | "telling" | "means" | "/r/has a" |  | "FN" |  |
| fn:telling | /r/HasA | fn:fe:medium | "telling" | "medium" | "/r/has a" |  | "FN" |  |
| fn:telling | /r/HasA | fn:fe:time | "telling" | "time" | "/r/has a" |  | "FN" |  |
| fn:telling | /r/HasA | fn:fe:place | "telling" | "place" | "/r/has a" |  | "FN" |  |
| fn:telling | /r/HasA | fn:fe:communicative_force | "telling" | "communicative force" | "/r/has a" |  | "FN" |  |
| fn:telling | /r/HasA | fn:fe:descriptor | "telling" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:telling | /r/HasA | fn:fe:iterations | "telling" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:temperature | /r/IsA | fn:measurable_attributes | "temperature" | "measurable attributes" | "/r/is a" |  | "FN" |  |
| fn:ambient_temperature | /r/IsA | fn:temperature | "ambient temperature" | "temperature" | "/r/is a" |  | "FN" |  |
| fn:temperature | /r/UsedFor | fn:heat_potential | "temperature" | "heat potential" | "/r/used for" |  | "FN" |  |
| fn:change_of_temperature | /r/Causes | fn:temperature | "change of temperature" | "temperature" | "/r/causes" |  | "FN" |  |
| fn:temperature | fn:HasLexicalUnit | fn:lu:temperature:temperature | "temperature" | "temperature" | "has lexical unit" |  | "FN" |  |
| fn:temperature | fn:HasLexicalUnit | fn:lu:temperature:hot | "temperature" | "hot" | "has lexical unit" |  | "FN" |  |
| fn:temperature | fn:HasLexicalUnit | fn:lu:temperature:cool | "temperature" | "cool" | "has lexical unit" |  | "FN" |  |
| fn:temperature | fn:HasLexicalUnit | fn:lu:temperature:freezing | "temperature" | "freezing" | "has lexical unit" |  | "FN" |  |
| fn:temperature | fn:HasLexicalUnit | fn:lu:temperature:cold | "temperature" | "cold" | "has lexical unit" |  | "FN" |  |
| fn:temperature | fn:HasLexicalUnit | fn:lu:temperature:lukewarm | "temperature" | "lukewarm" | "has lexical unit" |  | "FN" |  |
| fn:temperature | fn:HasLexicalUnit | fn:lu:temperature:tepid | "temperature" | "tepid" | "has lexical unit" |  | "FN" |  |
| fn:temperature | fn:HasLexicalUnit | fn:lu:temperature:frigid | "temperature" | "frigid" | "has lexical unit" |  | "FN" |  |
| fn:temperature | fn:HasLexicalUnit | fn:lu:temperature:scalding | "temperature" | "scalding" | "has lexical unit" |  | "FN" |  |
| fn:temperature | fn:HasLexicalUnit | fn:lu:temperature:warm | "temperature" | "warm" | "has lexical unit" |  | "FN" |  |
| fn:temperature | /r/HasA | fn:fe:entity | "temperature" | "entity" | "/r/has a" |  | "FN" |  |
| fn:temperature | /r/HasA | fn:fe:attribute | "temperature" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:temperature | /r/HasA | fn:fe:temperature | "temperature" | "temperature" | "/r/has a" |  | "FN" |  |
| fn:fe:degree | /r/RelatedTo | fn:fe:temperature | "degree" | "temperature" | "/r/related to" |  | "FN" |  |
| fn:temperature | /r/HasA | fn:fe:degree | "temperature" | "degree" | "/r/has a" |  | "FN" |  |
| fn:temperature | /r/HasA | fn:fe:time | "temperature" | "time" | "/r/has a" |  | "FN" |  |
| fn:temperature | /r/HasA | fn:fe:circumstances | "temperature" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:temperature | /r/HasA | fn:fe:subregion | "temperature" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:temporal_collocation | /r/IsA | fn:basis_for_attribute | "temporal collocation" | "basis for attribute" | "/r/is a" |  | "FN" |  |
| fn:calendric_unit | /r/RelatedTo | fn:temporal_collocation | "calendric unit" | "temporal collocation" | "/r/related to" |  | "FN" |  |
| fn:relative_time | /r/SimilarTo | fn:temporal_collocation | "relative time" | "temporal collocation" | "/r/similar to" |  | "FN" |  |
| fn:time_vector | /r/SimilarTo | fn:temporal_collocation | "time vector" | "temporal collocation" | "/r/similar to" |  | "FN" |  |
| fn:temporal_collocation | /r/IsA | fn:simultaneity | "temporal collocation" | "simultaneity" | "/r/is a" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:in | "temporal collocation" | "in" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:on | "temporal collocation" | "on" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:at | "temporal collocation" | "at" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:now | "temporal collocation" | "now" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:current | "temporal collocation" | "current" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:currently | "temporal collocation" | "currently" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:then | "temporal collocation" | "then" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:when | "temporal collocation" | "when" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:modern | "temporal collocation" | "modern" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:nowadays | "temporal collocation" | "nowadays" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:today | "temporal collocation" | "today" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:ultimately | "temporal collocation" | "ultimately" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:no_longer | "temporal collocation" | "no longer" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:within | "temporal collocation" | "within" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:future | "temporal collocation" | "future" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:recently | "temporal collocation" | "recently" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:ancient | "temporal collocation" | "ancient" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:prehistoric | "temporal collocation" | "prehistoric" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:at_the_time | "temporal collocation" | "at the time" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:at_present | "temporal collocation" | "at present" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:during | "temporal collocation" | "during" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:early | "temporal collocation" | "early" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:newly | "temporal collocation" | "newly" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:around | "temporal collocation" | "around" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:as | "temporal collocation" | "as" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:of_late | "temporal collocation" | "of late" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:lately | "temporal collocation" | "lately" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:as_of_late | "temporal collocation" | "as of late" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:while | "temporal collocation" | "while" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:overnight | "temporal collocation" | "overnight" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:back_then | "temporal collocation" | "back then" | "has lexical unit" |  | "FN" |  |
| fn:temporal_collocation | fn:HasLexicalUnit | fn:lu:temporal_collocation:over | "temporal collocation" | "over" | "has lexical unit" |  | "FN" |  |
| fn:fe:trajector_entity | /r/RelatedTo | fn:fe:trajector_event | "trajector entity" | "trajector event" | "/r/related to" |  | "FN" |  |
| fn:temporal_collocation | /r/HasA | fn:fe:trajector_entity | "temporal collocation" | "trajector entity" | "/r/has a" |  | "FN" |  |
| fn:fe:landmark_event | /r/RelatedTo | fn:fe:landmark_period | "landmark event" | "landmark period" | "/r/related to" |  | "FN" |  |
| fn:temporal_collocation | /r/HasA | fn:fe:landmark_event | "temporal collocation" | "landmark event" | "/r/has a" |  | "FN" |  |
| fn:temporal_collocation | /r/HasA | fn:fe:event_description | "temporal collocation" | "event description" | "/r/has a" |  | "FN" |  |
| fn:fe:trajector_period | /r/RelatedTo | fn:fe:trajector_event | "trajector period" | "trajector event" | "/r/related to" |  | "FN" |  |
| fn:temporal_collocation | /r/HasA | fn:fe:trajector_period | "temporal collocation" | "trajector period" | "/r/has a" |  | "FN" |  |
| fn:fe:landmark_period | /r/RelatedTo | fn:fe:landmark_event | "landmark period" | "landmark event" | "/r/related to" |  | "FN" |  |
| fn:temporal_collocation | /r/HasA | fn:fe:landmark_period | "temporal collocation" | "landmark period" | "/r/has a" |  | "FN" |  |
| fn:fe:trajector_event | /r/RelatedTo | fn:fe:trajector_period | "trajector event" | "trajector period" | "/r/related to" |  | "FN" |  |
| fn:temporal_collocation | /r/HasA | fn:fe:trajector_event | "temporal collocation" | "trajector event" | "/r/has a" |  | "FN" |  |
| fn:fe:landmark_entity | /r/RelatedTo | fn:fe:landmark_event | "landmark entity" | "landmark event" | "/r/related to" |  | "FN" |  |
| fn:temporal_collocation | /r/HasA | fn:fe:landmark_entity | "temporal collocation" | "landmark entity" | "/r/has a" |  | "FN" |  |
| fn:event | /r/UsedFor | fn:temporal_pattern | "event" | "temporal pattern" | "/r/used for" |  | "FN" |  |
| fn:process | /r/UsedFor | fn:temporal_pattern | "process" | "temporal pattern" | "/r/used for" |  | "FN" |  |
| fn:temporal_pattern | fn:HasLexicalUnit | fn:lu:temporal_pattern:rhythm | "temporal pattern" | "rhythm" | "has lexical unit" |  | "FN" |  |
| fn:temporal_pattern | fn:HasLexicalUnit | fn:lu:temporal_pattern:rhythmically | "temporal pattern" | "rhythmically" | "has lexical unit" |  | "FN" |  |
| fn:temporal_pattern | fn:HasLexicalUnit | fn:lu:temporal_pattern:beat | "temporal pattern" | "beat" | "has lexical unit" |  | "FN" |  |
| fn:temporal_pattern | fn:HasLexicalUnit | fn:lu:temporal_pattern:rhythmic | "temporal pattern" | "rhythmic" | "has lexical unit" |  | "FN" |  |
| fn:temporal_pattern | fn:HasLexicalUnit | fn:lu:temporal_pattern:time | "temporal pattern" | "time" | "has lexical unit" |  | "FN" |  |
| fn:temporal_pattern | /r/HasA | fn:fe:process | "temporal pattern" | "process" | "/r/has a" |  | "FN" |  |
| fn:temporal_pattern | /r/HasA | fn:fe:subevent | "temporal pattern" | "subevent" | "/r/has a" |  | "FN" |  |
| fn:temporal_pattern | /r/HasA | fn:fe:descriptor | "temporal pattern" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:temporal_pattern | /r/HasA | fn:fe:pattern | "temporal pattern" | "pattern" | "/r/has a" |  | "FN" |  |
| fn:temporal_pattern | /r/HasA | fn:fe:type | "temporal pattern" | "type" | "/r/has a" |  | "FN" |  |
| fn:part_orientational | /r/UsedFor | fn:temporal_subregion | "part orientational" | "temporal subregion" | "/r/used for" |  | "FN" |  |
| fn:temporal_subregion | fn:HasLexicalUnit | fn:lu:temporal_subregion:late | "temporal subregion" | "late" | "has lexical unit" |  | "FN" |  |
| fn:temporal_subregion | fn:HasLexicalUnit | fn:lu:temporal_subregion:later | "temporal subregion" | "later" | "has lexical unit" |  | "FN" |  |
| fn:temporal_subregion | fn:HasLexicalUnit | fn:lu:temporal_subregion:middle | "temporal subregion" | "middle" | "has lexical unit" |  | "FN" |  |
| fn:temporal_subregion | fn:HasLexicalUnit | fn:lu:temporal_subregion:middle | "temporal subregion" | "middle" | "has lexical unit" |  | "FN" |  |
| fn:temporal_subregion | fn:HasLexicalUnit | fn:lu:temporal_subregion:early | "temporal subregion" | "early" | "has lexical unit" |  | "FN" |  |
| fn:temporal_subregion | fn:HasLexicalUnit | fn:lu:temporal_subregion:earlier | "temporal subregion" | "earlier" | "has lexical unit" |  | "FN" |  |
| fn:temporal_subregion | fn:HasLexicalUnit | fn:lu:temporal_subregion:mid | "temporal subregion" | "mid" | "has lexical unit" |  | "FN" |  |
| fn:temporal_subregion | fn:HasLexicalUnit | fn:lu:temporal_subregion:end | "temporal subregion" | "end" | "has lexical unit" |  | "FN" |  |
| fn:temporal_subregion | fn:HasLexicalUnit | fn:lu:temporal_subregion:beginning | "temporal subregion" | "beginning" | "has lexical unit" |  | "FN" |  |
| fn:temporal_subregion | fn:HasLexicalUnit | fn:lu:temporal_subregion:outset | "temporal subregion" | "outset" | "has lexical unit" |  | "FN" |  |
| fn:temporal_subregion | fn:HasLexicalUnit | fn:lu:temporal_subregion:start | "temporal subregion" | "start" | "has lexical unit" |  | "FN" |  |
| fn:temporal_subregion | fn:HasLexicalUnit | fn:lu:temporal_subregion:dawning | "temporal subregion" | "dawning" | "has lexical unit" |  | "FN" |  |
| fn:temporal_subregion | fn:HasLexicalUnit | fn:lu:temporal_subregion:turn | "temporal subregion" | "turn" | "has lexical unit" |  | "FN" |  |
| fn:temporal_subregion | /r/HasA | fn:fe:subpart | "temporal subregion" | "subpart" | "/r/has a" |  | "FN" |  |
| fn:temporal_subregion | /r/HasA | fn:fe:subpart_property | "temporal subregion" | "subpart property" | "/r/has a" |  | "FN" |  |
| fn:temporal_subregion | /r/HasA | fn:fe:time_period | "temporal subregion" | "time period" | "/r/has a" |  | "FN" |  |
| fn:temporal_subregion | /r/HasA | fn:fe:time | "temporal subregion" | "time" | "/r/has a" |  | "FN" |  |
| fn:temporal_subregion | /r/HasA | fn:fe:degree | "temporal subregion" | "degree" | "/r/has a" |  | "FN" |  |
| fn:temporary_group | /r/IsA | fn:organization | "temporary group" | "organization" | "/r/is a" |  | "FN" |  |
| fn:temporary_group | /r/IsA | fn:part_whole | "temporary group" | "part whole" | "/r/is a" |  | "FN" |  |
| fn:temporary_group | fn:HasLexicalUnit | fn:lu:temporary_group:detachment | "temporary group" | "detachment" | "has lexical unit" |  | "FN" |  |
| fn:temporary_group | fn:HasLexicalUnit | fn:lu:temporary_group:detail | "temporary group" | "detail" | "has lexical unit" |  | "FN" |  |
| fn:fe:temporary_group | /r/IsA | fn:st:group | "temporary group" | "group" | "/r/is a" |  | "FN" |  |
| fn:temporary_group | /r/HasA | fn:fe:temporary_group | "temporary group" | "temporary group" | "/r/has a" |  | "FN" |  |
| fn:temporary_group | /r/HasA | fn:fe:members | "temporary group" | "members" | "/r/has a" |  | "FN" |  |
| fn:temporary_group | /r/HasA | fn:fe:purpose | "temporary group" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:temporary_group | /r/HasA | fn:fe:period_of_existence | "temporary group" | "period of existence" | "/r/has a" |  | "FN" |  |
| fn:temporary_group | /r/HasA | fn:fe:name | "temporary group" | "name" | "/r/has a" |  | "FN" |  |
| fn:temporary_group | /r/HasA | fn:fe:container_possessor | "temporary group" | "container possessor" | "/r/has a" |  | "FN" |  |
| fn:temporary_group | /r/HasA | fn:fe:place | "temporary group" | "place" | "/r/has a" |  | "FN" |  |
| fn:temporary_group | /r/HasA | fn:fe:descriptor | "temporary group" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:temporary_group | /r/HasA | fn:fe:parent_organization | "temporary group" | "parent organization" | "/r/has a" |  | "FN" |  |
| fn:temporary_leave | /r/IsA | fn:expected_location_of_person | "temporary leave" | "expected location of person" | "/r/is a" |  | "FN" |  |
| fn:being_obligated | /r/UsedFor | fn:temporary_leave | "being obligated" | "temporary leave" | "/r/used for" |  | "FN" |  |
| fn:temporary_leave | fn:HasLexicalUnit | fn:lu:temporary_leave:absence | "temporary leave" | "absence" | "has lexical unit" |  | "FN" |  |
| fn:temporary_leave | fn:HasLexicalUnit | fn:lu:temporary_leave:leave | "temporary leave" | "leave" | "has lexical unit" |  | "FN" |  |
| fn:temporary_leave | fn:HasLexicalUnit | fn:lu:temporary_leave:sabbatical | "temporary leave" | "sabbatical" | "has lexical unit" |  | "FN" |  |
| fn:temporary_leave | fn:HasLexicalUnit | fn:lu:temporary_leave:leave_of_absence | "temporary leave" | "leave of absence" | "has lexical unit" |  | "FN" |  |
| fn:temporary_leave | fn:HasLexicalUnit | fn:lu:temporary_leave:vacation | "temporary leave" | "vacation" | "has lexical unit" |  | "FN" |  |
| fn:temporary_leave | fn:HasLexicalUnit | fn:lu:temporary_leave:holiday | "temporary leave" | "holiday" | "has lexical unit" |  | "FN" |  |
| fn:temporary_leave | fn:HasLexicalUnit | fn:lu:temporary_leave:furlough | "temporary leave" | "furlough" | "has lexical unit" |  | "FN" |  |
| fn:temporary_leave | fn:HasLexicalUnit | fn:lu:temporary_leave:time_off | "temporary leave" | "time off" | "has lexical unit" |  | "FN" |  |
| fn:temporary_leave | fn:HasLexicalUnit | fn:lu:temporary_leave:pto | "temporary leave" | "pto" | "has lexical unit" |  | "FN" |  |
| fn:temporary_leave | fn:HasLexicalUnit | fn:lu:temporary_leave:absent | "temporary leave" | "absent" | "has lexical unit" |  | "FN" |  |
| fn:fe:person | /r/IsA | fn:st:sentient | "person" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:temporary_leave | /r/HasA | fn:fe:person | "temporary leave" | "person" | "/r/has a" |  | "FN" |  |
| fn:temporary_leave | /r/HasA | fn:fe:activity | "temporary leave" | "activity" | "/r/has a" |  | "FN" |  |
| fn:temporary_leave | /r/HasA | fn:fe:duration | "temporary leave" | "duration" | "/r/has a" |  | "FN" |  |
| fn:temporary_leave | /r/HasA | fn:fe:location | "temporary leave" | "location" | "/r/has a" |  | "FN" |  |
| fn:temporary_leave | /r/HasA | fn:fe:type | "temporary leave" | "type" | "/r/has a" |  | "FN" |  |
| fn:temporary_leave | /r/HasA | fn:fe:depictive | "temporary leave" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:temporary_leave | /r/HasA | fn:fe:frequency | "temporary leave" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:temporary_leave | /r/HasA | fn:fe:explanation | "temporary leave" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:temporary_leave | /r/HasA | fn:fe:purpose | "temporary leave" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:temporary_leave | /r/HasA | fn:fe:time | "temporary leave" | "time" | "/r/has a" |  | "FN" |  |
| fn:temporary_stay | /r/IsA | fn:residence | "temporary stay" | "residence" | "/r/is a" |  | "FN" |  |
| fn:temporary_stay | /r/IsA | fn:visiting | "temporary stay" | "visiting" | "/r/is a" |  | "FN" |  |
| fn:temporary_stay | /r/IsA | fn:lodging_scenario | "temporary stay" | "lodging scenario" | "/r/is a" |  | "FN" |  |
| fn:temporary_stay | fn:HasLexicalUnit | fn:lu:temporary_stay:stay | "temporary stay" | "stay" | "has lexical unit" |  | "FN" |  |
| fn:temporary_stay | fn:HasLexicalUnit | fn:lu:temporary_stay:stay | "temporary stay" | "stay" | "has lexical unit" |  | "FN" |  |
| fn:temporary_stay | fn:HasLexicalUnit | fn:lu:temporary_stay:lodge | "temporary stay" | "lodge" | "has lexical unit" |  | "FN" |  |
| fn:temporary_stay | fn:HasLexicalUnit | fn:lu:temporary_stay:room | "temporary stay" | "room" | "has lexical unit" |  | "FN" |  |
| fn:temporary_stay | fn:HasLexicalUnit | fn:lu:temporary_stay:guest | "temporary stay" | "guest" | "has lexical unit" |  | "FN" |  |
| fn:temporary_stay | fn:HasLexicalUnit | fn:lu:temporary_stay:overnight | "temporary stay" | "overnight" | "has lexical unit" |  | "FN" |  |
| fn:temporary_stay | fn:HasLexicalUnit | fn:lu:temporary_stay:sleep_over | "temporary stay" | "sleep over" | "has lexical unit" |  | "FN" |  |
| fn:temporary_stay | fn:HasLexicalUnit | fn:lu:temporary_stay:stay_over | "temporary stay" | "stay over" | "has lexical unit" |  | "FN" |  |
| fn:temporary_stay | fn:HasLexicalUnit | fn:lu:temporary_stay:board | "temporary stay" | "board" | "has lexical unit" |  | "FN" |  |
| fn:temporary_stay | fn:HasLexicalUnit | fn:lu:temporary_stay:quarter | "temporary stay" | "quarter" | "has lexical unit" |  | "FN" |  |
| fn:temporary_stay | /r/HasA | fn:fe:guest | "temporary stay" | "guest" | "/r/has a" |  | "FN" |  |
| fn:temporary_stay | /r/HasA | fn:fe:location | "temporary stay" | "location" | "/r/has a" |  | "FN" |  |
| fn:temporary_stay | /r/HasA | fn:fe:duration | "temporary stay" | "duration" | "/r/has a" |  | "FN" |  |
| fn:temporary_stay | /r/HasA | fn:fe:co-participant | "temporary stay" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:temporary_stay | /r/HasA | fn:fe:time | "temporary stay" | "time" | "/r/has a" |  | "FN" |  |
| fn:temporary_stay | /r/HasA | fn:fe:host | "temporary stay" | "host" | "/r/has a" |  | "FN" |  |
| fn:temporary_stay | /r/HasA | fn:fe:purpose | "temporary stay" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:temporary_stay | /r/HasA | fn:fe:means | "temporary stay" | "means" | "/r/has a" |  | "FN" |  |
| fn:temporary_stay | /r/HasA | fn:fe:manner | "temporary stay" | "manner" | "/r/has a" |  | "FN" |  |
| fn:temporary_stay | /r/HasA | fn:fe:frequency | "temporary stay" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:temporary_stay | /r/HasA | fn:fe:iterations | "temporary stay" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:temporary_stay | /r/HasA | fn:fe:descriptor | "temporary stay" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:temporary_stay | /r/HasA | fn:fe:place | "temporary stay" | "place" | "/r/has a" |  | "FN" |  |
| fn:temporary_stay | /r/HasA | fn:fe:explanation | "temporary stay" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:temporary_stay | /r/HasA | fn:fe:containing_event | "temporary stay" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:temporary_transfer_scenario | /r/IsA | fn:transfer_scenario | "temporary transfer scenario" | "transfer scenario" | "/r/is a" |  | "FN" |  |
| fn:borrowing | /r/IsA | fn:temporary_transfer_scenario | "borrowing" | "temporary transfer scenario" | "/r/is a" |  | "FN" |  |
| fn:lending | /r/IsA | fn:temporary_transfer_scenario | "lending" | "temporary transfer scenario" | "/r/is a" |  | "FN" |  |
| fn:temporary_transfer_scenario | /r/HasA | fn:fe:theme | "temporary transfer scenario" | "theme" | "/r/has a" |  | "FN" |  |
| fn:temporary_transfer_scenario | /r/HasA | fn:fe:lender | "temporary transfer scenario" | "lender" | "/r/has a" |  | "FN" |  |
| fn:temporary_transfer_scenario | /r/HasA | fn:fe:borrower | "temporary transfer scenario" | "borrower" | "/r/has a" |  | "FN" |  |
| fn:temporary_transfer_scenario | /r/HasA | fn:fe:duration | "temporary transfer scenario" | "duration" | "/r/has a" |  | "FN" |  |
| fn:documents | /r/UsedFor | fn:terms_of_agreement | "documents" | "terms of agreement" | "/r/used for" |  | "FN" |  |
| fn:terms_of_agreement | fn:HasLexicalUnit | fn:lu:terms_of_agreement:condition | "terms of agreement" | "condition" | "has lexical unit" |  | "FN" |  |
| fn:terms_of_agreement | fn:HasLexicalUnit | fn:lu:terms_of_agreement:stipulation | "terms of agreement" | "stipulation" | "has lexical unit" |  | "FN" |  |
| fn:terms_of_agreement | fn:HasLexicalUnit | fn:lu:terms_of_agreement:provision | "terms of agreement" | "provision" | "has lexical unit" |  | "FN" |  |
| fn:terms_of_agreement | fn:HasLexicalUnit | fn:lu:terms_of_agreement:clause | "terms of agreement" | "clause" | "has lexical unit" |  | "FN" |  |
| fn:terms_of_agreement | fn:HasLexicalUnit | fn:lu:terms_of_agreement:term | "terms of agreement" | "term" | "has lexical unit" |  | "FN" |  |
| fn:terms_of_agreement | fn:HasLexicalUnit | fn:lu:terms_of_agreement:parameter | "terms of agreement" | "parameter" | "has lexical unit" |  | "FN" |  |
| fn:terms_of_agreement | /r/HasA | fn:fe:agreement | "terms of agreement" | "agreement" | "/r/has a" |  | "FN" |  |
| fn:terms_of_agreement | /r/HasA | fn:fe:regulated_entity | "terms of agreement" | "regulated entity" | "/r/has a" |  | "FN" |  |
| fn:terms_of_agreement | /r/HasA | fn:fe:requirements | "terms of agreement" | "requirements" | "/r/has a" |  | "FN" |  |
| fn:terms_of_agreement | /r/HasA | fn:fe:desired_state_of_affairs | "terms of agreement" | "desired state of affairs" | "/r/has a" |  | "FN" |  |
| fn:terms_of_agreement | /r/HasA | fn:fe:party | "terms of agreement" | "party" | "/r/has a" |  | "FN" |  |
| fn:terms_of_agreement | /r/HasA | fn:fe:descriptor | "terms of agreement" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:cause_harm | /r/UsedFor | fn:terrorism | "cause harm" | "terrorism" | "/r/used for" |  | "FN" |  |
| fn:terrorism | fn:HasLexicalUnit | fn:lu:terrorism:terrorism | "terrorism" | "terrorism" | "has lexical unit" |  | "FN" |  |
| fn:terrorism | fn:HasLexicalUnit | fn:lu:terrorism:terrorist | "terrorism" | "terrorist" | "has lexical unit" |  | "FN" |  |
| fn:terrorism | fn:HasLexicalUnit | fn:lu:terrorism:ecoterrorism | "terrorism" | "ecoterrorism" | "has lexical unit" |  | "FN" |  |
| fn:terrorism | fn:HasLexicalUnit | fn:lu:terrorism:ecoterrorist | "terrorism" | "ecoterrorist" | "has lexical unit" |  | "FN" |  |
| fn:terrorism | fn:HasLexicalUnit | fn:lu:terrorism:bioterrorism | "terrorism" | "bioterrorism" | "has lexical unit" |  | "FN" |  |
| fn:terrorism | fn:HasLexicalUnit | fn:lu:terrorism:bioterrorist | "terrorism" | "bioterrorist" | "has lexical unit" |  | "FN" |  |
| fn:terrorism | fn:HasLexicalUnit | fn:lu:terrorism:ecoterrorist_[environmentalist] | "terrorism" | "ecoterrorist [environmentalist]" | "has lexical unit" |  | "FN" |  |
| fn:terrorism | fn:HasLexicalUnit | fn:lu:terrorism:ecoterrorism_[environmentalism] | "terrorism" | "ecoterrorism [environmentalism]" | "has lexical unit" |  | "FN" |  |
| fn:terrorism | fn:HasLexicalUnit | fn:lu:terrorism:terror | "terrorism" | "terror" | "has lexical unit" |  | "FN" |  |
| fn:terrorism | /r/HasA | fn:fe:terrorist | "terrorism" | "terrorist" | "/r/has a" |  | "FN" |  |
| fn:terrorism | /r/HasA | fn:fe:act | "terrorism" | "act" | "/r/has a" |  | "FN" |  |
| fn:terrorism | /r/HasA | fn:fe:victim | "terrorism" | "victim" | "/r/has a" |  | "FN" |  |
| fn:terrorism | /r/HasA | fn:fe:organization | "terrorism" | "organization" | "/r/has a" |  | "FN" |  |
| fn:terrorism | /r/HasA | fn:fe:descriptor | "terrorism" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:terrorism | /r/HasA | fn:fe:manner | "terrorism" | "manner" | "/r/has a" |  | "FN" |  |
| fn:terrorism | /r/HasA | fn:fe:means | "terrorism" | "means" | "/r/has a" |  | "FN" |  |
| fn:terrorism | /r/HasA | fn:fe:time | "terrorism" | "time" | "/r/has a" |  | "FN" |  |
| fn:terrorism | /r/HasA | fn:fe:place | "terrorism" | "place" | "/r/has a" |  | "FN" |  |
| fn:terrorism | /r/HasA | fn:fe:purpose | "terrorism" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:terrorism | /r/HasA | fn:fe:instrument | "terrorism" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:text | /r/IsA | fn:artifact | "text" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:documents | /r/IsA | fn:text | "documents" | "text" | "/r/is a" |  | "FN" |  |
| fn:records | /r/IsA | fn:text | "records" | "text" | "/r/is a" |  | "FN" |  |
| fn:text | /r/UsedFor | fn:law | "text" | "law" | "/r/used for" |  | "FN" |  |
| fn:text | /r/UsedFor | fn:medium | "text" | "medium" | "/r/used for" |  | "FN" |  |
| fn:text | /r/UsedFor | fn:reference_text | "text" | "reference text" | "/r/used for" |  | "FN" |  |
| fn:text | /r/UsedFor | fn:topic | "text" | "topic" | "/r/used for" |  | "FN" |  |
| fn:text_creation | /r/UsedFor | fn:text | "text creation" | "text" | "/r/used for" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:tome | "text" | "tome" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:fanzine | "text" | "fanzine" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:epilogue | "text" | "epilogue" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:benediction | "text" | "benediction" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:imprecation | "text" | "imprecation" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:eulogy | "text" | "eulogy" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:autobiography | "text" | "autobiography" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:ballad | "text" | "ballad" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:biography | "text" | "biography" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:chronicle | "text" | "chronicle" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:comedy | "text" | "comedy" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:diary | "text" | "diary" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:drama | "text" | "drama" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:elegy | "text" | "elegy" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:epic | "text" | "epic" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:epigram | "text" | "epigram" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:epistle | "text" | "epistle" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:essay | "text" | "essay" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:exemplum | "text" | "exemplum" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:fable | "text" | "fable" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:festschrift | "text" | "festschrift" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:haiku | "text" | "haiku" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:letter | "text" | "letter" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:limerick | "text" | "limerick" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:lyric | "text" | "lyric" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:memoir | "text" | "memoir" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:monograph | "text" | "monograph" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:mystery | "text" | "mystery" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:novel | "text" | "novel" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:novelette | "text" | "novelette" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:novella | "text" | "novella" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:ode | "text" | "ode" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:poetry | "text" | "poetry" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:poem | "text" | "poem" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:rhyme | "text" | "rhyme" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:saga | "text" | "saga" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:song | "text" | "song" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:sonnet | "text" | "sonnet" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:speech | "text" | "speech" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:tetralogy | "text" | "tetralogy" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:thriller | "text" | "thriller" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:tragedy | "text" | "tragedy" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:trilogy | "text" | "trilogy" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:whodunit | "text" | "whodunit" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:manual | "text" | "manual" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:handbook | "text" | "handbook" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:paperback | "text" | "paperback" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:hardback | "text" | "hardback" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:grimoire | "text" | "grimoire" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:spellbook | "text" | "spellbook" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:lay | "text" | "lay" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:book | "text" | "book" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:magazine | "text" | "magazine" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:account | "text" | "account" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:sermon | "text" | "sermon" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:tract | "text" | "tract" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:screenplay | "text" | "screenplay" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:script | "text" | "script" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:article | "text" | "article" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:obituary | "text" | "obituary" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:volume | "text" | "volume" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:mag | "text" | "mag" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:edition | "text" | "edition" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:treatise | "text" | "treatise" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:report | "text" | "report" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:bulletin | "text" | "bulletin" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:tractate | "text" | "tractate" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:hagiography | "text" | "hagiography" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:journal | "text" | "journal" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:periodical | "text" | "periodical" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:editorial | "text" | "editorial" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:meditation | "text" | "meditation" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:booklet | "text" | "booklet" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:fiction | "text" | "fiction" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:writings | "text" | "writings" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:missive | "text" | "missive" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:newspaper | "text" | "newspaper" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:list | "text" | "list" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:manuscript | "text" | "manuscript" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:literature | "text" | "literature" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:history | "text" | "history" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:brochure | "text" | "brochure" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:material | "text" | "material" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:pamphlet | "text" | "pamphlet" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:issue | "text" | "issue" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:paper_[newspaper] | "text" | "paper [newspaper]" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:paper_[article] | "text" | "paper [article]" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:epic | "text" | "epic" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:publication | "text" | "publication" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:life | "text" | "life" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:record | "text" | "record" | "has lexical unit" |  | "FN" |  |
| fn:text | fn:HasLexicalUnit | fn:lu:text:textbook | "text" | "textbook" | "has lexical unit" |  | "FN" |  |
| fn:text | /r/HasA | fn:fe:author | "text" | "author" | "/r/has a" |  | "FN" |  |
| fn:text | /r/HasA | fn:fe:text | "text" | "text" | "/r/has a" |  | "FN" |  |
| fn:text | /r/HasA | fn:fe:beneficiary | "text" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:text | /r/HasA | fn:fe:time_of_creation | "text" | "time of creation" | "/r/has a" |  | "FN" |  |
| fn:text | /r/HasA | fn:fe:material | "text" | "material" | "/r/has a" |  | "FN" |  |
| fn:text | /r/HasA | fn:fe:containing_text | "text" | "containing text" | "/r/has a" |  | "FN" |  |
| fn:text | /r/HasA | fn:fe:genre | "text" | "genre" | "/r/has a" |  | "FN" |  |
| fn:text | /r/HasA | fn:fe:use | "text" | "use" | "/r/has a" |  | "FN" |  |
| fn:text | /r/HasA | fn:fe:subpart | "text" | "subpart" | "/r/has a" |  | "FN" |  |
| fn:text | /r/HasA | fn:fe:topic | "text" | "topic" | "/r/has a" |  | "FN" |  |
| fn:text | /r/HasA | fn:fe:title | "text" | "title" | "/r/has a" |  | "FN" |  |
| fn:text | /r/HasA | fn:fe:medium | "text" | "medium" | "/r/has a" |  | "FN" |  |
| fn:text | /r/HasA | fn:fe:place | "text" | "place" | "/r/has a" |  | "FN" |  |
| fn:text | /r/HasA | fn:fe:descriptor | "text" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:text_creation | /r/IsA | fn:intentionally_create | "text creation" | "intentionally create" | "/r/is a" |  | "FN" |  |
| fn:sign_agreement | /r/IsA | fn:text_creation | "sign agreement" | "text creation" | "/r/is a" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:text_creation | "communication" | "text creation" | "/r/used for" |  | "FN" |  |
| fn:text_creation | /r/UsedFor | fn:spelling_and_pronouncing | "text creation" | "spelling and pronouncing" | "/r/used for" |  | "FN" |  |
| fn:text_creation | /r/UsedFor | fn:text | "text creation" | "text" | "/r/used for" |  | "FN" |  |
| fn:text_creation | fn:HasLexicalUnit | fn:lu:text_creation:pen | "text creation" | "pen" | "has lexical unit" |  | "FN" |  |
| fn:text_creation | fn:HasLexicalUnit | fn:lu:text_creation:author | "text creation" | "author" | "has lexical unit" |  | "FN" |  |
| fn:text_creation | fn:HasLexicalUnit | fn:lu:text_creation:write | "text creation" | "write" | "has lexical unit" |  | "FN" |  |
| fn:text_creation | fn:HasLexicalUnit | fn:lu:text_creation:compose | "text creation" | "compose" | "has lexical unit" |  | "FN" |  |
| fn:text_creation | fn:HasLexicalUnit | fn:lu:text_creation:draft | "text creation" | "draft" | "has lexical unit" |  | "FN" |  |
| fn:text_creation | fn:HasLexicalUnit | fn:lu:text_creation:jot_down | "text creation" | "jot down" | "has lexical unit" |  | "FN" |  |
| fn:text_creation | fn:HasLexicalUnit | fn:lu:text_creation:jot | "text creation" | "jot" | "has lexical unit" |  | "FN" |  |
| fn:text_creation | fn:HasLexicalUnit | fn:lu:text_creation:speak | "text creation" | "speak" | "has lexical unit" |  | "FN" |  |
| fn:text_creation | fn:HasLexicalUnit | fn:lu:text_creation:say | "text creation" | "say" | "has lexical unit" |  | "FN" |  |
| fn:text_creation | fn:HasLexicalUnit | fn:lu:text_creation:utter | "text creation" | "utter" | "has lexical unit" |  | "FN" |  |
| fn:text_creation | fn:HasLexicalUnit | fn:lu:text_creation:write_up | "text creation" | "write up" | "has lexical unit" |  | "FN" |  |
| fn:text_creation | fn:HasLexicalUnit | fn:lu:text_creation:write_down | "text creation" | "write down" | "has lexical unit" |  | "FN" |  |
| fn:text_creation | fn:HasLexicalUnit | fn:lu:text_creation:write_in | "text creation" | "write in" | "has lexical unit" |  | "FN" |  |
| fn:text_creation | fn:HasLexicalUnit | fn:lu:text_creation:write_out | "text creation" | "write out" | "has lexical unit" |  | "FN" |  |
| fn:text_creation | fn:HasLexicalUnit | fn:lu:text_creation:print | "text creation" | "print" | "has lexical unit" |  | "FN" |  |
| fn:text_creation | fn:HasLexicalUnit | fn:lu:text_creation:type | "text creation" | "type" | "has lexical unit" |  | "FN" |  |
| fn:text_creation | fn:HasLexicalUnit | fn:lu:text_creation:type_out | "text creation" | "type out" | "has lexical unit" |  | "FN" |  |
| fn:text_creation | fn:HasLexicalUnit | fn:lu:text_creation:type_up | "text creation" | "type up" | "has lexical unit" |  | "FN" |  |
| fn:text_creation | fn:HasLexicalUnit | fn:lu:text_creation:type_in | "text creation" | "type in" | "has lexical unit" |  | "FN" |  |
| fn:text_creation | fn:HasLexicalUnit | fn:lu:text_creation:print_out | "text creation" | "print out" | "has lexical unit" |  | "FN" |  |
| fn:text_creation | fn:HasLexicalUnit | fn:lu:text_creation:print_up | "text creation" | "print up" | "has lexical unit" |  | "FN" |  |
| fn:text_creation | fn:HasLexicalUnit | fn:lu:text_creation:get_down | "text creation" | "get down" | "has lexical unit" |  | "FN" |  |
| fn:text_creation | fn:HasLexicalUnit | fn:lu:text_creation:chronicle | "text creation" | "chronicle" | "has lexical unit" |  | "FN" |  |
| fn:text_creation | fn:HasLexicalUnit | fn:lu:text_creation:sign | "text creation" | "sign" | "has lexical unit" |  | "FN" |  |
| fn:text_creation | fn:HasLexicalUnit | fn:lu:text_creation:dash_off | "text creation" | "dash off" | "has lexical unit" |  | "FN" |  |
| fn:text_creation | fn:HasLexicalUnit | fn:lu:text_creation:list | "text creation" | "list" | "has lexical unit" |  | "FN" |  |
| fn:fe:author | /r/IsA | fn:st:sentient | "author" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:text_creation | /r/HasA | fn:fe:author | "text creation" | "author" | "/r/has a" |  | "FN" |  |
| fn:text_creation | /r/HasA | fn:fe:components | "text creation" | "components" | "/r/has a" |  | "FN" |  |
| fn:text_creation | /r/HasA | fn:fe:text | "text creation" | "text" | "/r/has a" |  | "FN" |  |
| fn:text_creation | /r/HasA | fn:fe:depictive | "text creation" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:text_creation | /r/HasA | fn:fe:instrument | "text creation" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:text_creation | /r/HasA | fn:fe:place | "text creation" | "place" | "/r/has a" |  | "FN" |  |
| fn:text_creation | /r/HasA | fn:fe:manner | "text creation" | "manner" | "/r/has a" |  | "FN" |  |
| fn:text_creation | /r/HasA | fn:fe:means | "text creation" | "means" | "/r/has a" |  | "FN" |  |
| fn:text_creation | /r/HasA | fn:fe:purpose | "text creation" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:text_creation | /r/HasA | fn:fe:time | "text creation" | "time" | "/r/has a" |  | "FN" |  |
| fn:text_creation | /r/HasA | fn:fe:addressee | "text creation" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:text_creation | /r/HasA | fn:fe:beneficiary | "text creation" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:text_creation | /r/HasA | fn:fe:form | "text creation" | "form" | "/r/has a" |  | "FN" |  |
| fn:text_creation | /r/HasA | fn:fe:explanation | "text creation" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:text_creation | /r/HasA | fn:fe:medium | "text creation" | "medium" | "/r/has a" |  | "FN" |  |
| fn:theft | /r/IsA | fn:committing_crime | "theft" | "committing crime" | "/r/is a" |  | "FN" |  |
| fn:theft | /r/IsA | fn:taking | "theft" | "taking" | "/r/is a" |  | "FN" |  |
| fn:theft | /r/UsedFor | fn:robbery | "theft" | "robbery" | "/r/used for" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:steal | "theft" | "steal" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:purloin | "theft" | "purloin" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:filch | "theft" | "filch" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:snitch | "theft" | "snitch" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:pilfer | "theft" | "pilfer" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:swipe | "theft" | "swipe" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:lift | "theft" | "lift" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:pinch | "theft" | "pinch" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:thieve | "theft" | "thieve" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:thief | "theft" | "thief" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:pickpocket | "theft" | "pickpocket" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:cutpurse | "theft" | "cutpurse" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:pilferer | "theft" | "pilferer" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:snatcher | "theft" | "snatcher" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:theft | "theft" | "theft" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:thieving | "theft" | "thieving" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:pilferage | "theft" | "pilferage" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:light-fingered | "theft" | "light-fingered" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:thieving | "theft" | "thieving" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:snatch | "theft" | "snatch" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:nick | "theft" | "nick" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:embezzle | "theft" | "embezzle" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:misappropriate | "theft" | "misappropriate" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:shoplift | "theft" | "shoplift" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:stealer | "theft" | "stealer" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:shoplifter | "theft" | "shoplifter" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:shoplifting | "theft" | "shoplifting" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:pilfering | "theft" | "pilfering" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:stolen | "theft" | "stolen" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:embezzlement | "theft" | "embezzlement" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:embezzler | "theft" | "embezzler" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:peculation | "theft" | "peculation" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:misappropriation | "theft" | "misappropriation" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:larceny | "theft" | "larceny" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:snatch | "theft" | "snatch" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:stealing | "theft" | "stealing" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:pickpocket | "theft" | "pickpocket" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:heist | "theft" | "heist" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:flog | "theft" | "flog" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:abstract | "theft" | "abstract" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:cop | "theft" | "cop" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:rustle | "theft" | "rustle" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:bag | "theft" | "bag" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:abstraction | "theft" | "abstraction" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:make_off_(with) | "theft" | "make off (with)" | "has lexical unit" |  | "FN" |  |
| fn:theft | fn:HasLexicalUnit | fn:lu:theft:abscond_(with) | "theft" | "abscond (with)" | "has lexical unit" |  | "FN" |  |
| fn:theft | /r/HasA | fn:fe:perpetrator | "theft" | "perpetrator" | "/r/has a" |  | "FN" |  |
| fn:theft | /r/HasA | fn:fe:victim | "theft" | "victim" | "/r/has a" |  | "FN" |  |
| fn:theft | /r/HasA | fn:fe:goods | "theft" | "goods" | "/r/has a" |  | "FN" |  |
| fn:theft | /r/HasA | fn:fe:source | "theft" | "source" | "/r/has a" |  | "FN" |  |
| fn:theft | /r/HasA | fn:fe:manner | "theft" | "manner" | "/r/has a" |  | "FN" |  |
| fn:theft | /r/HasA | fn:fe:means | "theft" | "means" | "/r/has a" |  | "FN" |  |
| fn:theft | /r/HasA | fn:fe:place | "theft" | "place" | "/r/has a" |  | "FN" |  |
| fn:theft | /r/HasA | fn:fe:purpose | "theft" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:theft | /r/HasA | fn:fe:explanation | "theft" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:theft | /r/HasA | fn:fe:time | "theft" | "time" | "/r/has a" |  | "FN" |  |
| fn:theft | /r/HasA | fn:fe:instrument | "theft" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:theft | /r/HasA | fn:fe:frequency | "theft" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:thermodynamic_phase | /r/UsedFor | fn:substance_by_phase | "thermodynamic phase" | "substance by phase" | "/r/used for" |  | "FN" |  |
| fn:thermodynamic_phase | fn:HasLexicalUnit | fn:lu:thermodynamic_phase:state | "thermodynamic phase" | "state" | "has lexical unit" |  | "FN" |  |
| fn:thermodynamic_phase | fn:HasLexicalUnit | fn:lu:thermodynamic_phase:phase | "thermodynamic phase" | "phase" | "has lexical unit" |  | "FN" |  |
| fn:thermodynamic_phase | /r/HasA | fn:fe:matter | "thermodynamic phase" | "matter" | "/r/has a" |  | "FN" |  |
| fn:thermodynamic_phase | /r/HasA | fn:fe:phase | "thermodynamic phase" | "phase" | "/r/has a" |  | "FN" |  |
| fn:thriving | /r/IsA | fn:state | "thriving" | "state" | "/r/is a" |  | "FN" |  |
| fn:desirability | /r/UsedFor | fn:thriving | "desirability" | "thriving" | "/r/used for" |  | "FN" |  |
| fn:thriving | fn:HasLexicalUnit | fn:lu:thriving:thrive | "thriving" | "thrive" | "has lexical unit" |  | "FN" |  |
| fn:thriving | fn:HasLexicalUnit | fn:lu:thriving:flourish | "thriving" | "flourish" | "has lexical unit" |  | "FN" |  |
| fn:thriving | fn:HasLexicalUnit | fn:lu:thriving:prosper | "thriving" | "prosper" | "has lexical unit" |  | "FN" |  |
| fn:thriving | fn:HasLexicalUnit | fn:lu:thriving:languish | "thriving" | "languish" | "has lexical unit" |  | "FN" |  |
| fn:thriving | fn:HasLexicalUnit | fn:lu:thriving:slump | "thriving" | "slump" | "has lexical unit" |  | "FN" |  |
| fn:thriving | fn:HasLexicalUnit | fn:lu:thriving:do | "thriving" | "do" | "has lexical unit" |  | "FN" |  |
| fn:thriving | fn:HasLexicalUnit | fn:lu:thriving:fare | "thriving" | "fare" | "has lexical unit" |  | "FN" |  |
| fn:thriving | fn:HasLexicalUnit | fn:lu:thriving:prosperity | "thriving" | "prosperity" | "has lexical unit" |  | "FN" |  |
| fn:thriving | fn:HasLexicalUnit | fn:lu:thriving:live | "thriving" | "live" | "has lexical unit" |  | "FN" |  |
| fn:thriving | /r/HasA | fn:fe:entity | "thriving" | "entity" | "/r/has a" |  | "FN" |  |
| fn:fe:circumstances | /r/IsA | fn:st:state_of_affairs | "circumstances" | "state of affairs" | "/r/is a" |  | "FN" |  |
| fn:thriving | /r/HasA | fn:fe:circumstances | "thriving" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:thriving | /r/HasA | fn:fe:time | "thriving" | "time" | "/r/has a" |  | "FN" |  |
| fn:thriving | /r/HasA | fn:fe:place | "thriving" | "place" | "/r/has a" |  | "FN" |  |
| fn:thriving | /r/HasA | fn:fe:frequency | "thriving" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:thriving | /r/HasA | fn:fe:role | "thriving" | "role" | "/r/has a" |  | "FN" |  |
| fn:thriving | /r/HasA | fn:fe:particular_iteration | "thriving" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:thriving | /r/HasA | fn:fe:duration | "thriving" | "duration" | "/r/has a" |  | "FN" |  |
| fn:thriving | /r/HasA | fn:fe:explanation | "thriving" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:thriving | /r/HasA | fn:fe:desirability | "thriving" | "desirability" | "/r/has a" |  | "FN" |  |
| fn:thwarting | /r/IsA | fn:preventing_or_letting | "thwarting" | "preventing or letting" | "/r/is a" |  | "FN" |  |
| fn:subversion | /r/IsA | fn:thwarting | "subversion" | "thwarting" | "/r/is a" |  | "FN" |  |
| fn:thwarting | /r/SimilarTo | fn:preventing_or_letting | "thwarting" | "preventing or letting" | "/r/similar to" |  | "FN" |  |
| fn:thwarting | /r/Causes | fn:success_or_failure | "thwarting" | "success or failure" | "/r/causes" |  | "FN" |  |
| fn:thwarting | /r/IsA | fn:result_of_attempt_scenario | "thwarting" | "result of attempt scenario" | "/r/is a" |  | "FN" |  |
| fn:thwarting | fn:HasLexicalUnit | fn:lu:thwarting:thwart | "thwarting" | "thwart" | "has lexical unit" |  | "FN" |  |
| fn:thwarting | fn:HasLexicalUnit | fn:lu:thwarting:foil | "thwarting" | "foil" | "has lexical unit" |  | "FN" |  |
| fn:thwarting | fn:HasLexicalUnit | fn:lu:thwarting:stymie | "thwarting" | "stymie" | "has lexical unit" |  | "FN" |  |
| fn:thwarting | fn:HasLexicalUnit | fn:lu:thwarting:hamstring | "thwarting" | "hamstring" | "has lexical unit" |  | "FN" |  |
| fn:thwarting | fn:HasLexicalUnit | fn:lu:thwarting:prevent | "thwarting" | "prevent" | "has lexical unit" |  | "FN" |  |
| fn:thwarting | fn:HasLexicalUnit | fn:lu:thwarting:stop | "thwarting" | "stop" | "has lexical unit" |  | "FN" |  |
| fn:thwarting | fn:HasLexicalUnit | fn:lu:thwarting:forestall | "thwarting" | "forestall" | "has lexical unit" |  | "FN" |  |
| fn:thwarting | fn:HasLexicalUnit | fn:lu:thwarting:derail | "thwarting" | "derail" | "has lexical unit" |  | "FN" |  |
| fn:thwarting | fn:HasLexicalUnit | fn:lu:thwarting:frustrate | "thwarting" | "frustrate" | "has lexical unit" |  | "FN" |  |
| fn:thwarting | fn:HasLexicalUnit | fn:lu:thwarting:preclude | "thwarting" | "preclude" | "has lexical unit" |  | "FN" |  |
| fn:thwarting | fn:HasLexicalUnit | fn:lu:thwarting:counter | "thwarting" | "counter" | "has lexical unit" |  | "FN" |  |
| fn:thwarting | /r/HasA | fn:fe:preventing_cause | "thwarting" | "preventing cause" | "/r/has a" |  | "FN" |  |
| fn:thwarting | /r/HasA | fn:fe:protagonist | "thwarting" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:thwarting | /r/HasA | fn:fe:action | "thwarting" | "action" | "/r/has a" |  | "FN" |  |
| fn:thwarting | /r/HasA | fn:fe:time | "thwarting" | "time" | "/r/has a" |  | "FN" |  |
| fn:thwarting | /r/HasA | fn:fe:place | "thwarting" | "place" | "/r/has a" |  | "FN" |  |
| fn:thwarting | /r/HasA | fn:fe:manner | "thwarting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:thwarting | /r/HasA | fn:fe:degree | "thwarting" | "degree" | "/r/has a" |  | "FN" |  |
| fn:thwarting | /r/HasA | fn:fe:explanation | "thwarting" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:thwarting | /r/HasA | fn:fe:frequency | "thwarting" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:time_period_of_action | /r/IsA | fn:timespan | "time period of action" | "timespan" | "/r/is a" |  | "FN" |  |
| fn:alternatives | /r/UsedFor | fn:time_period_of_action | "alternatives" | "time period of action" | "/r/used for" |  | "FN" |  |
| fn:time_period_of_action | fn:HasLexicalUnit | fn:lu:time_period_of_action:window | "time period of action" | "window" | "has lexical unit" |  | "FN" |  |
| fn:time_period_of_action | /r/HasA | fn:fe:enabled_action | "time period of action" | "enabled action" | "/r/has a" |  | "FN" |  |
| fn:time_period_of_action | /r/HasA | fn:fe:duration | "time period of action" | "duration" | "/r/has a" |  | "FN" |  |
| fn:time_period_of_action | /r/HasA | fn:fe:agent | "time period of action" | "agent" | "/r/has a" |  | "FN" |  |
| fn:time_period_of_action | /r/HasA | fn:fe:whole | "time period of action" | "whole" | "/r/has a" |  | "FN" |  |
| fn:time_vector | /r/IsA | fn:basis_for_attribute | "time vector" | "basis for attribute" | "/r/is a" |  | "FN" |  |
| fn:direction | /r/UsedFor | fn:time_vector | "direction" | "time vector" | "/r/used for" |  | "FN" |  |
| fn:relative_time | /r/RelatedTo | fn:time_vector | "relative time" | "time vector" | "/r/related to" |  | "FN" |  |
| fn:time_vector | /r/SimilarTo | fn:temporal_collocation | "time vector" | "temporal collocation" | "/r/similar to" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:from | "time vector" | "from" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:hence | "time vector" | "hence" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:after | "time vector" | "after" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:before | "time vector" | "before" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:ago | "time vector" | "ago" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:since | "time vector" | "since" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:down_the_road | "time vector" | "down the road" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:previously | "time vector" | "previously" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:prior | "time vector" | "prior" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:beforehand | "time vector" | "beforehand" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:afterward | "time vector" | "afterward" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:afterwards | "time vector" | "afterwards" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:right_away | "time vector" | "right away" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:sooner_rather_than_later | "time vector" | "sooner rather than later" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:later | "time vector" | "later" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:thereafter | "time vector" | "thereafter" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:through | "time vector" | "through" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:former | "time vector" | "former" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:formerly | "time vector" | "formerly" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:eventually | "time vector" | "eventually" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:previous | "time vector" | "previous" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:pre | "time vector" | "pre" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:post | "time vector" | "post" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:ante | "time vector" | "ante" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:finally | "time vector" | "finally" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:then | "time vector" | "then" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:already | "time vector" | "already" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:until | "time vector" | "until" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:following | "time vector" | "following" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:since | "time vector" | "since" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:in_time | "time vector" | "in time" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | fn:HasLexicalUnit | fn:lu:time_vector:yet | "time vector" | "yet" | "has lexical unit" |  | "FN" |  |
| fn:time_vector | /r/HasA | fn:fe:landmark_event | "time vector" | "landmark event" | "/r/has a" |  | "FN" |  |
| fn:time_vector | /r/HasA | fn:fe:distance | "time vector" | "distance" | "/r/has a" |  | "FN" |  |
| fn:time_vector | /r/HasA | fn:fe:direction | "time vector" | "direction" | "/r/has a" |  | "FN" |  |
| fn:time_vector | /r/HasA | fn:fe:event | "time vector" | "event" | "/r/has a" |  | "FN" |  |
| fn:time_period_of_action | /r/IsA | fn:timespan | "time period of action" | "timespan" | "/r/is a" |  | "FN" |  |
| fn:timespan | /r/IsA | fn:delimited_state_scenario | "timespan" | "delimited state scenario" | "/r/is a" |  | "FN" |  |
| fn:timespan | fn:HasLexicalUnit | fn:lu:timespan:day | "timespan" | "day" | "has lexical unit" |  | "FN" |  |
| fn:timespan | fn:HasLexicalUnit | fn:lu:timespan:time | "timespan" | "time" | "has lexical unit" |  | "FN" |  |
| fn:timespan | fn:HasLexicalUnit | fn:lu:timespan:life | "timespan" | "life" | "has lexical unit" |  | "FN" |  |
| fn:timespan | /r/HasA | fn:fe:duration | "timespan" | "duration" | "/r/has a" |  | "FN" |  |
| fn:timespan | /r/HasA | fn:fe:state | "timespan" | "state" | "/r/has a" |  | "FN" |  |
| fn:timespan | /r/HasA | fn:fe:whole | "timespan" | "whole" | "/r/has a" |  | "FN" |  |
| fn:timespan | /r/HasA | fn:fe:descriptor | "timespan" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:scheduling | /r/Causes | fn:timetable | "scheduling" | "timetable" | "/r/causes" |  | "FN" |  |
| fn:timetable | fn:HasLexicalUnit | fn:lu:timetable:schedule | "timetable" | "schedule" | "has lexical unit" |  | "FN" |  |
| fn:timetable | fn:HasLexicalUnit | fn:lu:timetable:timetable | "timetable" | "timetable" | "has lexical unit" |  | "FN" |  |
| fn:timetable | fn:HasLexicalUnit | fn:lu:timetable:agenda | "timetable" | "agenda" | "has lexical unit" |  | "FN" |  |
| fn:timetable | fn:HasLexicalUnit | fn:lu:timetable:itinerary | "timetable" | "itinerary" | "has lexical unit" |  | "FN" |  |
| fn:timetable | /r/HasA | fn:fe:timetable | "timetable" | "timetable" | "/r/has a" |  | "FN" |  |
| fn:timetable | /r/HasA | fn:fe:events | "timetable" | "events" | "/r/has a" |  | "FN" |  |
| fn:timetable | /r/HasA | fn:fe:cognizer | "timetable" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:timetable | /r/HasA | fn:fe:period_of_iterations | "timetable" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:timetable | /r/HasA | fn:fe:time_of_implementation | "timetable" | "time of implementation" | "/r/has a" |  | "FN" |  |
| fn:timetable | /r/HasA | fn:fe:purpose | "timetable" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:timetable | /r/HasA | fn:fe:descriptor | "timetable" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:experiencer_focus | /r/UsedFor | fn:tolerating | "experiencer focus" | "tolerating" | "/r/used for" |  | "FN" |  |
| fn:tolerating | fn:HasLexicalUnit | fn:lu:tolerating:stand | "tolerating" | "stand" | "has lexical unit" |  | "FN" |  |
| fn:tolerating | fn:HasLexicalUnit | fn:lu:tolerating:endure | "tolerating" | "endure" | "has lexical unit" |  | "FN" |  |
| fn:tolerating | fn:HasLexicalUnit | fn:lu:tolerating:tolerant | "tolerating" | "tolerant" | "has lexical unit" |  | "FN" |  |
| fn:tolerating | fn:HasLexicalUnit | fn:lu:tolerating:bear | "tolerating" | "bear" | "has lexical unit" |  | "FN" |  |
| fn:tolerating | fn:HasLexicalUnit | fn:lu:tolerating:toleration | "tolerating" | "toleration" | "has lexical unit" |  | "FN" |  |
| fn:tolerating | fn:HasLexicalUnit | fn:lu:tolerating:tolerate | "tolerating" | "tolerate" | "has lexical unit" |  | "FN" |  |
| fn:tolerating | /r/HasA | fn:fe:experiencer | "tolerating" | "experiencer" | "/r/has a" |  | "FN" |  |
| fn:tolerating | /r/HasA | fn:fe:content | "tolerating" | "content" | "/r/has a" |  | "FN" |  |
| fn:tolerating | /r/HasA | fn:fe:explanation | "tolerating" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:tolerating | /r/HasA | fn:fe:degree | "tolerating" | "degree" | "/r/has a" |  | "FN" |  |
| fn:tolerating | /r/HasA | fn:fe:manner | "tolerating" | "manner" | "/r/has a" |  | "FN" |  |
| fn:tolerating | /r/HasA | fn:fe:parameter | "tolerating" | "parameter" | "/r/has a" |  | "FN" |  |
| fn:tolerating | /r/HasA | fn:fe:topic | "tolerating" | "topic" | "/r/has a" |  | "FN" |  |
| fn:tolerating | /r/HasA | fn:fe:state | "tolerating" | "state" | "/r/has a" |  | "FN" |  |
| fn:tolerating | /r/HasA | fn:fe:event | "tolerating" | "event" | "/r/has a" |  | "FN" |  |
| fn:tolerating | /r/HasA | fn:fe:circumstances | "tolerating" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:tolerating | /r/HasA | fn:fe:time | "tolerating" | "time" | "/r/has a" |  | "FN" |  |
| fn:tool_purpose | /r/IsA | fn:inherent_purpose | "tool purpose" | "inherent purpose" | "/r/is a" |  | "FN" |  |
| fn:purpose | /r/UsedFor | fn:tool_purpose | "purpose" | "tool purpose" | "/r/used for" |  | "FN" |  |
| fn:tool_purpose | fn:HasLexicalUnit | fn:lu:tool_purpose:use | "tool purpose" | "use" | "has lexical unit" |  | "FN" |  |
| fn:tool_purpose | fn:HasLexicalUnit | fn:lu:tool_purpose:function | "tool purpose" | "function" | "has lexical unit" |  | "FN" |  |
| fn:tool_purpose | /r/HasA | fn:fe:purpose | "tool purpose" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:tool_purpose | /r/HasA | fn:fe:tool | "tool purpose" | "tool" | "/r/has a" |  | "FN" |  |
| fn:tool_purpose | /r/HasA | fn:fe:type | "tool purpose" | "type" | "/r/has a" |  | "FN" |  |
| fn:tool_purpose | /r/HasA | fn:fe:domain | "tool purpose" | "domain" | "/r/has a" |  | "FN" |  |
| fn:text | /r/UsedFor | fn:topic | "text" | "topic" | "/r/used for" |  | "FN" |  |
| fn:spatial_contact | /r/RelatedTo | fn:topic | "spatial contact" | "topic" | "/r/related to" |  | "FN" |  |
| fn:discussion | /r/SimilarTo | fn:topic | "discussion" | "topic" | "/r/similar to" |  | "FN" |  |
| fn:topic | fn:HasLexicalUnit | fn:lu:topic:about | "topic" | "about" | "has lexical unit" |  | "FN" |  |
| fn:topic | fn:HasLexicalUnit | fn:lu:topic:concern | "topic" | "concern" | "has lexical unit" |  | "FN" |  |
| fn:topic | fn:HasLexicalUnit | fn:lu:topic:discuss | "topic" | "discuss" | "has lexical unit" |  | "FN" |  |
| fn:topic | fn:HasLexicalUnit | fn:lu:topic:topic | "topic" | "topic" | "has lexical unit" |  | "FN" |  |
| fn:topic | fn:HasLexicalUnit | fn:lu:topic:subject | "topic" | "subject" | "has lexical unit" |  | "FN" |  |
| fn:topic | fn:HasLexicalUnit | fn:lu:topic:cover | "topic" | "cover" | "has lexical unit" |  | "FN" |  |
| fn:topic | fn:HasLexicalUnit | fn:lu:topic:regarding | "topic" | "regarding" | "has lexical unit" |  | "FN" |  |
| fn:topic | fn:HasLexicalUnit | fn:lu:topic:treat | "topic" | "treat" | "has lexical unit" |  | "FN" |  |
| fn:topic | fn:HasLexicalUnit | fn:lu:topic:address | "topic" | "address" | "has lexical unit" |  | "FN" |  |
| fn:topic | fn:HasLexicalUnit | fn:lu:topic:concerning | "topic" | "concerning" | "has lexical unit" |  | "FN" |  |
| fn:topic | fn:HasLexicalUnit | fn:lu:topic:theme | "topic" | "theme" | "has lexical unit" |  | "FN" |  |
| fn:topic | fn:HasLexicalUnit | fn:lu:topic:dwell_(on) | "topic" | "dwell (on)" | "has lexical unit" |  | "FN" |  |
| fn:topic | fn:HasLexicalUnit | fn:lu:topic:on | "topic" | "on" | "has lexical unit" |  | "FN" |  |
| fn:topic | fn:HasLexicalUnit | fn:lu:topic:regard | "topic" | "regard" | "has lexical unit" |  | "FN" |  |
| fn:topic | fn:HasLexicalUnit | fn:lu:topic:regard | "topic" | "regard" | "has lexical unit" |  | "FN" |  |
| fn:topic | fn:HasLexicalUnit | fn:lu:topic:refer | "topic" | "refer" | "has lexical unit" |  | "FN" |  |
| fn:topic | /r/HasA | fn:fe:topic | "topic" | "topic" | "/r/has a" |  | "FN" |  |
| fn:topic | /r/HasA | fn:fe:text | "topic" | "text" | "/r/has a" |  | "FN" |  |
| fn:topic | /r/HasA | fn:fe:communicator | "topic" | "communicator" | "/r/has a" |  | "FN" |  |
| fn:topic | /r/HasA | fn:fe:degree | "topic" | "degree" | "/r/has a" |  | "FN" |  |
| fn:topic | /r/HasA | fn:fe:manner | "topic" | "manner" | "/r/has a" |  | "FN" |  |
| fn:topic | /r/HasA | fn:fe:status | "topic" | "status" | "/r/has a" |  | "FN" |  |
| fn:topic | /r/HasA | fn:fe:time | "topic" | "time" | "/r/has a" |  | "FN" |  |
| fn:topic | /r/HasA | fn:fe:explanation | "topic" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:touring | /r/IsA | fn:perception_active | "touring" | "perception active" | "/r/is a" |  | "FN" |  |
| fn:visiting | /r/UsedFor | fn:touring | "visiting" | "touring" | "/r/used for" |  | "FN" |  |
| fn:touring | fn:HasLexicalUnit | fn:lu:touring:tour | "touring" | "tour" | "has lexical unit" |  | "FN" |  |
| fn:touring | fn:HasLexicalUnit | fn:lu:touring:tour | "touring" | "tour" | "has lexical unit" |  | "FN" |  |
| fn:touring | fn:HasLexicalUnit | fn:lu:touring:tourist | "touring" | "tourist" | "has lexical unit" |  | "FN" |  |
| fn:touring | fn:HasLexicalUnit | fn:lu:touring:see | "touring" | "see" | "has lexical unit" |  | "FN" |  |
| fn:touring | fn:HasLexicalUnit | fn:lu:touring:sights | "touring" | "sights" | "has lexical unit" |  | "FN" |  |
| fn:touring | fn:HasLexicalUnit | fn:lu:touring:do | "touring" | "do" | "has lexical unit" |  | "FN" |  |
| fn:touring | fn:HasLexicalUnit | fn:lu:touring:sight_seer | "touring" | "sight seer" | "has lexical unit" |  | "FN" |  |
| fn:touring | fn:HasLexicalUnit | fn:lu:touring:sight-see | "touring" | "sight-see" | "has lexical unit" |  | "FN" |  |
| fn:touring | fn:HasLexicalUnit | fn:lu:touring:tourism | "touring" | "tourism" | "has lexical unit" |  | "FN" |  |
| fn:fe:tourist | /r/IsA | fn:st:sentient | "tourist" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:touring | /r/HasA | fn:fe:tourist | "touring" | "tourist" | "/r/has a" |  | "FN" |  |
| fn:fe:attraction | /r/IsA | fn:st:location | "attraction" | "location" | "/r/is a" |  | "FN" |  |
| fn:touring | /r/HasA | fn:fe:attraction | "touring" | "attraction" | "/r/has a" |  | "FN" |  |
| fn:touring | /r/HasA | fn:fe:depictive | "touring" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:touring | /r/HasA | fn:fe:ground | "touring" | "ground" | "/r/has a" |  | "FN" |  |
| fn:touring | /r/HasA | fn:fe:manner | "touring" | "manner" | "/r/has a" |  | "FN" |  |
| fn:touring | /r/HasA | fn:fe:means | "touring" | "means" | "/r/has a" |  | "FN" |  |
| fn:touring | /r/HasA | fn:fe:time | "touring" | "time" | "/r/has a" |  | "FN" |  |
| fn:touring | /r/HasA | fn:fe:purpose | "touring" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:touring | /r/HasA | fn:fe:place | "touring" | "place" | "/r/has a" |  | "FN" |  |
| fn:touring | /r/HasA | fn:fe:duration | "touring" | "duration" | "/r/has a" |  | "FN" |  |
| fn:touring | /r/HasA | fn:fe:particular_iteration | "touring" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:touring | /r/HasA | fn:fe:co-participant | "touring" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:cause_harm | /r/UsedFor | fn:toxic_substance | "cause harm" | "toxic substance" | "/r/used for" |  | "FN" |  |
| fn:toxic_substance | fn:HasLexicalUnit | fn:lu:toxic_substance:toxic | "toxic substance" | "toxic" | "has lexical unit" |  | "FN" |  |
| fn:toxic_substance | fn:HasLexicalUnit | fn:lu:toxic_substance:toxin | "toxic substance" | "toxin" | "has lexical unit" |  | "FN" |  |
| fn:toxic_substance | fn:HasLexicalUnit | fn:lu:toxic_substance:poison | "toxic substance" | "poison" | "has lexical unit" |  | "FN" |  |
| fn:toxic_substance | fn:HasLexicalUnit | fn:lu:toxic_substance:poisonous | "toxic substance" | "poisonous" | "has lexical unit" |  | "FN" |  |
| fn:toxic_substance | fn:HasLexicalUnit | fn:lu:toxic_substance:venom | "toxic substance" | "venom" | "has lexical unit" |  | "FN" |  |
| fn:toxic_substance | fn:HasLexicalUnit | fn:lu:toxic_substance:venomous | "toxic substance" | "venomous" | "has lexical unit" |  | "FN" |  |
| fn:toxic_substance | /r/HasA | fn:fe:victim | "toxic substance" | "victim" | "/r/has a" |  | "FN" |  |
| fn:toxic_substance | /r/HasA | fn:fe:degree | "toxic substance" | "degree" | "/r/has a" |  | "FN" |  |
| fn:toxic_substance | /r/HasA | fn:fe:body_part | "toxic substance" | "body part" | "/r/has a" |  | "FN" |  |
| fn:toxic_substance | /r/HasA | fn:fe:explanation | "toxic substance" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:toxic_substance | /r/HasA | fn:fe:toxic_substance | "toxic substance" | "toxic substance" | "/r/has a" |  | "FN" |  |
| fn:toxic_substance | /r/HasA | fn:fe:circumstances | "toxic substance" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:toxic_substance | /r/HasA | fn:fe:toxin_source | "toxic substance" | "toxin source" | "/r/has a" |  | "FN" |  |
| fn:toxic_substance | /r/HasA | fn:fe:type | "toxic substance" | "type" | "/r/has a" |  | "FN" |  |
| fn:toxic_substance | /r/HasA | fn:fe:duration | "toxic substance" | "duration" | "/r/has a" |  | "FN" |  |
| fn:transfer | /r/IsA | fn:eventive_affecting | "transfer" | "eventive affecting" | "/r/is a" |  | "FN" |  |
| fn:commerce_goods-transfer | /r/IsA | fn:transfer | "commerce goods-transfer" | "transfer" | "/r/is a" |  | "FN" |  |
| fn:commerce_money-transfer | /r/IsA | fn:transfer | "commerce money-transfer" | "transfer" | "/r/is a" |  | "FN" |  |
| fn:transfer_scenario | /r/HasSubevent | fn:transfer | "transfer scenario" | "transfer" | "/r/has subevent" |  | "FN" |  |
| fn:transfer | /r/HasPrerequisite | fn:pre_transfer | "transfer" | "pre transfer" | "/r/has prerequisite" |  | "FN" |  |
| fn:post_transfer | /r/HasPrerequisite | fn:transfer | "post transfer" | "transfer" | "/r/has prerequisite" |  | "FN" |  |
| fn:giving | /r/IsA | fn:transfer | "giving" | "transfer" | "/r/is a" |  | "FN" |  |
| fn:receiving | /r/IsA | fn:transfer | "receiving" | "transfer" | "/r/is a" |  | "FN" |  |
| fn:transfer | fn:HasLexicalUnit | fn:lu:transfer:transfer | "transfer" | "transfer" | "has lexical unit" |  | "FN" |  |
| fn:transfer | fn:HasLexicalUnit | fn:lu:transfer:transfer | "transfer" | "transfer" | "has lexical unit" |  | "FN" |  |
| fn:fe:recipient | /r/RelatedTo | fn:fe:transferors | "recipient" | "transferors" | "/r/related to" |  | "FN" |  |
| fn:transfer | /r/HasA | fn:fe:recipient | "transfer" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:transfer | /r/HasA | fn:fe:theme | "transfer" | "theme" | "/r/has a" |  | "FN" |  |
| fn:fe:donor | /r/RelatedTo | fn:fe:transferors | "donor" | "transferors" | "/r/related to" |  | "FN" |  |
| fn:transfer | /r/HasA | fn:fe:donor | "transfer" | "donor" | "/r/has a" |  | "FN" |  |
| fn:transfer | /r/HasA | fn:fe:place | "transfer" | "place" | "/r/has a" |  | "FN" |  |
| fn:transfer | /r/HasA | fn:fe:explanation | "transfer" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:transfer | /r/HasA | fn:fe:time | "transfer" | "time" | "/r/has a" |  | "FN" |  |
| fn:transfer | /r/HasA | fn:fe:transferors | "transfer" | "transferors" | "/r/has a" |  | "FN" |  |
| fn:transfer | /r/HasA | fn:fe:means | "transfer" | "means" | "/r/has a" |  | "FN" |  |
| fn:transfer | /r/HasA | fn:fe:manner | "transfer" | "manner" | "/r/has a" |  | "FN" |  |
| fn:transfer | /r/HasA | fn:fe:purpose | "transfer" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:temporary_transfer_scenario | /r/IsA | fn:transfer_scenario | "temporary transfer scenario" | "transfer scenario" | "/r/is a" |  | "FN" |  |
| fn:transfer_scenario | /r/HasSubevent | fn:post_transfer | "transfer scenario" | "post transfer" | "/r/has subevent" |  | "FN" |  |
| fn:transfer_scenario | /r/HasSubevent | fn:pre_transfer | "transfer scenario" | "pre transfer" | "/r/has subevent" |  | "FN" |  |
| fn:transfer_scenario | /r/HasSubevent | fn:transfer | "transfer scenario" | "transfer" | "/r/has subevent" |  | "FN" |  |
| fn:transfer_scenario | /r/UsedFor | fn:exchange | "transfer scenario" | "exchange" | "/r/used for" |  | "FN" |  |
| fn:giving_scenario | /r/IsA | fn:transfer_scenario | "giving scenario" | "transfer scenario" | "/r/is a" |  | "FN" |  |
| fn:receiving_scenario | /r/IsA | fn:transfer_scenario | "receiving scenario" | "transfer scenario" | "/r/is a" |  | "FN" |  |
| fn:transfer_scenario | /r/HasA | fn:fe:recipient | "transfer scenario" | "recipient" | "/r/has a" |  | "FN" |  |
| fn:transfer_scenario | /r/HasA | fn:fe:theme | "transfer scenario" | "theme" | "/r/has a" |  | "FN" |  |
| fn:transfer_scenario | /r/HasA | fn:fe:donor | "transfer scenario" | "donor" | "/r/has a" |  | "FN" |  |
| fn:transfer_scenario | /r/HasA | fn:fe:transferors | "transfer scenario" | "transferors" | "/r/has a" |  | "FN" |  |
| fn:transition_to_a_quality | /r/IsA | fn:becoming | "transition to a quality" | "becoming" | "/r/is a" |  | "FN" |  |
| fn:absorb_heat | /r/IsA | fn:transition_to_a_quality | "absorb heat" | "transition to a quality" | "/r/is a" |  | "FN" |  |
| fn:becoming_attached | /r/IsA | fn:transition_to_a_quality | "becoming attached" | "transition to a quality" | "/r/is a" |  | "FN" |  |
| fn:becoming_detached | /r/IsA | fn:transition_to_a_quality | "becoming detached" | "transition to a quality" | "/r/is a" |  | "FN" |  |
| fn:becoming_dry | /r/IsA | fn:transition_to_a_quality | "becoming dry" | "transition to a quality" | "/r/is a" |  | "FN" |  |
| fn:becoming_visible | /r/IsA | fn:transition_to_a_quality | "becoming visible" | "transition to a quality" | "/r/is a" |  | "FN" |  |
| fn:gradable_attributes | /r/UsedFor | fn:transition_to_a_quality | "gradable attributes" | "transition to a quality" | "/r/used for" |  | "FN" |  |
| fn:transition_to_state | /r/SimilarTo | fn:transition_to_a_quality | "transition to state" | "transition to a quality" | "/r/similar to" |  | "FN" |  |
| fn:transition_to_a_quality | fn:HasLexicalUnit | fn:lu:transition_to_a_quality:go | "transition to a quality" | "go" | "has lexical unit" |  | "FN" |  |
| fn:transition_to_a_quality | /r/HasA | fn:fe:place | "transition to a quality" | "place" | "/r/has a" |  | "FN" |  |
| fn:transition_to_a_quality | /r/HasA | fn:fe:time | "transition to a quality" | "time" | "/r/has a" |  | "FN" |  |
| fn:transition_to_a_quality | /r/HasA | fn:fe:duration_of_final_state | "transition to a quality" | "duration of final state" | "/r/has a" |  | "FN" |  |
| fn:transition_to_a_quality | /r/HasA | fn:fe:manner | "transition to a quality" | "manner" | "/r/has a" |  | "FN" |  |
| fn:transition_to_a_quality | /r/HasA | fn:fe:entity | "transition to a quality" | "entity" | "/r/has a" |  | "FN" |  |
| fn:transition_to_a_quality | /r/HasA | fn:fe:final_quality | "transition to a quality" | "final quality" | "/r/has a" |  | "FN" |  |
| fn:transition_to_a_quality | /r/HasA | fn:fe:transitional_period | "transition to a quality" | "transitional period" | "/r/has a" |  | "FN" |  |
| fn:transition_to_a_quality | /r/HasA | fn:fe:circumstances | "transition to a quality" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:transition_to_a_quality | /r/HasA | fn:fe:group | "transition to a quality" | "group" | "/r/has a" |  | "FN" |  |
| fn:transition_to_a_quality | /r/HasA | fn:fe:explanation | "transition to a quality" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:transition_to_a_situation | /r/IsA | fn:transition_to_state | "transition to a situation" | "transition to state" | "/r/is a" |  | "FN" |  |
| fn:transition_to_a_situation | /r/RelatedTo | fn:process_start | "transition to a situation" | "process start" | "/r/related to" |  | "FN" |  |
| fn:transition_to_a_situation | /r/RelatedTo | fn:transition_to_state | "transition to a situation" | "transition to state" | "/r/related to" |  | "FN" |  |
| fn:transition_to_a_situation | fn:HasLexicalUnit | fn:lu:transition_to_a_situation:come | "transition to a situation" | "come" | "has lexical unit" |  | "FN" |  |
| fn:transition_to_a_situation | /r/HasA | fn:fe:place | "transition to a situation" | "place" | "/r/has a" |  | "FN" |  |
| fn:transition_to_a_situation | /r/HasA | fn:fe:time | "transition to a situation" | "time" | "/r/has a" |  | "FN" |  |
| fn:transition_to_a_situation | /r/HasA | fn:fe:manner | "transition to a situation" | "manner" | "/r/has a" |  | "FN" |  |
| fn:transition_to_a_situation | /r/HasA | fn:fe:entity | "transition to a situation" | "entity" | "/r/has a" |  | "FN" |  |
| fn:transition_to_a_situation | /r/HasA | fn:fe:transitional_period | "transition to a situation" | "transitional period" | "/r/has a" |  | "FN" |  |
| fn:transition_to_a_situation | /r/HasA | fn:fe:circumstances | "transition to a situation" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:transition_to_a_situation | /r/HasA | fn:fe:group | "transition to a situation" | "group" | "/r/has a" |  | "FN" |  |
| fn:transition_to_a_situation | /r/HasA | fn:fe:explanation | "transition to a situation" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:transition_to_a_situation | /r/HasA | fn:fe:final_situation | "transition to a situation" | "final situation" | "/r/has a" |  | "FN" |  |
| fn:transition_to_state | /r/IsA | fn:event | "transition to state" | "event" | "/r/is a" |  | "FN" |  |
| fn:becoming | /r/IsA | fn:transition_to_state | "becoming" | "transition to state" | "/r/is a" |  | "FN" |  |
| fn:ceasing_to_be | /r/IsA | fn:transition_to_state | "ceasing to be" | "transition to state" | "/r/is a" |  | "FN" |  |
| fn:transition_to_a_situation | /r/IsA | fn:transition_to_state | "transition to a situation" | "transition to state" | "/r/is a" |  | "FN" |  |
| fn:undergo_change | /r/IsA | fn:transition_to_state | "undergo change" | "transition to state" | "/r/is a" |  | "FN" |  |
| fn:transition_to_a_situation | /r/RelatedTo | fn:transition_to_state | "transition to a situation" | "transition to state" | "/r/related to" |  | "FN" |  |
| fn:transition_to_state | /r/RelatedTo | fn:undergo_change | "transition to state" | "undergo change" | "/r/related to" |  | "FN" |  |
| fn:transition_to_state | /r/SimilarTo | fn:becoming | "transition to state" | "becoming" | "/r/similar to" |  | "FN" |  |
| fn:transition_to_state | /r/SimilarTo | fn:transition_to_a_quality | "transition to state" | "transition to a quality" | "/r/similar to" |  | "FN" |  |
| fn:transition_to_state | fn:HasLexicalUnit | fn:lu:transition_to_state:grow | "transition to state" | "grow" | "has lexical unit" |  | "FN" |  |
| fn:transition_to_state | fn:HasLexicalUnit | fn:lu:transition_to_state:get | "transition to state" | "get" | "has lexical unit" |  | "FN" |  |
| fn:transition_to_state | fn:HasLexicalUnit | fn:lu:transition_to_state:end_up | "transition to state" | "end up" | "has lexical unit" |  | "FN" |  |
| fn:transition_to_state | /r/HasA | fn:fe:place | "transition to state" | "place" | "/r/has a" |  | "FN" |  |
| fn:transition_to_state | /r/HasA | fn:fe:time | "transition to state" | "time" | "/r/has a" |  | "FN" |  |
| fn:transition_to_state | /r/HasA | fn:fe:duration_of_final_state | "transition to state" | "duration of final state" | "/r/has a" |  | "FN" |  |
| fn:transition_to_state | /r/HasA | fn:fe:manner | "transition to state" | "manner" | "/r/has a" |  | "FN" |  |
| fn:transition_to_state | /r/HasA | fn:fe:entity | "transition to state" | "entity" | "/r/has a" |  | "FN" |  |
| fn:fe:final_quality | /r/RelatedTo | fn:fe:final_category | "final quality" | "final category" | "/r/related to" |  | "FN" |  |
| fn:transition_to_state | /r/HasA | fn:fe:final_quality | "transition to state" | "final quality" | "/r/has a" |  | "FN" |  |
| fn:transition_to_state | /r/HasA | fn:fe:final_category | "transition to state" | "final category" | "/r/has a" |  | "FN" |  |
| fn:transition_to_state | /r/HasA | fn:fe:transitional_period | "transition to state" | "transitional period" | "/r/has a" |  | "FN" |  |
| fn:transition_to_state | /r/HasA | fn:fe:initial_state | "transition to state" | "initial state" | "/r/has a" |  | "FN" |  |
| fn:transition_to_state | /r/HasA | fn:fe:circumstances | "transition to state" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:transition_to_state | /r/HasA | fn:fe:initial_category | "transition to state" | "initial category" | "/r/has a" |  | "FN" |  |
| fn:transition_to_state | /r/HasA | fn:fe:group | "transition to state" | "group" | "/r/has a" |  | "FN" |  |
| fn:transition_to_state | /r/HasA | fn:fe:explanation | "transition to state" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:transition_to_state | /r/HasA | fn:fe:final_situation | "transition to state" | "final situation" | "/r/has a" |  | "FN" |  |
| fn:transitive_action | /r/IsA | fn:objective_influence | "transitive action" | "objective influence" | "/r/is a" |  | "FN" |  |
| fn:cause_bodily_experience | /r/IsA | fn:transitive_action | "cause bodily experience" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_change | /r/IsA | fn:transitive_action | "cause change" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_change_of_consistency | /r/IsA | fn:transitive_action | "cause change of consistency" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_change_of_phase | /r/IsA | fn:transitive_action | "cause change of phase" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_change_of_position_on_a_scale | /r/IsA | fn:transitive_action | "cause change of position on a scale" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_change_of_strength | /r/IsA | fn:transitive_action | "cause change of strength" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_expansion | /r/IsA | fn:transitive_action | "cause expansion" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_impact | /r/IsA | fn:transitive_action | "cause impact" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_motion | /r/IsA | fn:transitive_action | "cause motion" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_temperature_change | /r/IsA | fn:transitive_action | "cause temperature change" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_to_be_dry | /r/IsA | fn:transitive_action | "cause to be dry" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_to_be_included | /r/IsA | fn:transitive_action | "cause to be included" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_to_be_sharp | /r/IsA | fn:transitive_action | "cause to be sharp" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_to_be_wet | /r/IsA | fn:transitive_action | "cause to be wet" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_to_continue | /r/IsA | fn:transitive_action | "cause to continue" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_to_end | /r/IsA | fn:transitive_action | "cause to end" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_to_fragment | /r/IsA | fn:transitive_action | "cause to fragment" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_to_make_noise | /r/IsA | fn:transitive_action | "cause to make noise" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_to_move_in_place | /r/IsA | fn:transitive_action | "cause to move in place" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_to_resume | /r/IsA | fn:transitive_action | "cause to resume" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_to_rot | /r/IsA | fn:transitive_action | "cause to rot" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cause_to_wake | /r/IsA | fn:transitive_action | "cause to wake" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:container_focused_placing | /r/IsA | fn:transitive_action | "container focused placing" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:container_focused_removing | /r/IsA | fn:transitive_action | "container focused removing" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:corroding_caused | /r/IsA | fn:transitive_action | "corroding caused" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:creating | /r/IsA | fn:transitive_action | "creating" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:cure | /r/IsA | fn:transitive_action | "cure" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:damaging | /r/IsA | fn:transitive_action | "damaging" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:destroying | /r/IsA | fn:transitive_action | "destroying" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:downing | /r/IsA | fn:transitive_action | "downing" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:endangering | /r/IsA | fn:transitive_action | "endangering" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:erasing | /r/IsA | fn:transitive_action | "erasing" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:grinding | /r/IsA | fn:transitive_action | "grinding" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:imposing_obligation | /r/IsA | fn:transitive_action | "imposing obligation" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:infecting | /r/IsA | fn:transitive_action | "infecting" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:intentionally_affect | /r/IsA | fn:transitive_action | "intentionally affect" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:interrupt_process | /r/IsA | fn:transitive_action | "interrupt process" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:killing | /r/IsA | fn:transitive_action | "killing" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:placing | /r/IsA | fn:transitive_action | "placing" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:rejuvenation | /r/IsA | fn:transitive_action | "rejuvenation" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:removing | /r/IsA | fn:transitive_action | "removing" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:render_nonfunctional | /r/IsA | fn:transitive_action | "render nonfunctional" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:setting_fire | /r/IsA | fn:transitive_action | "setting fire" | "transitive action" | "/r/is a" |  | "FN" |  |
| fn:transitive_action | /r/HasA | fn:fe:agent | "transitive action" | "agent" | "/r/has a" |  | "FN" |  |
| fn:transitive_action | /r/HasA | fn:fe:patient | "transitive action" | "patient" | "/r/has a" |  | "FN" |  |
| fn:transitive_action | /r/HasA | fn:fe:event | "transitive action" | "event" | "/r/has a" |  | "FN" |  |
| fn:transitive_action | /r/HasA | fn:fe:depictive | "transitive action" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:transitive_action | /r/HasA | fn:fe:result | "transitive action" | "result" | "/r/has a" |  | "FN" |  |
| fn:transitive_action | /r/HasA | fn:fe:means | "transitive action" | "means" | "/r/has a" |  | "FN" |  |
| fn:transitive_action | /r/HasA | fn:fe:manner | "transitive action" | "manner" | "/r/has a" |  | "FN" |  |
| fn:transitive_action | /r/HasA | fn:fe:time | "transitive action" | "time" | "/r/has a" |  | "FN" |  |
| fn:transitive_action | /r/HasA | fn:fe:place | "transitive action" | "place" | "/r/has a" |  | "FN" |  |
| fn:transitive_action | /r/HasA | fn:fe:cause | "transitive action" | "cause" | "/r/has a" |  | "FN" |  |
| fn:translating | /r/IsA | fn:intentionally_create | "translating" | "intentionally create" | "/r/is a" |  | "FN" |  |
| fn:mental_activity | /r/UsedFor | fn:translating | "mental activity" | "translating" | "/r/used for" |  | "FN" |  |
| fn:translating | /r/UsedFor | fn:be_translation_equivalent | "translating" | "be translation equivalent" | "/r/used for" |  | "FN" |  |
| fn:translating | /r/UsedFor | fn:have_as_translation_equivalent | "translating" | "have as translation equivalent" | "/r/used for" |  | "FN" |  |
| fn:statement | /r/SimilarTo | fn:translating | "statement" | "translating" | "/r/similar to" |  | "FN" |  |
| fn:translating | fn:HasLexicalUnit | fn:lu:translating:translate | "translating" | "translate" | "has lexical unit" |  | "FN" |  |
| fn:translating | fn:HasLexicalUnit | fn:lu:translating:translation | "translating" | "translation" | "has lexical unit" |  | "FN" |  |
| fn:translating | /r/HasA | fn:fe:cognizer | "translating" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:translating | /r/HasA | fn:fe:source_symbol | "translating" | "source symbol" | "/r/has a" |  | "FN" |  |
| fn:translating | /r/HasA | fn:fe:source_representation | "translating" | "source representation" | "/r/has a" |  | "FN" |  |
| fn:translating | /r/HasA | fn:fe:manner | "translating" | "manner" | "/r/has a" |  | "FN" |  |
| fn:translating | /r/HasA | fn:fe:means | "translating" | "means" | "/r/has a" |  | "FN" |  |
| fn:translating | /r/HasA | fn:fe:time | "translating" | "time" | "/r/has a" |  | "FN" |  |
| fn:translating | /r/HasA | fn:fe:circumstances | "translating" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:translating | /r/HasA | fn:fe:target_symbol | "translating" | "target symbol" | "/r/has a" |  | "FN" |  |
| fn:translating | /r/HasA | fn:fe:target_representation | "translating" | "target representation" | "/r/has a" |  | "FN" |  |
| fn:translating | /r/HasA | fn:fe:content | "translating" | "content" | "/r/has a" |  | "FN" |  |
| fn:translating | /r/HasA | fn:fe:equivalence | "translating" | "equivalence" | "/r/has a" |  | "FN" |  |
| fn:translating | /r/HasA | fn:fe:medium | "translating" | "medium" | "/r/has a" |  | "FN" |  |
| fn:translating | /r/HasA | fn:fe:place | "translating" | "place" | "/r/has a" |  | "FN" |  |
| fn:translating | /r/HasA | fn:fe:purpose | "translating" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:transportation_status | /r/IsA | fn:state | "transportation status" | "state" | "/r/is a" |  | "FN" |  |
| fn:transportation_status | fn:HasLexicalUnit | fn:lu:transportation_status:on_foot | "transportation status" | "on foot" | "has lexical unit" |  | "FN" |  |
| fn:transportation_status | fn:HasLexicalUnit | fn:lu:transportation_status:mounted | "transportation status" | "mounted" | "has lexical unit" |  | "FN" |  |
| fn:transportation_status | fn:HasLexicalUnit | fn:lu:transportation_status:on_board | "transportation status" | "on board" | "has lexical unit" |  | "FN" |  |
| fn:transportation_status | /r/HasA | fn:fe:rider | "transportation status" | "rider" | "/r/has a" |  | "FN" |  |
| fn:transportation_status | /r/HasA | fn:fe:vehicle | "transportation status" | "vehicle" | "/r/has a" |  | "FN" |  |
| fn:prank | /r/IsA | fn:trap | "prank" | "trap" | "/r/is a" |  | "FN" |  |
| fn:intentional_deception | /r/UsedFor | fn:trap | "intentional deception" | "trap" | "/r/used for" |  | "FN" |  |
| fn:trap | fn:HasLexicalUnit | fn:lu:trap:trap | "trap" | "trap" | "has lexical unit" |  | "FN" |  |
| fn:trap | fn:HasLexicalUnit | fn:lu:trap:snare | "trap" | "snare" | "has lexical unit" |  | "FN" |  |
| fn:trap | /r/HasA | fn:fe:trap | "trap" | "trap" | "/r/has a" |  | "FN" |  |
| fn:trap | /r/HasA | fn:fe:deceiver | "trap" | "deceiver" | "/r/has a" |  | "FN" |  |
| fn:trap | /r/HasA | fn:fe:victim | "trap" | "victim" | "/r/has a" |  | "FN" |  |
| fn:trap | /r/HasA | fn:fe:descriptor | "trap" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:travel | /r/IsA | fn:self_motion | "travel" | "self motion" | "/r/is a" |  | "FN" |  |
| fn:travel | /r/HasSubevent | fn:setting_out | "travel" | "setting out" | "/r/has subevent" |  | "FN" |  |
| fn:travel | fn:HasLexicalUnit | fn:lu:travel:travel | "travel" | "travel" | "has lexical unit" |  | "FN" |  |
| fn:travel | fn:HasLexicalUnit | fn:lu:travel:travel | "travel" | "travel" | "has lexical unit" |  | "FN" |  |
| fn:travel | fn:HasLexicalUnit | fn:lu:travel:voyage | "travel" | "voyage" | "has lexical unit" |  | "FN" |  |
| fn:travel | fn:HasLexicalUnit | fn:lu:travel:voyage | "travel" | "voyage" | "has lexical unit" |  | "FN" |  |
| fn:travel | fn:HasLexicalUnit | fn:lu:travel:journey | "travel" | "journey" | "has lexical unit" |  | "FN" |  |
| fn:travel | fn:HasLexicalUnit | fn:lu:travel:journey | "travel" | "journey" | "has lexical unit" |  | "FN" |  |
| fn:travel | fn:HasLexicalUnit | fn:lu:travel:excursion | "travel" | "excursion" | "has lexical unit" |  | "FN" |  |
| fn:travel | fn:HasLexicalUnit | fn:lu:travel:odyssey | "travel" | "odyssey" | "has lexical unit" |  | "FN" |  |
| fn:travel | fn:HasLexicalUnit | fn:lu:travel:expedition | "travel" | "expedition" | "has lexical unit" |  | "FN" |  |
| fn:travel | fn:HasLexicalUnit | fn:lu:travel:commute | "travel" | "commute" | "has lexical unit" |  | "FN" |  |
| fn:travel | fn:HasLexicalUnit | fn:lu:travel:peregrination | "travel" | "peregrination" | "has lexical unit" |  | "FN" |  |
| fn:travel | fn:HasLexicalUnit | fn:lu:travel:pilgrimage | "travel" | "pilgrimage" | "has lexical unit" |  | "FN" |  |
| fn:travel | fn:HasLexicalUnit | fn:lu:travel:tour | "travel" | "tour" | "has lexical unit" |  | "FN" |  |
| fn:travel | fn:HasLexicalUnit | fn:lu:travel:tour | "travel" | "tour" | "has lexical unit" |  | "FN" |  |
| fn:travel | fn:HasLexicalUnit | fn:lu:travel:safari | "travel" | "safari" | "has lexical unit" |  | "FN" |  |
| fn:travel | fn:HasLexicalUnit | fn:lu:travel:trip | "travel" | "trip" | "has lexical unit" |  | "FN" |  |
| fn:travel | fn:HasLexicalUnit | fn:lu:travel:junket | "travel" | "junket" | "has lexical unit" |  | "FN" |  |
| fn:travel | fn:HasLexicalUnit | fn:lu:travel:traveler | "travel" | "traveler" | "has lexical unit" |  | "FN" |  |
| fn:travel | fn:HasLexicalUnit | fn:lu:travel:getaway | "travel" | "getaway" | "has lexical unit" |  | "FN" |  |
| fn:travel | fn:HasLexicalUnit | fn:lu:travel:jaunt | "travel" | "jaunt" | "has lexical unit" |  | "FN" |  |
| fn:travel | /r/HasA | fn:fe:area | "travel" | "area" | "/r/has a" |  | "FN" |  |
| fn:travel | /r/HasA | fn:fe:co-participant | "travel" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:travel | /r/HasA | fn:fe:distance | "travel" | "distance" | "/r/has a" |  | "FN" |  |
| fn:travel | /r/HasA | fn:fe:duration | "travel" | "duration" | "/r/has a" |  | "FN" |  |
| fn:travel | /r/HasA | fn:fe:goal | "travel" | "goal" | "/r/has a" |  | "FN" |  |
| fn:travel | /r/HasA | fn:fe:manner | "travel" | "manner" | "/r/has a" |  | "FN" |  |
| fn:travel | /r/HasA | fn:fe:means | "travel" | "means" | "/r/has a" |  | "FN" |  |
| fn:travel | /r/HasA | fn:fe:path | "travel" | "path" | "/r/has a" |  | "FN" |  |
| fn:fe:traveler | /r/IsA | fn:st:sentient | "traveler" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:travel | /r/HasA | fn:fe:traveler | "travel" | "traveler" | "/r/has a" |  | "FN" |  |
| fn:travel | /r/HasA | fn:fe:source | "travel" | "source" | "/r/has a" |  | "FN" |  |
| fn:travel | /r/HasA | fn:fe:speed | "travel" | "speed" | "/r/has a" |  | "FN" |  |
| fn:travel | /r/HasA | fn:fe:mode_of_transportation | "travel" | "mode of transportation" | "/r/has a" |  | "FN" |  |
| fn:travel | /r/HasA | fn:fe:time | "travel" | "time" | "/r/has a" |  | "FN" |  |
| fn:travel | /r/HasA | fn:fe:explanation | "travel" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:travel | /r/HasA | fn:fe:baggage | "travel" | "baggage" | "/r/has a" |  | "FN" |  |
| fn:travel | /r/HasA | fn:fe:frequency | "travel" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:travel | /r/HasA | fn:fe:purpose | "travel" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:travel | /r/HasA | fn:fe:iterations | "travel" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:travel | /r/HasA | fn:fe:period_of_iterations | "travel" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:travel | /r/HasA | fn:fe:travel_means | "travel" | "travel means" | "/r/has a" |  | "FN" |  |
| fn:travel | /r/HasA | fn:fe:depictive | "travel" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:travel | /r/HasA | fn:fe:result | "travel" | "result" | "/r/has a" |  | "FN" |  |
| fn:travel | /r/HasA | fn:fe:place | "travel" | "place" | "/r/has a" |  | "FN" |  |
| fn:travel | /r/HasA | fn:fe:direction | "travel" | "direction" | "/r/has a" |  | "FN" |  |
| fn:travel | /r/HasA | fn:fe:descriptor | "travel" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/IsA | fn:event | "traversing" | "event" | "/r/is a" |  | "FN" |  |
| fn:intentional_traversing | /r/IsA | fn:traversing | "intentional traversing" | "traversing" | "/r/is a" |  | "FN" |  |
| fn:traversing | /r/HasSubevent | fn:arriving | "traversing" | "arriving" | "/r/has subevent" |  | "FN" |  |
| fn:traversing | /r/HasSubevent | fn:departing | "traversing" | "departing" | "/r/has subevent" |  | "FN" |  |
| fn:path_shape | /r/UsedFor | fn:traversing | "path shape" | "traversing" | "/r/used for" |  | "FN" |  |
| fn:traversing | /r/UsedFor | fn:openness | "traversing" | "openness" | "/r/used for" |  | "FN" |  |
| fn:path_shape | /r/SimilarTo | fn:traversing | "path shape" | "traversing" | "/r/similar to" |  | "FN" |  |
| fn:traversing | /r/SimilarTo | fn:activity_start | "traversing" | "activity start" | "/r/similar to" |  | "FN" |  |
| fn:traversing | /r/SimilarTo | fn:arriving | "traversing" | "arriving" | "/r/similar to" |  | "FN" |  |
| fn:traversing | /r/SimilarTo | fn:change_direction | "traversing" | "change direction" | "/r/similar to" |  | "FN" |  |
| fn:traversing | /r/SimilarTo | fn:change_position_on_a_scale | "traversing" | "change position on a scale" | "/r/similar to" |  | "FN" |  |
| fn:traversing | /r/SimilarTo | fn:departing | "traversing" | "departing" | "/r/similar to" |  | "FN" |  |
| fn:traversing | /r/SimilarTo | fn:forming_relationships | "traversing" | "forming relationships" | "/r/similar to" |  | "FN" |  |
| fn:traversing | /r/SimilarTo | fn:intentional_traversing | "traversing" | "intentional traversing" | "/r/similar to" |  | "FN" |  |
| fn:traversing | /r/SimilarTo | fn:motion | "traversing" | "motion" | "/r/similar to" |  | "FN" |  |
| fn:traversing | /r/SimilarTo | fn:motion_directional | "traversing" | "motion directional" | "/r/similar to" |  | "FN" |  |
| fn:traversing | /r/SimilarTo | fn:moving_in_place | "traversing" | "moving in place" | "/r/similar to" |  | "FN" |  |
| fn:traversing | /r/SimilarTo | fn:path_shape | "traversing" | "path shape" | "/r/similar to" |  | "FN" |  |
| fn:traversing | /r/SimilarTo | fn:self_motion | "traversing" | "self motion" | "/r/similar to" |  | "FN" |  |
| fn:traversing | /r/SimilarTo | fn:undergo_change | "traversing" | "undergo change" | "/r/similar to" |  | "FN" |  |
| fn:traversing | /r/IsA | fn:motion_scenario | "traversing" | "motion scenario" | "/r/is a" |  | "FN" |  |
| fn:traversing | fn:HasLexicalUnit | fn:lu:traversing:traverse | "traversing" | "traverse" | "has lexical unit" |  | "FN" |  |
| fn:traversing | fn:HasLexicalUnit | fn:lu:traversing:skirt | "traversing" | "skirt" | "has lexical unit" |  | "FN" |  |
| fn:traversing | fn:HasLexicalUnit | fn:lu:traversing:mount | "traversing" | "mount" | "has lexical unit" |  | "FN" |  |
| fn:traversing | fn:HasLexicalUnit | fn:lu:traversing:descent | "traversing" | "descent" | "has lexical unit" |  | "FN" |  |
| fn:traversing | fn:HasLexicalUnit | fn:lu:traversing:descend | "traversing" | "descend" | "has lexical unit" |  | "FN" |  |
| fn:traversing | fn:HasLexicalUnit | fn:lu:traversing:cross | "traversing" | "cross" | "has lexical unit" |  | "FN" |  |
| fn:traversing | fn:HasLexicalUnit | fn:lu:traversing:crisscross | "traversing" | "crisscross" | "has lexical unit" |  | "FN" |  |
| fn:traversing | fn:HasLexicalUnit | fn:lu:traversing:ascent | "traversing" | "ascent" | "has lexical unit" |  | "FN" |  |
| fn:traversing | fn:HasLexicalUnit | fn:lu:traversing:ascend | "traversing" | "ascend" | "has lexical unit" |  | "FN" |  |
| fn:traversing | fn:HasLexicalUnit | fn:lu:traversing:jump | "traversing" | "jump" | "has lexical unit" |  | "FN" |  |
| fn:traversing | fn:HasLexicalUnit | fn:lu:traversing:pass | "traversing" | "pass" | "has lexical unit" |  | "FN" |  |
| fn:traversing | fn:HasLexicalUnit | fn:lu:traversing:circle | "traversing" | "circle" | "has lexical unit" |  | "FN" |  |
| fn:traversing | fn:HasLexicalUnit | fn:lu:traversing:hop | "traversing" | "hop" | "has lexical unit" |  | "FN" |  |
| fn:traversing | fn:HasLexicalUnit | fn:lu:traversing:leap | "traversing" | "leap" | "has lexical unit" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:theme | "traversing" | "theme" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:source | "traversing" | "source" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:path | "traversing" | "path" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:goal | "traversing" | "goal" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:manner | "traversing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:distance | "traversing" | "distance" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:area | "traversing" | "area" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:degree | "traversing" | "degree" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:means | "traversing" | "means" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:speed | "traversing" | "speed" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:cotheme | "traversing" | "cotheme" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:depictive | "traversing" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:place | "traversing" | "place" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:path_shape | "traversing" | "path shape" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:direction | "traversing" | "direction" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:time | "traversing" | "time" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:purpose | "traversing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:means_of_motion | "traversing" | "means of motion" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:duration | "traversing" | "duration" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:result | "traversing" | "result" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:explanation | "traversing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:reciprocation | "traversing" | "reciprocation" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:containing_event | "traversing" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:frequency | "traversing" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:re-encoding | "traversing" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:new_situation | "traversing" | "new situation" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:circumstances | "traversing" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:endpoints | "traversing" | "endpoints" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:coordinated_event | "traversing" | "coordinated event" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:period_of_iterations | "traversing" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:event_description | "traversing" | "event description" | "/r/has a" |  | "FN" |  |
| fn:traversing | /r/HasA | fn:fe:iterations | "traversing" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:treating_and_mistreating | /r/IsA | fn:conduct | "treating and mistreating" | "conduct" | "/r/is a" |  | "FN" |  |
| fn:treating_and_mistreating | fn:HasLexicalUnit | fn:lu:treating_and_mistreating:treat | "treating and mistreating" | "treat" | "has lexical unit" |  | "FN" |  |
| fn:treating_and_mistreating | fn:HasLexicalUnit | fn:lu:treating_and_mistreating:mistreat | "treating and mistreating" | "mistreat" | "has lexical unit" |  | "FN" |  |
| fn:treating_and_mistreating | fn:HasLexicalUnit | fn:lu:treating_and_mistreating:use | "treating and mistreating" | "use" | "has lexical unit" |  | "FN" |  |
| fn:treating_and_mistreating | /r/HasA | fn:fe:agent | "treating and mistreating" | "agent" | "/r/has a" |  | "FN" |  |
| fn:treating_and_mistreating | /r/HasA | fn:fe:manner | "treating and mistreating" | "manner" | "/r/has a" |  | "FN" |  |
| fn:treating_and_mistreating | /r/HasA | fn:fe:circumstances | "treating and mistreating" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:treating_and_mistreating | /r/HasA | fn:fe:affected_party | "treating and mistreating" | "affected party" | "/r/has a" |  | "FN" |  |
| fn:treating_and_mistreating | /r/HasA | fn:fe:explanation | "treating and mistreating" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:treating_and_mistreating | /r/HasA | fn:fe:time | "treating and mistreating" | "time" | "/r/has a" |  | "FN" |  |
| fn:treating_and_mistreating | /r/HasA | fn:fe:place | "treating and mistreating" | "place" | "/r/has a" |  | "FN" |  |
| fn:treating_and_mistreating | /r/HasA | fn:fe:means | "treating and mistreating" | "means" | "/r/has a" |  | "FN" |  |
| fn:treating_and_mistreating | /r/HasA | fn:fe:domain | "treating and mistreating" | "domain" | "/r/has a" |  | "FN" |  |
| fn:treating_and_mistreating | /r/HasA | fn:fe:degree | "treating and mistreating" | "degree" | "/r/has a" |  | "FN" |  |
| fn:treating_and_mistreating | /r/HasA | fn:fe:standard | "treating and mistreating" | "standard" | "/r/has a" |  | "FN" |  |
| fn:trendiness | /r/IsA | fn:social_behavior_evaluation | "trendiness" | "social behavior evaluation" | "/r/is a" |  | "FN" |  |
| fn:trendiness | fn:HasLexicalUnit | fn:lu:trendiness:fashionable | "trendiness" | "fashionable" | "has lexical unit" |  | "FN" |  |
| fn:trendiness | fn:HasLexicalUnit | fn:lu:trendiness:trendy | "trendiness" | "trendy" | "has lexical unit" |  | "FN" |  |
| fn:trendiness | fn:HasLexicalUnit | fn:lu:trendiness:hip | "trendiness" | "hip" | "has lexical unit" |  | "FN" |  |
| fn:trendiness | fn:HasLexicalUnit | fn:lu:trendiness:style | "trendiness" | "style" | "has lexical unit" |  | "FN" |  |
| fn:trendiness | fn:HasLexicalUnit | fn:lu:trendiness:fashion | "trendiness" | "fashion" | "has lexical unit" |  | "FN" |  |
| fn:trendiness | fn:HasLexicalUnit | fn:lu:trendiness:chic | "trendiness" | "chic" | "has lexical unit" |  | "FN" |  |
| fn:trendiness | fn:HasLexicalUnit | fn:lu:trendiness:cool | "trendiness" | "cool" | "has lexical unit" |  | "FN" |  |
| fn:trendiness | fn:HasLexicalUnit | fn:lu:trendiness:big | "trendiness" | "big" | "has lexical unit" |  | "FN" |  |
| fn:trendiness | /r/HasA | fn:fe:behavior | "trendiness" | "behavior" | "/r/has a" |  | "FN" |  |
| fn:trendiness | /r/HasA | fn:fe:degree | "trendiness" | "degree" | "/r/has a" |  | "FN" |  |
| fn:trendiness | /r/HasA | fn:fe:time | "trendiness" | "time" | "/r/has a" |  | "FN" |  |
| fn:trendiness | /r/HasA | fn:fe:circumstances | "trendiness" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:trendiness | /r/HasA | fn:fe:evaluee | "trendiness" | "evaluee" | "/r/has a" |  | "FN" |  |
| fn:trendiness | /r/HasA | fn:fe:judge | "trendiness" | "judge" | "/r/has a" |  | "FN" |  |
| fn:trendiness | /r/HasA | fn:fe:place | "trendiness" | "place" | "/r/has a" |  | "FN" |  |
| fn:criminal_process | /r/HasSubevent | fn:trial | "criminal process" | "trial" | "/r/has subevent" |  | "FN" |  |
| fn:trial | /r/HasSubevent | fn:court_examination | "trial" | "court examination" | "/r/has subevent" |  | "FN" |  |
| fn:trial | /r/HasSubevent | fn:jury_deliberation | "trial" | "jury deliberation" | "/r/has subevent" |  | "FN" |  |
| fn:trial | /r/HasSubevent | fn:verdict | "trial" | "verdict" | "/r/has subevent" |  | "FN" |  |
| fn:trial | /r/HasPrerequisite | fn:arraignment | "trial" | "arraignment" | "/r/has prerequisite" |  | "FN" |  |
| fn:sentencing | /r/HasPrerequisite | fn:trial | "sentencing" | "trial" | "/r/has prerequisite" |  | "FN" |  |
| fn:try_defendant | /r/IsA | fn:trial | "try defendant" | "trial" | "/r/is a" |  | "FN" |  |
| fn:trial | fn:HasLexicalUnit | fn:lu:trial:trial | "trial" | "trial" | "has lexical unit" |  | "FN" |  |
| fn:trial | fn:HasLexicalUnit | fn:lu:trial:case | "trial" | "case" | "has lexical unit" |  | "FN" |  |
| fn:trial | /r/HasA | fn:fe:charges | "trial" | "charges" | "/r/has a" |  | "FN" |  |
| fn:trial | /r/HasA | fn:fe:court | "trial" | "court" | "/r/has a" |  | "FN" |  |
| fn:trial | /r/HasA | fn:fe:defense | "trial" | "defense" | "/r/has a" |  | "FN" |  |
| fn:trial | /r/HasA | fn:fe:jury | "trial" | "jury" | "/r/has a" |  | "FN" |  |
| fn:trial | /r/HasA | fn:fe:place | "trial" | "place" | "/r/has a" |  | "FN" |  |
| fn:trial | /r/HasA | fn:fe:prosecution | "trial" | "prosecution" | "/r/has a" |  | "FN" |  |
| fn:trial | /r/HasA | fn:fe:time | "trial" | "time" | "/r/has a" |  | "FN" |  |
| fn:trial | /r/HasA | fn:fe:defendant | "trial" | "defendant" | "/r/has a" |  | "FN" |  |
| fn:trial | /r/HasA | fn:fe:judge | "trial" | "judge" | "/r/has a" |  | "FN" |  |
| fn:trial | /r/HasA | fn:fe:case | "trial" | "case" | "/r/has a" |  | "FN" |  |
| fn:trial | /r/HasA | fn:fe:manner | "trial" | "manner" | "/r/has a" |  | "FN" |  |
| fn:triggering | /r/Causes | fn:getting_triggered | "triggering" | "getting triggered" | "/r/causes" |  | "FN" |  |
| fn:triggering | fn:HasLexicalUnit | fn:lu:triggering:trigger | "triggering" | "trigger" | "has lexical unit" |  | "FN" |  |
| fn:triggering | fn:HasLexicalUnit | fn:lu:triggering:set_off | "triggering" | "set off" | "has lexical unit" |  | "FN" |  |
| fn:triggering | /r/HasA | fn:fe:cause | "triggering" | "cause" | "/r/has a" |  | "FN" |  |
| fn:triggering | /r/HasA | fn:fe:system | "triggering" | "system" | "/r/has a" |  | "FN" |  |
| fn:triggering | /r/HasA | fn:fe:means | "triggering" | "means" | "/r/has a" |  | "FN" |  |
| fn:triggering | /r/HasA | fn:fe:actor | "triggering" | "actor" | "/r/has a" |  | "FN" |  |
| fn:triggering | /r/HasA | fn:fe:manner | "triggering" | "manner" | "/r/has a" |  | "FN" |  |
| fn:triggering | /r/HasA | fn:fe:place | "triggering" | "place" | "/r/has a" |  | "FN" |  |
| fn:triggering | /r/HasA | fn:fe:time | "triggering" | "time" | "/r/has a" |  | "FN" |  |
| fn:triggering | /r/HasA | fn:fe:purpose | "triggering" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:trust | /r/IsA | fn:certainty | "trust" | "certainty" | "/r/is a" |  | "FN" |  |
| fn:trust | fn:HasLexicalUnit | fn:lu:trust:believe | "trust" | "believe" | "has lexical unit" |  | "FN" |  |
| fn:trust | fn:HasLexicalUnit | fn:lu:trust:reliable | "trust" | "reliable" | "has lexical unit" |  | "FN" |  |
| fn:trust | fn:HasLexicalUnit | fn:lu:trust:trustworthy | "trust" | "trustworthy" | "has lexical unit" |  | "FN" |  |
| fn:trust | fn:HasLexicalUnit | fn:lu:trust:credulous | "trust" | "credulous" | "has lexical unit" |  | "FN" |  |
| fn:trust | fn:HasLexicalUnit | fn:lu:trust:trust | "trust" | "trust" | "has lexical unit" |  | "FN" |  |
| fn:trust | fn:HasLexicalUnit | fn:lu:trust:reliability | "trust" | "reliability" | "has lexical unit" |  | "FN" |  |
| fn:trust | fn:HasLexicalUnit | fn:lu:trust:trust | "trust" | "trust" | "has lexical unit" |  | "FN" |  |
| fn:trust | fn:HasLexicalUnit | fn:lu:trust:credence | "trust" | "credence" | "has lexical unit" |  | "FN" |  |
| fn:trust | fn:HasLexicalUnit | fn:lu:trust:gullible | "trust" | "gullible" | "has lexical unit" |  | "FN" |  |
| fn:trust | fn:HasLexicalUnit | fn:lu:trust:faith | "trust" | "faith" | "has lexical unit" |  | "FN" |  |
| fn:trust | /r/HasA | fn:fe:cognizer | "trust" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:trust | /r/HasA | fn:fe:topic | "trust" | "topic" | "/r/has a" |  | "FN" |  |
| fn:trust | /r/HasA | fn:fe:content | "trust" | "content" | "/r/has a" |  | "FN" |  |
| fn:trust | /r/HasA | fn:fe:degree | "trust" | "degree" | "/r/has a" |  | "FN" |  |
| fn:trust | /r/HasA | fn:fe:manner | "trust" | "manner" | "/r/has a" |  | "FN" |  |
| fn:trust | /r/HasA | fn:fe:expressor | "trust" | "expressor" | "/r/has a" |  | "FN" |  |
| fn:trust | /r/HasA | fn:fe:information_source | "trust" | "information source" | "/r/has a" |  | "FN" |  |
| fn:trust | /r/HasA | fn:fe:information | "trust" | "information" | "/r/has a" |  | "FN" |  |
| fn:try_defendant | /r/IsA | fn:trial | "try defendant" | "trial" | "/r/is a" |  | "FN" |  |
| fn:try_defendant | fn:HasLexicalUnit | fn:lu:try_defendant:try | "try defendant" | "try" | "has lexical unit" |  | "FN" |  |
| fn:fe:judge | /r/RelatedTo | fn:fe:governing_authority | "judge" | "governing authority" | "/r/related to" |  | "FN" |  |
| fn:try_defendant | /r/HasA | fn:fe:judge | "try defendant" | "judge" | "/r/has a" |  | "FN" |  |
| fn:try_defendant | /r/HasA | fn:fe:court | "try defendant" | "court" | "/r/has a" |  | "FN" |  |
| fn:try_defendant | /r/HasA | fn:fe:defendant | "try defendant" | "defendant" | "/r/has a" |  | "FN" |  |
| fn:try_defendant | /r/HasA | fn:fe:jury | "try defendant" | "jury" | "/r/has a" |  | "FN" |  |
| fn:try_defendant | /r/HasA | fn:fe:time | "try defendant" | "time" | "/r/has a" |  | "FN" |  |
| fn:try_defendant | /r/HasA | fn:fe:place | "try defendant" | "place" | "/r/has a" |  | "FN" |  |
| fn:try_defendant | /r/HasA | fn:fe:charges | "try defendant" | "charges" | "/r/has a" |  | "FN" |  |
| fn:try_defendant | /r/HasA | fn:fe:governing_authority | "try defendant" | "governing authority" | "/r/has a" |  | "FN" |  |
| fn:try_defendant | /r/HasA | fn:fe:manner | "try defendant" | "manner" | "/r/has a" |  | "FN" |  |
| fn:trying_out | /r/IsA | fn:research | "trying out" | "research" | "/r/is a" |  | "FN" |  |
| fn:tasting | /r/IsA | fn:trying_out | "tasting" | "trying out" | "/r/is a" |  | "FN" |  |
| fn:trying_out | fn:HasLexicalUnit | fn:lu:trying_out:try | "trying out" | "try" | "has lexical unit" |  | "FN" |  |
| fn:trying_out | fn:HasLexicalUnit | fn:lu:trying_out:test_out | "trying out" | "test out" | "has lexical unit" |  | "FN" |  |
| fn:trying_out | fn:HasLexicalUnit | fn:lu:trying_out:try_out | "trying out" | "try out" | "has lexical unit" |  | "FN" |  |
| fn:fe:evaluator | /r/IsA | fn:st:sentient | "evaluator" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:trying_out | /r/HasA | fn:fe:evaluator | "trying out" | "evaluator" | "/r/has a" |  | "FN" |  |
| fn:trying_out | /r/HasA | fn:fe:experience | "trying out" | "experience" | "/r/has a" |  | "FN" |  |
| fn:trying_out | /r/HasA | fn:fe:entity | "trying out" | "entity" | "/r/has a" |  | "FN" |  |
| fn:trying_out | /r/HasA | fn:fe:manner | "trying out" | "manner" | "/r/has a" |  | "FN" |  |
| fn:trying_out | /r/HasA | fn:fe:means | "trying out" | "means" | "/r/has a" |  | "FN" |  |
| fn:trying_out | /r/HasA | fn:fe:purpose | "trying out" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:trying_out | /r/HasA | fn:fe:time | "trying out" | "time" | "/r/has a" |  | "FN" |  |
| fn:trying_out | /r/HasA | fn:fe:place | "trying out" | "place" | "/r/has a" |  | "FN" |  |
| fn:coming_to_believe | /r/UsedFor | fn:turning_out | "coming to believe" | "turning out" | "/r/used for" |  | "FN" |  |
| fn:turning_out | fn:HasLexicalUnit | fn:lu:turning_out:prove | "turning out" | "prove" | "has lexical unit" |  | "FN" |  |
| fn:turning_out | fn:HasLexicalUnit | fn:lu:turning_out:turn_out | "turning out" | "turn out" | "has lexical unit" |  | "FN" |  |
| fn:turning_out | fn:HasLexicalUnit | fn:lu:turning_out:end_up | "turning out" | "end up" | "has lexical unit" |  | "FN" |  |
| fn:turning_out | /r/HasA | fn:fe:state_of_affairs | "turning out" | "state of affairs" | "/r/has a" |  | "FN" |  |
| fn:turning_out | /r/HasA | fn:fe:time | "turning out" | "time" | "/r/has a" |  | "FN" |  |
| fn:biological_classification | /r/IsA | fn:type | "biological classification" | "type" | "/r/is a" |  | "FN" |  |
| fn:type | /r/UsedFor | fn:diversity | "type" | "diversity" | "/r/used for" |  | "FN" |  |
| fn:type | fn:HasLexicalUnit | fn:lu:type:type | "type" | "type" | "has lexical unit" |  | "FN" |  |
| fn:type | fn:HasLexicalUnit | fn:lu:type:class | "type" | "class" | "has lexical unit" |  | "FN" |  |
| fn:type | fn:HasLexicalUnit | fn:lu:type:kind | "type" | "kind" | "has lexical unit" |  | "FN" |  |
| fn:type | fn:HasLexicalUnit | fn:lu:type:sort | "type" | "sort" | "has lexical unit" |  | "FN" |  |
| fn:type | fn:HasLexicalUnit | fn:lu:type:variety | "type" | "variety" | "has lexical unit" |  | "FN" |  |
| fn:type | fn:HasLexicalUnit | fn:lu:type:strain | "type" | "strain" | "has lexical unit" |  | "FN" |  |
| fn:type | fn:HasLexicalUnit | fn:lu:type:breed | "type" | "breed" | "has lexical unit" |  | "FN" |  |
| fn:type | fn:HasLexicalUnit | fn:lu:type:ilk | "type" | "ilk" | "has lexical unit" |  | "FN" |  |
| fn:type | fn:HasLexicalUnit | fn:lu:type:make | "type" | "make" | "has lexical unit" |  | "FN" |  |
| fn:type | fn:HasLexicalUnit | fn:lu:type:race | "type" | "race" | "has lexical unit" |  | "FN" |  |
| fn:type | fn:HasLexicalUnit | fn:lu:type:brand | "type" | "brand" | "has lexical unit" |  | "FN" |  |
| fn:type | fn:HasLexicalUnit | fn:lu:type:form | "type" | "form" | "has lexical unit" |  | "FN" |  |
| fn:type | fn:HasLexicalUnit | fn:lu:type:shade | "type" | "shade" | "has lexical unit" |  | "FN" |  |
| fn:type | fn:HasLexicalUnit | fn:lu:type:version | "type" | "version" | "has lexical unit" |  | "FN" |  |
| fn:type | /r/HasA | fn:fe:subtype | "type" | "subtype" | "/r/has a" |  | "FN" |  |
| fn:type | /r/HasA | fn:fe:category | "type" | "category" | "/r/has a" |  | "FN" |  |
| fn:type | /r/HasA | fn:fe:type_property | "type" | "type property" | "/r/has a" |  | "FN" |  |
| fn:type | /r/HasA | fn:fe:item_property | "type" | "item property" | "/r/has a" |  | "FN" |  |
| fn:typicality | /r/IsA | fn:gradable_attributes | "typicality" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:similarity | /r/UsedFor | fn:typicality | "similarity" | "typicality" | "/r/used for" |  | "FN" |  |
| fn:typicality | /r/RelatedTo | fn:idiosyncrasy | "typicality" | "idiosyncrasy" | "/r/related to" |  | "FN" |  |
| fn:typicality | /r/IsA | fn:instance | "typicality" | "instance" | "/r/is a" |  | "FN" |  |
| fn:typicality | fn:HasLexicalUnit | fn:lu:typicality:normal | "typicality" | "normal" | "has lexical unit" |  | "FN" |  |
| fn:typicality | fn:HasLexicalUnit | fn:lu:typicality:unusual | "typicality" | "unusual" | "has lexical unit" |  | "FN" |  |
| fn:typicality | fn:HasLexicalUnit | fn:lu:typicality:ordinary | "typicality" | "ordinary" | "has lexical unit" |  | "FN" |  |
| fn:typicality | fn:HasLexicalUnit | fn:lu:typicality:average | "typicality" | "average" | "has lexical unit" |  | "FN" |  |
| fn:typicality | fn:HasLexicalUnit | fn:lu:typicality:odd | "typicality" | "odd" | "has lexical unit" |  | "FN" |  |
| fn:typicality | fn:HasLexicalUnit | fn:lu:typicality:commonplace | "typicality" | "commonplace" | "has lexical unit" |  | "FN" |  |
| fn:typicality | fn:HasLexicalUnit | fn:lu:typicality:vanilla | "typicality" | "vanilla" | "has lexical unit" |  | "FN" |  |
| fn:typicality | fn:HasLexicalUnit | fn:lu:typicality:curious | "typicality" | "curious" | "has lexical unit" |  | "FN" |  |
| fn:typicality | fn:HasLexicalUnit | fn:lu:typicality:common | "typicality" | "common" | "has lexical unit" |  | "FN" |  |
| fn:typicality | fn:HasLexicalUnit | fn:lu:typicality:typically | "typicality" | "typically" | "has lexical unit" |  | "FN" |  |
| fn:typicality | fn:HasLexicalUnit | fn:lu:typicality:abnormal | "typicality" | "abnormal" | "has lexical unit" |  | "FN" |  |
| fn:typicality | fn:HasLexicalUnit | fn:lu:typicality:irregularity | "typicality" | "irregularity" | "has lexical unit" |  | "FN" |  |
| fn:typicality | fn:HasLexicalUnit | fn:lu:typicality:conventional | "typicality" | "conventional" | "has lexical unit" |  | "FN" |  |
| fn:typicality | /r/HasA | fn:fe:degree | "typicality" | "degree" | "/r/has a" |  | "FN" |  |
| fn:typicality | /r/HasA | fn:fe:state_of_affairs | "typicality" | "state of affairs" | "/r/has a" |  | "FN" |  |
| fn:typicality | /r/HasA | fn:fe:comparison_set | "typicality" | "comparison set" | "/r/has a" |  | "FN" |  |
| fn:typicality | /r/HasA | fn:fe:feature | "typicality" | "feature" | "/r/has a" |  | "FN" |  |
| fn:statement | /r/UsedFor | fn:unattributed_information | "statement" | "unattributed information" | "/r/used for" |  | "FN" |  |
| fn:unattributed_information | fn:HasLexicalUnit | fn:lu:unattributed_information:purported | "unattributed information" | "purported" | "has lexical unit" |  | "FN" |  |
| fn:unattributed_information | fn:HasLexicalUnit | fn:lu:unattributed_information:purportedly | "unattributed information" | "purportedly" | "has lexical unit" |  | "FN" |  |
| fn:unattributed_information | fn:HasLexicalUnit | fn:lu:unattributed_information:allegedly | "unattributed information" | "allegedly" | "has lexical unit" |  | "FN" |  |
| fn:unattributed_information | fn:HasLexicalUnit | fn:lu:unattributed_information:alleged | "unattributed information" | "alleged" | "has lexical unit" |  | "FN" |  |
| fn:unattributed_information | fn:HasLexicalUnit | fn:lu:unattributed_information:ostensibly | "unattributed information" | "ostensibly" | "has lexical unit" |  | "FN" |  |
| fn:unattributed_information | fn:HasLexicalUnit | fn:lu:unattributed_information:ostensible | "unattributed information" | "ostensible" | "has lexical unit" |  | "FN" |  |
| fn:unattributed_information | fn:HasLexicalUnit | fn:lu:unattributed_information:reportedly | "unattributed information" | "reportedly" | "has lexical unit" |  | "FN" |  |
| fn:unattributed_information | fn:HasLexicalUnit | fn:lu:unattributed_information:rumor | "unattributed information" | "rumor" | "has lexical unit" |  | "FN" |  |
| fn:unattributed_information | fn:HasLexicalUnit | fn:lu:unattributed_information:rumor | "unattributed information" | "rumor" | "has lexical unit" |  | "FN" |  |
| fn:unattributed_information | fn:HasLexicalUnit | fn:lu:unattributed_information:supposedly | "unattributed information" | "supposedly" | "has lexical unit" |  | "FN" |  |
| fn:unattributed_information | fn:HasLexicalUnit | fn:lu:unattributed_information:proverbial | "unattributed information" | "proverbial" | "has lexical unit" |  | "FN" |  |
| fn:unattributed_information | /r/HasA | fn:fe:reported_fact | "unattributed information" | "reported fact" | "/r/has a" |  | "FN" |  |
| fn:unattributed_information | /r/HasA | fn:fe:time | "unattributed information" | "time" | "/r/has a" |  | "FN" |  |
| fn:unattributed_information | /r/HasA | fn:fe:duration | "unattributed information" | "duration" | "/r/has a" |  | "FN" |  |
| fn:unattributed_information | /r/HasA | fn:fe:explanation | "unattributed information" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:undergo_change | /r/IsA | fn:transition_to_state | "undergo change" | "transition to state" | "/r/is a" |  | "FN" |  |
| fn:improvement_or_decline | /r/IsA | fn:undergo_change | "improvement or decline" | "undergo change" | "/r/is a" |  | "FN" |  |
| fn:nuclear_process | /r/IsA | fn:undergo_change | "nuclear process" | "undergo change" | "/r/is a" |  | "FN" |  |
| fn:undergo_transformation | /r/IsA | fn:undergo_change | "undergo transformation" | "undergo change" | "/r/is a" |  | "FN" |  |
| fn:undergo_change | /r/UsedFor | fn:progression | "undergo change" | "progression" | "/r/used for" |  | "FN" |  |
| fn:transition_to_state | /r/RelatedTo | fn:undergo_change | "transition to state" | "undergo change" | "/r/related to" |  | "FN" |  |
| fn:traversing | /r/SimilarTo | fn:undergo_change | "traversing" | "undergo change" | "/r/similar to" |  | "FN" |  |
| fn:undergo_change | /r/SimilarTo | fn:undergo_transformation | "undergo change" | "undergo transformation" | "/r/similar to" |  | "FN" |  |
| fn:cause_change | /r/Causes | fn:undergo_change | "cause change" | "undergo change" | "/r/causes" |  | "FN" |  |
| fn:undergo_change | fn:HasLexicalUnit | fn:lu:undergo_change:change | "undergo change" | "change" | "has lexical unit" |  | "FN" |  |
| fn:undergo_change | fn:HasLexicalUnit | fn:lu:undergo_change:turn | "undergo change" | "turn" | "has lexical unit" |  | "FN" |  |
| fn:undergo_change | fn:HasLexicalUnit | fn:lu:undergo_change:change | "undergo change" | "change" | "has lexical unit" |  | "FN" |  |
| fn:undergo_change | fn:HasLexicalUnit | fn:lu:undergo_change:veer | "undergo change" | "veer" | "has lexical unit" |  | "FN" |  |
| fn:undergo_change | fn:HasLexicalUnit | fn:lu:undergo_change:swing | "undergo change" | "swing" | "has lexical unit" |  | "FN" |  |
| fn:undergo_change | fn:HasLexicalUnit | fn:lu:undergo_change:plummet | "undergo change" | "plummet" | "has lexical unit" |  | "FN" |  |
| fn:undergo_change | fn:HasLexicalUnit | fn:lu:undergo_change:changeable | "undergo change" | "changeable" | "has lexical unit" |  | "FN" |  |
| fn:undergo_change | fn:HasLexicalUnit | fn:lu:undergo_change:shift | "undergo change" | "shift" | "has lexical unit" |  | "FN" |  |
| fn:undergo_change | fn:HasLexicalUnit | fn:lu:undergo_change:shift | "undergo change" | "shift" | "has lexical unit" |  | "FN" |  |
| fn:undergo_change | fn:HasLexicalUnit | fn:lu:undergo_change:transition | "undergo change" | "transition" | "has lexical unit" |  | "FN" |  |
| fn:undergo_change | fn:HasLexicalUnit | fn:lu:undergo_change:go | "undergo change" | "go" | "has lexical unit" |  | "FN" |  |
| fn:undergo_change | /r/HasA | fn:fe:entity | "undergo change" | "entity" | "/r/has a" |  | "FN" |  |
| fn:fe:final_category | /r/RelatedTo | fn:fe:initial_quality | "final category" | "initial quality" | "/r/related to" |  | "FN" |  |
| fn:undergo_change | /r/HasA | fn:fe:final_category | "undergo change" | "final category" | "/r/has a" |  | "FN" |  |
| fn:undergo_change | /r/HasA | fn:fe:initial_category | "undergo change" | "initial category" | "/r/has a" |  | "FN" |  |
| fn:undergo_change | /r/HasA | fn:fe:time | "undergo change" | "time" | "/r/has a" |  | "FN" |  |
| fn:fe:initial_quality | /r/RelatedTo | fn:fe:initial_category | "initial quality" | "initial category" | "/r/related to" |  | "FN" |  |
| fn:undergo_change | /r/HasA | fn:fe:initial_quality | "undergo change" | "initial quality" | "/r/has a" |  | "FN" |  |
| fn:fe:final_quality | /r/RelatedTo | fn:fe:initial_category | "final quality" | "initial category" | "/r/related to" |  | "FN" |  |
| fn:undergo_change | /r/HasA | fn:fe:final_quality | "undergo change" | "final quality" | "/r/has a" |  | "FN" |  |
| fn:fe:attribute | /r/RelatedTo | fn:fe:initial_category | "attribute" | "initial category" | "/r/related to" |  | "FN" |  |
| fn:undergo_change | /r/HasA | fn:fe:attribute | "undergo change" | "attribute" | "/r/has a" |  | "FN" |  |
| fn:undergo_change | /r/HasA | fn:fe:manner | "undergo change" | "manner" | "/r/has a" |  | "FN" |  |
| fn:undergo_change | /r/HasA | fn:fe:degree | "undergo change" | "degree" | "/r/has a" |  | "FN" |  |
| fn:undergo_change | /r/HasA | fn:fe:circumstances | "undergo change" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:undergo_change | /r/HasA | fn:fe:cause | "undergo change" | "cause" | "/r/has a" |  | "FN" |  |
| fn:undergo_change | /r/HasA | fn:fe:intermediate_value | "undergo change" | "intermediate value" | "/r/has a" |  | "FN" |  |
| fn:fe:value_range | /r/RelatedTo | fn:fe:final_quality | "value range" | "final quality" | "/r/related to" |  | "FN" |  |
| fn:undergo_change | /r/HasA | fn:fe:value_range | "undergo change" | "value range" | "/r/has a" |  | "FN" |  |
| fn:undergo_change | /r/HasA | fn:fe:frequency | "undergo change" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:undergo_change | /r/HasA | fn:fe:period_of_iterations | "undergo change" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:undergo_change | /r/HasA | fn:fe:place | "undergo change" | "place" | "/r/has a" |  | "FN" |  |
| fn:undergo_change | /r/HasA | fn:fe:final_situation | "undergo change" | "final situation" | "/r/has a" |  | "FN" |  |
| fn:undergo_change | /r/HasA | fn:fe:initial_situation | "undergo change" | "initial situation" | "/r/has a" |  | "FN" |  |
| fn:undergo_transformation | /r/IsA | fn:undergo_change | "undergo transformation" | "undergo change" | "/r/is a" |  | "FN" |  |
| fn:undergo_change | /r/SimilarTo | fn:undergo_transformation | "undergo change" | "undergo transformation" | "/r/similar to" |  | "FN" |  |
| fn:undergo_transformation | fn:HasLexicalUnit | fn:lu:undergo_transformation:metamorphosis | "undergo transformation" | "metamorphosis" | "has lexical unit" |  | "FN" |  |
| fn:undergo_transformation | fn:HasLexicalUnit | fn:lu:undergo_transformation:transform | "undergo transformation" | "transform" | "has lexical unit" |  | "FN" |  |
| fn:undergo_transformation | fn:HasLexicalUnit | fn:lu:undergo_transformation:transformation | "undergo transformation" | "transformation" | "has lexical unit" |  | "FN" |  |
| fn:undergo_transformation | fn:HasLexicalUnit | fn:lu:undergo_transformation:metamorphose | "undergo transformation" | "metamorphose" | "has lexical unit" |  | "FN" |  |
| fn:undergo_transformation | fn:HasLexicalUnit | fn:lu:undergo_transformation:transmutation | "undergo transformation" | "transmutation" | "has lexical unit" |  | "FN" |  |
| fn:undergo_transformation | fn:HasLexicalUnit | fn:lu:undergo_transformation:transmute | "undergo transformation" | "transmute" | "has lexical unit" |  | "FN" |  |
| fn:undergo_transformation | fn:HasLexicalUnit | fn:lu:undergo_transformation:convert | "undergo transformation" | "convert" | "has lexical unit" |  | "FN" |  |
| fn:undergo_transformation | fn:HasLexicalUnit | fn:lu:undergo_transformation:conversion | "undergo transformation" | "conversion" | "has lexical unit" |  | "FN" |  |
| fn:undergo_transformation | fn:HasLexicalUnit | fn:lu:undergo_transformation:transmogrify | "undergo transformation" | "transmogrify" | "has lexical unit" |  | "FN" |  |
| fn:undergo_transformation | fn:HasLexicalUnit | fn:lu:undergo_transformation:transubstantiate | "undergo transformation" | "transubstantiate" | "has lexical unit" |  | "FN" |  |
| fn:undergo_transformation | fn:HasLexicalUnit | fn:lu:undergo_transformation:transubstantiation | "undergo transformation" | "transubstantiation" | "has lexical unit" |  | "FN" |  |
| fn:undergo_transformation | fn:HasLexicalUnit | fn:lu:undergo_transformation:transition | "undergo transformation" | "transition" | "has lexical unit" |  | "FN" |  |
| fn:undergo_transformation | /r/HasA | fn:fe:entity | "undergo transformation" | "entity" | "/r/has a" |  | "FN" |  |
| fn:undergo_transformation | /r/HasA | fn:fe:final_category | "undergo transformation" | "final category" | "/r/has a" |  | "FN" |  |
| fn:undergo_transformation | /r/HasA | fn:fe:initial_category | "undergo transformation" | "initial category" | "/r/has a" |  | "FN" |  |
| fn:undergo_transformation | /r/HasA | fn:fe:time | "undergo transformation" | "time" | "/r/has a" |  | "FN" |  |
| fn:undergo_transformation | /r/HasA | fn:fe:manner | "undergo transformation" | "manner" | "/r/has a" |  | "FN" |  |
| fn:undergo_transformation | /r/HasA | fn:fe:degree | "undergo transformation" | "degree" | "/r/has a" |  | "FN" |  |
| fn:undergo_transformation | /r/HasA | fn:fe:circumstances | "undergo transformation" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:undergo_transformation | /r/HasA | fn:fe:cause | "undergo transformation" | "cause" | "/r/has a" |  | "FN" |  |
| fn:undergo_transformation | /r/HasA | fn:fe:frequency | "undergo transformation" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:undergo_transformation | /r/HasA | fn:fe:period_of_iterations | "undergo transformation" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:undergo_transformation | /r/HasA | fn:fe:place | "undergo transformation" | "place" | "/r/has a" |  | "FN" |  |
| fn:undergoing | /r/IsA | fn:event | "undergoing" | "event" | "/r/is a" |  | "FN" |  |
| fn:eventive_affecting | /r/UsedFor | fn:undergoing | "eventive affecting" | "undergoing" | "/r/used for" |  | "FN" |  |
| fn:undergoing | /r/SimilarTo | fn:catastrophe | "undergoing" | "catastrophe" | "/r/similar to" |  | "FN" |  |
| fn:undergoing | /r/IsA | fn:undergoing_scenario | "undergoing" | "undergoing scenario" | "/r/is a" |  | "FN" |  |
| fn:undergoing | fn:HasLexicalUnit | fn:lu:undergoing:undergo | "undergoing" | "undergo" | "has lexical unit" |  | "FN" |  |
| fn:undergoing | fn:HasLexicalUnit | fn:lu:undergoing:experience | "undergoing" | "experience" | "has lexical unit" |  | "FN" |  |
| fn:undergoing | /r/HasA | fn:fe:entity | "undergoing" | "entity" | "/r/has a" |  | "FN" |  |
| fn:undergoing | /r/HasA | fn:fe:event | "undergoing" | "event" | "/r/has a" |  | "FN" |  |
| fn:undergoing | /r/HasA | fn:fe:time | "undergoing" | "time" | "/r/has a" |  | "FN" |  |
| fn:undergoing | /r/HasA | fn:fe:place | "undergoing" | "place" | "/r/has a" |  | "FN" |  |
| fn:undergoing | /r/HasA | fn:fe:explanation | "undergoing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:undergoing | /r/HasA | fn:fe:purpose | "undergoing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:undergoing | /r/HasA | fn:fe:manner | "undergoing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:undergoing | /r/HasA | fn:fe:circumstances | "undergoing" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:eventive_affecting | /r/IsA | fn:undergoing_scenario | "eventive affecting" | "undergoing scenario" | "/r/is a" |  | "FN" |  |
| fn:undergoing | /r/IsA | fn:undergoing_scenario | "undergoing" | "undergoing scenario" | "/r/is a" |  | "FN" |  |
| fn:undergoing_scenario | /r/HasA | fn:fe:entity | "undergoing scenario" | "entity" | "/r/has a" |  | "FN" |  |
| fn:undergoing_scenario | /r/HasA | fn:fe:event | "undergoing scenario" | "event" | "/r/has a" |  | "FN" |  |
| fn:undergoing_scenario | /r/HasA | fn:fe:time | "undergoing scenario" | "time" | "/r/has a" |  | "FN" |  |
| fn:undergoing_scenario | /r/HasA | fn:fe:place | "undergoing scenario" | "place" | "/r/has a" |  | "FN" |  |
| fn:undergoing_scenario | /r/HasA | fn:fe:explanation | "undergoing scenario" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:undergoing_scenario | /r/HasA | fn:fe:purpose | "undergoing scenario" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:undergoing_scenario | /r/HasA | fn:fe:circumstances | "undergoing scenario" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:accoutrements | /r/UsedFor | fn:undressing | "accoutrements" | "undressing" | "/r/used for" |  | "FN" |  |
| fn:clothing | /r/UsedFor | fn:undressing | "clothing" | "undressing" | "/r/used for" |  | "FN" |  |
| fn:removing | /r/UsedFor | fn:undressing | "removing" | "undressing" | "/r/used for" |  | "FN" |  |
| fn:undressing | fn:HasLexicalUnit | fn:lu:undressing:doff | "undressing" | "doff" | "has lexical unit" |  | "FN" |  |
| fn:undressing | fn:HasLexicalUnit | fn:lu:undressing:take_off | "undressing" | "take off" | "has lexical unit" |  | "FN" |  |
| fn:undressing | fn:HasLexicalUnit | fn:lu:undressing:slip | "undressing" | "slip" | "has lexical unit" |  | "FN" |  |
| fn:undressing | fn:HasLexicalUnit | fn:lu:undressing:kick_off | "undressing" | "kick off" | "has lexical unit" |  | "FN" |  |
| fn:undressing | fn:HasLexicalUnit | fn:lu:undressing:peel_off | "undressing" | "peel off" | "has lexical unit" |  | "FN" |  |
| fn:undressing | fn:HasLexicalUnit | fn:lu:undressing:pull_off | "undressing" | "pull off" | "has lexical unit" |  | "FN" |  |
| fn:undressing | fn:HasLexicalUnit | fn:lu:undressing:remove | "undressing" | "remove" | "has lexical unit" |  | "FN" |  |
| fn:undressing | fn:HasLexicalUnit | fn:lu:undressing:shed | "undressing" | "shed" | "has lexical unit" |  | "FN" |  |
| fn:undressing | fn:HasLexicalUnit | fn:lu:undressing:strip_off | "undressing" | "strip off" | "has lexical unit" |  | "FN" |  |
| fn:undressing | fn:HasLexicalUnit | fn:lu:undressing:throw_off | "undressing" | "throw off" | "has lexical unit" |  | "FN" |  |
| fn:undressing | /r/HasA | fn:fe:wearer | "undressing" | "wearer" | "/r/has a" |  | "FN" |  |
| fn:undressing | /r/HasA | fn:fe:clothing | "undressing" | "clothing" | "/r/has a" |  | "FN" |  |
| fn:fe:body_location | /r/IsA | fn:st:source | "body location" | "source" | "/r/is a" |  | "FN" |  |
| fn:undressing | /r/HasA | fn:fe:body_location | "undressing" | "body location" | "/r/has a" |  | "FN" |  |
| fn:undressing | /r/HasA | fn:fe:manner | "undressing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:undressing | /r/HasA | fn:fe:means | "undressing" | "means" | "/r/has a" |  | "FN" |  |
| fn:undressing | /r/HasA | fn:fe:result | "undressing" | "result" | "/r/has a" |  | "FN" |  |
| fn:undressing | /r/HasA | fn:fe:degree | "undressing" | "degree" | "/r/has a" |  | "FN" |  |
| fn:undressing | /r/HasA | fn:fe:place | "undressing" | "place" | "/r/has a" |  | "FN" |  |
| fn:undressing | /r/HasA | fn:fe:time | "undressing" | "time" | "/r/has a" |  | "FN" |  |
| fn:undressing | /r/HasA | fn:fe:purpose | "undressing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:undressing | /r/HasA | fn:fe:circumstances | "undressing" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:undressing | /r/HasA | fn:fe:explanation | "undressing" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:unemployment_rate | /r/IsA | fn:measurable_attributes | "unemployment rate" | "measurable attributes" | "/r/is a" |  | "FN" |  |
| fn:unemployment_rate | fn:HasLexicalUnit | fn:lu:unemployment_rate:unemployment | "unemployment rate" | "unemployment" | "has lexical unit" |  | "FN" |  |
| fn:unemployment_rate | fn:HasLexicalUnit | fn:lu:unemployment_rate:joblessness | "unemployment rate" | "joblessness" | "has lexical unit" |  | "FN" |  |
| fn:unemployment_rate | fn:HasLexicalUnit | fn:lu:unemployment_rate:employment | "unemployment rate" | "employment" | "has lexical unit" |  | "FN" |  |
| fn:unemployment_rate | /r/HasA | fn:fe:individuals | "unemployment rate" | "individuals" | "/r/has a" |  | "FN" |  |
| fn:unemployment_rate | /r/HasA | fn:fe:employment | "unemployment rate" | "employment" | "/r/has a" |  | "FN" |  |
| fn:unemployment_rate | /r/HasA | fn:fe:value | "unemployment rate" | "value" | "/r/has a" |  | "FN" |  |
| fn:unemployment_rate | /r/HasA | fn:fe:degree | "unemployment rate" | "degree" | "/r/has a" |  | "FN" |  |
| fn:unemployment_rate | /r/HasA | fn:fe:time | "unemployment rate" | "time" | "/r/has a" |  | "FN" |  |
| fn:unemployment_rate | /r/HasA | fn:fe:group | "unemployment rate" | "group" | "/r/has a" |  | "FN" |  |
| fn:unemployment_rate | /r/HasA | fn:fe:place | "unemployment rate" | "place" | "/r/has a" |  | "FN" |  |
| fn:use_firearm | /r/IsA | fn:using | "use firearm" | "using" | "/r/is a" |  | "FN" |  |
| fn:use_firearm | /r/UsedFor | fn:shoot_projectiles | "use firearm" | "shoot projectiles" | "/r/used for" |  | "FN" |  |
| fn:use_firearm | /r/IsA | fn:shooting_scenario | "use firearm" | "shooting scenario" | "/r/is a" |  | "FN" |  |
| fn:use_firearm | fn:HasLexicalUnit | fn:lu:use_firearm:shoot | "use firearm" | "shoot" | "has lexical unit" |  | "FN" |  |
| fn:use_firearm | fn:HasLexicalUnit | fn:lu:use_firearm:fire | "use firearm" | "fire" | "has lexical unit" |  | "FN" |  |
| fn:use_firearm | fn:HasLexicalUnit | fn:lu:use_firearm:discharge | "use firearm" | "discharge" | "has lexical unit" |  | "FN" |  |
| fn:use_firearm | fn:HasLexicalUnit | fn:lu:use_firearm:shot | "use firearm" | "shot" | "has lexical unit" |  | "FN" |  |
| fn:use_firearm | /r/HasA | fn:fe:agent | "use firearm" | "agent" | "/r/has a" |  | "FN" |  |
| fn:use_firearm | /r/HasA | fn:fe:firearm | "use firearm" | "firearm" | "/r/has a" |  | "FN" |  |
| fn:use_firearm | /r/HasA | fn:fe:means | "use firearm" | "means" | "/r/has a" |  | "FN" |  |
| fn:use_firearm | /r/HasA | fn:fe:manner | "use firearm" | "manner" | "/r/has a" |  | "FN" |  |
| fn:use_firearm | /r/HasA | fn:fe:place | "use firearm" | "place" | "/r/has a" |  | "FN" |  |
| fn:use_firearm | /r/HasA | fn:fe:purpose | "use firearm" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:use_firearm | /r/HasA | fn:fe:time | "use firearm" | "time" | "/r/has a" |  | "FN" |  |
| fn:use_firearm | /r/HasA | fn:fe:goal | "use firearm" | "goal" | "/r/has a" |  | "FN" |  |
| fn:use_firearm | /r/HasA | fn:fe:path | "use firearm" | "path" | "/r/has a" |  | "FN" |  |
| fn:use_firearm | /r/HasA | fn:fe:source | "use firearm" | "source" | "/r/has a" |  | "FN" |  |
| fn:use_firearm | /r/HasA | fn:fe:area | "use firearm" | "area" | "/r/has a" |  | "FN" |  |
| fn:use_firearm | /r/HasA | fn:fe:iterations | "use firearm" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:use_firearm | /r/HasA | fn:fe:depictive | "use firearm" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:operate_vehicle | /r/IsA | fn:use_vehicle | "operate vehicle" | "use vehicle" | "/r/is a" |  | "FN" |  |
| fn:ride_vehicle | /r/IsA | fn:use_vehicle | "ride vehicle" | "use vehicle" | "/r/is a" |  | "FN" |  |
| fn:use_vehicle | /r/HasA | fn:fe:theme | "use vehicle" | "theme" | "/r/has a" |  | "FN" |  |
| fn:use_vehicle | /r/HasA | fn:fe:vehicle | "use vehicle" | "vehicle" | "/r/has a" |  | "FN" |  |
| fn:use_vehicle | /r/HasA | fn:fe:source | "use vehicle" | "source" | "/r/has a" |  | "FN" |  |
| fn:use_vehicle | /r/HasA | fn:fe:manner | "use vehicle" | "manner" | "/r/has a" |  | "FN" |  |
| fn:use_vehicle | /r/HasA | fn:fe:path | "use vehicle" | "path" | "/r/has a" |  | "FN" |  |
| fn:use_vehicle | /r/HasA | fn:fe:goal | "use vehicle" | "goal" | "/r/has a" |  | "FN" |  |
| fn:use_vehicle | /r/HasA | fn:fe:distance | "use vehicle" | "distance" | "/r/has a" |  | "FN" |  |
| fn:use_vehicle | /r/HasA | fn:fe:duration | "use vehicle" | "duration" | "/r/has a" |  | "FN" |  |
| fn:use_vehicle | /r/HasA | fn:fe:speed | "use vehicle" | "speed" | "/r/has a" |  | "FN" |  |
| fn:use_vehicle | /r/HasA | fn:fe:area | "use vehicle" | "area" | "/r/has a" |  | "FN" |  |
| fn:use_vehicle | /r/HasA | fn:fe:road | "use vehicle" | "road" | "/r/has a" |  | "FN" |  |
| fn:use_vehicle | /r/HasA | fn:fe:route | "use vehicle" | "route" | "/r/has a" |  | "FN" |  |
| fn:use_vehicle | /r/HasA | fn:fe:time | "use vehicle" | "time" | "/r/has a" |  | "FN" |  |
| fn:use_vehicle | /r/HasA | fn:fe:cotheme | "use vehicle" | "cotheme" | "/r/has a" |  | "FN" |  |
| fn:use_vehicle | /r/HasA | fn:fe:driver | "use vehicle" | "driver" | "/r/has a" |  | "FN" |  |
| fn:used_up | /r/IsA | fn:position_on_a_scale | "used up" | "position on a scale" | "/r/is a" |  | "FN" |  |
| fn:expend_resource | /r/Causes | fn:used_up | "expend resource" | "used up" | "/r/causes" |  | "FN" |  |
| fn:used_up | fn:HasLexicalUnit | fn:lu:used_up:spent | "used up" | "spent" | "has lexical unit" |  | "FN" |  |
| fn:used_up | fn:HasLexicalUnit | fn:lu:used_up:worn_out | "used up" | "worn out" | "has lexical unit" |  | "FN" |  |
| fn:used_up | fn:HasLexicalUnit | fn:lu:used_up:depleted | "used up" | "depleted" | "has lexical unit" |  | "FN" |  |
| fn:used_up | fn:HasLexicalUnit | fn:lu:used_up:used_up | "used up" | "used up" | "has lexical unit" |  | "FN" |  |
| fn:used_up | fn:HasLexicalUnit | fn:lu:used_up:exhausted | "used up" | "exhausted" | "has lexical unit" |  | "FN" |  |
| fn:used_up | fn:HasLexicalUnit | fn:lu:used_up:through | "used up" | "through" | "has lexical unit" |  | "FN" |  |
| fn:used_up | /r/HasA | fn:fe:resource | "used up" | "resource" | "/r/has a" |  | "FN" |  |
| fn:used_up | /r/HasA | fn:fe:degree | "used up" | "degree" | "/r/has a" |  | "FN" |  |
| fn:used_up | /r/HasA | fn:fe:explanation | "used up" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:used_up | /r/HasA | fn:fe:excess | "used up" | "excess" | "/r/has a" |  | "FN" |  |
| fn:used_up | /r/HasA | fn:fe:subregion | "used up" | "subregion" | "/r/has a" |  | "FN" |  |
| fn:usefulness | /r/IsA | fn:gradable_attributes | "usefulness" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:capability | /r/UsedFor | fn:usefulness | "capability" | "usefulness" | "/r/used for" |  | "FN" |  |
| fn:using | /r/UsedFor | fn:usefulness | "using" | "usefulness" | "/r/used for" |  | "FN" |  |
| fn:desirability | /r/SimilarTo | fn:usefulness | "desirability" | "usefulness" | "/r/similar to" |  | "FN" |  |
| fn:usefulness | fn:HasLexicalUnit | fn:lu:usefulness:good | "usefulness" | "good" | "has lexical unit" |  | "FN" |  |
| fn:usefulness | fn:HasLexicalUnit | fn:lu:usefulness:effective | "usefulness" | "effective" | "has lexical unit" |  | "FN" |  |
| fn:usefulness | fn:HasLexicalUnit | fn:lu:usefulness:excellent | "usefulness" | "excellent" | "has lexical unit" |  | "FN" |  |
| fn:usefulness | fn:HasLexicalUnit | fn:lu:usefulness:outstanding | "usefulness" | "outstanding" | "has lexical unit" |  | "FN" |  |
| fn:usefulness | fn:HasLexicalUnit | fn:lu:usefulness:superb | "usefulness" | "superb" | "has lexical unit" |  | "FN" |  |
| fn:usefulness | fn:HasLexicalUnit | fn:lu:usefulness:wonderful | "usefulness" | "wonderful" | "has lexical unit" |  | "FN" |  |
| fn:usefulness | fn:HasLexicalUnit | fn:lu:usefulness:fantastic | "usefulness" | "fantastic" | "has lexical unit" |  | "FN" |  |
| fn:usefulness | fn:HasLexicalUnit | fn:lu:usefulness:fine | "usefulness" | "fine" | "has lexical unit" |  | "FN" |  |
| fn:usefulness | fn:HasLexicalUnit | fn:lu:usefulness:tremendous | "usefulness" | "tremendous" | "has lexical unit" |  | "FN" |  |
| fn:usefulness | fn:HasLexicalUnit | fn:lu:usefulness:terrific | "usefulness" | "terrific" | "has lexical unit" |  | "FN" |  |
| fn:usefulness | fn:HasLexicalUnit | fn:lu:usefulness:marvellous | "usefulness" | "marvellous" | "has lexical unit" |  | "FN" |  |
| fn:usefulness | fn:HasLexicalUnit | fn:lu:usefulness:great | "usefulness" | "great" | "has lexical unit" |  | "FN" |  |
| fn:usefulness | fn:HasLexicalUnit | fn:lu:usefulness:super | "usefulness" | "super" | "has lexical unit" |  | "FN" |  |
| fn:usefulness | fn:HasLexicalUnit | fn:lu:usefulness:splendid | "usefulness" | "splendid" | "has lexical unit" |  | "FN" |  |
| fn:usefulness | fn:HasLexicalUnit | fn:lu:usefulness:useful | "usefulness" | "useful" | "has lexical unit" |  | "FN" |  |
| fn:usefulness | fn:HasLexicalUnit | fn:lu:usefulness:utility | "usefulness" | "utility" | "has lexical unit" |  | "FN" |  |
| fn:usefulness | fn:HasLexicalUnit | fn:lu:usefulness:value | "usefulness" | "value" | "has lexical unit" |  | "FN" |  |
| fn:usefulness | fn:HasLexicalUnit | fn:lu:usefulness:valuable | "usefulness" | "valuable" | "has lexical unit" |  | "FN" |  |
| fn:usefulness | fn:HasLexicalUnit | fn:lu:usefulness:perfect | "usefulness" | "perfect" | "has lexical unit" |  | "FN" |  |
| fn:usefulness | fn:HasLexicalUnit | fn:lu:usefulness:ideal | "usefulness" | "ideal" | "has lexical unit" |  | "FN" |  |
| fn:usefulness | fn:HasLexicalUnit | fn:lu:usefulness:ineffective | "usefulness" | "ineffective" | "has lexical unit" |  | "FN" |  |
| fn:usefulness | fn:HasLexicalUnit | fn:lu:usefulness:work | "usefulness" | "work" | "has lexical unit" |  | "FN" |  |
| fn:usefulness | fn:HasLexicalUnit | fn:lu:usefulness:strong | "usefulness" | "strong" | "has lexical unit" |  | "FN" |  |
| fn:usefulness | /r/HasA | fn:fe:entity | "usefulness" | "entity" | "/r/has a" |  | "FN" |  |
| fn:usefulness | /r/HasA | fn:fe:purpose | "usefulness" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:usefulness | /r/HasA | fn:fe:degree | "usefulness" | "degree" | "/r/has a" |  | "FN" |  |
| fn:usefulness | /r/HasA | fn:fe:domain | "usefulness" | "domain" | "/r/has a" |  | "FN" |  |
| fn:usefulness | /r/HasA | fn:fe:time | "usefulness" | "time" | "/r/has a" |  | "FN" |  |
| fn:using | /r/IsA | fn:intentionally_affect | "using" | "intentionally affect" | "/r/is a" |  | "FN" |  |
| fn:attempt_means | /r/IsA | fn:using | "attempt means" | "using" | "/r/is a" |  | "FN" |  |
| fn:detonate_explosive | /r/IsA | fn:using | "detonate explosive" | "using" | "/r/is a" |  | "FN" |  |
| fn:expend_resource | /r/IsA | fn:using | "expend resource" | "using" | "/r/is a" |  | "FN" |  |
| fn:operating_a_system | /r/IsA | fn:using | "operating a system" | "using" | "/r/is a" |  | "FN" |  |
| fn:use_firearm | /r/IsA | fn:using | "use firearm" | "using" | "/r/is a" |  | "FN" |  |
| fn:using | /r/UsedFor | fn:artifact | "using" | "artifact" | "/r/used for" |  | "FN" |  |
| fn:using | /r/UsedFor | fn:usefulness | "using" | "usefulness" | "/r/used for" |  | "FN" |  |
| fn:operating_a_system | /r/RelatedTo | fn:using | "operating a system" | "using" | "/r/related to" |  | "FN" |  |
| fn:using | fn:HasLexicalUnit | fn:lu:using:use | "using" | "use" | "has lexical unit" |  | "FN" |  |
| fn:using | fn:HasLexicalUnit | fn:lu:using:employ | "using" | "employ" | "has lexical unit" |  | "FN" |  |
| fn:using | fn:HasLexicalUnit | fn:lu:using:use | "using" | "use" | "has lexical unit" |  | "FN" |  |
| fn:using | fn:HasLexicalUnit | fn:lu:using:avail_oneself | "using" | "avail oneself" | "has lexical unit" |  | "FN" |  |
| fn:using | fn:HasLexicalUnit | fn:lu:using:operate | "using" | "operate" | "has lexical unit" |  | "FN" |  |
| fn:using | fn:HasLexicalUnit | fn:lu:using:operation | "using" | "operation" | "has lexical unit" |  | "FN" |  |
| fn:using | fn:HasLexicalUnit | fn:lu:using:apply | "using" | "apply" | "has lexical unit" |  | "FN" |  |
| fn:using | fn:HasLexicalUnit | fn:lu:using:utilise | "using" | "utilise" | "has lexical unit" |  | "FN" |  |
| fn:using | fn:HasLexicalUnit | fn:lu:using:utilisation | "using" | "utilisation" | "has lexical unit" |  | "FN" |  |
| fn:using | fn:HasLexicalUnit | fn:lu:using:application | "using" | "application" | "has lexical unit" |  | "FN" |  |
| fn:using | fn:HasLexicalUnit | fn:lu:using:operational | "using" | "operational" | "has lexical unit" |  | "FN" |  |
| fn:using | fn:HasLexicalUnit | fn:lu:using:employment | "using" | "employment" | "has lexical unit" |  | "FN" |  |
| fn:using | fn:HasLexicalUnit | fn:lu:using:exercise | "using" | "exercise" | "has lexical unit" |  | "FN" |  |
| fn:using | /r/HasA | fn:fe:agent | "using" | "agent" | "/r/has a" |  | "FN" |  |
| fn:using | /r/HasA | fn:fe:place | "using" | "place" | "/r/has a" |  | "FN" |  |
| fn:using | /r/HasA | fn:fe:purpose | "using" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:using | /r/HasA | fn:fe:time | "using" | "time" | "/r/has a" |  | "FN" |  |
| fn:using | /r/HasA | fn:fe:means | "using" | "means" | "/r/has a" |  | "FN" |  |
| fn:using | /r/HasA | fn:fe:manner | "using" | "manner" | "/r/has a" |  | "FN" |  |
| fn:using | /r/HasA | fn:fe:instrument | "using" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:using | /r/HasA | fn:fe:role | "using" | "role" | "/r/has a" |  | "FN" |  |
| fn:using | /r/HasA | fn:fe:outcome | "using" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:using | /r/HasA | fn:fe:containing_event | "using" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:using | /r/HasA | fn:fe:frequency | "using" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:using | /r/HasA | fn:fe:period_of_iterations | "using" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:using | /r/HasA | fn:fe:circumstances | "using" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:using | /r/HasA | fn:fe:depictive | "using" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:using | /r/HasA | fn:fe:explanation | "using" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:using | /r/HasA | fn:fe:group | "using" | "group" | "/r/has a" |  | "FN" |  |
| fn:using | /r/HasA | fn:fe:degree | "using" | "degree" | "/r/has a" |  | "FN" |  |
| fn:using | /r/HasA | fn:fe:duration | "using" | "duration" | "/r/has a" |  | "FN" |  |
| fn:using_resource | fn:HasLexicalUnit | fn:lu:using_resource:use | "using resource" | "use" | "has lexical unit" |  | "FN" |  |
| fn:using_resource | fn:HasLexicalUnit | fn:lu:using_resource:spend | "using resource" | "spend" | "has lexical unit" |  | "FN" |  |
| fn:using_resource | /r/HasA | fn:fe:agent | "using resource" | "agent" | "/r/has a" |  | "FN" |  |
| fn:using_resource | /r/HasA | fn:fe:resource | "using resource" | "resource" | "/r/has a" |  | "FN" |  |
| fn:using_resource | /r/HasA | fn:fe:purpose | "using resource" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:using_resource | /r/HasA | fn:fe:portion | "using resource" | "portion" | "/r/has a" |  | "FN" |  |
| fn:using_resource | /r/HasA | fn:fe:means | "using resource" | "means" | "/r/has a" |  | "FN" |  |
| fn:using_resource | /r/HasA | fn:fe:manner | "using resource" | "manner" | "/r/has a" |  | "FN" |  |
| fn:using_resource | /r/HasA | fn:fe:place | "using resource" | "place" | "/r/has a" |  | "FN" |  |
| fn:using_resource | /r/HasA | fn:fe:time | "using resource" | "time" | "/r/has a" |  | "FN" |  |
| fn:vehicle | /r/IsA | fn:artifact | "vehicle" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:vehicle | /r/UsedFor | fn:convoy | "vehicle" | "convoy" | "/r/used for" |  | "FN" |  |
| fn:vehicle | /r/UsedFor | fn:vehicle_subpart | "vehicle" | "vehicle subpart" | "/r/used for" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:car | "vehicle" | "car" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:bus | "vehicle" | "bus" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:truck | "vehicle" | "truck" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:bike | "vehicle" | "bike" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:taxi | "vehicle" | "taxi" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:plane | "vehicle" | "plane" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:ferry | "vehicle" | "ferry" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:boat | "vehicle" | "boat" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:bicycle | "vehicle" | "bicycle" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:ship | "vehicle" | "ship" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:tram | "vehicle" | "tram" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:automobile | "vehicle" | "automobile" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:tricycle | "vehicle" | "tricycle" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:airplane | "vehicle" | "airplane" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:scooter | "vehicle" | "scooter" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:schooner | "vehicle" | "schooner" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:train | "vehicle" | "train" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:carriage | "vehicle" | "carriage" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:cab | "vehicle" | "cab" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:coach | "vehicle" | "coach" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:vehicle | "vehicle" | "vehicle" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:lorry | "vehicle" | "lorry" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:submarine | "vehicle" | "submarine" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:tank | "vehicle" | "tank" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:cart | "vehicle" | "cart" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:toboggan | "vehicle" | "toboggan" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:pick-up | "vehicle" | "pick-up" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:van | "vehicle" | "van" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:limousine | "vehicle" | "limousine" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:convertible | "vehicle" | "convertible" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:helicopter | "vehicle" | "helicopter" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:canoe | "vehicle" | "canoe" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:kayak | "vehicle" | "kayak" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:buggy | "vehicle" | "buggy" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:liner | "vehicle" | "liner" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:sedan | "vehicle" | "sedan" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:vessel | "vehicle" | "vessel" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:tank_car | "vehicle" | "tank car" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:warplane | "vehicle" | "warplane" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:yacht | "vehicle" | "yacht" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:chopper | "vehicle" | "chopper" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:helo | "vehicle" | "helo" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:bird | "vehicle" | "bird" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:minivan | "vehicle" | "minivan" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:ambulance | "vehicle" | "ambulance" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | fn:HasLexicalUnit | fn:lu:vehicle:aircraft | "vehicle" | "aircraft" | "has lexical unit" |  | "FN" |  |
| fn:vehicle | /r/HasA | fn:fe:descriptor | "vehicle" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:vehicle | /r/HasA | fn:fe:vehicle | "vehicle" | "vehicle" | "/r/has a" |  | "FN" |  |
| fn:vehicle | /r/HasA | fn:fe:possessor | "vehicle" | "possessor" | "/r/has a" |  | "FN" |  |
| fn:vehicle | /r/HasA | fn:fe:itinerary | "vehicle" | "itinerary" | "/r/has a" |  | "FN" |  |
| fn:vehicle | /r/HasA | fn:fe:means_of_propulsion | "vehicle" | "means of propulsion" | "/r/has a" |  | "FN" |  |
| fn:vehicle | /r/HasA | fn:fe:use | "vehicle" | "use" | "/r/has a" |  | "FN" |  |
| fn:getting_vehicle_underway | /r/UsedFor | fn:vehicle_departure_initial_stage | "getting vehicle underway" | "vehicle departure initial stage" | "/r/used for" |  | "FN" |  |
| fn:vehicle_departure_initial_stage | fn:HasLexicalUnit | fn:lu:vehicle_departure_initial_stage:lift_off | "vehicle departure initial stage" | "lift off" | "has lexical unit" |  | "FN" |  |
| fn:vehicle_departure_initial_stage | fn:HasLexicalUnit | fn:lu:vehicle_departure_initial_stage:take_off | "vehicle departure initial stage" | "take off" | "has lexical unit" |  | "FN" |  |
| fn:vehicle_departure_initial_stage | fn:HasLexicalUnit | fn:lu:vehicle_departure_initial_stage:cast_off | "vehicle departure initial stage" | "cast off" | "has lexical unit" |  | "FN" |  |
| fn:vehicle_departure_initial_stage | /r/HasA | fn:fe:vehicle | "vehicle departure initial stage" | "vehicle" | "/r/has a" |  | "FN" |  |
| fn:vehicle_departure_initial_stage | /r/HasA | fn:fe:source | "vehicle departure initial stage" | "source" | "/r/has a" |  | "FN" |  |
| fn:vehicle_departure_initial_stage | /r/HasA | fn:fe:intended_goal | "vehicle departure initial stage" | "intended goal" | "/r/has a" |  | "FN" |  |
| fn:vehicle_departure_initial_stage | /r/HasA | fn:fe:manner | "vehicle departure initial stage" | "manner" | "/r/has a" |  | "FN" |  |
| fn:vehicle_departure_initial_stage | /r/HasA | fn:fe:depictive | "vehicle departure initial stage" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:vehicle_departure_initial_stage | /r/HasA | fn:fe:means | "vehicle departure initial stage" | "means" | "/r/has a" |  | "FN" |  |
| fn:vehicle_departure_initial_stage | /r/HasA | fn:fe:result | "vehicle departure initial stage" | "result" | "/r/has a" |  | "FN" |  |
| fn:vehicle_departure_initial_stage | /r/HasA | fn:fe:co-participant | "vehicle departure initial stage" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:vehicle_departure_initial_stage | /r/HasA | fn:fe:circumstances | "vehicle departure initial stage" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:vehicle_departure_initial_stage | /r/HasA | fn:fe:place | "vehicle departure initial stage" | "place" | "/r/has a" |  | "FN" |  |
| fn:vehicle_departure_initial_stage | /r/HasA | fn:fe:duration_of_final_state | "vehicle departure initial stage" | "duration of final state" | "/r/has a" |  | "FN" |  |
| fn:vehicle_departure_initial_stage | /r/HasA | fn:fe:time | "vehicle departure initial stage" | "time" | "/r/has a" |  | "FN" |  |
| fn:vehicle_departure_initial_stage | /r/HasA | fn:fe:explanation | "vehicle departure initial stage" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:vehicle_landing | /r/IsA | fn:arriving | "vehicle landing" | "arriving" | "/r/is a" |  | "FN" |  |
| fn:vehicle_landing | /r/UsedFor | fn:cause_to_land | "vehicle landing" | "cause to land" | "/r/used for" |  | "FN" |  |
| fn:vehicle_landing | fn:HasLexicalUnit | fn:lu:vehicle_landing:land | "vehicle landing" | "land" | "has lexical unit" |  | "FN" |  |
| fn:vehicle_landing | fn:HasLexicalUnit | fn:lu:vehicle_landing:set_down | "vehicle landing" | "set down" | "has lexical unit" |  | "FN" |  |
| fn:vehicle_landing | fn:HasLexicalUnit | fn:lu:vehicle_landing:touch_down | "vehicle landing" | "touch down" | "has lexical unit" |  | "FN" |  |
| fn:vehicle_landing | /r/HasA | fn:fe:vehicle | "vehicle landing" | "vehicle" | "/r/has a" |  | "FN" |  |
| fn:vehicle_landing | /r/HasA | fn:fe:source | "vehicle landing" | "source" | "/r/has a" |  | "FN" |  |
| fn:vehicle_landing | /r/HasA | fn:fe:path | "vehicle landing" | "path" | "/r/has a" |  | "FN" |  |
| fn:vehicle_landing | /r/HasA | fn:fe:goal | "vehicle landing" | "goal" | "/r/has a" |  | "FN" |  |
| fn:vehicle_landing | /r/HasA | fn:fe:manner | "vehicle landing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:vehicle_landing | /r/HasA | fn:fe:means | "vehicle landing" | "means" | "/r/has a" |  | "FN" |  |
| fn:vehicle_landing | /r/HasA | fn:fe:mode_of_transportation | "vehicle landing" | "mode of transportation" | "/r/has a" |  | "FN" |  |
| fn:vehicle_landing | /r/HasA | fn:fe:cotheme | "vehicle landing" | "cotheme" | "/r/has a" |  | "FN" |  |
| fn:vehicle_landing | /r/HasA | fn:fe:time | "vehicle landing" | "time" | "/r/has a" |  | "FN" |  |
| fn:vehicle_landing | /r/HasA | fn:fe:new_situation | "vehicle landing" | "new situation" | "/r/has a" |  | "FN" |  |
| fn:vehicle_landing | /r/HasA | fn:fe:depictive | "vehicle landing" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:vehicle_landing | /r/HasA | fn:fe:period_of_iterations | "vehicle landing" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:vehicle_landing | /r/HasA | fn:fe:circumstances | "vehicle landing" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:vehicle_landing | /r/HasA | fn:fe:purpose | "vehicle landing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:vehicle_landing | /r/HasA | fn:fe:degree | "vehicle landing" | "degree" | "/r/has a" |  | "FN" |  |
| fn:vehicle_landing | /r/HasA | fn:fe:event_description | "vehicle landing" | "event description" | "/r/has a" |  | "FN" |  |
| fn:vehicle_landing | /r/HasA | fn:fe:re-encoding | "vehicle landing" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:vehicle_landing | /r/HasA | fn:fe:frequency | "vehicle landing" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:vehicle_landing | /r/HasA | fn:fe:place | "vehicle landing" | "place" | "/r/has a" |  | "FN" |  |
| fn:vehicle_subpart | /r/IsA | fn:part_whole | "vehicle subpart" | "part whole" | "/r/is a" |  | "FN" |  |
| fn:vehicle | /r/UsedFor | fn:vehicle_subpart | "vehicle" | "vehicle subpart" | "/r/used for" |  | "FN" |  |
| fn:vehicle_subpart | fn:HasLexicalUnit | fn:lu:vehicle_subpart:door | "vehicle subpart" | "door" | "has lexical unit" |  | "FN" |  |
| fn:vehicle_subpart | fn:HasLexicalUnit | fn:lu:vehicle_subpart:window | "vehicle subpart" | "window" | "has lexical unit" |  | "FN" |  |
| fn:vehicle_subpart | fn:HasLexicalUnit | fn:lu:vehicle_subpart:seat | "vehicle subpart" | "seat" | "has lexical unit" |  | "FN" |  |
| fn:vehicle_subpart | fn:HasLexicalUnit | fn:lu:vehicle_subpart:seatbelt | "vehicle subpart" | "seatbelt" | "has lexical unit" |  | "FN" |  |
| fn:vehicle_subpart | fn:HasLexicalUnit | fn:lu:vehicle_subpart:tire | "vehicle subpart" | "tire" | "has lexical unit" |  | "FN" |  |
| fn:vehicle_subpart | fn:HasLexicalUnit | fn:lu:vehicle_subpart:wheel | "vehicle subpart" | "wheel" | "has lexical unit" |  | "FN" |  |
| fn:vehicle_subpart | fn:HasLexicalUnit | fn:lu:vehicle_subpart:brake | "vehicle subpart" | "brake" | "has lexical unit" |  | "FN" |  |
| fn:vehicle_subpart | fn:HasLexicalUnit | fn:lu:vehicle_subpart:engine | "vehicle subpart" | "engine" | "has lexical unit" |  | "FN" |  |
| fn:vehicle_subpart | fn:HasLexicalUnit | fn:lu:vehicle_subpart:hood | "vehicle subpart" | "hood" | "has lexical unit" |  | "FN" |  |
| fn:vehicle_subpart | fn:HasLexicalUnit | fn:lu:vehicle_subpart:trunk | "vehicle subpart" | "trunk" | "has lexical unit" |  | "FN" |  |
| fn:vehicle_subpart | fn:HasLexicalUnit | fn:lu:vehicle_subpart:part | "vehicle subpart" | "part" | "has lexical unit" |  | "FN" |  |
| fn:vehicle_subpart | fn:HasLexicalUnit | fn:lu:vehicle_subpart:windshield | "vehicle subpart" | "windshield" | "has lexical unit" |  | "FN" |  |
| fn:vehicle_subpart | /r/HasA | fn:fe:part | "vehicle subpart" | "part" | "/r/has a" |  | "FN" |  |
| fn:vehicle_subpart | /r/HasA | fn:fe:whole | "vehicle subpart" | "whole" | "/r/has a" |  | "FN" |  |
| fn:vehicle_subpart | /r/HasA | fn:fe:function | "vehicle subpart" | "function" | "/r/has a" |  | "FN" |  |
| fn:vehicle_subpart | /r/HasA | fn:fe:orientation | "vehicle subpart" | "orientation" | "/r/has a" |  | "FN" |  |
| fn:vehicle_subpart | /r/HasA | fn:fe:descriptor | "vehicle subpart" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:verdict | /r/IsA | fn:legal_rulings | "verdict" | "legal rulings" | "/r/is a" |  | "FN" |  |
| fn:trial | /r/HasSubevent | fn:verdict | "trial" | "verdict" | "/r/has subevent" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:verdict | "communication" | "verdict" | "/r/used for" |  | "FN" |  |
| fn:verdict | /r/HasPrerequisite | fn:jury_deliberation | "verdict" | "jury deliberation" | "/r/has prerequisite" |  | "FN" |  |
| fn:verdict | fn:HasLexicalUnit | fn:lu:verdict:pronounce | "verdict" | "pronounce" | "has lexical unit" |  | "FN" |  |
| fn:verdict | fn:HasLexicalUnit | fn:lu:verdict:find | "verdict" | "find" | "has lexical unit" |  | "FN" |  |
| fn:verdict | fn:HasLexicalUnit | fn:lu:verdict:finding | "verdict" | "finding" | "has lexical unit" |  | "FN" |  |
| fn:verdict | fn:HasLexicalUnit | fn:lu:verdict:ruling | "verdict" | "ruling" | "has lexical unit" |  | "FN" |  |
| fn:verdict | fn:HasLexicalUnit | fn:lu:verdict:convict | "verdict" | "convict" | "has lexical unit" |  | "FN" |  |
| fn:verdict | fn:HasLexicalUnit | fn:lu:verdict:conviction | "verdict" | "conviction" | "has lexical unit" |  | "FN" |  |
| fn:verdict | fn:HasLexicalUnit | fn:lu:verdict:acquit | "verdict" | "acquit" | "has lexical unit" |  | "FN" |  |
| fn:verdict | fn:HasLexicalUnit | fn:lu:verdict:acquittal | "verdict" | "acquittal" | "has lexical unit" |  | "FN" |  |
| fn:verdict | fn:HasLexicalUnit | fn:lu:verdict:verdict | "verdict" | "verdict" | "has lexical unit" |  | "FN" |  |
| fn:verdict | fn:HasLexicalUnit | fn:lu:verdict:clear | "verdict" | "clear" | "has lexical unit" |  | "FN" |  |
| fn:verdict | fn:HasLexicalUnit | fn:lu:verdict:guilty | "verdict" | "guilty" | "has lexical unit" |  | "FN" |  |
| fn:verdict | fn:HasLexicalUnit | fn:lu:verdict:not_guilty | "verdict" | "not guilty" | "has lexical unit" |  | "FN" |  |
| fn:verdict | /r/HasA | fn:fe:judge | "verdict" | "judge" | "/r/has a" |  | "FN" |  |
| fn:verdict | /r/HasA | fn:fe:finding | "verdict" | "finding" | "/r/has a" |  | "FN" |  |
| fn:verdict | /r/HasA | fn:fe:defendant | "verdict" | "defendant" | "/r/has a" |  | "FN" |  |
| fn:verdict | /r/HasA | fn:fe:charges | "verdict" | "charges" | "/r/has a" |  | "FN" |  |
| fn:verdict | /r/HasA | fn:fe:case | "verdict" | "case" | "/r/has a" |  | "FN" |  |
| fn:verdict | /r/HasA | fn:fe:time | "verdict" | "time" | "/r/has a" |  | "FN" |  |
| fn:verdict | /r/HasA | fn:fe:place | "verdict" | "place" | "/r/has a" |  | "FN" |  |
| fn:verdict | /r/HasA | fn:fe:legal_basis | "verdict" | "legal basis" | "/r/has a" |  | "FN" |  |
| fn:verdict | /r/HasA | fn:fe:circumstances | "verdict" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:verdict | /r/HasA | fn:fe:manner | "verdict" | "manner" | "/r/has a" |  | "FN" |  |
| fn:verdict | /r/HasA | fn:fe:purpose | "verdict" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:verdict | /r/HasA | fn:fe:means | "verdict" | "means" | "/r/has a" |  | "FN" |  |
| fn:verdict | /r/HasA | fn:fe:explanation | "verdict" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:verification | /r/IsA | fn:scrutiny | "verification" | "scrutiny" | "/r/is a" |  | "FN" |  |
| fn:correctness | /r/UsedFor | fn:verification | "correctness" | "verification" | "/r/used for" |  | "FN" |  |
| fn:verification | fn:HasLexicalUnit | fn:lu:verification:confirm | "verification" | "confirm" | "has lexical unit" |  | "FN" |  |
| fn:verification | fn:HasLexicalUnit | fn:lu:verification:verify | "verification" | "verify" | "has lexical unit" |  | "FN" |  |
| fn:verification | fn:HasLexicalUnit | fn:lu:verification:confirmation | "verification" | "confirmation" | "has lexical unit" |  | "FN" |  |
| fn:verification | fn:HasLexicalUnit | fn:lu:verification:verification | "verification" | "verification" | "has lexical unit" |  | "FN" |  |
| fn:verification | fn:HasLexicalUnit | fn:lu:verification:identify | "verification" | "identify" | "has lexical unit" |  | "FN" |  |
| fn:verification | fn:HasLexicalUnit | fn:lu:verification:verifiable | "verification" | "verifiable" | "has lexical unit" |  | "FN" |  |
| fn:verification | fn:HasLexicalUnit | fn:lu:verification:substantiate | "verification" | "substantiate" | "has lexical unit" |  | "FN" |  |
| fn:verification | fn:HasLexicalUnit | fn:lu:verification:make_sure | "verification" | "make sure" | "has lexical unit" |  | "FN" |  |
| fn:verification | fn:HasLexicalUnit | fn:lu:verification:certify | "verification" | "certify" | "has lexical unit" |  | "FN" |  |
| fn:verification | fn:HasLexicalUnit | fn:lu:verification:unconfirmed | "verification" | "unconfirmed" | "has lexical unit" |  | "FN" |  |
| fn:verification | fn:HasLexicalUnit | fn:lu:verification:unidentified | "verification" | "unidentified" | "has lexical unit" |  | "FN" |  |
| fn:verification | /r/HasA | fn:fe:inspector | "verification" | "inspector" | "/r/has a" |  | "FN" |  |
| fn:fe:unconfirmed_content | /r/IsA | fn:st:content | "unconfirmed content" | "content" | "/r/is a" |  | "FN" |  |
| fn:verification | /r/HasA | fn:fe:unconfirmed_content | "verification" | "unconfirmed content" | "/r/has a" |  | "FN" |  |
| fn:verification | /r/HasA | fn:fe:manner | "verification" | "manner" | "/r/has a" |  | "FN" |  |
| fn:verification | /r/HasA | fn:fe:means | "verification" | "means" | "/r/has a" |  | "FN" |  |
| fn:verification | /r/HasA | fn:fe:degree | "verification" | "degree" | "/r/has a" |  | "FN" |  |
| fn:verification | /r/HasA | fn:fe:purpose | "verification" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:verification | /r/HasA | fn:fe:medium | "verification" | "medium" | "/r/has a" |  | "FN" |  |
| fn:verification | /r/HasA | fn:fe:instrument | "verification" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:verification | /r/HasA | fn:fe:condition | "verification" | "condition" | "/r/has a" |  | "FN" |  |
| fn:verification | /r/HasA | fn:fe:descriptor | "verification" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:verification | /r/HasA | fn:fe:communicative_force | "verification" | "communicative force" | "/r/has a" |  | "FN" |  |
| fn:verification | /r/HasA | fn:fe:time | "verification" | "time" | "/r/has a" |  | "FN" |  |
| fn:verification | /r/HasA | fn:fe:place | "verification" | "place" | "/r/has a" |  | "FN" |  |
| fn:verification | /r/HasA | fn:fe:explanation | "verification" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:version_sequence | fn:HasLexicalUnit | fn:lu:version_sequence:preliminary | "version sequence" | "preliminary" | "has lexical unit" |  | "FN" |  |
| fn:version_sequence | fn:HasLexicalUnit | fn:lu:version_sequence:initial | "version sequence" | "initial" | "has lexical unit" |  | "FN" |  |
| fn:version_sequence | fn:HasLexicalUnit | fn:lu:version_sequence:draft | "version sequence" | "draft" | "has lexical unit" |  | "FN" |  |
| fn:version_sequence | fn:HasLexicalUnit | fn:lu:version_sequence:final | "version sequence" | "final" | "has lexical unit" |  | "FN" |  |
| fn:version_sequence | fn:HasLexicalUnit | fn:lu:version_sequence:rough | "version sequence" | "rough" | "has lexical unit" |  | "FN" |  |
| fn:version_sequence | fn:HasLexicalUnit | fn:lu:version_sequence:working | "version sequence" | "working" | "has lexical unit" |  | "FN" |  |
| fn:version_sequence | /r/HasA | fn:fe:item | "version sequence" | "item" | "/r/has a" |  | "FN" |  |
| fn:version_sequence | /r/HasA | fn:fe:degree | "version sequence" | "degree" | "/r/has a" |  | "FN" |  |
| fn:victim_operated_ied | /r/IsA | fn:improvised_explosive_device | "victim operated ied" | "improvised explosive device" | "/r/is a" |  | "FN" |  |
| fn:victim_operated_ied | fn:HasLexicalUnit | fn:lu:victim_operated_ied:voied | "victim operated ied" | "voied" | "has lexical unit" |  | "FN" |  |
| fn:victim_operated_ied | fn:HasLexicalUnit | fn:lu:victim_operated_ied:ppied | "victim operated ied" | "ppied" | "has lexical unit" |  | "FN" |  |
| fn:victim_operated_ied | /r/HasA | fn:fe:bomb | "victim operated ied" | "bomb" | "/r/has a" |  | "FN" |  |
| fn:victim_operated_ied | /r/HasA | fn:fe:use | "victim operated ied" | "use" | "/r/has a" |  | "FN" |  |
| fn:victim_operated_ied | /r/HasA | fn:fe:type | "victim operated ied" | "type" | "/r/has a" |  | "FN" |  |
| fn:victim_operated_ied | /r/HasA | fn:fe:material | "victim operated ied" | "material" | "/r/has a" |  | "FN" |  |
| fn:victim_operated_ied | /r/HasA | fn:fe:bomber | "victim operated ied" | "bomber" | "/r/has a" |  | "FN" |  |
| fn:victim_operated_ied | /r/HasA | fn:fe:part | "victim operated ied" | "part" | "/r/has a" |  | "FN" |  |
| fn:victim_operated_ied | /r/HasA | fn:fe:name | "victim operated ied" | "name" | "/r/has a" |  | "FN" |  |
| fn:victim_operated_ied | /r/HasA | fn:fe:time_of_creation | "victim operated ied" | "time of creation" | "/r/has a" |  | "FN" |  |
| fn:victim_operated_ied | /r/HasA | fn:fe:creator | "victim operated ied" | "creator" | "/r/has a" |  | "FN" |  |
| fn:victim_operated_ied | /r/HasA | fn:fe:descriptor | "victim operated ied" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:victim_operated_ied | /r/HasA | fn:fe:victim | "victim operated ied" | "victim" | "/r/has a" |  | "FN" |  |
| fn:cause_harm | /r/UsedFor | fn:violence | "cause harm" | "violence" | "/r/used for" |  | "FN" |  |
| fn:violence | fn:HasLexicalUnit | fn:lu:violence:violence | "violence" | "violence" | "has lexical unit" |  | "FN" |  |
| fn:violence | fn:HasLexicalUnit | fn:lu:violence:brutality | "violence" | "brutality" | "has lexical unit" |  | "FN" |  |
| fn:violence | fn:HasLexicalUnit | fn:lu:violence:savagery | "violence" | "savagery" | "has lexical unit" |  | "FN" |  |
| fn:fe:aggressor | /r/IsA | fn:st:sentient | "aggressor" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:violence | /r/HasA | fn:fe:aggressor | "violence" | "aggressor" | "/r/has a" |  | "FN" |  |
| fn:violence | /r/HasA | fn:fe:victim | "violence" | "victim" | "/r/has a" |  | "FN" |  |
| fn:violence | /r/HasA | fn:fe:degree | "violence" | "degree" | "/r/has a" |  | "FN" |  |
| fn:violence | /r/HasA | fn:fe:manner | "violence" | "manner" | "/r/has a" |  | "FN" |  |
| fn:violence | /r/HasA | fn:fe:means | "violence" | "means" | "/r/has a" |  | "FN" |  |
| fn:violence | /r/HasA | fn:fe:place | "violence" | "place" | "/r/has a" |  | "FN" |  |
| fn:violence | /r/HasA | fn:fe:time | "violence" | "time" | "/r/has a" |  | "FN" |  |
| fn:violence | /r/HasA | fn:fe:instrument | "violence" | "instrument" | "/r/has a" |  | "FN" |  |
| fn:violence | /r/HasA | fn:fe:purpose | "violence" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:violence | /r/HasA | fn:fe:containing_event | "violence" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:violence | /r/HasA | fn:fe:explanation | "violence" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:violence | /r/HasA | fn:fe:iterations | "violence" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:violence | /r/HasA | fn:fe:cause | "violence" | "cause" | "/r/has a" |  | "FN" |  |
| fn:violence | /r/HasA | fn:fe:circumstances | "violence" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:violence | /r/HasA | fn:fe:frequency | "violence" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:violence | /r/HasA | fn:fe:aggressors | "violence" | "aggressors" | "/r/has a" |  | "FN" |  |
| fn:visit_host | /r/IsA | fn:visitor_scenario | "visit host" | "visitor scenario" | "/r/is a" |  | "FN" |  |
| fn:visit_host | /r/HasSubevent | fn:drop_in_on | "visit host" | "drop in on" | "/r/has subevent" |  | "FN" |  |
| fn:visit_host | /r/IsA | fn:visitor_and_host | "visit host" | "visitor and host" | "/r/is a" |  | "FN" |  |
| fn:visit_host | /r/HasA | fn:fe:visitor | "visit host" | "visitor" | "/r/has a" |  | "FN" |  |
| fn:visit_host | /r/HasA | fn:fe:host | "visit host" | "host" | "/r/has a" |  | "FN" |  |
| fn:visit_host | /r/HasA | fn:fe:purpose | "visit host" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:visit_host | /r/HasA | fn:fe:normal_location | "visit host" | "normal location" | "/r/has a" |  | "FN" |  |
| fn:visit_host | /r/HasA | fn:fe:host_location | "visit host" | "host location" | "/r/has a" |  | "FN" |  |
| fn:visit_host_arrival | /r/IsA | fn:visiting_scenario_arrival | "visit host arrival" | "visiting scenario arrival" | "/r/is a" |  | "FN" |  |
| fn:visitor_and_host | /r/HasSubevent | fn:visit_host_arrival | "visitor and host" | "visit host arrival" | "/r/has subevent" |  | "FN" |  |
| fn:visit_host_stay | /r/HasPrerequisite | fn:visit_host_arrival | "visit host stay" | "visit host arrival" | "/r/has prerequisite" |  | "FN" |  |
| fn:drop_in_on | /r/IsA | fn:visit_host_arrival | "drop in on" | "visit host arrival" | "/r/is a" |  | "FN" |  |
| fn:visit_host_arrival | /r/HasA | fn:fe:visitor | "visit host arrival" | "visitor" | "/r/has a" |  | "FN" |  |
| fn:visit_host_arrival | /r/HasA | fn:fe:normal_location | "visit host arrival" | "normal location" | "/r/has a" |  | "FN" |  |
| fn:visit_host_arrival | /r/HasA | fn:fe:path | "visit host arrival" | "path" | "/r/has a" |  | "FN" |  |
| fn:visit_host_arrival | /r/HasA | fn:fe:host | "visit host arrival" | "host" | "/r/has a" |  | "FN" |  |
| fn:visit_host_arrival | /r/HasA | fn:fe:manner | "visit host arrival" | "manner" | "/r/has a" |  | "FN" |  |
| fn:visit_host_arrival | /r/HasA | fn:fe:means | "visit host arrival" | "means" | "/r/has a" |  | "FN" |  |
| fn:visit_host_arrival | /r/HasA | fn:fe:mode_of_transportation | "visit host arrival" | "mode of transportation" | "/r/has a" |  | "FN" |  |
| fn:visit_host_arrival | /r/HasA | fn:fe:time | "visit host arrival" | "time" | "/r/has a" |  | "FN" |  |
| fn:visit_host_arrival | /r/HasA | fn:fe:purpose | "visit host arrival" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:visit_host_arrival | /r/HasA | fn:fe:host_location | "visit host arrival" | "host location" | "/r/has a" |  | "FN" |  |
| fn:visit_host_arrival | /r/HasA | fn:fe:place | "visit host arrival" | "place" | "/r/has a" |  | "FN" |  |
| fn:visit_host_departure | /r/IsA | fn:visiting_scenario_departing | "visit host departure" | "visiting scenario departing" | "/r/is a" |  | "FN" |  |
| fn:visitor_and_host | /r/HasSubevent | fn:visit_host_departure | "visitor and host" | "visit host departure" | "/r/has subevent" |  | "FN" |  |
| fn:visit_host_departure | /r/HasPrerequisite | fn:visit_host_stay | "visit host departure" | "visit host stay" | "/r/has prerequisite" |  | "FN" |  |
| fn:visit_host_departure | /r/HasA | fn:fe:visitor | "visit host departure" | "visitor" | "/r/has a" |  | "FN" |  |
| fn:visit_host_departure | /r/HasA | fn:fe:host_location | "visit host departure" | "host location" | "/r/has a" |  | "FN" |  |
| fn:visit_host_departure | /r/HasA | fn:fe:path | "visit host departure" | "path" | "/r/has a" |  | "FN" |  |
| fn:visit_host_departure | /r/HasA | fn:fe:goal | "visit host departure" | "goal" | "/r/has a" |  | "FN" |  |
| fn:visit_host_departure | /r/HasA | fn:fe:manner | "visit host departure" | "manner" | "/r/has a" |  | "FN" |  |
| fn:visit_host_departure | /r/HasA | fn:fe:means | "visit host departure" | "means" | "/r/has a" |  | "FN" |  |
| fn:visit_host_departure | /r/HasA | fn:fe:speed | "visit host departure" | "speed" | "/r/has a" |  | "FN" |  |
| fn:visit_host_departure | /r/HasA | fn:fe:mode_of_transportation | "visit host departure" | "mode of transportation" | "/r/has a" |  | "FN" |  |
| fn:visit_host_departure | /r/HasA | fn:fe:distance | "visit host departure" | "distance" | "/r/has a" |  | "FN" |  |
| fn:visit_host_departure | /r/HasA | fn:fe:time | "visit host departure" | "time" | "/r/has a" |  | "FN" |  |
| fn:visit_host_departure | /r/HasA | fn:fe:place | "visit host departure" | "place" | "/r/has a" |  | "FN" |  |
| fn:visit_host_departure | /r/HasA | fn:fe:purpose | "visit host departure" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:visit_host_departure | /r/HasA | fn:fe:host | "visit host departure" | "host" | "/r/has a" |  | "FN" |  |
| fn:visit_host_stay | /r/IsA | fn:visiting_scenario_stay | "visit host stay" | "visiting scenario stay" | "/r/is a" |  | "FN" |  |
| fn:visitor_and_host | /r/HasSubevent | fn:visit_host_stay | "visitor and host" | "visit host stay" | "/r/has subevent" |  | "FN" |  |
| fn:visit_host_stay | /r/HasPrerequisite | fn:visit_host_arrival | "visit host stay" | "visit host arrival" | "/r/has prerequisite" |  | "FN" |  |
| fn:visit_host_departure | /r/HasPrerequisite | fn:visit_host_stay | "visit host departure" | "visit host stay" | "/r/has prerequisite" |  | "FN" |  |
| fn:visit_host_stay | /r/HasA | fn:fe:visitor | "visit host stay" | "visitor" | "/r/has a" |  | "FN" |  |
| fn:visit_host_stay | /r/HasA | fn:fe:host | "visit host stay" | "host" | "/r/has a" |  | "FN" |  |
| fn:visit_host_stay | /r/HasA | fn:fe:dependent_state | "visit host stay" | "dependent state" | "/r/has a" |  | "FN" |  |
| fn:visit_host_stay | /r/HasA | fn:fe:purpose | "visit host stay" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:visit_host_stay | /r/HasA | fn:fe:normal_location | "visit host stay" | "normal location" | "/r/has a" |  | "FN" |  |
| fn:visit_host_stay | /r/HasA | fn:fe:time | "visit host stay" | "time" | "/r/has a" |  | "FN" |  |
| fn:visit_host_stay | /r/HasA | fn:fe:duration | "visit host stay" | "duration" | "/r/has a" |  | "FN" |  |
| fn:visit_host_stay | /r/HasA | fn:fe:manner | "visit host stay" | "manner" | "/r/has a" |  | "FN" |  |
| fn:visit_host_stay | /r/HasA | fn:fe:place | "visit host stay" | "place" | "/r/has a" |  | "FN" |  |
| fn:visit_host_stay | /r/HasA | fn:fe:means | "visit host stay" | "means" | "/r/has a" |  | "FN" |  |
| fn:visit_host_stay | /r/HasA | fn:fe:iterations | "visit host stay" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:visit_host_stay | /r/HasA | fn:fe:frequency | "visit host stay" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:visit_host_stay | /r/HasA | fn:fe:host_location | "visit host stay" | "host location" | "/r/has a" |  | "FN" |  |
| fn:visiting | /r/IsA | fn:being_located | "visiting" | "being located" | "/r/is a" |  | "FN" |  |
| fn:visiting | /r/IsA | fn:intentionally_act | "visiting" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:temporary_stay | /r/IsA | fn:visiting | "temporary stay" | "visiting" | "/r/is a" |  | "FN" |  |
| fn:visiting | /r/IsA | fn:visiting_scenario_stay | "visiting" | "visiting scenario stay" | "/r/is a" |  | "FN" |  |
| fn:visitor_scenario | /r/HasSubevent | fn:visiting | "visitor scenario" | "visiting" | "/r/has subevent" |  | "FN" |  |
| fn:visiting | /r/UsedFor | fn:touring | "visiting" | "touring" | "/r/used for" |  | "FN" |  |
| fn:visitor_departure | /r/HasPrerequisite | fn:visiting | "visitor departure" | "visiting" | "/r/has prerequisite" |  | "FN" |  |
| fn:visiting | /r/HasPrerequisite | fn:visitor_arrival | "visiting" | "visitor arrival" | "/r/has prerequisite" |  | "FN" |  |
| fn:visiting | fn:HasLexicalUnit | fn:lu:visiting:visitor | "visiting" | "visitor" | "has lexical unit" |  | "FN" |  |
| fn:visiting | fn:HasLexicalUnit | fn:lu:visiting:visit | "visiting" | "visit" | "has lexical unit" |  | "FN" |  |
| fn:visiting | fn:HasLexicalUnit | fn:lu:visiting:visit | "visiting" | "visit" | "has lexical unit" |  | "FN" |  |
| fn:visiting | fn:HasLexicalUnit | fn:lu:visiting:revisit | "visiting" | "revisit" | "has lexical unit" |  | "FN" |  |
| fn:visiting | fn:HasLexicalUnit | fn:lu:visiting:call | "visiting" | "call" | "has lexical unit" |  | "FN" |  |
| fn:visiting | /r/HasA | fn:fe:agent | "visiting" | "agent" | "/r/has a" |  | "FN" |  |
| fn:fe:entity | /r/IsA | fn:st:physical_object | "entity" | "physical object" | "/r/is a" |  | "FN" |  |
| fn:visiting | /r/HasA | fn:fe:entity | "visiting" | "entity" | "/r/has a" |  | "FN" |  |
| fn:visiting | /r/HasA | fn:fe:dependent_state | "visiting" | "dependent state" | "/r/has a" |  | "FN" |  |
| fn:visiting | /r/HasA | fn:fe:purpose | "visiting" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:visiting | /r/HasA | fn:fe:normal_location | "visiting" | "normal location" | "/r/has a" |  | "FN" |  |
| fn:visiting | /r/HasA | fn:fe:time | "visiting" | "time" | "/r/has a" |  | "FN" |  |
| fn:visiting | /r/HasA | fn:fe:duration | "visiting" | "duration" | "/r/has a" |  | "FN" |  |
| fn:visiting | /r/HasA | fn:fe:manner | "visiting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:visiting | /r/HasA | fn:fe:place | "visiting" | "place" | "/r/has a" |  | "FN" |  |
| fn:visiting | /r/HasA | fn:fe:means | "visiting" | "means" | "/r/has a" |  | "FN" |  |
| fn:visiting | /r/HasA | fn:fe:iterations | "visiting" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:visiting | /r/HasA | fn:fe:frequency | "visiting" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:visiting | /r/HasA | fn:fe:depictive | "visiting" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:visitor_and_host | /r/IsA | fn:visiting_scenario | "visitor and host" | "visiting scenario" | "/r/is a" |  | "FN" |  |
| fn:visiting_scenario | /r/HasSubevent | fn:visiting_scenario_arrival | "visiting scenario" | "visiting scenario arrival" | "/r/has subevent" |  | "FN" |  |
| fn:visiting_scenario | /r/HasSubevent | fn:visiting_scenario_departing | "visiting scenario" | "visiting scenario departing" | "/r/has subevent" |  | "FN" |  |
| fn:visiting_scenario | /r/HasSubevent | fn:visiting_scenario_stay | "visiting scenario" | "visiting scenario stay" | "/r/has subevent" |  | "FN" |  |
| fn:visitor_scenario | /r/IsA | fn:visiting_scenario | "visitor scenario" | "visiting scenario" | "/r/is a" |  | "FN" |  |
| fn:visiting_scenario | /r/HasA | fn:fe:agent | "visiting scenario" | "agent" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario | /r/HasA | fn:fe:entity | "visiting scenario" | "entity" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario | /r/HasA | fn:fe:purpose | "visiting scenario" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario | /r/HasA | fn:fe:normal_location | "visiting scenario" | "normal location" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_arrival | /r/IsA | fn:arriving | "visiting scenario arrival" | "arriving" | "/r/is a" |  | "FN" |  |
| fn:visit_host_arrival | /r/IsA | fn:visiting_scenario_arrival | "visit host arrival" | "visiting scenario arrival" | "/r/is a" |  | "FN" |  |
| fn:visitor_arrival | /r/IsA | fn:visiting_scenario_arrival | "visitor arrival" | "visiting scenario arrival" | "/r/is a" |  | "FN" |  |
| fn:visiting_scenario | /r/HasSubevent | fn:visiting_scenario_arrival | "visiting scenario" | "visiting scenario arrival" | "/r/has subevent" |  | "FN" |  |
| fn:visiting_scenario_stay | /r/HasPrerequisite | fn:visiting_scenario_arrival | "visiting scenario stay" | "visiting scenario arrival" | "/r/has prerequisite" |  | "FN" |  |
| fn:visiting_scenario_arrival | /r/HasA | fn:fe:agent | "visiting scenario arrival" | "agent" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_arrival | /r/HasA | fn:fe:normal_location | "visiting scenario arrival" | "normal location" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_arrival | /r/HasA | fn:fe:path | "visiting scenario arrival" | "path" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_arrival | /r/HasA | fn:fe:goal | "visiting scenario arrival" | "goal" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_arrival | /r/HasA | fn:fe:manner | "visiting scenario arrival" | "manner" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_arrival | /r/HasA | fn:fe:means | "visiting scenario arrival" | "means" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_arrival | /r/HasA | fn:fe:mode_of_transportation | "visiting scenario arrival" | "mode of transportation" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_arrival | /r/HasA | fn:fe:time | "visiting scenario arrival" | "time" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_arrival | /r/HasA | fn:fe:purpose | "visiting scenario arrival" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_arrival | /r/HasA | fn:fe:place | "visiting scenario arrival" | "place" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_departing | /r/IsA | fn:departing | "visiting scenario departing" | "departing" | "/r/is a" |  | "FN" |  |
| fn:visit_host_departure | /r/IsA | fn:visiting_scenario_departing | "visit host departure" | "visiting scenario departing" | "/r/is a" |  | "FN" |  |
| fn:visitor_departure | /r/IsA | fn:visiting_scenario_departing | "visitor departure" | "visiting scenario departing" | "/r/is a" |  | "FN" |  |
| fn:visiting_scenario | /r/HasSubevent | fn:visiting_scenario_departing | "visiting scenario" | "visiting scenario departing" | "/r/has subevent" |  | "FN" |  |
| fn:visiting_scenario_departing | /r/HasPrerequisite | fn:visiting_scenario_stay | "visiting scenario departing" | "visiting scenario stay" | "/r/has prerequisite" |  | "FN" |  |
| fn:visiting_scenario_departing | /r/HasA | fn:fe:agent | "visiting scenario departing" | "agent" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_departing | /r/HasA | fn:fe:source | "visiting scenario departing" | "source" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_departing | /r/HasA | fn:fe:path | "visiting scenario departing" | "path" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_departing | /r/HasA | fn:fe:goal | "visiting scenario departing" | "goal" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_departing | /r/HasA | fn:fe:manner | "visiting scenario departing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_departing | /r/HasA | fn:fe:means | "visiting scenario departing" | "means" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_departing | /r/HasA | fn:fe:speed | "visiting scenario departing" | "speed" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_departing | /r/HasA | fn:fe:mode_of_transportation | "visiting scenario departing" | "mode of transportation" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_departing | /r/HasA | fn:fe:distance | "visiting scenario departing" | "distance" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_departing | /r/HasA | fn:fe:time | "visiting scenario departing" | "time" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_departing | /r/HasA | fn:fe:place | "visiting scenario departing" | "place" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_departing | /r/HasA | fn:fe:purpose | "visiting scenario departing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:visit_host_stay | /r/IsA | fn:visiting_scenario_stay | "visit host stay" | "visiting scenario stay" | "/r/is a" |  | "FN" |  |
| fn:visiting | /r/IsA | fn:visiting_scenario_stay | "visiting" | "visiting scenario stay" | "/r/is a" |  | "FN" |  |
| fn:visiting_scenario | /r/HasSubevent | fn:visiting_scenario_stay | "visiting scenario" | "visiting scenario stay" | "/r/has subevent" |  | "FN" |  |
| fn:visiting_scenario_stay | /r/HasPrerequisite | fn:visiting_scenario_arrival | "visiting scenario stay" | "visiting scenario arrival" | "/r/has prerequisite" |  | "FN" |  |
| fn:visiting_scenario_departing | /r/HasPrerequisite | fn:visiting_scenario_stay | "visiting scenario departing" | "visiting scenario stay" | "/r/has prerequisite" |  | "FN" |  |
| fn:visiting_scenario_stay | /r/HasA | fn:fe:agent | "visiting scenario stay" | "agent" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_stay | /r/HasA | fn:fe:entity | "visiting scenario stay" | "entity" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_stay | /r/HasA | fn:fe:dependent_state | "visiting scenario stay" | "dependent state" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_stay | /r/HasA | fn:fe:purpose | "visiting scenario stay" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_stay | /r/HasA | fn:fe:normal_location | "visiting scenario stay" | "normal location" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_stay | /r/HasA | fn:fe:time | "visiting scenario stay" | "time" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_stay | /r/HasA | fn:fe:duration | "visiting scenario stay" | "duration" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_stay | /r/HasA | fn:fe:manner | "visiting scenario stay" | "manner" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_stay | /r/HasA | fn:fe:place | "visiting scenario stay" | "place" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_stay | /r/HasA | fn:fe:means | "visiting scenario stay" | "means" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_stay | /r/HasA | fn:fe:iterations | "visiting scenario stay" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:visiting_scenario_stay | /r/HasA | fn:fe:frequency | "visiting scenario stay" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:visitor_and_host | /r/IsA | fn:visiting_scenario | "visitor and host" | "visiting scenario" | "/r/is a" |  | "FN" |  |
| fn:visitor_and_host | /r/HasSubevent | fn:visit_host_arrival | "visitor and host" | "visit host arrival" | "/r/has subevent" |  | "FN" |  |
| fn:visitor_and_host | /r/HasSubevent | fn:visit_host_departure | "visitor and host" | "visit host departure" | "/r/has subevent" |  | "FN" |  |
| fn:visitor_and_host | /r/HasSubevent | fn:visit_host_stay | "visitor and host" | "visit host stay" | "/r/has subevent" |  | "FN" |  |
| fn:guest_and_host | /r/UsedFor | fn:visitor_and_host | "guest and host" | "visitor and host" | "/r/used for" |  | "FN" |  |
| fn:receive_visitor_scenario | /r/IsA | fn:visitor_and_host | "receive visitor scenario" | "visitor and host" | "/r/is a" |  | "FN" |  |
| fn:visit_host | /r/IsA | fn:visitor_and_host | "visit host" | "visitor and host" | "/r/is a" |  | "FN" |  |
| fn:visitor_and_host | /r/HasA | fn:fe:visitor | "visitor and host" | "visitor" | "/r/has a" |  | "FN" |  |
| fn:visitor_and_host | /r/HasA | fn:fe:host | "visitor and host" | "host" | "/r/has a" |  | "FN" |  |
| fn:visitor_and_host | /r/HasA | fn:fe:purpose | "visitor and host" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:visitor_and_host | /r/HasA | fn:fe:normal_location | "visitor and host" | "normal location" | "/r/has a" |  | "FN" |  |
| fn:visitor_and_host | /r/HasA | fn:fe:host_location | "visitor and host" | "host location" | "/r/has a" |  | "FN" |  |
| fn:visitor_arrival | /r/IsA | fn:visiting_scenario_arrival | "visitor arrival" | "visiting scenario arrival" | "/r/is a" |  | "FN" |  |
| fn:drop_in_on | /r/IsA | fn:visitor_arrival | "drop in on" | "visitor arrival" | "/r/is a" |  | "FN" |  |
| fn:visitor_scenario | /r/HasSubevent | fn:visitor_arrival | "visitor scenario" | "visitor arrival" | "/r/has subevent" |  | "FN" |  |
| fn:visiting | /r/HasPrerequisite | fn:visitor_arrival | "visiting" | "visitor arrival" | "/r/has prerequisite" |  | "FN" |  |
| fn:visitor_arrival | /r/HasA | fn:fe:agent | "visitor arrival" | "agent" | "/r/has a" |  | "FN" |  |
| fn:visitor_arrival | /r/HasA | fn:fe:normal_location | "visitor arrival" | "normal location" | "/r/has a" |  | "FN" |  |
| fn:visitor_arrival | /r/HasA | fn:fe:path | "visitor arrival" | "path" | "/r/has a" |  | "FN" |  |
| fn:visitor_arrival | /r/HasA | fn:fe:goal | "visitor arrival" | "goal" | "/r/has a" |  | "FN" |  |
| fn:visitor_arrival | /r/HasA | fn:fe:manner | "visitor arrival" | "manner" | "/r/has a" |  | "FN" |  |
| fn:visitor_arrival | /r/HasA | fn:fe:means | "visitor arrival" | "means" | "/r/has a" |  | "FN" |  |
| fn:visitor_arrival | /r/HasA | fn:fe:mode_of_transportation | "visitor arrival" | "mode of transportation" | "/r/has a" |  | "FN" |  |
| fn:visitor_arrival | /r/HasA | fn:fe:time | "visitor arrival" | "time" | "/r/has a" |  | "FN" |  |
| fn:visitor_arrival | /r/HasA | fn:fe:purpose | "visitor arrival" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:visitor_arrival | /r/HasA | fn:fe:place | "visitor arrival" | "place" | "/r/has a" |  | "FN" |  |
| fn:visitor_departure | /r/IsA | fn:visiting_scenario_departing | "visitor departure" | "visiting scenario departing" | "/r/is a" |  | "FN" |  |
| fn:visitor_scenario | /r/HasSubevent | fn:visitor_departure | "visitor scenario" | "visitor departure" | "/r/has subevent" |  | "FN" |  |
| fn:visitor_departure | /r/HasPrerequisite | fn:visiting | "visitor departure" | "visiting" | "/r/has prerequisite" |  | "FN" |  |
| fn:visitor_departure | /r/HasA | fn:fe:agent | "visitor departure" | "agent" | "/r/has a" |  | "FN" |  |
| fn:visitor_departure | /r/HasA | fn:fe:source | "visitor departure" | "source" | "/r/has a" |  | "FN" |  |
| fn:visitor_departure | /r/HasA | fn:fe:path | "visitor departure" | "path" | "/r/has a" |  | "FN" |  |
| fn:visitor_departure | /r/HasA | fn:fe:goal | "visitor departure" | "goal" | "/r/has a" |  | "FN" |  |
| fn:visitor_departure | /r/HasA | fn:fe:manner | "visitor departure" | "manner" | "/r/has a" |  | "FN" |  |
| fn:visitor_departure | /r/HasA | fn:fe:means | "visitor departure" | "means" | "/r/has a" |  | "FN" |  |
| fn:visitor_departure | /r/HasA | fn:fe:speed | "visitor departure" | "speed" | "/r/has a" |  | "FN" |  |
| fn:visitor_departure | /r/HasA | fn:fe:mode_of_transportation | "visitor departure" | "mode of transportation" | "/r/has a" |  | "FN" |  |
| fn:visitor_departure | /r/HasA | fn:fe:distance | "visitor departure" | "distance" | "/r/has a" |  | "FN" |  |
| fn:visitor_departure | /r/HasA | fn:fe:time | "visitor departure" | "time" | "/r/has a" |  | "FN" |  |
| fn:visitor_departure | /r/HasA | fn:fe:place | "visitor departure" | "place" | "/r/has a" |  | "FN" |  |
| fn:visitor_departure | /r/HasA | fn:fe:purpose | "visitor departure" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:visit_host | /r/IsA | fn:visitor_scenario | "visit host" | "visitor scenario" | "/r/is a" |  | "FN" |  |
| fn:visitor_scenario | /r/HasSubevent | fn:visiting | "visitor scenario" | "visiting" | "/r/has subevent" |  | "FN" |  |
| fn:visitor_scenario | /r/HasSubevent | fn:visitor_arrival | "visitor scenario" | "visitor arrival" | "/r/has subevent" |  | "FN" |  |
| fn:visitor_scenario | /r/HasSubevent | fn:visitor_departure | "visitor scenario" | "visitor departure" | "/r/has subevent" |  | "FN" |  |
| fn:visitor_scenario | /r/IsA | fn:visiting_scenario | "visitor scenario" | "visiting scenario" | "/r/is a" |  | "FN" |  |
| fn:visitor_scenario | /r/HasA | fn:fe:agent | "visitor scenario" | "agent" | "/r/has a" |  | "FN" |  |
| fn:fe:entity | /r/IsA | fn:st:location | "entity" | "location" | "/r/is a" |  | "FN" |  |
| fn:visitor_scenario | /r/HasA | fn:fe:entity | "visitor scenario" | "entity" | "/r/has a" |  | "FN" |  |
| fn:visitor_scenario | /r/HasA | fn:fe:purpose | "visitor scenario" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:visitor_scenario | /r/HasA | fn:fe:normal_location | "visitor scenario" | "normal location" | "/r/has a" |  | "FN" |  |
| fn:vocalizations | /r/IsA | fn:sounds | "vocalizations" | "sounds" | "/r/is a" |  | "FN" |  |
| fn:sounds | /r/SimilarTo | fn:vocalizations | "sounds" | "vocalizations" | "/r/similar to" |  | "FN" |  |
| fn:vocalizations | fn:HasLexicalUnit | fn:lu:vocalizations:cry | "vocalizations" | "cry" | "has lexical unit" |  | "FN" |  |
| fn:vocalizations | fn:HasLexicalUnit | fn:lu:vocalizations:howl | "vocalizations" | "howl" | "has lexical unit" |  | "FN" |  |
| fn:vocalizations | fn:HasLexicalUnit | fn:lu:vocalizations:squeak | "vocalizations" | "squeak" | "has lexical unit" |  | "FN" |  |
| fn:vocalizations | /r/HasA | fn:fe:sound_source | "vocalizations" | "sound source" | "/r/has a" |  | "FN" |  |
| fn:vocalizations | /r/HasA | fn:fe:location_of_sound_source | "vocalizations" | "location of sound source" | "/r/has a" |  | "FN" |  |
| fn:vocalizations | /r/HasA | fn:fe:place | "vocalizations" | "place" | "/r/has a" |  | "FN" |  |
| fn:vocalizations | /r/HasA | fn:fe:internal_cause | "vocalizations" | "internal cause" | "/r/has a" |  | "FN" |  |
| fn:vocalizations | /r/HasA | fn:fe:manner | "vocalizations" | "manner" | "/r/has a" |  | "FN" |  |
| fn:vocalizations | /r/HasA | fn:fe:degree | "vocalizations" | "degree" | "/r/has a" |  | "FN" |  |
| fn:vocalizations | /r/HasA | fn:fe:explanation | "vocalizations" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:vocalizations | /r/HasA | fn:fe:path | "vocalizations" | "path" | "/r/has a" |  | "FN" |  |
| fn:vocalizations | /r/HasA | fn:fe:frequency | "vocalizations" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:volubility | /r/IsA | fn:inclination | "volubility" | "inclination" | "/r/is a" |  | "FN" |  |
| fn:communication | /r/UsedFor | fn:volubility | "communication" | "volubility" | "/r/used for" |  | "FN" |  |
| fn:social_behavior_evaluation | /r/UsedFor | fn:volubility | "social behavior evaluation" | "volubility" | "/r/used for" |  | "FN" |  |
| fn:volubility | fn:HasLexicalUnit | fn:lu:volubility:effusive | "volubility" | "effusive" | "has lexical unit" |  | "FN" |  |
| fn:volubility | fn:HasLexicalUnit | fn:lu:volubility:glib | "volubility" | "glib" | "has lexical unit" |  | "FN" |  |
| fn:volubility | fn:HasLexicalUnit | fn:lu:volubility:laconic | "volubility" | "laconic" | "has lexical unit" |  | "FN" |  |
| fn:volubility | fn:HasLexicalUnit | fn:lu:volubility:loquacious | "volubility" | "loquacious" | "has lexical unit" |  | "FN" |  |
| fn:volubility | fn:HasLexicalUnit | fn:lu:volubility:reticent | "volubility" | "reticent" | "has lexical unit" |  | "FN" |  |
| fn:volubility | fn:HasLexicalUnit | fn:lu:volubility:silent | "volubility" | "silent" | "has lexical unit" |  | "FN" |  |
| fn:volubility | fn:HasLexicalUnit | fn:lu:volubility:talkative | "volubility" | "talkative" | "has lexical unit" |  | "FN" |  |
| fn:volubility | fn:HasLexicalUnit | fn:lu:volubility:chatty | "volubility" | "chatty" | "has lexical unit" |  | "FN" |  |
| fn:volubility | fn:HasLexicalUnit | fn:lu:volubility:big_mouth | "volubility" | "big mouth" | "has lexical unit" |  | "FN" |  |
| fn:volubility | fn:HasLexicalUnit | fn:lu:volubility:brusque | "volubility" | "brusque" | "has lexical unit" |  | "FN" |  |
| fn:volubility | fn:HasLexicalUnit | fn:lu:volubility:curt | "volubility" | "curt" | "has lexical unit" |  | "FN" |  |
| fn:volubility | fn:HasLexicalUnit | fn:lu:volubility:expansive | "volubility" | "expansive" | "has lexical unit" |  | "FN" |  |
| fn:volubility | fn:HasLexicalUnit | fn:lu:volubility:garrulous | "volubility" | "garrulous" | "has lexical unit" |  | "FN" |  |
| fn:volubility | fn:HasLexicalUnit | fn:lu:volubility:gushing | "volubility" | "gushing" | "has lexical unit" |  | "FN" |  |
| fn:volubility | fn:HasLexicalUnit | fn:lu:volubility:gushy | "volubility" | "gushy" | "has lexical unit" |  | "FN" |  |
| fn:volubility | fn:HasLexicalUnit | fn:lu:volubility:mum | "volubility" | "mum" | "has lexical unit" |  | "FN" |  |
| fn:volubility | fn:HasLexicalUnit | fn:lu:volubility:voluble | "volubility" | "voluble" | "has lexical unit" |  | "FN" |  |
| fn:volubility | fn:HasLexicalUnit | fn:lu:volubility:terse | "volubility" | "terse" | "has lexical unit" |  | "FN" |  |
| fn:volubility | fn:HasLexicalUnit | fn:lu:volubility:uncommunicative | "volubility" | "uncommunicative" | "has lexical unit" |  | "FN" |  |
| fn:volubility | fn:HasLexicalUnit | fn:lu:volubility:loquacity | "volubility" | "loquacity" | "has lexical unit" |  | "FN" |  |
| fn:volubility | fn:HasLexicalUnit | fn:lu:volubility:loudmouth | "volubility" | "loudmouth" | "has lexical unit" |  | "FN" |  |
| fn:volubility | fn:HasLexicalUnit | fn:lu:volubility:chatterbox | "volubility" | "chatterbox" | "has lexical unit" |  | "FN" |  |
| fn:volubility | fn:HasLexicalUnit | fn:lu:volubility:reticence | "volubility" | "reticence" | "has lexical unit" |  | "FN" |  |
| fn:volubility | fn:HasLexicalUnit | fn:lu:volubility:reserved | "volubility" | "reserved" | "has lexical unit" |  | "FN" |  |
| fn:volubility | fn:HasLexicalUnit | fn:lu:volubility:taciturn | "volubility" | "taciturn" | "has lexical unit" |  | "FN" |  |
| fn:volubility | fn:HasLexicalUnit | fn:lu:volubility:mute | "volubility" | "mute" | "has lexical unit" |  | "FN" |  |
| fn:volubility | fn:HasLexicalUnit | fn:lu:volubility:quiet | "volubility" | "quiet" | "has lexical unit" |  | "FN" |  |
| fn:volubility | /r/HasA | fn:fe:speaker | "volubility" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:volubility | /r/HasA | fn:fe:company | "volubility" | "company" | "/r/has a" |  | "FN" |  |
| fn:volubility | /r/HasA | fn:fe:text | "volubility" | "text" | "/r/has a" |  | "FN" |  |
| fn:volubility | /r/HasA | fn:fe:topic | "volubility" | "topic" | "/r/has a" |  | "FN" |  |
| fn:volubility | /r/HasA | fn:fe:medium | "volubility" | "medium" | "/r/has a" |  | "FN" |  |
| fn:volubility | /r/HasA | fn:fe:degree | "volubility" | "degree" | "/r/has a" |  | "FN" |  |
| fn:volubility | /r/HasA | fn:fe:manner | "volubility" | "manner" | "/r/has a" |  | "FN" |  |
| fn:volubility | /r/HasA | fn:fe:judge | "volubility" | "judge" | "/r/has a" |  | "FN" |  |
| fn:run_risk | /r/UsedFor | fn:wagering | "run risk" | "wagering" | "/r/used for" |  | "FN" |  |
| fn:wagering | fn:HasLexicalUnit | fn:lu:wagering:wager | "wagering" | "wager" | "has lexical unit" |  | "FN" |  |
| fn:wagering | fn:HasLexicalUnit | fn:lu:wagering:wager | "wagering" | "wager" | "has lexical unit" |  | "FN" |  |
| fn:wagering | fn:HasLexicalUnit | fn:lu:wagering:bet | "wagering" | "bet" | "has lexical unit" |  | "FN" |  |
| fn:fe:gambler | /r/IsA | fn:st:sentient | "gambler" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:wagering | /r/HasA | fn:fe:gambler | "wagering" | "gambler" | "/r/has a" |  | "FN" |  |
| fn:wagering | /r/HasA | fn:fe:place | "wagering" | "place" | "/r/has a" |  | "FN" |  |
| fn:wagering | /r/HasA | fn:fe:time | "wagering" | "time" | "/r/has a" |  | "FN" |  |
| fn:wagering | /r/HasA | fn:fe:asset | "wagering" | "asset" | "/r/has a" |  | "FN" |  |
| fn:wagering | /r/HasA | fn:fe:frequency | "wagering" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:wagering | /r/HasA | fn:fe:purpose | "wagering" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:wagering | /r/HasA | fn:fe:explanation | "wagering" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:wagering | /r/HasA | fn:fe:iterations | "wagering" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:wagering | /r/HasA | fn:fe:circumstances | "wagering" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:wagering | /r/HasA | fn:fe:beneficiary | "wagering" | "beneficiary" | "/r/has a" |  | "FN" |  |
| fn:wagering | /r/HasA | fn:fe:outcome | "wagering" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:fe:uncertain_situation | /r/RelatedTo | fn:fe:outcome | "uncertain situation" | "outcome" | "/r/related to" |  | "FN" |  |
| fn:wagering | /r/HasA | fn:fe:uncertain_situation | "wagering" | "uncertain situation" | "/r/has a" |  | "FN" |  |
| fn:standing_by | /r/IsA | fn:waiting | "standing by" | "waiting" | "/r/is a" |  | "FN" |  |
| fn:change_event_time | /r/UsedFor | fn:waiting | "change event time" | "waiting" | "/r/used for" |  | "FN" |  |
| fn:intentionally_act | /r/UsedFor | fn:waiting | "intentionally act" | "waiting" | "/r/used for" |  | "FN" |  |
| fn:waiting | /r/RelatedTo | fn:holding_off_on | "waiting" | "holding off on" | "/r/related to" |  | "FN" |  |
| fn:waiting | fn:HasLexicalUnit | fn:lu:waiting:wait | "waiting" | "wait" | "has lexical unit" |  | "FN" |  |
| fn:waiting | fn:HasLexicalUnit | fn:lu:waiting:bide_its_time | "waiting" | "bide its time" | "has lexical unit" |  | "FN" |  |
| fn:waiting | /r/HasA | fn:fe:protagonist | "waiting" | "protagonist" | "/r/has a" |  | "FN" |  |
| fn:fe:salient_entity | /r/RelatedTo | fn:fe:expected_event | "salient entity" | "expected event" | "/r/related to" |  | "FN" |  |
| fn:waiting | /r/HasA | fn:fe:salient_entity | "waiting" | "salient entity" | "/r/has a" |  | "FN" |  |
| fn:waiting | /r/HasA | fn:fe:time | "waiting" | "time" | "/r/has a" |  | "FN" |  |
| fn:waiting | /r/HasA | fn:fe:place | "waiting" | "place" | "/r/has a" |  | "FN" |  |
| fn:waiting | /r/HasA | fn:fe:duration | "waiting" | "duration" | "/r/has a" |  | "FN" |  |
| fn:waiting | /r/HasA | fn:fe:manner | "waiting" | "manner" | "/r/has a" |  | "FN" |  |
| fn:waiting | /r/HasA | fn:fe:expected_event | "waiting" | "expected event" | "/r/has a" |  | "FN" |  |
| fn:waiting | /r/HasA | fn:fe:end_point | "waiting" | "end point" | "/r/has a" |  | "FN" |  |
| fn:waiting | /r/HasA | fn:fe:explanation | "waiting" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:waiting | /r/HasA | fn:fe:depictive | "waiting" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:waiting | /r/HasA | fn:fe:purpose | "waiting" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:waiting | /r/HasA | fn:fe:co-participant | "waiting" | "co-participant" | "/r/has a" |  | "FN" |  |
| fn:waking_up | /r/IsA | fn:event | "waking up" | "event" | "/r/is a" |  | "FN" |  |
| fn:sleep_wake_cycle | /r/HasSubevent | fn:waking_up | "sleep wake cycle" | "waking up" | "/r/has subevent" |  | "FN" |  |
| fn:waking_up | /r/HasPrerequisite | fn:sleep | "waking up" | "sleep" | "/r/has prerequisite" |  | "FN" |  |
| fn:being_awake | /r/HasPrerequisite | fn:waking_up | "being awake" | "waking up" | "/r/has prerequisite" |  | "FN" |  |
| fn:waking_up | fn:HasLexicalUnit | fn:lu:waking_up:come_to | "waking up" | "come to" | "has lexical unit" |  | "FN" |  |
| fn:waking_up | fn:HasLexicalUnit | fn:lu:waking_up:awake | "waking up" | "awake" | "has lexical unit" |  | "FN" |  |
| fn:waking_up | fn:HasLexicalUnit | fn:lu:waking_up:wake | "waking up" | "wake" | "has lexical unit" |  | "FN" |  |
| fn:waking_up | fn:HasLexicalUnit | fn:lu:waking_up:wake_up | "waking up" | "wake up" | "has lexical unit" |  | "FN" |  |
| fn:waking_up | fn:HasLexicalUnit | fn:lu:waking_up:get_up | "waking up" | "get up" | "has lexical unit" |  | "FN" |  |
| fn:waking_up | fn:HasLexicalUnit | fn:lu:waking_up:revive | "waking up" | "revive" | "has lexical unit" |  | "FN" |  |
| fn:waking_up | fn:HasLexicalUnit | fn:lu:waking_up:come_back_around | "waking up" | "come back around" | "has lexical unit" |  | "FN" |  |
| fn:waking_up | /r/HasA | fn:fe:place | "waking up" | "place" | "/r/has a" |  | "FN" |  |
| fn:waking_up | /r/HasA | fn:fe:sleeper | "waking up" | "sleeper" | "/r/has a" |  | "FN" |  |
| fn:waking_up | /r/HasA | fn:fe:time | "waking up" | "time" | "/r/has a" |  | "FN" |  |
| fn:waking_up | /r/HasA | fn:fe:sleep_state | "waking up" | "sleep state" | "/r/has a" |  | "FN" |  |
| fn:waking_up | /r/HasA | fn:fe:manner | "waking up" | "manner" | "/r/has a" |  | "FN" |  |
| fn:waking_up | /r/HasA | fn:fe:depictive | "waking up" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:waking_up | /r/HasA | fn:fe:new_situation | "waking up" | "new situation" | "/r/has a" |  | "FN" |  |
| fn:waking_up | /r/HasA | fn:fe:circumstances | "waking up" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:waking_up | /r/HasA | fn:fe:particular_iteration | "waking up" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:waking_up | /r/HasA | fn:fe:explanation | "waking up" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:waking_up | /r/HasA | fn:fe:frequency | "waking up" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:give_impression | /r/UsedFor | fn:want_suspect | "give impression" | "want suspect" | "/r/used for" |  | "FN" |  |
| fn:want_suspect | /r/UsedFor | fn:surrendering | "want suspect" | "surrendering" | "/r/used for" |  | "FN" |  |
| fn:want_suspect | fn:HasLexicalUnit | fn:lu:want_suspect:wanted | "want suspect" | "wanted" | "has lexical unit" |  | "FN" |  |
| fn:want_suspect | /r/HasA | fn:fe:suspect | "want suspect" | "suspect" | "/r/has a" |  | "FN" |  |
| fn:want_suspect | /r/HasA | fn:fe:charges | "want suspect" | "charges" | "/r/has a" |  | "FN" |  |
| fn:want_suspect | /r/HasA | fn:fe:degree | "want suspect" | "degree" | "/r/has a" |  | "FN" |  |
| fn:warning | /r/IsA | fn:telling | "warning" | "telling" | "/r/is a" |  | "FN" |  |
| fn:warning | fn:HasLexicalUnit | fn:lu:warning:warn | "warning" | "warn" | "has lexical unit" |  | "FN" |  |
| fn:warning | fn:HasLexicalUnit | fn:lu:warning:warning | "warning" | "warning" | "has lexical unit" |  | "FN" |  |
| fn:warning | fn:HasLexicalUnit | fn:lu:warning:alert | "warning" | "alert" | "has lexical unit" |  | "FN" |  |
| fn:warning | fn:HasLexicalUnit | fn:lu:warning:forewarn | "warning" | "forewarn" | "has lexical unit" |  | "FN" |  |
| fn:warning | /r/HasA | fn:fe:speaker | "warning" | "speaker" | "/r/has a" |  | "FN" |  |
| fn:warning | /r/HasA | fn:fe:addressee | "warning" | "addressee" | "/r/has a" |  | "FN" |  |
| fn:warning | /r/HasA | fn:fe:message | "warning" | "message" | "/r/has a" |  | "FN" |  |
| fn:warning | /r/HasA | fn:fe:topic | "warning" | "topic" | "/r/has a" |  | "FN" |  |
| fn:warning | /r/HasA | fn:fe:manner | "warning" | "manner" | "/r/has a" |  | "FN" |  |
| fn:warning | /r/HasA | fn:fe:means | "warning" | "means" | "/r/has a" |  | "FN" |  |
| fn:warning | /r/HasA | fn:fe:medium | "warning" | "medium" | "/r/has a" |  | "FN" |  |
| fn:warning | /r/HasA | fn:fe:time | "warning" | "time" | "/r/has a" |  | "FN" |  |
| fn:warning | /r/HasA | fn:fe:place | "warning" | "place" | "/r/has a" |  | "FN" |  |
| fn:warning | /r/HasA | fn:fe:communicative_force | "warning" | "communicative force" | "/r/has a" |  | "FN" |  |
| fn:warning | /r/HasA | fn:fe:descriptor | "warning" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:warning | /r/HasA | fn:fe:iterations | "warning" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:choosing | /r/UsedFor | fn:waver_between_options | "choosing" | "waver between options" | "/r/used for" |  | "FN" |  |
| fn:waver_between_options | fn:HasLexicalUnit | fn:lu:waver_between_options:waver | "waver between options" | "waver" | "has lexical unit" |  | "FN" |  |
| fn:waver_between_options | fn:HasLexicalUnit | fn:lu:waver_between_options:vacillate | "waver between options" | "vacillate" | "has lexical unit" |  | "FN" |  |
| fn:waver_between_options | fn:HasLexicalUnit | fn:lu:waver_between_options:waffle | "waver between options" | "waffle" | "has lexical unit" |  | "FN" |  |
| fn:waver_between_options | fn:HasLexicalUnit | fn:lu:waver_between_options:go_back_and_forth | "waver between options" | "go back and forth" | "has lexical unit" |  | "FN" |  |
| fn:waver_between_options | fn:HasLexicalUnit | fn:lu:waver_between_options:flip-flop | "waver between options" | "flip-flop" | "has lexical unit" |  | "FN" |  |
| fn:waver_between_options | fn:HasLexicalUnit | fn:lu:waver_between_options:dither | "waver between options" | "dither" | "has lexical unit" |  | "FN" |  |
| fn:waver_between_options | /r/HasA | fn:fe:cognizer | "waver between options" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:waver_between_options | /r/HasA | fn:fe:explanation | "waver between options" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:waver_between_options | /r/HasA | fn:fe:options | "waver between options" | "options" | "/r/has a" |  | "FN" |  |
| fn:waver_between_options | /r/HasA | fn:fe:place | "waver between options" | "place" | "/r/has a" |  | "FN" |  |
| fn:waver_between_options | /r/HasA | fn:fe:time | "waver between options" | "time" | "/r/has a" |  | "FN" |  |
| fn:waver_between_options | /r/HasA | fn:fe:manner | "waver between options" | "manner" | "/r/has a" |  | "FN" |  |
| fn:waver_between_options | /r/HasA | fn:fe:issue | "waver between options" | "issue" | "/r/has a" |  | "FN" |  |
| fn:fe:option_1 | /r/HasPrerequisite | fn:fe:option_2 | "option 1" | "option 2" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:option_1 | /r/RelatedTo | fn:fe:options | "option 1" | "options" | "/r/related to" |  | "FN" |  |
| fn:waver_between_options | /r/HasA | fn:fe:option_1 | "waver between options" | "option 1" | "/r/has a" |  | "FN" |  |
| fn:fe:option_2 | /r/HasPrerequisite | fn:fe:option_1 | "option 2" | "option 1" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:option_2 | /r/RelatedTo | fn:fe:options | "option 2" | "options" | "/r/related to" |  | "FN" |  |
| fn:waver_between_options | /r/HasA | fn:fe:option_2 | "waver between options" | "option 2" | "/r/has a" |  | "FN" |  |
| fn:waver_between_options | /r/HasA | fn:fe:duration | "waver between options" | "duration" | "/r/has a" |  | "FN" |  |
| fn:waver_between_options | /r/HasA | fn:fe:frequency | "waver between options" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:waver_between_options | /r/HasA | fn:fe:degree | "waver between options" | "degree" | "/r/has a" |  | "FN" |  |
| fn:waver_between_options | /r/HasA | fn:fe:containing_event | "waver between options" | "containing event" | "/r/has a" |  | "FN" |  |
| fn:waver_between_options | /r/HasA | fn:fe:circumstances | "waver between options" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:wealthiness | /r/IsA | fn:gradable_attributes | "wealthiness" | "gradable attributes" | "/r/is a" |  | "FN" |  |
| fn:possession | /r/UsedFor | fn:wealthiness | "possession" | "wealthiness" | "/r/used for" |  | "FN" |  |
| fn:wealthiness | fn:HasLexicalUnit | fn:lu:wealthiness:affluent | "wealthiness" | "affluent" | "has lexical unit" |  | "FN" |  |
| fn:wealthiness | fn:HasLexicalUnit | fn:lu:wealthiness:bankrupt | "wealthiness" | "bankrupt" | "has lexical unit" |  | "FN" |  |
| fn:wealthiness | fn:HasLexicalUnit | fn:lu:wealthiness:broke | "wealthiness" | "broke" | "has lexical unit" |  | "FN" |  |
| fn:wealthiness | fn:HasLexicalUnit | fn:lu:wealthiness:needy | "wealthiness" | "needy" | "has lexical unit" |  | "FN" |  |
| fn:wealthiness | fn:HasLexicalUnit | fn:lu:wealthiness:poor | "wealthiness" | "poor" | "has lexical unit" |  | "FN" |  |
| fn:wealthiness | fn:HasLexicalUnit | fn:lu:wealthiness:privileged | "wealthiness" | "privileged" | "has lexical unit" |  | "FN" |  |
| fn:wealthiness | fn:HasLexicalUnit | fn:lu:wealthiness:prosperous | "wealthiness" | "prosperous" | "has lexical unit" |  | "FN" |  |
| fn:wealthiness | fn:HasLexicalUnit | fn:lu:wealthiness:rich | "wealthiness" | "rich" | "has lexical unit" |  | "FN" |  |
| fn:wealthiness | fn:HasLexicalUnit | fn:lu:wealthiness:underprivileged | "wealthiness" | "underprivileged" | "has lexical unit" |  | "FN" |  |
| fn:wealthiness | fn:HasLexicalUnit | fn:lu:wealthiness:wealthy | "wealthiness" | "wealthy" | "has lexical unit" |  | "FN" |  |
| fn:wealthiness | fn:HasLexicalUnit | fn:lu:wealthiness:well-off | "wealthiness" | "well-off" | "has lexical unit" |  | "FN" |  |
| fn:wealthiness | fn:HasLexicalUnit | fn:lu:wealthiness:poverty | "wealthiness" | "poverty" | "has lexical unit" |  | "FN" |  |
| fn:wealthiness | fn:HasLexicalUnit | fn:lu:wealthiness:impoverished | "wealthiness" | "impoverished" | "has lexical unit" |  | "FN" |  |
| fn:wealthiness | /r/HasA | fn:fe:person | "wealthiness" | "person" | "/r/has a" |  | "FN" |  |
| fn:wealthiness | /r/HasA | fn:fe:institution | "wealthiness" | "institution" | "/r/has a" |  | "FN" |  |
| fn:wealthiness | /r/HasA | fn:fe:degree | "wealthiness" | "degree" | "/r/has a" |  | "FN" |  |
| fn:wealthiness | /r/HasA | fn:fe:type_of_possession | "wealthiness" | "type of possession" | "/r/has a" |  | "FN" |  |
| fn:weapon | /r/IsA | fn:artifact | "weapon" | "artifact" | "/r/is a" |  | "FN" |  |
| fn:improvised_explosive_device | /r/IsA | fn:weapon | "improvised explosive device" | "weapon" | "/r/is a" |  | "FN" |  |
| fn:weapon | /r/UsedFor | fn:ammunition | "weapon" | "ammunition" | "/r/used for" |  | "FN" |  |
| fn:weapon | /r/UsedFor | fn:bearing_arms | "weapon" | "bearing arms" | "/r/used for" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:rifle | "weapon" | "rifle" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:pistol | "weapon" | "pistol" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:six-shooter | "weapon" | "six-shooter" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:firearm | "weapon" | "firearm" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:gun | "weapon" | "gun" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:cannon | "weapon" | "cannon" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:bomb | "weapon" | "bomb" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:warhead | "weapon" | "warhead" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:sword | "weapon" | "sword" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:knife | "weapon" | "knife" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:gat | "weapon" | "gat" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:ak-47 | "weapon" | "ak-47" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:grenade | "weapon" | "grenade" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:crossbow | "weapon" | "crossbow" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:machine-gun | "weapon" | "machine-gun" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:shotgun | "weapon" | "shotgun" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:shooter | "weapon" | "shooter" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:flame-thrower | "weapon" | "flame-thrower" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:weapon | "weapon" | "weapon" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:handgun | "weapon" | "handgun" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:club | "weapon" | "club" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:twenty-two | "weapon" | "twenty-two" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:forty-four | "weapon" | "forty-four" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:missile | "weapon" | "missile" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:garrotte | "weapon" | "garrotte" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:revolver | "weapon" | "revolver" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:weaponry | "weapon" | "weaponry" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:scud-b_missile | "weapon" | "scud-b missile" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:arsenal | "weapon" | "arsenal" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:chemical_weapon | "weapon" | "chemical weapon" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:ballistic_missile | "weapon" | "ballistic missile" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:biological_weapon | "weapon" | "biological weapon" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:nuclear_weapon | "weapon" | "nuclear weapon" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:mustard_gas | "weapon" | "mustard gas" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:cw | "weapon" | "cw" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:bw | "weapon" | "bw" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:wmd | "weapon" | "wmd" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:weapon_of_mass_destruction | "weapon" | "weapon of mass destruction" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:mine | "weapon" | "mine" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:spear | "weapon" | "spear" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:bow | "weapon" | "bow" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:explosive | "weapon" | "explosive" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:explosive | "weapon" | "explosive" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:plastic_explosive | "weapon" | "plastic explosive" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:dynamite | "weapon" | "dynamite" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:nuclear | "weapon" | "nuclear" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:scud-b | "weapon" | "scud-b" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:scud-c_missile | "weapon" | "scud-c missile" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:atomic_weapon | "weapon" | "atomic weapon" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:ordnance | "weapon" | "ordnance" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:arms | "weapon" | "arms" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:artillery | "weapon" | "artillery" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:shell | "weapon" | "shell" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:atomic_bomb | "weapon" | "atomic bomb" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:biological | "weapon" | "biological" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:chemical | "weapon" | "chemical" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:nerve_gas | "weapon" | "nerve gas" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:strategic | "weapon" | "strategic" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:strategic_nuclear_weapon | "weapon" | "strategic nuclear weapon" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:icbm | "weapon" | "icbm" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:rpg | "weapon" | "rpg" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:rocket | "weapon" | "rocket" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:small_arms | "weapon" | "small arms" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:efp | "weapon" | "efp" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:assault_rifle | "weapon" | "assault rifle" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:mortar | "weapon" | "mortar" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:automatic_weapon | "weapon" | "automatic weapon" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:c4 | "weapon" | "c4" | "has lexical unit" |  | "FN" |  |
| fn:weapon | fn:HasLexicalUnit | fn:lu:weapon:phosgene | "weapon" | "phosgene" | "has lexical unit" |  | "FN" |  |
| fn:weapon | /r/HasA | fn:fe:weapon | "weapon" | "weapon" | "/r/has a" |  | "FN" |  |
| fn:weapon | /r/HasA | fn:fe:use | "weapon" | "use" | "/r/has a" |  | "FN" |  |
| fn:weapon | /r/HasA | fn:fe:type | "weapon" | "type" | "/r/has a" |  | "FN" |  |
| fn:weapon | /r/HasA | fn:fe:material | "weapon" | "material" | "/r/has a" |  | "FN" |  |
| fn:weapon | /r/HasA | fn:fe:wielder | "weapon" | "wielder" | "/r/has a" |  | "FN" |  |
| fn:weapon | /r/HasA | fn:fe:part | "weapon" | "part" | "/r/has a" |  | "FN" |  |
| fn:weapon | /r/HasA | fn:fe:name | "weapon" | "name" | "/r/has a" |  | "FN" |  |
| fn:weapon | /r/HasA | fn:fe:time_of_creation | "weapon" | "time of creation" | "/r/has a" |  | "FN" |  |
| fn:weapon | /r/HasA | fn:fe:creator | "weapon" | "creator" | "/r/has a" |  | "FN" |  |
| fn:weapon | /r/HasA | fn:fe:descriptor | "weapon" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:accoutrements | /r/UsedFor | fn:wearing | "accoutrements" | "wearing" | "/r/used for" |  | "FN" |  |
| fn:body_parts | /r/UsedFor | fn:wearing | "body parts" | "wearing" | "/r/used for" |  | "FN" |  |
| fn:clothing | /r/UsedFor | fn:wearing | "clothing" | "wearing" | "/r/used for" |  | "FN" |  |
| fn:spatial_contact | /r/RelatedTo | fn:wearing | "spatial contact" | "wearing" | "/r/related to" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:naked | "wearing" | "naked" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:nude | "wearing" | "nude" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:unclad | "wearing" | "unclad" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:unshod | "wearing" | "unshod" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:shoeless | "wearing" | "shoeless" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:sockless | "wearing" | "sockless" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:nakedness | "wearing" | "nakedness" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:nudity | "wearing" | "nudity" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:clad | "wearing" | "clad" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:clothed | "wearing" | "clothed" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:wear | "wearing" | "wear" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:dressed | "wearing" | "dressed" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:barefoot | "wearing" | "barefoot" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:bare | "wearing" | "bare" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:bare | "wearing" | "bare" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:bareheaded | "wearing" | "bareheaded" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:barelegged | "wearing" | "barelegged" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:bare-chested | "wearing" | "bare-chested" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:hatless | "wearing" | "hatless" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:coatless | "wearing" | "coatless" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:shirtless | "wearing" | "shirtless" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:barefooted | "wearing" | "barefooted" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:undressed | "wearing" | "undressed" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:topless | "wearing" | "topless" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:masked | "wearing" | "masked" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:hooded | "wearing" | "hooded" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:undress | "wearing" | "undress" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:costumed | "wearing" | "costumed" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:garbed | "wearing" | "garbed" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:unclothed | "wearing" | "unclothed" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:bare-armed | "wearing" | "bare-armed" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:bare-breasted | "wearing" | "bare-breasted" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:hatted | "wearing" | "hatted" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:braless | "wearing" | "braless" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:robed | "wearing" | "robed" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:attired | "wearing" | "attired" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:gloved | "wearing" | "gloved" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:gloveless | "wearing" | "gloveless" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:have_on | "wearing" | "have on" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:with_on | "wearing" | "with on" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:have_got_on | "wearing" | "have got on" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:in | "wearing" | "in" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:decked_out | "wearing" | "decked out" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:dolled_up | "wearing" | "dolled up" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:got_on | "wearing" | "got on" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:sport | "wearing" | "sport" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:swaddled | "wearing" | "swaddled" | "has lexical unit" |  | "FN" |  |
| fn:wearing | fn:HasLexicalUnit | fn:lu:wearing:swathed | "wearing" | "swathed" | "has lexical unit" |  | "FN" |  |
| fn:wearing | /r/HasA | fn:fe:wearer | "wearing" | "wearer" | "/r/has a" |  | "FN" |  |
| fn:wearing | /r/HasA | fn:fe:clothing | "wearing" | "clothing" | "/r/has a" |  | "FN" |  |
| fn:wearing | /r/HasA | fn:fe:body_part | "wearing" | "body part" | "/r/has a" |  | "FN" |  |
| fn:wearing | /r/HasA | fn:fe:degree | "wearing" | "degree" | "/r/has a" |  | "FN" |  |
| fn:wearing | /r/HasA | fn:fe:manner | "wearing" | "manner" | "/r/has a" |  | "FN" |  |
| fn:wearing | /r/HasA | fn:fe:time | "wearing" | "time" | "/r/has a" |  | "FN" |  |
| fn:wearing | /r/HasA | fn:fe:source | "wearing" | "source" | "/r/has a" |  | "FN" |  |
| fn:fe:intended_wearing_location | /r/IsA | fn:st:goal | "intended wearing location" | "goal" | "/r/is a" |  | "FN" |  |
| fn:wearing | /r/HasA | fn:fe:intended_wearing_location | "wearing" | "intended wearing location" | "/r/has a" |  | "FN" |  |
| fn:wearing | /r/HasA | fn:fe:purpose | "wearing" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:wearing | /r/HasA | fn:fe:relative_location | "wearing" | "relative location" | "/r/has a" |  | "FN" |  |
| fn:weather | /r/HasSubevent | fn:precipitation | "weather" | "precipitation" | "/r/has subevent" |  | "FN" |  |
| fn:weather | fn:HasLexicalUnit | fn:lu:weather:stormy | "weather" | "stormy" | "has lexical unit" |  | "FN" |  |
| fn:weather | fn:HasLexicalUnit | fn:lu:weather:snowy | "weather" | "snowy" | "has lexical unit" |  | "FN" |  |
| fn:weather | fn:HasLexicalUnit | fn:lu:weather:blizzard | "weather" | "blizzard" | "has lexical unit" |  | "FN" |  |
| fn:weather | fn:HasLexicalUnit | fn:lu:weather:storm | "weather" | "storm" | "has lexical unit" |  | "FN" |  |
| fn:weather | fn:HasLexicalUnit | fn:lu:weather:storm | "weather" | "storm" | "has lexical unit" |  | "FN" |  |
| fn:weather | fn:HasLexicalUnit | fn:lu:weather:hailstorm | "weather" | "hailstorm" | "has lexical unit" |  | "FN" |  |
| fn:weather | fn:HasLexicalUnit | fn:lu:weather:rainstorm | "weather" | "rainstorm" | "has lexical unit" |  | "FN" |  |
| fn:weather | fn:HasLexicalUnit | fn:lu:weather:snowstorm | "weather" | "snowstorm" | "has lexical unit" |  | "FN" |  |
| fn:weather | fn:HasLexicalUnit | fn:lu:weather:weather | "weather" | "weather" | "has lexical unit" |  | "FN" |  |
| fn:weather | fn:HasLexicalUnit | fn:lu:weather:thunderstorm | "weather" | "thunderstorm" | "has lexical unit" |  | "FN" |  |
| fn:weather | fn:HasLexicalUnit | fn:lu:weather:climate | "weather" | "climate" | "has lexical unit" |  | "FN" |  |
| fn:weather | fn:HasLexicalUnit | fn:lu:weather:lowering_sky | "weather" | "lowering sky" | "has lexical unit" |  | "FN" |  |
| fn:weather | fn:HasLexicalUnit | fn:lu:weather:sunshine | "weather" | "sunshine" | "has lexical unit" |  | "FN" |  |
| fn:weather | fn:HasLexicalUnit | fn:lu:weather:fair | "weather" | "fair" | "has lexical unit" |  | "FN" |  |
| fn:weather | /r/HasA | fn:fe:place | "weather" | "place" | "/r/has a" |  | "FN" |  |
| fn:weather | /r/HasA | fn:fe:time | "weather" | "time" | "/r/has a" |  | "FN" |  |
| fn:weather | /r/HasA | fn:fe:specification | "weather" | "specification" | "/r/has a" |  | "FN" |  |
| fn:wholes_and_parts | /r/IsA | fn:inclusion_scenario | "wholes and parts" | "inclusion scenario" | "/r/is a" |  | "FN" |  |
| fn:part_piece | /r/IsA | fn:wholes_and_parts | "part piece" | "wholes and parts" | "/r/is a" |  | "FN" |  |
| fn:wholes_and_parts | /r/HasA | fn:fe:whole | "wholes and parts" | "whole" | "/r/has a" |  | "FN" |  |
| fn:wholes_and_parts | /r/HasA | fn:fe:part | "wholes and parts" | "part" | "/r/has a" |  | "FN" |  |
| fn:wholes_and_parts | /r/HasA | fn:fe:manner | "wholes and parts" | "manner" | "/r/has a" |  | "FN" |  |
| fn:wholes_and_parts | /r/HasA | fn:fe:time | "wholes and parts" | "time" | "/r/has a" |  | "FN" |  |
| fn:wholes_and_parts | /r/HasA | fn:fe:place | "wholes and parts" | "place" | "/r/has a" |  | "FN" |  |
| fn:choosing | /r/UsedFor | fn:willingness | "choosing" | "willingness" | "/r/used for" |  | "FN" |  |
| fn:willingness | fn:HasLexicalUnit | fn:lu:willingness:willing | "willingness" | "willing" | "has lexical unit" |  | "FN" |  |
| fn:willingness | fn:HasLexicalUnit | fn:lu:willingness:unwilling | "willingness" | "unwilling" | "has lexical unit" |  | "FN" |  |
| fn:willingness | fn:HasLexicalUnit | fn:lu:willingness:reluctant | "willingness" | "reluctant" | "has lexical unit" |  | "FN" |  |
| fn:willingness | fn:HasLexicalUnit | fn:lu:willingness:willingness | "willingness" | "willingness" | "has lexical unit" |  | "FN" |  |
| fn:willingness | fn:HasLexicalUnit | fn:lu:willingness:loath | "willingness" | "loath" | "has lexical unit" |  | "FN" |  |
| fn:willingness | fn:HasLexicalUnit | fn:lu:willingness:grudging | "willingness" | "grudging" | "has lexical unit" |  | "FN" |  |
| fn:willingness | fn:HasLexicalUnit | fn:lu:willingness:unwillingness | "willingness" | "unwillingness" | "has lexical unit" |  | "FN" |  |
| fn:willingness | fn:HasLexicalUnit | fn:lu:willingness:prepared | "willingness" | "prepared" | "has lexical unit" |  | "FN" |  |
| fn:willingness | fn:HasLexicalUnit | fn:lu:willingness:down | "willingness" | "down" | "has lexical unit" |  | "FN" |  |
| fn:willingness | /r/HasA | fn:fe:cognizer | "willingness" | "cognizer" | "/r/has a" |  | "FN" |  |
| fn:willingness | /r/HasA | fn:fe:activity | "willingness" | "activity" | "/r/has a" |  | "FN" |  |
| fn:willingness | /r/HasA | fn:fe:explanation | "willingness" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:willingness | /r/HasA | fn:fe:place | "willingness" | "place" | "/r/has a" |  | "FN" |  |
| fn:willingness | /r/HasA | fn:fe:time | "willingness" | "time" | "/r/has a" |  | "FN" |  |
| fn:willingness | /r/HasA | fn:fe:purpose | "willingness" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:willingness | /r/HasA | fn:fe:degree | "willingness" | "degree" | "/r/has a" |  | "FN" |  |
| fn:willingness | /r/HasA | fn:fe:frequency | "willingness" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:win_prize | /r/UsedFor | fn:beat_opponent | "win prize" | "beat opponent" | "/r/used for" |  | "FN" |  |
| fn:win_prize | /r/RelatedTo | fn:finish_competition | "win prize" | "finish competition" | "/r/related to" |  | "FN" |  |
| fn:win_prize | fn:HasLexicalUnit | fn:lu:win_prize:win | "win prize" | "win" | "has lexical unit" |  | "FN" |  |
| fn:win_prize | /r/HasA | fn:fe:competitor | "win prize" | "competitor" | "/r/has a" |  | "FN" |  |
| fn:win_prize | /r/HasA | fn:fe:score | "win prize" | "score" | "/r/has a" |  | "FN" |  |
| fn:win_prize | /r/HasA | fn:fe:margin | "win prize" | "margin" | "/r/has a" |  | "FN" |  |
| fn:win_prize | /r/HasA | fn:fe:rank | "win prize" | "rank" | "/r/has a" |  | "FN" |  |
| fn:win_prize | /r/HasA | fn:fe:prize | "win prize" | "prize" | "/r/has a" |  | "FN" |  |
| fn:win_prize | /r/HasA | fn:fe:means | "win prize" | "means" | "/r/has a" |  | "FN" |  |
| fn:win_prize | /r/HasA | fn:fe:manner | "win prize" | "manner" | "/r/has a" |  | "FN" |  |
| fn:win_prize | /r/HasA | fn:fe:time | "win prize" | "time" | "/r/has a" |  | "FN" |  |
| fn:win_prize | /r/HasA | fn:fe:place | "win prize" | "place" | "/r/has a" |  | "FN" |  |
| fn:win_prize | /r/HasA | fn:fe:venue | "win prize" | "venue" | "/r/has a" |  | "FN" |  |
| fn:win_prize | /r/HasA | fn:fe:particular_iteration | "win prize" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:win_prize | /r/HasA | fn:fe:competition | "win prize" | "competition" | "/r/has a" |  | "FN" |  |
| fn:win_prize | /r/HasA | fn:fe:explanation | "win prize" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:win_prize | /r/HasA | fn:fe:period_of_iterations | "win prize" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:win_prize | /r/HasA | fn:fe:opponent | "win prize" | "opponent" | "/r/has a" |  | "FN" |  |
| fn:win_prize | /r/HasA | fn:fe:circumstances | "win prize" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:win_prize | /r/HasA | fn:fe:re-encoding | "win prize" | "re-encoding" | "/r/has a" |  | "FN" |  |
| fn:win_prize | /r/HasA | fn:fe:result | "win prize" | "result" | "/r/has a" |  | "FN" |  |
| fn:win_prize | /r/HasA | fn:fe:iterations | "win prize" | "iterations" | "/r/has a" |  | "FN" |  |
| fn:win_prize | /r/HasA | fn:fe:communicative_force | "win prize" | "communicative force" | "/r/has a" |  | "FN" |  |
| fn:win_prize | /r/HasA | fn:fe:event_description | "win prize" | "event description" | "/r/has a" |  | "FN" |  |
| fn:participation | /r/UsedFor | fn:withdraw_from_participation | "participation" | "withdraw from participation" | "/r/used for" |  | "FN" |  |
| fn:withdraw_from_participation | fn:HasLexicalUnit | fn:lu:withdraw_from_participation:withdraw | "withdraw from participation" | "withdraw" | "has lexical unit" |  | "FN" |  |
| fn:withdraw_from_participation | fn:HasLexicalUnit | fn:lu:withdraw_from_participation:withdrawal | "withdraw from participation" | "withdrawal" | "has lexical unit" |  | "FN" |  |
| fn:withdraw_from_participation | fn:HasLexicalUnit | fn:lu:withdraw_from_participation:pull_out | "withdraw from participation" | "pull out" | "has lexical unit" |  | "FN" |  |
| fn:withdraw_from_participation | fn:HasLexicalUnit | fn:lu:withdraw_from_participation:pull-out | "withdraw from participation" | "pull-out" | "has lexical unit" |  | "FN" |  |
| fn:withdraw_from_participation | fn:HasLexicalUnit | fn:lu:withdraw_from_participation:beg_off | "withdraw from participation" | "beg off" | "has lexical unit" |  | "FN" |  |
| fn:fe:participant | /r/IsA | fn:st:sentient | "participant" | "sentient" | "/r/is a" |  | "FN" |  |
| fn:withdraw_from_participation | /r/HasA | fn:fe:participant | "withdraw from participation" | "participant" | "/r/has a" |  | "FN" |  |
| fn:fe:activity | /r/RelatedTo | fn:fe:organization | "activity" | "organization" | "/r/related to" |  | "FN" |  |
| fn:withdraw_from_participation | /r/HasA | fn:fe:activity | "withdraw from participation" | "activity" | "/r/has a" |  | "FN" |  |
| fn:withdraw_from_participation | /r/HasA | fn:fe:explanation | "withdraw from participation" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:withdraw_from_participation | /r/HasA | fn:fe:place | "withdraw from participation" | "place" | "/r/has a" |  | "FN" |  |
| fn:withdraw_from_participation | /r/HasA | fn:fe:time | "withdraw from participation" | "time" | "/r/has a" |  | "FN" |  |
| fn:withdraw_from_participation | /r/HasA | fn:fe:organization | "withdraw from participation" | "organization" | "/r/has a" |  | "FN" |  |
| fn:withdraw_from_participation | /r/HasA | fn:fe:purpose | "withdraw from participation" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:withdraw_from_participation | /r/HasA | fn:fe:means | "withdraw from participation" | "means" | "/r/has a" |  | "FN" |  |
| fn:withdraw_from_participation | /r/HasA | fn:fe:medium | "withdraw from participation" | "medium" | "/r/has a" |  | "FN" |  |
| fn:withdraw_from_participation | /r/HasA | fn:fe:manner | "withdraw from participation" | "manner" | "/r/has a" |  | "FN" |  |
| fn:within_distance | /r/IsA | fn:locative_relation | "within distance" | "locative relation" | "/r/is a" |  | "FN" |  |
| fn:interior_profile_relation | /r/RelatedTo | fn:within_distance | "interior profile relation" | "within distance" | "/r/related to" |  | "FN" |  |
| fn:within_distance | fn:HasLexicalUnit | fn:lu:within_distance:within | "within distance" | "within" | "has lexical unit" |  | "FN" |  |
| fn:within_distance | /r/HasA | fn:fe:ground | "within distance" | "ground" | "/r/has a" |  | "FN" |  |
| fn:within_distance | /r/HasA | fn:fe:figure | "within distance" | "figure" | "/r/has a" |  | "FN" |  |
| fn:within_distance | /r/HasA | fn:fe:distance | "within distance" | "distance" | "/r/has a" |  | "FN" |  |
| fn:linguistic_meaning | /r/UsedFor | fn:word_relations | "linguistic meaning" | "word relations" | "/r/used for" |  | "FN" |  |
| fn:word_relations | fn:HasLexicalUnit | fn:lu:word_relations:synonym | "word relations" | "synonym" | "has lexical unit" |  | "FN" |  |
| fn:word_relations | fn:HasLexicalUnit | fn:lu:word_relations:antonym | "word relations" | "antonym" | "has lexical unit" |  | "FN" |  |
| fn:word_relations | fn:HasLexicalUnit | fn:lu:word_relations:contrary | "word relations" | "contrary" | "has lexical unit" |  | "FN" |  |
| fn:word_relations | fn:HasLexicalUnit | fn:lu:word_relations:hyponym | "word relations" | "hyponym" | "has lexical unit" |  | "FN" |  |
| fn:word_relations | fn:HasLexicalUnit | fn:lu:word_relations:hypernym | "word relations" | "hypernym" | "has lexical unit" |  | "FN" |  |
| fn:word_relations | fn:HasLexicalUnit | fn:lu:word_relations:synonymous | "word relations" | "synonymous" | "has lexical unit" |  | "FN" |  |
| fn:word_relations | fn:HasLexicalUnit | fn:lu:word_relations:meronym | "word relations" | "meronym" | "has lexical unit" |  | "FN" |  |
| fn:word_relations | fn:HasLexicalUnit | fn:lu:word_relations:holonym | "word relations" | "holonym" | "has lexical unit" |  | "FN" |  |
| fn:word_relations | fn:HasLexicalUnit | fn:lu:word_relations:homophone | "word relations" | "homophone" | "has lexical unit" |  | "FN" |  |
| fn:word_relations | fn:HasLexicalUnit | fn:lu:word_relations:homograph | "word relations" | "homograph" | "has lexical unit" |  | "FN" |  |
| fn:word_relations | fn:HasLexicalUnit | fn:lu:word_relations:collocate | "word relations" | "collocate" | "has lexical unit" |  | "FN" |  |
| fn:word_relations | fn:HasLexicalUnit | fn:lu:word_relations:collocate | "word relations" | "collocate" | "has lexical unit" |  | "FN" |  |
| fn:word_relations | fn:HasLexicalUnit | fn:lu:word_relations:homonym | "word relations" | "homonym" | "has lexical unit" |  | "FN" |  |
| fn:word_relations | fn:HasLexicalUnit | fn:lu:word_relations:homophonous | "word relations" | "homophonous" | "has lexical unit" |  | "FN" |  |
| fn:fe:sign_1 | /r/HasPrerequisite | fn:fe:sign_2 | "sign 1" | "sign 2" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:sign_1 | /r/RelatedTo | fn:fe:signs | "sign 1" | "signs" | "/r/related to" |  | "FN" |  |
| fn:word_relations | /r/HasA | fn:fe:sign_1 | "word relations" | "sign 1" | "/r/has a" |  | "FN" |  |
| fn:fe:sign_2 | /r/HasPrerequisite | fn:fe:sign_1 | "sign 2" | "sign 1" | "/r/has prerequisite" |  | "FN" |  |
| fn:fe:sign_2 | /r/RelatedTo | fn:fe:signs | "sign 2" | "signs" | "/r/related to" |  | "FN" |  |
| fn:word_relations | /r/HasA | fn:fe:sign_2 | "word relations" | "sign 2" | "/r/has a" |  | "FN" |  |
| fn:word_relations | /r/HasA | fn:fe:signs | "word relations" | "signs" | "/r/has a" |  | "FN" |  |
| fn:word_relations | /r/HasA | fn:fe:circumstances | "word relations" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:work | /r/IsA | fn:attempt | "work" | "attempt" | "/r/is a" |  | "FN" |  |
| fn:seeking_to_achieve | /r/IsA | fn:work | "seeking to achieve" | "work" | "/r/is a" |  | "FN" |  |
| fn:work | fn:HasLexicalUnit | fn:lu:work:work | "work" | "work" | "has lexical unit" |  | "FN" |  |
| fn:work | fn:HasLexicalUnit | fn:lu:work:work | "work" | "work" | "has lexical unit" |  | "FN" |  |
| fn:work | fn:HasLexicalUnit | fn:lu:work:plug_away | "work" | "plug away" | "has lexical unit" |  | "FN" |  |
| fn:work | fn:HasLexicalUnit | fn:lu:work:bang_away | "work" | "bang away" | "has lexical unit" |  | "FN" |  |
| fn:work | /r/HasA | fn:fe:agent | "work" | "agent" | "/r/has a" |  | "FN" |  |
| fn:fe:goal | /r/RelatedTo | fn:fe:salient_entity | "goal" | "salient entity" | "/r/related to" |  | "FN" |  |
| fn:work | /r/HasA | fn:fe:goal | "work" | "goal" | "/r/has a" |  | "FN" |  |
| fn:work | /r/HasA | fn:fe:outcome | "work" | "outcome" | "/r/has a" |  | "FN" |  |
| fn:work | /r/HasA | fn:fe:means | "work" | "means" | "/r/has a" |  | "FN" |  |
| fn:work | /r/HasA | fn:fe:degree | "work" | "degree" | "/r/has a" |  | "FN" |  |
| fn:work | /r/HasA | fn:fe:time | "work" | "time" | "/r/has a" |  | "FN" |  |
| fn:work | /r/HasA | fn:fe:depictive | "work" | "depictive" | "/r/has a" |  | "FN" |  |
| fn:work | /r/HasA | fn:fe:place | "work" | "place" | "/r/has a" |  | "FN" |  |
| fn:work | /r/HasA | fn:fe:manner | "work" | "manner" | "/r/has a" |  | "FN" |  |
| fn:work | /r/HasA | fn:fe:duration | "work" | "duration" | "/r/has a" |  | "FN" |  |
| fn:work | /r/HasA | fn:fe:purpose | "work" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:work | /r/HasA | fn:fe:particular_iteration | "work" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:work | /r/HasA | fn:fe:circumstances | "work" | "circumstances" | "/r/has a" |  | "FN" |  |
| fn:work | /r/HasA | fn:fe:domain | "work" | "domain" | "/r/has a" |  | "FN" |  |
| fn:work | /r/HasA | fn:fe:salient_entity | "work" | "salient entity" | "/r/has a" |  | "FN" |  |
| fn:work | /r/HasA | fn:fe:frequency | "work" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:work | /r/HasA | fn:fe:event_description | "work" | "event description" | "/r/has a" |  | "FN" |  |
| fn:work | /r/HasA | fn:fe:descriptor | "work" | "descriptor" | "/r/has a" |  | "FN" |  |
| fn:working_a_post | /r/IsA | fn:intentionally_act | "working a post" | "intentionally act" | "/r/is a" |  | "FN" |  |
| fn:working_a_post | fn:HasLexicalUnit | fn:lu:working_a_post:man | "working a post" | "man" | "has lexical unit" |  | "FN" |  |
| fn:working_a_post | fn:HasLexicalUnit | fn:lu:working_a_post:staff | "working a post" | "staff" | "has lexical unit" |  | "FN" |  |
| fn:working_a_post | fn:HasLexicalUnit | fn:lu:working_a_post:work | "working a post" | "work" | "has lexical unit" |  | "FN" |  |
| fn:working_a_post | /r/HasA | fn:fe:agent | "working a post" | "agent" | "/r/has a" |  | "FN" |  |
| fn:working_a_post | /r/HasA | fn:fe:place | "working a post" | "place" | "/r/has a" |  | "FN" |  |
| fn:working_a_post | /r/HasA | fn:fe:purpose | "working a post" | "purpose" | "/r/has a" |  | "FN" |  |
| fn:working_a_post | /r/HasA | fn:fe:time | "working a post" | "time" | "/r/has a" |  | "FN" |  |
| fn:working_a_post | /r/HasA | fn:fe:means | "working a post" | "means" | "/r/has a" |  | "FN" |  |
| fn:working_a_post | /r/HasA | fn:fe:manner | "working a post" | "manner" | "/r/has a" |  | "FN" |  |
| fn:working_a_post | /r/HasA | fn:fe:frequency | "working a post" | "frequency" | "/r/has a" |  | "FN" |  |
| fn:working_a_post | /r/HasA | fn:fe:period_of_iterations | "working a post" | "period of iterations" | "/r/has a" |  | "FN" |  |
| fn:working_a_post | /r/HasA | fn:fe:result | "working a post" | "result" | "/r/has a" |  | "FN" |  |
| fn:working_a_post | /r/HasA | fn:fe:particular_iteration | "working a post" | "particular iteration" | "/r/has a" |  | "FN" |  |
| fn:working_a_post | /r/HasA | fn:fe:explanation | "working a post" | "explanation" | "/r/has a" |  | "FN" |  |
| fn:working_a_post | /r/HasA | fn:fe:event_description | "working a post" | "event description" | "/r/has a" |  | "FN" |  |
| fn:working_a_post | /r/HasA | fn:fe:post | "working a post" | "post" | "/r/has a" |  | "FN" |  |
| fn:working_a_post | /r/HasA | fn:fe:salient_entity | "working a post" | "salient entity" | "/r/has a" |  | "FN" |  |

